/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { StockInfo } from "./StockInfo";
import { markType } from "./type";
import { round10N } from "./numberExtended";
/**
 * @hidden
 */
var StockDetails = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StockDetails, _super);
    function StockDetails() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._annualLow = 0;
        _this._annualHigh = 0;
        _this._marketPrice = 0;
        _this._marketShares = 0;
        _this._volatility = 0;
        return _this;
    }
    Object.defineProperty(StockDetails.prototype, "annualLow", {
        get: function () {
            return this._annualLow;
        },
        set: function (a) {
            this._annualLow = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(StockDetails.prototype, "annualHigh", {
        get: function () {
            return this._annualHigh;
        },
        set: function (a) {
            this._annualHigh = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(StockDetails.prototype, "marketPrice", {
        get: function () {
            return this._marketPrice;
        },
        set: function (a) {
            this._marketPrice = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(StockDetails.prototype, "marketShares", {
        get: function () {
            return this._marketShares;
        },
        set: function (a) {
            this._marketShares = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(StockDetails.prototype, "marketCap", {
        get: function () {
            return round10N(this.marketPrice * this.marketShares / 1000, 1);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(StockDetails.prototype, "volatility", {
        get: function () {
            return this._volatility;
        },
        set: function (a) {
            this._volatility = a;
        },
        enumerable: false,
        configurable: true
    });
    StockDetails.$t = markType(StockDetails, 'StockDetails', StockInfo.$);
    return StockDetails;
}(StockInfo));
export { StockDetails };
