import { Base, Type } from "./type";
import { CodeGenerationTargetPlatforms } from "./CodeGenerationTargetPlatforms";
import { CodeGeneratingRendererResult } from "./CodeGeneratingRendererResult";
import { CodeGenerationRendererOptions } from "./CodeGenerationRendererOptions";
import { CodeGeneratingCodeWriter } from "./CodeGeneratingCodeWriter";
import { CodeGenerationItemBuilderPropertyInfo } from "./CodeGenerationItemBuilderPropertyInfo";
import { List$1 } from "./List$1";
import { TypeDescriptionContext } from "./TypeDescriptionContext";
import { TypeDescriptionMetadata } from "./TypeDescriptionMetadata";
import { DescriptionRef } from "./DescriptionRef";
import { StringBuilder } from "./StringBuilder";
import { CodeGeneratingImportManager } from "./CodeGeneratingImportManager";
import { CodeGenerationLibraryItemContent } from "./CodeGenerationLibraryItemContent";
import { CodeGeneratingComponentRendererHandlerEmitter } from "./CodeGeneratingComponentRendererHandlerEmitter";
import { CodeGeneratingComponentRendererDataEmitter } from "./CodeGeneratingComponentRendererDataEmitter";
import { CodeGenerationLibraryItemContentLocation } from "./CodeGenerationLibraryItemContentLocation";
import { CodeGeneratingComponentRendererDataEmitterPropertyType } from "./CodeGeneratingComponentRendererDataEmitterPropertyType";
import { CodeGeneratingComponentRendererDataEmitterItemType } from "./CodeGeneratingComponentRendererDataEmitterItemType";
import { JsonDictionaryValue } from "./JsonDictionaryValue";
import { JsonDictionaryObject } from "./JsonDictionaryObject";
import { JsonDictionaryItem } from "./JsonDictionaryItem";
import { ComponentRenderer } from "./ComponentRenderer";
import { DescriptionTreeAction } from "./DescriptionTreeAction";
import { CodeGeneratingComponentRendererTemplateEmitter } from "./CodeGeneratingComponentRendererTemplateEmitter";
import { CodeGeneratingComponentRendererModuleEmitter } from "./CodeGeneratingComponentRendererModuleEmitter";
import { ICodeGenerationRendererTemplate } from "./ICodeGenerationRendererTemplate";
import { IComponentRendererAdapter } from "./IComponentRendererAdapter";
/**
 * @hidden
 */
export declare abstract class CodeGeneratingComponentRendererCodeEmitter extends Base {
    static $t: Type;
    private l;
    private j;
    protected get_al(): string;
    protected get al(): string;
    protected get_am(): string;
    protected get am(): string;
    protected get a6(): string;
    protected get m(): CodeGenerationRendererOptions;
    private z;
    protected br(a: CodeGenerationItemBuilderPropertyInfo): void;
    protected get k(): CodeGeneratingRendererResult;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    private d;
    protected get h(): CodeGeneratingCodeWriter;
    private a;
    protected get e(): CodeGeneratingCodeWriter;
    private c;
    protected get g(): CodeGeneratingCodeWriter;
    private b;
    protected get f(): CodeGeneratingCodeWriter;
    private aa;
    protected bb(a: string): void;
    abstract get r(): boolean;
    w(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): boolean;
    q(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): boolean;
    t(a: CodeGenerationItemBuilderPropertyInfo): boolean;
    private af;
    protected get aq(): string;
    bc(a: string, b: string, c: TypeDescriptionContext): void;
    u(a: string, b: TypeDescriptionContext): boolean;
    bq(): void;
    bk(a: number): void;
    bl(a: string): void;
    bi(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    bj(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    toString(): string;
    protected a0(): string;
    protected a3(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo, c: boolean): string;
    protected ab(a: CodeGenerationItemBuilderPropertyInfo, b: boolean): List$1<string>;
    protected ac(a: CodeGenerationItemBuilderPropertyInfo, b: boolean): List$1<string>;
    protected a9(a: any): string;
    protected abstract i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    protected ao(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    private an;
    protected ar(a: TypeDescriptionContext, b: CodeGenerationItemBuilder, c: string, d: string): string;
    protected as(a: CodeGenerationItemBuilderPropertyInfo, b: TypeDescriptionContext, c: List$1<CodeGenerationItemBuilder>, d: List$1<string>, e: string): string;
    protected a8(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected at(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected ag(a: CodeGenerationItemBuilderPropertyInfo): any;
    private a2;
    protected s(a: CodeGenerationItemBuilderPropertyInfo): boolean;
    protected a1(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected av(a: CodeGenerationItemBuilderPropertyInfo): string;
    private ay;
    protected aw(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected az(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ax(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_x(): boolean;
    protected get x(): boolean;
    protected ak(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected aj(a: any): string;
    protected ai(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ah(a: any): string;
    private ad;
    private ae;
    bp(a: string): void;
    bo(a: string): void;
    private au;
    bm(): void;
    protected get_a7(): string;
    protected get a7(): string;
    get ap(): string;
    protected get v(): boolean;
    protected get o(): boolean;
    protected get p(): boolean;
    a5: string;
    protected get_y(): boolean;
    get y(): boolean;
    a4: string;
    protected get_n(): boolean;
    get n(): boolean;
    bn(): void;
    be(a: StringBuilder): void;
    bh(a: StringBuilder): void;
    bd(a: StringBuilder): void;
    bf(a: TypeDescriptionContext, b: CodeGeneratingImportManager): void;
    protected bg(a: TypeDescriptionContext, b: List$1<string>, c: CodeGeneratingImportManager): void;
}
/**
 * @hidden
 */
export declare class BlazorRazorCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    get r(): boolean;
    protected ar(a: TypeDescriptionContext, b: CodeGenerationItemBuilder, c: string, d: string): string;
    protected as(a: CodeGenerationItemBuilderPropertyInfo, b: TypeDescriptionContext, c: List$1<CodeGenerationItemBuilder>, d: List$1<string>, e: string): string;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    protected get_y(): boolean;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected bv(a: TypeDescriptionContext, b: string, c: CodeGenerationItemBuilderPropertyInfo): string;
    protected at(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    bc(a: string, b: string, c: TypeDescriptionContext): void;
    bq(): void;
    bl(a: string): void;
    private bu;
    private bs;
    private bt;
    bi(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected aw(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected a3(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo, c: boolean): string;
    protected ag(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected a0(): string;
    protected av(a: CodeGenerationItemBuilderPropertyInfo): string;
    private bw;
    protected a1(a: CodeGenerationItemBuilderPropertyInfo): string;
    bj(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected get_a7(): string;
}
/**
 * @hidden
 */
export declare class BlazorCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    get r(): boolean;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    protected get_y(): boolean;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected bv(a: string, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected at(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    bc(a: string, b: string, c: TypeDescriptionContext): void;
    bq(): void;
    bl(a: string): void;
    private bu;
    private bs;
    private bt;
    bi(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected aw(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected a3(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo, c: boolean): string;
    protected ag(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected a0(): string;
    protected av(a: CodeGenerationItemBuilderPropertyInfo): string;
    private bw;
    protected a1(a: CodeGenerationItemBuilderPropertyInfo): string;
    bj(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected get_a7(): string;
}
/**
 * @hidden
 */
export declare class ReactMarkupCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    get r(): boolean;
    protected ar(a: TypeDescriptionContext, b: CodeGenerationItemBuilder, c: string, d: string): string;
    protected as(a: CodeGenerationItemBuilderPropertyInfo, b: TypeDescriptionContext, c: List$1<CodeGenerationItemBuilder>, d: List$1<string>, e: string): string;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected at(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_x(): boolean;
    protected get_a7(): string;
    private bs;
    private bt;
    bc(a: string, b: string, c: TypeDescriptionContext): void;
    private bv;
    bq(): void;
    private bu;
    protected ax(a: CodeGenerationItemBuilderPropertyInfo): string;
    bl(a: string): void;
    bi(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected ag(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected a0(): string;
    protected av(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected a1(a: CodeGenerationItemBuilderPropertyInfo): string;
    bj(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected bg(a: TypeDescriptionContext, b: List$1<string>, c: CodeGeneratingImportManager): void;
}
/**
 * @hidden
 */
export declare abstract class WebCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    get r(): boolean;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    private bs;
    protected aw(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected at(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_x(): boolean;
    u(a: string, b: TypeDescriptionContext): boolean;
    bc(a: string, b: string, c: TypeDescriptionContext): void;
    private bw;
    bq(): void;
    bk(a: number): void;
    bl(a: string): void;
    private bv;
    private bt;
    private bu;
    bi(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected ag(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected a0(): string;
    protected av(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected a1(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ax(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected a3(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo, c: boolean): string;
    bj(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
}
/**
 * @hidden
 */
export declare class ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter extends WebCodeBehindCodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected get_a7(): string;
    protected bg(a: TypeDescriptionContext, b: List$1<string>, c: CodeGeneratingImportManager): void;
    bx(a: string, b: TypeDescriptionContext): boolean;
}
/**
 * @hidden
 */
export declare class WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    get r(): boolean;
    private bs;
    protected aw(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    protected ar(a: TypeDescriptionContext, b: CodeGenerationItemBuilder, c: string, d: string): string;
    protected as(a: CodeGenerationItemBuilderPropertyInfo, b: TypeDescriptionContext, c: List$1<CodeGenerationItemBuilder>, d: List$1<string>, e: string): string;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected at(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_x(): boolean;
    bc(a: string, b: string, c: TypeDescriptionContext): void;
    private bw;
    bq(): void;
    bl(a: string): void;
    private bv;
    private bt;
    private bu;
    protected get_a7(): string;
    protected bg(a: TypeDescriptionContext, b: List$1<string>, c: CodeGeneratingImportManager): void;
    bi(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected ag(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected a0(): string;
    protected av(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected a1(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ax(a: CodeGenerationItemBuilderPropertyInfo): string;
    bj(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
}
/**
 * @hidden
 */
export declare class WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter extends WebCodeBehindCodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected get_a7(): string;
    protected bg(a: TypeDescriptionContext, b: List$1<string>, c: CodeGeneratingImportManager): void;
}
/**
 * @hidden
 */
export declare class TSCodeGeneratingComponentRendererHandlerEmitter extends CodeGeneratingComponentRendererHandlerEmitter {
    static $t: Type;
    private w;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult, c: CodeGenerationTargetPlatforms);
    protected t(a: string, b: boolean): void;
    protected u(a: string, b: boolean): void;
    protected get aa(): string;
    protected get ab(): string;
    private x;
    protected v(a: CodeGeneratingImportManager, b: string): void;
    protected get_z(): string;
    protected get z(): string;
    protected get_y(): string;
    protected get y(): string;
    protected q(a: string, b: string): string;
}
/**
 * @hidden
 */
export declare class TSCodeGeneratingComponentRendererDataEmitter extends CodeGeneratingComponentRendererDataEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected x(a: string, b?: boolean): string;
    protected w(a: string): string;
    protected aq(a: string): string;
    protected get_t(): string;
    private am;
    protected al(a: CodeGenerationLibraryItemContentLocation, b: string, c: string[], d: CodeGeneratingComponentRendererDataEmitterPropertyType[], e: CodeGeneratingCodeWriter, f: CodeGeneratingImportManager): void;
    protected ah(a: string, b: CodeGenerationLibraryItemContentLocation, c: CodeGenerationLibraryItemContent): void;
    protected ai(a: string, b: JsonDictionaryValue): void;
    protected aj(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: JsonDictionaryObject): void;
    protected z(a: string, b: CodeGeneratingImportManager): void;
    protected aa(a: string, b: string, c: CodeGeneratingImportManager): void;
    protected ab(a: string, b: CodeGeneratingImportManager): void;
    protected ad(a: CodeGeneratingComponentRendererDataEmitterItemType, b: CodeGeneratingCodeWriter, c: CodeGeneratingImportManager): void;
    private an;
    private ap;
    protected ak(a: CodeGenerationLibraryItemContentLocation, b: string, c: string[], d: CodeGeneratingComponentRendererDataEmitterPropertyType[], e: CodeGeneratingCodeWriter): void;
    protected y(a: CodeGenerationLibraryItemContentLocation, b: string, c: string[], d: CodeGeneratingComponentRendererDataEmitterPropertyType[], e: JsonDictionaryItem, f: number, g: CodeGeneratingCodeWriter): void;
    private ar;
    protected u(a: CodeGeneratingComponentRendererDataEmitterPropertyType, b: JsonDictionaryValue): string;
    protected ao(a: JsonDictionaryValue): string;
}
/**
 * @hidden
 */
export declare class AngularTemplateCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    get r(): boolean;
    protected ar(a: TypeDescriptionContext, b: CodeGenerationItemBuilder, c: string, d: string): string;
    protected as(a: CodeGenerationItemBuilderPropertyInfo, b: TypeDescriptionContext, c: List$1<CodeGenerationItemBuilder>, d: List$1<string>, e: string): string;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected at(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_x(): boolean;
    protected get_a7(): string;
    private bu;
    private bs;
    private bt;
    bc(a: string, b: string, c: TypeDescriptionContext): void;
    protected bg(a: TypeDescriptionContext, b: List$1<string>, c: CodeGeneratingImportManager): void;
    private bv;
    bq(): void;
    bl(a: string): void;
    bi(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected ax(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ag(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected a0(): string;
    protected av(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected a1(a: CodeGenerationItemBuilderPropertyInfo): string;
    bj(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
}
/**
 * @hidden
 */
export declare class AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter extends WebCodeBehindCodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected get_a7(): string;
    protected bg(a: TypeDescriptionContext, b: List$1<string>, c: CodeGeneratingImportManager): void;
}
/**
 * @hidden
 */
export declare class DotNetCodeGeneratingComponentRendererDataEmitter extends CodeGeneratingComponentRendererDataEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected ab(a: string, b: CodeGeneratingImportManager): void;
    protected af(a: CodeGeneratingCodeWriter): void;
    private am;
    protected ae(a: CodeGeneratingCodeWriter): void;
    protected x(a: string, b?: boolean): string;
    protected w(a: string): string;
    protected aq(a: string): string;
    protected al(a: CodeGenerationLibraryItemContentLocation, b: string, c: string[], d: CodeGeneratingComponentRendererDataEmitterPropertyType[], e: CodeGeneratingCodeWriter, f: CodeGeneratingImportManager): void;
    protected ah(a: string, b: CodeGenerationLibraryItemContentLocation, c: CodeGenerationLibraryItemContent): void;
    protected ai(a: string, b: JsonDictionaryValue): void;
    protected aj(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: JsonDictionaryObject): void;
    protected get_t(): string;
    protected ad(a: CodeGeneratingComponentRendererDataEmitterItemType, b: CodeGeneratingCodeWriter, c: CodeGeneratingImportManager): void;
    private an;
    protected get_r(): boolean;
    private ap;
    protected ak(a: CodeGenerationLibraryItemContentLocation, b: string, c: string[], d: CodeGeneratingComponentRendererDataEmitterPropertyType[], e: CodeGeneratingCodeWriter): void;
    protected y(a: CodeGenerationLibraryItemContentLocation, b: string, c: string[], d: CodeGeneratingComponentRendererDataEmitterPropertyType[], e: JsonDictionaryItem, f: number, g: CodeGeneratingCodeWriter): void;
    private ar;
    protected u(a: CodeGeneratingComponentRendererDataEmitterPropertyType, b: JsonDictionaryValue): string;
    protected ao(a: JsonDictionaryValue): string;
}
/**
 * @hidden
 */
export declare class WPFXamlCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected a9(a: any): string;
    protected get_r(): boolean;
    get r(): boolean;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    protected get_y(): boolean;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected at(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    bc(a: string, b: string, c: TypeDescriptionContext): void;
    bq(): void;
    bl(a: string): void;
    bi(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected ag(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected a0(): string;
    protected av(a: CodeGenerationItemBuilderPropertyInfo): string;
    private bs;
    protected a1(a: CodeGenerationItemBuilderPropertyInfo): string;
    bj(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected get_a7(): string;
}
/**
 * @hidden
 */
export declare class WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected a9(a: any): string;
    protected get_r(): boolean;
    get r(): boolean;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    protected get_y(): boolean;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
}
/**
 * @hidden
 */
export declare class CodeGeneratingComponentRenderer extends ComponentRenderer {
    static $t: Type;
    loadCodeJson(a: string): void;
    protected dg(a: boolean): void;
    protected o(): boolean;
    static er(a: string): string;
    static et(a: string): string;
    static es(a: string): string;
    static eu(a: string): string;
    protected ar(): boolean;
    br(a: DescriptionTreeAction): any;
    bs(a: DescriptionTreeAction): any;
    bt(a: DescriptionTreeAction): any;
    bv(a: DescriptionTreeAction): any;
    protected cm(a: string): any;
    protected cn(a: string): any;
    ae(a: JsonDictionaryItem): boolean;
    al(a: JsonDictionaryItem): boolean;
    af(a: JsonDictionaryItem): boolean;
    ag(a: JsonDictionaryItem): boolean;
    ah(a: JsonDictionaryItem): boolean;
    ed(a: CodeGenerationItemBuilder, b: CodeGenerationRendererOptions, c: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    ee(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererDataEmitter;
    ef(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererHandlerEmitter;
    eh(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererTemplateEmitter;
    eg(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererModuleEmitter;
    markRefUsed(a: string): void;
    emitCode(a: ICodeGenerationRendererTemplate): CodeGeneratingRendererResult;
    private ez;
    protected be(): (arg1: string) => string;
    private ev;
    private ew;
    private ej;
    private ek;
    private en;
    private eo;
    private ep;
    private em;
    private el;
    constructor(a: CodeGenerationTargetPlatforms, b: CodeGenerationRendererOptions);
    private static eq;
}
/**
 * @hidden
 */
export declare class CodeGenerationContainer extends Base {
    static $t: Type;
    private _id;
    get id(): string;
    set id(a: string);
    constructor();
    b: List$1<CodeGenerationItemBuilder>;
    d(a: TypeDescriptionContext, b: CodeGeneratingRendererResult, c: CodeGeneratingComponentRenderer, d: CodeGenerationRendererOptions): void;
    private a;
    markRefUsed(a: string): void;
}
/**
 * @hidden
 */
export declare class CodeGenerationItemBuilder extends Base {
    static $t: Type;
    private h;
    private g;
    private c;
    private b;
    private k;
    private i;
    p(): string;
    constructor(a: CodeGenerationTargetPlatforms, b: string, c: TypeDescriptionContext, d: any);
    a(a: string): CodeGenerationItemBuilder;
    s(a: TypeDescriptionMetadata): string;
    y(a: string, b: TypeDescriptionMetadata, c: any, d: DescriptionRef): void;
    w(a: string, b: TypeDescriptionMetadata, c: DescriptionRef): void;
    x(a: string, b: TypeDescriptionMetadata): void;
    j(a: string): any;
    u: string;
    v(a: CodeGeneratingComponentRendererCodeEmitter, b: boolean): void;
    protected f(a: TypeDescriptionContext, b: CodeGeneratingComponentRendererCodeEmitter): boolean;
    private d;
    private e;
    r(): string;
    protected get t(): string;
    static o(a: CodeGenerationTargetPlatforms, b: string, c: TypeDescriptionContext, d: string, e: string): string;
    n(): string;
    private q;
    protected get_l(): string;
    protected get l(): string;
    protected get_m(): string;
    protected get m(): string;
}
/**
 * @hidden
 */
export declare class CodeGenerationRendererAdapter extends Base implements IComponentRendererAdapter {
    static $t: Type;
    private a;
    private b;
    constructor(a: CodeGenerationTargetPlatforms, b: IComponentRendererAdapter);
    createColorCollection(a: any[]): any;
    createBrushCollection(a: any[]): any;
    createDoubleCollection(a: any[]): any;
    createObject(a: string, b: any, c: TypeDescriptionContext, d: string): any;
    coerceToEnum(a: string, b: TypeDescriptionContext, c: string): any;
    onUIThread(a: any, b: () => void): void;
    setOrUpdateCollectionOnTarget(a: any, b: string, c: TypeDescriptionMetadata, d: TypeDescriptionContext, e: any, f: any): void;
    private c;
    onPendingRef(a: any, b: string, c: TypeDescriptionMetadata, d: DescriptionRef): void;
    setPropertyValue(a: any, b: string, c: TypeDescriptionMetadata, d: any, e: any, f: DescriptionRef): void;
    getPropertyValue(a: any, b: string): any;
    getRootObject(a: any): any;
    clearContainer(a: any, b: TypeDescriptionContext, c: (arg1: boolean) => void): void;
    forPropertyValueItem(a: any, b: string, c: (arg1: any) => void): void;
    clearCollection(a: any, b: string, c: TypeDescriptionMetadata): void;
    addItemToCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number, e: any): void;
    resetPropertyOnTarget(a: any, b: string, c: TypeDescriptionMetadata, d: any): void;
    replaceItemInCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number, e: any): void;
    replaceRootItem(a: any, b: string, c: TypeDescriptionContext, d: (arg1: boolean) => void): void;
    removeItemFromCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number): void;
    removeRootItem(a: any, b: TypeDescriptionContext, c: (arg1: boolean) => void): void;
    flushChanges(a: any): void;
    executeMethod(a: any, b: string, c: any[], d: TypeDescriptionMetadata[], e: (arg1: any) => void): void;
    serializeBrush(a: any): any;
    serializeColor(a: any): any;
    serializeBrushCollection(a: any): any;
    serializePoint(a: any): any;
    serializeSize(a: any): any;
    serializeRect(a: any): any;
    serializeColorCollection(a: any): any;
    serializeTimespan(a: any): any;
    serializeDoubleCollection(a: any): any;
}
