import { Type } from "./type";
/**
 * Describes the type of legend badge that represents a series in a legend
 */
export declare enum LegendItemBadgeShape {
    /**
     * Specifies automatic badge with best match of series type, e.g. Square badge for Area Series, Line badge for Line Series etc.
     */
    Automatic = 0,
    /**
     * Specifies a circle badge in a legend
     */
    Circle = 1,
    /**
     * Specifies a thin line badge in a legend
     */
    Line = 2,
    /**
     * Specifies a square badge in a legend
     */
    Square = 3,
    /**
     * Specifies a marker badge in a legend (if series supports markers otherwise a circle badge)
     */
    Marker = 4,
    /**
     * Specifies a thick horizontal bar in a legend
     */
    Bar = 5,
    /**
     * Specifies a thick vertical column in a legend
     */
    Column = 6,
    /**
     * Specifies hidden badge in a legend, next to the series title
     */
    Hidden = 7
}
/**
 * @hidden
 */
export declare let LegendItemBadgeShape_$type: Type;
