import { IgrDataLegendSeriesValueInfo } from "./igr-data-legend-series-value-info";
import { DataLegendSummaryColumn as DataLegendSummaryColumn_internal } from "./DataLegendSummaryColumn";
/**
 * Represent a column in summary row
*/
export declare class IgrDataLegendSummaryColumn extends IgrDataLegendSeriesValueInfo {
    protected createImplementation(): DataLegendSummaryColumn_internal;
    /**
                                 * @hidden
                                 */
    get i(): DataLegendSummaryColumn_internal;
    constructor();
    /**
     * Get values of series in the summary column
    */
    get seriesValues(): number[];
    /**
     * Get labels rendered on left side of series values, e.g. "H:" for High, "L:" for Low
    */
    get seriesLabels(): string[];
    /**
     * Get optional units on right side of series values, e.g. "Hz" for hertz
    */
    get seriesUnits(): string[];
    /**
     * Add a value in the summary column
    
    */
    addValue(value: number): void;
    /**
     * Add label in the summary column
    
    */
    addLabel(label: string): void;
    /**
     * Add unit in the summary column
    
    */
    addUnits(units: string): void;
}
