import { PropertyUpdatedEventArgs as PropertyUpdatedEventArgs_internal } from "./PropertyUpdatedEventArgs";
import { ContentChildrenManager } from "./ContentChildrenManager";
/**
 * EventArgs class for property updated events.
*/
export declare class IgrPropertyUpdatedEventArgs {
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): PropertyUpdatedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Name of the property being updated.
    */
    get propertyName(): string;
    set propertyName(v: string);
    /**
     * Old or previous value of the property being updated.
    */
    get oldValue(): any;
    set oldValue(v: any);
    /**
     * New or current value of the property being updated.
    */
    get newValue(): any;
    set newValue(v: any);
}
