/*!
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
  */
  
import { Children, cloneElement, Component, createElement, Fragment } from 'react';
import { createPortal } from 'react-dom';

/*!
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let _typeIdentifierCache = {};
let _nextTypeIdentifier = 0;
// interface Function {
//     $type?: Type;
// }
function getInstanceType(obj) {
    if (obj.$type) {
        return obj.$type;
    }
    else if (typeof obj === 'number') {
        return Number_$type;
    }
    else if (typeof obj === 'string') {
        return String_$type;
    }
    else if (typeof obj === 'boolean') {
        return Boolean_$type;
    }
    else if (obj instanceof Date) {
        return Date_$type;
    }
    return Base.prototype.$type;
}
let Base = /*@__PURE__*/ (() => {
    class Base {
        constructor() {
        }
        equals(other) {
            return this === other;
        }
        static equalsStatic(a, b) {
            var aIsNull = (a == null) || (!!a.isNullable && !a.hasValue);
            var bIsNull = (b == null) || (!!b.isNullable && !b.hasValue);
            if (aIsNull || bIsNull) {
                return aIsNull && bIsNull;
            }
            if (a.equals) {
                return a.equals(b);
            }
            if (b.equals) {
                return b.equals(a);
            }
            if (Number.isNaN(a) && Number.isNaN(b)) {
                return true;
            }
            if (a instanceof Date) {
                return b instanceof Date && +a === +b;
            }
            return a == b && typeof a == typeof b;
        }
        static equalsSimple(item1, item2) {
            return item1 == item2;
        }
        ;
        static compareSimple(item1, item2) {
            if (item1 == item2) {
                return 0;
            }
            if (item1 < item2) {
                return -1;
            }
            return 1;
        }
        ;
        static compare(item1, item2) {
            if (item1 === item2) {
                return 0;
            }
            var xComparable = typeCast(IComparable_$type, item1);
            if (xComparable !== null && xComparable.compareToObject) {
                return xComparable.compareToObject(item2);
            }
            var yComparable = typeCast(IComparable_$type, item2);
            if (yComparable !== null && yComparable.compareToObject) {
                return -yComparable.compareToObject(item1);
            }
            return Base.compareSimple(item1, item2);
        }
        ;
        getHashCode() {
            if (this.$hashCode === undefined) {
                this.$hashCode = Base.nextHashCode++;
            }
            return this.$hashCode;
        }
        static getHashCodeStatic(obj) {
            if (obj.getHashCode) {
                return obj.getHashCode();
            }
            if (obj.$hashCode !== undefined) {
                return obj.$hashCode;
            }
            if (!(typeof obj == "object")) {
                return Type.getPrimitiveHashCode(obj);
            }
            else {
                obj.$hashCode = Base.nextHashCode++;
                return obj.$hashCode;
            }
        }
        memberwiseClone() {
            var clone;
            try {
                clone = Object.create(this.$type.InstanceConstructor.prototype);
            }
            catch (e) {
                class Cons {
                }
                Cons.prototype = this.$type.InstanceConstructor.prototype;
                clone = new Cons();
            }
            for (var prop in this) {
                if (this.hasOwnProperty(prop)) {
                    clone[prop] = this[prop];
                }
            }
            return clone;
        }
        static referenceEquals(a, b) {
            return a === b || (a == null && b == null);
        }
        static getArrayOfValues(obj) {
            var result = [];
            for (var i in obj) {
                if (obj.hasOwnProperty(i)) {
                    result.push(obj[i]);
                }
            }
            return result;
        }
        static getArrayOfProperties(obj) {
            var result = [];
            for (var i in obj) {
                if (obj.hasOwnProperty(i)) {
                    result.push(i);
                }
            }
            return result;
        }
        ;
    }
    Base.nextHashCode = 0;
    return Base;
})();
class Type extends Base {
    constructor(instanceConstructor, identifier, baseType = Base.prototype.$type, interfaces = null, staticInitializer = null) {
        super();
        this.specializationCache = null;
        this._staticInitializer = null;
        this.name = null;
        this.typeArguments = null;
        this.baseType = null;
        this.interfaces = null;
        this.isEnumType = false;
        this._isGenericType = undefined;
        this._staticFields = null;
        this.isNullable = false;
        this._$nullNullable = null;
        this.enumInfo = null;
        this.specializationCache = {};
        this._staticInitializer = staticInitializer;
        this._fullName = identifier;
        this.name = identifier;
        this.InstanceConstructor = instanceConstructor;
        var lastDotIndex = this.name.lastIndexOf(".");
        if (lastDotIndex >= 0) {
            this.name = this.name.substr(lastDotIndex + 1);
        }
        this.typeArguments = null;
        this.baseType = null;
        this.interfaces = null;
        if (baseType) {
            this.baseType = baseType;
        }
        if (interfaces) {
            this.interfaces = interfaces;
        }
        if (_typeIdentifierCache[identifier]) {
            this.identifier = _typeIdentifierCache[identifier];
        }
        else {
            this.identifier = _nextTypeIdentifier++;
            _typeIdentifierCache[identifier] = this.identifier;
        }
        // rather than always evaluating a function on a type to see if it is an enum
        // we can just cache it once on the type
        // if (baseType && Enum && baseType == Enum.prototype.$type) {
        //     this.isEnumType = true;
        // }
    }
    get typeName() {
        return this.name;
    }
    get fullName() {
        return this._fullName;
    }
    getSpecId(types) {
        if (types.length === 1) {
            if (!types[0]) {
                return "undef";
            }
            else if (types[0] === -1) {
                return undefined;
            }
            else if (!types[0].typeName) {
                return types[0].toString();
            }
            else if (types[0].stringId) {
                return types[0].stringId;
            }
            else {
                return types[0].identifier.toString();
            }
        }
        var ret = "";
        for (var i = 0; i < types.length; i++) {
            var type = types[i];
            if (!type) {
                ret += "undef";
            }
            else if (type == -1) {
                return undefined;
            }
            else if (!type.typeName) {
                ret += type.toString();
            }
            else if (type.stringId) {
                ret += type.stringId;
            }
            else {
                ret += type.identifier.toString();
            }
        }
        return ret;
    }
    get isGenericType() {
        if (this._isGenericType === undefined) {
            this._isGenericType = this.name.indexOf("$") >= 0;
        }
        return this._isGenericType;
    }
    get isGenericTypeDefinition() {
        return this.typeArguments === null && this.isGenericType;
    }
    get genericTypeArguments() {
        return this.typeArguments;
    }
    getStaticFields(type) {
        if (type === undefined) {
            type = this;
        }
        var t = this;
        while (t != null) {
            if (t === type || t._fullName == type._fullName) {
                if (t._staticFields == null && t._staticInitializer) {
                    t._staticFields = {};
                    t._staticInitializer.apply(t._staticFields, t.typeArguments);
                }
                return t._staticFields;
            }
            t = t.baseType;
        }
        return null;
    }
    initSelfReferences(replacement) {
        var i, j;
        if (replacement) {
            if (this.typeArguments) {
                var updateCache = false;
                for (j = 0; j < this.typeArguments.length; j++) {
                    var typeArg = this.typeArguments[j];
                    if (typeArg == -1) {
                        updateCache = true;
                        this.typeArguments[j] = replacement;
                    }
                    else if (typeArg &&
                        typeArg instanceof Type &&
                        typeArg.initSelfReferences) {
                        typeArg.initSelfReferences(replacement);
                    }
                }
                if (updateCache) {
                    var specId = this.getSpecId(this.typeArguments);
                    var ret = this.specializationCache[specId];
                    if (!ret) {
                        this.specializationCache[specId] = this;
                    }
                }
            }
        }
        else {
            if (this.baseType) {
                this.baseType.initSelfReferences(this);
            }
            if (this.interfaces) {
                for (i = 0; i < this.interfaces.length; i++) {
                    this.interfaces[i].initSelfReferences(this);
                }
            }
        }
        return this;
    }
    specialize(...rest) {
        var i;
        if (!this.isGenericType) {
            return this;
        }
        var specId = this.getSpecId(Array.from(arguments));
        var ret = this.specializationCache[specId];
        if (ret) {
            return ret;
        }
        ret = new Type(this.InstanceConstructor, this._fullName, this.baseType, this.interfaces, this._staticInitializer);
        ret.specializationCache = this.specializationCache;
        var placeholders = this.typeArguments;
        var hasPlaceholders = false;
        // Make sure the placeholders are actually numbers. If they are types, we are re-specializing an
        // already specialized type.
        if (placeholders && placeholders.length) {
            /* going back to how it used to be. we shouldn't assume that the number/order of the arguments
                relates to the typearguments. this may be an interface that has its type information already
                and either has placeholders or is a closed type
            // you can have a mixed bag where some are placeholders and others are not and the
            // placeholder doesn't have to be the first slot
            for (i = 0; i < placeholders.length; i++) {
                if (isFinite(placeholders[ i ])) {
                    hasPlaceholders = true;
                    break;
                }
            }*/
            hasPlaceholders = true;
        }
        ret.typeArguments = [];
        if (hasPlaceholders) {
            for (i = 0; i < placeholders.length; i++) {
                // if the argument being provided is a placeholder index and we already have
                // a placeholder then keep the index we have. otherwise we're taking the index
                // of the parent type
                if (typeof placeholders[i] === "number" &&
                    isFinite(placeholders[i]) && !isFinite(arguments[placeholders[i]])) {
                    ret.typeArguments[i] = arguments[placeholders[i]];
                }
                else {
                    ret.typeArguments[i] = placeholders[i];
                }
            }
        }
        else {
            for (i = 0; i < arguments.length; i++) {
                ret.typeArguments[i] = arguments[i];
            }
        }
        // since the placeholder indexes for the basetype and interfaces implemented are based
        // on the order of the type arguments for the defining types we should pass its typeargs
        // and not the outermost type's type arguments which may be different in number and order
        // than the base type of the base types and interfaces implemented
        if (this.baseType && this.baseType.typeArguments) {
            ret.baseType = this.specialize.apply(this.baseType, ret.typeArguments);
        }
        if (this.interfaces) {
            ret.interfaces = [];
            for (i = 0; i < this.interfaces.length; i++) {
                ret.interfaces[i] = this.specialize.apply(this.interfaces[i], ret.typeArguments);
            }
        }
        // rather than doing this check in various places we could just cache a field on the type
        if (this._fullName == "Nullable$1" && ret.typeArguments.length == 1) {
            ret.isNullable = true;
        }
        // if this was a self referencing type (e.g. IEquatable<Int32> for Int32 then we won't have the
        // specId yet because we don't know the type argument. we'll update the cache when we update
        // the self references. otherwise other types that use self references (but for a different type)
        // will get and use the wrong type arguments
        if (specId) {
            this.specializationCache[specId] = ret;
            ret.stringId = ret.generateString();
        }
        else {
            // the self referencing type needs to be able to put itself into the specialization cache
            // of the original type
            //ret.specializationCache = this.specializationCache;
        }
        if (this.InstanceConstructor != null) {
            var _self = this;
            ret.InstanceConstructor = function () {
                _self.InstanceConstructor.apply(this, ret.typeArguments.concat(Array.prototype.slice.call(arguments, 0)));
                return this;
            };
            ret.InstanceConstructor.prototype = this.InstanceConstructor.prototype;
        }
        return ret;
    }
    equals(other) {
        if (!(other instanceof Type)) {
            return false;
        }
        if (this.identifier !== other.identifier) {
            return false;
        }
        if (this.typeArguments === null && other.typeArguments === null) {
            return true;
        }
        if (this.typeArguments === null && other.typeArguments !== null) {
            return false;
        }
        if (this.typeArguments !== null && other.typeArguments === null) {
            return false;
        }
        if (this.typeArguments.length !== other.typeArguments.length) {
            return false;
        }
        for (var i = 0; i < this.typeArguments.length; i++) {
            //TODO: handle covariance case here.
            //if (!$.ig.util.canAssign(this.typeArguments[ i ], other.typeArguments[ i ])) {
            //    return false;
            //}
            if (!Type.checkEquals(this.typeArguments[i], other.typeArguments[i])) {
                return false;
            }
        }
        return true;
    }
    static checkEquals(type1, type2) {
        if (type1 instanceof Type) {
            return type1.equals(type2);
        }
        else if (type2 instanceof Type) {
            return type2.equals(type1);
        }
        else {
            return type1 === type2;
        }
    }
    static op_Equality(type1, type2) {
        return type1.equals(type2);
    }
    static op_Inequality(type1, type2) {
        return !type1.equals(type2);
    }
    generateString() {
        if (!this.typeArguments || !this.typeArguments.length) {
            return this.identifier.toString();
        }
        else {
            var ret = this.identifier.toString() + "[";
            var first = true;
            for (var i = 0; i < this.typeArguments.length; i++) {
                if (this.typeArguments[i] == undefined) {
                    continue;
                }
                if (first) {
                    first = false;
                }
                else {
                    ret += ",";
                }
                if (this.typeArguments[i].toString) {
                    ret += this.typeArguments[i].toString();
                }
                else {
                    ret += this.typeArguments[i].identifier.toString();
                }
            }
            ret += "]";
            return ret;
        }
    }
    get isValueType() {
        return this.baseType === ValueType.prototype.$type;
    }
    isAssignableFrom(tOther) {
        // TODO: Unit test and make sure this is right (especially with generics
        if (this === tOther) {
            return true;
        }
        if (tOther.baseType && this.isAssignableFrom(tOther.baseType)) {
            return true;
        }
        if (tOther.interfaces) {
            for (var i = 0; i < tOther.interfaces.length; i++) {
                if (this.isAssignableFrom(tOther.interfaces[i])) {
                    return true;
                }
            }
        }
        return false;
    }
    isInstanceOfType(value) {
        return typeCast(this, value) !== null;
    }
    get isPrimitive() {
        return this === Number_$type ||
            this === Boolean_$type;
    }
    static canAssign(targetType, type) {
        if (targetType.name === 'Nullable$1' && type.name !== 'Nullable$1') {
            targetType = Nullable.getUnderlyingType(targetType);
        }
        return Type.canAssignSimple(targetType, type);
    }
    static canAssignSimple(targetType, type) {
        if (targetType === type || Type.checkEquals(targetType, type)) {
            return true;
        }
        if (type.interfaces) {
            for (var i = 0; i < type.interfaces.length; i++) {
                if (Type.canAssignSimple(targetType, type.interfaces[i])) {
                    return true;
                }
            }
        }
        if (type.baseType) {
            return Type.canAssignSimple(targetType, type.baseType);
        }
        return false;
    }
    static createInstance($t) {
        if ($t === Number || $t == Number_$type ||
            $t.isEnumType) {
            return 0;
        }
        if ($t == Boolean || $t == Boolean_$type) {
            return false;
        }
        if ($t.InstanceConstructor) {
            var result;
            //result = Object.create((<Type>$t).InstanceConstructor.prototype);
            let C = $t.InstanceConstructor;
            //(<Type>$t).InstanceConstructor.apply(result, Array.prototype.slice.call(arguments, 1));
            result = new C(...Array.prototype.slice.call(arguments, 1));
            return result;
        }
        throw new Error("Cannot find instance constructor for the type parameter");
    }
    ;
    static getDefaultValue($t) {
        if ($t === Number_$type ||
            $t.isEnumType) {
            return 0;
        }
        if ($t == Boolean_$type) {
            return false;
        }
        if ($t.baseType === ValueType.$type) {
            return Type.createInstance($t);
        }
        return null;
    }
    ;
    static getPrimitiveHashCode(v) {
        var val = typeof v;
        if (val === "string" || v instanceof String) {
            var hash = 0, i, chr, len;
            if (v.length === 0) {
                return hash;
            }
            for (i = 0, len = v.length; i < len; i++) {
                chr = v.charCodeAt(i);
                /*jslint bitwise: true */
                hash = ((hash << 5) - hash) + chr;
                hash |= 0; // Convert to 32bit integer
            }
            return hash;
        }
        else if (val === "boolean" || v instanceof Boolean) {
            return +v;
        }
        else {
            return v;
        }
    }
    // static mark(t: Function, name: string,
    //     baseType: Type = Base.prototype.$type, 
    //     interfaces: Type[] = null, 
    //     staticInitializer: () => void = null) {
    //     t.prototype.$type = new Type(t, name, baseType, interfaces, staticInitializer);
    //     (<any>t).$type = t.prototype.$type;
    // }
    static decodePropType(val) {
        if (val === 0) {
            return Boolean_$type;
        }
        else if (val === 1) {
            return Number_$type;
        }
        else if (val === 2) {
            return String_$type;
        }
        else if (val === 3) {
            return Date_$type;
        }
        else {
            return val;
        }
    }
}
function markDep(depProp, PropMeta, t, changedFunction, props) {
    let names = [];
    let currName = "";
    let currOpts = [];
    let hasDefaultValue = false;
    let defaultValue = null;
    let propType = null;
    let changeHandler = null;
    let setterFunc = null;
    let getterFunc = null;
    let aliasName = null;
    let propertyAlias = null;
    //debugger;
    for (var i = 0; i < props.length; i++) {
        if (i % 2 == 0) {
            currName = props[i];
            if (currName.indexOf(":") >= 0) {
                let parts = currName.split(':');
                if (parts.length == 2) {
                    currName = parts[0];
                    aliasName = parts[1];
                    propertyAlias = currName.substring(0, 1).toLowerCase() + currName.substring(1) + "Property";
                }
                else {
                    currName = parts[0];
                    aliasName = parts[1];
                    if (aliasName.length == 0) {
                        aliasName = currName.substring(0, 1).toLowerCase() + currName.substring(1);
                    }
                    propertyAlias = parts[2];
                }
            }
            else {
                aliasName = currName.substring(0, 1).toLowerCase() + currName.substring(1);
                propertyAlias = aliasName + "Property";
            }
            names.push(currName);
        }
        else {
            currOpts = props[i];
            if (currOpts.length == 2) {
                hasDefaultValue = true;
                defaultValue = currOpts[1];
                propType = Type.decodePropType(currOpts[0]);
            }
            else {
                hasDefaultValue = false;
                propType = Type.decodePropType(currOpts[0]);
            }
            let changedName = currName;
            changeHandler = (o, a) => {
                o[changedFunction].call(o, changedName, a.oldValue, a.newValue);
            };
            let meta = null;
            if (hasDefaultValue) {
                meta = PropMeta.createWithDefaultAndCallback(defaultValue, changeHandler);
            }
            else {
                meta = PropMeta.createWithCallback(changeHandler);
            }
            let dp = depProp.registerAlt(currName, propType, t.$type, meta);
            setterFunc = function (v) {
                this.setValueAlt(dp, v);
            };
            if (propType.isEnumType) {
                getterFunc = function () {
                    return typeGetValue(this.getValueAlt(dp));
                };
            }
            else {
                getterFunc = function () {
                    return this.getValueAlt(dp);
                };
            }
            Object.defineProperty(t.prototype, aliasName, {
                set: setterFunc,
                get: getterFunc,
                configurable: true
            });
            t[propertyAlias] = dp;
        }
    }
    // let superClass = (<any>t).$type.baseType;
    // if (superClass !== null && superClass !== undefined) {
    //     let superNames = superClass.InstanceConstructor.$$p;
    //     if (superNames) {
    //         for (var j = superNames.length - 1; j >= 0; j--) {
    //             names.unshift(superNames[j]);
    //         }
    //     }
    // }
    //(<any>t).$$p = names;
    return names;
}
function typeGetValue(v) {
    if (v !== null && v.$type && v.$type.isEnumType) {
        return v.value;
    }
    return v;
}
function typeCast(targetType, obj) {
    if (obj === undefined || obj === null) {
        return null;
    }
    if (targetType === Array) {
        return ((obj instanceof Array) ? obj : null);
    }
    if (targetType === String) {
        targetType = String_$type;
    }
    if (targetType === Number) {
        targetType = Number_$type;
    }
    if (targetType === Boolean) {
        targetType = Boolean_$type;
    }
    if (targetType === Date) {
        targetType = Date_$type;
    }
    var type = obj;
    if (obj.$type) {
        type = obj.$type;
    }
    else if (typeof obj === 'number') {
        type = targetType === Number ? Number : Number_$type;
    }
    else if (typeof obj === 'string') {
        type = String_$type;
    }
    else if (typeof obj === 'boolean') {
        type = Boolean_$type;
    }
    else if (obj instanceof Date) {
        type = Date_$type;
    }
    if (obj instanceof Array) {
        type = Array_$type;
    }
    if (Type.canAssignSimple(targetType, type)) {
        return obj;
    }
    if (targetType.name === 'Nullable$1' && type.name !== 'Nullable$1') {
        targetType = Nullable.getUnderlyingType(targetType);
        if (Type.canAssignSimple(targetType, type)) {
            return toNullable(targetType, obj);
        }
        return toNullable(targetType, null);
    }
    return null;
}
function typeCastObjTo$t($t, v) {
    var shouldWrap = false;
    if ($t.isNullable) {
        $t = $t.typeArguments[0];
        shouldWrap = true;
    }
    if (v !== null && $t.isEnumType) {
        v = v.value;
    }
    return shouldWrap ? toNullable($t, v) : v;
}
let pendingStaticCtors = /*@__PURE__*/ new Array();
function markStruct(t, name, baseType = ValueType.prototype.$type, interfaces = null, staticInitializer = null) {
    t.prototype.$type = new Type(t, name, baseType, interfaces, staticInitializer);
    //TODO: do we need/want a flag on the function like we have in js?
    if (typeof t.staticInit === "function") {
        pendingStaticCtors.push(t);
    }
    t.$type = t.prototype.$type;
    t.$ = t.prototype.$type;
    return t.prototype.$type;
}
/* #__PURE__ */
function markEnum(name, encodedDef) {
    let t = new Type(null, name, Base.prototype.$type, [IConvertible_$type]);
    t.isEnumType = true;
    let parts = encodedDef.split("|");
    let names = [];
    let actualNames = [];
    let namesValuesMap = {};
    let actualNamesValuesMap = {};
    for (var i = 0; i < parts.length; i++) {
        let subParts = parts[i].split(",");
        let nameParts = subParts[0].split(":");
        let name = nameParts[0];
        let actualName = nameParts[0];
        if (nameParts.length > 1) {
            actualName = nameParts[1];
        }
        names.push(name);
        actualNames.push(actualName);
        //TODO: did we support string enums??
        namesValuesMap[name] = parseInt(subParts[1]);
        actualNamesValuesMap[actualName] = parseInt(subParts[1]);
    }
    let info = {
        names: names,
        actualNames: actualNames,
        namesValuesMap: namesValuesMap,
        actualNamesValuesMap: actualNamesValuesMap
    };
    t.enumInfo = info;
    return t;
}
let markTypeInitialized = false;
function markType(t, name, baseType = Base.prototype.$type, interfaces = null, staticInitializer = null) {
    t.prototype.$type = new Type(t, name, baseType, interfaces, staticInitializer);
    if (!markTypeInitialized) {
        markTypeInitialized = true;
        markType(Type, "Type");
        markType(Base, "Base", null);
    }
    //TODO: do we need/want a flag on the function like we have in js?
    if (typeof t.staticInit === "function") {
        pendingStaticCtors.push(t);
    }
    //t.prototype.$ = t.prototype.$type;
    t.$type = t.prototype.$type;
    t.$ = t.prototype.$type;
    return t.prototype.$type;
}
function callStaticConstructors() {
    if (pendingStaticCtors.length > 0) {
        //TODO: is the copy of the array needed? 
        let classes = Array.from(pendingStaticCtors);
        pendingStaticCtors.length = 0;
        for (let c of classes) {
            c.staticInit();
        }
    }
}
let IConvertible_$type = /*@__PURE__*/ new Type(null, "IConvertible");
let Enum = /*@__PURE__*/ (() => {
    class Enum extends Base {
    }
    Enum.$t = /*@__PURE__*/ markType(Enum, "Enum");
    return Enum;
})();
class EnumBox extends Enum {
    constructor(value, type) {
        super();
        this.value = value;
        this.$type = type;
    }
    getHashCode() {
        return this.value;
    }
    // TODO: Fill out remaining IConvertible implementation
    toDouble(provider) {
        return this.value;
    }
    toString() {
        return EnumUtil.getName(this.$type, this.value);
    }
    getActualName() {
        const vals = EnumUtil.getValues(this.$type);
        const actualNames = this.$type.isEnumType ? this.$type.enumInfo.actualNames : EnumUtil.getNames(this.$type);
        return actualNames[vals.indexOf(this.value)];
    }
}
function getBoxIfEnum($t, v) {
    if (v !== null && $t) { // TODO: Remove the $t check here and fix the null ref issue
        if ($t.isNullable) {
            $t = $t.typeArguments[0];
        }
        if ($t.isEnumType) {
            return enumGetBox($t, v);
        }
    }
    return v;
}
;
function enumGetBox($t, v) {
    if (!$t._boxes) {
        $t._boxes = {};
    }
    if (!$t._boxes[v]) {
        $t._boxes[v] = new EnumBox(v, $t);
    }
    return $t._boxes[v];
}
class EnumUtil {
    static getValueFromName(values, enumType, value, ignoreCase) {
        if (values.hasOwnProperty(value)) {
            return enumGetBox(enumType, values[value]);
        }
        else if (ignoreCase) {
            var upper = value.toUpperCase();
            for (var x in values) {
                if (x.toUpperCase() === upper) {
                    return enumGetBox(enumType, values[x]);
                }
            }
        }
        else {
            // A.S. Nov 4, 2016 Adjusted to handle case where leading char is _.
            var firstChar = value.charAt(0);
            if (firstChar != "_") {
                value = firstChar.toLowerCase() + value.substr(1);
            }
            else {
                value = "_" + value.charAt(1).toLowerCase() + value.substr(2);
            }
            if (values.hasOwnProperty(value)) {
                return enumGetBox(enumType, values[value]);
            }
        }
        return null;
    }
    static parse(enumType, value, ignoreCase) {
        //var info = Type.getDefinedNameAndNamespace(enumType.fullName);
        //if (Type.canAssign(this.$type, enumType)) 
        {
            //var p = info.namespace[ info.name ].prototype;
            var values = enumType.isEnumType ? enumType.enumInfo.actualNamesValuesMap : enumType.InstanceConstructor.prototype;
            let val = EnumUtil.getValueFromName(values, enumType, value, ignoreCase);
            if (val !== null) {
                return val;
            }
            if (enumType.isEnumType) {
                values = enumType.enumInfo.namesValuesMap;
                let val = EnumUtil.getValueFromName(values, enumType, value, ignoreCase);
                if (val !== null) {
                    return val;
                }
            }
        }
        throw new Error("Invalid " + enumType.name + " value: " + value);
    }
    // static $getName(value: number): string {
    // }
    // static $value(): number {
    // }
    //private _v: number;
    static enumHasFlag(value, flag) {
        /*jslint bitwise: true */
        return (value & flag) === flag;
    }
    static toString(enumType, value) {
        return EnumUtil.getName(enumType, value);
    }
    static getName(enumType, v) {
        if (enumType._nameMap == undefined) {
            let vals = EnumUtil.getValues(enumType);
            let names = enumType.isEnumType ? enumType.enumInfo.names : EnumUtil.getNames(enumType);
            let map = {};
            for (let i = 0; i < vals.length; i++) {
                map[vals[i]] = names[i];
            }
            enumType._nameMap = map;
        }
        let lookup = enumType._nameMap;
        return lookup[v];
    }
    static getFlaggedName(enumType, v, getName) {
        var names = [];
        var original = v;
        var zeroValueName;
        var value;
        var values = [];
        for (var p in this) {
            if (this.hasOwnProperty(p)) {
                value = enumType[p];
                if (typeof enumType[p] == "number") {
                    values.push(p);
                }
            }
        }
        values.sort((a, b) => { return this[a] - this[b]; });
        for (var i = values.length - 1; i >= 0; i--) {
            value = this[values[i]];
            if (value === 0) {
                zeroValueName = getName(0);
            }
            /*jslint bitwise: true */
            else if ((v & value) === value) {
                v -= value;
                names.unshift(getName(value));
            }
        }
        if (v !== 0) {
            return original.toString();
        }
        if (original !== 0) {
            return names.join(", ");
        }
        return zeroValueName || "0";
    }
    static getValues($t) {
        var result = [];
        if ($t.isEnumType) {
            for (let i = 0; i < $t.enumInfo.actualNames.length; i++) {
                result.push($t.enumInfo.actualNamesValuesMap[$t.enumInfo.actualNames[i]]);
            }
            return result;
        }
        var p = $t.isEnumType ?
            $t.enumInfo.actualNames : $t.InstanceConstructor.prototype;
        for (var member in p) {
            if (p.hasOwnProperty(member)) {
                if (typeof p[member] === "number") {
                    result.push(p[member]);
                }
            }
        }
        return result;
    }
    static getNames($t) {
        var result = [];
        if ($t.isEnumType) {
            for (let i = 0; i < $t.enumInfo.actualNames.length; i++) {
                result.push($t.enumInfo.actualNames[i]);
            }
            return result;
        }
        var p = $t.isEnumType ?
            $t.enumInfo.actualNames : $t.InstanceConstructor.prototype;
        for (var member in p) {
            if (p.hasOwnProperty(member)) {
                if (typeof p[member] === "number") {
                    result.push(member);
                }
            }
        }
        return result;
    }
    static getEnumValue($t, v) {
        if (v !== null && v !== undefined) {
            if (typeof v === "number") {
                return v;
            }
            else {
                return v.value;
            }
        }
        return 0;
    }
    static isDefined($t, value) {
        value = typeGetValue(value);
        var p = $t.isEnumType ?
            $t.enumInfo.actualNamesValuesMap : $t.InstanceConstructor.prototype;
        for (var member in p) {
            if (p.hasOwnProperty(member)) {
                if (p[member] === value) {
                    return true;
                }
            }
        }
        return false;
    }
    // TODO: Fill out remaining IConvertible implementation
    static toDouble(enumType, value, provider) {
        return value.value;
    }
    static toObject($t, value) {
        return value;
    }
    static tryParse$1($tEnum, value, ignoreCase, result) {
        try {
            return {
                ret: true,
                p2: typeGetValue(EnumUtil.parse($tEnum, value, ignoreCase))
            };
        }
        catch (e) {
            result = Type.createInstance($tEnum);
            return {
                ret: false,
                p2: result
            };
        }
    }
}
let ValueType = /*@__PURE__*/ (() => {
    class ValueType extends Base {
    }
    ValueType.$t = /*@__PURE__*/ markType(ValueType, "ValueType");
    return ValueType;
})();
let Nullable = /*@__PURE__*/ (() => {
    class Nullable extends Base {
        static getUnderlyingType(nullableType) {
            if (nullableType.isGenericType !== undefined && nullableType.isGenericType &&
                !nullableType.isGenericTypeDefinition &&
                Nullable$1.prototype.$type.typeName == nullableType.typeName) {
                return nullableType.genericTypeArguments[0];
            }
            return null;
        }
    }
    Nullable.$t = /*@__PURE__*/ markType(Nullable, "Nullable");
    return Nullable;
})();
let Nullable$1 = /*@__PURE__*/ (() => {
    class Nullable$1 extends Base {
        constructor($t, value) {
            super();
            this.$t = null;
            this._value = null;
            this.isNullable = true;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            if (value !== undefined) {
                this._value = value;
            }
        }
        static nullableEquals(v1, v2) {
            /*jshint eqnull:true */
            var v1IsNull = (v1 == null) || (!!v1.isNullable && !v1.hasValue);
            var v2IsNull = (v2 == null) || (!!v2.isNullable && !v2.hasValue);
            if (v1IsNull && v2IsNull) {
                return true;
            }
            if (v1IsNull != v2IsNull) {
                return false;
            }
            var val1 = v1;
            var val2 = v2;
            if (v1.isNullable) {
                val1 = v1.value;
            }
            if (v2.isNullable) {
                val2 = v2.value;
            }
            return val1 == val2;
        }
        equals(value) {
            return Nullable$1.nullableEquals(this, value);
        }
        getHashCode() {
            if (this._value === null) {
                return 0;
            }
            if (this._value["getHashCode"] !== undefined) {
                return this._value.getHashCode();
            }
            return Type.getPrimitiveHashCode(this._value);
        }
        get hasValue() {
            return this._value !== null;
        }
        toString() {
            return this._value === null ? "" : this._value.toString();
        }
        get value() {
            return this._value;
        }
        set value(value) {
            this._value = value;
        }
        getValueOrDefault() {
            if (this.hasValue) {
                return this._value;
            }
            else {
                return this.getDefaultValue();
            }
        }
        getDefaultValue() {
            if (Type.canAssign(Number_$type, this.$t)) {
                return 0;
            }
            else if (Type.canAssign(Boolean_$type, this.$t)) {
                return false;
            }
            else if (this.$t.baseType == ValueType.prototype.$type) {
                return Type.createInstance(this.$t);
            }
            else {
                return null;
            }
        }
        getValueOrDefault1(defaultValue) {
            if (this.hasValue) {
                return this._value;
            }
            else {
                return defaultValue;
            }
        }
        preIncrement() {
            if (!this.hasValue) {
                return this;
            }
            this._value = (this._value + 1);
            return this;
        }
        preDecrement() {
            if (!this.hasValue) {
                return this;
            }
            this._value = (this._value - 1);
            return this;
        }
        postIncrement() {
            if (!this.hasValue) {
                return this;
            }
            var originalValue = this._value;
            this._value = (this._value + 1);
            return new Nullable$1(this.$t, originalValue);
        }
        postDecrement() {
            if (!this.hasValue) {
                return this;
            }
            var originalValue = this._value;
            this._value = (this._value - 1);
            return new Nullable$1(this.$t, originalValue);
        }
    }
    Nullable$1.$t = /*@__PURE__*/ markType(Nullable$1, "Nullable$1");
    return Nullable$1;
})();
function toNullable(t, value) {
    if (value == null) {
        return t._$nullNullable || (t._$nullNullable = new Nullable$1(t, null));
    }
    else if (value.isNullable) {
        return value;
    }
    return new Nullable$1(t, value);
}
let IComparable_$type = /*@__PURE__*/ new Type(null, "IComparable");
let IComparable$1_$type = /*@__PURE__*/ new Type(null, "IComparable$1");
let IEquatable$1_$type = /*@__PURE__*/ new Type(null, "IEquatable$1");
let INotifyPropertyChanged_$type = /*@__PURE__*/ new Type(null, "INotifyPropertyChanged");
let PropertyChangedEventArgs = /*@__PURE__*/ (() => {
    class PropertyChangedEventArgs extends Base {
        constructor(propertyName) {
            super();
            this._propertyName = null;
            this._propertyName = propertyName;
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(value) {
            this._propertyName = value;
        }
    }
    PropertyChangedEventArgs.$t = /*@__PURE__*/ markType(PropertyChangedEventArgs, "PropertyChangedEventArgs");
    return PropertyChangedEventArgs;
})();
class IteratorWrapper {
    constructor(inner, getNew) {
        this._inner = null;
        this._getNew = null;
        this._hasNext = true;
        this._current = null;
        this._inner = inner;
        this._getNew = getNew;
    }
    moveNext() {
        let next = this._inner.next();
        this._hasNext = !next.done;
        this._current = next.value;
        return this._hasNext;
    }
    get current() {
        return this._current;
    }
    get currentObject() {
        return this._current;
    }
    dispose() {
    }
    reset() {
        this._inner = this._getNew();
        this._current = null;
        this._hasNext = true;
    }
}
class IterableWrapper {
    constructor(inner) {
        this._inner = null;
        this._inner = inner;
    }
    getEnumerator() {
        return new IteratorWrapper(this._inner()[Symbol.iterator](), () => this._inner()[Symbol.iterator]());
    }
    getEnumeratorObject() {
        return new IteratorWrapper(this._inner()[Symbol.iterator](), () => this._inner()[Symbol.iterator]());
    }
}
class EnumeratorWrapper {
    constructor(inner) {
        this._inner = null;
        this._inner = inner;
    }
    next() {
        let done = !this._inner.moveNext();
        let value = null;
        if (!done) {
            value = this._inner.current;
        }
        return {
            done: done,
            value: value
        };
    }
}
class EnumeratorWrapperObject {
    constructor(inner) {
        this._inner = null;
        this._inner = inner;
    }
    next() {
        let done = !this._inner.moveNext();
        let value = null;
        if (!done) {
            value = this._inner.currentObject;
        }
        return {
            done: done,
            value: value
        };
    }
}
function* getEn(arr) {
    for (let item of arr) {
        yield item;
    }
}
function getEnumeratorObject(en) {
    if ((en instanceof Array || Array.isArray(en))) {
        let arr = en;
        return new IteratorWrapper(getEn(arr), () => getEn(arr));
    }
    return en.getEnumeratorObject();
}
function getEnumerator(en) {
    if ((en instanceof Array || Array.isArray(en))) {
        let arr = en;
        return new IteratorWrapper(getEn(arr), () => getEn(arr));
    }
    return en.getEnumerator();
}
class EnumerableWrapper {
    constructor(inner) {
        this._inner = null;
        this._inner = inner;
    }
    [Symbol.iterator]() {
        return new EnumeratorWrapper(getEnumerator(this._inner));
    }
}
class EnumerableWrapperObject {
    constructor(inner) {
        this._inner = null;
        this._inner = inner;
    }
    [Symbol.iterator]() {
        return new EnumeratorWrapperObject(getEnumeratorObject(this._inner));
    }
}
function toEnum(v) {
    return new IterableWrapper(v);
}
function fromEnum(v) {
    return new EnumerableWrapper(v);
}
function toEn(v) {
    return new IterableWrapper(v);
}
function fromEn(v) {
    return new EnumerableWrapperObject(v);
}
function* fromDict(v) {
    for (let item of v) {
        let [key, value] = item;
        yield { key: key, value: value };
    }
}
let Number_$type = /*@__PURE__*/ new Type(Number, "Number", Base.prototype.$type, [IComparable_$type, IConvertible_$type]);
let String_$type = /*@__PURE__*/ new Type(String, "String", Base.prototype.$type, [IComparable_$type, IConvertible_$type]);
let Date_$type = /*@__PURE__*/ new Type(Date, "Date", Base.prototype.$type, [IComparable_$type, IConvertible_$type]);
let Boolean_$type = /*@__PURE__*/ new Type(Boolean, "Boolean", Base.prototype.$type, [IComparable_$type, IConvertible_$type]);
let Void_$type = /*@__PURE__*/ new Type(null, "Void", Base.prototype.$type);
let n$ = Number_$type;
let s$ = String_$type;
let d$ = Date_$type;
let b$ = Boolean_$type;
let v$ = Void_$type;
let Delegate_$type = /*@__PURE__*/ new Type(null, "Delegate");
function runOn(target, func) {
    var self = func;
    var ret = function () {
        return self.apply(target, arguments);
    };
    ret.original = self;
    ret.target = target;
    return ret;
}
function delegateCombine(del1, del2) {
    if (!del1) {
        return del2;
    }
    if (!del2) {
        return del1;
    }
    var ret = function () {
        del1.apply(null, arguments);
        return del2.apply(null, arguments);
    };
    ret.enumerate = function (arr) {
        if (del1) {
            if (del1.enumerate) {
                del1.enumerate(arr);
            }
            else {
                arr.push(del1);
            }
        }
        if (del2) {
            if (del2.enumerate) {
                del2.enumerate(arr);
            }
            else {
                arr.push(del2);
            }
        }
    };
    return ret;
}
;
function delegateRemove(del1, del2) {
    if (!del1) {
        return null;
    }
    if (!del2) {
        return del1;
    }
    var arr = [];
    var del = null;
    if (del1.enumerate) {
        del1.enumerate(arr);
    }
    else {
        arr.push(del1);
    }
    for (var i = 0; i < arr.length; i++) {
        if (del2.original) {
            if (arr[i].original == del2.original &&
                arr[i].target == del2.target) {
                continue;
            }
        }
        if (arr[i] == del2) {
            continue;
        }
        del = delegateCombine(del, arr[i]);
    }
    return del;
}
;
let IDisposable_$type = /*@__PURE__*/ new Type(null, 'IDisposable');
let IEnumerable_$type = /*@__PURE__*/ new Type(null, "IEnumerable");
let IEnumerator_$type = /*@__PURE__*/ new Type(null, "IEnumerator");
let IEqualityComparer$1_$type = /*@__PURE__*/ new Type(null, "IEqualityComparer$1");
let IEqualityComparer_$type = /*@__PURE__*/ new Type(null, "IEqualityComparer");
let ICollection_$type = /*@__PURE__*/ new Type(null, "ICollection", null, [IEnumerable_$type]);
let IList_$type = /*@__PURE__*/ new Type(null, "IList", null, [IEnumerable_$type, ICollection_$type]);
let IEnumerable$1_$type = /*@__PURE__*/ new Type(null, "IEnumerable$1", null, [IEnumerable_$type]);
let ICollection$1_$type = /*@__PURE__*/ new Type(null, "ICollection$1", null, [/*@__PURE__*/ IEnumerable$1_$type.specialize(0), IEnumerable_$type]);
let IList$1_$type = /*@__PURE__*/ new Type(null, "IList$1", null, [
    /*@__PURE__*/ ICollection$1_$type.specialize(0),
    /*@__PURE__*/ IEnumerable$1_$type.specialize(0),
    IEnumerable_$type
]);
let IEnumerator$1_$type = /*@__PURE__*/ new Type(null, "IEnumerator$1", null, [IEnumerator_$type, IDisposable_$type]);
let IDictionary_$type = /*@__PURE__*/ new Type(null, "IDictionary");
let BaseError = /*@__PURE__*/ (() => {
    class BaseError extends Base {
        constructor(initNumber = -1, ...rest) {
            super();
            this._message = null;
            this._innerException = null;
            if (initNumber >= 0) {
                switch (initNumber) {
                    case 1:
                        this.init1.apply(this, arguments);
                        break;
                    case 2:
                        this.init2.apply(this, arguments);
                        break;
                }
            }
            return;
        }
        get_message() {
            return this._message;
        }
        get message() {
            return this.get_message();
        }
        get innerException() {
            return this._innerException;
        }
        init1(initNumber, message) {
            this._message = message;
        }
        init2(initNumber, message, innerException) {
            this._message = message;
            this._innerException = innerException;
        }
        toString() {
            return this._message;
        }
    }
    BaseError.$t = /*@__PURE__*/ markType(BaseError, "BaseError");
    return BaseError;
})();
let SystemException = /*@__PURE__*/ (() => {
    class SystemException extends BaseError {
        constructor(initNumber, ...rest) {
            super(0);
            if (initNumber > 0) {
                switch (initNumber) {
                    case 1:
                        this.init1.apply(this, arguments);
                        break;
                    case 2:
                        this.init2.apply(this, arguments);
                        break;
                }
                return;
            }
            //super(0);
        }
        init1(initNumber, message) {
            super.init1(1, message);
        }
        init2(initNumber, message, innerException) {
            super.init2(2, message, innerException);
        }
    }
    SystemException.$t = /*@__PURE__*/ markType(SystemException, "SystemException", BaseError.prototype.$type);
    return SystemException;
})();
let NotSupportedException = /*@__PURE__*/ (() => {
    class NotSupportedException extends SystemException {
        constructor(initNumber, ...rest) {
            super(0);
            if (initNumber > 0) {
                switch (initNumber) {
                    case 1:
                        this.init1.apply(this, arguments);
                        break;
                    case 2:
                        this.init2.apply(this, arguments);
                        break;
                }
                return;
            }
        }
        init1(initNumber, message) {
            super.init1(1, message);
        }
        init2(initNumber, message, innerException) {
            super.init2(2, message, innerException);
        }
    }
    NotSupportedException.$t = /*@__PURE__*/ markType(NotSupportedException, "NotSupportedException", SystemException.prototype.$type);
    return NotSupportedException;
})();
let FormatException = /*@__PURE__*/ (() => {
    class FormatException extends SystemException {
        constructor(initNumber, ...rest) {
            super(0);
            if (initNumber > 0) {
                switch (initNumber) {
                    case 1:
                        this.init1.apply(this, arguments);
                        break;
                    case 2:
                        this.init2.apply(this, arguments);
                        break;
                }
                return;
            }
        }
        init1(initNumber, message) {
            super.init1(1, message);
        }
        init2(initNumber, message, innerException) {
            super.init2(2, message, innerException);
        }
    }
    FormatException.$t = /*@__PURE__*/ markType(FormatException, "FormatException", SystemException.prototype.$type);
    return FormatException;
})();
class PointUtil {
    static equals(p1, p2) {
        if (p1 == null && p2 == null) {
            return true;
        }
        if (p1 == null && p2 != null) {
            return false;
        }
        if (p1 != null && p2 == null) {
            return false;
        }
        return p1.x == p2.x && p1.y == p2.y;
    }
    static notEquals(p1, p2) {
        return !PointUtil.equals(p1, p2);
    }
    static create() {
        return { x: 0, y: 0, $type: Point_$type };
    }
    static createXY(x, y) {
        return { x: x, y: y, $type: Point_$type };
    }
}
let Point_$type = /*@__PURE__*/ new Type(null, "Point");
var SeekOrigin = /*@__PURE__*/ (function (SeekOrigin) {
    SeekOrigin[SeekOrigin["Begin"] = 0] = "Begin";
    SeekOrigin[SeekOrigin["Current"] = 1] = "Current";
    SeekOrigin[SeekOrigin["End"] = 2] = "End";
    return SeekOrigin;
})({});
let Stream = /*@__PURE__*/ (() => {
    class Stream extends Base {
        close() {
            this.disposeCore(true);
        }
        dispose() {
            this.close();
        }
        disposeCore(disposing) {
        }
        readByte() {
            var bytes = [0];
            var count = this.read(bytes, 0, 1);
            if (count === 0) {
                return -1;
            }
            return bytes[0];
        }
        writeByte(value) {
            this.write([value], 0, 1);
        }
    }
    Stream.$t = /*@__PURE__*/ markType(Stream, "Stream");
    return Stream;
})();
let EventArgs = /*@__PURE__*/ (() => {
    class EventArgs extends Base {
        static get empty() {
            if (EventArgs._empty) {
                return EventArgs._empty;
            }
            EventArgs._empty = new EventArgs;
            return EventArgs._empty;
        }
    }
    EventArgs.$t = /*@__PURE__*/ markType(EventArgs, "EventArgs");
    return EventArgs;
})();
let IFormatProvider_$type = /*@__PURE__*/ new Type(null, 'IFormatProvider');
let Array_$type = /*@__PURE__*/ new Type(Array, "Array", Base.prototype.$type, [IEnumerable_$type, ICollection_$type]);
let a$ = Array_$type;
let TypeRegistrar = /*@__PURE__*/ (() => {
    class TypeRegistrar {
        static create(typeName, ...rest) {
            if (TypeRegistrar.isRegistered(typeName)) {
                let C = TypeRegistrar.get(typeName);
                if (C.htmlTagName) {
                    return document.createElement(C.htmlTagName);
                }
                else {
                    return new C(...rest);
                }
            }
            else {
                return null;
            }
        }
        static register(typeName, type) {
            TypeRegistrar._registrar.set(typeName, type.InstanceConstructor);
        }
        static registerCons(typeName, type) {
            TypeRegistrar._registrar.set(typeName, type);
        }
        static callRegister(typeName) {
            let type = TypeRegistrar.get(typeName);
            if (type !== undefined && type !== null &&
                type["register"] !== undefined) {
                type["register"]();
            }
        }
        static isRegistered(typeName) {
            return TypeRegistrar.get(typeName) !== null;
        }
        static get(typeName) {
            if (TypeRegistrar._registrar.has(typeName)) {
                return TypeRegistrar._registrar.get(typeName);
            }
            if (typeName.indexOf("Igx") == 0) {
                let igc = typeName.replace("Igx", "Igc");
                if (TypeRegistrar._registrar.has(igc)) {
                    return TypeRegistrar._registrar.get(igc);
                }
                let igr = typeName.replace("Igx", "Igr");
                if (igr.indexOf("Component") == igr.length - 9) {
                    igr = igr.substring(0, igr.length - 9);
                }
                if (TypeRegistrar._registrar.has(igr)) {
                    return TypeRegistrar._registrar.get(igr);
                }
            }
            return null;
        }
        static createFromInternal(internal, prefix, postfix) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            let name = internal.$type.name;
            let externalName = prefix + name + postfix;
            if (!TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return TypeRegistrar.create(externalName);
        }
    }
    TypeRegistrar._registrar = /*@__PURE__*/ new Map();
    return TypeRegistrar;
})();
function createMutationObserver(...args) {
    let origObserver = MutationObserver;
    if (window.Zone && window.Zone.__symbol__) {
        origObserver = window[window.Zone.__symbol__('MutationObserver')]
            || window[window.Zone.__symbol__('WebKitMutationObserver')];
    }
    return new origObserver(...args);
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IArray_$type = /*@__PURE__*/ new Type(null, 'IArray');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IArrayList_$type = /*@__PURE__*/ new Type(null, 'IArrayList');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function arrayCopyTo(source, dest, index) {
    for (var i = 0; i < source.length; i++) {
        dest[index++] = source[i];
    }
}
function arrayCopy(source, sourceIndex, dest, destIndex, count) {
    for (var i = 0; i < count; i++) {
        dest[destIndex + i] = source[sourceIndex + i];
    }
}
function arrayInsert(target, index, item) {
    target.splice(index, 0, item);
}
function arrayRemoveAt(target, index) {
    target.splice(index, 1);
}
function arrayRemoveItem(target, item) {
    var index = target.indexOf(item);
    if (index >= 0) {
        target.splice(index, 1);
        return true;
    }
    return false;
}
function arrayGetValue(target, index) {
    return target[index];
}
function arrayGetLength(target, dimension) {
    // TODO: Is there a better way to do this? Maybe attach the rank values to the array?
    var array = target;
    var dim = dimension;
    while (array) {
        if (dim === 0) {
            return array.length;
        }
        dim--;
        array = array[0];
    }
    return -1;
}
function arrayGetRank(target) {
    return 1;
}
function arrayResize(target, length) {
    target.length = 0;
}
function arrayInsertRange(target, index, items) {
    var i = 0;
    if (target.length === 0) {
        for (i = 0; i < items.length; i++) {
            target[index++] = items[i];
        }
    }
    else {
        for (i = 0; i < items.length; i++) {
            target.splice(index++, 0, items[i]);
        }
    }
}
function arrayInsertRange1(target, index, items) {
    //TODO: adjust this later, but this is the safest change to make right now.
    var i = 0;
    if (target.length === 0) {
        for (i = 0; i < items.length; i++) {
            target[index++] = items[i];
        }
    }
    else {
        for (i = 0; i < items.length; i++) {
            target.splice(index++, 0, items[i]);
        }
    }
}
function arrayShallowClone(arr) {
    var newArr = [];
    for (var i = 0; i < arr.length; i++) {
        newArr[i] = arr[i];
    }
    return newArr;
}
function arrayClear(arr) {
    arr.length = 0;
}
//   export function listItem(list: any, index: number, item?: any): void {
//       if ((<any>list).$type === undefined) {
//           let arr = <any[]>list;
//           if (item !== undefined) {
//               arr[index] = item;
//               return item;
//           } else {
//               return arr[index];
//           }
//       }
//       if (item !== undefined) {
//           list.item(index, item);
//           return item;
//       }
//       return list.item(index);
//   }
//export function  listAdd(list: any, item: any): void {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//					arrayInsert(arr, arr.length, item);
//					return;
//			}
//			list.add(item);
//	}
//export function  listClear(list: any): void {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//					arrayClear(arr);
//					return;
//			}
//			list.clear();
//	}
//export function listContains(list: any, item: any): boolean {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//					return arr.indexOf(item) > -1;
//			}
//			return list.contains(item);
//	}
//export function listIndexOf(list: any, item: any): number {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//					return arr.indexOf(item);
//			}
//			return list.indexOf(item);
//	}
//export function listInsert(list: any, index: number, item: any): void {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//					arrayInsert(arr, index, item);
//					return;
//			}
//			list.contains(item);
//	}
//export function listRemove(list: any, item: any): boolean {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//                       arrayRemoveItem(arr, item);
//                       return true;
//			}
//			return list.remove(item);
//	}
//export function listRemoveAt(list: any, index: number): void {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//                       arrayRemoveAt(arr, index);
//                       return;
//			}
//			list.removeAt(index);
//	}
//export function listIsFixedSize(list: any): boolean {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//					return false;
//			}
//			return list.isFixedSize;
//	}
//export function listIsReadOnly(list: any): boolean {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//					return false;
//			}
//			return list.isReadOnly;
//	}
//export function collectionCount(collection: any): number {
//			if ((<any>collection).$type === undefined) {
//					let arr = <any[]>collection;
//					return arr.length;
//			}
//			return collection.count;
//	}
//export function collectionCopyTo(collection: any, array: any[], index: number): void {
//			if ((<any>collection).$type === undefined) {
//					let arr = <any[]>collection;
//					arrayCopy(arr, 0, array, index, arr.length);
//					return;
//			}
//			return collection.copyTo(array, index);
//	}
//export function collectionIsSynchronized(collection: any): boolean {
//			if ((<any>collection).$type === undefined) {
//					let arr = <any[]>collection;
//					return false;
//			}
//			return collection.isSynchronized;
//	}
//export function collectionSyncRoot(collection: any): any {
//			if ((<any>collection).$type === undefined) {
//					let arr = <any[]>collection;
//					return arr;
//			}
//			return collection.syncRoot;
//   }
function boxArray$1(array) {
    return new ArrayBox$1(array);
}
function unboxArray(box) {
    if (box.$arrayWrapper) {
        return box._target;
    }
    return box;
}
function arrayListCreate() {
    return new ArrayBox$1([]);
}
class ArrayBox$1 {
    constructor(target) {
        this.isFixedSize = false;
        this.isSynchronized = false;
        this.syncRoot = null;
        this.isReadOnly = false;
        this.$arrayWrapper = true;
        this._target = target;
    }
    item(index, value) {
        if (arguments.length === 2) {
            this._target[index] = value;
            return value;
        }
        else {
            return this._target[index];
        }
    }
    indexOf(item) {
        return this._target.indexOf(item);
    }
    insert(index, item) {
        this._target.splice(index, 0, item);
    }
    insertRange(index, items) {
        arrayInsertRange(this._target, index, items);
    }
    removeRange(index, count) {
        this._target.splice(index, count);
    }
    removeAt(index) {
        this._target.splice(index, 1);
    }
    get count() {
        return this._target.length;
    }
    add(item) {
        this._target.push(item);
    }
    clear() {
        this._target.length = 0;
    }
    contains(item) {
        return this._target.indexOf(item) >= 0;
    }
    copyTo(array, arrayIndex) {
        for (let i = 0; i < this._target.length; i++) {
            array[i + arrayIndex] = this._target[i];
        }
    }
    remove(item) {
        let index = this._target.indexOf(item);
        if (index < 0) {
            return false;
        }
        this._target.splice(index, 1);
        return true;
    }
    getEnumerator() {
        return getEnumerator(this._target);
    }
    getEnumeratorObject() {
        return getEnumeratorObject(this._target);
    }
    getHashCode() {
        return Base.getHashCodeStatic(this._target);
    }
    equals(other) {
        if (other.$arrayWrapper) {
            other = other._target;
        }
        return this._target === other;
    }
    get $type() {
        return Array_$type;
    }
    reverse() {
        let len = this._target.length;
        for (let i = 0; i < len / 2.0; i++) {
            let swap = this._target[(len - 1) - i];
            this._target[(len - 1) - i] = this._target[i];
            this._target[i] = swap;
        }
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IComparer_$type = /*@__PURE__*/ new Type(null, 'IComparer');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IComparer$1_$type = /*@__PURE__*/ new Type(null, 'IComparer$1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class CompareUtil {
    static compareToObject(obj1, obj2) {
        if (obj1.compareToObject) {
            return obj1.compareToObject(obj2);
        }
        return Base.compare(obj1, obj2);
    }
    static compareTo(obj1, obj2) {
        if (obj1.compareTo) {
            return obj1.compareTo(obj2);
        }
        return Base.compare(obj1, obj2);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Comparer$1 = /*@__PURE__*/ (() => {
    class Comparer$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
        static defaultComparerValue($t) {
            return new DefaultComparer$1($t);
        }
        static a($t, a) {
            return null;
        }
        compareObject(a, b) {
            return this.compare(typeCastObjTo$t(this.$t, a), typeCastObjTo$t(this.$t, b));
        }
    }
    Comparer$1.$t = /*@__PURE__*/ markType(Comparer$1, 'Comparer$1', Base.$, [IComparer_$type, /*@__PURE__*/ IComparer$1_$type.specialize(0)]);
    return Comparer$1;
})();
/**
 * @hidden
 */
let DefaultComparer$1 = /*@__PURE__*/ (() => {
    class DefaultComparer$1 extends Comparer$1 {
        constructor($t) {
            super($t);
            this.$t = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
        compare(a, b) {
            let c = typeCast(IComparable$1_$type.specialize(this.$t), a);
            if (c != null) {
                return CompareUtil.compareTo(c, b);
            }
            let d = typeCast(IComparable$1_$type.specialize(this.$t), b);
            if (d != null) {
                return -CompareUtil.compareTo(d, a);
            }
            return (Base.compare(a, b));
        }
    }
    DefaultComparer$1.$t = /*@__PURE__*/ markType(DefaultComparer$1, 'DefaultComparer$1', /*@__PURE__*/ Comparer$1.$.specialize(0));
    return DefaultComparer$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ReadOnlyCollection$1 = /*@__PURE__*/ (() => {
    class ReadOnlyCollection$1 extends Base {
        constructor($t, a, ..._rest) {
            super();
            this.$t = null;
            this.a = null;
            this.c = {};
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        this.a = c;
                    }
                    break;
            }
        }
        item(a, b) {
            if (arguments.length === 2) {
                this.a.item(a, b);
                return b;
            }
            else {
                return this.a.item(a);
            }
        }
        indexOf(a) {
            return this.a.indexOf(a);
        }
        insert(a, b) {
        }
        removeAt(a) {
        }
        get count() {
            return this.a.count;
        }
        get isReadOnly() {
            return true;
        }
        add(a) {
        }
        clear() {
        }
        contains(a) {
            return this.a.contains(a);
        }
        copyTo(a, b) {
            this.a.copyTo(a, b);
        }
        remove(a) {
            return false;
        }
        getEnumerator() {
            return getEnumerator(this.a);
        }
        getEnumeratorObject() {
            return getEnumerator(this.a);
        }
        get isFixedSize() {
            return true;
        }
        add1(a) {
            return -1;
        }
        contains1(a) {
            return this.a.contains(typeCastObjTo$t(this.$t, a));
        }
        indexOf1(a) {
            return this.a.indexOf(typeCastObjTo$t(this.$t, a));
        }
        insert1(a, b) {
        }
        remove1(a) {
        }
        copyTo1(a, b) {
            this.a.copyTo(a, b);
        }
        get b() {
            return this.a;
        }
        get isSynchronized() {
            return true;
        }
        get syncRoot() {
            return this.c;
        }
    }
    ReadOnlyCollection$1.$t = /*@__PURE__*/ markType(ReadOnlyCollection$1, 'ReadOnlyCollection$1', Base.$, [/*@__PURE__*/ IList$1_$type.specialize(0), IList_$type]);
    return ReadOnlyCollection$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NotImplementedException = /*@__PURE__*/ (() => {
    class NotImplementedException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "not implemented");
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                        throw new NotImplementedException(0);
                    }
                    break;
            }
        }
    }
    NotImplementedException.$t = /*@__PURE__*/ markType(NotImplementedException, 'NotImplementedException', BaseError.$);
    return NotImplementedException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function log10(value) {
    return Math.log(value) / Math.log(10);
}
function toDouble(value) {
    return +value;
}
let toDecimal = toDouble;
function compareTo(value, other) {
    if (value == other) {
        return 0;
    }
    if (value < other) {
        return -1;
    }
    return 1;
}
function isInfinity(value) {
    return !isFinite(value) && !isNaN_(value);
}
function intDivide(value, divisor) {
    var result = value / divisor;
    return truncate(result);
}
function truncate(val) {
    if (val >= 0) {
        return Math.floor(val);
    }
    else {
        return Math.ceil(val);
    }
}
function logBase(n, n2) {
    return Math.log(n) / Math.log(n2);
}
function tryParseNumber(s, v) {
    var value = Number(s);
    if (value !== null && isFinite(value) && s.trim().length !== 0) {
        return {
            p1: value,
            ret: true
        };
    }
    else {
        return {
            p1: 0,
            ret: false
        };
    }
}
function isNegativeInfinity(v) {
    return v == Number.NEGATIVE_INFINITY;
}
function isPositiveInfinity(v) {
    return v == Number.POSITIVE_INFINITY;
}
function isNaN_(v) {
    return v !== v; // http://us6.campaign-archive1.com/?u=2cc20705b76fa66ab84a6634f&id=43bf7f05e9
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function stringStartsWith(str, check) {
    return str.indexOf(check) == 0;
}
function stringEndsWith(str, check) {
    let ind = str.lastIndexOf(check);
    return ind >= 0 && ind == str.length - check.length;
}
function stringContains(str, check) {
    return str.indexOf(check) != -1;
}
function stringCreateFromCharArray(charArray) {
    return charArray.join("");
}
function stringCreateFromChar(char, count) {
    var ret = "";
    for (var i = 0; i < count; i++) {
        ret = ret + char;
    }
    return ret;
}
function stringCreateFromCharArraySlice(charArray, start, length) {
    var ret = "";
    for (var i = 0; i < length; i++) {
        ret = ret + charArray[start + i];
    }
    return ret;
}
;
function stringToCharArray(target) {
    return target.split("");
}
function stringCopyToCharArray(source, sourceIndex, destination, destinationIndex, count) {
    for (var i = destinationIndex; i < destinationIndex + count; i++) {
        destination[i] = source.charAt(sourceIndex + i - destinationIndex);
    }
}
;
function stringIsDigit(str, index) {
    index = index || 0;
    var ch = str.charAt(index);
    if (ch >= "0" && ch <= "9") {
        return true;
    }
    return false;
}
;
function charMaxValue() {
    return "\uffff";
}
function charMinValue() {
    return "\u0000";
}
// static toDateTime(target: string) {
// 	var result = new Date(target);
// 	if (!isNaN(+result)) {
// 		return result;
// 	}
// 	// TODO: Cache this regex?
// 	if (/^((([0-9]{1,4})\s*(\s+((a|p)m?)\s*))|(([0-9]{1,4})\s*:\s*([0-9]?[0-9])\s*(:\s*([0-9]?[0-9])\s*(.\s*([0-9]{0,4})[0-9]*\s*)?)?(\s+((a|p)m?)\s*)?)|(\s*([0-9]?[0-9])\s*:\s*([0-9]?[0-9])\s*.\s*([0-9]{0,4})[0-9]*\s*(\s+((a|p)m?)\s*)?))$/i.test(target)) {
// 		// The string can be a time string only, in which case we should return today at that time.
// 		return new Date(new Date().toDateString() + " " + target);
// 	}
// 	throw new FormatException(1, "The string cannot be converted to a date");
// }
// static toDecimal(target: string) {
// 	var result = +target;
// 	if (isNaN(result)) {
// 		new FormatException(1, "The string cannot be converted to a number");
// 	}
// 	return result;
// }
function stringToString1(target) {
    return target.toString();
}
function stringRemove(target, index, count) {
    if (!count || ((index + count) > target.length)) {
        return target.substr(0, index);
    }
    return target.substr(0, index) + target.substr(index + count);
}
function stringCompareTo(target, other) {
    if (target == other) {
        return 0;
    }
    if (target < other) {
        return -1;
    }
    return 1;
}
let stringCompare = stringCompareTo;
function stringIsNullOrEmpty(target) { return !target || target.length < 1; }
function stringIsNullOrWhiteSpace(target) { return !target || target.trim().length < 1; }
function stringEmpty() { return ""; }
function stringEquals(target, other) { return target == other; }
function stringEscapeRegExp(str) {
    return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
}
function createGuid() {
    /*jslint bitwise: true */
    function S4() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }
    return (S4() + S4() + "-" + S4() + "-4" + S4().substr(0, 3) + "-" + S4() + "-" + S4() +
        S4() + S4()).toLowerCase();
}
function stringConcat(...s) {
    return String.prototype.concat(...s);
}
function stringReplace(str, oldValue, newValue) {
    return str.replace(new RegExp(stringEscapeRegExp(oldValue), "g"), newValue);
}
function stringJoin(sep, ...vals) {
    return vals.join(sep);
}
function stringJoin1($t, sep, vals) {
    var result;
    var en = getEnumerator(vals);
    while (en.moveNext()) {
        var v = en.current.toString();
        if (result === undefined) {
            result = v;
        }
        else {
            result += sep + v;
        }
    }
    return result;
}
function stringToString$1($t, v) {
    if (v !== null && $t) {
        if ($t.isNullable) {
            $t = $t.typeArguments[0];
        }
        if ($t.isEnumType) {
            return EnumUtil.getName($t, v);
        }
    }
    return v.toString();
}
function stringToLocaleLower(str, locale) {
    if (locale == null || locale.name == null)
        return str.toLocaleLowerCase();
    return str.toLocaleLowerCase(locale.name);
}
function stringToLocaleUpper(str, locale) {
    if (locale == null || locale.name == null)
        return str.toLocaleUpperCase();
    return str.toLocaleUpperCase(locale.name);
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let List$1 = /*@__PURE__*/ (() => {
    class List$1 extends Base {
        constructor($t, a, ..._rest) {
            super();
            this.$t = null;
            this._inner = null;
            this.c = false;
            this.h = 0;
            this.m = {};
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this._inner = ([]);
                        this.c = (this.$t.InstanceConstructor && this.$t.InstanceConstructor.prototype.equals === Base.prototype.equals);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        {
                            this._inner = ([]);
                            this.c = (this.$t.InstanceConstructor && this.$t.InstanceConstructor.prototype.equals === Base.prototype.equals);
                        }
                        if (this.d(0, c, true)) {
                            return;
                        }
                        for (let d of fromEnum(c)) {
                            this.add(d);
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        {
                            this._inner = ([]);
                            this.c = (this.$t.InstanceConstructor && this.$t.InstanceConstructor.prototype.equals === Base.prototype.equals);
                        }
                    }
                    break;
            }
        }
        x(a, b) {
            this._inner[a] = b;
        }
        r(a, b) {
            this._inner.splice(a, 0, b);
        }
        n(a) {
            this._inner.push(a);
        }
        u(a) {
            if (a == 0) {
                this._inner.shift();
                return;
            }
            this._inner.splice(a, 1);
        }
        p() {
            this._inner = ([]);
        }
        item(a, b) {
            if (arguments.length === 2) {
                this.x(a, b);
                return b;
            }
            else {
                return this._inner[a];
            }
        }
        indexOf(a) {
            if (this.c) {
                return (this._inner.indexOf(a));
            }
            for (let b = 0; b < this._inner.length; b++) {
                if (Base.equalsStatic(getBoxIfEnum(this.$t, a), getBoxIfEnum(this.$t, this._inner[b]))) {
                    return b;
                }
            }
            return -1;
        }
        indexOf2(a, b) {
            if (this.c) {
                return (this._inner.indexOf(a, b));
            }
            for (; b < this._inner.length; b++) {
                if (Base.equalsStatic(getBoxIfEnum(this.$t, a), getBoxIfEnum(this.$t, this._inner[b]))) {
                    return b;
                }
            }
            return -1;
        }
        k(a) {
            if (this.c) {
                return (this._inner.lastIndexOf(a));
            }
            for (let b = this._inner.length - 1; b >= 0; b--) {
                if (Base.equalsStatic(getBoxIfEnum(this.$t, a), getBoxIfEnum(this.$t, this._inner[b]))) {
                    return b;
                }
            }
            return -1;
        }
        insert(a, b) {
            this.r(a, b);
        }
        removeAt(a) {
            this.u(a);
        }
        get count() {
            return this._inner.length;
        }
        get isReadOnly() {
            return false;
        }
        add(a) {
            this.n(a);
        }
        clear() {
            this.p();
        }
        contains(a) {
            return this.indexOf(a) >= 0;
        }
        copyTo(a, b) {
            for (let c = 0; c < this._inner.length; c++) {
                a[b + c] = this._inner[c];
            }
        }
        remove(a) {
            let b = this.indexOf(a);
            if (b < 0) {
                return false;
            }
            this.u(b);
            return true;
        }
        getEnumerator() {
            return getEnumeratorObject(this._inner);
        }
        getEnumeratorObject() {
            return getEnumeratorObject(this._inner);
        }
        asArray() {
            return this._inner;
        }
        d(index_, collection_, a) {
            let b = typeCast(IArrayList_$type, collection_);
            if (b != null) {
                let a_ = b.asArrayList();
                Array.prototype.splice.apply(this._inner, Array.prototype.concat.apply([index_, 0], a_));
                return true;
            }
            let c = typeCast(IArray_$type, collection_);
            if (c != null) {
                let a_ = c.asArray();
                Array.prototype.splice.apply(this._inner, Array.prototype.concat.apply([index_, 0], a_));
                return true;
            }
            let asList_ = typeCast(IList$1_$type.specialize(this.$t), collection_);
            if (asList_ != null) {
                for (let i_ = 0; i_ < asList_.count; i_++) {
                    let item_ = asList_.item(i_);
                    this._inner.splice(index_ + i_, 0, item_);
                }
                return true;
            }
            let arr_ = (Array.isArray(collection_) ? collection_ : null);
            if (arr_ != null) {
                let inn_ = this._inner;
                if (this._inner.length == 0) {
                    if (a) {
                        let parr_ = arr_;
                        let d = arr_.length;
                        for (let i_ = 0; i_ < d; i_++) {
                            inn_[index_++] = parr_[i_];
                        }
                    }
                    else {
                        let e = arr_.length;
                        for (let i_ = 0; i_ < e; i_++) {
                            inn_[index_++] = typeCastObjTo$t(this.$t, arr_[i_]);
                        }
                    }
                }
                else {
                    for (let i_ = 0; i_ < arr_.length; i_++) {
                        inn_.splice(index_++, 0, arr_[i_]);
                    }
                }
                return true;
            }
            return false;
        }
        t(a, b) {
            if (this.d(a, b, false)) {
                return;
            }
            let j_ = a;
            for (let item_ of fromEn(b)) {
                this._inner.splice(j_, 0, item_);
                j_++;
            }
        }
        s(a, b) {
            if (this.d(a, b, true)) {
                return;
            }
            let j_ = a;
            for (let item_ of fromEnum(b)) {
                this._inner.splice(j_, 0, item_);
                j_++;
            }
        }
        v(index_, numToRemove_) {
            if (index_ == 0 && numToRemove_ == 1) {
                this._inner.shift();
                return;
            }
            this._inner.splice(index_, numToRemove_);
        }
        copyTo1(a, b) {
            arrayCopyTo(this._inner, a, b);
        }
        get isFixedSize() {
            return false;
        }
        add1(a) {
            this.n(typeCastObjTo$t(this.$t, a));
            return this._inner.length - 1;
        }
        contains1(a) {
            return this.indexOf1(a) >= 0;
        }
        indexOf1(a) {
            return this.indexOf(typeCastObjTo$t(this.$t, a));
        }
        insert1(a, b) {
            this.r(a, typeCastObjTo$t(this.$t, b));
        }
        remove1(a) {
            let b = this.indexOf1(a);
            if (b < 0) {
                return;
            }
            this.u(b);
        }
        y() {
            let a = null;
            if (this.$t == Number_$type) {
                a = (b, c) => {
                    let d = b;
                    let e = c;
                    if (d < e) {
                        return -1;
                    }
                    if (d == e) {
                        return 0;
                    }
                    return 1;
                };
            }
            else if (this.$t == Number_$type) {
                a = (b, c) => {
                    let d = b;
                    let e = c;
                    if (d < e) {
                        return -1;
                    }
                    if (d == e) {
                        return 0;
                    }
                    return 1;
                };
            }
            else if (this.$t == Number_$type) {
                a = (b, c) => {
                    let d = typeGetValue(b);
                    let e = typeGetValue(c);
                    if (d < e) {
                        return -1;
                    }
                    if (d == e) {
                        return 0;
                    }
                    return 1;
                };
            }
            else if (this.$t == Date_$type) {
                a = (b, c) => {
                    let d = b;
                    let e = c;
                    if (d.getTime() < e.getTime()) {
                        return -1;
                    }
                    if (d.getTime() == e.getTime()) {
                        return 0;
                    }
                    return 1;
                };
            }
            else {
                a = (b, c) => stringCompareTo(b, c);
            }
            this.ab(a);
        }
        ab(compare_) {
            this._inner.sort(compare_);
        }
        aa(compare_) {
            this._inner.sort(compare_);
        }
        o(a) {
            for (let item_ of fromEnum(a)) {
                this._inner.push(item_);
            }
        }
        toArray() {
            return this._inner;
        }
        q(a) {
            for (let b = 0; b < this._inner.length; b++) {
                a(this._inner[b]);
            }
        }
        get isSynchronized() {
            return true;
        }
        get syncRoot() {
            return this.m;
        }
        f(a) {
            return this.g(a, Comparer$1.defaultComparerValue(this.$t));
        }
        g(a, b) {
            let c = 0;
            let d = this.count - 1;
            while (c <= d) {
                let e = c + (intDivide((d - c), 2));
                let f = this._inner[e];
                let g = b.compare(f, a);
                if (g == 0) {
                    return e;
                }
                if (g < 0) {
                    c = e + 1;
                }
                else {
                    d = e - 1;
                }
            }
            return ~c;
        }
        e() {
            return new ReadOnlyCollection$1(this.$t, 1, this);
        }
        w() {
            for (let a = 0; a < intDivide(this.count, 2); a++) {
                let b = this.count - a - 1;
                let c = this._inner[a];
                this._inner[a] = this._inner[b];
                this._inner[b] = c;
            }
        }
        z(a) {
            this.aa(runOn(a, a.compare));
        }
        i(a) {
            for (let b = 0; b < this._inner.length; b++) {
                if (a(this._inner[b])) {
                    return b;
                }
            }
            return -1;
        }
        l(a) {
            throw new NotImplementedException(0);
        }
    }
    List$1.$t = /*@__PURE__*/ markType(List$1, 'List$1', Base.$, [/*@__PURE__*/ IList$1_$type.specialize(0), IArray_$type, IList_$type]);
    return List$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockInfo = /*@__PURE__*/ (() => {
    class StockInfo extends Base {
        constructor() {
            super(...arguments);
            this._company = null;
            this._symbol = null;
            this._sector = null;
        }
        get company() {
            return this._company;
        }
        set company(a) {
            this._company = a;
        }
        get symbol() {
            return this._symbol;
        }
        set symbol(a) {
            this._symbol = a;
        }
        get sector() {
            return this._sector;
        }
        set sector(a) {
            this._sector = a;
        }
    }
    StockInfo.$t = /*@__PURE__*/ markType(StockInfo, 'StockInfo');
    return StockInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockPricePoint = /*@__PURE__*/ (() => {
    class StockPricePoint extends StockInfo {
        constructor() {
            super();
            this._open = 0;
            this._high = 0;
            this._low = 0;
            this._close = 0;
            this._volume = 0;
            this._date = new Date();
        }
        get open() {
            return this._open;
        }
        set open(a) {
            this._open = a;
        }
        get high() {
            return this._high;
        }
        set high(a) {
            this._high = a;
        }
        get low() {
            return this._low;
        }
        set low(a) {
            this._low = a;
        }
        get close() {
            return this._close;
        }
        set close(a) {
            this._close = a;
        }
        get volume() {
            return this._volume;
        }
        set volume(a) {
            this._volume = a;
        }
        get date() {
            return this._date;
        }
        set date(a) {
            this._date = a;
        }
    }
    StockPricePoint.$t = /*@__PURE__*/ markType(StockPricePoint, 'StockPricePoint', StockInfo.$);
    return StockPricePoint;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockPriceHistory = /*@__PURE__*/ (() => {
    class StockPriceHistory extends List$1 {
        constructor() {
            super(StockPricePoint.$, 0);
            this._symbol = null;
            this._company = null;
            this.symbol = "";
            this.company = "";
        }
        get title() {
            let a = stringIsNullOrEmpty(this.company) ? "" : " - " + this.company;
            return this.symbol + a;
        }
        get symbol() {
            return this._symbol;
        }
        set symbol(a) {
            this._symbol = a;
        }
        get company() {
            return this._company;
        }
        set company(a) {
            this._company = a;
        }
        toString() {
            return this.symbol;
        }
    }
    StockPriceHistory.$t = /*@__PURE__*/ markType(StockPriceHistory, 'StockPriceHistory', /*@__PURE__*/ List$1.$.specialize(StockPricePoint.$));
    return StockPriceHistory;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockPosition = /*@__PURE__*/ (() => {
    class StockPosition extends StockInfo {
        constructor() {
            super(...arguments);
            this._index = 0;
            this._tradeDate = new Date();
            this._shares = 0;
            this._costPerShare = 0;
            this._marketPrice = 0;
            this._data = null;
            this._action = null;
        }
        get index() {
            return this._index;
        }
        set index(a) {
            this._index = a;
        }
        get tradeDate() {
            return this._tradeDate;
        }
        set tradeDate(a) {
            this._tradeDate = a;
        }
        get shares() {
            return this._shares;
        }
        set shares(a) {
            this._shares = a;
        }
        get costPerShare() {
            return this._costPerShare;
        }
        set costPerShare(a) {
            this._costPerShare = a;
        }
        get costTotal() {
            return Math.round(this.shares * this.costPerShare);
        }
        get marketValue() {
            return Math.round(this.shares * this.marketPrice);
        }
        get marketPrice() {
            return this._marketPrice;
        }
        set marketPrice(a) {
            this._marketPrice = a;
        }
        get gainValue() {
            return Math.round(this.marketValue - this.costTotal);
        }
        get gainPercentage() {
            return this.gainValue / this.costTotal * 100;
        }
        get data() {
            return this._data;
        }
        set data(a) {
            this._data = a;
        }
        get action() {
            return this._action;
        }
        set action(a) {
            this._action = a;
        }
    }
    StockPosition.$t = /*@__PURE__*/ markType(StockPosition, 'StockPosition', StockInfo.$);
    return StockPosition;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockChangedEventArgs = /*@__PURE__*/ (() => {
    class StockChangedEventArgs extends Base {
        constructor(a, b) {
            super();
            this._addedSymbols = null;
            this._removedSymbols = null;
            this.addedSymbols = a;
            this.removedSymbols = b;
        }
        get addedSymbols() {
            return this._addedSymbols;
        }
        set addedSymbols(a) {
            this._addedSymbols = a;
        }
        get removedSymbols() {
            return this._removedSymbols;
        }
        set removedSymbols(a) {
            this._removedSymbols = a;
        }
    }
    StockChangedEventArgs.$t = /*@__PURE__*/ markType(StockChangedEventArgs, 'StockChangedEventArgs');
    return StockChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyValuePair$2 = /*@__PURE__*/ (() => {
    class KeyValuePair$2 extends ValueType {
        constructor($tKey, $tValue, a, ..._rest) {
            super();
            this.$tKey = null;
            this.$tValue = null;
            this.a = null;
            this.c = null;
            this.$tKey = $tKey;
            this.$tValue = $tValue;
            this.$type = this.$type.specialize(this.$tKey, this.$tValue);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.a = c;
                        this.c = d;
                    }
                    break;
            }
        }
        get key() {
            return this.a;
        }
        get value() {
            return this.c;
        }
    }
    KeyValuePair$2.$t = /*@__PURE__*/ markStruct(KeyValuePair$2, 'KeyValuePair$2');
    return KeyValuePair$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDictionary$2_$type = /*@__PURE__*/ new Type(null, 'IDictionary$2', null, [/*@__PURE__*/ ICollection$1_$type.specialize(/*@__PURE__*/ KeyValuePair$2.$.specialize(0, 1)), /*@__PURE__*/ IEnumerable$1_$type.specialize(/*@__PURE__*/ KeyValuePair$2.$.specialize(0, 1)), IEnumerable_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EqualityComparer$1 = /*@__PURE__*/ (() => {
    class EqualityComparer$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
        static defaultEqualityComparerValue($t) {
            return new DefaultEqualityComparer$1($t);
        }
        equalsC(a, b) {
            return this.equalsC(typeCastObjTo$t(this.$t, a), typeCastObjTo$t(this.$t, b));
        }
        getHashCodeC(a) {
            return this.getHashCodeC(typeCastObjTo$t(this.$t, a));
        }
    }
    EqualityComparer$1.$t = /*@__PURE__*/ markType(EqualityComparer$1, 'EqualityComparer$1', Base.$, [IEqualityComparer_$type, /*@__PURE__*/ IEqualityComparer$1_$type.specialize(0)]);
    return EqualityComparer$1;
})();
/**
 * @hidden
 */
let DefaultEqualityComparer$1 = /*@__PURE__*/ (() => {
    class DefaultEqualityComparer$1 extends EqualityComparer$1 {
        constructor($t) {
            super($t);
            this.$t = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
        equalsC(a, b) {
            return Base.equalsStatic(getBoxIfEnum(this.$t, a), getBoxIfEnum(this.$t, b));
        }
        getHashCodeC(a) {
            return Base.getHashCodeStatic(a);
        }
    }
    DefaultEqualityComparer$1.$t = /*@__PURE__*/ markType(DefaultEqualityComparer$1, 'DefaultEqualityComparer$1', /*@__PURE__*/ EqualityComparer$1.$.specialize(0));
    return DefaultEqualityComparer$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InvalidOperationException = /*@__PURE__*/ (() => {
    class InvalidOperationException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "Invalid operation");
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(2, c, d);
                        throw new NotImplementedException(0);
                    }
                    break;
            }
        }
    }
    InvalidOperationException.$t = /*@__PURE__*/ markType(InvalidOperationException, 'InvalidOperationException', BaseError.$);
    return InvalidOperationException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Dictionary_EnumerableCollection$3 = /*@__PURE__*/ (() => {
    class Dictionary_EnumerableCollection$3 extends Base {
        constructor($tKey, $tValue, $t, a, b, c) {
            super();
            this.$tKey = null;
            this.$tValue = null;
            this.$t = null;
            this.c = null;
            this.b = null;
            this.a = null;
            this.$tKey = $tKey;
            this.$tValue = $tValue;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$tKey, this.$tValue, this.$t);
            this.c = b;
            this.b = c;
            this.a = a;
        }
        get count() {
            return this.a.count;
        }
        get isReadOnly() {
            return true;
        }
        add(a) {
            throw new InvalidOperationException(0);
        }
        clear() {
            throw new InvalidOperationException(0);
        }
        contains(a) {
            for (let b of fromEn(this.c)) {
                if (Base.equalsStatic(getBoxIfEnum(this.$t, b), getBoxIfEnum(this.$t, a))) {
                    return true;
                }
            }
            return false;
        }
        copyTo(a, b) {
            for (let c of fromEn(this.c)) {
                a[b++] = c;
            }
        }
        remove(a) {
            throw new InvalidOperationException(0);
        }
        getEnumerator() {
            return getEnumeratorObject(this.c);
        }
        getEnumeratorObject() {
            return getEnumeratorObject(this.c);
        }
    }
    Dictionary_EnumerableCollection$3.$t = /*@__PURE__*/ markType(Dictionary_EnumerableCollection$3, 'Dictionary_EnumerableCollection$3', Base.$, [/*@__PURE__*/ ICollection$1_$type.specialize(2)]);
    return Dictionary_EnumerableCollection$3;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArgumentException = /*@__PURE__*/ (() => {
    class ArgumentException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(2, c, d);
                    }
                    break;
            }
        }
    }
    ArgumentException.$t = /*@__PURE__*/ markType(ArgumentException, 'ArgumentException', BaseError.$);
    return ArgumentException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Dictionary$2 = /*@__PURE__*/ (() => {
    class Dictionary$2 extends Base {
        constructor($tKey, $tValue, a, ..._rest) {
            super();
            this.$tKey = null;
            this.$tValue = null;
            this.j = null;
            this.k = 0;
            this.e = false;
            this.d = false;
            this.c = false;
            this.a = null;
            this.b = null;
            this.$tKey = $tKey;
            this.$tValue = $tValue;
            this.$type = this.$type.specialize(this.$tKey, this.$tValue);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [0, null];
                        {
                            let e = c[0];
                            let f = c[1];
                            this.a = ({});
                            this.b = ({});
                            this.j = f || EqualityComparer$1.defaultEqualityComparerValue(this.$tKey);
                            this.e = f == null && (($tKey === String_$type));
                            this.d = ($tKey === Base.$type || ($tKey.InstanceConstructor && !$tKey.InstanceConstructor.prototype.getHashCode));
                            this.c = f == null && (this.e || this.d || ($tKey.InstanceConstructor && $tKey.InstanceConstructor.prototype.getHashCode == Base.prototype.getHashCode));
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = [c, null];
                        {
                            let f = d[0];
                            let g = d[1];
                            this.a = ({});
                            this.b = ({});
                            this.j = g || EqualityComparer$1.defaultEqualityComparerValue(this.$tKey);
                            this.e = g == null && (($tKey === String_$type));
                            this.d = ($tKey === Base.$type || ($tKey.InstanceConstructor && !$tKey.InstanceConstructor.prototype.getHashCode));
                            this.c = g == null && (this.e || this.d || ($tKey.InstanceConstructor && $tKey.InstanceConstructor.prototype.getHashCode == Base.prototype.getHashCode));
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = [0, c];
                        {
                            let f = d[0];
                            let g = d[1];
                            this.a = ({});
                            this.b = ({});
                            this.j = g || EqualityComparer$1.defaultEqualityComparerValue(this.$tKey);
                            this.e = g == null && (($tKey === String_$type));
                            this.d = ($tKey === Base.$type || ($tKey.InstanceConstructor && !$tKey.InstanceConstructor.prototype.getHashCode));
                            this.c = g == null && (this.e || this.d || ($tKey.InstanceConstructor && $tKey.InstanceConstructor.prototype.getHashCode == Base.prototype.getHashCode));
                        }
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = [c.count];
                        {
                            let f = d[0];
                            let g = [f, null];
                            {
                                let i = g[0];
                                let j = g[1];
                                this.a = ({});
                                this.b = ({});
                                this.j = j || EqualityComparer$1.defaultEqualityComparerValue(this.$tKey);
                                this.e = j == null && (($tKey === String_$type));
                                this.d = ($tKey === Base.$type || ($tKey.InstanceConstructor && !$tKey.InstanceConstructor.prototype.getHashCode));
                                this.c = j == null && (this.e || this.d || ($tKey.InstanceConstructor && $tKey.InstanceConstructor.prototype.getHashCode == Base.prototype.getHashCode));
                            }
                        }
                        for (let e of fromEnum(c)) {
                            this.item(e.key, e.value);
                        }
                    }
                    break;
                case 4:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.a = ({});
                        this.b = ({});
                        this.j = d || EqualityComparer$1.defaultEqualityComparerValue(this.$tKey);
                        this.e = d == null && (($tKey === String_$type));
                        this.d = ($tKey === Base.$type || ($tKey.InstanceConstructor && !$tKey.InstanceConstructor.prototype.getHashCode));
                        this.c = d == null && (this.e || this.d || ($tKey.InstanceConstructor && $tKey.InstanceConstructor.prototype.getHashCode == Base.prototype.getHashCode));
                    }
                    break;
            }
        }
        get count() {
            return this.k;
        }
        item(key_, a) {
            if (arguments.length === 2) {
                this.o(key_, a, false);
                return a;
            }
            else {
                let result_ = this.f(key_);
                let a = (result_ !== undefined);
                return a ? result_ : Type.getDefaultValue(this.$tValue);
            }
        }
        get m() {
            return this.k;
        }
        containsKey(a) {
            if (this.c) {
                let b = this.n(a);
                return (this.a.hasOwnProperty(b));
            }
            else {
                let c = this.l(a);
                let d = this.b[c];
                if (d) {
                    if ((d.$isHashSetBucket)) {
                        let g = (d);
                        for (let f = 0; f < g.length; f++) {
                            let e = g[f];
                            if (this.j.equalsC((e.key), a)) {
                                return true;
                            }
                        }
                    }
                    else {
                        return this.j.equalsC((d.key), a);
                    }
                }
            }
            return false;
        }
        removeItem(a) {
            if (this.c) {
                let b = this.n(a);
                if ((!this.a.hasOwnProperty(b))) {
                    return false;
                }
                delete this.a[b];
                delete this.b[b];
                this.k--;
                return true;
            }
            let c = this.l(a);
            let d = this.b[c];
            if (d) {
                if ((d.$isHashSetBucket)) {
                    let g = (d);
                    for (let f = 0; f < g.length; f++) {
                        let e = g[f];
                        if (this.j.equalsC((e.key), a)) {
                            arrayRemoveItem(d, e);
                            if ((d.length) == 1) {
                                this.b[c] = (d[0]);
                            }
                            this.k--;
                            return true;
                        }
                    }
                }
                else {
                    if (this.j.equalsC((d.key), a)) {
                        delete this.b[c];
                        this.k--;
                        return true;
                    }
                }
            }
            return false;
        }
        clear() {
            this.k = 0;
            this.a = ({});
            this.b = ({});
        }
        n(a) {
            if (this.e) {
                return stringToString$1(this.$tKey, a);
            }
            else {
                return Base.getHashCodeStatic(a).toString();
            }
        }
        l(a) {
            return this.j.getHashCodeC(a);
        }
        addItem(a, b) {
            this.o(a, b, true);
        }
        o(a, b, c) {
            if (this.c) {
                let d = this.n(a);
                if ((!this.a.hasOwnProperty(d))) {
                    this.k++;
                }
                else if (c) {
                    throw new ArgumentException(1, "Duplicate key added to the dictionary");
                }
                this.a[d] = a;
                this.b[d] = b;
            }
            else {
                let e = this.l(a);
                let f = this.b[e];
                if (f) {
                    if ((f.$isHashSetBucket)) {
                        let i = (f);
                        for (let h = 0; h < i.length; h++) {
                            let g = i[h];
                            if (this.j.equalsC((g.key), a)) {
                                if (c) {
                                    throw new ArgumentException(1, "Duplicate key added to the dictionary");
                                }
                                g.value = b;
                                return;
                            }
                        }
                        f.push({ key: a, value: b });
                        this.k++;
                    }
                    else {
                        if (this.j.equalsC((f.key), a)) {
                            if (c) {
                                throw new ArgumentException(1, "Duplicate key added to the dictionary");
                            }
                            f.value = b;
                        }
                        else {
                            let j = typeCastObjTo$t(this.$tValue, ([f, { key: a, value: b }]));
                            j.$isHashSetBucket = true;
                            ;
                            this.b[e] = j;
                            this.k++;
                        }
                    }
                }
                else {
                    this.b[e] = { key: a, value: b };
                    this.k++;
                }
            }
        }
        f(a) {
            if (this.c) {
                let b = this.n(a);
                if ((this.a.hasOwnProperty(b))) {
                    let c = (this.b[b]);
                    return c;
                }
            }
            else {
                let d = this.l(a);
                let e = this.b[d];
                if (e) {
                    if ((e.$isHashSetBucket)) {
                        let h = (e);
                        for (let g = 0; g < h.length; g++) {
                            let f = h[g];
                            if (this.j.equalsC((f.key), a)) {
                                let i = (f.value);
                                return i;
                            }
                        }
                    }
                    else {
                        if (this.j.equalsC((e.key), a)) {
                            let j = (e.value);
                            return j;
                        }
                    }
                }
            }
            return typeCastObjTo$t(this.$tValue, (undefined));
        }
        tryGetValue(a, b) {
            if (this.c) {
                let c = this.n(a);
                if ((this.a.hasOwnProperty(c))) {
                    b = (this.b[c]);
                    return {
                        ret: true,
                        p1: b
                    };
                }
            }
            else {
                let d = this.l(a);
                let e = this.b[d];
                if (e) {
                    if ((e.$isHashSetBucket)) {
                        let h = (e);
                        for (let g = 0; g < h.length; g++) {
                            let f = h[g];
                            if (this.j.equalsC((f.key), a)) {
                                b = (f.value);
                                return {
                                    ret: true,
                                    p1: b
                                };
                            }
                        }
                    }
                    else {
                        if (this.j.equalsC((e.key), a)) {
                            b = (e.value);
                            return {
                                ret: true,
                                p1: b
                            };
                        }
                    }
                }
            }
            b = Type.getDefaultValue(this.$tValue);
            return {
                ret: false,
                p1: b
            };
        }
        get isReadOnly() {
            return false;
        }
        add(a) {
            this.addItem(a.key, a.value);
        }
        contains(a) {
            let b;
            return ((() => { let c = this.tryGetValue(a.key, b); b = c.p1; return c.ret; })()) && Base.equalsStatic(getBoxIfEnum(this.$tValue, b), getBoxIfEnum(this.$tValue, a.value));
        }
        copyTo(a, b) {
            throw new NotImplementedException(0);
        }
        remove(a) {
            this.removeItem(a.key);
            return true;
        }
        getEnumerator() {
            return getEnumerator(this.g());
        }
        *_g() {
            if (this.c) {
                let a = (Base.getArrayOfProperties(this.a));
                for (let b = 0; b < a.length; b++) {
                    yield new KeyValuePair$2(this.$tKey, this.$tValue, 1, this.a[a[b]], this.b[a[b]]);
                }
            }
            else {
                let c = (Base.getArrayOfProperties(this.b));
                for (let d = 0; d < c.length; d++) {
                    let e = this.b[c[d]];
                    if ((e.$isHashSetBucket)) {
                        let f = (e);
                        for (let g = 0; g < f.length; g++) {
                            let subItem_ = f[g];
                            yield new KeyValuePair$2(this.$tKey, this.$tValue, 1, (subItem_.key), (subItem_.value));
                        }
                    }
                    else {
                        yield new KeyValuePair$2(this.$tKey, this.$tValue, 1, (e.key), (e.value));
                    }
                }
            }
        }
        g() {
            return toEnum(() => this._g());
        }
        *_h() {
            if (this.c) {
                let a = (Base.getArrayOfProperties(this.a));
                for (let b = 0; b < a.length; b++) {
                    yield this.a[a[b]];
                }
            }
            else {
                let c = (Base.getArrayOfProperties(this.b));
                for (let d = 0; d < c.length; d++) {
                    let e = this.b[c[d]];
                    if ((e.$isHashSetBucket)) {
                        let f = (e);
                        for (let g = 0; g < f.length; g++) {
                            let subItem_ = f[g];
                            yield (subItem_.key);
                        }
                    }
                    else {
                        yield (e.key);
                    }
                }
            }
        }
        h() {
            return toEnum(() => this._h());
        }
        *_i() {
            if (this.c) {
                let a = (Base.getArrayOfProperties(this.a));
                for (let b = 0; b < a.length; b++) {
                    yield this.b[a[b]];
                }
            }
            else {
                let c = (Base.getArrayOfProperties(this.b));
                for (let d = 0; d < c.length; d++) {
                    let e = this.b[c[d]];
                    if ((e.$isHashSetBucket)) {
                        let f = (e);
                        for (let g = 0; g < f.length; g++) {
                            let subItem_ = f[g];
                            yield (subItem_.value);
                        }
                    }
                    else {
                        yield (e.value);
                    }
                }
            }
        }
        i() {
            return toEnum(() => this._i());
        }
        getEnumeratorObject() {
            return getEnumerator(this.g());
        }
        get keys() {
            return new Dictionary_EnumerableCollection$3(this.$tKey, this.$tValue, this.$tKey, this, this.h(), this.j || EqualityComparer$1.defaultEqualityComparerValue(this.$tKey));
        }
        get values() {
            return new Dictionary_EnumerableCollection$3(this.$tKey, this.$tValue, this.$tValue, this, this.i(), EqualityComparer$1.defaultEqualityComparerValue(this.$tValue));
        }
    }
    Dictionary$2.$t = /*@__PURE__*/ markType(Dictionary$2, 'Dictionary$2', Base.$, [/*@__PURE__*/ IDictionary$2_$type.specialize(0, 1), IDictionary_$type]);
    return Dictionary$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Random = /*@__PURE__*/ (() => {
    class Random extends Base {
        constructor(a, ..._rest) {
            super();
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                    }
                    break;
            }
        }
        nextDouble() {
            return Math.random();
        }
        next() {
            return this.next1(0x7FFFFFFF);
        }
        next1(a) {
            return truncate(Math.round(this.nextDouble() * (a - 1)));
        }
        next2(a, b) {
            return a + truncate(Math.round(this.nextDouble() * ((b - a) - 1)));
        }
    }
    Random.$t = /*@__PURE__*/ markType(Random, 'Random');
    return Random;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let DateTimeKind_$type = /*@__PURE__*/ markEnum("DateTimeKind", "Unspecified,0|Utc,1|Local,2");
function dateKind() {
    return 2 /* DateTimeKind.Local */;
}
;
function defaultDVDateParse(str) {
    return new Date(parseInt(str.replace("/Date(", "").replace(")/", ""), 10));
}
function dateNow() {
    return new Date();
}
;
function dateMinValue() {
    let d = new Date(1, 0, 1, 0, 0, 0, 0);
    d.setFullYear(1);
    return d;
}
;
function dateMaxValue() {
    return new Date(9999, 12, 31, 23, 59, 59, 0.9999999);
}
;
function dateFromMilliseconds(value) {
    return new Date(value);
}
;
function dateStdTimezoneOffset(date) {
    var jan, jul, janOffset, julOffset;
    jan = new Date(date.getFullYear(), 0, 1);
    jul = new Date(date.getFullYear(), 6, 1);
    julOffset = jul.getTimezoneOffset();
    janOffset = jan.getTimezoneOffset();
    return Math.max(janOffset, julOffset);
}
;
function dateIsDST(date) {
    return date.getTimezoneOffset() < dateStdTimezoneOffset(date);
}
;
function dateFromValues(year, month, day, hour, minute, second, millisecond) {
    return new Date(year, month - 1, day, hour, minute, second, millisecond);
}
function dateFromTicks(ticks) {
    return new Date(ticks);
}
function dateAddSeconds(value, seconds) {
    return dateAddDays(value, seconds / 86400);
}
function dateAddMinutes(value, minutes) {
    return dateAddDays(value, minutes / 1440);
}
function dateAddHours(value, hours) {
    return dateAddDays(value, hours / 24);
}
function dateAddDays(value, days) {
    var result = new Date(+value + (days * 86400000));
    // Correct for any daylight saving time shifts
    if (!dateIsDST(value)) {
        if (dateIsDST(result)) {
            result = new Date(+result - 3600000);
        }
    }
    else {
        if (!dateIsDST(result)) {
            result = new Date(+result + 3600000);
        }
    }
    return result;
}
function dateAddMonths(value, num) {
    var result = new Date(value.getTime());
    var currentMonth = result.getMonth() + result.getFullYear() * 12;
    result.setMonth(result.getMonth() + num);
    var diff = result.getMonth() + result.getFullYear() * 12 - currentMonth;
    // If don't get the right number, set date to
    // last day of previous month
    if (diff != num) {
        result.setDate(0);
    }
    return result;
}
function dateAddYears(value, num) {
    var result = new Date(value.getTime());
    result.setFullYear(result.getFullYear() + num);
    return result;
}
function dateIsLeapYear(year) {
    return year % 4 === 0 && (year % 100 !== 0 || year % 400 == 0);
}
function dateToFileTime(value) {
    return (+value - +new Date(1600, 11, 31, 19, 0, 0, 0)) * 10000;
}
function dateFromFileTime(value) {
    // TODO: Test this
    return +(value / 10000) + +new Date(1600, 11, 31, 19, 0, 0, 0);
}
function dateFromFileTimeUtc(value) {
    return new Date(+(value / 10000) + +Date.UTC(1600, 12, 1, 0, 0, 0, 0));
}
function dateGetMonth(value) {
    return value.getMonth() + 1;
}
function dateToday() {
    var r = new Date();
    r.setHours(0, 0, 0, 0);
    return r;
}
function dateGetTimeOfDay(value) {
    return (value.getHours() * 3600000) +
        (value.getMinutes() * 60000) +
        (value.getSeconds() * 1000) +
        value.getMilliseconds();
}
function dateGetDate(value) {
    return new Date(+value - dateGetTimeOfDay(value));
}
function dateEquals(d1, d2) {
    return d2 instanceof Date && +d1 === +d2;
}
function dateAdd(d, t) { return new Date(+d + t); }
;
function dateSubtract(d, t) { return new Date(+d - t); }
;
function daysInMonth(year, month) {
    switch (month) {
        case 1: return 31; // Jan
        case 2: return dateIsLeapYear(year) ? 29 : 28; // Feb
        case 3: return 31; // Mar
        case 4: return 30; // Apr
        case 5: return 31; // May
        case 6: return 30; // Jun
        case 7: return 31; // Jul
        case 8: return 31; // Aug
        case 9: return 30; // Sep
        case 10: return 31; // Oct
        case 11: return 30; // Nov
        case 12: return 31; // Dec
    }
    // TODO: throw error here?
    return 0;
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockDataLookup = /*@__PURE__*/ (() => {
    class StockDataLookup extends Base {
        static d(a, b, c, d, e) {
            if (StockDataLookup.b.containsKey(a)) {
            }
            else {
                let f = new StockPricePoint();
                f.symbol = a;
                f.company = b;
                f.open = c;
                f.close = c;
                f.volume = d;
                f.sector = e;
                StockDataLookup.b.addItem(a, f);
            }
        }
        static get(a) {
            if (StockDataLookup.b.containsKey(a)) {
                return StockDataLookup.b.item(a);
            }
            else {
                let b = new StockPricePoint();
                b.symbol = a;
                b.open = StockDataLookup.c.next2(100, 500);
                b.volume = StockDataLookup.c.next2(100000, 500000);
                StockDataLookup.b.addItem(a, b);
                return b;
            }
        }
        static staticInit() {
            let a = dateNow();
            StockDataLookup.b = new Dictionary$2(String_$type, StockPricePoint.$, 0);
            StockDataLookup.d("TSLA", "Tesla Inc", 332.01, 10834796, "Transportation");
            StockDataLookup.d("UBER", "Uber Technologies Inc", 38.79, 79442420, "Transportation");
            StockDataLookup.d("NVDA", "Nvidia Corp", 163.5, 16422819, "Technology");
            StockDataLookup.d("GOOG", "Alphabet Inc", 1204.11, 43944923, "Technology");
            StockDataLookup.d("QCOM", "Qualcomm Inc", 83.24, 16689039, "Technology");
            StockDataLookup.d("ROKU", "Roku Inc", 80.76, 22878291, "Technology");
            StockDataLookup.d("CSCO", "Cisco Systems Inc", 51.83, 28869931, "Technology");
            StockDataLookup.d("INTC", "Intel Corp", 45.33, 39091928, "Technology");
            StockDataLookup.d("ADBE", "Adobe Systems Inc", 270.565, 2698322, "Technology");
            StockDataLookup.d("AVGO", "Broadcom Inc", 293.82, 3786434, "Technology");
            StockDataLookup.d("LYFT", "Lyft Inc", 50, 10007408, "Transportation");
            StockDataLookup.d("PYPL", "PayPal Holdings Inc", 107.6, 5657900, "Financial");
            StockDataLookup.d("ORCL", "Oracle Corp", 53.72, 10664674, "Technology");
            StockDataLookup.d("SBUX", "Starbucks Corp", 77.25, 9778829, "Consumer Goods");
            StockDataLookup.d("TWTR", "Twitter Inc", 37.5, 16829698, "Communication");
            StockDataLookup.d("AMAT", "Applied Materials Inc", 39.26, 10725058, "Materials");
            StockDataLookup.d("ATVI", "Activision Blizzard Inc", 44.73, 9803138, "Technology");
            StockDataLookup.d("SNAP", "Snap Inc", 10.05, 15911862, "Communication");
            StockDataLookup.d("TMUS", "T-Mobile US Inc", 74.38, 3477107, "Communication");
            StockDataLookup.d("AMZN", "Amazon.com Inc", 1836.56, 5783410, "Technology");
            StockDataLookup.d("AAPL", "Apple Inc", 223.55, 957369, "Technology");
            StockDataLookup.d("MSFT", "Microsoft Corp", 124.11, 33944923, "Technology");
            StockDataLookup.d("NFLX", "Netflix Inc", 361.95, 16833347, "Communication");
            StockDataLookup.d("BABA", "Alibaba Group Holding Ltd", 169.79, 22330737, "Technology");
            StockDataLookup.d("BAC", "Bank of America Corp", 28.53, 5783410, "Financial");
            StockDataLookup.d("AMJ", "JP Morgan Chase & Co", 25.34, 1350492, "Financial");
            StockDataLookup.d("TXN", "Texas Instruments Inc", 109.17, 7867589, "Technology");
            StockDataLookup.d("CAT", "Caterpillar Inc", 127.51, 8580682, "Industrial");
            StockDataLookup.d("MMM", "3M Co", 173.935, 5916911, "Materials");
            StockDataLookup.d("DIS", "Walt Disney Co", 131.5, 11389896, "Communication");
            StockDataLookup.d("AMD", "Advanced Micro Devices Inc", 26.98, 99017893, "Technology");
            StockDataLookup.d("HON", "Honeywell Intl. Inc", 168.48, 3705165, "Materials");
            StockDataLookup.d("IBM", "Intl. Business Machines", 133.28, 4958021, "Technology");
            StockDataLookup.d("UTX", "United Technologies Corp", 134.03, 4119212, "Technology");
            StockDataLookup.d("CVS", "CVS Health Corp", 54.3, 11183821, "Consumer Goods");
            StockDataLookup.d("DAL", "Delta Air Lines Inc", 55.44, 5223811, "Transportation");
            StockDataLookup.d("CCZ", "Comcast Corp", 55.5, 410, "Communication");
            StockDataLookup.d("BBY", "Best Buy Co Inc", 70.3, 5408468, "Consumer Goods");
            StockDataLookup.d("AAL", "American Airlines Group Inc", 33.16, 7040853, "Transportation");
            StockDataLookup.d("CRM", "Salesforce.Com Inc", 154.92, 5694582, "Financial");
            StockDataLookup.d("C", "Citigroup Inc", 66.13, 23494395, "Financial");
            StockDataLookup.d("F", "Ford Motor Co", 10.17, 51102054, "Transportation");
            StockDataLookup.d("T", "AT&T Inc", 30.35, 27713285, "Communication");
            StockDataLookup.d("V", "Visa Inc", 157.19, 9729964, "Financial");
            StockDataLookup.d("GE", "General Electric Co", 9.85, 60136022, "Energy");
            StockDataLookup.d("MU", "Micron Technology Inc", 37.36, 33092081, "Technology");
            StockDataLookup.d("MA", "Mastercard Inc", 241.51, 4137245, "Financial");
            StockDataLookup.d("HD", "Home Depot Inc", 191, 3326028, "Materials");
            StockDataLookup.d("VZ", "Verizon Comm Inc", 56.72, 13759350, "Communication");
            StockDataLookup.d("EA", "Electronic Arts Inc", 92.01, 3685460, "Communication");
            StockDataLookup.d("FB", "Facebook Inc", 183.5, 16833347, "Technology");
            StockDataLookup.d("GM", "General Motors Company", 36.85, 19454839, "Transportation");
        }
    }
    StockDataLookup.$t = /*@__PURE__*/ markType(StockDataLookup, 'StockDataLookup');
    StockDataLookup.b = null;
    StockDataLookup.c = /*@__PURE__*/ new Random(0);
    return StockDataLookup;
})();
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let CalendarWeekRule_$type = /*@__PURE__*/ markEnum("CalendarWeekRule", "FirstDay,0|FirstFullWeek,1|FirstFourDayWeek,2");
let Calendar = /*@__PURE__*/ (() => {
    class Calendar extends Base {
        eras() {
            // TODO: Base this on the culture
            return [1];
        }
        getEra(time) {
            // TODO: Base this on the culture
            return 1;
        }
        getDayOfMonth(time) {
            // TODO: Base this on the culture
            return time.getDate();
        }
        getDaysInMonth(year, month, era) {
            // TODO: Base this on the culture
            return daysInMonth(year, month);
        }
        getDaysInYear(year, era) {
            // TODO: Base this on the culture
            return dateIsLeapYear(year) ? 366 : 365;
        }
        getMonth(time) {
            // TODO: Base this on the culture
            return dateGetMonth(time);
        }
        getYear(time) {
            // TODO: Base this on the culture
            return time.getFullYear();
        }
        toDateTime(year, month, day, hour, minute, second, millisecond, era) {
            // TODO: Base this on the culture
            return dateFromValues(year, month, day, hour, minute, second, millisecond);
        }
        addMonths(time, months) {
            return dateAddMonths(time, months);
        }
        addYears(time, years) {
            return dateAddYears(time, years);
        }
    }
    Calendar.$t = /*@__PURE__*/ markType(Calendar, "Calendar");
    return Calendar;
})();
let CompareInfo = /*@__PURE__*/ (() => {
    class CompareInfo extends Base {
        compare1(string1, offset1, length1, string2, offset2, length2, options) {
            var v1 = string1.substr(offset1, length1);
            var v2 = string2.substr(offset2, length2);
            // TODO: Handle other compare options
            /*jslint bitwise: true */
            if ((options & 1 /* CompareOptions.IgnoreCase */) !== 0) {
                v1 = v1.toLowerCase();
                v2 = v2.toLowerCase();
            }
            return Base.compare(v1, v2);
        }
        compare4(string1, string2) {
            return this.compare5(string1, string2, 0 /* CompareOptions.None */);
        }
        compare5(string1, string2, options) {
            return this.compare1(string1, 0, string1.length, string2, 0, string2.length, options);
        }
        indexOf1(source, value) {
            return this.indexOf6(source, value, 0, 0 /* CompareOptions.None */);
        }
        indexOf3(source, value, options) {
            return this.indexOf6(source, value, 0, options);
        }
        indexOf6(source, value, startIndex, options) {
            // TODO: Handle other compare options
            /*jslint bitwise: true */
            if ((options & 1 /* CompareOptions.IgnoreCase */) !== 0) {
                source = source.toLowerCase();
                value = value.toLowerCase();
            }
            return source.indexOf(value, startIndex);
        }
        indexOf5(source, value, options) {
            // TODO: Use options
            return source.indexOf(value);
        }
        referenceEquals(a, b) {
            return a === b;
        }
    }
    CompareInfo.$t = /*@__PURE__*/ markType(CompareInfo, "CompareInfo");
    return CompareInfo;
})();
let DateTimeFormat = /*@__PURE__*/ (() => {
    class DateTimeFormat extends Base {
        constructor(cultureName, isInvariant) {
            super();
            this._cultureName = null;
            this._isInvariant = false;
            this._dateSeparator = "/";
            this._timeSeparator = ":";
            this._longDatePattern = "dddd, MMMM d, yyyy";
            this._shortDatePattern = null;
            this._shortTimePattern = "h:mm tt";
            this._monthNames = [];
            this._cultureName = cultureName;
            this._isInvariant = isInvariant;
            let format = new Intl.DateTimeFormat(this._cultureName, { month: 'long' });
            let months = [];
            for (var i = 0; i < 12; i++) {
                const testDate = new Date(0, i, 2, 0, 0, 0);
                months.push(format.format(testDate));
            }
            this._monthNames = months;
        }
        clone() {
            var copy = new DateTimeFormat(this._cultureName, this._isInvariant);
            for (var attr in this) {
                if (this.hasOwnProperty(attr)) {
                    copy[attr] = this[attr];
                }
            }
            return copy;
        }
        get dateSeparator() {
            return this._dateSeparator;
        }
        set dateSeparator(value) {
            this._dateSeparator = value;
        }
        get timeSeparator() {
            return this._timeSeparator;
        }
        set timeSeparator(value) {
            this._timeSeparator = value;
        }
        get longDatePattern() {
            return this._longDatePattern;
        }
        set longDatePattern(value) {
            this._longDatePattern = value;
        }
        get shortDatePattern() {
            if (!this._shortDatePattern) {
                var g = globalInfo[this._isInvariant ? "invariant" : this._cultureName];
                if (g) {
                    this._shortDatePattern = g.d;
                }
                else {
                    this._shortDatePattern = "M/d/yyyy";
                }
            }
            return this._shortDatePattern;
        }
        set shortDatePattern(value) {
            this._shortDatePattern = value;
        }
        get shortTimePattern() {
            return this._shortTimePattern;
        }
        set shortTimePattern(value) {
            this._shortTimePattern = value;
        }
        get monthNames() {
            return this._monthNames;
        }
        set monthNames(value) {
            this._monthNames = value;
        }
    }
    DateTimeFormat.$t = /*@__PURE__*/ markType(DateTimeFormat, "DateTimeFormat");
    return DateTimeFormat;
})();
let NumberFormatInfo = /*@__PURE__*/ (() => {
    class NumberFormatInfo extends Base {
        constructor(cultureName, isInvariant) {
            super();
            this._cultureName = null;
            this._isInvariant = false;
            this._currencySymbol = null;
            this._nativeDigits = null;
            this._negativeSign = "-";
            this._percentSymbol = null;
            this._positiveSign = "+";
            this._numberDecimalSeparator = null;
            this._numberGroupSizes = null;
            this._cultureName = cultureName;
            this._isInvariant = isInvariant;
        }
        clone() {
            var copy = new NumberFormatInfo(this._cultureName, this._isInvariant);
            for (var attr in this) {
                if (this.hasOwnProperty(attr)) {
                    copy[attr] = this[attr];
                }
            }
            return copy;
        }
        get currencySymbol() {
            if (!this._currencySymbol) {
                var g = globalInfo[this._isInvariant ? "invariant" : this._cultureName];
                if (g) {
                    this._currencySymbol = g.c;
                }
                else {
                    this._currencySymbol = "$";
                }
            }
            return this._currencySymbol;
        }
        set currencySymbol(value) {
            this._currencySymbol = value;
        }
        get nativeDigits() {
            if (!this._nativeDigits) {
                var g = globalInfo[this._isInvariant ? "invariant" : this._cultureName];
                if (g && g.n) {
                    this._nativeDigits = Array.from(g.n);
                }
                else {
                    this._nativeDigits = Array.from("0123456789");
                }
            }
            return this._nativeDigits;
        }
        get negativeSign() {
            return this._negativeSign;
        }
        set negativeSign(value) {
            this._negativeSign = value;
        }
        set percentSymbol(value) {
            this._percentSymbol = value;
        }
        get percentSymbol() {
            if (!this._percentSymbol) {
                var temp = (1).toLocaleString(this._cultureName, { style: "percent" });
                this._percentSymbol = temp[temp.length - 1];
            }
            return this._percentSymbol;
        }
        get positiveSign() {
            return this._positiveSign;
        }
        set positiveSign(value) {
            this._positiveSign = value;
        }
        set numberDecimalSeparator(value) {
            this._numberDecimalSeparator = value;
        }
        get numberDecimalSeparator() {
            if (!this._numberDecimalSeparator) {
                this._numberDecimalSeparator = (1.1).toLocaleString(this._cultureName)
                    .substring(1, 2);
            }
            return this._numberDecimalSeparator;
        }
        set numberGroupSeparator(value) {
            this._numberGroupSeparator = value;
        }
        get numberGroupSeparator() {
            if (!this._numberGroupSeparator) {
                var s = (123456789.0).toLocaleString(this._cultureName);
                var result = /\D/.exec(s);
                if (result === null || result.length === 0) {
                    this._numberGroupSeparator = ",";
                }
                else {
                    this._numberGroupSeparator = result[0];
                }
            }
            return this._numberGroupSeparator;
        }
        set numberGroupSizes(value) {
            this._numberGroupSizes = value;
        }
        get numberGroupSizes() {
            if (!this._numberGroupSizes) {
                var s = (123456789.0).toLocaleString(this._cultureName);
                var result = /\D(\d+)\D/.exec(s);
                if (result === null || result.length === 0) {
                    this._numberGroupSizes = [3];
                }
                else {
                    this._numberGroupSizes = [result[1].length];
                }
            }
            return this._numberGroupSizes;
        }
    }
    NumberFormatInfo.$t = /*@__PURE__*/ markType(NumberFormatInfo, "NumberFormatInfo");
    return NumberFormatInfo;
})();
let Thread = /*@__PURE__*/ (() => {
    class Thread extends Base {
        constructor() {
            super(...arguments);
            this._currentCulture = null;
        }
        static get currentThread() {
            if (!this._currentThread) {
                this._currentThread = new Thread();
            }
            return this._currentThread;
        }
        get currentCulture() {
            if (!this._currentCulture) {
                var currentLocale = navigator.language || navigator.userLanguage;
                this._currentCulture = new CultureInfo(currentLocale);
            }
            return this._currentCulture;
        }
        set currentCulture(value) {
            this._currentCulture = value;
        }
    }
    Thread._currentThread = null;
    Thread.$t = /*@__PURE__*/ markType(Thread, "Thread");
    return Thread;
})();
let globalInfo = { "invariant": { c: "¤", d: "MM/dd/yyyy" }, 127: "invariant",
    "af": { c: "R", d: "yyyy/MM/dd" },
    54: "af", "af-ZA": { c: "R", d: "yyyy/MM/dd" },
    1078: "af-ZA", "am": { c: "ETB", d: "d/M/yyyy" },
    94: "am", "am-ET": { c: "ETB", d: "d/M/yyyy" },
    1118: "am-ET", "ar": { c: "ر.س.‏", d: "dd/MM/yy", n: "٠١٢٣٤٥٦٧٨٩" },
    1: "ar", "ar-AE": { c: "د.إ.‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    14337: "ar-AE", "ar-BH": { c: "د.ب.‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    15361: "ar-BH", "ar-DZ": { c: "د.ج.‏", d: "dd-MM-yyyy" },
    5121: "ar-DZ", "ar-EG": { c: "ج.م.‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    3073: "ar-EG", "ar-IQ": { c: "د.ع.‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    2049: "ar-IQ", "ar-JO": { c: "د.ا.‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    11265: "ar-JO", "ar-KW": { c: "د.ك.‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    13313: "ar-KW", "ar-LB": { c: "ل.ل.‏‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    12289: "ar-LB", "ar-LY": { c: "د.ل.‏‏", d: "dd/MM/yyyy" },
    4097: "ar-LY", "ar-MA": { c: "د.م.‏‏", d: "dd-MM-yyyy" },
    6145: "ar-MA", "arn": { c: "$", d: "dd-MM-yyyy" },
    122: "arn", "arn-CL": { c: "$", d: "dd-MM-yyyy" },
    1146: "arn-CL", "ar-OM": { c: "ر.ع.‏‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    8193: "ar-OM", "ar-QA": { c: "ر.ق.‏‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    16385: "ar-QA", "ar-SA": { c: "ر.س.‏", d: "dd/MM/yy", n: "٠١٢٣٤٥٦٧٨٩" },
    1025: "ar-SA", "ar-SY": { c: "ل.س.‏‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    10241: "ar-SY", "ar-TN": { c: "د.ت.‏‏", d: "dd-MM-yyyy" },
    7169: "ar-TN", "ar-YE": { c: "ر.ي.‏‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    9217: "ar-YE", "as": { c: "₹", d: "dd-MM-yyyy", n: "০১২৩৪৫৬৭৮৯" },
    77: "as", "as-IN": { c: "₹", d: "dd-MM-yyyy", n: "০১২৩৪৫৬৭৮৯" },
    1101: "as-IN", "az": { c: "man.", d: "dd.MM.yyyy" },
    44: "az", "az-Cyrl": { c: "ман.", d: "dd.MM.yyyy" },
    29740: "az-Cyrl", "az-Cyrl-AZ": { c: "ман.", d: "dd.MM.yyyy" },
    2092: "az-Cyrl-AZ", "az-Latn": { c: "man.", d: "dd.MM.yyyy" },
    30764: "az-Latn", "az-Latn-AZ": { c: "man.", d: "dd.MM.yyyy" },
    1068: "az-Latn-AZ", "ba": { c: "₽", d: "dd.MM.yy" },
    109: "ba", "ba-RU": { c: "₽", d: "dd.MM.yy" },
    1133: "ba-RU", "be": { c: "Br", d: "dd.MM.yy" },
    35: "be", "be-BY": { c: "Br", d: "dd.MM.yy" },
    1059: "be-BY", "bg": { c: "лв.", d: "d.M.yyyy \"г.\"" },
    2: "bg", "bg-BG": { c: "лв.", d: "d.M.yyyy \"г.\"" },
    1026: "bg-BG", "bn": { c: "₹", d: "dd-MM-yy", n: "০১২৩৪৫৬৭৮৯" },
    69: "bn", "bn-BD": { c: "৳", d: "dd-MM-yy", n: "০১২৩৪৫৬৭৮৯" },
    2117: "bn-BD", "bn-IN": { c: "₹", d: "dd-MM-yy", n: "০১২৩৪৫৬৭৮৯" },
    1093: "bn-IN", "bo": { c: "¥", d: "yyyy/M/d", n: "༠༡༢༣༤༥༦༧༨༩" },
    81: "bo", "bo-CN": { c: "¥", d: "yyyy/M/d", n: "༠༡༢༣༤༥༦༧༨༩" },
    1105: "bo-CN", "br": { c: "€", d: "dd/MM/yyyy" },
    126: "br", "br-FR": { c: "€", d: "dd/MM/yyyy" },
    1150: "br-FR", "bs": { c: "KM", d: "d.M.yyyy" },
    30746: "bs", "bs-Cyrl": { c: "КМ", d: "d.M.yyyy" },
    25626: "bs-Cyrl", "bs-Cyrl-BA": { c: "КМ", d: "d.M.yyyy" },
    8218: "bs-Cyrl-BA", "bs-Latn": { c: "KM", d: "d.M.yyyy" },
    26650: "bs-Latn", "bs-Latn-BA": { c: "KM", d: "d.M.yyyy" },
    5146: "bs-Latn-BA", "ca": { c: "€", d: "dd/MM/yyyy" },
    3: "ca", "ca-ES": { c: "€", d: "dd/MM/yyyy" },
    1027: "ca-ES", "ca-ES-valencia": { c: "€", d: "dd/MM/yy" },
    2051: "ca-ES-valencia", "chr": { c: "$", d: "M/d/yyyy" },
    92: "chr", "chr-Cher": { c: "$", d: "M/d/yyyy" },
    31836: "chr-Cher", "chr-Cher-US": { c: "$", d: "M/d/yyyy" },
    1116: "chr-Cher-US", "co": { c: "€", d: "dd/MM/yyyy" },
    131: "co", "co-FR": { c: "€", d: "dd/MM/yyyy" },
    1155: "co-FR", "cs": { c: "Kč", d: "d. M. yyyy" },
    5: "cs", "cs-CZ": { c: "Kč", d: "d. M. yyyy" },
    1029: "cs-CZ", "cy": { c: "£", d: "dd/MM/yy" },
    82: "cy", "cy-GB": { c: "£", d: "dd/MM/yy" },
    1106: "cy-GB", "da": { c: "kr.", d: "dd-MM-yyyy" },
    6: "da", "da-DK": { c: "kr.", d: "dd-MM-yyyy" },
    1030: "da-DK", "de": { c: "€", d: "dd.MM.yyyy" },
    7: "de", "de-AT": { c: "€", d: "dd.MM.yyyy" },
    3079: "de-AT", "de-CH": { c: "Fr.", d: "dd.MM.yyyy" },
    2055: "de-CH", "de-DE": { c: "€", d: "dd.MM.yyyy" },
    1031: "de-DE", "de-LI": { c: "CHF", d: "dd.MM.yyyy" },
    5127: "de-LI", "de-LU": { c: "€", d: "dd.MM.yyyy" },
    4103: "de-LU", "dsb": { c: "€", d: "d. M. yyyy" },
    31790: "dsb", "dsb-DE": { c: "€", d: "d. M. yyyy" },
    2094: "dsb-DE", "dv": { c: "ރ.", d: "dd/MM/yy" },
    101: "dv", "dv-MV": { c: "ރ.", d: "dd/MM/yy" },
    1125: "dv-MV", "el": { c: "€", d: "d/M/yyyy" },
    8: "el", "el-GR": { c: "€", d: "d/M/yyyy" },
    1032: "el-GR", "en": { c: "$", d: "M/d/yyyy" },
    9: "en", "en-029": { c: "EC$", d: "dd/MM/yyyy" },
    9225: "en-029", "en-AU": { c: "$", d: "d/MM/yyyy" },
    3081: "en-AU", "en-BZ": { c: "BZ$", d: "dd/MM/yyyy" },
    10249: "en-BZ", "en-CA": { c: "$", d: "yyyy-MM-dd" },
    4105: "en-CA", "en-GB": { c: "£", d: "dd/MM/yyyy" },
    2057: "en-GB", "en-HK": { c: "$", d: "d/M/yy" },
    15369: "en-HK", "en-IE": { c: "€", d: "dd/MM/yyyy" },
    6153: "en-IE", "en-IN": { c: "₹", d: "dd-MM-yyyy" },
    16393: "en-IN", "en-JM": { c: "J$", d: "dd/MM/yyyy" },
    8201: "en-JM", "en-MY": { c: "RM", d: "d/M/yyyy" },
    17417: "en-MY", "en-NZ": { c: "$", d: "d/MM/yyyy" },
    5129: "en-NZ", "en-PH": { c: "₱", d: "M/d/yyyy" },
    13321: "en-PH", "en-SG": { c: "$", d: "d/M/yyyy" },
    18441: "en-SG", "en-TT": { c: "TT$", d: "dd/MM/yyyy" },
    11273: "en-TT", "en-US": { c: "$", d: "M/d/yyyy" },
    1033: "en-US", "en-ZA": { c: "R", d: "yyyy-MM-dd" },
    7177: "en-ZA", "en-ZW": { c: "$", d: "dd/MM/yyyy" },
    12297: "en-ZW", "es": { c: "€", d: "dd/MM/yyyy" },
    10: "es", "es-419": { c: "US$", d: "dd/MM/yy" },
    22538: "es-419", "es-AR": { c: "$", d: "dd/MM/yyyy" },
    11274: "es-AR", "es-BO": { c: "Bs.", d: "dd/MM/yyyy" },
    16394: "es-BO", "es-CL": { c: "$", d: "dd-MM-yyyy" },
    13322: "es-CL", "es-CO": { c: "$", d: "dd/MM/yyyy" },
    9226: "es-CO", "es-CR": { c: "₡", d: "dd/MM/yyyy" },
    5130: "es-CR", "es-DO": { c: "RD$", d: "d/M/yy" },
    7178: "es-DO", "es-EC": { c: "$", d: "dd/MM/yyyy" },
    12298: "es-EC", "es-ES": { c: "€", d: "dd/MM/yyyy" },
    3082: "es-ES", "es-GT": { c: "Q", d: "dd/MM/yyyy" },
    4106: "es-GT", "es-HN": { c: "L.", d: "dd/MM/yyyy" },
    18442: "es-HN", "es-MX": { c: "$", d: "dd/MM/yyyy" },
    2058: "es-MX", "es-NI": { c: "C$", d: "dd/MM/yyyy" },
    19466: "es-NI", "es-PA": { c: "B/.", d: "d/M/yy" },
    6154: "es-PA", "es-PE": { c: "S/.", d: "dd/MM/yyyy" },
    10250: "es-PE", "es-PR": { c: "$", d: "dd/MM/yyyy" },
    20490: "es-PR", "es-PY": { c: "₲", d: "dd/MM/yyyy" },
    15370: "es-PY", "es-SV": { c: "$", d: "dd/MM/yyyy" }, 17418: "es-SV", "es-US": { c: "$", d: "M/d/yyyy" }, 21514: "es-US", "es-UY": { c: "$U", d: "dd/MM/yyyy" }, 14346: "es-UY", "es-VE": { c: "Bs.F.", d: "dd-MM-yyyy" }, 8202: "es-VE", "et": { c: "€", d: "d.MM.yyyy" }, 37: "et", "et-EE": { c: "€", d: "d.MM.yyyy" }, 1061: "et-EE", "eu": { c: "€", d: "yyyy/MM/dd" }, 45: "eu", "eu-ES": { c: "€", d: "yyyy/MM/dd" }, 1069: "eu-ES", "fa": { c: "ريال", d: "dd/MM/yyyy", n: "۰۱۲۳۴۵۶۷۸۹" }, 41: "fa", "fa-IR": { c: "ريال", d: "dd/MM/yyyy", n: "۰۱۲۳۴۵۶۷۸۹" }, 1065: "fa-IR", "ff": { c: "CFA", d: "dd/MM/yyyy" }, 103: "ff", "ff-Latn": { c: "CFA", d: "dd/MM/yyyy" }, 31847: "ff-Latn", "ff-Latn-SN": { c: "CFA", d: "dd/MM/yyyy" }, 2151: "ff-Latn-SN", "fi": { c: "€", d: "d.M.yyyy" }, 11: "fi", "fi-FI": { c: "€", d: "d.M.yyyy" }, 1035: "fi-FI", "fil": { c: "₱", d: "M/d/yyyy" }, 100: "fil", "fil-PH": { c: "₱", d: "M/d/yyyy" }, 1124: "fil-PH", "fo": { c: "kr.", d: "dd-MM-yyyy" }, 56: "fo", "fo-FO": { c: "kr.", d: "dd-MM-yyyy" }, 1080: "fo-FO", "fr": { c: "€", d: "dd/MM/yyyy" }, 12: "fr", "fr-BE": { c: "€", d: "dd-MM-yy" }, 2060: "fr-BE", "fr-CA": { c: "$", d: "yyyy-MM-dd" }, 3084: "fr-CA", "fr-CD": { c: "FC", d: "dd/MM/yyyy" }, 9228: "fr-CD", "fr-CH": { c: "fr.", d: "dd.MM.yyyy" }, 4108: "fr-CH", "fr-CI": { c: "CFA", d: "dd/MM/yyyy" }, 12300: "fr-CI", "fr-CM": { c: "FCFA", d: "dd/MM/yyyy" }, 11276: "fr-CM", "fr-FR": { c: "€", d: "dd/MM/yyyy" }, 1036: "fr-FR", "fr-HT": { c: "G", d: "dd/MM/yyyy" }, 15372: "fr-HT", "fr-LU": { c: "€", d: "dd/MM/yyyy" }, 5132: "fr-LU", "fr-MA": { c: "DH", d: "dd/MM/yyyy" }, 14348: "fr-MA", "fr-MC": { c: "€", d: "dd/MM/yyyy" }, 6156: "fr-MC", "fr-ML": { c: "CFA", d: "dd/MM/yyyy" }, 13324: "fr-ML", "fr-RE": { c: "€", d: "dd/MM/yyyy" }, 8204: "fr-RE", "fr-SN": { c: "CFA", d: "dd/MM/yyyy" }, 10252: "fr-SN", "fy": { c: "€", d: "d-M-yyyy" }, 98: "fy", "fy-NL": { c: "€", d: "d-M-yyyy" }, 1122: "fy-NL", "ga": { c: "€", d: "dd/MM/yyyy" }, 60: "ga", "ga-IE": { c: "€", d: "dd/MM/yyyy" }, 2108: "ga-IE", "gd": { c: "£", d: "dd/MM/yyyy" }, 145: "gd", "gd-GB": { c: "£", d: "dd/MM/yyyy" }, 1169: "gd-GB", "gl": { c: "€", d: "dd/MM/yyyy" }, 86: "gl", "gl-ES": { c: "€", d: "dd/MM/yyyy" }, 1110: "gl-ES", "gn": { c: "₲", d: "dd/MM/yyyy" }, 116: "gn", "gn-PY": { c: "₲", d: "dd/MM/yyyy" }, 1140: "gn-PY", "gsw": { c: "€", d: "dd/MM/yyyy" }, 132: "gsw", "gsw-FR": { c: "€", d: "dd/MM/yyyy" }, 1156: "gsw-FR", "gu": { c: "₹", d: "dd-MM-yy", n: "૦૧૨૩૪૫૬૭૮૯" }, 71: "gu", "gu-IN": { c: "₹", d: "dd-MM-yy", n: "૦૧૨૩૪૫૬૭૮૯" }, 1095: "gu-IN", "ha": { c: "₦", d: "d/M/yyyy" }, 104: "ha", "ha-Latn": { c: "₦", d: "d/M/yyyy" }, 31848: "ha-Latn", "ha-Latn-NG": { c: "₦", d: "d/M/yyyy" }, 1128: "ha-Latn-NG", "haw": { c: "$", d: "M/d/yyyy" }, 117: "haw", "haw-US": { c: "$", d: "M/d/yyyy" }, 1141: "haw-US", "he": { c: "₪", d: "dd/MM/yyyy" }, 13: "he", "he-IL": { c: "₪", d: "dd/MM/yyyy" }, 1037: "he-IL", "hi": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 57: "hi", "hi-IN": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 1081: "hi-IN", "hr": { c: "kn", d: "d.M.yyyy." }, 26: "hr", "hr-BA": { c: "KM", d: "d.M.yyyy." }, 4122: "hr-BA", "hr-HR": { c: "kn", d: "d.M.yyyy." }, 1050: "hr-HR", "hsb": { c: "€", d: "d. M. yyyy" }, 46: "hsb", "hsb-DE": { c: "€", d: "d. M. yyyy" }, 1070: "hsb-DE", "hu": { c: "Ft", d: "yyyy.MM.dd." }, 14: "hu", "hu-HU": { c: "Ft", d: "yyyy.MM.dd." }, 1038: "hu-HU", "hy": { c: "֏", d: "dd.MM.yyyy" }, 43: "hy", "hy-AM": { c: "֏", d: "dd.MM.yyyy" }, 1067: "hy-AM", "id": { c: "Rp", d: "dd/MM/yyyy" }, 33: "id", "id-ID": { c: "Rp", d: "dd/MM/yyyy" }, 1057: "id-ID", "ig": { c: "₦", d: "d/M/yyyy" }, 112: "ig", "ig-NG": { c: "₦", d: "d/M/yyyy" }, 1136: "ig-NG", "ii": { c: "¥", d: "yyyy/M/d" }, 120: "ii", "ii-CN": { c: "¥", d: "yyyy/M/d" }, 1144: "ii-CN", "is": { c: "kr.", d: "d.M.yyyy" }, 15: "is", "is-IS": { c: "kr.", d: "d.M.yyyy" }, 1039: "is-IS", "it": { c: "€", d: "dd/MM/yyyy" }, 16: "it", "it-CH": { c: "fr.", d: "dd.MM.yyyy" }, 2064: "it-CH", "it-IT": { c: "€", d: "dd/MM/yyyy" }, 1040: "it-IT", "iu": { c: "$", d: "d/MM/yyyy" }, 93: "iu", "iu-Cans": { c: "$", d: "d/M/yyyy" }, 30813: "iu-Cans", "iu-Cans-CA": { c: "$", d: "d/M/yyyy" }, 1117: "iu-Cans-CA", "iu-Latn": { c: "$", d: "d/MM/yyyy" }, 31837: "iu-Latn", "iu-Latn-CA": { c: "$", d: "d/MM/yyyy" }, 2141: "iu-Latn-CA", "ja": { c: "¥", d: "yyyy/MM/dd" }, 17: "ja", "ja-JP": { c: "¥", d: "yyyy/MM/dd" }, 1041: "ja-JP", "jv": { c: "Rp", d: "dd/MM/yyyy" }, 4096: "jv", "jv-Latn": { c: "Rp", d: "dd/MM/yyyy" }, "jv-Latn-ID": { c: "Rp", d: "dd/MM/yyyy" }, "ka": { c: "ლ.", d: "dd.MM.yyyy" }, 55: "ka", "ka-GE": { c: "ლ.", d: "dd.MM.yyyy" }, 1079: "ka-GE", "kk": { c: "₸", d: "d-MMM-yy" }, 63: "kk", "kk-KZ": { c: "₸", d: "d-MMM-yy" }, 1087: "kk-KZ", "kl": { c: "kr.", d: "dd-MM-yyyy" }, 111: "kl", "kl-GL": { c: "kr.", d: "dd-MM-yyyy" }, 1135: "kl-GL", "km": { c: "៛", d: "dd/MM/yy", n: "០១២៣៤៥៦៧៨៩" }, 83: "km", "km-KH": { c: "៛", d: "dd/MM/yy", n: "០១២៣៤៥៦៧៨៩" }, 1107: "km-KH", "kn": { c: "₹", d: "dd-MM-yy", n: "೦೧೨೩೪೫೬೭೮೯" }, 75: "kn", "kn-IN": { c: "₹", d: "dd-MM-yy", n: "೦೧೨೩೪೫೬೭೮೯" }, 1099: "kn-IN", "ko": { c: "₩", d: "yyyy-MM-dd" }, 18: "ko", "kok": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 87: "kok", "kok-IN": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 1111: "kok-IN", "ko-KR": { c: "₩", d: "yyyy-MM-dd" }, 1042: "ko-KR", "ku": { c: "د.ع.‏", d: "yyyy/MM/dd", n: "٠١٢٣٤٥٦٧٨٩" }, 146: "ku", "ku-Arab": { c: "د.ع.‏", d: "yyyy/MM/dd", n: "٠١٢٣٤٥٦٧٨٩" }, 31890: "ku-Arab", "ku-Arab-IQ": { c: "د.ع.‏", d: "yyyy/MM/dd", n: "٠١٢٣٤٥٦٧٨٩" }, 1170: "ku-Arab-IQ", "ky": { c: "сом", d: "d-MMM yy" }, 64: "ky", "ky-KG": { c: "сом", d: "d-MMM yy" }, 1088: "ky-KG", "lb": { c: "€", d: "dd.MM.yy" }, 110: "lb", "lb-LU": { c: "€", d: "dd.MM.yy" }, 1134: "lb-LU", "lo": { c: "₭", d: "dd/MM/yyyy", n: "໐໑໒໓໔໕໖໗໘໙" }, 84: "lo", "lo-LA": { c: "₭", d: "dd/MM/yyyy", n: "໐໑໒໓໔໕໖໗໘໙" }, 1108: "lo-LA", "lt": { c: "Lt", d: "yyyy-MM-dd" }, 39: "lt", "lt-LT": { c: "Lt", d: "yyyy-MM-dd" }, 1063: "lt-LT", "lv": { c: "€", d: "dd.MM.yyyy." }, 38: "lv", "lv-LV": { c: "€", d: "dd.MM.yyyy." }, 1062: "lv-LV", "mg": { c: "Ar", d: "d/M/yyyy" }, "mg-MG": { c: "Ar", d: "d/M/yyyy" }, "mi": { c: "$", d: "dd/MM/yyyy" }, 129: "mi", "mi-NZ": { c: "$", d: "dd/MM/yyyy" }, 1153: "mi-NZ", "mk": { c: "ден.", d: "dd.MM.yyyy" }, 47: "mk", "mk-MK": { c: "ден.", d: "dd.MM.yyyy" }, 1071: "mk-MK", "ml": { c: "₹", d: "dd-MM-yy", n: "൦൧൨൩൪൫൬൭൮൯" }, 76: "ml", "ml-IN": { c: "₹", d: "dd-MM-yy", n: "൦൧൨൩൪൫൬൭൮൯" }, 1100: "ml-IN", "mn": { c: "₮", d: "yyyy-MM-dd" }, 80: "mn", "mn-Cyrl": { c: "₮", d: "yyyy-MM-dd" }, 30800: "mn-Cyrl", "mn-MN": { c: "₮", d: "yyyy-MM-dd" }, 1104: "mn-MN", "mn-Mong": { c: "¥", d: "yyyy/M/d" }, 31824: "mn-Mong", "mn-Mong-CN": { c: "¥", d: "yyyy/M/d" }, 2128: "mn-Mong-CN", "mn-Mong-MN": { c: "₮", d: "yyyy/M/d" }, 3152: "mn-Mong-MN", "moh": { c: "$", d: "M/d/yyyy" }, 124: "moh", "moh-CA": { c: "$", d: "M/d/yyyy" }, 1148: "moh-CA", "mr": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 78: "mr", "mr-IN": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 1102: "mr-IN", "ms": { c: "RM", d: "dd/MM/yyyy" }, 62: "ms", "ms-BN": { c: "$", d: "dd/MM/yyyy" }, 2110: "ms-BN", "ms-MY": { c: "RM", d: "dd/MM/yyyy" }, 1086: "ms-MY", "mt": { c: "€", d: "dd/MM/yyyy" }, 58: "mt", "mt-MT": { c: "€", d: "dd/MM/yyyy" }, 1082: "mt-MT", "my": { c: "K", d: "dd-MM-yyyy", n: "၀၁၂၃၄၅၆၇၈၉" }, 85: "my", "my-MM": { c: "K", d: "dd-MM-yyyy", n: "၀၁၂၃၄၅၆၇၈၉" }, 1109: "my-MM", "nb": { c: "kr", d: "dd.MM.yyyy" }, 31764: "nb", "nb-NO": { c: "kr", d: "dd.MM.yyyy" }, 1044: "nb-NO", "ne": { c: "रु", d: "M/d/yyyy", n: "०१२३४५६७८९" }, 97: "ne", "ne-IN": { c: "₹", d: "yyyy-MM-dd", n: "०१२३४५६७८९" }, 2145: "ne-IN", "ne-NP": { c: "रु", d: "M/d/yyyy", n: "०१२३४५६७८९" }, 1121: "ne-NP", "nl": { c: "€", d: "d-M-yyyy" }, 19: "nl", "nl-BE": { c: "€", d: "d/MM/yyyy" }, 2067: "nl-BE", "nl-NL": { c: "€", d: "d-M-yyyy" }, 1043: "nl-NL", "nn": { c: "kr", d: "dd.MM.yyyy" }, 30740: "nn", "nn-NO": { c: "kr", d: "dd.MM.yyyy" }, 2068: "nn-NO", "no": { c: "kr", d: "dd.MM.yyyy" }, 20: "no", "nqo": { c: "ߖߕ.", d: "dd/MM/yyyy", n: "߀߁߂߃߄߅߆߇߈߉" }, "nqo-GN": { c: "ߖߕ.", d: "dd/MM/yyyy", n: "߀߁߂߃߄߅߆߇߈߉" }, "nso": { c: "R", d: "dd/MM/yy" }, 108: "nso", "nso-ZA": { c: "R", d: "dd/MM/yy" }, 1132: "nso-ZA", "oc": { c: "€", d: "dd/MM/yyyy" }, 130: "oc", "oc-FR": { c: "€", d: "dd/MM/yyyy" }, 1154: "oc-FR", "om": { c: "Br", d: "dd/MM/yy" }, 114: "om", "om-ET": { c: "Br", d: "dd/MM/yy" }, 1138: "om-ET", "or": { c: "₹", d: "dd-MM-yy", n: "୦୧୨୩୪୫୬୭୮୯" }, 72: "or", "or-IN": { c: "₹", d: "dd-MM-yy", n: "୦୧୨୩୪୫୬୭୮୯" }, 1096: "or-IN", "pa": { c: "₹", d: "dd-MM-yy", n: "੦੧੨੩੪੫੬੭੮੯" }, 70: "pa", "pa-Arab": { c: "Rs", d: "dd-MM-yy", n: "۰۱۲۳۴۵۶۷۸۹" }, 31814: "pa-Arab", "pa-Arab-PK": { c: "Rs", d: "dd-MM-yy", n: "۰۱۲۳۴۵۶۷۸۹" }, 2118: "pa-Arab-PK", "pa-IN": { c: "₹", d: "dd-MM-yy", n: "੦੧੨੩੪੫੬੭੮੯" }, 1094: "pa-IN", "pl": { c: "zł", d: "yyyy-MM-dd" }, 21: "pl", "pl-PL": { c: "zł", d: "yyyy-MM-dd" }, 1045: "pl-PL", "prs": { c: "؋", d: "yyyy/M/d", n: "٠١٢٣٤٥٦٧٨٩" }, 140: "prs", "prs-AF": { c: "؋", d: "yyyy/M/d", n: "٠١٢٣٤٥٦٧٨٩" }, 1164: "prs-AF", "ps": { c: "؋", d: "yyyy/M/d", n: "٠١٢٣٤٥٦٧٨٩" }, 99: "ps", "ps-AF": { c: "؋", d: "yyyy/M/d", n: "٠١٢٣٤٥٦٧٨٩" }, 1123: "ps-AF", "pt": { c: "R$", d: "dd/MM/yyyy" }, 22: "pt", "pt-AO": { c: "Kz", d: "dd/MM/yy" }, "pt-BR": { c: "R$", d: "dd/MM/yyyy" }, 1046: "pt-BR", "pt-PT": { c: "€", d: "dd/MM/yyyy" }, 2070: "pt-PT", "qut": { c: "Q", d: "dd/MM/yyyy" }, 134: "qut", "qut-GT": { c: "Q", d: "dd/MM/yyyy" }, 1158: "qut-GT", "quz": { c: "Bs.", d: "dd/MM/yyyy" }, 107: "quz", "quz-BO": { c: "Bs.", d: "dd/MM/yyyy" }, 1131: "quz-BO", "quz-EC": { c: "$", d: "dd/MM/yyyy" }, 2155: "quz-EC", "quz-PE": { c: "S/.", d: "dd/MM/yyyy" }, 3179: "quz-PE", "rm": { c: "fr.", d: "dd-MM-yyyy" }, 23: "rm", "rm-CH": { c: "fr.", d: "dd-MM-yyyy" }, 1047: "rm-CH", "ro": { c: "lei", d: "dd.MM.yyyy" }, 24: "ro", "ro-MD": { c: "L", d: "dd.MM.yyyy" }, 2072: "ro-MD", "ro-RO": { c: "lei", d: "dd.MM.yyyy" }, 1048: "ro-RO", "ru": { c: "₽", d: "dd.MM.yyyy" }, 25: "ru", "ru-RU": { c: "₽", d: "dd.MM.yyyy" }, 1049: "ru-RU", "rw": { c: "RWF", d: "d/MM/yyyy" }, 135: "rw", "rw-RW": { c: "RWF", d: "d/MM/yyyy" }, 1159: "rw-RW", "sa": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 79: "sa", "sah": { c: "₽", d: "dd.MM.yyyy" }, 133: "sah", "sah-RU": { c: "₽", d: "dd.MM.yyyy" }, 1157: "sah-RU", "sa-IN": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 1103: "sa-IN", "sd": { c: "Rs", d: "dd/MM/yyyy", n: "۰۱۲۳۴۵۶۷۸۹" }, 89: "sd", "sd-Arab": { c: "Rs", d: "dd/MM/yyyy", n: "۰۱۲۳۴۵۶۷۸۹" }, 31833: "sd-Arab", "sd-Arab-PK": { c: "Rs", d: "dd/MM/yyyy", n: "۰۱۲۳۴۵۶۷۸۹" }, 2137: "sd-Arab-PK", "se": { c: "kr", d: "dd.MM.yyyy" }, 59: "se", "se-FI": { c: "€", d: "d.M.yyyy" }, 3131: "se-FI", "se-NO": { c: "kr", d: "dd.MM.yyyy" }, 1083: "se-NO", "se-SE": { c: "kr", d: "yyyy-MM-dd" }, 2107: "se-SE", "si": { c: "රු.", d: "yyyy-MM-dd" }, 91: "si", "si-LK": { c: "රු.", d: "yyyy-MM-dd" }, 1115: "si-LK", "sk": { c: "EUR", d: "d.M.yyyy" }, 27: "sk", "sk-SK": { c: "EUR", d: "d.M.yyyy" }, 1051: "sk-SK", "sl": { c: "€", d: "d.M.yyyy" }, 36: "sl", "sl-SI": { c: "€", d: "d.M.yyyy" }, 1060: "sl-SI", "sma": { c: "kr", d: "yyyy-MM-dd" }, 30779: "sma", "sma-NO": { c: "kr", d: "dd.MM.yyyy" }, 6203: "sma-NO", "sma-SE": { c: "kr", d: "yyyy-MM-dd" }, 7227: "sma-SE", "smj": { c: "kr", d: "yyyy-MM-dd" }, 31803: "smj", "smj-NO": { c: "kr", d: "dd.MM.yyyy" }, 4155: "smj-NO", "smj-SE": { c: "kr", d: "yyyy-MM-dd" }, 5179: "smj-SE", "smn": { c: "€", d: "d.M.yyyy" }, 28731: "smn", "smn-FI": { c: "€", d: "d.M.yyyy" }, 9275: "smn-FI", "sms": { c: "€", d: "d.M.yyyy" }, 29755: "sms", "sms-FI": { c: "€", d: "d.M.yyyy" }, 8251: "sms-FI", "sn": { c: "US$", d: "dd/MM/yyyy" }, "sn-Latn": { c: "US$", d: "dd/MM/yyyy" }, "sn-Latn-ZW": { c: "US$", d: "dd/MM/yyyy" }, "so": { c: "S", d: "dd/MM/yy" }, 119: "so", "so-SO": { c: "S", d: "dd/MM/yy" }, 1143: "so-SO", "sq": { c: "Lek", d: "d.M.yyyy" }, 28: "sq", "sq-AL": { c: "Lek", d: "d.M.yyyy" }, 1052: "sq-AL", "sr": { c: "din.", d: "d.M.yyyy." }, 31770: "sr", "sr-Cyrl": { c: "дин.", d: "d.M.yyyy." }, 27674: "sr-Cyrl", "sr-Cyrl-BA": { c: "КМ", d: "d.M.yyyy." }, 7194: "sr-Cyrl-BA", "sr-Cyrl-CS": { c: "дин.", d: "d.M.yyyy." }, 3098: "sr-Cyrl-CS", "sr-Cyrl-ME": { c: "€", d: "d.M.yyyy." }, 12314: "sr-Cyrl-ME", "sr-Cyrl-RS": { c: "дин.", d: "d.M.yyyy." }, 10266: "sr-Cyrl-RS", "sr-Latn": { c: "din.", d: "d.M.yyyy." }, 28698: "sr-Latn", "sr-Latn-BA": { c: "KM", d: "d.M.yyyy." }, 6170: "sr-Latn-BA", "sr-Latn-CS": { c: "din.", d: "d.M.yyyy." }, 2074: "sr-Latn-CS", "sr-Latn-ME": { c: "€", d: "d.M.yyyy." }, 11290: "sr-Latn-ME", "sr-Latn-RS": { c: "din.", d: "d.M.yyyy." }, 9242: "sr-Latn-RS", "st": { c: "R", d: "yyyy-MM-dd" }, 48: "st", "st-ZA": { c: "R", d: "yyyy-MM-dd" }, 1072: "st-ZA", "sv": { c: "kr", d: "yyyy-MM-dd" }, 29: "sv", "sv-FI": { c: "€", d: "d.M.yyyy" }, 2077: "sv-FI", "sv-SE": { c: "kr", d: "yyyy-MM-dd" }, 1053: "sv-SE", "sw": { c: "KSh", d: "M/d/yyyy" }, 65: "sw", "sw-KE": { c: "KSh", d: "M/d/yyyy" }, 1089: "sw-KE", "syr": { c: "ܠ.ܣ.‏", d: "dd/MM/yyyy" }, 90: "syr", "syr-SY": { c: "ܠ.ܣ.‏", d: "dd/MM/yyyy" }, 1114: "syr-SY", "ta": { c: "₹", d: "dd-MM-yyyy", n: "௦௧௨௩௪௫௬௭௮௯" }, 73: "ta", "ta-IN": { c: "₹", d: "dd-MM-yyyy", n: "௦௧௨௩௪௫௬௭௮௯" }, 1097: "ta-IN", "ta-LK": { c: "Rs", d: "dd-MM-yyyy", n: "௦௧௨௩௪௫௬௭௮௯" }, 2121: "ta-LK", "te": { c: "₹", d: "dd-MM-yy", n: "౦౧౨౩౪౫౬౭౮౯" }, 74: "te", "te-IN": { c: "₹", d: "dd-MM-yy", n: "౦౧౨౩౪౫౬౭౮౯" }, 1098: "te-IN", "tg": { c: "смн", d: "dd.MM.yyyy" }, 40: "tg", "tg-Cyrl": { c: "смн", d: "dd.MM.yyyy" }, 31784: "tg-Cyrl", "tg-Cyrl-TJ": { c: "смн", d: "dd.MM.yyyy" }, 1064: "tg-Cyrl-TJ", "th": { c: "฿", d: "d/M/yyyy", n: "๐๑๒๓๔๕๖๗๘๙" }, 30: "th", "th-TH": { c: "฿", d: "d/M/yyyy", n: "๐๑๒๓๔๕๖๗๘๙" }, 1054: "th-TH", "ti": { c: "ERN", d: "d/M/yyyy" }, 115: "ti", "ti-ER": { c: "ERN", d: "d/M/yyyy" }, 2163: "ti-ER", "ti-ET": { c: "ብር", d: "d/M/yyyy" }, 1139: "ti-ET", "tk": { c: "m.", d: "dd.MM.yy \"ý.\"" }, 66: "tk", "tk-TM": { c: "m.", d: "dd.MM.yy \"ý.\"" }, 1090: "tk-TM", "tn": { c: "R", d: "dd/MM/yy" }, 50: "tn", "tn-BW": { c: "P", d: "dd/MM/yy" }, 2098: "tn-BW", "tn-ZA": { c: "R", d: "dd/MM/yy" }, 1074: "tn-ZA", "tr": { c: "₺", d: "d.M.yyyy" }, 31: "tr", "tr-TR": { c: "₺", d: "d.M.yyyy" }, 1055: "tr-TR", "ts": { c: "R", d: "yyyy-MM-dd" }, 49: "ts", "ts-ZA": { c: "R", d: "yyyy-MM-dd" }, 1073: "ts-ZA", "tt": { c: "₽", d: "dd.MM.yyyy" }, 68: "tt", "tt-RU": { c: "₽", d: "dd.MM.yyyy" }, 1092: "tt-RU", "tzm": { c: "DA", d: "dd-MM-yyyy" }, 95: "tzm", "tzm-Latn": { c: "DA", d: "dd-MM-yyyy" }, 31839: "tzm-Latn", "tzm-Latn-DZ": { c: "DA", d: "dd-MM-yyyy" }, 2143: "tzm-Latn-DZ", "tzm-Tfng": { c: "ⴷⵔ", d: "dd-MM-yyyy" }, 30815: "tzm-Tfng", "tzm-Tfng-MA": { c: "ⴷⵔ", d: "dd-MM-yyyy" }, 4191: "tzm-Tfng-MA", "ug": { c: "¥", d: "yyyy-M-d" }, 128: "ug", "ug-CN": { c: "¥", d: "yyyy-M-d" }, 1152: "ug-CN", "uk": { c: "₴", d: "dd.MM.yyyy" }, 34: "uk", "uk-UA": { c: "₴", d: "dd.MM.yyyy" }, 1058: "uk-UA", "ur": { c: "Rs", d: "dd/MM/yyyy", n: "۰۱۲۳۴۵۶۷۸۹" }, 32: "ur", "ur-IN": { c: "₹", d: "d/M/yy", n: "۰۱۲۳۴۵۶۷۸۹" }, 2080: "ur-IN", "ur-PK": { c: "Rs", d: "dd/MM/yyyy", n: "۰۱۲۳۴۵۶۷۸۹" }, 1056: "ur-PK", "uz": { c: "so\"m", d: "dd.MM.yyyy" }, 67: "uz", "uz-Cyrl": { c: "сўм", d: "dd.MM.yyyy" }, 30787: "uz-Cyrl", "uz-Cyrl-UZ": { c: "сўм", d: "dd.MM.yyyy" }, 2115: "uz-Cyrl-UZ", "uz-Latn": { c: "so\"m", d: "dd.MM.yyyy" }, 31811: "uz-Latn", "uz-Latn-UZ": { c: "so\"m", d: "dd.MM.yyyy" }, 1091: "uz-Latn-UZ", "vi": { c: "₫", d: "dd/MM/yyyy" }, 42: "vi", "vi-VN": { c: "₫", d: "dd/MM/yyyy" }, 1066: "vi-VN", "wo": { c: "CFA", d: "dd/MM/yyyy" }, 136: "wo", "wo-SN": { c: "CFA", d: "dd/MM/yyyy" }, 1160: "wo-SN", "xh": { c: "R", d: "yyyy/MM/dd" }, 52: "xh", "xh-ZA": { c: "R", d: "yyyy/MM/dd" }, 1076: "xh-ZA", "yo": { c: "₦", d: "d/M/yyyy" }, 106: "yo", "yo-NG": { c: "₦", d: "d/M/yyyy" }, 1130: "yo-NG", "zgh": { c: "ⴷⵔⵎ", d: "dd-MM-yyyy" }, "zgh-Tfng": { c: "ⴷⵔⵎ", d: "dd-MM-yyyy" }, "zgh-Tfng-MA": { c: "ⴷⵔⵎ", d: "dd-MM-yyyy" }, "zh": { c: "¥", d: "yyyy/M/d" }, 30724: "zh", "zh-CHS": { c: "¥", d: "yyyy/M/d" }, 4: "zh-CHS", "zh-CHT": { c: "HK$", d: "d/M/yyyy" }, 31748: "zh-CHT", "zh-CN": { c: "¥", d: "yyyy/M/d" }, 2052: "zh-CN", "zh-Hans": { c: "¥", d: "yyyy/M/d" }, "zh-Hant": { c: "HK$", d: "d/M/yyyy" }, "zh-HK": { c: "HK$", d: "d/M/yyyy" }, 3076: "zh-HK", "zh-MO": { c: "MOP", d: "d/M/yyyy" }, 5124: "zh-MO", "zh-SG": { c: "$", d: "d/M/yyyy" }, 4100: "zh-SG", "zh-TW": { c: "NT$", d: "yyyy/M/d" }, 1028: "zh-TW", "zu": { c: "R", d: "dd-MM-yyyy" }, 53: "zu", "zu-ZA": { c: "R", d: "dd-MM-yyyy" }, 1077: "zu-ZA" };
let CultureInfo = /*@__PURE__*/ (() => {
    class CultureInfo extends Base {
        constructor(name) {
            super();
            this._name = null;
            this._isInvariant = false;
            this._dateTimeFormat = null;
            this._numberFormat = null;
            this._name = name;
        }
        clone() {
            var copy = new CultureInfo(this._name);
            for (var attr in this) {
                if (this.hasOwnProperty(attr)) {
                    copy[attr] = this[attr];
                }
            }
            if (this._dateTimeFormat) {
                copy._dateTimeFormat = this._dateTimeFormat.clone();
            }
            if (this._numberFormat) {
                copy._numberFormat = this._numberFormat.clone();
            }
            return copy;
        }
        get compareInfo() {
            // TODO:
            return new CompareInfo();
        }
        getFormat($t) {
            if ($t === NumberFormatInfo.prototype.$type) {
                return this.numberFormat;
            }
            if ($t === DateTimeFormat.prototype.$type) {
                return this.dateTimeFormat;
            }
            throw new Error("Unknown format type");
        }
        get name() {
            return this._name;
        }
        get calendar() {
            // TODO
            return new Calendar();
        }
        get dateTimeFormat() {
            if (!this._dateTimeFormat) {
                this._dateTimeFormat = new DateTimeFormat(this._name, this._isInvariant);
            }
            return this._dateTimeFormat;
        }
        set dateTimeFormat(value) {
            this._dateTimeFormat = value;
        }
        get numberFormat() {
            if (!this._numberFormat) {
                this._numberFormat = new NumberFormatInfo(this._name, this._isInvariant);
            }
            return this._numberFormat;
        }
        set numberFormat(value) {
            this._numberFormat = value;
        }
        get twoLetterISOLanguageName() {
            if (this._name.length > 2 && this._name[2] == "-") {
                return this._name.substr(0, 2);
            }
            // TODO
            return "";
        }
        static getCultureInfo(lcid) {
            var name = globalInfo[lcid];
            if (name) {
                if (name === "invariant") {
                    return CultureInfo.invariantCulture;
                }
                return new CultureInfo(name);
            }
            // TODO: throw error here?
            return CultureInfo.invariantCulture;
        }
        static get currentCulture() {
            return Thread.currentThread.currentCulture;
        }
        static get invariantCulture() {
            if (this._cachedInvariant) {
                return this._cachedInvariant;
            }
            // TODO: Make a true invariant culture
            /*jshint -W093 */
            this._cachedInvariant = new CultureInfo("en-US");
            this._cachedInvariant._isInvariant = true;
            return this._cachedInvariant;
        }
    }
    CultureInfo._cachedInvariant = null;
    CultureInfo.$t = /*@__PURE__*/ markType(CultureInfo, "CultureInfo");
    return CultureInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function ieeeRemainder(a, b) {
    var r = Math.abs(a % b);
    if (isNaN(r) || r == b || r <= Math.abs(b) / 2.0) {
        return r;
    }
    else {
        return Math.sign(a) * (r - b);
    }
}
;
function numberToString1(value, provider) {
    return value.toLocaleString(provider.name, { useGrouping: false }); // TODO: Figure out how to use the provider correctly here
}
function tryParseNumber1(s, style, provider, v) {
    // TODO: had to change the provider from CultureInfo to any but that's not ideal. see what we should do here
    var value, i, currentCharCode;
    provider = provider || CultureInfo.currentCulture;
    /*jslint bitwise: true */
    if ((style & 1 /* NumberStyles.AllowLeadingWhite */) !== 0) {
        var index = 0;
        while (index < s.length && s[index] === ' ') {
            index++;
        }
        s = s.substring(index);
    }
    if ((style & 2 /* NumberStyles.AllowTrailingWhite */) !== 0) {
        var index = s.length - 1;
        while (index >= 0 && s[index] === ' ') {
            index--;
        }
        s = s.substring(0, index + 1);
    }
    if (s.length != s.trim().length) {
        return {
            p3: 0,
            ret: false
        };
    }
    var numberFormat = provider.numberFormat;
    if (style & 256 /* NumberStyles.AllowCurrencySymbol */) {
        // TODO: Use the locale specific symbol from the provider here
        if (s[0] == "$") {
            s = s.slice(1);
        }
    }
    var multiplier = 1;
    var hadParentheses = false;
    if (style & 16 /* NumberStyles.AllowParentheses */) {
        if (s[0] == "(" && s[s.length - 1] == ")") {
            hadParentheses = true;
            multiplier *= -1;
            s = s.slice(1, -1);
        }
    }
    if (style & 256 /* NumberStyles.AllowCurrencySymbol */) {
        // TODO: Use the locale specific symbol from the provider here
        if (s[0] == "$") {
            s = s.slice(1);
        }
    }
    if (style & 4 /* NumberStyles.AllowLeadingSign */) {
        var positiveSign = numberFormat.positiveSign;
        var negativeSign = numberFormat.negativeSign;
        if (s[0] == positiveSign || s[0] == negativeSign) {
            if (hadParentheses) {
                return {
                    p3: 0,
                    ret: false
                };
            }
            if (s[0] == negativeSign) {
                multiplier *= -1;
            }
            s = s.slice(1);
        }
    }
    if (style & 8 /* NumberStyles.AllowTrailingSign */) {
        // TODO
    }
    if (style & 32 /* NumberStyles.AllowDecimalPoint */) {
        if (style & 128 /* NumberStyles.AllowExponent */) {
            // TODO
        }
        if (style & 64 /* NumberStyles.AllowThousands */) {
            var decimalSeparator = numberFormat.numberDecimalSeparator;
            var groupSeparator = numberFormat.numberGroupSeparator;
            var hitDecimalSeparator = false;
            for (i = 0; i < s.length; i++) {
                switch (s[i]) {
                    case groupSeparator:
                        if (hitDecimalSeparator) {
                            return {
                                p3: 0,
                                ret: false
                            };
                        }
                        s = s.slice(0, i) + s.slice(i + 1);
                        i--;
                        break;
                    case decimalSeparator:
                        hitDecimalSeparator = true;
                        if (decimalSeparator != ".") {
                            s = s.slice(0, i) + "." + s.slice(i + 1);
                        }
                        break;
                }
            }
        }
        value = Number(s);
        if (value !== null && isFinite(value) && s.trim().length !== 0) {
            return {
                p3: value * multiplier,
                ret: true
            };
        }
    }
    else {
        var zeroCharCode = "0".charCodeAt(0);
        var nineCharCode = "9".charCodeAt(0);
        value = 0;
        if (style & 512 /* NumberStyles.AllowHexSpecifier */) {
            var aCharCode = "a".charCodeAt(0);
            var fCharCode = "f".charCodeAt(0);
            var ACharCode = "A".charCodeAt(0);
            var FCharCode = "F".charCodeAt(0);
            for (i = 0; i < s.length; i++) {
                value *= 16;
                currentCharCode = s[i].charCodeAt(0);
                if (zeroCharCode <= currentCharCode && currentCharCode <= nineCharCode) {
                    value += (currentCharCode - zeroCharCode);
                }
                else if (aCharCode <= currentCharCode && currentCharCode <= fCharCode) {
                    value += (currentCharCode - aCharCode) + 10;
                }
                else if (ACharCode <= currentCharCode && currentCharCode <= FCharCode) {
                    value += (currentCharCode - ACharCode) + 10;
                }
                else {
                    return {
                        p3: 0,
                        ret: false
                    };
                }
            }
        }
        else {
            for (i = 0; i < s.length; i++) {
                value *= 10;
                currentCharCode = s[i].charCodeAt(0);
                if (zeroCharCode <= currentCharCode && currentCharCode <= nineCharCode) {
                    value += (currentCharCode - zeroCharCode);
                }
                else {
                    return {
                        p3: 0,
                        ret: false
                    };
                }
            }
        }
        return {
            p3: value * multiplier,
            ret: true
        };
    }
    return {
        p3: 0,
        ret: false
    };
}
function parseNumber(s, provider) {
    return parseNumber1(s, 231, provider);
}
function parseNumber1(s, style, provider) {
    var r = tryParseNumber1(s, style, provider);
    if (!r.ret) {
        throw new FormatException(1, "Incorrect number format");
    }
    return r.p3;
}
function parseInt8_1(s, provider) {
    return parseIntCore(s, provider, -128, 127);
}
;
function parseInt8_2(s, style, provider) {
    return parseIntCore(s, provider, -128, 127, style);
}
;
function parseInt16_1(s, provider) {
    return parseIntCore(s, provider, -32768, 32767);
}
;
function parseInt16_2(s, style, provider) {
    return parseIntCore(s, provider, -32768, 32767, style);
}
;
function parseInt32_1(s, provider) {
    return parseIntCore(s, provider, -2147483648, 2147483647);
}
;
function parseInt32_2(s, style, provider) {
    return parseIntCore(s, provider, -2147483648, 2147483647, style);
}
;
function parseInt64_1(s, provider) {
    return parseIntCore(s, provider, -9223372036854775808, 9223372036854775807);
}
;
function parseInt64_2(s, style, provider) {
    return parseIntCore(s, provider, -9223372036854775808, 9223372036854775807, style);
}
;
function parseUInt8_1(s, provider) {
    return parseIntCore(s, provider, 0, 255);
}
;
function parseUInt8_2(s, style, provider) {
    return parseIntCore(s, provider, 0, 255, style);
}
;
function parseUInt16_1(s, provider) {
    return parseIntCore(s, provider, 0, 65535);
}
;
function parseUInt16_2(s, style, provider) {
    return parseIntCore(s, provider, 0, 65535, style);
}
;
function parseUInt32_1(s, provider) {
    return parseIntCore(s, provider, 0, 4294967295);
}
;
function parseUInt32_2(s, style, provider) {
    return parseIntCore(s, provider, 0, 4294967295, style);
}
;
function parseUInt64_1(s, provider) {
    return parseIntCore(s, provider, 0, 18446744073709551615);
}
;
function parseUInt64_2(s, style, provider) {
    return parseIntCore(s, provider, 0, 18446744073709551615, style);
}
;
function parseIntCore(s, provider, min, max, style = 7 /* NumberStyles.Integer */) {
    var r = tryParseIntCore(s, provider, min, max, style);
    if (!r.ret) {
        throw new FormatException(1, "Incorrect number format");
    }
    return r.p3;
}
;
function tryParseInt8_1(s, value) {
    return tryParseIntCore(s, null, -128, 127);
}
;
function tryParseInt8_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, -128, 127, style);
}
;
function tryParseInt16_1(s, value) {
    return tryParseIntCore(s, null, -32768, 32767);
}
;
function tryParseInt16_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, -32768, 32767, style);
}
;
function tryParseInt32_1(s, value) {
    return tryParseIntCore(s, null, -2147483648, 2147483647);
}
;
function tryParseInt32_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, -2147483648, 2147483647, style);
}
;
function tryParseInt64_1(s, value) {
    return tryParseIntCore(s, null, -9223372036854775808, 9223372036854775807);
}
;
function tryParseInt64_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, -9223372036854775808, 9223372036854775807, style);
}
;
function tryParseUInt8_1(s, value) {
    return tryParseIntCore(s, null, 0, 255);
}
;
function tryParseUInt8_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, 0, 255, style);
}
;
function tryParseUInt16_1(s, value) {
    return tryParseIntCore(s, null, 0, 65535);
}
;
function tryParseUInt16_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, 0, 65535, style);
}
;
function tryParseUInt32_1(s, value) {
    return tryParseIntCore(s, null, 0, 4294967295);
}
;
function tryParseUInt32_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, 0, 4294967295, style);
}
;
function tryParseUInt64_1(s, value) {
    return tryParseIntCore(s, null, 0, 18446744073709551615);
}
;
function tryParseUInt64_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, 0, 18446744073709551615, style);
}
;
function tryParseIntCore(s, provider, min, max, style = 7 /* NumberStyles.Integer */) {
    /*jshint eqnull:true */
    /*jslint bitwise: true */
    //style = style != null ? style : NumberStyles.integer; // Don't use || here, because 0 could be a valid style
    provider = provider || CultureInfo.currentCulture;
    var r = tryParseNumber1(s, style, provider);
    if ((style & 512 /* NumberStyles.AllowHexSpecifier */) && max < r.p3) {
        r.p3 -= (-min * 2);
    }
    if (!r.ret || r.p3 < min || max < r.p3 || r.p3 % 1 !== 0) {
        return {
            p1: 0,
            p3: 0,
            ret: false
        };
    }
    let ret = {
        p1: r.p3,
        p3: r.p3,
        ret: r.ret
    };
    return ret;
}
function numberToString(number, provider) {
    return numberToString2(number, "G", provider);
}
;
let gFormatOptions = { useGrouping: false, maximumSignificantDigits: 15 };
let zeroFormatOptions = {
    useGrouping: false,
    maximumSignificantDigits: 15,
    maximumFractionDigits: 0
};
function numberToString2(number, format, provider) {
    // TODO: had to change the provider from CultureInfo to any but that's not ideal. see what we should do here
    provider = provider || CultureInfo.currentCulture;
    switch (format) {
        case "G":
            return number.toLocaleString(provider.name, gFormatOptions);
        case "R":
        case "r":
            return number.toString()
                .replace(".", provider.numberFormat.numberDecimalSeparator);
    }
    if (format.match(/[0\#\.]+/)) {
        var isValid = true;
        var formatIndexOfDecimalSeparator = format.indexOf(".");
        var decimalFormat = formatIndexOfDecimalSeparator == -1 ? "" :
            format.substring(formatIndexOfDecimalSeparator + 1);
        var numberString = number.toFixed(decimalFormat.length).toString();
        var numberIndexOfDecimalSeparator = numberString.indexOf(".");
        var integralPart = numberIndexOfDecimalSeparator == -1 ? numberString :
            numberString.substring(0, numberIndexOfDecimalSeparator);
        var integralFormat = formatIndexOfDecimalSeparator == -1 ? format :
            format.substring(0, formatIndexOfDecimalSeparator);
        while (integralFormat.length < integralPart.length) {
            integralFormat = "0" + integralFormat;
        }
        while (integralPart.length < integralFormat.length) {
            integralPart = "0" + integralPart;
        }
        var formattedIntegralPart = "";
        var digit;
        for (var ii = integralFormat.length - 1; ii >= 0; ii--) {
            if (integralFormat[ii] == "0") {
                formattedIntegralPart = integralPart[ii] + formattedIntegralPart;
            }
            else if (integralFormat[ii] == "#") {
                digit = integralPart.substring(0, ii + 1).match(/[1-9]/) ?
                    integralPart[ii] : "";
                formattedIntegralPart = digit + formattedIntegralPart;
            }
            else {
                isValid = false;
            }
        }
        var decimalPart = numberIndexOfDecimalSeparator == -1 ? "" :
            numberString.substring(numberIndexOfDecimalSeparator + 1);
        var formattedDecimalPart = "";
        for (var jj = 0; jj < decimalFormat.length; jj++) {
            if (decimalFormat[jj] == "0") {
                formattedDecimalPart += decimalPart[jj];
            }
            else if (decimalFormat[jj] == "#") {
                digit = decimalPart.length > jj && (decimalPart[jj] != "0" || decimalPart.substring(jj).match(/[1-9]/)) ?
                    decimalPart[jj] : "";
                formattedDecimalPart += digit;
            }
            else {
                isValid = false;
            }
        }
        if (isValid) {
            return formattedIntegralPart +
                (formattedDecimalPart.length > 0 ? "." + formattedDecimalPart : "");
        }
    }
    throw new FormatException(1, "Unsupported format code: " + format);
}
function intToString(number, provider) {
    return intToString1(number, "G", provider);
}
;
function intToString1(number, format, provider) {
    provider = provider || CultureInfo.currentCulture;
    if (format && format.length) {
        if (format[0] == "X") {
            number = intSToU(number);
            var result = number.toString(16).toUpperCase();
            if (format.length !== 1) {
                var digits = +format.substr(1);
                if (!isFinite(digits)) {
                    throw new Error("Unsupported format code: " + format);
                }
                while (result.length < digits) {
                    result = "0" + result;
                }
            }
            return result;
        }
    }
    switch (format) {
        case "G":
            return number.toLocaleString(provider.name, gFormatOptions);
    }
    throw new Error("Unsupported format code: " + format);
}
function intSToU(number) {
    if (number < 0) {
        number = number + 1 + 0xFFFFFFFF;
    }
    return number;
}
function u32BitwiseAnd(a, b) {
    var r = a & b;
    if (r < 0) {
        r += 4294967296;
    }
    return r;
}
function u32BitwiseOr(a, b) {
    var r = a | b;
    if (r < 0) {
        r += 4294967296;
    }
    return r;
}
function u32BitwiseXor(a, b) {
    var r = a ^ b;
    if (r < 0) {
        r += 4294967296;
    }
    return r;
}
function u32LS(a, b) {
    var r = a << b;
    if (r < 0) {
        r += 4294967296;
    }
    return r;
}
function decimalAdjust(type, value, exp) {
    // If the exp is undefined or zero...
    if (typeof exp === "undefined" || +exp === 0) {
        return Math[type](value);
    }
    value = +value;
    exp = +exp;
    // If the value is not a number or the exp is not an integer...
    if (isNaN(value) || !(typeof exp === "number" && exp % 1 === 0)) {
        return NaN;
    }
    // Shift
    value = value.toString().split("e");
    value = Math[type](+(value[0] + "e" + (value[1] ? (+value[1] - exp) : -exp)));
    // Shift back
    value = value.toString().split("e");
    return +(value[0] + "e" + (value[1] ? (+value[1] + exp) : exp));
}
function round10(value, exp) {
    return decimalAdjust("round", value, exp);
}
function round10N(value, exp) {
    return decimalAdjust("round", value, -exp);
}
function floor10(value, exp) {
    return decimalAdjust("floor", value, exp);
}
function ceil10(value, exp) {
    return decimalAdjust("ceil", value, exp);
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockDetails = /*@__PURE__*/ (() => {
    class StockDetails extends StockInfo {
        constructor() {
            super(...arguments);
            this._annualLow = 0;
            this._annualHigh = 0;
            this._marketPrice = 0;
            this._marketShares = 0;
            this._volatility = 0;
        }
        get annualLow() {
            return this._annualLow;
        }
        set annualLow(a) {
            this._annualLow = a;
        }
        get annualHigh() {
            return this._annualHigh;
        }
        set annualHigh(a) {
            this._annualHigh = a;
        }
        get marketPrice() {
            return this._marketPrice;
        }
        set marketPrice(a) {
            this._marketPrice = a;
        }
        get marketShares() {
            return this._marketShares;
        }
        set marketShares(a) {
            this._marketShares = a;
        }
        get marketCap() {
            return round10N(this.marketPrice * this.marketShares / 1000, 1);
        }
        get volatility() {
            return this._volatility;
        }
        set volatility(a) {
            this._volatility = a;
        }
    }
    StockDetails.$t = /*@__PURE__*/ markType(StockDetails, 'StockDetails', StockInfo.$);
    return StockDetails;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function timeSpanInit1(h, m, s) {
    return (h * 3600000) + (m * 60000) + (s * 1000);
}
;
function timeSpanInit2(d, h, m, s, ms) {
    return (d * 86400000) + (h * 3600000) + (m * 60000) + (s * 1000) + ms;
}
;
function timeSpanInit3(d, h, m, s) {
    return (d * 86400000) + (h * 3600000) + (m * 60000) + (s * 1000);
}
;
function timeSpanTotalDays(t) { return t / 86400000; }
;
function timeSpanTotalHours(t) { return t / 3600000; }
;
function timeSpanTotalMilliseconds(t) { return t; }
;
function timeSpanTotalMinutes(t) { return t / 60000; }
;
function timeSpanTotalSeconds(t) { return t / 1000; }
;
function timeSpanFromDays(v) { return v * 86400000; }
;
function timeSpanFromHours(v) { return v * 3600000; }
;
function timeSpanFromMilliseconds(v) { return v; }
;
function timeSpanFromMinutes(v) { return v * 60000; }
;
function timeSpanFromSeconds(v) { return v * 1000; }
;
function timeSpanFromTicks(v) { return v / 10000; }
;
function timeSpanDays(t) { return truncate(t / 86400000); }
;
function timeSpanHours(t) { return truncate((t / 3600000) % 24); }
;
function timeSpanMilliseconds(t) { return t % 1000; }
;
function timeSpanMinutes(t) { return truncate((t / 60000) % 60); }
;
function timeSpanSeconds(t) { return truncate((t / 1000) % 60); }
;
function timeSpanTicks(t) { return truncate(t * 10000); }
;
function timeSpanNegate(t) { return -t; }
;

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockDataGenerator = /*@__PURE__*/ (() => {
    class StockDataGenerator extends Base {
        constructor() {
            super();
            this._priceStart = 0;
            this._priceRange = 0;
            this._priceMinimum = 0;
            this._priceMaximum = 0;
            this._volumeStart = 0;
            this._volumeRange = 0;
            this._dateRange = 0;
            this._dateInterval = 0;
            this._stockInterval = 0;
            this._skipAfterHours = false;
            this.g = new Date();
            this.h = new Date();
            this.q = new Random(0);
            this.skipAfterHours = false;
            this.priceStart = 0;
            this.priceRange = NaN;
            this.priceMinimum = NaN;
            this.priceMaximum = NaN;
            this.volumeStart = 0;
            this.volumeRange = NaN;
            this.dateRange = 12;
            this.dateInterval = 24 * 60;
        }
        get priceStart() {
            return this._priceStart;
        }
        set priceStart(a) {
            this._priceStart = a;
        }
        get priceRange() {
            return this._priceRange;
        }
        set priceRange(a) {
            this._priceRange = a;
        }
        get priceMinimum() {
            return this._priceMinimum;
        }
        set priceMinimum(a) {
            this._priceMinimum = a;
        }
        get priceMaximum() {
            return this._priceMaximum;
        }
        set priceMaximum(a) {
            this._priceMaximum = a;
        }
        get volumeStart() {
            return this._volumeStart;
        }
        set volumeStart(a) {
            this._volumeStart = a;
        }
        get volumeRange() {
            return this._volumeRange;
        }
        set volumeRange(a) {
            this._volumeRange = a;
        }
        get dateRange() {
            return this._dateRange;
        }
        set dateRange(a) {
            this._dateRange = a;
        }
        get dateInterval() {
            return this._dateInterval;
        }
        set dateInterval(a) {
            this._dateInterval = a;
        }
        get stockInterval() {
            return this._stockInterval;
        }
        set stockInterval(a) {
            this._stockInterval = a;
        }
        get skipAfterHours() {
            return this._skipAfterHours;
        }
        set skipAfterHours(a) {
            this._skipAfterHours = a;
        }
        generatePosition(a, b = "") {
            let c = StockDataLookup.get(a);
            let d = (intDivide(this.q.next2(1, 10), 100));
            let e = new StockPosition();
            e.symbol = c.symbol;
            e.company = c.company;
            e.sector = c.sector;
            e.costPerShare = c.close - (c.open * d);
            e.marketPrice = c.close;
            e.tradeDate = dateNow();
            return e;
        }
        generateDetails() {
            let a = new List$1(StockDetails.$, 0);
            for (let b of fromEnum(StockDataLookup.b.values)) {
                let c = (intDivide(this.q.next2(10, 30), 100));
                let d = new StockDetails();
                d.company = b.company;
                d.symbol = b.symbol;
                d.sector = b.sector;
                d.marketPrice = b.close;
                d.marketShares = intDivide((b.volume * this.q.next2(15, 20)), 1000000);
                d.annualLow = b.close - (b.open * c);
                d.annualHigh = b.close + (b.open * c);
                a.add(d);
            }
            return a.toArray();
        }
        generateStockPrices(a, b = "") {
            let c = dateNow();
            this.g = dateFromValues(c.getFullYear(), dateGetMonth(c), c.getDate(), 16, 30, 0, 0);
            this.h = dateAddMonths(this.g, -this.dateRange);
            let d = Math.ceil(timeSpanTotalMinutes((+(this.g) - +(this.h))) / this.dateInterval);
            let e = d * this.dateInterval;
            this.s(d + " steps, " + e + " range");
            if (d > 100000) {
                d = 100000;
                e = d * this.dateInterval;
                this.s(d + "^steps, " + e + " range");
            }
            let f = dateAddMinutes(this.g, -e);
            if (this.h.getTime() > f.getTime()) {
                this.h = f;
            }
            let g = StockDataLookup.get(a);
            g.date = this.h;
            let h = g.sector;
            if (this.priceStart > 0) {
                g.open = this.priceStart;
            }
            if (this.volumeStart > 0) {
                g.volume = this.volumeStart;
            }
            this.volumeRange = g.volume * 0.05;
            this.priceRange = g.open * 0.025;
            this.priceMinimum = g.open - (g.open * 0.75);
            this.priceMaximum = g.open + (g.open * 0.75);
            g.high = g.open + (g.open * 0.02);
            g.low = g.open - (g.open * 0.02);
            g.close = g.open + ((this.q.nextDouble() - 0.5) * this.priceRange);
            let i = new StockPriceHistory();
            i.symbol = a;
            if (!stringIsNullOrEmpty(b)) {
                g.company = b;
                i.company = b;
            }
            else if (!stringIsNullOrEmpty(g.company)) {
                i.company = g.company;
            }
            do {
                if (this.skipAfterHours) {
                    if (!this.e(g.date)) {
                        i.add(g);
                    }
                }
                else {
                    i.add(g);
                }
                g = this.generateStockPricePoint(g);
            } while (g.date.getTime() <= this.g.getTime());
            this.s(" " + i.count + " items");
            return i;
        }
        e(a) {
            if (a.getDay() == 6) {
                return true;
            }
            if (a.getDay() == 0) {
                return true;
            }
            let b = timeSpanInit1(9, 30, 0);
            let c = timeSpanInit1(16, 30, 0);
            let d = dateGetTimeOfDay(a);
            if (d < b || d > c) {
                return true;
            }
            return false;
        }
        generateStockPricePoint(a) {
            let b = (this.q.nextDouble() - 0.499) * this.priceRange;
            let c = a.close;
            let d = a.close + b;
            if (d < this.priceMinimum) {
                d = this.priceMinimum + b;
            }
            if (d > this.priceMaximum) {
                d = this.priceMaximum - b;
            }
            let e = (this.q.nextDouble() * 1.5 * Math.abs(b));
            let f = (this.q.nextDouble() * 1.5 * Math.abs(b));
            if (d > c) {
                e = d + e;
                f = c - f;
            }
            else {
                e = c + e;
                f = d - f;
            }
            let g = (this.q.nextDouble() - 0.49) * this.volumeRange;
            let h = truncate(Math.abs(a.volume + g));
            let i = dateAddMinutes(a.date, this.dateInterval);
            if (i.getTime() > this.g.getTime()) {
                i = this.g;
            }
            let j = ((() => {
                let $ret = new StockPricePoint();
                $ret.date = dateAddMinutes(a.date, this.dateInterval);
                $ret.symbol = a.symbol;
                $ret.company = a.company;
                $ret.sector = a.sector;
                $ret.close = round10N(d, 2);
                $ret.open = round10N(c, 2);
                $ret.high = round10N(e, 2);
                $ret.low = round10N(f, 2);
                $ret.volume = h;
                return $ret;
            })());
            return j;
        }
        s(message_) {
        }
    }
    StockDataGenerator.$t = /*@__PURE__*/ markType(StockDataGenerator, 'StockDataGenerator');
    return StockDataGenerator;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialDataAdapter = /*@__PURE__*/ (() => {
    class FinancialDataAdapter extends Base {
        get stockSymbols() {
            return this.e;
        }
        set stockSymbols(a) {
            this.a1(this.e, a);
        }
        get stockPrices() {
            return this.c;
        }
        set stockPrices(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.ap("StockPrices", b, this.c);
            }
        }
        get stockPricesMemberPaths() {
            return this.d;
        }
        get stockPositions() {
            return this.b;
        }
        set stockPositions(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
                this.ap("StockPositions", b, this.b);
            }
        }
        get stockDetails() {
            return this.a;
        }
        set stockDetails(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.ap("StockDetails", b, this.a);
            }
        }
        get ac() {
            return this.aa;
        }
        set ac(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.ap("StockPricesTimeRange", b, this.aa);
            }
        }
        get ab() {
            return this.z;
        }
        set ab(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.ap("StockPricesTimeInterval", b, this.z);
            }
        }
        get u() {
            return this.r;
        }
        set u(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.ap("StockPricesTradeAfterHours", b, this.r);
            }
        }
        ap(a, b, c) {
            this.aq(a, b, c);
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
        aq(a, b, c) {
            switch (a) {
                case "StockPricesTimeRange":
                case "StockPricesTimeInterval":
                case "StockPricesTradeAfterHours":
                    this.az();
                    break;
                case "StockSymbols":
                    this.ay(b, c);
                    break;
            }
        }
        au(a, b) {
            if (a == null) {
                a = new Array(0);
            }
            if (b == null) {
                b = new Array(0);
            }
            this.log("OnStockChanged " + a.length + " -> " + b.length);
            if (this.stockSymbolsChanged != null) {
                this.stockSymbolsChanged(this, new StockChangedEventArgs(a, b));
            }
        }
        constructor() {
            super();
            this.e = new Array(0);
            this.c = new Array(0);
            this.d = ["*.open", "*.high", "*.low", "*.close", "*.volume", "*.date"];
            this.b = new Array(0);
            this.a = null;
            this.aa = 6;
            this.z = 10;
            this.r = true;
            this.propertyChanged = null;
            this.populateStockPosition = null;
            this.populateStockPrices = null;
            this.stockSymbolsChanged = null;
            this.v = new Dictionary$2(String_$type, StockPriceHistory.$, 0);
            this.x = new List$1(StockPosition.$, 0);
            this.w = new Dictionary$2(String_$type, String_$type, 0);
            this.o = new StockDataGenerator();
            this.o = new StockDataGenerator();
            this.a = this.o.generateDetails();
        }
        log(message_) {
        }
        clearData() {
            this.e = new Array(0);
            this.v.clear();
            this.x.clear();
            arrayClear(this.stockPrices);
            arrayClear(this.stockPositions);
        }
        removeStockPosition(a) {
            this.ar(a);
        }
        removeStockPrices(a) {
            this.as(a, 0);
        }
        ax(a, b = "") {
            let e = this.stockSymbols;
            for (let d = 0; d < e.length; d++) {
                let c = e[d];
                if (!this.w.containsKey(c)) {
                    this.w.addItem(c, "");
                }
            }
            if (this.w.containsKey(a)) {
                this.w.item(a, b);
            }
            else {
                this.w.addItem(a, b);
            }
            let f = this.y(String_$type, this.stockSymbols);
            if (!f.contains(a)) {
                f.add(a);
            }
            this.stockSymbols = this.f(String_$type, f);
        }
        a0(a) {
            if (this.v.containsKey(a)) {
                let b = this.y(String_$type, this.stockSymbols);
                if (this.w.containsKey(a)) {
                    this.w.removeItem(a);
                }
                let c = this.y(String_$type, this.stockSymbols);
                if (c.contains(a)) {
                    c.remove(a);
                }
                this.e = this.f(String_$type, c);
                this.ay(this.f(String_$type, b), this.f(String_$type, c));
            }
        }
        ad(a) {
            if (stringIsNullOrEmpty(a)) {
                return "";
            }
            if (this.w.containsKey(a)) {
                return this.w.item(a);
            }
            return "";
        }
        q(a) {
            this.o.dateRange = this.ac;
            this.o.dateInterval = this.ab;
            this.o.skipAfterHours = !this.u;
            let b = this.ad(a);
            let c;
            if (this.populateStockPrices == null) {
                this.log("OnGeneratingPrices " + a);
                c = this.o.generateStockPrices(a, b);
            }
            else {
                this.log("OnPopulatePrices " + a);
                c = this.populateStockPrices(a);
            }
            return c;
        }
        p(a) {
            this.o.dateRange = this.ac;
            this.o.dateInterval = this.ab;
            this.o.skipAfterHours = !this.u;
            let b = this.ad(a);
            let c;
            if (this.populateStockPosition == null) {
                this.log("OnGeneratingPosition " + a);
                c = this.o.generatePosition(a, b);
            }
            else {
                this.log("OnPopulatePosition " + a);
                c = this.populateStockPosition(a);
            }
            return c;
        }
        an(a, b) {
            if (stringIsNullOrEmpty(a)) {
                return;
            }
            if (b == null) {
                return;
            }
            b.index = this.x.count;
            this.x.add(b);
            this.stockPositions = this.f(StockPosition.$, this.x);
        }
        ao(a, b) {
            if (stringIsNullOrEmpty(a)) {
                return;
            }
            if (b == null) {
                return;
            }
            this.log("OnAddingPrices " + a);
            if (!this.v.containsKey(a)) {
                this.v.addItem(a, b);
            }
            else {
                return;
            }
            this.stockPrices = this.f(StockPriceHistory.$, this.v.values);
        }
        as(a, b) {
            if (stringIsNullOrEmpty(a)) {
                return;
            }
            this.log("OnRemovingPrices " + a);
            if (this.v.containsKey(a)) {
                this.v.removeItem(a);
            }
            else {
                return;
            }
            this.stockPrices = this.f(StockPriceHistory.$, this.v.values);
        }
        ar(a) {
            this.log("OnRemovingPosition " + a);
            if (this.x.count > a) {
                this.x.removeAt(a);
            }
            else {
                return;
            }
            for (let b = 0; b < this.x.count; b++) {
                this.x._inner[b].index = b;
            }
            this.stockPositions = this.f(StockPosition.$, this.x);
        }
        at() {
            this.log("OnStockClearing ");
            this.a1(this.stockSymbols, new Array(0), true);
        }
        a1(a, b, c = false) {
            if (this.t(a, b)) {
                return;
            }
            let d = this.y(String_$type, a);
            for (let f = 0; f < b.length; f++) {
                let e = b[f];
                if (!d.contains(e)) {
                    d.add(e);
                }
            }
            this.e = this.f(String_$type, d);
            this.ap("StockSymbols", null, this.e);
            this.au(a, this.e);
        }
        ay(a, b) {
            if (a == b) {
                return;
            }
            this.log("StockGenerate ");
            if (a != null && a.length != 0) {
                for (let c = a.length - 1; c >= 0; c--) {
                    let d = a[c];
                    if (this.v.containsKey(d)) {
                        this.as(d, c);
                    }
                }
            }
            if (b != null && b.length != 0) {
                for (let e = 0; e < b.length; e++) {
                    let f = b[e];
                    if (!this.v.containsKey(f)) {
                        let g = this.p(f);
                        let h = this.q(f);
                        this.ao(f, h);
                        this.an(f, g);
                    }
                }
            }
        }
        az() {
            this.o.dateRange = this.ac;
            this.o.dateInterval = this.ab;
            this.o.skipAfterHours = !this.u;
            if (this.stockSymbols == null || this.stockSymbols.length == 0) {
                this.v.clear();
                this.x.clear();
                arrayClear(this.stockPrices);
                arrayClear(this.stockPositions);
            }
            else {
                this.v.clear();
                this.x.clear();
                arrayClear(this.stockPrices);
                arrayClear(this.stockPositions);
                for (let a = 0; a < this.stockSymbols.length; a++) {
                    let b = this.stockSymbols[a];
                    let c = this.p(b);
                    let d = this.q(b);
                    this.ao(b, d);
                    this.an(b, c);
                }
            }
        }
        s(a, b) {
            if (a == null || a.length == 0) {
                return false;
            }
            for (let d = 0; d < a.length; d++) {
                let c = a[d];
                if (b == c) {
                    return true;
                }
            }
            return false;
        }
        f($t, a) {
            if (a == null || a.count == 0) {
                return new Array(0);
            }
            let b = new Array(a.count);
            let c = 0;
            for (let d of fromEnum(a)) {
                b[c] = d;
                c++;
            }
            return b;
        }
        y($t, a) {
            if (a == null || a.length == 0) {
                return new List$1($t, 0);
            }
            let b = new List$1($t, 0);
            for (let c = 0; c < a.length; c++) {
                b.add(a[c]);
            }
            return b;
        }
        t(a, b) {
            if (a == null || b == null) {
                return false;
            }
            if (a.length != b.length) {
                return false;
            }
            for (let c = 0; c < a.length; c++) {
                if (a[c] != b[c]) {
                    return false;
                }
            }
            return true;
        }
    }
    FinancialDataAdapter.$t = /*@__PURE__*/ markType(FinancialDataAdapter, 'FinancialDataAdapter', Base.$, [INotifyPropertyChanged_$type]);
    return FinancialDataAdapter;
})();

/**
 * Represents event arguments for FDC3 MessageRecived
*/
class IgrStockChangedEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets array of added stock symbols
    */
    get addedSymbols() {
        return this.i.addedSymbols;
    }
    set addedSymbols(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.addedSymbols = v;
    }
    /**
     * Gets array of removed stock symbols
    */
    get removedSymbols() {
        return this.i.removedSymbols;
    }
    set removedSymbols(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.removedSymbols = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISupportsDataChangeNotifications_$type = /*@__PURE__*/ new Type(null, 'ISupportsDataChangeNotifications');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceSupportsCount_$type = /*@__PURE__*/ new Type(null, 'IDataSourceSupportsCount');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceDataProviderUpdateNotifier_$type = /*@__PURE__*/ new Type(null, 'IDataSourceDataProviderUpdateNotifier', null, [ISupportsDataChangeNotifications_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let INotifyCollectionChanged_$type = /*@__PURE__*/ new Type(null, 'INotifyCollectionChanged');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NotifyCollectionChangedEventArgs = /*@__PURE__*/ (() => {
    class NotifyCollectionChangedEventArgs extends EventArgs {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super();
                        this.f = 0;
                        this.b = null;
                        this.h = 0;
                        this.c = null;
                        this.i = 0;
                        this.f = c;
                        this.c = new List$1(Base.$, 0);
                        this.b = new List$1(Base.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        super();
                        this.f = 0;
                        this.b = null;
                        this.h = 0;
                        this.c = null;
                        this.i = 0;
                        this.f = c;
                        this.c = new List$1(Base.$, 0);
                        if (this.f == 1 || this.f == 2) {
                            this.c.add(d);
                            this.i = e;
                        }
                        if (this.f != 1) {
                            this.b = ((() => {
                                let $ret = new List$1(Base.$, 0);
                                $ret.add1(d);
                                return $ret;
                            })());
                        }
                        else {
                            this.b = new List$1(Base.$, 0);
                        }
                        this.h = e;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        super();
                        this.f = 0;
                        this.b = null;
                        this.h = 0;
                        this.c = null;
                        this.i = 0;
                        this.f = c;
                        this.h = f;
                        this.i = f;
                        this.b = ((() => {
                            let $ret = new List$1(Base.$, 0);
                            $ret.add1(d);
                            return $ret;
                        })());
                        this.c = ((() => {
                            let $ret = new List$1(Base.$, 0);
                            $ret.add1(e);
                            return $ret;
                        })());
                    }
                    break;
            }
        }
        get action() {
            return this.f;
        }
        get newItems() {
            return this.b;
        }
        get newStartingIndex() {
            return this.h;
        }
        get oldItems() {
            return this.c;
        }
        get oldStartingIndex() {
            return this.i;
        }
    }
    NotifyCollectionChangedEventArgs.$t = /*@__PURE__*/ markType(NotifyCollectionChangedEventArgs, 'NotifyCollectionChangedEventArgs', EventArgs.$);
    return NotifyCollectionChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ObservableCollection$1 = /*@__PURE__*/ (() => {
    class ObservableCollection$1 extends List$1 {
        constructor($t, a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super($t, 0);
                        this.$t = $t;
                        this.$type = this.$type.specialize(this.$t);
                        this.collectionChanged = null;
                        this.propertyChanged = null;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super($t, 1, c);
                        this.$t = $t;
                        this.$type = this.$type.specialize(this.$t);
                        this.collectionChanged = null;
                        this.propertyChanged = null;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        super($t, 2, c);
                        this.$t = $t;
                        this.$type = this.$type.specialize(this.$t);
                        this.collectionChanged = null;
                        this.propertyChanged = null;
                    }
                    break;
            }
        }
        x(a, b) {
            let c = this._inner[a];
            super.x(a, b);
            if (this.propertyChanged != null) {
                this.ad(new PropertyChangedEventArgs("Item[]"));
            }
            if (this.collectionChanged != null) {
                let d = new NotifyCollectionChangedEventArgs(2, 2, getBoxIfEnum(this.$t, b), getBoxIfEnum(this.$t, c), a);
                this.ac(d);
            }
        }
        p() {
            super.p();
            if (this.propertyChanged != null) {
                this.ad(new PropertyChangedEventArgs("Count"));
                this.ad(new PropertyChangedEventArgs("Item[]"));
            }
            if (this.collectionChanged != null) {
                let a = new NotifyCollectionChangedEventArgs(0, 4);
                this.ac(a);
            }
        }
        r(a, b) {
            super.r(a, b);
            if (this.propertyChanged != null) {
                this.ad(new PropertyChangedEventArgs("Count"));
                this.ad(new PropertyChangedEventArgs("Item[]"));
            }
            if (this.collectionChanged != null) {
                let c = new NotifyCollectionChangedEventArgs(1, 0, getBoxIfEnum(this.$t, b), a);
                this.ac(c);
            }
        }
        n(a) {
            super.n(a);
            if (this.propertyChanged != null) {
                this.ad(new PropertyChangedEventArgs("Count"));
                this.ad(new PropertyChangedEventArgs("Item[]"));
            }
            if (this.collectionChanged != null) {
                let b = new NotifyCollectionChangedEventArgs(1, 0, getBoxIfEnum(this.$t, a), this.count - 1);
                this.ac(b);
            }
        }
        u(a) {
            let b = this._inner[a];
            super.u(a);
            if (this.propertyChanged != null) {
                this.ad(new PropertyChangedEventArgs("Count"));
                this.ad(new PropertyChangedEventArgs("Item[]"));
            }
            if (this.collectionChanged != null) {
                let c = new NotifyCollectionChangedEventArgs(1, 1, getBoxIfEnum(this.$t, b), a);
                this.ac(c);
            }
        }
        ad(a) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, a);
            }
        }
        ac(a) {
            if (this.collectionChanged != null) {
                this.collectionChanged(this, a);
            }
        }
    }
    ObservableCollection$1.$t = /*@__PURE__*/ markType(ObservableCollection$1, 'ObservableCollection$1', /*@__PURE__*/ List$1.$.specialize(0), [INotifyCollectionChanged_$type, INotifyPropertyChanged_$type]);
    return ObservableCollection$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HashSet$1 = /*@__PURE__*/ (() => {
    class HashSet$1 extends Base {
        constructor($t, a, ..._rest) {
            super();
            this.$t = null;
            this.k = null;
            this.n = 0;
            this._values = null;
            this.c = false;
            this._stringPlaceholder = null;
            this.b = false;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [null];
                        {
                            let e = c[0];
                            this._values = ({});
                            this.k = e || EqualityComparer$1.defaultEqualityComparerValue(this.$t);
                            this.c = e == null && (($t === String_$type));
                            this.b = ($t === Base.$type || ($t.InstanceConstructor && !$t.InstanceConstructor.prototype.getHashCode));
                            this._stringPlaceholder = ({});
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = [c, null];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = [g];
                            {
                                let j = h[0];
                                this._values = ({});
                                this.k = j || EqualityComparer$1.defaultEqualityComparerValue(this.$t);
                                this.c = j == null && (($t === String_$type));
                                this.b = ($t === Base.$type || ($t.InstanceConstructor && !$t.InstanceConstructor.prototype.getHashCode));
                                this._stringPlaceholder = ({});
                            }
                            for (let i of fromEnum(f)) {
                                this.add_1(i);
                            }
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        this._values = ({});
                        this.k = c || EqualityComparer$1.defaultEqualityComparerValue(this.$t);
                        this.c = c == null && (($t === String_$type));
                        this.b = ($t === Base.$type || ($t.InstanceConstructor && !$t.InstanceConstructor.prototype.getHashCode));
                        this._stringPlaceholder = ({});
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [d];
                        {
                            let g = e[0];
                            this._values = ({});
                            this.k = g || EqualityComparer$1.defaultEqualityComparerValue(this.$t);
                            this.c = g == null && (($t === String_$type));
                            this.b = ($t === Base.$type || ($t.InstanceConstructor && !$t.InstanceConstructor.prototype.getHashCode));
                            this._stringPlaceholder = ({});
                        }
                        for (let f of fromEnum(c)) {
                            this.add_1(f);
                        }
                    }
                    break;
            }
        }
        add(a) {
            this.add_1(a);
        }
        get isReadOnly() {
            return false;
        }
        getEnumeratorObject() {
            return this.getEnumerator();
        }
        get l() {
            return this.k;
        }
        get count() {
            return this.n;
        }
        add_1(item_) {
            if (this.c) {
                if ((this._values[item_])) {
                    return false;
                }
                this._values[item_] = this._stringPlaceholder;
                this.n++;
                return true;
            }
            let a = this.k.getHashCodeC(item_);
            let current_ = this._values[a];
            if ((current_)) {
                if ((current_.$isHashSetBucket)) {
                    let b = (current_);
                    for (let d = 0; d < b.length; d++) {
                        let c = b[d];
                        if (this.k.equalsC(c, item_)) {
                            return false;
                        }
                    }
                    current_.push(item_);
                }
                else {
                    if (this.k.equalsC(current_, item_)) {
                        return false;
                    }
                    let bucket_ = typeCastObjTo$t(this.$t, ([current_, item_]));
                    bucket_.$isHashSetBucket = true;
                    ;
                    this._values[a] = bucket_;
                }
            }
            else {
                this._values[a] = item_;
            }
            this.n++;
            return true;
        }
        clear() {
            this.n = 0;
            this._values = ({});
        }
        contains(item_) {
            if (this.c) {
                return (!!this._values[item_]);
            }
            let a = this.k.getHashCodeC(item_);
            let current_ = this._values[a];
            if ((current_ !== undefined)) {
                if ((current_.$isHashSetBucket)) {
                    let b = (current_);
                    for (let d = 0; d < b.length; d++) {
                        let c = b[d];
                        if (this.k.equalsC(c, item_)) {
                            return true;
                        }
                    }
                }
                else {
                    if (this.k.equalsC(current_, item_)) {
                        return true;
                    }
                }
            }
            return false;
        }
        copyTo1(a) {
            throw new NotImplementedException(0);
        }
        copyTo(a, b) {
            throw new NotImplementedException(0);
        }
        copyTo2(a, b, c) {
            throw new NotImplementedException(0);
        }
        static m($t) {
            throw new NotImplementedException(0);
        }
        r(a) {
            throw new NotImplementedException(0);
        }
        getEnumerator() {
            if (this.c) {
                let a = (Base.getArrayOfProperties(this._values));
                return getEnumeratorObject(a);
            }
            let result_ = new Array(0);
            let b = (Base.getArrayOfValues(this._values));
            for (let c = 0; c < b.length; c++) {
                let item_ = b[c];
                if ((item_.$isHashSetBucket)) {
                    let d = (item_);
                    for (let e = 0; e < d.length; e++) {
                        let subItem_ = d[e];
                        result_.push(subItem_);
                    }
                }
                else {
                    result_.push(item_);
                }
            }
            return getEnumeratorObject(result_);
        }
        s(a) {
            throw new NotImplementedException(0);
        }
        e(a) {
            throw new NotImplementedException(0);
        }
        f(a) {
            throw new NotImplementedException(0);
        }
        g(a) {
            throw new NotImplementedException(0);
        }
        h(a) {
            throw new NotImplementedException(0);
        }
        t(a) {
            throw new NotImplementedException(0);
        }
        i(a) {
            if (this.count > 0) {
                for (let b of fromEnum(a)) {
                    if (this.contains(b)) {
                        return true;
                    }
                }
            }
            return false;
        }
        remove(item_) {
            if (this.c) {
                if (!(this._values[item_])) {
                    return false;
                }
                delete this._values[item_];
                this.n--;
                return true;
            }
            let hashCode_ = this.k.getHashCodeC(item_);
            let current_ = this._values[hashCode_];
            if ((current_)) {
                if ((current_.$isHashSetBucket)) {
                    let a = (current_);
                    for (let b = 0; b < a.length; b++) {
                        let currentItem_ = a[b];
                        if (this.k.equalsC(currentItem_, item_)) {
                            arrayRemoveItem(current_, currentItem_);
                            if ((current_.length) == 1) {
                                this._values[hashCode_] = (current_[0]);
                            }
                            this.n--;
                            return true;
                        }
                    }
                }
                else {
                    if (this.k.equalsC(current_, item_)) {
                        delete this._values[hashCode_];
                        this.n--;
                        return true;
                    }
                }
            }
            return false;
        }
        j(a) {
            throw new NotImplementedException(0);
        }
        u(a) {
            throw new NotImplementedException(0);
        }
        v() {
        }
        w(a) {
            for (let b of fromEnum(a)) {
                this.add_1(b);
            }
        }
    }
    HashSet$1.$t = /*@__PURE__*/ markType(HashSet$1, 'HashSet$1', Base.$, [/*@__PURE__*/ ICollection$1_$type.specialize(0), /*@__PURE__*/ IEnumerable$1_$type.specialize(0), IEnumerable_$type]);
    return HashSet$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SyncableObservableCollectionChangedListener_$type = /*@__PURE__*/ new Type(null, 'SyncableObservableCollectionChangedListener');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SyncableObservableCollection$2 = /*@__PURE__*/ (() => {
    class SyncableObservableCollection$2 extends Base {
        get syncTarget() {
            return this.a;
        }
        set syncTarget(a) {
            let b = this.a;
            this.a = a;
            this.af(b, this.a);
        }
        addOneWayTarget(a) {
            this.q.add(a);
            this.al(a, true);
        }
        removeOneWayTarget(a) {
            this.q.remove(a);
        }
        get compare() {
            return this._compare;
        }
        set compare(a) {
            this._compare = a;
        }
        get createTo() {
            return this._createTo;
        }
        set createTo(a) {
            this._createTo = a;
        }
        get createFrom() {
            return this._createFrom;
        }
        set createFrom(a) {
            this._createFrom = a;
        }
        get shouldDetachOnTargetChange() {
            return this._shouldDetachOnTargetChange;
        }
        set shouldDetachOnTargetChange(a) {
            this._shouldDetachOnTargetChange = a;
        }
        af(a, b) {
            if (a != null) {
                a.removeListener(runOn(this, this.ao));
            }
            this.al(this.a, false);
            if (b != null) {
                b.addListener(runOn(this, this.ao));
            }
        }
        al(a, b) {
            if (a == null) {
                return;
            }
            this.h = true;
            let c = new List$1(this.$t1, 0);
            let d = new HashSet$1(this.$t1, 0);
            for (let e = 0; e < this.all.count; e++) {
                if (!d.contains(this.all.item(e))) {
                    c.add(this.all.item(e));
                    d.add_1(this.all.item(e));
                }
            }
            if (!b) {
                for (let f = 0; f < a.all.count; f++) {
                    if (!this.l(d, a.all.item(f))) {
                        let g = this.createFrom(a.all.item(f));
                        c.add(g);
                        d.add_1(g);
                    }
                }
            }
            if (!b) {
                this.am(c, this.all);
            }
            this.an(c, a.all);
            this.h = false;
        }
        l(a, b) {
            if (this.compare == null) {
                throw new InvalidOperationException(1, "SyncableObservableCollection has no Compare function provided.");
            }
            for (let c of fromEnum(a)) {
                if (this.compare(c, b)) {
                    return true;
                }
            }
            return false;
        }
        am(a, b) {
            let c = new List$1(Number_$type, 0);
            let d = 0;
            for (let e = 0; e < b.count; e++) {
                if (getBoxIfEnum(this.$t1, b.item(e)) == null) {
                    c.add(e);
                    continue;
                }
                if (d > a.count - 1) {
                    c.add(e);
                    continue;
                }
                if (Base.equalsStatic(b.item(e), getBoxIfEnum(this.$t1, a._inner[d]))) {
                    d++;
                    continue;
                }
                b.insert(e, a._inner[d]);
                d++;
            }
            for (let f = c.count - 1; f >= 0; f--) {
                b.removeAt(f);
            }
            for (; d < a.count; d++) {
                b.add(a._inner[d]);
            }
        }
        an(a, b) {
            let c = new List$1(Number_$type, 0);
            let d = 0;
            for (let e = 0; e < b.count; e++) {
                if (getBoxIfEnum(this.$t2, b.item(e)) == null) {
                    c.add(e);
                    continue;
                }
                if (d > a.count - 1) {
                    c.add(e);
                    continue;
                }
                if (Base.equalsStatic(b.item(e), getBoxIfEnum(this.$t1, a._inner[d]))) {
                    d++;
                    continue;
                }
                b.insert(e, this.createTo(a._inner[d]));
                d++;
            }
            for (let f = c.count - 1; f >= 0; f--) {
                b.removeAt(f);
            }
            for (; d < a.count; d++) {
                b.add(this.createTo(a._inner[d]));
            }
        }
        ao(a, b) {
            if (this.a == null) {
                return;
            }
            if (this.h) {
                return;
            }
            if (this.g) {
                return;
            }
            if (this.shouldDetachOnTargetChange) {
                this.syncTarget = null;
                this.q.clear();
                return;
            }
            let c = this.a.all;
            this.i = true;
            this.ak(this.$t1, this.$t2, b, this.all, c);
            this.i = false;
        }
        ae(a) {
        }
        aj(a, b) {
            this.ae(b);
            if (this.a == null && this.q.count == 0) {
                return;
            }
            if (this.h) {
                return;
            }
            if (this.i) {
                return;
            }
            if (this.a != null) {
                let c = this.a.all;
                this.g = true;
                this.ak(this.$t2, this.$t1, b, c, this.all);
                this.g = false;
            }
            if (this.q.count > 0) {
                for (let d = 0; d < this.q.count; d++) {
                    let e = this.q._inner[d].all;
                    this.g = true;
                    this.ak(this.$t2, this.$t1, b, e, this.all);
                    this.g = false;
                }
            }
        }
        ak($t, $f, a, b, c) {
            switch (a.action) {
                case 0:
                    if (a.newItems != null) {
                        for (let d = 0; d < a.newItems.count; d++) {
                            let e = a.newItems.item(d);
                            if ($f != $t) {
                                if ($f == this.$t1) {
                                    e = getBoxIfEnum(this.$t2, this.createTo(typeCastObjTo$t(this.$t1, a.newItems.item(d))));
                                }
                                if ($f == this.$t2) {
                                    e = getBoxIfEnum(this.$t1, this.createFrom(typeCastObjTo$t(this.$t2, a.newItems.item(d))));
                                }
                            }
                            b.insert(d + a.newStartingIndex, typeCastObjTo$t($t, e));
                        }
                    }
                    break;
                case 1:
                    if (a.oldItems != null) {
                        for (let f = 0; f < a.oldItems.count; f++) {
                            b.removeAt(a.oldStartingIndex);
                        }
                    }
                    break;
                case 2:
                    if (a.oldItems != null) {
                        for (let g = 0; g < a.oldItems.count; g++) {
                            b.removeAt(a.oldStartingIndex);
                        }
                    }
                    if (a.newItems != null) {
                        for (let h = 0; h < a.newItems.count; h++) {
                            let i = a.newItems.item(h);
                            if ($f != $t) {
                                if ($f == this.$t1) {
                                    i = getBoxIfEnum(this.$t2, this.createTo(typeCastObjTo$t(this.$t1, a.newItems.item(h))));
                                }
                                if ($f == this.$t2) {
                                    i = getBoxIfEnum(this.$t1, this.createFrom(typeCastObjTo$t(this.$t2, a.newItems.item(h))));
                                }
                            }
                            b.insert(h + a.newStartingIndex, typeCastObjTo$t($t, a.newItems.item(h)));
                        }
                    }
                    break;
                case 4:
                    b.clear();
                    for (let j of fromEnum(c)) {
                        let k = getBoxIfEnum($f, j);
                        if ($f != $t) {
                            if ($f == this.$t1) {
                                k = getBoxIfEnum(this.$t2, this.createTo(typeCastObjTo$t(this.$t1, k)));
                            }
                            if ($f == this.$t2) {
                                k = getBoxIfEnum(this.$t1, this.createFrom(typeCastObjTo$t(this.$t2, k)));
                            }
                        }
                        b.add(typeCastObjTo$t($t, k));
                    }
                    break;
            }
        }
        constructor($t1, $t2, a, ..._rest) {
            super();
            this.$t1 = null;
            this.$t2 = null;
            this.a = null;
            this.q = new List$1(SyncableObservableCollection$1.$.specialize(this.$t2), 0);
            this._compare = null;
            this._createTo = null;
            this._createFrom = null;
            this._shouldDetachOnTargetChange = false;
            this.h = false;
            this.i = false;
            this.g = false;
            this._inner = null;
            this.p = new List$1(SyncableObservableCollectionChangedListener_$type, 0);
            this.f = null;
            this.$t1 = $t1;
            this.$t2 = $t2;
            this.$type = this.$type.specialize(this.$t1, this.$t2);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this._inner = new ObservableCollection$1(this.$t1, 0);
                        this.addListener(runOn(this, this.aj));
                        let c = this._inner;
                        c.collectionChanged = delegateCombine(c.collectionChanged, runOn(this, this.x));
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this._inner = c;
                    }
                    break;
            }
        }
        ac(a) {
            if (this._inner != null) {
                let b = this._inner;
                b.collectionChanged = delegateRemove(b.collectionChanged, runOn(this, this.x));
            }
            this._inner = a;
            if (this._inner != null) {
                let c = this._inner;
                c.collectionChanged = delegateCombine(c.collectionChanged, runOn(this, this.x));
            }
        }
        x(a, b) {
            if (this.f != null) {
                this.f();
            }
            for (let c of fromEnum(this.p)) {
                c.onChanged(this);
            }
        }
        add(a) {
            this._inner.add(a);
            return true;
        }
        add1(a, b) {
            this._inner.insert(a, b);
        }
        clear() {
            this._inner.clear();
        }
        get(a) {
            return this._inner._inner[a];
        }
        indexOf(a) {
            return this._inner.indexOf(a);
        }
        remove1(a) {
            let b = this._inner.contains(a);
            this._inner.remove(a);
            return b;
        }
        contains(a) {
            return this._inner.contains(a);
        }
        remove(a) {
            let b = this._inner._inner[a];
            this._inner.removeAt(a);
            return b;
        }
        set(a, b) {
            this._inner.item(a, b);
            return b;
        }
        size() {
            return this._inner.count;
        }
        addChangedListener(a) {
            this.p.add(a);
        }
        removeChangedListener(a) {
            this.p.remove(a);
        }
        addListener(a) {
            let b = this._inner;
            b.collectionChanged = delegateCombine(b.collectionChanged, a);
        }
        removeListener(a) {
            let b = this._inner;
            b.collectionChanged = delegateRemove(b.collectionChanged, a);
        }
        get all() {
            return this._inner;
        }
    }
    SyncableObservableCollection$2.$t = /*@__PURE__*/ markType(SyncableObservableCollection$2, 'SyncableObservableCollection$2');
    return SyncableObservableCollection$2;
})();
/**
 * @hidden
 */
let SyncableObservableCollection$1 = /*@__PURE__*/ (() => {
    class SyncableObservableCollection$1 extends SyncableObservableCollection$2 {
        constructor($t) {
            super($t, $t, 0);
            this.$t = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.compare = (a, b) => Base.equalsStatic(a, getBoxIfEnum(this.$t, b));
            this.createFrom = (a) => a;
            this.createTo = (a) => a;
        }
    }
    SyncableObservableCollection$1.$t = /*@__PURE__*/ markType(SyncableObservableCollection$1, 'SyncableObservableCollection$1', /*@__PURE__*/ SyncableObservableCollection$2.$.specialize(0, 0));
    return SyncableObservableCollection$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SortDescription = /*@__PURE__*/ (() => {
    class SortDescription extends Base {
        constructor() {
            super();
            this.b = false;
            this.h = null;
            this.d = 0;
            this.g = null;
        }
        get propertyName() {
            return this.h;
        }
        set propertyName(a) {
            this.h = a;
        }
        get direction() {
            return this.d;
        }
        set direction(a) {
            this.d = a;
        }
        get displayName() {
            return this.g;
        }
        set displayName(a) {
            this.g = a;
        }
        equals(a) {
            let b = a;
            if (b == null) {
                return super.equals(a);
            }
            return b.propertyName == this.propertyName && b.direction == this.direction && b.displayName == this.displayName;
        }
        getHashCode() {
            return Base.getHashCodeStatic(this.propertyName) * 17 + this.direction;
        }
        k() {
            this.b = true;
        }
        static create(a, b, c = null) {
            let d = new SortDescription();
            d.propertyName = a;
            d.direction = b;
            d.displayName = c;
            return d;
        }
    }
    SortDescription.$t = /*@__PURE__*/ markType(SortDescription, 'SortDescription');
    return SortDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SortDescriptionCollection = /*@__PURE__*/ (() => {
    class SortDescriptionCollection extends Base {
        getInner() {
            return this.f;
        }
        get syncTarget() {
            return this.d;
        }
        set syncTarget(a) {
            if (a == null) {
                this.f.syncTarget = null;
                this.d = null;
                return;
            }
            this.d = a;
            this.f.syncTarget = this.d.f;
        }
        constructor() {
            super();
            this.d = null;
            this.f = null;
            this.f = new SyncableObservableCollection$1(SortDescription.$);
        }
        add(a) {
            return this.f.add(a);
        }
        insert(a, b) {
            this.f.add1(a, b);
        }
        clear() {
            this.f.clear();
        }
        get(a) {
            return this.f.get(a);
        }
        indexOf(a) {
            return this.f.indexOf(a);
        }
        remove(a) {
            return this.f.remove1(a);
        }
        removeAt(a) {
            return this.f.remove(a);
        }
        set(a, b) {
            return this.f.set(a, b);
        }
        size() {
            return this.f.size();
        }
        n(a) {
            this.f.addListener(a);
        }
        r(a) {
            this.f.removeListener(a);
        }
        o(a) {
            this.f.addOneWayTarget(a.f);
        }
        s(a) {
            this.f.removeOneWayTarget(a.f);
        }
        get onChanged() {
            return this.f.f;
        }
        set onChanged(a) {
            this.f.f = a;
        }
        get k() {
            return this.f.all;
        }
    }
    SortDescriptionCollection.$t = /*@__PURE__*/ markType(SortDescriptionCollection, 'SortDescriptionCollection');
    return SortDescriptionCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enumerates different calculation modes for summaries in the data source.
 */
var DataSourceSummaryScope = /*@__PURE__*/ (function (DataSourceSummaryScope) {
    /**
     * Summaries are calculated for both the root and section level.
     */
    DataSourceSummaryScope[DataSourceSummaryScope["Both"] = 0] = "Both";
    /**
     * Summaries are only calculated at the root level.
     */
    DataSourceSummaryScope[DataSourceSummaryScope["Root"] = 1] = "Root";
    /**
     * Summaries are only calculated at the group level.
     */
    DataSourceSummaryScope[DataSourceSummaryScope["Groups"] = 2] = "Groups";
    /**
     * Summaries are not calculated at all.
     */
    DataSourceSummaryScope[DataSourceSummaryScope["None"] = 3] = "None";
    return DataSourceSummaryScope;
})({});
/**
 * @hidden
 */
let DataSourceSummaryScope_$type = /*@__PURE__*/ markEnum('DataSourceSummaryScope', 'Both,0|Root,1|Groups,2|None,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceSupportsIndexedAccess_$type = /*@__PURE__*/ new Type(null, 'IDataSourceSupportsIndexedAccess', null, [IDataSourceSupportsCount_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enumerates possible display modes for section headers.
 */
var DataSourceSectionHeaderDisplayMode = /*@__PURE__*/ (function (DataSourceSectionHeaderDisplayMode) {
    /**
     * Each group is preceded by a single section header that combines multiple groups into one.
     */
    DataSourceSectionHeaderDisplayMode[DataSourceSectionHeaderDisplayMode["Combined"] = 0] = "Combined";
    /**
     * Each group may be preceded by multiple section headers, one for each group.
     */
    DataSourceSectionHeaderDisplayMode[DataSourceSectionHeaderDisplayMode["Split"] = 1] = "Split";
    return DataSourceSectionHeaderDisplayMode;
})({});
/**
 * @hidden
 */
let DataSourceSectionHeaderDisplayMode_$type = /*@__PURE__*/ markEnum('DataSourceSectionHeaderDisplayMode', 'Combined,0|Split,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSchemaChangedEventArgs = /*@__PURE__*/ (() => {
    class DataSourceSchemaChangedEventArgs extends EventArgs {
        constructor(a, b) {
            super();
            this.d = 0;
            this.b = null;
            this.b = a;
            this.d = b;
        }
        get schema() {
            return this.b;
        }
        get count() {
            return this.d;
        }
    }
    DataSourceSchemaChangedEventArgs.$t = /*@__PURE__*/ markType(DataSourceSchemaChangedEventArgs, 'DataSourceSchemaChangedEventArgs', EventArgs.$);
    return DataSourceSchemaChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceRowExpansionChangedEventArgs = /*@__PURE__*/ (() => {
    class DataSourceRowExpansionChangedEventArgs extends EventArgs {
        constructor(a, b, c) {
            super();
            this.f = -1;
            this.c = false;
            this.b = false;
            this.f = a;
            this.c = b;
            this.b = c;
        }
        get rowIndex() {
            return this.f;
        }
        get oldState() {
            return this.c;
        }
        get newState() {
            return this.b;
        }
    }
    DataSourceRowExpansionChangedEventArgs.$t = /*@__PURE__*/ markType(DataSourceRowExpansionChangedEventArgs, 'DataSourceRowExpansionChangedEventArgs', EventArgs.$);
    return DataSourceRowExpansionChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function nullableConcat(v1, v2) {
    if (v1 == null) {
        v1 = "";
    }
    else if (!!v1.isNullable) {
        v1 = v1.getValueOrDefault1("");
    }
    if (v2 == null) {
        v2 = "";
    }
    else if (!!v2.isNullable) {
        v2 = v2.getValueOrDefault1("");
    }
    return v1.toString() + v2.toString();
}
function nullableAdd(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return null;
    }
    if (v2.isNullable && !v2.hasValue) {
        return null;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return toNullable(Number_$type, val1 + val2);
}
function nullableSubtract(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return null;
    }
    if (v2.isNullable && !v2.hasValue) {
        return null;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return toNullable(Number_$type, val1 - val2);
}
function nullableMultiply(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return null;
    }
    if (v2.isNullable && !v2.hasValue) {
        return null;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return toNullable(Number_$type, val1 * val2);
}
function nullableDivide(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return null;
    }
    if (v2.isNullable && !v2.hasValue) {
        return null;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return toNullable(Number_$type, val1 / val2);
}
function nullableModulus(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return null;
    }
    if (v2.isNullable && !v2.hasValue) {
        return null;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return toNullable(Number_$type, val1 % val2);
}
function nullableGreaterThan(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return false;
    }
    if (v2.isNullable && !v2.hasValue) {
        return false;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return val1 > val2;
}
function nullableGreaterThanOrEqual(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return false;
    }
    if (v2.isNullable && !v2.hasValue) {
        return false;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return val1 >= val2;
}
function nullableLessThan(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return false;
    }
    if (v2.isNullable && !v2.hasValue) {
        return false;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return val1 < val2;
}
function nullableLessThanOrEqual(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return false;
    }
    if (v2.isNullable && !v2.hasValue) {
        return false;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return val1 <= val2;
}
function nullableIsNull(v) {
    /*jshint eqnull:true */
    return v == null || (!!v.isNullable && !v.hasValue);
}
function nullableEquals(v1, v2) {
    /*jshint eqnull:true */
    var v1IsNull = (v1 == null) || (!!v1.isNullable && !v1.hasValue);
    var v2IsNull = (v2 == null) || (!!v2.isNullable && !v2.hasValue);
    if (v1IsNull && v2IsNull) {
        return true;
    }
    if (v1IsNull != v2IsNull) {
        return false;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return val1 == val2;
}
function nullableNotEquals(v1, v2) {
    return !nullableEquals(v1, v2);
}
function unwrapNullable(v) {
    /*jshint eqnull:true */
    if (v == null || !v.isNullable) {
        return v;
    }
    if (!v.hasValue) {
        return null;
    }
    return v.value;
}
function wrapNullable($t, v) {
    /*jshint eqnull:true */
    if (v != null && v.isNullable) {
        return v;
    }
    return toNullable($t, v);
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function startsWith1(target, s, comparisonType) {
    if (target.length < s.length) {
        return false;
    }
    return stringCompare1(target.slice(0, s.length), s, comparisonType || 0) === 0;
}
;
function endsWith1(target, s, comparisonType) {
    if (target.length < s.length) {
        return false;
    }
    return stringCompare1(target.slice(-s.length), s, comparisonType || 0) === 0;
}
;
function isLower(target) {
    return target.toLowerCase() === target;
}
function isLetterOrDigit(target) {
    var charCode = target.charCodeAt(0);
    // "a" <= c && c <= "z"
    if (97 <= charCode && charCode <= 122) {
        return true;
    }
    // "A" <= c && c <= "Z"
    if (65 <= charCode && charCode <= 90) {
        return true;
    }
    // "0" <= c && c <= "9"
    if (48 <= charCode && charCode <= 57) {
        return true;
    }
    if (charCode <= 0x7F) {
        return false;
    }
    return unicode_hack_impl("(\\p{L}|\\p{Nd})").test(target); // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers
}
function isLetter(c) {
    var charCode = c.charCodeAt(0);
    // "a" <= c && c <= "z"
    if (97 <= charCode && charCode <= 122) {
        return true;
    }
    // "A" <= c && c <= "Z"
    if (65 <= charCode && charCode <= 90) {
        return true;
    }
    if (charCode <= 0x7F) {
        return false;
    }
    return unicode_hack_impl("\\p{L}").test(c); // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers
}
function isDigit1(c, index) {
    return isDigit(c[index]);
}
function isDigit(c) {
    var charCode = c.charCodeAt(0);
    // "0" <= c && c <= "9"
    if (48 <= charCode && charCode <= 57) {
        return true;
    }
    if (charCode <= 0x7F) {
        return false;
    }
    return unicode_hack_impl("\\p{Nd}").test(c); // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers
}
function isNumber(c) {
    var charCode = c.charCodeAt(0);
    // "0" <= c && c <= "9"
    if (48 <= charCode && charCode <= 57) {
        return true;
    }
    if (charCode <= 0x7F) {
        return false;
    }
    return unicode_hack_impl("\\p{N}").test(c); // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers
}
function padLeft(target, len, c) {
    var s = target;
    c = c || " ";
    while (s.length < len) {
        s = c + s;
    }
    return s;
}
function reverse(target) {
    /* Inverts the order of the characters in a string.
        returnType="string" Returns a new inverted string.
    */
    var s = "";
    for (var i = target.length - 1; i >= 0; i--) {
        s += target[i];
    }
    return s;
}
;
function padRight(target, len, c) {
    var s = target;
    c = c || " ";
    while (s.length < len) {
        s += c;
    }
    return s;
}
;
function indexOfAny(target, chars) {
    var s = target.toString();
    for (var i = 0; i < s.length; i++) {
        if (chars.indexOf(s[i]) > -1) {
            return i;
        }
    }
    return -1;
}
function lastIndexOfAny(target, chars) {
    var s = target.toString();
    for (var i = s.length - 1; i >= 0; i--) {
        if (chars.indexOf(s[i]) > -1) {
            return i;
        }
    }
    return -1;
}
function stringFormat(format, ...rest) {
    return stringFormat1(format, ...rest);
}
;
function stringFormat1(format, ...args) {
    return stringFormat2(CultureInfo.currentCulture, format, ...args);
}
;
function stringFormat2(provider, format, ...args) {
    // TODO: what is going on with provider here??
    // TODO: Use the provider somehow
    return format.replace(/{(\d+)(?::)?([^}]*)?}/g, function (match, number, format) {
        var arg = args[number];
        if (arg === void 0) {
            return match;
        }
        if (arg === null) {
            return "";
        }
        if (format) {
            if (format[0] === "X") {
                return intToString1(arg, format, provider);
            }
            else {
                return numberToString2(arg, format, provider);
            }
        }
        return arg;
    });
}
;
function stringCompare1(strA, strB, comparisonType) {
    if (!strA) {
        return !strB ? 0 : -1;
    }
    else if (!strB) {
        return 1;
    }
    // TODO: Make sure this is right
    switch (comparisonType) {
        case 0 /* StringComparison.CurrentCulture */:
            return CultureInfo.currentCulture
                .compareInfo.compare4(strA, strB);
        case 1 /* StringComparison.CurrentCultureIgnoreCase */:
            return CultureInfo.currentCulture.compareInfo
                .compare4(strA.toLowerCase(), strB.toLowerCase());
        case 2 /* StringComparison.InvariantCulture */:
        case 4 /* StringComparison.Ordinal */:
            return stringCompareTo(strA, strB);
        case 3 /* StringComparison.InvariantCultureIgnoreCase */:
        case 5 /* StringComparison.OrdinalIgnoreCase */:
            return stringCompareTo(strA.toLowerCase(), strB.toLowerCase());
        default:
            break;
    }
    return 0;
}
;
function stringCompare2(strA, strB, culture, options) {
    return culture.compareInfo.compare5(strA, strB, options);
}
;
function stringCompare3(strA, indexA, strB, indexB, length) {
    var v1 = strA.substr(indexA, length);
    var v2 = strB.substr(indexB, length);
    return stringCompare1(v1, v2, 0 /* StringComparison.CurrentCulture */);
}
;
function stringCompareOrdinal(strA, indexA, strB, indexB, length) {
    var v1 = strA.substr(indexA, length);
    var v2 = strB.substr(indexB, length);
    return stringCompare1(v1, v2, 4 /* StringComparison.Ordinal */);
}
;
function stringEquals1(strA, strB, comparisonType) {
    return stringCompare1(strA, strB, comparisonType) == 0;
}
;
function stringInsert(str, index, value) {
    return str.substr(0, index) + value + str.substr(index);
}
;
// https://developer.mozilla.org/en-US/docs/Web/API/WindowBase64/Base64_encoding_and_decoding
function b64toUint8Array(b64Data, nBlocksSize) {
    /*jslint bitwise: true */
    function b64ToUint6(nChr) {
        return nChr > 64 && nChr < 91 ?
            nChr - 65
            : nChr > 96 && nChr < 123 ?
                nChr - 71
                : nChr > 47 && nChr < 58 ?
                    nChr + 4
                    : nChr === 43 ?
                        62
                        : nChr === 47 ?
                            63
                            :
                                0;
    }
    var sB64Enc = b64Data.replace(/[^A-Za-z0-9\+\/]/g, ""), nInLen = sB64Enc.length, nOutLen = nBlocksSize ?
        Math.ceil((nInLen * 3 + 1 >> 2) / nBlocksSize) * nBlocksSize :
        nInLen * 3 + 1 >> 2, taBytes;
    if (typeof window.Uint8Array === "function") {
        taBytes = new Uint8Array(nOutLen);
    }
    else {
        taBytes = new Array(nOutLen);
    }
    for (var nMod3, nMod4, nUint24 = 0, nOutIdx = 0, nInIdx = 0; nInIdx < nInLen; nInIdx++) {
        nMod4 = nInIdx & 3;
        nUint24 |= b64ToUint6(sB64Enc.charCodeAt(nInIdx)) << 18 - 6 * nMod4;
        if (nMod4 === 3 || nInLen - nInIdx === 1) {
            for (nMod3 = 0; nMod3 < 3 && nOutIdx < nOutLen; nMod3++, nOutIdx++) {
                taBytes[nOutIdx] = nUint24 >>> (16 >>> nMod3 & 24) & 255;
            }
            nUint24 = 0;
        }
    }
    return taBytes;
}
;
// https://developer.mozilla.org/en-US/docs/Web/API/WindowBase64/Base64_encoding_and_decoding
function uint8ArraytoB64(aBytes) {
    /*jslint bitwise: true */
    function uint6ToB64(nUint6) {
        return nUint6 < 26 ?
            nUint6 + 65
            : nUint6 < 52 ?
                nUint6 + 71
                : nUint6 < 62 ?
                    nUint6 - 4
                    : nUint6 === 62 ?
                        43
                        : nUint6 === 63 ?
                            47
                            :
                                65;
    }
    var nMod3 = 2, sB64Enc = "";
    for (var nLen = aBytes.length, nUint24 = 0, nIdx = 0; nIdx < nLen; nIdx++) {
        nMod3 = nIdx % 3;
        if (nIdx > 0 && (nIdx * 4 / 3) % 76 === 0) {
            sB64Enc += "\r\n";
        }
        nUint24 |= aBytes[nIdx] << (16 >>> nMod3 & 24);
        if (nMod3 === 2 || aBytes.length - nIdx === 1) {
            sB64Enc += String.fromCharCode(uint6ToB64(nUint24 >>> 18 & 63), uint6ToB64(nUint24 >>> 12 & 63), uint6ToB64(nUint24 >>> 6 & 63), uint6ToB64(nUint24 & 63));
            nUint24 = 0;
        }
    }
    return sB64Enc.substr(0, sB64Enc.length - 2 + nMod3) +
        (nMod3 === 2 ? "" : nMod3 === 1 ? "=" : "==");
}
function stringSplit(value, separators, options) {
    var r = "", i;
    for (i = 0; i < separators.length; i++) {
        if (i !== 0) {
            r += "|";
        }
        r += stringEscapeRegExp(separators[i]);
    }
    var result = value.split(new RegExp(r));
    for (i = result.length - 1; i >= 0; i--) {
        /*jslint bitwise: true */
        if ((result[i].length === 0 &&
            (options & 1 /* StringSplitOptions.RemoveEmptyEntries */)) ||
            separators.indexOf(result[i]) > -1) {
            result.splice(i, 1);
        }
    }
    return result;
}
;
/*! unicode_hack.js
Copyright (C) 2010-2012,2014  Marcelo Gibson de Castro GonÃ§alves. All rights reserved.

Copying and distribution of this file, with or without modification,
are permitted in any medium without royalty provided the copyright
notice and this notice are preserved.  This file is offered as-is,
without any warranty.
*/
// jscs:disable
var unicodeCategories = {
    Cn: "[\u0378\u0379\u037f-\u0383\u038b\u038d\u03a2\u0528-\u0530\u0557\u0558\u0560\u0588\u058b-\u0590\u05c8-\u05cf\u05eb-\u05ef\u05f5-\u05ff\u0604\u0605\u061c\u061d\u070e\u074b\u074c\u07b2-\u07bf\u07fb-\u07ff\u082e\u082f\u083f\u085c\u085d\u085f-\u08ff\u0978\u0980\u0984\u098d\u098e\u0991\u0992\u09a9\u09b1\u09b3-\u09b5\u09ba\u09bb\u09c5\u09c6\u09c9\u09ca\u09cf-\u09d6\u09d8-\u09db\u09de\u09e4\u09e5\u09fc-\u0a00\u0a04\u0a0b-\u0a0e\u0a11\u0a12\u0a29\u0a31\u0a34\u0a37\u0a3a\u0a3b\u0a3d\u0a43-\u0a46\u0a49\u0a4a\u0a4e-\u0a50\u0a52-\u0a58\u0a5d\u0a5f-\u0a65\u0a76-\u0a80\u0a84\u0a8e\u0a92\u0aa9\u0ab1\u0ab4\u0aba\u0abb\u0ac6\u0aca\u0ace\u0acf\u0ad1-\u0adf\u0ae4\u0ae5\u0af0\u0af2-\u0b00\u0b04\u0b0d\u0b0e\u0b11\u0b12\u0b29\u0b31\u0b34\u0b3a\u0b3b\u0b45\u0b46\u0b49\u0b4a\u0b4e-\u0b55\u0b58-\u0b5b\u0b5e\u0b64\u0b65\u0b78-\u0b81\u0b84\u0b8b-\u0b8d\u0b91\u0b96-\u0b98\u0b9b\u0b9d\u0ba0-\u0ba2\u0ba5-\u0ba7\u0bab-\u0bad\u0bba-\u0bbd\u0bc3-\u0bc5\u0bc9\u0bce\u0bcf\u0bd1-\u0bd6\u0bd8-\u0be5\u0bfb-\u0c00\u0c04\u0c0d\u0c11\u0c29\u0c34\u0c3a-\u0c3c\u0c45\u0c49\u0c4e-\u0c54\u0c57\u0c5a-\u0c5f\u0c64\u0c65\u0c70-\u0c77\u0c80\u0c81\u0c84\u0c8d\u0c91\u0ca9\u0cb4\u0cba\u0cbb\u0cc5\u0cc9\u0cce-\u0cd4\u0cd7-\u0cdd\u0cdf\u0ce4\u0ce5\u0cf0\u0cf3-\u0d01\u0d04\u0d0d\u0d11\u0d3b\u0d3c\u0d45\u0d49\u0d4f-\u0d56\u0d58-\u0d5f\u0d64\u0d65\u0d76-\u0d78\u0d80\u0d81\u0d84\u0d97-\u0d99\u0db2\u0dbc\u0dbe\u0dbf\u0dc7-\u0dc9\u0dcb-\u0dce\u0dd5\u0dd7\u0de0-\u0df1\u0df5-\u0e00\u0e3b-\u0e3e\u0e5c-\u0e80\u0e83\u0e85\u0e86\u0e89\u0e8b\u0e8c\u0e8e-\u0e93\u0e98\u0ea0\u0ea4\u0ea6\u0ea8\u0ea9\u0eac\u0eba\u0ebe\u0ebf\u0ec5\u0ec7\u0ece\u0ecf\u0eda\u0edb\u0ede-\u0eff\u0f48\u0f6d-\u0f70\u0f98\u0fbd\u0fcd\u0fdb-\u0fff\u10c6-\u10cf\u10fd-\u10ff\u1249\u124e\u124f\u1257\u1259\u125e\u125f\u1289\u128e\u128f\u12b1\u12b6\u12b7\u12bf\u12c1\u12c6\u12c7\u12d7\u1311\u1316\u1317\u135b\u135c\u137d-\u137f\u139a-\u139f\u13f5-\u13ff\u169d-\u169f\u16f1-\u16ff\u170d\u1715-\u171f\u1737-\u173f\u1754-\u175f\u176d\u1771\u1774-\u177f\u17de\u17df\u17ea-\u17ef\u17fa-\u17ff\u180f\u181a-\u181f\u1878-\u187f\u18ab-\u18af\u18f6-\u18ff\u191d-\u191f\u192c-\u192f\u193c-\u193f\u1941-\u1943\u196e\u196f\u1975-\u197f\u19ac-\u19af\u19ca-\u19cf\u19db-\u19dd\u1a1c\u1a1d\u1a5f\u1a7d\u1a7e\u1a8a-\u1a8f\u1a9a-\u1a9f\u1aae-\u1aff\u1b4c-\u1b4f\u1b7d-\u1b7f\u1bab-\u1bad\u1bba-\u1bbf\u1bf4-\u1bfb\u1c38-\u1c3a\u1c4a-\u1c4c\u1c80-\u1ccf\u1cf3-\u1cff\u1de7-\u1dfb\u1f16\u1f17\u1f1e\u1f1f\u1f46\u1f47\u1f4e\u1f4f\u1f58\u1f5a\u1f5c\u1f5e\u1f7e\u1f7f\u1fb5\u1fc5\u1fd4\u1fd5\u1fdc\u1ff0\u1ff1\u1ff5\u1fff\u2065-\u2069\u2072\u2073\u208f\u209d-\u209f\u20ba-\u20cf\u20f1-\u20ff\u218a-\u218f\u23f4-\u23ff\u2427-\u243f\u244b-\u245f\u2700\u27cb\u27cd\u2b4d-\u2b4f\u2b5a-\u2bff\u2c2f\u2c5f\u2cf2-\u2cf8\u2d26-\u2d2f\u2d66-\u2d6e\u2d71-\u2d7e\u2d97-\u2d9f\u2da7\u2daf\u2db7\u2dbf\u2dc7\u2dcf\u2dd7\u2ddf\u2e32-\u2e7f\u2e9a\u2ef4-\u2eff\u2fd6-\u2fef\u2ffc-\u2fff\u3040\u3097\u3098\u3100-\u3104\u312e-\u3130\u318f\u31bb-\u31bf\u31e4-\u31ef\u321f\u32ff\u4db6-\u4dbf\u9fcc-\u9fff\ua48d-\ua48f\ua4c7-\ua4cf\ua62c-\ua63f\ua674-\ua67b\ua698-\ua69f\ua6f8-\ua6ff\ua78f\ua792-\ua79f\ua7aa-\ua7f9\ua82c-\ua82f\ua83a-\ua83f\ua878-\ua87f\ua8c5-\ua8cd\ua8da-\ua8df\ua8fc-\ua8ff\ua954-\ua95e\ua97d-\ua97f\ua9ce\ua9da-\ua9dd\ua9e0-\ua9ff\uaa37-\uaa3f\uaa4e\uaa4f\uaa5a\uaa5b\uaa7c-\uaa7f\uaac3-\uaada\uaae0-\uab00\uab07\uab08\uab0f\uab10\uab17-\uab1f\uab27\uab2f-\uabbf\uabee\uabef\uabfa-\uabff\ud7a4-\ud7af\ud7c7-\ud7ca\ud7fc-\ud7ff\ufa2e\ufa2f\ufa6e\ufa6f\ufada-\ufaff\ufb07-\ufb12\ufb18-\ufb1c\ufb37\ufb3d\ufb3f\ufb42\ufb45\ufbc2-\ufbd2\ufd40-\ufd4f\ufd90\ufd91\ufdc8-\ufdef\ufdfe\ufdff\ufe1a-\ufe1f\ufe27-\ufe2f\ufe53\ufe67\ufe6c-\ufe6f\ufe75\ufefd\ufefe\uff00\uffbf-\uffc1\uffc8\uffc9\uffd0\uffd1\uffd8\uffd9\uffdd-\uffdf\uffe7\uffef-\ufff8\ufffe\uffff]",
    Lu: "[\u0041-\u005a\u00c0-\u00d6\u00d8-\u00de\u0100\u0102\u0104\u0106\u0108\u010a\u010c\u010e\u0110\u0112\u0114\u0116\u0118\u011a\u011c\u011e\u0120\u0122\u0124\u0126\u0128\u012a\u012c\u012e\u0130\u0132\u0134\u0136\u0139\u013b\u013d\u013f\u0141\u0143\u0145\u0147\u014a\u014c\u014e\u0150\u0152\u0154\u0156\u0158\u015a\u015c\u015e\u0160\u0162\u0164\u0166\u0168\u016a\u016c\u016e\u0170\u0172\u0174\u0176\u0178\u0179\u017b\u017d\u0181\u0182\u0184\u0186\u0187\u0189-\u018b\u018e-\u0191\u0193\u0194\u0196-\u0198\u019c\u019d\u019f\u01a0\u01a2\u01a4\u01a6\u01a7\u01a9\u01ac\u01ae\u01af\u01b1-\u01b3\u01b5\u01b7\u01b8\u01bc\u01c4\u01c7\u01ca\u01cd\u01cf\u01d1\u01d3\u01d5\u01d7\u01d9\u01db\u01de\u01e0\u01e2\u01e4\u01e6\u01e8\u01ea\u01ec\u01ee\u01f1\u01f4\u01f6-\u01f8\u01fa\u01fc\u01fe\u0200\u0202\u0204\u0206\u0208\u020a\u020c\u020e\u0210\u0212\u0214\u0216\u0218\u021a\u021c\u021e\u0220\u0222\u0224\u0226\u0228\u022a\u022c\u022e\u0230\u0232\u023a\u023b\u023d\u023e\u0241\u0243-\u0246\u0248\u024a\u024c\u024e\u0370\u0372\u0376\u0386\u0388-\u038a\u038c\u038e\u038f\u0391-\u03a1\u03a3-\u03ab\u03cf\u03d2-\u03d4\u03d8\u03da\u03dc\u03de\u03e0\u03e2\u03e4\u03e6\u03e8\u03ea\u03ec\u03ee\u03f4\u03f7\u03f9\u03fa\u03fd-\u042f\u0460\u0462\u0464\u0466\u0468\u046a\u046c\u046e\u0470\u0472\u0474\u0476\u0478\u047a\u047c\u047e\u0480\u048a\u048c\u048e\u0490\u0492\u0494\u0496\u0498\u049a\u049c\u049e\u04a0\u04a2\u04a4\u04a6\u04a8\u04aa\u04ac\u04ae\u04b0\u04b2\u04b4\u04b6\u04b8\u04ba\u04bc\u04be\u04c0\u04c1\u04c3\u04c5\u04c7\u04c9\u04cb\u04cd\u04d0\u04d2\u04d4\u04d6\u04d8\u04da\u04dc\u04de\u04e0\u04e2\u04e4\u04e6\u04e8\u04ea\u04ec\u04ee\u04f0\u04f2\u04f4\u04f6\u04f8\u04fa\u04fc\u04fe\u0500\u0502\u0504\u0506\u0508\u050a\u050c\u050e\u0510\u0512\u0514\u0516\u0518\u051a\u051c\u051e\u0520\u0522\u0524\u0526\u0531-\u0556\u10a0-\u10c5\u1e00\u1e02\u1e04\u1e06\u1e08\u1e0a\u1e0c\u1e0e\u1e10\u1e12\u1e14\u1e16\u1e18\u1e1a\u1e1c\u1e1e\u1e20\u1e22\u1e24\u1e26\u1e28\u1e2a\u1e2c\u1e2e\u1e30\u1e32\u1e34\u1e36\u1e38\u1e3a\u1e3c\u1e3e\u1e40\u1e42\u1e44\u1e46\u1e48\u1e4a\u1e4c\u1e4e\u1e50\u1e52\u1e54\u1e56\u1e58\u1e5a\u1e5c\u1e5e\u1e60\u1e62\u1e64\u1e66\u1e68\u1e6a\u1e6c\u1e6e\u1e70\u1e72\u1e74\u1e76\u1e78\u1e7a\u1e7c\u1e7e\u1e80\u1e82\u1e84\u1e86\u1e88\u1e8a\u1e8c\u1e8e\u1e90\u1e92\u1e94\u1e9e\u1ea0\u1ea2\u1ea4\u1ea6\u1ea8\u1eaa\u1eac\u1eae\u1eb0\u1eb2\u1eb4\u1eb6\u1eb8\u1eba\u1ebc\u1ebe\u1ec0\u1ec2\u1ec4\u1ec6\u1ec8\u1eca\u1ecc\u1ece\u1ed0\u1ed2\u1ed4\u1ed6\u1ed8\u1eda\u1edc\u1ede\u1ee0\u1ee2\u1ee4\u1ee6\u1ee8\u1eea\u1eec\u1eee\u1ef0\u1ef2\u1ef4\u1ef6\u1ef8\u1efa\u1efc\u1efe\u1f08-\u1f0f\u1f18-\u1f1d\u1f28-\u1f2f\u1f38-\u1f3f\u1f48-\u1f4d\u1f59\u1f5b\u1f5d\u1f5f\u1f68-\u1f6f\u1fb8-\u1fbb\u1fc8-\u1fcb\u1fd8-\u1fdb\u1fe8-\u1fec\u1ff8-\u1ffb\u2102\u2107\u210b-\u210d\u2110-\u2112\u2115\u2119-\u211d\u2124\u2126\u2128\u212a-\u212d\u2130-\u2133\u213e\u213f\u2145\u2183\u2c00-\u2c2e\u2c60\u2c62-\u2c64\u2c67\u2c69\u2c6b\u2c6d-\u2c70\u2c72\u2c75\u2c7e-\u2c80\u2c82\u2c84\u2c86\u2c88\u2c8a\u2c8c\u2c8e\u2c90\u2c92\u2c94\u2c96\u2c98\u2c9a\u2c9c\u2c9e\u2ca0\u2ca2\u2ca4\u2ca6\u2ca8\u2caa\u2cac\u2cae\u2cb0\u2cb2\u2cb4\u2cb6\u2cb8\u2cba\u2cbc\u2cbe\u2cc0\u2cc2\u2cc4\u2cc6\u2cc8\u2cca\u2ccc\u2cce\u2cd0\u2cd2\u2cd4\u2cd6\u2cd8\u2cda\u2cdc\u2cde\u2ce0\u2ce2\u2ceb\u2ced\ua640\ua642\ua644\ua646\ua648\ua64a\ua64c\ua64e\ua650\ua652\ua654\ua656\ua658\ua65a\ua65c\ua65e\ua660\ua662\ua664\ua666\ua668\ua66a\ua66c\ua680\ua682\ua684\ua686\ua688\ua68a\ua68c\ua68e\ua690\ua692\ua694\ua696\ua722\ua724\ua726\ua728\ua72a\ua72c\ua72e\ua732\ua734\ua736\ua738\ua73a\ua73c\ua73e\ua740\ua742\ua744\ua746\ua748\ua74a\ua74c\ua74e\ua750\ua752\ua754\ua756\ua758\ua75a\ua75c\ua75e\ua760\ua762\ua764\ua766\ua768\ua76a\ua76c\ua76e\ua779\ua77b\ua77d\ua77e\ua780\ua782\ua784\ua786\ua78b\ua78d\ua790\ua7a0\ua7a2\ua7a4\ua7a6\ua7a8\uff21-\uff3a]",
    Ll: "[\u0061-\u007a\u00aa\u00b5\u00ba\u00df-\u00f6\u00f8-\u00ff\u0101\u0103\u0105\u0107\u0109\u010b\u010d\u010f\u0111\u0113\u0115\u0117\u0119\u011b\u011d\u011f\u0121\u0123\u0125\u0127\u0129\u012b\u012d\u012f\u0131\u0133\u0135\u0137\u0138\u013a\u013c\u013e\u0140\u0142\u0144\u0146\u0148\u0149\u014b\u014d\u014f\u0151\u0153\u0155\u0157\u0159\u015b\u015d\u015f\u0161\u0163\u0165\u0167\u0169\u016b\u016d\u016f\u0171\u0173\u0175\u0177\u017a\u017c\u017e-\u0180\u0183\u0185\u0188\u018c\u018d\u0192\u0195\u0199-\u019b\u019e\u01a1\u01a3\u01a5\u01a8\u01aa\u01ab\u01ad\u01b0\u01b4\u01b6\u01b9\u01ba\u01bd-\u01bf\u01c6\u01c9\u01cc\u01ce\u01d0\u01d2\u01d4\u01d6\u01d8\u01da\u01dc\u01dd\u01df\u01e1\u01e3\u01e5\u01e7\u01e9\u01eb\u01ed\u01ef\u01f0\u01f3\u01f5\u01f9\u01fb\u01fd\u01ff\u0201\u0203\u0205\u0207\u0209\u020b\u020d\u020f\u0211\u0213\u0215\u0217\u0219\u021b\u021d\u021f\u0221\u0223\u0225\u0227\u0229\u022b\u022d\u022f\u0231\u0233-\u0239\u023c\u023f\u0240\u0242\u0247\u0249\u024b\u024d\u024f-\u0293\u0295-\u02af\u0371\u0373\u0377\u037b-\u037d\u0390\u03ac-\u03ce\u03d0\u03d1\u03d5-\u03d7\u03d9\u03db\u03dd\u03df\u03e1\u03e3\u03e5\u03e7\u03e9\u03eb\u03ed\u03ef-\u03f3\u03f5\u03f8\u03fb\u03fc\u0430-\u045f\u0461\u0463\u0465\u0467\u0469\u046b\u046d\u046f\u0471\u0473\u0475\u0477\u0479\u047b\u047d\u047f\u0481\u048b\u048d\u048f\u0491\u0493\u0495\u0497\u0499\u049b\u049d\u049f\u04a1\u04a3\u04a5\u04a7\u04a9\u04ab\u04ad\u04af\u04b1\u04b3\u04b5\u04b7\u04b9\u04bb\u04bd\u04bf\u04c2\u04c4\u04c6\u04c8\u04ca\u04cc\u04ce\u04cf\u04d1\u04d3\u04d5\u04d7\u04d9\u04db\u04dd\u04df\u04e1\u04e3\u04e5\u04e7\u04e9\u04eb\u04ed\u04ef\u04f1\u04f3\u04f5\u04f7\u04f9\u04fb\u04fd\u04ff\u0501\u0503\u0505\u0507\u0509\u050b\u050d\u050f\u0511\u0513\u0515\u0517\u0519\u051b\u051d\u051f\u0521\u0523\u0525\u0527\u0561-\u0587\u1d00-\u1d2b\u1d62-\u1d77\u1d79-\u1d9a\u1e01\u1e03\u1e05\u1e07\u1e09\u1e0b\u1e0d\u1e0f\u1e11\u1e13\u1e15\u1e17\u1e19\u1e1b\u1e1d\u1e1f\u1e21\u1e23\u1e25\u1e27\u1e29\u1e2b\u1e2d\u1e2f\u1e31\u1e33\u1e35\u1e37\u1e39\u1e3b\u1e3d\u1e3f\u1e41\u1e43\u1e45\u1e47\u1e49\u1e4b\u1e4d\u1e4f\u1e51\u1e53\u1e55\u1e57\u1e59\u1e5b\u1e5d\u1e5f\u1e61\u1e63\u1e65\u1e67\u1e69\u1e6b\u1e6d\u1e6f\u1e71\u1e73\u1e75\u1e77\u1e79\u1e7b\u1e7d\u1e7f\u1e81\u1e83\u1e85\u1e87\u1e89\u1e8b\u1e8d\u1e8f\u1e91\u1e93\u1e95-\u1e9d\u1e9f\u1ea1\u1ea3\u1ea5\u1ea7\u1ea9\u1eab\u1ead\u1eaf\u1eb1\u1eb3\u1eb5\u1eb7\u1eb9\u1ebb\u1ebd\u1ebf\u1ec1\u1ec3\u1ec5\u1ec7\u1ec9\u1ecb\u1ecd\u1ecf\u1ed1\u1ed3\u1ed5\u1ed7\u1ed9\u1edb\u1edd\u1edf\u1ee1\u1ee3\u1ee5\u1ee7\u1ee9\u1eeb\u1eed\u1eef\u1ef1\u1ef3\u1ef5\u1ef7\u1ef9\u1efb\u1efd\u1eff-\u1f07\u1f10-\u1f15\u1f20-\u1f27\u1f30-\u1f37\u1f40-\u1f45\u1f50-\u1f57\u1f60-\u1f67\u1f70-\u1f7d\u1f80-\u1f87\u1f90-\u1f97\u1fa0-\u1fa7\u1fb0-\u1fb4\u1fb6\u1fb7\u1fbe\u1fc2-\u1fc4\u1fc6\u1fc7\u1fd0-\u1fd3\u1fd6\u1fd7\u1fe0-\u1fe7\u1ff2-\u1ff4\u1ff6\u1ff7\u210a\u210e\u210f\u2113\u212f\u2134\u2139\u213c\u213d\u2146-\u2149\u214e\u2184\u2c30-\u2c5e\u2c61\u2c65\u2c66\u2c68\u2c6a\u2c6c\u2c71\u2c73\u2c74\u2c76-\u2c7c\u2c81\u2c83\u2c85\u2c87\u2c89\u2c8b\u2c8d\u2c8f\u2c91\u2c93\u2c95\u2c97\u2c99\u2c9b\u2c9d\u2c9f\u2ca1\u2ca3\u2ca5\u2ca7\u2ca9\u2cab\u2cad\u2caf\u2cb1\u2cb3\u2cb5\u2cb7\u2cb9\u2cbb\u2cbd\u2cbf\u2cc1\u2cc3\u2cc5\u2cc7\u2cc9\u2ccb\u2ccd\u2ccf\u2cd1\u2cd3\u2cd5\u2cd7\u2cd9\u2cdb\u2cdd\u2cdf\u2ce1\u2ce3\u2ce4\u2cec\u2cee\u2d00-\u2d25\ua641\ua643\ua645\ua647\ua649\ua64b\ua64d\ua64f\ua651\ua653\ua655\ua657\ua659\ua65b\ua65d\ua65f\ua661\ua663\ua665\ua667\ua669\ua66b\ua66d\ua681\ua683\ua685\ua687\ua689\ua68b\ua68d\ua68f\ua691\ua693\ua695\ua697\ua723\ua725\ua727\ua729\ua72b\ua72d\ua72f-\ua731\ua733\ua735\ua737\ua739\ua73b\ua73d\ua73f\ua741\ua743\ua745\ua747\ua749\ua74b\ua74d\ua74f\ua751\ua753\ua755\ua757\ua759\ua75b\ua75d\ua75f\ua761\ua763\ua765\ua767\ua769\ua76b\ua76d\ua76f\ua771-\ua778\ua77a\ua77c\ua77f\ua781\ua783\ua785\ua787\ua78c\ua78e\ua791\ua7a1\ua7a3\ua7a5\ua7a7\ua7a9\ua7fa\ufb00-\ufb06\ufb13-\ufb17\uff41-\uff5a]",
    Lt: "[\u01c5\u01c8\u01cb\u01f2\u1f88-\u1f8f\u1f98-\u1f9f\u1fa8-\u1faf\u1fbc\u1fcc\u1ffc]",
    Lm: "[\u02b0-\u02c1\u02c6-\u02d1\u02e0-\u02e4\u02ec\u02ee\u0374\u037a\u0559\u0640\u06e5\u06e6\u07f4\u07f5\u07fa\u081a\u0824\u0828\u0971\u0e46\u0ec6\u10fc\u17d7\u1843\u1aa7\u1c78-\u1c7d\u1d2c-\u1d61\u1d78\u1d9b-\u1dbf\u2071\u207f\u2090-\u209c\u2c7d\u2d6f\u2e2f\u3005\u3031-\u3035\u303b\u309d\u309e\u30fc-\u30fe\ua015\ua4f8-\ua4fd\ua60c\ua67f\ua717-\ua71f\ua770\ua788\ua9cf\uaa70\uaadd\uff70\uff9e\uff9f]",
    Lo: "[\u01bb\u01c0-\u01c3\u0294\u05d0-\u05ea\u05f0-\u05f2\u0620-\u063f\u0641-\u064a\u066e\u066f\u0671-\u06d3\u06d5\u06ee\u06ef\u06fa-\u06fc\u06ff\u0710\u0712-\u072f\u074d-\u07a5\u07b1\u07ca-\u07ea\u0800-\u0815\u0840-\u0858\u0904-\u0939\u093d\u0950\u0958-\u0961\u0972-\u0977\u0979-\u097f\u0985-\u098c\u098f\u0990\u0993-\u09a8\u09aa-\u09b0\u09b2\u09b6-\u09b9\u09bd\u09ce\u09dc\u09dd\u09df-\u09e1\u09f0\u09f1\u0a05-\u0a0a\u0a0f\u0a10\u0a13-\u0a28\u0a2a-\u0a30\u0a32\u0a33\u0a35\u0a36\u0a38\u0a39\u0a59-\u0a5c\u0a5e\u0a72-\u0a74\u0a85-\u0a8d\u0a8f-\u0a91\u0a93-\u0aa8\u0aaa-\u0ab0\u0ab2\u0ab3\u0ab5-\u0ab9\u0abd\u0ad0\u0ae0\u0ae1\u0b05-\u0b0c\u0b0f\u0b10\u0b13-\u0b28\u0b2a-\u0b30\u0b32\u0b33\u0b35-\u0b39\u0b3d\u0b5c\u0b5d\u0b5f-\u0b61\u0b71\u0b83\u0b85-\u0b8a\u0b8e-\u0b90\u0b92-\u0b95\u0b99\u0b9a\u0b9c\u0b9e\u0b9f\u0ba3\u0ba4\u0ba8-\u0baa\u0bae-\u0bb9\u0bd0\u0c05-\u0c0c\u0c0e-\u0c10\u0c12-\u0c28\u0c2a-\u0c33\u0c35-\u0c39\u0c3d\u0c58\u0c59\u0c60\u0c61\u0c85-\u0c8c\u0c8e-\u0c90\u0c92-\u0ca8\u0caa-\u0cb3\u0cb5-\u0cb9\u0cbd\u0cde\u0ce0\u0ce1\u0cf1\u0cf2\u0d05-\u0d0c\u0d0e-\u0d10\u0d12-\u0d3a\u0d3d\u0d4e\u0d60\u0d61\u0d7a-\u0d7f\u0d85-\u0d96\u0d9a-\u0db1\u0db3-\u0dbb\u0dbd\u0dc0-\u0dc6\u0e01-\u0e30\u0e32\u0e33\u0e40-\u0e45\u0e81\u0e82\u0e84\u0e87\u0e88\u0e8a\u0e8d\u0e94-\u0e97\u0e99-\u0e9f\u0ea1-\u0ea3\u0ea5\u0ea7\u0eaa\u0eab\u0ead-\u0eb0\u0eb2\u0eb3\u0ebd\u0ec0-\u0ec4\u0edc\u0edd\u0f00\u0f40-\u0f47\u0f49-\u0f6c\u0f88-\u0f8c\u1000-\u102a\u103f\u1050-\u1055\u105a-\u105d\u1061\u1065\u1066\u106e-\u1070\u1075-\u1081\u108e\u10d0-\u10fa\u1100-\u1248\u124a-\u124d\u1250-\u1256\u1258\u125a-\u125d\u1260-\u1288\u128a-\u128d\u1290-\u12b0\u12b2-\u12b5\u12b8-\u12be\u12c0\u12c2-\u12c5\u12c8-\u12d6\u12d8-\u1310\u1312-\u1315\u1318-\u135a\u1380-\u138f\u13a0-\u13f4\u1401-\u166c\u166f-\u167f\u1681-\u169a\u16a0-\u16ea\u1700-\u170c\u170e-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176c\u176e-\u1770\u1780-\u17b3\u17dc\u1820-\u1842\u1844-\u1877\u1880-\u18a8\u18aa\u18b0-\u18f5\u1900-\u191c\u1950-\u196d\u1970-\u1974\u1980-\u19ab\u19c1-\u19c7\u1a00-\u1a16\u1a20-\u1a54\u1b05-\u1b33\u1b45-\u1b4b\u1b83-\u1ba0\u1bae\u1baf\u1bc0-\u1be5\u1c00-\u1c23\u1c4d-\u1c4f\u1c5a-\u1c77\u1ce9-\u1cec\u1cee-\u1cf1\u2135-\u2138\u2d30-\u2d65\u2d80-\u2d96\u2da0-\u2da6\u2da8-\u2dae\u2db0-\u2db6\u2db8-\u2dbe\u2dc0-\u2dc6\u2dc8-\u2dce\u2dd0-\u2dd6\u2dd8-\u2dde\u3006\u303c\u3041-\u3096\u309f\u30a1-\u30fa\u30ff\u3105-\u312d\u3131-\u318e\u31a0-\u31ba\u31f0-\u31ff\u3400-\u4db5\u4e00-\u9fcb\ua000-\ua014\ua016-\ua48c\ua4d0-\ua4f7\ua500-\ua60b\ua610-\ua61f\ua62a\ua62b\ua66e\ua6a0-\ua6e5\ua7fb-\ua801\ua803-\ua805\ua807-\ua80a\ua80c-\ua822\ua840-\ua873\ua882-\ua8b3\ua8f2-\ua8f7\ua8fb\ua90a-\ua925\ua930-\ua946\ua960-\ua97c\ua984-\ua9b2\uaa00-\uaa28\uaa40-\uaa42\uaa44-\uaa4b\uaa60-\uaa6f\uaa71-\uaa76\uaa7a\uaa80-\uaaaf\uaab1\uaab5\uaab6\uaab9-\uaabd\uaac0\uaac2\uaadb\uaadc\uab01-\uab06\uab09-\uab0e\uab11-\uab16\uab20-\uab26\uab28-\uab2e\uabc0-\uabe2\uac00-\ud7a3\ud7b0-\ud7c6\ud7cb-\ud7fb\uf900-\ufa2d\ufa30-\ufa6d\ufa70-\ufad9\ufb1d\ufb1f-\ufb28\ufb2a-\ufb36\ufb38-\ufb3c\ufb3e\ufb40\ufb41\ufb43\ufb44\ufb46-\ufbb1\ufbd3-\ufd3d\ufd50-\ufd8f\ufd92-\ufdc7\ufdf0-\ufdfb\ufe70-\ufe74\ufe76-\ufefc\uff66-\uff6f\uff71-\uff9d\uffa0-\uffbe\uffc2-\uffc7\uffca-\uffcf\uffd2-\uffd7\uffda-\uffdc]",
    Mn: "[\u0300-\u036f\u0483-\u0487\u0591-\u05bd\u05bf\u05c1\u05c2\u05c4\u05c5\u05c7\u0610-\u061a\u064b-\u065f\u0670\u06d6-\u06dc\u06df-\u06e4\u06e7\u06e8\u06ea-\u06ed\u0711\u0730-\u074a\u07a6-\u07b0\u07eb-\u07f3\u0816-\u0819\u081b-\u0823\u0825-\u0827\u0829-\u082d\u0859-\u085b\u0900-\u0902\u093a\u093c\u0941-\u0948\u094d\u0951-\u0957\u0962\u0963\u0981\u09bc\u09c1-\u09c4\u09cd\u09e2\u09e3\u0a01\u0a02\u0a3c\u0a41\u0a42\u0a47\u0a48\u0a4b-\u0a4d\u0a51\u0a70\u0a71\u0a75\u0a81\u0a82\u0abc\u0ac1-\u0ac5\u0ac7\u0ac8\u0acd\u0ae2\u0ae3\u0b01\u0b3c\u0b3f\u0b41-\u0b44\u0b4d\u0b56\u0b62\u0b63\u0b82\u0bc0\u0bcd\u0c3e-\u0c40\u0c46-\u0c48\u0c4a-\u0c4d\u0c55\u0c56\u0c62\u0c63\u0cbc\u0cbf\u0cc6\u0ccc\u0ccd\u0ce2\u0ce3\u0d41-\u0d44\u0d4d\u0d62\u0d63\u0dca\u0dd2-\u0dd4\u0dd6\u0e31\u0e34-\u0e3a\u0e47-\u0e4e\u0eb1\u0eb4-\u0eb9\u0ebb\u0ebc\u0ec8-\u0ecd\u0f18\u0f19\u0f35\u0f37\u0f39\u0f71-\u0f7e\u0f80-\u0f84\u0f86\u0f87\u0f8d-\u0f97\u0f99-\u0fbc\u0fc6\u102d-\u1030\u1032-\u1037\u1039\u103a\u103d\u103e\u1058\u1059\u105e-\u1060\u1071-\u1074\u1082\u1085\u1086\u108d\u109d\u135d-\u135f\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17b7-\u17bd\u17c6\u17c9-\u17d3\u17dd\u180b-\u180d\u18a9\u1920-\u1922\u1927\u1928\u1932\u1939-\u193b\u1a17\u1a18\u1a56\u1a58-\u1a5e\u1a60\u1a62\u1a65-\u1a6c\u1a73-\u1a7c\u1a7f\u1b00-\u1b03\u1b34\u1b36-\u1b3a\u1b3c\u1b42\u1b6b-\u1b73\u1b80\u1b81\u1ba2-\u1ba5\u1ba8\u1ba9\u1be6\u1be8\u1be9\u1bed\u1bef-\u1bf1\u1c2c-\u1c33\u1c36\u1c37\u1cd0-\u1cd2\u1cd4-\u1ce0\u1ce2-\u1ce8\u1ced\u1dc0-\u1de6\u1dfc-\u1dff\u20d0-\u20dc\u20e1\u20e5-\u20f0\u2cef-\u2cf1\u2d7f\u2de0-\u2dff\u302a-\u302f\u3099\u309a\ua66f\ua67c\ua67d\ua6f0\ua6f1\ua802\ua806\ua80b\ua825\ua826\ua8c4\ua8e0-\ua8f1\ua926-\ua92d\ua947-\ua951\ua980-\ua982\ua9b3\ua9b6-\ua9b9\ua9bc\uaa29-\uaa2e\uaa31\uaa32\uaa35\uaa36\uaa43\uaa4c\uaab0\uaab2-\uaab4\uaab7\uaab8\uaabe\uaabf\uaac1\uabe5\uabe8\uabed\ufb1e\ufe00-\ufe0f\ufe20-\ufe26]",
    Me: "[\u0488\u0489\u20dd-\u20e0\u20e2-\u20e4\ua670-\ua672]",
    Mc: "[\u0903\u093b\u093e-\u0940\u0949-\u094c\u094e\u094f\u0982\u0983\u09be-\u09c0\u09c7\u09c8\u09cb\u09cc\u09d7\u0a03\u0a3e-\u0a40\u0a83\u0abe-\u0ac0\u0ac9\u0acb\u0acc\u0b02\u0b03\u0b3e\u0b40\u0b47\u0b48\u0b4b\u0b4c\u0b57\u0bbe\u0bbf\u0bc1\u0bc2\u0bc6-\u0bc8\u0bca-\u0bcc\u0bd7\u0c01-\u0c03\u0c41-\u0c44\u0c82\u0c83\u0cbe\u0cc0-\u0cc4\u0cc7\u0cc8\u0cca\u0ccb\u0cd5\u0cd6\u0d02\u0d03\u0d3e-\u0d40\u0d46-\u0d48\u0d4a-\u0d4c\u0d57\u0d82\u0d83\u0dcf-\u0dd1\u0dd8-\u0ddf\u0df2\u0df3\u0f3e\u0f3f\u0f7f\u102b\u102c\u1031\u1038\u103b\u103c\u1056\u1057\u1062-\u1064\u1067-\u106d\u1083\u1084\u1087-\u108c\u108f\u109a-\u109c\u17b6\u17be-\u17c5\u17c7\u17c8\u1923-\u1926\u1929-\u192b\u1930\u1931\u1933-\u1938\u19b0-\u19c0\u19c8\u19c9\u1a19-\u1a1b\u1a55\u1a57\u1a61\u1a63\u1a64\u1a6d-\u1a72\u1b04\u1b35\u1b3b\u1b3d-\u1b41\u1b43\u1b44\u1b82\u1ba1\u1ba6\u1ba7\u1baa\u1be7\u1bea-\u1bec\u1bee\u1bf2\u1bf3\u1c24-\u1c2b\u1c34\u1c35\u1ce1\u1cf2\ua823\ua824\ua827\ua880\ua881\ua8b4-\ua8c3\ua952\ua953\ua983\ua9b4\ua9b5\ua9ba\ua9bb\ua9bd-\ua9c0\uaa2f\uaa30\uaa33\uaa34\uaa4d\uaa7b\uabe3\uabe4\uabe6\uabe7\uabe9\uabea\uabec]",
    Nd: "[\u0030-\u0039\u0660-\u0669\u06f0-\u06f9\u07c0-\u07c9\u0966-\u096f\u09e6-\u09ef\u0a66-\u0a6f\u0ae6-\u0aef\u0b66-\u0b6f\u0be6-\u0bef\u0c66-\u0c6f\u0ce6-\u0cef\u0d66-\u0d6f\u0e50-\u0e59\u0ed0-\u0ed9\u0f20-\u0f29\u1040-\u1049\u1090-\u1099\u17e0-\u17e9\u1810-\u1819\u1946-\u194f\u19d0-\u19d9\u1a80-\u1a89\u1a90-\u1a99\u1b50-\u1b59\u1bb0-\u1bb9\u1c40-\u1c49\u1c50-\u1c59\ua620-\ua629\ua8d0-\ua8d9\ua900-\ua909\ua9d0-\ua9d9\uaa50-\uaa59\uabf0-\uabf9\uff10-\uff19]",
    Nl: "[\u16ee-\u16f0\u2160-\u2182\u2185-\u2188\u3007\u3021-\u3029\u3038-\u303a\ua6e6-\ua6ef]",
    No: "[\u00b2\u00b3\u00b9\u00bc-\u00be\u09f4-\u09f9\u0b72-\u0b77\u0bf0-\u0bf2\u0c78-\u0c7e\u0d70-\u0d75\u0f2a-\u0f33\u1369-\u137c\u17f0-\u17f9\u19da\u2070\u2074-\u2079\u2080-\u2089\u2150-\u215f\u2189\u2460-\u249b\u24ea-\u24ff\u2776-\u2793\u2cfd\u3192-\u3195\u3220-\u3229\u3251-\u325f\u3280-\u3289\u32b1-\u32bf\ua830-\ua835]",
    Zs: "[\u0020\u00a0\u1680\u180e\u2000-\u200a\u202f\u205f\u3000]",
    Zl: "[\u2028]",
    Zp: "[\u2029]",
    Cc: "[\u0000-\u001f\u007f-\u009f]",
    Cf: "[\u00ad\u0600-\u0603\u06dd\u070f\u17b4\u17b5\u200b-\u200f\u202a-\u202e\u2060-\u2064\u206a-\u206f\ufeff\ufff9-\ufffb]",
    Cs: "[\ud800-\udfff]",
    Co: "[\ue000-\uf8ff]",
    Ps: "[\u0028\u005b\u007b\u0f3a\u0f3c\u169b\u201a\u201e\u2045\u207d\u208d\u2329\u2768\u276a\u276c\u276e\u2770\u2772\u2774\u27c5\u27e6\u27e8\u27ea\u27ec\u27ee\u2983\u2985\u2987\u2989\u298b\u298d\u298f\u2991\u2993\u2995\u2997\u29d8\u29da\u29fc\u2e22\u2e24\u2e26\u2e28\u3008\u300a\u300c\u300e\u3010\u3014\u3016\u3018\u301a\u301d\ufd3e\ufe17\ufe35\ufe37\ufe39\ufe3b\ufe3d\ufe3f\ufe41\ufe43\ufe47\ufe59\ufe5b\ufe5d\uff08\uff3b\uff5b\uff5f\uff62]",
    Pd: "[\u002d\u058a\u05be\u1400\u1806\u2010-\u2015\u2e17\u2e1a\u301c\u3030\u30a0\ufe31\ufe32\ufe58\ufe63\uff0d]",
    Pc: "[\u005f\u203f\u2040\u2054\ufe33\ufe34\ufe4d-\ufe4f\uff3f]",
    Pe: "[\u0029\\\u005d\u007d\u0f3b\u0f3d\u169c\u2046\u207e\u208e\u232a\u2769\u276b\u276d\u276f\u2771\u2773\u2775\u27c6\u27e7\u27e9\u27eb\u27ed\u27ef\u2984\u2986\u2988\u298a\u298c\u298e\u2990\u2992\u2994\u2996\u2998\u29d9\u29db\u29fd\u2e23\u2e25\u2e27\u2e29\u3009\u300b\u300d\u300f\u3011\u3015\u3017\u3019\u301b\u301e\u301f\ufd3f\ufe18\ufe36\ufe38\ufe3a\ufe3c\ufe3e\ufe40\ufe42\ufe44\ufe48\ufe5a\ufe5c\ufe5e\uff09\uff3d\uff5d\uff60\uff63]",
    Sm: "[\u002b\u003c-\u003e\u007c\u007e\u00ac\u00b1\u00d7\u00f7\u03f6\u0606-\u0608\u2044\u2052\u207a-\u207c\u208a-\u208c\u2118\u2140-\u2144\u214b\u2190-\u2194\u219a\u219b\u21a0\u21a3\u21a6\u21ae\u21ce\u21cf\u21d2\u21d4\u21f4-\u22ff\u2308-\u230b\u2320\u2321\u237c\u239b-\u23b3\u23dc-\u23e1\u25b7\u25c1\u25f8-\u25ff\u266f\u27c0-\u27c4\u27c7-\u27ca\u27cc\u27ce-\u27e5\u27f0-\u27ff\u2900-\u2982\u2999-\u29d7\u29dc-\u29fb\u29fe-\u2aff\u2b30-\u2b44\u2b47-\u2b4c\ufb29\ufe62\ufe64-\ufe66\uff0b\uff1c-\uff1e\uff5c\uff5e\uffe2\uffe9-\uffec]",
    Po: "[\u0021-\u0023\u0025-\u0027\u002a\u002c\u002e\u002f\u003a\u003b\u003f\u0040\u005c\u00a1\u00b7\u00bf\u037e\u0387\u055a-\u055f\u0589\u05c0\u05c3\u05c6\u05f3\u05f4\u0609\u060a\u060c\u060d\u061b\u061e\u061f\u066a-\u066d\u06d4\u0700-\u070d\u07f7-\u07f9\u0830-\u083e\u085e\u0964\u0965\u0970\u0df4\u0e4f\u0e5a\u0e5b\u0f04-\u0f12\u0f85\u0fd0-\u0fd4\u0fd9\u0fda\u104a-\u104f\u10fb\u1361-\u1368\u166d\u166e\u16eb-\u16ed\u1735\u1736\u17d4-\u17d6\u17d8-\u17da\u1800-\u1805\u1807-\u180a\u1944\u1945\u1a1e\u1a1f\u1aa0-\u1aa6\u1aa8-\u1aad\u1b5a-\u1b60\u1bfc-\u1bff\u1c3b-\u1c3f\u1c7e\u1c7f\u1cd3\u2016\u2017\u2020-\u2027\u2030-\u2038\u203b-\u203e\u2041-\u2043\u2047-\u2051\u2053\u2055-\u205e\u2cf9-\u2cfc\u2cfe\u2cff\u2d70\u2e00\u2e01\u2e06-\u2e08\u2e0b\u2e0e-\u2e16\u2e18\u2e19\u2e1b\u2e1e\u2e1f\u2e2a-\u2e2e\u2e30\u2e31\u3001-\u3003\u303d\u30fb\ua4fe\ua4ff\ua60d-\ua60f\ua673\ua67e\ua6f2-\ua6f7\ua874-\ua877\ua8ce\ua8cf\ua8f8-\ua8fa\ua92e\ua92f\ua95f\ua9c1-\ua9cd\ua9de\ua9df\uaa5c-\uaa5f\uaade\uaadf\uabeb\ufe10-\ufe16\ufe19\ufe30\ufe45\ufe46\ufe49-\ufe4c\ufe50-\ufe52\ufe54-\ufe57\ufe5f-\ufe61\ufe68\ufe6a\ufe6b\uff01-\uff03\uff05-\uff07\uff0a\uff0c\uff0e\uff0f\uff1a\uff1b\uff1f\uff20\uff3c\uff61\uff64\uff65]",
    Sk: "[\u005e\u0060\u00a8\u00af\u00b4\u00b8\u02c2-\u02c5\u02d2-\u02df\u02e5-\u02eb\u02ed\u02ef-\u02ff\u0375\u0384\u0385\u1fbd\u1fbf-\u1fc1\u1fcd-\u1fcf\u1fdd-\u1fdf\u1fed-\u1fef\u1ffd\u1ffe\u309b\u309c\ua700-\ua716\ua720\ua721\ua789\ua78a\ufbb2-\ufbc1\uff3e\uff40\uffe3]",
    Sc: "[\u0024\u00a2-\u00a5\u060b\u09f2\u09f3\u09fb\u0af1\u0bf9\u0e3f\u17db\u20a0-\u20b9\ua838\ufdfc\ufe69\uff04\uffe0\uffe1\uffe5\uffe6]",
    Pi: "[\u00ab\u2018\u201b\u201c\u201f\u2039\u2e02\u2e04\u2e09\u2e0c\u2e1c\u2e20]",
    So: "[\u00a6\u00a7\u00a9\u00ae\u00b0\u00b6\u0482\u060e\u060f\u06de\u06e9\u06fd\u06fe\u07f6\u09fa\u0b70\u0bf3-\u0bf8\u0bfa\u0c7f\u0d79\u0f01-\u0f03\u0f13-\u0f17\u0f1a-\u0f1f\u0f34\u0f36\u0f38\u0fbe-\u0fc5\u0fc7-\u0fcc\u0fce\u0fcf\u0fd5-\u0fd8\u109e\u109f\u1360\u1390-\u1399\u1940\u19de-\u19ff\u1b61-\u1b6a\u1b74-\u1b7c\u2100\u2101\u2103-\u2106\u2108\u2109\u2114\u2116\u2117\u211e-\u2123\u2125\u2127\u2129\u212e\u213a\u213b\u214a\u214c\u214d\u214f\u2195-\u2199\u219c-\u219f\u21a1\u21a2\u21a4\u21a5\u21a7-\u21ad\u21af-\u21cd\u21d0\u21d1\u21d3\u21d5-\u21f3\u2300-\u2307\u230c-\u231f\u2322-\u2328\u232b-\u237b\u237d-\u239a\u23b4-\u23db\u23e2-\u23f3\u2400-\u2426\u2440-\u244a\u249c-\u24e9\u2500-\u25b6\u25b8-\u25c0\u25c2-\u25f7\u2600-\u266e\u2670-\u26ff\u2701-\u2767\u2794-\u27bf\u2800-\u28ff\u2b00-\u2b2f\u2b45\u2b46\u2b50-\u2b59\u2ce5-\u2cea\u2e80-\u2e99\u2e9b-\u2ef3\u2f00-\u2fd5\u2ff0-\u2ffb\u3004\u3012\u3013\u3020\u3036\u3037\u303e\u303f\u3190\u3191\u3196-\u319f\u31c0-\u31e3\u3200-\u321e\u322a-\u3250\u3260-\u327f\u328a-\u32b0\u32c0-\u32fe\u3300-\u33ff\u4dc0-\u4dff\ua490-\ua4c6\ua828-\ua82b\ua836\ua837\ua839\uaa77-\uaa79\ufdfd\uffe4\uffe8\uffed\uffee\ufffc\ufffd]",
    Pf: "[\u00bb\u2019\u201d\u203a\u2e03\u2e05\u2e0a\u2e0d\u2e1d\u2e21]"
};
let unicode_hack_impl = /*@__PURE__*/ (function () {
    /* Regexps to match characters in the BMP according to their Unicode category.
        Extracted from running all characters (code units) against Java's
        Character.getType. Source:
        https://ideone.com/04llh4
    */
    /* Also supports the general category (only the first letter) */
    var firstLetters = {}, p;
    for (p in unicodeCategories) {
        if (firstLetters[p[0]]) {
            firstLetters[p[0]] = unicodeCategories[p]
                .substring(0, unicodeCategories[p].length - 1) + firstLetters[p[0]].substring(1);
        }
        else {
            firstLetters[p[0]] = unicodeCategories[p];
        }
    }
    for (p in firstLetters) {
        unicodeCategories[p] = firstLetters[p];
    }
    /* Gets a regex written in a dialect that supports unicode categories and
        translates it to a dialect supported by JavaScript. */
    return function (regexpString) {
        var modifiers = "";
        if (regexpString instanceof RegExp) {
            modifiers = (regexpString.global ? "g" : "") +
                (regexpString.ignoreCase ? "i" : "") +
                (regexpString.multiline ? "m" : "");
            regexpString = regexpString.source;
        }
        regexpString = regexpString.replace(/\\p\{(..?)\}/g, function (match, group) {
            return unicodeCategories[group] || match;
        });
        return new RegExp(regexpString, modifiers);
    };
})();
function unicode_hack(regexpString) {
    return unicode_hack_impl(regexpString);
}
//jscs:enable
function netRegexToJS(netPattern) {
    var jsPattern = "";
    var nextNETGroupIndex = 1;
    var nextJSGroupIndex = 1;
    var namedGroups = [];
    var nameToJSGroupIndexMap = {};
    var netToJSGroupIndexMap = [[0]];
    var matchMustStartAtCurrentPosition = false;
    var name;
    var i = 0;
    if (netPattern.startsWith("\\G")) {
        i += 2;
        matchMustStartAtCurrentPosition = true;
    }
    var isInClass = false;
    for (; i < netPattern.length; i++) {
        var current = netPattern.charAt(i);
        switch (current) {
            case "\\":
                switch (netPattern.charAt(i + 1)) {
                    case "A":
                        jsPattern = jsPattern.concat("^");
                        i++;
                        break;
                    case "z":
                    case "Z":
                        jsPattern = jsPattern.concat("$");
                        i++;
                        break;
                    case "G":
                        throw new Error("\\G .NET Regex escape is only supported at the start of the pattern.");
                    case "p":
                        if (netPattern.charAt(i + 2) !== "{") {
                            throw new Error("\\p should be followed by braces.");
                        }
                        var endBraceIndex = netPattern.indexOf("}", i + 3);
                        if (endBraceIndex < 0) {
                            throw new Error("Could not find the close brace of the \\p pattern.");
                        }
                        var pattern = netPattern.substring(i + 3, endBraceIndex);
                        i = endBraceIndex;
                        var content = unicodeCategories[pattern];
                        if (content === void 0) {
                            throw new Error("Unknown \\p pattern: " + pattern);
                        }
                        if (isInClass) {
                            jsPattern = jsPattern.concat(content.substr(1, content.length - 2));
                        }
                        else {
                            jsPattern = jsPattern.concat(content);
                        }
                        break;
                    default:
                        jsPattern = jsPattern.concat(netPattern.substr(i, 2));
                        i++;
                        break;
                }
                break;
            case "/":
                jsPattern = jsPattern.concat("\\/");
                break;
            case "[":
                isInClass = true;
                jsPattern = jsPattern.concat("[");
                break;
            case "]":
                isInClass = false;
                jsPattern = jsPattern.concat("]");
                break;
            case "(":
                jsPattern = jsPattern.concat("(");
                var next = netPattern[i + 1];
                name = "";
                if (next === "?") {
                    i++;
                    next = netPattern[i + 1];
                    if (next === "<" || next === "\"") {
                        if (netPattern[i + 2] === "=" || netPattern[i + 2] === "!") {
                            throw new Error("Lookbehind assertions are not supported in JavaScript: " + pattern);
                        }
                        i++;
                        var end = next === "<" ? ">" : "\"";
                        var start = ++i;
                        for (; i < netPattern.length && netPattern[i] != end; i++) {
                        }
                        name = netPattern.slice(start, i);
                    }
                    else {
                        jsPattern = jsPattern.concat("?");
                        // Non-capturing group
                        if (next === ":") {
                            continue;
                        }
                    }
                }
                var currentJSGroupIndex = nextJSGroupIndex++;
                if (name.length !== 0) {
                    if (!(namedGroups.indexOf(name) > -1)) {
                        namedGroups.push(name);
                    }
                    var jsGroups = nameToJSGroupIndexMap[name];
                    if (!jsGroups) {
                        nameToJSGroupIndexMap[name] = jsGroups = [];
                    }
                    jsGroups.push(currentJSGroupIndex);
                }
                else {
                    netToJSGroupIndexMap[nextNETGroupIndex++] = [currentJSGroupIndex];
                }
                break;
            default:
                jsPattern = jsPattern.concat(netPattern.substr(i, 1));
                break;
        }
    }
    var nameToNetGroupIndexMap = {};
    for (i = 0; i < namedGroups.length; i++) {
        var currentNETGroupIndex = nextNETGroupIndex++;
        name = namedGroups[i];
        netToJSGroupIndexMap[currentNETGroupIndex] = nameToJSGroupIndexMap[name];
        nameToNetGroupIndexMap[name] = currentNETGroupIndex;
    }
    return {
        pattern: jsPattern,
        nameToNetGroupIndexMap: nameToNetGroupIndexMap,
        netToJSGroupIndexMap: netToJSGroupIndexMap,
        matchMustStartAtCurrentPosition: matchMustStartAtCurrentPosition
    };
}
function trim(target, ...rest) {
    if (rest.length == 0)
        return target.trim();
    var parts = stringSplit(target, rest, 0 /* StringSplitOptions.None */);
    return parts.join("");
}
function trimStart(target, ...rest) {
    if (target.length === 0) {
        return target;
    }
    var args;
    if (rest.length == 0)
        args = [" "];
    else if (rest.length == 1 && Array.isArray(rest[0])) {
        args = rest[0];
    }
    else {
        args = rest;
    }
    var i = 0;
    for (; i < target.length && args.indexOf(target.charAt(i)) > -1; i++) { }
    return target.substring(i);
}
function trimEnd(target, ...rest) {
    if (target.length === 0) {
        return target;
    }
    var args;
    if (rest.length == 0)
        args = [" "];
    else if (rest.length == 1 && Array.isArray(rest[0])) {
        args = rest[0];
    }
    else {
        args = rest;
    }
    var i = target.length - 1;
    for (; i >= 0 && args.indexOf(target.charAt(i)) > -1; i--) { }
    return target.substring(0, i + 1);
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class ConvertUtil {
    static toBoolean(v, provider) {
        if (v.toBoolean) {
            return v.toBoolean(provider);
        }
        if (typeof v === 'string' || v instanceof String) {
            if (v.toLowerCase().trim() == "true") {
                return true;
            }
            return false;
        }
        return !!v;
    }
    static toString1(v, provider) {
        if (v.toString1) {
            return v.toString1(provider);
        }
        if (typeof v === 'string' || v instanceof String) {
            return v;
        }
        return v.toString();
    }
    static toChar(v, provider) {
        if (v.toChar) {
            return v.toChar(provider);
        }
        if (typeof v === 'string' || v instanceof String) {
            return v[0];
        }
        return String.fromCharCode(+v);
    }
    static toDateTime(v, provider) {
        if (v.toDateTime) {
            return v.toDateTime(provider);
        }
        if (v == null) {
            return dateMinValue();
        }
        var str = v.toString();
        if (/^\s*([0-9]{1,4}\s*((\s+[ap]m?)|(((:\s*[0-9]{1,2}\s*){1,2}(\.\s*[0-9]+)?)(\s+[ap]m?)?)))\s*$/i.test(str)) {
            // The string can be a time string only, in which case we should return today at that time.
            str = new Date().toDateString() + " " + str;
        }
        var dt = new Date(Date.parse(str));
        if (isNaN(+dt))
            throw new FormatException(0, "");
        return dt;
    }
    static convertToNumber(meth, v, minValue, maxValue, trunc, provider, throwOnNaN) {
        if (v[meth]) {
            return v[meth](provider);
        }
        let numberVal = 0;
        if (typeof v === 'string' || v instanceof String) {
            numberVal = parseFloat(v);
            if (throwOnNaN === true && isNaN(numberVal)) {
                throw new FormatException(0, "The string cannot be converted to a number");
            }
        }
        else {
            numberVal = +v;
        }
        if (numberVal < minValue) {
            numberVal = minValue;
        }
        if (numberVal > maxValue) {
            numberVal = maxValue;
        }
        if (trunc) {
            numberVal = truncate(numberVal);
        }
        return numberVal;
    }
    static toByte(v, provider) {
        return ConvertUtil.convertToNumber("toByte", v, 0, 255, true, provider, true);
    }
    static toDecimal(v, provider) {
        return ConvertUtil.convertToNumber("toDecimal", v, Number.NEGATIVE_INFINITY, Number.POSITIVE_INFINITY, false, provider, true);
    }
    static toDouble(v, provider) {
        return ConvertUtil.convertToNumber("toDouble", v, Number.NEGATIVE_INFINITY, Number.POSITIVE_INFINITY, false, provider);
    }
    static toInt16(v, provider) {
        return ConvertUtil.convertToNumber("toInt16", v, -32768, 32767, true, provider, true);
    }
    static toInt32(v, provider) {
        return ConvertUtil.convertToNumber("toInt32", v, -2147483648, 2147483647, true, provider, true);
    }
    static toInt64(v, provider) {
        return ConvertUtil.convertToNumber("toInt64", v, -9223372036854775808, 9223372036854775807, true, provider, true);
    }
    static toSByte(v, provider) {
        return ConvertUtil.convertToNumber("toSByte", v, -128, 127, true, provider, true);
    }
    static toUInt16(v, provider) {
        return ConvertUtil.convertToNumber("toUInt16", v, 0, 65535, true, provider, true);
    }
    static toUInt32(v, provider) {
        return ConvertUtil.convertToNumber("toUInt32", v, 0, 4294967295, true, provider, true);
    }
    static toUInt64(v, provider) {
        return ConvertUtil.convertToNumber("toUInt64", v, 0, 18446744073709551615, true, provider, true);
    }
    static toSingle(v, provider) {
        return ConvertUtil.convertToNumber("toSingle", v, Number.NEGATIVE_INFINITY, Number.POSITIVE_INFINITY, false, provider);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function dateToString(value, provider) {
    return dateToStringFormat(value, "s", provider);
}
;
function fromOADate(value) {
    var days = Math.floor(value);
    var result = new Date(1899, 11, 30 + days);
    if (value !== days) {
        result = new Date(+result + Math.round((value - days) * 86400000));
    }
    return result;
}
function toOADate(value) {
    var u1 = Date.UTC(value.getFullYear(), value.getMonth(), value.getDate(), value.getHours(), value.getMinutes(), value.getSeconds(), value.getMilliseconds());
    var u2 = Date.UTC(1899, 11, 30);
    return (u1 - u2) / 86400000;
}
class IntlCache {
}
let intlCache = /*@__PURE__*/ new IntlCache();
function dateToStringFormat(value, format, provider) {
    var result;
    provider = provider || CultureInfo.currentCulture; // TODO: Use the provider below
    var mmm = function (value, provider) {
        // On some browsers, the ja-JP month short formatting seems to not match .NET"s "MMM" formatting
        var cultureName = provider.name;
        if (cultureName == "ja-JP") {
            if (window.Intl) {
                if (!intlCache.monthShortJP) {
                    intlCache.monthShortJP = new Intl.DateTimeFormat("en-US", { month: "numeric" });
                }
                result = intlCache.monthShortJP.format(value).replace(/\u200E/g, "");
            }
            else {
                result = value.toLocaleString("en-US", { month: "numeric" })
                    .replace(/\u200E/g, "");
            }
        }
        else {
            if (window.Intl) {
                if (!intlCache['mmm_' + provider.name]) {
                    intlCache['mmm_' + provider.name] = new Intl.DateTimeFormat(provider.name, { month: "short" });
                }
                result = intlCache['mmm_' + provider.name].format(value)
                    .replace(/\u200E/g, "");
            }
            else {
                result = value.toLocaleString(provider.name, { month: "short" })
                    .replace(/\u200E/g, "");
            }
        }
        if (result.indexOf(" ") >= 0) {
            // Date.toLocaleString is not supported fully
            // TODO: Handle other cultures?
            return ["Jan", "Feb", "Mar", "Apr", "May", "Jun",
                "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"][value.getMonth()];
        }
        return result;
    };
    var tt = function (value, abbr) {
        var h = value.getHours();
        var designator = h <= 11 ? "AM" : "PM";
        if (window.Intl) {
            var d = new Date(+value);
            d.setHours(h, 0, 0, 0);
            var culture = provider.name;
            // account for left-to-right marker ie/edge inject
            var r = /\d|[\u200E]/g;
            var withAmPm = applyFormat("tt:" + abbr, { hour12: true, hour: "2-digit" }, d)
                .replace(r, "");
            var nonAmPm = applyFormat("tt:" + abbr, { hour12: false, hour: "2-digit" }, d)
                .replace(r, "");
            var pattern = stringEscapeRegExp(nonAmPm);
            var amPm = withAmPm.replace(new RegExp("\\s*" + pattern + "\\s*"), "").trim();
            // ie & edge will not include the culture's am/pm designator
            // and they instead include some erroneous extra characters.
            // if that's the case then we'll just use the previous fallback
            if (amPm.replace(/[.,:;]/g, "").length > 0) {
                designator = amPm;
            }
        }
        if (abbr && designator) {
            designator = designator.charAt(0);
        }
        return designator;
    };
    var applyFormat = function (format, options, otherVal) {
        let val = value;
        if (otherVal) {
            val = otherVal;
        }
        if (window.Intl) {
            if (!intlCache[format + "_" + provider.name]) {
                intlCache[format + "_" + provider.name] = new Intl.DateTimeFormat(provider.name, options);
            }
            var formatter = intlCache[format + "_" + provider.name];
            return formatter.format(val);
        }
        return val.toLocaleString(provider.name, options);
    };
    switch (format) {
        case "s":
            {
                var s = new Date(Date.UTC(value.getFullYear(), value.getMonth(), value.getDate(), value.getHours(), value.getMinutes(), value.getSeconds())).toISOString();
                var d = s.lastIndexOf(".");
                if (d < 0) {
                    return s;
                }
                return s.slice(0, d);
            }
        case "MMMM":
            return applyFormat(format, { month: "long" })
                .replace(/\u200E/g, "");
        case "ddd":
            return applyFormat(format, { weekday: "short" })
                .replace(/\u200E/g, "");
        case "dddd":
            result = applyFormat(format, { weekday: "long" })
                .replace(/\u200E/g, "");
            if (result.indexOf(" ") >= 0) {
                // Date.toLocaleString is not supported fully
                // TODO: Handle other cultures?
                return ["Sunday", "Monday", "Tuesday", "Wednesday",
                    "Thursday", "Friday", "Saturday"][value.getDay()];
            }
            return result;
        case "%h":
            return value.getHours();
            ;
        case "%m":
            return value.getMinutes();
        case "%s":
            return value.getSeconds();
        case "%t":
            return tt(value, true);
        case "d": // short date
            return applyFormat(format, {});
        case "D": // long date
            return applyFormat(format, { weekday: "long", month: "long", day: "numeric", year: "numeric" });
        case "f": // full datetime (short time)
            return applyFormat(format, {
                weekday: "long", month: "long", day: "numeric", year: "numeric",
                hour: "numeric", minute: "numeric"
            });
        case "F": // full datetime (long time)
            return applyFormat(format, {
                weekday: "long", month: "long", day: "numeric", year: "numeric",
                hour: "numeric", minute: "numeric", second: "numeric"
            });
        case "g": // general (short time)
            return applyFormat(format, {
                month: "numeric", day: "numeric", year: "numeric",
                hour: "numeric", minute: "numeric"
            });
        case "G": // general (long time)
            return applyFormat(format, {
                month: "numeric", day: "numeric", year: "numeric",
                hour: "numeric", minute: "numeric", second: "numeric"
            });
        case "M": // month/day
        case "m":
            return applyFormat(format, { month: "long", day: "numeric" });
        case "t": // short time
            return applyFormat(format, { hour: "numeric", minute: "numeric" });
        case "T": // long time
            return applyFormat(format, { hour: "numeric", minute: "numeric", second: "numeric" });
        //return value.toLocaleTimeString();
        case "Y": // year/month
        case "y":
            return applyFormat(format, { year: "numeric", month: "long" });
    }
    result = format;
    var year = value.getFullYear().toString();
    result = result.replace("yyyy", year);
    result = result.replace("yy", year.substr(-2));
    result = result.replace("MMM", mmm(value, provider));
    result = result.replace("MM", (value.getMonth() + 1).toString().replace(/^(\d)$/, "0$1"));
    result = result.replace("dd", value.getDate().toString().replace(/^(\d)$/, "0$1"));
    var hours = value.getHours();
    result = result.replace("HH", hours.toString().replace(/^(\d)$/, "0$1"));
    result = result.replace("hh", (hours % 12 == 0 ? 12 : hours % 12).toString().replace(/^(\d)$/, "0$1"));
    result = result.replace("tt", tt(value, false));
    result = result.replace("mm", value.getMinutes().toString().replace(/^(\d)$/, "0$1"));
    result = result.replace("ss", value.getSeconds().toString().replace(/^(\d)$/, "0$1"));
    result = result.replace("ff", Math.round(value.getMilliseconds() / 10).toString().replace(/^(\d)$/, "0$1")); // hundredths of a second
    return result;
}
function dateTryParse(s, result) {
    var date = new Date(s);
    if (date == null || isNaN(+date)) {
        // IE8 does not support this format, so parse it manually
        var r = /(\d{4})-(\d{2})-(\d{2})(?:T(\d{2}):(\d{2}):(\d{2}))?/.exec(s);
        if (r) {
            if (r[4]) {
                return {
                    p1: new Date(+r[1], +r[2] - 1, +r[3], +r[4], +r[5], +r[6]), ret: true
                };
            }
            else {
                return { p1: new Date(+r[1], +r[2] - 1, +r[3]), ret: true };
            }
        }
        return { p1: null, ret: false };
    }
    // TODO: Use the current date separator/date format here here?
    if (date.getFullYear() < 1930 && /\d+\/\d+\/\d\d(?!\d)/.test(s)) {
        date.setFullYear(date.getFullYear() + 100);
    }
    return { p1: date, ret: true };
}
function dateParseExact(s, format = null, provider = null) {
    // TODO: Use the format and provider
    var r = dateTryParse(s);
    if (!r.ret) {
        throw new FormatException(1, "Unknown date format");
    }
    return r.p1;
}
function toLocalTime(value) {
    // TODO: Implement
    return value;
}
function toUniversalTime(value) {
    // TODO: Implement
    return value;
}
let _requiresISOCorrection = !/*@__PURE__*/ isNaN(+/*@__PURE__*/ new Date("2000-01-01T00:00:00")) &&
    /*@__PURE__*/ /*@__PURE__*/ new Date("2000-01-01T00:00:00").getHours() !== 0;
let _requiresISODateCorrection = !/*@__PURE__*/ isNaN(+/*@__PURE__*/ new Date("2000-01-01")) &&
    /*@__PURE__*/ /*@__PURE__*/ new Date("2000-01-01").getHours() !== 0;
function dateParse(s, provider) {
    provider = provider || CultureInfo.currentCulture; // TODO: Use the provider below
    var result;
    var isoTest = /(\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2})(?:\.| )?(\d*)?/.exec(s);
    if (isoTest) {
        result = dateParseExact(isoTest[1]);
        if (isoTest[2]) {
            var ms = Number("0." + isoTest[2]) * 1000;
            result = new Date(+result + ms);
        }
        if (!_requiresISOCorrection) {
            return result;
        }
    }
    else {
        result = dateParseExact(s);
        if (!_requiresISODateCorrection) {
            return result;
        }
    }
    return new Date(result.getUTCFullYear(), result.getUTCMonth(), result.getUTCDate(), result.getUTCHours(), result.getUTCMinutes(), result.getUTCSeconds(), result.getUTCMilliseconds());
}
let _longDateFormatOptions = {
    weekday: "long",
    year: "numeric",
    month: "long",
    day: "numeric"
};
function toLongDateString(value) {
    return value.toLocaleString(CultureInfo.currentCulture.name, _longDateFormatOptions).replace(/\u200E/g, "");
}
let _longTimeFormatOptions = {
    hour: "numeric",
    minute: "numeric",
    second: "numeric"
};
function toLongTimeString(value) {
    return value.toLocaleString(CultureInfo.currentCulture.name, _longTimeFormatOptions).replace(/\u200E/g, "");
}
var DayOfWeek = /*@__PURE__*/ (function (DayOfWeek) {
    DayOfWeek[DayOfWeek["Sunday"] = 0] = "Sunday";
    DayOfWeek[DayOfWeek["Monday"] = 1] = "Monday";
    DayOfWeek[DayOfWeek["Tuesday"] = 2] = "Tuesday";
    DayOfWeek[DayOfWeek["Wednesday"] = 3] = "Wednesday";
    DayOfWeek[DayOfWeek["Thursday"] = 4] = "Thursday";
    DayOfWeek[DayOfWeek["Friday"] = 5] = "Friday";
    DayOfWeek[DayOfWeek["Saturday"] = 6] = "Saturday";
    return DayOfWeek;
})({});
let DayOfWeek_$type = /*@__PURE__*/ markEnum("DayOfWeek", "Sunday,0|Monday,1|Tuesday,2|Wednesday,3|Thursday,4|Friday,5|Saturday,6");

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Convert = /*@__PURE__*/ (() => {
    class Convert extends Base {
        static toDouble5(a) {
            return a;
        }
        static toDouble1(a) {
            return a;
        }
        static toDouble(a) {
            return a;
        }
        static toDouble2(a) {
            return a;
        }
        static toDecimal(a) {
            return a;
        }
        static toDecimal3(a) {
            return a;
        }
        static toDecimal1(a) {
            return a;
        }
        static toInt32(a) {
            if (a >= 0) {
                let b = truncate(Math.floor(a));
                if (b != a) {
                    let c = a - b;
                    let d = Math.ceil(a) - a;
                    if (c > d || ((c == d) && (b & 1) > 0)) {
                        b++;
                    }
                }
                return b;
            }
            else {
                let e = truncate(Math.ceil(a));
                if (e != a) {
                    let f = e - a;
                    let g = a - Math.floor(a);
                    if (f > g || ((f == g) && (e & 1) > 0)) {
                        e--;
                    }
                }
                return e;
            }
        }
        static toInt322(a) {
            return parseInt(a);
        }
        static toDouble3(a) {
            return Convert.toDouble4(a, CultureInfo.currentCulture);
        }
        static toDouble4(a, b) {
            let c = (typeGetValue(unwrapNullable(a)));
            if (c == null) {
                return 0;
            }
            let d = (+c);
            if (isNaN_(d)) {
                return ConvertUtil.toDouble(c, b);
            }
            return d;
        }
        static toInt321(a) {
            let b = (typeGetValue(unwrapNullable(a)));
            if (b == null) {
                return 0;
            }
            let c = (+b);
            if (isNaN_(c)) {
                return ConvertUtil.toInt32(b, CultureInfo.currentCulture);
            }
            return c;
        }
        static toInt64(a) {
            let b = (typeGetValue(unwrapNullable(a)));
            if (b == null) {
                return 0;
            }
            let c = (+b);
            if (isNaN_(c)) {
                return ConvertUtil.toInt64(b, CultureInfo.currentCulture);
            }
            return c;
        }
        static toDecimal2(a) {
            let b = (typeGetValue(unwrapNullable(a)));
            if (b == null) {
                return 0;
            }
            let c = (+b);
            if (isNaN_(c)) {
                return ConvertUtil.toDecimal(b, CultureInfo.currentCulture);
            }
            return c;
        }
        static toByte(a) {
            return (a ? 1 : 0);
        }
        static toByte1(a) {
            let b = (typeGetValue(unwrapNullable(a)));
            if (b == null) {
                return 0;
            }
            let c = (+b);
            if (isNaN_(c)) {
                return ConvertUtil.toByte(b, CultureInfo.currentCulture);
            }
            return c;
        }
        static toBoolean(a) {
            let b = (typeGetValue(unwrapNullable(a)));
            if (b == null) {
                return false;
            }
            return (!!b);
        }
        static toDateTime(a) {
            let b = (typeGetValue(unwrapNullable(a)));
            if (b == null) {
                return dateMinValue();
            }
            if (typeCast(Date_$type, b) !== null) {
                return b;
            }
            let c = (+b);
            if (!isNaN_(c)) {
                return dateFromTicks(c);
            }
            return dateParse(b.toString());
        }
        static toChar(a) {
            return String.fromCharCode(a);
        }
        static toChar1(a) {
            return String.fromCharCode(a);
        }
        static toDouble6(a, b) {
            return parseNumber(a, b);
        }
        static toUInt16(a) {
            return (a ? 1 : 0);
        }
        static toBoolean1(a) {
            return a != 0;
        }
        static toUInt32(a) {
            return a;
        }
        static fromBase64String(a) {
            return (b64toUint8Array(a));
        }
        static toBase64String(a) {
            return (uint8ArraytoB64(a));
        }
        static toByte2(a, b) {
            throw new NotImplementedException(0);
        }
    }
    Convert.$t = /*@__PURE__*/ markType(Convert, 'Convert');
    return Convert;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISummaryResult_$type = /*@__PURE__*/ new Type(null, 'ISummaryResult');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DefaultSummaryResult = /*@__PURE__*/ (() => {
    class DefaultSummaryResult extends Base {
        constructor(a, b, c) {
            super();
            this.a = null;
            this.e = null;
            this.d = null;
            this.b = 0;
            this.c = 0;
            this.e = a;
            this.b = b;
            this.d = c;
        }
        get groupKey() {
            return this.a;
        }
        set groupKey(a) {
            this.a = a;
        }
        get propertyName() {
            return this.e;
        }
        get operand() {
            return this.b;
        }
        get value() {
            return this.d;
        }
        set value(a) {
            this.d = a;
        }
        get summaryIndex() {
            return this.c;
        }
        set summaryIndex(a) {
            this.c = a;
        }
    }
    DefaultSummaryResult.$t = /*@__PURE__*/ markType(DefaultSummaryResult, 'DefaultSummaryResult', Base.$, [ISummaryResult_$type]);
    return DefaultSummaryResult;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArgumentNullException = /*@__PURE__*/ (() => {
    class ArgumentNullException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(1, c + " cannot be null.");
                    }
                    break;
                case 1:
                    {
                        super(0);
                        throw new NotImplementedException(0);
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, d);
                        throw new NotImplementedException(0);
                    }
                    break;
            }
        }
    }
    ArgumentNullException.$t = /*@__PURE__*/ markType(ArgumentNullException, 'ArgumentNullException', BaseError.$);
    return ArgumentNullException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IEditableDataSource_$type = /*@__PURE__*/ new Type(null, 'IEditableDataSource');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Transaction = /*@__PURE__*/ (() => {
    class Transaction extends Base {
        constructor() {
            super(...arguments);
            this._id = null;
            this._transactionID = 0;
            this._type = 0;
            this._value = null;
            this._error = null;
        }
        get id() {
            return this._id;
        }
        set id(a) {
            this._id = a;
        }
        get transactionID() {
            return this._transactionID;
        }
        set transactionID(a) {
            this._transactionID = a;
        }
        get type() {
            return this._type;
        }
        set type(a) {
            this._type = a;
        }
        get value() {
            return this._value;
        }
        set value(a) {
            this._value = a;
        }
        get error() {
            return this._error;
        }
        set error(a) {
            this._error = a;
        }
    }
    Transaction.$t = /*@__PURE__*/ markType(Transaction, 'Transaction');
    return Transaction;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransactionState = /*@__PURE__*/ (() => {
    class TransactionState extends Base {
        get id() {
            return this._id;
        }
        set id(a) {
            this._id = a;
        }
        get transactionType() {
            return this._transactionType;
        }
        set transactionType(a) {
            this._transactionType = a;
        }
        get value() {
            return this._value;
        }
        set value(a) {
            this._value = a;
        }
        get version() {
            return this._version;
        }
        set version(a) {
            this._version = a;
        }
        constructor(a, b, c) {
            super();
            this._id = null;
            this._transactionType = 0;
            this._value = null;
            this._version = null;
            this.id = a;
            this.transactionType = b;
            this.value = c;
        }
    }
    TransactionState.$t = /*@__PURE__*/ markType(TransactionState, 'TransactionState');
    return TransactionState;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BaseTransactionService = /*@__PURE__*/ (() => {
    class BaseTransactionService extends Base {
        constructor(a, b, c) {
            super();
            this.i = false;
            this.p = new List$1(Transaction.$, 0);
            this.n = null;
            this.h = null;
            this.r = null;
            this.stateChanged = null;
            if (a == null || b == null) {
                throw new ArgumentNullException(1);
            }
            this.h = a;
            this.r = b;
            if (c != null) {
                this.n = new Dictionary$2(Base.$, TransactionState.$, 2, c);
            }
            else {
                this.n = new Dictionary$2(Base.$, TransactionState.$, 0);
            }
        }
        get m() {
            return this.i;
        }
        set m(a) {
            this.i = a;
        }
        get q() {
            return this.p;
        }
        get o() {
            return this.n;
        }
        get_l() {
            return this.i;
        }
        set_l(a) {
        }
        get l() {
            return this.get_l();
        }
        set l(a) {
            this.set_l(a);
        }
        get_k() {
            return false;
        }
        get k() {
            return this.get_k();
        }
        get_j() {
            return false;
        }
        get j() {
            return this.get_j();
        }
        af(a, b) {
            if (a.containsKey(b.id)) {
                if (this.h != null) {
                    this.h(a.item(b.id), b.value);
                }
                else {
                    a.item(b.id).value = b.value;
                }
            }
            else {
                a.addItem(b.id, new TransactionState(b.id, b.type, this.r(b.value)));
            }
        }
        aa(a, b) {
            if (this.stateChanged != null) {
                this.stateChanged(a, b);
            }
        }
        z(a, b, c) {
        }
        v(a, b = false) {
            if (this.m) {
                this.af(this.o, a);
                this.q.add(a);
            }
        }
        w(a, b = null) {
            if (a) {
                this.n.clear();
                this.p.clear();
            }
        }
        g(a) {
            if (this.o.count > 0 && this.o.containsKey(a)) {
                return this.o.item(a);
            }
            return null;
        }
        ad() {
            this.i = true;
        }
        y(a) {
            this.i = false;
            this.x(-1);
        }
        x(a = -1) {
            if (a > -1) {
                for (let b = 0; b < this.q.count; b++) {
                    let c = this.q._inner[b];
                    if (c.transactionID == a) {
                        this.q.removeAt(b);
                        this.o.clear();
                        for (let d = 0; d < this.q.count; d++) {
                            this.af(this.o, this.q._inner[d]);
                        }
                        break;
                    }
                }
            }
            else {
                this.n.clear();
                this.p.clear();
            }
        }
        d(a) {
            for (let b = 0; b < this.q.count; b++) {
                if (this.q._inner[b].transactionID == a) {
                    return this.q._inner[b];
                }
            }
            return null;
        }
        e(a) {
            return null;
        }
        s(a, b) {
            return -1;
        }
        u(a) {
        }
        ac(a) {
        }
        ae() {
        }
        ab() {
        }
        a(a = -1) {
            let b = new List$1(TransactionState.$, 0);
            for (let c of fromEnum(this.o.values)) {
                b.add(c);
            }
            return b.toArray();
        }
        c(a = null) {
            if (a != null) {
                let b = new List$1(Transaction.$, 0);
                for (let c = 0; c < this.q.count; c++) {
                    if (this.q._inner[c].id == a) {
                        b.add(this.q._inner[c]);
                    }
                }
                return b.toArray();
            }
            return this.q.toArray();
        }
        b() {
            let a = new List$1(Transaction.$, 0);
            for (let b = 0; b < this.q.count; b++) {
                if (!stringIsNullOrWhiteSpace(this.q._inner[b].error)) {
                    a.add(this.q._inner[b]);
                }
            }
            return a.toArray();
        }
    }
    BaseTransactionService.$t = /*@__PURE__*/ markType(BaseTransactionService, 'BaseTransactionService');
    return BaseTransactionService;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransactionHistory = /*@__PURE__*/ (() => {
    class TransactionHistory extends Base {
        constructor() {
            super(...arguments);
            this.a = new List$1(Transaction.$, 0);
        }
        get transactions() {
            return this.a;
        }
    }
    TransactionHistory.$t = /*@__PURE__*/ markType(TransactionHistory, 'TransactionHistory');
    return TransactionHistory;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransactionCommit = /*@__PURE__*/ (() => {
    class TransactionCommit extends Base {
        constructor() {
            super(...arguments);
            this._id = 0;
            this.a = null;
            this.b = null;
            this.d = 0;
        }
        get id() {
            return this._id;
        }
        set id(a) {
            this._id = a;
        }
    }
    TransactionCommit.$t = /*@__PURE__*/ markType(TransactionCommit, 'TransactionCommit');
    return TransactionCommit;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enumeration for the different transaction types.
 */
var TransactionType = /*@__PURE__*/ (function (TransactionType) {
    /**
     * An add transaction.
     */
    TransactionType[TransactionType["Add"] = 0] = "Add";
    /**
     * An update transaction.
     */
    TransactionType[TransactionType["Update"] = 1] = "Update";
    /**
     * A delete transaction.
     */
    TransactionType[TransactionType["Delete"] = 2] = "Delete";
    return TransactionType;
})({});
/**
 * @hidden
 */
let TransactionType_$type = /*@__PURE__*/ markEnum('TransactionType', 'Add,0|Update,1|Delete,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransactionService = /*@__PURE__*/ (() => {
    class TransactionService extends BaseTransactionService {
        constructor(a, b, c) {
            super(a, b, c);
            this.am = new List$1(Transaction.$, 0);
            this.ak = new List$1(TransactionCommit.$, 0);
            this.ai = null;
            this.an = new List$1(TransactionHistory.$, 0);
            this.al = new List$1(TransactionHistory.$, 0);
            this.aj = null;
            this.aj = c;
            if (this.aj != null) {
                this.ai = new Dictionary$2(Base.$, TransactionState.$, 2, this.aj);
            }
            else {
                this.ai = new Dictionary$2(Base.$, TransactionState.$, 0);
            }
        }
        get_l() {
            return true;
        }
        set_l(a) {
            super.set_l(a);
        }
        get_k() {
            return this.an.count > 0;
        }
        get_j() {
            return this.al.count > 0;
        }
        af(a, b) {
            let c = null;
            if (a.containsKey(b.id)) {
                c = a.item(b.id);
            }
            if (c != null) {
                switch (b.type) {
                    case TransactionType.Delete:
                        if (c.transactionType == 0) {
                            a.removeItem(b.id);
                        }
                        else if (c.transactionType == 1) {
                            c.value = null;
                            c.transactionType = TransactionType.Delete;
                        }
                        break;
                    case 1:
                        if (c.transactionType == 0 || c.transactionType == 1) {
                            this.h(c.value, b.value);
                        }
                        break;
                }
            }
            else {
                a.addItem(b.id, new TransactionState(b.id, b.type, this.r(b.value)));
            }
        }
        aq(a, b) {
            let c = null;
            if (a.containsKey(b.id)) {
                c = a.item(b.id);
            }
            switch (b.type) {
                case 0:
                    if (c != null) {
                        throw new InvalidOperationException(1, "Cannot add this transaction. A transaction with this ID already exists.");
                    }
                    break;
                case 1:
                case TransactionType.Delete:
                    if (c != null && c.transactionType == TransactionType.Delete) {
                        throw new InvalidOperationException(1, "Cannot add this transaction. A transaction with this ID has already been deleted.");
                    }
                    break;
            }
        }
        z(a, b, c) {
            super.z(a, b, c);
            switch (a) {
                case "IsEnabled":
                    this.w(true, null);
                    break;
            }
        }
        v(a, b = false) {
            let c = (this.m || b) ? this.o : this.ai;
            let d = (this.m || b) ? this.q : this.am;
            this.aq(c, a);
            this.af(c, a);
            d.add(a);
            a.transactionID = TransactionService.ao++;
            if (!this.m && !b) {
                let e = new TransactionHistory();
                e.transactions.add(a);
                this.an.insert(0, e);
                this.al.clear();
                this.aa(3, e);
            }
        }
        w(a, b = null) {
            if (b != null) {
                for (let c = 0; c < this.am.count; c++) {
                    if (this.am._inner[c].id == b) {
                        this.am.removeAt(c);
                        c--;
                    }
                }
                this.ai.removeItem(b);
                for (let d = 0; d < this.an.count; d++) {
                    for (let e = 0; e < this.an._inner[d].transactions.count; e++) {
                        if (this.an._inner[d].transactions._inner[e].id == b) {
                            this.an._inner[d].transactions.removeAt(e);
                            e--;
                        }
                    }
                    if (this.an._inner[d].transactions.count == 0) {
                        this.an.removeAt(d);
                        d--;
                    }
                }
            }
            else {
                if (this.aj != null) {
                    this.ai = new Dictionary$2(Base.$, TransactionState.$, 2, this.aj);
                }
                else {
                    this.ai = new Dictionary$2(Base.$, TransactionState.$, 0);
                }
                this.am.clear();
                this.an.clear();
            }
            this.al.clear();
            super.w(a, b);
        }
        g(a) {
            let b = this.m ? this.o : this.ai;
            if (b.count > 0 && b.containsKey(a)) {
                return b.item(a);
            }
            return null;
        }
        ah(a) {
            return super.g(a);
        }
        ag(a) {
            for (let b = this.ak.count - 1; b >= 0; b--) {
                if (this.ak._inner[b].b.containsKey(a)) {
                    return this.ak._inner[b].b.item(a);
                }
            }
            return null;
        }
        y(a) {
            this.m = false;
            if (a) {
                let b = new TransactionHistory();
                for (let c = 0; c < this.q.count; c++) {
                    let d = this.q._inner[c];
                    let e = this.o.item(d.id);
                    this.am.add(d);
                    this.af(this.ai, d);
                    b.transactions.add(d);
                }
                this.an.insert(0, b);
                this.al.clear();
            }
            super.y(a);
        }
        ap(a) {
            for (let b = 0; b < this.q.count; b++) {
                let c = this.q._inner[b];
                if (c.transactionID == a) {
                    this.am.add(c);
                    this.af(this.ai, c);
                    this.q.removeAt(b);
                    this.o.clear();
                    for (let d = 0; d < this.q.count; d++) {
                        this.af(this.o, this.q._inner[d]);
                    }
                    let e = new TransactionHistory();
                    e.transactions.add(c);
                    this.an.insert(0, e);
                    this.al.clear();
                    break;
                }
            }
        }
        s(a, b) {
            let c = -1;
            if (this.ai.count > 0) {
                let d = new TransactionCommit();
                d.id = TransactionService.ao++;
                d.a = this.a(-1);
                d.b = this.ai;
                d.d = -1;
                if (a) {
                    d.d = this.ak.count;
                    this.ak.add(d);
                }
                else {
                    this.aa(5, d);
                }
                c = d.id;
            }
            this.w(b, null);
            return c;
        }
        u(a) {
            let b = this.e(a);
            if (b != null) {
                this.aa(5, b);
                this.ak.removeAt(b.d);
            }
        }
        ac(a) {
            let b = this.e(a);
            if (b != null) {
                this.ak.removeAt(b.d);
            }
        }
        ae() {
            if (this.k) {
                let a = this.an._inner[0];
                this.an.removeAt(0);
                let b = this.am.count - a.transactions.count;
                this.am.v(b, a.transactions.count);
                this.al.insert(0, a);
                this.ai.clear();
                for (let c = 0; c < this.an.count; c++) {
                    for (let d = 0; d < this.an._inner[c].transactions.count; d++) {
                        this.af(this.ai, this.an._inner[c].transactions._inner[d]);
                    }
                }
                this.aa(0, a);
            }
        }
        ab() {
            if (this.j) {
                let a = this.al._inner[0];
                this.al.removeAt(0);
                for (let b = 0; b < a.transactions.count; b++) {
                    this.af(this.ai, a.transactions._inner[b]);
                    this.am.add(a.transactions._inner[b]);
                }
                this.an.insert(0, a);
                this.aa(1, a);
            }
        }
        a(a = -1) {
            let b = new List$1(TransactionState.$, 0);
            if (a > -1) {
                let c = this.e(a);
                if (c != null) {
                    for (let d of fromEnum(c.b.values)) {
                        b.add(d);
                    }
                }
            }
            else {
                for (let e of fromEnum(this.ai.values)) {
                    b.add(e);
                }
            }
            return b.toArray();
        }
        e(a) {
            for (let b = 0; b < this.ak.count; b++) {
                if (this.ak._inner[b].id == a) {
                    return this.ak._inner[b];
                }
            }
            return null;
        }
        c(a = null) {
            if (a != null) {
                let b = new List$1(Transaction.$, 0);
                for (let c = 0; c < this.q.count; c++) {
                    if (this.q._inner[c].id == a || this.aj.equalsC(this.q._inner[c].id, a)) {
                        b.add(this.q._inner[c]);
                    }
                }
                return b.toArray();
            }
            return this.q.toArray();
        }
    }
    TransactionService.$t = /*@__PURE__*/ markType(TransactionService, 'TransactionService', BaseTransactionService.$);
    TransactionService.ao = 0;
    return TransactionService;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransactionKeyEqualityComparer = /*@__PURE__*/ (() => {
    class TransactionKeyEqualityComparer extends Base {
        equalsC(a, b) {
            let c = a;
            let d = b;
            if (c.length != d.length) {
                return false;
            }
            for (let e = 0; e < c.length; e++) {
                if (c[e] == null && d[e] != null) {
                    return false;
                }
                if (c[e] != null && d[e] == null) {
                    return false;
                }
                if (c[e] != d[e]) {
                    if (!Base.equalsStatic(c[e], d[e])) {
                        return false;
                    }
                }
            }
            return true;
        }
        getHashCodeC(a) {
            let b = 0;
            let c = a;
            for (let d = 0; d < c.length; d++) {
                if (c[d] != null) {
                    b += Base.getHashCodeStatic(c[d]);
                }
            }
            return b;
        }
    }
    TransactionKeyEqualityComparer.$t = /*@__PURE__*/ markType(TransactionKeyEqualityComparer, 'TransactionKeyEqualityComparer', Base.$, [/*@__PURE__*/ IEqualityComparer$1_$type.specialize(Base.$)]);
    return TransactionKeyEqualityComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastIterationDictionary$2 = /*@__PURE__*/ (() => {
    class FastIterationDictionary$2 extends Base {
        constructor($tKey, $tValue, a, ..._rest) {
            super();
            this.$tKey = null;
            this.$tValue = null;
            this.k = null;
            this.o = null;
            this.q = null;
            this.p = null;
            this.l = null;
            this.c = false;
            this.$tKey = $tKey;
            this.$tValue = $tValue;
            this.$type = this.$type.specialize(this.$tKey, this.$tValue);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [null];
                        {
                            let e = c[0];
                            this.k = new Dictionary$2(this.$tKey, this.$tValue, 2, e);
                            this.o = new List$1(this.$tKey, 0);
                            this.q = new List$1(this.$tValue, 0);
                            this.l = new Dictionary$2(this.$tKey, Number_$type, 0);
                            this.p = new List$1(Boolean_$type, 0);
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.k = new Dictionary$2(this.$tKey, this.$tValue, 2, c);
                        this.o = new List$1(this.$tKey, 0);
                        this.q = new List$1(this.$tValue, 0);
                        this.l = new Dictionary$2(this.$tKey, Number_$type, 0);
                        this.p = new List$1(Boolean_$type, 0);
                    }
                    break;
            }
        }
        s(a, b) {
            this.k.addItem(a, b);
            this.o.add(a);
            this.q.add(b);
            this.l.addItem(a, this.o.count - 1);
            this.p.add(false);
        }
        i() {
            for (let a = 0; a < this.o.count; a++) {
                if (this.p._inner[a]) {
                    continue;
                }
                if (this.item(this.o._inner[a]) != this.q._inner[a]) {
                    return false;
                }
            }
            return true;
        }
        e() {
            let a = new HashSet$1(this.$tValue, 0);
            for (let b = 0; b < this.q.count; b++) {
                if (this.p._inner[b]) {
                    continue;
                }
                if (a.contains(this.q._inner[b])) {
                    return true;
                }
                a.add_1(this.q._inner[b]);
            }
            return false;
        }
        j(a) {
            for (let b = 0; b < this.q.count; b++) {
                if (this.p._inner[b]) {
                    continue;
                }
                let c = a(this.q._inner[b]);
                if (!Base.equalsStatic(c, getBoxIfEnum(this.$tKey, this.o._inner[b]))) {
                    return false;
                }
            }
            return true;
        }
        u() {
            this.k.clear();
            this.o.clear();
            this.q.clear();
            this.l.clear();
            this.p.clear();
        }
        d(a) {
            return this.k.containsKey(a);
        }
        get r() {
            return this.k.count;
        }
        get m() {
            return this.k.keys;
        }
        get g() {
            return this.c;
        }
        set g(a) {
            this.c = a;
            if (this.p.count > (this.l.count * 3)) {
                this.t();
            }
        }
        f(a) {
            let b = this.k.removeItem(a);
            if (b) {
                let c = this.l.item(a);
                this.p._inner[c] = true;
                this.l.removeItem(a);
                if (this.p.count > (this.l.count * 3)) {
                    this.t();
                }
                return b;
            }
            return b;
        }
        t() {
            if (this.g) {
                return;
            }
            let a = this.p.count;
            let b = 0;
            let c = new List$1(this.$tKey, 0);
            let d = new List$1(this.$tValue, 0);
            let e = new List$1(Boolean_$type, 0);
            for (let f = 0; f < a; f++) {
                if (this.p._inner[f]) {
                    continue;
                }
                else {
                    this.l.removeItem(this.o._inner[f]);
                    this.l.addItem(this.o._inner[f], b);
                    c.add(this.o._inner[f]);
                    d.add(this.q._inner[f]);
                    e.add(false);
                    b++;
                }
            }
            this.o = c;
            this.q = d;
            this.p = e;
        }
        h(a, b) {
            return {
                ret: ((() => { let c = this.k.tryGetValue(a, b); b = c.p1; return c.ret; })()),
                p1: b
            };
        }
        b(a) {
            return this.k.f(a);
        }
        get n() {
            return this.k.values;
        }
        item(a, b) {
            if (arguments.length === 2) {
                if (!this.d(a)) {
                    this.s(a, b);
                }
                else {
                    this.k.item(a, b);
                    let c = this.l.item(a);
                    this.q._inner[c] = b;
                    this.p._inner[c] = false;
                }
                return b;
            }
            else {
                return this.k.item(a);
            }
        }
    }
    FastIterationDictionary$2.$t = /*@__PURE__*/ markType(FastIterationDictionary$2, 'FastIterationDictionary$2');
    return FastIterationDictionary$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSpecialRow = /*@__PURE__*/ (() => {
    class DataSourceSpecialRow extends Base {
        constructor() {
            super(...arguments);
            this.$$isSpecialRow = true;
            this.j = new FastIterationDictionary$2(String_$type, Base.$, 0);
            this.i = new FastIterationDictionary$2(String_$type, Base.$, 0);
            this._rowType = 0;
            this._targetRow = null;
            this._level = 0;
            this._summaryResults = null;
        }
        get rowType() {
            return this._rowType;
        }
        set rowType(a) {
            this._rowType = a;
        }
        get keys() {
            let a = new List$1(String_$type, 0);
            for (let b = 0; b < this.j.o.count; b++) {
                if (this.j.p._inner[b]) {
                    continue;
                }
                a.add(this.j.o._inner[b]);
            }
            return a.toArray();
        }
        get values() {
            let a = new List$1(Base.$, 0);
            for (let b = 0; b < this.j.q.count; b++) {
                if (this.j.p._inner[b]) {
                    continue;
                }
                a.add1(this.j.q._inner[b]);
            }
            return a.toArray();
        }
        get sectionKeys() {
            let a = new List$1(String_$type, 0);
            for (let b = 0; b < this.i.o.count; b++) {
                if (this.i.p._inner[b]) {
                    continue;
                }
                a.add(this.i.o._inner[b]);
            }
            return a.toArray();
        }
        get sectionValues() {
            let a = new List$1(Base.$, 0);
            for (let b = 0; b < this.i.q.count; b++) {
                if (this.i.p._inner[b]) {
                    continue;
                }
                a.add1(this.i.q._inner[b]);
            }
            return a.toArray();
        }
        get targetRow() {
            return this._targetRow;
        }
        set targetRow(a) {
            this._targetRow = a;
        }
        get level() {
            return this._level;
        }
        set level(a) {
            this._level = a;
        }
        get summaryResults() {
            return this._summaryResults;
        }
        set summaryResults(a) {
            this._summaryResults = a;
        }
        getValue(a) {
            if (a == "SectionInformation") {
                return this.i;
            }
            let b = null;
            if (((() => { let c = this.j.h(a, b); b = c.p1; return c.ret; })())) {
                return b;
            }
            b = this.getSummaryValue(a);
            return b;
        }
        getSectionValue(a) {
            if (a == "SectionInformation") {
                return this.i;
            }
            let b = null;
            if (((() => { let c = this.i.h(a, b); b = c.p1; return c.ret; })())) {
                return b;
            }
            b = this.getSummaryValue(a);
            return b;
        }
        setValue(a, b) {
            this.j.item(a, b);
        }
        setSectionValue(a, b) {
            this.i.item(a, b);
        }
        getSectionKeys() {
            let a = new Array(this.i.r);
            let b = 0;
            for (let c of fromEnum(this.i.m)) {
                a[b] = c;
                b++;
            }
            return a;
        }
        getSummaryValue(a) {
            if (this.summaryResults != null) {
                for (let b = 0; b < this.summaryResults.length; b++) {
                    if (this.summaryResults[b] != null && this.summaryResults[b].propertyName == a) {
                        return this.summaryResults[b].value;
                    }
                }
            }
            return null;
        }
        getSummaryResults(a) {
            if (stringIsNullOrWhiteSpace(a)) {
                return this.summaryResults;
            }
            let b = new List$1(ISummaryResult_$type, 0);
            for (let c = 0; c < this.summaryResults.length; c++) {
                if (this.summaryResults[c] != null && this.summaryResults[c].propertyName == a) {
                    b.add(this.summaryResults[c]);
                }
            }
            return b.toArray();
        }
        l(a) {
            if (a.rowType != 1) {
                return false;
            }
            if (a.i.r != this.i.r) {
                return false;
            }
            for (let b = 0; b < a.i.o.count; b++) {
                let c = a.i.o._inner[b];
                let d = a.i.q._inner[b];
                if (!this.i.d(c)) {
                    return false;
                }
                if (this.i.item(c) == null) {
                    if (this.i.item(c) != d) {
                        return false;
                    }
                    continue;
                }
                if (!Base.equalsStatic(this.i.item(c), d)) {
                    return false;
                }
            }
            return true;
        }
        equals(a) {
            let b = typeCast(DataSourceSpecialRow.$, a);
            if (b != null) {
                if (this.rowType == 1 && b.rowType == 1) {
                    return this.l(b);
                }
                else if (this.rowType == 3 && b.rowType == 3) {
                    return this.targetRow == b.targetRow;
                }
            }
            return super.equals(a);
        }
        getHashCode() {
            if (this.rowType == 1) {
                let a = 0;
                for (let b = 0; b < this.i.q.count; b++) {
                    a = a * 17 + this.o(this.i.o._inner[b]);
                    a = a * 17 + this.o(this.i.q._inner[b]);
                }
                return a;
            }
            return super.getHashCode();
        }
        o(val_) {
            if (val_ == null) {
                return 0;
            }
            return Base.getHashCodeStatic(val_);
        }
    }
    DataSourceSpecialRow.$t = /*@__PURE__*/ markType(DataSourceSpecialRow, 'DataSourceSpecialRow');
    return DataSourceSpecialRow;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceAggregatedResult = /*@__PURE__*/ (() => {
    class DataSourceAggregatedResult extends Base {
        constructor() {
            super(...arguments);
            this._item = null;
            this._transactionType = 0;
            this._keys = null;
            this._values = null;
        }
        get item() {
            return this._item;
        }
        set item(a) {
            this._item = a;
        }
        get transactionType() {
            return this._transactionType;
        }
        set transactionType(a) {
            this._transactionType = a;
        }
        get keys() {
            return this._keys;
        }
        set keys(a) {
            this._keys = a;
        }
        get values() {
            return this._values;
        }
        set values(a) {
            this._values = a;
        }
    }
    DataSourceAggregatedResult.$t = /*@__PURE__*/ markType(DataSourceAggregatedResult, 'DataSourceAggregatedResult');
    return DataSourceAggregatedResult;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceDataCommittedEventArgs = /*@__PURE__*/ (() => {
    class DataSourceDataCommittedEventArgs extends EventArgs {
        get commitID() {
            return this._commitID;
        }
        set commitID(a) {
            this._commitID = a;
        }
        get changes() {
            return this._changes;
        }
        set changes(a) {
            this._changes = a;
        }
        constructor(a, b) {
            super();
            this._commitID = 0;
            this._changes = null;
            this.commitID = a;
            this.changes = b;
        }
    }
    DataSourceDataCommittedEventArgs.$t = /*@__PURE__*/ markType(DataSourceDataCommittedEventArgs, 'DataSourceDataCommittedEventArgs', EventArgs.$);
    return DataSourceDataCommittedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Localization = /*@__PURE__*/ (() => {
    class Localization extends Base {
        static register(a, b) {
            if (Localization.c == null) {
                Localization.c = {};
            }
            Localization.c[a] = b;
        }
        static getString(a, b, ...c) {
            let d;
            if (Localization.b != null) {
                d = Localization.b(a, b);
            }
            else {
                let e = null;
                if (Localization.c != null) {
                    e = Localization.c[a];
                }
                if (e != null) {
                    d = (e[b]);
                }
                else {
                    throw new NotSupportedException(1, "string override must be specified for localization");
                }
            }
            if (stringIsNullOrEmpty(d)) {
                d = "";
            }
            else if (c != null && c.length > 0) {
                d = stringFormat1(d, ...c);
            }
            return d;
        }
        static setString(a, b, c) {
            let d = null;
            if (Localization.c != null) {
                d = Localization.c[a];
            }
            if (d != null) {
                d[b] = c;
            }
            else {
                throw new NotSupportedException(1, "locale set for " + a + " was not loaded.");
            }
        }
        static isRegistered(a) {
            return (Localization.c && Localization.c[a] !== undefined);
        }
        static d(a) {
            let b = (navigator.language ? navigator.language.toLowerCase() : "");
            let c = a + "-";
            while (true) {
                if (Localization.isRegistered(c + b)) {
                    return b;
                }
                let d = Localization.e(b);
                if (d != null && Localization.isRegistered(c + d)) {
                    return d;
                }
                let e = b.lastIndexOf('-');
                if (e <= 0) {
                    break;
                }
                b = b.substr(0, e);
            }
            return "en";
        }
        static e(a) {
            switch (a) {
                case "zh-hk":
                case "zh-tw":
                case "zh-mo": return "zh-Hant";
                case "zh-cn":
                case "zh-sg":
                case "zh": return "zh-Hans";
            }
            return null;
        }
    }
    Localization.$t = /*@__PURE__*/ markType(Localization, 'Localization');
    Localization.b = null;
    Localization.c = null;
    return Localization;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceDataProvider_$type = /*@__PURE__*/ new Type(null, 'IDataSourceDataProvider', null, [ISupportsDataChangeNotifications_$type, IDataSourceSupportsCount_$type]);
/**
 * @hidden
 */
let IFilterExpression_$type = /*@__PURE__*/ new Type(null, 'IFilterExpression');
/**
 * @hidden
 */
let FilterExpressionCollection = /*@__PURE__*/ (() => {
    class FilterExpressionCollection extends Base {
        get syncTarget() {
            return this.a;
        }
        set syncTarget(a) {
            if (a == null) {
                this.f.syncTarget = null;
                this.a = null;
                return;
            }
            this.a = a;
            this.f.syncTarget = this.a.f;
        }
        get shouldDetachOnTargetChange() {
            return this.f.shouldDetachOnTargetChange;
        }
        set shouldDetachOnTargetChange(a) {
            this.f.shouldDetachOnTargetChange = a;
        }
        constructor() {
            super();
            this.a = null;
            this.f = null;
            this.f = new SyncableObservableCollection$1(IFilterExpression_$type);
        }
        add(a) {
            return this.f.add(a);
        }
        insert(a, b) {
            this.f.add1(a, b);
        }
        clear() {
            this.f.clear();
        }
        get(a) {
            return this.f.get(a);
        }
        indexOf(a) {
            return this.f.indexOf(a);
        }
        remove(a) {
            return this.f.remove1(a);
        }
        removeAt(a) {
            return this.f.remove(a);
        }
        set(a, b) {
            return this.f.set(a, b);
        }
        size() {
            return this.f.size();
        }
        get onChanged() {
            return this.f.f;
        }
        set onChanged(a) {
            this.f.f = a;
        }
        n(a) {
            this.f.addListener(a);
        }
        r(a) {
            this.f.removeListener(a);
        }
        o(a) {
            this.f.addOneWayTarget(a.f);
        }
        s(a) {
            this.f.removeOneWayTarget(a.f);
        }
        get k() {
            return this.f.all;
        }
    }
    FilterExpressionCollection.$t = /*@__PURE__*/ markType(FilterExpressionCollection, 'FilterExpressionCollection');
    return FilterExpressionCollection;
})();
/**
 * @hidden
 */
let IDataSource_$type = /*@__PURE__*/ new Type(null, 'IDataSource', null, [ISupportsDataChangeNotifications_$type, IDataSourceSupportsIndexedAccess_$type]);
/**
 * @hidden
 */
let SummaryCalculator = /*@__PURE__*/ (() => {
    class SummaryCalculator extends Base {
        constructor() {
            super(...arguments);
            this._propertyName = null;
            this._propertyType = 0;
            this._dataSource = null;
            this._isSummaryDirty = false;
            this.b = 5;
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get propertyType() {
            return this._propertyType;
        }
        set propertyType(a) {
            this._propertyType = a;
        }
        get dataSource() {
            return this._dataSource;
        }
        set dataSource(a) {
            this._dataSource = a;
        }
        get isSummaryDirty() {
            return this._isSummaryDirty;
        }
        set isSummaryDirty(a) {
            this._isSummaryDirty = a;
        }
        get_operand() {
            return this.b;
        }
        get operand() {
            return this.get_operand();
        }
        beginCalculation(a, b) {
            this.dataSource = a;
            this.propertyName = b;
            if (this.propertyName != null) {
                this.propertyType = a.resolveSchemaPropertyType(this.propertyName);
            }
            this.isSummaryDirty = false;
        }
        endCalculation() {
            return null;
        }
        aggregate(a) {
        }
        itemAdded(a, b, c) {
            return b;
        }
        itemRemoved(a, b, c) {
            return b;
        }
        i(a) {
            if (this.dataSource == null) {
                return NaN;
            }
            let b = this.dataSource.getItemProperty(a, this.propertyName);
            if (b == null) {
                return NaN;
            }
            return this.j(b);
        }
        j(a) {
            if (a == null) {
                return NaN;
            }
            switch (this.propertyType) {
                case 6: return a;
                case 5: return a;
                case 1: return typeGetValue(a);
                case 3: return typeGetValue(a);
                case 4: return typeGetValue(a);
                case 7: return a;
                case 8: return toOADate(a);
                case 11: try {
                    return Convert.toDouble3(a);
                }
                catch (b) {
                    return NaN;
                }
            }
            return 0;
        }
        k(a) {
            switch (this.propertyType) {
                case 6: return a;
                case 5: return a;
                case 1: return truncate(a);
                case 3: return truncate(a);
                case 4: return truncate(a);
                case 7: return a;
                case 8: return fromOADate(a);
                default: return a;
            }
        }
    }
    SummaryCalculator.$t = /*@__PURE__*/ markType(SummaryCalculator, 'SummaryCalculator');
    return SummaryCalculator;
})();
/**
 * @hidden
 */
let SumSummaryCalculator = /*@__PURE__*/ (() => {
    class SumSummaryCalculator extends SummaryCalculator {
        constructor() {
            super(...arguments);
            this.p = 0;
        }
        get_displayName() {
            let a = BaseDataSource.bb("DataSource_Summary_Sum");
            return a != null ? a : "Sum";
        }
        get displayName() {
            return this.get_displayName();
        }
        get_operand() {
            return 2;
        }
        beginCalculation(a, b) {
            super.beginCalculation(a, b);
            this.p = 0;
        }
        endCalculation() {
            return new DefaultSummaryResult(this.propertyName, 2, this.k(this.p));
        }
        aggregate(a) {
            let b = this.i(a);
            if (!isNaN_(b)) {
                this.p += b;
            }
        }
        itemAdded(a, b, c) {
            let d = this.i(a);
            if (isNaN_(d)) {
                d = 0;
            }
            if (b == null) {
                return new DefaultSummaryResult(this.propertyName, 2, this.k(d));
            }
            let e = this.j(b.value) + d;
            return new DefaultSummaryResult(this.propertyName, 2, this.k(e));
        }
        itemRemoved(a, b, c) {
            let d = this.i(a);
            if (isNaN_(d)) {
                d = 0;
            }
            let e = this.j(b.value) - d;
            return new DefaultSummaryResult(this.propertyName, 2, this.k(e));
        }
    }
    SumSummaryCalculator.$t = /*@__PURE__*/ markType(SumSummaryCalculator, 'SumSummaryCalculator', SummaryCalculator.$);
    return SumSummaryCalculator;
})();
/**
 * @hidden
 */
let CountSummaryCalculator = /*@__PURE__*/ (() => {
    class CountSummaryCalculator extends SummaryCalculator {
        constructor() {
            super(...arguments);
            this.p = 0;
        }
        get_displayName() {
            let a = BaseDataSource.bb("DataSource_Summary_Count");
            return a != null ? a : "Count";
        }
        get displayName() {
            return this.get_displayName();
        }
        get_operand() {
            return 4;
        }
        beginCalculation(a, b) {
            super.beginCalculation(a, b);
            this.propertyType = 1;
            this.p = 0;
        }
        endCalculation() {
            return new DefaultSummaryResult(this.propertyName, 4, this.p);
        }
        aggregate(a) {
            this.p++;
        }
        itemAdded(a, b, c) {
            if (b == null) {
                return new DefaultSummaryResult(this.propertyName, 4, 1);
            }
            return new DefaultSummaryResult(this.propertyName, 4, typeGetValue(b.value) + 1);
        }
        itemRemoved(a, b, c) {
            return new DefaultSummaryResult(this.propertyName, 4, typeGetValue(b.value) - 1);
        }
    }
    CountSummaryCalculator.$t = /*@__PURE__*/ markType(CountSummaryCalculator, 'CountSummaryCalculator', SummaryCalculator.$);
    return CountSummaryCalculator;
})();
/**
 * @hidden
 */
let AverageSummaryCalculator = /*@__PURE__*/ (() => {
    class AverageSummaryCalculator extends SummaryCalculator {
        constructor() {
            super(...arguments);
            this.p = 0;
            this.q = 0;
        }
        get_displayName() {
            let a = BaseDataSource.bb("DataSource_Summary_Avg");
            return a != null ? a : "Avg";
        }
        get displayName() {
            return this.get_displayName();
        }
        get_operand() {
            return 3;
        }
        beginCalculation(a, b) {
            super.beginCalculation(a, b);
            this.p = 0;
            this.q = 0;
        }
        endCalculation() {
            let a = this.q > 0 ? this.p / this.q : 0;
            return new DefaultSummaryResult(this.propertyName, 3, this.k(a));
        }
        aggregate(a) {
            let b = this.i(a);
            if (!isNaN_(b)) {
                this.p += b;
                this.q++;
            }
        }
        itemAdded(a, b, c) {
            let d = this.i(a);
            if (isNaN_(d)) {
                d = 0;
            }
            if (b == null) {
                return new DefaultSummaryResult(this.propertyName, 3, this.k(d));
            }
            let e = this.j(b.value) * (c - 1);
            let f = (e + d) / c;
            return new DefaultSummaryResult(this.propertyName, 3, this.k(f));
        }
        itemRemoved(a, b, c) {
            let d = this.i(a);
            if (isNaN_(d)) {
                d = 0;
            }
            let e = this.j(b.value) * (c + 1);
            let f = (e - d) / c;
            return new DefaultSummaryResult(this.propertyName, 3, this.k(f));
        }
    }
    AverageSummaryCalculator.$t = /*@__PURE__*/ markType(AverageSummaryCalculator, 'AverageSummaryCalculator', SummaryCalculator.$);
    return AverageSummaryCalculator;
})();
/**
 * @hidden
 */
let MaxSummaryCalculator = /*@__PURE__*/ (() => {
    class MaxSummaryCalculator extends SummaryCalculator {
        constructor() {
            super(...arguments);
            this.p = null;
        }
        get_displayName() {
            let a = BaseDataSource.bb("DataSource_Summary_Max");
            return a != null ? a : "Max";
        }
        get displayName() {
            return this.get_displayName();
        }
        get_operand() {
            return 1;
        }
        beginCalculation(a, b) {
            super.beginCalculation(a, b);
            this.p = null;
        }
        endCalculation() {
            return new DefaultSummaryResult(this.propertyName, 1, this.p);
        }
        aggregate(a) {
            this.p = this.q(a, this.p);
        }
        itemAdded(a, b, c) {
            if (b == null) {
                return new DefaultSummaryResult(this.propertyName, 1, this.q(a, null));
            }
            let d = this.q(a, b.value);
            return new DefaultSummaryResult(this.propertyName, 1, d);
        }
        itemRemoved(a, b, c) {
            let d = this.dataSource.getItemProperty(a, this.propertyName);
            if (Base.equalsStatic(d, b.value)) {
                this.isSummaryDirty = true;
            }
            return b;
        }
        q(a, b) {
            let c = this.dataSource.getItemProperty(a, this.propertyName);
            if (b == null) {
                return c;
            }
            if (c == null) {
                return b;
            }
            switch (this.propertyType) {
                case 0:
                    b = stringCompare(c, b) > 0 ? c : b;
                    break;
                case 6:
                    b = c > b ? c : b;
                    break;
                case 5:
                    b = c > b ? c : b;
                    break;
                case 1:
                    b = (typeGetValue(c)) > (typeGetValue(b)) ? c : b;
                    break;
                case 3:
                    b = (typeGetValue(c)) > (typeGetValue(b)) ? c : b;
                    break;
                case 4:
                    b = (typeGetValue(c)) > (typeGetValue(b)) ? c : b;
                    break;
                case 7:
                    b = c > b ? c : b;
                    break;
                case 2:
                    b = c ? c : b;
                    break;
                case 10:
                    b = (typeGetValue(c)) > (typeGetValue(b)) ? c : b;
                    break;
                case 8:
                    let xVal_ = c;
                    let yVal_ = b;
                    xVal_ = +xVal_;
                    yVal_ = +yVal_;
                    let d = typeGetValue(xVal_);
                    let e = typeGetValue(yVal_);
                    b = Base.compareSimple(d, e) > 0 ? c : b;
                    break;
            }
            return b;
        }
    }
    MaxSummaryCalculator.$t = /*@__PURE__*/ markType(MaxSummaryCalculator, 'MaxSummaryCalculator', SummaryCalculator.$);
    return MaxSummaryCalculator;
})();
/**
 * @hidden
 */
let MinSummaryCalculator = /*@__PURE__*/ (() => {
    class MinSummaryCalculator extends SummaryCalculator {
        constructor() {
            super(...arguments);
            this.p = null;
        }
        get_displayName() {
            let a = BaseDataSource.bb("DataSource_Summary_Min");
            return a != null ? a : "Min";
        }
        get displayName() {
            return this.get_displayName();
        }
        get_operand() {
            return 0;
        }
        beginCalculation(a, b) {
            super.beginCalculation(a, b);
            this.p = null;
        }
        endCalculation() {
            return new DefaultSummaryResult(this.propertyName, 0, this.p);
        }
        aggregate(a) {
            this.p = this.q(a, this.p);
        }
        itemAdded(a, b, c) {
            if (b == null) {
                return new DefaultSummaryResult(this.propertyName, 0, this.q(a, null));
            }
            let d = this.q(a, b.value);
            return new DefaultSummaryResult(this.propertyName, 0, d);
        }
        itemRemoved(a, b, c) {
            let d = this.dataSource.getItemProperty(a, this.propertyName);
            if (Base.equalsStatic(d, b.value)) {
                this.isSummaryDirty = true;
            }
            return b;
        }
        q(a, b) {
            let c = this.dataSource.getItemProperty(a, this.propertyName);
            if (b == null) {
                return c;
            }
            if (c == null) {
                return b;
            }
            switch (this.propertyType) {
                case 0:
                    b = stringCompare(c, b) < 0 ? c : b;
                    break;
                case 6:
                    b = c < b ? c : b;
                    break;
                case 5:
                    b = c < b ? c : b;
                    break;
                case 1:
                    b = (typeGetValue(c)) < (typeGetValue(b)) ? c : b;
                    break;
                case 3:
                    b = (typeGetValue(c)) < (typeGetValue(b)) ? c : b;
                    break;
                case 4:
                    b = (typeGetValue(c)) < (typeGetValue(b)) ? c : b;
                    break;
                case 7:
                    b = c < b ? c : b;
                    break;
                case 2:
                    b = !c ? c : b;
                    break;
                case 10:
                    b = (typeGetValue(c)) < (typeGetValue(b)) ? c : b;
                    break;
                case 8:
                    let xVal_ = c;
                    let yVal_ = b;
                    xVal_ = +xVal_;
                    yVal_ = +yVal_;
                    let d = typeGetValue(xVal_);
                    let e = typeGetValue(yVal_);
                    b = Base.compareSimple(d, e) < 0 ? c : b;
                    break;
            }
            return b;
        }
    }
    MinSummaryCalculator.$t = /*@__PURE__*/ markType(MinSummaryCalculator, 'MinSummaryCalculator', SummaryCalculator.$);
    return MinSummaryCalculator;
})();
/**
 * @hidden
 */
let SummaryDescription = /*@__PURE__*/ (() => {
    class SummaryDescription extends Base {
        constructor(a, ..._rest) {
            super();
            this.h = false;
            this.k = null;
            this.a = 0;
            this._alias = null;
            this.d = null;
            this.provideCalculator = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        this.propertyName = c;
                        this.operand = 4;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.propertyName = c;
                        this.operand = d;
                    }
                    break;
            }
        }
        get propertyName() {
            return this.k;
        }
        set propertyName(a) {
            this.k = a;
        }
        get operand() {
            return this.a;
        }
        set operand(a) {
            this.a = a;
            switch (this.a) {
                case 0:
                    this.calculator = new MinSummaryCalculator();
                    break;
                case 1:
                    this.calculator = new MaxSummaryCalculator();
                    break;
                case 2:
                    this.calculator = new SumSummaryCalculator();
                    break;
                case 3:
                    this.calculator = new AverageSummaryCalculator();
                    break;
                case 4:
                    this.calculator = new CountSummaryCalculator();
                    break;
            }
        }
        get alias() {
            return this._alias;
        }
        set alias(a) {
            this._alias = a;
        }
        get calculator() {
            return this.d;
        }
        set calculator(a) {
            this.d = a;
        }
        equals(a) {
            let b = a;
            if (b == null) {
                return super.equals(a);
            }
            return b.propertyName == this.propertyName && b.operand == this.operand;
        }
        getHashCode() {
            return Base.getHashCodeStatic(this.propertyName) * 17 + this.operand;
        }
        n() {
            this.h = true;
        }
        g() {
            if (this.provideCalculator != null) {
                let a = new ProvideCalculatorEventArgs();
                this.provideCalculator(this, a);
                return a.a;
            }
            return null;
        }
        f() {
            switch (this.a) {
                case 0: return new MinSummaryCalculator();
                case 1: return new MaxSummaryCalculator();
                case 2: return new SumSummaryCalculator();
                case 3: return new AverageSummaryCalculator();
                case 4: return new CountSummaryCalculator();
                case 5:
                    let a = this.g();
                    if (a == null) {
                        throw new ArgumentNullException(2, "Calculator", "No custom calculator was provided.");
                    }
                    return a;
            }
            return null;
        }
    }
    SummaryDescription.$t = /*@__PURE__*/ markType(SummaryDescription, 'SummaryDescription');
    return SummaryDescription;
})();
/**
 * @hidden
 */
let SummaryDescriptionCollection = /*@__PURE__*/ (() => {
    class SummaryDescriptionCollection extends Base {
        g() {
            return this.f;
        }
        get syncTarget() {
            return this.d;
        }
        set syncTarget(a) {
            if (a == null) {
                this.f.syncTarget = null;
                this.d = null;
                return;
            }
            this.d = a;
            this.f.syncTarget = this.d.f;
        }
        constructor() {
            super();
            this.d = null;
            this.f = null;
            this.f = new SyncableObservableCollection$1(SummaryDescription.$);
        }
        add(a) {
            return this.f.add(a);
        }
        insert(a, b) {
            this.f.add1(a, b);
        }
        clear() {
            this.f.clear();
        }
        get(a) {
            return this.f.get(a);
        }
        indexOf(a) {
            return this.f.indexOf(a);
        }
        remove(a) {
            return this.f.remove1(a);
        }
        removeAt(a) {
            return this.f.remove(a);
        }
        set(a, b) {
            return this.f.set(a, b);
        }
        size() {
            return this.f.size();
        }
        n(a) {
            this.f.addListener(a);
        }
        r(a) {
            this.f.removeListener(a);
        }
        o(a) {
            this.f.addOneWayTarget(a.f);
        }
        s(a) {
            this.f.removeOneWayTarget(a.f);
        }
        get onChanged() {
            return this.f.f;
        }
        set onChanged(a) {
            this.f.f = a;
        }
        get k() {
            return this.f.all;
        }
    }
    SummaryDescriptionCollection.$t = /*@__PURE__*/ markType(SummaryDescriptionCollection, 'SummaryDescriptionCollection');
    return SummaryDescriptionCollection;
})();
/**
 * @hidden
 */
let ProvideCalculatorEventArgs = /*@__PURE__*/ (() => {
    class ProvideCalculatorEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
        }
    }
    ProvideCalculatorEventArgs.$t = /*@__PURE__*/ markType(ProvideCalculatorEventArgs, 'ProvideCalculatorEventArgs');
    return ProvideCalculatorEventArgs;
})();
/**
 * @hidden
 */
let BaseDataSource = /*@__PURE__*/ (() => {
    class BaseDataSource extends Base {
        constructor() {
            super();
            this.v = null;
            this._isReadOnly = false;
            this.aa = false;
            this.dataCommitted = null;
            this.aq = false;
            this.a0 = null;
            this._externalDataSource = null;
            this.t = null;
            this.s = null;
            this.j = null;
            this.u = null;
            this.k = null;
            this.p = null;
            this.au = 0;
            this.av = 0;
            this.aw = 0;
            this.q = null;
            this.propertyChanged = null;
            this.m = null;
            this.o = null;
            this.schemaChanged = null;
            this.rowExpansionChanged = null;
            this.ab = false;
            this.i = 0;
            this.y = false;
            this.b = null;
            this.a = null;
            this.c = null;
            this.e = null;
            this.ah = false;
            this.ai = false;
            this.w = false;
            this.h = 0;
            this.ac = true;
            this.ae = true;
            this.z = false;
            this.ag = false;
            this.af = false;
            this.ad = true;
            this.ak = true;
            this.aj = false;
            this.al = true;
            this.am = true;
            this.x = false;
            this.d = null;
            this.m = new DefaultDataSourceDataProviderUpdateNotifier(this);
            this.t = new SortDescriptionCollection();
            this.s = new SortDescriptionCollection();
            this.u = new SummaryDescriptionCollection();
            this.t.n(runOn(this, this.cv));
            this.s.n(runOn(this, this.bz));
            this.u.n(runOn(this, this.cw));
            this.j = new FilterExpressionCollection();
            this.j.n(runOn(this, this.bx));
            this.v = new TransactionService(runOn(this, this.b1), runOn(this, this.clone1), new TransactionKeyEqualityComparer());
            let a = this.v;
            a.stateChanged = delegateCombine(a.stateChanged, runOn(this, this.cr));
        }
        cr(a, b) {
            if (a == 0 || a == 1) {
                if (this.updateNotifier != null) {
                    let c = b;
                    let d = c.transactions._inner[0];
                    if (d.type == 1 || d.type == TransactionType.Delete) {
                        let e = d.id;
                        let f = this.indexOfKey(e);
                        if (f > -1) {
                            let g = this.getItemAtIndex(f);
                            this.updateNotifier.notifySetItem(f, g, g);
                            let h = this.getStickyRows();
                            if (h != null) {
                                for (let i = 0; i < h.length; i++) {
                                    let j = h[i];
                                    let k = typeCast(DataSourceSpecialRow.$, this.getItemAtIndex(j));
                                    if (k != null && k.rowType == 3 && k.targetRow == g) {
                                        this.updateNotifier.notifySetItem(j, k, k);
                                        break;
                                    }
                                }
                            }
                        }
                    }
                    else if (d.type == 0) {
                    }
                }
            }
            this.cq(a, b);
        }
        cq(a, b) {
        }
        ar() {
            return !this.isReadOnly && this.actualPrimaryKey != null && this.actualBaseDataProvider != null && this.v != null;
        }
        b1(a, b) {
            if (a != null && b != null) {
                let c = a;
                let d = b;
                for (let e of fromEnum(d)) {
                    if (c.containsKey(e.key)) {
                        c.item(e.key, e.value);
                    }
                    else {
                        c.addItem(e.key, e.value);
                    }
                }
            }
        }
        clone1(a) {
            if (a != null) {
                let b = a;
                let c = new Dictionary$2(String_$type, Base.$, 0);
                for (let d of fromEnum(b)) {
                    c.addItem(d.key, d.value);
                }
                return c;
            }
            return null;
        }
        get isReadOnly() {
            return this._isReadOnly;
        }
        set isReadOnly(a) {
            this._isReadOnly = a;
        }
        get_isBatchingEnabled() {
            return this.aa;
        }
        set_isBatchingEnabled(a) {
            this.aa = a;
        }
        get isBatchingEnabled() {
            return this.get_isBatchingEnabled();
        }
        set isBatchingEnabled(a) {
            this.set_isBatchingEnabled(a);
        }
        get canUndo() {
            return this.v.k;
        }
        get canRedo() {
            return this.v.j;
        }
        get canCommit() {
            return this.v.a(-1).length > 0;
        }
        updatePropertyAtKey(a, b, c, d = false) {
            if (this.ar()) {
                let e = null;
                if (a.length == 1 && typeCast(DataSourceSpecialRow.$, a[0]) !== null) {
                    let f = a[0];
                    if (f.rowType == 3) {
                        e = f;
                        if (this.actualPrimaryKey != null) {
                            a = new Array(this.actualPrimaryKey.length);
                            this.getPrimaryKeyValue(e.targetRow, a);
                        }
                        else {
                            a = [e.targetRow];
                        }
                    }
                }
                let g = new Dictionary$2(String_$type, Base.$, 0);
                g.addItem(b, c);
                let h = new Transaction();
                h.id = a;
                h.value = g;
                h.type = 1;
                this.v.v(h, d);
                if (this.isBatchingEnabled || d) {
                    if (this.updateNotifier != null) {
                        let i = this.indexOfKey(a);
                        if (i > -1) {
                            let j = this.getItemAtIndex(i);
                            this.updateNotifier.notifySetItem(i, j, j);
                        }
                        if (this.isRowPinned(i)) {
                            let k = -1;
                            if (e != null) {
                                k = this.indexOfItem(e);
                            }
                            else {
                                let l = this.getStickyRows();
                                if (l != null) {
                                    for (let m = 0; m < l.length; m++) {
                                        let n = typeCast(DataSourceSpecialRow.$, this.getItemAtIndex(l[m]));
                                        if (n != null && n.rowType == 3) {
                                            e = n;
                                            k = l[m];
                                            break;
                                        }
                                    }
                                }
                            }
                            if (k > -1) {
                                this.updateNotifier.notifySetItem(k, e, e);
                            }
                        }
                    }
                }
                return h.transactionID;
            }
            return -1;
        }
        removeItemByKey(a) {
            if (this.ar()) {
                let b = null;
                if (a.length == 1 && typeCast(DataSourceSpecialRow.$, a[0]) !== null) {
                    let c = a[0];
                    if (c.rowType == 3) {
                        b = c;
                        if (this.actualPrimaryKey != null) {
                            a = new Array(this.actualPrimaryKey.length);
                            this.getPrimaryKeyValue(b.targetRow, a);
                        }
                        else {
                            a = [b.targetRow];
                        }
                    }
                }
                let d = new Transaction();
                d.id = a;
                d.type = TransactionType.Delete;
                this.v.v(d, false);
                if (this.isBatchingEnabled) {
                    if (this.updateNotifier != null) {
                        let e = this.indexOfKey(a);
                        if (e > -1) {
                            let f = this.getItemAtIndex(e);
                            this.updateNotifier.notifySetItem(e, f, f);
                        }
                        if (this.isRowPinned(e)) {
                            let g = -1;
                            if (b != null) {
                                g = this.indexOfItem(b);
                            }
                            else {
                                let h = this.getStickyRows();
                                if (h != null) {
                                    for (let i = 0; i < h.length; i++) {
                                        let j = typeCast(DataSourceSpecialRow.$, this.getItemAtIndex(h[i]));
                                        if (j != null && j.rowType == 3) {
                                            b = j;
                                            g = h[i];
                                            break;
                                        }
                                    }
                                }
                            }
                            if (g > -1) {
                                this.updateNotifier.notifySetItem(g, b, b);
                            }
                        }
                    }
                }
            }
        }
        removeItem(a) {
            if (this.ar()) {
                let b;
                if (typeCast(DataSourceSpecialRow.$, a) !== null) {
                    b = [a];
                }
                else if (this.actualPrimaryKey == null || this.actualPrimaryKey.length < 1) {
                    b = [a];
                }
                else {
                    b = new Array(this.actualPrimaryKey.length);
                    this.getPrimaryKeyValue(a, b);
                }
                this.removeItemByKey(b);
            }
        }
        addItem(a) {
            if (this.ar()) {
                if (typeCast(DataSourceSpecialRow.$, a) !== null) {
                    return;
                }
                let b = new Transaction();
                b.id = [a];
                b.type = 0;
                this.v.v(b, false);
            }
        }
        acceptPendingTransaction(a) {
            if (this.ar()) {
                let b = this.v.d(a);
                if (b != null) {
                    this.v.ap(a);
                }
            }
        }
        rejectPendingTransaction(a) {
            if (this.ar()) {
                let b = this.v.d(a);
                if (b != null) {
                    this.v.x(a);
                    if (this.updateNotifier != null) {
                        if (b.type != 0) {
                            let c = b.id;
                            let d = this.indexOfKey(c);
                            if (d > -1) {
                                let e = this.getItemAtIndex(d);
                                this.updateNotifier.notifySetItem(d, e, e);
                                let f = this.getStickyRows();
                                if (f != null) {
                                    for (let g = 0; g < f.length; g++) {
                                        let h = typeCast(DataSourceSpecialRow.$, this.getItemAtIndex(f[g]));
                                        if (h != null && h.rowType == 3) {
                                            if (h.targetRow == e) {
                                                this.updateNotifier.notifySetItem(f[g], h, h);
                                                break;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        commitEdits(a) {
            if (this.ar()) {
                let b = this.v.c(null).length > 0;
                let c = this.v.s(a, this.isBatchingEnabled);
                if (c == -1 && b) {
                    if (this.updateNotifier != null) {
                        this.updateNotifier.notifyClearItems();
                    }
                }
                return c;
            }
            return -1;
        }
        cancelEdits() {
            if (this.ar()) {
                this.v.w(true, null);
                if (this.updateNotifier != null) {
                    this.updateNotifier.notifyClearItems();
                }
            }
        }
        acceptPendingCommit(a) {
            if (this.ar()) {
                let b = this.v.e(a);
                if (b != null) {
                    this.v.u(a);
                    if (this.updateNotifier != null) {
                        for (let c = 0; c < b.a.length; c++) {
                            if (b.a[c].transactionType != 0) {
                                let d = b.a[c].id;
                                let e = this.indexOfKey(d);
                                if (e > -1) {
                                    let f = this.getItemAtIndex(e);
                                    this.updateNotifier.notifySetItem(e, f, f);
                                }
                            }
                        }
                    }
                }
            }
        }
        rejectPendingCommit(a) {
            if (this.ar()) {
                let b = this.v.e(a);
                if (b != null) {
                    this.v.ac(a);
                    if (this.updateNotifier != null) {
                        for (let c = 0; c < b.a.length; c++) {
                            if (b.a[c].transactionType != 0) {
                                let d = b.a[c].id;
                                let e = this.indexOfKey(d);
                                if (e > -1) {
                                    let f = this.getItemAtIndex(e);
                                    this.updateNotifier.notifySetItem(e, f, f);
                                }
                            }
                        }
                    }
                }
            }
        }
        undo() {
            if (this.ar()) {
                this.v.ae();
            }
        }
        redo() {
            if (this.ar()) {
                this.v.ab();
            }
        }
        hasEdit(a, b) {
            if (this.ar()) {
                a = this.g(a);
                let c = this.v.g(a);
                if (c != null) {
                    let d = typeCast(Dictionary$2.$.specialize(String_$type, Base.$), c.value);
                    if (d != null && d.containsKey(b)) {
                        return true;
                    }
                }
                c = this.v.ah(a);
                if (c != null) {
                    let e = typeCast(Dictionary$2.$.specialize(String_$type, Base.$), c.value);
                    if (e != null && e.containsKey(b)) {
                        return true;
                    }
                }
                c = this.v.ag(a);
                if (c != null) {
                    let f = typeCast(Dictionary$2.$.specialize(String_$type, Base.$), c.value);
                    if (f != null && f.containsKey(b)) {
                        return true;
                    }
                }
            }
            return false;
        }
        hasDelete(a) {
            if (this.ar()) {
                a = this.g(a);
                let b = this.v.g(a);
                if (b != null && b.transactionType == TransactionType.Delete) {
                    return true;
                }
                b = this.v.ah(a);
                if (b != null && b.transactionType == TransactionType.Delete) {
                    return true;
                }
                b = this.v.ag(a);
                if (b != null && b.transactionType == TransactionType.Delete) {
                    return true;
                }
            }
            return false;
        }
        hasAdd(a) {
            if (this.ar()) {
                let b = this.v.g(a);
                if (b != null && b.transactionType == 0) {
                    return true;
                }
                b = this.v.ah(a);
                if (b != null && b.transactionType == 0) {
                    return true;
                }
            }
            return false;
        }
        getAggregatedChanges(a) {
            if (this.ar()) {
                let b = this.v.a(a);
                let c = new List$1(DataSourceAggregatedResult.$, 0);
                for (let d = 0; d < b.length; d++) {
                    let e = b[d].id;
                    let f = new DataSourceAggregatedResult();
                    if (b[d].transactionType == 0) {
                        f.transactionType = 0;
                        f.item = e[0];
                    }
                    else if (b[d].transactionType == TransactionType.Delete) {
                        f.transactionType = TransactionType.Delete;
                        let g = this.indexOfKey(e);
                        if (g > -1) {
                            f.item = this.getItemAtIndex(g);
                        }
                        else {
                            f.item = e;
                        }
                    }
                    else if (b[d].transactionType == 1) {
                        f.transactionType = 1;
                        let h = b[d].value;
                        f.keys = new Array(h.count);
                        f.values = new Array(h.count);
                        let i = 0;
                        for (let j of fromEnum(h)) {
                            f.keys[i] = j.key;
                            f.values[i] = j.value;
                            i++;
                        }
                        let k = this.getItemFromKey(e);
                        if (k != null) {
                            f.item = k;
                        }
                        else {
                            f.item = e;
                        }
                    }
                    c.add(f);
                }
                return c.toArray();
            }
            return new Array(0);
        }
        isPendingTransaction(a) {
            return this.v.d(a) != null;
        }
        isPendingCommit(a) {
            return this.v.e(a) != null;
        }
        setTransactionError(a, b) {
            let c = this.v.d(a);
            if (c != null) {
                c.error = b;
                if (this.updateNotifier != null) {
                    let d = c.id;
                    let e = this.indexOfKey(d);
                    if (e > -1) {
                        let f = this.getItemAtIndex(e);
                        this.updateNotifier.notifySetItem(e, f, f);
                    }
                }
            }
        }
        getTransactionErrorByKey(a, b) {
            a = this.g(a);
            let c = this.v.c(a);
            for (let d = 0; d < c.length; d++) {
                if (c[d].error != null) {
                    if (c[d].type == 1) {
                        let e = c[d].value;
                        if (e.containsKey(b)) {
                            return c[d].error;
                        }
                    }
                }
            }
            return null;
        }
        getTransactionErrorByID(a) {
            let b = this.v.d(a);
            if (b != null) {
                return b.error;
            }
            return null;
        }
        getTransactionID(a, b) {
            a = this.g(a);
            let c = this.v.c(a);
            for (let d = 0; d < c.length; d++) {
                if (c[d].type == 1) {
                    let e = c[d].value;
                    if (e.containsKey(b)) {
                        return c[d].transactionID;
                    }
                }
            }
            return -1;
        }
        g(a) {
            if (a.length == 1 && typeCast(DataSourceSpecialRow.$, a[0]) !== null) {
                let b = a[0];
                if (b.rowType == 3) {
                    if (this.actualPrimaryKey != null) {
                        a = new Array(this.actualPrimaryKey.length);
                        this.getPrimaryKeyValue(b.targetRow, a);
                    }
                    else {
                        a = [b.targetRow];
                    }
                }
            }
            return a;
        }
        b2(a, b) {
            if (this.dataCommitted != null) {
                this.dataCommitted(this, new DataSourceDataCommittedEventArgs(a, b));
            }
        }
        static bb(a) {
            let b = Localization.d("DataVisualization");
            let c = stringFormat("DataVisualization-{0}", b);
            return Localization.isRegistered(c) ? Localization.getString(c, a) : null;
        }
        cv(a, b) {
            this.onSortDescriptionsChanged(b);
        }
        bz(a, b) {
            this.onGroupDescriptionsChanged(b);
        }
        cw(a, b) {
            this.onSummaryDescriptionsChanged(b);
        }
        bx(a, b) {
            this.onFilterExpressionsChanged(b);
        }
        onSortDescriptionsChanged(a) {
            this.queueAutoRefresh();
        }
        onGroupDescriptionsChanged(a) {
            if (this.isGroupingSupported) {
                if (this.groupDescriptions != null && this.groupDescriptions.k.count > 0) {
                    this.aq = true;
                }
                else {
                    this.aq = false;
                }
                this.queueAutoRefresh();
            }
        }
        onSummaryDescriptionsChanged(a) {
            this.queueAutoRefresh();
        }
        onFilterExpressionsChanged(a) {
            this.queueAutoRefresh();
        }
        onRowExpansionChanged(a, b, c) {
            if (this.rowExpansionChanged != null) {
                this.rowExpansionChanged(this, new DataSourceRowExpansionChangedEventArgs(a, b, c));
            }
        }
        isPlaceholderItem(a) {
            return false;
        }
        get externalDataSource() {
            return this._externalDataSource;
        }
        set externalDataSource(a) {
            this._externalDataSource = a;
        }
        get actualSchema() {
            return this.p;
        }
        set actualSchema(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.onPropertyUpdated("ActualSchema", b, this.p);
            }
        }
        get actualCount() {
            return this.au;
        }
        set actualCount(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.onPropertyUpdated("ActualCount", b, this.au);
            }
        }
        get firstVisibleIndexRequested() {
            return this.av;
        }
        set firstVisibleIndexRequested(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.onPropertyUpdated("FirstVisibleIndexRequested", b, this.av);
            }
        }
        get lastVisibleIndexRequested() {
            return this.aw;
        }
        set lastVisibleIndexRequested(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.onPropertyUpdated("LastVisibleIndexRequested", b, this.aw);
            }
        }
        get updateNotifier() {
            return this.q;
        }
        set updateNotifier(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.onPropertyUpdated("UpdateNotifier", b, this.q);
            }
        }
        getItemAtIndex(a) {
            return null;
        }
        getItemFromKey(a) {
            return null;
        }
        getItemProperty(a, b) {
            if (this.actualBaseDataProvider != null) {
                let item_ = a;
                if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                    return this.getSpecialRowItemValue(a, b);
                }
                return this.actualBaseDataProvider.getItemValue(a, b);
            }
            return null;
        }
        getSpecialRowItemValue(a, b) {
            if (a.rowType == 3) {
                if (this.ar()) {
                    let c = this.a2(a.targetRow, b);
                    if (c != null) {
                        return c;
                    }
                }
                return this.getItemProperty(a.targetRow, b);
            }
            return a.getSectionValue(b);
        }
        a2(a, b) {
            let c;
            if (this.actualPrimaryKey == null || this.actualPrimaryKey.length < 1) {
                c = [a];
            }
            else {
                c = new Array(this.actualPrimaryKey.length);
                this.getPrimaryKeyValue(a, c);
            }
            let d = this.v.g(c);
            if (d != null && d.transactionType == 1) {
                let e = d.value;
                if (e.containsKey(b)) {
                    return e.item(b);
                }
            }
            d = this.v.ah(c);
            if (d != null && d.transactionType == 1) {
                let f = d.value;
                if (f.containsKey(b)) {
                    return f.item(b);
                }
            }
            d = this.v.ag(c);
            if (d != null && d.transactionType == 1) {
                let g = d.value;
                if (g.containsKey(b)) {
                    return g.item(b);
                }
            }
            return null;
        }
        ao(a, b) {
            let c;
            if (this.actualPrimaryKey == null || this.actualPrimaryKey.length < 1) {
                c = [a];
            }
            else {
                c = new Array(this.actualPrimaryKey.length);
                this.getPrimaryKeyValue(a, c);
            }
            let d = this.v.g(c);
            if (d != null && d.transactionType == 1) {
                let e = d.value;
                if (e.containsKey(b)) {
                    return true;
                }
            }
            d = this.v.ah(c);
            if (d != null && d.transactionType == 1) {
                let f = d.value;
                if (f.containsKey(b)) {
                    return true;
                }
            }
            d = this.v.ag(c);
            if (d != null && d.transactionType == 1) {
                let g = d.value;
                if (g.containsKey(b)) {
                    return true;
                }
            }
            return false;
        }
        getItemPropertyAtIndex(a, b) {
            return null;
        }
        get_fullSectionInformationWillForceLoad() {
            return false;
        }
        get fullSectionInformationWillForceLoad() {
            return this.get_fullSectionInformationWillForceLoad();
        }
        onPropertyUpdated(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.propertyUpdatedOverride(a, b, c);
        }
        propertyUpdatedOverride(a, b, c) {
            switch (a) {
                case "PrimaryKey":
                    this.actualPrimaryKey = this.primaryKey;
                    break;
                case "ActualPrimaryKey":
                    this.onActualPrimaryKeyChanged(b, c);
                    break;
                case "ExecutionContext":
                    if (this.actualBaseDataProvider != null) {
                        let d = this.actualBaseDataProvider;
                        d.executionContext = this.executionContext;
                    }
                    this.queueAutoRefresh();
                    break;
                case "LastVisibleIndexRequested":
                case "FirstVisibleIndexRequested":
                    this.onRequestedVisibleRangeChanged();
                    break;
                case "ActualDataProvider":
                    this.onActualDataProviderChanged(b, c);
                    break;
                case "DeferAutoRefresh":
                    if (this.actualBaseDataProvider != null) {
                        let e = this.actualBaseDataProvider;
                        e.deferAutoRefresh = this.deferAutoRefresh;
                    }
                    if (!c) {
                        this.queueAutoRefresh();
                    }
                    break;
                case "PropertiesRequested":
                    if (this.actualBaseDataProvider != null) {
                        let f = this.actualBaseDataProvider;
                        f.propertiesRequested = this.propertiesRequested;
                    }
                    break;
                case "SchemaIncludedProperties":
                    if (this.actualBaseDataProvider != null) {
                        let g = this.actualBaseDataProvider;
                        g.schemaIncludedProperties = this.schemaIncludedProperties;
                    }
                    break;
                case "ShouldEmitSectionFooters":
                case "ShouldEmitSectionHeaders":
                case "ShouldEmitShiftedRows":
                case "SectionHeaderDisplayMode":
                case "IsSectionCollapsable":
                case "IncludeSummaryRowsInSection":
                case "IsSectionSummaryRowsAtBottom":
                case "IsSectionContentVisible":
                    this.queueAutoRefresh();
                    break;
                case "SummaryScope":
                    if (this.actualBaseDataProvider != null) {
                        let h = this.actualBaseDataProvider;
                        h.summaryScope = this.summaryScope;
                    }
                    this.queueAutoRefresh();
                    break;
            }
        }
        onActualPrimaryKeyChanged(a, b) {
            this.onActualPrimaryKeyChangedOverrride(a, b);
        }
        onActualPrimaryKeyChangedOverrride(a, b) {
        }
        get_isVirtual() {
            return false;
        }
        get isVirtual() {
            return this.get_isVirtual();
        }
        get dataProviderUpdateNotifier() {
            return this.m;
        }
        onActualDataProviderChanged(a, b) {
            let c = a;
            let d = b;
            if (c != null) {
                c.updateNotifier = null;
            }
            if (d != null) {
                d.updateNotifier = this.m;
            }
            if (c != null) {
                c.schemaChanged = delegateRemove(c.schemaChanged, runOn(this, this.bt));
            }
            if (d != null) {
                d.schemaChanged = delegateCombine(d.schemaChanged, runOn(this, this.bt));
                d.executionContext = this.executionContext;
                this.notifyUsingSourceIndexes = this.actualBaseDataProvider.notifyUsingSourceIndexes;
            }
            else {
                this.notifyUsingSourceIndexes = false;
            }
            if (c != null) {
                this.sortDescriptions.syncTarget = null;
                this.groupDescriptions.syncTarget = null;
                this.filterExpressions.syncTarget = null;
                this.summaryDescriptions.syncTarget = null;
            }
            if (d != null) {
                this.sortDescriptions.syncTarget = d.sortDescriptions;
                this.groupDescriptions.syncTarget = d.groupDescriptions;
                this.filterExpressions.syncTarget = d.filterExpressions;
                this.summaryDescriptions.syncTarget = d.summaryDescriptions;
                if (this.propertiesRequested != null) {
                    d.propertiesRequested = this.propertiesRequested;
                }
                d.schemaIncludedProperties = this.schemaIncludedProperties;
                d.summaryScope = this.summaryScope;
            }
            this.queueAutoRefresh();
        }
        onRequestedVisibleRangeChanged() {
        }
        get executionContext() {
            return this.o;
        }
        set executionContext(a) {
            let b = this.o;
            this.o = a;
            if (this.o != b) {
                this.onPropertyUpdated("ExecutionContext", b, this.o);
            }
        }
        canInitialize() {
            if (this.o != null && this.actualBaseDataProvider != null) {
                return true;
            }
            return false;
        }
        get isInitializing() {
            return this.ab;
        }
        get_isSortingSupported() {
            return false;
        }
        get isSortingSupported() {
            return this.get_isSortingSupported();
        }
        get_isFilteringSupported() {
            return false;
        }
        get isFilteringSupported() {
            return this.get_isFilteringSupported();
        }
        get sortDescriptions() {
            return this.t;
        }
        get groupDescriptions() {
            return this.s;
        }
        get filterExpressions() {
            return this.j;
        }
        get summaryDescriptions() {
            return this.u;
        }
        get summaryScope() {
            return this.i;
        }
        set summaryScope(a) {
            let b = this.i;
            this.i = a;
            if (this.i != b) {
                this.onPropertyUpdated("SummaryScope", enumGetBox(DataSourceSummaryScope_$type, b), enumGetBox(DataSourceSummaryScope_$type, this.i));
            }
        }
        get deferAutoRefresh() {
            return this.y;
        }
        set deferAutoRefresh(a) {
            let b = this.y;
            this.y = a;
            if (this.y != b) {
                this.onPropertyUpdated("DeferAutoRefresh", b, this.y);
            }
        }
        get primaryKey() {
            return this.b;
        }
        set primaryKey(a) {
            let b = this.b;
            this.b = a;
            if (this.b != b) {
                this.onPropertyUpdated("PrimaryKey", b, this.b);
            }
        }
        get actualPrimaryKey() {
            return this.a;
        }
        set actualPrimaryKey(a) {
            let b = this.a;
            this.a = a;
            if (this.a != b) {
                this.onPropertyUpdated("ActualPrimaryKey", b, this.a);
            }
        }
        get propertiesRequested() {
            return this.c;
        }
        set propertiesRequested(a) {
            let b = this.c;
            this.c = a;
            if (this.c != b) {
                this.onPropertyUpdated("PropertiesRequested", b, this.c);
            }
        }
        get schemaIncludedProperties() {
            return this.e;
        }
        set schemaIncludedProperties(a) {
            let b = this.e;
            this.e = a;
            if (this.e != b) {
                this.onPropertyUpdated("SchemaIncludedProperties", b, this.e);
            }
        }
        get notifyUsingSourceIndexes() {
            return this.ah;
        }
        set notifyUsingSourceIndexes(a) {
            let b = this.ah;
            this.ah = a;
            if (this.ah != b) {
                this.onPropertyUpdated("NotifyUsingSourceIndexes", b, this.ah);
            }
        }
        get_isItemIndexLookupSupported() {
            return false;
        }
        get isItemIndexLookupSupported() {
            return this.get_isItemIndexLookupSupported();
        }
        get_isKeyIndexLookupSupported() {
            return false;
        }
        get isKeyIndexLookupSupported() {
            return this.get_isKeyIndexLookupSupported();
        }
        initializeOverride() {
        }
        resolveFullCount(a) {
            return a;
        }
        bt(a, b) {
            this.ai = true;
            this.x = true;
            this.queueAutoRefresh();
            if (this.deferAutoRefresh) {
                this.actualSchema = b.schema;
                this.actualCount = this.resolveFullCount(b.count);
                this.b3();
            }
        }
        b3() {
            if (this.schemaChanged != null) {
                this.schemaChanged(this, new DataSourceSchemaChangedEventArgs(this.actualSchema, this.actualCount));
            }
        }
        onSetItem(a, b, c) {
            this.onSetItemOverride(a, b, c);
        }
        onBroadcastSetItem(a, b, c) {
            if (this.updateNotifier != null) {
                this.updateNotifier.notifySetItem(a, b, c);
            }
        }
        onSetItemOverride(a, b, c) {
            if (this.actualBaseDataProvider != null) {
                this.actualCount = this.resolveFullCount(this.actualBaseDataProvider.actualCount);
            }
            this.onBroadcastSetItem(a, b, c);
        }
        onClearItems() {
            this.onClearItemsOverride();
        }
        onBroadcastClearItems() {
            if (this.updateNotifier != null) {
                this.updateNotifier.notifyClearItems();
            }
        }
        onClearItemsOverride() {
            if (this.actualBaseDataProvider != null) {
                this.actualCount = this.resolveFullCount(this.actualBaseDataProvider.actualCount);
            }
            this.onBroadcastClearItems();
        }
        onInsertItem(a, b) {
            this.onInsertItemOverride(a, b);
        }
        onBroadcastInsertItem(a, b) {
            if (this.updateNotifier != null) {
                this.updateNotifier.notifyInsertItem(a, b);
            }
        }
        onInsertItemOverride(a, b) {
            if (this.actualBaseDataProvider != null) {
                this.actualCount = this.resolveFullCount(this.actualBaseDataProvider.actualCount);
            }
            this.onBroadcastInsertItem(a, b);
        }
        onRemoveItem(a, b) {
            this.onRemoveItemOverride(a, b);
        }
        onBroadcastRemoveItem(a, b) {
            if (this.updateNotifier != null) {
                this.updateNotifier.notifyRemoveItem(a, b);
            }
        }
        onRemoveItemOverride(a, b) {
            if (this.actualBaseDataProvider != null) {
                this.actualCount = this.resolveFullCount(this.actualBaseDataProvider.actualCount);
            }
            this.onBroadcastRemoveItem(a, b);
        }
        notifySetItem(a, b, c) {
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.notifySetItem(a, b, c);
            }
        }
        notifyClearItems() {
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.notifyClearItems();
            }
        }
        notifyInsertItem(a, b) {
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.notifyInsertItem(a, b);
            }
            ;
        }
        notifyRemoveItem(a, b) {
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.notifyRemoveItem(a, b);
            }
            ;
        }
        queueAutoRefresh() {
            if (this.deferAutoRefresh) {
                return;
            }
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.queueAutoRefresh();
            }
            if (this.w) {
                return;
            }
            if (this.executionContext != null) {
                this.w = true;
                this.executionContext.enqueueAction(runOn(this, this.bv));
            }
        }
        bv() {
            if (this.deferAutoRefresh) {
                this.w = false;
                return;
            }
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.flushAutoRefresh();
            }
            if (!this.w) {
                return;
            }
            this.w = false;
            this.ct();
        }
        ct() {
            if (this.actualBaseDataProvider != null) {
                this.actualSchema = this.actualBaseDataProvider.actualSchema;
                this.actualCount = this.resolveFullCount(this.actualBaseDataProvider.actualCount);
            }
            if (this.actualSchema != null && this.primaryKey == null) {
                this.actualPrimaryKey = this.actualSchema.primaryKey;
            }
            this.refreshInternalOverride();
            if (this.ai) {
                this.ai = false;
                this.b3();
            }
        }
        refreshInternalOverride() {
        }
        flushAutoRefresh() {
            this.bv();
        }
        refresh() {
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.refresh();
            }
            this.ct();
        }
        indexOfItem(a) {
            return -1;
        }
        indexOfKey(a) {
            return -1;
        }
        getPrimaryKeyValue(a, b) {
            let c = this.actualPrimaryKey;
            if (c == null || c.length < 1 || this.actualBaseDataProvider == null) {
                return;
            }
            for (let d = 0; d < c.length; d++) {
                b[d] = this.actualBaseDataProvider.getItemValue(a, c[d]);
            }
        }
        getRowType(a) {
            return 0;
        }
        getMainValuePath(a) {
            return "SectionInformation";
        }
        getStickyRows() {
            return this.getStickyRowsInRange(this.firstVisibleIndexRequested, this.lastVisibleIndexRequested);
        }
        getStickyRowsInRange(a, b) {
            return null;
        }
        isRowSpanning(a) {
            return a == 1 || a == 2;
        }
        getStickyRowPriority(a) {
            return -1;
        }
        isExclusivelySticky(a) {
            return false;
        }
        pinRow(a) {
        }
        unpinRow(a) {
        }
        clearPinnedRows() {
        }
        isRowPinned(a) {
            return false;
        }
        get_isGroupingSupported() {
            return false;
        }
        get isGroupingSupported() {
            return this.get_isGroupingSupported();
        }
        get_sectionHeaderDisplayMode() {
            return this.h;
        }
        set_sectionHeaderDisplayMode(a) {
            let b = this.h;
            this.h = a;
            if (b != this.h) {
                this.onPropertyUpdated("SectionHeaderDisplayMode", enumGetBox(DataSourceSectionHeaderDisplayMode_$type, b), enumGetBox(DataSourceSectionHeaderDisplayMode_$type, this.h));
            }
        }
        get sectionHeaderDisplayMode() {
            return this.get_sectionHeaderDisplayMode();
        }
        set sectionHeaderDisplayMode(a) {
            this.set_sectionHeaderDisplayMode(a);
        }
        get_isSectionCollapsable() {
            return this.ac;
        }
        set_isSectionCollapsable(a) {
            let b = this.ac;
            this.ac = a;
            if (this.ac != b) {
                this.onPropertyUpdated("IsSectionCollapsable", b, this.ac);
            }
        }
        get isSectionCollapsable() {
            return this.get_isSectionCollapsable();
        }
        set isSectionCollapsable(a) {
            this.set_isSectionCollapsable(a);
        }
        get_isSectionExpandedDefault() {
            return this.ae;
        }
        set_isSectionExpandedDefault(a) {
            this.ae = a;
        }
        get isSectionExpandedDefault() {
            return this.get_isSectionExpandedDefault();
        }
        set isSectionExpandedDefault(a) {
            this.set_isSectionExpandedDefault(a);
        }
        get_includeSummaryRowsInSection() {
            return this.z;
        }
        set_includeSummaryRowsInSection(a) {
            let b = this.z;
            this.z = a;
            if (this.z != b) {
                this.onPropertyUpdated("IncludeSummaryRowsInSection", b, this.z);
            }
        }
        get includeSummaryRowsInSection() {
            return this.get_includeSummaryRowsInSection();
        }
        set includeSummaryRowsInSection(a) {
            this.set_includeSummaryRowsInSection(a);
        }
        get_isSectionSummaryRowsAtBottom() {
            return this.ag;
        }
        set_isSectionSummaryRowsAtBottom(a) {
            let b = this.ag;
            this.ag = a;
            if (this.ag != b) {
                this.onPropertyUpdated("IsSectionSummaryRowsAtBottom", b, this.ag);
            }
        }
        get isSectionSummaryRowsAtBottom() {
            return this.get_isSectionSummaryRowsAtBottom();
        }
        set isSectionSummaryRowsAtBottom(a) {
            this.set_isSectionSummaryRowsAtBottom(a);
        }
        get_isSectionHeaderNormalRow() {
            return this.af;
        }
        set_isSectionHeaderNormalRow(a) {
            let b = this.af;
            this.af = a;
            if (this.af != b) {
                this.onPropertyUpdated("IsSectionHeaderNormalRow", b, this.af);
            }
        }
        get isSectionHeaderNormalRow() {
            return this.get_isSectionHeaderNormalRow();
        }
        set isSectionHeaderNormalRow(a) {
            this.set_isSectionHeaderNormalRow(a);
        }
        get_isSectionContentVisible() {
            return this.ad;
        }
        set_isSectionContentVisible(a) {
            let b = this.ad;
            this.ad = a;
            if (this.ad != b) {
                this.onPropertyUpdated("IsSectionContentVisible", b, this.ad);
            }
        }
        get isSectionContentVisible() {
            return this.get_isSectionContentVisible();
        }
        set isSectionContentVisible(a) {
            this.set_isSectionContentVisible(a);
        }
        get shouldEmitSectionHeaders() {
            return this.ak;
        }
        set shouldEmitSectionHeaders(a) {
            let b = this.ak;
            this.ak = a;
            if (this.ak != b) {
                this.onPropertyUpdated("ShouldEmitSectionHeaders", b, this.ak);
            }
        }
        get shouldEmitSectionFooters() {
            return this.aj;
        }
        set shouldEmitSectionFooters(a) {
            let b = this.aj;
            this.aj = a;
            if (this.aj != b) {
                this.onPropertyUpdated("ShouldEmitSectionFooters", b, this.aj);
            }
        }
        get shouldEmitShiftedRows() {
            return this.al;
        }
        set shouldEmitShiftedRows(a) {
            let b = this.al;
            this.al = a;
            if (this.al != b) {
                this.onPropertyUpdated("ShouldEmitShiftedRows", b, this.al);
            }
        }
        get shouldEmitSummaryRows() {
            return this.am;
        }
        set shouldEmitSummaryRows(a) {
            let b = this.am;
            this.am = a;
            if (this.am != b) {
                this.onPropertyUpdated("ShouldEmitSummaryRows", b, this.am);
            }
        }
        ensureComparables(a) {
            if (this.x && this.actualCount > 0 && this.actualBaseDataProvider != null) {
                let b = null;
                this.d = this.f(a, b);
                this.x = false;
            }
        }
        f(a, b) {
            let c = new Array(a.propertyNames.length);
            return c;
        }
        resolveSchemaPropertyType(a) {
            return this.actualBaseDataProvider.resolveSchemaPropertyType(a);
        }
        setIsRowExpandedAtIndex(a, b) {
        }
        getIsRowExpandedAtIndex(a) {
            return true;
        }
        getRowLevel(a) {
            return 0;
        }
        getRootSummaryRowCount() {
            return 0;
        }
        getRootSummaryResults() {
            return null;
        }
        getSectionSummaryResults(a) {
            return null;
        }
        clone() {
            return null;
        }
        cloneProperties(a) {
            let b = typeCast(BaseDataSource.$, a);
            if (b != null) {
                b.executionContext = this.executionContext;
                b.includeSummaryRowsInSection = this.includeSummaryRowsInSection;
                b.isSectionCollapsable = this.isSectionCollapsable;
                b.isSectionExpandedDefault = this.isSectionExpandedDefault;
                b.isSectionHeaderNormalRow = this.isSectionHeaderNormalRow;
                b.isSectionSummaryRowsAtBottom = this.isSectionSummaryRowsAtBottom;
                b.isSectionContentVisible = this.isSectionContentVisible;
                b.primaryKey = this.primaryKey;
                b.propertiesRequested = this.propertiesRequested;
                b.schemaIncludedProperties = this.schemaIncludedProperties;
                b.sectionHeaderDisplayMode = this.sectionHeaderDisplayMode;
                b.shouldEmitSectionFooters = this.shouldEmitSectionFooters;
                b.shouldEmitSectionHeaders = this.shouldEmitSectionHeaders;
                b.shouldEmitShiftedRows = this.shouldEmitShiftedRows;
                b.summaryScope = this.summaryScope;
                for (let c = 0; c < this.groupDescriptions.k.count; c++) {
                    b.groupDescriptions.add(this.groupDescriptions.k.item(c));
                }
                for (let d = 0; d < this.sortDescriptions.k.count; d++) {
                    b.sortDescriptions.add(this.sortDescriptions.k.item(d));
                }
                for (let e = 0; e < this.filterExpressions.k.count; e++) {
                    b.filterExpressions.add(this.filterExpressions.k.item(e));
                }
                for (let f = 0; f < this.summaryDescriptions.k.count; f++) {
                    b.summaryDescriptions.add(this.summaryDescriptions.k.item(f));
                }
            }
        }
        getRowCount() {
            return this.actualCount;
        }
    }
    BaseDataSource.$t = /*@__PURE__*/ markType(BaseDataSource, 'BaseDataSource', Base.$, [IDataSource_$type, IEditableDataSource_$type]);
    return BaseDataSource;
})();
/**
 * @hidden
 */
let DefaultDataSourceDataProviderUpdateNotifier = /*@__PURE__*/ (() => {
    class DefaultDataSourceDataProviderUpdateNotifier extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        notifySetItem(a, b, c) {
            this.a.onSetItem(a, b, c);
        }
        notifyClearItems() {
            this.a.onClearItems();
        }
        notifyInsertItem(a, b) {
            this.a.onInsertItem(a, b);
        }
        notifyRemoveItem(a, b) {
            this.a.onRemoveItem(a, b);
        }
    }
    DefaultDataSourceDataProviderUpdateNotifier.$t = /*@__PURE__*/ markType(DefaultDataSourceDataProviderUpdateNotifier, 'DefaultDataSourceDataProviderUpdateNotifier', Base.$, [IDataSourceDataProviderUpdateNotifier_$type]);
    return DefaultDataSourceDataProviderUpdateNotifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function arrayClear1(array, index, length) {
    for (var i = index; i < index + length; i++) {
        array[i] = null;
    }
}
function arrayCopy1(source, sourceIndex, dest, destIndex, count) {
    var i;
    if (source == dest && sourceIndex < destIndex) {
        for (i = count - 1; i >= 0; i--) {
            dest[i + destIndex] = source[i + sourceIndex];
        }
    }
    else {
        for (i = 0; i < count; i++) {
            dest[i + destIndex] = source[i + sourceIndex];
        }
    }
}
function arrayCopy2(source, dest, count) {
    for (var i = 0; i < count; i++) {
        dest[i] = source[i];
    }
}
function arrayIndexOf1($t, array, value) {
    return array.indexOf(value);
}
function arrayContains(array, value) {
    for (var i = 0; i < array.length; i++) {
        if (Type.equalsStatic(array[i], value))
            return true;
    }
    return false;
}
function arrayLast(array) {
    return array[array.length - 1];
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class BinaryUtil {
    static isResponseTypeSupported(responseType) {
        var xhr = null;
        try {
            xhr = new XMLHttpRequest();
            xhr.open("GET", "/");
            xhr.responseType = responseType;
        }
        catch (e) {
            return false;
        }
        if (xhr === null) {
            return false;
        }
        return xhr.responseType === responseType;
    }
    static getBinary(url, callback, error) {
        var data, ret, req, useVbArray = false, arrayBufferSupported = BinaryUtil.isResponseTypeSupported("arraybuffer") &&
            typeof Uint8Array != "undefined";
        if (typeof XMLHttpRequest == "undefined") {
            try {
                req = new window.ActiveXObject("Msxml2.XMLHTTP.6.0");
            }
            catch (e) { }
            try {
                req = new window.ActiveXObject("Msxml2.XMLHTTP.3.0");
            }
            catch (e) { }
            req = new window.ActiveXObject("Microsoft.XMLHTTP");
        }
        else {
            req = new XMLHttpRequest();
        }
        if (!arrayBufferSupported) {
            if (req.overrideMimeType) {
                req.overrideMimeType("text/plain; charset=x-user-defined");
            }
        }
        if (typeof window.VBArray != "undefined") {
            useVbArray = true;
        }
        req.onreadystatechange = function () {
            if (req.readyState == 4) {
                let isFileSchemeDownload = false;
                if (req.status == 0) {
                    isFileSchemeDownload = new URL(url).protocol == "file:" ||
                        new URL(url).protocol == "igfile:";
                }
                if (req.status == 200 || isFileSchemeDownload) {
                    if (arrayBufferSupported && typeof this.response != "undefined") {
                        callback(new Uint8Array(this.response));
                    }
                    else {
                        if (useVbArray) {
                            data = new window.VBArray(req.responseBody).toArray();
                            for (var i = 0; i < data.length; i++) {
                                data[i] = String.fromCharCode(data[i]);
                            }
                            ret = data.join("");
                            callback(ret);
                        }
                        else {
                            callback(req.responseText);
                        }
                    }
                }
                else {
                    error(req.error);
                }
            }
        };
        req.open("GET", url, true);
        if (arrayBufferSupported) {
            req.responseType = "arraybuffer";
        }
        req.send(null);
    }
    ;
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function boolCompare(value, other) {
    if (value == other) {
        return 0;
    }
    return value ? 1 : -1;
}
function parseBool(s) {
    var r = tryParseBool(s);
    if (!r.ret) {
        throw new FormatException(1, "Incorrect boolean format");
    }
    return r.p1;
}
;
function tryParseBool(s, v) {
    switch (s == null ? "" : s.trim().toLowerCase()) {
        case "true":
            return {
                p1: true,
                ret: true
            };
        case "false":
            return {
                p1: false,
                ret: true
            };
        default:
            return {
                p1: false,
                ret: false
            };
    }
}
;

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function boolToString(value, provider) {
    return value.toString();
}
;
function boolToInt16(value, provider) {
    return +value;
}
let boolToUInt16 = boolToInt16;
let boolToInt32 = boolToInt16;
let boolToInt64 = boolToInt16;
let boolToUInt64 = boolToInt16;
let boolToUInt32 = boolToInt16;
let boolToSingle = boolToInt16;
let boolToDouble = boolToInt16;
let boolToDecimal = boolToInt16;
function toBoolean(value, provider) {
    /*jshint -W018 */
    return !!+value;
}
function toString1(value, provider) {
    return value.toString();
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function getColorStringSafe(v) {
    /*jshint eqnull:true */
    return v == null ? null : v.colorString();
}
;
const wellKnownColors = {
    aliceblue: "f0f8ff",
    antiquewhite: "faebd7",
    aqua: "00ffff",
    aquamarine: "7fffd4",
    azure: "f0ffff",
    beige: "f5f5dc",
    bisque: "ffe4c4",
    black: "000000",
    blanchedalmond: "ffebcd",
    blue: "0000ff",
    blueviolet: "8a2be2",
    brown: "a52a2a",
    burlywood: "deb887",
    cadetblue: "5f9ea0",
    chartreuse: "7fff00",
    chocolate: "d2691e",
    coral: "ff7f50",
    cornflowerblue: "6495ed",
    cornsilk: "fff8dc",
    crimson: "dc143c",
    cyan: "00ffff",
    darkblue: "00008b",
    darkcyan: "008b8b",
    darkgoldenrod: "b8860b",
    darkgray: "a9a9a9",
    darkgreen: "006400",
    darkkhaki: "bdb76b",
    darkmagenta: "8b008b",
    darkolivegreen: "556b2f",
    darkorange: "ff8c00",
    darkorchid: "9932cc",
    darkred: "8b0000",
    darksalmon: "e9967a",
    darkseagreen: "8fbc8f",
    darkslateblue: "483d8b",
    darkslategray: "2f4f4f",
    darkturquoise: "00ced1",
    darkviolet: "9400d3",
    deeppink: "ff1493",
    deepskyblue: "00bfff",
    dimgray: "696969",
    dodgerblue: "1e90ff",
    feldspar: "d19275",
    firebrick: "b22222",
    floralwhite: "fffaf0",
    forestgreen: "228b22",
    fuchsia: "ff00ff",
    gainsboro: "dcdcdc",
    ghostwhite: "f8f8ff",
    gold: "ffd700",
    goldenrod: "daa520",
    gray: "808080",
    green: "008000",
    greenyellow: "adff2f",
    honeydew: "f0fff0",
    hotpink: "ff69b4",
    indianred: "cd5c5c",
    indigo: "4b0082",
    ivory: "fffff0",
    khaki: "f0e68c",
    lavender: "e6e6fa",
    lavenderblush: "fff0f5",
    lawngreen: "7cfc00",
    lemonchiffon: "fffacd",
    lightblue: "add8e6",
    lightcoral: "f08080",
    lightcyan: "e0ffff",
    lightgoldenrodyellow: "fafad2",
    lightgrey: "d3d3d3",
    lightgreen: "90ee90",
    lightpink: "ffb6c1",
    lightsalmon: "ffa07a",
    lightseagreen: "20b2aa",
    lightskyblue: "87cefa",
    lightslateblue: "8470ff",
    lightslategray: "778899",
    lightsteelblue: "b0c4de",
    lightyellow: "ffffe0",
    lime: "00ff00",
    limegreen: "32cd32",
    linen: "faf0e6",
    magenta: "ff00ff",
    maroon: "800000",
    mediumaquamarine: "66cdaa",
    mediumblue: "0000cd",
    mediumorchid: "ba55d3",
    mediumpurple: "9370d8",
    mediumseagreen: "3cb371",
    mediumslateblue: "7b68ee",
    mediumspringgreen: "00fa9a",
    mediumturquoise: "48d1cc",
    mediumvioletred: "c71585",
    midnightblue: "191970",
    mintcream: "f5fffa",
    mistyrose: "ffe4e1",
    moccasin: "ffe4b5",
    navajowhite: "ffdead",
    navy: "000080",
    oldlace: "fdf5e6",
    olive: "808000",
    olivedrab: "6b8e23",
    orange: "ffa500",
    orangered: "ff4500",
    orchid: "da70d6",
    palegoldenrod: "eee8aa",
    palegreen: "98fb98",
    paleturquoise: "afeeee",
    palevioletred: "d87093",
    papayawhip: "ffefd5",
    peachpuff: "ffdab9",
    peru: "cd853f",
    pink: "ffc0cb",
    plum: "dda0dd",
    powderblue: "b0e0e6",
    purple: "800080",
    red: "ff0000",
    rosybrown: "bc8f8f",
    royalblue: "4169e1",
    saddlebrown: "8b4513",
    salmon: "fa8072",
    sandybrown: "f4a460",
    seagreen: "2e8b57",
    seashell: "fff5ee",
    sienna: "a0522d",
    silver: "c0c0c0",
    skyblue: "87ceeb",
    slateblue: "6a5acd",
    slategray: "708090",
    snow: "fffafa",
    springgreen: "00ff7f",
    steelblue: "4682b4",
    tan: "d2b48c",
    teal: "008080",
    thistle: "d8bfd8",
    tomato: "ff6347",
    turquoise: "40e0d0",
    violet: "ee82ee",
    violetred: "d02090",
    wheat: "f5deb3",
    white: "ffffff",
    whitesmoke: "f5f5f5",
    yellow: "ffff00",
    yellowgreen: "9acd32"
};
function strToColor(str) {
    var ret = {
        a: 255,
        r: 0,
        g: 0,
        b: 0
    };
    var asColorName = str.replace(" ", "").toLowerCase();
    if (asColorName === "transparent") {
        return { a: 0, r: 0, g: 0, b: 0 };
    }
    if (wellKnownColors[asColorName] !== undefined) {
        str = wellKnownColors[asColorName];
    }
    var parts;
    if (str.lastIndexOf("rgba", 0) === 0) {
        str = str.replace("rgba", "").replace(" ", "").replace("(", "").replace(")", "");
        parts = str.split(",");
        ret.r = parseInt(parts[0], 10);
        ret.g = parseInt(parts[1], 10);
        ret.b = parseInt(parts[2], 10);
        ret.a = parseFloat(parts[3]) * 255.0;
    }
    else if (str.lastIndexOf("rgb", 0) === 0) {
        str = str.replace("rgb", "").replace(" ", "").replace("(", "").replace(")", "");
        parts = str.split(",");
        ret.r = parseInt(parts[0], 10);
        ret.g = parseInt(parts[1], 10);
        ret.b = parseInt(parts[2], 10);
    }
    else {
        str = str.replace("#", "").replace(" ", "");
        if (str.length === 8) {
            ret.r = parseInt(str.substr(0, 2), 16);
            ret.g = parseInt(str.substr(2, 2), 16);
            ret.b = parseInt(str.substr(4, 2), 16);
            ret.a = parseInt(str.substr(6, 2), 16);
        }
        else if (str.length === 6) {
            ret.r = parseInt(str.substr(0, 2), 16);
            ret.g = parseInt(str.substr(2, 2), 16);
            ret.b = parseInt(str.substr(4, 2), 16);
        }
        else if (str.length === 3) {
            ret.r = parseInt(str.substr(0, 1) + str.substr(0, 1), 16);
            ret.g = parseInt(str.substr(1, 1) + str.substr(1, 1), 16);
            ret.b = parseInt(str.substr(2, 1) + str.substr(2, 1), 16);
        }
    }
    return ret;
}
;
function rgbToHex(color) {
    /* Convert color from RGB to HEX format. null if non-rgb color is provided.
        paramType="string" optional="false" Color in RGB format.
        returnType="string|null" Returns converted color from RGB to HEX format. null if non-rgb color is provided.
    */
    var r, g, b, colHex = null;
    if (color.charAt(0) === "r") {
        let colorArr = color.replace("rgb(", "").replace(")", "").split(",");
        r = parseInt(colorArr[0], 10).toString(16);
        g = parseInt(colorArr[1], 10).toString(16);
        b = parseInt(colorArr[2], 10).toString(16);
        r = r.length === 1 ? "0" + r : r;
        g = g.length === 1 ? "0" + g : g;
        b = b.length === 1 ? "0" + b : b;
        colHex = "#" + r + g + b;
    }
    return colHex;
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Color = /*@__PURE__*/ (() => {
    class Color extends ValueType {
        constructor() {
            super();
            this._a = 0;
            this._r = 0;
            this._g = 0;
            this._b = 0;
            this._colorString = null;
            this.a = false;
        }
        get l() {
            return this._a;
        }
        set l(a) {
            this._a = truncate(Math.round(a));
            this.a = true;
        }
        get o() {
            return this._r;
        }
        set o(a) {
            this._r = truncate(Math.round(a));
            this.a = true;
        }
        get n() {
            return this._g;
        }
        set n(a) {
            this._g = truncate(Math.round(a));
            this.a = true;
        }
        get m() {
            return this._b;
        }
        set m(a) {
            this._b = truncate(Math.round(a));
            this.a = true;
        }
        get colorString() {
            if (this.a || this._colorString == null) {
                this.a = false;
                this.s();
            }
            return this._colorString;
        }
        set colorString(a) {
            this._colorString = a;
            this.r();
        }
        static create(a) {
            if (typeCast(Color.$, a) !== null) {
                return a;
            }
            let b = new Color();
            if (typeof a === 'string') {
                b.colorString = a;
            }
            else if (a != null) {
                throw new ArgumentException(1, "Unknown color type");
            }
            return b;
        }
        s() {
            this._colorString = "rgba(" + this._r + "," + this._g + "," + this._b + "," + this._a / 255 + ")";
        }
        r() {
            if (this.colorString == null) {
                this.l = this.o = this.n = this.m = 0;
                return;
            }
            let obj_ = strToColor(this._colorString);
            this._a = typeof obj_.a != 'undefined' ? Math.round(obj_.a) : 0;
            this._r = typeof obj_.r != 'undefined' ? Math.round(obj_.r) : 0;
            this._g = typeof obj_.g != 'undefined' ? Math.round(obj_.g) : 0;
            this._b = typeof obj_.b != 'undefined' ? Math.round(obj_.b) : 0;
            if (stringStartsWith(this._colorString, "#") && this._colorString.length == 9) {
                this.s();
            }
        }
        static u(a_, r_, g_, b_) {
            let a = new Color();
            a._a = (a_ | 0);
            a._r = (r_ | 0);
            a._g = (g_ | 0);
            a._b = (b_ | 0);
            a.a = true;
            return a;
        }
        equals(a) {
            if ((typeCast(Color.$, a) !== null) == false) {
                return false;
            }
            let b = a;
            return this._a == b._a && this._r == b._r && this._g == b._g && this._b == b._b;
        }
        getHashCode() {
            return (this._a << 24) | (this._r << 16) | (this._g << 8) | this._b;
        }
        static d(a, b) {
            return !(Color.b(a, b));
        }
        static e(a, b) {
            if (!a.hasValue) {
                return b.hasValue;
            }
            else if (!b.hasValue) {
                return true;
            }
            return Color.d(a.value, b.value);
        }
        static b(a, b) {
            return a._a == b._a && a._r == b._r && a._g == b._g && a._b == b._b;
        }
        static c(a, b) {
            if (!a.hasValue) {
                return !b.hasValue;
            }
            else if (!b.hasValue) {
                return false;
            }
            return Color.b(a.value, b.value);
        }
    }
    Color.$t = /*@__PURE__*/ markStruct(Color, 'Color');
    return Color;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GradientStop = /*@__PURE__*/ (() => {
    class GradientStop extends Base {
        constructor() {
            super();
            this.offset = 0;
            this._fill = null;
            this.d = null;
            this.g = new Color();
            this.offset = 0;
        }
        clone() {
            let a = new GradientStop();
            a.offset = this.offset;
            a._fill = this._fill;
            return a;
        }
        get fill() {
            return this._fill;
        }
        set fill(a) {
            this._fill = a;
        }
        get color() {
            if (this._fill == this.d) {
                return this.g;
            }
            let a = new Color();
            if (this._fill != null) {
                a.colorString = this._fill;
                this.g = a;
                this.d = this._fill;
            }
            return a;
        }
        set color(a) {
            this.g = a;
            this.d = this.g.colorString;
            this._fill = this.d;
        }
        equals(a) {
            if (a == null) {
                return false;
            }
            let b = a;
            return this.offset == b.offset && this.color.equals(b.color) && Base.equalsStatic(this._fill, b._fill);
        }
        getHashCode() {
            let a = (this.offset);
            if (Color.e(toNullable(Color.$, this.g), toNullable(Color.$, null))) {
                a ^= this.g.getHashCode();
            }
            return a;
        }
    }
    GradientStop.$t = /*@__PURE__*/ markType(GradientStop, 'GradientStop');
    return GradientStop;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Brush = /*@__PURE__*/ (() => {
    class Brush extends Base {
        constructor() {
            super(...arguments);
            this.isGradient = false;
            this.isRadialGradient = false;
            this.isImageFill = false;
            this._fill = null;
            this.f = null;
            this.k = new Color();
        }
        get fill() {
            if (this._fill == null) {
                this._fill = this.i();
            }
            return this._fill;
        }
        set fill(a) {
            this._fill = a;
        }
        get color() {
            if (this._fill == null && (this.isGradient || this.isRadialGradient)) {
                this._fill = this.i();
            }
            if (this._fill == this.f) {
                return this.k;
            }
            let a = new Color();
            if (this._fill != null) {
                a.colorString = this._fill;
                this.k = a;
                this.f = this._fill;
                if (this._fill.length == 9) {
                    this._fill = this.k.colorString;
                    this.f = this._fill;
                }
            }
            return a;
        }
        set color(a) {
            this.k = a;
            this.f = this.k.colorString;
            this._fill = this.f;
        }
        i() {
            return null;
        }
        equals(a) {
            if (a == null) {
                return false;
            }
            let b = a;
            return Base.equalsStatic(this._fill, b._fill) && this.color.equals(b.color) && this.isGradient == b.isGradient && this.isImageFill == b.isImageFill && this.isRadialGradient == b.isRadialGradient;
        }
        getHashCode() {
            let a = Base.getHashCodeStatic(this.isGradient) ^ Base.getHashCodeStatic(this.isRadialGradient) ^ Base.getHashCodeStatic(this.isImageFill);
            if (this.f != null) {
                a ^= Base.getHashCodeStatic(this.f);
            }
            if (Color.e(toNullable(Color.$, this.k), toNullable(Color.$, null))) {
                a ^= this.k.getHashCode();
            }
            return a;
        }
        static create(val_) {
            CssGradientUtil.touch();
            let b_ = new Brush();
            if (!val_) {
                return null;
            }
            if (typeof val_ == 'string') {
                if (CssGradientUtil.isGradient(val_)) {
                    b_ = CssGradientUtil.brushFromGradientString(val_);
                }
                else {
                    b_ = new Brush();
                    b_.fill = val_;
                }
            }
            else if (val_.type == 'linearGradient') {
                b_ = new LinearGradientBrush();
                if (val_.startPoint && val_.endPoint) {
                    b_.useCustomDirection = true;
                    b_.startX = val_.startPoint.x;
                    b_.startY = val_.startPoint.y;
                    b_.endX = val_.endPoint.x;
                    b_.endY = val_.endPoint.y;
                }
                if (val_.colorStops) {
                    let stops = [];
                    for (var i = 0; i < val_.colorStops.length; i++) {
                        let colorStop = new GradientStop();
                        colorStop.offset = val_.colorStops[i].offset;
                        colorStop.fill = val_.colorStops[i].color;
                        stops.push(colorStop);
                    }
                    b_.gradientStops = stops;
                }
            }
            ;
            return b_;
        }
    }
    Brush.$t = /*@__PURE__*/ markType(Brush, 'Brush');
    return Brush;
})();
/**
 * @hidden
 */
let LinearGradientBrush = /*@__PURE__*/ (() => {
    class LinearGradientBrush extends Brush {
        constructor() {
            super();
            this.useCustomDirection = false;
            this.startX = 0;
            this.startY = 0;
            this.endX = 0;
            this.endY = 0;
            this.isAbsolute = false;
            this.gradientStops = null;
            this.useCustomDirection = false;
            this.startX = 0;
            this.startY = 0;
            this.endX = 1;
            this.endY = 1;
            this.isAbsolute = false;
            this.gradientStops = new Array(0);
            this.isGradient = true;
        }
        clone() {
            let a = new LinearGradientBrush();
            a.startX = this.startX;
            a.startY = this.startY;
            a.endX = this.endX;
            a.endY = this.endY;
            a.useCustomDirection = this.useCustomDirection;
            a.isAbsolute = this.isAbsolute;
            if (this.gradientStops != null) {
                a.gradientStops = new Array(this.gradientStops.length);
                for (let b = 0; b < this.gradientStops.length; b++) {
                    a.gradientStops[b] = this.gradientStops[b].clone();
                }
            }
            return a;
        }
        equals(a) {
            if (a == null) {
                return false;
            }
            let b = typeCast(LinearGradientBrush.$, a);
            if (b == null) {
                return false;
            }
            let c = super.equals(a) && this.startX == b.startX && this.startY == b.startY && this.endX == b.endX && this.endY == b.endY && this.isAbsolute == b.isAbsolute && this.useCustomDirection == b.useCustomDirection;
            if (c == false) {
                return false;
            }
            if (this.gradientStops.length != b.gradientStops.length) {
                return false;
            }
            for (let d = 0, e = this.gradientStops.length; d < e; d++) {
                if (!this.gradientStops[d].equals(b.gradientStops[d])) {
                    return false;
                }
            }
            return true;
        }
        getHashCode() {
            return super.getHashCode() ^ (this.startX) ^ (this.startY) ^ (this.endX) ^ (this.endY);
        }
        i() {
            if (this.gradientStops != null && this.gradientStops.length > 0) {
                return this.gradientStops[0].color.colorString;
            }
            return super.i();
        }
    }
    LinearGradientBrush.$t = /*@__PURE__*/ markType(LinearGradientBrush, 'LinearGradientBrush', Brush.$);
    return LinearGradientBrush;
})();
/**
 * @hidden
 */
let CssGradientUtil = /*@__PURE__*/ (() => {
    class CssGradientUtil extends Base {
        static touch() {
        }
        static isGradient(a) {
            return stringContains(a, "linear-gradient") || stringContains(a, "radial-gradient");
        }
        static brushFromGradientString(a) {
            let b = (/hsl\([\s\S]+?\)[\s\S]*?[,\)]|rgba?\([\s\S]+?\)[\s\S]*?[,\)]|[^\(\)]*?[,\)]/gim), c = (/\s*\d*%\s*$/), d = (/^\s\s*/), e = (/\s\s*$/), f = (/[,\)]?$/);
            let g;
            let h, i = 1, j = 0, k, l;
            let m = false;
            let n;
            let o = a.match(b);
            if (o == null || o.length <= 1) {
                return null;
            }
            let p = new LinearGradientBrush();
            k = o.length;
            g = o[0];
            if (stringContains(g, "to") || stringContains(g, "deg")) {
                h = CssGradientUtil.c(g);
                p.useCustomDirection = true;
                let q = CssGradientUtil.a(h);
                p.startX = q[0].x;
                p.startY = q[0].y;
                p.endX = q[1].x;
                p.endY = q[1].y;
                n = new Array(k - 1);
            }
            else {
                n = new Array(k);
                i = 0;
            }
            for (; i < k; i++) {
                let r = new GradientStop();
                g = o[i];
                g = g.replace(d, "").replace(e, "").replace(f, "");
                l = g.search(c);
                if (l != -1) {
                    r._fill = g.substr(0, l);
                    r.offset = parseFloat(g.substr(l + 1)) / 100;
                }
                else {
                    r._fill = g;
                    r.offset = -1;
                    m = true;
                }
                n[j] = r;
                j++;
            }
            if (m) {
                if (n[0].offset == -1) {
                    n[0].offset = 0;
                }
                if (n[n.length - 1].offset == -1) {
                    n[n.length - 1].offset = 1;
                }
                CssGradientUtil.f(n);
            }
            p.gradientStops = n;
            return p;
        }
        static f(a) {
            let b, c, d, e, f = -1, g = -1, h = 0;
            let i = false;
            for (b = g + 1; b < a.length; b++) {
                let j = a[b];
                if (j.offset != -1) {
                    f = Math.max(f, j.offset);
                    j.offset = f;
                    if (i) {
                        d = 1;
                        e = intDivide((f - h), (b - g));
                        for (c = g + 1; c < b; c++) {
                            a[c].offset = h + e * d;
                            d++;
                        }
                        i = false;
                    }
                    g = b;
                    h = f;
                }
                else {
                    i = true;
                }
            }
        }
        static c(a) {
            let b = (/to\s*top\s*/i), c = (/to\s*right\s*top\s*/i), d = (/to\s*right\s*/i), e = (/to\s*right\s*bottom\s*/i), f = (/to\s*bottom\s*/i), g = (/to\s*left\s*bottom\s*/i), h = (/to\s*left\s*/i), i = (/to\s*left\s*top\s*/i);
            if (stringContains(a, "deg")) {
                return parseFloat(a);
            }
            if (b.test(a)) {
                return 0;
            }
            if (c.test(a)) {
                return 45;
            }
            if (d.test(a)) {
                return 90;
            }
            if (e.test(a)) {
                return 135;
            }
            if (f.test(a)) {
                return 180;
            }
            if (g.test(a)) {
                return 225;
            }
            if (h.test(a)) {
                return 270;
            }
            return i.test(a) ? 315 : 180;
        }
        static d(a) {
            return Math.PI * a / 180;
        }
        static e(a) {
            if (isNaN_(a) || isInfinity(a)) {
                return a;
            }
            while (a > 360) {
                a -= 360;
            }
            while (a < 0) {
                a += 360;
            }
            return a;
        }
        static a(a) {
            let b = new Array(2);
            let c = PointUtil.create();
            let d = PointUtil.create();
            let e = CssGradientUtil.e(a);
            if (e >= 0 && e <= 45) {
                let f = Math.tan(CssGradientUtil.d(e));
                c.x = 0.5 - 0.5 * f;
                c.y = 1;
                d.x = 0.5 + 0.5 * f;
                d.y = 0;
            }
            else if (e > 180 && e <= 225) {
                let g = Math.tan(CssGradientUtil.d(e - 180));
                c.x = 0.5 + 0.5 * g;
                c.y = 0;
                d.x = 0.5 - 0.5 * g;
                d.y = 1;
            }
            else if (e > 135 && e <= 180) {
                let h = Math.tan(CssGradientUtil.d(180 - e));
                c.x = 0.5 - 0.5 * h;
                c.y = 0;
                d.x = 0.5 + 0.5 * h;
                d.y = 1;
            }
            else if (e > 315 && e < 360) {
                let i = Math.tan(CssGradientUtil.d(360 - e));
                c.x = 0.5 + 0.5 * i;
                c.y = 1;
                d.x = 0.5 - 0.5 * i;
                d.y = 0;
            }
            else if (e > 45 && e <= 90) {
                let j = Math.tan(CssGradientUtil.d(90 - e));
                d.y = 0.5 - 0.5 * j;
                d.x = 1;
                c.y = 0.5 + 0.5 * j;
                c.x = 0;
            }
            else if (e > 90 && e <= 135) {
                let k = Math.tan(CssGradientUtil.d(e - 90));
                d.y = 0.5 + 0.5 * k;
                d.x = 1;
                c.y = 0.5 - 0.5 * k;
                c.x = 0;
            }
            else if (e > 225 && e <= 270) {
                let l = Math.tan(CssGradientUtil.d(270 - e));
                c.y = 0.5 - 0.5 * l;
                c.x = 1;
                d.y = 0.5 + 0.5 * l;
                d.x = 0;
            }
            else if (e > 270 && e <= 315) {
                let m = Math.tan(CssGradientUtil.d(e - 270));
                c.y = 0.5 + 0.5 * m;
                c.x = 1;
                d.y = 0.5 - 0.5 * m;
                d.x = 0;
            }
            b[0] = c;
            b[1] = d;
            return b;
        }
    }
    CssGradientUtil.$t = /*@__PURE__*/ markType(CssGradientUtil, 'CssGradientUtil');
    return CssGradientUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Size = /*@__PURE__*/ (() => {
    class Size extends ValueType {
        constructor(a, ..._rest) {
            super();
            this.i = 0;
            this.h = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.i = c;
                        this.h = d;
                    }
                    break;
            }
        }
        equals(a) {
            if (a == null) {
                return super.equals(a);
            }
            let b = a;
            return b.i == this.i && b.h == this.h;
        }
        getHashCode() {
            return (this.i) ^ (this.h);
        }
        get width() {
            return this.i;
        }
        set width(a) {
            this.i = a;
        }
        get height() {
            return this.h;
        }
        set height(a) {
            this.h = a;
        }
        get isEmpty() {
            return this.i < 0;
        }
        static get empty() {
            let a = new Size(0);
            a.i = Number.NEGATIVE_INFINITY;
            a.h = Number.NEGATIVE_INFINITY;
            return a;
        }
        static l_op_Inequality(a, b) {
            return !(Size.l_op_Equality(a, b));
        }
        static l_op_Inequality_Lifted(a, b) {
            if (!a.hasValue) {
                return b.hasValue;
            }
            else if (!b.hasValue) {
                return true;
            }
            return Size.l_op_Inequality(a.value, b.value);
        }
        static l_op_Equality(a, b) {
            return a.i == b.i && a.h == b.h;
        }
        static l_op_Equality_Lifted(a, b) {
            if (!a.hasValue) {
                return !b.hasValue;
            }
            else if (!b.hasValue) {
                return false;
            }
            return Size.l_op_Equality(a.value, b.value);
        }
    }
    Size.$t = /*@__PURE__*/ markStruct(Size, 'Size');
    return Size;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Rect = /*@__PURE__*/ (() => {
    class Rect extends Base {
        constructor(a, ..._rest) {
            super();
            this.s = 0;
            this.t = 0;
            this.r = 0;
            this.n = 0;
            this.q = 0;
            this.o = 0;
            this.p = 0;
            this.m = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        this.top = d;
                        this.left = c;
                        this.width = e;
                        this.height = f;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        this.top = d;
                        this.left = c;
                        this.width = e.width;
                        this.height = e.height;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.top = Math.min(c.y, d.y);
                        this.left = Math.min(c.x, d.x);
                        this.width = Math.max(Math.max(c.x, d.x) - this.left, 0);
                        this.height = Math.max(Math.max(c.y, d.y) - this.top, 0);
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.top = c.y;
                        this.left = c.x;
                        this.width = d.width;
                        this.height = d.height;
                    }
                    break;
                case 4:
                    {
                        this.top = 0;
                        this.left = 0;
                        this.width = 0;
                        this.height = 0;
                    }
                    break;
            }
        }
        get x() {
            return this.s;
        }
        set x(a) {
            this.s = a;
            this.o = this.s;
            this.p = this.o + this.r;
        }
        get y() {
            return this.t;
        }
        set y(a) {
            this.t = a;
            this.q = this.t;
            this.m = this.q + this.n;
        }
        get width() {
            return this.r;
        }
        set width(a) {
            this.r = a;
            this.p = this.o + this.r;
        }
        get height() {
            return this.n;
        }
        set height(a) {
            this.n = a;
            this.m = this.q + this.n;
        }
        get top() {
            return this.q;
        }
        set top(a) {
            this.q = a;
            this.y = this.q;
        }
        get left() {
            return this.o;
        }
        set left(a) {
            this.o = a;
            this.x = this.o;
        }
        get right() {
            return this.p;
        }
        set right(a) {
            this.p = a;
            this.r = this.p - this.o;
        }
        get bottom() {
            return this.m;
        }
        set bottom(a) {
            this.m = a;
            this.n = this.m - this.q;
        }
        get isEmpty() {
            return this.r < 0;
        }
        static get empty() {
            return new Rect(0, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY, Number.NEGATIVE_INFINITY, Number.NEGATIVE_INFINITY);
        }
        equals1(a) {
            if (Rect.l_op_Equality(a, null)) {
                return false;
            }
            if (a.x == this.x && a.y == this.y && a.width == this.width && a.height == this.height) {
                return true;
            }
            return false;
        }
        d(a, b) {
            return a >= this.s && a - this.r <= this.s && b >= this.t && b - this.n <= this.t;
        }
        containsLocation(a, b) {
            return !this.isEmpty && this.d(a, b);
        }
        containsPoint(a) {
            return this.containsLocation(a.x, a.y);
        }
        containsRect(a) {
            return !this.isEmpty && !a.isEmpty && (this.s <= a.s && this.t <= a.t && this.s + this.r >= a.s + a.r) && this.t + this.n >= a.t + a.n;
        }
        inflate(a, b) {
            this.x -= a;
            this.y -= b;
            this.width += a * 2;
            this.height += b * 2;
            if (this.r < 0 || this.n < 0) {
                this.af();
            }
        }
        af() {
            this.top = Number.POSITIVE_INFINITY;
            this.left = Number.POSITIVE_INFINITY;
            this.width = Number.NEGATIVE_INFINITY;
            this.height = Number.NEGATIVE_INFINITY;
        }
        intersectsWith(a) {
            if (this.isEmpty || a.isEmpty) {
                return false;
            }
            return a.left < this.right && this.left < a.right && a.top < this.bottom && this.top < a.bottom;
        }
        intersect(a) {
            if (!this.intersectsWith(a)) {
                this.af();
            }
            else {
                let b = Math.max(this.x, a.x);
                let c = Math.max(this.y, a.y);
                let d = Math.min(this.x + this.width, a.x + a.width) - b;
                let e = Math.min(this.y + this.height, a.y + a.height) - c;
                if (d < 0) {
                    d = 0;
                }
                if (e < 0) {
                    e = 0;
                }
                this.r = d;
                this.n = e;
                this.s = b;
                this.t = c;
                this.o = this.s;
                this.q = this.t;
                this.p = this.o + this.r;
                this.m = this.q + this.n;
            }
        }
        union(a) {
            if (this.isEmpty) {
                this.s = a.x;
                this.t = a.y;
                this.r = a.width;
                this.n = a.height;
                this.o = this.s;
                this.q = this.t;
                this.p = this.o + this.r;
                this.m = this.q + this.n;
                return;
            }
            if (!a.isEmpty) {
                let b = Math.min(this.x, a.x);
                let c = Math.min(this.y, a.y);
                let d = this.width;
                let e = this.height;
                if (a.width == Number.POSITIVE_INFINITY || this.width == Number.POSITIVE_INFINITY) {
                    d = Number.POSITIVE_INFINITY;
                }
                else {
                    let f = Math.max(this.right, a.right);
                    d = f - b;
                }
                if (a.height == Number.POSITIVE_INFINITY || this.height == Number.POSITIVE_INFINITY) {
                    e = Number.POSITIVE_INFINITY;
                }
                else {
                    let g = Math.max(this.bottom, a.bottom);
                    e = g - c;
                }
                this.s = b;
                this.t = c;
                this.r = d;
                this.n = e;
                this.o = this.s;
                this.q = this.t;
                this.p = this.o + this.r;
                this.m = this.q + this.n;
            }
        }
        equals(a) {
            if (a == null) {
                return super.equals(a);
            }
            let b = a;
            return b.left == this.left && b.top == this.top && b.width == this.width && b.height == this.height;
        }
        getHashCode() {
            return (this.s) ^ (this.t) ^ (this.r) ^ (this.n);
        }
        copy() {
            return new Rect(0, this.x, this.y, this.width, this.height);
        }
        static l_op_Equality(a, b) {
            if (a == null) {
                return b == null;
            }
            else if (b == null) {
                return false;
            }
            return a.s == b.s && a.t == b.t && a.r == b.r && a.n == b.n;
        }
        static l_op_Inequality(a, b) {
            if (a == null) {
                return b != null;
            }
            else if (b == null) {
                return true;
            }
            return a.s != b.s || a.t != b.t || a.r != b.r || a.n != b.n;
        }
    }
    Rect.$t = /*@__PURE__*/ markType(Rect, 'Rect');
    return Rect;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushCollection = /*@__PURE__*/ (() => {
    class BrushCollection extends ObservableCollection$1 {
        constructor() {
            super(Brush.$, 0);
            this.ae = 0;
        }
        ai() {
            return this.item(BrushCollection.ag.next1(this.count));
        }
        get af() {
            return this.ae;
        }
        set af(a) {
            if (this.ae != a) {
                this.ae = a;
                this.ac(new NotifyCollectionChangedEventArgs(0, 4));
            }
        }
        item(a, b) {
            if (arguments.length === 2) {
                super.item(a, b);
                return b;
            }
            else {
                if (a < 0 || a >= this.count) {
                    return null;
                }
                return super.item(a);
            }
        }
        equals(a) {
            if (a == null) {
                return false;
            }
            let b = a;
            if (b.count != this.count) {
                return false;
            }
            for (let c = 0; c < b.count; c++) {
                if (!b.item(c).equals(this.item(c))) {
                    return false;
                }
            }
            return true;
        }
    }
    BrushCollection.$t = /*@__PURE__*/ markType(BrushCollection, 'BrushCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(Brush.$));
    BrushCollection.ag = /*@__PURE__*/ new Random(0);
    return BrushCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ObservableColorCollection = /*@__PURE__*/ (() => {
    class ObservableColorCollection extends ObservableCollection$1 {
        constructor() {
            super(Color.$, 0);
            this.ae = 0;
        }
        get af() {
            return this.ae;
        }
        set af(a) {
            if (this.ae != a) {
                this.ae = a;
                this.ac(new NotifyCollectionChangedEventArgs(0, 4));
            }
        }
        equals(a) {
            if (a == null) {
                return false;
            }
            let b = a;
            if (b.count != this.count) {
                return false;
            }
            for (let c = 0; c < b.count; c++) {
                if (!b._inner[c].equals(this._inner[c])) {
                    return false;
                }
            }
            return true;
        }
        static ag(a) {
            let b = new ObservableColorCollection();
            for (let c of fromEnum(a)) {
                let d = new Color();
                d.colorString = c;
                b.add(d);
            }
            return b;
        }
    }
    ObservableColorCollection.$t = /*@__PURE__*/ markType(ObservableColorCollection, 'ObservableColorCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(Color.$));
    return ObservableColorCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoubleCollection = /*@__PURE__*/ (() => {
    class DoubleCollection extends List$1 {
        constructor() {
            super(Number_$type, 0);
        }
    }
    DoubleCollection.$t = /*@__PURE__*/ markType(DoubleCollection, 'DoubleCollection', /*@__PURE__*/ List$1.$.specialize(Number_$type));
    return DoubleCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function brushToString(v) {
    if (v == null) {
        return null;
    }
    return v.fill;
}
function stringToBrush(v) {
    if (v == null) {
        return null;
    }
    let brush = Brush.create(v);
    return brush;
}
function interfaceToInternal(v, create) {
    if (!v) {
        return v;
    }
    if (v && v.$type) {
        return v;
    }
    if (v._implementation) {
        return v._implementation;
    }
    var inn = create();
    if (inn.setNativeElement) {
        inn.setNativeElement({});
    }
    var outer = create();
    if (outer.setNativeElement) {
        outer.setNativeElement(v);
        outer.___rawMode = true;
        var allProps = getAllPropertyNames(outer);
        for (var i = 0; i < allProps.length; i++) {
            if (allProps[i] == "nativeElement" ||
                allProps[i] == "setNativeElement" ||
                allProps[i] == "helper" ||
                allProps[i] == "$type" ||
                allProps[i].indexOf("__") == 0 ||
                Base.prototype.hasOwnProperty(allProps[i]) ||
                Object.prototype.hasOwnProperty(allProps[i])) {
                continue;
            }
            if (!isValidProp(outer, allProps[i])) {
                continue;
            }
            var pValue = outer[allProps[i]];
            if (pValue === undefined) {
                continue;
            }
            if (pValue && pValue.$type && pValue.$type.name == "WCNativeHelper") {
                continue;
            }
            inn[allProps[i]] = pValue;
        }
    }
    else {
        var props = Object.getOwnPropertyNames(v);
        for (var i = 0; i < props.length; i++) {
            inn[props[i]] = v[props[i]];
        }
    }
    return inn;
}
function ensureEnum($t, v) {
    if (v == null) {
        return 0;
    }
    if (typeof v == "number") {
        let n = v;
        if (EnumUtil.getName($t, n) == undefined) {
            return 0;
        }
        return v;
    }
    let ret = typeGetValue(EnumUtil.parse($t, v, true));
    return ret;
}
function enumToString($t, v) {
    return EnumUtil.toString($t, v);
}
function ensureBool(v) {
    if (v == null) {
        return false;
    }
    if (typeof v == "boolean") {
        return v;
    }
    return v.toString().toLowerCase() == "true";
}
function colorToString(v) {
    if (v == null) {
        return null;
    }
    return v.colorString;
}
function stringToColor(v) {
    if (v == null) {
        return null;
    }
    let brush = Brush.create(v);
    return brush.color;
}
function fromSize(v) {
    if (v == null) {
        return null;
    }
    return {
        width: v.width,
        height: v.height
    };
}
function sizeToString(v) {
    if (!v) {
        return null;
    }
    return v.width + " " + v.height;
}
function toSize(v) {
    if (v == null) {
        return Size.empty;
    }
    let size = null;
    if (typeof v == "string") {
        v = v.trim();
        let parts = v.split(" ");
        if (parts.length != 2) {
            parts = v.split(",");
        }
        if (parts.length != 2) {
            return Size.empty;
        }
        parts[0] = parts[0].trim();
        parts[1] = parts[1].trim();
        let width = parseFloat(parts[0]);
        let height = parseFloat(parts[1]);
        return new Size(0, width, height);
    }
    else {
        if (v != null) {
            size = new Size(0, v.width, v.height);
        }
    }
    return size;
}
function fromPoint(v) {
    return v;
}
function pointToString(v) {
    if (!v) {
        return null;
    }
    return v.x + " " + v.y;
}
function toPoint(v) {
    if (v == null) {
        return PointUtil.createXY(NaN, NaN);
    }
    let point = null;
    if (typeof v == "string") {
        v = v.trim();
        let parts = v.split(" ");
        if (parts.length != 2) {
            parts = v.split(",");
        }
        if (parts.length != 2) {
            return PointUtil.createXY(NaN, NaN);
        }
        parts[0] = parts[0].trim();
        parts[1] = parts[1].trim();
        let x = parseFloat(parts[0]);
        let y = parseFloat(parts[1]);
        return PointUtil.createXY(x, y);
    }
    else {
        if (v != null) {
            point = PointUtil.createXY(v.x, v.y);
        }
    }
    return point;
}
function fromRect(v) {
    if (v == null) {
        return null;
    }
    return {
        top: v.top,
        left: v.left,
        width: v.width,
        height: v.height
    };
}
function rectToString(v) {
    if (!v) {
        return null;
    }
    return v.left + " " + v.top + " " + v.width + " " + v.height;
}
function toRect(v) {
    if (v == null) {
        return Rect.empty;
    }
    let size = null;
    if (typeof v == "string") {
        let parts = v.split(" ");
        if (parts.length != 4) {
            parts = v.split(",");
        }
        if (parts.length != 4) {
            return Rect.empty;
        }
        parts[0] = parts[0].trim();
        parts[1] = parts[1].trim();
        parts[2] = parts[2].trim();
        parts[3] = parts[3].trim();
        let left = parseFloat(parts[0]);
        let top = parseFloat(parts[1]);
        let width = parseFloat(parts[2]);
        let height = parseFloat(parts[3]);
        return new Rect(0, left, top, width, height);
    }
    else {
        if (v != null) {
            size = new Rect(0, v.left, v.top, v.width, v.height);
        }
    }
    return size;
}
function brushCollectionToString(v) {
    let bArray = fromBrushCollection(v);
    if (bArray == null) {
        return null;
    }
    return bArray.join(" ");
}
function toBrushCollection(v) {
    if (v == null) {
        return null;
    }
    let isRGB = true;
    if (typeof v == "string") {
        v = v.trim();
        v = v.split(/[\s,]+(?![^(]*\))/gm);
        for (let i = 0; i < v.length; i++) {
            v[i] = v[i].trim();
        }
    }
    let val = v ? v[0] : null;
    if (typeof val == 'string' && val == 'HSV' || val == 'RGB') {
        if (v[0] == 'HSV') {
            isRGB = false;
        }
        v = v.slice(1);
    }
    let brushCollection = new BrushCollection();
    for (var i = 0; v && i < v.length; i++) {
        let brush = Brush.create(v[i]);
        brushCollection.add(brush);
    }
    return brushCollection;
}
function fromBrushCollection(v) {
    if (v == null) {
        return null;
    }
    let internalCollection = v;
    let ret = [];
    for (let i = 0; i < internalCollection.count; i++) {
        const brush = internalCollection.item(i);
        if (brush != null) {
            ret.push(brush.fill);
        }
    }
    return ret;
}
function doubleCollectionToString(v) {
    let bArray = fromDoubleCollection(v);
    if (bArray == null) {
        return null;
    }
    return bArray.join(" ");
}
function toDoubleCollection(v) {
    if (v == null) {
        return null;
    }
    let isRGB = true;
    if (typeof v == "string") {
        v = v.trim();
        let vParts = v.split(/[\s,]+(?![^(]*\))/gm);
        for (let i = 0; i < vParts.length; i++) {
            vParts[i] = vParts[i].trim();
        }
        v = vParts;
    }
    let doubleCollection = new DoubleCollection();
    for (var i = 0; v && i < v.length; i++) {
        doubleCollection.add(+v[i]);
    }
    return doubleCollection;
}
function fromDoubleCollection(v) {
    if (v == null) {
        return null;
    }
    let internalCollection = v;
    let ret = [];
    for (let i = 0; i < internalCollection.count; i++) {
        const num = internalCollection.item(i);
        if (num != null) {
            ret.push(num);
        }
    }
    return ret;
}
function colorCollectionToString(v) {
    let bArray = fromColorCollection(v);
    if (bArray == null) {
        return null;
    }
    return bArray.join(" ");
}
function toColorCollection(v) {
    if (v == null) {
        return null;
    }
    let isRGB = true;
    if (typeof v == "string") {
        v = v.trim();
        v = v.split(/[\s,]+(?![^(]*\))/gm);
        for (let i = 0; i < v.length; i++) {
            v[i] = v[i].trim();
        }
    }
    let val = v ? v[0] : null;
    if (typeof val == 'string' && val == 'HSV' || val == 'RGB') {
        if (v[0] == 'HSV') {
            isRGB = false;
        }
        v = v.slice(1);
    }
    let colorCollection = new ObservableColorCollection();
    for (var i = 0; v && i < v.length; i++) {
        let color = stringToColor(v[i]);
        colorCollection.add(color);
    }
    return colorCollection;
}
function fromColorCollection(v) {
    if (v == null) {
        return null;
    }
    let internalCollection = v;
    let ret = [];
    for (let i = 0; i < internalCollection.count; i++) {
        ret.push(internalCollection.item(i).colorString);
    }
    return ret;
}
function arrayFindByName(arr, name) {
    for (let i = 0; i < arr.length; i++) {
        if (arr[i].findByName && arr[i].findByName(name)) {
            return arr[i].findByName(name);
        }
    }
}
class CollectionAdapter {
    constructor(query, target, allList, toTarget, onItemAdded, onItemRemoved, collisionChecker) {
        this._manualItems = [];
        this._collisionChecker = null;
        this.actualContent = [];
        this._removedManualKeys = new Set();
        if (collisionChecker) {
            this._collisionChecker = collisionChecker;
        }
        this._query = query;
        this._target = target;
        this._toTarget = toTarget;
        this._allList = allList;
        this._onItemAdded = onItemAdded;
        this._onItemRemoved = onItemRemoved;
        this.syncItems();
        if (this._query.changes) {
            this._query.changes.subscribe((v) => this.onQueryChanged(v));
        }
    }
    get collisionChecker() {
        return this._collisionChecker;
    }
    set collisionChecker(v) {
        this._collisionChecker = v;
    }
    updateQuery(q) {
        this._query = q;
        if (this._query.changes) {
            this._query.changes.subscribe((v) => this.onQueryChanged(v));
        }
        this.notifyContentChanged();
    }
    shiftContentToManual(manualCollection, onMoving) {
        let queryArray = null;
        if (this._query.toArray) {
            queryArray = this._query.toArray();
        }
        else {
            queryArray = this._query;
        }
        let item = null;
        let manualSet = new Set();
        if (this.collisionChecker) {
            for (var i = 0; i < this._manualItems.length; i++) {
                item = this._manualItems[i];
                if (item) {
                    let key = this.collisionChecker(item);
                    if (key) {
                        if (!manualSet.has(key)) {
                            manualSet.add(key);
                        }
                    }
                }
            }
        }
        let mapWasEmpty = manualSet.size == 0;
        for (var i = 0; i < queryArray.length; i++) {
            item = queryArray[i];
            if (!this._hasShiftedOnceAlready) {
                this._manualItems.splice(i, 0, item);
                manualCollection.insert(i, item);
                onMoving(item);
            }
            else {
                let key = this.collisionChecker(item);
                if (!key) {
                    this._manualItems.splice(i, 0, item);
                    manualCollection.insert(i, item);
                    onMoving(item);
                }
                else {
                    if (!manualSet.has(key)) {
                        this._manualItems.splice(manualCollection.count, 0, item);
                        manualCollection.insert(manualCollection.count, item);
                        onMoving(item);
                    }
                }
            }
        }
        this.syncItems();
        this._hasShiftedOnceAlready = true;
    }
    syncItems() {
        let targetMap = new Map();
        let queryMap = new Map();
        let manualMap = new Map();
        let item = null;
        for (var i = 0; i < this._allList.length; i++) {
            item = this._allList[i];
            targetMap.set(item, true);
        }
        let queryArray = null;
        if (this._query.toArray) {
            queryArray = this._query.toArray();
        }
        else {
            queryArray = this._query;
        }
        this.actualContent = queryArray;
        if (this.collisionChecker) {
            queryArray = queryArray.slice(0);
            this.actualContent = queryArray;
            let manualKeySet = new Set();
            for (let i = 0; i < this._manualItems.length; i++) {
                item = this._manualItems[i];
                if (item) {
                    let key = this.collisionChecker(item);
                    if (key) {
                        if (!manualKeySet.has(key)) {
                            manualKeySet.add(key);
                        }
                    }
                }
            }
            for (let i = queryArray.length - 1; i >= 0; i--) {
                item = queryArray[i];
                if (!item) {
                    queryArray.splice(i, 1);
                }
                else {
                    let key = this.collisionChecker(item);
                    if (key && (manualKeySet.has(key) || this._removedManualKeys.has(key))) {
                        queryArray.splice(i, 1);
                    }
                }
            }
        }
        for (var i = 0; i < queryArray.length; i++) {
            item = queryArray[i];
            queryMap.set(item, true);
        }
        for (var i = 0; i < this._manualItems.length; i++) {
            item = this._manualItems[i];
            manualMap.set(item, true);
        }
        for (var i = this._allList.length - 1; i >= 0; i--) {
            item = this._allList[i];
            if (!queryMap.has(item) && !manualMap.has(item)) {
                this._allList.splice(i, 1);
                this._target.removeAt(i);
                this._onItemRemoved(item);
            }
        }
        let ind = 0;
        let ins = 0;
        let insItem = null;
        let maxLen = queryArray.length + this._manualItems.length;
        while (ind < maxLen) {
            if (ind < queryArray.length) {
                insItem = queryArray[ind];
            }
            else if ((ind - queryArray.length) < this._manualItems.length) {
                insItem = this._manualItems[ind - queryArray.length];
            }
            else {
                break;
            }
            if (ins < this._allList.length) {
                item = this._allList[ins];
                if (item === insItem) {
                    ins++;
                    ind++;
                }
                else {
                    this._allList.splice(ins, 0, insItem);
                    this._target.insert(ins, this._toTarget(insItem));
                    this._onItemAdded(insItem);
                    ind++;
                    ins++;
                }
            }
            else {
                this._allList.push(insItem);
                this._target.add(this._toTarget(insItem));
                this._onItemAdded(insItem);
                ind++;
                ins++;
            }
        }
    }
    notifyContentChanged() {
        this.onQueryChanged(this._query);
    }
    onQueryChanged(currentItems) {
        this.syncItems();
    }
    addManualItem(item) {
        if (this.collisionChecker) {
            let key = this.collisionChecker(item);
            if (key) {
                if (this._removedManualKeys.has(key)) {
                    this._removedManualKeys.delete(key);
                }
            }
        }
        this._manualItems.push(item);
        this.syncItems();
    }
    removeManualItem(item) {
        let ind = this._manualItems.indexOf(item);
        if (ind >= 0) {
            if (this.collisionChecker) {
                let key = this.collisionChecker(item);
                if (key) {
                    if (!this._removedManualKeys.has(key)) {
                        this._removedManualKeys.add(key);
                    }
                }
            }
            this._manualItems.splice(ind, 1);
            this.syncItems();
            return true;
        }
        return false;
    }
    removeManualItemAt(index) {
        if (index < this._manualItems.length) {
            let item = this._manualItems[index];
            if (this.collisionChecker) {
                let key = this.collisionChecker(item);
                if (key) {
                    if (!this._removedManualKeys.has(key)) {
                        this._removedManualKeys.add(key);
                    }
                }
            }
        }
        this._manualItems.splice(index, 1);
        this.syncItems();
    }
    clearManualItems() {
        if (this.collisionChecker) {
            this._removedManualKeys.clear();
        }
        this._manualItems.length = 0;
        this.syncItems();
    }
    insertManualItem(index, item) {
        if (this.collisionChecker) {
            let key = this.collisionChecker(item);
            if (key) {
                if (this._removedManualKeys.has(key)) {
                    this._removedManualKeys.delete(key);
                }
            }
        }
        this._manualItems.splice(index, 0, item);
        this.syncItems();
    }
}
function addPaletteThemeEntry(theme, clss, background, border, foreground) {
    if (theme[clss] === undefined) {
        theme[clss] = {};
    }
    if (background !== null) {
        theme[clss]["background-color"] = background;
    }
    if (border !== null && border !== undefined) {
        theme[clss]["border-top-color"] = border;
        theme[clss]["border-left-color"] = border;
        theme[clss]["border-right-color"] = border;
        theme[clss]["border-bottom-color"] = border;
    }
    if (foreground !== null && foreground !== undefined) {
        theme[clss]["color"] = foreground;
    }
}
function addTextThemeEntry(theme, clss, fontFamily, fontSize, textColor, leftMargin, topMargin, rightMargin, bottomMargin, horizontalAlignment, verticalAlignment) {
    if (theme[clss] === undefined) {
        theme[clss] = {};
    }
    let t = theme[clss];
    if (fontFamily !== null && fontFamily !== undefined) {
        t["font-family"] = fontFamily;
        t["font-weight"] = "";
        t["font-style"] = "";
        t["font-variant"] = "";
        t["line-height"] = "";
    }
    if (fontSize !== null && fontSize !== undefined) {
        t["font-size"] = fontSize;
        t["font-weight"] = "";
        t["font-style"] = "";
        t["font-variant"] = "";
        t["line-height"] = "";
    }
    if (textColor !== null && textColor !== undefined) {
        t["color"] = textColor;
    }
    if (leftMargin !== null && leftMargin !== undefined) {
        t["margin-left"] = leftMargin;
    }
    if (topMargin !== null && topMargin !== undefined) {
        t["margin-top"] = topMargin;
    }
    if (rightMargin !== null && rightMargin !== undefined) {
        t["margin-right"] = rightMargin;
    }
    if (bottomMargin !== null && bottomMargin !== undefined) {
        t["margin-bottom"] = bottomMargin;
    }
    if (horizontalAlignment !== null && horizontalAlignment !== undefined) {
        t["text-align"] = horizontalAlignment;
    }
    if (verticalAlignment !== null && verticalAlignment !== undefined) {
        t["vertical-align"] = verticalAlignment;
    }
}
function isStylableProperty(name) {
    // using lower case to prevent issGrues with matching case of properties (e.g. chart.brushes)
    let propName = name.toLowerCase();
    // skip non-stylable properties
    if (propName == "height" ||
        propName == "width") {
        return false;
    }
    // check for all stylable properties
    if (stringEndsWith(propName, "height") || // grid.rowHeight
        stringEndsWith(propName, "width") || // zoomSlider.HigherThumbWidth
        stringEndsWith(propName, "width") || // zoomSlider.HigherCalloutOutline
        stringEndsWith(propName, "inset") || // zoomSlider.EndInset
        stringEndsWith(propName, "orientation") || // zoomSlider.Orientation
        stringEndsWith(propName, "duration") || // zoomSlider.PanTransitionDuration
        stringEndsWith(propName, "outline") || // zoomSlider.BarOutline
        stringEndsWith(propName, "brush") ||
        stringEndsWith(propName, "background") ||
        stringEndsWith(propName, "opacity") ||
        stringEndsWith(propName, "textstyle") ||
        stringEndsWith(propName, "brushes") || // chart.brushes  || chart.negativeBrushes
        stringEndsWith(propName, "outlines") || // chart.outlines || chart.negativeOutlines
        stringEndsWith(propName, "thickness") || // chart.AxisStrokeThickness
        stringEndsWith(propName, "colors") || //
        stringEndsWith(propName, "color") || // chart.AxisLabelTextColor
        stringEndsWith(propName, "margin") || // chart.AxisLabelTopMargin
        stringEndsWith(propName, "location") || // chart.AxisLabelLocation
        stringEndsWith(propName, "style") || // chart.AxisLabelTextStyle
        stringEndsWith(propName, "alignment") || // chart.AxisLabelHorizontalAlignment
        stringEndsWith(propName, "visibility") || // chart.AxisLabelVisibility
        stringEndsWith(propName, "extent") || // chart.AxisExtent
        stringEndsWith(propName, "length") || // chart.AxisTickLength
        stringEndsWith(propName, "strip") || // chart.AxisStrip
        stringEndsWith(propName, "stroke") || // chart.AxisStroke
        stringEndsWith(propName, "fill") || // piechart.OthersCategoryFill
        stringEndsWith(propName, "visible") ||
        stringEndsWith(propName, "radius") ||
        stringStartsWith(propName, "padding") ||
        stringEndsWith(propName, "dasharray") ||
        stringEndsWith(propName, "linejoin") ||
        stringEndsWith(propName, "linecap") ||
        propName === "usecanvas" ||
        propName === "useaccessibility" ||
        stringEndsWith(propName, "scrollbarstyle")) { // chart.isToolbarVisible
        return true;
    }
    return false;
}
function resolveUnits(val) {
    // TODO convert "em, px, pt, cm, in" units to "px"?
    // https://www.w3.org/Style/Examples/007/units.en.html
    let value = val.toLowerCase();
    if (stringEndsWith(value, "px")) { // 20px
        value = value.replace("px", "");
        value = value.replace(" ", "");
    }
    return value;
}
function toSpinal(value) {
    if (value == null) {
        return null;
    }
    let output = [];
    let upperRun = 0;
    for (let i = 0; i < value.length; i++) {
        var curr = value[i];
        var upperChar = curr.toUpperCase();
        var lowerChar = curr.toLowerCase();
        let charIsNewWord = (upperRun == 0 && output.length > 0);
        let previousCharWasNewWord = (upperRun > 1);
        if (upperChar == curr) {
            if (charIsNewWord) {
                output.push('-');
            }
            upperRun++;
        }
        else if (lowerChar == curr) {
            if (previousCharWasNewWord) {
                output.splice(output.length - 1, 0, '-');
            }
            upperRun = 0;
        }
        else {
            upperRun = 0;
        }
        output.push(lowerChar);
    }
    let sb = "";
    for (let i = 0; i < output.length; i++) {
        sb += output[i];
    }
    return sb;
}
function fromSpinal(value) {
    if (value == null) {
        return value;
    }
    let parts = value.split('-');
    for (let j = 1; j < parts.length; j++) {
        parts[j] = parts[j].substr(0, 1).toUpperCase() + parts[j].substr(1);
    }
    let ret = "";
    for (let j = 0; j < parts.length; j++) {
        ret += parts[j];
    }
    return ret;
}
function toCssPropertyName(value) {
    let sb = toSpinal(value);
    return sb;
}
// get all property names for specified component and its base classes
function getAllPropertyNames(comp) {
    let members = [];
    while (comp = (comp.prototype || Object.getPrototypeOf(comp))) {
        if (typeof HTMLElement !== 'undefined' && comp == HTMLElement.prototype) {
            break;
        }
        let props = Object.getOwnPropertyNames(comp.constructor.prototype);
        for (let i = 0; i < props.length; i++) {
            members.push(props[i]);
        }
    }
    return members;
}
let stylableMap = /*@__PURE__*/ new Map();
function initializePropertiesFromCss(ele, comp, cssPrefix, ignoredProperties, prefixRequired, additionalPrefixes) {
    let styles = getComputedStyle(ele);
    let props = getAllPropertyNames(comp);
    let filtered = false;
    let stylableProperties = [];
    if (stylableMap.has(comp.prototype || Object.getPrototypeOf(comp))) {
        stylableProperties = stylableMap.get(comp.prototype || Object.getPrototypeOf(comp));
        props = stylableProperties;
        filtered = true;
    }
    let compName = comp.constructor.name;
    for (let prop of props) {
        let cssPropName = null;
        if (filtered) {
            cssPropName = prop[1];
            prop = prop[0];
        }
        if (ignoredProperties && ignoredProperties.has(prop)) {
            if (!filtered && isStylableProperty(prop)) {
                let cssName = toCssPropertyName(prop);
                stylableProperties.push([prop, cssName]);
            }
            continue;
        }
        if (filtered || isStylableProperty(prop)) {
            let cssName = "";
            if (cssPropName) {
                cssName = cssPropName;
            }
            else {
                cssName = toCssPropertyName(prop);
            }
            // check if custom property is set with a prefix
            let cssValue = styles.getPropertyValue("--" + cssPrefix + cssName);
            if (cssValue && cssValue.length && cssValue.length > 0) {
                comp[prop] = resolveUnits(cssValue.trim());
            }
            if (additionalPrefixes) {
                for (let i = 0; i < additionalPrefixes.length; i++) {
                    let p = additionalPrefixes[i];
                    cssValue = styles.getPropertyValue("--" + p + cssName);
                    if (cssValue && cssValue.length && cssValue.length > 0) {
                        comp[prop] = resolveUnits(cssValue.trim());
                    }
                }
            }
            if (!prefixRequired) {
                // check if custom property is set without a prefix
                cssValue = styles.getPropertyValue("--" + cssName);
                if (cssValue && cssValue.length && cssValue.length > 0) {
                    comp[prop] = resolveUnits(cssValue.trim());
                }
            }
            if (!filtered) {
                stylableProperties.push([prop, cssName]);
            }
        }
    }
    if (!filtered) {
        stylableMap.set(comp.prototype || Object.getPrototypeOf(comp), stylableProperties);
    }
}
function addBrushPaletteThemeEntry(theme, clss, backgrounds, outlines) {
    if (outlines == null) {
        outlines = backgrounds;
    }
    let t = theme;
    for (let i = 0; i < Math.max(backgrounds.length, outlines.length); i++) {
        let pName = clss + "-" + (i + 1);
        if (t[pName] === undefined) {
            t[pName] = {};
        }
        if (backgrounds[i] !== undefined) {
            t[pName]["background-color"] = backgrounds[i];
        }
        if (outlines[i] !== undefined) {
            t[pName]["border-top-color"] = outlines[i];
            t[pName]["border-left-color"] = outlines[i];
            t[pName]["border-right-color"] = outlines[i];
            t[pName]["border-bottom-color"] = outlines[i];
        }
    }
}
function getModifiedProps(prevProps, nextProps) {
    let mod = {};
    for (let p of Object.keys(nextProps)) {
        if (prevProps[p] == undefined ||
            prevProps[p] !== nextProps[p]) {
            mod[p] = nextProps[p];
        }
    }
    return mod;
}
function isValidProp(owner, prop) {
    var _a, _b;
    while (owner = (owner.prototype || Object.getPrototypeOf(owner))) {
        if (typeof HTMLElement !== 'undefined' && owner == HTMLElement.prototype) {
            break;
        }
        if (owner.hasOwnProperty(prop)) {
            // has getter, but no setter
            const notSettable = ((_a = Object.getOwnPropertyDescriptor(owner, prop)) === null || _a === void 0 ? void 0 : _a.get) !== undefined && ((_b = Object.getOwnPropertyDescriptor(owner, prop)) === null || _b === void 0 ? void 0 : _b.set) === undefined;
            return !notSettable;
        }
    }
    return false;
}
let NamePatcher = /*@__PURE__*/ (() => {
    class NamePatcher {
        static ensureStylablePatched(prot) {
            this.ensurePatched(prot, isStylableProperty);
        }
        static ensurePatched(prot, nameFilter) {
            if (!prot) {
                return;
            }
            if (prot === Object.prototype || (typeof HTMLElement !== 'undefined' && prot === HTMLElement.prototype)) {
                return;
            }
            if (this._patched.has(prot)) {
                return;
            }
            this._patched.add(prot);
            for (const key of Object.getOwnPropertyNames(prot)) {
                if (nameFilter && !nameFilter(key)) {
                    continue;
                }
                let p = Object.getOwnPropertyDescriptor(prot, key);
                if (!p) {
                    continue;
                }
                const set = p.set;
                let name = key;
                if (set !== undefined) {
                    let newSet = function (v) {
                        this.__p = name;
                        if (this.__m) {
                            this.__m(name);
                        }
                        set.call(this, v);
                    };
                    Object.defineProperty(prot, key, Object.assign(Object.assign({}, p), { set: newSet }));
                }
            }
            let base = Object.getPrototypeOf(prot);
            if (base) {
                this.ensurePatched(base, nameFilter);
            }
        }
    }
    NamePatcher._patched = /*@__PURE__*/ new Set();
    return NamePatcher;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DictionaryUtil {
    static dictionaryCreate(capacity) {
        return new Map();
    }
    static *en(map) {
        for (let item of map) {
            let [key, value] = item;
            yield { key: key, value: value };
        }
    }
    static dictionaryGetEnumerator(map) {
        return new IteratorWrapper(DictionaryUtil.en(map), () => DictionaryUtil.en(map));
    }
    static dictionaryGetKeys(map) {
        return new IteratorWrapper(map.keys(), () => map.keys());
    }
    static dictionaryGetValues(map) {
        return new IteratorWrapper(map.values(), () => map.values());
    }
    static dictionaryGetDictionary(obj) {
        let map = new Map();
        for (var p in obj) {
            map.set(p.toString(), obj[p]);
        }
        return map;
    }
}

let DomRenderer_$type = /*@__PURE__*/ new Type(null, "DomRenderer");
let DomWrapper_$type = /*@__PURE__*/ new Type(null, "DomWrapper");
let DomPortal_$type = /*@__PURE__*/ new Type(null, "DomPortal");
let DomWrapperPosition_$type = /*@__PURE__*/ new Type(null, "DomWrapperPosition");
let NormalizedEvent_$type = /*@__PURE__*/ new Type(null, "NormalizedEvent");

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class HttpRequestUtil {
    static submit(url, callback, error) {
        var data, ret, req;
        if (typeof XMLHttpRequest == "undefined") {
            try {
                req = new window.ActiveXObject("Msxml2.XMLHTTP.6.0");
            }
            catch (e) { }
            try {
                req = new window.ActiveXObject("Msxml2.XMLHTTP.3.0");
            }
            catch (e) { }
            req = new window.ActiveXObject("Microsoft.XMLHTTP");
        }
        else {
            req = new XMLHttpRequest();
        }
        if (req.overrideMimeType) {
            req.overrideMimeType("text/plain; charset=x-user-defined");
        }
        req.onreadystatechange = function () {
            if (req.readyState == 4) {
                if (req.status == 200) {
                    if (callback) {
                        callback(req.responseText, req);
                    }
                }
                else {
                    if (error) {
                        error(req.error, req);
                    }
                }
            }
        };
        req.open("GET", url, true);
        req.send(null);
        return req;
    }
    ;
}

class IgCollection {
    item(index, value) {
        if (this._innerColl != null) {
            return this._innerColl.get(index);
        }
        else {
            if (value) {
                value = this._ensureOuter(value);
                let innerValue = null;
                if (value._implementation) {
                    innerValue = value._implementation;
                }
                else {
                    innerValue = value;
                }
                this._inner.item(index, innerValue);
                return value;
            }
            else {
                let item = this._inner.item(index);
                item = this._toExternal(item);
                return item;
            }
        }
    }
    indexOf(item) {
        if (this._innerColl != null) {
            return this._innerColl.indexOf(this._ensureOuter(item));
        }
        else {
            let actualItem = this._ensureOuter(item);
            if (actualItem._implementation) {
                actualItem = actualItem._implementation;
            }
            return this._inner.indexOf(actualItem);
        }
    }
    insert(index, item) {
        if (this._innerColl != null) {
            this._innerColl.add1(index, item);
        }
        else {
            let actualItem = this._ensureOuter(item);
            if (actualItem._implementation) {
                actualItem = actualItem._implementation;
            }
            this._inner.insert(index, actualItem);
        }
    }
    removeAt(index) {
        if (this._innerColl != null) {
            this._innerColl.remove(index);
        }
        else {
            this._inner.removeAt(index);
        }
    }
    get count() {
        if (this._innerColl != null) {
            return this._innerColl.size();
        }
        else {
            return this._inner.count;
        }
    }
    add(item) {
        if (this._innerColl != null) {
            this._innerColl.add(item);
        }
        else {
            let actualItem = this._ensureOuter(item);
            if (actualItem._implementation) {
                actualItem = actualItem._implementation;
            }
            this._inner.add(actualItem);
        }
    }
    clear() {
        if (this._innerColl != null) {
            this._innerColl.clear();
        }
        else {
            this._inner.clear();
        }
    }
    contains(item) {
        if (this._innerColl != null) {
            return this._innerColl.all.contains(item);
        }
        else {
            let actualItem = item;
            if (actualItem._implementation) {
                actualItem = actualItem._implementation;
            }
            return this._inner.contains(actualItem);
        }
    }
    remove(item) {
        if (this._innerColl != null) {
            return this._innerColl.remove1(item);
        }
        else {
            let actualItem = this._ensureOuter(item);
            if (actualItem._implementation) {
                actualItem = actualItem._implementation;
            }
            return this._inner.remove(actualItem);
        }
    }
    findByName(name) {
        for (let i = 0; i < this.count; i++) {
            var curr = this.item(i);
            if (curr && curr.name) {
                if (curr.name == name) {
                    return curr;
                }
            }
            if (curr) {
                if (curr.findByName) {
                    let found = curr.findByName(name);
                    if (found) {
                        return found;
                    }
                }
            }
        }
        return null;
    }
    hasName(name) {
        return this.findByName(name) != null;
    }
    filter(predicate, thisArg) {
        return this.toArray().filter(predicate, thisArg);
    }
    toArray() {
        let arr = [];
        for (let i = 0; i < this.count; i++) {
            arr[i] = this.item(i);
        }
        return arr;
    }
    *[Symbol.iterator]() {
        for (let i = 0; i < this.count; i++) {
            let item = this.item(i);
            yield item;
        }
    }
    _setSyncTarget(list) {
        if (this._innerColl != null) {
            this._innerColl.syncTarget = list;
        }
    }
    _fromInner(inner) {
        if (Array.isArray(inner)) {
            let l = new List$1(Base.prototype.$type, 0);
            l._inner = inner;
            inner = l;
        }
        this._inner = inner;
        if (this._innerColl) {
            this._createFrom = this._innerColl.createFrom;
            this._createTo = this._innerColl.createTo;
        }
        this._innerColl = null;
        return this;
    }
    _toExternal(item) {
        if (!item) {
            return null;
        }
        let ext = item.externalObject;
        if (ext) {
            return ext;
        }
        if (this._createFrom) {
            ext = this._createFrom(item);
        }
        if (!ext) {
            return item;
        }
        return ext;
    }
    _ensureOuter(item) {
        return item;
    }
    _splitOuter(item) {
        if (item == null) {
            return [];
        }
        if (item.indexOf(",") == -1) {
            return [item];
        }
        let parts = item.split(",");
        for (let i = 0; i < parts.length; i++) {
            if (parts[i]) {
                parts[i] = parts[i].trim();
            }
        }
        return parts;
    }
    _fromOuter(outer) {
        if (outer._isIgxCollection) {
            return outer;
        }
        if (Array.isArray(outer)) {
            for (let i = 0; i < outer.length; i++) {
                this.add(this._ensureOuter(outer[i]));
            }
            return this;
        }
        let split = this._splitOuter(outer);
        for (let i = 0; i < split.length; i++) {
            this.add(this._ensureOuter(split[i]));
        }
        return this;
    }
    constructor() {
        this._isIgxCollection = true;
        this._inner = null;
        this._innerColl = null;
        this._innerColl = this._createInnerColl();
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

class IgEvent {
    constructor() {
        this._callbacks = [];
    }
    emit(sender, args) {
        for (let i = 0; i < this._callbacks.length; i++) {
            this._callbacks[i](sender, args);
        }
    }
    add(callback) {
        this._callbacks.push(callback);
    }
    remove(callback) {
        let ind = this._callbacks.indexOf(callback);
        if (ind >= 0) {
            this._callbacks.splice(ind, 1);
        }
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function isPoint(p) {
    if (p == null)
        return false;
    if (typeCast(Point_$type, p) != null)
        return true;
    if (typeof p.x === "number" && typeof p.y === "number")
        return true;
    return false;
}
function pointFromLiteral(p) {
    if (p == null)
        return PointUtil.create();
    var cast = typeCast(Point_$type, p);
    if (cast != null)
        return cast;
    return PointUtil.createXY(p.x, p.y);
}
function pointToLiteral(p) {
    if (p == null)
        return null;
    return { x: p.x, y: p.y };
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function isRect(r) {
    if (r == null)
        return false;
    if (typeCast(Rect.$t, r) != null)
        return true;
    if (typeof r.x === "number" && typeof r.y === "number" &&
        typeof r.width === "number" && typeof r.height === "number")
        return true;
    //if (typeof r.left === "number" && typeof r.top === "number" &&
    //    typeof r.right === "number" && typeof r.bottom === "number")
    //    return true;
    return false;
}
function rectFromLiteral(r) {
    if (r == null)
        return new Rect(0, 0, 0, 0, 0);
    var cast = typeCast(Rect.$t, r);
    if (cast != null)
        return cast;
    return new Rect(0, r.left, r.top, r.width, r.height);
}
function rectToLiteral(r) {
    if (r == null)
        return null;
    return { left: r.left, top: r.top, width: r.width, height: r.height };
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function isSize(s) {
    if (s == null)
        return false;
    if (typeCast(Size.$t, s) != null)
        return true;
    if (typeof s.width === "number" && typeof s.height === "number")
        return true;
    return false;
}
function sizeFromLiteral(s) {
    if (s == null)
        return new Size(1, 0, 0);
    var cast = typeCast(Size.$t, s);
    if (cast != null)
        return cast;
    return new Size(1, s.width, s.height);
}
function sizeToLiteral(s) {
    if (s == null)
        return null;
    return { width: s.width, height: s.height };
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class PromiseWrapper {
    constructor(inner) {
        this._state = "pending";
        this._resolvedValue = null;
        this._rejectedError = null;
        this._then = [];
        this._fail = [];
        this._always = [];
        this._promise = inner;
        this._promise
            .then((v) => {
            this._state = "resolved";
            this._resolvedValue = v;
            for (var i = 0; i < this._then.length; i++) {
                this._then[i](v);
            }
            for (var i = 0; i < this._always.length; i++) {
                this._always[i](v);
            }
        })
            .catch((e) => {
            this._state = "rejected";
            this._rejectedError = e;
            for (var i = 0; i < this._fail.length; i++) {
                this._fail[i](e);
            }
            for (var i = 0; i < this._always.length; i++) {
                this._always[i](e);
            }
        });
    }
    state() {
        return this._state;
    }
    then(pass, fail) {
        this.done(pass);
        this.fail(fail);
        return this;
    }
    done(continuation) {
        this._then.push(continuation);
        if (this._state == "resolved") {
            continuation(this._resolvedValue);
        }
        return this;
    }
    fail(continuation) {
        this._fail.push(continuation);
        if (this._state == "failed") {
            continuation(this._rejectedError);
        }
        return this;
    }
    always(continuation) {
        this._always.push(continuation);
        if (this._state == "resolved") {
            continuation(this._resolvedValue);
        }
        if (this._state == "failed") {
            continuation(this._rejectedError);
        }
        return this;
    }
}
class PromiseFactory {
    constructor() {
        this._wrapper = null;
    }
    resolve(result) {
        if (this._resolve) {
            this._resolve(result);
        }
    }
    reject(error) {
        if (this._reject) {
            this._reject(error);
        }
    }
    promise() {
        this._promise = new Promise((resolve, reject) => {
            this._resolve = resolve;
            this._reject = reject;
        });
        this._wrapper = new PromiseWrapper(this._promise);
        return this._wrapper;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let ReflectionUtil = /*@__PURE__*/ (() => {
    class ReflectionUtil {
    }
    ReflectionUtil.getPropertyGetter = function (type, propertyName) {
        if (typeof type.prototype[propertyName] === "function") {
            return function (instance) {
                return type.prototype[propertyName].apply(instance, arguments);
            };
        }
        return function (instance) {
            return instance[propertyName];
        };
    };
    return ReflectionUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function sleep(milliseconds) {
    var start = new Date().getTime();
    for (var i = 0; i < 1e7; i++) {
        if ((new Date().getTime() - start) > milliseconds) {
            break;
        }
    }
}
;

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let XmlDocument_$type = /*@__PURE__*/ new Type(null, 'XmlDocument');
let XmlElement_$type = /*@__PURE__*/ new Type(null, 'XmlElement');
let XmlNode_$type = /*@__PURE__*/ new Type(null, 'XmlNode');
let XmlAttribute_$type = /*@__PURE__*/ new Type(null, 'XmlAttribute');
let XmlLinkedNode_$type = /*@__PURE__*/ new Type(null, 'XmlLinkedNode');
let XmlNodeList_$type = /*@__PURE__*/ new Type(null, 'XmlNodeList');
let XmlNamedNodeMap_$type = /*@__PURE__*/ new Type(null, 'XmlNamedNodeMap');
var XmlNodeType = /*@__PURE__*/ (function (XmlNodeType) {
    XmlNodeType[XmlNodeType["None"] = 0] = "None";
    XmlNodeType[XmlNodeType["Element"] = 1] = "Element";
    XmlNodeType[XmlNodeType["Attribute"] = 2] = "Attribute";
    XmlNodeType[XmlNodeType["Text"] = 3] = "Text";
    XmlNodeType[XmlNodeType["CDATA"] = 4] = "CDATA";
    XmlNodeType[XmlNodeType["EntityReference"] = 5] = "EntityReference";
    XmlNodeType[XmlNodeType["Entity"] = 6] = "Entity";
    XmlNodeType[XmlNodeType["ProcessingInstruction"] = 7] = "ProcessingInstruction";
    XmlNodeType[XmlNodeType["Comment"] = 8] = "Comment";
    XmlNodeType[XmlNodeType["Document"] = 9] = "Document";
    XmlNodeType[XmlNodeType["DocumentType"] = 10] = "DocumentType";
    XmlNodeType[XmlNodeType["DocumentFragment"] = 11] = "DocumentFragment";
    XmlNodeType[XmlNodeType["Notation"] = 12] = "Notation";
    XmlNodeType[XmlNodeType["Whitespace"] = 13] = "Whitespace";
    XmlNodeType[XmlNodeType["SignificantWhitespace"] = 14] = "SignificantWhitespace";
    XmlNodeType[XmlNodeType["EndElement"] = 15] = "EndElement";
    XmlNodeType[XmlNodeType["EndEntity"] = 16] = "EndEntity";
    XmlNodeType[XmlNodeType["XmlDeclaration"] = 17] = "XmlDeclaration";
    return XmlNodeType;
})({});
let XmlNodeType_$type = /*@__PURE__*/ markEnum("XmlNodeType", "Node,0;Element,1;Attribute,2;Text,3;CData,4;EntityReference,5;Entity,6;ProcessingInstruction,7;Comment,8;Document,9;DocumentType,10;DocumentFragment,11;Notation,12;Whitespace,13;SignificantWhitespace,14;EndElement,15;EndEntity,16;XmlDeclaration,17");

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ILegendContext_$type = /*@__PURE__*/ new Type(null, 'ILegendContext');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataContext = /*@__PURE__*/ (() => {
    class DataContext extends Base {
        constructor() {
            super(...arguments);
            this.c = 0;
            this.g = null;
            this.d = null;
            this.j = null;
            this.l = null;
            this.e = null;
            this.k = null;
            this.a = 0;
            this.f = null;
            this.m = null;
            this.propertyChanged = null;
        }
        get series() {
            return this.g;
        }
        set series(a) {
            this.g = a;
        }
        get item() {
            return this.d;
        }
        set item(a) {
            if (a != this.d) {
                this.d = a;
                this.i("Item");
            }
        }
        get actualItemBrush() {
            return this.j;
        }
        set actualItemBrush(a) {
            if (a != this.j) {
                this.j = a;
                this.i("ActualItemBrush");
            }
        }
        get outline() {
            return this.l;
        }
        set outline(a) {
            if (a != this.l) {
                this.l = a;
                this.i("Outline");
            }
        }
        get itemLabel() {
            return this.e;
        }
        set itemLabel(a) {
            if (a != this.e) {
                this.e = a;
                this.i("ItemLabel");
            }
        }
        get itemBrush() {
            return this.k;
        }
        set itemBrush(a) {
            if (a != this.k) {
                this.k = a;
                this.i("ItemBrush");
            }
        }
        get thickness() {
            return this.a;
        }
        set thickness(a) {
            if (a != this.a) {
                this.a = a;
                this.i("Thickness");
            }
        }
        get legendLabel() {
            return this.f;
        }
        set legendLabel(a) {
            if (a != this.f) {
                this.f = a;
                this.i("LegendLabel");
            }
        }
        i(a) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
        flatten() {
            let series_ = this.series;
            let item_ = this.item;
            let actualItemBrush_ = this.actualItemBrush;
            let outline_ = this.outline;
            let itemLabel_ = this.itemLabel;
            let itemBrush_ = this.itemBrush;
            let thickness_ = this.thickness;
            return { item: item_, itemBrush: actualItemBrush_, outline: outline_, itemLabel: itemLabel_, thickness: thickness_ };
        }
    }
    DataContext.$t = /*@__PURE__*/ markType(DataContext, 'DataContext', Base.$, [ILegendContext_$type, INotifyPropertyChanged_$type]);
    return DataContext;
})();

class IgrDataContext {
    createImplementation() {
        return new DataContext();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get series() {
        return this.i.series.externalObject;
    }
    set series(v) {
        if (v == null) {
            this.i.series = null;
            return;
        }
        this.i.series = v.i;
    }
    /**
 * Gets the item that is in context.
*/
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
    /**
     * Gets the actual resolved brush in use for the item that is in context.
    */
    get actualItemBrush() {
        return brushToString(this.i.actualItemBrush);
    }
    set actualItemBrush(v) {
        this.i.actualItemBrush = stringToBrush(v);
    }
    /**
     * Gets the outline in use for the item in context.
    */
    get outline() {
        return brushToString(this.i.outline);
    }
    set outline(v) {
        this.i.outline = stringToBrush(v);
    }
    /**
     * Gets the label in use for the item in context, if available.
    */
    get itemLabel() {
        return this.i.itemLabel;
    }
    set itemLabel(v) {
        this.i.itemLabel = v;
    }
    /**
     * Gets the potential brush in usage for the item in context.
    */
    get itemBrush() {
        return brushToString(this.i.itemBrush);
    }
    set itemBrush(v) {
        this.i.itemBrush = stringToBrush(v);
    }
    /**
     * Gets the thickness of the item in context.
    */
    get thickness() {
        return this.i.thickness;
    }
    set thickness(v) {
        this.i.thickness = +v;
    }
    /**
     * Gets the legend label to use for the item in context, if available.
    */
    get legendLabel() {
        return this.i.legendLabel;
    }
    set legendLabel(v) {
        this.i.legendLabel = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleCs {
    constructor() {
        this["AssemblyNotIncluded"] = "Nelze načíst soubor {0}.dll. Musíte se ujistit, že toto sestavení je zahrnuto v XAP, který je nasazen na Windows Phone, například přidáním odkazu na něj z některého z vašich projektů.";
        this["BreakEvenTitle_BreakEven"] = "Beze ztrát";
        this["BreakEvenTitle_FixedCost"] = "Fixní cena";
        this["BreakEvenTitle_LossArea"] = "Ztráta prostoru";
        this["BreakEvenTitle_MarginalProfit"] = "Mezní zisk";
        this["BreakEvenTitle_ProfitArea"] = "Zisková oblast";
        this["BreakEvenTitle_SafetyMargin"] = "Bezpečnostní marže";
        this["BreakEvenTitle_SalesRevenue"] = "Tržby";
        this["BreakEvenTitle_TotalCost"] = "Celkové náklady";
        this["BreakEvenTitle_VariableCost"] = "Variabilní náklady";
        this["BubbleSeries_Radius"] = "Poloměr";
        this["DataChart_InteractivityNotLoaded"] = "Byla aktivována funkce interaktivity, ale nebyl načten modul interakce s grafy.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Byla použita funkce zkratky čísel, ale modul zkratky čísel nebyl načten.";
        this["DataChart_VisualDataNotLoaded"] = "Byla zpřístupněna funkce VisualData, ale modul interakce s grafy nebyl načten.";
        this["DataProviderNotInitialized"] = "Poskytovatel dat byl použit bez první inicializace. Před použitím je nutné inicializovat poskytovatele dat.";
        this["DataSource_Summary_Avg"] = "Prům";
        this["DataSource_Summary_Count"] = "Počet";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Součet";
        this["Default_Series_Title"] = "Název série";
        this["FinancialChart_IndicatorMenu_Header"] = "Indikátory";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Samostatné ukazatele";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Překryvy";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Trendové čáry";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Svazky";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Oscilátor absolutního objemu";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Distribuce/Akumulace";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Průměrný směrový index";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Průměrný skutečný rozsah";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Šířka pásma Bollinger";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Chaikin oscilátor";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Chaikin Volatility";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Index komoditních kanálů";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Detrended Price Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Snadnost pohybu";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Rychlý stochastický oscilátor";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Index síly";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Plný stochastický oscilátor";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Index usnadnění trhu";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Hromadný index";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Střední cena";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Index peněžního toku";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Negativní objemový index";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "Objem zůstatku";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Procentní cenový oscilátor";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Procentní objemový oscilátor";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Pozitivní index objemu";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Trend objemu cen";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Pomalý stochastický oscilátor";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Standardní odchylka";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Typická cena";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Konečný oscilátor";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Vážený blízko";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bollingerovy kapely";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Cenový kanál";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Cubic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Kumulativní průměr";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Exponenciální průměr";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Exponenciální přizpůsobení";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Lineární uložení";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Logaritmické přizpůsobení";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Upravený průměr";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "PowerLaw Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Kvadratický tvar";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Quartic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Quintic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Jednoduchý průměr";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Vážený průměr";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Plocha";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Sloupec";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Čára";
        this["FinancialChart_RangeSelector_All"] = "Všechno";
        this["FinancialChart_RangeSelector_From"] = "Z";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 měsíc";
        this["FinancialChart_RangeSelector_OneYear"] = "1 rok";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 měsíce";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 měsíce";
        this["FinancialChart_RangeSelector_To"] = "Na";
        this["FinancialChart_RangeSelector_YearToDate"] = "YTD (Rok do data)";
        this["FinancialSeries_Close"] = "Zavřít";
        this["FinancialSeries_High"] = "Vysoký";
        this["FinancialSeries_Low"] = "Nízký";
        this["FinancialSeries_Open"] = "Otevřeno";
        this["FinancialSeries_Volume"] = "Objem";
        this["NoEncodingsLoaded"] = "Nebyly nalezeny žádné kódování! Načtěte sestavu Infragistics.Encoding nebo se podívejte do dokumentace, jak vytvořit vlastní kódování.";
        this["NotSupportedEncoding"] = "Kódování odpovídající pod {0} {1} není podporováno.";
        this["Object_Sealed"] = "Po zapečetění objektu nejsou úpravy povoleny.";
        this["OPD_DefaultInteraction"] = "Vyberte výchozí interakci tažení myší";
        this["OPD_DragPan"] = "Posuňte povrch";
        this["OPD_DragZoom"] = "Přibližte oblast výběru";
        this["OPD_ScaleToFit"] = "Přizpůsobit obrazovce";
        this["OPD_ScaleToFit_SeriesViewer"] = "Obnovit přiblížení (100%)";
        this["OPD_ZoomIn"] = "Přiblížit";
        this["OPD_ZoomOut"] = "Oddálit";
        this["OPD_ZoomTo100"] = "Přiblížit na 100%";
        this["PieChart_Others"] = "Ostatní";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Úpravy zdroje dat na základě rozsahu nejsou aktuálně podporovány";
        this["ScatterSeries_Value"] = "Hodnota";
        this["TRIAL_VERSION"] = "BEZPLATNÁ ZKUŠEBNÍ VERZE Nakupte na Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleCsModule {
    static register() {
        Localization.register("DataVisualization-cs", new DataVisualizationLocaleCs());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleDa {
    constructor() {
        this["AssemblyNotIncluded"] = "Kan ikke indlæse {0} .dll. Du skal sørge for, at denne samling er inkluderet i XAP, der er implementeret på Windows Phone, for eksempel ved at tilføje en reference til den fra et af dine projekter.";
        this["BreakEvenTitle_BreakEven"] = "Omkostningsnulpunkt";
        this["BreakEvenTitle_FixedCost"] = "Faste omkostninger";
        this["BreakEvenTitle_LossArea"] = "Tabsområde";
        this["BreakEvenTitle_MarginalProfit"] = "Marginal fortjeneste";
        this["BreakEvenTitle_ProfitArea"] = "Profitområde";
        this["BreakEvenTitle_SafetyMargin"] = "Sikkerhedsmargen";
        this["BreakEvenTitle_SalesRevenue"] = "Salgsindtægter";
        this["BreakEvenTitle_TotalCost"] = "Udgifter i alt";
        this["BreakEvenTitle_VariableCost"] = "Variable omkostninger";
        this["BubbleSeries_Radius"] = "Radius";
        this["DataChart_InteractivityNotLoaded"] = "Der blev adgang til interaktivitetsfunktionalitet, men kortinteraktionsmodul er ikke indlæst.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Nummerforkortelsesfunktionalitet blev brugt, men nummerforkortelsesmodulet er ikke indlæst.";
        this["DataChart_VisualDataNotLoaded"] = "VisualData-funktionalitet blev åbnet, men diagraminteraktionsmodulet er ikke indlæst.";
        this["DataProviderNotInitialized"] = "Dataudbyderen blev brugt uden først at initialisere. Dataudbyderen skal initialiseres inden brug.";
        this["DataSource_Summary_Avg"] = "Gns";
        this["DataSource_Summary_Count"] = "Tæl";
        this["DataSource_Summary_Max"] = "Maks";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Sum";
        this["Default_Series_Title"] = "Serietitel";
        this["FinancialChart_IndicatorMenu_Header"] = "Indikatorer";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Frittstående indikatorer";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Overlejringer";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Trendlinjer";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volumener";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Absolute Volume Oscillator (volumenoscillator)";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Akkumulering/Fordeling";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Gennemsnitligt retningsindeks";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Gennemsnitlig sand rækkevidde";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Bollinger-båndbredde";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Chaikin-oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Chaikin-volatilitet";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Varekanalindeks";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Detrended pris-oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Let bevægelse";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Hurtig stokastisk oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Kraft-indeks";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Fuld stokastisk oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Indeks for markedsfacilitering";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Masseindeks";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Medianpris";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Pengeflow-indeks";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Negativt volumenindeks";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "På saldovolumen";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Procentvis pris-oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Procentvis volumenoscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Positivt volumenindeks";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Prisvolumen Trend";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Langsom stokastisk oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Standardafvigelse";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Typisk pris";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Ultimate Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Vægtet luk";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bollinger Bands";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Priskanal";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Kubisk tilpasning";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Kumulativt gennemsnit";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Eksponentielt gennemsnit";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Eksponentiel tilpasning";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Lineær tilpasning";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Logaritmisk tilpasning";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Modificeret gennemsnit";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "PowerLaw tilpasning";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Kvadratisk tilpasning";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Kvartisk tilpasning";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Kvintisk tilpasning";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Simpel gennemsnit";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Vægtet gennemsnit";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Areal";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Kolonne";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Linie";
        this["FinancialChart_RangeSelector_All"] = "Alle";
        this["FinancialChart_RangeSelector_From"] = "Fra";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 måned";
        this["FinancialChart_RangeSelector_OneYear"] = "1 år";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 måneder";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 måneder";
        this["FinancialChart_RangeSelector_To"] = "Til";
        this["FinancialChart_RangeSelector_YearToDate"] = "YTD (År-til-dato)";
        this["FinancialSeries_Close"] = "Tæt";
        this["FinancialSeries_High"] = "Høj";
        this["FinancialSeries_Low"] = "Lav";
        this["FinancialSeries_Open"] = "Åben";
        this["FinancialSeries_Volume"] = "Volumen";
        this["NoEncodingsLoaded"] = "Ingen kodninger fundet! Indlæs Infragistics.Encoding-samlingen eller se i dokumentationen, hvordan du opretter tilpassede kodninger.";
        this["NotSupportedEncoding"] = "Kodningen, der svarer til {0} {1}, understøttes ikke.";
        this["Object_Sealed"] = "Ændringer er ikke tilladt, efter at objektet er forseglet.";
        this["OPD_DefaultInteraction"] = "Vælg standard mus-træk-interaktion";
        this["OPD_DragPan"] = "Panorer overfladen";
        this["OPD_DragZoom"] = "Zoom ind i markeringsområdet";
        this["OPD_ScaleToFit"] = "Tilpas til skærm";
        this["OPD_ScaleToFit_SeriesViewer"] = "Nulstil zoom (100%)";
        this["OPD_ZoomIn"] = "Zoom ind";
        this["OPD_ZoomOut"] = "Zoom ud";
        this["OPD_ZoomTo100"] = "Zoom til 100%";
        this["PieChart_Others"] = "Andre";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Intervalbaserede ændringer af datakilden understøttes i øjeblikket ikke";
        this["ScatterSeries_Value"] = "Værdi";
        this["TRIAL_VERSION"] = "ULICENSERET PRØVNING Køb på Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleDaModule {
    static register() {
        Localization.register("DataVisualization-da", new DataVisualizationLocaleDa());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleDe {
    constructor() {
        this["AssemblyNotIncluded"] = "{0}.dll kann nicht geladen werden. Stellen Sie sicher, dass diese Assembly im für Windows Phone bereitgestellten XAP enthalten ist; fügen Sie ihr hierzu beispielsweise einen Verweis von einem Ihrer Projekte hinzu.";
        this["BreakEvenTitle_BreakEven"] = "Break-Even";
        this["BreakEvenTitle_FixedCost"] = "Fixkosten";
        this["BreakEvenTitle_LossArea"] = "Verlustbereich";
        this["BreakEvenTitle_MarginalProfit"] = "Grenzertrag";
        this["BreakEvenTitle_ProfitArea"] = "Gewinnbereich";
        this["BreakEvenTitle_SafetyMargin"] = "Sicherheitsmarge";
        this["BreakEvenTitle_SalesRevenue"] = "Umsatzerlös";
        this["BreakEvenTitle_TotalCost"] = "Gesamtkosten";
        this["BreakEvenTitle_VariableCost"] = "Variable Kosten";
        this["BubbleSeries_Radius"] = "Radius";
        this["DataChart_InteractivityNotLoaded"] = "Es wurde auf die Interaktivitätsfunktion zugegriffen, aber das Modul für die Diagramminteraktion wurde nicht geladen.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Number abbreviation functionality was used, but the number abbreviator module has not been loaded.";
        this["DataChart_VisualDataNotLoaded"] = "Es wurde auf die VisualData-Funktion zugegriffen, aber das Modul für die Diagramminteraktion wurde nicht geladen.";
        this["DataProviderNotInitialized"] = "Der Datenanbieter wurde ohne vorherige Initialisierung verwendet. Der Datenanbieter muss vor der Verwendung initialisiert werden.";
        this["DataSource_Summary_Avg"] = "Avg";
        this["DataSource_Summary_Count"] = "Count";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Sum";
        this["Default_Series_Title"] = "Reihentitel";
        this["FinancialChart_IndicatorMenu_Header"] = "Anzeigen";
        this["FinancialChart_IndicatorMenu_Header1"] = "Anzeigen";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Eigenständige Anzeigen";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader1"] = "Eigenständige Anzeigen";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Überlagerungen";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader1"] = "Überlagerungen";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Trendlinien";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader1"] = "Trendlinien";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volumen";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader1"] = "Volumen";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Oszillator absolute Menge";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Akkumulationsverteilung";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Durchschnittlicher Richtungsindex";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Durchschnittlicher wahrer Bereich";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Breite des Bollinger-Bands";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Chaikin-Oszillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Chaikin-Volatilität";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Commodity Channel Index";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Oszillator trendbereinigter Preis";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Bewegungsleichtigkeit";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Schneller stochastischer Oszillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Kraftindex";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Vollständiger stochastischer Oszillator";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Market Facilitation Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Massenindex";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Durchschnittlicher Preis";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Geldflussindex";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Negativer Volumenindex";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "On Balance Volume";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Percentage Price Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Percentage Volume Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Positive Volume Index";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "On-Balance-Volumen";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Langsamer stochastischer Oszillator";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Standardabweichung";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stochastik Relative-Stärke-Index";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Typischer Preis";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Ultimate Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Gewichtetes Mittel";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams-Prozentbereich";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bollinger-Bänder";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Preiskanal";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Kubische Anpassung";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Kumulativer Durchschnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Exponentieller Durchschnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Exponentielle Anpassung";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Lineare Anpassung";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Logarithmische Anpassung";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Modifizierter Durchschnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "Potenzgesetz-Entsprechung";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Quadratische Anpassung";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Anpassung vierten Grades";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Anpassung fünften Grades";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Einfacher Durchschnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Gewichteter Durchschnitt";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Bereich";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Spalte";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Linie";
        this["FinancialChart_RangeSelector_All"] = "Alle";
        this["FinancialChart_RangeSelector_From"] = "From";
        this["FinancialChart_RangeSelector_OneMonth"] = "1M";
        this["FinancialChart_RangeSelector_OneYear"] = "1Y";
        this["FinancialChart_RangeSelector_SixMonths"] = "6M";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3M";
        this["FinancialChart_RangeSelector_To"] = "To";
        this["FinancialChart_RangeSelector_YearToDate"] = "YTD";
        this["FinancialSeries_Close"] = "Schließen";
        this["FinancialSeries_High"] = "Hoch";
        this["FinancialSeries_Low"] = "Niedrig";
        this["FinancialSeries_Open"] = "Öffnen";
        this["FinancialSeries_Volume"] = "Lautstärke";
        this["NoEncodingsLoaded"] = "Es wurden keine Codierungen gefunden! Laden Sie die Infragistics.Encoding Assembly oder lesen Sie in der Dokumentation nach, wie Sie benutzerdefinierte Codierungen erstellen.";
        this["NotSupportedEncoding"] = "Die Codierung entsprechend {0} {1} wird nicht unterstützt.";
        this["Object_Sealed"] = "Modifications are not permitted after the object has been sealed.";
        this["OPD_DefaultInteraction"] = "Standardmäßige Interaktion für Ziehen mit Maustaste auswählen";
        this["OPD_DragPan"] = "Die Oberfläche schwenken";
        this["OPD_DragZoom"] = "Auswahlbereich vergrößern";
        this["OPD_ScaleToFit"] = "An Bildschirm anpassen";
        this["OPD_ScaleToFit_SeriesViewer"] = "Zoom zurücksetzen (100%)";
        this["OPD_ZoomIn"] = "Vergrößern";
        this["OPD_ZoomOut"] = "Verkleinern";
        this["OPD_ZoomTo100"] = "Zoommodus 100%";
        this["PieChart_Others"] = "Andere";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Bereichsbasierte Änderungen an der Datenquelle werden aktuell nicht unterstützt";
        this["ScatterSeries_Value"] = "Wert";
        this["TRIAL_VERSION"] = "NICHT LIZENZIERTER TEST Zu kaufen auf Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleDeModule {
    static register() {
        Localization.register("DataVisualization-de", new DataVisualizationLocaleDe());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleEs {
    constructor() {
        this["AssemblyNotIncluded"] = "No se puede cargar {0}.dll. Asegúrese de que este conjunto esté incluido en el XAP que se ejecuta en el Windows Phone, por ejemplo añadiendo una referencia al mismo desde cualquiera de sus proyectos.";
        this["BreakEvenTitle_BreakEven"] = "Break Even";
        this["BreakEvenTitle_FixedCost"] = "Fixed Cost";
        this["BreakEvenTitle_LossArea"] = "Loss Area";
        this["BreakEvenTitle_MarginalProfit"] = "Marginal Profit";
        this["BreakEvenTitle_ProfitArea"] = "Profit Area";
        this["BreakEvenTitle_SafetyMargin"] = "Safety Margin";
        this["BreakEvenTitle_SalesRevenue"] = "Sales Revenue";
        this["BreakEvenTitle_TotalCost"] = "Total Cost";
        this["BreakEvenTitle_VariableCost"] = "Variable Cost";
        this["BubbleSeries_Radius"] = "Radio";
        this["DataChart_InteractivityNotLoaded"] = "Se ha accedido a la función de interactividad, pero no se ha cargado el módulo de interacción de gráficos.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Se ha utilizado la función de abreviatura de número, pero el módulo abreviador de número no se ha cargado.";
        this["DataChart_VisualDataNotLoaded"] = "Se ha accedido a la función Datos visuales, pero no se ha cargado el módulo de interacción de gráficos.";
        this["DataProviderNotInitialized"] = "El proveedor de datos se ha utilizado sin inicializarlo primero. El proveedor de datos debe inicializarse antes de utilizarlo.";
        this["DataSource_Summary_Avg"] = "Avg";
        this["DataSource_Summary_Count"] = "Count";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Sum";
        this["Default_Series_Title"] = "Título de la serie";
        this["FinancialChart_IndicatorMenu_Header"] = "Indicadores";
        this["FinancialChart_IndicatorMenu_Header1"] = "Indicadores";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Indicadores independientes";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader1"] = "Indicadores independientes";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Superposiciones";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader1"] = "Superposiciones";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Líneas de tendencia";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader1"] = "Líneas de tendencia";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volumen";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader1"] = "Volúmenes";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Oscilador de volumen absoluto";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Acumulación/Distribución";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Índice direccional promedio";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Rango medio verdadero";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Ancho de la Banda de Bollinger";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Oscilador de Chaikin";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Volatilidad de Chaikin";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Commodity Channel Index";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Oscilador de precio sin tendencia";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Facilidad de movimiento";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Oscilador estocástico rápido";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Force Index";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Oscilador estocástico total";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Índice de facilitación del mercado";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Índice de masa";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Precio medio";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Índice de flujo monetario";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Índice de volumen negativo";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "Balance de volúmenes";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Oscilador de precios en porcentaje";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Oscilador de volumen en porcentaje";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Índice de volumen positivo";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Price Volume Trend";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Oscilador estocástico lento";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Desviación estándar";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "RSI estocástico";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Precio típico";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Oscilador final";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Cierre ponderado";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bandas de Bollinger";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Canal de precios";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Ajuste cúbico";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Promedio acumulativo";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Promedio exponencial";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Ajuste exponencial";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Ajuste lineal";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Logarithmic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Ajuste logarítmico";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "Ajuste de ley de potencia";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Ajuste cuadrático";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Ajuste cuártico";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Ajuste quíntico";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Promedio simple";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Promedio ponderado";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Área";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Columna";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Línea";
        this["FinancialChart_RangeSelector_All"] = "Todo";
        this["FinancialChart_RangeSelector_From"] = "De";
        this["FinancialChart_RangeSelector_OneMonth"] = "1M";
        this["FinancialChart_RangeSelector_OneYear"] = "1Y";
        this["FinancialChart_RangeSelector_SixMonths"] = "6M";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3M";
        this["FinancialChart_RangeSelector_To"] = "A";
        this["FinancialChart_RangeSelector_YearToDate"] = "YTD";
        this["FinancialSeries_Close"] = "Cerrar";
        this["FinancialSeries_High"] = "Alto";
        this["FinancialSeries_Low"] = "Bajo";
        this["FinancialSeries_Open"] = "Abrir";
        this["FinancialSeries_Volume"] = "Volumen";
        this["NoEncodingsLoaded"] = "No se han encontrado codificaciones. Cargue el conjunto Infragistics.Encoding o consulte la documentación para saber cómo crear codificaciones personalizadas.";
        this["NotSupportedEncoding"] = "La codificación correspondiente bajo {0} {1} no se admite.";
        this["Object_Sealed"] = "No se permiten modificaciones después de haber sellado el objeto.";
        this["OPD_DefaultInteraction"] = "Seleccione la interacción predeterminada de arrastre del ratón";
        this["OPD_DragPan"] = "Aplicar panorámica a la superficie";
        this["OPD_DragZoom"] = "Zoom en el área de selección";
        this["OPD_ScaleToFit"] = "Ajustar a la pantalla";
        this["OPD_ScaleToFit_SeriesViewer"] = "Restablecer zoom (100%)";
        this["OPD_ZoomIn"] = "Acercar";
        this["OPD_ZoomOut"] = "Alejar";
        this["OPD_ZoomTo100"] = "Zoom al 100%";
        this["PieChart_Others"] = "Otros";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Las modificaciones de la fuente de datos basadas en intervalos no son compatibles";
        this["ScatterSeries_Value"] = "Valor";
        this["TRIAL_VERSION"] = "Compre la VERSIÓN DE PRUEBA SIN LICENCIA en Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleEsModule {
    static register() {
        Localization.register("DataVisualization-es", new DataVisualizationLocaleEs());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleFr {
    constructor() {
        this["AssemblyNotIncluded"] = "Impossible de charger {0}.dll. Vous devez vous assurer que cet ensemble est inclus dans le XAP qui est déployé sur le Windows Phone, par exemple, en lui ajoutant une référence depuis l'un de vos projets.";
        this["BreakEvenTitle_BreakEven"] = "Break Even";
        this["BreakEvenTitle_FixedCost"] = "Fixed Cost";
        this["BreakEvenTitle_LossArea"] = "Loss Area";
        this["BreakEvenTitle_MarginalProfit"] = "Marginal Profit";
        this["BreakEvenTitle_ProfitArea"] = "Profit Area";
        this["BreakEvenTitle_SafetyMargin"] = "Safety Margin";
        this["BreakEvenTitle_SalesRevenue"] = "Sales Revenue";
        this["BreakEvenTitle_TotalCost"] = "Total Cost";
        this["BreakEvenTitle_VariableCost"] = "Variable Cost";
        this["BubbleSeries_Radius"] = "Rayon";
        this["DataChart_InteractivityNotLoaded"] = "L’accès aux fonctionnalités d’interactivité a été possible mais le module d’interaction de graphiques n’a pas été chargé.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Les fonctionnalités d’abréviation numérique ont été utilisées, mais le module d’abréviation numérique n’a pas été chargé.";
        this["DataChart_VisualDataNotLoaded"] = "L’accès aux fonctionnalités de données visuelles a été possible mais le module d’interaction de graphiques n’a pas été chargé.";
        this["DataProviderNotInitialized"] = "Le fournisseur de données a été utilisé sans avoir été initialisé au préalable. Le fournisseur de données doit être initialisé avant toute utilisation.";
        this["DataSource_Summary_Avg"] = "Avg";
        this["DataSource_Summary_Count"] = "Count";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Sum";
        this["Default_Series_Title"] = "Titre de série";
        this["FinancialChart_IndicatorMenu_Header"] = "Indicateurs";
        this["FinancialChart_IndicatorMenu_Header1"] = "Indicateurs";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Indicateurs autonomes";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader1"] = "Indicateurs autonomes";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Superpositions";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader1"] = "Superpositions";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Lignes de tendance";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader1"] = "Lignes de tendance";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volume";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader1"] = "Volumes";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Oscillateur de volume absolu";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Accumulation-distribution";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Index directionnel moyen";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Average True Range";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Largeur de la bande de Bollinger";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Oscillateur de Chaikin";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Volatilité de Chaikin";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Commodity Channel Index";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Detrended Price Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Ease Of Movement";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Oscillateur stochastique rapide";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Force Index";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Oscillateur stochastique complet";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Market Facilitation Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Mass Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Prix médian";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Money Flow Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Negative Volume Index";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "Graphique du volume";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Oscillateur du pourcentage de prix";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Oscillateur du pourcentage de volume";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Positive Volume Index";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Price Volume Trend";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Oscillateur stochastique lent";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Écart type";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Prix typique";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Oscillateur ultime";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Clôture pondérée";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bandes de Bollinger";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Price Channel";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Ajustement cubique";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Moyenne cumulée";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Moyenne exponentielle";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Ajustement exponentiel";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Ajustement linéaire";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Ajustement logarithmique";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Moyenne modifiée";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "Ajustement de loi de puissance";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Ajustement quadratique";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Ajustement quartique";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Ajustement quintique";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Ajustement quintique";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Moyenne pondérée";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Zone";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Colonne";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Ligne";
        this["FinancialChart_RangeSelector_All"] = "Tous";
        this["FinancialChart_RangeSelector_From"] = "De";
        this["FinancialChart_RangeSelector_OneMonth"] = "1M";
        this["FinancialChart_RangeSelector_OneYear"] = "1A";
        this["FinancialChart_RangeSelector_SixMonths"] = "6M";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3M";
        this["FinancialChart_RangeSelector_To"] = "To";
        this["FinancialChart_RangeSelector_YearToDate"] = "AAJ";
        this["FinancialSeries_Close"] = "Fermer";
        this["FinancialSeries_High"] = "Haut";
        this["FinancialSeries_Low"] = "Bas";
        this["FinancialSeries_Open"] = "Ouvrir";
        this["FinancialSeries_Volume"] = "Volume";
        this["NoEncodingsLoaded"] = "Aucun encodage n'a été trouvé! Veuillez charger l'ensemble Infragistics.Encoding ou consultez la documentation concernant la création d'encodages personnalisés.";
        this["NotSupportedEncoding"] = "L'encodage correspondant sous la plage {0} {1} n'est pas pris en charge.";
        this["Object_Sealed"] = "Une fois que l’objet a été scellé, les modifications ne sont pas autorisées.";
        this["OPD_DefaultInteraction"] = "Sélectionner l'interaction de glissement de la souris par défaut";
        this["OPD_DragPan"] = "Faire un panoramique de la surface";
        this["OPD_DragZoom"] = "Faire un zoom avant sur la zone de sélection";
        this["OPD_ScaleToFit"] = "Adapter à l'écran";
        this["OPD_ScaleToFit_SeriesViewer"] = "Rétablir le zoom (à 100%)";
        this["OPD_ZoomIn"] = "Zoom avant";
        this["OPD_ZoomOut"] = "Zoom arrière";
        this["OPD_ZoomTo100"] = "Zoom à 100%";
        this["PieChart_Others"] = "Autres";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Les modifications basées sur la plage ne sont actuellement pas prises en charge pour la source des données";
        this["ScatterSeries_Value"] = "Valeur";
        this["TRIAL_VERSION"] = "Achat de la VERSION D’ESSAI SANS LICENCE sur Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleFrModule {
    static register() {
        Localization.register("DataVisualization-fr", new DataVisualizationLocaleFr());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleHu {
    constructor() {
        this["AssemblyNotIncluded"] = "A(z) {0}.dll nem tölthető be. Győződjön meg arról, hogy ez az összeállítás szerepel-e a Windows Phone-ra telepített XAP-ben, például úgy, hogy hozzáad egy arra mutató hivatkozást bármelyik projektjéhez.";
        this["BreakEvenTitle_BreakEven"] = "Nullszaldó";
        this["BreakEvenTitle_FixedCost"] = "Fix költség";
        this["BreakEvenTitle_LossArea"] = "Veszteségterület";
        this["BreakEvenTitle_MarginalProfit"] = "Határnyereség";
        this["BreakEvenTitle_ProfitArea"] = "Nyereségterület";
        this["BreakEvenTitle_SafetyMargin"] = "Biztonsági margin";
        this["BreakEvenTitle_SalesRevenue"] = "Árbevétel";
        this["BreakEvenTitle_TotalCost"] = "Összköltség";
        this["BreakEvenTitle_VariableCost"] = "Változó költség";
        this["BubbleSeries_Radius"] = "Sugár";
        this["DataChart_InteractivityNotLoaded"] = "Az interaktivitási funkció meghívásra került, de a diagram-interakciós modul nem töltődött be.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "A számrövidítési funkció meghívásra került, de a számrövidítő modul nem töltődött be.";
        this["DataChart_VisualDataNotLoaded"] = "A VisualData funkció meghívásra került, de a diagram-interakciós modul nem töltődött be.";
        this["DataProviderNotInitialized"] = "Az adatszolgáltatót inicializálás nélkül használták. Az adatszolgáltatót inicializálni kell használat előtt.";
        this["DataSource_Summary_Avg"] = "Átlag";
        this["DataSource_Summary_Count"] = "Darab";
        this["DataSource_Summary_Max"] = "Maximum";
        this["DataSource_Summary_Min"] = "Minimum";
        this["DataSource_Summary_Sum"] = "Szum";
        this["Default_Series_Title"] = "Adatsor címe";
        this["FinancialChart_IndicatorMenu_Header"] = "Mutatók";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Önálló mutatók";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Rétegek";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Trendvonalak";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volumenek";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Abszolút volumen oszcillátor";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Kumulatív/Eloszlás";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Átlagolt irányindex";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Átlagolt valós tartomány";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Bollinger szalag szélessége";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Chaikin oszcillátor";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Chaikin volatilitás";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Árucsatorna-index";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Trendmentesített ároszcillátor";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Árfolyam nyugodtsága";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Gyors sztochasztikus oszcillátor";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Force Index";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Teljes sztochasztikus oszcillátor";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Piackönnyítési index";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Volumen index";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Medián ár";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Pénzforgalmi index";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Negatív volumen index";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "Egyensúlyi volumen";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Százalékos ár oszcillátor";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Százalékos volumen oszcillátor";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Pozitív volumen index";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Ár-volumen trend";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Lassú sztochasztikus oszcillátor";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Szórás";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Sztochasztikus RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Tipikus ár";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Végső oszcillátor";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Súlyozott záróérték";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bollinger szalagok";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Árcsatorna";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Harmadfokú illesztés";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Halmozott átlag";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Exponenciális mozgóátlag";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Exponenciális illesztés";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Lineáris illesztés";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Logaritmikus illesztés";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Módosított átlag";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "Hatványfüggvényes illesztés";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Másodfokú illesztés";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Negyedfokú illesztés";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Ötödfokú illesztés";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Számtani átlag";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Súlyozott átlag";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Terület";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Oszlop";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Vonal";
        this["FinancialChart_RangeSelector_All"] = "Összes";
        this["FinancialChart_RangeSelector_From"] = "Ettől";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 hó";
        this["FinancialChart_RangeSelector_OneYear"] = "1 év";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 hó";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 hó";
        this["FinancialChart_RangeSelector_To"] = "Eddig";
        this["FinancialChart_RangeSelector_YearToDate"] = "Tárgyév";
        this["FinancialSeries_Close"] = "Záró";
        this["FinancialSeries_High"] = "Legmagasabb";
        this["FinancialSeries_Low"] = "Legalacsonyabb";
        this["FinancialSeries_Open"] = "Nyitó";
        this["FinancialSeries_Volume"] = "Volumen";
        this["NoEncodingsLoaded"] = "Nem találhatók kódolások! Töltse be az Infragistics.Encoding összeállítást, vagy nézzen utána a dokumentációban, hogy miként lehet létrehozni egyéni kódolást.";
        this["NotSupportedEncoding"] = "A(z) {0} {1} alatt található kódolás nem támogatott.";
        this["Object_Sealed"] = "Az objektum lezárása után nem végezhetők módosítások.";
        this["OPD_DefaultInteraction"] = "Válassza ki az egérhúzáshoz rendelt alapértelmezett műveletet";
        this["OPD_DragPan"] = "Nézet csúsztatása";
        this["OPD_DragZoom"] = "Nagyítás a kijelölésre";
        this["OPD_ScaleToFit"] = "Képernyőhöz igazítás";
        this["OPD_ScaleToFit_SeriesViewer"] = "Nagyítás visszaállítása (100%)";
        this["OPD_ZoomIn"] = "Nagyítás";
        this["OPD_ZoomOut"] = "Kicsinyítés";
        this["OPD_ZoomTo100"] = "Nagyítás 100%-ra";
        this["PieChart_Others"] = "Egyebek";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Az adatforrás tartományalapú módosítása jelenleg nem támogatott";
        this["ScatterSeries_Value"] = "Érték";
        this["TRIAL_VERSION"] = "LICENC NÉLKÜLI PRÓBAVERZIÓ Vásárlás az Infragistics.com oldalon";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleHuModule {
    static register() {
        Localization.register("DataVisualization-hu", new DataVisualizationLocaleHu());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleIt {
    constructor() {
        this["AssemblyNotIncluded"] = "Impossibile caricare {0}.dll. È necessario assicurarsi che questo assembly sia incluso nell’XAP distribuito su Windows Phone, ad esempio aggiungendo un riferimento ad esso da uno qualsiasi dei progetti.";
        this["BreakEvenTitle_BreakEven"] = "Pareggio finanziario";
        this["BreakEvenTitle_FixedCost"] = "Costo fisso";
        this["BreakEvenTitle_LossArea"] = "Area perdite";
        this["BreakEvenTitle_MarginalProfit"] = "Profitto marginale";
        this["BreakEvenTitle_ProfitArea"] = "Area di profitto";
        this["BreakEvenTitle_SafetyMargin"] = "Margine di sicurezza";
        this["BreakEvenTitle_SalesRevenue"] = "Entrate di vendita";
        this["BreakEvenTitle_TotalCost"] = "Costo totale";
        this["BreakEvenTitle_VariableCost"] = "Costo variabile";
        this["BubbleSeries_Radius"] = "Raggio";
        this["DataChart_InteractivityNotLoaded"] = "Accesso alla funzionalità di interattività ma il modulo di interazione grafico non è stato caricato.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "È stata utilizzata la funzionalità di abbreviazione numerica, ma il modulo di abbreviazione numerica non è stato caricato.";
        this["DataChart_VisualDataNotLoaded"] = "Accesso alla funzionalità VisualData ma il modulo di interazione grafico non è stato caricato.";
        this["DataProviderNotInitialized"] = "Il provider di dati è stato utilizzato senza prima inizializzare. Il provider di dati deve essere inizializzato prima dell'uso.";
        this["DataSource_Summary_Avg"] = "Media";
        this["DataSource_Summary_Count"] = "Conteggio";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Somma";
        this["Default_Series_Title"] = "Titolo serie";
        this["FinancialChart_IndicatorMenu_Header"] = "Indicatori";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Indicatori autonomi";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Sovrapposizioni";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Linee di tendenza";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volumi";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Oscillatore di volume assoluto";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Distribuzione accumulo";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Indice direzionale medio";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Intervallo medio vero";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Larghezza della banda di Bollinger";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Chaikin Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Volatilità del Chaikin";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Indice dei canali merceologici";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Oscillatore a prezzo differenziato";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Facilità di movimento";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Oscillatore stocastico veloce";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Force Index";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Oscillatore stocastico completo";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Indice di facilitazione del mercato";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Indice di massa";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Prezzo medio";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Indice del flusso di denaro";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "Convergenza/divergenza media mobile";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Indice di volume negativo";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "Volume del saldo";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Oscillatore prezzo percentuale";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Oscillatore volume percentuale";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Indice di volume positivo";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Andamento volume prezzo";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "Indice di forza relativa (RSI)";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Oscillatore stocastico lento";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Deviazione standard";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Prezzo tipico";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Oscillatore Ultimate";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Chiusura ponderata";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bande di Bollinger";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Canale di prezzo";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Adattamento a terzo grado";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Media cumulativa";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Media esponenziale";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Adattamento esponenziale";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Adattamento lineare";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Adattamento logaritmico";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Media modificata";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "PowerLaw Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Adattamento a secondo grado";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Adattamento a quarto grado";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Adattamento a quinto grado";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Media semplice";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Media ponderata";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Area";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Colonna";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Riga";
        this["FinancialChart_RangeSelector_All"] = "Tutto";
        this["FinancialChart_RangeSelector_From"] = "Da";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 mese";
        this["FinancialChart_RangeSelector_OneYear"] = "1 anno";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 mesi";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 mesi";
        this["FinancialChart_RangeSelector_To"] = "A";
        this["FinancialChart_RangeSelector_YearToDate"] = "Da inizio anno";
        this["FinancialSeries_Close"] = "Chiudi";
        this["FinancialSeries_High"] = "Alto";
        this["FinancialSeries_Low"] = "Basso";
        this["FinancialSeries_Open"] = "Aperto";
        this["FinancialSeries_Volume"] = "Volume";
        this["NoEncodingsLoaded"] = "Nessuna codifica trovata! Caricare l’assembly Infragistics.Encoding o consultare la documentazione su come creare codifiche personalizzate.";
        this["NotSupportedEncoding"] = "La codifica corrispondente in {0} {1} non è supportata.";
        this["Object_Sealed"] = "Modifiche non sono consentite dopo che l'oggetto è stato sigillato.";
        this["OPD_DefaultInteraction"] = "Selezionare l’interazione di trascinamento del mouse predefinita";
        this["OPD_DragPan"] = "Panoramica della superficie";
        this["OPD_DragZoom"] = "Zoom l'area di selezione";
        this["OPD_ScaleToFit"] = "Adatta allo schermo";
        this["OPD_ScaleToFit_SeriesViewer"] = "Reimposta zoom (100%)";
        this["OPD_ZoomIn"] = "Zoom avanti";
        this["OPD_ZoomOut"] = "Zoom indietro";
        this["OPD_ZoomTo100"] = "Zoom 100%";
        this["PieChart_Others"] = "Altri";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Modifiche dell’origine dati basate sull’intervallo non sono attualmente supportate";
        this["ScatterSeries_Value"] = "Valore";
        this["TRIAL_VERSION"] = "PROVA SENZA LICENZA Per acquistare: Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleItModule {
    static register() {
        Localization.register("DataVisualization-it", new DataVisualizationLocaleIt());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleJa {
    constructor() {
        this["AssemblyNotIncluded"] = "{0}.dll を読み込めません。このアセンブリが Windows Phone にデプロイされる XAP に含まれることを確認してください (プロジェクトから参照を追加など)。";
        this["BreakEvenTitle_BreakEven"] = "損益分岐点";
        this["BreakEvenTitle_FixedCost"] = "固定費";
        this["BreakEvenTitle_LossArea"] = "損失領域";
        this["BreakEvenTitle_MarginalProfit"] = "限界利益";
        this["BreakEvenTitle_ProfitArea"] = "利益領域";
        this["BreakEvenTitle_SafetyMargin"] = "安全余裕率";
        this["BreakEvenTitle_SalesRevenue"] = "売上収益";
        this["BreakEvenTitle_TotalCost"] = "総費用";
        this["BreakEvenTitle_VariableCost"] = "変動費";
        this["BubbleSeries_Radius"] = "半径";
        this["DataChart_InteractivityNotLoaded"] = "インタラクティブ機能にアクセスがありましたがインタラクション モジュールが読み込まれていません。";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "数値省略機能が使用されましたが、数値省略モジュールが読み込まれていません。";
        this["DataChart_VisualDataNotLoaded"] = "VisualData 機能にアクセスがありましたがインタラクション モジュールが読み込まれていません。";
        this["DataProviderNotInitialized"] = "初期化されていないデータ プロバイダーが使用されました。データ プロバイダーは使用前に初期化する必要があります。";
        this["DataSource_Summary_Avg"] = "Avg";
        this["DataSource_Summary_Count"] = "Count";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Sum";
        this["Default_Series_Title"] = "シリーズ タイトル";
        this["FinancialChart_IndicatorMenu_Header"] = "インジケーター";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "スタンドアロン インジケーター";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "オーバーレイ";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "トレンドライン";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "ボリューム";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "絶対出来高オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "蓄積/分配";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "平均方向性指数";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "ATR (アベレージ トゥルー レンジ)";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "ボリンジャー バンド幅";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "チャイキン オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "チャイキン ボラティリティ";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "商品チャネル指数 (CCI)";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "トレンド除去価格オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "イーズ オブ ムーブメント";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "ファスト スト キャスティクス オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "フォース インデックス";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "フル ストキャスティクス オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "マーケット ファシリテーション インデックス";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "マス インデックス";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "メディアンプライス";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "マネー フロー インデックス";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "負出来高指数 (NVI)";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "OBV (オン バランス ボリューム) インジケーター";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "パーセンテージ価格オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "パーセンテージ出来高オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "PVI (ポジティブ ボリューム インデックス)";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "価格出来高トレンド";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "スロー ストキャスティクス オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "標準偏差";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "ストキャスティクス RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "代表価格";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "アルティメット オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "加重終値";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "ウィリアム パーセント";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "ボリンジャー バンド";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "プライス チャネル";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "キュービック フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "累加平均";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "指数平均";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "指数フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "リニア フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "対数フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "修正平均";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "PowerLaw フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "二次フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "四次フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "五次フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "単純平均";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "加重平均";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "エリア";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "柱状";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "折れ線";
        this["FinancialChart_RangeSelector_All"] = "すべて";
        this["FinancialChart_RangeSelector_From"] = "開始:";
        this["FinancialChart_RangeSelector_OneMonth"] = "1か月";
        this["FinancialChart_RangeSelector_OneYear"] = "1年";
        this["FinancialChart_RangeSelector_SixMonths"] = "6か月";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3か月";
        this["FinancialChart_RangeSelector_To"] = "終了:";
        this["FinancialChart_RangeSelector_YearToDate"] = "累計";
        this["FinancialSeries_Close"] = "終値";
        this["FinancialSeries_High"] = "高値";
        this["FinancialSeries_Low"] = "安値";
        this["FinancialSeries_Open"] = "始値";
        this["FinancialSeries_Volume"] = "ボリューム";
        this["NoEncodingsLoaded"] = "Infragistics.Encoding アセンブリを読み込むか、ヘルプのカスタム エンコーティングを作成する方法を参照してください。";
        this["NotSupportedEncoding"] = "{0} {1} に対するエンコード化はサポートされていません。";
        this["Object_Sealed"] = "オブジェクトがシールドされた後は変更できません。";
        this["OPD_DefaultInteraction"] = "マウス ドラッグ操作";
        this["OPD_DragPan"] = "サーフェスのパン";
        this["OPD_DragZoom"] = "選択領域にズーム";
        this["OPD_ScaleToFit"] = "画面に合わせる";
        this["OPD_ScaleToFit_SeriesViewer"] = "ズームのリセット (100%)";
        this["OPD_ZoomIn"] = "拡大";
        this["OPD_ZoomOut"] = "縮小";
        this["OPD_ZoomTo100"] = "100% にズーム";
        this["PieChart_Others"] = "その他";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "データ ソースの範囲を基にした変更は現在サポートされていません。";
        this["ScatterSeries_Value"] = "値";
        this["TRIAL_VERSION"] = "トライアル版 (購入は jp.infragistics.com)";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleJaModule {
    static register() {
        Localization.register("DataVisualization-ja", new DataVisualizationLocaleJa());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleKo {
    constructor() {
        this["AssemblyNotIncluded"] = "{0}.dll 을 로딩할 수 없습니다. 예를 들면, 프로젝트에서 참조를 추가하여 이 어셈블리가 Windows Phone 에 배포된 XAP 에 포함되어 있는지 확인해야 합니다.";
        this["BreakEvenTitle_BreakEven"] = "손익분기점";
        this["BreakEvenTitle_FixedCost"] = "고정 비용";
        this["BreakEvenTitle_LossArea"] = "손실 영역";
        this["BreakEvenTitle_MarginalProfit"] = "한계 수익";
        this["BreakEvenTitle_ProfitArea"] = "수익 영역";
        this["BreakEvenTitle_SafetyMargin"] = "안전 여유";
        this["BreakEvenTitle_SalesRevenue"] = "매출 수입";
        this["BreakEvenTitle_TotalCost"] = "총 비용";
        this["BreakEvenTitle_VariableCost"] = "가변 비용";
        this["BubbleSeries_Radius"] = "범위";
        this["DataChart_InteractivityNotLoaded"] = "상호 작용 기능에 접속했지만 차트 상호 작용 모듈이 로딩되지 않았습니다.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "숫자 약어 기능을 사용했지만 숫자 약어 모듈이 로딩되지 않았습니다.";
        this["DataChart_VisualDataNotLoaded"] = "VisualData 기능에 접속했지만 차트 상호 작용 모듈이 로딩되지 않았습니다.";
        this["DataProviderNotInitialized"] = "데이터 제공자를 먼저 초기화하지 않고 사용했습니다. 사용하기 전에 데이터 제공자를 초기화해야 합니다.";
        this["DataSource_Summary_Avg"] = "평균";
        this["DataSource_Summary_Count"] = "총계";
        this["DataSource_Summary_Max"] = "최대";
        this["DataSource_Summary_Min"] = "최소";
        this["DataSource_Summary_Sum"] = "합계";
        this["Default_Series_Title"] = "시리즈 타이틀";
        this["FinancialChart_IndicatorMenu_Header"] = "인디케이터";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "독립형 인디케이터";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "오버레이";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "추세선";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "거래량";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "절대 거래량 지표";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "누적/분포";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "평균 지향 지수";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "평균 참 범위";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "볼린저 밴드 폭";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "차이킨 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "차이킨 변동성";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "커머더티 채널 인덱스";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "디트렌드 프라이스 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "이지 오브 무브먼트";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "패스트 스토캐스틱 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "강도 지수";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "풀 스토캐스틱 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "시장 촉진 지수";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "매스 인덱스";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "메디안 프라이스";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "자금 흐름 지표";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "네거티브 볼륨 인덱스";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "온 밸런스 볼륨";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "퍼센티지 프라이스 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "퍼센티지 볼륨 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "포지티브 볼륨 인덱스";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "프라이스 볼륨 트렌드";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "슬로 스토캐스틱 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "표준 편차";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "스토캐스틱 RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "티피컬 프라이스";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "얼티미트 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "웨이티드 클로즈";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "윌리엄스 %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "볼린저 밴드";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "프라이스 채널";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "큐빅 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "누적 평균";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "지수 평균";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "지수 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "선형 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "대수 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "수정된 평균";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "멱법칙 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "2 차 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "4 차 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "5 차 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "단순 평균";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "가중 평균";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "영역";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "열";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "선";
        this["FinancialChart_RangeSelector_All"] = "모두";
        this["FinancialChart_RangeSelector_From"] = "부터";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 개월";
        this["FinancialChart_RangeSelector_OneYear"] = "1 년";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 개월";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 개월";
        this["FinancialChart_RangeSelector_To"] = "에";
        this["FinancialChart_RangeSelector_YearToDate"] = "YTD (연간 누계)";
        this["FinancialSeries_Close"] = "닫기";
        this["FinancialSeries_High"] = "고";
        this["FinancialSeries_Low"] = "저";
        this["FinancialSeries_Open"] = "열기";
        this["FinancialSeries_Volume"] = "거래량";
        this["NoEncodingsLoaded"] = "인코딩을 찾을 수 없습니다! Infragistics 를 로딩해 주십시오. 어셈블리를 인코딩하거나 사용자 인코딩 작성 방법에 대한 설명서를 참조해 주십시오.";
        this["NotSupportedEncoding"] = "{0} {1} 에 해당하는 인코딩은 지원되지 않습니다.";
        this["Object_Sealed"] = "개체가 확정된 후에는 수정할 수 없습니다.";
        this["OPD_DefaultInteraction"] = "기본 마우스 드래그 상호 작용 선택";
        this["OPD_DragPan"] = "표면 패닝";
        this["OPD_DragZoom"] = "선택 영역 확대";
        this["OPD_ScaleToFit"] = "화면에 맞춤";
        this["OPD_ScaleToFit_SeriesViewer"] = "줌 재설정 (100%)";
        this["OPD_ZoomIn"] = "확대";
        this["OPD_ZoomOut"] = "축소";
        this["OPD_ZoomTo100"] = "줌 100%";
        this["PieChart_Others"] = "기타";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "데이터 소스의 범위를 기반으로 한 수정은 현재 지원되지 않습니다.";
        this["ScatterSeries_Value"] = "값";
        this["TRIAL_VERSION"] = "Infragistics.com 에서 라이선스가 없는 평가판 구입";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleKoModule {
    static register() {
        Localization.register("DataVisualization-ko", new DataVisualizationLocaleKo());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleNb {
    constructor() {
        this["AssemblyNotIncluded"] = "Kan ikke laste inn {0}.dll. Du må sørge for at denne enheten er inkludert i XAP som er distribuert til Windows Phone, for eksempel ved å legge til en referanse til den fra et av prosjektene dine.";
        this["BreakEvenTitle_BreakEven"] = "Balanse";
        this["BreakEvenTitle_FixedCost"] = "Faste kostnader";
        this["BreakEvenTitle_LossArea"] = "Tapsområde";
        this["BreakEvenTitle_MarginalProfit"] = "Marginalfortjeneste";
        this["BreakEvenTitle_ProfitArea"] = "Profittområde";
        this["BreakEvenTitle_SafetyMargin"] = "Sikkerhetsmargin";
        this["BreakEvenTitle_SalesRevenue"] = "Salgsinntekter";
        this["BreakEvenTitle_TotalCost"] = "Totalkostnad";
        this["BreakEvenTitle_VariableCost"] = "Variable kostnader";
        this["BubbleSeries_Radius"] = "Radius";
        this["DataChart_InteractivityNotLoaded"] = "Interaktivitetsfunksjonalitet ble åpnet, men kartinteraksjonsmodulen er ikke lastet inn.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Nummerforkortelsesfunksjonalitet ble brukt, men nummerforkortelsesmodulen er ikke lastet inn.";
        this["DataChart_VisualDataNotLoaded"] = "VisualData-funksjonalitet ble åpnet, men kartinteraksjonsmodulen er ikke lastet inn.";
        this["DataProviderNotInitialized"] = "Dataleverandøren ble brukt uten å initialisere først. Dataleverandøren må initialiseres før bruk.";
        this["DataSource_Summary_Avg"] = "Gj.sn";
        this["DataSource_Summary_Count"] = "Telle";
        this["DataSource_Summary_Max"] = "Maks";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Sum";
        this["Default_Series_Title"] = "Serietittel";
        this["FinancialChart_IndicatorMenu_Header"] = "Indikatorer";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Frittstående indikatorer";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Overlegg";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Trendlinjer";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volumer";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Absolutt Volumoscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Akkumuleringsfordeling";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Gjennomsnittlig retningsindeks";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Gjennomsnittlig True Range";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Bollinger bandbredde";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Chaikin Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Chaikin volatilitet";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Varekanalindeks";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Detrended Price Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Lett å bevege seg";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Rask stokastisk oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Kraftindeks";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Full stokastisk oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Markedsfasiliteringsindeks";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Masseindeks";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Median pris";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Pengestrømindeks";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Negativ volumindeks";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "On Balance Volume";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Prosentpris oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Prosent volumoscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Positiv volumindeks";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Prisvolumtrend";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Langsom stokastisk oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Standardavvik";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Typisk pris";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Ultimate Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Vektet Lukk";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bollinger-band";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Priskanal";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Cubic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Kumulativ gjennomsnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Eksponensielt gjennomsnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Eksponensiell passform";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Lineær passform";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Logaritmisk passform";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Endret gjennomsnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "PowerLaw Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Kvadratisk passform";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Quartic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Quintic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Enkelt gjennomsnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Vektlagt gjennomsnitt";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Område";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Kolonne";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Linje";
        this["FinancialChart_RangeSelector_All"] = "Alle";
        this["FinancialChart_RangeSelector_From"] = "Fra";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 måned";
        this["FinancialChart_RangeSelector_OneYear"] = "1 år";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 måneder";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 måneder";
        this["FinancialChart_RangeSelector_To"] = "Til";
        this["FinancialChart_RangeSelector_YearToDate"] = "År til dato";
        this["FinancialSeries_Close"] = "Lukk";
        this["FinancialSeries_High"] = "Høy";
        this["FinancialSeries_Low"] = "Lav";
        this["FinancialSeries_Open"] = "Åpen";
        this["FinancialSeries_Volume"] = "Volum";
        this["NoEncodingsLoaded"] = "Ingen kodinger er funnet! Last inn Infragistics.Encoding-enheten, eller se på dokumentasjonen hvordan du lager egendefinerte kodinger.";
        this["NotSupportedEncoding"] = "Kodingen som tilsvarer under {0} {1} støttes ikke.";
        this["Object_Sealed"] = "Endringer er ikke tillatt etter at objektet er forseglet.";
        this["OPD_DefaultInteraction"] = "Velg standard musedrag-interaksjon";
        this["OPD_DragPan"] = "Panorer overflaten";
        this["OPD_DragZoom"] = "Zoom inn til valgområdet";
        this["OPD_ScaleToFit"] = "Tilpass til skjermen";
        this["OPD_ScaleToFit_SeriesViewer"] = "Tilbakestill zoom (100%)";
        this["OPD_ZoomIn"] = "Zoom inn";
        this["OPD_ZoomOut"] = "Zoome ut";
        this["OPD_ZoomTo100"] = "Zoom til 100%";
        this["PieChart_Others"] = "Andre";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Områdebaserte modifikasjoner av datakilden støttes foreløpig ikke";
        this["ScatterSeries_Value"] = "Verdi";
        this["TRIAL_VERSION"] = "ULISENSISERT PRØVE Kjøp på Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleNbModule {
    static register() {
        Localization.register("DataVisualization-nb", new DataVisualizationLocaleNb());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleNl {
    constructor() {
        this["AssemblyNotIncluded"] = "Kan {0}.dll niet laden. U moet ervoor zorgen dat deze assembly is opgenomen in de XAP die op de Windows Phone is geïmplementeerd, bijvoorbeeld door er vanuit al uw projecten een verwijzing naar toe te voegen.";
        this["BreakEvenTitle_BreakEven"] = "Break-even";
        this["BreakEvenTitle_FixedCost"] = "Vaste kosten";
        this["BreakEvenTitle_LossArea"] = "Verliesgebied";
        this["BreakEvenTitle_MarginalProfit"] = "Marginale winst";
        this["BreakEvenTitle_ProfitArea"] = "Winstgebied";
        this["BreakEvenTitle_SafetyMargin"] = "Veiligheidsmarge";
        this["BreakEvenTitle_SalesRevenue"] = "Verkoopopbrengst";
        this["BreakEvenTitle_TotalCost"] = "Totale kosten";
        this["BreakEvenTitle_VariableCost"] = "Variabele kosten";
        this["BubbleSeries_Radius"] = "Radius";
        this["DataChart_InteractivityNotLoaded"] = "Er is toegang geweest tot de interactiviteitsfunctie, maar de grafiekinteractiemodule is niet geladen.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Er werd een functie voor getalafkorting gebruikt, maar de getalafkortingsmodule is niet geladen.";
        this["DataChart_VisualDataNotLoaded"] = "Er is toegang geweest tot de VisualData-functie, maar de grafiekinteractiemodule is niet geladen.";
        this["DataProviderNotInitialized"] = "Gegevensprovider is gebruikt zonder eerst te initialiseren. De gegevensprovider moet vóór gebruik worden geïnitialiseerd.";
        this["DataSource_Summary_Avg"] = "Gem";
        this["DataSource_Summary_Count"] = "Aant";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Som";
        this["Default_Series_Title"] = "Serietitel";
        this["FinancialChart_IndicatorMenu_Header"] = "Indicatoren";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Standalone indicatoren";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Overlays";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Trendlijnen";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volumes";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Oscillator met absoluut volume";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Accumulatie/Distributie";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Gemiddelde richtingindex";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Gemiddeld werkelijk bereik";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Bollinger-bandbreedte";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Chaikin-oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Chaikin-volatiliteit";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Commodity Channel Index";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Prijsoscillator zonder trend";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Ease Of Movement";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Snelle stochastische oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Krachtindex";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Volledige stochastische oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Market Facilitation Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Mass Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Mediane prijs";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Money Flow Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Negative Volume Index";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "On Balance Volume";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Percentage prijsoscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Percentage volumeoscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Positive Volume Index";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Prijsvolumetrend";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Langzame stochastische oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Standaardafwijking";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Normale prijs";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Ultieme oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Gewogen sluiten";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bollinger-banden";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Prijskanaal";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Derdegraads passend";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Cumulatief gemiddelde";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Exponentieel gemiddelde";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Exponentieel passend";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Lineair passend";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Logaritmisch passend";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Gewijzigd gemiddelde";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "Machtswet passend";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Kwadratisch passend";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Vierdegraads passend";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Vijfdegraads passend";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Eenvoudig gemiddelde";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Gewogen gemiddelde";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Gebied";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Kolom";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Lijn";
        this["FinancialChart_RangeSelector_All"] = "Alles";
        this["FinancialChart_RangeSelector_From"] = "Van";
        this["FinancialChart_RangeSelector_OneMonth"] = "1M";
        this["FinancialChart_RangeSelector_OneYear"] = "1J";
        this["FinancialChart_RangeSelector_SixMonths"] = "6M";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3M";
        this["FinancialChart_RangeSelector_To"] = "Tot";
        this["FinancialChart_RangeSelector_YearToDate"] = "JTH";
        this["FinancialSeries_Close"] = "Sluiten";
        this["FinancialSeries_High"] = "Hoog";
        this["FinancialSeries_Low"] = "Laag";
        this["FinancialSeries_Open"] = "Open";
        this["FinancialSeries_Volume"] = "Volume";
        this["NoEncodingsLoaded"] = "Er zijn geen coderingen gevonden! Laad de assemblage Infragistics.Encoding of bekijk de documentatie voor het maken van aangepaste coderingen.";
        this["NotSupportedEncoding"] = "De codering die overeenkomt met {0} {1} wordt niet ondersteund.";
        this["Object_Sealed"] = "Wijzigingen zijn niet toegestaan nadat het object is verzegeld.";
        this["OPD_DefaultInteraction"] = "Selecteer de standaard interactie voor slepen met de muis";
        this["OPD_DragPan"] = "Pan het oppervlak";
        this["OPD_DragZoom"] = "Inzoomen op selectiegebied";
        this["OPD_ScaleToFit"] = "Aanpassen aan scherm";
        this["OPD_ScaleToFit_SeriesViewer"] = "Zoomen opnieuw instellen (100%)";
        this["OPD_ZoomIn"] = "Inzoomen";
        this["OPD_ZoomOut"] = "Uitzoomen";
        this["OPD_ZoomTo100"] = "Zoomen naar 100%";
        this["PieChart_Others"] = "Overige";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Bereikgebaseerde wijzigingen van de gegevensbron worden momenteel niet ondersteund";
        this["ScatterSeries_Value"] = "Waarde";
        this["TRIAL_VERSION"] = "PROEF ZONDER LICENTIE Koop op Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleNlModule {
    static register() {
        Localization.register("DataVisualization-nl", new DataVisualizationLocaleNl());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocalePl {
    constructor() {
        this["AssemblyNotIncluded"] = "Nie można załadować pliku {0}.dll. Upewnij się, że ten zestaw jest uwzględniony w pliku XAP, który jest wdrażany w systemie Windows Phone, na przykład przez dodanie do niego odwołania z dowolnego projektu.";
        this["BreakEvenTitle_BreakEven"] = "Na czysto";
        this["BreakEvenTitle_FixedCost"] = "Koszt stały";
        this["BreakEvenTitle_LossArea"] = "Obszar strat";
        this["BreakEvenTitle_MarginalProfit"] = "Zysk krańcowy";
        this["BreakEvenTitle_ProfitArea"] = "Obszar zysków";
        this["BreakEvenTitle_SafetyMargin"] = "Margines bezpieczeństwa";
        this["BreakEvenTitle_SalesRevenue"] = "Przychody ze sprzedaży";
        this["BreakEvenTitle_TotalCost"] = "Koszt całkowity";
        this["BreakEvenTitle_VariableCost"] = "Koszt zmienny";
        this["BubbleSeries_Radius"] = "Promień";
        this["DataChart_InteractivityNotLoaded"] = "Uzyskano dostęp do funkcji interaktywności, ale moduł interakcji z wykresem nie został załadowany.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Użyto funkcji skracania liczb, ale moduł skracania liczb nie został załadowany.";
        this["DataChart_VisualDataNotLoaded"] = "Uzyskano dostęp do funkcji VisualData, ale moduł interakcji z wykresem nie został załadowany.";
        this["DataProviderNotInitialized"] = "Dostawca danych został użyty bez wcześniejszego zainicjowania. Dostawca danych musi zostać zainicjowany przed użyciem.";
        this["DataSource_Summary_Avg"] = "Śr.";
        this["DataSource_Summary_Count"] = "Liczba";
        this["DataSource_Summary_Max"] = "Maks";
        this["DataSource_Summary_Min"] = "Min.";
        this["DataSource_Summary_Sum"] = "Suma";
        this["Default_Series_Title"] = "Tytuły serii danych";
        this["FinancialChart_IndicatorMenu_Header"] = "Wskaźniki";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Oddzielne wskaźniki";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Nakładki";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Linie trendów";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Woluminy";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Oscylator ilości bezwzględnej";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Akumulacja/Dystrybucja";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Średni wskaźnik ruchu kierunkowego";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Średni prawdziwy zakres zmiany";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Szerokość pasm Bollingera";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Oscylator Chaikina";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Zmienność Chaikina";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Wskaźnik kanału towaru";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Beztrendowy oscylator cenowy (wskaźnik DPO)";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Wskaźnik swobody ruchu";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Szybki oscylator stochastyczny";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Wskaźnik siły";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Pełny oscylator stochastyczny";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Wskaźnik MFI";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Wskaźnik masy";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Mediana ceny";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Wskaźnik przepływów pieniężnych";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Wskaźnik wolumenu ujemnego";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "Wskaźnik OBV";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Oscylator ceny procentowej (PPO)";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Oscylator wolumenu procentowego (PVO)";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Wskaźnik wolumenu dodatniego";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Trend wolumenu cen (PVT)";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Wolny oscylator stochastyczny";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Odchylenie standardowe";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Cena typowa";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Oscylator UO";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Ważone zamknięcie";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "%R Williamsa";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Wstęgi Bollingera";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Cena kanału";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Dopasowanie sześcienne";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Średnia skumulowana";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Średnia wykładnicza";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Dopasowanie wykładnicze";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Dopasowanie liniowe";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Dopasowanie logarytmiczne";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Średnia zmodyfikowana";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "Dopasowanie PowerLaw";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Dopasowanie kwadratowe";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Dopasowanie czwartego stopnia";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Dopasowanie piątego stopnia";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Średnia zwykła";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Średnia ważona";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Obszar";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Kolumna";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Linia";
        this["FinancialChart_RangeSelector_All"] = "Wszystko";
        this["FinancialChart_RangeSelector_From"] = "Od";
        this["FinancialChart_RangeSelector_OneMonth"] = "1M";
        this["FinancialChart_RangeSelector_OneYear"] = "1Y";
        this["FinancialChart_RangeSelector_SixMonths"] = "6M";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3M";
        this["FinancialChart_RangeSelector_To"] = "Do";
        this["FinancialChart_RangeSelector_YearToDate"] = "YTD";
        this["FinancialSeries_Close"] = "Cena zamknięcia";
        this["FinancialSeries_High"] = "Szczyt";
        this["FinancialSeries_Low"] = "Dołek";
        this["FinancialSeries_Open"] = "Cena otwarcia";
        this["FinancialSeries_Volume"] = "Wolumen";
        this["NoEncodingsLoaded"] = "Nie znaleziono żadnych kodowań! Załaduj zestaw Infragistics.Encoding lub zapoznaj się z dokumentacją dotyczącą tworzenia niestandardowych kodowań.";
        this["NotSupportedEncoding"] = "Kodowanie odpowiadające {0} {1} nie jest obsługiwane.";
        this["Object_Sealed"] = "Po zapieczętowaniu obiektu modyfikacje są niedozwolone.";
        this["OPD_DefaultInteraction"] = "Wybierz domyślną interakcję przeciągania myszą";
        this["OPD_DragPan"] = "Przesuwaj powierzchnię";
        this["OPD_DragZoom"] = "Powiększ obszar wyboru";
        this["OPD_ScaleToFit"] = "Dopasuj do ekranu";
        this["OPD_ScaleToFit_SeriesViewer"] = "Resetuj powiększenie (100%)";
        this["OPD_ZoomIn"] = "Powiększ";
        this["OPD_ZoomOut"] = "Pomniejsz";
        this["OPD_ZoomTo100"] = "Powiększenie do 100%";
        this["PieChart_Others"] = "Inne";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Modyfikacje źródła danych oparte na zakresie nie są obecnie obsługiwane";
        this["ScatterSeries_Value"] = "Wartość";
        this["TRIAL_VERSION"] = "Zakup NIELICENCJONOWANEJ WERSJI PRÓBNEJ na Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocalePlModule {
    static register() {
        Localization.register("DataVisualization-pl", new DataVisualizationLocalePl());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocalePt {
    constructor() {
        this["AssemblyNotIncluded"] = "Não é possível carregar {0}.dll. É necessário garantir que esta assemblagem é incluída no XAP implementado no Windows Phone, adicionando-lhe, por exemplo, uma referência a partir de qualquer um dos seus projetos.";
        this["BreakEvenTitle_BreakEven"] = "Break Even";
        this["BreakEvenTitle_FixedCost"] = "Custo fixo";
        this["BreakEvenTitle_LossArea"] = "Área de perda";
        this["BreakEvenTitle_MarginalProfit"] = "Lucro marginal";
        this["BreakEvenTitle_ProfitArea"] = "Área de lucro";
        this["BreakEvenTitle_SafetyMargin"] = "Margem de segurança";
        this["BreakEvenTitle_SalesRevenue"] = "Receita de vendas";
        this["BreakEvenTitle_TotalCost"] = "Custo total";
        this["BreakEvenTitle_VariableCost"] = "Custo variável";
        this["BubbleSeries_Radius"] = "Raio";
        this["DataChart_InteractivityNotLoaded"] = "A funcionalidade de interatividade foi acedida, mas o módulo de interação do gráfico não foi carregado.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "A funcionalidade de abreviação de número foi usada, mas o módulo de abreviação de número não foi carregado.";
        this["DataChart_VisualDataNotLoaded"] = "A funcionalidade DadosVisuais foi acedida, mas o módulo de interação do gráfico não foi carregado.";
        this["DataProviderNotInitialized"] = "O fornecedor de dados foi utilizado sem inicializar primeiro. O fornecedor de dados deve ser inicializado antes da utilização.";
        this["DataSource_Summary_Avg"] = "Média";
        this["DataSource_Summary_Count"] = "Contagem";
        this["DataSource_Summary_Max"] = "Máx.";
        this["DataSource_Summary_Min"] = "Mín.";
        this["DataSource_Summary_Sum"] = "Soma";
        this["Default_Series_Title"] = "Título da série";
        this["FinancialChart_IndicatorMenu_Header"] = "Indicadores";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Indicadores independentes";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Sobreposições";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Linhas de tendência";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volumes";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Oscilador de volume absoluto";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Distribuição/Acumulação";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Índice direcional médio";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Intervalo médio verdadeiro";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Largura da banda de Bollinger";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Oscilador de Chaikin";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Volatilidade de Chaikin";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Índice do canal de mercadorias";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Oscilador de preço sem tendência";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Facilidade de movimento";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Oscilador estocástico rápido";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Índice de força";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Oscilador estocástico total";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Índice de facilitação do mercado";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Índice de massa";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Preço médio";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Índice de fluxo monetário";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Índice de volume negativo";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "Saldo de volume";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Oscilador de preço percentual";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Oscilador de volume percentual";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Índice de volume positivo";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Tendência de volume de preços";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Oscilador estocástico lento";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Desvio padrão";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Preço típico";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Oscilador final";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Fecho ponderado";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bandas de Bollinger";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Canal de preços";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Ajuste cúbico";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Média acumulada";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Média exponencial";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Ajuste exponencial";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Ajuste linear";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Ajuste logarítmico";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Média modificada";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "Ajuste de lei de potência";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Ajuste quadrático";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Ajuste de quarto grau";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Ajuste de quinto grau";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Média Simples";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Média ponderada";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Área";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Coluna";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Linha";
        this["FinancialChart_RangeSelector_All"] = "Todos";
        this["FinancialChart_RangeSelector_From"] = "De";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 mês";
        this["FinancialChart_RangeSelector_OneYear"] = "1 ano";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 meses";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 meses";
        this["FinancialChart_RangeSelector_To"] = "Para";
        this["FinancialChart_RangeSelector_YearToDate"] = "Ano até à data";
        this["FinancialSeries_Close"] = "Fechar";
        this["FinancialSeries_High"] = "Alto";
        this["FinancialSeries_Low"] = "Baixo";
        this["FinancialSeries_Open"] = "Aberto";
        this["FinancialSeries_Volume"] = "Volume";
        this["NoEncodingsLoaded"] = "Não foram encontradas codificações! Carregue a assemblagem Infragistics.Encoding ou consulte a documentação sobre como criar codificações personalizadas.";
        this["NotSupportedEncoding"] = "A codificação correspondente em {0} {1} não é suportada.";
        this["Object_Sealed"] = "Não são permitidas modificações após o fecho do objeto.";
        this["OPD_DefaultInteraction"] = "Selecionar a interação predefinida de arrasto do rato";
        this["OPD_DragPan"] = "Deslocar a superfície";
        this["OPD_DragZoom"] = "Ampliar para a área de seleção";
        this["OPD_ScaleToFit"] = "Ajustar ao ecrã";
        this["OPD_ScaleToFit_SeriesViewer"] = "Repor zoom (100%)";
        this["OPD_ZoomIn"] = "Ampliar";
        this["OPD_ZoomOut"] = "Reduzir";
        this["OPD_ZoomTo100"] = "Zoom para 100%";
        this["PieChart_Others"] = "Outros";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Neste momento, não há suporte para modificações com base no intervalo da fonte de dados";
        this["ScatterSeries_Value"] = "Valor";
        this["TRIAL_VERSION"] = "AVALIAÇÃO NÃO LICENCIADA Compre em Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocalePtModule {
    static register() {
        Localization.register("DataVisualization-pt", new DataVisualizationLocalePt());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleRo {
    constructor() {
        this["AssemblyNotIncluded"] = "Nu se poate încărca {0}.dll. Trebuie să vă asigurați că acest ansamblu este inclus în XAP care este implementat pe Windows Phone, de exemplu, adăugând o referință la acesta din oricare dintre proiectele dvs.";
        this["BreakEvenTitle_BreakEven"] = "Pragul de rentabilitate";
        this["BreakEvenTitle_FixedCost"] = "Costul fix";
        this["BreakEvenTitle_LossArea"] = "Zona de pierdere";
        this["BreakEvenTitle_MarginalProfit"] = "Profit marginal";
        this["BreakEvenTitle_ProfitArea"] = "Zona de profit";
        this["BreakEvenTitle_SafetyMargin"] = "Marja de siguranță";
        this["BreakEvenTitle_SalesRevenue"] = "Veniturile din vânzări";
        this["BreakEvenTitle_TotalCost"] = "Cost total";
        this["BreakEvenTitle_VariableCost"] = "Costul variabil";
        this["BubbleSeries_Radius"] = "Rază";
        this["DataChart_InteractivityNotLoaded"] = "Funcționalitatea de interactivitate a fost accesată, dar modulul de interacțiune a diagramei nu a fost încărcat.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "A fost utilizată funcționalitatea de abreviere a numărului, dar modulul de abreviere a numărului nu a fost încărcat.";
        this["DataChart_VisualDataNotLoaded"] = "Funcționalitatea VisualData a fost accesată, dar modulul de interacțiune a diagramelor nu a fost încărcat.";
        this["DataProviderNotInitialized"] = "Furnizorul de date a fost utilizat fără a inițializa mai întâi. Furnizorul de date trebuie inițializat înainte de utilizare.";
        this["DataSource_Summary_Avg"] = "Media";
        this["DataSource_Summary_Count"] = "Numără";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Sumă";
        this["Default_Series_Title"] = "Titlul seriei";
        this["FinancialChart_IndicatorMenu_Header"] = "Indicatori";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Indicatori independenți";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Suprapuneri";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Linii de trend";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volumele";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Oscilator de volum absolut";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Distribuția/Acumulării";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Indicele direcțional mediu";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Interval adevărat mediu";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Lățimea benzii Bollinger";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Oscilator Chaikin";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Volatilitatea Chaikin";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Indicele canalului mărfurilor";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Oscilator de preț detras";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Ușurința mișcării";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Oscilator stocastic rapid";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Indice de forță";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Oscilator stocastic complet";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Indicele facilitării pieței";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Indicele de masă";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Preț mediu";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Indicele fluxului de bani";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Indicele volumului negativ";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "Volumul soldului";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Oscilator de preț procentual";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Oscilator de volum procentual";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Indicele volumului pozitiv";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Tendința volumului prețului";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Oscilator stocastic lent";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Deviație standard";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Preț tipic";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Oscilator final";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Închis ponderat";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Trupe Bollinger";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Canal Preț";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Potrivire cubică";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Media cumulativă";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Media exponențială";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Potrivire exponențială";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Linear Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Potrivire logaritmică";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Media modificată";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "PowerLaw Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Potrivire quadratică";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Potrivire cvartică";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Potrivire cvintică";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Media simplă";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Medie ponderată";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Zonă";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Coloană";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Linia";
        this["FinancialChart_RangeSelector_All"] = "Toate";
        this["FinancialChart_RangeSelector_From"] = "Din";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 lună";
        this["FinancialChart_RangeSelector_OneYear"] = "1 an";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 luni";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 luni";
        this["FinancialChart_RangeSelector_To"] = "La";
        this["FinancialChart_RangeSelector_YearToDate"] = "YTD";
        this["FinancialSeries_Close"] = "Închide";
        this["FinancialSeries_High"] = "Înalt";
        this["FinancialSeries_Low"] = "Scăzut";
        this["FinancialSeries_Open"] = "Deschis";
        this["FinancialSeries_Volume"] = "Volum";
        this["NoEncodingsLoaded"] = "Nu se găsesc codificări! Vă rugăm să încărcați ansamblul Infragistics.Encoding sau să consultați documentația despre cum să creați codificări personalizate.";
        this["NotSupportedEncoding"] = "Codificarea corespunzătoare sub {0} {1} nu este acceptată.";
        this["Object_Sealed"] = "Modificările nu sunt permise după ce obiectul a fost sigilat.";
        this["OPD_DefaultInteraction"] = "Selectați interacțiunea implicită de tragere a mouse-ului";
        this["OPD_DragPan"] = "Mișcați suprafața";
        this["OPD_DragZoom"] = "Măriți zona de selecție";
        this["OPD_ScaleToFit"] = "Încadrat in ecran";
        this["OPD_ScaleToFit_SeriesViewer"] = "Resetați zoomul (100%)";
        this["OPD_ZoomIn"] = "Mărește";
        this["OPD_ZoomOut"] = "Micșorează";
        this["OPD_ZoomTo100"] = "Măriți la 100%";
        this["PieChart_Others"] = "Alții";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Modificările sursei de date bazate pe intervale nu sunt acceptate în prezent";
        this["ScatterSeries_Value"] = "Valoare";
        this["TRIAL_VERSION"] = "VARIANTĂ DE PROBĂ FĂRĂ LICENȚĂ Cumpărați la Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleRoModule {
    static register() {
        Localization.register("DataVisualization-ro", new DataVisualizationLocaleRo());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleSv {
    constructor() {
        this["AssemblyNotIncluded"] = "Det går inte att ladda {0}.dll. Du måste se till att den här enheten ingår i XAP som distribueras till Windows Phone, till exempel genom att lägga till en referens till den från något av dina projekt.";
        this["BreakEvenTitle_BreakEven"] = "Gå jämt upp";
        this["BreakEvenTitle_FixedCost"] = "Fast kostnad";
        this["BreakEvenTitle_LossArea"] = "Förlustområde";
        this["BreakEvenTitle_MarginalProfit"] = "Marginal vinst";
        this["BreakEvenTitle_ProfitArea"] = "Vinstområde";
        this["BreakEvenTitle_SafetyMargin"] = "Säkerhetsmarginal";
        this["BreakEvenTitle_SalesRevenue"] = "Försäljningsintäkter";
        this["BreakEvenTitle_TotalCost"] = "Total kostnad";
        this["BreakEvenTitle_VariableCost"] = "Rörlig kostnad";
        this["BubbleSeries_Radius"] = "Radie";
        this["DataChart_InteractivityNotLoaded"] = "Interaktivitetsfunktionalitet nås men diagraminteraktionsmodulen har inte laddats.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Nummerförkortningsfunktionalitet användes, men nummerförkortningsmodulen har inte laddats.";
        this["DataChart_VisualDataNotLoaded"] = "VisualData-funktionalitet nås, men diagraminteraktionsmodulen har inte laddats.";
        this["DataProviderNotInitialized"] = "Dataleverantören användes utan att initialiseras först. Dataleverantören måste initieras före användning.";
        this["DataSource_Summary_Avg"] = "Genomsnitt";
        this["DataSource_Summary_Count"] = "Räkna";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Summa";
        this["Default_Series_Title"] = "Serietitel";
        this["FinancialChart_IndicatorMenu_Header"] = "Indikatorer";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Fristående indikatorer";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Överlägg";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Trendlinjer";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volymer";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Absolut volymoscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Ackumulering/Fördelning";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Genomsnittligt riktningsindex";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Genomsnittligt sant intervall";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Bollinger-bandvidd";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Chaikin-oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Chaikin-instabilitet";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Varukanalindex";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Avtrenderad prisoscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Rörelseenkelhet";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Snabb stokastisk oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Force-index";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Helstokastisk oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Marknadsförenklingsindex";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Massindex";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Medianpris";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Penningflödesindex";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Negativt volymindex";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "På balansvolym";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Procentuell oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Procent volymoscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Positivt volymindex";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Prisvolymstrend";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Långsam stokastisk oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Standardavvikelse";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Typiskt pris";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Ultimat oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Viktad stängning";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bollinger-band";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Priskanal";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Kubisk passform";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Kumulativt genomsnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Exponentiellt genomsnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Exponentiell passform";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Linjär passform";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Logaritmisk passform";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Modifierat genomsnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "PowerLaw-passform";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Kvadratisk passform";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Fjärdegradspassform";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Femtegradspassform";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Enkelt genomsnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Vägt genomsnitt";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Område";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Kolumn";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Linje";
        this["FinancialChart_RangeSelector_All"] = "Allt";
        this["FinancialChart_RangeSelector_From"] = "Från";
        this["FinancialChart_RangeSelector_OneMonth"] = "1M";
        this["FinancialChart_RangeSelector_OneYear"] = "1Y";
        this["FinancialChart_RangeSelector_SixMonths"] = "6M";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3M";
        this["FinancialChart_RangeSelector_To"] = "Till";
        this["FinancialChart_RangeSelector_YearToDate"] = "YTD";
        this["FinancialSeries_Close"] = "Slut";
        this["FinancialSeries_High"] = "Hög";
        this["FinancialSeries_Low"] = "Låg";
        this["FinancialSeries_Open"] = "Öppna";
        this["FinancialSeries_Volume"] = "Volym";
        this["NoEncodingsLoaded"] = "Inga kodningar hittades! Ladda Infragistics.Encoding-monteringen eller titta i dokumentationen för att se hur man skapar anpassade kodningar.";
        this["NotSupportedEncoding"] = "Kodningen som motsvarar under {0} {1} stöds inte.";
        this["Object_Sealed"] = "Ändringar är inte tillåtna efter att objektet har förseglats.";
        this["OPD_DefaultInteraction"] = "Välj standard musinteraktion";
        this["OPD_DragPan"] = "Panorera ytan";
        this["OPD_DragZoom"] = "Zooma in i urvalsområdet";
        this["OPD_ScaleToFit"] = "Anpassa till skärm";
        this["OPD_ScaleToFit_SeriesViewer"] = "Återställ zoom (100%)";
        this["OPD_ZoomIn"] = "Zooma in";
        this["OPD_ZoomOut"] = "Zooma ut";
        this["OPD_ZoomTo100"] = "Zooma till 100%";
        this["PieChart_Others"] = "Andra";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Områdesbaserade modifieringar av datakällan stöds för närvarande inte";
        this["ScatterSeries_Value"] = "Värde";
        this["TRIAL_VERSION"] = "LICENSLÖS PROVNING Köp på Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleSvModule {
    static register() {
        Localization.register("DataVisualization-sv", new DataVisualizationLocaleSv());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleTr {
    constructor() {
        this["AssemblyNotIncluded"] = "{0}.dll yüklenemiyor. Bu derlemenin Windows Phone'a dağıtılan XAP'ye dahil edildiğinden emin olmanız gerekir, örneğin, projelerinizden herhangi birinden ona bir referans ekleyerek.";
        this["BreakEvenTitle_BreakEven"] = "Maliyeti Karşılayan";
        this["BreakEvenTitle_FixedCost"] = "Sabit Maliyet";
        this["BreakEvenTitle_LossArea"] = "Zarar Alanı";
        this["BreakEvenTitle_MarginalProfit"] = "Marjinal Kâr";
        this["BreakEvenTitle_ProfitArea"] = "Kâr Alanı";
        this["BreakEvenTitle_SafetyMargin"] = "Güvenlik Marjı";
        this["BreakEvenTitle_SalesRevenue"] = "Satış Geliri";
        this["BreakEvenTitle_TotalCost"] = "Toplam Maliyet";
        this["BreakEvenTitle_VariableCost"] = "Değişken Maliyet";
        this["BubbleSeries_Radius"] = "Yarıçap";
        this["DataChart_InteractivityNotLoaded"] = "Etkileşim işlevine erişildi, ancak grafik etkileşim modülü yüklenmedi.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Sayı kısaltma işlevi kullanıldı, ancak sayı kısaltma modülü yüklenmedi.";
        this["DataChart_VisualDataNotLoaded"] = "VisualData işlevine erişildi, ancak grafik etkileşim modülü yüklenmedi.";
        this["DataProviderNotInitialized"] = "Veri sağlayıcı, önce başlatılmadan kullanıldı. Veri sağlayıcı, kullanımdan önce başlatılmalıdır.";
        this["DataSource_Summary_Avg"] = "Ort.";
        this["DataSource_Summary_Count"] = "Adet";
        this["DataSource_Summary_Max"] = "Maks";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Toplam";
        this["Default_Series_Title"] = "Dizi Başlığı";
        this["FinancialChart_IndicatorMenu_Header"] = "Göstergeler";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Bağımsız Göstergeler";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Yer paylaşımları";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Trend çizgileri";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Ciltler";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Mutlak Hacim Osilatörü";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Birikim/Dağılımı";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Ortalama Yön Endeksi";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Ortalama Doğru Aralığı";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Bollinger Bant Genişliği";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Chaikin Osilatör";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Chaikin Volatilitesi";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Emtia Kanal Endeksi";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Azalan Fiyat Osilatörü";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Hareket Kolaylığı";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Hızlı Stokastik Osilatör";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Kuvvet Endeksi";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Tam Stokastik Osilatör";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Piyasa Kolaylaştırma Endeksi";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Kütle Endeksi";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Medyan Fiyat";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Para Akışı Endeksi";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Negatif Hacim Endeksi";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "Denge İşlem Hacmi";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Yüzde Fiyat Osilatörü";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Yüzde Hacim Osilatörü";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Pozitif Hacim Endeksi";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Fiyat Hacim Eğilimi";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Yavaş Stokastik Osilatör";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Standart Sapma";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Tipik Fiyat";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Nihai Osilatör";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Ağırlıklı Kapanış";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams% R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bollinger bantları";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Fiyat Kanalı";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Kübik Uyum";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Kümülatif Ortalama";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Üssel Ortalama";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Üssel Uyum";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Doğrusal Uyum";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Logaritmik Uyum";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Değiştirilmiş Ortalama";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "Kuvvet Uyumu";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "İkinci Dereceden Uyum";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Dördüncü Dereceden Uyum";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Beşinci Dereceden Uyum";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Basit Ortalama";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Ağırlıklı Ortalama";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Alan";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Sütun";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Çizgi";
        this["FinancialChart_RangeSelector_All"] = "Tümü";
        this["FinancialChart_RangeSelector_From"] = "Kaynak";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 Ay";
        this["FinancialChart_RangeSelector_OneYear"] = "1 yıl";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 Ay";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 Ay";
        this["FinancialChart_RangeSelector_To"] = "Hedef";
        this["FinancialChart_RangeSelector_YearToDate"] = "Yıl Başından Beri";
        this["FinancialSeries_Close"] = "Kapat";
        this["FinancialSeries_High"] = "Yüksek";
        this["FinancialSeries_Low"] = "Düşük";
        this["FinancialSeries_Open"] = "Açık";
        this["FinancialSeries_Volume"] = "Ses";
        this["NoEncodingsLoaded"] = "Kodlama bulunamadı! Lütfen Infragistics.Encoding derlemesini yükleyin veya özel kodlamaların nasıl oluşturulacağına ilişkin belgelere bakın.";
        this["NotSupportedEncoding"] = "{0} {1} altında karşılık gelen kodlama desteklenmiyor.";
        this["Object_Sealed"] = "Nesne mühürlendikten sonra değişikliklere izin verilmez.";
        this["OPD_DefaultInteraction"] = "Varsayılan fare sürükleme etkileşimini seçin";
        this["OPD_DragPan"] = "Yüzeyi kaydırın";
        this["OPD_DragZoom"] = "Seçim alanına yakınlaştırın";
        this["OPD_ScaleToFit"] = "Ekrana Sığdır";
        this["OPD_ScaleToFit_SeriesViewer"] = "Yakınlaştırmayı Sıfırla (%100)";
        this["OPD_ZoomIn"] = "Yakınlaştır";
        this["OPD_ZoomOut"] = "Uzaklaştır";
        this["OPD_ZoomTo100"] = "%100 Yakınlaştır";
        this["PieChart_Others"] = "Diğerleri";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Veri kaynağının aralığa dayalı değişiklikleri şu anda desteklenmemektedir";
        this["ScatterSeries_Value"] = "Değer";
        this["TRIAL_VERSION"] = "LİSANSSIZ DENEME Infragistics.com'dan Satın Alın";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleTrModule {
    static register() {
        Localization.register("DataVisualization-tr", new DataVisualizationLocaleTr());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleZhHans {
    constructor() {
        this["AssemblyNotIncluded"] = "无法加载 {0}.dll。您需要确保该程序集包含在部署到 Windows Phone 的 XAP 中，例如，通过在您的任何项目中添加对该程序集的引用。";
        this["BreakEvenTitle_BreakEven"] = "收支平衡";
        this["BreakEvenTitle_FixedCost"] = "固定成本";
        this["BreakEvenTitle_LossArea"] = "损失区";
        this["BreakEvenTitle_MarginalProfit"] = "边际利润";
        this["BreakEvenTitle_ProfitArea"] = "利润区";
        this["BreakEvenTitle_SafetyMargin"] = "安全边际";
        this["BreakEvenTitle_SalesRevenue"] = "销售收入";
        this["BreakEvenTitle_TotalCost"] = "总成本";
        this["BreakEvenTitle_VariableCost"] = "可变成本";
        this["BubbleSeries_Radius"] = "半径";
        this["DataChart_InteractivityNotLoaded"] = "已访问交互功能，但尚未加载图表交互模块。";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "已使用数字缩写功能，但尚未加载数字缩写模块。";
        this["DataChart_VisualDataNotLoaded"] = "已访问 VisualData 功能，但尚未加载图表交互模块。";
        this["DataProviderNotInitialized"] = "使用数据提供者时未先初始化。数据提供者必须在使用前初始化。";
        this["DataSource_Summary_Avg"] = "平均";
        this["DataSource_Summary_Count"] = "计算";
        this["DataSource_Summary_Max"] = "最大";
        this["DataSource_Summary_Min"] = "最小";
        this["DataSource_Summary_Sum"] = "合计";
        this["Default_Series_Title"] = "系列标题";
        this["FinancialChart_IndicatorMenu_Header"] = "指标";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "独立指标";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "叠加";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "趋势线";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "成交量";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "绝对交易量震荡指标";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "累积分配";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "平均方向指数";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "平均真实范围";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "布林带宽度";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "佳庆摆动指标";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "佳庆波动性指标";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "商品渠道指数";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "去趋势价格震荡指标";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "轻松移动";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "快速随机摆动指标";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "力指数";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "全随机摆动指标";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "市场促进指数";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "质量指数";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "中位数价格";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "资金流量指数";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "平滑移动平均线 (MACD)";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "负成交量指数";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "平衡交易量指标";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "百分比价格震荡指标";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "百分比交易量震荡指标";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "正成交量指数";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "价量趋势";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "变动率 (ROC)";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "相对强弱指数 (RSI)";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "慢速随机摆动指标";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "标准偏差";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "随机相对强弱指数";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "三重指数平滑平均线 (TRIX)";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "典型价格";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "终极摆动指标";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "加权收盘价";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "威廉指标";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "布林带";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "价格通道";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "三次拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "累积平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "指数平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "指数拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "线性拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "对数拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "修正平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "幂律拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "二次拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "四次拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "五次拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "简单平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "加权平均值";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "面积图";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "列";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "线";
        this["FinancialChart_RangeSelector_All"] = "全部";
        this["FinancialChart_RangeSelector_From"] = "自";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 个月";
        this["FinancialChart_RangeSelector_OneYear"] = "1 年";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 个月";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 个月";
        this["FinancialChart_RangeSelector_To"] = "至";
        this["FinancialChart_RangeSelector_YearToDate"] = "年初至今";
        this["FinancialSeries_Close"] = "关闭";
        this["FinancialSeries_High"] = "盘高";
        this["FinancialSeries_Low"] = "盘点";
        this["FinancialSeries_Open"] = "打开";
        this["FinancialSeries_Volume"] = "成交量";
        this["NoEncodingsLoaded"] = "未找到编码！请加载 Infragistics.Encoding 程序集或查看文档中如何创建自定义编码。";
        this["NotSupportedEncoding"] = "不支持 {0} {1} 下的编码。";
        this["Object_Sealed"] = "密封物体后，不允许修改。";
        this["OPD_DefaultInteraction"] = "选择默认的鼠标拖动交互";
        this["OPD_DragPan"] = "平移表面";
        this["OPD_DragZoom"] = "缩放到所选区域";
        this["OPD_ScaleToFit"] = "适应屏幕";
        this["OPD_ScaleToFit_SeriesViewer"] = "重置缩放 (100%)";
        this["OPD_ZoomIn"] = "放大";
        this["OPD_ZoomOut"] = "缩小";
        this["OPD_ZoomTo100"] = "缩放至 100%";
        this["PieChart_Others"] = "其他";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "当前不支持基于范围的数据源修改";
        this["ScatterSeries_Value"] = "数值";
        this["TRIAL_VERSION"] = "未经许可的试用版，通过 Infragistics.com 购买";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleZhHansModule {
    static register() {
        Localization.register("DataVisualization-zh-Hans", new DataVisualizationLocaleZhHans());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleZhHant {
    constructor() {
        this["AssemblyNotIncluded"] = "無法載入 {0}.dll。您需要確保此程序集包含在已部署至 Windows Phone 的 XAP 中，例如，從您的任何專案中添加對該程序集的引用。";
        this["BreakEvenTitle_BreakEven"] = "收支平衡";
        this["BreakEvenTitle_FixedCost"] = "固定成本";
        this["BreakEvenTitle_LossArea"] = "損失面積";
        this["BreakEvenTitle_MarginalProfit"] = "邊際利潤";
        this["BreakEvenTitle_ProfitArea"] = "利潤範圍";
        this["BreakEvenTitle_SafetyMargin"] = "安全寬限期";
        this["BreakEvenTitle_SalesRevenue"] = "銷售收入";
        this["BreakEvenTitle_TotalCost"] = "總費用";
        this["BreakEvenTitle_VariableCost"] = "變動成本";
        this["BubbleSeries_Radius"] = "半徑";
        this["DataChart_InteractivityNotLoaded"] = "已存取互動功能，但尚未載入圖表互動模組。";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "已使用數字縮寫功能，但尚未加載數字縮寫模組。";
        this["DataChart_VisualDataNotLoaded"] = "已存取 VisualData 功能，但尚未載入圖表互動模組。";
        this["DataProviderNotInitialized"] = "未先初始化就使用了資料提供者。資料提供者必須在使用前初始化。";
        this["DataSource_Summary_Avg"] = "平均";
        this["DataSource_Summary_Count"] = "計數";
        this["DataSource_Summary_Max"] = "最大";
        this["DataSource_Summary_Min"] = "最小";
        this["DataSource_Summary_Sum"] = "總和";
        this["Default_Series_Title"] = "數列標題";
        this["FinancialChart_IndicatorMenu_Header"] = "指標";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "獨立指標";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "疊加";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "趨勢線";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "成交量";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "絕對成交量震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "累積分佈";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "平均方向指數";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "平均真實範圍";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "布林帶寬度";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "柴金震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "柴金波動率";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "商品通道指數";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "去趨勢價格震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "輕鬆移動";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "快速隨機震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "力指數";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "全隨機震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "市場促進指數";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "質量指數";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "中位數價格";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "資金流量指數";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "負成交量指數";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "平衡成交量指標";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "百分比價格震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "百分比成交量震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "正成交量指數";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "價格量趨勢";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "變動率 (Rate of Change)";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "相對強弱指標 (Relative Strength Index)";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "慢速隨機震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "標準差";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "随機相對强弱指數";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "典型價格";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "終極震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "加權關閉";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "威廉指數";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "布林帶";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "價格頻道";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "立方體調整";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "累計平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "指數平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "指數調整";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "線性調整";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "对数調整";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "修正平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "幂律擬合";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "二次方調整";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "四次方調整";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "五次方調整";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "簡單平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "加權平均值";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "區域";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "列";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "線";
        this["FinancialChart_RangeSelector_All"] = "全部";
        this["FinancialChart_RangeSelector_From"] = "自";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 個月";
        this["FinancialChart_RangeSelector_OneYear"] = "1 年";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 個月";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 個月";
        this["FinancialChart_RangeSelector_To"] = "至";
        this["FinancialChart_RangeSelector_YearToDate"] = "年初至今";
        this["FinancialSeries_Close"] = "關閉";
        this["FinancialSeries_High"] = "高";
        this["FinancialSeries_Low"] = "低";
        this["FinancialSeries_Open"] = "開啟";
        this["FinancialSeries_Volume"] = "成交量";
        this["NoEncodingsLoaded"] = "未找到任何編碼！請加載 Infragistics.Encoding 程序集或查看文檔，了解如何創建自定義編碼。";
        this["NotSupportedEncoding"] = "不支援 {0} {1} 下的對應編碼。";
        this["Object_Sealed"] = "密封物體後，不允許修改。";
        this["OPD_DefaultInteraction"] = "選擇默認的鼠標拖曳互動";
        this["OPD_DragPan"] = "平移表面";
        this["OPD_DragZoom"] = "縮放選取範圍";
        this["OPD_ScaleToFit"] = "全螢幕";
        this["OPD_ScaleToFit_SeriesViewer"] = "重設縮放 (100%)";
        this["OPD_ZoomIn"] = "放大";
        this["OPD_ZoomOut"] = "縮小";
        this["OPD_ZoomTo100"] = "縮放成 100%";
        this["PieChart_Others"] = "其他";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "當前不支持基於範圍的數據源修改";
        this["ScatterSeries_Value"] = "數值";
        this["TRIAL_VERSION"] = "未授權的試用版，在 Infragistics.com 購買";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleZhHantModule {
    static register() {
        Localization.register("DataVisualization-zh-Hant", new DataVisualizationLocaleZhHant());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleEn {
    constructor() {
        this["AssemblyNotIncluded"] = "Cannot load {0}.dll. You need to make sure that this assembly is included in the XAP that is deployed to the Windows Phone, for example, by adding a reference to it from any of your projects.";
        this["BreakEvenTitle_BreakEven"] = "Break Even";
        this["BreakEvenTitle_FixedCost"] = "Fixed Cost";
        this["BreakEvenTitle_LossArea"] = "Loss Area";
        this["BreakEvenTitle_MarginalProfit"] = "Marginal Profit";
        this["BreakEvenTitle_ProfitArea"] = "Profit Area";
        this["BreakEvenTitle_SafetyMargin"] = "Safety Margin";
        this["BreakEvenTitle_SalesRevenue"] = "Sales Revenue";
        this["BreakEvenTitle_TotalCost"] = "Total Cost";
        this["BreakEvenTitle_VariableCost"] = "Variable Cost";
        this["BubbleSeries_Radius"] = "Radius";
        this["DataChart_InteractivityNotLoaded"] = "Interactivity functionality was accessed but chart interaction module has not been loaded.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Number abbreviation functionality was used, but the number abbreviator module has not been loaded.";
        this["DataChart_VisualDataNotLoaded"] = "VisualData functionality was accessed but chart interaction module has not been loaded.";
        this["DataProviderNotInitialized"] = "Data provider was used without initializing first. Data provider must be initialized before use.";
        this["DataSource_Summary_Avg"] = "Avg";
        this["DataSource_Summary_Count"] = "Count";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Sum";
        this["Default_Series_Title"] = "Series Title";
        this["FinancialChart_IndicatorMenu_Header"] = "Indicators";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Standalone Indicators";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Overlays";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Trendlines";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volumes";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Absolute Volume Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Accumulation/Distribution";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Average Directional Index";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Average True Range";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Bollinger Band Width";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Chaikin Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Chaikin Volatility";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Commodity Channel Index";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Detrended Price Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Ease Of Movement";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Fast Stochastic Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Force Index";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Full Stochastic Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Market Facilitation Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Mass Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Median Price";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Money Flow Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Negative Volume Index";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "On Balance Volume";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Percentage Price Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Percentage Volume Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Positive Volume Index";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Price Volume Trend";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Slow Stochastic Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Standard Deviation";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Typical Price";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Ultimate Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Weighted Close";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bollinger Bands";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Price Channel";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Cubic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Cumulative Average";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Exponential Average";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Exponential Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Linear Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Logarithmic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Modified Average";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "PowerLaw Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Quadratic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Quartic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Quintic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Simple Average";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Weighted Average";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Area";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Column";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Line";
        this["FinancialChart_RangeSelector_All"] = "All";
        this["FinancialChart_RangeSelector_From"] = "From";
        this["FinancialChart_RangeSelector_OneMonth"] = "1M";
        this["FinancialChart_RangeSelector_OneYear"] = "1Y";
        this["FinancialChart_RangeSelector_SixMonths"] = "6M";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3M";
        this["FinancialChart_RangeSelector_To"] = "To";
        this["FinancialChart_RangeSelector_YearToDate"] = "YTD";
        this["FinancialSeries_Close"] = "Close";
        this["FinancialSeries_High"] = "High";
        this["FinancialSeries_Low"] = "Low";
        this["FinancialSeries_Open"] = "Open";
        this["FinancialSeries_Volume"] = "Volume";
        this["NoEncodingsLoaded"] = "No Encodings are found! Please load the Infragistics.Encoding assembly or look at the documentation how to create custom encodings.";
        this["NotSupportedEncoding"] = "The encoding corresponding under the {0} {1} is not supported.";
        this["Object_Sealed"] = "Modifications are not permitted after the object has been sealed.";
        this["OPD_DefaultInteraction"] = "Select the default mouse drag interaction";
        this["OPD_DragPan"] = "Pan the surface";
        this["OPD_DragZoom"] = "Zoom in to selection area";
        this["OPD_ScaleToFit"] = "Fit to Screen";
        this["OPD_ScaleToFit_SeriesViewer"] = "Reset Zoom (100%)";
        this["OPD_ZoomIn"] = "Zoom in";
        this["OPD_ZoomOut"] = "Zoom out";
        this["OPD_ZoomTo100"] = "Zoom to 100%";
        this["PieChart_Others"] = "Others";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Range based modifications of the data source are not currently supported";
        this["ScatterSeries_Value"] = "Value";
        this["TRIAL_VERSION"] = "UNLICENSED TRIAL Buy at Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleEnModule {
    static register() {
        Localization.register("DataVisualization-en", new DataVisualizationLocaleEn());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinkedListNode$1 = /*@__PURE__*/ (() => {
    class LinkedListNode$1 extends Base {
        constructor($t, a, ..._rest) {
            super();
            this.$t = null;
            this.c = null;
            this.b = null;
            this.a = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        this.c = c;
                    }
                    break;
            }
        }
    }
    LinkedListNode$1.$t = /*@__PURE__*/ markType(LinkedListNode$1, 'LinkedListNode$1');
    return LinkedListNode$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinkedList$1 = /*@__PURE__*/ (() => {
    class LinkedList$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this.a = null;
            this.b = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
        get c() {
            return this.a;
        }
        get d() {
            return this.b;
        }
        e(a) {
            if (this.a == null) {
                this.a = new LinkedListNode$1(this.$t, 1, a);
                this.b = this.a;
            }
            else {
                let b = this.a;
                this.a = new LinkedListNode$1(this.$t, 1, a);
                this.a.a = b;
                b.b = this.a;
            }
        }
        f(a) {
            if (this.b == null) {
                this.a = new LinkedListNode$1(this.$t, 1, a);
                this.b = this.a;
            }
            else {
                let b = this.b;
                this.b = new LinkedListNode$1(this.$t, 1, a);
                this.b.b = b;
                b.a = this.b;
            }
        }
        i() {
            this.h(this.c);
        }
        g() {
            this.a = null;
            this.b = null;
        }
        h(a) {
            if (this.a == a) {
                this.a = a.a;
                if (a.a != null) {
                    a.a.b = null;
                }
            }
            if (this.b == a) {
                this.b = a.b;
                if (a.b != null) {
                    a.b.a = null;
                }
            }
            if (a.b != null) {
                a.b.a = a.a;
            }
            if (a.a != null) {
                a.a.b = a.b;
            }
            a.a = null;
            a.b = null;
        }
    }
    LinkedList$1.$t = /*@__PURE__*/ markType(LinkedList$1, 'LinkedList$1');
    return LinkedList$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LRUCacheItem$2 = /*@__PURE__*/ (() => {
    class LRUCacheItem$2 extends Base {
        constructor($tKey, $tValue) {
            super();
            this.$tKey = null;
            this.$tValue = null;
            this.a = null;
            this.b = null;
            this.c = null;
            this.$tKey = $tKey;
            this.$tValue = $tValue;
            this.$type = this.$type.specialize(this.$tKey, this.$tValue);
        }
    }
    LRUCacheItem$2.$t = /*@__PURE__*/ markType(LRUCacheItem$2, 'LRUCacheItem$2');
    return LRUCacheItem$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LRUCache$2 = /*@__PURE__*/ (() => {
    class LRUCache$2 extends Base {
        constructor($tKey, $tValue, a, ..._rest) {
            super();
            this.$tKey = null;
            this.$tValue = null;
            this.f = 0;
            this.e = null;
            this.a = null;
            this.$tKey = $tKey;
            this.$tValue = $tValue;
            this.$type = this.$type.specialize(this.$tKey, this.$tValue);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, null];
                        {
                            let f = d[0];
                            let g = d[1];
                            this.e = new LinkedList$1(LRUCacheItem$2.$.specialize(this.$tKey, this.$tValue));
                            this.a = new FastIterationDictionary$2(this.$tKey, LRUCacheItem$2.$.specialize(this.$tKey, this.$tValue), 1, g);
                            this.f = f;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.e = new LinkedList$1(LRUCacheItem$2.$.specialize(this.$tKey, this.$tValue));
                        this.a = new FastIterationDictionary$2(this.$tKey, LRUCacheItem$2.$.specialize(this.$tKey, this.$tValue), 1, d);
                        this.f = c;
                    }
                    break;
            }
        }
        get h() {
            return this.f;
        }
        set h(a) {
            this.f = a;
            while (this.a.r > this.f) {
                this.j(this.e.d.c.a);
            }
        }
        get b() {
            return this.a;
        }
        d(a) {
            return this.a.d(a);
        }
        item(a, b) {
            if (arguments.length === 2) {
                if (!this.a.d(a)) {
                    let c = new LRUCacheItem$2(this.$tKey, this.$tValue);
                    c.b = b;
                    c.a = a;
                    this.e.e(c);
                    c.c = this.e.c;
                    this.a.s(a, c);
                }
                else {
                    let d = this.item(a);
                    this.a.item(a).b = b;
                }
                while (this.a.r > this.f) {
                    this.j(this.e.d.c.a);
                }
                return b;
            }
            else {
                if (!this.a.d(a)) {
                    return Type.getDefaultValue(this.$tValue);
                }
                let b = this.a.item(a);
                let c = b.c;
                this.e.h(c);
                this.e.e(c.c);
                b.c = this.e.c;
                return b.b;
            }
        }
        j(a) {
            if (!this.a.d(a)) {
                return;
            }
            let b = this.a.item(a);
            this.e.h(b.c);
            this.a.f(b.a);
        }
        i() {
            this.a.u();
            this.e = new LinkedList$1(LRUCacheItem$2.$.specialize(this.$tKey, this.$tValue));
        }
        get g() {
            return this.a.r;
        }
    }
    LRUCache$2.$t = /*@__PURE__*/ markType(LRUCache$2, 'LRUCache$2');
    return LRUCache$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationState = /*@__PURE__*/ (() => {
    class AnimationState extends Base {
        constructor() {
            super(...arguments);
            this.e = 0;
            this.d = 0;
            this.i = null;
            this.g = 0;
            this.c = new Date();
            this.a = null;
            this.f = null;
            this.j = null;
            this.h = 0;
            this.b = false;
        }
    }
    AnimationState.$t = /*@__PURE__*/ markType(AnimationState, 'AnimationState');
    return AnimationState;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationManager = /*@__PURE__*/ (() => {
    class AnimationManager extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.c = new Dictionary$2(String_$type, AnimationState.$, 0);
            this.b = false;
            this.e = -1;
            this.a = a;
        }
        d() {
            return dateNow();
        }
        h(a, b, c, d, e, f, g) {
            let h = new AnimationState();
            h.d = f;
            h.e = g;
            h.i = b;
            h.g = c;
            h.c = this.d();
            h.a = d;
            h.f = e;
            this.f(h);
        }
        g(a, b, c, d, e) {
            let f = new AnimationState();
            f.j = a;
            f.i = b;
            f.g = c;
            f.c = this.d();
            f.a = d;
            f.f = e;
            this.f(f);
        }
        f(a) {
            if (this.c.containsKey(a.j)) {
                this.i(a.j, 0);
            }
            this.c.addItem(a.j, a);
            this.j();
            this.a.requestFrame(this.e);
        }
        i(a, b) {
            if (!this.c.containsKey(a)) {
                return;
            }
            let c = this.c.item(a);
            let d = c.a;
            if (b == 2) {
                c.a(c.f(0), c);
            }
            if (b == 1) {
                c.a(c.f(1), c);
            }
            this.c.removeItem(a);
            this.j();
        }
        j() {
            if (this.c.count == 0) {
                this.m();
            }
            else {
                this.l();
            }
        }
        l() {
            if (this.b) {
                return;
            }
            this.b = true;
            this.e = this.a.setupTicking(runOn(this, this.n));
        }
        m() {
            if (this.b) {
                this.a.teardownTicking(this.e);
                this.e = -1;
            }
            this.b = false;
        }
        n() {
            let a = dateNow();
            let b = new List$1(String_$type, 0);
            for (let c of fromEnum(this.c.values)) {
                let d = false;
                let e = (a.getTime() - c.c.getTime());
                if (e >= c.g) {
                    e = c.g;
                    d = true;
                }
                if ((e - c.h < 16 && e != c.g)) {
                    continue;
                }
                c.h = e;
                c.b = d;
                let f = (e / c.g);
                f = c.f(f);
                c.a(f, c);
                if (d) {
                    b.add(c.j);
                }
            }
            for (let g of fromEnum(b)) {
                this.c.removeItem(g);
            }
            this.j();
            if (this.b) {
                this.a.requestFrame(this.e);
            }
        }
        k() {
            this.c.clear();
            this.m();
        }
    }
    AnimationManager.$t = /*@__PURE__*/ markType(AnimationManager, 'AnimationManager');
    return AnimationManager;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var CancelBehavior = /*@__PURE__*/ (function (CancelBehavior) {
    CancelBehavior[CancelBehavior["KeepCurrent"] = 0] = "KeepCurrent";
    CancelBehavior[CancelBehavior["ToEnd"] = 1] = "ToEnd";
    CancelBehavior[CancelBehavior["ToBeginning"] = 2] = "ToBeginning";
    return CancelBehavior;
})({});
/**
 * @hidden
 */
let CancelBehavior_$type = /*@__PURE__*/ markEnum('CancelBehavior', 'KeepCurrent,0|ToEnd,1|ToBeginning,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITickProvider_$type = /*@__PURE__*/ new Type(null, 'ITickProvider');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ErrorMessageDisplayingEventArgs = /*@__PURE__*/ (() => {
    class ErrorMessageDisplayingEventArgs extends EventArgs {
        constructor(a) {
            super();
            this.b = null;
            this.errorMessage = a;
        }
        get errorMessage() {
            return this.b;
        }
        set errorMessage(a) {
            this.b = a;
        }
    }
    ErrorMessageDisplayingEventArgs.$t = /*@__PURE__*/ markType(ErrorMessageDisplayingEventArgs, 'ErrorMessageDisplayingEventArgs', EventArgs.$);
    return ErrorMessageDisplayingEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFastItemColumnInternal_$type = /*@__PURE__*/ new Type(null, 'IFastItemColumnInternal');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFastItemColumnPropertyName_$type = /*@__PURE__*/ new Type(null, 'IFastItemColumnPropertyName');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IGetItemAtIndex_$type = /*@__PURE__*/ new Type(null, 'IGetItemAtIndex');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFastItemColumn$1_$type = /*@__PURE__*/ new Type(null, 'IFastItemColumn$1', null, [/*@__PURE__*/ IList$1_$type.specialize(0), IFastItemColumnPropertyName_$type, IGetItemAtIndex_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastReflectionHelper = /*@__PURE__*/ (() => {
    class FastReflectionHelper extends Base {
        constructor(a, b) {
            super();
            this.c = false;
            this._propertyName = null;
            this.a = null;
            this.b = false;
            this.d = false;
            this._index = -1;
            this.k = null;
            this._useTraditionalReflection = false;
            this.useTraditionalReflection = a;
            this.o(b);
        }
        static needsHelper(a) {
            if (a == null) {
                return false;
            }
            if (a != "." && a != null && stringContains(a, ".") || stringContains(a, "[")) {
                return true;
            }
            return false;
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            if (a != this.k) {
                this.o(a);
            }
        }
        o(a) {
            this.k = a;
            this._propertyName = a;
            this.c = false;
            if (this._propertyName == ".") {
                this.c = true;
                return;
            }
            if (this._propertyName == null) {
                return;
            }
            let b = false;
            if (stringStartsWith(a, "[")) {
                b = true;
            }
            while (stringStartsWith(a, ".")) {
                a = a.substr(1);
            }
            while (stringStartsWith(a, "[")) {
                a = a.substr(1);
            }
            let c = a.indexOf("[");
            let d = a.indexOf(".");
            let e = -1;
            if (c < 0) {
                e = d;
            }
            else if (d < 0) {
                e = c;
            }
            else {
                e = Math.min(d, c);
            }
            if (e > 0) {
                if (a.charAt(e) == '[' || !b) {
                    let f = a.substr(e, a.length - e);
                    this.a = new FastReflectionHelper(this.useTraditionalReflection, f);
                    this.o(a.substr(0, e));
                    return;
                }
            }
            let g = a.indexOf("]");
            if (g > 0) {
                let h = a.substr(g + 1, a.length - g - 1);
                if (h.length > 0) {
                    this.a = new FastReflectionHelper(this.useTraditionalReflection, h);
                }
                a = a.substr(0, g);
                if (this.f(a)) {
                    this.b = true;
                    this._index = parseInt(a);
                }
                else {
                    this.d = true;
                }
            }
            else {
                this.b = false;
                this.d = false;
            }
            this._propertyName = a;
        }
        f(a) {
            if (a == null) {
                return false;
            }
            let b = a.trim();
            if (b.length == 0) {
                return false;
            }
            for (let c = 0; c < b.length; c++) {
                let d = b.charAt(c);
                let e = d.charCodeAt(0);
                if (48 <= e && e <= 57) {
                    continue;
                }
                return false;
            }
            return true;
        }
        get useTraditionalReflection() {
            return this._useTraditionalReflection;
        }
        set useTraditionalReflection(a) {
            this._useTraditionalReflection = a;
        }
        getPropertyValue(a) {
            let from_ = a;
            if (this.c) {
                return from_;
            }
            let b = null;
            if (this.b) {
                b = from_[this._index];
            }
            else {
                b = from_[this._propertyName];
            }
            if (this.a != null && (b !== undefined)) {
                return this.a.getPropertyValue(b);
            }
            return b;
        }
        setPropertyValue(a, b) {
            let from_ = a;
            let value_ = b;
            if (this.c) {
                return;
            }
            if (this.a != null) {
                let c = from_[this._propertyName];
                this.a.setPropertyValue(c, b);
                return;
            }
            let d = null;
            if (this.b) {
                from_[this._index] = value_;
            }
            else {
                from_[this._propertyName] = value_;
            }
        }
        get invalid() {
            return false;
        }
    }
    FastReflectionHelper.$t = /*@__PURE__*/ markType(FastReflectionHelper, 'FastReflectionHelper');
    return FastReflectionHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastItemColumn = /*@__PURE__*/ (() => {
    class FastItemColumn extends Base {
        constructor(a, b, c, d) {
            super();
            this.m = null;
            this.d = false;
            this.e = false;
            this.a = null;
            this.b = null;
            this._propertyName = null;
            this.k = 0;
            this.j = 0;
            this.h = null;
            this.n = 0;
            this.m = c;
            this.d = d;
            this.propertyName = b;
            this.e = FastReflectionHelper.needsHelper(b);
            if (this.e) {
                this.a = new FastReflectionHelper(true, this.propertyName);
            }
            this.c = a;
        }
        get c() {
            return this.b;
        }
        set c(a) {
            this.b = a;
            this.reset();
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get minimum() {
            if (isNaN_(this.k) && this.h != null) {
                this.k = Number.POSITIVE_INFINITY;
                for (let a of fromEnum(this.h)) {
                    if (!isNaN_(a)) {
                        this.k = Math.min(this.k, a);
                    }
                }
            }
            return this.k;
        }
        set minimum(a) {
            this.k = a;
        }
        get maximum() {
            if (isNaN_(this.j) && this.h != null) {
                this.j = Number.NEGATIVE_INFINITY;
                for (let a of fromEnum(this.h)) {
                    if (!isNaN_(a)) {
                        this.j = Math.max(this.j, a);
                    }
                }
            }
            return this.j;
        }
        set maximum(a) {
            this.j = a;
        }
        item(a, b) {
            if (arguments.length === 2) {
                this.h._inner[a] = b;
                return b;
            }
            else {
                return this.h._inner[a];
            }
        }
        getEnumerator() {
            return this.h.getEnumerator();
        }
        getEnumeratorObject() {
            return this.h.getEnumerator();
        }
        contains(a) {
            return this.h.contains(a);
        }
        copyTo(a, b) {
            this.h.copyTo(a, b);
        }
        get count() {
            return this.h.count;
        }
        get isReadOnly() {
            return true;
        }
        indexOf(a) {
            return this.h.indexOf(a);
        }
        add(a) {
            throw new NotImplementedException(0);
        }
        clear() {
            throw new NotImplementedException(0);
        }
        remove(a) {
            throw new NotImplementedException(0);
        }
        insert(a, b) {
            throw new NotImplementedException(0);
        }
        removeAt(a) {
            throw new NotImplementedException(0);
        }
        reset() {
            this.h = null;
            this.minimum = NaN;
            this.maximum = NaN;
            this.n = 0;
            return this.c != null ? this.insertRange(0, this.c.count) : true;
        }
        insertRange(a, b) {
            let c = new Array(b);
            let source_ = this.b.asArray();
            let item_;
            let d = this.minimum;
            let e = this.maximum;
            let f = isNaN_(this.minimum);
            let g = isNaN_(this.maximum);
            let h = 0;
            let i;
            let j = this.m;
            let sourceItem_ = null;
            let propertyName_ = this._propertyName;
            if (this.e) {
                for (let i_ = a; i_ < a + b; ++i_) {
                    sourceItem_ = source_[i_];
                    if (sourceItem_ == null) {
                        item_ = NaN;
                    }
                    else {
                        item_ = this.a.getPropertyValue(sourceItem_);
                    }
                    if (this.d) {
                        if ((typeof (item_) == 'function')) {
                            item_ = item_.apply(sourceItem_);
                        }
                    }
                    if (j != null) {
                        item_ = j(item_);
                    }
                    i = item_ == null ? NaN : item_;
                    let k = (i != i);
                    if (k) {
                        this.n++;
                    }
                    if (f || i < d) {
                        d = i;
                        f = k;
                    }
                    if (g || i > e) {
                        e = i;
                        g = k;
                    }
                    c[h] = i;
                    h++;
                }
            }
            else {
                if (this.m != null || this.d) {
                    for (let i_ = a; i_ < a + b; ++i_) {
                        sourceItem_ = source_[i_];
                        if (sourceItem_ == null) {
                            item_ = NaN;
                        }
                        else {
                            item_ = (sourceItem_[propertyName_]);
                        }
                        if (this.d) {
                            if ((typeof (item_) == 'function')) {
                                item_ = item_.apply(sourceItem_);
                            }
                        }
                        if (j != null) {
                            item_ = j(item_);
                        }
                        i = item_ == null ? NaN : item_;
                        let l = (i != i);
                        if (l) {
                            this.n++;
                        }
                        if (f || i < d) {
                            d = i;
                            f = l;
                        }
                        if (g || i > e) {
                            e = i;
                            g = l;
                        }
                        c[h] = i;
                        h++;
                    }
                }
                else {
                    for (let i_ = a; i_ < a + b; ++i_) {
                        sourceItem_ = source_[i_];
                        if (sourceItem_ == null) {
                            item_ = NaN;
                        }
                        else {
                            item_ = (sourceItem_[propertyName_]);
                        }
                        i = item_ == null ? NaN : item_;
                        let m = (i != i);
                        if (m) {
                            this.n++;
                        }
                        if (f || i < d) {
                            d = i;
                            f = m;
                        }
                        if (g || i > e) {
                            e = i;
                            g = m;
                        }
                        c[h] = i;
                        h++;
                    }
                }
            }
            this.minimum = d;
            this.maximum = e;
            if (this.h == null) {
                this.h = new List$1(Number_$type, 1, c);
            }
            else {
                this.h.t(a, c);
            }
            return true;
        }
        removeRange(a, b) {
            for (let c = a; c < a + b && !isNaN_(this.minimum) && !isNaN_(this.maximum); ++c) {
                if (this.item(c) == this.minimum) {
                    this.minimum = NaN;
                }
                if (this.item(c) == this.maximum) {
                    this.maximum = NaN;
                }
                if (isNaN_(this.item(c))) {
                    this.n--;
                }
            }
            this.h.v(a, b);
            return true;
        }
        s(a, b) {
            if (isNaN_(a)) {
                if (!isNaN_(b)) {
                    if (!isNaN_(this.minimum)) {
                        this.minimum = Math.min(b, this.minimum);
                    }
                    if (!isNaN_(this.maximum)) {
                        this.maximum = Math.max(b, this.maximum);
                    }
                }
                return;
            }
            if (isNaN_(b)) {
                this.minimum = !isNaN_(this.minimum) && a == this.minimum ? NaN : this.minimum;
                this.maximum = !isNaN_(this.maximum) && a == this.maximum ? NaN : this.maximum;
                return;
            }
            if (!isNaN_(this.minimum)) {
                if (a == this.minimum && b > this.minimum) {
                    this.minimum = NaN;
                }
                else {
                    this.minimum = Math.min(b, this.minimum);
                }
            }
            if (!isNaN_(this.maximum)) {
                if (a == this.maximum && b < this.maximum) {
                    this.maximum = NaN;
                }
                else {
                    this.maximum = Math.max(b, this.maximum);
                }
            }
        }
        replaceRange(a, b) {
            let c = false;
            for (let d = 0; d < b; ++d) {
                let e = this.h._inner[a + d];
                let f = this.l(this.c.item(a + d));
                if (isNaN_(e)) {
                    this.n--;
                }
                if (isNaN_(f)) {
                    this.n++;
                }
                if (e != f) {
                    this.h._inner[a + d] = f;
                    c = true;
                    this.s(e, f);
                }
            }
            return c;
        }
        l(a) {
            if (a == null) {
                return NaN;
            }
            let sourceItem_ = a;
            let from_ = a;
            let propertyName_ = this._propertyName;
            if (this.e) {
                a = this.a.getPropertyValue(from_);
            }
            else {
                a = from_[propertyName_];
            }
            if (this.d) {
                from_ = a;
                if ((typeof (from_) == 'function')) {
                    a = from_.apply(sourceItem_);
                }
            }
            if (this.m != null) {
                a = this.m(a);
            }
            if (a == null) {
                return NaN;
            }
            return a;
        }
        static i(a) {
            if (a == null) {
                return NaN;
            }
            return a;
        }
        get mayContainUnknowns() {
            return this.n > 0;
        }
        static q(a, b) {
            FastItemColumn.r(a, 0, a.count - 1, b);
        }
        static r(a, b, c, d) {
            if (b < c) {
                let e = FastItemColumn.o(a, b, c, d);
                FastItemColumn.r(a, b, e - 1, d);
                FastItemColumn.r(a, e + 1, c, d);
            }
        }
        static o(a, b, c, d) {
            let e = a.item(c);
            let f = b;
            for (let g = b; g < c; g++) {
                if (d(a.item(g), e) <= 0) {
                    let h = a.item(f);
                    a.item(f, a.item(g));
                    a.item(g, h);
                    f++;
                }
            }
            let i = a.item(f);
            a.item(f, a.item(c));
            a.item(c, i);
            return f;
        }
        static g(a, b) {
            let c = new List$1(Number_$type, 2, a.count);
            for (let d = 0; d < a.count; d++) {
                c.add(d);
            }
            if (a.count < 22) {
                FastItemColumn.q(c, (e, f) => {
                    let g = a.item(typeGetValue(e));
                    let h = a.item(typeGetValue(f));
                    return b(g, h);
                });
            }
            else {
                c.aa((e, f) => {
                    let g = a.item(e);
                    let h = a.item(f);
                    return b(g, h);
                });
            }
            return c;
        }
        f() {
            return FastItemColumn.g(this.h, (a, b) => {
                let c = a;
                let d = b;
                if (c < d) {
                    return -1;
                }
                if (c > d) {
                    return 1;
                }
                return 0;
            });
        }
        asArray() {
            return this.h.asArray();
        }
        getItem(a) {
            return this.item(a);
        }
    }
    FastItemColumn.$t = /*@__PURE__*/ markType(FastItemColumn, 'FastItemColumn', Base.$, [IFastItemColumnInternal_$type, /*@__PURE__*/ IFastItemColumn$1_$type.specialize(Number_$type)]);
    return FastItemColumn;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastItemDateTimeColumn = /*@__PURE__*/ (() => {
    class FastItemDateTimeColumn extends Base {
        constructor(a, b, c, d) {
            super();
            this.m = null;
            this.d = false;
            this.e = false;
            this.a = null;
            this.b = null;
            this._propertyName = null;
            this.g = false;
            this.f = false;
            this.k = new Date();
            this.j = new Date();
            this.i = null;
            this.m = c;
            this.d = d;
            this.propertyName = b;
            this.e = FastReflectionHelper.needsHelper(b);
            if (this.e) {
                this.a = new FastReflectionHelper(true, this.propertyName);
            }
            this.c = a;
        }
        get c() {
            return this.b;
        }
        set c(a) {
            this.b = a;
            this.reset();
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get minimum() {
            if (!this.g && this.i != null) {
                for (let a of fromEnum(this.i)) {
                    if (a < this.k) {
                        this.k = a;
                    }
                }
                if (this.i.count > 0) {
                    this.g = true;
                }
            }
            return this.k;
        }
        set minimum(a) {
            this.k = a;
        }
        get maximum() {
            if (!this.f && this.i != null) {
                for (let a of fromEnum(this.i)) {
                    if (a > this.j) {
                        this.j = a;
                    }
                }
                if (this.i.count > 0) {
                    this.f = true;
                }
            }
            return this.j;
        }
        set maximum(a) {
            this.j = a;
        }
        item(a, b) {
            if (arguments.length === 2) {
                return b;
            }
            else {
                return this.i._inner[a];
            }
        }
        getEnumerator() {
            return this.i.getEnumerator();
        }
        getEnumeratorObject() {
            return this.i.getEnumerator();
        }
        contains(a) {
            return this.i.contains(a);
        }
        copyTo(a, b) {
            this.i.copyTo(a, b);
        }
        get count() {
            return this.i.count;
        }
        get isReadOnly() {
            return true;
        }
        indexOf(a) {
            return this.i.indexOf(a);
        }
        add(a) {
            throw new NotImplementedException(0);
        }
        clear() {
            throw new NotImplementedException(0);
        }
        remove(a) {
            throw new NotImplementedException(0);
        }
        insert(a, b) {
            throw new NotImplementedException(0);
        }
        removeAt(a) {
            throw new NotImplementedException(0);
        }
        reset() {
            this.i = null;
            this.g = false;
            this.f = false;
            return this.c != null ? this.insertRange(0, this.c.count) : true;
        }
        insertRange(a, b) {
            let c = new Array(b);
            let source_ = this.b.asArray();
            let item_;
            let d = this.minimum;
            let e = this.maximum;
            let f;
            let g = 0;
            let h = this.m;
            let propertyName_ = this._propertyName;
            let sourceItem_ = null;
            if (this.e) {
                for (let i_ = a; i_ < a + b; ++i_) {
                    sourceItem_ = source_[i_];
                    item_ = this.a.getPropertyValue(sourceItem_);
                    if (this.d) {
                        if ((typeof (item_) == 'function')) {
                            item_ = item_.apply(sourceItem_);
                        }
                    }
                    if (h != null) {
                        item_ = h(item_);
                    }
                    f = item_ == null ? (new Date()) : item_;
                    if (!this.g) {
                        d = f;
                        this.g = true;
                    }
                    else if (f < d) {
                        d = f;
                    }
                    if (!this.f) {
                        e = f;
                        this.f = true;
                    }
                    else if (f > e) {
                        e = f;
                    }
                    c[g] = f;
                    g++;
                }
            }
            else {
                if (this.m != null || this.d) {
                    for (let i_ = a; i_ < a + b; ++i_) {
                        sourceItem_ = source_[i_];
                        item_ = (source_[i_][propertyName_]);
                        if (this.d) {
                            if ((typeof (item_) == 'function')) {
                                item_ = item_.apply(sourceItem_);
                            }
                        }
                        if (h != null) {
                            item_ = h(item_);
                        }
                        f = item_ == null ? (new Date()) : item_;
                        if (!this.g) {
                            d = f;
                            this.g = true;
                        }
                        else if (f < d) {
                            d = f;
                        }
                        if (!this.f) {
                            e = f;
                            this.f = true;
                        }
                        else if (f > e) {
                            e = f;
                        }
                        c[g] = f;
                        g++;
                    }
                }
                else {
                    for (let i_ = a; i_ < a + b; ++i_) {
                        item_ = (source_[i_][propertyName_]);
                        f = item_ == null ? (new Date()) : item_;
                        if (!this.g) {
                            d = f;
                            this.g = true;
                        }
                        else if (f < d) {
                            d = f;
                        }
                        if (!this.f) {
                            e = f;
                            this.f = true;
                        }
                        else if (f > e) {
                            e = f;
                        }
                        c[g] = f;
                        g++;
                    }
                }
            }
            this.minimum = d;
            this.maximum = e;
            if (this.i == null) {
                this.i = new List$1(Date_$type, 1, c);
            }
            else {
                this.i.t(a, c);
            }
            return true;
        }
        removeRange(a, b) {
            for (let c = a; c < a + b; ++c) {
                if (+(this.item(c)) == +(this.minimum)) {
                    this.g = false;
                }
                if (+(this.item(c)) == +(this.maximum)) {
                    this.f = false;
                }
            }
            this.i.v(a, b);
            return true;
        }
        p(a, b) {
            if (+a != +(dateMinValue())) {
                if (+b != +(dateMinValue())) {
                    this.minimum = b < this.minimum ? b : this.minimum;
                    this.maximum = b > this.maximum ? b : this.maximum;
                }
                return;
            }
            this.minimum = b < this.minimum ? b : this.minimum;
            this.maximum = b > this.maximum ? b : this.maximum;
        }
        replaceRange(a, b) {
            let c = false;
            for (let d = 0; d < b; ++d) {
                let e = this.i._inner[a + d];
                let f = this.l(this.c.item(a + d));
                if (+e != +f) {
                    this.i._inner[a + d] = f;
                    c = true;
                    this.p(e, f);
                }
            }
            return c;
        }
        l(a) {
            if (a == null) {
                return dateMinValue();
            }
            let sourceItem_ = a;
            let from_ = a;
            let propertyName_ = this._propertyName;
            if (this.e) {
                a = this.a.getPropertyValue(from_);
            }
            else {
                a = from_[propertyName_];
            }
            if (this.d) {
                from_ = a;
                if ((typeof (from_) == 'function')) {
                    a = from_.apply(sourceItem_);
                }
            }
            if (this.m != null) {
                a = this.m(a);
            }
            if (a == null) {
                return dateMinValue();
            }
            return a;
        }
        get mayContainUnknowns() {
            return true;
        }
        h() {
            return FastItemColumn.g(this.i, (a, b) => {
                let c = a;
                let d = b;
                if (c < d) {
                    return -1;
                }
                if (c > d) {
                    return 1;
                }
                return 0;
            });
        }
        asArray() {
            return this.i.asArray();
        }
        getItem(a) {
            return this.item(a);
        }
        static o() {
            TypeRegistrar.register("FastItemDateTimeColumn", FastItemDateTimeColumn.$);
        }
    }
    FastItemDateTimeColumn.$t = /*@__PURE__*/ markType(FastItemDateTimeColumn, 'FastItemDateTimeColumn', Base.$, [IFastItemColumnInternal_$type, /*@__PURE__*/ IFastItemColumn$1_$type.specialize(Date_$type)]);
    return FastItemDateTimeColumn;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastItemObjectColumn = /*@__PURE__*/ (() => {
    class FastItemObjectColumn extends Base {
        constructor(a, b, c, d) {
            super();
            this.h = null;
            this.d = false;
            this.e = false;
            this.a = null;
            this.b = null;
            this._propertyName = null;
            this.j = null;
            this.i = null;
            this.g = null;
            this.h = c;
            this.d = d;
            this.propertyName = b;
            this.e = FastReflectionHelper.needsHelper(b);
            if (this.e) {
                this.a = new FastReflectionHelper(true, this.propertyName);
            }
            this.c = a;
        }
        get c() {
            return this.b;
        }
        set c(a) {
            this.b = a;
            this.reset();
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get minimum() {
            return this.j;
        }
        set minimum(a) {
            this.j = a;
        }
        get maximum() {
            return this.i;
        }
        set maximum(a) {
            this.i = a;
        }
        item(a, b) {
            if (arguments.length === 2) {
                return b;
            }
            else {
                return this.g._inner[a];
            }
        }
        getEnumerator() {
            return this.g.getEnumerator();
        }
        getEnumeratorObject() {
            return this.g.getEnumerator();
        }
        contains(a) {
            return this.g.contains1(a);
        }
        copyTo(a, b) {
            this.g.copyTo(a, b);
        }
        get count() {
            return this.g.count;
        }
        get isReadOnly() {
            return true;
        }
        indexOf(a) {
            return this.g.indexOf1(a);
        }
        add(a) {
            throw new NotImplementedException(0);
        }
        clear() {
            throw new NotImplementedException(0);
        }
        remove(a) {
            throw new NotImplementedException(0);
        }
        insert(a, b) {
            throw new NotImplementedException(0);
        }
        removeAt(a) {
            throw new NotImplementedException(0);
        }
        reset() {
            this.g = null;
            return this.c != null ? this.insertRange(0, this.c.count) : true;
        }
        insertRange(a, b) {
            let c = ((() => {
                let $ret = new List$1(Base.$, 0);
                $ret.h = b;
                return $ret;
            })());
            for (let d = a; d < a + b; ++d) {
                let e = this.k(this.c.item(d));
                c.add1(e);
            }
            if (this.g == null) {
                this.g = c;
            }
            else {
                this.g.t(a, (c));
            }
            return true;
        }
        replaceRange(a, b) {
            let c = false;
            for (let d = 0; d < b; ++d) {
                let e = this.g._inner[a + d];
                let f = this.k(this.c.item(a + d));
                if (e != f) {
                    this.g._inner[a + d] = f;
                    c = true;
                }
            }
            return c;
        }
        removeRange(a, b) {
            this.g.v(a, b);
            return true;
        }
        k(a) {
            if (a == null) {
                return null;
            }
            let sourceItem_ = a;
            let from_ = a;
            let propertyName_ = this._propertyName;
            if (this.e) {
                a = this.a.getPropertyValue(from_);
            }
            else {
                a = from_[propertyName_];
            }
            if (this.d) {
                from_ = a;
                if ((typeof (from_) == 'function')) {
                    a = from_.apply(sourceItem_);
                }
            }
            if (this.h != null) {
                a = this.h(a);
            }
            return a;
        }
        get mayContainUnknowns() {
            return true;
        }
        f() {
            return FastItemColumn.g(this.g, (a, b) => {
                let c = parseFloat(a);
                let d = parseFloat(b);
                if (c < d) {
                    return -1;
                }
                if (c > d) {
                    return 1;
                }
                return 0;
            });
        }
        asArray() {
            return this.g.asArray();
        }
        getItem(a) {
            return this.item(a);
        }
        static m() {
            TypeRegistrar.register("FastItemObjectColumn", FastItemObjectColumn.$);
        }
    }
    FastItemObjectColumn.$t = /*@__PURE__*/ markType(FastItemObjectColumn, 'FastItemObjectColumn', Base.$, [IFastItemColumnInternal_$type, /*@__PURE__*/ IFastItemColumn$1_$type.specialize(Base.$)]);
    return FastItemObjectColumn;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastItemIntColumn = /*@__PURE__*/ (() => {
    class FastItemIntColumn extends Base {
        constructor(a, b, c, d) {
            super();
            this.h = null;
            this.d = false;
            this.e = false;
            this.a = null;
            this.b = null;
            this._propertyName = null;
            this.j = 0;
            this.i = 0;
            this.g = null;
            this.h = c;
            this.d = d;
            this.propertyName = b;
            this.e = FastReflectionHelper.needsHelper(b);
            if (this.e) {
                this.a = new FastReflectionHelper(true, this.propertyName);
            }
            this.c = a;
        }
        get c() {
            return this.b;
        }
        set c(a) {
            this.b = a;
            this.reset();
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get minimum() {
            return this.j;
        }
        set minimum(a) {
            this.j = a;
        }
        get maximum() {
            return this.i;
        }
        set maximum(a) {
            this.i = a;
        }
        item(a, b) {
            if (arguments.length === 2) {
                return b;
            }
            else {
                return this.g._inner[a];
            }
        }
        getEnumerator() {
            return this.g.getEnumerator();
        }
        getEnumeratorObject() {
            return this.g.getEnumerator();
        }
        contains(a) {
            return this.g.contains(a);
        }
        copyTo(a, b) {
            this.g.copyTo(a, b);
        }
        get count() {
            return this.g.count;
        }
        get isReadOnly() {
            return true;
        }
        indexOf(a) {
            return this.g.indexOf(a);
        }
        add(a) {
            throw new NotImplementedException(0);
        }
        clear() {
            throw new NotImplementedException(0);
        }
        remove(a) {
            throw new NotImplementedException(0);
        }
        insert(a, b) {
            throw new NotImplementedException(0);
        }
        removeAt(a) {
            throw new NotImplementedException(0);
        }
        reset() {
            this.g = null;
            return this.c != null ? this.insertRange(0, this.c.count) : true;
        }
        insertRange(a, b) {
            let c = new Array(b);
            let source_ = this.b.asArray();
            let item_;
            let d = this.minimum;
            let e = this.maximum;
            let f = 0;
            let g = this.h;
            let propertyName_ = this._propertyName;
            let sourceItem_;
            if (this.e) {
                for (let i_ = a; i_ < a + b; ++i_) {
                    sourceItem_ = source_[i_];
                    item_ = typeGetValue(this.a.getPropertyValue(sourceItem_));
                    if (this.d) {
                        if ((typeof (item_) == 'function')) {
                            item_ = item_.apply(sourceItem_);
                        }
                    }
                    if (g != null) {
                        item_ = g(item_);
                    }
                    let h = item_ == null ? 0 : typeGetValue(item_);
                    c[f] = h;
                    f++;
                }
            }
            else {
                if (this.h != null || this.d) {
                    for (let i_ = a; i_ < a + b; ++i_) {
                        sourceItem_ = source_[i_];
                        item_ = (source_[i_][propertyName_]);
                        if (this.d) {
                            if ((typeof (item_) == 'function')) {
                                item_ = item_.apply(sourceItem_);
                            }
                        }
                        if (g != null) {
                            item_ = g(item_);
                        }
                        let i = item_ == null ? 0 : typeGetValue(item_);
                        c[f] = i;
                        f++;
                    }
                }
                else {
                    for (let i_ = a; i_ < a + b; ++i_) {
                        item_ = (source_[i_][propertyName_]);
                        let j = item_ == null ? 0 : typeGetValue(item_);
                        c[f] = j;
                        f++;
                    }
                }
            }
            if (this.g == null) {
                this.g = new List$1(Number_$type, 1, c);
            }
            else {
                this.g.t(a, c);
            }
            return true;
        }
        replaceRange(a, b) {
            let c = false;
            for (let d = 0; d < b; ++d) {
                let e = this.g._inner[a + d];
                let f = this.k(this.c.item(a + d));
                if (e != f) {
                    this.g._inner[a + d] = f;
                    c = true;
                }
            }
            return c;
        }
        removeRange(a, b) {
            this.g.v(a, b);
            return true;
        }
        k(a) {
            let sourceItem_ = a;
            let from_ = a;
            let propertyName_ = this._propertyName;
            if (this.e) {
                a = this.a.getPropertyValue(from_);
            }
            else {
                a = from_[propertyName_];
            }
            if (this.d) {
                from_ = a;
                if ((typeof (from_) == 'function')) {
                    a = from_.apply(sourceItem_);
                }
            }
            if (this.h != null) {
                a = this.h(a);
            }
            if (a == null) {
                return 0;
            }
            return typeGetValue(a);
        }
        get mayContainUnknowns() {
            return true;
        }
        f() {
            return FastItemColumn.g(this.g, (a, b) => {
                let c = typeGetValue(a);
                let d = typeGetValue(b);
                if (c < d) {
                    return -1;
                }
                if (c > d) {
                    return 1;
                }
                return 0;
            });
        }
        asArray() {
            return this.g.asArray();
        }
        getItem(a) {
            return this.item(a);
        }
        static m() {
            TypeRegistrar.register("FastItemIntColumn", FastItemIntColumn.$);
        }
    }
    FastItemIntColumn.$t = /*@__PURE__*/ markType(FastItemIntColumn, 'FastItemIntColumn', Base.$, [IFastItemColumnInternal_$type, /*@__PURE__*/ IFastItemColumn$1_$type.specialize(Number_$type)]);
    return FastItemIntColumn;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFastItemsSource_$type = /*@__PURE__*/ new Type(null, 'IFastItemsSource', null, [IGetItemAtIndex_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnReference = /*@__PURE__*/ (() => {
    class ColumnReference extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.b = 0;
            this.a = a;
            this.b = 0;
        }
    }
    ColumnReference.$t = /*@__PURE__*/ markType(ColumnReference, 'ColumnReference');
    return ColumnReference;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastItemsSourceEventArgs = /*@__PURE__*/ (() => {
    class FastItemsSourceEventArgs extends EventArgs {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        super();
                        this._action = 0;
                        this._position = 0;
                        this._count = 0;
                        this._propertyName = null;
                        this.action = c;
                        this.position = d;
                        this.count = e;
                        this.propertyName = null;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super();
                        this._action = 0;
                        this._position = 0;
                        this._count = 0;
                        this._propertyName = null;
                        this.action = 3;
                        this.position = c;
                        this.count = 1;
                        this.propertyName = d;
                    }
                    break;
            }
        }
        get action() {
            return this._action;
        }
        set action(a) {
            this._action = a;
        }
        get position() {
            return this._position;
        }
        set position(a) {
            this._position = a;
        }
        get count() {
            return this._count;
        }
        set count(a) {
            this._count = a;
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
    }
    FastItemsSourceEventArgs.$t = /*@__PURE__*/ markType(FastItemsSourceEventArgs, 'FastItemsSourceEventArgs', EventArgs.$);
    return FastItemsSourceEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Tuple$2 = /*@__PURE__*/ (() => {
    class Tuple$2 extends Base {
        constructor($t1, $t2, a, b) {
            super();
            this.$t1 = null;
            this.$t2 = null;
            this.c = null;
            this.d = null;
            this.$t1 = $t1;
            this.$t2 = $t2;
            this.$type = this.$type.specialize(this.$t1, this.$t2);
            this.c = a;
            this.d = b;
        }
        equals(a) {
            let b = typeCast(Tuple$2.$.specialize(this.$t1, this.$t2), a);
            return b != null && Base.equalsStatic(getBoxIfEnum(this.$t1, this.c), getBoxIfEnum(this.$t1, b.c)) && Base.equalsStatic(getBoxIfEnum(this.$t2, this.d), getBoxIfEnum(this.$t2, b.d));
        }
        getHashCode() {
            let a = 0;
            if (getBoxIfEnum(this.$t1, this.c) != null) {
                a = Base.getHashCodeStatic(this.c);
            }
            if (getBoxIfEnum(this.$t2, this.d) != null) {
                a = a ^ Base.getHashCodeStatic(this.d) << 16;
            }
            return a;
        }
    }
    Tuple$2.$t = /*@__PURE__*/ markType(Tuple$2, 'Tuple$2');
    return Tuple$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastItemsSource = /*@__PURE__*/ (() => {
    class FastItemsSource extends Base {
        constructor() {
            super();
            this.event = null;
            this.a = new Dictionary$2(String_$type, ColumnReference.$, 0);
            this.d = null;
            this.c = new List$1(Base.$, 0);
            this.b = null;
        }
        o(a, b, c) {
            if (this.event != null) {
                this.event(this, new FastItemsSourceEventArgs(0, a, b, c));
            }
        }
        p(a, b) {
            if (this.event != null) {
                this.event(this, new FastItemsSourceEventArgs(1, a, b));
            }
        }
        get e() {
            return this.d;
        }
        set e(a) {
            if (this.d == a) {
                return;
            }
            this.m();
            this.d = a;
            this.c.clear();
            this.b = null;
            this.g();
            for (let b of fromEnum(this.a.values)) {
                b.a.reset();
            }
            this.o(1, 0, this.c.count);
        }
        m() {
        }
        n(a, b, c) {
            let d = a;
            switch (c.action) {
                case 0:
                    d.h(c.newStartingIndex, c.newItems);
                    break;
                case 1:
                    d.j(c.oldStartingIndex, c.oldItems);
                    break;
                case 2:
                    d.k(c.newStartingIndex, c.oldItems, c.newItems);
                    break;
                case 4:
                    d.l();
                    break;
            }
        }
        g() {
            this.c.t(this.c.count, this.d);
        }
        h(a, b) {
            if (this.b != null) {
                for (let c = 0; c < b.count; ++c) {
                    this.b.addItem(b.item(c), a + c);
                }
                for (let d = a; d < this.c.count; ++d) {
                    this.b.item(this.c._inner[d], d + b.count);
                }
            }
            this.c.t(a, b);
            for (let e of fromEnum(this.a.values)) {
                e.a.insertRange(a, b.count);
            }
            this.o(1, a, b.count);
        }
        j(a, b) {
            this.c.v(a, b.count);
            if (this.b != null) {
                for (let c of fromEn(b)) {
                    this.b.removeItem(c);
                }
                for (let d = a; d < this.c.count; ++d) {
                    this.b.item(this.c._inner[d], d);
                }
            }
            for (let e of fromEnum(this.a.values)) {
                e.a.removeRange(a, b.count);
            }
            this.o(0, a, b.count);
        }
        k(a, b, c) {
            for (let d = 0; d < c.count; ++d) {
                this.c._inner[a + d] = c.item(d);
            }
            if (this.b != null) {
                for (let e of fromEn(b)) {
                    this.b.removeItem(e);
                }
                for (let f = 0; f < c.count; ++f) {
                    this.b.addItem(c.item(f), a + f);
                }
            }
            for (let g of fromEnum(this.a.values)) {
                g.a.replaceRange(a, c.count);
            }
            this.o(2, a, b.count);
        }
        l() {
            this.c.clear();
            this.b = null;
            this.c.t(0, this.d);
            for (let a of fromEnum(this.a.values)) {
                a.a.reset();
            }
            this.o(4, 0, this.c.count);
        }
        i(a, b) {
            let c = null;
            let d = this.indexOf(a);
            if (d == -1) {
                throw new ArgumentException(1, "item");
            }
            if (stringIsNullOrEmpty(b)) {
                for (let e of fromEnum(this.a)) {
                    e.value.a.replaceRange(d, 1);
                    this.p(d, e.value.a.propertyName);
                }
            }
            else if (b == "Item[]") {
                for (let f of fromEnum(this.a)) {
                    if (f.key != null && stringStartsWith(f.key, "[") && stringEndsWith(f.key, "]")) {
                        f.value.a.replaceRange(d, 1);
                        this.p(d, f.value.a.propertyName);
                    }
                }
            }
            else {
                if (((() => { let g = this.a.tryGetValue(b, c); c = g.p1; return g.ret; })())) {
                    c.a.replaceRange(d, 1);
                }
                if (((() => { let g = this.a.tryGetValue(b + "_object", c); c = g.p1; return g.ret; })())) {
                    c.a.replaceRange(d, 1);
                }
                this.p(d, b);
            }
        }
        get count() {
            return this.c.count;
        }
        item(a) {
            return this.c._inner[a];
        }
        getEnumeratorObject() {
            return this.c.getEnumerator();
        }
        indexOf(a) {
            let b;
            if (this.b == null && this.c.count > 0) {
                this.b = new Dictionary$2(Base.$, Number_$type, 0);
                let contents_ = this.c;
                let index_ = this.b;
                for (let j_ = 0; j_ < this.c.count; j_++) {
                    let c = contents_._inner[j_];
                    if (!this.b.containsKey(c)) {
                        this.b.addItem(c, j_);
                    }
                }
            }
            if (this.b != null && ((() => { let d = this.b.tryGetValue(a, b); b = d.p1; return d.ret; })())) {
                return b;
            }
            else {
                return -1;
            }
        }
        registerColumnDateTime(a, b, c) {
            let d = null;
            if (a != null) {
                let e = null;
                if (!((() => { let f = this.a.tryGetValue(a, e); e = f.p1; return f.ret; })())) {
                    let f = FastItemsSource.f(a).c;
                    e = new ColumnReference(TypeRegistrar.create("FastItemDateTimeColumn", this, f, b, c));
                    this.a.addItem(a, e);
                }
                e.b = e.b + 1;
                d = typeCast(IFastItemColumn$1_$type.specialize(Date_$type), e.a);
            }
            return d;
        }
        registerColumnObject(a, b, c) {
            let d = null;
            let e = a + "_object";
            if (a != null) {
                let f = null;
                if (!((() => { let g = this.a.tryGetValue(e, f); f = g.p1; return g.ret; })())) {
                    let g = FastItemsSource.f(a).c;
                    f = new ColumnReference(TypeRegistrar.create("FastItemObjectColumn", this, g, b, c));
                    this.a.addItem(e, f);
                }
                f.b = f.b + 1;
                d = typeCast(IFastItemColumn$1_$type.specialize(Base.$), f.a);
            }
            return d;
        }
        registerColumnInt(a, b, c) {
            let d = null;
            if (a == null) {
                a = "";
            }
            let e = null;
            if (!((() => { let f = this.a.tryGetValue(a, e); e = f.p1; return f.ret; })())) {
                let f = FastItemsSource.f(a).c;
                e = new ColumnReference(TypeRegistrar.create("FastItemIntColumn", this, f, b, c));
                this.a.addItem(a, e);
            }
            e.b = e.b + 1;
            d = typeCast(IFastItemColumn$1_$type.specialize(Number_$type), e.a);
            return d;
        }
        registerColumn(a, b, c) {
            let d = null;
            if (a == null) {
                a = "";
            }
            let e = null;
            if (!((() => { let f = this.a.tryGetValue(a, e); e = f.p1; return f.ret; })())) {
                let f = FastItemsSource.f(a).c;
                e = new ColumnReference(new FastItemColumn(this, f, b, c));
                this.a.addItem(a, e);
            }
            e.b = e.b + 1;
            d = typeCast(IFastItemColumn$1_$type.specialize(Number_$type), e.a);
            return d;
        }
        deregisterColumn(a) {
            let b = a != null ? a.propertyName : null;
            let c = b;
            if (typeCast(IFastItemColumn$1_$type.specialize(Base.$), a) !== null) {
                c += "_object";
            }
            if (b != null) {
                let d = null;
                if (((() => { let e = this.a.tryGetValue(b, d); d = e.p1; return e.ret; })())) {
                    d.b = d.b - 1;
                    if (d.b == 0) {
                        this.a.removeItem(c);
                    }
                }
            }
        }
        asArray() {
            return this.c.asArray();
        }
        handleCollectionChanged(a) {
            switch (a.action) {
                case 0:
                    this.h(a.newStartingIndex, a.newItems);
                    break;
                case 1:
                    this.j(a.oldStartingIndex, a.oldItems);
                    break;
                case 2:
                    this.k(a.newStartingIndex, a.oldItems, a.newItems);
                    break;
                case 4:
                    this.l();
                    break;
            }
        }
        static f(a) {
            let b = a.split('!');
            if (b.length == 2) {
                return new Tuple$2(String_$type, String_$type, b[0], b[1]);
            }
            else {
                return new Tuple$2(String_$type, String_$type, a, null);
            }
        }
        getItem(a) {
            return this.item(a);
        }
    }
    FastItemsSource.$t = /*@__PURE__*/ markType(FastItemsSource, 'FastItemsSource', Base.$, [IEnumerable_$type, IFastItemsSource_$type]);
    return FastItemsSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastItemsSourceReference = /*@__PURE__*/ (() => {
    class FastItemsSourceReference extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.b = 0;
            this.a = a;
            this.b = 0;
        }
    }
    FastItemsSourceReference.$t = /*@__PURE__*/ markType(FastItemsSourceReference, 'FastItemsSourceReference');
    return FastItemsSourceReference;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFastItemsSourceProvider_$type = /*@__PURE__*/ new Type(null, 'IFastItemsSourceProvider');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IRenderer_$type = /*@__PURE__*/ new Type(null, 'IRenderer');
/**
 * @hidden
 */
let FontInfo = /*@__PURE__*/ (() => {
    class FontInfo extends Base {
        w(a) {
            if (isNaN_(this.f)) {
                let b = FontUtil.getFontInfoFromString(a, this.fontString);
                this.k = b.q;
                this.d = b.f;
                this.l = b.r;
                this.n = b.t;
                this.o = b.u;
                this.p = b.v;
            }
        }
        constructor() {
            super();
            this.i = 0;
            this.n = null;
            this.o = null;
            this.p = null;
            this.d = 0;
            this.e = 0;
            this.k = null;
            this.l = null;
            this.m = null;
            this.f = NaN;
            this.g = NaN;
        }
        c() {
            return isNaN_(this.f) && this.q == null && (this.fontString == null || this.fontString == "NaNpx/normal");
        }
        get j() {
            return this.i;
        }
        get t() {
            return this.n;
        }
        set t(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.x("FontStyle");
            }
        }
        x(a) {
            if (a != "FontString") {
                this.m = null;
            }
            if (this.i < 100000) {
                this.i++;
            }
            else {
                this.i = 0;
            }
        }
        get u() {
            return this.o;
        }
        set u(a) {
            let b = this.o;
            this.o = a;
            if (this.o != b) {
                this.x("FontVariant");
            }
        }
        get v() {
            return this.p;
        }
        set v(a) {
            let b = this.p;
            this.p = a;
            if (this.p != b) {
                this.x("FontWeight");
            }
        }
        get f() {
            return this.d;
        }
        set f(a) {
            let b = this.d;
            this.d = a;
            if (this.d != b) {
                this.x("FontSize");
            }
        }
        get g() {
            return this.e;
        }
        set g(a) {
            let b = this.e;
            this.e = a;
            if (this.e != b) {
                this.x("LineHeight");
            }
        }
        get q() {
            return this.k;
        }
        set q(a) {
            let b = this.k;
            this.k = a;
            if (this.k != b) {
                this.x("FontFamily");
            }
        }
        get r() {
            return this.l;
        }
        set r(a) {
            let b = this.l;
            this.l = a;
            if (this.l != b) {
                this.x("FontStretch");
            }
        }
        get fontString() {
            if (this.m == null) {
                FontUtil.updateFontString(this);
            }
            return this.m;
        }
        set fontString(a) {
            let b = this.m;
            this.m = a;
            if (this.m != b) {
                this.x("FontString");
            }
        }
        a() {
            return ((() => {
                let $ret = new FontInfo();
                $ret.t = this.t;
                $ret.u = this.u;
                $ret.v = this.v;
                $ret.f = this.f;
                $ret.g = this.g;
                $ret.q = this.q;
                $ret.r = this.r;
                $ret.fontString = this.fontString;
                return $ret;
            })());
        }
        h(a) {
            if (a > 0) {
                return this.f * a;
            }
            return this.f;
        }
        b(a) {
            let b = this.a();
            if (a > 0) {
                b.f = a;
            }
            return b;
        }
    }
    FontInfo.$t = /*@__PURE__*/ markType(FontInfo, 'FontInfo');
    return FontInfo;
})();
/**
 * @hidden
 */
let FontUtil = /*@__PURE__*/ (() => {
    class FontUtil extends Base {
        static getCurrentFontHeight(a, b) {
            if (a == null) {
                return 14;
            }
            let c = null;
            if (b != null) {
                c = b.fontString;
            }
            return a.getHeightForFontString(c, "M", true);
        }
        static measureStringHeight(a, b, c) {
            let d = a.getHeightForFontString(c.fontString, b, false);
            return d;
        }
        static measureStringWidth1(a, b, c) {
            c.aa();
            c.ac(b);
            let d = c.g(a);
            c.z();
            return d;
        }
        static measureStringWidth(a, b, c) {
            c.aa();
            c.ad(b);
            let d = c.g(a);
            c.z();
            return d;
        }
        static getDefaultFont(a) {
            if (FontUtil.a == null) {
                FontUtil.a = FontUtil.getFontInfoFromString(a, "12px Verdana");
            }
            return FontUtil.a;
        }
        static getFontSize(a) {
            return a.f;
        }
        static getFontWithNewFontSize(a, b) {
            let c = a.a();
            c.f = b;
            c.fontString = b + "px " + a.q;
            return c;
        }
        static getFontInfoFromString(a, b) {
            a.startCSSQuery();
            a.setCssQueryFontString(b);
            let c = a.getCssDefaultPropertyValue("", "font-style");
            let d = a.getCssDefaultPropertyValue("", "font-variant");
            let e = a.getCssDefaultPropertyValue("", "font-weight");
            e = FontUtil.o(e);
            let f = a.getCssDefaultPropertyValue("", "font-size");
            let g = a.getCssDefaultPropertyValue("", "line-height");
            let h = a.getCssDefaultPropertyValue("", "font-family");
            a.endCSSQuery();
            let i = new FontInfo();
            let j = true;
            b = "";
            if (c.length > 0) {
                if (!j) {
                    b += " ";
                }
                else {
                    j = false;
                }
                b += c;
            }
            if (d.length > 0) {
                if (!j) {
                    b += " ";
                }
                else {
                    j = false;
                }
                b += d;
            }
            if (e.length > 0) {
                if (!j) {
                    b += " ";
                }
                else {
                    j = false;
                }
                b += e;
            }
            if (f.length > 0) {
                if (!j) {
                    b += " ";
                }
                else {
                    j = false;
                }
                b += f;
            }
            if (g.length > 0) {
                if (!j) {
                    b += "/";
                }
                else {
                    j = false;
                }
                b += g;
            }
            if (h.length > 0) {
                if (!j) {
                    b += " ";
                }
                else {
                    j = false;
                }
                b += h;
            }
            let k = new FontInfo();
            k.q = h;
            k.f = parseFloat(f);
            k.r = "Normal";
            k.t = c;
            k.u = d;
            k.v = e;
            k.fontString = b;
            return k;
        }
        static getFontForClass(a, b) {
            let c = stringEmpty();
            a.startCSSQuery();
            let d = a.getCssDefaultPropertyValue(b, "font-style");
            let e = a.getCssDefaultPropertyValue(b, "font-variant");
            let f = a.getCssDefaultPropertyValue(b, "font-weight");
            f = FontUtil.o(f);
            let g = a.getCssDefaultPropertyValue(b, "font-size");
            let h = a.getCssDefaultPropertyValue(b, "line-height");
            let i = a.getCssDefaultPropertyValue(b, "font-family");
            a.endCSSQuery();
            let j = true;
            if (d.length > 0) {
                if (!j) {
                    c += " ";
                }
                else {
                    j = false;
                }
                c += d;
            }
            if (e.length > 0) {
                if (!j) {
                    c += " ";
                }
                else {
                    j = false;
                }
                c += e;
            }
            if (f.length > 0) {
                if (!j) {
                    c += " ";
                }
                else {
                    j = false;
                }
                c += f;
            }
            if (g.length > 0) {
                if (!j) {
                    c += " ";
                }
                else {
                    j = false;
                }
                c += g;
            }
            if (h.length > 0) {
                if (!j) {
                    c += "/";
                }
                else {
                    j = false;
                }
                c += h;
            }
            if (i.length > 0) {
                if (!j) {
                    c += " ";
                }
                else {
                    j = false;
                }
                c += i;
            }
            let k = new FontInfo();
            k.q = i;
            k.f = parseFloat(g);
            k.r = "Normal";
            k.t = d;
            k.u = e;
            k.v = f;
            k.fontString = c;
            return k;
        }
        static getFont(a) {
            return FontUtil.getFontForClass(a, "");
        }
        static updateFontString(a) {
            let b = stringEmpty();
            let c = a.t;
            let d = a.u;
            let e = a.v;
            let f = a.f.toString();
            let g = "normal";
            let h = a.q;
            let i = true;
            if (c != null && c.length > 0) {
                if (!i) {
                    b += " ";
                }
                else {
                    i = false;
                }
                b += c;
            }
            if (d != null && d.length > 0) {
                if (!i) {
                    b += " ";
                }
                else {
                    i = false;
                }
                b += d;
            }
            if (e != null && e.length > 0) {
                if (!i) {
                    b += " ";
                }
                else {
                    i = false;
                }
                b += e;
            }
            if (f.length > 0) {
                if (!i) {
                    b += " ";
                }
                else {
                    i = false;
                }
                b += f + "px";
            }
            if (g != null && g.length > 0) {
                if (!i) {
                    b += "/";
                }
                else {
                    i = false;
                }
                b += g;
            }
            if (h != null && h.length > 0) {
                if (!i) {
                    b += " ";
                }
                else {
                    i = false;
                }
                b += h;
            }
            a.fontString = b;
        }
        static getFontInfo(a, b, c) {
            if (c == null) {
                let d = new FontInfo();
                a.startCSSQuery();
                let e = a.getCssDefaultPropertyValue("", "font-style");
                let f = a.getCssDefaultPropertyValue("", "font-variant");
                let g = a.getCssDefaultPropertyValue("", "font-weight");
                g = FontUtil.o(g);
                let h = a.getCssDefaultPropertyValue("", "font-size");
                let i = a.getCssDefaultPropertyValue("", "line-height");
                let j = a.getCssDefaultPropertyValue("", "font-family");
                d.q = stringReplace(j, "'", "");
                d.t = FontUtil.p(e);
                d.v = FontUtil.p(g.toString());
                d.u = f;
                d.g = parseFloat(i);
                d.f = parseFloat(h);
                a.endCSSQuery();
                return d;
            }
            return c;
        }
        static p(a) {
            if (stringIsNullOrEmpty(a)) {
                return stringEmpty();
            }
            let b = a.substr(0, 1).toUpperCase();
            if (a.length > 1) {
                b += a.substr(1);
            }
            return b;
        }
        static toFontInfo(a, b) {
            if (b == null) {
                return null;
            }
            return FontUtil.getFontInfoFromString(a, b);
        }
        static interpolateFont(a, b, c, d) {
            if (c == null) {
                c = d;
            }
            if (d == null) {
                d = c;
            }
            if (c == null && d == null) {
                return;
            }
            if (b > 0.5) {
                a.q = d.q;
                a.r = d.r;
                a.t = d.t;
                a.u = d.u;
                a.v = d.v;
                a.g = d.g;
                a.f = d.f;
            }
            else {
                a.q = c.q;
                a.r = c.r;
                a.t = c.t;
                a.u = c.u;
                a.v = c.v;
                a.g = c.g;
                a.f = c.f;
            }
            if (!isNaN_(c.f) && !isNaN_(d.f)) {
                a.f = c.f + (d.f - c.f) * b;
            }
            FontUtil.updateFontString(a);
        }
        static charsEqual(a, b, c, d) {
            return Base.equalsStatic(a.charAt(b), c[d]);
        }
        static o(a) {
            switch (a) {
                case "400":
                    a = "normal";
                    break;
                case "700":
                case "800":
                    a = "bold";
                    break;
            }
            return a;
        }
    }
    FontUtil.$t = /*@__PURE__*/ markType(FontUtil, 'FontUtil');
    FontUtil.a = null;
    return FontUtil;
})();
/**
 * @hidden
 */
let RenderingContext = /*@__PURE__*/ (() => {
    class RenderingContext extends Base {
        h() {
            if (this.c == null) {
                return null;
            }
            return this.c.h$e();
        }
        constructor(a, b) {
            super();
            this.c = null;
            this.e = false;
            this.c = a;
            if (this.c != null) {
                this.c.h$d = b;
            }
        }
        get d() {
            if (this.c == null) {
                return false;
            }
            return true;
        }
        w(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$t(a);
        }
        t(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$q(a);
        }
        r(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$o(a);
        }
        x(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$u(a);
        }
        y(a, b, c) {
            if (this.c == null) {
                return;
            }
            this.c.h$v(a, b, c);
        }
        u(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$r(a);
        }
        v(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$s(a);
        }
        q(a, b) {
            if (this.c == null) {
                return;
            }
            this.c.h$n(a, b);
        }
        k(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$h(a);
        }
        s(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$p(a);
        }
        aa() {
            if (this.c == null) {
                return;
            }
            this.c.h$x();
        }
        z() {
            if (this.c == null) {
                return;
            }
            this.c.h$w();
        }
        af(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$ac(a);
        }
        ab(a, b) {
            if (this.c == null) {
                return;
            }
            this.c.h$y(a, b);
        }
        ag(a, b) {
            if (this.c == null) {
                return;
            }
            this.c.h$ad(a, b);
        }
        l(a, b, c, d) {
            if (this.c == null) {
                return;
            }
            this.c.h$i(a, b, c, d);
        }
        o(a, b, c, d, e, f, g, h, i, j) {
            if (this.c == null) {
                return;
            }
            this.c.h$l(a, b, c, d, e, f, g, h, i, j);
        }
        n(a, b, c, d, e, f) {
            if (this.c == null) {
                return;
            }
            this.c.h$k(a, b, c, d, e, f);
        }
        a(a, b) {
            if (this.c == null) {
                return null;
            }
            return this.c.h$a(a, b);
        }
        i() {
            if (this.c == null) {
                return null;
            }
            return this.c.h$f();
        }
        b() {
            if (this.c == null) {
                return null;
            }
            return this.c.h$b();
        }
        ac(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$z(a);
        }
        ad(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$aa(a);
        }
        g(a) {
            if (this.c == null) {
                return NaN;
            }
            return this.c.h$c(a);
        }
        ah(a, b, c) {
            if (this.c == null) {
                return null;
            }
            let d = this.c.h$b();
            let e = 0;
            if (d == null) {
                d = this.c.h$f();
            }
            else {
                e = d.j;
            }
            let f = a.an(d, e);
            if (f != null) {
                a.ah = f.a;
                return f;
            }
            let g = this.c.h$ae(a.al, b, c);
            a.am(d, e, g);
            a.ah = g.a;
            return g;
        }
        f(a) {
            if (this.c == null) {
                return NaN;
            }
            let b = this.c.h$b();
            let c = 0;
            if (b == null) {
                b = this.c.h$f();
            }
            else {
                c = b.j;
            }
            let d = a.an(b, c);
            if (d != null) {
                return d.c;
            }
            let e = this.c.h$ae(a.al, NaN, true);
            a.am(b, c, e);
            return e.c;
        }
        ae(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$ab(a);
        }
        j(a, b) {
            if (this.c == null || b == null) {
                return;
            }
            this.c.h$g(a, b);
        }
        p(a, b, c, d) {
            if (this.c == null) {
                return;
            }
            this.c.h$m(a, b, c, d);
        }
        m() {
            if (this.c == null) {
                return;
            }
            this.c.h$j();
        }
    }
    RenderingContext.$t = /*@__PURE__*/ markType(RenderingContext, 'RenderingContext');
    return RenderingContext;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MathUtil = /*@__PURE__*/ (() => {
    class MathUtil extends Base {
        static b(a) {
            return Math.log(a + Math.sqrt(a * a + 1));
        }
        static s(number_) {
            return number_.toString();
        }
        static g(a, b) {
            return Math.sqrt(a * a + b * b);
        }
        static p(a) {
            return a * a;
        }
        static a(a) {
            return !isNaN_(a) && !isInfinity(a);
        }
        static d(a, b, c) {
            return Math.min(c, Math.max(b, a));
        }
        static o(a) {
            return Math.PI * a / 180;
        }
        static f(a) {
            return 180 * a / Math.PI;
        }
        static l(a, b, c) {
            return Math.min(a, Math.min(b, c));
        }
        static i(a, b, c) {
            return Math.max(a, Math.max(b, c));
        }
        static k(...a) {
            let b = a[0];
            for (let c = 1; c < a.length; ++c) {
                b = Math.min(b, a[c]);
            }
            return b;
        }
        static m(a) {
            let b = a[0];
            for (let c = 1; c < a.length; ++c) {
                b = Math.min(b, a[c]);
            }
            return b;
        }
        static h(...a) {
            let b = a[0];
            for (let c = 1; c < a.length; ++c) {
                b = Math.max(b, a[c]);
            }
            return b;
        }
        static j(a) {
            let b = a[0];
            for (let c = 1; c < a.length; ++c) {
                b = Math.max(b, a[c]);
            }
            return b;
        }
        static r(a) {
            if (a.length == 0) {
                return 0;
            }
            let b = 0;
            for (let d = 0; d < a.length; d++) {
                let c = a[d];
                if (isNaN_(c)) {
                    continue;
                }
                if (isInfinity(c)) {
                    continue;
                }
                b += c;
            }
            return b;
        }
        static c(a) {
            if (a.length == 0) {
                return 0;
            }
            let b = 0;
            let c = 0;
            for (let e = 0; e < a.length; e++) {
                let d = a[e];
                if (isNaN_(d)) {
                    continue;
                }
                if (isInfinity(d)) {
                    continue;
                }
                b += d;
                c++;
            }
            return b / c;
        }
    }
    MathUtil.$t = /*@__PURE__*/ markType(MathUtil, 'MathUtil');
    MathUtil.n = (1 + /*@__PURE__*/ Math.sqrt(5)) / 2;
    MathUtil.q = /*@__PURE__*/ Math.sqrt(2);
    return MathUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColorUtil = /*@__PURE__*/ (() => {
    class ColorUtil extends Base {
        static z(a) {
            return Color.u(a, ColorUtil.j.next2(0, 255), ColorUtil.j.next2(0, 255), ColorUtil.j.next2(0, 255));
        }
        static aa(a) {
            let b = ColorUtil.b(a);
            return ColorUtil.r(b[0], ColorUtil.j.next2(0, 359), b[2], b[3]);
        }
        static ac(a) {
            let b = 0.299 * a.o + 0.587 * a.n + 0.114 * a.m;
            let c = Color.u(a.l, truncate(b), truncate(b), truncate(b));
            return c;
        }
        static w(a, interpolation_, maximum_, b) {
            let min_ = a;
            switch (b) {
                case 1:
                    {
                        let c = ColorUtil.b(a);
                        let d = ColorUtil.b(maximum_);
                        let e = c[1] >= 0 ? c[1] : d[1];
                        let f = d[1] >= 0 ? d[1] : c[1];
                        if (e >= 0 && f >= 0 && Math.abs(f - e) > 180) {
                            if (f > e) {
                                e += 360;
                            }
                            else {
                                f += 360;
                            }
                        }
                        interpolation_ = Math.max(0, Math.min(1, interpolation_));
                        return ColorUtil.r(c[0] + interpolation_ * (d[0] - c[0]), e + interpolation_ * (f - e), c[2] + interpolation_ * (d[2] - c[2]), c[3] + interpolation_ * (d[3] - c[3]));
                    }
                case 0: return Color.u((min_._a + interpolation_ * (maximum_._a - min_._a)), (min_._r + interpolation_ * (maximum_._r - min_._r)), (min_._g + interpolation_ * (maximum_._g - min_._g)), (min_._b + interpolation_ * (maximum_._b - min_._b)));
            }
            return a;
        }
        static u(a, b, c) {
            let d = a[1] >= 0 ? a[1] : c[1];
            let e = c[1] >= 0 ? c[1] : a[1];
            if (d >= 0 && e >= 0 && Math.abs(e - d) > 180) {
                if (e > d) {
                    d += 360;
                }
                else {
                    e += 360;
                }
            }
            b = Math.max(0, Math.min(1, b));
            return ColorUtil.r(a[0] + b * (c[0] - a[0]), d + b * (e - d), a[2] + b * (c[2] - a[2]), a[3] + b * (c[3] - a[3]));
        }
        static x(a, b) {
            let c = ColorUtil.a(a);
            if (b < 0) {
                return ColorUtil.q(c[0], c[1], c[2], c[3] * (1 - MathUtil.d(-b, 0, 1)));
            }
            else {
                return ColorUtil.q(c[0], c[1], c[2], c[3] + MathUtil.d(b, 0, 1) * (1 - c[3]));
            }
        }
        static y(a, b) {
            let c = ColorUtil.a(a);
            if (b < 0) {
                return ColorUtil.q(c[0], c[1], c[2] * (1 - MathUtil.d(-b, 0, 1)), c[3]);
            }
            else {
                return ColorUtil.q(c[0], c[1], MathUtil.d(c[2] + MathUtil.d(b, 0, 1) * (1 - c[2]), 0, 1), c[3]);
            }
        }
        static c(a) {
            let b = a.o / 255;
            let c = a.n / 255;
            let d = a.m / 255;
            let e = b < 0.03928 ? b / 12.92 : Math.pow(((b + 0.055) / 1.055), 2.4);
            let f = c < 0.03928 ? c / 12.92 : Math.pow(((c + 0.055) / 1.055), 2.4);
            let g = d < 0.03928 ? d / 12.92 : Math.pow(((d + 0.055) / 1.055), 2.4);
            return [e, f, g];
        }
        static g(a) {
            let b = ColorUtil.c(a);
            let c = b[0];
            let d = b[1];
            let e = b[2];
            return 0.2126 * c + 0.7152 * d + 0.0722 * e;
        }
        static ab(a, b) {
            let c = a.l / 255;
            let d = (1 - c) * b.o + c * a.o;
            let e = (1 - c) * b.n + c * a.n;
            let f = (1 - c) * b.m + c * a.m;
            return Color.u(255, truncate(Math.round(d)), truncate(Math.round(e)), truncate(Math.round(f)));
        }
        static a(a) {
            let b = new Array(4);
            let c = a.o / 255;
            let d = a.n / 255;
            let e = a.m / 255;
            let f = Math.min(Math.min(c, d), e);
            let g = Math.max(Math.max(c, d), e);
            let h = g - f;
            b[0] = a.l / 255;
            b[3] = (g + f) / 2;
            if (h == 0) {
                b[1] = -1;
                b[2] = 0;
            }
            else {
                b[1] = ColorUtil.h(g, h, c, d, e);
                b[2] = b[3] < 0.5 ? h / (g + f) : h / (2 - g - f);
            }
            return b;
        }
        static b(a) {
            let b = a.l / 255;
            let c = a.o / 255;
            let d = a.n / 255;
            let e = a.m / 255;
            let f = Math.min(c, Math.min(d, e));
            let g = Math.max(c, Math.max(d, e));
            let h = g - f;
            let i = new Array(4);
            i[0] = b;
            i[3] = g;
            if (h == 0) {
                i[1] = -1;
                i[2] = 0;
            }
            else {
                i[1] = ColorUtil.h(g, h, c, d, e);
                i[2] = h / g;
            }
            return i;
        }
        static q(a, b, c, d) {
            let e;
            let f;
            let g;
            if (c == 0) {
                e = d;
                f = d;
                g = d;
            }
            else {
                let h = d < 0.5 ? d * (1 + c) : d + c - (d * c);
                let i = 2 * d - h;
                let j = b / 360;
                e = ColorUtil.f(i, h, j + 1 / 3);
                f = ColorUtil.f(i, h, j);
                g = ColorUtil.f(i, h, j - 1 / 3);
            }
            return Color.u(truncate((a * 255)), truncate((e * 255)), truncate((f * 255)), truncate((g * 255)));
        }
        static r(a, b, c, d) {
            let e;
            let f;
            let g;
            while (b >= 360) {
                b -= 360;
            }
            if (c == 0) {
                e = d;
                f = d;
                g = d;
            }
            else {
                b /= 60;
                let h = Math.floor(b);
                let i = b - h;
                let j = d * (1 - c);
                let k = d * (1 - c * i);
                let l = d * (1 - c * (1 - i));
                switch (truncate(h)) {
                    case 0:
                        e = d;
                        f = l;
                        g = j;
                        break;
                    case 1:
                        e = k;
                        f = d;
                        g = j;
                        break;
                    case 2:
                        e = j;
                        f = d;
                        g = l;
                        break;
                    case 3:
                        e = j;
                        f = k;
                        g = d;
                        break;
                    case 4:
                        e = l;
                        f = j;
                        g = d;
                        break;
                    default:
                        e = d;
                        f = j;
                        g = k;
                        break;
                }
            }
            return Color.u(truncate((a * 255)), truncate((e * 255)), truncate((f * 255)), truncate((g * 255)));
        }
        static h(a, b, c, d, e) {
            let f = c == a ? (d - e) / b : d == a ? 2 + (e - c) / b : 4 + (c - d) / b;
            f *= 60;
            if (f < 0) {
                f += 360;
            }
            return f;
        }
        static f(a, b, c) {
            c = c < 0 ? c + 1 : c > 1 ? c - 1 : c;
            if (c < 1 / 6) {
                return a + ((b - a) * 6 * c);
            }
            if (c < 1 / 2) {
                return b;
            }
            if (c < 2 / 3) {
                return a + ((b - a) * 6 * (2 / 3 - c));
            }
            return a;
        }
        static i(a) {
            let b = a.l / 255;
            let c = truncate((a.o * b));
            let d = truncate((a.n * b));
            let e = truncate((a.m * b));
            return a.l << 24 | c << 16 | d << 8 | e;
        }
        static v(a) {
            return a.color;
        }
        static k(a, b) {
            if (ColorUtil.e == null) {
                ColorUtil.e = new Dictionary$2(String_$type, String_$type, 0);
                for (let c of fromEnum(ColorUtil.d.keys)) {
                    let d = ColorUtil.d.item(c);
                    ColorUtil.e.item(d, c);
                }
            }
            let e = ColorUtil.m(a);
            if (ColorUtil.e.containsKey(e.toLowerCase())) {
                return ColorUtil.e.item(e.toLowerCase());
            }
            if (b) {
                e = ColorUtil.o(a);
            }
            return e;
        }
        static o(a) {
            return "rgba(" + a.o + ", " + a.n + ", " + a.m + ", " + (a.l / 255) + ")";
        }
        static m(a) {
            if (a.l == 255) {
                return "#" + ColorUtil.l(a.o) + ColorUtil.l(a.n) + ColorUtil.l(a.m);
            }
            else {
                return "#" + ColorUtil.l(a.l) + ColorUtil.l(a.o) + ColorUtil.l(a.n) + ColorUtil.l(a.m);
            }
        }
        static l(a) {
            let b = intDivide(a, 16);
            let c = a % 16;
            return ColorUtil.n(b) + ColorUtil.n(c);
        }
        static n(a) {
            switch (a) {
                case 0: return "0";
                case 1: return "1";
                case 2: return "2";
                case 3: return "3";
                case 4: return "4";
                case 5: return "5";
                case 6: return "6";
                case 7: return "7";
                case 8: return "8";
                case 9: return "9";
                case 10: return "a";
                case 11: return "b";
                case 12: return "c";
                case 13: return "d";
                case 14: return "e";
                case 15: return "f";
            }
            return "0";
        }
        static t(a) {
            let b = new Color();
            b.colorString = a;
            return b;
        }
        static s(a) {
            let b = ((() => {
                let $ret = new Color();
                $ret.l = 255;
                return $ret;
            })());
            b = ColorUtil.t(a._fill);
            return b;
        }
        static p(a) {
            let b = null;
            let c = a.colorString;
            b = ((() => {
                let $ret = new Brush();
                $ret.fill = c;
                return $ret;
            })());
            return b;
        }
    }
    ColorUtil.$t = /*@__PURE__*/ markType(ColorUtil, 'ColorUtil');
    ColorUtil.j = /*@__PURE__*/ new Random(0);
    ColorUtil.e = null;
    ColorUtil.d = /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(String_$type, String_$type, 0);
        $ret.addItem("transparent", "#000000");
        $ret.addItem("aliceblue", "#f0f8ff");
        $ret.addItem("antiquewhite", "#faebd7");
        $ret.addItem("aqua", "#00ffff");
        $ret.addItem("aquamarine", "#7fffd4");
        $ret.addItem("azure", "#f0ffff");
        $ret.addItem("beige", "#f5f5dc");
        $ret.addItem("bisque", "#ffe4c4");
        $ret.addItem("black", "#000000");
        $ret.addItem("blanchedalmond", "#ffebcd");
        $ret.addItem("blue", "#0000ff");
        $ret.addItem("blueviolet", "#8a2be2");
        $ret.addItem("brown", "#a52a2a");
        $ret.addItem("burlywood", "#deb887");
        $ret.addItem("cadetblue", "#5f9ea0");
        $ret.addItem("chartreuse", "#7fff00");
        $ret.addItem("chocolate", "#d2691e");
        $ret.addItem("coral", "#ff7f50");
        $ret.addItem("cornflowerblue", "#6495ed");
        $ret.addItem("cornsilk", "#fff8dc");
        $ret.addItem("crimson", "#dc143c");
        $ret.addItem("cyan", "#00ffff");
        $ret.addItem("darkblue", "#00008b");
        $ret.addItem("darkcyan", "#008b8b");
        $ret.addItem("darkgoldenrod", "#b8860b");
        $ret.addItem("darkgray", "#a9a9a9");
        $ret.addItem("darkgreen", "#006400");
        $ret.addItem("darkkhaki", "#bdb76b");
        $ret.addItem("darkmagenta", "#8b008b");
        $ret.addItem("darkolivegreen", "#556b2f");
        $ret.addItem("darkorange", "#ff8c00");
        $ret.addItem("darkorchid", "#9932cc");
        $ret.addItem("darkred", "#8b0000");
        $ret.addItem("darksalmon", "#e9967a");
        $ret.addItem("darkseagreen", "#8fbc8f");
        $ret.addItem("darkslateblue", "#483d8b");
        $ret.addItem("darkslategray", "#2f4f4f");
        $ret.addItem("darkturquoise", "#00ced1");
        $ret.addItem("darkviolet", "#9400d3");
        $ret.addItem("deeppink", "#ff1493");
        $ret.addItem("deepskyblue", "#00bfff");
        $ret.addItem("dimgray", "#696969");
        $ret.addItem("dodgerblue", "#1e90ff");
        $ret.addItem("feldspar", "#d19275");
        $ret.addItem("firebrick", "#b22222");
        $ret.addItem("floralwhite", "#fffaf0");
        $ret.addItem("forestgreen", "#228b22");
        $ret.addItem("fuchsia", "#ff00ff");
        $ret.addItem("gainsboro", "#dcdcdc");
        $ret.addItem("ghostwhite", "#f8f8ff");
        $ret.addItem("gold", "#ffd700");
        $ret.addItem("goldenrod", "#daa520");
        $ret.addItem("gray", "#808080");
        $ret.addItem("green", "#008000");
        $ret.addItem("greenyellow", "#adff2f");
        $ret.addItem("honeydew", "#f0fff0");
        $ret.addItem("hotpink", "#ff69b4");
        $ret.addItem("indianred", "#cd5c5c");
        $ret.addItem("indigo", "#4b0082");
        $ret.addItem("ivory", "#fffff0");
        $ret.addItem("khaki", "#f0e68c");
        $ret.addItem("lavender", "#e6e6fa");
        $ret.addItem("lavenderblush", "#fff0f5");
        $ret.addItem("lawngreen", "#7cfc00");
        $ret.addItem("lemonchiffon", "#fffacd");
        $ret.addItem("lightblue", "#add8e6");
        $ret.addItem("lightcoral", "#f08080");
        $ret.addItem("lightcyan", "#e0ffff");
        $ret.addItem("lightgoldenrodyellow", "#fafad2");
        $ret.addItem("lightgray", "#d3d3d3");
        $ret.addItem("lightgreen", "#90ee90");
        $ret.addItem("lightpink", "#ffb6c1");
        $ret.addItem("lightsalmon", "#ffa07a");
        $ret.addItem("lightseagreen", "#20b2aa");
        $ret.addItem("lightskyblue", "#87cefa");
        $ret.addItem("lightslateblue", "#8470ff");
        $ret.addItem("lightslategray", "#778899");
        $ret.addItem("lightsteelblue", "#b0c4de");
        $ret.addItem("lightyellow", "#ffffe0");
        $ret.addItem("lime", "#00ff00");
        $ret.addItem("limegreen", "#32cd32");
        $ret.addItem("linen", "#faf0e6");
        $ret.addItem("magenta", "#ff00ff");
        $ret.addItem("maroon", "#800000");
        $ret.addItem("mediumaquamarine", "#66cdaa");
        $ret.addItem("mediumblue", "#0000cd");
        $ret.addItem("mediumorchid", "#ba55d3");
        $ret.addItem("mediumpurple", "#9370d8");
        $ret.addItem("mediumseagreen", "#3cb371");
        $ret.addItem("mediumslateblue", "#7b68ee");
        $ret.addItem("mediumspringgreen", "#00fa9a");
        $ret.addItem("mediumturquoise", "#48d1cc");
        $ret.addItem("mediumvioletred", "#c71585");
        $ret.addItem("midnightblue", "#191970");
        $ret.addItem("mintcream", "#f5fffa");
        $ret.addItem("mistyrose", "#ffe4e1");
        $ret.addItem("moccasin", "#ffe4b5");
        $ret.addItem("navajowhite", "#ffdead");
        $ret.addItem("navy", "#000080");
        $ret.addItem("oldlace", "#fdf5e6");
        $ret.addItem("olive", "#808000");
        $ret.addItem("olivedrab", "#6b8e23");
        $ret.addItem("orange", "#ffa500");
        $ret.addItem("orangered", "#ff4500");
        $ret.addItem("orchid", "#da70d6");
        $ret.addItem("palegoldenrod", "#eee8aa");
        $ret.addItem("palegreen", "#98fb98");
        $ret.addItem("paleturquoise", "#afeeee");
        $ret.addItem("palevioletred", "#d87093");
        $ret.addItem("papayawhip", "#ffefd5");
        $ret.addItem("peachpuff", "#ffdab9");
        $ret.addItem("peru", "#cd853f");
        $ret.addItem("pink", "#ffc0cb");
        $ret.addItem("plum", "#dda0dd");
        $ret.addItem("powderblue", "#b0e0e6");
        $ret.addItem("purple", "#800080");
        $ret.addItem("red", "#ff0000");
        $ret.addItem("rosybrown", "#bc8f8f");
        $ret.addItem("royalblue", "#4169e1");
        $ret.addItem("saddlebrown", "#8b4513");
        $ret.addItem("salmon", "#fa8072");
        $ret.addItem("sandybrown", "#f4a460");
        $ret.addItem("seagreen", "#2e8b57");
        $ret.addItem("seashell", "#fff5ee");
        $ret.addItem("sienna", "#a0522d");
        $ret.addItem("silver", "#c0c0c0");
        $ret.addItem("skyblue", "#87ceeb");
        $ret.addItem("slateblue", "#6a5acd");
        $ret.addItem("slategray", "#708090");
        $ret.addItem("snow", "#fffafa");
        $ret.addItem("springgreen", "#00ff7f");
        $ret.addItem("steelblue", "#4682b4");
        $ret.addItem("tan", "#d2b48c");
        $ret.addItem("teal", "#008080");
        $ret.addItem("thistle", "#d8bfd8");
        $ret.addItem("tomato", "#ff6347");
        $ret.addItem("turquoise", "#40e0d0");
        $ret.addItem("violet", "#ee82ee");
        $ret.addItem("violetred", "#d02090");
        $ret.addItem("wheat", "#f5deb3");
        $ret.addItem("white", "#ffffff");
        $ret.addItem("whitesmoke", "#f5f5f5");
        $ret.addItem("yellow", "#ffff00");
        $ret.addItem("yellowgreen", "#9acd32");
        return $ret;
    })());
    return ColorUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColorCollectionUtil = /*@__PURE__*/ (() => {
    class ColorCollectionUtil extends Base {
        static b(a, b) {
            b = MathUtil.d(b, 0, a.count - 1);
            let c = truncate(Math.floor(b));
            if (c == b) {
                return a._inner[c];
            }
            return ColorCollectionUtil.c(b - c, a._inner[c], a._inner[c + 1], a.af);
        }
        static c(a, b, c, d) {
            return ColorUtil.w(b, a, c, d);
        }
        static a(a) {
            let b = new ObservableColorCollection();
            b.o(a);
            return b;
        }
    }
    ColorCollectionUtil.$t = /*@__PURE__*/ markType(ColorCollectionUtil, 'ColorCollectionUtil');
    return ColorCollectionUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DVSR = /*@__PURE__*/ (() => {
    class DVSR extends Base {
        get container() {
            return this.a;
        }
        set container(a) {
            this.a = a;
        }
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
            this.setBundleId("DataVisualization");
        }
        getString(resourceName_) {
            let a = stringEmpty();
            resourceName_ = resourceName_.charAt(0).toUpperCase() + resourceName_.substr(1);
            a = this.a.getResourceString(resourceName_);
            return a;
        }
        setBundleId(a) {
            if (this.a != null) {
                this.a.setResourceBundleId(a);
                this.a.setCultureId(Localization.d(a));
            }
        }
    }
    DVSR.$t = /*@__PURE__*/ markType(DVSR, 'DVSR');
    return DVSR;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UnsetValue = /*@__PURE__*/ (() => {
    class UnsetValue extends Base {
    }
    UnsetValue.$t = /*@__PURE__*/ markType(UnsetValue, 'UnsetValue');
    return UnsetValue;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DependencyObject = /*@__PURE__*/ (() => {
    class DependencyObject extends Base {
        constructor() {
            super();
            this.localValues = null;
            this.a = null;
            this.localValues = DictionaryUtil.dictionaryCreate();
            this.a = DictionaryUtil.dictionaryCreate();
        }
        c(a) {
            if (this.localValues.has(a.name)) {
                return this.localValues.get(a.name);
            }
            return a.l.b;
        }
        h(dp_, a) {
            if (dp_.b) {
                let oldValue_ = null;
                if (this.localValues.has(dp_._name)) {
                    oldValue_ = this.localValues.get(dp_._name);
                }
                ;
                this.localValues.set(dp_._name, a);
                dp_.l.d(this, new DependencyPropertyChangedEventArgs(dp_, a, oldValue_));
            }
            else {
                this.localValues.set(dp_._name, a);
            }
        }
        f(a) {
            this.localValues.delete(a._name);
        }
        e(a) {
            if (this.localValues.has(a._name)) {
                return this.localValues.get(a.name);
            }
            return DependencyProperty.c;
        }
        g(a, b) {
            if (a == null) {
                return;
            }
            this.a.set(a.name, b);
        }
        getValueAlt(a) {
            return this.c(a);
        }
        setValueAlt(dp_, a) {
            this.h(dp_, a);
        }
    }
    DependencyObject.$t = /*@__PURE__*/ markType(DependencyObject, 'DependencyObject');
    return DependencyObject;
})();
/**
 * @hidden
 */
let DependencyProperty = /*@__PURE__*/ (() => {
    class DependencyProperty extends Base {
        get b() {
            return this.a;
        }
        constructor(a, b, c) {
            super();
            this._name = null;
            this.f = null;
            this.k = null;
            this.a = false;
            this._name = a;
            this.f = b;
            this.k = c;
            if (this.k != null && this.k.d != null) {
                this.a = true;
            }
            else {
                this.a = false;
            }
        }
        get l() {
            return this.k;
        }
        get propertyType() {
            return this.f;
        }
        get name() {
            return this._name;
        }
        static i(a, b, c, d) {
            return DependencyPropertiesCollection.c.e(a, b, c, d);
        }
        static h(a, b) {
            if (b == null) {
                return null;
            }
            let c = DependencyPropertiesCollection.c.d(b.typeName + a);
            if (c != null) {
                return c;
            }
            return DependencyProperty.h(a, b.baseType);
        }
        static registerAlt(a, b, c, d) {
            return DependencyProperty.i(a, b, c, d);
        }
    }
    DependencyProperty.$t = /*@__PURE__*/ markType(DependencyProperty, 'DependencyProperty');
    DependencyProperty.c = /*@__PURE__*/ new UnsetValue();
    return DependencyProperty;
})();
/**
 * @hidden
 */
let DependencyPropertiesCollection = /*@__PURE__*/ (() => {
    class DependencyPropertiesCollection extends Base {
        static get c() {
            if (DependencyPropertiesCollection.b == null) {
                DependencyPropertiesCollection.b = new DependencyPropertiesCollection();
            }
            return DependencyPropertiesCollection.b;
        }
        constructor() {
            super();
            this.a = null;
            if (this.a == null) {
                this.a = DictionaryUtil.dictionaryCreate();
            }
        }
        d(a) {
            if (this.a.has(a)) {
                return this.a.get(a);
            }
            return null;
        }
        e(a, b, c, d) {
            let e = new DependencyProperty(a, b, d);
            this.a.set(c.typeName + a, e);
            return e;
        }
    }
    DependencyPropertiesCollection.$t = /*@__PURE__*/ markType(DependencyPropertiesCollection, 'DependencyPropertiesCollection');
    DependencyPropertiesCollection.b = null;
    return DependencyPropertiesCollection;
})();
/**
 * @hidden
 */
let DependencyPropertyChangedEventArgs = /*@__PURE__*/ (() => {
    class DependencyPropertyChangedEventArgs extends Base {
        constructor(a, b, c) {
            super();
            this.a = null;
            this.b = null;
            this.e = null;
            this.a = b;
            this.b = c;
            this.e = a;
        }
        get f() {
            return this.e;
        }
        set f(a) {
            this.e = a;
        }
        get newValue() {
            return this.a;
        }
        get oldValue() {
            return this.b;
        }
    }
    DependencyPropertyChangedEventArgs.$t = /*@__PURE__*/ markType(DependencyPropertyChangedEventArgs, 'DependencyPropertyChangedEventArgs');
    return DependencyPropertyChangedEventArgs;
})();
/**
 * @hidden
 */
let PropertyMetadata = /*@__PURE__*/ (() => {
    class PropertyMetadata extends Base {
        get b() {
            return this.a;
        }
        set b(a) {
            this.a = a;
        }
        get d() {
            return this.c;
        }
        set d(a) {
            this.c = a;
        }
        constructor(a, ..._rest) {
            super();
            this.a = null;
            this.c = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        this.b = c;
                        this.d = null;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.b = null;
                        this.d = c;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.b = c;
                        this.d = d;
                    }
                    break;
            }
        }
        static createWithCallback(a) {
            return new PropertyMetadata(1, a);
        }
        static createWithDefaultAndCallback(a, b) {
            return new PropertyMetadata(2, a, b);
        }
    }
    PropertyMetadata.$t = /*@__PURE__*/ markType(PropertyMetadata, 'PropertyMetadata');
    return PropertyMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SRProvider = /*@__PURE__*/ (() => {
    class SRProvider extends DependencyObject {
        get l() {
            return this.k;
        }
        set l(a) {
            this.k = a;
            this.j.container = this.k;
        }
        constructor(a) {
            super();
            this.j = null;
            this.k = null;
            super.toString();
            this.k = a;
            this.j = new DVSR(a);
        }
        cb(a) {
            this.j.setBundleId(a);
        }
        get b3() {
            return this.j.getString("OPD_DefaultInteraction");
        }
        get b4() {
            return this.j.getString("OPD_ScaleToFit");
        }
        get b6() {
            return this.j.getString("OPD_ZoomTo100");
        }
        get b5() {
            return this.j.getString("OPD_ScaleToFit_SeriesViewer");
        }
        get b7() {
            return this.j.getString("PieChart_Others");
        }
        get bz() {
            return this.j.getString("FinancialSeries_Open");
        }
        get bw() {
            return this.j.getString("FinancialSeries_Close");
        }
        get by() {
            return this.j.getString("FinancialSeries_Low");
        }
        get bx() {
            return this.j.getString("FinancialSeries_High");
        }
        get b0() {
            return this.j.getString("FinancialSeries_Volume");
        }
        get m() {
            return this.j.getString("BubbleSeries_Radius");
        }
        get r() {
            return this.j.getString("DataProviderNotInitialized");
        }
        get b2() {
            return this.j.getString("Object_Sealed");
        }
        get b8() {
            return this.j.getString("RangeModificationsNotSupported");
        }
        get s() {
            return this.j.getString("Default_Series_Title");
        }
        get n() {
            return this.j.getString("DataChart_InteractivityNotLoaded");
        }
        get p() {
            return this.j.getString("DataChart_TrendLinesNotLoaded");
        }
        get o() {
            return this.j.getString("DataChart_NumberAbbreviatorNotLoaded");
        }
        get q() {
            return this.j.getString("DataChart_VisualDataNotLoaded");
        }
        get ca() {
            return this.j.getString("TRIAL_VERSION");
        }
        get b9() {
            return this.j.getString("ScatterSeries_Value");
        }
        b1(a) {
            return this.j.getString(a);
        }
        get bq() {
            return this.j.getString("FinancialChart_RangeSelector_OneMonth");
        }
        get bt() {
            return this.j.getString("FinancialChart_RangeSelector_ThreeMonths");
        }
        get bs() {
            return this.j.getString("FinancialChart_RangeSelector_SixMonths");
        }
        get bv() {
            return this.j.getString("FinancialChart_RangeSelector_YearToDate");
        }
        get br() {
            return this.j.getString("FinancialChart_RangeSelector_OneYear");
        }
        get bo() {
            return this.j.getString("FinancialChart_RangeSelector_All");
        }
        get bp() {
            return this.j.getString("FinancialChart_RangeSelector_From");
        }
        get bu() {
            return this.j.getString("FinancialChart_RangeSelector_To");
        }
        get t() {
            return this.j.getString("FinancialChart_IndicatorMenu_Header");
        }
        get v() {
            return this.j.getString("FinancialChart_IndicatorMenu_OverlaysCategoryHeader");
        }
        get w() {
            return this.j.getString("FinancialChart_IndicatorMenu_TrendlinesCategoryHeader");
        }
        get x() {
            return this.j.getString("FinancialChart_IndicatorMenu_VolumeCategoryHeader");
        }
        get u() {
            return this.j.getString("FinancialChart_IndicatorMenu_IndicatorsCategoryHeader");
        }
        get a6() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Overlay_BollingerBands");
        }
        get a7() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Overlay_PriceChannel");
        }
        get y() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator");
        }
        get z() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution");
        }
        get aa() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex");
        }
        get ab() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange");
        }
        get ac() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth");
        }
        get ad() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator");
        }
        get ae() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility");
        }
        get af() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex");
        }
        get ag() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator");
        }
        get ah() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement");
        }
        get ai() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator");
        }
        get aj() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_ForceIndex");
        }
        get ak() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator");
        }
        get al() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex");
        }
        get am() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_MassIndex");
        }
        get an() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_MedianPrice");
        }
        get ao() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex");
        }
        get ap() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence");
        }
        get aq() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex");
        }
        get ar() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume");
        }
        get as() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator");
        }
        get at() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator");
        }
        get au() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex");
        }
        get av() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend");
        }
        get aw() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum");
        }
        get ax() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex");
        }
        get ay() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator");
        }
        get az() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_StandardDeviation");
        }
        get a0() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_StochRSI");
        }
        get a1() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_TRIX");
        }
        get a2() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_TypicalPrice");
        }
        get a3() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator");
        }
        get a4() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_WeightedClose");
        }
        get a5() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR");
        }
        get a8() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_CubicFit");
        }
        get a9() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage");
        }
        get ba() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage");
        }
        get bb() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit");
        }
        get bc() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_LinearFit");
        }
        get bd() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit");
        }
        get be() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage");
        }
        get bf() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit");
        }
        get bg() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit");
        }
        get bh() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_QuarticFit");
        }
        get bi() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_QuinticFit");
        }
        get bj() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage");
        }
        get bk() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage");
        }
        get bl() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Volume_Area");
        }
        get bm() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Volume_Column");
        }
        get bn() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Volume_Line");
        }
    }
    SRProvider.$t = /*@__PURE__*/ markType(SRProvider, 'SRProvider', DependencyObject.$);
    return SRProvider;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushUtil = /*@__PURE__*/ (() => {
    class BrushUtil extends Base {
        static d(a, b) {
            if (a == null && b == null) {
                return true;
            }
            else if ((a != null && b == null) || (a == null && b != null)) {
                return false;
            }
            if ((a._fill == null && b._fill != null) || (a._fill != null && b._fill == null)) {
                return false;
            }
            else if (a._fill == null && b._fill == null) {
                return a.color.equals(b.color) && a.isGradient == b.isGradient && a.isImageFill == b.isImageFill && a.isRadialGradient == b.isRadialGradient;
            }
            else {
                return Base.equalsStatic(a, b);
            }
        }
        static m(a, b) {
            if (a == null) {
                return a;
            }
            if (a.isGradient) {
                let c = a.clone();
                for (let d = 0; d < c.gradientStops.length; d++) {
                    let e = c.gradientStops[d];
                    e.color = ColorUtil.x(e.color, b);
                }
                return c;
            }
            else {
                let f = ColorUtil.x(a.color, b);
                return ((() => {
                    let $ret = new Brush();
                    $ret.color = f;
                    return $ret;
                })());
            }
        }
        static o(a, b) {
            if (a == null) {
                return a;
            }
            if (a.isGradient) {
                let c = a.clone();
                for (let d = 0; d < c.gradientStops.length; d++) {
                    let e = c.gradientStops[d];
                    e.color = ColorUtil.y(e.color, b);
                }
                return c;
            }
            else {
                let f = ColorUtil.y(a.color, b);
                return ((() => {
                    let $ret = new Brush();
                    $ret.color = f;
                    return $ret;
                })());
            }
        }
        static n(a, b) {
            if (a == null) {
                return a;
            }
            if (a.isGradient) {
                let c = a.clone();
                for (let d = 0; d < c.gradientStops.length; d++) {
                    let e = c.gradientStops[d];
                    e.color = BrushUtil.u(e.color, b);
                }
                return c;
            }
            else {
                let f = BrushUtil.u(a.color, b);
                return ((() => {
                    let $ret = new Brush();
                    $ret.color = f;
                    return $ret;
                })());
            }
        }
        static u(a, b) {
            return Color.u(truncate(Math.round(255 * b)), a.o, a.n, a.m);
        }
        static e(a) {
            let b = Color.u(0, 0, 0, 0);
            if (a == null) {
                return new Tuple$2(Boolean_$type, Color.$, true, b);
            }
            if (typeCast(LinearGradientBrush.$, a) !== null) {
                if (a.gradientStops == null || a.gradientStops.length < 1) {
                    return new Tuple$2(Boolean_$type, Color.$, false, b);
                }
                b = a.gradientStops[0].color;
            }
            else {
                b = a.color;
            }
            return new Tuple$2(Boolean_$type, Color.$, true, b);
        }
        static t(a) {
            if (a == null) {
                return a;
            }
            if (typeCast(LinearGradientBrush.$, a) !== null) {
                let b = a.clone();
                for (let c = 0; c < b.gradientStops.length; c++) {
                    let d = b.gradientStops[c];
                    d.color = ColorUtil.ac(d.color);
                }
                return b;
            }
            else {
                let e = ((() => {
                    let $ret = new Brush();
                    $ret.color = a.color;
                    return $ret;
                })());
                e.color = ColorUtil.ac(e.color);
                return e;
            }
        }
        static j(a, b, c) {
            let d = BrushUtil.e(a);
            let e = new Color();
            if (!d.c) {
                return b;
            }
            else {
                e = d.d;
            }
            let f = new Color();
            let g = new Color();
            let h = BrushUtil.e(b);
            if (!h.c) {
                return b;
            }
            g = h.d;
            let i = BrushUtil.e(c);
            if (!i.c) {
                return b;
            }
            f = i.d;
            let j = ColorUtil.ab(e, f);
            let k = ColorUtil.g(j);
            let l = ColorUtil.g(f);
            let m = (Math.max(k, l) + 0.05) / (Math.min(k, l) + 0.05);
            j = ColorUtil.ab(e, g);
            k = ColorUtil.g(j);
            l = ColorUtil.g(g);
            let n = (Math.max(k, l) + 0.05) / (Math.min(k, l) + 0.05);
            if (n > m) {
                return b;
            }
            return c;
        }
        static i(a, b, c) {
            let d = new Color();
            if (typeCast(LinearGradientBrush.$, a) !== null) {
                if (a.gradientStops == null || a.gradientStops.length < 1) {
                    let e = new Brush();
                    e.color = b;
                    return e;
                }
                d = a.gradientStops[0].color;
            }
            else {
                d = a.color;
            }
            let f = ColorUtil.ab(d, c);
            let g = ColorUtil.g(f);
            let h = ColorUtil.g(c);
            let i = (Math.max(g, h) + 0.05) / (Math.min(g, h) + 0.05);
            f = ColorUtil.ab(d, b);
            g = ColorUtil.g(f);
            h = ColorUtil.g(b);
            let j = (Math.max(g, h) + 0.05) / (Math.min(g, h) + 0.05);
            if (j > i) {
                return ((() => {
                    let $ret = new Brush();
                    $ret.color = b;
                    return $ret;
                })());
            }
            return ((() => {
                let $ret = new Brush();
                $ret.color = c;
                return $ret;
            })());
        }
        static q(a, b) {
            if (a == null) {
                return a;
            }
            if (a.isGradient) {
                let c = a.clone();
                for (let d = 0; d < c.gradientStops.length; d++) {
                    let e = c.gradientStops[d];
                    e.color = Color.u(truncate(Math.round(e.color.l * b)), e.color.o, e.color.n, e.color.m);
                }
                return c;
            }
            else {
                let f = Color.u(truncate(Math.round(a.color.l * b)), a.color.o, a.color.n, a.color.m);
                return ((() => {
                    let $ret = new Brush();
                    $ret.color = f;
                    return $ret;
                })());
            }
        }
        static l(a, b, c, d) {
            let e = new Brush();
            if (a == null && c == null) {
                e._fill = "transparent";
                return e;
            }
            let f = null, g = null;
            let h = null, i = null;
            if (a == null) {
                let j = c.isGradient ? ((() => {
                    let $ret = new Color();
                    $ret.l = 0;
                    $ret.o = 255;
                    $ret.n = 255;
                    $ret.m = 255;
                    return $ret;
                })()) : ((() => {
                    let $ret = new Color();
                    $ret.l = 0;
                    $ret.o = c.color.o;
                    $ret.n = c.color.n;
                    $ret.m = c.color.m;
                    return $ret;
                })());
                f = ((() => {
                    let $ret = new Brush();
                    $ret.color = j;
                    return $ret;
                })());
            }
            else {
                if (a.isGradient) {
                    h = a;
                }
                else {
                    f = a;
                }
            }
            if (c == null) {
                let k = a.isGradient ? ((() => {
                    let $ret = new Color();
                    $ret.l = 0;
                    $ret.o = 255;
                    $ret.n = 255;
                    $ret.m = 255;
                    return $ret;
                })()) : ((() => {
                    let $ret = new Color();
                    $ret.l = 0;
                    $ret.o = a.color.o;
                    $ret.n = a.color.n;
                    $ret.m = a.color.m;
                    return $ret;
                })());
                g = ((() => {
                    let $ret = new Brush();
                    $ret.color = k;
                    return $ret;
                })());
            }
            else {
                if (c.isGradient) {
                    i = c;
                }
                else {
                    g = c;
                }
            }
            if (f != null && g != null) {
                return BrushUtil.s(f, b, g, d);
            }
            if (f != null && i != null) {
                return BrushUtil.r(f, b, i, d);
            }
            if (h != null && g != null) {
                return BrushUtil.r(g, 1 - b, h, d);
            }
            if (h != null && i != null) {
                return BrushUtil.p(h, b, i, d);
            }
            return e;
        }
        static h(a, b, c, d) {
            let e = new Brush();
            e.color = Color.u(a, b, c, d);
            return e;
        }
        static s(a, b, c, d) {
            let e = new Brush();
            e.color = ColorUtil.w(a.color, b, c.color, d);
            return e;
        }
        static r(a, b, c, d) {
            let e = new LinearGradientBrush();
            e.gradientStops = BrushUtil.c(a.color, b, c.gradientStops, d);
            if (c.useCustomDirection) {
                e.useCustomDirection = true;
                e.startX = c.startX;
                e.startY = c.startY;
                e.endX = c.endX;
                e.endY = c.endY;
            }
            return e;
        }
        static p(a, b, c, d) {
            let e = new LinearGradientBrush();
            e.gradientStops = BrushUtil.b(a.gradientStops, b, c.gradientStops, d);
            if (a.useCustomDirection || c.useCustomDirection) {
                e.useCustomDirection = true;
                e.startX = a.startX + b * (c.startX - a.startX);
                e.startY = a.startY + b * (c.startY - a.startY);
                e.endX = (1 - b) * a.endX + b * c.endX;
                e.endY = (1 - b) * a.endY + b * c.endY;
            }
            return e;
        }
        static c(a, b, c, d) {
            let e = new Array(c.length);
            for (let f = 0; f < c.length; ++f) {
                e[f] = ((() => {
                    let $ret = new GradientStop();
                    $ret.offset = c[f].offset;
                    $ret.color = ColorUtil.w(a, b, c[f].color, d);
                    return $ret;
                })());
            }
            return e;
        }
        static b(a, b, c, d) {
            let e = Math.min(a.length, c.length);
            let f = Math.max(a.length, c.length);
            let g = new Array(f);
            let h = 0;
            for (; h < e; ++h) {
                g[h] = ((() => {
                    let $ret = new GradientStop();
                    $ret.offset = (1 - b) * a[h].offset + b * c[h].offset;
                    $ret.color = ColorUtil.w(a[h].color, b, c[h].color, d);
                    return $ret;
                })());
            }
            for (; h < a.length; ++h) {
                g[h] = ((() => {
                    let $ret = new GradientStop();
                    $ret.offset = (1 - b) * a[h].offset + b * c[c.length - 1].offset;
                    $ret.color = ColorUtil.w(a[h].color, b, c[c.length - 1].color, d);
                    return $ret;
                })());
            }
            for (; h < c.length; ++h) {
                g[h] = ((() => {
                    let $ret = new GradientStop();
                    $ret.offset = (1 - b) * a[a.length - 1].offset + b * c[h].offset;
                    $ret.color = ColorUtil.w(a[a.length - 1].color, b, c[h].color, d);
                    return $ret;
                })());
            }
            return g;
        }
        static a(a, b) {
            let c = new Array(2);
            b.addClass(a);
            let d = new Brush();
            d._fill = b.getStyleProperty("background-color");
            let e = new Brush();
            e._fill = b.getStyleProperty("border-top-color");
            b.removeClass(a);
            c[0] = d;
            c[1] = e;
            return c;
        }
        static f(palleteName_, container_, a, b, c = null) {
            a = new BrushCollection();
            b = new BrushCollection();
            let d;
            let e = new List$1(String_$type, 0);
            e.add("background-color");
            e.add("border-top-color");
            container_.startCSSQuery();
            let f = container_.getCssDefaultValuesForClassCollection("ui-" + palleteName_ + "-palette-", e.toArray());
            let g = f.length;
            if (g == 0) {
                if (c == null) {
                    c = ["#B1BFC9", "#50a8be", "#798995", "#fc6754", "#4F606C", "#fec33c", "#374650", "#3c6399", "#162C3B", "#91af49"];
                }
                for (let h = 0; h < c.length - 1; h += 2) {
                    d = new Brush();
                    d._fill = c[h];
                    b.add(d);
                    d = new Brush();
                    d._fill = c[h + 1];
                    a.add(d);
                }
            }
            for (let i = 0; i < g; i++) {
                let j = new Brush();
                j._fill = f[i][0];
                let k = new Brush();
                k._fill = f[i][1];
                a.add(j);
                b.add(k);
            }
            container_.endCSSQuery();
            return {
                p2: a,
                p3: b
            };
        }
        static g(a, b, c, container_, d, e, f = null) {
            d = new BrushCollection();
            e = new BrushCollection();
            if (f == null) {
                f = ["#B1BFC9", "#50a8be", "#798995", "#fc6754", "#4F606C", "#fec33c", "#374650", "#3c6399", "#162C3B", "#91af49"];
            }
            container_.startCSSQuery();
            let g = new List$1(String_$type, 0);
            g.add("background-image");
            let h = container_.getCssDefaultValuesForClassCollection(a, g.toArray());
            let i = h.length;
            let j = container_.getCssDefaultValuesForClassCollection(b, g.toArray());
            let k = j.length;
            for (let l = 0; l < i; l++) {
                d.add(CssGradientUtil.brushFromGradientString(h[l][0]));
            }
            for (let m = 0; m < k; m++) {
                e.add(CssGradientUtil.brushFromGradientString(j[m][0]));
            }
            g.clear();
            let n = 0;
            let o = 0;
            let p = Math.min(i, k);
            let q = null;
            if (i == 0) {
                g.add("background-color");
            }
            if (k == 0) {
                g.add("border-top-color");
                o = i == 0 ? 1 : 0;
            }
            if (g.count > 0) {
                q = container_.getCssDefaultValuesForClassCollection(c, g.toArray());
                p = q.length;
            }
            if (i == 0) {
                if (p > 0) {
                    for (let r = 0; r < p; r++) {
                        let s = new Brush();
                        s._fill = q[r][n];
                        d.add(s);
                    }
                }
                else {
                    for (let t = 0; t < f.length - 1; t += 2) {
                        let u = new Brush();
                        u = new Brush();
                        u._fill = f[t + 1];
                        d.add(u);
                    }
                }
            }
            if (k == 0) {
                if (p > 0) {
                    for (let v = 0; v < p; v++) {
                        let w = new Brush();
                        w._fill = q[v][o];
                        e.add(w);
                    }
                }
                else {
                    for (let x = 0; x < f.length - 1; x += 2) {
                        let y = new Brush();
                        y._fill = f[x];
                        e.add(y);
                    }
                }
            }
            container_.endCSSQuery();
            return {
                p4: d,
                p5: e
            };
        }
        static k(a, b, c, container_, d) {
            let e = null;
            container_.startCSSQuery();
            let f = container_.getCssDefaultPropertyValue(a, "background-image");
            if (f != null) {
                e = CssGradientUtil.brushFromGradientString(f);
            }
            if (e == null) {
                e = new Brush();
                let g = container_.getCssDefaultPropertyValue(b, c);
                e._fill = g != null ? g : d;
            }
            container_.endCSSQuery();
            return e;
        }
    }
    BrushUtil.$t = /*@__PURE__*/ markType(BrushUtil, 'BrushUtil');
    return BrushUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushUtilCore = /*@__PURE__*/ (() => {
    class BrushUtilCore extends Base {
        static a(a) {
            if (a == null) {
                return false;
            }
            let b = typeCast(LinearGradientBrush.$, a);
            if (b != null) {
                return BrushUtilCore.c(b);
            }
            if (a.color.l == 0) {
                return true;
            }
            return false;
        }
        static c(a) {
            let d = a.gradientStops;
            for (let c = 0; c < d.length; c++) {
                let b = d[c];
                if (!BrushUtilCore.b(b)) {
                    return false;
                }
            }
            return true;
        }
        static b(a) {
            if (a.color.l == 0) {
                return true;
            }
            return false;
        }
    }
    BrushUtilCore.$t = /*@__PURE__*/ markType(BrushUtilCore, 'BrushUtilCore');
    return BrushUtilCore;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available modes for color interpolation.
 */
var InterpolationMode = /*@__PURE__*/ (function (InterpolationMode) {
    /**
     * Interpolation in RGB space.
     */
    InterpolationMode[InterpolationMode["RGB"] = 0] = "RGB";
    /**
     * Interpolation in HSV space.
     */
    InterpolationMode[InterpolationMode["HSV"] = 1] = "HSV";
    return InterpolationMode;
})({});
/**
 * @hidden
 */
let InterpolationMode_$type = /*@__PURE__*/ markEnum('InterpolationMode', 'RGB,0|HSV,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssHelper = /*@__PURE__*/ (() => {
    class CssHelper extends Base {
        static getDisoveryElement(a) {
            let b = a.createElement("fakediscoveryelement");
            b.setStyleProperty("box-sizing", "content-box");
            return b;
        }
        static getDefaultValue(a) {
            if (a == "color" || a == "border-color" || a == "border-top-color" || a == "border-left-color" || a == "border-right-color" || a == "border-bottom-color" || a == "background-color" || a == "outline-color") {
                return "rgb(3, 2, 1)";
            }
            else if (a == "margin-left" || a == "margin-top" || a == "margin-right" || a == "margin-bottom") {
                return "-4321px";
            }
            else if (a == "vertical-align") {
                return "baseline";
            }
            else if (a == "opacity") {
                return "0.888";
            }
            else if (a == "background-image") {
                return "none";
            }
            else if (a == "text-align") {
                return "justify";
            }
            else if (a == "visibility") {
                return "hidden";
            }
            else if (CssHelper.c(a)) {
                return "4321px";
            }
            return "DEFAULT";
        }
        static numberOfClasses(a, b, c) {
            let d = CssHelper.getDefaultValue(c);
            let e = 1;
            let f = false;
            while (!f && e < 500) {
                let g = b + e.toString();
                a.addClass(g);
                let h = a.getStyleProperty(c);
                if (h == d) {
                    break;
                }
                e++;
            }
            return e;
        }
        static getPropertyValue1(a, b, c) {
            if (b != null) {
                a.addClass(b);
            }
            let ret_ = a.getStyleProperty(c);
            if (b != null) {
                a.removeClass(b);
            }
            if (c == "opacity") {
                ret_ = (Math.round(1000.0 * +ret_) / 1000.0).toString();
            }
            if (CssHelper.a(ret_, CssHelper.getDefaultValue(c), c)) {
                return null;
            }
            return ret_;
        }
        static getPropertyValue(a, b) {
            return CssHelper.getPropertyValue1(a, null, b);
        }
        static a(a, b, c) {
            if (a == b) {
                return true;
            }
            if (CssHelper.c(c) && a != null && stringContains(a, "px")) {
                let d = stringReplace(a, "px", "");
                let e = parseFloat(d);
                if (Math.abs(Math.round(e) - 4321) < 2) {
                    return true;
                }
                return false;
            }
            else if (CssHelper.b(c) && a != null && stringContains(a, "px")) {
                let f = stringReplace(a, "px", "");
                let g = parseFloat(f);
                if (Math.abs(Math.round(g) + 4321) < 2) {
                    return true;
                }
                return false;
            }
            else {
                return a == b;
            }
        }
        static c(a) {
            return a == "width" || a == "height" || a == "border-top-width" || a == "border-left-width" || a == "border-right-width" || a == "border-bottom-width" || a == "border-width" || a == "border-radius" || a == "padding" || a == "padding-top" || a == "padding-left" || a == "padding-bottom" || a == "padding-right" || a == "border-top-left-radius";
        }
        static b(a) {
            return a == "margin-top" || a == "margin-left" || a == "margin-right" || a == "margin-bottom";
        }
        static getValuesForClassCollection(a, b, c) {
            let d = new List$1(List$1.$.specialize(String_$type), 0);
            let e = 1;
            let f = false;
            while (!f && e < 500) {
                let g = b + e.toString();
                a.addClass(g);
                let h = new List$1(String_$type, 0);
                for (let i = 0; i < c.count; i++) {
                    let j = c._inner[i];
                    let k = CssHelper.getDefaultValue(j);
                    let l = a.getStyleProperty(j);
                    if (CssHelper.a(l, k, j)) {
                        f = true;
                        break;
                    }
                    h.add(l);
                }
                a.removeClass(g);
                if (!f) {
                    d.add(h);
                }
                e++;
            }
            return d;
        }
    }
    CssHelper.$t = /*@__PURE__*/ markType(CssHelper, 'CssHelper');
    CssHelper.defaultMarginValue = "-4321px";
    CssHelper.defaultColorValue = "rgb(3, 2, 1)";
    CssHelper.defaultBackgroundImageValue = "none";
    CssHelper.defaultTextAlignValue = "justify";
    CssHelper.defaultVerticalAlignValue = "baseline";
    CssHelper.defaultOpacityValue = "0.888";
    CssHelper.defaultVisibilityValue = "hidden";
    CssHelper.defaultWidthHeightValue = "4321px";
    CssHelper.maxClasses = 500;
    return CssHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoubleAnimator = /*@__PURE__*/ (() => {
    class DoubleAnimator extends Base {
        get_g() {
            return this.o == 0;
        }
        get g() {
            return this.get_g();
        }
        u(a) {
            if (a == null) {
                this.s();
            }
            else if (a.supportsAnimation()) {
                this.requestAnimationFrame = a.getRequestAnimationFrame();
            }
        }
        t() {
            this.y(true);
        }
        get o() {
            return this.k;
        }
        set o(a) {
            this.k = a;
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs("TransitionProgress"));
            }
        }
        get r() {
            return this.p;
        }
        set r(a) {
            this.p = a;
        }
        get b() {
            return this.a;
        }
        set b(a) {
            this.a = a;
        }
        get l() {
            return this.i;
        }
        set l(a) {
            this.i = a;
        }
        get n() {
            return this.j;
        }
        set n(a) {
            this.j = a;
        }
        constructor(a, b, c) {
            super();
            this.k = 0;
            this.p = 0;
            this.a = null;
            this.i = 0;
            this.j = 0;
            this._requestAnimationFrame = null;
            this.d = false;
            this.h = new Date();
            this.q = 0;
            this.propertyChanged = null;
            this.i = a;
            this.j = b;
            this.p = c;
            this.s();
        }
        s() {
            this.requestAnimationFrame = (window.requestAnimationFrame ||
                window.webkitRequestAnimationFrame ||
                window.mozRequestAnimationFrame ||
                window.oRequestAnimationFrame ||
                window.msRequestAnimationFrame ||
                function (callback) {
                    window.setTimeout(callback, 1000 / 60);
                });
        }
        get requestAnimationFrame() {
            return this._requestAnimationFrame;
        }
        set requestAnimationFrame(a) {
            this._requestAnimationFrame = a;
        }
        get e() {
            return this.d;
        }
        set e(a) {
            this.d = a;
        }
        v() {
            this.k = 0;
            this.q = 0;
            this.h = dateNow();
            if (!this.d) {
                this.d = true;
                this.requestAnimationFrame(runOn(this, this.x));
            }
        }
        w() {
            this.d = false;
            this.k = 0;
            this.q = 0;
        }
        x() {
            this.y(false);
        }
        y(a) {
            if (!this.d) {
                this.w();
                return;
            }
            let b = dateNow();
            let c = b.getTime() - this.h.getTime();
            if (c > this.p) {
                c = this.p;
            }
            if ((c - this.q < 16 && c != this.p) && !a) {
                this.requestAnimationFrame(runOn(this, this.x));
                return;
            }
            this.q = c;
            let d = (c / this.p);
            if (this.a != null) {
                d = this.a(d);
            }
            let e = this.i + ((this.j - this.i) * d);
            if (!a) {
                if (c == this.p) {
                    this.w();
                }
                else {
                    this.requestAnimationFrame(runOn(this, this.x));
                }
            }
            this.o = e;
        }
        m() {
            return this.d ? dateNow().getTime() - this.h.getTime() : 0;
        }
        f() {
            return this.d;
        }
    }
    DoubleAnimator.$t = /*@__PURE__*/ markType(DoubleAnimator, 'DoubleAnimator', Base.$, [INotifyPropertyChanged_$type]);
    return DoubleAnimator;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AggregateException = /*@__PURE__*/ (() => {
    class AggregateException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(2, c, d);
                    }
                    break;
            }
        }
    }
    AggregateException.$t = /*@__PURE__*/ markType(AggregateException, 'AggregateException', BaseError.$);
    return AggregateException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Task = /*@__PURE__*/ (() => {
    class Task extends Base {
        constructor(a, ..._rest) {
            super();
            this.d = null;
            this.b = false;
            this.a = null;
            this.e = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, null];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = () => {
                            };
                            let i = (j) => {
                                if (j == null) {
                                    this.b = true;
                                }
                                else {
                                    this.a = new AggregateException(2, "Exception occurred during task execution", j);
                                }
                            };
                            this.d = f.done(h).fail(i);
                            this.e = g;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = () => {
                        };
                        let f = (g) => {
                            if (g == null) {
                                this.b = true;
                            }
                            else {
                                this.a = new AggregateException(2, "Exception occurred during task execution", g);
                            }
                        };
                        this.d = c.done(e).fail(f);
                        this.e = d;
                    }
                    break;
            }
        }
        get c() {
            return this.h == 5 || this.h == 7 || this.h == 6;
        }
        get h() {
            if (this.b) {
                return 6;
            }
            switch (this.d.state()) {
                case "pending": return 0;
                case "resolved": return 5;
                case "rejected": return 7;
                default: return 0;
            }
        }
        f(a) {
            let b = () => a(this);
            let c = (d) => a(this);
            let d = this.d.done(b).fail(c);
            return new Task(0, d);
        }
        g($tNewResult, a) {
            let b = new TaskCompletionSource$1($tNewResult, 0);
            let c = () => {
                try {
                    let d = a(this);
                    b.e(d);
                }
                catch (e) {
                    b.d((e));
                }
            };
            let d = (e) => c();
            let e = (f) => c();
            this.d.done(d).fail(e);
            return b.b;
        }
    }
    Task.$t = /*@__PURE__*/ markType(Task, 'Task');
    return Task;
})();
/**
 * @hidden
 */
let Task$1 = /*@__PURE__*/ (() => {
    class Task$1 extends Task {
        constructor($tResult, a, b) {
            super(1, a, b);
            this.$tResult = null;
            this.i = false;
            this.m = null;
            this.$tResult = $tResult;
            this.$type = this.$type.specialize(this.$tResult);
            let c = (d) => {
                let e = typeCastObjTo$t(this.$tResult, d);
                this.m = e;
                this.i = true;
            };
            let d = (e) => this.i = true;
            this.d.done(c).fail(d);
        }
        get n() {
            if (!this.i) {
                throw 'Result is not ready yet';
            }
            if (this.a != null) {
                throw this.a;
            }
            return this.m;
        }
        j(a) {
            return super.f((b) => a(b));
        }
        k($tNewResult, a) {
            let b = (c) => getBoxIfEnum($tNewResult, a(c));
            return this.l(Base.$, b).l($tNewResult, (c) => typeCastObjTo$t($tNewResult, c.n));
        }
        l($tNewResult, a) {
            return super.g($tNewResult, a);
        }
    }
    Task$1.$t = /*@__PURE__*/ markType(Task$1, 'Task$1', Task.$);
    return Task$1;
})();
/**
 * @hidden
 */
let TaskCompletionSource$1 = /*@__PURE__*/ (() => {
    class TaskCompletionSource$1 extends Base {
        constructor($tResult, a, ..._rest) {
            super();
            this.$tResult = null;
            this.a = null;
            this.b = null;
            this.$tResult = $tResult;
            this.$type = this.$type.specialize(this.$tResult);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [null];
                        {
                            let e = c[0];
                            this.a = new PromiseFactory();
                            this.b = new Task$1(this.$tResult, this.a.promise(), e);
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.a = new PromiseFactory();
                        this.b = new Task$1(this.$tResult, this.a.promise(), c);
                    }
                    break;
            }
        }
        c() {
            this.a.reject(null);
        }
        d(a) {
            this.a.reject(a);
        }
        e(a) {
            this.a.resolve(getBoxIfEnum(this.$tResult, a));
        }
    }
    TaskCompletionSource$1.$t = /*@__PURE__*/ markType(TaskCompletionSource$1, 'TaskCompletionSource$1');
    return TaskCompletionSource$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Transform = /*@__PURE__*/ (() => {
    class Transform extends DependencyObject {
    }
    Transform.$t = /*@__PURE__*/ markType(Transform, 'Transform', DependencyObject.$);
    return Transform;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MatrixTransform = /*@__PURE__*/ (() => {
    class MatrixTransform extends Transform {
        constructor() {
            super(...arguments);
            this.j = null;
        }
    }
    MatrixTransform.$t = /*@__PURE__*/ markType(MatrixTransform, 'MatrixTransform', Transform.$);
    return MatrixTransform;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Matrix = /*@__PURE__*/ (() => {
    class Matrix extends Transform {
        constructor() {
            super(...arguments);
            this.j = 0;
            this.k = 0;
            this.l = 0;
            this.m = 0;
            this.n = 0;
            this.o = 0;
        }
    }
    Matrix.$t = /*@__PURE__*/ markType(Matrix, 'Matrix', Transform.$);
    return Matrix;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScaleTransform = /*@__PURE__*/ (() => {
    class ScaleTransform extends Transform {
        constructor() {
            super(...arguments);
            this.l = 0;
            this.m = 0;
            this.j = 0;
            this.k = 0;
        }
    }
    ScaleTransform.$t = /*@__PURE__*/ markType(ScaleTransform, 'ScaleTransform', Transform.$);
    return ScaleTransform;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RotateTransform = /*@__PURE__*/ (() => {
    class RotateTransform extends Transform {
        constructor() {
            super(...arguments);
            this.j = 0;
            this.k = 0;
            this.l = 0;
        }
    }
    RotateTransform.$t = /*@__PURE__*/ markType(RotateTransform, 'RotateTransform', Transform.$);
    return RotateTransform;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TranslateTransform = /*@__PURE__*/ (() => {
    class TranslateTransform extends Transform {
        constructor() {
            super(...arguments);
            this.j = 0;
            this.k = 0;
        }
    }
    TranslateTransform.$t = /*@__PURE__*/ markType(TranslateTransform, 'TranslateTransform', Transform.$);
    return TranslateTransform;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransformCollection = /*@__PURE__*/ (() => {
    class TransformCollection extends List$1 {
        constructor() {
            super(Transform.$, 0);
        }
    }
    TransformCollection.$t = /*@__PURE__*/ markType(TransformCollection, 'TransformCollection', /*@__PURE__*/ List$1.$.specialize(Transform.$));
    return TransformCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransformGroup = /*@__PURE__*/ (() => {
    class TransformGroup extends Transform {
        constructor() {
            super();
            this.j = null;
            this.j = new TransformCollection();
        }
    }
    TransformGroup.$t = /*@__PURE__*/ markType(TransformGroup, 'TransformGroup', Transform.$);
    return TransformGroup;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransformMatrixHelpler = /*@__PURE__*/ (() => {
    class TransformMatrixHelpler extends Base {
        static f(a) {
            if (typeCast(MatrixTransform.$, a) !== null) {
                return a.j;
            }
            if (typeCast(ScaleTransform.$, a) !== null) {
                let b = a;
                return TransformMatrixHelpler.g(0, b.l, b.m, { $type: Point_$type, x: 0, y: 0 });
            }
            if (typeCast(RotateTransform.$, a) !== null) {
                let c = a;
                let d = 0;
                let e = 0;
                if (!isNaN_(c.k)) {
                    d = c.k;
                }
                if (!isNaN_(c.l)) {
                    e = c.l;
                }
                let f = TransformMatrixHelpler.g(0, 1, 1, { $type: Point_$type, x: -d, y: -e });
                let g = TransformMatrixHelpler.g(c.j, 1, 1, { $type: Point_$type, x: 0, y: 0 });
                let h = TransformMatrixHelpler.g(0, 1, 1, { $type: Point_$type, x: d, y: e });
                let i = TransformMatrixHelpler.e(f, g);
                i = TransformMatrixHelpler.e(i, h);
                return i;
            }
            if (typeCast(TranslateTransform.$, a) !== null) {
                let j = a;
                return TransformMatrixHelpler.g(0, 1, 1, { $type: Point_$type, x: j.j, y: j.k });
            }
            if (typeCast(TransformGroup.$, a) !== null) {
                let k = a;
                let l = new Matrix();
                l.j = 1;
                l.m = 1;
                if (k.j.count > 0) {
                    l = TransformMatrixHelpler.f(k.j._inner[0]);
                    for (let m = 1; m < k.j.count; m++) {
                        let n = TransformMatrixHelpler.f(k.j._inner[m]);
                        l = TransformMatrixHelpler.e(l, n);
                    }
                }
                return l;
            }
            return a;
        }
        static a(a) {
            return Math.atan2(a.k, a.j) * 180 / Math.PI;
        }
        static b(a) {
            let b = Math.sqrt((a.j * a.j) + (a.k * a.k));
            return b;
        }
        static c(a) {
            let b = Math.sqrt((a.l * a.l) + (a.m * a.m));
            return b;
        }
        static i(a, b) {
            let c = a.j * b.x + a.l * b.y + a.n;
            let d = a.k * b.x + a.m * b.y + a.o;
            return { $type: Point_$type, x: c, y: d };
        }
        static h(a) {
            return { $type: Point_$type, x: a.n, y: a.o };
        }
        static e(a, b) {
            let c = new Matrix();
            c.j = a.j * b.j + a.k * b.l;
            c.k = a.j * b.k + a.k * b.m;
            c.n = a.n * b.j + a.o * b.l + b.n;
            c.l = a.l * b.j + a.m * b.l;
            c.m = a.l * b.k + a.m * b.m;
            c.o = a.n * b.k + a.o * b.m + b.o;
            return c;
        }
        static d(a, b, c) {
            let d = TransformMatrixHelpler.a(b);
            let e = TransformMatrixHelpler.a(c);
            let f = TransformMatrixHelpler.b(b);
            let g = TransformMatrixHelpler.b(c);
            let h = TransformMatrixHelpler.c(b);
            let i = TransformMatrixHelpler.c(c);
            let j = TransformMatrixHelpler.h(b);
            let k = TransformMatrixHelpler.h(c);
            let l = d + (e - d) * a;
            let m = f + (g - f) * a;
            let n = h + (i - h) * a;
            let o = { $type: Point_$type, x: j.x + (k.x - j.x) * a, y: j.y + (k.y - j.y) * a };
            return TransformMatrixHelpler.g(l, m, n, o);
        }
        static g(a, b, c, d) {
            a = a % 360;
            let e = a * Math.PI / 180;
            let f = new Matrix();
            let g = Math.cos(e);
            let h = Math.sin(e);
            f.j = b * g;
            f.k = b * h;
            f.l = -c * h;
            f.m = c * g;
            f.n = d.x;
            f.o = d.y;
            return f;
        }
    }
    TransformMatrixHelpler.$t = /*@__PURE__*/ markType(TransformMatrixHelpler, 'TransformMatrixHelpler');
    return TransformMatrixHelpler;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationKeyFrameProperty = /*@__PURE__*/ (() => {
    class AnimationKeyFrameProperty extends Base {
        constructor(a, b) {
            super();
            this.a = 0;
            this.b = null;
            this.a = a;
            this.d = b;
        }
        get d() {
            return this.b;
        }
        set d(a) {
            let b = this.c(a);
            this.b = b;
        }
        c(a) {
            if (this.a == 0) {
                return a;
            }
            switch (this.a) {
                case 14:
                    let b = TransformMatrixHelpler.f(a);
                    let c = new MatrixTransform();
                    c.j = b;
                    return c;
            }
            return a;
        }
    }
    AnimationKeyFrameProperty.$t = /*@__PURE__*/ markType(AnimationKeyFrameProperty, 'AnimationKeyFrameProperty');
    return AnimationKeyFrameProperty;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UIElementPropertyId_$type = /*@__PURE__*/ markEnum('UIElementPropertyId', 'Unset,0|Opacity,1|BackgroundColor,2|BorderColor,3|BorderWidth,4|BorderRadius,5|Padding,6|Color,7|FontSize,8|Width,9|Height,10|Left,11|Top,12|Margin,13|Transform,14|Stroke,15|Fill,16|StrokeWidth,17|StrokeDashArray,18|StrokeDashOffset,19|Cursor,20|IsHitTestVisible,21|VerticalOffset,22|HorizontalOffset,23|Visibility,24|IsEnabled,25|MinWidth,26|MinHeight,27');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationKeyFrame = /*@__PURE__*/ (() => {
    class AnimationKeyFrame extends Base {
        constructor(a, ..._rest) {
            super();
            this.j = 0;
            this.i = new List$1(AnimationKeyFrameProperty.$, 0);
            this.a = null;
            this.h = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.j = NaN;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.j = c;
                    }
                    break;
            }
        }
        get b() {
            if (this.a == null) {
                this.a = this.i.toArray();
            }
            return this.a;
        }
        g(a) {
            if (this.h == null) {
                this.h = new Dictionary$2(UIElementPropertyId_$type, AnimationKeyFrameProperty.$, 0);
                for (let b = 0; b < this.b.length; b++) {
                    this.h.item(this.b[b].a, this.b[b]);
                }
            }
            if (this.h.containsKey(a)) {
                return this.h.item(a);
            }
            return null;
        }
        static d() {
            return new AnimationKeyFrame(0);
        }
        static e(a) {
            let b = new AnimationKeyFrame(0);
            b.j = a;
            return b;
        }
        static f(a, b) {
            let c = new AnimationKeyFrame(0);
            c.j = a;
            c.i.o(b);
            return c;
        }
        c(a) {
            this.i.add(a);
            this.a = null;
            this.h = null;
            return this;
        }
    }
    AnimationKeyFrame.$t = /*@__PURE__*/ markType(AnimationKeyFrame, 'AnimationKeyFrame');
    return AnimationKeyFrame;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UIElementPropertyAccessor = /*@__PURE__*/ (() => {
    class UIElementPropertyAccessor extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
        }
    }
    UIElementPropertyAccessor.$t = /*@__PURE__*/ markType(UIElementPropertyAccessor, 'UIElementPropertyAccessor');
    return UIElementPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EasingFunctions = /*@__PURE__*/ (() => {
    class EasingFunctions extends Base {
        static c(a) {
            return a * a * a;
        }
        static g(a) {
            return (Math.exp(2 * a) - 1) / (Math.exp(2) - 1);
        }
        static a(a) {
            return 1 - Math.sqrt(1 - a * a);
        }
        static e(a, b) {
            let c = a * 2;
            return 0.5 * b(c);
        }
        static f(a, b) {
            let c = (1 - a) * 2;
            let d = 1 - b(c);
            return 0.5 * d + 0.5;
        }
        static cubicEase(a) {
            if (a < 0.5) {
                let b = a * 2;
                return 0.5 * EasingFunctions.c(b);
            }
            let c = (1 - a) * 2;
            let d = 1 - EasingFunctions.c(c);
            return 0.5 * d + 0.5;
        }
        static exponentialEase(a) {
            if (a < 0.5) {
                return EasingFunctions.e(a, EasingFunctions.g);
            }
            return EasingFunctions.f(a, EasingFunctions.g);
        }
        static circleEase(a) {
            if (a < 0.5) {
                return EasingFunctions.e(a, EasingFunctions.a);
            }
            return EasingFunctions.f(a, EasingFunctions.a);
        }
    }
    EasingFunctions.$t = /*@__PURE__*/ markType(EasingFunctions, 'EasingFunctions');
    return EasingFunctions;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Thickness = /*@__PURE__*/ (() => {
    class Thickness extends Base {
        constructor(a, ..._rest) {
            super();
            this._bottom = 0;
            this._left = 0;
            this._right = 0;
            this._top = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        this.bottom = this.left = this.right = this.top = c;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        this.left = c;
                        this.top = d;
                        this.right = e;
                        this.bottom = f;
                    }
                    break;
                case 2:
                    {
                        this.bottom = NaN;
                        this.left = NaN;
                        this.right = NaN;
                        this.top = NaN;
                    }
                    break;
            }
        }
        get bottom() {
            return this._bottom;
        }
        set bottom(a) {
            this._bottom = a;
        }
        get left() {
            return this._left;
        }
        set left(a) {
            this._left = a;
        }
        get right() {
            return this._right;
        }
        set right(a) {
            this._right = a;
        }
        get top() {
            return this._top;
        }
        set top(a) {
            this._top = a;
        }
        a(a) {
            return this.bottom == a.bottom && this.top == a.top && this.left == a.left && this.right == a.right;
        }
        toString() {
            let a = this.left.toString() + "," + this.top.toString() + "," + this.right.toString() + "," + this.bottom.toString();
            return a;
        }
    }
    Thickness.$t = /*@__PURE__*/ markType(Thickness, 'Thickness');
    return Thickness;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CornerRadius = /*@__PURE__*/ (() => {
    class CornerRadius extends Base {
        constructor(a, ..._rest) {
            super();
            this.b = 0;
            this.a = 0;
            this.c = 0;
            this.d = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        this.a = this.b = this.c = this.d = c;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        this.c = c;
                        this.d = d;
                        this.b = e;
                        this.a = f;
                    }
                    break;
                case 2:
                    {
                        this.a = NaN;
                        this.b = NaN;
                        this.c = NaN;
                        this.d = NaN;
                    }
                    break;
            }
        }
    }
    CornerRadius.$t = /*@__PURE__*/ markType(CornerRadius, 'CornerRadius');
    return CornerRadius;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InterpolationUtil = /*@__PURE__*/ (() => {
    class InterpolationUtil extends Base {
        static g(a, b, c) {
            return new Thickness(1, b.left + a * (c.left - b.left), b.top + a * (c.top - b.top), b.right + a * (c.right - b.right), b.bottom + a * (c.bottom - b.bottom));
        }
        static e(a, b, c) {
            return new CornerRadius(1, b.c + a * (c.c - b.c), b.d + a * (c.d - b.d), b.b + a * (c.b - b.b), b.a + a * (c.a - b.a));
        }
        static f(a, b, c) {
            return new Rect(0, b.left + a * (c.left - b.left), b.top + a * (c.top - b.top), b.width + a * (c.width - b.width), b.height + a * (c.height - b.height));
        }
        static c(a, b, c, d) {
            let e = 1 - b;
            if (a == null) {
                a = new List$1(Point_$type, 0);
            }
            if (c == null) {
                c = new List$1(Point_$type, 0);
            }
            let f = c.count;
            let g = d.count;
            let h = Math.max(f, g);
            let i = a.count;
            if (i < h) {
                a.s(i, new Array(h - i));
            }
            if (i > h) {
                a.v(h, i - h);
            }
            for (let j = 0; j < Math.min(f, g); ++j) {
                a._inner[j] = { $type: Point_$type, x: (c._inner[j].x * e) + (d._inner[j].x * b), y: (c._inner[j].y * e) + (d._inner[j].y * b) };
            }
            if (f < g) {
                let k = f > 0 ? c._inner[f - 1] : { $type: Point_$type, x: 0, y: 0 };
                for (let l = f; l < g; ++l) {
                    a._inner[l] = { $type: Point_$type, x: (k.x * e) + (d._inner[l].x * b), y: (k.y * e) + (d._inner[l].y * b) };
                }
            }
            if (f > g) {
                let m = g > 0 ? d._inner[g - 1] : { $type: Point_$type, x: 0, y: 0 };
                for (let n = g; n < f; ++n) {
                    a._inner[n] = { $type: Point_$type, x: (c._inner[n].x * e) + (m.x * b), y: (c._inner[n].y * e) + (m.y * b) };
                }
            }
            return a;
        }
        static a($t, a, b, c, d, e, f) {
            return InterpolationUtil.d($t, new List$1($t, 1, a), b, new List$1($t, 1, c), new List$1($t, 1, d), e, f).toArray();
        }
        static d($t, a, b, c, d, e, f) {
            let g = 1 - b;
            if (a == null) {
                a = new List$1($t, 0);
            }
            if (c == null) {
                c = new List$1($t, 0);
            }
            let h = c.count;
            let i = d.count;
            let j = Math.max(h, i);
            if (a.count < j) {
                let k = j - a.count;
                let l = new Array(k);
                a.s(a.count, l);
            }
            if (a.count > j) {
                a.v(j, a.count - j);
            }
            for (let m = 0; m < Math.min(h, i); ++m) {
                a._inner[m] = f(b, g, c._inner[m], d._inner[m]);
            }
            if (h < i) {
                let n = h > 0 ? c._inner[h - 1] : e();
                for (let o = h; o < i; ++o) {
                    a._inner[o] = f(b, g, n, d._inner[o]);
                }
            }
            if (h > i) {
                let p = i > 0 ? d._inner[i - 1] : e();
                for (let q = i; q < h; ++q) {
                    a._inner[q] = f(b, g, c._inner[q], p);
                }
            }
            return a;
        }
        static b(a, b, c) {
            let d = 1 - a;
            if (b == null) {
                b = new Array(0);
            }
            let e = b.length;
            let f = c.length;
            let g = Math.max(e, f);
            let h = new Array(g);
            for (let i = 0; i < Math.min(e, f); i++) {
                h[i] = b[i] + a * (c[i] - b[i]);
            }
            if (e < f) {
                let j = e > 0 ? b[e - 1] : 0;
                for (let k = e; k < f; ++k) {
                    h[k] = j + a * (c[k] - j);
                }
            }
            if (e > f) {
                let l = f > 0 ? c[f - 1] : 0;
                for (let m = f; m < e; ++m) {
                    h[m] = b[m] + a * (l - b[m]);
                }
            }
            return h;
        }
    }
    InterpolationUtil.$t = /*@__PURE__*/ markType(InterpolationUtil, 'InterpolationUtil');
    return InterpolationUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Environment = /*@__PURE__*/ (() => {
    class Environment extends Base {
        static get newLine() {
            return "\n";
        }
        static get b() {
            try {
                throw new Error();
            }
            catch (a) {
                return (a.stack);
            }
            return "";
        }
    }
    Environment.$t = /*@__PURE__*/ markType(Environment, 'Environment');
    return Environment;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StringBuilder = /*@__PURE__*/ (() => {
    class StringBuilder extends Base {
        get internal() {
            return this._internal;
        }
        set internal(a) {
            this._internal = a;
        }
        constructor(a, ..._rest) {
            super();
            this._internal = null;
            this.b = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.internal = "";
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        {
                            this.internal = "";
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        this.internal = c;
                    }
                    break;
            }
        }
        k(a) {
            if (a != null) {
                this.l(a.toString());
            }
            return this;
        }
        l(str_) {
            if (str_ != null) {
                this.internal = this.internal.concat(str_);
            }
            ;
            return this;
        }
        n(a) {
            let str_ = a.toString();
            this.internal = this.internal.concat(str_);
            return this;
        }
        h(chr_) {
            this.internal = this.internal.concat(chr_);
            return this;
        }
        i(chr_, count_) {
            if (chr_.repeat) {
                this.internal = this.internal.concat(chr_.repeat(count_));
            }
            else {
                for (let a = 0; a < count_; a++) {
                    this.internal = this.internal.concat(chr_);
                }
            }
            return this;
        }
        j(value_) {
            this.internal = this.internal.concat(value_.toString());
            return this;
        }
        m(value_, startIndex_, count_) {
            this.internal = this.internal.concat(value_.substr(startIndex_, count_));
            return this;
        }
        g(value_, startIndex_, charCount_) {
            this.internal = this.internal.concat(value_.slice(startIndex_, startIndex_ + charCount_).join(''));
            return this;
        }
        t() {
            return this.u("");
        }
        u(str_) {
            if (str_ != null) {
                this.internal = this.internal.concat(str_);
            }
            this.internal = this.internal.concat(Environment.newLine);
            return this;
        }
        v() {
            this.internal = "";
            return this;
        }
        w(index_, chr_) {
            if (index_ == this.c) {
                this.h(chr_);
            }
            else {
                this.internal = this.internal.substring(0, index_).concat(chr_).concat(this.internal.substring(index_, this.internal.length));
            }
            return this;
        }
        x(index_, str_) {
            if (index_ == this.c) {
                this.l(str_);
            }
            else {
                this.internal = this.internal.substring(0, index_).concat(str_).concat(this.internal.substring(index_, this.internal.length));
            }
            return this;
        }
        y(startIndex_, length_) {
            this.internal = this.internal.substring(0, startIndex_).concat(this.internal.substring(startIndex_ + length_, this.internal.length));
            return this;
        }
        z(oldCh_, newCh_) {
            this.internal = this.internal.replace(oldCh_, newCh_);
            return this;
        }
        toString() {
            return this.internal;
        }
        f(a, b) {
            return this.internal.substr(a, b);
        }
        get c() {
            return this.internal.length;
        }
        set c(a) {
            if (a <= this.c) {
                this.internal = this.internal.substring(0, a);
            }
            else {
                throw new NotImplementedException(0);
            }
        }
        item(index_, a) {
            if (arguments.length === 2) {
                this.internal = this.internal.substring(0, index_).concat(a).concat(this.internal.substring(index_ + 1, this.internal.length));
                return a;
            }
            else {
                return this.internal.charAt(index_);
            }
        }
        q(a, b) {
            return this.l(stringFormat(a, b));
        }
        p(a, ...b) {
            return this.l(stringFormat1(a, ...b));
        }
        o(a, b, ...c) {
            return this.l(stringFormat2(a, b, ...c));
        }
        r(a, b, c) {
            return this.l(stringFormat(a, b, c));
        }
        s(a, b, c, d) {
            return this.l(stringFormat(a, b, c, d));
        }
    }
    StringBuilder.$t = /*@__PURE__*/ markType(StringBuilder, 'StringBuilder');
    return StringBuilder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CSSColorUtil = /*@__PURE__*/ (() => {
    class CSSColorUtil extends Base {
        static g(a) {
            return Brush.create(a);
        }
        static a(a) {
            let b = a[0];
            let c = a[1];
            if (isNaN_(b.x) || isNaN_(b.y)) {
                b = { $type: Point_$type, x: 0.5, y: 1 };
            }
            if (isNaN_(c.x) || isNaN_(c.y)) {
                c = { $type: Point_$type, x: 0.5, y: 0 };
            }
            let d = Math.atan2(c.y - b.y, c.x - b.x);
            d -= Math.PI;
            d = MathUtil.f(d);
            d = CSSColorUtil.b(d);
            return d;
        }
        static c(a) {
            if (typeCast(LinearGradientBrush.$, a) !== null) {
                return CSSColorUtil.e(a);
            }
            else {
                return CSSColorUtil.f(a);
            }
        }
        static b(a) {
            if (isNaN_(a) || isInfinity(a)) {
                return a;
            }
            while (a > 360) {
                a -= 360;
            }
            while (a < 0) {
                a += 360;
            }
            return a;
        }
        static e(a) {
            let b = CSSColorUtil.a([{ $type: Point_$type, x: a.startX, y: a.startY }, { $type: Point_$type, x: a.endX, y: a.endY }]);
            let c = new StringBuilder(0);
            c.l("linear-gradient(");
            c.l(numberToString(b, CultureInfo.invariantCulture));
            c.l("deg");
            if (a.gradientStops != null && a.gradientStops.length > 0) {
                let f = a.gradientStops;
                for (let e = 0; e < f.length; e++) {
                    let d = f[e];
                    c.l(", ");
                    c.l(CSSColorUtil.d(d.color));
                    if (!isNaN_(d.offset)) {
                        c.l(" ");
                        c.l(numberToString((d.offset * 100), CultureInfo.invariantCulture) + "%");
                    }
                }
            }
            c.l(")");
            return c.toString();
        }
        static f(a) {
            return CSSColorUtil.d(a.color);
        }
        static d(a) {
            return "rgba(" + a.o.toString() + ", " + a.n.toString() + ", " + a.m.toString() + ", " + (a.l / 255).toString() + ")";
        }
    }
    CSSColorUtil.$t = /*@__PURE__*/ markType(CSSColorUtil, 'CSSColorUtil');
    return CSSColorUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssColorPropertyAccessor = /*@__PURE__*/ (() => {
    class CssColorPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.d = null;
            this.d = a;
        }
        b(a) {
            let b = a;
            let c = b.getStyleProperty(this.d);
            return Brush.create(c);
        }
        c(a, b) {
            let c = a;
            let d = b;
            c.setStyleProperty(this.d, CSSColorUtil.c(d));
        }
    }
    CssColorPropertyAccessor.$t = /*@__PURE__*/ markType(CssColorPropertyAccessor, 'CssColorPropertyAccessor', UIElementPropertyAccessor.$);
    return CssColorPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssThicknessPropertyAccessor = /*@__PURE__*/ (() => {
    class CssThicknessPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.e = null;
            this.g = null;
            this.f = null;
            this.d = null;
            this.h = null;
            this.h = a;
            if (this.h == "border-width") {
                this.e = "border-left-width";
                this.g = "border-top-width";
                this.f = "border-right-width";
                this.d = "border-bottom-width";
            }
            else {
                this.e = this.h + "-left";
                this.g = this.h + "-top";
                this.f = this.h + "-right";
                this.d = this.h + "-bottom";
            }
        }
        b(a) {
            let b = a;
            let c = b.getStyleProperty(this.e);
            let d = b.getStyleProperty(this.g);
            let e = b.getStyleProperty(this.f);
            let f = b.getStyleProperty(this.d);
            let g = parseFloat(stringReplace(c, "px", ""));
            let h = parseFloat(stringReplace(c, "px", ""));
            let i = parseFloat(stringReplace(c, "px", ""));
            let j = parseFloat(stringReplace(c, "px", ""));
            if (isNaN_(g)) {
                g = 0;
            }
            if (isNaN_(h)) {
                h = 0;
            }
            if (isNaN_(i)) {
                i = 0;
            }
            if (isNaN_(j)) {
                j = 0;
            }
            return new Thickness(1, g, h, i, j);
        }
        c(a, b) {
            let c = a;
            let d = b;
            let e = d.top + "px " + d.right + "px " + d.bottom + "px " + d.left + "px";
            c.setStyleProperty(this.h, e);
        }
    }
    CssThicknessPropertyAccessor.$t = /*@__PURE__*/ markType(CssThicknessPropertyAccessor, 'CssThicknessPropertyAccessor', UIElementPropertyAccessor.$);
    return CssThicknessPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssPixelsPropertyAccessor = /*@__PURE__*/ (() => {
    class CssPixelsPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.d = null;
            this.d = a;
        }
        b(a) {
            let b = a;
            let c = b.getStyleProperty(this.d);
            let d = parseFloat(stringReplace(c, "px", ""));
            if (isNaN_(d)) {
                d = 0;
            }
            return d;
        }
        c(a, b) {
            let c = a;
            let d = b;
            if (isNaN_(d)) {
                c.setStyleProperty(this.d, null);
                return;
            }
            let e = d + "px";
            c.setStyleProperty(this.d, e);
        }
    }
    CssPixelsPropertyAccessor.$t = /*@__PURE__*/ markType(CssPixelsPropertyAccessor, 'CssPixelsPropertyAccessor', UIElementPropertyAccessor.$);
    return CssPixelsPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssLengthPropertyAccessor = /*@__PURE__*/ (() => {
    class CssLengthPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.d = null;
            this.d = a;
        }
        b(a) {
            let b = a;
            let c = b.getStyleProperty(this.d);
            let d = parseFloat(stringReplace(c, "px", ""));
            if (isNaN_(d)) {
                d = 0;
            }
            return d;
        }
        c(a, b) {
            let c = a;
            let d = b;
            let e = d + "";
            c.setStyleProperty(this.d, e);
        }
    }
    CssLengthPropertyAccessor.$t = /*@__PURE__*/ markType(CssLengthPropertyAccessor, 'CssLengthPropertyAccessor', UIElementPropertyAccessor.$);
    return CssLengthPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssLengthArrayPropertyAccessor = /*@__PURE__*/ (() => {
    class CssLengthArrayPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.d = null;
            this.d = a;
        }
        b(a) {
            let b = new DoubleCollection();
            let c = a;
            let d = c.getStyleProperty(this.d);
            let e = d.split(' ');
            for (let f = 0; f < e.length; f++) {
                let g = parseFloat(stringReplace(e[f], "px", ""));
                if (isNaN_(g)) {
                    g = 0;
                }
                b.add(g);
            }
            return b;
        }
        c(a, b) {
            let c = a;
            let d = b;
            let e = new Array(d.count);
            for (let f = 0; f < d.count; f++) {
                e[f] = d._inner[f].toString();
            }
            let g = stringJoin1(Number_$type, " ", d);
            c.setStyleProperty(this.d, g);
        }
    }
    CssLengthArrayPropertyAccessor.$t = /*@__PURE__*/ markType(CssLengthArrayPropertyAccessor, 'CssLengthArrayPropertyAccessor', UIElementPropertyAccessor.$);
    return CssLengthArrayPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssFloatPropertyAccessor = /*@__PURE__*/ (() => {
    class CssFloatPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.d = null;
            this.d = a;
        }
        b(a) {
            let b = a;
            let c = b.getStyleProperty(this.d);
            let d = parseFloat(stringReplace(c, "px", ""));
            if (isNaN_(d)) {
                d = 0;
            }
            return d;
        }
        c(a, b) {
            let c = a;
            let d = b;
            let e = d.toString();
            c.setStyleProperty(this.d, e);
        }
    }
    CssFloatPropertyAccessor.$t = /*@__PURE__*/ markType(CssFloatPropertyAccessor, 'CssFloatPropertyAccessor', UIElementPropertyAccessor.$);
    return CssFloatPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssCornerRadiusPropertyAccessor = /*@__PURE__*/ (() => {
    class CssCornerRadiusPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.f = null;
            this.g = null;
            this.e = null;
            this.d = null;
            this.h = null;
            this.h = a;
            this.f = "top-left-border-radius";
            this.g = "top-right-border-radius";
            this.e = "bottom-right-border-radius";
            this.d = "bottom-left-border-radius";
        }
        b(a) {
            let b = a;
            let c = b.getStyleProperty(this.f);
            let d = b.getStyleProperty(this.g);
            let e = b.getStyleProperty(this.e);
            let f = b.getStyleProperty(this.d);
            let g = parseFloat(stringReplace(c, "px", ""));
            let h = parseFloat(stringReplace(d, "px", ""));
            let i = parseFloat(stringReplace(e, "px", ""));
            let j = parseFloat(stringReplace(f, "px", ""));
            if (isNaN_(g)) {
                g = 0;
            }
            if (isNaN_(h)) {
                h = 0;
            }
            if (isNaN_(i)) {
                i = 0;
            }
            if (isNaN_(j)) {
                j = 0;
            }
            return new CornerRadius(1, g, h, i, j);
        }
        c(a, b) {
            let c = a;
            let d = b;
            let e = d.c + "px " + d.d + "px " + d.b + "px " + d.a + "px";
            c.setStyleProperty(this.h, e);
        }
    }
    CssCornerRadiusPropertyAccessor.$t = /*@__PURE__*/ markType(CssCornerRadiusPropertyAccessor, 'CssCornerRadiusPropertyAccessor', UIElementPropertyAccessor.$);
    return CssCornerRadiusPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssTransformPropertyAccessor = /*@__PURE__*/ (() => {
    class CssTransformPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.d = null;
            this.d = a;
        }
        b(a) {
            let b = a;
            let c = b.getStyleProperty(this.d);
            if (c == null || c.length == 0) {
                return null;
            }
            c = stringReplace(stringReplace(c, "matrix(", ""), ")", "");
            let d = c.split(',');
            if (d.length != 6) {
                let e = new Matrix();
                e.k = 0;
                e.j = 1;
                e.l = 0;
                e.m = 1;
                e.n = 0;
                e.o = 0;
                return e;
            }
            let f = parseFloat(d[0].trim());
            let g = parseFloat(d[1].trim());
            let h = parseFloat(d[2].trim());
            let i = parseFloat(d[3].trim());
            let j = parseFloat(d[4].trim());
            let k = parseFloat(d[5].trim());
            let l = new MatrixTransform();
            let m = new Matrix();
            m.j = f;
            m.k = g;
            m.l = h;
            m.m = i;
            m.n = j;
            m.o = k;
            l.j = m;
            return l;
        }
        c(a, b) {
            let c = null;
            if (typeCast(MatrixTransform.$, b) !== null) {
                c = b;
            }
            else {
                c = new MatrixTransform();
                c.j = TransformMatrixHelpler.f(b);
            }
            let d = a;
            if (c == null || c.j == null) {
                d.setStyleProperty(this.d, "");
                return;
            }
            let e = c.j;
            let f = "matrix(" + e.j + ", " + e.k + ", " + e.l + ", " + e.m + ", " + e.n + ", " + e.o + ")";
            d.setStyleProperty(this.d, f);
        }
    }
    CssTransformPropertyAccessor.$t = /*@__PURE__*/ markType(CssTransformPropertyAccessor, 'CssTransformPropertyAccessor', UIElementPropertyAccessor.$);
    return CssTransformPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUICursor_$type = /*@__PURE__*/ markEnum('NativeUICursor', 'Auto,0|Pointer,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssCursorPropertyAccessor = /*@__PURE__*/ (() => {
    class CssCursorPropertyAccessor extends UIElementPropertyAccessor {
        b(a) {
            let b = a;
            let c = b.getStyleProperty("cursor");
            if (c != null) {
                switch (c.toLowerCase()) {
                    case "pointer": return enumGetBox(NativeUICursor_$type, 1);
                }
            }
            return enumGetBox(NativeUICursor_$type, 0);
        }
        c(a, b) {
            let c = a;
            switch (EnumUtil.getEnumValue(NativeUICursor_$type, b)) {
                case 1:
                    c.setStyleProperty("cursor", "pointer");
                    break;
                case 0:
                    c.setStyleProperty("cursor", "auto");
                    break;
            }
        }
    }
    CssCursorPropertyAccessor.$t = /*@__PURE__*/ markType(CssCursorPropertyAccessor, 'CssCursorPropertyAccessor', UIElementPropertyAccessor.$);
    return CssCursorPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssHitTestVisiblePropertyAccessor = /*@__PURE__*/ (() => {
    class CssHitTestVisiblePropertyAccessor extends UIElementPropertyAccessor {
        b(a) {
            let b = a;
            let c = b.getStyleProperty("pointer-events");
            if (c != null) {
                switch (c.toLowerCase()) {
                    case "none": return false;
                    default: return true;
                }
            }
            return true;
        }
        c(a, b) {
            let c = a;
            c.setStyleProperty("pointer-events", b ? "auto" : "none");
        }
    }
    CssHitTestVisiblePropertyAccessor.$t = /*@__PURE__*/ markType(CssHitTestVisiblePropertyAccessor, 'CssHitTestVisiblePropertyAccessor', UIElementPropertyAccessor.$);
    return CssHitTestVisiblePropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Specifies the display state of an element.
 */
var Visibility = /*@__PURE__*/ (function (Visibility) {
    /**
     * Display the element.
     */
    Visibility[Visibility["Visible"] = 0] = "Visible";
    /**
     * Do not display the element.
     */
    Visibility[Visibility["Collapsed"] = 1] = "Collapsed";
    return Visibility;
})({});
/**
 * @hidden
 */
let Visibility_$type = /*@__PURE__*/ markEnum('Visibility', 'Visible,0|Collapsed,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssVisibilityPropertyAccessor = /*@__PURE__*/ (() => {
    class CssVisibilityPropertyAccessor extends UIElementPropertyAccessor {
        b(a) {
            let b = a;
            let c = b.getStyleProperty("visibility");
            if (c != null) {
                switch (c.toLowerCase()) {
                    case "collapse":
                    case "hidden": return enumGetBox(Visibility_$type, 1);
                }
            }
            return enumGetBox(Visibility_$type, 0);
        }
        c(a, b) {
            let c = a;
            c.setStyleProperty("visibility", EnumUtil.getEnumValue(Visibility_$type, b) == 1 ? "collapse" : "visible");
        }
    }
    CssVisibilityPropertyAccessor.$t = /*@__PURE__*/ markType(CssVisibilityPropertyAccessor, 'CssVisibilityPropertyAccessor', UIElementPropertyAccessor.$);
    return CssVisibilityPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UIElementPropertyAccessorFactory = /*@__PURE__*/ (() => {
    class UIElementPropertyAccessorFactory extends Base {
        static get c() {
            if (UIElementPropertyAccessorFactory.b == null) {
                UIElementPropertyAccessorFactory.b = new PlatformUIElementPropertyAccessorFactory();
            }
            return UIElementPropertyAccessorFactory.b;
        }
    }
    UIElementPropertyAccessorFactory.$t = /*@__PURE__*/ markType(UIElementPropertyAccessorFactory, 'UIElementPropertyAccessorFactory');
    UIElementPropertyAccessorFactory.b = null;
    return UIElementPropertyAccessorFactory;
})();
/**
 * @hidden
 */
let PlatformUIElementPropertyAccessorFactory = /*@__PURE__*/ (() => {
    class PlatformUIElementPropertyAccessorFactory extends UIElementPropertyAccessorFactory {
        constructor() {
            super();
        }
        a(a, b) {
            switch (a) {
                case 2:
                case 3:
                case 7:
                case 15:
                case 16: return new CssColorPropertyAccessor(this.d(a));
                case 4:
                case 13:
                case 6: return new CssThicknessPropertyAccessor(this.d(a));
                case 11:
                case 10:
                case 12:
                case 8:
                case 9:
                case 26:
                case 27: return new CssPixelsPropertyAccessor(this.d(a));
                case 17:
                case 19: return new CssLengthPropertyAccessor(this.d(a));
                case 18: return new CssLengthArrayPropertyAccessor(this.d(a));
                case 1: return new CssFloatPropertyAccessor(this.d(a));
                case 5: return new CssCornerRadiusPropertyAccessor(this.d(a));
                case 14: return new CssTransformPropertyAccessor(this.d(a));
                case 20: return new CssCursorPropertyAccessor();
                case 21: return new CssHitTestVisiblePropertyAccessor();
                case 24: return new CssVisibilityPropertyAccessor();
            }
            return null;
        }
        d(a) {
            switch (a) {
                case 2: return "background-color";
                case 3: return "border-color";
                case 7: return "color";
                case 4: return "border-width";
                case 13: return "margin";
                case 6: return "padding";
                case 11: return "left";
                case 10: return "height";
                case 12: return "top";
                case 9: return "width";
                case 5: return "border-radius";
                case 8: return "font-size";
                case 1: return "opacity";
                case 14: return "transform";
                case 15: return "stroke";
                case 16: return "fill";
                case 18: return "stroke-dasharray";
                case 19: return "stroke-dashoffset";
                case 17: return "stroke-width";
                case 26: return "min-width";
                case 27: return "min-height";
            }
            return "";
        }
    }
    PlatformUIElementPropertyAccessorFactory.$t = /*@__PURE__*/ markType(PlatformUIElementPropertyAccessorFactory, 'PlatformUIElementPropertyAccessorFactory', UIElementPropertyAccessorFactory.$);
    return PlatformUIElementPropertyAccessorFactory;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyFrameAnimationTimeline = /*@__PURE__*/ (() => {
    class KeyFrameAnimationTimeline extends Base {
        get b() {
            return this.a;
        }
        get j() {
            if (this.d) {
                return this.i;
            }
            return timeSpanTotalMilliseconds((+(dateNow()) - +(this.h)));
        }
        constructor(a, b) {
            super();
            this.c = null;
            this.a = null;
            this.h = new Date();
            this.g = new LinkedList$1(IKeyFrameAnimation_$type);
            this.f = new Dictionary$2(String_$type, IKeyFrameAnimation_$type, 0);
            this.e = new Dictionary$2(IKeyFrameAnimation_$type, LinkedListNode$1.$.specialize(IKeyFrameAnimation_$type), 0);
            this.k = 0;
            this.d = false;
            this.i = 0;
            this.l = -1;
            this.c = a;
            this.a = b;
            this.h = dateNow();
        }
        m(a) {
            if (this.f.containsKey(a.id)) {
                return;
            }
            this.g.f(a);
            let b = this.g.d;
            this.e.addItem(a, b);
            this.f.addItem(a.id, a);
            let c = false;
            if (this.k == 0) {
                c = true;
            }
            this.k++;
            if (c) {
                this.n();
            }
        }
        o(a) {
            if (!this.e.containsKey(a)) {
                return;
            }
            let b = this.e.item(a);
            this.g.h(b);
            this.f.removeItem(a.id);
            this.e.removeItem(a);
            let c = false;
            this.k--;
            if (this.k == 0) {
                c = true;
            }
            if (c) {
                this.p();
            }
        }
        p() {
            if (this.l >= 0) {
                this.c.teardownTicking(this.l);
                this.l = -1;
            }
        }
        n() {
            this.l = this.c.setupTicking(runOn(this, this.q));
            this.c.requestFrame(this.l);
        }
        q() {
            let a = this.j;
            this.i = a;
            try {
                this.d = true;
                let b = this.g.c;
                if (b == null) {
                    this.p();
                    this.d = false;
                    return;
                }
                while (b != null) {
                    let c = b.c;
                    if (c.playState == 1) {
                        c.aq();
                    }
                    else {
                        c.aq();
                        this.o(b.c);
                    }
                    b = b.a;
                }
                this.c.requestFrame(this.l);
            }
            finally {
                this.d = false;
            }
        }
    }
    KeyFrameAnimationTimeline.$t = /*@__PURE__*/ markType(KeyFrameAnimationTimeline, 'KeyFrameAnimationTimeline');
    return KeyFrameAnimationTimeline;
})();
/**
 * @hidden
 */
let IKeyFrameAnimation_$type = /*@__PURE__*/ new Type(null, 'IKeyFrameAnimation');
/**
 * @hidden
 */
let KeyFrameAnimationDirect = /*@__PURE__*/ (() => {
    class KeyFrameAnimationDirect extends Base {
        get effect() {
            return this.a;
        }
        set effect(a) {
            this.a = a;
        }
        get l() {
            if (this.d) {
                return true;
            }
            if (this.j) {
                return true;
            }
            return false;
        }
        get currentTime() {
            if (this.d) {
                return this.m;
            }
            return (this.c.j - this.startTime) * this.playbackRate;
        }
        set currentTime(a) {
            this.ar(a);
            this.as(true, false);
        }
        as(a, b) {
            let c;
            let d = false;
            if (!a) {
                let e = this.d;
                this.d = false;
                c = this.currentTime;
                d = this.l;
                this.d = e;
            }
            else {
                c = this.currentTime;
                d = this.l;
            }
            if (d && this.j && !this.f && !this.h) {
                if (this.playbackRate > 0 && c >= this.r) {
                    if (a) {
                        this.m = c;
                        this.d = true;
                    }
                    else {
                        if (this.i) {
                            this.m = Math.max(this.p, this.r);
                        }
                        else {
                            this.m = this.r;
                        }
                    }
                }
                else if (this.playbackRate < 0 && c <= 0) {
                    if (a) {
                        this.m = c;
                    }
                    else {
                        if (this.i) {
                            this.m = Math.min(this.p, 0);
                        }
                        else {
                            this.m = 0;
                        }
                    }
                }
                if (this.playbackRate != 0) {
                    if (a && this.d) {
                        this.q = this.c.j - (this.m / this.playbackRate);
                        this.j = true;
                        this.d = false;
                    }
                }
            }
            this.p = this.currentTime;
            this.i = true;
            let f = this.playState == 3;
            if (!b && f && !this.k()) {
                this.an(() => this.ad());
            }
            if (f && !this.k()) {
                if (b) {
                    this.aa();
                    this.ad();
                }
            }
            if (!f && this.k()) {
                this.v = this.x();
            }
        }
        x() {
            return new TaskCompletionSource$1(IKeyFrameAnimation_$type, 0);
        }
        aa() {
            this.e = false;
        }
        ad() {
            if (!this.e) {
                return;
            }
            this.e = false;
            if (this.playState != 3) {
                return;
            }
            this.al(this);
            this.ah();
        }
        ah() {
        }
        al(a) {
            this.v.e(a);
        }
        an(a) {
            if (!this.e) {
                this.e = true;
                this.c.b.enqueueAction(() => a());
            }
        }
        k() {
            return this.v == null || this.v.b.c;
        }
        ar(a) {
            if (this.d || !this.j || this.playbackRate == 0) {
                this.m = a;
                this.d = true;
            }
            else {
                this.q = this.c.j - (a / this.playbackRate);
            }
        }
        get finished() {
            return this.v != null ? this.v.b : null;
        }
        get ready() {
            return this.w != null ? this.w.b : null;
        }
        get id() {
            return this.u;
        }
        set id(a) {
            this.u = a;
        }
        get r() {
            return this.effect != null ? this.effect.as : 0;
        }
        get playState() {
            if (!this.l && !this.f && !this.h) {
                return 0;
            }
            else if (this.f || (!this.j && !this.h)) {
                return 2;
            }
            else if (this.l && (this.s > 0 && this.currentTime >= this.r || this.s < 0 && this.currentTime <= 0)) {
                return 3;
            }
            return 1;
        }
        get s() {
            if (this.g) {
                return this.n;
            }
            return this.o;
        }
        get playbackRate() {
            return this.o;
        }
        set playbackRate(a) {
            this.o = a;
        }
        get startTime() {
            return this.q;
        }
        set startTime(a) {
            let b = this.c.j;
            let c = this.p;
            this.q = a;
            this.j = true;
            if (this.playbackRate != 0) {
                this.d = false;
            }
            this.as(true, false);
        }
        get c() {
            return this.b;
        }
        constructor(a, b) {
            super();
            this.a = null;
            this.m = NaN;
            this.d = false;
            this.p = NaN;
            this.i = false;
            this.u = null;
            this.n = NaN;
            this.g = false;
            this.o = 1;
            this.q = NaN;
            this.j = false;
            this.b = null;
            this.onFinished = null;
            this.onCanceled = null;
            this.h = false;
            this.f = false;
            this.e = false;
            this.w = null;
            this.v = null;
            this.u = "AUTO_ID_" + KeyFrameAnimationDirect.t.toString();
            KeyFrameAnimationDirect.t++;
            this.effect = a;
            this.effect.r = this;
            this.b = b;
        }
        cancel() {
            if (this.playState != 0) {
                this.ak();
                this.ai("AbortError");
                this.v = this.x();
                this.ag();
                this.d = false;
                this.j = false;
            }
        }
        ai(a) {
            if (this.v != null) {
                this.v.d(new BaseError(1, a));
            }
        }
        aj(a) {
            if (this.w != null) {
                this.w.d(new BaseError(1, a));
            }
        }
        ag() {
        }
        ak() {
            if (this.h) {
                this.h = false;
            }
            if (this.f) {
                this.f = false;
            }
            this.z();
            this.aj("AbortError");
        }
        finish() {
            if (this.s == 0 || (this.s > 0 && isInfinity(this.r))) {
                return;
            }
            this.z();
            let a;
            if (this.playbackRate > 0) {
                a = this.r;
            }
            else {
                a = 0;
            }
            this.ar(a);
            if (!this.j) {
                this.q = this.c.j - (a / this.playbackRate);
                this.j = true;
            }
            if (this.f && this.j) {
                this.d = false;
                this.ab();
                this.am(this);
            }
            if (this.h && this.j) {
                this.ac();
                this.am(this);
            }
            this.as(true, true);
        }
        pause() {
            this.ae();
        }
        ae() {
            if (this.f) {
                return;
            }
            if (this.playState == 2) {
                return;
            }
            if (!this.l) {
                if (this.playbackRate >= 0) {
                    this.d = true;
                    this.m = 0;
                }
                if (isInfinity(this.r)) {
                    return;
                }
                this.m = this.r;
                this.d = true;
            }
            let a = false;
            if (this.h) {
                a = true;
            }
            if (!a) {
                this.w = this.y();
            }
            this.ao(() => {
                if (!this.f) {
                    return;
                }
                this.f = false;
                let b = this.c.j;
                if (this.j && !this.d) {
                    this.m = (b - this.q) * this.playbackRate;
                }
                this.z();
                this.j = false;
                this.am(this);
                this.as(false, false);
            });
            this.as(false, false);
        }
        y() {
            return new TaskCompletionSource$1(IKeyFrameAnimation_$type, 0);
        }
        ao(a) {
            if (!this.f) {
                this.f = true;
                this.c.b.enqueueAction(() => a());
            }
        }
        play() {
            this.af(true);
        }
        af(a) {
            let b = this.f;
            if (this.s > 0 && a && (!this.l || this.currentTime < 0 || this.currentTime >= this.r)) {
                this.m = 0;
                this.d = true;
            }
            else if (this.s < 0 && a && (!this.l || this.currentTime <= 0 || this.currentTime > this.r)) {
                if (isInfinity(this.r)) {
                    return;
                }
                this.m = this.r;
                this.d = true;
            }
            else if (this.s == 0 && !this.l) {
                this.m = 0;
                this.d = true;
            }
            let c = false;
            if (this.f) {
                this.ab();
                c = true;
            }
            if (this.h) {
                this.ac();
                c = true;
            }
            if (!this.d && !b && !this.g) {
                return;
            }
            if (this.d) {
                this.j = false;
            }
            if (!c) {
                this.w = this.y();
            }
            this.ap(() => {
                if (!this.h) {
                    return;
                }
                this.h = false;
                if (!this.j && !this.d) {
                    return;
                }
                let d = this.c.j;
                if (this.d) {
                    this.z();
                    let e = d;
                    if (this.playbackRate != 0) {
                        e = d - this.m / this.playbackRate;
                    }
                    this.q = e;
                    this.j = true;
                    if (this.playbackRate != 0) {
                        this.d = false;
                    }
                }
                else if (this.j && this.g) {
                    let f = (d - this.q) * this.playbackRate;
                    this.z();
                    if (this.playbackRate == 0) {
                        this.m = f;
                        this.d = true;
                    }
                    let g = d;
                    if (this.playbackRate != 0) {
                        g = d - f / this.playbackRate;
                    }
                    this.q = g;
                    this.j = true;
                }
                this.am(this);
                this.as(false, false);
                this.c.m(this);
            });
            this.as(false, false);
        }
        am(a) {
            if (this.w != null) {
                this.w.e(a);
                this.w = null;
            }
        }
        ab() {
            this.f = false;
        }
        ac() {
            this.h = false;
        }
        ap(a) {
            if (!this.h) {
                this.h = true;
                this.c.b.enqueueAction(() => a());
            }
        }
        reverse() {
            let a = this.n;
            this.n = -this.s;
            this.g = true;
            this.af(true);
        }
        updatePlaybackRate(a) {
            let b = this.playState;
            this.n = a;
            this.g = true;
            if (b == 0 || b == 2) {
                this.z();
            }
            else if (b == 3) {
                let c = this.d;
                this.d = false;
                let d = this.currentTime;
                this.d = c;
                if (this.n == 0) {
                    this.q = this.c.j;
                }
                else {
                    this.q = this.c.j - (d / this.n);
                }
                this.z();
            }
            else {
                this.af(false);
            }
        }
        z() {
            if (this.g) {
                this.o = this.n;
                this.g = false;
            }
        }
        commitStyles() {
            this.effect.a6();
        }
        aq() {
            this.effect.a7();
            this.as(false, false);
        }
    }
    KeyFrameAnimationDirect.$t = /*@__PURE__*/ markType(KeyFrameAnimationDirect, 'KeyFrameAnimationDirect', Base.$, [IKeyFrameAnimation_$type]);
    KeyFrameAnimationDirect.t = 0;
    return KeyFrameAnimationDirect;
})();
/**
 * @hidden
 */
let AnimationKeyFrameEffect = /*@__PURE__*/ (() => {
    class AnimationKeyFrameEffect extends Base {
        get an() {
            return this.aj * this.ai;
        }
        get as() {
            return Math.max(this.al + this.an + this.ah, 0);
        }
        a8() {
            this.al = this.p.f;
            this.ah = this.p.h;
            this.t = this.p.a;
            this.ai = this.p.i;
            this.aj = this.p.g;
            this.v = this.p.c;
            this.ak = this.p.j;
            this.u = this.p.b;
            this.az = this.a0(this.u);
        }
        a0(a) {
            switch (a) {
                case 3: return (b) => b;
                case 1: return EasingFunctions.exponentialEase;
                case 2: return EasingFunctions.circleEase;
                case 0: return EasingFunctions.cubicEase;
            }
            return (b) => b;
        }
        constructor(a, ..._rest) {
            super();
            this.r = null;
            this.a4 = null;
            this.o = 0;
            this.q = null;
            this.ag = new List$1(AnimationKeyFrame.$, 0);
            this.c = null;
            this.al = 0;
            this.ah = 0;
            this.az = null;
            this.t = 0;
            this.ai = 0;
            this.aj = 0;
            this.v = 0;
            this.ak = 0;
            this.u = 0;
            this.d = null;
            this.a = null;
            this.b = null;
            this.p = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        this.a4 = c;
                        this.o = d;
                        this.p = f;
                        this.a8();
                        this.q = e;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        this.a4 = c;
                        this.o = d;
                        this.q = e;
                        this.p = f;
                        this.a8();
                        this.ag.o(g);
                    }
                    break;
            }
        }
        get k() {
            if (this.d == null) {
                this.d = this.e();
            }
            return this.d;
        }
        e() {
            let a = this.h;
            if (a.length <= 1) {
                return [0];
            }
            let b = new Array(a.length);
            let c = 1 / (a.length - 1);
            let d = 0;
            for (let e = 0; e < a.length; e++) {
                if (isNaN_(a[e].j)) {
                    b[e] = d;
                }
                else {
                    b[e] = a[e].j;
                    d = a[e].j;
                    if (((a.length - 1) - e) > 0) {
                        c = (1 - d) / ((a.length - 1) - e);
                    }
                }
                d += c;
            }
            return b;
        }
        l(a) {
            this.ag.add(a);
            this.c = null;
            this.a = null;
            return this;
        }
        m(...a) {
            let b = new AnimationKeyFrame(0);
            if (a != null) {
                for (let c = 0; c < a.length; c++) {
                    b.c(a[c]);
                }
            }
            this.l(b);
            return this;
        }
        n(a, ...b) {
            let c = new AnimationKeyFrame(1, a);
            if (b != null) {
                for (let d = 0; d < b.length; d++) {
                    c.c(b[d]);
                }
            }
            this.l(c);
            return this;
        }
        get au() {
            if (this.r != null) {
                return this.r.currentTime;
            }
            return NaN;
        }
        get ac() {
            if (this.r != null) {
                return this.r.l;
            }
            return false;
        }
        get ap() {
            return Math.max(Math.min(this.al, this.as), 0);
        }
        get am() {
            return Math.max(Math.min(this.al + this.an, this.as), 0);
        }
        get w() {
            if (this.r != null && this.r.playbackRate < 0) {
                return false;
            }
            return true;
        }
        get s() {
            if (this.ac && (this.au < this.ap || !this.w && this.au == this.ap)) {
                return 0;
            }
            if (this.ac && (this.au > this.am || this.w && this.au == this.am)) {
                return 2;
            }
            if (this.ac) {
                return 1;
            }
            return 3;
        }
        get ao() {
            let a = this.s;
            switch (a) {
                case 0: if (this.t == 3 || this.t == 4) {
                    return Math.max(this.au - this.al, 0);
                }
                else {
                    return NaN;
                }
                case 1: return this.au - this.al;
                case 2: if (this.t == 2 || this.t == 4) {
                    return Math.max(Math.min(this.au - this.al, this.an), 0);
                }
                else {
                    return NaN;
                }
                default: return NaN;
            }
        }
        get y() {
            if (!this.ac) {
                return false;
            }
            let a = this.s;
            switch (a) {
                case 0: if (this.t == 3 || this.t == 4) {
                    return true;
                }
                else {
                    return false;
                }
                case 1: return true;
                case 2: if (this.t == 2 || this.t == 4) {
                    return true;
                }
                else {
                    return false;
                }
                default: return false;
            }
            return false;
        }
        get ad() {
            if (!this.y) {
                return false;
            }
            return true;
        }
        get av() {
            if (!this.y) {
                return NaN;
            }
            let a = 0;
            if (this.aj == 0) {
                if (this.s == 0) {
                    a = 0;
                }
                else {
                    a = this.ai;
                }
            }
            else {
                a = this.ao / this.aj;
            }
            return a + this.ak;
        }
        get ae() {
            if (!this.ad) {
                return false;
            }
            return true;
        }
        get aw() {
            if (!this.ad) {
                return NaN;
            }
            let a = 1;
            if (isInfinity(this.av)) {
                a = this.ak % 1;
            }
            else {
                a = this.av % 1;
            }
            if (a == 0 && (this.s == 1 || this.s == 2) && this.ao == this.an && this.ai != 0) {
                a = 1;
            }
            return a;
        }
        get z() {
            if (!this.y) {
                return false;
            }
            return true;
        }
        get aq() {
            if (!this.y) {
                return NaN;
            }
            if (this.s == 2 && isInfinity(this.ai)) {
                return Number.POSITIVE_INFINITY;
            }
            if (this.aw == 1) {
                return Math.floor(this.av) - 1;
            }
            return Math.floor(this.av);
        }
        get aa() {
            return this.ae;
        }
        get ar() {
            if (!this.ae) {
                return NaN;
            }
            let a = this.x();
            if (a) {
                return this.aw;
            }
            else {
                return 1 - this.aw;
            }
        }
        x() {
            let a = true;
            if (this.v == 0) {
                a = true;
            }
            else if (this.v == 1) {
                a = false;
            }
            else {
                let b = this.aq;
                if (this.v == 3) {
                    b++;
                }
                if (isInfinity(b)) {
                    a = true;
                }
                else {
                    if (b % 2 == 0) {
                        a = true;
                    }
                    else {
                        a = false;
                    }
                }
            }
            return a;
        }
        get af() {
            return this.aa;
        }
        get ay() {
            if (!this.aa) {
                return NaN;
            }
            let a = false;
            let b = this.x();
            if (b && this.s == 0) {
                a = true;
            }
            if (!b && this.s == 2) {
                a = true;
            }
            return this.ax(this.ar, a);
        }
        get at() {
            return this.ay;
        }
        get ab() {
            return this.af;
        }
        ax(a, b) {
            return this.az(a);
        }
        a7() {
            if (!this.af) {
                return;
            }
            let a = this.ay;
            for (let b = 0; b < this.f.length; b++) {
                let c = this.a1(this.f[b], this.g[b]);
                this.a5(this.f[b], this.g[b], c);
            }
        }
        a5(a, b, c) {
            b.c(this.a4, c);
        }
        a1(a, b) {
            if (!this.ab) {
                return null;
            }
            let c = a;
            let d = this.at;
            if (this.a4 == null) {
                return null;
            }
            let e = this.a2(c, b);
            let f = new List$1(AnimationKeyFrame.$, 0);
            let g = new List$1(Number_$type, 0);
            for (let h = 0; h < this.h.length; h++) {
                for (let i = 0; i < this.h[h].b.length; i++) {
                    if (this.h[h].b[i].a == c) {
                        f.add(this.h[h]);
                        g.add(this.k[h]);
                    }
                }
            }
            if (f.count == 0) {
                return e;
            }
            if (g._inner[0] != 0) {
                f.insert(0, new AnimationKeyFrame(1, 0).c(new AnimationKeyFrameProperty(c, e)));
                g.insert(0, 0);
            }
            if (g._inner[f.count - 1] != 1) {
                f.add(new AnimationKeyFrame(1, 1).c(new AnimationKeyFrameProperty(c, e)));
                g.add(1);
            }
            let j = false;
            let k = new List$1(AnimationKeyFrame.$, 0);
            let l = new List$1(Number_$type, 0);
            if (d < 0) {
                let m = 0;
                for (let n = 0; n < f.count; n++) {
                    if (g._inner[n] == 0) {
                        m++;
                    }
                    else {
                        break;
                    }
                }
                if (m > 1) {
                    j = true;
                    k.add(f._inner[0]);
                    l.add(g._inner[0]);
                }
            }
            if (d >= 1) {
                let o = 0;
                for (let p = f.count - 1; p >= 0; p--) {
                    if (g._inner[p] == 1) {
                        o++;
                    }
                    else {
                        break;
                    }
                }
                if (o > 1) {
                    j = true;
                    k.add(f._inner[f.count - 1]);
                    l.add(g._inner[f.count - 1]);
                }
            }
            if (!j) {
                let q = null;
                let r = -1;
                for (let s = 0; s < f.count; s++) {
                    if (g._inner[s] <= d) {
                        q = f._inner[s];
                        r = s;
                    }
                    else {
                        break;
                    }
                }
                if (r == -1) {
                    for (let t = 0; t < f.count; t++) {
                        if (g._inner[t] == 0) {
                            q = f._inner[t];
                            r = t;
                        }
                        else {
                            break;
                        }
                    }
                }
                k.add(q);
                l.add(g._inner[r]);
                if (r < g.count - 1) {
                    k.add(f._inner[r + 1]);
                    l.add(g._inner[r + 1]);
                }
            }
            if (k.count == 1) {
                for (let u = 0; u < k._inner[0].b.length; u++) {
                    if (k._inner[0].b[u].a == c) {
                        return k._inner[0].b[u].d;
                    }
                }
                return null;
            }
            let v = l._inner[0];
            let w = l._inner[k.count - 1];
            let x = k._inner[0].g(c).d;
            let y = k._inner[1].g(c).d;
            let z = (d - v) / (w - v);
            return this.a3(c, z, x, y);
        }
        a3(a, b, c, d) {
            switch (a) {
                case 2:
                case 3:
                case 7:
                case 15:
                case 16: return BrushUtil.l(c, b, d, 0);
                case 4:
                case 13:
                case 6: return InterpolationUtil.g(b, c, d);
                case 11:
                case 10:
                case 12:
                case 8:
                case 9:
                case 17:
                case 19:
                case 22:
                case 23: return c + b * (d - c);
                case 1: return c + b * (d - c);
                case 5: return InterpolationUtil.e(b, c, d);
                case 14: return this.a9(b, c, d);
                case 18: return InterpolationUtil.b(b, c, d);
                default: if (b < 0.5) {
                    return c;
                }
                else {
                    return d;
                }
            }
            return null;
        }
        a9(a, b, c) {
            let d = TransformMatrixHelpler.d(a, b.j, c.j);
            let e = new MatrixTransform();
            e.j = d;
            return e;
        }
        a2(a, b) {
            return b.b(this.a4);
        }
        get h() {
            if (this.c == null) {
                this.c = this.ag.toArray();
                this.a = this.i();
                this.b = this.j();
            }
            return this.c;
        }
        get f() {
            if (this.c == null) {
                this.c = this.ag.toArray();
                this.a = this.i();
                this.b = this.j();
            }
            return this.a;
        }
        get g() {
            if (this.c == null) {
                this.c = this.ag.toArray();
                this.a = this.i();
                this.b = this.j();
            }
            return this.b;
        }
        j() {
            let a = new List$1(UIElementPropertyAccessor.$, 0);
            for (let b = 0; b < this.f.length; b++) {
                a.add(UIElementPropertyAccessorFactory.c.a(this.f[b], this.o));
            }
            return a.toArray();
        }
        i() {
            let a = new List$1(UIElementPropertyId_$type, 0);
            let b = new HashSet$1(UIElementPropertyId_$type, 0);
            for (let c = 0; c < this.h.length; c++) {
                for (let d = 0; d < this.h[c].b.length; d++) {
                    if (!b.contains(this.h[c].b[d].a)) {
                        b.add_1(this.h[c].b[d].a);
                        a.add(this.h[c].b[d].a);
                    }
                }
            }
            return a.toArray();
        }
        a6() {
            let a = this.t;
            this.t = 4;
            this.a7();
            this.t = a;
        }
    }
    AnimationKeyFrameEffect.$t = /*@__PURE__*/ markType(AnimationKeyFrameEffect, 'AnimationKeyFrameEffect');
    return AnimationKeyFrameEffect;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationBrowserTickProvider = /*@__PURE__*/ (() => {
    class AnimationBrowserTickProvider extends Base {
        get requestAnimationFrame() {
            return this._requestAnimationFrame;
        }
        set requestAnimationFrame(a) {
            this._requestAnimationFrame = a;
        }
        constructor(a) {
            super();
            this.e = 0;
            this.c = null;
            this._requestAnimationFrame = null;
            this.d = new List$1(Delegate_$type, 0);
            this.b = false;
            this.requestAnimationFrame = a.getRequestAnimationFrame();
            this.c = new Dictionary$2(Number_$type, Delegate_$type, 0);
        }
        f() {
            this.b = false;
            this.d.clear();
            for (let a of fromEnum(this.c.values)) {
                this.d.add(a);
            }
            for (let b = 0; b < this.d.count; b++) {
                this.d._inner[b]();
            }
            this.d.clear();
        }
        setupTicking(a) {
            let b = this.e;
            this.e++;
            this.c.item(b, a);
            return b;
        }
        requestFrame(a) {
            if (this.b) {
                return;
            }
            this.b = true;
            this.requestAnimationFrame(runOn(this, this.f));
        }
        teardownTicking(a) {
            if (this.c.containsKey(a)) {
                this.c.removeItem(a);
            }
        }
    }
    AnimationBrowserTickProvider.$t = /*@__PURE__*/ markType(AnimationBrowserTickProvider, 'AnimationBrowserTickProvider', Base.$, [ITickProvider_$type]);
    return AnimationBrowserTickProvider;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IExecutionContext_$type = /*@__PURE__*/ new Type(null, 'IExecutionContext');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DOMExecutionContext = /*@__PURE__*/ (() => {
    class DOMExecutionContext extends Base {
        constructor(a) {
            super();
            this.c = 0;
            this.b = null;
            this._requestAnimationFrame = null;
            this.b = a;
            this.requestAnimationFrame = a.getRequestAnimationFrame();
            this.c = dateNow().getTime();
        }
        get requestAnimationFrame() {
            return this._requestAnimationFrame;
        }
        set requestAnimationFrame(a) {
            this._requestAnimationFrame = a;
        }
        execute(a) {
            a();
        }
        enqueueAction(a) {
            this.b.setTimeout(a, 0);
        }
        enqueueAnimationAction(a) {
            this.requestAnimationFrame(a);
        }
        executeDelayed(a, b) {
            this.b.setTimeout(a, b);
        }
        getCurrentRelativeTime() {
            return dateNow().getTime() - this.c;
        }
    }
    DOMExecutionContext.$t = /*@__PURE__*/ markType(DOMExecutionContext, 'DOMExecutionContext', Base.$, [IExecutionContext_$type]);
    return DOMExecutionContext;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyFrameAnimationFactory = /*@__PURE__*/ (() => {
    class KeyFrameAnimationFactory extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.g = null;
        }
        static get f() {
            if (KeyFrameAnimationFactory.e == null) {
                KeyFrameAnimationFactory.e = new PlatformKeyFrameAnimationFactory(KeyFrameAnimationFactory.h);
                KeyFrameAnimationFactory.e.g = new KeyFrameAnimationTimeline(KeyFrameAnimationFactory.e.d, KeyFrameAnimationFactory.e.b);
            }
            return KeyFrameAnimationFactory.e;
        }
        c(a) {
            return new KeyFrameAnimationDirect(a, this.g);
        }
    }
    KeyFrameAnimationFactory.$t = /*@__PURE__*/ markType(KeyFrameAnimationFactory, 'KeyFrameAnimationFactory');
    KeyFrameAnimationFactory.e = null;
    KeyFrameAnimationFactory.h = null;
    return KeyFrameAnimationFactory;
})();
/**
 * @hidden
 */
let PlatformKeyFrameAnimationFactory = /*@__PURE__*/ (() => {
    class PlatformKeyFrameAnimationFactory extends KeyFrameAnimationFactory {
        constructor(a) {
            super();
            this.j = null;
            this.i = null;
            this.j = new AnimationBrowserTickProvider(a);
            this.i = new DOMExecutionContext(a);
        }
        get_d() {
            return this.j;
        }
        get d() {
            return this.get_d();
        }
        get_b() {
            return this.i;
        }
        get b() {
            return this.get_b();
        }
    }
    PlatformKeyFrameAnimationFactory.$t = /*@__PURE__*/ markType(PlatformKeyFrameAnimationFactory, 'PlatformKeyFrameAnimationFactory', KeyFrameAnimationFactory.$);
    return PlatformKeyFrameAnimationFactory;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ElevationHelper = /*@__PURE__*/ (() => {
    class ElevationHelper extends Base {
        static g(a, b) {
            if (ElevationHelper.c == null) {
                ElevationHelper.c = ["0 1px 3px 0 ", "0 1px 5px 0 ", "0 1px 8px 0 ", "0 2px 4px -1px ", "0 3px 5px -1px ", "0 3px 5px -1px ", "0 4px 5px -2px ", "0 5px 5px -3px ", "0 5px 6px -3px ", "0 6px 6px -3px ", "0 6px 7px -4px ", "0 7px 8px -4px ", "0 7px 8px -4px ", "0 7px 9px -4px ", "0 8px 9px -5px ", "0 8px 10px -5px ", "0 8px 11px -5px ", "0 9px 11px -5px ", "0 9px 12px -6px ", "0 10px 13px -6px ", "0 10px 13px -6px ", "0 10px 14px -6px ", "0 11px 14px -7px ", "0 11px 15px -7px "];
            }
            a--;
            if (a < 0) {
                return "";
            }
            if (a > ElevationHelper.c.length - 1) {
                a = ElevationHelper.c.length - 1;
            }
            return ElevationHelper.c[a] + b;
        }
        static f(a, b) {
            if (ElevationHelper.b == null) {
                ElevationHelper.b = ["0 1px 1px 0 ", "0 2px 2px 0 ", "0 3px 4px 0 ", "0 4px 5px 0 ", "0 5px 8px 0 ", "0 6px 10px 0 ", "0 7px 10px 1px ", "0 8px 10px 1px ", "0 9px 12px 1px ", "0 10px 14px 1px ", "0 11px 15px 1px ", "0 12px 17px 2px ", "0 13px 19px 2px ", "0 14px 21px 2px ", "0 15px 22px 2px ", "0 16px 24px 2px ", "0 17px 26px 2px ", "0 18px 28px 2px ", "0 19px 29px 2px ", "0 20px 31px 3px ", "0 21px 33px 3px ", "0 22px 35px 3px ", "0 23px 36px 3px ", "0 24px 38px 3px "];
            }
            a--;
            if (a < 0) {
                return "";
            }
            if (a > ElevationHelper.b.length - 1) {
                a = ElevationHelper.b.length - 1;
            }
            return ElevationHelper.b[a] + b;
        }
        static d(a, b) {
            if (ElevationHelper.a == null) {
                ElevationHelper.a = ["0 2px 1px -1px ", "0 3px 1px -2px ", "0 3px 3px -2px ", "0 1px 10px 0 ", "0 1px 14px 0 ", "0 1px 18px 0 ", "0 2px 16px 1px ", "0 3px 14px 2px ", "0 3px 16px 2px ", "0 4px 18px 3px ", "0 4px 20px 3px ", "0 5px 22px 4px ", "0 5px 24px 4px ", "0 5px 26px 4px ", "0 6px 28px 5px ", "0 6px 30px 5px ", "0 6px 32px 5px ", "0 7px 34px 6px ", "0 7px 36px 6px ", "0 8px 38px 7px ", "0 8px 40px 7px ", "0 8px 42px 7px ", "0 9px 44px 8px ", "0 9px 46px 8px "];
            }
            a--;
            if (a < 0) {
                return "";
            }
            if (a > ElevationHelper.a.length - 1) {
                a = ElevationHelper.a.length - 1;
            }
            return ElevationHelper.a[a] + b;
        }
        static e(a, b, c, d) {
            if (a == 0) {
                return "";
            }
            return ElevationHelper.g(a, b._fill) + ", " + ElevationHelper.f(a, c._fill) + ", " + ElevationHelper.d(a, d._fill);
        }
    }
    ElevationHelper.$t = /*@__PURE__*/ markType(ElevationHelper, 'ElevationHelper');
    ElevationHelper.c = null;
    ElevationHelper.b = null;
    ElevationHelper.a = null;
    return ElevationHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for setting direction of linear gradient brush or a radial gradient brush
 */
var GradientDirection = /*@__PURE__*/ (function (GradientDirection) {
    /**
     * Specifies from top to bottom direction of gradient brush
     */
    GradientDirection[GradientDirection["TopBottom"] = 0] = "TopBottom";
    /**
     * Specifies from bottom to top direction of gradient brush
     */
    GradientDirection[GradientDirection["BottomTop"] = 1] = "BottomTop";
    /**
     * Specifies from left to right direction of gradient brush
     */
    GradientDirection[GradientDirection["LeftRight"] = 2] = "LeftRight";
    /**
     * Specifies from right to left direction of gradient brush
     */
    GradientDirection[GradientDirection["RightLeft"] = 3] = "RightLeft";
    /**
     * Specifies radial gradient brush
     */
    GradientDirection[GradientDirection["Radial"] = 4] = "Radial";
    return GradientDirection;
})({});
/**
 * @hidden
 */
let GradientDirection_$type = /*@__PURE__*/ markEnum('GradientDirection', 'TopBottom,0|BottomTop,1|LeftRight,2|RightLeft,3|Radial,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISupportsAnimation_$type = /*@__PURE__*/ new Type(null, 'ISupportsAnimation');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISupportsInput_$type = /*@__PURE__*/ new Type(null, 'ISupportsInput');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VersionQueueAction = /*@__PURE__*/ (() => {
    class VersionQueueAction extends Base {
        constructor(a, b) {
            super();
            this.c = 0;
            this.a = null;
            this.a = a;
            this.c = b;
        }
        get d() {
            return this.c;
        }
        get b() {
            return this.a;
        }
    }
    VersionQueueAction.$t = /*@__PURE__*/ markType(VersionQueueAction, 'VersionQueueAction');
    return VersionQueueAction;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VersionQueueHelper = /*@__PURE__*/ (() => {
    class VersionQueueHelper extends Base {
        constructor() {
            super(...arguments);
            this.b = new List$1(VersionQueueAction.$, 0);
            this.c = 0;
        }
        e() {
            if (this.c >= 0x7FFFFFFF - 1) {
                this.c = 0;
            }
            else {
                this.c++;
            }
            let a = new List$1(VersionQueueAction.$, 0);
            for (let b = 0; b < this.b.count; b++) {
                if (this.a(this.b._inner[b].d)) {
                    a.add(this.b._inner[b]);
                }
            }
            for (let c = 0; c < a.count; c++) {
                this.b.remove(a._inner[c]);
            }
            for (let d = 0; d < a.count; d++) {
                a._inner[d].b();
            }
        }
        d() {
            return this.c;
        }
        f(a, b) {
            if (this.a(b)) {
                a();
                return;
            }
            this.b.add(new VersionQueueAction(a, b));
        }
        a(a) {
            if (this.c > a) {
                return true;
            }
            if (this.c >= 0x7FFFFFFF - 1 && a < 0x7FFFFFFF - 1) {
                return true;
            }
            return false;
        }
    }
    VersionQueueHelper.$t = /*@__PURE__*/ markType(VersionQueueHelper, 'VersionQueueHelper');
    return VersionQueueHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyFrameAnimationPlayState_$type = /*@__PURE__*/ markEnum('KeyFrameAnimationPlayState', 'Idle,0|Running,1|Paused,2|Finished,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationKeyFrameEffectTiming = /*@__PURE__*/ (() => {
    class AnimationKeyFrameEffectTiming extends Base {
        constructor() {
            super();
            this.f = 0;
            this.c = 0;
            this.g = 0;
            this.b = 0;
            this.h = 0;
            this.a = 0;
            this.j = 0;
            this.i = 0;
            this.onFinished = null;
            this.onCanceled = null;
            this.f = 0;
            this.c = 0;
            this.b = 3;
            this.h = 0;
            this.a = 0;
            this.j = 0;
            this.i = 1;
        }
    }
    AnimationKeyFrameEffectTiming.$t = /*@__PURE__*/ markType(AnimationKeyFrameEffectTiming, 'AnimationKeyFrameEffectTiming');
    return AnimationKeyFrameEffectTiming;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyFrameAnimationFill_$type = /*@__PURE__*/ markEnum('KeyFrameAnimationFill', 'Auto,0|None,1|Forwards,2|Backwards,3|Both,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyFrameEffectEasing_$type = /*@__PURE__*/ markEnum('KeyFrameEffectEasing', 'CubicInOut,0|ExponentialInOut,1|CircleInOut,2|Linear,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyFrameEffectTimingDirection_$type = /*@__PURE__*/ markEnum('KeyFrameEffectTimingDirection', 'Normal,0|Reverse,1|Alternate,2|AlternateReverse,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationKeyFrameEffectTargetType_$type = /*@__PURE__*/ markEnum('AnimationKeyFrameEffectTargetType', 'NativeView,0|FrameworkElement,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDependentRenderer_$type = /*@__PURE__*/ new Type(null, 'IDependentRenderer');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyFrameAnimationEffectPhase_$type = /*@__PURE__*/ markEnum('KeyFrameAnimationEffectPhase', 'Before,0|Active,1|After,2|Idle,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushCollectionUtil = /*@__PURE__*/ (() => {
    class BrushCollectionUtil extends Base {
        static b(a, b) {
            if (isNaN_(b)) {
                return null;
            }
            b = MathUtil.d(b, 0, a.count - 1);
            let c = truncate(Math.floor(b));
            if (c == b) {
                return a.item(c);
            }
            return BrushCollectionUtil.c(b - c, a.item(c), a.item(c + 1), a.af);
        }
        static c(a, b, c, d) {
            let e = b.color;
            let f = c.color;
            let g = ColorUtil.w(e, a, f, d);
            let h = new Brush();
            h.color = g;
            return h;
        }
        static a(a) {
            let b = new BrushCollection();
            for (let c of fromEnum(a)) {
                let d = ColorUtil.p(c);
                if (d != null) {
                    b.add(d);
                }
            }
            return b;
        }
    }
    BrushCollectionUtil.$t = /*@__PURE__*/ markType(BrushCollectionUtil, 'BrushCollectionUtil');
    return BrushCollectionUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

class IgrContentChildCollection extends IgCollection {
    constructor(list) {
        super();
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        let coll = new SyncableObservableCollection$2(Base.$type, Base.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ContentChildCollection = /*@__PURE__*/ (() => {
    class ContentChildCollection extends ObservableCollection$1 {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(Base.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(Base.$, 1, c);
                    }
                    break;
            }
        }
    }
    ContentChildCollection.$t = /*@__PURE__*/ markType(ContentChildCollection, 'ContentChildCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(Base.$));
    return ContentChildCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoubleValueChangedEventArgs = /*@__PURE__*/ (() => {
    class DoubleValueChangedEventArgs extends EventArgs {
        constructor(a, b) {
            super();
            this._oldValue = 0;
            this._newValue = 0;
            this.oldValue = a;
            this.newValue = b;
        }
        get oldValue() {
            return this._oldValue;
        }
        set oldValue(a) {
            this._oldValue = a;
        }
        get newValue() {
            return this._newValue;
        }
        set newValue(a) {
            this._newValue = a;
        }
    }
    DoubleValueChangedEventArgs.$t = /*@__PURE__*/ markType(DoubleValueChangedEventArgs, 'DoubleValueChangedEventArgs', EventArgs.$);
    return DoubleValueChangedEventArgs;
})();

/**
 * Provides data for double value change events.
*/
class IgrDoubleValueChangedEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets the value before the change.
    */
    get oldValue() {
        return this.i.oldValue;
    }
    set oldValue(v) {
        this.i.oldValue = +v;
    }
    /**
     * Gets the new value.
    */
    get newValue() {
        return this.i.newValue;
    }
    set newValue(v) {
        this.i.newValue = +v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for choosing the direction of error bars calculation in scatter series.
 */
var ErrorBarCalculatorReference = /*@__PURE__*/ (function (ErrorBarCalculatorReference) {
    /**
     * Variable X.
     */
    ErrorBarCalculatorReference[ErrorBarCalculatorReference["X"] = 0] = "X";
    /**
     * Variable Y.
     */
    ErrorBarCalculatorReference[ErrorBarCalculatorReference["Y"] = 1] = "Y";
    return ErrorBarCalculatorReference;
})({});
/**
 * @hidden
 */
let ErrorBarCalculatorReference_$type = /*@__PURE__*/ markEnum('ErrorBarCalculatorReference', 'X,0|Y,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of error bar calculators.
 */
var ErrorBarCalculatorType = /*@__PURE__*/ (function (ErrorBarCalculatorType) {
    /**
     * A calculator type that provides a fixed value.
     */
    ErrorBarCalculatorType[ErrorBarCalculatorType["Fixed"] = 0] = "Fixed";
    /**
     * A calculator type that provides a fixed percentage of each input value
     */
    ErrorBarCalculatorType[ErrorBarCalculatorType["Percentage"] = 1] = "Percentage";
    /**
     * A calculator type that provides the input values directly.
     */
    ErrorBarCalculatorType[ErrorBarCalculatorType["Data"] = 2] = "Data";
    /**
     * A calculator type that provides the standard deviation of the input values.
     */
    ErrorBarCalculatorType[ErrorBarCalculatorType["StandardDeviation"] = 3] = "StandardDeviation";
    /**
     * A calculator type that provides the standard error of the input values.
     */
    ErrorBarCalculatorType[ErrorBarCalculatorType["StandardError"] = 4] = "StandardError";
    return ErrorBarCalculatorType;
})({});
/**
 * @hidden
 */
let ErrorBarCalculatorType_$type = /*@__PURE__*/ markEnum('ErrorBarCalculatorType', 'Fixed,0|Percentage,1|Data,2|StandardDeviation,3|StandardError,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IErrorBarCalculator_$type = /*@__PURE__*/ new Type(null, 'IErrorBarCalculator');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available actions that can cause a DataSource event.
 */
var FastItemsSourceEventAction = /*@__PURE__*/ (function (FastItemsSourceEventAction) {
    /**
     * One or more rows were removed from the data source.
     */
    FastItemsSourceEventAction[FastItemsSourceEventAction["Remove"] = 0] = "Remove";
    /**
     * One or more rows were added to the data source.
     */
    FastItemsSourceEventAction[FastItemsSourceEventAction["Insert"] = 1] = "Insert";
    /**
     * One or more rows were replaced in the data source.
     */
    FastItemsSourceEventAction[FastItemsSourceEventAction["Replace"] = 2] = "Replace";
    /**
     * An item property value changed in the data source.
     */
    FastItemsSourceEventAction[FastItemsSourceEventAction["Change"] = 3] = "Change";
    /**
     * The entire data source contents were reset.
     */
    FastItemsSourceEventAction[FastItemsSourceEventAction["Reset"] = 4] = "Reset";
    return FastItemsSourceEventAction;
})({});
/**
 * @hidden
 */
let FastItemsSourceEventAction_$type = /*@__PURE__*/ markEnum('FastItemsSourceEventAction', 'Remove,0|Insert,1|Replace,2|Change,3|Reset,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available highlighting states
 */
var HighlightingState = /*@__PURE__*/ (function (HighlightingState) {
    /**
     * Highlight is transitioning out.
     */
    HighlightingState[HighlightingState["outward"] = 0] = "outward";
    /**
     * Highlight is transitioning in.
     */
    HighlightingState[HighlightingState["inward"] = 1] = "inward";
    /**
     * Highlight is active and not transitioning in or out.
     */
    HighlightingState[HighlightingState["Static"] = 2] = "Static";
    return HighlightingState;
})({});
/**
 * @hidden
 */
let HighlightingState_$type = /*@__PURE__*/ markEnum('HighlightingState', 'Out:outward,0|In:inward,1|Static,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HighlightingInfo = /*@__PURE__*/ (() => {
    class HighlightingInfo extends Base {
        constructor() {
            super();
            this.h = 0;
            this.g = 0;
            this.f = 0;
            this.a = 0;
            this.e = 0;
            this.d = false;
            this.c = false;
            this.b = false;
            this.i = null;
            this.a = HighlightingState.outward;
            this.e = 0;
            this.d = false;
        }
    }
    HighlightingInfo.$t = /*@__PURE__*/ markType(HighlightingInfo, 'HighlightingInfo');
    return HighlightingInfo;
})();

/**
 * Contains contextual information about a highlighting.
*/
class IgrHighlightingInfo {
    createImplementation() {
        return new HighlightingInfo();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * The index of the first highlighted item.
    *
    * You can use `StartIndex` to get or set the first highlighted item for the series.
    */
    get startIndex() {
        return this.i.g;
    }
    set startIndex(v) {
        this.i.g = +v;
    }
    /**
     * The index of the last highlighted item.
    *
    * You can use the `EndIndex` to get or set the last highlighted item for the series.
    */
    get endIndex() {
        return this.i.f;
    }
    set endIndex(v) {
        this.i.f = +v;
    }
    /**
     * The state of the highlighting.
    *
    * You can use the `State` to get or set the transitioning state of the highlighting, between In, Out, or Static.
    */
    get state() {
        return this.i.a;
    }
    set state(v) {
        this.i.a = ensureEnum(HighlightingState_$type, v);
    }
    /**
     * A number between 0 and 1 representing the progress of the highlighting.
    *
    * You can use the `Progress` property to set a number between 0 and 1 representing the progress of the highlighting.
    */
    get progress() {
        return this.i.e;
    }
    set progress(v) {
        this.i.e = +v;
    }
    /**
     * True if this HighlightingInfo represents a marker highlighting.
    *
    * You can set the `IsMarker` to True if the HighlightingInfo represents a marker highlighting. Otherwise set to false.
    */
    get isMarker() {
        return this.i.d;
    }
    set isMarker(v) {
        this.i.d = ensureBool(v);
    }
    /**
     * True if this HighlightingInfo represents a full selection of the data.
    */
    get isFullRange() {
        return this.i.c;
    }
    set isFullRange(v) {
        this.i.c = ensureBool(v);
    }
    /**
     * TODO
    */
    get isExclusive() {
        return this.i.b;
    }
    set isExclusive(v) {
        this.i.b = ensureBool(v);
    }
    /**
     * The context for the highlight.
    */
    get context() {
        return this.i.i;
    }
    set context(v) {
        this.i.i = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IHighlightingManager_$type = /*@__PURE__*/ new Type(null, 'IHighlightingManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HighlightingInfoComparer = /*@__PURE__*/ (() => {
    class HighlightingInfoComparer extends Base {
        equalsC(a, b) {
            if (a == null && b != null) {
                return false;
            }
            if (a != null && b == null) {
                return false;
            }
            return a.d == b.d && a.g == b.g && a.f == b.f && a.i == b.i;
        }
        getHashCodeC(a) {
            let b = 23;
            b = b * 31 + (a.d ? 1 : 0);
            b = b * 31 + a.g;
            b = b * 31 + a.f;
            b = b * 31 + (a.i != null ? Base.getHashCodeStatic(a.i) : 0);
            return b;
        }
    }
    HighlightingInfoComparer.$t = /*@__PURE__*/ markType(HighlightingInfoComparer, 'HighlightingInfoComparer', Base.$, [/*@__PURE__*/ IEqualityComparer$1_$type.specialize(HighlightingInfo.$)]);
    return HighlightingInfoComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HighlightingData = /*@__PURE__*/ (() => {
    class HighlightingData extends Base {
        constructor() {
            super(...arguments);
            this.e = null;
            this.b = 0;
            this.d = 0;
            this.c = 0;
            this.a = 0;
        }
    }
    HighlightingData.$t = /*@__PURE__*/ markType(HighlightingData, 'HighlightingData');
    return HighlightingData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HighlightingManager = /*@__PURE__*/ (() => {
    class HighlightingManager extends Base {
        get executionContext() {
            return this._executionContext;
        }
        set executionContext(a) {
            this._executionContext = a;
        }
        get ensureAnimator() {
            return this._ensureAnimator;
        }
        set ensureAnimator(a) {
            this._ensureAnimator = a;
        }
        get maxHighlightingProgress() {
            return this._maxHighlightingProgress;
        }
        set maxHighlightingProgress(a) {
            this._maxHighlightingProgress = a;
        }
        get sumHighlightingProgress() {
            return this._sumHighlightingProgress;
        }
        set sumHighlightingProgress(a) {
            this._sumHighlightingProgress = a;
        }
        get maxMarkerHighlightingProgress() {
            return this._maxMarkerHighlightingProgress;
        }
        set maxMarkerHighlightingProgress(a) {
            this._maxMarkerHighlightingProgress = a;
        }
        get sumMarkerHighlightingProgress() {
            return this._sumMarkerHighlightingProgress;
        }
        set sumMarkerHighlightingProgress(a) {
            this._sumMarkerHighlightingProgress = a;
        }
        get totalHighlightingProgress() {
            return this._totalHighlightingProgress;
        }
        set totalHighlightingProgress(a) {
            this._totalHighlightingProgress = a;
        }
        get totalHighWaterMark() {
            return this._totalHighWaterMark;
        }
        set totalHighWaterMark(a) {
            this._totalHighWaterMark = a;
        }
        get inProgress() {
            return this._inProgress;
        }
        set inProgress(a) {
            this._inProgress = a;
        }
        get retainMainShapes() {
            return this._retainMainShapes;
        }
        set retainMainShapes(a) {
            this._retainMainShapes = a;
        }
        get isExclusiveHighlight() {
            return this._isExclusiveHighlight;
        }
        set isExclusiveHighlight(a) {
            this._isExclusiveHighlight = a;
        }
        constructor() {
            super();
            this._executionContext = null;
            this._ensureAnimator = null;
            this._maxHighlightingProgress = 0;
            this._sumHighlightingProgress = 0;
            this._maxMarkerHighlightingProgress = 0;
            this._sumMarkerHighlightingProgress = 0;
            this._totalHighlightingProgress = 0;
            this._totalHighWaterMark = 0;
            this._inProgress = false;
            this._retainMainShapes = false;
            this._isExclusiveHighlight = false;
            this.n = 0;
            this.p = 0;
            this.o = 0;
            this.d = new Dictionary$2(HighlightingInfo.$, HighlightingInfo.$, 2, new HighlightingInfoComparer());
            this.h = new List$1(HighlightingInfo.$, 0);
            this.g = new Dictionary$2(HighlightingInfo.$, HighlightingInfo.$, 2, new HighlightingInfoComparer());
            this.i = new List$1(HighlightingInfo.$, 0);
            this.b = false;
            this.c = false;
            this.r = 0;
            this.q = 0;
            this.k = new List$1(HighlightingInfo.$, 0);
            this.m = 0;
            this._dirtyContexts = null;
            this._allDirty = false;
            this.e = new Dictionary$2(Base.$, Boolean_$type, 0);
            this.f = new Dictionary$2(Base.$, HighlightingData.$, 0);
            this.j = new List$1(Base.$, 0);
            this.dirtyContexts = new List$1(Base.$, 0);
            this.q = 200;
            this.n = 0;
        }
        get l() {
            return this.h;
        }
        startHighlight(a) {
            if (a == null) {
                return;
            }
            this.a(a);
            this.inProgress = true;
            if (!this.d.containsKey(a)) {
                a.a = HighlightingState.inward;
                this.d.item(a, a);
                this.h.add(a);
            }
            else {
                a = this.d.item(a);
            }
            if (a.a == HighlightingState.outward) {
                a.a = HighlightingState.inward;
            }
        }
        a(a) {
            let b = null;
            if (this.g.containsKey(a)) {
                a = this.g.item(a);
                this.g.removeItem(a);
                this.i.remove(a);
                b = a;
            }
            let c = this.k;
            for (let d = 0; d < this.i.count; d++) {
                let e = this.i._inner[d];
                if (e.c && a.c && a.i == e.i) {
                    if (b == null) {
                        this.g.removeItem(e);
                        this.i.remove(e);
                        let f = this.d.item(e);
                        this.d.removeItem(f);
                        this.h.remove(f);
                        f.g = a.g;
                        f.f = a.f;
                        f.b = a.b;
                        this.d.item(f, f);
                        this.h.add(f);
                        b = f;
                    }
                    else {
                        c.add(e);
                    }
                }
                if (this.isExclusiveHighlight && e.i != a.i) {
                    c.add(e);
                }
                if (e.i == a.i && e.d == a.d && !e.c && (e.g != a.g || e.f != a.f)) {
                    c.add(e);
                }
            }
            for (let g = 0; g < c.count; g++) {
                this.i.remove(c._inner[g]);
                this.g.removeItem(c._inner[g]);
                this.t(c._inner[g]);
            }
            c.clear();
            if (b != null) {
                return b;
            }
            return a;
        }
        endHighlight(a) {
            if (a == null) {
                return;
            }
            if (!this.d.containsKey(a)) {
                return;
            }
            else {
                a = this.d.item(a);
            }
            this.u(a);
        }
        u(a) {
            if (this.g.containsKey(a)) {
                let b = this.g.item(a);
            }
            else {
                this.g.addItem(a, a);
                this.i.add(a);
                a.h = this.executionContext.getCurrentRelativeTime();
            }
            this.b = true;
            if (!this.c) {
                this.c = true;
                this.executionContext.executeDelayed(runOn(this, this.s), this.q);
            }
        }
        s() {
            this.c = false;
            if (!this.b) {
                return;
            }
            let a = this.k;
            let b = 0;
            let c = this.executionContext.getCurrentRelativeTime();
            for (let d = 0; d < this.i.count; d++) {
                let e = this.i._inner[d];
                if (c - e.h >= this.q) {
                    a.add(e);
                }
                else {
                    b = Math.max(b, this.q - (c - e.h));
                }
            }
            for (let f = 0; f < a.count; f++) {
                this.i.remove(a._inner[f]);
                this.g.removeItem(a._inner[f]);
                this.t(a._inner[f]);
            }
            if (a.count > 0) {
                if (this.ensureAnimator != null) {
                    this.ensureAnimator();
                }
            }
            a.clear();
            if (b > 0) {
                this.b = true;
                this.c = true;
                this.executionContext.executeDelayed(runOn(this, this.s), b);
            }
        }
        t(a) {
            if (a.a == HighlightingState.inward) {
                a.a = HighlightingState.outward;
            }
            if (a.a == 2) {
                a.a = HighlightingState.outward;
                a.e = 1;
            }
        }
        clear() {
            this.i.clear();
            this.g.clear();
            this.b = false;
            this.h.clear();
            this.d.clear();
            this.maxHighlightingProgress = 0;
            this.sumHighlightingProgress = 0;
            this.maxMarkerHighlightingProgress = 0;
            this.sumMarkerHighlightingProgress = 0;
            this.totalHighlightingProgress = 0;
        }
        getHighlightingInfo(a, b, c, d, e) {
            for (let f = 0; f < this.h.count; f++) {
                let g = this.h._inner[f];
                let h = g.g;
                let i = g.f;
                if (((c >= h && d <= i) || g.c) && g.d == e && a == g.i && (g.a == HighlightingState.inward || g.a == 2)) {
                    return g;
                }
            }
            for (let j = 0; j < this.h.count; j++) {
                let k = this.h._inner[j];
                let l = k.g;
                let m = k.f;
                if (((c >= l && d <= m) || k.c) && k.d == e && a == k.i && (k.a == HighlightingState.outward)) {
                    return k;
                }
            }
            return null;
        }
        get dirtyContexts() {
            return this._dirtyContexts;
        }
        set dirtyContexts(a) {
            this._dirtyContexts = a;
        }
        get allDirty() {
            return this._allDirty;
        }
        set allDirty(a) {
            this._allDirty = a;
        }
        tick(a) {
            this.e.clear();
            this.dirtyContexts.clear();
            this.f.clear();
            this.allDirty = false;
            let b = 0;
            if (this.m > a) {
                b = (1 - this.m) + a;
            }
            else {
                b = a - this.m;
            }
            this.m = a;
            let c = false;
            let d = new List$1(HighlightingInfo.$, 0);
            this.maxHighlightingProgress = 0;
            this.sumHighlightingProgress = 0;
            this.maxMarkerHighlightingProgress = 0;
            this.sumMarkerHighlightingProgress = 0;
            this.totalHighlightingProgress = 0;
            let e = false;
            let f = false;
            let g = false;
            let h = false;
            let i = false;
            let j = false;
            let k = 0;
            let l = 0;
            let m = 0;
            let n = 0;
            let o = 0;
            let p = 0;
            for (let q = 0; q < this.h.count; q++) {
                let r = this.h._inner[q];
                if (r.a == 2) {
                    if (r.d) {
                        h = true;
                    }
                    else {
                        if (!this.isExclusiveHighlight && !r.c) {
                            j = true;
                        }
                        else {
                            i = true;
                        }
                    }
                }
                if (r.a == HighlightingState.inward) {
                    if (r.d) {
                        e = true;
                        m = m + Math.min(1 - r.e, b);
                    }
                    else {
                        if (!this.isExclusiveHighlight && !r.c) {
                            g = true;
                            o = o + Math.min(1 - r.e, b);
                        }
                        else {
                            f = true;
                            k = k + Math.min(1 - r.e, b);
                        }
                    }
                }
                if (r.a == HighlightingState.outward) {
                    if (r.d) {
                        n = n + Math.min(r.e, b);
                    }
                    else {
                        if (!this.isExclusiveHighlight && !r.c) {
                            p = p + Math.min(r.e, b);
                        }
                        else {
                            l = l + Math.min(r.e, b);
                        }
                    }
                }
            }
            let s = 1;
            let t = 1;
            let u = 1;
            if (f && l > k) {
                let v = l - k;
                s = k / l;
            }
            if (e && n > m) {
                let w = n - m;
                t = m / n;
            }
            if (g && p > o) {
                let x = p - o;
                u = o / p;
            }
            else {
                u = s;
            }
            if (f || i) {
                this.n += b;
                if (this.n > 1) {
                    this.n = 1;
                }
            }
            else {
                this.n -= b;
                if (this.n < 0) {
                    this.n = 0;
                }
            }
            if (e || h) {
                this.p += b;
                if (this.p > 1) {
                    this.p = 1;
                }
            }
            else {
                this.p -= b;
                if (this.p < 0) {
                    this.p = 0;
                }
            }
            if (g || j) {
                this.o += b;
                if (this.o > 1) {
                    this.o = 1;
                }
            }
            else {
                this.o -= b;
                if (this.o < 0) {
                    this.o = 0;
                }
            }
            let y;
            for (let z = 0; z < this.h.count; z++) {
                let aa = this.h._inner[z];
                if (!this.isContextValid(aa.i)) {
                    d.add(aa);
                    continue;
                }
                y = b;
                if (aa.a == HighlightingState.outward) {
                    y = Math.min(y, aa.e);
                    if (aa.d) {
                        y = y * t;
                    }
                    else {
                        if (aa.c) {
                            y = y * s;
                        }
                        else {
                            y = y * u;
                        }
                    }
                    aa.e = aa.e - y;
                }
                else {
                    aa.e = aa.e + y;
                }
                if (aa.a == 2) {
                    aa.e = 1;
                }
                if (aa.e > 1) {
                    aa.e = 1;
                }
                if (aa.e < 0) {
                    aa.e = 0;
                }
                if (aa.d) {
                    this.maxMarkerHighlightingProgress = Math.max(aa.e, this.maxMarkerHighlightingProgress);
                    this.sumMarkerHighlightingProgress = this.sumMarkerHighlightingProgress + aa.e;
                }
                else {
                    this.maxHighlightingProgress = Math.max(aa.e, this.maxHighlightingProgress);
                    this.sumHighlightingProgress = this.sumHighlightingProgress + aa.e;
                }
                if (aa.a != HighlightingState.outward && aa.e != 1) {
                    c = true;
                }
                if (aa.a == HighlightingState.outward && aa.e != 0) {
                    c = true;
                }
                if (aa.e == 1 && aa.a == HighlightingState.inward) {
                    aa.a = 2;
                }
                if (aa.e == 0 && aa.a == HighlightingState.outward) {
                    d.add(aa);
                }
                if (this.isCrossContextHighlight(aa.i)) {
                    this.allDirty = true;
                }
                else {
                    if (!this.e.containsKey(aa.i)) {
                        this.e.addItem(aa.i, true);
                        this.dirtyContexts.add1(aa.i);
                    }
                }
            }
            for (let ab of fromEnum(d)) {
                this.d.removeItem(ab);
                this.h.remove(ab);
            }
            if (this.d.count == 0) {
                this.inProgress = false;
                this.maxHighlightingProgress = 0;
                this.sumHighlightingProgress = 0;
                this.maxMarkerHighlightingProgress = 0;
                this.sumMarkerHighlightingProgress = 0;
                this.totalHighlightingProgress = 0;
            }
            this.j.clear();
            for (let ac = 0; ac < this.h.count; ac++) {
                let ad = this.h._inner[ac];
                let ae = null;
                if (this.f.containsKey(ad.i)) {
                    ae = this.f.item(ad.i);
                }
                else {
                    ae = new HighlightingData();
                    ae.a = 0;
                    ae.d = 0;
                    ae.e = ad.i;
                    ae.b = 0;
                    ae.c = 0;
                    this.f.addItem(ad.i, ae);
                    this.j.add1(ad.i);
                }
                if (ad.d) {
                    ae.b += ad.e;
                }
                else {
                    if (ad.c) {
                        if (ad.b) {
                            ae.c += ad.e;
                        }
                        else {
                            ae.d += ad.e;
                        }
                    }
                    else {
                        ae.a += ad.e;
                    }
                }
            }
            if (this.isExclusiveHighlight) {
                this.totalHighlightingProgress = Math.max(this.sumHighlightingProgress, this.sumMarkerHighlightingProgress);
                this.totalHighWaterMark = Math.max(this.n, Math.max(this.p, this.o));
            }
            else {
                let af = 0;
                let ag = 0;
                let ah = 0;
                let ai = 0;
                let aj = 0;
                let ak = 0;
                let al = 0;
                for (let am = 0; am < this.j.count; am++) {
                    let an = this.f.item(this.j._inner[am]);
                    if (an.a > 0) {
                        ak++;
                    }
                    if (an.b > 0) {
                        al++;
                    }
                    if (an.d > 0) {
                        ah++;
                    }
                    af += an.a;
                    ag += an.d;
                    aj += an.c;
                    ai += an.b;
                }
                if (ak > 0) {
                    af = af / ak;
                }
                if (al > 0) {
                    ai = ai / al;
                }
                if (this.retainMainShapes) {
                    if (ah > 0) {
                        ag = ag / ah;
                    }
                }
                this.totalHighlightingProgress = Math.max(aj, Math.max(af, Math.max(ag, ai)));
                this.totalHighWaterMark = Math.max(this.n, Math.max(this.p, this.o));
            }
            if (!c) {
                this.m = 0;
            }
            return c;
        }
        isCrossContextHighlight(a) {
            return false;
        }
        isContextValid(a) {
            return a != null;
        }
    }
    HighlightingManager.$t = /*@__PURE__*/ markType(HighlightingManager, 'HighlightingManager', Base.$, [IHighlightingManager_$type]);
    return HighlightingManager;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enum specifying which needle if any is being dragged
 */
var NeedleBeingDragged = /*@__PURE__*/ (function (NeedleBeingDragged) {
    NeedleBeingDragged[NeedleBeingDragged["None"] = 0] = "None";
    NeedleBeingDragged[NeedleBeingDragged["Main"] = 1] = "Main";
    NeedleBeingDragged[NeedleBeingDragged["Highlight"] = 2] = "Highlight";
    return NeedleBeingDragged;
})({});
/**
 * @hidden
 */
let NeedleBeingDragged_$type = /*@__PURE__*/ markEnum('NeedleBeingDragged', 'None,0|Main,1|Highlight,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var HighlightedValueDisplayMode = /*@__PURE__*/ (function (HighlightedValueDisplayMode) {
    HighlightedValueDisplayMode[HighlightedValueDisplayMode["Auto"] = 0] = "Auto";
    HighlightedValueDisplayMode[HighlightedValueDisplayMode["Hidden"] = 1] = "Hidden";
    HighlightedValueDisplayMode[HighlightedValueDisplayMode["Overlay"] = 2] = "Overlay";
    return HighlightedValueDisplayMode;
})({});
/**
 * @hidden
 */
let HighlightedValueDisplayMode_$type = /*@__PURE__*/ markEnum('HighlightedValueDisplayMode', 'Auto,0|Hidden,1|Overlay,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enum specifying state of the highlight value
 */
var HighlightState = /*@__PURE__*/ (function (HighlightState) {
    HighlightState[HighlightState["Hidden"] = 0] = "Hidden";
    HighlightState[HighlightState["StartShowing"] = 1] = "StartShowing";
    HighlightState[HighlightState["Showing"] = 2] = "Showing";
    HighlightState[HighlightState["Shown"] = 3] = "Shown";
    HighlightState[HighlightState["StartHiding"] = 4] = "StartHiding";
    HighlightState[HighlightState["Hiding"] = 5] = "Hiding";
    return HighlightState;
})({});
/**
 * @hidden
 */
let HighlightState_$type = /*@__PURE__*/ markEnum('HighlightState', 'Hidden,0|StartShowing,1|Showing,2|Shown,3|StartHiding,4|Hiding,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CaptureImageSettings = /*@__PURE__*/ (() => {
    class CaptureImageSettings extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = false;
        }
        get c() {
            switch (this.a) {
                case 1: return "data:image/jpeg:base64,";
                default:
                case 0: return "data:image/png:base64,";
            }
        }
    }
    CaptureImageSettings.$t = /*@__PURE__*/ markType(CaptureImageSettings, 'CaptureImageSettings');
    return CaptureImageSettings;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var CaptureImageFormat = /*@__PURE__*/ (function (CaptureImageFormat) {
    CaptureImageFormat[CaptureImageFormat["Png"] = 0] = "Png";
    CaptureImageFormat[CaptureImageFormat["Jpeg"] = 1] = "Jpeg";
    return CaptureImageFormat;
})({});
/**
 * @hidden
 */
let CaptureImageFormat_$type = /*@__PURE__*/ markEnum('CaptureImageFormat', 'Png,0|Jpeg,1');

class IgrCaptureImageSettings {
    createImplementation() {
        return new CaptureImageSettings();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get format() {
        return this.i.a;
    }
    set format(v) {
        this.i.a = ensureEnum(CaptureImageFormat_$type, v);
    }
    get addToClipboard() {
        return this.i.b;
    }
    set addToClipboard(v) {
        this.i.b = ensureBool(v);
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageCapturedEventArgs = /*@__PURE__*/ (() => {
    class ImageCapturedEventArgs extends EventArgs {
        constructor(a, b, c) {
            super();
            this.f = null;
            this.d = null;
            this.b = null;
            this.f = a;
            this.d = b;
            this.b = c;
        }
        get base64Data() {
            return this.f;
        }
        get image() {
            return this.d;
        }
        get settings() {
            return this.b;
        }
    }
    ImageCapturedEventArgs.$t = /*@__PURE__*/ markType(ImageCapturedEventArgs, 'ImageCapturedEventArgs', EventArgs.$);
    return ImageCapturedEventArgs;
})();

class IgrImageCapturedEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets the captured image as Base64.
    */
    get base64Data() {
        return this.i.base64Data;
    }
    /**
     * Gets the captured image.
    */
    get image() {
        return this.i.image;
    }
    /**
     * Gets the settings used to capture the image.
    */
    get settings() {
        const r = this.i.settings;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrCaptureImageSettings();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FocusEventArgs = /*@__PURE__*/ (() => {
    class FocusEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
        }
    }
    FocusEventArgs.$t = /*@__PURE__*/ markType(FocusEventArgs, 'FocusEventArgs');
    return FocusEventArgs;
})();

class IgrFocusEventArgs {
    createImplementation() {
        return new FocusEventArgs();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get target() {
        return this.i.a;
    }
    set target(v) {
        this.i.a = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIComponentBuiltInType_$type = /*@__PURE__*/ markEnum('NativeUIComponentBuiltInType', 'Content,0|Button,1|Input,2|Label,3|DropDown,4|Slider,5|Checkbox,6|Grid,7|External,8|Absolute,9|IconButton,10|Icon,11|Popup,12|ToolPanel,13|Column,14|Renderer,15|CheckboxList,16');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var NativeUIElementFactoryFlavor = /*@__PURE__*/ (function (NativeUIElementFactoryFlavor) {
    NativeUIElementFactoryFlavor[NativeUIElementFactoryFlavor["None"] = 0] = "None";
    NativeUIElementFactoryFlavor[NativeUIElementFactoryFlavor["NativePlatform"] = 1] = "NativePlatform";
    NativeUIElementFactoryFlavor[NativeUIElementFactoryFlavor["XPlat"] = 2] = "XPlat";
    return NativeUIElementFactoryFlavor;
})({});
/**
 * @hidden
 */
let NativeUIElementFactoryFlavor_$type = /*@__PURE__*/ markEnum('NativeUIElementFactoryFlavor', 'None,0|NativePlatform,1|XPlat,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let INativeUIElementFactory_$type = /*@__PURE__*/ new Type(null, 'INativeUIElementFactory');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var BaseControlTheme = /*@__PURE__*/ (function (BaseControlTheme) {
    BaseControlTheme[BaseControlTheme["Default"] = 0] = "Default";
    BaseControlTheme[BaseControlTheme["DenaliLight"] = 1] = "DenaliLight";
    BaseControlTheme[BaseControlTheme["MaterialLight"] = 2] = "MaterialLight";
    BaseControlTheme[BaseControlTheme["SlingshotLight"] = 3] = "SlingshotLight";
    BaseControlTheme[BaseControlTheme["SlingshotDark"] = 4] = "SlingshotDark";
    BaseControlTheme[BaseControlTheme["RevealLight"] = 5] = "RevealLight";
    BaseControlTheme[BaseControlTheme["RevealDark"] = 6] = "RevealDark";
    return BaseControlTheme;
})({});
/**
 * @hidden
 */
let BaseControlTheme_$type = /*@__PURE__*/ markEnum('BaseControlTheme', 'Default,0|DenaliLight,1|MaterialLight,2|SlingshotLight,3|SlingshotDark,4|RevealLight,5|RevealDark,6');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUI = /*@__PURE__*/ (() => {
    class NativeUI extends Base {
        static ag(a, b, c) {
            let d = UIElementPropertyAccessorFactory.c.a(a, 0);
            d.c(b, c);
        }
        static l(a, b) {
            let c = UIElementPropertyAccessorFactory.c.a(a, 0);
            return c.b(b);
        }
        static y(a, b) {
            NativeUI.ag(1, a, b);
        }
        static g(a) {
            return NativeUI.l(1, a);
        }
        static m(a, b) {
            NativeUI.ag(2, a, b);
        }
        static aj(a) {
            return NativeUI.l(2, a);
        }
        static n(a, b) {
            NativeUI.ag(3, a, b);
        }
        static ak(a) {
            return NativeUI.l(3, a);
        }
        static p(a, b) {
            NativeUI.ag(4, a, b);
        }
        static ap(a) {
            return NativeUI.l(4, a);
        }
        static o(a, b) {
            NativeUI.ag(5, a, b);
        }
        static z(a, b) {
            NativeUI.ag(6, a, b);
        }
        static ar(a) {
            return NativeUI.l(6, a);
        }
        static ai(a) {
            return NativeUI.l(5, a);
        }
        static q(a, b) {
            NativeUI.ag(7, a, b);
        }
        static al(a) {
            return NativeUI.l(7, a);
        }
        static s(a, b) {
            NativeUI.ag(8, a, b);
        }
        static c(a) {
            return NativeUI.l(8, a);
        }
        static ah(a, b) {
            NativeUI.ag(9, a, b);
        }
        static k(a) {
            return NativeUI.l(9, a);
        }
        static x(a, b) {
            NativeUI.ag(26, a, b);
        }
        static f(a) {
            return NativeUI.l(26, a);
        }
        static t(a, b) {
            NativeUI.ag(10, a, b);
        }
        static d(a) {
            return NativeUI.l(10, a);
        }
        static v(a, b) {
            NativeUI.ag(11, a, b);
        }
        static ae(a, b) {
            NativeUI.ag(12, a, b);
        }
        static e(a) {
            return NativeUI.l(11, a);
        }
        static j(a) {
            return NativeUI.l(12, a);
        }
        static w(a, b) {
            NativeUI.ag(13, a, b);
        }
        static aq(a) {
            return NativeUI.l(13, a);
        }
        static af(a, b) {
            let c = TransformMatrixHelpler.f(b);
            let d = new MatrixTransform();
            d.j = c;
            NativeUI.ag(14, a, d);
        }
        static ao(a) {
            return NativeUI.l(14, a);
        }
        static aa(a, b) {
            NativeUI.ag(15, a, b);
        }
        static r(a, b) {
            NativeUI.ag(16, a, b);
        }
        static am(a) {
            return NativeUI.l(16, a);
        }
        static an(a) {
            return NativeUI.l(15, a);
        }
        static ad(a, b) {
            NativeUI.ag(17, a, b);
        }
        static i(a) {
            return NativeUI.l(17, a);
        }
        static ab(a, b) {
            NativeUI.ag(18, a, b);
        }
        static a(a) {
            return NativeUI.l(18, a);
        }
        static ac(a, b) {
            NativeUI.ag(19, a, b);
        }
        static h(a) {
            return NativeUI.l(19, a);
        }
        static u(a, b) {
            NativeUI.ag(21, a, b);
        }
        static b(a) {
            return NativeUI.l(21, a);
        }
    }
    NativeUI.$t = /*@__PURE__*/ markType(NativeUI, 'NativeUI');
    return NativeUI;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let INativeUIElementBridge_$type = /*@__PURE__*/ new Type(null, 'INativeUIElementBridge');
/**
 * @hidden
 */
let INativeUIContainerBridge_$type = /*@__PURE__*/ new Type(null, 'INativeUIContainerBridge', null, [INativeUIElementBridge_$type]);
/**
 * @hidden
 */
let NativeUIComponent = /*@__PURE__*/ (() => {
    class NativeUIComponent extends Base {
        constructor() {
            super(...arguments);
            this.j = null;
            this.ao = null;
            this.d = null;
            this.an = null;
            this.p = null;
            this.r = null;
            this.l = null;
            this.m = null;
        }
        az() {
            if (this.j != null) {
                this.j.bn(this);
            }
        }
        bd(a) {
            return this.d.getDesiredSize(this.an, a);
        }
        bc() {
            return this.d.getBoundingRect(this.an);
        }
        t(a) {
            return this.d.contains(this.an, a);
        }
        ay() {
            this.d.focus(this.an);
        }
        get_e() {
            return 8;
        }
        get e() {
            return this.get_e();
        }
        get am() {
            return this.d.getMethodTarget(this.an);
        }
        static ar(a) {
            if (!NativeUIComponent.w.contains(a)) {
                NativeUIComponent.w.add(a);
            }
        }
        static a(a, b) {
            let c = new List$1(INativeUIElementFactory_$type, 0);
            let d = new List$1(INativeUIElementFactory_$type, 0);
            for (let e = 0; e < a.length; e++) {
                let f = a[e];
                let g = b[e];
                for (let h = 0; h < NativeUIComponent.w.count; h++) {
                    if (NativeUIComponent.w._inner[h].flavor == g) {
                        d.add(NativeUIComponent.w._inner[h]);
                    }
                }
                for (let i = 0; i < d.count; i++) {
                    if (d._inner[i].supportsComponent(f)) {
                        c.add(d._inner[i]);
                        break;
                    }
                }
                if (c.count - 1 == e) {
                    d.clear();
                    continue;
                }
                for (let j = 0; j < NativeUIComponent.w.count; j++) {
                    if (NativeUIComponent.w._inner[j].supportsComponent(f)) {
                        c.add(NativeUIComponent.w._inner[j]);
                        break;
                    }
                }
                if (c.count - 1 != e) {
                    c.add(null);
                }
                d.clear();
            }
            return c.toArray();
        }
        static v(a, b) {
            let c = NativeUIComponent.a([a], [b]);
            return c != null && c.length > 0 && c[0] != null;
        }
        static as(a, b, c, d) {
            let e = NativeUIComponent.a([b], [c]);
            if (e.length > 0 && e[0] != null) {
                e[0].createComponent(a, b, d);
            }
        }
        static at(a, b, c) {
            NativeUIComponent.as(a, b, 0, c);
        }
        static au(a, b, c, d) {
            let e = 0;
            let f = new Array(b.length);
            let g = NativeUIComponent.a(b, c);
            for (let h = 0; h < g.length; h++) {
                let i = g[h];
                let j = b[h];
                if (i != null) {
                    i.createComponent(a, j, (k) => {
                        f[h] = k;
                        e++;
                        if (e == b.length) {
                            d(f);
                        }
                    });
                }
                else {
                    f[h] = null;
                    e++;
                    if (e == b.length) {
                        d(f);
                    }
                }
            }
        }
        static av(a, b, c) {
            let d = new Array(b.length);
            for (let e = 0; e < d.length; e++) {
                d[e] = 0;
            }
            NativeUIComponent.au(a, b, d, c);
        }
        static aw(a, b, c, d) {
            let e = NativeUIComponent.a([b], [c]);
            if (e.length > 0 && e[0] != null) {
                e[0].createComponentSync(a, b, d);
            }
        }
        static ax(a, b, c) {
            NativeUIComponent.aw(a, b, 0, c);
        }
        al(a) {
            return this.d.getTargetForProperty(a, this.an);
        }
        ai(a) {
            let b = this.al(a);
            return NativeUI.l(a, b);
        }
        a4(a, b) {
            let c = this.al(a);
            this.d.beforeSetNativeValue(a, b);
            NativeUI.ag(a, c, b);
            this.d.afterSetNativeValue(a, b);
        }
        ag(a) {
            let b = this.ak(a);
            return this.ah(b, a);
        }
        a2(a, b) {
            let c = this.ak(a);
            this.a3(c, a, b);
        }
        ap(a, b) {
            let c = this.aj(a);
            this.aq(c, this, a, b);
        }
        aq(a, b, c, d) {
            this.d.addHandler(a, b, c, d);
        }
        a0(a, b) {
            let c = this.aj(a);
            this.a1(c, this, a, b);
        }
        a1(a, b, c, d) {
            this.d.removeHandler(a, b, c, d);
        }
        ah(a, b) {
            return this.d.getValue(a, b);
        }
        a3(a, b, c) {
            this.d.setValue(a, b, c);
        }
        ak(a) {
            let b = this.an;
            b = this.d.getTargetForBuildInProperty(b, a);
            return b;
        }
        aj(a) {
            let b = this.an;
            b = this.d.getTargetForBuildInEvent(b, a);
            return b;
        }
        get ae() {
            return this.ai(9);
        }
        set ae(a) {
            this.a4(9, a);
        }
        get y() {
            return this.ai(10);
        }
        set y(a) {
            this.a4(10, a);
        }
        get aa() {
            return this.ai(1);
        }
        set aa(a) {
            this.a4(1, a);
        }
        get c() {
            let a = this.ag(18);
            return EnumUtil.getEnumValue(BaseControlTheme_$type, a);
        }
        set c(a) {
            this.a2(18, enumGetBox(BaseControlTheme_$type, a));
        }
        get a6() {
            return this.ai(2);
        }
        set a6(a) {
            this.a4(2, a);
        }
        get a7() {
            return this.ai(3);
        }
        set a7(a) {
            this.a4(3, a);
        }
        get be() {
            return this.ai(4);
        }
        set be(a) {
            this.a4(4, a);
        }
        get a5() {
            return this.ai(5);
        }
        set a5(a) {
            this.a4(5, a);
        }
        get bg() {
            return this.ai(6);
        }
        set bg(a) {
            this.a4(6, a);
        }
        get a8() {
            return this.ai(7);
        }
        set a8(a) {
            this.a4(7, a);
        }
        get x() {
            return this.ai(8);
        }
        set x(a) {
            this.a4(8, a);
        }
        get z() {
            return this.ai(11);
        }
        set z(a) {
            this.a4(11, a);
        }
        get ad() {
            return this.ai(12);
        }
        set ad(a) {
            this.a4(12, a);
        }
        get bf() {
            return this.ai(13);
        }
        set bf(a) {
            this.a4(13, a);
        }
        get bb() {
            return this.ai(14);
        }
        set bb(a) {
            this.a4(14, a);
        }
        get ba() {
            return this.ai(15);
        }
        set ba(a) {
            this.a4(15, a);
        }
        get a9() {
            return this.ai(16);
        }
        set a9(a) {
            this.a4(16, a);
        }
        get ac() {
            return this.ai(17);
        }
        set ac(a) {
            this.a4(17, a);
        }
        get b() {
            return this.ai(18);
        }
        set b(a) {
            this.a4(18, a);
        }
        get ab() {
            return this.ai(19);
        }
        set ab(a) {
            this.a4(19, a);
        }
        get f() {
            return this.d.getHorizontalAlignment(this.an);
        }
        set f(a) {
            this.d.setHorizontalAlignment(this.an, a);
        }
        get h() {
            return this.d.getVerticalAlignment(this.an);
        }
        set h(a) {
            this.d.setVerticalAlignment(this.an, a);
        }
        get g() {
            return this.d.getHorizontalContentAlignment(this.an);
        }
        set g(a) {
            this.d.setHorizontalContentAlignment(this.an, a);
        }
        get i() {
            return this.d.getVerticalContentAlignment(this.an);
        }
        set i(a) {
            this.d.setVerticalContentAlignment(this.an, a);
        }
        get k() {
            return EnumUtil.getEnumValue(NativeUICursor_$type, this.ai(20));
        }
        set k(a) {
            this.a4(20, enumGetBox(NativeUICursor_$type, a));
        }
        get_u() {
            return this.ai(21);
        }
        set_u(a) {
            this.a4(21, a);
        }
        get u() {
            return this.get_u();
        }
        set u(a) {
            this.set_u(a);
        }
        get bh() {
            return EnumUtil.getEnumValue(Visibility_$type, this.ai(24));
        }
        set bh(a) {
            this.a4(24, enumGetBox(Visibility_$type, a));
        }
        get q() {
            return this.p;
        }
        set q(a) {
            let b = this.p;
            this.p = a;
            if (this.p != b) {
                if (b != null) {
                    this.a0(7, b);
                }
                if (this.p != null) {
                    this.ap(7, this.p);
                }
            }
        }
        get s() {
            return this.r;
        }
        set s(a) {
            let b = this.r;
            this.r = a;
            if (this.r != b) {
                if (b != null) {
                    this.a0(8, b);
                }
                if (this.p != null) {
                    this.ap(8, this.r);
                }
            }
        }
        get n() {
            return this.l;
        }
        set n(a) {
            let b = this.l;
            this.l = a;
            if (this.l != b) {
                if (b != null) {
                    this.a0(13, b);
                }
                if (this.l != null) {
                    this.ap(13, this.l);
                }
            }
        }
        get o() {
            return this.m;
        }
        set o(a) {
            let b = this.m;
            this.m = a;
            if (this.m != b) {
                if (b != null) {
                    this.a0(14, b);
                }
                if (this.m != null) {
                    this.ap(14, this.m);
                }
            }
        }
        af() {
            return this.d.exportVisualData(this.am);
        }
    }
    NativeUIComponent.$t = /*@__PURE__*/ markType(NativeUIComponent, 'NativeUIComponent');
    NativeUIComponent.w = /*@__PURE__*/ new List$1(INativeUIElementFactory_$type, 0);
    return NativeUIComponent;
})();
/**
 * @hidden
 */
let NativeUIContainer = /*@__PURE__*/ (() => {
    class NativeUIContainer extends NativeUIComponent {
        get bk() {
            return this.bi.getChildrenCount(this.am);
        }
        get bi() {
            return this.d;
        }
        bj(a) {
            return this.bi.getChildAt(this.am, a);
        }
        bo(a) {
            let b = this.bj(a);
            if (b != null) {
                b.j = null;
            }
            this.bi.removeChildAt(this.am, a);
        }
        bl(a) {
            a.j = this;
            this.bi.addChild(this.am, a);
        }
        bm(a, b) {
            b.j = this;
            this.bi.insertChild(this.am, a, b);
        }
        bn(a) {
            a.j = null;
            this.bi.removeChild(this.am, a);
        }
    }
    NativeUIContainer.$t = /*@__PURE__*/ markType(NativeUIContainer, 'NativeUIContainer', NativeUIComponent.$);
    return NativeUIContainer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let INativeUIGridBridge_$type = /*@__PURE__*/ new Type(null, 'INativeUIGridBridge', null, [INativeUIContainerBridge_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let INativeUIAbsolutePanelBridge_$type = /*@__PURE__*/ new Type(null, 'INativeUIAbsolutePanelBridge', null, [INativeUIContainerBridge_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let INativeUIPopupBridge_$type = /*@__PURE__*/ new Type(null, 'INativeUIPopupBridge', null, [INativeUIContainerBridge_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let INativeUIWindowBridge_$type = /*@__PURE__*/ new Type(null, 'INativeUIWindowBridge');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let INativeUIColumnBridge_$type = /*@__PURE__*/ new Type(null, 'INativeUIColumnBridge', null, [INativeUIContainerBridge_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let INativeUIInputBridge_$type = /*@__PURE__*/ new Type(null, 'INativeUIInputBridge', null, [INativeUIElementBridge_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIComponentHorizontalAlignment_$type = /*@__PURE__*/ markEnum('NativeUIComponentHorizontalAlignment', 'Left,0|Center,1|Right,2|Stretch,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIComponentVerticalAlignment_$type = /*@__PURE__*/ markEnum('NativeUIComponentVerticalAlignment', 'Top,0|Center,1|Bottom,2|Stretch,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let INativeUIContentBridge_$type = /*@__PURE__*/ new Type(null, 'INativeUIContentBridge', null, [INativeUIElementBridge_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIContent = /*@__PURE__*/ (() => {
    class NativeUIContent extends NativeUIContainer {
        get_e() {
            return 0;
        }
        get bp() {
            return this.d;
        }
        get bq() {
            return this.bp.getContent(this.am);
        }
        set bq(a) {
            this.bp.setContent(this.am, a);
        }
    }
    NativeUIContent.$t = /*@__PURE__*/ markType(NativeUIContent, 'NativeUIContent', NativeUIContainer.$);
    return NativeUIContent;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUICheckbox = /*@__PURE__*/ (() => {
    class NativeUICheckbox extends NativeUIComponent {
        constructor() {
            super(...arguments);
            this.bi = null;
        }
        get_e() {
            return 6;
        }
        get bk() {
            let a = this.ag(4);
            return a;
        }
        set bk(a) {
            this.a2(4, a);
        }
        get bl() {
            let a = this.ag(7);
            return a;
        }
        set bl(a) {
            this.a2(7, a);
        }
        get bm() {
            let a = this.ag(17);
            return a;
        }
        set bm(a) {
            this.a2(17, a);
        }
        get bp() {
            return this.ag(65);
        }
        set bp(a) {
            this.a2(65, a);
        }
        get bn() {
            return this.ag(66);
        }
        set bn(a) {
            this.a2(66, a);
        }
        get bq() {
            return this.ag(67);
        }
        set bq(a) {
            this.a2(67, a);
        }
        get bo() {
            return this.ag(68);
        }
        set bo(a) {
            this.a2(68, a);
        }
        get bj() {
            return this.bi;
        }
        set bj(a) {
            let b = this.bi;
            this.bi = a;
            if (this.bi != b) {
                if (b != null) {
                    this.a0(2, b);
                }
                if (this.bi != null) {
                    this.ap(2, this.bi);
                }
            }
        }
    }
    NativeUICheckbox.$t = /*@__PURE__*/ markType(NativeUICheckbox, 'NativeUICheckbox', NativeUIComponent.$);
    return NativeUICheckbox;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var ControlDisplayDensity = /*@__PURE__*/ (function (ControlDisplayDensity) {
    ControlDisplayDensity[ControlDisplayDensity["Auto"] = 0] = "Auto";
    ControlDisplayDensity[ControlDisplayDensity["Comfortable"] = 1] = "Comfortable";
    ControlDisplayDensity[ControlDisplayDensity["Cosy"] = 2] = "Cosy";
    ControlDisplayDensity[ControlDisplayDensity["Compact"] = 3] = "Compact";
    return ControlDisplayDensity;
})({});
/**
 * @hidden
 */
let ControlDisplayDensity_$type = /*@__PURE__*/ markEnum('ControlDisplayDensity', 'Auto,0|Comfortable,1|Cosy,2|Compact,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUICheckboxList = /*@__PURE__*/ (() => {
    class NativeUICheckboxList extends NativeUIComponent {
        constructor() {
            super(...arguments);
            this.bk = null;
            this.bl = null;
            this.bm = null;
        }
        get_e() {
            return 16;
        }
        get bn() {
            return this.bk;
        }
        set bn(a) {
            let b = this.bk;
            this.bk = a;
            if (this.bk != b) {
                if (b != null) {
                    this.a0(2, b);
                }
                if (this.bk != null) {
                    this.ap(2, this.bk);
                }
            }
        }
        get bo() {
            return this.bl;
        }
        set bo(a) {
            let b = this.bl;
            this.bl = a;
            if (this.bl != b) {
                if (b != null) {
                    this.a0(18, b);
                }
                if (this.bl != null) {
                    this.ap(18, this.bl);
                }
            }
        }
        get bp() {
            return this.bm;
        }
        set bp(a) {
            let b = this.bm;
            this.bm = a;
            if (this.bm != b) {
                if (b != null) {
                    this.a0(19, b);
                }
                if (this.bm != null) {
                    this.ap(19, this.bm);
                }
            }
        }
        get br() {
            let a = this.ag(8);
            return a;
        }
        set br(a) {
            this.a2(8, a);
        }
        get bu() {
            let a = this.ag(23);
            return a;
        }
        set bu(a) {
            this.a2(23, a);
        }
        get bs() {
            let a = this.ag(75);
            return a;
        }
        set bs(a) {
            this.a2(75, a);
        }
        get bt() {
            let a = this.ag(74);
            return a;
        }
        set bt(a) {
            this.a2(74, a);
        }
        get bj() {
            let a = this.ag(1);
            return EnumUtil.getEnumValue(ControlDisplayDensity_$type, a);
        }
        set bj(a) {
            this.a2(1, enumGetBox(ControlDisplayDensity_$type, a));
        }
        get bq() {
            let a = this.ag(76);
            return a;
        }
        set bq(a) {
            this.a2(76, a);
        }
        get bi() {
            let a = this.ag(77);
            return a;
        }
        set bi(a) {
            this.a2(77, a);
        }
        get by() {
            let a = this.ag(33);
            return a;
        }
        set by(a) {
            this.a2(33, a);
        }
        get bv() {
            let a = this.ag(24);
            return a;
        }
        set bv(a) {
            this.a2(24, a);
        }
        get bw() {
            let a = this.ag(78);
            return a;
        }
        set bw(a) {
            this.a2(78, a);
        }
        get bx() {
            let a = this.ag(79);
            return a;
        }
        set bx(a) {
            this.a2(79, a);
        }
    }
    NativeUICheckboxList.$t = /*@__PURE__*/ markType(NativeUICheckboxList, 'NativeUICheckboxList', NativeUIComponent.$);
    return NativeUICheckboxList;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIDisplayDensity_$type = /*@__PURE__*/ markEnum('NativeUIDisplayDensity', 'Auto,0|Comfortable,1|Compact,2|Cosy,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIButtonDisplayType_$type = /*@__PURE__*/ markEnum('NativeUIButtonDisplayType', 'Raised,0|Flat,1|Outlined,2|Fab,3|Icon,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIButton = /*@__PURE__*/ (() => {
    class NativeUIButton extends NativeUIComponent {
        constructor() {
            super(...arguments);
            this.bj = null;
        }
        get_e() {
            return 1;
        }
        get bn() {
            let a = this.ag(1);
            return a == null ? 1 : EnumUtil.getEnumValue(NativeUIDisplayDensity_$type, a);
        }
        set bn(a) {
            this.a2(1, enumGetBox(NativeUIDisplayDensity_$type, a));
        }
        get bl() {
            let a = this.ag(0);
            return a == null ? 0 : EnumUtil.getEnumValue(NativeUIButtonDisplayType_$type, a);
        }
        set bl(a) {
            this.a2(0, enumGetBox(NativeUIButtonDisplayType_$type, a));
        }
        get bw() {
            let a = this.ag(3);
            return a;
        }
        set bw(a) {
            this.a2(3, a);
        }
        get bm() {
            return this.ag(54);
        }
        set bm(a) {
            this.a2(54, a);
        }
        get bs() {
            return this.ag(4);
        }
        set bs(a) {
            this.a2(4, a);
        }
        get bq() {
            return this.ag(5);
        }
        set bq(a) {
            this.a2(5, a);
        }
        get bp() {
            return this.ag(6);
        }
        set bp(a) {
            this.a2(6, a);
        }
        get bu() {
            return this.ag(32);
        }
        set bu(a) {
            this.a2(32, a);
        }
        get by() {
            return this.ag(24);
        }
        set by(a) {
            this.a2(24, a);
        }
        get bz() {
            return this.ag(55);
        }
        set bz(a) {
            this.a2(55, a);
        }
        get bt() {
            return this.ag(57);
        }
        set bt(a) {
            this.a2(57, a);
        }
        get br() {
            return this.ag(56);
        }
        set br(a) {
            this.a2(56, a);
        }
        get bo() {
            return this.ag(58);
        }
        set bo(a) {
            this.a2(58, a);
        }
        get bx() {
            return this.ag(17);
        }
        set bx(a) {
            this.a2(17, a);
        }
        get bi() {
            return this.ag(11);
        }
        set bi(a) {
            this.a2(11, a);
        }
        get bv() {
            return this.ag(83);
        }
        set bv(a) {
            this.a2(83, a);
        }
        get bk() {
            return this.bj;
        }
        set bk(a) {
            let b = this.bj;
            this.bj = a;
            if (this.bj != b) {
                if (b != null) {
                    this.a0(1, b);
                }
                if (this.bj != null) {
                    this.ap(1, this.bj);
                }
            }
        }
    }
    NativeUIButton.$t = /*@__PURE__*/ markType(NativeUIButton, 'NativeUIButton', NativeUIComponent.$);
    return NativeUIButton;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIIconButton = /*@__PURE__*/ (() => {
    class NativeUIIconButton extends NativeUIButton {
        get_e() {
            return 10;
        }
        get b6() {
            let a = this.ag(15);
            return a;
        }
        set b6(a) {
            this.a2(15, a);
        }
        get b7() {
            let a = this.ag(16);
            return a;
        }
        set b7(a) {
            this.a2(16, a);
        }
        get b3() {
            return this.ag(44);
        }
        set b3(a) {
            this.a2(44, a);
        }
        get b4() {
            return this.ag(45);
        }
        set b4(a) {
            this.a2(45, a);
        }
        get b5() {
            return this.ag(46);
        }
        set b5(a) {
            this.a2(46, a);
        }
        get b2() {
            return this.ag(47);
        }
        set b2(a) {
            this.a2(47, a);
        }
        get b1() {
            return this.ag(48);
        }
        set b1(a) {
            this.a2(48, a);
        }
        get b0() {
            return this.ag(49);
        }
        set b0(a) {
            this.a2(49, a);
        }
    }
    NativeUIIconButton.$t = /*@__PURE__*/ markType(NativeUIIconButton, 'NativeUIIconButton', NativeUIButton.$);
    return NativeUIIconButton;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIIcon = /*@__PURE__*/ (() => {
    class NativeUIIcon extends NativeUIComponent {
        get_e() {
            return 11;
        }
        get bo() {
            let a = this.ag(15);
            return a;
        }
        set bo(a) {
            this.a2(15, a);
        }
        get bp() {
            let a = this.ag(16);
            return a;
        }
        set bp(a) {
            this.a2(16, a);
        }
        get bl() {
            return this.ag(44);
        }
        set bl(a) {
            this.a2(44, a);
        }
        get bm() {
            return this.ag(45);
        }
        set bm(a) {
            this.a2(45, a);
        }
        get bn() {
            return this.ag(46);
        }
        set bn(a) {
            this.a2(46, a);
        }
        get bk() {
            return this.ag(47);
        }
        set bk(a) {
            this.a2(47, a);
        }
        get bi() {
            return this.ag(62);
        }
        set bi(a) {
            this.a2(62, a);
        }
        get bj() {
            return this.ag(63);
        }
        set bj(a) {
            this.a2(63, a);
        }
    }
    NativeUIIcon.$t = /*@__PURE__*/ markType(NativeUIIcon, 'NativeUIIcon', NativeUIComponent.$);
    return NativeUIIcon;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIDropDown = /*@__PURE__*/ (() => {
    class NativeUIDropDown extends NativeUIComponent {
        constructor() {
            super(...arguments);
            this.bj = null;
        }
        get_e() {
            return 4;
        }
        get bi() {
            let a = this.ag(1);
            return a == null ? 1 : EnumUtil.getEnumValue(NativeUIDisplayDensity_$type, a);
        }
        set bi(a) {
            this.a2(1, enumGetBox(NativeUIDisplayDensity_$type, a));
        }
        get bk() {
            return this.bj;
        }
        set bk(a) {
            let b = this.bj;
            this.bj = a;
            if (this.bj != b) {
                if (b != null) {
                    this.a0(3, b);
                }
                if (this.bj != null) {
                    this.ap(3, this.bj);
                }
            }
        }
        get bm() {
            let a = this.ag(9);
            return a;
        }
        set bm(a) {
            this.a2(9, a);
        }
        get bl() {
            let a = this.ag(8);
            return a;
        }
        set bl(a) {
            this.a2(8, a);
        }
    }
    NativeUIDropDown.$t = /*@__PURE__*/ markType(NativeUIDropDown, 'NativeUIDropDown', NativeUIComponent.$);
    return NativeUIDropDown;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUISlider = /*@__PURE__*/ (() => {
    class NativeUISlider extends NativeUIComponent {
        constructor() {
            super(...arguments);
            this.bi = null;
            this.bj = null;
        }
        get_e() {
            return 5;
        }
        get bp() {
            let a = this.ag(2);
            return a;
        }
        set bp(a) {
            this.a2(2, a);
        }
        get bn() {
            let a = this.ag(12);
            return a;
        }
        set bn(a) {
            this.a2(12, a);
        }
        get bm() {
            let a = this.ag(13);
            return a;
        }
        set bm(a) {
            this.a2(13, a);
        }
        get bo() {
            let a = this.ag(14);
            return a;
        }
        set bo(a) {
            this.a2(14, a);
        }
        get bk() {
            return this.bi;
        }
        set bk(a) {
            let b = this.bi;
            this.bi = a;
            if (this.bi != b) {
                if (b != null) {
                    this.a0(4, b);
                }
                if (this.bi != null) {
                    this.ap(4, this.bi);
                }
            }
        }
        get bl() {
            return this.bj;
        }
        set bl(a) {
            let b = this.bj;
            this.bj = a;
            if (this.bj != b) {
                if (b != null) {
                    this.a0(0, b);
                }
                if (this.bj != null) {
                    this.ap(0, this.bj);
                }
            }
        }
    }
    NativeUISlider.$t = /*@__PURE__*/ markType(NativeUISlider, 'NativeUISlider', NativeUIComponent.$);
    return NativeUISlider;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUILabel = /*@__PURE__*/ (() => {
    class NativeUILabel extends NativeUIComponent {
        get_e() {
            return 3;
        }
        get bk() {
            let a = this.ag(10);
            return a;
        }
        set bk(a) {
            this.a2(10, a);
        }
        get bi() {
            let a = this.ag(11);
            return a;
        }
        set bi(a) {
            this.a2(11, a);
        }
        get bj() {
            return this.ag(31);
        }
        set bj(a) {
            this.a2(31, a);
        }
    }
    NativeUILabel.$t = /*@__PURE__*/ markType(NativeUILabel, 'NativeUILabel', NativeUIComponent.$);
    return NativeUILabel;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIChildren = /*@__PURE__*/ (() => {
    class NativeUIChildren extends ObservableCollection$1 {
        constructor() {
            super(NativeUIComponent.$, 0);
        }
    }
    NativeUIChildren.$t = /*@__PURE__*/ markType(NativeUIChildren, 'NativeUIChildren', /*@__PURE__*/ ObservableCollection$1.$.specialize(NativeUIComponent.$));
    return NativeUIChildren;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIGridWidthType_$type = /*@__PURE__*/ markEnum('NativeUIGridWidthType', 'Auto,0|Value,1|Star,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIGridHeightType_$type = /*@__PURE__*/ markEnum('NativeUIGridHeightType', 'Auto,0|Value,1|Star,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIBoxSizing_$type = /*@__PURE__*/ markEnum('NativeUIBoxSizing', 'BorderBox,0|ContentBox,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIPlaceContent_$type = /*@__PURE__*/ markEnum('NativeUIPlaceContent', 'Unset,0|Center,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIGrid = /*@__PURE__*/ (() => {
    class NativeUIGrid extends NativeUIContainer {
        constructor() {
            super(...arguments);
            this.br = null;
        }
        get_e() {
            return 7;
        }
        get by() {
            return this.bp.getRowDefinitionsCount(this.am);
        }
        get bv() {
            return this.bp.getColumnDefinitionsCount(this.am);
        }
        get bp() {
            return this.d;
        }
        get bq() {
            let a = this.ag(38);
            return EnumUtil.getEnumValue(NativeUIBoxSizing_$type, a);
        }
        set bq(a) {
            this.a2(38, enumGetBox(NativeUIBoxSizing_$type, a));
        }
        get bt() {
            let a = this.ag(72);
            return EnumUtil.getEnumValue(NativeUIPlaceContent_$type, a);
        }
        set bt(a) {
            this.a2(72, enumGetBox(NativeUIPlaceContent_$type, a));
        }
        get bu() {
            return this.ag(37);
        }
        set bu(a) {
            this.a2(37, a);
        }
        b1(a, b, c) {
            this.bp.addRowDefinition(this.am, a, b, c);
        }
        b9(a, b, c) {
            this.bp.updateRowDefinition(this.am, a, b, c);
        }
        bz(a, b, c) {
            this.bp.addColumnDefinition(this.am, a, b, c);
        }
        b0(a, b, c, d) {
            this.bp.addColumnDefinitionWithMin(this.am, a, b, c, d);
        }
        b8(a, b, c) {
            this.bp.updateColumnDefinition(this.am, a, b, c);
        }
        b2(a, b, c) {
            this.bp.insertColumnDefinition(this.am, a, b, c);
        }
        b3(a, b, c, d) {
            this.bp.insertColumnDefinitionWithMin(this.am, a, b, c, d);
        }
        b7(a, b) {
            this.bp.setRow(this.am, a, b);
        }
        b6(a, b) {
            this.bp.setColumn(this.am, a, b);
        }
        bx(a) {
            return this.bp.getRow(this.am, a);
        }
        bw(a) {
            return this.bp.getColumn(this.am, a);
        }
        b5(a) {
            this.bp.removeRowDefinition(this.am, a);
        }
        b4(a) {
            this.bp.removeColumnDefinition(this.am, a);
        }
        get bs() {
            return this.br;
        }
        set bs(a) {
            let b = this.br;
            this.br = a;
            if (this.br != b) {
                if (b != null) {
                    this.a0(1, b);
                }
                if (this.br != null) {
                    this.ap(1, this.br);
                }
            }
        }
    }
    NativeUIGrid.$t = /*@__PURE__*/ markType(NativeUIGrid, 'NativeUIGrid', NativeUIContainer.$);
    return NativeUIGrid;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIAbsolutePanel = /*@__PURE__*/ (() => {
    class NativeUIAbsolutePanel extends NativeUIContainer {
        get_e() {
            return 9;
        }
        get bp() {
            return this.d;
        }
        bs(a, b) {
            this.bp.setX(this.am, a, b);
        }
        bt(a, b) {
            this.bp.setY(this.am, a, b);
        }
        bq(a) {
            return this.bp.getX(this.am, a);
        }
        br(a) {
            return this.bp.getY(this.am, a);
        }
    }
    NativeUIAbsolutePanel.$t = /*@__PURE__*/ markType(NativeUIAbsolutePanel, 'NativeUIAbsolutePanel', NativeUIContainer.$);
    return NativeUIAbsolutePanel;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIColumn = /*@__PURE__*/ (() => {
    class NativeUIColumn extends NativeUIContainer {
        get_e() {
            return 14;
        }
        get bp() {
            return this.d;
        }
    }
    NativeUIColumn.$t = /*@__PURE__*/ markType(NativeUIColumn, 'NativeUIColumn', NativeUIContainer.$);
    return NativeUIColumn;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIInputDisplayType_$type = /*@__PURE__*/ markEnum('NativeUIInputDisplayType', 'Line,0|Border,1|Box,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIInputType_$type = /*@__PURE__*/ markEnum('NativeUIInputType', 'Text,0|Number,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIInput = /*@__PURE__*/ (() => {
    class NativeUIInput extends NativeUIComponent {
        constructor() {
            super(...arguments);
            this.bm = null;
            this.bi = null;
        }
        get bj() {
            return this.d;
        }
        get bo() {
            let a = this.ag(0);
            return a == null ? 1 : EnumUtil.getEnumValue(NativeUIInputDisplayType_$type, a);
        }
        set bo(a) {
            this.a2(0, enumGetBox(NativeUIInputDisplayType_$type, a));
        }
        get bl() {
            let a = this.ag(1);
            return a == null ? 1 : EnumUtil.getEnumValue(NativeUIDisplayDensity_$type, a);
        }
        set bl(a) {
            this.a2(1, enumGetBox(NativeUIDisplayDensity_$type, a));
        }
        get bs() {
            let a = this.ag(2);
            return a;
        }
        set bs(a) {
            this.a2(2, a);
        }
        get bn() {
            return this.bm;
        }
        set bn(a) {
            let b = this.bm;
            this.bm = a;
            if (this.bm != b) {
                if (b != null) {
                    this.a0(0, b);
                }
                if (this.bm != null) {
                    this.ap(0, this.bm);
                }
            }
        }
        get bp() {
            let a = this.ag(19);
            return a == null ? 0 : EnumUtil.getEnumValue(NativeUIInputType_$type, a);
        }
        set bp(a) {
            this.a2(19, enumGetBox(NativeUIInputType_$type, a));
        }
        get bk() {
            let a = this.ag(20);
            return a == null ? 0 : EnumUtil.getEnumValue(NativeUIComponentHorizontalAlignment_$type, a);
        }
        set bk(a) {
            this.a2(20, enumGetBox(NativeUIComponentHorizontalAlignment_$type, a));
        }
        get bv() {
            let a = this.ag(33);
            return a == null ? null : a;
        }
        set bv(a) {
            this.a2(33, a);
        }
        get br() {
            let a = this.ag(21);
            return a == null ? false : a;
        }
        set br(a) {
            this.a2(21, a);
        }
        get bq() {
            let a = this.ag(32);
            return a == null ? false : a;
        }
        set bq(a) {
            this.a2(32, a);
        }
        bt() {
            this.bj.select(this.am);
        }
        bu(a, b) {
            this.bj.setSelectionRange(this.am, a, b);
        }
    }
    NativeUIInput.$t = /*@__PURE__*/ markType(NativeUIInput, 'NativeUIInput', NativeUIComponent.$);
    return NativeUIInput;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIPopupAnimationType_$type = /*@__PURE__*/ markEnum('NativeUIPopupAnimationType', 'GrowShrink,0|FadeInOutSlide,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIPopupPointerPosition_$type = /*@__PURE__*/ markEnum('NativeUIPopupPointerPosition', 'Auto,0|Top,1|Bottom,2|Left,3|Right,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIPopup = /*@__PURE__*/ (() => {
    class NativeUIPopup extends NativeUIContainer {
        constructor() {
            super(...arguments);
            this.bt = null;
            this.br = null;
        }
        get bp() {
            return this.d;
        }
        get b2() {
            return this.ag(22);
        }
        get b1() {
            return this.ag(59);
        }
        get by() {
            return this.ag(60);
        }
        get bw() {
            return this.ag(25);
        }
        set bw(a) {
            this.a2(25, a);
        }
        get b5() {
            return typeGetValue(this.ag(26));
        }
        set b5(a) {
            this.a2(26, a);
        }
        get bx() {
            return this.ag(39);
        }
        set bx(a) {
            this.a2(39, a);
        }
        get bq() {
            return EnumUtil.getEnumValue(NativeUIPopupAnimationType_$type, this.ag(35));
        }
        set bq(a) {
            this.a2(35, enumGetBox(NativeUIPopupAnimationType_$type, a));
        }
        get cb() {
            return this.ag(23);
        }
        set cb(a) {
            this.a2(23, a);
        }
        get b3() {
            return this.ag(17);
        }
        set b3(a) {
            this.a2(17, a);
        }
        get_u() {
            return this.ag(36);
        }
        set_u(a) {
            this.a2(36, a);
        }
        get bz() {
            return this.ag(37);
        }
        set bz(a) {
            this.a2(37, a);
        }
        get b6() {
            return typeGetValue(this.ag(40));
        }
        set b6(a) {
            this.a2(40, a);
        }
        get b0() {
            return this.ag(41);
        }
        set b0(a) {
            this.a2(41, a);
        }
        get bv() {
            return EnumUtil.getEnumValue(NativeUIPopupPointerPosition_$type, this.ag(43));
        }
        set bv(a) {
            this.a2(43, enumGetBox(NativeUIPopupPointerPosition_$type, a));
        }
        get cc() {
            return this.ag(42);
        }
        set cc(a) {
            this.a2(42, a);
        }
        get b4() {
            return this.ag(61);
        }
        set b4(a) {
            this.a2(61, a);
        }
        get bu() {
            return this.bt;
        }
        set bu(a) {
            let b = this.bt;
            this.bt = a;
            if (this.bt != b) {
                if (b != null) {
                    this.a0(5, b);
                }
                if (this.bt != null) {
                    this.ap(5, this.bt);
                }
            }
        }
        get bs() {
            return this.br;
        }
        set bs(a) {
            let b = this.br;
            this.br = a;
            if (this.br != b) {
                if (b != null) {
                    this.a0(6, b);
                }
                if (this.br != null) {
                    this.ap(6, this.br);
                }
            }
        }
        ca(a, b, c) {
            this.bp.showRelativeToExclusionRect(this.am, a, b, c);
        }
        b7() {
            this.bp.close(this.am);
        }
        b8() {
            this.bp.notifyContentSizeChanged(this.am);
        }
        b9(a) {
            this.bp.notifyExclusionRectChanged(this.am, a);
        }
    }
    NativeUIPopup.$t = /*@__PURE__*/ markType(NativeUIPopup, 'NativeUIPopup', NativeUIContainer.$);
    return NativeUIPopup;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIWindow = /*@__PURE__*/ (() => {
    class NativeUIWindow extends Base {
        static get b() {
            return NativeUIWindow.a;
        }
        static set b(a) {
            NativeUIWindow.a = a;
        }
        static g(a, b) {
            NativeUIWindow.b.addEventListener(a, b);
        }
        static h(a, b, c) {
            NativeUIWindow.b.addEventListener1(a, b, c);
        }
        static i(a, b) {
            NativeUIWindow.b.removeEventListener(a, b);
        }
        static e() {
            return NativeUIWindow.b.getWidth();
        }
        static f(a) {
            return NativeUIWindow.b.getWidth1(a);
        }
        static c() {
            return NativeUIWindow.b.getHeight();
        }
        static d(a) {
            return NativeUIWindow.b.getHeight1(a);
        }
    }
    NativeUIWindow.$t = /*@__PURE__*/ markType(NativeUIWindow, 'NativeUIWindow');
    NativeUIWindow.a = null;
    return NativeUIWindow;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIPopupDirection_$type = /*@__PURE__*/ markEnum('NativeUIPopupDirection', 'Auto,0|Down,1|Up,2|Left,3|Right,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIPopupAlignment_$type = /*@__PURE__*/ markEnum('NativeUIPopupAlignment', 'Auto,0|Near,1|Far,2|Middle,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIBuiltInProperties_$type = /*@__PURE__*/ markEnum('NativeUIBuiltInProperties', 'DisplayType,0|Density,1|Value,2|Label,3|DisableRipple,4|DisableHover,5|DisableFocusStyle,6|IsChecked,7|DataSource,8|SelectedValue,9|Text,10|FontInfo,11|Min,12|Max,13|Step,14|CollectionName,15|IconName,16|CornerRadius,17|BaseTheme,18|InputType,19|TextAlignment,20|ShowSpinner,21|IsShown,22|Background,23|HoverBackground,24|AnimationEnabled,25|AnimationDuration,26|Actions,27|RowHeight,28|ActualRowHeight,29|Orientation,30|IsWrapEnabled,31|IsDisabled,32|TextColor,33|DisabledTextColor,34|AnimationType,35|IsHitTestVisible,36|IsFocusable,37|BoxSizing,38|DisableHitTestDuringAnimation,39|Elevation,40|IsPointerEnabled,41|PointerBackground,42|PointerPosition,43|ViewBoxLeft,44|ViewBoxTop,45|ViewBoxWidth,46|ViewBoxHeight,47|IconWidth,48|IconHeight,49|SubmenuBackground,50|GroupHeaderBackground,51|GroupHeaderTextColor,52|SeparatorBackground,53|Content,54|ContentPadding,55|DisablePointer,56|FillAvailableSpace,57|ClickTunneling,58|IsShowing,59|IsClosing,60|PointerSize,61|FillColors,62|StrokeColors,63|StrokeWidth,64|UncheckedBackgroundColor,65|CheckedBackgroundColor,66|UncheckedBorderColor,67|CheckedBorderColor,68|MenuArrowStroke,69|IconFill,70|IconStroke,71|PlaceContent,72|ItemsSource,73|SelectedMemberPath,74|DataMemberPath,75|ShowSelectAll,76|PrimaryKey,77|SearchIconColor,78|SearchTextColor,79|SubtitleTextColor,80|GroupHeaderSubtitleTextColor,81|SubtitleFontInfo,82|MinWidth,83');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIBuiltInEvents_$type = /*@__PURE__*/ markEnum('NativeUIBuiltInEvents', 'Changing,0|Clicked,1|Change,2|SelectedValueChanged,3|ValueChanged,4|Opened,5|Closed,6|MouseEnter,7|MouseLeave,8|MouseDown,9|ContentRefreshed,10|DrillDownRequested,11|DrillUpRequested,12|GotFocus,13|LostFocus,14|SizeChanged,15|PositionChanged,16|OnCommand,17|ItemAdded,18|ItemRemoved,19');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIAlignItems_$type = /*@__PURE__*/ markEnum('NativeUIAlignItems', 'Normal,0|Center,1|Stretch,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIInputChangingEventArgs = /*@__PURE__*/ (() => {
    class NativeUIInputChangingEventArgs extends Base {
    }
    NativeUIInputChangingEventArgs.$t = /*@__PURE__*/ markType(NativeUIInputChangingEventArgs, 'NativeUIInputChangingEventArgs');
    return NativeUIInputChangingEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUICheckboxChangeEventArgs = /*@__PURE__*/ (() => {
    class NativeUICheckboxChangeEventArgs extends Base {
    }
    NativeUICheckboxChangeEventArgs.$t = /*@__PURE__*/ markType(NativeUICheckboxChangeEventArgs, 'NativeUICheckboxChangeEventArgs');
    return NativeUICheckboxChangeEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUICheckboxListChangeEventArgs = /*@__PURE__*/ (() => {
    class NativeUICheckboxListChangeEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.c = 0;
            this.b = false;
            this.a = null;
        }
    }
    NativeUICheckboxListChangeEventArgs.$t = /*@__PURE__*/ markType(NativeUICheckboxListChangeEventArgs, 'NativeUICheckboxListChangeEventArgs');
    return NativeUICheckboxListChangeEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUISliderValueChangedEventArgs = /*@__PURE__*/ (() => {
    class NativeUISliderValueChangedEventArgs extends Base {
    }
    NativeUISliderValueChangedEventArgs.$t = /*@__PURE__*/ markType(NativeUISliderValueChangedEventArgs, 'NativeUISliderValueChangedEventArgs');
    return NativeUISliderValueChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIButtonClickedEventArgs = /*@__PURE__*/ (() => {
    class NativeUIButtonClickedEventArgs extends Base {
    }
    NativeUIButtonClickedEventArgs.$t = /*@__PURE__*/ markType(NativeUIButtonClickedEventArgs, 'NativeUIButtonClickedEventArgs');
    return NativeUIButtonClickedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIDropDownSelectedValueChangedEventArgs = /*@__PURE__*/ (() => {
    class NativeUIDropDownSelectedValueChangedEventArgs extends Base {
    }
    NativeUIDropDownSelectedValueChangedEventArgs.$t = /*@__PURE__*/ markType(NativeUIDropDownSelectedValueChangedEventArgs, 'NativeUIDropDownSelectedValueChangedEventArgs');
    return NativeUIDropDownSelectedValueChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIClickedEventArgs = /*@__PURE__*/ (() => {
    class NativeUIClickedEventArgs extends Base {
    }
    NativeUIClickedEventArgs.$t = /*@__PURE__*/ markType(NativeUIClickedEventArgs, 'NativeUIClickedEventArgs');
    return NativeUIClickedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIPopupOpenedEventArgs = /*@__PURE__*/ (() => {
    class NativeUIPopupOpenedEventArgs extends Base {
    }
    NativeUIPopupOpenedEventArgs.$t = /*@__PURE__*/ markType(NativeUIPopupOpenedEventArgs, 'NativeUIPopupOpenedEventArgs');
    return NativeUIPopupOpenedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIPopupClosedEventArgs = /*@__PURE__*/ (() => {
    class NativeUIPopupClosedEventArgs extends Base {
    }
    NativeUIPopupClosedEventArgs.$t = /*@__PURE__*/ markType(NativeUIPopupClosedEventArgs, 'NativeUIPopupClosedEventArgs');
    return NativeUIPopupClosedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIMouseEventArgs = /*@__PURE__*/ (() => {
    class NativeUIMouseEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
        }
    }
    NativeUIMouseEventArgs.$t = /*@__PURE__*/ markType(NativeUIMouseEventArgs, 'NativeUIMouseEventArgs');
    return NativeUIMouseEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIFocusEventArgs = /*@__PURE__*/ (() => {
    class NativeUIFocusEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
        }
    }
    NativeUIFocusEventArgs.$t = /*@__PURE__*/ markType(NativeUIFocusEventArgs, 'NativeUIFocusEventArgs');
    return NativeUIFocusEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUISizeChangedEventArgs = /*@__PURE__*/ (() => {
    class NativeUISizeChangedEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = 0;
            this.a = 0;
        }
    }
    NativeUISizeChangedEventArgs.$t = /*@__PURE__*/ markType(NativeUISizeChangedEventArgs, 'NativeUISizeChangedEventArgs');
    return NativeUISizeChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIPositionChangedEventArgs = /*@__PURE__*/ (() => {
    class NativeUIPositionChangedEventArgs extends Base {
    }
    NativeUIPositionChangedEventArgs.$t = /*@__PURE__*/ markType(NativeUIPositionChangedEventArgs, 'NativeUIPositionChangedEventArgs');
    return NativeUIPositionChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectChangedEventArgs = /*@__PURE__*/ (() => {
    class RectChangedEventArgs extends EventArgs {
        constructor(a, b) {
            super();
            this._oldRect = null;
            this._newRect = null;
            this.oldRect = a;
            this.newRect = b;
        }
        get oldRect() {
            return this._oldRect;
        }
        set oldRect(a) {
            this._oldRect = a;
        }
        get newRect() {
            return this._newRect;
        }
        set newRect(a) {
            this._newRect = a;
        }
    }
    RectChangedEventArgs.$t = /*@__PURE__*/ markType(RectChangedEventArgs, 'RectChangedEventArgs', EventArgs.$);
    return RectChangedEventArgs;
})();

/**
 * Provides data for rectangle changed events.
*/
class IgrRectChangedEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets the rectangle before the change.
    */
    get oldRect() {
        return fromRect(this.i.oldRect);
    }
    set oldRect(v) {
        this.i.oldRect = toRect(v);
    }
    /**
     * Gets the new rectangle.
    */
    get newRect() {
        return fromRect(this.i.newRect);
    }
    set newRect(v) {
        this.i.newRect = toRect(v);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArrayExtension = /*@__PURE__*/ (() => {
    class ArrayExtension extends Base {
        static shuffle$1($t, a) {
            if (a != null) {
                let b = new Random(0);
                for (let c = a.count - 1; c > 0; --c) {
                    let d = b.next1(c);
                    let e = a.item(c);
                    a.item(c, a.item(d));
                    a.item(d, e);
                }
            }
        }
        static quickSort(a, b) {
            ArrayExtension.h(a, 0, a.count - 1, b);
        }
        static h(a, b, c, d) {
            if (b < c) {
                let e = ArrayExtension.f(a, b, c, d);
                ArrayExtension.h(a, b, e - 1, d);
                ArrayExtension.h(a, e + 1, c, d);
            }
        }
        static f(a, b, c, d) {
            let e = a.item(c);
            let f = b;
            for (let g = b; g < c; g++) {
                if (d(a.item(g), e) <= 0) {
                    let h = a.item(f);
                    a.item(f, a.item(g));
                    a.item(g, h);
                    f++;
                }
            }
            let i = a.item(f);
            a.item(f, a.item(c));
            a.item(c, i);
            return f;
        }
        static insertionIndex$1($t, a, b) {
            let c = -1;
            let d = 0;
            let e = a.count;
            while (c == -1) {
                if (e <= d) {
                    c = d;
                }
                else {
                    let f = intDivide((d + e), 2);
                    switch (Math.sign(CompareUtil.compareToObject(b, getBoxIfEnum($t, a.item(f))))) {
                        case -1:
                            e = f;
                            break;
                        case 0:
                            c = f;
                            break;
                        case 1:
                            d = f + 1;
                            break;
                    }
                }
            }
            return c;
        }
        static insertionIndex$11($t, a, b, c) {
            let d = -1;
            let e = 0;
            let f = a.count;
            while (d == -1) {
                if (f <= e) {
                    d = e;
                }
                else {
                    let g = intDivide((e + f), 2);
                    switch (Math.sign(b(c, a.item(g)))) {
                        case -1:
                            f = g;
                            break;
                        case 0:
                            d = g;
                            break;
                        case 1:
                            e = g + 1;
                            break;
                    }
                }
            }
            return d;
        }
        static binarySearch$11($t, a, b) {
            let c = 0;
            let d = a.count - 1;
            while (c <= d) {
                let e = (c + ((d - c) >> 1));
                let f = b(a.item(e));
                if (f < 0) {
                    d = e - 1;
                }
                else if (f > 0) {
                    c = e + 1;
                }
                else {
                    return e;
                }
            }
            return ~c;
        }
        static binarySearch$1($t, a, b) {
            let c = 0;
            let d = a.count - 1;
            while (c <= d) {
                let e = (c + ((d - c) >> 1));
                let f = b(a.item(e));
                if (f < 0) {
                    d = e - 1;
                }
                else if (f > 0) {
                    c = e + 1;
                }
                else {
                    return e;
                }
            }
            return ~c;
        }
        static getModulus$1($t, a, b) {
            if (a == null) {
                return Type.getDefaultValue($t);
            }
            if (a.count == 0) {
                return Type.getDefaultValue($t);
            }
            return a.item(b % a.count);
        }
    }
    ArrayExtension.$t = /*@__PURE__*/ markType(ArrayExtension, 'ArrayExtension');
    return ArrayExtension;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IPlatformAPIHelperImpl_$type = /*@__PURE__*/ new Type(null, 'IPlatformAPIHelperImpl');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PlatformAPIHelper = /*@__PURE__*/ (() => {
    class PlatformAPIHelper extends Base {
        static a(a) {
            if (a == null) {
                return null;
            }
            return a._fill;
        }
        static b(a) {
            if (Color.c(toNullable(Color.$, a), toNullable(Color.$, null))) {
                return null;
            }
            return a.colorString;
        }
        static d(a) {
            if (PointUtil.equals(a, null)) {
                return null;
            }
            let b = {};
            let c = b;
            c["x"] = a.x;
            c["y"] = a.y;
            return c;
        }
        static g(a) {
            if (Size.l_op_Equality_Lifted(toNullable(Size.$, a), toNullable(Size.$, null))) {
                return null;
            }
            let b = {};
            let c = b;
            c["width"] = a.width;
            c["height"] = a.height;
            return c;
        }
        static f(a) {
            if (Rect.l_op_Equality(a, null)) {
                return null;
            }
            let b = {};
            let c = b;
            c["left"] = a.left;
            c["top"] = a.top;
            c["width"] = a.width;
            c["height"] = a.height;
            return c;
        }
        static c(a) {
            if (a == null) {
                return null;
            }
            return a.toArray();
        }
        static h(a) {
            if (a == null) {
                return null;
            }
            return Brush.create(a);
        }
        static j(a) {
            if (a == null) {
                return null;
            }
            let b = a;
            return { $type: Point_$type, x: b["x"], y: b["y"] };
        }
        static m(a) {
            if (a == null) {
                return null;
            }
            let b = a;
            return new Size(1, b["width"], b["height"]);
        }
        static l(a) {
            if (a == null) {
                return null;
            }
            let b = a;
            return new Rect(0, b["left"], b["top"], b["width"], b["height"]);
        }
        static i(a) {
            if (a == null) {
                return null;
            }
            let b = a;
            let c = new DoubleCollection();
            for (let d = 0; d < b.length; d++) {
                c.add(b[d]);
            }
            return c;
        }
        static e(a, b) {
            if (a == Brush.$) {
                return PlatformAPIHelper.a(b);
            }
            if (a == Color.$) {
                return PlatformAPIHelper.b(b);
            }
            if (a == Point_$type) {
                return PlatformAPIHelper.d(b);
            }
            if (a == Size.$) {
                return PlatformAPIHelper.g(b);
            }
            if (a == Rect.$) {
                return PlatformAPIHelper.f(b);
            }
            if (a == DoubleCollection.$) {
                return PlatformAPIHelper.c(b);
            }
            return b;
        }
        static k(a, b) {
            if (a == Brush.$) {
                return PlatformAPIHelper.h(b);
            }
            if (a == Color.$) {
                let c = PlatformAPIHelper.h(b);
                if (c == null) {
                    return null;
                }
                return c._fill;
            }
            if (a == Point_$type) {
                return PlatformAPIHelper.j(b);
            }
            if (a == Size.$) {
                return PlatformAPIHelper.m(b);
            }
            if (a == Rect.$) {
                return PlatformAPIHelper.l(b);
            }
            if (a == DoubleCollection.$) {
                return PlatformAPIHelper.i(b);
            }
            return b;
        }
        static n(a) {
            if (a == null) {
                return null;
            }
            if (a.length == 1) {
                return a.toLowerCase();
            }
            return a.substr(0, 1).toLowerCase() + a.substr(1);
        }
        static o(a) {
            if (a == null) {
                return null;
            }
            if (a.length == 1) {
                return a.toUpperCase();
            }
            return a.substr(0, 1).toUpperCase() + a.substr(1);
        }
    }
    PlatformAPIHelper.$t = /*@__PURE__*/ markType(PlatformAPIHelper, 'PlatformAPIHelper');
    return PlatformAPIHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CoreGeometryUtil = /*@__PURE__*/ (() => {
    class CoreGeometryUtil extends Base {
        static a(a) {
            if (isNaN_(a) || isInfinity(a)) {
                return a;
            }
            while (a > 360) {
                a -= 360;
            }
            while (a < 0) {
                a += 360;
            }
            return a;
        }
        static b(a) {
            if (isNaN_(a) || isInfinity(a)) {
                return a;
            }
            while (a > Math.PI * 2) {
                a -= Math.PI * 2;
            }
            while (a < 0) {
                a += Math.PI * 2;
            }
            return a;
        }
        static c(a, b, c, d, e) {
            let f = { $type: Point_$type, x: (a.x + b.x) / 2, y: (a.y + b.y) / 2 };
            let g = b.x - a.x;
            let h = b.y - a.y;
            let i = Math.sqrt(g * g + h * h);
            let j = h;
            let k = g * -1;
            if (e == d) {
                j = h * -1;
                k = g;
            }
            let l = Math.max(Math.abs(j), Math.abs(k));
            j = j / l;
            k = k / l;
            let m = Math.sqrt(j * j + k * k);
            let n = j / m;
            let o = k / m;
            let p = i / 2;
            let q = Math.sqrt(c * c - p * p);
            if (isNaN_(q)) {
                q = 0;
            }
            let r = q * n;
            let s = q * o;
            let t = { $type: Point_$type, x: f.x + r, y: f.y + s };
            return t;
        }
    }
    CoreGeometryUtil.$t = /*@__PURE__*/ markType(CoreGeometryUtil, 'CoreGeometryUtil');
    return CoreGeometryUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DeviceUtils = /*@__PURE__*/ (() => {
    class DeviceUtils extends Base {
        static g(a) {
            return a;
        }
        static f(a) {
            return a;
        }
        static a(a) {
            if (isNaN_(a)) {
                return NaN;
            }
            if (a <= 0) {
                return NaN;
            }
            return a;
        }
        static c(a) {
            return a * DeviceUtils.d();
        }
        static b(a) {
            return a * DeviceUtils.e();
        }
        static d() {
            let a = DeviceUtils.g(2);
            return 2 / a;
        }
        static e() {
            let a = DeviceUtils.f(2);
            return 2 / a;
        }
    }
    DeviceUtils.$t = /*@__PURE__*/ markType(DeviceUtils, 'DeviceUtils');
    return DeviceUtils;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathSegment = /*@__PURE__*/ (() => {
    class PathSegment extends Base {
    }
    PathSegment.$t = /*@__PURE__*/ markType(PathSegment, 'PathSegment');
    return PathSegment;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathSegmentCollection = /*@__PURE__*/ (() => {
    class PathSegmentCollection extends List$1 {
        constructor() {
            super(PathSegment.$, 0);
        }
    }
    PathSegmentCollection.$t = /*@__PURE__*/ markType(PathSegmentCollection, 'PathSegmentCollection', /*@__PURE__*/ List$1.$.specialize(PathSegment.$));
    return PathSegmentCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathFigure = /*@__PURE__*/ (() => {
    class PathFigure extends Base {
        constructor() {
            super();
            this._segments = null;
            this._startPoint = null;
            this._isFilled = false;
            this._isClosed = false;
            this._segments = new PathSegmentCollection();
            this._isClosed = false;
            this._isFilled = true;
        }
        get segments() {
            return this._segments;
        }
        set segments(a) {
            this._segments = a;
        }
        get startPoint() {
            return this._startPoint;
        }
        set startPoint(a) {
            this._startPoint = a;
        }
        get isFilled() {
            return this._isFilled;
        }
        set isFilled(a) {
            this._isFilled = a;
        }
        get isClosed() {
            return this._isClosed;
        }
        set isClosed(a) {
            this._isClosed = a;
        }
    }
    PathFigure.$t = /*@__PURE__*/ markType(PathFigure, 'PathFigure');
    return PathFigure;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathFigureCollection = /*@__PURE__*/ (() => {
    class PathFigureCollection extends List$1 {
        constructor() {
            super(PathFigure.$, 0);
        }
    }
    PathFigureCollection.$t = /*@__PURE__*/ markType(PathFigureCollection, 'PathFigureCollection', /*@__PURE__*/ List$1.$.specialize(PathFigure.$));
    return PathFigureCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathMarkupToken = /*@__PURE__*/ (() => {
    class PathMarkupToken extends Base {
        constructor(a, b) {
            super();
            this.c = 0;
            this.a = false;
            this.b = 0;
            this.c = a;
            this.a = b;
        }
    }
    PathMarkupToken.$t = /*@__PURE__*/ markType(PathMarkupToken, 'PathMarkupToken');
    return PathMarkupToken;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineSegment = /*@__PURE__*/ (() => {
    class LineSegment extends PathSegment {
        get c() {
            return this.b;
        }
        set c(a) {
            this.b = a;
        }
        constructor(a, ..._rest) {
            super();
            this.b = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        this.c = c;
                    }
                    break;
                case 1: break;
            }
        }
        get_a() {
            return 0;
        }
        get a() {
            return this.get_a();
        }
    }
    LineSegment.$t = /*@__PURE__*/ markType(LineSegment, 'LineSegment', PathSegment.$);
    return LineSegment;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BezierSegment = /*@__PURE__*/ (() => {
    class BezierSegment extends PathSegment {
        get e() {
            return this.b;
        }
        set e(a) {
            this.b = a;
        }
        get f() {
            return this.c;
        }
        set f(a) {
            this.c = a;
        }
        get g() {
            return this.d;
        }
        set g(a) {
            this.d = a;
        }
        constructor(a, ..._rest) {
            super();
            this.b = null;
            this.c = null;
            this.d = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.e = this.f = this.g = { $type: Point_$type, x: 0, y: 0 };
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        this.e = c;
                        this.f = d;
                        this.g = e;
                    }
                    break;
            }
        }
        get_a() {
            return 1;
        }
        get a() {
            return this.get_a();
        }
    }
    BezierSegment.$t = /*@__PURE__*/ markType(BezierSegment, 'BezierSegment', PathSegment.$);
    return BezierSegment;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArcSegment = /*@__PURE__*/ (() => {
    class ArcSegment extends PathSegment {
        constructor() {
            super();
            this.e = null;
            this.b = false;
            this.d = 0;
            this.f = new Size();
            this.c = 0;
            this.b = false;
            this.d = 0;
        }
        get_a() {
            return 4;
        }
        get a() {
            return this.get_a();
        }
    }
    ArcSegment.$t = /*@__PURE__*/ markType(ArcSegment, 'ArcSegment', PathSegment.$);
    return ArcSegment;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Geometry = /*@__PURE__*/ (() => {
    class Geometry extends Base {
        constructor() {
            super();
        }
        static a(a) {
            if (a != null) {
                let b = new PathMarkupParser();
                return b.k(a);
            }
            return null;
        }
    }
    Geometry.$t = /*@__PURE__*/ markType(Geometry, 'Geometry');
    return Geometry;
})();
/**
 * @hidden
 */
let PathGeometry = /*@__PURE__*/ (() => {
    class PathGeometry extends Geometry {
        constructor() {
            super();
            this.c = null;
            this.c = new PathFigureCollection();
        }
        get_b() {
            return 4;
        }
        get b() {
            return this.get_b();
        }
    }
    PathGeometry.$t = /*@__PURE__*/ markType(PathGeometry, 'PathGeometry', Geometry.$);
    return PathGeometry;
})();
/**
 * @hidden
 */
let PathMarkupParser = /*@__PURE__*/ (() => {
    class PathMarkupParser extends Base {
        constructor() {
            super(...arguments);
            this.e = '\0';
            this.h = 0;
            this.l = { $type: Point_$type, x: 0, y: 0 };
            this.f = null;
            this.i = null;
        }
        k(a) {
            this.f = new List$1(PathMarkupToken.$, 0);
            this.h = 0;
            while (this.d(a)) {
                switch (this.e) {
                    case 'M':
                    case 'm':
                        this.f.add(new PathMarkupToken(0, this.e.charCodeAt(0) < 'm'.charCodeAt(0)));
                        break;
                    case 'L':
                    case 'l':
                        this.f.add(new PathMarkupToken(1, this.e.charCodeAt(0) < 'l'.charCodeAt(0)));
                        break;
                    case 'H':
                    case 'h':
                        this.f.add(new PathMarkupToken(2, this.e.charCodeAt(0) < 'h'.charCodeAt(0)));
                        break;
                    case 'V':
                    case 'v':
                        this.f.add(new PathMarkupToken(3, this.e.charCodeAt(0) < 'v'.charCodeAt(0)));
                        break;
                    case 'C':
                    case 'c':
                        this.f.add(new PathMarkupToken(4, this.e.charCodeAt(0) < 'c'.charCodeAt(0)));
                        break;
                    case 'Q':
                    case 'q':
                        this.f.add(new PathMarkupToken(5, this.e.charCodeAt(0) < 'q'.charCodeAt(0)));
                        break;
                    case 'S':
                    case 's':
                        this.f.add(new PathMarkupToken(6, this.e.charCodeAt(0) < 's'.charCodeAt(0)));
                        break;
                    case 'T':
                    case 't':
                        this.f.add(new PathMarkupToken(7, this.e.charCodeAt(0) < 't'.charCodeAt(0)));
                        break;
                    case 'A':
                    case 'a':
                        this.f.add(new PathMarkupToken(8, this.e.charCodeAt(0) < 'a'.charCodeAt(0)));
                        break;
                    case 'Z':
                    case 'z':
                        this.f.add(new PathMarkupToken(9, this.e.charCodeAt(0) < 'z'.charCodeAt(0)));
                        break;
                }
                if (this.a(this.e)) {
                    let b = true;
                    let c = false;
                    let d = false;
                    let e = stringEmpty();
                    let f = false;
                    this.h = this.h - 1;
                    while (this.h < a.length) {
                        let g = a.charAt(this.h);
                        if (d) {
                            if (!this.a(g)) {
                                f = true;
                                break;
                            }
                            else {
                                e += g;
                                this.h++;
                                if (this.h >= a.length) {
                                    f = true;
                                    break;
                                }
                            }
                        }
                        else if (c) {
                            if (g == 'e' || g == 'E') {
                                d = true;
                                e += g;
                                this.h++;
                                continue;
                            }
                            if ((g == '-' || g == '+') && e.length > 0) {
                                f = true;
                                break;
                            }
                            if (!this.a(g)) {
                                f = true;
                                break;
                            }
                            else {
                                e += g;
                                this.h++;
                                if (this.h >= a.length) {
                                    f = true;
                                    break;
                                }
                            }
                        }
                        else if (b) {
                            if (g == '.') {
                                c = true;
                                e += g;
                                this.h++;
                                continue;
                            }
                            if (g == 'e' || g == 'E') {
                                d = true;
                                e += g;
                                this.h++;
                                continue;
                            }
                            if ((g == '-' || g == '+') && e.length > 0) {
                                f = true;
                                break;
                            }
                            if (!this.a(g)) {
                                f = true;
                                break;
                            }
                            else {
                                e += g;
                                this.h++;
                                if (this.h >= a.length) {
                                    f = true;
                                    break;
                                }
                            }
                        }
                    }
                    if (f) {
                        this.f.add(((() => {
                            let $ret = new PathMarkupToken(10, false);
                            $ret.b = parseFloat(e);
                            return $ret;
                        })()));
                    }
                }
            }
            return this.j();
        }
        a(a) {
            return a == '.' || a == '-' || a == '+' || (a.charCodeAt(0) >= '0'.charCodeAt(0) && a.charCodeAt(0) <= '9'.charCodeAt(0));
        }
        j() {
            this.h = 0;
            let a = true;
            let b = new PathGeometry();
            let c = null;
            let d = 11;
            let e = null;
            let f = null;
            let g = null;
            while (this.h < this.f.count) {
                let h = this.f._inner[this.h++];
                if (a && h.c != 0) {
                    return null;
                }
                switch (h.c) {
                    case 0:
                        c = new PathFigure();
                        b.c.add(c);
                        this.l = this.m(h.a);
                        c._startPoint = this.l;
                        while (this.b()) {
                            this.l = this.m(h.a);
                            c._segments.add(new LineSegment(0, this.l));
                        }
                        d = 0;
                        break;
                    case 1:
                    case 2:
                    case 3:
                        if (c == null) {
                            return null;
                        }
                        do {
                            switch (h.c) {
                                case 1:
                                    this.l = this.m(h.a);
                                    break;
                                case 2:
                                    this.l.x = h.a ? this.g() : this.l.x + this.g();
                                    break;
                                case 3:
                                    this.l.y = h.a ? this.g() : this.l.y + this.g();
                                    break;
                            }
                            c._segments.add(new LineSegment(0, this.l));
                        } while (this.b());
                        d = 1;
                        break;
                    case 4:
                    case 6:
                        if (c == null) {
                            return null;
                        }
                        do {
                            if (h.c == 6) {
                                if (d == 4) {
                                    e = { $type: Point_$type, x: 2 * this.l.x - f.x, y: 2 * this.l.y - f.y };
                                }
                                else {
                                    e = this.l;
                                }
                            }
                            else {
                                e = this.m(h.a);
                            }
                            f = this.m(h.a);
                            g = this.m(h.a);
                            c._segments.add(new BezierSegment(1, e, f, g));
                            this.l = g;
                            d = 4;
                        } while (this.b());
                        break;
                    case 5:
                    case 7: break;
                    case 8:
                        if (c == null) {
                            return null;
                        }
                        do {
                            let i = this.g();
                            let j = this.g();
                            let k = this.g();
                            let l = this.g();
                            let m = this.g();
                            this.l = this.m(h.a);
                            c._segments.add(((() => {
                                let $ret = new ArcSegment();
                                $ret.e = this.l;
                                $ret.f = new Size(1, i, j);
                                $ret.c = k;
                                $ret.b = l == 1;
                                $ret.d = m == 1 ? 1 : 0;
                                return $ret;
                            })()));
                        } while (this.b());
                        d = 8;
                        break;
                    case 9:
                        if (c == null) {
                            return null;
                        }
                        c._isClosed = true;
                        break;
                }
                a = false;
            }
            return b;
        }
        m(a) {
            let b = this.g();
            let c = this.g();
            if (!a) {
                b += this.l.x;
                c += this.l.y;
            }
            return { $type: Point_$type, x: b, y: c };
        }
        g() {
            let a = this.f._inner[this.h++];
            if (a.c != 10) {
                throw new InvalidOperationException(0);
            }
            return a.b;
        }
        b() {
            if (this.h >= this.f.count) {
                return false;
            }
            return this.f._inner[this.h].c == 10;
        }
        d(a) {
            while (this.h < a.length && this.c(a.charAt(this.h))) {
                this.h++;
            }
            if (this.h < a.length) {
                this.e = a.charAt(this.h);
                this.h++;
                return true;
            }
            return false;
        }
        c(a) {
            return a == '\r' || a == '\n' || a == ' ' || a == '\t';
        }
    }
    PathMarkupParser.$t = /*@__PURE__*/ markType(PathMarkupParser, 'PathMarkupParser');
    return PathMarkupParser;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UIElement = /*@__PURE__*/ (() => {
    class UIElement extends DependencyObject {
        constructor() {
            super(...arguments);
            this.j = null;
        }
    }
    UIElement.$t = /*@__PURE__*/ markType(UIElement, 'UIElement', DependencyObject.$);
    return UIElement;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FrameworkElement = /*@__PURE__*/ (() => {
    class FrameworkElement extends UIElement {
        constructor() {
            super();
            this._name = null;
            this.m = 0;
            this.l = 0;
            this._visibility = 0;
            this._width = 0;
            this._height = 0;
            this.o = 0;
            this.n = 0;
            this.s = 0;
            this.x = null;
            this._dataContext = null;
            this._opacity = 1;
            this.y = null;
            this._opacity = 1;
            this.s = 0;
            this._visibility = 0;
            this.width = NaN;
            this.height = NaN;
        }
        get name() {
            return this._name;
        }
        set name(a) {
            this._name = a;
        }
        get visibility() {
            return this._visibility;
        }
        set visibility(a) {
            if (this._visibility != a) {
                let b = this._visibility;
                this._visibility = a;
                this.w(b, this._visibility);
            }
        }
        w(a, b) {
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
        get dataContext() {
            return this._dataContext;
        }
        set dataContext(a) {
            this._dataContext = a;
        }
        get opacity() {
            return this._opacity;
        }
        set opacity(a) {
            if (this._opacity != a) {
                this._opacity = a;
                this.v();
            }
        }
        v() {
        }
    }
    FrameworkElement.$t = /*@__PURE__*/ markType(FrameworkElement, 'FrameworkElement', UIElement.$);
    return FrameworkElement;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UIElementCollection = /*@__PURE__*/ (() => {
    class UIElementCollection extends ObservableCollection$1 {
        constructor(a) {
            super(UIElement.$, 0);
            this.ae = null;
            this.ae = a;
        }
        ac(a) {
            super.ac(a);
            if (a.oldItems != null) {
                for (let b of fromEn(a.oldItems)) {
                    b.x = null;
                }
            }
            if (a.newItems != null) {
                for (let c of fromEn(a.newItems)) {
                    c.x = this.ae;
                }
            }
        }
        p() {
            for (let a of fromEnum(this)) {
                a.x = null;
            }
            super.p();
        }
    }
    UIElementCollection.$t = /*@__PURE__*/ markType(UIElementCollection, 'UIElementCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(UIElement.$));
    return UIElementCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Panel = /*@__PURE__*/ (() => {
    class Panel extends FrameworkElement {
        constructor() {
            super();
            this.ab = null;
            this.ab = new UIElementCollection(this);
        }
    }
    Panel.$t = /*@__PURE__*/ markType(Panel, 'Panel', FrameworkElement.$);
    return Panel;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Control = /*@__PURE__*/ (() => {
    class Control extends FrameworkElement {
        constructor() {
            super();
            this.ab = null;
            this.ae = null;
            this.ad = 0;
            this.af = 0;
        }
        ac() {
        }
    }
    Control.$t = /*@__PURE__*/ markType(Control, 'Control', FrameworkElement.$);
    return Control;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ContentControl = /*@__PURE__*/ (() => {
    class ContentControl extends Control {
        constructor() {
            super(...arguments);
            this._content = null;
            this.ah = null;
        }
        get content() {
            return this._content;
        }
        set content(a) {
            this._content = a;
        }
    }
    ContentControl.$t = /*@__PURE__*/ markType(ContentControl, 'ContentControl', Control.$);
    return ContentControl;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Extensions = /*@__PURE__*/ (() => {
    class Extensions extends Base {
        static e(a) {
            a.c.clear();
            a.c.add(new PathFigure());
            a.c.removeAt(0);
        }
        static d(a) {
            a.d.clear();
            a.d.add(new PathGeometry());
            a.d.removeAt(0);
        }
        static c(a) {
            if (a == null) {
                return;
            }
            let b = typeCast(Panel.$, a.x);
            if (b != null) {
                b.ab.remove(a);
                return;
            }
            let c = typeCast(ContentControl.$, a.x);
            if (c != null) {
                c.content = null;
                return;
            }
        }
        static f(a, b) {
            let c = new List$1(UIElement.$, 0);
            for (let d of fromEnum(a.ab)) {
                if (typeCast(UIElement.$, d) !== null) {
                    c.add(d);
                }
            }
            for (let e of fromEnum(c)) {
                a.ab.remove(e);
                b.ab.add(e);
            }
        }
        static a(a) {
            return !isNaN_(a.x) && !isNaN_(a.y) && !isInfinity(a.x) && !isInfinity(a.y);
        }
        static b(a) {
            return !isNaN_(a.left) && !isNaN_(a.right) && !isNaN_(a.top) && !isNaN_(a.bottom) && !isInfinity(a.left) && !isInfinity(a.right) && !isInfinity(a.top) && !isInfinity(a.bottom);
        }
    }
    Extensions.$t = /*@__PURE__*/ markType(Extensions, 'Extensions');
    return Extensions;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FrameworkElementExtensions = /*@__PURE__*/ (() => {
    class FrameworkElementExtensions extends Base {
        static a(a, b) {
            return a.x != null;
        }
    }
    FrameworkElementExtensions.$t = /*@__PURE__*/ markType(FrameworkElementExtensions, 'FrameworkElementExtensions');
    return FrameworkElementExtensions;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IVisualData_$type = /*@__PURE__*/ new Type(null, 'IVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MathUtilExtended = /*@__PURE__*/ (() => {
    class MathUtilExtended extends Base {
        static d(a) {
            if (a <= 0) {
                return NaN;
            }
            let b = [57.156235665862923, -59.597960355475493, 14.136097974741746, -0.49191381609762019, 3.3994649984811891E-05, 4.6523628927048578E-05, -9.8374475304879565E-05, 0.00015808870322491249, -0.00021026444172410488, 0.00021743961811521265, -0.00016431810653676389, 8.441822398385275E-05, -2.6190838401581408E-05, 3.6899182659531625E-06];
            let c = a;
            let d = (a + 0.5) * Math.log(a + 5.2421875) - (a + 5.2421875);
            let e = 0.99999999999999711;
            for (let f = 0; f < 14; f++) {
                e += b[f] / ++c;
            }
            return d + Math.log(2.5066282746310007 * e / a);
        }
        static j(a, b, c) {
            let d = truncate(Math.floor(a)) & 255;
            let e = truncate(Math.floor(b)) & 255;
            let f = truncate(Math.floor(c)) & 255;
            a -= Math.floor(a);
            b -= Math.floor(b);
            c -= Math.floor(c);
            let g = MathUtilExtended.c(a);
            let h = MathUtilExtended.c(b);
            let i = MathUtilExtended.c(c);
            let j = MathUtilExtended.a[d] + e;
            let k = MathUtilExtended.a[j] + f;
            let l = MathUtilExtended.a[j + 1] + f;
            let m = MathUtilExtended.a[d + 1] + e;
            let n = MathUtilExtended.a[m] + f;
            let o = MathUtilExtended.a[m + 1] + f;
            return MathUtilExtended.f(i, MathUtilExtended.f(h, MathUtilExtended.f(g, MathUtilExtended.e(MathUtilExtended.a[k], a, b, c), MathUtilExtended.e(MathUtilExtended.a[n], a - 1, b, c)), MathUtilExtended.f(g, MathUtilExtended.e(MathUtilExtended.a[l], a, b - 1, c), MathUtilExtended.e(MathUtilExtended.a[o], a - 1, b - 1, c))), MathUtilExtended.f(h, MathUtilExtended.f(g, MathUtilExtended.e(MathUtilExtended.a[k + 1], a, b, c - 1), MathUtilExtended.e(MathUtilExtended.a[n + 1], a - 1, b, c - 1)), MathUtilExtended.f(g, MathUtilExtended.e(MathUtilExtended.a[l + 1], a, b - 1, c - 1), MathUtilExtended.e(MathUtilExtended.a[o + 1], a - 1, b - 1, c - 1))));
        }
        static c(a) {
            return a * a * a * (a * (a * 6 - 15) + 10);
        }
        static f(a, b, c) {
            return b + a * (c - b);
        }
        static e(a, b, c, d) {
            let e = a & 15;
            let f = e < 8 ? b : c;
            let g = e < 4 ? c : e == 12 || e == 14 ? b : d;
            return ((e & 1) == 0 ? f : -f) + ((e & 2) == 0 ? g : -g);
        }
        static h(a) {
            if (a == 0) {
                return 0;
            }
            if (a < 0) {
                return -MathUtilExtended.g(-a);
            }
            let b = truncate(Math.floor(log10(a)));
            let c = a / MathUtilExtended.b(10, b);
            let d = c < 2 ? 1 : (c < 5 ? 2 : (c < 10 ? 5 : 10));
            return d * MathUtilExtended.b(10, b);
        }
        static i(a) {
            if (a == 0) {
                return 0;
            }
            if (a < 0) {
                return -MathUtilExtended.i(-a);
            }
            let b = truncate(Math.floor(log10(a)));
            let c = a / MathUtilExtended.b(10, b);
            let d = c < 1 ? 1 : (c < 3 ? 2 : (c < 7 ? 5 : 10));
            return d * MathUtilExtended.b(10, b);
        }
        static g(a) {
            if (a == 0) {
                return 0;
            }
            if (a < 0) {
                return -MathUtilExtended.h(-a);
            }
            let b = truncate(Math.floor(log10(a)));
            let c = a / MathUtilExtended.b(10, b);
            let d = c <= 1 ? 1 : (c <= 2 ? 2 : (c <= 5 ? 5 : 10));
            return d * MathUtilExtended.b(10, b);
        }
        static b(a, b) {
            let c = 1;
            for (; b > 0; --b) {
                c *= a;
            }
            for (; b < 0; ++b) {
                c /= a;
            }
            return c;
        }
    }
    MathUtilExtended.$t = /*@__PURE__*/ markType(MathUtilExtended, 'MathUtilExtended');
    MathUtilExtended.a = [151, 160, 137, 91, 90, 15, 131, 13, 201, 95, 96, 53, 194, 233, 7, 225, 140, 36, 103, 30, 69, 142, 8, 99, 37, 240, 21, 10, 23, 190, 6, 148, 247, 120, 234, 75, 0, 26, 197, 62, 94, 252, 219, 203, 117, 35, 11, 32, 57, 177, 33, 88, 237, 149, 56, 87, 174, 20, 125, 136, 171, 168, 68, 175, 74, 165, 71, 134, 139, 48, 27, 166, 77, 146, 158, 231, 83, 111, 229, 122, 60, 211, 133, 230, 220, 105, 92, 41, 55, 46, 245, 40, 244, 102, 143, 54, 65, 25, 63, 161, 1, 216, 80, 73, 209, 76, 132, 187, 208, 89, 18, 169, 200, 196, 135, 130, 116, 188, 159, 86, 164, 100, 109, 198, 173, 186, 3, 64, 52, 217, 226, 250, 124, 123, 5, 202, 38, 147, 118, 126, 255, 82, 85, 212, 207, 206, 59, 227, 47, 16, 58, 17, 182, 189, 28, 42, 223, 183, 170, 213, 119, 248, 152, 2, 44, 154, 163, 70, 221, 153, 101, 155, 167, 43, 172, 9, 129, 22, 39, 253, 19, 98, 108, 110, 79, 113, 224, 232, 178, 185, 112, 104, 218, 246, 97, 228, 251, 34, 242, 193, 238, 210, 144, 12, 191, 179, 162, 241, 81, 51, 145, 235, 249, 14, 239, 107, 49, 192, 214, 31, 181, 199, 106, 157, 184, 84, 204, 176, 115, 121, 50, 45, 127, 4, 150, 254, 138, 236, 205, 93, 222, 114, 67, 29, 24, 72, 243, 141, 128, 195, 78, 66, 215, 61, 156, 180, 151, 160, 137, 91, 90, 15, 131, 13, 201, 95, 96, 53, 194, 233, 7, 225, 140, 36, 103, 30, 69, 142, 8, 99, 37, 240, 21, 10, 23, 190, 6, 148, 247, 120, 234, 75, 0, 26, 197, 62, 94, 252, 219, 203, 117, 35, 11, 32, 57, 177, 33, 88, 237, 149, 56, 87, 174, 20, 125, 136, 171, 168, 68, 175, 74, 165, 71, 134, 139, 48, 27, 166, 77, 146, 158, 231, 83, 111, 229, 122, 60, 211, 133, 230, 220, 105, 92, 41, 55, 46, 245, 40, 244, 102, 143, 54, 65, 25, 63, 161, 1, 216, 80, 73, 209, 76, 132, 187, 208, 89, 18, 169, 200, 196, 135, 130, 116, 188, 159, 86, 164, 100, 109, 198, 173, 186, 3, 64, 52, 217, 226, 250, 124, 123, 5, 202, 38, 147, 118, 126, 255, 82, 85, 212, 207, 206, 59, 227, 47, 16, 58, 17, 182, 189, 28, 42, 223, 183, 170, 213, 119, 248, 152, 2, 44, 154, 163, 70, 221, 153, 101, 155, 167, 43, 172, 9, 129, 22, 39, 253, 19, 98, 108, 110, 79, 113, 224, 232, 178, 185, 112, 104, 218, 246, 97, 228, 251, 34, 242, 193, 238, 210, 144, 12, 191, 179, 162, 241, 81, 51, 145, 235, 249, 14, 239, 107, 49, 192, 214, 31, 181, 199, 106, 157, 184, 84, 204, 176, 115, 121, 50, 45, 127, 4, 150, 254, 138, 236, 205, 93, 222, 114, 67, 29, 24, 72, 243, 141, 128, 195, 78, 66, 215, 61, 156, 180];
    return MathUtilExtended;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IPool$1_$type = /*@__PURE__*/ new Type(null, 'IPool$1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IIndexedPool$1_$type = /*@__PURE__*/ new Type(null, 'IIndexedPool$1', null, [/*@__PURE__*/ IPool$1_$type.specialize(0)]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Pool$1 = /*@__PURE__*/ (() => {
    class Pool$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this._create = null;
            this._disactivate = null;
            this._activate = null;
            this._destroy = null;
            this.a = null;
            this.b = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.a = new List$1(this.$t, 0);
            this.b = new List$1(this.$t, 0);
        }
        get create() {
            return this._create;
        }
        set create(a) {
            this._create = a;
        }
        get disactivate() {
            return this._disactivate;
        }
        set disactivate(a) {
            this._disactivate = a;
        }
        get activate() {
            return this._activate;
        }
        set activate(a) {
            this._activate = a;
        }
        get destroy() {
            return this._destroy;
        }
        set destroy(a) {
            this._destroy = a;
        }
        item(a) {
            if (a >= this.count) {
                this.count = a + 1;
            }
            return this.a._inner[a];
        }
        clear() {
            this.count = 0;
        }
        get count() {
            return this.a.count;
        }
        set count(a) {
            let b = this.a.count;
            while (a > this.a.count && this.b.count > 0) {
                let c = this.b._inner[this.b.count - 1];
                this.a.add(c);
                this.b.removeAt(this.b.count - 1);
                if (this.activate != null) {
                    this.activate(c);
                }
            }
            while (a > this.a.count && this.b.count == 0) {
                let d = this.create();
                this.a.add(d);
                if (this.activate != null) {
                    this.activate(d);
                }
            }
            let e = 2;
            while (b != 0) {
                b >>= 1;
                e <<= 1;
            }
            while (a < this.a.count) {
                let f = this.a._inner[this.a.count - 1];
                this.a.removeAt(this.a.count - 1);
                if (this.disactivate != null) {
                    this.disactivate(f);
                }
                if (this.b.count < e) {
                    this.b.add(f);
                }
                else {
                    if (this.destroy != null) {
                        this.destroy(f);
                    }
                }
            }
            if (e < this.b.count) {
                for (let g = e; g < this.b.count; ++g) {
                    this.destroy(this.b._inner[g]);
                }
                this.b.v(e, this.b.count - e);
            }
        }
        c(a) {
            for (let b = 0; b < this.b.count; b++) {
                a(this.b._inner[b]);
            }
            for (let c = 0; c < this.a.count; c++) {
                a(this.a._inner[c]);
            }
        }
    }
    Pool$1.$t = /*@__PURE__*/ markType(Pool$1, 'Pool$1', Base.$, [/*@__PURE__*/ IIndexedPool$1_$type.specialize(0)]);
    return Pool$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IHashPool$2_$type = /*@__PURE__*/ new Type(null, 'IHashPool$2', null, [/*@__PURE__*/ IPool$1_$type.specialize(1)]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HashPool$2 = /*@__PURE__*/ (() => {
    class HashPool$2 extends Base {
        constructor($tKey, $tValue) {
            super();
            this.$tKey = null;
            this.$tValue = null;
            this.d = null;
            this.b = null;
            this._create = null;
            this._disactivate = null;
            this._activate = null;
            this._destroy = null;
            this.$tKey = $tKey;
            this.$tValue = $tValue;
            this.$type = this.$type.specialize(this.$tKey, this.$tValue);
            this.d = new List$1(this.$tValue, 0);
            this.b = new Dictionary$2(this.$tKey, this.$tValue, 0);
        }
        get create() {
            return this._create;
        }
        set create(a) {
            this._create = a;
        }
        get disactivate() {
            return this._disactivate;
        }
        set disactivate(a) {
            this._disactivate = a;
        }
        get activate() {
            return this._activate;
        }
        set activate(a) {
            this._activate = a;
        }
        get destroy() {
            return this._destroy;
        }
        set destroy(a) {
            this._destroy = a;
        }
        item(a) {
            let b;
            if (!((() => { let c = this.b.tryGetValue(a, b); b = c.p1; return c.ret; })())) {
                if (this.d.count > 0) {
                    b = this.d._inner[this.d.count - 1];
                    this.d.removeAt(this.d.count - 1);
                }
                else {
                    b = this.create();
                }
                if (this.activate != null) {
                    this.activate(b);
                }
                this.b.item(a, b);
            }
            return b;
        }
        get c() {
            return this.b.keys;
        }
        a(a) {
            return this.b.containsKey(a);
        }
        h(a) {
            let b;
            if (((() => { let c = this.b.tryGetValue(a, b); b = c.p1; return c.ret; })())) {
                this.b.removeItem(a);
                if (this.disactivate != null) {
                    this.disactivate(b);
                }
                this.d.add(b);
                let c = this.b.count;
                let d = 2;
                while (c != 0) {
                    c >>= 1;
                    d <<= 1;
                }
                if (d < this.d.count) {
                    for (let e = d; e < this.d.count; ++e) {
                        this.destroy(this.d._inner[e]);
                    }
                    this.d.v(d, this.d.count - d);
                }
            }
        }
        clear() {
            let a = new List$1(this.$tKey, 0);
            for (let b of fromEnum(this.b.keys)) {
                a.add(b);
            }
            for (let c of fromEnum(a)) {
                this.h(c);
            }
        }
        get e() {
            return this.b.count;
        }
        f(a) {
            for (let b = 0; b < this.d.count; b++) {
                a(this.d._inner[b]);
            }
            for (let c of fromEnum(this.b.values)) {
                a(c);
            }
        }
        g(a) {
            for (let b = 0; b < this.d.count; b++) {
                a(this.d._inner[b]);
            }
            for (let c of fromEnum(this.b.values)) {
                a(c);
            }
        }
    }
    HashPool$2.$t = /*@__PURE__*/ markType(HashPool$2, 'HashPool$2', Base.$, [/*@__PURE__*/ IHashPool$2_$type.specialize(0, 1)]);
    return HashPool$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RearrangedList$1 = /*@__PURE__*/ (() => {
    class RearrangedList$1 extends Base {
        constructor($t, a, b) {
            super();
            this.$t = null;
            this.b = null;
            this.a = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.b = a;
            this.a = b;
        }
        indexOf(a) {
            let b = this.b.indexOf(a);
            if (b == -1) {
                return -1;
            }
            return this.a.indexOf(b);
        }
        insert(a, b) {
            throw new NotImplementedException(0);
        }
        removeAt(a) {
            throw new NotImplementedException(0);
        }
        item(a, b) {
            if (arguments.length === 2) {
                return b;
            }
            else {
                return this.b.item(this.a.item(a));
            }
        }
        add(a) {
            throw new NotImplementedException(0);
        }
        clear() {
            this.a.clear();
        }
        contains(a) {
            return this.b.contains(a);
        }
        copyTo(a, b) {
            throw new NotImplementedException(0);
        }
        get count() {
            return this.a.count;
        }
        get isReadOnly() {
            return true;
        }
        remove(a) {
            throw new NotImplementedException(0);
        }
        *_getEnumerator() {
            for (let a of fromEnum(this.a)) {
                yield this.b.item(a);
            }
        }
        getEnumerator() {
            return toEnum(() => this._getEnumerator()).getEnumerator();
        }
        *_getEnumeratorObject() {
            for (let a of fromEnum(this.a)) {
                yield getBoxIfEnum(this.$t, this.b.item(a));
            }
        }
        getEnumeratorObject() {
            return toEnum(() => this._getEnumeratorObject()).getEnumeratorObject();
        }
    }
    RearrangedList$1.$t = /*@__PURE__*/ markType(RearrangedList$1, 'RearrangedList$1', Base.$, [/*@__PURE__*/ IList$1_$type.specialize(0)]);
    return RearrangedList$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectUtil = /*@__PURE__*/ (() => {
    class RectUtil extends Base {
        static l(a) {
            if (a.isEmpty) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            return { $type: Point_$type, x: 0.5 * (a.left + a.right), y: 0.5 * (a.bottom + a.top) };
        }
        static e(a) {
            if (a.isEmpty) {
                return 0;
            }
            return a.width * a.height;
        }
        static p(a) {
            if (a.isEmpty) {
                return a;
            }
            return new Rect(0, a.left, a.top, a.width, a.height);
        }
        static m(a, b) {
            if (a.containsPoint(b)) {
                return b;
            }
            let c = { $type: Point_$type, x: a.left + 0.5 * a.width, y: a.top + 0.5 * a.height };
            let d = { $type: Point_$type, x: b.x - c.x, y: b.y - c.y };
            let e;
            if (d.x != 0) {
                e = (a.left - c.x) / d.x;
                let f = c.y + e * d.y;
                if (f > a.top && f < a.bottom) {
                    return e > 0 ? { $type: Point_$type, x: a.left, y: f } : { $type: Point_$type, x: a.right, y: c.y - e * d.y };
                }
            }
            e = (a.top - c.y) / d.y;
            let g = c.x + e * d.x;
            return e > 0 ? { $type: Point_$type, x: g, y: a.top } : { $type: Point_$type, x: c.x - e * d.x, y: a.bottom };
        }
        static g(a, b) {
            if (a.isEmpty) {
                return NaN;
            }
            return RectUtil.f(a, b.x, b.y);
        }
        static h(a, b) {
            if (a.isEmpty) {
                return Number.POSITIVE_INFINITY;
            }
            let c = RectUtil.f(a, b.left, b.top);
            if (c > 0) {
                c = Math.min(c, RectUtil.f(a, b.left, b.bottom));
            }
            if (c > 0) {
                c = Math.min(c, RectUtil.f(a, b.right, b.bottom));
            }
            if (c > 0) {
                c = Math.min(c, RectUtil.f(a, b.right, b.top));
            }
            if (c > 0) {
                c = Math.min(c, RectUtil.f(b, a.left, a.top));
            }
            if (c > 0) {
                c = Math.min(c, RectUtil.f(b, a.left, a.bottom));
            }
            if (c > 0) {
                c = Math.min(c, RectUtil.f(b, a.right, a.bottom));
            }
            if (c > 0) {
                c = Math.min(c, RectUtil.f(b, a.right, a.top));
            }
            return c;
        }
        static f(a, b, c) {
            let d = b - a.left;
            let e = c - a.top;
            let f = a.width * d;
            let g = a.height * e;
            if (f > 0) {
                let h = a.width * a.width;
                if (f < h) {
                    d -= (f / h) * a.width;
                }
                else {
                    d -= a.width;
                }
            }
            if (g > 0) {
                let i = a.height * a.height;
                if (g < i) {
                    e -= (g / i) * a.height;
                }
                else {
                    e -= a.height;
                }
            }
            return d * d + e * e;
        }
        static a(a, b) {
            if (a.isEmpty || b.isEmpty) {
                return false;
            }
            if (a.left > b.left) {
                return false;
            }
            if (a.right < b.right) {
                return false;
            }
            if (a.top > b.top) {
                return false;
            }
            if (a.bottom < b.bottom) {
                return false;
            }
            return true;
        }
        static b(a, b) {
            if (a.isEmpty || b.isEmpty) {
                return false;
            }
            if (a.right < b.left) {
                return false;
            }
            if (a.left > b.right) {
                return false;
            }
            if (a.top > b.bottom) {
                return false;
            }
            if (a.bottom < b.top) {
                return false;
            }
            return true;
        }
        static i(a, b) {
            if (a.isEmpty || b.isEmpty) {
                return 0;
            }
            let c = Math.min(a.right, b.right) - Math.max(a.left, b.left);
            if (c <= 0) {
                return 0;
            }
            let d = Math.min(a.bottom, b.bottom) - Math.max(a.top, b.top);
            if (d <= 0) {
                return 0;
            }
            return c * d;
        }
        static q(a, b, c) {
            if (a.isEmpty) {
                return a;
            }
            return new Rect(0, a.x - b, a.y - c, Math.max(0, a.width + 2 * b), Math.max(0, a.height + 2 * c));
        }
        static t(a, b, c) {
            a.x = a.x - b;
            a.y = a.y - c;
            let d = a.width + 2 * b;
            let e = a.height + 2 * c;
            a.width = d > 1 ? d : 1;
            a.height = e > 1 ? e : 1;
            return a;
        }
        static s(a, b, c) {
            a.x = a.x - b;
            a.y = a.y - c;
            let d = a.width + 2 * b;
            let e = a.height + 2 * c;
            a.width = d > 1 ? d : 1;
            a.height = e > 1 ? e : 1;
            return a;
        }
        static r(a, b) {
            let c = a.x - b;
            let d = a.y - b;
            let e = a.width + b + b;
            let f = a.height + b + b;
            let g = e > 0 ? e : 0;
            let h = f > 0 ? f : 0;
            return new Rect(0, c, d, g, h);
        }
        static y(a) {
            a.x = Math.round(a.x);
            a.y = Math.round(a.y);
            a.width = Math.round(a.width);
            a.height = Math.round(a.height);
            return a;
        }
        static c(a) {
            return a.x == 0 && a.y == 0 && a.width == 0 && a.height == 0;
        }
        static z(a) {
            let b = new Size(1, a.width, a.height);
            return b;
        }
        static u(a, b) {
            let c = RectUtil.v(a, RectUtil.z(b));
            return c;
        }
        static v(a, b) {
            let c = a;
            c.x = a.x / b.width;
            c.y = a.y / b.height;
            c.width = a.width / b.width;
            c.height = a.height / b.height;
            return c;
        }
        static n(a) {
            let b = { $type: Point_$type, x: a.x, y: a.y };
            return b;
        }
        static o(a) {
            let b = { $type: Point_$type, x: a.x + a.width, y: a.y };
            return b;
        }
        static j(a) {
            let b = { $type: Point_$type, x: a.x, y: a.y + a.height };
            return b;
        }
        static k(a) {
            let b = { $type: Point_$type, x: a.x + a.width, y: a.y + a.height };
            return b;
        }
        static d(a) {
            let b = ((() => {
                let $ret = new List$1(Point_$type, 0);
                $ret.add(RectUtil.n(a));
                $ret.add(RectUtil.o(a));
                $ret.add(RectUtil.k(a));
                $ret.add(RectUtil.j(a));
                return $ret;
            })());
            return b;
        }
        static w(a, b) {
            b = CoreGeometryUtil.a(b);
            if (b == 0 || b == 180) {
                return new Rect(0, a.left, a.top, a.width, a.height);
            }
            let c = RectUtil.l(a);
            if (b == 90 || b == 270) {
                let d = a.height / 2;
                let e = a.width / 2;
                return new Rect(0, c.x - d, c.y - e, a.height, a.width);
            }
            return RectUtil.x(a, c.x, c.y, b);
        }
        static x(a, b, c, d) {
            let e = RectUtil.d(a);
            let f = MathUtil.o(d);
            let g = Math.cos(f);
            let h = Math.sin(f);
            let i = 1.7976931348623157E+308;
            let j = 1.7976931348623157E+308;
            let k = -1.7976931348623157E+308;
            let l = -1.7976931348623157E+308;
            let m;
            for (let n = 0; n < e.count; n++) {
                m = e._inner[n];
                let o = (g * (m.x - b) - h * (m.y - c) + b);
                let p = (h * (m.x - b) + g * (m.y - c) + c);
                i = Math.min(i, p);
                j = Math.min(j, o);
                k = Math.max(k, o);
                l = Math.max(l, p);
            }
            let q = new Rect(0, j, i, k - j, l - i);
            return q;
        }
    }
    RectUtil.$t = /*@__PURE__*/ markType(RectUtil, 'RectUtil');
    return RectUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ReverseArrayEnumerator$1 = /*@__PURE__*/ (() => {
    class ReverseArrayEnumerator$1 extends Base {
        constructor($t, a) {
            super();
            this.$t = null;
            this.b = 0;
            this.a = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.a = a;
            this.b = a.count;
        }
        get current() {
            return typeCastObjTo$t(this.$t, this.a.item(this.b));
        }
        get currentObject() {
            return this.a.item(this.b);
        }
        moveNext() {
            this.b--;
            return this.b >= 0;
        }
        reset() {
            this.b = this.a.count;
        }
        dispose() {
            throw new NotImplementedException(0);
        }
    }
    ReverseArrayEnumerator$1.$t = /*@__PURE__*/ markType(ReverseArrayEnumerator$1, 'ReverseArrayEnumerator$1', Base.$, [/*@__PURE__*/ IEnumerator$1_$type.specialize(0)]);
    return ReverseArrayEnumerator$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stack$1 = /*@__PURE__*/ (() => {
    class Stack$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this.c = arrayListCreate();
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
        h(a) {
            this.c.add(getBoxIfEnum(this.$t, a));
        }
        d() {
            if (this.c.count < 1) {
                return Type.getDefaultValue(this.$t);
            }
            return typeCastObjTo$t(this.$t, this.c.item(this.c.count - 1));
        }
        e() {
            let a = this.c.item(this.c.count - 1);
            this.c.removeAt(this.c.count - 1);
            return typeCastObjTo$t(this.$t, a);
        }
        get f() {
            return this.c.count;
        }
        g() {
            this.c.clear();
        }
        b(a) {
            return this.c.contains(getBoxIfEnum(this.$t, a));
        }
        getEnumeratorObject() {
            return new ReverseArrayEnumerator$1(this.$t, this.c);
        }
        getEnumerator() {
            return new ReverseArrayEnumerator$1(this.$t, this.c);
        }
        a() {
            let a = this.c.count;
            let b = new Array(a);
            for (let c = 0; c < a; c++) {
                b[c] = typeCastObjTo$t(this.$t, this.c.item(a - (c + 1)));
            }
            return b;
        }
    }
    Stack$1.$t = /*@__PURE__*/ markType(Stack$1, 'Stack$1', Base.$, [/*@__PURE__*/ IEnumerable$1_$type.specialize(0)]);
    return Stack$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackPool$1 = /*@__PURE__*/ (() => {
    class StackPool$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this.e = false;
            this.j = null;
            this.c = null;
            this.b = null;
            this.d = null;
            this.g = null;
            this.i = null;
            this.h = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.g = new Dictionary$2(this.$t, Base.$, 0);
            this.i = new Stack$1(this.$t);
            this.h = new Stack$1(this.$t);
        }
        a() {
            let a;
            if (this.i.f != 0) {
                a = this.i.e();
            }
            else {
                a = this.h.f != 0 ? this.h.e() : this.j();
                this.b(a);
            }
            this.g.addItem(a, null);
            return a;
        }
        n(a) {
            this.g.removeItem(a);
            if (this.f) {
                this.i.h(a);
            }
            else {
                this.c(a);
                let b = StackPool$1.m(this.$t, this.g.count);
                if (this.h.f < b) {
                    this.d(a);
                }
                else {
                    this.h.h(a);
                }
            }
        }
        get f() {
            return this.e;
        }
        set f(a) {
            if (this.e != a) {
                this.e = a;
                if (!this.e) {
                    let b = StackPool$1.m(this.$t, this.g.count);
                    while (this.i.f > 0 && this.h.f <= b) {
                        let c = this.i.e();
                        this.c(c);
                        this.h.h(c);
                    }
                    while (this.i.f > 0) {
                        let d = this.i.e();
                        this.c(d);
                        this.d(d);
                    }
                    while (this.h.f > b) {
                        this.d(this.h.e());
                    }
                }
            }
        }
        get k() {
            return this.g.count;
        }
        get l() {
            return this.h.f;
        }
        static m($t, a) {
            let b = 2;
            while (a > b) {
                b = b << 1;
            }
            return b;
        }
    }
    StackPool$1.$t = /*@__PURE__*/ markType(StackPool$1, 'StackPool$1');
    return StackPool$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISchedulableRender_$type = /*@__PURE__*/ new Type(null, 'ISchedulableRender');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CanvasRenderScheduler = /*@__PURE__*/ (() => {
    class CanvasRenderScheduler extends Base {
        constructor() {
            super();
            this.d = true;
            this.i = null;
            this.h = null;
            this.a = null;
            this.c = false;
            this.k = -1;
            this.j = null;
            this.b = false;
            this.e = false;
            this.i = new List$1(ISchedulableRender_$type, 0);
            this.h = new List$1(CanvasRenderScheduler.$, 0);
        }
        o(a) {
            this.d = true;
            this.i.add(a);
        }
        u(a) {
            this.d = true;
            this.i.remove(a);
        }
        s() {
            this.d = true;
            this.q();
        }
        get g() {
            return this.c;
        }
        m(a) {
            let b = this.j;
            this.j = a;
            if (this.c && this.j != null && b == null) {
                this.j.setTimeout(runOn(this, this.n), 0);
            }
        }
        q() {
            if (!this.c) {
                this.c = true;
                if (this.j != null) {
                    this.j.setTimeout(runOn(this, this.n), 0);
                }
                else {
                    window.setTimeout(runOn(this, this.n), 0);
                }
            }
        }
        r(a, b) {
            this.q();
        }
        l() {
            if (this.k != -1) {
                window.clearTimeout(this.k);
                this.k = -1;
            }
            if (this.c) {
                this.n();
            }
        }
        n() {
            this.k = -1;
            if (this.c) {
                this.c = false;
                this.b = true;
                if (this.h.count > 0) {
                    for (let a = 0; a < this.h.count; a++) {
                        this.h._inner[a].l();
                    }
                }
                if (this.d) {
                    this.t();
                }
                this.p();
            }
        }
        get f() {
            return this.b;
        }
        p() {
            if (this.e) {
                this.b = false;
                return;
            }
            let a = true;
            for (let b = 0; b < this.i.count; b++) {
                let c = this.i._inner[b];
                c.preRender();
            }
            for (let d = 0; d < this.i.count; d++) {
                let e = this.i._inner[d];
                e.undirty(a);
                a = false;
            }
            for (let f = 0; f < this.i.count; f++) {
                let g = this.i._inner[f];
                g.postRender();
            }
            this.b = false;
            if (this.a != null) {
                this.a();
            }
        }
        t() {
            this.i.aa((a, b) => {
                let c = a;
                let d = b;
                if (c.index < d.index) {
                    return -1;
                }
                if (c.index > d.index) {
                    return 1;
                }
                return 0;
            });
            this.d = false;
        }
    }
    CanvasRenderScheduler.$t = /*@__PURE__*/ markType(CanvasRenderScheduler, 'CanvasRenderScheduler');
    return CanvasRenderScheduler;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextFontMetrics = /*@__PURE__*/ (() => {
    class TextFontMetrics extends Base {
        constructor() {
            super(...arguments);
            this.c = 0;
            this.b = 0;
            this.a = 0;
        }
    }
    TextFontMetrics.$t = /*@__PURE__*/ markType(TextFontMetrics, 'TextFontMetrics');
    return TextFontMetrics;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CanvasViewRenderer = /*@__PURE__*/ (() => {
    class CanvasViewRenderer extends Base {
        constructor() {
            super(...arguments);
            this.j = null;
            this.h = 0;
            this.f = 0;
            this.i = 0;
            this.g = 0;
            this.b = false;
            this.c = false;
            this.aa = null;
            this.m = "left";
            this.a = null;
            this.d = 11;
            this.e = 1;
        }
        h$e() {
            return this.j;
        }
        get h$d() {
            return this.j;
        }
        set h$d(a) {
            this.j = a;
        }
        l(a, b, c, d, e, f, g) {
            return CanvasViewRenderer.k(this.j, a, b, c, d, e, f, g);
        }
        static k(a, b, c, d, e, f, g, h) {
            let i;
            if (b.useCustomDirection) {
                let j, k, l, m, n;
                n = e - c;
                j = c + b.startX * n;
                l = c + b.endX * n;
                n = f - d;
                k = d + b.startY * n;
                m = d + b.endY * n;
                if (h) {
                    let o = g / 2;
                    j -= o;
                    l += o;
                    k -= o;
                    m += o;
                }
                i = a.createLinearGradient(j, k, l, m);
            }
            else {
                if (h) {
                    let p = g / 2;
                    c -= p;
                    e += p;
                    d -= p;
                    f += p;
                }
                i = a.createLinearGradient(c, d, c, f);
            }
            for (let q = 0; q < b.gradientStops.length; q++) {
                let r = b.gradientStops[q];
                i.addColorStop(r.offset, r._fill);
            }
            return i;
        }
        h$t(a) {
            if (a._visibility != 0) {
                return;
            }
            let b = a.n;
            let c = a.o;
            let d = a.width;
            let e = a.height;
            let f = a.ap;
            let g = a.aq;
            this.j.beginPath();
            this.j.globalAlpha = (a._opacity * this.e);
            if (a.ai != null) {
                let h = new Array(a.ai.count);
                for (let i = 0; i < a.ai.count; i++) {
                    h[i] = a.ai._inner[i];
                }
                this.j.setLineDash(h);
            }
            else {
                this.j.setLineDash(new Array(0));
            }
            if (f > 0 || g > 0) {
                if (f > d / 2) {
                    f = (d / 2);
                }
                if (g > e / 2) {
                    g = (e / 2);
                }
                let j = Math.min(f, g);
                this.j.beginPath();
                this.j.moveTo(b + j, c);
                this.j.lineTo(b + d - j, c);
                this.j.arc(b + d - j, c + j, j, (3 / 2 * Math.PI), 0, false);
                this.j.lineTo(b + d, c + e - j);
                this.j.arc(b + d - j, c + e - j, j, 0, (Math.PI / 2), false);
                this.j.lineTo(b + j, c + e);
                this.j.arc(b + j, c + e - j, j, (Math.PI / 2), Math.PI, false);
                this.j.lineTo(b, c + j);
                this.j.arc(b + j, c + j, j, Math.PI, (3 / 2 * Math.PI), false);
                this.j.closePath();
            }
            else {
                this.j.rect(b, c, d, e);
            }
            let k = a._fill;
            let l = a._stroke;
            if (k != null) {
                if (k.isGradient && c == c && b == b) {
                    this.j.fillStyle = this.l(k, b, c, b + d, c + e, a.ad, false);
                }
                else {
                    this.j.fillStyle = k._fill;
                }
                this.j.fill();
            }
            if (l != null) {
                if (l.isGradient && c == c && b == b) {
                    this.j.strokeStyle = this.l(l, b, c, b + d, c + e, a.ad, true);
                }
                else {
                    this.j.strokeStyle = l._fill;
                }
                this.j.lineWidth = a.ad;
                this.j.stroke();
            }
            this.j.globalAlpha = 1;
            if (a.ai != null) {
                this.j.setLineDash(new Array(0));
            }
        }
        h$q(a) {
            if (a._visibility != 0) {
                return;
            }
            this.j.beginPath();
            if (a._opacity < 1 || this.e < 1) {
                this.j.globalAlpha = (a._opacity * this.e);
            }
            let b = a._fill;
            let c = a._stroke;
            this.b = (b != null && b.isGradient) || (c != null && c.isGradient);
            if (this.b) {
                this.f = -1.7976931348623157E+308;
                this.g = -1.7976931348623157E+308;
                this.h = 1.7976931348623157E+308;
                this.i = 1.7976931348623157E+308;
                this.c = false;
            }
            switch (a.am) {
                case 0:
                    this.j.lineJoin = "miter";
                    break;
                case 1:
                    this.j.lineJoin = "bevel";
                    break;
                case 2:
                    this.j.lineJoin = "round";
                    break;
            }
            switch (a.al) {
                case 0:
                    this.j.lineCap = "butt";
                    break;
                case 3:
                case 2:
                    this.j.lineCap = "round";
                    break;
                case 1:
                    this.j.lineCap = "square";
                    break;
            }
            if (a.ai != null) {
                let d = new Array(a.ai.count);
                for (let e = 0; e < a.ai.count; e++) {
                    d[e] = a.ai._inner[e];
                }
                this.j.setLineDash(d);
            }
            else {
                this.j.setLineDash(new Array(0));
            }
            this.h$o(a.an);
            if (b != null) {
                if (b.isGradient && this.c) {
                    this.j.fillStyle = this.l(b, this.h, this.i, this.f, this.g, a.ad, false);
                }
                else {
                    this.j.fillStyle = a._fill._fill;
                }
                this.j.fill();
            }
            if (c != null) {
                if (c.isGradient && this.c) {
                    this.j.strokeStyle = this.l(c, this.h, this.i, this.f, this.g, a.ad, true);
                }
                else {
                    this.j.strokeStyle = a._stroke._fill;
                }
                this.j.lineWidth = a.ad;
                if (a.ad > 0) {
                    this.j.stroke();
                }
            }
            if (a._opacity < 1 || this.e < 1) {
                this.j.globalAlpha = 1;
            }
            if (a.ai != null) {
                this.j.setLineDash(new Array(0));
            }
        }
        h$o(a) {
            if (a == null) {
                return;
            }
            let b = a.b;
            switch (b) {
                case 0:
                    for (let c = 0; c < a.d.count; c++) {
                        this.h$o(a.d._inner[c]);
                    }
                    break;
                case 4:
                    this.t(a);
                    break;
                case 1:
                    this.r(a);
                    break;
                case 2:
                    this.w(a);
                    break;
                case 3:
                    this.p(a);
                    break;
            }
        }
        p(a) {
            this.j.moveTo(a.e.x, (a.e.y - a.d));
            this.aa = { $type: Point_$type, x: a.e.x, y: a.e.y - a.d };
            let b = ((() => {
                let $ret = new ArcSegment();
                $ret.e = { $type: Point_$type, x: a.e.x, y: a.e.y + a.d };
                $ret.b = false;
                $ret.f = new Size(1, a.c, a.d);
                return $ret;
            })());
            let c = ((() => {
                let $ret = new ArcSegment();
                $ret.e = { $type: Point_$type, x: a.e.x, y: a.e.y - a.d };
                $ret.b = false;
                $ret.f = new Size(1, a.c, a.d);
                return $ret;
            })());
            let d = this.b;
            this.b = false;
            this.n(b);
            this.n(c);
            this.b = d;
            if (!this.b) {
                return;
            }
            let e = a.e.x - a.c;
            let f = a.e.y + a.c;
            let g = a.e.x - a.d;
            let h = a.e.y + a.d;
            let i = this.f;
            let j = this.g;
            let k = this.h;
            let l = this.i;
            this.h = e < k ? e : k;
            this.i = g < l ? g : l;
            this.f = f > i ? f : i;
            this.g = h > j ? h : j;
            this.c = true;
        }
        t(a) {
            let b = a.c;
            let c = b.count;
            for (let d = 0; d < c; d++) {
                this.q(b._inner[d]);
            }
        }
        q(a) {
            let b = a == null ? null : a._startPoint;
            if (PointUtil.equals(b, null)) {
                return;
            }
            let c = b.x;
            let d = b.y;
            this.j.moveTo(c, d);
            if (this.b) {
                let e = this.f;
                let f = this.g;
                let g = this.h;
                let h = this.i;
                this.h = c < g ? c : g;
                this.i = d < h ? d : h;
                this.f = c > e ? c : e;
                this.g = d > f ? d : f;
                this.c = true;
            }
            this.aa = b;
            let i = a._segments;
            let j = i.count;
            for (let k = 0; k < j; k++) {
                this.x(i._inner[k]);
            }
            if (a._isClosed) {
                this.j.closePath();
            }
        }
        x(a) {
            let b = a.a;
            switch (b) {
                case 0:
                    this.s(a);
                    break;
                case 3:
                    this.v(a);
                    break;
                case 4:
                    this.n(a);
                    break;
                case 1:
                    this.o(a);
                    break;
                case 2:
                    this.u(a);
                    break;
            }
        }
        z(a, b, c, d, e, f, g, h) {
            let i = 1 / 50;
            let j;
            let k;
            let l;
            let m;
            let n;
            let o;
            let p;
            let q = this.h;
            let r = this.i;
            let s = this.f;
            let t = this.g;
            for (let u = 0; u <= 1; u += i) {
                j = 1 - u;
                k = j * j;
                l = k * j;
                m = u * u;
                n = m * u;
                o = l * a + 3 * k * u * c + 3 * j * m * e + n * g;
                p = l * b + 3 * k * u * d + 3 * j * m * f + n * h;
                q = o < q ? o : q;
                r = p < r ? p : r;
                s = o > s ? o : s;
                t = p > t ? p : t;
            }
            this.h = q;
            this.i = r;
            this.f = s;
            this.g = t;
            this.c = true;
        }
        o(a) {
            this.j.bezierCurveTo(a.e.x, a.e.y, a.f.x, a.f.y, a.g.x, a.g.y);
            if (this.b) {
                this.z(this.aa.x, this.aa.y, a.e.x, a.e.y, a.f.x, a.f.y, a.g.x, a.g.y);
            }
        }
        u(a) {
            let b = 0;
            let c = a.b.count;
            let d = a.b;
            let e = this.aa;
            let f = this.aa;
            let g = this.aa;
            let h = this.b;
            while (b < c) {
                if (b + 1 < c && b + 2 < c) {
                    e = d._inner[b];
                    f = d._inner[b + 1];
                    g = d._inner[b + 2];
                    this.j.bezierCurveTo(e.x, e.y, f.x, f.y, g.x, g.y);
                    if (h) {
                        this.z(this.aa.x, this.aa.y, e.x, e.y, f.x, f.y, g.x, g.y);
                        this.aa = g;
                    }
                }
                b = b + 3;
            }
            this.aa = g;
        }
        y(a, b, c, d, e) {
            let f = new List$1(Point_$type, 0);
            f.add(a);
            f.add({ $type: Point_$type, x: a.x + Math.cos(b) * d, y: a.y + Math.sin(b) * d });
            f.add({ $type: Point_$type, x: a.x + Math.cos(c) * d, y: a.y + Math.sin(c) * d });
            let g = Math.PI * 2;
            let h = Math.PI / 2;
            let i = Math.PI;
            let j = Math.PI * 3 / 2;
            while (b < 0) {
                b += g;
            }
            while (b > g) {
                b -= g;
            }
            while (c < 0) {
                c += g;
            }
            while (c > g) {
                c -= g;
            }
            if (e) {
                if ((0 > c && 0 < b) || (g > c && g < b) || (b < c)) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(0) * d, y: a.y + Math.sin(0) * d });
                }
                if (h > c && h < b) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(h) * d, y: a.y + Math.sin(h) * d });
                }
                if (i > c && i < b) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(i) * d, y: a.y + Math.sin(i) * d });
                }
                if (j > c && j < b) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(j) * d, y: a.y + Math.sin(j) * d });
                }
            }
            else {
                if ((0 > b && 0 < c) || (g > b && g < c) || (c < b)) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(0) * d, y: a.y + Math.sin(0) * d });
                }
                if (h > b && h < c) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(h) * d, y: a.y + Math.sin(h) * d });
                }
                if (i > b && i < c) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(i) * d, y: a.y + Math.sin(i) * d });
                }
                if (j > b && j < c) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(j) * d, y: a.y + Math.sin(j) * d });
                }
            }
            let k = 1.7976931348623157E+308;
            let l = 1.7976931348623157E+308;
            let m = -1.7976931348623157E+308;
            let n = -1.7976931348623157E+308;
            for (let o = 0; o < f.count; o++) {
                let p = f._inner[o];
                k = Math.min(k, p.x);
                l = Math.min(l, p.y);
                m = Math.max(m, p.x);
                n = Math.max(n, p.y);
            }
            this.h = Math.min(this.h, k);
            this.i = Math.min(this.i, l);
            this.f = Math.max(this.f, m);
            this.g = Math.max(this.g, n);
            this.c = true;
        }
        n(a) {
            let b = this.aa;
            let c = a.e;
            if (a.f.width != a.f.height) {
                this.j.save();
                this.j.scale(a.f.width / a.f.height, 1);
                b = { $type: Point_$type, x: b.x * (a.f.height / a.f.width), y: b.y };
                c = { $type: Point_$type, x: c.x * (a.f.height / a.f.width), y: c.y };
            }
            let d = a.d == 0;
            let e = CoreGeometryUtil.c(b, c, a.f.height, d, a.b);
            let f = Math.atan2(b.y - e.y, b.x - e.x);
            let g = Math.atan2(c.y - e.y, c.x - e.x);
            let h = (Math.abs(g - f) < Math.PI);
            if (a.b == h) {
                if (f < g) {
                    f += 2 * Math.PI;
                }
                else {
                    g += 2 * Math.PI;
                }
            }
            if (!isNaN_(e.x) && !isNaN_(e.y) && !isNaN_(a.f.height) && !isNaN_(f) && !isNaN_(g)) {
                this.j.arc(e.x, e.y, a.f.height, f, g, d);
                if (this.b) {
                    this.y(e, f, g, a.f.height, d);
                }
            }
            this.aa = a.e;
            if (a.f.width != a.f.height) {
                this.j.restore();
            }
        }
        s(a) {
            let b = a.c.x;
            let c = a.c.y;
            this.j.lineTo(b, c);
            this.aa = a.c;
            if (this.b) {
                let d = this.f;
                let e = this.g;
                let f = this.h;
                let g = this.i;
                this.h = b < f ? b : f;
                this.i = c < g ? c : g;
                this.f = b > d ? b : d;
                this.g = c > e ? c : e;
                this.c = true;
            }
        }
        v(a) {
            let b = a._points;
            let c = b.count;
            if (this.b) {
                let d = this.h;
                let e = this.i;
                let f = this.f;
                let g = this.g;
                let h;
                let i;
                for (let j = 0; j < c; j++) {
                    h = b._inner[j].x;
                    i = b._inner[j].y;
                    this.j.lineTo(h, i);
                    d = h < d ? h : d;
                    e = i < e ? i : e;
                    f = h > f ? h : f;
                    g = i > g ? i : g;
                }
                this.h = d;
                this.i = e;
                this.f = f;
                this.g = g;
                this.c = true;
            }
            else {
                for (let k = 0; k < c; k++) {
                    this.j.lineTo(b._inner[k].x, b._inner[k].y);
                }
            }
            this.aa = a._points._inner[c - 1];
        }
        w(a) {
            this.j.rect(a.e.left, a.e.top, a.e.width, a.e.height);
            if (this.b) {
                let b = a.e;
                let c = this.h;
                let d = this.i;
                let e = this.f;
                let f = this.g;
                let g = b.left;
                let h = b.right;
                let i = b.top;
                let j = b.bottom;
                this.h = g < c ? g : c;
                this.i = i < d ? i : d;
                this.f = h > e ? h : e;
                this.g = j > f ? j : f;
                this.c = true;
            }
        }
        r(a) {
            this.j.moveTo(a.d.x, a.d.y);
            this.j.lineTo(a.c.x, a.c.y);
            if (this.b) {
                let b = a.d;
                let c = a.c;
                let d = this.h;
                let e = this.i;
                let f = this.f;
                let g = this.g;
                let h = b.x < c.x ? b.x : c.x;
                let i = b.x > c.x ? b.x : c.x;
                let j = b.y < c.y ? b.y : c.y;
                let k = b.y > c.y ? b.y : c.y;
                this.h = h < d ? h : d;
                this.i = j < e ? j : e;
                this.f = i > f ? i : f;
                this.g = k > g ? k : g;
                this.c = true;
            }
        }
        h$u(a) {
            if (a._visibility == 0 && a.al != null) {
                if (a._opacity < 1 || this.e < 1) {
                    this.j.globalAlpha = (a._opacity * this.e);
                }
                let def_ = this.m;
                let con_ = this.j;
                con_.textAlign = def_;
                this.j.fillStyle = a.ao != null ? a.ao._fill : null;
                if (a.ag) {
                    this.j.textBaseline = "alphabetic";
                    this.j.fillText(a.al, a.n, a.o + a.ah);
                }
                else {
                    this.j.textBaseline = "top";
                    this.j.fillText(a.al, a.n, a.o);
                }
                if (a._opacity < 1 || this.e < 1) {
                    this.j.globalAlpha = 1;
                }
            }
        }
        h$v(a, b, c) {
            if (a._visibility == 0) {
                if (a._opacity < 1 || this.e < 1) {
                    this.j.globalAlpha = (a._opacity * this.e);
                }
                let d = b.left + b.width / 2;
                let e = a.al.split(' ');
                this.j.fillStyle = a.ao._fill;
                this.j.textBaseline = "top";
                this.j.textAlign = "center";
                let f = b.width;
                let g = b.height;
                let h = b.top;
                let i = "";
                for (let j = 0; j < e.length; j++) {
                    let k = i + e[j];
                    let l = this.j.measureText(k);
                    if (l.width > f) {
                        if (i != null) {
                            this.j.fillText(i, d, h);
                        }
                        i = "";
                        h = h + c;
                    }
                    i = i + e[j] + " ";
                }
                if (i != null) {
                    this.j.fillText(i, d, h);
                }
                if (a._opacity < 1 || this.e < 1) {
                    this.j.globalAlpha = 1;
                }
            }
        }
        h$r(a) {
            if (a.an == null || a.an.count < 1) {
                return;
            }
            this.j.beginPath();
            this.j.globalAlpha = (a._opacity * this.e);
            if (a.ai != null) {
                let b = new Array(a.ai.count);
                for (let c = 0; c < a.ai.count; c++) {
                    b[c] = a.ai._inner[c];
                }
                this.j.setLineDash(b);
            }
            else {
                this.j.setLineDash(new Array(0));
            }
            let d = a.an;
            let e = d._inner[0];
            let f = a._fill;
            let g = a._stroke;
            this.b = (f != null && f.isGradient) || (g != null && g.isGradient);
            if (this.b) {
                let h = 1.7976931348623157E+308;
                let i = -1.7976931348623157E+308;
                let j = 1.7976931348623157E+308;
                let k = -1.7976931348623157E+308;
                let l = e.x;
                let m = e.y;
                h = l < h ? l : h;
                j = m < j ? m : j;
                i = l > i ? l : i;
                k = m > k ? m : k;
                this.j.moveTo(l, m);
                for (let n = 1; n < d.count; n++) {
                    l = d._inner[n].x;
                    m = d._inner[n].y;
                    this.j.lineTo(l, m);
                    h = l < h ? l : h;
                    j = m < j ? m : j;
                    i = l > i ? l : i;
                    k = m > k ? m : k;
                }
                this.j.closePath();
                this.h = h;
                this.i = j;
                this.f = i;
                this.g = k;
            }
            else {
                this.j.moveTo(e.x, e.y);
                for (let o = 1; o < d.count; o++) {
                    this.j.lineTo(d._inner[o].x, d._inner[o].y);
                }
                this.j.closePath();
            }
            if (f != null) {
                if (f.isGradient) {
                    this.j.fillStyle = this.l(f, this.h, this.i, this.f, this.g, a.ad, false);
                }
                else {
                    this.j.fillStyle = f._fill;
                }
                this.j.fill();
            }
            if (g != null) {
                if (g.isGradient) {
                    this.j.strokeStyle = this.l(g, this.h, this.i, this.f, this.g, a.ad, true);
                }
                else {
                    this.j.strokeStyle = g._fill;
                }
                this.j.lineWidth = a.ad;
                this.j.stroke();
            }
            this.j.globalAlpha = 1;
            if (a.ai != null) {
                this.j.setLineDash(new Array(0));
            }
        }
        h$s(a) {
            if (a.an == null || a.an.count < 1) {
                return;
            }
            this.j.beginPath();
            this.j.globalAlpha = (a._opacity * this.e);
            if (a.ai != null) {
                let b = new Array(a.ai.count);
                for (let c = 0; c < a.ai.count; c++) {
                    b[c] = a.ai._inner[c];
                }
                this.j.setLineDash(b);
            }
            else {
                this.j.setLineDash(new Array(0));
            }
            let d = a.an;
            let e = d._inner[0];
            let f = a._fill;
            let g = a._stroke;
            this.b = (f != null && f.isGradient) || (g != null && g.isGradient);
            if (this.b) {
                let h = 1.7976931348623157E+308;
                let i = -1.7976931348623157E+308;
                let j = 1.7976931348623157E+308;
                let k = -1.7976931348623157E+308;
                let l = e.x;
                let m = e.y;
                h = l < h ? l : h;
                j = m < j ? m : j;
                i = l > i ? l : i;
                k = m > k ? m : k;
                this.j.moveTo(l, m);
                for (let n = 1; n < d.count; n++) {
                    l = d._inner[n].x;
                    m = d._inner[n].y;
                    this.j.lineTo(l, m);
                    h = l < h ? l : h;
                    j = m < j ? m : j;
                    i = l > i ? l : i;
                    k = m > k ? m : k;
                }
                this.h = h;
                this.i = j;
                this.f = i;
                this.g = k;
            }
            else {
                this.j.moveTo(e.x, e.y);
                for (let o = 1; o < d.count; o++) {
                    this.j.lineTo(d._inner[o].x, d._inner[o].y);
                }
            }
            if (f != null) {
                if (f.isGradient) {
                    this.j.fillStyle = this.l(f, this.h, this.i, this.f, this.g, a.ad, false);
                }
                else {
                    this.j.fillStyle = f._fill;
                }
                this.j.fill();
            }
            if (g != null) {
                if (g.isGradient) {
                    this.j.strokeStyle = this.l(g, this.h, this.i, this.f, this.g, a.ad, true);
                }
                else {
                    this.j.strokeStyle = g._fill;
                }
                this.j.lineWidth = a.ad;
                this.j.stroke();
            }
            this.j.globalAlpha = 1;
            if (a.ai != null) {
                this.j.setLineDash(new Array(0));
            }
        }
        h$n(a, b) {
            if (b._visibility == 1) {
                return;
            }
            if ((b._opacity != 1 || this.e != 1) && !a.isHitTestRender) {
                this.j.globalAlpha = (b._opacity * this.e);
            }
            let c = b.ah;
            if (c != null && c.render != null) {
                a.context = this.j;
                a.xPosition = b.n;
                a.yPosition = b.o;
                a.data = b.content;
                c.render(a);
            }
            this.j.globalAlpha = 1;
        }
        h$h(a) {
            if (typeCast(TransformGroup.$, a) !== null) {
                let b = a;
                for (let c = b.j.count - 1; c >= 0; c--) {
                    let d = b.j._inner[c];
                    this.h$h(d);
                }
            }
            else if (typeCast(TranslateTransform.$, a) !== null) {
                let e = a;
                this.j.translate(e.j, e.k);
            }
            else if (typeCast(RotateTransform.$, a) !== null) {
                let f = a;
                let g = f.j * Math.PI / 180;
                let h = Math.cos(g);
                let i = Math.sin(g);
                let j = f.k * (1 - h) + f.l * i;
                let k = f.l * (1 - h) - f.k * i;
                this.j.transform(h, i, i * -1, h, j, k);
            }
            else if (typeCast(ScaleTransform.$, a) !== null) {
                let l = a;
                this.j.transform(l.l, 0, 0, l.m, l.j - l.l * l.j, l.k - l.m * l.k);
            }
        }
        h$p(a) {
            if (a._visibility != 0) {
                return;
            }
            this.j.beginPath();
            this.j.globalAlpha = (a._opacity * this.e);
            if (a.ai != null) {
                let b = new Array(a.ai.count);
                for (let c = 0; c < a.ai.count; c++) {
                    b[c] = a.ai._inner[c];
                }
                this.j.setLineDash(b);
            }
            else {
                this.j.setLineDash(new Array(0));
            }
            this.j.moveTo(a.an, a.ap);
            this.j.lineTo(a.ao, a.aq);
            if (this.b) {
                this.h = 1.7976931348623157E+308;
                this.f = -1.7976931348623157E+308;
                this.i = 1.7976931348623157E+308;
                this.g = -1.7976931348623157E+308;
                let d = this.h;
                let e = this.i;
                let f = this.f;
                let g = this.g;
                let h = a.an < a.ao ? a.an : a.ao;
                let i = a.an > a.ao ? a.an : a.ao;
                let j = a.ap < a.aq ? a.ap : a.aq;
                let k = a.ap > a.aq ? a.ap : a.aq;
                this.h = h < d ? h : d;
                this.i = j < e ? j : e;
                this.f = i > f ? i : f;
                this.g = k > g ? k : g;
            }
            let l = a._fill;
            let m = a._stroke;
            if (l != null) {
                if (l.isGradient) {
                    this.j.fillStyle = this.l(l, this.h, this.i, this.f, this.f, a.ad, false);
                }
                else {
                    this.j.fillStyle = l._fill;
                }
                this.j.fill();
            }
            if (m != null) {
                if (m.isGradient) {
                    this.j.strokeStyle = this.l(m, this.h, this.i, this.f, this.f, a.ad, true);
                }
                else {
                    this.j.strokeStyle = a._stroke._fill;
                }
                this.j.lineWidth = a.ad;
                this.j.stroke();
            }
            this.j.globalAlpha = 1;
            if (a.ai != null) {
                this.j.setLineDash(new Array(0));
            }
        }
        h$ac(a) {
            this.j.beginPath();
            this.j.rect(a.left, a.top, a.width, a.height);
            this.j.clip();
        }
        h$x() {
            this.j.save();
        }
        h$w() {
            this.j.restore();
        }
        h$y(a, b) {
            this.j.scale(a, b);
        }
        h$ad(a, b) {
            this.j.translate(a, b);
        }
        h$i(a, b, c, d) {
            this.j.clearRect(a, b, c, d);
        }
        h$k(a, b, c, d, e, f) {
            if (b != 1) {
                this.j.globalAlpha = (b * this.e);
            }
            this.j.drawImage(a, c, d, e, f);
            if (b != 1) {
                this.j.globalAlpha = 1;
            }
        }
        h$l(a, b, c, d, e, f, g, h, i, j) {
            if (b != 1) {
                this.j.globalAlpha = (b * this.e);
            }
            this.j.drawImage(a, c, d, e, f, g, h, i, j);
            if (b != 1) {
                this.j.globalAlpha = 1;
            }
        }
        h$a(a, b) {
            let c = this.j.getImageData(a, b, 1, 1);
            let d = new Array(4);
            d[0] = c.data[0];
            d[1] = c.data[1];
            d[2] = c.data[2];
            d[3] = c.data[3];
            return d;
        }
        h$f() {
            return this.j.font;
        }
        h$b() {
            return this.a;
        }
        h$z(a) {
            if (this.j.font != a) {
                this.j.font = a;
            }
        }
        h$aa(a) {
            this.a = a;
            if (a != null) {
                this.d = a.f;
            }
            let b = a != null ? a.fontString : null;
            if (this.j.font != b) {
                this.j.font = b;
            }
        }
        h$ae(a, b, c) {
            this.j.textBaseline = "alphabetic";
            let d = this.j.measureText(a);
            let metrics_ = d;
            let e = b;
            let f = new TextFontMetrics();
            if ((metrics_.actualBoundingBoxAscent !== undefined)) {
                f.a = (metrics_.actualBoundingBoxAscent);
                e = (metrics_.actualBoundingBoxAscent + metrics_.actualBoundingBoxDescent);
                if (c) {
                    let g = (b - e);
                    let h = g / 2;
                    f.a += h;
                    e += g;
                }
            }
            f.c = d.width;
            f.b = e;
            return f;
        }
        h$c(a) {
            let b = this.j.measureText(a);
            return b.width;
        }
        h$ab(a) {
            this.e = a;
        }
        h$g(shape_, style_) {
            if (style_ == null) {
                return;
            }
            let fillColor_ = null;
            let strokeColor_ = null;
            let strokeThickness_ = NaN;
            let opacity_ = NaN;
            let s_ = style_;
            if (s_.fill) {
                fillColor_ = s_.fill;
            }
            ;
            if (s_.stroke) {
                strokeColor_ = s_.stroke;
            }
            ;
            if (s_.strokeThickness) {
                strokeThickness_ = s_.strokeThickness;
            }
            ;
            if (s_.opacity) {
                opacity_ = s_.opacity;
            }
            ;
            if (fillColor_ != null) {
                shape_._fill = ((() => {
                    let $ret = new Brush();
                    $ret.fill = fillColor_;
                    return $ret;
                })());
            }
            if (strokeColor_ != null) {
                shape_._stroke = ((() => {
                    let $ret = new Brush();
                    $ret.fill = strokeColor_;
                    return $ret;
                })());
            }
            if (strokeThickness_ != undefined && !isNaN_(strokeThickness_)) {
                shape_.ad = strokeThickness_;
            }
            if (!isNaN_(opacity_)) {
                shape_._opacity = opacity_;
            }
        }
        h$m(a, b, c, d) {
            this.j.shadowColor = a;
            this.j.shadowBlur = b;
            this.j.shadowOffsetX = c;
            this.j.shadowOffsetY = d;
        }
        h$j() {
            this.j.shadowColor = "rgba(0,0,0,0)";
            this.j.shadowBlur = 0;
            this.j.shadowOffsetX = 0;
            this.j.shadowOffsetY = 0;
        }
    }
    CanvasViewRenderer.$t = /*@__PURE__*/ markType(CanvasViewRenderer, 'CanvasViewRenderer', Base.$, [IRenderer_$type]);
    return CanvasViewRenderer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DependencyObjectNotifier = /*@__PURE__*/ (() => {
    class DependencyObjectNotifier extends DependencyObject {
        constructor() {
            super(...arguments);
            this.propertyChanged = null;
        }
        j(a) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
    }
    DependencyObjectNotifier.$t = /*@__PURE__*/ markType(DependencyObjectNotifier, 'DependencyObjectNotifier', DependencyObject.$, [INotifyPropertyChanged_$type]);
    return DependencyObjectNotifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IOverviewPlusDetailControl_$type = /*@__PURE__*/ new Type(null, 'IOverviewPlusDetailControl');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IOverviewPlusDetailPane_$type = /*@__PURE__*/ new Type(null, 'IOverviewPlusDetailPane');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyChangedEventArgs$1 = /*@__PURE__*/ (() => {
    class PropertyChangedEventArgs$1 extends PropertyChangedEventArgs {
        constructor($t, a, b, c) {
            super(a);
            this.$t = null;
            this._oldValue = null;
            this._newValue = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.oldValue = b;
            this.newValue = c;
        }
        get oldValue() {
            return this._oldValue;
        }
        set oldValue(a) {
            this._oldValue = a;
        }
        get newValue() {
            return this._newValue;
        }
        set newValue(a) {
            this._newValue = a;
        }
    }
    PropertyChangedEventArgs$1.$t = /*@__PURE__*/ markType(PropertyChangedEventArgs$1, 'PropertyChangedEventArgs$1', PropertyChangedEventArgs.$);
    return PropertyChangedEventArgs$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SchedulableRenderWrapper = /*@__PURE__*/ (() => {
    class SchedulableRenderWrapper extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        get b() {
            return this.a;
        }
        get d() {
            let a = this.b;
            return a != null;
        }
        get isDirty() {
            let a = this.b;
            return a != null ? a.isDirty : false;
        }
        set isDirty(a) {
            let b = this.b;
            if (b != null) {
                b.isDirty = a;
            }
        }
        undirty(a) {
            let b = this.b;
            if (b != null) {
                b.undirty(a);
            }
        }
        get index() {
            let a = this.b;
            return a != null ? a.index : 0;
        }
        postRender() {
            let a = this.b;
            if (a != null) {
                a.postRender();
            }
        }
        preRender() {
            let a = this.b;
            if (a != null) {
                a.preRender();
            }
        }
        isValid() {
            let a = this.b;
            if (a != null) {
                a.isValid();
            }
            return false;
        }
        equals(a) {
            let b = typeCast(SchedulableRenderWrapper.$, a);
            if (b == null) {
                return super.equals(a);
            }
            let c = b.b;
            let d = this.b;
            return Base.equalsStatic(c, d);
        }
    }
    SchedulableRenderWrapper.$t = /*@__PURE__*/ markType(SchedulableRenderWrapper, 'SchedulableRenderWrapper', Base.$, [ISchedulableRender_$type]);
    return SchedulableRenderWrapper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EventProxy = /*@__PURE__*/ (() => {
    class EventProxy extends Base {
        constructor() {
            super(...arguments);
            this.onMouseWheel = null;
            this.onMouseWheelHorizontal = null;
            this.onPinchStarted = null;
            this.onPinchDelta = null;
            this.onGestureCompleted = null;
            this.onZoomStarted = null;
            this.onZoomDelta = null;
            this.onZoomCompleted = null;
            this.onFlingStarted = null;
            this.onContactStarted = null;
            this.onManipulationCancelled = null;
            this.onDragStarted = null;
            this.onContactMoved = null;
            this.onDragDelta = null;
            this.onContactCompleted = null;
            this.onDragCompleted = null;
            this.onMouseLeave = null;
            this.onMouseOver = null;
            this.onMouseEnter = null;
            this.onMouseDown = null;
            this.onMouseUp = null;
            this.onDoubleTap = null;
            this.onHold = null;
            this.onKeyDown = null;
            this.onKeyUp = null;
            this.bl = null;
            this.bi = 0;
            this.al = false;
            this.am = false;
            this.ao = null;
            this.aq = null;
            this.ar = null;
            this.as = null;
            this.aa = false;
            this.ab = false;
            this.af = false;
            this.ap = null;
        }
        ad(a, b, c) {
            if (this.aq != null) {
                return this.aq(a, b, c);
            }
            return this.ao(a);
        }
        get_an() {
            return false;
        }
        get an() {
            return this.get_an();
        }
        get_ac() {
            return false;
        }
        get ac() {
            return this.get_ac();
        }
        au() {
        }
        aj(a, b) {
            if (this.onMouseWheel != null && !this.ae) {
                return this.onMouseWheel(a, b);
            }
            return false;
        }
        ak(a, b) {
            if (this.onMouseWheelHorizontal != null && !this.ae) {
                return this.onMouseWheelHorizontal(a, b);
            }
            return false;
        }
        bd(a, b) {
            if (this.onPinchStarted != null && !this.ae) {
                this.onPinchStarted(a, b);
            }
        }
        bg(a, b, c, d) {
            if (this.onZoomStarted != null && !this.ae) {
                this.onZoomStarted(a, b, c, d);
            }
        }
        ag(a, b, c) {
            if (this.onFlingStarted != null && !this.ae) {
                return this.onFlingStarted(a, b, c);
            }
            return true;
        }
        bc(a, b) {
            if (this.onPinchDelta != null && !this.ae) {
                this.onPinchDelta(a, b);
            }
        }
        bf(a, b, c, d) {
            if (this.onZoomDelta != null && !this.ae) {
                this.onZoomDelta(a, b, c, d);
            }
        }
        be(a, b, c, d) {
            if (this.onZoomCompleted != null && !this.ae) {
                this.onZoomCompleted(a, b, c, d);
            }
        }
        a4(a, b) {
            if (this.onGestureCompleted != null && !this.ae) {
                this.onGestureCompleted(a, b);
            }
        }
        a6(a) {
            if (this.onManipulationCancelled != null && !this.ae) {
                this.onManipulationCancelled(a);
            }
        }
        az(a, b) {
            if (this.onContactStarted != null && !this.ae) {
                this.onContactStarted(a, b);
            }
        }
        a3(a) {
            if (this.onDragStarted != null && !this.ae) {
                this.onDragStarted(a);
            }
        }
        ay(a, b) {
            if (this.onContactMoved != null && !this.ae) {
                this.onContactMoved(a, b);
            }
        }
        a2(a) {
            if (this.onDragDelta != null && !this.ae) {
                this.onDragDelta(a);
            }
        }
        ax(a, b, c) {
            if (this.onContactCompleted != null && !this.ae) {
                this.am = c;
                this.onContactCompleted(a, b);
                this.am = false;
            }
        }
        a1(a) {
            if (this.onDragCompleted != null && !this.ae) {
                this.onDragCompleted(a);
            }
        }
        a9(a) {
            if (this.onMouseLeave != null && !this.ae) {
                this.onMouseLeave(a);
            }
        }
        ba(a, b, c) {
            if (this.onMouseOver != null && !this.ae) {
                this.onMouseOver(a, b, c);
            }
        }
        a8(a) {
            if (this.onMouseEnter != null && !this.ae) {
                this.onMouseEnter(a);
            }
        }
        a7(a) {
            if (this.onMouseDown != null && !this.ae) {
                this.onMouseDown(a);
            }
        }
        bb(a) {
            if (this.onMouseUp != null && !this.ae) {
                this.onMouseUp(a);
            }
        }
        ah(a) {
            if (this.onKeyDown != null && !this.ae) {
                return this.onKeyDown(a);
            }
            return false;
        }
        ai(a) {
            if (this.onKeyUp != null && !this.ae) {
                return this.onKeyUp(a);
            }
            return false;
        }
        a0(a) {
            if (this.onDoubleTap != null && !this.ae) {
                this.onDoubleTap(a);
            }
        }
        a5(a) {
            if (this.onHold != null && !this.ae) {
                this.onHold(a);
            }
        }
        get ae() {
            return this.aa;
        }
        set ae(a) {
            this.aa = a;
            this.aw();
        }
        aw() {
        }
    }
    EventProxy.$t = /*@__PURE__*/ markType(EventProxy, 'EventProxy');
    return EventProxy;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DVContainer = /*@__PURE__*/ (() => {
    class DVContainer extends Base {
        static get instance() {
            if (DVContainer.a == null) {
                DVContainer.a = new DVContainer();
            }
            return DVContainer.a;
        }
        constructor() {
            super();
            this.d = new Dictionary$2(String_$type, Delegate_$type, 0);
        }
        registerFactory(a, b) {
            this.d.addItem(a.typeName, b);
        }
        createInstance(a, b) {
            if (this.d.containsKey(a.typeName)) {
                return this.d.item(a.typeName)();
            }
            throw new BaseError(1, b());
        }
        registerIfLoaded(typeName_) {
            if (TypeRegistrar.isRegistered(typeName_)) {
                TypeRegistrar.callRegister(typeName_);
            }
        }
        checkLoaded(typeName_) {
            if (TypeRegistrar.isRegistered(typeName_)) {
                return true;
            }
            return false;
        }
    }
    DVContainer.$t = /*@__PURE__*/ markType(DVContainer, 'DVContainer');
    DVContainer.a = null;
    return DVContainer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FontDefaults = /*@__PURE__*/ (() => {
    class FontDefaults extends Base {
        static a7(a) {
            return "Titillium Web, " + a + ", Arial, sans-serif";
        }
    }
    FontDefaults.$t = /*@__PURE__*/ markType(FontDefaults, 'FontDefaults');
    FontDefaults.legendLabelsBrush = /*@__PURE__*/ BrushUtil.h(255, 37, 37, 37);
    FontDefaults.legendLabelsFontSizeConst = 13;
    FontDefaults.legendLabelsFontSize = /*@__PURE__*/ DeviceUtils.f(13);
    FontDefaults.legendLabelsFontConst = "Verdana";
    FontDefaults.legendLabelsFontFamily = /*@__PURE__*/ FontDefaults.a7("Verdana");
    FontDefaults.dataLegendFontBrush = /*@__PURE__*/ BrushUtil.h(255, 37, 37, 37);
    FontDefaults.dataLegendFontSizeConst = 13;
    FontDefaults.dataLegendFontSize = /*@__PURE__*/ DeviceUtils.f(13);
    FontDefaults.dataLegendFontFamilyConst = "Verdana";
    FontDefaults.dataLegendFontFamily = /*@__PURE__*/ FontDefaults.a7("Verdana");
    FontDefaults.dataLegendFontWeight = "400";
    FontDefaults.dataLegendFontStyle = "Normal";
    FontDefaults.dataLegendFontStretch = "Normal";
    FontDefaults.dataLegendFontVariant = "Normal";
    FontDefaults.dataLegendHeaderFontWeight = "600";
    FontDefaults.chartAxisLabelBrush = /*@__PURE__*/ BrushUtil.h(255, 78, 78, 78);
    FontDefaults.chartFontSizeConst = 13;
    FontDefaults.chartFontSize = /*@__PURE__*/ DeviceUtils.f(13);
    FontDefaults.chartFontNameConst = "Verdana";
    FontDefaults.chartXAxisLabelsMarginTop = 5;
    FontDefaults.chartXAxisLabelsMarginBottom = 5;
    FontDefaults.chartXAxisLabelsMarginLeft = 2;
    FontDefaults.chartXAxisLabelsMarginRight = 2;
    FontDefaults.chartYAxisLabelsMarginTop = 2;
    FontDefaults.chartYAxisLabelsMarginBottom = 2;
    FontDefaults.chartYAxisLabelsMarginLeft = 5;
    FontDefaults.chartYAxisLabelsMarginRight = 5;
    FontDefaults.chartFontFamily = /*@__PURE__*/ FontDefaults.a7("Verdana");
    FontDefaults.chartFontWeight = "400";
    FontDefaults.chartFontStyle = "Normal";
    FontDefaults.chartFontStretch = "Normal";
    FontDefaults.chartFontVariant = "Normal";
    FontDefaults.chartTitleFontSizeConst = 20;
    FontDefaults.chartTitleFontSize = /*@__PURE__*/ DeviceUtils.f(20);
    FontDefaults.chartTitleNameConst = "Verdana";
    FontDefaults.chartTitleFontWeight = "600";
    FontDefaults.chartSubtitleFontSizeConst = 20;
    FontDefaults.chartSubtitleFontSize = /*@__PURE__*/ DeviceUtils.f(20);
    FontDefaults.chartSubtitleNameConst = "Verdana";
    FontDefaults.chartSubtitleFontWeight = "600";
    FontDefaults.tooltipLabelsBrush = /*@__PURE__*/ BrushUtil.h(255, 78, 78, 78);
    FontDefaults.tooltipLabelsFontSizeConst = 13;
    FontDefaults.tooltipLabelsFontSize = /*@__PURE__*/ DeviceUtils.f(FontDefaults.tooltipLabelsFontSizeConst);
    FontDefaults.tooltipFontNameConst = "Verdana";
    FontDefaults.tooltipLabelsFontFamily = /*@__PURE__*/ FontDefaults.a7("Verdana");
    FontDefaults.gaugesFontBrush = /*@__PURE__*/ BrushUtil.h(255, 97, 97, 97);
    FontDefaults.gaugesFontSizeConst = 12;
    FontDefaults.gaugesFontSize = /*@__PURE__*/ DeviceUtils.f(12);
    FontDefaults.gaugesFontFamilyConst = "Verdana";
    FontDefaults.gaugesFontWeight = "600";
    FontDefaults.gaugesFontFamily = /*@__PURE__*/ FontDefaults.a7("Verdana");
    FontDefaults.gaugesFontStyle = "Normal";
    FontDefaults.gaugesFontStretch = "Normal";
    FontDefaults.gaugesFontVariant = "Normal";
    FontDefaults.gaugesTitleSizeConst = 12 * 2;
    FontDefaults.gaugesTitleSize = /*@__PURE__*/ DeviceUtils.f(24);
    FontDefaults.gaugesSubtleSizeConst = 12 * 2;
    FontDefaults.gaugesSubtitleSize = /*@__PURE__*/ DeviceUtils.f(24);
    FontDefaults.gaugesHighlightLabelSizeConst = 12 * 2;
    FontDefaults.gaugesHighlightLabelSize = /*@__PURE__*/ DeviceUtils.f(24);
    FontDefaults.treemapFontSizeConst = 13;
    FontDefaults.treemapFontSize = /*@__PURE__*/ DeviceUtils.f(13);
    FontDefaults.treemapHeaderFontSizeConst = 13;
    FontDefaults.treemapHeaderFontSize = /*@__PURE__*/ DeviceUtils.f(13);
    FontDefaults.treemapFontFamilyConst = "Verdana";
    FontDefaults.treemapFontFamily = /*@__PURE__*/ FontDefaults.a7("Verdana");
    FontDefaults.treemapHeaderFontFamily = /*@__PURE__*/ FontDefaults.a7("Verdana");
    FontDefaults.zoomSliderFontSizeConst = 10;
    FontDefaults.zoomSliderFontSize = /*@__PURE__*/ DeviceUtils.f(10);
    FontDefaults.zoomSliderNameConst = "Verdana";
    return FontDefaults;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available interaction states of the chart or geographic map control.
 */
var InteractionState = /*@__PURE__*/ (function (InteractionState) {
    /**
     * User gesture will not change the state of the chart.
     */
    InteractionState[InteractionState["None"] = 0] = "None";
    /**
     * User gesture will start a drag rectangle to zoom the chart.
     */
    InteractionState[InteractionState["DragZoom"] = 1] = "DragZoom";
    /**
     * User gesture will start a pan action to move the chart's window.
     */
    InteractionState[InteractionState["DragPan"] = 2] = "DragPan";
    /**
     * User gesture will start a pan action in a touch environment and a drag rectangle in a mouse environment.
     */
    InteractionState[InteractionState["Auto"] = 3] = "Auto";
    return InteractionState;
})({});
/**
 * @hidden
 */
let InteractionState_$type = /*@__PURE__*/ markEnum('InteractionState', 'None,0|DragZoom,1|DragPan,2|Auto,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SvgIconCollection = /*@__PURE__*/ (() => {
    class SvgIconCollection extends Base {
        constructor() {
            super(...arguments);
            this.e = null;
            this.b = new Dictionary$2(String_$type, String_$type, 0);
            this.c = new Dictionary$2(String_$type, Array_$type, 0);
        }
        g(a, b) {
            this.b.item(a, b);
        }
        d(a) {
            if (a != null && this.b.containsKey(a)) {
                return this.b.item(a);
            }
            return null;
        }
        f(a, b) {
            this.c.item(a, b);
        }
        a(a) {
            if (a != null && this.c.containsKey(a)) {
                return this.c.item(a);
            }
            return null;
        }
    }
    SvgIconCollection.$t = /*@__PURE__*/ markType(SvgIconCollection, 'SvgIconCollection');
    return SvgIconCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SvgIconRegistry = /*@__PURE__*/ (() => {
    class SvgIconRegistry extends Base {
        constructor() {
            super(...arguments);
            this.d = new Dictionary$2(String_$type, SvgIconCollection.$, 0);
            this.e = new Dictionary$2(String_$type, SvgIconCollection.$, 0);
        }
        static get instance() {
            if (SvgIconRegistry.b == null) {
                SvgIconRegistry.b = new SvgIconRegistry();
            }
            return SvgIconRegistry.b;
        }
        addSvgPathString(a, b, c) {
            if (a == null) {
                a = "default";
            }
            if (!this.d.containsKey(a)) {
                this.d.item(a, ((() => {
                    let $ret = new SvgIconCollection();
                    $ret.e = a;
                    return $ret;
                })()));
            }
            this.d.item(a).g(b, c);
        }
        getSvgPathString(a, b) {
            if (a == null) {
                a = "default";
            }
            if (this.d.containsKey(a)) {
                return this.d.item(a).d(b);
            }
            return null;
        }
        addSvgPathsString(a, b, c) {
            if (a == null) {
                a = "default";
            }
            if (!this.d.containsKey(a)) {
                this.d.item(a, ((() => {
                    let $ret = new SvgIconCollection();
                    $ret.e = a;
                    return $ret;
                })()));
            }
            this.d.item(a).f(b, c);
        }
        getSvgPathsString(a, b) {
            if (a == null) {
                a = "default";
            }
            if (this.d.containsKey(a)) {
                return this.d.item(a).a(b);
            }
            return null;
        }
        addDataURLString(a, b, c) {
            if (a == null) {
                a = "default";
            }
            if (!this.e.containsKey(a)) {
                this.e.item(a, ((() => {
                    let $ret = new SvgIconCollection();
                    $ret.e = a;
                    return $ret;
                })()));
            }
            this.e.item(a).g(b, c);
        }
        getDataURLString(a, b) {
            if (a == null) {
                a = "default";
            }
            if (this.e.containsKey(a)) {
                return this.e.item(a).d(b);
            }
            return null;
        }
    }
    SvgIconRegistry.$t = /*@__PURE__*/ markType(SvgIconRegistry, 'SvgIconRegistry');
    SvgIconRegistry.b = null;
    return SvgIconRegistry;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatSpecifier = /*@__PURE__*/ (() => {
    class FormatSpecifier extends Base {
        constructor() {
            super();
            this.a = null;
            this.e();
        }
        toIntl() {
            return null;
        }
        getLocalCulture() {
            let a = (window.navigator.language);
            if (stringContains(a, "-")) {
                return a;
            }
            else {
                if (this.a.containsKey(a)) {
                    return this.a.item(a);
                }
                return a;
            }
        }
        e() {
            this.a = new Dictionary$2(String_$type, String_$type, 0);
            this.a.addItem("af", "af-ZA");
            this.a.addItem("ar", "ar-EG");
            this.a.addItem("az", "az-AZ");
            this.a.addItem("be", "be-BY");
            this.a.addItem("bg", "bg-BG");
            this.a.addItem("ca", "ca-ES");
            this.a.addItem("cs", "cs-CZ");
            this.a.addItem("Cy", "Cy-sr-SP");
            this.a.addItem("da", "da-DK");
            this.a.addItem("de", "de-DE");
            this.a.addItem("div", "div-MV");
            this.a.addItem("el", "el-GR");
            this.a.addItem("en", "en-US");
            this.a.addItem("es", "es-ES");
            this.a.addItem("et", "et-EE");
            this.a.addItem("eu", "eu-ES");
            this.a.addItem("fa", "fa-IR");
            this.a.addItem("fi", "fi-FI");
            this.a.addItem("fo", "fo-FO");
            this.a.addItem("fr", "fr-FR");
            this.a.addItem("gl", "gl-ES");
            this.a.addItem("gu", "gu-IN");
            this.a.addItem("he", "he-IL");
            this.a.addItem("hi", "hi-IN");
            this.a.addItem("hr", "hr-HR");
            this.a.addItem("hu", "hu-HU");
            this.a.addItem("hy", "hy-AM");
            this.a.addItem("id", "id-ID");
            this.a.addItem("is", "is-IS");
            this.a.addItem("it", "it-IT");
            this.a.addItem("ja", "ja-JP");
            this.a.addItem("ka", "ka-GE");
            this.a.addItem("kk", "kk-KZ");
            this.a.addItem("kl", "kl-GL");
            this.a.addItem("km", "km-KH");
            this.a.addItem("kn", "kn-IN");
            this.a.addItem("ko", "ko-KR");
            this.a.addItem("kok", "kok-IN");
            this.a.addItem("ky", "ky-KZ");
            this.a.addItem("Lt", "Lt-az-AZ");
            this.a.addItem("lt", "lt-LT");
            this.a.addItem("lv", "lv-LV");
            this.a.addItem("mk", "mk-MK");
            this.a.addItem("mn", "mn-MN");
            this.a.addItem("mr", "mr-IN");
            this.a.addItem("ms", "ms-MY");
            this.a.addItem("nb", "nb-NO");
            this.a.addItem("nl", "nl-NL");
            this.a.addItem("nn", "nn-NO");
            this.a.addItem("pa", "pa-IN");
            this.a.addItem("pl", "pl-PL");
            this.a.addItem("prs", "prs-AF");
            this.a.addItem("ps", "ps-AF");
            this.a.addItem("pt", "pt-PT");
            this.a.addItem("ro", "ro-RO");
            this.a.addItem("ru", "ru-RU");
            this.a.addItem("sa", "sa-IN");
            this.a.addItem("si", "si-LK");
            this.a.addItem("sk", "sk-SK");
            this.a.addItem("sl", "sl-SI");
            this.a.addItem("sq", "sq-AL");
            this.a.addItem("sr", "sr-Latn-ME");
            this.a.addItem("sv", "sv-FI");
            this.a.addItem("sw", "sw-KE");
            this.a.addItem("syr", "syr-SY");
            this.a.addItem("ta", "ta-IN");
            this.a.addItem("te", "te-IN");
            this.a.addItem("th", "th-TH");
            this.a.addItem("tk", "tk-TM");
            this.a.addItem("tr", "tr-TR");
            this.a.addItem("tt", "tt-RU");
            this.a.addItem("uk", "uk-UA");
            this.a.addItem("ur", "ur-PK");
            this.a.addItem("vi", "vi-VN");
            this.a.addItem("zh", "zh-CN");
        }
        c() {
            return this.toIntl();
            return null;
        }
    }
    FormatSpecifier.$t = /*@__PURE__*/ markType(FormatSpecifier, 'FormatSpecifier');
    return FormatSpecifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumberFormatSpecifier = /*@__PURE__*/ (() => {
    class NumberFormatSpecifier extends FormatSpecifier {
        constructor() {
            super();
            this.g = new Dictionary$2(String_$type, String_$type, 0);
            this._locale = null;
            this._compactDisplay = null;
            this._currency = null;
            this._currencyDisplay = null;
            this._currencySign = null;
            this._currencyCode = null;
            this._localeMatcher = null;
            this._notation = null;
            this._numberingSystem = null;
            this._signDisplay = null;
            this._style = null;
            this._unit = null;
            this._unitDisplay = null;
            this._useGrouping = false;
            this._minimumIntegerDigits = 0;
            this._minimumFractionDigits = 0;
            this._maximumFractionDigits = 0;
            this._minimumSignificantDigits = 0;
            this._maximumSignificantDigits = 0;
            this.useGrouping = true;
            this.minimumIntegerDigits = -1;
            this.minimumFractionDigits = -1;
            this.maximumFractionDigits = -1;
            this.minimumSignificantDigits = -1;
            this.maximumSignificantDigits = -1;
            this.z();
        }
        z() {
            this.g = new Dictionary$2(String_$type, String_$type, 0);
            this.g.addItem("ps-AF", "AFN");
            this.g.addItem("prs-AF", "AFN");
            this.g.addItem("sq-AL", "ALL");
            this.g.addItem("ar-DZ", "DZD");
            this.g.addItem("es-AR", "ARS");
            this.g.addItem("hy-AM", "AMD");
            this.g.addItem("pt-AO", "AOA");
            this.g.addItem("en-AU", "AUD");
            this.g.addItem("de-AT", "EUR");
            this.g.addItem("az-AZ", "AZN");
            this.g.addItem("Lt-az-AZ", "AZN");
            this.g.addItem("Cy-az-AZ", "AZN");
            this.g.addItem("ar-BH", "BHD");
            this.g.addItem("eu-ES", "EUR");
            this.g.addItem("be-BY", "BYN");
            this.g.addItem("nl-BE", "EUR");
            this.g.addItem("fr-BE", "EUR");
            this.g.addItem("en-BZ", "BZD");
            this.g.addItem("es-BO", "BOV");
            this.g.addItem("pt-BR", "BRL");
            this.g.addItem("ms-BN", "USD");
            this.g.addItem("bg-BG", "BGN");
            this.g.addItem("km-KH", "KHR");
            this.g.addItem("en-CA", "CAD");
            this.g.addItem("fr-CA", "CAD");
            this.g.addItem("en-CB", "USA");
            this.g.addItem("ca-ES", "EUR");
            this.g.addItem("es-CL", "CLP");
            this.g.addItem("zh-CN", "CNY");
            this.g.addItem("zh-CHS", "CNY");
            this.g.addItem("zh-CHT", "CNY");
            this.g.addItem("es-CO", "COU");
            this.g.addItem("es-CR", "CRC");
            this.g.addItem("hr-HR", "HRK");
            this.g.addItem("cs-CZ", "CZK");
            this.g.addItem("da-DK", "DKK");
            this.g.addItem("es-DO", "DOP");
            this.g.addItem("es-EC", "USD");
            this.g.addItem("ar-EG", "USD");
            this.g.addItem("es-SV", "SVC");
            this.g.addItem("et-EE", "EUR");
            this.g.addItem("fo-FO", "DKK");
            this.g.addItem("kl-GL", "DKK");
            this.g.addItem("fi-FI", "EUR");
            this.g.addItem("sv-FI", "EUR");
            this.g.addItem("fr-FR", "EUR");
            this.g.addItem("gl-ES", "EUR");
            this.g.addItem("ka-GE", "GEL");
            this.g.addItem("de-DE", "EUR");
            this.g.addItem("el-GR", "EUR");
            this.g.addItem("es-GT", "GTQ");
            this.g.addItem("es-HN", "HNL");
            this.g.addItem("zh-HK", "HKD");
            this.g.addItem("hu-HU", "HUF");
            this.g.addItem("is-IS", "ISK");
            this.g.addItem("gu-IN", "INR");
            this.g.addItem("hi-IN", "INR");
            this.g.addItem("kn-IN", "INR");
            this.g.addItem("kok-IN", "INR");
            this.g.addItem("mr-IN", "INR");
            this.g.addItem("pa-IN", "INR");
            this.g.addItem("sa-IN", "INR");
            this.g.addItem("ta-IN", "INR");
            this.g.addItem("te-IN", "INR");
            this.g.addItem("id-ID", "IDR");
            this.g.addItem("fa-IR", "IRR");
            this.g.addItem("ar-IQ", "IQD");
            this.g.addItem("en-IE", "EUR");
            this.g.addItem("he-IL", "ILS");
            this.g.addItem("it-IT", "EUR");
            this.g.addItem("en-JM", "JMD");
            this.g.addItem("ja-JP", "JPY");
            this.g.addItem("ar-JO", "JOD");
            this.g.addItem("kk-KZ", "KZT");
            this.g.addItem("ky-KZ", "KZT");
            this.g.addItem("sw-KE", "KES");
            this.g.addItem("ko-KR", "KPW");
            this.g.addItem("ar-KW", "KWD");
            this.g.addItem("ky-KG", "KGS");
            this.g.addItem("lv-LV", "EUR");
            this.g.addItem("ar-LB", "LBP");
            this.g.addItem("ar-LY", "LYD");
            this.g.addItem("de-LI", "CHF");
            this.g.addItem("lt-LT", "EUR");
            this.g.addItem("fr-LU", "EUR");
            this.g.addItem("de-LU", "EUR");
            this.g.addItem("zh-MO", "MOP");
            this.g.addItem("ms-MY", "MYR");
            this.g.addItem("div-MV", "MVR");
            this.g.addItem("es-MX", "MXN");
            this.g.addItem("fr-MC", "EUR");
            this.g.addItem("mn-MN", "MNT");
            this.g.addItem("sr-Latn-ME", "EUR");
            this.g.addItem("ar-MA", "MAD");
            this.g.addItem("mk-MK", "MKD");
            this.g.addItem("en-NZ", "NZD");
            this.g.addItem("es-NI", "NIO");
            this.g.addItem("nb-NO", "NOK");
            this.g.addItem("nn-NO", "NOK");
            this.g.addItem("ar-OM", "OMR");
            this.g.addItem("ur-PK", "PKR");
            this.g.addItem("es-PA", "PAB");
            this.g.addItem("es-PY", "PYG");
            this.g.addItem("es-PE", "PEN");
            this.g.addItem("en-PH", "PHP");
            this.g.addItem("pl-PL", "PLN");
            this.g.addItem("pt-PT", "EUR");
            this.g.addItem("es-PR", "USD");
            this.g.addItem("ar-QA", "QAR");
            this.g.addItem("ro-RO", "RON");
            this.g.addItem("ru-RU", "RUB");
            this.g.addItem("tt-RU", "RUB");
            this.g.addItem("ar-SA", "SAR");
            this.g.addItem("sr-SP", "RSD");
            this.g.addItem("Lt-sr-SP", "RSD");
            this.g.addItem("Cy-sr-SP", "XOF");
            this.g.addItem("zh-SG", "SGD");
            this.g.addItem("sk-SK", "EUR");
            this.g.addItem("sl-SI", "EUR");
            this.g.addItem("af-ZA", "ZAR");
            this.g.addItem("en-ZA", "ZAR");
            this.g.addItem("es-ES", "EUR");
            this.g.addItem("sv-SE", "EUR");
            this.g.addItem("si-LK", "LKR");
            this.g.addItem("fr-CH", "CHF");
            this.g.addItem("de-CH", "CHF");
            this.g.addItem("it-CH", "CHF");
            this.g.addItem("ar-SY", "SYP");
            this.g.addItem("syr-SY", "SYP");
            this.g.addItem("zh-TW", "TWD");
            this.g.addItem("th-TH", "THB");
            this.g.addItem("nl-NL", "EUR");
            this.g.addItem("en-TT", "TTD");
            this.g.addItem("ar-TN", "TND");
            this.g.addItem("tr-TR", "TRY");
            this.g.addItem("tk-TM", "TMT");
            this.g.addItem("uk-UA", "UAH");
            this.g.addItem("ar-AE", "AED");
            this.g.addItem("en-GB", "GBP");
            this.g.addItem("en-US", "USD");
            this.g.addItem("es-UY", "UYU");
            this.g.addItem("uz-UZ", "UZS");
            this.g.addItem("Cy-uz-UZ", "UZS");
            this.g.addItem("Lt-uz-UZ", "UZS");
            this.g.addItem("es-VE", "VED");
            this.g.addItem("vi-VN", "VND");
            this.g.addItem("ar-YE", "YER");
            this.g.addItem("en-ZW", "ZWL");
        }
        toIntl() {
            let a = {};
            if (this.compactDisplay != null) {
                this.aa(a, "compactDisplay", this.compactDisplay);
            }
            if (this.currency != null) {
                this.aa(a, "currency", this.currency);
            }
            if (this.currencyDisplay != null) {
                this.aa(a, "currencyDisplay", this.currencyDisplay);
            }
            if (this.currencySign != null) {
                this.aa(a, "currencySign", this.currencySign);
            }
            if (this.localeMatcher != null) {
                this.aa(a, "localeMatcher", this.localeMatcher);
            }
            if (this.notation != null) {
                this.aa(a, "notation", this.notation);
            }
            if (this.numberingSystem != null) {
                this.aa(a, "numberingSystem", this.numberingSystem);
            }
            if (this.signDisplay != null) {
                this.aa(a, "signDisplay", this.signDisplay);
            }
            if (this.style != null) {
                this.aa(a, "style", this.style);
            }
            if (this.unit != null) {
                this.aa(a, "unit", this.unit);
            }
            if (this.unitDisplay != null) {
                this.aa(a, "unitDisplay", this.unitDisplay);
            }
            if (this.useGrouping != true) {
                this.aa(a, "useGrouping", this.useGrouping);
            }
            if (this.minimumIntegerDigits != -1) {
                this.aa(a, "minimumIntegerDigits", this.minimumIntegerDigits);
            }
            if (this.minimumFractionDigits != -1) {
                this.aa(a, "minimumFractionDigits", this.minimumFractionDigits);
            }
            if (this.maximumFractionDigits != -1) {
                this.aa(a, "maximumFractionDigits", this.maximumFractionDigits);
            }
            if (this.minimumSignificantDigits != -1) {
                this.aa(a, "minimumSignificantDigits", this.minimumSignificantDigits);
            }
            if (this.maximumSignificantDigits != -1) {
                this.aa(a, "maximumSignificantDigits", this.maximumSignificantDigits);
            }
            let locale_ = stringIsNullOrEmpty(this.locale) ? this.getLocalCulture() : this.locale;
            if (this.style == "currency") {
                if (this.currencyCode != null) {
                    this.aa(a, "currency", this.currencyCode);
                }
                else if (this.g.containsKey(locale_)) {
                    this.aa(a, "currency", this.g.item(locale_));
                }
            }
            let options_ = a;
            return new Intl.NumberFormat(locale_, options_);
        }
        aa(options_, propertyName_, value_) {
            options_[propertyName_] = value_;
        }
        c() {
            return this.toIntl();
        }
        get locale() {
            return this._locale;
        }
        set locale(a) {
            this._locale = a;
        }
        get compactDisplay() {
            return this._compactDisplay;
        }
        set compactDisplay(a) {
            this._compactDisplay = a;
        }
        get currency() {
            return this._currency;
        }
        set currency(a) {
            this._currency = a;
        }
        get currencyDisplay() {
            return this._currencyDisplay;
        }
        set currencyDisplay(a) {
            this._currencyDisplay = a;
        }
        get currencySign() {
            return this._currencySign;
        }
        set currencySign(a) {
            this._currencySign = a;
        }
        get currencyCode() {
            return this._currencyCode;
        }
        set currencyCode(a) {
            this._currencyCode = a;
        }
        get localeMatcher() {
            return this._localeMatcher;
        }
        set localeMatcher(a) {
            this._localeMatcher = a;
        }
        get notation() {
            return this._notation;
        }
        set notation(a) {
            this._notation = a;
        }
        get numberingSystem() {
            return this._numberingSystem;
        }
        set numberingSystem(a) {
            this._numberingSystem = a;
        }
        get signDisplay() {
            return this._signDisplay;
        }
        set signDisplay(a) {
            this._signDisplay = a;
        }
        get style() {
            return this._style;
        }
        set style(a) {
            this._style = a;
        }
        get unit() {
            return this._unit;
        }
        set unit(a) {
            this._unit = a;
        }
        get unitDisplay() {
            return this._unitDisplay;
        }
        set unitDisplay(a) {
            this._unitDisplay = a;
        }
        get useGrouping() {
            return this._useGrouping;
        }
        set useGrouping(a) {
            this._useGrouping = a;
        }
        get minimumIntegerDigits() {
            return this._minimumIntegerDigits;
        }
        set minimumIntegerDigits(a) {
            this._minimumIntegerDigits = a;
        }
        get minimumFractionDigits() {
            return this._minimumFractionDigits;
        }
        set minimumFractionDigits(a) {
            this._minimumFractionDigits = a;
        }
        get maximumFractionDigits() {
            return this._maximumFractionDigits;
        }
        set maximumFractionDigits(a) {
            this._maximumFractionDigits = a;
        }
        get minimumSignificantDigits() {
            return this._minimumSignificantDigits;
        }
        set minimumSignificantDigits(a) {
            this._minimumSignificantDigits = a;
        }
        get maximumSignificantDigits() {
            return this._maximumSignificantDigits;
        }
        set maximumSignificantDigits(a) {
            this._maximumSignificantDigits = a;
        }
    }
    NumberFormatSpecifier.$t = /*@__PURE__*/ markType(NumberFormatSpecifier, 'NumberFormatSpecifier', FormatSpecifier.$);
    return NumberFormatSpecifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeFormatSpecifier = /*@__PURE__*/ (() => {
    class DateTimeFormatSpecifier extends FormatSpecifier {
        constructor() {
            super();
            this._locale = null;
            this._dateStyle = null;
            this._timeStyle = null;
            this._fractionalSecondDigits = 0;
            this._calendar = null;
            this._dayPeriod = null;
            this._numberingSystem = null;
            this._localeMatcher = null;
            this._timeZone = null;
            this._hour12 = null;
            this._hourCycle = null;
            this._formatMatcher = null;
            this._weekDay = null;
            this._era = null;
            this._year = null;
            this._month = null;
            this._day = null;
            this._hour = null;
            this._minute = null;
            this._second = null;
            this._timeZoneName = null;
            this.fractionalSecondDigits = -1;
        }
        toIntl() {
            let a = {};
            if (this.dateStyle != null) {
                this.aa(a, "dateStyle", this.dateStyle);
            }
            if (this.timeStyle != null) {
                this.aa(a, "timeStyle", this.timeStyle);
            }
            if (this.fractionalSecondDigits != -1) {
                this.aa(a, "fractionalSecondDigits", this.fractionalSecondDigits);
            }
            if (this.calendar != null) {
                this.aa(a, "calendar", this.calendar);
            }
            if (this.dayPeriod != null) {
                this.aa(a, "dayPeriod", this.dayPeriod);
            }
            if (this.numberingSystem != null) {
                this.aa(a, "numberingSystem", this.numberingSystem);
            }
            if (this.localeMatcher != null) {
                this.aa(a, "localeMatcher", this.localeMatcher);
            }
            if (this.timeZone != null) {
                this.aa(a, "timeZone", this.timeZone);
            }
            if (this.hour12 != null) {
                this.aa(a, "hour12", this.hour12.toLowerCase() == "true" ? true : false);
            }
            if (this.hourCycle != null) {
                this.aa(a, "hourCycle", this.hourCycle);
            }
            if (this.formatMatcher != null) {
                this.aa(a, "formatMatcher", this.formatMatcher);
            }
            if (this.weekDay != null) {
                this.aa(a, "weekday", this.weekDay);
            }
            if (this.era != null) {
                this.aa(a, "era", this.era);
            }
            if (this.year != null) {
                this.aa(a, "year", this.year);
            }
            if (this.month != null) {
                this.aa(a, "month", this.month);
            }
            if (this.day != null) {
                this.aa(a, "day", this.day);
            }
            if (this.hour != null) {
                this.aa(a, "hour", this.hour);
            }
            if (this.minute != null) {
                this.aa(a, "minute", this.minute);
            }
            if (this.second != null) {
                this.aa(a, "second", this.second);
            }
            if (this.timeZoneName != null) {
                this.aa(a, "timeZoneName", this.timeZoneName);
            }
            let locale_ = stringIsNullOrEmpty(this.locale) ? this.getLocalCulture() : this.locale;
            let options_ = a;
            return new Intl.DateTimeFormat(locale_, options_);
        }
        aa(options_, propertyName_, value_) {
            options_[propertyName_] = value_;
        }
        c() {
            return this.toIntl();
        }
        get locale() {
            return this._locale;
        }
        set locale(a) {
            this._locale = a;
        }
        get dateStyle() {
            return this._dateStyle;
        }
        set dateStyle(a) {
            this._dateStyle = a;
        }
        get timeStyle() {
            return this._timeStyle;
        }
        set timeStyle(a) {
            this._timeStyle = a;
        }
        get fractionalSecondDigits() {
            return this._fractionalSecondDigits;
        }
        set fractionalSecondDigits(a) {
            this._fractionalSecondDigits = a;
        }
        get calendar() {
            return this._calendar;
        }
        set calendar(a) {
            this._calendar = a;
        }
        get dayPeriod() {
            return this._dayPeriod;
        }
        set dayPeriod(a) {
            this._dayPeriod = a;
        }
        get numberingSystem() {
            return this._numberingSystem;
        }
        set numberingSystem(a) {
            this._numberingSystem = a;
        }
        get localeMatcher() {
            return this._localeMatcher;
        }
        set localeMatcher(a) {
            this._localeMatcher = a;
        }
        get timeZone() {
            return this._timeZone;
        }
        set timeZone(a) {
            this._timeZone = a;
        }
        get hour12() {
            return this._hour12;
        }
        set hour12(a) {
            this._hour12 = a;
        }
        get hourCycle() {
            return this._hourCycle;
        }
        set hourCycle(a) {
            this._hourCycle = a;
        }
        get formatMatcher() {
            return this._formatMatcher;
        }
        set formatMatcher(a) {
            this._formatMatcher = a;
        }
        get weekDay() {
            return this._weekDay;
        }
        set weekDay(a) {
            this._weekDay = a;
        }
        get era() {
            return this._era;
        }
        set era(a) {
            this._era = a;
        }
        get year() {
            return this._year;
        }
        set year(a) {
            this._year = a;
        }
        get month() {
            return this._month;
        }
        set month(a) {
            this._month = a;
        }
        get day() {
            return this._day;
        }
        set day(a) {
            this._day = a;
        }
        get hour() {
            return this._hour;
        }
        set hour(a) {
            this._hour = a;
        }
        get minute() {
            return this._minute;
        }
        set minute(a) {
            this._minute = a;
        }
        get second() {
            return this._second;
        }
        set second(a) {
            this._second = a;
        }
        get timeZoneName() {
            return this._timeZoneName;
        }
        set timeZoneName(a) {
            this._timeZoneName = a;
        }
    }
    DateTimeFormatSpecifier.$t = /*@__PURE__*/ markType(DateTimeFormatSpecifier, 'DateTimeFormatSpecifier', FormatSpecifier.$);
    return DateTimeFormatSpecifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BindingFormatter = /*@__PURE__*/ (() => {
    class BindingFormatter extends Base {
        constructor() {
            super();
            this.h = null;
            this.a = null;
            this.f = null;
            this.g = null;
            this.b = null;
            this.c = null;
        }
        get j() {
            return this.h;
        }
        set j(a) {
            this.h = a;
            this.l();
        }
        l() {
            let a = this.j;
            if (a == null) {
                return;
            }
            let b = 0;
            let c = new List$1(String_$type, 0);
            let d = new List$1(FastReflectionHelper.$, 0);
            let e = new List$1(String_$type, 0);
            for (let f = a.indexOf('{', b); f >= b; f = a.indexOf('{', b)) {
                e.add(a.substr(b, f - b));
                let g = a.indexOf('}', f);
                if (g <= f) {
                    return;
                }
                let h = a.substr(f + 1, g - f - 1).trim();
                let i = h.indexOf(':');
                if (i == -1) {
                    c.add(h);
                    if (h == "0" || h == ".") {
                        d.add(null);
                    }
                    else {
                        d.add(new FastReflectionHelper(false, h));
                    }
                }
                else {
                    let j = h.substr(0, i).trim();
                    d.add(new FastReflectionHelper(false, j));
                    c.add(j);
                    if (j == "0" || j == ".") {
                        d.add(null);
                    }
                    else {
                        d.add(new FastReflectionHelper(false, h));
                    }
                }
                b = g + 1;
            }
            e.add(a.substr(b));
            this.f = e;
            this.g = d;
        }
        get d() {
            return this.a;
        }
        set d(a) {
            this.a = a;
            this.k();
        }
        k() {
            if (this.a == null) {
                this.b = null;
                this.c = null;
                return;
            }
            this.b = new Array(this.a.length);
            this.c = new Array(this.a.length);
            for (let a = 0; a < this.a.length; a++) {
                let spec_ = this.a[a];
                if ((spec_._implementation)) {
                    spec_ = (spec_._implementation);
                }
                let b = this.e(spec_);
                this.c[a] = b;
                if (b != 0) {
                    if (typeCast(FormatSpecifier.$, spec_) !== null) {
                        this.b[a] = spec_.toIntl();
                    }
                    else {
                        this.b[a] = spec_;
                    }
                }
            }
        }
        e(a) {
            if (a == null) {
                return 0;
            }
            let v_ = a;
            if ((v_ instanceof Intl.NumberFormat) || typeCast(NumberFormatSpecifier.$, v_) !== null) {
                return 1;
            }
            if ((v_ instanceof Intl.DateTimeFormat) || typeCast(DateTimeFormatSpecifier.$, v_) !== null) {
                return 2;
            }
            return 0;
        }
        i(a) {
            let b = "";
            if (this.f == null) {
                return b;
            }
            for (let c = 0; c < this.f.count; c++) {
                b += this.f._inner[c];
                if (c < this.g.count) {
                    let obj_ = a;
                    let d = this.g._inner[c];
                    if (d != null) {
                        obj_ = d.getPropertyValue(obj_);
                    }
                    if (this.b != null && c < this.b.length && this.b[c] != null) {
                        let platformSpecifier_ = this.b[c];
                        let e = this.c[c];
                        let intlSpecifier_ = platformSpecifier_;
                        b += intlSpecifier_.format(obj_);
                    }
                    else {
                        b += obj_ != null ? obj_.toString() : "";
                    }
                }
            }
            return b;
        }
    }
    BindingFormatter.$t = /*@__PURE__*/ markType(BindingFormatter, 'BindingFormatter');
    return BindingFormatter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PlatformSpecifierType_$type = /*@__PURE__*/ markEnum('PlatformSpecifierType', 'None,0|Number,1|Date,2|AbstractNumber,3|AbstractDate,4|Generic,5');

class IgrFormatSpecifier {
    createImplementation() {
        return new FormatSpecifier();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    getLocalCulture() {
        let iv = this.i.getLocalCulture();
        return (iv);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrFormatSpecifierModule {
    static register() {
        TypeRegistrar.registerCons("IgrFormatSpecifier", IgrFormatSpecifier);
        TypeRegistrar.register("FormatSpecifier", FormatSpecifier.$type);
    }
}

class IgrFormatSpecifierCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrFormatSpecifier.$type) {
            IgrFormatSpecifier.$type = markType(IgrFormatSpecifier, "IgrFormatSpecifier");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrFormatSpecifier.$type) {
            IgrFormatSpecifier.$type = markType(IgrFormatSpecifier, "IgrFormatSpecifier");
        }
        let coll = new SyncableObservableCollection$2(IgrFormatSpecifier.$type, FormatSpecifier.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgrFormatSpecifier();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatSpecifierCollection = /*@__PURE__*/ (() => {
    class FormatSpecifierCollection extends ObservableCollection$1 {
        constructor() {
            super(FormatSpecifier.$, 0);
        }
    }
    FormatSpecifierCollection.$t = /*@__PURE__*/ markType(FormatSpecifierCollection, 'FormatSpecifierCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(FormatSpecifier.$));
    return FormatSpecifierCollection;
})();

class IgrNumberFormatSpecifier extends IgrFormatSpecifier {
    createImplementation() {
        return new NumberFormatSpecifier();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get locale() {
        return this.i.locale;
    }
    set locale(v) {
        this.i.locale = v;
    }
    get compactDisplay() {
        return this.i.compactDisplay;
    }
    set compactDisplay(v) {
        this.i.compactDisplay = v;
    }
    get currency() {
        return this.i.currency;
    }
    set currency(v) {
        this.i.currency = v;
    }
    get currencyDisplay() {
        return this.i.currencyDisplay;
    }
    set currencyDisplay(v) {
        this.i.currencyDisplay = v;
    }
    get currencySign() {
        return this.i.currencySign;
    }
    set currencySign(v) {
        this.i.currencySign = v;
    }
    get currencyCode() {
        return this.i.currencyCode;
    }
    set currencyCode(v) {
        this.i.currencyCode = v;
    }
    get localeMatcher() {
        return this.i.localeMatcher;
    }
    set localeMatcher(v) {
        this.i.localeMatcher = v;
    }
    get notation() {
        return this.i.notation;
    }
    set notation(v) {
        this.i.notation = v;
    }
    get numberingSystem() {
        return this.i.numberingSystem;
    }
    set numberingSystem(v) {
        this.i.numberingSystem = v;
    }
    get signDisplay() {
        return this.i.signDisplay;
    }
    set signDisplay(v) {
        this.i.signDisplay = v;
    }
    get style() {
        return this.i.style;
    }
    set style(v) {
        this.i.style = v;
    }
    get unit() {
        return this.i.unit;
    }
    set unit(v) {
        this.i.unit = v;
    }
    get unitDisplay() {
        return this.i.unitDisplay;
    }
    set unitDisplay(v) {
        this.i.unitDisplay = v;
    }
    get useGrouping() {
        return this.i.useGrouping;
    }
    set useGrouping(v) {
        this.i.useGrouping = ensureBool(v);
    }
    get minimumIntegerDigits() {
        return this.i.minimumIntegerDigits;
    }
    set minimumIntegerDigits(v) {
        this.i.minimumIntegerDigits = +v;
    }
    get minimumFractionDigits() {
        return this.i.minimumFractionDigits;
    }
    set minimumFractionDigits(v) {
        this.i.minimumFractionDigits = +v;
    }
    get maximumFractionDigits() {
        return this.i.maximumFractionDigits;
    }
    set maximumFractionDigits(v) {
        this.i.maximumFractionDigits = +v;
    }
    get minimumSignificantDigits() {
        return this.i.minimumSignificantDigits;
    }
    set minimumSignificantDigits(v) {
        this.i.minimumSignificantDigits = +v;
    }
    get maximumSignificantDigits() {
        return this.i.maximumSignificantDigits;
    }
    set maximumSignificantDigits(v) {
        this.i.maximumSignificantDigits = +v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrNumberFormatSpecifierModule {
    static register() {
        TypeRegistrar.registerCons("IgrNumberFormatSpecifier", IgrNumberFormatSpecifier);
        TypeRegistrar.register("NumberFormatSpecifier", NumberFormatSpecifier.$type);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PlatformFormatter = /*@__PURE__*/ (() => {
    class PlatformFormatter extends Base {
        a(a) {
            return "";
        }
    }
    PlatformFormatter.$t = /*@__PURE__*/ markType(PlatformFormatter, 'PlatformFormatter');
    return PlatformFormatter;
})();

class IgrDateTimeFormatSpecifier extends IgrFormatSpecifier {
    createImplementation() {
        return new DateTimeFormatSpecifier();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get locale() {
        return this.i.locale;
    }
    set locale(v) {
        this.i.locale = v;
    }
    get dateStyle() {
        return this.i.dateStyle;
    }
    set dateStyle(v) {
        this.i.dateStyle = v;
    }
    get timeStyle() {
        return this.i.timeStyle;
    }
    set timeStyle(v) {
        this.i.timeStyle = v;
    }
    get fractionalSecondDigits() {
        return this.i.fractionalSecondDigits;
    }
    set fractionalSecondDigits(v) {
        this.i.fractionalSecondDigits = +v;
    }
    get calendar() {
        return this.i.calendar;
    }
    set calendar(v) {
        this.i.calendar = v;
    }
    get dayPeriod() {
        return this.i.dayPeriod;
    }
    set dayPeriod(v) {
        this.i.dayPeriod = v;
    }
    get numberingSystem() {
        return this.i.numberingSystem;
    }
    set numberingSystem(v) {
        this.i.numberingSystem = v;
    }
    get localeMatcher() {
        return this.i.localeMatcher;
    }
    set localeMatcher(v) {
        this.i.localeMatcher = v;
    }
    get timeZone() {
        return this.i.timeZone;
    }
    set timeZone(v) {
        this.i.timeZone = v;
    }
    get hour12() {
        return this.i.hour12;
    }
    set hour12(v) {
        this.i.hour12 = v;
    }
    get hourCycle() {
        return this.i.hourCycle;
    }
    set hourCycle(v) {
        this.i.hourCycle = v;
    }
    get formatMatcher() {
        return this.i.formatMatcher;
    }
    set formatMatcher(v) {
        this.i.formatMatcher = v;
    }
    get weekDay() {
        return this.i.weekDay;
    }
    set weekDay(v) {
        this.i.weekDay = v;
    }
    get era() {
        return this.i.era;
    }
    set era(v) {
        this.i.era = v;
    }
    get year() {
        return this.i.year;
    }
    set year(v) {
        this.i.year = v;
    }
    get month() {
        return this.i.month;
    }
    set month(v) {
        this.i.month = v;
    }
    get day() {
        return this.i.day;
    }
    set day(v) {
        this.i.day = v;
    }
    get hour() {
        return this.i.hour;
    }
    set hour(v) {
        this.i.hour = v;
    }
    get minute() {
        return this.i.minute;
    }
    set minute(v) {
        this.i.minute = v;
    }
    get second() {
        return this.i.second;
    }
    set second(v) {
        this.i.second = v;
    }
    get timeZoneName() {
        return this.i.timeZoneName;
    }
    set timeZoneName(v) {
        this.i.timeZoneName = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDateTimeFormatSpecifierModule {
    static register() {
        TypeRegistrar.registerCons("IgrDateTimeFormatSpecifier", IgrDateTimeFormatSpecifier);
        TypeRegistrar.register("DateTimeFormatSpecifier", DateTimeFormatSpecifier.$type);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArrayAccessHelper = /*@__PURE__*/ (() => {
    class ArrayAccessHelper extends Base {
        static b(values_) {
            let a = (Array.isArray(values_) ? values_ : null);
            return a;
        }
        static c(values_) {
            let a = (Array.isArray(values_) ? values_ : null);
            return a;
        }
        static a(a) {
            if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
                return a.asArray();
            }
            return null;
        }
    }
    ArrayAccessHelper.$t = /*@__PURE__*/ markType(ArrayAccessHelper, 'ArrayAccessHelper');
    return ArrayAccessHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DelayManagerCallbackSettings = /*@__PURE__*/ (() => {
    class DelayManagerCallbackSettings extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = 0;
            this.c = 0;
        }
    }
    DelayManagerCallbackSettings.$t = /*@__PURE__*/ markType(DelayManagerCallbackSettings, 'DelayManagerCallbackSettings');
    return DelayManagerCallbackSettings;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DelayManager = /*@__PURE__*/ (() => {
    class DelayManager extends Base {
        get b() {
            return this.a;
        }
        set b(a) {
            this.a = a;
        }
        constructor(a, ..._rest) {
            super();
            this.a = null;
            this.c = null;
            this.d = null;
            this.e = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.c = new FastIterationDictionary$2(Delegate_$type, DelayManagerCallbackSettings.$, 0);
                        this.d = new FastIterationDictionary$2(Number_$type, Delegate_$type, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        {
                            this.c = new FastIterationDictionary$2(Delegate_$type, DelayManagerCallbackSettings.$, 0);
                            this.d = new FastIterationDictionary$2(Number_$type, Delegate_$type, 0);
                        }
                        this.a = c;
                    }
                    break;
            }
        }
        f(a, b) {
            if (this.a == null) {
                return -1;
            }
            if (this.c.d(a)) {
                this.c.item(a).c = this.a.getCurrentRelativeTime();
            }
            else {
                let c = new DelayManagerCallbackSettings();
                c.a = this.e++;
                c.c = this.a.getCurrentRelativeTime();
                c.b = b;
                this.c.s(a, c);
                this.d.s(c.a, a);
            }
            this.a.executeDelayed(() => this.h(a), b);
            return this.c.item(a).a;
        }
        g(a) {
            if (this.d.d(a)) {
                let b = this.d.item(a);
                this.d.f(a);
                this.c.f(b);
            }
        }
        h(a) {
            if (this.c.d(a)) {
                let b = this.c.item(a);
                let c = this.a == null ? 0 : this.a.getCurrentRelativeTime();
                let d = c - b.c;
                if (this.a == null || d >= b.b) {
                    a();
                    this.c.f(a);
                    this.d.f(b.a);
                }
                else {
                    this.a.executeDelayed(() => this.h(a), (b.b - d));
                }
            }
        }
    }
    DelayManager.$t = /*@__PURE__*/ markType(DelayManager, 'DelayManager');
    return DelayManager;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SVGNode = /*@__PURE__*/ (() => {
    class SVGNode extends Base {
        constructor(a) {
            super();
            this.c = 0;
            this.g = null;
            this.h = null;
            this.f = null;
            this.b = null;
            this.e = null;
            this.e = new List$1(SVGNode.$, 0);
            this.b = a;
        }
        a(a) {
            return null;
        }
        d() {
            return this.c == 4 || this.c == 3 || this.c == 5 || this.c == 6 || this.c == 7 || this.c == 1 || this.c == 2;
        }
    }
    SVGNode.$t = /*@__PURE__*/ markType(SVGNode, 'SVGNode');
    return SVGNode;
})();
/**
 * @hidden
 */
let SVGPresentationNode = /*@__PURE__*/ (() => {
    class SVGPresentationNode extends SVGNode {
        get l() {
            return this.j;
        }
        set l(a) {
            this.j = a;
            if (this.j != null) {
                this.j.c = this;
                this.j.a = 0;
            }
        }
        get m() {
            return this.k;
        }
        set m(a) {
            this.k = a;
            if (this.k != null) {
                this.k.c = this;
                this.k.a = 1;
            }
        }
        get s() {
            return this.o;
        }
        set s(a) {
            this.o = a;
        }
        get p() {
            return this.n;
        }
        set p(a) {
            this.n = a;
        }
        constructor(a) {
            super(a);
            this.j = null;
            this.k = null;
            this.t = 0;
            this.r = 0;
            this.v = 0;
            this.u = 0;
            this.q = 0;
            this.i = null;
            this.o = NaN;
            this.n = NaN;
            this.t = 1;
            this.r = 4;
            this.q = 1;
            this.l = ((() => {
                let $ret = new SVGBrush();
                $ret.b = 1;
                $ret.c = this;
                $ret.a = 0;
                return $ret;
            })());
            this.m = ((() => {
                let $ret = new SVGBrush();
                $ret.b = 1;
                $ret.c = this;
                $ret.a = 1;
                return $ret;
            })());
        }
        a(a) {
            if (this.b == null) {
                return null;
            }
            let b = this.b;
            while (b != null) {
                if (b.d()) {
                    let c = b;
                    if (a == 0 && c.l != null) {
                        switch (c.l.b) {
                            case 0:
                            case 2: return c.l;
                        }
                    }
                    else if (a == 1 && c.m != null) {
                        switch (c.m.b) {
                            case 0:
                            case 2: return c.m;
                        }
                    }
                }
                b = b.b;
            }
            return super.a(a);
        }
    }
    SVGPresentationNode.$t = /*@__PURE__*/ markType(SVGPresentationNode, 'SVGPresentationNode', SVGNode.$);
    return SVGPresentationNode;
})();
/**
 * @hidden
 */
let SVGBrush = /*@__PURE__*/ (() => {
    class SVGBrush extends Base {
        constructor() {
            super(...arguments);
            this.e = null;
            this.b = 0;
            this.c = null;
            this.a = 0;
        }
        f(a) {
            switch (this.b) {
                case 0: return null;
                case 1:
                    {
                        if (this.c != null) {
                            let b = this.c.a(this.a);
                            if (b != null) {
                                switch (b.b) {
                                    case 0: return null;
                                    case 1: return this.d(a);
                                    default: return this.d(b.e);
                                }
                            }
                        }
                        return this.d(a);
                    }
                default: return this.d(this.e);
            }
        }
        d(a) {
            if (this.c.d()) {
                let b = this.c;
                if (this.a == 0 && !isNaN_(b.p)) {
                    return BrushUtil.q(a, b.p);
                }
                else if (this.a == 1 && !isNaN_(b.s)) {
                    return BrushUtil.q(a, b.s);
                }
            }
            return a;
        }
    }
    SVGBrush.$t = /*@__PURE__*/ markType(SVGBrush, 'SVGBrush');
    return SVGBrush;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SVGRoot = /*@__PURE__*/ (() => {
    class SVGRoot extends SVGPresentationNode {
        get_c() {
            return 1;
        }
        constructor() {
            super(null);
            this.x = 0;
            this.w = 0;
            this.y = null;
        }
    }
    SVGRoot.$t = /*@__PURE__*/ markType(SVGRoot, 'SVGRoot', SVGPresentationNode.$);
    return SVGRoot;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SVGGroup = /*@__PURE__*/ (() => {
    class SVGGroup extends SVGPresentationNode {
        get_c() {
            return 2;
        }
        constructor(a) {
            super(a);
        }
    }
    SVGGroup.$t = /*@__PURE__*/ markType(SVGGroup, 'SVGGroup', SVGPresentationNode.$);
    return SVGGroup;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SVGRect = /*@__PURE__*/ (() => {
    class SVGRect extends SVGPresentationNode {
        get_c() {
            return 4;
        }
        constructor(a) {
            super(a);
            this.z = 0;
            this.w = 0;
            this.x = 0;
            this.y = 0;
        }
    }
    SVGRect.$t = /*@__PURE__*/ markType(SVGRect, 'SVGRect', SVGPresentationNode.$);
    return SVGRect;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SVGLine = /*@__PURE__*/ (() => {
    class SVGLine extends SVGPresentationNode {
        get_c() {
            return 3;
        }
        constructor(a) {
            super(a);
            this.w = 0;
            this.y = 0;
            this.x = 0;
            this.z = 0;
        }
    }
    SVGLine.$t = /*@__PURE__*/ markType(SVGLine, 'SVGLine', SVGPresentationNode.$);
    return SVGLine;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SVGPath = /*@__PURE__*/ (() => {
    class SVGPath extends SVGPresentationNode {
        get_c() {
            return 7;
        }
        constructor(a) {
            super(a);
            this.w = null;
        }
    }
    SVGPath.$t = /*@__PURE__*/ markType(SVGPath, 'SVGPath', SVGPresentationNode.$);
    return SVGPath;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SVGEllipse = /*@__PURE__*/ (() => {
    class SVGEllipse extends SVGPresentationNode {
        get_c() {
            return 6;
        }
        constructor(a) {
            super(a);
            this.w = 0;
            this.x = 0;
            this.y = 0;
            this.z = 0;
        }
    }
    SVGEllipse.$t = /*@__PURE__*/ markType(SVGEllipse, 'SVGEllipse', SVGPresentationNode.$);
    return SVGEllipse;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SVGCircle = /*@__PURE__*/ (() => {
    class SVGCircle extends SVGEllipse {
        get_c() {
            return 5;
        }
        constructor(a) {
            super(a);
        }
    }
    SVGCircle.$t = /*@__PURE__*/ markType(SVGCircle, 'SVGCircle', SVGEllipse.$);
    return SVGCircle;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SVGParser = /*@__PURE__*/ (() => {
    class SVGParser extends Base {
        static c(a) {
            let b = false;
            let c = "";
            let d = "";
            let e = null;
            for (let f = 0; f < a.length; f++) {
                let g = a.charAt(f);
                if (g == '<') {
                    b = true;
                    continue;
                }
                if (b) {
                    if (g == ' ' || g == '>') {
                        if (g == '>') {
                            f--;
                        }
                        b = false;
                        continue;
                    }
                    d += g;
                    continue;
                }
                if (a.charAt(f) != '>' && !(a.charAt(f) == '/' && a.charAt(f + 1) == '>')) {
                    c += g;
                }
                else {
                    if (d == "svg") {
                        e = SVGParser.d(1, null, c);
                        if (a.charAt(f) == '>') {
                            f = SVGParser.f(a, f + 1, e);
                        }
                        return e;
                    }
                    else {
                        b = false;
                        c = "";
                        d = "";
                    }
                }
            }
            return null;
        }
        static f(a, b, c) {
            let d = false;
            let e = false;
            let f = null;
            let g = "";
            let h = "";
            for (let i = b; i < a.length; i++) {
                let j = a.charAt(i);
                if (j == '<') {
                    d = true;
                    e = true;
                    continue;
                }
                if (!e) {
                    continue;
                }
                if (d) {
                    if (c != null && j == '/') {
                        switch (c.c) {
                            case 2: return i + ("g>").length;
                            case 3:
                            case 7:
                            case 4: return i + ("rect>").length;
                            case 5: return i + ("circle>").length;
                            case 6: return i + ("ellipse>").length;
                            case 1: return i + ("svg>").length;
                        }
                    }
                    if (j == ' ' || j == '>') {
                        if (j == '>') {
                            i--;
                        }
                        d = false;
                        continue;
                    }
                    g += j;
                    continue;
                }
                if (a.charAt(i) != '>' && !(a.charAt(i) == '/' && a.charAt(i + 1) == '>')) {
                    h += j;
                }
                else {
                    let k = false;
                    switch (g) {
                        case "svg":
                            f = SVGParser.d(1, c, h);
                            break;
                        case "g":
                            f = SVGParser.d(2, c, h);
                            break;
                        case "line":
                            f = SVGParser.d(3, c, h);
                            break;
                        case "path":
                            f = SVGParser.d(7, c, h);
                            break;
                        case "rect":
                            f = SVGParser.d(4, c, h);
                            break;
                        case "circle":
                            f = SVGParser.d(5, c, h);
                            break;
                        case "ellipse":
                            f = SVGParser.d(6, c, h);
                            break;
                    }
                    if (f == null) {
                        let l = "";
                        let m = i;
                        while (m < a.length) {
                            l += a.charAt(m);
                            if (stringEndsWith(l, "/" + g + ">")) {
                                break;
                            }
                            m++;
                            i++;
                        }
                    }
                    else {
                        if (c != null) {
                            c.e.add(f);
                        }
                        if (a.charAt(i) == '>') {
                            i = SVGParser.f(a, i + 1, f);
                        }
                    }
                    d = false;
                    e = false;
                    g = "";
                    h = "";
                }
            }
            return -1;
        }
        static d(a, b, c) {
            let d = null;
            switch (a) {
                case 1:
                    d = new SVGRoot();
                    break;
                case 2:
                    d = new SVGGroup(b);
                    break;
                case 4:
                    d = new SVGRect(b);
                    break;
                case 3:
                    d = new SVGLine(b);
                    break;
                case 7:
                    d = new SVGPath(b);
                    break;
                case 5:
                    d = new SVGCircle(b);
                    break;
                case 6:
                    d = new SVGEllipse(b);
                    break;
            }
            let e = true;
            let f = false;
            let g = "";
            let h = "";
            for (let i = 0; i < c.length; i++) {
                if (c.charAt(i) == '=') {
                    e = false;
                    continue;
                }
                if (c.charAt(i) == '\"') {
                    f = !f;
                    if (!f && i == c.length - 1) {
                        SVGParser.g(d, g, h);
                        e = true;
                        f = false;
                        g = "";
                        h = "";
                    }
                    continue;
                }
                if (!e && !f && (c.charAt(i) == ' ' || i == c.length - 1)) {
                    SVGParser.g(d, g, h);
                    e = true;
                    f = false;
                    g = "";
                    h = "";
                    continue;
                }
                if (e) {
                    g += c.charAt(i);
                }
                if (f) {
                    h += c.charAt(i);
                }
            }
            return d;
        }
        static g(a, b, c) {
            switch (b) {
                case "id":
                    a.g = c;
                    break;
                case "transform":
                    a.h = SVGParser.j(c);
                    break;
                case "class":
                    a.f = c;
                    break;
            }
            if (a.c == 1) {
                let d = a;
                switch (b) {
                    case "width":
                        d.x = SVGParser.e(c);
                        break;
                    case "height":
                        d.w = SVGParser.e(c);
                        break;
                    case "viewBox":
                        d.y = SVGParser.k(c);
                        break;
                }
            }
            else if (a.c == 7) {
                let e = a;
                switch (b) {
                    case "d":
                        e.w = Geometry.a(c);
                        break;
                }
            }
            else if (a.c == 4) {
                let f = a;
                switch (b) {
                    case "width":
                        f.z = SVGParser.e(c);
                        break;
                    case "height":
                        f.w = SVGParser.e(c);
                        break;
                    case "rx":
                        f.x = SVGParser.e(c);
                        break;
                    case "ry":
                        f.y = SVGParser.e(c);
                        break;
                }
            }
            else if (a.c == 3) {
                let g = a;
                switch (b) {
                    case "x1":
                        g.w = SVGParser.e(c);
                        break;
                    case "y1":
                        g.y = SVGParser.e(c);
                        break;
                    case "x2":
                        g.x = SVGParser.e(c);
                        break;
                    case "y2":
                        g.z = SVGParser.e(c);
                        break;
                }
            }
            else if (a.c == 6 || a.c == 5) {
                let h = a;
                switch (b) {
                    case "cx":
                        h.w = SVGParser.e(c);
                        break;
                    case "cy":
                        h.x = SVGParser.e(c);
                        break;
                    case "r":
                        h.y = SVGParser.e(c);
                        h.z = SVGParser.e(c);
                        break;
                    case "rx":
                        h.y = SVGParser.e(c);
                        break;
                    case "ry":
                        h.z = SVGParser.e(c);
                        break;
                }
            }
            if (a.d()) {
                let i = a;
                switch (b) {
                    case "opacity":
                        i.q = parseFloat(c);
                        break;
                    case "fill":
                        i.l = SVGParser.b(c);
                        break;
                    case "fill-opacity":
                        i.p = parseFloat(c);
                        break;
                    case "stroke":
                        i.m = SVGParser.b(c);
                        break;
                    case "stroke-linecap":
                        i.u = SVGParser.h(c);
                        break;
                    case "stroke-linejoin":
                        i.v = SVGParser.i(c);
                        break;
                    case "stroke-width":
                        i.t = SVGParser.e(c);
                        break;
                    case "stroke-miterlimit":
                        i.r = SVGParser.e(c);
                        break;
                    case "stroke-dasharray":
                        i.i = SVGParser.a(c);
                        break;
                    case "stroke-opacity":
                        i.s = parseFloat(c);
                        break;
                }
            }
        }
        static e(a) {
            return parseFloat(stringReplace(stringReplace(a, "px", ""), "%", ""));
        }
        static k(a) {
            let b = new Rect(4);
            let c = a.split(' ');
            if (c.length == 1) {
                let d = SVGParser.e(c[0]);
                b.x = d;
                b.y = d;
                b.width = d;
                b.height = d;
            }
            else if (c.length == 2) {
                b.x = SVGParser.e(c[0]);
                b.y = b.x;
                b.width = SVGParser.e(c[1]);
                b.height = b.width;
            }
            else if (c.length == 3) {
                b.x = SVGParser.e(c[0]);
                b.y = SVGParser.e(c[1]);
                b.width = SVGParser.e(c[2]);
                b.height = b.width;
            }
            else {
                b.x = SVGParser.e(c[0]);
                b.y = SVGParser.e(c[1]);
                b.width = SVGParser.e(c[2]);
                b.height = SVGParser.e(c[3]);
            }
            return b;
        }
        static j(a) {
            let b = a.split(')');
            let c = new TransformGroup();
            for (let d = 0; d < b.length; d++) {
                let e = trimStart(b[d]);
                if (stringStartsWith(e, "rotate")) {
                    let f;
                    if (stringContains(e, ",")) {
                        f = stringReplace(e, "rotate(", "").split(',');
                    }
                    else {
                        f = stringReplace(e, "rotate(", "").split(' ');
                    }
                    let g = ((() => {
                        let $ret = new RotateTransform();
                        $ret.j = parseFloat(f[0]);
                        return $ret;
                    })());
                    if (f.length > 1) {
                        g.k = parseFloat(f[1]);
                        g.l = parseFloat(f[2]);
                    }
                    c.j.insert(0, g);
                }
                else if (stringStartsWith(e, "translate")) {
                    let h;
                    if (stringContains(e, ",")) {
                        h = stringReplace(e, "translate(", "").split(',');
                    }
                    else {
                        h = stringReplace(e, "translate(", "").split(' ');
                    }
                    let i = ((() => {
                        let $ret = new TranslateTransform();
                        $ret.j = parseFloat(h[0]);
                        $ret.k = parseFloat(h[1]);
                        return $ret;
                    })());
                    c.j.insert(0, i);
                }
                else if (stringStartsWith(e, "scale")) {
                    let j;
                    if (stringContains(e, ",")) {
                        j = stringReplace(e, "scale(", "").split(',');
                    }
                    else {
                        j = stringReplace(e, "scale(", "").split(' ');
                    }
                    let k = new ScaleTransform();
                    if (j.length == 1) {
                        k.l = parseFloat(j[0]);
                        k.m = k.l;
                    }
                    else if (j.length == 2) {
                        k.l = parseFloat(j[0]);
                        k.m = parseFloat(j[1]);
                    }
                    c.j.insert(0, k);
                }
                else if (stringStartsWith(e, "matrix")) {
                    let l;
                    if (stringContains(e, ",")) {
                        l = stringReplace(e, "matrix(", "").split(',');
                    }
                    else {
                        l = stringReplace(e, "matrix(", "").split(' ');
                    }
                    let m = new MatrixTransform();
                    let n = new Matrix();
                    n.j = parseFloat(l[0]);
                    n.k = parseFloat(l[1]);
                    n.l = parseFloat(l[2]);
                    n.m = parseFloat(l[3]);
                    n.n = parseFloat(l[4]);
                    n.o = parseFloat(l[5]);
                    m.j = n;
                    c.j.insert(0, m);
                }
            }
            return c;
        }
        static b(a) {
            let b = new SVGBrush();
            if (a == "none") {
                b.b = 0;
                return b;
            }
            else if (a == "inherits") {
                b.b = 1;
                return b;
            }
            else {
                b.b = 2;
                b.e = ((() => {
                    let $ret = new Brush();
                    $ret.fill = a;
                    return $ret;
                })());
                return b;
            }
        }
        static h(a) {
            switch (a) {
                case "round": return 2;
                case "square": return 1;
                default: return 0;
            }
        }
        static i(a) {
            switch (a) {
                case "bevel": return 1;
                case "round": return 2;
                default: return 0;
            }
        }
        static a(a) {
            let b = a.split(' ');
            let c = new Array(b.length);
            for (let d = 0; d < b.length; d++) {
                c[d] = parseFloat(b[d]);
            }
            return c;
        }
    }
    SVGParser.$t = /*@__PURE__*/ markType(SVGParser, 'SVGParser');
    return SVGParser;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SVGBrushType_$type = /*@__PURE__*/ markEnum('SVGBrushType', 'None,0|Inherits,1|Specified,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SVGAttributeType_$type = /*@__PURE__*/ markEnum('SVGAttributeType', 'Fill,0|Stroke,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SVGNodeType_$type = /*@__PURE__*/ markEnum('SVGNodeType', 'Unknown,0|Root,1|Group,2|Line,3|Rect,4|Circle,5|Ellipse,6|Path,7');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IZoomSlider_$type = /*@__PURE__*/ new Type(null, 'IZoomSlider');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DOMWindowBridge = /*@__PURE__*/ (() => {
    class DOMWindowBridge extends Base {
        constructor() {
            super(...arguments);
            this.b = new List$1(Delegate_$type, 0);
            this.a = new List$1(Delegate_$type, 0);
        }
        addEventListener(a, b) {
            switch (a) {
                case 15:
                    if (this.b.count == 0) {
                        window.addEventListener("resize", runOn(this, this.d), false);
                    }
                    this.b.add(b);
                    break;
                case 9:
                    if (this.a.count == 0) {
                        window.addEventListener("pointerdown", runOn(this, this.c), false);
                    }
                    this.a.add(b);
                    break;
            }
        }
        addEventListener1(a, b, c) {
            this.addEventListener(a, b);
        }
        getHeight() {
            return (window.innerHeight);
        }
        getHeight1(a) {
            return (window.innerHeight);
        }
        getWidth() {
            return (window.innerWidth);
        }
        getWidth1(a) {
            return (window.innerWidth);
        }
        removeEventListener(a, b) {
            switch (a) {
                case 15:
                    this.b.remove(b);
                    if (this.b.count == 0) {
                        window.removeEventListener("resize", runOn(this, this.d), false);
                    }
                    break;
                case 9:
                    this.a.remove(b);
                    if (this.a.count == 0) {
                        window.removeEventListener("pointerdown", runOn(this, this.c), false);
                    }
                    break;
            }
        }
        d(a) {
            let b = new NativeUISizeChangedEventArgs();
            b.b = this.getWidth();
            b.a = this.getHeight();
            for (let c = 0; c < this.b.count; c++) {
                this.b._inner[c](b);
            }
        }
        c(a) {
            let b = new NativeUIMouseEventArgs();
            b.a = a.target;
            for (let c = 0; c < this.a.count; c++) {
                this.a._inner[c](b);
            }
        }
    }
    DOMWindowBridge.$t = /*@__PURE__*/ markType(DOMWindowBridge, 'DOMWindowBridge', Base.$, [INativeUIWindowBridge_$type]);
    return DOMWindowBridge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIElementBridge = /*@__PURE__*/ (() => {
    class NativeUIElementBridge extends Base {
        constructor() {
            super(...arguments);
            this.i = null;
            this.e = null;
            this.m = null;
            this.j = null;
            this.f = null;
            this.n = null;
            this.g = null;
            this.c = null;
            this.k = null;
            this.h = null;
            this.d = null;
            this.l = null;
            this.b = 0;
            this.a = 0;
        }
        getDesiredSize(a, b) {
            let c = (a);
            return new Size(1, c.offsetWidth, c.offsetHeight);
        }
        getBoundingRect(a) {
            let b = a.getNativeElement();
            let c = b.getBoundingClientRect();
            return new Rect(0, (c.left), (c.top), (c.width), (c.height));
        }
        contains(a, b) {
            let c = a.getNativeElement();
            return (c.contains(b));
        }
        focus(a) {
            let b = a.getNativeElement();
            b.focus();
        }
        getMethodTarget(a) {
            return a;
        }
        getTargetForProperty(a, b) {
            return b;
        }
        addHandler(a, b, c, d) {
            switch (c) {
                case 7:
                    {
                        let e = a;
                        this.i = e.listen("mouseenter", runOn(this, this.q));
                        this.e = d;
                        this.m = b;
                    }
                    break;
                case 8:
                    {
                        let f = a;
                        this.j = f.listen("mouseleave", runOn(this, this.r));
                        this.f = d;
                        this.n = b;
                    }
                    break;
                case 13:
                    {
                        let g = a;
                        this.g = g.listen("focus", runOn(this, this.o));
                        this.c = d;
                        this.k = b;
                    }
                    break;
                case 14:
                    {
                        let h = a;
                        this.h = h.listen("blur", runOn(this, this.p));
                        this.d = d;
                        this.l = b;
                    }
                    break;
            }
        }
        getHorizontalAlignment(a) {
            return this.a;
        }
        getTargetForBuildInEvent(a, b) {
            return a;
        }
        getTargetForBuildInProperty(a, b) {
            return a;
        }
        getValue(a, b) {
            return null;
        }
        getVerticalAlignment(a) {
            return this.b;
        }
        removeHandler(a, b, c, d) {
            switch (c) {
                case 7:
                    if (this.i != null) {
                        this.i();
                    }
                    this.e = null;
                    this.m = null;
                    break;
                case 8:
                    if (this.j != null) {
                        this.j();
                    }
                    this.f = null;
                    this.n = null;
                    break;
                case 13:
                    if (this.g != null) {
                        this.g();
                    }
                    this.c = null;
                    this.k = null;
                    break;
                case 14:
                    if (this.h != null) {
                        this.h();
                    }
                    this.d = null;
                    this.l = null;
                    break;
            }
        }
        setHorizontalAlignment(a, b) {
            this.a = b;
            let c = a;
            switch (b) {
                case 0:
                    c.setStyleProperty("justify-self", "start");
                    c.setStyleProperty("text-align", "left");
                    break;
                case 1:
                    c.setStyleProperty("justify-self", "center");
                    c.setStyleProperty("text-align", "center");
                    break;
                case 2:
                    c.setStyleProperty("justify-self", "end");
                    c.setStyleProperty("text-align", "right");
                    break;
                case 3:
                    c.setStyleProperty("justify-self", "stretch");
                    c.setStyleProperty("text-align", "center");
                    break;
            }
        }
        setValue(a, b, c) {
        }
        setVerticalAlignment(a, b) {
            this.b = b;
            let c = a;
            switch (b) {
                case 0:
                    c.setStyleProperty("align-self", "start");
                    c.setStyleProperty("valign", "top");
                    break;
                case 1:
                    c.setStyleProperty("align-self", "center");
                    c.setStyleProperty("valign", "center");
                    break;
                case 2:
                    c.setStyleProperty("align-self", "end");
                    c.setStyleProperty("valign", "bottom");
                    break;
                case 3:
                    c.setStyleProperty("align-self", "stretch");
                    c.setStyleProperty("valign", "center");
                    break;
            }
        }
        q(a) {
            if (this.e != null) {
                let b = new NativeUIMouseEventArgs();
                this.e(this.m, b);
            }
        }
        r(a) {
            if (this.f != null) {
                let b = new NativeUIMouseEventArgs();
                this.f(this.n, b);
            }
        }
        o(a) {
            if (this.c != null) {
                let b = new NativeUIFocusEventArgs();
                this.c(this.k, b);
            }
        }
        p(a) {
            if (this.d != null) {
                let b = new NativeUIFocusEventArgs();
                this.d(this.l, b);
            }
        }
        getHorizontalContentAlignment(a) {
            return 3;
        }
        setHorizontalContentAlignment(a, b) {
        }
        getVerticalContentAlignment(a) {
            return 3;
        }
        setVerticalContentAlignment(a, b) {
        }
        beforeSetNativeValue(a, b) {
        }
        afterSetNativeValue(a, b) {
        }
        exportVisualData(a) {
            return null;
        }
    }
    NativeUIElementBridge.$t = /*@__PURE__*/ markType(NativeUIElementBridge, 'NativeUIElementBridge', Base.$, [INativeUIElementBridge_$type]);
    return NativeUIElementBridge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PanelBridge = /*@__PURE__*/ (() => {
    class PanelBridge extends NativeUIElementBridge {
        constructor() {
            super();
            this.t = null;
            this.t = new List$1(NativeUIComponent.$, 0);
        }
        v(a, b) {
            this.t.add(b);
            a.append(b.an);
        }
        w(a, b, c) {
            this.t.insert(b, c);
            if (this.t.count - 1 >= (b + 1)) {
                this.t._inner[b + 1].an.before(c.an);
            }
            else {
                a.append(c.an);
            }
        }
        s(a, b) {
            return this.t._inner[b];
        }
        u(a) {
            return a.getChildCount();
        }
        x(a, b) {
            this.t.remove(b);
            a.removeChild(b.an);
        }
        y(a, b) {
            this.t.removeAt(b);
            a.getChildAt(b).remove();
        }
    }
    PanelBridge.$t = /*@__PURE__*/ markType(PanelBridge, 'PanelBridge', NativeUIElementBridge.$);
    return PanelBridge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridBridgeColumnDefinition = /*@__PURE__*/ (() => {
    class GridBridgeColumnDefinition extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.d = 0;
            this.b = NaN;
        }
        get c() {
            return this.b;
        }
        set c(a) {
            this.b = a;
        }
        e() {
            switch (this.a) {
                case 0: return "auto";
                case 1: return this.d + "px";
                case 2: return isNaN_(this.c) ? this.d + "fr" : "minmax(" + this.c + "px," + this.d + "fr)";
            }
            return "";
        }
    }
    GridBridgeColumnDefinition.$t = /*@__PURE__*/ markType(GridBridgeColumnDefinition, 'GridBridgeColumnDefinition');
    return GridBridgeColumnDefinition;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridBridgeRowDefinition = /*@__PURE__*/ (() => {
    class GridBridgeRowDefinition extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = 0;
        }
        c() {
            switch (this.a) {
                case 0: return "auto";
                case 1: return this.b + "px";
                case 2: return this.b + "fr";
            }
            return "";
        }
    }
    GridBridgeRowDefinition.$t = /*@__PURE__*/ markType(GridBridgeRowDefinition, 'GridBridgeRowDefinition');
    return GridBridgeRowDefinition;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridBridge = /*@__PURE__*/ (() => {
    class GridBridge extends PanelBridge {
        constructor() {
            super();
            this.aa = null;
            this.z = null;
            this.ad = null;
            this.ab = new List$1(GridBridgeColumnDefinition.$, 0);
            this.ac = new List$1(GridBridgeRowDefinition.$, 0);
        }
        addColumnDefinition(a, b, c, d) {
            let e = new GridBridgeColumnDefinition();
            e.a = c;
            e.d = d;
            this.ab.add(e);
            this.af(a);
        }
        addColumnDefinitionWithMin(a, b, c, d, e) {
            let f = new GridBridgeColumnDefinition();
            f.a = c;
            f.d = d;
            f.c = e;
            this.ab.add(f);
            this.af(a);
        }
        insertColumnDefinition(a, b, c, d) {
            let e = new GridBridgeColumnDefinition();
            e.a = c;
            e.d = d;
            this.ab.insert(b, e);
            this.af(a);
        }
        insertColumnDefinitionWithMin(a, b, c, d, e) {
            let f = new GridBridgeColumnDefinition();
            f.a = c;
            f.d = d;
            f.c = e;
            this.ab.insert(b, f);
            this.af(a);
        }
        af(a) {
            let b = "";
            for (let c = 0; c < this.ab.count; c++) {
                if (c > 0) {
                    b += " ";
                }
                b += this.ab._inner[c].e();
            }
            a.setStyleProperty("grid-template-columns", b);
        }
        ag(a) {
            let b = "";
            for (let c = 0; c < this.ac.count; c++) {
                if (c > 0) {
                    b += " ";
                }
                b += this.ac._inner[c].c();
            }
            a.setStyleProperty("grid-template-rows", b);
        }
        addHandler(a, b, c, d) {
            switch (c) {
                case 1:
                    {
                        let e = a;
                        this.aa = e.listen("click", runOn(this, this.ae));
                        this.z = d;
                        this.ad = b;
                    }
                    break;
            }
        }
        removeHandler(a, b, c, d) {
            switch (c) {
                case 1:
                    if (this.aa != null) {
                        this.aa();
                    }
                    this.z = null;
                    this.ad = null;
                    break;
            }
        }
        ae(a) {
            if (this.z != null) {
                let b = new NativeUIClickedEventArgs();
                this.z(this.ad, b);
            }
        }
        addRowDefinition(a, b, c, d) {
            let e = new GridBridgeRowDefinition();
            e.a = c;
            e.b = d;
            this.ac.add(e);
            this.ag(a);
        }
        getColumn(a, b) {
            let c = b.an.getStyleProperty("grid-column");
            let d = parseInt(c);
            return d - 1;
        }
        getColumnDefinitionsCount(a) {
            return this.ab.count;
        }
        getRow(a, b) {
            let c = b.an.getStyleProperty("grid-row");
            let d = parseInt(c);
            return d - 1;
        }
        getRowDefinitionsCount(a) {
            return this.ac.count;
        }
        getValue(a, b) {
            switch (b) {
                case 38: return enumGetBox(NativeUIBoxSizing_$type, a.getStyleProperty("box-sizing") == "border-box" ? 0 : 1);
                case 72: return enumGetBox(NativeUIPlaceContent_$type, a.getStyleProperty("place-content") == "center" ? 1 : 0);
            }
            return super.getValue(a, b);
        }
        removeColumnDefinition(a, b) {
            this.ab.removeAt(b);
            this.af(a);
        }
        removeRowDefinition(a, b) {
            this.ac.removeAt(b);
            this.ag(a);
        }
        setColumn(a, b, c) {
            b.an.setStyleProperty("grid-column", (c + 1).toString());
        }
        setRow(a, b, c) {
            b.an.setStyleProperty("grid-row", (c + 1).toString());
        }
        setValue(a, b, c) {
            super.setValue(a, b, c);
            switch (b) {
                case 38:
                    a.setStyleProperty("box-sizing", (EnumUtil.getEnumValue(NativeUIBoxSizing_$type, c)) == 0 ? "border-box" : "content-box");
                    break;
                case 72:
                    a.setStyleProperty("place-content", (EnumUtil.getEnumValue(NativeUIPlaceContent_$type, c)) == 1 ? "center" : "unset");
                    break;
            }
        }
        updateColumnDefinition(a, b, c, d) {
            let e = this.ab._inner[b];
            e.a = c;
            e.d = d;
            this.af(a);
        }
        updateRowDefinition(a, b, c, d) {
            let e = this.ac._inner[b];
            e.a = c;
            e.b = d;
            this.ag(a);
        }
        getChildAt(a, b) {
            return this.s.apply(this, arguments);
        }
        removeChildAt(a, b) {
            this.y.apply(this, arguments);
        }
        addChild(a, b) {
            this.v.apply(this, arguments);
        }
        insertChild(a, b, c) {
            this.w.apply(this, arguments);
        }
        removeChild(a, b) {
            this.x.apply(this, arguments);
        }
        getChildrenCount(a) {
            return this.u.apply(this, arguments);
        }
    }
    GridBridge.$t = /*@__PURE__*/ markType(GridBridge, 'GridBridge', PanelBridge.$, [INativeUIGridBridge_$type]);
    return GridBridge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AbsolutePanelBridge = /*@__PURE__*/ (() => {
    class AbsolutePanelBridge extends PanelBridge {
        constructor() {
            super();
        }
        addHandler(a, b, c, d) {
        }
        getX(a, b) {
            let c = b.an.getStyleProperty("left");
            stringReplace(c, "px", "");
            let d = parseFloat(c);
            return d;
        }
        getY(a, b) {
            let c = b.an.getStyleProperty("top");
            stringReplace(c, "px", "");
            let d = parseFloat(c);
            return d;
        }
        getValue(a, b) {
            switch (b) {
            }
            return super.getValue(a, b);
        }
        removeHandler(a, b, c, d) {
        }
        setX(a, b, c) {
            b.an.setStyleProperty("position", "absolute");
            b.an.setStyleProperty("left", c.toString() + "px");
        }
        setY(a, b, c) {
            b.an.setStyleProperty("position", "absolute");
            b.an.setStyleProperty("top", c.toString() + "px");
        }
        setValue(a, b, c) {
            super.setValue(a, b, c);
            switch (b) {
            }
        }
        getChildAt(a, b) {
            return this.s.apply(this, arguments);
        }
        removeChildAt(a, b) {
            this.y.apply(this, arguments);
        }
        addChild(a, b) {
            this.v.apply(this, arguments);
        }
        insertChild(a, b, c) {
            this.w.apply(this, arguments);
        }
        removeChild(a, b) {
            this.x.apply(this, arguments);
        }
        getChildrenCount(a) {
            return this.u.apply(this, arguments);
        }
    }
    AbsolutePanelBridge.$t = /*@__PURE__*/ markType(AbsolutePanelBridge, 'AbsolutePanelBridge', PanelBridge.$, [INativeUIAbsolutePanelBridge_$type]);
    return AbsolutePanelBridge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IgcCheckboxBridge = /*@__PURE__*/ (() => {
    class IgcCheckboxBridge extends NativeUIElementBridge {
        constructor() {
            super(...arguments);
            this.t = null;
            this.s = null;
            this.u = null;
        }
        addHandler(a, b, c, d) {
            switch (c) {
                case 2:
                    let e = a;
                    this.t = e.listen("igcChange", runOn(this, this.v));
                    this.s = d;
                    this.u = b;
                    break;
            }
        }
        v(a) {
            if (this.s != null) {
                let b = new NativeUICheckboxChangeEventArgs();
                this.s(this.u, b);
            }
        }
        getValue(a, b) {
            switch (b) {
                case 4: return true;
                case 7: return a.getProperty("checked");
            }
            return null;
        }
        removeHandler(a, b, c, d) {
            switch (c) {
                case 2:
                    if (this.t != null) {
                        this.t();
                    }
                    this.s = null;
                    this.u = null;
                    break;
            }
        }
        setValue(a, b, c) {
            switch (b) {
                case 4: return;
                case 7:
                    a.setProperty("checked", c);
                    return;
            }
        }
    }
    IgcCheckboxBridge.$t = /*@__PURE__*/ markType(IgcCheckboxBridge, 'IgcCheckboxBridge', NativeUIElementBridge.$);
    return IgcCheckboxBridge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IgcSliderBridge = /*@__PURE__*/ (() => {
    class IgcSliderBridge extends NativeUIElementBridge {
        constructor() {
            super(...arguments);
            this.u = null;
            this.s = null;
            this.w = null;
            this.v = null;
            this.t = null;
            this.x = null;
        }
        addHandler(a, b, c, d) {
            switch (c) {
                case 0:
                    {
                        let e = a;
                        this.v = e.listen("igcInput", runOn(this, this.z));
                        this.t = d;
                        this.x = b;
                    }
                    break;
                case 4:
                    {
                        let f = a;
                        this.u = f.listen("igcChange", runOn(this, this.y));
                        this.s = d;
                        this.w = b;
                    }
                    break;
            }
        }
        z(a) {
            if (this.t != null) {
                let b = new NativeUISliderValueChangedEventArgs();
                this.t(this.x, b);
            }
        }
        y(a) {
            if (this.s != null) {
                let b = new NativeUISliderValueChangedEventArgs();
                this.s(this.w, b);
            }
        }
        getValue(a, b) {
            switch (b) {
                case 12: return a.getProperty("min");
                case 13: return a.getProperty("max");
                case 14: return a.getProperty("step");
                case 2: return a.getProperty("value");
            }
            return null;
        }
        removeHandler(a, b, c, d) {
            switch (c) {
                case 0:
                    if (this.v != null) {
                        this.v();
                    }
                    this.t = null;
                    this.x = null;
                    break;
                case 4:
                    if (this.u != null) {
                        this.u();
                    }
                    this.s = null;
                    this.w = null;
                    break;
            }
        }
        setValue(a, b, c) {
            switch (b) {
                case 12:
                    a.setProperty("min", c);
                    break;
                case 13:
                    a.setProperty("max", c);
                    break;
                case 14:
                    a.setProperty("step", c);
                    break;
                case 2:
                    a.setProperty("value", c);
                    break;
            }
        }
    }
    IgcSliderBridge.$t = /*@__PURE__*/ markType(IgcSliderBridge, 'IgcSliderBridge', NativeUIElementBridge.$);
    return IgcSliderBridge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IgcDropdownBridge = /*@__PURE__*/ (() => {
    class IgcDropdownBridge extends NativeUIElementBridge {
        constructor(a) {
            super();
            this.t = null;
            this.s = null;
            this.v = null;
            this.w = null;
            this.u = null;
            this.x = null;
            this.u = a;
        }
        addHandler(a, b, c, d) {
            switch (c) {
                case 3:
                    let e = a;
                    this.t = e.listen("igcChange", runOn(this, this.y));
                    this.s = d;
                    this.v = b;
                    break;
            }
        }
        y(a) {
            if (this.s != null) {
                let b = new NativeUIDropDownSelectedValueChangedEventArgs();
                this.s(this.v, b);
            }
        }
        getValue(a, b) {
            switch (b) {
                case 8: return this.w;
                case 9:
                    let currItem_ = a.getProperty("selectedItem");
                    if (currItem_ == null || currItem_ == undefined) {
                        return null;
                    }
                    return currItem_.innerText;
            }
            return null;
        }
        removeHandler(a, b, c, d) {
            switch (c) {
                case 3:
                    if (this.t != null) {
                        this.t();
                    }
                    this.s = null;
                    this.v = null;
                    break;
            }
        }
        setValue(a, b, c) {
            switch (b) {
                case 8:
                    {
                        this.w = c;
                        let d = a.querySelectorAll("igc-dropdown-item");
                        if (d != null) {
                            for (let e = 0; e < d.length; e++) {
                                let f = d[e];
                                f.remove();
                            }
                        }
                        {
                            let g = this.w;
                            for (let h = 0; h < g.length; h++) {
                                let i = g[h];
                                let j = this.u.createElement("igc-dropdown-item");
                                j.setText(i);
                                a.append(j);
                            }
                        }
                        if (this.x != null) {
                            d = a.querySelectorAll("igc-dropdown-item");
                            if (d != null) {
                                for (let k = 0; k < d.length; k++) {
                                    let l = d[k];
                                    let m = l.getText();
                                    if (m == this.x) {
                                        let targ_ = a.getNativeElement();
                                        if (targ_ != null && (targ_._selectItem)) {
                                            let currItem_ = l.getNativeElement();
                                            targ_._selectItem(currItem_);
                                        }
                                        else {
                                            a.setProperty("selectedItem", l.getNativeElement());
                                        }
                                    }
                                }
                            }
                        }
                    }
                    return;
                case 9:
                    {
                        this.x = c;
                        let n = a.querySelectorAll("igc-dropdown-item");
                        if (n != null) {
                            for (let o = 0; o < n.length; o++) {
                                let p = n[o];
                                let q = p.getText();
                                if (q == this.x) {
                                    let targ_ = a.getNativeElement();
                                    if (targ_ != null && (targ_._selectItem)) {
                                        let currItem_ = p.getNativeElement();
                                        targ_._selectItem(currItem_);
                                    }
                                    else {
                                        a.setProperty("selectedItem", p.getNativeElement());
                                    }
                                }
                            }
                        }
                    }
                    return;
                case 1:
                    let r = "large";
                    switch (EnumUtil.getEnumValue(NativeUIDisplayDensity_$type, c)) {
                        case 0:
                            r = "large";
                            break;
                        case 1:
                            r = "large";
                            break;
                        case 2:
                            r = "small";
                            break;
                        case 3:
                            r = "medium";
                            break;
                    }
                    a.setProperty("size", r);
                    let s = a.querySelectorAll("igc-input");
                    if (s != null) {
                        for (let t = 0; t < s.length; t++) {
                            s[t].setProperty("size", r);
                        }
                    }
                    break;
            }
        }
    }
    IgcDropdownBridge.$t = /*@__PURE__*/ markType(IgcDropdownBridge, 'IgcDropdownBridge', NativeUIElementBridge.$);
    return IgcDropdownBridge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SpanBridge = /*@__PURE__*/ (() => {
    class SpanBridge extends NativeUIElementBridge {
        addHandler(a, b, c, d) {
        }
        getValue(a, b) {
            switch (b) {
                case 10: return a.getText();
                case 31: return a.getStyleProperty("white-space") != "nowrap";
            }
            return super.getValue(a, b);
        }
        removeHandler(a, b, c, d) {
        }
        setValue(a, b, c) {
            super.setValue(a, b, c);
            switch (b) {
                case 10:
                    a.setText(c);
                    break;
                case 11:
                    a.setStyleProperty("font", c.fontString);
                    break;
                case 31:
                    a.setStyleProperty("white-space", c ? "normal" : "nowrap");
                    break;
            }
        }
    }
    SpanBridge.$t = /*@__PURE__*/ markType(SpanBridge, 'SpanBridge', NativeUIElementBridge.$);
    return SpanBridge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IgcInputBridge = /*@__PURE__*/ (() => {
    class IgcInputBridge extends NativeUIElementBridge {
        constructor() {
            super(...arguments);
            this.t = null;
            this.s = null;
            this.u = null;
        }
        addHandler(a, b, c, d) {
            switch (c) {
                case 0:
                    let e = a;
                    this.t = e.listen("igcInput", runOn(this, this.v));
                    this.s = d;
                    this.u = b;
                    break;
            }
        }
        v(a) {
            if (this.s != null) {
                let b = new NativeUIInputChangingEventArgs();
                this.s(this.u, b);
            }
        }
        getValue(a, b) {
            switch (b) {
                case 2: return a.getProperty("value");
                case 1:
                    let c = a.getProperty("size");
                    let d = 1;
                    switch (c) {
                        case "small":
                            d = 2;
                            break;
                        case "medium":
                            d = 3;
                            break;
                        case "large":
                            d = 1;
                            break;
                        default:
                            d = 1;
                            break;
                    }
                    return enumGetBox(NativeUIDisplayDensity_$type, d);
            }
            return null;
        }
        removeHandler(a, b, c, d) {
            switch (c) {
                case 1:
                    if (this.t != null) {
                        this.t();
                    }
                    this.s = null;
                    this.u = null;
                    break;
            }
        }
        setValue(a, b, c) {
            switch (b) {
                case 3:
                    a.setProperty("value", c);
                    break;
                case 1:
                    let d = "large";
                    switch (EnumUtil.getEnumValue(NativeUIDisplayDensity_$type, c)) {
                        case 0:
                            d = "large";
                            break;
                        case 1:
                            d = "large";
                            break;
                        case 2:
                            d = "small";
                            break;
                        case 3:
                            d = "medium";
                            break;
                    }
                    a.setProperty("size", d);
                    break;
            }
        }
        select(a) {
        }
        setSelectionRange(a, b, c) {
        }
    }
    IgcInputBridge.$t = /*@__PURE__*/ markType(IgcInputBridge, 'IgcInputBridge', NativeUIElementBridge.$, [INativeUIInputBridge_$type]);
    return IgcInputBridge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IgcButtonBridge = /*@__PURE__*/ (() => {
    class IgcButtonBridge extends NativeUIElementBridge {
        constructor() {
            super(...arguments);
            this.u = null;
            this.s = null;
            this.v = null;
            this.w = null;
            this.t = null;
        }
        addHandler(a, b, c, d) {
            switch (c) {
                case 1:
                    let e = a;
                    this.u = e.listen("click", runOn(this, this.x));
                    this.s = d;
                    this.v = b;
                    break;
            }
        }
        x(a) {
            if (this.s != null) {
                let b = new NativeUIButtonClickedEventArgs();
                this.s(this.v, b);
            }
        }
        getValue(a, b) {
            switch (b) {
                case 3: return this.t != null ? this.t : this.w;
                case 1:
                    let c = a.getProperty("size");
                    let d = 1;
                    switch (c) {
                        case "small":
                            d = 2;
                            break;
                        case "medium":
                            d = 3;
                            break;
                        case "large":
                            d = 1;
                            break;
                        default:
                            d = 1;
                            break;
                    }
                    return enumGetBox(NativeUIDisplayDensity_$type, d);
            }
            return null;
        }
        removeHandler(a, b, c, d) {
            switch (c) {
                case 1:
                    if (this.u != null) {
                        this.u();
                    }
                    this.s = null;
                    this.v = null;
                    break;
            }
        }
        setValue(a, b, c) {
            switch (b) {
                case 3:
                    if (typeCast(NativeUIComponent.$, c) !== null) {
                        this.t = c;
                        a.append(this.t.an);
                    }
                    else {
                        this.w = c == null ? null : c.toString();
                        a.setText(this.w);
                    }
                    break;
                case 1:
                    let d = "large";
                    switch (EnumUtil.getEnumValue(NativeUIDisplayDensity_$type, c)) {
                        case 0:
                            d = "large";
                            break;
                        case 1:
                            d = "large";
                            break;
                        case 2:
                            d = "small";
                            break;
                        case 3:
                            d = "medium";
                            break;
                    }
                    a.setProperty("size", d);
                    break;
            }
        }
    }
    IgcButtonBridge.$t = /*@__PURE__*/ markType(IgcButtonBridge, 'IgcButtonBridge', NativeUIElementBridge.$);
    return IgcButtonBridge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IgcIconButtonBridge = /*@__PURE__*/ (() => {
    class IgcIconButtonBridge extends IgcButtonBridge {
        constructor() {
            super(...arguments);
            this.z = null;
            this.y = "default";
            this.aa = "<svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><path d=\"@@Inject\"/></svg>";
        }
        getValue(a, b) {
            switch (b) {
                case 16: return this.z;
                case 15: return this.y;
            }
            return super.getValue(a, b);
        }
        setValue(a, b, c) {
            let nativeEle_ = a.getNativeElement();
            switch (b) {
                case 16:
                    this.z = c;
                    if (this.z != null && this.y != null) {
                        if (SvgIconRegistry.instance.getSvgPathString(this.y, this.z) != null) {
                            let svg_ = stringReplace(this.aa, "@@Inject", (SvgIconRegistry.instance.getSvgPathString(this.y, this.z)));
                            let iconName_ = this.z;
                            let iconCollection_ = this.y;
                            nativeEle_.registerIconFromText(iconName_, svg_, iconCollection_);
                            a.setProperty("name", this.z);
                            a.setProperty("collection", this.y);
                        }
                        else {
                            a.setProperty("name", this.z);
                            a.setProperty("collection", this.y);
                        }
                    }
                    return;
                case 15:
                    this.y = c;
                    if (this.z != null && this.y != null) {
                        if (SvgIconRegistry.instance.getSvgPathString(this.y, this.z) != null) {
                            let svg_ = stringReplace(this.aa, "@@Inject", (SvgIconRegistry.instance.getSvgPathString(this.y, this.z)));
                            let iconName_ = this.z;
                            let iconCollection_ = this.y;
                            nativeEle_.registerIconFromText(iconName_, svg_, iconCollection_);
                            a.setProperty("name", this.z);
                            a.setProperty("collection", this.y);
                        }
                        else {
                            a.setProperty("name", this.z);
                            a.setProperty("collection", this.y);
                        }
                    }
                    return;
                case 1:
                    switch (EnumUtil.getEnumValue(NativeUIDisplayDensity_$type, c)) {
                        case 1:
                            nativeEle_.size = "large";
                            break;
                        case 3:
                            nativeEle_.size = "medium";
                            break;
                        case 2:
                            nativeEle_.size = "small";
                            break;
                    }
                    break;
            }
        }
    }
    IgcIconButtonBridge.$t = /*@__PURE__*/ markType(IgcIconButtonBridge, 'IgcIconButtonBridge', IgcButtonBridge.$);
    return IgcIconButtonBridge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DivBridge = /*@__PURE__*/ (() => {
    class DivBridge extends NativeUIElementBridge {
        constructor() {
            super(...arguments);
            this.s = null;
        }
        getContent(a) {
            return this.s;
        }
        getValue(a, b) {
            return null;
        }
        setContent(a, b) {
            if (this.s == b) {
                return;
            }
            this.s = b;
            if (b == null) {
                for (let c = a.getChildCount() - 1; c >= 0; c--) {
                    let d = a.getChildAt(c);
                    d.remove();
                }
            }
            else {
                for (let e = a.getChildCount() - 1; e >= 0; e--) {
                    let f = a.getChildAt(e);
                    f.remove();
                }
                a.append(b.an);
            }
        }
        setValue(a, b, c) {
        }
    }
    DivBridge.$t = /*@__PURE__*/ markType(DivBridge, 'DivBridge', NativeUIElementBridge.$, [INativeUIContentBridge_$type]);
    return DivBridge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUIInputsFactory = /*@__PURE__*/ (() => {
    class NativeUIInputsFactory extends Base {
        constructor() {
            super(...arguments);
            this.c = 0;
        }
        static get b() {
            if (NativeUIInputsFactory.a == null) {
                NativeUIInputsFactory.a = new NativeUIInputsFactory();
                NativeUIWindow.b = new DOMWindowBridge();
            }
            return NativeUIInputsFactory.a;
        }
        static n() {
            NativeUIComponent.ar(NativeUIInputsFactory.b);
        }
        static o(a) {
            NativeUIInputsFactory.b.c = a;
            NativeUIComponent.ar(NativeUIInputsFactory.b);
        }
        get flavor() {
            return this.c;
        }
        supportsComponent(a) {
            switch (a) {
                case 0: return true;
                case 1: return true;
                case 2: return true;
                case 3: return true;
                case 4: return true;
                case 5: return true;
                case 6: return true;
                case 7: return true;
                case 8: return false;
                case 9: return true;
                case 10: return true;
            }
            return false;
        }
        createComponentSync(a, b, c) {
            this.createComponent(a, b, c);
        }
        createComponent(a, b, c) {
            switch (b) {
                case 0:
                    this.g(a, c);
                    break;
                case 1:
                    this.e(a, c);
                    break;
                case 2:
                    this.k(a, c);
                    break;
                case 3:
                    this.l(a, c);
                    break;
                case 4:
                    this.h(a, c);
                    break;
                case 5:
                    this.m(a, c);
                    break;
                case 6:
                    this.f(a, c);
                    break;
                case 7:
                    this.i(a, c);
                    break;
                case 9:
                    this.d(a, c);
                    break;
                case 10:
                    this.j(a, c);
                    break;
                case 8: break;
            }
        }
        i(a, b) {
            let c = a;
            let d = c.createElement("div");
            d.setStyleProperty("display", "grid");
            d.setStyleProperty("border-style", "solid");
            d.setStyleProperty("border-width", "0px");
            let e = new GridBridge();
            let f = new NativeUIGrid();
            f.an = d;
            f.d = e;
            b(f);
        }
        d(a, b) {
            let c = a;
            let d = c.createElement("div");
            let e = new AbsolutePanelBridge();
            let f = new NativeUIAbsolutePanel();
            f.an = d;
            f.d = e;
            b(f);
        }
        f(a, b) {
            let c = a;
            let d = c.createElement("igc-checkbox");
            let e = new IgcCheckboxBridge();
            let f = new NativeUICheckbox();
            f.an = d;
            f.d = e;
            b(f);
        }
        m(a, b) {
            let c = a;
            let d = c.createElement("igc-slider");
            d.setProperty("hideTooltip", true);
            let e = new IgcSliderBridge();
            let f = new NativeUISlider();
            f.an = d;
            f.d = e;
            b(f);
        }
        h(a, b) {
            let c = a;
            let d = c.createElement("igc-dropdown");
            let e = c.createElement("igc-input");
            e.setAttribute("slot", "target");
            d.listen("igcChange", (ev_) => {
                let f = ev_.originalEvent.detail.value;
                e.setProperty("value", f);
            });
            d.append(e);
            let f = new IgcDropdownBridge(c);
            let g = new NativeUIDropDown();
            g.an = d;
            g.d = f;
            b(g);
        }
        l(a, b) {
            let c = a;
            let d = c.createElement("span");
            let e = new SpanBridge();
            let f = new NativeUILabel();
            f.an = d;
            f.d = e;
            b(f);
        }
        k(a, b) {
            let c = a;
            let d = c.createElement("igc-input");
            let e = new IgcInputBridge();
            let f = new NativeUIInput();
            f.an = d;
            f.d = e;
            b(f);
        }
        e(a, b) {
            let c = a;
            let d = c.createElement("igc-button");
            let e = new IgcButtonBridge();
            let f = new NativeUIButton();
            f.an = d;
            f.d = e;
            b(f);
        }
        j(a, b) {
            let c = a;
            let d = c.createElement("igc-icon-button");
            let e = new IgcIconButtonBridge();
            let f = new NativeUIIconButton();
            f.an = d;
            f.d = e;
            b(f);
        }
        g(a, b) {
            let c = a;
            let d = c.createElement("div");
            d.setStyleProperty("display", "grid");
            let e = new DivBridge();
            let f = new NativeUIContent();
            f.an = d;
            f.d = e;
            b(f);
        }
    }
    NativeUIInputsFactory.$t = /*@__PURE__*/ markType(NativeUIInputsFactory, 'NativeUIInputsFactory', Base.$, [INativeUIElementFactory_$type]);
    NativeUIInputsFactory.a = null;
    return NativeUIInputsFactory;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IIcon_$type = /*@__PURE__*/ new Type(null, 'IIcon');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataTemplateMeasureInfo = /*@__PURE__*/ (() => {
    class DataTemplateMeasureInfo extends Base {
        constructor() {
            super(...arguments);
            this.renderContext = null;
            this.context = null;
            this.width = 0;
            this.height = 0;
            this.isConstant = false;
            this.data = null;
            this.passInfo = null;
            this.renderOffsetX = 0;
            this.renderOffsetY = 0;
        }
    }
    DataTemplateMeasureInfo.$t = /*@__PURE__*/ markType(DataTemplateMeasureInfo, 'DataTemplateMeasureInfo');
    return DataTemplateMeasureInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataTemplateRenderInfo = /*@__PURE__*/ (() => {
    class DataTemplateRenderInfo extends Base {
        constructor() {
            super(...arguments);
            this.renderContext = null;
            this.context = null;
            this.xPosition = 0;
            this.yPosition = 0;
            this.availableWidth = 0;
            this.availableHeight = 0;
            this.data = null;
            this.isHitTestRender = false;
            this.passInfo = null;
            this.renderOffsetX = 0;
            this.renderOffsetY = 0;
        }
    }
    DataTemplateRenderInfo.$t = /*@__PURE__*/ markType(DataTemplateRenderInfo, 'DataTemplateRenderInfo');
    return DataTemplateRenderInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendItemHelper = /*@__PURE__*/ (() => {
    class LegendItemHelper extends Base {
        static get b() {
            if (isNaN_(LegendItemHelper.a)) {
                LegendItemHelper.a = window.devicePixelRatio == undefined ? 1 : window.devicePixelRatio;
            }
            return LegendItemHelper.a;
        }
        static set b(a) {
            LegendItemHelper.a = a;
        }
        static c(a, b, c, d, e, f, g, h, i) {
            LegendItemHelper.d(a, b, c, d, e, f, g, h, i, false);
        }
        static d(a, b, c, d, e, f, g, h, i, j, ...k) {
            let l = a;
            let m = f;
            if (m != null && m.series != null) {
                if (h != null) {
                    let n = 18, o = 16;
                    let p = l.createElement("canvas");
                    if (j) {
                        p.setStyleProperty("vertical-align", "middle");
                    }
                    p.setAttribute("width", (n * LegendItemHelper.b).toString());
                    p.setAttribute("height", (o * LegendItemHelper.b).toString());
                    p.setStyleProperty("width", n.toString() + "px");
                    p.setStyleProperty("height", o.toString() + "px");
                    let q = j ? l.createElement("span") : l.createElement("td");
                    q.addClass("ui-legend-item-badge");
                    q.append(p);
                    let r = l.get2DCanvasContext(p);
                    let s = new DataTemplateMeasureInfo();
                    s.passInfo = i;
                    s.context = r;
                    s.width = n;
                    s.height = o;
                    s.data = m;
                    h.measure(s);
                    let t = new DataTemplateRenderInfo();
                    t.availableWidth = (isNaN_(s.width) ? n : Math.min(s.width, n));
                    t.availableHeight = (isNaN_(s.height) ? o : Math.min(s.height, o));
                    t.passInfo = i;
                    t.context = r;
                    t.data = m;
                    t.xPosition = 0;
                    t.yPosition = 0;
                    if (LegendItemHelper.b != 1) {
                        r.save();
                        r.scale(LegendItemHelper.b, LegendItemHelper.b);
                    }
                    h.render(t);
                    if (LegendItemHelper.b != 1) {
                        r.restore();
                    }
                    l.append(q);
                }
                if (j) {
                    let u = l.createElement("label");
                    u.addClass("ui-legend-item-text");
                    u.setText(g);
                    l.append(u);
                    let v = k[0];
                    let w = k[1];
                    let x = stringEndsWith(getInstanceType(m.series).typeName, "Overlay");
                    if (!isNaN_(v) && !x) {
                        u.setText(u.getText() + ": ");
                        let y = l.createElement("label");
                        y.setStyleProperty("font-weight", "bold");
                        y.setText(numberToString2(v, "0.00") + (isNaN_(w) ? "" : " "));
                        l.append(y);
                    }
                    if (!isNaN_(w) && !x) {
                        let z = l.createElement("label");
                        z.setText("(" + numberToString2(w, "0.00") + "%)");
                        l.append(z);
                    }
                }
                else {
                    let aa = l.createElement("td");
                    let ab = l.createElement("span");
                    ab.setText(g);
                    ab.setStyleProperty("vertical-align", "middle");
                    aa.append(ab);
                    aa.addClass("ui-legend-item-text");
                    l.append(aa);
                }
            }
        }
    }
    LegendItemHelper.$t = /*@__PURE__*/ markType(LegendItemHelper, 'LegendItemHelper');
    LegendItemHelper.a = NaN;
    return LegendItemHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes the label mode for highlighted series.
 */
var HighlightedValueLabelMode = /*@__PURE__*/ (function (HighlightedValueLabelMode) {
    HighlightedValueLabelMode[HighlightedValueLabelMode["Auto"] = 0] = "Auto";
    HighlightedValueLabelMode[HighlightedValueLabelMode["PreferOriginal"] = 1] = "PreferOriginal";
    HighlightedValueLabelMode[HighlightedValueLabelMode["PreferHighlighted"] = 2] = "PreferHighlighted";
    HighlightedValueLabelMode[HighlightedValueLabelMode["LabelBoth"] = 3] = "LabelBoth";
    return HighlightedValueLabelMode;
})({});
/**
 * @hidden
 */
let HighlightedValueLabelMode_$type = /*@__PURE__*/ markEnum('HighlightedValueLabelMode', 'Auto,0|PreferOriginal,1|PreferHighlighted,2|LabelBoth,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes mode of legend badges that represent all series in a legend
 */
var LegendItemBadgeMode = /*@__PURE__*/ (function (LegendItemBadgeMode) {
    /**
     * Specifies legend badges with simplified visuals of series, e.g. with fixed thickness, no overlaid markers
     */
    LegendItemBadgeMode[LegendItemBadgeMode["Simplified"] = 0] = "Simplified";
    /**
     * Specifies legend badges that match all visuals of series such as thickness and markers (if supported by a series)
     */
    LegendItemBadgeMode[LegendItemBadgeMode["MatchSeries"] = 1] = "MatchSeries";
    return LegendItemBadgeMode;
})({});
/**
 * @hidden
 */
let LegendItemBadgeMode_$type = /*@__PURE__*/ markEnum('LegendItemBadgeMode', 'Simplified,0|MatchSeries,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes the type of legend badge that represents a series in a legend
 */
var LegendItemBadgeShape = /*@__PURE__*/ (function (LegendItemBadgeShape) {
    /**
     * Specifies automatic badge with best match of series type, e.g. Square badge for Area Series, Line badge for Line Series etc.
     */
    LegendItemBadgeShape[LegendItemBadgeShape["Automatic"] = 0] = "Automatic";
    /**
     * Specifies a circle badge in a legend
     */
    LegendItemBadgeShape[LegendItemBadgeShape["Circle"] = 1] = "Circle";
    /**
     * Specifies a thin line badge in a legend
     */
    LegendItemBadgeShape[LegendItemBadgeShape["Line"] = 2] = "Line";
    /**
     * Specifies a square badge in a legend
     */
    LegendItemBadgeShape[LegendItemBadgeShape["Square"] = 3] = "Square";
    /**
     * Specifies a marker badge in a legend (if series supports markers otherwise a circle badge)
     */
    LegendItemBadgeShape[LegendItemBadgeShape["Marker"] = 4] = "Marker";
    /**
     * Specifies a thick horizontal bar in a legend
     */
    LegendItemBadgeShape[LegendItemBadgeShape["Bar"] = 5] = "Bar";
    /**
     * Specifies a thick vertical column in a legend
     */
    LegendItemBadgeShape[LegendItemBadgeShape["Column"] = 6] = "Column";
    /**
     * Specifies hidden badge in a legend, next to the series title
     */
    LegendItemBadgeShape[LegendItemBadgeShape["Hidden"] = 7] = "Hidden";
    return LegendItemBadgeShape;
})({});
/**
 * @hidden
 */
let LegendItemBadgeShape_$type = /*@__PURE__*/ markEnum('LegendItemBadgeShape', 'Automatic,0|Circle,1|Line,2|Square,3|Marker,4|Bar,5|Column,6|Hidden,7');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available collision modes of callout layers.
 */
var CalloutCollisionMode = /*@__PURE__*/ (function (CalloutCollisionMode) {
    /**
     * Automatically decide the collision strategy.
     */
    CalloutCollisionMode[CalloutCollisionMode["Auto"] = 0] = "Auto";
    /**
     * Use a simulated annealing based collision strategy. This is higher quality, but takes longer, and is performed time-sliced in the background until an acceptable quality is reached.
     */
    CalloutCollisionMode[CalloutCollisionMode["SimulatedAnnealing"] = 1] = "SimulatedAnnealing";
    /**
     * Use a greedy algorithm to avoid collisions. This is cheap and predictable, but of comparatively low quality.
     */
    CalloutCollisionMode[CalloutCollisionMode["Greedy"] = 2] = "Greedy";
    /**
     * Use a greedy algorithm with localized center of mass hints to avoid collisions. This is relatively cheap to perform, compared to the simulated annealing approach, but is of comparatively lower quality.
     */
    CalloutCollisionMode[CalloutCollisionMode["GreedyCenterOfMass"] = 3] = "GreedyCenterOfMass";
    /**
     * If slice anchors are present, either fit the labels inside the slices or outside, depending on collisions.
     */
    CalloutCollisionMode[CalloutCollisionMode["RadialBestFit"] = 4] = "RadialBestFit";
    /**
     * If slice anchors are present, either fit the labels inside the slices or outside, depending on collisions.
     */
    CalloutCollisionMode[CalloutCollisionMode["RadialInsideEnd"] = 5] = "RadialInsideEnd";
    /**
     * If slice anchors are present, either fit the labels inside the slices or outside, depending on collisions.
     */
    CalloutCollisionMode[CalloutCollisionMode["RadialOutsideEnd"] = 6] = "RadialOutsideEnd";
    /**
     * If slice anchors are present, fit the labels inside the slices.
     */
    CalloutCollisionMode[CalloutCollisionMode["RadialCenter"] = 7] = "RadialCenter";
    return CalloutCollisionMode;
})({});
/**
 * @hidden
 */
let CalloutCollisionMode_$type = /*@__PURE__*/ markEnum('CalloutCollisionMode', 'Auto,0|SimulatedAnnealing,1|Greedy,2|GreedyCenterOfMass,3|RadialBestFit,4|RadialInsideEnd,5|RadialOutsideEnd,6|RadialCenter,7');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for calculating and grouping slices into the Others slice.
 */
var OthersCategoryType = /*@__PURE__*/ (function (OthersCategoryType) {
    /**
     * Data value is compared directly to the value of OthersCategoryThreshold.
     */
    OthersCategoryType[OthersCategoryType["Number"] = 0] = "Number";
    /**
     * Data value is compared to OthersCategoryThreshold as a percentage of the total.
     */
    OthersCategoryType[OthersCategoryType["Percent"] = 1] = "Percent";
    return OthersCategoryType;
})({});
/**
 * @hidden
 */
let OthersCategoryType_$type = /*@__PURE__*/ markEnum('OthersCategoryType', 'Number,0|Percent,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available radial label modes.
 */
var RadialLabelMode = /*@__PURE__*/ (function (RadialLabelMode) {
    /**
     * Labelling mode is determined automatically.
     */
    RadialLabelMode[RadialLabelMode["Auto"] = 0] = "Auto";
    /**
     * Labelling mode is defined by the settings of the callout layer.
     */
    RadialLabelMode[RadialLabelMode["Normal"] = 1] = "Normal";
    /**
     * The value of the item is displayed.
     */
    RadialLabelMode[RadialLabelMode["Value"] = 2] = "Value";
    /**
     * The percentage of the whole is displayed, if using a proportional axis, otherwise the value is used as a fallback.
     */
    RadialLabelMode[RadialLabelMode["Percentage"] = 3] = "Percentage";
    /**
     * The value and the percentage are displayed, if using a proportional axis, otherwise the value is used as a fallback.
     */
    RadialLabelMode[RadialLabelMode["ValueAndPercentage"] = 4] = "ValueAndPercentage";
    /**
     * The label of the category is used as a label.
     */
    RadialLabelMode[RadialLabelMode["Label"] = 5] = "Label";
    /**
     * The label of the category and the value are used as the label.
     */
    RadialLabelMode[RadialLabelMode["LabelAndValue"] = 6] = "LabelAndValue";
    /**
     * The label of the category and the percentage are used as the label, if using a proportional axis, otherwise the label and value is used as a fallback.
     */
    RadialLabelMode[RadialLabelMode["LabelAndPercentage"] = 7] = "LabelAndPercentage";
    /**
     * The label of the category and the value and the percentage are used as the label, if using a proportional axis, otherwise the label and value is used as a fallback.
     */
    RadialLabelMode[RadialLabelMode["LabelAndValueAndPercentage"] = 8] = "LabelAndValueAndPercentage";
    return RadialLabelMode;
})({});
/**
 * @hidden
 */
let RadialLabelMode_$type = /*@__PURE__*/ markEnum('RadialLabelMode', 'Auto,0|Normal,1|Value,2|Percentage,3|ValueAndPercentage,4|Label,5|LabelAndValue,6|LabelAndPercentage,7|LabelAndValueAndPercentage,8');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TrendCalculators = /*@__PURE__*/ (() => {
    class TrendCalculators extends Base {
        static *_g(a, b) {
            let c = new Array(b);
            let d = 0;
            for (d = 0; d < b; d++) {
                c[d] = 0;
            }
            let e = NaN;
            let f = NaN;
            let g = NaN;
            let h = NaN;
            d = 0;
            for (let i of fromEnum(a)) {
                if (!isNaN_(i)) {
                    let j = d % b;
                    if (d == 0) {
                        g = 1;
                        h = i;
                        f = i;
                        e = i;
                    }
                    else if (d < b) {
                        g += (d + 1);
                        e += i;
                        f += (d + 1) * i;
                        h = f / g;
                    }
                    else {
                        f = f + (b * i) - e;
                        h = f / g;
                        e = e + i - c[j];
                    }
                    c[j] = i;
                    ++d;
                }
                yield h;
            }
        }
        static g(a, b) {
            return toEnum(() => TrendCalculators._g(a, b));
        }
        static *_b(a, b) {
            let c = 0;
            let d = NaN;
            let e = 2 / (1 + b);
            for (let f of fromEnum(a)) {
                if (!isNaN_(f)) {
                    if (c < b) {
                        d = isNaN_(d) ? f : (d * c + f) / (c + 1);
                    }
                    else {
                        d = (f - d) * e + d;
                    }
                    ++c;
                }
                yield d;
            }
        }
        static b(a, b) {
            return toEnum(() => TrendCalculators._b(a, b));
        }
        static *_c(a, b) {
            let c = 0;
            let d = NaN;
            let e = 1 / b;
            for (let f of fromEnum(a)) {
                if (!isNaN_(f)) {
                    if (c < b) {
                        d = isNaN_(d) ? f : (d * c + f) / (c + 1);
                    }
                    else {
                        d = (f - d) * e + d;
                    }
                    ++c;
                }
                yield d;
            }
        }
        static c(a, b) {
            return toEnum(() => TrendCalculators._c(a, b));
        }
        static *_a(a) {
            let b = NaN;
            let c = 0;
            for (let d of fromEnum(a)) {
                if (!isNaN_(d)) {
                    b = isNaN_(b) ? d : (b * c + d) / (c + 1);
                    ++c;
                }
                yield b;
            }
        }
        static a(a) {
            return toEnum(() => TrendCalculators._a(a));
        }
        static *_e(a, b) {
            let c = new Array(b);
            let d = 0;
            for (d = 0; d < b; d++) {
                c[d] = 0;
            }
            d = 0;
            let e = NaN;
            for (let f of fromEnum(a)) {
                if (!isNaN_(f)) {
                    let g = f / b;
                    let h = d % b;
                    if (d < b) {
                        e = isNaN_(e) ? f : (e * d + f) / (d + 1);
                    }
                    else {
                        e = e + g - c[h];
                    }
                    c[h] = g;
                    ++d;
                }
                yield e;
            }
        }
        static e(a, b) {
            return toEnum(() => TrendCalculators._e(a, b));
        }
        static *_d(a, b) {
            let c = new Array(b);
            let d = 0;
            for (d = 0; d < b; d++) {
                c[d] = 0;
            }
            d = 0;
            let e = NaN;
            for (let f of fromEnum(a)) {
                if (!isNaN_(f)) {
                    let g = f;
                    let h = d % b;
                    if (d < b) {
                        e = isNaN_(e) ? g : e + g;
                    }
                    else {
                        e = e + g - c[h];
                    }
                    c[h] = g;
                    ++d;
                }
                yield e;
            }
        }
        static d(a, b) {
            return toEnum(() => TrendCalculators._d(a, b));
        }
        static *_f(a, b) {
            let c = getEnumerator(TrendCalculators.e(a, b));
            let d = getEnumerator(a);
            let e = new Array(b);
            let f = 0;
            for (f = 0; f < b; f++) {
                e[f] = 0;
            }
            f = 0;
            while (d.moveNext() && c.moveNext()) {
                e[(f++) % b] = d.current;
                let g = 0;
                if (f < b) {
                    let h = 0;
                    for (let i = 0; i < f; i++) {
                        let j = (c.current - e[i]);
                        g += j * j;
                        h++;
                    }
                    yield Math.sqrt(g / h);
                }
                else {
                    for (let k = 0; k < b; ++k) {
                        let l = (c.current - e[k]);
                        g += l * l;
                    }
                    yield Math.sqrt(g / b);
                }
            }
        }
        static f(a, b) {
            return toEnum(() => TrendCalculators._f(a, b));
        }
    }
    TrendCalculators.$t = /*@__PURE__*/ markType(TrendCalculators, 'TrendCalculators');
    return TrendCalculators;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of trend lines supported by series.
 */
var TrendLineType = /*@__PURE__*/ (function (TrendLineType) {
    /**
     * No trend line will be displayed.
     */
    TrendLineType[TrendLineType["None"] = 0] = "None";
    /**
     * Linear fit.
     */
    TrendLineType[TrendLineType["LinearFit"] = 1] = "LinearFit";
    /**
     * Quadratic polynomial fit.
     */
    TrendLineType[TrendLineType["QuadraticFit"] = 2] = "QuadraticFit";
    /**
     * Cubic polynomial fit.
     */
    TrendLineType[TrendLineType["CubicFit"] = 3] = "CubicFit";
    /**
     * Quartic polynomial fit.
     */
    TrendLineType[TrendLineType["QuarticFit"] = 4] = "QuarticFit";
    /**
     * Quintic polynomial fit.
     */
    TrendLineType[TrendLineType["QuinticFit"] = 5] = "QuinticFit";
    /**
     * Logarithmic fit.
     */
    TrendLineType[TrendLineType["LogarithmicFit"] = 6] = "LogarithmicFit";
    /**
     * Exponential fit.
     */
    TrendLineType[TrendLineType["ExponentialFit"] = 7] = "ExponentialFit";
    /**
     * Powerlaw fit.
     */
    TrendLineType[TrendLineType["PowerLawFit"] = 8] = "PowerLawFit";
    /**
     * Simple moving average.
     */
    TrendLineType[TrendLineType["SimpleAverage"] = 9] = "SimpleAverage";
    /**
     * Exponential moving average.
     */
    TrendLineType[TrendLineType["ExponentialAverage"] = 10] = "ExponentialAverage";
    /**
     * Modified moving average.
     */
    TrendLineType[TrendLineType["ModifiedAverage"] = 11] = "ModifiedAverage";
    /**
     * Cumulative moving average.
     */
    TrendLineType[TrendLineType["CumulativeAverage"] = 12] = "CumulativeAverage";
    /**
     * Weighted moving average.
     */
    TrendLineType[TrendLineType["WeightedAverage"] = 13] = "WeightedAverage";
    return TrendLineType;
})({});
/**
 * @hidden
 */
let TrendLineType_$type = /*@__PURE__*/ markEnum('TrendLineType', 'None,0|LinearFit,1|QuadraticFit,2|CubicFit,3|QuarticFit,4|QuinticFit,5|LogarithmicFit,6|ExponentialFit,7|PowerLawFit,8|SimpleAverage,9|ExponentialAverage,10|ModifiedAverage,11|CumulativeAverage,12|WeightedAverage,13');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available methods of plotting data with unknown values in a series.
 * <para>Double.NaN and null are examples of unknown values.</para>
 */
var UnknownValuePlotting = /*@__PURE__*/ (function (UnknownValuePlotting) {
    /**
     * Plot the unknown value as the midpoint between surrounding known values using linear interpolation.
     */
    UnknownValuePlotting[UnknownValuePlotting["LinearInterpolate"] = 0] = "LinearInterpolate";
    /**
     * Do not plot the unknown value on the chart.
     */
    UnknownValuePlotting[UnknownValuePlotting["DontPlot"] = 1] = "DontPlot";
    return UnknownValuePlotting;
})({});
/**
 * @hidden
 */
let UnknownValuePlotting_$type = /*@__PURE__*/ markEnum('UnknownValuePlotting', 'LinearInterpolate,0|DontPlot,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IUnknownValuePlotting_$type = /*@__PURE__*/ new Type(null, 'IUnknownValuePlotting');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyUpdatedEventArgs = /*@__PURE__*/ (() => {
    class PropertyUpdatedEventArgs extends EventArgs {
        constructor(a, b, c) {
            super();
            this._propertyName = null;
            this._oldValue = null;
            this._newValue = null;
            this.propertyName = a;
            this.oldValue = b;
            this.newValue = c;
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get oldValue() {
            return this._oldValue;
        }
        set oldValue(a) {
            this._oldValue = a;
        }
        get newValue() {
            return this._newValue;
        }
        set newValue(a) {
            this._newValue = a;
        }
    }
    PropertyUpdatedEventArgs.$t = /*@__PURE__*/ markType(PropertyUpdatedEventArgs, 'PropertyUpdatedEventArgs', EventArgs.$);
    return PropertyUpdatedEventArgs;
})();

/**
 * EventArgs class for property updated events.
*/
class IgrPropertyUpdatedEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Name of the property being updated.
    */
    get propertyName() {
        return this.i.propertyName;
    }
    set propertyName(v) {
        this.i.propertyName = v;
    }
    /**
     * Old or previous value of the property being updated.
    */
    get oldValue() {
        return this.i.oldValue;
    }
    set oldValue(v) {
        this.i.oldValue = v;
    }
    /**
     * New or current value of the property being updated.
    */
    get newValue() {
        return this.i.newValue;
    }
    set newValue(v) {
        this.i.newValue = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes the mode used to abbreviate large numbers
 */
var DataAbbreviationMode = /*@__PURE__*/ (function (DataAbbreviationMode) {
    /**
     * Specifies abbreviation that is automatically resolves to shared abbreviation between multiple numbers, 2.5K for 2,500 and 2500K for 2,500,000
     */
    DataAbbreviationMode[DataAbbreviationMode["Auto"] = 0] = "Auto";
    /**
     * Specifies independent abbreviation for multiple numbers, 2.5K for 2,500 and 2.5M for 2,500,000
     */
    DataAbbreviationMode[DataAbbreviationMode["Independent"] = 1] = "Independent";
    /**
     * Specifies shared abbreviation between multiple numbers, 2.5K for 2,500 and 2500K for 2,500,000
     */
    DataAbbreviationMode[DataAbbreviationMode["Shared"] = 2] = "Shared";
    /**
     * Specifies number abbreviation to thousands, 2.5K for 2,500
     */
    DataAbbreviationMode[DataAbbreviationMode["Kilo"] = 3] = "Kilo";
    /**
     * Specifies number abbreviation to millions, 2.5M for 2,500,000
     */
    DataAbbreviationMode[DataAbbreviationMode["Million"] = 4] = "Million";
    /**
     * Specifies number abbreviation to billion, 2.5B for 2,500,000,000
     */
    DataAbbreviationMode[DataAbbreviationMode["Billion"] = 5] = "Billion";
    /**
     * Specifies number abbreviation to trillion, 2.5T for 2,500,000,000,000
     */
    DataAbbreviationMode[DataAbbreviationMode["Trillion"] = 6] = "Trillion";
    /**
     * Specifies number abbreviation to quadrillion, 2.5Q for 2,500,000,000,000,000
     */
    DataAbbreviationMode[DataAbbreviationMode["Quadrillion"] = 7] = "Quadrillion";
    /**
     * Specifies default abbreviation
     */
    DataAbbreviationMode[DataAbbreviationMode["Unset"] = 8] = "Unset";
    /**
     * Specifies no abbreviation of numbers
     */
    DataAbbreviationMode[DataAbbreviationMode["None"] = 9] = "None";
    return DataAbbreviationMode;
})({});
/**
 * @hidden
 */
let DataAbbreviationMode_$type = /*@__PURE__*/ markEnum('DataAbbreviationMode', 'Auto,0|Independent,1|Shared,2|Kilo,3|Million,4|Billion,5|Trillion,6|Quadrillion,7|Unset,8|None,9');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes type of summarization to use for the data legend.
 */
var DataLegendSummaryType = /*@__PURE__*/ (function (DataLegendSummaryType) {
    /**
     * Specifies automatic summarization
     */
    DataLegendSummaryType[DataLegendSummaryType["Auto"] = 0] = "Auto";
    /**
     * Specifies total of values in summary row
     */
    DataLegendSummaryType[DataLegendSummaryType["Total"] = 1] = "Total";
    /**
     * Specifies average of values in summary row
     */
    DataLegendSummaryType[DataLegendSummaryType["Average"] = 2] = "Average";
    /**
     * Specifies minimum of values in summary row
     */
    DataLegendSummaryType[DataLegendSummaryType["Min"] = 3] = "Min";
    /**
     * Specifies maximum of values in summary row
     */
    DataLegendSummaryType[DataLegendSummaryType["Max"] = 4] = "Max";
    /**
     * Specifies no summarization
     */
    DataLegendSummaryType[DataLegendSummaryType["None"] = 5] = "None";
    return DataLegendSummaryType;
})({});
/**
 * @hidden
 */
let DataLegendSummaryType_$type = /*@__PURE__*/ markEnum('DataLegendSummaryType', 'Auto,0|Total,1|Average,2|Min,3|Max,4|None,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes mode for displaying units after series values in the data legend.
 */
var DataLegendUnitsMode = /*@__PURE__*/ (function (DataLegendUnitsMode) {
    /**
     * Specifies automatic visibility of units based on series type
     */
    DataLegendUnitsMode[DataLegendUnitsMode["Auto"] = 0] = "Auto";
    /**
     * Specifies always visible units after series values
     */
    DataLegendUnitsMode[DataLegendUnitsMode["Visible"] = 1] = "Visible";
    /**
     * Specifies hidden units after series values
     */
    DataLegendUnitsMode[DataLegendUnitsMode["Hidden"] = 2] = "Hidden";
    return DataLegendUnitsMode;
})({});
/**
 * @hidden
 */
let DataLegendUnitsMode_$type = /*@__PURE__*/ markEnum('DataLegendUnitsMode', 'Auto,0|Visible,1|Hidden,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes mode for displaying labels before series values in the data legend.
 */
var DataLegendLabelMode = /*@__PURE__*/ (function (DataLegendLabelMode) {
    /**
     * Specifies automatic labels based on series type, e.g. "O: H: L: C:" for Financial Series
     */
    DataLegendLabelMode[DataLegendLabelMode["Auto"] = 0] = "Auto";
    /**
     * Specifies always visible labels before series values
     */
    DataLegendLabelMode[DataLegendLabelMode["Visible"] = 1] = "Visible";
    /**
     * Specifies hidden labels before series values
     */
    DataLegendLabelMode[DataLegendLabelMode["Hidden"] = 2] = "Hidden";
    return DataLegendLabelMode;
})({});
/**
 * @hidden
 */
let DataLegendLabelMode_$type = /*@__PURE__*/ markEnum('DataLegendLabelMode', 'Auto,0|Visible,1|Hidden,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes mode for displaying values in the data legend.
 */
var DataLegendValueMode = /*@__PURE__*/ (function (DataLegendValueMode) {
    /**
     * Specifies automatic mode that resolves to best value display mode
     */
    DataLegendValueMode[DataLegendValueMode["Auto"] = 0] = "Auto";
    /**
     * Specifies values as decimal number, e.g. 170.25 for 170.25
     */
    DataLegendValueMode[DataLegendValueMode["Decimal"] = 1] = "Decimal";
    /**
     * Specifies values with currency symbol, e.g. $170.25 for 170.25
     * Note symbol of the currency depends on the ValueFormatCulture property
     */
    DataLegendValueMode[DataLegendValueMode["Currency"] = 2] = "Currency";
    return DataLegendValueMode;
})({});
/**
 * @hidden
 */
let DataLegendValueMode_$type = /*@__PURE__*/ markEnum('DataLegendValueMode', 'Auto,0|Decimal,1|Currency,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes mode for displaying values in the data legend.
 */
var DataLegendLayoutMode = /*@__PURE__*/ (function (DataLegendLayoutMode) {
    /**
     * Specifies a layout mode where values of series are placed in columns of a table
     */
    DataLegendLayoutMode[DataLegendLayoutMode["Table"] = 0] = "Table";
    /**
     * Specifies a layout mode where values of series are stacked vertically below series title
     */
    DataLegendLayoutMode[DataLegendLayoutMode["Vertical"] = 1] = "Vertical";
    return DataLegendLayoutMode;
})({});
/**
 * @hidden
 */
let DataLegendLayoutMode_$type = /*@__PURE__*/ markEnum('DataLegendLayoutMode', 'Table,0|Vertical,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes mode for formatting time in header of data legend
 */
var DataLegendHeaderTimeMode = /*@__PURE__*/ (function (DataLegendHeaderTimeMode) {
    /**
     * Specifies automatic time format that defaults to no string
     */
    DataLegendHeaderTimeMode[DataLegendHeaderTimeMode["Auto"] = 0] = "Auto";
    /**
     * Specifies time as short string in header row of data legend
     */
    DataLegendHeaderTimeMode[DataLegendHeaderTimeMode["ShortStyle"] = 1] = "ShortStyle";
    /**
     * Specifies time as long string in header row of data legend
     */
    DataLegendHeaderTimeMode[DataLegendHeaderTimeMode["LongStyle"] = 2] = "LongStyle";
    /**
     * Specifies time as medium string in header row of data legend
     */
    DataLegendHeaderTimeMode[DataLegendHeaderTimeMode["MediumStyle"] = 3] = "MediumStyle";
    /**
     * Specifies time as full string in header row of data legend
     */
    DataLegendHeaderTimeMode[DataLegendHeaderTimeMode["FullStyle"] = 4] = "FullStyle";
    /**
     * Specifies no time in header row of data legend
     */
    DataLegendHeaderTimeMode[DataLegendHeaderTimeMode["None"] = 5] = "None";
    return DataLegendHeaderTimeMode;
})({});
/**
 * @hidden
 */
let DataLegendHeaderTimeMode_$type = /*@__PURE__*/ markEnum('DataLegendHeaderTimeMode', 'Auto,0|ShortStyle,1|LongStyle,2|MediumStyle,3|FullStyle,4|None,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes mode for formatting date in header of data legend
 */
var DataLegendHeaderDateMode = /*@__PURE__*/ (function (DataLegendHeaderDateMode) {
    /**
     * Specifies automatic date format that defaults to short string
     */
    DataLegendHeaderDateMode[DataLegendHeaderDateMode["Auto"] = 0] = "Auto";
    /**
     * Specifies date as short string in header row of data legend
     */
    DataLegendHeaderDateMode[DataLegendHeaderDateMode["ShortStyle"] = 1] = "ShortStyle";
    /**
     * Specifies date as long string in header row of data legend
     */
    DataLegendHeaderDateMode[DataLegendHeaderDateMode["LongStyle"] = 2] = "LongStyle";
    /**
     * Specifies date as medium string in header row of data legend
     */
    DataLegendHeaderDateMode[DataLegendHeaderDateMode["MediumStyle"] = 3] = "MediumStyle";
    /**
     * Specifies date as full string in header row of data legend
     */
    DataLegendHeaderDateMode[DataLegendHeaderDateMode["FullStyle"] = 4] = "FullStyle";
    /**
     * Specifies no date in header row of data legend
     */
    DataLegendHeaderDateMode[DataLegendHeaderDateMode["None"] = 5] = "None";
    return DataLegendHeaderDateMode;
})({});
/**
 * @hidden
 */
let DataLegendHeaderDateMode_$type = /*@__PURE__*/ markEnum('DataLegendHeaderDateMode', 'Auto,0|ShortStyle,1|LongStyle,2|MediumStyle,3|FullStyle,4|None,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available positions on the crossing axis at which the category tooltip can be displayed.
 */
var DataToolTipLayerGroupingMode = /*@__PURE__*/ (function (DataToolTipLayerGroupingMode) {
    /**
     * A grouping mode is selected automatically
     */
    DataToolTipLayerGroupingMode[DataToolTipLayerGroupingMode["Auto"] = 0] = "Auto";
    /**
     * Displays a grouped tooltip based on the primary axis if possible.
     */
    DataToolTipLayerGroupingMode[DataToolTipLayerGroupingMode["Grouped"] = 1] = "Grouped";
    /**
     * Displays individual tooltips for each series.
     */
    DataToolTipLayerGroupingMode[DataToolTipLayerGroupingMode["Individual"] = 2] = "Individual";
    return DataToolTipLayerGroupingMode;
})({});
/**
 * @hidden
 */
let DataToolTipLayerGroupingMode_$type = /*@__PURE__*/ markEnum('DataToolTipLayerGroupingMode', 'Auto,0|Grouped,1|Individual,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available positions on the X axis at which the summary tooltip to be displayed.
 */
var DataTooltipGroupedPositionX = /*@__PURE__*/ (function (DataTooltipGroupedPositionX) {
    /**
     * A position on the X axis is selected automatically.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["Auto"] = 0] = "Auto";
    /**
     * Aligns the tooltip so that it appears to the left of the horizontal snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["SnapLeft"] = 1] = "SnapLeft";
    /**
     * Aligns the tooltip so that it appears to the right of the horizontal snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["SnapRight"] = 2] = "SnapRight";
    /**
     * Aligns the tooltip so that it appears at the middle of the horizontal snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["SnapMiddle"] = 3] = "SnapMiddle";
    /**
     * Aligns the tooltip so that it appears to the left of the horizontal snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["LeftEdgeSnapLeft"] = 4] = "LeftEdgeSnapLeft";
    /**
     * Aligns the tooltip so that it appears to the right of the horizontal snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["LeftEdgeSnapRight"] = 5] = "LeftEdgeSnapRight";
    /**
     * Aligns the tooltip so that it appears at the middle of the horizontal snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["LeftEdgeSnapMiddle"] = 6] = "LeftEdgeSnapMiddle";
    /**
     * Aligns the tooltip so that it appears to the left of the horizontal snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["RightEdgeSnapLeft"] = 7] = "RightEdgeSnapLeft";
    /**
     * Aligns the tooltip so that it appears to the right of the horizontal snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["RightEdgeSnapRight"] = 8] = "RightEdgeSnapRight";
    /**
     * Aligns the tooltip so that it appears at the middle of the horizontal snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["RightEdgeSnapMiddle"] = 9] = "RightEdgeSnapMiddle";
    /**
     * Aligns the tooltip so that it appears to the left of the cursor.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["TrackLeft"] = 10] = "TrackLeft";
    /**
     * Aligns the tooltip so that it appears to the right of the cursor.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["TrackRight"] = 11] = "TrackRight";
    /**
     * Aligns the tooltip so that the cursor appears in the center of the tooltip width.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["TrackMiddle"] = 12] = "TrackMiddle";
    /**
     * Aligns the tooltip relative to the left plot area edge.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["PinLeft"] = 13] = "PinLeft";
    /**
     * Aligns the tooltip relative to the right plot area edge.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["PinRight"] = 14] = "PinRight";
    /**
     * Aligns the tooltip width center with the width center of the plot area.
     */
    DataTooltipGroupedPositionX[DataTooltipGroupedPositionX["PinMiddle"] = 15] = "PinMiddle";
    return DataTooltipGroupedPositionX;
})({});
/**
 * @hidden
 */
let DataTooltipGroupedPositionX_$type = /*@__PURE__*/ markEnum('DataTooltipGroupedPositionX', 'Auto,0|SnapLeft,1|SnapRight,2|SnapMiddle,3|LeftEdgeSnapLeft,4|LeftEdgeSnapRight,5|LeftEdgeSnapMiddle,6|RightEdgeSnapLeft,7|RightEdgeSnapRight,8|RightEdgeSnapMiddle,9|TrackLeft,10|TrackRight,11|TrackMiddle,12|PinLeft,13|PinRight,14|PinMiddle,15');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available positions on the Y axis at which the summary tooltip to be displayed.
 */
var DataTooltipGroupedPositionY = /*@__PURE__*/ (function (DataTooltipGroupedPositionY) {
    /**
     * A position on the Y axis is selected automatically.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["Auto"] = 0] = "Auto";
    /**
     * Aligns the tooltip so that it appears at the top of the vertical snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["SnapTop"] = 1] = "SnapTop";
    /**
     * Aligns the tooltip so that it appears at the bottom of the vertical snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["SnapBottom"] = 2] = "SnapBottom";
    /**
     * Aligns the tooltip so that it appears at the middle of the vertical snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["SnapMiddle"] = 3] = "SnapMiddle";
    /**
     * Aligns the tooltip so that it appears at the top of the vertical snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["TopEdgeSnapTop"] = 4] = "TopEdgeSnapTop";
    /**
     * Aligns the tooltip so that it appears at the bottom of the vertical snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["TopEdgeSnapBottom"] = 5] = "TopEdgeSnapBottom";
    /**
     * Aligns the tooltip so that it appears at the middle of the vertical snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["TopEdgeSnapMiddle"] = 6] = "TopEdgeSnapMiddle";
    /**
     * Aligns the tooltip so that it appears at the top of the vertical snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["BottomEdgeSnapTop"] = 7] = "BottomEdgeSnapTop";
    /**
     * Aligns the tooltip so that it appears at the bottom of the vertical snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["BottomEdgeSnapBottom"] = 8] = "BottomEdgeSnapBottom";
    /**
     * Aligns the tooltip so that it appears at the middle of the vertical snap point of the current series if applicable.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["BottomEdgeSnapMiddle"] = 9] = "BottomEdgeSnapMiddle";
    /**
     * Aligns the tooltip so that it appears at the top of the cursor.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["TrackTop"] = 10] = "TrackTop";
    /**
     * Aligns the tooltip so that it appears at the bottom of the cursor.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["TrackBottom"] = 11] = "TrackBottom";
    /**
     * Aligns the tooltip so that the cursor appears in the center of the tooltip height.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["TrackMiddle"] = 12] = "TrackMiddle";
    /**
     * Aligns the tooltip relative to the top chart edge.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["PinTop"] = 13] = "PinTop";
    /**
     * Aligns the tooltip relative to the bottom chart edge.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["PinBottom"] = 14] = "PinBottom";
    /**
     * Aligns the tooltip height center with the height center of the chart.
     */
    DataTooltipGroupedPositionY[DataTooltipGroupedPositionY["PinMiddle"] = 15] = "PinMiddle";
    return DataTooltipGroupedPositionY;
})({});
/**
 * @hidden
 */
let DataTooltipGroupedPositionY_$type = /*@__PURE__*/ markEnum('DataTooltipGroupedPositionY', 'Auto,0|SnapTop,1|SnapBottom,2|SnapMiddle,3|TopEdgeSnapTop,4|TopEdgeSnapBottom,5|TopEdgeSnapMiddle,6|BottomEdgeSnapTop,7|BottomEdgeSnapBottom,8|BottomEdgeSnapMiddle,9|TrackTop,10|TrackBottom,11|TrackMiddle,12|PinTop,13|PinBottom,14|PinMiddle,15');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataLegend_$type = /*@__PURE__*/ new Type(null, 'IDataLegend');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataLegendSeries_$type = /*@__PURE__*/ new Type(null, 'IDataLegendSeries');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataLegendTarget_$type = /*@__PURE__*/ new Type(null, 'IDataLegendTarget');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes type of data columns to use for the data legend.
 */
var DataLegendSeriesValueType = /*@__PURE__*/ (function (DataLegendSeriesValueType) {
    /**
     * Specifies the Value data column for the category series and radial series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["Value"] = 0] = "Value";
    /**
     * Specifies the Low data column for the financial price series and range series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["Low"] = 1] = "Low";
    /**
     * Specifies the High data column for the financial price series and range series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["High"] = 2] = "High";
    /**
     * Specifies the Open data column for the financial price series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["Open"] = 3] = "Open";
    /**
     * Specifies the Close data column for the financial price series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["Close"] = 4] = "Close";
    /**
     * Specifies the typical price column for the financial price series: (high + low + close) / 3
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["TypicalPrice"] = 5] = "TypicalPrice";
    /**
     * Specifies the average column between high/low for the range series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["Average"] = 6] = "Average";
    /**
     * Specifies the range column between high/low for the range series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["Range"] = 7] = "Range";
    /**
     * Specifies the Volume data column for the financial price series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["Volume"] = 8] = "Volume";
    /**
     * Specifies the Change data column for the financial price series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["Change"] = 9] = "Change";
    /**
     * Specifies the Angle data column for the polar series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["Angle"] = 10] = "Angle";
    /**
     * Specifies the Radius data column for the polar series, radial series, and bubble series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["Radius"] = 11] = "Radius";
    /**
     * Specifies the Fill data column for the bubble series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["Fill"] = 12] = "Fill";
    /**
     * Specifies the X data column for the bubble series and scatter series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["XValue"] = 13] = "XValue";
    /**
     * Specifies the Y data column for the bubble series and scatter series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["YValue"] = 14] = "YValue";
    /**
     * Specifies the summary data columns for all series
     */
    DataLegendSeriesValueType[DataLegendSeriesValueType["Summary"] = 15] = "Summary";
    return DataLegendSeriesValueType;
})({});
/**
 * @hidden
 */
let DataLegendSeriesValueType_$type = /*@__PURE__*/ markEnum('DataLegendSeriesValueType', 'Value,0|Low,1|High,2|Open,3|Close,4|TypicalPrice,5|Average,6|Range,7|Volume,8|Change,9|Angle,10|Radius,11|Fill,12|XValue,13|YValue,14|Summary,15');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes type of data columns to use for the data legend.
 */
var DataLegendSeriesFamily = /*@__PURE__*/ (function (DataLegendSeriesFamily) {
    /**
     * Specifies the Category series
     */
    DataLegendSeriesFamily[DataLegendSeriesFamily["Category"] = 0] = "Category";
    /**
     * Specifies the Range series
     */
    DataLegendSeriesFamily[DataLegendSeriesFamily["Range"] = 1] = "Range";
    /**
     * Specifies the Financial Price series
     */
    DataLegendSeriesFamily[DataLegendSeriesFamily["Financial"] = 2] = "Financial";
    /**
     * Specifies the Financial Indicator series
     */
    DataLegendSeriesFamily[DataLegendSeriesFamily["Indicator"] = 3] = "Indicator";
    /**
     * Specifies the Polar series
     */
    DataLegendSeriesFamily[DataLegendSeriesFamily["Polar"] = 4] = "Polar";
    /**
     * Specifies the Radial series
     */
    DataLegendSeriesFamily[DataLegendSeriesFamily["Radial"] = 5] = "Radial";
    /**
     * Specifies the Scatter series
     */
    DataLegendSeriesFamily[DataLegendSeriesFamily["Scatter"] = 6] = "Scatter";
    /**
     * Specifies the Stacked series
     */
    DataLegendSeriesFamily[DataLegendSeriesFamily["Stacked"] = 7] = "Stacked";
    /**
     * Specifies the Shape series
     */
    DataLegendSeriesFamily[DataLegendSeriesFamily["Shape"] = 8] = "Shape";
    /**
     * Specifies the Geographic series
     */
    DataLegendSeriesFamily[DataLegendSeriesFamily["Geographic"] = 9] = "Geographic";
    /**
     * Specifies the Highlight series
     */
    DataLegendSeriesFamily[DataLegendSeriesFamily["Highlight"] = 10] = "Highlight";
    return DataLegendSeriesFamily;
})({});
/**
 * @hidden
 */
let DataLegendSeriesFamily_$type = /*@__PURE__*/ markEnum('DataLegendSeriesFamily', 'Category,0|Range,1|Financial,2|Indicator,3|Polar,4|Radial,5|Scatter,6|Stacked,7|Shape,8|Geographic,9|Highlight,10');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendSeriesValueInfo = /*@__PURE__*/ (() => {
    class DataLegendSeriesValueInfo extends Base {
        constructor() {
            super();
            this.l = 0;
            this.v = null;
            this.w = null;
            this.x = null;
            this.y = null;
            this.z = null;
            this.n = 0;
            this.m = 0;
            this.j = false;
            this.i = false;
            this.e = false;
            this.h = false;
            this.f = false;
            this.g = false;
            this.d = false;
            this.a = 0;
            this.o = 0;
            this.p = 0;
            this.k = false;
            this.c = false;
            this.b = false;
            this.r = null;
            this.q = null;
            this.s = null;
            this.t = null;
            this.b = true;
            this.c = true;
            this.k = false;
            this.v = "";
            this.w = "";
            this.x = "";
            this.y = "";
            this.s = "";
            this.n = -1;
            this.m = -1;
            this.j = false;
            this.i = false;
            this.e = true;
            this.h = true;
            this.f = true;
            this.g = true;
            this.d = true;
            this.z = null;
        }
        u() {
            let a = "";
            if (!stringIsNullOrEmpty(this.r)) {
                a += this.r + ": ";
            }
            else if (!stringIsNullOrEmpty(this.q)) {
                a += this.q + ": ";
            }
            a += this.l;
            return a;
        }
    }
    DataLegendSeriesValueInfo.$t = /*@__PURE__*/ markType(DataLegendSeriesValueInfo, 'DataLegendSeriesValueInfo');
    return DataLegendSeriesValueInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendSeriesContext = /*@__PURE__*/ (() => {
    class DataLegendSeriesContext extends Base {
        b(a) {
            if (this.c.containsKey(a)) {
                return this.c.item(a);
            }
            return null;
        }
        f(a) {
            if (this.c.containsKey(a)) {
                return this.c.item(a).l;
            }
            return NaN;
        }
        k(a, b) {
            let c = null;
            if (!this.c.containsKey(a)) {
                c = new DataLegendSeriesValueInfo();
                c.a = a;
                this.i(c);
            }
            c.l = b;
        }
        l(a, b) {
            let c = b;
            if (this.c.containsKey(a)) {
                this.j(a);
            }
            c.a = a;
            this.i(c);
        }
        j(a) {
            if (this.c.containsKey(a)) {
                let b = this.c.item(a);
                this.e.remove(b);
                this.c.removeItem(a);
            }
        }
        i(a) {
            let b = false;
            if (a.o == -1) {
                b = true;
                a.o = this.g();
            }
            this.c.item(a.a, a);
            this.e.add(a);
            if (!b) {
                this.e.aa((c, d) => c.o - d.o);
            }
        }
        g() {
            let a = -1;
            for (let b = 0; b < this.e.count; b++) {
                a = Math.max(a, this.e._inner[b].o);
            }
            return a + 1;
        }
        constructor() {
            super();
            this.c = new Dictionary$2(DataLegendSeriesValueType_$type, DataLegendSeriesValueInfo.$, 0);
            this.h = null;
            this.d = null;
            this.e = new List$1(DataLegendSeriesValueInfo.$, 0);
        }
        get e() {
            return this.d;
        }
        set e(a) {
            this.d = a;
            this.c.clear();
            for (let b = 0; b < this.d.count; b++) {
                this.d._inner[b].o = b;
                this.c.item(this.d._inner[b].a, this.d._inner[b]);
            }
        }
        a() {
            let a = new List$1(Number_$type, 0);
            for (let b of fromEnum(this.e)) {
                a.add(b.l);
            }
            return a.toArray();
        }
    }
    DataLegendSeriesContext.$t = /*@__PURE__*/ markType(DataLegendSeriesContext, 'DataLegendSeriesContext');
    return DataLegendSeriesContext;
})();

/**
 * Represent info about series values
*/
class IgrDataLegendSeriesValueInfo {
    createImplementation() {
        return new DataLegendSeriesValueInfo();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets value of series
    */
    get value() {
        return this.i.l;
    }
    set value(v) {
        this.i.l = +v;
    }
    /**
     * Gets or sets prefix for negative value
    */
    get valueNegativePrefix() {
        return this.i.v;
    }
    set valueNegativePrefix(v) {
        this.i.v = v;
    }
    /**
     * Gets or sets suffix for negative value
    */
    get valueNegativeSuffix() {
        return this.i.w;
    }
    set valueNegativeSuffix(v) {
        this.i.w = v;
    }
    /**
     * Gets or sets prefix for positive value
    */
    get valuePositivePrefix() {
        return this.i.x;
    }
    set valuePositivePrefix(v) {
        this.i.x = v;
    }
    /**
     * Gets or sets suffix for positive value
    */
    get valuePositiveSuffix() {
        return this.i.y;
    }
    set valuePositiveSuffix(v) {
        this.i.y = v;
    }
    /**
     * Gets value color used by the series
    */
    get formatWithSeriesColor() {
        return brushToString(this.i.z);
    }
    set formatWithSeriesColor(v) {
        this.i.z = stringToBrush(v);
    }
    /**
     * Gets or sets minimum digits used for displaying faction of the value
    */
    get formatMinFractions() {
        return this.i.n;
    }
    set formatMinFractions(v) {
        this.i.n = +v;
    }
    /**
     * Gets or sets maximum digits used for displaying faction of the value
    */
    get formatMaxFractions() {
        return this.i.m;
    }
    set formatMaxFractions(v) {
        this.i.m = +v;
    }
    /**
     * Gets or sets whether or not use conditional color
    */
    get formatUsePositiveColor() {
        return this.i.j;
    }
    set formatUsePositiveColor(v) {
        this.i.j = ensureBool(v);
    }
    /**
     * Gets or sets whether or not use conditional color
    */
    get formatUseNegativeColor() {
        return this.i.i;
    }
    set formatUseNegativeColor(v) {
        this.i.i = ensureBool(v);
    }
    /**
     * Gets or sets whether or not allow displaying value as currency
    */
    get formatAllowCurrency() {
        return this.i.e;
    }
    set formatAllowCurrency(v) {
        this.i.e = ensureBool(v);
    }
    /**
     * Gets or sets whether or not allow displaying value as percentage
    */
    get formatAllowPercent() {
        return this.i.h;
    }
    set formatAllowPercent(v) {
        this.i.h = ensureBool(v);
    }
    /**
     * Gets or sets whether or not allow displaying value as decimal
    */
    get formatAllowDecimal() {
        return this.i.f;
    }
    set formatAllowDecimal(v) {
        this.i.f = ensureBool(v);
    }
    /**
     * Gets or sets whether or not allow displaying value as integer
    */
    get formatAllowInteger() {
        return this.i.g;
    }
    set formatAllowInteger(v) {
        this.i.g = ensureBool(v);
    }
    /**
     * Gets or sets whether or not allow displaying value with abbreviation
    */
    get formatAllowAbbreviation() {
        return this.i.d;
    }
    set formatAllowAbbreviation(v) {
        this.i.d = ensureBool(v);
    }
    /**
     * Gets or sets type of value
    */
    get valueType() {
        return this.i.a;
    }
    set valueType(v) {
        this.i.a = ensureEnum(DataLegendSeriesValueType_$type, v);
    }
    /**
     * Gets the index of series
    */
    get index() {
        return this.i.o;
    }
    set index(v) {
        this.i.o = +v;
    }
    get orderIndex() {
        return this.i.p;
    }
    set orderIndex(v) {
        this.i.p = +v;
    }
    /**
     * Gets or sets whether this value is excluded/hidden by default in Data Legend
    */
    get isExcludeByDefault() {
        return this.i.k;
    }
    set isExcludeByDefault(v) {
        this.i.k = ensureBool(v);
    }
    /**
     * Gets or sets whether the unit text is allowed by the series, e.g. "Hz"
    */
    get allowUnits() {
        return this.i.c;
    }
    set allowUnits(v) {
        this.i.c = ensureBool(v);
    }
    /**
     * Gets or sets whether the label text is allowed by the series, e.g. "H:"
    */
    get allowLabels() {
        return this.i.b;
    }
    set allowLabels(v) {
        this.i.b = ensureBool(v);
    }
    /**
     * Gets or sets member path for the series value, e.g. "HighPrice"
    */
    get memberPath() {
        return this.i.r;
    }
    set memberPath(v) {
        this.i.r = v;
    }
    /**
     * Gets or sets member path for the series value, e.g. "High"
    */
    get memberLabel() {
        return this.i.q;
    }
    set memberLabel(v) {
        this.i.q = v;
    }
    /**
     * Gets or sets label for the series value, e.g. "H:"
    */
    get memberSymbol() {
        return this.i.s;
    }
    set memberSymbol(v) {
        this.i.s = v;
    }
    /**
     * Gets or sets unit text for the value, e.g. "Hz"
    */
    get memberUnit() {
        return this.i.t;
    }
    set memberUnit(v) {
        this.i.t = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    /**
     * Converts this object to a string
    
    */
    toString() {
        let iv = this.i.u();
        return (iv);
    }
}

/**
 * Represent info about series values
*/
class IgrDataLegendSeriesContext {
    createImplementation() {
        return new DataLegendSeriesContext();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets a family of series that the current series belongs to, e.g. Category, Range, Financial, etc.
    */
    get seriesFamily() {
        return this.i.h;
    }
    set seriesFamily(v) {
        this.i.h = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    /**
     * Creates an instance of DataLegendSeriesContext
    
    */
    getSeriesValueInfo(type) {
        let iv = this.i.b((type == null ? null : type));
        let ret = null;
        if (iv && iv.externalObject) {
            ret = iv.externalObject;
        }
        else {
            if (iv) {
                let e = new IgrDataLegendSeriesValueInfo();
                e._implementation = iv;
                iv.externalObject = e;
                ret = e;
            }
        }
        return ret;
    }
    /**
     * Gets value info for the series value type
    
    */
    getSeriesValue(type) {
        let iv = this.i.f((type == null ? null : type));
        return (iv);
    }
    setSeriesValue(type, value) {
        this.i.k((type == null ? null : type), value);
    }
    setSeriesValueInfo(type, valueInfo) {
        this.i.l((type == null ? null : type), (valueInfo == null ? null : valueInfo.i));
    }
    /**
     * Gets all values that a series renders at the current data point
     * For example, Open, High, Low, Close for Financial Series
    
    */
    getSeriesValues() {
        let iv = this.i.a();
        return (iv);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendSummaryColumn = /*@__PURE__*/ (() => {
    class DataLegendSummaryColumn extends DataLegendSeriesValueInfo {
        constructor() {
            super();
            this.ah = new List$1(Number_$type, 0);
            this.af = new List$1(String_$type, 0);
            this.ag = new List$1(String_$type, 0);
            this.ad = new HashSet$1(String_$type, 0);
            this.ae = new HashSet$1(String_$type, 0);
            this.a = 15;
        }
        get ac() {
            return this.ah.toArray();
        }
        ak(a) {
            this.ah.add(a);
        }
        ai(a) {
            if (!this.ad.contains(a)) {
                this.ad.add_1(a);
                this.af.add(a);
            }
        }
        aj(a) {
            if (!this.ae.contains(a)) {
                this.ae.add_1(a);
                this.ag.add(a);
            }
        }
        get aa() {
            return this.af.toArray();
        }
        get ab() {
            return this.ag.toArray();
        }
    }
    DataLegendSummaryColumn.$t = /*@__PURE__*/ markType(DataLegendSummaryColumn, 'DataLegendSummaryColumn', DataLegendSeriesValueInfo.$);
    return DataLegendSummaryColumn;
})();

/**
 * Represent a column in summary row
*/
class IgrDataLegendSummaryColumn extends IgrDataLegendSeriesValueInfo {
    createImplementation() {
        return new DataLegendSummaryColumn();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Get values of series in the summary column
    */
    get seriesValues() {
        return this.i.ac;
    }
    /**
     * Get labels rendered on left side of series values, e.g. "H:" for High, "L:" for Low
    */
    get seriesLabels() {
        return this.i.aa;
    }
    /**
     * Get optional units on right side of series values, e.g. "Hz" for hertz
    */
    get seriesUnits() {
        return this.i.ab;
    }
    /**
     * Add a value in the summary column
    
    */
    addValue(value) {
        this.i.ak(value);
    }
    /**
     * Add label in the summary column
    
    */
    addLabel(label) {
        this.i.ai(label);
    }
    /**
     * Add unit in the summary column
    
    */
    addUnits(units) {
        this.i.aj(units);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ILegendSeries_$type = /*@__PURE__*/ new Type(null, 'ILegendSeries');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ILegendSeriesInternal_$type = /*@__PURE__*/ new Type(null, 'ILegendSeriesInternal');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StandardLegendItems_$type = /*@__PURE__*/ markEnum('StandardLegendItems', 'Default,0|Discrete,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IScaleLegendSeries_$type = /*@__PURE__*/ new Type(null, 'IScaleLegendSeries', null, [ILegendSeries_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ILegendOwner_$type = /*@__PURE__*/ new Type(null, 'ILegendOwner');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IInternalLegendOwner_$type = /*@__PURE__*/ new Type(null, 'IInternalLegendOwner');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ILegendTemplateProvider_$type = /*@__PURE__*/ new Type(null, 'ILegendTemplateProvider');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IChartLegend_$type = /*@__PURE__*/ new Type(null, 'IChartLegend');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IChartItemLegend_$type = /*@__PURE__*/ new Type(null, 'IChartItemLegend', null, [IChartLegend_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IChartScaleLegend_$type = /*@__PURE__*/ new Type(null, 'IChartScaleLegend', null, [IChartLegend_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IOnDemandRender_$type = /*@__PURE__*/ new Type(null, 'IOnDemandRender');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointCollection = /*@__PURE__*/ (() => {
    class PointCollection extends List$1 {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(Point_$type, 0);
                    }
                    break;
                case 1:
                    {
                        let source_ = _rest[0];
                        super(Point_$type, 0);
                        this._inner = source_._inner;
                    }
                    break;
            }
        }
    }
    PointCollection.$t = /*@__PURE__*/ markType(PointCollection, 'PointCollection', /*@__PURE__*/ List$1.$.specialize(Point_$type));
    return PointCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolyBezierSegment = /*@__PURE__*/ (() => {
    class PolyBezierSegment extends PathSegment {
        constructor() {
            super();
            this.b = null;
            this.b = new PointCollection(0);
        }
        get_a() {
            return 2;
        }
        get a() {
            return this.get_a();
        }
    }
    PolyBezierSegment.$t = /*@__PURE__*/ markType(PolyBezierSegment, 'PolyBezierSegment', PathSegment.$);
    return PolyBezierSegment;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Numeric = /*@__PURE__*/ (() => {
    class Numeric extends Base {
        constructor() {
            super();
        }
        static e(a, b, c, d, e) {
            let f;
            let g = a.count;
            let h = new Array(g);
            if (b._inner[0] == 0) {
                return false;
            }
            let i = b._inner[0];
            e._inner[0] = d._inner[0] / (i);
            for (f = 1; f < g; f++) {
                h[f] = c._inner[f - 1] / i;
                i = b._inner[f] - a._inner[f] * h[f];
                if (i == 0) {
                    return false;
                }
                e._inner[f] = (d._inner[f] - a._inner[f] * e._inner[f - 1]) / i;
            }
            for (f = (g - 2); f >= 0; f--) {
                e._inner[f] -= h[f + 1] * e._inner[f + 1];
            }
            return true;
        }
        static d(a, b) {
            let c = arrayGetLength(a, 0);
            let d = new Array(c);
            let e = new Array(c);
            let f = new Array(c);
            for (let g = 0; g < c; g++) {
                f[g] = 0;
            }
            for (let h = 0; h < c; h++) {
                let i = 0;
                let j = 0;
                let k = 0;
                for (let l = 0; l < c; l++) {
                    if (f[l] != 1) {
                        for (let m = 0; m < c; m++) {
                            if (f[m] == 0) {
                                if (Math.abs(a[l][m]) >= i) {
                                    i = Math.abs(a[l][m]);
                                    j = l;
                                    k = m;
                                }
                            }
                        }
                    }
                }
                ++(f[k]);
                if (j != k) {
                    for (let n = 0; n < c; n++) {
                        let o = a[j][n];
                        a[j][n] = a[k][n];
                        a[k][n] = o;
                    }
                    {
                        let p = b[j];
                        b[j] = b[k];
                        b[k] = p;
                    }
                }
                e[h] = j;
                d[h] = k;
                if (a[k][k] == 0) {
                    return false;
                }
                let q = 1 / a[k][k];
                a[k][k] = 1;
                for (let r = 0; r < c; r++) {
                    a[k][r] *= q;
                }
                b[k] *= q;
                for (let s = 0; s < c; s++) {
                    if (s != k) {
                        let t = a[s][k];
                        a[s][k] = 0;
                        for (let u = 0; u < c; u++) {
                            a[s][u] -= a[k][u] * t;
                        }
                        b[s] -= b[k] * t;
                    }
                }
            }
            for (let v = c - 1; v >= 0; v--) {
                if (e[v] != d[v]) {
                    for (let w = 0; w < c; w++) {
                        let x = a[w][e[v]];
                        a[w][e[v]] = a[w][d[v]];
                        a[w][d[v]] = x;
                    }
                }
            }
            return true;
        }
        static c(a, b, c, d, e) {
            let f = new List$1(Number_$type, 0);
            for (let g = 0; g < a; ++g) {
                while (g < a && (isNaN_(b(g)) || isNaN_(c(g)))) {
                    f.add(NaN);
                    ++g;
                }
                let h = g;
                while (g < a && !isNaN_(b(g)) && !isNaN_(c(g))) {
                    ++g;
                }
                --g;
                if (g - h > 0) {
                    f.o(Numeric.b(h, g - h + 1, b, c, d, e));
                }
                else {
                    for (; h <= g; ++h) {
                        f.add(NaN);
                    }
                }
            }
            return f.toArray();
        }
        static b(a, b, c, d, e, f) {
            return Numeric.a(b, (g) => c(g + a), (g) => d(g + a), e, f);
        }
        static a(a, b, c, d, e) {
            let f = new Array(a - 1);
            let g = new Array(a);
            g[0] = isNaN_(d) ? 0 : -0.5;
            f[0] = isNaN_(d) ? 0 : (3 / (b(1) - b(0))) * ((c(1) - c(0)) / (b(1) - b(0)) - d);
            for (let h = 1; h < a - 1; h++) {
                let i = (b(h) - b(h - 1)) / (b(h + 1) - b(h - 1));
                let j = i * g[h - 1] + 2;
                g[h] = (i - 1) / j;
                f[h] = (c(h + 1) - c(h)) / (b(h + 1) - b(h)) - (c(h) - c(h - 1)) / (b(h) - b(h - 1));
                f[h] = (6 * f[h] / (b(h + 1) - b(h - 1)) - i * f[h - 1]) / j;
            }
            let k = isNaN_(e) ? 0 : 0.5;
            let l = isNaN_(e) ? 0 : (3 / (b(a - 1) - b(a - 2))) * (e - (c(a - 1) - c(a - 2)) / (b(a - 1) - b(a - 2)));
            g[a - 1] = (l - k * f[a - 2]) / (k * g[a - 2] + 1);
            for (let m = a - 2; m >= 0; m--) {
                g[m] = g[m] * g[m + 1] + f[m];
            }
            return g;
        }
        f(a, b, c, d, e, f, g) {
            let h = d - b;
            let i = (d - a) / h;
            let j = (a - b) / h;
            return i * c + j * e + ((i * i * i - i) * f + (j * j * j - j) * g) * (h * h) / 6;
        }
        static h(a, b, c, d) {
            let e = new PathFigureCollection();
            let f = 0;
            let g = -1;
            let h = NaN;
            let i = NaN;
            for (let j = 0; j < a; j++) {
                h = b(j);
                i = c(j);
                if (isNaN_(h) || isNaN_(i)) {
                    g = j - 1;
                    if (g - f > 0) {
                        e.add(Numeric.g(f, g, b, c, d));
                    }
                    f = j + 1;
                }
            }
            if (!isNaN_(h) && !isNaN_(i)) {
                g = a - 1;
            }
            if (g - f > 0) {
                e.add(Numeric.g(f, g, b, c, d));
            }
            return e;
        }
        static g(a, b, c, d, e) {
            e = 0.5 * MathUtil.d(isNaN_(e) ? 0.5 : e, 0, 1);
            let f = new PathFigure();
            let g = b - a + 1;
            if (g < 2) {
                return f;
            }
            if (g == 2) {
                f._startPoint = { $type: Point_$type, x: c(a), y: d(a) };
                let h = ((() => {
                    let $ret = new LineSegment(1);
                    $ret.c = { $type: Point_$type, x: c(a + 1), y: d(a + 1) };
                    return $ret;
                })());
                f._segments.add(h);
                return f;
            }
            let i = new PolyBezierSegment();
            let j = c(a);
            let k = d(a);
            let l = c(a + 1);
            let m = d(a + 1);
            while (l == j && m == k && a + 1 <= b) {
                a++;
                l = c(a + 1);
                m = d(a + 1);
            }
            let n = l - j;
            let o = m - k;
            let p = Math.sqrt(n * n + o * o);
            for (let q = a + 1; q < b; ++q) {
                let r = c(q);
                let s = d(q);
                if (r == j && s == k) {
                    continue;
                }
                let t = c(q + 1) - c(q - 1);
                let u = d(q + 1) - d(q - 1);
                let v = t * t + u * u;
                if (v < 0.01) {
                    t = -(d(q + 1) - d(q));
                    u = c(q + 1) - c(q);
                    v = t * t + u * u;
                }
                v = Math.sqrt(v);
                let w = e * Math.sqrt((r - j) * (r - j) + (s - k) * (s - k));
                if (v > 0.01) {
                    i.b.add({ $type: Point_$type, x: j + n * w / p, y: k + o * w / p });
                    i.b.add({ $type: Point_$type, x: r - t * w / v, y: s - u * w / v });
                    i.b.add({ $type: Point_$type, x: r, y: s });
                    j = r;
                    k = s;
                    n = t;
                    o = u;
                    p = v;
                }
            }
            {
                let x = b;
                let y = c(x);
                let z = d(x);
                if (!(y == j && z == k)) {
                    let aa = c(x) - c(x - 1);
                    let ab = d(x) - d(x - 1);
                    let ac = aa * aa + ab * ab;
                    let ad = e * Math.sqrt((y - j) * (y - j) + (z - k) * (z - k));
                    i.b.add({ $type: Point_$type, x: j + n * ad / p, y: k + o * ad / p });
                    i.b.add({ $type: Point_$type, x: y - aa * ad / ac, y: z - ab * ad / ac });
                    i.b.add({ $type: Point_$type, x: y, y: z });
                }
            }
            f._startPoint = { $type: Point_$type, x: c(a), y: d(a) };
            f._segments.add(i);
            return f;
        }
    }
    Numeric.$t = /*@__PURE__*/ markType(Numeric, 'Numeric');
    return Numeric;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LeastSquaresFit = /*@__PURE__*/ (() => {
    class LeastSquaresFit extends Numeric {
        static aa() {
            return LeastSquaresFit.t() && LeastSquaresFit.u() && LeastSquaresFit.s() && LeastSquaresFit.w() && LeastSquaresFit.x() && LeastSquaresFit.r() && LeastSquaresFit.y() && LeastSquaresFit.z();
        }
        constructor() {
            super();
        }
        static k(a, b, c) {
            let d = 0;
            let e = 0;
            let f = 0;
            let g = 0;
            let h = 0;
            for (let i = 0; i < a; ++i) {
                let j = b(i);
                let k = c(i);
                if (!isNaN_(j) && !isNaN_(k)) {
                    d += k;
                    e += j * j;
                    f += j;
                    g += j * k;
                    ++h;
                }
            }
            if (h < 2) {
                return null;
            }
            let l = (d * e - f * g) / (h * e - f * f);
            let m = (h * g - f * d) / (h * e - f * f);
            return [l, m];
        }
        static ad(a, b) {
            if (a.length != 2) {
                return NaN;
            }
            return a[0] + a[1] * b;
        }
        static t() {
            let a = new Random(0);
            let b = new Array(2);
            for (let c = 0; c < b.length; ++c) {
                b[c] = 10 * a.nextDouble();
            }
            let d = new List$1(Number_$type, 0);
            let e = new List$1(Number_$type, 0);
            for (let f = -100; f < 100; ++f) {
                let g = f;
                let h = LeastSquaresFit.ad(b, g);
                if (!isNaN_(h)) {
                    d.add(g);
                    e.add(h);
                }
            }
            let i = LeastSquaresFit.k(d.count, (j) => d._inner[j], (j) => e._inner[j]);
            for (let j = 0; j < b.length; ++j) {
                if (Math.abs(b[j] - i[j]) > 0.0001) {
                }
            }
            return true;
        }
        static l(a, b, c) {
            let d = 0;
            let e = 0;
            let f = 0;
            let g = 0;
            let h = 0;
            for (let i = 0; i < a; ++i) {
                let j = b(i);
                let k = c(i);
                if (!isNaN_(j) && !isNaN_(k) && j > 0) {
                    let l = Math.log(j);
                    d += k * l;
                    e += k;
                    f += l;
                    g += l * l;
                    ++h;
                }
            }
            if (h < 2) {
                return null;
            }
            let m = (h * d - e * f) / (h * g - f * f);
            let n = (e - m * f) / h;
            return [n, m];
        }
        static ae(a, b) {
            if (a.length != 2 || b < 0 || isInfinity(b) || isNaN_(b)) {
                return NaN;
            }
            return a[0] + a[1] * Math.log(b);
        }
        static u() {
            let a = new Random(0);
            let b = new Array(2);
            for (let c = 0; c < b.length; ++c) {
                b[c] = 10 * a.nextDouble();
            }
            let d = new List$1(Number_$type, 0);
            let e = new List$1(Number_$type, 0);
            for (let f = 1; f < 100; ++f) {
                let g = f;
                let h = LeastSquaresFit.ae(b, g);
                if (!isNaN_(h)) {
                    d.add(g);
                    e.add(h);
                }
            }
            let i = LeastSquaresFit.l(d.count, (j) => d._inner[j], (j) => e._inner[j]);
            for (let j = 0; j < b.length; ++j) {
                if (Math.abs(b[j] - i[j]) > 0.0001) {
                }
            }
            return true;
        }
        static j(a, b, c) {
            let d = 0;
            let e = 0;
            let f = 0;
            let g = 0;
            let h = 0;
            let i = 0;
            for (let j = 0; j < a; ++j) {
                let k = b(j);
                let l = c(j);
                if (!isNaN_(k) && !isNaN_(l) && l > 0) {
                    let m = Math.log(l);
                    d += k * k * l;
                    e += l * m;
                    f += k * l;
                    g += k * l * m;
                    h += l;
                    ++i;
                }
            }
            if (i < 2) {
                return null;
            }
            let n = (d * e - f * g) / (h * d - f * f);
            let o = (h * g - f * e) / (h * d - f * f);
            return [Math.exp(n), o];
        }
        static ac(a, b) {
            if (a.length != 2 || b < 0 || isInfinity(b) || isNaN_(b)) {
                return NaN;
            }
            return a[0] * Math.exp(a[1] * b);
        }
        static s() {
            let a = new Random(0);
            let b = new Array(2);
            for (let c = 0; c < b.length; ++c) {
                b[c] = 2 * a.nextDouble();
            }
            let d = new List$1(Number_$type, 0);
            let e = new List$1(Number_$type, 0);
            for (let f = 1; f < 100; ++f) {
                let g = f;
                let h = LeastSquaresFit.ac(b, g);
                if (!isNaN_(h)) {
                    d.add(g);
                    e.add(h);
                }
            }
            let i = LeastSquaresFit.j(d.count, (j) => d._inner[j], (j) => e._inner[j]);
            for (let j = 0; j < b.length; ++j) {
                if (Math.abs(b[j] - i[j]) > 0.0001) {
                    return false;
                }
            }
            return true;
        }
        static n(a, b, c) {
            let d = 0;
            let e = 0;
            let f = 0;
            let g = 0;
            let h = 0;
            for (let i = 0; i < a; ++i) {
                let j = b(i);
                let k = c(i);
                if (!isNaN_(j) && !isNaN_(k) && j > 0 && k > 0) {
                    let l = Math.log(b(i));
                    let m = Math.log(c(i));
                    d += l * m;
                    e += l;
                    f += m;
                    g += l * l;
                    ++h;
                }
            }
            if (h < 2) {
                return null;
            }
            let n = (h * d - e * f) / (h * g - e * e);
            let o = Math.exp((f - n * e) / h);
            return [o, n];
        }
        static ag(a, b) {
            if (a.length != 2 || b < 0 || isInfinity(b) || isNaN_(b)) {
                return NaN;
            }
            return a[0] * Math.pow(b, a[1]);
        }
        static w() {
            let a = new Random(0);
            let b = new Array(2);
            for (let c = 0; c < b.length; ++c) {
                b[c] = 10 * a.nextDouble();
            }
            let d = new List$1(Number_$type, 0);
            let e = new List$1(Number_$type, 0);
            for (let f = -100; f < 100; ++f) {
                d.add(f);
                e.add(LeastSquaresFit.ag(b, f));
            }
            let g = LeastSquaresFit.n(d.count, (h) => d._inner[h], (h) => e._inner[h]);
            for (let h = 0; h < b.length; ++h) {
                if (Math.abs(b[h] - g[h]) > 0.0001) {
                    return false;
                }
            }
            return true;
        }
        static o(a, b, c) {
            return LeastSquaresFit.m(a, 2, b, c);
        }
        static ah(a, b) {
            return LeastSquaresFit.af(a, b);
        }
        static x() {
            return LeastSquaresFit.v(2);
        }
        static i(a, b, c) {
            return LeastSquaresFit.m(a, 3, b, c);
        }
        static ab(a, b) {
            return LeastSquaresFit.af(a, b);
        }
        static r() {
            return LeastSquaresFit.v(3);
        }
        static p(a, b, c) {
            return LeastSquaresFit.m(a, 4, b, c);
        }
        static ai(a, b) {
            return LeastSquaresFit.af(a, b);
        }
        static y() {
            return LeastSquaresFit.v(4);
        }
        static q(a, b, c) {
            return LeastSquaresFit.m(a, 5, b, c);
        }
        static aj(a, b) {
            return LeastSquaresFit.af(a, b);
        }
        static z() {
            return LeastSquaresFit.v(5);
        }
        static m(a, b, c, d) {
            let e = new Array(1 + 2 * b);
            for (let f = 0; f < e.length; f++) {
                e[f] = 0;
            }
            let g = ((() => {
                let $firstRank;
                let $ret = new Array($firstRank = b + 1);
                let $currRet = $ret;
                for (let $rankInit = 0; $rankInit < $firstRank; $rankInit++) {
                    $currRet[$rankInit] = new Array(b + 1);
                }
                return $ret;
            })());
            let h = new Array(b + 1);
            for (let i = 0; i < h.length; i++) {
                h[i] = 0;
            }
            let j = 0;
            for (let k = 0; k < a; ++k) {
                let l = 1;
                let m = c(k);
                if (!isNaN_(m) && !isNaN_(d(k))) {
                    for (let n = 0; n < e.length; ++n) {
                        e[n] += l;
                        l *= m;
                        ++j;
                    }
                }
            }
            if (j < b) {
                return null;
            }
            for (let o = 0; o <= b; ++o) {
                for (let p = 0; p <= b; ++p) {
                    g[o][p] = e[o + p];
                }
            }
            for (let q = 0; q < a; ++q) {
                let r = c(q);
                let s = d(q);
                if (!isNaN_(r) && !isNaN_(s)) {
                    for (let t = 0; t <= b; ++t) {
                        h[t] += (Math.pow(r, t) * s);
                    }
                }
            }
            return Numeric.d(g, h) ? h : null;
        }
        static af(a, b) {
            if (a.length < 1 || isInfinity(b) || isNaN_(b)) {
                return NaN;
            }
            let c = 0;
            for (let d = 0; d < a.length; ++d) {
                c += a[d] * Math.pow(b, d);
            }
            return c;
        }
        static v(a) {
            let b = new Random(0);
            let c = new Array(a + 1);
            for (let d = 0; d < c.length; ++d) {
                c[d] = 2 * b.nextDouble();
            }
            let e = new List$1(Number_$type, 0);
            let f = new List$1(Number_$type, 0);
            for (let g = -100; g < 100; ++g) {
                let h = g;
                let i = LeastSquaresFit.af(c, h);
                if (!isNaN_(i)) {
                    e.add(h);
                    f.add(i);
                }
            }
            let j = LeastSquaresFit.m(e.count, a, (k) => e._inner[k], (k) => f._inner[k]);
            for (let k = 0; k < a; ++k) {
                if (Math.abs(c[k] - j[k]) > 0.0001) {
                    return false;
                }
            }
            return true;
        }
    }
    LeastSquaresFit.$t = /*@__PURE__*/ markType(LeastSquaresFit, 'LeastSquaresFit', Numeric.$);
    return LeastSquaresFit;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var ElevationMode = /*@__PURE__*/ (function (ElevationMode) {
    ElevationMode[ElevationMode["Auto"] = 0] = "Auto";
    ElevationMode[ElevationMode["MaterialShadow"] = 1] = "MaterialShadow";
    ElevationMode[ElevationMode["HaloShadow"] = 2] = "HaloShadow";
    return ElevationMode;
})({});
/**
 * @hidden
 */
let ElevationMode_$type = /*@__PURE__*/ markEnum('ElevationMode', 'Auto,0|MaterialShadow,1|HaloShadow,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IToolbarTarget_$type = /*@__PURE__*/ new Type(null, 'IToolbarTarget');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ICommandAvailabilityListener_$type = /*@__PURE__*/ new Type(null, 'ICommandAvailabilityListener');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ICommandStateChangedListener_$type = /*@__PURE__*/ new Type(null, 'ICommandStateChangedListener');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Represents type for toolbar action
 */
var ToolActionType = /*@__PURE__*/ (function (ToolActionType) {
    ToolActionType[ToolActionType["Unknown"] = 0] = "Unknown";
    ToolActionType[ToolActionType["GroupHeader"] = 1] = "GroupHeader";
    ToolActionType[ToolActionType["Checkbox"] = 2] = "Checkbox";
    ToolActionType[ToolActionType["IconButton"] = 3] = "IconButton";
    ToolActionType[ToolActionType["Label"] = 4] = "Label";
    ToolActionType[ToolActionType["NumberInput"] = 5] = "NumberInput";
    ToolActionType[ToolActionType["Radio"] = 6] = "Radio";
    ToolActionType[ToolActionType["Separator"] = 7] = "Separator";
    ToolActionType[ToolActionType["IconMenu"] = 8] = "IconMenu";
    ToolActionType[ToolActionType["Button"] = 9] = "Button";
    ToolActionType[ToolActionType["SubPanel"] = 10] = "SubPanel";
    ToolActionType[ToolActionType["CheckboxList"] = 11] = "CheckboxList";
    return ToolActionType;
})({});
/**
 * @hidden
 */
let ToolActionType_$type = /*@__PURE__*/ markEnum('ToolActionType', 'Unknown,0|GroupHeader,1|Checkbox,2|IconButton,3|Label,4|NumberInput,5|Radio,6|Separator,7|IconMenu,8|Button,9|SubPanel,10|CheckboxList,11');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var ToolCommandStateType = /*@__PURE__*/ (function (ToolCommandStateType) {
    ToolCommandStateType[ToolCommandStateType["VisibilityChanged"] = 0] = "VisibilityChanged";
    ToolCommandStateType[ToolCommandStateType["IsDisabledChanged"] = 1] = "IsDisabledChanged";
    ToolCommandStateType[ToolCommandStateType["ValueChanged"] = 2] = "ValueChanged";
    return ToolCommandStateType;
})({});
/**
 * @hidden
 */
let ToolCommandStateType_$type = /*@__PURE__*/ markEnum('ToolCommandStateType', 'VisibilityChanged,0|IsDisabledChanged,1|ValueChanged,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var ToolCommandExecutionState = /*@__PURE__*/ (function (ToolCommandExecutionState) {
    ToolCommandExecutionState[ToolCommandExecutionState["Completed"] = 0] = "Completed";
    ToolCommandExecutionState[ToolCommandExecutionState["Failed"] = 1] = "Failed";
    ToolCommandExecutionState[ToolCommandExecutionState["Pending"] = 2] = "Pending";
    return ToolCommandExecutionState;
})({});
/**
 * @hidden
 */
let ToolCommandExecutionState_$type = /*@__PURE__*/ markEnum('ToolCommandExecutionState', 'Completed,0|Failed,1|Pending,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolCommandStateChanged = /*@__PURE__*/ (() => {
    class ToolCommandStateChanged extends Base {
        constructor() {
            super(...arguments);
            this.c = null;
            this.a = 0;
            this.b = null;
        }
    }
    ToolCommandStateChanged.$t = /*@__PURE__*/ markType(ToolCommandStateChanged, 'ToolCommandStateChanged');
    return ToolCommandStateChanged;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionInfo = /*@__PURE__*/ (() => {
    class ToolActionInfo extends Base {
        constructor() {
            super();
            this._parentId = null;
            this._commandId = null;
            this._commandArgument = null;
            this._commandArgumentValue = null;
            this._paddingLeft = 0;
            this._paddingRight = 0;
            this._paddingBottom = 0;
            this._paddingTop = 0;
            this._name = null;
            this._title = null;
            this._subtitle = null;
            this._iconName = null;
            this._iconCollectionName = null;
            this._iconViewBoxLeft = 0;
            this._iconViewBoxTop = 0;
            this._iconViewBoxWidth = 0;
            this._iconViewBoxHeight = 0;
            this._iconWidth = 0;
            this._iconHeight = 0;
            this._isDisabled = false;
            this._isHighlighted = false;
            this._textColor = null;
            this._disabledTextColor = null;
            this._closeOnExecute = false;
            this._actions = null;
            this.iconCollectionName = "default";
            this.iconViewBoxLeft = NaN;
            this.iconViewBoxTop = NaN;
            this.iconViewBoxWidth = NaN;
            this.iconViewBoxHeight = NaN;
            this.iconWidth = NaN;
            this.iconHeight = NaN;
            this.paddingLeft = NaN;
            this.paddingRight = NaN;
            this.paddingBottom = NaN;
            this.paddingTop = NaN;
            this.isDisabled = false;
            this.isHighlighted = false;
        }
        get parentId() {
            return this._parentId;
        }
        set parentId(a) {
            this._parentId = a;
        }
        get commandId() {
            return this._commandId;
        }
        set commandId(a) {
            this._commandId = a;
        }
        get commandArgument() {
            return this._commandArgument;
        }
        set commandArgument(a) {
            this._commandArgument = a;
        }
        get commandArgumentValue() {
            return this._commandArgumentValue;
        }
        set commandArgumentValue(a) {
            this._commandArgumentValue = a;
        }
        get paddingLeft() {
            return this._paddingLeft;
        }
        set paddingLeft(a) {
            this._paddingLeft = a;
        }
        get paddingRight() {
            return this._paddingRight;
        }
        set paddingRight(a) {
            this._paddingRight = a;
        }
        get paddingBottom() {
            return this._paddingBottom;
        }
        set paddingBottom(a) {
            this._paddingBottom = a;
        }
        get paddingTop() {
            return this._paddingTop;
        }
        set paddingTop(a) {
            this._paddingTop = a;
        }
        get name() {
            return this._name;
        }
        set name(a) {
            this._name = a;
        }
        get title() {
            return this._title;
        }
        set title(a) {
            this._title = a;
        }
        get subtitle() {
            return this._subtitle;
        }
        set subtitle(a) {
            this._subtitle = a;
        }
        get iconName() {
            return this._iconName;
        }
        set iconName(a) {
            this._iconName = a;
        }
        get iconCollectionName() {
            return this._iconCollectionName;
        }
        set iconCollectionName(a) {
            this._iconCollectionName = a;
        }
        get iconViewBoxLeft() {
            return this._iconViewBoxLeft;
        }
        set iconViewBoxLeft(a) {
            this._iconViewBoxLeft = a;
        }
        get iconViewBoxTop() {
            return this._iconViewBoxTop;
        }
        set iconViewBoxTop(a) {
            this._iconViewBoxTop = a;
        }
        get iconViewBoxWidth() {
            return this._iconViewBoxWidth;
        }
        set iconViewBoxWidth(a) {
            this._iconViewBoxWidth = a;
        }
        get iconViewBoxHeight() {
            return this._iconViewBoxHeight;
        }
        set iconViewBoxHeight(a) {
            this._iconViewBoxHeight = a;
        }
        get iconWidth() {
            return this._iconWidth;
        }
        set iconWidth(a) {
            this._iconWidth = a;
        }
        get iconHeight() {
            return this._iconHeight;
        }
        set iconHeight(a) {
            this._iconHeight = a;
        }
        get isDisabled() {
            return this._isDisabled;
        }
        set isDisabled(a) {
            this._isDisabled = a;
        }
        get isHighlighted() {
            return this._isHighlighted;
        }
        set isHighlighted(a) {
            this._isHighlighted = a;
        }
        get textColor() {
            return this._textColor;
        }
        set textColor(a) {
            this._textColor = a;
        }
        get disabledTextColor() {
            return this._disabledTextColor;
        }
        set disabledTextColor(a) {
            this._disabledTextColor = a;
        }
        get closeOnExecute() {
            return this._closeOnExecute;
        }
        set closeOnExecute(a) {
            this._closeOnExecute = a;
        }
        get actions() {
            return this._actions;
        }
        set actions(a) {
            this._actions = a;
        }
        get_b() {
            return 0;
        }
        get b() {
            return this.get_b();
        }
    }
    ToolActionInfo.$t = /*@__PURE__*/ markType(ToolActionInfo, 'ToolActionInfo');
    return ToolActionInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionCheckboxInfo = /*@__PURE__*/ (() => {
    class ToolActionCheckboxInfo extends ToolActionInfo {
        constructor() {
            super(...arguments);
            this._isChecked = false;
        }
        get_b() {
            return 2;
        }
        get isChecked() {
            return this._isChecked;
        }
        set isChecked(a) {
            this._isChecked = a;
        }
    }
    ToolActionCheckboxInfo.$t = /*@__PURE__*/ markType(ToolActionCheckboxInfo, 'ToolActionCheckboxInfo', ToolActionInfo.$);
    return ToolActionCheckboxInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionCheckboxListInfo = /*@__PURE__*/ (() => {
    class ToolActionCheckboxListInfo extends ToolActionInfo {
        constructor() {
            super(...arguments);
            this._itemsSource = null;
            this._dataMemberPath = null;
            this._selectedMemberPath = null;
            this._primaryKey = null;
        }
        get_b() {
            return 11;
        }
        get itemsSource() {
            return this._itemsSource;
        }
        set itemsSource(a) {
            this._itemsSource = a;
        }
        get dataMemberPath() {
            return this._dataMemberPath;
        }
        set dataMemberPath(a) {
            this._dataMemberPath = a;
        }
        get selectedMemberPath() {
            return this._selectedMemberPath;
        }
        set selectedMemberPath(a) {
            this._selectedMemberPath = a;
        }
        get primaryKey() {
            return this._primaryKey;
        }
        set primaryKey(a) {
            this._primaryKey = a;
        }
    }
    ToolActionCheckboxListInfo.$t = /*@__PURE__*/ markType(ToolActionCheckboxListInfo, 'ToolActionCheckboxListInfo', ToolActionInfo.$);
    return ToolActionCheckboxListInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionRadioInfo = /*@__PURE__*/ (() => {
    class ToolActionRadioInfo extends ToolActionInfo {
        constructor() {
            super(...arguments);
            this._isChecked = false;
            this._channel = null;
        }
        get_b() {
            return 6;
        }
        get isChecked() {
            return this._isChecked;
        }
        set isChecked(a) {
            this._isChecked = a;
        }
        get channel() {
            return this._channel;
        }
        set channel(a) {
            this._channel = a;
        }
    }
    ToolActionRadioInfo.$t = /*@__PURE__*/ markType(ToolActionRadioInfo, 'ToolActionRadioInfo', ToolActionInfo.$);
    return ToolActionRadioInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionIconButtonInfo = /*@__PURE__*/ (() => {
    class ToolActionIconButtonInfo extends ToolActionInfo {
        get_b() {
            return 3;
        }
        get tooltipDelay() {
            return this._tooltipDelay;
        }
        set tooltipDelay(a) {
            this._tooltipDelay = a;
        }
        get isMenuOpenOnStart() {
            return this._isMenuOpenOnStart;
        }
        set isMenuOpenOnStart(a) {
            this._isMenuOpenOnStart = a;
        }
        constructor() {
            super();
            this._tooltipDelay = 0;
            this._isMenuOpenOnStart = false;
            this.tooltipDelay = -1;
        }
    }
    ToolActionIconButtonInfo.$t = /*@__PURE__*/ markType(ToolActionIconButtonInfo, 'ToolActionIconButtonInfo', ToolActionInfo.$);
    return ToolActionIconButtonInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionLabelInfo = /*@__PURE__*/ (() => {
    class ToolActionLabelInfo extends ToolActionInfo {
        get_b() {
            return 4;
        }
    }
    ToolActionLabelInfo.$t = /*@__PURE__*/ markType(ToolActionLabelInfo, 'ToolActionLabelInfo', ToolActionInfo.$);
    return ToolActionLabelInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionIconMenuInfo = /*@__PURE__*/ (() => {
    class ToolActionIconMenuInfo extends ToolActionIconButtonInfo {
        get_b() {
            return 8;
        }
    }
    ToolActionIconMenuInfo.$t = /*@__PURE__*/ markType(ToolActionIconMenuInfo, 'ToolActionIconMenuInfo', ToolActionIconButtonInfo.$);
    return ToolActionIconMenuInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionNumberInputInfo = /*@__PURE__*/ (() => {
    class ToolActionNumberInputInfo extends ToolActionInfo {
        constructor() {
            super(...arguments);
            this._value = 0;
        }
        get_b() {
            return 5;
        }
        get value() {
            return this._value;
        }
        set value(a) {
            this._value = a;
        }
    }
    ToolActionNumberInputInfo.$t = /*@__PURE__*/ markType(ToolActionNumberInputInfo, 'ToolActionNumberInputInfo', ToolActionInfo.$);
    return ToolActionNumberInputInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionSeparatorInfo = /*@__PURE__*/ (() => {
    class ToolActionSeparatorInfo extends ToolActionInfo {
        get_b() {
            return 7;
        }
        get size() {
            return this._size;
        }
        set size(a) {
            this._size = a;
        }
        get isGroupHeaderSeparator() {
            return this._isGroupHeaderSeparator;
        }
        set isGroupHeaderSeparator(a) {
            this._isGroupHeaderSeparator = a;
        }
        constructor() {
            super();
            this._size = 0;
            this._isGroupHeaderSeparator = false;
            this.size = DeviceUtils.g(2);
        }
    }
    ToolActionSeparatorInfo.$t = /*@__PURE__*/ markType(ToolActionSeparatorInfo, 'ToolActionSeparatorInfo', ToolActionInfo.$);
    return ToolActionSeparatorInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionGroupHeaderInfo = /*@__PURE__*/ (() => {
    class ToolActionGroupHeaderInfo extends ToolActionInfo {
        get_b() {
            return 1;
        }
    }
    ToolActionGroupHeaderInfo.$t = /*@__PURE__*/ markType(ToolActionGroupHeaderInfo, 'ToolActionGroupHeaderInfo', ToolActionInfo.$);
    return ToolActionGroupHeaderInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolCommand = /*@__PURE__*/ (() => {
    class ToolCommand extends Base {
        constructor() {
            super();
            this._commandId = null;
            this._argumentsList = null;
            this.argumentsList = null;
        }
        get commandId() {
            return this._commandId;
        }
        set commandId(a) {
            this._commandId = a;
        }
        get argumentsList() {
            return this._argumentsList;
        }
        set argumentsList(a) {
            this._argumentsList = a;
        }
    }
    ToolCommand.$t = /*@__PURE__*/ markType(ToolCommand, 'ToolCommand');
    return ToolCommand;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolCommandArgument = /*@__PURE__*/ (() => {
    class ToolCommandArgument extends Base {
        constructor() {
            super(...arguments);
            this._argumentName = null;
            this._value = null;
        }
        get argumentName() {
            return this._argumentName;
        }
        set argumentName(a) {
            this._argumentName = a;
        }
        get value() {
            return this._value;
        }
        set value(a) {
            this._value = a;
        }
    }
    ToolCommandArgument.$t = /*@__PURE__*/ markType(ToolCommandArgument, 'ToolCommandArgument');
    return ToolCommandArgument;
})();

class IgrToolCommandArgumentCollection extends IgCollection {
    constructor(list) {
        super();
        if (!ToolCommandArgument.$type) {
            ToolCommandArgument.$type = markType(ToolCommandArgument, "ToolCommandArgument");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!ToolCommandArgument.$type) {
            ToolCommandArgument.$type = markType(ToolCommandArgument, "ToolCommandArgument");
        }
        let coll = new SyncableObservableCollection$2(ToolCommandArgument.$type, ToolCommandArgument.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolCommandArgumentCollection = /*@__PURE__*/ (() => {
    class ToolCommandArgumentCollection extends ObservableCollection$1 {
        constructor() {
            super(ToolCommandArgument.$, 0);
        }
    }
    ToolCommandArgumentCollection.$t = /*@__PURE__*/ markType(ToolCommandArgumentCollection, 'ToolCommandArgumentCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(ToolCommandArgument.$));
    return ToolCommandArgumentCollection;
})();

class ContentChildrenManager {
    getChildren(propChildren) {
        let children = [];
        Children.forEach(propChildren, (ch) => {
            let key = this._getPropsKey(ch);
            if (key === undefined) {
                throw new Error("each child must have a unique key or name property");
            }
            if (typeof ch.type === "string") {
                // this is a HTML element, not a React Component
                children.push(cloneElement(ch, {
                    key: key
                }));
            }
            else if (!ch.props.name) {
                children.push(cloneElement(ch, {
                    key: key,
                    name: key,
                    ref: this.getChildRef,
                    originalRef: ch.ref
                }));
            }
            else {
                children.push(cloneElement(ch, {
                    key: key,
                    ref: this.getChildRef,
                    originalRef: ch.ref
                }));
            }
        });
        this._contentChildren = children;
        let prevActual = this._contentChildrenActual;
        this._contentChildrenActual = [];
        let prevMap = this._contentChildrenMap;
        let prevUnresolved = this._contentChildrenUnresolvedSet;
        this._contentChildrenUnresolvedSet = new Set();
        this._contentChildrenMap = new Map();
        this._contentChildrenUnresolved = 0;
        if (this._contentChildren) {
            this._contentChildren.map((ch, i) => {
                let key = this._getPropsKey(ch);
                var unresolved = prevUnresolved.has(key);
                if (prevMap && prevMap.has(key) && !unresolved) {
                    this._contentChildrenActual[i] = prevActual[prevMap.get(key)];
                }
                else {
                    this._contentChildrenActual[i] = null;
                    this._contentChildrenUnresolvedSet.add(key);
                    this._contentChildrenUnresolved++;
                }
                this._contentChildrenMap.set(key, i);
            });
        }
        return children;
    }
    getChildRef(child) {
        //console.log(child);
        this.trackChild(child);
    }
    constructor(getPropsKey, getKey, updateContentChildren) {
        this._contentChildren = null;
        this._contentChildrenActual = null;
        this._contentChildrenMap = null;
        this._contentChildrenUnresolvedSet = null;
        this._contentChildrenUnresolved = 0;
        this.getChildRef = this.getChildRef.bind(this);
        this._getPropsKey = getPropsKey;
        this._getKey = getKey;
        this._updateContentChildren = updateContentChildren;
        this._contentChildrenUnresolvedSet = new Set();
    }
    get contentChildrenActual() {
        return this._contentChildrenActual;
    }
    trackChild(child) {
        var _a;
        if (child === null) {
            return;
        }
        let name = this._getKey(child);
        let index = this._contentChildrenMap.get(name);
        // resolve any refs from content child.
        const contentChild = this._contentChildren[index];
        const ref = (_a = contentChild === null || contentChild === void 0 ? void 0 : contentChild.props) === null || _a === void 0 ? void 0 : _a.originalRef;
        if (ref && typeof ref === 'function') {
            // user has set a callback function.
            ref(child);
        }
        else if (ref && ref.hasOwnProperty('current')) {
            // user has set a useRef object.
            ref.current = child;
        }
        if (this._contentChildrenActual[index] === null) {
            this._contentChildrenActual[index] = child;
            this._contentChildrenUnresolvedSet.delete(name);
            this._contentChildrenUnresolved--;
            if (this._contentChildrenUnresolved <= 0) {
                this._updateContentChildren();
            }
        }
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrTemplateView extends Component {
    constructor(props) {
        super(props);
    }
    render() {
        if (!this.props.template) {
            return null;
        }
        let ele = createElement(this.props.template, { dataContext: this.props.dataContext });
        return ele;
    }
}
class IgrTemplateContainer extends Component {
    constructor(props) {
        super(props);
        this._template = null;
        this._containerTemplate = null;
        this._dataContext = null;
        if (props.owner) {
            this._currentOwner = props.owner;
        }
    }
    componentDidUpdate() {
        if (this.contentReady) {
            this.contentReady();
        }
    }
    render() {
        if (!this._template) {
            return null;
        }
        let ele = createElement(IgrTemplateView, { dataContext: this._dataContext, template: this._template });
        if (this._containerTemplate !== null) {
        }
        else {
            if (this.props.omitContainer) {
                return (createElement(Fragment, null, ele));
            }
            else {
                return (createElement("div", { className: 'ui-template-container', style: { display: "contents" } }, ele));
            }
        }
        return ele;
    }
    get currentOwner() {
        return this._currentOwner;
    }
    shouldComponentUpdate(nextProps, nextState) {
        if (nextProps.owner !== undefined) {
            this._currentOwner = nextProps.owner;
        }
        return true;
    }
    set template(value) {
        this._template = value;
        this.setState({ template: this._template });
    }
    get template() {
        return this._template;
    }
    set containerTemplate(value) {
        this._containerTemplate = value;
        this.setState({ containerTemplate: this._containerTemplate });
    }
    get containerTemplate() {
        return this._containerTemplate;
    }
    set dataContext(value) {
        if (this._dataContext == null && value == null) {
            return;
        }
        this._dataContext = value;
        this.setState({ dataContext: this._dataContext });
    }
    get dataContext() {
        return this._dataContext;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrTemplateContainerModule {
    static register() {
        TypeRegistrar.registerCons("IgrTemplateContainer", IgrTemplateContainer);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrTemplateContent extends Component {
    constructor(props) {
        super(props);
    }
    render() {
        if (!this.props.template) {
            return null;
        }
        let ele = createElement(this.props.template, { dataContext: this.props.dataContext });
        return ele;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrTemplateContentModule {
    static register() {
        TypeRegistrar.registerCons("IgrTemplateContent", IgrTemplateContent);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrChildContent extends Component {
    constructor(props) {
        super(props);
    }
    render() {
        if (this.props.children) {
            return this.props.children;
        }
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrChildContentModule {
    static register() {
        TypeRegistrar.registerCons("IgrChildContent", IgrChildContent);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let requiredStyle = `
    .ig-tooltip-container {
        padding: 5px; 
        padding: var(--tooltip-container-padding, 5px);
        background-color: white; 
        background-color: var(--tooltip-container-background-color, white);
        border-style: solid; 
        border-style: var(--tooltip-container-border-style, solid);
        border-width: 1px; 
        border-width: var(--tooltip-container-border-width, 1px);
        color: ${FontDefaults.tooltipLabelsBrush.fill}; 
        color: var(--tooltip-container-text-color, ${FontDefaults.tooltipLabelsBrush.fill});
        pointer-events: none;
        white-space: nowrap;
        border-color: #666;
        border-color: var(--tooltip-container-border-color, #666);
        font: ${FontDefaults.tooltipLabelsFontSize}px ${FontDefaults.tooltipLabelsFontFamily};
        font: var(--tooltip-container-font, ${FontDefaults.tooltipLabelsFontSize}px ${FontDefaults.tooltipLabelsFontFamily});
    }
`;
let checked = /*@__PURE__*/ new WeakMap();
function ensureCss() {
    if (!document) {
        return;
    }
    if (checked.has(document)) {
        return;
    }
    for (let i = document.head.children.length - 1; i >= 0; i--) {
        let child = document.head.children[i];
        if (child.tagName &&
            child.tagName.toLowerCase() == "style" && child.hasAttribute("data-ig-tooltip-style")) {
            return;
        }
    }
    let style = document.createElement("style");
    style.textContent = requiredStyle;
    style.setAttribute('data-ig-tooltip-style', 'true');
    document.head.appendChild(style);
    checked.set(document, true);
}
class IgrTooltipContainer extends Component {
    constructor(props) {
        super(props);
        this._template = null;
        this._containerTemplate = null;
        this._dataContext = null;
        ensureCss();
        if (props.owner) {
            this._currentOwner = props.owner;
        }
    }
    render() {
        if (!this._template || !this._dataContext || !this.dataContext.item) {
            return null;
        }
        let ele = createElement(IgrTemplateContent, { dataContext: this._dataContext, template: this._template });
        if (this._containerTemplate !== null) {
        }
        else {
            return (createElement("div", { className: 'ig-tooltip-container igr-tooltip-container ig-tooltip-container-background', style: {} }, ele));
        }
        return ele;
    }
    get currentOwner() {
        return this._currentOwner;
    }
    shouldComponentUpdate(nextProps, nextState) {
        if (nextProps.owner !== undefined) {
            this._currentOwner = nextProps.owner;
        }
        return true;
    }
    set template(value) {
        this._template = value;
        this.setState({ template: this._template });
    }
    get template() {
        return this._template;
    }
    set containerTemplate(value) {
        this._containerTemplate = value;
        this.setState({ containerTemplate: this._containerTemplate });
    }
    get containerTemplate() {
        return this._containerTemplate;
    }
    set dataContext(value) {
        if (this._dataContext == null && value == null) {
            return;
        }
        this._dataContext = value;
        this.setState({ dataContext: this._dataContext });
    }
    get dataContext() {
        return this._dataContext;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrTooltipContainerModule {
    static register() {
        TypeRegistrar.registerCons("IgrTooltipContainer", IgrTooltipContainer);
        IgrTemplateContentModule.register();
    }
}

let PlatformConstants = /*@__PURE__*/ (() => {
    class PlatformConstants {
    }
    PlatformConstants.Prefix = "Igr";
    PlatformConstants.Postfix = "";
    return PlatformConstants;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class ReactRenderer {
    constructor(container, document, useDefaultsSource, defaultsSource, portalManager = null) {
        this.container = container;
        this._useDefaultsSource = false;
        this._checkResized = null;
        this._resizeListener = null;
        this._resizeTicking = false;
        this._portalManager = null;
        this._resizeTickId = -1;
        this._discStack = [];
        this._toUnbind = [];
        this._currentFontQuery = null;
        this._document = document;
        this._container = container;
        this._rootElement = container;
        this._rootWrapper = new ReactWrapper(this._rootElement, this);
        this._cssHelper = new ReactCssHelper(this, this._document);
        this._useDefaultsSource = useDefaultsSource;
        this._defaultsSource = defaultsSource;
        this._portalManager = portalManager;
        if (this._portalManager) {
            this._portalManager.renderer = this;
        }
    }
    addSizeWatcher(onResized) {
        let previousWidth = this._rootElement.offsetWidth;
        let previousHeight = this._rootElement.offsetHeight;
        let previousRatio = window.devicePixelRatio;
        if (this._checkResized == null) {
            this._checkResized = () => {
                let currWidth = this._rootElement.offsetWidth;
                let currHeight = this._rootElement.offsetHeight;
                let currRatio = window.devicePixelRatio;
                let changed = false;
                if (previousWidth != currWidth ||
                    previousHeight != currHeight ||
                    previousRatio != currRatio) {
                    changed = true;
                }
                previousWidth = currWidth;
                previousHeight = currHeight;
                previousRatio = currRatio;
                if (changed) {
                    onResized();
                }
            };
        }
        this._resizeListener = this.globalListen("window", "resize", (ev) => this._checkResized());
        let self = this;
        this._resizeTicking = true;
        function resizeTick() {
            self._resizeTickId = -1;
            if (self._resizeTicking) {
                self._checkResized();
                self._resizeTickId = self.setTimeout(resizeTick, 100);
            }
        }
        this._resizeTickId = this.setTimeout(resizeTick, 100);
    }
    destroy() {
        for (let i = 0; i < this._toUnbind.length; i++) {
            this._toUnbind[i]();
        }
        this._toUnbind = [];
        this.removeSizeWatcher();
        this._rootWrapper.destroy();
        this._rootWrapper = null;
        this._rootElement = null;
    }
    removeSizeWatcher() {
        this._resizeTicking = false;
        if (this._resizeTickId != -1) {
            window.clearTimeout(this._resizeTickId);
            this._resizeTickId = -1;
        }
        if (this._resizeListener != null) {
            this._resizeListener();
            this._resizeListener = null;
        }
    }
    updateRoot(root) {
        this._rootWrapper = root;
        this._rootElement = root.getNativeElement();
    }
    withRenderer(act) {
        act(this);
    }
    supportsAnimation() {
        return true;
    }
    getRequestAnimationFrame() {
        let ret = (act) => {
            requestAnimationFrame(act);
        };
        return ret;
    }
    setTimeout(act, millisecondsDelay) {
        let val;
        val = window.setTimeout(act, millisecondsDelay);
        return val;
    }
    clearTimeout(timerId) {
        window.clearTimeout(timerId);
    }
    get rootWrapper() {
        return this._rootWrapper;
    }
    querySelector(selector) {
        let wrapper = null;
        this.withRenderer((ren) => {
            let ele = this.rootWrapper.getNativeElement().querySelector(selector);
            if (ele === null) {
                return null;
            }
            wrapper = new ReactWrapper(ele, ren);
        });
        return wrapper;
    }
    getWrapper(ele) {
        if (!ele) {
            return null;
        }
        let wrapper = null;
        this.withRenderer((ren) => {
            wrapper = new ReactWrapper(ele, ren);
        });
        return wrapper;
    }
    getResourceString(resourceId) {
        // check if the resource culture is available.  It is a combination of the bundle ID and culture ID
        let grouping = this._resourceBundleId + "-" + this._cultureId;
        let isRegistered = Localization.isRegistered(grouping);
        if (isRegistered) {
            return Localization.getString(grouping, resourceId);
        }
        else {
            return "";
        }
    }
    setResourceBundleId(bundle) {
        this._resourceBundleId = bundle;
    }
    setCultureId(culture) {
        this._cultureId = culture;
    }
    append(child) {
        this._rootWrapper.append(child);
        return this;
    }
    appendToBody(element) {
        if (this._document !== null && this._document.body !== null) {
            this._document.body.appendChild(element.getNativeElement());
        }
    }
    createElement(elementName) {
        let ele;
        this.withRenderer((ren) => {
            ele = this._document.createElement(elementName);
        });
        let wrap = new ReactWrapper(ele, this);
        return wrap;
    }
    createElementNS(elementName, ns) {
        let ele;
        this.withRenderer((ren) => {
            ele = this._document.createElementNS(ns, elementName);
        });
        let wrap = new ReactWrapper(ele, this);
        return wrap;
    }
    endCSSQuery() {
        this._currentFontQuery = null;
        if (!this.hasBody()) {
            return;
        }
        if (this._discStack.length > 0) {
            var toRemove = this._discStack.pop();
            toRemove.remove();
        }
    }
    expandTemplate(template, args) {
        throw new Error("not implemented");
    }
    get2DCanvasContext(canvas) {
        let context = null;
        this.withRenderer((ren) => {
            var canv = (canvas.getNativeElement());
            context = canv.getContext("2d");
        });
        return context;
    }
    get isComputedFontQuery() {
        return this._currentFontQuery != null &&
            this.hasBody();
    }
    getCssDefaultPropertyValue(className, propertyName) {
        if (this._useDefaultsSource && !this.isComputedFontQuery) {
            let c = this._defaultsSource[className];
            if (className == "" || className == null) {
                c = this._defaultsSource;
            }
            if (c === undefined) {
                return null;
            }
            let v = c[propertyName];
            if (v === undefined) {
                return null;
            }
            return v;
        }
        return this._cssHelper.getPropertyValue(this.getCurrentDiscovery(), className, propertyName);
    }
    getCssDefaultValuesForClassCollection(classPrefix, propertyNames) {
        if (this._useDefaultsSource) {
            let ret = [];
            for (let k in this._defaultsSource) {
                if (k.indexOf(classPrefix) === 0) {
                    let subRet = [];
                    ret.push(subRet);
                    for (let i = 0; i < propertyNames.length; i++) {
                        let v = this._defaultsSource[k][propertyNames[i]];
                        if (v === undefined) {
                            subRet.push(null);
                        }
                        else {
                            subRet.push(v);
                        }
                    }
                }
            }
            return ret;
        }
        return this._cssHelper.getValuesForClassCollection(this.getCurrentDiscovery(), classPrefix, propertyNames);
    }
    getDefaultFontHeight() {
        if (this._defaultsSource["default-font-height"] !== undefined) {
            return +this._defaultsSource["default-font-height"];
        }
        return 16;
    }
    getHeightForFontString(fontString, text, useOffsetHeight) {
        if (this._rootWrapper.getNativeElement() == null) {
            //TODO: some voodoo here.
            return 12;
        }
        this.startCSSQuery();
        let disc = this.getCurrentDiscovery();
        if (disc == null || !this.hasWindow) {
            return this.getDefaultFontHeight();
        }
        if (disc.getNativeElement().parentElement) {
            disc.getNativeElement().parentElement.removeChild(disc.getNativeElement());
        }
        disc.setStyleProperty("position", "absolute");
        disc.setStyleProperty("visibility", "hidden");
        disc.setStyleProperty("font", fontString);
        document.body.appendChild(disc.getNativeElement());
        let span;
        this.withRenderer((ren) => {
            span = ren.createElement("span");
        });
        var spanWrap = new ReactWrapper(span, this);
        this.getCurrentDiscovery().append(spanWrap);
        spanWrap.setText(text);
        var height;
        if (useOffsetHeight) {
            var offHeight = spanWrap.getNativeElement().offsetHeight;
            height = offHeight;
        }
        else {
            height = spanWrap.getNativeElement().height();
        }
        if (height == 0) {
            //HACK: HACK! HACK! HACK!
            height = this.getDefaultFontHeight();
        }
        //console.log("font height: " + height);
        document.body.removeChild(disc.getNativeElement());
        this.endCSSQuery();
        return height;
    }
    getSubRenderer(root) {
        var elem = root;
        elem = elem.getNativeElement();
        return new ReactRenderer(elem, this._document, this._useDefaultsSource, this._defaultsSource, this._portalManager);
    }
    listen(element, eventName, handler) {
        let retVal = null;
        if (element == "window") {
            element = window;
        }
        if (element == "document") {
            element = document;
        }
        var $self = this;
        var ret = element.addEventListener(eventName, handler);
        var self = this;
        retVal = function () {
            var ind = self._toUnbind.indexOf(retVal);
            if (ind >= 0) {
                self._toUnbind.splice(ind, 1);
            }
            element.removeEventListener(eventName, handler);
            handler = null;
        };
        this._toUnbind.push(retVal);
        return retVal;
    }
    runInMainZone(action) {
        action();
    }
    globalListen(element, eventName, handler) {
        let retVal = null;
        //this._ngZone.runOutsideAngular(() => {
        var $self = this;
        var a = function (e) {
            var inner = {};
            //TODO: normalize here?
            inner.originalEvent = e;
            inner.altKey = e.altKey;
            inner.button = e.button;
            inner.ctrlKey = e.ctrlKey;
            inner.offsetX = e.offsetX;
            inner.offsetY = e.offsetY;
            inner.pageX = e.pageX;
            inner.pageY = e.pageY;
            if (e.touches && e.touches.length > 0) {
                inner.pageX = e.touches[0].pageX;
                inner.pageY = e.touches[0].pageY;
            }
            inner.shiftKey = e.shiftKey;
            inner.which = e.which;
            inner.preventDefault = function () {
                e.preventDefault();
            };
            inner.stopPropagation = function () {
                e.stopPropagation();
            };
            //console.log(e);
            handler(inner);
        };
        var ret = this.listen(element, eventName, a);
        var self = this;
        retVal = function () {
            var ind = self._toUnbind.indexOf(retVal);
            if (ind >= 0) {
                self._toUnbind.splice(ind, 1);
            }
            ret();
            a = null;
        };
        this._toUnbind.push(retVal);
        //});
        return retVal;
    }
    hasBody() {
        return this._document !== null && this._document.body !== null;
    }
    hasWindow() {
        //todo: hmmm
        return true;
    }
    getCurrentDiscovery() {
        if (this._discStack.length <= 0) {
            return null;
        }
        return this._discStack[this._discStack.length - 1];
    }
    setCssQueryFontString(fontString) {
        if (this._useDefaultsSource) {
            this._currentFontQuery = fontString;
        }
        if (!document.body.contains(this.getCurrentDiscovery().getNativeElement())) {
            this.getCurrentDiscovery().remove();
            this.appendToBody(this.getCurrentDiscovery());
        }
        this.getCurrentDiscovery().setStyleProperty("font", fontString);
    }
    startCSSQuery() {
        if (!this.hasBody()) {
            return;
        }
        var disc = this._cssHelper.getDiscoveryElement(this._rootElement);
        this._discStack.push(disc);
        this._rootWrapper.append(disc);
    }
    supportsDOMEvents() {
        //todo: hmmm.
        return true;
    }
    getPortal(hostElement, elementTag, portalCallback, isContentPortal) {
        if (this._portalManager) {
            this._portalManager.getPortal(hostElement, elementTag, portalCallback, isContentPortal);
        }
    }
    getExternal(internalComponent, styleSourceElement, optionalParent = null) {
        if (internalComponent.externalObject) {
            return internalComponent.externalObject;
        }
        let ext = null;
        if (!internalComponent.$type) {
            return null;
        }
        let name = internalComponent.$type.name;
        let externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        ext = TypeRegistrar.create(externalName);
        if (ext) {
            ext._implementation = internalComponent;
            internalComponent.externalObject = ext;
        }
        if (styleSourceElement) {
            if (ext._styling) {
                ext._styling(styleSourceElement.getNativeElement(), ext, optionalParent);
            }
        }
        return ext;
    }
}
class ReactWrapper {
    constructor(element, renderer) {
        this.renderer = renderer;
        this._toUnbind = [];
        this._attrCache = new Map();
        this._styleCache = new Map();
        this._innerText = undefined;
        if (element && element.getNativeElement) {
            element = element.getNativeElement();
        }
        this.ele = element;
        this._toUnbind = [];
    }
    destroy() {
        this.unlistenAll();
        this.ele = null;
    }
    withRenderer(act) {
        act(this.renderer);
    }
    addClass(className) {
        if (className == null || className.length == 0) {
            return this;
        }
        this.withRenderer((ren) => {
            className.split(" ").forEach((item) => this.ele.classList.add(item));
        });
        return this;
    }
    append(child) {
        this.withRenderer((ren) => {
            this.ele.appendChild(child.getNativeElement());
        });
        return this;
    }
    getAttribute(propertyName) {
        if (this._attrCache.has(propertyName)) {
            return this._attrCache.get(propertyName);
        }
        return null;
    }
    setAttribute(propertyName, value) {
        this._attrCache.set(propertyName, value);
        this.withRenderer((ren) => {
            this.ele.setAttribute(propertyName, value);
        });
        return this;
    }
    before(child) {
        if (this.ele.parentElement) {
            this.ele.parentElement.insertBefore(child.getNativeElement(), this.ele);
            // this.insertBefore(child.getNativeElement());
        }
        return this;
    }
    clone() {
        return new ReactWrapper(this.getNativeElement().cloneNode(true), this.renderer);
    }
    getStyleProperty(propertyName) {
        if (this.getNativeElement() !== null) {
            if (getComputedStyle !== undefined) {
                var computed = getComputedStyle(this.getNativeElement());
                //console.log("getting computed value for: " + propertyName + ": " + computed[propertyName]);
                return computed[propertyName];
            }
        }
        if (this._styleCache.has(propertyName)) {
            return this._styleCache.get(propertyName);
        }
        return null;
    }
    setStyleProperty(propertyName, value) {
        this._styleCache.set(propertyName, value);
        this.withRenderer((ren) => {
            this.ele.style[propertyName] = value;
        });
        return this;
    }
    findByClass(className) {
        if (className.substring(0, 1) == '.') {
            className = className.substring(1);
        }
        let ret = this.ele.getElementsByClassName(className);
        let retVal = [];
        retVal.length = ret.length;
        for (var i = 0; i < ret.length; i++) {
            retVal[i] = new ReactWrapper(ret[i], this.renderer);
        }
        return retVal;
    }
    focus(preventScroll) {
        if (this.getNativeElement() !== null && this.getNativeElement().focus !== undefined) {
            if (preventScroll) {
                this.getNativeElement().focus({ preventScroll: true });
            }
            else {
                this.getNativeElement().focus();
            }
        }
        return this;
    }
    getChildAt(i) {
        let child = this.ele.children[i];
        return new ReactWrapper(child, this.renderer);
    }
    getChildCount() {
        return this.ele.children.length;
    }
    getNativeElement() {
        let nativeElement = null;
        this.withRenderer((ren) => {
            if (this.ele == null) {
                nativeElement = null;
                return;
            }
            if (this.ele.getNativeElement == undefined) {
                nativeElement = this.ele;
                return nativeElement;
            }
            nativeElement = (this.ele.getNativeElement());
        });
        return nativeElement;
    }
    height() {
        var ret = this.getStyleProperty("height");
        if (ret == null) {
            //todo: some voodoo here.
            return 500;
        }
        let val = parseFloat(ret.replace("px", ""));
        if (isNaN(val)) {
            return 0;
        }
        return val;
    }
    hide() {
        this.setStyleProperty("display", "none");
        return this;
    }
    listen(eventName, handler) {
        let retVal = null;
        //this.ngZone.runOutsideAngular(() => {
        var $self = this;
        var a = function (e) {
            var inner = {};
            //TODO: normalize here?
            inner.originalEvent = e;
            inner.altKey = e.altKey;
            inner.button = e.button;
            inner.ctrlKey = e.ctrlKey;
            inner.offsetX = e.offsetX;
            inner.offsetY = e.offsetY;
            inner.pageX = e.pageX;
            inner.pageY = e.pageY;
            if (e.touches && e.touches.length > 0) {
                inner.pageX = e.touches[0].pageX;
                inner.pageY = e.touches[0].pageY;
            }
            inner.shiftKey = e.shiftKey;
            inner.which = e.which;
            inner.preventDefault = function () {
                e.preventDefault();
            };
            inner.stopPropagation = function () {
                e.stopPropagation();
            };
            //console.log(e);
            handler(inner);
        };
        var ret = this.renderer.listen(this.ele, eventName, a);
        var self = this;
        retVal = function () {
            var ind = self._toUnbind.indexOf(retVal);
            if (ind >= 0) {
                self._toUnbind.splice(ind, 1);
            }
            ret();
            a = null;
        };
        this._toUnbind.push(retVal);
        //});
        return retVal;
    }
    getOffsetHelper(ele) {
        var clientRect = ele.getBoundingClientRect();
        return {
            top: clientRect.top + window.pageYOffset,
            left: clientRect.left + window.pageXOffset
        };
    }
    getOffset() {
        return this.getOffsetHelper(this.getNativeElement());
    }
    setOffset(x, y) {
        let par = this.getNativeElement().offsetParent || this.getNativeElement().parentElement;
        let parentOffset = this.getOffsetHelper(par);
        return this.setRawPosition(x - parentOffset.left, y - parentOffset.top);
        //return this;
    }
    outerHeight() {
        return this.getProperty("offsetHeight");
    }
    outerHeightWithMargin() {
        let height = this.outerHeight();
        height += parseInt(this.getStyleProperty("marginTop"));
        height += parseInt(this.getStyleProperty("marginBottom"));
        return height;
    }
    outerWidth() {
        return this.getProperty("offsetWidth");
    }
    outerWidthWithMargin() {
        let width = this.outerWidth();
        width += parseInt(this.getStyleProperty("marginLeft"));
        width += parseInt(this.getStyleProperty("marginRight"));
        return width;
    }
    getProperty(propertyName) {
        let native = this.getNativeElement();
        return native[propertyName];
    }
    setProperty(propertyName, value) {
        this.withRenderer((ren) => {
            this.ele[propertyName] = value;
        });
        return this;
    }
    remove() {
        this.withRenderer((ren) => {
            let ele = this.getNativeElement();
            if (ele.parentElement != null) {
                this.ele.parentElement.removeChild(ele);
            }
            //ren.detachView([this.getNativeElement()]);
        });
        return this;
    }
    removeChild(child) {
        this.withRenderer((ren) => {
            this.ele.removeChild(child.getNativeElement());
            //ren.detachView([child.getNativeElement()]);
        });
        return this;
    }
    removeChildren() {
        for (let i = this.getChildCount() - 1; i >= 0; i--) {
            this.removeChild(this.getChildAt(i));
        }
        return this;
    }
    removeClass(className) {
        if (className == null || className.length == 0) {
            return this;
        }
        this.withRenderer((ren) => {
            className.split(" ").forEach((item) => this.ele.classList.remove(item));
        });
        return this;
    }
    setRawStyleProperty(propertyName, value) {
        //this.withRenderer((ren) => {
        this.ele.style[propertyName] = value;
        //})
        return this;
    }
    setRawPosition(x, y) {
        this.ele.style.left = x + "px";
        this.ele.style.top = y + "px";
        return this;
    }
    setRawXPosition(x) {
        this.ele.style.left = x + "px";
        return this;
    }
    setRawYPosition(y) {
        this.ele.style.top = y + "px";
        return this;
    }
    setRawSize(width, height) {
        this.ele.style.width = width + "px";
        this.ele.style.height = height + "px";
        return this;
    }
    show() {
        this.setStyleProperty("display", "");
        return this;
    }
    getText() {
        if (this._innerText != undefined) {
            return this._innerText;
        }
        return this.getNativeElement().innerText;
    }
    setText(value) {
        this._innerText = value;
        this.withRenderer((ren) => {
            //workaround warning:
            this.getNativeElement().innerText = value;
            //ren.setText(this.ele, value);
        });
        return this;
    }
    setRawText(value) {
        this._innerText = value;
        this.ele.textContent = value;
        return this;
    }
    unlistenAll() {
        var toUnbind = [];
        for (var i = 0; i < this._toUnbind.length; i++) {
            toUnbind.push(this._toUnbind[i]);
        }
        for (var i = 0; i < toUnbind.length; i++) {
            toUnbind[i]();
        }
        this._toUnbind.length = 0;
        return this;
    }
    width() {
        var ret = this.getStyleProperty("width");
        if (ret == null) {
            //todo: some voodoo here.
            return 500;
        }
        let val = parseFloat(ret.replace("px", ""));
        if (isNaN(val)) {
            return 0;
        }
        return val;
    }
    parent() {
        return this.ele == null || this.ele.parentElement == null ? null :
            new ReactWrapper(this.ele.parentElement, this.renderer);
    }
    querySelectorAll(selector) {
        let elements = this.ele.querySelectorAll(selector);
        let result = [];
        for (let ii = 0; ii < elements.length; ii++) {
            result.push(new ReactWrapper(elements[ii], this.renderer));
        }
        return result;
    }
}
class ReactCssHelper {
    getDiscoveryElement(container) {
        //console.log(container);
        var ele = this.renderer.createElement("fakediscoveryelement");
        var wrapper = new ReactWrapper(ele, this.renderer);
        wrapper.setStyleProperty("box-sizing", "content-box");
        return wrapper;
    }
    constructor(renderer, document) {
        this.renderer = renderer;
        this.document = document;
    }
    getPropertyValue(discoveryElement, className, propertyName) {
        //console.log("fetching: " + className + ", prop: " + propertyName);
        var ret = CssHelper.getPropertyValue1(discoveryElement, className, propertyName);
        //console.log("for: " + className + ", prop: " + propertyName + " value: " + ret);
        return ret;
    }
    getValuesForClassCollection(discoveryElement, classPrefix, propertyNames) {
        var prop = new List$1(String_$type, 0);
        for (var i = 0; i < propertyNames.length; i++) {
            prop.add(propertyNames[i]);
        }
        var ret = CssHelper.getValuesForClassCollection(discoveryElement, classPrefix, prop);
        var retVal = new Array(ret.count);
        for (var i1 = 0; i1 < ret.count; i1++) {
            retVal[i1] = new Array(ret._inner[i1].count);
            for (var j = 0; j < ret._inner[i1].count; j++) {
                retVal[i1][j] = ret._inner[i1]._inner[j];
            }
        }
        return retVal;
    }
}
class PortalManager {
    constructor(id, requestRender) {
        this.disableContentPortal = false;
        this._portals = [];
        this._portalsMap = new Map();
        this._id = null;
        this._currId = 0;
        this._requestRender = requestRender;
        this._onPortalRef = this._onPortalRef.bind(this);
        this._id = id;
    }
    onRender(children) {
        if (this._portals && this._portals.length > 0) {
            //children = React.Children.toArray(this.props.children);
            for (let i = 0; i < this._portals.length; i++) {
                let p = this._portals[i];
                if (p.isContentPortal && !this.disableContentPortal) {
                    var mine = children.slice(0);
                    children.length = 0;
                    var n = p._createPortal(mine);
                    p._nativePortal = n;
                }
                else {
                    var n = p._createPortal(null);
                    p._nativePortal = n;
                }
                children.push(p._nativePortal);
            }
        }
    }
    getId() {
        return this._id + "__" + (this._currId++).toString();
    }
    getPortal(hostElement, elementTag, portalCallback, isContentPortal) {
        const existingPortal = this._portals.find(x => x.portalContainer.getNativeElement() === hostElement.getNativeElement());
        if (existingPortal) {
            return;
        }
        let portal = new ReactDomPortal(this, hostElement, elementTag, portalCallback, this.getId(), this._onPortalRef, isContentPortal);
        this._portals.push(portal);
        this._portalsMap.set(portal._portalId, portal);
        this._requestRender();
    }
    _onPortalRef(ele) {
        if (ele != null) {
            var key = ele.props.id;
            if (this._portalsMap.has(key)) {
                var p = this._portalsMap.get(key);
                p._onComponentProvided(ele);
            }
        }
    }
    _destroy(portal) {
        let ind = this._portals.indexOf(portal);
        this._portalsMap.delete(portal._portalId);
        this._portals.splice(ind, 1);
        this._requestRender();
    }
}
class ReactDomPortal {
    destroy() {
        this._owner._destroy(this);
    }
    _onComponentProvided(ele) {
        var oldValue = this.componentRef;
        this.componentRef = ele;
        if (oldValue !== this.componentRef) {
            this._portalCallback(this);
        }
    }
    toPascal(name) {
        var val = fromSpinal(name);
        return val.substr(0, 1).toUpperCase() + val.substr(1);
    }
    createElementFromTag(elementTag, portalId, portalRef, children) {
        if (elementTag.indexOf("-") >= 0) {
            elementTag = this.toPascal(elementTag);
        }
        var name = "Igr" + elementTag;
        var ele = TypeRegistrar.get(name);
        var rEle = createElement(ele, {
            ref: portalRef,
            key: portalId,
            id: portalId,
            children: children
        });
        return rEle;
    }
    _createPortal(children) {
        var reactEle = this.createElementFromTag(this._elementTag, this._portalId, this._portalRef, children);
        this._nativePortal = createPortal(reactEle, this.portalContainer.getNativeElement(), this._portalId);
        return this._nativePortal;
    }
    constructor(portalManager, hostElement, elementTag, portalCallback, portalId, portalRef, isContentPortal) {
        this._portalRef = null;
        this.portalContainer = hostElement;
        this._elementTag = elementTag;
        this._portalCallback = portalCallback;
        this._portalId = portalId;
        this.isContentPortal = isContentPortal;
        this._portalRef = portalRef;
        this._owner = portalManager;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFormattable_$type = /*@__PURE__*/ new Type(null, 'IFormattable');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IndexOutOfRangeException = /*@__PURE__*/ (() => {
    class IndexOutOfRangeException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
    }
    IndexOutOfRangeException.$t = /*@__PURE__*/ markType(IndexOutOfRangeException, 'IndexOutOfRangeException', BaseError.$);
    return IndexOutOfRangeException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Guid = /*@__PURE__*/ (() => {
    class Guid extends ValueType {
        constructor(a, ..._rest) {
            super();
            this.ae = 0;
            this.ac = 0;
            this.ad = 0;
            this.r = 0;
            this.s = 0;
            this.t = 0;
            this.u = 0;
            this.v = 0;
            this.w = 0;
            this.x = 0;
            this.y = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        this.ae = (((c[3] << 24) | (c[2] << 16)) | (c[1] << 8)) | c[0];
                        this.ac = ((c[5] << 8) | c[4]);
                        this.ad = ((c[7] << 8) | c[6]);
                        this.r = c[8];
                        this.s = c[9];
                        this.t = c[10];
                        this.u = c[11];
                        this.v = c[12];
                        this.w = c[13];
                        this.x = c[14];
                        this.y = c[15];
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        let h = _rest[5];
                        let i = _rest[6];
                        let j = _rest[7];
                        let k = _rest[8];
                        let l = _rest[9];
                        let m = _rest[10];
                        this.ae = c;
                        this.ac = d;
                        this.ad = e;
                        this.r = f;
                        this.s = g;
                        this.t = h;
                        this.u = i;
                        this.v = j;
                        this.w = k;
                        this.x = l;
                        this.y = m;
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        if (c == null) {
                            throw new ArgumentNullException(0, "g");
                        }
                        let d = new Guid_GuidResult();
                        d.i(1);
                        if (!((() => { let e = Guid.n(c, 15, d); d = e.p2; return e.ret; })())) {
                            throw d.a();
                        }
                        this.ae = d.c.ae;
                        this.ac = d.c.ac;
                        this.ad = d.c.ad;
                        this.r = d.c.r;
                        this.s = d.c.s;
                        this.t = d.c.t;
                        this.u = d.c.u;
                        this.v = d.c.v;
                        this.w = d.c.w;
                        this.x = d.c.x;
                        this.y = d.c.y;
                    }
                    break;
            }
        }
        compareTo(a) {
            let b = this.ae - a.ae;
            if (b != 0) {
                return b;
            }
            b = this.ac - a.ac;
            if (b != 0) {
                return b;
            }
            b = this.ad - a.ad;
            if (b != 0) {
                return b;
            }
            b = this.r - a.r;
            if (b != 0) {
                return b;
            }
            b = this.s - a.s;
            if (b != 0) {
                return b;
            }
            b = this.t - a.t;
            if (b != 0) {
                return b;
            }
            b = this.u - a.u;
            if (b != 0) {
                return b;
            }
            b = this.v - a.v;
            if (b != 0) {
                return b;
            }
            b = this.w - a.w;
            if (b != 0) {
                return b;
            }
            b = this.x - a.x;
            if (b != 0) {
                return b;
            }
            b = this.y - a.y;
            return b;
        }
        compareToObject(a) {
            if (typeCast(Guid.$, a) !== null) {
                return this.compareTo(a);
            }
            return 1;
        }
        equals(a) {
            return Guid.l_op_Equality(this, a);
        }
        static newGuid() {
            return new Guid(3, (createGuid()));
        }
        toByteArray() {
            return [this.ae, (this.ae >> 8), (this.ae >> 16), (this.ae >> 24), this.ac, (this.ac >> 8), this.ad, (this.ad >> 8), this.r, this.s, this.t, this.u, this.v, this.w, this.x, this.y];
        }
        toString() {
            return this.toString1("D", null);
        }
        toString2(a) {
            return this.toString1(a, null);
        }
        toString1(a, b) {
            let c;
            if ((a == null) || (a.length == 0)) {
                a = "D";
            }
            let d = 0;
            let e = 38;
            let f = true;
            let g = false;
            if (a.length != 1) {
                throw new FormatException(0);
            }
            let h = a.charAt(0);
            switch (h) {
                case 'D':
                case 'd':
                    c = new Array(36);
                    e = 36;
                    break;
                case 'N':
                case 'n':
                    c = new Array(32);
                    e = 32;
                    f = false;
                    break;
                case 'B':
                case 'b':
                    c = new Array(38);
                    c[d++] = '{';
                    c[37] = '}';
                    break;
                case 'P':
                case 'p':
                    c = new Array(38);
                    c[d++] = '(';
                    c[37] = ')';
                    break;
                default:
                    if ((h != 'X') && (h != 'x')) {
                        throw new FormatException(0);
                    }
                    c = new Array(68);
                    c[d++] = '{';
                    c[67] = '}';
                    e = 68;
                    f = false;
                    g = true;
                    break;
            }
            if (g) {
                c[d++] = '0';
                c[d++] = 'x';
                d = Guid.af(c, d, this.ae >> 24, this.ae >> 16);
                d = Guid.af(c, d, this.ae >> 8, this.ae);
                c[d++] = ',';
                c[d++] = '0';
                c[d++] = 'x';
                d = Guid.af(c, d, this.ac >> 8, this.ac);
                c[d++] = ',';
                c[d++] = '0';
                c[d++] = 'x';
                d = Guid.af(c, d, this.ad >> 8, this.ad);
                c[d++] = ',';
                c[d++] = '{';
                d = Guid.ag(c, d, this.r, this.s, true);
                c[d++] = ',';
                d = Guid.ag(c, d, this.t, this.u, true);
                c[d++] = ',';
                d = Guid.ag(c, d, this.v, this.w, true);
                c[d++] = ',';
                d = Guid.ag(c, d, this.x, this.y, true);
                c[d++] = '}';
            }
            else {
                d = Guid.af(c, d, this.ae >> 24, this.ae >> 16);
                d = Guid.af(c, d, this.ae >> 8, this.ae);
                if (f) {
                    c[d++] = '-';
                }
                d = Guid.af(c, d, this.ac >> 8, this.ac);
                if (f) {
                    c[d++] = '-';
                }
                d = Guid.af(c, d, this.ad >> 8, this.ad);
                if (f) {
                    c[d++] = '-';
                }
                d = Guid.af(c, d, this.r, this.s);
                if (f) {
                    c[d++] = '-';
                }
                d = Guid.af(c, d, this.t, this.u);
                d = Guid.af(c, d, this.v, this.w);
                d = Guid.af(c, d, this.x, this.y);
            }
            return stringCreateFromCharArraySlice(c, 0, e);
        }
        static af(a, b, c, d) {
            return Guid.ag(a, b, c, d, false);
        }
        static ag(a, b, c, d, e) {
            if (e) {
                a[b++] = '0';
                a[b++] = 'x';
            }
            a[b++] = Guid.z(c >> 4);
            a[b++] = Guid.z(c);
            if (e) {
                a[b++] = ',';
                a[b++] = '0';
                a[b++] = 'x';
            }
            a[b++] = Guid.z(d >> 4);
            a[b++] = Guid.z(d);
            return b;
        }
        static z(a) {
            a &= 15;
            return ((a > 9) ? String.fromCharCode(((a - 10) + 97)) : String.fromCharCode((a + 48)));
        }
        static tryParse(a, b) {
            let c = new Guid_GuidResult();
            c.i(0);
            if (((() => { let d = Guid.n(a, 15, c); c = d.p2; return d.ret; })())) {
                b = c.c;
                return {
                    ret: true,
                    p1: b
                };
            }
            b = Guid.empty;
            return {
                ret: false,
                p1: b
            };
        }
        static n(a, b, c) {
            if (a == null) {
                c.k(2, "Format_GuidUnrecognized");
                return {
                    ret: false,
                    p2: c
                };
            }
            let d = a.trim();
            if (d.length == 0) {
                c.k(2, "Format_GuidUnrecognized");
                return {
                    ret: false,
                    p2: c
                };
            }
            let e = d.indexOf('-', 0) >= 0;
            if (e) {
                if ((b & (64 | 4)) == 0) {
                    c.k(2, "Format_GuidUnrecognized");
                    return {
                        ret: false,
                        p2: c
                    };
                }
            }
            else if ((b & 64) != 0) {
                c.k(2, "Format_GuidUnrecognized");
                return {
                    ret: false,
                    p2: c
                };
            }
            let f = d.indexOf('{', 0) >= 0;
            if (f) {
                if ((b & (32 | 2)) == 0) {
                    c.k(2, "Format_GuidUnrecognized");
                    return {
                        ret: false,
                        p2: c
                    };
                }
            }
            else if ((b & 32) != 0) {
                c.k(2, "Format_GuidUnrecognized");
                return {
                    ret: false,
                    p2: c
                };
            }
            if (d.indexOf('(', 0) >= 0) {
                if ((b & (16 | 1)) == 0) {
                    c.k(2, "Format_GuidUnrecognized");
                    return {
                        ret: false,
                        p2: c
                    };
                }
            }
            else if ((b & 16) != 0) {
                c.k(2, "Format_GuidUnrecognized");
                return {
                    ret: false,
                    p2: c
                };
            }
            try {
                if (e) {
                    return {
                        ret: ((() => { let g = Guid.o(d, c); c = g.p1; return g.ret; })()),
                        p2: c
                    };
                }
                if (f) {
                    return {
                        ret: ((() => { let g = Guid.p(d, c); c = g.p1; return g.ret; })()),
                        p2: c
                    };
                }
                return {
                    ret: ((() => { let g = Guid.q(d, c); c = g.p1; return g.ret; })()),
                    p2: c
                };
            }
            catch (g) {
                let h = typeCast(IndexOutOfRangeException.$, g);
                if (h != null) {
                    c.m(5, "Format_GuidUnrecognized", null, null, h);
                    return {
                        ret: false,
                        p2: c
                    };
                }
                let i = typeCast(ArgumentException.$, g);
                if (i != null) {
                    c.m(5, "Format_GuidUnrecognized", null, null, i);
                    return {
                        ret: false,
                        p2: c
                    };
                }
                throw g;
            }
        }
        static o(a, b) {
            let c;
            let d;
            let e;
            let f = 0;
            let g = 0;
            if (a.charAt(0) == '{') {
                if ((a.length != 38) || (a.charAt(37) != '}')) {
                    b.k(2, "Format_GuidInvLen");
                    return {
                        ret: false,
                        p1: b
                    };
                }
                f = 1;
            }
            else if (a.charAt(0) == '(') {
                if ((a.length != 38) || (a.charAt(37) != ')')) {
                    b.k(2, "Format_GuidInvLen");
                    return {
                        ret: false,
                        p1: b
                    };
                }
                f = 1;
            }
            else if (a.length != 36) {
                b.k(2, "Format_GuidInvLen");
                return {
                    ret: false,
                    p1: b
                };
            }
            if (((a.charAt(8 + f) != '-') || (a.charAt(13 + f) != '-')) || ((a.charAt(18 + f) != '-') || (a.charAt(23 + f) != '-'))) {
                b.k(2, "Format_GuidDashes");
                return {
                    ret: false,
                    p1: b
                };
            }
            g = f;
            if (!((() => { let h = Guid.j(a, g, 8, 8192, c, b); g = h.p1; c = h.p4; b = h.p5; return h.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            b.c.ae = c;
            g++;
            if (!((() => { let h = Guid.j(a, g, 4, 8192, c, b); g = h.p1; c = h.p4; b = h.p5; return h.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            b.c.ac = c;
            g++;
            if (!((() => { let h = Guid.j(a, g, 4, 8192, c, b); g = h.p1; c = h.p4; b = h.p5; return h.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            b.c.ad = c;
            g++;
            if (!((() => { let h = Guid.j(a, g, 4, 8192, c, b); g = h.p1; c = h.p4; b = h.p5; return h.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            g++;
            f = g;
            if (!((() => { let h = Guid.j(a, g, 4, 8192, d, b); g = h.p1; d = h.p4; b = h.p5; return h.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            if (!((() => { let h = Guid.j(a, g, 8, 8192, e, b); g = h.p1; e = h.p4; b = h.p5; return h.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            b.c.r = ((c >> 8) & 255);
            b.c.s = (c & 255);
            c = d;
            b.c.t = ((c >> 8) & 255);
            b.c.u = (c & 255);
            c = e;
            b.c.v = ((c >> 24) & 255);
            b.c.w = ((c >> 16) & 255);
            b.c.x = ((c >> 8) & 255);
            b.c.y = (c & 255);
            return {
                ret: true,
                p1: b
            };
        }
        static ah(a) {
            let b = 0;
            let c = new Array(a.length);
            for (let d = 0; d < a.length; d++) {
                let e = a.charAt(d);
                if (!/\s/i.test(e)) {
                    c[b++] = e;
                }
            }
            return stringCreateFromCharArraySlice(c, 0, b);
        }
        static p(a, b) {
            let c = 0;
            let d = 0;
            a = Guid.ah(a);
            if (stringIsNullOrEmpty(a) || (a.charAt(0) != '{')) {
                b.k(2, "Format_GuidBrace");
                return {
                    ret: false,
                    p1: b
                };
            }
            if (!Guid.b(a, 1)) {
                b.l(2, "Format_GuidHexPrefix", "{0xdddddddd, etc}");
                return {
                    ret: false,
                    p1: b
                };
            }
            c = 3;
            d = a.indexOf(',', c) - c;
            if (d <= 0) {
                b.k(2, "Format_GuidComma");
                return {
                    ret: false,
                    p1: b
                };
            }
            if (!((() => { let e = Guid.i(a.substr(c, d), -1, 4096, b.c.ae, b); b.c.ae = e.p3; b = e.p4; return e.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            if (!Guid.b(a, (c + d) + 1)) {
                b.l(2, "Format_GuidHexPrefix", "{0xdddddddd, 0xdddd, etc}");
                return {
                    ret: false,
                    p1: b
                };
            }
            c = (c + d) + 3;
            d = a.indexOf(',', c) - c;
            if (d <= 0) {
                b.k(2, "Format_GuidComma");
                return {
                    ret: false,
                    p1: b
                };
            }
            if (!((() => { let e = Guid.k(a.substr(c, d), -1, 4096, b.c.ac, b); b.c.ac = e.p3; b = e.p4; return e.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            if (!Guid.b(a, (c + d) + 1)) {
                b.l(2, "Format_GuidHexPrefix", "{0xdddddddd, 0xdddd, 0xdddd, etc}");
                return {
                    ret: false,
                    p1: b
                };
            }
            c = (c + d) + 3;
            d = a.indexOf(',', c) - c;
            if (d <= 0) {
                b.k(2, "Format_GuidComma");
                return {
                    ret: false,
                    p1: b
                };
            }
            if (!((() => { let e = Guid.k(a.substr(c, d), -1, 4096, b.c.ad, b); b.c.ad = e.p3; b = e.p4; return e.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            if ((a.length <= ((c + d) + 1)) || (a.charAt((c + d) + 1) != '{')) {
                b.k(2, "Format_GuidBrace");
                return {
                    ret: false,
                    p1: b
                };
            }
            d++;
            let e = new Array(8);
            for (let f = 0; f < 8; f++) {
                if (!Guid.b(a, (c + d) + 1)) {
                    b.l(2, "Format_GuidHexPrefix", "{... { ... 0xdd, ...}}");
                    return {
                        ret: false,
                        p1: b
                    };
                }
                c = (c + d) + 3;
                if (f < 7) {
                    d = a.indexOf(',', c) - c;
                    if (d <= 0) {
                        b.k(2, "Format_GuidComma");
                        return {
                            ret: false,
                            p1: b
                        };
                    }
                }
                else {
                    d = a.indexOf('}', c) - c;
                    if (d <= 0) {
                        b.k(2, "Format_GuidBraceAfterLastNumber");
                        return {
                            ret: false,
                            p1: b
                        };
                    }
                }
                let g = intSToU(parseInt32_2(a.substr(c, d), 515));
                if (g > 255) {
                    b.k(2, "Overflow_Byte");
                    return {
                        ret: false,
                        p1: b
                    };
                }
                e[f] = g;
            }
            b.c.r = e[0];
            b.c.s = e[1];
            b.c.t = e[2];
            b.c.u = e[3];
            b.c.v = e[4];
            b.c.w = e[5];
            b.c.x = e[6];
            b.c.y = e[7];
            if ((((c + d) + 1) >= a.length) || (a.charAt((c + d) + 1) != '}')) {
                b.k(2, "Format_GuidEndBrace");
                return {
                    ret: false,
                    p1: b
                };
            }
            if (((c + d) + 1) != (a.length - 1)) {
                b.k(2, "Format_ExtraJunkAtEnd");
                return {
                    ret: false,
                    p1: b
                };
            }
            return {
                ret: true,
                p1: b
            };
        }
        static q(a, b) {
            let c;
            let d;
            let e;
            let f = 0;
            if (a.length != 32) {
                b.k(2, "Format_GuidInvLen");
                return {
                    ret: false,
                    p1: b
                };
            }
            for (let g = 0; g < a.length; g++) {
                let h = a.charAt(g);
                if ((h.charCodeAt(0) < '0'.charCodeAt(0)) || (h.charCodeAt(0) > '9'.charCodeAt(0))) {
                    let i = h.toUpperCase();
                    if ((i.charCodeAt(0) < 'A'.charCodeAt(0)) || (i.charCodeAt(0) > 'F'.charCodeAt(0))) {
                        b.k(2, "Format_GuidInvalidChar");
                        return {
                            ret: false,
                            p1: b
                        };
                    }
                }
            }
            if (!((() => { let j = Guid.i(a.substr(f, 8), -1, 4096, b.c.ae, b); b.c.ae = j.p3; b = j.p4; return j.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            f += 8;
            if (!((() => { let j = Guid.k(a.substr(f, 4), -1, 4096, b.c.ac, b); b.c.ac = j.p3; b = j.p4; return j.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            f += 4;
            if (!((() => { let j = Guid.k(a.substr(f, 4), -1, 4096, b.c.ad, b); b.c.ad = j.p3; b = j.p4; return j.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            f += 4;
            if (!((() => { let j = Guid.i(a.substr(f, 4), -1, 4096, c, b); c = j.p3; b = j.p4; return j.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            f += 4;
            if (!((() => { let j = Guid.i(a.substr(f, 4), -1, f, d, b); d = j.p3; b = j.p4; return j.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            f += 4;
            if (!((() => { let j = Guid.i(a.substr(f, 8), -1, f, e, b); e = j.p3; b = j.p4; return j.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            b.c.r = ((c >> 8) & 255);
            b.c.s = (c & 255);
            c = d;
            b.c.t = ((c >> 8) & 255);
            b.c.u = (c & 255);
            c = e;
            b.c.v = ((c >> 24) & 255);
            b.c.w = ((c >> 16) & 255);
            b.c.x = ((c >> 8) & 255);
            b.c.y = (c & 255);
            return {
                ret: true,
                p1: b
            };
        }
        static k(a, b, c, d, e) {
            let f = 0;
            return {
                ret: ((() => { let g = Guid.l(a, f, b, c, d, e); f = g.p1; d = g.p4; e = g.p5; return g.ret; })()),
                p3: d,
                p4: e
            };
        }
        static l(a, b, c, d, e, f) {
            let g;
            e = 0;
            let h = ((() => { let i = Guid.j(a, b, c, d, g, f); b = i.p1; g = i.p4; f = i.p5; return i.ret; })());
            e = g;
            return {
                ret: h,
                p1: b,
                p4: e,
                p5: f
            };
        }
        static i(a, b, c, d, e) {
            let f = 0;
            return {
                ret: ((() => { let g = Guid.j(a, f, b, c, d, e); f = g.p1; d = g.p4; e = g.p5; return g.ret; })()),
                p3: d,
                p4: e
            };
        }
        static j(a, b, c, d, e, f) {
            e = 0;
            let g = b;
            try {
                if (c == -1) {
                    let h = a.length - b;
                    while (true) {
                        if (((() => { let i = tryParseInt32_2(a.substr(b, h), 515, CultureInfo.invariantCulture, e); e = i.p3; return i.ret; })())) {
                            break;
                        }
                        h--;
                    }
                    b += h;
                }
                else {
                    e = parseInt32_2(a.substr(b, c), 515);
                    b += c;
                }
            }
            catch (i) {
                if (f.d != 0) {
                    throw i;
                }
                f.j(i);
                return {
                    ret: false,
                    p1: b,
                    p4: e,
                    p5: f
                };
            }
            if (c != -1 && (b - g) != c) {
                f.k(2, "Format_GuidInvalidChar");
                return {
                    ret: false,
                    p1: b,
                    p4: e,
                    p5: f
                };
            }
            return {
                ret: true,
                p1: b,
                p4: e,
                p5: f
            };
        }
        static b(a, b) {
            return (((a.length > (b + 1)) && (a.charAt(b) == '0')) && (a.charAt(b + 1).toLowerCase() == 'x'));
        }
        static l_op_Inequality(a, b) {
            return !(Guid.l_op_Equality(a, b));
        }
        static l_op_Inequality_Lifted(a, b) {
            if (!a.hasValue) {
                return b.hasValue;
            }
            else if (!b.hasValue) {
                return true;
            }
            return Guid.l_op_Inequality(a.value, b.value);
        }
        static l_op_Equality(a, b) {
            return a.ae == b.ae && a.ac == b.ac && a.ad == b.ad && a.r == b.r && a.s == b.s && a.t == b.t && a.u == b.u && a.v == b.v && a.w == b.w && a.x == b.x && a.y == b.y;
        }
        static l_op_Equality_Lifted(a, b) {
            if (!a.hasValue) {
                return !b.hasValue;
            }
            else if (!b.hasValue) {
                return false;
            }
            return Guid.l_op_Equality(a.value, b.value);
        }
    }
    Guid.$t = /*@__PURE__*/ /*@__PURE__*/ markStruct(Guid, 'Guid', ValueType.$, [IFormattable_$type, IComparable_$type, /*@__PURE__*/ IComparable$1_$type.specialize(-1), /*@__PURE__*/ IEquatable$1_$type.specialize(-1)]).initSelfReferences();
    Guid.empty = /*@__PURE__*/ new Guid(0);
    return Guid;
})();
/**
 * @hidden
 */
let Guid_GuidResult = /*@__PURE__*/ (() => {
    class Guid_GuidResult extends ValueType {
        constructor() {
            super();
            this.c = new Guid();
            this.d = 0;
            this.e = 0;
            this.h = null;
            this.f = null;
            this.g = null;
            this.b = null;
        }
        i(a) {
            this.c = Guid.empty;
            this.d = a;
        }
        j(a) {
            this.e = 4;
            this.b = a;
        }
        k(a, b) {
            this.m(a, b, null, null, null);
        }
        l(a, b, c) {
            this.m(a, b, c, null, null);
        }
        m(a, b, c, d, e) {
            this.e = a;
            this.h = b;
            this.f = c;
            this.g = d;
            this.b = e;
            if (this.d != 0) {
                throw this.a();
            }
        }
        a() {
            switch (this.e) {
                case 1: return new ArgumentNullException(0, this.g);
                case 2: return new FormatException(0);
                case 3: return new FormatException(0);
                case 4: return this.b;
                case 5: return new FormatException(2, "The format of the Guid was incorrect.", this.b);
            }
            return new FormatException(0);
        }
    }
    Guid_GuidResult.$t = /*@__PURE__*/ markStruct(Guid_GuidResult, 'Guid_GuidResult');
    return Guid_GuidResult;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

class ReactTemplateAdapter {
    constructor(renderer, portalManager, propertyName, igTemplating, createExternal) {
        this._value = null;
        this._initializing = new Set();
        this._templateContents = new Map();
        this._waiting = new Map();
        this._renderer = renderer;
        this._portalManager = portalManager;
        this._propertyName = propertyName;
        this._igTemplating = igTemplating;
        this._createExternal = createExternal;
    }
    createMutationObserver(...args) {
        let origObserver = MutationObserver;
        if (window.Zone && window.Zone.__symbol__) {
            origObserver = window[window.Zone.__symbol__('MutationObserver')]
                || window[window.Zone.__symbol__('WebKitMutationObserver')];
        }
        return new origObserver(...args);
    }
    setValue(target, value) {
        if (value === this._value) {
            return;
        }
        this._value = value;
        let html = this._igTemplating.html;
        var currTemplate = null;
        var templateId = Guid.newGuid().toString();
        let self = this;
        var litTemplate = function (context) {
            if (!context) {
                return html `<div></div>`;
            }
            let contentId = context.___contentId;
            if (context.___immediate ||
                (context.i && context.i.___immediate) ||
                (context.i && context.i.nativeElement && context.i.nativeElement.___immediate) ||
                (context.nativeElement && context.nativeElement.___immediate)) {
                let innerContext = context;
                if (!contentId && context.i && context.i.___contentId) {
                    contentId = context.i.___contentId;
                    innerContext = context.i;
                }
                if (!contentId && context.i && context.i.nativeElement && context.i.nativeElement.___contentId) {
                    contentId = context.i.nativeElement.___contentId;
                    innerContext = context.i.nativeElement;
                }
                if (!contentId && context.nativeElement && context.nativeElement.___contentId) {
                    contentId = context.nativeElement.___contentId;
                    innerContext = context.nativeElement;
                }
                var template = currTemplate;
                if (!template.___currentContextMap) {
                    template.___currentContextMap = new Map();
                }
                let currentContext = null;
                if (template.___currentContextMap.has(contentId)) {
                    currentContext = template.___currentContextMap.get(contentId);
                }
                if (currentContext !== innerContext) {
                    template.___currentContextMap.set(contentId, innerContext);
                    self.adjustDynamicContent(null, template.___templateId, contentId, "Update", context);
                }
                if (innerContext.___root) {
                    let root = innerContext.___root;
                    if (!root.___host) {
                        var host = root.querySelector("#" + 'host-' + contentId);
                        if (host) {
                            root.___host = host;
                            template.___checkHost(template, root, root.___host);
                        }
                    }
                    else {
                        if (root.___host) {
                            template.___checkHost(template, root, root.___host);
                        }
                    }
                }
            }
            return html `<div id="${'host-' + contentId}" style="display: contents;">
			</div>`;
        };
        currTemplate = litTemplate;
        litTemplate.___isBridged = true;
        litTemplate.___templateId = templateId;
        litTemplate.___onTemplateInit = (template, templateContent) => {
            let mut = self.createMutationObserver((list) => {
                for (var mutation of list) {
                    if (mutation.type == 'childList') {
                        var host = templateContent.querySelector("#" + 'host-' + templateContent._id);
                        templateContent.___host = host;
                        if (template.___checkHost(template, templateContent, templateContent.___host)) {
                            mut.disconnect();
                            mut = null;
                        }
                        break;
                    }
                }
            });
            mut.observe(templateContent, {
                childList: true
            });
            // var dynCont = template.___container.parentElement.querySelector(".ig-dynamic-content-holder");
            // let mut2 = self.createMutationObserver((list) => {
            // 	for (var mutation of list) {
            // 		if (mutation.type == 'childList') {
            // 			var host = templateContent.querySelector("#" + 'host-' + templateContent._id);
            // 			templateContent.___host = host;
            // 			if (template.___checkHost(template, templateContent, templateContent.___host)) {
            // 			mut2.disconnect();
            // 			mut2 = null;
            // 			if (mut) {
            // 				mut.disconnect();
            // 				mut = null;
            // 			}
            // 			}
            // 			break;
            // 		}
            // 	}
            // });
            // mut2.observe(dynCont, {
            // 	childList: true
            // });
        };
        litTemplate.___onTemplateTeardown = (template, templateContent) => {
            self.adjustDynamicContent(null, template.___templateId, templateContent._id, "Remove", null);
        };
        litTemplate.___checkHost = (template, templateContent, host) => {
            if (host) {
                if (!this._templateContents.has(templateContent._id)) {
                    self.adjustDynamicContent(this._renderer.getWrapper(host), template.___templateId, templateContent._id, "Add", null);
                }
            }
            // var content = document.getElementById(templateContent._id);
            // if (content && host) {
            // if (content.parentElement != host) {
            // 	if (host.id.replace("host-", "") != content.id) {
            // 	console.log("error!");
            // 	}
            // 	host.appendChild(content);
            // 	return true;
            // }
            // }
            return false;
        };
        litTemplate.___onTemplateContextChanged = (template, templateContent, context) => {
            if (templateContent.___host) {
                template.___checkHost(template, templateContent, templateContent.___host);
            }
            self.adjustDynamicContent(null, template.___templateId, templateContent._id, "Update", context);
        };
        target[this._propertyName] = litTemplate;
    }
    ensureExternalObject(target) {
        if (target && target._implementation) {
            // we are already an external type.
            return target;
        }
        let owningType = null;
        if (target.$type) {
            owningType = target.$type.name;
        }
        if (!owningType) {
            return target;
        }
        let typeName = "Igr" + owningType;
        if (this._createExternal) {
            let ext = this._createExternal();
            ext._implementation = target;
            target.externalObject = ext;
            return ext;
        }
        else {
            if (TypeRegistrar.isRegistered(typeName)) {
                let ext = TypeRegistrar.create(typeName);
                ext._implementation = target;
                target.externalObject = ext;
                return ext;
            }
        }
        return target;
    }
    adjustDynamicContent(hostElement, templateId, contentId, operation, context) {
        if (context && !context._implementation) {
            if (context.externalObject) {
                context = context.externalObject;
            }
            else {
                context = this.ensureExternalObject(context);
            }
        }
        if (operation == "Add") {
            if (!this._initializing.has(contentId)) {
                this._initializing.add(contentId);
                //console.log("Add: " + contentId);
                this._portalManager.getPortal(hostElement, "TemplateContainer", (p) => {
                    this._initializing.delete(contentId);
                    this._templateContents.set(contentId, p.componentRef);
                    if (this._waiting.has(contentId)) {
                        if (this._waiting.get(contentId)) {
                            this._waiting.get(contentId)(p.componentRef);
                            this._waiting.delete(contentId);
                        }
                    }
                }, false);
            }
        }
        else if (operation == "Update") {
            //console.log("Update: " + contentId);
            if (this._templateContents.has(contentId)) {
                let t = this._templateContents.get(contentId);
                t.template = this._value;
                if (context) {
                    t.dataContext = context;
                }
            }
            else {
                this._waiting.set(contentId, (c) => {
                    let t = this._templateContents.get(contentId);
                    t.template = this._value;
                    if (context) {
                        t.dataContext = context;
                    }
                });
            }
        }
        else if (operation == "Remove") {
            //console.log("Remove: " + contentId);
            if (this._templateContents.has(contentId)) {
                this._templateContents.delete(contentId);
            }
            if (this._waiting.has(contentId)) {
                this._templateContents.delete(contentId);
            }
            ;
        }
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IExternalDataSeriesAdapter_$type = /*@__PURE__*/ new Type(null, 'IExternalDataSeriesAdapter');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Identifies which type of series is suggested for a data series.
 */
var DataSeriesType = /*@__PURE__*/ (function (DataSeriesType) {
    /**
     * Used when a line series is suggested.
     */
    DataSeriesType[DataSeriesType["Line"] = 0] = "Line";
    /**
     * Used when a column series is suggested.
     */
    DataSeriesType[DataSeriesType["Column"] = 1] = "Column";
    /**
     * Used when an area series is suggested.
     */
    DataSeriesType[DataSeriesType["Area"] = 2] = "Area";
    /**
     * Used when a bar series is suggested.
     */
    DataSeriesType[DataSeriesType["Bar"] = 3] = "Bar";
    /**
     * Used when a step line series is suggested.
     */
    DataSeriesType[DataSeriesType["StepLine"] = 4] = "StepLine";
    /**
     * Used when a step area series is suggested.
     */
    DataSeriesType[DataSeriesType["StepArea"] = 5] = "StepArea";
    /**
     * Used when a spline series is suggested.
     */
    DataSeriesType[DataSeriesType["Spline"] = 6] = "Spline";
    /**
     * Used when a spline area series is suggested.
     */
    DataSeriesType[DataSeriesType["SplineArea"] = 7] = "SplineArea";
    /**
     * Used when a waterfall series is suggested.
     */
    DataSeriesType[DataSeriesType["Waterfall"] = 8] = "Waterfall";
    /**
     * Used when a stacked series is suggested.
     */
    DataSeriesType[DataSeriesType["Stacked"] = 9] = "Stacked";
    /**
     * Used when a point series is suggested.
     */
    DataSeriesType[DataSeriesType["Point"] = 10] = "Point";
    /**
     * Used when a scatter point series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterPoint"] = 11] = "ScatterPoint";
    /**
     * Used when a scatter line series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterLine"] = 12] = "ScatterLine";
    /**
     * Used when a scatter spline series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterSpline"] = 13] = "ScatterSpline";
    /**
     * Used when a scatter area series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterArea"] = 14] = "ScatterArea";
    /**
     * Used when a scatter contour series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterContour"] = 15] = "ScatterContour";
    /**
     * Used when a high density scatter series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterHighDensity"] = 16] = "ScatterHighDensity";
    /**
     * Used when a bubble series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterBubble"] = 17] = "ScatterBubble";
    /**
     * Used when a polygon series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterPolygon"] = 18] = "ScatterPolygon";
    /**
     * Used when a polyline series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterPolyline"] = 19] = "ScatterPolyline";
    /**
     * Used when a financial price series is suggested.
     */
    DataSeriesType[DataSeriesType["FinancialPrice"] = 20] = "FinancialPrice";
    /**
     * Used when an financial indicator series is suggested.
     */
    DataSeriesType[DataSeriesType["FinancialIndicator"] = 21] = "FinancialIndicator";
    /**
     * Used when a financial overlay series is suggested.
     */
    DataSeriesType[DataSeriesType["FinancialOverlay"] = 22] = "FinancialOverlay";
    /**
     * Used when a value overlay is suggested.
     */
    DataSeriesType[DataSeriesType["ValueOverlay"] = 23] = "ValueOverlay";
    /**
     * Specifies unknown series type
     */
    DataSeriesType[DataSeriesType["Unknown"] = 24] = "Unknown";
    /**
     * Used when an item tooltip layer is suggested.
     */
    DataSeriesType[DataSeriesType["ItemToolTipLayer"] = 25] = "ItemToolTipLayer";
    /**
     * Used when a category tooltip layer is suggested.
     */
    DataSeriesType[DataSeriesType["CategoryToolTipLayer"] = 26] = "CategoryToolTipLayer";
    /**
     * Used when a crosshair layer is suggested.
     */
    DataSeriesType[DataSeriesType["CrosshairLayer"] = 27] = "CrosshairLayer";
    /**
     * Used when a callout layer is suggested.
     */
    DataSeriesType[DataSeriesType["CalloutLayer"] = 28] = "CalloutLayer";
    /**
     * Used when a final value layer is suggested.
     */
    DataSeriesType[DataSeriesType["FinalValueLayer"] = 29] = "FinalValueLayer";
    /**
     * Used when a category highlight layer is suggested.
     */
    DataSeriesType[DataSeriesType["CategoryHighlightLayer"] = 30] = "CategoryHighlightLayer";
    /**
     * Used when a category item highlight layer is suggested.
     */
    DataSeriesType[DataSeriesType["CategoryItemHighlightLayer"] = 31] = "CategoryItemHighlightLayer";
    /**
     * Used when a data tooltip layer is suggested.
     */
    DataSeriesType[DataSeriesType["DataToolTipLayer"] = 32] = "DataToolTipLayer";
    /**
     * Used when a value layer is suggested.
     */
    DataSeriesType[DataSeriesType["ValueLayer"] = 33] = "ValueLayer";
    /**
     * Used when a pie chart is suggested.
     */
    DataSeriesType[DataSeriesType["Pie"] = 34] = "Pie";
    return DataSeriesType;
})({});
/**
 * @hidden
 */
let DataSeriesType_$type = /*@__PURE__*/ markEnum('DataSeriesType', 'Line,0|Column,1|Area,2|Bar,3|StepLine,4|StepArea,5|Spline,6|SplineArea,7|Waterfall,8|Stacked,9|Point,10|ScatterPoint,11|ScatterLine,12|ScatterSpline,13|ScatterArea,14|ScatterContour,15|ScatterHighDensity,16|ScatterBubble,17|ScatterPolygon,18|ScatterPolyline,19|FinancialPrice,20|FinancialIndicator,21|FinancialOverlay,22|ValueOverlay,23|Unknown,24|ItemToolTipLayer,25|CategoryToolTipLayer,26|CrosshairLayer,27|CalloutLayer,28|FinalValueLayer,29|CategoryHighlightLayer,30|CategoryItemHighlightLayer,31|DataToolTipLayer,32|ValueLayer,33|Pie,34');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Identifies various intents for the sub properties of the data being bound to a data series.
 */
var DataSeriesIntent = /*@__PURE__*/ (function (DataSeriesIntent) {
    /**
     * Identifies the primary values to use for a series.
     */
    DataSeriesIntent[DataSeriesIntent["PrimarySeriesValue"] = 0] = "PrimarySeriesValue";
    /**
     * Identifies the x axis values to use for a scatter series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesX"] = 1] = "SeriesX";
    /**
     * Identifies the y axis values to use for a scatter series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesY"] = 2] = "SeriesY";
    /**
     * Identifies the fill scale values to use for a bubble series or scatter area series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesFill"] = 3] = "SeriesFill";
    /**
     * Identifies the legend label values to use for a bubble series in item-wize legends.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesLabel"] = 4] = "SeriesLabel";
    /**
     * Identifies the radius values to use for a bubble, polar, or radial series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesRadius"] = 5] = "SeriesRadius";
    /**
     * Identifies the angle values to use for a polar or radial series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesAngle"] = 6] = "SeriesAngle";
    /**
     * Identifies the shape values to use for a scatter polyline or polygon series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesShape"] = 7] = "SeriesShape";
    /**
     * Identifies the item-wize values to use for a series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesValue"] = 8] = "SeriesValue";
    /**
     * Identifies a grouping identifier to use for a series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesGroup"] = 9] = "SeriesGroup";
    /**
     * Identifies a title to use for a series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesTitle"] = 10] = "SeriesTitle";
    /**
     * Identifies an open value to use for a financial series.
     */
    DataSeriesIntent[DataSeriesIntent["OpenSeriesValue"] = 11] = "OpenSeriesValue";
    /**
     * Identifies a high value to use for a financial series or range series.
     */
    DataSeriesIntent[DataSeriesIntent["HighSeriesValue"] = 12] = "HighSeriesValue";
    /**
     * Identifies a low value to use for a financial series or range series.
     */
    DataSeriesIntent[DataSeriesIntent["LowSeriesValue"] = 13] = "LowSeriesValue";
    /**
     * Identifies a close value to use for a financial series or range series.
     */
    DataSeriesIntent[DataSeriesIntent["CloseSeriesValue"] = 14] = "CloseSeriesValue";
    /**
     * Identifies a volume value to use for a financial series or range series.
     */
    DataSeriesIntent[DataSeriesIntent["VolumeSeriesValue"] = 15] = "VolumeSeriesValue";
    /**
     * Identifies an axis label value to use for a series.
     */
    DataSeriesIntent[DataSeriesIntent["AxisLabelValue"] = 16] = "AxisLabelValue";
    /**
     * Identifies an axis date value to use for a series.
     */
    DataSeriesIntent[DataSeriesIntent["AxisDateValue"] = 17] = "AxisDateValue";
    /**
     * Identifies that a value should be ignored when considering values for a series.
     */
    DataSeriesIntent[DataSeriesIntent["DontPlot"] = 18] = "DontPlot";
    /**
     * Identifies a sales units value to use for a break-even series
     */
    DataSeriesIntent[DataSeriesIntent["SalesUnit"] = 19] = "SalesUnit";
    /**
     * Identifies a sales fixed cost to use for a break-even series
     */
    DataSeriesIntent[DataSeriesIntent["SalesFixedCost"] = 20] = "SalesFixedCost";
    /**
     * Identifies a sales variable cost to use for a break-even series
     */
    DataSeriesIntent[DataSeriesIntent["SalesVariableCost"] = 21] = "SalesVariableCost";
    /**
     * Identifies a sales total cost to use for a break-even series
     */
    DataSeriesIntent[DataSeriesIntent["SalesTotalCost"] = 22] = "SalesTotalCost";
    /**
     * Identifies a sales revenue to use for a break-even series
     */
    DataSeriesIntent[DataSeriesIntent["SalesRevenue"] = 23] = "SalesRevenue";
    /**
     * Identifies a sales marginal profit to use for a break-even series
     */
    DataSeriesIntent[DataSeriesIntent["SalesMarginalProfit"] = 24] = "SalesMarginalProfit";
    /**
     * Identifes a value that has been used to generate other data to bind against.
     */
    DataSeriesIntent[DataSeriesIntent["GenerationInput"] = 25] = "GenerationInput";
    return DataSeriesIntent;
})({});
/**
 * @hidden
 */
let DataSeriesIntent_$type = /*@__PURE__*/ markEnum('DataSeriesIntent', 'PrimarySeriesValue,0|SeriesX,1|SeriesY,2|SeriesFill,3|SeriesLabel,4|SeriesRadius,5|SeriesAngle,6|SeriesShape,7|SeriesValue,8|SeriesGroup,9|SeriesTitle,10|OpenSeriesValue,11|HighSeriesValue,12|LowSeriesValue,13|CloseSeriesValue,14|VolumeSeriesValue,15|AxisLabelValue,16|AxisDateValue,17|DontPlot,18|SalesUnit,19|SalesFixedCost,20|SalesVariableCost,21|SalesTotalCost,22|SalesRevenue,23|SalesMarginalProfit,24|GenerationInput,25');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSeriesMemberPathHint = /*@__PURE__*/ (() => {
    class DataSeriesMemberPathHint extends Base {
        constructor() {
            super(...arguments);
            this._path = null;
            this._intent = 0;
        }
        get path() {
            return this._path;
        }
        set path(a) {
            this._path = a;
        }
        get intent() {
            return this._intent;
        }
        set intent(a) {
            this._intent = a;
        }
        equals(a) {
            let b = typeCast(DataSeriesMemberPathHint.$, a);
            if (b == null) {
                return false;
            }
            if (!Base.equalsStatic(this.path, b.path)) {
                return false;
            }
            if (this.intent != b.intent) {
                return false;
            }
            return true;
        }
        toString() {
            return enumGetBox(DataSeriesIntent_$type, this.intent) + " Path = '" + this.path + "'";
        }
        update1(a, b = null) {
            this.path = stringIsNullOrEmpty(b) ? a : stringReplace(b, "NAME", a);
        }
        update(a, b = null) {
            if (a.length == 0) {
                return;
            }
            this.update1(a[0], b);
        }
        hasPath() {
            return !stringIsNullOrEmpty(this.path);
        }
        clone() {
            return ((() => {
                let $ret = new DataSeriesMemberPathHint();
                $ret.intent = this.intent;
                $ret.path = this.path;
                return $ret;
            })());
        }
    }
    DataSeriesMemberPathHint.$t = /*@__PURE__*/ markType(DataSeriesMemberPathHint, 'DataSeriesMemberPathHint');
    return DataSeriesMemberPathHint;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSeries = /*@__PURE__*/ (() => {
    class DataSeries extends Base {
        constructor() {
            super();
            this.k = null;
            this._name = null;
            this._title = null;
            this._data = null;
            this._highlightedData = null;
            this._priority = 0;
            this._index = 0;
            this._suggestedPrimaryAxis = 0;
            this._suggestedSecondaryAxis = 0;
            this._suggestedSeries = 0;
            this._dataPath = null;
            this._suggestedMarker = 0;
            this.k = new List$1(DataSeriesMemberPathHint.$, 0);
            this.suggestedMarker = 13;
            this.index = -1;
            this.priority = -1;
        }
        get name() {
            return this._name;
        }
        set name(a) {
            this._name = a;
        }
        get title() {
            return this._title;
        }
        set title(a) {
            this._title = a;
        }
        get data() {
            return this._data;
        }
        set data(a) {
            this._data = a;
        }
        get highlightedData() {
            return this._highlightedData;
        }
        set highlightedData(a) {
            this._highlightedData = a;
        }
        get priority() {
            return this._priority;
        }
        set priority(a) {
            this._priority = a;
        }
        get index() {
            return this._index;
        }
        set index(a) {
            this._index = a;
        }
        get suggestedPrimaryAxis() {
            return this._suggestedPrimaryAxis;
        }
        set suggestedPrimaryAxis(a) {
            this._suggestedPrimaryAxis = a;
        }
        get suggestedSecondaryAxis() {
            return this._suggestedSecondaryAxis;
        }
        set suggestedSecondaryAxis(a) {
            this._suggestedSecondaryAxis = a;
        }
        get suggestedSeries() {
            return this._suggestedSeries;
        }
        set suggestedSeries(a) {
            this._suggestedSeries = a;
        }
        get dataPath() {
            return this._dataPath;
        }
        set dataPath(a) {
            this._dataPath = a;
        }
        get suggestedMarker() {
            return this._suggestedMarker;
        }
        set suggestedMarker(a) {
            this._suggestedMarker = a;
        }
        addMemberPathHint(a) {
            this.k.add(a);
        }
        addMemberPathHint1(a, b) {
            let c = a.clone();
            c.intent = b;
            this.k.add(c);
        }
        addMemberPathHint2(a, b) {
            let c = new DataSeriesMemberPathHint();
            c.intent = b;
            c.path = a;
            this.k.add(c);
        }
        removeMemberPathHint(a) {
            this.k.remove(a);
        }
        clearMemberPathHints() {
            this.k.clear();
        }
        getMemberPathHintCount() {
            return this.k.count;
        }
        getMemberPathHintAt(a) {
            return this.k._inner[a];
        }
        findMatchingHint(a) {
            for (let b = 0; b < this.k.count; b++) {
                if (this.k._inner[b].intent == a) {
                    return this.k._inner[b];
                }
            }
            return null;
        }
        getMemberPathFor(a) {
            let b = this.findMatchingHint(a);
            if (b == null) {
                return "";
            }
            return b.path;
        }
        hasMatchingHint(a) {
            let b = this.findMatchingHint(a);
            if (b == null) {
                return false;
            }
            if (stringIsNullOrEmpty(b.path)) {
                return false;
            }
            return true;
        }
        j() {
            return this.k;
        }
        equals(a) {
            let b = typeCast(DataSeries.$, a);
            if (b == null) {
                return false;
            }
            if (!Base.equalsStatic(this.name, b.name)) {
                return false;
            }
            if (!Base.equalsStatic(this.title, b.title)) {
                return false;
            }
            if (this.data != b.data) {
                return false;
            }
            if (this.highlightedData != b.highlightedData) {
                return false;
            }
            if (this.priority != b.priority) {
                return false;
            }
            if (this.suggestedPrimaryAxis != b.suggestedPrimaryAxis) {
                return false;
            }
            if (this.suggestedSecondaryAxis != b.suggestedSecondaryAxis) {
                return false;
            }
            if (this.suggestedSeries != b.suggestedSeries) {
                return false;
            }
            if (this.suggestedMarker != b.suggestedMarker) {
                return false;
            }
            if (!Base.equalsStatic(this.dataPath, b.dataPath)) {
                return false;
            }
            let c = this.j();
            let d = b.j();
            if (c.count != d.count) {
                return false;
            }
            for (let e = 0; e < c.count; e++) {
                if (!c.item(e).equals(d.item(e))) {
                    return false;
                }
            }
            return true;
        }
        isMatch(a) {
            let b = typeCast(DataSeries.$, a);
            if (b == null) {
                return false;
            }
            if (!Base.equalsStatic(this.name, b.name)) {
                return false;
            }
            if (!Base.equalsStatic(this.title, b.title)) {
                return false;
            }
            if (this.priority != b.priority) {
                return false;
            }
            if (this.suggestedPrimaryAxis != b.suggestedPrimaryAxis) {
                return false;
            }
            if (this.suggestedSecondaryAxis != b.suggestedSecondaryAxis) {
                return false;
            }
            if (this.suggestedSeries != b.suggestedSeries) {
                return false;
            }
            if (this.suggestedMarker != b.suggestedMarker) {
                return false;
            }
            if (!Base.equalsStatic(this.dataPath, b.dataPath)) {
                return false;
            }
            let c = this.j();
            let d = b.j();
            if (c.count != d.count) {
                return false;
            }
            for (let e = 0; e < c.count; e++) {
                if (!c.item(e).equals(d.item(e))) {
                    return false;
                }
            }
            return true;
        }
        toString() {
            let a = enumGetBox(DataSeriesType_$type, this.suggestedSeries) + " hints: ";
            for (let b of fromEnum(this.k)) {
                a += " {" + b.toString() + "}, ";
            }
            return a;
        }
    }
    DataSeries.$t = /*@__PURE__*/ markType(DataSeries, 'DataSeries');
    return DataSeries;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSeriesCollection = /*@__PURE__*/ (() => {
    class DataSeriesCollection extends ObservableCollection$1 {
        constructor() {
            super(DataSeries.$, 0);
        }
    }
    DataSeriesCollection.$t = /*@__PURE__*/ markType(DataSeriesCollection, 'DataSeriesCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(DataSeries.$));
    return DataSeriesCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceClonableDataProvider_$type = /*@__PURE__*/ new Type(null, 'IDataSourceClonableDataProvider');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceLocalDataProvider_$type = /*@__PURE__*/ new Type(null, 'IDataSourceLocalDataProvider', null, [IDataSourceDataProvider_$type, IDataSourceSupportsIndexedAccess_$type, IDataSourceClonableDataProvider_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSeriesAdapterProviderInfo = /*@__PURE__*/ (() => {
    class DataSeriesAdapterProviderInfo extends Base {
        constructor() {
            super();
            this.e = null;
            this.a = 0;
            this.c = null;
            this.b = null;
            this.d = false;
            this.e = new List$1(Delegate_$type, 0);
        }
    }
    DataSeriesAdapterProviderInfo.$t = /*@__PURE__*/ markType(DataSeriesAdapterProviderInfo, 'DataSeriesAdapterProviderInfo');
    return DataSeriesAdapterProviderInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Matcher = /*@__PURE__*/ (() => {
    class Matcher extends Base {
        constructor(a) {
            super();
            this.c = null;
            let patt_ = Matcher.d(a);
            this.c = (new RegExp(patt_));
        }
        b(a) {
            return this.c.test(a);
        }
        static a(a) {
            return Matcher.d(a) != null;
        }
        static d(a) {
            if (a == null) {
                return null;
            }
            if (stringStartsWith(a, "/") && stringEndsWith(a, "/")) {
                return a.substr(1, a.length - 2);
            }
            if (stringStartsWith(a, "Regex(") && stringEndsWith(a, ")")) {
                return a.substr(6, a.length - 7);
            }
            if (stringStartsWith(a, "RegExp(") && stringEndsWith(a, ")")) {
                return a.substr(7, a.length - 8);
            }
            if (stringContains(a, "*") || stringContains(a, "#") || stringContains(a, "?")) {
                a = stringReplace(a, ".", "\\.");
                a = stringReplace(a, "*", ".*");
                a = stringReplace(a, "#", "\\d+");
                a = stringReplace(a, "?", ".+");
                a = stringReplace(a, "[", "\\[");
                a = stringReplace(a, "]", "\\]");
                return "^" + a + "$";
            }
            return null;
        }
    }
    Matcher.$t = /*@__PURE__*/ markType(Matcher, 'Matcher');
    return Matcher;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceSchema_$type = /*@__PURE__*/ new Type(null, 'IDataSourceSchema');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enumerates the available property types on a data source schema.
 */
var DataSourceSchemaPropertyType = /*@__PURE__*/ (function (DataSourceSchemaPropertyType) {
    /**
     * The property is of type string.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["StringValue"] = 0] = "StringValue";
    /**
     * The property is of type integer.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["IntValue"] = 1] = "IntValue";
    /**
     * The property is of type boolean.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["BooleanValue"] = 2] = "BooleanValue";
    /**
     * The property is of type long.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["LongValue"] = 3] = "LongValue";
    /**
     * The property if of type short.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["ShortValue"] = 4] = "ShortValue";
    /**
     * The property is of type double.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["DoubleValue"] = 5] = "DoubleValue";
    /**
     * The property is of type decimal.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["DecimalValue"] = 6] = "DecimalValue";
    /**
     * The property is of type single.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["SingleValue"] = 7] = "SingleValue";
    /**
     * The property is of type datetime.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["DateTimeValue"] = 8] = "DateTimeValue";
    /**
     * The property is of type datetimeoffset.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["DateTimeOffsetValue"] = 9] = "DateTimeOffsetValue";
    /**
     * The property is of type byte.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["ByteValue"] = 10] = "ByteValue";
    /**
     * The property is of type object.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["ObjectValue"] = 11] = "ObjectValue";
    return DataSourceSchemaPropertyType;
})({});
/**
 * @hidden
 */
let DataSourceSchemaPropertyType_$type = /*@__PURE__*/ markEnum('DataSourceSchemaPropertyType', 'StringValue,0|IntValue,1|BooleanValue,2|LongValue,3|ShortValue,4|DoubleValue,5|DecimalValue,6|SingleValue,7|DateTimeValue,8|DateTimeOffsetValue,9|ByteValue,10|ObjectValue,11');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DefaultDataSourceSchema = /*@__PURE__*/ (() => {
    class DefaultDataSourceSchema extends Base {
        constructor(a, b, c, d, e) {
            super();
            this.d = null;
            this.e = null;
            this.a = null;
            this.b = null;
            this.c = null;
            this.d = a;
            this.e = b;
            this.a = c;
            this.b = d;
            this.c = e;
        }
        get primaryKey() {
            return this.a;
        }
        get propertyNames() {
            return this.d;
        }
        get propertyTypes() {
            return this.e;
        }
        get propertyDataIntents() {
            return this.b;
        }
        get subSchemas() {
            return this.c;
        }
    }
    DefaultDataSourceSchema.$t = /*@__PURE__*/ markType(DefaultDataSourceSchema, 'DefaultDataSourceSchema', Base.$, [IDataSourceSchema_$type]);
    return DefaultDataSourceSchema;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceDataProviderSchemaChangedEventArgs = /*@__PURE__*/ (() => {
    class DataSourceDataProviderSchemaChangedEventArgs extends EventArgs {
        constructor(a, b) {
            super();
            this.d = 0;
            this.b = null;
            this.b = a;
            this.d = b;
        }
        get schema() {
            return this.b;
        }
        get count() {
            return this.d;
        }
    }
    DataSourceDataProviderSchemaChangedEventArgs.$t = /*@__PURE__*/ markType(DataSourceDataProviderSchemaChangedEventArgs, 'DataSourceDataProviderSchemaChangedEventArgs', EventArgs.$);
    return DataSourceDataProviderSchemaChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceLocalDataProvider = /*@__PURE__*/ (() => {
    class DataSourceLocalDataProvider extends Base {
        constructor() {
            super();
            this.n = null;
            this.m = null;
            this.g = null;
            this.o = null;
            this.f = 0;
            this.aa = 5;
            this.ab = null;
            this.u = new Dictionary$2(String_$type, DataSourceSchemaPropertyType_$type, 0);
            this.ad = null;
            this.schemaChanged = null;
            this.t = new Dictionary$2(String_$type, FastReflectionHelper.$, 0);
            this.v = new HashSet$1(String_$type, 0);
            this.j = null;
            this.y = null;
            this.r = false;
            this.i = null;
            this.h = null;
            this.q = false;
            this.a = null;
            this.p = false;
            this.b = null;
            this.n = new SortDescriptionCollection();
            this.n.n(runOn(this, this.au));
            this.m = new SortDescriptionCollection();
            this.o = new SummaryDescriptionCollection();
            this.g = new FilterExpressionCollection();
        }
        au(a, b) {
            this.queueAutoRefresh();
        }
        clone() {
            let a = new DataSourceLocalDataProvider();
            a.deferAutoRefresh = this.deferAutoRefresh;
            a.executionContext = this.executionContext;
            a.dataSource = this.dataSource;
            a.propertiesRequested = this.propertiesRequested;
            a.schemaHints = this.schemaHints;
            a.summaryScope = this.summaryScope;
            for (let b = 0; b < this.groupDescriptions.k.count; b++) {
                a.groupDescriptions.add(this.groupDescriptions.k.item(b));
            }
            for (let c = 0; c < this.sortDescriptions.k.count; c++) {
                a.sortDescriptions.add(this.sortDescriptions.k.item(c));
            }
            for (let d = 0; d < this.filterExpressions.k.count; d++) {
                a.filterExpressions.add(this.filterExpressions.k.item(d));
            }
            for (let e = 0; e < this.summaryDescriptions.k.count; e++) {
                a.summaryDescriptions.add(this.summaryDescriptions.k.item(e));
            }
            return a;
        }
        get dataSource() {
            return this.ab;
        }
        set dataSource(a) {
            let b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.ao("ItemsSource", b, this.ab);
            }
        }
        get schemaHints() {
            return this.ad;
        }
        set schemaHints(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.ao("SchemaHints", b, this.ad);
            }
        }
        ap() {
            if (this.ad == null) {
                return;
            }
            this.u.clear();
            let a = this.ad.split(',');
            for (let b = 0; b < a.length; b++) {
                let c = a[b].trim().split(':');
                if (c.length != 2) {
                    continue;
                }
                let d = c[0];
                let e = this.d(c[1]);
                this.u.addItem(d, e);
            }
        }
        d(a) {
            let b = EnumUtil.parse(DataSourceSchemaPropertyType_$type, a, true);
            if (b != null) {
                return EnumUtil.getEnumValue(DataSourceSchemaPropertyType_$type, b);
            }
            return 11;
        }
        getItemAtIndex(a) {
            if (this.y == null) {
                return null;
            }
            if (this.r) {
                return this.y[a];
            }
            return this.y.item(a);
        }
        getItemValue(a, b) {
            this.ak();
            let c;
            let d = this.t.tryGetValue(b, c);
            c = d.p1;
            if (c == null && !this.v.contains(b)) {
                let e = b.split('.');
                let f = a;
                let g = true;
                for (let h = 0; h < e.length; h++) {
                    f = f[e[h]];
                    if ((f === undefined)) {
                        g = false;
                        break;
                    }
                }
                if (g) {
                    c = new FastReflectionHelper(false, b);
                    this.t.addItem(b, c);
                }
                else {
                    this.v.add_1(b);
                }
            }
            if (c == null) {
                return null;
            }
            let val_ = c.getPropertyValue(a);
            if ((val_ === undefined)) {
                return null;
            }
            return val_;
        }
        setItemValue(a, b, c) {
            this.ak();
            let d;
            let e = this.t.tryGetValue(b, d);
            d = e.p1;
            if (d == null) {
                return;
            }
            d.setPropertyValue(a, c);
        }
        removeItem(a) {
            if (this.y != null) {
                let b = this.y.indexOf(a);
                if (this.r) {
                    this.y.splice(b, 1);
                }
                else {
                    this.y.removeAt(b);
                }
                this.notifyRemoveItem(b, a);
            }
        }
        addItem(a) {
            if (this.y != null) {
                let b = this.actualCount;
                if (this.r) {
                    this.y.splice(b, 0, a);
                }
                else {
                    this.y.insert(b, a);
                }
                this.notifyInsertItem(this.actualCount - 1, a);
            }
        }
        ak() {
            if (this.j == null) {
                this.j = this.actualSchema;
                if (this.schemaChanged != null) {
                    this.schemaChanged(this, new DataSourceDataProviderSchemaChangedEventArgs(this.j, this.actualCount));
                }
            }
        }
        get actualCount() {
            if (this.y == null) {
                return 0;
            }
            if (this.r) {
                return (this.y.length);
            }
            return this.y.count;
        }
        get actualSchema() {
            if (this.j == null) {
                if (this.y == null) {
                    this.j = new DefaultDataSourceSchema([], [], null, null, []);
                }
                else {
                    this.j = this.l();
                }
            }
            return this.j;
        }
        l() {
            let a = this.ac();
            if (a == null) {
                return new DefaultDataSourceSchema([], [], null, null, []);
            }
            this.t.clear();
            this.v.clear();
            return this.k(a, null, 0);
        }
        k(a, b, c) {
            if (c >= this.aa) {
                return null;
            }
            if (a == null) {
                return null;
            }
            if ((typeof a === 'function')) {
                return null;
            }
            if ((Array.isArray(a))) {
                return null;
            }
            let check_ = a;
            if ((check_ instanceof HTMLElement)) {
                return null;
            }
            let d = new List$1(String_$type, 0);
            let e = new HashSet$1(String_$type, 0);
            let f = new List$1(DataSourceSchemaPropertyType_$type, 0);
            let g = new List$1(List$1.$.specialize(String_$type), 0);
            let h = this.w(a);
            let i = new List$1(IDataSourceSchema_$type, 0);
            if (this.schemaIncludedProperties == null || this.schemaIncludedProperties.length > 0) {
                for (let j = 0; j < h.count; j++) {
                    let k = h._inner[j];
                    if (this.schemaIncludedProperties != null && this.schemaIncludedProperties.length > 0) {
                        let l = false;
                        for (let m = 0; m < this.schemaIncludedProperties.length; m++) {
                            if (this.schemaIncludedProperties[m] == k) {
                                l = true;
                                break;
                            }
                        }
                        if (!l) {
                            continue;
                        }
                    }
                    if (stringStartsWith(k, "_")) {
                        continue;
                    }
                    if (k == "$hashCode" || k == "$type") {
                        continue;
                    }
                    if ((typeof check_[k] === 'function')) {
                        continue;
                    }
                    if (e.contains(k)) {
                        continue;
                    }
                    else {
                        let n = b == null ? k : b + "." + k;
                        d.add(k);
                        e.add_1(k);
                        this.t.addItem(n, new FastReflectionHelper(false, n));
                        if (this.u.containsKey(n)) {
                            f.add(this.u.item(n));
                            this.u.removeItem(n);
                        }
                        else {
                            f.add(this.c(a, k));
                        }
                        g.add(this.x(a, k));
                        if (f._inner[f.count - 1] == 11) {
                            i.add(this.k(a[k], n, c + 1));
                        }
                        else {
                            i.add(null);
                        }
                    }
                }
                for (let o of fromEnum(this.u)) {
                    let p = o.key.split('.');
                    for (let q = 0; q < p.length; q++) {
                        if (e.contains(p[q])) {
                            continue;
                        }
                        else {
                            d.add(p[q]);
                            e.add_1(p[q]);
                            f.add(q == p.length - 1 ? o.value : 11);
                            g.add(new List$1(String_$type, 0));
                        }
                    }
                }
            }
            let r = new Array(g.count);
            for (let s = 0; s < g.count; s++) {
                r[s] = g._inner[s].toArray();
            }
            return new DefaultDataSourceSchema(d.toArray(), f.toArray(), null, r, i.toArray());
        }
        resolveSchemaPropertyType(a) {
            let b = a.split('.');
            if (b.length == 1) {
                for (let c = 0; c < this.actualSchema.propertyNames.length; c++) {
                    if (this.actualSchema.propertyNames[c] == b[0]) {
                        return this.actualSchema.propertyTypes[c];
                    }
                }
                return 11;
            }
            else {
                let d = this.ac();
                let e = this.getItemValue(d, a);
                if (e == null) {
                    return 11;
                }
                else {
                    return DataSourceLocalDataProvider.e(e);
                }
            }
        }
        setSchema(a) {
            this.j = a;
            if (this.schemaChanged != null) {
                this.schemaChanged(this, new DataSourceDataProviderSchemaChangedEventArgs(this.j, this.actualCount));
            }
        }
        w(schemaItem_) {
            let propertyKey_ = null;
            let ret_ = new List$1(String_$type, 0);
            let exclusions_ = {};
            for (propertyKey_ in schemaItem_) {
                if (!isNaN(propertyKey_)) {
                    continue;
                }
                if (!exclusions_.hasOwnProperty(propertyKey_)) {
                    ret_.add(propertyKey_);
                }
            }
            ;
            return ret_;
        }
        am(a, item_, propertyName_, b) {
            if ((item_.__dataIntents !== undefined)) {
                if ((item_.__dataIntents[propertyName_] !== undefined)) {
                    this.al(a, item_, propertyName_);
                }
                let selfName_ = "self." + propertyName_;
                if (!b && (item_.__dataIntents[selfName_] !== undefined)) {
                    this.al(a, item_, selfName_);
                }
                let selfName2_ = "self_" + propertyName_;
                if (!b && (item_.__dataIntents[selfName2_] !== undefined)) {
                    this.al(a, item_, selfName2_);
                }
            }
        }
        al(a, item_, propertyName_) {
            let val_ = item_.__dataIntents[propertyName_];
            let b = typeCast(Array_$type, val_) !== null;
            if (!b) {
                b = (Array.isArray(val_));
            }
            if (b) {
                let c = val_;
                for (let d = 0; d < c.length; d++) {
                    if (c[d] != null) {
                        a.add(c[d].toString());
                    }
                }
            }
        }
        x(item_, propertyName_) {
            let a = new List$1(String_$type, 0);
            let list_ = this.y;
            let dataIntents_ = null;
            this.am(a, item_, propertyName_, false);
            this.am(a, list_, propertyName_, true);
            return a;
        }
        c(item_, propertyName_) {
            if (item_ == null) {
                return 11;
            }
            if ((item_[propertyName_] == undefined)) {
                return 11;
            }
            let value_ = item_[propertyName_];
            return DataSourceLocalDataProvider.e(value_);
        }
        static e(value_) {
            if (value_ == null) {
                return 11;
            }
            if ((typeof value_ == 'number')) {
                return 5;
            }
            if ((typeof value_ == 'boolean')) {
                return 2;
            }
            if ((typeof value_ == 'string')) {
                return 0;
            }
            if ((typeof value_ == 'object')) {
                if ((value_ instanceof Date)) {
                    return 8;
                }
            }
            return 11;
        }
        ac() {
            let a = 0;
            if (this.r) {
                a = (this.y.length);
            }
            else {
                a = this.y.count;
            }
            for (let b = 0; b < a; b++) {
                let c;
                if (this.r) {
                    c = this.y[b];
                }
                else {
                    c = this.y.item(b);
                }
                if (c != null) {
                    return c;
                }
            }
            return null;
        }
        ao(a, b, c) {
            this.aq(a, b, c);
        }
        get z() {
            return this.y;
        }
        aq(a, b, c) {
            switch (a) {
                case "ItemsSource":
                    this.j = null;
                    if (b != null) {
                        if (typeCast(INotifyCollectionChanged_$type, b) !== null) {
                            let d = typeCast(INotifyCollectionChanged_$type, b);
                            d.collectionChanged = delegateRemove(d.collectionChanged, runOn(this, this.an));
                        }
                    }
                    if (this.dataSource != null) {
                        this.r = false;
                        if (typeCast(Array_$type, this.dataSource) !== null) {
                            this.r = true;
                            this.y = this.dataSource;
                        }
                        else if (typeCast(IList_$type, this.dataSource) !== null) {
                            this.y = this.dataSource;
                        }
                        if (!this.r && this.y == null) {
                            let source_ = this.dataSource;
                            this.r = (Array.isArray(source_));
                            if (this.r) {
                                this.y = this.dataSource;
                            }
                        }
                        if (typeCast(INotifyCollectionChanged_$type, this.dataSource) !== null) {
                            let e = typeCast(INotifyCollectionChanged_$type, this.dataSource);
                            e.collectionChanged = delegateCombine(e.collectionChanged, runOn(this, this.an));
                        }
                    }
                    else {
                        this.y = null;
                    }
                    this.ak();
                    break;
                case "DeferAutoRefresh":
                    if (!c) {
                        this.queueAutoRefresh();
                    }
                    break;
                case "SchemaHints":
                    this.j = null;
                    this.ap();
                    this.ak();
                    break;
            }
        }
        an(a, b) {
            switch (b.action) {
                case 0:
                    if (b.newItems != null) {
                        this.notifyInsertItem(b.newStartingIndex, b.newItems.item(0));
                    }
                    break;
                case 1:
                    if (b.oldItems != null) {
                        this.notifyRemoveItem(b.oldStartingIndex, b.oldItems.item(0));
                    }
                    break;
                case 2:
                    if (b.newItems != null) {
                        this.notifySetItem(b.newStartingIndex, b.oldItems.item(0), b.newItems.item(0));
                    }
                    break;
                case 4:
                    this.notifyClearItems();
                    break;
            }
        }
        get executionContext() {
            return this.i;
        }
        set executionContext(a) {
            this.i = a;
        }
        get s() {
            return false;
        }
        notifySetItem(a, b, c) {
            if (this.s) {
                if (this.r) {
                    this.y[a] = c;
                }
                else {
                    this.y.item(a, c);
                }
            }
            if (this.updateNotifier != null) {
                this.updateNotifier.notifySetItem(a, b, c);
            }
        }
        notifyClearItems() {
            if (this.s) {
                if (this.r) {
                    this.y.length = 0;
                }
                else {
                    this.y.clear();
                }
            }
            if (this.updateNotifier != null) {
                this.updateNotifier.notifyClearItems();
            }
        }
        notifyInsertItem(a, b) {
            if (this.s) {
                if (this.r) {
                    this.y.splice(a, 0, b);
                }
                else {
                    this.y.insert(a, b);
                }
            }
            let c = 0;
            if (this.r) {
                c = (this.y.length);
            }
            else {
                c = this.y.count;
            }
            if (this.y != null && c == 1 && (this.actualSchema == null || this.actualSchema.propertyNames.length == 0)) {
                this.j = null;
                this.ak();
            }
            if (this.updateNotifier != null) {
                this.updateNotifier.notifyInsertItem(a, b);
            }
        }
        notifyRemoveItem(a, b) {
            if (this.s) {
                if (this.r) {
                    this.y.splice(a, 1);
                }
                else {
                    this.y.remove(a);
                }
            }
            if (this.updateNotifier != null) {
                this.updateNotifier.notifyRemoveItem(a, b);
            }
        }
        get updateNotifier() {
            return this.h;
        }
        set updateNotifier(a) {
            this.h = a;
        }
        get deferAutoRefresh() {
            return this.q;
        }
        set deferAutoRefresh(a) {
            let b = this.q;
            this.q = a;
            if (this.q != b) {
                this.ao("DeferAutoRefresh", b, this.q);
            }
        }
        get isSortingSupported() {
            return false;
        }
        get isFilteringSupported() {
            return false;
        }
        get sortDescriptions() {
            return this.n;
        }
        get filterExpressions() {
            return this.g;
        }
        get summaryDescriptions() {
            return this.o;
        }
        get summaryScope() {
            return this.f;
        }
        set summaryScope(a) {
            this.f = a;
        }
        get notifyUsingSourceIndexes() {
            return true;
        }
        get propertiesRequested() {
            return this.a;
        }
        set propertiesRequested(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
            }
        }
        get isItemIndexLookupSupported() {
            return true;
        }
        get isKeyIndexLookupSupported() {
            return false;
        }
        get isGroupingSupported() {
            return false;
        }
        get groupDescriptions() {
            return this.m;
        }
        queueAutoRefresh() {
            if (this.deferAutoRefresh) {
                return;
            }
            if (this.p) {
                return;
            }
            if (this.executionContext != null) {
                this.p = true;
                this.executionContext.enqueueAction(runOn(this, this.aj));
            }
        }
        aj() {
            if (this.deferAutoRefresh) {
                this.p = false;
                return;
            }
            if (!this.p) {
                return;
            }
            this.p = false;
            this.ar();
        }
        ar() {
            this.as();
        }
        as() {
        }
        flushAutoRefresh() {
            this.aj();
        }
        refresh() {
            this.ar();
        }
        indexOfItem(a) {
            if (this.y == null) {
                return -1;
            }
            return this.y.indexOf(a);
        }
        indexOfKey(a) {
            return -1;
        }
        get schemaIncludedProperties() {
            return this.b;
        }
        set schemaIncludedProperties(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
            }
        }
    }
    DataSourceLocalDataProvider.$t = /*@__PURE__*/ markType(DataSourceLocalDataProvider, 'DataSourceLocalDataProvider', Base.$, [IDataSourceLocalDataProvider_$type]);
    return DataSourceLocalDataProvider;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var DataSourceSummaryOperand = /*@__PURE__*/ (function (DataSourceSummaryOperand) {
    DataSourceSummaryOperand[DataSourceSummaryOperand["Min"] = 0] = "Min";
    DataSourceSummaryOperand[DataSourceSummaryOperand["Max"] = 1] = "Max";
    DataSourceSummaryOperand[DataSourceSummaryOperand["Sum"] = 2] = "Sum";
    DataSourceSummaryOperand[DataSourceSummaryOperand["Average"] = 3] = "Average";
    DataSourceSummaryOperand[DataSourceSummaryOperand["Count"] = 4] = "Count";
    DataSourceSummaryOperand[DataSourceSummaryOperand["Custom"] = 5] = "Custom";
    return DataSourceSummaryOperand;
})({});
/**
 * @hidden
 */
let DataSourceSummaryOperand_$type = /*@__PURE__*/ markEnum('DataSourceSummaryOperand', 'Min,0|Max,1|Sum,2|Average,3|Count,4|Custom,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AggregatedDataProviderLayerInfo = /*@__PURE__*/ (() => {
    class AggregatedDataProviderLayerInfo extends Base {
        constructor() {
            super(...arguments);
            this.f = new List$1(String_$type, 0);
            this.e = new List$1(String_$type, 0);
            this.h = new List$1(Base.$, 0);
            this.g = new List$1(DataSourceSummaryOperand_$type, 0);
            this.b = new List$1(String_$type, 0);
            this.c = new List$1(Base.$, 0);
            this.d = new List$1(Base.$, 0);
        }
        p(a, b, c, d) {
            this.m.add(a);
            this.l.add(b);
            this.n.add(c);
            this.o.add1(d);
        }
        get a() {
            return this.i != null && this.i.count == 1;
        }
        get m() {
            return this.f;
        }
        get l() {
            return this.e;
        }
        get o() {
            return this.h;
        }
        get n() {
            return this.g;
        }
        get i() {
            return this.b;
        }
        set i(a) {
            this.b = a;
        }
        get j() {
            return this.c;
        }
        set j(a) {
            this.c = a;
        }
        get k() {
            return this.d;
        }
        set k(a) {
            this.d = a;
        }
    }
    AggregatedDataProviderLayerInfo.$t = /*@__PURE__*/ markType(AggregatedDataProviderLayerInfo, 'AggregatedDataProviderLayerInfo');
    return AggregatedDataProviderLayerInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AggregatedDataProviderTopLayer = /*@__PURE__*/ (() => {
    class AggregatedDataProviderTopLayer extends Base {
        constructor() {
            super(...arguments);
            this.q = "";
            this.m = "";
            this.c = new List$1(AggregatedDataProviderLayerInfo.$, 0);
            this.e = new List$1(String_$type, 0);
            this.d = new List$1(String_$type, 0);
            this.g = new List$1(Base.$, 0);
            this.f = new List$1(DataSourceSummaryOperand_$type, 0);
        }
        n() {
            return {};
        }
        z(a, b, c) {
            let d = a;
            d[b] = c;
        }
        o(a) {
            let b = this.n();
            this.z(b, this.w, this.p);
            if (this.j.count == 0) {
            }
            let c = this.a();
            for (let d = 0; d < this.j.count; d++) {
                let e = this.s(d);
                this.z(b, e, this.l._inner[d]);
                let f = this.r(d);
                this.z(b, f, c);
            }
            for (let g = 0; g < this.h.count; g++) {
                let h = this.h._inner[g];
                if (h.a) {
                    continue;
                }
                let i = this.b(h);
                if (h.m != null && h.m.count > 0) {
                    for (let j = 0; j < h.m.count; j++) {
                        let k = h.m._inner[j];
                        let l = h.n._inner[j];
                        let m = h.o._inner[j];
                        let n = this.u(h, k, l, j);
                        this.z(b, n, m);
                        let o = this.t(h, k, l, j);
                        this.z(b, o, c);
                        if (!a.contains(n)) {
                            a.add(n);
                        }
                    }
                }
            }
            return b;
        }
        t(a, b, c, d) {
            let e = this.u(a, b, c, d);
            return e + "_Drill";
        }
        u(a, b, c, d) {
            let e = "";
            for (let f = 1; f < a.j.count; f++) {
                let g = a.j._inner[f];
                if (g == null) {
                    continue;
                }
                e += g.toString();
            }
            if (a.l._inner[d] != null) {
                return e + a.l._inner[d];
            }
            let h = b;
            let i = this.v(c);
            return e + h + i;
        }
        r(a) {
            return this.s(a) + "_Drill";
        }
        v(a) {
            let b = "";
            switch (a) {
                case 3:
                    b = "Average";
                    break;
                case 4:
                    b = "Count";
                    break;
                case 5:
                    b = "Custom";
                    break;
                case 1:
                    b = "Max";
                    break;
                case 0:
                    b = "Min";
                    break;
                case 2:
                    b = "Sum";
                    break;
            }
            return b;
        }
        s(a) {
            if (this.i._inner[a] != null) {
                return this.i._inner[a];
            }
            let b = this.j._inner[a];
            let c = this.v(this.k._inner[a]);
            return b + c;
        }
        x() {
            let a = this.a();
            let b = a.length;
            this.j.add(this.w);
            this.k.add(4);
            this.l.add1(b);
        }
        a() {
            let a = new List$1(Base.$, 0);
            for (let b = 0; b < this.h.count; b++) {
                if (this.h._inner[b].a) {
                    for (let c = 0; c < this.h._inner[b].k.count; c++) {
                        a.add1(this.h._inner[b].k._inner[c]);
                    }
                }
            }
            return a.toArray();
        }
        b(a) {
            let b = new List$1(Base.$, 0);
            for (let c = 0; c < a.k.count; c++) {
                b.add1(a.k._inner[c]);
            }
            return b.toArray();
        }
        get w() {
            return this.q;
        }
        set w(a) {
            this.q = a;
        }
        get p() {
            return this.m;
        }
        set p(a) {
            this.m = a;
        }
        get h() {
            return this.c;
        }
        y(a, b, c, d) {
            this.j.add(a);
            this.i.add(b);
            this.k.add(c);
            this.l.add1(d);
        }
        get j() {
            return this.e;
        }
        get i() {
            return this.d;
        }
        get l() {
            return this.g;
        }
        get k() {
            return this.f;
        }
    }
    AggregatedDataProviderTopLayer.$t = /*@__PURE__*/ markType(AggregatedDataProviderTopLayer, 'AggregatedDataProviderTopLayer');
    return AggregatedDataProviderTopLayer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AggregatedDataProviderLayerMap = /*@__PURE__*/ (() => {
    class AggregatedDataProviderLayerMap extends Base {
        constructor() {
            super(...arguments);
            this.c = new Dictionary$2(Base.$, AggregatedDataProviderTopLayer.$, 0);
            this.d = new List$1(AggregatedDataProviderTopLayer.$, 0);
        }
        a(a) {
            let b = new List$1(Base.$, 0);
            for (let c = 0; c < this.d.count; c++) {
                let d = this.d._inner[c];
                let e = d.o(a);
                b.add1(e);
            }
            return b.toArray();
        }
        b(a) {
            let b = a == null ? AggregatedDataProviderLayerMap.e : a;
            if (this.c.containsKey(b)) {
                return this.c.item(b);
            }
            return null;
        }
        f(a) {
            let b = a.j._inner[0] == null ? AggregatedDataProviderLayerMap.e : a.j._inner[0];
            let c;
            if (!this.c.containsKey(b)) {
                c = new AggregatedDataProviderTopLayer();
                this.d.add(c);
                c.w = a.i._inner[0];
                c.p = b;
                this.c.addItem(c.p, c);
            }
            else {
                c = this.c.item(b);
            }
            c.h.add(a);
        }
    }
    AggregatedDataProviderLayerMap.$t = /*@__PURE__*/ markType(AggregatedDataProviderLayerMap, 'AggregatedDataProviderLayerMap');
    AggregatedDataProviderLayerMap.e = {};
    return AggregatedDataProviderLayerMap;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceUpdateNotifier_$type = /*@__PURE__*/ new Type(null, 'IDataSourceUpdateNotifier');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AggregatedDataProvider = /*@__PURE__*/ (() => {
    class AggregatedDataProvider extends Base {
        constructor() {
            super();
            this.g = new DataSourceLocalDataProvider();
            this.c = null;
            this.r = null;
            this.j = false;
            this.q = null;
            this.i = false;
            this.schemaChanged = null;
            this.propertyChanged = null;
            this.h = false;
            this.k = true;
            this.o = new List$1(String_$type, 0);
            let a = this.g;
            a.schemaChanged = delegateCombine(a.schemaChanged, runOn(this, this.ab));
        }
        clone() {
            let a = new AggregatedDataProvider();
            a.deferAutoRefresh = this.deferAutoRefresh;
            a.executionContext = this.executionContext;
            a.dataSource = this.dataSource;
            a.propertiesRequested = this.propertiesRequested;
            a.schemaHints = this.schemaHints;
            a.summaryScope = this.summaryScope;
            a.includeParentSummary = this.includeParentSummary;
            if (this.targetDataSource != null) {
                a.targetDataSource = this.targetDataSource.clone();
            }
            for (let b = 0; b < this.groupDescriptions.k.count; b++) {
                a.groupDescriptions.add(this.groupDescriptions.k.item(b));
            }
            for (let c = 0; c < this.sortDescriptions.k.count; c++) {
                a.sortDescriptions.add(this.sortDescriptions.k.item(c));
            }
            for (let d = 0; d < this.filterExpressions.k.count; d++) {
                a.filterExpressions.add(this.filterExpressions.k.item(d));
            }
            for (let e = 0; e < this.summaryDescriptions.k.count; e++) {
                a.summaryDescriptions.add(this.summaryDescriptions.k.item(e));
            }
            return a;
        }
        ab(a, b) {
            if (this.schemaChanged != null) {
                this.schemaChanged(this, b);
            }
        }
        get targetDataSource() {
            return this.c;
        }
        set targetDataSource(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.ai("TargetDataSource", b, this.c);
            }
        }
        get schemaHints() {
            return this.r;
        }
        set schemaHints(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.ai("SchemaHints", b, this.r);
            }
        }
        get includeParentSummary() {
            return this.j;
        }
        set includeParentSummary(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.ai("IncludeParentSummary", b, this.r);
            }
        }
        get actualSchema() {
            return this.g.actualSchema;
        }
        get executionContext() {
            return this.g.executionContext;
        }
        set executionContext(a) {
            this.g.executionContext = a;
        }
        get updateNotifier() {
            return this.g.updateNotifier;
        }
        set updateNotifier(a) {
            this.g.updateNotifier = a;
        }
        get dataSource() {
            return this.q;
        }
        set dataSource(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.ai("ItemsSource", b, this.q);
            }
        }
        get deferAutoRefresh() {
            return this.i;
        }
        set deferAutoRefresh(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.ai("DeferAutoRefresh", b, this.i);
            }
        }
        get isSortingSupported() {
            return this.g.isSortingSupported;
        }
        get isGroupingSupported() {
            return this.g.isGroupingSupported;
        }
        get isFilteringSupported() {
            return this.g.isFilteringSupported;
        }
        get sortDescriptions() {
            return this.g.sortDescriptions;
        }
        get groupDescriptions() {
            return this.g.groupDescriptions;
        }
        get summaryDescriptions() {
            return this.g.summaryDescriptions;
        }
        get summaryScope() {
            return this.g.summaryScope;
        }
        set summaryScope(a) {
            this.g.summaryScope = a;
        }
        get filterExpressions() {
            return this.g.filterExpressions;
        }
        get propertiesRequested() {
            return this.g.propertiesRequested;
        }
        set propertiesRequested(a) {
            this.g.propertiesRequested = a;
        }
        get schemaIncludedProperties() {
            return this.g.schemaIncludedProperties;
        }
        set schemaIncludedProperties(a) {
            this.g.schemaIncludedProperties = a;
        }
        get notifyUsingSourceIndexes() {
            return true;
        }
        get isItemIndexLookupSupported() {
            return this.g.isItemIndexLookupSupported;
        }
        get isKeyIndexLookupSupported() {
            return this.g.isKeyIndexLookupSupported;
        }
        get actualCount() {
            return this.g.actualCount;
        }
        ai(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.ao(a, b, c);
        }
        ao(a, b, c) {
            switch (a) {
                case "ItemsSource":
                    this.g.dataSource = c;
                    break;
                case "DeferAutoRefresh":
                    if (!c) {
                        this.queueAutoRefresh();
                    }
                    break;
                case "TargetDataSource":
                    if (b != null) {
                        let d = b;
                        if (d.updateNotifier != null) {
                            if (typeCast(AggregatedDataProviderTargetDataSourceNotifier.$, d.updateNotifier) !== null) {
                                d.updateNotifier = d.updateNotifier.c;
                            }
                        }
                        d.schemaChanged = delegateRemove(d.schemaChanged, runOn(this, this.ah));
                    }
                    if (c != null) {
                        let e = c;
                        this.g.executionContext = e.executionContext;
                        let f = new AggregatedDataProviderTargetDataSourceNotifier(this, e.updateNotifier);
                        e.updateNotifier = f;
                        e.schemaChanged = delegateCombine(e.schemaChanged, runOn(this, this.ah));
                    }
                    this.queueAutoRefresh();
                    break;
            }
        }
        ah(a, b) {
            this.k = true;
            this.queueAutoRefresh();
        }
        addItem(a) {
            this.g.addItem(a);
        }
        queueAutoRefresh() {
            if (this.deferAutoRefresh) {
                return;
            }
            if (this.h) {
                return;
            }
            if (this.executionContext != null) {
                this.h = true;
                this.executionContext.enqueueAction(runOn(this, this.ae));
            }
        }
        ae() {
            if (this.deferAutoRefresh) {
                this.h = false;
                return;
            }
            if (!this.h) {
                return;
            }
            this.h = false;
            this.ap();
        }
        ap() {
            this.aq();
        }
        aq() {
            if (this.c == null) {
                return;
            }
            if (!this.k) {
                return;
            }
            this.k = false;
            let a = this.c.clone();
            let b = this.c.clone();
            a = this.d(a);
            b = this.e(b);
            a.flushAutoRefresh();
            b.flushAutoRefresh();
            this.o.clear();
            let c = this.a(b, a, 0, 0);
            this.t(c, this.o);
            this.dataSource = c;
        }
        t(a, b) {
            if (b.count == 0) {
                return null;
            }
            for (let d = 0; d < a.length; d++) {
                let c = a[d];
                let e = c;
                for (let f of fromEnum(b)) {
                    if (e[f] == null) {
                        e[f] = NaN;
                    }
                }
            }
            return null;
        }
        d(a) {
            a.shouldEmitSummaryRows = false;
            a.includeSummaryRowsInSection = false;
            a.summaryScope = 2;
            a.isSectionSummaryRowsAtBottom = true;
            a.sectionHeaderDisplayMode = 0;
            if (a.summaryDescriptions.k.count == 0) {
                for (let b = 1; b < a.groupDescriptions.k.count; b++) {
                    a.summaryDescriptions.k.add(new SummaryDescription(2, a.groupDescriptions.k.item(b).propertyName, 4));
                }
            }
            return a;
        }
        e(a) {
            a.shouldEmitSummaryRows = false;
            a.includeSummaryRowsInSection = false;
            a.summaryScope = 2;
            a.isSectionSummaryRowsAtBottom = true;
            a.sectionHeaderDisplayMode = 0;
            while (a.groupDescriptions.k.count > 1) {
                a.groupDescriptions.k.removeAt(a.groupDescriptions.k.count - 1);
            }
            if (a.summaryDescriptions.k.count == 0) {
                for (let b = 0; b < a.groupDescriptions.k.count; b++) {
                    a.summaryDescriptions.k.add(new SummaryDescription(2, a.groupDescriptions.k.item(b).propertyName, 4));
                }
            }
            return a;
        }
        flushAutoRefresh() {
            this.ae();
        }
        refresh() {
            this.ap();
        }
        getItemAtIndex(a) {
            return this.g.getItemAtIndex(a);
        }
        getItemValue(a, b) {
            return this.g.getItemValue(a, b);
        }
        indexOfItem(a) {
            return this.g.indexOfItem(a);
        }
        indexOfKey(a) {
            return this.g.indexOfKey(a);
        }
        removeItem(a) {
            this.g.removeItem(a);
        }
        resolveSchemaPropertyType(a) {
            return this.g.resolveSchemaPropertyType(a);
        }
        setItemValue(a, b, c) {
            this.g.setItemValue(a, b, c);
        }
        notifyClearItems() {
            if (this.targetDataSource != null) {
                this.targetDataSource.notifyClearItems();
            }
        }
        notifyInsertItem(a, b) {
            if (this.targetDataSource != null) {
                this.targetDataSource.notifyInsertItem(a, b);
            }
        }
        notifyRemoveItem(a, b) {
            if (this.targetDataSource != null) {
                this.targetDataSource.notifyRemoveItem(a, b);
            }
        }
        notifySetItem(a, b, c) {
            if (this.targetDataSource != null) {
                this.targetDataSource.notifySetItem(a, b, c);
            }
        }
        p(a) {
            return a.groupDescriptions.k.count;
        }
        a(a, b, c, d) {
            if (d == this.p(b)) {
                let e = this.z(b, c, d);
                return e.d;
            }
            if (d == 0) {
                let f = new AggregatedDataProviderLayerMap();
                let g = this.aa(f, a, c, d);
                g = this.aa(f, b, c, d);
                return g.d;
            }
            return new Array(0);
        }
        aa(a, b, c, d) {
            let e = false;
            let f = 0;
            let g = null;
            for (let h = c; h < b.actualCount; h++) {
                let i = b.getRowType(h);
                if (i == 3 || i == 6) {
                    continue;
                }
                if (!e) {
                    if (i == 0) {
                        e = true;
                    }
                    if (i == 1) {
                        e = true;
                        f = 0;
                        g = this.b(a, b, h, d);
                        this.ag(a, b, g, h, d);
                        continue;
                    }
                }
                let j = b.getItemAtIndex(h);
                if (g != null && i == 0) {
                    g.k.add1(j);
                }
                if (g != null && this.l(b, j, h)) {
                    if (b.getRowType(h) == 1) {
                        h--;
                    }
                    e = false;
                    g = null;
                }
            }
            return new Tuple$2(Number_$type, Array_$type, b.actualCount, a.a(this.o));
        }
        ag(a, b, c, d, e) {
            let f = b.getRowType(d);
            if (f == 1) {
                let g = b.getItemAtIndex(d);
                if (c.i.count == 1) {
                    this.ad(a, b, g, c);
                }
                else {
                    this.ac(b, g, c);
                }
            }
        }
        af(a, b, c, d, e) {
            let f = b.getRowType(d);
            if (f == 5) {
                let g = b.getItemAtIndex(d);
                if (this.n(g, c)) {
                    if (c.i.count == 1) {
                        this.ad(a, b, g, c);
                    }
                    else {
                        this.ac(b, g, c);
                    }
                }
            }
            let h = 1;
            while (d + h < b.actualCount && b.getRowType(d + h) == 5) {
                let i = b.getRowType(d + h);
                if (i == 5) {
                    let j = b.getItemAtIndex(d + h);
                    if (c.i.count == 1) {
                        this.ad(a, b, j, c);
                    }
                    else {
                        this.ac(b, j, c);
                    }
                }
                h++;
            }
        }
        ad(a, b, c, d) {
            let e = a.b(d.j._inner[0]);
            let f = c.summaryResults;
            if (e != null) {
                for (let g = 0; g < f.length; g++) {
                    let h = f[g];
                    e.y(h.propertyName, b.summaryDescriptions.k.item(g).alias, h.operand, h.value);
                }
            }
        }
        ac(a, b, c) {
            let d = b.summaryResults;
            for (let e = 0; e < d.length; e++) {
                let f = d[e];
                c.p(f.propertyName, a.summaryDescriptions.k.item(e).alias, f.operand, f.value);
            }
        }
        n(a, b) {
            return a.level == 1;
        }
        b(a, b, c, d) {
            let e = b.getItemAtIndex(c);
            let f = e.getSectionKeys();
            let g = new List$1(String_$type, 0);
            for (let h = 0; h < f.length; h++) {
                g.add(f[h]);
            }
            let i = new List$1(Base.$, 0);
            for (let j = 0; j < g.count; j++) {
                i.add1(e.getSectionValue(g._inner[j]));
            }
            let k = new AggregatedDataProviderLayerInfo();
            k.i = g;
            k.j = i;
            a.f(k);
            return k;
        }
        z(a, b, c) {
            let d = new List$1(Base.$, 0);
            let e = false;
            for (let f = b; f < a.actualCount; f++) {
                let g = a.getRowType(f);
                if (g == 3 || g == 6) {
                    continue;
                }
                if (!e) {
                    if (g == 0) {
                        e = true;
                    }
                    if (g == 1) {
                        e = true;
                        continue;
                    }
                }
                let h = a.getItemAtIndex(f);
                d.add1(h);
                if (this.l(a, h, f)) {
                    return new Tuple$2(Number_$type, Array_$type, f, d.toArray());
                }
            }
            return new Tuple$2(Number_$type, Array_$type, a.actualCount, d.toArray());
        }
        l(a, b, c) {
            if (a.getRowType(c) != 0) {
                return true;
            }
            return false;
        }
        aj() {
            this.k = true;
            this.queueAutoRefresh();
        }
        ak(a, b) {
            this.k = true;
            this.queueAutoRefresh();
        }
        al(a, b) {
            this.k = true;
            this.queueAutoRefresh();
        }
        am(a, b, c) {
            this.k = true;
            this.queueAutoRefresh();
        }
        an(a, b) {
            this.k = true;
            this.queueAutoRefresh();
        }
    }
    AggregatedDataProvider.$t = /*@__PURE__*/ markType(AggregatedDataProvider, 'AggregatedDataProvider', Base.$, [IDataSourceLocalDataProvider_$type, INotifyPropertyChanged_$type]);
    return AggregatedDataProvider;
})();
/**
 * @hidden
 */
let AggregatedDataProviderTargetDataSourceNotifier = /*@__PURE__*/ (() => {
    class AggregatedDataProviderTargetDataSourceNotifier extends Base {
        get c() {
            return this.b;
        }
        constructor(a, b) {
            super();
            this.a = null;
            this.b = null;
            this.a = a;
            this.b = b;
        }
        notifyClearItems() {
            this.a.aj();
            if (this.b != null) {
                this.b.notifyClearItems();
            }
        }
        notifyInsertItem(a, b) {
            this.a.ak(a, b);
            if (this.b != null) {
                this.b.notifyInsertItem(a, b);
            }
        }
        notifyRemoveItem(a, b) {
            this.a.al(a, b);
            if (this.b != null) {
                this.b.notifyRemoveItem(a, b);
            }
        }
        notifySetItem(a, b, c) {
            this.a.am(a, b, c);
            if (this.b != null) {
                this.b.notifySetItem(a, b, c);
            }
        }
        rangeActualized(a, b) {
            this.a.an(a, b);
            if (this.b != null) {
                this.b.rangeActualized(a, b);
            }
        }
    }
    AggregatedDataProviderTargetDataSourceNotifier.$t = /*@__PURE__*/ markType(AggregatedDataProviderTargetDataSourceNotifier, 'AggregatedDataProviderTargetDataSourceNotifier', Base.$, [IDataSourceUpdateNotifier_$type]);
    return AggregatedDataProviderTargetDataSourceNotifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enumerates the join types available to the flat data provider.
 */
var FlatDataProviderJoinType = /*@__PURE__*/ (function (FlatDataProviderJoinType) {
    /**
     * Performs an inner join.
     */
    FlatDataProviderJoinType[FlatDataProviderJoinType["Join"] = 0] = "Join";
    /**
     * Performs a left outer join.
     */
    FlatDataProviderJoinType[FlatDataProviderJoinType["Left"] = 1] = "Left";
    /**
     * Performs a right outer join.
     */
    FlatDataProviderJoinType[FlatDataProviderJoinType["Right"] = 2] = "Right";
    return FlatDataProviderJoinType;
})({});
/**
 * @hidden
 */
let FlatDataProviderJoinType_$type = /*@__PURE__*/ markEnum('FlatDataProviderJoinType', 'Join,0|Left,1|Right,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enumerates the join types available to the flat data provider.
 */
var FlatDataProviderJoinCollisionType = /*@__PURE__*/ (function (FlatDataProviderJoinCollisionType) {
    /**
     * Retention is based on the join type.
     */
    FlatDataProviderJoinCollisionType[FlatDataProviderJoinCollisionType["Auto"] = 0] = "Auto";
    /**
     * Retains values only if they are from left.
     */
    FlatDataProviderJoinCollisionType[FlatDataProviderJoinCollisionType["LeftOnly"] = 1] = "LeftOnly";
    /**
     * Retains values only if they are from right.
     */
    FlatDataProviderJoinCollisionType[FlatDataProviderJoinCollisionType["RightOnly"] = 2] = "RightOnly";
    /**
     * Prefers to retain values from left.
     */
    FlatDataProviderJoinCollisionType[FlatDataProviderJoinCollisionType["PreferLeft"] = 3] = "PreferLeft";
    /**
     * Prefers to retain values from right.
     */
    FlatDataProviderJoinCollisionType[FlatDataProviderJoinCollisionType["PreferRight"] = 4] = "PreferRight";
    return FlatDataProviderJoinCollisionType;
})({});
/**
 * @hidden
 */
let FlatDataProviderJoinCollisionType_$type = /*@__PURE__*/ markEnum('FlatDataProviderJoinCollisionType', 'Auto,0|LeftOnly,1|RightOnly,2|PreferLeft,3|PreferRight,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IPageCandidatesSink_$type = /*@__PURE__*/ new Type(null, 'IPageCandidatesSink');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceVelocityReading = /*@__PURE__*/ (() => {
    class DataSourceVelocityReading extends Base {
        constructor(a, b) {
            super();
            this.b = null;
            this.a = 0;
            this.b = a;
            this.a = b;
        }
    }
    DataSourceVelocityReading.$t = /*@__PURE__*/ markType(DataSourceVelocityReading, 'DataSourceVelocityReading');
    return DataSourceVelocityReading;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceVelocityTracker = /*@__PURE__*/ (() => {
    class DataSourceVelocityTracker extends Base {
        constructor() {
            super();
            this.f = 0;
            this.d = 6;
            this.a = null;
            this.b = 0;
            this.c = 0;
            this.f = this.g();
            this.c = 0;
            this.a = new Array(this.d);
        }
        i(a) {
            let b = this.e();
            this.a[this.b] = new DataSourceVelocityReading(a, b);
            this.b++;
            if (this.b > (this.d - 1)) {
                this.b = 0;
            }
        }
        h() {
            for (let a = 0; a < this.d; a++) {
                this.a[a] = null;
            }
        }
        j() {
            let a = 0x7FFFFFFF;
            let b = -2147483648;
            let c = 0;
            let d = 0;
            let e = 0;
            let f = 0;
            let g = this.e();
            for (let h = 0; h < this.d; h++) {
                if (this.a[h] == null) {
                    continue;
                }
                if ((g - this.a[h].a) > 300) {
                    continue;
                }
                if (this.a[h].a < a) {
                    a = this.a[h].a;
                    c = this.a[h].b.x;
                    d = this.a[h].b.y;
                }
                if (this.a[h].a > b) {
                    b = this.a[h].a;
                    e = this.a[h].b.x;
                    f = this.a[h].b.y;
                }
            }
            let i = b - a;
            i = Math.max(i, 16);
            let j = (i) / 1000;
            if (j == 0) {
                return { $type: Point_$type, x: c, y: d };
            }
            return { $type: Point_$type, x: (e - c) / j, y: (f - d) / j };
        }
        g() {
            let a = dateNow();
            return a.getTime();
        }
        e() {
            let a = (this.g() - this.f);
            if (a == this.c) {
                a += 1;
            }
            this.c = a;
            return a;
        }
    }
    DataSourceVelocityTracker.$t = /*@__PURE__*/ markType(DataSourceVelocityTracker, 'DataSourceVelocityTracker');
    return DataSourceVelocityTracker;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PagePredictionEngine = /*@__PURE__*/ (() => {
    class PagePredictionEngine extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.s = 0;
            this.u = 0;
            this.x = -1;
            this.t = -1;
            this.y = 500;
            this.r = 1000;
            this.v = 8;
            this.d = null;
            this.f = null;
            this.w = 0;
            this.propertyChanged = null;
            this.i = false;
            this.h = false;
            this.g = new FastIterationDictionary$2(Base.$, Number_$type, 0);
            this.p = new List$1(Number_$type, 0);
            this.o = new List$1(Number_$type, 0);
            this.c = new DataSourceVelocityTracker();
            this.q = 0;
        }
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.ay("ExecutionContext", b, this.a);
            }
        }
        get aa() {
            return this.s;
        }
        set aa(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.ay("FirstVisibleIndexRequested", b, this.s);
            }
        }
        get ae() {
            return this.u;
        }
        set ae(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.ay("LastVisibleIndexRequested", b, this.u);
            }
        }
        get ag() {
            return this.x;
        }
        set ag(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.ay("PageSize", b, this.x);
            }
        }
        get ab() {
            return this.t;
        }
        set ab(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.ay("FullCount", b, this.t);
            }
        }
        get ah() {
            return this.y;
        }
        set ah(a) {
            let b = this.y;
            this.y = a;
            if (b != this.y) {
                this.ay(PagePredictionEngine.aq, b, this.y);
            }
        }
        get z() {
            return this.r;
        }
        set z(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.ay("FetchAheadMilliseconds", b, this.r);
            }
        }
        get af() {
            return this.v;
        }
        set af(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.ay("MaximumPageCandidates", b, this.v);
            }
        }
        get e() {
            return this.d;
        }
        set e(a) {
            let b = this.d;
            this.d = a;
            if (b != this.d) {
                this.ay("PageCandidatesSink", b, this.d);
            }
        }
        ay(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.az(a, b, c);
        }
        az(a, b, c) {
            switch (a) {
                case "FirstVisibleIndexRequested":
                case "LastVisibleIndexRequested":
                    this.aw();
                    break;
                case "ExecutionContext":
                    this.ax();
                    break;
                case "FullCount":
                    this.a2();
                    break;
                case "PageSize":
                    this.a2();
                    break;
            }
        }
        a2() {
            this.c.h();
            this.q = 0;
            let a = new List$1(Number_$type, 0);
            for (let b = 0; b < this.g.q.count; b++) {
                if (this.g.p._inner[b]) {
                    continue;
                }
                a.add(this.g.q._inner[b]);
            }
            for (let c = 0; c < a.count; c++) {
                this.a1(a._inner[c]);
            }
            if (this.ab > 0 && this.ag > 0) {
                this.w = truncate(Math.ceil(this.ab / this.ag));
            }
        }
        ax() {
            this.au();
        }
        au() {
            if (this.i) {
                return;
            }
            if (this.b != null) {
                this.i = true;
                this.b.enqueueAction(runOn(this, this.av));
            }
        }
        av() {
            this.i = false;
            this.a4();
        }
        a4() {
            if (this.t == -1 || this.x == -1) {
                return;
            }
            this.at();
            this.a5();
            this.a6();
            if (this.q != 0) {
                this.as();
            }
        }
        a3() {
            this.h = false;
            this.a4();
        }
        as() {
            if (this.h) {
                return;
            }
            if (this.b != null) {
                this.h = true;
                this.b.executeDelayed(runOn(this, this.a3), 0);
            }
        }
        a6() {
            let a = this.ac();
            let b = this.ad();
            let c = true;
            let d;
            for (let e = a; e <= b; e++) {
                d = e;
                c = this.j(d, 2);
            }
            if (this.q > 0) {
                d = b;
                while (c) {
                    d++;
                    c = this.j(d, 1);
                }
            }
            else if (this.q < 0) {
                d = a;
                while (c) {
                    d--;
                    c = this.j(d, 1);
                }
            }
            this.a0();
        }
        a0() {
            this.o.clear();
            let a = this.g.o;
            let b = this.g.o.count;
            let c = this.g.p;
            for (let d = 0; d < b; d++) {
                if (c._inner[d]) {
                    continue;
                }
                let e = typeGetValue(a._inner[d]);
                this.o.add(e);
            }
            for (let f = 0; f < this.o.count; f++) {
                this.j(this.o._inner[f], 1);
            }
        }
        j(a, b) {
            if (a < 0 || a > this.w) {
                return false;
            }
            if (this.l(a)) {
                this.a1(a);
                return false;
            }
            if (this.m(a, this.z)) {
                this.a1(a);
                return false;
            }
            if (this.n()) {
                this.a1(a);
                return false;
            }
            this.ar(a, b);
            return true;
        }
        ar(a, b) {
            if (!this.g.d(a)) {
                if (this.d != null) {
                    if (this.d.addCandidate(a, b)) {
                        this.g.s(a, a);
                    }
                }
            }
        }
        a1(a) {
            if (this.g.d(a)) {
                this.g.f(a);
                if (this.d != null) {
                    this.d.removeCandidate(a);
                }
            }
        }
        n() {
            return this.g.r >= this.af;
        }
        m(a, b) {
            let c = b / 1000;
            let d = c * this.q;
            if (this.k(a)) {
                return false;
            }
            if (d > 0) {
                let e = d + this.ae;
                if (e >= (a * this.ag)) {
                    return false;
                }
            }
            else {
                let f = this.aa + d;
                if (f <= ((a * this.ag) + this.ag)) {
                    return false;
                }
            }
            return true;
        }
        k(a) {
            let b = a * this.ag;
            let c = b + this.ag;
            if (this.ae < b || this.aa > c) {
                return false;
            }
            return true;
        }
        l(a) {
            let b = this.ah / 1000;
            let c = b * this.q;
            if (c > 0) {
                let d = c + this.aa;
                if (d > (a * this.ag) + this.ag) {
                    return true;
                }
            }
            else {
                let e = this.ae + c;
                if (e < (a * this.ag)) {
                    return true;
                }
            }
            return false;
        }
        ac() {
            return truncate(Math.floor(this.aa / this.ag));
        }
        ad() {
            return truncate(Math.floor(this.ae / this.ag));
        }
        a5() {
            this.q = this.c.j().y;
        }
        at() {
            this.c.i({ $type: Point_$type, x: 0, y: this.aa });
        }
        aw() {
            if (this.b != null) {
                this.b.enqueueAction(runOn(this, this.a4));
            }
        }
    }
    PagePredictionEngine.$t = /*@__PURE__*/ markType(PagePredictionEngine, 'PagePredictionEngine', Base.$, [INotifyPropertyChanged_$type]);
    PagePredictionEngine.aq = "PageVisibilityDisplayThresholdMilliseconds";
    return PagePredictionEngine;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourcePage_$type = /*@__PURE__*/ new Type(null, 'IDataSourcePage');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionData = /*@__PURE__*/ (() => {
    class SectionData extends Base {
        constructor() {
            super(...arguments);
            this.o = false;
            this.ae = 0;
            this.af = 0;
            this.ad = 0;
            this.e = null;
            this.f = null;
            this.i = null;
            this.h = null;
            this.g = null;
            this.aa = 0;
            this.ah = 0;
            this.ag = 0;
            this.t = 0;
            this.d = null;
            this.u = 0;
            this.b = null;
            this.s = -1;
            this.c = null;
            this.a = null;
            this.y = 0;
            this.l = true;
            this.k = null;
        }
        get z() {
            return this.s;
        }
        set z(a) {
            this.s = a;
        }
        get ac() {
            return this.af + this.y + this.ah - this.t;
        }
        get ab() {
            return this.ac + this.d[this.d.length - 1] - 1;
        }
        get p() {
            if (!this.q) {
                return false;
            }
            let a = this.w();
            for (let b = a; b < this.c.length; b++) {
                if (!this.c[b]) {
                    return false;
                }
            }
            return true;
        }
        get q() {
            return this.l;
        }
        set q(a) {
            this.l = a;
        }
        ai(a, b) {
            this.aj(a, b, this.e.length);
        }
        aj(a, b, c) {
            switch (a) {
                case 0:
                    this.c = new Array(1);
                    this.a = new Array(1);
                    break;
                case 1:
                    this.c = new Array(c);
                    this.a = new Array(c);
                    break;
            }
            for (let d = 0; d < this.c.length; d++) {
                this.c[d] = b;
            }
        }
        static r(a) {
            let b = new List$1(Dictionary$2.$.specialize(String_$type, ISummaryResult_$type), 0);
            if (a != null) {
                for (let c = 0; c < a.length; c++) {
                    if (a[c] == null) {
                        continue;
                    }
                    if (b.count == 0) {
                        b.add(new Dictionary$2(String_$type, ISummaryResult_$type, 0));
                    }
                    for (let d = 0; d < b.count; d++) {
                        if (!b._inner[d].containsKey(a[c].propertyName)) {
                            b._inner[d].addItem(a[c].propertyName, a[c]);
                            break;
                        }
                        else if (d == b.count - 1) {
                            b.add(new Dictionary$2(String_$type, ISummaryResult_$type, 0));
                        }
                    }
                }
            }
            return b;
        }
        j(a) {
            let b = this.v();
            if (a >= this.af && a < this.af + b) {
                return 1;
            }
            if (a >= this.af + b && a < this.af + b + this.ah) {
                return 5;
            }
            if (a > this.ad - this.u - this.ag && a <= this.ad - this.u) {
                return 5;
            }
            if (a > this.ad - this.u && a <= this.ad) {
                return 2;
            }
            return 0;
        }
        x(a) {
            let b = this.v();
            let c = -1;
            if (a >= this.af + b && a < this.af + b + this.ah) {
                c = a - (this.af + b);
            }
            if (a > this.ad - this.u - this.ag && a <= this.ad - this.u) {
                c = a - (this.ad - this.u - this.ag + 1);
            }
            return c;
        }
        v() {
            let a = 0;
            if (this.a != null) {
                for (let b = 0; b < this.a.length; b++) {
                    if (this.a[b] != null) {
                        a++;
                    }
                }
            }
            return a;
        }
        w() {
            if (this.a != null) {
                for (let a = 0; a < this.a.length; a++) {
                    if (this.a[a] != null) {
                        return a;
                    }
                }
            }
            return 0;
        }
        m() {
            return this.d[this.d.length - 1] > 0;
        }
        am(a) {
            for (let b = 0; b < this.g.length; b++) {
                if (this.g[b] == null) {
                    continue;
                }
                let c = this.i[b];
                let d = SectionData.r(c);
                for (let e = 0; e < d.count; e++) {
                    let f = new Array(d._inner[e].count);
                    d._inner[e].values.copyTo(f, 0);
                    this.g[b].a[e].summaryResults = f;
                    if (a != null) {
                        a(this.g[b].a[e]);
                    }
                }
            }
        }
        ak(a, b) {
            if (a == null || a.rowType != 5) {
                return;
            }
            if (b < 0 && b >= this.g[a.level - 1].a.length) {
                return;
            }
            this.g[a.level - 1].a[b] = a;
        }
        n() {
            for (let a = 0; a < this.g.length; a++) {
                if (this.g[a] != null) {
                    for (let b = 0; b < this.g[a].a.length; b++) {
                        if (this.g[a].a[b] != null) {
                            return true;
                        }
                    }
                }
            }
            return false;
        }
        an(a, b, c) {
            c.summaryIndex = b;
            this.i[a][b] = c;
            if (this.o && this.k != null) {
                this.k.i[a][b] = c;
            }
        }
        al(a, b) {
            for (let c = a - 1; c >= 0; c--) {
                if (this.h[c] != -1) {
                    this.h[c] += b;
                }
            }
        }
    }
    SectionData.$t = /*@__PURE__*/ markType(SectionData, 'SectionData');
    return SectionData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionDataStartIndexComparer = /*@__PURE__*/ (() => {
    class SectionDataStartIndexComparer extends Base {
        compare(a, b) {
            return Base.compareSimple(a.af, b.af);
        }
    }
    SectionDataStartIndexComparer.$t = /*@__PURE__*/ markType(SectionDataStartIndexComparer, 'SectionDataStartIndexComparer', Base.$, [/*@__PURE__*/ IComparer$1_$type.specialize(SectionData.$)]);
    return SectionDataStartIndexComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionDataUndisplacedStartIndexComparer = /*@__PURE__*/ (() => {
    class SectionDataUndisplacedStartIndexComparer extends Base {
        compare(a, b) {
            return Base.compareSimple(a.ac, b.af);
        }
    }
    SectionDataUndisplacedStartIndexComparer.$t = /*@__PURE__*/ markType(SectionDataUndisplacedStartIndexComparer, 'SectionDataUndisplacedStartIndexComparer', Base.$, [/*@__PURE__*/ IComparer$1_$type.specialize(SectionData.$)]);
    return SectionDataUndisplacedStartIndexComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionSearchData = /*@__PURE__*/ (() => {
    class SectionSearchData extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.c = 0;
            this.b = null;
        }
    }
    SectionSearchData.$t = /*@__PURE__*/ markType(SectionSearchData, 'SectionSearchData');
    return SectionSearchData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionMap = /*@__PURE__*/ (() => {
    class SectionMap extends Base {
        constructor() {
            super();
            this.a = new SectionData();
            this.j = new SectionDataStartIndexComparer();
            this.k = new SectionDataUndisplacedStartIndexComparer();
            this.s = new List$1(SectionData.$, 0);
            this.m = new SectionSearchData();
            this.l = new SectionSearchData();
        }
        get t() {
            return this.s;
        }
        get u() {
            return this.s._inner[this.s.count - 1].ad + 1;
        }
        get q() {
            return this.t.count > 0;
        }
        n(a, b, c) {
            if (a >= 0 && a < this.s.count) {
                let d = this.s._inner[a];
                if (b >= d.af && b <= d.ad) {
                    c.c = c.c + 1;
                    if (c.c >= c.a.length) {
                        c.c = 0;
                    }
                    c.b[c.c] = a;
                    c.a[c.c] = d;
                    return true;
                }
            }
            return false;
        }
        o(a, b, c) {
            if (a >= 0 && a < this.s.count) {
                let d = this.s._inner[a];
                if ((b >= d.ac && b <= d.ab) || (!d.p && b >= d.ac)) {
                    c.c = c.c + 1;
                    if (c.c >= c.a.length) {
                        c.c = 0;
                    }
                    c.b[c.c] = a;
                    c.a[c.c] = d;
                    return true;
                }
            }
            return false;
        }
        e(a) {
            return this.f(a, this.j, this.m);
        }
        f(a, b, c) {
            if (c.a == null) {
                c.a = new Array(5);
                c.b = new Array(5);
                for (let d = 0; d < c.a.length; d++) {
                    c.a[d] = null;
                    c.b[d] = -1;
                }
            }
            if (c.a[c.c] != null) {
                if (a >= c.a[c.c].af && a <= c.a[c.c].ad) {
                    return c.a[c.c];
                }
                for (let e = 0; e < c.a.length; e++) {
                    if (c.a[e] != null) {
                        if (a >= c.a[e].af && a <= c.a[e].ad) {
                            c.c = e;
                            return c.a[c.c];
                        }
                    }
                }
                let f = c.b[c.c] + 1;
                if (this.n(f, a, c)) {
                    return c.a[c.c];
                }
                f = c.b[c.c] - 1;
                if (this.n(f, a, c)) {
                    return c.a[c.c];
                }
            }
            this.a.af = a;
            let g = this.s.g(this.a, b);
            if (g < 0) {
                g = ~g;
                g--;
            }
            if (this.n(g, a, c)) {
                return c.a[c.c];
            }
            if (this.n(g + 1, a, c)) {
                return c.a[c.c];
            }
            if (this.n(g - 1, a, c)) {
                return c.a[c.c];
            }
            return null;
        }
        h(a, b, c) {
            if (c.a == null) {
                c.a = new Array(5);
                c.b = new Array(5);
                for (let d = 0; d < c.a.length; d++) {
                    c.a[d] = null;
                    c.b[d] = -1;
                }
            }
            if (c.a[c.c] != null) {
                let e = c.a[c.c];
                if (a >= e.ac && a <= e.ab) {
                    return e;
                }
                for (let f = 0; f < c.a.length; f++) {
                    if (c.a[f] != null) {
                        if (a >= c.a[f].ac && a <= c.a[f].ab) {
                            c.c = f;
                            return c.a[c.c];
                        }
                    }
                }
                let g = c.b[c.c] + 1;
                if (this.o(g, a, c)) {
                    return c.a[c.c];
                }
                g = c.b[c.c] - 1;
                if (this.o(g, a, c)) {
                    return c.a[c.c];
                }
            }
            this.a.af = a;
            let h = this.s.g(this.a, b);
            if (h < 0) {
                h = ~h;
                h--;
            }
            if (this.o(h, a, c)) {
                return c.a[c.c];
            }
            if (this.o(h + 1, a, c)) {
                return c.a[c.c];
            }
            if (this.o(h - 1, a, c)) {
                return c.a[c.c];
            }
            return null;
        }
        v() {
            this.s.clear();
            this.m.a = null;
            this.l.a = null;
        }
        ac(a, b, c) {
            for (let d = a.ae + 1; d < this.s.count; d++) {
                let e = this.s._inner[d];
                e.t += c;
                e.af += b;
                e.ad += b;
                for (let f = 0; f < e.h.length; f++) {
                    if (e.h[f] != -1) {
                        e.h[f] += b;
                    }
                }
            }
        }
        ab(a, b, c) {
            for (let d = a.ae; d < this.s.count; d++) {
                let e = this.s._inner[d];
                e.t += c;
                e.af += b;
                e.ad += b;
                e.ae = d;
                if (e.z > a.ae) {
                    e.z -= 1;
                }
                for (let f = 0; f < e.h.length; f++) {
                    if (e.h[f] != -1) {
                        e.h[f] += b;
                    }
                }
            }
        }
        x(a) {
            if (this.s.count == 0) {
                return;
            }
            let b = this.s._inner[this.s.count - 1];
            b.ad = a;
        }
        i(a, b, c, d, e, f) {
            let g = this.b(b, c, d, e, f);
            g.af = a;
            g.ae = this.s.count;
            if (this.s.count > 0) {
                g.t = this.s._inner[this.s.count - 1].t;
            }
            this.s.add(g);
            return g;
        }
        b(a, b, c, d, e) {
            let f = new SectionData();
            f.e = c;
            f.d = new Array(c.length);
            let g = new Array(c.length);
            for (let h = 0; h < g.length; h++) {
                f.d[h] = 0;
                g[h] = a.getItemProperty(b, c[h]);
            }
            f.f = g;
            f.ai(d, e);
            let i = d == 1 ? c.length : 1;
            f.b = new Array(i);
            f.h = new Array(i);
            f.i = new Array(i);
            for (let j = 0; j < i; j++) {
                f.h[j] = -1;
                f.i[j] = new Array(a.summaryDescriptions.k.count);
                for (let k = 0; k < a.summaryDescriptions.k.count; k++) {
                    f.i[j][k] = null;
                }
            }
            f.g = new Array(c.length);
            return f;
        }
        ad(a, b, c) {
            for (let d = a.ae + 1; d < this.s.count; d++) {
                this.s._inner[d].ae = d;
                this.s._inner[d].t += c;
                this.s._inner[d].af += b;
                this.s._inner[d].ad += b;
                for (let e = 0; e < this.s._inner[d].h.length; e++) {
                    if (this.s._inner[d].h[e] != -1) {
                        this.s._inner[d].h[e] += b;
                    }
                }
            }
        }
        aa(a, b) {
            this.s.insert(a, b);
        }
        ae(a) {
            if (this.m != null) {
                let b = this.m;
                SectionMap.w(a, b);
            }
            if (this.l != null) {
                let c = this.l;
                SectionMap.w(a, c);
            }
            this.s._inner[a].o = true;
            this.s.removeAt(a);
        }
        static w(a, b) {
            if (b.a != null) {
                for (let c = 0; c < b.a.length; c++) {
                    if (b.a[c] != null) {
                        if (b.a[c].ae == a) {
                            b.a[c] = null;
                        }
                    }
                }
            }
        }
        d() {
            return this.s._inner[this.s.count - 1];
        }
        c() {
            return this.s._inner[0];
        }
        y() {
            this.s._inner[this.s.count - 1].t += 1;
        }
        g(a) {
            return this.h(a, this.k, this.l);
        }
        p(a) {
            for (let b = 0; b < this.t.count; b++) {
                if (b == a.ae) {
                    continue;
                }
                if (this.t._inner[b].z == a.ae) {
                    return true;
                }
            }
            return false;
        }
        z(a, b) {
            if (a.e == null) {
                a.d[0] += b;
                return;
            }
            if (a.z == -1) {
                for (let c = 0; c < a.e.length; c++) {
                    a.d[c] += b;
                }
            }
            else {
                let d = a.w();
                for (let e = a.w(); e < a.e.length; e++) {
                    a.d[e] += b;
                }
                let f = a.z;
                while (f >= 0) {
                    let g = this.t._inner[f];
                    let h = g.w();
                    g.d[h] += b;
                    f = g.z;
                }
            }
        }
        af(a, b) {
            for (let c = 0; c < a.ae; c++) {
                let d = this.s._inner[c];
                for (let e = 0; e < a.e.length; e++) {
                    if (d.a[e] != null && (d.f[e] == a.f[e] || Base.equalsStatic(d.f[e], a.f[e]))) {
                        a.z = c;
                        a.a[e] = null;
                    }
                }
            }
        }
        r(a) {
            let b = a.w();
            if (b == 0) {
                return true;
            }
            let c = this.s._inner[a.z];
            for (let d = b - 1; d >= 0; d--) {
                if (!c.c[d]) {
                    return false;
                }
            }
            return this.r(c);
        }
    }
    SectionMap.$t = /*@__PURE__*/ markType(SectionMap, 'SectionMap');
    return SectionMap;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceExecutionContext_$type = /*@__PURE__*/ new Type(null, 'IDataSourceExecutionContext');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceExecutionContext = /*@__PURE__*/ (() => {
    class DataSourceExecutionContext extends Base {
        get requestAnimationFrame() {
            return this._requestAnimationFrame;
        }
        set requestAnimationFrame(a) {
            this._requestAnimationFrame = a;
        }
        constructor() {
            super();
            this._requestAnimationFrame = null;
            this.requestAnimationFrame = (window.requestAnimationFrame ||
                window.webkitRequestAnimationFrame ||
                window.mozRequestAnimationFrame ||
                window.oRequestAnimationFrame ||
                window.msRequestAnimationFrame ||
                function (callback) {
                    window.setTimeout(callback, 1000 / 60);
                });
        }
        enqueueAction(a) {
            window.setTimeout(() => a(), 0);
        }
        execute(a) {
            window.setTimeout(() => a(), 0);
        }
        executeDelayed(a, b) {
            window.setTimeout(() => a(), b);
        }
    }
    DataSourceExecutionContext.$t = /*@__PURE__*/ markType(DataSourceExecutionContext, 'DataSourceExecutionContext', Base.$, [IDataSourceExecutionContext_$type]);
    return DataSourceExecutionContext;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourcePropertiesComparer = /*@__PURE__*/ (() => {
    class DataSourcePropertiesComparer extends Base {
        constructor(a, b, c, d) {
            super();
            this.e = null;
            this.b = null;
            this.a = null;
            this.g = 0;
            this.f = null;
            this.d = null;
            this.c = null;
            this.a = b;
            this.e = d;
            this.f = d.actualSchema;
            if (a != null) {
                let e = new List$1(String_$type, 0);
                for (let g = 0; g < a.length; g++) {
                    let f = a[g];
                    let h = this.f;
                    let i = true;
                    let j = f.split('.');
                    for (let k = 0; k < j.length; k++) {
                        let l = j[k];
                        let m = "[" + l + "]";
                        let n = false;
                        if (h != null) {
                            for (let o = 0; o < h.propertyNames.length; o++) {
                                if (l == h.propertyNames[o] || m == h.propertyNames[o]) {
                                    n = true;
                                    if (h.subSchemas != null && h.subSchemas.length > o) {
                                        h = h.subSchemas[o];
                                    }
                                    else {
                                        h = null;
                                    }
                                    break;
                                }
                            }
                        }
                        if (!n) {
                            i = false;
                            break;
                        }
                    }
                    if (i) {
                        e.add(f);
                    }
                }
                a = e.toArray();
            }
            this.b = a;
            if (this.b != null) {
                this.g = this.b.length;
            }
            if (this.b != null) {
                this.d = new Array(this.g);
            }
            this.c = c;
            if (this.c == null) {
                this.c = new Array(this.g);
            }
            let p = new Dictionary$2(String_$type, DataSourceSchemaPropertyType_$type, 0);
            for (let q = 0; q < this.f.propertyNames.length; q++) {
                p.item(this.f.propertyNames[q], this.f.propertyTypes[q]);
            }
            if (this.b != null) {
                for (let r = 0; r < this.b.length; r++) {
                    if (p.containsKey(this.b[r])) {
                        this.d[r] = p.item(this.b[r]);
                    }
                    else {
                        this.d[r] = d.resolveSchemaPropertyType(this.b[r]);
                    }
                }
            }
        }
        compare(a, b) {
            if (this.b == null) {
                if (a == b) {
                    return 0;
                }
                return -1;
            }
            let c = null;
            let d = null;
            let e = null;
            let f = null;
            let x_ = a;
            if ((x_ != null && x_.$$isSpecialRow !== undefined)) {
                e = x_;
            }
            let y_ = b;
            if ((y_ != null && y_.$$isSpecialRow !== undefined)) {
                f = y_;
            }
            let g = null;
            let h = false;
            let i = this.g;
            for (let j = 0; j < i; j++) {
                g = this.b[j];
                h = this.a[j] == 1;
                if (e != null && e.rowType == 4) {
                    return 1;
                }
                if (e != null) {
                    c = e.getValue(g);
                }
                else {
                    c = this.e.getItemProperty(a, g);
                }
                if (f != null) {
                    d = f.getValue(g);
                }
                else {
                    d = this.e.getItemProperty(b, g);
                }
                let k = this.j(c, d, h, this.d[j], this.c[j]);
                if (j == i - 1) {
                    if (e != null && e.rowType == 5 && k == 0) {
                        if (this.e.isSectionSummaryRowsAtBottom) {
                            k = h ? -1 : 1;
                        }
                        else {
                            k = h ? 1 : -1;
                        }
                    }
                }
                if (k != 0) {
                    return k;
                }
            }
            return 0;
        }
        h(a, b) {
            if (this.b == null) {
                for (let c = 0; c < a.length; c++) {
                    if (a[c] != b[c]) {
                        return -1;
                    }
                }
                return 0;
            }
            let d = null;
            let e = null;
            let f = false;
            let g = this.g;
            for (let h = 0; h < g; h++) {
                f = this.a[h] == 1;
                d = a[h];
                e = b[h];
                let i = this.j(d, e, f, this.d[h], this.c[h]);
                if (i != 0) {
                    return i;
                }
            }
            return 0;
        }
        i(a, b) {
            if (this.b == null) {
                if (b.length == 1) {
                    if (a == b[0]) {
                        return 0;
                    }
                }
                return -1;
            }
            let c = null;
            let d = null;
            let e = null;
            let f = false;
            let g = this.g;
            for (let h = 0; h < g; h++) {
                e = this.b[h];
                f = this.a[h] == 1;
                c = this.e.getItemProperty(a, e);
                d = b[h];
                let i = this.j(c, d, f, this.d[h], this.c[h]);
                if (i != 0) {
                    return i;
                }
            }
            return 0;
        }
        j(a, b, c, d, e) {
            if (c) {
                let f = a;
                a = b;
                b = f;
            }
            let g = 0;
            switch (d) {
                case 2:
                    a = a == null ? false : a;
                    b = b == null ? false : b;
                    g = boolCompare(a, b);
                    break;
                case 8:
                    a = a == null ? dateMinValue() : a;
                    b = b == null ? dateMinValue() : b;
                    let xVal_ = a;
                    let yVal_ = b;
                    xVal_ = +xVal_;
                    yVal_ = +yVal_;
                    let h = typeGetValue(xVal_);
                    let i = typeGetValue(yVal_);
                    g = Base.compareSimple(h, i);
                    break;
                case 5:
                    a = a == null ? -1.7976931348623157E+308 : a;
                    b = b == null ? -1.7976931348623157E+308 : b;
                    g = Base.compareSimple(a, b);
                    break;
                case 10:
                    a = a == null ? 0 : a;
                    b = b == null ? 0 : b;
                    g = Base.compareSimple(a, b);
                    break;
                case 6:
                    a = a == null ? -7.9228162514264338E+28 : a;
                    b = b == null ? -7.9228162514264338E+28 : b;
                    g = Base.compareSimple(a, b);
                    break;
                case 7:
                    a = a == null ? -3.4028230607370965E+38 : a;
                    b = b == null ? -3.4028230607370965E+38 : b;
                    g = Base.compareSimple(b, b);
                    break;
                case 1:
                    a = a == null ? -2147483648 : a;
                    b = b == null ? -2147483648 : b;
                    g = Base.compareSimple((typeGetValue(a)), typeGetValue(b));
                    break;
                case 3:
                    a = a == null ? -9.2233720368547758E+18 : a;
                    b = b == null ? -9.2233720368547758E+18 : b;
                    g = Base.compareSimple((typeGetValue(a)), typeGetValue(b));
                    break;
                case 11:
                    if (e) {
                        let j = a;
                        let k = b;
                        if (j != null) {
                            g = CompareUtil.compareToObject(j, k);
                        }
                        else if (k != null) {
                            g = -1;
                        }
                        else {
                            g = 0;
                        }
                    }
                    else {
                        a = a == null ? "" : a;
                        b = b == null ? "" : b;
                        g = stringCompare(a.toString(), b.toString());
                    }
                    break;
                case 4:
                    a = a == null ? -32768 : a;
                    b = b == null ? -32768 : b;
                    g = Base.compareSimple((typeGetValue(a)), typeGetValue(b));
                    break;
                case 0:
                    a = a == null ? "" : a;
                    b = b == null ? "" : b;
                    g = stringCompare(a, b);
                    break;
            }
            return g;
        }
    }
    DataSourcePropertiesComparer.$t = /*@__PURE__*/ markType(DataSourcePropertiesComparer, 'DataSourcePropertiesComparer', Base.$, [/*@__PURE__*/ IComparer$1_$type.specialize(Base.$)]);
    return DataSourcePropertiesComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceBatchStartedEventArgs = /*@__PURE__*/ (() => {
    class DataSourceBatchStartedEventArgs extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
    }
    DataSourceBatchStartedEventArgs.$t = /*@__PURE__*/ markType(DataSourceBatchStartedEventArgs, 'DataSourceBatchStartedEventArgs');
    return DataSourceBatchStartedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceBatchCompletedEventArgs = /*@__PURE__*/ (() => {
    class DataSourceBatchCompletedEventArgs extends Base {
        constructor(a, b) {
            super();
            this.b = false;
            this.a = null;
            this.b = a;
            this.a = b;
        }
    }
    DataSourceBatchCompletedEventArgs.$t = /*@__PURE__*/ markType(DataSourceBatchCompletedEventArgs, 'DataSourceBatchCompletedEventArgs');
    return DataSourceBatchCompletedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VirtualDataSource = /*@__PURE__*/ (() => {
    class VirtualDataSource extends BaseDataSource {
        constructor() {
            super();
            this.dj = false;
            this.d6 = 0;
            this.dd = null;
            this.c4 = null;
            this.c3 = null;
            this.d5 = 50;
            this.d4 = 200;
            this.actualPageSizePopulated = false;
            this.dq = 50;
            this.dh = false;
            this.c8 = null;
            this.cz = null;
            this.c0 = null;
            this.dg = new LRUCache$2(Base.$, IDataSourcePage_$type, 0, 200);
            this.dn = new Dictionary$2(Base.$, Array_$type, 0);
            this.dp = new Dictionary$2(Number_$type, Number_$type, 0);
            this.di = false;
            this.cx = null;
            this.c1 = null;
            this.df = new SectionMap();
            this.cy = null;
            this.dy = -1;
            this.dr = -1;
            this.d0 = -1;
            this.dt = -1;
            this.d1 = -1;
            this.du = -1;
            this.dz = -1;
            this.ds = -1;
            this.d3 = -1;
            this.d2 = -1;
            this.dw = -1;
            this.dv = -1;
            this.dx = -1;
            this.dm = new Dictionary$2(String_$type, Boolean_$type, 0);
            this._concurrencyTag = null;
            this.batchStarted = null;
            this.batchCompleted = null;
            this.dd = new PagePredictionEngine();
            this.dd.e = this;
            this.dd.ag = this.actualPageSize;
            this.dd.f = this.df;
            this.executionContext = new DataSourceExecutionContext();
            this.dd.b = this.executionContext;
            this.isReadOnly = true;
        }
        get_isSectionCollapsable() {
            if (!this.isSectionContentVisible) {
                return true;
            }
            return super.get_isSectionCollapsable();
        }
        set_isSectionCollapsable(a) {
            super.set_isSectionCollapsable(a);
        }
        get_isSectionExpandedDefault() {
            if (!this.isSectionContentVisible) {
                return false;
            }
            if (this.isSectionCollapsable) {
                return super.get_isSectionExpandedDefault();
            }
            return true;
        }
        set_isSectionExpandedDefault(a) {
            super.set_isSectionExpandedDefault(a);
        }
        get_actualBaseDataProvider() {
            return this.actualDataProvider;
        }
        get actualBaseDataProvider() {
            return this.get_actualBaseDataProvider();
        }
        get dataProvider() {
            return this.c4;
        }
        set dataProvider(a) {
            let b = this.c4;
            this.c4 = a;
            if (b != this.c4) {
                this.onPropertyUpdated("DataProvider", b, this.c4);
            }
        }
        get actualDataProvider() {
            if (this.c3 == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.c3;
        }
        set actualDataProvider(a) {
            let b = this.c3;
            this.c3 = a;
            if (b != this.c3) {
                this.onPropertyUpdated("ActualDataProvider", b, this.c3);
            }
        }
        get pageSizeRequested() {
            return this.d5;
        }
        set pageSizeRequested(a) {
            let b = this.d5;
            this.d5 = a;
            if (b != this.d5) {
                this.onPropertyUpdated("PageSizeRequested", b, this.d5);
            }
        }
        resetCache() {
            if (this.c9 != null) {
                this.c9.resetCache();
            }
            this.resetCacheOverride();
        }
        resetCacheOverride() {
            this.dg.i();
        }
        get maxCachedPages() {
            return this.d4;
        }
        set maxCachedPages(a) {
            let b = this.d4;
            this.d4 = a;
            if (b != this.d4) {
                this.onPropertyUpdated("MaxCachedPages", b, this.d4);
            }
        }
        get actualPageSize() {
            return this.dq;
        }
        set actualPageSize(a) {
            let b = this.dq;
            this.dq = a;
            if (b != this.dq) {
                this.onPropertyUpdated("ActualPageSize", b, this.dq);
            }
        }
        get_isSortingSupported() {
            if (this.externalDataSource != null && !this.dh) {
                this.dh = true;
                let a = this.externalDataSource.isSortingSupportedOverride;
                this.dh = false;
                return a;
            }
            return false;
        }
        get_isFilteringSupported() {
            if (this.externalDataSource != null && !this.dh) {
                this.dh = true;
                let a = this.externalDataSource.isFilteringSupportedOverride;
                this.dh = false;
                return a;
            }
            return false;
        }
        get_isGroupingSupported() {
            if (this.externalDataSource != null && !this.dh) {
                this.dh = true;
                let a = this.externalDataSource.isGroupingSupportedOverride;
                this.dh = false;
                return a;
            }
            return false;
        }
        get c9() {
            return this.c8;
        }
        set c9(a) {
            this.c8 = a;
            this.actualDataProvider = this.resolveDataProvider();
        }
        resolveDataProvider() {
            if (this.c9 == null) {
                return null;
            }
            return this.c9.resolveDataProvider();
        }
        propertyUpdatedOverride(a, b, c) {
            super.propertyUpdatedOverride(a, b, c);
            switch (a) {
                case "DataProvider":
                    this.actualDataProvider = this.dataProvider;
                    this.queueAutoRefresh();
                    break;
                case "ExecutionContext":
                    this.dd.b = this.executionContext;
                    break;
                case "ActualDataProvider":
                    this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                    this.actualDataProvider.pageLoaded = runOn(this, this.er);
                    this.actualDataProvider.batchCompleted = runOn(this, this.eq);
                    this.queueAutoRefresh();
                    break;
                case "PageSizeRequested":
                    this.actualPageSize = this.pageSizeRequested;
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                    }
                    this.queueAutoRefresh();
                    break;
                case "ActualPageSize":
                    this.dd.ag = this.actualPageSize;
                    this.queueAutoRefresh();
                    break;
                case "FirstVisibleIndexRequested":
                    this.dd.aa = this.firstVisibleIndexRequested;
                    break;
                case "LastVisibleIndexRequested":
                    this.dd.ae = this.lastVisibleIndexRequested;
                    break;
                case "ActualCount":
                    if (this.actualDataProvider != null && !this.df.q) {
                        this.dd.ab = this.actualDataProvider.actualCount;
                    }
                    else {
                        this.dd.ab = this.actualCount;
                    }
                    this.queueAutoRefresh();
                    break;
                case "MaxCachedPages":
                    this.dg.h = this.maxCachedPages;
                    break;
            }
        }
        ea(a) {
            if (this.aq && this.df.q) {
                let b = this.de(a);
                if (b == null) {
                    b = this.df.d();
                }
                return a - b.t;
            }
            return a;
        }
        er(a, b, c) {
            let d = this.executionContext;
            if (d != null) {
                d.execute(() => this.ex(a, b, c));
            }
            else {
                this.ex(a, b, c);
            }
        }
        ex(a, b, c) {
            if (a == null) {
                b = this.resolveFullCount(b);
                if (this.actualCount != b) {
                    this.actualCount = b;
                }
                return;
            }
            if (c != this.actualPageSize && !this.actualPageSizePopulated) {
                this.actualPageSize = c;
            }
            this.actualPageSizePopulated = true;
            let d = a.pageIndex();
            this.es(d);
            this.dg.item(d, a);
            let e = a.schema();
            if (e != null) {
                this.actualSchema = e;
            }
            let f = a.getSummaryInformation();
            if (this.summaryDescriptions.k.count > 0 && this.c1 == null && f != null) {
                this.c1 = f;
                for (let g = 0; g < this.c1.length; g++) {
                    this.c1[g].summaryIndex = this.d8(this.c1[g]);
                }
                let h = SectionData.r(this.c1);
                this.d6 = h.count;
            }
            let i = a.getGroupInformation();
            if (this.groupDescriptions.k.count > 0 && this.cx == null && i != null) {
                this.cx = i;
                this.ew();
                this.dj = false;
            }
            b = this.resolveFullCount(b);
            if (this.actualCount != b) {
                this.actualCount = b;
            }
            this.ev(a);
        }
        d8(a) {
            for (let b = 0; b < this.summaryDescriptions.k.count; b++) {
                let c = this.summaryDescriptions.k.item(b);
                if (c.propertyName == a.propertyName && c.operand == a.operand) {
                    return b;
                }
            }
            return -1;
        }
        resolveFullCount(a) {
            if (this.cx != null) {
                return this.df.u + this.getRootSummaryRowCount();
            }
            return a + this.getRootSummaryRowCount();
        }
        ew() {
            let a = 0;
            let b = 0;
            let c = this.shouldEmitSectionHeaders;
            let d = this.shouldEmitSectionFooters;
            for (let e = 0; e < this.cx.length; e++) {
                let f = new SectionData();
                let g = b;
                let h = this.cx[e].endIndex - this.cx[e].startIndex;
                f.af = a;
                f.ae = e;
                f.d = new Array(this.groupDescriptions.k.count);
                for (let i = 0; i < this.groupDescriptions.k.count; i++) {
                    f.d[i] = 0;
                }
                f.ad = a + h;
                f.t = 0;
                f.e = this.cx[e].groupKeyProperties;
                f.f = this.cx[e].groupKeyValues;
                f.h = new Array(0);
                f.ai(this.sectionHeaderDisplayMode, this.isSectionExpandedDefault);
                this.ep(f, e == 0);
                if (d) {
                    f.u = f.c.length;
                }
                let j = 0;
                f.i = new Array(this.groupDescriptions.k.count);
                if (this.summaryScope == 0 || this.summaryScope == 2) {
                    if (this.cx[e].summaryResults != null) {
                        f.i[this.groupDescriptions.k.count - 1] = this.cx[e].summaryResults;
                        if (f.i != null) {
                            for (let k = 0; k < f.i[this.groupDescriptions.k.count - 1].length; k++) {
                                let l = f.i[this.groupDescriptions.k.count - 1][k];
                                l.summaryIndex = this.d8(l);
                                l.groupKey = f.f;
                            }
                            j = SectionData.r(f.i[this.groupDescriptions.k.count - 1]).count;
                        }
                    }
                }
                if (this.includeSummaryRowsInSection && this.shouldEmitSummaryRows) {
                    if (this.isSectionSummaryRowsAtBottom) {
                        f.ag = j;
                    }
                    else {
                        f.ah = j;
                        g += j;
                    }
                    b += j;
                    f.ad = f.ad + j;
                }
                if (d) {
                    b++;
                }
                if (c) {
                    let m = 0;
                    f.b = new Array(f.c.length);
                    if (f.z > -1) {
                        let n = this.df.t._inner[f.z];
                        for (let o = 0; o < n.f.length; o++) {
                            m = o;
                            if (!Base.equalsStatic(n.f[o], f.f[o])) {
                                break;
                            }
                        }
                    }
                    for (let p = m; p < f.c.length; p++) {
                        b++;
                        g++;
                        f.ad = f.ad + 1;
                        let q = this.ej(f, p);
                        f.a[p] = q;
                        f.b[p] = p - m;
                        if (this.dm.containsKey(q)) {
                            f.c[p] = this.dm.item(q);
                        }
                        else {
                            f.c[p] = this.isSectionExpandedDefault;
                        }
                        if (!f.c[p]) {
                            let r = 0;
                            let s = f.c.length - 1 - p;
                            f.ad = f.ad - r;
                            b -= r;
                            if (d) {
                                b--;
                                f.u = f.u - 1;
                            }
                            p += s;
                        }
                    }
                }
                f.y = c ? f.v() : 0;
                f.t = g;
                this.df.z(f, h + 1);
                if (!f.p) {
                    let t = f.w();
                    f.ad = f.ad - (f.d[t] + j);
                    b -= f.d[t] + j;
                }
                a = f.ad + 1;
                this.df.t.add(f);
                f.q = this.df.r(f);
            }
            let u = 0;
            for (let v = 0; v < this.df.t.count; v++) {
                let w = this.df.t._inner[v];
                if (this.shouldEmitSectionHeaders) {
                    if (!w.q) {
                        let x = w.ad - w.af + 1;
                        this.df.ae(w.ae);
                        this.df.ab(w, -x, -x);
                        v--;
                        u++;
                        continue;
                    }
                }
                if (w.z > -1) {
                    w.z -= u;
                }
            }
        }
        ep(a, b) {
            if (b) {
                this.cz = new Array(this.groupDescriptions.k.count);
                for (let c = 0; c < this.cz.length; c++) {
                    this.cz[c] = a;
                }
            }
            if (this.sectionHeaderDisplayMode == 1) {
                let d = false;
                let e = a.e.length;
                for (let f = 0; f < e; f++) {
                    if (d) {
                        this.cz[f] = a;
                        continue;
                    }
                    let g = false;
                    if (this.cz[f].f[f] == null) {
                        g = a.f[f] != null;
                    }
                    else {
                        g = !Base.equalsStatic(this.cz[f].f[f], a.f[f]);
                    }
                    if (g) {
                        this.cz[f] = a;
                        if (f - 1 > -1) {
                            let h = f - 1;
                            while (h >= 0 && this.cz[h].o) {
                                h = h - 1;
                            }
                            a.z = this.cz[h].ae;
                        }
                        d = true;
                    }
                }
            }
            else {
                let i = false;
                for (let j = 0; j < a.e.length; j++) {
                    if (this.cz[0].f[j] == null) {
                        if (this.cz[0].f[j] != a.f[j]) {
                            i = true;
                            break;
                        }
                        continue;
                    }
                    if (!Base.equalsStatic(this.cz[0].f[j], a.f[j])) {
                        i = true;
                        break;
                    }
                }
                if (i) {
                    this.cz[0] = a;
                }
            }
        }
        eo(a) {
        }
        ev(a) {
            if (this.updateNotifier != null) {
                let b = a.pageIndex() * this.actualPageSize;
                if (this.actualDataProvider != null) {
                    if (b > this.actualDataProvider.actualCount) {
                        return;
                    }
                }
                let c = this.d9(b);
                let d = this.d9(b + a.count() - 1);
                if (c > 0 && this.getRowType(c - 1) == 1) {
                    c--;
                }
                if (this.actualCount == 0 && a.count() == 0) {
                    this.onClearItems();
                }
                else {
                    this.updateNotifier.rangeActualized(c, d);
                }
            }
        }
        d9(a) {
            if (this.aq && this.df.q) {
                let b = this.df.g(a);
                if (b == null) {
                    b = this.df.d();
                }
                if (!b.p) {
                    return b.af;
                }
                return a + b.t;
            }
            return a;
        }
        et(a) {
            a();
        }
        get_isVirtual() {
            return true;
        }
        isPlaceholderItem(a) {
            let b = this.c2(a);
            let c = b[0];
            if (!this.dg.d(c)) {
                if (b[1] == -1) {
                    return false;
                }
                return true;
            }
            return false;
        }
        getItemAtIndex(a) {
            if (a >= this.actualCount - this.getRootSummaryRowCount()) {
                return this.ee(a);
            }
            let b = this.c2(a);
            let c = b[0];
            if (!this.dg.d(c)) {
                if (b[1] == -1) {
                    return this.ee(a);
                }
                return null;
            }
            let d = this.dg.item(c);
            let e = b[1];
            if (e == -1) {
                return this.ee(a);
            }
            return d.getItemAtIndex(e);
        }
        getItemFromKey(a) {
            let b = this.indexOfKey(a);
            if (b >= 0) {
                return this.getItemAtIndex(b);
            }
            return null;
        }
        ee(a) {
            if (a >= this.actualCount - this.getRootSummaryRowCount()) {
                let b = new DataSourceSpecialRow();
                b.rowType = 4;
                b.level = 0;
                let c = a - (this.actualCount - this.getRootSummaryRowCount());
                let d = SectionData.r(this.c1);
                let e = new Array(d._inner[c].count);
                d._inner[c].values.copyTo(e, 0);
                b.summaryResults = e;
                return b;
            }
            let f = this.de(a);
            if (f != null) {
                let g = f.j(a);
                if (g == 1 || g == 2) {
                    let h = new DataSourceSpecialRow();
                    h.rowType = g;
                    h.summaryResults = f.i[f.i.length - 1];
                    h.level = g == 1 ? f.w() + (a - f.af) : (f.u - 1) - (f.w() + (a - (f.ad - f.u + 1)));
                    if (this.sectionHeaderDisplayMode == 0) {
                        for (let i = 0; i < this.groupDescriptions.k.count; i++) {
                            h.setSectionValue(this.groupDescriptions.k.item(i).propertyName, f.f[i]);
                            h.setValue(this.groupDescriptions.k.item(i).propertyName, f.f[i]);
                        }
                    }
                    else {
                        if (h.level >= 0 && h.level < this.groupDescriptions.k.count) {
                            h.setSectionValue(this.groupDescriptions.k.item(h.level).propertyName, f.f[h.level]);
                            h.setValue(this.groupDescriptions.k.item(h.level).propertyName, f.f[h.level]);
                        }
                    }
                    return h;
                }
                else if (g == 5) {
                    let j = new DataSourceSpecialRow();
                    j.rowType = 5;
                    j.level = f.c.length;
                    let k = f.x(a);
                    let l = SectionData.r(f.i[f.i.length - 1]);
                    let m = new Array(l._inner[k].count);
                    l._inner[k].values.copyTo(m, 0);
                    j.summaryResults = m;
                    return j;
                }
            }
            return null;
        }
        c2(a) {
            if (this.aq && this.df.q) {
                let b = false;
                let c = this.de(a);
                if (c == null) {
                    c = this.df.d();
                    if (this.c1.length > 0 && a > c.ad) {
                        b = true;
                    }
                }
                let d = c.af;
                if (this.shouldEmitSectionHeaders && a >= d && a < d + c.v()) {
                    b = true;
                }
                if (a - (d + c.v() - 1) <= c.aa + c.ah) {
                    b = true;
                }
                if (this.shouldEmitSectionFooters) {
                    if (a <= c.ad && a >= c.ad - c.c.length - c.ag) {
                        b = true;
                    }
                }
                else if (c.ag > 0) {
                    if (a > c.ad - c.ag && a <= c.ad) {
                        b = true;
                    }
                }
                let e = a - c.t;
                let f = truncate(Math.floor(e / this.actualPageSize));
                let g = e % this.actualPageSize;
                if (b) {
                    g = -1;
                }
                let h = new Array(2);
                h[0] = f;
                h[1] = g;
                return h;
            }
            else {
                let i = truncate(Math.floor(a / this.actualPageSize));
                let j = a % this.actualPageSize;
                let k = new Array(2);
                k[0] = i;
                k[1] = j;
                return k;
            }
        }
        de(a) {
            return this.df.e(a);
        }
        getItemPropertyAtIndex(a, b) {
            if (a > (this.actualCount - 1) - this.getRootSummaryRowCount()) {
                return this.ef(a, b);
            }
            let c = this.c2(a);
            let d = c[0];
            if (!this.dg.d(d)) {
                if (c[1] == -1) {
                    return this.ef(a, b);
                }
                return null;
            }
            let e = this.dg.item(d);
            let f = c[1];
            if (f == -1) {
                return this.ef(a, b);
            }
            if (this.ar()) {
                let g = e.getItemAtIndex(f);
                let h = this.ao(g, b);
                if (h) {
                    let i = this.a2(g, b);
                    return i;
                }
            }
            return e.getItemValueAtIndex(f, b);
        }
        ef(a, b) {
            let c = this.ee(a);
            if (typeCast(DataSourceSpecialRow.$, c) !== null) {
                return c.getValue(b);
            }
            return null;
        }
        eu(a) {
            if (!this.dp.containsKey(a)) {
                this.dp.addItem(a, 1);
            }
            else {
                this.dp.item(a, this.dp.item(a) + 1);
            }
        }
        es(a) {
            if (this.dp.containsKey(a)) {
                this.dp.item(a, this.dp.item(a) - 1);
                if (this.dp.item(a) <= 0) {
                    this.dp.removeItem(a);
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.removePageRequest(a);
                    }
                }
            }
        }
        addCandidate(a, b) {
            let c = false;
            if (!this.dn.containsKey(a)) {
                let d = new List$1(Number_$type, 0);
                let e = this.transformPage(a);
                for (let f = 0; f < e.length; f++) {
                    let g = e[f];
                    if (!this.dg.d(g)) {
                        d.add(g);
                        this.eu(g);
                        let h = this.dp.item(g);
                        if (h == 1 && this.actualDataProvider != null) {
                            this.actualDataProvider.addPageRequest(g, b);
                        }
                        c = true;
                    }
                }
                if (d.count > 0) {
                    this.dn.addItem(a, d.toArray());
                }
            }
            return c;
        }
        removeCandidate(a) {
            if (this.dn.containsKey(a)) {
                for (let b = 0; b < this.dn.item(a).length; b++) {
                    let c = this.dn.item(a)[b];
                    this.es(c);
                }
                this.dn.removeItem(a);
            }
        }
        transformPage(a) {
            let b = [a];
            if (this.aq && this.df.q) {
                let c = a * this.actualPageSize;
                let d = c + this.actualPageSize - 1;
                let e = this.de(c);
                let f = new List$1(Number_$type, 0);
                for (let g = c; g <= d; g++) {
                    if (e == null) {
                        break;
                    }
                    if (g > e.ad) {
                        if (e.ae < this.df.t.count - 1) {
                            e = this.df.t._inner[e.ae + 1];
                        }
                        else {
                            break;
                        }
                    }
                    if (!e.p || (g >= e.af && g <= e.af + (e.v() - 1) + e.aa)) {
                        continue;
                    }
                    let h = g - e.t;
                    let i = intDivide(h, this.actualPageSize);
                    if (!f.contains(i)) {
                        f.add(i);
                    }
                }
                b = f.toArray();
            }
            return b;
        }
        getUnrealizedCount() {
            let a = this.dg.g * this.actualPageSize;
            let b = this.actualCount - a;
            return b;
        }
        onSetItemOverride(a, b, c) {
            super.onSetItemOverride(a, b, c);
            let d = this.c2(a);
            let e = d[0];
            if (this.dg.d(e)) {
                this.dg.j(e);
            }
        }
        refreshInternalOverride() {
            super.refreshInternalOverride();
            this.actualPageSizePopulated = false;
            let a = this.actualCount != 0;
            this.di = true;
            if (!this.dj) {
                this.resetCache();
                if (a) {
                    this.onClearItems();
                }
                this.cx = null;
                this.c1 = null;
                this.d6 = 0;
                this.df.v();
            }
            else {
                this.dj = false;
                if (a) {
                    this.onClearItems();
                }
            }
            this.ey();
            this.dd.au();
            this.di = false;
        }
        ey() {
            if (this.actualDataProvider != null) {
                for (let a of fromEnum(this.dn.values)) {
                    for (let c = 0; c < a.length; c++) {
                        let b = a[c];
                        this.actualDataProvider.addPageRequest(b, 1);
                    }
                }
            }
        }
        onClearItemsOverride() {
            super.onClearItemsOverride();
            if (!this.di) {
                this.queueAutoRefresh();
            }
        }
        onInsertItemOverride(a, b) {
            super.onInsertItemOverride(a, b);
            this.queueAutoRefresh();
        }
        onRemoveItemOverride(a, b) {
            super.onRemoveItemOverride(a, b);
            this.queueAutoRefresh();
        }
        get_isItemIndexLookupSupported() {
            return true;
        }
        get_isKeyIndexLookupSupported() {
            return true;
        }
        indexOfItem(a) {
            let b = this.dg.b;
            let c = b.o;
            let d = b.q;
            let e = d.count;
            let f = b.p;
            for (let g = 0; g < e; g++) {
                if (f._inner[g]) {
                    continue;
                }
                let h = d._inner[g].b;
                let i = h.count();
                for (let j = 0; j < i; j++) {
                    if (this.dl(h.getItemAtIndex(j), a)) {
                        let k = typeGetValue(c._inner[g]);
                        let l = k * this.actualPageSize;
                        return l + j;
                    }
                }
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
                return this.actualDataProvider.indexOfItem(a);
            }
            return -1;
        }
        dl(a, b) {
            if (a == null && b == null) {
                return true;
            }
            if (a == null || b == null) {
                return false;
            }
            return Base.equalsStatic(a, b);
        }
        indexOfKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return -1;
            }
            this.ensureComparables(this.actualSchema);
            let c = this.dc();
            if (this.aq && this.shouldEmitSectionHeaders && !this.isSectionContentVisible && this.isSectionHeaderNormalRow) {
                if (this.df.t.count > 0) {
                    for (let d = 0; d < this.df.t.count; d++) {
                        let e = this.df.t._inner[d];
                        let f = new DataSourceSpecialRow();
                        for (let g = 0; g < e.e.length; g++) {
                            let h = e.e[g];
                            let i = e.f[g];
                            f.setSectionValue(h, i);
                        }
                        if (c.i(f, a) == 0) {
                            return d;
                        }
                    }
                }
            }
            let j = this.dg.b;
            let k = j.o;
            let l = j.q;
            let m = l.count;
            let n = j.p;
            for (let o = 0; o < m; o++) {
                if (n._inner[o]) {
                    continue;
                }
                let p = l._inner[o].b;
                let q = p.count();
                for (let r = 0; r < q; r++) {
                    if (c.i(p.getItemAtIndex(r), a) == 0) {
                        let s = typeGetValue(k._inner[o]);
                        let t = s * this.actualPageSize;
                        return t + r;
                    }
                }
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                return this.actualDataProvider.indexOfKey(a);
            }
            return -1;
        }
        dc() {
            let a = new Array(this.actualPrimaryKey.length);
            for (let b = 0; b < a.length; b++) {
                a[b] = 0;
            }
            return new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.d, this);
        }
        getStickyRowPriority(a) {
            let b = this.getRowType(a);
            switch (b) {
                case 1: return 100 - this.getRowLevel(a);
                case 2: return 99 - this.getRowLevel(a);
                case 3:
                case 5: return 2;
                case 4: return 3;
            }
            return 1;
        }
        unpinRow(a) {
            super.unpinRow(a);
        }
        pinRow(a) {
            super.pinRow(a);
        }
        isRowPinned(a) {
            return super.isRowPinned(a);
        }
        getStickyRowsInRange(a, b) {
            if ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && (this.summaryDescriptions == null || this.summaryDescriptions.k.count == 0)) {
                return null;
            }
            let c = this.de(a);
            let d = this.de(b);
            if (this.df.t.count > 0) {
                if (this.df.t.count == 1) {
                    c = this.df.t._inner[0];
                    d = this.df.t._inner[0];
                }
                else {
                    c = this.df.e(a);
                    if (c != null) {
                        while (c.z != -1) {
                            c = this.df.t._inner[c.z];
                        }
                    }
                    d = this.df.e(b);
                    if (b >= this.actualCount - this.getRootSummaryRowCount()) {
                        d = this.df.d();
                    }
                }
            }
            else if (this.getRootSummaryRowCount() > 0) {
                let e = new List$1(Number_$type, 0);
                for (let f = this.actualCount - this.getRootSummaryRowCount(); f < this.actualCount; f++) {
                    e.add(f);
                }
                return e.toArray();
            }
            if (c == null || d == null) {
                return null;
            }
            if (c.ae == this.dy && c.aa == this.d0 && c.af == this.d1 && c.ad == this.dz && c.ah == this.d3 && c.ag == this.d2 && d.ae == this.dr && d.aa == this.dt && d.af == this.du && d.ad == this.ds && d.ah == this.dw && d.ag == this.dv && this.getRootSummaryRowCount() == this.dx) {
                return this.cy;
            }
            this.dy = c.ae;
            this.dr = d.ae;
            this.d0 = c.aa;
            this.dt = d.aa;
            this.d1 = c.af;
            this.du = d.af;
            this.dz = c.ad;
            this.ds = d.ad;
            this.dw = d.ah;
            this.dv = d.ag;
            this.d3 = c.ah;
            this.d2 = c.ag;
            this.dx = this.getRootSummaryRowCount();
            let g = new List$1(Number_$type, 0);
            for (let h = c.ae; h <= d.ae; h++) {
                let i = this.df.t._inner[h];
                let j = i.c.length;
                let k = i.v();
                if (this.shouldEmitSectionHeaders && this.aq) {
                    for (let l = 0; l < i.c.length; l++) {
                        if (i.a[l] != null) {
                            let m = i.af + i.b[l];
                            g.add(m);
                        }
                        if (!i.c[l]) {
                            break;
                        }
                    }
                }
                if (i.p) {
                    for (let n = 0; n < i.ah; n++) {
                        g.add(i.af + n + k);
                    }
                    if (this.shouldEmitShiftedRows) {
                        for (let o = 0; o < i.aa; o++) {
                            g.add(i.af + o + j);
                        }
                    }
                    if (this.summaryScope == 0 || this.summaryScope == 2) {
                        if (this.includeSummaryRowsInSection && this.isSectionSummaryRowsAtBottom) {
                            for (let p = i.ag - 1; p >= 0; p--) {
                                if (this.shouldEmitSectionFooters) {
                                    g.add(i.ad - k - p);
                                }
                                else {
                                    g.add(i.ad - p);
                                }
                            }
                        }
                    }
                }
                if (this.shouldEmitSectionFooters && this.aq) {
                    for (let q = i.c.length - 1; q >= 0; q--) {
                        if (!i.c[q]) {
                            break;
                        }
                        g.add(i.ad - q);
                    }
                }
            }
            for (let r = this.actualCount - this.getRootSummaryRowCount(); r < this.actualCount; r++) {
                g.add(r);
            }
            this.cy = g.toArray();
            return this.cy;
        }
        isExclusivelySticky(a) {
            let b = this.getRowType(a);
            return b == 1 || b == 2 || b == 4 || (this.isSectionSummaryRowsAtBottom && b == 5);
        }
        getRowType(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                let c = b.rowType;
                if (this.isSectionHeaderNormalRow && c == 1) {
                    return 0;
                }
                return c;
            }
            return 0;
        }
        getIsRowExpandedAtIndex(a) {
            let b = this.df.e(a);
            if (b == null) {
                b = this.df.d();
            }
            for (let c = 0; c < b.a.length; c++) {
                if (b.a[c] != null) {
                    if (a == b.af + b.b[c]) {
                        return b.c[c];
                    }
                }
            }
            return super.getIsRowExpandedAtIndex(a);
        }
        setIsRowExpandedAtIndex(a, b) {
            let c = this.df.e(a);
            if (c == null) {
                c = this.df.d();
            }
            for (let d = 0; d < c.a.length; d++) {
                if (c.a[d] != null) {
                    if (a == c.af + c.b[d]) {
                        let e = false;
                        let f = c.a[d];
                        if (this.dm.containsKey(f) && this.dm.item(f) != b) {
                            let g = this.dm.item(f);
                            if (b == this.isSectionExpandedDefault) {
                                this.dm.removeItem(f);
                            }
                            else {
                                this.dm.item(f, b);
                            }
                            e = true;
                            this.onRowExpansionChanged(a, g, b);
                        }
                        else if (b != this.isSectionExpandedDefault) {
                            this.dm.addItem(f, b);
                            e = true;
                            this.onRowExpansionChanged(a, this.isSectionExpandedDefault, b);
                        }
                        if (e) {
                            this.df.v();
                            this.ew();
                            this.dj = true;
                            if (this.actualCount != this.df.u) {
                                this.actualCount = this.df.u + this.getRootSummaryRowCount();
                            }
                            else {
                                this.queueAutoRefresh();
                            }
                        }
                        break;
                    }
                }
            }
        }
        getRowLevel(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return b.level;
            }
            if (this.isGroupingSupported) {
                if (this.sectionHeaderDisplayMode == 1) {
                    return this.groupDescriptions.k.count;
                }
                else if (this.groupDescriptions.k.count > 0) {
                    return 1;
                }
            }
            return 0;
        }
        getRootSummaryRowCount() {
            return this.shouldEmitSummaryRows ? this.d6 : 0;
        }
        ei(a) {
            let b = "";
            for (let c = 0; c < a.e.length; c++) {
                let d = a.f[c].toString();
                b += a.e[c] + ":" + d;
            }
            return b;
        }
        ej(a, b) {
            if (this.sectionHeaderDisplayMode == 0) {
                return this.ei(a);
            }
            let c = "";
            for (let d = 0; d < a.e.length; d++) {
                let e = a.f[d].toString();
                c += a.e[d] + ":" + e + ":";
            }
            let f = b.toString();
            c += f;
            return c;
        }
        getRootSummaryResults() {
            return this.c1;
        }
        getSectionSummaryResults(a) {
            if (this.df.t.count > 0 && a >= 0 && a < this.df.t.count) {
                return this.df.t._inner[a].i;
            }
            return null;
        }
        clone() {
            return null;
        }
        cloneProperties(a) {
            super.cloneProperties(a);
            let b = typeCast(VirtualDataSource.$, a);
            if (b != null) {
                b.pageSizeRequested = this.pageSizeRequested;
                b.maxCachedPages = this.maxCachedPages;
            }
        }
        get concurrencyTag() {
            return this._concurrencyTag;
        }
        set concurrencyTag(a) {
            this._concurrencyTag = a;
        }
        get_isBatchingEnabled() {
            return true;
        }
        set_isBatchingEnabled(a) {
            super.set_isBatchingEnabled(a);
        }
        updatePropertyAtKey(a, b, c, d = false) {
            let e = super.updatePropertyAtKey(a, b, c, d);
            if (this.concurrencyTag != null && this.ar()) {
                let f = this.indexOfKey(a);
                if (f > -1) {
                    let g = this.getItemAtIndex(f);
                    let h = this.actualDataProvider.getItemValue(g, this.concurrencyTag);
                    if (h != null) {
                        let i = this.v.g(a);
                        i.version = h;
                    }
                }
            }
            return e;
        }
        removeItemByKey(a) {
            super.removeItemByKey(a);
            if (this.concurrencyTag != null && this.ar()) {
                let b = this.indexOfKey(a);
                if (b > -1) {
                    let c = this.getItemAtIndex(b);
                    let d = this.actualDataProvider.getItemValue(c, this.concurrencyTag);
                    if (d != null) {
                        let e = this.v.g(a);
                        e.version = d;
                    }
                }
            }
        }
        cq(a, b) {
            if (a == 5) {
                let c = b;
                let d = c.a;
                let e = new List$1(TransactionState.$, 0);
                for (let f = 0; f < d.length; f++) {
                    let g = d[f].transactionType;
                    let h = null;
                    let i = null;
                    if (g == TransactionType.Delete || g == 1) {
                        let j = new Dictionary$2(String_$type, Base.$, 0);
                        let k = d[f].id;
                        for (let l = 0; l < this.actualPrimaryKey.length; l++) {
                            j.addItem(this.actualPrimaryKey[l], k[l]);
                        }
                        h = j;
                    }
                    if (g == 0) {
                        let m = new Dictionary$2(String_$type, Base.$, 0);
                        let n = d[f].id;
                        let o = n[0];
                        for (let p = 0; p < this.actualSchema.propertyNames.length; p++) {
                            let q = this.actualSchema.propertyNames[p];
                            m.addItem(q, this.actualDataProvider.getItemValue(o, q));
                        }
                        i = m;
                    }
                    else if (g == 1) {
                        i = d[f].value;
                    }
                    if (h != null) {
                        let r = {};
                        let s = h;
                        for (let t of fromEnum(s)) {
                            r[t.key] = t.value;
                        }
                        h = r;
                    }
                    if (i != null) {
                        let u = {};
                        let v = i;
                        for (let w of fromEnum(v)) {
                            u[w.key] = w.value;
                        }
                        i = u;
                    }
                    e.add(((() => {
                        let $ret = new TransactionState(h, g, i);
                        $ret.version = d[f].version;
                        return $ret;
                    })()));
                }
                let x = e.toArray();
                if (this.batchStarted != null) {
                    this.batchStarted(this, new DataSourceBatchStartedEventArgs(x));
                }
                this.actualDataProvider.createBatchRequest(x);
            }
        }
        eq(a, b, c) {
            if (b) {
                this.queueAutoRefresh();
            }
            if (this.batchCompleted != null) {
                this.batchCompleted(this, new DataSourceBatchCompletedEventArgs(a, c));
            }
        }
    }
    VirtualDataSource.$t = /*@__PURE__*/ markType(VirtualDataSource, 'VirtualDataSource', BaseDataSource.$, [IPageCandidatesSink_$type]);
    return VirtualDataSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FlatDataProvider = /*@__PURE__*/ (() => {
    class FlatDataProvider extends Base {
        constructor() {
            super();
            this.n = new DataSourceLocalDataProvider();
            this.k = null;
            this.j = null;
            this.p = false;
            this.z = null;
            this.aa = null;
            this.h = 1;
            this.e = 0;
            this.ab = null;
            this.w = null;
            this.q = false;
            this.schemaChanged = null;
            this.propertyChanged = null;
            this.o = false;
            this.a = null;
            this.r = true;
            let a = this.n;
            a.schemaChanged = delegateCombine(a.schemaChanged, runOn(this, this.ap));
            this.n.sortDescriptions.n(runOn(this, this.ay));
            this.n.groupDescriptions.n(runOn(this, this.aw));
            this.n.summaryDescriptions.n(runOn(this, this.az));
            this.n.filterExpressions.n(runOn(this, this.av));
        }
        clone() {
            let a = new FlatDataProvider();
            a.deferAutoRefresh = this.deferAutoRefresh;
            a.executionContext = this.executionContext;
            a.dataSource = this.dataSource;
            a.propertiesRequested = this.propertiesRequested;
            a.schemaHints = this.schemaHints;
            a.summaryScope = this.summaryScope;
            a.leftJoinProperty = this.leftJoinProperty;
            a.rightJoinProperty = this.rightJoinProperty;
            a.joinCollisionType = this.joinCollisionType;
            a.joinType = this.joinType;
            if (this.targetDataSource != null) {
                a.targetDataSource = this.targetDataSource.clone();
            }
            if (this.rightDataSource != null) {
                a.rightDataSource = this.rightDataSource.clone();
            }
            for (let b = 0; b < this.groupDescriptions.k.count; b++) {
                a.groupDescriptions.add(this.groupDescriptions.k.item(b));
            }
            for (let c = 0; c < this.sortDescriptions.k.count; c++) {
                a.sortDescriptions.add(this.sortDescriptions.k.item(c));
            }
            for (let d = 0; d < this.filterExpressions.k.count; d++) {
                a.filterExpressions.add(this.filterExpressions.k.item(d));
            }
            for (let e = 0; e < this.summaryDescriptions.k.count; e++) {
                a.summaryDescriptions.add(this.summaryDescriptions.k.item(e));
            }
            return a;
        }
        av(a, b) {
            this.r = true;
        }
        az(a, b) {
            this.r = true;
        }
        aw(a, b) {
            this.r = true;
        }
        ay(a, b) {
            this.r = true;
        }
        ap(a, b) {
            if (this.schemaChanged != null) {
                this.schemaChanged(this, b);
            }
        }
        get targetDataSource() {
            return this.k;
        }
        set targetDataSource(a) {
            let b = this.k;
            this.k = a;
            if (b != this.k) {
                this.ax("TargetDataSource", b, this.k);
            }
        }
        get rightDataSource() {
            return this.j;
        }
        set rightDataSource(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.ax("RightDataSource", b, this.j);
            }
        }
        get broadcastChangesToRightDataSource() {
            return this.p;
        }
        set broadcastChangesToRightDataSource(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.ax("BroadcastChangesToRightDataSource", b, this.p);
            }
        }
        get leftJoinProperty() {
            return this.z;
        }
        set leftJoinProperty(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.ax("LeftJoinProperty", b, this.z);
            }
        }
        get rightJoinProperty() {
            return this.aa;
        }
        set rightJoinProperty(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.ax("RightJoinProperty", b, this.aa);
            }
        }
        get joinType() {
            return this.h;
        }
        set joinType(a) {
            let b = this.h;
            this.h = a;
            if (b != this.h) {
                this.ax("JoinType", enumGetBox(FlatDataProviderJoinType_$type, b), enumGetBox(FlatDataProviderJoinType_$type, this.h));
            }
        }
        get joinCollisionType() {
            return this.e;
        }
        set joinCollisionType(a) {
            let b = this.e;
            this.e = a;
            if (b != this.e) {
                this.ax("JoinCollisionType", enumGetBox(FlatDataProviderJoinCollisionType_$type, b), enumGetBox(FlatDataProviderJoinCollisionType_$type, this.e));
            }
        }
        get schemaHints() {
            return this.ab;
        }
        set schemaHints(a) {
            let b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.ax("SchemaHints", b, this.ab);
            }
        }
        get actualSchema() {
            return this.n.actualSchema;
        }
        get executionContext() {
            return this.n.executionContext;
        }
        set executionContext(a) {
            this.n.executionContext = a;
        }
        get updateNotifier() {
            return this.n.updateNotifier;
        }
        set updateNotifier(a) {
            this.n.updateNotifier = a;
        }
        get dataSource() {
            return this.w;
        }
        set dataSource(a) {
            let b = this.w;
            this.w = a;
            if (b != this.w) {
                this.ax("ItemsSource", b, this.w);
            }
        }
        get deferAutoRefresh() {
            return this.q;
        }
        set deferAutoRefresh(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.ax("DeferAutoRefresh", b, this.q);
            }
        }
        get isSortingSupported() {
            return this.n.isSortingSupported;
        }
        get isGroupingSupported() {
            return this.n.isGroupingSupported;
        }
        get isFilteringSupported() {
            return this.n.isFilteringSupported;
        }
        get sortDescriptions() {
            return this.n.sortDescriptions;
        }
        get groupDescriptions() {
            return this.n.groupDescriptions;
        }
        get summaryDescriptions() {
            return this.n.summaryDescriptions;
        }
        get summaryScope() {
            return this.n.summaryScope;
        }
        set summaryScope(a) {
            this.n.summaryScope = a;
        }
        get filterExpressions() {
            return this.n.filterExpressions;
        }
        get propertiesRequested() {
            return this.n.propertiesRequested;
        }
        set propertiesRequested(a) {
            this.n.propertiesRequested = a;
        }
        get schemaIncludedProperties() {
            return this.n.schemaIncludedProperties;
        }
        set schemaIncludedProperties(a) {
            this.n.schemaIncludedProperties = a;
        }
        get notifyUsingSourceIndexes() {
            return true;
        }
        get isItemIndexLookupSupported() {
            return this.n.isItemIndexLookupSupported;
        }
        get isKeyIndexLookupSupported() {
            return this.n.isKeyIndexLookupSupported;
        }
        get actualCount() {
            return this.n.actualCount;
        }
        ax(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.a5(a, b, c);
        }
        a5(a, b, c) {
            switch (a) {
                case "ItemsSource":
                    this.n.dataSource = c;
                    break;
                case "DeferAutoRefresh":
                    if (!c) {
                        this.queueAutoRefresh();
                    }
                    break;
                case "TargetDataSource":
                    if (b != null) {
                        let d = b;
                        if (d.updateNotifier != null) {
                            if (typeCast(FlatDataProviderTargetDataSourceNotifier.$, d.updateNotifier) !== null) {
                                d.updateNotifier = d.updateNotifier.c;
                            }
                        }
                        d.schemaChanged = delegateRemove(d.schemaChanged, runOn(this, this.au));
                    }
                    if (c != null) {
                        let e = c;
                        this.n.executionContext = e.executionContext;
                        let f = new FlatDataProviderTargetDataSourceNotifier(this, e.updateNotifier);
                        e.updateNotifier = f;
                        e.schemaChanged = delegateCombine(e.schemaChanged, runOn(this, this.au));
                    }
                    this.queueAutoRefresh();
                    break;
                case "RightDataSource":
                    if (b != null) {
                        let g = b;
                        if (g.updateNotifier != null) {
                            if (typeCast(FlatDataProviderTargetDataSourceNotifier.$, g.updateNotifier) !== null) {
                                g.updateNotifier = g.updateNotifier.c;
                            }
                        }
                        g.schemaChanged = delegateRemove(g.schemaChanged, runOn(this, this.au));
                    }
                    if (c != null) {
                        let h = c;
                        let i = new FlatDataProviderTargetDataSourceNotifier(this, h.updateNotifier);
                        h.updateNotifier = i;
                        h.schemaChanged = delegateCombine(h.schemaChanged, runOn(this, this.au));
                    }
                    this.queueAutoRefresh();
                    break;
            }
        }
        au(a, b) {
            this.r = true;
            this.queueAutoRefresh();
        }
        addItem(a) {
            this.n.addItem(a);
        }
        queueAutoRefresh() {
            if (this.deferAutoRefresh) {
                return;
            }
            if (this.o) {
                return;
            }
            if (this.executionContext != null) {
                this.o = true;
                this.executionContext.enqueueAction(runOn(this, this.ar));
            }
        }
        ar() {
            if (this.deferAutoRefresh) {
                this.o = false;
                return;
            }
            if (!this.o) {
                return;
            }
            this.o = false;
            this.a6();
        }
        a6() {
            this.a7();
        }
        a7() {
            if (this.k == null) {
                return;
            }
            if (!this.r) {
                return;
            }
            this.r = false;
            this.k.flushAutoRefresh();
            let a = this.k.isVirtual;
            if (a) {
                let b = 50;
                if (typeCast(VirtualDataSource.$, this.k) !== null) {
                    b = this.k.actualPageSize;
                }
                this.k.firstVisibleIndexRequested = 0;
                this.k.lastVisibleIndexRequested = b;
            }
            let c = this.b(this.k);
            if (this.rightDataSource != null && this.rightJoinProperty != null && this.leftJoinProperty != null) {
                let d = this.b(this.j);
                c = this.c(c, d);
            }
            this.dataSource = c;
        }
        c(a, b) {
            let c = new List$1(Base.$, 0);
            let d = this.u(a, this.targetDataSource, false);
            let e = this.u(b, this.rightDataSource, true);
            let f = this.joinCollisionType;
            switch (this.joinType) {
                case 0:
                    this.aq(c, a, d, this.targetDataSource, b, e, this.rightDataSource, false, f);
                    break;
                case 1:
                    this.aq(c, a, d, this.targetDataSource, b, e, this.rightDataSource, true, f);
                    break;
                case 2:
                    f = this.f(f);
                    this.aq(c, b, e, this.rightDataSource, a, d, this.targetDataSource, true, f);
                    break;
            }
            return c.toArray();
        }
        f(a) {
            switch (a) {
                case 0: return 0;
                case 1: return 2;
                case 2: return 1;
                case 3: return 4;
                case 4: return 3;
            }
            return 0;
        }
        u(a, b, c) {
            let d = this.leftJoinProperty;
            if (c) {
                d = this.rightJoinProperty;
            }
            let e = new Dictionary$2(Base.$, Base.$, 0);
            for (let f = 0; f < a.length; f++) {
                let g = a[f];
                let h = b.getItemProperty(g, d);
                e.item(h, g);
            }
            return e;
        }
        createDynamicItem() {
            return {};
        }
        setDynamicItemProperty(a, b, c) {
            if (b.charAt(0) == '[') {
                b = b.substr(1, b.length - 2);
            }
            let d = a;
            d[b] = c;
        }
        hasDynamicItemProperty(a, b) {
            let c = a;
            return c[b] != undefined;
        }
        aq(a, b, c, d, e, f, g, h, i) {
            let j = new HashSet$1(String_$type, 0);
            let k = new HashSet$1(String_$type, 0);
            let l = new HashSet$1(String_$type, 0);
            let m = new List$1(String_$type, 0);
            let n = new List$1(DataSourceSchemaPropertyType_$type, 0);
            if (d.actualSchema != null) {
                for (let o = 0; o < d.actualSchema.propertyNames.length; o++) {
                    let p = d.actualSchema.propertyNames[o];
                    let q = d.actualSchema.propertyTypes[o];
                    j.add_1(p);
                    if (!l.contains(p)) {
                        l.add_1(p);
                        m.add(p);
                        n.add(q);
                    }
                }
            }
            if (g.actualSchema != null) {
                for (let r = 0; r < g.actualSchema.propertyNames.length; r++) {
                    let s = g.actualSchema.propertyNames[r];
                    let t = g.actualSchema.propertyTypes[r];
                    k.add_1(s);
                    if (!l.contains(s)) {
                        l.add_1(s);
                        m.add(s);
                        n.add(t);
                    }
                }
            }
            let u = m.toArray();
            let v = n.toArray();
            for (let w = 0; w < b.length; w++) {
                let x = b[w];
                let y = d.getItemProperty(x, this.leftJoinProperty);
                let z = f.containsKey(y);
                if (!z && !h) {
                    continue;
                }
                let aa = this.createDynamicItem();
                let ab = null;
                if (z) {
                    ab = f.item(y);
                }
                this.at(aa, x, z, j, k, u, v, c, d, ab, f, g, i);
                a.add1(aa);
            }
        }
        at(a, b, c, d, e, f, g, h, i, j, k, l, m) {
            let n = i.actualSchema;
            let o = l.actualSchema;
            for (let p = 0; p < f.length; p++) {
                let q = f[p];
                let r = g[p];
                let s = d.contains(q) && e.contains(q);
                if (!s) {
                    if (d.contains(q)) {
                        let t = i.getItemProperty(b, q);
                        this.setDynamicItemProperty(a, q, t);
                        continue;
                    }
                    else {
                        let u = l.getItemProperty(j, q);
                        this.setDynamicItemProperty(a, q, u);
                        continue;
                    }
                }
                let v = m;
                if (q == this.leftJoinProperty) {
                    v = 1;
                }
                switch (v) {
                    case 0:
                        let w = i.getItemProperty(b, q);
                        this.setDynamicItemProperty(a, q, w);
                        continue;
                    case 1:
                        let x = i.getItemProperty(b, q);
                        this.setDynamicItemProperty(a, q, x);
                        continue;
                    case 2: if (c) {
                        let y = l.getItemProperty(j, q);
                        this.setDynamicItemProperty(a, q, y);
                        continue;
                    }
                    else {
                        this.setDynamicItemProperty(a, q, this.y(r));
                        continue;
                    }
                    case 3:
                        let z = i.getItemProperty(b, q);
                        this.setDynamicItemProperty(a, q, z);
                        continue;
                    case 4: if (c) {
                        let aa = l.getItemProperty(j, q);
                        this.setDynamicItemProperty(a, q, aa);
                        continue;
                    }
                    else {
                        let ab = i.getItemProperty(b, q);
                        this.setDynamicItemProperty(a, q, ab);
                        continue;
                    }
                }
            }
        }
        y(a) {
            return null;
        }
        flushAutoRefresh() {
            this.ar();
        }
        refresh() {
            this.a6();
        }
        getItemAtIndex(a) {
            return this.n.getItemAtIndex(a);
        }
        getItemValue(a, b) {
            return this.n.getItemValue(a, b);
        }
        indexOfItem(a) {
            return this.n.indexOfItem(a);
        }
        indexOfKey(a) {
            return this.n.indexOfKey(a);
        }
        removeItem(a) {
            this.n.removeItem(a);
        }
        resolveSchemaPropertyType(a) {
            return this.n.resolveSchemaPropertyType(a);
        }
        setItemValue(a, b, c) {
            this.n.setItemValue(a, b, c);
        }
        notifyClearItems() {
            if (this.targetDataSource != null) {
                this.targetDataSource.notifyClearItems();
            }
            if (this.rightDataSource != null && this.broadcastChangesToRightDataSource) {
                this.rightDataSource.notifyClearItems();
            }
        }
        notifyInsertItem(a, b) {
            if (this.targetDataSource != null) {
                this.targetDataSource.notifyInsertItem(a, b);
            }
            if (this.rightDataSource != null && this.broadcastChangesToRightDataSource) {
                this.rightDataSource.notifyInsertItem(a, b);
            }
        }
        notifyRemoveItem(a, b) {
            if (this.targetDataSource != null) {
                this.targetDataSource.notifyRemoveItem(a, b);
            }
            if (this.rightDataSource != null && this.broadcastChangesToRightDataSource) {
                this.rightDataSource.notifyRemoveItem(a, b);
            }
        }
        notifySetItem(a, b, c) {
            if (this.targetDataSource != null) {
                this.targetDataSource.notifySetItem(a, b, c);
            }
            if (this.rightDataSource != null && this.broadcastChangesToRightDataSource) {
                this.rightDataSource.notifySetItem(a, b, c);
            }
        }
        v(a) {
            return a.groupDescriptions.k.count;
        }
        b(a) {
            let b = this.d(a);
            return b;
        }
        as(a, b) {
            let c = this.k;
            if (this.a != null) {
                for (let d = 0; d < c.actualCount; d++) {
                    let e = c.getRowType(d);
                    {
                        let f = c.getItemAtIndex(d);
                        this.a[d] = f;
                    }
                }
            }
            this.n.notifyClearItems();
        }
        d(a) {
            let b = new List$1(Base.$, 0);
            for (let c = 0; c < a.actualCount; c++) {
                let d = a.getRowType(c);
                let e = a.getItemAtIndex(c);
                b.add1(e);
            }
            this.a = b.toArray();
            return this.a;
        }
        a0() {
            this.r = true;
            this.queueAutoRefresh();
        }
        a1(a, b) {
            this.r = true;
            this.queueAutoRefresh();
        }
        a2(a, b) {
            this.r = true;
            this.queueAutoRefresh();
        }
        a3(a, b, c) {
            this.r = true;
            this.queueAutoRefresh();
        }
        a4(a, b) {
            this.as(a, b);
            if (this.k.lastVisibleIndexRequested < this.k.actualCount) {
                let c = this.k.lastVisibleIndexRequested - this.k.firstVisibleIndexRequested;
                this.k.lastVisibleIndexRequested += c;
                this.k.firstVisibleIndexRequested += c;
            }
        }
    }
    FlatDataProvider.$t = /*@__PURE__*/ markType(FlatDataProvider, 'FlatDataProvider', Base.$, [IDataSourceLocalDataProvider_$type, INotifyPropertyChanged_$type]);
    return FlatDataProvider;
})();
/**
 * @hidden
 */
let FlatDataProviderTargetDataSourceNotifier = /*@__PURE__*/ (() => {
    class FlatDataProviderTargetDataSourceNotifier extends Base {
        get c() {
            return this.b;
        }
        constructor(a, b) {
            super();
            this.a = null;
            this.b = null;
            this.a = a;
            this.b = b;
        }
        notifyClearItems() {
            this.a.a0();
            if (this.b != null) {
                this.b.notifyClearItems();
            }
        }
        notifyInsertItem(a, b) {
            this.a.a1(a, b);
            if (this.b != null) {
                this.b.notifyInsertItem(a, b);
            }
        }
        notifyRemoveItem(a, b) {
            this.a.a2(a, b);
            if (this.b != null) {
                this.b.notifyRemoveItem(a, b);
            }
        }
        notifySetItem(a, b, c) {
            this.a.a3(a, b, c);
            if (this.b != null) {
                this.b.notifySetItem(a, b, c);
            }
        }
        rangeActualized(a, b) {
            this.a.a4(a, b);
            if (this.b != null) {
                this.b.rangeActualized(a, b);
            }
        }
    }
    FlatDataProviderTargetDataSourceNotifier.$t = /*@__PURE__*/ markType(FlatDataProviderTargetDataSourceNotifier, 'FlatDataProviderTargetDataSourceNotifier', Base.$, [IDataSourceUpdateNotifier_$type]);
    return FlatDataProviderTargetDataSourceNotifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSeriesAdapterRule_$type = /*@__PURE__*/ new Type(null, 'IDataSeriesAdapterRule');
/**
 * @hidden
 */
let DataSeriesAdapterRunContext = /*@__PURE__*/ (() => {
    class DataSeriesAdapterRunContext extends Base {
        get analyzer() {
            return this._analyzer;
        }
        set analyzer(a) {
            this._analyzer = a;
        }
        constructor(a) {
            super();
            this.g = null;
            this._analyzer = null;
            this.h = null;
            this.n = null;
            this.o = null;
            this.q = null;
            this.p = null;
            this.b = null;
            this.a = null;
            this.m = null;
            this.g = a;
            this.analyzer = new DataSeriesDataProviderAnalyzer(this);
            this.analyzer.includedProperties = this.g.includedProperties;
            this.analyzer.excludedProperties = this.g.excludedProperties;
            this.h = new DataSeriesCollection();
            this.n = new Stack$1(IDataSourceLocalDataProvider_$type);
            this.o = new Stack$1(IDataSourceLocalDataProvider_$type);
            this.q = new Stack$1(String_$type);
            this.p = new Stack$1(String_$type);
            this.b = this.g.includedProperties;
            this.a = this.g.excludedProperties;
            this.m = null;
            if (this.g.supportedSeriesTypes != null) {
                this.m = new HashSet$1(DataSeriesType_$type, 0);
                for (let b = 0; b < this.g.supportedSeriesTypes.length; b++) {
                    this.m.add_1(this.g.supportedSeriesTypes[b]);
                }
            }
        }
        getSubProvider(a, b) {
            let c = this.g.h(a, false);
            this.pushDataSource(c.c);
            if (c.b != null) {
                this.pushHighlightingDataSource(c.b);
            }
            else {
                this.pushHighlightingDataSource(null);
            }
            this.pushPath(b);
            return c.c;
        }
        popSubProvider() {
            this.popDataSource();
            this.popHighlightingDataSource();
            this.popPath();
        }
        z(a, b) {
            return this.g.ap(a, b);
        }
        recurseRules(a, b, c) {
            this.g.bb(this, a, b, c);
        }
        get includedProperties() {
            return this.b;
        }
        get excludedProperties() {
            return this.a;
        }
        getCurrentDataSource() {
            return this.n.d();
        }
        getCurrentHighlightingDataSource() {
            return this.o.d();
        }
        pushDataSource(a) {
            this.n.h(a);
        }
        pushHighlightingDataSource(a) {
            this.o.h(a);
        }
        hasValidType(a) {
            if (this.m == null) {
                return true;
            }
            if (this.m.contains(a.suggestedSeries)) {
                return true;
            }
            return false;
        }
        popDataSource() {
            return this.n.e();
        }
        popHighlightingDataSource() {
            return this.o.e();
        }
        getCurrentPathSegment() {
            return this.q.d();
        }
        getCurrentPath() {
            let a = "";
            let b = true;
            for (let c of fromEnum(this.q)) {
                if (b) {
                    b = false;
                }
                else {
                    a += ".";
                }
                a += c;
            }
            return a;
        }
        getParentTitle() {
            if (this.p.f == 0) {
                return null;
            }
            return this.p.d();
        }
        pushPath(a) {
            this.q.h(a);
        }
        popPath() {
            return this.q.e();
        }
        pushParentTitle(a) {
            this.p.h(a);
        }
        popParentTitle() {
            return this.p.e();
        }
        ae(a, b) {
            if (a.priority == -1) {
                a.priority = b.priority;
            }
            if (a.dataPath == null) {
                a.dataPath = this.getCurrentPath();
            }
            if (a.data == null) {
                a.data = this.getCurrentDataSource().dataSource;
            }
            if (a.highlightedData == null) {
                let c = this.getCurrentHighlightingDataSource();
                if (c != null) {
                    a.highlightedData = c.dataSource;
                }
            }
        }
        addDataSeries(a, b) {
            this.ae(a, b);
            this.h.add(a);
        }
        removeDataSeries(a) {
            this.h.remove(a);
        }
        insertDataSeries(a, b, c) {
            this.ae(b, c);
            this.h.insert(a, b);
        }
        clearDataSeries() {
            this.h.clear();
        }
        getDataSeriesCount() {
            return this.h.count;
        }
        getDataSeriesAt(a) {
            return this.h._inner[a];
        }
    }
    DataSeriesAdapterRunContext.$t = /*@__PURE__*/ markType(DataSeriesAdapterRunContext, 'DataSeriesAdapterRunContext');
    return DataSeriesAdapterRunContext;
})();
/**
 * @hidden
 */
let DataSeriesDataProviderAnalyzer = /*@__PURE__*/ (() => {
    class DataSeriesDataProviderAnalyzer extends Base {
        constructor(a) {
            super();
            this.u = null;
            this.b = null;
            this.a = null;
            this.x = false;
            this.w = false;
            this.ap = new HashSet$1(String_$type, 0);
            this.ar = new List$1(Matcher.$, 0);
            this.ao = new HashSet$1(String_$type, 0);
            this.aq = new List$1(Matcher.$, 0);
            this.u = a;
        }
        get includedProperties() {
            return this.b;
        }
        set includedProperties(a) {
            this.b = a;
            this.ap.clear();
            if (this.b == null) {
                this.x = false;
            }
            else {
                this.x = true;
                let d = this.b;
                for (let c = 0; c < d.length; c++) {
                    let b = d[c];
                    if (Matcher.a(b)) {
                        this.ar.add(new Matcher(b));
                    }
                    else {
                        this.ap.add_1(b);
                    }
                }
            }
        }
        get excludedProperties() {
            return this.a;
        }
        set excludedProperties(a) {
            this.a = a;
            this.ao.clear();
            if (this.a == null) {
                this.w = false;
            }
            else {
                this.w = true;
                let d = this.a;
                for (let c = 0; c < d.length; c++) {
                    let b = d[c];
                    if (Matcher.a(b)) {
                        this.aq.add(new Matcher(b));
                    }
                    else {
                        this.ao.add_1(b);
                    }
                }
            }
        }
        getParentTitle() {
            return this.u.getParentTitle();
        }
        shouldIncludeProperty(a, b) {
            if (!stringIsNullOrEmpty(b)) {
                a = b + "." + a;
            }
            if (this.x && !this.ap.contains(a) && !this.ad(a)) {
                return false;
            }
            if (this.w && (this.ao.contains(a) || this.z(a))) {
                return false;
            }
            return true;
        }
        z(a) {
            for (let b = 0; b < this.aq.count; b++) {
                if (this.aq._inner[b].b(a)) {
                    return true;
                }
            }
            return false;
        }
        ad(a) {
            for (let b = 0; b < this.ar.count; b++) {
                if (this.ar._inner[b].b(a)) {
                    return true;
                }
            }
            return false;
        }
        expandCamelCasedWords(a) {
            if (a == null) {
                return null;
            }
            a = stringReplace(stringReplace(a, "[", ""), "]", "");
            let b = new List$1(String_$type, 0);
            let c = 0;
            for (let d = 0; d < a.length; d++) {
                let e = a.charAt(d);
                let f = e.toUpperCase();
                let g = e.toLowerCase();
                if (d == 0) {
                    e = f;
                }
                let h = (c == 0 && b.count > 0);
                let i = (c > 1);
                if (f == e) {
                    if (h) {
                        b.add(' ');
                    }
                    c++;
                }
                else if (g == e) {
                    if (i) {
                        b.insert(b.count - 1, ' ');
                    }
                    c = 0;
                }
                else {
                    c = 0;
                }
                b.add(e);
            }
            let j = stringEmpty();
            for (let k = 0; k < b.count; k++) {
                j += b._inner[k];
            }
            return j;
        }
        hasStringProperties() {
            return this.getAllStringProperties().length > 0;
        }
        getAllStringProperties() {
            return this.s((a) => a == 0, null);
        }
        getAllExcludedStringProperties() {
            return this.r((a) => a == 0, null);
        }
        isCollection(a) {
            if (typeCast(IEnumerable_$type, a) !== null || typeCast(Array_$type, a) !== null) {
                return true;
            }
            return false;
        }
        getAllPropertiesWithName(a) {
            return this.s(null, (b) => b == a);
        }
        getAllNumericProperties() {
            return this.s(runOn(this, this.aj), null);
        }
        getAllObjectProperties() {
            return this.s(runOn(this, this.ak), null);
        }
        getAllCollectionProperties() {
            let a = this.getAllObjectProperties();
            if (a.length == 0) {
                return new Array(0);
            }
            let b = this.u.getCurrentDataSource();
            let c = new List$1(String_$type, 0);
            for (let d = 0; d < b.actualCount; d++) {
                if (this.isCollection(b.getItemAtIndex(d))) {
                    c.add(b.actualSchema.propertyNames[d]);
                }
            }
            return c.toArray();
        }
        getFirstNumericProperty() {
            let a = this.getAllNumericProperties();
            if (a.length == 0) {
                return null;
            }
            return a[0];
        }
        hasNumericProperties() {
            return this.getAllNumericProperties().length > 0;
        }
        ag(a) {
            if (a == 8 || a == 9) {
                return true;
            }
            return false;
        }
        v(a) {
            let b = this.u.getCurrentDataSource();
            if (b == null) {
                return 11;
            }
            let c = b.actualSchema;
            if (c == null) {
                return 11;
            }
            let d = -1;
            for (let e = 0; e < c.propertyNames.length; e++) {
                if (Base.equalsStatic(c.propertyNames[e], a)) {
                    d = e;
                    break;
                }
            }
            if (d == -1) {
                return 11;
            }
            return c.propertyTypes[d];
        }
        s(a, b) {
            let c = this.u.getCurrentDataSource();
            let d = c.actualSchema;
            if (d == null) {
                return new Array(0);
            }
            let e = this.u.getCurrentPath();
            let f = 0;
            for (let g = 0; g < d.propertyTypes.length; g++) {
                if ((a == null || a(d.propertyTypes[g])) && (b == null || b(d.propertyNames[g])) && this.an(d.propertyDataIntents, g) && this.shouldIncludeProperty(d.propertyNames[g], e)) {
                    f++;
                }
            }
            let h = new Array(f);
            f = 0;
            for (let i = 0; i < d.propertyTypes.length; i++) {
                if ((a == null || a(d.propertyTypes[i])) && (b == null || b(d.propertyNames[i])) && this.an(d.propertyDataIntents, i) && this.shouldIncludeProperty(d.propertyNames[i], e)) {
                    h[f] = d.propertyNames[i];
                    f++;
                }
            }
            return h;
        }
        r(a, b) {
            let c = this.u.getCurrentDataSource();
            let d = c.actualSchema;
            if (d == null) {
                return new Array(0);
            }
            let e = this.u.getCurrentPath();
            let f = 0;
            for (let g = 0; g < d.propertyTypes.length; g++) {
                if ((a == null || a(d.propertyTypes[g])) && (b == null || b(d.propertyNames[g])) && this.an(d.propertyDataIntents, g) && !this.shouldIncludeProperty(d.propertyNames[g], e)) {
                    f++;
                }
            }
            let h = new Array(f);
            f = 0;
            for (let i = 0; i < d.propertyTypes.length; i++) {
                if ((a == null || a(d.propertyTypes[i])) && (b == null || b(d.propertyNames[i])) && this.an(d.propertyDataIntents, i) && !this.shouldIncludeProperty(d.propertyNames[i], e)) {
                    h[f] = d.propertyNames[i];
                    f++;
                }
            }
            return h;
        }
        an(a, b) {
            if (a == null) {
                return true;
            }
            return !this.y(a, b, "DontPlot");
        }
        y(a, b, c) {
            if (a == null) {
                return false;
            }
            for (let d = 0; d < a[b].length; d++) {
                let e = a[b][d];
                if (Base.equalsStatic(e.toLowerCase(), c.toLowerCase())) {
                    return true;
                }
            }
            return false;
        }
        getAllPropertiesWithIntent(a) {
            return this.m(a, false, false);
        }
        getAllPropertiesWithValuelessIntent(a) {
            return this.m(a, true, false);
        }
        getPropertyIntentValue(a, b) {
            let c = this.u.getCurrentDataSource();
            if (c == null) {
                return null;
            }
            let d = c.actualSchema;
            if (d == null) {
                return null;
            }
            let e = d.propertyDataIntents;
            if (e == null || d.propertyNames == null) {
                return null;
            }
            for (let f = 0; f < d.propertyNames.length; f++) {
                if (d.propertyNames[f] != null && Base.equalsStatic(d.propertyNames[f], b)) {
                    for (let g = 0; g < e[f].length; g++) {
                        let h = e[f][g];
                        let i = h.split('/');
                        if (i.length == 2 && i[0] != null && Base.equalsStatic(i[0], a)) {
                            return i[1];
                        }
                    }
                }
            }
            return null;
        }
        getAllPropertiesWithValuedIntent(a) {
            return this.m(a, false, true);
        }
        m(a, b, c) {
            let d = this.u.getCurrentDataSource();
            if (d == null) {
                return new Array(0);
            }
            let e = d.actualSchema;
            if (e == null) {
                return new Array(0);
            }
            let f = e.propertyDataIntents;
            if (f == null || e.propertyNames == null) {
                return new Array(0);
            }
            let g = 0;
            for (let h = 0; h < e.propertyNames.length; h++) {
                for (let i = 0; i < f[h].length; i++) {
                    let j = f[h][i];
                    let k = j.split('/');
                    if (b && k.length > 1) {
                        continue;
                    }
                    if (c && k.length < 2) {
                        continue;
                    }
                    if (Base.equalsStatic(a.toLowerCase(), k[0].toLowerCase())) {
                        g++;
                    }
                }
            }
            let l = new Array(g);
            g = 0;
            for (let m = 0; m < e.propertyNames.length; m++) {
                for (let n = 0; n < f[m].length; n++) {
                    let o = f[m][n];
                    let p = o.split('/');
                    if (b && p.length > 1) {
                        continue;
                    }
                    if (c && p.length < 2) {
                        continue;
                    }
                    if (Base.equalsStatic(a.toLowerCase(), o.toLowerCase())) {
                        l[g] = e.propertyNames[m];
                        g++;
                    }
                }
            }
            return l;
        }
        getAllDateTimeProperties() {
            return this.s(runOn(this, this.ag), null);
        }
        getAllExcludedDateTimeProperties() {
            return this.r(runOn(this, this.ag), null);
        }
        getFirstDateTimeProperty() {
            let a = this.getAllDateTimeProperties();
            if (a.length == 0) {
                return null;
            }
            return a[0];
        }
        getFirstStringProperty() {
            let a = this.getAllStringProperties();
            if (a.length == 0) {
                return null;
            }
            return a[0];
        }
        hasDateTimeProperties() {
            return this.getAllDateTimeProperties().length > 0;
        }
        aj(a) {
            return a == 1 || a == 3 || a == 4 || a == 7 || a == 5 || a == 6 || a == 10;
        }
        ak(a) {
            return a == 11;
        }
        isMonotonic(a, b, c) {
            if (a == null) {
                return false;
            }
            let d = false;
            let e = false;
            let f = a.actualCount;
            for (let g = 0; g < Math.min(f, c); g++) {
                if (g == 0) {
                    continue;
                }
                let h = this.as(a.getItemValue(a.getItemAtIndex(g - 1), b));
                let i = this.as(a.getItemValue(a.getItemAtIndex(g), b));
                if (!e && h != i) {
                    d = i > h;
                    e = true;
                }
                if (h == i) {
                    continue;
                }
                if (e) {
                    let j = i > h;
                    if (j != d) {
                        return false;
                    }
                }
            }
            return true;
        }
        a1(a, b, c) {
            let d = this.u.getCurrentDataSource();
            let e = d.actualSchema;
            if (e == null) {
                return null;
            }
            let f = this.s(b, null);
            if (f.length == 0) {
                return null;
            }
            if (d.actualCount > a) {
                return null;
            }
            for (let g = 0; g < f.length; g++) {
                if (c(f[g], this.v(f[g]))) {
                    return f[g];
                }
            }
            return null;
        }
        getFirstDistinctStringProperty(a) {
            return this.a1(a, (b) => b == 0, runOn(this, this.al));
        }
        getFirstDistinctNumericProperty(a) {
            return this.a1(a, runOn(this, this.aj), runOn(this, this.ai));
        }
        getFirstDistinctMonotonicNumericProperty(a) {
            let b = this.u.getCurrentDataSource();
            return this.a1(a, runOn(this, this.aj), (c, d) => this.ai(c, d) && this.isMonotonic(b, c, a));
        }
        getAllDistinctMonotonicNumericProperties(a) {
            let b = this.u.getCurrentDataSource();
            return this.s(runOn(this, this.aj), (c) => this.ai(c, this.v(c)) && this.isMonotonic(b, c, a));
        }
        getAllExcludedDistinctMonotonicNumericProperties(a) {
            let b = this.u.getCurrentDataSource();
            return this.r(runOn(this, this.aj), (c) => this.ai(c, this.v(c)) && this.isMonotonic(b, c, a));
        }
        getFirstDistinctDateTimeProperty(a) {
            return this.a1(a, runOn(this, this.ag), runOn(this, this.af));
        }
        getFirstStringPropertyPreferringDistinct(a) {
            let b = this.getFirstDistinctStringProperty(a);
            if (b != null) {
                return b;
            }
            let c = this.getAllStringProperties();
            if (c.length == 0) {
                return null;
            }
            return c[0];
        }
        getTitleString(a, b) {
            return this.getTitleStringWithSeparator(a, b, " - ");
        }
        getTitleStringWithSeparator(a, b, c) {
            let d = this.u.getCurrentDataSource();
            let e = null;
            if (e == null && b != null) {
                let f = null;
                for (let g = 0; g < b.length; g++) {
                    let h = this.getPropertyIntentValue(EnumUtil.getName(DataSeriesIntent_$type, (10)), b[g]);
                    if (e == null) {
                        e = h;
                        f = h;
                    }
                    else {
                        if (h != null) {
                            if (h.trim().length > 0 && h != f) {
                                e += c + h;
                            }
                            f = h;
                        }
                    }
                }
            }
            if (e == null) {
                let i = this.getAllPropertiesWithValuelessIntent(EnumUtil.getName(DataSeriesIntent_$type, (10)));
                if (i != null && i.length > 0) {
                    e = i[0];
                    e = this.av(a, d, e);
                }
            }
            if (e == null) {
                if (this.getParentTitle() != null) {
                    e = this.getParentTitle();
                }
            }
            if (e == null && a != null) {
                let j = this.getAllStringProperties();
                for (let l = 0; l < j.length; l++) {
                    let k = j[l];
                    if (k != null && (Base.equalsStatic(k.toLowerCase(), "label") || Base.equalsStatic(k.toLowerCase(), "title"))) {
                        e = k;
                    }
                }
                if (e != null) {
                    e = this.av(a, d, e);
                }
            }
            return e;
        }
        av(a, b, c) {
            if (a != null) {
                let d = b.getItemValue(a, c);
                if (d != null) {
                    c = d.toString();
                }
            }
            else {
                c = this.getNonNullPropertyValue(c).toString();
            }
            return c;
        }
        getNonNullPropertyValue(a) {
            let b = this.u.getCurrentDataSource();
            for (let c = 0; c < b.actualCount; c++) {
                let d = b.getItemValue(b.getItemAtIndex(c), a);
                if (d != null) {
                    return d;
                }
            }
            return null;
        }
        al(a, b) {
            let c = this.u.getCurrentDataSource();
            let d = new HashSet$1(String_$type, 0);
            for (let e = 0; e < c.actualCount; e++) {
                let f = c.getItemValue(c.getItemAtIndex(e), a);
                let g = f;
                if (d.contains(g)) {
                    return false;
                }
                d.add_1(g);
            }
            return true;
        }
        af(a, b) {
            let c = this.u.getCurrentDataSource();
            let d = new HashSet$1(Number_$type, 0);
            for (let e = 0; e < c.actualCount; e++) {
                let f;
                let g = c.getItemValue(c.getItemAtIndex(e), a);
                if (g == null) {
                    f = dateMinValue();
                }
                else {
                    f = g;
                }
                if (d.contains(f.getTime())) {
                    return false;
                }
                d.add_1(f.getTime());
            }
            return true;
        }
        as(value_) {
            return (+value_);
        }
        ai(a, b) {
            let c = this.u.getCurrentDataSource();
            if (b == 4 || b == 1 || b == 3) {
                let d = new HashSet$1(Number_$type, 0);
                for (let e = 0; e < c.actualCount; e++) {
                    let f;
                    let g = c.getItemValue(c.getItemAtIndex(e), a);
                    if (g == null) {
                        f = -9.2233720368547758E+18;
                    }
                    else {
                        f = typeGetValue(g);
                    }
                    if (d.contains(f)) {
                        return false;
                    }
                    d.add_1(f);
                }
                return true;
            }
            if (b == 7 || b == 5 || b == 6) {
                let h = new HashSet$1(Number_$type, 0);
                for (let i = 0; i < c.actualCount; i++) {
                    let j;
                    let k = c.getItemValue(c.getItemAtIndex(i), a);
                    if (k == null) {
                        j = NaN;
                    }
                    else {
                        j = this.as(k);
                    }
                    if (h.contains(j)) {
                        return false;
                    }
                    h.add_1(j);
                }
                return true;
            }
            return false;
        }
    }
    DataSeriesDataProviderAnalyzer.$t = /*@__PURE__*/ markType(DataSeriesDataProviderAnalyzer, 'DataSeriesDataProviderAnalyzer');
    return DataSeriesDataProviderAnalyzer;
})();
/**
 * @hidden
 */
let DataSeriesAdapterUpdateNotifier = /*@__PURE__*/ (() => {
    class DataSeriesAdapterUpdateNotifier extends Base {
        constructor(a, b) {
            super();
            this.a = null;
            this.b = null;
            this.a = a;
            this.b = b;
        }
        notifyClearItems() {
            this.a.a4(this.b);
        }
        notifyInsertItem(a, b) {
            this.a.a5(this.b, a, b);
        }
        notifyRemoveItem(a, b) {
            this.a.a6(this.b, a, b);
        }
        notifySetItem(a, b, c) {
            this.a.a7(this.b, a, b, c);
        }
    }
    DataSeriesAdapterUpdateNotifier.$t = /*@__PURE__*/ markType(DataSeriesAdapterUpdateNotifier, 'DataSeriesAdapterUpdateNotifier', Base.$, [IDataSourceDataProviderUpdateNotifier_$type]);
    return DataSeriesAdapterUpdateNotifier;
})();
/**
 * @hidden
 */
let DataSeriesAdapterRuleCollection = /*@__PURE__*/ (() => {
    class DataSeriesAdapterRuleCollection extends ObservableCollection$1 {
        constructor() {
            super(IDataSeriesAdapterRule_$type, 0);
        }
    }
    DataSeriesAdapterRuleCollection.$t = /*@__PURE__*/ markType(DataSeriesAdapterRuleCollection, 'DataSeriesAdapterRuleCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(IDataSeriesAdapterRule_$type));
    return DataSeriesAdapterRuleCollection;
})();
/**
 * @hidden
 */
let DataSeriesAdapterRemovingDuplicatesEventArgs = /*@__PURE__*/ (() => {
    class DataSeriesAdapterRemovingDuplicatesEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
            this.d = null;
            this.e = null;
            this.a = null;
            this.c = false;
        }
    }
    DataSeriesAdapterRemovingDuplicatesEventArgs.$t = /*@__PURE__*/ markType(DataSeriesAdapterRemovingDuplicatesEventArgs, 'DataSeriesAdapterRemovingDuplicatesEventArgs');
    return DataSeriesAdapterRemovingDuplicatesEventArgs;
})();
/**
 * @hidden
 */
let DataSeriesAdapterRunEventArgs = /*@__PURE__*/ (() => {
    class DataSeriesAdapterRunEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.b = false;
        }
    }
    DataSeriesAdapterRunEventArgs.$t = /*@__PURE__*/ markType(DataSeriesAdapterRunEventArgs, 'DataSeriesAdapterRunEventArgs');
    return DataSeriesAdapterRunEventArgs;
})();
/**
 * @hidden
 */
let DataSeriesAdapterImplementation = /*@__PURE__*/ (() => {
    class DataSeriesAdapterImplementation extends Base {
        constructor() {
            super();
            this.ab = false;
            this.z = false;
            this.aa = false;
            this.ai = null;
            this.ak = null;
            this.ah = new Dictionary$2(Base.$, DataSeriesAdapterProviderInfo.$, 0);
            this.ag = new Dictionary$2(Base.$, DataSeriesAdapterProviderInfo.$, 0);
            this.aj = null;
            this.propertyChanged = null;
            this.c = null;
            this.b = null;
            this.a = null;
            this.t = null;
            this.s = null;
            this.r = null;
            this.m = null;
            this.n = null;
            this.x = null;
            this._rules = null;
            this._dataSeries = null;
            this.ac = false;
            this.removingUnsupported = null;
            this.removingDuplicates = null;
            this.t = new SortDescriptionCollection();
            this.r = new SortDescriptionCollection();
            this.x = new SummaryDescriptionCollection();
            this.m = new FilterExpressionCollection();
            this.n = new FilterExpressionCollection();
            this.s = new SortDescriptionCollection();
            this.t.n(runOn(this, this.as));
            this.r.n(runOn(this, this.as));
            this.x.n(runOn(this, this.as));
            this.m.n(runOn(this, this.as));
            this.n.n(runOn(this, this.as));
            this.s.n(runOn(this, this.as));
            this.rules = new DataSeriesAdapterRuleCollection();
            this.dataSeries = new DataSeriesCollection();
            this.a8(this.rules);
            let a = this.rules;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.bg));
        }
        as(a, b) {
            let c = this.ad;
            let d = this.af();
            let e = this.ae();
            if (c != this.z || d != this.ab || e != this.aa) {
                this.z = c;
                this.ab = d;
                this.aa = e;
                this.refresh();
            }
        }
        ap(a, b) {
            let c = stringEmpty();
            if (this.ai != null) {
                c = this.ai(a);
            }
            if (stringIsNullOrEmpty(c)) {
                return b;
            }
            return c;
        }
        a8(a) {
        }
        bg(a, b) {
            this.refresh();
        }
        get g() {
            return this.ak;
        }
        get itemsSource() {
            return this.aj;
        }
        set itemsSource(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.a3("ItemsSource", b, this.aj);
            }
        }
        get supportedSeriesTypes() {
            return this.c;
        }
        set supportedSeriesTypes(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.a3("SupportedSeriesTypes", b, this.c);
            }
        }
        get includedProperties() {
            return this.b;
        }
        set includedProperties(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
                this.a3("IncludedProperties", b, this.b);
            }
        }
        get excludedProperties() {
            return this.a;
        }
        set excludedProperties(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.a3("ExcludedProperties", b, this.a);
            }
        }
        get sortDescriptions() {
            return this.t;
        }
        get postSortDescriptions() {
            return this.s;
        }
        get groupDescriptions() {
            return this.r;
        }
        get filterExpressions() {
            return this.m;
        }
        get highlightFilterExpressions() {
            return this.n;
        }
        get summaryDescriptions() {
            return this.x;
        }
        get rules() {
            return this._rules;
        }
        set rules(a) {
            this._rules = a;
        }
        get dataSeries() {
            return this._dataSeries;
        }
        set dataSeries(a) {
            this._dataSeries = a;
        }
        a3(a, b, c) {
            this.a9(a, b, c);
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
        a9(a, b, c) {
            switch (a) {
                case "ItemsSource":
                    this.refresh();
                    break;
                case "SupportedSeriesTypes":
                    this.refresh();
                    break;
                case "IncludedProperties":
                    this.refresh();
                    break;
                case "ExcludedProperties":
                    this.refresh();
                    break;
            }
        }
        refresh() {
            this.ac = true;
            this.bf();
            let a = new DataSeriesAdapterRunContext(this);
            let b = this.h(this.itemsSource, true);
            this.at(this.itemsSource, b, null, false);
            a.pushDataSource(b.c);
            if (b.b != null) {
                a.pushHighlightingDataSource(b.b);
            }
            else {
                a.pushHighlightingDataSource(null);
            }
            this.bi(a);
            this.bk(a);
            this.au();
            this.ac = false;
        }
        ay(a, b) {
            let c = new DataSeriesAdapterRunContext(this);
            let d = this.h(this.itemsSource, true);
            c.pushDataSource(d.c);
            a.clear();
            let e = new HashSet$1(String_$type, 0);
            for (let f = 0; f < this.rules.count; f++) {
                let g = this.rules._inner[f];
                let h = g.getPrimaryAxisLabelsStrings(c);
                if (h == null) {
                    continue;
                }
                for (let j = 0; j < h.length; j++) {
                    let i = h[j];
                    if (i == null) {
                        continue;
                    }
                    e.add_1(i);
                    a.add_1(new Tuple$2(String_$type, String_$type, i, c.analyzer.expandCamelCasedWords(i)));
                }
            }
            b.clear();
            let k = d.c.actualSchema.propertyNames;
            for (let m = 0; m < k.length; m++) {
                let l = k[m];
                if (e.contains(l)) {
                    continue;
                }
                b.add_1(new Tuple$2(String_$type, String_$type, l, c.analyzer.expandCamelCasedWords(l)));
            }
        }
        bf() {
            for (let a of fromEnum(this.ah.keys)) {
                let b = this.ah.item(a);
                b.d = false;
            }
        }
        au() {
            let a = new List$1(Base.$, 0);
            for (let b of fromEnum(this.ah.keys)) {
                let c = this.ah.item(b);
                if (!c.d) {
                    a.add1(b);
                    this.av(c);
                }
            }
            for (let d = 0; d < a.count; d++) {
                let e = a._inner[d];
                this.ah.removeItem(e);
            }
        }
        bk(a) {
            this.be(a);
            this.bd(a);
            this.bj(a);
        }
        be(a) {
            let b = true;
            if (this.removingUnsupported != null) {
                let c = ((() => {
                    let $ret = new DataSeriesAdapterRunEventArgs();
                    $ret.a = a;
                    return $ret;
                })());
                this.removingUnsupported(this, c);
                b = !c.b;
            }
            if (b) {
                if (this.supportedSeriesTypes == null) {
                    return;
                }
                let d = new HashSet$1(DataSeriesType_$type, 0);
                for (let e = 0; e < this.supportedSeriesTypes.length; e++) {
                    d.add_1(this.supportedSeriesTypes[e]);
                }
                for (let f = a.getDataSeriesCount() - 1; f >= 0; f--) {
                    let g = a.getDataSeriesAt(f);
                    if (!d.contains(g.suggestedSeries)) {
                        a.removeDataSeries(g);
                    }
                }
            }
        }
        bj(a) {
            let b = 0;
            for (; b < Math.min(this.dataSeries.count, a.getDataSeriesCount()); b++) {
                if (!this.dataSeries._inner[b].equals(a.getDataSeriesAt(b))) {
                    this.dataSeries.removeAt(b);
                    b--;
                }
            }
            for (; b < a.getDataSeriesCount(); b++) {
                this.dataSeries.insert(b, a.getDataSeriesAt(b));
            }
            for (; b < this.dataSeries.count; b++) {
                this.dataSeries.removeAt(b);
                b--;
            }
        }
        bd(a) {
            let b = new Dictionary$2(String_$type, List$1.$.specialize(DataSeries.$), 0);
            for (let c = 0; c < a.getDataSeriesCount(); c++) {
                let d = a.getDataSeriesAt(c);
                let e = d.j();
                for (let f = 0; f < e.count; f++) {
                    if (e.item(f).intent == 16 || e.item(f).intent == 17) {
                        continue;
                    }
                    let g = (d.dataPath != null ? (d.dataPath + ".") : "") + e.item(f).path;
                    if (e.item(f).intent == 25) {
                        g = e.item(f).path;
                    }
                    if (!b.containsKey(g)) {
                        b.item(g, new List$1(DataSeries.$, 0));
                    }
                    b.item(g).add(d);
                }
            }
            for (let h of fromEnum(b.keys)) {
                if (b.item(h).count > 1) {
                    let i = new Array(b.item(h).count);
                    let j = b.item(h);
                    let k = j.count;
                    for (let l = 0; l < k; l++) {
                        i[l] = j._inner[l];
                    }
                    let m = true;
                    if (this.removingDuplicates != null) {
                        let n = ((() => {
                            let $ret = new DataSeriesAdapterRemovingDuplicatesEventArgs();
                            $ret.e = h;
                            $ret.b = a;
                            $ret.a = i;
                            return $ret;
                        })());
                        m = !n.c;
                    }
                    if (m) {
                        let o = -1;
                        let p = null;
                        j = b.item(h);
                        k = j.count;
                        for (let q = 0; q < k; q++) {
                            let r = j._inner[q];
                            if (r.priority > o) {
                                o = r.priority;
                                p = r;
                            }
                        }
                        for (let s = 0; s < k; s++) {
                            let t = j._inner[s];
                            if (t != p) {
                                a.removeDataSeries(t);
                            }
                        }
                    }
                }
            }
        }
        bi(a) {
            for (let b = 0; b < this.rules.count; b++) {
                this.bh(a, this.rules._inner[b]);
            }
        }
        bh(a, b) {
            b.evaluate(a);
        }
        get ad() {
            return this.sortDescriptions.k.count > 0 || this.groupDescriptions.k.count > 0 || this.filterExpressions.k.count > 0 || this.highlightFilterExpressions.k.count > 0 || this.summaryDescriptions.k.count > 0;
        }
        af() {
            return this.groupDescriptions.k.count > 0 && this.postSortDescriptions.k.count > 0;
        }
        ae() {
            return this.highlightFilterExpressions.k.count > 0;
        }
        h(a, b) {
            let c = new DataSeriesAdapterProviderInfo();
            let d = this.af();
            let e = this.ae();
            let f = 0;
            if (typeCast(IDataSource_$type, a) !== null || (b && this.ad)) {
                if (d || e) {
                    f = 2;
                }
                else {
                    f = 1;
                }
            }
            if (a != null && this.ah.containsKey(a)) {
                let g = this.ah.item(a);
                g.d = true;
                if (g.a != f) {
                    this.aw(this.ah, a, g);
                }
                else {
                    return g;
                }
            }
            if (typeCast(IDataSourceLocalDataProvider_$type, a) !== null) {
                c.c = a;
                return c;
            }
            if (typeCast(IDataSource_$type, a) !== null) {
                let h = new AggregatedDataProvider();
                h.targetDataSource = a;
                this.sortDescriptions.o(h.targetDataSource.sortDescriptions);
                this.groupDescriptions.o(h.targetDataSource.groupDescriptions);
                this.filterExpressions.o(h.targetDataSource.filterExpressions);
                this.summaryDescriptions.o(h.targetDataSource.summaryDescriptions);
                c.e.add(() => {
                    this.sortDescriptions.s(h.targetDataSource.sortDescriptions);
                    this.groupDescriptions.s(h.targetDataSource.groupDescriptions);
                    this.filterExpressions.s(h.targetDataSource.filterExpressions);
                    this.summaryDescriptions.s(h.targetDataSource.summaryDescriptions);
                });
                if (f == 2) {
                    let i = this.q(c, h);
                    c.c = i;
                    if (e) {
                        this.ax(c);
                    }
                    return c;
                }
                c.c = h;
                return c;
            }
            if (b && this.ad) {
                let j = this.g.getLocalDataSource(a);
                j.deferAutoRefresh = true;
                let k = new AggregatedDataProvider();
                k.targetDataSource = j;
                this.sortDescriptions.o(k.targetDataSource.sortDescriptions);
                this.groupDescriptions.o(k.targetDataSource.groupDescriptions);
                this.filterExpressions.o(k.targetDataSource.filterExpressions);
                this.summaryDescriptions.o(k.targetDataSource.summaryDescriptions);
                c.e.add(() => {
                    this.sortDescriptions.s(k.targetDataSource.sortDescriptions);
                    this.groupDescriptions.s(k.targetDataSource.groupDescriptions);
                    this.filterExpressions.s(k.targetDataSource.filterExpressions);
                    this.summaryDescriptions.s(k.targetDataSource.summaryDescriptions);
                });
                j.deferAutoRefresh = false;
                if (f == 2) {
                    let l = this.q(c, k);
                    c.c = l;
                    if (e) {
                        this.ax(c);
                    }
                    return c;
                }
                c.c = k;
                return c;
            }
            let m = this.g.getDataProvider(a);
            c.c = m;
            return c;
        }
        ax(a) {
            let b = new DataSeriesAdapterRunContext(this);
            a.c.flushAutoRefresh();
            b.pushDataSource(a.c);
            let c = this.aq(b, a);
            if (c == null) {
                return;
            }
            if (typeCast(FlatDataProvider.$, a.c) !== null) {
                let d = a.c;
                let e = d.targetDataSource;
                let f = e.clone();
                let g = f.dataProvider;
                let h = g.targetDataSource;
                this.highlightFilterExpressions.o(h.filterExpressions);
                this.groupDescriptions.o(h.groupDescriptions);
                this.sortDescriptions.o(h.sortDescriptions);
                this.summaryDescriptions.o(h.summaryDescriptions);
                a.e.add(() => {
                    this.highlightFilterExpressions.s(h.filterExpressions);
                    this.groupDescriptions.s(h.groupDescriptions);
                    this.sortDescriptions.s(h.sortDescriptions);
                    this.summaryDescriptions.s(h.summaryDescriptions);
                });
                f.flushAutoRefresh();
                let i = new FlatDataProvider();
                i.targetDataSource = e;
                i.rightDataSource = f;
                d.joinType = 1;
                d.rightDataSource = f;
                d.leftJoinProperty = c;
                d.rightJoinProperty = c;
                d.joinCollisionType = 1;
                i.joinType = 1;
                i.rightDataSource = f;
                i.leftJoinProperty = c;
                i.rightJoinProperty = c;
                i.joinCollisionType = 2;
                d.broadcastChangesToRightDataSource = true;
                a.c = d;
                i.flushAutoRefresh();
                a.b = i;
            }
        }
        aq(a, b) {
            let c = -1;
            let d = null;
            for (let e = 0; e < this.rules.count; e++) {
                let f = this.rules._inner[e].priority;
                let g = this.rules._inner[e].getPrimaryAxisLabelsString(a);
                if (g != null && f > c) {
                    d = g;
                    c = f;
                }
            }
            return d;
        }
        q(a, b) {
            let c = this.g.getLocalDataSource(null);
            c.dataProvider = b;
            let d = new FlatDataProvider();
            d.targetDataSource = c;
            this.postSortDescriptions.o(d.targetDataSource.sortDescriptions);
            a.e.add(() => this.postSortDescriptions.s(d.targetDataSource.sortDescriptions));
            return d;
        }
        aw(a, b, c) {
            this.av(c);
            a.removeItem(b);
        }
        av(a) {
            if (a.e.count > 0) {
                for (let b = 0; b < a.e.count; b++) {
                    let c = a.e._inner[b];
                    c();
                }
                a.e.clear();
            }
            let d = a.c;
            d.updateNotifier = null;
            d.schemaChanged = delegateRemove(d.schemaChanged, runOn(this, this.ba));
            let e = a.b;
            if (e != null) {
                e.updateNotifier = null;
                e.schemaChanged = delegateRemove(e.schemaChanged, runOn(this, this.ba));
            }
        }
        bb(a, b, c, d) {
            let e = this.h(b, false);
            this.at(b, e, a.getCurrentDataSource(), d);
            a.pushDataSource(e.c);
            if (e.b != null) {
                a.pushHighlightingDataSource(e.b);
            }
            else {
                a.pushHighlightingDataSource(null);
            }
            a.pushPath(c);
            this.bi(a);
            a.popPath();
            a.popDataSource();
            a.popHighlightingDataSource();
        }
        at(a, b, c, d) {
            if (a != null && !this.ah.containsKey(a)) {
                b.a = 0;
                if (typeCast(AggregatedDataProvider.$, b.c) !== null) {
                    b.a = 1;
                }
                else if (typeCast(FlatDataProvider.$, b.c) !== null) {
                    b.a = 2;
                }
                b.d = true;
                this.ah.addItem(a, b);
                let e = b.c;
                e.schemaChanged = delegateCombine(e.schemaChanged, runOn(this, this.ba));
                if (b.b != null) {
                    let f = b.b;
                    f.schemaChanged = delegateCombine(f.schemaChanged, runOn(this, this.ba));
                }
                if (c != null) {
                    let g = new DataSeriesAdapterUpdateNotifier(this, b.c);
                    c.updateNotifier = g;
                }
                if (d) {
                    let h = new DataSeriesAdapterUpdateNotifier(this, b.c);
                    b.c.updateNotifier = h;
                    if (b.b != null) {
                        let i = new DataSeriesAdapterUpdateNotifier(this, b.b);
                        b.b.updateNotifier = h;
                    }
                }
            }
        }
        ba(a, b) {
            if (!this.ac) {
                this.refresh();
            }
        }
        a4(a) {
            this.refresh();
        }
        a5(a, b, c) {
            this.refresh();
        }
        a6(a, b, c) {
            this.refresh();
        }
        a7(a, b, c, d) {
            this.refresh();
        }
        notifyClearItems(a) {
            if (this.ah.containsKey(a)) {
                this.ah.item(a).c.notifyClearItems();
            }
        }
        notifyInsertItem(a, b, c) {
            if (this.ah.containsKey(a)) {
                this.ah.item(a).c.notifyInsertItem(b, c);
            }
        }
        notifyRemoveItem(a, b, c) {
            if (this.ah.containsKey(a)) {
                this.ah.item(a).c.notifyRemoveItem(b, c);
            }
        }
        notifySetItem(a, b, c, d) {
            if (this.ah.containsKey(a)) {
                this.ah.item(a).c.notifySetItem(b, c, d);
            }
        }
    }
    DataSeriesAdapterImplementation.$t = /*@__PURE__*/ markType(DataSeriesAdapterImplementation, 'DataSeriesAdapterImplementation', Base.$, [INotifyPropertyChanged_$type]);
    return DataSeriesAdapterImplementation;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryGroup = /*@__PURE__*/ (() => {
    class SummaryGroup extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
        }
    }
    SummaryGroup.$t = /*@__PURE__*/ markType(SummaryGroup, 'SummaryGroup');
    return SummaryGroup;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RemovedShiftedRowInfo = /*@__PURE__*/ (() => {
    class RemovedShiftedRowInfo extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this._item = null;
        }
        get item() {
            return this._item;
        }
        set item(a) {
            this._item = a;
        }
    }
    RemovedShiftedRowInfo.$t = /*@__PURE__*/ markType(RemovedShiftedRowInfo, 'RemovedShiftedRowInfo');
    return RemovedShiftedRowInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RearrangedListView = /*@__PURE__*/ (() => {
    class RearrangedListView extends Base {
        get bl() {
            return this.a8;
        }
        get i() {
            return this.e;
        }
        get a7() {
            return this.a5;
        }
        get aq() {
            if (!this.m.isSectionContentVisible) {
                return true;
            }
            return this.m.isSectionCollapsable;
        }
        constructor(a) {
            super();
            this.n = null;
            this.a5 = null;
            this.z = new SectionMap();
            this.e = null;
            this.a = null;
            this.b = null;
            this.c = null;
            this.d = null;
            this.a9 = 0;
            this.a8 = 0;
            this.am = false;
            this.as = false;
            this.o = null;
            this.a1 = null;
            this.a0 = null;
            this.s = null;
            this.aa = null;
            this.ac = null;
            this.m = null;
            this.ae = null;
            this.af = null;
            this.ag = null;
            this.ap = false;
            this.k = 0;
            this.j = 0;
            this.av = false;
            this.au = false;
            this.aw = false;
            this.ax = false;
            this.ah = false;
            this.a4 = new List$1(Array_$type, 0);
            this.az = new Dictionary$2(String_$type, Boolean_$type, 0);
            this.n = a;
        }
        w(a) {
            return this.z.e(a);
        }
        v() {
            return this.z.d();
        }
        get p() {
            return this.o;
        }
        set p(a) {
            this.o = a;
        }
        get a3() {
            return this.a1;
        }
        set a3(a) {
            this.a1 = a;
        }
        get a2() {
            return this.a0;
        }
        set a2(a) {
            this.a0 = a;
        }
        get t() {
            return this.s;
        }
        set t(a) {
            this.s = a;
        }
        get ab() {
            return this.aa;
        }
        set ab(a) {
            this.aa = a;
        }
        get ad() {
            return this.ac;
        }
        set ad(a) {
            this.ac = a;
        }
        get l() {
            return this.k;
        }
        set l(a) {
            this.k = a;
        }
        get ar() {
            if (!this.m.isSectionContentVisible) {
                return false;
            }
            if (this.aq) {
                return this.m.isSectionExpandedDefault;
            }
            return true;
        }
        b7() {
            if (this.a5 == this.n || this.a5 == null) {
                this.a5 = new List$1(Base.$, 0);
            }
            this.a5.clear();
            if (!this.aq) {
                this.az.clear();
            }
            if (this.n == null) {
                return;
            }
            let a = this.n.actualCount;
            this.a8 = 0;
            this.a9 = this.bb();
            this.bs(null);
            let b = this.ag.k.count > 0 && this.l != 2 && this.l != 3;
            if (this.s == null) {
                for (let c = 0; c < a; c++) {
                    let d = this.n.getItemAtIndex(c);
                    this.a5.add1(d);
                    if (b) {
                        this.br(null, d);
                    }
                }
            }
            else {
                for (let e = 0; e < a; e++) {
                    let f = this.n.getItemAtIndex(e);
                    if (this.s(f)) {
                        this.a5.add1(f);
                        if (b) {
                            this.br(null, f);
                        }
                    }
                }
            }
            this.bv(null);
            if (this.a1 != null) {
                this.a5.z(this.a1);
            }
            this.ah = false;
            this.z.v();
            if (this.ae != null && this.ae.k.count > 0) {
                this.ah = true;
                this.b2();
            }
            else {
                this.z.t.add(((() => {
                    let $ret = new SectionData();
                    $ret.ae = 0;
                    $ret.e = null;
                    $ret.f = null;
                    $ret.af = 0;
                    $ret.ad = this.a5.count;
                    $ret.c = new Array(0);
                    $ret.d = new Array(1);
                    return $ret;
                })()));
            }
            if (this.ax && b) {
                this.bx(this.e);
            }
            let g = this.p;
            let h = new List$1(Base.$, 0);
            if (this.a4.count > 0 && this.aw) {
                if (!this.ah) {
                    let i = this.z.t._inner[0];
                    for (let j = 0; j < this.a4.count; j++) {
                        let k = this.m.indexOfKey(this.a4._inner[j]);
                        if (k != -1) {
                            this.bk(i, this.a5._inner[k], j);
                        }
                    }
                }
                else {
                    for (let l = 0; l < this.a4.count; l++) {
                        let m = this.m.indexOfKey(this.a4._inner[l]);
                        if (m != -1) {
                            let n = this.z.e(m);
                            this.bk(n, this.a5._inner[m], l);
                        }
                    }
                }
            }
            if (this.ab != null) {
                this.ab.notifyClearItems();
            }
        }
        bm(a, b) {
            let c = null;
            if (a.p) {
                if (b) {
                    let d = a.af + a.v() + a.ah + a.aa;
                    c = this.a5._inner[d];
                }
                else {
                    let e = a.ad - a.u - a.ag;
                    c = this.a5._inner[e];
                }
            }
            return c;
        }
        get a6() {
            return this.z.t;
        }
        b2() {
            if (this.a5.count == 0) {
                return;
            }
            let a = dateNow();
            let b = this.f();
            let c = this.g();
            let d = this.j == 1 ? c.length : 1;
            if (this.b == null || this.b.length != c.length) {
                this.a = new Array(d);
                this.b = new Array(d);
                for (let e = 0; e < d; e++) {
                    this.a[e] = null;
                    this.b[e] = null;
                }
            }
            this.c = new Array(d);
            for (let f = 0; f < d; f++) {
                this.c[f] = new Array(this.ag.k.count);
            }
            let g = this.l == 3 || this.l == 1;
            let h = new List$1(Base.$, 0);
            let i = null;
            let j = null;
            if (this.m.isSectionContentVisible || !this.av) {
                for (let k = 0; k < this.a5.count; k++) {
                    let l = this.a5._inner[k];
                    if (l == null) {
                        continue;
                    }
                    if (i == null) {
                        let m = this.x(k, l, c);
                        k += this.bd(m, k, b, c, true);
                        this.bt(m, true, g);
                        this.z.z(m, 1);
                        this.br(m, l);
                        j = l;
                    }
                    else {
                        if (this.a2.compare(i, l) != 0) {
                            let n = this.z.t._inner[this.z.t.count - 1];
                            if (n.q) {
                                k += this.bc(k, j, b, c);
                            }
                            this.bu(k - 1, j, b);
                            let o = this.x(k, l, c);
                            this.bt(o, false, g);
                            let p = this.bd(o, k, b, c, true);
                            k += p;
                            o.q = this.z.r(o);
                            this.z.z(o, 1);
                            this.br(o, l);
                            j = l;
                        }
                        else {
                            let q = this.z.t._inner[this.z.t.count - 1];
                            this.z.z(q, 1);
                            this.br(q, l);
                        }
                    }
                    if (k == this.a5.count - 1) {
                        let r = this.z.t._inner[this.z.t.count - 1];
                        if (r.q) {
                            k += this.bc(k + 1, j, b, c);
                        }
                        this.bu(k, j, b);
                    }
                    i = l;
                }
                if (!g) {
                    if (this.j == 1) {
                        for (let s = 0; s < c.length; s++) {
                            if (this.b[s] == null) {
                                continue;
                            }
                            for (let t = 0; t < this.ag.k.count; t++) {
                                this.b[s].i[s][t] = this.c[s][t].endCalculation();
                                this.b[s].i[s][t].summaryIndex = t;
                                this.b[s].i[s][t].groupKey = this.b[s].f;
                            }
                            for (let u = 0; u < this.b[s].h.length; u++) {
                                if (this.b[s].h[u] == -1) {
                                    this.b[s].h[u] = this.z.t._inner[this.z.t.count - 1].ad + 1;
                                }
                            }
                        }
                    }
                    else {
                        if (this.b[0] != null) {
                            for (let v = 0; v < this.ag.k.count; v++) {
                                this.b[0].i[0][v] = this.c[0][v].endCalculation();
                                this.b[0].i[0][v].summaryIndex = v;
                                this.b[0].i[0][v].groupKey = this.b[0].f;
                            }
                            this.b[0].h[0] = this.z.t._inner[this.z.t.count - 1].ad + 1;
                        }
                    }
                }
                this.by();
                for (let w = 0; w < this.z.t.count; w++) {
                    let x = this.z.t._inner[w];
                    if (this.av) {
                        if (!x.q) {
                            let y = x.ad - x.af + 1;
                            if (this.j == 1 && this.ae.k.count > 1 && this.am && this.as) {
                                let z = x.w();
                                let aa = false;
                                if (w + 1 < this.z.t.count && this.z.t._inner[w + 1].w() == 0) {
                                    aa = true;
                                }
                                if (aa) {
                                    let ab = x.v();
                                    y = ab + x.d[x.d.length - 1];
                                }
                            }
                            this.a5.v(x.af, y);
                            this.z.ae(x.ae);
                            this.z.ab(x, -y, -y);
                            w--;
                        }
                        else if (!x.p) {
                            let ac = 0;
                            let ad = x.w();
                            for (let ae = ad; ae < x.c.length; ae++) {
                                ac = x.b[ae];
                                if (!x.c[ae]) {
                                    break;
                                }
                            }
                            let af = x.af + ac + 1;
                            let ag = x.d[x.d.length - 1];
                            this.a5.v(af, ag);
                            x.ad -= ag;
                            this.z.ac(x, -ag, -ag);
                        }
                    }
                }
            }
            else {
                for (let ah = 0; ah < this.a5.count; ah++) {
                    let ai = this.a5._inner[ah];
                    if (ai == null) {
                        continue;
                    }
                    if (i == null) {
                        let aj = this.x(ah, ai, c);
                        this.be(h, aj, ai, b, c, true);
                        this.bt(aj, true, g);
                        this.z.z(aj, 1);
                        this.br(aj, ai);
                        j = ai;
                    }
                    else {
                        if (this.a2.compare(i, ai) != 0) {
                            let ak = this.z.t._inner[this.z.t.count - 1];
                            this.bu(h.count - 1, j, b);
                            let al = this.x(ah, ai, c);
                            this.bt(al, false, g);
                            this.be(h, al, ai, b, c, true);
                            al.q = this.z.r(al);
                            this.z.z(al, 1);
                            this.br(al, ai);
                            j = ai;
                        }
                        else {
                            let am = this.z.t._inner[this.z.t.count - 1];
                            this.z.z(am, 1);
                            this.br(am, ai);
                        }
                    }
                    if (ah == this.a5.count - 1) {
                        let an = this.z.t._inner[this.z.t.count - 1];
                        this.bu(ah, j, b);
                    }
                    i = ai;
                }
                this.a5 = h;
            }
            for (let ao = 0; ao < this.b.length; ao++) {
                this.a[ao] = null;
                this.b[ao] = null;
            }
            this.c = null;
            let ap = dateNow();
        }
        bt(a, b, c) {
            if (b) {
                for (let d = 0; d < this.b.length; d++) {
                    this.b[d] = a;
                    if (!c) {
                        for (let e = 0; e < this.ag.k.count; e++) {
                            let f = this.ag.k.item(e);
                            this.c[d][e] = f.f();
                            this.c[d][e].beginCalculation(this.m, f.propertyName);
                        }
                    }
                }
            }
            if (this.j == 1) {
                let g = false;
                let h = a.e.length;
                for (let i = 0; i < h; i++) {
                    if (g) {
                        if (!c) {
                            for (let j = 0; j < this.ag.k.count; j++) {
                                this.b[i].i[i][j] = this.c[i][j].endCalculation();
                                this.b[i].i[i][j].summaryIndex = j;
                                this.b[i].i[i][j].groupKey = this.b[i].f;
                                this.c[i][j].beginCalculation(this.m, this.ag.k.item(j).propertyName);
                            }
                            this.b[i].h[i] = a.af;
                        }
                        this.b[i] = a;
                        continue;
                    }
                    let k = false;
                    if (this.b[i].f[i] == null) {
                        k = a.f[i] != null;
                    }
                    else {
                        k = !Base.equalsStatic(this.b[i].f[i], a.f[i]);
                    }
                    if (k) {
                        if (!c) {
                            for (let l = 0; l < this.ag.k.count; l++) {
                                this.b[i].i[i][l] = this.c[i][l].endCalculation();
                                this.b[i].i[i][l].summaryIndex = l;
                                this.b[i].i[i][l].groupKey = this.b[i].f;
                                this.c[i][l].beginCalculation(this.m, this.ag.k.item(l).propertyName);
                            }
                            this.b[i].h[i] = a.af;
                        }
                        this.b[i] = a;
                        if (i - 1 > -1) {
                            let m = i - 1;
                            while (m >= 0 && this.b[m].o) {
                                m = m - 1;
                            }
                            a.z = this.b[m].ae;
                        }
                        g = true;
                    }
                }
            }
            else {
                let n = false;
                for (let o = 0; o < a.e.length; o++) {
                    if (this.b[0].f[o] == null) {
                        if (this.b[0].f[o] != a.f[o]) {
                            n = true;
                            break;
                        }
                        continue;
                    }
                    if (!Base.equalsStatic(this.b[0].f[o], a.f[o])) {
                        n = true;
                        break;
                    }
                }
                if (n) {
                    if (!c) {
                        for (let p = 0; p < this.ag.k.count; p++) {
                            this.b[0].i[0][p] = this.c[0][p].endCalculation();
                            this.b[0].i[0][p].summaryIndex = p;
                            this.b[0].i[0][p].groupKey = this.b[0].f;
                            this.c[0][p].beginCalculation(this.m, this.ag.k.item(p).propertyName);
                        }
                        this.b[0].h[0] = a.af;
                    }
                    this.b[0] = a;
                }
            }
        }
        bb() {
            let a = 0;
            let b = new Dictionary$2(String_$type, Number_$type, 0);
            for (let c = 0; c < this.ag.k.count; c++) {
                let d = this.ag.k.item(c).propertyName;
                if (!b.containsKey(d)) {
                    b.addItem(d, 1);
                }
                else {
                    b.item(d, b.item(d) + 1);
                }
                if (b.item(d) > a) {
                    a = b.item(d);
                }
            }
            return a;
        }
        be(a, b, c, d, e, f) {
            let g = 0;
            if (this.av) {
                if (this.m.sectionHeaderDisplayMode == 0) {
                    if (this.an(a, 0, c, d, e, f)) {
                        this.z.y();
                        g++;
                        if (b != null) {
                            let h = this.bn(b);
                            b.a[0] = h;
                            b.c[0] = this.al(h);
                            b.b[0] = (a.count - 1) - b.af;
                        }
                    }
                }
                else if (this.m.sectionHeaderDisplayMode == 1) {
                    for (let i = 0, j = 0; i < e.length; i++) {
                        let k = a.count + j;
                        if (this.an(a, i, c, d, [e[i]], f)) {
                            g++;
                            this.z.y();
                            if (b != null) {
                                let l = this.bo(b, i);
                                b.a[i] = l;
                                b.c[i] = this.al(l);
                                b.b[i] = k - b.af;
                                if (!b.c[i]) {
                                    break;
                                }
                            }
                            else if (!this.ar) {
                                break;
                            }
                            j++;
                        }
                    }
                }
            }
            return g;
        }
        bd(a, b, c, d, e) {
            let f = 0;
            if (this.av) {
                let g = this.a5._inner[b];
                if (this.m.sectionHeaderDisplayMode == 0) {
                    if (this.ao(b, 0, g, c, d, e)) {
                        this.z.y();
                        f++;
                        if (a != null) {
                            let h = this.bn(a);
                            a.a[0] = h;
                            a.c[0] = this.al(h);
                            a.b[0] = b - a.af;
                        }
                    }
                }
                else if (this.m.sectionHeaderDisplayMode == 1) {
                    for (let i = 0, j = 0; i < d.length; i++) {
                        let k = b + j;
                        if (this.ao(k, i, g, c, [d[i]], e)) {
                            f++;
                            this.z.y();
                            if (a != null) {
                                let l = this.bo(a, i);
                                a.a[i] = l;
                                a.c[i] = this.al(l);
                                a.b[i] = k - a.af;
                                if (!a.c[i]) {
                                    break;
                                }
                            }
                            else if (!this.ar) {
                                break;
                            }
                            j++;
                        }
                    }
                }
            }
            return f;
        }
        ao(a, b, c, d, e, f) {
            let g = new DataSourceSpecialRow();
            g.level = b;
            for (let h = 0; h < d.length; h++) {
                g.setValue(d[h], this.m.getItemProperty(c, d[h]));
                if (h < e.length) {
                    g.setSectionValue(e[h], this.m.getItemProperty(c, e[h]));
                }
            }
            g.rowType = 1;
            g.summaryResults = new Array(this.ag.k.count);
            if (f && this.a != null) {
                if (this.a[b] != null) {
                    if (this.a[b].l(g)) {
                        return false;
                    }
                    else {
                        this.a[b] = g;
                        for (let i = b + 1; i < this.a.length; i++) {
                            this.a[i] = null;
                        }
                    }
                }
                else {
                    this.a[b] = g;
                }
            }
            this.a5.insert1(a, g);
            return true;
        }
        an(a, b, c, d, e, f) {
            let g = new DataSourceSpecialRow();
            g.level = b;
            for (let h = 0; h < d.length; h++) {
                g.setValue(d[h], this.m.getItemProperty(c, d[h]));
                if (h < e.length) {
                    g.setSectionValue(e[h], this.m.getItemProperty(c, e[h]));
                }
            }
            g.rowType = 1;
            g.summaryResults = new Array(this.ag.k.count);
            if (f && this.a != null) {
                if (this.a[b] != null) {
                    if (this.a[b].l(g)) {
                        return false;
                    }
                    else {
                        this.a[b] = g;
                        for (let i = b + 1; i < this.a.length; i++) {
                            this.a[i] = null;
                        }
                    }
                }
                else {
                    this.a[b] = g;
                }
            }
            a.add1(g);
            return true;
        }
        bc(a, b, c, d) {
            let e = 0;
            if (this.au) {
                if (this.m.sectionHeaderDisplayMode == 0) {
                    this.bw(a, 0, b, c, d);
                    e++;
                }
                else if (this.m.sectionHeaderDisplayMode == 1) {
                    for (let f = d.length - 1; f >= 0; f--) {
                        if (this.z.t._inner[this.z.t.count - 1].c[f]) {
                            this.bw(a, f, b, c, [d[f]]);
                            a++;
                            e++;
                        }
                    }
                }
            }
            return e;
        }
        bw(a, b, c, d, e) {
            let f = new DataSourceSpecialRow();
            f.level = b;
            for (let g = 0; g < d.length; g++) {
                f.setValue(d[g], this.m.getItemProperty(c, d[g]));
                if (g < e.length) {
                    f.setSectionValue(e[g], this.m.getItemProperty(c, e[g]));
                }
            }
            f.rowType = 2;
            this.a5.insert1(a, f);
        }
        q(a, b, c) {
            let d = this.r(b, 0, c, 5);
            if (this.as) {
                a.ag = a.ag + 1;
            }
            else {
                a.ah = a.ah + 1;
            }
            a.ad += 1;
            this.z.ac(a, 1, 1);
            return d;
        }
        r(a, b, c, d) {
            let e = ((() => {
                let $ret = new DataSourceSpecialRow();
                $ret.level = b;
                $ret.rowType = d;
                $ret.summaryResults = c;
                return $ret;
            })());
            this.a5.insert1(a, e);
            return e;
        }
        bg(a, b, c) {
            let d = a.v();
            let e = a.af + a.ah + a.aa;
            if (this.av) {
                e += d;
            }
            this.bi(e, a.c.length, b);
            a.aa += 1;
            a.ad += 1;
            a.t += 1;
            if (c) {
                this.z.ac(a, 1, 1);
            }
            return e;
        }
        bh(a, b, c) {
            let d = a.v();
            if (this.av) {
                b += d;
            }
            this.bi(b, a.c.length, c);
            a.aa += 1;
            a.ad += 1;
            a.t += 1;
            this.z.ac(a, 1, 1);
            return b;
        }
        bi(a, b, c) {
            let d = new DataSourceSpecialRow();
            d.rowType = 3;
            d.targetRow = c;
            d.level = b;
            this.a5.insert1(a, d);
            return a + 1;
        }
        bj(a, b) {
            let c = -1;
            for (let d = 0; d < this.a4.count; d++) {
                if (this.p.i(b, this.a4._inner[d]) == 0) {
                    c = d;
                    break;
                }
            }
            return this.bk(a, b, c);
        }
        bk(a, b, c) {
            let d = -1;
            if (c != -1) {
                let e = a.af;
                let f = e + a.aa;
                let g = false;
                for (let h = e; h < f; h++) {
                    let i = this.av ? h + 1 : h;
                    let j = typeCast(DataSourceSpecialRow.$, this.a5._inner[i]);
                    if (j.targetRow != null) {
                        if (this.a1 != null) {
                            let k = this.a1.compare(b, j.targetRow);
                            if (k == 0 || k < 0) {
                                d = this.bh(a, h, b);
                                g = true;
                                break;
                            }
                        }
                        else {
                            let l = -1;
                            for (let m = 0; m < this.a4.count; m++) {
                                if (this.p.i(j.targetRow, this.a4._inner[m]) == 0) {
                                    l = m;
                                    break;
                                }
                            }
                            if (l > c) {
                                d = this.bh(a, h, b);
                                g = true;
                                break;
                            }
                        }
                    }
                }
                if (!g) {
                    d = this.bg(a, b, true);
                    g = true;
                }
            }
            return d;
        }
        bx(a) {
            let b = SectionData.r(a);
            this.a8 = b.count;
            for (let c = 0; c < b.count; c++) {
                let d = new Array(b._inner[c].count);
                b._inner[c].values.copyTo(d, 0);
                this.r(this.a5.count, 0, d, 4);
            }
        }
        by() {
            if (this.l == 0 || this.l == 2) {
                for (let a = 0; a < this.z.t.count; a++) {
                    let b = this.z.t._inner[a];
                    if (!b.q) {
                        continue;
                    }
                    if (this.ax && this.am) {
                        if (this.as) {
                            this.bz(b, false);
                        }
                        else {
                            this.b0(b, false);
                        }
                    }
                    else {
                        for (let c = 0; c < b.i.length; c++) {
                            let d = this.a5._inner[b.af + b.b[c]];
                            if (d != null) {
                                d.summaryResults = b.i[c];
                            }
                            if (!b.c[c]) {
                                break;
                            }
                        }
                    }
                }
            }
        }
        b0(a, b) {
            let c = 0;
            let d = this.bm(a, !this.as);
            for (let e = 0; e < a.i.length; e++) {
                if (a.a[e] == null || !a.c[e]) {
                    continue;
                }
                let f = SectionData.r(a.i[e]);
                if (this.av) {
                    c += 1;
                }
                a.g[e] = new SummaryGroup();
                a.g[e].a = new Array(this.a9);
                for (let g = 0; g < f.count; g++) {
                    let h = new Array(f._inner[g].count);
                    f._inner[g].values.copyTo(h, 0);
                    let i = a.af + c + g;
                    let j = this.r(i, e + 1, h, 5);
                    a.ak(j, g);
                    for (let k = e + 1; k < a.b.length; k++) {
                        a.b[k]++;
                    }
                    a.ad += 1;
                    a.ah += 1;
                    this.z.ad(a, 1, 1);
                    if (d != null) {
                        let l = this.f();
                        for (let m = 0; m < l.length; m++) {
                            j.setValue(l[m], this.m.getItemProperty(d, l[m]));
                        }
                    }
                    if (b && this.ab != null) {
                        this.ab.notifyInsertItem(i, j);
                    }
                }
                c += f.count;
            }
        }
        bf(a, b, c) {
            let d = a.h[b];
            let e = SectionData.r(a.i[b]);
            for (let f = 0; f < e.count; f++) {
                let g = new Array(e._inner[f].count);
                e._inner[f].values.copyTo(g, 0);
                let h = this.z.e(d - 1);
                let i = this.r(d + f, b + 1, g, 5);
                a.ak(i, f);
                h.ad = h.ad + 1;
                h.ag = h.ag + 1;
                this.z.ac(h, 1, 1);
                let j = null;
                let k = 0;
                for (let l = d + f - 1; l >= 0; l--) {
                    let m = this.m.getRowType(l);
                    if (m == 0 || m == 1) {
                        j = this.a5._inner[l];
                        k = m;
                        break;
                    }
                }
                if (j != null) {
                    let n = this.f();
                    if (k == 1) {
                        let o = typeCast(DataSourceSpecialRow.$, j);
                        for (let p = 0; p < n.length; p++) {
                            i.setValue(n[p], o.getValue(n[p]));
                        }
                    }
                    else {
                        for (let q = 0; q < n.length; q++) {
                            i.setValue(n[q], this.m.getItemProperty(j, n[q]));
                        }
                    }
                }
                if (c && this.ab != null) {
                    this.ab.notifyInsertItem(d + f, i);
                }
            }
            return e.count;
        }
        bz(a, b) {
            for (let c = 0; c < a.i.length; c++) {
                if (!a.c[c]) {
                    break;
                }
                if (a.h[c] == -1) {
                    continue;
                }
                a.g[c] = new SummaryGroup();
                a.g[c].a = new Array(this.a9);
                let d = this.bf(a, c, b);
            }
        }
        f() {
            let a = new Array(this.ae.k.count + this.af.k.count);
            let b = 0;
            for (let c = 0; c < this.ae.k.count; c++) {
                a[b] = this.ae.k.item(c).propertyName;
                b++;
            }
            for (let d = 0; d < this.af.k.count; d++) {
                a[b] = this.af.k.item(d).propertyName;
                b++;
            }
            return a;
        }
        g() {
            let a = new Array(this.ae.k.count);
            let b = 0;
            for (let c = 0; c < this.ae.k.count; c++) {
                a[b] = this.ae.k.item(c).propertyName;
                b++;
            }
            return a;
        }
        bu(a, b, c) {
            this.z.x(a);
        }
        x(a, b, c) {
            return this.z.i(a, this.m, b, c, this.m.sectionHeaderDisplayMode, this.ar);
        }
        cc(a) {
            this.a4 = new List$1(Array_$type, 0);
            for (let b = 0; b < a.count; b++) {
                this.a4.add(a._inner[b]);
            }
        }
        b3() {
            this.a5.clear();
            if (this.ab != null) {
                this.ab.notifyClearItems();
            }
        }
        notifySetItem(a, b, c) {
            if (this.a1 != null) {
                this.b9(b);
                this.bp(c);
            }
            else {
                this.ca(a, b);
                this.bq(a, c);
            }
        }
        bq(a, b) {
            if (!this.ay(b)) {
                return;
            }
            let c = this.ba(a);
            this.b4(c, b);
        }
        b4(a, b) {
            this.b1(a, b);
            this.cf(a, b);
            this.ck(a, b);
        }
        b1(a, b) {
            if (this.ah) {
                let c = this.z.e(a);
                if (c == null) {
                    c = this.z.d();
                }
                let d = c.v();
                let e = true;
                if (a >= c.af && a <= c.af + (d - 1) + c.ah + c.aa) {
                    if (!this.ai(c, b, this.a5._inner[c.af])) {
                        c = this.z.e(c.af - 1);
                        if (c == null) {
                            c = this.z.c();
                            c.af += 1;
                        }
                        e = false;
                    }
                    else {
                        a = c.af + d + c.ah + c.aa;
                    }
                }
                if (e && !c.p) {
                    return;
                }
                c.ad += 1;
                this.z.ac(c, 1, 0);
                if (this.ai(c, b, this.a5._inner[c.af])) {
                    if (!c.p) {
                        c.ad -= 1;
                        this.z.ac(c, -1, 0);
                        return;
                    }
                    if (a >= c.ad - c.u - c.ag && a <= c.ad) {
                        a = c.ad - c.u - c.ag;
                    }
                }
            }
            this.a5.insert1(a, b);
            if (this.ab != null) {
                this.ab.notifyInsertItem(a, b);
            }
        }
        cf(a, b) {
            let c = null;
            if (this.ah) {
                c = this.z.e(a);
            }
            else {
                c = this.z.t._inner[0];
            }
            if (c == null) {
                if (this.ah && a == 0) {
                    c = this.z.c();
                }
                else {
                    c = this.z.d();
                }
            }
            if (this.ai(c, b, this.a5._inner[c.af])) {
                this.z.z(c, 1);
                if (this.aw && c.p) {
                    let d = this.bj(c, b);
                    if (d != -1 && this.ab != null) {
                        this.ab.notifyInsertItem(d, this.a5._inner[d]);
                    }
                }
            }
            else {
                let e = this.z.e(a - 1);
                if (e != null && this.ai(e, b, this.a5._inner[e.af])) {
                    this.z.z(e, 1);
                    if (this.aw && e.p) {
                        let f = this.bj(e, b);
                        if (f != -1 && this.ab != null) {
                            this.ab.notifyInsertItem(f, this.a5._inner[f]);
                        }
                    }
                }
                else {
                    let g = false;
                    if (a <= c.af) {
                        g = true;
                    }
                    let h = 0;
                    let i = null;
                    let j = null;
                    let k = this.f();
                    let l = this.g();
                    let m = this.z.b(this.m, b, l, this.j, this.ar);
                    m.af = a;
                    m.ad = a;
                    m.ae = g ? c.ae : c.ae + 1;
                    if (this.j == 1) {
                        this.z.af(m, g);
                        for (let n = 0; n < c.f.length; n++) {
                            if (Base.equalsStatic(c.f[n], m.f[n]) && !c.c[n]) {
                                this.z.z(c, 1);
                                return;
                            }
                        }
                    }
                    this.z.aa(m.ae, m);
                    if (this.av) {
                        let o = this.bd(m, a, k, l, false);
                        m.ad += o;
                        h += o;
                        i = this.a5._inner[a];
                        if (!g) {
                            c.ad -= 1;
                        }
                    }
                    if (m.p) {
                        if (this.aw) {
                            for (let p = 0; p < this.a4.count; p++) {
                                if (this.p.i(b, this.a4._inner[p]) == 0) {
                                    this.bg(m, b, false);
                                    h++;
                                    break;
                                }
                            }
                        }
                    }
                    else {
                        this.a5.removeAt(a + h);
                        m.ad -= 1;
                        h--;
                    }
                    if (this.au) {
                        let q = this.bc(a + (h - 1), b, k, l);
                        if (q > 1) {
                            m.ad += q;
                        }
                        h += q;
                        j = this.a5._inner[a + (h - 1)];
                    }
                    this.z.ad(m, h, h);
                    if (this.j == 1) {
                        this.b8(m);
                    }
                    else {
                        if (m.a[0] != null && m.h[0] == -1) {
                            m.h[0] = m.ad + 1;
                        }
                    }
                    if (m.p) {
                        this.z.z(m, 1);
                    }
                    if (this.ab != null) {
                        if (i != null) {
                            this.ab.notifyInsertItem(a, i);
                        }
                        if (j != null) {
                            this.ab.notifyInsertItem(a + (h - 1), j);
                        }
                    }
                }
            }
        }
        cn(a) {
            let b = this.a5.indexOf1(a);
            if (b >= 0) {
                let c = this.a5._inner[b - 1];
                let d = typeCast(DataSourceSpecialRow.$, c);
                let e = this.f();
                for (let f = 0; f < e.length; f++) {
                    if (d == null) {
                        a.setValue(e[f], this.m.getItemProperty(c, e[f]));
                    }
                    else {
                        a.setValue(e[f], d.getValue(e[f]));
                    }
                }
            }
        }
        b8(a) {
            let b = false;
            let c = false;
            if (a.ae > 0) {
                let d = this.z.t._inner[a.ae - 1];
                let e = 0;
                for (let f = 0, g = 0; f < a.e.length;) {
                    if (!b && Base.equalsStatic(d.f[f], a.f[f])) {
                        this.a5.removeAt(a.af + g);
                        a.ad -= 1;
                        this.z.ac(a, -1, -1);
                        if (this.am && (this.l == 2 || this.l == 0)) {
                            for (let h = 0; h < this.a9; h++) {
                                let i = typeCast(DataSourceSpecialRow.$, this.a5._inner[a.af - 1]);
                                if (i != null && i.rowType == 5 && i.level == f + 1) {
                                    this.a5.removeAt(a.af - 1);
                                    d.ad -= 1;
                                    this.z.ac(d, -1, -1);
                                    this.a5.insert1(a.ad + 1, i);
                                    e++;
                                    this.cn(i);
                                }
                            }
                        }
                        a.a[f] = null;
                        a.b[f] = 0;
                        a.c[f] = true;
                        if (d.a[f] != null) {
                            a.z = d.ae;
                        }
                        g--;
                        c = true;
                    }
                    else {
                        b = true;
                        a.b[f] = g;
                        if (e > 0) {
                            a.ad += e;
                            this.z.ac(a, e, e);
                            a.h[f] = a.ad - (e - 1);
                        }
                        else {
                            a.h[f] = a.ad + 1;
                        }
                    }
                    f++;
                    g++;
                }
                if (a.z == -1 && c) {
                    a.z = d.z;
                }
            }
            if (a.ae < this.z.t.count - 1) {
                b = false;
                c = false;
                let j = this.z.t._inner[a.ae + 1];
                for (let k = 0, l = 0; k < a.e.length; k++, l++) {
                    if (!b && Base.equalsStatic(j.f[k], a.f[k])) {
                        if (j.a[k] != null) {
                            this.a5.removeAt(j.af + l);
                            j.ad -= 1;
                            this.z.ac(j, -1, -1);
                            a.al(k, -1);
                            a.i[k] = j.i[k];
                            a.d[k] = j.d[k];
                            if (this.am && (this.l == 2 || this.l == 0)) {
                                let m = j.g[k].a[0];
                                let n = this.a5.indexOf1(m);
                                a.h[k] = n;
                                let o = this.z.e(n);
                                let p = j.g[k].a.length;
                                for (let q = 0; q < p; q++) {
                                    j.g[k].a[q] = null;
                                    this.a5.removeAt(n);
                                    o.ad -= 1;
                                    if (this.as) {
                                        o.ag -= 1;
                                    }
                                    else {
                                        o.ah -= 1;
                                    }
                                }
                                this.z.ac(o, -p, -p);
                                a.al(k, -p);
                            }
                            j.h[k] = -1;
                            j.d[k] = 0;
                            j.i[k] = null;
                            j.g[k] = null;
                            j.a[k] = null;
                            j.b[k] = 0;
                            j.c[k] = true;
                            c = true;
                        }
                        l--;
                    }
                    else {
                        b = true;
                        j.b[k] = l;
                        if (a.a[k] != null && a.h[k] == -1) {
                            a.h[k] = a.ad + 1;
                        }
                    }
                }
            }
        }
        ai(a, b, c) {
            if (this.ae.k.count == 0) {
                return true;
            }
            if (this.a2.compare(b, c) == 0) {
                return true;
            }
            return false;
        }
        h(a, b) {
            let c = new Array(a.length);
            for (let d = 0; d < c.length; d++) {
                c[d] = this.m.getItemProperty(b, a[d]);
            }
            return c;
        }
        at(a, b) {
            if (a == null && b == null) {
                return true;
            }
            if (a == null && b != null) {
                return false;
            }
            if (a != null && b == null) {
                return false;
            }
            return Base.equalsStatic(a, b);
        }
        ba(a) {
            if (this.ae.k.count == 0 && this.a4.count == 0 && this.s == null && this.n.actualCount == this.a5.count) {
                return a;
            }
            let b = 0;
            let c = 0;
            let d = this.a5.count;
            while (b < a && c < d) {
                while (c < d) {
                    let e = this.a5._inner[c];
                    let f = false;
                    let viewItem_ = e;
                    if ((viewItem_.$$isSpecialRow !== undefined)) {
                        f = true;
                    }
                    if (!f) {
                        break;
                    }
                    c++;
                }
                let g = this.n.getItemAtIndex(b);
                if (this.at(g, this.a5._inner[c])) {
                    c++;
                    b++;
                }
                else {
                    b++;
                }
            }
            return c;
        }
        ca(a, b) {
            let c = this.ba(a);
            if (c < this.a5.count) {
                if (this.at(b, this.a5._inner[c])) {
                    this.b5(c, b);
                }
            }
        }
        b5(a, b) {
            this.a5.removeAt(a);
            if (this.ab != null) {
                this.ab.notifyRemoveItem(a, b);
            }
            let c = this.y(a, b);
            this.cl(a, b, c);
        }
        y(a, b) {
            let c = null;
            if (this.ah) {
                c = this.z.e(a);
            }
            else {
                c = this.z.t._inner[0];
            }
            if (c != null) {
                this.z.z(c, -1);
                if (c.p) {
                    c.ad -= 1;
                    this.z.ac(c, -1, 0);
                    if (this.aw) {
                        for (let d = 0; d < c.aa; d++) {
                            let e = 0;
                            if (this.av) {
                                e = 1;
                            }
                            e += c.ah;
                            let f = this.a5._inner[c.af + d + e];
                            let g = null;
                            let item_ = f;
                            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                                g = f;
                            }
                            if (g != null) {
                                if (g.targetRow == b) {
                                    this.a5.removeAt(c.af + d + e);
                                    c.ad -= 1;
                                    c.aa -= 1;
                                    c.t -= 1;
                                    this.z.ac(c, -1, -1);
                                    if (this.ab != null) {
                                        this.ab.notifyRemoveItem(c.af + d + e, g);
                                    }
                                }
                            }
                        }
                    }
                }
                if (this.ah && !c.m() && this.aj(c)) {
                    let h = 0;
                    if (this.z.p(c)) {
                        let i = c.w();
                        let j = i;
                        let k = this.ae.k.count;
                        let l = this.g();
                        let m = this.z.t._inner[c.ae + 1];
                        for (let n = 0; n < c.f.length; n++) {
                            if (!Base.equalsStatic(c.f[n], m.f[n])) {
                                j = n;
                                break;
                            }
                        }
                        if (this.av) {
                            if (c.c[j - 1]) {
                                for (let o = j; o < k; o++) {
                                    if (c.g[o] != null) {
                                        for (let p = 0; p < c.g[o].a.length; p++) {
                                            let q = c.g[o].a[p];
                                            if (q != null) {
                                                let r = this.a5.indexOf1(q);
                                                if (r >= 0) {
                                                    this.a5.removeAt(r);
                                                    c.ad -= 1;
                                                    h++;
                                                    if (this.ab != null) {
                                                        this.ab.notifyRemoveItem(r, q);
                                                    }
                                                    if (!this.as) {
                                                        for (let s = o + 1; s < c.b.length; s++) {
                                                            c.b[s]--;
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    let t = c.af + c.b[o];
                                    let u = typeCast(DataSourceSpecialRow.$, this.a5._inner[t]);
                                    if (u != null && u.rowType == 1) {
                                        c.a[o] = null;
                                        this.a5.removeAt(t);
                                        c.ad -= 1;
                                        h++;
                                        if (this.ab != null) {
                                            this.ab.notifyRemoveItem(t, u);
                                        }
                                        for (let v = o + 1; v < c.b.length; v++) {
                                            c.b[v]--;
                                        }
                                    }
                                    if (!c.c[o]) {
                                        break;
                                    }
                                }
                            }
                        }
                        c.k = m;
                        for (let w = 0; w < j; w++) {
                            if (this.am && !this.as && (this.l == 2 || this.l == 0)) {
                                m.af -= (this.av ? this.a9 + 1 : this.a9);
                            }
                            else if (this.av) {
                                m.af -= 1;
                            }
                        }
                        m.d[i] = c.d[i];
                        m.a[i] = c.a[i];
                        m.c[i] = c.c[i];
                        m.z = c.z;
                        for (let x = i; x < k; x++) {
                            m.g[x] = c.g[x];
                        }
                        m.b[i] = c.b[i];
                        for (let y = i, z = c.b[i]; y < k; y++) {
                            m.b[y] = z;
                            if (this.av) {
                                z++;
                            }
                            if (!this.as) {
                                if (m.g[y] != null) {
                                    z += m.g[y].a.length;
                                }
                            }
                            let aa = m.af - h + m.b[y];
                            let ab = typeCast(DataSourceSpecialRow.$, this.a5._inner[aa]);
                            if (ab != null && ab.rowType == 1) {
                                for (let ac = 0; ac < m.f.length; ac++) {
                                    ab.setValue(m.e[ac], m.f[ac]);
                                }
                            }
                        }
                    }
                    else {
                        if (this.av) {
                            for (let ad = c.af; ad <= c.ad; ad++) {
                                let ae = typeCast(DataSourceSpecialRow.$, this.a5._inner[ad]);
                                if (ae != null && ae.rowType == 1) {
                                    this.a5.removeAt(ad);
                                    c.ad -= 1;
                                    h++;
                                    ad--;
                                    if (this.ab != null) {
                                        this.ab.notifyRemoveItem(ad, ae);
                                    }
                                }
                            }
                        }
                        for (let af = 0; af < c.g.length; af++) {
                            if (c.g[af] == null) {
                                continue;
                            }
                            for (let ag = 0; ag < c.g[af].a.length; ag++) {
                                let ah = c.g[af].a[ag];
                                if (ah != null) {
                                    let ai = this.a5.indexOf1(ah);
                                    this.a5.removeAt(ai);
                                    c.ad -= 1;
                                    h++;
                                    if (this.ab != null) {
                                        this.ab.notifyRemoveItem(ai, ah);
                                    }
                                }
                            }
                        }
                        if (c.z >= 0) {
                            let aj = c.ad - c.af + 1;
                            if (aj > 0) {
                                let ak = this.a5._inner[c.af - 1];
                                let al = typeCast(DataSourceSpecialRow.$, ak);
                                let am = this.f();
                                for (let an = 0; an < aj; an++) {
                                    let ao = c.af + an;
                                    let ap = typeCast(DataSourceSpecialRow.$, this.a5._inner[ao]);
                                    if (ap != null) {
                                        for (let aq = 0; aq < am.length; aq++) {
                                            if (al == null) {
                                                ap.setValue(am[aq], this.m.getItemProperty(ak, am[aq]));
                                            }
                                            else {
                                                ap.setValue(am[aq], al.getValue(am[aq]));
                                            }
                                        }
                                    }
                                }
                                let ar = this.z.t._inner[c.ae - 1];
                                ar.ad += aj;
                            }
                        }
                    }
                    if (this.au) {
                        for (let as = 0; as < c.a.length; as++) {
                            if (!c.c[as]) {
                                break;
                            }
                            if (c.a[as] != null) {
                                let at = this.a5._inner[c.ad];
                                this.a5.removeAt(c.ad);
                                if (this.ab != null) {
                                    this.ab.notifyRemoveItem(c.ad, at);
                                }
                                h++;
                                c.ad -= 1;
                            }
                        }
                    }
                    this.z.ae(c.ae);
                    this.z.ab(c, -h, -h);
                    c.o = true;
                }
            }
            return c;
        }
        aj(a) {
            for (let b = a.af; b <= a.ad; b++) {
                if (this.m.getRowType(b) == 0) {
                    return false;
                }
            }
            return true;
        }
        bp(a) {
            if (this.ay(a)) {
                let b = this.a5.g(a, this.a1);
                if (b < 0) {
                    b = ~b;
                }
                this.b4(b, a);
            }
        }
        b6(a) {
            this.a4.add(a);
            let b = this.m.indexOfKey(a);
            let c = this.m.getItemAtIndex(b);
            if (b == -1) {
                return;
            }
            if (this.aw) {
                let d = this.z.e(b);
                let e = this.bj(d, this.a5._inner[b]);
                if (this.ab != null) {
                    this.ab.notifyInsertItem(e, this.a5._inner[e]);
                }
            }
        }
        cd(a) {
            if (this.a4.remove(a)) {
                let b = this.m.indexOfKey(a);
                let c = this.m.getItemAtIndex(b);
                if (b == -1) {
                    return;
                }
                let d = this.z.e(b);
                let e = d.af;
                if (this.av) {
                    e += d.v();
                }
                if (this.aw) {
                    let f = this.u(e, this.a5._inner[b], d.aa, this.f());
                    if (f != null) {
                        d.ad -= 1;
                        d.aa -= 1;
                        d.t -= 1;
                        this.z.ac(d, -1, -1);
                        if (this.ab != null) {
                            this.ab.notifyRemoveItem(f.a, f.item);
                        }
                    }
                }
            }
        }
        u(a, b, c, d) {
            for (let e = a + (c - 1); e >= a; e--) {
                if (typeCast(DataSourceSpecialRow.$, this.a5._inner[e]) !== null) {
                    let f = this.a5._inner[e];
                    if (f.rowType == 3) {
                        let g = f.targetRow;
                        if (g == b) {
                            this.a5.removeAt(e);
                            return ((() => {
                                let $ret = new RemovedShiftedRowInfo();
                                $ret.item = f;
                                $ret.a = e;
                                return $ret;
                            })());
                        }
                    }
                }
            }
            return null;
        }
        b9(a) {
            if (!this.ay(a)) {
                return;
            }
            let b = this.a5.g(a, this.a1);
            if (b < 0) {
                b = ~b;
            }
            if (b >= 0) {
                let c = this.a5.count;
                let d = 0;
                let e = false;
                while (d <= c) {
                    let f = b - d;
                    let g = b + d;
                    if (f < 0 && g > c - 1) {
                        break;
                    }
                    if (f >= 0 && f < c) {
                        if (this.a5._inner[f] != null && Base.equalsStatic(this.a5._inner[f], a)) {
                            b = f;
                            e = true;
                            break;
                        }
                    }
                    if (g < c) {
                        if (this.a5._inner[g] != null && Base.equalsStatic(this.a5._inner[g], a)) {
                            b = g;
                            e = true;
                            break;
                        }
                    }
                    d++;
                }
                if (b < 0 || b > c - 1) {
                    return;
                }
                if (e) {
                    let h = this.a5._inner[b];
                    if (h == null && a == null) {
                        this.a5.removeAt(b);
                        this.aa.notifyRemoveItem(b, a);
                        let i = this.y(b, a);
                        this.cj(b, a, false, i);
                        return;
                    }
                    if (h == null) {
                        return;
                    }
                    if (Base.equalsStatic(h, a)) {
                        this.a5.removeAt(b);
                        this.aa.notifyRemoveItem(b, a);
                        let j = this.y(b, a);
                        this.cj(b, a, false, j);
                    }
                }
                else {
                    if (b - 1 >= 0) {
                        let k = this.z.e(b - 1);
                        if (k != null && !k.p) {
                            b = b - 1;
                        }
                    }
                    this.y(b, a);
                }
            }
            else {
                let l = this.a5.count;
                for (let m = 0; m < l; m++) {
                    let n = this.a5._inner[m];
                    if (n == null && a == null) {
                        this.a5.removeAt(m);
                        break;
                    }
                    if (n == null) {
                        continue;
                    }
                    if (Base.equalsStatic(n, a)) {
                        this.a5.removeAt(m);
                        this.aa.notifyRemoveItem(m, a);
                        let o = this.y(m, a);
                        this.cl(m, a, o);
                        break;
                    }
                }
            }
        }
        ay(a) {
            if (this.s == null) {
                return true;
            }
            return this.s(a);
        }
        notifyClearItems() {
        }
        notifyInsertItem(a, b) {
            if (this.a1 != null) {
                this.bp(b);
            }
            else {
                this.bq(a, b);
            }
        }
        notifyRemoveItem(a, b) {
            if (this.a1 != null) {
                this.b9(b);
            }
            else {
                this.ca(a, b);
            }
        }
        cb(a, b) {
            let c = this.z.e(a);
            if (c == null) {
                c = this.z.d();
            }
            for (let d = 0, e = 0; d < c.a.length; d++) {
                if (c.a[d] != null) {
                    if (a == c.af + c.b[d]) {
                        let f = c.a[d];
                        if (this.az.containsKey(f)) {
                            if (this.az.item(f) != b) {
                                let g = this.az.item(f);
                                if (b == this.ar) {
                                    this.az.removeItem(f);
                                }
                                else {
                                    this.az.item(f, b);
                                }
                                this.m.queueAutoRefresh();
                                if (this.ad != null) {
                                    this.ad.notifyRowExpansionChanged(a, g, b);
                                }
                            }
                        }
                        else if (b != this.ar) {
                            this.az.addItem(f, b);
                            this.m.queueAutoRefresh();
                            if (this.ad != null) {
                                this.ad.notifyRowExpansionChanged(a, this.ar, b);
                            }
                        }
                    }
                    e++;
                }
            }
        }
        ak(a) {
            let b = this.z.e(a);
            if (b == null) {
                b = this.z.d();
            }
            for (let c = 0, d = 0; c < b.a.length; c++) {
                if (b.a[c] != null) {
                    if (a == b.af + b.b[c]) {
                        return b.c[c];
                    }
                    d++;
                }
            }
            return true;
        }
        al(a) {
            if (!this.aq) {
                return true;
            }
            return this.az.containsKey(a) ? this.az.item(a) : this.ar;
        }
        bn(a) {
            let b = "";
            for (let c = 0; c < a.e.length; c++) {
                let d = a.e[c];
                let e = a.f[c] != null ? a.f[c].toString() : "";
                b += d + ":" + e;
            }
            return b;
        }
        bo(a, b) {
            if (this.m.sectionHeaderDisplayMode == 0) {
                return this.bn(a);
            }
            let c = "";
            for (let d = 0; d < b + 1; d++) {
                let e = a.e[d];
                let f = a.f[d] != null ? a.f[d].toString() : "";
                c += e + ":" + f + ":";
            }
            return c;
        }
        bs(a) {
            if (this.l == 3 || (a != null && this.l == 1) || (a == null && this.l == 2)) {
                return;
            }
            if (a == null && (this.e == null || this.e.length != this.ag.k.count)) {
                this.e = new Array(this.ag.k.count);
            }
            if (a != null) {
                let b = a.v();
                for (let c = b - 1; c >= 0; c--) {
                    for (let d = 0; d < this.ag.k.count; d++) {
                        let e = this.ag.k.item(d);
                        this.c[c][d].beginCalculation(this.m, e.propertyName);
                    }
                }
            }
            else {
                if (this.d == null || this.d.length != this.ag.k.count) {
                    this.d = new Array(this.ag.k.count);
                }
                for (let f = 0; f < this.ag.k.count; f++) {
                    let g = this.ag.k.item(f);
                    if (this.d[f] == null || this.d[f].operand != g.operand) {
                        this.d[f] = g.f();
                    }
                    this.d[f].beginCalculation(this.m, g.propertyName);
                }
            }
        }
        bv(a) {
            if (this.l == 3 || (a != null && this.l == 1) || (a == null && this.l == 2)) {
                return;
            }
            if (a != null) {
                let b = a.v();
                for (let c = b - 1; c >= 0; c--) {
                    let d = this.a5._inner[a.af + c];
                    for (let e = 0; e < this.ag.k.count; e++) {
                        let f = this.ag.k.item(e);
                        let g = this.c[c][e].endCalculation();
                        g.summaryIndex = e;
                        g.groupKey = a.f;
                        if (d != null) {
                            d.summaryResults[c] = g;
                        }
                    }
                }
            }
            else {
                for (let h = 0; h < this.ag.k.count; h++) {
                    let i = this.d[h].endCalculation();
                    i.summaryIndex = h;
                    this.e[h] = i;
                }
            }
        }
        br(a, b) {
            if (this.l == 3 || (a != null && this.l == 1) || (a == null && this.l == 2)) {
                return;
            }
            if (b != null) {
                if (a != null) {
                    for (let c = 0; c < this.c.length; c++) {
                        if (this.c[c] != null) {
                            for (let d = 0; d < this.c[c].length; d++) {
                                if (this.c[c][d] != null) {
                                    this.c[c][d].aggregate(b);
                                }
                            }
                        }
                    }
                }
                else {
                    for (let e = 0; e < this.ag.k.count; e++) {
                        this.d[e].aggregate(b);
                    }
                }
            }
        }
        ch(a, b, c, d, e) {
            if (this.j == 0) {
                d = 0;
            }
            let f = a.i[d][e];
            let g = b.itemAdded(c, f, a.d[d]);
            a.an(d, e, g);
            if (this.av) {
                if (a.a[d] != null) {
                    let h = typeCast(DataSourceSpecialRow.$, this.a5._inner[a.af + a.b[d]]);
                    if (h != null) {
                        h.summaryResults[e] = a.i[d][e];
                    }
                }
            }
        }
        cg(a, b, c, d, e, f) {
            if (this.j == 0) {
                d = 0;
            }
            let g = a.i[d][e];
            let h = a.d[d];
            let i = f ? b.itemAdded(c, g, h) : b.itemRemoved(c, g, h);
            a.an(d, e, i);
            if (this.av) {
                if (!a.o && a.a[d] != null) {
                    let j = typeCast(DataSourceSpecialRow.$, this.a5._inner[a.af + a.b[d]]);
                    if (j != null) {
                        j.summaryResults[e] = a.i[d][e];
                    }
                }
            }
        }
        cj(a, b, c, d) {
            if (this.ag.k.count == 0) {
                return;
            }
            if (d == null) {
                d = this.w(a);
                if (d == null) {
                    d = this.z.d();
                }
            }
            let e = false;
            let f = false;
            let g = false;
            for (let h = 0; h < this.ag.k.count; h++) {
                let i = this.ag.k.item(h);
                if (this.l == 0 || this.l == 1) {
                    let j = null;
                    if (c) {
                        j = this.d[h].itemAdded(b, this.e[h], this.n.actualCount);
                    }
                    else {
                        j = this.d[h].itemRemoved(b, this.e[h], this.n.actualCount);
                    }
                    j.summaryIndex = h;
                    this.e[h] = j;
                    if (this.d[h].isSummaryDirty) {
                        e = true;
                    }
                    else {
                        f = true;
                    }
                }
                if (this.l == 0 || this.l == 2) {
                    if (d != null && d.i != null) {
                        let k = i.f();
                        k.dataSource = this.m;
                        k.propertyName = i.propertyName;
                        k.propertyType = this.m.resolveSchemaPropertyType(i.propertyName);
                        let l = this.g();
                        let m = d.w();
                        for (let n = m; n < l.length; n++) {
                            this.cg(d, k, b, n, h, c);
                            if (k.isSummaryDirty) {
                                e = true;
                            }
                            g = true;
                        }
                        let o = d.z;
                        while (o != -1) {
                            let p = this.z.t._inner[o];
                            let q = p.w();
                            for (let r = q; r < m; r++) {
                                this.cg(p, k, b, r, h, c);
                                if (k.isSummaryDirty) {
                                    e = true;
                                }
                            }
                            o = p.z;
                            m = m - 1;
                        }
                    }
                }
            }
            if (e) {
                this.m.queueAutoRefresh();
            }
            else {
                if (f) {
                    let s = SectionData.r(this.e);
                    this.ce(s);
                }
                if (g) {
                    this.ci(d, null);
                    let t = d.z;
                    while (t != -1) {
                        let u = this.z.t._inner[t];
                        this.ci(u, null);
                        t = u.z;
                    }
                }
            }
        }
        cm(a, b, c, d, e) {
            let f = a;
            let g = this.ag.k.item(a);
            if (g == null) {
                return;
            }
            if (e == null) {
                e = this.w(b);
                if (e == null) {
                    e = this.z.d();
                }
            }
            let h = false;
            let i = false;
            let j = false;
            if (this.l == 0 || this.l == 1) {
                let k = null;
                if (d) {
                    k = this.d[f].itemAdded(c, this.e[f], this.n.actualCount);
                }
                else {
                    k = this.d[f].itemRemoved(c, this.e[f], this.n.actualCount);
                }
                k.summaryIndex = f;
                this.e[f] = k;
                if (this.d[f].isSummaryDirty) {
                    h = true;
                }
                else {
                    i = true;
                }
            }
            if (this.l == 0 || this.l == 2) {
                if (e != null && e.i != null) {
                    let l = g.f();
                    l.dataSource = this.m;
                    l.propertyName = g.propertyName;
                    l.propertyType = this.m.resolveSchemaPropertyType(g.propertyName);
                    let m = this.g();
                    let n = e.w();
                    for (let o = n; o < m.length; o++) {
                        this.cg(e, l, c, o, f, d);
                        if (l.isSummaryDirty) {
                            h = true;
                        }
                        j = true;
                    }
                    let p = e.z;
                    while (p != -1) {
                        let q = this.z.t._inner[p];
                        let r = q.w();
                        for (let s = r; s < n; s++) {
                            this.cg(q, l, c, s, f, d);
                            if (l.isSummaryDirty) {
                                h = true;
                            }
                        }
                        p = q.z;
                        n = n - 1;
                    }
                }
            }
            if (h) {
                this.m.queueAutoRefresh();
            }
            else {
                if (i) {
                    let t = SectionData.r(this.e);
                    this.ce(t);
                }
                if (j) {
                    this.ci(e, null);
                    let u = e.z;
                    while (u != -1) {
                        let v = this.z.t._inner[u];
                        this.ci(v, null);
                        u = v.z;
                    }
                }
            }
        }
        ck(a, b) {
            if (this.ag.k.count == 0) {
                return;
            }
            let c = this.w(a);
            if (c == null) {
                c = this.z.d();
            }
            let d = null;
            if (c != null) {
                d = typeCast(DataSourceSpecialRow.$, this.a5._inner[c.af]);
            }
            let e = false;
            let f = false;
            let g = false;
            for (let h = 0; h < this.ag.k.count; h++) {
                let i = this.ag.k.item(h);
                if (this.l == 0 || this.l == 1) {
                    let j = this.d[h].itemAdded(b, this.e[h], this.n.actualCount);
                    j.summaryIndex = h;
                    this.e[h] = j;
                    if (this.d[h].isSummaryDirty) {
                        e = true;
                    }
                    else {
                        f = true;
                    }
                }
                if (this.l == 0 || this.l == 2) {
                    if (c != null && c.i != null) {
                        let k = i.f();
                        k.dataSource = this.m;
                        k.propertyName = i.propertyName;
                        k.propertyType = this.m.resolveSchemaPropertyType(i.propertyName);
                        let l = this.g();
                        let m = c.w();
                        if (this.j == 1) {
                            for (let n = m; n < l.length; n++) {
                                this.ch(c, k, b, n, h);
                                if (k.isSummaryDirty) {
                                    e = true;
                                }
                                g = true;
                            }
                        }
                        else {
                            this.ch(c, k, b, m, h);
                            if (k.isSummaryDirty) {
                                e = true;
                            }
                            g = true;
                        }
                        let o = c.z;
                        while (o != -1) {
                            let p = this.z.t._inner[o];
                            let q = p.w();
                            for (let r = q; r < m; r++) {
                                this.ch(p, k, b, r, h);
                                if (k.isSummaryDirty) {
                                    e = true;
                                }
                            }
                            o = p.z;
                            m = m - 1;
                        }
                    }
                }
            }
            if (e) {
                this.m.queueAutoRefresh();
            }
            else {
                if (f) {
                    let s = SectionData.r(this.e);
                    this.ce(s);
                }
                if (g) {
                    this.ci(c, null);
                    let t = c.z;
                    while (t != -1) {
                        let u = this.z.t._inner[t];
                        this.ci(u, null);
                        t = u.z;
                    }
                }
            }
        }
        cl(a, b, c) {
            if (this.ag.k.count == 0) {
                return;
            }
            let d = null;
            if (c != null) {
                d = typeCast(DataSourceSpecialRow.$, this.a5._inner[c.af]);
            }
            let e = false;
            let f = false;
            let g = false;
            for (let h = 0; h < this.ag.k.count; h++) {
                let i = this.ag.k.item(h);
                if (this.l == 0 || this.l == 1) {
                    let j = this.d[h].itemRemoved(b, this.e[h], this.m.actualCount);
                    j.summaryIndex = h;
                    this.e[h] = j;
                    if (this.d[h].isSummaryDirty) {
                        e = true;
                    }
                    else {
                        f = true;
                    }
                }
                if (this.l == 0 || this.l == 2) {
                    if (c != null && c.i != null) {
                        let k = i.f();
                        k.dataSource = this.m;
                        k.propertyName = i.propertyName;
                        k.propertyType = this.m.resolveSchemaPropertyType(i.propertyName);
                        let l = this.g();
                        let m = c.w();
                        if (this.j == 1) {
                            for (let n = m; n < l.length; n++) {
                                this.cg(c, k, b, n, h, false);
                                if (k.isSummaryDirty) {
                                    e = true;
                                }
                                g = true;
                            }
                        }
                        else {
                            this.cg(c, k, b, m, h, false);
                            if (k.isSummaryDirty) {
                                e = true;
                            }
                            g = true;
                        }
                        let o = c.z;
                        while (o != -1) {
                            let p = this.z.t._inner[o];
                            let q = p.w();
                            for (let r = q; r < m; r++) {
                                this.cg(p, k, b, r, h, false);
                                if (k.isSummaryDirty) {
                                    e = true;
                                }
                            }
                            o = p.z;
                            m = m - 1;
                        }
                    }
                }
            }
            if (e) {
                this.m.queueAutoRefresh();
            }
            else {
                if (f) {
                    let s = SectionData.r(this.e);
                    this.ce(s);
                }
                if (g) {
                    this.ci(c, null);
                    let t = c.z;
                    while (t != -1) {
                        let u = this.z.t._inner[t];
                        this.ci(u, null);
                        t = u.z;
                    }
                }
            }
        }
        ci(a, b) {
            if (this.l == 2 || this.l == 0) {
                if (this.am) {
                    if (!a.o && !a.n()) {
                        if (this.as) {
                            this.bz(a, true);
                        }
                        else {
                            this.b0(a, true);
                        }
                    }
                    else {
                        a.am((c) => {
                            if (this.ab != null) {
                                let d = this.a5.indexOf1(c);
                                this.ab.notifySetItem(d, c, c);
                            }
                        });
                    }
                }
                else {
                    if (!a.o) {
                        for (let c = 0; c < a.i.length; c++) {
                            let d = a.af + a.b[c];
                            let e = this.a5._inner[d];
                            if (e != null) {
                                e.summaryResults = a.i[c];
                                if (this.ab != null) {
                                    this.ab.notifySetItem(d, e, e);
                                }
                            }
                        }
                    }
                }
            }
        }
        ce(a) {
            for (let b = 0; b < a.count; b++) {
                let c = new Array(a._inner[b].count);
                a._inner[b].values.copyTo(c, 0);
                let d = this.a5.count - a.count + b;
                let e = typeCast(DataSourceSpecialRow.$, this.a5._inner[d]);
                e.summaryResults = c;
                if (this.ab != null) {
                    this.ab.notifySetItem(d, e, e);
                }
            }
        }
    }
    RearrangedListView.$t = /*@__PURE__*/ markType(RearrangedListView, 'RearrangedListView', Base.$, [ISupportsDataChangeNotifications_$type]);
    return RearrangedListView;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISupportsExpansionChangeNotifications_$type = /*@__PURE__*/ new Type(null, 'ISupportsExpansionChangeNotifications');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LocalDataSource = /*@__PURE__*/ (() => {
    class LocalDataSource extends BaseDataSource {
        get_actualBaseDataProvider() {
            return this.actualDataProvider;
        }
        get actualBaseDataProvider() {
            return this.get_actualBaseDataProvider();
        }
        get dataProvider() {
            return this.cz;
        }
        set dataProvider(a) {
            let b = this.cz;
            this.cz = a;
            if (b != this.cz) {
                this.onPropertyUpdated("DataProvider", b, this.cz);
            }
        }
        get actualDataProvider() {
            if (this.cy == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.cy;
        }
        set actualDataProvider(a) {
            let b = this.cy;
            this.cy = a;
            if (b != this.cy) {
                this.onPropertyUpdated("ActualDataProvider", b, this.cy);
            }
        }
        get dataSource() {
            return this.d0;
        }
        set dataSource(a) {
            let b = this.d0;
            this.d0 = a;
            if (b != this.d0) {
                this.onPropertyUpdated("ItemsSource", b, this.d0);
            }
        }
        canInitialize() {
            let a = super.canInitialize();
            if (!a) {
                return false;
            }
            return this.dataSource != null;
        }
        get c5() {
            return this.c4;
        }
        set c5(a) {
            this.c4 = a;
            {
                this.actualDataProvider = this.resolveDataProvider();
            }
        }
        constructor() {
            super();
            this.cz = null;
            this.dc = false;
            this.cy = null;
            this.d0 = null;
            this.c4 = null;
            this.c8 = null;
            this.da = null;
            this.d4 = null;
            this.c6 = null;
            this.dl = new List$1(Array_$type, 0);
            this.db = false;
            this.cx = null;
            this.du = -1;
            this.dm = -1;
            this.dw = -1;
            this.dp = -1;
            this.dx = -1;
            this.dq = -1;
            this.dv = -1;
            this.dn = -1;
            this.dz = -1;
            this.dy = -1;
            this.ds = -1;
            this.dr = -1;
            this.dt = -1;
            this.executionContext = new DataSourceExecutionContext();
            this.v.l = false;
        }
        resolveDataProvider() {
            let provider_ = new DataSourceLocalDataProvider();
            provider_.executionContext = new DataSourceExecutionContext();
            return provider_;
        }
        propertyUpdatedOverride(a, b, c) {
            super.propertyUpdatedOverride(a, b, c);
            switch (a) {
                case "DataProvider":
                    this.dc = true;
                    this.actualDataProvider = this.dataProvider;
                    break;
                case "ActualDataProvider":
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.dataSource = this.dataSource;
                        this.actualSchema = this.actualDataProvider.actualSchema;
                        this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                    }
                    this.queueAutoRefresh();
                    break;
                case "ItemsSource":
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.dataSource = this.dataSource;
                        this.actualSchema = this.actualDataProvider.actualSchema;
                        this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                    }
                    this.queueAutoRefresh();
                    break;
            }
        }
        getItemAtIndex(a) {
            if (this.c8 != null && this.c8.a7 != null) {
                return this.c8.a7.item(a);
            }
            else {
                return this.actualDataProvider.getItemAtIndex(a);
            }
        }
        getItemFromKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return a[0];
            }
            let c = this.c7();
            let d;
            if (this.c8 != null) {
                let e = this.c8.a7.count;
                for (let f = 0; f < e; f++) {
                    d = this.c8.a7.item(f);
                    if (typeCast(DataSourceSpecialRow.$, d) !== null) {
                        let g = d;
                        if (g.rowType == 1 && !this.isSectionContentVisible && this.isSectionHeaderNormalRow) {
                            if (c.i(d, a) == 0) {
                                return d;
                            }
                        }
                    }
                    else if (c.i(d, a) == 0) {
                        return d;
                    }
                }
                return null;
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                let h = this.actualDataProvider.indexOfKey(a);
                return this.actualDataProvider.getItemAtIndex(h);
            }
            if (this.actualDataProvider != null) {
                let i = this.actualDataProvider.actualCount;
                for (let j = 0; j < i; j++) {
                    d = this.actualDataProvider.getItemAtIndex(j);
                    if (c.i(d, a) == 0) {
                        return d;
                    }
                }
            }
            return null;
        }
        getItemPropertyAtIndex(a, b) {
            let c;
            if (this.c8 != null) {
                c = this.c8.a7.item(a);
            }
            else {
                c = this.actualDataProvider.getItemAtIndex(a);
            }
            if (c == null) {
                return null;
            }
            let item_ = c;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return this.getSpecialRowItemValue(c, b);
            }
            if (this.ar()) {
                let d = this.ao(c, b);
                if (d) {
                    let e = this.a2(c, b);
                    return e;
                }
            }
            return this.actualDataProvider.getItemValue(c, b);
        }
        c3() {
            return this.actualDataProvider;
        }
        de() {
            return this.dl != null && this.dl.count > 0;
        }
        refreshInternalOverride() {
            super.refreshInternalOverride();
            if (this.actualDataProvider != null) {
                if (this.df() || this.dg() || this.dh() || this.di() || this.de()) {
                    if (this.c8 == null) {
                        if (this.da == null) {
                            this.da = new LocalDataSourceViewUpdateNotifier(this);
                        }
                        this.c8 = new RearrangedListView(this.actualDataProvider);
                        this.c8.ab = this.da;
                        this.c8.ad = new LocalDataSourceViewExpansionNotifier(this);
                    }
                    this.ensureComparables(this.actualDataProvider.actualSchema);
                    this.c8.av = this.shouldEmitSectionHeaders && this.aq;
                    this.c8.au = this.shouldEmitSectionFooters && this.aq;
                    this.c8.aw = this.shouldEmitShiftedRows;
                    this.c8.ax = this.shouldEmitSummaryRows;
                    this.c8.cc(this.dl);
                    this.c8.a3 = this.dk();
                    this.c8.a2 = this.dj();
                    this.c8.p = this.c7();
                    this.c8.ae = this.groupDescriptions;
                    this.c8.af = this.sortDescriptions;
                    this.c8.ag = this.summaryDescriptions;
                    this.c8.l = this.summaryScope;
                    this.c8.am = this.includeSummaryRowsInSection;
                    this.c8.as = this.isSectionSummaryRowsAtBottom;
                    this.c8.j = this.sectionHeaderDisplayMode;
                    this.c8.m = this;
                    this.c8.ap = this.groupDescriptions != null && this.groupDescriptions.k.count > 0;
                    this.c8.t = this.c9();
                    this.c8.b7();
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    this.actualCount = this.c8.a7.count;
                }
                else {
                    let a = this.c3();
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    if (a != null) {
                        this.actualCount = a.actualCount;
                    }
                    else {
                        this.actualCount = 0;
                    }
                    if (this.c8 != null) {
                        this.c8.ab = null;
                        this.c8 = null;
                        this.onBroadcastClearItems();
                    }
                }
            }
            else {
                this.actualCount = 0;
                this.actualSchema = null;
            }
        }
        get_isItemIndexLookupSupported() {
            return true;
        }
        get_isKeyIndexLookupSupported() {
            return true;
        }
        indexOfItem(a) {
            if (this.c8 != null) {
                return this.c8.a7.indexOf(a);
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
                return this.actualDataProvider.indexOfItem(a);
            }
            if (this.actualDataProvider != null) {
                let b = this.actualDataProvider.actualCount;
                let c;
                for (let d = 0; d < b; d++) {
                    c = this.actualDataProvider.getItemAtIndex(d);
                    if (this.dd(c, a)) {
                        return d;
                    }
                }
            }
            return -1;
        }
        dd(a, b) {
            if (a == null && b == null) {
                return true;
            }
            if (a == null || b == null) {
                return false;
            }
            return Base.equalsStatic(a, b);
        }
        indexOfKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return this.indexOfItem(a[0]);
            }
            let c = this.c7();
            let d;
            if (this.c8 != null) {
                let e = this.c8.a7.count;
                for (let f = 0; f < e; f++) {
                    d = this.c8.a7.item(f);
                    if (typeCast(DataSourceSpecialRow.$, d) !== null) {
                        let g = d;
                        if (g.rowType == 1 && !this.isSectionContentVisible && this.isSectionHeaderNormalRow) {
                            if (c.i(d, a) == 0) {
                                return f;
                            }
                        }
                    }
                    else if (c.i(d, a) == 0) {
                        return f;
                    }
                }
                return -1;
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                return this.actualDataProvider.indexOfKey(a);
            }
            if (this.actualDataProvider != null) {
                let h = this.actualDataProvider.actualCount;
                for (let i = 0; i < h; i++) {
                    d = this.actualDataProvider.getItemAtIndex(i);
                    if (c.i(d, a) == 0) {
                        return i;
                    }
                }
            }
            return -1;
        }
        onActualPrimaryKeyChangedOverrride(a, b) {
            super.onActualPrimaryKeyChangedOverrride(a, b);
            this.c6 = null;
        }
        c7() {
            if (this.c6 != null) {
                return this.c6;
            }
            if (this.actualPrimaryKey == null) {
                this.c6 = new DataSourcePropertiesComparer(null, null, null, this);
                return this.c6;
            }
            let a = new Array(this.actualPrimaryKey.length);
            for (let b = 0; b < a.length; b++) {
                a[b] = 0;
            }
            this.c6 = new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.d, this);
            return this.c6;
        }
        c9() {
            if (this.filterExpressions.k.count == 0) {
                return null;
            }
            let a = this.actualDataProvider;
            let b = this.actualDataProvider.actualSchema;
            let c = this.filterExpressions.k;
            let d = (e) => {
                for (let f = 0; f < c.count; f++) {
                    if (!c.item(f).match(e, a, b)) {
                        return false;
                    }
                }
                return true;
            };
            return d;
        }
        dk() {
            let a = 0;
            if (this.sortDescriptions.k.count == 0 && (this.groupDescriptions == null || this.groupDescriptions.k.count == 0)) {
                return null;
            }
            a = this.sortDescriptions.k.count;
            if (this.groupDescriptions != null) {
                a += this.groupDescriptions.k.count;
            }
            let b = new Array(a);
            let c = new Array(a);
            let d = 0;
            if (this.groupDescriptions != null) {
                for (let e = 0; e < this.groupDescriptions.k.count; e++) {
                    b[e] = this.groupDescriptions.k.item(e).propertyName;
                    c[e] = this.groupDescriptions.k.item(e).direction;
                    d++;
                }
            }
            for (let f = 0; f < this.sortDescriptions.k.count; f++) {
                b[f + d] = this.sortDescriptions.k.item(f).propertyName;
                c[f + d] = this.sortDescriptions.k.item(f).direction;
            }
            return new DataSourcePropertiesComparer(b, c, this.d, this);
        }
        dj() {
            if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
                return null;
            }
            let a = 0;
            a = this.groupDescriptions.k.count;
            let b = new Array(a);
            let c = new Array(a);
            if (this.groupDescriptions != null) {
                for (let d = 0; d < this.groupDescriptions.k.count; d++) {
                    b[d] = this.groupDescriptions.k.item(d).propertyName;
                    c[d] = this.groupDescriptions.k.item(d).direction;
                }
            }
            return new DataSourcePropertiesComparer(b, c, this.d, this);
        }
        dg() {
            if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
                return false;
            }
            if (this.actualDataProvider == null) {
                return false;
            }
            if (this.actualDataProvider.isGroupingSupported) {
                return false;
            }
            return true;
        }
        dh() {
            if (this.sortDescriptions == null || this.sortDescriptions.k.count < 1) {
                return false;
            }
            if (this.actualDataProvider == null) {
                return false;
            }
            if (this.actualDataProvider.isSortingSupported) {
                return false;
            }
            return true;
        }
        df() {
            return this.filterExpressions != null && this.filterExpressions.k.count > 0;
        }
        di() {
            if (this.summaryDescriptions == null || this.summaryDescriptions.k.count < 1) {
                return false;
            }
            return true;
        }
        onClearItemsOverride() {
            if (this.c8 != null) {
                this.c8.notifyClearItems();
                this.queueAutoRefresh();
            }
            else {
                super.onClearItemsOverride();
            }
        }
        onSetItemOverride(a, b, c) {
            if (this.c8 != null) {
                this.c8.notifySetItem(a, b, c);
            }
            else {
                super.onSetItemOverride(a, b, c);
            }
        }
        onInsertItemOverride(a, b) {
            if (this.c8 != null) {
                this.c8.notifyInsertItem(a, b);
            }
            else {
                super.onInsertItemOverride(a, b);
            }
        }
        onRemoveItemOverride(a, b) {
            if (this.c8 != null) {
                this.c8.notifyRemoveItem(a, b);
            }
            else {
                super.onRemoveItemOverride(a, b);
            }
        }
        d6() {
            this.actualCount = this.c8.a7.count;
            this.onBroadcastClearItems();
        }
        d9(a, b, c) {
            this.actualCount = this.c8.a7.count;
            this.onBroadcastSetItem(a, b, c);
        }
        d7(a, b) {
            this.actualCount = this.c8.a7.count;
            this.onBroadcastInsertItem(a, b);
        }
        d8(a, b) {
            this.actualCount = this.c8.a7.count;
            this.onBroadcastRemoveItem(a, b);
        }
        pinRow(a) {
            super.pinRow(a);
            this.du = -1;
            this.dm = -1;
            if (this.c8 != null) {
                this.dl.add(a);
                this.c8.b6(a);
            }
            else {
                this.dl.add(a);
                this.queueAutoRefresh();
            }
        }
        unpinRow(a) {
            super.unpinRow(a);
            let b = this.c7();
            if (this.c8 != null) {
                for (let c = this.dl.count - 1; c >= 0; c--) {
                    let d = this.dl._inner[c];
                    if (d.length != a.length) {
                        continue;
                    }
                    if (b.h(d, a) == 0) {
                        this.dl.removeAt(c);
                        this.c8.cd(d);
                    }
                }
            }
            else {
                for (let e = this.dl.count - 1; e >= 0; e--) {
                    let f = this.dl._inner[e];
                    if (f.length != a.length) {
                        continue;
                    }
                    if (b.h(f, a) == 0) {
                        this.dl.removeAt(e);
                    }
                }
                this.queueAutoRefresh();
            }
            this.du = -1;
            this.dm = -1;
        }
        clearPinnedRows() {
            for (let a = this.dl.count - 1; a >= 0; a--) {
                this.unpinRow(this.dl._inner[a]);
            }
        }
        isRowPinned(a) {
            if (this.c8 == null) {
                return false;
            }
            let b = this.getItemAtIndex(a);
            if (b == null) {
                return false;
            }
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                if (item_.rowType == 3) {
                    return true;
                }
            }
            let c = this.c7();
            let d;
            if (this.actualPrimaryKey == null) {
                d = new Array(1);
                d[0] = b;
            }
            else {
                let e = this.actualPrimaryKey;
                let f = e.length;
                d = new Array(f);
                for (let g = 0; g < f; g++) {
                    d[g] = this.getItemProperty(b, e[g]);
                }
            }
            for (let h = 0; h < this.dl.count; h++) {
                if (c.h(this.dl._inner[h], d) == 0) {
                    return true;
                }
            }
            return false;
        }
        get_isSortingSupported() {
            if (this.externalDataSource != null && !this.db) {
                this.db = true;
                let a = this.externalDataSource.isSortingSupportedOverride;
                this.db = false;
                return a;
            }
            return true;
        }
        get_isFilteringSupported() {
            if (this.externalDataSource != null && !this.db) {
                this.db = true;
                let a = this.externalDataSource.isFilteringSupportedOverride;
                this.db = false;
                return a;
            }
            return true;
        }
        get_isGroupingSupported() {
            if (this.externalDataSource != null && !this.db) {
                this.db = true;
                let a = this.externalDataSource.isGroupingSupportedOverride;
                this.db = false;
                return a;
            }
            return true;
        }
        getStickyRowPriority(a) {
            let b = this.getRowType(a);
            switch (b) {
                case 1: return 100 - this.getRowLevel(a);
                case 2: return 99 - this.getRowLevel(a);
                case 3:
                case 5: return 2;
                case 4: return 3;
            }
            return 1;
        }
        getStickyRowsInRange(a, b) {
            if (this.c8 == null || ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && (this.summaryDescriptions == null || this.summaryDescriptions.k.count == 0) && !this.de())) {
                return null;
            }
            let c = null;
            let d = null;
            if (this.c8.a6.count == 1) {
                c = this.c8.a6._inner[0];
                d = this.c8.a6._inner[0];
            }
            else {
                c = this.c8.w(a);
                if (c != null) {
                    while (c.z != -1) {
                        c = this.c8.a6._inner[c.z];
                    }
                }
                d = this.c8.w(b);
                if (b >= this.c8.a7.count - this.c8.bl) {
                    d = this.c8.v();
                }
            }
            if (c == null || d == null) {
                return null;
            }
            if (c.ae == this.du && c.aa == this.dw && c.af == this.dx && c.ad == this.dv && c.ah == this.dz && c.ag == this.dy && d.ae == this.dm && d.aa == this.dp && d.af == this.dq && d.ad == this.dn && d.ah == this.ds && d.ag == this.dr && this.c8.bl == this.dt) {
                return this.cx;
            }
            this.du = c.ae;
            this.dm = d.ae;
            this.dw = c.aa;
            this.dp = d.aa;
            this.dx = c.af;
            this.dq = d.af;
            this.dv = c.ad;
            this.dn = d.ad;
            this.dz = c.ah;
            this.dy = c.ag;
            this.ds = d.ah;
            this.dr = d.ag;
            this.dt = this.c8.bl;
            if (this.c8.a6.count == 1) {
                this.dm = d.ad;
            }
            let e = 0;
            if (this.shouldEmitSectionHeaders && this.aq) {
                e = 1;
            }
            let f = this.c8.bb();
            let g = new List$1(Number_$type, 0);
            for (let h = c.ae; h <= d.ae; h++) {
                let i = this.c8.a6._inner[h];
                let j = this.c8.a6._inner[h].c.length;
                let k = this.c8.a6._inner[h].v();
                if (this.shouldEmitSectionHeaders && this.aq) {
                    for (let l = 0; l < j; l++) {
                        if (this.c8.a6._inner[h].a[l] != null) {
                            let m = i.af + i.b[l];
                            g.add(m);
                            if (this.summaryScope == 0 || this.summaryScope == 2) {
                                if (i.c[l] && this.includeSummaryRowsInSection && !this.isSectionSummaryRowsAtBottom) {
                                    for (let n = 0; n < f; n++) {
                                        g.add(m + 1 + n);
                                    }
                                }
                            }
                        }
                        if (!this.c8.a6._inner[h].c[l]) {
                            break;
                        }
                    }
                }
                if (this.c8.a6._inner[h].p) {
                    if (this.shouldEmitShiftedRows) {
                        for (let o = 0; o < this.c8.a6._inner[h].aa; o++) {
                            g.add(this.c8.a6._inner[h].af + this.c8.a6._inner[h].ah + o + k);
                        }
                    }
                }
                if (this.summaryScope == 0 || this.summaryScope == 2) {
                    if (this.shouldEmitSummaryRows && this.includeSummaryRowsInSection && this.isSectionSummaryRowsAtBottom) {
                        for (let p = this.c8.a6._inner[h].ag - 1; p >= 0; p--) {
                            if (this.shouldEmitSectionFooters) {
                                g.add(this.c8.a6._inner[h].ad - k - p);
                            }
                            else {
                                g.add(this.c8.a6._inner[h].ad - p);
                            }
                        }
                    }
                }
                if (this.shouldEmitSectionFooters && this.aq) {
                    for (let q = j - 1; q >= 0; q--) {
                        if (!this.c8.a6._inner[h].c[q]) {
                            break;
                        }
                        g.add(this.c8.a6._inner[h].ad - q);
                    }
                }
            }
            for (let r = this.c8.a7.count - this.c8.bl; r < this.c8.a7.count; r++) {
                g.add(r);
            }
            this.cx = g.toArray();
            return this.cx;
        }
        isExclusivelySticky(a) {
            let b = this.getRowType(a);
            return b == 1 || b == 2 || b == 4 || (this.isSectionSummaryRowsAtBottom && b == 5);
        }
        getRowType(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                let c = b.rowType;
                if (this.isSectionHeaderNormalRow && c == 1) {
                    return 0;
                }
                return c;
            }
            return 0;
        }
        setIsRowExpandedAtIndex(a, b) {
            if (this.isSectionCollapsable && this.c8 != null && this.c8.a7.count > 0 && this.c8.a7.count > a) {
                this.c8.cb(a, b);
            }
        }
        getIsRowExpandedAtIndex(a) {
            if (this.c8 != null && this.c8.a7.count > 0 && this.c8.a7.count > a) {
                return this.c8.ak(a);
            }
            return true;
        }
        getRowLevel(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return b.level;
            }
            if (this.sectionHeaderDisplayMode == 1) {
                return this.groupDescriptions.k.count;
            }
            else if (this.groupDescriptions.k.count > 0) {
                return 1;
            }
            return 0;
        }
        getRootSummaryRowCount() {
            if (this.c8 != null) {
                return this.c8.bl;
            }
            return 0;
        }
        getRootSummaryResults() {
            if (this.c8 != null) {
                return this.c8.i;
            }
            return null;
        }
        getSectionSummaryResults(a) {
            if (this.c8 != null && this.c8.a6.count > 0 && a >= 0 && a < this.c8.a6.count) {
                return this.c8.a6._inner[a].i;
            }
            return null;
        }
        clone() {
            let a = new LocalDataSource();
            a.dataSource = this.dataSource;
            super.cloneProperties(a);
            if (this.dc && this.dataProvider != null && typeCast(IDataSourceClonableDataProvider_$type, this.dataProvider) !== null) {
                a.dataProvider = this.dataProvider.clone();
            }
            return a;
        }
        ar() {
            return !this.isReadOnly && this.actualBaseDataProvider != null && this.v != null;
        }
        cq(a, b) {
            if (a == 5) {
                let c = new List$1(TransactionType_$type, 0);
                let d = new List$1(Base.$, 0);
                let e = b;
                let f = e.a;
                for (let g = 0; g < f.length; g++) {
                    if (f[g].transactionType == 1) {
                        let h = f[g].id;
                        let i = this.getItemFromKey(h);
                        if (i != null) {
                            let j = f[g].value;
                            let k = this.indexOfItem(i);
                            let l = null;
                            if (this.c8 != null && k > -1) {
                                l = this.c8.w(k);
                                for (let m = 0; m < this.summaryDescriptions.k.count; m++) {
                                    let n = this.summaryDescriptions.k.item(m);
                                    if (n.operand == 5 || j.containsKey(n.propertyName)) {
                                        this.c8.cm(m, k, i, false, l);
                                    }
                                }
                            }
                            for (let o of fromEnum(j)) {
                                this.actualDataProvider.setItemValue(i, o.key, o.value);
                            }
                            if (l != null && this.c8 != null && k > -1) {
                                for (let p = 0; p < this.summaryDescriptions.k.count; p++) {
                                    let q = this.summaryDescriptions.k.item(p);
                                    if (q.operand == 5 || j.containsKey(q.propertyName)) {
                                        this.c8.cm(p, k, i, true, l);
                                    }
                                }
                            }
                            if (k > -1) {
                                this.onBroadcastSetItem(k, i, i);
                            }
                            d.add1(i);
                            c.add(1);
                            if (this.dl.count > 0) {
                                let r = this.c7();
                                for (let s = 0; s < this.dl.count; s++) {
                                    if (r.h(this.dl._inner[s], h) == 0) {
                                        let t = this.getStickyRows();
                                        for (let u = 0; u < t.length; u++) {
                                            let v = t[u];
                                            let w = typeCast(DataSourceSpecialRow.$, this.c8.a7.item(v));
                                            if (w != null && w.rowType == 3 && w.targetRow == i) {
                                                this.onBroadcastSetItem(v, w, w);
                                                break;
                                            }
                                        }
                                        break;
                                    }
                                }
                            }
                        }
                    }
                    else if (f[g].transactionType == TransactionType.Delete) {
                        let x = f[g].id;
                        let y = this.indexOfKey(x);
                        if (y > -1) {
                            let z = this.getItemAtIndex(y);
                            this.actualDataProvider.removeItem(z);
                            this.notifyRemoveItem(y, z);
                            d.add1(z);
                            c.add(TransactionType.Delete);
                        }
                    }
                    else if (f[g].transactionType == 0) {
                        let aa = f[g].id;
                        let ab = aa[0];
                        if (f[g].value != null) {
                            let ac = f[g].value;
                            for (let ad of fromEnum(ac)) {
                                this.actualDataProvider.setItemValue(ab, ad.key, ad.value);
                            }
                        }
                        this.actualDataProvider.addItem(ab);
                        d.add1(ab);
                        c.add(0);
                    }
                }
                if (f.length > 0) {
                    this.b2(e.id, this.getAggregatedChanges(e.id));
                }
            }
        }
    }
    LocalDataSource.$t = /*@__PURE__*/ markType(LocalDataSource, 'LocalDataSource', BaseDataSource.$);
    return LocalDataSource;
})();
/**
 * @hidden
 */
let LocalDataSourceViewUpdateNotifier = /*@__PURE__*/ (() => {
    class LocalDataSourceViewUpdateNotifier extends Base {
        notifyClearItems() {
            this.a.d6();
        }
        notifyInsertItem(a, b) {
            this.a.d7(a, b);
        }
        notifyRemoveItem(a, b) {
            this.a.d8(a, b);
        }
        notifySetItem(a, b, c) {
            this.a.d9(a, b, c);
        }
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
    }
    LocalDataSourceViewUpdateNotifier.$t = /*@__PURE__*/ markType(LocalDataSourceViewUpdateNotifier, 'LocalDataSourceViewUpdateNotifier', Base.$, [ISupportsDataChangeNotifications_$type]);
    return LocalDataSourceViewUpdateNotifier;
})();
/**
 * @hidden
 */
let LocalDataSourceViewExpansionNotifier = /*@__PURE__*/ (() => {
    class LocalDataSourceViewExpansionNotifier extends Base {
        notifyRowExpansionChanged(a, b, c) {
            this.a.onRowExpansionChanged(a, b, c);
        }
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
    }
    LocalDataSourceViewExpansionNotifier.$t = /*@__PURE__*/ markType(LocalDataSourceViewExpansionNotifier, 'LocalDataSourceViewExpansionNotifier', Base.$, [ISupportsExpansionChangeNotifications_$type]);
    return LocalDataSourceViewExpansionNotifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSeriesAdapter = /*@__PURE__*/ (() => {
    class DataSeriesAdapter extends Base {
        constructor() {
            super();
            this.e = null;
            this.f = new List$1(Delegate_$type, 0);
            this.e = new DataSeriesAdapterImplementation();
            this.e.ak = this;
            let a = this.e.dataSeries;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.j));
        }
        j(a, b) {
            for (let c = 0; c < this.f.count; c++) {
                this.f._inner[c](this, this.a());
            }
        }
        get i() {
            return this.e.itemsSource;
        }
        set i(a) {
            this.e.itemsSource = a;
        }
        getDataProvider(a) {
            return ((() => {
                let $ret = new DataSourceLocalDataProvider();
                $ret.dataSource = a;
                return $ret;
            })());
        }
        getLocalDataSource(a) {
            return ((() => {
                let $ret = new LocalDataSource();
                $ret.dataSource = a;
                return $ret;
            })());
        }
        l(a) {
            this.f.add(a);
        }
        x(a) {
            this.f.remove(a);
        }
        k(a) {
            this.e.dataSeries.add(a);
        }
        v(a) {
            this.e.dataSeries.remove(a);
        }
        w(a) {
            this.e.dataSeries.removeAt(a);
        }
        c(a) {
            return this.e.dataSeries._inner[a];
        }
        a() {
            let a = new Array(this.e.dataSeries.count);
            for (let b = 0; b < this.e.dataSeries.count; b++) {
                a[b] = this.e.dataSeries._inner[b];
            }
            return a;
        }
        n() {
            this.e.dataSeries.clear();
        }
        p(a, b) {
            this.e.dataSeries.insert(a, b);
        }
        g() {
            return this.e.dataSeries.count;
        }
        m(a) {
            this.e.rules.add(a);
        }
        y(a) {
            this.e.rules.remove(a);
        }
        z(a) {
            this.e.rules.removeAt(a);
        }
        d(a) {
            return this.e.rules._inner[a];
        }
        o() {
            this.e.rules.clear();
        }
        q(a, b) {
            this.e.rules.insert(a, b);
        }
        h() {
            return this.e.rules.count;
        }
        b() {
            let a = new Array(this.e.rules.count);
            for (let b = 0; b < this.e.rules.count; b++) {
                a[b] = this.e.rules._inner[b];
            }
            return a;
        }
        r(a) {
            this.e.notifyClearItems(a);
        }
        s(a, b, c) {
            this.e.notifyInsertItem(a, b, c);
        }
        t(a, b, c) {
            this.e.notifyRemoveItem(a, b, c);
        }
        u(a, b, c, d) {
            this.e.notifySetItem(a, b, c, d);
        }
    }
    DataSeriesAdapter.$t = /*@__PURE__*/ markType(DataSeriesAdapter, 'DataSeriesAdapter', Base.$, [IExternalDataSeriesAdapter_$type]);
    return DataSeriesAdapter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates which axis type is suggested in a data series.
 */
var DataSeriesAxisType = /*@__PURE__*/ (function (DataSeriesAxisType) {
    /**
     * Used when a category axis type is suggested.
     */
    DataSeriesAxisType[DataSeriesAxisType["Category"] = 0] = "Category";
    /**
     * Used when a linear axis type is suggested.
     */
    DataSeriesAxisType[DataSeriesAxisType["Linear"] = 1] = "Linear";
    /**
     * Used when a logarithmic axis type is suggested.
     */
    DataSeriesAxisType[DataSeriesAxisType["Logarithmic"] = 2] = "Logarithmic";
    /**
     * Used when a continuous date time axis type is suggested.
     */
    DataSeriesAxisType[DataSeriesAxisType["ContinuousDateTime"] = 3] = "ContinuousDateTime";
    /**
     * Used when a discrete date time axis type is suggested.
     */
    DataSeriesAxisType[DataSeriesAxisType["DiscreteDateTime"] = 4] = "DiscreteDateTime";
    /**
     * Used when an angular category axis is suggested.
     */
    DataSeriesAxisType[DataSeriesAxisType["CategoryAngle"] = 5] = "CategoryAngle";
    /**
     * Used when a proportional category angle axis is suggested.
     */
    DataSeriesAxisType[DataSeriesAxisType["ProportionalCategoryAngle"] = 6] = "ProportionalCategoryAngle";
    /**
     * Used when a radial axis is suggested.
     */
    DataSeriesAxisType[DataSeriesAxisType["RadialLinear"] = 7] = "RadialLinear";
    /**
     * Used when a logarithmic radial axis is suggested.
     */
    DataSeriesAxisType[DataSeriesAxisType["RadialLogarithmic"] = 8] = "RadialLogarithmic";
    return DataSeriesAxisType;
})({});
/**
 * @hidden
 */
let DataSeriesAxisType_$type = /*@__PURE__*/ markEnum('DataSeriesAxisType', 'Category,0|Linear,1|Logarithmic,2|ContinuousDateTime,3|DiscreteDateTime,4|CategoryAngle,5|ProportionalCategoryAngle,6|RadialLinear,7|RadialLogarithmic,8');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Identifies which type of marker is suggested for a data series.
 */
var DataSeriesMarker = /*@__PURE__*/ (function (DataSeriesMarker) {
    /**
     * Used when Automatic marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Automatic"] = 0] = "Automatic";
    /**
     * Used when no marker is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["None"] = 1] = "None";
    /**
     * Used when Circle marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Circle"] = 2] = "Circle";
    /**
     * Used when Flat-top triangle marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Triangle"] = 3] = "Triangle";
    /**
     * Used when Flat-base triangle marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Pyramid"] = 4] = "Pyramid";
    /**
     * Used when Square marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Square"] = 5] = "Square";
    /**
     * Used when Diamond marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Diamond"] = 6] = "Diamond";
    /**
     * Used when Pentagon marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Pentagon"] = 7] = "Pentagon";
    /**
     * Used when Hexagon marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Hexagon"] = 8] = "Hexagon";
    /**
     * Used when Four-pointed star marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Tetragram"] = 9] = "Tetragram";
    /**
     * Used when Five-pointed star marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Pentagram"] = 10] = "Pentagram";
    /**
     * Used when Six-pointed star marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Hexagram"] = 11] = "Hexagram";
    /**
     * Used when a hidden marker is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Hidden"] = 12] = "Hidden";
    /**
     * Used when a hidden marker is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Smart"] = 13] = "Smart";
    return DataSeriesMarker;
})({});
/**
 * @hidden
 */
let DataSeriesMarker_$type = /*@__PURE__*/ markEnum('DataSeriesMarker', 'Automatic,0|None,1|Circle,2|Triangle,3|Pyramid,4|Square,5|Diamond,6|Pentagon,7|Hexagon,8|Tetragram,9|Pentagram,10|Hexagram,11|Hidden,12|Smart,13');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

class IgrDataSeriesCollection extends IgCollection {
    constructor(list) {
        super();
        if (!DataSeries.$type) {
            DataSeries.$type = markType(DataSeries, "DataSeries");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!DataSeries.$type) {
            DataSeries.$type = markType(DataSeries, "DataSeries");
        }
        let coll = new SyncableObservableCollection$2(DataSeries.$type, DataSeries.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSeriesAdapterCachedProviderType_$type = /*@__PURE__*/ markEnum('DataSeriesAdapterCachedProviderType', 'Simple,0|Aggregated,1|Flat,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SimplePieSeriesRule = /*@__PURE__*/ (() => {
    class SimplePieSeriesRule extends Base {
        constructor() {
            super();
            this._priority = 0;
            this._useColumnThreshold = 0;
            this._distinctCheckThreshold = 0;
            this.priority = 10;
            this.distinctCheckThreshold = 50000;
            this.useColumnThreshold = 30;
        }
        get priority() {
            return this._priority;
        }
        set priority(a) {
            this._priority = a;
        }
        get useColumnThreshold() {
            return this._useColumnThreshold;
        }
        set useColumnThreshold(a) {
            this._useColumnThreshold = a;
        }
        get distinctCheckThreshold() {
            return this._distinctCheckThreshold;
        }
        set distinctCheckThreshold(a) {
            this._distinctCheckThreshold = a;
        }
        getPrimaryAxisLabelsStrings(a) {
            let b = a.analyzer;
            let c = b.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (16)));
            if (c.length > 0) {
                return c;
            }
            let d = b.getAllStringProperties();
            let e = b.getAllDateTimeProperties();
            let f = b.getAllDistinctMonotonicNumericProperties(this.distinctCheckThreshold);
            let g = new HashSet$1(String_$type, 0);
            for (let h = 0; h < d.length; h++) {
                let i = d[h];
                g.add_1(i);
            }
            for (let j = 0; j < e.length; j++) {
                let k = e[j];
                g.add_1(k);
            }
            for (let l = 0; l < f.length; l++) {
                let m = f[l];
                g.add_1(m);
            }
            d = b.getAllExcludedStringProperties();
            e = b.getAllExcludedDateTimeProperties();
            f = b.getAllExcludedDistinctMonotonicNumericProperties(this.distinctCheckThreshold);
            for (let n = 0; n < d.length; n++) {
                let o = d[n];
                g.add_1(o);
            }
            for (let p = 0; p < e.length; p++) {
                let q = e[p];
                g.add_1(q);
            }
            for (let r = 0; r < f.length; r++) {
                let s = f[r];
                g.add_1(s);
            }
            let t = new Array(g.count);
            let u = 0;
            for (let v of fromEnum(g)) {
                t[u] = v;
                u++;
            }
            return t;
        }
        getPrimaryAxisLabelsString(a) {
            return SimplePieSeriesRule.d(a.analyzer, this.distinctCheckThreshold);
        }
        static d(a, b) {
            let c = a.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (16)));
            if (c.length > 0) {
                return c[0];
            }
            return (((d) => d != null ? d : (((e) => e != null ? e : (((f) => f != null ? f : a.getFirstStringProperty())(a.getFirstDistinctMonotonicNumericProperty(b))))(a.getFirstDistinctDateTimeProperty(b))))(a.getFirstDistinctStringProperty(b)));
        }
        static c(a, b) {
            return SimplePieSeriesRule.d(a.analyzer, b);
        }
        evaluate(a) {
            let b = SimplePieSeriesRule.c(a, this.distinctCheckThreshold);
            let c = null;
            let d = a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (0)));
            if (d.length > 0) {
                c = d;
            }
            if (c == null) {
                c = a.analyzer.getAllNumericProperties();
            }
            if (c == null || c.length == 0) {
                return;
            }
            let e = a.getCurrentDataSource().actualCount;
            for (let f = 0; f < c.length; f++) {
                if (c[f] == b && c.length > 1) {
                    continue;
                }
                let g = new Array(1);
                g[0] = c[f];
                let h = a.analyzer.getTitleString(null, g);
                let i = new DataSeries();
                let j = new DataSeriesMemberPathHint();
                j.intent = 0;
                j.path = c[f];
                let k = new DataSeriesMemberPathHint();
                k.intent = 16;
                k.path = b;
                i.addMemberPathHint(j);
                i.addMemberPathHint(k);
                i.suggestedSeries = 34;
                this.e(i, a);
                i.suggestedPrimaryAxis = 6;
                i.suggestedSecondaryAxis = 7;
                i.name = c[f];
                if (h != null) {
                    i.title = h;
                }
                else {
                    i.title = c[f];
                    i.title = a.analyzer.expandCamelCasedWords(i.title);
                }
                a.addDataSeries(i, this);
            }
        }
        e(a, b) {
        }
    }
    SimplePieSeriesRule.$t = /*@__PURE__*/ markType(SimplePieSeriesRule, 'SimplePieSeriesRule', Base.$, [IDataSeriesAdapterRule_$type]);
    return SimplePieSeriesRule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SimpleFinancialPriceSeriesRule = /*@__PURE__*/ (() => {
    class SimpleFinancialPriceSeriesRule extends Base {
        constructor() {
            super();
            this._priority = 0;
            this._distinctCheckThreshold = 0;
            this.priority = 10;
            this.distinctCheckThreshold = 50000;
        }
        get priority() {
            return this._priority;
        }
        set priority(a) {
            this._priority = a;
        }
        get distinctCheckThreshold() {
            return this._distinctCheckThreshold;
        }
        set distinctCheckThreshold(a) {
            this._distinctCheckThreshold = a;
        }
        f(a, b) {
            for (let c of fromEnum(b)) {
                if (a.contains(c)) {
                    a.remove(c);
                }
            }
        }
        static e(a, b) {
            let c = a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (17)));
            if (c.length > 0) {
                return c[0];
            }
            return (((d) => d != null ? d : a.analyzer.getFirstDateTimeProperty())(a.analyzer.getFirstDistinctDateTimeProperty(b)));
        }
        getPrimaryAxisLabelsString(a) {
            return SimpleFinancialPriceSeriesRule.d(a.analyzer, this.distinctCheckThreshold);
        }
        static d(a, b) {
            let c = a.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (17)));
            if (c.length > 0) {
                return c[0];
            }
            c = a.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (16)));
            if (c.length > 0) {
                return c[0];
            }
            return (((d) => d != null ? d : (((e) => e != null ? e : (((f) => f != null ? f : a.getFirstStringProperty())(a.getFirstDistinctMonotonicNumericProperty(b))))(a.getFirstDistinctStringProperty(b))))(a.getFirstDistinctDateTimeProperty(b)));
        }
        static b(a, b) {
            return SimpleFinancialPriceSeriesRule.d(a.analyzer, b);
        }
        evaluate(a) {
            let b = SimpleFinancialPriceSeriesRule.e(a, this.distinctCheckThreshold);
            let c = SimpleFinancialPriceSeriesRule.b(a, this.distinctCheckThreshold);
            let d = new List$1(String_$type, 1, a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (11))));
            let e = new List$1(String_$type, 1, a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (12))));
            let f = new List$1(String_$type, 1, a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (13))));
            let g = new List$1(String_$type, 1, a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (14))));
            let h = new List$1(String_$type, 1, a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (15))));
            let i = Math.min(d.count, Math.min(e.count, Math.min(f.count, g.count)));
            if (i == 0) {
                let j = new List$1(String_$type, 1, a.analyzer.getAllNumericProperties());
                for (let k of fromEnum(j)) {
                    if (Base.equalsStatic(k.toLowerCase(), "open")) {
                        d.add(k);
                        continue;
                    }
                    if (Base.equalsStatic(k.toLowerCase(), "high")) {
                        e.add(k);
                        continue;
                    }
                    if (Base.equalsStatic(k.toLowerCase(), "low")) {
                        f.add(k);
                        continue;
                    }
                    if (Base.equalsStatic(k.toLowerCase(), "close")) {
                        g.add(k);
                        continue;
                    }
                    if (Base.equalsStatic(k.toLowerCase(), "volume")) {
                        h.add(k);
                        continue;
                    }
                }
                this.f(j, d);
                this.f(j, e);
                this.f(j, f);
                this.f(j, g);
                this.f(j, h);
                let l = d.count + e.count + f.count + g.count + j.count;
                if (l == 0) {
                    return;
                }
                i = l <= 4 ? 1 : truncate(Math.floor(l / 5));
                let m = [d, e, f, g, h];
                let n = 0;
                while (j.count > 0) {
                    m[n++ % m.length].add(j._inner[0]);
                    j.removeAt(0);
                }
            }
            let o = this.c(a.getCurrentDataSource());
            for (let p = 0; p < i; p++) {
                a.pushParentTitle(i == 1 ? o : o + (p + 1));
                let q = d.count > p ? d._inner[p] : null;
                let r = e.count > p ? e._inner[p] : null;
                let s = f.count > p ? f._inner[p] : null;
                let t = g.count > p ? g._inner[p] : null;
                let u = ((() => {
                    let $ret = new DataSeries();
                    $ret.name = stringJoin("_", ...[q, r, s, t]);
                    $ret.title = a.analyzer.getTitleString(null, [q, r, s, t]);
                    $ret.suggestedSeries = 20;
                    $ret.suggestedPrimaryAxis = 0;
                    $ret.suggestedSecondaryAxis = 1;
                    return $ret;
                })());
                u.addMemberPathHint(((() => {
                    let $ret = new DataSeriesMemberPathHint();
                    $ret.intent = 11;
                    $ret.path = q;
                    return $ret;
                })()));
                u.addMemberPathHint(((() => {
                    let $ret = new DataSeriesMemberPathHint();
                    $ret.intent = 12;
                    $ret.path = r;
                    return $ret;
                })()));
                u.addMemberPathHint(((() => {
                    let $ret = new DataSeriesMemberPathHint();
                    $ret.intent = 13;
                    $ret.path = s;
                    return $ret;
                })()));
                u.addMemberPathHint(((() => {
                    let $ret = new DataSeriesMemberPathHint();
                    $ret.intent = 14;
                    $ret.path = t;
                    return $ret;
                })()));
                if (h.count > p) {
                    u.addMemberPathHint(((() => {
                        let $ret = new DataSeriesMemberPathHint();
                        $ret.intent = 15;
                        $ret.path = h._inner[p];
                        return $ret;
                    })()));
                }
                if (b != null) {
                    u.addMemberPathHint(((() => {
                        let $ret = new DataSeriesMemberPathHint();
                        $ret.intent = 17;
                        $ret.path = b;
                        return $ret;
                    })()));
                }
                u.addMemberPathHint(((() => {
                    let $ret = new DataSeriesMemberPathHint();
                    $ret.intent = 16;
                    $ret.path = c;
                    return $ret;
                })()));
                a.addDataSeries(u, this);
                a.popParentTitle();
            }
        }
        c(a) {
            let b = a == null ? null : a.dataSource;
            if (b == null) {
                return null;
            }
            let c = (typeof b.title === 'function');
            return c ? (b.title()) : (b.title) ? (b.title) : null;
        }
        getPrimaryAxisLabelsStrings(a) {
            let b = this.getPrimaryAxisLabelsString(a);
            if (b == null) {
                return null;
            }
            return [b];
        }
    }
    SimpleFinancialPriceSeriesRule.$t = /*@__PURE__*/ markType(SimpleFinancialPriceSeriesRule, 'SimpleFinancialPriceSeriesRule', Base.$, [IDataSeriesAdapterRule_$type]);
    return SimpleFinancialPriceSeriesRule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SimpleScatterSeriesRule = /*@__PURE__*/ (() => {
    class SimpleScatterSeriesRule extends Base {
        constructor() {
            super();
            this._priority = 0;
            this._monotonicCheckAmount = 0;
            this.priority = 9;
            this.monotonicCheckAmount = 10000;
        }
        get priority() {
            return this._priority;
        }
        set priority(a) {
            this._priority = a;
        }
        get monotonicCheckAmount() {
            return this._monotonicCheckAmount;
        }
        set monotonicCheckAmount(a) {
            this._monotonicCheckAmount = a;
        }
        evaluate(a) {
            let b = a.analyzer.getAllNumericProperties();
            if (b.length == 0) {
                return;
            }
            let c = a.getCurrentDataSource().actualCount;
            let d = new List$1(String_$type, 0);
            for (let e = 0; e < b.length; e++) {
                d.add(b[e]);
            }
            let f = this.c(d);
            let g = this.d(d);
            let h = a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (1)));
            let i = a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (2)));
            if (h.length > 0 && i.length > 0 && h.length == i.length) {
                f.clear();
                g.clear();
                d.clear();
                for (let j = 0; j < h.length; j++) {
                    f.add(h[j]);
                    g.add(i[j]);
                }
            }
            let k = 0;
            for (k = 0; k < Math.min(f.count, g.count); k++) {
                let l = new Array(2);
                l[0] = f._inner[k];
                l[1] = g._inner[k];
                let m = a.analyzer.getTitleString(null, l);
                this.f(a, f._inner[k], g._inner[k], m);
            }
            for (; k < f.count; k++) {
                d.add(f._inner[k]);
            }
            for (; k < g.count; k++) {
                d.add(g._inner[k]);
            }
            for (let n = 0; n < d.count; n += 2) {
                if (n + 1 >= d.count) {
                    continue;
                }
                let o = new Array(2);
                o[0] = d._inner[n];
                o[1] = d._inner[n + 1];
                let p = a.analyzer.getTitleString(null, o);
                this.f(a, d._inner[n], d._inner[n + 1], p);
            }
        }
        d(a) {
            let b = new List$1(String_$type, 0);
            for (let c = 0; c < a.count; c++) {
                if (this.b(a._inner[c])) {
                    b.add(a._inner[c]);
                    a.removeAt(c);
                    c--;
                }
            }
            return b;
        }
        b(a) {
            if (Base.equalsStatic(a.toLowerCase(), "y") || Base.equalsStatic(a.toLowerCase(), "yvalue")) {
                return true;
            }
            return false;
        }
        c(a) {
            let b = new List$1(String_$type, 0);
            for (let c = 0; c < a.count; c++) {
                if (this.a(a._inner[c])) {
                    b.add(a._inner[c]);
                    a.removeAt(c);
                    c--;
                }
            }
            return b;
        }
        a(a) {
            if (Base.equalsStatic(a.toLowerCase(), "x") || Base.equalsStatic(a.toLowerCase(), "xvalue")) {
                return true;
            }
            return false;
        }
        f(a, b, c, d) {
            let e = new DataSeries();
            e.name = b + "_" + c;
            if (d != null) {
                e.title = d;
            }
            else {
                e.title = b + " - " + c;
                e.title = a.analyzer.expandCamelCasedWords(e.title);
            }
            let f = new DataSeriesMemberPathHint();
            f.intent = 1;
            f.path = b;
            let g = new DataSeriesMemberPathHint();
            g.intent = 2;
            g.path = c;
            e.addMemberPathHint(f);
            e.addMemberPathHint(g);
            let h = a.getCurrentDataSource();
            let i = h.actualCount;
            if (i > this.monotonicCheckAmount) {
                e.suggestedSeries = 11;
            }
            else {
                if (a.analyzer.isMonotonic(h, b, this.monotonicCheckAmount)) {
                    e.suggestedSeries = 12;
                }
                else {
                    e.suggestedSeries = 11;
                }
            }
            e.suggestedPrimaryAxis = 1;
            e.suggestedSecondaryAxis = 1;
            a.addDataSeries(e, this);
        }
        getPrimaryAxisLabelsString(a) {
            return null;
        }
        getPrimaryAxisLabelsStrings(a) {
            let b = this.getPrimaryAxisLabelsString(a);
            if (b == null) {
                return null;
            }
            return [b];
        }
    }
    SimpleScatterSeriesRule.$t = /*@__PURE__*/ markType(SimpleScatterSeriesRule, 'SimpleScatterSeriesRule', Base.$, [IDataSeriesAdapterRule_$type]);
    return SimpleScatterSeriesRule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SubCollectionsRule = /*@__PURE__*/ (() => {
    class SubCollectionsRule extends Base {
        constructor() {
            super();
            this._priority = 0;
            this._collectionTransformationThreshold = 0;
            this.priority = 0;
            this.collectionTransformationThreshold = 50;
        }
        get priority() {
            return this._priority;
        }
        set priority(a) {
            this._priority = a;
        }
        get collectionTransformationThreshold() {
            return this._collectionTransformationThreshold;
        }
        set collectionTransformationThreshold(a) {
            this._collectionTransformationThreshold = a;
        }
        evaluate(a) {
            let b = a.getCurrentDataSource();
            if (b == null) {
                return;
            }
            if (b.actualCount == 0 || b.actualCount > this.collectionTransformationThreshold) {
                return;
            }
            let c = b.getItemAtIndex(0);
            if (a.analyzer.isCollection(c)) {
                for (let d = 0; d < b.actualCount; d++) {
                    if (a.analyzer.isCollection(b.getItemAtIndex(d))) {
                        let e = a.analyzer.getTitleString(b.getItemAtIndex(d), null);
                        if (e != null) {
                            a.pushParentTitle(e);
                        }
                        a.recurseRules(b.getItemAtIndex(d), "[" + d + "]", false);
                        if (e != null) {
                            a.popParentTitle();
                        }
                    }
                }
            }
        }
        getPrimaryAxisLabelsString(a) {
            return null;
        }
        getPrimaryAxisLabelsStrings(a) {
            let b = this.getPrimaryAxisLabelsString(a);
            if (b == null) {
                return null;
            }
            return [b];
        }
    }
    SubCollectionsRule.$t = /*@__PURE__*/ markType(SubCollectionsRule, 'SubCollectionsRule', Base.$, [IDataSeriesAdapterRule_$type]);
    return SubCollectionsRule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SimpleCategorySeriesRule = /*@__PURE__*/ (() => {
    class SimpleCategorySeriesRule extends Base {
        constructor() {
            super();
            this._priority = 0;
            this._useColumnThreshold = 0;
            this._distinctCheckThreshold = 0;
            this.priority = 10;
            this.distinctCheckThreshold = 50000;
            this.useColumnThreshold = 30;
        }
        get priority() {
            return this._priority;
        }
        set priority(a) {
            this._priority = a;
        }
        get useColumnThreshold() {
            return this._useColumnThreshold;
        }
        set useColumnThreshold(a) {
            this._useColumnThreshold = a;
        }
        get distinctCheckThreshold() {
            return this._distinctCheckThreshold;
        }
        set distinctCheckThreshold(a) {
            this._distinctCheckThreshold = a;
        }
        getPrimaryAxisLabelsString(a) {
            return SimpleCategorySeriesRule.d(a.analyzer, this.distinctCheckThreshold);
        }
        getPrimaryAxisLabelsStrings(a) {
            let b = a.analyzer;
            let c = b.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (16)));
            if (c.length > 0) {
                return c;
            }
            let d = b.getAllStringProperties();
            let e = b.getAllDateTimeProperties();
            let f = b.getAllDistinctMonotonicNumericProperties(this.distinctCheckThreshold);
            let g = new HashSet$1(String_$type, 0);
            for (let h = 0; h < d.length; h++) {
                let i = d[h];
                g.add_1(i);
            }
            for (let j = 0; j < e.length; j++) {
                let k = e[j];
                g.add_1(k);
            }
            for (let l = 0; l < f.length; l++) {
                let m = f[l];
                g.add_1(m);
            }
            d = b.getAllExcludedStringProperties();
            e = b.getAllExcludedDateTimeProperties();
            f = b.getAllExcludedDistinctMonotonicNumericProperties(this.distinctCheckThreshold);
            for (let n = 0; n < d.length; n++) {
                let o = d[n];
                g.add_1(o);
            }
            for (let p = 0; p < e.length; p++) {
                let q = e[p];
                g.add_1(q);
            }
            for (let r = 0; r < f.length; r++) {
                let s = f[r];
                g.add_1(s);
            }
            let t = new Array(g.count);
            let u = 0;
            for (let v of fromEnum(g)) {
                t[u] = v;
                u++;
            }
            return t;
        }
        static d(a, b) {
            let c = a.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (16)));
            if (c.length > 0) {
                return c[0];
            }
            return (((d) => d != null ? d : (((e) => e != null ? e : (((f) => f != null ? f : a.getFirstStringProperty())(a.getFirstDistinctMonotonicNumericProperty(b))))(a.getFirstDistinctDateTimeProperty(b))))(a.getFirstDistinctStringProperty(b)));
        }
        static c(a, b) {
            return SimpleCategorySeriesRule.d(a.analyzer, b);
        }
        evaluate(a) {
            let b = SimpleCategorySeriesRule.c(a, this.distinctCheckThreshold);
            let c = null;
            let d = a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (0)));
            if (d.length > 0) {
                c = d;
            }
            if (c == null) {
                c = a.analyzer.getAllNumericProperties();
            }
            if (c == null || c.length == 0) {
                return;
            }
            let e = a.getCurrentDataSource().actualCount;
            for (let f = 0; f < c.length; f++) {
                if (c[f] == b && c.length > 1) {
                    continue;
                }
                let g = new Array(1);
                g[0] = c[f];
                let h = a.analyzer.getTitleString(null, g);
                let i = new DataSeries();
                let j = new DataSeriesMemberPathHint();
                j.intent = 0;
                j.path = c[f];
                let k = new DataSeriesMemberPathHint();
                k.intent = 16;
                k.path = b;
                i.addMemberPathHint(j);
                i.addMemberPathHint(k);
                if (e > this.useColumnThreshold) {
                    i.suggestedSeries = 0;
                }
                else {
                    i.suggestedSeries = 1;
                }
                this.e(i, a);
                i.suggestedPrimaryAxis = 0;
                i.suggestedSecondaryAxis = 1;
                i.name = c[f];
                if (h != null) {
                    i.title = h;
                }
                else {
                    i.title = c[f];
                    i.title = a.analyzer.expandCamelCasedWords(i.title);
                }
                a.addDataSeries(i, this);
            }
        }
        e(a, b) {
            if (!b.hasValidType(a)) {
                a.suggestedSeries = 0;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 1;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 2;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 6;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 7;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 4;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 5;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 10;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 8;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 0;
            }
        }
    }
    SimpleCategorySeriesRule.$t = /*@__PURE__*/ markType(SimpleCategorySeriesRule, 'SimpleCategorySeriesRule', Base.$, [IDataSeriesAdapterRule_$type]);
    return SimpleCategorySeriesRule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Identifies the operator type of an operator filter expression.
 */
var FilterExpressionOperatorType = /*@__PURE__*/ (function (FilterExpressionOperatorType) {
    /**
     * No operator type specified.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["None"] = 0] = "None";
    /**
     * Determines if two expressions are equal.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Equal"] = 1] = "Equal";
    /**
     * Determines if two expressions are not equal.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["NotEqual"] = 2] = "NotEqual";
    /**
     * Determines if an expression is greater than another.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["GreaterThan"] = 3] = "GreaterThan";
    /**
     * Determines if an expression is greater than or equal to another.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["GreaterThanOrEqual"] = 4] = "GreaterThanOrEqual";
    /**
     * Determines if an expression is less than another.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["LessThan"] = 5] = "LessThan";
    /**
     * Determines if an expression is less than or equal to another.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["LessThanOrEqual"] = 6] = "LessThanOrEqual";
    /**
     * Applies the And operator to two expressions.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["And"] = 7] = "And";
    /**
     * Applies the Or operator to two expressions.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Or"] = 8] = "Or";
    /**
     * Applies the Not operator to a single expression.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Not"] = 9] = "Not";
    /**
     * Adds two expressions.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Add"] = 10] = "Add";
    /**
     * Subtracts one expression from another.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Subtract"] = 11] = "Subtract";
    /**
     * Multiplies two expressions.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Multiply"] = 12] = "Multiply";
    /**
     * Divides one expression by another.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Divide"] = 13] = "Divide";
    /**
     * Performs the modulus of one expression by another.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Modulo"] = 14] = "Modulo";
    /**
     * Groups an expression.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Grouping"] = 15] = "Grouping";
    return FilterExpressionOperatorType;
})({});
/**
 * @hidden
 */
let FilterExpressionOperatorType_$type = /*@__PURE__*/ markEnum('FilterExpressionOperatorType', 'None,0|Equal,1|NotEqual,2|GreaterThan,3|GreaterThanOrEqual,4|LessThan,5|LessThanOrEqual,6|And,7|Or,8|Not,9|Add,10|Subtract,11|Multiply,12|Divide,13|Modulo,14|Grouping,15');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indentifies the function type for a filter function expression.
 */
var FilterExpressionFunctionType = /*@__PURE__*/ (function (FilterExpressionFunctionType) {
    /**
     * Determines if a string contains another.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Contains"] = 0] = "Contains";
    /**
     * Determines if a string ends with another.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["EndsWith"] = 1] = "EndsWith";
    /**
     * Determines if a string starts with another.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["StartsWith"] = 2] = "StartsWith";
    /**
     * Gets the length of a string.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Length"] = 3] = "Length";
    /**
     * Gets the index of a string within another.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["IndexOf"] = 4] = "IndexOf";
    /**
     * Replaces instances of a string within another with a separate string.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Replace"] = 5] = "Replace";
    /**
     * Gets the substring of a string based on start index and optionally length.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Substring"] = 6] = "Substring";
    /**
     * Gets the lowercase representation of a string.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["ToLower"] = 7] = "ToLower";
    /**
     * Gets the uppercase representation of a string.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["ToUpper"] = 8] = "ToUpper";
    /**
     * Trims the starting and ending whitespace from a string.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Trim"] = 9] = "Trim";
    /**
     * Concatenates strings together.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Concat"] = 10] = "Concat";
    /**
     * Gets the day from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Day"] = 11] = "Day";
    /**
     * Gets the hour from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Hour"] = 12] = "Hour";
    /**
     * Gets the minute from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Minute"] = 13] = "Minute";
    /**
     * Gets the month from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Month"] = 14] = "Month";
    /**
     * Gets teh second from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Second"] = 15] = "Second";
    /**
     * Gets the year from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Year"] = 16] = "Year";
    /**
     * Rounds a numeric value.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Round"] = 17] = "Round";
    /**
     * Floors a numeric value.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Floor"] = 18] = "Floor";
    /**
     * Ceilings a numeric value.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Ceiling"] = 19] = "Ceiling";
    /**
     * Gets the date from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Date"] = 20] = "Date";
    /**
     * Gets the time from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Time"] = 21] = "Time";
    /**
     * Gets the current date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Now"] = 22] = "Now";
    /**
     * Gets whether the value matches a certain type.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["IsOf"] = 23] = "IsOf";
    /**
     * Gets a value cast to a specific type.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Cast"] = 24] = "Cast";
    return FilterExpressionFunctionType;
})({});
/**
 * @hidden
 */
let FilterExpressionFunctionType_$type = /*@__PURE__*/ markEnum('FilterExpressionFunctionType', 'Contains,0|EndsWith,1|StartsWith,2|Length,3|IndexOf,4|Replace,5|Substring,6|ToLower,7|ToUpper,8|Trim,9|Concat,10|Day,11|Hour,12|Minute,13|Month,14|Second,15|Year,16|Round,17|Floor,18|Ceiling,19|Date,20|Time,21|Now,22|IsOf,23|Cast,24');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IOperationFilterExpression_$type = /*@__PURE__*/ new Type(null, 'IOperationFilterExpression', null, [IFilterExpression_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFunctionFilterExpression_$type = /*@__PURE__*/ new Type(null, 'IFunctionFilterExpression', null, [IFilterExpression_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IPropertyReferenceFilterExpression_$type = /*@__PURE__*/ new Type(null, 'IPropertyReferenceFilterExpression', null, [IFilterExpression_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ILiteralFilterExpression_$type = /*@__PURE__*/ new Type(null, 'ILiteralFilterExpression', null, [IFilterExpression_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterFactory = /*@__PURE__*/ (() => {
    class FilterFactory extends Base {
        constructor() {
            super(...arguments);
            this.au = dateMinValue();
        }
        get todayOverride() {
            return this.au;
        }
        set todayOverride(a) {
            this.au = a;
        }
        static get instance() {
            if (FilterFactory.as == null) {
                FilterFactory.as = new FilterFactory();
            }
            return FilterFactory.as;
        }
        static build(a) {
            let b = FilterFactory.instance;
            return a(b);
        }
        property(a) {
            return FilterExpression.property(a);
        }
        literal(a) {
            return FilterExpression.literal(a);
        }
        group(a) {
            return FilterExpression.operation(a, 15, null);
        }
        and(a, b) {
            return FilterExpression.operation(a, 7, b);
        }
        or(a, b) {
            return FilterExpression.operation(a, 8, b);
        }
        not(a) {
            return FilterExpression.operation(a, 9, null);
        }
        add(a, b) {
            return FilterExpression.operation(a, 10, b);
        }
        divide(a, b) {
            return FilterExpression.operation(a, 13, b);
        }
        equal(a, b) {
            return FilterExpression.operation(a, 1, b);
        }
        greaterThan(a, b) {
            return FilterExpression.operation(a, 3, b);
        }
        greaterThanOrEqual(a, b) {
            return FilterExpression.operation(a, 4, b);
        }
        lessThan(a, b) {
            return FilterExpression.operation(a, 5, b);
        }
        lessThanOrEqual(a, b) {
            return FilterExpression.operation(a, 6, b);
        }
        modulus(a, b) {
            return FilterExpression.operation(a, 14, b);
        }
        multiply(a, b) {
            return FilterExpression.operation(a, 12, b);
        }
        notEqual(a, b) {
            return FilterExpression.operation(a, 2, b);
        }
        subtract(a, b) {
            return FilterExpression.operation(a, 11, b);
        }
        ceiling(a) {
            return FilterExpression.func(19, a);
        }
        concat(a, b) {
            return FilterExpression.func(10, a, b);
        }
        concat1(a, b) {
            return FilterExpression.func(10, a, FilterExpression.literal(b));
        }
        contains(a, b) {
            if (typeof b === 'string') {
                b = FilterExpression.literal(b);
            }
            return FilterExpression.func(0, a, b);
        }
        day(a) {
            return FilterExpression.func(11, a);
        }
        endsWith(a, b) {
            if (typeof b === 'string') {
                b = FilterExpression.literal(b);
            }
            return FilterExpression.func(1, a, b);
        }
        floor(a) {
            return FilterExpression.func(18, a);
        }
        hour(a) {
            return FilterExpression.func(12, a);
        }
        indexOf(a, b) {
            if (typeof b === 'string') {
                b = FilterExpression.literal(b);
            }
            return FilterExpression.func(4, a, b);
        }
        length(a) {
            return FilterExpression.func(FilterExpressionFunctionType.Length, a);
        }
        minute(a) {
            return FilterExpression.func(13, a);
        }
        month(a) {
            return FilterExpression.func(14, a);
        }
        replace(a, b, c) {
            if (typeof b === 'string') {
                b = FilterExpression.literal(b);
            }
            if (typeof c === 'string') {
                c = FilterExpression.literal(c);
            }
            return FilterExpression.func(5, a, b, c);
        }
        round(a) {
            return FilterExpression.func(17, a);
        }
        second(a) {
            return FilterExpression.func(15, a);
        }
        startsWith(a, b) {
            if (typeof b === 'string') {
                b = FilterExpression.literal(b);
            }
            return FilterExpression.func(2, a, b);
        }
        substring(a, b, c = null) {
            if (typeof b === 'number') {
                b = FilterExpression.literal(b);
            }
            if (c != null && typeof c === 'number') {
                c = FilterExpression.literal(c);
            }
            if (c != null) {
                return FilterExpression.func(6, a, b, c);
            }
            else {
                return FilterExpression.func(6, a, b);
            }
        }
        toLower(a) {
            return FilterExpression.func(7, a);
        }
        toUpper(a) {
            return FilterExpression.func(8, a);
        }
        trim(a) {
            return FilterExpression.func(9, a);
        }
        year(a) {
            return FilterExpression.func(16, a);
        }
        date(a) {
            return FilterExpression.func(20, a);
        }
        time(a) {
            return FilterExpression.func(21, a);
        }
        now() {
            return FilterExpression.func(16);
        }
        isOf(a, b) {
            return FilterExpression.func(16, a);
        }
        cast(a, b) {
            return FilterExpression.func(24, a);
        }
    }
    FilterFactory.$t = /*@__PURE__*/ markType(FilterFactory, 'FilterFactory');
    FilterFactory.as = null;
    return FilterFactory;
})();
/**
 * @hidden
 */
let FilterExpression = /*@__PURE__*/ (() => {
    class FilterExpression extends Base {
        constructor() {
            super(...arguments);
            this.bi = false;
            this._precedence = 0;
            this.bj = false;
        }
        get_precedence() {
            return this._precedence;
        }
        get precedence() {
            return this.get_precedence();
        }
        markAutoGenerated() {
            this.bj = true;
        }
        get isAutoGenerated() {
            return this.bj;
        }
        static isFilterExpression(a) {
            return typeCast(IFilterExpression_$type, a) !== null;
        }
        static isSchemaType(a) {
            return typeCast(DataSourceSchemaPropertyType_$type, a) !== null;
        }
        static operation(a, b, c) {
            if (FilterExpression.isFilterExpression(a)) {
                let d = a;
                if (FilterExpression.isFilterExpression(c)) {
                    let e = c;
                    return new OperationFilterExpression(d, b, e);
                }
                else {
                    return new OperationFilterExpression(d, b, c);
                }
            }
            else {
                let f = a;
                if (FilterExpression.isFilterExpression(c)) {
                    let g = c;
                    return new OperationFilterExpression(f, b, g);
                }
                else {
                    return new OperationFilterExpression(f, b, c);
                }
            }
        }
        static func(a, ...b) {
            return new FunctionFilterExpression(a, ...b);
        }
        bp() {
            this.bi = this.bn();
        }
        static property(a) {
            if (a == null) {
                return null;
            }
            let b = new PropertyReferenceFilterExpression(null);
            b.propertyReference = a;
            return b;
        }
        static nullLiteral() {
            let a = new LiteralFilterExpression(null, false);
            return a;
        }
        static literal(a) {
            let b = new LiteralFilterExpression(a, false);
            return b;
        }
        static unquotedLiteral(a) {
            let b = new LiteralFilterExpression(a, true);
            return b;
        }
        match(a, b, c) {
            let d = this.evaluate(a, b, c);
            return this.bo(d, b, c);
        }
        bo(a, b, c) {
            if (!this.bi) {
                return this.bk(a, b, c);
            }
            return a;
        }
        bk(a, b, c) {
            return Convert.toBoolean(a);
        }
        get_isPropertyReference() {
            return false;
        }
        get isPropertyReference() {
            return this.get_isPropertyReference();
        }
        get_isOperation() {
            return false;
        }
        get isOperation() {
            return this.get_isOperation();
        }
        get_isFunction() {
            return false;
        }
        get isFunction() {
            return this.get_isFunction();
        }
        get_isLiteral() {
            return false;
        }
        get isLiteral() {
            return this.get_isLiteral();
        }
        get_isNull() {
            return false;
        }
        get isNull() {
            return this.get_isNull();
        }
        get_isWrapper() {
            return false;
        }
        get isWrapper() {
            return this.get_isWrapper();
        }
        group() {
            return FilterExpression.operation(this, 15, null);
        }
        and(a) {
            return FilterExpression.operation(this, 7, a);
        }
        or(a) {
            return FilterExpression.operation(this, 8, a);
        }
        not() {
            return FilterExpression.operation(this, 9, null);
        }
        add(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 10, b);
            }
            else {
                return FilterExpression.operation(this, 10, a);
            }
        }
        plus(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 10, b);
            }
            else {
                return FilterExpression.operation(this, 10, a);
            }
        }
        divide(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 13, b);
            }
            else {
                return FilterExpression.operation(this, 13, a);
            }
        }
        divideBy(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 13, b);
            }
            else {
                return FilterExpression.operation(this, 13, a);
            }
        }
        isEqualTo(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 1, b);
            }
            else {
                return FilterExpression.operation(this, 1, a);
            }
        }
        isGreaterThan(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 3, b);
            }
            else {
                return FilterExpression.operation(this, 3, a);
            }
        }
        isGreaterThanOrEqualTo(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 4, b);
            }
            else {
                return FilterExpression.operation(this, 4, a);
            }
        }
        isLessThan(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 5, b);
            }
            else {
                return FilterExpression.operation(this, 5, a);
            }
        }
        isLessThanOrEqualTo(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 6, b);
            }
            else {
                return FilterExpression.operation(this, 6, a);
            }
        }
        modulo(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 14, b);
            }
            else {
                return FilterExpression.operation(this, 14, a);
            }
        }
        multiply(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 12, b);
            }
            else {
                return FilterExpression.operation(this, 12, a);
            }
        }
        times(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 12, b);
            }
            else {
                return FilterExpression.operation(this, 12, a);
            }
        }
        isNotEqualTo(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 2, b);
            }
            else {
                return FilterExpression.operation(this, 2, a);
            }
        }
        subtract(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 11, b);
            }
            else {
                return FilterExpression.operation(this, 11, a);
            }
        }
        minus(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 11, b);
            }
            else {
                return FilterExpression.operation(this, 11, a);
            }
        }
        ceiling() {
            return FilterExpression.func(19, this);
        }
        concat(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.func(10, this, b);
            }
            else {
                let c = a;
                return FilterExpression.func(10, this, FilterExpression.literal(c));
            }
        }
        contains(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.func(0, this, b);
            }
            else {
                let c = a;
                return FilterExpression.func(0, this, FilterExpression.literal(c));
            }
        }
        day() {
            return FilterExpression.func(11, this);
        }
        endsWith(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.func(1, this, b);
            }
            else {
                let c = a;
                return FilterExpression.func(1, this, FilterExpression.literal(c));
            }
        }
        floor() {
            return FilterExpression.func(18, this);
        }
        hour() {
            return FilterExpression.func(12, this);
        }
        indexOf(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.func(4, this, b);
            }
            else {
                let c = a;
                return FilterExpression.func(4, this, FilterExpression.literal(c));
            }
        }
        length() {
            return FilterExpression.func(FilterExpressionFunctionType.Length, this);
        }
        minute() {
            return FilterExpression.func(13, this);
        }
        month() {
            return FilterExpression.func(14, this);
        }
        isToday() {
            return new TodayExpression(1, this);
        }
        isTomorrow() {
            return new TomorrowExpression(1, this);
        }
        isYesterday() {
            return new YesterdayExpression(1, this);
        }
        isThisWeek() {
            return new ThisWeekExpression(1, this);
        }
        isNextWeek() {
            return new NextWeekExpression(1, this);
        }
        isLastWeek() {
            return new LastWeekExpression(1, this);
        }
        isThisMonth() {
            return new ThisMonthExpression(1, this);
        }
        isNextMonth() {
            return new NextMonthExpression(1, this);
        }
        isLastMonth() {
            return new LastMonthExpression(1, this);
        }
        isThisYear() {
            return new ThisYearExpression(1, this);
        }
        isNextYear() {
            return new NextYearExpression(1, this);
        }
        isLastYear() {
            return new LastYearExpression(1, this);
        }
        isYearToDate() {
            return new YearToDateExpression(1, this);
        }
        isThisQuarter() {
            return new ThisQuarterExpression(1, this);
        }
        isNextQuarter() {
            return new NextQuarterExpression(1, this);
        }
        isLastQuarter() {
            return new LastQuarterExpression(1, this);
        }
        isQ1() {
            return new Q1Expression(1, this);
        }
        isQ2() {
            return new Q2Expression(1, this);
        }
        isQ3() {
            return new Q3Expression(1, this);
        }
        isQ4() {
            return new Q4Expression(1, this);
        }
        replace(a, b) {
            if (FilterExpression.isFilterExpression(a)) {
                let c = a;
                if (FilterExpression.isFilterExpression(b)) {
                    let d = b;
                    return FilterExpression.func(5, this, c, d);
                }
                else {
                    let e = b;
                    return FilterExpression.func(5, this, c, FilterExpression.literal(e));
                }
            }
            else {
                let f = a;
                if (FilterExpression.isFilterExpression(b)) {
                    let g = b;
                    return FilterExpression.func(5, this, FilterExpression.literal(f), g);
                }
                else {
                    let h = b;
                    return FilterExpression.func(5, this, FilterExpression.literal(f), FilterExpression.literal(h));
                }
            }
        }
        round() {
            return FilterExpression.func(17, this);
        }
        second() {
            return FilterExpression.func(15, this);
        }
        startsWith(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.func(2, this, b);
            }
            else {
                let c = a;
                return FilterExpression.func(2, this, FilterExpression.literal(c));
            }
        }
        substring(a, b = null) {
            if (FilterExpression.isFilterExpression(a)) {
                let c = a;
                if (b == null) {
                    return FilterExpression.func(6, this, c);
                }
                else {
                    if (FilterExpression.isFilterExpression(b)) {
                        let d = b;
                        return FilterExpression.func(6, this, c, d);
                    }
                    else {
                        let e = typeGetValue(b);
                        return FilterExpression.func(6, this, c, FilterExpression.literal(e));
                    }
                }
            }
            else {
                let f = typeGetValue(a);
                if (b == null) {
                    return FilterExpression.func(6, this, FilterExpression.literal(f));
                }
                else {
                    if (FilterExpression.isFilterExpression(b)) {
                        let g = b;
                        return FilterExpression.func(6, this, FilterExpression.literal(f), g);
                    }
                    else {
                        let h = typeGetValue(b);
                        return FilterExpression.func(6, this, FilterExpression.literal(f), FilterExpression.literal(h));
                    }
                }
            }
        }
        toLower() {
            return FilterExpression.func(7, this);
        }
        toUpper() {
            return FilterExpression.func(8, this);
        }
        trim() {
            return FilterExpression.func(9, this);
        }
        year() {
            return FilterExpression.func(16, this);
        }
        date() {
            return FilterExpression.func(20, this);
        }
        time() {
            return FilterExpression.func(21, this);
        }
        now() {
            return FilterExpression.func(22);
        }
        isOf(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.func(23, this, b);
            }
            else {
                let c = a;
                return FilterExpression.func(23, this, FilterExpression.literal(a));
            }
        }
        cast(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.func(24, this, b);
            }
            else if (FilterExpression.isSchemaType(a)) {
                let c = EnumUtil.getEnumValue(DataSourceSchemaPropertyType_$type, a);
                return FilterExpression.func(24, this, FilterExpression.literal(enumGetBox(DataSourceSchemaPropertyType_$type, c)));
            }
            else {
                let d = a;
                return FilterExpression.func(24, this, FilterExpression.literal(d));
            }
        }
    }
    FilterExpression.$t = /*@__PURE__*/ markType(FilterExpression, 'FilterExpression', Base.$, [IFilterExpression_$type]);
    return FilterExpression;
})();
/**
 * @hidden
 */
let OperationFilterExpression = /*@__PURE__*/ (() => {
    class OperationFilterExpression extends FilterExpression {
        constructor(a, b, c) {
            super();
            this.br = null;
            this.bt = false;
            this.bs = null;
            this.bu = false;
            this.bq = 0;
            if (a != null) {
                if (FilterExpression.isFilterExpression(a)) {
                    this.br = a;
                }
                else {
                    this.propertyName = a;
                }
            }
            if (c != null) {
                if (FilterExpression.isFilterExpression(c)) {
                    this.bs = c;
                }
                else {
                    this.value = c;
                }
            }
            this.bq = b;
        }
        get_isOperation() {
            return true;
        }
        bn() {
            return this.b0;
        }
        get isComparisonOperation() {
            let a = this.operator;
            switch (a) {
                case 0:
                case 1:
                case 2:
                case 3:
                case 5:
                case 6:
                case 4: return true;
            }
            return false;
        }
        get propertyName() {
            if (this.br == null || !this.br.isPropertyReference) {
                return null;
            }
            return this.br.propertyReference;
        }
        set propertyName(a) {
            this.left = FilterExpression.property(a);
        }
        get hasPropertyName() {
            return this.br != null && this.br.isPropertyReference;
        }
        get value() {
            if (this.bs == null) {
                return null;
            }
            if (this.bs.isNull) {
                return null;
            }
            if (!this.bs.isLiteral) {
                return null;
            }
            return this.bs.literalValue;
        }
        set value(a) {
            if (a == null) {
                this.right = FilterExpression.nullLiteral();
                return;
            }
            this.right = FilterExpression.literal(a);
        }
        get hasValue() {
            return this.bs != null;
        }
        get left() {
            return this.br;
        }
        set left(a) {
            this.br = a;
            this.bt = true;
            this.bp();
        }
        get hasLeft() {
            return this.bt;
        }
        get right() {
            return this.bs;
        }
        set right(a) {
            this.bs = a;
            this.bu = true;
            this.bp();
        }
        get hasRight() {
            return this.bu;
        }
        get operator() {
            return this.bq;
        }
        set operator(a) {
            let b = enumGetBox(FilterExpressionOperatorType_$type, this.bq);
            let c = a;
            if (c == null) {
                a = 0;
            }
            if ((typeof c == "number")) {
                let d = typeGetValue(c);
                if ((EnumUtil.getName(FilterExpressionOperatorType_$type, d) == undefined)) {
                    a = 0;
                }
                a = d;
            }
            else {
                a = (typeGetValue(EnumUtil.parse(FilterExpressionOperatorType_$type, c, true)));
            }
            this.bq = a;
            this.bp();
        }
        get hasOperator() {
            return this.bq != 0;
        }
        get b0() {
            switch (this.operator) {
                case 7:
                case 1:
                case 3:
                case 4:
                case 5:
                case 6:
                case 9:
                case 2:
                case 8: return true;
            }
            return false;
        }
        get_precedence() {
            switch (this.operator) {
                case 15: return 0;
                case 9: return 4;
                case 12: return 6;
                case 13: return 7;
                case 14: return 8;
                case 10: return 9;
                case 11: return 10;
                case 5: return 11;
                case 3: return 12;
                case 6: return 13;
                case 4: return 14;
                case 1: return 16;
                case 2: return 17;
                case 7: return 18;
                case 8: return 19;
                case 0: return 99;
            }
            return 99;
        }
        evaluate(a, b, c) {
            switch (this.operator) {
                case 10:
                case 13:
                case 14:
                case 12:
                case 11: return this.b3(a, b, c);
                case 0:
                case 1:
                case 3:
                case 4:
                case 5:
                case 6:
                case 2: return this.b4(a, b, c);
                case 7:
                case 9:
                case 8: return this.b5(a, b, c);
                case 15: if (this.left != null) {
                    return this.left.evaluate(a, b, c);
                }
                else {
                    if (this.right == null) {
                        return null;
                    }
                    return this.right.evaluate(a, b, c);
                }
            }
            throw new NotImplementedException(0);
        }
        b4(a, b, c) {
            let d = null;
            let e = null;
            let f = -1;
            if (this.left != null) {
                d = this.left.evaluate(a, b, c);
            }
            if (this.right != null) {
                e = this.right.evaluate(a, b, c);
            }
            if (d == null && e == null) {
                f = 0;
            }
            let g = null;
            let h = null;
            if (typeCast(IComparable_$type, d) !== null) {
                g = d;
            }
            if (typeCast(IComparable_$type, e) !== null) {
                h = e;
            }
            if (typeof d === 'number' && isNaN_(d) || typeof e === 'number' && isNaN_(e) || typeof d === 'number' && isNaN_(d) || typeof e === 'number' && isNaN_(e)) {
                return false;
            }
            if (typeof d === 'number' && !(typeof e === 'number')) {
                e = OperationFilterExpression.b2(e);
            }
            if (typeof e === 'number' && !(typeof d === 'number')) {
                d = OperationFilterExpression.b2(d);
            }
            if (typeCast(Date_$type, d) !== null && typeCast(Date_$type, e) !== null) {
                switch (this.operator) {
                    case 1: return d.getTime() == e.getTime();
                    case 2: return d.getTime() != e.getTime();
                    case 3: return d.getTime() > e.getTime();
                    case 4: return d.getTime() >= e.getTime();
                    case 5: return d.getTime() < e.getTime();
                    case 6: return d.getTime() <= e.getTime();
                }
            }
            if (g != null) {
                if (e == null) {
                    f = CompareUtil.compareToObject(g, 0);
                    if (f == 0) {
                        f = -1;
                    }
                }
                else {
                    f = CompareUtil.compareToObject(g, e);
                }
            }
            else if (h != null) {
                if (d == null) {
                    let i = CompareUtil.compareToObject(h, 0);
                    if (i == 0) {
                        f = 1;
                    }
                    else {
                        f = 1;
                        if (i == 0) {
                            f = 0;
                        }
                        if (i > 0) {
                            f = -1;
                        }
                    }
                }
                else {
                    let j = CompareUtil.compareToObject(h, d);
                    f = 1;
                    if (j == 0) {
                        f = 0;
                    }
                    if (j > 0) {
                        f = -1;
                    }
                }
            }
            else {
                let k = null;
                let l = null;
                if (d != null) {
                    k = d.toString();
                }
                if (e != null) {
                    l = e.toString();
                }
                if (k != null) {
                    if (l == null) {
                        f = 1;
                    }
                    else {
                        f = stringCompareTo(k, l);
                    }
                }
                else if (l != null) {
                    if (k == null) {
                        f = -1;
                    }
                    else {
                        let m = stringCompareTo(l, k);
                        f = 1;
                        if (m == 0) {
                            f = 0;
                        }
                        if (m > 0) {
                            f = -1;
                        }
                    }
                }
                else {
                    f = 0;
                }
            }
            switch (this.operator) {
                case 0:
                case 1: return f == 0;
                case 3: return f > 0;
                case 4: return f >= 0;
                case 5: return f < 0;
                case 6: return f <= 0;
                case 2: return f != 0;
            }
            throw new InvalidOperationException(0);
        }
        static b2(a) {
            if (typeCast(Date_$type, a) !== null) {
                return a.getTime();
            }
            if (a == null) {
                return 0;
            }
            return a;
        }
        b5(a, b, c) {
            let d = null;
            let e = null;
            if (this.left != null) {
                d = this.left.evaluate(a, b, c);
            }
            if (this.right != null) {
                e = this.right.evaluate(a, b, c);
            }
            if (e == null && d == null) {
                return false;
            }
            if (e == null) {
                e = false;
            }
            if (d == null) {
                d = false;
            }
            switch (this.operator) {
                case 7: return d && e;
                case 9: if (this.left == null) {
                    return !e;
                }
                else {
                    return !d;
                }
                case 8: return d || e;
            }
            return false;
        }
        b3(a, b, c) {
            let d = null;
            let e = null;
            if (this.left != null) {
                d = this.left.evaluate(a, b, c);
            }
            if (this.right != null) {
                e = this.right.evaluate(a, b, c);
            }
            if (d == null) {
                return e;
            }
            if (e == null) {
                return d;
            }
            if (d == null && e == null) {
                return 0;
            }
            if (typeof d === 'number' || typeof e === 'number') {
                switch (this.operator) {
                    case 10: return d + e;
                    case 13: return d / e;
                    case 14: return d % e;
                    case 12: return d * e;
                    case 11: return d - e;
                }
            }
            if (typeof d === 'number' || typeof e === 'number') {
                switch (this.operator) {
                    case 10: return d + e;
                    case 13: return d / e;
                    case 14: return d % e;
                    case 12: return d * e;
                    case 11: return d - e;
                }
            }
            if (typeof d === 'number' || typeof e === 'number') {
                switch (this.operator) {
                    case 10: return d + e;
                    case 13: return d / e;
                    case 14: return d % e;
                    case 12: return d * e;
                    case 11: return d - e;
                }
            }
            if (typeof d === 'number' || typeof e === 'number') {
                switch (this.operator) {
                    case 10: return typeGetValue(d) + typeGetValue(e);
                    case 13: return intDivide(typeGetValue(d), typeGetValue(e));
                    case 14: return typeGetValue(d) % typeGetValue(e);
                    case 12: return typeGetValue(d) * typeGetValue(e);
                    case 11: return typeGetValue(d) - typeGetValue(e);
                }
            }
            if (typeof d === 'number' || typeof e === 'number') {
                switch (this.operator) {
                    case 10: return typeGetValue(d) + typeGetValue(e);
                    case 13: return intDivide(typeGetValue(d), typeGetValue(e));
                    case 14: return typeGetValue(d) % typeGetValue(e);
                    case 12: return typeGetValue(d) * typeGetValue(e);
                    case 11: return typeGetValue(d) - typeGetValue(e);
                }
            }
            if (typeof d === 'number' || typeof e === 'number') {
                switch (this.operator) {
                    case 10: return typeGetValue(d) + typeGetValue(e);
                    case 13: return intDivide(typeGetValue(d), typeGetValue(e));
                    case 14: return typeGetValue(d) % typeGetValue(e);
                    case 12: return typeGetValue(d) * typeGetValue(e);
                    case 11: return typeGetValue(d) - typeGetValue(e);
                }
            }
            if (typeof d === 'number' || typeof e === 'number') {
                switch (this.operator) {
                    case 10: return typeGetValue(d) + typeGetValue(e);
                    case 13: return intDivide(typeGetValue(d), typeGetValue(e));
                    case 14: return typeGetValue(d) % typeGetValue(e);
                    case 12: return typeGetValue(d) * typeGetValue(e);
                    case 11: return typeGetValue(d) - typeGetValue(e);
                }
            }
            throw new NotImplementedException(0);
        }
    }
    OperationFilterExpression.$t = /*@__PURE__*/ markType(OperationFilterExpression, 'OperationFilterExpression', FilterExpression.$, [IOperationFilterExpression_$type]);
    return OperationFilterExpression;
})();
/**
 * @hidden
 */
let FunctionFilterExpression = /*@__PURE__*/ (() => {
    class FunctionFilterExpression extends FilterExpression {
        constructor(a, ...b) {
            super();
            this.br = 19;
            this.bq = new FilterExpressionCollection();
            this.br = a;
            for (let c = 0; c < b.length; c++) {
                this.bq.add(b[c]);
            }
        }
        get_isFunction() {
            return true;
        }
        bn() {
            return this.bs;
        }
        get functionType() {
            return this.br;
        }
        set functionType(a) {
            let b = enumGetBox(FilterExpressionFunctionType_$type, this.br);
            let c = a;
            if (c == null) {
                a = 0;
            }
            if ((typeof c == "number")) {
                let d = typeGetValue(c);
                if ((EnumUtil.getName(FilterExpressionFunctionType_$type, d) == undefined)) {
                    a = 0;
                }
                a = d;
            }
            else {
                a = (typeGetValue(EnumUtil.parse(FilterExpressionFunctionType_$type, c, true)));
            }
            this.br = a;
            this.bp();
        }
        get bs() {
            switch (this.functionType) {
                case 1:
                case 2:
                case 0: return true;
            }
            return false;
        }
        get functionArguments() {
            return this.bq;
        }
        get hasFunctionArguments() {
            return this.bq.k.count > 0;
        }
        evaluate(a, b, c) {
            let d = null;
            let e = null;
            let f = null;
            let g = null;
            let h = this.functionArguments.k;
            if (h.count > 0) {
                for (let i = 0; i < h.count; i++) {
                    let j = null;
                    if (h.item(i) != null) {
                        j = h.item(i).evaluate(a, b, c);
                    }
                    switch (i) {
                        case 0:
                            d = j;
                            break;
                        case 1:
                            e = j;
                            break;
                        case 2:
                            f = j;
                            break;
                        case 3:
                            g = j;
                            break;
                    }
                    if (i > 3) {
                        break;
                    }
                }
            }
            switch (this.functionType) {
                case 19:
                    if (d == null) {
                        d = 0;
                    }
                    if (!(typeof d === 'number')) {
                        d = OperationFilterExpression.b2(d);
                    }
                    return Math.ceil(d);
                case 18:
                    if (d == null) {
                        d = 0;
                    }
                    if (!(typeof d === 'number')) {
                        d = OperationFilterExpression.b2(d);
                    }
                    return Math.floor(d);
                case 17:
                    if (d == null) {
                        d = 0;
                    }
                    if (typeof d === 'number') {
                        return Math.round(d);
                    }
                    if (!(typeof d === 'number')) {
                        d = OperationFilterExpression.b2(d);
                    }
                    return Math.round(d);
                case 11:
                    if (d == null) {
                        return 0;
                    }
                    return d.getDate();
                case 12:
                    if (d == null) {
                        return 0;
                    }
                    return d.getHours();
                case 13:
                    if (d == null) {
                        return 0;
                    }
                    return d.getMinutes();
                case 14:
                    if (d == null) {
                        return 0;
                    }
                    return dateGetMonth(d);
                case 16:
                    if (d == null) {
                        return 0;
                    }
                    return d.getFullYear();
                case 15:
                    if (d == null) {
                        return 0;
                    }
                    return d.getSeconds();
                case 20:
                    if (d == null) {
                        return 0;
                    }
                    return dateGetDate(d);
                case 21:
                    if (d == null) {
                        return 0;
                    }
                    return d;
                case 22: return dateNow();
                case 23:
                    let k = this.bv(e, f);
                    let l = d;
                    if (l == null) {
                        return true;
                    }
                    if (k == null) {
                        return false;
                    }
                    if (k.isAssignableFrom(getInstanceType(l))) {
                        return true;
                    }
                    return false;
                case 24:
                    let m = this.bv(e, d);
                    let n = d;
                    if (n == null) {
                        return null;
                    }
                    if (m == null) {
                        return null;
                    }
                    return this.bt(n, m);
                case 10:
                    if (d == null) {
                        d = "";
                    }
                    if (e == null) {
                        e = "";
                    }
                    return stringConcat(d, e);
                case 1:
                    if (d == null) {
                        d = "";
                    }
                    if (e == null) {
                        e = "";
                    }
                    return stringEndsWith(d, e);
                case 4:
                    if (d == null) {
                        d = "";
                    }
                    if (e == null) {
                        e = "";
                    }
                    return d.indexOf(e);
                case FilterExpressionFunctionType.Length:
                    if (d == null) {
                        d = "";
                    }
                    return d.length;
                case 5:
                    if (d == null) {
                        d = "";
                    }
                    if (e == null) {
                        e = "";
                    }
                    if (f == null) {
                        f = "";
                    }
                    return stringReplace(d, e, f);
                case 2:
                    if (d == null) {
                        d = "";
                    }
                    if (e == null) {
                        e = "";
                    }
                    return stringStartsWith(d, e);
                case 6:
                    if (d == null) {
                        d = "";
                    }
                    if (e == null) {
                        e = 0;
                    }
                    if (f != null) {
                        return d.substr(typeGetValue(e), typeGetValue(f));
                    }
                    else {
                        return d.substr(typeGetValue(e));
                    }
                case 0:
                    if (d == null) {
                        d = "";
                    }
                    if (e == null) {
                        e = "";
                    }
                    return stringContains(d, e);
                case 7:
                    if (d == null) {
                        d = "";
                    }
                    return d.toLowerCase();
                case 8:
                    if (d == null) {
                        d = "";
                    }
                    return d.toUpperCase();
                case 9:
                    if (d == null) {
                        d = "";
                    }
                    return d.trim();
            }
            throw new NotImplementedException(0);
        }
        get_precedence() {
            switch (this.functionType) {
                case 23: return 15;
                case 24: return 5;
            }
            return 2;
        }
        bt(a, b) {
            if (b == String_$type) {
                if (a == null) {
                    return "";
                }
                return a.toString();
            }
            else if (b == Number_$type || b == Number_$type || b == Number_$type) {
                return Convert.toInt321(a);
            }
            else if (b == Boolean_$type) {
                return Convert.toBoolean(a);
            }
            else if (b == Number_$type) {
                return Convert.toByte1(a);
            }
            else if (b == Date_$type) {
                return Convert.toDateTime(a);
            }
            else if (b == Number_$type || b == Number_$type) {
                return Convert.toInt64(a);
            }
            else if (b == Number_$type) {
                return Convert.toDecimal2(a);
            }
            else {
                return a;
            }
        }
        bv(a, b) {
            if (typeCast(DataSourceSchemaPropertyType_$type, a) !== null || typeof a === 'number') {
                let c = typeGetValue(a);
                switch (c) {
                    case 2: return Boolean_$type;
                    case 10: return Number_$type;
                    case 9: return Date_$type;
                    case 8: return Date_$type;
                    case 6: return Number_$type;
                    case 5: return Number_$type;
                    case 1: return Number_$type;
                    case 3: return Number_$type;
                    case 11:
                        if (b != null && typeof b === 'string') {
                            return this.bu(b);
                        }
                        return Base.$;
                    case 4: return Number_$type;
                    case 7: return Number_$type;
                    case 0: return String_$type;
                }
            }
            if (typeof a === 'string') {
                return this.bu(b);
            }
            return Base.$;
        }
        bu(a) {
            switch (a) {
                case "Edm.Boolean":
                case "Boolean":
                case "bool":
                case "boolean": return Boolean_$type;
                case "Edm.Byte":
                case "Byte":
                case "byte":
                case "Edm.SByte":
                case "SByte": return Number_$type;
                case "Edm.DateTimeOffset":
                case "DateTimeOffset": return Date_$type;
                case "Edm.DateTime":
                case "DateTime":
                case "Calendar":
                case "datetime":
                case "calendar":
                case "Edm.Time":
                case "Time":
                case "time": return Date_$type;
                case "Edm.Decimal":
                case "Decimal":
                case "decimal": return Number_$type;
                case "Edm.Double":
                case "Double":
                case "double": return Number_$type;
                case "Edm.Float":
                case "Float":
                case "float":
                case "Edm.Single":
                case "Single":
                case "single": return Number_$type;
                case "Edm.Int16":
                case "Int16":
                case "Short":
                case "short": return Number_$type;
                case "Edm.Int32":
                case "Int32":
                case "int":
                case "Integer": return Number_$type;
                case "Edm.Int64":
                case "Int64":
                case "long":
                case "Long": return Number_$type;
                case "Edm.String":
                case "String":
                case "string": return String_$type;
            }
            return Base.$;
        }
    }
    FunctionFilterExpression.$t = /*@__PURE__*/ markType(FunctionFilterExpression, 'FunctionFilterExpression', FilterExpression.$, [IFunctionFilterExpression_$type]);
    return FunctionFilterExpression;
})();
/**
 * @hidden
 */
let PropertyReferenceFilterExpression = /*@__PURE__*/ (() => {
    class PropertyReferenceFilterExpression extends FilterExpression {
        constructor(a) {
            super();
            this.bq = null;
            this.bq = a;
        }
        get_isPropertyReference() {
            return true;
        }
        get_precedence() {
            return 99;
        }
        bn() {
            return false;
        }
        get propertyReference() {
            return this.bq;
        }
        set propertyReference(a) {
            this.bq = a;
        }
        evaluate(a, b, c) {
            let d = b.getItemValue(a, this.propertyReference);
            return d;
        }
    }
    PropertyReferenceFilterExpression.$t = /*@__PURE__*/ markType(PropertyReferenceFilterExpression, 'PropertyReferenceFilterExpression', FilterExpression.$, [IPropertyReferenceFilterExpression_$type]);
    return PropertyReferenceFilterExpression;
})();
/**
 * @hidden
 */
let LiteralFilterExpression = /*@__PURE__*/ (() => {
    class LiteralFilterExpression extends FilterExpression {
        constructor(a, b) {
            super();
            this.br = null;
            this.bq = false;
            this.br = a;
        }
        get_precedence() {
            return 99;
        }
        get_isLiteral() {
            return true;
        }
        get_isNull() {
            return this.literalValue == null;
        }
        get literalValue() {
            return this.br;
        }
        set literalValue(a) {
            this.br = a;
        }
        get leaveUnquoted() {
            return this.bq;
        }
        set leaveUnquoted(a) {
            this.bq = a;
        }
        bn() {
            return typeCast(Boolean_$type, this.literalValue) !== null;
        }
        evaluate(a, b, c) {
            return this.literalValue;
        }
    }
    LiteralFilterExpression.$t = /*@__PURE__*/ markType(LiteralFilterExpression, 'LiteralFilterExpression', FilterExpression.$, [ILiteralFilterExpression_$type]);
    return LiteralFilterExpression;
})();
/**
 * @hidden
 */
let WrapperExpression = /*@__PURE__*/ (() => {
    class WrapperExpression extends FilterExpression {
        get innerExpression() {
            return this._innerExpression;
        }
        set innerExpression(a) {
            this._innerExpression = a;
        }
        get expression() {
            return this.bq;
        }
        set expression(a) {
            this.bq = a;
            this.bw = true;
        }
        get propertyName() {
            if (this.bq == null || !this.bq.isPropertyReference) {
                return null;
            }
            return this.bq.propertyReference;
        }
        set propertyName(a) {
            this.expression = FilterExpression.property(a);
        }
        get_isWrapper() {
            return true;
        }
        get_precedence() {
            return 99;
        }
        get bt() {
            return FilterFactory.instance;
        }
        constructor(a, ..._rest) {
            super();
            this.bq = null;
            this.bw = false;
            this._innerExpression = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        this.expression = FilterFactory.instance.property(c);
                        this.propertyName = c;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.expression = c;
                        if (this.expression.isPropertyReference) {
                            this.propertyName = this.expression.propertyReference;
                        }
                    }
                    break;
            }
        }
        bn() {
            return true;
        }
        evaluate(a, b, c) {
            if (this.innerExpression == null || this.bw) {
                this.innerExpression = this.bu();
                this.bw = false;
            }
            return this.innerExpression.evaluate(a, b, c);
        }
    }
    WrapperExpression.$t = /*@__PURE__*/ markType(WrapperExpression, 'WrapperExpression', FilterExpression.$);
    return WrapperExpression;
})();
/**
 * @hidden
 */
let TodayExpression = /*@__PURE__*/ (() => {
    class TodayExpression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 0;
        }
        bu() {
            let a = +(this.bt.todayOverride) != +(dateMinValue()) ? this.bt.todayOverride : dateGetDate(dateNow());
            let b = FilterFactory.instance.literal(dateGetMonth(a));
            let c = FilterFactory.instance.literal(a.getDate());
            let d = FilterFactory.instance.literal(a.getFullYear());
            return this.expression.month().isEqualTo(b).and(this.expression.day().isEqualTo(c)).and(this.expression.year().isEqualTo(d));
        }
    }
    TodayExpression.$t = /*@__PURE__*/ markType(TodayExpression, 'TodayExpression', WrapperExpression.$);
    return TodayExpression;
})();
/**
 * @hidden
 */
let TomorrowExpression = /*@__PURE__*/ (() => {
    class TomorrowExpression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 1;
        }
        bu() {
            let a = +(this.bt.todayOverride) != +(dateMinValue()) ? this.bt.todayOverride : dateGetDate(dateNow());
            a = dateAddDays(a, 1);
            let b = FilterFactory.instance.literal(dateGetMonth(a));
            let c = FilterFactory.instance.literal(a.getDate());
            let d = FilterFactory.instance.literal(a.getFullYear());
            return this.expression.month().isEqualTo(b).and(this.expression.day().isEqualTo(c)).and(this.expression.year().isEqualTo(d));
        }
    }
    TomorrowExpression.$t = /*@__PURE__*/ markType(TomorrowExpression, 'TomorrowExpression', WrapperExpression.$);
    return TomorrowExpression;
})();
/**
 * @hidden
 */
let YesterdayExpression = /*@__PURE__*/ (() => {
    class YesterdayExpression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 2;
        }
        bu() {
            let a = +(this.bt.todayOverride) != +(dateMinValue()) ? this.bt.todayOverride : dateGetDate(dateNow());
            a = dateAddDays(a, -1);
            let b = FilterFactory.instance.literal(dateGetMonth(a));
            let c = FilterFactory.instance.literal(a.getDate());
            let d = FilterFactory.instance.literal(a.getFullYear());
            return this.expression.month().isEqualTo(b).and(this.expression.day().isEqualTo(c)).and(this.expression.year().isEqualTo(d));
        }
    }
    YesterdayExpression.$t = /*@__PURE__*/ markType(YesterdayExpression, 'YesterdayExpression', WrapperExpression.$);
    return YesterdayExpression;
})();
/**
 * @hidden
 */
let OffsettableWeekExpression = /*@__PURE__*/ (() => {
    class OffsettableWeekExpression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                        this.by = 0;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                        this.by = 0;
                    }
                    break;
            }
        }
        bu() {
            let a = +(this.bt.todayOverride) != +(dateMinValue()) ? this.bt.todayOverride : dateGetDate(dateNow());
            a = dateAddDays(a, this.by);
            let b = dateAddDays(a, 0 - a.getDay());
            let c = dateAddDays(a, 6 - a.getDay());
            let d = false;
            let e = dateMinValue();
            let f = dateMinValue();
            let g = dateMinValue();
            let h = dateMinValue();
            for (let i = 0; i < 7; i++) {
                let j = dateAddDays(c, -i);
                if (j.getDate() == 1) {
                    if (i == 6) {
                        break;
                    }
                    d = true;
                    f = dateAddDays(j, -1);
                    e = dateAddDays(f, -(6 - i - 1));
                    g = j;
                    h = dateAddDays(j, i);
                    break;
                }
            }
            if (d) {
                let k = this.expression.year().isEqualTo(this.bt.literal(e.getFullYear())).and(this.expression.month().isEqualTo(this.bt.literal(dateGetMonth(e))));
                let l = null;
                if (f.getDate() - e.getDate() > 0) {
                    l = this.expression.day().isGreaterThanOrEqualTo(this.bt.literal(e.getDate())).and(this.expression.day().isLessThanOrEqualTo(this.bt.literal(f.getDate())));
                }
                else {
                    l = this.expression.day().isEqualTo(this.bt.literal(e.getDate()));
                }
                let m = k.and(l);
                let n = this.expression.year().isEqualTo(this.bt.literal(g.getFullYear())).and(this.expression.month().isEqualTo(this.bt.literal(dateGetMonth(g))));
                let o = null;
                if (h.getDate() - g.getDate() > 0) {
                    o = this.expression.day().isGreaterThanOrEqualTo(this.bt.literal(g.getDate())).and(this.expression.day().isLessThanOrEqualTo(this.bt.literal(h.getDate())));
                }
                else {
                    o = this.expression.day().isEqualTo(this.bt.literal(g.getDate()));
                }
                let p = n.and(o);
                return m.or(p);
            }
            let q = FilterFactory.instance.literal(dateGetMonth(a));
            let r = FilterFactory.instance.literal(a.getFullYear());
            let s = FilterFactory.instance.literal(b.getDate());
            let t = FilterFactory.instance.literal(c.getDate());
            return this.expression.year().isEqualTo(r).and(this.expression.month().isEqualTo(q)).and(this.expression.day().isGreaterThanOrEqualTo(s)).and(this.expression.day().isLessThanOrEqualTo(t));
        }
    }
    OffsettableWeekExpression.$t = /*@__PURE__*/ markType(OffsettableWeekExpression, 'OffsettableWeekExpression', WrapperExpression.$);
    return OffsettableWeekExpression;
})();
/**
 * @hidden
 */
let ThisWeekExpression = /*@__PURE__*/ (() => {
    class ThisWeekExpression extends OffsettableWeekExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 3;
        }
    }
    ThisWeekExpression.$t = /*@__PURE__*/ markType(ThisWeekExpression, 'ThisWeekExpression', OffsettableWeekExpression.$);
    return ThisWeekExpression;
})();
/**
 * @hidden
 */
let NextWeekExpression = /*@__PURE__*/ (() => {
    class NextWeekExpression extends OffsettableWeekExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                        this.by = 7;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                        this.by = 7;
                    }
                    break;
            }
        }
        getWrapperType() {
            return 4;
        }
    }
    NextWeekExpression.$t = /*@__PURE__*/ markType(NextWeekExpression, 'NextWeekExpression', OffsettableWeekExpression.$);
    return NextWeekExpression;
})();
/**
 * @hidden
 */
let LastWeekExpression = /*@__PURE__*/ (() => {
    class LastWeekExpression extends OffsettableWeekExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                        this.by = -7;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                        this.by = -7;
                    }
                    break;
            }
        }
        getWrapperType() {
            return 5;
        }
    }
    LastWeekExpression.$t = /*@__PURE__*/ markType(LastWeekExpression, 'LastWeekExpression', OffsettableWeekExpression.$);
    return LastWeekExpression;
})();
/**
 * @hidden
 */
let ThisMonthExpression = /*@__PURE__*/ (() => {
    class ThisMonthExpression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 6;
        }
        bu() {
            let a = +(this.bt.todayOverride) != +(dateMinValue()) ? this.bt.todayOverride : dateGetDate(dateNow());
            return this.expression.year().isEqualTo(this.bt.literal(a.getFullYear())).and(this.expression.month().isEqualTo(this.bt.literal(dateGetMonth(a))));
        }
    }
    ThisMonthExpression.$t = /*@__PURE__*/ markType(ThisMonthExpression, 'ThisMonthExpression', WrapperExpression.$);
    return ThisMonthExpression;
})();
/**
 * @hidden
 */
let NextMonthExpression = /*@__PURE__*/ (() => {
    class NextMonthExpression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 7;
        }
        bu() {
            let a = +(this.bt.todayOverride) != +(dateMinValue()) ? this.bt.todayOverride : dateGetDate(dateNow());
            a = dateAddMonths(a, 1);
            return this.expression.year().isEqualTo(this.bt.literal(a.getFullYear())).and(this.expression.month().isEqualTo(this.bt.literal(dateGetMonth(a))));
        }
    }
    NextMonthExpression.$t = /*@__PURE__*/ markType(NextMonthExpression, 'NextMonthExpression', WrapperExpression.$);
    return NextMonthExpression;
})();
/**
 * @hidden
 */
let LastMonthExpression = /*@__PURE__*/ (() => {
    class LastMonthExpression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 8;
        }
        bu() {
            let a = +(this.bt.todayOverride) != +(dateMinValue()) ? this.bt.todayOverride : dateGetDate(dateNow());
            a = dateAddMonths(a, -1);
            return this.expression.year().isEqualTo(this.bt.literal(a.getFullYear())).and(this.expression.month().isEqualTo(this.bt.literal(dateGetMonth(a))));
        }
    }
    LastMonthExpression.$t = /*@__PURE__*/ markType(LastMonthExpression, 'LastMonthExpression', WrapperExpression.$);
    return LastMonthExpression;
})();
/**
 * @hidden
 */
let ThisYearExpression = /*@__PURE__*/ (() => {
    class ThisYearExpression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 9;
        }
        bu() {
            let a = +(this.bt.todayOverride) != +(dateMinValue()) ? this.bt.todayOverride : dateGetDate(dateNow());
            return this.expression.year().isEqualTo(this.bt.literal(a.getFullYear()));
        }
    }
    ThisYearExpression.$t = /*@__PURE__*/ markType(ThisYearExpression, 'ThisYearExpression', WrapperExpression.$);
    return ThisYearExpression;
})();
/**
 * @hidden
 */
let NextYearExpression = /*@__PURE__*/ (() => {
    class NextYearExpression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 10;
        }
        bu() {
            let a = +(this.bt.todayOverride) != +(dateMinValue()) ? this.bt.todayOverride : dateGetDate(dateNow());
            a = dateAddYears(a, 1);
            return this.expression.year().isEqualTo(this.bt.literal(a.getFullYear()));
        }
    }
    NextYearExpression.$t = /*@__PURE__*/ markType(NextYearExpression, 'NextYearExpression', WrapperExpression.$);
    return NextYearExpression;
})();
/**
 * @hidden
 */
let LastYearExpression = /*@__PURE__*/ (() => {
    class LastYearExpression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 11;
        }
        bu() {
            let a = +(this.bt.todayOverride) != +(dateMinValue()) ? this.bt.todayOverride : dateGetDate(dateNow());
            a = dateAddYears(a, -1);
            return this.expression.year().isEqualTo(this.bt.literal(a.getFullYear()));
        }
    }
    LastYearExpression.$t = /*@__PURE__*/ markType(LastYearExpression, 'LastYearExpression', WrapperExpression.$);
    return LastYearExpression;
})();
/**
 * @hidden
 */
let YearToDateExpression = /*@__PURE__*/ (() => {
    class YearToDateExpression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 15;
        }
        bu() {
            let a = +(this.bt.todayOverride) != +(dateMinValue()) ? this.bt.todayOverride : dateGetDate(dateNow());
            return this.expression.year().isEqualTo(this.bt.literal(a.getFullYear())).and(this.expression.month().isEqualTo(this.bt.literal(dateGetMonth(a))).and(this.expression.day().isLessThanOrEqualTo(this.bt.literal(a.getDate()))).or(this.expression.month().isLessThan(this.bt.literal(dateGetMonth(a)))));
        }
    }
    YearToDateExpression.$t = /*@__PURE__*/ markType(YearToDateExpression, 'YearToDateExpression', WrapperExpression.$);
    return YearToDateExpression;
})();
/**
 * @hidden
 */
let ThisQuarterExpression = /*@__PURE__*/ (() => {
    class ThisQuarterExpression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 12;
        }
        bu() {
            let a = +(this.bt.todayOverride) != +(dateMinValue()) ? this.bt.todayOverride : dateGetDate(dateNow());
            let b = this.expression.year().isEqualTo(this.bt.literal(a.getFullYear()));
            if (dateGetMonth(a) == 1 || dateGetMonth(a) == 2 || dateGetMonth(a) == 3) {
                return b.and(this.expression.isQ1());
            }
            else if (dateGetMonth(a) == 4 || dateGetMonth(a) == 5 || dateGetMonth(a) == 6) {
                return b.and(this.expression.isQ2());
            }
            else if (dateGetMonth(a) == 7 || dateGetMonth(a) == 8 || dateGetMonth(a) == 9) {
                return b.and(this.expression.isQ3());
            }
            else {
                return b.and(this.expression.isQ4());
            }
        }
    }
    ThisQuarterExpression.$t = /*@__PURE__*/ markType(ThisQuarterExpression, 'ThisQuarterExpression', WrapperExpression.$);
    return ThisQuarterExpression;
})();
/**
 * @hidden
 */
let NextQuarterExpression = /*@__PURE__*/ (() => {
    class NextQuarterExpression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 13;
        }
        bu() {
            let a = +(this.bt.todayOverride) != +(dateMinValue()) ? this.bt.todayOverride : dateGetDate(dateNow());
            let b = this.expression.year().isEqualTo(this.bt.literal(a.getFullYear()));
            if (dateGetMonth(a) == 1 || dateGetMonth(a) == 2 || dateGetMonth(a) == 3) {
                return b.and(this.expression.isQ2());
            }
            else if (dateGetMonth(a) == 4 || dateGetMonth(a) == 5 || dateGetMonth(a) == 6) {
                return b.and(this.expression.isQ3());
            }
            else if (dateGetMonth(a) == 7 || dateGetMonth(a) == 8 || dateGetMonth(a) == 9) {
                return b.and(this.expression.isQ4());
            }
            else {
                return this.expression.year().isEqualTo(this.bt.literal(a.getFullYear() + 1)).and(this.expression.isQ1());
            }
        }
    }
    NextQuarterExpression.$t = /*@__PURE__*/ markType(NextQuarterExpression, 'NextQuarterExpression', WrapperExpression.$);
    return NextQuarterExpression;
})();
/**
 * @hidden
 */
let LastQuarterExpression = /*@__PURE__*/ (() => {
    class LastQuarterExpression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 13;
        }
        bu() {
            let a = +(this.bt.todayOverride) != +(dateMinValue()) ? this.bt.todayOverride : dateGetDate(dateNow());
            let b = this.expression.year().isEqualTo(this.bt.literal(a.getFullYear()));
            if (dateGetMonth(a) == 1 || dateGetMonth(a) == 2 || dateGetMonth(a) == 3) {
                return this.expression.year().isEqualTo(this.bt.literal(a.getFullYear() - 1)).and(this.expression.isQ4());
            }
            else if (dateGetMonth(a) == 4 || dateGetMonth(a) == 5 || dateGetMonth(a) == 6) {
                return b.and(this.expression.isQ1());
            }
            else if (dateGetMonth(a) == 7 || dateGetMonth(a) == 8 || dateGetMonth(a) == 9) {
                return b.and(this.expression.isQ2());
            }
            else {
                return b.and(this.expression.isQ3());
            }
        }
    }
    LastQuarterExpression.$t = /*@__PURE__*/ markType(LastQuarterExpression, 'LastQuarterExpression', WrapperExpression.$);
    return LastQuarterExpression;
})();
/**
 * @hidden
 */
let Q1Expression = /*@__PURE__*/ (() => {
    class Q1Expression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 16;
        }
        bu() {
            return this.expression.month().isEqualTo(this.bt.literal(1)).or(this.expression.month().isEqualTo(this.bt.literal(2))).or(this.expression.month().isEqualTo(this.bt.literal(3)));
        }
    }
    Q1Expression.$t = /*@__PURE__*/ markType(Q1Expression, 'Q1Expression', WrapperExpression.$);
    return Q1Expression;
})();
/**
 * @hidden
 */
let Q2Expression = /*@__PURE__*/ (() => {
    class Q2Expression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 17;
        }
        bu() {
            return this.expression.month().isEqualTo(this.bt.literal(4)).or(this.expression.month().isEqualTo(this.bt.literal(5))).or(this.expression.month().isEqualTo(this.bt.literal(6)));
        }
    }
    Q2Expression.$t = /*@__PURE__*/ markType(Q2Expression, 'Q2Expression', WrapperExpression.$);
    return Q2Expression;
})();
/**
 * @hidden
 */
let Q3Expression = /*@__PURE__*/ (() => {
    class Q3Expression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 18;
        }
        bu() {
            return this.expression.month().isEqualTo(this.bt.literal(7)).or(this.expression.month().isEqualTo(this.bt.literal(8))).or(this.expression.month().isEqualTo(this.bt.literal(9)));
        }
    }
    Q3Expression.$t = /*@__PURE__*/ markType(Q3Expression, 'Q3Expression', WrapperExpression.$);
    return Q3Expression;
})();
/**
 * @hidden
 */
let Q4Expression = /*@__PURE__*/ (() => {
    class Q4Expression extends WrapperExpression {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
        getWrapperType() {
            return 19;
        }
        bu() {
            return this.expression.month().isEqualTo(this.bt.literal(10)).or(this.expression.month().isEqualTo(this.bt.literal(11))).or(this.expression.month().isEqualTo(this.bt.literal(12)));
        }
    }
    Q4Expression.$t = /*@__PURE__*/ markType(Q4Expression, 'Q4Expression', WrapperExpression.$);
    return Q4Expression;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrLocalDataSourceModule {
    static register() {
        TypeRegistrar.register('LocalDataSource', LocalDataSource.$type);
        TypeRegistrar.register('LocalDataSource', LocalDataSource.$type);
        TypeRegistrar.register('LiteralFilterExpression', LiteralFilterExpression.$type);
        TypeRegistrar.register('LiteralFilterExpression', LiteralFilterExpression.$type);
        TypeRegistrar.register('PropertyReferenceFilterExpression', PropertyReferenceFilterExpression.$type);
        TypeRegistrar.register('PropertyReferenceFilterExpression', PropertyReferenceFilterExpression.$type);
        TypeRegistrar.register('OperationFilterExpression', OperationFilterExpression.$type);
        TypeRegistrar.register('OperationFilterExpression', OperationFilterExpression.$type);
        TypeRegistrar.register('FunctionFilterExpression', FunctionFilterExpression.$type);
        TypeRegistrar.register('FunctionFilterExpression', FunctionFilterExpression.$type);
    }
}

/**
 * Represents a colleciton of filter expressions.
*/
class IgrFilterExpressionCollection {
    createImplementation() {
        return new FilterExpressionCollection();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    item(index, value) {
        let filter = null;
        if (value !== undefined) {
            filter = this.set(index, value == null ? null : value);
        }
        else {
            filter = this.get(index);
        }
        return filter;
    }
    get count() {
        return this.i.size();
    }
    toArray() {
        let arr = [];
        for (let i = 0; i < this.count; i++) {
            arr[i] = this.item(i);
        }
        return arr;
    }
    *[Symbol.iterator]() {
        for (let i = 0; i < this.count; i++) {
            let item = this.item(i);
            if (item.externalObject) {
                item = item.externalObject;
            }
            yield item;
        }
    }
    get syncTarget() {
        const r = this.i.syncTarget;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrFilterExpressionCollection();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set syncTarget(v) {
        v == null ? this.i.syncTarget = null : this.i.syncTarget = v.i;
    }
    /**
     * Gets or sets whether this collection should detach the sync when the target collection changes.
    */
    get shouldDetachOnTargetChange() {
        return this.i.shouldDetachOnTargetChange;
    }
    set shouldDetachOnTargetChange(v) {
        this.i.shouldDetachOnTargetChange = ensureBool(v);
    }
    get onChanged() {
        return this.i.onChanged;
    }
    set onChanged(v) {
        this.i.onChanged = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.syncTarget != null && this.syncTarget.findByName && this.syncTarget.findByName(name)) {
            return this.syncTarget.findByName(name);
        }
        return null;
    }
    add(item) {
        let iv = this.i.add(item);
        return (iv);
    }
    insert(index, item) {
        this.i.insert(index, item);
    }
    clear() {
        this.i.clear();
    }
    get(index) {
        let iv = this.i.get(index);
        return (iv);
    }
    indexOf(item) {
        let iv = this.i.indexOf(item);
        return (iv);
    }
    remove(item) {
        let iv = this.i.remove(item);
        return (iv);
    }
    removeAt(index) {
        let iv = this.i.removeAt(index);
        return (iv);
    }
    set(index, value) {
        let iv = this.i.set(index, value);
        return (iv);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterSyntaxToken = /*@__PURE__*/ (() => {
    class FilterSyntaxToken extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = null;
        }
    }
    FilterSyntaxToken.$t = /*@__PURE__*/ markType(FilterSyntaxToken, 'FilterSyntaxToken');
    return FilterSyntaxToken;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterSyntaxLexer = /*@__PURE__*/ (() => {
    class FilterSyntaxLexer extends Base {
        constructor() {
            super();
        }
        e(a) {
            let b = 0;
            let c = a.length;
            let d = new List$1(FilterSyntaxToken.$, 0);
            while (b < c) {
                b = this.f(d, b, c, a);
            }
            return d;
        }
        f(a, b, c, d) {
            while (b < c && this.d(d.charAt(b))) {
                b++;
            }
            if (b > (c - 1)) {
                return b;
            }
            let e = d.charAt(b);
            if (e == '{') {
                a.add(((() => {
                    let $ret = new FilterSyntaxToken();
                    $ret.a = 14;
                    return $ret;
                })()));
                return b + 1;
            }
            if (e == '}') {
                a.add(((() => {
                    let $ret = new FilterSyntaxToken();
                    $ret.a = 15;
                    return $ret;
                })()));
                return b + 1;
            }
            if (e == '(') {
                a.add(((() => {
                    let $ret = new FilterSyntaxToken();
                    $ret.a = 10;
                    return $ret;
                })()));
                return b + 1;
            }
            if (e == ')') {
                a.add(((() => {
                    let $ret = new FilterSyntaxToken();
                    $ret.a = 11;
                    return $ret;
                })()));
                return b + 1;
            }
            if (e == '[') {
                a.add(((() => {
                    let $ret = new FilterSyntaxToken();
                    $ret.a = 12;
                    return $ret;
                })()));
                return b + 1;
            }
            if (e == ']') {
                a.add(((() => {
                    let $ret = new FilterSyntaxToken();
                    $ret.a = 13;
                    return $ret;
                })()));
                return b + 1;
            }
            if (e == ':') {
                a.add(((() => {
                    let $ret = new FilterSyntaxToken();
                    $ret.a = 18;
                    return $ret;
                })()));
                return b + 1;
            }
            if (e == ',') {
                a.add(((() => {
                    let $ret = new FilterSyntaxToken();
                    $ret.a = 6;
                    return $ret;
                })()));
                return b + 1;
            }
            if (e == '.') {
                a.add(((() => {
                    let $ret = new FilterSyntaxToken();
                    $ret.a = 17;
                    return $ret;
                })()));
                return b + 1;
            }
            if (e == '\'') {
                let f = "";
                let g = b;
                let h = false;
                for (g = b + 1; g < c; g++) {
                    if (d.charAt(g) == '\\') {
                        if (g + 1 < c && d.charAt(g + 1) == '\'') {
                            g++;
                        }
                        else {
                        }
                    }
                    else if (d.charAt(g) == '\'' && g + 1 < c && d.charAt(g + 1) == '\'') {
                        g++;
                    }
                    else if (d.charAt(g) == '\'') {
                        h = true;
                        break;
                    }
                    else {
                    }
                }
                if (!h) {
                    throw new InvalidOperationException(1, "missing end quote for string starting at position: " + b);
                }
                else {
                    f = d.substr(b + 1, (g - 1) - b);
                    b = g + 1;
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 2;
                        $ret.b = f;
                        return $ret;
                    })()));
                }
                return b;
            }
            if ((e == 't' || e == 'T') && (b + ("true").length) < c && d.substr(b, ("true").length).toLowerCase() == "true") {
                b += ("true").length;
                a.add(((() => {
                    let $ret = new FilterSyntaxToken();
                    $ret.a = 72;
                    $ret.b = true;
                    return $ret;
                })()));
                return b;
            }
            if ((e == 'f' || e == 'F') && (b + ("false").length) < c && d.substr(b, ("false").length).toLowerCase() == "false") {
                b += ("false").length;
                a.add(((() => {
                    let $ret = new FilterSyntaxToken();
                    $ret.a = 73;
                    $ret.b = false;
                    return $ret;
                })()));
                return b;
            }
            if ((e == 'n' || e == 'N') && (b + ("null").length) < c && d.substr(b, ("null").length).toLowerCase() == "null") {
                b += ("null").length;
                a.add(((() => {
                    let $ret = new FilterSyntaxToken();
                    $ret.a = 71;
                    return $ret;
                })()));
                return b;
            }
            if ((e == '-' && (b + 1 < c) && this.c(d.charAt(b + 1))) || this.c(e)) {
                let i = this.h(e, b, c, d);
                let j = this.g(e, b, c, d);
                let k = this.i(e, b, c, d);
                if (i >= 0) {
                    let l = d.substr(b, (i - b) + 1);
                    let m = dateParse(l, CultureInfo.invariantCulture);
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 3;
                        $ret.b = m;
                        return $ret;
                    })()));
                    return i + 1;
                }
                else if (j >= 0) {
                    let n = d.substr(b, (j - b) + 1);
                    let o = dateParse(n);
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 3;
                        $ret.b = o;
                        return $ret;
                    })()));
                    return j + 1;
                }
                else if (k >= 0) {
                    let p = d.substr(b, (j - b) + 1);
                    let q = dateParseExact(p, "hh:mm:ss.FFFFFFFFFFFF", CultureInfo.invariantCulture);
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 5;
                        $ret.b = q;
                        return $ret;
                    })()));
                    return k + 1;
                }
                else {
                    let r = b;
                    let s = true;
                    let t = false;
                    let u = false;
                    let v = "";
                    let w = false;
                    if (e == '-') {
                        v += e;
                        r++;
                    }
                    while (r < c) {
                        let x = d.charAt(r);
                        if (u) {
                            if (x == '-') {
                                v += x;
                                r++;
                            }
                            if (x == '+') {
                                v += x;
                                r++;
                            }
                            if (r < c) {
                                x = d.charAt(r);
                            }
                            if (!this.c(x)) {
                                w = true;
                                break;
                            }
                            else {
                                v += x;
                                r++;
                            }
                        }
                        else if (t) {
                            if (x == 'e' || x == 'E') {
                                v += x;
                                r++;
                                u = true;
                                continue;
                            }
                            if (!this.c(x)) {
                                w = true;
                                break;
                            }
                            else {
                                v += x;
                                r++;
                            }
                        }
                        else if (s) {
                            if (x == '.') {
                                v += x;
                                r++;
                                t = true;
                                continue;
                            }
                            if (x == 'e' || x == 'E') {
                                v += x;
                                r++;
                                u = true;
                                continue;
                            }
                            if (!this.c(x)) {
                                w = true;
                                break;
                            }
                            else {
                                v += x;
                                r++;
                            }
                        }
                    }
                    if (r >= c - 1) {
                        w = true;
                    }
                    if (!w) {
                        if (v.charAt(v.length - 1) == 'E' || v.charAt(v.length - 1) == 'e' || v.charAt(v.length - 1) == '.') {
                            throw new InvalidOperationException(1, "expected end of number starting at: " + b);
                        }
                    }
                    else {
                        b = r;
                        if (stringContains(v, ".") || stringContains(v, "E") || stringContains(v, "e")) {
                            a.add(((() => {
                                let $ret = new FilterSyntaxToken();
                                $ret.a = 1;
                                $ret.b = parseNumber1(v, 167);
                                return $ret;
                            })()));
                        }
                        else {
                            a.add(((() => {
                                let $ret = new FilterSyntaxToken();
                                $ret.a = 0;
                                $ret.b = truncate(parseNumber1(v, 7));
                                return $ret;
                            })()));
                        }
                    }
                    return b;
                }
            }
            if (this.a(e)) {
                let y = "";
                let z = b;
                let aa = false;
                for (z = b; z < c; z++) {
                    if (d.charAt(z) == '\r' || d.charAt(z) == '\n') {
                        aa = true;
                        break;
                    }
                    if (this.d(d.charAt(z))) {
                        aa = true;
                        break;
                    }
                    if (d.charAt(z) == ':') {
                        aa = true;
                        break;
                    }
                    if (!this.b(d.charAt(z))) {
                        aa = true;
                        break;
                    }
                    else {
                        y += d.charAt(z);
                    }
                }
                if (z >= c - 1) {
                    aa = true;
                }
                if (!aa) {
                    throw new InvalidOperationException(1, "invalidly formed identifier starting at position: " + b);
                }
                else {
                    b = z;
                    this.k(a, y);
                }
                return b;
            }
            throw new InvalidOperationException(1, "unexpected character: " + e + " at position: " + b);
        }
        i(a, b, c, d) {
            if (this.c(a) && (b + 1) < c && this.c(d.charAt(b + 1)) && (b + 2) < c && (d.charAt(b + 2) == ':') && (b + 3) < c && this.c(d.charAt(b + 3)) && (b + 4) < c && this.c(d.charAt(b + 4))) {
                if ((b + 5) < c && (d.charAt(b + 5) == ':')) {
                    if ((b + 6) < c && this.c(d.charAt(b + 6)) && (b + 7) < c && this.c(d.charAt(b + 7))) {
                        if ((b + 8) < c && (d.charAt(b + 8) == '.')) {
                            if ((b + 9) < c && this.c(d.charAt(b + 9))) {
                                let e = 0;
                                while (e < 12) {
                                    let f = b + 9 + e;
                                    if (f >= c) {
                                        break;
                                    }
                                    if (!this.c(d.charAt(f))) {
                                        break;
                                    }
                                    e++;
                                }
                                if (e > 12) {
                                    return -1;
                                }
                                return b + 9 + (e - 1);
                            }
                        }
                        else {
                            return b + 7;
                        }
                    }
                }
                else {
                    return b + 4;
                }
            }
            return -1;
        }
        h(a, b, c, d) {
            if (this.g(a, b, c, d) >= 0) {
                if ((b + 10) < c && (d.charAt(b + 10) == 'T')) {
                    if (b + 11 < c) {
                        let e = this.i(d.charAt(b + 11), b + 11, c, d);
                        if (e >= 0) {
                            if (e + 1 < c && (d.charAt(e + 1) == 'Z' || d.charAt(e + 1) == '+' || d.charAt(e + 1) == '-')) {
                                e = this.j(d.charAt(e + 1), e + 1, c, d);
                            }
                        }
                        return e;
                    }
                }
            }
            return -1;
        }
        j(a, b, c, d) {
            if (a == 'Z') {
                return b;
            }
            else if (a == '+' || a == '-') {
                return ((b + 1) < c && this.c(d.charAt(b + 1)) && (b + 2) < c && this.c(d.charAt(b + 2)) && (b + 3) < c && (d.charAt(b + 3) == ':') && (b + 5) < c && this.c(d.charAt(b + 5)) && (b + 6) < c && this.c(d.charAt(b + 6))) ? b + 6 : -1;
            }
            return -1;
        }
        g(a, b, c, d) {
            return (this.c(a) && (b + 1) < c && this.c(d.charAt(b + 1)) && (b + 2) < c && this.c(d.charAt(b + 2)) && (b + 3) < c && this.c(d.charAt(b + 3)) && (b + 4) < c && (d.charAt(b + 4) == '-') && (b + 5) < c && this.c(d.charAt(b + 5)) && (b + 6) < c && this.c(d.charAt(b + 6)) && (b + 7) < c && (d.charAt(b + 7) == '-') && (b + 8) < c && this.c(d.charAt(b + 8)) && (b + 9) < c && this.c(d.charAt(b + 9))) ? b + 9 : -1;
        }
        k(a, b) {
            switch (b) {
                case "substringof":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 20;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "startswith":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 21;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "endswith":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 22;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "length":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 24;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "replace":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 23;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "indexof":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 25;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "substring":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 26;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "contains":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 27;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "tolower":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 28;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "toupper":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 29;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "trim":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 30;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "concat":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 31;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "year":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 32;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "month":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 33;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "day":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 34;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "days":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 35;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "hour":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 36;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "hours":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 37;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "minute":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 38;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "minutes":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 39;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "second":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 40;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "seconds":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 41;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "date":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 42;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "time":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 43;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "round":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 44;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "floor":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 45;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "ceiling":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 46;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "fractionalseconds":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 47;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "totaloffsetminutes":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 48;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "mindatetime":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 49;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "maxdatetime":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 50;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "now":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 51;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "and":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 52;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "or":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 53;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "eq":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 54;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "ne":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 55;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "lt":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 56;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "le":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 57;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "gt":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 58;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "ge":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 59;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "has":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 60;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "add":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 61;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "sub":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 62;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "mul":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 63;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "div":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 64;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "mod":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 65;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "not":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 66;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "isof":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 67;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "cast":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 68;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "NaN":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 69;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
                case "infinity":
                    a.add(((() => {
                        let $ret = new FilterSyntaxToken();
                        $ret.a = 70;
                        $ret.b = b;
                        return $ret;
                    })()));
                    return;
            }
            a.add(((() => {
                let $ret = new FilterSyntaxToken();
                $ret.a = 74;
                $ret.b = b;
                return $ret;
            })()));
        }
        b(a) {
            return isLetterOrDigit(a);
        }
        a(a) {
            return isLetter(a);
        }
        c(a) {
            return a == '0' || a == '1' || a == '2' || a == '3' || a == '4' || a == '5' || a == '6' || a == '7' || a == '8' || a == '9';
        }
        d(a) {
            return a == '\r' || a == '\n' || a == ' ' || a == '\t';
        }
    }
    FilterSyntaxLexer.$t = /*@__PURE__*/ markType(FilterSyntaxLexer, 'FilterSyntaxLexer');
    return FilterSyntaxLexer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterSyntaxTokenType_$type = /*@__PURE__*/ markEnum('FilterSyntaxTokenType', 'IntegerLiteral,0|FloatingPointLiteral,1|StringLiteral,2|DateTimeLiteral,3|DateTimeOffsetLiteral,4|TimeLiteral,5|Comma,6|Equals,7|Plus,8|Minus,9|OpenParen,10|CloseParen,11|OpenBracket,12|CloseBracket,13|OpenCurlyBrace,14|CloseCurlyBrace,15|Slash,16|Dot,17|Colon,18|Percent,19|SubStringOfToken,20|StartsWithToken,21|EndsWithToken,22|ReplaceToken,23|LengthToken,24|IndexOfToken,25|SubstringToken,26|ContainsToken,27|ToLowerToken,28|ToUpperToken,29|TrimToken,30|ConcatToken,31|YearToken,32|MonthToken,33|DayToken,34|DaysToken,35|HourToken,36|HoursToken,37|MinuteToken,38|MinutesToken,39|SecondToken,40|SecondsToken,41|DateToken,42|TimeToken,43|RoundToken,44|FloorToken,45|CeilingToken,46|FractionalSecondsToken,47|TotalOffsetMinutesToken,48|MinDateTimeToken,49|MaxDateTimeToken,50|NowToken,51|AndToken,52|OrToken,53|EqToken,54|NeToken,55|LtToken,56|LeToken,57|GtToken,58|GeToken,59|HasToken,60|AddToken,61|SubToken,62|MulToken,63|DivToken,64|ModToken,65|NotToken,66|IsOfToken,67|CastToken,68|NotANumber,69|Infinity,70|NullToken,71|TrueToken,72|FalseToken,73|Identifier,74');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterSyntaxParseResult = /*@__PURE__*/ (() => {
    class FilterSyntaxParseResult extends Base {
        constructor() {
            super();
            this.a = null;
            this.d = 0;
            this.c = null;
            this.c = new List$1(String_$type, 0);
        }
        get b() {
            return this.c.count > 0;
        }
        get e() {
            return stringJoin1(String_$type, "\r\n", this.c);
        }
    }
    FilterSyntaxParseResult.$t = /*@__PURE__*/ markType(FilterSyntaxParseResult, 'FilterSyntaxParseResult');
    return FilterSyntaxParseResult;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterSyntaxExpressionSyntax = /*@__PURE__*/ (() => {
    class FilterSyntaxExpressionSyntax extends Base {
    }
    FilterSyntaxExpressionSyntax.$t = /*@__PURE__*/ markType(FilterSyntaxExpressionSyntax, 'FilterSyntaxExpressionSyntax');
    return FilterSyntaxExpressionSyntax;
})();
/**
 * @hidden
 */
let FilterSyntaxPrimitiveValueExpressionSyntax = /*@__PURE__*/ (() => {
    class FilterSyntaxPrimitiveValueExpressionSyntax extends FilterSyntaxExpressionSyntax {
        constructor() {
            super(...arguments);
            this.b = 0;
            this.c = null;
        }
        a(a) {
            a.i(this);
        }
    }
    FilterSyntaxPrimitiveValueExpressionSyntax.$t = /*@__PURE__*/ markType(FilterSyntaxPrimitiveValueExpressionSyntax, 'FilterSyntaxPrimitiveValueExpressionSyntax', FilterSyntaxExpressionSyntax.$);
    return FilterSyntaxPrimitiveValueExpressionSyntax;
})();
/**
 * @hidden
 */
let FilterSyntaxNullExpressionSyntax = /*@__PURE__*/ (() => {
    class FilterSyntaxNullExpressionSyntax extends FilterSyntaxExpressionSyntax {
        constructor() {
            super(...arguments);
            this.b = 0;
            this.c = null;
        }
        a(a) {
            a.g(this);
        }
    }
    FilterSyntaxNullExpressionSyntax.$t = /*@__PURE__*/ markType(FilterSyntaxNullExpressionSyntax, 'FilterSyntaxNullExpressionSyntax', FilterSyntaxExpressionSyntax.$);
    return FilterSyntaxNullExpressionSyntax;
})();
/**
 * @hidden
 */
let FilterSyntaxParenthesisExpressionSyntax = /*@__PURE__*/ (() => {
    class FilterSyntaxParenthesisExpressionSyntax extends FilterSyntaxExpressionSyntax {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        a(a) {
            a.h(this);
        }
    }
    FilterSyntaxParenthesisExpressionSyntax.$t = /*@__PURE__*/ markType(FilterSyntaxParenthesisExpressionSyntax, 'FilterSyntaxParenthesisExpressionSyntax', FilterSyntaxExpressionSyntax.$);
    return FilterSyntaxParenthesisExpressionSyntax;
})();
/**
 * @hidden
 */
let FilterSyntaxBinaryOperatorExpressionSyntax = /*@__PURE__*/ (() => {
    class FilterSyntaxBinaryOperatorExpressionSyntax extends FilterSyntaxExpressionSyntax {
        constructor() {
            super(...arguments);
            this.d = 0;
            this.b = null;
            this.c = null;
        }
        a(a) {
            a.c(this);
        }
    }
    FilterSyntaxBinaryOperatorExpressionSyntax.$t = /*@__PURE__*/ markType(FilterSyntaxBinaryOperatorExpressionSyntax, 'FilterSyntaxBinaryOperatorExpressionSyntax', FilterSyntaxExpressionSyntax.$);
    return FilterSyntaxBinaryOperatorExpressionSyntax;
})();
/**
 * @hidden
 */
let FilterSyntaxMemberExpressionSyntax = /*@__PURE__*/ (() => {
    class FilterSyntaxMemberExpressionSyntax extends FilterSyntaxExpressionSyntax {
        constructor() {
            super(...arguments);
            this.b = null;
            this.c = null;
        }
        a(a) {
            a.e(this);
        }
    }
    FilterSyntaxMemberExpressionSyntax.$t = /*@__PURE__*/ markType(FilterSyntaxMemberExpressionSyntax, 'FilterSyntaxMemberExpressionSyntax', FilterSyntaxExpressionSyntax.$);
    return FilterSyntaxMemberExpressionSyntax;
})();
/**
 * @hidden
 */
let FilterSyntaxMethodCallExpressionSyntax = /*@__PURE__*/ (() => {
    class FilterSyntaxMethodCallExpressionSyntax extends FilterSyntaxExpressionSyntax {
        constructor() {
            super(...arguments);
            this.c = null;
            this.b = null;
        }
        a(a) {
            a.f(this);
        }
    }
    FilterSyntaxMethodCallExpressionSyntax.$t = /*@__PURE__*/ markType(FilterSyntaxMethodCallExpressionSyntax, 'FilterSyntaxMethodCallExpressionSyntax', FilterSyntaxExpressionSyntax.$);
    return FilterSyntaxMethodCallExpressionSyntax;
})();
/**
 * @hidden
 */
let FilterSyntaxIdentifierExpressionSyntax = /*@__PURE__*/ (() => {
    class FilterSyntaxIdentifierExpressionSyntax extends FilterSyntaxExpressionSyntax {
        constructor() {
            super(...arguments);
            this.b = 0;
            this.c = null;
        }
        a(a) {
            a.d(this);
        }
    }
    FilterSyntaxIdentifierExpressionSyntax.$t = /*@__PURE__*/ markType(FilterSyntaxIdentifierExpressionSyntax, 'FilterSyntaxIdentifierExpressionSyntax', FilterSyntaxExpressionSyntax.$);
    return FilterSyntaxIdentifierExpressionSyntax;
})();
/**
 * @hidden
 */
let FilterSyntaxUnaryOperatorExpressionSyntax = /*@__PURE__*/ (() => {
    class FilterSyntaxUnaryOperatorExpressionSyntax extends FilterSyntaxExpressionSyntax {
        constructor() {
            super(...arguments);
            this.c = 0;
            this.b = null;
        }
        a(a) {
            a.j(this);
        }
    }
    FilterSyntaxUnaryOperatorExpressionSyntax.$t = /*@__PURE__*/ markType(FilterSyntaxUnaryOperatorExpressionSyntax, 'FilterSyntaxUnaryOperatorExpressionSyntax', FilterSyntaxExpressionSyntax.$);
    return FilterSyntaxUnaryOperatorExpressionSyntax;
})();
/**
 * @hidden
 */
let FilterSyntaxVisitor = /*@__PURE__*/ (() => {
    class FilterSyntaxVisitor extends Base {
        constructor() {
            super();
        }
        b(a) {
            a.a(this);
        }
        a(a) {
        }
        j(a) {
            this.a(a);
        }
        c(a) {
            this.a(a);
        }
        d(a) {
            this.a(a);
        }
        e(a) {
            this.a(a);
        }
        f(a) {
            this.a(a);
        }
        g(a) {
            this.a(a);
        }
        h(a) {
            this.a(a);
        }
        i(a) {
            this.a(a);
        }
    }
    FilterSyntaxVisitor.$t = /*@__PURE__*/ markType(FilterSyntaxVisitor, 'FilterSyntaxVisitor');
    return FilterSyntaxVisitor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterSyntaxParser = /*@__PURE__*/ (() => {
    class FilterSyntaxParser extends Base {
        d(a) {
            let b = new FilterSyntaxLexer();
            let c = b.e(a);
            let d = this.t(c);
            if (d.d != c.count) {
                this.ao(d, "content past expected end at: " + d.d);
            }
            return d;
        }
        ao(a, b) {
            a.c.add(b);
        }
        a(a, b) {
            let c = ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.d = b;
                return $ret;
            })());
            c.c.add(a);
            return c;
        }
        t(a) {
            let b = 0;
            let c = a.count;
            return this.i(a, b, c, 0);
        }
        b(a, b, c, d) {
            if (b > c - 1) {
                return this.a("expected op", b);
            }
            if (!this.v(a, b, c)) {
                return this.a("expected op", b);
            }
            let e = a._inner[b];
            let f = this.am(a, b, c);
            if (e.a == 10) {
                return this.l(a, b, c, d);
            }
            b++;
            let g = this.i(a, b, c, f);
            if (g.b) {
                return g;
            }
            b = g.d;
            return ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.a = ((() => {
                    let $ret = new FilterSyntaxBinaryOperatorExpressionSyntax();
                    $ret.b = d;
                    $ret.d = e.a;
                    $ret.c = g.a;
                    return $ret;
                })());
                $ret.d = b;
                return $ret;
            })());
        }
        c(a, b, c) {
            if (b > c - 1) {
                return this.a("expected op or expression", b);
            }
            if (this.w(a, b, c)) {
                let d = a._inner[b];
                let e = this.am(a, b, c);
                b++;
                let f = this.i(a, b, c, e);
                if (f.b) {
                    return f;
                }
                b = f.d;
                return ((() => {
                    let $ret = new FilterSyntaxParseResult();
                    $ret.a = ((() => {
                        let $ret = new FilterSyntaxUnaryOperatorExpressionSyntax();
                        $ret.c = d.a;
                        $ret.b = f.a;
                        return $ret;
                    })());
                    $ret.d = b;
                    return $ret;
                })());
            }
            else if (this.u(a, b, c, 10)) {
                b++;
                let g = this.i(a, b, c, 0);
                if (g.b) {
                    return g;
                }
                b = g.d;
                if (this.u(a, b, c, 11)) {
                    b++;
                }
                return ((() => {
                    let $ret = new FilterSyntaxParseResult();
                    $ret.a = ((() => {
                        let $ret = new FilterSyntaxParenthesisExpressionSyntax();
                        $ret.b = g.a;
                        return $ret;
                    })());
                    $ret.d = b;
                    return $ret;
                })());
            }
            else {
                if (this.ae(a, b, c)) {
                    return this.m(a, b, c);
                }
                else if (this.ac(a, b, c)) {
                    return this.k(a, b, c);
                }
                else if (this.aj(a, b, c)) {
                    return this.r(a, b, c);
                }
            }
            return this.a("expected lhs for expression", b);
        }
        i(a, b, c, d = 0) {
            let e = this.c(a, b, c);
            if (e.b) {
                return e;
            }
            b = e.d;
            while (this.am(a, b, c) > d) {
                e = this.b(a, b, c, e.a);
                if (e.b) {
                    return e;
                }
                b = e.d;
            }
            return ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.a = e.a;
                $ret.d = b;
                return $ret;
            })());
        }
        am(a, b, c) {
            if (b >= c) {
                return 0;
            }
            let d = a._inner[b].a;
            switch (d) {
                case 52: return 20;
                case 53: return 10;
                case 54: return 40;
                case 55: return 30;
                case 56: return 80;
                case 57: return 60;
                case 58: return 70;
                case 59: return 50;
                case 61: return 100;
                case 62: return 90;
                case 63: return 130;
                case 64: return 120;
                case 65: return 110;
                case 10: return 140;
            }
            return 0;
        }
        k(a, b, c) {
            if (b > c - 1) {
                return this.a("expected identifier", b);
            }
            if (a._inner[b].a != 74) {
                return this.a("expected identifier", b);
            }
            let d = this.j(a, b, c);
            if (d.b) {
                return d;
            }
            b = d.d;
            if (this.u(a, b, c, 17) || this.u(a, b, c, 16)) {
                return this.g(d.a, a, b, c);
            }
            return d;
        }
        g(a, b, c, d) {
            if (c > d - 1) {
                return this.a("expected member separator", c);
            }
            if (b._inner[c].a != 17 && b._inner[c].a != 16) {
                return this.a("expected member separator", c);
            }
            c++;
            let e = this.k(b, c, d);
            if (e.b) {
                return e;
            }
            c = e.d;
            return ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.a = ((() => {
                    let $ret = new FilterSyntaxMemberExpressionSyntax();
                    $ret.b = a;
                    $ret.c = e.a;
                    return $ret;
                })());
                $ret.d = c;
                return $ret;
            })());
        }
        j(a, b, c) {
            if (b > c - 1) {
                return this.a("expected identifier", b);
            }
            if (a._inner[b].a != 74) {
                return this.a("expected identifier", b);
            }
            return ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.a = ((() => {
                    let $ret = new FilterSyntaxIdentifierExpressionSyntax();
                    $ret.b = 74;
                    $ret.c = a._inner[b].b;
                    return $ret;
                })());
                $ret.d = b + 1;
                return $ret;
            })());
        }
        ac(a, b, c) {
            if (b > c - 1) {
                return false;
            }
            if (a._inner[b].a != 74) {
                return false;
            }
            return true;
        }
        q(a, b, c) {
            if (b > c - 1) {
                return this.a("expected open paren at: " + b, b);
            }
            if (a._inner[b].a != 10) {
                return this.a("expected open paren at: " + b, b);
            }
            b++;
            let d = this.i(a, b, c, 0);
            if (d.b) {
                return d;
            }
            b = d.d;
            if (b > c - 1) {
                return this.a("expected close paren at: " + b, b);
            }
            if (a._inner[b].a != 11) {
                return this.a("expected close paren at: " + b, b);
            }
            b++;
            let e = ((() => {
                let $ret = new FilterSyntaxParenthesisExpressionSyntax();
                $ret.b = d.a;
                return $ret;
            })());
            return ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.a = e;
                $ret.d = b;
                return $ret;
            })());
        }
        ai(a, b, c) {
            if (b > c - 1) {
                return false;
            }
            if (a._inner[b].a == 10) {
                return true;
            }
            return false;
        }
        l(a, b, c, d) {
            if (!this.u(a, b, c, 10)) {
                return this.a("expected open paren", b);
            }
            b++;
            let e = new List$1(FilterSyntaxExpressionSyntax.$, 0);
            while (b < c && a._inner[b].a != 11) {
                let f = this.i(a, b, c, 0);
                if (f.b) {
                    return f;
                }
                b = f.d;
                e.add(f.a);
                if (b < c && a._inner[b].a == 6) {
                    b++;
                }
            }
            if (a._inner[b].a != 11) {
                return this.a("expected close paren", b);
            }
            if (b < c && a._inner[b].a == 11) {
                b++;
            }
            let g = ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.a = ((() => {
                    let $ret = new FilterSyntaxMethodCallExpressionSyntax();
                    $ret.c = d;
                    $ret.b = e.toArray();
                    return $ret;
                })());
                $ret.d = b;
                return $ret;
            })());
            return g;
        }
        ae(a, b, c) {
            if (this.x(a._inner[b]) && this.al(a, b, c, 10)) {
                return true;
            }
            return false;
        }
        m(a, b, c) {
            if (!this.x(a._inner[b])) {
                return this.a("expected method name", b);
            }
            return ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.a = ((() => {
                    let $ret = new FilterSyntaxIdentifierExpressionSyntax();
                    $ret.b = a._inner[b].a;
                    $ret.c = a._inner[b].b;
                    return $ret;
                })());
                $ret.d = b + 1;
                return $ret;
            })());
        }
        ad(a, b, c) {
            if (this.x(a._inner[b]) && this.al(a, b, c, 10)) {
                return true;
            }
            return false;
        }
        u(a, b, c, d) {
            if (b >= c) {
                return false;
            }
            return a._inner[b].a == d;
        }
        al(a, b, c, d) {
            if (b + 1 >= c) {
                return false;
            }
            return a._inner[b + 1].a == d;
        }
        x(a) {
            switch (a.a) {
                case 23: return true;
                case 24: return true;
                case 46: return true;
                case 31: return true;
                case 27: return true;
                case 42: return true;
                case 35: return true;
                case 34: return true;
                case 22: return true;
                case 47: return true;
                case 37: return true;
                case 36: return true;
                case 74: return true;
                case 25: return true;
                case 67: return true;
                case 50: return true;
                case 49: return true;
                case 39: return true;
                case 38: return true;
                case 33: return true;
                case 51: return true;
                case 44: return true;
                case 41: return true;
                case 40: return true;
                case 21: return true;
                case 20: return true;
                case 26: return true;
                case 43: return true;
                case 28: return true;
                case 48: return true;
                case 29: return true;
                case 30: return true;
                case 32: return true;
                case 45: return true;
                case 68: return true;
            }
            return false;
        }
        n(a, b, c) {
            if (!this.u(a, b, c, 66)) {
                return this.a("expected token not", b);
            }
            b++;
            let d = this.i(a, b, c, 0);
            if (d.b) {
                return d;
            }
            b = d.d;
            return ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.a = ((() => {
                    let $ret = new FilterSyntaxUnaryOperatorExpressionSyntax();
                    $ret.c = 66;
                    $ret.b = d.a;
                    return $ret;
                })());
                $ret.d = b;
                return $ret;
            })());
        }
        af(a, b, c) {
            if (this.u(a, b, c, 66)) {
                return true;
            }
            return false;
        }
        e(a, b, c, d) {
            if (!this.v(b, c, d)) {
                return this.a("expected binary expression operator", c);
            }
            let e = b._inner[c].a;
            c++;
            let f = this.i(b, c, d, 0);
            if (f.b) {
                return f;
            }
            c = f.d;
            return ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.a = ((() => {
                    let $ret = new FilterSyntaxBinaryOperatorExpressionSyntax();
                    $ret.b = a;
                    $ret.c = f.a;
                    $ret.d = e;
                    return $ret;
                })());
                $ret.d = c;
                return $ret;
            })());
        }
        v(a, b, c) {
            if (b >= c) {
                return false;
            }
            let d = a._inner[b].a;
            switch (d) {
                case 10: return true;
                case 52: return true;
                case 53: return true;
                case 54: return true;
                case 55: return true;
                case 56: return true;
                case 57: return true;
                case 58: return true;
                case 59: return true;
                case 61: return true;
                case 62: return true;
                case 63: return true;
                case 64: return true;
                case 65: return true;
            }
            return false;
        }
        w(a, b, c) {
            if (b >= c) {
                return false;
            }
            let d = a._inner[b].a;
            switch (d) {
                case 66: return true;
            }
            return false;
        }
        r(a, b, c) {
            if (this.ak(a, b, c)) {
                return this.s(a, b, c);
            }
            else if (this.ab(a, b, c)) {
                return this.h(a, b, c);
            }
            else if (this.ah(a, b, c)) {
                return this.p(a, b, c);
            }
            else if (this.y(a, b, c)) {
                return this.f(a, b, c);
            }
            else if (this.ag(a, b, c)) {
                return this.o(a, b, c);
            }
            else {
                throw new InvalidOperationException(1, "expected json value at: " + b);
            }
        }
        aj(a, b, c) {
            if (this.ak(a, b, c)) {
                return true;
            }
            else if (this.ab(a, b, c)) {
                return true;
            }
            else if (this.ah(a, b, c)) {
                return true;
            }
            else if (this.y(a, b, c)) {
                return true;
            }
            else if (this.ag(a, b, c)) {
                return true;
            }
            else {
                return false;
            }
        }
        o(a, b, c) {
            let d = a._inner[b];
            b++;
            if (d.a != 71) {
                throw new InvalidOperationException(1, "expected null value at: " + b);
            }
            let e = ((() => {
                let $ret = new FilterSyntaxNullExpressionSyntax();
                $ret.c = d.b;
                $ret.b = d.a;
                return $ret;
            })());
            return ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.a = e;
                $ret.d = b;
                return $ret;
            })());
        }
        ag(a, b, c) {
            if (b > c - 1) {
                return false;
            }
            if (a._inner[b].a == 71) {
                return true;
            }
            return false;
        }
        f(a, b, c) {
            let d = a._inner[b];
            b++;
            if (d.a != 72 && d.a != 73) {
                throw new InvalidOperationException(1, "expected boolean at: " + b);
            }
            let e = ((() => {
                let $ret = new FilterSyntaxPrimitiveValueExpressionSyntax();
                $ret.c = d.b;
                $ret.b = d.a;
                return $ret;
            })());
            return ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.a = e;
                $ret.d = b;
                return $ret;
            })());
        }
        y(a, b, c) {
            if (b > c - 1) {
                return false;
            }
            if (a._inner[b].a == 72 || a._inner[b].a == 73) {
                return true;
            }
            return false;
        }
        p(a, b, c) {
            let d = a._inner[b];
            b++;
            if (d.a != 1 && d.a != 0) {
                throw new InvalidOperationException(1, "expected number at: " + b);
            }
            let e = ((() => {
                let $ret = new FilterSyntaxPrimitiveValueExpressionSyntax();
                $ret.c = d.b;
                $ret.b = d.a;
                return $ret;
            })());
            return ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.a = e;
                $ret.d = b;
                return $ret;
            })());
        }
        ah(a, b, c) {
            if (b > c - 1) {
                return false;
            }
            if (a._inner[b].a == 1 || a._inner[b].a == 0) {
                return true;
            }
            return false;
        }
        aa(a, b, c) {
            if (b > c - 1) {
                return false;
            }
            if (a._inner[b].a == 6) {
                return true;
            }
            return false;
        }
        z(a, b, c) {
            if (b > c - 1) {
                return false;
            }
            if (a._inner[b].a == 18) {
                return true;
            }
            return false;
        }
        s(a, b, c) {
            let d = a._inner[b];
            b++;
            if (d.a != 2) {
                return this.a("expected string at: " + b, b);
            }
            let e = ((() => {
                let $ret = new FilterSyntaxPrimitiveValueExpressionSyntax();
                $ret.c = this.an(d.b);
                $ret.b = 2;
                return $ret;
            })());
            return ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.a = e;
                $ret.d = b;
                return $ret;
            })());
        }
        h(a, b, c) {
            let d = a._inner[b];
            b++;
            if (d.a != 3 && d.a != 4 && d.a != 5) {
                return this.a("expected datetime literal at: " + b, b);
            }
            let e = ((() => {
                let $ret = new FilterSyntaxPrimitiveValueExpressionSyntax();
                $ret.b = d.a;
                return $ret;
            })());
            e.c = d.b;
            return ((() => {
                let $ret = new FilterSyntaxParseResult();
                $ret.a = e;
                $ret.d = b;
                return $ret;
            })());
        }
        an(a) {
            if (a == null) {
                return null;
            }
            let b = -1;
            let c = new StringBuilder(0);
            let d = 0;
            for (d = 0; d < a.length; d++) {
                if (a.charAt(d) == '\\' && b == -1) {
                    b = d;
                }
                else if (a.charAt(d) == '\'' && b == -1 && d + 1 < a.length && a.charAt(d + 1) == '\'') {
                    c.h('\'');
                    d++;
                }
                else {
                    if (b == -1) {
                        c.h(a.charAt(d));
                    }
                    else {
                        if (a.charAt(d) == 'n') {
                            c.l("\n");
                            b = -1;
                        }
                        else if (a.charAt(d) == 'r') {
                            c.l("\r");
                            b = -1;
                        }
                        else if (a.charAt(d) == 't') {
                            c.l("\t");
                            b = -1;
                        }
                        else if (a.charAt(d) == '\"') {
                            c.l("\"");
                            b = -1;
                        }
                        else if (a.charAt(d) == '\\') {
                            c.l("\\");
                            b = -1;
                        }
                        else {
                            c.l("\\" + a.charAt(d));
                            b = -1;
                        }
                    }
                }
            }
            return c.toString();
        }
        ak(a, b, c) {
            if (b > c - 1) {
                return false;
            }
            if (a._inner[b].a == 2) {
                return true;
            }
            return false;
        }
        ab(a, b, c) {
            if (b > c - 1) {
                return false;
            }
            if (a._inner[b].a == 3 || a._inner[b].a == 4 || a._inner[b].a == 5) {
                return true;
            }
            return false;
        }
    }
    FilterSyntaxParser.$t = /*@__PURE__*/ markType(FilterSyntaxParser, 'FilterSyntaxParser');
    return FilterSyntaxParser;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterSyntaxPrintingHelper = /*@__PURE__*/ (() => {
    class FilterSyntaxPrintingHelper extends Base {
        static b(a) {
            switch (a) {
                case 52: return "and";
                case 53: return "or";
                case 54: return "eq";
                case 55: return "ne";
                case 56: return "lt";
                case 57: return "le";
                case 58: return "gt";
                case 59: return "ge";
                case 61: return "add";
                case 62: return "sub";
                case 63: return "mul";
                case 64: return "div";
                case 65: return "mod";
                case 66: return "not";
            }
            return "UNKNOWN";
        }
        static a(a) {
            return a.c != null ? a.c.toString() : "";
        }
        static c(a) {
            switch (a.b) {
                case 2:
                    let b = "'" + stringReplace(a.c.toString(), "'", "''") + "'";
                    return b;
                case 0: return a.c != null ? a.c.toString() : "";
                case 1: return a.c != null ? a.c.toString() : "";
                case 69: return "NaN";
                case 70: return "Infinity";
            }
            return "UNKNOWN";
        }
    }
    FilterSyntaxPrintingHelper.$t = /*@__PURE__*/ markType(FilterSyntaxPrintingHelper, 'FilterSyntaxPrintingHelper');
    return FilterSyntaxPrintingHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TestFilterSyntaxVisitor = /*@__PURE__*/ (() => {
    class TestFilterSyntaxVisitor extends FilterSyntaxVisitor {
        constructor() {
            super();
            this.l = new StringBuilder(0);
        }
        get k() {
            return this.l.toString();
        }
        c(a) {
            this.l.l("[[");
            this.l.l(FilterSyntaxPrintingHelper.b(a.d));
            this.l.l(" ");
            this.b(a.b);
            this.l.l(" ");
            this.b(a.c);
            this.l.l("]]");
        }
        d(a) {
            this.l.l(FilterSyntaxPrintingHelper.a(a));
        }
        e(a) {
            this.b(a.b);
            if (a.c != null) {
                this.l.l(".");
                this.b(a.c);
            }
        }
        f(a) {
            this.b(a.c);
            this.l.l("(");
            if (a.b != null) {
                let b = true;
                let e = a.b;
                for (let d = 0; d < e.length; d++) {
                    let c = e[d];
                    if (b) {
                        b = false;
                    }
                    else {
                        this.l.l(", ");
                    }
                    this.b(c);
                }
            }
            this.l.l(")");
        }
        g(a) {
            this.l.l("null");
        }
        h(a) {
            this.l.l("(");
            this.b(a.b);
            this.l.l(")");
        }
        i(a) {
            this.l.l(FilterSyntaxPrintingHelper.c(a));
        }
        j(a) {
            this.l.l("[[");
            this.l.l(FilterSyntaxPrintingHelper.b(a.c));
            this.l.l(" ");
            this.b(a.b);
            this.l.l("]]");
        }
    }
    TestFilterSyntaxVisitor.$t = /*@__PURE__*/ markType(TestFilterSyntaxVisitor, 'TestFilterSyntaxVisitor', FilterSyntaxVisitor.$);
    return TestFilterSyntaxVisitor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterExpressionConversionVisitor = /*@__PURE__*/ (() => {
    class FilterExpressionConversionVisitor extends FilterSyntaxVisitor {
        constructor() {
            super();
            this.q = null;
            this.n = null;
            this.r = new Stack$1(IFilterExpression_$type);
            this.s = new StringBuilder(0);
            this.q = new List$1(String_$type, 0);
        }
        o() {
            return this.r.e();
        }
        get p() {
            return this.q.count > 0;
        }
        get k() {
            return this.q.toArray();
        }
        c(a) {
            this.b(a.b);
            let b = this.r.e();
            this.b(a.c);
            let c = this.r.e();
            let d = new OperationFilterExpression(null, 1, null);
            d.operator = this.m(a.d);
            d.left = b;
            d.right = c;
            this.r.h(d);
        }
        t(a) {
            this.q.add(a);
        }
        m(a) {
            switch (a) {
                case 54: return 1;
                case 55: return 2;
                case 56: return 5;
                case 57: return 6;
                case 58: return 3;
                case 59: return 4;
                case 61: return 10;
                case 62: return 11;
                case 63: return 12;
                case 64: return 13;
                case 65: return 14;
                case 66: return 9;
                case 52: return 7;
                case 53: return 8;
            }
            let b = EnumUtil.getName(FilterSyntaxTokenType_$type, a);
            this.t("unexpected operator: " + b);
            return 0;
        }
        d(a) {
            let b = new PropertyReferenceFilterExpression(null);
            b.propertyReference = a.c.toString();
            this.r.h(b);
        }
        e(a) {
            this.b(a.b);
            let b = this.r.e();
            if (a.c != null) {
                this.b(a.c);
                let c = this.r.e();
                b.propertyReference += "." + c.propertyReference;
            }
            this.r.h(b);
        }
        f(a) {
            let b = this.l(a.c);
            let c = [];
            let d = new FunctionFilterExpression(b, ...c);
            d.functionType = b;
            if (a.b != null) {
                let e = true;
                let h = a.b;
                for (let g = 0; g < h.length; g++) {
                    let f = h[g];
                    this.b(f);
                    let i = this.r.e();
                    d.functionArguments.add(i);
                }
            }
            this.r.h(d);
        }
        l(a) {
            if (typeCast(FilterSyntaxIdentifierExpressionSyntax.$, a) !== null) {
                let b = a;
                switch (b.b) {
                    case 20:
                        this.t("unsupported function: " + enumGetBox(FilterSyntaxTokenType_$type, b.b));
                        return 7;
                    case 21: return 2;
                    case 22: return 1;
                    case 23: return 5;
                    case 24: return FilterExpressionFunctionType.Length;
                    case 25: return 4;
                    case 26: return 6;
                    case 27: return 0;
                    case 28: return 7;
                    case 29: return 8;
                    case 30: return 9;
                    case 31: return 10;
                    case 32: return 16;
                    case 33: return 14;
                    case 34: return 11;
                    case 35:
                        this.t("unsupported function: " + enumGetBox(FilterSyntaxTokenType_$type, b.b));
                        return 7;
                    case 36: return 12;
                    case 37:
                        this.t("unsupported function: " + enumGetBox(FilterSyntaxTokenType_$type, b.b));
                        return 7;
                    case 38: return 13;
                    case 39:
                        this.t("unsupported function: " + enumGetBox(FilterSyntaxTokenType_$type, b.b));
                        return 7;
                    case 40: return 15;
                    case 41:
                        this.t("unsupported function: " + enumGetBox(FilterSyntaxTokenType_$type, b.b));
                        return 7;
                    case 42: return 20;
                    case 43: return 21;
                    case 44: return 17;
                    case 45: return 18;
                    case 46: return 19;
                    case 47:
                        this.t("unsupported function: " + enumGetBox(FilterSyntaxTokenType_$type, b.b));
                        return 7;
                    case 48:
                        this.t("unsupported function: " + enumGetBox(FilterSyntaxTokenType_$type, b.b));
                        return 7;
                    case 49:
                        this.t("unsupported function: " + enumGetBox(FilterSyntaxTokenType_$type, b.b));
                        return 7;
                    case 50:
                        this.t("unsupported function: " + enumGetBox(FilterSyntaxTokenType_$type, b.b));
                        return 7;
                    case 51: return 22;
                    case 68: return 24;
                }
            }
            this.t("unsupported function type");
            return 7;
        }
        g(a) {
            this.r.h(((() => {
                let $ret = new LiteralFilterExpression(null, false);
                $ret.literalValue = null;
                return $ret;
            })()));
        }
        h(a) {
            let b = ((() => {
                let $ret = new OperationFilterExpression(null, 1, null);
                $ret.operator = 15;
                return $ret;
            })());
            this.b(a.b);
            let c = this.r.e();
            b.left = c;
            this.r.h(b);
        }
        i(a) {
            switch (a.b) {
                case 4:
                case 3:
                case 5:
                    this.r.h(((() => {
                        let $ret = new LiteralFilterExpression(null, false);
                        $ret.literalValue = a.c;
                        return $ret;
                    })()));
                    break;
                case 0:
                    this.r.h(((() => {
                        let $ret = new LiteralFilterExpression(null, false);
                        $ret.literalValue = a.c;
                        return $ret;
                    })()));
                    break;
                case 1:
                    this.r.h(((() => {
                        let $ret = new LiteralFilterExpression(null, false);
                        $ret.literalValue = a.c;
                        return $ret;
                    })()));
                    break;
                case 2:
                    this.r.h(((() => {
                        let $ret = new LiteralFilterExpression(null, false);
                        $ret.literalValue = a.c;
                        return $ret;
                    })()));
                    break;
            }
        }
        j(a) {
            this.b(a.b);
            let b = this.r.e();
            let c = new OperationFilterExpression(null, 1, null);
            c.operator = this.m(a.c);
            c.left = b;
            this.r.h(c);
        }
    }
    FilterExpressionConversionVisitor.$t = /*@__PURE__*/ markType(FilterExpressionConversionVisitor, 'FilterExpressionConversionVisitor', FilterSyntaxVisitor.$);
    return FilterExpressionConversionVisitor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterExpressionParsingResult = /*@__PURE__*/ (() => {
    class FilterExpressionParsingResult extends Base {
        constructor() {
            super(...arguments);
            this._result = null;
            this._errors = null;
        }
        get result() {
            return this._result;
        }
        set result(a) {
            this._result = a;
        }
        get errors() {
            return this._errors;
        }
        set errors(a) {
            this._errors = a;
        }
    }
    FilterExpressionParsingResult.$t = /*@__PURE__*/ markType(FilterExpressionParsingResult, 'FilterExpressionParsingResult');
    return FilterExpressionParsingResult;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterExpressionParsingHelper = /*@__PURE__*/ (() => {
    class FilterExpressionParsingHelper extends Base {
        static getFilterExpression(a) {
            let b = new FilterExpressionParsingResult();
            let c = new FilterSyntaxParser();
            let d = c.d(a);
            if (d.b) {
                b.errors = d.e;
                return b;
            }
            let e = new FilterExpressionConversionVisitor();
            e.b(d.a);
            if (e.k != null && (e.k.length > 0)) {
                b.errors = stringJoin("\r\n", ...e.k);
                return b;
            }
            b.result = e.o();
            return b;
        }
    }
    FilterExpressionParsingHelper.$t = /*@__PURE__*/ markType(FilterExpressionParsingHelper, 'FilterExpressionParsingHelper');
    return FilterExpressionParsingHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncVirtualDataTask = /*@__PURE__*/ (() => {
    class AsyncVirtualDataTask extends Base {
        constructor() {
            super(...arguments);
            this._hasErrors = false;
            this._isRunning = false;
            this._isCancelled = false;
            this._isCompleted = false;
            this._result = null;
            this._run = null;
        }
        get hasErrors() {
            return this._hasErrors;
        }
        set hasErrors(a) {
            this._hasErrors = a;
        }
        get isRunning() {
            return this._isRunning;
        }
        set isRunning(a) {
            this._isRunning = a;
        }
        get isCancelled() {
            return this._isCancelled;
        }
        set isCancelled(a) {
            this._isCancelled = a;
        }
        get isCompleted() {
            return this._isCompleted;
        }
        set isCompleted(a) {
            this._isCompleted = a;
        }
        get result() {
            return this._result;
        }
        set result(a) {
            this._result = a;
        }
        get run() {
            return this._run;
        }
        set run(a) {
            this._run = a;
        }
    }
    AsyncVirtualDataTask.$t = /*@__PURE__*/ markType(AsyncVirtualDataTask, 'AsyncVirtualDataTask');
    return AsyncVirtualDataTask;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncVirtualDataSourceDataProviderWorkerSettings = /*@__PURE__*/ (() => {
    class AsyncVirtualDataSourceDataProviderWorkerSettings extends Base {
        constructor() {
            super(...arguments);
            this._pageSizeRequested = 0;
            this._timeoutMilliseconds = 0;
            this._pageLoaded = null;
            this._batchCompleted = null;
            this._executionContext = null;
        }
        get pageSizeRequested() {
            return this._pageSizeRequested;
        }
        set pageSizeRequested(a) {
            this._pageSizeRequested = a;
        }
        get timeoutMilliseconds() {
            return this._timeoutMilliseconds;
        }
        set timeoutMilliseconds(a) {
            this._timeoutMilliseconds = a;
        }
        get pageLoaded() {
            return this._pageLoaded;
        }
        set pageLoaded(a) {
            this._pageLoaded = a;
        }
        get batchCompleted() {
            return this._batchCompleted;
        }
        set batchCompleted(a) {
            this._batchCompleted = a;
        }
        get executionContext() {
            return this._executionContext;
        }
        set executionContext(a) {
            this._executionContext = a;
        }
    }
    AsyncVirtualDataSourceDataProviderWorkerSettings.$t = /*@__PURE__*/ markType(AsyncVirtualDataSourceDataProviderWorkerSettings, 'AsyncVirtualDataSourceDataProviderWorkerSettings');
    return AsyncVirtualDataSourceDataProviderWorkerSettings;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncVirtualDataSourceProviderTaskDataHolder = /*@__PURE__*/ (() => {
    class AsyncVirtualDataSourceProviderTaskDataHolder extends Base {
    }
    AsyncVirtualDataSourceProviderTaskDataHolder.$t = /*@__PURE__*/ markType(AsyncVirtualDataSourceProviderTaskDataHolder, 'AsyncVirtualDataSourceProviderTaskDataHolder');
    return AsyncVirtualDataSourceProviderTaskDataHolder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncDataSourcePageTaskHolder = /*@__PURE__*/ (() => {
    class AsyncDataSourcePageTaskHolder extends Base {
        constructor() {
            super(...arguments);
            this._task = null;
        }
        get task() {
            return this._task;
        }
        set task(a) {
            this._task = a;
        }
    }
    AsyncDataSourcePageTaskHolder.$t = /*@__PURE__*/ markType(AsyncDataSourcePageTaskHolder, 'AsyncDataSourcePageTaskHolder');
    return AsyncDataSourcePageTaskHolder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncDataSourcePageRequest = /*@__PURE__*/ (() => {
    class AsyncDataSourcePageRequest extends Base {
        constructor(a, b) {
            super();
            this.e = 0;
            this.f = 0;
            this.a = null;
            this.c = false;
            this.e = a;
            this.f = b;
        }
        get index() {
            return this.e;
        }
        set index(a) {
            this.e = a;
        }
        get retryDelay() {
            return this.f;
        }
        set retryDelay(a) {
            this.f = a;
        }
        get taskHolder() {
            return this.a;
        }
        set taskHolder(a) {
            this.a = a;
        }
        get isDone() {
            return this.c;
        }
        set isDone(a) {
            this.c = a;
        }
    }
    AsyncDataSourcePageRequest.$t = /*@__PURE__*/ markType(AsyncDataSourcePageRequest, 'AsyncDataSourcePageRequest');
    return AsyncDataSourcePageRequest;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WeakReference = /*@__PURE__*/ (() => {
    class WeakReference extends Base {
        constructor(a) {
            super();
            this.b = null;
            this.b = a;
        }
        get_a() {
            return true;
        }
        get a() {
            return this.get_a();
        }
        get_c() {
            return this.b;
        }
        set_c(a) {
            this.b = a;
        }
        get c() {
            return this.get_c();
        }
        set c(a) {
            this.set_c(a);
        }
    }
    WeakReference.$t = /*@__PURE__*/ markType(WeakReference, 'WeakReference');
    return WeakReference;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncVirtualDataSourceProviderWorker = /*@__PURE__*/ (() => {
    class AsyncVirtualDataSourceProviderWorker extends Base {
        constructor(a) {
            super();
            this.r = new LinkedList$1(AsyncDataSourcePageRequest.$);
            this.p = new List$1(AsyncDataSourcePageRequest.$, 0);
            this.ac = {};
            this.i = true;
            this.u = 0;
            this.t = 0;
            this.v = 0;
            this.e = null;
            this.s = -1;
            this.as = null;
            this.aq = null;
            this.ar = null;
            this.h = false;
            this._isShutdown = false;
            this.g = false;
            this.i = true;
            this.u = a.pageSizeRequested;
            this.t = this.u;
            this.v = a.timeoutMilliseconds;
            this.as = new WeakReference(a.pageLoaded);
            this.aq = new WeakReference(a.batchCompleted);
            this.ar = new WeakReference(a.executionContext);
        }
        get tasks() {
            return this.p;
        }
        get pageLoaded() {
            if (this.as == null) {
                return null;
            }
            return this.as.c;
        }
        get batchCompleted() {
            if (this.aq == null) {
                return null;
            }
            return this.aq.c;
        }
        get executionContext() {
            if (this.ar == null) {
                return null;
            }
            return this.ar.c;
        }
        get actualPageSize() {
            return this.t;
        }
        set actualPageSize(a) {
            this.t = a;
        }
        get actualCount() {
            return this.s;
        }
        set actualCount(a) {
            this.s = a;
        }
        get actualSchema() {
            return this.e;
        }
        set actualSchema(a) {
            this.e = a;
        }
        get populatedActualPageSize() {
            return this.h;
        }
        set populatedActualPageSize(a) {
            this.h = a;
        }
        get isRunning() {
            return this.i;
        }
        set isRunning(a) {
            this.i = a;
        }
        addPageRequest(a, b) {
            return this.addPageRequestWithRetry(a, b, 200);
        }
        addPageRequestWithRetry(a, b, c) {
            if (this.isShutdown) {
                return false;
            }
            if (b == 2) {
                this.r.e(new AsyncDataSourcePageRequest(a, c));
            }
            else {
                this.r.f(new AsyncDataSourcePageRequest(a, c));
            }
            return true;
        }
        removePageRequest(a) {
            let b = null;
            let c = this.r.c;
            while (c != null) {
                let d = c.c;
                if (d.index == a) {
                    b = c;
                    break;
                }
                c = c.a;
            }
            if (b != null) {
                this.r.h(b);
            }
        }
        get isShutdown() {
            return this._isShutdown;
        }
        set isShutdown(a) {
            this._isShutdown = a;
        }
        removeAllPageRequests() {
            this.r.g();
        }
        shutdown() {
            this.as = null;
            this.aq = null;
            this.ar = null;
            this.isShutdown = true;
            this.i = false;
        }
        initialize() {
        }
        getTaskDataHolder() {
            return null;
        }
        getTasksData(a) {
        }
        removeCompletedTaskData(a, b) {
        }
        getCompletedTaskData(a, b) {
        }
        runATask() {
            for (let a = 0; a < this.p.count; a++) {
                if (!this.p.item(a).taskHolder.task.isRunning && !this.p.item(a).isDone && !this.p.item(a).taskHolder.task.isCompleted && !this.p.item(a).taskHolder.task.isCancelled) {
                    this.p.item(a).taskHolder.task.isRunning = true;
                    this.p.item(a).taskHolder.task.run();
                    break;
                }
            }
        }
        checkAndPotentiallyWaitOnTasks(a) {
            this.runATask();
            for (let b = 0; b < a.length; b++) {
                if (a[b].isDone || a[b].taskHolder.task.isCompleted || a[b].taskHolder.task.isCancelled) {
                    return b;
                }
            }
            return -1;
        }
        doWork() {
            if (!this.g) {
                this.g = true;
                this.initialize();
            }
            {
                let a = null;
                let b = null;
                let c = this.p.count;
                if (this.r.c != null && c < 2) {
                    let d = this.r.c;
                    this.r.i();
                    this.makeTaskForRequest(d.c, d.c.retryDelay);
                    c = this.p.count;
                }
                if (c > 0) {
                    a = new Array(c);
                    for (let e = 0; e < c; e++) {
                        a[e] = this.p.item(e);
                    }
                    b = this.getTaskDataHolder();
                    this.getTasksData(b);
                }
                if (a != null && a.length > 0) {
                    let f = this.checkAndPotentiallyWaitOnTasks(a);
                    if (!this.i) {
                        return;
                    }
                    if (f >= 0) {
                        let g = a[f];
                        this.getCompletedTaskData(b, f);
                        this.p.remove(g);
                        this.removeCompletedTaskData(b, f);
                        this.processCompletedTask(g.taskHolder, g.retryDelay, g.index, b);
                    }
                }
                else {
                }
                if (!this.i) {
                    return;
                }
                if (this.i) {
                    window.setTimeout(runOn(this, this.doWork), 100);
                }
            }
        }
        makeTaskForRequest(a, b) {
        }
        processCompletedTask(a, b, c, d) {
        }
        retryIndex(a, b) {
            let c = b * 2;
            if (b > 20000) {
                this.removePageRequest(a);
            }
            if (this.ar == null) {
                this.shutdown();
                return;
            }
            let d = typeCast(IDataSourceExecutionContext_$type, this.ar.c);
            if (d == null) {
                this.shutdown();
                return;
            }
            d.executeDelayed(() => this.addPageRequestWithRetry(a, 0, c), b);
        }
        isLastPage(a) {
            if (this.s < 0) {
                return false;
            }
            if ((this.s - (a * this.t)) < this.t) {
                return true;
            }
            return false;
        }
        createBatchRequest(a) {
        }
    }
    AsyncVirtualDataSourceProviderWorker.$t = /*@__PURE__*/ markType(AsyncVirtualDataSourceProviderWorker, 'AsyncVirtualDataSourceProviderWorker');
    AsyncVirtualDataSourceProviderWorker.maxSimultaneousExecutingTasks = 2;
    AsyncVirtualDataSourceProviderWorker.maxRetryDelay = 20000;
    AsyncVirtualDataSourceProviderWorker.initialRetryDelay = 200;
    return AsyncVirtualDataSourceProviderWorker;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Identifies the type of wrapper expression.
 */
var FilterExpressionWrapperType = /*@__PURE__*/ (function (FilterExpressionWrapperType) {
    /**
     * A wrapper for the Today expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["Today"] = 0] = "Today";
    /**
     * A wrapper for the Tomorrow expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["Tomorrow"] = 1] = "Tomorrow";
    /**
     * A wrapper for the Yesterday expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["Yesterday"] = 2] = "Yesterday";
    /**
     * A wrapper for the ThisWeek expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["ThisWeek"] = 3] = "ThisWeek";
    /**
     * A wrapper for the NextWeek expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["NextWeek"] = 4] = "NextWeek";
    /**
     * A wrapper for the LastWeek expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["LastWeek"] = 5] = "LastWeek";
    /**
     * A wrapper for the ThisMonth expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["ThisMonth"] = 6] = "ThisMonth";
    /**
     * A wrapper for the NextMonth expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["NextMonth"] = 7] = "NextMonth";
    /**
     * A wrapper for the LastMonth expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["LastMonth"] = 8] = "LastMonth";
    /**
     * A wrapper for the ThisYear expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["ThisYear"] = 9] = "ThisYear";
    /**
     * A wrapper for the NextYear expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["NextYear"] = 10] = "NextYear";
    /**
     * A wrapper for the LastYear expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["LastYear"] = 11] = "LastYear";
    /**
     * A wrapper for the ThisQuarter expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["ThisQuarter"] = 12] = "ThisQuarter";
    /**
     * A wrapper for the NextQuarter expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["NextQuarter"] = 13] = "NextQuarter";
    /**
     * A wrapper for the LastQuarter expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["LastQuarter"] = 14] = "LastQuarter";
    /**
     * A wrapper for the YearToDate expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["YearToDate"] = 15] = "YearToDate";
    /**
     * A wrapper for the Q1 expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["Q1"] = 16] = "Q1";
    /**
     * A wrapper for the Q2 expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["Q2"] = 17] = "Q2";
    /**
     * A wrapper for the Q3 expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["Q3"] = 18] = "Q3";
    /**
     * A wrapper for the Q4 expression.
     */
    FilterExpressionWrapperType[FilterExpressionWrapperType["Q4"] = 19] = "Q4";
    return FilterExpressionWrapperType;
})({});
/**
 * @hidden
 */
let FilterExpressionWrapperType_$type = /*@__PURE__*/ markEnum('FilterExpressionWrapperType', 'Today,0|Tomorrow,1|Yesterday,2|ThisWeek,3|NextWeek,4|LastWeek,5|ThisMonth,6|NextMonth,7|LastMonth,8|ThisYear,9|NextYear,10|LastYear,11|ThisQuarter,12|NextQuarter,13|LastQuarter,14|YearToDate,15|Q1,16|Q2,17|Q3,18|Q4,19');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterExpressionVisitor = /*@__PURE__*/ (() => {
    class FilterExpressionVisitor extends Base {
        visit(a) {
            if (a == null) {
                throw new InvalidOperationException(1, "Expected an expression but found none");
            }
            if (a.isOperation) {
                this.visitOperationExpression(a);
            }
            else if (a.isFunction) {
                this.visitFunctionExpression(a);
            }
            else if (a.isLiteral) {
                this.visitLiteralExpression(a);
            }
            else if (a.isPropertyReference) {
                this.visitPropertyReferenceExpression(a);
            }
            else if (a.isWrapper) {
                let b = a;
                this.visit(b.innerExpression);
            }
        }
        visitOperationExpression(a) {
            if (a.left != null) {
                this.visit(a.left);
            }
            if (a.right != null) {
                this.visit(a.right);
            }
        }
        visitFunctionExpression(a) {
            for (let b = 0; b < a.functionArguments.k.count; b++) {
                this.visit(a.functionArguments.k.item(b));
            }
        }
        visitLiteralExpression(a) {
        }
        visitPropertyReferenceExpression(a) {
        }
    }
    FilterExpressionVisitor.$t = /*@__PURE__*/ markType(FilterExpressionVisitor, 'FilterExpressionVisitor');
    return FilterExpressionVisitor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ContainsPropertyDataSourceFilterExpressionVisitor = /*@__PURE__*/ (() => {
    class ContainsPropertyDataSourceFilterExpressionVisitor extends FilterExpressionVisitor {
        constructor(a) {
            super();
            this.h = null;
            this.f = false;
            this.h = a;
        }
        get contains() {
            return this.f;
        }
        visitPropertyReferenceExpression(a) {
            if (a.isPropertyReference && a.propertyReference == this.h) {
                this.f = true;
            }
        }
    }
    ContainsPropertyDataSourceFilterExpressionVisitor.$t = /*@__PURE__*/ markType(ContainsPropertyDataSourceFilterExpressionVisitor, 'ContainsPropertyDataSourceFilterExpressionVisitor', FilterExpressionVisitor.$);
    return ContainsPropertyDataSourceFilterExpressionVisitor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SortGroupParser = /*@__PURE__*/ (() => {
    class SortGroupParser extends Base {
        b(a, b) {
            if (a == null) {
                return;
            }
            let c = a.split(',');
            for (let d = 0; d < c.length; d++) {
                let e = c[d].trim();
                if (stringIsNullOrEmpty(e)) {
                    continue;
                }
                let f = "";
                let g = 0;
                for (; g < e.length; g++) {
                    if (e.charAt(g) == ' ') {
                        break;
                    }
                    f += e.charAt(g);
                }
                g++;
                let h = "";
                for (; g < e.length; g++) {
                    if (e.charAt(g) == ' ') {
                        break;
                    }
                    h += e.charAt(g);
                }
                h = h.toLowerCase();
                let i = h == "desc" ? 1 : 0;
                let j = "";
                if (h == "as") {
                    g++;
                    j = this.a(e, g);
                }
                else {
                    g++;
                    let k = "";
                    for (; g < e.length; g++) {
                        if (e.charAt(g) == ' ') {
                            break;
                        }
                        k += e.charAt(g);
                    }
                    if (k.toLowerCase() == "as") {
                        g++;
                        j = this.a(e, g);
                    }
                }
                if (b != null) {
                    b(f, i, j == "" ? null : j);
                }
            }
        }
        a(a, b) {
            let c = "";
            let d = false;
            for (; b < a.length; b++) {
                if (d && a.charAt(b) == '\'') {
                    break;
                }
                if (d) {
                    c += a.charAt(b);
                }
                if (!d && a.charAt(b) == '\'') {
                    d = true;
                }
            }
            return c;
        }
    }
    SortGroupParser.$t = /*@__PURE__*/ markType(SortGroupParser, 'SortGroupParser');
    return SortGroupParser;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryParser = /*@__PURE__*/ (() => {
    class SummaryParser extends Base {
        a(a, b) {
            if (a == null) {
                return;
            }
            let c = a.split(',');
            for (let d = 0; d < c.length; d++) {
                let e = c[d].trim();
                let f = "";
                let g = 0;
                for (g = 0; g < e.length; g++) {
                    let h = e.charAt(g);
                    if (h != '(') {
                        f += h;
                    }
                    else {
                        break;
                    }
                }
                if (g == e.length) {
                    continue;
                }
                f = f.trim().toLowerCase();
                let i = 4;
                switch (f) {
                    case "avg":
                        i = 3;
                        break;
                    case "sum":
                        i = 2;
                        break;
                    case "min":
                        i = 0;
                        break;
                    case "max":
                        i = 1;
                        break;
                    case "count":
                        i = 4;
                        break;
                    default: continue;
                }
                g++;
                let j = "";
                for (; g < e.length; g++) {
                    let k = e.charAt(g);
                    if (k != ')') {
                        j += k;
                    }
                    else {
                        break;
                    }
                }
                if (j.length == 0) {
                    continue;
                }
                if (e.charAt(g) != ')') {
                    continue;
                }
                g++;
                let l = null;
                if (g < e.length) {
                    if (e.charAt(g) != ' ') {
                        continue;
                    }
                    g++;
                    if (e.substr(g, 2) != "as") {
                        continue;
                    }
                    g += 2;
                    if (e.charAt(g) != ' ') {
                        continue;
                    }
                    g++;
                    l = e.substr(g, e.length - g);
                }
                if (b != null) {
                    b(j, i, l);
                }
            }
        }
    }
    SummaryParser.$t = /*@__PURE__*/ markType(SummaryParser, 'SummaryParser');
    return SummaryParser;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * The row type.
 */
var DataSourceRowType = /*@__PURE__*/ (function (DataSourceRowType) {
    /**
     * Normal row
     */
    DataSourceRowType[DataSourceRowType["Normal"] = 0] = "Normal";
    /**
     * Section header
     */
    DataSourceRowType[DataSourceRowType["SectionHeader"] = 1] = "SectionHeader";
    /**
     * Section footer
     */
    DataSourceRowType[DataSourceRowType["SectionFooter"] = 2] = "SectionFooter";
    /**
     * A shited row
     */
    DataSourceRowType[DataSourceRowType["ShiftedRow"] = 3] = "ShiftedRow";
    /**
     * A summary row at the root level
     */
    DataSourceRowType[DataSourceRowType["SummaryRowRoot"] = 4] = "SummaryRowRoot";
    /**
     * A summary row at the section level
     */
    DataSourceRowType[DataSourceRowType["SummaryRowSection"] = 5] = "SummaryRowSection";
    /**
     * Custom
     */
    DataSourceRowType[DataSourceRowType["Custom"] = 6] = "Custom";
    return DataSourceRowType;
})({});
/**
 * @hidden
 */
let DataSourceRowType_$type = /*@__PURE__*/ markEnum('DataSourceRowType', 'Normal,0|SectionHeader,1|SectionFooter,2|ShiftedRow,3|SummaryRowRoot,4|SummaryRowSection,5|Custom,6');

/**
 * Provides information about a schema change event that has occurred.
*/
class IgrDataSourceSchemaChangedEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets the new schema that has been provided.
    */
    get schema() {
        return this.i.schema;
    }
    /**
     * Gets the current full count of items in the data source.
    */
    get count() {
        return this.i.count;
    }
}

/**
 * Provides information about row expansion or collapse.
*/
class IgrDataSourceRowExpansionChangedEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * The index of the row being expanded or collapsed.
    */
    get rowIndex() {
        return this.i.rowIndex;
    }
    /**
     * The previous state of the row. True is expanded, False is collapsed.
    */
    get oldState() {
        return this.i.oldState;
    }
    /**
     * The new state of the row. True is expanded, False is collapsed.
    */
    get newState() {
        return this.i.newState;
    }
}

/**
 * Provides information about a schema change event.
*/
class IgrDataSourceDataProviderSchemaChangedEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Represents the current schema for the data provider.
    */
    get schema() {
        return this.i.schema;
    }
    /**
     * Represents the current full count for the data provider. May be -1 if this information is not available yet.
    */
    get count() {
        return this.i.count;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceVirtualDataProvider_$type = /*@__PURE__*/ new Type(null, 'IDataSourceVirtualDataProvider', null, [IDataSourceDataProvider_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates the priority for a page request.
 */
var DataSourcePageRequestPriority = /*@__PURE__*/ (function (DataSourcePageRequestPriority) {
    /**
     * Indicates a request with low priority.
     */
    DataSourcePageRequestPriority[DataSourcePageRequestPriority["Low"] = 0] = "Low";
    /**
     * Indicates a request with normal priority.
     */
    DataSourcePageRequestPriority[DataSourcePageRequestPriority["Normal"] = 1] = "Normal";
    /**
     * Indicates a request with high priority.
     */
    DataSourcePageRequestPriority[DataSourcePageRequestPriority["High"] = 2] = "High";
    return DataSourcePageRequestPriority;
})({});
/**
 * @hidden
 */
let DataSourcePageRequestPriority_$type = /*@__PURE__*/ markEnum('DataSourcePageRequestPriority', 'Low,0|Normal,1|High,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IExternalDataSource_$type = /*@__PURE__*/ new Type(null, 'IExternalDataSource');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IExternalLocalDataSource_$type = /*@__PURE__*/ new Type(null, 'IExternalLocalDataSource');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IExternalVirtualDataSource_$type = /*@__PURE__*/ new Type(null, 'IExternalVirtualDataSource');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISectionInformation_$type = /*@__PURE__*/ new Type(null, 'ISectionInformation');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DefaultSectionInformation = /*@__PURE__*/ (() => {
    class DefaultSectionInformation extends Base {
        constructor(a, b, c, d, e) {
            super();
            this.e = 0;
            this.d = 0;
            this.a = null;
            this.b = null;
            this.c = null;
            this.e = a;
            this.d = b;
            this.a = c;
            this.b = d;
            this.c = e;
        }
        get startIndex() {
            return this.e;
        }
        get endIndex() {
            return this.d;
        }
        get groupKeyValues() {
            return this.b;
        }
        get groupKeyProperties() {
            return this.a;
        }
        get summaryResults() {
            return this.c;
        }
    }
    DefaultSectionInformation.$t = /*@__PURE__*/ markType(DefaultSectionInformation, 'DefaultSectionInformation', Base.$, [ISectionInformation_$type]);
    return DefaultSectionInformation;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ODataLiteralEmitter_$type = /*@__PURE__*/ new Type(null, 'ODataLiteralEmitter');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DefaultODataLiteralEmitter = /*@__PURE__*/ (() => {
    class DefaultODataLiteralEmitter extends Base {
        emitLiteral(a, b) {
            if (a == null) {
                return "null";
            }
            if (typeCast(Boolean_$type, a) !== null) {
                return a ? "true" : "false";
            }
            else if (typeCast(Date_$type, a) !== null) {
                return this.a(a);
            }
            else if (typeof a === 'string') {
                let c = a.toString();
                if (!b) {
                    c = "'" + c + "'";
                }
                return c;
            }
            else {
                return a.toString();
            }
        }
        b(a) {
            let b = false;
            if (timeSpanTotalMilliseconds(a) < 0) {
                b = true;
                a = timeSpanNegate(a);
            }
            let c = new StringBuilder(0);
            c.l("duration'");
            if (b) {
                c.l("-");
            }
            c.l("P");
            if (timeSpanDays(a) > 0) {
                c.l(timeSpanDays(a).toString());
                c.l("D");
            }
            c.l("T");
            if (timeSpanHours(a) > 0) {
                c.j(timeSpanHours(a));
                c.l("H");
            }
            if (timeSpanMinutes(a) > 0 || timeSpanHours(a) > 0) {
                c.j(timeSpanMinutes(a));
                c.l("M");
            }
            if (timeSpanSeconds(a) > 0 || timeSpanMilliseconds(a) > 0 || timeSpanHours(a) > 0 || timeSpanMinutes(a) > 0) {
                c.j(timeSpanSeconds(a));
                if (timeSpanMilliseconds(a) > 0) {
                    c.l(".");
                    c.l((timeSpanMilliseconds(a) / 1000).toString());
                }
                c.l("S");
            }
            c.l("'");
            return c.toString();
        }
        a(a) {
            let b;
            if (a.getSeconds() == 0 && a.getMilliseconds() == 0) {
                b = dateToStringFormat(a, "yyyy-MM-ddTHH:mm");
            }
            else if (a.getMilliseconds() == 0) {
                b = dateToStringFormat(a, "yyyy-MM-ddTHH:mm:ss");
            }
            else {
                b = dateToStringFormat(a, "yyyy-MM-ddTHH:mm:ss.fffffff");
            }
            return "datetime'" + b + "'";
        }
    }
    DefaultODataLiteralEmitter.$t = /*@__PURE__*/ markType(DefaultODataLiteralEmitter, 'DefaultODataLiteralEmitter', Base.$, [ODataLiteralEmitter_$type]);
    return DefaultODataLiteralEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ODataDataSourceFilterExpressionVisitor = /*@__PURE__*/ (() => {
    class ODataDataSourceFilterExpressionVisitor extends FilterExpressionVisitor {
        constructor(a, ..._rest) {
            super();
            this.h = null;
            this.f = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.f = new DefaultODataLiteralEmitter();
                        this.h = new StringBuilder(0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        {
                            this.f = new DefaultODataLiteralEmitter();
                            this.h = new StringBuilder(0);
                        }
                        this.f = c;
                    }
                    break;
            }
        }
        toString() {
            return this.h.toString();
        }
        visitOperationExpression(a) {
            let b = true;
            let c = "";
            switch (a.operator) {
                case 10:
                    c = "add";
                    break;
                case 7:
                    c = "and";
                    break;
                case 13:
                    c = "div";
                    break;
                case 0:
                case 1:
                    c = "eq";
                    break;
                case 3:
                    c = "gt";
                    break;
                case 4:
                    c = "ge";
                    break;
                case 15:
                    b = false;
                    break;
                case 5:
                    c = "lt";
                    break;
                case 6:
                    c = "le";
                    break;
                case 14:
                    c = "mod";
                    break;
                case 12:
                    c = "mul";
                    break;
                case 9:
                    c = "not";
                    b = false;
                    break;
                case 2:
                    c = "ne";
                    break;
                case 8:
                    c = "or";
                    break;
                case 11:
                    c = "sub";
                    break;
                default:
                    c = "eq";
                    break;
            }
            if (b) {
                if (this.g(a, a.left)) {
                    this.h.l("(");
                }
                this.visit(a.left);
                if (this.g(a, a.left)) {
                    this.h.l(")");
                }
                this.h.l(" ");
                this.h.l(c);
                this.h.l(" ");
                if (this.g(a, a.right)) {
                    this.h.l("(");
                }
                this.visit(a.right);
                if (this.g(a, a.right)) {
                    this.h.l(")");
                }
            }
            else {
                if (a.operator == 15) {
                    this.h.l("(");
                }
                else {
                    this.h.u(c + " ");
                }
                if (a.left != null) {
                    this.visit(a.left);
                }
                else {
                    this.visit(a.right);
                }
                if (a.operator == 15) {
                    this.h.l(")");
                }
            }
        }
        g(a, b) {
            let c = a.precedence;
            let d = b != null ? b.precedence : 0;
            if (b != null && b.isOperation && b.operator == 15) {
                return false;
            }
            return d < c;
        }
        visitFunctionExpression(a) {
            let b = "";
            switch (a.functionType) {
                case 19:
                    b = "ceiling";
                    break;
                case 10:
                    b = "concat";
                    break;
                case 0:
                    b = "contains";
                    break;
                case 11:
                    b = "day";
                    break;
                case 1:
                    b = "endswith";
                    break;
                case 18:
                    b = "floor";
                    break;
                case 12:
                    b = "hour";
                    break;
                case 4:
                    b = "indexof";
                    break;
                case FilterExpressionFunctionType.Length:
                    b = "length";
                    break;
                case 13:
                    b = "minute";
                    break;
                case 14:
                    b = "month";
                    break;
                case 5:
                    b = "replace";
                    break;
                case 17:
                    b = "round";
                    break;
                case 15:
                    b = "second";
                    break;
                case 2:
                    b = "startswith";
                    break;
                case 6:
                    b = "substring";
                    break;
                case 7:
                    b = "tolower";
                    break;
                case 8:
                    b = "toupper";
                    break;
                case 9:
                    b = "trim";
                    break;
                case 16:
                    b = "year";
                    break;
            }
            this.h.l(b);
            this.h.l("(");
            let c = true;
            for (let d = 0; d < a.functionArguments.k.count; d++) {
                if (c) {
                    c = false;
                }
                else {
                    this.h.l(", ");
                }
                this.visit(a.functionArguments.k.item(d));
            }
            this.h.l(")");
        }
        visitLiteralExpression(a) {
            this.i(a, a.literalValue);
        }
        i(a, b) {
            let c = this.f.emitLiteral(b, a.leaveUnquoted);
            this.h.l(c);
        }
        visitPropertyReferenceExpression(a) {
            this.j(a.propertyReference);
        }
        j(a) {
            this.h.l(a);
        }
    }
    ODataDataSourceFilterExpressionVisitor.$t = /*@__PURE__*/ markType(ODataDataSourceFilterExpressionVisitor, 'ODataDataSourceFilterExpressionVisitor', FilterExpressionVisitor.$);
    return ODataDataSourceFilterExpressionVisitor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ODataDataSourceSchema = /*@__PURE__*/ (() => {
    class ODataDataSourceSchema extends Base {
        constructor(a, b, c) {
            super();
            this.a = null;
            this.d = null;
            this.e = null;
            this.b = null;
            this.c = null;
            this.d = a;
            this.e = b;
            this.a = c;
        }
        get propertyNames() {
            return this.d;
        }
        get primaryKey() {
            return this.a;
        }
        get propertyTypes() {
            return this.e;
        }
        get propertyDataIntents() {
            return this.b;
        }
        get subSchemas() {
            return this.c;
        }
    }
    ODataDataSourceSchema.$t = /*@__PURE__*/ markType(ODataDataSourceSchema, 'ODataDataSourceSchema', Base.$, [IDataSourceSchema_$type]);
    return ODataDataSourceSchema;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Event arguments for the ProvideCalculator event.
*/
class IgrProvideCalculatorEventArgs {
    createImplementation() {
        return new ProvideCalculatorEventArgs();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets or sets the summary calculator to use for this summary.
    */
    get calculator() {
        return this.i.a;
    }
    set calculator(v) {
        this.i.a = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PagedDataSource = /*@__PURE__*/ (() => {
    class PagedDataSource extends LocalDataSource {
        constructor(a) {
            super();
            this.ea = null;
            this.eb = false;
            this.actualDataProvider = a;
            this.actualDataProvider.executionContext = new DataSourceExecutionContext();
        }
        isPlaceholderItem(a) {
            return !this.eb;
        }
        getItemPropertyAtIndex(a, b) {
            if (this.ea.isVirtual) {
                if (this.getRowType(a) != 0) {
                    return super.getItemPropertyAtIndex(a, b);
                }
                else {
                    let c = this.getItemAtIndex(a);
                    if (c == null) {
                        return null;
                    }
                    return this.getItemProperty(c, b);
                }
            }
            return super.getItemPropertyAtIndex(a, b);
        }
        getItemProperty(a, b) {
            if (a == null) {
                return null;
            }
            if (this.ea.isVirtual) {
                return this.ea.getItemProperty(a, b);
            }
            return super.getItemProperty(a, b);
        }
        setSchema(a) {
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.setSchema(a);
                this.queueAutoRefresh();
            }
        }
    }
    PagedDataSource.$t = /*@__PURE__*/ markType(PagedDataSource, 'PagedDataSource', LocalDataSource.$);
    return PagedDataSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PredictionEnginePageCandidate = /*@__PURE__*/ (() => {
    class PredictionEnginePageCandidate extends Base {
    }
    PredictionEnginePageCandidate.$t = /*@__PURE__*/ markType(PredictionEnginePageCandidate, 'PredictionEnginePageCandidate');
    return PredictionEnginePageCandidate;
})();

/**
 * Represents the final state of items with all transactions combined.
*/
class IgrTransactionState {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets or sets the ID for the state.  I.e. an items primary key.
    */
    get id() {
        return this.i.id;
    }
    set id(v) {
        this.i.id = v;
    }
    /**
     * Gets or sets how this state was created.
    */
    get transactionType() {
        return this.i.transactionType;
    }
    set transactionType(v) {
        this.i.transactionType = ensureEnum(TransactionType_$type, v);
    }
    /**
     * Gets or sets the final value with all transaction deltas combined.
    */
    get value() {
        return this.i.value;
    }
    set value(v) {
        this.i.value = v;
    }
    /**
     * Gets or sets the version data for this item. Used for concurrency.
    */
    get version() {
        return this.i.version;
    }
    set version(v) {
        this.i.version = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enumeration for the different transaction service events.
 */
var TransactionEvent = /*@__PURE__*/ (function (TransactionEvent) {
    /**
     * An undo action has occurred.
     */
    TransactionEvent[TransactionEvent["Undo"] = 0] = "Undo";
    /**
     * A redo action has occurred.
     */
    TransactionEvent[TransactionEvent["Redo"] = 1] = "Redo";
    /**
     * Transactions have been cleared from the service.
     */
    TransactionEvent[TransactionEvent["Clear"] = 2] = "Clear";
    /**
     * A transaction was added to the service.
     */
    TransactionEvent[TransactionEvent["Add"] = 3] = "Add";
    /**
     * Pending transactions have ended.
     */
    TransactionEvent[TransactionEvent["End"] = 4] = "End";
    /**
     * Transactions have been committed.
     */
    TransactionEvent[TransactionEvent["Commit"] = 5] = "Commit";
    return TransactionEvent;
})({});
/**
 * @hidden
 */
let TransactionEvent_$type = /*@__PURE__*/ markEnum('TransactionEvent', 'Undo,0|Redo,1|Clear,2|Add,3|End,4|Commit,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enumeration for the different pending states a transaction can be in.
 */
var TransactionPendingState = /*@__PURE__*/ (function (TransactionPendingState) {
    /**
     * The transaction will stay pending.
     */
    TransactionPendingState[TransactionPendingState["Pending"] = 0] = "Pending";
    /**
     * The transaction is to be accepted.
     */
    TransactionPendingState[TransactionPendingState["Accept"] = 1] = "Accept";
    /**
     * The transaction is to be rejected.
     */
    TransactionPendingState[TransactionPendingState["Reject"] = 2] = "Reject";
    return TransactionPendingState;
})({});
/**
 * @hidden
 */
let TransactionPendingState_$type = /*@__PURE__*/ markEnum('TransactionPendingState', 'Pending,0|Accept,1|Reject,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TypeDescriptionPlatform = /*@__PURE__*/ (function (TypeDescriptionPlatform) {
    TypeDescriptionPlatform[TypeDescriptionPlatform["WPF"] = 0] = "WPF";
    TypeDescriptionPlatform[TypeDescriptionPlatform["JQuery"] = 1] = "JQuery";
    TypeDescriptionPlatform[TypeDescriptionPlatform["React"] = 2] = "React";
    TypeDescriptionPlatform[TypeDescriptionPlatform["Angular"] = 3] = "Angular";
    TypeDescriptionPlatform[TypeDescriptionPlatform["WebComponents"] = 4] = "WebComponents";
    TypeDescriptionPlatform[TypeDescriptionPlatform["XamarinForms"] = 5] = "XamarinForms";
    TypeDescriptionPlatform[TypeDescriptionPlatform["XamarinAndroid"] = 6] = "XamarinAndroid";
    TypeDescriptionPlatform[TypeDescriptionPlatform["XamariniOS"] = 7] = "XamariniOS";
    TypeDescriptionPlatform[TypeDescriptionPlatform["WindowsForms"] = 8] = "WindowsForms";
    TypeDescriptionPlatform[TypeDescriptionPlatform["UWP"] = 9] = "UWP";
    TypeDescriptionPlatform[TypeDescriptionPlatform["WinUI"] = 10] = "WinUI";
    TypeDescriptionPlatform[TypeDescriptionPlatform["Unknown"] = 11] = "Unknown";
    TypeDescriptionPlatform[TypeDescriptionPlatform["Blazor"] = 12] = "Blazor";
    return TypeDescriptionPlatform;
})({});
/**
 * @hidden
 */
let TypeDescriptionPlatform_$type = /*@__PURE__*/ markEnum('TypeDescriptionPlatform', 'WPF,0|JQuery,1|React,2|Angular,3|WebComponents,4|XamarinForms,5|XamarinAndroid,6|XamariniOS,7|WindowsForms,8|UWP,9|WinUI,10|Unknown,11|Blazor,12');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TypeDescriptionWellKnownType = /*@__PURE__*/ (function (TypeDescriptionWellKnownType) {
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Void"] = 0] = "Void";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Number"] = 1] = "Number";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["string1"] = 2] = "string1";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Date"] = 3] = "Date";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Brush"] = 4] = "Brush";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Color"] = 5] = "Color";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["BrushCollection"] = 6] = "BrushCollection";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["boolean1"] = 7] = "boolean1";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["ExportedType"] = 8] = "ExportedType";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Collection"] = 9] = "Collection";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Array"] = 10] = "Array";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Point"] = 11] = "Point";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Size"] = 12] = "Size";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["IList"] = 13] = "IList";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Rect"] = 14] = "Rect";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["DataTemplate"] = 15] = "DataTemplate";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["ColorCollection"] = 16] = "ColorCollection";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Unknown"] = 17] = "Unknown";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["MethodRef"] = 18] = "MethodRef";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["EventRef"] = 19] = "EventRef";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["DataRef"] = 20] = "DataRef";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["TimeSpan"] = 21] = "TimeSpan";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["TemplateRef"] = 22] = "TemplateRef";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["DoubleCollection"] = 23] = "DoubleCollection";
    return TypeDescriptionWellKnownType;
})({});
/**
 * @hidden
 */
let TypeDescriptionWellKnownType_$type = /*@__PURE__*/ markEnum('TypeDescriptionWellKnownType', 'Void,0|Number,1|String:string1,2|Date,3|Brush,4|Color,5|BrushCollection,6|Boolean:boolean1,7|ExportedType,8|Collection,9|Array,10|Point,11|Size,12|IList,13|Rect,14|DataTemplate,15|ColorCollection,16|Unknown,17|MethodRef,18|EventRef,19|DataRef,20|TimeSpan,21|TemplateRef,22|DoubleCollection,23');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IComponentRendererAdapter_$type = /*@__PURE__*/ new Type(null, 'IComponentRendererAdapter');
/**
 * @hidden
 */
let TypeDescriptionContext = /*@__PURE__*/ (() => {
    class TypeDescriptionContext extends Base {
        constructor(a, b) {
            super();
            this.r = new Dictionary$2(String_$type, Base.$, 0);
            this.q = new Dictionary$2(String_$type, Delegate_$type, 0);
            this.g = null;
            this.i = 0;
            this.s = new HashSet$1(Dictionary$2.$.specialize(String_$type, String_$type), 0);
            this.g = a;
            this.i = b;
        }
        ac(a) {
            if (!this.s.contains(a)) {
                this.s.add_1(a);
            }
        }
        k(a) {
            return this.s.contains(a);
        }
        ad(a, b) {
            this.s.add_1(b);
            this.r.item(a, b);
        }
        ae(a, b) {
            this.q.item(a, b);
        }
        static ab(key_) {
            if (key_ == null) {
                return null;
            }
            return key_.substr(0, 1).toUpperCase() + key_.substr(1);
        }
        static aa(key_) {
            if (key_ == null) {
                return null;
            }
            return key_.substr(0, 1).toLowerCase() + key_.substr(1);
        }
        a() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.r.keys)) {
                a.add(b);
            }
            return a.toArray();
        }
        b(a) {
            if (this.r.containsKey(a)) {
                let b = this.r.item(a);
                return new List$1(String_$type, 1, b.keys).toArray();
            }
            else {
                return null;
            }
        }
        getMetadata(a, b) {
            if (this.r.containsKey(a + "@@" + b)) {
                return this.r.item(a + "@@" + b);
            }
            if (this.r.containsKey(a)) {
                let c = new TypeDescriptionMetadata();
                c.owningContext = this;
                c.owningType = a;
                c.propertyName = b;
                let d = this.r.item(a);
                if (!d.containsKey(b)) {
                    this.r.item(a + "@@" + b, null);
                    return null;
                }
                let e = d.item(b);
                let f = "Unknown";
                let g = null;
                let h = null;
                let i = null;
                let j = e.split(')');
                if (j.length > 1) {
                    let k = j[0];
                    e = j[1];
                    k = stringReplace(k, "(", "");
                    let l = k.split(',');
                    for (let n = 0; n < l.length; n++) {
                        let m = l[n];
                        let o = m.split(':');
                        let p = o[0];
                        let q = o[1];
                        let r = 3;
                        switch (p) {
                            case "web":
                                c.q(3, q);
                                c.q(2, q);
                                c.q(4, q);
                                c.q(1, q);
                                continue;
                            case "xam":
                                c.q(6, q);
                                c.q(7, q);
                                c.q(5, q);
                                c.q(9, q);
                                c.q(10, q);
                                continue;
                            case "w":
                                r = 0;
                                break;
                            case "a":
                                r = 3;
                                break;
                            case "r":
                                r = 2;
                                break;
                            case "j":
                                r = 1;
                                break;
                            case "wc":
                                r = 4;
                                break;
                            case "xf":
                                r = 5;
                                break;
                            case "xa":
                                r = 6;
                                break;
                            case "xi":
                                r = 7;
                                break;
                            case "wf":
                                r = 8;
                                break;
                            case "uwp":
                                r = 9;
                                break;
                            case "winui":
                                r = 10;
                                break;
                        }
                        c.q(r, q);
                    }
                }
                let s = e.split(':');
                if (s.length >= 4) {
                    i = s[3];
                }
                if (s.length >= 3) {
                    g = s[2];
                }
                if (s.length >= 2) {
                    h = s[1];
                }
                if (s.length >= 1) {
                    f = s[0];
                }
                if (stringStartsWith(f, "*")) {
                    c.mustBeFirst = true;
                    f = f.substr(1);
                }
                c.knownType = EnumUtil.getEnumValue(TypeDescriptionWellKnownType_$type, EnumUtil.parse(TypeDescriptionWellKnownType_$type, f, true));
                c.specificExternalType = h;
                c.specificType = g;
                if (c.knownType == 19) {
                    if (i == "customEvent") {
                        c.isCustomEvent = true;
                    }
                }
                c.collectionElementType = i;
                this.r.item(a + "@@" + b, c);
                return c;
            }
            return null;
        }
        w(a) {
            if (this.q.containsKey(a)) {
                return this.q.item(a)();
            }
            return null;
        }
        af(a, b, c, d) {
            if (TypeDescriptionMetadata.shouldCamelize(this.i)) {
                b = TypeDescriptionContext.aa(b);
            }
            else {
                b = TypeDescriptionContext.ab(b);
            }
            this.g.setPropertyValue(a, b, c, d, null, null);
        }
        ag(a, b, c, d) {
            b = TypeDescriptionContext.ab(b);
            this.g.setPropertyValue(a, b, c, d, null, null);
        }
        v(a) {
            return this.g.createColorCollection(a);
        }
        u(a) {
            return this.g.createBrushCollection(a);
        }
        x(a) {
            return this.g.createDoubleCollection(a);
        }
        y(a, b, c) {
            return this.g.createObject(a, b, this, c);
        }
        t(a, b, c, d) {
            if (c != null && c.owningType != null && c.propertyName != null && this.j(c.owningType, c.propertyName) && d) {
                let e = this.c(c.owningType, c.propertyName);
                let f = this.d(c.owningType, c.propertyName);
                if (e != null && f != null) {
                    for (let g = 0; g < e.length; g++) {
                        if (e[g].toLowerCase() == b.toLowerCase()) {
                            let h = 0;
                            if (((() => { let i = tryParseInt32_1(f[g], h); h = i.p1; return i.ret; })())) {
                                return h;
                            }
                        }
                    }
                }
            }
            return this.g.coerceToEnum(a, this, b);
        }
        c(a, b) {
            if (this.r.containsKey(a + "@@" + b + "@names")) {
                return this.r.item(a + "@@" + b + "@names");
            }
            if (this.r.containsKey(a)) {
                let c = this.r.item(a);
                if (!c.containsKey(b + "@names")) {
                    this.r.item(a + "@@" + b + "@names", null);
                    return null;
                }
                let d = c.item(b + "@names");
                let e = d.split(';');
                this.r.item(a + "@@" + b + "@names", e);
                return e;
            }
            else {
                return null;
            }
        }
        j(a, b) {
            if (this.r.containsKey(a + "@@" + b + "@constantValues")) {
                return this.r.item(a + "@@" + b + "@constantValues") != null;
            }
            if (this.r.containsKey(a)) {
                let c = this.r.item(a);
                if (!c.containsKey(b + "@constantValues")) {
                    this.r.item(a + "@@" + b + "@constantValues", null);
                    return false;
                }
                let d = c.item(b + "@constantValues");
                let e = d.split(';');
                this.r.item(a + "@@" + b + "@constantValues", e);
                return e != null;
            }
            else {
                return false;
            }
        }
        d(a, b) {
            if (this.r.containsKey(a + "@@" + b + "@constantValues")) {
                return this.r.item(a + "@@" + b + "@constantValues");
            }
            if (this.r.containsKey(a)) {
                let c = this.r.item(a);
                if (!c.containsKey(b + "@constantValues")) {
                    this.r.item(a + "@@" + b + "@constantValues", null);
                    return null;
                }
                let d = c.item(b + "@constantValues");
                let e = d.split(';');
                this.r.item(a + "@@" + b + "@constantValues", e);
                return e;
            }
            else {
                return null;
            }
        }
        hasNameBinding(a, b) {
            if (this.r.containsKey(a + "@@" + b + "@nameBinding")) {
                return this.r.item(a + "@@" + b + "@nameBinding") == "true";
            }
            if (this.r.containsKey(a)) {
                let c = this.r.item(a);
                if (!c.containsKey(b + "@nameBinding")) {
                    this.r.item(a + "@@" + b + "@nameBinding", null);
                    return false;
                }
                let d = c.item(b + "@nameBinding");
                this.r.item(a + "@@" + b + "@names", d);
                return d == "true";
            }
            else {
                return false;
            }
        }
        getMustSetInCodePlatforms(a, b) {
            if (this.r.containsKey(a + "@@" + b + "@mustSetInCode")) {
                return this.r.item(a + "@@" + b + "@mustSetInCode");
            }
            if (this.r.containsKey(a)) {
                let c = this.r.item(a);
                if (!c.containsKey(b + "@mustSetInCode")) {
                    this.r.item(a + "@@" + b + "@mustSetInCode", null);
                    return null;
                }
                let d = c.item(b + "@mustSetInCode");
                let e = d.split(';');
                this.r.item(a + "@@" + b + "@mustSetInCode", e);
                return e;
            }
            else {
                return null;
            }
        }
        getStringUnionPlatforms(a, b) {
            if (this.r.containsKey(a + "@@" + b + "@stringUnion")) {
                return this.r.item(a + "@@" + b + "@stringUnion");
            }
            if (this.r.containsKey(a)) {
                let c = this.r.item(a);
                if (!c.containsKey(b + "@stringUnion")) {
                    this.r.item(a + "@@" + b + "@stringUnion", null);
                    return null;
                }
                let d = c.item(b + "@stringUnion");
                let e = d.split(';');
                this.r.item(a + "@@" + b + "@stringUnion", e);
                return e;
            }
            else {
                return null;
            }
        }
        hasMustSetInCodePlatforms(a, b) {
            if (this.r.containsKey(a + "@@" + b + "@mustSetInCode")) {
                return this.r.item(a + "@@" + b + "@mustSetInCode") != null;
            }
            if (this.r.containsKey(a)) {
                let c = this.r.item(a);
                if (!c.containsKey(b + "@mustSetInCode")) {
                    this.r.item(a + "@@" + b + "@mustSetInCode", null);
                    return false;
                }
                let d = c.item(b + "@mustSetInCode");
                let e = d.split(';');
                this.r.item(a + "@@" + b + "@mustSetInCode", e);
                return true;
            }
            else {
                return false;
            }
        }
        hasStringUnionPlatforms(a, b) {
            if (this.r.containsKey(a + "@@" + b + "@stringUnion")) {
                return this.r.item(a + "@@" + b + "@stringUnion") != null;
            }
            if (this.r.containsKey(a)) {
                let c = this.r.item(a);
                if (!c.containsKey(b + "@stringUnion")) {
                    this.r.item(a + "@@" + b + "@stringUnion", null);
                    return false;
                }
                let d = c.item(b + "@stringUnion");
                let e = d.split(';');
                this.r.item(a + "@@" + b + "@stringUnion", e);
                return true;
            }
            else {
                return false;
            }
        }
        hasQueryListName(a, b) {
            if (this.r.containsKey(a + "@@" + b + "@ngQueryList")) {
                return this.r.item(a + "@@" + b + "@ngQueryList") != null;
            }
            if (this.r.containsKey(a)) {
                let c = this.r.item(a);
                if (!c.containsKey(b + "@ngQueryList")) {
                    this.r.item(a + "@@" + b + "@ngQueryList", null);
                    return false;
                }
                let d = c.item(b + "@ngQueryList");
                this.r.item(a + "@@" + b + "@ngQueryList", d);
                return d != null;
            }
            else {
                return false;
            }
        }
        getQueryListName(a, b) {
            if (this.r.containsKey(a + "@@" + b + "@ngQueryList")) {
                return this.r.item(a + "@@" + b + "@ngQueryList");
            }
            if (this.r.containsKey(a)) {
                let c = this.r.item(a);
                if (!c.containsKey(b + "@ngQueryList")) {
                    this.r.item(a + "@@" + b + "@ngQueryList", null);
                    return null;
                }
                let d = c.item(b + "@ngQueryList");
                this.r.item(a + "@@" + b + "@ngQueryList", d);
                return d;
            }
            else {
                return null;
            }
        }
        p(a) {
            return a == "int" || a == "Int32" || a == "short" || a == "Int16" || a == "double" || a == "Double" || a == "float" || a == "Float" || a == "Single" || a == "single" || a == "DateTime" || a == "decimal" || a == "Decimal" || a == "long" || a == "Int64" || a == "byte" || a == "bool" || a == "string" || a == "String";
        }
    }
    TypeDescriptionContext.$t = /*@__PURE__*/ markType(TypeDescriptionContext, 'TypeDescriptionContext');
    return TypeDescriptionContext;
})();
/**
 * @hidden
 */
let TypeDescriptionMetadata = /*@__PURE__*/ (() => {
    class TypeDescriptionMetadata extends Base {
        constructor() {
            super(...arguments);
            this._owningContext = null;
            this._owningType = null;
            this._propertyName = null;
            this._knownType = 0;
            this._specificType = null;
            this._specificExternalType = null;
            this._collectionElementType = null;
            this._isCustomEvent = false;
            this._mustBeFirst = false;
            this.f = new Dictionary$2(TypeDescriptionPlatform_$type, String_$type, 0);
            this.g = new Dictionary$2(TypeDescriptionPlatform_$type, String_$type, 0);
        }
        get owningContext() {
            return this._owningContext;
        }
        set owningContext(a) {
            this._owningContext = a;
        }
        get owningType() {
            return this._owningType;
        }
        set owningType(a) {
            this._owningType = a;
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get knownType() {
            return this._knownType;
        }
        set knownType(a) {
            this._knownType = a;
        }
        get specificType() {
            return this._specificType;
        }
        set specificType(a) {
            this._specificType = a;
        }
        get specificExternalType() {
            return this._specificExternalType;
        }
        set specificExternalType(a) {
            this._specificExternalType = a;
        }
        get collectionElementType() {
            return this._collectionElementType;
        }
        set collectionElementType(a) {
            this._collectionElementType = a;
        }
        get isCustomEvent() {
            return this._isCustomEvent;
        }
        set isCustomEvent(a) {
            this._isCustomEvent = a;
        }
        get mustBeFirst() {
            return this._mustBeFirst;
        }
        set mustBeFirst(a) {
            this._mustBeFirst = a;
        }
        q(a, b) {
            if (stringContains(b, "/")) {
                let c = b.split('/');
                this.g.item(a, c[1].trim());
                this.f.item(a, c[0].trim());
            }
            else {
                this.f.item(a, b.trim());
            }
        }
        static camelize(a) {
            if (a == null || a.length == 0) {
                return a;
            }
            return a.substr(0, 1).toLowerCase() + a.substr(1);
        }
        static toPascal(a) {
            if (a == null || a.length == 0) {
                return a;
            }
            return a.substr(0, 1).toUpperCase() + a.substr(1);
        }
        j(a) {
            let b = "";
            if (this.f.containsKey(a)) {
                b = this.f.item(a);
            }
            else {
                b = this.propertyName;
            }
            if (TypeDescriptionMetadata.shouldCamelize(a)) {
                return TypeDescriptionMetadata.camelize(b);
            }
            return b;
        }
        static shouldCamelize(a) {
            if (a == 3 || a == 1 || a == 4 || a == 2) {
                return true;
            }
            return false;
        }
        k(a) {
            if (this.g.containsKey(a)) {
                return this.g.item(a);
            }
            else {
                return null;
            }
        }
    }
    TypeDescriptionMetadata.$t = /*@__PURE__*/ markType(TypeDescriptionMetadata, 'TypeDescriptionMetadata');
    return TypeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Description = /*@__PURE__*/ (() => {
    class Description extends Base {
        constructor() {
            super(...arguments);
            this.c = new Dictionary$2(String_$type, Boolean_$type, 0);
            this.d = new List$1(String_$type, 0);
            this.e = null;
        }
        a() {
            if (this.d.count == 0) {
                this.d.add("Type");
            }
            return this.d.toArray();
        }
        g(a) {
            if (!this.c.containsKey(a)) {
                if (this.d.count == 0) {
                    this.d.add("Type");
                }
                this.d.add(a);
            }
            this.c.item(a, true);
        }
        b(a) {
            if (this.c.containsKey(a)) {
                return this.c.item(a);
            }
            return false;
        }
        get name() {
            return this.e;
        }
        set name(a) {
            this.e = a;
            this.g("Name");
        }
    }
    Description.$t = /*@__PURE__*/ markType(Description, 'Description');
    return Description;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JsonWriter = /*@__PURE__*/ (() => {
    class JsonWriter extends Base {
        constructor() {
            super(...arguments);
            this.d = new StringBuilder(0);
            this.b = 0;
            this.a = true;
        }
        g() {
            this.b++;
        }
        e() {
            this.b--;
        }
        i(a) {
            this.f();
            this.d.l(a);
        }
        f() {
            if (this.a) {
                this.a = false;
                for (let a = 0; a < this.b; a++) {
                    this.d.l("\t");
                }
            }
        }
        j(a) {
            this.f();
            this.d.u(a);
            this.a = true;
        }
        h() {
            this.f();
            this.d.t();
            this.a = true;
        }
        toString() {
            return this.d.toString();
        }
    }
    JsonWriter.$t = /*@__PURE__*/ markType(JsonWriter, 'JsonWriter');
    return JsonWriter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JsonDictionaryItem = /*@__PURE__*/ (() => {
    class JsonDictionaryItem extends Base {
        b() {
            let a = new JsonWriter();
            this.d(a);
            return a.toString();
        }
        d(a) {
        }
        a(a) {
            if (a == null) {
                return null;
            }
            return stringReplace(stringReplace(stringReplace(stringReplace(stringReplace(a, "\\", "\\\\"), "\t", "\\t"), "\"", "\\\""), "\r", "\\r"), "\n", "\\n");
        }
        static c(a) {
            if (a == null) {
                return null;
            }
            let b = -1;
            let c = new StringBuilder(0);
            for (let d = 0; d < a.length; d++) {
                if (a.charAt(d) == '\\' && b == -1) {
                    b = d;
                }
                else {
                    if (b == -1) {
                        c.h(a.charAt(d));
                    }
                    else {
                        if (a.charAt(d) == 'n') {
                            c.l("\n");
                            b = -1;
                        }
                        else if (a.charAt(d) == 'r') {
                            c.l("\r");
                            b = -1;
                        }
                        else if (a.charAt(d) == 't') {
                            c.l("\t");
                            b = -1;
                        }
                        else if (a.charAt(d) == '\"') {
                            c.l("\"");
                            b = -1;
                        }
                        else if (a.charAt(d) == '\\') {
                            c.l("\\");
                            b = -1;
                        }
                        else {
                            c.l("\\" + a.charAt(d));
                            b = -1;
                        }
                    }
                }
            }
            return c.toString();
        }
    }
    JsonDictionaryItem.$t = /*@__PURE__*/ markType(JsonDictionaryItem, 'JsonDictionaryItem');
    return JsonDictionaryItem;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JsonDictionaryObject = /*@__PURE__*/ (() => {
    class JsonDictionaryObject extends JsonDictionaryItem {
        constructor() {
            super();
            this.i = new List$1(String_$type, 0);
            this.h = new Dictionary$2(String_$type, JsonDictionaryItem.$, 0);
        }
        j(a, b) {
            if (!this.h.containsKey(a)) {
                this.i.add(a);
            }
            this.h.item(a, b);
        }
        l(a) {
            if (this.h.containsKey(a)) {
                this.i.remove(a);
            }
            this.h.removeItem(a);
        }
        k() {
            this.i.clear();
            this.h.clear();
        }
        item(a, b) {
            if (arguments.length === 2) {
                if (!this.h.containsKey(a)) {
                    this.i.add(a);
                }
                this.h.item(a, b);
                return b;
            }
            else {
                return this.h.item(a);
            }
        }
        g(a) {
            return this.h.containsKey(a);
        }
        e() {
            return this.i.toArray();
        }
        d(a) {
            a.i("{");
            a.h();
            a.g();
            let b = this.e();
            if (b != null) {
                for (let c = 0; c < b.length; c++) {
                    if (c > 0) {
                        a.j(",");
                    }
                    let d = b[c];
                    let e = this.h.item(d);
                    a.i("\"" + this.a(d) + "\": ");
                    if (e == null) {
                        a.i("null");
                    }
                    else {
                        e.d(a);
                    }
                }
            }
            a.h();
            a.e();
            a.i("}");
        }
    }
    JsonDictionaryObject.$t = /*@__PURE__*/ markType(JsonDictionaryObject, 'JsonDictionaryObject', JsonDictionaryItem.$);
    return JsonDictionaryObject;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JsonDictionaryValue = /*@__PURE__*/ (() => {
    class JsonDictionaryValue extends JsonDictionaryItem {
        constructor() {
            super();
            this._value = null;
            this.e = 0;
        }
        get value() {
            return this._value;
        }
        set value(a) {
            this._value = a;
        }
        d(a) {
            switch (this.e) {
                case 1:
                    if (this.value) {
                        a.i("true");
                    }
                    else {
                        a.i("false");
                    }
                    break;
                case 3:
                    a.i("null");
                    break;
                case 0:
                    a.i(this.value.toString());
                    break;
                case 2:
                    a.i("\"" + this.a(this.value) + "\"");
                    break;
            }
        }
    }
    JsonDictionaryValue.$t = /*@__PURE__*/ markType(JsonDictionaryValue, 'JsonDictionaryValue', JsonDictionaryItem.$);
    return JsonDictionaryValue;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ComponentRendererSerializationHelper = /*@__PURE__*/ (() => {
    class ComponentRendererSerializationHelper extends Base {
        static serializeBrush(a) {
            if (a == null) {
                return null;
            }
            let b = a;
            return CSSColorUtil.c(b);
        }
        static serializeColor(a) {
            if (a == null) {
                return null;
            }
            return CSSColorUtil.d(a);
        }
        static serializeBrushCollection(a) {
            if (a == null) {
                return null;
            }
            let b = "";
            let c = a;
            let d = true;
            for (let e of fromEnum(c)) {
                if (d) {
                    d = false;
                }
                else {
                    b += ", ";
                }
                b += ComponentRendererSerializationHelper.serializeBrush(e);
            }
            return b;
        }
        static serializePoint(a) {
            let b = a;
            let c = new JsonDictionaryObject();
            c.item("x", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = b.x;
                return $ret;
            })()));
            c.item("y", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = b.y;
                return $ret;
            })()));
            return c;
        }
        static serializeSize(a) {
            let b = a;
            let c = new JsonDictionaryObject();
            c.item("width", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = b.width;
                return $ret;
            })()));
            c.item("height", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = b.height;
                return $ret;
            })()));
            return c;
        }
        static serializeRect(a) {
            let b = a;
            let c = new JsonDictionaryObject();
            c.item("left", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = b.left;
                return $ret;
            })()));
            c.item("top", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = b.top;
                return $ret;
            })()));
            c.item("width", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = b.width;
                return $ret;
            })()));
            c.item("height", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = b.height;
                return $ret;
            })()));
            return c;
        }
        static serializeColorCollection(a) {
            if (a == null) {
                return null;
            }
            let b = "";
            let c = a;
            let d = true;
            for (let e of fromEnum(c)) {
                if (d) {
                    d = false;
                }
                else {
                    b += ", ";
                }
                b += CSSColorUtil.d(e);
            }
            return b;
        }
        static serializeTimespan(a) {
            if (a == null) {
                return null;
            }
            return timeSpanTotalMilliseconds(a);
        }
        static serializeDoubleCollection(a) {
            if (a == null) {
                return null;
            }
            let b = "";
            let c = a;
            let d = true;
            for (let e of fromEnum(c)) {
                if (d) {
                    d = false;
                }
                else {
                    b += ", ";
                }
                b += numberToString(e, CultureInfo.invariantCulture);
            }
            return b;
        }
    }
    ComponentRendererSerializationHelper.$t = /*@__PURE__*/ markType(ComponentRendererSerializationHelper, 'ComponentRendererSerializationHelper');
    return ComponentRendererSerializationHelper;
})();

class IgrComponentRendererContainer extends Component {
    constructor(props) {
        super(props);
        this.listeners = [];
        this._currentRoot = null;
        this.rootCreated = this.rootCreated.bind(this);
        this.state = {};
    }
    createObject(t, container, context, portalChildren, nameContext) {
        let C = t;
        t = new C();
        return t;
    }
    rootCreated(rootRef) {
        this._currentRoot = rootRef;
        for (let i = 0; i < this.listeners.length; i++) {
            this.listeners[i](rootRef);
        }
        this.listeners.length = 0;
    }
    replaceRootItem(t, deferAttach, continueActions) {
        let act = (r) => {
            continueActions(true);
        };
        this.listeners.push(act);
        this.setState({ rootComponentType: t });
    }
    clearContainer(continueActions) {
        let act = (r) => {
            continueActions(true);
        };
        this.listeners.push(act);
        this.setState({ rootComponentType: null });
    }
    getRootObject() {
        return this._currentRoot;
    }
    render() {
        if (this.state.rootComponentType) {
            let ele = createElement(this.state.rootComponentType, { ref: this.rootCreated, width: "100%", height: "100%" });
            return createElement("div", { style: this.props.style ? this.props.style : { width: "100%", height: "100%" } }, ele);
        }
        else {
            return createElement("div", { style: this.props.style ? this.props.style : { width: "100%", height: "100%" } });
        }
    }
}

class ComponentRendererAdapter {
    constructor() {
        this.isBlazorRenderer = false;
        this._platform = "Igr";
    }
    createObject(type, container, context, nameContext) {
        var isPlain = context.getMetadata(type, "__isPlainObject");
        if (isPlain) {
            return {};
        }
        var origName = type;
        var meta = context.getMetadata(origName, "__qualifiedNameTS");
        if (meta) {
            type = meta.specificExternalType;
        }
        var meta = context.getMetadata(origName, "__qualifiedNameBlazorTS");
        if (meta && this.isBlazorRenderer) {
            type = meta.specificExternalType;
        }
        var tagName = null;
        var meta = context.getMetadata(origName, "__tagNameWC");
        if (meta && this._platform === "Igc") {
            tagName = meta.specificExternalType;
        }
        var portalChildren = false;
        var meta = context.getMetadata(origName, "__portalChildrenWC");
        if (meta && this._platform === "Igc") {
            portalChildren = true;
        }
        if (tagName) {
            if (this._platform === "Igc") {
                let crc = IgrComponentRendererContainer.fromElement(container);
                return crc.createObject(tagName, container, context, portalChildren, nameContext);
            }
        }
        var mustManageInMarkup = false;
        var meta = context.getMetadata(origName, "__manageCollectionInMarkup");
        if (meta) {
            mustManageInMarkup = true;
        }
        var meta = context.getMetadata(origName, "__manageItemInMarkup");
        if (meta) {
            mustManageInMarkup = true;
        }
        var preferUnsuffixed = false;
        var meta = context.getMetadata(origName, "__preferUnsuffixed");
        if (meta) {
            preferUnsuffixed = true;
        }
        if (mustManageInMarkup && this._platform == "Igx") {
            let crc = container;
            return crc.createObject(origName, container, context, false, nameContext);
        }
        let typeName = "Igr" + type + "";
        let shortTypeName = "Igr" + type;
        if (preferUnsuffixed) {
            if (TypeRegistrar.isRegistered(shortTypeName)) {
                return TypeRegistrar.create(shortTypeName);
            }
        }
        if (TypeRegistrar.isRegistered(typeName)) {
            return TypeRegistrar.create(typeName);
        }
        if (TypeRegistrar.isRegistered(shortTypeName)) {
            return TypeRegistrar.create(shortTypeName);
        }
        if (TypeRegistrar.isRegistered(type)) {
            return TypeRegistrar.create(type);
        }
    }
    //createRootObject(type: string, container: any, context: TypeDescriptionContext, continueActions: (resumeRequired: boolean) => void) {
    //    let typeName = "Igr" + type;
    //    if (TypeRegistrar.isRegistered(typeName)) {
    //        let t = TypeRegistrar.get(typeName);
    //        let crc = container as IgrComponentRendererContainer;
    //        crc.createRootObject(t, continueActions);
    //    }
    //}
    createColorCollection(colors) {
        return colors;
    }
    createBrushCollection(brushes) {
        return brushes;
    }
    createDoubleCollection(lengths) {
        return lengths;
    }
    coerceToEnum(type, context, value) {
        return TypeDescriptionMetadata.camelize(value);
    }
    onUIThread(container, action) {
        action();
    }
    setOrUpdateCollectionOnTarget(container, propertyName, propertyMetadata, context, target, value) {
        let coll;
        if (this.mustManageInMarkup(target, propertyName, propertyMetadata, true)) {
            coll = this.getMarkupCollection(target, propertyName, propertyMetadata, true);
        }
        else {
            coll = this.getPropertyValue(target, propertyName);
        }
        if (coll instanceof IgCollection) {
            for (let i = 0; i < coll.count; i++) {
                if (coll.item(i) && coll.item(i)._implementation) {
                    coll.item(i).___parent = null;
                }
            }
            coll.clear();
            let newArr = value;
            for (let i = 0; i < newArr.length; i++) {
                if (newArr[i] && newArr[i]._implementation) {
                    newArr[i].___parent = target;
                }
            }
            for (let i = 0; i < newArr.length; i++) {
                coll.add(newArr[i]);
            }
        }
        else if (Array.isArray(coll) || coll == null || coll == undefined) {
            if (coll) {
                for (let i = 0; i < coll.length; i++) {
                    if (coll[i] && coll[i]._implementation) {
                        coll[i].___parent = null;
                    }
                }
            }
            let newArr = value;
            for (let i = 0; i < newArr.length; i++) {
                if (newArr[i] && newArr[i]._implementation) {
                    newArr[i].___parent = target;
                }
            }
            this.setPropertyValue(target, propertyName, propertyMetadata, value, coll, null);
        }
        else {
            if (coll.clear !== undefined) {
                if (coll.count && coll.item) {
                    for (let i = 0; i < coll.count; i++) {
                        if (coll.item(i) && coll.item(i)._implementation) {
                            coll.item(i).___parent = null;
                        }
                    }
                }
                coll.clear();
            }
            if (coll.add !== undefined) {
                let newArr = value;
                for (let i = 0; i < newArr.length; i++) {
                    if (newArr[i] && newArr[i]._implementation) {
                        newArr[i].___parent = target;
                    }
                }
                for (let i = 0; i < newArr.length; i++) {
                    coll.add(newArr[i]);
                }
            }
        }
    }
    onPendingRef(target, propertyName, propertyMetadata, sourceRef) {
    }
    ensureExternalObject(target, propertyMetadata) {
        if (target && target._implementation) {
            // we are already an external type.
            return target;
        }
        let owningType = propertyMetadata.owningType;
        let context = propertyMetadata.owningContext;
        let typeName = "Igr" + owningType + "";
        var meta = context.getMetadata(owningType, "__qualifiedNameTS");
        if (meta) {
            typeName = "Igr" + meta.specificExternalType + "";
        }
        if (TypeRegistrar.isRegistered(typeName)) {
            return TypeRegistrar.create(typeName);
        }
        typeName = "Igr" + owningType;
        if (meta) {
            typeName = "Igr" + meta.specificExternalType;
        }
        if (TypeRegistrar.isRegistered(typeName)) {
            return TypeRegistrar.create(typeName);
        }
        return null;
    }
    setPropertyValue(target, propertyName, propertyMetadata, value, oldValue, sourceRef) {
        if (this._platform == "Igx" &&
            IgrComponentRendererContainer.isEvent &&
            IgrComponentRendererContainer.isEvent(target[propertyName])) {
            if (target["_" + propertyName + "Subscription"]) {
                target["_" + propertyName + "Subscription"]();
                target["_" + propertyName + "Subscription"] = null;
            }
            if (value != null) {
                var fun = function (ev) {
                    if (ev.sender && ev.args) {
                        value(ev.sender, ev.args);
                    }
                    else {
                        value(ev);
                    }
                };
                var sub = target[propertyName].subscribe(fun);
                target["_" + propertyName + "Subscription"] = sub;
            }
            return;
        }
        var fromScript = value && value.___fromScript;
        if (this._platform == "Igc" &&
            target.addEventListener &&
            propertyMetadata &&
            propertyMetadata.knownType == TypeDescriptionWellKnownType.EventRef &&
            propertyMetadata.isCustomEvent) {
            if (fromScript && this.isBlazorRenderer) {
                if (!target.externalObject) {
                    var ext = this.ensureExternalObject(target, propertyMetadata);
                    if (!ext) {
                        if (value) {
                            target.addEventListener(propertyName, value);
                        }
                        else {
                            target.removeEventListener(propertyName, oldValue);
                        }
                        return;
                    }
                    if (ext !== target) {
                        target.externalObject = ext.i;
                        if (ext.i && !ext.i.nativeElement) {
                            ext.i.nativeElement = target;
                        }
                    }
                }
                let extObj = target.externalObject;
                if (target.externalObject.externalObject) {
                    extObj = target.externalObject.externalObject;
                }
                //extObj[propertyName] = value;
                extObj[propertyName + "Script"] = value.___fromScriptId;
            }
            if (propertyMetadata &&
                propertyMetadata.knownType == TypeDescriptionWellKnownType.EventRef &&
                propertyMetadata.isCustomEvent) {
                if (this.isBlazorRenderer && !fromScript) {
                    if (!target.externalObject) {
                        var ext = this.ensureExternalObject(target, propertyMetadata);
                        if (!ext) {
                            if (value) {
                                target.addEventListener(propertyName, value);
                            }
                            else {
                                target.removeEventListener(propertyName, oldValue);
                            }
                            return;
                        }
                        if (ext !== target) {
                            target.externalObject = ext.i;
                            if (ext.i && !ext.i.nativeElement) {
                                ext.i.nativeElement = target;
                            }
                        }
                    }
                    let extObj = target.externalObject;
                    if (target.externalObject.externalObject) {
                        extObj = target.externalObject.externalObject;
                    }
                    extObj[propertyName] = value;
                }
                else {
                    if (value) {
                        target.addEventListener(propertyName, value);
                    }
                    else {
                        target.removeEventListener(propertyName, oldValue);
                    }
                }
                return;
            }
        }
        if (this._platform == "Igc" &&
            target.emitEvent &&
            target.addEventListener) {
            if (propertyMetadata &&
                propertyMetadata.knownType == TypeDescriptionWellKnownType.EventRef) {
                //TODO: this needs to come from the metadata.
                if (propertyName.endsWith("Ocurred")) {
                    propertyName = propertyName.replace("Ocurred", "");
                }
                if (propertyName.toLowerCase() == "selectionchanged") {
                    propertyName = "selection";
                }
                var eventId = "igc" + TypeDescriptionMetadata.toPascal(propertyName);
                if (value) {
                    target.addEventListener(eventId, value);
                }
                else {
                    target.removeEventListener(eventId, oldValue);
                }
                return;
            }
        }
        if (this._platform == "Igc" &&
            target.addEventListener &&
            this.isBlazorRenderer &&
            propertyMetadata &&
            propertyMetadata.knownType == TypeDescriptionWellKnownType.TemplateRef) {
            var fromScript = value && value.___fromScript;
            if (!fromScript) {
                if (!target.externalObject) {
                    var ext = this.ensureExternalObject(target, propertyMetadata);
                    if (!ext) {
                        target[propertyName] = value;
                        return;
                    }
                    if (ext !== target) {
                        target.externalObject = ext.i;
                        if (ext.i && !ext.i.nativeElement) {
                            ext.i.nativeElement = target;
                        }
                    }
                }
                let extObj = target.externalObject;
                if (target.externalObject.externalObject) {
                    extObj = target.externalObject.externalObject;
                }
                extObj[propertyName] = value;
                return;
            }
        }
        if (oldValue && oldValue._implementation) {
            value.___parent = null;
        }
        if (value && value._implementation) {
            value.___parent = target;
        }
        if (propertyMetadata != null &&
            !(target instanceof Description) &&
            this.mustManageInMarkup(target, propertyName, propertyMetadata, false)) {
            let coll = this.getMarkupCollection(target, propertyName, propertyMetadata, false);
            if (value) {
                coll.add(value);
            }
            else {
                coll.clear();
            }
            return;
        }
        target[propertyName] = value;
    }
    getPropertyValue(target, propertyName) {
        return target[propertyName];
    }
    clearContainer(container, context, continueActions) {
        if (this._platform === "Igc") {
            let crc = IgrComponentRendererContainer.fromElement(container);
            crc.clearContainer(continueActions);
            return;
        }
        let crc = container;
        crc.clearContainer(continueActions);
    }
    getRootObject(container) {
        if (this._platform === "Igc") {
            let crc = IgrComponentRendererContainer.fromElement(container);
            return crc.getRootObject();
        }
        let crc = container;
        return crc.getRootObject();
    }
    forPropertyValueItem(target, propertyName, forItem) {
        let coll = this.getPropertyValue(target, propertyName);
        if (coll instanceof IgCollection) {
            for (let i = 0; i < coll.count; i++) {
                forItem(coll.item(i));
            }
        }
        else if (Array.isArray(coll)) {
            for (let i = 0; i < coll.length; i++) {
                forItem(coll[i]);
            }
        }
        else {
            if (coll.clear !== undefined) {
                for (let i = 0; i < coll.count; i++) {
                    forItem(coll.item(i));
                }
            }
        }
    }
    getMarkupTypeMatcher(target, propertyName, metadata, isCollection) {
        if (this._platform === "Igc" || this._platform === "Igx") {
            if ((isCollection && metadata.knownType !== TypeDescriptionWellKnownType.Collection) ||
                (!isCollection && metadata.knownType !== TypeDescriptionWellKnownType.ExportedType)) {
                return null;
            }
            if (isCollection) {
                let type = metadata.collectionElementType;
                let origName = type;
                var meta = metadata.owningContext.getMetadata(type, "__qualifiedNameTS");
                if (meta) {
                    type = meta.specificExternalType;
                }
                var tagName = null;
                meta = metadata.owningContext.getMetadata(origName, "__tagNameWC");
                if (meta && this._platform === "Igc") {
                    tagName = meta.specificExternalType;
                    if (tagName) {
                        if (window && window.customElements && window.customElements.get) {
                            let tags = [];
                            let tt = window.customElements.get(tagName);
                            if (tt) {
                                tags.push(tt);
                            }
                            var subMeta = metadata.owningContext.getMetadata(origName, "__tagNameWCSubstitutable");
                            if (subMeta) {
                                let subs = subMeta.specificExternalType;
                                let subParts = subs.split(',');
                                for (var j = 0; j < subParts.length; j++) {
                                    let subPart = subParts[j];
                                    let subT = window.customElements.get(subPart);
                                    if (subT) {
                                        tags.push(subT);
                                    }
                                }
                            }
                            return (o) => {
                                if (tags.length == 0) {
                                    return false;
                                }
                                for (let i = 0; i < tags.length; i++) {
                                    if (o instanceof tags[i]) {
                                        return true;
                                    }
                                }
                                return false;
                            };
                        }
                    }
                }
                let typeName = "Igr" + type + "";
                if (TypeRegistrar.isRegistered(typeName)) {
                    let t = TypeRegistrar.get(typeName);
                    return (o) => o instanceof t;
                }
                let shortTypeName = "Igr" + type;
                if (TypeRegistrar.isRegistered(shortTypeName)) {
                    let t = TypeRegistrar.get(shortTypeName);
                    return (o) => o instanceof t;
                }
                if (TypeRegistrar.isRegistered(type)) {
                    let t = TypeRegistrar.get(type);
                    return (o) => o instanceof t;
                }
            }
            else {
                var type = metadata.specificExternalType;
                let origName = type;
                var meta = metadata.owningContext.getMetadata(type, "__qualifiedNameTS");
                if (meta) {
                    type = meta.specificExternalType;
                }
                var tagName = null;
                meta = metadata.owningContext.getMetadata(origName, "__tagNameWC");
                if (meta && this._platform === "Igc") {
                    tagName = meta.specificExternalType;
                    if (tagName) {
                        if (window && window.customElements && window.customElements.get) {
                            let tags = [];
                            let tt = window.customElements.get(tagName);
                            if (tt) {
                                tags.push(tt);
                            }
                            var subMeta = metadata.owningContext.getMetadata(origName, "__tagNameWCSubstitutable");
                            if (subMeta) {
                                let subs = subMeta.specificExternalType;
                                let subParts = subs.split(',');
                                for (var j = 0; j < subParts.length; j++) {
                                    let subPart = subParts[j];
                                    let subT = window.customElements.get(subPart);
                                    if (subT) {
                                        tags.push(subT);
                                    }
                                }
                            }
                            return (o) => {
                                if (tags.length == 0) {
                                    return false;
                                }
                                for (let i = 0; i < tags.length; i++) {
                                    if (o instanceof tags[i]) {
                                        return true;
                                    }
                                }
                                return false;
                            };
                        }
                    }
                }
                let typeName = "Igr" + type + "";
                if (TypeRegistrar.isRegistered(typeName)) {
                    let t = TypeRegistrar.get(typeName);
                    return (o) => o instanceof t;
                }
                let shortTypeName = "Igr" + type;
                if (TypeRegistrar.isRegistered(shortTypeName)) {
                    let t = TypeRegistrar.get(shortTypeName);
                    return (o) => o instanceof t;
                }
                if (TypeRegistrar.isRegistered(type)) {
                    let t = TypeRegistrar.get(type);
                    return (o) => o instanceof t;
                }
            }
        }
        return null;
    }
    mustManageInMarkup(target, propertyName, metadata, isCollection) {
        if (this._platform === "Igc" || this._platform === "Igx") {
            if ((isCollection && metadata.knownType !== TypeDescriptionWellKnownType.Collection) ||
                (!isCollection && metadata.knownType !== TypeDescriptionWellKnownType.ExportedType)) {
                return false;
            }
            if (isCollection) {
                var ele = metadata.collectionElementType;
                var needsMarkup = metadata.owningContext.getMetadata(ele, "__manageCollectionInMarkup");
                if (needsMarkup) {
                    return true;
                }
            }
            else {
                var ele = metadata.specificExternalType;
                var needsMarkup = metadata.owningContext.getMetadata(ele, "__manageItemInMarkup");
                if (needsMarkup) {
                    return true;
                }
            }
        }
        return false;
    }
    getMarkupCollection(target, propertyName, metadata, isCollection) {
        if (this._platform == "Igx") {
            return new ngMarkupCollection(target, this._platform, this.getMarkupTypeMatcher(target, propertyName, metadata, isCollection), metadata);
        }
        else {
            return new HtmlMarkupCollection(target, this._platform, this.getMarkupTypeMatcher(target, propertyName, metadata, isCollection));
        }
    }
    clearCollection(target, propertyName, metadata) {
        let coll;
        if (this.mustManageInMarkup(target, propertyName, metadata, true)) {
            coll = this.getMarkupCollection(target, propertyName, metadata, true);
        }
        else {
            coll = this.getPropertyValue(target, propertyName);
        }
        if (coll instanceof IgCollection) {
            for (let i = 0; i < coll.count; i++) {
                if (coll.item(i) && coll.item(i)._implementation) {
                    coll.item(i).___parent = null;
                }
            }
            coll.clear();
        }
        else if (Array.isArray(coll)) {
            for (let i = 0; i < coll.length; i++) {
                if (coll[i] && coll[i]._implementation) {
                    coll[i].___parent = null;
                }
            }
            this.setPropertyValue(target, propertyName, metadata, [], coll, null);
        }
        else {
            if (coll.clear !== undefined) {
                for (let i = 0; i < coll.count; i++) {
                    if (coll.item(i) && coll.item(i)._implementation) {
                        coll.item(i).___parent = null;
                    }
                }
                coll.clear();
            }
        }
    }
    addItemToCollection(propertyName, propertyMetadata, target, newIndex, item) {
        let coll;
        if (this.mustManageInMarkup(target, propertyName, propertyMetadata, true)) {
            coll = this.getMarkupCollection(target, propertyName, propertyMetadata, true);
        }
        else {
            coll = this.getPropertyValue(target, propertyName);
        }
        if (item && item._implementation) {
            item.___parent = target;
        }
        if (coll instanceof IgCollection) {
            coll.insert(newIndex, item);
        }
        else if (Array.isArray(coll)) {
            let newArr = [];
            for (let i = 0; i < coll.length; i++) {
                newArr[i] = coll[i];
            }
            newArr.splice(newIndex, 0, item);
            this.setPropertyValue(target, propertyName, propertyMetadata, newArr, coll, null);
        }
        else {
            if (coll.insert !== undefined) {
                coll.insert(newIndex, item);
            }
        }
    }
    resetPropertyOnTarget(container, propertyName, propertyMetadata, target) {
        //TODO: anything we can do here? store default?
    }
    replaceItemInCollection(propertyName, propertyMetadata, target, newIndex, item) {
        let coll;
        if (this.mustManageInMarkup(target, propertyName, propertyMetadata, true)) {
            coll = this.getMarkupCollection(target, propertyName, propertyMetadata, true);
        }
        else {
            coll = this.getPropertyValue(target, propertyName);
        }
        if (item && item._implementation) {
            item.___parent = target;
        }
        if (coll instanceof IgCollection) {
            let oldValue = coll.item(newIndex);
            if (oldValue && oldValue._implementation) {
                oldValue.___parent = null;
            }
            coll.item(newIndex, item);
        }
        else if (Array.isArray(coll)) {
            let newArr = [];
            for (let i = 0; i < coll.length; i++) {
                newArr[i] = coll[i];
            }
            let oldValue = newArr[newIndex];
            if (oldValue && oldValue._implementation) {
                oldValue.___parent = null;
            }
            newArr[newIndex] = item;
            this.setPropertyValue(target, propertyName, propertyMetadata, newArr, coll, null);
        }
        else {
            if (coll.item !== undefined) {
                let oldValue = coll.item(newIndex);
                if (oldValue && oldValue._implementation) {
                    oldValue.___parent = null;
                }
                coll.item(newIndex, item);
            }
        }
    }
    removeItemFromCollection(propertyName, propertyMetadata, target, oldIndex) {
        let coll;
        if (this.mustManageInMarkup(target, propertyName, propertyMetadata, true)) {
            coll = this.getMarkupCollection(target, propertyName, propertyMetadata, true);
        }
        else {
            coll = this.getPropertyValue(target, propertyName);
        }
        if (coll instanceof IgCollection) {
            let oldValue = coll.item(oldIndex);
            if (oldValue && oldValue._implementation) {
                oldValue.___parent = null;
            }
            coll.removeAt(oldIndex);
        }
        else if (Array.isArray(coll)) {
            let newArr = [];
            for (let i = 0; i < coll.length; i++) {
                newArr[i] = coll[i];
            }
            let oldValue = newArr[oldIndex];
            if (oldValue && oldValue._implementation) {
                oldValue.___parent = null;
            }
            newArr.splice(oldIndex, 1);
            this.setPropertyValue(target, propertyName, propertyMetadata, newArr, coll, null);
        }
        else {
            if (coll.removeAt !== undefined) {
                let oldValue = coll.item(oldIndex);
                if (oldValue && oldValue._implementation) {
                    oldValue.___parent = null;
                }
                coll.removeAt(oldIndex);
            }
        }
    }
    replaceRootItem(container, type, context, continueActions) {
        let typeName = "Igr" + type + "";
        let deferAttach = false;
        var meta = context.getMetadata(type, "__qualifiedNameTS");
        if (meta) {
            typeName = "Igr" + meta.specificExternalType + "";
        }
        meta = context.getMetadata(type, "__deferAttachWC");
        if (meta && this._platform === "Igc") {
            deferAttach = true;
        }
        var tagName = null;
        var meta = context.getMetadata(type, "__tagNameWC");
        if (meta && this._platform === "Igc") {
            tagName = meta.specificExternalType;
        }
        if (tagName) {
            if (this._platform === "Igc") {
                let crc = IgrComponentRendererContainer.fromElement(container);
                crc.replaceRootItem(tagName, deferAttach, continueActions);
                return;
            }
        }
        if (TypeRegistrar.isRegistered(typeName)) {
            let t = TypeRegistrar.get(typeName);
            if (this._platform === "Igc") {
                let crc = IgrComponentRendererContainer.fromElement(container);
                crc.replaceRootItem(t, deferAttach, continueActions);
                return;
            }
            let crc = container;
            crc.replaceRootItem(t, deferAttach, continueActions);
        }
        else {
            if (this._platform === "Igc") {
                let crc = IgrComponentRendererContainer.fromElement(container);
                crc.clearContainer(continueActions);
                return;
            }
            let crc = container;
            crc.clearContainer(continueActions);
        }
    }
    removeRootItem(container, context, continueActions) {
        this.clearContainer(container, context, continueActions);
    }
    flushChanges(container) {
    }
    executeMethod(target, methodName, argumentValues_, argumentMetadata, onFinished) {
        var meth = TypeDescriptionMetadata.camelize(methodName);
        var methInfo_ = target[methodName];
        let ret = null;
        if (methInfo_ != null) {
            ret = methInfo_.apply(target, argumentValues_);
        }
        onFinished(ret);
    }
    serializeBrush(value) {
        return ComponentRendererSerializationHelper.serializeBrush(value);
    }
    serializeColor(value) {
        return ComponentRendererSerializationHelper.serializeColor(value);
    }
    serializeBrushCollection(value) {
        return ComponentRendererSerializationHelper.serializeBrushCollection(value);
    }
    serializePoint(value) {
        return ComponentRendererSerializationHelper.serializePoint(value);
    }
    serializeSize(value) {
        return ComponentRendererSerializationHelper.serializeSize(value);
    }
    serializeRect(value) {
        return ComponentRendererSerializationHelper.serializeRect(value);
    }
    serializeColorCollection(value) {
        return ComponentRendererSerializationHelper.serializeColorCollection(value);
    }
    serializeTimespan(value) {
        return ComponentRendererSerializationHelper.serializeTimespan(value);
    }
    serializeDoubleCollection(value) {
        return ComponentRendererSerializationHelper.serializeDoubleCollection(value);
    }
}
class MarkupCollection {
    constructor(target, platform) {
    }
}
//TODO: this could be more efficient if it tracked the child list changes and maintained a current view rather than repolling
class ngMarkupCollection extends MarkupCollection {
    getItems() {
        return this._target["___listContent" + this._propertyName];
    }
    get count() {
        return this.getItems().length;
    }
    clear() {
        let items = this.getItems();
        items.length = 0;
        this.notifyList();
    }
    item(index, value) {
        let items = this.getItems();
        items[index] = value;
        this.notifyList();
    }
    removeAt(index) {
        let items = this.getItems();
        items.splice(index, 1);
        this.notifyList();
    }
    insert(index, item) {
        let items = this.getItems();
        items.splice(index, 0, item);
        this.notifyList();
    }
    add(item) {
        let items = this.getItems();
        items.push(item);
        this.notifyList();
    }
    notifyList() {
        let items = this.getItems();
        let qList = this._target[this._queryListName];
        qList.reset([...items]);
        qList.notifyOnChanges();
    }
    constructor(target, platform, typeMatcher, metadata) {
        super(target, platform);
        this._target = target;
        if (metadata.owningContext.hasQueryListName(metadata.owningType, metadata.propertyName)) {
            let queryListName = (metadata.owningContext.getQueryListName(metadata.owningType, metadata.propertyName));
            this._queryListName = queryListName;
        }
        this._componentRef = target.___owningRef;
        this._viewContainerRef = target.___viewContainerRef;
        this._propertyName = metadata.propertyName;
        if (!this._target["___listContent" + metadata.propertyName]) {
            this._target["___listContent" + metadata.propertyName] = [];
        }
    }
}
//TODO: this could be more efficient if it tracked the child list changes and maintained a current view rather than repolling
class HtmlMarkupCollection extends MarkupCollection {
    get count() {
        let items = Array.from(this._target.children).map((v, i) => { return { item: v, index: i }; }).filter((i) => this._typeMatcher(i.item));
        return items.length;
    }
    clear() {
        let items = Array.from(this._target.children).map((v, i) => { return { item: v, index: i }; }).filter((i) => this._typeMatcher(i.item));
        for (var i = 0; i < items.length; i++) {
            items[i].item.remove();
        }
    }
    item(index, value) {
        let items = Array.from(this._target.children).map((v, i) => { return { item: v, index: i }; }).filter((i) => this._typeMatcher(i.item));
        if (value) {
            if (index > items.length - 1 || index < 0) {
                return value;
            }
            items[index].item.replaceWith(value);
            return value;
        }
        else {
            if (index > items.length - 1 || index < 0) {
                return null;
            }
            return items[index].item;
        }
    }
    removeAt(index) {
        let items = Array.from(this._target.children).map((v, i) => { return { item: v, index: i }; }).filter((i) => this._typeMatcher(i.item));
        if (index > items.length - 1 || index < 0) {
            return;
        }
        let removeItem = items[index];
        removeItem.item.remove();
    }
    insert(index, item) {
        let items = Array.from(this._target.children).map((v, i) => { return { item: v, index: i }; }).filter((i) => this._typeMatcher(i.item));
        if (items.length == 0) {
            this._target.append(item);
        }
        else {
            if (items.length - 1 < index) {
                let insertAfter2 = items[items.length - 1].item;
                insertAfter2.after(item);
                return;
            }
            let insertAfter = items[index].item;
            insertAfter.after(item);
        }
    }
    add(item) {
        let items = Array.from(this._target.children).map((v, i) => { return { item: v, index: i }; }).filter((i) => this._typeMatcher(i.item));
        if (items.length == 0) {
            this._target.append(item);
        }
        else {
            let insertAfter = items[items.length - 1].item;
            insertAfter.after(item);
        }
    }
    constructor(target, platform, typeMatcher) {
        super(target, platform);
        this._target = target;
        this._typeMatcher = typeMatcher;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrComponentRendererContainerModule {
    static register() {
        TypeRegistrar.registerCons("IgrComponentRendererContainer", IgrComponentRendererContainer);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var CodeGenerationTargetPlatforms = /*@__PURE__*/ (function (CodeGenerationTargetPlatforms) {
    CodeGenerationTargetPlatforms[CodeGenerationTargetPlatforms["WPF"] = 0] = "WPF";
    CodeGenerationTargetPlatforms[CodeGenerationTargetPlatforms["Angular"] = 1] = "Angular";
    CodeGenerationTargetPlatforms[CodeGenerationTargetPlatforms["React"] = 2] = "React";
    CodeGenerationTargetPlatforms[CodeGenerationTargetPlatforms["WebComponents"] = 3] = "WebComponents";
    CodeGenerationTargetPlatforms[CodeGenerationTargetPlatforms["WindowsForms"] = 4] = "WindowsForms";
    CodeGenerationTargetPlatforms[CodeGenerationTargetPlatforms["Blazor"] = 5] = "Blazor";
    return CodeGenerationTargetPlatforms;
})({});
/**
 * @hidden
 */
let CodeGenerationTargetPlatforms_$type = /*@__PURE__*/ markEnum('CodeGenerationTargetPlatforms', 'WPF,0|Angular,1|React,2|WebComponents,3|WindowsForms,4|Blazor,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationItemBuilderPropertyInfo = /*@__PURE__*/ (() => {
    class CodeGenerationItemBuilderPropertyInfo extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
            this.c = null;
            this.a = null;
        }
    }
    CodeGenerationItemBuilderPropertyInfo.$t = /*@__PURE__*/ markType(CodeGenerationItemBuilderPropertyInfo, 'CodeGenerationItemBuilderPropertyInfo');
    return CodeGenerationItemBuilderPropertyInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingImportManager = /*@__PURE__*/ (() => {
    class CodeGeneratingImportManager extends Base {
        constructor() {
            super(...arguments);
            this._packageOverride = null;
            this._isImportsOnly = false;
            this.k = new List$1(String_$type, 0);
            this.i = new HashSet$1(String_$type, 0);
            this.j = new List$1(String_$type, 0);
            this.h = new HashSet$1(String_$type, 0);
            this.f = new Dictionary$2(String_$type, List$1.$.specialize(String_$type), 0);
            this.g = new Dictionary$2(String_$type, HashSet$1.$.specialize(String_$type), 0);
        }
        get packageOverride() {
            return this._packageOverride;
        }
        set packageOverride(a) {
            this._packageOverride = a;
        }
        get isImportsOnly() {
            return this._isImportsOnly;
        }
        set isImportsOnly(a) {
            this._isImportsOnly = a;
        }
        addUsing(a) {
            if (!this.i.contains(a)) {
                this.i.add_1(a);
                this.k.add(a);
            }
        }
        get hasPackageImports() {
            return this.f.count > 0;
        }
        packageImportsToString() {
            let a = new StringBuilder(0);
            for (let b = 0; b < this.j.count; b++) {
                let c = this.j._inner[b];
                let d = this.f.item(c);
                let e = stringJoin1(String_$type, ", ", d);
                if (this.isImportsOnly && b > 0) {
                    a.u(",");
                }
                if (this.isImportsOnly) {
                    a.l(e);
                }
                else {
                    if (this.h.contains(c)) {
                        if (e == "@SELF@") {
                            a.u("import '" + c + "';");
                        }
                        else {
                            a.u("import " + e + " from '" + c + "';");
                        }
                    }
                    else {
                        a.u("import { " + e + " } from '" + c + "';");
                    }
                }
            }
            return a.toString();
        }
        usingsToString(a) {
            let b = new StringBuilder(0);
            for (let c = 0; c < this.k.count; c++) {
                if (!stringStartsWith(this.k._inner[c].trim(), "@") && a) {
                    b.u("@" + this.k._inner[c]);
                }
                else {
                    b.u(this.k._inner[c]);
                }
            }
            return b.toString();
        }
        any() {
            return this.j.count > 0 || this.k.count > 0;
        }
        addPackageImport(a, b) {
            if (this.packageOverride != null) {
                a = this.packageOverride;
            }
            if (!this.g.containsKey(a)) {
                this.j.add(a);
                this.g.addItem(a, new HashSet$1(String_$type, 0));
                this.f.addItem(a, new List$1(String_$type, 0));
            }
            if (!this.g.item(a).contains(b)) {
                this.g.item(a).add_1(b);
                this.f.item(a).add(b);
            }
        }
        addDefaultImport(a, b) {
            if (this.packageOverride != null) {
                a = this.packageOverride;
            }
            if (!this.g.containsKey(a)) {
                this.j.add(a);
                this.g.addItem(a, new HashSet$1(String_$type, 0));
                this.f.addItem(a, new List$1(String_$type, 0));
                this.h.add_1(a);
            }
            if (!this.g.item(a).contains(b)) {
                this.g.item(a).add_1(b);
                this.f.item(a).add(b);
            }
        }
        static merge(a, b) {
            let c = new CodeGeneratingImportManager();
            if (a.isImportsOnly || b.isImportsOnly) {
                c.isImportsOnly = true;
            }
            if (b.f.count > 0 || a.f.count > 0) {
                for (let d of fromEnum(a.f.keys)) {
                    for (let e of fromEnum(a.f.item(d))) {
                        if (a.h.contains(d)) {
                            c.addDefaultImport(d, e);
                        }
                        else {
                            c.addPackageImport(d, e);
                        }
                    }
                }
                for (let f of fromEnum(b.f.keys)) {
                    for (let g of fromEnum(b.f.item(f))) {
                        if (b.h.contains(f)) {
                            c.addDefaultImport(f, g);
                        }
                        else {
                            c.addPackageImport(f, g);
                        }
                    }
                }
            }
            else {
                for (let h of fromEnum(a.k)) {
                    c.addUsing(h);
                }
                for (let i of fromEnum(b.k)) {
                    c.addUsing(i);
                }
            }
            return c;
        }
        removeDuplicates(a) {
            let b = CodeGeneratingImportManager.merge(this, new CodeGeneratingImportManager());
            if (this.isImportsOnly) {
                b.isImportsOnly = true;
            }
            if (a.f.count > 0) {
                for (let c of fromEnum(a.f.keys)) {
                    if (this.f.containsKey(c)) {
                        for (let d of fromEnum(a.f.item(c))) {
                            if (b.g.containsKey(c) && b.g.item(c).contains(d)) {
                                b.g.item(c).remove(d);
                                b.f.item(c).remove(d);
                                if (b.f.item(c).count == 0) {
                                    b.j.remove(c);
                                    b.h.remove(c);
                                    b.g.removeItem(c);
                                    b.f.removeItem(c);
                                }
                            }
                        }
                    }
                }
            }
            else {
                for (let e of fromEnum(a.k)) {
                    if (b.i.contains(e)) {
                        b.i.remove(e);
                        b.k.remove(e);
                    }
                }
            }
            return b;
        }
    }
    CodeGeneratingImportManager.$t = /*@__PURE__*/ markType(CodeGeneratingImportManager, 'CodeGeneratingImportManager');
    return CodeGeneratingImportManager;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingRendererResult = /*@__PURE__*/ (() => {
    class CodeGeneratingRendererResult extends Base {
        constructor() {
            super(...arguments);
            this.q = new List$1(CodeGenerationItemBuilderPropertyInfo.$, 0);
            this._platform = 0;
            this._generationOptions = null;
            this.l = new Dictionary$2(String_$type, List$1.$.specialize(String_$type), 0);
            this.n = new Dictionary$2(String_$type, List$1.$.specialize(CodeGeneratingImportManager.$), 0);
            this.k = new Dictionary$2(String_$type, List$1.$.specialize(String_$type), 0);
            this.p = new HashSet$1(String_$type, 0);
            this.i = new Dictionary$2(String_$type, Number_$type, 0);
            this.o = new Dictionary$2(String_$type, String_$type, 0);
            this.m = new Dictionary$2(String_$type, String_$type, 0);
            this.j = new Dictionary$2(String_$type, Number_$type, 0);
        }
        get t() {
            return this.q;
        }
        get platform() {
            return this._platform;
        }
        set platform(a) {
            this._platform = a;
        }
        get generationOptions() {
            return this._generationOptions;
        }
        set generationOptions(a) {
            this._generationOptions = a;
        }
        addPackageRef(a) {
            this.p.add_1(a);
        }
        addContainerResult(a, b) {
            if (!this.l.containsKey(a)) {
                this.l.addItem(a, new List$1(String_$type, 0));
            }
            let c = this.l.item(a);
            c.add(b);
        }
        addImportResult(a, b) {
            if (!this.n.containsKey(a)) {
                this.n.addItem(a, new List$1(CodeGeneratingImportManager.$, 0));
            }
            let c = this.n.item(a);
            c.add(b);
        }
        addContainerNewFileResult(a, b) {
            if (!this.k.containsKey(a)) {
                this.k.addItem(a, new List$1(String_$type, 0));
            }
            let c = this.k.item(a);
            c.add(b);
        }
        getPackages() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.p)) {
                a.add(b);
            }
            return a.toArray();
        }
        getKeys() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.l.keys)) {
                a.add(b);
            }
            return a.toArray();
        }
        getImportsKeys() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.n.keys)) {
                a.add(b);
            }
            return a.toArray();
        }
        getContentForKey(a) {
            if (!this.l.containsKey(a)) {
                return "";
            }
            let b = this.l.item(a);
            if (b.count == 1) {
                return b._inner[0];
            }
            let c = "";
            for (let d of fromEnum(b)) {
                c += d;
            }
            return c;
        }
        r(a) {
            if (!this.n.containsKey(a)) {
                return null;
            }
            return this.n.item(a);
        }
        getImportsArrayForKey(a) {
            let b = this.r(a);
            if (b == null) {
                return null;
            }
            return b.toArray();
        }
        u(a) {
            if (!this.i.containsKey(a)) {
                this.i.item(a, 1);
            }
            let b = this.i.item(a);
            let c = a + b;
            this.i.item(a, b + 1);
            return c;
        }
        af(a) {
            this.q.add(a);
        }
        getNewFiles() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.k.keys)) {
                a.add(b);
            }
            return a;
        }
        getNewFileContent(a) {
            let b = this.k.item(a);
            let c = "";
            for (let d of fromEnum(b)) {
                c += d;
            }
            return c;
        }
        defineString(a, b) {
            this.o.item(a, b);
        }
        getStringNames() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.o.keys)) {
                a.add(b);
            }
            return a.toArray();
        }
        getString(a) {
            return this.o.item(a);
        }
        trackDescriptionField(a, b) {
            this.m.item(a, b);
        }
        hasDescription(a) {
            return this.m.containsKey(a);
        }
        getDescriptionField(a) {
            return this.m.item(a);
        }
        v(a) {
            let b = 0;
            if (!this.j.containsKey(a)) {
                this.j.addItem(a, b);
            }
            else {
                b = this.j.item(a);
            }
            b++;
            this.j.item(a, b);
            return a + b;
        }
    }
    CodeGeneratingRendererResult.$t = /*@__PURE__*/ markType(CodeGeneratingRendererResult, 'CodeGeneratingRendererResult');
    return CodeGeneratingRendererResult;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingCodeWriter = /*@__PURE__*/ (() => {
    class CodeGeneratingCodeWriter extends Base {
        constructor(a) {
            super();
            this.e = new StringBuilder(0);
            this.c = 0;
            this.b = true;
            this.a = null;
            this.a = a;
        }
        h() {
            this.c++;
        }
        f() {
            this.c--;
        }
        j(a) {
            this.g();
            this.e.l(a);
        }
        g() {
            if (this.b) {
                this.b = false;
                for (let a = 0; a < this.c; a++) {
                    if (this.a.useSpacesForIndent) {
                        for (let b = 0; b < this.a.indentSpaces; b++) {
                            this.e.l(" ");
                        }
                    }
                    else {
                        this.e.l("\t");
                    }
                }
            }
        }
        l(a) {
            this.g();
            this.e.u(a);
            this.b = true;
        }
        k(a) {
            let b = stringReplace(a, "\r\n", "\n").split('\n');
            for (let d = 0; d < b.length; d++) {
                let c = b[d];
                let e = trimStart(c, ...['\r', '\n']);
                this.l(e);
            }
        }
        i() {
            this.g();
            this.e.t();
            this.b = true;
        }
        toString() {
            return this.e.toString();
        }
    }
    CodeGeneratingCodeWriter.$t = /*@__PURE__*/ markType(CodeGeneratingCodeWriter, 'CodeGeneratingCodeWriter');
    return CodeGeneratingCodeWriter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationSpecialValue = /*@__PURE__*/ (() => {
    class CodeGenerationSpecialValue extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = null;
        }
    }
    CodeGenerationSpecialValue.$t = /*@__PURE__*/ markType(CodeGenerationSpecialValue, 'CodeGenerationSpecialValue');
    return CodeGenerationSpecialValue;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebImportsHalper = /*@__PURE__*/ (() => {
    class WebImportsHalper extends Base {
        static b(a, b, c, d, e, f, g) {
            for (let h of fromEnum(f)) {
                let i = h;
                let j = h;
                let k = null;
                if (stringContains(i, ":")) {
                    let l = i.split(':');
                    i = l[0];
                    k = l[1];
                    j = i;
                }
                if (stringEndsWith(i, "Component")) {
                    i = i.substr(0, i.length - ("Component").length);
                }
                if (stringStartsWith(i, d)) {
                    i = i.substr(d.length);
                }
                if (e.getMetadata(i, "__importTypes" + EnumUtil.getName(CodeGenerationTargetPlatforms_$type, a.platform)) != null) {
                    g.addPackageImport(e.getMetadata(i, "__importTypes" + EnumUtil.getName(CodeGenerationTargetPlatforms_$type, a.platform)).specificExternalType, j);
                }
                else if (e.getMetadata("Web" + i, "__importTypes" + EnumUtil.getName(CodeGenerationTargetPlatforms_$type, a.platform)) != null) {
                    g.addPackageImport(e.getMetadata("Web" + i, "__importTypes" + EnumUtil.getName(CodeGenerationTargetPlatforms_$type, a.platform)).specificExternalType, j);
                }
                else {
                    if (k != null) {
                        g.addPackageImport(k, j);
                    }
                    else {
                        g.addPackageImport("igniteui-" + b + "-" + c, j);
                    }
                }
            }
        }
        a(a, b) {
            let c = false;
            if (b.getMetadata(a, "__isPlainObject") != null && b.getMetadata(a, "__marshalByValue") == null) {
                c = true;
            }
            return c;
        }
    }
    WebImportsHalper.$t = /*@__PURE__*/ markType(WebImportsHalper, 'WebImportsHalper');
    return WebImportsHalper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JsonDictionaryArray = /*@__PURE__*/ (() => {
    class JsonDictionaryArray extends JsonDictionaryItem {
        constructor() {
            super(...arguments);
            this._items = null;
        }
        get items() {
            return this._items;
        }
        set items(a) {
            this._items = a;
        }
        d(a) {
            a.i("[");
            a.h();
            a.g();
            if (this.items != null) {
                for (let b = 0; b < this.items.length; b++) {
                    if (b > 0) {
                        a.j(",");
                    }
                    let c = this.items[b];
                    if (c == null) {
                        a.i("null");
                    }
                    else {
                        c.d(a);
                    }
                }
            }
            a.h();
            a.e();
            a.i("]");
        }
    }
    JsonDictionaryArray.$t = /*@__PURE__*/ markType(JsonDictionaryArray, 'JsonDictionaryArray', JsonDictionaryItem.$);
    return JsonDictionaryArray;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JsonDictionaryParser = /*@__PURE__*/ (() => {
    class JsonDictionaryParser extends Base {
        parse(json_) {
            let a = JSON.parse(json_);
            return JsonDictionaryParser.b(a);
        }
        static d(item_) {
            let propertyKey_ = null;
            let ret_ = new List$1(String_$type, 0);
            let exclusions_ = {};
            for (propertyKey_ in item_) {
                if (!isNaN(propertyKey_)) {
                    continue;
                }
                if (!exclusions_.hasOwnProperty(propertyKey_)) {
                    ret_.add(propertyKey_);
                }
            }
            ;
            return ret_;
        }
        static b(obj_) {
            if (typeCast(Array_$type, obj_) !== null) {
                return JsonDictionaryParser.a(obj_);
            }
            if (typeof obj_ === 'number') {
                return JsonDictionaryParser.a(obj_);
            }
            if (typeof obj_ === 'string') {
                return JsonDictionaryParser.a(obj_);
            }
            if (typeCast(Boolean_$type, obj_) !== null) {
                return JsonDictionaryParser.a(obj_);
            }
            let a = new JsonDictionaryObject();
            let b = JsonDictionaryParser.d(obj_);
            for (let c = 0; c < b.count; c++) {
                let key_ = b._inner[c];
                let d = obj_[key_];
                d = JsonDictionaryParser.a(d);
                a.item(key_, d);
            }
            return a;
        }
        static a(a) {
            if (typeCast(Array_$type, a) !== null) {
                let b = a;
                let c = new Array(b.length);
                for (let d = 0; d < b.length; d++) {
                    c[d] = JsonDictionaryParser.a(b[d]);
                }
                return ((() => {
                    let $ret = new JsonDictionaryArray();
                    $ret.items = c;
                    return $ret;
                })());
            }
            else if (typeof a === 'number') {
                return ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.value = a;
                    $ret.e = 0;
                    return $ret;
                })());
            }
            else if (typeof a === 'string') {
                return ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.value = a;
                    $ret.e = 2;
                    return $ret;
                })());
            }
            else if (typeCast(Boolean_$type, a) !== null) {
                return ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.value = a;
                    $ret.e = 1;
                    return $ret;
                })());
            }
            else if (a == null) {
                return ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.value = a;
                    $ret.e = 3;
                    return $ret;
                })());
            }
            else {
                return JsonDictionaryParser.b(a);
            }
        }
    }
    JsonDictionaryParser.$t = /*@__PURE__*/ markType(JsonDictionaryParser, 'JsonDictionaryParser');
    return JsonDictionaryParser;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingComponentRendererHandlerEmitter = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRendererHandlerEmitter extends Base {
        get n() {
            return this.m;
        }
        constructor(a, b) {
            super();
            this.o = null;
            this.m = null;
            this.e = null;
            this.a = null;
            this.k = new CodeGeneratingImportManager();
            this.b = null;
            this.d = null;
            this.c = null;
            this.p = new HashSet$1(String_$type, 0);
            this.o = a;
            this.m = b;
            this.e = new CodeGeneratingCodeWriter(this.o);
            this.b = new CodeGeneratingCodeWriter(this.o);
            this.d = new CodeGeneratingCodeWriter(this.o);
            this.c = new CodeGeneratingCodeWriter(this.o);
            this.a = new CodeGeneratingCodeWriter(this.o);
        }
        get j() {
            return this.e;
        }
        get f() {
            return this.a;
        }
        get l() {
            return this.k;
        }
        get g() {
            return this.b;
        }
        get i() {
            return this.d;
        }
        get h() {
            return this.c;
        }
        u(a, b) {
        }
        t(a, b) {
        }
        s(a, b) {
            let c = new HashSet$1(String_$type, 0);
            if (a != null && a.length > 0) {
                for (let d = 0; d < a.length; d++) {
                    let e = a[d];
                    if (e != null) {
                        this.r(e, c, true, false);
                    }
                }
            }
            if (b != null && b.length > 0) {
                for (let f = 0; f < b.length; f++) {
                    let g = b[f];
                    if (g != null) {
                        this.r(g, c, false, true);
                    }
                }
            }
            for (let h = 0; h < this.m.t.count; h++) {
                let i = this.m.t._inner[h];
                if (i.a != null && i.c == null) {
                    this.r(i.a.e, c, false, false);
                }
            }
            this.m.addContainerResult("eventHandlers", this.j.toString());
            this.m.addContainerResult("eventScript", this.f.toString());
            this.m.addImportResult("handlersImports", this.l);
            this.m.addContainerResult("onInit", this.g.toString());
            this.m.addContainerResult("handlersStyles", this.i.toString());
            this.m.addContainerResult("onViewInit", this.h.toString());
        }
        r(a, b, c, d) {
            if (this.o.library != null && this.o.library.hasItem(a)) {
                if (b.contains(a)) {
                    return;
                }
                b.add_1(a);
                let e = this.o.library.getItem(a);
                if (e.type == 1) {
                    let f = false;
                    let g = e.getContentForPlatform(this.m.platform);
                    if (g != null) {
                        if (g.isJson) {
                            let h = new JsonDictionaryParser();
                            let i = h.parse(g.content);
                            if (i.g("imports")) {
                                let j = i.item("imports").value;
                                let k = stringReplace(j, "\r\n", "\n").split('\n');
                                for (let m = 0; m < k.length; m++) {
                                    let l = k[m];
                                    if (l.trim().length == 0) {
                                        continue;
                                    }
                                    if (!this.p.contains(l)) {
                                        this.p.add_1(l);
                                        this.v(this.l, l);
                                    }
                                }
                            }
                            if (i.g("styles")) {
                                this.i.k(i.item("styles").value);
                            }
                            if (i.g("handler")) {
                                let n = this.j;
                                if (g.isJSContent) {
                                    n = this.f;
                                }
                                let o = i.item("handler").value;
                                o = this.q(o, a);
                                if (!stringContains(o, "OMIT HANDLER")) {
                                    let p = stringReplace(o, "\r\n", "\n").split('\n');
                                    let q = 0x7FFFFFFF;
                                    let r = "";
                                    for (let s = 0; s < this.o.indentSpaces; s++) {
                                        r += " ";
                                    }
                                    for (let u = 0; u < p.length; u++) {
                                        let t = p[u];
                                        let v = t;
                                        if (v.trim().length == 0) {
                                            continue;
                                        }
                                        v = stringReplace(t, "\t", r);
                                        let w = 0;
                                        for (let x = 0; x < v.length; x++) {
                                            if (v.charAt(x) != ' ' && v.charAt(x) != '\t') {
                                                break;
                                            }
                                            w++;
                                        }
                                        if (w < q) {
                                            q = w;
                                        }
                                    }
                                    for (let z = 0; z < p.length; z++) {
                                        let y = p[z];
                                        let aa = y;
                                        let ab = 0;
                                        if (aa.trim().length > 0) {
                                            while (aa.length > 0 && (aa.charAt(0) == ' ' || aa.charAt(0) == '\t') && ab < q) {
                                                if (aa.charAt(0) == ' ') {
                                                    aa = aa.substr(1);
                                                    ab++;
                                                }
                                                if (aa.charAt(0) == '\t') {
                                                    aa = aa.substr(1);
                                                    ab += this.o.indentSpaces;
                                                }
                                            }
                                        }
                                        n.l(aa);
                                    }
                                }
                                else {
                                    f = true;
                                }
                            }
                        }
                        else {
                            let ac = g.content;
                            this.j.l(ac);
                        }
                    }
                    if (c && !f) {
                        this.t(a, g.isJSContent);
                    }
                    if (d && !f) {
                        this.u(a, g.isJSContent);
                    }
                }
            }
        }
        v(a, b) {
        }
        q(a, b) {
            return a;
        }
    }
    CodeGeneratingComponentRendererHandlerEmitter.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRendererHandlerEmitter, 'CodeGeneratingComponentRendererHandlerEmitter');
    return CodeGeneratingComponentRendererHandlerEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingRegexHelper = /*@__PURE__*/ (() => {
    class CodeGeneratingRegexHelper extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = new RegExp(a);
        }
        execute(a, b) {
            return a;
        }
    }
    CodeGeneratingRegexHelper.$t = /*@__PURE__*/ markType(CodeGeneratingRegexHelper, 'CodeGeneratingRegexHelper');
    return CodeGeneratingRegexHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingComponentRendererDataEmitterPropertyType = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRendererDataEmitterPropertyType extends Base {
        constructor() {
            super(...arguments);
            this.c = 0;
            this.f = false;
            this.a = null;
            this.b = null;
            this.d = false;
        }
        e() {
            if (this.c == 3) {
                return false;
            }
            if (!this.f && !this.d) {
                return true;
            }
            if (this.a == null) {
                return false;
            }
            for (let a = 0; a < this.a.length; a++) {
                let b = this.b[a];
                if (b.f) {
                    if (!b.e()) {
                        return false;
                    }
                }
            }
            return true;
        }
    }
    CodeGeneratingComponentRendererDataEmitterPropertyType.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRendererDataEmitterPropertyType, 'CodeGeneratingComponentRendererDataEmitterPropertyType');
    return CodeGeneratingComponentRendererDataEmitterPropertyType;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingComponentRendererDataEmitterItemType = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRendererDataEmitterItemType extends Base {
        constructor() {
            super(...arguments);
            this.d = null;
            this.a = null;
            this.b = null;
            this.c = null;
        }
    }
    CodeGeneratingComponentRendererDataEmitterItemType.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRendererDataEmitterItemType, 'CodeGeneratingComponentRendererDataEmitterItemType');
    return CodeGeneratingComponentRendererDataEmitterItemType;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingComponentRendererDataEmitter = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRendererDataEmitter extends Base {
        get p() {
            return this.o;
        }
        get n() {
            return this.m;
        }
        x(a, b = false) {
            return a;
        }
        w(a) {
            return a;
        }
        constructor(a, b) {
            super();
            this.o = null;
            this.m = null;
            this.e = null;
            this.d = null;
            this.i = ((() => {
                let $ret = new CodeGeneratingImportManager();
                $ret.packageOverride = "./SampleData";
                return $ret;
            })());
            this.j = new CodeGeneratingImportManager();
            this.c = null;
            this.o = a;
            this.m = b;
            this.e = new CodeGeneratingCodeWriter(this.o);
            this.d = new CodeGeneratingCodeWriter(this.o);
            this.c = new CodeGeneratingCodeWriter(this.o);
        }
        get h() {
            return this.e;
        }
        get g() {
            return this.d;
        }
        get k() {
            return this.i;
        }
        get l() {
            return this.j;
        }
        set l(a) {
            this.j = a;
        }
        get f() {
            return this.c;
        }
        set f(a) {
            this.c = a;
        }
        u(a, b) {
            return null;
        }
        get_t() {
            return "";
        }
        get t() {
            return this.get_t();
        }
        get_v() {
            return ".json";
        }
        get v() {
            return this.get_v();
        }
        get_r() {
            return false;
        }
        get r() {
            return this.get_r();
        }
        ac(a) {
            if (a != null) {
                let b = a;
                let c = b.e();
                for (let d = 0; d < c.length; d++) {
                    let e = c[d];
                    let f = b.item(e);
                    if (typeCast(JsonDictionaryValue.$, f) !== null) {
                        let g = f;
                        this.ai(e, g);
                    }
                    else if (typeCast(JsonDictionaryArray.$, f) !== null) {
                        let h = 0;
                        let i = f;
                        this.ag(h, e, i, this.h, this.k);
                        this.ah(e, 0, null);
                    }
                    else {
                        let j = f;
                        let k = this.a(j);
                        let l = this.b(j);
                        let m = this.s(this.x(e, true), this.x(e), k, l);
                        for (let n of fromEnum(m)) {
                            this.ad(n, this.h, this.k);
                        }
                        this.aj(e, k, l, j);
                    }
                }
            }
            let o = new HashSet$1(String_$type, 0);
            for (let p = 0; p < this.m.t.count; p++) {
                let q = this.m.t._inner[p];
                if (q.a != null && q.c == null) {
                    if (this.o.library != null && this.o.library.hasItem(q.a.e)) {
                        if (o.contains(q.a.e)) {
                            continue;
                        }
                        o.add_1(q.a.e);
                        let r = this.o.library.getItem(q.a.e);
                        let s = this.t;
                        if (r.type == 0) {
                            let t = new CodeGeneratingCodeWriter(this.o);
                            let u = new CodeGeneratingImportManager();
                            let v = r.name;
                            let w = r.getContentForPlatform(this.m.platform);
                            if (w.isJson) {
                                let x = r.getConfigForPlatform(this.m.platform);
                                let y = 0;
                                if (x != null) {
                                    y = x.location;
                                }
                                switch (y) {
                                    case 0:
                                        let z = new JsonDictionaryParser();
                                        let aa = z.parse(w.content);
                                        this.af(t);
                                        this.ag(y, v, aa, t, u);
                                        this.ae(t);
                                        this.ah(v, y, w);
                                        break;
                                    case 3:
                                        this.ah(v, y, w);
                                        break;
                                    case 2:
                                        if (this.r) {
                                            let ab = new JsonDictionaryParser();
                                            let ac = ab.parse(w.content);
                                            this.af(t);
                                            this.ag(y, v, ac, t, u);
                                            this.ae(t);
                                        }
                                        this.ah(v, y, w);
                                        break;
                                    case 1:
                                        this.ah(v, y, w);
                                        let ad = w.content;
                                        s = this.v;
                                        this.aa(v, v + s, u);
                                        t.j(ad);
                                        break;
                                }
                            }
                            else {
                                let ae = w.content;
                                this.z(v, u);
                                t.j(ae);
                                this.ah(v, 0, w);
                            }
                            this.ab(v, u);
                            this.m.addContainerNewFileResult(v + s, t.toString());
                        }
                    }
                }
            }
            this.m.addContainerResult("vmProperties", this.g.toString());
            this.m.addImportResult("vmImports", this.k);
            this.m.addImportResult("vmLibraryImports", this.l);
            this.m.addContainerResult("vmLibraryProjectFiles", this.f.toString());
            this.m.addContainerResult("vmData", this.h.toString());
        }
        ae(a) {
        }
        af(a) {
        }
        ab(a, b) {
        }
        z(a, b) {
        }
        aa(a, b, c) {
        }
        aj(a, b, c, d) {
        }
        ah(a, b, c) {
        }
        ai(a, b) {
        }
        ag(a, b, c, d, e) {
            if (typeCast(JsonDictionaryArray.$, c) !== null) {
                let f = c;
                if (f.items != null && f.items.length > 0) {
                    let g = this.q(f.items);
                    if (g != null) {
                        let h = this.a(g);
                        let i = this.b(g);
                        if (h != null) {
                            this.al(a, b, h, i, d, e);
                            for (let j = 0; j < f.items.length; j++) {
                                this.y(a, b, h, i, f.items[j], j, d);
                            }
                            this.ak(a, b, h, i, d);
                        }
                    }
                }
            }
        }
        ak(a, b, c, d, e) {
        }
        ad(a, b, c) {
        }
        s(a, b, c, d) {
            let e = new List$1(CodeGeneratingComponentRendererDataEmitterItemType.$, 0);
            let f = new CodeGeneratingComponentRendererDataEmitterItemType();
            f.d = a;
            f.c = b;
            f.a = c;
            f.b = d;
            e.add(f);
            for (let g = 0; g < c.length; g++) {
                let h = c[g];
                let i = d[g];
                if (i.f) {
                    let j = this.s(this.x(a) + "_" + h, b, i.a, i.b);
                    e.o(j);
                }
                else if (i.d) {
                    let k = this.s(this.x(a) + "_" + h + "Item", b, i.a, i.b);
                    e.o(k);
                }
            }
            return e;
        }
        y(a, b, c, d, e, f, g) {
        }
        al(a, b, c, d, e, f) {
        }
        b(a) {
            let b = new List$1(CodeGeneratingComponentRendererDataEmitterPropertyType.$, 0);
            if (typeCast(JsonDictionaryObject.$, a) !== null) {
                let c = a;
                let d = c.e();
                for (let f = 0; f < d.length; f++) {
                    let e = d[f];
                    let g = c.item(e);
                    let h = new CodeGeneratingComponentRendererDataEmitterPropertyType();
                    if (typeCast(JsonDictionaryObject.$, g) !== null) {
                        h.f = true;
                        let i = this.a(g);
                        let j = this.b(g);
                        h.a = i;
                        h.b = j;
                    }
                    else if (typeCast(JsonDictionaryArray.$, g) !== null) {
                        h.d = true;
                        let k = g;
                        if (k.items != null && k.items.length > 0) {
                            let l = this.q(k.items);
                            let m = this.a(l);
                            let n = this.b(l);
                            h.a = m;
                            h.b = n;
                        }
                    }
                    else {
                        let o = g;
                        h.c = o.e;
                    }
                    b.add(h);
                }
                return b.toArray();
            }
            return null;
        }
        a(a) {
            if (typeCast(JsonDictionaryObject.$, a) !== null) {
                let b = a;
                return b.e();
            }
            return null;
        }
        q(a) {
            for (let b = 0; b < a.length; b++) {
                if (a[b] != null) {
                    let c = this.b(a[b]);
                    if (c == null) {
                        continue;
                    }
                    let d = true;
                    for (let e = 0; e < c.length; e++) {
                        if (!c[e].e()) {
                            d = false;
                        }
                    }
                    if (!d) {
                        continue;
                    }
                    return a[b];
                }
            }
            return null;
        }
    }
    CodeGeneratingComponentRendererDataEmitter.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRendererDataEmitter, 'CodeGeneratingComponentRendererDataEmitter');
    return CodeGeneratingComponentRendererDataEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JsonDictionaryValueType_$type = /*@__PURE__*/ markEnum('JsonDictionaryValueType', 'NumberValue,0|BooleanValue,1|StringValue,2|NullValue,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TypeDescriptionCleanups = /*@__PURE__*/ (() => {
    class TypeDescriptionCleanups extends Base {
        constructor() {
            super();
            this.a = new Dictionary$2(String_$type, Delegate_$type, 0);
            this.a.item("Series", (a) => {
                let s_ = a;
                if (s_.removeAxes)
                    s_.removeAxes();
            });
        }
        b(a, b) {
            if (b == null) {
                return;
            }
            let c = "";
            let d;
            let obj_ = b;
            let impl_ = obj_.i;
            let e = (impl_);
            if (e) {
                d = getInstanceType(impl_);
            }
            else {
                impl_ = obj_._chart || obj_._map || obj_._gauge;
                e = (impl_);
                if (e) {
                    d = getInstanceType(impl_);
                }
                else {
                    return;
                }
            }
            while (d != null) {
                c = d.typeName;
                c = stringReplace(stringReplace(c, "Ultra", ""), "Xam", "");
                if (this.a.containsKey(c)) {
                    this.a.item(c)(b);
                }
                d = d.baseType;
                if (d != null && (d.typeName == "Object" || d.typeName == "Base")) {
                    return;
                }
            }
        }
    }
    TypeDescriptionCleanups.$t = /*@__PURE__*/ markType(TypeDescriptionCleanups, 'TypeDescriptionCleanups');
    return TypeDescriptionCleanups;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionPropertyValue = /*@__PURE__*/ (() => {
    class DescriptionPropertyValue extends Base {
        constructor() {
            super(...arguments);
            this.c = null;
            this.b = null;
            this.a = null;
        }
    }
    DescriptionPropertyValue.$t = /*@__PURE__*/ markType(DescriptionPropertyValue, 'DescriptionPropertyValue');
    return DescriptionPropertyValue;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionTreeNode = /*@__PURE__*/ (() => {
    class DescriptionTreeNode extends Base {
        constructor() {
            super();
            this.g = 0;
            this.e = new List$1(DescriptionPropertyValue.$, 0);
            this.d = new Dictionary$2(String_$type, DescriptionPropertyValue.$, 0);
            this.i = null;
            this.g = DescriptionTreeNode.h;
            DescriptionTreeNode.h++;
            if (DescriptionTreeNode.h >= 0x7FFFFFFFFFFFFFFF) {
                DescriptionTreeNode.h = 0;
            }
        }
        b() {
            let a = new DescriptionTreeNode();
            a.g = this.g;
            a.i = this.i;
            for (let b = 0; b < this.e.count; b++) {
                let c = this.e._inner[b].c;
                let d = this.e._inner[b].a;
                let e = this.e._inner[b].b;
                if (typeCast(DescriptionTreeNode.$, e) !== null) {
                    e = e.b();
                }
                if (typeCast(Array_$type, e) !== null) {
                    let f = e;
                    let g = new Array(f.length);
                    for (let h = 0; h < f.length; h++) {
                        if (typeCast(DescriptionTreeNode.$, f[h]) !== null) {
                            g[h] = f[h].b();
                        }
                        else {
                            g[h] = f[h];
                        }
                    }
                    e = g;
                }
                a.k(c, e, d);
            }
            return a;
        }
        j(a, b) {
            let c = new DescriptionPropertyValue();
            c.c = a;
            c.b = b;
            this.d.addItem(a.toLowerCase(), c);
            this.e.add(c);
        }
        k(a, b, c) {
            let d = new DescriptionPropertyValue();
            d.c = a;
            d.b = b;
            d.a = c;
            this.d.addItem(a.toLowerCase(), d);
            this.e.add(d);
        }
        n(a, b) {
            if (this.d.containsKey(a.toLowerCase())) {
                let c = this.d.item(a.toLowerCase());
                c.b = b;
            }
            else {
                this.j(a, b);
            }
        }
        o(a, b, c) {
            if (this.d.containsKey(a.toLowerCase())) {
                let d = this.d.item(a.toLowerCase());
                d.b = b;
            }
            else {
                this.k(a, b, c);
            }
        }
        a(a) {
            return this.d.item(a.toLowerCase());
        }
        c(a) {
            return this.d.containsKey(a.toLowerCase());
        }
        m(a) {
            if (this.d.containsKey(a.toLowerCase())) {
                let b = this.d.item(a.toLowerCase());
                this.d.removeItem(a.toLowerCase());
                this.e.remove(b);
            }
        }
        l() {
            this.d.clear();
            this.e.clear();
        }
        f() {
            return this.e;
        }
    }
    DescriptionTreeNode.$t = /*@__PURE__*/ markType(DescriptionTreeNode, 'DescriptionTreeNode');
    DescriptionTreeNode.h = 0;
    return DescriptionTreeNode;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Queue$1 = /*@__PURE__*/ (() => {
    class Queue$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this.d = 0;
            this.e = 0;
            this.f = 0;
            this.a = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.a = new Array(4);
        }
        get count() {
            return this.d;
        }
        copyTo(a, b) {
            if (this.e < this.f) {
                for (let c = this.e; c < this.f; c++) {
                    a[b++] = getBoxIfEnum(this.$t, this.a[c]);
                }
            }
            else {
                for (let d = this.e; d < this.a.length; d++) {
                    a[b++] = getBoxIfEnum(this.$t, this.a[d]);
                }
                for (let e = 0; e < this.f; e++) {
                    a[b++] = getBoxIfEnum(this.$t, this.a[e]);
                }
            }
        }
        get isSynchronized() {
            return false;
        }
        get syncRoot() {
            return null;
        }
        *_getEnumerator() {
            if (this.e < this.f) {
                for (let a = this.e; a < this.f; a++) {
                    yield this.a[a];
                }
            }
            else {
                for (let b = this.e; b < this.a.length; b++) {
                    yield this.a[b];
                }
                for (let c = 0; c < this.f; c++) {
                    yield this.a[c];
                }
            }
        }
        getEnumerator() {
            return toEnum(() => this._getEnumerator()).getEnumerator();
        }
        getEnumeratorObject() {
            return this.getEnumerator();
        }
        g(a) {
            if (this.d == this.a.length) {
                let b = new Array(Math.max(2, this.a.length * 2));
                this.copyTo(b, 0);
                this.e = 0;
                this.f = this.a.length;
                this.a = b;
            }
            this.a[this.f] = a;
            this.f = (this.f + 1) % this.a.length;
            this.d++;
        }
        b() {
            if (this.d == 0) {
                throw new InvalidOperationException(1, "The Queue is empty.");
            }
            let a = this.a[this.e];
            this.a[this.e] = (null);
            this.e = (this.e + 1) % this.a.length;
            this.d--;
            return a;
        }
        c() {
            if (this.d == 0) {
                throw new InvalidOperationException(1, "The Queue is empty.");
            }
            return this.a[this.e];
        }
    }
    Queue$1.$t = /*@__PURE__*/ markType(Queue$1, 'Queue$1', Base.$, [ICollection_$type, /*@__PURE__*/ IEnumerable$1_$type.specialize(0)]);
    return Queue$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionTreeAction = /*@__PURE__*/ (() => {
    class DescriptionTreeAction extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.c = null;
            this.b = null;
            this.d = null;
            this.j = null;
            this.h = null;
            this.g = null;
            this.f = 0;
            this.e = 0;
        }
        i(a) {
            let b = this.j;
            if (this.d != null) {
                b = this.d.j(a);
            }
            else {
                if (TypeDescriptionMetadata.shouldCamelize(a)) {
                    b = TypeDescriptionMetadata.camelize(this.j);
                }
            }
            if (stringEndsWith(b, "Ref")) {
                b = b.substr(0, b.length - ("Ref").length);
            }
            return b;
        }
    }
    DescriptionTreeAction.$t = /*@__PURE__*/ markType(DescriptionTreeAction, 'DescriptionTreeAction');
    return DescriptionTreeAction;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RefValueChangedTarget = /*@__PURE__*/ (() => {
    class RefValueChangedTarget extends Base {
        constructor() {
            super(...arguments);
            this.c = null;
            this.d = null;
            this.a = null;
            this.b = null;
        }
    }
    RefValueChangedTarget.$t = /*@__PURE__*/ markType(RefValueChangedTarget, 'RefValueChangedTarget');
    return RefValueChangedTarget;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionRefValueChangedEventArgs = /*@__PURE__*/ (() => {
    class DescriptionRefValueChangedEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
            this.a = null;
        }
    }
    DescriptionRefValueChangedEventArgs.$t = /*@__PURE__*/ markType(DescriptionRefValueChangedEventArgs, 'DescriptionRefValueChangedEventArgs');
    return DescriptionRefValueChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionRef = /*@__PURE__*/ (() => {
    class DescriptionRef extends Base {
        constructor(a) {
            super();
            this.d = null;
            this.b = null;
            this.a = false;
            this.d = a;
            this.b = new List$1(RefValueChangedTarget.$, 0);
        }
        get e() {
            return this.d;
        }
        get c() {
            return this.b.count;
        }
        g(a, b, c, d) {
            this.b.add(((() => {
                let $ret = new RefValueChangedTarget();
                $ret.b = a;
                $ret.c = b;
                $ret.d = c;
                $ret.a = d;
                return $ret;
            })()));
        }
        j(a, b, c) {
            for (let d = this.b.count - 1; d >= 0; d--) {
                if (this.b._inner[d].c == b && this.b._inner[d].d == c) {
                    this.b.removeAt(d);
                }
            }
        }
        l(a) {
            for (let b = this.b.count - 1; b >= 0; b--) {
                if (this.b._inner[b].c == a) {
                    this.b.removeAt(b);
                }
            }
        }
        k(a) {
            for (let b = this.b.count - 1; b >= 0; b--) {
                if (this.b._inner[b].b == a) {
                    this.b.removeAt(b);
                }
            }
        }
        h() {
            this.b.clear();
        }
        i(a) {
            for (let b = this.b.count - 1; b >= 0; b--) {
                if (this.b._inner[b].c == a) {
                    this.b.removeAt(b);
                }
            }
        }
        f(a, b) {
            for (let c = 0; c < this.b.count; c++) {
                this.b._inner[c].a(this, ((() => {
                    let $ret = new DescriptionRefValueChangedEventArgs();
                    $ret.b = a;
                    $ret.a = b;
                    return $ret;
                })()));
            }
        }
    }
    DescriptionRef.$t = /*@__PURE__*/ markType(DescriptionRef, 'DescriptionRef');
    return DescriptionRef;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITypeDescriptionPropertyTransforms_$type = /*@__PURE__*/ new Type(null, 'ITypeDescriptionPropertyTransforms');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TypeDescriptionPropretyTransforms = /*@__PURE__*/ (() => {
    class TypeDescriptionPropretyTransforms extends Base {
        constructor() {
            super();
            this.a = new Dictionary$2(String_$type, Delegate_$type, 0);
            this.a.item("VisibilityToBooleanTransform", (a, b) => {
                if (a.toString().toLowerCase() == "visible") {
                    return true;
                }
                return false;
            });
            this.a.item("FontFamilyTransform", (a, b) => {
                let c = this.d(b);
                let d = this.c(b);
                let e = this.e(b);
                let f = a;
                if (f == null) {
                    f = "Verdana";
                }
                return c + " " + e + " " + d + " " + f;
            });
            this.a.item("FontStyleTransform", (a, b) => {
                let c = this.b(b);
                let d = this.c(b);
                let e = this.e(b);
                let f = a;
                if (f == null) {
                    f = "normal";
                }
                return f + " " + e + " " + d + " " + c;
            });
            this.a.item("FontSizeTransform", (a, b) => {
                let c = this.b(b);
                let d = this.d(b);
                let e = this.e(b);
                let f = a != null ? a.toString() + "px" : null;
                if (f == null) {
                    f = "14px";
                }
                return d + " " + e + " " + f + " " + c;
            });
            this.a.item("FontWeightTransform", (a, b) => {
                let c = this.b(b);
                let d = this.c(b);
                let e = this.d(b);
                let f = a;
                if (f == null) {
                    f = "normal";
                }
                f = f.toLowerCase();
                return e + " " + f + " " + d + " " + c;
            });
        }
        b(a) {
            let b = stringReplace(stringReplace(stringReplace(a.j, "Style", "Family"), "Weight", "Family"), "Size", "Family");
            let c = "Verdana";
            let d = a.b;
            if (d == null) {
                d = a.c;
            }
            if (d != null) {
                if (d.c(b)) {
                    c = d.a(b).b;
                    if (c == null) {
                        c = "Verdana";
                    }
                }
            }
            return c;
        }
        d(a) {
            let b = stringReplace(stringReplace(stringReplace(a.j, "Family", "Style"), "Weight", "Style"), "Size", "Style");
            let c = "normal";
            let d = a.b;
            if (d == null) {
                d = a.c;
            }
            if (d != null) {
                if (d.c(b)) {
                    c = d.a(b).b;
                    if (c == null) {
                        c = "normal";
                    }
                }
            }
            return c;
        }
        c(a) {
            let b = stringReplace(stringReplace(stringReplace(a.j, "Family", "Size"), "Weight", "Size"), "Style", "Size");
            let c = "14px";
            let d = a.b;
            if (d == null) {
                d = a.c;
            }
            if (d != null) {
                if (d.c(b)) {
                    c = d.a(b).b;
                    if (c == null) {
                        c = "14px";
                    }
                    else {
                        c = c.toString() + "px";
                    }
                }
            }
            return c;
        }
        e(a) {
            let b = stringReplace(stringReplace(stringReplace(a.j, "Family", "Weight"), "Size", "Weight"), "Style", "Weight");
            let c = "normal";
            let d = a.b;
            if (d == null) {
                d = a.c;
            }
            if (d != null) {
                if (d.c(b)) {
                    c = d.a(b).b;
                    if (c == null) {
                        c = "normal";
                    }
                    c = c.toLowerCase();
                }
            }
            return c;
        }
        transform(a, b, c) {
            let d = c.d;
            if (d == null) {
                return b;
            }
            let e = d.k(a);
            if (e != null && this.a.containsKey(e)) {
                let f = this.a.item(e);
                return f(b, c);
            }
            return b;
        }
    }
    TypeDescriptionPropretyTransforms.$t = /*@__PURE__*/ markType(TypeDescriptionPropretyTransforms, 'TypeDescriptionPropretyTransforms', Base.$, [ITypeDescriptionPropertyTransforms_$type]);
    return TypeDescriptionPropretyTransforms;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionSerializerBuilder = /*@__PURE__*/ (() => {
    class DescriptionSerializerBuilder extends Base {
        toString() {
            return this.d.toString();
        }
        constructor() {
            super();
            this.d = null;
            this.b = 0;
            this.a = false;
            this.d = new StringBuilder(0);
        }
        e(a) {
            this.g();
            this.d.l(a);
        }
        f(a) {
            this.g();
            this.d.u(a);
            this.a = true;
        }
        g() {
            if (this.a) {
                for (let a = 0; a < this.b; a++) {
                    this.d.l("\t");
                }
                this.a = false;
            }
        }
        i() {
            this.b++;
        }
        h() {
            this.b--;
        }
    }
    DescriptionSerializerBuilder.$t = /*@__PURE__*/ markType(DescriptionSerializerBuilder, 'DescriptionSerializerBuilder');
    return DescriptionSerializerBuilder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionTreeBuilder = /*@__PURE__*/ (() => {
    class DescriptionTreeBuilder extends Base {
        static c(item_) {
            let propertyKey_ = null;
            let ret_ = new List$1(String_$type, 0);
            let seen_ = new HashSet$1(String_$type, 0);
            let exclusions_ = {};
            let seen = new Set();
            let comp = item_;
            while (comp = (comp.prototype || Object.getPrototypeOf(comp))) {
                if (comp == Base.prototype) {
                    break;
                }
                let props = Object.getOwnPropertyNames(comp.constructor.prototype);
                for (let i = 0; i < props.length; i++) {
                    if (!seen.has(props[i])) {
                        seen.add(props[i]);
                        ret_.add(props[i]);
                    }
                }
            }
            ;
            return ret_;
        }
        static createTree(a, description_) {
            return DescriptionTreeBuilder.createTreeWithOptions(a, description_, false);
        }
        static createTreeWithOptions(a, description_, b) {
            let c = new DescriptionTreeNode();
            if (description_ == null) {
                return null;
            }
            let d = DescriptionTreeBuilder.c(description_);
            for (let e = 0; e < d.count; e++) {
                let key_ = d._inner[e];
                if (key_.toLowerCase() != "type" && !description_.b(DescriptionTreeBuilder.d(key_))) {
                    continue;
                }
                let f = description_[key_];
                if (typeCast(Description.$, f) !== null) {
                    let g = DescriptionTreeBuilder.createTree(a, f);
                    f = g;
                }
                if (typeCast(Array_$type, f) !== null) {
                    let h = f;
                    let i = new Array(h.length);
                    for (let j = 0; j < i.length; j++) {
                        let k = h[j];
                        if (typeCast(Description.$, k) !== null) {
                            let l = DescriptionTreeBuilder.createTree(a, k);
                            i[j] = l;
                        }
                        else {
                            i[j] = k;
                        }
                    }
                    f = i;
                }
                if (key_.toLowerCase() == "type") {
                    c.i = f;
                }
                c.j(DescriptionTreeBuilder.d(key_), f);
            }
            if (c.c("type")) {
                let m = c.a("type").b;
                let n = c.f();
                for (let o = 0; o < n.count; o++) {
                    let p = n._inner[o];
                    p.a = a.getMetadata(m, p.c);
                }
            }
            return c;
        }
        static d(key_) {
            if (key_ == null) {
                return null;
            }
            return key_.substr(0, 1).toUpperCase() + key_.substr(1);
        }
    }
    DescriptionTreeBuilder.$t = /*@__PURE__*/ markType(DescriptionTreeBuilder, 'DescriptionTreeBuilder');
    return DescriptionTreeBuilder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionResult = /*@__PURE__*/ (() => {
    class DescriptionResult extends Base {
        constructor() {
            super();
            this.c = new List$1(String_$type, 0);
            this._result = null;
        }
        d(a) {
            this.c.add(a);
        }
        e(a) {
            for (let b = 0; b < a.c.count; b++) {
                this.c.add(a.c._inner[b]);
            }
        }
        get result() {
            return this._result;
        }
        set result(a) {
            this._result = a;
        }
        get warnings() {
            return this.c.toArray();
        }
    }
    DescriptionResult.$t = /*@__PURE__*/ markType(DescriptionResult, 'DescriptionResult');
    return DescriptionResult;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EmbeddedRefDescription = /*@__PURE__*/ (() => {
    class EmbeddedRefDescription extends Description {
        constructor() {
            super(...arguments);
            this.h = null;
            this.i = null;
        }
        get_type() {
            return "EmbeddedRef";
        }
        get type() {
            return this.get_type();
        }
        get refType() {
            return this.h;
        }
        set refType(a) {
            this.h = a;
            this.g("RefType");
        }
        get value() {
            return this.i;
        }
        set value(a) {
            this.i = a;
            this.g("Value");
        }
    }
    EmbeddedRefDescription.$t = /*@__PURE__*/ markType(EmbeddedRefDescription, 'EmbeddedRefDescription', Description.$);
    return EmbeddedRefDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointDescription = /*@__PURE__*/ (() => {
    class PointDescription extends Base {
        constructor() {
            super(...arguments);
            this._x = 0;
            this._y = 0;
        }
        get x() {
            return this._x;
        }
        set x(a) {
            this._x = a;
        }
        get y() {
            return this._y;
        }
        set y(a) {
            this._y = a;
        }
    }
    PointDescription.$t = /*@__PURE__*/ markType(PointDescription, 'PointDescription');
    return PointDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SizeDescription = /*@__PURE__*/ (() => {
    class SizeDescription extends Base {
        constructor() {
            super(...arguments);
            this._width = 0;
            this._height = 0;
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
    }
    SizeDescription.$t = /*@__PURE__*/ markType(SizeDescription, 'SizeDescription');
    return SizeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectDescription = /*@__PURE__*/ (() => {
    class RectDescription extends Base {
        constructor() {
            super(...arguments);
            this._left = 0;
            this._top = 0;
            this._width = 0;
            this._height = 0;
        }
        get left() {
            return this._left;
        }
        set left(a) {
            this._left = a;
        }
        get top() {
            return this._top;
        }
        set top(a) {
            this._top = a;
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
    }
    RectDescription.$t = /*@__PURE__*/ markType(RectDescription, 'RectDescription');
    return RectDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionSerializer = /*@__PURE__*/ (() => {
    class DescriptionSerializer extends Base {
        constructor() {
            super();
            this.h = false;
            this.g = false;
            this.f = false;
            this.i = null;
            this.e = false;
        }
        p(a, b) {
            let c = DescriptionTreeBuilder.createTree(a, b);
            let d = new DescriptionSerializerBuilder();
            this.q(a, c, d);
            return d.toString();
        }
        t(a, b, c) {
            this.q(a, b, c);
        }
        c(a, b) {
            let c = new JsonDictionaryParser();
            let d = c.parse(b);
            return this.d(a, d, false, null, false);
        }
        d(a, b, c, d, e) {
            if (!(typeCast(JsonDictionaryObject.$, b) !== null)) {
                throw new NotSupportedException(1, "expected an object at the root of the json");
            }
            let f = b;
            if (c) {
                this.f = true;
                this.i = d;
            }
            if (e) {
                this.e = true;
            }
            let g = this.b(a, f);
            this.f = false;
            this.i = null;
            this.e = false;
            return g;
        }
        v(a, b, c, d, e) {
            if (this.g) {
                a.ag(b, c, d, e);
            }
            else {
                a.af(b, c, d, e);
            }
        }
        b(a, b, c = 8) {
            if (!b.g("type")) {
                if (b.g("refType")) {
                    let d = new EmbeddedRefDescription();
                    d.refType = b.item("refType").value;
                    d.value = b.item("id").value;
                    let e = new DescriptionResult();
                    e.result = d;
                    return e;
                }
                else {
                    throw new NotSupportedException(1, "expected type to be defined for the json object");
                }
            }
            let f = new DescriptionResult();
            let g = b.item("type").value;
            let h = a.w(g);
            f.result = h;
            if (h == null) {
                if (this.h) {
                    throw new NotSupportedException(1, "missing description for type: " + g);
                }
                f.d("couldn't find registered description for type: " + g);
                return f;
            }
            let i = b.e();
            for (let j = 0; j < i.length; j++) {
                let k = i[j];
                let l = a.getMetadata(g, TypeDescriptionContext.ab(k));
                if (l == null) {
                    if (TypeDescriptionContext.ab(k) == "Name") {
                        let m = "string";
                        let n = b.item(k);
                        let o = this.j(f, a, n, m);
                        h.name = o;
                    }
                    continue;
                }
                let p = b.item(k);
                if (l.knownType == 14 || l.knownType == 11 || l.knownType == 12) {
                    let q = p;
                    switch (l.knownType) {
                        case 14:
                            q = DescriptionSerializer.l(a, p);
                            break;
                        case 12:
                            q = DescriptionSerializer.m(a, p);
                            break;
                        case 11:
                            q = DescriptionSerializer.k(a, p);
                            break;
                    }
                    if (!this.e) {
                        this.v(a, h, k, l, q);
                    }
                }
                else if (typeCast(JsonDictionaryObject.$, p) !== null) {
                    let r = p;
                    let s = this.b(a, r, l.knownType);
                    f.e(s);
                    this.v(a, h, k, l, s.result);
                }
                else if (typeCast(JsonDictionaryArray.$, p) !== null) {
                    let t = p;
                    let u = "string";
                    let v = false;
                    if (l.knownType == 10) {
                        u = l.specificExternalType;
                    }
                    if (l.knownType == 9) {
                        v = true;
                        u = l.collectionElementType;
                    }
                    if (l.knownType == 23) {
                        v = true;
                        u = l.specificExternalType;
                    }
                    let w = this.a(f, a, t, u);
                    if (this.f) {
                        if (l.propertyName.toLowerCase() == "includedproperties" || l.propertyName.toLowerCase() == "excludedproperties") {
                            let x = w;
                            let y = new Array(x.length);
                            for (let z = 0; z < x.length; z++) {
                                y[z] = this.n(x[z]);
                            }
                            w = y;
                        }
                    }
                    if (!this.e || v) {
                        this.v(a, h, k, l, w);
                    }
                }
                else {
                    let aa = l.specificExternalType;
                    if (aa == null && l.knownType == 3) {
                        aa = "DateTime";
                    }
                    if (aa == null) {
                        aa = "String";
                    }
                    let ab = p;
                    let ac = this.j(f, a, ab, aa);
                    if (this.f) {
                        if (stringEndsWith(l.propertyName, "MemberPath") || stringEndsWith(l.propertyName.toLowerCase(), "field") || l.propertyName.toLowerCase() == "member" || l.propertyName.toLowerCase() == "membername" || (g != null && stringEndsWith(g, "Axis") && l.propertyName.toLowerCase() == "label")) {
                            ac = this.n(ac);
                        }
                    }
                    if (!this.e) {
                        this.v(a, h, k, l, ac);
                    }
                }
            }
            return f;
        }
        n(a) {
            let b = a.toString();
            if (this.i != null) {
                a = this.i(b);
            }
            else {
                if (stringStartsWith(b, "{")) {
                    if (!stringStartsWith(b, "{[")) {
                        b = b.substr(1, b.length - 2);
                        b = "{[" + b + "]}";
                        a = b;
                    }
                }
                else {
                    if (!stringStartsWith(b, "[")) {
                        b = "[" + b + "]";
                        a = b;
                    }
                }
            }
            return a;
        }
        static k(a, b) {
            if (b == null) {
                return null;
            }
            let c = NaN;
            let d = NaN;
            if (b.g("x")) {
                c = b.item("x").value;
            }
            if (b.g("y")) {
                d = b.item("y").value;
            }
            return ((() => {
                let $ret = new PointDescription();
                $ret.x = c;
                $ret.y = d;
                return $ret;
            })());
        }
        static m(a, b) {
            if (b == null) {
                return null;
            }
            let c = NaN;
            let d = NaN;
            if (b.g("width")) {
                c = b.item("width").value;
            }
            if (b.g("height")) {
                d = b.item("height").value;
            }
            return ((() => {
                let $ret = new SizeDescription();
                $ret.width = c;
                $ret.height = d;
                return $ret;
            })());
        }
        static l(a, b) {
            if (b == null) {
                return null;
            }
            let c = NaN;
            let d = NaN;
            let e = NaN;
            let f = NaN;
            if (b.g("left")) {
                c = b.item("left").value;
            }
            if (b.g("top")) {
                d = b.item("top").value;
            }
            if (b.g("width")) {
                e = b.item("width").value;
            }
            if (b.g("height")) {
                f = b.item("height").value;
            }
            return ((() => {
                let $ret = new RectDescription();
                $ret.left = c;
                $ret.top = d;
                $ret.width = e;
                $ret.height = f;
                return $ret;
            })());
        }
        a(a, b, c, d) {
            let e = new Array(c.items.length);
            for (let f = 0; f < c.items.length; f++) {
                let g = c.items[f];
                if (typeCast(JsonDictionaryObject.$, g) !== null) {
                    let h = g;
                    let i = this.b(b, h);
                    a.e(i);
                    e[f] = i.result;
                }
                else if (typeCast(JsonDictionaryArray.$, g) !== null) {
                    let j = g;
                    let k = this.a(a, b, j, d);
                    e[f] = k;
                }
                else {
                    let l = g;
                    let m = this.j(a, b, l, d);
                    e[f] = m;
                }
            }
            return e;
        }
        j(a, b, c, d) {
            switch (c.e) {
                case 1: return c.value;
                case 3: return c.value;
                case 0: switch (d.toLowerCase()) {
                    case "int": return truncate(c.value);
                    case "double": return c.value;
                    case "timespan": return c.value;
                    case "short": return truncate(c.value);
                    case "long": return truncate(c.value);
                    case "float": return c.value;
                    case "byte": return truncate(c.value);
                    default:
                        a.d("unexpected target type for number: " + d);
                        return c.value;
                }
                case 2:
                    if (d.toLowerCase() == "datetime") {
                        let val_ = c.value;
                        let e = (new Date(val_));
                        return e;
                    }
                    return c.value;
                default:
                    a.d("unexpected value type");
                    return c.value;
            }
        }
        q(a, b, c) {
            if (b == null) {
                c.e("null");
                return;
            }
            let d = false;
            c.f("{");
            c.i();
            c.e("\"type\": \"" + b.i + "\"");
            let e = b.f();
            for (let f = 0; f < e.count; f++) {
                let g = e._inner[f];
                if (g.c.toLowerCase() == "type") {
                    continue;
                }
                if (f >= 0) {
                    c.f(",");
                }
                this.r(a, b, g, c);
                d = true;
            }
            if (d) {
                c.f("");
            }
            c.h();
            c.f("}");
        }
        o(a) {
            if (a == null) {
                return null;
            }
            return a.substr(0, 1).toLowerCase() + a.substr(1);
        }
        r(a, b, c, d) {
            if (c.c.toLowerCase() == "type") {
                return;
            }
            d.e("\"" + this.o(c.c) + "\": ");
            this.u(a, b, c, c.b, d);
        }
        u(a, b, c, d, e) {
            let f = 2;
            if (c.a != null) {
                f = c.a.knownType;
            }
            switch (f) {
                case 6:
                case 16:
                case 23:
                case 10:
                    {
                        e.e("[");
                        let g = c.b;
                        let h = c.a.specificType;
                        if (c.a.knownType == 6 || c.a.knownType == 16) {
                            h = "String";
                        }
                        for (let i = 0; i < g.length; i++) {
                            if (i > 0) {
                                e.e(", ");
                            }
                            let j = h;
                            if (typeCast(DescriptionTreeNode.$, g[i]) !== null) {
                                this.q(a, g[i], e);
                            }
                            else {
                                this.s(a, h, g[i], e);
                            }
                        }
                        e.e("]");
                    }
                    break;
                case 7:
                    this.s(a, "Boolean", d, e);
                    break;
                case 9:
                    {
                        e.e("[");
                        let k = c.b;
                        let l = c.a.collectionElementType;
                        for (let m = 0; m < k.length; m++) {
                            if (m > 0) {
                                e.e(", ");
                            }
                            let n = l;
                            if (typeCast(DescriptionTreeNode.$, k[m]) !== null) {
                                this.q(a, k[m], e);
                            }
                            else {
                                this.s(a, l, k[m], e);
                            }
                        }
                        e.e("]");
                    }
                    break;
                case 4:
                case 18:
                case 19:
                case 20:
                case 22:
                case 5:
                case 2:
                    this.s(a, "String", d, e);
                    break;
                case 3:
                    this.s(a, "DateTime", d, e);
                    break;
                case 8:
                    if (c.a.specificExternalType.toLowerCase() == "string") {
                        this.s(a, "String", d, e);
                    }
                    else {
                        this.q(a, d, e);
                    }
                    break;
                case 1:
                    this.s(a, "Double", d, e);
                    break;
                case 14:
                case 12:
                case 11:
                    this.q(a, d, e);
                    break;
                case 21:
                    this.s(a, "TimeSpan", d, e);
                    break;
                case 17:
                    if (typeof d === 'string') {
                        this.s(a, "String", d, e);
                    }
                    else if (typeof d === 'number' || typeof d === 'number' || typeof d === 'number') {
                        this.s(a, "Number", d, e);
                    }
                    else if (typeCast(Date_$type, d) !== null) {
                        this.s(a, "DateTime", d, e);
                    }
                    else {
                        throw new NotImplementedException(0);
                    }
                    break;
                case 0:
                case 15:
                case 13: throw new NotImplementedException(0);
            }
        }
        s(a, b, c, d) {
            switch (b.toLowerCase()) {
                case "string":
                    if (c == null) {
                        d.e("null");
                    }
                    else {
                        d.e("\"" + stringReplace(c, "\"", "\\\"") + "\"");
                    }
                    break;
                case "number":
                case "double":
                    if (c == null) {
                        d.e("null");
                    }
                    else {
                        if (!(typeof c === 'number')) {
                            c = Convert.toDouble3(c);
                        }
                        d.e(c.toString());
                    }
                    break;
                case "int":
                    if (c == null) {
                        d.e("null");
                    }
                    else {
                        d.e(c.toString());
                    }
                    break;
                case "float":
                    if (c == null) {
                        d.e("null");
                    }
                    else {
                        d.e(c.toString());
                    }
                    break;
                case "long":
                    if (c == null) {
                        d.e("null");
                    }
                    else {
                        d.e(c.toString());
                    }
                    break;
                case "decimal":
                    if (c == null) {
                        d.e("null");
                    }
                    else {
                        d.e(c.toString());
                    }
                    break;
                case "timespan":
                    if (c == null) {
                        d.e("null");
                    }
                    else {
                        d.e(c.toString());
                    }
                    break;
                case "boolean":
                    d.e(c == null ? "false" : c.toString().toLowerCase());
                    break;
                case "datetime":
                    if (c == null) {
                        d.e("null");
                    }
                    else {
                        let v_ = c;
                        d.e("\"" + (v_.toJSON()) + "\"");
                    }
                    break;
            }
        }
    }
    DescriptionSerializer.$t = /*@__PURE__*/ markType(DescriptionSerializer, 'DescriptionSerializer');
    return DescriptionSerializer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DiffApplyInfo = /*@__PURE__*/ (() => {
    class DiffApplyInfo extends Base {
        constructor() {
            super();
            this.a = null;
            this.c = null;
            this.b = null;
            this.d = null;
            this.a = new HashSet$1(Number_$type, 0);
            this.c = new List$1(DescriptionTreeAction.$, 0);
            this.b = new List$1(DescriptionTreeAction.$, 0);
            this.d = new List$1(DescriptionTreeAction.$, 0);
        }
    }
    DiffApplyInfo.$t = /*@__PURE__*/ markType(DiffApplyInfo, 'DiffApplyInfo');
    return DiffApplyInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionTreeReconciler_TreeModeData = /*@__PURE__*/ (() => {
    class DescriptionTreeReconciler_TreeModeData extends Base {
        constructor() {
            super(...arguments);
            this.f = null;
            this.a = null;
            this.d = 0;
            this.c = false;
            this.e = 0;
            this.b = false;
        }
    }
    DescriptionTreeReconciler_TreeModeData.$t = /*@__PURE__*/ markType(DescriptionTreeReconciler_TreeModeData, 'DescriptionTreeReconciler_TreeModeData');
    return DescriptionTreeReconciler_TreeModeData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionTreeReconciler = /*@__PURE__*/ (() => {
    class DescriptionTreeReconciler extends Base {
        static a(a, b) {
            let c = new DiffApplyInfo();
            for (let d = 0; d < b.count; d++) {
                let e = b._inner[d];
                switch (e.a) {
                    case 0:
                        if (typeCast(DescriptionTreeNode.$, e.h) !== null) {
                            let f = e.h.g;
                            c.a.add_1(f);
                        }
                        e.c.o(e.j, e.g, e.d);
                        if (typeCast(DescriptionTreeNode.$, e.g) !== null) {
                            let g = e.g.g;
                            if (c.a.contains(g)) {
                                c.a.remove(g);
                            }
                            c.c.add(e);
                        }
                        break;
                    case 1:
                        if (typeCast(DescriptionTreeNode.$, e.h) !== null) {
                            let h = e.h.g;
                            c.a.add_1(h);
                        }
                        e.c.m(e.j);
                        break;
                    case 3:
                        {
                            let i = e.c.a(e.j).b;
                            let j = i[e.f];
                            if (typeCast(DescriptionTreeNode.$, j) !== null) {
                                let k = j.g;
                                c.a.add_1(k);
                            }
                            i[e.f] = e.g;
                            if (typeCast(DescriptionTreeNode.$, e.g) !== null) {
                                let l = e.g.g;
                                if (c.a.contains(l)) {
                                    c.a.remove(l);
                                }
                                c.b.add(e);
                            }
                        }
                        break;
                    case 4:
                        {
                            let m = e.c.a(e.j).b;
                            let n = m[e.f];
                            if (typeCast(DescriptionTreeNode.$, n) !== null) {
                                let o = n.g;
                                c.a.add_1(o);
                            }
                            let p = new Array(m.length - 1);
                            let q = 0;
                            for (let r = 0; r < m.length; r++) {
                                if (r != e.f) {
                                    p[q] = m[r];
                                    q++;
                                }
                            }
                            e.c.n(e.j, p);
                        }
                        break;
                    case 2:
                        {
                            if (e.c == null && a == null) {
                                c.d.add(e);
                            }
                            else {
                                let s = e.c.a(e.j).b;
                                let t = new Array(s.length + 1);
                                let u = 0;
                                for (let v = 0; v < t.length; v++) {
                                    if (v == e.e) {
                                        t[v] = e.g;
                                    }
                                    else {
                                        t[v] = s[u];
                                        u++;
                                    }
                                }
                                e.c.n(e.j, t);
                                if (typeCast(DescriptionTreeNode.$, e.g) !== null) {
                                    let w = e.g.g;
                                    if (c.a.contains(w)) {
                                        c.a.remove(w);
                                    }
                                    c.b.add(e);
                                }
                            }
                        }
                        break;
                    case 5:
                        {
                            let x = e.c.a(e.j).b;
                            for (let y = 0; y < x.length; y++) {
                                let z = x[y];
                                if (typeCast(DescriptionTreeNode.$, z) !== null) {
                                    let aa = z.g;
                                    c.a.add_1(aa);
                                }
                            }
                            e.c.n(e.j, []);
                        }
                        break;
                }
            }
            return c;
        }
        static c(a, b, c) {
            let d = new List$1(DescriptionTreeAction.$, 0);
            if (a == null && b == null) {
                return d;
            }
            if (a != null && b == null) {
                let e = new DescriptionTreeAction();
                e.a = 4;
                e.f = 0;
                e.h = a;
                e.d = null;
                e.j = null;
                d.add(e);
                return d;
            }
            if (a == null && b != null) {
                let f = new DescriptionTreeAction();
                f.a = 2;
                f.f = 0;
                f.g = b;
                f.d = null;
                f.j = null;
                d.add(f);
                return d;
            }
            if (b.i != a.i) {
                let g = new DescriptionTreeAction();
                g.a = 3;
                g.f = 0;
                g.h = a;
                g.g = b;
                g.d = null;
                g.j = null;
                d.add(g);
                return d;
            }
            DescriptionTreeReconciler.g(d, a, b, c);
            return d;
        }
        static g(a, b, c, d) {
            c.g = b.g;
            let e = DescriptionTreeReconciler.e(b);
            let f = DescriptionTreeReconciler.e(c);
            let g = new List$1(DescriptionPropertyValue.$, 0);
            let h = new List$1(DescriptionPropertyValue.$, 0);
            let i = new List$1(DescriptionPropertyValue.$, 0);
            for (let j = 0; j < e.count; j++) {
                let k = e._inner[j];
                if (c.c(k.c)) {
                    if (!Base.equalsStatic(k, c.a(k.c))) {
                        let l = c.a(k.c);
                        if (typeCast(DescriptionTreeNode.$, k.b) !== null && typeCast(DescriptionTreeNode.$, l.b) !== null) {
                            let m = k.b;
                            let n = l.b;
                            if (m.i == n.i) {
                                if ((!m.c("Name") && !n.c("Name")) || (m.c("Name") && n.c("Name") && (m.a("Name").b == n.a("Name").b))) {
                                    DescriptionTreeReconciler.g(a, m, n, d);
                                }
                                else {
                                    i.add(c.a(k.c));
                                }
                            }
                            else {
                                i.add(c.a(k.c));
                            }
                        }
                        else {
                            i.add(c.a(k.c));
                        }
                    }
                }
                else {
                    if (!d) {
                        g.add(k);
                    }
                }
            }
            for (let o = 0; o < f.count; o++) {
                let p = f._inner[o];
                if (!b.c(p.c)) {
                    h.add(p);
                }
            }
            for (let q = 0; q < g.count; q++) {
                let r = g._inner[q];
                let s = new DescriptionTreeAction();
                s.c = b;
                s.b = c;
                s.a = 1;
                s.j = r.c;
                s.d = r.a;
                s.h = r.b;
                a.add(s);
            }
            for (let t = 0; t < h.count; t++) {
                let u = h._inner[t];
                let v = new DescriptionTreeAction();
                v.c = b;
                v.b = c;
                v.a = 0;
                v.j = u.c;
                v.d = u.a;
                v.g = u.b;
                v.h = null;
                a.add(v);
            }
            for (let w = 0; w < i.count; w++) {
                let x = i._inner[w];
                let y = b.a(x.c).b;
                let z = x.b;
                if (!Base.equalsStatic(z, y)) {
                    let aa = new DescriptionTreeAction();
                    aa.c = b;
                    aa.b = c;
                    aa.a = 0;
                    aa.j = x.c;
                    aa.d = x.a;
                    aa.g = x.b;
                    aa.h = b.a(x.c).b;
                    a.add(aa);
                }
            }
            let ab = DescriptionTreeReconciler.d(b);
            let ac = DescriptionTreeReconciler.d(c);
            let ad = new List$1(DescriptionPropertyValue.$, 0);
            let ae = new List$1(DescriptionPropertyValue.$, 0);
            let af = new List$1(DescriptionPropertyValue.$, 0);
            for (let ag = 0; ag < ab.count; ag++) {
                let ah = ab._inner[ag];
                if (c.c(ah.c)) {
                    if (!DescriptionTreeReconciler.b(ah.b, c.a(ah.c).b)) {
                        af.add(c.a(ah.c));
                    }
                    else {
                        let ai = ah.b;
                        let aj = c.a(ah.c).b;
                        for (let ak = 0; ak < ai.length; ak++) {
                            let al = ai[ak];
                            let am = aj[ak];
                            if (typeCast(DescriptionTreeNode.$, al) !== null && typeCast(DescriptionTreeNode.$, am) !== null) {
                                let an = al;
                                let ao = am;
                                let ap = false;
                                let aq = an.i == ao.i && an.i == "EmbeddedRef";
                                if (aq) {
                                    let ar = an.f().toArray();
                                    let as = ao.f().toArray();
                                    for (let at = 0; at <= ar.length - 1; at++) {
                                        let au = ar[at];
                                        let av = as[at];
                                        if (au.c != av.c || au.b != av.b) {
                                            ap = true;
                                            break;
                                        }
                                    }
                                }
                                if (an.i == ao.i && !ap) {
                                    DescriptionTreeReconciler.g(a, an, ao, d);
                                }
                                else {
                                    let aw = new DescriptionTreeAction();
                                    aw.j = ah.c;
                                    aw.d = ah.a;
                                    aw.c = b;
                                    aw.b = c;
                                    aw.a = 3;
                                    aw.f = ak;
                                    aw.e = ak;
                                    aw.h = an;
                                    aw.g = ao;
                                    a.add(aw);
                                }
                            }
                            else {
                                if (!Base.equalsStatic(al, am)) {
                                    let ax = new DescriptionTreeAction();
                                    ax.j = ah.c;
                                    ax.d = ah.a;
                                    ax.c = b;
                                    ax.b = c;
                                    ax.a = 3;
                                    ax.f = ak;
                                    ax.e = ak;
                                    ax.h = al;
                                    ax.g = am;
                                    a.add(ax);
                                }
                            }
                        }
                    }
                }
                else {
                    if (!d) {
                        ad.add(ah);
                    }
                }
            }
            for (let ay = 0; ay < ac.count; ay++) {
                let az = ac._inner[ay];
                if (!b.c(az.c)) {
                    ae.add(az);
                }
            }
            for (let a0 = 0; a0 < ad.count; a0++) {
                let a1 = ad._inner[a0];
                let a2 = new DescriptionTreeAction();
                a2.c = b;
                a2.b = c;
                a2.j = a1.c;
                a2.d = a1.a;
                a2.a = 5;
                a2.h = a1.b;
                a.add(a2);
            }
            for (let a3 = 0; a3 < ae.count; a3++) {
                let a4 = ae._inner[a3];
                let a5 = new DescriptionTreeAction();
                a5.c = b;
                a5.b = c;
                a5.j = a4.c;
                a5.d = a4.a;
                a5.a = 0;
                a5.h = null;
                a5.g = a4.b;
                a.add(a5);
            }
            for (let a6 = 0; a6 < af.count; a6++) {
                DescriptionTreeReconciler.h(a, b, c, b.a(af._inner[a6].c), af._inner[a6], d);
            }
        }
        static f(a) {
            if (a == null) {
                return "UNKOWN";
            }
            if (!a.c("Type")) {
                return "UNKOWN";
            }
            return a.a("Type").b;
        }
        static h(a, b, c, d, e, f) {
            let g = false;
            let h = d.b;
            let i = e.b;
            if (h.length > 0) {
                if (typeCast(DescriptionTreeNode.$, h[0]) !== null) {
                    let j = h[0];
                    if (j.c("Name") && j.a("Name") != null) {
                        g = true;
                    }
                    if (j.c("RefType") && j.a("RefType").b == "uuid") {
                        g = true;
                    }
                }
            }
            if (i.length > 0) {
                if (typeCast(DescriptionTreeNode.$, i[0]) !== null) {
                    let k = i[0];
                    if (k.c("Name") && k.a("Name") != null) {
                        g = true;
                    }
                    if (k.c("RefType") && k.a("RefType").b == "uuid") {
                        g = true;
                    }
                }
            }
            if (g) {
                let l = new Dictionary$2(String_$type, DescriptionTreeReconciler_TreeModeData.$, 0);
                let m = new List$1(DescriptionTreeReconciler_TreeModeData.$, 0);
                let n = new Dictionary$2(String_$type, DescriptionTreeReconciler_TreeModeData.$, 0);
                let o = new List$1(DescriptionTreeReconciler_TreeModeData.$, 0);
                let p = 0;
                for (let q = 0; q < h.length; q++) {
                    let r = new DescriptionTreeReconciler_TreeModeData();
                    r.a = h[q];
                    r.d = q;
                    r.f = r.a.c("Name") ? r.a.a("Name").b : r.a.c("RefType") ? r.a.a("Value").b : null;
                    if (r.f == null) {
                        r.f = "BADKEY_" + p.toString();
                        p++;
                    }
                    m.add(r);
                    l.addItem(r.f, r);
                }
                for (let s = 0; s < i.length; s++) {
                    let t = new DescriptionTreeReconciler_TreeModeData();
                    t.a = i[s];
                    t.d = s;
                    t.f = t.a.c("Name") ? t.a.a("Name").b : t.a.c("RefType") ? t.a.a("Value").b : null;
                    if (t.f == null) {
                        t.f = "BADKEY_" + p.toString();
                        p++;
                    }
                    o.add(t);
                    n.addItem(t.f, t);
                }
                for (let u = 0; u < m.count; u++) {
                    let v = m._inner[u];
                    if (!n.containsKey(v.f) || (n.containsKey(v.f) && DescriptionTreeReconciler.f(v.a) != DescriptionTreeReconciler.f(n.item(v.f).a))) {
                        v.c = true;
                    }
                }
                for (let w = 0; w < o.count; w++) {
                    let x = o._inner[w];
                    if (!l.containsKey(x.f) || (l.containsKey(x.f) && DescriptionTreeReconciler.f(x.a) != DescriptionTreeReconciler.f(l.item(x.f).a))) {
                        x.b = true;
                    }
                    else {
                        l.item(x.f).e = w;
                    }
                }
                for (let y = 0; y < m.count; y++) {
                    let z = m._inner[y];
                    if (z.c) {
                        let aa = new DescriptionTreeAction();
                        aa.j = e.c;
                        aa.c = b;
                        aa.b = c;
                        aa.d = e.a;
                        aa.f = z.d;
                        aa.a = 4;
                        aa.h = z.a;
                        a.add(aa);
                        for (let ab = y + 1; ab < m.count; ab++) {
                            let ac = m._inner[ab];
                            ac.d--;
                        }
                    }
                }
                for (let ad = 0; ad < o.count; ad++) {
                    let ae = o._inner[ad];
                    if (ae.b) {
                        let af = new DescriptionTreeAction();
                        af.j = e.c;
                        af.c = b;
                        af.b = c;
                        af.d = e.a;
                        af.e = ad;
                        af.a = 2;
                        af.g = i[ad];
                        a.add(af);
                        for (let ag = 0; ag < m.count; ag++) {
                            let ah = m._inner[ag];
                            if (!ah.c && ah.d >= ad) {
                                ah.d++;
                            }
                        }
                    }
                    else {
                        let ai = l.item(ae.f);
                        if (ai.d == ai.e) {
                            DescriptionTreeReconciler.g(a, ai.a, ae.a, f);
                            continue;
                        }
                        let aj = new DescriptionTreeAction();
                        aj.j = e.c;
                        aj.c = b;
                        aj.b = c;
                        aj.d = e.a;
                        aj.f = ai.d;
                        aj.a = 4;
                        aj.h = ai.a;
                        a.add(aj);
                        for (let ak = 0; ak < m.count; ak++) {
                            let al = m._inner[ak];
                            if (!al.c && al.a != ai.a && al.d >= ai.d) {
                                al.d--;
                            }
                        }
                        aj = new DescriptionTreeAction();
                        aj.j = e.c;
                        aj.c = b;
                        aj.b = c;
                        aj.d = e.a;
                        aj.e = ai.e;
                        aj.a = 2;
                        aj.g = ai.a;
                        a.add(aj);
                        ai.d = ai.e;
                        for (let am = 0; am < m.count; am++) {
                            let an = m._inner[am];
                            if (!an.c && an.a != ai.a && an.d >= ai.d) {
                                an.d++;
                            }
                        }
                        DescriptionTreeReconciler.g(a, ai.a, ae.a, f);
                    }
                }
            }
            else {
                let ao = Math.max(h.length, i.length);
                for (let ap = 0; ap < ao; ap++) {
                    if (ap >= h.length) {
                        let aq = new DescriptionTreeAction();
                        aq.j = e.c;
                        aq.c = b;
                        aq.b = c;
                        aq.d = e.a;
                        aq.e = ap;
                        aq.a = 2;
                        aq.g = i[ap];
                        a.add(aq);
                    }
                    else if (ap >= i.length) {
                        let ar = new DescriptionTreeAction();
                        ar.j = e.c;
                        ar.c = b;
                        ar.b = c;
                        ar.d = e.a;
                        ar.f = i.length;
                        ar.a = 4;
                        ar.h = h[ap];
                        a.add(ar);
                    }
                    else {
                        let as = h[ap];
                        let at = i[ap];
                        if (typeCast(DescriptionTreeNode.$, as) !== null && typeCast(DescriptionTreeNode.$, at) !== null) {
                            let au = as;
                            let av = at;
                            if (au.i == av.i) {
                                DescriptionTreeReconciler.g(a, au, av, f);
                            }
                            else {
                                let aw = new DescriptionTreeAction();
                                aw.j = e.c;
                                aw.c = b;
                                aw.b = c;
                                aw.d = e.a;
                                aw.f = ap;
                                aw.e = ap;
                                aw.a = 3;
                                aw.h = h[ap];
                                aw.g = i[ap];
                                a.add(aw);
                            }
                        }
                        else {
                            if (!Base.equalsStatic(as, at)) {
                                let ax = new DescriptionTreeAction();
                                ax.j = e.c;
                                ax.c = b;
                                ax.b = c;
                                ax.d = e.a;
                                ax.f = ap;
                                ax.e = ap;
                                ax.a = 3;
                                ax.h = h[ap];
                                ax.g = i[ap];
                                a.add(ax);
                            }
                        }
                    }
                }
            }
        }
        static b(a, b) {
            let c = a;
            let d = b;
            if (c == null && d == null) {
                return true;
            }
            if ((c != null && d == null) || (c == null && d != null)) {
                return false;
            }
            if (c.length != d.length) {
                return false;
            }
            for (let e = 0; e < c.length; e++) {
                let f = c[e];
                let g = d[e];
                if (typeCast(DescriptionTreeNode.$, f) !== null && !(typeCast(DescriptionTreeNode.$, g) !== null)) {
                    return false;
                }
                if (!(typeCast(DescriptionTreeNode.$, f) !== null) && typeCast(DescriptionTreeNode.$, g) !== null) {
                    return false;
                }
                if (typeCast(DescriptionTreeNode.$, f) !== null) {
                    let h = f;
                    let i = g;
                    if (h.i != i.i) {
                        return false;
                    }
                    let j = h.c("Name") ? h.a("Name").b : null;
                    let k = i.c("Name") ? i.a("Name").b : null;
                    if (!Base.equalsStatic(j, k)) {
                        return false;
                    }
                }
                else {
                    if (!Base.equalsStatic(f, g)) {
                        return false;
                    }
                }
            }
            return true;
        }
        static e(a) {
            let b = new List$1(DescriptionPropertyValue.$, 0);
            let c = a.f();
            for (let d = 0; d < c.count; d++) {
                let e = c._inner[d];
                if (e.a != null && e.a.knownType != 10 && e.a.knownType != 9) {
                    b.add(e);
                }
            }
            return b;
        }
        static d(a) {
            let b = new List$1(DescriptionPropertyValue.$, 0);
            let c = a.f();
            for (let d = 0; d < c.count; d++) {
                let e = c._inner[d];
                if (e.a != null && (e.a.knownType == 10 || e.a.knownType == 9)) {
                    b.add(e);
                }
            }
            return b;
        }
    }
    DescriptionTreeReconciler.$t = /*@__PURE__*/ markType(DescriptionTreeReconciler, 'DescriptionTreeReconciler');
    return DescriptionTreeReconciler;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionRefTargetInfo = /*@__PURE__*/ (() => {
    class DescriptionRefTargetInfo extends Base {
        constructor() {
            super(...arguments);
            this._target = null;
            this._propertyName = null;
            this._container = null;
        }
        get target() {
            return this._target;
        }
        set target(a) {
            this._target = a;
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get container() {
            return this._container;
        }
        set container(a) {
            this._container = a;
        }
    }
    DescriptionRefTargetInfo.$t = /*@__PURE__*/ markType(DescriptionRefTargetInfo, 'DescriptionRefTargetInfo');
    return DescriptionRefTargetInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ComponentRenderer = /*@__PURE__*/ (() => {
    class ComponentRenderer extends Base {
        static get defaultInstance() {
            return ComponentRenderer._defaultInstance;
        }
        static set defaultInstance(a) {
            ComponentRenderer._defaultInstance = a;
        }
        get adapter() {
            return this._adapter;
        }
        set adapter(a) {
            this._adapter = a;
        }
        get context() {
            return this._context;
        }
        set context(a) {
            this._context = a;
        }
        get isProceedOnErrorEnabled() {
            return this._isProceedOnErrorEnabled;
        }
        set isProceedOnErrorEnabled(a) {
            this._isProceedOnErrorEnabled = a;
        }
        constructor() {
            super();
            this._adapter = null;
            this._context = null;
            this._isProceedOnErrorEnabled = false;
            this.j = null;
            this.k = null;
            this._preserveKeyOrder = false;
            this.ay = new Dictionary$2(Base.$, Description.$, 0);
            this.az = new Dictionary$2(Base.$, Boolean_$type, 0);
            this.a0 = new Dictionary$2(Base.$, Boolean_$type, 0);
            this.ax = new Dictionary$2(Base.$, Boolean_$type, 0);
            this.av = new Dictionary$2(Base.$, DescriptionTreeNode.$, 0);
            this.a4 = new Dictionary$2(Base.$, ContainerState.$, 0);
            this.a1 = new Dictionary$2(Base.$, Queue$1.$.specialize(Queue$1.$.specialize(DescriptionTreeAction.$)), 0);
            this.aw = new Dictionary$2(Base.$, List$1.$.specialize(Delegate_$type), 0);
            this.au = new Dictionary$2(Base.$, Boolean_$type, 0);
            this.a3 = new Dictionary$2(String_$type, DescriptionRef.$, 0);
            this.a5 = new Dictionary$2(String_$type, Base.$, 0);
            this.a7 = new Dictionary$2(String_$type, Base.$, 0);
            this.a2 = new Dictionary$2(Base.$, String_$type, 0);
            this.bb = new List$1(Delegate_$type, 0);
            this.a6 = new Dictionary$2(String_$type, List$1.$.specialize(Delegate_$type), 0);
            this.a9 = new List$1(Delegate_$type, 0);
            this.ba = new List$1(Delegate_$type, 0);
            this._shouldNamespaceSystemRefValues = false;
            let a = this.i();
            this.adapter = a;
            let adapter_ = this.adapter;
            let b = (adapter_._platform);
            if (b == "Igc") {
                ComponentRenderer.platform = 4;
            }
            else if (b == "Igr") {
                ComponentRenderer.platform = 2;
            }
            this.context = new TypeDescriptionContext(this.adapter, ComponentRenderer.platform);
            this.j = new TypeDescriptionPropretyTransforms();
            this.k = new TypeDescriptionCleanups();
        }
        i() {
            return (new ComponentRendererAdapter());
        }
        toJson(a) {
            let b = new DescriptionSerializerBuilder();
            let c = new DescriptionSerializer();
            b.f("{");
            b.i();
            b.f("\"descriptions\": {");
            b.i();
            let d = true;
            for (let e of fromEnum(this.av.keys)) {
                if (d) {
                    d = false;
                }
                else {
                    b.f(",");
                }
                let f = e;
                let g = this.av.item(e);
                let h = "root";
                h = a(f);
                if (stringIsNullOrEmpty(h)) {
                    h = "root";
                }
                b.e("\"" + h + "\"");
                b.e(": ");
                c.t(this.context, g, b);
            }
            b.f("");
            b.h();
            b.e("}");
            if (this.a7.count > 0) {
                b.e(",");
            }
            b.f("");
            if (this.a7.count > 0) {
                d = true;
                b.f("refs: {");
                b.i();
                for (let i of fromEnum(this.a7.keys)) {
                    if (!this.p(i, this.a7.item(i))) {
                        continue;
                    }
                    if (d) {
                        d = false;
                    }
                    else {
                        b.f(",");
                    }
                    this.d6(b, i, this.a7.item(i));
                }
                b.f("");
                b.h();
                b.f("}");
            }
            b.h();
            b.f("}");
            return b.toString();
        }
        d6(a, b, c) {
            a.e("\"" + b + "\": ");
            this.d7(a, c);
        }
        d7(a, b) {
            if (this.y(b)) {
                if (typeof b === 'string') {
                    a.e(b == null ? "null" : "\"" + b.toString() + "\"");
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeCast(Date_$type, b) !== null) {
                    let v_ = b;
                    a.e("\"" + (v_.toJSON()) + "\"");
                }
                else if (typeCast(Boolean_$type, b) !== null) {
                    a.e(b == null ? "null" : b.toString().toLowerCase());
                }
                else {
                    a.e("null");
                }
            }
            else {
                if (b == null) {
                    a.e("null");
                    return;
                }
                if (this.v(b)) {
                    a.f("[");
                    a.i();
                    let c = new DataSourceLocalDataProvider();
                    c.dataSource = b;
                    for (let d = 0; d < c.actualCount; d++) {
                        if (d > 0) {
                            a.f(",");
                        }
                        this.d5(a, c, d);
                    }
                    a.f("");
                    a.h();
                    a.e("]");
                }
                else {
                    let e = [b];
                    let f = new DataSourceLocalDataProvider();
                    f.dataSource = e;
                    this.d5(a, f, 0);
                }
            }
        }
        y(a) {
            if (typeof a === 'string') {
                return true;
            }
            if (typeof a === 'number' || typeof a === 'number' || typeof a === 'number' || typeof a === 'number' || typeof a === 'number' || typeof a === 'number' || typeof a === 'number') {
                return true;
            }
            if (typeCast(Date_$type, a) !== null) {
                return true;
            }
            if (typeCast(Boolean_$type, a) !== null) {
                return true;
            }
            return false;
        }
        v(a) {
            if (typeCast(Array_$type, a) !== null) {
                return true;
            }
            if (typeCast(IEnumerable_$type, a) !== null) {
                return true;
            }
            return false;
        }
        d5(a, b, c) {
            a.f("{");
            a.i();
            let d = b.actualSchema;
            for (let e = 0; e < d.propertyNames.length; e++) {
                if (e > 0) {
                    a.f(",");
                }
                let f = d.propertyNames[e];
                if (stringStartsWith(f, "[")) {
                    f = f.substr(1, f.length - 2);
                }
                a.e("\"" + f + "\"");
                a.e(": ");
                let g = b.getItemValue(b.getItemAtIndex(c), d.propertyNames[e]);
                switch (d.propertyTypes[e]) {
                    case 0:
                        a.e(g == null ? "null" : "\"" + g.toString() + "\"");
                        break;
                    case 2:
                        a.e(g == null ? "null" : "\"" + g.toString() + "\"");
                        break;
                    case 10:
                    case 6:
                    case 5:
                    case 1:
                    case 3:
                    case 4:
                    case 7:
                        a.e(g == null ? "null" : g.toString());
                        break;
                    case 8:
                        let v_ = g;
                        a.e("\"" + (v_.toJSON()) + "\"");
                        break;
                    case 11:
                        this.d7(a, g);
                        break;
                }
            }
            a.h();
            a.f("}");
        }
        p(a, b) {
            if (b == null) {
                return true;
            }
            let v_ = b;
            if ((typeof v_ === 'function')) {
                return false;
            }
            return true;
        }
        createObjectFromJson(a, b) {
            let c = new JsonDictionaryParser();
            let d = c.parse(a);
            let e = new DescriptionSerializer();
            let f = false;
            let g = e.d(this.context, d, f, null, false);
            if (g.result == null) {
                return null;
            }
            let h = DescriptionTreeBuilder.createTree(this.context, g.result);
            let i = this.a4.item(b);
            if (h.c("Type")) {
                let j = h.a("Type").b;
                return this.b0(j, h, b, i, true, -1, null);
            }
            else {
                return this.bz(typeCast(JsonDictionaryObject.$, d));
            }
        }
        loadJson(a, b) {
            this.de(a, b, null, false, false, false);
        }
        loadJsonOverlay(a, b, c) {
            this.de(a, b, c, true, false, true);
        }
        loadJsonDelta(a, b, c) {
            this.de(a, b, null, true, c, false);
        }
        get preserveKeyOrder() {
            return this._preserveKeyOrder;
        }
        set preserveKeyOrder(a) {
            this._preserveKeyOrder = a;
        }
        ar() {
            return false;
        }
        dg(a) {
        }
        de(a, b, c, d, e, f) {
            let g = new JsonDictionaryParser();
            let h = g.parse(a);
            let i = new DescriptionSerializer();
            i.h = this.isProceedOnErrorEnabled;
            i.g = this.ar();
            let j = null;
            if (typeCast(JsonDictionaryObject.$, h) !== null) {
                let k = h;
                if (k.g("skipAlterDataCasing")) {
                    let l = k.item("skipAlterDataCasing");
                    if (l.value) {
                        this.dg(true);
                    }
                }
                else {
                    this.dg(false);
                }
                if (k.g("descriptions")) {
                    let m = k.item("descriptions");
                    if (typeCast(JsonDictionaryObject.$, m) !== null) {
                        let n = m;
                        let o = n.e();
                        for (let p = 0; p < o.length; p++) {
                            let q = o[p];
                            let r = n.item(q);
                            let s = b(q);
                            if (s == null) {
                                continue;
                            }
                            j = s;
                            let t = false;
                            let u = this.be();
                            if (u != null) {
                                t = true;
                            }
                            let v = null;
                            if (this.isProceedOnErrorEnabled) {
                                try {
                                    v = i.d(this.context, r, t, u, false);
                                }
                                catch (w) {
                                    return;
                                }
                            }
                            else {
                                v = i.d(this.context, r, t, u, false);
                            }
                            if (v.result == null) {
                                continue;
                            }
                            if (f) {
                                if (!this.a8.containsKey(s)) {
                                    let x = null;
                                    if (this.isProceedOnErrorEnabled) {
                                        try {
                                            x = i.d(this.context, r, t, u, true);
                                        }
                                        catch (y) {
                                            return;
                                        }
                                    }
                                    else {
                                        x = i.d(this.context, r, t, u, true);
                                    }
                                    this.d0(x.result, s, d, true, false);
                                    let z = c(q);
                                    let aa = this.a8.item(s);
                                    this.c8(this.av.item(s), z, aa, s);
                                }
                            }
                            this.d0(v.result, s, d, e, false);
                        }
                    }
                }
                if (k.g("refs") && j != null) {
                    let ab = k.item("refs");
                    let ac = this.ah(ab);
                    if (!ac && typeCast(JsonDictionaryObject.$, ab) !== null) {
                        let ad = ab;
                        let ae = ad.e();
                        for (let af = 0; af < ae.length; af++) {
                            let ag = ae[af];
                            let ah = ad.item(ag);
                            if (typeCast(JsonDictionaryValue.$, ah) !== null) {
                                let ai = ah;
                                this.provideRefValue(j, ag, ai.value);
                            }
                            else if (typeCast(JsonDictionaryArray.$, ah) !== null) {
                                let aj = ah;
                                let ak = this.a(aj);
                                this.provideRefValue(j, ag, ak);
                            }
                            else {
                                let al = this.bz(ah);
                                this.provideRefValue(j, ag, al);
                            }
                        }
                    }
                }
                if (k.g("modules") && j != null) {
                    let am = k.item("modules");
                    this.ae(am);
                }
                if (k.g("strings") && j != null) {
                    let an = k.item("strings");
                    this.al(an);
                }
                if (k.g("onInit") && j != null) {
                    let ao = k.item("onInit");
                    this.af(ao);
                }
                if (k.g("onViewInit") && j != null) {
                    let ap = k.item("onViewInit");
                    this.ag(ap);
                }
            }
        }
        provideRefValueFromJson(a, b, c) {
            let d = b;
            let e = new JsonDictionaryParser();
            let f = e.parse(c);
            if (typeCast(JsonDictionaryValue.$, f) !== null) {
                let g = f;
                this.provideRefValue(a, d, g.value);
            }
            else if (typeCast(JsonDictionaryArray.$, f) !== null) {
                let h = f;
                let i = this.a(h);
                this.provideRefValue(a, d, i);
            }
            else {
                let j = this.bz(f);
                this.provideRefValue(a, d, j);
            }
        }
        be() {
            return null;
        }
        ah(a) {
            return false;
        }
        ae(a) {
            return false;
        }
        al(a) {
            return false;
        }
        af(a) {
            return false;
        }
        ag(a) {
            return false;
        }
        cq(a, b, c) {
            let d = a;
            if (c != null) {
                d = c.j(b);
            }
            else {
                if (TypeDescriptionMetadata.shouldCamelize(b)) {
                    d = TypeDescriptionMetadata.camelize(d);
                }
            }
            if (stringEndsWith(d, "Ref")) {
                d = d.substr(0, d.length - ("Ref").length);
            }
            return d;
        }
        c8(a, b, c, d) {
            if (!c.b(b)) {
                c.k(d, this.av.item(d).g, b, this.av.item(d), runOn(this, this.dl), -1);
            }
            for (let e of fromEnum(a.f())) {
                this.c9(this.cq(e.c, ComponentRenderer.platform, e.a), e.b, b, c, d, a.g);
            }
        }
        c9(a, b, c, d, e, f) {
            if (typeCast(DescriptionTreeNode.$, b) !== null) {
                let g = b;
                let h = this.adapter.getPropertyValue(c, a);
                if (!d.b(h) && !d.a(g.g)) {
                    d.k(e, g.g, h, g, runOn(this, this.dl), f);
                }
                for (let i of fromEnum(g.f())) {
                    this.c9(a + "." + this.cq(i.c, ComponentRenderer.platform, i.a), i.b, c, d, e, g.g);
                }
            }
            if (typeCast(Array_$type, b) !== null) {
                let j = new Dictionary$2(Number_$type, DescriptionTreeNode.$, 0);
                let k = 0;
                let l = b.length;
                let o = b;
                for (let n = 0; n < o.length; n++) {
                    let m = o[n];
                    if (typeCast(DescriptionTreeNode.$, m) !== null) {
                        let p = m;
                        j.item(k, p);
                    }
                    k++;
                }
                let q = this.adapter.getPropertyValue(c, a);
                k = 0;
                this.adapter.forPropertyValueItem(c, a, (r) => {
                    if (j.containsKey(k)) {
                        let s = j.item(k);
                        if (!d.b(r) && !d.a(s.g)) {
                            d.k(e, s.g, r, s, runOn(this, this.dl), f);
                        }
                        for (let t of fromEnum(s.f())) {
                            this.c9(a + "." + t.c, t.b, c, d, e, s.g);
                        }
                    }
                    k++;
                });
                if (l > 0 && k == 0) {
                    let r = this.cv(a);
                    this.adapter.forPropertyValueItem(c, r, (s) => {
                        if (j.containsKey(k)) {
                            let t = j.item(k);
                            if (!d.b(s) && !d.a(t.g)) {
                                d.k(e, t.g, s, t, runOn(this, this.dl), f);
                            }
                            for (let u of fromEnum(t.f())) {
                                this.c9(r + "." + u.c, u.b, c, d, e, t.g);
                            }
                        }
                        k++;
                    });
                }
            }
        }
        cv(a) {
            let b = a.lastIndexOf('.');
            let c = null;
            let d = a;
            if (b > 0) {
                c = a.substr(0, b);
                d = a.substr(b + 1);
            }
            d = "actual" + this.cs(d);
            if (c != null) {
                return c + "." + d;
            }
            return d;
        }
        cs(a) {
            return a.substr(0, 1).toUpperCase() + a.substr(1);
        }
        a(a) {
            let b = new Array(a.items.length);
            for (let c = 0; c < a.items.length; c++) {
                let d = this.bz(a.items[c]);
                b[c] = d;
            }
            return b;
        }
        bz(a) {
            if (a == null) {
                return null;
            }
            let b = {};
            let dict_ = b;
            let c = a.e();
            for (let d = 0; d < c.length; d++) {
                let key_ = c[d];
                if (typeCast(JsonDictionaryObject.$, a.item(key_)) !== null) {
                    let val_ = this.bz(a.item(key_));
                    dict_[key_] = val_;
                }
                else if (typeCast(JsonDictionaryArray.$, a.item(key_)) !== null) {
                    let val_ = this.a(a.item(key_));
                    dict_[key_] = val_;
                }
                else {
                    let val_ = a.item(key_).value;
                    dict_[key_] = val_;
                }
            }
            return dict_;
        }
        get a8() {
            return this.a4;
        }
        cleanup(a, b) {
            this.d0(null, a, false, false, b);
        }
        render(a, b) {
            this.d0(a, b, false, false, false);
        }
        d0(a, b, c, d, e) {
            if (!this.a4.containsKey(b)) {
                this.a4.item(b, new ContainerState());
                this.a4.item(b).i = b;
            }
            this.ay.item(b, a);
            this.az.item(b, c);
            this.a0.item(b, d);
            this.ax.item(b, e);
            this.dh(b, () => this.dy(b));
        }
        dh(a, b) {
            this.adapter.onUIThread(a, b);
        }
        dy(a) {
            if (this.ay.containsKey(a)) {
                let b = this.az.containsKey(a) ? this.az.item(a) : false;
                let c = this.a0.containsKey(a) ? this.a0.item(a) : false;
                let d = this.ay.item(a);
                this.ay.removeItem(a);
                let e = DescriptionTreeBuilder.createTreeWithOptions(this.context, d, this.preserveKeyOrder);
                let f = null;
                if (this.av.containsKey(a)) {
                    f = this.av.item(a);
                }
                let g = DescriptionTreeReconciler.c(f, e, b);
                if (!c && b) {
                    e = f.b();
                    DescriptionTreeReconciler.a(f, g);
                    let h = f;
                    f = e;
                    e = h;
                    g = DescriptionTreeReconciler.c(f, e, false);
                }
                if (c) {
                    let i = DescriptionTreeReconciler.a(f, g);
                    if (!this.a4.containsKey(a)) {
                        this.a4.addItem(a, ((() => {
                            let $ret = new ContainerState();
                            $ret.i = a;
                            return $ret;
                        })()));
                    }
                    let j = this.a4.item(a);
                    if (i.a.count > 0) {
                        for (let k of fromEnum(i.a)) {
                            if (j.a(k)) {
                                let l = j.j(k);
                                this.c6(a, l, j);
                            }
                        }
                    }
                    if (i.c.count > 0) {
                        for (let m of fromEnum(i.c)) {
                            let n = this.b6(a, j, m);
                            let o = this.adapter.getPropertyValue(n, m.j);
                            if (o != null) {
                                if (!j.b(o)) {
                                    let p = m.g;
                                    if (typeCast(DescriptionTreeNode.$, p) !== null) {
                                        let q = p.g;
                                        j.k(a, q, o, p, runOn(this, this.dl), m.c.g);
                                    }
                                }
                            }
                        }
                    }
                    if (i.d.count > 0) {
                        for (let r of fromEnum(i.d)) {
                            let s = r.g;
                            if (s != null) {
                                if (!j.b(s)) {
                                    let t = r.g;
                                    if (typeCast(DescriptionTreeNode.$, t) !== null) {
                                        let u = t.g;
                                        this.av.item(a, t);
                                    }
                                }
                            }
                        }
                    }
                    if (i.b.count > 0) {
                        for (let v of fromEnum(i.b)) {
                            let w = v.c.a(v.j).b;
                            if (w == null) {
                                continue;
                            }
                            let x = new Dictionary$2(String_$type, DescriptionTreeNode.$, 0);
                            for (let y = 0; y < w.length; y++) {
                                let z = w[y];
                                if (typeCast(DescriptionTreeNode.$, z) !== null) {
                                    let aa = z;
                                    if (aa.c("Name")) {
                                        x.item(aa.a("Name").b, aa);
                                    }
                                }
                            }
                            if (x.count == 0) {
                                continue;
                            }
                            let ab = this.b6(a, j, v);
                            let ac = this.adapter.getPropertyValue(ab, v.j);
                            if (ac != null) {
                                let ad = 0;
                                this.adapter.forPropertyValueItem(ab, v.j, (ae) => {
                                    if (x.containsKey(this.adapter.getPropertyValue(ae, "Name").toString())) {
                                        if (!j.b(ae)) {
                                            let af = x.item(this.adapter.getPropertyValue(ae, "Name").toString());
                                            if (typeCast(DescriptionTreeNode.$, af) !== null) {
                                                let ag = af.g;
                                                j.k(a, ag, ae, af, runOn(this, this.dl), v.c.g);
                                            }
                                        }
                                    }
                                    ad++;
                                });
                            }
                        }
                    }
                }
                else {
                    this.av.item(a, e);
                }
                if (!c) {
                    this.dz(a, g);
                }
                if (this.ax.item(a)) {
                    this.dw(a);
                    if (this.a4.containsKey(a)) {
                        this.a4.removeItem(a);
                    }
                }
            }
        }
        getTargetValue(a, b, c) {
            let d = this.context.getMetadata(a, this.cs(b));
            let e = d.j(ComponentRenderer.platform);
            return this.adapter.getPropertyValue(c, e);
        }
        setTargetValue(a, b, c, d, e) {
            let f = this.context.getMetadata(a, this.cs(b));
            let g = f.j(ComponentRenderer.platform);
            this.adapter.setPropertyValue(c, g, f, d, e, null);
        }
        executeMethod(a, b, c) {
            let d = new JsonDictionaryParser();
            let e = d.parse(b);
            if (!this.a4.containsKey(a)) {
                this.a4.item(a, new ContainerState());
                this.a4.item(a).i = a;
            }
            let f = this.a4.item(a);
            let g = new DescriptionSerializer();
            g.h = this.isProceedOnErrorEnabled;
            g.g = this.ar();
            let h = this.av.item(a);
            let i = null;
            let j = new List$1(Base.$, 0);
            let k = new List$1(TypeDescriptionMetadata.$, 0);
            if (typeCast(JsonDictionaryObject.$, e) !== null) {
                let l = null;
                let m = e;
                if (m.g("targetRef")) {
                    l = this.co(m, "targetRef");
                }
                let n = null;
                if (m.g("methodName")) {
                    n = this.co(m, "methodName");
                }
                if (l != null) {
                    if (this.a5.containsKey(l)) {
                        i = this.a5.item(l);
                    }
                }
                else {
                    i = f.j(h.g);
                }
                if (m.g("args")) {
                    let o = m.item("args");
                    for (let p = 0; p < o.items.length; p++) {
                        let q = o.items[p];
                        let r = this.g(h, q, g);
                        let s = null;
                        if (typeCast(DescriptionTreeNode.$, r.g) !== null && r.g.i == "EmbeddedRef") {
                            s = this.b8(a, r.g);
                        }
                        else {
                            s = this.b3(r, a, f);
                        }
                        if (r.d.knownType == 8 && r.d.specificType == "string") {
                            s = this.bo(r.d.specificExternalType, s, r.d);
                        }
                        j.add1(s);
                        k.add(r.d);
                    }
                }
                let t = null;
                if (m.g("return")) {
                    let u = m.item("return");
                    let v = this.g(h, u, g);
                    t = v.d;
                }
                this.adapter.executeMethod(i, n, j.toArray(), k.toArray(), (w) => {
                    let x = this.ct(w, t);
                    c(x);
                });
            }
        }
        b8(a, b) {
            if (b.i == "EmbeddedRef") {
                let c = "uuid";
                let d = null;
                for (let e = 0; e < b.f().count; e++) {
                    if (b.f()._inner[e].c == "RefType") {
                        c = b.f()._inner[e].b;
                    }
                    if (b.f()._inner[e].c == "Value") {
                        d = b.f()._inner[e].b;
                    }
                }
                if (d != null) {
                    for (let f = 0; f < this.a9.count; f++) {
                        let g = this.a9._inner[f](a, c, d);
                        if (g != null) {
                            return g;
                        }
                    }
                    if (c == "name") {
                        let h = d;
                        if (this.a5.containsKey(h)) {
                            return this.a5.item(h);
                        }
                        if (this.a7.containsKey(h)) {
                            return this.a7.item(h);
                        }
                    }
                    return null;
                }
            }
            return null;
        }
        static bd(a) {
            if (typeCast(Date_$type, a) !== null) {
                return a.getTime();
            }
            if (a == null) {
                return 0;
            }
            return a;
        }
        ct(a, b) {
            let c = new JsonDictionaryObject();
            c.item("knownType", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = EnumUtil.getName(TypeDescriptionWellKnownType_$type, b.knownType);
                return $ret;
            })()));
            if (b.specificType != null) {
                c.item("specificType", ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = b.specificType;
                    return $ret;
                })()));
            }
            if (b.specificExternalType != null) {
                c.item("specificExternalType", ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = b.specificExternalType;
                    return $ret;
                })()));
            }
            if (b.collectionElementType != null) {
                c.item("collectionElementType", ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = b.collectionElementType;
                    return $ret;
                })()));
            }
            switch (b.knownType) {
                case 0: break;
                case 1:
                    c.item("result", ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 0;
                        $ret.value = ComponentRenderer.bd(a);
                        return $ret;
                    })()));
                    break;
                case 2:
                    c.item("result", ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 2;
                        $ret.value = a != null ? a.toString() : null;
                        return $ret;
                    })()));
                    break;
                case 3:
                    c.item("result", ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 2;
                        $ret.value = a != null ? a.toString() : null;
                        return $ret;
                    })()));
                    break;
                case 4:
                    c.item("result", ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 2;
                        $ret.value = this.b9(a);
                        return $ret;
                    })()));
                    break;
                case 5:
                    c.item("result", ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 2;
                        $ret.value = this.cb(a);
                        return $ret;
                    })()));
                    break;
                case 6:
                    c.item("result", ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 2;
                        $ret.value = this.ca(a);
                        return $ret;
                    })()));
                    break;
                case 7:
                    c.item("result", ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 1;
                        $ret.value = a;
                        return $ret;
                    })()));
                    break;
                case 8: break;
                case 9: break;
                case 10: break;
                case 11:
                    c.item("result", ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 2;
                        $ret.value = this.ce(a);
                        return $ret;
                    })()));
                    break;
                case 12:
                    c.item("result", this.cg(a));
                    break;
                case 13: break;
                case 14:
                    c.item("result", ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 2;
                        $ret.value = this.cf(a);
                        return $ret;
                    })()));
                    break;
                case 15: break;
                case 16:
                    c.item("result", ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 2;
                        $ret.value = this.cc(a);
                        return $ret;
                    })()));
                    break;
                case 17: break;
                case 18: break;
                case 19: break;
                case 20: break;
                case 21:
                    c.item("result", ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 2;
                        $ret.value = this.ch(a);
                        return $ret;
                    })()));
                    break;
                case 22: break;
                case 23:
                    c.item("result", ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 2;
                        $ret.value = this.cd(a);
                        return $ret;
                    })()));
                    break;
            }
            return c.b();
        }
        cd(a) {
            return this.adapter.serializeDoubleCollection(a);
        }
        ch(a) {
            return this.adapter.serializeTimespan(a);
        }
        cc(a) {
            return this.adapter.serializeColorCollection(a);
        }
        cf(a) {
            return this.adapter.serializeRect(a);
        }
        cg(a) {
            return this.adapter.serializeSize(a);
        }
        ce(a) {
            return this.adapter.serializePoint(a);
        }
        ca(a) {
            return this.adapter.serializeBrushCollection(a);
        }
        cb(a) {
            return this.adapter.serializeColor(a);
        }
        b9(a) {
            return this.adapter.serializeBrush(a);
        }
        g(a, b, c) {
            let d = new DescriptionTreeAction();
            d.a = 0;
            d.c = a;
            d.j = "*argument";
            let e = new TypeDescriptionMetadata();
            e.propertyName = "*argument";
            let f;
            let g = this.co(b, "knownType");
            let h = EnumUtil.tryParse$1(TypeDescriptionWellKnownType_$type, g, true, f);
            f = h.p2;
            e.knownType = f;
            e.specificExternalType = this.co(b, "specificExternalType");
            e.specificType = this.co(b, "specificType");
            e.collectionElementType = this.co(b, "collectionElementType");
            d.d = e;
            let i = null;
            i = this.b2(e, b, c);
            d.g = i;
            return d;
        }
        co(a, b) {
            if (typeCast(JsonDictionaryObject.$, a) !== null) {
                let c = a;
                if (c.g(b)) {
                    return c.item(b).value != null ? c.item(b).value.toString() : null;
                }
            }
            return null;
        }
        b2(a, b, c) {
            if (typeCast(JsonDictionaryObject.$, b) !== null) {
                let d = b;
                if (d.g("value")) {
                    let e = (d.item("value")) != null ? (d.item("value")) : null;
                    return this.by(a.knownType, a.specificType, a.specificExternalType, a.collectionElementType, e, c);
                }
            }
            return null;
        }
        by(a, b, c, d, e, f) {
            if (typeCast(JsonDictionaryObject.$, e) !== null) {
                let g = e;
                if (g.g("type") || g.g("refType")) {
                    let h = f.c(this.context, g.b());
                    if (h != null) {
                        let i = h.result;
                        if (i == null) {
                            return null;
                        }
                        return DescriptionTreeBuilder.createTreeWithOptions(this.context, i, this.preserveKeyOrder);
                    }
                    return null;
                }
                else if (a == 11) {
                    let j = DescriptionSerializer.k(this.context, g);
                    return DescriptionTreeBuilder.createTreeWithOptions(this.context, j, this.preserveKeyOrder);
                }
                else if (a == 14) {
                    let k = DescriptionSerializer.k(this.context, g);
                    return DescriptionTreeBuilder.createTreeWithOptions(this.context, k, this.preserveKeyOrder);
                }
                else if (a == 12) {
                    let l = DescriptionSerializer.k(this.context, g);
                    return DescriptionTreeBuilder.createTreeWithOptions(this.context, l, this.preserveKeyOrder);
                }
            }
            else if (typeCast(JsonDictionaryArray.$, e) !== null) {
                let m = e;
                let n = "string";
                let o = false;
                if (a == 10) {
                    n = c;
                }
                if (a == 9) {
                    o = true;
                    n = d;
                }
                let p = new Array(m.items.length);
                let q;
                let r;
                let s;
                let t;
                let u = this.db(o, n, b, c, q, r, s, t);
                q = u.p4;
                r = u.p5;
                s = u.p6;
                t = u.p7;
                if (m.items != null) {
                    for (let v = 0; v < m.items.length; v++) {
                        let w = m.items[v];
                        let x = this.by(q, r, s, t, w, f);
                        p[v] = x;
                    }
                }
                return p;
            }
            else if (typeCast(JsonDictionaryValue.$, e) !== null) {
                return e.value;
            }
            return e;
        }
        db(a, b, c, d, e, f, g, h) {
            if (a) {
                e = 8;
                f = b;
                g = null;
                h = null;
                return {
                    p4: e,
                    p5: f,
                    p6: g,
                    p7: h
                };
            }
            let i = c;
            if (d != null) {
                i = d;
            }
            h = null;
            switch (d) {
                case "string":
                    if (c != null && c != "string") {
                        e = 8;
                        f = "string";
                        g = d;
                    }
                    else {
                        e = 2;
                        f = null;
                        g = null;
                    }
                    return {
                        p4: e,
                        p5: f,
                        p6: g,
                        p7: h
                    };
                case "double":
                    e = 1;
                    f = "double";
                    g = "double";
                    return {
                        p4: e,
                        p5: f,
                        p6: g,
                        p7: h
                    };
                case "int":
                    e = 1;
                    f = "double";
                    g = "double";
                    return {
                        p4: e,
                        p5: f,
                        p6: g,
                        p7: h
                    };
                case "long":
                    e = 1;
                    f = "double";
                    g = "double";
                    return {
                        p4: e,
                        p5: f,
                        p6: g,
                        p7: h
                    };
                case "bool":
                    e = 1;
                    f = "double";
                    g = "double";
                    return {
                        p4: e,
                        p5: f,
                        p6: g,
                        p7: h
                    };
            }
            e = 8;
            f = c;
            g = d;
            return {
                p4: e,
                p5: f,
                p6: g,
                p7: h
            };
        }
        resolveRefValue(a, b, c) {
            this.dh(a, () => {
                if (!this.a4.containsKey(a)) {
                    this.a4.addItem(a, ((() => {
                        let $ret = new ContainerState();
                        $ret.i = a;
                        return $ret;
                    })()));
                }
                let d = this.a4.item(a);
                if (!this.hasRef(b)) {
                    c(null);
                    return;
                }
                let e = this.f(b);
                let f = this.b5(e);
                c(f);
            });
        }
        resolveRefName(a, b, c) {
            this.dh(a, () => {
                if (!this.a4.containsKey(a)) {
                    this.a4.addItem(a, ((() => {
                        let $ret = new ContainerState();
                        $ret.i = a;
                        return $ret;
                    })()));
                }
                let d = this.a4.item(a);
                if (b != null && this.a2.containsKey(b)) {
                    c(this.a2.item(b));
                    return;
                }
                c(null);
            });
        }
        provideRefValue(a, b, c) {
            this.dh(a, () => {
                if (!this.a4.containsKey(a)) {
                    this.a4.addItem(a, ((() => {
                        let $ret = new ContainerState();
                        $ret.i = a;
                        return $ret;
                    })()));
                }
                let d = this.a4.item(a);
                this.dl(a, b, c, true);
            });
        }
        removeRefValue(a, b) {
            this.dh(a, () => {
                if (!this.a4.containsKey(a)) {
                    this.a4.addItem(a, ((() => {
                        let $ret = new ContainerState();
                        $ret.i = a;
                        return $ret;
                    })()));
                }
                let c = this.a4.item(a);
                this.removeRefValueCore(a, b, true);
            });
        }
        dw(a) {
            let b = this.a4.item(a);
            let c = new List$1(String_$type, 0);
            for (let d of fromEnum(this.a3.keys)) {
                if (this.a3.item(d).c == 0) {
                    c.add(d);
                }
            }
            for (let e = 0; e < c.count; e++) {
                let f = this.shouldNamespaceSystemRefValues;
                this.shouldNamespaceSystemRefValues = false;
                this.removeRefValueCore(a, c._inner[e], this.a7.containsKey(c._inner[e]));
                this.shouldNamespaceSystemRefValues = f;
            }
        }
        clearRefValues(a) {
            this.dh(a, () => {
                if (!this.a4.containsKey(a)) {
                    this.a4.addItem(a, ((() => {
                        let $ret = new ContainerState();
                        $ret.i = a;
                        return $ret;
                    })()));
                }
                let b = this.a4.item(a);
                this.clearUserRefValues();
            });
        }
        w(a) {
            if (this.au.containsKey(a) && this.au.item(a)) {
                return false;
            }
            if (this.a1.containsKey(a) && this.a1.item(a).count > 0) {
                return false;
            }
            return true;
        }
        queueForIdle(a, b) {
            this.dh(a, () => {
                if (this.w(a)) {
                    b();
                }
                else {
                    if (!this.aw.containsKey(a)) {
                        this.aw.item(a, new List$1(Delegate_$type, 0));
                    }
                    this.aw.item(a).add(b);
                }
            });
        }
        tryFlushIdleActions(a) {
            if (this.w(a)) {
                if (this.aw.containsKey(a)) {
                    let b = new List$1(Delegate_$type, 1, this.aw.item(a));
                    this.aw.item(a).clear();
                    for (let c = 0; c < b.count; c++) {
                        b._inner[c]();
                    }
                }
            }
        }
        dz(a, b) {
            let c = this.a4.item(a);
            this.di(a, c, b);
        }
        d4(a, b) {
            if (this.isProceedOnErrorEnabled) {
                try {
                    this.c7(a, b, true);
                }
                catch (c) {
                    this.au.item(a, false);
                }
            }
            else {
                this.c7(a, b, true);
            }
        }
        eb(a, b) {
            if (this.isProceedOnErrorEnabled) {
                try {
                    this.c7(a, b, false);
                }
                catch (c) {
                    this.au.item(a, false);
                }
            }
            else {
                this.c7(a, b, false);
            }
        }
        c7(a, b, c) {
            if (!c) {
                if (this.au.containsKey(a) && this.au.item(a)) {
                    return;
                }
            }
            this.au.item(a, true);
            let d = true;
            while (d && this.a1.item(a).count > 0) {
                while (this.a1.item(a).count > 0 && this.a1.item(a).c().count < 1) {
                    this.a1.item(a).b();
                }
                if (this.a1.item(a).count < 1) {
                    break;
                }
                let e = this.a1.item(a).c();
                while (e.count > 0) {
                    let f = e.b();
                    d = this.ab(a, b, f);
                    if (!d) {
                        break;
                    }
                }
            }
            if (d) {
                this.au.item(a, false);
            }
            if (this.w(a)) {
                this.tryFlushIdleActions(a);
            }
        }
        di(a, b, c) {
            let d = new Queue$1(DescriptionTreeAction.$);
            for (let e = 0; e < c.count; e++) {
                d.g(c._inner[e]);
            }
            if (!this.a1.containsKey(a)) {
                this.a1.addItem(a, new Queue$1(Queue$1.$.specialize(DescriptionTreeAction.$)));
            }
            this.a1.item(a).g(d);
            this.eb(a, b);
        }
        dj(a, b, c) {
            for (let d = 0; d < c.count; d++) {
                this.ab(a, b, c._inner[d]);
            }
        }
        ab(a, b, c) {
            switch (c.a) {
                case 5: return this.ac(a, b, c);
                case 2: return this.ad(a, b, c);
                case 4: return this.ai(a, b, c);
                case 3: return this.aj(a, b, c);
                case 1: return this.ak(a, b, c);
                case 0: return this.am(a, b, c);
            }
            return true;
        }
        am(a, b, c) {
            let d = this.b6(a, b, c);
            this.at(a, b, c, d);
            return true;
        }
        at(a, b, c, d) {
            let e = this.b3(c, a, b);
            e = this.j.transform(ComponentRenderer.platform, e, c);
            let f = false;
            if (this.bb != null && this.bb.count > 0) {
                for (let g = 0; g < this.bb.count; g++) {
                    let h = this.bb._inner[g];
                    let i = this.cr(a, c);
                    if (h(i, d, e)) {
                        f = true;
                    }
                }
            }
            if (c.j == "Type" || c.j == "type") {
                f = true;
            }
            if (f) {
                return true;
            }
            if (c.d != null && c.d.knownType == 9) {
                this.aq(a, b, c.i(ComponentRenderer.platform), c.d, e, d);
            }
            else {
                this.d8(a, b, c.i(ComponentRenderer.platform), c.d, e, c.h, d);
            }
            return true;
        }
        cr(a, b) {
            let c = b.c;
            let d = "";
            if (c != this.av.item(a)) {
                let e = this.cp(a, c);
                d = e;
            }
            if (d.length > 0) {
                d += ".";
            }
            d += b.j;
            return d;
        }
        cp(a, b) {
            if (b == null) {
                return "";
            }
            let c = this.cw("", this.av.item(a), b);
            if (c.c) {
                return c.d;
            }
            return "";
        }
        cw(a, b, c) {
            if (b == c) {
                return new Tuple$2(Boolean_$type, String_$type, true, a);
            }
            if (a.length > 0) {
                a += ".";
            }
            let d = b.f();
            for (let e = 0; e < d.count; e++) {
                let f = d._inner[e];
                if (typeCast(DescriptionTreeNode.$, f.b) !== null) {
                    if (f.b.g == c.g) {
                        a += f.c;
                        return new Tuple$2(Boolean_$type, String_$type, true, a);
                    }
                    else {
                        let g = a + f.c;
                        let h = this.cw(g, f.b, c);
                        if (h.c) {
                            return h;
                        }
                    }
                }
                if (f.a != null && f.a.knownType == 9) {
                    let i = f.b;
                    for (let j = 0; j < i.length; j++) {
                        if (typeCast(DescriptionTreeNode.$, i[j]) !== null) {
                            let k = i[j];
                            if (k.g == c.g) {
                                a += f.c + "[" + j + "]";
                                return new Tuple$2(Boolean_$type, String_$type, true, a);
                            }
                            else {
                                let l = a + f.c + "[" + j + "]";
                                let m = this.cw(l, k, c);
                                if (m.c) {
                                    return m;
                                }
                            }
                        }
                    }
                }
            }
            return new Tuple$2(Boolean_$type, String_$type, false, a);
        }
        aq(a, b, c, d, e, f) {
            if (this.a6.containsKey(c)) {
                for (let g of fromEnum(this.a6.item(c))) {
                    g(c, f, e);
                }
            }
            this.adapter.setOrUpdateCollectionOnTarget(a, c, d, this.context, f, e);
            return true;
        }
        b3(a, b, c) {
            if (a.d == null) {
                return a.g;
            }
            switch (a.d.knownType) {
                case 10: return this.bg(a, b, c);
                case 7: return this.bh(a);
                case 4: return this.bi(a);
                case 6: return this.bj(a);
                case 23: return this.bn(a);
                case 9: return this.bg(a, b, c);
                case 5: return this.bk(a);
                case 16: return this.bl(a);
                case 20: return this.ci(a, c);
                case 22: return this.cl(a, c);
                case 15: return null;
                case 3: return this.bm(a);
                case 19: return this.cj(a, c);
                case 8: return this.bp(a, b, c);
                case 13: return null;
                case 18: return this.ck(a, c);
                case 1: return this.bq(a);
                case 11: return this.br(a);
                case 14: return this.bs(a);
                case 12: return this.bt(a);
                case 2: return this.bu(a);
                case 21: return this.bv(a);
                case 17: return this.bw(a, b, c);
                case 0: return null;
            }
            return null;
        }
        bw(a, b, c) {
            let d = this.bx(a.g, a, b, c);
            return d;
        }
        bx(a, b, c, d) {
            if (typeof a === 'string') {
                if (stringStartsWith(a, "@d:")) {
                    let v_ = a.substr(3);
                    a = new Date(v_);
                }
            }
            if (typeCast(Array_$type, a) !== null) {
                let e = a;
                let f = new Array(e.length);
                for (let g = 0; g < e.length; g++) {
                    let h = this.bx(e[g], b, c, d);
                    f[g] = h;
                }
                a = f;
            }
            if (typeCast(DescriptionTreeNode.$, a) !== null) {
                let i = a;
                if (i.i == "EmbeddedRef") {
                    return this.b0(i.i, a, c, d, false, b.c.g, b.d);
                }
            }
            return a;
        }
        bv(a) {
            return a.g;
        }
        bu(a) {
            return a.g != null ? a.g.toString() : null;
        }
        bt(a) {
            let b = a.g;
            let width_ = b.width;
            let height_ = b.height;
            let c = { width: width_, height: height_ };
            return c;
        }
        bs(a) {
            let b = a.g;
            let top_ = b.top;
            let left_ = b.left;
            let width_ = b.width;
            let height_ = b.height;
            let c = { left: left_, top: top_, width: width_, height: height_ };
            return c;
        }
        br(a) {
            let b = a.g;
            let x_ = b.x;
            let y_ = b.y;
            let c = { x: x_, y: y_ };
            return c;
        }
        bq(a) {
            if (a.g == null) {
                if (a.d != null && ((a.d.specificType == "double" || a.d.specificType == "float") || (a.d.specificExternalType == "double" || a.d.specificExternalType == "float"))) {
                    return NaN;
                }
                return 0;
            }
            let b = a.g;
            if (typeof b === 'number') {
                b = typeGetValue(b);
            }
            if (a.d != null && a.d.specificExternalType != null) {
                switch (a.d.specificExternalType) {
                    case "int":
                        b = truncate(b);
                        break;
                    case "float":
                        b = b;
                        break;
                    case "short":
                        b = truncate(b);
                        break;
                    case "long":
                        b = truncate(b);
                        break;
                }
            }
            return b;
        }
        e(a) {
            if (this.a3.containsKey(a)) {
                let b = this.a3.item(a);
                return b;
            }
            let c = new DescriptionRef(a);
            this.a3.addItem(a, c);
            return c;
        }
        ck(a, b) {
            return a.g == null ? null : this.e(a.g);
        }
        bp(a, b, c) {
            let d = a.d.specificType;
            if (d == null) {
                d = a.d.specificExternalType;
            }
            if (typeCast(DescriptionTreeNode.$, a.g) !== null) {
                let e = a.g;
                if (e.c("Type")) {
                    d = e.a("Type").b;
                }
            }
            let f = this.b0(d, a.g, b, c, false, a.c.g, a.d);
            return f;
        }
        cj(a, b) {
            return a.g == null ? null : this.e(a.g);
        }
        bm(a) {
            if (typeof a.g === 'string') {
                let v_ = a.g;
                a.g = new Date(v_);
            }
            return a.g;
        }
        ci(a, b) {
            return a.g == null ? null : this.e(a.g);
        }
        cl(a, b) {
            return a.g == null ? null : this.e(a.g);
        }
        cn(a) {
            return a;
        }
        bl(a) {
            let b = a.g;
            if (b == null) {
                return null;
            }
            let c = new Array(b.length);
            for (let d = 0; d < b.length; d++) {
                c[d] = this.cn(b[d]);
            }
            return c;
        }
        bk(a) {
            return this.cn(a.g);
        }
        bj(a) {
            let b = a.g;
            if (b == null) {
                return null;
            }
            let c = new Array(b.length);
            for (let d = 0; d < b.length; d++) {
                c[d] = this.cm(b[d]);
            }
            return c;
        }
        bn(a) {
            let b = a.g;
            if (b == null) {
                return null;
            }
            let c = new Array(b.length);
            for (let d = 0; d < b.length; d++) {
                c[d] = b[d];
            }
            return c;
        }
        cm(a) {
            return a;
        }
        bi(a) {
            return this.cm(a.g);
        }
        bh(a) {
            return a.g;
        }
        addTargetPropertyUpdatingListener(a) {
            this.bb.add(a);
        }
        removeTargetPropertyUpdatingListener(a) {
            this.bb.remove(a);
        }
        addPropertyUpdatingListener(a, b) {
            if (!this.a6.containsKey(a)) {
                this.a6.addItem(a, new List$1(Delegate_$type, 0));
            }
            this.a6.item(a).add(b);
        }
        addReferenceLookupListener(a) {
            this.a9.add(a);
        }
        removeReferenceLookupListener(a) {
            this.a9.remove(a);
        }
        removePropertyUpdatingListener(a, b) {
            if (this.a6.containsKey(a)) {
                this.a6.item(a).remove(b);
                if (this.a6.item(a).count == 0) {
                    this.a6.removeItem(a);
                }
            }
        }
        addNamespaceLookupListener(a) {
            this.ba.add(a);
        }
        removeNamespaceLookupListener(a) {
            this.ba.remove(a);
        }
        bg(a, b, c) {
            if (a.g == null) {
                return null;
            }
            let d = a.g;
            let e = new List$1(Base.$, 0);
            let f = a.d.specificType;
            if (f == null) {
                f = a.d.specificExternalType;
            }
            if (a.d.knownType == 9) {
                f = a.d.collectionElementType;
                if (f == null) {
                    f = a.d.specificExternalType;
                }
            }
            for (let g = 0; g < d.length; g++) {
                let h = f;
                if (typeCast(DescriptionTreeNode.$, d[g]) !== null) {
                    let i = d[g];
                    if (i.c("Type")) {
                        h = i.a("Type").b;
                    }
                }
                let j = this.b0(h, d[g], b, c, false, a.c.g, a.d);
                e.add1(j);
            }
            return e.toArray();
        }
        d8(a, b, c, d, e, f, g) {
            if (typeCast(DescriptionRef.$, e) !== null) {
                let h = e;
                let i = false;
                if (f != null && typeof f === 'string') {
                    if (this.hasRef(f)) {
                        let j = this.f(f);
                        if (Base.equalsStatic(j, e)) {
                            i = true;
                        }
                        else {
                            j.j(a, g, c);
                        }
                    }
                }
                if (this.t(e)) {
                    let k = e;
                    if (k.e != null && k.e.length > 0 && this.a5.containsKey(k.e)) {
                        k.a = true;
                    }
                    e = this.b5(e);
                    this.d9(g, c, d, e, f, k);
                }
                else {
                    this.adapter.onPendingRef(g, c, d, e);
                }
                let l = null;
                l = (m, n) => {
                    let o = m;
                    if (o.e != null && o.e.length > 0 && this.a5.containsKey(o.e)) {
                        o.a = true;
                    }
                    let p = this.b5(m);
                    this.d9(g, c, d, p, f, o);
                };
                if (!i) {
                    h.g(a, g, c, l);
                }
                return;
            }
            this.d9(g, c, d, e, f, null);
        }
        u(a) {
            return this.a7.containsKey(a);
        }
        get shouldNamespaceSystemRefValues() {
            return this._shouldNamespaceSystemRefValues;
        }
        set shouldNamespaceSystemRefValues(a) {
            this._shouldNamespaceSystemRefValues = a;
        }
        dl(a, b, c, d) {
            let e = null;
            if (d) {
                if (this.a7.containsKey(b)) {
                    e = this.a7.item(b);
                }
                this.a7.item(b, c);
                if (c != null) {
                    this.a2.item(c, b);
                }
            }
            else {
                if (this.shouldNamespaceSystemRefValues) {
                    let f = "";
                    if (this.ba != null && this.ba.count > 0) {
                        for (let g = 0; g < this.ba.count; g++) {
                            f = this.ba._inner[g](a);
                        }
                    }
                    if (!stringIsNullOrEmpty(f)) {
                        b = f + "/" + b;
                    }
                }
                if (this.a5.containsKey(b)) {
                    e = this.a5.item(b);
                }
                this.a5.item(b, c);
                if (c != null) {
                    this.a2.item(c, b);
                }
                if (this.a3.containsKey(b)) {
                    this.a3.item(b).a = true;
                }
            }
            if (this.a3.containsKey(b)) {
                this.a3.item(b).f(e, c);
            }
        }
        removeRefValueCore(a, b, c) {
            let d = null;
            if (c) {
                if (this.a7.containsKey(b)) {
                    d = this.a7.item(b);
                }
                this.a7.removeItem(b);
                if (d != null && this.a2.containsKey(d)) {
                    this.a2.removeItem(d);
                }
            }
            else {
                if (this.shouldNamespaceSystemRefValues) {
                    let e = "";
                    if (this.ba != null && this.ba.count > 0) {
                        for (let f = 0; f < this.ba.count; f++) {
                            e = this.ba._inner[f](a);
                        }
                    }
                    if (!stringIsNullOrEmpty(e)) {
                        b = e + "/" + b;
                    }
                }
                if (this.a5.containsKey(b)) {
                    d = this.a5.item(b);
                }
                this.a5.removeItem(b);
                if (d != null && this.a2.containsKey(d)) {
                    this.a2.removeItem(d);
                }
            }
            if (this.a3.containsKey(b)) {
                this.a3.item(b).f(d, this.b5(this.a3.item(b)));
                if (this.a3.item(b).c <= 0) {
                    this.a3.item(b).h();
                    this.a3.removeItem(b);
                }
            }
        }
        clearUserRefValues() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.a7.keys)) {
                a.add(b);
            }
            for (let c of fromEnum(a)) {
                this.removeRefValueCore(null, c, true);
            }
        }
        t(a) {
            return this.a7.containsKey(a.e) || this.a5.containsKey(a.e);
        }
        b5(a) {
            if (this.a7.containsKey(a.e)) {
                return this.a7.item(a.e);
            }
            if (this.a5.containsKey(a.e)) {
                return this.a5.item(a.e);
            }
            return null;
        }
        hasRef(a) {
            return this.a3.containsKey(a);
        }
        f(a) {
            return this.a3.item(a);
        }
        getMissingRefs() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.a3.keys)) {
                if (!this.t(this.a3.item(b))) {
                    a.add(b);
                }
            }
            return a.toArray();
        }
        getRefChangeInfos(a) {
            let b = new List$1(DescriptionRefTargetInfo.$, 0);
            if (this.a3.containsKey(a)) {
                for (let c of fromEnum(this.a3.item(a).b)) {
                    b.add(((() => {
                        let $ret = new DescriptionRefTargetInfo();
                        $ret.container = c.b;
                        $ret.propertyName = c.d;
                        $ret.target = c.c;
                        return $ret;
                    })()));
                }
            }
            return b.toArray();
        }
        b6(a, b, c) {
            return b.j(c.c.g);
        }
        ak(a, b, c) {
            let d = this.b6(a, b, c);
            this.ap(a, b, c, d);
            return true;
        }
        ap(a, b, c, d) {
            this.adapter.resetPropertyOnTarget(a, c.i(ComponentRenderer.platform), c.d, d);
            return true;
        }
        aj(a, b, c) {
            if (c.c == null) {
                return this.ao(a, b, c);
            }
            else {
                let d = this.b6(a, b, c);
                this.d1(a, b, c, d);
            }
            return true;
        }
        d1(a, b, c, d) {
            let e = c.i(ComponentRenderer.platform);
            let f = c.d.collectionElementType;
            if (f == null) {
                f = c.d.specificExternalType;
            }
            let g = this.b0(f, c.g, a, b, false, c.c.g, c.d);
            this.adapter.replaceItemInCollection(e, c.d, d, c.e, g);
            if (c.h != null && typeCast(DescriptionTreeNode.$, c.h) !== null) {
                let h = c.h.g;
                if (h >= 0) {
                    let i = b.j(h);
                    if (i != null) {
                        this.c6(a, i, b);
                    }
                }
            }
        }
        ao(a, b, c) {
            let d = this.adapter.getRootObject(a);
            if (d != null) {
                this.c6(a, d, b);
            }
            if (!(typeCast(DescriptionTreeNode.$, c.g) !== null)) {
                throw new NotImplementedException(0);
            }
            let e = c.g;
            let f = false;
            this.adapter.replaceRootItem(a, e.i, this.context, (g) => {
                let h = this.adapter.getRootObject(a);
                b.k(a, e.g, h, e, runOn(this, this.dl), -1);
                let i = this.bc(e);
                this.dj(a, b, i);
                f = true;
                if (g) {
                    this.d4(a, b);
                }
            });
            return f;
        }
        c6(a, b, c) {
            let d = this.bf(a, b, c);
            for (let e of fromEnum(this.a3.values)) {
                e.i(b);
            }
            if (d != -1) {
                c.l(this, a, d, runOn(this, this.removeRefValueCore));
            }
            this.k.b(ComponentRenderer.platform, b);
        }
        bf(a, b, c) {
            return c.h(b);
        }
        ai(a, b, c) {
            if (c.c == null) {
                return this.an(a, b, c);
            }
            else {
                let d = this.b6(a, b, c);
                this.dp(a, b, c, d);
            }
            return true;
        }
        dp(a, b, c, d) {
            let e = c.i(ComponentRenderer.platform);
            this.adapter.removeItemFromCollection(e, c.d, d, c.f);
            if (c.h != null && typeCast(DescriptionTreeNode.$, c.h) !== null) {
                let f = c.h.g;
                if (f >= 0) {
                    let g = b.j(f);
                    if (g != null) {
                        this.c6(a, g, b);
                    }
                }
            }
        }
        an(a, b, c) {
            let d = this.adapter.getRootObject(a);
            if (d != null) {
                this.c6(a, d, b);
            }
            let e = false;
            this.adapter.removeRootItem(a, this.context, (f) => {
                e = true;
                if (f) {
                    this.d4(a, b);
                }
            });
            return e;
        }
        ad(a, b, c) {
            if (c.c == null) {
                return this.n(a, b, c);
            }
            else {
                let d = this.b6(a, b, c);
                this.cx(a, b, c, d);
            }
            return true;
        }
        n(a, b, c) {
            if (!(typeCast(DescriptionTreeNode.$, c.g) !== null)) {
                throw new NotImplementedException(0);
            }
            let d = c.g;
            let e = false;
            this.adapter.replaceRootItem(a, d.i, this.context, (f) => {
                let g = this.adapter.getRootObject(a);
                b.k(a, d.g, g, d, runOn(this, this.dl), -1);
                let h = this.bc(d);
                this.dj(a, b, h);
                e = true;
                if (f) {
                    this.d4(a, b);
                }
            });
            return e;
        }
        cx(a, b, c, d) {
            let e = c.i(ComponentRenderer.platform);
            let f = c.d.collectionElementType;
            if (typeCast(DescriptionTreeNode.$, c.g) !== null) {
                let g = c.g;
                if (g.c("Type")) {
                    f = g.a("Type").b;
                }
            }
            if (f == null) {
                f = c.d.specificExternalType;
            }
            let h = this.b0(f, c.g, a, b, false, c.c.g, c.d);
            this.adapter.addItemToCollection(e, c.d, d, c.e, h);
        }
        b0(a, b, c, d, e, f, g) {
            if (this.x(a)) {
                return b;
            }
            let h = null;
            if (b != null && typeCast(DescriptionTreeNode.$, b) !== null) {
                let i = b;
                let j = null;
                if (i.c("Name")) {
                    j = i.a("Name").b;
                    if (!stringIsNullOrEmpty(j)) {
                        if (this.shouldNamespaceSystemRefValues) {
                            let k = "";
                            if (this.ba != null && this.ba.count > 0) {
                                for (let l = 0; l < this.ba.count; l++) {
                                    k = this.ba._inner[l](c);
                                }
                            }
                            if (!stringIsNullOrEmpty(k)) {
                                j = k + "/" + j;
                            }
                        }
                        if (this.a5.containsKey(j)) {
                            let m = this.a5.item(j);
                            h = m;
                        }
                    }
                }
                if (h == null) {
                    h = this.context.y(a, c, j);
                }
            }
            else if (b != null) {
                h = this.context.y(a, c, null);
            }
            if (b == null) {
                return h;
            }
            if (typeCast(DescriptionTreeNode.$, b) !== null) {
                let n = b;
                if (n.i == "EmbeddedRef") {
                    let o = "uuid";
                    let p = null;
                    for (let q = 0; q < n.f().count; q++) {
                        if (n.f()._inner[q].c == "RefType") {
                            o = n.f()._inner[q].b;
                        }
                        if (n.f()._inner[q].c == "Value") {
                            p = n.f()._inner[q].b;
                        }
                    }
                    if (p != null) {
                        for (let r = 0; r < this.a9.count; r++) {
                            let s = this.a9._inner[r](c, o, p);
                            if (s != null) {
                                return s;
                            }
                        }
                        if (o == "name") {
                            let t = p;
                            if (this.a5.containsKey(t)) {
                                return this.a5.item(t);
                            }
                        }
                        return null;
                    }
                }
                else {
                    if (!this.a4.containsKey(c)) {
                        this.a4.addItem(c, ((() => {
                            let $ret = new ContainerState();
                            $ret.i = c;
                            return $ret;
                        })()));
                        d = this.a4.item(c);
                    }
                    d.k(c, n.g, h, n, runOn(this, this.dl), f);
                    let u = this.bc(n);
                    this.dj(c, d, u);
                    if (e) {
                        d.l(this, c, n.g, runOn(this, this.removeRefValueCore));
                    }
                }
            }
            let v = (a == "object" || a == "Object");
            let w = v && typeof b === 'string' && stringStartsWith(b.toString(), "[") && stringEndsWith(b.toString(), "]");
            if (w) {
                let newVal_ = b;
                let x = JSON.parse(newVal_);
                return x;
            }
            if (!v && typeof b === 'string' && a.toLowerCase() != "string") {
                return this.bo(a, b, g);
            }
            if (v) {
                return b;
            }
            return h;
        }
        x(a) {
            return a == "int" || a == "Int32" || a == "short" || a == "Int16" || a == "double" || a == "Double" || a == "float" || a == "Float" || a == "Single" || a == "single" || a == "DateTime" || a == "decimal" || a == "Decimal" || a == "long" || a == "Int64" || a == "byte" || a == "bool" || a == "string" || a == "String";
        }
        bo(a, b, c) {
            return this.context.t(a, b, c, this.o());
        }
        o() {
            return true;
        }
        bc(a) {
            let b = a.f();
            let c = new List$1(DescriptionTreeAction.$, 0);
            for (let d = 0; d < b.count; d++) {
                let e = new DescriptionTreeAction();
                e.a = 0;
                e.j = b._inner[d].c;
                e.d = b._inner[d].a;
                e.c = a;
                e.b = a;
                e.g = b._inner[d].b;
                if (e.d != null && e.d.mustBeFirst) {
                    c.insert(0, e);
                }
                else {
                    c.add(e);
                }
            }
            return c;
        }
        ac(a, b, c) {
            if (c.c == null) {
                return this.r(a, b, c);
            }
            else {
                let d = this.b6(a, b, c);
                this.c3(a, b, c, d);
            }
            return true;
        }
        c3(a, b, c, d) {
            let e = c.i(ComponentRenderer.platform);
            this.adapter.clearCollection(d, e, c.d);
            if (c.h != null && typeCast(Array_$type, c.h) !== null) {
                let f = c.h;
                for (let g = 0; g < f.length; g++) {
                    let h = f[g];
                    if (h != null && typeCast(DescriptionTreeNode.$, h) !== null) {
                        let i = h.g;
                        if (i >= 0) {
                            let j = b.j(i);
                            if (j != null) {
                                this.c6(a, j, b);
                            }
                        }
                    }
                }
            }
        }
        d9(a, b, c, d, e, f) {
            if (this.a6.containsKey(b)) {
                for (let g of fromEnum(this.a6.item(b))) {
                    g(b, a, d);
                }
            }
            this.adapter.setPropertyValue(a, b, c, d, e, f);
        }
        b4(a, b) {
            return this.adapter.getPropertyValue(a, b);
        }
        r(a, b, c) {
            return this.q(a, b);
        }
        q(a, b) {
            let c = this.adapter.getRootObject(a);
            if (c != null) {
                this.c6(a, c, b);
            }
            let d = false;
            this.adapter.clearContainer(a, this.context, (e) => {
                d = true;
                if (e) {
                    this.d4(a, b);
                }
            });
            return d;
        }
    }
    ComponentRenderer.$t = /*@__PURE__*/ markType(ComponentRenderer, 'ComponentRenderer');
    ComponentRenderer._defaultInstance = null;
    ComponentRenderer.platform = 3;
    return ComponentRenderer;
})();
/**
 * @hidden
 */
let ContainerState = /*@__PURE__*/ (() => {
    class ContainerState extends Base {
        constructor() {
            super(...arguments);
            this.i = null;
            this.e = new Dictionary$2(Number_$type, Base.$, 0);
            this.f = new Dictionary$2(Base.$, Number_$type, 0);
            this.d = new Dictionary$2(Number_$type, String_$type, 0);
            this.g = new Dictionary$2(Number_$type, HashSet$1.$.specialize(Number_$type), 0);
            this.c = new Dictionary$2(Number_$type, List$1.$.specialize(Number_$type), 0);
        }
        k(a, b, c, d, e, f) {
            if (d.c("Name")) {
                this.d.item(b, d.a("Name").b);
                e(a, this.d.item(b), c, false);
            }
            this.e.item(b, c);
            this.f.item(c, b);
            if (!this.g.containsKey(b)) {
                this.g.item(b, new HashSet$1(Number_$type, 0));
            }
            this.g.item(b).add_1(f);
            if (f >= 0) {
                if (!this.c.containsKey(f)) {
                    this.c.item(f, new List$1(Number_$type, 0));
                }
                this.c.item(f).add(b);
            }
        }
        a(a) {
            return this.e.containsKey(a);
        }
        b(a) {
            return this.f.containsKey(a);
        }
        j(a) {
            return this.e.item(a);
        }
        l(a, b, c, d) {
            if (this.c.containsKey(c)) {
                let e = this.c.item(c);
                for (let f = 0; f < e.count; f++) {
                    if (!this.g.containsKey(e._inner[f]) || this.g.item(e._inner[f]).count < 1 || (this.g.item(e._inner[f]).count == 1 && this.g.item(e._inner[f]).contains(c))) {
                        if (this.e.containsKey(e._inner[f])) {
                            a.c6(b, this.e.item(e._inner[f]), this);
                        }
                    }
                }
                this.c.removeItem(c);
            }
            let g = this.e.item(c);
            this.f.removeItem(g);
            this.e.removeItem(c);
            if (this.g.containsKey(c)) {
                this.g.removeItem(c);
            }
            if (this.d.containsKey(c)) {
                let h = this.d.item(c);
                this.d.removeItem(c);
                d(b, h, false);
            }
        }
        h(a) {
            if (this.f.containsKey(a)) {
                return this.f.item(a);
            }
            return -1;
        }
    }
    ContainerState.$t = /*@__PURE__*/ markType(ContainerState, 'ContainerState');
    return ContainerState;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DotNetCodeGeneratingComponentRendererHandlerEmitter = /*@__PURE__*/ (() => {
    class DotNetCodeGeneratingComponentRendererHandlerEmitter extends CodeGeneratingComponentRendererHandlerEmitter {
        constructor(a, b) {
            super(a, b);
        }
        v(a, b) {
            super.v(a, b);
            a.addUsing(b);
        }
        t(a, b) {
            super.t(a, b);
            if (b) {
                this.g.l("await JS.InvokeVoidAsync(\"" + a + "\");");
            }
            else {
                this.g.l("this." + a + "();");
            }
        }
        u(a, b) {
            super.u(a, b);
            if (b) {
                this.h.l("await JS.InvokeVoidAsync(\"" + a + "\");");
            }
            else {
                this.h.l("this." + a + "();");
            }
        }
        q(a, b) {
            return a;
        }
    }
    DotNetCodeGeneratingComponentRendererHandlerEmitter.$t = /*@__PURE__*/ markType(DotNetCodeGeneratingComponentRendererHandlerEmitter, 'DotNetCodeGeneratingComponentRendererHandlerEmitter', CodeGeneratingComponentRendererHandlerEmitter.$);
    return DotNetCodeGeneratingComponentRendererHandlerEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingComponentRendererTemplateEmitter = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRendererTemplateEmitter extends Base {
        get n() {
            return this.m;
        }
        constructor(a, b) {
            super();
            this.o = null;
            this.m = null;
            this.e = null;
            this.b = null;
            this.c = null;
            this.d = null;
            this.a = null;
            this.k = new CodeGeneratingImportManager();
            this.p = new HashSet$1(String_$type, 0);
            this.o = a;
            this.m = b;
            this.e = new CodeGeneratingCodeWriter(this.o);
            this.a = new CodeGeneratingCodeWriter(this.o);
            this.b = new CodeGeneratingCodeWriter(this.o);
            this.c = new CodeGeneratingCodeWriter(this.o);
            this.d = new CodeGeneratingCodeWriter(this.o);
        }
        get j() {
            return this.e;
        }
        get g() {
            return this.b;
        }
        get h() {
            return this.c;
        }
        get i() {
            return this.d;
        }
        get f() {
            return this.a;
        }
        get l() {
            return this.k;
        }
        r() {
            let a = new HashSet$1(String_$type, 0);
            for (let b = 0; b < this.m.t.count; b++) {
                let c = this.m.t._inner[b];
                if (c.a != null && c.c == null) {
                    if (this.o.library != null && this.o.library.hasItem(c.a.e)) {
                        if (a.contains(c.a.e)) {
                            continue;
                        }
                        a.add_1(c.a.e);
                        let d = this.o.library.getItem(c.a.e);
                        if (d.type == 2) {
                            let e = d.getContentForPlatform(this.m.platform);
                            if (e != null) {
                                if (e.isJSContent) {
                                    let f = e.content;
                                    this.f.l(f);
                                }
                                else if (e.isJson) {
                                    let g = new JsonDictionaryParser();
                                    let h = g.parse(e.content);
                                    if (h.g("imports")) {
                                        let i = h.item("imports").value;
                                        let j = stringReplace(i, "\r\n", "\n").split('\n');
                                        for (let l = 0; l < j.length; l++) {
                                            let k = j[l];
                                            if (k.trim().length == 0) {
                                                continue;
                                            }
                                            if (!this.p.contains(k)) {
                                                this.p.add_1(k);
                                                this.s(this.l, k);
                                            }
                                        }
                                    }
                                    if (h.g("styles")) {
                                        let m = h.item("styles").value;
                                        let n = stringReplace(m, "\r\n", "\n").split('\n');
                                        for (let p = 0; p < n.length; p++) {
                                            let o = n[p];
                                            if (o.trim().length == 0) {
                                                continue;
                                            }
                                            this.g.l(o);
                                        }
                                    }
                                    if (h.g("supportingMethods")) {
                                        let q = h.item("supportingMethods").value;
                                        q = this.q(c.a.e, q);
                                        let r = stringReplace(q, "\r\n", "\n").split('\n');
                                        for (let t = 0; t < r.length; t++) {
                                            let s = r[t];
                                            if (s.trim().length == 0) {
                                                continue;
                                            }
                                            this.h.l(s);
                                        }
                                    }
                                    if (h.g("content")) {
                                        let u = h.item("content").value;
                                        u = this.q(c.a.e, u);
                                        let v = stringReplace(u, "\r\n", "\n").split('\n');
                                        let w = 0x7FFFFFFF;
                                        let x = "";
                                        for (let y = 0; y < this.o.indentSpaces; y++) {
                                            x += " ";
                                        }
                                        for (let aa = 0; aa < v.length; aa++) {
                                            let z = v[aa];
                                            let ab = z;
                                            if (ab.trim().length == 0) {
                                                continue;
                                            }
                                            ab = stringReplace(z, "\t", x);
                                            let ac = 0;
                                            for (let ad = 0; ad < ab.length; ad++) {
                                                if (ab.charAt(ad) != ' ' && ab.charAt(ad) != '\t') {
                                                    break;
                                                }
                                                ac++;
                                            }
                                            if (ac < w) {
                                                w = ac;
                                            }
                                        }
                                        for (let af = 0; af < v.length; af++) {
                                            let ae = v[af];
                                            let ag = ae;
                                            let ah = 0;
                                            if (ag.trim().length > 0) {
                                                while (ag.length > 0 && (ag.charAt(0) == ' ' || ag.charAt(0) == '\t') && ah < w) {
                                                    if (ag.charAt(0) == ' ') {
                                                        ag = ag.substr(1);
                                                        ah++;
                                                    }
                                                    if (ag.charAt(0) == '\t') {
                                                        ag = ag.substr(1);
                                                        ah += this.o.indentSpaces;
                                                    }
                                                }
                                            }
                                            this.j.l(ag);
                                        }
                                    }
                                    if (h.g("supportingTypes")) {
                                        let ai = h.item("supportingTypes").value;
                                        let aj = stringReplace(ai, "\r\n", "\n").split('\n');
                                        for (let al = 0; al < aj.length; al++) {
                                            let ak = aj[al];
                                            if (ak.trim().length == 0) {
                                                continue;
                                            }
                                            this.i.l(ak);
                                        }
                                    }
                                }
                                else {
                                    let am = e.content;
                                    this.j.l(am);
                                }
                            }
                        }
                    }
                }
            }
            this.m.addContainerResult("templateContents", this.j.toString());
            this.m.addImportResult("templateImports", this.l);
            this.m.addContainerResult("templateSupportingMethods", this.h.toString());
            this.m.addContainerResult("templateSupportingTypes", this.i.toString());
            this.m.addContainerResult("templateStyles", this.g.toString());
            this.m.addContainerResult("templateScripts", this.f.toString());
        }
        s(a, b) {
        }
        q(a, b) {
            return b;
        }
    }
    CodeGeneratingComponentRendererTemplateEmitter.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRendererTemplateEmitter, 'CodeGeneratingComponentRendererTemplateEmitter');
    return CodeGeneratingComponentRendererTemplateEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TSCodeGeneratingComponentRendererTemplateEmitter = /*@__PURE__*/ (() => {
    class TSCodeGeneratingComponentRendererTemplateEmitter extends CodeGeneratingComponentRendererTemplateEmitter {
        constructor(a, b, c) {
            super(a, b);
            this.t = 0;
            this.u = new Dictionary$2(String_$type, String_$type, 0);
            this.t = c;
            this.u.item("IgxRowType", "RowType");
            this.u.item("IgxCellType", "CellType");
        }
        get v() {
            switch (this.t) {
                case 1: return "angular";
                case 2: return "react";
                case 3: return "webcomponents";
            }
            return "";
        }
        get w() {
            switch (this.t) {
                case 1: return "Igx";
                case 2: return "Igr";
                case 3: return "Igc";
            }
            return "";
        }
        s(a, b) {
            super.s(a, b);
            let c = new CodeGeneratingRegexHelper("import {([^}]+)}\\s+from\\s+['\"]([^'\"]+)['\"]");
            c.execute(b, (d, e, f) => {
                let g = d(1);
                let h = d(2);
                h = stringReplace(h, "webcomponents", this.v);
                h = stringReplace(h, "react", this.v);
                h = stringReplace(h, "angular", this.v);
                if (this.v == "angular" || this.v == "react") {
                    if (stringContains(h, "/grids")) {
                        h = stringReplace(h, "/grids", "");
                    }
                }
                if (this.v == "angular") {
                    if (stringContains(h, "igniteui-angular-grids")) {
                        h = stringReplace(h, "igniteui-angular-grids", "igniteui-angular");
                    }
                }
                let i = g.split(',');
                for (let k = 0; k < i.length; k++) {
                    let j = i[k];
                    let l = j.trim();
                    if (stringStartsWith(l, "Igc")) {
                        l = this.w + l.substr(3);
                    }
                    if (stringStartsWith(l, "Igr")) {
                        l = this.w + l.substr(3);
                    }
                    if (stringStartsWith(l, "Igx")) {
                        l = this.w + l.substr(3);
                    }
                    if (stringStartsWith(l, "Igr") && stringEndsWith(l, "Component")) {
                        l = l.substr(0, l.length - ("Component").length);
                    }
                    if (h.trim() == "igniteui-angular") {
                        if (this.u.containsKey(l.trim())) {
                            l = this.u.item(l.trim());
                        }
                        if (stringStartsWith(l.trim(), "Igx") && stringEndsWith(l.trim(), "EventArgs")) {
                            this.u.item(l.trim(), stringReplace(l, "Igx", "I"));
                            l = stringReplace(l, "Igx", "I");
                        }
                    }
                    a.addPackageImport(h.trim(), l.trim());
                }
                return null;
            });
        }
        q(a, b) {
            return b;
        }
    }
    TSCodeGeneratingComponentRendererTemplateEmitter.$t = /*@__PURE__*/ markType(TSCodeGeneratingComponentRendererTemplateEmitter, 'TSCodeGeneratingComponentRendererTemplateEmitter', CodeGeneratingComponentRendererTemplateEmitter.$);
    return TSCodeGeneratingComponentRendererTemplateEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DotNetCodeGeneratingComponentRendererTemplateEmitter = /*@__PURE__*/ (() => {
    class DotNetCodeGeneratingComponentRendererTemplateEmitter extends CodeGeneratingComponentRendererTemplateEmitter {
        constructor(a, b) {
            super(a, b);
        }
        s(a, b) {
            super.s(a, b);
            a.addUsing(b);
        }
        q(a, b) {
            return b;
        }
    }
    DotNetCodeGeneratingComponentRendererTemplateEmitter.$t = /*@__PURE__*/ markType(DotNetCodeGeneratingComponentRendererTemplateEmitter, 'DotNetCodeGeneratingComponentRendererTemplateEmitter', CodeGeneratingComponentRendererTemplateEmitter.$);
    return DotNetCodeGeneratingComponentRendererTemplateEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingComponentRendererModuleEmitter = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRendererModuleEmitter extends Base {
        get j() {
            return this.i;
        }
        constructor(a, b) {
            super();
            this.k = null;
            this.i = null;
            this.b = null;
            this.f = new CodeGeneratingImportManager();
            this.e = new CodeGeneratingImportManager();
            this.a = null;
            this.k = a;
            this.i = b;
            this.b = new CodeGeneratingCodeWriter(this.k);
            this.a = new CodeGeneratingCodeWriter(this.k);
        }
        get d() {
            return this.b;
        }
        get h() {
            return this.f;
        }
        get g() {
            return this.e;
        }
        get c() {
            return this.a;
        }
        n(a, b) {
            this.p();
            if (typeCast(JsonDictionaryArray.$, a) !== null) {
                let c = a;
                for (let d = 0; d < c.items.length; d++) {
                    let e = c.items[d];
                    if (typeCast(JsonDictionaryValue.$, e) !== null) {
                        let f = e;
                        if (f != null) {
                            let g = f.value.toString();
                            let h;
                            g = ((() => { let i = this.l(g, b, h); h = i.p2; return i.ret; })());
                            this.m(b, g, h);
                        }
                    }
                }
            }
            this.o();
            this.i.addImportResult("modulesImports", this.h);
            this.i.addContainerResult("modulesRegister", this.d.toString());
            this.i.addImportResult("descriptionImports", this.g);
            this.i.addContainerResult("descriptionRegister", this.c.toString());
        }
        l(a, b, c) {
            c = false;
            if (a == "withDescriptions") {
                return {
                    ret: a,
                    p2: c
                };
            }
            let d = "";
            let e = a.split('/');
            if (e.length == 1) {
                d = e[0];
                return {
                    ret: d,
                    p2: c
                };
            }
            else {
                let f = e[0];
                d = e[1];
                if (stringStartsWith(d, "Web") && b.getMetadata(stringReplace(d, "Module", ""), "__qualifiedNameTS") != null) {
                    c = true;
                    d = d.substr(3);
                    if (stringStartsWith(f, "web")) {
                        this.j.addPackageRef(f);
                    }
                    else {
                        this.j.addPackageRef("web" + f);
                    }
                }
                return {
                    ret: f + "/" + d,
                    p2: c
                };
            }
        }
        o() {
        }
        m(a, b, c) {
        }
        p() {
        }
    }
    CodeGeneratingComponentRendererModuleEmitter.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRendererModuleEmitter, 'CodeGeneratingComponentRendererModuleEmitter');
    return CodeGeneratingComponentRendererModuleEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TSCodeGeneratingComponentRendererModuleEmitter = /*@__PURE__*/ (() => {
    class TSCodeGeneratingComponentRendererModuleEmitter extends CodeGeneratingComponentRendererModuleEmitter {
        constructor(a, b, c) {
            super(b, c);
            this.q = 0;
            this.v = 0;
            this.r = false;
            this.t = new Dictionary$2(String_$type, List$1.$.specialize(String_$type), 0);
            this.u = new HashSet$1(String_$type, 0);
            this.s = false;
            this.q = a;
        }
        p() {
            super.p();
            this.v = 0;
        }
        get x() {
            switch (this.q) {
                case 1: return "Igx";
                case 2: return "Igr";
                case 3: return "Igc";
            }
            return "";
        }
        get w() {
            switch (this.q) {
                case 1: return "angular";
                case 2: return "react";
                case 3: return "webcomponents";
            }
            return "";
        }
        m(a, b, c) {
            super.m(a, b, c);
            if (b == "withDescriptions") {
                this.r = true;
                return;
            }
            let d = "igniteui-" + this.w + "-core";
            let e = "";
            let f = b.split('/');
            if (f.length == 1) {
                e = f[0];
                this.j.addPackageRef(e);
            }
            else {
                d = f[0];
                this.j.addPackageRef(d);
                if (d == "webinputs") {
                    d = "igniteui-" + this.w;
                }
                else {
                    if (d == "webgrids") {
                        d = "grids";
                    }
                    d = "igniteui-" + this.w + "-" + d;
                }
                e = f[1];
            }
            let g = false;
            let h = null;
            let i = stringReplace(e, "Module", "");
            if (c) {
                i = "Web" + i;
            }
            if (a.getMetadata(i, "__skipModuleRegister" + EnumUtil.getName(CodeGenerationTargetPlatforms_$type, this.q)) != null) {
                g = true;
            }
            if (a.getMetadata(i, "__importOverride" + EnumUtil.getName(CodeGenerationTargetPlatforms_$type, this.q)) != null) {
                h = a.getMetadata(i, "__importOverride" + EnumUtil.getName(CodeGenerationTargetPlatforms_$type, this.q)).specificExternalType;
            }
            if (h != null) {
                if (!this.u.contains(h)) {
                    this.u.add_1(h);
                }
            }
            else {
                if (!this.t.containsKey(d)) {
                    this.t.addItem(d, new List$1(String_$type, 0));
                }
            }
            if (this.v > 0 && !g) {
                this.d.l(",");
            }
            if (!g) {
                this.d.j(this.x + e);
                this.v++;
            }
            if (h == null && !g) {
                let j = this.t.item(d);
                j.add(this.x + e);
            }
            if (this.r) {
                if (!this.s) {
                    this.s = true;
                    this.c.l("private _componentRenderer: ComponentRenderer = null;");
                    this.c.l("public get renderer(): ComponentRenderer {");
                    this.c.h();
                    this.c.l("if (this._componentRenderer == null) {");
                    this.c.h();
                    this.c.l("this._componentRenderer = new ComponentRenderer();");
                    this.c.l("var context = this._componentRenderer.context;");
                    this.g.addPackageImport("igniteui-" + this.w + "-core", "ComponentRenderer");
                }
                let k = e;
                if (stringEndsWith(k, "Module")) {
                    k = k.substr(0, k.length - ("Module").length);
                    k += "DescriptionModule";
                }
                if (c) {
                    k = "Web" + k;
                }
                this.g.addPackageImport("igniteui-" + this.w + "-core", k);
                this.c.l(k + ".register(context);");
            }
        }
        o() {
            super.o();
            for (let a of fromEnum(this.t.keys)) {
                let b = a;
                let c = this.t.item(a);
                for (let d of fromEnum(c)) {
                    this.h.addPackageImport(b, d);
                }
            }
            for (let e of fromEnum(this.u)) {
                this.h.addDefaultImport(e, "@SELF@");
            }
            if (this.r) {
                this.c.f();
                this.c.l("}");
                this.c.l("return this._componentRenderer;");
                this.c.f();
                this.c.l("}");
            }
        }
    }
    TSCodeGeneratingComponentRendererModuleEmitter.$t = /*@__PURE__*/ markType(TSCodeGeneratingComponentRendererModuleEmitter, 'TSCodeGeneratingComponentRendererModuleEmitter', CodeGeneratingComponentRendererModuleEmitter.$);
    return TSCodeGeneratingComponentRendererModuleEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DotNetCodeGeneratingComponentRendererModuleEmitter = /*@__PURE__*/ (() => {
    class DotNetCodeGeneratingComponentRendererModuleEmitter extends CodeGeneratingComponentRendererModuleEmitter {
        constructor(a, b, c) {
            super(b, c);
            this.q = 0;
            this.t = 0;
            this.r = false;
            this.s = new Dictionary$2(String_$type, List$1.$.specialize(String_$type), 0);
            this.q = a;
        }
        get u() {
            return this.t;
        }
        p() {
            super.p();
            this.t = 0;
        }
        get v() {
            switch (this.q) {
                case 0: return "Xam";
                case 4: return "Ultra";
                case 5: return "Igb";
            }
            return "";
        }
        m(a, b, c) {
            super.m(a, b, c);
            if (b == "withDescriptions" && this.q != 5) {
                this.r = true;
                return;
            }
            let d = "";
            let e = b.split('/');
            if (e.length == 1) {
                d = e[0];
                this.j.addPackageRef(d);
            }
            else {
                this.j.addPackageRef(e[0]);
                d = e[1];
            }
            if (this.r) {
                if (this.t == 0) {
                    this.c.l("private ComponentRenderer _componentRenderer = null;");
                    this.c.l("public ComponentRenderer Renderer");
                    this.c.l("{");
                    this.c.h();
                    this.c.l("get");
                    this.c.l("{");
                    this.c.h();
                    this.c.l("if (this._componentRenderer == null)");
                    this.c.l("{");
                    this.c.h();
                    this.c.l("this._componentRenderer = new ComponentRenderer();");
                    this.c.l("var context = this._componentRenderer.Context;");
                }
                let f = d;
                if (stringEndsWith(f, "Module")) {
                    f = f.substr(0, f.length - ("Module").length);
                    f += "DescriptionModule";
                }
                this.c.l(f + ".Register(context);");
            }
            this.t++;
        }
        o() {
            super.o();
            if (this.r) {
                this.g.addUsing("using Infragistics.Controls.Description;");
                this.c.f();
                this.c.l("}");
                this.c.f();
                this.c.l("return this._componentRenderer;");
                this.c.l("}");
                this.c.f();
                this.c.l("}");
            }
        }
    }
    DotNetCodeGeneratingComponentRendererModuleEmitter.$t = /*@__PURE__*/ markType(DotNetCodeGeneratingComponentRendererModuleEmitter, 'DotNetCodeGeneratingComponentRendererModuleEmitter', CodeGeneratingComponentRendererModuleEmitter.$);
    return DotNetCodeGeneratingComponentRendererModuleEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BlazorCodeGeneratingComponentRendererModuleEmitter = /*@__PURE__*/ (() => {
    class BlazorCodeGeneratingComponentRendererModuleEmitter extends DotNetCodeGeneratingComponentRendererModuleEmitter {
        constructor(a, b, c) {
            super(a, b, c);
            this.w = null;
            this.x = 0;
        }
        p() {
            super.p();
        }
        m(a, b, c) {
            super.m(a, b, c);
            if (this.x > 0) {
                this.d.l(", ");
            }
            let d = "";
            let e = b.split('/');
            if (e.length == 1) {
                d = e[0];
            }
            else {
                d = e[1];
            }
            if (d == "withDescriptions") {
                this.d.j("typeof(IgbInputModule)");
            }
            else {
                this.d.j("typeof(");
                this.d.j("Igb" + d);
                this.d.j(")");
            }
            this.x++;
        }
        o() {
            super.o();
        }
    }
    BlazorCodeGeneratingComponentRendererModuleEmitter.$t = /*@__PURE__*/ markType(BlazorCodeGeneratingComponentRendererModuleEmitter, 'BlazorCodeGeneratingComponentRendererModuleEmitter', DotNetCodeGeneratingComponentRendererModuleEmitter.$);
    return BlazorCodeGeneratingComponentRendererModuleEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationTransformer = /*@__PURE__*/ (() => {
    class CodeGenerationTransformer extends Base {
        constructor(a) {
            super();
            this.a = 0;
            this.b = new Dictionary$2(String_$type, Delegate_$type, 0);
            this.a = a;
            this.b.item("VisibilityToBooleanTransform", (b, c) => {
                if (b.toString().toLowerCase() == "visible") {
                    return true;
                }
                return false;
            });
            if (a == 0) {
                this.b.item("AxisLabelTransform", (b, c) => {
                    let d = b;
                    if (d == null) {
                        return null;
                    }
                    if (!stringContains(d, "{")) {
                        return "{" + d + "}";
                    }
                    return d;
                });
                this.b.item("FontFamilyTransform", (b, c) => {
                    let d = b;
                    if (d == null) {
                        return null;
                    }
                    return ((() => {
                        let $ret = new CodeGenerationSpecialValue();
                        $ret.a = 0;
                        $ret.b = d;
                        return $ret;
                    })());
                });
                this.b.item("FontStyleTransform", (b, c) => {
                    let d = b;
                    if (d == null) {
                        return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Normal";
                            return $ret;
                        })());
                    }
                    d = d.toLowerCase();
                    switch (d) {
                        case "normal": return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Normal";
                            return $ret;
                        })());
                        case "italic": return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Italic";
                            return $ret;
                        })());
                    }
                    return ((() => {
                        let $ret = new CodeGenerationSpecialValue();
                        $ret.a = 1;
                        $ret.b = "Normal";
                        return $ret;
                    })());
                });
                this.b.item("FontWeightTransform", (b, c) => {
                    let d = b;
                    if (d == null) {
                        return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Normal";
                            return $ret;
                        })());
                    }
                    d = d.toLowerCase();
                    switch (d) {
                        case "normal": return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 2;
                            $ret.b = "Normal";
                            return $ret;
                        })());
                        case "bold": return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 2;
                            $ret.b = "Bold";
                            return $ret;
                        })());
                    }
                    return ((() => {
                        let $ret = new CodeGenerationSpecialValue();
                        $ret.a = 1;
                        $ret.b = "Normal";
                        return $ret;
                    })());
                });
            }
            if (a == 4) {
                this.b.item("ColorTransform", (b, c) => ((() => {
                    let $ret = new CodeGenerationSpecialValue();
                    $ret.a = 3;
                    $ret.b = b;
                    return $ret;
                })()));
                this.b.item("FontFamilyTransform", (b, c) => {
                    let d = b;
                    if (d == null) {
                        return null;
                    }
                    return ((() => {
                        let $ret = new CodeGenerationSpecialValue();
                        $ret.a = 0;
                        $ret.b = d;
                        return $ret;
                    })());
                });
                this.b.item("FontStyleTransform", (b, c) => {
                    let d = b;
                    let e = c.j;
                    let f = stringReplace(e, "Style", "Weight");
                    let g = false;
                    if (c.c.c(f)) {
                        let h = c.c.a(f);
                        let i = h.b;
                        if (i != null && i.toLowerCase() == "bold") {
                            g = true;
                        }
                    }
                    if (d == null) {
                        if (g) {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Bold";
                                return $ret;
                            })());
                        }
                        else {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Regular";
                                return $ret;
                            })());
                        }
                    }
                    d = d.toLowerCase();
                    switch (d) {
                        case "normal": if (g) {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Bold";
                                return $ret;
                            })());
                        }
                        else {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Regular";
                                return $ret;
                            })());
                        }
                        case "italic": if (g) {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "BoldItalic";
                                return $ret;
                            })());
                        }
                        else {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Italic";
                                return $ret;
                            })());
                        }
                    }
                    if (g) {
                        return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Bold";
                            return $ret;
                        })());
                    }
                    else {
                        return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Regular";
                            return $ret;
                        })());
                    }
                });
                this.b.item("FontWeightTransform", (b, c) => {
                    let d = b;
                    let e = c.j;
                    let f = stringReplace(e, "Weight", "Style");
                    let g = false;
                    if (c.c.c(f)) {
                        let h = c.c.a(f);
                        let i = h.b;
                        if (i != null && i.toLowerCase() == "italic") {
                            g = true;
                        }
                    }
                    if (d == null) {
                        if (g) {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Italic";
                                return $ret;
                            })());
                        }
                        else {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Regular";
                                return $ret;
                            })());
                        }
                    }
                    d = d.toLowerCase();
                    switch (d) {
                        case "normal": if (g) {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Italic";
                                return $ret;
                            })());
                        }
                        else {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Regular";
                                return $ret;
                            })());
                        }
                        case "bold": if (g) {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "BoldItalic";
                                return $ret;
                            })());
                        }
                        else {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Bold";
                                return $ret;
                            })());
                        }
                    }
                    if (g) {
                        return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Italic";
                            return $ret;
                        })());
                    }
                    else {
                        return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Regular";
                            return $ret;
                        })());
                    }
                });
            }
            if (a == 1 || a == 2 || a == 3) {
                this.b.item("FontFamilyTransform", (b, c) => {
                    let d = this.e(c);
                    let e = this.d(c);
                    let f = this.f(c);
                    let g = b;
                    if (g == null) {
                        g = "Verdana";
                    }
                    return d + " " + f + " " + e + " " + g;
                });
                this.b.item("FontStyleTransform", (b, c) => {
                    let d = this.c(c);
                    let e = this.d(c);
                    let f = this.f(c);
                    let g = b;
                    if (g == null) {
                        g = "normal";
                    }
                    return g + " " + f + " " + e + " " + d;
                });
                this.b.item("FontSizeTransform", (b, c) => {
                    let d = this.c(c);
                    let e = this.e(c);
                    let f = this.f(c);
                    let g = b != null ? b.toString() + "px" : null;
                    if (g == null) {
                        g = "14px";
                    }
                    return e + " " + f + " " + g + " " + d;
                });
                this.b.item("FontWeightTransform", (b, c) => {
                    let d = this.c(c);
                    let e = this.d(c);
                    let f = this.e(c);
                    let g = b != null ? b.toString() : null;
                    if (g == null) {
                        g = "normal";
                    }
                    g = g.toLowerCase();
                    return f + " " + g + " " + e + " " + d;
                });
            }
        }
        c(a) {
            let b = stringReplace(stringReplace(stringReplace(a.j, "Style", "Family"), "Weight", "Family"), "Size", "Family");
            let c = "Verdana";
            if (a.c.c(b)) {
                c = a.c.a(b).b;
                if (c == null) {
                    c = "Verdana";
                }
            }
            return c;
        }
        e(a) {
            let b = stringReplace(stringReplace(stringReplace(a.j, "Family", "Style"), "Weight", "Style"), "Size", "Style");
            let c = "normal";
            if (a.c.c(b)) {
                c = a.c.a(b).b;
                if (c == null) {
                    c = "normal";
                }
            }
            return c;
        }
        d(a) {
            let b = stringReplace(stringReplace(stringReplace(a.j, "Family", "Size"), "Weight", "Size"), "Style", "Size");
            let c = "14px";
            if (a.c.c(b)) {
                c = a.c.a(b).b.toString();
                if (c == null) {
                    c = "14px";
                }
                else {
                    c = c.toString() + "px";
                }
            }
            return c;
        }
        f(a) {
            let b = stringReplace(stringReplace(stringReplace(a.j, "Family", "Weight"), "Size", "Weight"), "Style", "Weight");
            let c = "normal";
            if (a.c.c(b)) {
                c = a.c.a(b).b;
                if (c == null) {
                    c = "normal";
                }
                c = c.toLowerCase();
            }
            return c;
        }
        transform(a, b, c) {
            let d = c.d;
            if (d == null) {
                return b;
            }
            let e = d.k(a);
            if (e != null && this.b.containsKey(e)) {
                let f = this.b.item(e);
                return f(b, c);
            }
            return b;
        }
    }
    CodeGenerationTransformer.$t = /*@__PURE__*/ markType(CodeGenerationTransformer, 'CodeGenerationTransformer', Base.$, [ITypeDescriptionPropertyTransforms_$type]);
    return CodeGenerationTransformer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRendererCodeEmitter extends Base {
        get_al() {
            switch (this.j.platform) {
                case 1: return "Igx";
                case 2: return "Igr";
                case 3: return "Igc";
                case 4: return "Ultra";
                case 0: return "Xam";
                case 5: return "Igb";
            }
            return "";
        }
        get al() {
            return this.get_al();
        }
        get_am() {
            switch (this.j.platform) {
                case 1: return "Component";
                case 2: return "";
                case 3: return "Component";
                case 4: return "";
                case 0: return "";
            }
            return "";
        }
        get am() {
            return this.get_am();
        }
        get a6() {
            switch (this.j.platform) {
                case 1: return "angular";
                case 2: return "react";
                case 3: return "webcomponents";
            }
            return "";
        }
        get m() {
            return this.l;
        }
        br(a) {
            this.j.af(a);
        }
        get k() {
            return this.j;
        }
        constructor(a, b) {
            super();
            this.l = null;
            this.j = null;
            this.z = new List$1(CodeGenerationItemBuilderPropertyInfo.$, 0);
            this.d = null;
            this.a = null;
            this.c = null;
            this.b = null;
            this.aa = new List$1(String_$type, 0);
            this.af = new Stack$1(String_$type);
            this.ad = new Stack$1(String_$type);
            this.ae = new Stack$1(Boolean_$type);
            this.a5 = null;
            this.a4 = null;
            this.l = a;
            this.j = b;
            this.d = new CodeGeneratingCodeWriter(this.l);
            this.a = new CodeGeneratingCodeWriter(this.l);
            this.c = new CodeGeneratingCodeWriter(this.l);
            this.b = new CodeGeneratingCodeWriter(this.l);
        }
        get h() {
            return this.d;
        }
        get e() {
            return this.a;
        }
        get g() {
            return this.c;
        }
        get f() {
            return this.b;
        }
        bb(a) {
            if (a == null || a == "any") {
                return;
            }
            this.aa.add(a);
        }
        w(a, b) {
            if (this.r) {
                return false;
            }
            if (a.hasMustSetInCodePlatforms(b.b.owningType, b.b.propertyName)) {
                let c = a.getMustSetInCodePlatforms(b.b.owningType, b.b.propertyName);
                for (let e = 0; e < c.length; e++) {
                    let d = c[e];
                    let f;
                    if (((() => { let g = EnumUtil.tryParse$1(CodeGenerationTargetPlatforms_$type, d, true, f); f = g.p2; return g.ret; })())) {
                        if (f == this.j.platform) {
                            return true;
                        }
                    }
                }
            }
            return false;
        }
        q(a, b) {
            if (b.b != null && (b.b.knownType == 20 || b.b.knownType == 19 || b.b.knownType == 22 || b.b.knownType == 18)) {
                if (b.a != null) {
                    return true;
                }
            }
            if (b.b != null && (b.b.knownType == 8 || b.b.knownType == 9 || b.b.knownType == 10)) {
                if (this.w(a, b)) {
                    return true;
                }
            }
            return false;
        }
        t(a) {
            if (a.b != null && (a.b.knownType == 19)) {
                if (a.a != null) {
                    return true;
                }
            }
            return false;
        }
        get aq() {
            return this.af.d();
        }
        bc(a, b, c) {
            this.af.h(a);
        }
        u(a, b) {
            let c = false;
            if (b.getMetadata(a, "__isPlainObject") != null) {
                c = true;
            }
            return c;
        }
        bq() {
        }
        bk(a) {
        }
        bl(a) {
            this.af.e();
        }
        bi(a, b, c, d) {
        }
        bj(a, b, c, d) {
            this.bi(a, b, c, d);
        }
        toString() {
            return this.d.toString();
        }
        a0() {
            return "null";
        }
        a3(a, b, c) {
            if (b.b == null) {
                return b.c;
            }
            if (typeCast(CodeGenerationSpecialValue.$, b.c) !== null) {
                b.c = this.ag(b);
            }
            switch (b.b.knownType) {
                case 10:
                    if (this.w(a, b)) {
                        return this.ao(a, b);
                    }
                    return this.at(a, b);
                case 23:
                    if (this.w(a, b)) {
                        return this.ao(a, b);
                    }
                    return this.at(a, b);
                case 7: return b.c ? "true" : "false";
                case 4: return this.ai(b);
                case 6:
                    {
                        return stringJoin1(String_$type, " ", this.ab(b, c));
                    }
                case 9:
                    if (this.w(a, b)) {
                        return this.ao(a, b);
                    }
                    throw new NotSupportedException(1, "shouldn't get here");
                case 5: return this.ak(b);
                case 16:
                    {
                        return stringJoin1(String_$type, " ", this.ac(b, c));
                    }
                case 20:
                    if (b.a != null) {
                        return this.a2(b);
                    }
                    if (b.c == null) {
                        return this.a0();
                    }
                    break;
                case 22:
                    if (b.a != null) {
                        return this.a2(b);
                    }
                    if (b.c == null) {
                        return this.a0();
                    }
                    break;
                case 15: throw new NotSupportedException(1, "need to figure this out");
                case 3: throw new NotSupportedException(1, "need to figure this out");
                case 19: if (b.a != null) {
                    return this.ax(b);
                }
                else {
                    return this.a0();
                }
                case 8:
                    if (b.b.specificExternalType == "string") {
                        return this.aw(b);
                    }
                    if (b.a != null) {
                        return this.ay(b);
                    }
                    if (this.w(a, b)) {
                        return this.ao(a, b);
                    }
                    throw new NotSupportedException(1, "shouldn't get here");
                case 13: throw new NotSupportedException(1, "shouldn't get here");
                case 18: if (b.a != null) {
                    return this.az(b);
                }
                else {
                    return this.a0();
                }
                case 1: return b.c.toString();
                case 11:
                    {
                        let d = b.c;
                        return d.x + ", " + d.y;
                    }
                case 14:
                    {
                        let e = b.c;
                        return e.left + ", " + e.top + ", " + e.width + ", " + e.height;
                    }
                case 12:
                    {
                        let f = b.c;
                        return f.width + ", " + f.height;
                    }
                case 2: return b.c != null ? b.c.toString() : this.a0();
                case 21: return this.a9(b.c);
                case 17:
                    if (b.c == null) {
                        return "null";
                    }
                    if (typeof b.c === 'string') {
                        return b.c.toString();
                    }
                    return b.c.toString();
                case 0: throw new NotSupportedException(1, "shouldn't get here");
            }
            return "";
        }
        ab(a, b) {
            if (a.b == null) {
                return ((() => {
                    let $ret = new List$1(String_$type, 0);
                    $ret.add(a.c);
                    return $ret;
                })());
            }
            if (typeCast(CodeGenerationSpecialValue.$, a.c) !== null) {
                a.c = this.ag(a);
            }
            let c = a.c;
            let d = new List$1(String_$type, 0);
            for (let e = 0; e < c.count; e++) {
                d.add(this.ah(c.item(e)));
            }
            return d;
        }
        ac(a, b) {
            if (a.b == null) {
                return ((() => {
                    let $ret = new List$1(String_$type, 0);
                    $ret.add(a.c);
                    return $ret;
                })());
            }
            if (typeCast(CodeGenerationSpecialValue.$, a.c) !== null) {
                a.c = this.ag(a);
            }
            let c = a.c;
            let d = new List$1(String_$type, 0);
            for (let e = 0; e < c.count; e++) {
                d.add(this.aj(c.item(e)));
            }
            return d;
        }
        a9(a) {
            if (a == null) {
                return "";
            }
            return a.toString();
        }
        ao(a, b) {
            let c = this.a8(a, b);
            if (b.c != null) {
                let d = b.c;
                if (typeCast(List$1.$.specialize(Base.$), d) !== null) {
                    d = d.toArray();
                }
                if (typeCast(CodeGenerationItemBuilder.$, d) !== null) {
                    let e = this.i(this.l, this.j);
                    let f = this.an(c, b.c, e);
                    c = this.ar(a, b.c, f, c);
                }
                else if (typeCast(Array_$type, d) !== null) {
                    let g = d;
                    let h = new List$1(CodeGenerationItemBuilder.$, 0);
                    let i = new List$1(String_$type, 0);
                    for (let j = 0; j < g.length; j++) {
                        if (typeCast(CodeGenerationItemBuilder.$, g[j]) !== null) {
                            let k = this.i(this.l, this.j);
                            let l = c;
                            let m = g[j].p();
                            if (m == null) {
                                m = g[j].n();
                                m = this.au(m);
                            }
                            if (m != null) {
                                if (m != l) {
                                    l = m;
                                }
                                else {
                                    l = c + "_" + j.toString();
                                }
                            }
                            let n = this.an(l, g[j], k);
                            h.add(g[j]);
                            i.add(n);
                        }
                    }
                    c = this.as(b, a, h, i, c);
                }
            }
            return c;
        }
        an(a, b, c) {
            b.u = a;
            b.v(c, true);
            let d = c.toString();
            for (let e of fromEnum(c.aa)) {
                this.aa.add(e);
            }
            return d;
        }
        ar(a, b, c, d) {
            return d;
        }
        as(a, b, c, d, e) {
            return e;
        }
        a8(a, b) {
            if (b.c == null) {
                return this.a0();
            }
            if (typeCast(CodeGenerationItemBuilder.$, b.c) !== null) {
                let c = b.c.p();
                if (c != null) {
                    return c;
                }
                let d = b.c.n();
                let e = this.au(d);
                return e;
            }
            else if (typeCast(IList_$type, b.c) !== null) {
                let f = b.c;
                if (f.count > 0 && typeCast(CodeGenerationItemBuilder.$, f.item(0)) !== null) {
                    let g = f.item(0);
                    let h = g.p();
                    if (h != null) {
                        return h;
                    }
                    let i = g.n();
                    let j = this.au(i);
                    return j;
                }
                return this.au(b.b.propertyName);
            }
            else if (typeCast(Array_$type, b.c) !== null) {
                let k = b.c;
                if (k.length > 0 && typeCast(CodeGenerationItemBuilder.$, k[0]) !== null) {
                    let l = b.c.p();
                    if (l != null) {
                        return l;
                    }
                    let m = b.c.n();
                    let n = this.au(m);
                    return n;
                }
                return this.au(b.b.propertyName);
            }
            return this.a0();
        }
        at(a, b) {
            return "";
        }
        ag(a) {
            return a.c;
        }
        a2(a) {
            if (!stringIsNullOrEmpty(a.a.e)) {
                if (a.a.a) {
                    return this.av(a);
                }
                else {
                    return this.a1(a);
                }
            }
            return this.a0();
        }
        s(a) {
            if (a.a != null && !stringIsNullOrEmpty(a.a.e)) {
                if (a.a.a) {
                    return true;
                }
            }
            return false;
        }
        a1(a) {
            return "";
        }
        av(a) {
            return "";
        }
        ay(a) {
            if (!stringIsNullOrEmpty(a.a.e)) {
                return a.a.e;
            }
            return this.a0();
        }
        aw(a) {
            return a.c != null ? a.c.toString() : "";
        }
        az(a) {
            return this.ax(a);
        }
        ax(a) {
            if (!stringIsNullOrEmpty(a.a.e)) {
                this.br(a);
                return a.a.e;
            }
            return this.a0();
        }
        get_x() {
            return false;
        }
        get x() {
            return this.get_x();
        }
        ak(a) {
            let b = a.c;
            return ColorUtil.k(b, this.x);
        }
        aj(a) {
            let b = a;
            return ColorUtil.k(b, this.x);
        }
        ai(a) {
            if (a.c == null) {
                return "";
            }
            let b = a.c;
            return ColorUtil.k(b.color, this.x);
        }
        ah(a) {
            if (a == null) {
                return "";
            }
            let b = a;
            return ColorUtil.k(b.color, this.x);
        }
        bp(a) {
            this.ad.h(a);
            this.ae.h(false);
        }
        bo(a) {
            let b = this.au(a);
            this.ad.h(b);
            this.ae.h(true);
        }
        au(a) {
            let b = stringReplace(stringReplace(a, this.a7, ""), "Component", "");
            b = CodeGeneratingComponentRenderer.er(b);
            return this.j.v(b);
        }
        bm() {
            this.a4 = this.ad.e();
            this.ae.e();
        }
        get_a7() {
            return "";
        }
        get a7() {
            return this.get_a7();
        }
        get ap() {
            if (this.ad.f > 0) {
                return this.ad.d();
            }
            let a = stringReplace(stringReplace(this.aq, this.a7, ""), "Component", "");
            return CodeGeneratingComponentRenderer.er(a);
        }
        get v() {
            return this.af.f == 1;
        }
        get o() {
            if (this.ae.f == 0) {
                return false;
            }
            return this.ae.d();
        }
        get p() {
            if (this.ad.f > 0) {
                return true;
            }
            return false;
        }
        get_y() {
            return true;
        }
        get y() {
            return this.get_y();
        }
        get_n() {
            return this.r;
        }
        get n() {
            return this.get_n();
        }
        bn() {
            this.a4 = this.ad.e();
        }
        be(a) {
            let b = this.f.toString();
            if (b.length > 0) {
                a.l(b);
            }
        }
        bh(a) {
            let b = this.g.toString();
            if (b.length > 0) {
                a.l(b);
            }
        }
        bd(a) {
            let b = this.e.toString();
            if (b.length > 0) {
                a.l(b);
            }
        }
        bf(a, b) {
            if (this.aa.count > 0) {
                this.bg(a, this.aa, b);
            }
        }
        bg(a, b, c) {
        }
    }
    CodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRendererCodeEmitter, 'CodeGeneratingComponentRendererCodeEmitter');
    return CodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let BlazorRazorCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class BlazorRazorCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        get_r() {
            return false;
        }
        get r() {
            return this.get_r();
        }
        ar(a, b, c, d) {
            d = super.ar(a, b, c, d);
            this.f.l("private " + b.n() + " _" + CodeGeneratingComponentRenderer.er(d) + " = null;");
            this.f.l("public " + b.n() + " " + CodeGeneratingComponentRenderer.es(d));
            this.f.l("{");
            this.f.h();
            this.f.l("get");
            this.f.l("{");
            this.f.h();
            this.f.l("if (this._" + CodeGeneratingComponentRenderer.er(d) + " == null)");
            this.f.l("{");
            this.f.h();
            this.f.k(c);
            this.f.l("this._" + CodeGeneratingComponentRenderer.er(d) + " = " + d + ";");
            this.f.f();
            this.f.l("}");
            this.f.l("return this._" + CodeGeneratingComponentRenderer.er(d) + ";");
            this.f.f();
            this.f.l("}");
            this.f.f();
            this.f.l("}");
            return CodeGeneratingComponentRenderer.es(d);
        }
        as(a, b, c, d, e) {
            e = super.as(a, b, c, d, e);
            let f = null;
            if (c.count > 0) {
                f = c._inner[0].r() + "[]";
            }
            else {
                let g = a.b.specificExternalType;
                f = CodeGenerationItemBuilder.o(this.k.platform, g, b, this.al, this.am) + "[]";
            }
            this.f.l("private " + f + " _" + CodeGeneratingComponentRenderer.er(e) + " = null;");
            this.f.l("public " + f + " " + CodeGeneratingComponentRenderer.es(e));
            this.f.l("{");
            this.f.h();
            this.f.l("get");
            this.f.l("{");
            this.f.h();
            this.f.l("if (this._" + CodeGeneratingComponentRenderer.er(e) + " == null)");
            this.f.l("{");
            this.f.h();
            this.f.k("var " + CodeGeneratingComponentRenderer.er(e) + " = new " + stringReplace(f, "[]", "") + "[" + c.count + "];");
            for (let h = 0; h < c.count; h++) {
                this.f.k(d._inner[h]);
                this.f.k(e + "[" + h + "] = " + c._inner[h].u + ";");
            }
            this.f.l("this._" + CodeGeneratingComponentRenderer.er(e) + " = " + e + ";");
            this.f.f();
            this.f.l("}");
            this.f.l("return this._" + CodeGeneratingComponentRenderer.er(e) + ";");
            this.f.f();
            this.f.l("}");
            this.f.f();
            this.f.l("}");
            return CodeGeneratingComponentRenderer.es(e);
        }
        i(a, b) {
            return new BlazorCodeBehindCodeGeneratingComponentRendererCodeEmitter(a, b);
        }
        get_y() {
            return false;
        }
        constructor(a, b) {
            super(a, b);
            this.bu = 0;
            this.bs = new HashSet$1(String_$type, 0);
            this.bt = new HashSet$1(String_$type, 0);
        }
        bv(a, b, c) {
            if (c.c == null) {
                return "null";
            }
            let d = c.c;
            let e = b;
            let f = new CodeGenerationItemBuilderPropertyInfo();
            f.b = ((() => {
                let $ret = new TypeDescriptionMetadata();
                $ret.propertyName = c.b.propertyName;
                $ret.specificType = b;
                $ret.specificExternalType = b;
                return $ret;
            })());
            f.b.knownType = 8;
            f.b.owningType = c.b.owningType;
            if (f.b.specificType == "string") {
                f.b.knownType = 2;
            }
            if (f.b.specificType == "int") {
                f.b.knownType = 1;
            }
            if (f.b.specificType == "double") {
                f.b.knownType = 1;
            }
            if (f.b.knownType == 8) {
                e = this.a7 + e;
            }
            let g = "@(new " + e + "[] { ";
            for (let h = 0; h < d.length; h++) {
                if (h > 0) {
                    g += ", ";
                }
                f.c = d[h];
                if (f.b.knownType == 2) {
                    g += "\"" + this.a3(a, f, true) + "\"";
                }
                else {
                    g += this.a3(a, f, true);
                }
            }
            g += " })";
            return g;
        }
        at(a, b) {
            let c = b.b.specificType;
            if (c == null) {
                c = b.b.specificExternalType;
            }
            return this.bv(a, c, b);
        }
        bc(a, b, c) {
            super.bc(a, b, c);
            this.h.l("<" + a + "");
            if (!this.bs.contains(this.ap)) {
                this.bs.add_1(this.ap);
                if (!this.bt.contains(this.aq)) {
                    this.bt.add_1(this.aq);
                    this.bb(this.aq);
                }
                this.f.l("private " + this.aq + " " + CodeGeneratingComponentRenderer.er(this.ap) + ";");
                if (!this.p) {
                    if (this.v) {
                        this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + ";");
                    }
                }
                else {
                    this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + ";");
                }
            }
        }
        bq() {
            this.h.l(">");
            this.h.h();
        }
        bl(a) {
            this.h.f();
            this.h.l("</" + a + ">");
            this.h.l("");
            super.bl(a);
        }
        bi(a, b, c, d) {
            if (c.b != null && d.hasNameBinding(c.b.owningType, CodeGeneratingComponentRenderer.es(c.b.propertyName)) && this.q(d, c)) {
                this.br(c);
                if (a > 0) {
                    this.h.l("");
                }
                if (c.a == null || c.a.e == null) {
                    this.h.j(b + "Name=\"@null\"");
                }
                else {
                    this.h.j(b + "Name=\"" + c.a.e + "\"");
                }
                return;
            }
            if (this.s(c)) {
                this.br(c);
                if (!this.bs.contains(this.ap)) {
                    this.bs.add_1(this.ap);
                    if (!this.bt.contains(this.aq)) {
                        this.bt.add_1(this.aq);
                        this.bb(this.aq);
                    }
                    this.f.l("private " + this.aq + " " + CodeGeneratingComponentRenderer.er(this.ap) + ";");
                    if (!this.p) {
                        if (this.v) {
                            this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + ";");
                        }
                    }
                    else {
                        this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + ";");
                    }
                }
                let e = CodeGeneratingComponentRenderer.er(this.a3(d, c, true));
                let f = e;
                if (f != "null" && !stringStartsWith(f, "this.")) {
                    f = "this." + f;
                }
                this.e.l(CodeGeneratingComponentRenderer.er(this.ap) + "." + b + " = " + f + ";");
                return;
            }
            if (a > 0) {
                this.h.l("");
            }
            let g = false;
            if (b == "ComponentRenderer" && (c.b.owningType == "PropertyEditor" || c.b.owningType == "PropertyEditorPanel")) {
                g = true;
            }
            if (!g) {
                if (c.a != null && c.a.e != null) {
                    if (this.m != null) {
                        if (this.m.library != null) {
                            if (this.m.library.hasItem(c.a.e)) {
                                let h = this.m.library.getItem(c.a.e);
                                let i = h.getContentForPlatform(5);
                                if (i != null && i.isJSContent) {
                                    b = b + "Script";
                                }
                            }
                        }
                    }
                }
                this.h.j(b);
                this.h.j("=");
                this.h.j("\"");
                this.h.j(this.a3(d, c, true));
                this.h.j("\"");
            }
            if (b == "Name") {
                this.h.l("");
                this.h.j("@ref=\"" + CodeGeneratingComponentRenderer.er(this.a3(d, c, true)) + "\"");
            }
        }
        aw(a) {
            let b = a.b != null ? a.b.specificType + "." : "";
            return b + (a.c != null ? a.c.toString() : "");
        }
        a3(a, b, c) {
            if (b.b == null) {
                return b.c;
            }
            if (typeCast(CodeGenerationSpecialValue.$, b.c) !== null) {
                b.c = this.ag(b);
            }
            switch (b.b.knownType) {
                case 11:
                    {
                        let d = b.c;
                        return "@(new Point(" + d.x + ", " + d.y + "))";
                    }
                case 14:
                    {
                        let e = b.c;
                        return "@(new Rect(" + e.left + ", " + e.top + ", " + e.width + ", " + e.height + "))";
                    }
                case 12:
                    {
                        let f = b.c;
                        return "@(new Size(" + f.width + ", " + f.height + "))";
                    }
                case 17:
                    if (b.c == null) {
                        return "null";
                    }
                    if (typeof b.c === 'string') {
                        return "@(\"" + b.c.toString() + "\")";
                    }
                    if (typeCast(Boolean_$type, b.c) !== null) {
                        return b.c ? "true" : "false";
                    }
                    return b.c.toString();
            }
            return super.a3(a, b, c);
        }
        ag(a) {
            let b = a.c;
            switch (b.a) {
                case 3: return b.b;
                case 0: return b.b;
                case 1: return b.b;
                case 2: return b.b;
            }
            return b.b;
        }
        a0() {
            return "@null";
        }
        av(a) {
            return CodeGeneratingComponentRenderer.er(CodeGeneratingComponentRenderer.er(a.a.e));
        }
        bw(a) {
            a = stringReplace(a, "-", "_");
            return CodeGeneratingComponentRenderer.es(a);
        }
        a1(a) {
            this.br(a);
            return CodeGeneratingComponentRenderer.es(a.a.e);
        }
        bj(a, b, c, d) {
            if (c.b.knownType == 9) {
                let e = typeCast(IList_$type, c.c);
                if (e != null) {
                    for (let f of fromEn(e)) {
                        if (typeCast(CodeGenerationItemBuilder.$, f) !== null) {
                            let g = f;
                            g.v(this, false);
                        }
                    }
                }
            }
            else {
                if (typeCast(CodeGenerationItemBuilder.$, c.c) !== null) {
                    let h = c.c;
                    h.v(this, false);
                }
            }
        }
        get_a7() {
            return "Igb";
        }
    }
    BlazorRazorCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(BlazorRazorCodeGeneratingComponentRendererCodeEmitter, 'BlazorRazorCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return BlazorRazorCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let BlazorCodeBehindCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class BlazorCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        get_r() {
            return true;
        }
        get r() {
            return this.get_r();
        }
        i(a, b) {
            return new BlazorCodeBehindCodeGeneratingComponentRendererCodeEmitter(a, b);
        }
        get_y() {
            return false;
        }
        constructor(a, b) {
            super(a, b);
            this.bu = 0;
            this.bs = new HashSet$1(String_$type, 0);
            this.bt = new HashSet$1(String_$type, 0);
        }
        bv(a, b) {
            if (b.c == null) {
                return "null";
            }
            let c = b.c;
            let d = "new " + a + "[] { ";
            for (let e = 0; e < c.length; e++) {
                if (e > 0) {
                    d += ", ";
                }
                d += "\"" + c[e] + "\"";
            }
            d += " }";
            return d;
        }
        at(a, b) {
            if (b.b.specificExternalType == "string") {
                return this.bv(b.b.specificExternalType, b);
            }
            if (b.c == null) {
                return "null";
            }
            let c = b.c;
            let d = "";
            for (let e = 0; e < c.length; e++) {
                if (e > 0) {
                    d += ", ";
                }
                d += c[e];
            }
            return d;
        }
        bc(a, b, c) {
            super.bc(a, b, c);
            if (this.v) {
                this.h.l("var " + this.ap + " = new " + a + "();");
            }
            else {
                this.h.l("var " + this.ap + " = new " + a + "();");
            }
            if (!this.bs.contains(this.ap)) {
                this.bs.add_1(this.ap);
                if (!this.bt.contains(this.aq)) {
                    this.bt.add_1(this.aq);
                    this.bb(this.aq);
                }
                this.f.l("private " + this.aq + " " + CodeGeneratingComponentRenderer.er(this.ap) + ";");
                if (!this.p) {
                    if (this.v) {
                        this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + ";");
                    }
                }
                else {
                    this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + ";");
                }
            }
        }
        bq() {
        }
        bl(a) {
            super.bl(a);
        }
        bi(a, b, c, d) {
            if (c.b != null && d.hasNameBinding(c.b.owningType, CodeGeneratingComponentRenderer.es(c.b.propertyName)) && this.q(d, c)) {
                this.br(c);
                if (a > 0) {
                    this.h.l("");
                }
                if (c.a == null || c.a.e == null) {
                    this.h.j(this.ap + "." + b + "Name = null;");
                }
                else {
                    this.h.j(this.ap + "." + b + "Name = " + c.a.e + ";");
                }
                return;
            }
            if (this.s(c)) {
                this.br(c);
                if (!this.bs.contains(this.ap)) {
                    this.bs.add_1(this.ap);
                    if (!this.bt.contains(this.aq)) {
                        this.bt.add_1(this.aq);
                        this.bb(this.aq);
                    }
                    this.f.l("private " + this.aq + " " + CodeGeneratingComponentRenderer.er(this.ap) + ";");
                    if (!this.p) {
                        if (this.v) {
                            this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + ";");
                        }
                    }
                    else {
                        this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + ";");
                    }
                }
                let e = CodeGeneratingComponentRenderer.er(this.a3(d, c, true));
                let f = e;
                if (f != "null" && !stringStartsWith(f, "this.")) {
                    f = "this." + f;
                }
                this.e.l(CodeGeneratingComponentRenderer.er(this.ap) + "." + b + " = " + f + ";");
                return;
            }
            if (a > 0) {
                this.h.l("");
            }
            let g = false;
            if (b == "ComponentRenderer" && (c.b.owningType == "PropertyEditor" || c.b.owningType == "PropertyEditorPanel")) {
                g = true;
            }
            if (!g) {
                let h = false;
                if (c.a != null && c.a.e != null) {
                    if (this.m != null) {
                        if (this.m.library != null) {
                            if (this.m.library.hasItem(c.a.e)) {
                                let i = this.m.library.getItem(c.a.e);
                                let j = i.getContentForPlatform(5);
                                if (j != null && j.isJSContent) {
                                    b = b + "Script";
                                    h = true;
                                }
                            }
                        }
                    }
                }
                this.h.j(this.ap + ".");
                this.h.j(b);
                this.h.j(" = ");
                if (h) {
                    this.h.j("\"" + this.a3(d, c, true) + "\"");
                }
                else {
                    this.h.j(this.a3(d, c, true));
                }
                this.h.j(";");
            }
        }
        aw(a) {
            let b = a.b != null ? a.b.specificType + "." : "";
            return b + (a.c != null ? a.c.toString() : "");
        }
        a3(a, b, c) {
            if (b.b == null) {
                return "\"" + b.c + "\"";
            }
            if (typeCast(CodeGenerationSpecialValue.$, b.c) !== null) {
                b.c = this.ag(b);
            }
            switch (b.b.knownType) {
                case 11:
                    {
                        let d = b.c;
                        return "new Point(" + d.x + ", " + d.y + ")";
                    }
                case 14:
                    {
                        let e = b.c;
                        return "new Rect(" + e.left + ", " + e.top + ", " + e.width + ", " + e.height + ")";
                    }
                case 12:
                    {
                        let f = b.c;
                        return "new Size(" + f.width + ", " + f.height + ")";
                    }
                case 17:
                    if (b.c == null) {
                        return "null";
                    }
                    if (typeof b.c === 'string') {
                        return "\"" + b.c.toString() + "\"";
                    }
                    if (typeCast(Boolean_$type, b.c) !== null) {
                        return b.c ? "true" : "false";
                    }
                    return b.c.toString();
                case 5:
                case 6:
                case 16:
                case 2: return "\"" + super.a3(a, b, c) + "\"";
                case 9: throw new NotSupportedException(1, "shouldn't get here");
            }
            return super.a3(a, b, c);
        }
        ag(a) {
            let b = a.c;
            switch (b.a) {
                case 3: return b.b;
                case 0: return b.b;
                case 1: return b.b;
                case 2: return b.b;
            }
            return b.b;
        }
        a0() {
            return "null";
        }
        av(a) {
            return CodeGeneratingComponentRenderer.er(CodeGeneratingComponentRenderer.er(a.a.e));
        }
        bw(a) {
            a = stringReplace(a, "-", "_");
            return CodeGeneratingComponentRenderer.es(a);
        }
        a1(a) {
            this.br(a);
            return CodeGeneratingComponentRenderer.es(a.a.e);
        }
        bj(a, b, c, d) {
            if (c.b.knownType == 9) {
                let e = typeCast(IList_$type, c.c);
                if (e != null) {
                    for (let f of fromEn(e)) {
                        if (typeCast(CodeGenerationItemBuilder.$, f) !== null) {
                            let g = f;
                            g.v(this, false);
                            this.h.l(this.ap + "." + b + ".Add(" + this.a4 + ");");
                        }
                    }
                }
            }
            else if (c.b.knownType == 10) {
                let h = typeCast(Array_$type, c.c);
                if (h != null) {
                    let i = "[";
                    for (let j = 0; j < h.length; j++) {
                        let k = arrayGetValue(h, j);
                        if (typeCast(CodeGenerationItemBuilder.$, k) !== null) {
                            let l = k;
                            l.v(this, false);
                            i += this.a4 + ",";
                        }
                    }
                    i = trimEnd(i, ',');
                    i += "]";
                    this.h.l(this.ap + "." + b + " = " + i + ";");
                }
            }
            else {
                if (typeCast(CodeGenerationItemBuilder.$, c.c) !== null) {
                    let m = c.c;
                    m.v(this, false);
                    this.h.l(this.ap + "." + b + " = " + this.a4 + ";");
                }
            }
        }
        get_a7() {
            return "Igb";
        }
    }
    BlazorCodeBehindCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(BlazorCodeBehindCodeGeneratingComponentRendererCodeEmitter, 'BlazorCodeBehindCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return BlazorCodeBehindCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let ReactMarkupCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class ReactMarkupCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        get_r() {
            return false;
        }
        get r() {
            return this.get_r();
        }
        ar(a, b, c, d) {
            d = super.ar(a, b, c, d);
            let e = b.r();
            this.f.l("private " + " _" + CodeGeneratingComponentRenderer.er(d) + ": " + e + " | null = null;");
            this.f.l("public get " + CodeGeneratingComponentRenderer.er(d) + "(): " + e + " {");
            this.f.h();
            this.f.l("if (this._" + CodeGeneratingComponentRenderer.er(d) + " == null)");
            this.f.l("{");
            this.f.h();
            this.f.k(c);
            this.f.l("this._" + CodeGeneratingComponentRenderer.er(d) + " = " + d + ";");
            this.f.f();
            this.f.l("}");
            this.f.l("return this._" + CodeGeneratingComponentRenderer.er(d) + ";");
            this.f.f();
            this.f.l("}");
            return CodeGeneratingComponentRenderer.es(d);
        }
        as(a, b, c, d, e) {
            e = super.as(a, b, c, d, e);
            let f = null;
            if (c.count > 0) {
                f = c._inner[0].r() + "[]";
            }
            else {
                let g = a.b.specificExternalType;
                f = CodeGenerationItemBuilder.o(this.k.platform, g, b, this.al, this.am) + "[]";
            }
            this.f.l("private" + " _" + CodeGeneratingComponentRenderer.er(e) + ": " + f + " | null = null;");
            this.f.l("public get " + CodeGeneratingComponentRenderer.er(e) + "(): " + f + " {");
            this.f.h();
            this.f.l("if (this._" + CodeGeneratingComponentRenderer.er(e) + " == null)");
            this.f.l("{");
            this.f.h();
            this.f.k("let " + CodeGeneratingComponentRenderer.er(e) + ": " + f + " = [];");
            for (let h = 0; h < c.count; h++) {
                this.f.k(d._inner[h]);
                this.f.k(e + ".push(" + c._inner[h].u + ")");
            }
            this.f.l("this._" + CodeGeneratingComponentRenderer.er(e) + " = " + e + ";");
            this.f.f();
            this.f.l("}");
            this.f.l("return this._" + CodeGeneratingComponentRenderer.er(e) + ";");
            this.f.f();
            this.f.l("}");
            return CodeGeneratingComponentRenderer.es(e);
        }
        i(a, b) {
            return new ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter(a, b);
        }
        constructor(a, b) {
            super(a, b);
            this.bs = new HashSet$1(String_$type, 0);
            this.bt = new HashSet$1(String_$type, 0);
        }
        at(a, b) {
            if (b.c == null) {
                return "{null}";
            }
            if (b.b != null && b.b.knownType == 23) {
                let c = b.c;
                let d = "";
                for (let e = 0; e < c.length; e++) {
                    if (e > 0) {
                        d += ", ";
                    }
                    d += c[e];
                }
                return d;
            }
            let f = b.c;
            let g = "[";
            for (let h = 0; h < f.length; h++) {
                if (h > 0) {
                    g += ", ";
                }
                if (b.b != null && (b.b.specificExternalType == "int" || b.b.specificExternalType == "double")) {
                    g += f[h].toString();
                }
                else {
                    g += "\"" + f[h].toString() + "\"";
                }
            }
            g += "]";
            return g;
        }
        get_x() {
            return true;
        }
        get_a7() {
            return "Igr";
        }
        bc(a, b, c) {
            super.bc(a, b, c);
            this.h.l("<" + this.bv(a) + "");
            this.h.h();
            if (!this.bt.contains(this.aq)) {
                this.bt.add_1(this.aq);
                this.bb(this.aq);
            }
            if (!this.bs.contains(this.ap)) {
                this.bs.add_1(this.ap);
                this.f.l("private " + CodeGeneratingComponentRenderer.er(this.ap) + ": " + this.aq);
                if (this.v) {
                    this.f.l("private " + CodeGeneratingComponentRenderer.er(this.ap) + "Ref(r: " + this.aq + ") {");
                    this.f.h();
                    this.f.l("this." + CodeGeneratingComponentRenderer.er(this.ap) + " = r;");
                    this.f.l("this.setState({});");
                    this.f.f();
                    this.f.l("}");
                    this.g.l("this." + CodeGeneratingComponentRenderer.er(this.ap) + "Ref = " + "this." + CodeGeneratingComponentRenderer.er(this.ap) + "Ref.bind(this);");
                }
            }
        }
        bv(a) {
            if (stringEndsWith(a, "Component")) {
                a = a.substr(0, a.length - ("Component").length);
            }
            return CodeGeneratingComponentRenderer.es(a);
        }
        bq() {
            if (!this.v && !this.p) {
                let a = this.bu();
                this.h.l("");
                this.h.l("name=\"" + a + "\"");
            }
            this.h.f();
            this.h.l(">");
            this.h.h();
        }
        bu() {
            let a = CodeGeneratingComponentRenderer.er(stringReplace(stringReplace(this.aq, this.a7, ""), "Component", ""));
            a = this.k.u(a);
            return a;
        }
        ax(a) {
            if (!stringIsNullOrEmpty(a.a.e)) {
                this.br(a);
                if (!this.bs.contains(a.a.e)) {
                    this.g.l("this." + CodeGeneratingComponentRenderer.er(a.a.e) + " = " + "this." + CodeGeneratingComponentRenderer.er(a.a.e) + ".bind(this);");
                }
                return "this." + CodeGeneratingComponentRenderer.er(a.a.e);
            }
            return this.a0();
        }
        bl(a) {
            this.h.f();
            this.h.l("</" + this.bv(a) + ">");
            super.bl(a);
        }
        bi(a, b, c, d) {
            let e = CodeGeneratingComponentRenderer.er(b);
            let f = this.a3(d, c, true);
            if (c.b != null && d.hasNameBinding(c.b.owningType, CodeGeneratingComponentRenderer.es(c.b.propertyName)) && this.q(d, c)) {
                this.br(c);
                if (a > 0) {
                    this.h.l("");
                }
                if (c.a == null || c.a.e == null) {
                    this.h.j(e + "Name={null}");
                }
                else {
                    this.h.j(e + "Name=\"" + c.a.e + "\"");
                }
                return;
            }
            if (!(e == "name") || !this.v) {
                let g = (c.b != null && c.b.knownType == 10);
                if (this.q(d, c)) {
                    this.br(c);
                    let h = CodeGeneratingComponentRenderer.er(f);
                    let i = h;
                    if (i != "null" && !stringStartsWith(i, "this.")) {
                        i = "this." + i;
                    }
                    f = "{" + i + "}";
                }
                else if (g) {
                    f = "{" + f + "}";
                }
                if (a > 0) {
                    this.h.l("");
                }
                this.h.j(e);
                this.h.j("=");
                if (!this.q(d, c) && !g) {
                    this.h.j("\"");
                }
                this.h.j(f);
                if (!this.q(d, c) && !g) {
                    this.h.j("\"");
                }
                a++;
            }
            if (e == "name") {
                if (this.v) {
                    if (a > 0) {
                        this.h.l("");
                    }
                    this.h.j("ref={this." + CodeGeneratingComponentRenderer.er(this.a3(d, c, true)) + "Ref}");
                }
            }
        }
        ag(a) {
            let b = a.c;
            switch (b.a) {
                case 3: return b.b;
                case 0: return b.b;
                case 1: return b.b;
                case 2: return b.b;
            }
            return b.b;
        }
        a0() {
            return "null";
        }
        av(a) {
            return "this." + CodeGeneratingComponentRenderer.er(a.a.e);
        }
        a1(a) {
            return "this." + CodeGeneratingComponentRenderer.er(a.a.e);
        }
        bj(a, b, c, d) {
            if (c.b.knownType == 9) {
                let e = typeCast(IList_$type, c.c);
                if (e != null) {
                    for (let f of fromEn(e)) {
                        if (typeCast(CodeGenerationItemBuilder.$, f) !== null) {
                            let g = f;
                            g.v(this, false);
                        }
                    }
                }
            }
            else {
                if (typeCast(CodeGenerationItemBuilder.$, c.c) !== null) {
                    let h = c.c;
                    h.v(this, false);
                }
            }
        }
        bg(a, b, c) {
            super.bg(a, b, c);
            WebImportsHalper.b(this.k, this.a6, this.a5, this.a7, a, b, c);
        }
    }
    ReactMarkupCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(ReactMarkupCodeGeneratingComponentRendererCodeEmitter, 'ReactMarkupCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return ReactMarkupCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let WebCodeBehindCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class WebCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        get_r() {
            return true;
        }
        get r() {
            return this.get_r();
        }
        constructor(a, b) {
            super(a, b);
            this.bv = 0;
            this.bt = new HashSet$1(String_$type, 0);
            this.bu = new HashSet$1(String_$type, 0);
        }
        bs(a) {
            if (!a.b.owningContext.hasStringUnionPlatforms(a.b.owningType, a.b.propertyName)) {
                return false;
            }
            let b = a.b.owningContext.getStringUnionPlatforms(a.b.owningType, a.b.propertyName);
            for (let c = 0; c < b.length; c++) {
                if (b[c].toLowerCase() == this.a6) {
                    return true;
                }
            }
            return false;
        }
        aw(a) {
            if (this.bs(a)) {
                return "\"" + CodeGeneratingComponentRenderer.et(a.c.toString()) + "\"";
            }
            else {
                if (!this.bu.contains(a.b.specificType)) {
                    this.bu.add_1(a.b.specificType);
                    if (a.b.owningContext.getMetadata(a.b.owningType, "__importTypes" + EnumUtil.getName(CodeGenerationTargetPlatforms_$type, this.k.platform)) != null) {
                        let b = a.b.owningContext.getMetadata(a.b.owningType, "__importTypes" + EnumUtil.getName(CodeGenerationTargetPlatforms_$type, this.k.platform)).specificExternalType;
                        this.bb(a.b.specificType + ":" + b);
                    }
                    else if (a.b.owningContext.getMetadata("Web" + a.b.owningType, "__importTypes" + EnumUtil.getName(CodeGenerationTargetPlatforms_$type, this.k.platform)) != null) {
                        let c = a.b.owningContext.getMetadata("Web" + a.b.owningType, "__importTypes" + EnumUtil.getName(CodeGenerationTargetPlatforms_$type, this.k.platform)).specificExternalType;
                        this.bb(a.b.specificType + ":" + c);
                    }
                    else {
                        this.bb(a.b.specificType);
                    }
                }
                let d = a.b != null ? a.b.specificType + "." : "";
                return d + (a.c != null ? a.c.toString() : "");
            }
        }
        at(a, b) {
            if (b.c == null) {
                return "null";
            }
            let c = b.c;
            let d = "[";
            for (let e = 0; e < c.length; e++) {
                if (e > 0) {
                    d += ", ";
                }
                d += c[e];
            }
            return d + "]";
        }
        get_x() {
            return true;
        }
        u(a, b) {
            let c = false;
            let d = this.a6 == "react" ? b.getMetadata(a, "__isPlainObject") != null && (b.getMetadata(a, "__isTSPlainInterface") != null || b.getMetadata(a, "__marshalByValue") == null) : b.getMetadata(a, "__isPlainObject") != null;
            if (d) {
                c = true;
            }
            return c;
        }
        bc(a, b, c) {
            super.bc(a, b, c);
            let d = this.u(b, c);
            if (d) {
                if (this.v) {
                    this.h.l("var " + this.ap + ": " + a + " = {} as " + a + ";");
                }
                else {
                    this.h.l("var " + this.ap + ": " + a + " = {} as " + a + ";");
                }
            }
            else {
                if (this.v) {
                    this.h.l("var " + this.ap + " = new " + a + "();");
                }
                else {
                    this.h.l("var " + this.ap + " = new " + a + "();");
                }
            }
            if (!this.bt.contains(this.ap)) {
                this.bt.add_1(this.ap);
                if (!this.bu.contains(this.aq)) {
                    this.bu.add_1(this.aq);
                    this.bb(this.aq);
                }
                this.f.l("private " + CodeGeneratingComponentRenderer.er(this.ap) + ": " + this.aq);
                if (!this.p) {
                    if (this.v) {
                        this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + " = document.querySelector('" + CodeGeneratingComponentRenderer.eu(stringReplace(this.aq, "Component", "")) + "') as " + this.aq + ";");
                    }
                }
                else {
                    this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + " = document.getElementById('" + this.ap + "') as " + this.aq + ";");
                }
            }
        }
        bw(a) {
            if (stringEndsWith(a, "Component")) {
                a = a.substr(0, a.length - ("Component").length);
            }
            return CodeGeneratingComponentRenderer.eu(a);
        }
        bq() {
            this.h.l("");
        }
        bk(a) {
        }
        bl(a) {
            {
                this.h.l("");
            }
            super.bl(a);
        }
        bi(a, b, c, d) {
            let e = CodeGeneratingComponentRenderer.er(b);
            if (e == "name" && c.b == null) {
                return;
            }
            if (this.s(c)) {
                this.br(c);
                if (!this.bt.contains(this.ap)) {
                    this.bt.add_1(this.ap);
                    if (!this.bu.contains(this.aq)) {
                        this.bu.add_1(this.aq);
                        this.bb(this.aq);
                    }
                    this.f.l("private " + CodeGeneratingComponentRenderer.er(this.ap) + ": " + this.aq);
                    if (!this.p) {
                        if (this.v) {
                            this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + " = document.querySelector('" + CodeGeneratingComponentRenderer.eu(stringReplace(this.aq, "Component", "")) + "') as " + this.aq + ";");
                        }
                    }
                    else {
                        this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + " = document.getElementById('" + this.ap + "') as " + this.aq + ";");
                    }
                }
                let f = CodeGeneratingComponentRenderer.er(this.a3(d, c, true));
                let g = f;
                if (g != "null" && !stringStartsWith(g, "this.")) {
                    g = "this." + g;
                }
                if (this.aq == "any" && stringContains(e, "-")) {
                    this.e.l(CodeGeneratingComponentRenderer.er(this.ap) + "['" + e + "'] = " + g + ";");
                }
                else {
                    if (c.b != null && c.b.isCustomEvent) {
                        this.e.l(CodeGeneratingComponentRenderer.er(this.ap) + ".addEventListener(\"" + e + "\", " + g + ");");
                    }
                    else {
                        this.e.l(CodeGeneratingComponentRenderer.er(this.ap) + "." + e + " = " + g + ";");
                    }
                }
                return;
            }
            if (a > 0) {
                this.h.l("");
            }
            if (this.aq == "any" && stringContains(e, "-")) {
                this.h.j(this.ap + "." + CodeGeneratingComponentRenderer.er(this.ap) + "['" + e + "']");
            }
            else {
                this.h.j(this.ap + "." + CodeGeneratingComponentRenderer.er(e));
            }
            this.h.j(" = ");
            this.h.j(this.a3(d, c, true));
            this.h.j(";");
        }
        ag(a) {
            let b = a.c;
            switch (b.a) {
                case 3: return b.b;
                case 0: return b.b;
                case 1: return b.b;
                case 2: return b.b;
            }
            return b.b;
        }
        a0() {
            return "null";
        }
        av(a) {
            return CodeGeneratingComponentRenderer.er(a.a.e);
        }
        a1(a) {
            return CodeGeneratingComponentRenderer.er(a.a.e);
        }
        ax(a) {
            if (!stringIsNullOrEmpty(a.a.e)) {
                this.br(a);
                if (!this.bt.contains(a.a.e)) {
                    this.g.l("this." + CodeGeneratingComponentRenderer.er(a.a.e) + " = " + "this." + CodeGeneratingComponentRenderer.er(a.a.e) + ".bind(this);");
                }
                return "this." + CodeGeneratingComponentRenderer.er(a.a.e);
            }
            return this.a0();
        }
        a3(a, b, c) {
            if (b.b == null) {
                return "\"" + b.c + "\"";
            }
            if (typeCast(CodeGenerationSpecialValue.$, b.c) !== null) {
                b.c = this.ag(b);
            }
            switch (b.b.knownType) {
                case 11:
                    {
                        let d = b.c;
                        return "{ x: " + d.x + ", y: " + d.y + "}";
                    }
                case 14:
                    {
                        let e = b.c;
                        return "{ left: " + e.left + ", top: " + e.top + ", width: " + e.width + ", height: " + e.height + "}";
                    }
                case 12:
                    {
                        let f = b.c;
                        return "{ width: " + f.width + ", height: " + f.height + "}";
                    }
                case 17:
                    if (b.c == null) {
                        return "null";
                    }
                    if (typeof b.c === 'string') {
                        return "\"" + b.c.toString() + "\"";
                    }
                    if (typeCast(Boolean_$type, b.c) !== null) {
                        return b.c ? "true" : "false";
                    }
                    return b.c.toString();
                case 5:
                case 2: return "\"" + super.a3(a, b, c) + "\"";
                case 23: return "[" + super.a3(a, b, c) + "]";
                case 6: return "[\"" + stringJoin1(String_$type, "\", \"", super.ab(b, c)) + "\"]";
                case 16: return "[\"" + stringJoin1(String_$type, "\", \"", super.ac(b, c)) + "\"]";
                case 9: throw new NotSupportedException(1, "shouldn't get here");
            }
            return super.a3(a, b, c);
        }
        bj(a, b, c, d) {
            if (c.b.knownType == 9) {
                let e = typeCast(IList_$type, c.c);
                if (e != null) {
                    let f = true;
                    for (let g of fromEn(e)) {
                        if (typeCast(CodeGenerationItemBuilder.$, g) !== null) {
                            let h = g;
                            h.v(this, false);
                            let i = c.b.owningType;
                            let j = d.getMetadata(i, "__isPlainObject");
                            let k = false;
                            if (j != null) {
                                k = true;
                            }
                            if (k) {
                                if (f) {
                                    f = false;
                                    this.h.l(this.ap + "." + b + " = []");
                                }
                                this.h.l(this.ap + "." + b + ".push(" + this.a4 + ");");
                            }
                            else {
                                this.h.l(this.ap + "." + b + ".add(" + this.a4 + ");");
                            }
                        }
                    }
                }
            }
            else if (c.b.knownType == 10) {
                let l = typeCast(Array_$type, c.c);
                if (l != null) {
                    let m = "[";
                    for (let n = 0; n < l.length; n++) {
                        let o = arrayGetValue(l, n);
                        if (typeCast(CodeGenerationItemBuilder.$, o) !== null) {
                            let p = o;
                            p.v(this, false);
                            m += this.a4 + ",";
                        }
                    }
                    m = trimEnd(m, ',');
                    m += "]";
                    this.h.l(this.ap + "." + b + " = " + m + ";");
                }
            }
            else {
                if (typeCast(CodeGenerationItemBuilder.$, c.c) !== null) {
                    let q = c.c;
                    q.v(this, false);
                    this.h.l(this.ap + "." + b + " = " + this.a4 + ";");
                }
            }
        }
    }
    WebCodeBehindCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(WebCodeBehindCodeGeneratingComponentRendererCodeEmitter, 'WebCodeBehindCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return WebCodeBehindCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter extends WebCodeBehindCodeGeneratingComponentRendererCodeEmitter {
        get_r() {
            return true;
        }
        i(a, b) {
            return new ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter(a, b);
        }
        constructor(a, b) {
            super(a, b);
        }
        get_a7() {
            return "Igc";
        }
        bg(a, b, c) {
            super.bg(a, b, c);
            WebImportsHalper.b(this.k, this.a6, this.a5, this.a7, a, b, c);
        }
        bx(a, b) {
            let c = false;
            if (b.getMetadata(a, "__isPlainObject") != null && b.getMetadata(a, "__marshalByValue") == null) {
                c = true;
            }
            return c;
        }
    }
    ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter, 'ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter', WebCodeBehindCodeGeneratingComponentRendererCodeEmitter.$);
    return ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        get_r() {
            return false;
        }
        get r() {
            return this.get_r();
        }
        bs(a) {
            if (!a.b.owningContext.hasStringUnionPlatforms(a.b.owningType, a.b.propertyName)) {
                return false;
            }
            let b = a.b.owningContext.getStringUnionPlatforms(a.b.owningType, a.b.propertyName);
            for (let c = 0; c < b.length; c++) {
                if (b[c].toLowerCase() == this.a6) {
                    return true;
                }
            }
            return false;
        }
        aw(a) {
            if (this.bs(a)) {
                return CodeGeneratingComponentRenderer.et(a.c.toString());
            }
            else {
                return super.aw(a);
            }
        }
        i(a, b) {
            return new WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter(a, b);
        }
        ar(a, b, c, d) {
            d = super.ar(a, b, c, d);
            let e = b.r();
            this.f.l("private" + " _" + CodeGeneratingComponentRenderer.er(d) + ": " + e + " | null = null;");
            this.f.l("public get " + CodeGeneratingComponentRenderer.er(d) + "(): " + e + " {");
            this.f.h();
            this.f.l("if (this._" + CodeGeneratingComponentRenderer.er(d) + " == null)");
            this.f.l("{");
            this.f.h();
            this.f.k(c);
            this.f.l("this._" + CodeGeneratingComponentRenderer.er(d) + " = " + d + ";");
            this.f.f();
            this.f.l("}");
            this.f.l("return this._" + CodeGeneratingComponentRenderer.er(d) + ";");
            this.f.f();
            this.f.l("}");
            return CodeGeneratingComponentRenderer.es(d);
        }
        as(a, b, c, d, e) {
            e = super.as(a, b, c, d, e);
            let f = null;
            if (c.count > 0) {
                f = c._inner[0].r() + "[]";
            }
            else {
                let g = a.b.specificExternalType;
                f = CodeGenerationItemBuilder.o(this.k.platform, g, b, this.al, this.am) + "[]";
            }
            this.f.l("private" + " _" + CodeGeneratingComponentRenderer.er(e) + ": " + f + " | null = null;");
            this.f.l("public get " + CodeGeneratingComponentRenderer.er(e) + "(): " + f + " {");
            this.f.h();
            this.f.l("if (this._" + CodeGeneratingComponentRenderer.er(e) + " == null)");
            this.f.l("{");
            this.f.h();
            this.f.k("let " + CodeGeneratingComponentRenderer.er(e) + ": " + f + " = [];");
            for (let h = 0; h < c.count; h++) {
                this.f.k(d._inner[h]);
                this.f.k(e + ".push(" + c._inner[h].u + ")");
            }
            this.f.l("this._" + CodeGeneratingComponentRenderer.er(e) + " = " + e + ";");
            this.f.f();
            this.f.l("}");
            this.f.l("return this._" + CodeGeneratingComponentRenderer.er(e) + ";");
            this.f.f();
            this.f.l("}");
            return CodeGeneratingComponentRenderer.es(e);
        }
        constructor(a, b) {
            super(a, b);
            this.bv = 0;
            this.bt = new HashSet$1(String_$type, 0);
            this.bu = new HashSet$1(String_$type, 0);
        }
        at(a, b) {
            if (b.c == null) {
                return "null";
            }
            let c = b.c;
            let d = "";
            for (let e = 0; e < c.length; e++) {
                if (e > 0) {
                    d += ", ";
                }
                d += c[e];
            }
            return d;
        }
        get_x() {
            return true;
        }
        bc(a, b, c) {
            super.bc(a, b, c);
            this.h.l("<" + this.bw(a) + "");
            if (!this.bt.contains(this.ap)) {
                this.bt.add_1(this.ap);
                if (!this.bu.contains(this.aq)) {
                    this.bu.add_1(this.aq);
                    this.bb(this.aq);
                }
                this.f.l("private " + CodeGeneratingComponentRenderer.er(this.ap) + ": " + this.aq);
                if (!this.p) {
                    if (this.v) {
                        this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + " = document.querySelector('" + CodeGeneratingComponentRenderer.eu(stringReplace(this.aq, "Component", "")) + "') as " + this.aq + ";");
                    }
                }
                else {
                    this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + " = document.getElementById('" + this.ap + "') as " + this.aq + ";");
                }
            }
        }
        bw(a) {
            if (stringEndsWith(a, "Component")) {
                a = a.substr(0, a.length - ("Component").length);
            }
            return CodeGeneratingComponentRenderer.eu(a);
        }
        bq() {
            this.h.l(">");
            this.h.h();
        }
        bl(a) {
            this.h.f();
            this.h.l("</" + this.bw(a) + ">");
            super.bl(a);
        }
        get_a7() {
            return "Igc";
        }
        bg(a, b, c) {
            super.bg(a, b, c);
            WebImportsHalper.b(this.k, this.a6, this.a5, this.a7, a, b, c);
        }
        bi(a, b, c, d) {
            let e = CodeGeneratingComponentRenderer.er(b);
            if (this.q(d, c)) {
                this.br(c);
                if (!this.bt.contains(this.ap)) {
                    this.bt.add_1(this.ap);
                    if (!this.bu.contains(this.aq)) {
                        this.bu.add_1(this.aq);
                        this.bb(this.aq);
                    }
                    this.f.l("private " + CodeGeneratingComponentRenderer.er(this.ap) + ": " + this.aq);
                    if (!this.p) {
                        if (this.v) {
                            this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + " = document.querySelector('" + CodeGeneratingComponentRenderer.eu(stringReplace(this.aq, "Component", "")) + "') as " + this.aq + ";");
                        }
                    }
                    else {
                        this.g.l("var " + CodeGeneratingComponentRenderer.er(this.ap) + " = this." + CodeGeneratingComponentRenderer.er(this.ap) + " = document.getElementById('" + this.ap + "') as " + this.aq + ";");
                    }
                }
                let f = CodeGeneratingComponentRenderer.er(this.a3(d, c, true));
                let g = f;
                if (g != "null" && !stringStartsWith(g, "this.")) {
                    g = "this." + g;
                }
                if (c.b.isCustomEvent) {
                    this.e.l(CodeGeneratingComponentRenderer.er(this.ap) + ".addEventListener(\"" + e + "\", " + g + ");");
                }
                else {
                    this.e.l(CodeGeneratingComponentRenderer.er(this.ap) + "." + e + " = " + g + ";");
                }
                return;
            }
            if (a > 0) {
                this.h.l("");
            }
            this.h.j(CodeGeneratingComponentRenderer.eu(e));
            this.h.j("=");
            this.h.j("\"");
            this.h.j(this.a3(d, c, true));
            this.h.j("\"");
            if (e == "name") {
                this.h.l("");
                this.h.j("id=\"" + this.a3(d, c, true) + "\"");
            }
        }
        ag(a) {
            let b = a.c;
            switch (b.a) {
                case 3: return b.b;
                case 0: return b.b;
                case 1: return b.b;
                case 2: return b.b;
            }
            return b.b;
        }
        a0() {
            return "null";
        }
        av(a) {
            return CodeGeneratingComponentRenderer.er(a.a.e);
        }
        a1(a) {
            return CodeGeneratingComponentRenderer.er(a.a.e);
        }
        ax(a) {
            if (!stringIsNullOrEmpty(a.a.e)) {
                this.br(a);
                if (!this.bt.contains(a.a.e)) {
                    this.g.l("this." + CodeGeneratingComponentRenderer.er(a.a.e) + " = " + "this." + CodeGeneratingComponentRenderer.er(a.a.e) + ".bind(this);");
                }
                return "this." + CodeGeneratingComponentRenderer.er(a.a.e);
            }
            return this.a0();
        }
        bj(a, b, c, d) {
            if (c.b.knownType == 9) {
                let e = typeCast(IList_$type, c.c);
                if (e != null) {
                    for (let f of fromEn(e)) {
                        if (typeCast(CodeGenerationItemBuilder.$, f) !== null) {
                            let g = f;
                            g.v(this, false);
                        }
                    }
                }
            }
            else {
                if (typeCast(CodeGenerationItemBuilder.$, c.c) !== null) {
                    let h = c.c;
                    h.v(this, false);
                }
            }
        }
    }
    WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter, 'WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter extends WebCodeBehindCodeGeneratingComponentRendererCodeEmitter {
        i(a, b) {
            return new WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter(a, b);
        }
        constructor(a, b) {
            super(a, b);
        }
        get_a7() {
            return "Igc";
        }
        bg(a, b, c) {
            super.bg(a, b, c);
            WebImportsHalper.b(this.k, this.a6, this.a5, this.a7, a, b, c);
        }
    }
    WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter, 'WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter', WebCodeBehindCodeGeneratingComponentRendererCodeEmitter.$);
    return WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let TSCodeGeneratingComponentRendererHandlerEmitter = /*@__PURE__*/ (() => {
    class TSCodeGeneratingComponentRendererHandlerEmitter extends CodeGeneratingComponentRendererHandlerEmitter {
        constructor(a, b, c) {
            super(a, b);
            this.w = 0;
            this.x = new Dictionary$2(String_$type, String_$type, 0);
            this.w = c;
            this.x.item("IgxRowType", "RowType");
            this.x.item("IgxCellType", "CellType");
        }
        t(a, b) {
            super.t(a, b);
            this.g.l("this." + CodeGeneratingComponentRenderer.er(a) + "();");
        }
        u(a, b) {
            super.u(a, b);
            this.h.l("this." + CodeGeneratingComponentRenderer.er(a) + "();");
        }
        get aa() {
            switch (this.w) {
                case 1: return "angular";
                case 2: return "react";
                case 3: return "webcomponents";
            }
            return "";
        }
        get ab() {
            switch (this.w) {
                case 1: return "Igx";
                case 2: return "Igr";
                case 3: return "Igc";
            }
            return "";
        }
        v(a, b) {
            super.v(a, b);
            let c = new CodeGeneratingRegexHelper("import {([^}]+)}\\s+from\\s+['\"]([^'\"]+)['\"]");
            c.execute(b, (d, e, f) => {
                let g = d(1);
                let h = d(2);
                h = stringReplace(h, "webcomponents", this.aa);
                h = stringReplace(h, "react", this.aa);
                h = stringReplace(h, "angular", this.aa);
                if (this.aa == "angular" || this.aa == "react") {
                    if (stringContains(h, "/grids")) {
                        h = stringReplace(h, "/grids", "");
                    }
                }
                if (this.aa == "angular") {
                    if (stringContains(h, "igniteui-angular-grids")) {
                        h = stringReplace(h, "igniteui-angular-grids", "igniteui-angular");
                    }
                }
                let i = g.split(',');
                for (let k = 0; k < i.length; k++) {
                    let j = i[k];
                    let l = j.trim();
                    if (stringStartsWith(l, "Igc")) {
                        l = this.ab + l.substr(3);
                    }
                    if (stringStartsWith(l, "Igr")) {
                        l = this.ab + l.substr(3);
                    }
                    if (stringStartsWith(l, "Igx")) {
                        l = this.ab + l.substr(3);
                    }
                    if (stringStartsWith(l, "Igr") && stringEndsWith(l, "Component")) {
                        l = l.substr(0, l.length - ("Component").length);
                    }
                    if (h.trim() == "igniteui-angular") {
                        if (this.x.containsKey(l.trim())) {
                            l = this.x.item(l.trim());
                        }
                        if (stringStartsWith(l.trim(), "Igx") && stringEndsWith(l.trim(), "EventArgs")) {
                            this.x.item(l.trim(), stringReplace(l, "Igx", "I"));
                            l = stringReplace(l, "Igx", "I");
                        }
                    }
                    a.addPackageImport(h.trim(), l.trim());
                }
                return null;
            });
        }
        get_z() {
            switch (this.n.platform) {
                case 1: return "Component";
                case 2: return "";
                case 3: return "Component";
                case 4: return "";
                case 0: return "";
            }
            return "";
        }
        get z() {
            return this.get_z();
        }
        get_y() {
            switch (this.n.platform) {
                case 1: return "Igx";
                case 2: return "Igr";
                case 3: return "Igc";
                case 4: return "Ultra";
                case 0: return "Xam";
                case 5: return "Igb";
            }
            return "";
        }
        get y() {
            return this.get_y();
        }
        q(a, b) {
            return a;
        }
    }
    TSCodeGeneratingComponentRendererHandlerEmitter.$t = /*@__PURE__*/ markType(TSCodeGeneratingComponentRendererHandlerEmitter, 'TSCodeGeneratingComponentRendererHandlerEmitter', CodeGeneratingComponentRendererHandlerEmitter.$);
    return TSCodeGeneratingComponentRendererHandlerEmitter;
})();
/**
 * @hidden
 */
let TSCodeGeneratingComponentRendererDataEmitter = /*@__PURE__*/ (() => {
    class TSCodeGeneratingComponentRendererDataEmitter extends CodeGeneratingComponentRendererDataEmitter {
        constructor(a, b) {
            super(a, b);
            this.am = new Dictionary$2(CodeGeneratingCodeWriter.$, Number_$type, 0);
        }
        x(a, b = false) {
            a = CodeGeneratingComponentRenderer.es(a);
            a = stringReplace(a, "-", "_");
            if (b) {
                a += "Item";
            }
            return a;
        }
        w(a) {
            a = stringReplace(a, "-", "_");
            if (this.p.g) {
                return a;
            }
            return CodeGeneratingComponentRenderer.er(a);
        }
        aq(a) {
            a = stringReplace(a, "-", "_");
            return "_" + CodeGeneratingComponentRenderer.er(a);
        }
        get_t() {
            return ".ts";
        }
        al(a, b, c, d, e, f) {
            super.al(a, b, c, d, e, f);
            let g = this.s(this.x(b, true), this.x(b, false), c, d);
            for (let h of fromEnum(g)) {
                this.ad(h, e, f);
            }
            let i = 0;
            if (f == this.k) {
                f.addPackageImport("./" + this.x(b, false), this.x(b, false));
            }
            else {
                f.addPackageImport("./" + this.x(b, false), this.x(b, false));
            }
            e.l("export class " + this.x(b, false) + " extends Array<" + this.x(b, true) + "> {");
            e.h();
            e.l("public constructor(items: Array<" + this.x(b, true) + "> | number = -1) {");
            e.h();
            e.l("if (Array.isArray(items)) {");
            e.h();
            e.l("super(...items);");
            e.f();
            e.l("} else {");
            e.h();
            e.l("const newItems = [");
            e.h();
        }
        ah(a, b, c) {
            super.ah(a, b, c);
            let d = this.p.cDNBasePath + this.x(a, false) + ".json";
            let e = "";
            if (this.n.platform == 2) {
                e = "this.setState({}); ";
            }
            if (this.n.platform == 3) {
                e = "if ((this as any)._bind) { (this as any)._bind(); } ";
            }
            if (this.n.platform == 1) {
                e = "this._detector.markForCheck(); ";
            }
            let f = this.x(a, false);
            let g = "null";
            switch (b) {
                case 3:
                case 2:
                    f = "any[]";
                    break;
                case 1:
                    f = "any[]";
                    g = this.x(a, false);
                    break;
                case 0: break;
            }
            this.g.l("private " + this.aq(a) + ": " + f + " = " + g + ";");
            if ((b == 3 || b == 2) || (c != null && c.isAsync)) {
                this.g.l("private _isFetching: boolean = false;");
            }
            this.g.l("public get " + CodeGeneratingComponentRenderer.er(a) + "(): " + f + " {");
            this.g.h();
            if (c != null && c.isAsync) {
                this.g.l("if (this." + this.aq(a) + " == null && !this._isFetching)");
                this.g.l("{");
                this.g.h();
                this.g.l("this._isFetching = true;");
                this.g.l("( async () => { this." + this.aq(a) + " = await (await " + this.x(a, false) + ".fetch()); " + e + " })();");
                this.g.f();
                this.g.l("}");
            }
            else {
                if ((b == 3 || b == 2)) {
                    this.g.l("if (this." + this.aq(a) + " == null && !this._isFetching)");
                    this.g.l("{");
                    this.g.h();
                    this.g.l("this._isFetching = true;");
                    this.g.l("( async () => {");
                    this.g.l("    const url = '" + d + "';");
                    this.g.l("    this." + this.aq(a) + " = await (await fetch(url)).json();");
                    this.g.l("    " + e);
                    this.g.l("})();");
                    this.g.f();
                    this.g.l("}");
                }
                if (b == 0) {
                    this.g.l("if (this." + this.aq(a) + " == null)");
                    this.g.l("{");
                    this.g.h();
                    this.g.l("this." + this.aq(a) + " = new " + this.x(a, false) + "();");
                    this.g.f();
                    this.g.l("}");
                }
            }
            this.g.l("return this." + this.aq(a) + ";");
            this.g.f();
            this.g.l("}");
            this.g.l("");
        }
        ai(a, b) {
            super.ai(a, b);
            this.g.l("private " + this.aq(a) + ": " + this.an(b.e) + " = " + this.ao(b) + ";");
            this.g.l("public get " + CodeGeneratingComponentRenderer.er(a) + "(): " + this.an(b.e) + " {");
            this.g.h();
            this.g.l("return this." + this.aq(a) + ";");
            this.g.f();
            this.g.l("}");
            this.g.l("");
        }
        aj(a, b, c, d) {
            super.aj(a, b, c, d);
            this.g.l("private " + this.aq(a) + ": " + this.x(a, false) + "Item = null;");
            this.g.l("public get " + CodeGeneratingComponentRenderer.er(a) + "(): " + this.x(a, false) + "Item {");
            this.g.h();
            this.g.l("if (this." + this.aq(a) + " == null)");
            this.g.l("{");
            this.g.h();
            this.g.l("this." + this.aq(a) + " = ");
            this.ar(this.x(a, true), b, c, d, this.g);
            this.g.l("}");
            this.g.l("return this." + this.aq(a) + ";");
            this.g.f();
            this.g.l("}");
            this.g.l("");
        }
        z(a, b) {
            b.addPackageImport("./" + a, a);
        }
        aa(a, b, c) {
            c.addDefaultImport("./" + b, a);
        }
        ab(a, b) {
            this.l = CodeGeneratingImportManager.merge(this.l, b);
        }
        ad(a, b, c) {
            let d = 0;
            if (c == this.k) {
                c.addPackageImport("./" + a.c, a.d);
            }
            else {
                c.addPackageImport("./" + a.c, a.d);
            }
            b.l("export class " + a.d + " {");
            b.h();
            b.l("public constructor(init: Partial<" + a.d + ">) {");
            b.h();
            b.l("Object.assign(this, init);");
            b.f();
            b.l("}");
            b.l("");
            for (let e = 0; e < a.a.length; e++) {
                let f = a.a[e];
                let g = a.b[e];
                b.l("public " + this.w(f) + ": " + this.ap(a, f, g) + ";");
            }
            b.f();
            b.l("");
            b.l("}");
        }
        an(a) {
            switch (a) {
                case 1: return "boolean";
                case 0: return "number";
                case 2: return "string";
                case 3: return "any";
            }
            return "any";
        }
        ap(a, b, c) {
            if (c.d) {
                return a.d + "_" + CodeGeneratingComponentRenderer.es(this.w(b)) + "Item[]";
            }
            else if (c.f) {
                return a.d + "_" + TypeDescriptionContext.ab(this.w(b));
            }
            else {
                switch (c.c) {
                    case 1: return "boolean";
                    case 0: return "number";
                    case 2: return "string";
                    case 3: return "any";
                }
            }
            return "any";
        }
        ak(a, b, c, d, e) {
            super.ak(a, b, c, d, e);
            e.f();
            e.l("];");
            e.l("super(...newItems.slice(0));");
            e.f();
            e.l("}");
            e.f();
            e.l("}");
            e.f();
            e.l("}");
        }
        y(a, b, c, d, e, f, g) {
            super.y(a, b, c, d, e, f, g);
            this.ar(this.x(b, true), c, d, e, g);
            g.l(",");
        }
        ar(a, b, c, d, e) {
            if (d == null) {
                e.j("null");
                return;
            }
            if (typeCast(JsonDictionaryArray.$, d) !== null) {
                let f = d;
                e.l("[");
                e.h();
                if (f.items != null && f.items.length > 0) {
                    for (let g = 0; g < f.items.length; g++) {
                        if (g > 0) {
                            e.l(",");
                        }
                        this.ar(a, b, c, f.items[g], e);
                    }
                }
                e.f();
                e.l("]");
            }
            else if (typeCast(JsonDictionaryObject.$, d) !== null) {
                let h = d;
                e.l("new " + a + "(");
                e.l("{");
                e.h();
                let i = true;
                for (let j = 0; j < b.length; j++) {
                    let k = b[j];
                    let l = c[j];
                    if (!h.g(k)) {
                        continue;
                    }
                    if (i) {
                        i = false;
                    }
                    else {
                        e.l(",");
                    }
                    e.j(this.w(k) + ": ");
                    if (l.d) {
                        let m = a + "_" + CodeGeneratingComponentRenderer.es(this.w(k)) + "Item";
                        if (h.g(k)) {
                            this.ar(m, l.a, l.b, h.item(k), e);
                        }
                        else {
                            e.j("[]");
                        }
                    }
                    else if (l.f) {
                        let n = a + "_" + CodeGeneratingComponentRenderer.es(this.w(k));
                        this.ar(n, l.a, l.b, h.item(k), e);
                    }
                    else {
                        let o = h.item(k);
                        e.j(this.u(l, o));
                    }
                }
                e.l("");
                e.f();
                e.j("})");
            }
        }
        u(a, b) {
            if (b.value == null) {
                return ("null");
            }
            switch (a.c) {
                case 1: return (b.value ? "true" : "false");
                case 0: return (b.value.toString());
                case 2: return ("`" + stringReplace(b.value, "`", "\\`") + "`");
                case 3: return ("null");
            }
            return "";
        }
        ao(a) {
            switch (a.e) {
                case 1: return (a.value ? "true" : "false");
                case 0: return (a.value.toString());
                case 2: return ("`" + a.value + "`");
                case 3: return "null";
            }
            return "";
        }
    }
    TSCodeGeneratingComponentRendererDataEmitter.$t = /*@__PURE__*/ markType(TSCodeGeneratingComponentRendererDataEmitter, 'TSCodeGeneratingComponentRendererDataEmitter', CodeGeneratingComponentRendererDataEmitter.$);
    return TSCodeGeneratingComponentRendererDataEmitter;
})();
/**
 * @hidden
 */
let AngularTemplateCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class AngularTemplateCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        get_r() {
            return false;
        }
        get r() {
            return this.get_r();
        }
        ar(a, b, c, d) {
            d = super.ar(a, b, c, d);
            let e = b.r();
            this.f.l("private " + " _" + CodeGeneratingComponentRenderer.er(d) + ": " + e + " | null = null;");
            this.f.l("public get " + CodeGeneratingComponentRenderer.er(d) + "(): " + e + " {");
            this.f.h();
            this.f.l("if (this._" + CodeGeneratingComponentRenderer.er(d) + " == null)");
            this.f.l("{");
            this.f.h();
            this.f.k(c);
            this.f.l("this._" + CodeGeneratingComponentRenderer.er(d) + " = " + d + ";");
            this.f.f();
            this.f.l("}");
            this.f.l("return this._" + CodeGeneratingComponentRenderer.er(d) + ";");
            this.f.f();
            this.f.l("}");
            return CodeGeneratingComponentRenderer.er(d);
        }
        as(a, b, c, d, e) {
            e = super.as(a, b, c, d, e);
            let f = null;
            if (c.count > 0) {
                f = c._inner[0].r() + "[]";
            }
            else {
                let g = a.b.specificExternalType;
                f = CodeGenerationItemBuilder.o(this.k.platform, g, b, this.al, this.am) + "[]";
            }
            this.f.l("private" + " _" + CodeGeneratingComponentRenderer.er(e) + ": " + f + " | null = null;");
            this.f.l("public get " + CodeGeneratingComponentRenderer.er(e) + "(): " + f + " {");
            this.f.h();
            this.f.l("if (this._" + CodeGeneratingComponentRenderer.er(e) + " == null)");
            this.f.l("{");
            this.f.h();
            this.f.k("let " + CodeGeneratingComponentRenderer.er(e) + ": " + f + " = [];");
            for (let h = 0; h < c.count; h++) {
                this.f.k(d._inner[h]);
                this.f.k(e + ".push(" + c._inner[h].u + ")");
            }
            this.f.l("this._" + CodeGeneratingComponentRenderer.er(e) + " = " + e + ";");
            this.f.f();
            this.f.l("}");
            this.f.l("return this._" + CodeGeneratingComponentRenderer.er(e) + ";");
            this.f.f();
            this.f.l("}");
            return CodeGeneratingComponentRenderer.es(e);
        }
        i(a, b) {
            return new AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter(a, b);
        }
        constructor(a, b) {
            super(a, b);
            this.bu = 0;
            this.bs = new HashSet$1(String_$type, 0);
            this.bt = new HashSet$1(String_$type, 0);
        }
        at(a, b) {
            if (b.c == null) {
                return "null";
            }
            let c = b.c;
            let d = "";
            for (let e = 0; e < c.length; e++) {
                if (e > 0) {
                    d += ", ";
                }
                d += c[e];
            }
            return d;
        }
        get_x() {
            return true;
        }
        get_a7() {
            return "Igx";
        }
        bc(a, b, c) {
            super.bc(a, b, c);
            this.h.l("<" + this.bv(a) + "");
            if (!this.bs.contains(this.ap)) {
                this.bs.add_1(this.ap);
                if (!this.bt.contains(this.aq)) {
                    this.bt.add_1(this.aq);
                    this.bb(this.aq);
                }
                this.f.l("@ViewChild(\"" + CodeGeneratingComponentRenderer.er(this.ap) + "\", { static: true } )");
                this.f.l("private " + CodeGeneratingComponentRenderer.er(this.ap) + ": " + this.aq);
            }
        }
        bg(a, b, c) {
            super.bg(a, b, c);
            WebImportsHalper.b(this.k, this.a6, this.a5, this.a7, a, b, c);
        }
        bv(a) {
            if (stringEndsWith(a, "Component")) {
                a = a.substr(0, a.length - ("Component").length);
            }
            return CodeGeneratingComponentRenderer.eu(a);
        }
        bq() {
            this.h.l(">");
            this.h.h();
        }
        bl(a) {
            this.h.f();
            this.h.l("</" + this.bv(a) + ">");
            super.bl(a);
        }
        bi(a, b, c, d) {
            let e = CodeGeneratingComponentRenderer.er(b);
            if (this.q(d, c)) {
                this.br(c);
                if (this.t(c)) {
                    e = "(" + e + ")";
                }
                else {
                    e = "[" + e + "]";
                }
            }
            if (a > 0) {
                this.h.l("");
            }
            this.h.j(e);
            this.h.j("=");
            this.h.j("\"");
            this.h.j(this.a3(d, c, true));
            this.h.j("\"");
            if (e == "name") {
                this.h.l("");
                this.h.j("#" + CodeGeneratingComponentRenderer.er(this.a3(d, c, true)));
            }
        }
        ax(a) {
            if (!stringIsNullOrEmpty(a.a.e)) {
                this.br(a);
                return "this." + CodeGeneratingComponentRenderer.er(a.a.e) + "($event)";
            }
            return this.a0();
        }
        ag(a) {
            let b = a.c;
            switch (b.a) {
                case 3: return b.b;
                case 0: return b.b;
                case 1: return b.b;
                case 2: return b.b;
            }
            return b.b;
        }
        a0() {
            return "null";
        }
        av(a) {
            return CodeGeneratingComponentRenderer.er(a.a.e);
        }
        a1(a) {
            return CodeGeneratingComponentRenderer.er(a.a.e);
        }
        bj(a, b, c, d) {
            if (c.b.knownType == 9) {
                let e = typeCast(IList_$type, c.c);
                if (e != null) {
                    for (let f of fromEn(e)) {
                        if (typeCast(CodeGenerationItemBuilder.$, f) !== null) {
                            let g = f;
                            g.v(this, false);
                        }
                    }
                }
            }
            else {
                if (typeCast(CodeGenerationItemBuilder.$, c.c) !== null) {
                    let h = c.c;
                    h.v(this, false);
                }
            }
        }
    }
    AngularTemplateCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(AngularTemplateCodeGeneratingComponentRendererCodeEmitter, 'AngularTemplateCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return AngularTemplateCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter extends WebCodeBehindCodeGeneratingComponentRendererCodeEmitter {
        get_r() {
            return true;
        }
        i(a, b) {
            return new AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter(a, b);
        }
        constructor(a, b) {
            super(a, b);
        }
        get_a7() {
            return "Igc";
        }
        bg(a, b, c) {
            super.bg(a, b, c);
            WebImportsHalper.b(this.k, this.a6, this.a5, this.a7, a, b, c);
        }
    }
    AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter, 'AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter', WebCodeBehindCodeGeneratingComponentRendererCodeEmitter.$);
    return AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let DotNetCodeGeneratingComponentRendererDataEmitter = /*@__PURE__*/ (() => {
    class DotNetCodeGeneratingComponentRendererDataEmitter extends CodeGeneratingComponentRendererDataEmitter {
        constructor(a, b) {
            super(a, b);
            this.am = false;
        }
        ab(a, b) {
            super.ab(a, b);
            this.f.l("<Compile Include=\"" + a + ".cs\">");
            this.f.h();
            this.f.l("<SubType>Code</SubType>");
            this.f.f();
            this.f.l("</Compile>");
        }
        af(a) {
            a.l("using System;");
            a.l("using System.Collections.Generic;");
            if (!this.am) {
                this.am = true;
            }
            super.af(a);
        }
        ae(a) {
            super.ae(a);
        }
        x(a, b = false) {
            a = CodeGeneratingComponentRenderer.es(a);
            a = stringReplace(a, "-", "_");
            if (b) {
                a += "Item";
            }
            return a;
        }
        w(a) {
            a = stringReplace(a, "-", "_");
            return CodeGeneratingComponentRenderer.es(a);
        }
        aq(a) {
            a = stringReplace(a, "-", "_");
            return "_" + CodeGeneratingComponentRenderer.er(a);
        }
        al(a, b, c, d, e, f) {
            super.al(a, b, c, d, e, f);
            let g = this.s(this.x(b, true), this.x(b, false), c, d);
            for (let h of fromEnum(g)) {
                this.ad(h, e, f);
            }
            e.l("");
            e.l("public class " + this.x(b, false));
            e.h();
            e.l(": List<" + this.x(b, true) + ">");
            e.f();
            e.l("{");
            e.h();
            e.l("public " + this.x(b, false) + "()");
            e.l("{");
            e.h();
        }
        ah(a, b, c) {
            super.ah(a, b, c);
            if (b == 3) {
                let d = this.p.cDNBasePath + this.x(a, false) + ".json";
                this.g.l("public RemoteJSON " + this.w(a));
                this.g.l("{");
                this.g.h();
                this.g.l("get");
                this.g.l("{");
                this.g.h();
                this.g.l("return RemoteJSON.LoadFrom(\"" + d + "\");");
                this.g.f();
                this.g.l("}");
                this.g.l("");
                return;
            }
            let e = this.aq(a) + " = " + "new " + this.x(a, false) + "(); ";
            let f = "";
            if (this.n.platform == 5) {
                f = " StateHasChanged();";
            }
            else {
                f = " OnPropertyChanged(\"" + this.x(a, false) + "\");";
            }
            if (c != null && (b == 2 || c.isAsync)) {
                e = this.x(a, false) + ".Fetch().ContinueWith((t) => {" + this.aq(a) + " = t.Result; " + f + " });";
            }
            this.g.l("private " + this.x(a, false) + " " + this.aq(a) + " = null;");
            this.g.l("public " + this.x(a, false) + " " + this.w(a));
            this.g.l("{");
            this.g.h();
            this.g.l("get");
            this.g.l("{");
            this.g.h();
            this.g.l("if (" + this.aq(a) + " == null)");
            this.g.l("{");
            this.g.h();
            this.g.l(e);
            this.g.f();
            this.g.l("}");
            this.g.l("return " + this.aq(a) + ";");
            this.g.f();
            this.g.l("}");
            this.g.f();
            this.g.l("}");
            this.g.l("");
        }
        ai(a, b) {
            super.ai(a, b);
            this.g.l("private " + this.an(b.e) + " " + this.aq(a) + " = " + this.ao(b) + ";");
            this.g.l("public " + this.an(b.e) + " " + this.w(a));
            this.g.l("{");
            this.g.h();
            this.g.l("get");
            this.g.l("{");
            this.g.h();
            this.g.l("return " + this.aq(a) + ";");
            this.g.f();
            this.g.l("}");
            this.g.f();
            this.g.l("}");
            this.g.l("");
        }
        aj(a, b, c, d) {
            super.aj(a, b, c, d);
            this.g.l("private " + this.x(a, false) + "Item " + this.aq(a) + " = null;");
            this.g.l("public " + this.x(a, false) + "Item " + this.w(a));
            this.g.l("{");
            this.g.h();
            this.g.l("get");
            this.g.l("{");
            this.g.h();
            this.g.l("if (" + this.aq(a) + " == null)");
            this.g.l("{");
            this.g.h();
            this.g.l("_" + a + " = ");
            this.ar(this.x(a, true), b, c, d, this.g);
            this.g.f();
            this.g.l("}");
            this.g.l("return " + this.aq(a) + ";");
            this.g.f();
            this.g.l("}");
            this.g.f();
            this.g.l("}");
            this.g.l("");
        }
        get_t() {
            return ".cs";
        }
        ad(a, b, c) {
            b.l("public class " + a.d);
            b.l("{");
            b.h();
            for (let d = 0; d < a.a.length; d++) {
                let e = a.a[d];
                let f = a.b[d];
                b.l("public " + this.ap(a, e, f) + " " + this.w(e) + " { get; set; }");
            }
            b.f();
            b.l("}");
        }
        an(a) {
            switch (a) {
                case 1: return "bool";
                case 0: return "double";
                case 2: return "string";
                case 3: return "object";
            }
            return "object";
        }
        get_r() {
            return true;
        }
        ap(a, b, c) {
            if (c.d) {
                return "List<" + a.d + "_" + this.w(b) + "Item>";
            }
            else if (c.f) {
                return a.d + "_" + this.w(b);
            }
            else {
                switch (c.c) {
                    case 1: return "bool";
                    case 0: return "double";
                    case 2: return "string";
                    case 3: return "object";
                }
            }
            return "object";
        }
        ak(a, b, c, d, e) {
            super.ak(a, b, c, d, e);
            e.f();
            e.l("}");
            if (a == 2 || a == 3) {
                let f = this.p.cDNBasePath + this.x(b, false) + ".json";
                e.l("public async static System.Threading.Tasks.Task<" + this.x(b, false) + "> Fetch()");
                e.l("{");
                e.h();
                e.l("var url = \"" + f + "\" ;");
                e.l("var client = new System.Net.Http.HttpClient();");
                e.l("var str = await client.GetStringAsync(url);");
                e.l("var arr = System.Text.Json.JsonSerializer.Deserialize<" + this.x(b, false) + ">(str);");
                e.l("return arr;");
                e.f();
                e.l("}");
                e.l("");
            }
            e.f();
            e.l("}");
        }
        y(a, b, c, d, e, f, g) {
            super.y(a, b, c, d, e, f, g);
            if (a == 2 || a == 3) {
                return;
            }
            g.j("this.Add(");
            this.ar(this.x(b, true), c, d, e, g);
            g.l(");");
        }
        ar(a, b, c, d, e) {
            if (d == null) {
                e.j("null");
                return;
            }
            if (typeCast(JsonDictionaryArray.$, d) !== null) {
                let f = d;
                e.l("new List<" + a + ">()");
                e.l("{");
                e.h();
                if (f.items != null && f.items.length > 0) {
                    for (let g = 0; g < f.items.length; g++) {
                        if (g > 0) {
                            e.l(",");
                        }
                        this.ar(a, b, c, f.items[g], e);
                    }
                }
                e.f();
                e.l("}");
            }
            else if (typeCast(JsonDictionaryObject.$, d) !== null) {
                let h = d;
                e.l("new " + a + "()");
                e.l("{");
                e.h();
                for (let i = 0; i < b.length; i++) {
                    let j = b[i];
                    let k = c[i];
                    if (!h.g(j)) {
                        continue;
                    }
                    if (i > 0) {
                        e.l(",");
                    }
                    e.j(j + " = ");
                    if (k.d) {
                        let l = a + "_" + this.w(j) + "Item";
                        this.ar(l, k.a, k.b, h.item(j), e);
                    }
                    else if (k.f) {
                        let m = a + "_" + this.w(j);
                        this.ar(m, k.a, k.b, h.item(j), e);
                    }
                    else {
                        let n = h.item(j);
                        try {
                            e.j(this.u(k, n));
                        }
                        catch (o) {
                            let p = getInstanceType(n.value).typeName;
                            let q = stringReplace(EnumUtil.getName(JsonDictionaryValueType_$type, k.c), "Value", "");
                            let r = "'" + j + "' property (" + n.value + ") is '" + p + "' instead of '" + q + "' type.";
                            throw new BaseError(1, "Failed on creating '" + a + "' because " + r + "\n" + o.message);
                        }
                    }
                }
                e.l("");
                e.f();
                e.j("}");
            }
        }
        u(a, b) {
            switch (a.c) {
                case 1: return (b.value ? "true" : "false");
                case 0:
                    if (b == null || b.value == null) {
                        return "double.NaN";
                    }
                    return (b.value.toString());
                case 2: if (b.value == null) {
                    return "null";
                }
                else {
                    return ("@\"" + stringReplace(b.value, "\"", "\"\"") + "\"");
                }
                case 3: return ("null");
            }
            return "";
        }
        ao(a) {
            switch (a.e) {
                case 1: return (a.value ? "true" : "false");
                case 0: return (a.value.toString());
                case 2: return ("@\"" + stringReplace(a.value, "\"", "\"\"") + "\"");
                case 3: return "null";
            }
            return "";
        }
    }
    DotNetCodeGeneratingComponentRendererDataEmitter.$t = /*@__PURE__*/ markType(DotNetCodeGeneratingComponentRendererDataEmitter, 'DotNetCodeGeneratingComponentRendererDataEmitter', CodeGeneratingComponentRendererDataEmitter.$);
    return DotNetCodeGeneratingComponentRendererDataEmitter;
})();
/**
 * @hidden
 */
let WPFXamlCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class WPFXamlCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        a9(a) {
            if (a == null || isNaN_(a)) {
                return "";
            }
            return timeSpanFromMilliseconds(a).toString();
        }
        get_r() {
            return false;
        }
        get r() {
            return this.get_r();
        }
        i(a, b) {
            return new WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter(a, b);
        }
        get_y() {
            return false;
        }
        constructor(a, b) {
            super(a, b);
        }
        at(a, b) {
            if (b.c == null) {
                return "null";
            }
            let c = b.c;
            let d = "";
            for (let e = 0; e < c.length; e++) {
                if (e > 0) {
                    d += ", ";
                }
                d += c[e];
            }
            return d;
        }
        bc(a, b, c) {
            super.bc(a, b, c);
            this.h.l("<ig:" + a + "");
        }
        bq() {
            this.h.l(">");
            this.h.h();
        }
        bl(a) {
            this.h.f();
            this.h.l("</ig:" + a + ">");
            super.bl(a);
        }
        bi(a, b, c, d) {
            if (b == "Label" && c.b != null && stringContains(c.b.owningType, "Axis")) {
                if (c.c != null && stringContains(c.c, "{")) {
                    if (a > 0) {
                        this.h.l("");
                    }
                    this.h.j(b);
                    this.h.j("=");
                    this.h.j("\"");
                    this.h.j("{}" + this.a3(d, c, true));
                    this.h.j("\"");
                    return;
                }
            }
            if (a > 0) {
                this.h.l("");
            }
            this.h.j(b);
            this.h.j("=");
            this.h.j("\"");
            this.h.j(this.a3(d, c, true));
            this.h.j("\"");
        }
        ag(a) {
            let b = a.c;
            switch (b.a) {
                case 3: return b.b;
                case 0: return b.b;
                case 1: return b.b;
                case 2: return b.b;
            }
            return b.b;
        }
        a0() {
            return "{x:Null}";
        }
        av(a) {
            return "{Binding ElementName=" + a.a.e + "}";
        }
        bs(a) {
            a = stringReplace(a, "-", "_");
            return CodeGeneratingComponentRenderer.es(a);
        }
        a1(a) {
            this.br(a);
            return "{Binding " + this.bs(a.a.e) + "}";
        }
        bj(a, b, c, d) {
            this.h.j("<ig:");
            {
                this.h.j(this.aq);
                this.h.j(".");
            }
            this.h.j(b);
            this.h.l(">");
            this.h.h();
            if (c.b.knownType == 9) {
                let e = typeCast(IList_$type, c.c);
                if (e != null) {
                    for (let f of fromEn(e)) {
                        if (typeCast(CodeGenerationItemBuilder.$, f) !== null) {
                            let g = f;
                            g.v(this, false);
                        }
                    }
                }
            }
            else {
                if (typeCast(CodeGenerationItemBuilder.$, c.c) !== null) {
                    let h = c.c;
                    h.v(this, false);
                }
            }
            this.h.f();
            this.h.j("</ig:");
            {
                this.h.j(this.aq);
                this.h.j(".");
            }
            this.h.j(b);
            this.h.l(">");
        }
        get_a7() {
            return "Xam";
        }
    }
    WPFXamlCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(WPFXamlCodeGeneratingComponentRendererCodeEmitter, 'WPFXamlCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return WPFXamlCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        a9(a) {
            if (a == null || isNaN_(a)) {
                return "";
            }
            return "TimeSpan.FromMilliseconds(" + a + ")";
        }
        get_r() {
            return true;
        }
        get r() {
            return this.get_r();
        }
        i(a, b) {
            return new WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter(a, b);
        }
        get_y() {
            return false;
        }
        constructor(a, b) {
            super(a, b);
        }
    }
    WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter, 'WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let CodeGeneratingComponentRenderer = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRenderer extends ComponentRenderer {
        loadCodeJson(a) {
            this.loadJson(a, (b) => ((() => {
                let $ret = new CodeGenerationContainer();
                $ret.id = b;
                return $ret;
            })()));
        }
        dg(a) {
            this.ej.c = a;
        }
        o() {
            return false;
        }
        static er(a) {
            if (a == null) {
                return null;
            }
            if (a.length == 1) {
                return a.toLowerCase();
            }
            return a.substr(0, 1).toLowerCase() + a.substr(1);
        }
        static et(a) {
            if (a == null) {
                return null;
            }
            if (a.length == 1) {
                return a.toLowerCase();
            }
            if (Base.equalsStatic(a.toUpperCase(), a)) {
                return a;
            }
            return a.substr(0, 1).toLowerCase() + a.substr(1);
        }
        static es(a) {
            if (a == null) {
                return null;
            }
            if (a.length == 1) {
                return a.toUpperCase();
            }
            return a.substr(0, 1).toUpperCase() + a.substr(1);
        }
        static eu(a) {
            if (a == null) {
                return null;
            }
            let b = new List$1(String_$type, 0);
            let c = 0;
            for (let d = 0; d < a.length; d++) {
                let e = a.charAt(d);
                let f = e.toUpperCase();
                let g = e.toLowerCase();
                let h = (c == 0 && b.count > 0);
                let i = (c > 1);
                if (f == e) {
                    if (h) {
                        b.add('-');
                    }
                    c++;
                }
                else if (g == e) {
                    if (i) {
                        b.insert(b.count - 1, '-');
                    }
                    c = 0;
                }
                else {
                    c = 0;
                }
                b.add(g);
            }
            let j = new StringBuilder(0);
            for (let k = 0; k < b.count; k++) {
                j.h(b._inner[k]);
            }
            return j.toString();
        }
        ar() {
            return true;
        }
        br(a) {
            let b = a.g;
            return b == null ? { $type: Point_$type, x: NaN, y: NaN } : { $type: Point_$type, x: b.x, y: b.y };
        }
        bs(a) {
            let b = a.g;
            return b == null ? Rect.empty : new Rect(0, b.left, b.top, b.width, b.height);
        }
        bt(a) {
            let b = a.g;
            return b == null ? new Size(1, NaN, NaN) : new Size(1, b.width, b.height);
        }
        bv(a) {
            let b = a.g;
            if (typeof b === 'number') {
                return typeGetValue(b);
            }
            if (typeof b === 'number') {
                return b;
            }
            if (typeof b === 'string') {
                return parseFloat(b);
            }
            return NaN;
        }
        cm(a) {
            if (a == null) {
                return null;
            }
            return Brush.create(a);
        }
        cn(a) {
            if (a == null) {
                return null;
            }
            return Brush.create(a).color;
        }
        ae(a) {
            super.ae(a);
            this.en = a;
            return true;
        }
        al(a) {
            super.al(a);
            this.ep = a;
            return true;
        }
        af(a) {
            super.af(a);
            this.el = a;
            return true;
        }
        ag(a) {
            super.ag(a);
            this.em = a;
            return true;
        }
        ah(a) {
            super.ah(a);
            this.eo = a;
            return true;
        }
        ed(a, b, c) {
            switch (this.ek) {
                case 1: if (b.forceCodeBehind) {
                    return new AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                else {
                    return new AngularTemplateCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                case 2: if (b.forceCodeBehind) {
                    return new ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                else {
                    return new ReactMarkupCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                case 3: if (b.forceCodeBehind) {
                    return new WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                else {
                    return new WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                case 4: break;
                case 0: if (b.forceCodeBehind) {
                    return new WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                else {
                    return new WPFXamlCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                case 5: if (b.forceCodeBehind) {
                    return new BlazorCodeBehindCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                else {
                    return new BlazorRazorCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
            }
            return null;
        }
        ee(a, b) {
            switch (this.ek) {
                case 1: return new TSCodeGeneratingComponentRendererDataEmitter(a, b);
                case 2: return new TSCodeGeneratingComponentRendererDataEmitter(a, b);
                case 3: return new TSCodeGeneratingComponentRendererDataEmitter(a, b);
                case 4: break;
                case 0:
                case 5: return new DotNetCodeGeneratingComponentRendererDataEmitter(a, b);
            }
            return null;
        }
        ef(a, b) {
            switch (this.ek) {
                case 1: return new TSCodeGeneratingComponentRendererHandlerEmitter(a, b, this.ek);
                case 2: return new TSCodeGeneratingComponentRendererHandlerEmitter(a, b, this.ek);
                case 3: return new TSCodeGeneratingComponentRendererHandlerEmitter(a, b, this.ek);
                case 4: break;
                case 0:
                case 5: return new DotNetCodeGeneratingComponentRendererHandlerEmitter(a, b);
            }
            return null;
        }
        eh(a, b) {
            switch (this.ek) {
                case 1: return new TSCodeGeneratingComponentRendererTemplateEmitter(a, b, this.ek);
                case 2: return new TSCodeGeneratingComponentRendererTemplateEmitter(a, b, this.ek);
                case 3: return new TSCodeGeneratingComponentRendererTemplateEmitter(a, b, this.ek);
                case 4: break;
                case 0:
                case 5: return new DotNetCodeGeneratingComponentRendererTemplateEmitter(a, b);
            }
            return null;
        }
        eg(a, b) {
            switch (this.ek) {
                case 1: return new TSCodeGeneratingComponentRendererModuleEmitter(this.ek, a, b);
                case 2: return new TSCodeGeneratingComponentRendererModuleEmitter(this.ek, a, b);
                case 3: return new TSCodeGeneratingComponentRendererModuleEmitter(this.ek, a, b);
                case 4: break;
                case 0: return new DotNetCodeGeneratingComponentRendererModuleEmitter(this.ek, a, b);
                case 5: return new BlazorCodeGeneratingComponentRendererModuleEmitter(this.ek, a, b);
            }
            return null;
        }
        markRefUsed(a) {
            for (let b of fromEnum(this.a8.keys)) {
                let c = b;
                c.markRefUsed(a);
            }
        }
        emitCode(a) {
            let b = new CodeGeneratingRendererResult();
            b.platform = this.ek;
            b.generationOptions = this.ej;
            for (let c of fromEnum(this.a8.keys)) {
                let d = c;
                let e = d.id;
                for (let f of fromEnum(d.b)) {
                    if (f.j("Name") != null) {
                        b.trackDescriptionField(e, f.j("Name"));
                    }
                    if (f.j("name") != null) {
                        b.trackDescriptionField(e, f.j("name"));
                    }
                }
            }
            for (let g of fromEnum(this.a8.keys)) {
                let h = g;
                h.d(this.context, b, this, this.ej);
            }
            if (this.en != null) {
                let i = this.eg(this.ej, b);
                i.n(this.en, this.context);
            }
            if (this.ep != null) {
                if (typeCast(JsonDictionaryObject.$, this.ep) !== null) {
                    let j = this.ep;
                    let m = j.e();
                    for (let l = 0; l < m.length; l++) {
                        let k = m[l];
                        b.defineString(k, j.item(k).value);
                    }
                }
            }
            {
                let n = this.ee(this.ej, b);
                n.ac(this.eo);
            }
            let o = this.ef(this.ej, b);
            let p = new List$1(String_$type, 0);
            let q = new List$1(String_$type, 0);
            if (this.el != null) {
                if (typeCast(JsonDictionaryArray.$, this.el) !== null) {
                    let r = this.el;
                    if (r.items != null) {
                        let u = r.items;
                        for (let t = 0; t < u.length; t++) {
                            let s = u[t];
                            p.add(s.value.toString());
                        }
                    }
                }
                else if (typeCast(JsonDictionaryValue.$, this.el) !== null) {
                    let v = this.el;
                    p.add(v.value.toString());
                }
            }
            if (this.em != null) {
                if (typeCast(JsonDictionaryArray.$, this.em) !== null) {
                    let w = this.em;
                    if (w.items != null) {
                        let z = w.items;
                        for (let y = 0; y < z.length; y++) {
                            let x = z[y];
                            q.add(x.value.toString());
                        }
                    }
                }
                else if (typeCast(JsonDictionaryValue.$, this.em) !== null) {
                    let aa = this.em;
                    q.add(aa.value.toString());
                }
            }
            o.s(p.toArray(), q.toArray());
            let ab = this.eh(this.ej, b);
            ab.r();
            this.ez(b, a);
            return b;
        }
        ez(a, b) {
            b.execute(a);
        }
        be() {
            return runOn(this, this.ew);
        }
        ev(a) {
            a = stringReplace(a, "-", "_");
            if (!this.ej.g) {
                switch (this.ek) {
                    case 1:
                    case 2:
                    case 3: return CodeGeneratingComponentRenderer.er(a);
                    case 4:
                    case 0:
                    case 5: return CodeGeneratingComponentRenderer.es(a);
                }
            }
            return a;
        }
        ew(a) {
            let b = a;
            if (stringStartsWith(a, "{")) {
                if (!stringStartsWith(a, "{[")) {
                    a = a.substr(1, a.length - 2);
                    a = "{" + this.ev(a) + "}";
                    b = a;
                }
            }
            else {
                b = this.ev(a);
            }
            return b;
        }
        constructor(a, b) {
            super();
            this.ej = null;
            this.ek = 0;
            this.en = null;
            this.eo = null;
            this.ep = null;
            this.em = null;
            this.el = null;
            this.ej = b;
            this.ek = a;
            this.preserveKeyOrder = true;
            ComponentRenderer.platform = CodeGeneratingComponentRenderer.eq(a);
            this.adapter = new CodeGenerationRendererAdapter(a, this.adapter);
            if (b.reusedContext != null) {
                this.context = b.reusedContext;
            }
            else {
                this.context = new TypeDescriptionContext(this.adapter, ComponentRenderer.platform);
            }
            this.j = new CodeGenerationTransformer(a);
        }
        static eq(a) {
            switch (a) {
                case 1: return 3;
                case 2: return 2;
                case 3: return 4;
                case 4: return 8;
                case 0: return 0;
                case 5: return 12;
            }
            return 0;
        }
    }
    CodeGeneratingComponentRenderer.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRenderer, 'CodeGeneratingComponentRenderer', ComponentRenderer.$);
    return CodeGeneratingComponentRenderer;
})();
/**
 * @hidden
 */
let CodeGenerationContainer = /*@__PURE__*/ (() => {
    class CodeGenerationContainer extends Base {
        get id() {
            return this._id;
        }
        set id(a) {
            this._id = a;
        }
        constructor() {
            super();
            this._id = null;
            this.b = null;
            this.a = new HashSet$1(String_$type, 0);
            this.b = new List$1(CodeGenerationItemBuilder.$, 0);
        }
        d(a, b, c, d) {
            let e = new StringBuilder(0);
            let f = new StringBuilder(0);
            let g = new StringBuilder(0);
            let h = new CodeGeneratingImportManager();
            for (let i of fromEnum(this.a)) {
                if (!c.hasRef(i)) {
                    c.e(i);
                }
                b.af(((() => {
                    let $ret = new CodeGenerationItemBuilderPropertyInfo();
                    $ret.a = c.f(i);
                    return $ret;
                })()));
            }
            for (let j of fromEnum(this.b)) {
                let k = c.ed(j, d, b);
                j.v(k, true);
                let l = k.toString();
                b.addContainerResult(this.id, l);
                k.be(e);
                k.bh(f);
                k.bd(g);
                k.bf(a, h);
            }
            b.addContainerResult("bindingFields", e.toString());
            b.addContainerResult("bindingInit", f.toString());
            b.addContainerResult("bindingCode", g.toString());
            b.addImportResult("bindingImports", h);
        }
        markRefUsed(a) {
            this.a.add_1(a);
        }
    }
    CodeGenerationContainer.$t = /*@__PURE__*/ markType(CodeGenerationContainer, 'CodeGenerationContainer');
    return CodeGenerationContainer;
})();
/**
 * @hidden
 */
let CodeGenerationItemBuilder = /*@__PURE__*/ (() => {
    class CodeGenerationItemBuilder extends Base {
        p() {
            let a = this;
            let b = null;
            if (a.j("Name") != null) {
                b = a.j("Name");
            }
            if (a.j("name") != null) {
                b = a.j("name");
            }
            if (b != null) {
                return b;
            }
            return null;
        }
        constructor(a, b, c, d) {
            super();
            this.h = new List$1(String_$type, 0);
            this.g = new Dictionary$2(String_$type, CodeGenerationItemBuilderPropertyInfo.$, 0);
            this.c = null;
            this.b = 0;
            this.k = null;
            this.i = null;
            this.u = null;
            this.b = a;
            this.k = b;
            this.c = c;
            this.i = d;
        }
        a(a) {
            let b = this.c.getMetadata(this.k, a);
            return new CodeGenerationItemBuilder(this.b, this.s(b), this.c, this.i);
        }
        s(a) {
            return a.specificExternalType != null ? a.specificExternalType : a.specificType;
        }
        y(a, b, c, d) {
            if (!this.g.containsKey(a)) {
                this.h.add(a);
            }
            ;
            this.g.item(a, ((() => {
                let $ret = new CodeGenerationItemBuilderPropertyInfo();
                $ret.b = b;
                $ret.c = c;
                $ret.a = d;
                return $ret;
            })()));
        }
        w(a, b, c) {
            let d = null;
            if (!this.g.containsKey(a)) {
                this.h.add(a);
            }
            ;
            if (this.g.containsKey(a)) {
                let e = this.g.item(a);
                d = e.c;
            }
            this.g.item(a, ((() => {
                let $ret = new CodeGenerationItemBuilderPropertyInfo();
                $ret.b = b;
                $ret.c = d;
                $ret.a = c;
                return $ret;
            })()));
        }
        x(a, b) {
            if (this.g.containsKey(a)) {
                this.g.removeItem(a);
            }
        }
        j(a) {
            if (this.g.containsKey(a)) {
                return this.g.item(a).c;
            }
            return null;
        }
        v(a, b) {
            let c = this.n();
            if (b) {
                let d = this.q();
                a.a5 = d;
            }
            let e = false;
            let f = false;
            if (this.g.containsKey("Name")) {
                e = true;
                a.bp(this.g.item("Name").c);
            }
            else if (this.g.containsKey("name")) {
                e = true;
                a.bp(this.g.item("name").c);
            }
            else {
                if (b && this.u != null) {
                    e = true;
                    a.bp(this.u);
                }
                else if (this.f(this.c, a)) {
                    f = true;
                    a.bo(c);
                    if (a.y) {
                        this.h.add("name");
                        this.g.addItem("name", ((() => {
                            let $ret = new CodeGenerationItemBuilderPropertyInfo();
                            $ret.c = a.ap;
                            return $ret;
                        })()));
                    }
                    else {
                        this.h.add("Name");
                        this.g.addItem("Name", ((() => {
                            let $ret = new CodeGenerationItemBuilderPropertyInfo();
                            $ret.c = a.ap;
                            return $ret;
                        })()));
                    }
                }
            }
            a.bc(this.r(), this.k, this.c);
            let g = 0;
            for (let h of fromEnum(this.h)) {
                let i = this.g.item(h);
                if (i.b == null && h.toLowerCase() == "type") {
                    continue;
                }
                if (this.e(a, h, i)) {
                    a.bi(g, h, i, this.c);
                    g++;
                }
            }
            a.bq();
            let j = 0;
            for (let k of fromEnum(this.h)) {
                let l = this.g.item(k);
                if (l.b == null && k.toLowerCase() == "type") {
                    continue;
                }
                if (!this.e(a, k, l)) {
                    a.bj(j, k, l, this.c);
                    j++;
                }
            }
            a.bk(j);
            a.bl(c);
            if (e) {
                a.bn();
            }
            else {
                if (f) {
                    a.bm();
                }
            }
        }
        f(a, b) {
            if (b.n) {
                return true;
            }
            for (let c of fromEnum(this.h)) {
                let d = this.g.item(c);
                if (b.q(a, d)) {
                    return true;
                }
            }
            return false;
        }
        d(a) {
            let b = typeCast(Array_$type, a.c);
            for (let c of b) {
                if (typeCast(CodeGenerationItemBuilder.$, c) !== null) {
                    return false;
                }
            }
            return true;
        }
        e(a, b, c) {
            if (c.b == null) {
                if (b.toLowerCase() == "name") {
                    return true;
                }
            }
            switch (c.b.knownType) {
                case 10: return a.r ? this.d(c) : true;
                case 7: return true;
                case 4: return c.c == null || !(typeCast(LinearGradientBrush.$, c.c) !== null);
                case 6:
                    return true;
                    break;
                case 23: return true;
                case 9:
                    if (a.w(this.c, c)) {
                        return true;
                    }
                    return false;
                case 5: return true;
                case 16: return true;
                case 20: return true;
                case 22: return true;
                case 15: return false;
                case 3: return true;
                case 19: return true;
                case 8:
                    if (a.w(this.c, c)) {
                        return true;
                    }
                    if (c.b.specificExternalType == "string") {
                        return true;
                    }
                    if (c.a != null) {
                        return true;
                    }
                    return false;
                case 13: return false;
                case 18: return true;
                case 1: return true;
                case 11: return true;
                case 14: return true;
                case 12: return true;
                case 2: return true;
                case 21: return true;
                case 17: return true;
                case 0: return false;
            }
            return false;
        }
        r() {
            return this.n();
        }
        get t() {
            return this.k;
        }
        static o(a, b, c, d, e) {
            if (a == 0 || a == 4) {
                let f = c.getMetadata(b, "_qualifiedName");
                if (f != null) {
                    let g = f.specificExternalType;
                    let h = g.lastIndexOf('.');
                    if (h >= 0) {
                        return g.substr(h + 1);
                    }
                    else {
                        return g;
                    }
                }
                return b;
            }
            else if ((a == 5 || a == 2 || a == 1 || a == 3) && c.getMetadata(b, "__qualifiedNameTS") != null) {
                let i = c.getMetadata(b, "__qualifiedNameTS");
                if (c.getMetadata(b, "__skipSuffix") != null) {
                    return d + i.specificExternalType;
                }
                return d + i.specificExternalType + e;
            }
            else {
                if (c.getMetadata(b, "__skipSuffix") != null) {
                    return d + b;
                }
                return d + b + e;
            }
        }
        n() {
            return CodeGenerationItemBuilder.o(this.b, this.k, this.c, this.l, this.m);
        }
        q() {
            let a = this.c.getMetadata(this.k, "_qualifiedName");
            if (a != null) {
                let b = a.specificExternalType;
                let c = b.split('.');
                if (c.length > 2) {
                    return c[c.length - 2].toLowerCase();
                }
            }
            if (this.b == 1 || this.b == 3 || this.b == 2 || this.b == 5) {
                a = this.c.getMetadata(this.k, "__packageNameWC");
                if (a != null) {
                    let d = a.specificExternalType;
                    return d;
                }
            }
            if (this.k == "Legend" || this.k == "ItemLegend") {
                return "charts";
            }
            return "core";
        }
        get_l() {
            switch (this.b) {
                case 1: return "Igx";
                case 2: return "Igr";
                case 3: return "Igc";
                case 4: return "Ultra";
                case 0: return "Xam";
                case 5: return "Igb";
            }
            return "";
        }
        get l() {
            return this.get_l();
        }
        get_m() {
            switch (this.b) {
                case 1: return "Component";
                case 2: return "";
                case 3: return "Component";
                case 4: return "";
                case 0: return "";
            }
            return "";
        }
        get m() {
            return this.get_m();
        }
    }
    CodeGenerationItemBuilder.$t = /*@__PURE__*/ markType(CodeGenerationItemBuilder, 'CodeGenerationItemBuilder');
    return CodeGenerationItemBuilder;
})();
/**
 * @hidden
 */
let CodeGenerationRendererAdapter = /*@__PURE__*/ (() => {
    class CodeGenerationRendererAdapter extends Base {
        constructor(a, b) {
            super();
            this.a = 0;
            this.b = null;
            this.b = b;
            this.a = a;
        }
        createColorCollection(a) {
            let b = new List$1(Base.$, 0);
            for (let c = 0; c < a.length; c++) {
                b.add1(a[c]);
            }
            return b;
        }
        createBrushCollection(a) {
            let b = new List$1(Base.$, 0);
            for (let c = 0; c < a.length; c++) {
                b.add1(a[c]);
            }
            return b;
        }
        createDoubleCollection(a) {
            let b = new List$1(Base.$, 0);
            for (let c = 0; c < a.length; c++) {
                b.add1(a[c]);
            }
            return b.toArray();
        }
        createObject(a, b, c, d) {
            let e = new CodeGenerationItemBuilder(this.a, a, c, b);
            return e;
        }
        coerceToEnum(a, b, c) {
            return c;
        }
        onUIThread(a, b) {
            b();
        }
        setOrUpdateCollectionOnTarget(a, b, c, d, e, f) {
            let g = this.getPropertyValue(e, b);
            if (g == null) {
                let h = new List$1(Base.$, 0);
                let i = f;
                for (let j = 0; j < i.count; j++) {
                    h.add1(i.item(j));
                }
                this.setPropertyValue(e, b, c, h, null, null);
            }
            else {
                let k = f;
                let l = g;
                l.clear();
                for (let m = 0; m < k.count; m++) {
                    l.add(k.item(m));
                }
            }
        }
        c(a) {
            if (a == null) {
                return false;
            }
            return false;
        }
        onPendingRef(a, b, c, d) {
            let e = a;
            e.w(b, c, d);
        }
        setPropertyValue(a, b, c, d, e, f) {
            if (!(typeCast(CodeGenerationItemBuilder.$, a) !== null)) {
                this.b.setPropertyValue(a, b, c, d, e, f);
                return;
            }
            while (stringContains(b, ".")) {
                let g = b.split('.');
                let h = this.getPropertyValue(a, g[0]);
                if (h != null && !this.c(h)) {
                    b = "";
                    for (let i = 1; i < g.length; i++) {
                        if (i > 1) {
                            b += ".";
                        }
                        b += g[i];
                    }
                    a = h;
                }
                else {
                    let j = a;
                    let k = j.a(g[0]);
                    h = k;
                    this.setPropertyValue(a, g[0], c, h, null, f);
                    b = "";
                    for (let l = 1; l < g.length; l++) {
                        if (l > 1) {
                            b += ".";
                        }
                        b += g[l];
                    }
                    a = h;
                }
            }
            let m = a;
            m.y(b, c, d, f);
        }
        getPropertyValue(a, b) {
            while (stringContains(b, ".")) {
                let c = b.split('.');
                let d = this.getPropertyValue(a, c[0]);
                if (d != null) {
                    b = "";
                    for (let e = 1; e < c.length; e++) {
                        if (e > 1) {
                            b += ".";
                        }
                        b += c[e];
                    }
                    a = d;
                }
                else {
                    let f = a;
                    let g = f.a(c[0]);
                    d = g;
                    for (let h = 1; h < c.length; h++) {
                        if (h > 1) {
                            b += ".";
                        }
                        b += c[h];
                    }
                    a = d;
                }
            }
            let i = a;
            return i.j(b);
        }
        getRootObject(a) {
            let b = a;
            let c = b.b.count > 0 ? b.b._inner[0] : null;
            return c;
        }
        clearContainer(a, b, c) {
            let d = a;
            let e = d.b.count > 0 ? d.b._inner[0] : null;
            d.b.clear();
            c(false);
        }
        forPropertyValueItem(a, b, c) {
            let d = this.getPropertyValue(a, b);
            if (typeCast(IList_$type, d) !== null) {
                let e = d;
                for (let f = 0; f < e.count; f++) {
                    c(e.item(f));
                }
            }
            else if (typeCast(Array_$type, d) !== null) {
                let g = d;
                for (let h = 0; h < g.length; h++) {
                    c(g[h]);
                }
            }
        }
        clearCollection(a, b, c) {
            let d = this.getPropertyValue(a, b);
            if (typeCast(IList_$type, d) !== null) {
                d.clear();
            }
            else if (typeCast(Array_$type, d) !== null) {
                this.setPropertyValue(a, b, c, null, d, null);
            }
        }
        addItemToCollection(a, b, c, d, e) {
            let f = this.getPropertyValue(c, a);
            if (typeCast(IList_$type, f) !== null) {
                f.insert(d, e);
            }
            else if (typeCast(Array_$type, f) !== null) {
                let g = f;
                let h = new List$1(Base.$, 0);
                for (let i = 0; i < g.count; i++) {
                    h.add1(g.item(i));
                }
                h.insert1(d, e);
                let j = [g.count + 1];
                for (let k = 0; k < j.length; k++) {
                    j[k] = h._inner[k];
                }
                this.setPropertyValue(c, a, b, j, f, null);
            }
        }
        resetPropertyOnTarget(a, b, c, d) {
            while (stringContains(b, ".")) {
                let e = b.split('.');
                let f = this.getPropertyValue(d, e[0]);
                if (f != null && !this.c(f)) {
                    b = "";
                    for (let g = 1; g < e.length; g++) {
                        if (g > 1) {
                            b += ".";
                        }
                        b += e[g];
                    }
                    d = f;
                }
                else {
                    let h = d;
                    let i = h.a(e[0]);
                    f = i;
                    this.setPropertyValue(d, e[0], c, f, null, null);
                    b = "";
                    for (let j = 1; j < e.length; j++) {
                        if (j > 1) {
                            b += ".";
                        }
                        b += e[j];
                    }
                    d = f;
                }
            }
            let k = d;
            k.x(b, c);
        }
        replaceItemInCollection(a, b, c, d, e) {
            let f = this.getPropertyValue(c, a);
            if (typeCast(IList_$type, f) !== null) {
                f.item(d, e);
            }
            else if (typeCast(Array_$type, f) !== null) {
                let g = f;
                let h = new List$1(Base.$, 0);
                for (let i = 0; i < g.count; i++) {
                    h.add1(g.item(i));
                }
                h._inner[d] = e;
                let j = [g.count + 1];
                for (let k = 0; k < j.length; k++) {
                    j[k] = h._inner[k];
                }
                this.setPropertyValue(c, a, b, j, f, null);
            }
        }
        replaceRootItem(a, b, c, d) {
            let e = this.createObject(b, a, c, null);
            let f = a;
            let g = f.b.count > 0 ? f.b._inner[0] : null;
            f.b.clear();
            {
                f.b.add(e);
            }
            d(false);
        }
        removeItemFromCollection(a, b, c, d) {
            let e = this.getPropertyValue(c, a);
            if (typeCast(IList_$type, e) !== null) {
                e.removeAt(d);
            }
            else if (typeCast(Array_$type, e) !== null) {
                let f = e;
                let g = new List$1(Base.$, 0);
                for (let h = 0; h < f.count; h++) {
                    g.add1(f.item(h));
                }
                g.removeAt(d);
                let i = [f.count - 1];
                for (let j = 0; j < i.length; j++) {
                    i[j] = g._inner[j];
                }
                this.setPropertyValue(c, a, b, i, e, null);
            }
        }
        removeRootItem(a, b, c) {
            let d = a;
            let e = d.b.count > 0 ? d.b._inner[0] : null;
            d.b.clear();
            c(false);
        }
        flushChanges(a) {
        }
        executeMethod(a, b, c, d, e) {
        }
        serializeBrush(a) {
            return null;
        }
        serializeColor(a) {
            return null;
        }
        serializeBrushCollection(a) {
            return null;
        }
        serializePoint(a) {
            return null;
        }
        serializeSize(a) {
            return null;
        }
        serializeRect(a) {
            return null;
        }
        serializeColorCollection(a) {
            return null;
        }
        serializeTimespan(a) {
            return null;
        }
        serializeDoubleCollection(a) {
            return null;
        }
    }
    CodeGenerationRendererAdapter.$t = /*@__PURE__*/ markType(CodeGenerationRendererAdapter, 'CodeGenerationRendererAdapter', Base.$, [IComponentRendererAdapter_$type]);
    return CodeGenerationRendererAdapter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var CodeGenerationLibraryItemType = /*@__PURE__*/ (function (CodeGenerationLibraryItemType) {
    CodeGenerationLibraryItemType[CodeGenerationLibraryItemType["Data"] = 0] = "Data";
    CodeGenerationLibraryItemType[CodeGenerationLibraryItemType["EventHandler"] = 1] = "EventHandler";
    CodeGenerationLibraryItemType[CodeGenerationLibraryItemType["Template"] = 2] = "Template";
    CodeGenerationLibraryItemType[CodeGenerationLibraryItemType["Unknown"] = 3] = "Unknown";
    return CodeGenerationLibraryItemType;
})({});
/**
 * @hidden
 */
let CodeGenerationLibraryItemType_$type = /*@__PURE__*/ markEnum('CodeGenerationLibraryItemType', 'Data,0|EventHandler,1|Template,2|Unknown,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var CodeGenerationLibraryItemPlatform = /*@__PURE__*/ (function (CodeGenerationLibraryItemPlatform) {
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["Angular"] = 0] = "Angular";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["React"] = 1] = "React";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["WebComponents"] = 2] = "WebComponents";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["JQuery"] = 3] = "JQuery";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["WPF"] = 4] = "WPF";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["WindowsForms"] = 5] = "WindowsForms";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["Web"] = 6] = "Web";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["AllWeb"] = 7] = "AllWeb";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["Desktop"] = 8] = "Desktop";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["Win"] = 9] = "Win";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["XPlat"] = 10] = "XPlat";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["All"] = 11] = "All";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["Unknown"] = 12] = "Unknown";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["DotNet"] = 13] = "DotNet";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["Blazor"] = 14] = "Blazor";
    return CodeGenerationLibraryItemPlatform;
})({});
/**
 * @hidden
 */
let CodeGenerationLibraryItemPlatform_$type = /*@__PURE__*/ markEnum('CodeGenerationLibraryItemPlatform', 'Angular,0|React,1|WebComponents,2|JQuery,3|WPF,4|WindowsForms,5|Web,6|AllWeb,7|Desktop,8|Win,9|XPlat,10|All,11|Unknown,12|DotNet,13|Blazor,14');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var CodeGenerationLibraryItemContentLocation = /*@__PURE__*/ (function (CodeGenerationLibraryItemContentLocation) {
    CodeGenerationLibraryItemContentLocation[CodeGenerationLibraryItemContentLocation["Code"] = 0] = "Code";
    CodeGenerationLibraryItemContentLocation[CodeGenerationLibraryItemContentLocation["JsonFile"] = 1] = "JsonFile";
    CodeGenerationLibraryItemContentLocation[CodeGenerationLibraryItemContentLocation["CDN"] = 2] = "CDN";
    CodeGenerationLibraryItemContentLocation[CodeGenerationLibraryItemContentLocation["CDNSkipHydrate"] = 3] = "CDNSkipHydrate";
    return CodeGenerationLibraryItemContentLocation;
})({});
/**
 * @hidden
 */
let CodeGenerationLibraryItemContentLocation_$type = /*@__PURE__*/ markEnum('CodeGenerationLibraryItemContentLocation', 'Code,0|JsonFile,1|CDN,2|CDNSkipHydrate,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationLibraryItemContentConfiguration = /*@__PURE__*/ (() => {
    class CodeGenerationLibraryItemContentConfiguration extends Base {
        constructor() {
            super(...arguments);
            this._platform = 0;
            this._location = 0;
        }
        get platform() {
            return this._platform;
        }
        set platform(a) {
            this._platform = a;
        }
        get location() {
            return this._location;
        }
        set location(a) {
            this._location = a;
        }
        static a(a) {
            let b = typeCast(JsonDictionaryObject.$, a);
            if (b == null) {
                return null;
            }
            let c = new CodeGenerationLibraryItemContentConfiguration();
            c.platform = 10;
            if (b.g("platform")) {
                let d = b.item("platform");
                c.platform = CodeGenerationLibraryItemContent.c(d);
            }
            c.location = 0;
            if (b.g("location")) {
                let e = b.item("location");
                c.location = CodeGenerationLibraryItemContentConfiguration.c(e);
            }
            return c;
        }
        static c(a) {
            let b = a.value;
            let c;
            if (((() => { let d = EnumUtil.tryParse$1(CodeGenerationLibraryItemContentLocation_$type, b, true, c); c = d.p2; return d.ret; })())) {
                return c;
            }
            return 0;
        }
        e() {
            let a = new JsonDictionaryObject();
            a.item("platform", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = EnumUtil.getName(CodeGenerationLibraryItemPlatform_$type, this.platform);
                return $ret;
            })()));
            a.item("location", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = EnumUtil.getName(CodeGenerationLibraryItemContentLocation_$type, this.location);
                return $ret;
            })()));
            return a;
        }
    }
    CodeGenerationLibraryItemContentConfiguration.$t = /*@__PURE__*/ markType(CodeGenerationLibraryItemContentConfiguration, 'CodeGenerationLibraryItemContentConfiguration');
    return CodeGenerationLibraryItemContentConfiguration;
})();
/**
 * @hidden
 */
let CodeGenerationLibraryItemContent = /*@__PURE__*/ (() => {
    class CodeGenerationLibraryItemContent extends Base {
        constructor() {
            super(...arguments);
            this._platform = 0;
            this._content = null;
            this._isJson = false;
            this._isAsync = false;
            this._isJSContent = false;
            this._configs = null;
        }
        get platform() {
            return this._platform;
        }
        set platform(a) {
            this._platform = a;
        }
        get content() {
            return this._content;
        }
        set content(a) {
            this._content = a;
        }
        get isJson() {
            return this._isJson;
        }
        set isJson(a) {
            this._isJson = a;
        }
        get isAsync() {
            return this._isAsync;
        }
        set isAsync(a) {
            this._isAsync = a;
        }
        get isJSContent() {
            return this._isJSContent;
        }
        set isJSContent(a) {
            this._isJSContent = a;
        }
        get configs() {
            return this._configs;
        }
        set configs(a) {
            this._configs = a;
        }
        static b(a) {
            let b = new CodeGenerationLibraryItemContent();
            if (typeCast(JsonDictionaryObject.$, a) !== null) {
                let c = a;
                if (c.g("platform")) {
                    let d = c.item("platform");
                    b.platform = CodeGenerationLibraryItemContent.c(d);
                }
                if (c.g("content")) {
                    let e = c.item("content");
                    b.content = e.value;
                }
                if (c.g("isJson")) {
                    let f = c.item("isJson");
                    b.isJson = f.value;
                }
                if (c.g("isJSContent")) {
                    let g = c.item("isJSContent");
                    b.isJSContent = g.value;
                }
                if (c.g("isAsync")) {
                    let h = c.item("isAsync");
                    b.isAsync = h.value;
                }
                if (c.g("configs")) {
                    let i = c.item("configs");
                    if (i != null && i.items != null && i.items.length > 0) {
                        let j = new Array(i.items.length);
                        for (let k = 0; k < i.items.length; k++) {
                            let l = i.items[k];
                            if (l != null) {
                                let m = CodeGenerationLibraryItemContentConfiguration.a(l);
                                j[k] = m;
                            }
                        }
                        b.configs = j;
                    }
                }
            }
            return b;
        }
        e() {
            let a = new JsonDictionaryObject();
            a.item("platform", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = EnumUtil.getName(CodeGenerationLibraryItemPlatform_$type, this.platform);
                return $ret;
            })()));
            a.item("content", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = this.content;
                return $ret;
            })()));
            a.item("isJson", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 1;
                $ret.value = this.isJson;
                return $ret;
            })()));
            a.item("isJSContent", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 1;
                $ret.value = this.isJSContent;
                return $ret;
            })()));
            a.item("isAsync", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 1;
                $ret.value = this.isAsync;
                return $ret;
            })()));
            if (this.configs != null && this.configs.length > 0) {
                a.item("configs", new JsonDictionaryArray());
                let b = new Array(this.configs.length);
                for (let c = 0; c < this.configs.length; c++) {
                    let d = this.configs[c].e();
                    b[c] = d;
                }
                a.item("configs").items = b;
            }
            return a;
        }
        static c(a) {
            let b = a.value;
            let c;
            if (((() => { let d = EnumUtil.tryParse$1(CodeGenerationLibraryItemPlatform_$type, b, true, c); c = d.p2; return d.ret; })())) {
                return c;
            }
            return 12;
        }
    }
    CodeGenerationLibraryItemContent.$t = /*@__PURE__*/ markType(CodeGenerationLibraryItemContent, 'CodeGenerationLibraryItemContent');
    return CodeGenerationLibraryItemContent;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationLibraryItem = /*@__PURE__*/ (() => {
    class CodeGenerationLibraryItem extends Base {
        constructor() {
            super(...arguments);
            this._name = null;
            this._type = 0;
            this.m = new Dictionary$2(CodeGenerationLibraryItemPlatform_$type, CodeGenerationLibraryItemContent.$, 0);
            this.n = new List$1(CodeGenerationLibraryItemContent.$, 0);
        }
        get name() {
            return this._name;
        }
        set name(a) {
            this._name = a;
        }
        get type() {
            return this._type;
        }
        set type(a) {
            this._type = a;
        }
        getContentForPlatformString(a) {
            let b;
            b = EnumUtil.getEnumValue(CodeGenerationTargetPlatforms_$type, EnumUtil.parse(CodeGenerationTargetPlatforms_$type, a, true));
            return this.getContentForPlatform(b);
        }
        getConfigForPlatformString(a) {
            let b;
            b = EnumUtil.getEnumValue(CodeGenerationTargetPlatforms_$type, EnumUtil.parse(CodeGenerationTargetPlatforms_$type, a, true));
            return this.getConfigForPlatform(b);
        }
        getContentForPlatform(a) {
            for (let b of fromEnum(this.n)) {
                if (this.l(b, a)) {
                    return b;
                }
            }
            return null;
        }
        getConfigForPlatform(a) {
            let b = this.getContentForPlatform(a);
            if (b == null) {
                return null;
            }
            if (b.configs != null) {
                let e = b.configs;
                for (let d = 0; d < e.length; d++) {
                    let c = e[d];
                    if (this.j(c, a)) {
                        return c;
                    }
                }
            }
            return null;
        }
        j(a, b) {
            return this.k(a.platform, b);
        }
        l(a, b) {
            return this.k(a.platform, b);
        }
        k(a, b) {
            switch (a) {
                case 11: return true;
                case 7: return b == 1 || b == 2 || b == 3 || b == 5;
                case 0: return b == 1;
                case 8: return b == 0 || b == 4;
                case 13: return b == 0 || b == 4 || b == 5;
                case 3: return false;
                case 1: return b == 2;
                case 12: return false;
                case 6: return b == 1 || b == 2 || b == 3;
                case 2: return b == 3;
                case 9: return b == 0 || b == 4;
                case 5: return b == 4;
                case 4: return b == 0;
                case 14: return b == 5;
                case 10: return true;
            }
            return false;
        }
        addPlatformContent(a, b) {
            if (b == null) {
                return;
            }
            this.m.item(a, b);
            b.platform = a;
            this.n.add(b);
        }
        b(a) {
            if (a == null) {
                return null;
            }
            return ((() => {
                let $ret = new CodeGenerationLibraryItemContent();
                $ret.content = a;
                return $ret;
            })());
        }
        e(a) {
            if (a == null) {
                return null;
            }
            return ((() => {
                let $ret = new CodeGenerationLibraryItemContent();
                $ret.content = a;
                $ret.isJson = true;
                return $ret;
            })());
        }
        static a(a) {
            let b = new CodeGenerationLibraryItem();
            if (typeCast(JsonDictionaryObject.$, a) !== null) {
                let c = a;
                if (c.g("name")) {
                    b.name = c.item("name").value.toString();
                }
                if (c.g("type")) {
                    let d = c.item("type").value.toString();
                    let e = 3;
                    let f = EnumUtil.tryParse$1(CodeGenerationLibraryItemType_$type, d, true, e);
                    e = f.p2;
                    b.type = e;
                }
                if (c.g("content")) {
                    let g = c.item("content");
                    if (typeCast(JsonDictionaryArray.$, g) !== null) {
                        let h = g;
                        if (h.items != null && h.items.length > 0) {
                            for (let i = 0; i < h.items.length; i++) {
                                let j = CodeGenerationLibraryItemContent.b(h.items[i]);
                                b.n.add(j);
                                b.m.addItem(j.platform, j);
                            }
                        }
                    }
                }
            }
            return b;
        }
        i() {
            let a = new JsonDictionaryObject();
            a.item("name", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = this.name;
                return $ret;
            })()));
            let b = new JsonDictionaryArray();
            a.item("content", b);
            a.item("type", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = EnumUtil.getName(CodeGenerationLibraryItemType_$type, this.type);
                return $ret;
            })()));
            let c = new List$1(JsonDictionaryItem.$, 0);
            for (let d of fromEnum(this.n)) {
                let e = d.e();
                c.add(e);
            }
            b.items = c.toArray();
            return a;
        }
    }
    CodeGenerationLibraryItem.$t = /*@__PURE__*/ markType(CodeGenerationLibraryItem, 'CodeGenerationLibraryItem');
    return CodeGenerationLibraryItem;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationLibrary = /*@__PURE__*/ (() => {
    class CodeGenerationLibrary extends Base {
        constructor() {
            super(...arguments);
            this.f = new List$1(CodeGenerationLibraryItem.$, 0);
            this.e = new Dictionary$2(String_$type, CodeGenerationLibraryItem.$, 0);
        }
        static fromJson(a) {
            let b = new JsonDictionaryParser();
            let c = b.parse(a);
            let d = new CodeGenerationLibrary();
            if (typeCast(JsonDictionaryObject.$, c) !== null) {
                let e = c;
                if (e.g("items")) {
                    let f = typeCast(JsonDictionaryArray.$, e.item("items"));
                    if (f != null) {
                        let i = f.items;
                        for (let h = 0; h < i.length; h++) {
                            let g = i[h];
                            let j = CodeGenerationLibraryItem.a(g);
                            d.f.add(j);
                            d.e.addItem(j.name, j);
                        }
                    }
                }
            }
            return d;
        }
        toJson() {
            let a = new JsonDictionaryObject();
            let b = new JsonDictionaryArray();
            a.item("items", b);
            let c = new List$1(JsonDictionaryItem.$, 0);
            for (let d of fromEnum(this.f)) {
                let e = d.i();
                c.add(e);
            }
            b.items = c.toArray();
            return a.b();
        }
        hasItem(a) {
            return this.e.containsKey(a);
        }
        getKeys() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.e.keys)) {
                a.add(b);
            }
            return a.toArray();
        }
        getItem(a) {
            return this.e.item(a);
        }
    }
    CodeGenerationLibrary.$t = /*@__PURE__*/ markType(CodeGenerationLibrary, 'CodeGenerationLibrary');
    return CodeGenerationLibrary;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ICodeGenerationRendererTemplate_$type = /*@__PURE__*/ new Type(null, 'ICodeGenerationRendererTemplate');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Tuple$3 = /*@__PURE__*/ (() => {
    class Tuple$3 extends Base {
        constructor($t1, $t2, $t3, a, b, c) {
            super();
            this.$t1 = null;
            this.$t2 = null;
            this.$t3 = null;
            this.c = null;
            this.d = null;
            this.e = null;
            this.$t1 = $t1;
            this.$t2 = $t2;
            this.$t3 = $t3;
            this.$type = this.$type.specialize(this.$t1, this.$t2, this.$t3);
            this.c = a;
            this.d = b;
            this.e = c;
        }
        equals(a) {
            let b = typeCast(Tuple$3.$.specialize(this.$t1, this.$t2, this.$t3), a);
            return b != null && Base.equalsStatic(getBoxIfEnum(this.$t1, this.c), getBoxIfEnum(this.$t1, b.c)) && Base.equalsStatic(getBoxIfEnum(this.$t2, this.d), getBoxIfEnum(this.$t2, b.d)) && Base.equalsStatic(getBoxIfEnum(this.$t3, this.e), getBoxIfEnum(this.$t3, b.e));
        }
        getHashCode() {
            let a = 0;
            if (getBoxIfEnum(this.$t1, this.c) != null) {
                a = Base.getHashCodeStatic(this.c);
            }
            if (getBoxIfEnum(this.$t2, this.d) != null) {
                a = a ^ Base.getHashCodeStatic(this.d) << 8;
            }
            if (getBoxIfEnum(this.$t3, this.e) != null) {
                a = a ^ Base.getHashCodeStatic(this.e) << 16;
            }
            return a;
        }
    }
    Tuple$3.$t = /*@__PURE__*/ markType(Tuple$3, 'Tuple$3');
    return Tuple$3;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationFolderTemplate = /*@__PURE__*/ (() => {
    class CodeGenerationFolderTemplate extends Base {
        constructor() {
            super(...arguments);
            this.e = new List$1(String_$type, 0);
            this.c = new List$1(String_$type, 0);
            this.d = new List$1(String_$type, 0);
        }
        addFile(a, b) {
            this.e.add(a);
            this.c.add(b);
        }
        getFilePaths() {
            return this.e.toArray();
        }
        getFileOuutput(a) {
            for (let b = 0; b < this.e.count; b++) {
                if (this.e._inner[b] == a) {
                    return this.d._inner[b];
                }
            }
            return null;
        }
        b(a, b) {
            if (a == null) {
                return false;
            }
            let c = stringReplace(a, "\r\n", "\n").split('\n');
            for (let e = 0; e < c.length; e++) {
                let d = c[e];
                let f = !stringStartsWith(d.trim(), "import") && !stringStartsWith(d.trim(), "@using") && !stringStartsWith(d.trim(), "@inject") && !stringStartsWith(d.trim(), "using");
                if (d.trim().length > 0 && (b || f)) {
                    return true;
                }
            }
            return false;
        }
        saveTemplateToJson() {
            let a = new JsonDictionaryObject();
            let b = new JsonDictionaryArray();
            let c = new List$1(JsonDictionaryItem.$, 0);
            for (let d = 0; d < this.e.count; d++) {
                let e = new JsonDictionaryObject();
                let f = ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = this.e._inner[d];
                    return $ret;
                })());
                let g = ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = this.c._inner[d];
                    return $ret;
                })());
                e.item("path", f);
                e.item("content", g);
                c.add(e);
            }
            b.items = c.toArray();
            a.item("files", b);
            return a.b();
        }
        loadTemplateFromJson(a) {
            let b = new JsonDictionaryParser();
            let c = b.parse(a);
            if (typeCast(JsonDictionaryObject.$, c) !== null) {
                let d = c;
                if (d.g("files")) {
                    let e = d.item("Files");
                    if (typeCast(JsonDictionaryArray.$, e) !== null) {
                        let f = e;
                        for (let g = 0; g < f.items.length; g++) {
                            let h = f.items[g];
                            if (typeCast(JsonDictionaryObject.$, h) !== null) {
                                let i = h;
                                if (i.g("path") && i.g("content")) {
                                    this.e.add(i.item("path").value.toString());
                                    this.c.add(i.item("content").value.toString());
                                }
                            }
                        }
                    }
                }
            }
        }
        execute(a) {
            this.d.clear();
            for (let b = 0; b < this.c.count; b++) {
                this.d.add(this.c._inner[b]);
            }
            let c = a.getKeys();
            let d = new HashSet$1(String_$type, 0);
            for (let e = 0; e < c.length; e++) {
                if (this.b(a.getContentForKey(c[e]), true)) {
                    d.add_1(c[e]);
                }
            }
            let f = a.getImportsKeys();
            for (let g = 0; g < f.length; g++) {
                d.add_1(f[g]);
            }
            let h = a.getStringNames();
            for (let i = 0; i < h.length; i++) {
                d.add_1(h[i]);
            }
            let j = a.getPackages();
            for (let k = 0; k < j.length; k++) {
                d.add_1(j[k]);
            }
            for (let l = 0; l < this.c.count; l++) {
                let m = this.d._inner[l];
                m = this.i(m, d);
                this.d._inner[l] = m;
            }
            for (let n = 0; n < this.c.count; n++) {
                let o = new List$1(String_$type, 0);
                let r = a.getImportsKeys();
                for (let q = 0; q < r.length; q++) {
                    let p = r[q];
                    o.add(p);
                }
                let s = this.d._inner[n];
                let t = this.e._inner[n];
                s = this.k(t, s, o.toArray(), a);
                this.d._inner[n] = s;
            }
            let w = a.getKeys();
            for (let v = 0; v < w.length; v++) {
                let u = w[v];
                for (let x = 0; x < this.c.count; x++) {
                    let y = this.d._inner[x];
                    let z = a.getContentForKey(u);
                    y = this.j(y, u, z, a);
                    this.d._inner[x] = y;
                }
            }
            let ac = a.getStringNames();
            for (let ab = 0; ab < ac.length; ab++) {
                let aa = ac[ab];
                for (let ad = 0; ad < this.c.count; ad++) {
                    let ae = this.d._inner[ad];
                    ae = stringReplace(ae, "$$" + aa, a.getString(aa));
                    this.d._inner[ad] = ae;
                }
            }
            for (let af of fromEnum(a.getNewFiles())) {
                let ag = a.getNewFileContent(af);
                let ah = "";
                for (let ai of fromEnum(this.e)) {
                    if (stringStartsWith(ai, "src")) {
                        ah = "src/";
                    }
                }
                this.e.add(ah + af);
                this.d.add(ag);
            }
        }
        i(a, b) {
            return a;
        }
        k(a, b, c, d) {
            let e = new List$1(Tuple$3.$.specialize(Number_$type, String_$type, CodeGeneratingImportManager.$), 0);
            for (let g = 0; g < c.length; g++) {
                let f = c[g];
                let h = new CodeGeneratingRegexHelper("(?:(<!--)|(\\/\\/))\\s*insert " + f + "(?:(\\s*-->)?)[\\w\\W\\r\\n]*?(?:(<!--)|(\\/\\/))\\s*end " + f + "(?:(\\s*-->)?)((\\r\\n)|(\\n))");
                b = h.execute(b, (i, j, k) => {
                    let l = d.r(f);
                    let m = new CodeGeneratingImportManager();
                    for (let n of fromEnum(l)) {
                        m = CodeGeneratingImportManager.merge(m, n);
                    }
                    e.add(new Tuple$3(Number_$type, String_$type, CodeGeneratingImportManager.$, j, f, m));
                    return null;
                });
            }
            e.aa((i, j) => Base.compareSimple(i.c, j.c));
            let i = new CodeGeneratingImportManager();
            for (let j of fromEnum(e)) {
                let k = j.d;
                let l = j.e;
                let m = l.removeDuplicates(i);
                i = CodeGeneratingImportManager.merge(i, l);
                let n = new CodeGeneratingRegexHelper("(?:(<!--)|(\\/\\/))\\s*insert " + k + "(?:(\\s*-->)?)[\\w\\W\\r\\n]*?(?:(<!--)|(\\/\\/))\\s*end " + k + "(?:(\\s*-->)?)((\\r\\n)|(\\n))");
                b = n.execute(b, (o, p, q) => {
                    let r = this.h(a, m, d);
                    if (r != null && r.length > 0) {
                        r = this.f(r, b, p, d);
                    }
                    return r;
                });
            }
            return b;
        }
        f(a, b, c, d) {
            let e = c;
            let f = 0;
            let g = 0;
            let h = "";
            while (e > 0) {
                if (b.charAt(e) == ' ') {
                    h += ' ';
                }
                if (b.charAt(e) == '\t') {
                    h += '\t';
                }
                if (b.charAt(e) == '\n') {
                    break;
                }
                e--;
            }
            let i = new StringBuilder(0);
            let j = stringReplace(a, "\r\n", "\n").split('\n');
            for (let k = 0; k < j.length; k++) {
                if (k == j.length - 1 && j[k].length == 0) {
                    continue;
                }
                let l = j[k];
                if (k > 0) {
                    i.l(h);
                }
                i.u(l);
            }
            return i.toString();
        }
        h(a, b, c) {
            if (b.hasPackageImports) {
                return b.packageImportsToString();
            }
            else {
                let d = false;
                if (stringEndsWith(a, ".razor")) {
                    d = true;
                }
                return b.usingsToString(d);
            }
        }
        j(a, b, c, d) {
            let e = new CodeGeneratingRegexHelper("(?:(<!--)|(\\/\\/))\\s*insert " + b + "(?:(\\s*-->)?)[\\w\\W\\r\\n]*?(?:(<!--)|(\\/\\/))\\s*end " + b + "(?:(\\s*-->)?)((\\r\\n)|(\\n))");
            a = e.execute(a, (f, g, h) => {
                if (c != null && c.length > 0) {
                    c = this.f(c, a, g, d);
                }
                return c;
            });
            return a;
        }
    }
    CodeGenerationFolderTemplate.$t = /*@__PURE__*/ markType(CodeGenerationFolderTemplate, 'CodeGenerationFolderTemplate', Base.$, [ICodeGenerationRendererTemplate_$type]);
    return CodeGenerationFolderTemplate;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationRendererOptions = /*@__PURE__*/ (() => {
    class CodeGenerationRendererOptions extends Base {
        constructor() {
            super();
            this._forceHelperLookups = false;
            this._skipAlterDataCasing = false;
            this.c = false;
            this._reusedContext = null;
            this._generateFullProject = false;
            this._forceCodeBehind = false;
            this._library = null;
            this._cDNBasePath = null;
            this._useSpacesForIndent = false;
            this._indentSpaces = 0;
            this.useSpacesForIndent = true;
            this.indentSpaces = 4;
            this.cDNBasePath = "https://static.infragistics.com/xplatform/cdn/";
        }
        get forceHelperLookups() {
            return this._forceHelperLookups;
        }
        set forceHelperLookups(a) {
            this._forceHelperLookups = a;
        }
        get skipAlterDataCasing() {
            return this._skipAlterDataCasing;
        }
        set skipAlterDataCasing(a) {
            this._skipAlterDataCasing = a;
        }
        get reusedContext() {
            return this._reusedContext;
        }
        set reusedContext(a) {
            this._reusedContext = a;
        }
        get g() {
            return this.skipAlterDataCasing || this.c;
        }
        get generateFullProject() {
            return this._generateFullProject;
        }
        set generateFullProject(a) {
            this._generateFullProject = a;
        }
        get forceCodeBehind() {
            return this._forceCodeBehind;
        }
        set forceCodeBehind(a) {
            this._forceCodeBehind = a;
        }
        get library() {
            return this._library;
        }
        set library(a) {
            this._library = a;
        }
        get cDNBasePath() {
            return this._cDNBasePath;
        }
        set cDNBasePath(a) {
            this._cDNBasePath = a;
        }
        get useSpacesForIndent() {
            return this._useSpacesForIndent;
        }
        set useSpacesForIndent(a) {
            this._useSpacesForIndent = a;
        }
        get indentSpaces() {
            return this._indentSpaces;
        }
        set indentSpaces(a) {
            this._indentSpaces = a;
        }
    }
    CodeGenerationRendererOptions.$t = /*@__PURE__*/ markType(CodeGenerationRendererOptions, 'CodeGenerationRendererOptions');
    return CodeGenerationRendererOptions;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationSpecialValueType_$type = /*@__PURE__*/ markEnum('CodeGenerationSpecialValueType', 'FontFamily,0|FontStyles,1|FontWeights,2|Color,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ComponentRendererMethodHelperBuilder = /*@__PURE__*/ (() => {
    class ComponentRendererMethodHelperBuilder extends Base {
        constructor(a, b) {
            super();
            this.e = null;
            this.f = null;
            this.d = new List$1(ComponentRendererMethodHelperArgumentBuilder.$, 0);
            this.b = null;
            this.e = a;
            this.f = b;
        }
        argument() {
            let a = new ComponentRendererMethodHelperArgumentBuilder(this);
            this.d.add(a);
            return a;
        }
        $return() {
            let a = new ComponentRendererMethodHelperReturnBuilder(this);
            this.b = a;
            return a;
        }
        build() {
            let a = new JsonDictionaryObject();
            let b = new JsonDictionaryArray();
            a.item("args", b);
            let c = new Array(this.d.count);
            let d = 0;
            for (let e of fromEnum(this.d)) {
                c[d] = e.y();
                d++;
            }
            b.items = c;
            if (this.f != null) {
                a.item("targetRef", ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = this.f;
                    return $ret;
                })()));
            }
            a.item("methodName", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = this.e;
                return $ret;
            })()));
            if (this.b == null) {
                this.$return().asVoid();
            }
            a.item("return", this.b.x());
            return a.b();
        }
    }
    ComponentRendererMethodHelperBuilder.$t = /*@__PURE__*/ markType(ComponentRendererMethodHelperBuilder, 'ComponentRendererMethodHelperBuilder');
    return ComponentRendererMethodHelperBuilder;
})();
/**
 * @hidden
 */
let ComponentRendererMethodHelperArgumentBuilder = /*@__PURE__*/ (() => {
    class ComponentRendererMethodHelperArgumentBuilder extends Base {
        constructor(a) {
            super();
            this.v = null;
            this.z = 0;
            this.ac = null;
            this.ab = null;
            this.aa = null;
            this.x = null;
            this.v = a;
        }
        argument() {
            return this.v.argument();
        }
        $return() {
            return this.v.$return();
        }
        build() {
            return this.v.build();
        }
        asInt(a) {
            this.z = 1;
            this.ac = null;
            this.ab = "int";
            this.x = ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = a;
                return $ret;
            })());
            return this;
        }
        asIntArray(a) {
            this.z = 10;
            this.ac = null;
            this.ab = "int";
            if (a == null) {
                this.x = ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 3;
                    $ret.value = null;
                    return $ret;
                })());
            }
            else {
                let b = new JsonDictionaryArray();
                b.items = new Array(a.length);
                for (let c = 0; c < a.length; c++) {
                    b.items[c] = ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 0;
                        $ret.value = a[c];
                        return $ret;
                    })());
                }
                this.x = b;
            }
            return this;
        }
        asDouble(a) {
            this.z = 1;
            this.ac = null;
            this.ab = "double";
            this.x = ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = a;
                return $ret;
            })());
            return this;
        }
        asDoubleArray(a) {
            this.z = 10;
            this.ac = null;
            this.ab = "double";
            if (a == null) {
                this.x = ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 3;
                    $ret.value = null;
                    return $ret;
                })());
            }
            else {
                let b = new JsonDictionaryArray();
                b.items = new Array(a.length);
                for (let c = 0; c < a.length; c++) {
                    b.items[c] = ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 0;
                        $ret.value = a[c];
                        return $ret;
                    })());
                }
                this.x = b;
            }
            return this;
        }
        asShort(a) {
            this.z = 1;
            this.ac = null;
            this.ab = "short";
            this.x = ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = a;
                return $ret;
            })());
            return this;
        }
        asShortArray(a) {
            this.z = 10;
            this.ac = null;
            this.ab = "short";
            if (a == null) {
                this.x = ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 3;
                    $ret.value = null;
                    return $ret;
                })());
            }
            else {
                let b = new JsonDictionaryArray();
                b.items = new Array(a.length);
                for (let c = 0; c < a.length; c++) {
                    b.items[c] = ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 0;
                        $ret.value = a[c];
                        return $ret;
                    })());
                }
                this.x = b;
            }
            return this;
        }
        asLong(a) {
            this.z = 1;
            this.ac = null;
            this.ab = "long";
            this.x = ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = a;
                return $ret;
            })());
            return this;
        }
        asLongArray(a) {
            this.z = 10;
            this.ac = null;
            this.ab = "long";
            if (a == null) {
                this.x = ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 3;
                    $ret.value = null;
                    return $ret;
                })());
            }
            else {
                let b = new JsonDictionaryArray();
                b.items = new Array(a.length);
                for (let c = 0; c < a.length; c++) {
                    b.items[c] = ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 0;
                        $ret.value = a[c];
                        return $ret;
                    })());
                }
                this.x = b;
            }
            return this;
        }
        asFloat(a) {
            this.z = 1;
            this.ac = null;
            this.ab = "float";
            this.x = ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = a;
                return $ret;
            })());
            return this;
        }
        asFloatArray(a) {
            this.z = 10;
            this.ac = null;
            this.ab = "float";
            if (a == null) {
                this.x = ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 3;
                    $ret.value = null;
                    return $ret;
                })());
            }
            else {
                let b = new JsonDictionaryArray();
                b.items = new Array(a.length);
                for (let c = 0; c < a.length; c++) {
                    b.items[c] = ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 0;
                        $ret.value = a[c];
                        return $ret;
                    })());
                }
                this.x = b;
            }
            return this;
        }
        asEnum(a, b) {
            this.z = 8;
            this.ac = a.typeName;
            this.ab = "string";
            if (b == null) {
                this.x = ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 3;
                    $ret.value = null;
                    return $ret;
                })());
            }
            else {
                this.x = ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = b.toString();
                    return $ret;
                })());
            }
            return this;
        }
        asString(a) {
            this.z = 2;
            this.ac = null;
            this.ab = "string";
            if (a == null) {
                this.x = ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 3;
                    $ret.value = null;
                    return $ret;
                })());
            }
            else {
                this.x = ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = a;
                    return $ret;
                })());
            }
            return this;
        }
        asStringArray(a) {
            this.z = 10;
            this.ac = null;
            this.ab = "string";
            if (a == null) {
                this.x = ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 3;
                    $ret.value = null;
                    return $ret;
                })());
            }
            else {
                let b = new JsonDictionaryArray();
                b.items = new Array(a.length);
                for (let c = 0; c < a.length; c++) {
                    b.items[c] = ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 2;
                        $ret.value = a[c];
                        return $ret;
                    })());
                }
                this.x = b;
            }
            return this;
        }
        asPublicTypeRef(a, b) {
            this.z = 8;
            this.ac = a;
            this.ab = a;
            if (b == null) {
                this.x = ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 3;
                    $ret.value = null;
                    return $ret;
                })());
            }
            else {
                let c = new JsonDictionaryObject();
                c.item("refType", ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = "name";
                    return $ret;
                })()));
                c.item("id", ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = b.name;
                    return $ret;
                })()));
                this.x = c;
            }
            return this;
        }
        asPoint(a) {
            this.z = 11;
            this.ac = null;
            this.ab = null;
            let b = new JsonDictionaryObject();
            b.item("x", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = a.x;
                return $ret;
            })()));
            b.item("y", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = a.y;
                return $ret;
            })()));
            this.x = b;
            return this;
        }
        asSize(a) {
            this.z = 12;
            this.ac = null;
            this.ab = null;
            let b = new JsonDictionaryObject();
            b.item("width", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = a.width;
                return $ret;
            })()));
            b.item("height", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = a.height;
                return $ret;
            })()));
            this.x = b;
            return this;
        }
        asRect(a) {
            this.z = 14;
            this.ac = null;
            this.ab = null;
            let b = new JsonDictionaryObject();
            b.item("left", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = a.left;
                return $ret;
            })()));
            b.item("top", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = a.top;
                return $ret;
            })()));
            b.item("width", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = a.width;
                return $ret;
            })()));
            b.item("height", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = a.height;
                return $ret;
            })()));
            this.x = b;
            return this;
        }
        asMethodRef(a) {
            this.z = 18;
            this.ac = null;
            this.ab = null;
            let b = new JsonDictionaryObject();
            b.item("refType", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = "name";
                return $ret;
            })()));
            b.item("id", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = a;
                return $ret;
            })()));
            this.x = b;
            return this;
        }
        asBool(a) {
            this.z = 2;
            this.ac = null;
            this.ab = "boolean";
            this.x = ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 1;
                $ret.value = a;
                return $ret;
            })());
            return this;
        }
        asBoolArray(a) {
            this.z = 10;
            this.ac = null;
            this.ab = "boolean";
            if (a == null) {
                this.x = ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 3;
                    $ret.value = null;
                    return $ret;
                })());
            }
            else {
                let b = new JsonDictionaryArray();
                b.items = new Array(a.length);
                for (let c = 0; c < a.length; c++) {
                    b.items[c] = ((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.e = 1;
                        $ret.value = a[c];
                        return $ret;
                    })());
                }
                this.x = b;
            }
            return this;
        }
        y() {
            let a = new JsonDictionaryObject();
            a.item("knownType", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = EnumUtil.getName(TypeDescriptionWellKnownType_$type, this.z);
                return $ret;
            })()));
            if (this.ac != null) {
                a.item("specificType", ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = this.ac;
                    return $ret;
                })()));
            }
            if (this.ab != null) {
                a.item("specificExternalType", ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = this.ab;
                    return $ret;
                })()));
            }
            if (this.aa != null) {
                a.item("collectionElementType", ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = this.aa;
                    return $ret;
                })()));
            }
            if (this.x != null) {
                a.item("value", this.x);
            }
            else {
                a.item("value", ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 3;
                    return $ret;
                })()));
            }
            return a;
        }
    }
    ComponentRendererMethodHelperArgumentBuilder.$t = /*@__PURE__*/ markType(ComponentRendererMethodHelperArgumentBuilder, 'ComponentRendererMethodHelperArgumentBuilder');
    return ComponentRendererMethodHelperArgumentBuilder;
})();
/**
 * @hidden
 */
let ComponentRendererMethodHelperReturnBuilder = /*@__PURE__*/ (() => {
    class ComponentRendererMethodHelperReturnBuilder extends Base {
        constructor(a) {
            super();
            this.b = null;
            this.y = 0;
            this.ab = null;
            this.aa = null;
            this.z = null;
            this.b = a;
        }
        argument() {
            return this.b.argument();
        }
        $return() {
            return this.b.$return();
        }
        build() {
            return this.b.build();
        }
        asInt() {
            this.y = 1;
            this.ab = null;
            this.aa = "int";
            return this;
        }
        asIntArray() {
            this.y = 10;
            this.ab = null;
            this.aa = "int";
            return this;
        }
        asDouble() {
            this.y = 1;
            this.ab = null;
            this.aa = "double";
            return this;
        }
        asDoubleArray() {
            this.y = 10;
            this.ab = null;
            this.aa = "double";
            return this;
        }
        asShort() {
            this.y = 1;
            this.ab = null;
            this.aa = "short";
            return this;
        }
        asShortArray() {
            this.y = 10;
            this.ab = null;
            this.aa = "short";
            return this;
        }
        asLong() {
            this.y = 1;
            this.ab = null;
            this.aa = "long";
            return this;
        }
        asLongArray() {
            this.y = 10;
            this.ab = null;
            this.aa = "long";
            return this;
        }
        asFlout() {
            this.y = 1;
            this.ab = null;
            this.aa = "float";
            return this;
        }
        asFloatArray() {
            this.y = 10;
            this.ab = null;
            this.aa = "float";
            return this;
        }
        asEnum(a) {
            this.y = 8;
            this.ab = a.typeName;
            this.aa = "string";
            return this;
        }
        asString() {
            this.y = 2;
            this.ab = null;
            this.aa = "string";
            return this;
        }
        asStringArray() {
            this.y = 10;
            this.ab = null;
            this.aa = "string";
            return this;
        }
        asPublicTypeRef(a) {
            this.y = 8;
            this.ab = a;
            this.aa = a;
            let b = new JsonDictionaryObject();
            b.item("refType", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = "name";
                return $ret;
            })()));
            b.item("id", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = "name";
                return $ret;
            })()));
            return this;
        }
        asPoint() {
            this.y = 11;
            this.ab = null;
            this.aa = null;
            return this;
        }
        asSize() {
            this.y = 12;
            this.ab = null;
            this.aa = null;
            return this;
        }
        asRect() {
            this.y = 14;
            this.ab = null;
            this.aa = null;
            return this;
        }
        asMethodRef() {
            this.y = 18;
            this.ab = null;
            this.aa = null;
            return this;
        }
        asBool() {
            this.y = 7;
            this.ab = null;
            this.aa = "boolean";
            return this;
        }
        x() {
            let a = new JsonDictionaryObject();
            a.item("knownType", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = EnumUtil.getName(TypeDescriptionWellKnownType_$type, this.y);
                return $ret;
            })()));
            if (this.ab != null) {
                a.item("specificType", ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = this.ab;
                    return $ret;
                })()));
            }
            if (this.aa != null) {
                a.item("specificExternalType", ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = this.aa;
                    return $ret;
                })()));
            }
            if (this.z != null) {
                a.item("collectionElementType", ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.e = 2;
                    $ret.value = this.z;
                    return $ret;
                })()));
            }
            return a;
        }
        asVoid() {
            this.y = 0;
            this.ab = null;
            this.aa = null;
            return this;
        }
    }
    ComponentRendererMethodHelperReturnBuilder.$t = /*@__PURE__*/ markType(ComponentRendererMethodHelperReturnBuilder, 'ComponentRendererMethodHelperReturnBuilder');
    return ComponentRendererMethodHelperReturnBuilder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ComponentRendererMethodHelper = /*@__PURE__*/ (() => {
    class ComponentRendererMethodHelper extends Base {
        static call(a, b = null) {
            return new ComponentRendererMethodHelperBuilder(a, b);
        }
        static returnAsInt(a) {
            let b = ComponentRendererMethodHelper.l(a);
            if (b != null) {
                return truncate(b);
            }
            return -2147483648;
        }
        static l(a) {
            let b = new JsonDictionaryParser();
            let c = b.parse(a);
            if (c != null && typeCast(JsonDictionaryObject.$, c) !== null) {
                let d = c;
                if (d.g("result")) {
                    if (typeCast(JsonDictionaryObject.$, d.item("result")) !== null) {
                        return d.item("result");
                    }
                    return d.item("result").value;
                }
            }
            return null;
        }
        static returnAsDouble(a) {
            let b = ComponentRendererMethodHelper.l(a);
            if (b != null) {
                return b;
            }
            return NaN;
        }
        static returnAsShort(a) {
            let b = ComponentRendererMethodHelper.l(a);
            if (b != null) {
                return truncate(b);
            }
            return -32768;
        }
        static returnAsLong(a) {
            let b = ComponentRendererMethodHelper.l(a);
            if (b != null) {
                return truncate(b);
            }
            return -9.2233720368547758E+18;
        }
        static returnAsFloat(a) {
            let b = ComponentRendererMethodHelper.l(a);
            if (b != null) {
                return b;
            }
            return NaN;
        }
        static returnAsEnum(a, b) {
            let c = ComponentRendererMethodHelper.l(b);
            if (c != null) {
                return EnumUtil.parse(a, c, true);
            }
            return null;
        }
        static returnAsString(a) {
            let b = ComponentRendererMethodHelper.l(a);
            if (b != null) {
                return b;
            }
            return null;
        }
        static returnAsAsPublicTypeRef(a, b) {
            let c = ComponentRendererMethodHelper.l(b);
            if (c != null) {
                let d = c;
                let e = ((() => {
                    let $ret = new EmbeddedRefDescription();
                    $ret.refType = "name";
                    $ret.name = d.item("id").value.toString();
                    return $ret;
                })());
                return e;
            }
            return null;
        }
        static returnAsPoint(a) {
            let b = ComponentRendererMethodHelper.l(a);
            if (b != null) {
                let c = b;
                let d = new PointDescription();
                d.x = c.item("x").value;
                d.y = c.item("y").value;
                return d;
            }
            return null;
        }
        static returnAsSize(a) {
            let b = ComponentRendererMethodHelper.l(a);
            if (b != null) {
                let c = b;
                let d = new SizeDescription();
                d.width = c.item("width").value;
                d.height = c.item("height").value;
                return d;
            }
            return null;
        }
        static returnAsRect(a) {
            let b = ComponentRendererMethodHelper.l(a);
            if (b != null) {
                let c = b;
                let d = new RectDescription();
                d.width = c.item("width").value;
                d.height = c.item("height").value;
                return d;
            }
            return null;
        }
        static asMethodRef(a) {
            let b = ComponentRendererMethodHelper.l(a);
            if (b != null) {
                let c = b;
                let d = ((() => {
                    let $ret = new EmbeddedRefDescription();
                    $ret.refType = "name";
                    $ret.name = c.item("id").value.toString();
                    return $ret;
                })());
                return d;
            }
            return null;
        }
        static returnAsBool(a) {
            let b = ComponentRendererMethodHelper.l(a);
            if (b != null) {
                return b;
            }
            return false;
        }
    }
    ComponentRendererMethodHelper.$t = /*@__PURE__*/ markType(ComponentRendererMethodHelper, 'ComponentRendererMethodHelper');
    return ComponentRendererMethodHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationIdleEventArgsDescription = /*@__PURE__*/ (() => {
    class AnimationIdleEventArgsDescription extends Description {
        get_type() {
            return "AnimationIdleEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    AnimationIdleEventArgsDescription.$t = /*@__PURE__*/ markType(AnimationIdleEventArgsDescription, 'AnimationIdleEventArgsDescription', Description.$);
    return AnimationIdleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationIdleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AnimationIdleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AnimationIdleEventArgsDescriptionMetadata.a == null) {
                AnimationIdleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AnimationIdleEventArgsDescriptionMetadata.c(AnimationIdleEventArgsDescriptionMetadata.a);
            }
            if (a.k(AnimationIdleEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AnimationIdleEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            AnimationIdleEventArgsDescriptionMetadata.b(a);
            a.ae("AnimationIdleEventArgs", () => new AnimationIdleEventArgsDescription());
            a.ad("AnimationIdleEventArgs", AnimationIdleEventArgsDescriptionMetadata.a);
        }
    }
    AnimationIdleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AnimationIdleEventArgsDescriptionMetadata, 'AnimationIdleEventArgsDescriptionMetadata');
    AnimationIdleEventArgsDescriptionMetadata.a = null;
    return AnimationIdleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnnotationLayerProxyDescriptionModule = /*@__PURE__*/ (() => {
    class AnnotationLayerProxyDescriptionModule extends Base {
        static register(a) {
        }
    }
    AnnotationLayerProxyDescriptionModule.$t = /*@__PURE__*/ markType(AnnotationLayerProxyDescriptionModule, 'AnnotationLayerProxyDescriptionModule');
    return AnnotationLayerProxyDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ApplyButtonClickEventArgsDescription = /*@__PURE__*/ (() => {
    class ApplyButtonClickEventArgsDescription extends Description {
        get_type() {
            return "ApplyButtonClickEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ApplyButtonClickEventArgsDescription.$t = /*@__PURE__*/ markType(ApplyButtonClickEventArgsDescription, 'ApplyButtonClickEventArgsDescription', Description.$);
    return ApplyButtonClickEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ApplyButtonClickEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ApplyButtonClickEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ApplyButtonClickEventArgsDescriptionMetadata.a == null) {
                ApplyButtonClickEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ApplyButtonClickEventArgsDescriptionMetadata.c(ApplyButtonClickEventArgsDescriptionMetadata.a);
            }
            if (a.k(ApplyButtonClickEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ApplyButtonClickEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ApplyButtonClickEventArgsDescriptionMetadata.b(a);
            a.ae("ApplyButtonClickEventArgs", () => new ApplyButtonClickEventArgsDescription());
            a.ad("ApplyButtonClickEventArgs", ApplyButtonClickEventArgsDescriptionMetadata.a);
        }
    }
    ApplyButtonClickEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ApplyButtonClickEventArgsDescriptionMetadata, 'ApplyButtonClickEventArgsDescriptionMetadata');
    ApplyButtonClickEventArgsDescriptionMetadata.a = null;
    return ApplyButtonClickEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesViewerDescription = /*@__PURE__*/ (() => {
    class SeriesViewerDescription extends Description {
        get_type() {
            return "SeriesViewer";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.h = null;
            this.l = null;
            this.j = null;
            this.k = null;
            this.ej = null;
            this.v = null;
            this.ei = null;
            this.af = false;
            this.ak = false;
            this.an = false;
            this.d8 = null;
            this.ex = null;
            this.ev = null;
            this.d4 = null;
            this.eb = null;
            this.fn = null;
            this.ed = null;
            this.fp = null;
            this.ea = null;
            this.ec = null;
            this.bg = 0;
            this.bf = 0;
            this.bc = 0;
            this.bd = 0;
            this.be = 0;
            this.bi = 0;
            this.bh = 0;
            this.ag = false;
            this.fm = null;
            this.fo = null;
            this.b1 = 0;
            this.b0 = 0;
            this.by = 0;
            this.b4 = 0;
            this.bz = 0;
            this.b3 = 0;
            this.b2 = 0;
            this.aq = false;
            this.d7 = null;
            this.ef = null;
            this.eh = null;
            this.eg = null;
            this.y = null;
            this.aa = null;
            this.ap = false;
            this.al = false;
            this.dn = 0;
            this.dk = 0;
            this.dm = 0;
            this.dj = 0;
            this.dl = 0;
            this.ai = false;
            this.dy = null;
            this.du = null;
            this.aj = false;
            this.ft = null;
            this.b8 = 0;
            this.b7 = 0;
            this.a8 = 0;
            this.a7 = 0;
            this.ca = 0;
            this.b9 = 0;
            this.fd = null;
            this.dz = null;
            this.d9 = null;
            this.fl = null;
            this.fu = null;
            this.el = null;
            this.d0 = null;
            this.et = null;
            this.d1 = null;
            this.ek = null;
            this.z = null;
            this.d6 = null;
            this.m = null;
            this.i = null;
            this.b5 = 0;
            this.b6 = 0;
            this.ew = null;
            this.d2 = null;
            this.dx = null;
            this.fi = null;
            this.fa = null;
            this.fk = null;
            this.fc = null;
            this.fj = null;
            this.fb = null;
            this.bw = 0;
            this.bu = 0;
            this.bv = 0;
            this.bs = 0;
            this.br = 0;
            this.bp = 0;
            this.bq = 0;
            this.bn = 0;
            this.e6 = null;
            this.bx = 0;
            this.bk = 0;
            this.bm = 0;
            this.bb = 0;
            this.ba = 0;
            this.a9 = 0;
            this.ah = false;
            this.bl = 0;
            this.bj = 0;
            this.a4 = 0;
            this.a3 = 0;
            this.am = false;
            this.x = null;
            this.a5 = 0;
            this.a6 = 0;
            this.ep = null;
            this.eq = null;
            this.em = null;
            this.en = null;
            this.eo = null;
            this.er = null;
            this.ez = null;
            this.e2 = null;
            this.e3 = null;
            this.ey = null;
            this.e4 = null;
            this.e0 = null;
            this.e1 = null;
            this.fr = null;
            this.fq = null;
            this.fs = null;
            this.e5 = null;
            this.dv = null;
            this.d5 = null;
            this.eu = null;
            this.d3 = null;
            this.es = null;
            this.ee = null;
            this.dw = null;
            this.ff = null;
            this.bt = 0;
            this.fh = null;
            this.fg = null;
            this.e7 = null;
            this.bo = 0;
            this.e9 = null;
            this.e8 = null;
            this.ao = false;
            this.fe = null;
        }
        get series() {
            return this.n;
        }
        set series(a) {
            this.n = a;
            this.g("Series");
        }
        get brushes() {
            return this.h;
        }
        set brushes(a) {
            this.h = a;
            this.g("Brushes");
        }
        get outlines() {
            return this.l;
        }
        set outlines(a) {
            this.l = a;
            this.g("Outlines");
        }
        get markerBrushes() {
            return this.j;
        }
        set markerBrushes(a) {
            this.j = a;
            this.g("MarkerBrushes");
        }
        get markerOutlines() {
            return this.k;
        }
        set markerOutlines(a) {
            this.k = a;
            this.g("MarkerOutlines");
        }
        get markerAutomaticBehavior() {
            return this.ej;
        }
        set markerAutomaticBehavior(a) {
            this.ej = a;
            this.g("MarkerAutomaticBehavior");
        }
        get crosshairPoint() {
            return this.v;
        }
        set crosshairPoint(a) {
            this.v = a;
            this.g("CrosshairPoint");
        }
        get legendRef() {
            return this.ei;
        }
        set legendRef(a) {
            this.ei = a;
            this.g("LegendRef");
        }
        get animateSeriesWhenAxisRangeChanges() {
            return this.af;
        }
        set animateSeriesWhenAxisRangeChanges(a) {
            this.af = a;
            this.g("AnimateSeriesWhenAxisRangeChanges");
        }
        get isWindowSyncedToVisibleRange() {
            return this.ak;
        }
        set isWindowSyncedToVisibleRange(a) {
            this.ak = a;
            this.g("IsWindowSyncedToVisibleRange");
        }
        get shouldSimulateHoverMoveCrosshairPoint() {
            return this.an;
        }
        set shouldSimulateHoverMoveCrosshairPoint(a) {
            this.an = a;
            this.g("ShouldSimulateHoverMoveCrosshairPoint");
        }
        get highlightingMode() {
            return this.d8;
        }
        set highlightingMode(a) {
            this.d8 = a;
            this.g("HighlightingMode");
        }
        get selectionMode() {
            return this.ex;
        }
        set selectionMode(a) {
            this.ex = a;
            this.g("SelectionMode");
        }
        get selectionBehavior() {
            return this.ev;
        }
        set selectionBehavior(a) {
            this.ev = a;
            this.g("SelectionBehavior");
        }
        get focusMode() {
            return this.d4;
        }
        set focusMode(a) {
            this.d4 = a;
            this.g("FocusMode");
        }
        get horizontalViewScrollbarMode() {
            return this.eb;
        }
        set horizontalViewScrollbarMode(a) {
            this.eb = a;
            this.g("HorizontalViewScrollbarMode");
        }
        get verticalViewScrollbarMode() {
            return this.fn;
        }
        set verticalViewScrollbarMode(a) {
            this.fn = a;
            this.g("VerticalViewScrollbarMode");
        }
        get horizontalViewScrollbarPosition() {
            return this.ed;
        }
        set horizontalViewScrollbarPosition(a) {
            this.ed = a;
            this.g("HorizontalViewScrollbarPosition");
        }
        get verticalViewScrollbarPosition() {
            return this.fp;
        }
        set verticalViewScrollbarPosition(a) {
            this.fp = a;
            this.g("VerticalViewScrollbarPosition");
        }
        get horizontalViewScrollbarFill() {
            return this.ea;
        }
        set horizontalViewScrollbarFill(a) {
            this.ea = a;
            this.g("HorizontalViewScrollbarFill");
        }
        get horizontalViewScrollbarOutline() {
            return this.ec;
        }
        set horizontalViewScrollbarOutline(a) {
            this.ec = a;
            this.g("HorizontalViewScrollbarOutline");
        }
        get horizontalViewScrollbarStrokeThickness() {
            return this.bg;
        }
        set horizontalViewScrollbarStrokeThickness(a) {
            this.bg = a;
            this.g("HorizontalViewScrollbarStrokeThickness");
        }
        get horizontalViewScrollbarMaxOpacity() {
            return this.bf;
        }
        set horizontalViewScrollbarMaxOpacity(a) {
            this.bf = a;
            this.g("HorizontalViewScrollbarMaxOpacity");
        }
        get horizontalViewScrollbarCornerRadius() {
            return this.bc;
        }
        set horizontalViewScrollbarCornerRadius(a) {
            this.bc = a;
            this.g("HorizontalViewScrollbarCornerRadius");
        }
        get horizontalViewScrollbarHeight() {
            return this.bd;
        }
        set horizontalViewScrollbarHeight(a) {
            this.bd = a;
            this.g("HorizontalViewScrollbarHeight");
        }
        get horizontalViewScrollbarInset() {
            return this.be;
        }
        set horizontalViewScrollbarInset(a) {
            this.be = a;
            this.g("HorizontalViewScrollbarInset");
        }
        get horizontalViewScrollbarTrackStartInset() {
            return this.bi;
        }
        set horizontalViewScrollbarTrackStartInset(a) {
            this.bi = a;
            this.g("HorizontalViewScrollbarTrackStartInset");
        }
        get horizontalViewScrollbarTrackEndInset() {
            return this.bh;
        }
        set horizontalViewScrollbarTrackEndInset(a) {
            this.bh = a;
            this.g("HorizontalViewScrollbarTrackEndInset");
        }
        get horizontalViewScrollbarShouldAddAutoTrackInsets() {
            return this.ag;
        }
        set horizontalViewScrollbarShouldAddAutoTrackInsets(a) {
            this.ag = a;
            this.g("HorizontalViewScrollbarShouldAddAutoTrackInsets");
        }
        get verticalViewScrollbarFill() {
            return this.fm;
        }
        set verticalViewScrollbarFill(a) {
            this.fm = a;
            this.g("VerticalViewScrollbarFill");
        }
        get verticalViewScrollbarOutline() {
            return this.fo;
        }
        set verticalViewScrollbarOutline(a) {
            this.fo = a;
            this.g("VerticalViewScrollbarOutline");
        }
        get verticalViewScrollbarStrokeThickness() {
            return this.b1;
        }
        set verticalViewScrollbarStrokeThickness(a) {
            this.b1 = a;
            this.g("VerticalViewScrollbarStrokeThickness");
        }
        get verticalViewScrollbarMaxOpacity() {
            return this.b0;
        }
        set verticalViewScrollbarMaxOpacity(a) {
            this.b0 = a;
            this.g("VerticalViewScrollbarMaxOpacity");
        }
        get verticalViewScrollbarCornerRadius() {
            return this.by;
        }
        set verticalViewScrollbarCornerRadius(a) {
            this.by = a;
            this.g("VerticalViewScrollbarCornerRadius");
        }
        get verticalViewScrollbarWidth() {
            return this.b4;
        }
        set verticalViewScrollbarWidth(a) {
            this.b4 = a;
            this.g("VerticalViewScrollbarWidth");
        }
        get verticalViewScrollbarInset() {
            return this.bz;
        }
        set verticalViewScrollbarInset(a) {
            this.bz = a;
            this.g("VerticalViewScrollbarInset");
        }
        get verticalViewScrollbarTrackStartInset() {
            return this.b3;
        }
        set verticalViewScrollbarTrackStartInset(a) {
            this.b3 = a;
            this.g("VerticalViewScrollbarTrackStartInset");
        }
        get verticalViewScrollbarTrackEndInset() {
            return this.b2;
        }
        set verticalViewScrollbarTrackEndInset(a) {
            this.b2 = a;
            this.g("VerticalViewScrollbarTrackEndInset");
        }
        get verticalViewScrollbarShouldAddAutoTrackInsets() {
            return this.aq;
        }
        set verticalViewScrollbarShouldAddAutoTrackInsets(a) {
            this.aq = a;
            this.g("VerticalViewScrollbarShouldAddAutoTrackInsets");
        }
        get highlightingBehavior() {
            return this.d7;
        }
        set highlightingBehavior(a) {
            this.d7 = a;
            this.g("HighlightingBehavior");
        }
        get legendHighlightingMode() {
            return this.ef;
        }
        set legendHighlightingMode(a) {
            this.ef = a;
            this.g("LegendHighlightingMode");
        }
        get legendItemBadgeShape() {
            return this.eh;
        }
        set legendItemBadgeShape(a) {
            this.eh = a;
            this.g("LegendItemBadgeShape");
        }
        get legendItemBadgeMode() {
            return this.eg;
        }
        set legendItemBadgeMode(a) {
            this.eg = a;
            this.g("LegendItemBadgeMode");
        }
        get effectiveViewport() {
            return this.y;
        }
        set effectiveViewport(a) {
            this.y = a;
            this.g("EffectiveViewport");
        }
        get windowRect() {
            return this.aa;
        }
        set windowRect(a) {
            this.aa = a;
            this.g("WindowRect");
        }
        get useTiledZooming() {
            return this.ap;
        }
        set useTiledZooming(a) {
            this.ap = a;
            this.g("UseTiledZooming");
        }
        get preferHigherResolutionTiles() {
            return this.al;
        }
        set preferHigherResolutionTiles(a) {
            this.al = a;
            this.g("PreferHigherResolutionTiles");
        }
        get zoomTileCacheSize() {
            return this.dn;
        }
        set zoomTileCacheSize(a) {
            this.dn = a;
            this.g("ZoomTileCacheSize");
        }
        get highlightingTransitionDuration() {
            return this.dk;
        }
        set highlightingTransitionDuration(a) {
            this.dk = a;
            this.g("HighlightingTransitionDuration");
        }
        get selectionTransitionDuration() {
            return this.dm;
        }
        set selectionTransitionDuration(a) {
            this.dm = a;
            this.g("SelectionTransitionDuration");
        }
        get focusTransitionDuration() {
            return this.dj;
        }
        set focusTransitionDuration(a) {
            this.dj = a;
            this.g("FocusTransitionDuration");
        }
        get scrollbarsAnimationDuration() {
            return this.dl;
        }
        set scrollbarsAnimationDuration(a) {
            this.dl = a;
            this.g("ScrollbarsAnimationDuration");
        }
        get isPagePanningAllowed() {
            return this.ai;
        }
        set isPagePanningAllowed(a) {
            this.ai = a;
            this.g("IsPagePanningAllowed");
        }
        get contentHitTestMode() {
            return this.dy;
        }
        set contentHitTestMode(a) {
            this.dy = a;
            this.g("ContentHitTestMode");
        }
        get actualContentHitTestMode() {
            return this.du;
        }
        set actualContentHitTestMode(a) {
            this.du = a;
            this.g("ActualContentHitTestMode");
        }
        get isSurfaceInteractionDisabled() {
            return this.aj;
        }
        set isSurfaceInteractionDisabled(a) {
            this.aj = a;
            this.g("IsSurfaceInteractionDisabled");
        }
        get windowResponse() {
            return this.ft;
        }
        set windowResponse(a) {
            this.ft = a;
            this.g("WindowResponse");
        }
        get windowRectMinWidth() {
            return this.b8;
        }
        set windowRectMinWidth(a) {
            this.b8 = a;
            this.g("WindowRectMinWidth");
        }
        get windowRectMinHeight() {
            return this.b7;
        }
        set windowRectMinHeight(a) {
            this.b7 = a;
            this.g("WindowRectMinHeight");
        }
        get actualWindowRectMinWidth() {
            return this.a8;
        }
        set actualWindowRectMinWidth(a) {
            this.a8 = a;
            this.g("ActualWindowRectMinWidth");
        }
        get actualWindowRectMinHeight() {
            return this.a7;
        }
        set actualWindowRectMinHeight(a) {
            this.a7 = a;
            this.g("ActualWindowRectMinHeight");
        }
        get windowSizeMinWidth() {
            return this.ca;
        }
        set windowSizeMinWidth(a) {
            this.ca = a;
            this.g("WindowSizeMinWidth");
        }
        get windowSizeMinHeight() {
            return this.b9;
        }
        set windowSizeMinHeight(a) {
            this.b9 = a;
            this.g("WindowSizeMinHeight");
        }
        get syncChannel() {
            return this.fd;
        }
        set syncChannel(a) {
            this.fd = a;
            this.g("SyncChannel");
        }
        get crosshairVisibility() {
            return this.dz;
        }
        set crosshairVisibility(a) {
            this.dz = a;
            this.g("CrosshairVisibility");
        }
        get horizontalCrosshairBrush() {
            return this.d9;
        }
        set horizontalCrosshairBrush(a) {
            this.d9 = a;
            this.g("HorizontalCrosshairBrush");
        }
        get verticalCrosshairBrush() {
            return this.fl;
        }
        set verticalCrosshairBrush(a) {
            this.fl = a;
            this.g("VerticalCrosshairBrush");
        }
        get zoomCoercionMode() {
            return this.fu;
        }
        set zoomCoercionMode(a) {
            this.fu = a;
            this.g("ZoomCoercionMode");
        }
        get plotAreaBackground() {
            return this.el;
        }
        set plotAreaBackground(a) {
            this.el = a;
            this.g("PlotAreaBackground");
        }
        get defaultInteraction() {
            return this.d0;
        }
        set defaultInteraction(a) {
            this.d0 = a;
            this.g("DefaultInteraction");
        }
        get rightButtonDefaultInteraction() {
            return this.et;
        }
        set rightButtonDefaultInteraction(a) {
            this.et = a;
            this.g("RightButtonDefaultInteraction");
        }
        get dragModifier() {
            return this.d1;
        }
        set dragModifier(a) {
            this.d1 = a;
            this.g("DragModifier");
        }
        get panModifier() {
            return this.ek;
        }
        set panModifier(a) {
            this.ek = a;
            this.g("PanModifier");
        }
        get previewRect() {
            return this.z;
        }
        set previewRect(a) {
            this.z = a;
            this.g("PreviewRect");
        }
        get highlightedValuesDisplayMode() {
            return this.d6;
        }
        set highlightedValuesDisplayMode(a) {
            this.d6 = a;
            this.g("HighlightedValuesDisplayMode");
        }
        get selectedSeriesItems() {
            return this.m;
        }
        set selectedSeriesItems(a) {
            this.m = a;
            this.g("SelectedSeriesItems");
        }
        get focusedSeriesItems() {
            return this.i;
        }
        set focusedSeriesItems(a) {
            this.i = a;
            this.g("FocusedSeriesItems");
        }
        get windowPositionHorizontal() {
            return this.b5;
        }
        set windowPositionHorizontal(a) {
            this.b5 = a;
            this.g("WindowPositionHorizontal");
        }
        get windowPositionVertical() {
            return this.b6;
        }
        set windowPositionVertical(a) {
            this.b6 = a;
            this.g("WindowPositionVertical");
        }
        get selectionBrush() {
            return this.ew;
        }
        set selectionBrush(a) {
            this.ew = a;
            this.g("SelectionBrush");
        }
        get focusBrush() {
            return this.d2;
        }
        set focusBrush(a) {
            this.d2 = a;
            this.g("FocusBrush");
        }
        get chartTitle() {
            return this.dx;
        }
        set chartTitle(a) {
            this.dx = a;
            this.g("ChartTitle");
        }
        get titleHorizontalAlignment() {
            return this.fi;
        }
        set titleHorizontalAlignment(a) {
            this.fi = a;
            this.g("TitleHorizontalAlignment");
        }
        get subtitleHorizontalAlignment() {
            return this.fa;
        }
        set subtitleHorizontalAlignment(a) {
            this.fa = a;
            this.g("SubtitleHorizontalAlignment");
        }
        get titleTextStyle() {
            return this.fk;
        }
        set titleTextStyle(a) {
            this.fk = a;
            this.g("TitleTextStyle");
        }
        get subtitleTextStyle() {
            return this.fc;
        }
        set subtitleTextStyle(a) {
            this.fc = a;
            this.g("SubtitleTextStyle");
        }
        get titleTextColor() {
            return this.fj;
        }
        set titleTextColor(a) {
            this.fj = a;
            this.g("TitleTextColor");
        }
        get subtitleTextColor() {
            return this.fb;
        }
        set subtitleTextColor(a) {
            this.fb = a;
            this.g("SubtitleTextColor");
        }
        get titleTopMargin() {
            return this.bw;
        }
        set titleTopMargin(a) {
            this.bw = a;
            this.g("TitleTopMargin");
        }
        get titleLeftMargin() {
            return this.bu;
        }
        set titleLeftMargin(a) {
            this.bu = a;
            this.g("TitleLeftMargin");
        }
        get titleRightMargin() {
            return this.bv;
        }
        set titleRightMargin(a) {
            this.bv = a;
            this.g("TitleRightMargin");
        }
        get titleBottomMargin() {
            return this.bs;
        }
        set titleBottomMargin(a) {
            this.bs = a;
            this.g("TitleBottomMargin");
        }
        get subtitleTopMargin() {
            return this.br;
        }
        set subtitleTopMargin(a) {
            this.br = a;
            this.g("SubtitleTopMargin");
        }
        get subtitleLeftMargin() {
            return this.bp;
        }
        set subtitleLeftMargin(a) {
            this.bp = a;
            this.g("SubtitleLeftMargin");
        }
        get subtitleRightMargin() {
            return this.bq;
        }
        set subtitleRightMargin(a) {
            this.bq = a;
            this.g("SubtitleRightMargin");
        }
        get subtitleBottomMargin() {
            return this.bn;
        }
        set subtitleBottomMargin(a) {
            this.bn = a;
            this.g("SubtitleBottomMargin");
        }
        get subtitle() {
            return this.e6;
        }
        set subtitle(a) {
            this.e6 = a;
            this.g("Subtitle");
        }
        get topMargin() {
            return this.bx;
        }
        set topMargin(a) {
            this.bx = a;
            this.g("TopMargin");
        }
        get leftMargin() {
            return this.bk;
        }
        set leftMargin(a) {
            this.bk = a;
            this.g("LeftMargin");
        }
        get rightMargin() {
            return this.bm;
        }
        set rightMargin(a) {
            this.bm = a;
            this.g("RightMargin");
        }
        get bottomMargin() {
            return this.bb;
        }
        set bottomMargin(a) {
            this.bb = a;
            this.g("BottomMargin");
        }
        get autoMarginWidth() {
            return this.ba;
        }
        set autoMarginWidth(a) {
            this.ba = a;
            this.g("AutoMarginWidth");
        }
        get autoMarginHeight() {
            return this.a9;
        }
        set autoMarginHeight(a) {
            this.a9 = a;
            this.g("AutoMarginHeight");
        }
        get isAntiAliasingEnabledDuringInteraction() {
            return this.ah;
        }
        set isAntiAliasingEnabledDuringInteraction(a) {
            this.ah = a;
            this.g("IsAntiAliasingEnabledDuringInteraction");
        }
        get pixelScalingRatio() {
            return this.bl;
        }
        set pixelScalingRatio(a) {
            this.bl = a;
            this.g("PixelScalingRatio");
        }
        get interactionPixelScalingRatio() {
            return this.bj;
        }
        set interactionPixelScalingRatio(a) {
            this.bj = a;
            this.g("InteractionPixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.a4;
        }
        set actualPixelScalingRatio(a) {
            this.a4 = a;
            this.g("ActualPixelScalingRatio");
        }
        get actualInteractionPixelScalingRatio() {
            return this.a3;
        }
        set actualInteractionPixelScalingRatio(a) {
            this.a3 = a;
            this.g("ActualInteractionPixelScalingRatio");
        }
        get shouldPanOnMaximumZoom() {
            return this.am;
        }
        set shouldPanOnMaximumZoom(a) {
            this.am = a;
            this.g("ShouldPanOnMaximumZoom");
        }
        get actualWindowRect() {
            return this.x;
        }
        set actualWindowRect(a) {
            this.x = a;
            this.g("ActualWindowRect");
        }
        get actualWindowPositionHorizontal() {
            return this.a5;
        }
        set actualWindowPositionHorizontal(a) {
            this.a5 = a;
            this.g("ActualWindowPositionHorizontal");
        }
        get actualWindowPositionVertical() {
            return this.a6;
        }
        set actualWindowPositionVertical(a) {
            this.a6 = a;
            this.g("ActualWindowPositionVertical");
        }
        get plotAreaMouseLeftButtonDownRef() {
            return this.ep;
        }
        set plotAreaMouseLeftButtonDownRef(a) {
            this.ep = a;
            this.g("PlotAreaMouseLeftButtonDownRef");
        }
        get plotAreaMouseLeftButtonUpRef() {
            return this.eq;
        }
        set plotAreaMouseLeftButtonUpRef(a) {
            this.eq = a;
            this.g("PlotAreaMouseLeftButtonUpRef");
        }
        get plotAreaClickedRef() {
            return this.em;
        }
        set plotAreaClickedRef(a) {
            this.em = a;
            this.g("PlotAreaClickedRef");
        }
        get plotAreaMouseEnterRef() {
            return this.en;
        }
        set plotAreaMouseEnterRef(a) {
            this.en = a;
            this.g("PlotAreaMouseEnterRef");
        }
        get plotAreaMouseLeaveRef() {
            return this.eo;
        }
        set plotAreaMouseLeaveRef(a) {
            this.eo = a;
            this.g("PlotAreaMouseLeaveRef");
        }
        get plotAreaMouseOverRef() {
            return this.er;
        }
        set plotAreaMouseOverRef(a) {
            this.er = a;
            this.g("PlotAreaMouseOverRef");
        }
        get seriesCursorMouseMoveRef() {
            return this.ez;
        }
        set seriesCursorMouseMoveRef(a) {
            this.ez = a;
            this.g("SeriesCursorMouseMoveRef");
        }
        get seriesMouseLeftButtonDownRef() {
            return this.e2;
        }
        set seriesMouseLeftButtonDownRef(a) {
            this.e2 = a;
            this.g("SeriesMouseLeftButtonDownRef");
        }
        get seriesMouseLeftButtonUpRef() {
            return this.e3;
        }
        set seriesMouseLeftButtonUpRef(a) {
            this.e3 = a;
            this.g("SeriesMouseLeftButtonUpRef");
        }
        get seriesClickRef() {
            return this.ey;
        }
        set seriesClickRef(a) {
            this.ey = a;
            this.g("SeriesClickRef");
        }
        get seriesMouseMoveRef() {
            return this.e4;
        }
        set seriesMouseMoveRef(a) {
            this.e4 = a;
            this.g("SeriesMouseMoveRef");
        }
        get seriesMouseEnterRef() {
            return this.e0;
        }
        set seriesMouseEnterRef(a) {
            this.e0 = a;
            this.g("SeriesMouseEnterRef");
        }
        get seriesMouseLeaveRef() {
            return this.e1;
        }
        set seriesMouseLeaveRef(a) {
            this.e1 = a;
            this.g("SeriesMouseLeaveRef");
        }
        get viewerManipulationStartingRef() {
            return this.fr;
        }
        set viewerManipulationStartingRef(a) {
            this.fr = a;
            this.g("ViewerManipulationStartingRef");
        }
        get viewerManipulationEndingRef() {
            return this.fq;
        }
        set viewerManipulationEndingRef(a) {
            this.fq = a;
            this.g("ViewerManipulationEndingRef");
        }
        get windowRectChangedRef() {
            return this.fs;
        }
        set windowRectChangedRef(a) {
            this.fs = a;
            this.g("WindowRectChangedRef");
        }
        get sizeChangedRef() {
            return this.e5;
        }
        set sizeChangedRef(a) {
            this.e5 = a;
            this.g("SizeChangedRef");
        }
        get actualWindowRectChangedRef() {
            return this.dv;
        }
        set actualWindowRectChangedRef(a) {
            this.dv = a;
            this.g("ActualWindowRectChangedRef");
        }
        get gridAreaRectChangedRef() {
            return this.d5;
        }
        set gridAreaRectChangedRef(a) {
            this.d5 = a;
            this.g("GridAreaRectChangedRef");
        }
        get selectedSeriesItemsChangedRef() {
            return this.eu;
        }
        set selectedSeriesItemsChangedRef(a) {
            this.eu = a;
            this.g("SelectedSeriesItemsChangedRef");
        }
        get focusedSeriesItemsChangedRef() {
            return this.d3;
        }
        set focusedSeriesItemsChangedRef(a) {
            this.d3 = a;
            this.g("FocusedSeriesItemsChangedRef");
        }
        get refreshCompletedRef() {
            return this.es;
        }
        set refreshCompletedRef(a) {
            this.es = a;
            this.g("RefreshCompletedRef");
        }
        get imageCapturedRef() {
            return this.ee;
        }
        set imageCapturedRef(a) {
            this.ee = a;
            this.g("ImageCapturedRef");
        }
        get background() {
            return this.dw;
        }
        set background(a) {
            this.dw = a;
            this.g("Background");
        }
        get titleFontFamily() {
            return this.ff;
        }
        set titleFontFamily(a) {
            this.ff = a;
            this.g("TitleFontFamily");
        }
        get titleFontSize() {
            return this.bt;
        }
        set titleFontSize(a) {
            this.bt = a;
            this.g("TitleFontSize");
        }
        get titleFontWeight() {
            return this.fh;
        }
        set titleFontWeight(a) {
            this.fh = a;
            this.g("TitleFontWeight");
        }
        get titleFontStyle() {
            return this.fg;
        }
        set titleFontStyle(a) {
            this.fg = a;
            this.g("TitleFontStyle");
        }
        get subtitleFontFamily() {
            return this.e7;
        }
        set subtitleFontFamily(a) {
            this.e7 = a;
            this.g("SubtitleFontFamily");
        }
        get subtitleFontSize() {
            return this.bo;
        }
        set subtitleFontSize(a) {
            this.bo = a;
            this.g("SubtitleFontSize");
        }
        get subtitleFontWeight() {
            return this.e9;
        }
        set subtitleFontWeight(a) {
            this.e9 = a;
            this.g("SubtitleFontWeight");
        }
        get subtitleFontStyle() {
            return this.e8;
        }
        set subtitleFontStyle(a) {
            this.e8 = a;
            this.g("SubtitleFontStyle");
        }
        get synchronizeHorizontally() {
            return this.ao;
        }
        set synchronizeHorizontally(a) {
            this.ao = a;
            this.g("SynchronizeHorizontally");
        }
        get synchronizeVertically() {
            return this.fe;
        }
        set synchronizeVertically(a) {
            this.fe = a;
            this.g("SynchronizeVertically");
        }
    }
    SeriesViewerDescription.$t = /*@__PURE__*/ markType(SeriesViewerDescription, 'SeriesViewerDescription', Description.$);
    return SeriesViewerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMapImageryDescription = /*@__PURE__*/ (() => {
    class GeographicMapImageryDescription extends Description {
        get_type() {
            return "GeographicMapImagery";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = null;
            this.t = null;
            this.l = false;
            this.u = null;
            this.n = 0;
            this.s = null;
            this.r = null;
            this.p = null;
            this.q = null;
        }
        get windowRect() {
            return this.j;
        }
        set windowRect(a) {
            this.j = a;
            this.g("WindowRect");
        }
        get geographicMap() {
            return this.h;
        }
        set geographicMap(a) {
            this.h = a;
            this.g("GeographicMap");
        }
        get referer() {
            return this.t;
        }
        set referer(a) {
            this.t = a;
            this.g("Referer");
        }
        get isHorizontalWrappingEnabled() {
            return this.l;
        }
        set isHorizontalWrappingEnabled(a) {
            this.l = a;
            this.g("IsHorizontalWrappingEnabled");
        }
        get userAgent() {
            return this.u;
        }
        set userAgent(a) {
            this.u = a;
            this.g("UserAgent");
        }
        get opacity() {
            return this.n;
        }
        set opacity(a) {
            this.n = a;
            this.g("Opacity");
        }
        get imageTilesReadyRef() {
            return this.s;
        }
        set imageTilesReadyRef(a) {
            this.s = a;
            this.g("ImageTilesReadyRef");
        }
        get imagesChangedRef() {
            return this.r;
        }
        set imagesChangedRef(a) {
            this.r = a;
            this.g("ImagesChangedRef");
        }
        get cancellingImageRef() {
            return this.p;
        }
        set cancellingImageRef(a) {
            this.p = a;
            this.g("CancellingImageRef");
        }
        get downloadingImageRef() {
            return this.q;
        }
        set downloadingImageRef(a) {
            this.q = a;
            this.g("DownloadingImageRef");
        }
    }
    GeographicMapImageryDescription.$t = /*@__PURE__*/ markType(GeographicMapImageryDescription, 'GeographicMapImageryDescription', Description.$);
    return GeographicMapImageryDescription;
})();
/**
 * @hidden
 */
let GeographicMapDescription = /*@__PURE__*/ (() => {
    class GeographicMapDescription extends SeriesViewerDescription {
        get_type() {
            return "GeographicMap";
        }
        constructor() {
            super();
            this.h6 = false;
            this.ij = null;
            this.h3 = false;
            this.ig = null;
            this.h5 = false;
            this.h4 = false;
            this.h0 = null;
            this.hz = null;
            this.hx = null;
            this.ic = 0;
            this.ib = 0;
            this.ii = null;
            this.ik = null;
            this.ih = null;
        }
        get zoomable() {
            return this.h6;
        }
        set zoomable(a) {
            this.h6 = a;
            this.g("Zoomable");
        }
        get resizeBehavior() {
            return this.ij;
        }
        set resizeBehavior(a) {
            this.ij = a;
            this.g("ResizeBehavior");
        }
        get isHorizontalWrappingEnabled() {
            return this.h3;
        }
        set isHorizontalWrappingEnabled(a) {
            this.h3 = a;
            this.g("IsHorizontalWrappingEnabled");
        }
        get backgroundTilingMode() {
            return this.ig;
        }
        set backgroundTilingMode(a) {
            this.ig = a;
            this.g("BackgroundTilingMode");
        }
        get useWorldRectForZoomBounds() {
            return this.h5;
        }
        set useWorldRectForZoomBounds(a) {
            this.h5 = a;
            this.g("UseWorldRectForZoomBounds");
        }
        get suppressZoomResetOnWorldRectChange() {
            return this.h4;
        }
        set suppressZoomResetOnWorldRectChange(a) {
            this.h4 = a;
            this.g("SuppressZoomResetOnWorldRectChange");
        }
        get worldRect() {
            return this.h0;
        }
        set worldRect(a) {
            this.h0 = a;
            this.g("WorldRect");
        }
        get actualWorldRect() {
            return this.hz;
        }
        set actualWorldRect(a) {
            this.hz = a;
            this.g("ActualWorldRect");
        }
        get backgroundContent() {
            return this.hx;
        }
        set backgroundContent(a) {
            this.hx = a;
            this.g("BackgroundContent");
        }
        get windowScale() {
            return this.ic;
        }
        set windowScale(a) {
            this.ic = a;
            this.g("WindowScale");
        }
        get actualWindowScale() {
            return this.ib;
        }
        set actualWindowScale(a) {
            this.ib = a;
            this.g("ActualWindowScale");
        }
        get imageTilesReadyRef() {
            return this.ii;
        }
        set imageTilesReadyRef(a) {
            this.ii = a;
            this.g("ImageTilesReadyRef");
        }
        get width() {
            return this.ik;
        }
        set width(a) {
            this.ik = a;
            this.g("Width");
        }
        get height() {
            return this.ih;
        }
        set height(a) {
            this.ih = a;
            this.g("Height");
        }
    }
    GeographicMapDescription.$t = /*@__PURE__*/ markType(GeographicMapDescription, 'GeographicMapDescription', SeriesViewerDescription.$);
    return GeographicMapDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArcGISOnlineMapImageryDescription = /*@__PURE__*/ (() => {
    class ArcGISOnlineMapImageryDescription extends GeographicMapImageryDescription {
        get_type() {
            return "ArcGISOnlineMapImagery";
        }
        constructor() {
            super();
            this.ag = null;
            this.ak = null;
            this.ah = null;
            this.al = null;
            this.ac = false;
            this.ae = 0;
            this.aj = null;
            this.ai = null;
        }
        get mapServerUri() {
            return this.ag;
        }
        set mapServerUri(a) {
            this.ag = a;
            this.g("MapServerUri");
        }
        get userName() {
            return this.ak;
        }
        set userName(a) {
            this.ak = a;
            this.g("UserName");
        }
        get password() {
            return this.ah;
        }
        set password(a) {
            this.ah = a;
            this.g("Password");
        }
        get userToken() {
            return this.al;
        }
        set userToken(a) {
            this.al = a;
            this.g("UserToken");
        }
        get isMapPublic() {
            return this.ac;
        }
        set isMapPublic(a) {
            this.ac = a;
            this.g("IsMapPublic");
        }
        get defaultTokenTimeout() {
            return this.ae;
        }
        set defaultTokenTimeout(a) {
            this.ae = a;
            this.g("DefaultTokenTimeout");
        }
        get tokenGenerationEndPoint() {
            return this.aj;
        }
        set tokenGenerationEndPoint(a) {
            this.aj = a;
            this.g("TokenGenerationEndPoint");
        }
        get refererUri() {
            return this.ai;
        }
        set refererUri(a) {
            this.ai = a;
            this.g("RefererUri");
        }
    }
    ArcGISOnlineMapImageryDescription.$t = /*@__PURE__*/ markType(ArcGISOnlineMapImageryDescription, 'ArcGISOnlineMapImageryDescription', GeographicMapImageryDescription.$);
    return ArcGISOnlineMapImageryDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageTilesReadyEventArgsDescription = /*@__PURE__*/ (() => {
    class ImageTilesReadyEventArgsDescription extends Description {
        get_type() {
            return "ImageTilesReadyEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ImageTilesReadyEventArgsDescription.$t = /*@__PURE__*/ markType(ImageTilesReadyEventArgsDescription, 'ImageTilesReadyEventArgsDescription', Description.$);
    return ImageTilesReadyEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageTilesReadyEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ImageTilesReadyEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ImageTilesReadyEventArgsDescriptionMetadata.a == null) {
                ImageTilesReadyEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ImageTilesReadyEventArgsDescriptionMetadata.c(ImageTilesReadyEventArgsDescriptionMetadata.a);
            }
            if (a.k(ImageTilesReadyEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ImageTilesReadyEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ImageTilesReadyEventArgsDescriptionMetadata.b(a);
            a.ae("ImageTilesReadyEventArgs", () => new ImageTilesReadyEventArgsDescription());
            a.ad("ImageTilesReadyEventArgs", ImageTilesReadyEventArgsDescriptionMetadata.a);
        }
    }
    ImageTilesReadyEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ImageTilesReadyEventArgsDescriptionMetadata, 'ImageTilesReadyEventArgsDescriptionMetadata');
    ImageTilesReadyEventArgsDescriptionMetadata.a = null;
    return ImageTilesReadyEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PlotAreaMouseButtonEventArgsDescription = /*@__PURE__*/ (() => {
    class PlotAreaMouseButtonEventArgsDescription extends Description {
        get_type() {
            return "PlotAreaMouseButtonEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.i = null;
            this.n = false;
            this.l = null;
        }
        get chartPosition() {
            return this.h;
        }
        set chartPosition(a) {
            this.h = a;
            this.g("ChartPosition");
        }
        get plotAreaPosition() {
            return this.i;
        }
        set plotAreaPosition(a) {
            this.i = a;
            this.g("PlotAreaPosition");
        }
        get manipulationOccurred() {
            return this.n;
        }
        set manipulationOccurred(a) {
            this.n = a;
            this.g("ManipulationOccurred");
        }
        get viewer() {
            return this.l;
        }
        set viewer(a) {
            this.l = a;
            this.g("Viewer");
        }
    }
    PlotAreaMouseButtonEventArgsDescription.$t = /*@__PURE__*/ markType(PlotAreaMouseButtonEventArgsDescription, 'PlotAreaMouseButtonEventArgsDescription', Description.$);
    return PlotAreaMouseButtonEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PlotAreaMouseEventArgsDescription = /*@__PURE__*/ (() => {
    class PlotAreaMouseEventArgsDescription extends Description {
        get_type() {
            return "PlotAreaMouseEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.i = null;
            this.n = false;
            this.l = null;
        }
        get chartPosition() {
            return this.h;
        }
        set chartPosition(a) {
            this.h = a;
            this.g("ChartPosition");
        }
        get plotAreaPosition() {
            return this.i;
        }
        set plotAreaPosition(a) {
            this.i = a;
            this.g("PlotAreaPosition");
        }
        get isDuringManipulation() {
            return this.n;
        }
        set isDuringManipulation(a) {
            this.n = a;
            this.g("IsDuringManipulation");
        }
        get viewer() {
            return this.l;
        }
        set viewer(a) {
            this.l = a;
            this.g("Viewer");
        }
    }
    PlotAreaMouseEventArgsDescription.$t = /*@__PURE__*/ markType(PlotAreaMouseEventArgsDescription, 'PlotAreaMouseEventArgsDescription', Description.$);
    return PlotAreaMouseEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransitionOutCompletedEventArgsDescription = /*@__PURE__*/ (() => {
    class TransitionOutCompletedEventArgsDescription extends Description {
        get_type() {
            return "TransitionOutCompletedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    TransitionOutCompletedEventArgsDescription.$t = /*@__PURE__*/ markType(TransitionOutCompletedEventArgsDescription, 'TransitionOutCompletedEventArgsDescription', Description.$);
    return TransitionOutCompletedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransitionOutCompletedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class TransitionOutCompletedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (TransitionOutCompletedEventArgsDescriptionMetadata.a == null) {
                TransitionOutCompletedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TransitionOutCompletedEventArgsDescriptionMetadata.c(TransitionOutCompletedEventArgsDescriptionMetadata.a);
            }
            if (a.k(TransitionOutCompletedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(TransitionOutCompletedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            TransitionOutCompletedEventArgsDescriptionMetadata.b(a);
            a.ae("TransitionOutCompletedEventArgs", () => new TransitionOutCompletedEventArgsDescription());
            a.ad("TransitionOutCompletedEventArgs", TransitionOutCompletedEventArgsDescriptionMetadata.a);
        }
    }
    TransitionOutCompletedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(TransitionOutCompletedEventArgsDescriptionMetadata, 'TransitionOutCompletedEventArgsDescriptionMetadata');
    TransitionOutCompletedEventArgsDescriptionMetadata.a = null;
    return TransitionOutCompletedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RenderRequestedEventArgsDescription = /*@__PURE__*/ (() => {
    class RenderRequestedEventArgsDescription extends Description {
        get_type() {
            return "RenderRequestedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
        }
        get animate() {
            return this.h;
        }
        set animate(a) {
            this.h = a;
            this.g("Animate");
        }
    }
    RenderRequestedEventArgsDescription.$t = /*@__PURE__*/ markType(RenderRequestedEventArgsDescription, 'RenderRequestedEventArgsDescription', Description.$);
    return RenderRequestedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RenderRequestedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class RenderRequestedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (RenderRequestedEventArgsDescriptionMetadata.a == null) {
                RenderRequestedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RenderRequestedEventArgsDescriptionMetadata.c(RenderRequestedEventArgsDescriptionMetadata.a);
            }
            if (a.k(RenderRequestedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(RenderRequestedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Animate", "Boolean");
        }
        static d(a) {
            RenderRequestedEventArgsDescriptionMetadata.b(a);
            a.ae("RenderRequestedEventArgs", () => new RenderRequestedEventArgsDescription());
            a.ad("RenderRequestedEventArgs", RenderRequestedEventArgsDescriptionMetadata.a);
        }
    }
    RenderRequestedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(RenderRequestedEventArgsDescriptionMetadata, 'RenderRequestedEventArgsDescriptionMetadata');
    RenderRequestedEventArgsDescriptionMetadata.a = null;
    return RenderRequestedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class SeriesDescriptionMetadata extends Base {
        static b(a) {
            if (SeriesDescriptionMetadata.a == null) {
                SeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SeriesDescriptionMetadata.c(SeriesDescriptionMetadata.a);
            }
            if (a.k(SeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(SeriesDescriptionMetadata.a);
            TransitionOutCompletedEventArgsDescriptionMetadata.d(a);
            RenderRequestedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("DataLegendGroup", "String");
            a.item("HighlightedValuesDataLegendGroup", "String");
            a.item("HighlightedValuesExtraPropertyOverlays", "Collection:SeriesLayerPropertyOverlay:SeriesLayerPropertyOverlayCollection:SeriesLayerPropertyOverlay");
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)DataRef::object");
            a.item("HighlightedDataSourceRef", "(w:HighlightedItemsSource,xam:HighlightedItemsSource,wf:HighlightedDataSource)DataRef::object");
            a.item("LegendRef", "(w:Legend,wf:Legend)DataRef::object");
            a.item("LegendItemVisibility", "ExportedType:string:Visibility");
            a.item("LegendItemVisibility@names", "Visible;Collapsed");
            a.item("LegendItemBadgeTemplateRef", "(w:LegendItemBadgeTemplate,wf:LegendItemBadgeTemplate)DataRef::object");
            a.item("ActualLegendItemBadgeTemplateRef", "(w:ActualLegendItemBadgeTemplate,wf:ActualLegendItemBadgeTemplate)DataRef::object");
            a.item("ActualLegendItemBadgeOutline", "Brush");
            a.item("ActualLegendItemBadgeBrush", "Brush");
            a.item("LegendItemBadgeShape", "ExportedType:string:LegendItemBadgeShape");
            a.item("LegendItemBadgeShape@names", "Automatic;Circle;Line;Square;Marker;Bar;Column;Hidden");
            a.item("LegendItemBadgeMode", "ExportedType:string:LegendItemBadgeMode");
            a.item("LegendItemBadgeMode@names", "Simplified;MatchSeries");
            a.item("LegendItemTemplateRef", "(w:LegendItemTemplate,wf:LegendItemTemplate)DataRef::object");
            a.item("DiscreteLegendItemTemplateRef", "(w:DiscreteLegendItemTemplate,wf:DiscreteLegendItemTemplate)DataRef::object");
            a.item("TransitionEasingFunctionRef", "(w:TransitionEasingFunction,wf:TransitionEasingFunction)MethodRef");
            a.item("TransitionInEasingFunctionRef", "(w:TransitionInEasingFunction,wf:TransitionInEasingFunction)MethodRef");
            a.item("TransitionOutEasingFunctionRef", "(w:TransitionOutEasingFunction,wf:TransitionOutEasingFunction)MethodRef");
            a.item("TransitionDuration", "Number:int");
            a.item("ActualResolution", "Number:double");
            a.item("Resolution", "Number:double");
            a.item("VisibleRangeMarginTop", "Number:double");
            a.item("VisibleRangeMarginBottom", "Number:double");
            a.item("VisibleRangeMarginLeft", "Number:double");
            a.item("VisibleRangeMarginRight", "Number:double");
            a.item("HighlightedTitleSuffix", "String");
            a.item("HighlightedLegendItemVisibility", "ExportedType:string:Visibility");
            a.item("HighlightedLegendItemVisibility@names", "Visible;Collapsed");
            a.item("Brush", "Brush");
            a.item("ActualBrush", "Brush");
            a.item("SelectionBrush", "Brush");
            a.item("FocusBrush", "Brush");
            a.item("ActualSelectionBrush", "Brush");
            a.item("ActualFocusBrush", "Brush");
            a.item("SafeActualBrush", "Brush");
            a.item("Outline", "Brush");
            a.item("ActualOutline", "Brush");
            a.item("LineJoin", "ExportedType:string:PenLineJoin");
            a.item("LineJoin@names", "Miter;Bevel;Round");
            a.item("HighlightedValuesDisplayMode", "ExportedType:string:SeriesHighlightedValuesDisplayMode");
            a.item("HighlightedValuesDisplayMode@names", "Auto;Hidden;Overlay");
            a.item("ShouldAnimateOnDataSourceSwap", "Boolean");
            a.item("Thickness", "Number:double");
            a.item("ActualThickness", "Number:double");
            a.item("DashArray", "DoubleCollection:double");
            a.item("ActualHighlightingMode", "ExportedType:string:SeriesHighlightingMode");
            a.item("ActualHighlightingMode@names", "Auto;None;BrightenSpecific;Brighten;FadeOthersSpecific;FadeOthers");
            a.item("ActualSelectionMode", "ExportedType:string:SeriesSelectionMode");
            a.item("ActualSelectionMode@names", "Auto;None;Brighten;FadeOthers;GrayscaleOthers;FocusColorThickOutline;FocusColorOutline;SelectionColorThickOutline;SelectionColorOutline;FocusColorFill;SelectionColorFill;ThickOutline");
            a.item("ActualFocusMode", "ExportedType:string:SeriesSelectionMode");
            a.item("ActualFocusMode@names", "Auto;None;Brighten;FadeOthers;GrayscaleOthers;FocusColorThickOutline;FocusColorOutline;SelectionColorThickOutline;SelectionColorOutline;FocusColorFill;SelectionColorFill;ThickOutline");
            a.item("ActualHighlightedValuesFadeOpacity", "Number:double");
            a.item("HighlightedValuesFadeOpacity", "Number:double");
            a.item("ActualHighlightingFadeOpacity", "Number:double");
            a.item("HighlightingFadeOpacity", "Number:double");
            a.item("IsActualLegendFinancial", "Boolean");
            a.item("IsComponentHighlightingModeIgnored", "Boolean");
            a.item("IsHighlightingEnabled", "Boolean");
            a.item("UseItemWiseColors", "Boolean");
            a.item("ShouldShiftOpacityForSafeActualBrush", "Boolean");
            a.item("ShouldRemoveHighlightedDataOnLayerHidden", "Boolean");
            a.item("ShouldHideAutoCallouts", "Boolean");
            a.item("IsDropShadowEnabled", "Boolean");
            a.item("ShadowBlur", "Number:double");
            a.item("ShadowColor", "Color");
            a.item("UseSingleShadow", "Boolean");
            a.item("ShadowOffsetX", "Number:double");
            a.item("ShadowOffsetY", "Number:double");
            a.item("AreaFillOpacity", "Number:double");
            a.item("ActualAreaFillOpacity", "Number:double");
            a.item("MarkerFillOpacity", "Number:double");
            a.item("ActualMarkerFillOpacity", "Number:double");
            a.item("IsDefaultToolTipSelected", "Boolean");
            a.item("ShowDefaultTooltip", "Boolean");
            a.item("VisibleRangeMode", "ExportedType:string:SeriesVisibleRangeMode");
            a.item("VisibleRangeMode@names", "Auto;ValuesOnly;IncludeReferenceValue");
            a.item("OutlineMode", "ExportedType:string:SeriesOutlineMode");
            a.item("OutlineMode@names", "Auto;Visible;Collapsed");
            a.item("TransitionInDuration", "Number:int");
            a.item("TransitionOutDuration", "Number:int");
            a.item("TransitionInSpeedType", "ExportedType:string:TransitionInSpeedType");
            a.item("TransitionInSpeedType@names", "Auto;Normal;ValueScaled;IndexScaled;Random");
            a.item("TransitionOutSpeedType", "ExportedType:string:TransitionOutSpeedType");
            a.item("TransitionOutSpeedType@names", "Auto;Normal;ValueScaled;IndexScaled;Random");
            a.item("LineCap", "ExportedType:string:PenLineCap");
            a.item("LineCap@names", "Flat;Square;Round;Triangle");
            a.item("AutoCalloutLabelFormat", "String");
            a.item("AutoCalloutLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("AutoCalloutLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("AutoCalloutValueLabelFormat", "String");
            a.item("AutoCalloutValueLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("AutoCalloutValueLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("MouseOverEnabled", "Boolean");
            a.item("CoercionMethodsRef", "(w:CoercionMethods,wf:CoercionMethods)DataRef");
            a.item("ExpectFunctions", "Boolean");
            a.item("HitTestMode", "ExportedType:string:SeriesHitTestMode");
            a.item("HitTestMode@names", "Auto;Computational;ColorEncoded");
            a.item("ActualHitTestMode", "ExportedType:string:SeriesHitTestMode");
            a.item("ActualHitTestMode@names", "Auto;Computational;ColorEncoded");
            a.item("FinalValue", "Number:double");
            a.item("PercentChange", "Number:double");
            a.item("Layers", "Collection:SeriesLayer:SeriesLayerCollection:SeriesLayer");
            a.item("ActualLayers", "Collection:SeriesLayer:SeriesLayerCollection:SeriesLayer");
            a.item("Opacity", "Number:double");
            a.item("Visibility", "ExportedType:string:Visibility");
            a.item("Visibility@names", "Visible;Collapsed");
            a.item("TransitionOutCompletedRef", "EventRef::transitionOutCompleted");
            a.item("RenderRequestedRef", "EventRef::renderRequested");
            SeriesDescriptionMetadata.e(a);
        }
        static d(a) {
            SeriesDescriptionMetadata.b(a);
            a.ad("Series", SeriesDescriptionMetadata.a);
        }
        static e(a) {
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource)DataRef:String");
            a.item("Title", "String");
            a.item("TooltipTemplateRef", "(w:ToolTip)DataRef:String");
        }
    }
    SeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(SeriesDescriptionMetadata, 'SeriesDescriptionMetadata');
    SeriesDescriptionMetadata.a = null;
    return SeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartCursorEventArgsDescription = /*@__PURE__*/ (() => {
    class ChartCursorEventArgsDescription extends Description {
        get_type() {
            return "ChartCursorEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.h = null;
            this.j = null;
        }
        get itemRef() {
            return this.l;
        }
        set itemRef(a) {
            this.l = a;
            this.g("ItemRef");
        }
        get series() {
            return this.h;
        }
        set series(a) {
            this.h = a;
            this.g("Series");
        }
        get seriesViewer() {
            return this.j;
        }
        set seriesViewer(a) {
            this.j = a;
            this.g("SeriesViewer");
        }
    }
    ChartCursorEventArgsDescription.$t = /*@__PURE__*/ markType(ChartCursorEventArgsDescription, 'ChartCursorEventArgsDescription', Description.$);
    return ChartCursorEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartMouseEventArgsDescription = /*@__PURE__*/ (() => {
    class ChartMouseEventArgsDescription extends Description {
        get_type() {
            return "ChartMouseEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.h = null;
            this.j = null;
        }
        get itemRef() {
            return this.l;
        }
        set itemRef(a) {
            this.l = a;
            this.g("ItemRef");
        }
        get series() {
            return this.h;
        }
        set series(a) {
            this.h = a;
            this.g("Series");
        }
        get chart() {
            return this.j;
        }
        set chart(a) {
            this.j = a;
            this.g("Chart");
        }
    }
    ChartMouseEventArgsDescription.$t = /*@__PURE__*/ markType(ChartMouseEventArgsDescription, 'ChartMouseEventArgsDescription', Description.$);
    return ChartMouseEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartMouseButtonEventArgsDescription = /*@__PURE__*/ (() => {
    class DataChartMouseButtonEventArgsDescription extends Description {
        get_type() {
            return "DataChartMouseButtonEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = false;
            this.n = null;
            this.h = null;
            this.j = null;
        }
        get handled() {
            return this.l;
        }
        set handled(a) {
            this.l = a;
            this.g("Handled");
        }
        get itemRef() {
            return this.n;
        }
        set itemRef(a) {
            this.n = a;
            this.g("ItemRef");
        }
        get series() {
            return this.h;
        }
        set series(a) {
            this.h = a;
            this.g("Series");
        }
        get chart() {
            return this.j;
        }
        set chart(a) {
            this.j = a;
            this.g("Chart");
        }
    }
    DataChartMouseButtonEventArgsDescription.$t = /*@__PURE__*/ markType(DataChartMouseButtonEventArgsDescription, 'DataChartMouseButtonEventArgsDescription', Description.$);
    return DataChartMouseButtonEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesViewerManipulationEventArgsDescription = /*@__PURE__*/ (() => {
    class SeriesViewerManipulationEventArgsDescription extends Description {
        get_type() {
            return "SeriesViewerManipulationEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = false;
            this.h = false;
        }
        get isZoomPan() {
            return this.i;
        }
        set isZoomPan(a) {
            this.i = a;
            this.g("IsZoomPan");
        }
        get isDragZoom() {
            return this.h;
        }
        set isDragZoom(a) {
            this.h = a;
            this.g("IsDragZoom");
        }
    }
    SeriesViewerManipulationEventArgsDescription.$t = /*@__PURE__*/ markType(SeriesViewerManipulationEventArgsDescription, 'SeriesViewerManipulationEventArgsDescription', Description.$);
    return SeriesViewerManipulationEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesViewerManipulationEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SeriesViewerManipulationEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SeriesViewerManipulationEventArgsDescriptionMetadata.a == null) {
                SeriesViewerManipulationEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SeriesViewerManipulationEventArgsDescriptionMetadata.c(SeriesViewerManipulationEventArgsDescriptionMetadata.a);
            }
            if (a.k(SeriesViewerManipulationEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(SeriesViewerManipulationEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("IsZoomPan", "Boolean");
            a.item("IsDragZoom", "Boolean");
        }
        static d(a) {
            SeriesViewerManipulationEventArgsDescriptionMetadata.b(a);
            a.ae("SeriesViewerManipulationEventArgs", () => new SeriesViewerManipulationEventArgsDescription());
            a.ad("SeriesViewerManipulationEventArgs", SeriesViewerManipulationEventArgsDescriptionMetadata.a);
        }
    }
    SeriesViewerManipulationEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SeriesViewerManipulationEventArgsDescriptionMetadata, 'SeriesViewerManipulationEventArgsDescriptionMetadata');
    SeriesViewerManipulationEventArgsDescriptionMetadata.a = null;
    return SeriesViewerManipulationEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class RectChangedEventArgsDescription extends Description {
        get_type() {
            return "RectChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
        }
        get oldRect() {
            return this.i;
        }
        set oldRect(a) {
            this.i = a;
            this.g("OldRect");
        }
        get newRect() {
            return this.h;
        }
        set newRect(a) {
            this.h = a;
            this.g("NewRect");
        }
    }
    RectChangedEventArgsDescription.$t = /*@__PURE__*/ markType(RectChangedEventArgsDescription, 'RectChangedEventArgsDescription', Description.$);
    return RectChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class RectChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (RectChangedEventArgsDescriptionMetadata.a == null) {
                RectChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RectChangedEventArgsDescriptionMetadata.c(RectChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(RectChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(RectChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("OldRect", "Rect");
            a.item("NewRect", "Rect");
        }
        static d(a) {
            RectChangedEventArgsDescriptionMetadata.b(a);
            a.ae("RectChangedEventArgs", () => new RectChangedEventArgsDescription());
            a.ad("RectChangedEventArgs", RectChangedEventArgsDescriptionMetadata.a);
        }
    }
    RectChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(RectChangedEventArgsDescriptionMetadata, 'RectChangedEventArgsDescriptionMetadata');
    RectChangedEventArgsDescriptionMetadata.a = null;
    return RectChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesViewerSelectedSeriesItemsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class SeriesViewerSelectedSeriesItemsChangedEventArgsDescription extends Description {
        get_type() {
            return "SeriesViewerSelectedSeriesItemsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.i = null;
            this.h = null;
        }
        get oldItems() {
            return this.j;
        }
        set oldItems(a) {
            this.j = a;
            this.g("OldItems");
        }
        get newItems() {
            return this.i;
        }
        set newItems(a) {
            this.i = a;
            this.g("NewItems");
        }
        get currentItems() {
            return this.h;
        }
        set currentItems(a) {
            this.h = a;
            this.g("CurrentItems");
        }
    }
    SeriesViewerSelectedSeriesItemsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(SeriesViewerSelectedSeriesItemsChangedEventArgsDescription, 'SeriesViewerSelectedSeriesItemsChangedEventArgsDescription', Description.$);
    return SeriesViewerSelectedSeriesItemsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata.a == null) {
                SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata.c(SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("OldItems", "Collection:ChartSelection:ChartSelectedItemCollection:ChartSelection");
            a.item("NewItems", "Collection:ChartSelection:ChartSelectedItemCollection:ChartSelection");
            a.item("CurrentItems", "Collection:ChartSelection:ChartSelectedItemCollection:ChartSelection");
        }
        static d(a) {
            SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata.b(a);
            a.ae("SeriesViewerSelectedSeriesItemsChangedEventArgs", () => new SeriesViewerSelectedSeriesItemsChangedEventArgsDescription());
            a.ad("SeriesViewerSelectedSeriesItemsChangedEventArgs", SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata.a);
        }
    }
    SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata, 'SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata');
    SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata.a = null;
    return SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RefreshCompletedEventArgsDescription = /*@__PURE__*/ (() => {
    class RefreshCompletedEventArgsDescription extends Description {
        get_type() {
            return "RefreshCompletedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    RefreshCompletedEventArgsDescription.$t = /*@__PURE__*/ markType(RefreshCompletedEventArgsDescription, 'RefreshCompletedEventArgsDescription', Description.$);
    return RefreshCompletedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RefreshCompletedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class RefreshCompletedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (RefreshCompletedEventArgsDescriptionMetadata.a == null) {
                RefreshCompletedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RefreshCompletedEventArgsDescriptionMetadata.c(RefreshCompletedEventArgsDescriptionMetadata.a);
            }
            if (a.k(RefreshCompletedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(RefreshCompletedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            RefreshCompletedEventArgsDescriptionMetadata.b(a);
            a.ae("RefreshCompletedEventArgs", () => new RefreshCompletedEventArgsDescription());
            a.ad("RefreshCompletedEventArgs", RefreshCompletedEventArgsDescriptionMetadata.a);
        }
    }
    RefreshCompletedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(RefreshCompletedEventArgsDescriptionMetadata, 'RefreshCompletedEventArgsDescriptionMetadata');
    RefreshCompletedEventArgsDescriptionMetadata.a = null;
    return RefreshCompletedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageCapturedEventArgsDescription = /*@__PURE__*/ (() => {
    class ImageCapturedEventArgsDescription extends Description {
        get_type() {
            return "ImageCapturedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ImageCapturedEventArgsDescription.$t = /*@__PURE__*/ markType(ImageCapturedEventArgsDescription, 'ImageCapturedEventArgsDescription', Description.$);
    return ImageCapturedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageCapturedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ImageCapturedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ImageCapturedEventArgsDescriptionMetadata.a == null) {
                ImageCapturedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ImageCapturedEventArgsDescriptionMetadata.c(ImageCapturedEventArgsDescriptionMetadata.a);
            }
            if (a.k(ImageCapturedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ImageCapturedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ImageCapturedEventArgsDescriptionMetadata.b(a);
            a.ae("ImageCapturedEventArgs", () => new ImageCapturedEventArgsDescription());
            a.ad("ImageCapturedEventArgs", ImageCapturedEventArgsDescriptionMetadata.a);
        }
    }
    ImageCapturedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ImageCapturedEventArgsDescriptionMetadata, 'ImageCapturedEventArgsDescriptionMetadata');
    ImageCapturedEventArgsDescriptionMetadata.a = null;
    return ImageCapturedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PlotAreaMouseButtonEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class PlotAreaMouseButtonEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (PlotAreaMouseButtonEventArgsDescriptionMetadata.a == null) {
                PlotAreaMouseButtonEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PlotAreaMouseButtonEventArgsDescriptionMetadata.c(PlotAreaMouseButtonEventArgsDescriptionMetadata.a);
            }
            if (a.k(PlotAreaMouseButtonEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(PlotAreaMouseButtonEventArgsDescriptionMetadata.a);
            SeriesViewerDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("ChartPosition", "Point");
            a.item("PlotAreaPosition", "Point");
            a.item("ManipulationOccurred", "Boolean");
            a.item("Viewer", "ExportedType:SeriesViewer");
        }
        static d(a) {
            PlotAreaMouseButtonEventArgsDescriptionMetadata.b(a);
            a.ae("PlotAreaMouseButtonEventArgs", () => new PlotAreaMouseButtonEventArgsDescription());
            a.ad("PlotAreaMouseButtonEventArgs", PlotAreaMouseButtonEventArgsDescriptionMetadata.a);
        }
    }
    PlotAreaMouseButtonEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(PlotAreaMouseButtonEventArgsDescriptionMetadata, 'PlotAreaMouseButtonEventArgsDescriptionMetadata');
    PlotAreaMouseButtonEventArgsDescriptionMetadata.a = null;
    return PlotAreaMouseButtonEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let PlotAreaMouseEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class PlotAreaMouseEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (PlotAreaMouseEventArgsDescriptionMetadata.a == null) {
                PlotAreaMouseEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PlotAreaMouseEventArgsDescriptionMetadata.c(PlotAreaMouseEventArgsDescriptionMetadata.a);
            }
            if (a.k(PlotAreaMouseEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(PlotAreaMouseEventArgsDescriptionMetadata.a);
            SeriesViewerDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("ChartPosition", "Point");
            a.item("PlotAreaPosition", "Point");
            a.item("IsDuringManipulation", "Boolean");
            a.item("Viewer", "ExportedType:SeriesViewer");
        }
        static d(a) {
            PlotAreaMouseEventArgsDescriptionMetadata.b(a);
            a.ae("PlotAreaMouseEventArgs", () => new PlotAreaMouseEventArgsDescription());
            a.ad("PlotAreaMouseEventArgs", PlotAreaMouseEventArgsDescriptionMetadata.a);
        }
    }
    PlotAreaMouseEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(PlotAreaMouseEventArgsDescriptionMetadata, 'PlotAreaMouseEventArgsDescriptionMetadata');
    PlotAreaMouseEventArgsDescriptionMetadata.a = null;
    return PlotAreaMouseEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let ChartCursorEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ChartCursorEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ChartCursorEventArgsDescriptionMetadata.a == null) {
                ChartCursorEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ChartCursorEventArgsDescriptionMetadata.c(ChartCursorEventArgsDescriptionMetadata.a);
            }
            if (a.k(ChartCursorEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ChartCursorEventArgsDescriptionMetadata.a);
            SeriesDescriptionMetadata.d(a);
            SeriesViewerDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("Series", "ExportedType:Series");
            a.item("SeriesViewer", "ExportedType:SeriesViewer");
        }
        static d(a) {
            ChartCursorEventArgsDescriptionMetadata.b(a);
            a.ae("ChartCursorEventArgs", () => new ChartCursorEventArgsDescription());
            a.ad("ChartCursorEventArgs", ChartCursorEventArgsDescriptionMetadata.a);
        }
    }
    ChartCursorEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ChartCursorEventArgsDescriptionMetadata, 'ChartCursorEventArgsDescriptionMetadata');
    ChartCursorEventArgsDescriptionMetadata.a = null;
    return ChartCursorEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let ChartMouseEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ChartMouseEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ChartMouseEventArgsDescriptionMetadata.a == null) {
                ChartMouseEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ChartMouseEventArgsDescriptionMetadata.c(ChartMouseEventArgsDescriptionMetadata.a);
            }
            if (a.k(ChartMouseEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ChartMouseEventArgsDescriptionMetadata.a);
            SeriesDescriptionMetadata.d(a);
            SeriesViewerDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("Series", "ExportedType:Series");
            a.item("Chart", "ExportedType:SeriesViewer");
        }
        static d(a) {
            ChartMouseEventArgsDescriptionMetadata.b(a);
            a.ae("ChartMouseEventArgs", () => new ChartMouseEventArgsDescription());
            a.ad("ChartMouseEventArgs", ChartMouseEventArgsDescriptionMetadata.a);
        }
    }
    ChartMouseEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ChartMouseEventArgsDescriptionMetadata, 'ChartMouseEventArgsDescriptionMetadata');
    ChartMouseEventArgsDescriptionMetadata.a = null;
    return ChartMouseEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let DataChartMouseButtonEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataChartMouseButtonEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DataChartMouseButtonEventArgsDescriptionMetadata.a == null) {
                DataChartMouseButtonEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataChartMouseButtonEventArgsDescriptionMetadata.c(DataChartMouseButtonEventArgsDescriptionMetadata.a);
            }
            if (a.k(DataChartMouseButtonEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataChartMouseButtonEventArgsDescriptionMetadata.a);
            SeriesDescriptionMetadata.d(a);
            SeriesViewerDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Handled", "Boolean");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("Series", "ExportedType:Series");
            a.item("Chart", "ExportedType:SeriesViewer");
        }
        static d(a) {
            DataChartMouseButtonEventArgsDescriptionMetadata.b(a);
            a.ae("DataChartMouseButtonEventArgs", () => new DataChartMouseButtonEventArgsDescription());
            a.ad("DataChartMouseButtonEventArgs", DataChartMouseButtonEventArgsDescriptionMetadata.a);
        }
    }
    DataChartMouseButtonEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataChartMouseButtonEventArgsDescriptionMetadata, 'DataChartMouseButtonEventArgsDescriptionMetadata');
    DataChartMouseButtonEventArgsDescriptionMetadata.a = null;
    return DataChartMouseButtonEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let SeriesViewerDescriptionMetadata = /*@__PURE__*/ (() => {
    class SeriesViewerDescriptionMetadata extends Base {
        static b(a) {
            if (SeriesViewerDescriptionMetadata.a == null) {
                SeriesViewerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SeriesViewerDescriptionMetadata.c(SeriesViewerDescriptionMetadata.a);
            }
            if (a.k(SeriesViewerDescriptionMetadata.a)) {
                return;
            }
            a.ac(SeriesViewerDescriptionMetadata.a);
            PlotAreaMouseButtonEventArgsDescriptionMetadata.d(a);
            PlotAreaMouseEventArgsDescriptionMetadata.d(a);
            ChartCursorEventArgsDescriptionMetadata.d(a);
            DataChartMouseButtonEventArgsDescriptionMetadata.d(a);
            ChartMouseEventArgsDescriptionMetadata.d(a);
            SeriesViewerManipulationEventArgsDescriptionMetadata.d(a);
            RectChangedEventArgsDescriptionMetadata.d(a);
            SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata.d(a);
            RefreshCompletedEventArgsDescriptionMetadata.d(a);
            ImageCapturedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Series", "Collection:Series:SeriesCollection:Series");
            a.item("Brushes", "BrushCollection:string");
            a.item("Outlines", "BrushCollection:string");
            a.item("MarkerBrushes", "BrushCollection:string");
            a.item("MarkerOutlines", "BrushCollection:string");
            a.item("MarkerAutomaticBehavior", "ExportedType:string:MarkerAutomaticBehavior");
            a.item("MarkerAutomaticBehavior@names", "CircleSmart;None;SmartIndexed;Indexed;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram");
            a.item("CrosshairPoint", "Point");
            a.item("LegendRef", "(w:Legend,wf:Legend)DataRef::object");
            a.item("AnimateSeriesWhenAxisRangeChanges", "Boolean");
            a.item("IsWindowSyncedToVisibleRange", "Boolean");
            a.item("ShouldSimulateHoverMoveCrosshairPoint", "Boolean");
            a.item("HighlightingMode", "ExportedType:string:SeriesHighlightingMode");
            a.item("HighlightingMode@names", "Auto;None;BrightenSpecific;Brighten;FadeOthersSpecific;FadeOthers");
            a.item("SelectionMode", "ExportedType:string:SeriesSelectionMode");
            a.item("SelectionMode@names", "Auto;None;Brighten;FadeOthers;GrayscaleOthers;FocusColorThickOutline;FocusColorOutline;SelectionColorThickOutline;SelectionColorOutline;FocusColorFill;SelectionColorFill;ThickOutline");
            a.item("SelectionBehavior", "ExportedType:string:SeriesSelectionBehavior");
            a.item("SelectionBehavior@names", "Auto;PerDataItemMultiSelect;PerDataItemSingleSelect;PerSeriesAndDataItemMultiSelect;PerSeriesAndDataItemSingleSelect;PerSeriesAndDataItemGlobalSingleSelect;PerSeriesMultiSelect;PerSeriesSingleSelect");
            a.item("FocusMode", "ExportedType:string:SeriesSelectionMode");
            a.item("FocusMode@names", "Auto;None;Brighten;FadeOthers;GrayscaleOthers;FocusColorThickOutline;FocusColorOutline;SelectionColorThickOutline;SelectionColorOutline;FocusColorFill;SelectionColorFill;ThickOutline");
            a.item("HorizontalViewScrollbarMode", "ExportedType:string:SeriesViewerScrollbarMode");
            a.item("HorizontalViewScrollbarMode@names", "None;Fading;FadeToLine;Persistent");
            a.item("VerticalViewScrollbarMode", "ExportedType:string:SeriesViewerScrollbarMode");
            a.item("VerticalViewScrollbarMode@names", "None;Fading;FadeToLine;Persistent");
            a.item("HorizontalViewScrollbarPosition", "ExportedType:string:SeriesViewerHorizontalScrollbarPosition");
            a.item("HorizontalViewScrollbarPosition@names", "Auto;InsideBottom;InsideTop");
            a.item("VerticalViewScrollbarPosition", "ExportedType:string:SeriesViewerVerticalScrollbarPosition");
            a.item("VerticalViewScrollbarPosition@names", "Auto;InsideLeft;InsideRight");
            a.item("HorizontalViewScrollbarFill", "Brush");
            a.item("HorizontalViewScrollbarOutline", "Brush");
            a.item("HorizontalViewScrollbarStrokeThickness", "Number:double");
            a.item("HorizontalViewScrollbarMaxOpacity", "Number:double");
            a.item("HorizontalViewScrollbarCornerRadius", "Number:double");
            a.item("HorizontalViewScrollbarHeight", "Number:double");
            a.item("HorizontalViewScrollbarInset", "Number:double");
            a.item("HorizontalViewScrollbarTrackStartInset", "Number:double");
            a.item("HorizontalViewScrollbarTrackEndInset", "Number:double");
            a.item("HorizontalViewScrollbarShouldAddAutoTrackInsets", "Boolean");
            a.item("VerticalViewScrollbarFill", "Brush");
            a.item("VerticalViewScrollbarOutline", "Brush");
            a.item("VerticalViewScrollbarStrokeThickness", "Number:double");
            a.item("VerticalViewScrollbarMaxOpacity", "Number:double");
            a.item("VerticalViewScrollbarCornerRadius", "Number:double");
            a.item("VerticalViewScrollbarWidth", "Number:double");
            a.item("VerticalViewScrollbarInset", "Number:double");
            a.item("VerticalViewScrollbarTrackStartInset", "Number:double");
            a.item("VerticalViewScrollbarTrackEndInset", "Number:double");
            a.item("VerticalViewScrollbarShouldAddAutoTrackInsets", "Boolean");
            a.item("HighlightingBehavior", "ExportedType:string:SeriesHighlightingBehavior");
            a.item("HighlightingBehavior@names", "Auto;DirectlyOver;NearestItems;NearestItemsRetainMainShapes;NearestItemsAndSeries");
            a.item("LegendHighlightingMode", "ExportedType:string:LegendHighlightingMode");
            a.item("LegendHighlightingMode@names", "Auto;None;MatchSeries");
            a.item("LegendItemBadgeShape", "ExportedType:string:LegendItemBadgeShape");
            a.item("LegendItemBadgeShape@names", "Automatic;Circle;Line;Square;Marker;Bar;Column;Hidden");
            a.item("LegendItemBadgeMode", "ExportedType:string:LegendItemBadgeMode");
            a.item("LegendItemBadgeMode@names", "Simplified;MatchSeries");
            a.item("EffectiveViewport", "Rect");
            a.item("WindowRect", "Rect");
            a.item("UseTiledZooming", "Boolean");
            a.item("PreferHigherResolutionTiles", "Boolean");
            a.item("ZoomTileCacheSize", "Number:int");
            a.item("HighlightingTransitionDuration", "Number:int");
            a.item("SelectionTransitionDuration", "Number:int");
            a.item("FocusTransitionDuration", "Number:int");
            a.item("ScrollbarsAnimationDuration", "Number:int");
            a.item("IsPagePanningAllowed", "Boolean");
            a.item("ContentHitTestMode", "ExportedType:string:ChartHitTestMode");
            a.item("ContentHitTestMode@names", "Auto;Computational;ColorEncoded;Mixed;MixedFavoringComputational");
            a.item("ActualContentHitTestMode", "ExportedType:string:ChartHitTestMode");
            a.item("ActualContentHitTestMode@names", "Auto;Computational;ColorEncoded;Mixed;MixedFavoringComputational");
            a.item("IsSurfaceInteractionDisabled", "Boolean");
            a.item("WindowResponse", "ExportedType:string:WindowResponse");
            a.item("WindowResponse@names", "Deferred;Immediate");
            a.item("WindowRectMinWidth", "Number:double");
            a.item("WindowRectMinHeight", "Number:double");
            a.item("ActualWindowRectMinWidth", "Number:double");
            a.item("ActualWindowRectMinHeight", "Number:double");
            a.item("WindowSizeMinWidth", "Number:double");
            a.item("WindowSizeMinHeight", "Number:double");
            a.item("SyncChannel", "String");
            a.item("CrosshairVisibility", "ExportedType:string:Visibility");
            a.item("CrosshairVisibility@names", "Visible;Collapsed");
            a.item("HorizontalCrosshairBrush", "Brush");
            a.item("VerticalCrosshairBrush", "Brush");
            a.item("ZoomCoercionMode", "ExportedType:string:ZoomCoercionMode");
            a.item("ZoomCoercionMode@names", "Auto;AxisConstrained;Unconstrained");
            a.item("PlotAreaBackground", "Brush");
            a.item("DefaultInteraction", "ExportedType:string:InteractionState");
            a.item("DefaultInteraction@names", "None;DragZoom;DragPan;Auto");
            a.item("RightButtonDefaultInteraction", "ExportedType:string:InteractionState");
            a.item("RightButtonDefaultInteraction@names", "None;DragZoom;DragPan;Auto");
            a.item("DragModifier", "ExportedType:string:ModifierKeys");
            a.item("DragModifier@names", "None;Alt;Control;Shift;Windows;Apple");
            a.item("PanModifier", "ExportedType:string:ModifierKeys");
            a.item("PanModifier@names", "None;Alt;Control;Shift;Windows;Apple");
            a.item("PreviewRect", "Rect");
            a.item("HighlightedValuesDisplayMode", "ExportedType:string:SeriesHighlightedValuesDisplayMode");
            a.item("HighlightedValuesDisplayMode@names", "Auto;Hidden;Overlay");
            a.item("SelectedSeriesItems", "Collection:ChartSelection:ChartSelectedItemCollection:ChartSelection");
            a.item("FocusedSeriesItems", "Collection:ChartSelection:ChartSelectedItemCollection:ChartSelection");
            a.item("WindowPositionHorizontal", "Number:double");
            a.item("WindowPositionVertical", "Number:double");
            a.item("SelectionBrush", "Brush");
            a.item("FocusBrush", "Brush");
            a.item("ChartTitle", "(w:Title,xam:Title,wf:Title)String");
            a.item("TitleHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("TitleHorizontalAlignment@names", "Left;Center;Right;Stretch");
            a.item("SubtitleHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("SubtitleHorizontalAlignment@names", "Left;Center;Right;Stretch");
            a.item("TitleTextStyle", "String");
            a.item("SubtitleTextStyle", "String");
            a.item("TitleTextColor", "Brush");
            a.item("SubtitleTextColor", "Brush");
            a.item("TitleTopMargin", "Number:double");
            a.item("TitleLeftMargin", "Number:double");
            a.item("TitleRightMargin", "Number:double");
            a.item("TitleBottomMargin", "Number:double");
            a.item("SubtitleTopMargin", "Number:double");
            a.item("SubtitleLeftMargin", "Number:double");
            a.item("SubtitleRightMargin", "Number:double");
            a.item("SubtitleBottomMargin", "Number:double");
            a.item("Subtitle", "String");
            a.item("TopMargin", "Number:double");
            a.item("LeftMargin", "Number:double");
            a.item("RightMargin", "Number:double");
            a.item("BottomMargin", "Number:double");
            a.item("AutoMarginWidth", "Number:double");
            a.item("AutoMarginHeight", "Number:double");
            a.item("IsAntiAliasingEnabledDuringInteraction", "Boolean");
            a.item("PixelScalingRatio", "Number:double");
            a.item("InteractionPixelScalingRatio", "Number:double");
            a.item("ActualPixelScalingRatio", "Number:double");
            a.item("ActualInteractionPixelScalingRatio", "Number:double");
            a.item("ShouldPanOnMaximumZoom", "Boolean");
            a.item("ActualWindowRect", "Rect");
            a.item("ActualWindowPositionHorizontal", "Number:double");
            a.item("ActualWindowPositionVertical", "Number:double");
            a.item("PlotAreaMouseLeftButtonDownRef", "EventRef::plotAreaMouseLeftButtonDown");
            a.item("PlotAreaMouseLeftButtonUpRef", "EventRef::plotAreaMouseLeftButtonUp");
            a.item("PlotAreaClickedRef", "EventRef::plotAreaClicked");
            a.item("PlotAreaMouseEnterRef", "EventRef::plotAreaMouseEnter");
            a.item("PlotAreaMouseLeaveRef", "EventRef::plotAreaMouseLeave");
            a.item("PlotAreaMouseOverRef", "EventRef::plotAreaMouseOver");
            a.item("SeriesCursorMouseMoveRef", "EventRef::seriesCursorMouseMove");
            a.item("SeriesMouseLeftButtonDownRef", "EventRef::seriesMouseLeftButtonDown");
            a.item("SeriesMouseLeftButtonUpRef", "EventRef::seriesMouseLeftButtonUp");
            a.item("SeriesClickRef", "EventRef::seriesClick");
            a.item("SeriesMouseMoveRef", "EventRef::seriesMouseMove");
            a.item("SeriesMouseEnterRef", "EventRef::seriesMouseEnter");
            a.item("SeriesMouseLeaveRef", "EventRef::seriesMouseLeave");
            a.item("ViewerManipulationStartingRef", "EventRef::viewerManipulationStarting");
            a.item("ViewerManipulationEndingRef", "EventRef::viewerManipulationEnding");
            a.item("WindowRectChangedRef", "EventRef::windowRectChanged");
            a.item("SizeChangedRef", "EventRef::sizeChanged");
            a.item("ActualWindowRectChangedRef", "EventRef::actualWindowRectChanged");
            a.item("GridAreaRectChangedRef", "EventRef::gridAreaRectChanged");
            a.item("SelectedSeriesItemsChangedRef", "EventRef::selectedSeriesItemsChanged");
            a.item("FocusedSeriesItemsChangedRef", "EventRef::focusedSeriesItemsChanged");
            a.item("RefreshCompletedRef", "EventRef::refreshCompleted");
            a.item("ImageCapturedRef", "EventRef::imageCaptured");
            SeriesViewerDescriptionMetadata.e(a);
        }
        static d(a) {
            SeriesViewerDescriptionMetadata.b(a);
            a.ad("SeriesViewer", SeriesViewerDescriptionMetadata.a);
        }
        static e(a) {
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
            a.item("TitleFontFamily", "(w:TitleFontFamily/FontFamilyTransform,xam:TitleFontFamily,wf:TitleFontFamily,web:TitleTextStyle/FontFamilyTransform)String");
            a.item("TitleFontSize", "(w:TitleFontSize,xam:TitleFontSize,wf:TitleFontSize,web:TitleTextStyle/FontSizeTransform)Number:double");
            a.item("TitleFontStyle", "(w:TitleFontStyle/FontStyleTransform,xam:TitleTextStyle/FontStyleTransform,wf:TitleTextStyle/FontStyleTransform,web:TitleTextStyle/FontStyleTransform)String");
            a.item("TitleFontWeight", "(w:TitleFontWeight/FontWeightTransform,xam:TitleTextStyle/FontWeightTransform,wf:TitleTextStyle/FontWeightTransform,web:TitleTextStyle/FontWeightTransform)String");
            a.item("SubtitleFontFamily", "(w:SubtitleFontFamily/FontFamilyTransform,xam:SubtitleFontFamily,wf:SubtitleFontFamily,web:SubtitleTextStyle/FontFamilyTransform)String");
            a.item("SubtitleFontSize", "(w:SubtitleFontSize,xam:SubtitleFontSize,wf:SubtitleFontSize,web:SubtitleTextStyle/FontSizeTransform)Number:double");
            a.item("SubtitleFontStyle", "(w:SubtitleFontStyle/FontStyleTransform,xam:SubtitleTextStyle/FontStyleTransform,wf:SubtitleTextStyle/FontStyleTransform,web:SubtitleTextStyle/FontStyleTransform)String");
            a.item("SubtitleFontWeight", "(w:SubtitleFontWeight/FontWeightTransform,xam:SubtitleTextStyle/FontWeightTransform,wf:SubtitleTextStyle/FontWeightTransform,web:SubtitleTextStyle/FontWeightTransform)String");
            a.item("SynchronizeHorizontally", "Boolean");
            a.item("SynchronizeVertically", "Boolean");
        }
    }
    SeriesViewerDescriptionMetadata.$t = /*@__PURE__*/ markType(SeriesViewerDescriptionMetadata, 'SeriesViewerDescriptionMetadata');
    SeriesViewerDescriptionMetadata.a = null;
    return SeriesViewerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImagesChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class ImagesChangedEventArgsDescription extends Description {
        get_type() {
            return "ImagesChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ImagesChangedEventArgsDescription.$t = /*@__PURE__*/ markType(ImagesChangedEventArgsDescription, 'ImagesChangedEventArgsDescription', Description.$);
    return ImagesChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImagesChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ImagesChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ImagesChangedEventArgsDescriptionMetadata.a == null) {
                ImagesChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ImagesChangedEventArgsDescriptionMetadata.c(ImagesChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(ImagesChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ImagesChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ImagesChangedEventArgsDescriptionMetadata.b(a);
            a.ae("ImagesChangedEventArgs", () => new ImagesChangedEventArgsDescription());
            a.ad("ImagesChangedEventArgs", ImagesChangedEventArgsDescriptionMetadata.a);
        }
    }
    ImagesChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ImagesChangedEventArgsDescriptionMetadata, 'ImagesChangedEventArgsDescriptionMetadata');
    ImagesChangedEventArgsDescriptionMetadata.a = null;
    return ImagesChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CancellingMultiScaleImageEventArgsDescription = /*@__PURE__*/ (() => {
    class CancellingMultiScaleImageEventArgsDescription extends Description {
        get_type() {
            return "CancellingMultiScaleImageEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get uri() {
            return this.h;
        }
        set uri(a) {
            this.h = a;
            this.g("Uri");
        }
    }
    CancellingMultiScaleImageEventArgsDescription.$t = /*@__PURE__*/ markType(CancellingMultiScaleImageEventArgsDescription, 'CancellingMultiScaleImageEventArgsDescription', Description.$);
    return CancellingMultiScaleImageEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CancellingMultiScaleImageEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CancellingMultiScaleImageEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CancellingMultiScaleImageEventArgsDescriptionMetadata.a == null) {
                CancellingMultiScaleImageEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CancellingMultiScaleImageEventArgsDescriptionMetadata.c(CancellingMultiScaleImageEventArgsDescriptionMetadata.a);
            }
            if (a.k(CancellingMultiScaleImageEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(CancellingMultiScaleImageEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Uri", "String");
        }
        static d(a) {
            CancellingMultiScaleImageEventArgsDescriptionMetadata.b(a);
            a.ae("CancellingMultiScaleImageEventArgs", () => new CancellingMultiScaleImageEventArgsDescription());
            a.ad("CancellingMultiScaleImageEventArgs", CancellingMultiScaleImageEventArgsDescriptionMetadata.a);
        }
    }
    CancellingMultiScaleImageEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CancellingMultiScaleImageEventArgsDescriptionMetadata, 'CancellingMultiScaleImageEventArgsDescriptionMetadata');
    CancellingMultiScaleImageEventArgsDescriptionMetadata.a = null;
    return CancellingMultiScaleImageEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DownloadingMultiScaleImageEventArgsDescription = /*@__PURE__*/ (() => {
    class DownloadingMultiScaleImageEventArgsDescription extends Description {
        get_type() {
            return "DownloadingMultiScaleImageEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get uri() {
            return this.h;
        }
        set uri(a) {
            this.h = a;
            this.g("Uri");
        }
    }
    DownloadingMultiScaleImageEventArgsDescription.$t = /*@__PURE__*/ markType(DownloadingMultiScaleImageEventArgsDescription, 'DownloadingMultiScaleImageEventArgsDescription', Description.$);
    return DownloadingMultiScaleImageEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DownloadingMultiScaleImageEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DownloadingMultiScaleImageEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DownloadingMultiScaleImageEventArgsDescriptionMetadata.a == null) {
                DownloadingMultiScaleImageEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DownloadingMultiScaleImageEventArgsDescriptionMetadata.c(DownloadingMultiScaleImageEventArgsDescriptionMetadata.a);
            }
            if (a.k(DownloadingMultiScaleImageEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(DownloadingMultiScaleImageEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Uri", "String");
        }
        static d(a) {
            DownloadingMultiScaleImageEventArgsDescriptionMetadata.b(a);
            a.ae("DownloadingMultiScaleImageEventArgs", () => new DownloadingMultiScaleImageEventArgsDescription());
            a.ad("DownloadingMultiScaleImageEventArgs", DownloadingMultiScaleImageEventArgsDescriptionMetadata.a);
        }
    }
    DownloadingMultiScaleImageEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DownloadingMultiScaleImageEventArgsDescriptionMetadata, 'DownloadingMultiScaleImageEventArgsDescriptionMetadata');
    DownloadingMultiScaleImageEventArgsDescriptionMetadata.a = null;
    return DownloadingMultiScaleImageEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMapDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicMapDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicMapDescriptionMetadata.a == null) {
                GeographicMapDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicMapDescriptionMetadata.c(GeographicMapDescriptionMetadata.a);
            }
            if (a.k(GeographicMapDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicMapDescriptionMetadata.a);
            GeographicMapImageryDescriptionMetadata.d(a);
            ImageTilesReadyEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            SeriesViewerDescriptionMetadata.c(a);
            a.item("Zoomable", "Boolean");
            a.item("ResizeBehavior", "ExportedType:string:MapResizeBehavior");
            a.item("ResizeBehavior@names", "Auto;MaintainTopLeftPosition;MaintainCenterPosition");
            a.item("IsHorizontalWrappingEnabled", "Boolean");
            a.item("BackgroundTilingMode", "ExportedType:string:MapBackgroundTilingMode");
            a.item("BackgroundTilingMode@names", "Auto;NonWrapped;Wrapped");
            a.item("UseWorldRectForZoomBounds", "Boolean");
            a.item("SuppressZoomResetOnWorldRectChange", "Boolean");
            a.item("WorldRect", "Rect");
            a.item("ActualWorldRect", "Rect");
            a.item("BackgroundContent", "ExportedType:GeographicMapImagery");
            a.item("WindowScale", "Number:double");
            a.item("ActualWindowScale", "Number:double");
            a.item("ImageTilesReadyRef", "EventRef::imageTilesReady");
            GeographicMapDescriptionMetadata.e(a);
        }
        static d(a) {
            GeographicMapDescriptionMetadata.b(a);
            a.ae("GeographicMap", () => new GeographicMapDescription());
            a.ad("GeographicMap", GeographicMapDescriptionMetadata.a);
        }
        static e(a) {
            a.item("_qualifiedName", "String:Infragistics.Controls.Maps.XamGeographicMap");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
        }
    }
    GeographicMapDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicMapDescriptionMetadata, 'GeographicMapDescriptionMetadata');
    GeographicMapDescriptionMetadata.a = null;
    return GeographicMapDescriptionMetadata;
})();
/**
 * @hidden
 */
let GeographicMapImageryDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicMapImageryDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicMapImageryDescriptionMetadata.a == null) {
                GeographicMapImageryDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicMapImageryDescriptionMetadata.c(GeographicMapImageryDescriptionMetadata.a);
            }
            if (a.k(GeographicMapImageryDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicMapImageryDescriptionMetadata.a);
            GeographicMapDescriptionMetadata.d(a);
            ImageTilesReadyEventArgsDescriptionMetadata.d(a);
            ImagesChangedEventArgsDescriptionMetadata.d(a);
            CancellingMultiScaleImageEventArgsDescriptionMetadata.d(a);
            DownloadingMultiScaleImageEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("WindowRect", "Rect");
            a.item("GeographicMap", "ExportedType:XamGeographicMap");
            a.item("Referer", "String");
            a.item("IsHorizontalWrappingEnabled", "Boolean");
            a.item("UserAgent", "String");
            a.item("Opacity", "Number:double");
            a.item("ImageTilesReadyRef", "EventRef::imageTilesReady");
            a.item("ImagesChangedRef", "EventRef::imagesChanged");
            a.item("CancellingImageRef", "EventRef::cancellingImage");
            a.item("DownloadingImageRef", "EventRef::downloadingImage");
        }
        static d(a) {
            GeographicMapImageryDescriptionMetadata.b(a);
            a.ad("GeographicMapImagery", GeographicMapImageryDescriptionMetadata.a);
        }
    }
    GeographicMapImageryDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicMapImageryDescriptionMetadata, 'GeographicMapImageryDescriptionMetadata');
    GeographicMapImageryDescriptionMetadata.a = null;
    return GeographicMapImageryDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArcGISOnlineMapImageryDescriptionMetadata = /*@__PURE__*/ (() => {
    class ArcGISOnlineMapImageryDescriptionMetadata extends Base {
        static b(a) {
            if (ArcGISOnlineMapImageryDescriptionMetadata.a == null) {
                ArcGISOnlineMapImageryDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ArcGISOnlineMapImageryDescriptionMetadata.c(ArcGISOnlineMapImageryDescriptionMetadata.a);
            }
            if (a.k(ArcGISOnlineMapImageryDescriptionMetadata.a)) {
                return;
            }
            a.ac(ArcGISOnlineMapImageryDescriptionMetadata.a);
        }
        static c(a) {
            GeographicMapImageryDescriptionMetadata.c(a);
            a.item("MapServerUri", "String");
            a.item("UserName", "String");
            a.item("Password", "String");
            a.item("UserToken", "String");
            a.item("IsMapPublic", "Boolean");
            a.item("DefaultTokenTimeout", "Number:int");
            a.item("TokenGenerationEndPoint", "String");
            a.item("RefererUri", "String");
        }
        static d(a) {
            ArcGISOnlineMapImageryDescriptionMetadata.b(a);
            a.ae("ArcGISOnlineMapImagery", () => new ArcGISOnlineMapImageryDescription());
            a.ad("ArcGISOnlineMapImagery", ArcGISOnlineMapImageryDescriptionMetadata.a);
        }
    }
    ArcGISOnlineMapImageryDescriptionMetadata.$t = /*@__PURE__*/ markType(ArcGISOnlineMapImageryDescriptionMetadata, 'ArcGISOnlineMapImageryDescriptionMetadata');
    ArcGISOnlineMapImageryDescriptionMetadata.a = null;
    return ArcGISOnlineMapImageryDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArcGISOnlineMapImageryDescriptionModule = /*@__PURE__*/ (() => {
    class ArcGISOnlineMapImageryDescriptionModule extends Base {
        static register(a) {
            ArcGISOnlineMapImageryDescriptionMetadata.d(a);
        }
    }
    ArcGISOnlineMapImageryDescriptionModule.$t = /*@__PURE__*/ markType(ArcGISOnlineMapImageryDescriptionModule, 'ArcGISOnlineMapImageryDescriptionModule');
    return ArcGISOnlineMapImageryDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningSeriesStyleEventArgsBaseDescription = /*@__PURE__*/ (() => {
    class AssigningSeriesStyleEventArgsBaseDescription extends Description {
        get_type() {
            return "AssigningSeriesStyleEventArgsBase";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.a2 = 0;
            this.a1 = 0;
            this.w = new Date();
            this.v = new Date();
            this.a6 = null;
            this.a5 = null;
            this.a7 = null;
            this.ad = 0;
            this.z = 0;
            this.i = null;
            this.j = null;
            this.h = null;
            this.ab = 0;
            this.af = 0;
            this.ac = 0;
            this.ag = 0;
            this.aa = 0;
            this.ae = 0;
            this.aj = 0;
            this.ak = 0;
            this.ai = 0;
            this.am = 0;
            this.al = 0;
            this.ah = 0;
            this.o = false;
            this.n = false;
            this.p = false;
            this.q = false;
        }
        get startIndex() {
            return this.a2;
        }
        set startIndex(a) {
            this.a2 = a;
            this.g("StartIndex");
        }
        get endIndex() {
            return this.a1;
        }
        set endIndex(a) {
            this.a1 = a;
            this.g("EndIndex");
        }
        get startDate() {
            return this.w;
        }
        set startDate(a) {
            this.w = a;
            this.g("StartDate");
        }
        get endDate() {
            return this.v;
        }
        set endDate(a) {
            this.v = a;
            this.g("EndDate");
        }
        get getItemsRef() {
            return this.a6;
        }
        set getItemsRef(a) {
            this.a6 = a;
            this.g("GetItemsRef");
        }
        get fill() {
            return this.a5;
        }
        set fill(a) {
            this.a5 = a;
            this.g("Fill");
        }
        get stroke() {
            return this.a7;
        }
        set stroke(a) {
            this.a7 = a;
            this.g("Stroke");
        }
        get opacity() {
            return this.ad;
        }
        set opacity(a) {
            this.ad = a;
            this.g("Opacity");
        }
        get fadeOpacity() {
            return this.z;
        }
        set fadeOpacity(a) {
            this.z = a;
            this.g("FadeOpacity");
        }
        get highlightingInfo() {
            return this.i;
        }
        set highlightingInfo(a) {
            this.i = a;
            this.g("HighlightingInfo");
        }
        get selectionHighlightingInfo() {
            return this.j;
        }
        set selectionHighlightingInfo(a) {
            this.j = a;
            this.g("SelectionHighlightingInfo");
        }
        get focusHighlightingInfo() {
            return this.h;
        }
        set focusHighlightingInfo(a) {
            this.h = a;
            this.g("FocusHighlightingInfo");
        }
        get maxAllSeriesHighlightingProgress() {
            return this.ab;
        }
        set maxAllSeriesHighlightingProgress(a) {
            this.ab = a;
            this.g("MaxAllSeriesHighlightingProgress");
        }
        get sumAllSeriesHighlightingProgress() {
            return this.af;
        }
        set sumAllSeriesHighlightingProgress(a) {
            this.af = a;
            this.g("SumAllSeriesHighlightingProgress");
        }
        get maxAllSeriesSelectionHighlightingProgress() {
            return this.ac;
        }
        set maxAllSeriesSelectionHighlightingProgress(a) {
            this.ac = a;
            this.g("MaxAllSeriesSelectionHighlightingProgress");
        }
        get sumAllSeriesSelectionHighlightingProgress() {
            return this.ag;
        }
        set sumAllSeriesSelectionHighlightingProgress(a) {
            this.ag = a;
            this.g("SumAllSeriesSelectionHighlightingProgress");
        }
        get maxAllSeriesFocusHighlightingProgress() {
            return this.aa;
        }
        set maxAllSeriesFocusHighlightingProgress(a) {
            this.aa = a;
            this.g("MaxAllSeriesFocusHighlightingProgress");
        }
        get sumAllSeriesFocusHighlightingProgress() {
            return this.ae;
        }
        set sumAllSeriesFocusHighlightingProgress(a) {
            this.ae = a;
            this.g("SumAllSeriesFocusHighlightingProgress");
        }
        get totalAllSeriesHighlightingProgress() {
            return this.aj;
        }
        set totalAllSeriesHighlightingProgress(a) {
            this.aj = a;
            this.g("TotalAllSeriesHighlightingProgress");
        }
        get totalAllSeriesHighWaterMark() {
            return this.ak;
        }
        set totalAllSeriesHighWaterMark(a) {
            this.ak = a;
            this.g("TotalAllSeriesHighWaterMark");
        }
        get totalAllSeriesFocusHighWaterMark() {
            return this.ai;
        }
        set totalAllSeriesFocusHighWaterMark(a) {
            this.ai = a;
            this.g("TotalAllSeriesFocusHighWaterMark");
        }
        get totalAllSeriesSelectionHighWaterMark() {
            return this.am;
        }
        set totalAllSeriesSelectionHighWaterMark(a) {
            this.am = a;
            this.g("TotalAllSeriesSelectionHighWaterMark");
        }
        get totalAllSeriesSelectionHighlightingProgress() {
            return this.al;
        }
        set totalAllSeriesSelectionHighlightingProgress(a) {
            this.al = a;
            this.g("TotalAllSeriesSelectionHighlightingProgress");
        }
        get totalAllSeriesFocusHighlightingProgress() {
            return this.ah;
        }
        set totalAllSeriesFocusHighlightingProgress(a) {
            this.ah = a;
            this.g("TotalAllSeriesFocusHighlightingProgress");
        }
        get highlightingHandled() {
            return this.o;
        }
        set highlightingHandled(a) {
            this.o = a;
            this.g("HighlightingHandled");
        }
        get hasDateRange() {
            return this.n;
        }
        set hasDateRange(a) {
            this.n = a;
            this.g("HasDateRange");
        }
        get isNegativeShape() {
            return this.p;
        }
        set isNegativeShape(a) {
            this.p = a;
            this.g("IsNegativeShape");
        }
        get isThumbnail() {
            return this.q;
        }
        set isThumbnail(a) {
            this.q = a;
            this.g("IsThumbnail");
        }
    }
    AssigningSeriesStyleEventArgsBaseDescription.$t = /*@__PURE__*/ markType(AssigningSeriesStyleEventArgsBaseDescription, 'AssigningSeriesStyleEventArgsBaseDescription', Description.$);
    return AssigningSeriesStyleEventArgsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningPolarStyleEventArgsBaseDescription = /*@__PURE__*/ (() => {
    class AssigningPolarStyleEventArgsBaseDescription extends AssigningSeriesStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningPolarStyleEventArgsBase";
        }
        constructor() {
            super();
        }
    }
    AssigningPolarStyleEventArgsBaseDescription.$t = /*@__PURE__*/ markType(AssigningPolarStyleEventArgsBaseDescription, 'AssigningPolarStyleEventArgsBaseDescription', AssigningSeriesStyleEventArgsBaseDescription.$);
    return AssigningPolarStyleEventArgsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningPolarMarkerStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningPolarMarkerStyleEventArgsDescription extends AssigningPolarStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningPolarMarkerStyleEventArgs";
        }
        constructor() {
            super();
        }
    }
    AssigningPolarMarkerStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningPolarMarkerStyleEventArgsDescription, 'AssigningPolarMarkerStyleEventArgsDescription', AssigningPolarStyleEventArgsBaseDescription.$);
    return AssigningPolarMarkerStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HighlightingInfoDescription = /*@__PURE__*/ (() => {
    class HighlightingInfoDescription extends Description {
        get_type() {
            return "HighlightingInfo";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.q = 0;
            this.p = 0;
            this.u = null;
            this.n = 0;
            this.j = false;
            this.i = false;
            this.h = false;
            this.t = null;
        }
        get startIndex() {
            return this.q;
        }
        set startIndex(a) {
            this.q = a;
            this.g("StartIndex");
        }
        get endIndex() {
            return this.p;
        }
        set endIndex(a) {
            this.p = a;
            this.g("EndIndex");
        }
        get state() {
            return this.u;
        }
        set state(a) {
            this.u = a;
            this.g("State");
        }
        get progress() {
            return this.n;
        }
        set progress(a) {
            this.n = a;
            this.g("Progress");
        }
        get isMarker() {
            return this.j;
        }
        set isMarker(a) {
            this.j = a;
            this.g("IsMarker");
        }
        get isFullRange() {
            return this.i;
        }
        set isFullRange(a) {
            this.i = a;
            this.g("IsFullRange");
        }
        get isExclusive() {
            return this.h;
        }
        set isExclusive(a) {
            this.h = a;
            this.g("IsExclusive");
        }
        get contextRef() {
            return this.t;
        }
        set contextRef(a) {
            this.t = a;
            this.g("ContextRef");
        }
    }
    HighlightingInfoDescription.$t = /*@__PURE__*/ markType(HighlightingInfoDescription, 'HighlightingInfoDescription', Description.$);
    return HighlightingInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HighlightingInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class HighlightingInfoDescriptionMetadata extends Base {
        static b(a) {
            if (HighlightingInfoDescriptionMetadata.a == null) {
                HighlightingInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HighlightingInfoDescriptionMetadata.c(HighlightingInfoDescriptionMetadata.a);
            }
            if (a.k(HighlightingInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(HighlightingInfoDescriptionMetadata.a);
        }
        static c(a) {
            a.item("StartIndex", "Number:int");
            a.item("EndIndex", "Number:int");
            a.item("State", "ExportedType:string:HighlightingState");
            a.item("State@names", "Outward;Inward;Static");
            a.item("Progress", "Number:double");
            a.item("IsMarker", "Boolean");
            a.item("IsFullRange", "Boolean");
            a.item("IsExclusive", "Boolean");
            a.item("ContextRef", "(w:Context,wf:Context)DataRef");
        }
        static d(a) {
            HighlightingInfoDescriptionMetadata.b(a);
            a.ae("HighlightingInfo", () => new HighlightingInfoDescription());
            a.ad("HighlightingInfo", HighlightingInfoDescriptionMetadata.a);
        }
    }
    HighlightingInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(HighlightingInfoDescriptionMetadata, 'HighlightingInfoDescriptionMetadata');
    HighlightingInfoDescriptionMetadata.a = null;
    return HighlightingInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningSeriesStyleEventArgsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningSeriesStyleEventArgsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningSeriesStyleEventArgsBaseDescriptionMetadata.a == null) {
                AssigningSeriesStyleEventArgsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningSeriesStyleEventArgsBaseDescriptionMetadata.c(AssigningSeriesStyleEventArgsBaseDescriptionMetadata.a);
            }
            if (a.k(AssigningSeriesStyleEventArgsBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningSeriesStyleEventArgsBaseDescriptionMetadata.a);
            HighlightingInfoDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("StartIndex", "Number:int");
            a.item("EndIndex", "Number:int");
            a.item("StartDate", "Date");
            a.item("EndDate", "Date");
            a.item("GetItemsRef", "(w:GetItems,wf:GetItems)MethodRef");
            a.item("Fill", "Brush");
            a.item("Stroke", "Brush");
            a.item("Opacity", "Number:double");
            a.item("FadeOpacity", "Number:double");
            a.item("HighlightingInfo", "ExportedType:HighlightingInfo");
            a.item("SelectionHighlightingInfo", "ExportedType:HighlightingInfo");
            a.item("FocusHighlightingInfo", "ExportedType:HighlightingInfo");
            a.item("MaxAllSeriesHighlightingProgress", "Number:double");
            a.item("SumAllSeriesHighlightingProgress", "Number:double");
            a.item("MaxAllSeriesSelectionHighlightingProgress", "Number:double");
            a.item("SumAllSeriesSelectionHighlightingProgress", "Number:double");
            a.item("MaxAllSeriesFocusHighlightingProgress", "Number:double");
            a.item("SumAllSeriesFocusHighlightingProgress", "Number:double");
            a.item("TotalAllSeriesHighlightingProgress", "Number:double");
            a.item("TotalAllSeriesHighWaterMark", "Number:double");
            a.item("TotalAllSeriesFocusHighWaterMark", "Number:double");
            a.item("TotalAllSeriesSelectionHighWaterMark", "Number:double");
            a.item("TotalAllSeriesSelectionHighlightingProgress", "Number:double");
            a.item("TotalAllSeriesFocusHighlightingProgress", "Number:double");
            a.item("HighlightingHandled", "Boolean");
            a.item("HasDateRange", "Boolean");
            a.item("IsNegativeShape", "Boolean");
            a.item("IsThumbnail", "Boolean");
        }
        static d(a) {
            AssigningSeriesStyleEventArgsBaseDescriptionMetadata.b(a);
            a.ad("AssigningSeriesStyleEventArgsBase", AssigningSeriesStyleEventArgsBaseDescriptionMetadata.a);
        }
    }
    AssigningSeriesStyleEventArgsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningSeriesStyleEventArgsBaseDescriptionMetadata, 'AssigningSeriesStyleEventArgsBaseDescriptionMetadata');
    AssigningSeriesStyleEventArgsBaseDescriptionMetadata.a = null;
    return AssigningSeriesStyleEventArgsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningPolarStyleEventArgsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningPolarStyleEventArgsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningPolarStyleEventArgsBaseDescriptionMetadata.a == null) {
                AssigningPolarStyleEventArgsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningPolarStyleEventArgsBaseDescriptionMetadata.c(AssigningPolarStyleEventArgsBaseDescriptionMetadata.a);
            }
            if (a.k(AssigningPolarStyleEventArgsBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningPolarStyleEventArgsBaseDescriptionMetadata.a);
        }
        static c(a) {
            AssigningSeriesStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningPolarStyleEventArgsBaseDescriptionMetadata.b(a);
            a.ad("AssigningPolarStyleEventArgsBase", AssigningPolarStyleEventArgsBaseDescriptionMetadata.a);
        }
    }
    AssigningPolarStyleEventArgsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningPolarStyleEventArgsBaseDescriptionMetadata, 'AssigningPolarStyleEventArgsBaseDescriptionMetadata');
    AssigningPolarStyleEventArgsBaseDescriptionMetadata.a = null;
    return AssigningPolarStyleEventArgsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningPolarMarkerStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningPolarMarkerStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningPolarMarkerStyleEventArgsDescriptionMetadata.a == null) {
                AssigningPolarMarkerStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningPolarMarkerStyleEventArgsDescriptionMetadata.c(AssigningPolarMarkerStyleEventArgsDescriptionMetadata.a);
            }
            if (a.k(AssigningPolarMarkerStyleEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningPolarMarkerStyleEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            AssigningPolarStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningPolarMarkerStyleEventArgsDescriptionMetadata.b(a);
            a.ae("AssigningPolarMarkerStyleEventArgs", () => new AssigningPolarMarkerStyleEventArgsDescription());
            a.ad("AssigningPolarMarkerStyleEventArgs", AssigningPolarMarkerStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningPolarMarkerStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningPolarMarkerStyleEventArgsDescriptionMetadata, 'AssigningPolarMarkerStyleEventArgsDescriptionMetadata');
    AssigningPolarMarkerStyleEventArgsDescriptionMetadata.a = null;
    return AssigningPolarMarkerStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningSeriesShapeStyleEventArgsBaseDescription = /*@__PURE__*/ (() => {
    class AssigningSeriesShapeStyleEventArgsBaseDescription extends AssigningSeriesStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningSeriesShapeStyleEventArgsBase";
        }
        constructor() {
            super();
            this.bg = 0;
            this.bc = null;
            this.be = 0;
            this.bf = 0;
        }
        get strokeThickness() {
            return this.bg;
        }
        set strokeThickness(a) {
            this.bg = a;
            this.g("StrokeThickness");
        }
        get strokeDashArray() {
            return this.bc;
        }
        set strokeDashArray(a) {
            this.bc = a;
            this.g("StrokeDashArray");
        }
        get radiusX() {
            return this.be;
        }
        set radiusX(a) {
            this.be = a;
            this.g("RadiusX");
        }
        get radiusY() {
            return this.bf;
        }
        set radiusY(a) {
            this.bf = a;
            this.g("RadiusY");
        }
    }
    AssigningSeriesShapeStyleEventArgsBaseDescription.$t = /*@__PURE__*/ markType(AssigningSeriesShapeStyleEventArgsBaseDescription, 'AssigningSeriesShapeStyleEventArgsBaseDescription', AssigningSeriesStyleEventArgsBaseDescription.$);
    return AssigningSeriesShapeStyleEventArgsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningPolarStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningPolarStyleEventArgsDescription extends AssigningSeriesShapeStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningPolarStyleEventArgs";
        }
        constructor() {
            super();
        }
    }
    AssigningPolarStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningPolarStyleEventArgsDescription, 'AssigningPolarStyleEventArgsDescription', AssigningSeriesShapeStyleEventArgsBaseDescription.$);
    return AssigningPolarStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.a == null) {
                AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.c(AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.a);
            }
            if (a.k(AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.a);
        }
        static c(a) {
            AssigningSeriesStyleEventArgsBaseDescriptionMetadata.c(a);
            a.item("StrokeThickness", "Number:double");
            a.item("StrokeDashArray", "DoubleCollection:double");
            a.item("RadiusX", "Number:double");
            a.item("RadiusY", "Number:double");
        }
        static d(a) {
            AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.b(a);
            a.ad("AssigningSeriesShapeStyleEventArgsBase", AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.a);
        }
    }
    AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata, 'AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata');
    AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.a = null;
    return AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningPolarStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningPolarStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningPolarStyleEventArgsDescriptionMetadata.a == null) {
                AssigningPolarStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningPolarStyleEventArgsDescriptionMetadata.c(AssigningPolarStyleEventArgsDescriptionMetadata.a);
            }
            if (a.k(AssigningPolarStyleEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningPolarStyleEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningPolarStyleEventArgsDescriptionMetadata.b(a);
            a.ae("AssigningPolarStyleEventArgs", () => new AssigningPolarStyleEventArgsDescription());
            a.ad("AssigningPolarStyleEventArgs", AssigningPolarStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningPolarStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningPolarStyleEventArgsDescriptionMetadata, 'AssigningPolarStyleEventArgsDescriptionMetadata');
    AssigningPolarStyleEventArgsDescriptionMetadata.a = null;
    return AssigningPolarStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningRadialStyleEventArgsBaseDescription = /*@__PURE__*/ (() => {
    class AssigningRadialStyleEventArgsBaseDescription extends AssigningSeriesStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningRadialStyleEventArgsBase";
        }
        constructor() {
            super();
        }
    }
    AssigningRadialStyleEventArgsBaseDescription.$t = /*@__PURE__*/ markType(AssigningRadialStyleEventArgsBaseDescription, 'AssigningRadialStyleEventArgsBaseDescription', AssigningSeriesStyleEventArgsBaseDescription.$);
    return AssigningRadialStyleEventArgsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningRadialMarkerStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningRadialMarkerStyleEventArgsDescription extends AssigningRadialStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningRadialMarkerStyleEventArgs";
        }
        constructor() {
            super();
        }
    }
    AssigningRadialMarkerStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningRadialMarkerStyleEventArgsDescription, 'AssigningRadialMarkerStyleEventArgsDescription', AssigningRadialStyleEventArgsBaseDescription.$);
    return AssigningRadialMarkerStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningRadialStyleEventArgsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningRadialStyleEventArgsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningRadialStyleEventArgsBaseDescriptionMetadata.a == null) {
                AssigningRadialStyleEventArgsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningRadialStyleEventArgsBaseDescriptionMetadata.c(AssigningRadialStyleEventArgsBaseDescriptionMetadata.a);
            }
            if (a.k(AssigningRadialStyleEventArgsBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningRadialStyleEventArgsBaseDescriptionMetadata.a);
        }
        static c(a) {
            AssigningSeriesStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningRadialStyleEventArgsBaseDescriptionMetadata.b(a);
            a.ad("AssigningRadialStyleEventArgsBase", AssigningRadialStyleEventArgsBaseDescriptionMetadata.a);
        }
    }
    AssigningRadialStyleEventArgsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningRadialStyleEventArgsBaseDescriptionMetadata, 'AssigningRadialStyleEventArgsBaseDescriptionMetadata');
    AssigningRadialStyleEventArgsBaseDescriptionMetadata.a = null;
    return AssigningRadialStyleEventArgsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningRadialMarkerStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningRadialMarkerStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningRadialMarkerStyleEventArgsDescriptionMetadata.a == null) {
                AssigningRadialMarkerStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningRadialMarkerStyleEventArgsDescriptionMetadata.c(AssigningRadialMarkerStyleEventArgsDescriptionMetadata.a);
            }
            if (a.k(AssigningRadialMarkerStyleEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningRadialMarkerStyleEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            AssigningRadialStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningRadialMarkerStyleEventArgsDescriptionMetadata.b(a);
            a.ae("AssigningRadialMarkerStyleEventArgs", () => new AssigningRadialMarkerStyleEventArgsDescription());
            a.ad("AssigningRadialMarkerStyleEventArgs", AssigningRadialMarkerStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningRadialMarkerStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningRadialMarkerStyleEventArgsDescriptionMetadata, 'AssigningRadialMarkerStyleEventArgsDescriptionMetadata');
    AssigningRadialMarkerStyleEventArgsDescriptionMetadata.a = null;
    return AssigningRadialMarkerStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningRadialStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningRadialStyleEventArgsDescription extends AssigningSeriesShapeStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningRadialStyleEventArgs";
        }
        constructor() {
            super();
        }
    }
    AssigningRadialStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningRadialStyleEventArgsDescription, 'AssigningRadialStyleEventArgsDescription', AssigningSeriesShapeStyleEventArgsBaseDescription.$);
    return AssigningRadialStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningRadialStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningRadialStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningRadialStyleEventArgsDescriptionMetadata.a == null) {
                AssigningRadialStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningRadialStyleEventArgsDescriptionMetadata.c(AssigningRadialStyleEventArgsDescriptionMetadata.a);
            }
            if (a.k(AssigningRadialStyleEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningRadialStyleEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningRadialStyleEventArgsDescriptionMetadata.b(a);
            a.ae("AssigningRadialStyleEventArgs", () => new AssigningRadialStyleEventArgsDescription());
            a.ad("AssigningRadialStyleEventArgs", AssigningRadialStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningRadialStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningRadialStyleEventArgsDescriptionMetadata, 'AssigningRadialStyleEventArgsDescriptionMetadata');
    AssigningRadialStyleEventArgsDescriptionMetadata.a = null;
    return AssigningRadialStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningScatterStyleEventArgsBaseDescription = /*@__PURE__*/ (() => {
    class AssigningScatterStyleEventArgsBaseDescription extends AssigningSeriesStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningScatterStyleEventArgsBase";
        }
        constructor() {
            super();
        }
    }
    AssigningScatterStyleEventArgsBaseDescription.$t = /*@__PURE__*/ markType(AssigningScatterStyleEventArgsBaseDescription, 'AssigningScatterStyleEventArgsBaseDescription', AssigningSeriesStyleEventArgsBaseDescription.$);
    return AssigningScatterStyleEventArgsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningScatterMarkerStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningScatterMarkerStyleEventArgsDescription extends AssigningScatterStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningScatterMarkerStyleEventArgs";
        }
        constructor() {
            super();
        }
    }
    AssigningScatterMarkerStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningScatterMarkerStyleEventArgsDescription, 'AssigningScatterMarkerStyleEventArgsDescription', AssigningScatterStyleEventArgsBaseDescription.$);
    return AssigningScatterMarkerStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningScatterStyleEventArgsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningScatterStyleEventArgsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningScatterStyleEventArgsBaseDescriptionMetadata.a == null) {
                AssigningScatterStyleEventArgsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningScatterStyleEventArgsBaseDescriptionMetadata.c(AssigningScatterStyleEventArgsBaseDescriptionMetadata.a);
            }
            if (a.k(AssigningScatterStyleEventArgsBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningScatterStyleEventArgsBaseDescriptionMetadata.a);
        }
        static c(a) {
            AssigningSeriesStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningScatterStyleEventArgsBaseDescriptionMetadata.b(a);
            a.ad("AssigningScatterStyleEventArgsBase", AssigningScatterStyleEventArgsBaseDescriptionMetadata.a);
        }
    }
    AssigningScatterStyleEventArgsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningScatterStyleEventArgsBaseDescriptionMetadata, 'AssigningScatterStyleEventArgsBaseDescriptionMetadata');
    AssigningScatterStyleEventArgsBaseDescriptionMetadata.a = null;
    return AssigningScatterStyleEventArgsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningScatterMarkerStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningScatterMarkerStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningScatterMarkerStyleEventArgsDescriptionMetadata.a == null) {
                AssigningScatterMarkerStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningScatterMarkerStyleEventArgsDescriptionMetadata.c(AssigningScatterMarkerStyleEventArgsDescriptionMetadata.a);
            }
            if (a.k(AssigningScatterMarkerStyleEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningScatterMarkerStyleEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            AssigningScatterStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningScatterMarkerStyleEventArgsDescriptionMetadata.b(a);
            a.ae("AssigningScatterMarkerStyleEventArgs", () => new AssigningScatterMarkerStyleEventArgsDescription());
            a.ad("AssigningScatterMarkerStyleEventArgs", AssigningScatterMarkerStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningScatterMarkerStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningScatterMarkerStyleEventArgsDescriptionMetadata, 'AssigningScatterMarkerStyleEventArgsDescriptionMetadata');
    AssigningScatterMarkerStyleEventArgsDescriptionMetadata.a = null;
    return AssigningScatterMarkerStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningScatterStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningScatterStyleEventArgsDescription extends AssigningSeriesShapeStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningScatterStyleEventArgs";
        }
        constructor() {
            super();
        }
    }
    AssigningScatterStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningScatterStyleEventArgsDescription, 'AssigningScatterStyleEventArgsDescription', AssigningSeriesShapeStyleEventArgsBaseDescription.$);
    return AssigningScatterStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningScatterStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningScatterStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningScatterStyleEventArgsDescriptionMetadata.a == null) {
                AssigningScatterStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningScatterStyleEventArgsDescriptionMetadata.c(AssigningScatterStyleEventArgsDescriptionMetadata.a);
            }
            if (a.k(AssigningScatterStyleEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningScatterStyleEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningScatterStyleEventArgsDescriptionMetadata.b(a);
            a.ae("AssigningScatterStyleEventArgs", () => new AssigningScatterStyleEventArgsDescription());
            a.ad("AssigningScatterStyleEventArgs", AssigningScatterStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningScatterStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningScatterStyleEventArgsDescriptionMetadata, 'AssigningScatterStyleEventArgsDescriptionMetadata');
    AssigningScatterStyleEventArgsDescriptionMetadata.a = null;
    return AssigningScatterStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningShapeStyleEventArgsBaseDescription = /*@__PURE__*/ (() => {
    class AssigningShapeStyleEventArgsBaseDescription extends AssigningSeriesStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningShapeStyleEventArgsBase";
        }
        constructor() {
            super();
        }
    }
    AssigningShapeStyleEventArgsBaseDescription.$t = /*@__PURE__*/ markType(AssigningShapeStyleEventArgsBaseDescription, 'AssigningShapeStyleEventArgsBaseDescription', AssigningSeriesStyleEventArgsBaseDescription.$);
    return AssigningShapeStyleEventArgsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningShapeMarkerStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningShapeMarkerStyleEventArgsDescription extends AssigningShapeStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningShapeMarkerStyleEventArgs";
        }
        constructor() {
            super();
        }
    }
    AssigningShapeMarkerStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningShapeMarkerStyleEventArgsDescription, 'AssigningShapeMarkerStyleEventArgsDescription', AssigningShapeStyleEventArgsBaseDescription.$);
    return AssigningShapeMarkerStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningShapeStyleEventArgsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningShapeStyleEventArgsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningShapeStyleEventArgsBaseDescriptionMetadata.a == null) {
                AssigningShapeStyleEventArgsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningShapeStyleEventArgsBaseDescriptionMetadata.c(AssigningShapeStyleEventArgsBaseDescriptionMetadata.a);
            }
            if (a.k(AssigningShapeStyleEventArgsBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningShapeStyleEventArgsBaseDescriptionMetadata.a);
        }
        static c(a) {
            AssigningSeriesStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningShapeStyleEventArgsBaseDescriptionMetadata.b(a);
            a.ad("AssigningShapeStyleEventArgsBase", AssigningShapeStyleEventArgsBaseDescriptionMetadata.a);
        }
    }
    AssigningShapeStyleEventArgsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningShapeStyleEventArgsBaseDescriptionMetadata, 'AssigningShapeStyleEventArgsBaseDescriptionMetadata');
    AssigningShapeStyleEventArgsBaseDescriptionMetadata.a = null;
    return AssigningShapeStyleEventArgsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningShapeMarkerStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningShapeMarkerStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningShapeMarkerStyleEventArgsDescriptionMetadata.a == null) {
                AssigningShapeMarkerStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningShapeMarkerStyleEventArgsDescriptionMetadata.c(AssigningShapeMarkerStyleEventArgsDescriptionMetadata.a);
            }
            if (a.k(AssigningShapeMarkerStyleEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningShapeMarkerStyleEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            AssigningShapeStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningShapeMarkerStyleEventArgsDescriptionMetadata.b(a);
            a.ae("AssigningShapeMarkerStyleEventArgs", () => new AssigningShapeMarkerStyleEventArgsDescription());
            a.ad("AssigningShapeMarkerStyleEventArgs", AssigningShapeMarkerStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningShapeMarkerStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningShapeMarkerStyleEventArgsDescriptionMetadata, 'AssigningShapeMarkerStyleEventArgsDescriptionMetadata');
    AssigningShapeMarkerStyleEventArgsDescriptionMetadata.a = null;
    return AssigningShapeMarkerStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningShapeStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningShapeStyleEventArgsDescription extends AssigningSeriesShapeStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningShapeStyleEventArgs";
        }
        constructor() {
            super();
        }
    }
    AssigningShapeStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningShapeStyleEventArgsDescription, 'AssigningShapeStyleEventArgsDescription', AssigningSeriesShapeStyleEventArgsBaseDescription.$);
    return AssigningShapeStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningShapeStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningShapeStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningShapeStyleEventArgsDescriptionMetadata.a == null) {
                AssigningShapeStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningShapeStyleEventArgsDescriptionMetadata.c(AssigningShapeStyleEventArgsDescriptionMetadata.a);
            }
            if (a.k(AssigningShapeStyleEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningShapeStyleEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningShapeStyleEventArgsDescriptionMetadata.b(a);
            a.ae("AssigningShapeStyleEventArgs", () => new AssigningShapeStyleEventArgsDescription());
            a.ad("AssigningShapeStyleEventArgs", AssigningShapeStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningShapeStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningShapeStyleEventArgsDescriptionMetadata, 'AssigningShapeStyleEventArgsDescriptionMetadata');
    AssigningShapeStyleEventArgsDescriptionMetadata.a = null;
    return AssigningShapeStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncCompletedEventArgsDescription = /*@__PURE__*/ (() => {
    class AsyncCompletedEventArgsDescription extends Description {
        get_type() {
            return "AsyncCompletedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    AsyncCompletedEventArgsDescription.$t = /*@__PURE__*/ markType(AsyncCompletedEventArgsDescription, 'AsyncCompletedEventArgsDescription', Description.$);
    return AsyncCompletedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncCompletedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AsyncCompletedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AsyncCompletedEventArgsDescriptionMetadata.a == null) {
                AsyncCompletedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AsyncCompletedEventArgsDescriptionMetadata.c(AsyncCompletedEventArgsDescriptionMetadata.a);
            }
            if (a.k(AsyncCompletedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AsyncCompletedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            AsyncCompletedEventArgsDescriptionMetadata.b(a);
            a.ae("AsyncCompletedEventArgs", () => new AsyncCompletedEventArgsDescription());
            a.ad("AsyncCompletedEventArgs", AsyncCompletedEventArgsDescriptionMetadata.a);
        }
    }
    AsyncCompletedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AsyncCompletedEventArgsDescriptionMetadata, 'AsyncCompletedEventArgsDescriptionMetadata');
    AsyncCompletedEventArgsDescriptionMetadata.a = null;
    return AsyncCompletedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BaseDataSourceDescription = /*@__PURE__*/ (() => {
    class BaseDataSourceDescription extends Description {
        get_type() {
            return "BaseDataSource";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.o = false;
            this.n = false;
            this.al = 0;
            this.am = 0;
            this.an = 0;
            this.l = false;
            this.h = null;
            this.i = null;
            this.at = null;
            this.p = false;
            this.r = false;
            this.m = false;
            this.t = false;
            this.s = false;
            this.q = false;
            this.v = false;
            this.u = false;
            this.w = false;
            this.x = false;
            this.as = null;
            this.ar = null;
        }
        get isReadOnly() {
            return this.o;
        }
        set isReadOnly(a) {
            this.o = a;
            this.g("IsReadOnly");
        }
        get isBatchingEnabled() {
            return this.n;
        }
        set isBatchingEnabled(a) {
            this.n = a;
            this.g("IsBatchingEnabled");
        }
        get actualCount() {
            return this.al;
        }
        set actualCount(a) {
            this.al = a;
            this.g("ActualCount");
        }
        get firstVisibleIndexRequested() {
            return this.am;
        }
        set firstVisibleIndexRequested(a) {
            this.am = a;
            this.g("FirstVisibleIndexRequested");
        }
        get lastVisibleIndexRequested() {
            return this.an;
        }
        set lastVisibleIndexRequested(a) {
            this.an = a;
            this.g("LastVisibleIndexRequested");
        }
        get deferAutoRefresh() {
            return this.l;
        }
        set deferAutoRefresh(a) {
            this.l = a;
            this.g("DeferAutoRefresh");
        }
        get primaryKey() {
            return this.h;
        }
        set primaryKey(a) {
            this.h = a;
            this.g("PrimaryKey");
        }
        get propertiesRequested() {
            return this.i;
        }
        set propertiesRequested(a) {
            this.i = a;
            this.g("PropertiesRequested");
        }
        get sectionHeaderDisplayMode() {
            return this.at;
        }
        set sectionHeaderDisplayMode(a) {
            this.at = a;
            this.g("SectionHeaderDisplayMode");
        }
        get isSectionCollapsable() {
            return this.p;
        }
        set isSectionCollapsable(a) {
            this.p = a;
            this.g("IsSectionCollapsable");
        }
        get isSectionExpandedDefault() {
            return this.r;
        }
        set isSectionExpandedDefault(a) {
            this.r = a;
            this.g("IsSectionExpandedDefault");
        }
        get includeSummaryRowsInSection() {
            return this.m;
        }
        set includeSummaryRowsInSection(a) {
            this.m = a;
            this.g("IncludeSummaryRowsInSection");
        }
        get isSectionSummaryRowsAtBottom() {
            return this.t;
        }
        set isSectionSummaryRowsAtBottom(a) {
            this.t = a;
            this.g("IsSectionSummaryRowsAtBottom");
        }
        get isSectionHeaderNormalRow() {
            return this.s;
        }
        set isSectionHeaderNormalRow(a) {
            this.s = a;
            this.g("IsSectionHeaderNormalRow");
        }
        get isSectionContentVisible() {
            return this.q;
        }
        set isSectionContentVisible(a) {
            this.q = a;
            this.g("IsSectionContentVisible");
        }
        get shouldEmitSectionHeaders() {
            return this.v;
        }
        set shouldEmitSectionHeaders(a) {
            this.v = a;
            this.g("ShouldEmitSectionHeaders");
        }
        get shouldEmitSectionFooters() {
            return this.u;
        }
        set shouldEmitSectionFooters(a) {
            this.u = a;
            this.g("ShouldEmitSectionFooters");
        }
        get shouldEmitShiftedRows() {
            return this.w;
        }
        set shouldEmitShiftedRows(a) {
            this.w = a;
            this.g("ShouldEmitShiftedRows");
        }
        get shouldEmitSummaryRows() {
            return this.x;
        }
        set shouldEmitSummaryRows(a) {
            this.x = a;
            this.g("ShouldEmitSummaryRows");
        }
        get schemaChangedRef() {
            return this.as;
        }
        set schemaChangedRef(a) {
            this.as = a;
            this.g("SchemaChangedRef");
        }
        get rowExpansionChangedRef() {
            return this.ar;
        }
        set rowExpansionChangedRef(a) {
            this.ar = a;
            this.g("RowExpansionChangedRef");
        }
    }
    BaseDataSourceDescription.$t = /*@__PURE__*/ markType(BaseDataSourceDescription, 'BaseDataSourceDescription', Description.$);
    return BaseDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSchemaChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class DataSourceSchemaChangedEventArgsDescription extends Description {
        get_type() {
            return "DataSourceSchemaChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    DataSourceSchemaChangedEventArgsDescription.$t = /*@__PURE__*/ markType(DataSourceSchemaChangedEventArgsDescription, 'DataSourceSchemaChangedEventArgsDescription', Description.$);
    return DataSourceSchemaChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSchemaChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataSourceSchemaChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DataSourceSchemaChangedEventArgsDescriptionMetadata.a == null) {
                DataSourceSchemaChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataSourceSchemaChangedEventArgsDescriptionMetadata.c(DataSourceSchemaChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(DataSourceSchemaChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataSourceSchemaChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            DataSourceSchemaChangedEventArgsDescriptionMetadata.b(a);
            a.ae("DataSourceSchemaChangedEventArgs", () => new DataSourceSchemaChangedEventArgsDescription());
            a.ad("DataSourceSchemaChangedEventArgs", DataSourceSchemaChangedEventArgsDescriptionMetadata.a);
        }
    }
    DataSourceSchemaChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataSourceSchemaChangedEventArgsDescriptionMetadata, 'DataSourceSchemaChangedEventArgsDescriptionMetadata');
    DataSourceSchemaChangedEventArgsDescriptionMetadata.a = null;
    return DataSourceSchemaChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceRowExpansionChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class DataSourceRowExpansionChangedEventArgsDescription extends Description {
        get_type() {
            return "DataSourceRowExpansionChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    DataSourceRowExpansionChangedEventArgsDescription.$t = /*@__PURE__*/ markType(DataSourceRowExpansionChangedEventArgsDescription, 'DataSourceRowExpansionChangedEventArgsDescription', Description.$);
    return DataSourceRowExpansionChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceRowExpansionChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataSourceRowExpansionChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DataSourceRowExpansionChangedEventArgsDescriptionMetadata.a == null) {
                DataSourceRowExpansionChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataSourceRowExpansionChangedEventArgsDescriptionMetadata.c(DataSourceRowExpansionChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(DataSourceRowExpansionChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataSourceRowExpansionChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            DataSourceRowExpansionChangedEventArgsDescriptionMetadata.b(a);
            a.ae("DataSourceRowExpansionChangedEventArgs", () => new DataSourceRowExpansionChangedEventArgsDescription());
            a.ad("DataSourceRowExpansionChangedEventArgs", DataSourceRowExpansionChangedEventArgsDescriptionMetadata.a);
        }
    }
    DataSourceRowExpansionChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataSourceRowExpansionChangedEventArgsDescriptionMetadata, 'DataSourceRowExpansionChangedEventArgsDescriptionMetadata');
    DataSourceRowExpansionChangedEventArgsDescriptionMetadata.a = null;
    return DataSourceRowExpansionChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BaseDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class BaseDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (BaseDataSourceDescriptionMetadata.a == null) {
                BaseDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BaseDataSourceDescriptionMetadata.c(BaseDataSourceDescriptionMetadata.a);
            }
            if (a.k(BaseDataSourceDescriptionMetadata.a)) {
                return;
            }
            a.ac(BaseDataSourceDescriptionMetadata.a);
            DataSourceSchemaChangedEventArgsDescriptionMetadata.d(a);
            DataSourceRowExpansionChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("IsReadOnly", "Boolean");
            a.item("IsBatchingEnabled", "Boolean");
            a.item("ActualCount", "Number:int");
            a.item("FirstVisibleIndexRequested", "Number:int");
            a.item("LastVisibleIndexRequested", "Number:int");
            a.item("DeferAutoRefresh", "Boolean");
            a.item("PrimaryKey", "Array:string");
            a.item("PropertiesRequested", "Array:string");
            a.item("SectionHeaderDisplayMode", "ExportedType:string:DataSourceSectionHeaderDisplayMode");
            a.item("SectionHeaderDisplayMode@names", "Combined;Split");
            a.item("IsSectionCollapsable", "Boolean");
            a.item("IsSectionExpandedDefault", "Boolean");
            a.item("IncludeSummaryRowsInSection", "Boolean");
            a.item("IsSectionSummaryRowsAtBottom", "Boolean");
            a.item("IsSectionHeaderNormalRow", "Boolean");
            a.item("IsSectionContentVisible", "Boolean");
            a.item("ShouldEmitSectionHeaders", "Boolean");
            a.item("ShouldEmitSectionFooters", "Boolean");
            a.item("ShouldEmitShiftedRows", "Boolean");
            a.item("ShouldEmitSummaryRows", "Boolean");
            a.item("SchemaChangedRef", "EventRef::schemaChanged");
            a.item("RowExpansionChangedRef", "EventRef::rowExpansionChanged");
        }
        static d(a) {
            BaseDataSourceDescriptionMetadata.b(a);
            a.ad("BaseDataSource", BaseDataSourceDescriptionMetadata.a);
        }
    }
    BaseDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(BaseDataSourceDescriptionMetadata, 'BaseDataSourceDescriptionMetadata');
    BaseDataSourceDescriptionMetadata.a = null;
    return BaseDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BingMapsMapImageryDescription = /*@__PURE__*/ (() => {
    class BingMapsMapImageryDescription extends GeographicMapImageryDescription {
        get_type() {
            return "BingMapsMapImagery";
        }
        constructor() {
            super();
            this.ah = false;
            this.ag = false;
            this.aq = null;
            this.al = null;
            this.ad = null;
            this.ac = null;
            this.an = null;
            this.ak = null;
            this.ao = null;
            this.am = null;
            this.ap = null;
        }
        get isInitialized() {
            return this.ah;
        }
        set isInitialized(a) {
            this.ah = a;
            this.g("IsInitialized");
        }
        get isDeferredLoad() {
            return this.ag;
        }
        set isDeferredLoad(a) {
            this.ag = a;
            this.g("IsDeferredLoad");
        }
        get tilePath() {
            return this.aq;
        }
        set tilePath(a) {
            this.aq = a;
            this.g("TilePath");
        }
        get actualTilePath() {
            return this.al;
        }
        set actualTilePath(a) {
            this.al = a;
            this.g("ActualTilePath");
        }
        get subDomains() {
            return this.ad;
        }
        set subDomains(a) {
            this.ad = a;
            this.g("SubDomains");
        }
        get actualSubDomains() {
            return this.ac;
        }
        set actualSubDomains(a) {
            this.ac = a;
            this.g("ActualSubDomains");
        }
        get bingImageryRestUri() {
            return this.an;
        }
        set bingImageryRestUri(a) {
            this.an = a;
            this.g("BingImageryRestUri");
        }
        get actualBingImageryRestUri() {
            return this.ak;
        }
        set actualBingImageryRestUri(a) {
            this.ak = a;
            this.g("ActualBingImageryRestUri");
        }
        get cultureName() {
            return this.ao;
        }
        set cultureName(a) {
            this.ao = a;
            this.g("CultureName");
        }
        get apiKey() {
            return this.am;
        }
        set apiKey(a) {
            this.am = a;
            this.g("ApiKey");
        }
        get imageryStyle() {
            return this.ap;
        }
        set imageryStyle(a) {
            this.ap = a;
            this.g("ImageryStyle");
        }
    }
    BingMapsMapImageryDescription.$t = /*@__PURE__*/ markType(BingMapsMapImageryDescription, 'BingMapsMapImageryDescription', GeographicMapImageryDescription.$);
    return BingMapsMapImageryDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BingMapsMapImageryDescriptionMetadata = /*@__PURE__*/ (() => {
    class BingMapsMapImageryDescriptionMetadata extends Base {
        static b(a) {
            if (BingMapsMapImageryDescriptionMetadata.a == null) {
                BingMapsMapImageryDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BingMapsMapImageryDescriptionMetadata.c(BingMapsMapImageryDescriptionMetadata.a);
            }
            if (a.k(BingMapsMapImageryDescriptionMetadata.a)) {
                return;
            }
            a.ac(BingMapsMapImageryDescriptionMetadata.a);
        }
        static c(a) {
            GeographicMapImageryDescriptionMetadata.c(a);
            a.item("IsInitialized", "Boolean");
            a.item("IsDeferredLoad", "Boolean");
            a.item("TilePath", "String");
            a.item("ActualTilePath", "String");
            a.item("SubDomains", "Collection:String:SubDomainsCollection:String");
            a.item("ActualSubDomains", "Collection:String:SubDomainsCollection:String");
            a.item("BingImageryRestUri", "String");
            a.item("ActualBingImageryRestUri", "String");
            a.item("CultureName", "String");
            a.item("ApiKey", "String");
            a.item("ImageryStyle", "ExportedType:string:BingMapsImageryStyle");
            a.item("ImageryStyle@names", "Aerial;AerialWithLabels;Road;CanvasDark;CanvasLight;CanvasGray");
        }
        static d(a) {
            BingMapsMapImageryDescriptionMetadata.b(a);
            a.ae("BingMapsMapImagery", () => new BingMapsMapImageryDescription());
            a.ad("BingMapsMapImagery", BingMapsMapImageryDescriptionMetadata.a);
        }
    }
    BingMapsMapImageryDescriptionMetadata.$t = /*@__PURE__*/ markType(BingMapsMapImageryDescriptionMetadata, 'BingMapsMapImageryDescriptionMetadata');
    BingMapsMapImageryDescriptionMetadata.a = null;
    return BingMapsMapImageryDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BingMapsMapImageryDescriptionModule = /*@__PURE__*/ (() => {
    class BingMapsMapImageryDescriptionModule extends Base {
        static register(a) {
            BingMapsMapImageryDescriptionMetadata.d(a);
        }
    }
    BingMapsMapImageryDescriptionModule.$t = /*@__PURE__*/ markType(BingMapsMapImageryDescriptionModule, 'BingMapsMapImageryDescriptionModule');
    return BingMapsMapImageryDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatLinearGraphLabelEventArgsDescription = /*@__PURE__*/ (() => {
    class FormatLinearGraphLabelEventArgsDescription extends Description {
        get_type() {
            return "FormatLinearGraphLabelEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    FormatLinearGraphLabelEventArgsDescription.$t = /*@__PURE__*/ markType(FormatLinearGraphLabelEventArgsDescription, 'FormatLinearGraphLabelEventArgsDescription', Description.$);
    return FormatLinearGraphLabelEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatLinearGraphLabelEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FormatLinearGraphLabelEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FormatLinearGraphLabelEventArgsDescriptionMetadata.a == null) {
                FormatLinearGraphLabelEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FormatLinearGraphLabelEventArgsDescriptionMetadata.c(FormatLinearGraphLabelEventArgsDescriptionMetadata.a);
            }
            if (a.k(FormatLinearGraphLabelEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(FormatLinearGraphLabelEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            FormatLinearGraphLabelEventArgsDescriptionMetadata.b(a);
            a.ae("FormatLinearGraphLabelEventArgs", () => new FormatLinearGraphLabelEventArgsDescription());
            a.ad("FormatLinearGraphLabelEventArgs", FormatLinearGraphLabelEventArgsDescriptionMetadata.a);
        }
    }
    FormatLinearGraphLabelEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FormatLinearGraphLabelEventArgsDescriptionMetadata, 'FormatLinearGraphLabelEventArgsDescriptionMetadata');
    FormatLinearGraphLabelEventArgsDescriptionMetadata.a = null;
    return FormatLinearGraphLabelEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AlignLinearGraphLabelEventArgsDescription = /*@__PURE__*/ (() => {
    class AlignLinearGraphLabelEventArgsDescription extends FormatLinearGraphLabelEventArgsDescription {
        get_type() {
            return "AlignLinearGraphLabelEventArgs";
        }
        constructor() {
            super();
        }
    }
    AlignLinearGraphLabelEventArgsDescription.$t = /*@__PURE__*/ markType(AlignLinearGraphLabelEventArgsDescription, 'AlignLinearGraphLabelEventArgsDescription', FormatLinearGraphLabelEventArgsDescription.$);
    return AlignLinearGraphLabelEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AlignLinearGraphLabelEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AlignLinearGraphLabelEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AlignLinearGraphLabelEventArgsDescriptionMetadata.a == null) {
                AlignLinearGraphLabelEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AlignLinearGraphLabelEventArgsDescriptionMetadata.c(AlignLinearGraphLabelEventArgsDescriptionMetadata.a);
            }
            if (a.k(AlignLinearGraphLabelEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AlignLinearGraphLabelEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            FormatLinearGraphLabelEventArgsDescriptionMetadata.c(a);
        }
        static d(a) {
            AlignLinearGraphLabelEventArgsDescriptionMetadata.b(a);
            a.ae("AlignLinearGraphLabelEventArgs", () => new AlignLinearGraphLabelEventArgsDescription());
            a.ad("AlignLinearGraphLabelEventArgs", AlignLinearGraphLabelEventArgsDescriptionMetadata.a);
        }
    }
    AlignLinearGraphLabelEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AlignLinearGraphLabelEventArgsDescriptionMetadata, 'AlignLinearGraphLabelEventArgsDescriptionMetadata');
    AlignLinearGraphLabelEventArgsDescriptionMetadata.a = null;
    return AlignLinearGraphLabelEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BulletGraphDescription = /*@__PURE__*/ (() => {
    class BulletGraphDescription extends Description {
        get fontFamily() {
            return this.cu;
        }
        set fontFamily(a) {
            this.cu = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.ac;
        }
        set fontSize(a) {
            this.ac = a;
            this.g("FontSize");
        }
        get fontWeight() {
            return this.cw;
        }
        set fontWeight(a) {
            this.cw = a;
            this.g("FontWeight");
        }
        get fontStyle() {
            return this.cv;
        }
        set fontStyle(a) {
            this.cv = a;
            this.g("FontStyle");
        }
        get width() {
            return this.dc;
        }
        set width(a) {
            this.dc = a;
            this.g("Width");
        }
        get height() {
            return this.cy;
        }
        set height(a) {
            this.cy = a;
            this.g("Height");
        }
        get background() {
            return this.cp;
        }
        set background(a) {
            this.cp = a;
            this.g("Background");
        }
        get_type() {
            return "BulletGraph";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.cu = null;
            this.ac = 0;
            this.cw = null;
            this.cv = null;
            this.dc = null;
            this.cy = null;
            this.cp = null;
            this.a6 = 0;
            this.c2 = null;
            this.c3 = null;
            this.c4 = null;
            this.at = 0;
            this.k = null;
            this.i = null;
            this.j = null;
            this.al = 0;
            this.x = 0;
            this.ak = 0;
            this.w = 0;
            this.aw = 0;
            this.c6 = null;
            this.a7 = 0;
            this.da = null;
            this.ad = 0;
            this.v = 0;
            this.ae = 0;
            this.cl = null;
            this.cz = null;
            this.ar = 0;
            this.as = 0;
            this.a8 = 0;
            this.a9 = 0;
            this.af = 0;
            this.a2 = 0;
            this.a3 = 0;
            this.ah = 0;
            this.ag = 0;
            this.ai = 0;
            this.aj = 0;
            this.am = 0;
            this.a4 = 0;
            this.a1 = 0;
            this.a5 = 0;
            this.c8 = null;
            this.ct = null;
            this.c9 = null;
            this.db = null;
            this.ba = 0;
            this.ao = 0;
            this.an = 0;
            this.ap = 0;
            this.c1 = null;
            this.p = false;
            this.cq = null;
            this.cr = null;
            this.ab = 0;
            this.z = 0;
            this.aa = 0;
            this.av = 0;
            this.au = 0;
            this.c5 = null;
            this.ax = 0;
            this.ay = 0;
            this.az = 0;
            this.c7 = null;
            this.a0 = 0;
            this.q = false;
            this.c0 = null;
            this.h = null;
            this.ci = 0;
            this.ch = 0;
            this.r = false;
            this.cs = null;
            this.aq = 0;
            this.y = 0;
            this.cx = null;
            this.co = null;
            this.cn = null;
            this.cm = null;
        }
        get transitionProgress() {
            return this.a6;
        }
        set transitionProgress(a) {
            this.a6 = a;
            this.g("TransitionProgress");
        }
        get orientation() {
            return this.c2;
        }
        set orientation(a) {
            this.c2 = a;
            this.g("Orientation");
        }
        get scaleBackgroundBrush() {
            return this.c3;
        }
        set scaleBackgroundBrush(a) {
            this.c3 = a;
            this.g("ScaleBackgroundBrush");
        }
        get scaleBackgroundOutline() {
            return this.c4;
        }
        set scaleBackgroundOutline(a) {
            this.c4 = a;
            this.g("ScaleBackgroundOutline");
        }
        get scaleBackgroundThickness() {
            return this.at;
        }
        set scaleBackgroundThickness(a) {
            this.at = a;
            this.g("ScaleBackgroundThickness");
        }
        get ranges() {
            return this.k;
        }
        set ranges(a) {
            this.k = a;
            this.g("Ranges");
        }
        get rangeBrushes() {
            return this.i;
        }
        set rangeBrushes(a) {
            this.i = a;
            this.g("RangeBrushes");
        }
        get rangeOutlines() {
            return this.j;
        }
        set rangeOutlines(a) {
            this.j = a;
            this.g("RangeOutlines");
        }
        get minimumValue() {
            return this.al;
        }
        set minimumValue(a) {
            this.al = a;
            this.g("MinimumValue");
        }
        get actualMinimumValue() {
            return this.x;
        }
        set actualMinimumValue(a) {
            this.x = a;
            this.g("ActualMinimumValue");
        }
        get maximumValue() {
            return this.ak;
        }
        set maximumValue(a) {
            this.ak = a;
            this.g("MaximumValue");
        }
        get actualMaximumValue() {
            return this.w;
        }
        set actualMaximumValue(a) {
            this.w = a;
            this.g("ActualMaximumValue");
        }
        get targetValue() {
            return this.aw;
        }
        set targetValue(a) {
            this.aw = a;
            this.g("TargetValue");
        }
        get targetValueName() {
            return this.c6;
        }
        set targetValueName(a) {
            this.c6 = a;
            this.g("TargetValueName");
        }
        get value() {
            return this.a7;
        }
        set value(a) {
            this.a7 = a;
            this.g("Value");
        }
        get valueName() {
            return this.da;
        }
        set valueName(a) {
            this.da = a;
            this.g("ValueName");
        }
        get highlightValue() {
            return this.ad;
        }
        set highlightValue(a) {
            this.ad = a;
            this.g("HighlightValue");
        }
        get actualHighlightValueOpacity() {
            return this.v;
        }
        set actualHighlightValueOpacity(a) {
            this.v = a;
            this.g("ActualHighlightValueOpacity");
        }
        get highlightValueOpacity() {
            return this.ae;
        }
        set highlightValueOpacity(a) {
            this.ae = a;
            this.g("HighlightValueOpacity");
        }
        get actualHighlightValueDisplayMode() {
            return this.cl;
        }
        set actualHighlightValueDisplayMode(a) {
            this.cl = a;
            this.g("ActualHighlightValueDisplayMode");
        }
        get highlightValueDisplayMode() {
            return this.cz;
        }
        set highlightValueDisplayMode(a) {
            this.cz = a;
            this.g("HighlightValueDisplayMode");
        }
        get rangeInnerExtent() {
            return this.ar;
        }
        set rangeInnerExtent(a) {
            this.ar = a;
            this.g("RangeInnerExtent");
        }
        get rangeOuterExtent() {
            return this.as;
        }
        set rangeOuterExtent(a) {
            this.as = a;
            this.g("RangeOuterExtent");
        }
        get valueInnerExtent() {
            return this.a8;
        }
        set valueInnerExtent(a) {
            this.a8 = a;
            this.g("ValueInnerExtent");
        }
        get valueOuterExtent() {
            return this.a9;
        }
        set valueOuterExtent(a) {
            this.a9 = a;
            this.g("ValueOuterExtent");
        }
        get interval() {
            return this.af;
        }
        set interval(a) {
            this.af = a;
            this.g("Interval");
        }
        get ticksPostInitial() {
            return this.a2;
        }
        set ticksPostInitial(a) {
            this.a2 = a;
            this.g("TicksPostInitial");
        }
        get ticksPreTerminal() {
            return this.a3;
        }
        set ticksPreTerminal(a) {
            this.a3 = a;
            this.g("TicksPreTerminal");
        }
        get labelInterval() {
            return this.ah;
        }
        set labelInterval(a) {
            this.ah = a;
            this.g("LabelInterval");
        }
        get labelExtent() {
            return this.ag;
        }
        set labelExtent(a) {
            this.ag = a;
            this.g("LabelExtent");
        }
        get labelsPostInitial() {
            return this.ai;
        }
        set labelsPostInitial(a) {
            this.ai = a;
            this.g("LabelsPostInitial");
        }
        get labelsPreTerminal() {
            return this.aj;
        }
        set labelsPreTerminal(a) {
            this.aj = a;
            this.g("LabelsPreTerminal");
        }
        get minorTickCount() {
            return this.am;
        }
        set minorTickCount(a) {
            this.am = a;
            this.g("MinorTickCount");
        }
        get tickStartExtent() {
            return this.a4;
        }
        set tickStartExtent(a) {
            this.a4 = a;
            this.g("TickStartExtent");
        }
        get tickEndExtent() {
            return this.a1;
        }
        set tickEndExtent(a) {
            this.a1 = a;
            this.g("TickEndExtent");
        }
        get tickStrokeThickness() {
            return this.a5;
        }
        set tickStrokeThickness(a) {
            this.a5 = a;
            this.g("TickStrokeThickness");
        }
        get tickBrush() {
            return this.c8;
        }
        set tickBrush(a) {
            this.c8 = a;
            this.g("TickBrush");
        }
        get fontBrush() {
            return this.ct;
        }
        set fontBrush(a) {
            this.ct = a;
            this.g("FontBrush");
        }
        get valueBrush() {
            return this.c9;
        }
        set valueBrush(a) {
            this.c9 = a;
            this.g("ValueBrush");
        }
        get valueOutline() {
            return this.db;
        }
        set valueOutline(a) {
            this.db = a;
            this.g("ValueOutline");
        }
        get valueStrokeThickness() {
            return this.ba;
        }
        set valueStrokeThickness(a) {
            this.ba = a;
            this.g("ValueStrokeThickness");
        }
        get minorTickStartExtent() {
            return this.ao;
        }
        set minorTickStartExtent(a) {
            this.ao = a;
            this.g("MinorTickStartExtent");
        }
        get minorTickEndExtent() {
            return this.an;
        }
        set minorTickEndExtent(a) {
            this.an = a;
            this.g("MinorTickEndExtent");
        }
        get minorTickStrokeThickness() {
            return this.ap;
        }
        set minorTickStrokeThickness(a) {
            this.ap = a;
            this.g("MinorTickStrokeThickness");
        }
        get minorTickBrush() {
            return this.c1;
        }
        set minorTickBrush(a) {
            this.c1 = a;
            this.g("MinorTickBrush");
        }
        get isScaleInverted() {
            return this.p;
        }
        set isScaleInverted(a) {
            this.p = a;
            this.g("IsScaleInverted");
        }
        get backingBrush() {
            return this.cq;
        }
        set backingBrush(a) {
            this.cq = a;
            this.g("BackingBrush");
        }
        get backingOutline() {
            return this.cr;
        }
        set backingOutline(a) {
            this.cr = a;
            this.g("BackingOutline");
        }
        get backingStrokeThickness() {
            return this.ab;
        }
        set backingStrokeThickness(a) {
            this.ab = a;
            this.g("BackingStrokeThickness");
        }
        get backingInnerExtent() {
            return this.z;
        }
        set backingInnerExtent(a) {
            this.z = a;
            this.g("BackingInnerExtent");
        }
        get backingOuterExtent() {
            return this.aa;
        }
        set backingOuterExtent(a) {
            this.aa = a;
            this.g("BackingOuterExtent");
        }
        get scaleStartExtent() {
            return this.av;
        }
        set scaleStartExtent(a) {
            this.av = a;
            this.g("ScaleStartExtent");
        }
        get scaleEndExtent() {
            return this.au;
        }
        set scaleEndExtent(a) {
            this.au = a;
            this.g("ScaleEndExtent");
        }
        get targetValueBrush() {
            return this.c5;
        }
        set targetValueBrush(a) {
            this.c5 = a;
            this.g("TargetValueBrush");
        }
        get targetValueBreadth() {
            return this.ax;
        }
        set targetValueBreadth(a) {
            this.ax = a;
            this.g("TargetValueBreadth");
        }
        get targetValueInnerExtent() {
            return this.ay;
        }
        set targetValueInnerExtent(a) {
            this.ay = a;
            this.g("TargetValueInnerExtent");
        }
        get targetValueOuterExtent() {
            return this.az;
        }
        set targetValueOuterExtent(a) {
            this.az = a;
            this.g("TargetValueOuterExtent");
        }
        get targetValueOutline() {
            return this.c7;
        }
        set targetValueOutline(a) {
            this.c7 = a;
            this.g("TargetValueOutline");
        }
        get targetValueStrokeThickness() {
            return this.a0;
        }
        set targetValueStrokeThickness(a) {
            this.a0 = a;
            this.g("TargetValueStrokeThickness");
        }
        get mergeViewports() {
            return this.q;
        }
        set mergeViewports(a) {
            this.q = a;
            this.g("MergeViewports");
        }
        get labelFormat() {
            return this.c0;
        }
        set labelFormat(a) {
            this.c0 = a;
            this.g("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.h;
        }
        set labelFormatSpecifiers(a) {
            this.h = a;
            this.g("LabelFormatSpecifiers");
        }
        get transitionDuration() {
            return this.ci;
        }
        set transitionDuration(a) {
            this.ci = a;
            this.g("TransitionDuration");
        }
        get showToolTipTimeout() {
            return this.ch;
        }
        set showToolTipTimeout(a) {
            this.ch = a;
            this.g("ShowToolTipTimeout");
        }
        get showToolTip() {
            return this.r;
        }
        set showToolTip(a) {
            this.r = a;
            this.g("ShowToolTip");
        }
        get font() {
            return this.cs;
        }
        set font(a) {
            this.cs = a;
            this.g("Font");
        }
        get pixelScalingRatio() {
            return this.aq;
        }
        set pixelScalingRatio(a) {
            this.aq = a;
            this.g("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.y;
        }
        set actualPixelScalingRatio(a) {
            this.y = a;
            this.g("ActualPixelScalingRatio");
        }
        get formatLabelRef() {
            return this.cx;
        }
        set formatLabelRef(a) {
            this.cx = a;
            this.g("FormatLabelRef");
        }
        get alignLabelRef() {
            return this.co;
        }
        set alignLabelRef(a) {
            this.co = a;
            this.g("AlignLabelRef");
        }
        get actualMinimumValueChangeRef() {
            return this.cn;
        }
        set actualMinimumValueChangeRef(a) {
            this.cn = a;
            this.g("ActualMinimumValueChangeRef");
        }
        get actualMaximumValueChangeRef() {
            return this.cm;
        }
        set actualMaximumValueChangeRef(a) {
            this.cm = a;
            this.g("ActualMaximumValueChangeRef");
        }
    }
    BulletGraphDescription.$t = /*@__PURE__*/ markType(BulletGraphDescription, 'BulletGraphDescription', Description.$);
    return BulletGraphDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BulletGraphDescriptionMetadata = /*@__PURE__*/ (() => {
    class BulletGraphDescriptionMetadata extends Base {
        static e(a) {
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:TextStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:TextStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontStyle/FontStyleTransform,wf:FontStyle/FontStyleTransform,web:TextStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontStyle/FontWeightTransform,wf:FontStyle/FontWeightTransform,web:TextStyle/FontWeightTransform)String");
            a.item("_qualifiedName", "String:Infragistics.Controls.Gauges.XamBulletGraph");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
            a.item("LegendRef", "(w:Legend)DataRef:String");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (BulletGraphDescriptionMetadata.a == null) {
                BulletGraphDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BulletGraphDescriptionMetadata.c(BulletGraphDescriptionMetadata.a);
            }
            if (a.k(BulletGraphDescriptionMetadata.a)) {
                return;
            }
            a.ac(BulletGraphDescriptionMetadata.a);
            FormatLinearGraphLabelEventArgsDescriptionMetadata.d(a);
            AlignLinearGraphLabelEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("TransitionProgress", "Number:double");
            a.item("Orientation", "ExportedType:string:LinearScaleOrientation");
            a.item("Orientation@names", "Horizontal;Vertical");
            a.item("ScaleBackgroundBrush", "Brush");
            a.item("ScaleBackgroundOutline", "Brush");
            a.item("ScaleBackgroundThickness", "Number:double");
            a.item("Ranges", "Collection:LinearGraphRange:LinearGraphRangeCollection:LinearGraphRange");
            a.item("RangeBrushes", "BrushCollection:string");
            a.item("RangeOutlines", "BrushCollection:string");
            a.item("MinimumValue", "Number:double");
            a.item("ActualMinimumValue", "Number:double");
            a.item("MaximumValue", "Number:double");
            a.item("ActualMaximumValue", "Number:double");
            a.item("TargetValue", "Number:double");
            a.item("TargetValueName", "String");
            a.item("Value", "Number:double");
            a.item("ValueName", "String");
            a.item("HighlightValue", "Number:double");
            a.item("ActualHighlightValueOpacity", "Number:double");
            a.item("HighlightValueOpacity", "Number:double");
            a.item("ActualHighlightValueDisplayMode", "ExportedType:string:HighlightedValueDisplayMode");
            a.item("ActualHighlightValueDisplayMode@names", "Auto;Hidden;Overlay");
            a.item("HighlightValueDisplayMode", "ExportedType:string:HighlightedValueDisplayMode");
            a.item("HighlightValueDisplayMode@names", "Auto;Hidden;Overlay");
            a.item("RangeInnerExtent", "Number:double");
            a.item("RangeOuterExtent", "Number:double");
            a.item("ValueInnerExtent", "Number:double");
            a.item("ValueOuterExtent", "Number:double");
            a.item("Interval", "Number:double");
            a.item("TicksPostInitial", "Number:double");
            a.item("TicksPreTerminal", "Number:double");
            a.item("LabelInterval", "Number:double");
            a.item("LabelExtent", "Number:double");
            a.item("LabelsPostInitial", "Number:double");
            a.item("LabelsPreTerminal", "Number:double");
            a.item("MinorTickCount", "Number:double");
            a.item("TickStartExtent", "Number:double");
            a.item("TickEndExtent", "Number:double");
            a.item("TickStrokeThickness", "Number:double");
            a.item("TickBrush", "Brush");
            a.item("FontBrush", "Brush");
            a.item("ValueBrush", "Brush");
            a.item("ValueOutline", "Brush");
            a.item("ValueStrokeThickness", "Number:double");
            a.item("MinorTickStartExtent", "Number:double");
            a.item("MinorTickEndExtent", "Number:double");
            a.item("MinorTickStrokeThickness", "Number:double");
            a.item("MinorTickBrush", "Brush");
            a.item("IsScaleInverted", "Boolean");
            a.item("BackingBrush", "Brush");
            a.item("BackingOutline", "Brush");
            a.item("BackingStrokeThickness", "Number:double");
            a.item("BackingInnerExtent", "Number:double");
            a.item("BackingOuterExtent", "Number:double");
            a.item("ScaleStartExtent", "Number:double");
            a.item("ScaleEndExtent", "Number:double");
            a.item("TargetValueBrush", "Brush");
            a.item("TargetValueBreadth", "Number:double");
            a.item("TargetValueInnerExtent", "Number:double");
            a.item("TargetValueOuterExtent", "Number:double");
            a.item("TargetValueOutline", "Brush");
            a.item("TargetValueStrokeThickness", "Number:double");
            a.item("MergeViewports", "Boolean");
            a.item("LabelFormat", "String");
            a.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("TransitionDuration", "Number:int");
            a.item("ShowToolTipTimeout", "Number:int");
            a.item("ShowToolTip", "Boolean");
            a.item("Font", "String");
            a.item("PixelScalingRatio", "Number:double");
            a.item("ActualPixelScalingRatio", "Number:double");
            a.item("FormatLabelRef", "EventRef::formatLabel");
            a.item("AlignLabelRef", "EventRef::alignLabel");
            a.item("ActualMinimumValueChangeRef", "EventRef::actualMinimumValueChange");
            a.item("ActualMaximumValueChangeRef", "EventRef::actualMaximumValueChange");
            BulletGraphDescriptionMetadata.e(a);
        }
        static d(a) {
            BulletGraphDescriptionMetadata.b(a);
            a.ae("BulletGraph", () => new BulletGraphDescription());
            a.ad("BulletGraph", BulletGraphDescriptionMetadata.a);
        }
    }
    BulletGraphDescriptionMetadata.$t = /*@__PURE__*/ markType(BulletGraphDescriptionMetadata, 'BulletGraphDescriptionMetadata');
    BulletGraphDescriptionMetadata.a = null;
    return BulletGraphDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGraphRangeDescription = /*@__PURE__*/ (() => {
    class LinearGraphRangeDescription extends Description {
        get_type() {
            return "LinearGraphRange";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.w = null;
            this.v = null;
            this.x = null;
            this.m = 0;
            this.h = 0;
            this.j = 0;
            this.i = 0;
            this.l = 0;
            this.k = 0;
            this.n = 0;
        }
        get name() {
            return this.w;
        }
        set name(a) {
            this.w = a;
            this.g("Name");
        }
        get brush() {
            return this.v;
        }
        set brush(a) {
            this.v = a;
            this.g("Brush");
        }
        get outline() {
            return this.x;
        }
        set outline(a) {
            this.x = a;
            this.g("Outline");
        }
        get startValue() {
            return this.m;
        }
        set startValue(a) {
            this.m = a;
            this.g("StartValue");
        }
        get endValue() {
            return this.h;
        }
        set endValue(a) {
            this.h = a;
            this.g("EndValue");
        }
        get innerStartExtent() {
            return this.j;
        }
        set innerStartExtent(a) {
            this.j = a;
            this.g("InnerStartExtent");
        }
        get innerEndExtent() {
            return this.i;
        }
        set innerEndExtent(a) {
            this.i = a;
            this.g("InnerEndExtent");
        }
        get outerStartExtent() {
            return this.l;
        }
        set outerStartExtent(a) {
            this.l = a;
            this.g("OuterStartExtent");
        }
        get outerEndExtent() {
            return this.k;
        }
        set outerEndExtent(a) {
            this.k = a;
            this.g("OuterEndExtent");
        }
        get strokeThickness() {
            return this.n;
        }
        set strokeThickness(a) {
            this.n = a;
            this.g("StrokeThickness");
        }
    }
    LinearGraphRangeDescription.$t = /*@__PURE__*/ markType(LinearGraphRangeDescription, 'LinearGraphRangeDescription', Description.$);
    return LinearGraphRangeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGraphRangeDescriptionMetadata = /*@__PURE__*/ (() => {
    class LinearGraphRangeDescriptionMetadata extends Base {
        static b(a) {
            if (LinearGraphRangeDescriptionMetadata.a == null) {
                LinearGraphRangeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LinearGraphRangeDescriptionMetadata.c(LinearGraphRangeDescriptionMetadata.a);
            }
            if (a.k(LinearGraphRangeDescriptionMetadata.a)) {
                return;
            }
            a.ac(LinearGraphRangeDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Name", "String");
            a.item("Brush", "Brush");
            a.item("Outline", "Brush");
            a.item("StartValue", "Number:double");
            a.item("EndValue", "Number:double");
            a.item("InnerStartExtent", "Number:double");
            a.item("InnerEndExtent", "Number:double");
            a.item("OuterStartExtent", "Number:double");
            a.item("OuterEndExtent", "Number:double");
            a.item("StrokeThickness", "Number:double");
        }
        static d(a) {
            LinearGraphRangeDescriptionMetadata.b(a);
            a.ae("LinearGraphRange", () => new LinearGraphRangeDescription());
            a.ad("LinearGraphRange", LinearGraphRangeDescriptionMetadata.a);
        }
    }
    LinearGraphRangeDescriptionMetadata.$t = /*@__PURE__*/ markType(LinearGraphRangeDescriptionMetadata, 'LinearGraphRangeDescriptionMetadata');
    LinearGraphRangeDescriptionMetadata.a = null;
    return LinearGraphRangeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGraphRangeDescriptionModule = /*@__PURE__*/ (() => {
    class LinearGraphRangeDescriptionModule extends Base {
        static register(a) {
            LinearGraphRangeDescriptionMetadata.d(a);
        }
    }
    LinearGraphRangeDescriptionModule.$t = /*@__PURE__*/ markType(LinearGraphRangeDescriptionModule, 'LinearGraphRangeDescriptionModule');
    return LinearGraphRangeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatSpecifierDescription = /*@__PURE__*/ (() => {
    class FormatSpecifierDescription extends Description {
        get_type() {
            return "FormatSpecifier";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    FormatSpecifierDescription.$t = /*@__PURE__*/ markType(FormatSpecifierDescription, 'FormatSpecifierDescription', Description.$);
    FormatSpecifierDescription.__marshalByValue = true;
    FormatSpecifierDescription.__marshalByValueAlias = "FormatSpecifier";
    return FormatSpecifierDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatSpecifierDescriptionMetadata = /*@__PURE__*/ (() => {
    class FormatSpecifierDescriptionMetadata extends Base {
        static b(a) {
            if (FormatSpecifierDescriptionMetadata.a == null) {
                FormatSpecifierDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FormatSpecifierDescriptionMetadata.c(FormatSpecifierDescriptionMetadata.a);
            }
            if (a.k(FormatSpecifierDescriptionMetadata.a)) {
                return;
            }
            a.ac(FormatSpecifierDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
        }
        static d(a) {
            FormatSpecifierDescriptionMetadata.b(a);
            a.ae("FormatSpecifier", () => new FormatSpecifierDescription());
            a.ad("FormatSpecifier", FormatSpecifierDescriptionMetadata.a);
        }
    }
    FormatSpecifierDescriptionMetadata.$t = /*@__PURE__*/ markType(FormatSpecifierDescriptionMetadata, 'FormatSpecifierDescriptionMetadata');
    FormatSpecifierDescriptionMetadata.a = null;
    return FormatSpecifierDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatSpecifierDescriptionModule = /*@__PURE__*/ (() => {
    class FormatSpecifierDescriptionModule extends Base {
        static register(a) {
            FormatSpecifierDescriptionMetadata.d(a);
        }
    }
    FormatSpecifierDescriptionModule.$t = /*@__PURE__*/ markType(FormatSpecifierDescriptionModule, 'FormatSpecifierDescriptionModule');
    return FormatSpecifierDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumberFormatSpecifierDescription = /*@__PURE__*/ (() => {
    class NumberFormatSpecifierDescription extends FormatSpecifierDescription {
        get_type() {
            return "NumberFormatSpecifier";
        }
        constructor() {
            super();
            this.ad = null;
            this.y = null;
            this.z = null;
            this.ab = null;
            this.ac = null;
            this.aa = null;
            this.ae = null;
            this.af = null;
            this.ag = null;
            this.ah = null;
            this.ai = null;
            this.aj = null;
            this.ak = null;
            this.l = false;
            this.q = 0;
            this.p = 0;
            this.n = 0;
            this.r = 0;
            this.o = 0;
        }
        get locale() {
            return this.ad;
        }
        set locale(a) {
            this.ad = a;
            this.g("Locale");
        }
        get compactDisplay() {
            return this.y;
        }
        set compactDisplay(a) {
            this.y = a;
            this.g("CompactDisplay");
        }
        get currency() {
            return this.z;
        }
        set currency(a) {
            this.z = a;
            this.g("Currency");
        }
        get currencyDisplay() {
            return this.ab;
        }
        set currencyDisplay(a) {
            this.ab = a;
            this.g("CurrencyDisplay");
        }
        get currencySign() {
            return this.ac;
        }
        set currencySign(a) {
            this.ac = a;
            this.g("CurrencySign");
        }
        get currencyCode() {
            return this.aa;
        }
        set currencyCode(a) {
            this.aa = a;
            this.g("CurrencyCode");
        }
        get localeMatcher() {
            return this.ae;
        }
        set localeMatcher(a) {
            this.ae = a;
            this.g("LocaleMatcher");
        }
        get notation() {
            return this.af;
        }
        set notation(a) {
            this.af = a;
            this.g("Notation");
        }
        get numberingSystem() {
            return this.ag;
        }
        set numberingSystem(a) {
            this.ag = a;
            this.g("NumberingSystem");
        }
        get signDisplay() {
            return this.ah;
        }
        set signDisplay(a) {
            this.ah = a;
            this.g("SignDisplay");
        }
        get style() {
            return this.ai;
        }
        set style(a) {
            this.ai = a;
            this.g("Style");
        }
        get unit() {
            return this.aj;
        }
        set unit(a) {
            this.aj = a;
            this.g("Unit");
        }
        get unitDisplay() {
            return this.ak;
        }
        set unitDisplay(a) {
            this.ak = a;
            this.g("UnitDisplay");
        }
        get useGrouping() {
            return this.l;
        }
        set useGrouping(a) {
            this.l = a;
            this.g("UseGrouping");
        }
        get minimumIntegerDigits() {
            return this.q;
        }
        set minimumIntegerDigits(a) {
            this.q = a;
            this.g("MinimumIntegerDigits");
        }
        get minimumFractionDigits() {
            return this.p;
        }
        set minimumFractionDigits(a) {
            this.p = a;
            this.g("MinimumFractionDigits");
        }
        get maximumFractionDigits() {
            return this.n;
        }
        set maximumFractionDigits(a) {
            this.n = a;
            this.g("MaximumFractionDigits");
        }
        get minimumSignificantDigits() {
            return this.r;
        }
        set minimumSignificantDigits(a) {
            this.r = a;
            this.g("MinimumSignificantDigits");
        }
        get maximumSignificantDigits() {
            return this.o;
        }
        set maximumSignificantDigits(a) {
            this.o = a;
            this.g("MaximumSignificantDigits");
        }
    }
    NumberFormatSpecifierDescription.$t = /*@__PURE__*/ markType(NumberFormatSpecifierDescription, 'NumberFormatSpecifierDescription', FormatSpecifierDescription.$);
    NumberFormatSpecifierDescription.__marshalByValue1 = true;
    NumberFormatSpecifierDescription.__marshalByValueAlias1 = "NumberFormatSpecifier";
    return NumberFormatSpecifierDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumberFormatSpecifierDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumberFormatSpecifierDescriptionMetadata extends Base {
        static b(a) {
            if (NumberFormatSpecifierDescriptionMetadata.a == null) {
                NumberFormatSpecifierDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumberFormatSpecifierDescriptionMetadata.c(NumberFormatSpecifierDescriptionMetadata.a);
            }
            if (a.k(NumberFormatSpecifierDescriptionMetadata.a)) {
                return;
            }
            a.ac(NumberFormatSpecifierDescriptionMetadata.a);
        }
        static c(a) {
            FormatSpecifierDescriptionMetadata.c(a);
            a.item("Locale", "String");
            a.item("CompactDisplay", "String");
            a.item("Currency", "String");
            a.item("CurrencyDisplay", "String");
            a.item("CurrencySign", "String");
            a.item("CurrencyCode", "String");
            a.item("LocaleMatcher", "String");
            a.item("Notation", "String");
            a.item("NumberingSystem", "String");
            a.item("SignDisplay", "String");
            a.item("Style", "String");
            a.item("Unit", "String");
            a.item("UnitDisplay", "String");
            a.item("UseGrouping", "Boolean");
            a.item("MinimumIntegerDigits", "Number:int");
            a.item("MinimumFractionDigits", "Number:int");
            a.item("MaximumFractionDigits", "Number:int");
            a.item("MinimumSignificantDigits", "Number:int");
            a.item("MaximumSignificantDigits", "Number:int");
            NumberFormatSpecifierDescriptionMetadata.e(a);
        }
        static d(a) {
            NumberFormatSpecifierDescriptionMetadata.b(a);
            a.ae("NumberFormatSpecifier", () => new NumberFormatSpecifierDescription());
            a.ad("NumberFormatSpecifier", NumberFormatSpecifierDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-core");
            a.item("__importTypesReact", "String:igniteui-react-core");
            a.item("__importTypesAngular", "String:igniteui-angular-core");
            a.item("__skipSuffix", "Boolean");
        }
    }
    NumberFormatSpecifierDescriptionMetadata.$t = /*@__PURE__*/ markType(NumberFormatSpecifierDescriptionMetadata, 'NumberFormatSpecifierDescriptionMetadata');
    NumberFormatSpecifierDescriptionMetadata.a = null;
    return NumberFormatSpecifierDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumberFormatSpecifierDescriptionModule = /*@__PURE__*/ (() => {
    class NumberFormatSpecifierDescriptionModule extends Base {
        static register(a) {
            FormatSpecifierDescriptionModule.register(a);
            NumberFormatSpecifierDescriptionMetadata.d(a);
        }
    }
    NumberFormatSpecifierDescriptionModule.$t = /*@__PURE__*/ markType(NumberFormatSpecifierDescriptionModule, 'NumberFormatSpecifierDescriptionModule');
    return NumberFormatSpecifierDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BulletGraphCoreDescriptionModule = /*@__PURE__*/ (() => {
    class BulletGraphCoreDescriptionModule extends Base {
        static register(a) {
            BulletGraphDescriptionMetadata.d(a);
            LinearGraphRangeDescriptionModule.register(a);
            NumberFormatSpecifierDescriptionModule.register(a);
        }
    }
    BulletGraphCoreDescriptionModule.$t = /*@__PURE__*/ markType(BulletGraphCoreDescriptionModule, 'BulletGraphCoreDescriptionModule');
    return BulletGraphCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TooltipContainerDescriptionModule = /*@__PURE__*/ (() => {
    class TooltipContainerDescriptionModule extends Base {
        static register(a) {
        }
    }
    TooltipContainerDescriptionModule.$t = /*@__PURE__*/ markType(TooltipContainerDescriptionModule, 'TooltipContainerDescriptionModule');
    return TooltipContainerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SimpleDefaultTooltipDescriptionMetadata = /*@__PURE__*/ (() => {
    class SimpleDefaultTooltipDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    SimpleDefaultTooltipDescriptionMetadata.$t = /*@__PURE__*/ markType(SimpleDefaultTooltipDescriptionMetadata, 'SimpleDefaultTooltipDescriptionMetadata');
    return SimpleDefaultTooltipDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DVInteractivityDescriptionModule = /*@__PURE__*/ (() => {
    class DVInteractivityDescriptionModule extends Base {
        static register(a) {
            TooltipContainerDescriptionModule.register(a);
            SimpleDefaultTooltipDescriptionMetadata.register(a);
        }
    }
    DVInteractivityDescriptionModule.$t = /*@__PURE__*/ markType(DVInteractivityDescriptionModule, 'DVInteractivityDescriptionModule');
    return DVInteractivityDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BulletGraphDescriptionModule = /*@__PURE__*/ (() => {
    class BulletGraphDescriptionModule extends Base {
        static register(a) {
            BulletGraphCoreDescriptionModule.register(a);
            DVInteractivityDescriptionModule.register(a);
        }
    }
    BulletGraphDescriptionModule.$t = /*@__PURE__*/ markType(BulletGraphDescriptionModule, 'BulletGraphDescriptionModule');
    return BulletGraphDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonDescription = /*@__PURE__*/ (() => {
    class ButtonDescription extends Description {
        get_type() {
            return "Button";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.a8 = 0;
            this.a7 = 0;
            this.e3 = null;
            this.ey = null;
            this.ev = null;
            this.ef = null;
            this.ee = null;
            this.er = null;
            this.eo = null;
            this.ec = null;
            this.cs = 0;
            this.cq = 0;
            this.cr = 0;
            this.ep = null;
            this.af = 0;
            this.ae = 0;
            this.ag = 0;
            this.ah = 0;
            this.ed = null;
            this.eg = null;
            this.eh = null;
            this.ei = null;
            this.cp = 0;
            this.ej = null;
            this.eq = null;
            this.en = null;
            this.ek = null;
            this.el = null;
            this.em = null;
            this.ad = 0;
            this.gs = null;
            this.gu = null;
            this.gv = null;
            this.gw = null;
            this.dc = 0;
            this.gz = null;
            this.gt = null;
            this.df = 0;
            this.de = 0;
            this.dd = 0;
            this.be = 0;
            this.bg = 0;
            this.bf = 0;
            this.bh = 0;
            this.bi = 0;
            this.g1 = null;
            this.fg = null;
            this.fi = null;
            this.fj = null;
            this.fk = null;
            this.cy = 0;
            this.fn = null;
            this.fh = null;
            this.c1 = 0;
            this.c0 = 0;
            this.cz = 0;
            this.fp = null;
            this.fq = null;
            this.fo = null;
            this.fl = null;
            this.fm = null;
            this.aw = 0;
            this.ay = 0;
            this.ax = 0;
            this.az = 0;
            this.a0 = 0;
            this.eu = null;
            this.ez = null;
            this.e0 = null;
            this.e1 = null;
            this.ct = 0;
            this.e4 = null;
            this.f0 = null;
            this.ew = null;
            this.dg = 0;
            this.c3 = 0;
            this.c2 = 0;
            this.fv = null;
            this.a1 = 0;
            this.fw = null;
            this.fx = null;
            this.g4 = null;
            this.f1 = null;
            this.g3 = null;
            this.g2 = null;
            this.g0 = null;
            this.gx = null;
            this.gy = null;
            this.ft = null;
            this.fu = null;
            this.ai = 0;
            this.ao = 0;
            this.an = 0;
            this.ap = 0;
            this.aq = 0;
            this.gh = null;
            this.gj = null;
            this.gk = null;
            this.gl = null;
            this.c8 = 0;
            this.go = null;
            this.gi = null;
            this.db = 0;
            this.da = 0;
            this.c9 = 0;
            this.a9 = 0;
            this.bb = 0;
            this.ba = 0;
            this.bc = 0;
            this.bd = 0;
            this.gq = null;
            this.gr = null;
            this.gp = null;
            this.gm = null;
            this.gn = null;
            this.e5 = null;
            this.e7 = null;
            this.e8 = null;
            this.e9 = null;
            this.cu = 0;
            this.fc = null;
            this.e6 = null;
            this.cx = 0;
            this.cw = 0;
            this.cv = 0;
            this.ar = 0;
            this.at = 0;
            this.as = 0;
            this.au = 0;
            this.av = 0;
            this.fe = null;
            this.ff = null;
            this.fd = null;
            this.fa = null;
            this.fb = null;
            this.f2 = null;
            this.f4 = null;
            this.f5 = null;
            this.f6 = null;
            this.c4 = 0;
            this.f9 = null;
            this.f3 = null;
            this.c7 = 0;
            this.c6 = 0;
            this.c5 = 0;
            this.a2 = 0;
            this.a4 = 0;
            this.a3 = 0;
            this.a5 = 0;
            this.a6 = 0;
            this.gb = null;
            this.gc = null;
            this.ga = null;
            this.f7 = null;
            this.f8 = null;
            this.ge = null;
            this.gd = null;
            this.e2 = null;
            this.fr = null;
            this.fs = null;
            this.es = null;
            this.g5 = null;
            this.gg = null;
            this.dh = 0;
            this.et = null;
            this.o = false;
            this.p = false;
            this.q = false;
            this.m = false;
            this.h = false;
            this.k = false;
            this.r = false;
            this.j = false;
            this.n = false;
            this.l = false;
            this.ak = 0;
            this.am = 0;
            this.al = 0;
            this.aj = 0;
            this.fz = null;
            this.g6 = null;
            this.i = false;
            this.ex = null;
            this.fy = null;
            this.gf = null;
        }
        get minWidth() {
            return this.a8;
        }
        set minWidth(a) {
            this.a8 = a;
            this.g("MinWidth");
        }
        get minHeight() {
            return this.a7;
        }
        set minHeight(a) {
            this.a7 = a;
            this.g("MinHeight");
        }
        get displayType() {
            return this.e3;
        }
        set displayType(a) {
            this.e3 = a;
            this.g("DisplayType");
        }
        get density() {
            return this.ey;
        }
        set density(a) {
            this.ey = a;
            this.g("Density");
        }
        get baseTheme() {
            return this.ev;
        }
        set baseTheme(a) {
            this.ev = a;
            this.g("BaseTheme");
        }
        get actualDensity() {
            return this.ef;
        }
        set actualDensity(a) {
            this.ef = a;
            this.g("ActualDensity");
        }
        get actualBorderColor() {
            return this.ee;
        }
        set actualBorderColor(a) {
            this.ee = a;
            this.g("ActualBorderColor");
        }
        get actualUmbraShadowColor() {
            return this.er;
        }
        set actualUmbraShadowColor(a) {
            this.er = a;
            this.g("ActualUmbraShadowColor");
        }
        get actualPenumbraShadowColor() {
            return this.eo;
        }
        set actualPenumbraShadowColor(a) {
            this.eo = a;
            this.g("ActualPenumbraShadowColor");
        }
        get actualAmbientShadowColor() {
            return this.ec;
        }
        set actualAmbientShadowColor(a) {
            this.ec = a;
            this.g("ActualAmbientShadowColor");
        }
        get actualRestingElevation() {
            return this.cs;
        }
        set actualRestingElevation(a) {
            this.cs = a;
            this.g("ActualRestingElevation");
        }
        get actualFocusElevation() {
            return this.cq;
        }
        set actualFocusElevation(a) {
            this.cq = a;
            this.g("ActualFocusElevation");
        }
        get actualHoverElevation() {
            return this.cr;
        }
        set actualHoverElevation(a) {
            this.cr = a;
            this.g("ActualHoverElevation");
        }
        get actualRippleColor() {
            return this.ep;
        }
        set actualRippleColor(a) {
            this.ep = a;
            this.g("ActualRippleColor");
        }
        get actualCornerRadiusBottomRight() {
            return this.af;
        }
        set actualCornerRadiusBottomRight(a) {
            this.af = a;
            this.g("ActualCornerRadiusBottomRight");
        }
        get actualCornerRadiusBottomLeft() {
            return this.ae;
        }
        set actualCornerRadiusBottomLeft(a) {
            this.ae = a;
            this.g("ActualCornerRadiusBottomLeft");
        }
        get actualCornerRadiusTopLeft() {
            return this.ag;
        }
        set actualCornerRadiusTopLeft(a) {
            this.ag = a;
            this.g("ActualCornerRadiusTopLeft");
        }
        get actualCornerRadiusTopRight() {
            return this.ah;
        }
        set actualCornerRadiusTopRight(a) {
            this.ah = a;
            this.g("ActualCornerRadiusTopRight");
        }
        get actualBackgroundColor() {
            return this.ed;
        }
        set actualBackgroundColor(a) {
            this.ed = a;
            this.g("ActualBackgroundColor");
        }
        get actualDisabledBackgroundColor() {
            return this.eg;
        }
        set actualDisabledBackgroundColor(a) {
            this.eg = a;
            this.g("ActualDisabledBackgroundColor");
        }
        get actualDisabledBorderColor() {
            return this.eh;
        }
        set actualDisabledBorderColor(a) {
            this.eh = a;
            this.g("ActualDisabledBorderColor");
        }
        get actualDisabledTextColor() {
            return this.ei;
        }
        set actualDisabledTextColor(a) {
            this.ei = a;
            this.g("ActualDisabledTextColor");
        }
        get actualDisabledElevation() {
            return this.cp;
        }
        set actualDisabledElevation(a) {
            this.cp = a;
            this.g("ActualDisabledElevation");
        }
        get actualElevationMode() {
            return this.ej;
        }
        set actualElevationMode(a) {
            this.ej = a;
            this.g("ActualElevationMode");
        }
        get actualTextColor() {
            return this.eq;
        }
        set actualTextColor(a) {
            this.eq = a;
            this.g("ActualTextColor");
        }
        get actualHoverTextColor() {
            return this.en;
        }
        set actualHoverTextColor(a) {
            this.en = a;
            this.g("ActualHoverTextColor");
        }
        get actualFocusBackgroundColor() {
            return this.ek;
        }
        set actualFocusBackgroundColor(a) {
            this.ek = a;
            this.g("ActualFocusBackgroundColor");
        }
        get actualFocusTextColor() {
            return this.el;
        }
        set actualFocusTextColor(a) {
            this.el = a;
            this.g("ActualFocusTextColor");
        }
        get actualHoverBackgroundColor() {
            return this.em;
        }
        set actualHoverBackgroundColor(a) {
            this.em = a;
            this.g("ActualHoverBackgroundColor");
        }
        get actualBorderWidth() {
            return this.ad;
        }
        set actualBorderWidth(a) {
            this.ad = a;
            this.g("ActualBorderWidth");
        }
        get raisedBackgroundColor() {
            return this.gs;
        }
        set raisedBackgroundColor(a) {
            this.gs = a;
            this.g("RaisedBackgroundColor");
        }
        get raisedDisabledBackgroundColor() {
            return this.gu;
        }
        set raisedDisabledBackgroundColor(a) {
            this.gu = a;
            this.g("RaisedDisabledBackgroundColor");
        }
        get raisedDisabledBorderColor() {
            return this.gv;
        }
        set raisedDisabledBorderColor(a) {
            this.gv = a;
            this.g("RaisedDisabledBorderColor");
        }
        get raisedDisabledTextColor() {
            return this.gw;
        }
        set raisedDisabledTextColor(a) {
            this.gw = a;
            this.g("RaisedDisabledTextColor");
        }
        get raisedDisabledElevation() {
            return this.dc;
        }
        set raisedDisabledElevation(a) {
            this.dc = a;
            this.g("RaisedDisabledElevation");
        }
        get raisedHoverBackgroundColor() {
            return this.gz;
        }
        set raisedHoverBackgroundColor(a) {
            this.gz = a;
            this.g("RaisedHoverBackgroundColor");
        }
        get raisedBorderColor() {
            return this.gt;
        }
        set raisedBorderColor(a) {
            this.gt = a;
            this.g("RaisedBorderColor");
        }
        get raisedRestingElevation() {
            return this.df;
        }
        set raisedRestingElevation(a) {
            this.df = a;
            this.g("RaisedRestingElevation");
        }
        get raisedHoverElevation() {
            return this.de;
        }
        set raisedHoverElevation(a) {
            this.de = a;
            this.g("RaisedHoverElevation");
        }
        get raisedFocusElevation() {
            return this.dd;
        }
        set raisedFocusElevation(a) {
            this.dd = a;
            this.g("RaisedFocusElevation");
        }
        get raisedBorderWidth() {
            return this.be;
        }
        set raisedBorderWidth(a) {
            this.be = a;
            this.g("RaisedBorderWidth");
        }
        get raisedCornerRadiusBottomRight() {
            return this.bg;
        }
        set raisedCornerRadiusBottomRight(a) {
            this.bg = a;
            this.g("RaisedCornerRadiusBottomRight");
        }
        get raisedCornerRadiusBottomLeft() {
            return this.bf;
        }
        set raisedCornerRadiusBottomLeft(a) {
            this.bf = a;
            this.g("RaisedCornerRadiusBottomLeft");
        }
        get raisedCornerRadiusTopLeft() {
            return this.bh;
        }
        set raisedCornerRadiusTopLeft(a) {
            this.bh = a;
            this.g("RaisedCornerRadiusTopLeft");
        }
        get raisedCornerRadiusTopRight() {
            return this.bi;
        }
        set raisedCornerRadiusTopRight(a) {
            this.bi = a;
            this.g("RaisedCornerRadiusTopRight");
        }
        get raisedRippleColor() {
            return this.g1;
        }
        set raisedRippleColor(a) {
            this.g1 = a;
            this.g("RaisedRippleColor");
        }
        get flatBackgroundColor() {
            return this.fg;
        }
        set flatBackgroundColor(a) {
            this.fg = a;
            this.g("FlatBackgroundColor");
        }
        get flatDisabledBackgroundColor() {
            return this.fi;
        }
        set flatDisabledBackgroundColor(a) {
            this.fi = a;
            this.g("FlatDisabledBackgroundColor");
        }
        get flatDisabledBorderColor() {
            return this.fj;
        }
        set flatDisabledBorderColor(a) {
            this.fj = a;
            this.g("FlatDisabledBorderColor");
        }
        get flatDisabledTextColor() {
            return this.fk;
        }
        set flatDisabledTextColor(a) {
            this.fk = a;
            this.g("FlatDisabledTextColor");
        }
        get flatDisabledElevation() {
            return this.cy;
        }
        set flatDisabledElevation(a) {
            this.cy = a;
            this.g("FlatDisabledElevation");
        }
        get flatHoverBackgroundColor() {
            return this.fn;
        }
        set flatHoverBackgroundColor(a) {
            this.fn = a;
            this.g("FlatHoverBackgroundColor");
        }
        get flatBorderColor() {
            return this.fh;
        }
        set flatBorderColor(a) {
            this.fh = a;
            this.g("FlatBorderColor");
        }
        get flatRestingElevation() {
            return this.c1;
        }
        set flatRestingElevation(a) {
            this.c1 = a;
            this.g("FlatRestingElevation");
        }
        get flatHoverElevation() {
            return this.c0;
        }
        set flatHoverElevation(a) {
            this.c0 = a;
            this.g("FlatHoverElevation");
        }
        get flatFocusElevation() {
            return this.cz;
        }
        set flatFocusElevation(a) {
            this.cz = a;
            this.g("FlatFocusElevation");
        }
        get flatRippleColor() {
            return this.fp;
        }
        set flatRippleColor(a) {
            this.fp = a;
            this.g("FlatRippleColor");
        }
        get flatTextColor() {
            return this.fq;
        }
        set flatTextColor(a) {
            this.fq = a;
            this.g("FlatTextColor");
        }
        get flatHoverTextColor() {
            return this.fo;
        }
        set flatHoverTextColor(a) {
            this.fo = a;
            this.g("FlatHoverTextColor");
        }
        get flatFocusBackgroundColor() {
            return this.fl;
        }
        set flatFocusBackgroundColor(a) {
            this.fl = a;
            this.g("FlatFocusBackgroundColor");
        }
        get flatFocusTextColor() {
            return this.fm;
        }
        set flatFocusTextColor(a) {
            this.fm = a;
            this.g("FlatFocusTextColor");
        }
        get flatBorderWidth() {
            return this.aw;
        }
        set flatBorderWidth(a) {
            this.aw = a;
            this.g("FlatBorderWidth");
        }
        get flatCornerRadiusBottomRight() {
            return this.ay;
        }
        set flatCornerRadiusBottomRight(a) {
            this.ay = a;
            this.g("FlatCornerRadiusBottomRight");
        }
        get flatCornerRadiusBottomLeft() {
            return this.ax;
        }
        set flatCornerRadiusBottomLeft(a) {
            this.ax = a;
            this.g("FlatCornerRadiusBottomLeft");
        }
        get flatCornerRadiusTopLeft() {
            return this.az;
        }
        set flatCornerRadiusTopLeft(a) {
            this.az = a;
            this.g("FlatCornerRadiusTopLeft");
        }
        get flatCornerRadiusTopRight() {
            return this.a0;
        }
        set flatCornerRadiusTopRight(a) {
            this.a0 = a;
            this.g("FlatCornerRadiusTopRight");
        }
        get backgroundColor() {
            return this.eu;
        }
        set backgroundColor(a) {
            this.eu = a;
            this.g("BackgroundColor");
        }
        get disabledBackgroundColor() {
            return this.ez;
        }
        set disabledBackgroundColor(a) {
            this.ez = a;
            this.g("DisabledBackgroundColor");
        }
        get disabledBorderColor() {
            return this.e0;
        }
        set disabledBorderColor(a) {
            this.e0 = a;
            this.g("DisabledBorderColor");
        }
        get disabledTextColor() {
            return this.e1;
        }
        set disabledTextColor(a) {
            this.e1 = a;
            this.g("DisabledTextColor");
        }
        get disabledElevation() {
            return this.ct;
        }
        set disabledElevation(a) {
            this.ct = a;
            this.g("DisabledElevation");
        }
        get elevationMode() {
            return this.e4;
        }
        set elevationMode(a) {
            this.e4 = a;
            this.g("ElevationMode");
        }
        get hoverBackgroundColor() {
            return this.f0;
        }
        set hoverBackgroundColor(a) {
            this.f0 = a;
            this.g("HoverBackgroundColor");
        }
        get borderColor() {
            return this.ew;
        }
        set borderColor(a) {
            this.ew = a;
            this.g("BorderColor");
        }
        get restingElevation() {
            return this.dg;
        }
        set restingElevation(a) {
            this.dg = a;
            this.g("RestingElevation");
        }
        get hoverElevation() {
            return this.c3;
        }
        set hoverElevation(a) {
            this.c3 = a;
            this.g("HoverElevation");
        }
        get focusElevation() {
            return this.c2;
        }
        set focusElevation(a) {
            this.c2 = a;
            this.g("FocusElevation");
        }
        get fontFamily() {
            return this.fv;
        }
        set fontFamily(a) {
            this.fv = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.a1;
        }
        set fontSize(a) {
            this.a1 = a;
            this.g("FontSize");
        }
        get fontStyle() {
            return this.fw;
        }
        set fontStyle(a) {
            this.fw = a;
            this.g("FontStyle");
        }
        get fontWeight() {
            return this.fx;
        }
        set fontWeight(a) {
            this.fx = a;
            this.g("FontWeight");
        }
        get textColor() {
            return this.g4;
        }
        set textColor(a) {
            this.g4 = a;
            this.g("TextColor");
        }
        get hoverTextColor() {
            return this.f1;
        }
        set hoverTextColor(a) {
            this.f1 = a;
            this.g("HoverTextColor");
        }
        get rippleColor() {
            return this.g3;
        }
        set rippleColor(a) {
            this.g3 = a;
            this.g("RippleColor");
        }
        get raisedTextColor() {
            return this.g2;
        }
        set raisedTextColor(a) {
            this.g2 = a;
            this.g("RaisedTextColor");
        }
        get raisedHoverTextColor() {
            return this.g0;
        }
        set raisedHoverTextColor(a) {
            this.g0 = a;
            this.g("RaisedHoverTextColor");
        }
        get raisedFocusBackgroundColor() {
            return this.gx;
        }
        set raisedFocusBackgroundColor(a) {
            this.gx = a;
            this.g("RaisedFocusBackgroundColor");
        }
        get raisedFocusTextColor() {
            return this.gy;
        }
        set raisedFocusTextColor(a) {
            this.gy = a;
            this.g("RaisedFocusTextColor");
        }
        get focusBackgroundColor() {
            return this.ft;
        }
        set focusBackgroundColor(a) {
            this.ft = a;
            this.g("FocusBackgroundColor");
        }
        get focusTextColor() {
            return this.fu;
        }
        set focusTextColor(a) {
            this.fu = a;
            this.g("FocusTextColor");
        }
        get borderWidth() {
            return this.ai;
        }
        set borderWidth(a) {
            this.ai = a;
            this.g("BorderWidth");
        }
        get cornerRadiusBottomRight() {
            return this.ao;
        }
        set cornerRadiusBottomRight(a) {
            this.ao = a;
            this.g("CornerRadiusBottomRight");
        }
        get cornerRadiusBottomLeft() {
            return this.an;
        }
        set cornerRadiusBottomLeft(a) {
            this.an = a;
            this.g("CornerRadiusBottomLeft");
        }
        get cornerRadiusTopLeft() {
            return this.ap;
        }
        set cornerRadiusTopLeft(a) {
            this.ap = a;
            this.g("CornerRadiusTopLeft");
        }
        get cornerRadiusTopRight() {
            return this.aq;
        }
        set cornerRadiusTopRight(a) {
            this.aq = a;
            this.g("CornerRadiusTopRight");
        }
        get outlinedBackgroundColor() {
            return this.gh;
        }
        set outlinedBackgroundColor(a) {
            this.gh = a;
            this.g("OutlinedBackgroundColor");
        }
        get outlinedDisabledBackgroundColor() {
            return this.gj;
        }
        set outlinedDisabledBackgroundColor(a) {
            this.gj = a;
            this.g("OutlinedDisabledBackgroundColor");
        }
        get outlinedDisabledBorderColor() {
            return this.gk;
        }
        set outlinedDisabledBorderColor(a) {
            this.gk = a;
            this.g("OutlinedDisabledBorderColor");
        }
        get outlinedDisabledTextColor() {
            return this.gl;
        }
        set outlinedDisabledTextColor(a) {
            this.gl = a;
            this.g("OutlinedDisabledTextColor");
        }
        get outlinedDisabledElevation() {
            return this.c8;
        }
        set outlinedDisabledElevation(a) {
            this.c8 = a;
            this.g("OutlinedDisabledElevation");
        }
        get outlinedHoverBackgroundColor() {
            return this.go;
        }
        set outlinedHoverBackgroundColor(a) {
            this.go = a;
            this.g("OutlinedHoverBackgroundColor");
        }
        get outlinedBorderColor() {
            return this.gi;
        }
        set outlinedBorderColor(a) {
            this.gi = a;
            this.g("OutlinedBorderColor");
        }
        get outlinedRestingElevation() {
            return this.db;
        }
        set outlinedRestingElevation(a) {
            this.db = a;
            this.g("OutlinedRestingElevation");
        }
        get outlinedHoverElevation() {
            return this.da;
        }
        set outlinedHoverElevation(a) {
            this.da = a;
            this.g("OutlinedHoverElevation");
        }
        get outlinedFocusElevation() {
            return this.c9;
        }
        set outlinedFocusElevation(a) {
            this.c9 = a;
            this.g("OutlinedFocusElevation");
        }
        get outlinedBorderWidth() {
            return this.a9;
        }
        set outlinedBorderWidth(a) {
            this.a9 = a;
            this.g("OutlinedBorderWidth");
        }
        get outlinedCornerRadiusBottomRight() {
            return this.bb;
        }
        set outlinedCornerRadiusBottomRight(a) {
            this.bb = a;
            this.g("OutlinedCornerRadiusBottomRight");
        }
        get outlinedCornerRadiusBottomLeft() {
            return this.ba;
        }
        set outlinedCornerRadiusBottomLeft(a) {
            this.ba = a;
            this.g("OutlinedCornerRadiusBottomLeft");
        }
        get outlinedCornerRadiusTopLeft() {
            return this.bc;
        }
        set outlinedCornerRadiusTopLeft(a) {
            this.bc = a;
            this.g("OutlinedCornerRadiusTopLeft");
        }
        get outlinedCornerRadiusTopRight() {
            return this.bd;
        }
        set outlinedCornerRadiusTopRight(a) {
            this.bd = a;
            this.g("OutlinedCornerRadiusTopRight");
        }
        get outlinedRippleColor() {
            return this.gq;
        }
        set outlinedRippleColor(a) {
            this.gq = a;
            this.g("OutlinedRippleColor");
        }
        get outlinedTextColor() {
            return this.gr;
        }
        set outlinedTextColor(a) {
            this.gr = a;
            this.g("OutlinedTextColor");
        }
        get outlinedHoverTextColor() {
            return this.gp;
        }
        set outlinedHoverTextColor(a) {
            this.gp = a;
            this.g("OutlinedHoverTextColor");
        }
        get outlinedFocusBackgroundColor() {
            return this.gm;
        }
        set outlinedFocusBackgroundColor(a) {
            this.gm = a;
            this.g("OutlinedFocusBackgroundColor");
        }
        get outlinedFocusTextColor() {
            return this.gn;
        }
        set outlinedFocusTextColor(a) {
            this.gn = a;
            this.g("OutlinedFocusTextColor");
        }
        get fabBackgroundColor() {
            return this.e5;
        }
        set fabBackgroundColor(a) {
            this.e5 = a;
            this.g("FabBackgroundColor");
        }
        get fabDisabledBackgroundColor() {
            return this.e7;
        }
        set fabDisabledBackgroundColor(a) {
            this.e7 = a;
            this.g("FabDisabledBackgroundColor");
        }
        get fabDisabledBorderColor() {
            return this.e8;
        }
        set fabDisabledBorderColor(a) {
            this.e8 = a;
            this.g("FabDisabledBorderColor");
        }
        get fabDisabledTextColor() {
            return this.e9;
        }
        set fabDisabledTextColor(a) {
            this.e9 = a;
            this.g("FabDisabledTextColor");
        }
        get fabDisabledElevation() {
            return this.cu;
        }
        set fabDisabledElevation(a) {
            this.cu = a;
            this.g("FabDisabledElevation");
        }
        get fabHoverBackgroundColor() {
            return this.fc;
        }
        set fabHoverBackgroundColor(a) {
            this.fc = a;
            this.g("FabHoverBackgroundColor");
        }
        get fabBorderColor() {
            return this.e6;
        }
        set fabBorderColor(a) {
            this.e6 = a;
            this.g("FabBorderColor");
        }
        get fabRestingElevation() {
            return this.cx;
        }
        set fabRestingElevation(a) {
            this.cx = a;
            this.g("FabRestingElevation");
        }
        get fabHoverElevation() {
            return this.cw;
        }
        set fabHoverElevation(a) {
            this.cw = a;
            this.g("FabHoverElevation");
        }
        get fabFocusElevation() {
            return this.cv;
        }
        set fabFocusElevation(a) {
            this.cv = a;
            this.g("FabFocusElevation");
        }
        get fabBorderWidth() {
            return this.ar;
        }
        set fabBorderWidth(a) {
            this.ar = a;
            this.g("FabBorderWidth");
        }
        get fabCornerRadiusBottomRight() {
            return this.at;
        }
        set fabCornerRadiusBottomRight(a) {
            this.at = a;
            this.g("FabCornerRadiusBottomRight");
        }
        get fabCornerRadiusBottomLeft() {
            return this.as;
        }
        set fabCornerRadiusBottomLeft(a) {
            this.as = a;
            this.g("FabCornerRadiusBottomLeft");
        }
        get fabCornerRadiusTopLeft() {
            return this.au;
        }
        set fabCornerRadiusTopLeft(a) {
            this.au = a;
            this.g("FabCornerRadiusTopLeft");
        }
        get fabCornerRadiusTopRight() {
            return this.av;
        }
        set fabCornerRadiusTopRight(a) {
            this.av = a;
            this.g("FabCornerRadiusTopRight");
        }
        get fabRippleColor() {
            return this.fe;
        }
        set fabRippleColor(a) {
            this.fe = a;
            this.g("FabRippleColor");
        }
        get fabTextColor() {
            return this.ff;
        }
        set fabTextColor(a) {
            this.ff = a;
            this.g("FabTextColor");
        }
        get fabHoverTextColor() {
            return this.fd;
        }
        set fabHoverTextColor(a) {
            this.fd = a;
            this.g("FabHoverTextColor");
        }
        get fabFocusBackgroundColor() {
            return this.fa;
        }
        set fabFocusBackgroundColor(a) {
            this.fa = a;
            this.g("FabFocusBackgroundColor");
        }
        get fabFocusTextColor() {
            return this.fb;
        }
        set fabFocusTextColor(a) {
            this.fb = a;
            this.g("FabFocusTextColor");
        }
        get iconBackgroundColor() {
            return this.f2;
        }
        set iconBackgroundColor(a) {
            this.f2 = a;
            this.g("IconBackgroundColor");
        }
        get iconDisabledBackgroundColor() {
            return this.f4;
        }
        set iconDisabledBackgroundColor(a) {
            this.f4 = a;
            this.g("IconDisabledBackgroundColor");
        }
        get iconDisabledBorderColor() {
            return this.f5;
        }
        set iconDisabledBorderColor(a) {
            this.f5 = a;
            this.g("IconDisabledBorderColor");
        }
        get iconDisabledTextColor() {
            return this.f6;
        }
        set iconDisabledTextColor(a) {
            this.f6 = a;
            this.g("IconDisabledTextColor");
        }
        get iconDisabledElevation() {
            return this.c4;
        }
        set iconDisabledElevation(a) {
            this.c4 = a;
            this.g("IconDisabledElevation");
        }
        get iconHoverBackgroundColor() {
            return this.f9;
        }
        set iconHoverBackgroundColor(a) {
            this.f9 = a;
            this.g("IconHoverBackgroundColor");
        }
        get iconBorderColor() {
            return this.f3;
        }
        set iconBorderColor(a) {
            this.f3 = a;
            this.g("IconBorderColor");
        }
        get iconRestingElevation() {
            return this.c7;
        }
        set iconRestingElevation(a) {
            this.c7 = a;
            this.g("IconRestingElevation");
        }
        get iconHoverElevation() {
            return this.c6;
        }
        set iconHoverElevation(a) {
            this.c6 = a;
            this.g("IconHoverElevation");
        }
        get iconFocusElevation() {
            return this.c5;
        }
        set iconFocusElevation(a) {
            this.c5 = a;
            this.g("IconFocusElevation");
        }
        get iconBorderWidth() {
            return this.a2;
        }
        set iconBorderWidth(a) {
            this.a2 = a;
            this.g("IconBorderWidth");
        }
        get iconCornerRadiusBottomRight() {
            return this.a4;
        }
        set iconCornerRadiusBottomRight(a) {
            this.a4 = a;
            this.g("IconCornerRadiusBottomRight");
        }
        get iconCornerRadiusBottomLeft() {
            return this.a3;
        }
        set iconCornerRadiusBottomLeft(a) {
            this.a3 = a;
            this.g("IconCornerRadiusBottomLeft");
        }
        get iconCornerRadiusTopLeft() {
            return this.a5;
        }
        set iconCornerRadiusTopLeft(a) {
            this.a5 = a;
            this.g("IconCornerRadiusTopLeft");
        }
        get iconCornerRadiusTopRight() {
            return this.a6;
        }
        set iconCornerRadiusTopRight(a) {
            this.a6 = a;
            this.g("IconCornerRadiusTopRight");
        }
        get iconRippleColor() {
            return this.gb;
        }
        set iconRippleColor(a) {
            this.gb = a;
            this.g("IconRippleColor");
        }
        get iconTextColor() {
            return this.gc;
        }
        set iconTextColor(a) {
            this.gc = a;
            this.g("IconTextColor");
        }
        get iconHoverTextColor() {
            return this.ga;
        }
        set iconHoverTextColor(a) {
            this.ga = a;
            this.g("IconHoverTextColor");
        }
        get iconFocusBackgroundColor() {
            return this.f7;
        }
        set iconFocusBackgroundColor(a) {
            this.f7 = a;
            this.g("IconFocusBackgroundColor");
        }
        get iconFocusTextColor() {
            return this.f8;
        }
        set iconFocusTextColor(a) {
            this.f8 = a;
            this.g("IconFocusTextColor");
        }
        get inputId() {
            return this.ge;
        }
        set inputId(a) {
            this.ge = a;
            this.g("InputId");
        }
        get id() {
            return this.gd;
        }
        set id(a) {
            this.gd = a;
            this.g("Id");
        }
        get display() {
            return this.e2;
        }
        set display(a) {
            this.e2 = a;
            this.g("Display");
        }
        get flexDirection() {
            return this.fr;
        }
        set flexDirection(a) {
            this.fr = a;
            this.g("FlexDirection");
        }
        get flexGrow() {
            return this.fs;
        }
        set flexGrow(a) {
            this.fs = a;
            this.g("FlexGrow");
        }
        get alignItems() {
            return this.es;
        }
        set alignItems(a) {
            this.es = a;
            this.g("AlignItems");
        }
        get valueRef() {
            return this.g5;
        }
        set valueRef(a) {
            this.g5 = a;
            this.g("ValueRef");
        }
        get name() {
            return this.gg;
        }
        set name(a) {
            this.gg = a;
            this.g("Name");
        }
        get tabIndex() {
            return this.dh;
        }
        set tabIndex(a) {
            this.dh = a;
            this.g("TabIndex");
        }
        get ariaLabel() {
            return this.et;
        }
        set ariaLabel(a) {
            this.et = a;
            this.g("AriaLabel");
        }
        get fillAvailableSpace() {
            return this.o;
        }
        set fillAvailableSpace(a) {
            this.o = a;
            this.g("FillAvailableSpace");
        }
        get focused() {
            return this.p;
        }
        set focused(a) {
            this.p = a;
            this.g("Focused");
        }
        get isFocusStyleEnabled() {
            return this.q;
        }
        set isFocusStyleEnabled(a) {
            this.q = a;
            this.g("IsFocusStyleEnabled");
        }
        get disableRipple() {
            return this.m;
        }
        set disableRipple(a) {
            this.m = a;
            this.g("DisableRipple");
        }
        get actualDisableRipple() {
            return this.h;
        }
        set actualDisableRipple(a) {
            this.h = a;
            this.g("ActualDisableRipple");
        }
        get disableHover() {
            return this.k;
        }
        set disableHover(a) {
            this.k = a;
            this.g("DisableHover");
        }
        get isHover() {
            return this.r;
        }
        set isHover(a) {
            this.r = a;
            this.g("IsHover");
        }
        get disabled() {
            return this.j;
        }
        set disabled(a) {
            this.j = a;
            this.g("Disabled");
        }
        get disableTransitions() {
            return this.n;
        }
        set disableTransitions(a) {
            this.n = a;
            this.g("DisableTransitions");
        }
        get disablePointer() {
            return this.l;
        }
        set disablePointer(a) {
            this.l = a;
            this.g("DisablePointer");
        }
        get contentPaddingLeft() {
            return this.ak;
        }
        set contentPaddingLeft(a) {
            this.ak = a;
            this.g("ContentPaddingLeft");
        }
        get contentPaddingTop() {
            return this.am;
        }
        set contentPaddingTop(a) {
            this.am = a;
            this.g("ContentPaddingTop");
        }
        get contentPaddingRight() {
            return this.al;
        }
        set contentPaddingRight(a) {
            this.al = a;
            this.g("ContentPaddingRight");
        }
        get contentPaddingBottom() {
            return this.aj;
        }
        set contentPaddingBottom(a) {
            this.aj = a;
            this.g("ContentPaddingBottom");
        }
        get horizontalContentAlignment() {
            return this.fz;
        }
        set horizontalContentAlignment(a) {
            this.fz = a;
            this.g("HorizontalContentAlignment");
        }
        get verticalContentAlignment() {
            return this.g6;
        }
        set verticalContentAlignment(a) {
            this.g6 = a;
            this.g("VerticalContentAlignment");
        }
        get clickTunneling() {
            return this.i;
        }
        set clickTunneling(a) {
            this.i = a;
            this.g("ClickTunneling");
        }
        get clickedRef() {
            return this.ex;
        }
        set clickedRef(a) {
            this.ex = a;
            this.g("ClickedRef");
        }
        get gotFocusRef() {
            return this.fy;
        }
        set gotFocusRef(a) {
            this.fy = a;
            this.g("GotFocusRef");
        }
        get lostFocusRef() {
            return this.gf;
        }
        set lostFocusRef(a) {
            this.gf = a;
            this.g("LostFocusRef");
        }
    }
    ButtonDescription.$t = /*@__PURE__*/ markType(ButtonDescription, 'ButtonDescription', Description.$);
    return ButtonDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonClickEventArgsDescription = /*@__PURE__*/ (() => {
    class ButtonClickEventArgsDescription extends Description {
        get_type() {
            return "ButtonClickEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ButtonClickEventArgsDescription.$t = /*@__PURE__*/ markType(ButtonClickEventArgsDescription, 'ButtonClickEventArgsDescription', Description.$);
    return ButtonClickEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonClickEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ButtonClickEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ButtonClickEventArgsDescriptionMetadata.a == null) {
                ButtonClickEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ButtonClickEventArgsDescriptionMetadata.c(ButtonClickEventArgsDescriptionMetadata.a);
            }
            if (a.k(ButtonClickEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ButtonClickEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ButtonClickEventArgsDescriptionMetadata.b(a);
            a.ae("ButtonClickEventArgs", () => new ButtonClickEventArgsDescription());
            a.ad("ButtonClickEventArgs", ButtonClickEventArgsDescriptionMetadata.a);
        }
    }
    ButtonClickEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ButtonClickEventArgsDescriptionMetadata, 'ButtonClickEventArgsDescriptionMetadata');
    ButtonClickEventArgsDescriptionMetadata.a = null;
    return ButtonClickEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FocusEventArgsDescription = /*@__PURE__*/ (() => {
    class FocusEventArgsDescription extends Description {
        get_type() {
            return "FocusEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get targetRef() {
            return this.h;
        }
        set targetRef(a) {
            this.h = a;
            this.g("TargetRef");
        }
    }
    FocusEventArgsDescription.$t = /*@__PURE__*/ markType(FocusEventArgsDescription, 'FocusEventArgsDescription', Description.$);
    return FocusEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FocusEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FocusEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FocusEventArgsDescriptionMetadata.a == null) {
                FocusEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FocusEventArgsDescriptionMetadata.c(FocusEventArgsDescriptionMetadata.a);
            }
            if (a.k(FocusEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(FocusEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("TargetRef", "(w:Target,wf:Target)DataRef");
        }
        static d(a) {
            FocusEventArgsDescriptionMetadata.b(a);
            a.ae("FocusEventArgs", () => new FocusEventArgsDescription());
            a.ad("FocusEventArgs", FocusEventArgsDescriptionMetadata.a);
        }
    }
    FocusEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FocusEventArgsDescriptionMetadata, 'FocusEventArgsDescriptionMetadata');
    FocusEventArgsDescriptionMetadata.a = null;
    return FocusEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonDescriptionMetadata = /*@__PURE__*/ (() => {
    class ButtonDescriptionMetadata extends Base {
        static b(a) {
            if (ButtonDescriptionMetadata.a == null) {
                ButtonDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ButtonDescriptionMetadata.c(ButtonDescriptionMetadata.a);
            }
            if (a.k(ButtonDescriptionMetadata.a)) {
                return;
            }
            a.ac(ButtonDescriptionMetadata.a);
            ButtonClickEventArgsDescriptionMetadata.d(a);
            FocusEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:XButton");
            a.item("MinWidth", "Number:double");
            a.item("MinHeight", "Number:double");
            a.item("DisplayType", "ExportedType:string:ButtonDisplayStyle");
            a.item("DisplayType@names", "Raised;Flat;Outlined;Fab;Icon");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("ActualDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("ActualDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActualBorderColor", "Brush");
            a.item("ActualUmbraShadowColor", "Brush");
            a.item("ActualPenumbraShadowColor", "Brush");
            a.item("ActualAmbientShadowColor", "Brush");
            a.item("ActualRestingElevation", "Number:int");
            a.item("ActualFocusElevation", "Number:int");
            a.item("ActualHoverElevation", "Number:int");
            a.item("ActualRippleColor", "Brush");
            a.item("ActualCornerRadiusBottomRight", "(w:ActualCornerRadius.BottomRight,wf:ActualCornerRadiusBottomRight)Number:double");
            a.item("ActualCornerRadiusBottomLeft", "(w:ActualCornerRadius.BottomLeft,wf:ActualCornerRadiusBottomLeft)Number:double");
            a.item("ActualCornerRadiusTopLeft", "(w:ActualCornerRadius.TopLeft,wf:ActualCornerRadiusTopLeft)Number:double");
            a.item("ActualCornerRadiusTopRight", "(w:ActualCornerRadius.TopRight,wf:ActualCornerRadiusTopRight)Number:double");
            a.item("ActualBackgroundColor", "Brush");
            a.item("ActualDisabledBackgroundColor", "Brush");
            a.item("ActualDisabledBorderColor", "Brush");
            a.item("ActualDisabledTextColor", "Brush");
            a.item("ActualDisabledElevation", "Number:int");
            a.item("ActualElevationMode", "ExportedType:string:ElevationMode");
            a.item("ActualElevationMode@names", "Auto;MaterialShadow;HaloShadow");
            a.item("ActualTextColor", "Brush");
            a.item("ActualHoverTextColor", "Brush");
            a.item("ActualFocusBackgroundColor", "Brush");
            a.item("ActualFocusTextColor", "Brush");
            a.item("ActualHoverBackgroundColor", "Brush");
            a.item("ActualBorderWidth", "Number:double");
            a.item("RaisedBackgroundColor", "Brush");
            a.item("RaisedDisabledBackgroundColor", "Brush");
            a.item("RaisedDisabledBorderColor", "Brush");
            a.item("RaisedDisabledTextColor", "Brush");
            a.item("RaisedDisabledElevation", "Number:int");
            a.item("RaisedHoverBackgroundColor", "Brush");
            a.item("RaisedBorderColor", "Brush");
            a.item("RaisedRestingElevation", "Number:int");
            a.item("RaisedHoverElevation", "Number:int");
            a.item("RaisedFocusElevation", "Number:int");
            a.item("RaisedBorderWidth", "Number:double");
            a.item("RaisedCornerRadiusBottomRight", "(w:RaisedCornerRadius.BottomRight,wf:RaisedCornerRadiusBottomRight)Number:double");
            a.item("RaisedCornerRadiusBottomLeft", "(w:RaisedCornerRadius.BottomLeft,wf:RaisedCornerRadiusBottomLeft)Number:double");
            a.item("RaisedCornerRadiusTopLeft", "(w:RaisedCornerRadius.TopLeft,wf:RaisedCornerRadiusTopLeft)Number:double");
            a.item("RaisedCornerRadiusTopRight", "(w:RaisedCornerRadius.TopRight,wf:RaisedCornerRadiusTopRight)Number:double");
            a.item("RaisedRippleColor", "Brush");
            a.item("FlatBackgroundColor", "Brush");
            a.item("FlatDisabledBackgroundColor", "Brush");
            a.item("FlatDisabledBorderColor", "Brush");
            a.item("FlatDisabledTextColor", "Brush");
            a.item("FlatDisabledElevation", "Number:int");
            a.item("FlatHoverBackgroundColor", "Brush");
            a.item("FlatBorderColor", "Brush");
            a.item("FlatRestingElevation", "Number:int");
            a.item("FlatHoverElevation", "Number:int");
            a.item("FlatFocusElevation", "Number:int");
            a.item("FlatRippleColor", "Brush");
            a.item("FlatTextColor", "Brush");
            a.item("FlatHoverTextColor", "Brush");
            a.item("FlatFocusBackgroundColor", "Brush");
            a.item("FlatFocusTextColor", "Brush");
            a.item("FlatBorderWidth", "Number:double");
            a.item("FlatCornerRadiusBottomRight", "(w:FlatCornerRadius.BottomRight,wf:FlatCornerRadiusBottomRight)Number:double");
            a.item("FlatCornerRadiusBottomLeft", "(w:FlatCornerRadius.BottomLeft,wf:FlatCornerRadiusBottomLeft)Number:double");
            a.item("FlatCornerRadiusTopLeft", "(w:FlatCornerRadius.TopLeft,wf:FlatCornerRadiusTopLeft)Number:double");
            a.item("FlatCornerRadiusTopRight", "(w:FlatCornerRadius.TopRight,wf:FlatCornerRadiusTopRight)Number:double");
            a.item("BackgroundColor", "Brush");
            a.item("DisabledBackgroundColor", "Brush");
            a.item("DisabledBorderColor", "Brush");
            a.item("DisabledTextColor", "Brush");
            a.item("DisabledElevation", "Number:int");
            a.item("ElevationMode", "ExportedType:string:ElevationMode");
            a.item("ElevationMode@names", "Auto;MaterialShadow;HaloShadow");
            a.item("HoverBackgroundColor", "Brush");
            a.item("BorderColor", "Brush");
            a.item("RestingElevation", "Number:int");
            a.item("HoverElevation", "Number:int");
            a.item("FocusElevation", "Number:int");
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontFamily/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontFamily/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            a.item("TextColor", "Brush");
            a.item("HoverTextColor", "Brush");
            a.item("RippleColor", "Brush");
            a.item("RaisedTextColor", "Brush");
            a.item("RaisedHoverTextColor", "Brush");
            a.item("RaisedFocusBackgroundColor", "Brush");
            a.item("RaisedFocusTextColor", "Brush");
            a.item("FocusBackgroundColor", "Brush");
            a.item("FocusTextColor", "Brush");
            a.item("BorderWidth", "Number:double");
            a.item("CornerRadiusBottomRight", "(w:CornerRadius.BottomRight,wf:CornerRadiusBottomRight)Number:double");
            a.item("CornerRadiusBottomLeft", "(w:CornerRadius.BottomLeft,wf:CornerRadiusBottomLeft)Number:double");
            a.item("CornerRadiusTopLeft", "(w:CornerRadius.TopLeft,wf:CornerRadiusTopLeft)Number:double");
            a.item("CornerRadiusTopRight", "(w:CornerRadius.TopRight,wf:CornerRadiusTopRight)Number:double");
            a.item("OutlinedBackgroundColor", "Brush");
            a.item("OutlinedDisabledBackgroundColor", "Brush");
            a.item("OutlinedDisabledBorderColor", "Brush");
            a.item("OutlinedDisabledTextColor", "Brush");
            a.item("OutlinedDisabledElevation", "Number:int");
            a.item("OutlinedHoverBackgroundColor", "Brush");
            a.item("OutlinedBorderColor", "Brush");
            a.item("OutlinedRestingElevation", "Number:int");
            a.item("OutlinedHoverElevation", "Number:int");
            a.item("OutlinedFocusElevation", "Number:int");
            a.item("OutlinedBorderWidth", "Number:double");
            a.item("OutlinedCornerRadiusBottomRight", "(w:OutlinedCornerRadius.BottomRight,wf:OutlinedCornerRadiusBottomRight)Number:double");
            a.item("OutlinedCornerRadiusBottomLeft", "(w:OutlinedCornerRadius.BottomLeft,wf:OutlinedCornerRadiusBottomLeft)Number:double");
            a.item("OutlinedCornerRadiusTopLeft", "(w:OutlinedCornerRadius.TopLeft,wf:OutlinedCornerRadiusTopLeft)Number:double");
            a.item("OutlinedCornerRadiusTopRight", "(w:OutlinedCornerRadius.TopRight,wf:OutlinedCornerRadiusTopRight)Number:double");
            a.item("OutlinedRippleColor", "Brush");
            a.item("OutlinedTextColor", "Brush");
            a.item("OutlinedHoverTextColor", "Brush");
            a.item("OutlinedFocusBackgroundColor", "Brush");
            a.item("OutlinedFocusTextColor", "Brush");
            a.item("FabBackgroundColor", "Brush");
            a.item("FabDisabledBackgroundColor", "Brush");
            a.item("FabDisabledBorderColor", "Brush");
            a.item("FabDisabledTextColor", "Brush");
            a.item("FabDisabledElevation", "Number:int");
            a.item("FabHoverBackgroundColor", "Brush");
            a.item("FabBorderColor", "Brush");
            a.item("FabRestingElevation", "Number:int");
            a.item("FabHoverElevation", "Number:int");
            a.item("FabFocusElevation", "Number:int");
            a.item("FabBorderWidth", "Number:double");
            a.item("FabCornerRadiusBottomRight", "(w:FabCornerRadius.BottomRight,wf:FabCornerRadiusBottomRight)Number:double");
            a.item("FabCornerRadiusBottomLeft", "(w:FabCornerRadius.BottomLeft,wf:FabCornerRadiusBottomLeft)Number:double");
            a.item("FabCornerRadiusTopLeft", "(w:FabCornerRadius.TopLeft,wf:FabCornerRadiusTopLeft)Number:double");
            a.item("FabCornerRadiusTopRight", "(w:FabCornerRadius.TopRight,wf:FabCornerRadiusTopRight)Number:double");
            a.item("FabRippleColor", "Brush");
            a.item("FabTextColor", "Brush");
            a.item("FabHoverTextColor", "Brush");
            a.item("FabFocusBackgroundColor", "Brush");
            a.item("FabFocusTextColor", "Brush");
            a.item("IconBackgroundColor", "Brush");
            a.item("IconDisabledBackgroundColor", "Brush");
            a.item("IconDisabledBorderColor", "Brush");
            a.item("IconDisabledTextColor", "Brush");
            a.item("IconDisabledElevation", "Number:int");
            a.item("IconHoverBackgroundColor", "Brush");
            a.item("IconBorderColor", "Brush");
            a.item("IconRestingElevation", "Number:int");
            a.item("IconHoverElevation", "Number:int");
            a.item("IconFocusElevation", "Number:int");
            a.item("IconBorderWidth", "Number:double");
            a.item("IconCornerRadiusBottomRight", "(w:IconCornerRadius.BottomRight,wf:IconCornerRadiusBottomRight)Number:double");
            a.item("IconCornerRadiusBottomLeft", "(w:IconCornerRadius.BottomLeft,wf:IconCornerRadiusBottomLeft)Number:double");
            a.item("IconCornerRadiusTopLeft", "(w:IconCornerRadius.TopLeft,wf:IconCornerRadiusTopLeft)Number:double");
            a.item("IconCornerRadiusTopRight", "(w:IconCornerRadius.TopRight,wf:IconCornerRadiusTopRight)Number:double");
            a.item("IconRippleColor", "Brush");
            a.item("IconTextColor", "Brush");
            a.item("IconHoverTextColor", "Brush");
            a.item("IconFocusBackgroundColor", "Brush");
            a.item("IconFocusTextColor", "Brush");
            a.item("InputId", "String");
            a.item("Id", "String");
            a.item("Display", "String");
            a.item("FlexDirection", "String");
            a.item("FlexGrow", "String");
            a.item("AlignItems", "String");
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
            a.item("Name", "String");
            a.item("TabIndex", "Number:int");
            a.item("AriaLabel", "String");
            a.item("FillAvailableSpace", "Boolean");
            a.item("Focused", "(w:IsFocused,xam:IsFocused,wf:IsFocused)Boolean");
            a.item("IsFocusStyleEnabled", "Boolean");
            a.item("DisableRipple", "Boolean");
            a.item("ActualDisableRipple", "Boolean");
            a.item("DisableHover", "Boolean");
            a.item("IsHover", "Boolean");
            a.item("Disabled", "(w:IsDisabled,xam:IsDisabled,wf:IsDisabled)Boolean");
            a.item("DisableTransitions", "Boolean");
            a.item("DisablePointer", "Boolean");
            a.item("ContentPaddingLeft", "Number:double");
            a.item("ContentPaddingTop", "Number:double");
            a.item("ContentPaddingRight", "Number:double");
            a.item("ContentPaddingBottom", "Number:double");
            a.item("HorizontalContentAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("HorizontalContentAlignment@names", "Left;Center;Right;Stretch");
            a.item("VerticalContentAlignment", "ExportedType:string:VerticalAlignment");
            a.item("VerticalContentAlignment@names", "Top;Center;Bottom;Stretch");
            a.item("ClickTunneling", "Boolean");
            a.item("ClickedRef", "EventRef::clicked");
            a.item("GotFocusRef", "EventRef::gotFocus");
            a.item("LostFocusRef", "EventRef::lostFocus");
        }
        static d(a) {
            ButtonDescriptionMetadata.b(a);
            a.ae("Button", () => new ButtonDescription());
            a.ad("Button", ButtonDescriptionMetadata.a);
        }
    }
    ButtonDescriptionMetadata.$t = /*@__PURE__*/ markType(ButtonDescriptionMetadata, 'ButtonDescriptionMetadata');
    ButtonDescriptionMetadata.a = null;
    return ButtonDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonGroupDescription = /*@__PURE__*/ (() => {
    class ButtonGroupDescription extends Description {
        get_type() {
            return "ButtonGroup";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.au = null;
            this.as = null;
            this.at = null;
            this.af = null;
            this.i = null;
            this.q = 0;
            this.ag = null;
            this.ai = null;
            this.an = null;
            this.ak = null;
            this.ah = null;
            this.aj = null;
            this.p = 0;
            this.ao = null;
            this.ar = null;
            this.al = null;
            this.am = null;
            this.ap = null;
            this.aq = null;
            this.u = 0;
            this.a8 = null;
            this.ba = null;
            this.bf = null;
            this.bc = null;
            this.bd = null;
            this.a9 = null;
            this.bb = null;
            this.t = 0;
            this.be = null;
            this.bt = null;
            this.bw = null;
            this.bu = null;
            this.bv = null;
            this.w = 0;
            this.bh = null;
            this.bj = null;
            this.bo = null;
            this.bl = null;
            this.bm = null;
            this.bi = null;
            this.bk = null;
            this.v = 0;
            this.bn = null;
            this.bp = null;
            this.bs = null;
            this.bq = null;
            this.br = null;
            this.s = 0;
            this.av = null;
            this.ax = null;
            this.a2 = null;
            this.az = null;
            this.a0 = null;
            this.aw = null;
            this.ay = null;
            this.r = 0;
            this.a1 = null;
            this.a3 = null;
            this.a6 = null;
            this.a4 = null;
            this.a5 = null;
            this.bg = null;
            this.a7 = null;
            this.l = false;
            this.m = false;
            this.h = null;
            this.bx = null;
        }
        get displayType() {
            return this.au;
        }
        set displayType(a) {
            this.au = a;
            this.g("DisplayType");
        }
        get baseTheme() {
            return this.as;
        }
        set baseTheme(a) {
            this.as = a;
            this.g("BaseTheme");
        }
        get density() {
            return this.at;
        }
        set density(a) {
            this.at = a;
            this.g("Density");
        }
        get actualDensity() {
            return this.af;
        }
        set actualDensity(a) {
            this.af = a;
            this.g("ActualDensity");
        }
        get selectedIndices() {
            return this.i;
        }
        set selectedIndices(a) {
            this.i = a;
            this.g("SelectedIndices");
        }
        get actualItemCornerRadius() {
            return this.q;
        }
        set actualItemCornerRadius(a) {
            this.q = a;
            this.g("ActualItemCornerRadius");
        }
        get actualItemBackgroundColor() {
            return this.ag;
        }
        set actualItemBackgroundColor(a) {
            this.ag = a;
            this.g("ActualItemBackgroundColor");
        }
        get actualItemDisabledBackgroundColor() {
            return this.ai;
        }
        set actualItemDisabledBackgroundColor(a) {
            this.ai = a;
            this.g("ActualItemDisabledBackgroundColor");
        }
        get actualItemTextColor() {
            return this.an;
        }
        set actualItemTextColor(a) {
            this.an = a;
            this.g("ActualItemTextColor");
        }
        get actualItemDisabledTextColor() {
            return this.ak;
        }
        set actualItemDisabledTextColor(a) {
            this.ak = a;
            this.g("ActualItemDisabledTextColor");
        }
        get actualItemBorderColor() {
            return this.ah;
        }
        set actualItemBorderColor(a) {
            this.ah = a;
            this.g("ActualItemBorderColor");
        }
        get actualItemDisabledBorderColor() {
            return this.aj;
        }
        set actualItemDisabledBorderColor(a) {
            this.aj = a;
            this.g("ActualItemDisabledBorderColor");
        }
        get actualItemBorderWidth() {
            return this.p;
        }
        set actualItemBorderWidth(a) {
            this.p = a;
            this.g("ActualItemBorderWidth");
        }
        get actualSelectedItemBackgroundColor() {
            return this.ao;
        }
        set actualSelectedItemBackgroundColor(a) {
            this.ao = a;
            this.g("ActualSelectedItemBackgroundColor");
        }
        get actualSelectedItemTextColor() {
            return this.ar;
        }
        set actualSelectedItemTextColor(a) {
            this.ar = a;
            this.g("ActualSelectedItemTextColor");
        }
        get actualItemHoverBackgroundColor() {
            return this.al;
        }
        set actualItemHoverBackgroundColor(a) {
            this.al = a;
            this.g("ActualItemHoverBackgroundColor");
        }
        get actualItemHoverTextColor() {
            return this.am;
        }
        set actualItemHoverTextColor(a) {
            this.am = a;
            this.g("ActualItemHoverTextColor");
        }
        get actualSelectedItemHoverBackgroundColor() {
            return this.ap;
        }
        set actualSelectedItemHoverBackgroundColor(a) {
            this.ap = a;
            this.g("ActualSelectedItemHoverBackgroundColor");
        }
        get actualSelectedItemHoverTextColor() {
            return this.aq;
        }
        set actualSelectedItemHoverTextColor(a) {
            this.aq = a;
            this.g("ActualSelectedItemHoverTextColor");
        }
        get itemCornerRadius() {
            return this.u;
        }
        set itemCornerRadius(a) {
            this.u = a;
            this.g("ItemCornerRadius");
        }
        get itemBackgroundColor() {
            return this.a8;
        }
        set itemBackgroundColor(a) {
            this.a8 = a;
            this.g("ItemBackgroundColor");
        }
        get itemDisabledBackgroundColor() {
            return this.ba;
        }
        set itemDisabledBackgroundColor(a) {
            this.ba = a;
            this.g("ItemDisabledBackgroundColor");
        }
        get itemTextColor() {
            return this.bf;
        }
        set itemTextColor(a) {
            this.bf = a;
            this.g("ItemTextColor");
        }
        get itemDisabledTextColor() {
            return this.bc;
        }
        set itemDisabledTextColor(a) {
            this.bc = a;
            this.g("ItemDisabledTextColor");
        }
        get itemHoverBackgroundColor() {
            return this.bd;
        }
        set itemHoverBackgroundColor(a) {
            this.bd = a;
            this.g("ItemHoverBackgroundColor");
        }
        get itemBorderColor() {
            return this.a9;
        }
        set itemBorderColor(a) {
            this.a9 = a;
            this.g("ItemBorderColor");
        }
        get itemDisabledBorderColor() {
            return this.bb;
        }
        set itemDisabledBorderColor(a) {
            this.bb = a;
            this.g("ItemDisabledBorderColor");
        }
        get itemBorderWidth() {
            return this.t;
        }
        set itemBorderWidth(a) {
            this.t = a;
            this.g("ItemBorderWidth");
        }
        get itemHoverTextColor() {
            return this.be;
        }
        set itemHoverTextColor(a) {
            this.be = a;
            this.g("ItemHoverTextColor");
        }
        get selectedItemBackgroundColor() {
            return this.bt;
        }
        set selectedItemBackgroundColor(a) {
            this.bt = a;
            this.g("SelectedItemBackgroundColor");
        }
        get selectedItemTextColor() {
            return this.bw;
        }
        set selectedItemTextColor(a) {
            this.bw = a;
            this.g("SelectedItemTextColor");
        }
        get selectedItemHoverBackgroundColor() {
            return this.bu;
        }
        set selectedItemHoverBackgroundColor(a) {
            this.bu = a;
            this.g("SelectedItemHoverBackgroundColor");
        }
        get selectedItemHoverTextColor() {
            return this.bv;
        }
        set selectedItemHoverTextColor(a) {
            this.bv = a;
            this.g("SelectedItemHoverTextColor");
        }
        get outlinedItemCornerRadius() {
            return this.w;
        }
        set outlinedItemCornerRadius(a) {
            this.w = a;
            this.g("OutlinedItemCornerRadius");
        }
        get outlinedItemBackgroundColor() {
            return this.bh;
        }
        set outlinedItemBackgroundColor(a) {
            this.bh = a;
            this.g("OutlinedItemBackgroundColor");
        }
        get outlinedItemDisabledBackgroundColor() {
            return this.bj;
        }
        set outlinedItemDisabledBackgroundColor(a) {
            this.bj = a;
            this.g("OutlinedItemDisabledBackgroundColor");
        }
        get outlinedItemTextColor() {
            return this.bo;
        }
        set outlinedItemTextColor(a) {
            this.bo = a;
            this.g("OutlinedItemTextColor");
        }
        get outlinedItemDisabledTextColor() {
            return this.bl;
        }
        set outlinedItemDisabledTextColor(a) {
            this.bl = a;
            this.g("OutlinedItemDisabledTextColor");
        }
        get outlinedItemHoverBackgroundColor() {
            return this.bm;
        }
        set outlinedItemHoverBackgroundColor(a) {
            this.bm = a;
            this.g("OutlinedItemHoverBackgroundColor");
        }
        get outlinedItemBorderColor() {
            return this.bi;
        }
        set outlinedItemBorderColor(a) {
            this.bi = a;
            this.g("OutlinedItemBorderColor");
        }
        get outlinedItemDisabledBorderColor() {
            return this.bk;
        }
        set outlinedItemDisabledBorderColor(a) {
            this.bk = a;
            this.g("OutlinedItemDisabledBorderColor");
        }
        get outlinedItemBorderWidth() {
            return this.v;
        }
        set outlinedItemBorderWidth(a) {
            this.v = a;
            this.g("OutlinedItemBorderWidth");
        }
        get outlinedItemHoverTextColor() {
            return this.bn;
        }
        set outlinedItemHoverTextColor(a) {
            this.bn = a;
            this.g("OutlinedItemHoverTextColor");
        }
        get outlinedSelectedItemBackgroundColor() {
            return this.bp;
        }
        set outlinedSelectedItemBackgroundColor(a) {
            this.bp = a;
            this.g("OutlinedSelectedItemBackgroundColor");
        }
        get outlinedSelectedItemTextColor() {
            return this.bs;
        }
        set outlinedSelectedItemTextColor(a) {
            this.bs = a;
            this.g("OutlinedSelectedItemTextColor");
        }
        get outlinedSelectedItemHoverBackgroundColor() {
            return this.bq;
        }
        set outlinedSelectedItemHoverBackgroundColor(a) {
            this.bq = a;
            this.g("OutlinedSelectedItemHoverBackgroundColor");
        }
        get outlinedSelectedItemHoverTextColor() {
            return this.br;
        }
        set outlinedSelectedItemHoverTextColor(a) {
            this.br = a;
            this.g("OutlinedSelectedItemHoverTextColor");
        }
        get flatItemCornerRadius() {
            return this.s;
        }
        set flatItemCornerRadius(a) {
            this.s = a;
            this.g("FlatItemCornerRadius");
        }
        get flatItemBackgroundColor() {
            return this.av;
        }
        set flatItemBackgroundColor(a) {
            this.av = a;
            this.g("FlatItemBackgroundColor");
        }
        get flatItemDisabledBackgroundColor() {
            return this.ax;
        }
        set flatItemDisabledBackgroundColor(a) {
            this.ax = a;
            this.g("FlatItemDisabledBackgroundColor");
        }
        get flatItemTextColor() {
            return this.a2;
        }
        set flatItemTextColor(a) {
            this.a2 = a;
            this.g("FlatItemTextColor");
        }
        get flatItemDisabledTextColor() {
            return this.az;
        }
        set flatItemDisabledTextColor(a) {
            this.az = a;
            this.g("FlatItemDisabledTextColor");
        }
        get flatItemHoverBackgroundColor() {
            return this.a0;
        }
        set flatItemHoverBackgroundColor(a) {
            this.a0 = a;
            this.g("FlatItemHoverBackgroundColor");
        }
        get flatItemBorderColor() {
            return this.aw;
        }
        set flatItemBorderColor(a) {
            this.aw = a;
            this.g("FlatItemBorderColor");
        }
        get flatItemDisabledBorderColor() {
            return this.ay;
        }
        set flatItemDisabledBorderColor(a) {
            this.ay = a;
            this.g("FlatItemDisabledBorderColor");
        }
        get flatItemBorderWidth() {
            return this.r;
        }
        set flatItemBorderWidth(a) {
            this.r = a;
            this.g("FlatItemBorderWidth");
        }
        get flatItemHoverTextColor() {
            return this.a1;
        }
        set flatItemHoverTextColor(a) {
            this.a1 = a;
            this.g("FlatItemHoverTextColor");
        }
        get flatSelectedItemBackgroundColor() {
            return this.a3;
        }
        set flatSelectedItemBackgroundColor(a) {
            this.a3 = a;
            this.g("FlatSelectedItemBackgroundColor");
        }
        get flatSelectedItemTextColor() {
            return this.a6;
        }
        set flatSelectedItemTextColor(a) {
            this.a6 = a;
            this.g("FlatSelectedItemTextColor");
        }
        get flatSelectedItemHoverBackgroundColor() {
            return this.a4;
        }
        set flatSelectedItemHoverBackgroundColor(a) {
            this.a4 = a;
            this.g("FlatSelectedItemHoverBackgroundColor");
        }
        get flatSelectedItemHoverTextColor() {
            return this.a5;
        }
        set flatSelectedItemHoverTextColor(a) {
            this.a5 = a;
            this.g("FlatSelectedItemHoverTextColor");
        }
        get orientation() {
            return this.bg;
        }
        set orientation(a) {
            this.bg = a;
            this.g("Orientation");
        }
        get id() {
            return this.a7;
        }
        set id(a) {
            this.a7 = a;
            this.g("Id");
        }
        get disabled() {
            return this.l;
        }
        set disabled(a) {
            this.l = a;
            this.g("Disabled");
        }
        get isMultiSelect() {
            return this.m;
        }
        set isMultiSelect(a) {
            this.m = a;
            this.g("IsMultiSelect");
        }
        get buttons() {
            return this.h;
        }
        set buttons(a) {
            this.h = a;
            this.g("Buttons");
        }
        get selectionChangedRef() {
            return this.bx;
        }
        set selectionChangedRef(a) {
            this.bx = a;
            this.g("SelectionChangedRef");
        }
    }
    ButtonGroupDescription.$t = /*@__PURE__*/ markType(ButtonGroupDescription, 'ButtonGroupDescription', Description.$);
    return ButtonGroupDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonGroupSelectionChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class ButtonGroupSelectionChangedEventArgsDescription extends Description {
        get_type() {
            return "ButtonGroupSelectionChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ButtonGroupSelectionChangedEventArgsDescription.$t = /*@__PURE__*/ markType(ButtonGroupSelectionChangedEventArgsDescription, 'ButtonGroupSelectionChangedEventArgsDescription', Description.$);
    return ButtonGroupSelectionChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonGroupSelectionChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ButtonGroupSelectionChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ButtonGroupSelectionChangedEventArgsDescriptionMetadata.a == null) {
                ButtonGroupSelectionChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ButtonGroupSelectionChangedEventArgsDescriptionMetadata.c(ButtonGroupSelectionChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(ButtonGroupSelectionChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ButtonGroupSelectionChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ButtonGroupSelectionChangedEventArgsDescriptionMetadata.b(a);
            a.ae("ButtonGroupSelectionChangedEventArgs", () => new ButtonGroupSelectionChangedEventArgsDescription());
            a.ad("ButtonGroupSelectionChangedEventArgs", ButtonGroupSelectionChangedEventArgsDescriptionMetadata.a);
        }
    }
    ButtonGroupSelectionChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ButtonGroupSelectionChangedEventArgsDescriptionMetadata, 'ButtonGroupSelectionChangedEventArgsDescriptionMetadata');
    ButtonGroupSelectionChangedEventArgsDescriptionMetadata.a = null;
    return ButtonGroupSelectionChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonGroupDescriptionMetadata = /*@__PURE__*/ (() => {
    class ButtonGroupDescriptionMetadata extends Base {
        static b(a) {
            if (ButtonGroupDescriptionMetadata.a == null) {
                ButtonGroupDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ButtonGroupDescriptionMetadata.c(ButtonGroupDescriptionMetadata.a);
            }
            if (a.k(ButtonGroupDescriptionMetadata.a)) {
                return;
            }
            a.ac(ButtonGroupDescriptionMetadata.a);
            ButtonGroupSelectionChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:XButtonGroup");
            a.item("DisplayType", "ExportedType:string:ButtonGroupDisplayStyle");
            a.item("DisplayType@names", "Flat;Outlined");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActualDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("ActualDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("SelectedIndices", "Array:int");
            a.item("ActualItemCornerRadius", "Number:double");
            a.item("ActualItemBackgroundColor", "Brush");
            a.item("ActualItemDisabledBackgroundColor", "Brush");
            a.item("ActualItemTextColor", "Brush");
            a.item("ActualItemDisabledTextColor", "Brush");
            a.item("ActualItemBorderColor", "Brush");
            a.item("ActualItemDisabledBorderColor", "Brush");
            a.item("ActualItemBorderWidth", "Number:double");
            a.item("ActualSelectedItemBackgroundColor", "Brush");
            a.item("ActualSelectedItemTextColor", "Brush");
            a.item("ActualItemHoverBackgroundColor", "Brush");
            a.item("ActualItemHoverTextColor", "Brush");
            a.item("ActualSelectedItemHoverBackgroundColor", "Brush");
            a.item("ActualSelectedItemHoverTextColor", "Brush");
            a.item("ItemCornerRadius", "Number:double");
            a.item("ItemBackgroundColor", "Brush");
            a.item("ItemDisabledBackgroundColor", "Brush");
            a.item("ItemTextColor", "Brush");
            a.item("ItemDisabledTextColor", "Brush");
            a.item("ItemHoverBackgroundColor", "Brush");
            a.item("ItemBorderColor", "Brush");
            a.item("ItemDisabledBorderColor", "Brush");
            a.item("ItemBorderWidth", "Number:double");
            a.item("ItemHoverTextColor", "Brush");
            a.item("SelectedItemBackgroundColor", "Brush");
            a.item("SelectedItemTextColor", "Brush");
            a.item("SelectedItemHoverBackgroundColor", "Brush");
            a.item("SelectedItemHoverTextColor", "Brush");
            a.item("OutlinedItemCornerRadius", "Number:double");
            a.item("OutlinedItemBackgroundColor", "Brush");
            a.item("OutlinedItemDisabledBackgroundColor", "Brush");
            a.item("OutlinedItemTextColor", "Brush");
            a.item("OutlinedItemDisabledTextColor", "Brush");
            a.item("OutlinedItemHoverBackgroundColor", "Brush");
            a.item("OutlinedItemBorderColor", "Brush");
            a.item("OutlinedItemDisabledBorderColor", "Brush");
            a.item("OutlinedItemBorderWidth", "Number:double");
            a.item("OutlinedItemHoverTextColor", "Brush");
            a.item("OutlinedSelectedItemBackgroundColor", "Brush");
            a.item("OutlinedSelectedItemTextColor", "Brush");
            a.item("OutlinedSelectedItemHoverBackgroundColor", "Brush");
            a.item("OutlinedSelectedItemHoverTextColor", "Brush");
            a.item("FlatItemCornerRadius", "Number:double");
            a.item("FlatItemBackgroundColor", "Brush");
            a.item("FlatItemDisabledBackgroundColor", "Brush");
            a.item("FlatItemTextColor", "Brush");
            a.item("FlatItemDisabledTextColor", "Brush");
            a.item("FlatItemHoverBackgroundColor", "Brush");
            a.item("FlatItemBorderColor", "Brush");
            a.item("FlatItemDisabledBorderColor", "Brush");
            a.item("FlatItemBorderWidth", "Number:double");
            a.item("FlatItemHoverTextColor", "Brush");
            a.item("FlatSelectedItemBackgroundColor", "Brush");
            a.item("FlatSelectedItemTextColor", "Brush");
            a.item("FlatSelectedItemHoverBackgroundColor", "Brush");
            a.item("FlatSelectedItemHoverTextColor", "Brush");
            a.item("Orientation", "ExportedType:string:ButtonGroupOrientation");
            a.item("Orientation@names", "Horizontal;Vertical");
            a.item("Id", "String");
            a.item("Disabled", "(w:IsDisabled,xam:IsDisabled,wf:IsDisabled)Boolean");
            a.item("IsMultiSelect", "Boolean");
            a.item("Buttons", "Collection:Button:ButtonGroupButtonCollection:Button");
            a.item("SelectionChangedRef", "EventRef::selectionChanged");
        }
        static d(a) {
            ButtonGroupDescriptionMetadata.b(a);
            a.ae("ButtonGroup", () => new ButtonGroupDescription());
            a.ad("ButtonGroup", ButtonGroupDescriptionMetadata.a);
        }
    }
    ButtonGroupDescriptionMetadata.$t = /*@__PURE__*/ markType(ButtonGroupDescriptionMetadata, 'ButtonGroupDescriptionMetadata');
    ButtonGroupDescriptionMetadata.a = null;
    return ButtonGroupDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChildContentDescriptionModule = /*@__PURE__*/ (() => {
    class ChildContentDescriptionModule extends Base {
        static register(a) {
        }
    }
    ChildContentDescriptionModule.$t = /*@__PURE__*/ markType(ChildContentDescriptionModule, 'ChildContentDescriptionModule');
    return ChildContentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RippleDescription = /*@__PURE__*/ (() => {
    class RippleDescription extends Description {
        get_type() {
            return "Ripple";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.r = null;
            this.t = null;
            this.s = null;
            this.p = null;
            this.q = null;
            this.n = 0;
            this.i = false;
            this.h = false;
            this.j = false;
        }
        get eventSourceRef() {
            return this.r;
        }
        set eventSourceRef(a) {
            this.r = a;
            this.g("EventSourceRef");
        }
        get rippleColor() {
            return this.t;
        }
        set rippleColor(a) {
            this.t = a;
            this.g("RippleColor");
        }
        get hoverColor() {
            return this.s;
        }
        set hoverColor(a) {
            this.s = a;
            this.g("HoverColor");
        }
        get actualHoverColor() {
            return this.p;
        }
        set actualHoverColor(a) {
            this.p = a;
            this.g("ActualHoverColor");
        }
        get actualRippleColor() {
            return this.q;
        }
        set actualRippleColor(a) {
            this.q = a;
            this.g("ActualRippleColor");
        }
        get rippleDuration() {
            return this.n;
        }
        set rippleDuration(a) {
            this.n = a;
            this.g("RippleDuration");
        }
        get isDisabled() {
            return this.i;
        }
        set isDisabled(a) {
            this.i = a;
            this.g("IsDisabled");
        }
        get isCentered() {
            return this.h;
        }
        set isCentered(a) {
            this.h = a;
            this.g("IsCentered");
        }
        get isHoverEnabled() {
            return this.j;
        }
        set isHoverEnabled(a) {
            this.j = a;
            this.g("IsHoverEnabled");
        }
    }
    RippleDescription.$t = /*@__PURE__*/ markType(RippleDescription, 'RippleDescription', Description.$);
    return RippleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RippleDescriptionMetadata = /*@__PURE__*/ (() => {
    class RippleDescriptionMetadata extends Base {
        static b(a) {
            if (RippleDescriptionMetadata.a == null) {
                RippleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RippleDescriptionMetadata.c(RippleDescriptionMetadata.a);
            }
            if (a.k(RippleDescriptionMetadata.a)) {
                return;
            }
            a.ac(RippleDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:XRipple");
            a.item("EventSourceRef", "(w:EventSource,wf:EventSource)DataRef");
            a.item("RippleColor", "Brush");
            a.item("HoverColor", "Brush");
            a.item("ActualHoverColor", "Brush");
            a.item("ActualRippleColor", "Brush");
            a.item("RippleDuration", "Number:double");
            a.item("IsDisabled", "Boolean");
            a.item("IsCentered", "Boolean");
            a.item("IsHoverEnabled", "Boolean");
        }
        static d(a) {
            RippleDescriptionMetadata.b(a);
            a.ae("Ripple", () => new RippleDescription());
            a.ad("Ripple", RippleDescriptionMetadata.a);
        }
    }
    RippleDescriptionMetadata.$t = /*@__PURE__*/ markType(RippleDescriptionMetadata, 'RippleDescriptionMetadata');
    RippleDescriptionMetadata.a = null;
    return RippleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RippleDescriptionModule = /*@__PURE__*/ (() => {
    class RippleDescriptionModule extends Base {
        static register(a) {
            RippleDescriptionMetadata.d(a);
        }
    }
    RippleDescriptionModule.$t = /*@__PURE__*/ markType(RippleDescriptionModule, 'RippleDescriptionModule');
    return RippleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonDescriptionModule = /*@__PURE__*/ (() => {
    class ButtonDescriptionModule extends Base {
        static register(a) {
            RippleDescriptionModule.register(a);
            ChildContentDescriptionModule.register(a);
            ButtonDescriptionMetadata.d(a);
        }
    }
    ButtonDescriptionModule.$t = /*@__PURE__*/ markType(ButtonDescriptionModule, 'ButtonDescriptionModule');
    return ButtonDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonGroupDescriptionModule = /*@__PURE__*/ (() => {
    class ButtonGroupDescriptionModule extends Base {
        static register(a) {
            ChildContentDescriptionModule.register(a);
            ButtonDescriptionModule.register(a);
            ButtonGroupDescriptionMetadata.d(a);
        }
    }
    ButtonGroupDescriptionModule.$t = /*@__PURE__*/ markType(ButtonGroupDescriptionModule, 'ButtonGroupDescriptionModule');
    return ButtonGroupDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalendarDescription = /*@__PURE__*/ (() => {
    class CalendarDescription extends Description {
        get_type() {
            return "Calendar";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.o = new Date();
            this.n = new Date();
            this.m = new Date();
            this.l = new Date();
            this.z = null;
            this.w = null;
            this.v = null;
            this.ai = null;
            this.ak = null;
            this.ac = null;
            this.ah = null;
            this.am = null;
            this.aj = null;
            this.ad = null;
            this.y = null;
            this.x = null;
            this.h = false;
            this.ae = null;
            this.t = 0;
            this.af = null;
            this.ag = null;
            this.aa = null;
            this.ab = null;
            this.i = false;
            this.al = null;
            this.an = null;
        }
        get value() {
            return this.o;
        }
        set value(a) {
            this.o = a;
            this.g("Value");
        }
        get today() {
            return this.n;
        }
        set today(a) {
            this.n = a;
            this.g("Today");
        }
        get minDate() {
            return this.m;
        }
        set minDate(a) {
            this.m = a;
            this.g("MinDate");
        }
        get maxDate() {
            return this.l;
        }
        set maxDate(a) {
            this.l = a;
            this.g("MaxDate");
        }
        get density() {
            return this.z;
        }
        set density(a) {
            this.z = a;
            this.g("Density");
        }
        get baseTheme() {
            return this.w;
        }
        set baseTheme(a) {
            this.w = a;
            this.g("BaseTheme");
        }
        get backgroundColor() {
            return this.v;
        }
        set backgroundColor(a) {
            this.v = a;
            this.g("BackgroundColor");
        }
        get selectedDateBackgroundColor() {
            return this.ai;
        }
        set selectedDateBackgroundColor(a) {
            this.ai = a;
            this.g("SelectedDateBackgroundColor");
        }
        get selectedFocusDateBackgroundColor() {
            return this.ak;
        }
        set selectedFocusDateBackgroundColor(a) {
            this.ak = a;
            this.g("SelectedFocusDateBackgroundColor");
        }
        get focusDateBackgroundColor() {
            return this.ac;
        }
        set focusDateBackgroundColor(a) {
            this.ac = a;
            this.g("FocusDateBackgroundColor");
        }
        get hoverBackgroundColor() {
            return this.ah;
        }
        set hoverBackgroundColor(a) {
            this.ah = a;
            this.g("HoverBackgroundColor");
        }
        get textColor() {
            return this.am;
        }
        set textColor(a) {
            this.am = a;
            this.g("TextColor");
        }
        get selectedDateTextColor() {
            return this.aj;
        }
        set selectedDateTextColor(a) {
            this.aj = a;
            this.g("SelectedDateTextColor");
        }
        get focusDateTextColor() {
            return this.ad;
        }
        set focusDateTextColor(a) {
            this.ad = a;
            this.g("FocusDateTextColor");
        }
        get currentDateTextColor() {
            return this.y;
        }
        set currentDateTextColor(a) {
            this.y = a;
            this.g("CurrentDateTextColor");
        }
        get currentDateBorderColor() {
            return this.x;
        }
        set currentDateBorderColor(a) {
            this.x = a;
            this.g("CurrentDateBorderColor");
        }
        get showTodayButton() {
            return this.h;
        }
        set showTodayButton(a) {
            this.h = a;
            this.g("ShowTodayButton");
        }
        get fontFamily() {
            return this.ae;
        }
        set fontFamily(a) {
            this.ae = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.t;
        }
        set fontSize(a) {
            this.t = a;
            this.g("FontSize");
        }
        get fontStyle() {
            return this.af;
        }
        set fontStyle(a) {
            this.af = a;
            this.g("FontStyle");
        }
        get fontWeight() {
            return this.ag;
        }
        set fontWeight(a) {
            this.ag = a;
            this.g("FontWeight");
        }
        get firstDayOfWeek() {
            return this.aa;
        }
        set firstDayOfWeek(a) {
            this.aa = a;
            this.g("FirstDayOfWeek");
        }
        get firstWeekOfYear() {
            return this.ab;
        }
        set firstWeekOfYear(a) {
            this.ab = a;
            this.g("FirstWeekOfYear");
        }
        get showWeekNumbers() {
            return this.i;
        }
        set showWeekNumbers(a) {
            this.i = a;
            this.g("ShowWeekNumbers");
        }
        get selectedValueChangedRef() {
            return this.al;
        }
        set selectedValueChangedRef(a) {
            this.al = a;
            this.g("SelectedValueChangedRef");
        }
        get valueChangeRef() {
            return this.an;
        }
        set valueChangeRef(a) {
            this.an = a;
            this.g("ValueChangeRef");
        }
    }
    CalendarDescription.$t = /*@__PURE__*/ markType(CalendarDescription, 'CalendarDescription', Description.$);
    return CalendarDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedValueChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class SelectedValueChangedEventArgsDescription extends Description {
        get_type() {
            return "SelectedValueChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = new Date();
            this.h = new Date();
        }
        get oldValue() {
            return this.i;
        }
        set oldValue(a) {
            this.i = a;
            this.g("OldValue");
        }
        get newValue() {
            return this.h;
        }
        set newValue(a) {
            this.h = a;
            this.g("NewValue");
        }
    }
    SelectedValueChangedEventArgsDescription.$t = /*@__PURE__*/ markType(SelectedValueChangedEventArgsDescription, 'SelectedValueChangedEventArgsDescription', Description.$);
    return SelectedValueChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedValueChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SelectedValueChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SelectedValueChangedEventArgsDescriptionMetadata.a == null) {
                SelectedValueChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SelectedValueChangedEventArgsDescriptionMetadata.c(SelectedValueChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(SelectedValueChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(SelectedValueChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("OldValue", "Date");
            a.item("NewValue", "Date");
        }
        static d(a) {
            SelectedValueChangedEventArgsDescriptionMetadata.b(a);
            a.ae("SelectedValueChangedEventArgs", () => new SelectedValueChangedEventArgsDescription());
            a.ad("SelectedValueChangedEventArgs", SelectedValueChangedEventArgsDescriptionMetadata.a);
        }
    }
    SelectedValueChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SelectedValueChangedEventArgsDescriptionMetadata, 'SelectedValueChangedEventArgsDescriptionMetadata');
    SelectedValueChangedEventArgsDescriptionMetadata.a = null;
    return SelectedValueChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalendarDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalendarDescriptionMetadata extends Base {
        static b(a) {
            if (CalendarDescriptionMetadata.a == null) {
                CalendarDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalendarDescriptionMetadata.c(CalendarDescriptionMetadata.a);
            }
            if (a.k(CalendarDescriptionMetadata.a)) {
                return;
            }
            a.ac(CalendarDescriptionMetadata.a);
            SelectedValueChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:XCalendar");
            a.item("Value", "Date");
            a.item("Today", "Date");
            a.item("MinDate", "Date");
            a.item("MaxDate", "Date");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("BackgroundColor", "Brush");
            a.item("SelectedDateBackgroundColor", "Brush");
            a.item("SelectedFocusDateBackgroundColor", "Brush");
            a.item("FocusDateBackgroundColor", "Brush");
            a.item("HoverBackgroundColor", "Brush");
            a.item("TextColor", "Brush");
            a.item("SelectedDateTextColor", "Brush");
            a.item("FocusDateTextColor", "Brush");
            a.item("CurrentDateTextColor", "Brush");
            a.item("CurrentDateBorderColor", "Brush");
            a.item("ShowTodayButton", "Boolean");
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontFamily/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontFamily/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            a.item("FirstDayOfWeek", "ExportedType:string:DayOfWeek");
            a.item("FirstDayOfWeek@names", "Sunday;Monday;Tuesday;Wednesday;Thursday;Friday;Saturday");
            a.item("FirstWeekOfYear", "ExportedType:string:FirstWeek");
            a.item("FirstWeekOfYear@names", "FirstDay;FirstFullWeek;FirstFourDayWeek");
            a.item("ShowWeekNumbers", "Boolean");
            a.item("SelectedValueChangedRef", "EventRef::selectedValueChanged");
            a.item("ValueChangeRef", "EventRef::valueChange");
        }
        static d(a) {
            CalendarDescriptionMetadata.b(a);
            a.ae("Calendar", () => new CalendarDescription());
            a.ad("Calendar", CalendarDescriptionMetadata.a);
        }
    }
    CalendarDescriptionMetadata.$t = /*@__PURE__*/ markType(CalendarDescriptionMetadata, 'CalendarDescriptionMetadata');
    CalendarDescriptionMetadata.a = null;
    return CalendarDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalendarDateDescription = /*@__PURE__*/ (() => {
    class CalendarDateDescription extends Description {
        get_type() {
            return "CalendarDate";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.o = new Date();
            this.i = false;
            this.k = false;
            this.j = false;
        }
        get date() {
            return this.o;
        }
        set date(a) {
            this.o = a;
            this.g("Date");
        }
        get isCurrentMonth() {
            return this.i;
        }
        set isCurrentMonth(a) {
            this.i = a;
            this.g("IsCurrentMonth");
        }
        get isPrevMonth() {
            return this.k;
        }
        set isPrevMonth(a) {
            this.k = a;
            this.g("IsPrevMonth");
        }
        get isNextMonth() {
            return this.j;
        }
        set isNextMonth(a) {
            this.j = a;
            this.g("IsNextMonth");
        }
    }
    CalendarDateDescription.$t = /*@__PURE__*/ markType(CalendarDateDescription, 'CalendarDateDescription', Description.$);
    CalendarDateDescription.__marshalByValue = true;
    CalendarDateDescription.__marshalByValueAlias = "CalendarDate";
    return CalendarDateDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalendarDateDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalendarDateDescriptionMetadata extends Base {
        static b(a) {
            if (CalendarDateDescriptionMetadata.a == null) {
                CalendarDateDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalendarDateDescriptionMetadata.c(CalendarDateDescriptionMetadata.a);
            }
            if (a.k(CalendarDateDescriptionMetadata.a)) {
                return;
            }
            a.ac(CalendarDateDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Date", "Date");
            a.item("IsCurrentMonth", "Boolean");
            a.item("IsPrevMonth", "Boolean");
            a.item("IsNextMonth", "Boolean");
        }
        static d(a) {
            CalendarDateDescriptionMetadata.b(a);
            a.ae("CalendarDate", () => new CalendarDateDescription());
            a.ad("CalendarDate", CalendarDateDescriptionMetadata.a);
        }
    }
    CalendarDateDescriptionMetadata.$t = /*@__PURE__*/ markType(CalendarDateDescriptionMetadata, 'CalendarDateDescriptionMetadata');
    CalendarDateDescriptionMetadata.a = null;
    return CalendarDateDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalendarFormatOptionsDescription = /*@__PURE__*/ (() => {
    class CalendarFormatOptionsDescription extends Description {
        get_type() {
            return "CalendarFormatOptions";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = null;
            this.j = null;
        }
        get weekday() {
            return this.k;
        }
        set weekday(a) {
            this.k = a;
            this.g("Weekday");
        }
        get month() {
            return this.j;
        }
        set month(a) {
            this.j = a;
            this.g("Month");
        }
    }
    CalendarFormatOptionsDescription.$t = /*@__PURE__*/ markType(CalendarFormatOptionsDescription, 'CalendarFormatOptionsDescription', Description.$);
    CalendarFormatOptionsDescription.__marshalByValue = true;
    CalendarFormatOptionsDescription.__marshalByValueAlias = "CalendarFormatOptions";
    return CalendarFormatOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalendarFormatOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalendarFormatOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (CalendarFormatOptionsDescriptionMetadata.a == null) {
                CalendarFormatOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalendarFormatOptionsDescriptionMetadata.c(CalendarFormatOptionsDescriptionMetadata.a);
            }
            if (a.k(CalendarFormatOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(CalendarFormatOptionsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Weekday", "String");
            a.item("Month", "String");
        }
        static d(a) {
            CalendarFormatOptionsDescriptionMetadata.b(a);
            a.ae("CalendarFormatOptions", () => new CalendarFormatOptionsDescription());
            a.ad("CalendarFormatOptions", CalendarFormatOptionsDescriptionMetadata.a);
        }
    }
    CalendarFormatOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(CalendarFormatOptionsDescriptionMetadata, 'CalendarFormatOptionsDescriptionMetadata');
    CalendarFormatOptionsDescriptionMetadata.a = null;
    return CalendarFormatOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IconDescription = /*@__PURE__*/ (() => {
    class IconDescription extends Description {
        get_type() {
            return "Icon";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.at = null;
            this.ap = null;
            this.aq = null;
            this.ar = null;
            this.r = 0;
            this.av = null;
            this.a7 = null;
            this.w = 0;
            this.ba = null;
            this.az = null;
            this.a0 = null;
            this.u = 0;
            this.a1 = null;
            this.h = null;
            this.i = null;
            this.a3 = null;
            this.a4 = null;
            this.a5 = null;
            this.a6 = null;
            this.au = null;
            this.a9 = null;
            this.a8 = null;
            this.j = null;
            this.aw = null;
            this.s = 0;
            this.ax = null;
            this.ay = null;
            this.a2 = null;
            this.an = 0;
            this.as = null;
            this.o = false;
            this.n = false;
            this.v = 0;
            this.y = 0;
            this.z = 0;
            this.aa = 0;
            this.x = 0;
            this.ab = 0;
            this.t = 0;
        }
        get baseTheme() {
            return this.at;
        }
        set baseTheme(a) {
            this.at = a;
            this.g("BaseTheme");
        }
        get actualFill() {
            return this.ap;
        }
        set actualFill(a) {
            this.ap = a;
            this.g("ActualFill");
        }
        get actualStroke() {
            return this.aq;
        }
        set actualStroke(a) {
            this.aq = a;
            this.g("ActualStroke");
        }
        get actualTextColor() {
            return this.ar;
        }
        set actualTextColor(a) {
            this.ar = a;
            this.g("ActualTextColor");
        }
        get actualStrokeWidth() {
            return this.r;
        }
        set actualStrokeWidth(a) {
            this.r = a;
            this.g("ActualStrokeWidth");
        }
        get fill() {
            return this.av;
        }
        set fill(a) {
            this.av = a;
            this.g("Fill");
        }
        get stroke() {
            return this.a7;
        }
        set stroke(a) {
            this.a7 = a;
            this.g("Stroke");
        }
        get strokeWidth() {
            return this.w;
        }
        set strokeWidth(a) {
            this.w = a;
            this.g("StrokeWidth");
        }
        get textColor() {
            return this.ba;
        }
        set textColor(a) {
            this.ba = a;
            this.g("TextColor");
        }
        get hoverFill() {
            return this.az;
        }
        set hoverFill(a) {
            this.az = a;
            this.g("HoverFill");
        }
        get hoverStroke() {
            return this.a0;
        }
        set hoverStroke(a) {
            this.a0 = a;
            this.g("HoverStroke");
        }
        get hoverStrokeThickness() {
            return this.u;
        }
        set hoverStrokeThickness(a) {
            this.u = a;
            this.g("HoverStrokeThickness");
        }
        get hoverTextColor() {
            return this.a1;
        }
        set hoverTextColor(a) {
            this.a1 = a;
            this.g("HoverTextColor");
        }
        get fillColors() {
            return this.h;
        }
        set fillColors(a) {
            this.h = a;
            this.g("FillColors");
        }
        get strokeColors() {
            return this.i;
        }
        set strokeColors(a) {
            this.i = a;
            this.g("StrokeColors");
        }
        get primaryFillColor() {
            return this.a3;
        }
        set primaryFillColor(a) {
            this.a3 = a;
            this.g("PrimaryFillColor");
        }
        get primaryStrokeColor() {
            return this.a4;
        }
        set primaryStrokeColor(a) {
            this.a4 = a;
            this.g("PrimaryStrokeColor");
        }
        get secondaryFillColor() {
            return this.a5;
        }
        set secondaryFillColor(a) {
            this.a5 = a;
            this.g("SecondaryFillColor");
        }
        get secondaryStrokeColor() {
            return this.a6;
        }
        set secondaryStrokeColor(a) {
            this.a6 = a;
            this.g("SecondaryStrokeColor");
        }
        get dataURL() {
            return this.au;
        }
        set dataURL(a) {
            this.au = a;
            this.g("DataURL");
        }
        get svgPath() {
            return this.a9;
        }
        set svgPath(a) {
            this.a9 = a;
            this.g("SvgPath");
        }
        get svg() {
            return this.a8;
        }
        set svg(a) {
            this.a8 = a;
            this.g("Svg");
        }
        get sVGPaths() {
            return this.j;
        }
        set sVGPaths(a) {
            this.j = a;
            this.g("SVGPaths");
        }
        get fontFamily() {
            return this.aw;
        }
        set fontFamily(a) {
            this.aw = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.s;
        }
        set fontSize(a) {
            this.s = a;
            this.g("FontSize");
        }
        get fontStyle() {
            return this.ax;
        }
        set fontStyle(a) {
            this.ax = a;
            this.g("FontStyle");
        }
        get fontWeight() {
            return this.ay;
        }
        set fontWeight(a) {
            this.ay = a;
            this.g("FontWeight");
        }
        get id() {
            return this.a2;
        }
        set id(a) {
            this.a2 = a;
            this.g("Id");
        }
        get tabIndex() {
            return this.an;
        }
        set tabIndex(a) {
            this.an = a;
            this.g("TabIndex");
        }
        get ariaLabel() {
            return this.as;
        }
        set ariaLabel(a) {
            this.as = a;
            this.g("AriaLabel");
        }
        get isHover() {
            return this.o;
        }
        set isHover(a) {
            this.o = a;
            this.g("IsHover");
        }
        get disabled() {
            return this.n;
        }
        set disabled(a) {
            this.n = a;
            this.g("Disabled");
        }
        get opacity() {
            return this.v;
        }
        set opacity(a) {
            this.v = a;
            this.g("Opacity");
        }
        get viewBoxLeft() {
            return this.y;
        }
        set viewBoxLeft(a) {
            this.y = a;
            this.g("ViewBoxLeft");
        }
        get viewBoxTop() {
            return this.z;
        }
        set viewBoxTop(a) {
            this.z = a;
            this.g("ViewBoxTop");
        }
        get viewBoxWidth() {
            return this.aa;
        }
        set viewBoxWidth(a) {
            this.aa = a;
            this.g("ViewBoxWidth");
        }
        get viewBoxHeight() {
            return this.x;
        }
        set viewBoxHeight(a) {
            this.x = a;
            this.g("ViewBoxHeight");
        }
        get width() {
            return this.ab;
        }
        set width(a) {
            this.ab = a;
            this.g("Width");
        }
        get height() {
            return this.t;
        }
        set height(a) {
            this.t = a;
            this.g("Height");
        }
    }
    IconDescription.$t = /*@__PURE__*/ markType(IconDescription, 'IconDescription', Description.$);
    return IconDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IconDescriptionMetadata = /*@__PURE__*/ (() => {
    class IconDescriptionMetadata extends Base {
        static b(a) {
            if (IconDescriptionMetadata.a == null) {
                IconDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                IconDescriptionMetadata.c(IconDescriptionMetadata.a);
            }
            if (a.k(IconDescriptionMetadata.a)) {
                return;
            }
            a.ac(IconDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:XIcon");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("ActualFill", "Brush");
            a.item("ActualStroke", "Brush");
            a.item("ActualTextColor", "Brush");
            a.item("ActualStrokeWidth", "Number:double");
            a.item("Fill", "Brush");
            a.item("Stroke", "Brush");
            a.item("StrokeWidth", "Number:double");
            a.item("TextColor", "Brush");
            a.item("HoverFill", "Brush");
            a.item("HoverStroke", "Brush");
            a.item("HoverStrokeThickness", "Number:double");
            a.item("HoverTextColor", "Brush");
            a.item("FillColors", "BrushCollection:string");
            a.item("StrokeColors", "BrushCollection:string");
            a.item("PrimaryFillColor", "Brush");
            a.item("PrimaryStrokeColor", "Brush");
            a.item("SecondaryFillColor", "Brush");
            a.item("SecondaryStrokeColor", "Brush");
            a.item("DataURL", "String");
            a.item("SvgPath", "(w:SVGPath,wf:SVGPath)String");
            a.item("Svg", "(w:SVG,wf:SVG)String");
            a.item("SVGPaths", "Array:string");
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontFamily/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontFamily/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            a.item("Id", "String");
            a.item("TabIndex", "Number:int");
            a.item("AriaLabel", "String");
            a.item("IsHover", "Boolean");
            a.item("Disabled", "(w:IsDisabled,xam:IsDisabled,wf:IsDisabled)Boolean");
            a.item("Opacity", "Number:double");
            a.item("ViewBoxLeft", "Number:double");
            a.item("ViewBoxTop", "Number:double");
            a.item("ViewBoxWidth", "Number:double");
            a.item("ViewBoxHeight", "Number:double");
            a.item("Width", "Number:double");
            a.item("Height", "Number:double");
        }
        static d(a) {
            IconDescriptionMetadata.b(a);
            a.ae("Icon", () => new IconDescription());
            a.ad("Icon", IconDescriptionMetadata.a);
        }
    }
    IconDescriptionMetadata.$t = /*@__PURE__*/ markType(IconDescriptionMetadata, 'IconDescriptionMetadata');
    IconDescriptionMetadata.a = null;
    return IconDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IconDescriptionModule = /*@__PURE__*/ (() => {
    class IconDescriptionModule extends Base {
        static register(a) {
            ChildContentDescriptionModule.register(a);
            IconDescriptionMetadata.d(a);
        }
    }
    IconDescriptionModule.$t = /*@__PURE__*/ markType(IconDescriptionModule, 'IconDescriptionModule');
    return IconDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalendarDescriptionModule = /*@__PURE__*/ (() => {
    class CalendarDescriptionModule extends Base {
        static register(a) {
            ButtonDescriptionModule.register(a);
            IconDescriptionModule.register(a);
            CalendarDescriptionMetadata.d(a);
        }
    }
    CalendarDescriptionModule.$t = /*@__PURE__*/ markType(CalendarDescriptionModule, 'CalendarDescriptionModule');
    return CalendarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutRenderStyleUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class CalloutRenderStyleUpdatingEventArgsDescription extends Description {
        get_type() {
            return "CalloutRenderStyleUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.z = null;
            this.aa = null;
            this.j = 0;
            this.k = 0;
            this.m = 0;
            this.n = 0;
            this.t = null;
            this.v = null;
            this.h = null;
            this.u = null;
            this.y = null;
            this.x = null;
            this.w = null;
            this.l = 0;
        }
        get xValueRef() {
            return this.z;
        }
        set xValueRef(a) {
            this.z = a;
            this.g("XValueRef");
        }
        get yValueRef() {
            return this.aa;
        }
        set yValueRef(a) {
            this.aa = a;
            this.g("YValueRef");
        }
        get labelPositionX() {
            return this.j;
        }
        set labelPositionX(a) {
            this.j = a;
            this.g("LabelPositionX");
        }
        get labelPositionY() {
            return this.k;
        }
        set labelPositionY(a) {
            this.k = a;
            this.g("LabelPositionY");
        }
        get targetPositionX() {
            return this.m;
        }
        set targetPositionX(a) {
            this.m = a;
            this.g("TargetPositionX");
        }
        get targetPositionY() {
            return this.n;
        }
        set targetPositionY(a) {
            this.n = a;
            this.g("TargetPositionY");
        }
        get actualPosition() {
            return this.t;
        }
        set actualPosition(a) {
            this.t = a;
            this.g("ActualPosition");
        }
        get itemRef() {
            return this.v;
        }
        set itemRef(a) {
            this.v = a;
            this.g("ItemRef");
        }
        get series() {
            return this.h;
        }
        set series(a) {
            this.h = a;
            this.g("Series");
        }
        get background() {
            return this.u;
        }
        set background(a) {
            this.u = a;
            this.g("Background");
        }
        get textColor() {
            return this.y;
        }
        set textColor(a) {
            this.y = a;
            this.g("TextColor");
        }
        get outline() {
            return this.x;
        }
        set outline(a) {
            this.x = a;
            this.g("Outline");
        }
        get leaderBrush() {
            return this.w;
        }
        set leaderBrush(a) {
            this.w = a;
            this.g("LeaderBrush");
        }
        get strokeThickness() {
            return this.l;
        }
        set strokeThickness(a) {
            this.l = a;
            this.g("StrokeThickness");
        }
    }
    CalloutRenderStyleUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(CalloutRenderStyleUpdatingEventArgsDescription, 'CalloutRenderStyleUpdatingEventArgsDescription', Description.$);
    return CalloutRenderStyleUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutRenderStyleUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalloutRenderStyleUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CalloutRenderStyleUpdatingEventArgsDescriptionMetadata.a == null) {
                CalloutRenderStyleUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalloutRenderStyleUpdatingEventArgsDescriptionMetadata.c(CalloutRenderStyleUpdatingEventArgsDescriptionMetadata.a);
            }
            if (a.k(CalloutRenderStyleUpdatingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(CalloutRenderStyleUpdatingEventArgsDescriptionMetadata.a);
            SeriesDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("XValueRef", "(w:XValue,wf:XValue)DataRef");
            a.item("YValueRef", "(w:YValue,wf:YValue)DataRef");
            a.item("LabelPositionX", "Number:double");
            a.item("LabelPositionY", "Number:double");
            a.item("TargetPositionX", "Number:double");
            a.item("TargetPositionY", "Number:double");
            a.item("ActualPosition", "ExportedType:string:CalloutPlacementPositions");
            a.item("ActualPosition@names", "Top;Left;Right;Bottom;TopLeft;TopRight;BottomLeft;BottomRight");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("Series", "ExportedType:Series");
            a.item("Background", "Brush");
            a.item("TextColor", "Brush");
            a.item("Outline", "Brush");
            a.item("LeaderBrush", "Brush");
            a.item("StrokeThickness", "Number:double");
        }
        static d(a) {
            CalloutRenderStyleUpdatingEventArgsDescriptionMetadata.b(a);
            a.ae("CalloutRenderStyleUpdatingEventArgs", () => new CalloutRenderStyleUpdatingEventArgsDescription());
            a.ad("CalloutRenderStyleUpdatingEventArgs", CalloutRenderStyleUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    CalloutRenderStyleUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CalloutRenderStyleUpdatingEventArgsDescriptionMetadata, 'CalloutRenderStyleUpdatingEventArgsDescriptionMetadata');
    CalloutRenderStyleUpdatingEventArgsDescriptionMetadata.a = null;
    return CalloutRenderStyleUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CancelButtonClickEventArgsDescription = /*@__PURE__*/ (() => {
    class CancelButtonClickEventArgsDescription extends Description {
        get_type() {
            return "CancelButtonClickEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    CancelButtonClickEventArgsDescription.$t = /*@__PURE__*/ markType(CancelButtonClickEventArgsDescription, 'CancelButtonClickEventArgsDescription', Description.$);
    return CancelButtonClickEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CancelButtonClickEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CancelButtonClickEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CancelButtonClickEventArgsDescriptionMetadata.a == null) {
                CancelButtonClickEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CancelButtonClickEventArgsDescriptionMetadata.c(CancelButtonClickEventArgsDescriptionMetadata.a);
            }
            if (a.k(CancelButtonClickEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(CancelButtonClickEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            CancelButtonClickEventArgsDescriptionMetadata.b(a);
            a.ae("CancelButtonClickEventArgs", () => new CancelButtonClickEventArgsDescription());
            a.ad("CancelButtonClickEventArgs", CancelButtonClickEventArgsDescriptionMetadata.a);
        }
    }
    CancelButtonClickEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CancelButtonClickEventArgsDescriptionMetadata, 'CancelButtonClickEventArgsDescriptionMetadata');
    CancelButtonClickEventArgsDescriptionMetadata.a = null;
    return CancelButtonClickEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CancelEventArgsDescription = /*@__PURE__*/ (() => {
    class CancelEventArgsDescription extends Description {
        get_type() {
            return "CancelEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
        }
        get cancel() {
            return this.h;
        }
        set cancel(a) {
            this.h = a;
            this.g("Cancel");
        }
    }
    CancelEventArgsDescription.$t = /*@__PURE__*/ markType(CancelEventArgsDescription, 'CancelEventArgsDescription', Description.$);
    return CancelEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CancelEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CancelEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CancelEventArgsDescriptionMetadata.a == null) {
                CancelEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CancelEventArgsDescriptionMetadata.c(CancelEventArgsDescriptionMetadata.a);
            }
            if (a.k(CancelEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(CancelEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            CancelEventArgsDescriptionMetadata.b(a);
            a.ae("CancelEventArgs", () => new CancelEventArgsDescription());
            a.ad("CancelEventArgs", CancelEventArgsDescriptionMetadata.a);
        }
    }
    CancelEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CancelEventArgsDescriptionMetadata, 'CancelEventArgsDescriptionMetadata');
    CancelEventArgsDescriptionMetadata.a = null;
    return CancelEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CaptureImageSettingsDescription = /*@__PURE__*/ (() => {
    class CaptureImageSettingsDescription extends Description {
        get_type() {
            return "CaptureImageSettings";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = false;
        }
        get format() {
            return this.j;
        }
        set format(a) {
            this.j = a;
            this.g("Format");
        }
        get addToClipboard() {
            return this.h;
        }
        set addToClipboard(a) {
            this.h = a;
            this.g("AddToClipboard");
        }
    }
    CaptureImageSettingsDescription.$t = /*@__PURE__*/ markType(CaptureImageSettingsDescription, 'CaptureImageSettingsDescription', Description.$);
    return CaptureImageSettingsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CaptureImageSettingsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CaptureImageSettingsDescriptionMetadata extends Base {
        static b(a) {
            if (CaptureImageSettingsDescriptionMetadata.a == null) {
                CaptureImageSettingsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CaptureImageSettingsDescriptionMetadata.c(CaptureImageSettingsDescriptionMetadata.a);
            }
            if (a.k(CaptureImageSettingsDescriptionMetadata.a)) {
                return;
            }
            a.ac(CaptureImageSettingsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Format", "ExportedType:string:CaptureImageFormat");
            a.item("Format@names", "Png;Jpeg");
            a.item("AddToClipboard", "Boolean");
        }
        static d(a) {
            CaptureImageSettingsDescriptionMetadata.b(a);
            a.ae("CaptureImageSettings", () => new CaptureImageSettingsDescription());
            a.ad("CaptureImageSettings", CaptureImageSettingsDescriptionMetadata.a);
        }
    }
    CaptureImageSettingsDescriptionMetadata.$t = /*@__PURE__*/ markType(CaptureImageSettingsDescriptionMetadata, 'CaptureImageSettingsDescriptionMetadata');
    CaptureImageSettingsDescriptionMetadata.a = null;
    return CaptureImageSettingsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartSeriesEventArgsDescription = /*@__PURE__*/ (() => {
    class ChartSeriesEventArgsDescription extends Description {
        get_type() {
            return "ChartSeriesEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get series() {
            return this.h;
        }
        set series(a) {
            this.h = a;
            this.g("Series");
        }
    }
    ChartSeriesEventArgsDescription.$t = /*@__PURE__*/ markType(ChartSeriesEventArgsDescription, 'ChartSeriesEventArgsDescription', Description.$);
    return ChartSeriesEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartSeriesEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ChartSeriesEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ChartSeriesEventArgsDescriptionMetadata.a == null) {
                ChartSeriesEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ChartSeriesEventArgsDescriptionMetadata.c(ChartSeriesEventArgsDescriptionMetadata.a);
            }
            if (a.k(ChartSeriesEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ChartSeriesEventArgsDescriptionMetadata.a);
            SeriesDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Series", "ExportedType:Series");
        }
        static d(a) {
            ChartSeriesEventArgsDescriptionMetadata.b(a);
            a.ae("ChartSeriesEventArgs", () => new ChartSeriesEventArgsDescription());
            a.ad("ChartSeriesEventArgs", ChartSeriesEventArgsDescriptionMetadata.a);
        }
    }
    ChartSeriesEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ChartSeriesEventArgsDescriptionMetadata, 'ChartSeriesEventArgsDescriptionMetadata');
    ChartSeriesEventArgsDescriptionMetadata.a = null;
    return ChartSeriesEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DomainChartSeriesPointerEventArgsDescription = /*@__PURE__*/ (() => {
    class DomainChartSeriesPointerEventArgsDescription extends Description {
        get_type() {
            return "DomainChartSeriesPointerEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = null;
        }
        get series() {
            return this.h;
        }
        set series(a) {
            this.h = a;
            this.g("Series");
        }
        get itemRef() {
            return this.j;
        }
        set itemRef(a) {
            this.j = a;
            this.g("ItemRef");
        }
    }
    DomainChartSeriesPointerEventArgsDescription.$t = /*@__PURE__*/ markType(DomainChartSeriesPointerEventArgsDescription, 'DomainChartSeriesPointerEventArgsDescription', Description.$);
    return DomainChartSeriesPointerEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DomainChartSeriesPointerEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DomainChartSeriesPointerEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DomainChartSeriesPointerEventArgsDescriptionMetadata.a == null) {
                DomainChartSeriesPointerEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DomainChartSeriesPointerEventArgsDescriptionMetadata.c(DomainChartSeriesPointerEventArgsDescriptionMetadata.a);
            }
            if (a.k(DomainChartSeriesPointerEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(DomainChartSeriesPointerEventArgsDescriptionMetadata.a);
            SeriesDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Series", "ExportedType:Series");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
        }
        static d(a) {
            DomainChartSeriesPointerEventArgsDescriptionMetadata.b(a);
            a.ae("DomainChartSeriesPointerEventArgs", () => new DomainChartSeriesPointerEventArgsDescription());
            a.ad("DomainChartSeriesPointerEventArgs", DomainChartSeriesPointerEventArgsDescriptionMetadata.a);
        }
    }
    DomainChartSeriesPointerEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DomainChartSeriesPointerEventArgsDescriptionMetadata, 'DomainChartSeriesPointerEventArgsDescriptionMetadata');
    DomainChartSeriesPointerEventArgsDescriptionMetadata.a = null;
    return DomainChartSeriesPointerEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutStyleUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class CalloutStyleUpdatingEventArgsDescription extends Description {
        get_type() {
            return "CalloutStyleUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.q = null;
            this.r = null;
            this.m = null;
            this.h = null;
            this.l = null;
            this.p = null;
            this.o = null;
            this.n = null;
            this.j = 0;
        }
        get xValueRef() {
            return this.q;
        }
        set xValueRef(a) {
            this.q = a;
            this.g("XValueRef");
        }
        get yValueRef() {
            return this.r;
        }
        set yValueRef(a) {
            this.r = a;
            this.g("YValueRef");
        }
        get itemRef() {
            return this.m;
        }
        set itemRef(a) {
            this.m = a;
            this.g("ItemRef");
        }
        get series() {
            return this.h;
        }
        set series(a) {
            this.h = a;
            this.g("Series");
        }
        get background() {
            return this.l;
        }
        set background(a) {
            this.l = a;
            this.g("Background");
        }
        get textColor() {
            return this.p;
        }
        set textColor(a) {
            this.p = a;
            this.g("TextColor");
        }
        get outline() {
            return this.o;
        }
        set outline(a) {
            this.o = a;
            this.g("Outline");
        }
        get leaderBrush() {
            return this.n;
        }
        set leaderBrush(a) {
            this.n = a;
            this.g("LeaderBrush");
        }
        get strokeThickness() {
            return this.j;
        }
        set strokeThickness(a) {
            this.j = a;
            this.g("StrokeThickness");
        }
    }
    CalloutStyleUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(CalloutStyleUpdatingEventArgsDescription, 'CalloutStyleUpdatingEventArgsDescription', Description.$);
    return CalloutStyleUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutStyleUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalloutStyleUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CalloutStyleUpdatingEventArgsDescriptionMetadata.a == null) {
                CalloutStyleUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalloutStyleUpdatingEventArgsDescriptionMetadata.c(CalloutStyleUpdatingEventArgsDescriptionMetadata.a);
            }
            if (a.k(CalloutStyleUpdatingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(CalloutStyleUpdatingEventArgsDescriptionMetadata.a);
            SeriesDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("XValueRef", "(w:XValue,wf:XValue)DataRef");
            a.item("YValueRef", "(w:YValue,wf:YValue)DataRef");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("Series", "ExportedType:Series");
            a.item("Background", "Brush");
            a.item("TextColor", "Brush");
            a.item("Outline", "Brush");
            a.item("LeaderBrush", "Brush");
            a.item("StrokeThickness", "Number:double");
        }
        static d(a) {
            CalloutStyleUpdatingEventArgsDescriptionMetadata.b(a);
            a.ae("CalloutStyleUpdatingEventArgs", () => new CalloutStyleUpdatingEventArgsDescription());
            a.ad("CalloutStyleUpdatingEventArgs", CalloutStyleUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    CalloutStyleUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CalloutStyleUpdatingEventArgsDescriptionMetadata, 'CalloutStyleUpdatingEventArgsDescriptionMetadata');
    CalloutStyleUpdatingEventArgsDescriptionMetadata.a = null;
    return CalloutStyleUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterStringErrorsParsingEventArgsDescription = /*@__PURE__*/ (() => {
    class FilterStringErrorsParsingEventArgsDescription extends Description {
        get_type() {
            return "FilterStringErrorsParsingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
        }
        get propertyName() {
            return this.i;
        }
        set propertyName(a) {
            this.i = a;
            this.g("PropertyName");
        }
        get errors() {
            return this.h;
        }
        set errors(a) {
            this.h = a;
            this.g("Errors");
        }
    }
    FilterStringErrorsParsingEventArgsDescription.$t = /*@__PURE__*/ markType(FilterStringErrorsParsingEventArgsDescription, 'FilterStringErrorsParsingEventArgsDescription', Description.$);
    return FilterStringErrorsParsingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterStringErrorsParsingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FilterStringErrorsParsingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FilterStringErrorsParsingEventArgsDescriptionMetadata.a == null) {
                FilterStringErrorsParsingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FilterStringErrorsParsingEventArgsDescriptionMetadata.c(FilterStringErrorsParsingEventArgsDescriptionMetadata.a);
            }
            if (a.k(FilterStringErrorsParsingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(FilterStringErrorsParsingEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("PropertyName", "String");
            a.item("Errors", "String");
        }
        static d(a) {
            FilterStringErrorsParsingEventArgsDescriptionMetadata.b(a);
            a.ae("FilterStringErrorsParsingEventArgs", () => new FilterStringErrorsParsingEventArgsDescription());
            a.ad("FilterStringErrorsParsingEventArgs", FilterStringErrorsParsingEventArgsDescriptionMetadata.a);
        }
    }
    FilterStringErrorsParsingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FilterStringErrorsParsingEventArgsDescriptionMetadata, 'FilterStringErrorsParsingEventArgsDescriptionMetadata');
    FilterStringErrorsParsingEventArgsDescriptionMetadata.a = null;
    return FilterStringErrorsParsingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DomainChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class DomainChartDescriptionMetadata extends Base {
        static b(a) {
            if (DomainChartDescriptionMetadata.a == null) {
                DomainChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DomainChartDescriptionMetadata.c(DomainChartDescriptionMetadata.a);
            }
            if (a.k(DomainChartDescriptionMetadata.a)) {
                return;
            }
            a.ac(DomainChartDescriptionMetadata.a);
            ChartSeriesEventArgsDescriptionMetadata.d(a);
            DomainChartSeriesPointerEventArgsDescriptionMetadata.d(a);
            CalloutStyleUpdatingEventArgsDescriptionMetadata.d(a);
            CalloutRenderStyleUpdatingEventArgsDescriptionMetadata.d(a);
            SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata.d(a);
            FilterStringErrorsParsingEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("PixelScalingRatio", "Number:double");
            a.item("TitleLeftMargin", "Number:double");
            a.item("TitleRightMargin", "Number:double");
            a.item("TitleTopMargin", "Number:double");
            a.item("TitleBottomMargin", "Number:double");
            a.item("SubtitleLeftMargin", "Number:double");
            a.item("SubtitleTopMargin", "Number:double");
            a.item("SubtitleRightMargin", "Number:double");
            a.item("SubtitleBottomMargin", "Number:double");
            a.item("SubtitleTextColor", "Brush");
            a.item("TitleTextColor", "Brush");
            a.item("LeftMargin", "Number:double");
            a.item("TopMargin", "Number:double");
            a.item("RightMargin", "Number:double");
            a.item("BottomMargin", "Number:double");
            a.item("TransitionDuration", "Number:int");
            a.item("TransitionEasingFunctionRef", "(w:TransitionEasingFunction,wf:TransitionEasingFunction)MethodRef");
            a.item("HighlightingTransitionDuration", "Number:int");
            a.item("SelectionTransitionDuration", "Number:int");
            a.item("FocusTransitionDuration", "Number:int");
            a.item("SubtitleTextStyle", "String");
            a.item("TitleTextStyle", "String");
            a.item("DataToolTipGroupingMode", "ExportedType:string:DataToolTipLayerGroupingMode");
            a.item("DataToolTipGroupingMode@names", "Auto;Grouped;Individual");
            a.item("DataToolTipPositionOffsetX", "Number:double");
            a.item("DataToolTipPositionOffsetY", "Number:double");
            a.item("DataToolTipDefaultPositionOffsetX", "Number:double");
            a.item("DataToolTipDefaultPositionOffsetY", "Number:double");
            a.item("DataToolTipGroupedPositionModeX", "ExportedType:string:DataTooltipGroupedPositionX");
            a.item("DataToolTipGroupedPositionModeX@names", "Auto;SnapLeft;SnapRight;SnapMiddle;LeftEdgeSnapLeft;LeftEdgeSnapRight;LeftEdgeSnapMiddle;RightEdgeSnapLeft;RightEdgeSnapRight;RightEdgeSnapMiddle;TrackLeft;TrackRight;TrackMiddle;PinLeft;PinRight;PinMiddle");
            a.item("DataToolTipGroupedPositionModeY", "ExportedType:string:DataTooltipGroupedPositionY");
            a.item("DataToolTipGroupedPositionModeY@names", "Auto;SnapTop;SnapBottom;SnapMiddle;TopEdgeSnapTop;TopEdgeSnapBottom;TopEdgeSnapMiddle;BottomEdgeSnapTop;BottomEdgeSnapBottom;BottomEdgeSnapMiddle;TrackTop;TrackBottom;TrackMiddle;PinTop;PinBottom;PinMiddle");
            a.item("DataToolTipShouldUpdateWhenSeriesDataChanges", "Boolean");
            a.item("DataToolTipIncludedSeries", "Array:string");
            a.item("DataToolTipExcludedSeries", "Array:string");
            a.item("DataToolTipIncludedColumns", "Array:string");
            a.item("DataToolTipExcludedColumns", "Array:string");
            a.item("DataToolTipValueFormatAbbreviation", "ExportedType:string:DataAbbreviationMode");
            a.item("DataToolTipValueFormatAbbreviation@names", "Auto;Independent;Shared;Kilo;Million;Billion;Trillion;Quadrillion;Unset;None");
            a.item("DataToolTipValueFormatMaxFractions", "Number:int");
            a.item("DataToolTipValueFormatMinFractions", "Number:int");
            a.item("DataToolTipValueFormatMode", "ExportedType:string:DataLegendValueMode");
            a.item("DataToolTipValueFormatMode@names", "Auto;Decimal;Currency");
            a.item("DataToolTipValueFormatCulture", "String");
            a.item("DataToolTipValueFormatUseGrouping", "Boolean");
            a.item("DataToolTipValueFormatString", "String");
            a.item("DataToolTipValueFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("DataToolTipValueFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("DataToolTipValueRowMarginBottom", "(w:DataToolTipValueRowMargin.Bottom,wf:DataToolTipValueRowMarginBottom)Number:double");
            a.item("DataToolTipValueRowMarginLeft", "(w:DataToolTipValueRowMargin.Left,wf:DataToolTipValueRowMarginLeft)Number:double");
            a.item("DataToolTipValueRowMarginRight", "(w:DataToolTipValueRowMargin.Right,wf:DataToolTipValueRowMarginRight)Number:double");
            a.item("DataToolTipValueRowMarginTop", "(w:DataToolTipValueRowMargin.Top,wf:DataToolTipValueRowMarginTop)Number:double");
            a.item("DataToolTipValueRowVisible", "Boolean");
            a.item("DataToolTipValueTextWhenMissingData", "String");
            a.item("DataToolTipValueTextUseSeriesColors", "Boolean");
            a.item("DataToolTipValueTextMarginBottom", "(w:DataToolTipValueTextMargin.Bottom,wf:DataToolTipValueTextMarginBottom)Number:double");
            a.item("DataToolTipValueTextMarginLeft", "(w:DataToolTipValueTextMargin.Left,wf:DataToolTipValueTextMarginLeft)Number:double");
            a.item("DataToolTipValueTextMarginRight", "(w:DataToolTipValueTextMargin.Right,wf:DataToolTipValueTextMarginRight)Number:double");
            a.item("DataToolTipValueTextMarginTop", "(w:DataToolTipValueTextMargin.Top,wf:DataToolTipValueTextMarginTop)Number:double");
            a.item("DataToolTipValueTextColor", "Brush");
            a.item("DataToolTipValueTextFontFamily", "(w:DataToolTipValueTextFontFamily/FontFamilyTransform,xam:DataToolTipValueTextFontFamily,wf:DataToolTipValueTextFontFamily,web:dataToolTipValueTextStyle/FontFamilyTransform)String");
            a.item("DataToolTipValueTextFontSize", "(w:DataToolTipValueTextFontSize,xam:DataToolTipValueTextFontSize,wf:DataToolTipValueTextFontSize,web:dataToolTipValueTextStyle/FontSizeTransform)Number:double");
            a.item("DataToolTipValueTextFontStyle", "(w:DataToolTipValueTextFontStyle/FontStyleTransform,xam:DataToolTipValueTextFontFamily/FontStyleTransform,wf:DataToolTipValueTextFontFamily/FontStyleTransform,web:dataToolTipValueTextStyle/FontStyleTransform)String");
            a.item("DataToolTipValueTextFontWeight", "(w:DataToolTipValueTextFontWeight/FontWeightTransform,xam:DataToolTipValueTextFontFamily/FontWeightTransform,wf:DataToolTipValueTextFontFamily/FontWeightTransform,web:dataToolTipValueTextStyle/FontWeightTransform)String");
            a.item("DataToolTipHeaderFormatString", "String");
            a.item("DataToolTipHeaderFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("DataToolTipHeaderFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("DataToolTipHeaderFormatCulture", "String");
            a.item("DataToolTipHeaderFormatDate", "ExportedType:string:DataLegendHeaderDateMode");
            a.item("DataToolTipHeaderFormatDate@names", "Auto;ShortStyle;LongStyle;MediumStyle;FullStyle;None");
            a.item("DataToolTipHeaderFormatTime", "ExportedType:string:DataLegendHeaderTimeMode");
            a.item("DataToolTipHeaderFormatTime@names", "Auto;ShortStyle;LongStyle;MediumStyle;FullStyle;None");
            a.item("DataToolTipHeaderText", "String");
            a.item("DataToolTipHeaderTextColor", "Brush");
            a.item("DataToolTipHeaderTextMarginBottom", "(w:DataToolTipHeaderTextMargin.Bottom,wf:DataToolTipHeaderTextMarginBottom)Number:double");
            a.item("DataToolTipHeaderTextMarginLeft", "(w:DataToolTipHeaderTextMargin.Left,wf:DataToolTipHeaderTextMarginLeft)Number:double");
            a.item("DataToolTipHeaderTextMarginRight", "(w:DataToolTipHeaderTextMargin.Right,wf:DataToolTipHeaderTextMarginRight)Number:double");
            a.item("DataToolTipHeaderTextMarginTop", "(w:DataToolTipHeaderTextMargin.Top,wf:DataToolTipHeaderTextMarginTop)Number:double");
            a.item("DataToolTipHeaderRowMarginBottom", "(w:DataToolTipHeaderRowMargin.Bottom,wf:DataToolTipHeaderRowMarginBottom)Number:double");
            a.item("DataToolTipHeaderRowMarginLeft", "(w:DataToolTipHeaderRowMargin.Left,wf:DataToolTipHeaderRowMarginLeft)Number:double");
            a.item("DataToolTipHeaderRowMarginRight", "(w:DataToolTipHeaderRowMargin.Right,wf:DataToolTipHeaderRowMarginRight)Number:double");
            a.item("DataToolTipHeaderRowMarginTop", "(w:DataToolTipHeaderRowMargin.Top,wf:DataToolTipHeaderRowMarginTop)Number:double");
            a.item("DataToolTipHeaderRowVisible", "Boolean");
            a.item("DataToolTipHeaderTextFontFamily", "(w:DataToolTipHeaderTextFontFamily/FontFamilyTransform,xam:DataToolTipHeaderTextFontFamily,wf:DataToolTipHeaderTextFontFamily,web:dataToolTipHeaderTextStyle/FontFamilyTransform)String");
            a.item("DataToolTipHeaderTextFontSize", "(w:DataToolTipHeaderTextFontSize,xam:DataToolTipHeaderTextFontSize,wf:DataToolTipHeaderTextFontSize,web:dataToolTipHeaderTextStyle/FontSizeTransform)Number:double");
            a.item("DataToolTipHeaderTextFontStyle", "(w:DataToolTipHeaderTextFontStyle/FontStyleTransform,xam:DataToolTipHeaderTextFontFamily/FontStyleTransform,wf:DataToolTipHeaderTextFontFamily/FontStyleTransform,web:dataToolTipHeaderTextStyle/FontStyleTransform)String");
            a.item("DataToolTipHeaderTextFontWeight", "(w:DataToolTipHeaderTextFontWeight/FontWeightTransform,xam:DataToolTipHeaderTextFontFamily/FontWeightTransform,wf:DataToolTipHeaderTextFontFamily/FontWeightTransform,web:dataToolTipHeaderTextStyle/FontWeightTransform)String");
            a.item("DataToolTipGroupTextColor", "Brush");
            a.item("DataToolTipGroupTextMarginBottom", "(w:DataToolTipGroupTextMargin.Bottom,wf:DataToolTipGroupTextMarginBottom)Number:double");
            a.item("DataToolTipGroupTextMarginLeft", "(w:DataToolTipGroupTextMargin.Left,wf:DataToolTipGroupTextMarginLeft)Number:double");
            a.item("DataToolTipGroupTextMarginRight", "(w:DataToolTipGroupTextMargin.Right,wf:DataToolTipGroupTextMarginRight)Number:double");
            a.item("DataToolTipGroupTextMarginTop", "(w:DataToolTipGroupTextMargin.Top,wf:DataToolTipGroupTextMarginTop)Number:double");
            a.item("DataToolTipGroupRowMarginBottom", "(w:DataToolTipGroupRowMargin.Bottom,wf:DataToolTipGroupRowMarginBottom)Number:double");
            a.item("DataToolTipGroupRowMarginLeft", "(w:DataToolTipGroupRowMargin.Left,wf:DataToolTipGroupRowMarginLeft)Number:double");
            a.item("DataToolTipGroupRowMarginRight", "(w:DataToolTipGroupRowMargin.Right,wf:DataToolTipGroupRowMarginRight)Number:double");
            a.item("DataToolTipGroupRowMarginTop", "(w:DataToolTipGroupRowMargin.Top,wf:DataToolTipGroupRowMarginTop)Number:double");
            a.item("DataToolTipGroupRowVisible", "Boolean");
            a.item("DataToolTipGroupTextFontFamily", "(w:DataToolTipGroupTextFontFamily/FontFamilyTransform,xam:DataToolTipGroupTextFontFamily,wf:DataToolTipGroupTextFontFamily,web:dataToolTipGroupTextStyle/FontFamilyTransform)String");
            a.item("DataToolTipGroupTextFontSize", "(w:DataToolTipGroupTextFontSize,xam:DataToolTipGroupTextFontSize,wf:DataToolTipGroupTextFontSize,web:dataToolTipGroupTextStyle/FontSizeTransform)Number:double");
            a.item("DataToolTipGroupTextFontStyle", "(w:DataToolTipGroupTextFontStyle/FontStyleTransform,xam:DataToolTipGroupTextFontFamily/FontStyleTransform,wf:DataToolTipGroupTextFontFamily/FontStyleTransform,web:dataToolTipGroupTextStyle/FontStyleTransform)String");
            a.item("DataToolTipGroupTextFontWeight", "(w:DataToolTipGroupTextFontWeight/FontWeightTransform,xam:DataToolTipGroupTextFontFamily/FontWeightTransform,wf:DataToolTipGroupTextFontFamily/FontWeightTransform,web:dataToolTipGroupTextStyle/FontWeightTransform)String");
            a.item("DataToolTipSummaryTitleTextColor", "Brush");
            a.item("DataToolTipSummaryTitleTextFontFamily", "(w:DataToolTipSummaryTitleTextFontFamily/FontFamilyTransform,xam:DataToolTipSummaryTitleTextFontFamily,wf:DataToolTipSummaryTitleTextFontFamily,web:dataToolTipSummaryTitleTextStyle/FontFamilyTransform)String");
            a.item("DataToolTipSummaryTitleTextFontSize", "(w:DataToolTipSummaryTitleTextFontSize,xam:DataToolTipSummaryTitleTextFontSize,wf:DataToolTipSummaryTitleTextFontSize,web:dataToolTipSummaryTitleTextStyle/FontSizeTransform)Number:double");
            a.item("DataToolTipSummaryTitleTextFontStyle", "(w:DataToolTipSummaryTitleTextFontStyle/FontStyleTransform,xam:DataToolTipSummaryTitleTextFontFamily/FontStyleTransform,wf:DataToolTipSummaryTitleTextFontFamily/FontStyleTransform,web:dataToolTipSummaryTitleTextStyle/FontStyleTransform)String");
            a.item("DataToolTipSummaryTitleTextFontWeight", "(w:DataToolTipSummaryTitleTextFontWeight/FontWeightTransform,xam:DataToolTipSummaryTitleTextFontFamily/FontWeightTransform,wf:DataToolTipSummaryTitleTextFontFamily/FontWeightTransform,web:dataToolTipSummaryTitleTextStyle/FontWeightTransform)String");
            a.item("DataToolTipSummaryType", "ExportedType:string:DataLegendSummaryType");
            a.item("DataToolTipSummaryType@names", "Auto;Total;Average;Min;Max;None");
            a.item("DataToolTipSummaryTitleText", "String");
            a.item("DataToolTipSummaryTitleTextMarginBottom", "(w:DataToolTipSummaryTitleTextMargin.Bottom,wf:DataToolTipSummaryTitleTextMarginBottom)Number:double");
            a.item("DataToolTipSummaryTitleTextMarginLeft", "(w:DataToolTipSummaryTitleTextMargin.Left,wf:DataToolTipSummaryTitleTextMarginLeft)Number:double");
            a.item("DataToolTipSummaryTitleTextMarginRight", "(w:DataToolTipSummaryTitleTextMargin.Right,wf:DataToolTipSummaryTitleTextMarginRight)Number:double");
            a.item("DataToolTipSummaryTitleTextMarginTop", "(w:DataToolTipSummaryTitleTextMargin.Top,wf:DataToolTipSummaryTitleTextMarginTop)Number:double");
            a.item("DataToolTipSummaryRowMarginBottom", "(w:DataToolTipSummaryRowMargin.Bottom,wf:DataToolTipSummaryRowMarginBottom)Number:double");
            a.item("DataToolTipSummaryRowMarginLeft", "(w:DataToolTipSummaryRowMargin.Left,wf:DataToolTipSummaryRowMarginLeft)Number:double");
            a.item("DataToolTipSummaryRowMarginRight", "(w:DataToolTipSummaryRowMargin.Right,wf:DataToolTipSummaryRowMarginRight)Number:double");
            a.item("DataToolTipSummaryRowMarginTop", "(w:DataToolTipSummaryRowMargin.Top,wf:DataToolTipSummaryRowMarginTop)Number:double");
            a.item("DataToolTipSummaryValueTextColor", "Brush");
            a.item("DataToolTipSummaryValueTextFontFamily", "(w:DataToolTipSummaryValueTextFontFamily/FontFamilyTransform,xam:DataToolTipSummaryValueTextFontFamily,wf:DataToolTipSummaryValueTextFontFamily,web:dataToolTipSummaryValueTextStyle/FontFamilyTransform)String");
            a.item("DataToolTipSummaryValueTextFontSize", "(w:DataToolTipSummaryValueTextFontSize,xam:DataToolTipSummaryValueTextFontSize,wf:DataToolTipSummaryValueTextFontSize,web:dataToolTipSummaryValueTextStyle/FontSizeTransform)Number:double");
            a.item("DataToolTipSummaryValueTextFontStyle", "(w:DataToolTipSummaryValueTextFontStyle/FontStyleTransform,xam:DataToolTipSummaryValueTextFontFamily/FontStyleTransform,wf:DataToolTipSummaryValueTextFontFamily/FontStyleTransform,web:dataToolTipSummaryValueTextStyle/FontStyleTransform)String");
            a.item("DataToolTipSummaryValueTextFontWeight", "(w:DataToolTipSummaryValueTextFontWeight/FontWeightTransform,xam:DataToolTipSummaryValueTextFontFamily/FontWeightTransform,wf:DataToolTipSummaryValueTextFontFamily/FontWeightTransform,web:dataToolTipSummaryValueTextStyle/FontWeightTransform)String");
            a.item("DataToolTipSummaryLabelText", "String");
            a.item("DataToolTipSummaryLabelTextColor", "Brush");
            a.item("DataToolTipSummaryLabelTextFontFamily", "(w:DataToolTipSummaryLabelTextFontFamily/FontFamilyTransform,xam:DataToolTipSummaryLabelTextFontFamily,wf:DataToolTipSummaryLabelTextFontFamily,web:dataToolTipSummaryLabelTextStyle/FontFamilyTransform)String");
            a.item("DataToolTipSummaryLabelTextFontSize", "(w:DataToolTipSummaryLabelTextFontSize,xam:DataToolTipSummaryLabelTextFontSize,wf:DataToolTipSummaryLabelTextFontSize,web:dataToolTipSummaryLabelTextStyle/FontSizeTransform)Number:double");
            a.item("DataToolTipSummaryLabelTextFontStyle", "(w:DataToolTipSummaryLabelTextFontStyle/FontStyleTransform,xam:DataToolTipSummaryLabelTextFontFamily/FontStyleTransform,wf:DataToolTipSummaryLabelTextFontFamily/FontStyleTransform,web:dataToolTipSummaryLabelTextStyle/FontStyleTransform)String");
            a.item("DataToolTipSummaryLabelTextFontWeight", "(w:DataToolTipSummaryLabelTextFontWeight/FontWeightTransform,xam:DataToolTipSummaryLabelTextFontFamily/FontWeightTransform,wf:DataToolTipSummaryLabelTextFontFamily/FontWeightTransform,web:dataToolTipSummaryLabelTextStyle/FontWeightTransform)String");
            a.item("DataToolTipSummaryUnitsText", "String");
            a.item("DataToolTipSummaryUnitsTextColor", "Brush");
            a.item("DataToolTipSummaryUnitsTextFontFamily", "(w:DataToolTipSummaryUnitsTextFontFamily/FontFamilyTransform,xam:DataToolTipSummaryUnitsTextFontFamily,wf:DataToolTipSummaryUnitsTextFontFamily,web:dataToolTipSummaryUnitsTextStyle/FontFamilyTransform)String");
            a.item("DataToolTipSummaryUnitsTextFontSize", "(w:DataToolTipSummaryUnitsTextFontSize,xam:DataToolTipSummaryUnitsTextFontSize,wf:DataToolTipSummaryUnitsTextFontSize,web:dataToolTipSummaryUnitsTextStyle/FontSizeTransform)Number:double");
            a.item("DataToolTipSummaryUnitsTextFontStyle", "(w:DataToolTipSummaryUnitsTextFontStyle/FontStyleTransform,xam:DataToolTipSummaryUnitsTextFontFamily/FontStyleTransform,wf:DataToolTipSummaryUnitsTextFontFamily/FontStyleTransform,web:dataToolTipSummaryUnitsTextStyle/FontStyleTransform)String");
            a.item("DataToolTipSummaryUnitsTextFontWeight", "(w:DataToolTipSummaryUnitsTextFontWeight/FontWeightTransform,xam:DataToolTipSummaryUnitsTextFontFamily/FontWeightTransform,wf:DataToolTipSummaryUnitsTextFontFamily/FontWeightTransform,web:dataToolTipSummaryUnitsTextStyle/FontWeightTransform)String");
            a.item("DataToolTipBadgeMarginBottom", "(w:DataToolTipBadgeMargin.Bottom,wf:DataToolTipBadgeMarginBottom)Number:double");
            a.item("DataToolTipBadgeMarginLeft", "(w:DataToolTipBadgeMargin.Left,wf:DataToolTipBadgeMarginLeft)Number:double");
            a.item("DataToolTipBadgeMarginRight", "(w:DataToolTipBadgeMargin.Right,wf:DataToolTipBadgeMarginRight)Number:double");
            a.item("DataToolTipBadgeMarginTop", "(w:DataToolTipBadgeMargin.Top,wf:DataToolTipBadgeMarginTop)Number:double");
            a.item("DataToolTipBadgeShape", "ExportedType:string:LegendItemBadgeShape");
            a.item("DataToolTipBadgeShape@names", "Automatic;Circle;Line;Square;Marker;Bar;Column;Hidden");
            a.item("DataToolTipUnitsDisplayMode", "ExportedType:string:DataLegendUnitsMode");
            a.item("DataToolTipUnitsDisplayMode@names", "Auto;Visible;Hidden");
            a.item("DataToolTipUnitsText", "String");
            a.item("DataToolTipUnitsTextColor", "Brush");
            a.item("DataToolTipUnitsTextMarginBottom", "(w:DataToolTipUnitsTextMargin.Bottom,wf:DataToolTipUnitsTextMarginBottom)Number:double");
            a.item("DataToolTipUnitsTextMarginLeft", "(w:DataToolTipUnitsTextMargin.Left,wf:DataToolTipUnitsTextMarginLeft)Number:double");
            a.item("DataToolTipUnitsTextMarginRight", "(w:DataToolTipUnitsTextMargin.Right,wf:DataToolTipUnitsTextMarginRight)Number:double");
            a.item("DataToolTipUnitsTextMarginTop", "(w:DataToolTipUnitsTextMargin.Top,wf:DataToolTipUnitsTextMarginTop)Number:double");
            a.item("DataToolTipUnitsTextFontFamily", "(w:DataToolTipUnitsTextFontFamily/FontFamilyTransform,xam:DataToolTipUnitsTextFontFamily,wf:DataToolTipUnitsTextFontFamily,web:dataToolTipUnitsTextStyle/FontFamilyTransform)String");
            a.item("DataToolTipUnitsTextFontSize", "(w:DataToolTipUnitsTextFontSize,xam:DataToolTipUnitsTextFontSize,wf:DataToolTipUnitsTextFontSize,web:dataToolTipUnitsTextStyle/FontSizeTransform)Number:double");
            a.item("DataToolTipUnitsTextFontStyle", "(w:DataToolTipUnitsTextFontStyle/FontStyleTransform,xam:DataToolTipUnitsTextFontFamily/FontStyleTransform,wf:DataToolTipUnitsTextFontFamily/FontStyleTransform,web:dataToolTipUnitsTextStyle/FontStyleTransform)String");
            a.item("DataToolTipUnitsTextFontWeight", "(w:DataToolTipUnitsTextFontWeight/FontWeightTransform,xam:DataToolTipUnitsTextFontFamily/FontWeightTransform,wf:DataToolTipUnitsTextFontFamily/FontWeightTransform,web:dataToolTipUnitsTextStyle/FontWeightTransform)String");
            a.item("DataToolTipTitleTextMarginBottom", "(w:DataToolTipTitleTextMargin.Bottom,wf:DataToolTipTitleTextMarginBottom)Number:double");
            a.item("DataToolTipTitleTextMarginLeft", "(w:DataToolTipTitleTextMargin.Left,wf:DataToolTipTitleTextMarginLeft)Number:double");
            a.item("DataToolTipTitleTextMarginRight", "(w:DataToolTipTitleTextMargin.Right,wf:DataToolTipTitleTextMarginRight)Number:double");
            a.item("DataToolTipTitleTextMarginTop", "(w:DataToolTipTitleTextMargin.Top,wf:DataToolTipTitleTextMarginTop)Number:double");
            a.item("DataToolTipTitleTextColor", "Brush");
            a.item("DataToolTipTitleTextFontFamily", "(w:DataToolTipTitleTextFontFamily/FontFamilyTransform,xam:DataToolTipTitleTextFontFamily,wf:DataToolTipTitleTextFontFamily,web:dataToolTipTitleTextStyle/FontFamilyTransform)String");
            a.item("DataToolTipTitleTextFontSize", "(w:DataToolTipTitleTextFontSize,xam:DataToolTipTitleTextFontSize,wf:DataToolTipTitleTextFontSize,web:dataToolTipTitleTextStyle/FontSizeTransform)Number:double");
            a.item("DataToolTipTitleTextFontStyle", "(w:DataToolTipTitleTextFontStyle/FontStyleTransform,xam:DataToolTipTitleTextFontFamily/FontStyleTransform,wf:DataToolTipTitleTextFontFamily/FontStyleTransform,web:dataToolTipTitleTextStyle/FontStyleTransform)String");
            a.item("DataToolTipTitleTextFontWeight", "(w:DataToolTipTitleTextFontWeight/FontWeightTransform,xam:DataToolTipTitleTextFontFamily/FontWeightTransform,wf:DataToolTipTitleTextFontFamily/FontWeightTransform,web:dataToolTipTitleTextStyle/FontWeightTransform)String");
            a.item("DataToolTipLabelDisplayMode", "ExportedType:string:DataLegendLabelMode");
            a.item("DataToolTipLabelDisplayMode@names", "Auto;Visible;Hidden");
            a.item("DataToolTipLabelTextColor", "Brush");
            a.item("DataToolTipLabelTextMarginBottom", "(w:DataToolTipLabelTextMargin.Bottom,wf:DataToolTipLabelTextMarginBottom)Number:double");
            a.item("DataToolTipLabelTextMarginLeft", "(w:DataToolTipLabelTextMargin.Left,wf:DataToolTipLabelTextMarginLeft)Number:double");
            a.item("DataToolTipLabelTextMarginRight", "(w:DataToolTipLabelTextMargin.Right,wf:DataToolTipLabelTextMarginRight)Number:double");
            a.item("DataToolTipLabelTextMarginTop", "(w:DataToolTipLabelTextMargin.Top,wf:DataToolTipLabelTextMarginTop)Number:double");
            a.item("DataToolTipLabelTextFontFamily", "(w:DataToolTipLabelTextFontFamily/FontFamilyTransform,xam:DataToolTipLabelTextFontFamily,wf:DataToolTipLabelTextFontFamily,web:dataToolTipLabelTextStyle/FontFamilyTransform)String");
            a.item("DataToolTipLabelTextFontSize", "(w:DataToolTipLabelTextFontSize,xam:DataToolTipLabelTextFontSize,wf:DataToolTipLabelTextFontSize,web:dataToolTipLabelTextStyle/FontSizeTransform)Number:double");
            a.item("DataToolTipLabelTextFontStyle", "(w:DataToolTipLabelTextFontStyle/FontStyleTransform,xam:DataToolTipLabelTextFontFamily/FontStyleTransform,wf:DataToolTipLabelTextFontFamily/FontStyleTransform,web:dataToolTipLabelTextStyle/FontStyleTransform)String");
            a.item("DataToolTipLabelTextFontWeight", "(w:DataToolTipLabelTextFontWeight/FontWeightTransform,xam:DataToolTipLabelTextFontFamily/FontWeightTransform,wf:DataToolTipLabelTextFontFamily/FontWeightTransform,web:dataToolTipLabelTextStyle/FontWeightTransform)String");
            a.item("SortDescriptions", "Collection:ChartSortDescription:ChartSortDescriptionCollection:ChartSortDescription");
            a.item("GroupSortDescriptions", "Collection:ChartSortDescription:ChartSortDescriptionCollection:ChartSortDescription");
            a.item("GroupDescriptions", "Collection:ChartSortDescription:ChartSortDescriptionCollection:ChartSortDescription");
            a.item("FilterExpressions", "Collection:FilterExpression:FilterExpressionCollection:FilterExpression");
            a.item("HighlightFilterExpressions", "Collection:FilterExpression:FilterExpressionCollection:FilterExpression");
            a.item("SummaryDescriptions", "Collection:ChartSummaryDescription:ChartSummaryDescriptionCollection:ChartSummaryDescription");
            a.item("SelectionMode", "ExportedType:string:SeriesSelectionMode");
            a.item("SelectionMode@names", "Auto;None;Brighten;FadeOthers;GrayscaleOthers;FocusColorThickOutline;FocusColorOutline;SelectionColorThickOutline;SelectionColorOutline;FocusColorFill;SelectionColorFill;ThickOutline");
            a.item("FocusMode", "ExportedType:string:SeriesSelectionMode");
            a.item("FocusMode@names", "Auto;None;Brighten;FadeOthers;GrayscaleOthers;FocusColorThickOutline;FocusColorOutline;SelectionColorThickOutline;SelectionColorOutline;FocusColorFill;SelectionColorFill;ThickOutline");
            a.item("SelectionBrush", "Brush");
            a.item("FocusBrush", "Brush");
            a.item("SelectionBehavior", "ExportedType:string:SeriesSelectionBehavior");
            a.item("SelectionBehavior@names", "Auto;PerDataItemMultiSelect;PerDataItemSingleSelect;PerSeriesAndDataItemMultiSelect;PerSeriesAndDataItemSingleSelect;PerSeriesAndDataItemGlobalSingleSelect;PerSeriesMultiSelect;PerSeriesSingleSelect");
            a.item("SelectedSeriesItems", "Collection:ChartSelection:ChartSelectedItemCollection:ChartSelection");
            a.item("FocusedSeriesItems", "Collection:ChartSelection:ChartSelectedItemCollection:ChartSelection");
            a.item("InitialSortDescriptions", "Collection:ChartSortDescription:ChartSortDescriptionCollection:ChartSortDescription");
            a.item("InitialGroupSortDescriptions", "Collection:ChartSortDescription:ChartSortDescriptionCollection:ChartSortDescription");
            a.item("InitialGroupDescriptions", "Collection:ChartSortDescription:ChartSortDescriptionCollection:ChartSortDescription");
            a.item("InitialFilterExpressions", "Collection:FilterExpression:FilterExpressionCollection:FilterExpression");
            a.item("InitialHighlightFilterExpressions", "Collection:FilterExpression:FilterExpressionCollection:FilterExpression");
            a.item("InitialSummaryDescriptions", "Collection:ChartSummaryDescription:ChartSummaryDescriptionCollection:ChartSummaryDescription");
            a.item("InitialSorts", "String");
            a.item("GroupSorts", "String");
            a.item("InitialGroups", "String");
            a.item("InitialFilter", "String");
            a.item("InitialHighlightFilter", "String");
            a.item("InitialSummaries", "String");
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:DataSource)DataRef::object");
            a.item("DataSource", "(w:ItemsSource,xam:ItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            a.item("HighlightedDataSourceRef", "(w:HighlightedItemsSource,xam:HighlightedItemsSource,wf:HighlightedDataSource)DataRef::object");
            a.item("HighlightedDataSource", "(w:HighlightedItemsSource,xam:HighlightedItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            a.item("IncludedProperties", "Array:string");
            a.item("ExcludedProperties", "Array:string");
            a.item("Brushes", "BrushCollection:string");
            a.item("Outlines", "BrushCollection:string");
            a.item("ActualBrushes", "BrushCollection:string");
            a.item("ActualOutlines", "BrushCollection:string");
            a.item("LegendRef", "(w:Legend,wf:Legend)DataRef::object");
            a.item("IsHorizontalZoomEnabled", "Boolean");
            a.item("IsVerticalZoomEnabled", "Boolean");
            a.item("ShouldDisplayMockData", "Boolean");
            a.item("ShouldUseSkeletonStyleForMockData", "Boolean");
            a.item("HighlightedValuesDisplayMode", "ExportedType:string:SeriesHighlightedValuesDisplayMode");
            a.item("HighlightedValuesDisplayMode@names", "Auto;Hidden;Overlay");
            a.item("IsSeriesHighlightingEnabled", "Boolean");
            a.item("HighlightedLegendItemVisibility", "ExportedType:string:Visibility");
            a.item("HighlightedLegendItemVisibility@names", "Visible;Collapsed");
            a.item("WindowRect", "Rect");
            a.item("ChartTitle", "(w:Title,xam:Title,wf:Title)String");
            a.item("Subtitle", "String");
            a.item("TitleAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("TitleAlignment@names", "Left;Center;Right;Stretch");
            a.item("SubtitleAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("SubtitleAlignment@names", "Left;Center;Right;Stretch");
            a.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            a.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
            a.item("Resolution", "Number:double");
            a.item("Thickness", "Number:double");
            a.item("OutlineMode", "ExportedType:string:SeriesOutlineMode");
            a.item("OutlineMode@names", "Auto;Visible;Collapsed");
            a.item("MarkerOutlineMode", "ExportedType:string:MarkerOutlineMode");
            a.item("MarkerOutlineMode@names", "Auto;Normal;MatchMarkerBrush");
            a.item("MarkerFillMode", "ExportedType:string:MarkerFillMode");
            a.item("MarkerFillMode@names", "Auto;Normal;MatchMarkerOutline");
            a.item("MarkerFillOpacity", "Number:double");
            a.item("MarkerThickness", "Number:double");
            a.item("MarkerTypes", "Collection:string:MarkerTypeCollection:MarkerType");
            a.item("MarkerTypes@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            a.item("MarkerAutomaticBehavior", "ExportedType:string:MarkerAutomaticBehavior");
            a.item("MarkerAutomaticBehavior@names", "CircleSmart;None;SmartIndexed;Indexed;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram");
            a.item("MarkerBrushes", "BrushCollection:string");
            a.item("MarkerOutlines", "BrushCollection:string");
            a.item("MarkerMaxCount", "Number:int");
            a.item("AreaFillOpacity", "Number:double");
            a.item("AnimateSeriesWhenAxisRangeChanges", "Boolean");
            a.item("TrendLineBrushes", "BrushCollection:string");
            a.item("TrendLineType", "ExportedType:string:TrendLineType");
            a.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            a.item("TrendLineThickness", "Number:double");
            a.item("AlignsGridLinesToPixels", "Boolean");
            a.item("PlotAreaMarginLeft", "Number:double");
            a.item("PlotAreaMarginTop", "Number:double");
            a.item("PlotAreaMarginRight", "Number:double");
            a.item("PlotAreaMarginBottom", "Number:double");
            a.item("ComputedPlotAreaMarginMode", "ExportedType:string:ComputedPlotAreaMarginMode");
            a.item("ComputedPlotAreaMarginMode@names", "Auto;Series;None");
            a.item("SeriesPlotAreaMarginHorizontalMode", "ExportedType:string:SeriesPlotAreaMarginHorizontalMode");
            a.item("SeriesPlotAreaMarginHorizontalMode@names", "Auto;LeftMarginRightMargin;LeftBufferRightBuffer;LeftMarginRightBuffer;LeftBufferRightMargin;None");
            a.item("SeriesPlotAreaMarginVerticalMode", "ExportedType:string:SeriesPlotAreaMarginVerticalMode");
            a.item("SeriesPlotAreaMarginVerticalMode@names", "Auto;BottomMarginTopMargin;BottomBufferTopBuffer;BottomMarginTopBuffer;BottomBufferTopMargin;None");
            a.item("HighlightingMode", "ExportedType:string:SeriesHighlightingMode");
            a.item("HighlightingMode@names", "Auto;None;BrightenSpecific;Brighten;FadeOthersSpecific;FadeOthers");
            a.item("HighlightingBehavior", "ExportedType:string:SeriesHighlightingBehavior");
            a.item("HighlightingBehavior@names", "Auto;DirectlyOver;NearestItems;NearestItemsRetainMainShapes;NearestItemsAndSeries");
            a.item("LegendHighlightingMode", "ExportedType:string:LegendHighlightingMode");
            a.item("LegendHighlightingMode@names", "Auto;None;MatchSeries");
            a.item("LegendItemBadgeShape", "ExportedType:string:LegendItemBadgeShape");
            a.item("LegendItemBadgeShape@names", "Automatic;Circle;Line;Square;Marker;Bar;Column;Hidden");
            a.item("LegendItemBadgeMode", "ExportedType:string:LegendItemBadgeMode");
            a.item("LegendItemBadgeMode@names", "Simplified;MatchSeries");
            a.item("TrendLinePeriod", "Number:int");
            a.item("ToolTipType", "ExportedType:string:ToolTipType");
            a.item("ToolTipType@names", "Default;Item;Category;None;Data");
            a.item("CrosshairsDisplayMode", "ExportedType:string:CrosshairsDisplayMode");
            a.item("CrosshairsDisplayMode@names", "Auto;None;Horizontal;Vertical;Both");
            a.item("CrosshairsSnapToData", "Boolean");
            a.item("CrosshairsLineVerticalStroke", "Brush");
            a.item("CrosshairsLineThickness", "Number:double");
            a.item("CrosshairsLineHorizontalStroke", "Brush");
            a.item("CrosshairsAnnotationEnabled", "Boolean");
            a.item("CrosshairsAnnotationXAxisBackground", "Brush");
            a.item("CrosshairsAnnotationYAxisBackground", "Brush");
            a.item("CrosshairsAnnotationXAxisTextColor", "Brush");
            a.item("CrosshairsAnnotationYAxisTextColor", "Brush");
            a.item("CrosshairsAnnotationXAxisPrecision", "Number:int");
            a.item("CrosshairsAnnotationYAxisPrecision", "Number:int");
            a.item("ShouldAvoidAxisAnnotationCollisions", "Boolean");
            a.item("ShouldPanOnMaximumZoom", "Boolean");
            a.item("FinalValueAnnotationsVisible", "Boolean");
            a.item("FinalValueAnnotationsBackground", "Brush");
            a.item("FinalValueAnnotationsTextColor", "Brush");
            a.item("FinalValueAnnotationsPrecision", "Number:int");
            a.item("AutoCalloutsVisible", "Boolean");
            a.item("CalloutsVisible", "Boolean");
            a.item("CalloutStyleUpdatingEventEnabled", "Boolean");
            a.item("UseValueForAutoCalloutLabels", "Boolean");
            a.item("CalloutCollisionMode", "ExportedType:string:CalloutCollisionMode");
            a.item("CalloutCollisionMode@names", "Auto;SimulatedAnnealing;Greedy;GreedyCenterOfMass;RadialBestFit;RadialInsideEnd;RadialOutsideEnd;RadialCenter");
            a.item("CalloutsUseItemColorForFill", "Boolean");
            a.item("CalloutsUseItemColorForOutline", "Boolean");
            a.item("CalloutsUseAutoContrastingLabelColors", "Boolean");
            a.item("CalloutsStrokeThickness", "Number:double");
            a.item("CalloutsBackground", "Brush");
            a.item("CalloutsAutoLabelPrecision", "Number:int");
            a.item("CalloutsDataSourceRef", "(w:CalloutsItemsSource,xam:CalloutsItemsSource,wf:CalloutsDataSource)DataRef::object");
            a.item("CalloutsAllowedPositions", "Collection:string:CalloutPlacementPositionsCollection:CalloutPlacementPositions");
            a.item("CalloutsAllowedPositions@names", "Top;Left;Right;Bottom;TopLeft;TopRight;BottomLeft;BottomRight");
            a.item("CalloutsXMemberPath", "String");
            a.item("CalloutsYMemberPath", "String");
            a.item("CalloutsLabelMemberPath", "String");
            a.item("CalloutsContentMemberPath", "String");
            a.item("ValueLines", "Collection:string:ValueModeCollection:ValueLayerValueMode");
            a.item("ValueLines@names", "Auto;Minimum;Maximum;Average;GlobalMinimum;GlobalMaximum;GlobalAverage");
            a.item("ValueLinesBrushes", "BrushCollection:string");
            a.item("ValueLinesThickness", "Number:double");
            a.item("HorizontalViewScrollbarMode", "ExportedType:string:SeriesViewerScrollbarMode");
            a.item("HorizontalViewScrollbarMode@names", "None;Fading;FadeToLine;Persistent");
            a.item("VerticalViewScrollbarMode", "ExportedType:string:SeriesViewerScrollbarMode");
            a.item("VerticalViewScrollbarMode@names", "None;Fading;FadeToLine;Persistent");
            a.item("HorizontalViewScrollbarPosition", "ExportedType:string:SeriesViewerHorizontalScrollbarPosition");
            a.item("HorizontalViewScrollbarPosition@names", "Auto;InsideBottom;InsideTop");
            a.item("VerticalViewScrollbarPosition", "ExportedType:string:SeriesViewerVerticalScrollbarPosition");
            a.item("VerticalViewScrollbarPosition@names", "Auto;InsideLeft;InsideRight");
            a.item("HorizontalViewScrollbarFill", "Brush");
            a.item("HorizontalViewScrollbarOutline", "Brush");
            a.item("HorizontalViewScrollbarStrokeThickness", "Number:double");
            a.item("HorizontalViewScrollbarMaxOpacity", "Number:double");
            a.item("HorizontalViewScrollbarCornerRadius", "Number:double");
            a.item("HorizontalViewScrollbarHeight", "Number:double");
            a.item("HorizontalViewScrollbarInset", "Number:double");
            a.item("HorizontalViewScrollbarTrackStartInset", "Number:double");
            a.item("HorizontalViewScrollbarTrackEndInset", "Number:double");
            a.item("HorizontalViewScrollbarShouldAddAutoTrackInsets", "Boolean");
            a.item("VerticalViewScrollbarFill", "Brush");
            a.item("VerticalViewScrollbarOutline", "Brush");
            a.item("VerticalViewScrollbarStrokeThickness", "Number:double");
            a.item("VerticalViewScrollbarMaxOpacity", "Number:double");
            a.item("VerticalViewScrollbarCornerRadius", "Number:double");
            a.item("VerticalViewScrollbarWidth", "Number:double");
            a.item("VerticalViewScrollbarInset", "Number:double");
            a.item("VerticalViewScrollbarTrackStartInset", "Number:double");
            a.item("VerticalViewScrollbarTrackEndInset", "Number:double");
            a.item("VerticalViewScrollbarShouldAddAutoTrackInsets", "Boolean");
            a.item("WindowRectMinWidth", "Number:double");
            a.item("WindowRectMinHeight", "Number:double");
            a.item("WindowSizeMinWidth", "Number:double");
            a.item("WindowSizeMinHeight", "Number:double");
            a.item("SeriesAddedRef", "EventRef::seriesAdded");
            a.item("SeriesRemovedRef", "EventRef::seriesRemoved");
            a.item("SeriesPointerEnterRef", "EventRef::seriesPointerEnter");
            a.item("SeriesPointerLeaveRef", "EventRef::seriesPointerLeave");
            a.item("SeriesPointerMoveRef", "EventRef::seriesPointerMove");
            a.item("SeriesPointerDownRef", "EventRef::seriesPointerDown");
            a.item("SeriesPointerUpRef", "EventRef::seriesPointerUp");
            a.item("CalloutStyleUpdatingRef", "EventRef::calloutStyleUpdating");
            a.item("CalloutRenderStyleUpdatingRef", "EventRef::calloutRenderStyleUpdating");
            a.item("SelectedSeriesItemsChangedRef", "EventRef::selectedSeriesItemsChanged");
            a.item("FocusedSeriesItemsChangedRef", "EventRef::focusedSeriesItemsChanged");
            a.item("FilterStringErrorsParsingRef", "EventRef::filterStringErrorsParsing");
        }
        static d(a) {
            DomainChartDescriptionMetadata.b(a);
            a.ad("DomainChart", DomainChartDescriptionMetadata.a);
        }
    }
    DomainChartDescriptionMetadata.$t = /*@__PURE__*/ markType(DomainChartDescriptionMetadata, 'DomainChartDescriptionMetadata');
    DomainChartDescriptionMetadata.a = null;
    return DomainChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XYChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class XYChartDescriptionMetadata extends Base {
        static b(a) {
            if (XYChartDescriptionMetadata.a == null) {
                XYChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                XYChartDescriptionMetadata.c(XYChartDescriptionMetadata.a);
            }
            if (a.k(XYChartDescriptionMetadata.a)) {
                return;
            }
            a.ac(XYChartDescriptionMetadata.a);
        }
        static c(a) {
            DomainChartDescriptionMetadata.c(a);
            a.item("XAxisFormatLabelRef", "(w:XAxisFormatLabel,wf:XAxisFormatLabel)MethodRef");
            a.item("YAxisFormatLabelRef", "(w:YAxisFormatLabel,wf:YAxisFormatLabel)MethodRef");
            a.item("XAxisLabelLeftMargin", "Number:double");
            a.item("XAxisLabelTopMargin", "Number:double");
            a.item("XAxisLabelRightMargin", "Number:double");
            a.item("XAxisLabelBottomMargin", "Number:double");
            a.item("YAxisLabelLeftMargin", "Number:double");
            a.item("YAxisLabelTopMargin", "Number:double");
            a.item("YAxisLabelRightMargin", "Number:double");
            a.item("YAxisLabelBottomMargin", "Number:double");
            a.item("XAxisLabelTextColor", "Brush");
            a.item("YAxisLabelTextColor", "Brush");
            a.item("ActualXAxisLabelTextColor", "Brush");
            a.item("ActualYAxisLabelTextColor", "Brush");
            a.item("XAxisTitleMargin", "Number:double");
            a.item("YAxisTitleMargin", "Number:double");
            a.item("XAxisTitleLeftMargin", "Number:double");
            a.item("YAxisTitleLeftMargin", "Number:double");
            a.item("XAxisTitleTopMargin", "Number:double");
            a.item("YAxisTitleTopMargin", "Number:double");
            a.item("XAxisTitleRightMargin", "Number:double");
            a.item("YAxisTitleRightMargin", "Number:double");
            a.item("XAxisTitleBottomMargin", "Number:double");
            a.item("YAxisTitleBottomMargin", "Number:double");
            a.item("XAxisTitleTextColor", "Brush");
            a.item("YAxisTitleTextColor", "Brush");
            a.item("XAxisLabelTextStyle", "String");
            a.item("YAxisLabelTextStyle", "String");
            a.item("XAxisTitleTextStyle", "String");
            a.item("YAxisTitleTextStyle", "String");
            a.item("XAxisLabelRef", "(w:XAxisLabel,wf:XAxisLabel)DataRef");
            a.item("YAxisLabelRef", "(w:YAxisLabel,wf:YAxisLabel)DataRef");
            a.item("XAxisMajorStroke", "Brush");
            a.item("YAxisMajorStroke", "Brush");
            a.item("XAxisMajorStrokeThickness", "Number:double");
            a.item("YAxisMajorStrokeThickness", "Number:double");
            a.item("XAxisMinorStrokeThickness", "Number:double");
            a.item("YAxisMinorStrokeThickness", "Number:double");
            a.item("XAxisStrip", "Brush");
            a.item("YAxisStrip", "Brush");
            a.item("XAxisStroke", "Brush");
            a.item("YAxisStroke", "Brush");
            a.item("XAxisStrokeThickness", "Number:double");
            a.item("YAxisStrokeThickness", "Number:double");
            a.item("XAxisTickLength", "Number:double");
            a.item("YAxisTickLength", "Number:double");
            a.item("XAxisTickStroke", "Brush");
            a.item("YAxisTickStroke", "Brush");
            a.item("XAxisTickStrokeThickness", "Number:double");
            a.item("YAxisTickStrokeThickness", "Number:double");
            a.item("XAxisTitle", "String");
            a.item("YAxisTitle", "String");
            a.item("XAxisMinorStroke", "Brush");
            a.item("YAxisMinorStroke", "Brush");
            a.item("XAxisLabelAngle", "Number:double");
            a.item("YAxisLabelAngle", "Number:double");
            a.item("XAxisExtent", "Number:double");
            a.item("YAxisExtent", "Number:double");
            a.item("XAxisTitleAngle", "Number:double");
            a.item("YAxisTitleAngle", "Number:double");
            a.item("XAxisInverted", "Boolean");
            a.item("YAxisInverted", "Boolean");
            a.item("XAxisTitleAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("XAxisTitleAlignment@names", "Left;Center;Right;Stretch");
            a.item("YAxisTitleAlignment", "ExportedType:string:VerticalAlignment");
            a.item("YAxisTitleAlignment@names", "Top;Center;Bottom;Stretch");
            a.item("XAxisLabelHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("XAxisLabelHorizontalAlignment@names", "Left;Center;Right;Stretch");
            a.item("YAxisLabelHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("YAxisLabelHorizontalAlignment@names", "Left;Center;Right;Stretch");
            a.item("XAxisLabelVerticalAlignment", "ExportedType:string:VerticalAlignment");
            a.item("XAxisLabelVerticalAlignment@names", "Top;Center;Bottom;Stretch");
            a.item("YAxisLabelVerticalAlignment", "ExportedType:string:VerticalAlignment");
            a.item("YAxisLabelVerticalAlignment@names", "Top;Center;Bottom;Stretch");
            a.item("XAxisLabelVisibility", "ExportedType:string:Visibility");
            a.item("XAxisLabelVisibility@names", "Visible;Collapsed");
            a.item("YAxisLabelVisibility", "ExportedType:string:Visibility");
            a.item("YAxisLabelVisibility@names", "Visible;Collapsed");
            a.item("YAxisLabelLocation", "ExportedType:string:YAxisLabelLocation");
            a.item("YAxisLabelLocation@names", "OutsideLeft;OutsideRight;InsideLeft;InsideRight;Auto");
            a.item("XAxisLabelLocation", "ExportedType:string:XAxisLabelLocation");
            a.item("XAxisLabelLocation@names", "OutsideTop;OutsideBottom;InsideTop;InsideBottom;Auto");
            a.item("XAxisLabelFormat", "String");
            a.item("XAxisLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("XAxisLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("YAxisLabelFormat", "String");
            a.item("YAxisLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("YAxisLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
        }
        static d(a) {
            XYChartDescriptionMetadata.b(a);
            a.ad("XYChart", XYChartDescriptionMetadata.a);
        }
    }
    XYChartDescriptionMetadata.$t = /*@__PURE__*/ markType(XYChartDescriptionMetadata, 'XYChartDescriptionMetadata');
    XYChartDescriptionMetadata.a = null;
    return XYChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DomainChartDescription = /*@__PURE__*/ (() => {
    class DomainChartDescription extends Description {
        get_type() {
            return "DomainChart";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.fe = 0;
            this.fr = 0;
            this.fs = 0;
            this.ft = 0;
            this.fq = 0;
            this.fm = 0;
            this.fo = 0;
            this.fn = 0;
            this.fl = 0;
            this.nc = null;
            this.nf = null;
            this.fb = 0;
            this.fu = 0;
            this.fk = 0;
            this.da = 0;
            this.ji = 0;
            this.ni = null;
            this.jf = 0;
            this.jh = 0;
            this.je = 0;
            this.nd = null;
            this.ng = null;
            this.ki = null;
            this.d7 = 0;
            this.d8 = 0;
            this.dh = 0;
            this.di = 0;
            this.kg = null;
            this.kh = null;
            this.b3 = false;
            this.p = null;
            this.m = null;
            this.o = null;
            this.l = null;
            this.lv = null;
            this.jb = 0;
            this.jc = 0;
            this.lx = null;
            this.lw = null;
            this.b4 = false;
            this.ly = null;
            this.q = null;
            this.ev = 0;
            this.ew = 0;
            this.ex = 0;
            this.ey = 0;
            this.b5 = false;
            this.l3 = null;
            this.b6 = false;
            this.e0 = 0;
            this.e1 = 0;
            this.e2 = 0;
            this.e3 = 0;
            this.lz = null;
            this.l0 = null;
            this.ez = 0;
            this.l1 = null;
            this.l2 = null;
            this.kp = null;
            this.n = null;
            this.kn = null;
            this.ko = null;
            this.kq = null;
            this.kr = null;
            this.ks = null;
            this.dy = 0;
            this.dz = 0;
            this.d0 = 0;
            this.d1 = 0;
            this.dt = 0;
            this.du = 0;
            this.dv = 0;
            this.dw = 0;
            this.b2 = false;
            this.kt = null;
            this.dx = 0;
            this.ku = null;
            this.kv = null;
            this.kj = null;
            this.dp = 0;
            this.dq = 0;
            this.dr = 0;
            this.ds = 0;
            this.dj = 0;
            this.dk = 0;
            this.dl = 0;
            this.dm = 0;
            this.b1 = false;
            this.kk = null;
            this.dn = 0;
            this.kl = null;
            this.km = null;
            this.k7 = null;
            this.k8 = null;
            this.ee = 0;
            this.k9 = null;
            this.la = null;
            this.lb = null;
            this.k6 = null;
            this.ef = 0;
            this.eg = 0;
            this.eh = 0;
            this.ei = 0;
            this.ea = 0;
            this.eb = 0;
            this.ec = 0;
            this.ed = 0;
            this.lh = null;
            this.li = null;
            this.ek = 0;
            this.lj = null;
            this.lk = null;
            this.k1 = null;
            this.k2 = null;
            this.k3 = null;
            this.d9 = 0;
            this.k4 = null;
            this.k5 = null;
            this.lc = null;
            this.ld = null;
            this.le = null;
            this.ej = 0;
            this.lf = null;
            this.lg = null;
            this.dd = 0;
            this.de = 0;
            this.df = 0;
            this.dg = 0;
            this.kf = null;
            this.lp = null;
            this.lq = null;
            this.lr = null;
            this.er = 0;
            this.es = 0;
            this.et = 0;
            this.eu = 0;
            this.ls = null;
            this.eq = 0;
            this.lt = null;
            this.lu = null;
            this.em = 0;
            this.en = 0;
            this.eo = 0;
            this.ep = 0;
            this.ll = null;
            this.lm = null;
            this.el = 0;
            this.ln = null;
            this.lo = null;
            this.kw = null;
            this.kx = null;
            this.d3 = 0;
            this.d4 = 0;
            this.d5 = 0;
            this.d6 = 0;
            this.ky = null;
            this.d2 = 0;
            this.kz = null;
            this.k0 = null;
            this.aj = null;
            this.v = null;
            this.u = null;
            this.s = null;
            this.w = null;
            this.ak = null;
            this.m0 = null;
            this.l9 = null;
            this.mz = null;
            this.l7 = null;
            this.my = null;
            this.ai = null;
            this.t = null;
            this.ac = null;
            this.aa = null;
            this.z = null;
            this.y = null;
            this.ab = null;
            this.ad = null;
            this.mn = null;
            this.ma = null;
            this.ml = null;
            this.mk = null;
            this.mm = null;
            this.mo = null;
            this.ke = null;
            this.bl = null;
            this.mb = null;
            this.bm = null;
            this.x = null;
            this.r = null;
            this.j = null;
            this.ah = null;
            this.h = null;
            this.i = null;
            this.ms = null;
            this.b9 = false;
            this.cb = false;
            this.cd = false;
            this.cf = false;
            this.md = null;
            this.ca = false;
            this.mc = null;
            this.bp = null;
            this.j5 = null;
            this.na = null;
            this.ne = null;
            this.nb = null;
            this.nk = null;
            this.fj = 0;
            this.fp = 0;
            this.mw = null;
            this.mv = null;
            this.mu = null;
            this.fc = 0;
            this.fd = 0;
            this.ag = null;
            this.mt = null;
            this.ae = null;
            this.af = null;
            this.jg = 0;
            this.c9 = 0;
            this.bs = false;
            this.al = null;
            this.nj = null;
            this.fv = 0;
            this.br = false;
            this.fg = 0;
            this.fi = 0;
            this.fh = 0;
            this.ff = 0;
            this.j6 = null;
            this.m2 = null;
            this.m3 = null;
            this.mf = null;
            this.me = null;
            this.mp = null;
            this.mr = null;
            this.mq = null;
            this.jj = 0;
            this.nh = null;
            this.kb = null;
            this.b0 = false;
            this.kd = null;
            this.dc = 0;
            this.kc = null;
            this.bz = false;
            this.j7 = null;
            this.j9 = null;
            this.j8 = null;
            this.ka = null;
            this.i9 = 0;
            this.ja = 0;
            this.cc = false;
            this.ce = false;
            this.b7 = false;
            this.l5 = null;
            this.l6 = null;
            this.jd = 0;
            this.bt = false;
            this.by = false;
            this.bu = false;
            this.cg = false;
            this.jw = null;
            this.bw = false;
            this.bx = false;
            this.bv = false;
            this.db = 0;
            this.jy = null;
            this.i8 = 0;
            this.j0 = null;
            this.k = null;
            this.j3 = null;
            this.j4 = null;
            this.j1 = null;
            this.jz = null;
            this.am = null;
            this.an = null;
            this.fw = 0;
            this.mh = null;
            this.nm = null;
            this.mj = null;
            this.no = null;
            this.mg = null;
            this.mi = null;
            this.e8 = 0;
            this.e7 = 0;
            this.e4 = 0;
            this.e5 = 0;
            this.e6 = 0;
            this.fa = 0;
            this.e9 = 0;
            this.b8 = false;
            this.nl = null;
            this.nn = null;
            this.f0 = 0;
            this.fz = 0;
            this.fx = 0;
            this.f3 = 0;
            this.fy = 0;
            this.f2 = 0;
            this.f1 = 0;
            this.ch = false;
            this.f5 = 0;
            this.f4 = 0;
            this.f7 = 0;
            this.f6 = 0;
            this.m1 = null;
            this.m9 = null;
            this.m5 = null;
            this.m6 = null;
            this.m7 = null;
            this.m4 = null;
            this.m8 = null;
            this.j2 = null;
            this.jx = null;
            this.mx = null;
            this.l8 = null;
            this.l4 = null;
        }
        get pixelScalingRatio() {
            return this.fe;
        }
        set pixelScalingRatio(a) {
            this.fe = a;
            this.g("PixelScalingRatio");
        }
        get titleLeftMargin() {
            return this.fr;
        }
        set titleLeftMargin(a) {
            this.fr = a;
            this.g("TitleLeftMargin");
        }
        get titleRightMargin() {
            return this.fs;
        }
        set titleRightMargin(a) {
            this.fs = a;
            this.g("TitleRightMargin");
        }
        get titleTopMargin() {
            return this.ft;
        }
        set titleTopMargin(a) {
            this.ft = a;
            this.g("TitleTopMargin");
        }
        get titleBottomMargin() {
            return this.fq;
        }
        set titleBottomMargin(a) {
            this.fq = a;
            this.g("TitleBottomMargin");
        }
        get subtitleLeftMargin() {
            return this.fm;
        }
        set subtitleLeftMargin(a) {
            this.fm = a;
            this.g("SubtitleLeftMargin");
        }
        get subtitleTopMargin() {
            return this.fo;
        }
        set subtitleTopMargin(a) {
            this.fo = a;
            this.g("SubtitleTopMargin");
        }
        get subtitleRightMargin() {
            return this.fn;
        }
        set subtitleRightMargin(a) {
            this.fn = a;
            this.g("SubtitleRightMargin");
        }
        get subtitleBottomMargin() {
            return this.fl;
        }
        set subtitleBottomMargin(a) {
            this.fl = a;
            this.g("SubtitleBottomMargin");
        }
        get subtitleTextColor() {
            return this.nc;
        }
        set subtitleTextColor(a) {
            this.nc = a;
            this.g("SubtitleTextColor");
        }
        get titleTextColor() {
            return this.nf;
        }
        set titleTextColor(a) {
            this.nf = a;
            this.g("TitleTextColor");
        }
        get leftMargin() {
            return this.fb;
        }
        set leftMargin(a) {
            this.fb = a;
            this.g("LeftMargin");
        }
        get topMargin() {
            return this.fu;
        }
        set topMargin(a) {
            this.fu = a;
            this.g("TopMargin");
        }
        get rightMargin() {
            return this.fk;
        }
        set rightMargin(a) {
            this.fk = a;
            this.g("RightMargin");
        }
        get bottomMargin() {
            return this.da;
        }
        set bottomMargin(a) {
            this.da = a;
            this.g("BottomMargin");
        }
        get transitionDuration() {
            return this.ji;
        }
        set transitionDuration(a) {
            this.ji = a;
            this.g("TransitionDuration");
        }
        get transitionEasingFunctionRef() {
            return this.ni;
        }
        set transitionEasingFunctionRef(a) {
            this.ni = a;
            this.g("TransitionEasingFunctionRef");
        }
        get highlightingTransitionDuration() {
            return this.jf;
        }
        set highlightingTransitionDuration(a) {
            this.jf = a;
            this.g("HighlightingTransitionDuration");
        }
        get selectionTransitionDuration() {
            return this.jh;
        }
        set selectionTransitionDuration(a) {
            this.jh = a;
            this.g("SelectionTransitionDuration");
        }
        get focusTransitionDuration() {
            return this.je;
        }
        set focusTransitionDuration(a) {
            this.je = a;
            this.g("FocusTransitionDuration");
        }
        get subtitleTextStyle() {
            return this.nd;
        }
        set subtitleTextStyle(a) {
            this.nd = a;
            this.g("SubtitleTextStyle");
        }
        get titleTextStyle() {
            return this.ng;
        }
        set titleTextStyle(a) {
            this.ng = a;
            this.g("TitleTextStyle");
        }
        get dataToolTipGroupingMode() {
            return this.ki;
        }
        set dataToolTipGroupingMode(a) {
            this.ki = a;
            this.g("DataToolTipGroupingMode");
        }
        get dataToolTipPositionOffsetX() {
            return this.d7;
        }
        set dataToolTipPositionOffsetX(a) {
            this.d7 = a;
            this.g("DataToolTipPositionOffsetX");
        }
        get dataToolTipPositionOffsetY() {
            return this.d8;
        }
        set dataToolTipPositionOffsetY(a) {
            this.d8 = a;
            this.g("DataToolTipPositionOffsetY");
        }
        get dataToolTipDefaultPositionOffsetX() {
            return this.dh;
        }
        set dataToolTipDefaultPositionOffsetX(a) {
            this.dh = a;
            this.g("DataToolTipDefaultPositionOffsetX");
        }
        get dataToolTipDefaultPositionOffsetY() {
            return this.di;
        }
        set dataToolTipDefaultPositionOffsetY(a) {
            this.di = a;
            this.g("DataToolTipDefaultPositionOffsetY");
        }
        get dataToolTipGroupedPositionModeX() {
            return this.kg;
        }
        set dataToolTipGroupedPositionModeX(a) {
            this.kg = a;
            this.g("DataToolTipGroupedPositionModeX");
        }
        get dataToolTipGroupedPositionModeY() {
            return this.kh;
        }
        set dataToolTipGroupedPositionModeY(a) {
            this.kh = a;
            this.g("DataToolTipGroupedPositionModeY");
        }
        get dataToolTipShouldUpdateWhenSeriesDataChanges() {
            return this.b3;
        }
        set dataToolTipShouldUpdateWhenSeriesDataChanges(a) {
            this.b3 = a;
            this.g("DataToolTipShouldUpdateWhenSeriesDataChanges");
        }
        get dataToolTipIncludedSeries() {
            return this.p;
        }
        set dataToolTipIncludedSeries(a) {
            this.p = a;
            this.g("DataToolTipIncludedSeries");
        }
        get dataToolTipExcludedSeries() {
            return this.m;
        }
        set dataToolTipExcludedSeries(a) {
            this.m = a;
            this.g("DataToolTipExcludedSeries");
        }
        get dataToolTipIncludedColumns() {
            return this.o;
        }
        set dataToolTipIncludedColumns(a) {
            this.o = a;
            this.g("DataToolTipIncludedColumns");
        }
        get dataToolTipExcludedColumns() {
            return this.l;
        }
        set dataToolTipExcludedColumns(a) {
            this.l = a;
            this.g("DataToolTipExcludedColumns");
        }
        get dataToolTipValueFormatAbbreviation() {
            return this.lv;
        }
        set dataToolTipValueFormatAbbreviation(a) {
            this.lv = a;
            this.g("DataToolTipValueFormatAbbreviation");
        }
        get dataToolTipValueFormatMaxFractions() {
            return this.jb;
        }
        set dataToolTipValueFormatMaxFractions(a) {
            this.jb = a;
            this.g("DataToolTipValueFormatMaxFractions");
        }
        get dataToolTipValueFormatMinFractions() {
            return this.jc;
        }
        set dataToolTipValueFormatMinFractions(a) {
            this.jc = a;
            this.g("DataToolTipValueFormatMinFractions");
        }
        get dataToolTipValueFormatMode() {
            return this.lx;
        }
        set dataToolTipValueFormatMode(a) {
            this.lx = a;
            this.g("DataToolTipValueFormatMode");
        }
        get dataToolTipValueFormatCulture() {
            return this.lw;
        }
        set dataToolTipValueFormatCulture(a) {
            this.lw = a;
            this.g("DataToolTipValueFormatCulture");
        }
        get dataToolTipValueFormatUseGrouping() {
            return this.b4;
        }
        set dataToolTipValueFormatUseGrouping(a) {
            this.b4 = a;
            this.g("DataToolTipValueFormatUseGrouping");
        }
        get dataToolTipValueFormatString() {
            return this.ly;
        }
        set dataToolTipValueFormatString(a) {
            this.ly = a;
            this.g("DataToolTipValueFormatString");
        }
        get dataToolTipValueFormatSpecifiers() {
            return this.q;
        }
        set dataToolTipValueFormatSpecifiers(a) {
            this.q = a;
            this.g("DataToolTipValueFormatSpecifiers");
        }
        get dataToolTipValueRowMarginBottom() {
            return this.ev;
        }
        set dataToolTipValueRowMarginBottom(a) {
            this.ev = a;
            this.g("DataToolTipValueRowMarginBottom");
        }
        get dataToolTipValueRowMarginLeft() {
            return this.ew;
        }
        set dataToolTipValueRowMarginLeft(a) {
            this.ew = a;
            this.g("DataToolTipValueRowMarginLeft");
        }
        get dataToolTipValueRowMarginRight() {
            return this.ex;
        }
        set dataToolTipValueRowMarginRight(a) {
            this.ex = a;
            this.g("DataToolTipValueRowMarginRight");
        }
        get dataToolTipValueRowMarginTop() {
            return this.ey;
        }
        set dataToolTipValueRowMarginTop(a) {
            this.ey = a;
            this.g("DataToolTipValueRowMarginTop");
        }
        get dataToolTipValueRowVisible() {
            return this.b5;
        }
        set dataToolTipValueRowVisible(a) {
            this.b5 = a;
            this.g("DataToolTipValueRowVisible");
        }
        get dataToolTipValueTextWhenMissingData() {
            return this.l3;
        }
        set dataToolTipValueTextWhenMissingData(a) {
            this.l3 = a;
            this.g("DataToolTipValueTextWhenMissingData");
        }
        get dataToolTipValueTextUseSeriesColors() {
            return this.b6;
        }
        set dataToolTipValueTextUseSeriesColors(a) {
            this.b6 = a;
            this.g("DataToolTipValueTextUseSeriesColors");
        }
        get dataToolTipValueTextMarginBottom() {
            return this.e0;
        }
        set dataToolTipValueTextMarginBottom(a) {
            this.e0 = a;
            this.g("DataToolTipValueTextMarginBottom");
        }
        get dataToolTipValueTextMarginLeft() {
            return this.e1;
        }
        set dataToolTipValueTextMarginLeft(a) {
            this.e1 = a;
            this.g("DataToolTipValueTextMarginLeft");
        }
        get dataToolTipValueTextMarginRight() {
            return this.e2;
        }
        set dataToolTipValueTextMarginRight(a) {
            this.e2 = a;
            this.g("DataToolTipValueTextMarginRight");
        }
        get dataToolTipValueTextMarginTop() {
            return this.e3;
        }
        set dataToolTipValueTextMarginTop(a) {
            this.e3 = a;
            this.g("DataToolTipValueTextMarginTop");
        }
        get dataToolTipValueTextColor() {
            return this.lz;
        }
        set dataToolTipValueTextColor(a) {
            this.lz = a;
            this.g("DataToolTipValueTextColor");
        }
        get dataToolTipValueTextFontFamily() {
            return this.l0;
        }
        set dataToolTipValueTextFontFamily(a) {
            this.l0 = a;
            this.g("DataToolTipValueTextFontFamily");
        }
        get dataToolTipValueTextFontSize() {
            return this.ez;
        }
        set dataToolTipValueTextFontSize(a) {
            this.ez = a;
            this.g("DataToolTipValueTextFontSize");
        }
        get dataToolTipValueTextFontStyle() {
            return this.l1;
        }
        set dataToolTipValueTextFontStyle(a) {
            this.l1 = a;
            this.g("DataToolTipValueTextFontStyle");
        }
        get dataToolTipValueTextFontWeight() {
            return this.l2;
        }
        set dataToolTipValueTextFontWeight(a) {
            this.l2 = a;
            this.g("DataToolTipValueTextFontWeight");
        }
        get dataToolTipHeaderFormatString() {
            return this.kp;
        }
        set dataToolTipHeaderFormatString(a) {
            this.kp = a;
            this.g("DataToolTipHeaderFormatString");
        }
        get dataToolTipHeaderFormatSpecifiers() {
            return this.n;
        }
        set dataToolTipHeaderFormatSpecifiers(a) {
            this.n = a;
            this.g("DataToolTipHeaderFormatSpecifiers");
        }
        get dataToolTipHeaderFormatCulture() {
            return this.kn;
        }
        set dataToolTipHeaderFormatCulture(a) {
            this.kn = a;
            this.g("DataToolTipHeaderFormatCulture");
        }
        get dataToolTipHeaderFormatDate() {
            return this.ko;
        }
        set dataToolTipHeaderFormatDate(a) {
            this.ko = a;
            this.g("DataToolTipHeaderFormatDate");
        }
        get dataToolTipHeaderFormatTime() {
            return this.kq;
        }
        set dataToolTipHeaderFormatTime(a) {
            this.kq = a;
            this.g("DataToolTipHeaderFormatTime");
        }
        get dataToolTipHeaderText() {
            return this.kr;
        }
        set dataToolTipHeaderText(a) {
            this.kr = a;
            this.g("DataToolTipHeaderText");
        }
        get dataToolTipHeaderTextColor() {
            return this.ks;
        }
        set dataToolTipHeaderTextColor(a) {
            this.ks = a;
            this.g("DataToolTipHeaderTextColor");
        }
        get dataToolTipHeaderTextMarginBottom() {
            return this.dy;
        }
        set dataToolTipHeaderTextMarginBottom(a) {
            this.dy = a;
            this.g("DataToolTipHeaderTextMarginBottom");
        }
        get dataToolTipHeaderTextMarginLeft() {
            return this.dz;
        }
        set dataToolTipHeaderTextMarginLeft(a) {
            this.dz = a;
            this.g("DataToolTipHeaderTextMarginLeft");
        }
        get dataToolTipHeaderTextMarginRight() {
            return this.d0;
        }
        set dataToolTipHeaderTextMarginRight(a) {
            this.d0 = a;
            this.g("DataToolTipHeaderTextMarginRight");
        }
        get dataToolTipHeaderTextMarginTop() {
            return this.d1;
        }
        set dataToolTipHeaderTextMarginTop(a) {
            this.d1 = a;
            this.g("DataToolTipHeaderTextMarginTop");
        }
        get dataToolTipHeaderRowMarginBottom() {
            return this.dt;
        }
        set dataToolTipHeaderRowMarginBottom(a) {
            this.dt = a;
            this.g("DataToolTipHeaderRowMarginBottom");
        }
        get dataToolTipHeaderRowMarginLeft() {
            return this.du;
        }
        set dataToolTipHeaderRowMarginLeft(a) {
            this.du = a;
            this.g("DataToolTipHeaderRowMarginLeft");
        }
        get dataToolTipHeaderRowMarginRight() {
            return this.dv;
        }
        set dataToolTipHeaderRowMarginRight(a) {
            this.dv = a;
            this.g("DataToolTipHeaderRowMarginRight");
        }
        get dataToolTipHeaderRowMarginTop() {
            return this.dw;
        }
        set dataToolTipHeaderRowMarginTop(a) {
            this.dw = a;
            this.g("DataToolTipHeaderRowMarginTop");
        }
        get dataToolTipHeaderRowVisible() {
            return this.b2;
        }
        set dataToolTipHeaderRowVisible(a) {
            this.b2 = a;
            this.g("DataToolTipHeaderRowVisible");
        }
        get dataToolTipHeaderTextFontFamily() {
            return this.kt;
        }
        set dataToolTipHeaderTextFontFamily(a) {
            this.kt = a;
            this.g("DataToolTipHeaderTextFontFamily");
        }
        get dataToolTipHeaderTextFontSize() {
            return this.dx;
        }
        set dataToolTipHeaderTextFontSize(a) {
            this.dx = a;
            this.g("DataToolTipHeaderTextFontSize");
        }
        get dataToolTipHeaderTextFontStyle() {
            return this.ku;
        }
        set dataToolTipHeaderTextFontStyle(a) {
            this.ku = a;
            this.g("DataToolTipHeaderTextFontStyle");
        }
        get dataToolTipHeaderTextFontWeight() {
            return this.kv;
        }
        set dataToolTipHeaderTextFontWeight(a) {
            this.kv = a;
            this.g("DataToolTipHeaderTextFontWeight");
        }
        get dataToolTipGroupTextColor() {
            return this.kj;
        }
        set dataToolTipGroupTextColor(a) {
            this.kj = a;
            this.g("DataToolTipGroupTextColor");
        }
        get dataToolTipGroupTextMarginBottom() {
            return this.dp;
        }
        set dataToolTipGroupTextMarginBottom(a) {
            this.dp = a;
            this.g("DataToolTipGroupTextMarginBottom");
        }
        get dataToolTipGroupTextMarginLeft() {
            return this.dq;
        }
        set dataToolTipGroupTextMarginLeft(a) {
            this.dq = a;
            this.g("DataToolTipGroupTextMarginLeft");
        }
        get dataToolTipGroupTextMarginRight() {
            return this.dr;
        }
        set dataToolTipGroupTextMarginRight(a) {
            this.dr = a;
            this.g("DataToolTipGroupTextMarginRight");
        }
        get dataToolTipGroupTextMarginTop() {
            return this.ds;
        }
        set dataToolTipGroupTextMarginTop(a) {
            this.ds = a;
            this.g("DataToolTipGroupTextMarginTop");
        }
        get dataToolTipGroupRowMarginBottom() {
            return this.dj;
        }
        set dataToolTipGroupRowMarginBottom(a) {
            this.dj = a;
            this.g("DataToolTipGroupRowMarginBottom");
        }
        get dataToolTipGroupRowMarginLeft() {
            return this.dk;
        }
        set dataToolTipGroupRowMarginLeft(a) {
            this.dk = a;
            this.g("DataToolTipGroupRowMarginLeft");
        }
        get dataToolTipGroupRowMarginRight() {
            return this.dl;
        }
        set dataToolTipGroupRowMarginRight(a) {
            this.dl = a;
            this.g("DataToolTipGroupRowMarginRight");
        }
        get dataToolTipGroupRowMarginTop() {
            return this.dm;
        }
        set dataToolTipGroupRowMarginTop(a) {
            this.dm = a;
            this.g("DataToolTipGroupRowMarginTop");
        }
        get dataToolTipGroupRowVisible() {
            return this.b1;
        }
        set dataToolTipGroupRowVisible(a) {
            this.b1 = a;
            this.g("DataToolTipGroupRowVisible");
        }
        get dataToolTipGroupTextFontFamily() {
            return this.kk;
        }
        set dataToolTipGroupTextFontFamily(a) {
            this.kk = a;
            this.g("DataToolTipGroupTextFontFamily");
        }
        get dataToolTipGroupTextFontSize() {
            return this.dn;
        }
        set dataToolTipGroupTextFontSize(a) {
            this.dn = a;
            this.g("DataToolTipGroupTextFontSize");
        }
        get dataToolTipGroupTextFontStyle() {
            return this.kl;
        }
        set dataToolTipGroupTextFontStyle(a) {
            this.kl = a;
            this.g("DataToolTipGroupTextFontStyle");
        }
        get dataToolTipGroupTextFontWeight() {
            return this.km;
        }
        set dataToolTipGroupTextFontWeight(a) {
            this.km = a;
            this.g("DataToolTipGroupTextFontWeight");
        }
        get dataToolTipSummaryTitleTextColor() {
            return this.k7;
        }
        set dataToolTipSummaryTitleTextColor(a) {
            this.k7 = a;
            this.g("DataToolTipSummaryTitleTextColor");
        }
        get dataToolTipSummaryTitleTextFontFamily() {
            return this.k8;
        }
        set dataToolTipSummaryTitleTextFontFamily(a) {
            this.k8 = a;
            this.g("DataToolTipSummaryTitleTextFontFamily");
        }
        get dataToolTipSummaryTitleTextFontSize() {
            return this.ee;
        }
        set dataToolTipSummaryTitleTextFontSize(a) {
            this.ee = a;
            this.g("DataToolTipSummaryTitleTextFontSize");
        }
        get dataToolTipSummaryTitleTextFontStyle() {
            return this.k9;
        }
        set dataToolTipSummaryTitleTextFontStyle(a) {
            this.k9 = a;
            this.g("DataToolTipSummaryTitleTextFontStyle");
        }
        get dataToolTipSummaryTitleTextFontWeight() {
            return this.la;
        }
        set dataToolTipSummaryTitleTextFontWeight(a) {
            this.la = a;
            this.g("DataToolTipSummaryTitleTextFontWeight");
        }
        get dataToolTipSummaryType() {
            return this.lb;
        }
        set dataToolTipSummaryType(a) {
            this.lb = a;
            this.g("DataToolTipSummaryType");
        }
        get dataToolTipSummaryTitleText() {
            return this.k6;
        }
        set dataToolTipSummaryTitleText(a) {
            this.k6 = a;
            this.g("DataToolTipSummaryTitleText");
        }
        get dataToolTipSummaryTitleTextMarginBottom() {
            return this.ef;
        }
        set dataToolTipSummaryTitleTextMarginBottom(a) {
            this.ef = a;
            this.g("DataToolTipSummaryTitleTextMarginBottom");
        }
        get dataToolTipSummaryTitleTextMarginLeft() {
            return this.eg;
        }
        set dataToolTipSummaryTitleTextMarginLeft(a) {
            this.eg = a;
            this.g("DataToolTipSummaryTitleTextMarginLeft");
        }
        get dataToolTipSummaryTitleTextMarginRight() {
            return this.eh;
        }
        set dataToolTipSummaryTitleTextMarginRight(a) {
            this.eh = a;
            this.g("DataToolTipSummaryTitleTextMarginRight");
        }
        get dataToolTipSummaryTitleTextMarginTop() {
            return this.ei;
        }
        set dataToolTipSummaryTitleTextMarginTop(a) {
            this.ei = a;
            this.g("DataToolTipSummaryTitleTextMarginTop");
        }
        get dataToolTipSummaryRowMarginBottom() {
            return this.ea;
        }
        set dataToolTipSummaryRowMarginBottom(a) {
            this.ea = a;
            this.g("DataToolTipSummaryRowMarginBottom");
        }
        get dataToolTipSummaryRowMarginLeft() {
            return this.eb;
        }
        set dataToolTipSummaryRowMarginLeft(a) {
            this.eb = a;
            this.g("DataToolTipSummaryRowMarginLeft");
        }
        get dataToolTipSummaryRowMarginRight() {
            return this.ec;
        }
        set dataToolTipSummaryRowMarginRight(a) {
            this.ec = a;
            this.g("DataToolTipSummaryRowMarginRight");
        }
        get dataToolTipSummaryRowMarginTop() {
            return this.ed;
        }
        set dataToolTipSummaryRowMarginTop(a) {
            this.ed = a;
            this.g("DataToolTipSummaryRowMarginTop");
        }
        get dataToolTipSummaryValueTextColor() {
            return this.lh;
        }
        set dataToolTipSummaryValueTextColor(a) {
            this.lh = a;
            this.g("DataToolTipSummaryValueTextColor");
        }
        get dataToolTipSummaryValueTextFontFamily() {
            return this.li;
        }
        set dataToolTipSummaryValueTextFontFamily(a) {
            this.li = a;
            this.g("DataToolTipSummaryValueTextFontFamily");
        }
        get dataToolTipSummaryValueTextFontSize() {
            return this.ek;
        }
        set dataToolTipSummaryValueTextFontSize(a) {
            this.ek = a;
            this.g("DataToolTipSummaryValueTextFontSize");
        }
        get dataToolTipSummaryValueTextFontStyle() {
            return this.lj;
        }
        set dataToolTipSummaryValueTextFontStyle(a) {
            this.lj = a;
            this.g("DataToolTipSummaryValueTextFontStyle");
        }
        get dataToolTipSummaryValueTextFontWeight() {
            return this.lk;
        }
        set dataToolTipSummaryValueTextFontWeight(a) {
            this.lk = a;
            this.g("DataToolTipSummaryValueTextFontWeight");
        }
        get dataToolTipSummaryLabelText() {
            return this.k1;
        }
        set dataToolTipSummaryLabelText(a) {
            this.k1 = a;
            this.g("DataToolTipSummaryLabelText");
        }
        get dataToolTipSummaryLabelTextColor() {
            return this.k2;
        }
        set dataToolTipSummaryLabelTextColor(a) {
            this.k2 = a;
            this.g("DataToolTipSummaryLabelTextColor");
        }
        get dataToolTipSummaryLabelTextFontFamily() {
            return this.k3;
        }
        set dataToolTipSummaryLabelTextFontFamily(a) {
            this.k3 = a;
            this.g("DataToolTipSummaryLabelTextFontFamily");
        }
        get dataToolTipSummaryLabelTextFontSize() {
            return this.d9;
        }
        set dataToolTipSummaryLabelTextFontSize(a) {
            this.d9 = a;
            this.g("DataToolTipSummaryLabelTextFontSize");
        }
        get dataToolTipSummaryLabelTextFontStyle() {
            return this.k4;
        }
        set dataToolTipSummaryLabelTextFontStyle(a) {
            this.k4 = a;
            this.g("DataToolTipSummaryLabelTextFontStyle");
        }
        get dataToolTipSummaryLabelTextFontWeight() {
            return this.k5;
        }
        set dataToolTipSummaryLabelTextFontWeight(a) {
            this.k5 = a;
            this.g("DataToolTipSummaryLabelTextFontWeight");
        }
        get dataToolTipSummaryUnitsText() {
            return this.lc;
        }
        set dataToolTipSummaryUnitsText(a) {
            this.lc = a;
            this.g("DataToolTipSummaryUnitsText");
        }
        get dataToolTipSummaryUnitsTextColor() {
            return this.ld;
        }
        set dataToolTipSummaryUnitsTextColor(a) {
            this.ld = a;
            this.g("DataToolTipSummaryUnitsTextColor");
        }
        get dataToolTipSummaryUnitsTextFontFamily() {
            return this.le;
        }
        set dataToolTipSummaryUnitsTextFontFamily(a) {
            this.le = a;
            this.g("DataToolTipSummaryUnitsTextFontFamily");
        }
        get dataToolTipSummaryUnitsTextFontSize() {
            return this.ej;
        }
        set dataToolTipSummaryUnitsTextFontSize(a) {
            this.ej = a;
            this.g("DataToolTipSummaryUnitsTextFontSize");
        }
        get dataToolTipSummaryUnitsTextFontStyle() {
            return this.lf;
        }
        set dataToolTipSummaryUnitsTextFontStyle(a) {
            this.lf = a;
            this.g("DataToolTipSummaryUnitsTextFontStyle");
        }
        get dataToolTipSummaryUnitsTextFontWeight() {
            return this.lg;
        }
        set dataToolTipSummaryUnitsTextFontWeight(a) {
            this.lg = a;
            this.g("DataToolTipSummaryUnitsTextFontWeight");
        }
        get dataToolTipBadgeMarginBottom() {
            return this.dd;
        }
        set dataToolTipBadgeMarginBottom(a) {
            this.dd = a;
            this.g("DataToolTipBadgeMarginBottom");
        }
        get dataToolTipBadgeMarginLeft() {
            return this.de;
        }
        set dataToolTipBadgeMarginLeft(a) {
            this.de = a;
            this.g("DataToolTipBadgeMarginLeft");
        }
        get dataToolTipBadgeMarginRight() {
            return this.df;
        }
        set dataToolTipBadgeMarginRight(a) {
            this.df = a;
            this.g("DataToolTipBadgeMarginRight");
        }
        get dataToolTipBadgeMarginTop() {
            return this.dg;
        }
        set dataToolTipBadgeMarginTop(a) {
            this.dg = a;
            this.g("DataToolTipBadgeMarginTop");
        }
        get dataToolTipBadgeShape() {
            return this.kf;
        }
        set dataToolTipBadgeShape(a) {
            this.kf = a;
            this.g("DataToolTipBadgeShape");
        }
        get dataToolTipUnitsDisplayMode() {
            return this.lp;
        }
        set dataToolTipUnitsDisplayMode(a) {
            this.lp = a;
            this.g("DataToolTipUnitsDisplayMode");
        }
        get dataToolTipUnitsText() {
            return this.lq;
        }
        set dataToolTipUnitsText(a) {
            this.lq = a;
            this.g("DataToolTipUnitsText");
        }
        get dataToolTipUnitsTextColor() {
            return this.lr;
        }
        set dataToolTipUnitsTextColor(a) {
            this.lr = a;
            this.g("DataToolTipUnitsTextColor");
        }
        get dataToolTipUnitsTextMarginBottom() {
            return this.er;
        }
        set dataToolTipUnitsTextMarginBottom(a) {
            this.er = a;
            this.g("DataToolTipUnitsTextMarginBottom");
        }
        get dataToolTipUnitsTextMarginLeft() {
            return this.es;
        }
        set dataToolTipUnitsTextMarginLeft(a) {
            this.es = a;
            this.g("DataToolTipUnitsTextMarginLeft");
        }
        get dataToolTipUnitsTextMarginRight() {
            return this.et;
        }
        set dataToolTipUnitsTextMarginRight(a) {
            this.et = a;
            this.g("DataToolTipUnitsTextMarginRight");
        }
        get dataToolTipUnitsTextMarginTop() {
            return this.eu;
        }
        set dataToolTipUnitsTextMarginTop(a) {
            this.eu = a;
            this.g("DataToolTipUnitsTextMarginTop");
        }
        get dataToolTipUnitsTextFontFamily() {
            return this.ls;
        }
        set dataToolTipUnitsTextFontFamily(a) {
            this.ls = a;
            this.g("DataToolTipUnitsTextFontFamily");
        }
        get dataToolTipUnitsTextFontSize() {
            return this.eq;
        }
        set dataToolTipUnitsTextFontSize(a) {
            this.eq = a;
            this.g("DataToolTipUnitsTextFontSize");
        }
        get dataToolTipUnitsTextFontStyle() {
            return this.lt;
        }
        set dataToolTipUnitsTextFontStyle(a) {
            this.lt = a;
            this.g("DataToolTipUnitsTextFontStyle");
        }
        get dataToolTipUnitsTextFontWeight() {
            return this.lu;
        }
        set dataToolTipUnitsTextFontWeight(a) {
            this.lu = a;
            this.g("DataToolTipUnitsTextFontWeight");
        }
        get dataToolTipTitleTextMarginBottom() {
            return this.em;
        }
        set dataToolTipTitleTextMarginBottom(a) {
            this.em = a;
            this.g("DataToolTipTitleTextMarginBottom");
        }
        get dataToolTipTitleTextMarginLeft() {
            return this.en;
        }
        set dataToolTipTitleTextMarginLeft(a) {
            this.en = a;
            this.g("DataToolTipTitleTextMarginLeft");
        }
        get dataToolTipTitleTextMarginRight() {
            return this.eo;
        }
        set dataToolTipTitleTextMarginRight(a) {
            this.eo = a;
            this.g("DataToolTipTitleTextMarginRight");
        }
        get dataToolTipTitleTextMarginTop() {
            return this.ep;
        }
        set dataToolTipTitleTextMarginTop(a) {
            this.ep = a;
            this.g("DataToolTipTitleTextMarginTop");
        }
        get dataToolTipTitleTextColor() {
            return this.ll;
        }
        set dataToolTipTitleTextColor(a) {
            this.ll = a;
            this.g("DataToolTipTitleTextColor");
        }
        get dataToolTipTitleTextFontFamily() {
            return this.lm;
        }
        set dataToolTipTitleTextFontFamily(a) {
            this.lm = a;
            this.g("DataToolTipTitleTextFontFamily");
        }
        get dataToolTipTitleTextFontSize() {
            return this.el;
        }
        set dataToolTipTitleTextFontSize(a) {
            this.el = a;
            this.g("DataToolTipTitleTextFontSize");
        }
        get dataToolTipTitleTextFontStyle() {
            return this.ln;
        }
        set dataToolTipTitleTextFontStyle(a) {
            this.ln = a;
            this.g("DataToolTipTitleTextFontStyle");
        }
        get dataToolTipTitleTextFontWeight() {
            return this.lo;
        }
        set dataToolTipTitleTextFontWeight(a) {
            this.lo = a;
            this.g("DataToolTipTitleTextFontWeight");
        }
        get dataToolTipLabelDisplayMode() {
            return this.kw;
        }
        set dataToolTipLabelDisplayMode(a) {
            this.kw = a;
            this.g("DataToolTipLabelDisplayMode");
        }
        get dataToolTipLabelTextColor() {
            return this.kx;
        }
        set dataToolTipLabelTextColor(a) {
            this.kx = a;
            this.g("DataToolTipLabelTextColor");
        }
        get dataToolTipLabelTextMarginBottom() {
            return this.d3;
        }
        set dataToolTipLabelTextMarginBottom(a) {
            this.d3 = a;
            this.g("DataToolTipLabelTextMarginBottom");
        }
        get dataToolTipLabelTextMarginLeft() {
            return this.d4;
        }
        set dataToolTipLabelTextMarginLeft(a) {
            this.d4 = a;
            this.g("DataToolTipLabelTextMarginLeft");
        }
        get dataToolTipLabelTextMarginRight() {
            return this.d5;
        }
        set dataToolTipLabelTextMarginRight(a) {
            this.d5 = a;
            this.g("DataToolTipLabelTextMarginRight");
        }
        get dataToolTipLabelTextMarginTop() {
            return this.d6;
        }
        set dataToolTipLabelTextMarginTop(a) {
            this.d6 = a;
            this.g("DataToolTipLabelTextMarginTop");
        }
        get dataToolTipLabelTextFontFamily() {
            return this.ky;
        }
        set dataToolTipLabelTextFontFamily(a) {
            this.ky = a;
            this.g("DataToolTipLabelTextFontFamily");
        }
        get dataToolTipLabelTextFontSize() {
            return this.d2;
        }
        set dataToolTipLabelTextFontSize(a) {
            this.d2 = a;
            this.g("DataToolTipLabelTextFontSize");
        }
        get dataToolTipLabelTextFontStyle() {
            return this.kz;
        }
        set dataToolTipLabelTextFontStyle(a) {
            this.kz = a;
            this.g("DataToolTipLabelTextFontStyle");
        }
        get dataToolTipLabelTextFontWeight() {
            return this.k0;
        }
        set dataToolTipLabelTextFontWeight(a) {
            this.k0 = a;
            this.g("DataToolTipLabelTextFontWeight");
        }
        get sortDescriptions() {
            return this.aj;
        }
        set sortDescriptions(a) {
            this.aj = a;
            this.g("SortDescriptions");
        }
        get groupSortDescriptions() {
            return this.v;
        }
        set groupSortDescriptions(a) {
            this.v = a;
            this.g("GroupSortDescriptions");
        }
        get groupDescriptions() {
            return this.u;
        }
        set groupDescriptions(a) {
            this.u = a;
            this.g("GroupDescriptions");
        }
        get filterExpressions() {
            return this.s;
        }
        set filterExpressions(a) {
            this.s = a;
            this.g("FilterExpressions");
        }
        get highlightFilterExpressions() {
            return this.w;
        }
        set highlightFilterExpressions(a) {
            this.w = a;
            this.g("HighlightFilterExpressions");
        }
        get summaryDescriptions() {
            return this.ak;
        }
        set summaryDescriptions(a) {
            this.ak = a;
            this.g("SummaryDescriptions");
        }
        get selectionMode() {
            return this.m0;
        }
        set selectionMode(a) {
            this.m0 = a;
            this.g("SelectionMode");
        }
        get focusMode() {
            return this.l9;
        }
        set focusMode(a) {
            this.l9 = a;
            this.g("FocusMode");
        }
        get selectionBrush() {
            return this.mz;
        }
        set selectionBrush(a) {
            this.mz = a;
            this.g("SelectionBrush");
        }
        get focusBrush() {
            return this.l7;
        }
        set focusBrush(a) {
            this.l7 = a;
            this.g("FocusBrush");
        }
        get selectionBehavior() {
            return this.my;
        }
        set selectionBehavior(a) {
            this.my = a;
            this.g("SelectionBehavior");
        }
        get selectedSeriesItems() {
            return this.ai;
        }
        set selectedSeriesItems(a) {
            this.ai = a;
            this.g("SelectedSeriesItems");
        }
        get focusedSeriesItems() {
            return this.t;
        }
        set focusedSeriesItems(a) {
            this.t = a;
            this.g("FocusedSeriesItems");
        }
        get initialSortDescriptions() {
            return this.ac;
        }
        set initialSortDescriptions(a) {
            this.ac = a;
            this.g("InitialSortDescriptions");
        }
        get initialGroupSortDescriptions() {
            return this.aa;
        }
        set initialGroupSortDescriptions(a) {
            this.aa = a;
            this.g("InitialGroupSortDescriptions");
        }
        get initialGroupDescriptions() {
            return this.z;
        }
        set initialGroupDescriptions(a) {
            this.z = a;
            this.g("InitialGroupDescriptions");
        }
        get initialFilterExpressions() {
            return this.y;
        }
        set initialFilterExpressions(a) {
            this.y = a;
            this.g("InitialFilterExpressions");
        }
        get initialHighlightFilterExpressions() {
            return this.ab;
        }
        set initialHighlightFilterExpressions(a) {
            this.ab = a;
            this.g("InitialHighlightFilterExpressions");
        }
        get initialSummaryDescriptions() {
            return this.ad;
        }
        set initialSummaryDescriptions(a) {
            this.ad = a;
            this.g("InitialSummaryDescriptions");
        }
        get initialSorts() {
            return this.mn;
        }
        set initialSorts(a) {
            this.mn = a;
            this.g("InitialSorts");
        }
        get groupSorts() {
            return this.ma;
        }
        set groupSorts(a) {
            this.ma = a;
            this.g("GroupSorts");
        }
        get initialGroups() {
            return this.ml;
        }
        set initialGroups(a) {
            this.ml = a;
            this.g("InitialGroups");
        }
        get initialFilter() {
            return this.mk;
        }
        set initialFilter(a) {
            this.mk = a;
            this.g("InitialFilter");
        }
        get initialHighlightFilter() {
            return this.mm;
        }
        set initialHighlightFilter(a) {
            this.mm = a;
            this.g("InitialHighlightFilter");
        }
        get initialSummaries() {
            return this.mo;
        }
        set initialSummaries(a) {
            this.mo = a;
            this.g("InitialSummaries");
        }
        get dataSourceRef() {
            return this.ke;
        }
        set dataSourceRef(a) {
            this.ke = a;
            this.g("DataSourceRef");
        }
        get dataSource() {
            return this.bl;
        }
        set dataSource(a) {
            this.bl = a;
            this.g("DataSource");
        }
        get highlightedDataSourceRef() {
            return this.mb;
        }
        set highlightedDataSourceRef(a) {
            this.mb = a;
            this.g("HighlightedDataSourceRef");
        }
        get highlightedDataSource() {
            return this.bm;
        }
        set highlightedDataSource(a) {
            this.bm = a;
            this.g("HighlightedDataSource");
        }
        get includedProperties() {
            return this.x;
        }
        set includedProperties(a) {
            this.x = a;
            this.g("IncludedProperties");
        }
        get excludedProperties() {
            return this.r;
        }
        set excludedProperties(a) {
            this.r = a;
            this.g("ExcludedProperties");
        }
        get brushes() {
            return this.j;
        }
        set brushes(a) {
            this.j = a;
            this.g("Brushes");
        }
        get outlines() {
            return this.ah;
        }
        set outlines(a) {
            this.ah = a;
            this.g("Outlines");
        }
        get actualBrushes() {
            return this.h;
        }
        set actualBrushes(a) {
            this.h = a;
            this.g("ActualBrushes");
        }
        get actualOutlines() {
            return this.i;
        }
        set actualOutlines(a) {
            this.i = a;
            this.g("ActualOutlines");
        }
        get legendRef() {
            return this.ms;
        }
        set legendRef(a) {
            this.ms = a;
            this.g("LegendRef");
        }
        get isHorizontalZoomEnabled() {
            return this.b9;
        }
        set isHorizontalZoomEnabled(a) {
            this.b9 = a;
            this.g("IsHorizontalZoomEnabled");
        }
        get isVerticalZoomEnabled() {
            return this.cb;
        }
        set isVerticalZoomEnabled(a) {
            this.cb = a;
            this.g("IsVerticalZoomEnabled");
        }
        get shouldDisplayMockData() {
            return this.cd;
        }
        set shouldDisplayMockData(a) {
            this.cd = a;
            this.g("ShouldDisplayMockData");
        }
        get shouldUseSkeletonStyleForMockData() {
            return this.cf;
        }
        set shouldUseSkeletonStyleForMockData(a) {
            this.cf = a;
            this.g("ShouldUseSkeletonStyleForMockData");
        }
        get highlightedValuesDisplayMode() {
            return this.md;
        }
        set highlightedValuesDisplayMode(a) {
            this.md = a;
            this.g("HighlightedValuesDisplayMode");
        }
        get isSeriesHighlightingEnabled() {
            return this.ca;
        }
        set isSeriesHighlightingEnabled(a) {
            this.ca = a;
            this.g("IsSeriesHighlightingEnabled");
        }
        get highlightedLegendItemVisibility() {
            return this.mc;
        }
        set highlightedLegendItemVisibility(a) {
            this.mc = a;
            this.g("HighlightedLegendItemVisibility");
        }
        get windowRect() {
            return this.bp;
        }
        set windowRect(a) {
            this.bp = a;
            this.g("WindowRect");
        }
        get chartTitle() {
            return this.j5;
        }
        set chartTitle(a) {
            this.j5 = a;
            this.g("ChartTitle");
        }
        get subtitle() {
            return this.na;
        }
        set subtitle(a) {
            this.na = a;
            this.g("Subtitle");
        }
        get titleAlignment() {
            return this.ne;
        }
        set titleAlignment(a) {
            this.ne = a;
            this.g("TitleAlignment");
        }
        get subtitleAlignment() {
            return this.nb;
        }
        set subtitleAlignment(a) {
            this.nb = a;
            this.g("SubtitleAlignment");
        }
        get unknownValuePlotting() {
            return this.nk;
        }
        set unknownValuePlotting(a) {
            this.nk = a;
            this.g("UnknownValuePlotting");
        }
        get resolution() {
            return this.fj;
        }
        set resolution(a) {
            this.fj = a;
            this.g("Resolution");
        }
        get thickness() {
            return this.fp;
        }
        set thickness(a) {
            this.fp = a;
            this.g("Thickness");
        }
        get outlineMode() {
            return this.mw;
        }
        set outlineMode(a) {
            this.mw = a;
            this.g("OutlineMode");
        }
        get markerOutlineMode() {
            return this.mv;
        }
        set markerOutlineMode(a) {
            this.mv = a;
            this.g("MarkerOutlineMode");
        }
        get markerFillMode() {
            return this.mu;
        }
        set markerFillMode(a) {
            this.mu = a;
            this.g("MarkerFillMode");
        }
        get markerFillOpacity() {
            return this.fc;
        }
        set markerFillOpacity(a) {
            this.fc = a;
            this.g("MarkerFillOpacity");
        }
        get markerThickness() {
            return this.fd;
        }
        set markerThickness(a) {
            this.fd = a;
            this.g("MarkerThickness");
        }
        get markerTypes() {
            return this.ag;
        }
        set markerTypes(a) {
            this.ag = a;
            this.g("MarkerTypes");
        }
        get markerAutomaticBehavior() {
            return this.mt;
        }
        set markerAutomaticBehavior(a) {
            this.mt = a;
            this.g("MarkerAutomaticBehavior");
        }
        get markerBrushes() {
            return this.ae;
        }
        set markerBrushes(a) {
            this.ae = a;
            this.g("MarkerBrushes");
        }
        get markerOutlines() {
            return this.af;
        }
        set markerOutlines(a) {
            this.af = a;
            this.g("MarkerOutlines");
        }
        get markerMaxCount() {
            return this.jg;
        }
        set markerMaxCount(a) {
            this.jg = a;
            this.g("MarkerMaxCount");
        }
        get areaFillOpacity() {
            return this.c9;
        }
        set areaFillOpacity(a) {
            this.c9 = a;
            this.g("AreaFillOpacity");
        }
        get animateSeriesWhenAxisRangeChanges() {
            return this.bs;
        }
        set animateSeriesWhenAxisRangeChanges(a) {
            this.bs = a;
            this.g("AnimateSeriesWhenAxisRangeChanges");
        }
        get trendLineBrushes() {
            return this.al;
        }
        set trendLineBrushes(a) {
            this.al = a;
            this.g("TrendLineBrushes");
        }
        get trendLineType() {
            return this.nj;
        }
        set trendLineType(a) {
            this.nj = a;
            this.g("TrendLineType");
        }
        get trendLineThickness() {
            return this.fv;
        }
        set trendLineThickness(a) {
            this.fv = a;
            this.g("TrendLineThickness");
        }
        get alignsGridLinesToPixels() {
            return this.br;
        }
        set alignsGridLinesToPixels(a) {
            this.br = a;
            this.g("AlignsGridLinesToPixels");
        }
        get plotAreaMarginLeft() {
            return this.fg;
        }
        set plotAreaMarginLeft(a) {
            this.fg = a;
            this.g("PlotAreaMarginLeft");
        }
        get plotAreaMarginTop() {
            return this.fi;
        }
        set plotAreaMarginTop(a) {
            this.fi = a;
            this.g("PlotAreaMarginTop");
        }
        get plotAreaMarginRight() {
            return this.fh;
        }
        set plotAreaMarginRight(a) {
            this.fh = a;
            this.g("PlotAreaMarginRight");
        }
        get plotAreaMarginBottom() {
            return this.ff;
        }
        set plotAreaMarginBottom(a) {
            this.ff = a;
            this.g("PlotAreaMarginBottom");
        }
        get computedPlotAreaMarginMode() {
            return this.j6;
        }
        set computedPlotAreaMarginMode(a) {
            this.j6 = a;
            this.g("ComputedPlotAreaMarginMode");
        }
        get seriesPlotAreaMarginHorizontalMode() {
            return this.m2;
        }
        set seriesPlotAreaMarginHorizontalMode(a) {
            this.m2 = a;
            this.g("SeriesPlotAreaMarginHorizontalMode");
        }
        get seriesPlotAreaMarginVerticalMode() {
            return this.m3;
        }
        set seriesPlotAreaMarginVerticalMode(a) {
            this.m3 = a;
            this.g("SeriesPlotAreaMarginVerticalMode");
        }
        get highlightingMode() {
            return this.mf;
        }
        set highlightingMode(a) {
            this.mf = a;
            this.g("HighlightingMode");
        }
        get highlightingBehavior() {
            return this.me;
        }
        set highlightingBehavior(a) {
            this.me = a;
            this.g("HighlightingBehavior");
        }
        get legendHighlightingMode() {
            return this.mp;
        }
        set legendHighlightingMode(a) {
            this.mp = a;
            this.g("LegendHighlightingMode");
        }
        get legendItemBadgeShape() {
            return this.mr;
        }
        set legendItemBadgeShape(a) {
            this.mr = a;
            this.g("LegendItemBadgeShape");
        }
        get legendItemBadgeMode() {
            return this.mq;
        }
        set legendItemBadgeMode(a) {
            this.mq = a;
            this.g("LegendItemBadgeMode");
        }
        get trendLinePeriod() {
            return this.jj;
        }
        set trendLinePeriod(a) {
            this.jj = a;
            this.g("TrendLinePeriod");
        }
        get toolTipType() {
            return this.nh;
        }
        set toolTipType(a) {
            this.nh = a;
            this.g("ToolTipType");
        }
        get crosshairsDisplayMode() {
            return this.kb;
        }
        set crosshairsDisplayMode(a) {
            this.kb = a;
            this.g("CrosshairsDisplayMode");
        }
        get crosshairsSnapToData() {
            return this.b0;
        }
        set crosshairsSnapToData(a) {
            this.b0 = a;
            this.g("CrosshairsSnapToData");
        }
        get crosshairsLineVerticalStroke() {
            return this.kd;
        }
        set crosshairsLineVerticalStroke(a) {
            this.kd = a;
            this.g("CrosshairsLineVerticalStroke");
        }
        get crosshairsLineThickness() {
            return this.dc;
        }
        set crosshairsLineThickness(a) {
            this.dc = a;
            this.g("CrosshairsLineThickness");
        }
        get crosshairsLineHorizontalStroke() {
            return this.kc;
        }
        set crosshairsLineHorizontalStroke(a) {
            this.kc = a;
            this.g("CrosshairsLineHorizontalStroke");
        }
        get crosshairsAnnotationEnabled() {
            return this.bz;
        }
        set crosshairsAnnotationEnabled(a) {
            this.bz = a;
            this.g("CrosshairsAnnotationEnabled");
        }
        get crosshairsAnnotationXAxisBackground() {
            return this.j7;
        }
        set crosshairsAnnotationXAxisBackground(a) {
            this.j7 = a;
            this.g("CrosshairsAnnotationXAxisBackground");
        }
        get crosshairsAnnotationYAxisBackground() {
            return this.j9;
        }
        set crosshairsAnnotationYAxisBackground(a) {
            this.j9 = a;
            this.g("CrosshairsAnnotationYAxisBackground");
        }
        get crosshairsAnnotationXAxisTextColor() {
            return this.j8;
        }
        set crosshairsAnnotationXAxisTextColor(a) {
            this.j8 = a;
            this.g("CrosshairsAnnotationXAxisTextColor");
        }
        get crosshairsAnnotationYAxisTextColor() {
            return this.ka;
        }
        set crosshairsAnnotationYAxisTextColor(a) {
            this.ka = a;
            this.g("CrosshairsAnnotationYAxisTextColor");
        }
        get crosshairsAnnotationXAxisPrecision() {
            return this.i9;
        }
        set crosshairsAnnotationXAxisPrecision(a) {
            this.i9 = a;
            this.g("CrosshairsAnnotationXAxisPrecision");
        }
        get crosshairsAnnotationYAxisPrecision() {
            return this.ja;
        }
        set crosshairsAnnotationYAxisPrecision(a) {
            this.ja = a;
            this.g("CrosshairsAnnotationYAxisPrecision");
        }
        get shouldAvoidAxisAnnotationCollisions() {
            return this.cc;
        }
        set shouldAvoidAxisAnnotationCollisions(a) {
            this.cc = a;
            this.g("ShouldAvoidAxisAnnotationCollisions");
        }
        get shouldPanOnMaximumZoom() {
            return this.ce;
        }
        set shouldPanOnMaximumZoom(a) {
            this.ce = a;
            this.g("ShouldPanOnMaximumZoom");
        }
        get finalValueAnnotationsVisible() {
            return this.b7;
        }
        set finalValueAnnotationsVisible(a) {
            this.b7 = a;
            this.g("FinalValueAnnotationsVisible");
        }
        get finalValueAnnotationsBackground() {
            return this.l5;
        }
        set finalValueAnnotationsBackground(a) {
            this.l5 = a;
            this.g("FinalValueAnnotationsBackground");
        }
        get finalValueAnnotationsTextColor() {
            return this.l6;
        }
        set finalValueAnnotationsTextColor(a) {
            this.l6 = a;
            this.g("FinalValueAnnotationsTextColor");
        }
        get finalValueAnnotationsPrecision() {
            return this.jd;
        }
        set finalValueAnnotationsPrecision(a) {
            this.jd = a;
            this.g("FinalValueAnnotationsPrecision");
        }
        get autoCalloutsVisible() {
            return this.bt;
        }
        set autoCalloutsVisible(a) {
            this.bt = a;
            this.g("AutoCalloutsVisible");
        }
        get calloutsVisible() {
            return this.by;
        }
        set calloutsVisible(a) {
            this.by = a;
            this.g("CalloutsVisible");
        }
        get calloutStyleUpdatingEventEnabled() {
            return this.bu;
        }
        set calloutStyleUpdatingEventEnabled(a) {
            this.bu = a;
            this.g("CalloutStyleUpdatingEventEnabled");
        }
        get useValueForAutoCalloutLabels() {
            return this.cg;
        }
        set useValueForAutoCalloutLabels(a) {
            this.cg = a;
            this.g("UseValueForAutoCalloutLabels");
        }
        get calloutCollisionMode() {
            return this.jw;
        }
        set calloutCollisionMode(a) {
            this.jw = a;
            this.g("CalloutCollisionMode");
        }
        get calloutsUseItemColorForFill() {
            return this.bw;
        }
        set calloutsUseItemColorForFill(a) {
            this.bw = a;
            this.g("CalloutsUseItemColorForFill");
        }
        get calloutsUseItemColorForOutline() {
            return this.bx;
        }
        set calloutsUseItemColorForOutline(a) {
            this.bx = a;
            this.g("CalloutsUseItemColorForOutline");
        }
        get calloutsUseAutoContrastingLabelColors() {
            return this.bv;
        }
        set calloutsUseAutoContrastingLabelColors(a) {
            this.bv = a;
            this.g("CalloutsUseAutoContrastingLabelColors");
        }
        get calloutsStrokeThickness() {
            return this.db;
        }
        set calloutsStrokeThickness(a) {
            this.db = a;
            this.g("CalloutsStrokeThickness");
        }
        get calloutsBackground() {
            return this.jy;
        }
        set calloutsBackground(a) {
            this.jy = a;
            this.g("CalloutsBackground");
        }
        get calloutsAutoLabelPrecision() {
            return this.i8;
        }
        set calloutsAutoLabelPrecision(a) {
            this.i8 = a;
            this.g("CalloutsAutoLabelPrecision");
        }
        get calloutsDataSourceRef() {
            return this.j0;
        }
        set calloutsDataSourceRef(a) {
            this.j0 = a;
            this.g("CalloutsDataSourceRef");
        }
        get calloutsAllowedPositions() {
            return this.k;
        }
        set calloutsAllowedPositions(a) {
            this.k = a;
            this.g("CalloutsAllowedPositions");
        }
        get calloutsXMemberPath() {
            return this.j3;
        }
        set calloutsXMemberPath(a) {
            this.j3 = a;
            this.g("CalloutsXMemberPath");
        }
        get calloutsYMemberPath() {
            return this.j4;
        }
        set calloutsYMemberPath(a) {
            this.j4 = a;
            this.g("CalloutsYMemberPath");
        }
        get calloutsLabelMemberPath() {
            return this.j1;
        }
        set calloutsLabelMemberPath(a) {
            this.j1 = a;
            this.g("CalloutsLabelMemberPath");
        }
        get calloutsContentMemberPath() {
            return this.jz;
        }
        set calloutsContentMemberPath(a) {
            this.jz = a;
            this.g("CalloutsContentMemberPath");
        }
        get valueLines() {
            return this.am;
        }
        set valueLines(a) {
            this.am = a;
            this.g("ValueLines");
        }
        get valueLinesBrushes() {
            return this.an;
        }
        set valueLinesBrushes(a) {
            this.an = a;
            this.g("ValueLinesBrushes");
        }
        get valueLinesThickness() {
            return this.fw;
        }
        set valueLinesThickness(a) {
            this.fw = a;
            this.g("ValueLinesThickness");
        }
        get horizontalViewScrollbarMode() {
            return this.mh;
        }
        set horizontalViewScrollbarMode(a) {
            this.mh = a;
            this.g("HorizontalViewScrollbarMode");
        }
        get verticalViewScrollbarMode() {
            return this.nm;
        }
        set verticalViewScrollbarMode(a) {
            this.nm = a;
            this.g("VerticalViewScrollbarMode");
        }
        get horizontalViewScrollbarPosition() {
            return this.mj;
        }
        set horizontalViewScrollbarPosition(a) {
            this.mj = a;
            this.g("HorizontalViewScrollbarPosition");
        }
        get verticalViewScrollbarPosition() {
            return this.no;
        }
        set verticalViewScrollbarPosition(a) {
            this.no = a;
            this.g("VerticalViewScrollbarPosition");
        }
        get horizontalViewScrollbarFill() {
            return this.mg;
        }
        set horizontalViewScrollbarFill(a) {
            this.mg = a;
            this.g("HorizontalViewScrollbarFill");
        }
        get horizontalViewScrollbarOutline() {
            return this.mi;
        }
        set horizontalViewScrollbarOutline(a) {
            this.mi = a;
            this.g("HorizontalViewScrollbarOutline");
        }
        get horizontalViewScrollbarStrokeThickness() {
            return this.e8;
        }
        set horizontalViewScrollbarStrokeThickness(a) {
            this.e8 = a;
            this.g("HorizontalViewScrollbarStrokeThickness");
        }
        get horizontalViewScrollbarMaxOpacity() {
            return this.e7;
        }
        set horizontalViewScrollbarMaxOpacity(a) {
            this.e7 = a;
            this.g("HorizontalViewScrollbarMaxOpacity");
        }
        get horizontalViewScrollbarCornerRadius() {
            return this.e4;
        }
        set horizontalViewScrollbarCornerRadius(a) {
            this.e4 = a;
            this.g("HorizontalViewScrollbarCornerRadius");
        }
        get horizontalViewScrollbarHeight() {
            return this.e5;
        }
        set horizontalViewScrollbarHeight(a) {
            this.e5 = a;
            this.g("HorizontalViewScrollbarHeight");
        }
        get horizontalViewScrollbarInset() {
            return this.e6;
        }
        set horizontalViewScrollbarInset(a) {
            this.e6 = a;
            this.g("HorizontalViewScrollbarInset");
        }
        get horizontalViewScrollbarTrackStartInset() {
            return this.fa;
        }
        set horizontalViewScrollbarTrackStartInset(a) {
            this.fa = a;
            this.g("HorizontalViewScrollbarTrackStartInset");
        }
        get horizontalViewScrollbarTrackEndInset() {
            return this.e9;
        }
        set horizontalViewScrollbarTrackEndInset(a) {
            this.e9 = a;
            this.g("HorizontalViewScrollbarTrackEndInset");
        }
        get horizontalViewScrollbarShouldAddAutoTrackInsets() {
            return this.b8;
        }
        set horizontalViewScrollbarShouldAddAutoTrackInsets(a) {
            this.b8 = a;
            this.g("HorizontalViewScrollbarShouldAddAutoTrackInsets");
        }
        get verticalViewScrollbarFill() {
            return this.nl;
        }
        set verticalViewScrollbarFill(a) {
            this.nl = a;
            this.g("VerticalViewScrollbarFill");
        }
        get verticalViewScrollbarOutline() {
            return this.nn;
        }
        set verticalViewScrollbarOutline(a) {
            this.nn = a;
            this.g("VerticalViewScrollbarOutline");
        }
        get verticalViewScrollbarStrokeThickness() {
            return this.f0;
        }
        set verticalViewScrollbarStrokeThickness(a) {
            this.f0 = a;
            this.g("VerticalViewScrollbarStrokeThickness");
        }
        get verticalViewScrollbarMaxOpacity() {
            return this.fz;
        }
        set verticalViewScrollbarMaxOpacity(a) {
            this.fz = a;
            this.g("VerticalViewScrollbarMaxOpacity");
        }
        get verticalViewScrollbarCornerRadius() {
            return this.fx;
        }
        set verticalViewScrollbarCornerRadius(a) {
            this.fx = a;
            this.g("VerticalViewScrollbarCornerRadius");
        }
        get verticalViewScrollbarWidth() {
            return this.f3;
        }
        set verticalViewScrollbarWidth(a) {
            this.f3 = a;
            this.g("VerticalViewScrollbarWidth");
        }
        get verticalViewScrollbarInset() {
            return this.fy;
        }
        set verticalViewScrollbarInset(a) {
            this.fy = a;
            this.g("VerticalViewScrollbarInset");
        }
        get verticalViewScrollbarTrackStartInset() {
            return this.f2;
        }
        set verticalViewScrollbarTrackStartInset(a) {
            this.f2 = a;
            this.g("VerticalViewScrollbarTrackStartInset");
        }
        get verticalViewScrollbarTrackEndInset() {
            return this.f1;
        }
        set verticalViewScrollbarTrackEndInset(a) {
            this.f1 = a;
            this.g("VerticalViewScrollbarTrackEndInset");
        }
        get verticalViewScrollbarShouldAddAutoTrackInsets() {
            return this.ch;
        }
        set verticalViewScrollbarShouldAddAutoTrackInsets(a) {
            this.ch = a;
            this.g("VerticalViewScrollbarShouldAddAutoTrackInsets");
        }
        get windowRectMinWidth() {
            return this.f5;
        }
        set windowRectMinWidth(a) {
            this.f5 = a;
            this.g("WindowRectMinWidth");
        }
        get windowRectMinHeight() {
            return this.f4;
        }
        set windowRectMinHeight(a) {
            this.f4 = a;
            this.g("WindowRectMinHeight");
        }
        get windowSizeMinWidth() {
            return this.f7;
        }
        set windowSizeMinWidth(a) {
            this.f7 = a;
            this.g("WindowSizeMinWidth");
        }
        get windowSizeMinHeight() {
            return this.f6;
        }
        set windowSizeMinHeight(a) {
            this.f6 = a;
            this.g("WindowSizeMinHeight");
        }
        get seriesAddedRef() {
            return this.m1;
        }
        set seriesAddedRef(a) {
            this.m1 = a;
            this.g("SeriesAddedRef");
        }
        get seriesRemovedRef() {
            return this.m9;
        }
        set seriesRemovedRef(a) {
            this.m9 = a;
            this.g("SeriesRemovedRef");
        }
        get seriesPointerEnterRef() {
            return this.m5;
        }
        set seriesPointerEnterRef(a) {
            this.m5 = a;
            this.g("SeriesPointerEnterRef");
        }
        get seriesPointerLeaveRef() {
            return this.m6;
        }
        set seriesPointerLeaveRef(a) {
            this.m6 = a;
            this.g("SeriesPointerLeaveRef");
        }
        get seriesPointerMoveRef() {
            return this.m7;
        }
        set seriesPointerMoveRef(a) {
            this.m7 = a;
            this.g("SeriesPointerMoveRef");
        }
        get seriesPointerDownRef() {
            return this.m4;
        }
        set seriesPointerDownRef(a) {
            this.m4 = a;
            this.g("SeriesPointerDownRef");
        }
        get seriesPointerUpRef() {
            return this.m8;
        }
        set seriesPointerUpRef(a) {
            this.m8 = a;
            this.g("SeriesPointerUpRef");
        }
        get calloutStyleUpdatingRef() {
            return this.j2;
        }
        set calloutStyleUpdatingRef(a) {
            this.j2 = a;
            this.g("CalloutStyleUpdatingRef");
        }
        get calloutRenderStyleUpdatingRef() {
            return this.jx;
        }
        set calloutRenderStyleUpdatingRef(a) {
            this.jx = a;
            this.g("CalloutRenderStyleUpdatingRef");
        }
        get selectedSeriesItemsChangedRef() {
            return this.mx;
        }
        set selectedSeriesItemsChangedRef(a) {
            this.mx = a;
            this.g("SelectedSeriesItemsChangedRef");
        }
        get focusedSeriesItemsChangedRef() {
            return this.l8;
        }
        set focusedSeriesItemsChangedRef(a) {
            this.l8 = a;
            this.g("FocusedSeriesItemsChangedRef");
        }
        get filterStringErrorsParsingRef() {
            return this.l4;
        }
        set filterStringErrorsParsingRef(a) {
            this.l4 = a;
            this.g("FilterStringErrorsParsingRef");
        }
    }
    DomainChartDescription.$t = /*@__PURE__*/ markType(DomainChartDescription, 'DomainChartDescription', Description.$);
    return DomainChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XYChartDescription = /*@__PURE__*/ (() => {
    class XYChartDescription extends DomainChartDescription {
        get_type() {
            return "XYChart";
        }
        constructor() {
            super();
            this.tp = null;
            this.t7 = null;
            this.ru = 0;
            this.rw = 0;
            this.rv = 0;
            this.rt = 0;
            this.sb = 0;
            this.sd = 0;
            this.sc = 0;
            this.sa = 0;
            this.tu = null;
            this.uc = null;
            this.tn = null;
            this.to = null;
            this.r5 = 0;
            this.sm = 0;
            this.r4 = 0;
            this.sl = 0;
            this.r7 = 0;
            this.so = 0;
            this.r6 = 0;
            this.sn = 0;
            this.r3 = 0;
            this.sk = 0;
            this.t5 = null;
            this.un = null;
            this.tv = null;
            this.ud = null;
            this.t6 = null;
            this.uo = null;
            this.tt = null;
            this.ub = null;
            this.ty = null;
            this.ug = null;
            this.rx = 0;
            this.se = 0;
            this.ry = 0;
            this.sf = 0;
            this.t0 = null;
            this.ui = null;
            this.t1 = null;
            this.uj = null;
            this.rz = 0;
            this.sg = 0;
            this.r0 = 0;
            this.sh = 0;
            this.t2 = null;
            this.uk = null;
            this.r1 = 0;
            this.si = 0;
            this.t3 = null;
            this.ul = null;
            this.tz = null;
            this.uh = null;
            this.rs = 0;
            this.r9 = 0;
            this.rr = 0;
            this.r8 = 0;
            this.r2 = 0;
            this.sj = 0;
            this.rn = false;
            this.ro = false;
            this.t4 = null;
            this.um = null;
            this.tr = null;
            this.t9 = null;
            this.tw = null;
            this.ue = null;
            this.tx = null;
            this.uf = null;
            this.ua = null;
            this.ts = null;
            this.tq = null;
            this.rj = null;
            this.t8 = null;
            this.rk = null;
        }
        get xAxisFormatLabelRef() {
            return this.tp;
        }
        set xAxisFormatLabelRef(a) {
            this.tp = a;
            this.g("XAxisFormatLabelRef");
        }
        get yAxisFormatLabelRef() {
            return this.t7;
        }
        set yAxisFormatLabelRef(a) {
            this.t7 = a;
            this.g("YAxisFormatLabelRef");
        }
        get xAxisLabelLeftMargin() {
            return this.ru;
        }
        set xAxisLabelLeftMargin(a) {
            this.ru = a;
            this.g("XAxisLabelLeftMargin");
        }
        get xAxisLabelTopMargin() {
            return this.rw;
        }
        set xAxisLabelTopMargin(a) {
            this.rw = a;
            this.g("XAxisLabelTopMargin");
        }
        get xAxisLabelRightMargin() {
            return this.rv;
        }
        set xAxisLabelRightMargin(a) {
            this.rv = a;
            this.g("XAxisLabelRightMargin");
        }
        get xAxisLabelBottomMargin() {
            return this.rt;
        }
        set xAxisLabelBottomMargin(a) {
            this.rt = a;
            this.g("XAxisLabelBottomMargin");
        }
        get yAxisLabelLeftMargin() {
            return this.sb;
        }
        set yAxisLabelLeftMargin(a) {
            this.sb = a;
            this.g("YAxisLabelLeftMargin");
        }
        get yAxisLabelTopMargin() {
            return this.sd;
        }
        set yAxisLabelTopMargin(a) {
            this.sd = a;
            this.g("YAxisLabelTopMargin");
        }
        get yAxisLabelRightMargin() {
            return this.sc;
        }
        set yAxisLabelRightMargin(a) {
            this.sc = a;
            this.g("YAxisLabelRightMargin");
        }
        get yAxisLabelBottomMargin() {
            return this.sa;
        }
        set yAxisLabelBottomMargin(a) {
            this.sa = a;
            this.g("YAxisLabelBottomMargin");
        }
        get xAxisLabelTextColor() {
            return this.tu;
        }
        set xAxisLabelTextColor(a) {
            this.tu = a;
            this.g("XAxisLabelTextColor");
        }
        get yAxisLabelTextColor() {
            return this.uc;
        }
        set yAxisLabelTextColor(a) {
            this.uc = a;
            this.g("YAxisLabelTextColor");
        }
        get actualXAxisLabelTextColor() {
            return this.tn;
        }
        set actualXAxisLabelTextColor(a) {
            this.tn = a;
            this.g("ActualXAxisLabelTextColor");
        }
        get actualYAxisLabelTextColor() {
            return this.to;
        }
        set actualYAxisLabelTextColor(a) {
            this.to = a;
            this.g("ActualYAxisLabelTextColor");
        }
        get xAxisTitleMargin() {
            return this.r5;
        }
        set xAxisTitleMargin(a) {
            this.r5 = a;
            this.g("XAxisTitleMargin");
        }
        get yAxisTitleMargin() {
            return this.sm;
        }
        set yAxisTitleMargin(a) {
            this.sm = a;
            this.g("YAxisTitleMargin");
        }
        get xAxisTitleLeftMargin() {
            return this.r4;
        }
        set xAxisTitleLeftMargin(a) {
            this.r4 = a;
            this.g("XAxisTitleLeftMargin");
        }
        get yAxisTitleLeftMargin() {
            return this.sl;
        }
        set yAxisTitleLeftMargin(a) {
            this.sl = a;
            this.g("YAxisTitleLeftMargin");
        }
        get xAxisTitleTopMargin() {
            return this.r7;
        }
        set xAxisTitleTopMargin(a) {
            this.r7 = a;
            this.g("XAxisTitleTopMargin");
        }
        get yAxisTitleTopMargin() {
            return this.so;
        }
        set yAxisTitleTopMargin(a) {
            this.so = a;
            this.g("YAxisTitleTopMargin");
        }
        get xAxisTitleRightMargin() {
            return this.r6;
        }
        set xAxisTitleRightMargin(a) {
            this.r6 = a;
            this.g("XAxisTitleRightMargin");
        }
        get yAxisTitleRightMargin() {
            return this.sn;
        }
        set yAxisTitleRightMargin(a) {
            this.sn = a;
            this.g("YAxisTitleRightMargin");
        }
        get xAxisTitleBottomMargin() {
            return this.r3;
        }
        set xAxisTitleBottomMargin(a) {
            this.r3 = a;
            this.g("XAxisTitleBottomMargin");
        }
        get yAxisTitleBottomMargin() {
            return this.sk;
        }
        set yAxisTitleBottomMargin(a) {
            this.sk = a;
            this.g("YAxisTitleBottomMargin");
        }
        get xAxisTitleTextColor() {
            return this.t5;
        }
        set xAxisTitleTextColor(a) {
            this.t5 = a;
            this.g("XAxisTitleTextColor");
        }
        get yAxisTitleTextColor() {
            return this.un;
        }
        set yAxisTitleTextColor(a) {
            this.un = a;
            this.g("YAxisTitleTextColor");
        }
        get xAxisLabelTextStyle() {
            return this.tv;
        }
        set xAxisLabelTextStyle(a) {
            this.tv = a;
            this.g("XAxisLabelTextStyle");
        }
        get yAxisLabelTextStyle() {
            return this.ud;
        }
        set yAxisLabelTextStyle(a) {
            this.ud = a;
            this.g("YAxisLabelTextStyle");
        }
        get xAxisTitleTextStyle() {
            return this.t6;
        }
        set xAxisTitleTextStyle(a) {
            this.t6 = a;
            this.g("XAxisTitleTextStyle");
        }
        get yAxisTitleTextStyle() {
            return this.uo;
        }
        set yAxisTitleTextStyle(a) {
            this.uo = a;
            this.g("YAxisTitleTextStyle");
        }
        get xAxisLabelRef() {
            return this.tt;
        }
        set xAxisLabelRef(a) {
            this.tt = a;
            this.g("XAxisLabelRef");
        }
        get yAxisLabelRef() {
            return this.ub;
        }
        set yAxisLabelRef(a) {
            this.ub = a;
            this.g("YAxisLabelRef");
        }
        get xAxisMajorStroke() {
            return this.ty;
        }
        set xAxisMajorStroke(a) {
            this.ty = a;
            this.g("XAxisMajorStroke");
        }
        get yAxisMajorStroke() {
            return this.ug;
        }
        set yAxisMajorStroke(a) {
            this.ug = a;
            this.g("YAxisMajorStroke");
        }
        get xAxisMajorStrokeThickness() {
            return this.rx;
        }
        set xAxisMajorStrokeThickness(a) {
            this.rx = a;
            this.g("XAxisMajorStrokeThickness");
        }
        get yAxisMajorStrokeThickness() {
            return this.se;
        }
        set yAxisMajorStrokeThickness(a) {
            this.se = a;
            this.g("YAxisMajorStrokeThickness");
        }
        get xAxisMinorStrokeThickness() {
            return this.ry;
        }
        set xAxisMinorStrokeThickness(a) {
            this.ry = a;
            this.g("XAxisMinorStrokeThickness");
        }
        get yAxisMinorStrokeThickness() {
            return this.sf;
        }
        set yAxisMinorStrokeThickness(a) {
            this.sf = a;
            this.g("YAxisMinorStrokeThickness");
        }
        get xAxisStrip() {
            return this.t0;
        }
        set xAxisStrip(a) {
            this.t0 = a;
            this.g("XAxisStrip");
        }
        get yAxisStrip() {
            return this.ui;
        }
        set yAxisStrip(a) {
            this.ui = a;
            this.g("YAxisStrip");
        }
        get xAxisStroke() {
            return this.t1;
        }
        set xAxisStroke(a) {
            this.t1 = a;
            this.g("XAxisStroke");
        }
        get yAxisStroke() {
            return this.uj;
        }
        set yAxisStroke(a) {
            this.uj = a;
            this.g("YAxisStroke");
        }
        get xAxisStrokeThickness() {
            return this.rz;
        }
        set xAxisStrokeThickness(a) {
            this.rz = a;
            this.g("XAxisStrokeThickness");
        }
        get yAxisStrokeThickness() {
            return this.sg;
        }
        set yAxisStrokeThickness(a) {
            this.sg = a;
            this.g("YAxisStrokeThickness");
        }
        get xAxisTickLength() {
            return this.r0;
        }
        set xAxisTickLength(a) {
            this.r0 = a;
            this.g("XAxisTickLength");
        }
        get yAxisTickLength() {
            return this.sh;
        }
        set yAxisTickLength(a) {
            this.sh = a;
            this.g("YAxisTickLength");
        }
        get xAxisTickStroke() {
            return this.t2;
        }
        set xAxisTickStroke(a) {
            this.t2 = a;
            this.g("XAxisTickStroke");
        }
        get yAxisTickStroke() {
            return this.uk;
        }
        set yAxisTickStroke(a) {
            this.uk = a;
            this.g("YAxisTickStroke");
        }
        get xAxisTickStrokeThickness() {
            return this.r1;
        }
        set xAxisTickStrokeThickness(a) {
            this.r1 = a;
            this.g("XAxisTickStrokeThickness");
        }
        get yAxisTickStrokeThickness() {
            return this.si;
        }
        set yAxisTickStrokeThickness(a) {
            this.si = a;
            this.g("YAxisTickStrokeThickness");
        }
        get xAxisTitle() {
            return this.t3;
        }
        set xAxisTitle(a) {
            this.t3 = a;
            this.g("XAxisTitle");
        }
        get yAxisTitle() {
            return this.ul;
        }
        set yAxisTitle(a) {
            this.ul = a;
            this.g("YAxisTitle");
        }
        get xAxisMinorStroke() {
            return this.tz;
        }
        set xAxisMinorStroke(a) {
            this.tz = a;
            this.g("XAxisMinorStroke");
        }
        get yAxisMinorStroke() {
            return this.uh;
        }
        set yAxisMinorStroke(a) {
            this.uh = a;
            this.g("YAxisMinorStroke");
        }
        get xAxisLabelAngle() {
            return this.rs;
        }
        set xAxisLabelAngle(a) {
            this.rs = a;
            this.g("XAxisLabelAngle");
        }
        get yAxisLabelAngle() {
            return this.r9;
        }
        set yAxisLabelAngle(a) {
            this.r9 = a;
            this.g("YAxisLabelAngle");
        }
        get xAxisExtent() {
            return this.rr;
        }
        set xAxisExtent(a) {
            this.rr = a;
            this.g("XAxisExtent");
        }
        get yAxisExtent() {
            return this.r8;
        }
        set yAxisExtent(a) {
            this.r8 = a;
            this.g("YAxisExtent");
        }
        get xAxisTitleAngle() {
            return this.r2;
        }
        set xAxisTitleAngle(a) {
            this.r2 = a;
            this.g("XAxisTitleAngle");
        }
        get yAxisTitleAngle() {
            return this.sj;
        }
        set yAxisTitleAngle(a) {
            this.sj = a;
            this.g("YAxisTitleAngle");
        }
        get xAxisInverted() {
            return this.rn;
        }
        set xAxisInverted(a) {
            this.rn = a;
            this.g("XAxisInverted");
        }
        get yAxisInverted() {
            return this.ro;
        }
        set yAxisInverted(a) {
            this.ro = a;
            this.g("YAxisInverted");
        }
        get xAxisTitleAlignment() {
            return this.t4;
        }
        set xAxisTitleAlignment(a) {
            this.t4 = a;
            this.g("XAxisTitleAlignment");
        }
        get yAxisTitleAlignment() {
            return this.um;
        }
        set yAxisTitleAlignment(a) {
            this.um = a;
            this.g("YAxisTitleAlignment");
        }
        get xAxisLabelHorizontalAlignment() {
            return this.tr;
        }
        set xAxisLabelHorizontalAlignment(a) {
            this.tr = a;
            this.g("XAxisLabelHorizontalAlignment");
        }
        get yAxisLabelHorizontalAlignment() {
            return this.t9;
        }
        set yAxisLabelHorizontalAlignment(a) {
            this.t9 = a;
            this.g("YAxisLabelHorizontalAlignment");
        }
        get xAxisLabelVerticalAlignment() {
            return this.tw;
        }
        set xAxisLabelVerticalAlignment(a) {
            this.tw = a;
            this.g("XAxisLabelVerticalAlignment");
        }
        get yAxisLabelVerticalAlignment() {
            return this.ue;
        }
        set yAxisLabelVerticalAlignment(a) {
            this.ue = a;
            this.g("YAxisLabelVerticalAlignment");
        }
        get xAxisLabelVisibility() {
            return this.tx;
        }
        set xAxisLabelVisibility(a) {
            this.tx = a;
            this.g("XAxisLabelVisibility");
        }
        get yAxisLabelVisibility() {
            return this.uf;
        }
        set yAxisLabelVisibility(a) {
            this.uf = a;
            this.g("YAxisLabelVisibility");
        }
        get yAxisLabelLocation() {
            return this.ua;
        }
        set yAxisLabelLocation(a) {
            this.ua = a;
            this.g("YAxisLabelLocation");
        }
        get xAxisLabelLocation() {
            return this.ts;
        }
        set xAxisLabelLocation(a) {
            this.ts = a;
            this.g("XAxisLabelLocation");
        }
        get xAxisLabelFormat() {
            return this.tq;
        }
        set xAxisLabelFormat(a) {
            this.tq = a;
            this.g("XAxisLabelFormat");
        }
        get xAxisLabelFormatSpecifiers() {
            return this.rj;
        }
        set xAxisLabelFormatSpecifiers(a) {
            this.rj = a;
            this.g("XAxisLabelFormatSpecifiers");
        }
        get yAxisLabelFormat() {
            return this.t8;
        }
        set yAxisLabelFormat(a) {
            this.t8 = a;
            this.g("YAxisLabelFormat");
        }
        get yAxisLabelFormatSpecifiers() {
            return this.rk;
        }
        set yAxisLabelFormatSpecifiers(a) {
            this.rk = a;
            this.g("YAxisLabelFormatSpecifiers");
        }
    }
    XYChartDescription.$t = /*@__PURE__*/ markType(XYChartDescription, 'XYChartDescription', DomainChartDescription.$);
    return XYChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryChartDescription = /*@__PURE__*/ (() => {
    class CategoryChartDescription extends XYChartDescription {
        get tooltipTemplateRef() {
            return this.xq;
        }
        set tooltipTemplateRef(a) {
            this.xq = a;
            this.g("TooltipTemplateRef");
        }
        get width() {
            return this.xv;
        }
        set width(a) {
            this.xv = a;
            this.g("Width");
        }
        get height() {
            return this.xo;
        }
        set height(a) {
            this.xo = a;
            this.g("Height");
        }
        get background() {
            return this.xm;
        }
        set background(a) {
            this.xm = a;
            this.g("Background");
        }
        get_type() {
            return "CategoryChart";
        }
        constructor() {
            super();
            this.xq = null;
            this.xv = null;
            this.xo = null;
            this.xm = null;
            this.xf = 0;
            this.xg = 0;
            this.xr = null;
            this.xu = null;
            this.xn = null;
            this.xp = null;
            this.vx = false;
            this.vy = false;
            this.xs = null;
            this.xt = null;
            this.wk = 0;
            this.wn = 0;
            this.wj = 0;
            this.wm = 0;
            this.wl = 0;
            this.wo = 0;
            this.wu = 0;
            this.xl = null;
            this.vz = false;
            this.v0 = false;
            this.wh = 0;
            this.wi = 0;
            this.v4 = false;
            this.v1 = false;
            this.v3 = false;
            this.xw = null;
            this.v5 = false;
            this.xh = 0;
            this.ww = 0;
            this.wv = 0;
            this.wx = 0;
            this.vr = null;
            this.vs = null;
            this.v2 = false;
            this.wp = 0;
            this.wq = 0;
            this.wr = 0;
            this.ws = 0;
            this.wt = 0;
            this.vv = false;
            this.vw = false;
        }
        get transitionInDuration() {
            return this.xf;
        }
        set transitionInDuration(a) {
            this.xf = a;
            this.g("TransitionInDuration");
        }
        get transitionOutDuration() {
            return this.xg;
        }
        set transitionOutDuration(a) {
            this.xg = a;
            this.g("TransitionOutDuration");
        }
        get transitionInEasingFunctionRef() {
            return this.xr;
        }
        set transitionInEasingFunctionRef(a) {
            this.xr = a;
            this.g("TransitionInEasingFunctionRef");
        }
        get transitionOutEasingFunctionRef() {
            return this.xu;
        }
        set transitionOutEasingFunctionRef(a) {
            this.xu = a;
            this.g("TransitionOutEasingFunctionRef");
        }
        get chartType() {
            return this.xn;
        }
        set chartType(a) {
            this.xn = a;
            this.g("ChartType");
        }
        get markerCollisionAvoidance() {
            return this.xp;
        }
        set markerCollisionAvoidance(a) {
            this.xp = a;
            this.g("MarkerCollisionAvoidance");
        }
        get isSplineShapePartOfRange() {
            return this.vx;
        }
        set isSplineShapePartOfRange(a) {
            this.vx = a;
            this.g("IsSplineShapePartOfRange");
        }
        get isTransitionInEnabled() {
            return this.vy;
        }
        set isTransitionInEnabled(a) {
            this.vy = a;
            this.g("IsTransitionInEnabled");
        }
        get transitionInMode() {
            return this.xs;
        }
        set transitionInMode(a) {
            this.xs = a;
            this.g("TransitionInMode");
        }
        get transitionInSpeedType() {
            return this.xt;
        }
        set transitionInSpeedType(a) {
            this.xt = a;
            this.g("TransitionInSpeedType");
        }
        get xAxisInterval() {
            return this.wk;
        }
        set xAxisInterval(a) {
            this.wk = a;
            this.g("XAxisInterval");
        }
        get xAxisMinorInterval() {
            return this.wn;
        }
        set xAxisMinorInterval(a) {
            this.wn = a;
            this.g("XAxisMinorInterval");
        }
        get xAxisGap() {
            return this.wj;
        }
        set xAxisGap(a) {
            this.wj = a;
            this.g("XAxisGap");
        }
        get xAxisMinimumGapSize() {
            return this.wm;
        }
        set xAxisMinimumGapSize(a) {
            this.wm = a;
            this.g("XAxisMinimumGapSize");
        }
        get xAxisMaximumGap() {
            return this.wl;
        }
        set xAxisMaximumGap(a) {
            this.wl = a;
            this.g("XAxisMaximumGap");
        }
        get xAxisOverlap() {
            return this.wo;
        }
        set xAxisOverlap(a) {
            this.wo = a;
            this.g("XAxisOverlap");
        }
        get yAxisInterval() {
            return this.wu;
        }
        set yAxisInterval(a) {
            this.wu = a;
            this.g("YAxisInterval");
        }
        get autoMarginAndAngleUpdateMode() {
            return this.xl;
        }
        set autoMarginAndAngleUpdateMode(a) {
            this.xl = a;
            this.g("AutoMarginAndAngleUpdateMode");
        }
        get shouldAutoExpandMarginForInitialLabels() {
            return this.vz;
        }
        set shouldAutoExpandMarginForInitialLabels(a) {
            this.vz = a;
            this.g("ShouldAutoExpandMarginForInitialLabels");
        }
        get shouldConsiderAutoRotationForInitialLabels() {
            return this.v0;
        }
        set shouldConsiderAutoRotationForInitialLabels(a) {
            this.v0 = a;
            this.g("ShouldConsiderAutoRotationForInitialLabels");
        }
        get autoExpandMarginExtraPadding() {
            return this.wh;
        }
        set autoExpandMarginExtraPadding(a) {
            this.wh = a;
            this.g("AutoExpandMarginExtraPadding");
        }
        get autoExpandMarginMaximumValue() {
            return this.wi;
        }
        set autoExpandMarginMaximumValue(a) {
            this.wi = a;
            this.g("AutoExpandMarginMaximumValue");
        }
        get yAxisFavorLabellingScaleEnd() {
            return this.v4;
        }
        set yAxisFavorLabellingScaleEnd(a) {
            this.v4 = a;
            this.g("YAxisFavorLabellingScaleEnd");
        }
        get xAxisEnhancedIntervalPreferMoreCategoryLabels() {
            return this.v1;
        }
        set xAxisEnhancedIntervalPreferMoreCategoryLabels(a) {
            this.v1 = a;
            this.g("XAxisEnhancedIntervalPreferMoreCategoryLabels");
        }
        get yAxisEnhancedIntervalPreferMoreCategoryLabels() {
            return this.v3;
        }
        set yAxisEnhancedIntervalPreferMoreCategoryLabels(a) {
            this.v3 = a;
            this.g("YAxisEnhancedIntervalPreferMoreCategoryLabels");
        }
        get yAxisAutoRangeBufferMode() {
            return this.xw;
        }
        set yAxisAutoRangeBufferMode(a) {
            this.xw = a;
            this.g("YAxisAutoRangeBufferMode");
        }
        get yAxisIsLogarithmic() {
            return this.v5;
        }
        set yAxisIsLogarithmic(a) {
            this.v5 = a;
            this.g("YAxisIsLogarithmic");
        }
        get yAxisLogarithmBase() {
            return this.xh;
        }
        set yAxisLogarithmBase(a) {
            this.xh = a;
            this.g("YAxisLogarithmBase");
        }
        get yAxisMinimumValue() {
            return this.ww;
        }
        set yAxisMinimumValue(a) {
            this.ww = a;
            this.g("YAxisMinimumValue");
        }
        get yAxisMaximumValue() {
            return this.wv;
        }
        set yAxisMaximumValue(a) {
            this.wv = a;
            this.g("YAxisMaximumValue");
        }
        get yAxisMinorInterval() {
            return this.wx;
        }
        set yAxisMinorInterval(a) {
            this.wx = a;
            this.g("YAxisMinorInterval");
        }
        get negativeBrushes() {
            return this.vr;
        }
        set negativeBrushes(a) {
            this.vr = a;
            this.g("NegativeBrushes");
        }
        get negativeOutlines() {
            return this.vs;
        }
        set negativeOutlines(a) {
            this.vs = a;
            this.g("NegativeOutlines");
        }
        get yAxisAbbreviateLargeNumbers() {
            return this.v2;
        }
        set yAxisAbbreviateLargeNumbers(a) {
            this.v2 = a;
            this.g("YAxisAbbreviateLargeNumbers");
        }
        get xAxisZoomMaximumCategoryRange() {
            return this.wp;
        }
        set xAxisZoomMaximumCategoryRange(a) {
            this.wp = a;
            this.g("XAxisZoomMaximumCategoryRange");
        }
        get xAxisZoomMaximumItemSpan() {
            return this.wq;
        }
        set xAxisZoomMaximumItemSpan(a) {
            this.wq = a;
            this.g("XAxisZoomMaximumItemSpan");
        }
        get xAxisZoomToCategoryRange() {
            return this.wr;
        }
        set xAxisZoomToCategoryRange(a) {
            this.wr = a;
            this.g("XAxisZoomToCategoryRange");
        }
        get xAxisZoomToCategoryStart() {
            return this.ws;
        }
        set xAxisZoomToCategoryStart(a) {
            this.ws = a;
            this.g("XAxisZoomToCategoryStart");
        }
        get xAxisZoomToItemSpan() {
            return this.wt;
        }
        set xAxisZoomToItemSpan(a) {
            this.wt = a;
            this.g("XAxisZoomToItemSpan");
        }
        get isCategoryHighlightingEnabled() {
            return this.vv;
        }
        set isCategoryHighlightingEnabled(a) {
            this.vv = a;
            this.g("IsCategoryHighlightingEnabled");
        }
        get isItemHighlightingEnabled() {
            return this.vw;
        }
        set isItemHighlightingEnabled(a) {
            this.vw = a;
            this.g("IsItemHighlightingEnabled");
        }
    }
    CategoryChartDescription.$t = /*@__PURE__*/ markType(CategoryChartDescription, 'CategoryChartDescription', XYChartDescription.$);
    return CategoryChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryChartDescriptionMetadata extends Base {
        static e(a) {
            a.item("TooltipTemplateRef", "(w:ToolTip)DataRef:String");
            a.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamCategoryChart");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (CategoryChartDescriptionMetadata.a == null) {
                CategoryChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryChartDescriptionMetadata.c(CategoryChartDescriptionMetadata.a);
            }
            if (a.k(CategoryChartDescriptionMetadata.a)) {
                return;
            }
            a.ac(CategoryChartDescriptionMetadata.a);
        }
        static c(a) {
            XYChartDescriptionMetadata.c(a);
            a.item("TransitionInDuration", "Number:int");
            a.item("TransitionOutDuration", "Number:int");
            a.item("TransitionInEasingFunctionRef", "(w:TransitionInEasingFunction,wf:TransitionInEasingFunction)MethodRef");
            a.item("TransitionOutEasingFunctionRef", "(w:TransitionOutEasingFunction,wf:TransitionOutEasingFunction)MethodRef");
            a.item("ChartType", "ExportedType:string:CategoryChartType");
            a.item("ChartType@names", "Line;Area;Column;Point;StepLine;StepArea;Spline;SplineArea;Waterfall;Auto");
            a.item("MarkerCollisionAvoidance", "ExportedType:string:CategorySeriesMarkerCollisionAvoidance");
            a.item("MarkerCollisionAvoidance@names", "None;Omit");
            a.item("IsSplineShapePartOfRange", "Boolean");
            a.item("IsTransitionInEnabled", "Boolean");
            a.item("TransitionInMode", "ExportedType:string:CategoryTransitionInMode");
            a.item("TransitionInMode@names", "Auto;FromZero;SweepFromLeft;SweepFromRight;SweepFromTop;SweepFromBottom;SweepFromCenter;AccordionFromLeft;AccordionFromRight;AccordionFromTop;AccordionFromBottom;Expand;SweepFromCategoryAxisMinimum;SweepFromCategoryAxisMaximum;SweepFromValueAxisMinimum;SweepFromValueAxisMaximum;AccordionFromCategoryAxisMinimum;AccordionFromCategoryAxisMaximum;AccordionFromValueAxisMinimum;AccordionFromValueAxisMaximum;FromParent");
            a.item("TransitionInSpeedType", "ExportedType:string:TransitionInSpeedType");
            a.item("TransitionInSpeedType@names", "Auto;Normal;ValueScaled;IndexScaled;Random");
            a.item("XAxisInterval", "Number:double");
            a.item("XAxisMinorInterval", "Number:double");
            a.item("XAxisGap", "Number:double");
            a.item("XAxisMinimumGapSize", "Number:double");
            a.item("XAxisMaximumGap", "Number:double");
            a.item("XAxisOverlap", "Number:double");
            a.item("YAxisInterval", "Number:double");
            a.item("AutoMarginAndAngleUpdateMode", "ExportedType:string:AutoMarginsAndAngleUpdateMode");
            a.item("AutoMarginAndAngleUpdateMode@names", "None;SizeChanging;SizeChangingAndZoom");
            a.item("ShouldAutoExpandMarginForInitialLabels", "Boolean");
            a.item("ShouldConsiderAutoRotationForInitialLabels", "Boolean");
            a.item("AutoExpandMarginExtraPadding", "Number:double");
            a.item("AutoExpandMarginMaximumValue", "Number:double");
            a.item("YAxisFavorLabellingScaleEnd", "Boolean");
            a.item("XAxisEnhancedIntervalPreferMoreCategoryLabels", "Boolean");
            a.item("YAxisEnhancedIntervalPreferMoreCategoryLabels", "Boolean");
            a.item("YAxisAutoRangeBufferMode", "ExportedType:string:AxisRangeBufferMode");
            a.item("YAxisAutoRangeBufferMode@names", "Auto;Series;SeriesMinimum;SeriesMaximum;None");
            a.item("YAxisIsLogarithmic", "Boolean");
            a.item("YAxisLogarithmBase", "Number:int");
            a.item("YAxisMinimumValue", "Number:double");
            a.item("YAxisMaximumValue", "Number:double");
            a.item("YAxisMinorInterval", "Number:double");
            a.item("NegativeBrushes", "BrushCollection:string");
            a.item("NegativeOutlines", "BrushCollection:string");
            a.item("YAxisAbbreviateLargeNumbers", "Boolean");
            a.item("XAxisZoomMaximumCategoryRange", "Number:double");
            a.item("XAxisZoomMaximumItemSpan", "Number:double");
            a.item("XAxisZoomToCategoryRange", "Number:double");
            a.item("XAxisZoomToCategoryStart", "Number:double");
            a.item("XAxisZoomToItemSpan", "Number:double");
            a.item("IsCategoryHighlightingEnabled", "Boolean");
            a.item("IsItemHighlightingEnabled", "Boolean");
            CategoryChartDescriptionMetadata.e(a);
        }
        static d(a) {
            CategoryChartDescriptionMetadata.b(a);
            a.ae("CategoryChart", () => new CategoryChartDescription());
            a.ad("CategoryChart", CategoryChartDescriptionMetadata.a);
        }
    }
    CategoryChartDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryChartDescriptionMetadata, 'CategoryChartDescriptionMetadata');
    CategoryChartDescriptionMetadata.a = null;
    return CategoryChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisRangeChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class AxisRangeChangedEventArgsDescription extends Description {
        get_type() {
            return "AxisRangeChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = 0;
            this.i = 0;
            this.j = 0;
            this.h = 0;
        }
        get oldMinimumValue() {
            return this.k;
        }
        set oldMinimumValue(a) {
            this.k = a;
            this.g("OldMinimumValue");
        }
        get minimumValue() {
            return this.i;
        }
        set minimumValue(a) {
            this.i = a;
            this.g("MinimumValue");
        }
        get oldMaximumValue() {
            return this.j;
        }
        set oldMaximumValue(a) {
            this.j = a;
            this.g("OldMaximumValue");
        }
        get maximumValue() {
            return this.h;
        }
        set maximumValue(a) {
            this.h = a;
            this.g("MaximumValue");
        }
    }
    AxisRangeChangedEventArgsDescription.$t = /*@__PURE__*/ markType(AxisRangeChangedEventArgsDescription, 'AxisRangeChangedEventArgsDescription', Description.$);
    return AxisRangeChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisRangeChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AxisRangeChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AxisRangeChangedEventArgsDescriptionMetadata.a == null) {
                AxisRangeChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AxisRangeChangedEventArgsDescriptionMetadata.c(AxisRangeChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(AxisRangeChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AxisRangeChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("OldMinimumValue", "Number:double");
            a.item("MinimumValue", "Number:double");
            a.item("OldMaximumValue", "Number:double");
            a.item("MaximumValue", "Number:double");
        }
        static d(a) {
            AxisRangeChangedEventArgsDescriptionMetadata.b(a);
            a.ae("AxisRangeChangedEventArgs", () => new AxisRangeChangedEventArgsDescription());
            a.ad("AxisRangeChangedEventArgs", AxisRangeChangedEventArgsDescriptionMetadata.a);
        }
    }
    AxisRangeChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AxisRangeChangedEventArgsDescriptionMetadata, 'AxisRangeChangedEventArgsDescriptionMetadata');
    AxisRangeChangedEventArgsDescriptionMetadata.a = null;
    return AxisRangeChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class AxisDescriptionMetadata extends Base {
        static b(a) {
            if (AxisDescriptionMetadata.a == null) {
                AxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AxisDescriptionMetadata.c(AxisDescriptionMetadata.a);
            }
            if (a.k(AxisDescriptionMetadata.a)) {
                return;
            }
            a.ac(AxisDescriptionMetadata.a);
            AxisRangeChangedEventArgsDescriptionMetadata.d(a);
            RenderRequestedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("FormatLabelRef", "(w:FormatLabel,wf:FormatLabel)MethodRef");
            a.item("Title", "String");
            a.item("Stroke", "Brush");
            a.item("ActualStroke", "Brush");
            a.item("StrokeThickness", "Number:double");
            a.item("StrokeDashArray", "DoubleCollection:double");
            a.item("Strip", "Brush");
            a.item("MajorStroke", "Brush");
            a.item("ActualMajorStroke", "Brush");
            a.item("MajorStrokeThickness", "Number:double");
            a.item("MajorStrokeDashArray", "DoubleCollection:double");
            a.item("MinorStroke", "Brush");
            a.item("ActualMinorStroke", "Brush");
            a.item("MinorStrokeThickness", "Number:double");
            a.item("MinorStrokeDashArray", "DoubleCollection:double");
            a.item("TickStroke", "Brush");
            a.item("TickStrokeThickness", "Number:double");
            a.item("TickStrokeDashArray", "DoubleCollection:double");
            a.item("TickLength", "Number:double");
            a.item("IsDisabled", "Boolean");
            a.item("IsInverted", "Boolean");
            a.item("ShouldAvoidAnnotationCollisions", "Boolean");
            a.item("ShouldKeepAnnotationsInView", "Boolean");
            a.item("UsePerLabelHeightMeasurement", "Boolean");
            a.item("UseEnhancedIntervalManagement", "Boolean");
            a.item("EnhancedIntervalMinimumCharacters", "Number:int");
            a.item("EnhancedIntervalPreferMoreCategoryLabels", "Boolean");
            a.item("LabelTextColor", "(w:LabelSettings.TextColor,wf:LabelTextColor)Brush");
            a.item("LabelLocation", "(w:LabelSettings.Location,wf:LabelLocation)ExportedType:string:AxisLabelsLocation");
            a.item("LabelLocation@names", "OutsideTop;OutsideBottom;OutsideLeft;OutsideRight;InsideTop;InsideBottom;InsideLeft;InsideRight");
            a.item("LabelShowFirstLabel", "(w:LabelSettings.ShowFirstLabel,wf:LabelShowFirstLabel)Boolean");
            a.item("LabelAngle", "(w:LabelSettings.Angle,wf:LabelAngle)Number:double");
            a.item("LabelExtent", "(w:LabelSettings.Extent,wf:LabelExtent)Number:double");
            a.item("LabelLeftMargin", "(w:LabelSettings.LeftMargin,wf:LabelLeftMargin)Number:double");
            a.item("LabelRightMargin", "(w:LabelSettings.RightMargin,wf:LabelRightMargin)Number:double");
            a.item("LabelTopMargin", "(w:LabelSettings.TopMargin,wf:LabelTopMargin)Number:double");
            a.item("LabelBottomMargin", "(w:LabelSettings.BottomMargin,wf:LabelBottomMargin)Number:double");
            a.item("LabelHorizontalAlignment", "(w:LabelSettings.HorizontalAlignment,wf:LabelHorizontalAlignment)ExportedType:string:HorizontalAlignment");
            a.item("LabelHorizontalAlignment@names", "Left;Center;Right;Stretch");
            a.item("LabelVerticalAlignment", "(w:LabelSettings.VerticalAlignment,wf:LabelVerticalAlignment)ExportedType:string:VerticalAlignment");
            a.item("LabelVerticalAlignment@names", "Top;Center;Bottom;Stretch");
            a.item("CrossingAxisRef", "(w:CrossingAxis,wf:CrossingAxis)DataRef::object");
            a.item("CrossingAxisRef@nameBinding", "true");
            a.item("CrossingValue", "Unknown");
            a.item("TitlePosition", "(w:TitleSettings.Position,wf:TitlePosition)ExportedType:string:AxisTitlePosition");
            a.item("TitlePosition@names", "Auto;Left;Right;Top;Bottom");
            a.item("TitleTextColor", "(w:TitleSettings.TextColor,wf:TitleTextColor)Brush");
            a.item("TitleLocation", "(w:TitleSettings.Location,wf:TitleLocation)ExportedType:string:AxisLabelsLocation");
            a.item("TitleLocation@names", "OutsideTop;OutsideBottom;OutsideLeft;OutsideRight;InsideTop;InsideBottom;InsideLeft;InsideRight");
            a.item("TitleShowFirstLabel", "(w:TitleSettings.ShowFirstLabel,wf:TitleShowFirstLabel)Boolean");
            a.item("TitleAngle", "(w:TitleSettings.Angle,wf:TitleAngle)Number:double");
            a.item("TitleExtent", "(w:TitleSettings.Extent,wf:TitleExtent)Number:double");
            a.item("TitleLeftMargin", "(w:TitleSettings.LeftMargin,wf:TitleLeftMargin)Number:double");
            a.item("TitleRightMargin", "(w:TitleSettings.RightMargin,wf:TitleRightMargin)Number:double");
            a.item("TitleTopMargin", "(w:TitleSettings.TopMargin,wf:TitleTopMargin)Number:double");
            a.item("TitleBottomMargin", "(w:TitleSettings.BottomMargin,wf:TitleBottomMargin)Number:double");
            a.item("TitleHorizontalAlignment", "(w:TitleSettings.HorizontalAlignment,wf:TitleHorizontalAlignment)ExportedType:string:HorizontalAlignment");
            a.item("TitleHorizontalAlignment@names", "Left;Center;Right;Stretch");
            a.item("TitleVerticalAlignment", "(w:TitleSettings.VerticalAlignment,wf:TitleVerticalAlignment)ExportedType:string:VerticalAlignment");
            a.item("TitleVerticalAlignment@names", "Top;Center;Bottom;Stretch");
            a.item("Annotations", "Collection:AxisAnnotation:AxisAnnotationCollection:IAxisAnnotation");
            a.item("CoercionMethodsRef", "(w:CoercionMethods,wf:CoercionMethods)DataRef");
            a.item("ExpectFunctions", "Boolean");
            a.item("LabelFormat", "String");
            a.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("RangeChangedRef", "EventRef::rangeChanged");
            a.item("RenderRequestedRef", "EventRef::renderRequested");
            AxisDescriptionMetadata.e(a);
        }
        static d(a) {
            AxisDescriptionMetadata.b(a);
            a.ad("Axis", AxisDescriptionMetadata.a);
        }
        static e(a) {
            a.item("Label", "(w:Label/AxisLabelTransform)String");
            a.item("LabelTextColor", "(w:LabelSettings.Foreground,wf:LabelTextColor,web:LabelTextColor)Brush");
            a.item("TitleTextColor", "(w:TitleSettings.Foreground,wf:TitleTextColor,web:TitleTextColor)Brush");
            a.item("LabelFontFamily", "(w:LabelSettings.FontFamily/FontFamilyTransform,wf:LabelFontFamily,xam:LabelFontFamily,web:LabelTextStyle/FontFamilyTransform)String");
            a.item("LabelFontSize", "(w:LabelSettings.FontSize,wf:LabelFontSize,xam:LabelFontSize,web:LabelTextStyle/FontSizeTransform)Number:double");
            a.item("LabelFontStyle", "(w:LabelSettings.FontStyle/FontStyleTransform,xam:LabelTextStyle/FontStyleTransform,wf:LabelTextStyle/FontStyleTransform,web:LabelTextStyle/FontStyleTransform)String");
            a.item("LabelFontWeight", "(w:LabelSettings.FontWeight/FontWeightTransform,xam:LabelTextSTyle/FontWeightTransform,wf:LabelTextStyle/FontWeightTransform,web:LabelTextStyle/FontWeightTransform)String");
            a.item("TitleFontFamily", "(w:TitleSettings.FontFamily/FontFamilyTransform,xam:TitleFontFamily,wf:TitleFontFamily,web:TitleTextStyle/FontFamilyTransform)String");
            a.item("TitleFontSize", "(w:TitleSettings.FontSize,wf:TitleFontSize,xam:TitleTextStyle/FontSizeTransform,web:TitleTextStyle/FontSizeTransform)Number:double");
            a.item("TitleFontStyle", "(w:TitleSettings.FontStyle/FontStyleTransform,xam:TitleTextStyle/FontStyleTransform,wf:TitleTextStyle/FontStyleTransform,web:TitleTextStyle/FontStyleTransform)String");
            a.item("TitleFontWeight", "(w:TitleSettings.FontWeight/FontWeightTransform,xam:TitleTextStyle/FontWeightTransform,wf:TitleTextStyle/FontWeightTransform,web:TitleTextStyle/FontWeightTransform)String");
            a.item("LabelVisibility", "(w:LabelSettings.Visibility,wf:LabelsVisible/VisibilityToBooleanTransform)ExportedType:string:Visibility");
            a.item("LabelSettings", "ExportedType:AxisLabelSettings");
        }
    }
    AxisDescriptionMetadata.$t = /*@__PURE__*/ markType(AxisDescriptionMetadata, 'AxisDescriptionMetadata');
    AxisDescriptionMetadata.a = null;
    return AxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryAxisBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryAxisBaseDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryAxisBaseDescriptionMetadata.a == null) {
                CategoryAxisBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryAxisBaseDescriptionMetadata.c(CategoryAxisBaseDescriptionMetadata.a);
            }
            if (a.k(CategoryAxisBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(CategoryAxisBaseDescriptionMetadata.a);
        }
        static c(a) {
            AxisDescriptionMetadata.c(a);
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)DataRef::object");
            a.item("ItemsCount", "Number:int");
            a.item("Gap", "Number:double");
            a.item("MaximumGap", "Number:double");
            a.item("MinimumGapSize", "Number:double");
            a.item("Overlap", "Number:double");
            a.item("UseClusteringMode", "Boolean");
            a.item("ItemsCountChangeRef", "EventRef::itemsCountChange");
            CategoryAxisBaseDescriptionMetadata.e(a);
        }
        static d(a) {
            CategoryAxisBaseDescriptionMetadata.b(a);
            a.ad("CategoryAxisBase", CategoryAxisBaseDescriptionMetadata.a);
        }
        static e(a) {
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource)DataRef:String");
        }
    }
    CategoryAxisBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryAxisBaseDescriptionMetadata, 'CategoryAxisBaseDescriptionMetadata');
    CategoryAxisBaseDescriptionMetadata.a = null;
    return CategoryAxisBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisDescription = /*@__PURE__*/ (() => {
    class AxisDescription extends Description {
        get_type() {
            return "Axis";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.by = null;
            this.cg = null;
            this.ce = null;
            this.bv = null;
            this.aw = 0;
            this.l = null;
            this.cd = null;
            this.b9 = null;
            this.bt = null;
            this.au = 0;
            this.j = null;
            this.ca = null;
            this.bu = null;
            this.av = 0;
            this.k = null;
            this.cf = null;
            this.ay = 0;
            this.m = null;
            this.ax = 0;
            this.v = false;
            this.w = false;
            this.y = false;
            this.z = false;
            this.ac = false;
            this.ab = false;
            this.bp = 0;
            this.t = false;
            this.b6 = null;
            this.b5 = null;
            this.x = false;
            this.an = 0;
            this.ap = 0;
            this.ar = 0;
            this.as = 0;
            this.at = 0;
            this.ao = 0;
            this.b4 = null;
            this.b7 = null;
            this.bx = null;
            this.br = null;
            this.cm = null;
            this.cn = null;
            this.cl = null;
            this.aa = false;
            this.az = 0;
            this.a1 = 0;
            this.a3 = 0;
            this.a4 = 0;
            this.a5 = 0;
            this.a0 = 0;
            this.ck = null;
            this.co = null;
            this.h = null;
            this.bw = null;
            this.u = false;
            this.b3 = null;
            this.i = null;
            this.cb = null;
            this.cc = null;
            this.bz = null;
            this.b0 = null;
            this.aq = 0;
            this.b2 = null;
            this.b1 = null;
            this.ch = null;
            this.a2 = 0;
            this.cj = null;
            this.ci = null;
            this.b8 = null;
        }
        get formatLabelRef() {
            return this.by;
        }
        set formatLabelRef(a) {
            this.by = a;
            this.g("FormatLabelRef");
        }
        get title() {
            return this.cg;
        }
        set title(a) {
            this.cg = a;
            this.g("Title");
        }
        get stroke() {
            return this.ce;
        }
        set stroke(a) {
            this.ce = a;
            this.g("Stroke");
        }
        get actualStroke() {
            return this.bv;
        }
        set actualStroke(a) {
            this.bv = a;
            this.g("ActualStroke");
        }
        get strokeThickness() {
            return this.aw;
        }
        set strokeThickness(a) {
            this.aw = a;
            this.g("StrokeThickness");
        }
        get strokeDashArray() {
            return this.l;
        }
        set strokeDashArray(a) {
            this.l = a;
            this.g("StrokeDashArray");
        }
        get strip() {
            return this.cd;
        }
        set strip(a) {
            this.cd = a;
            this.g("Strip");
        }
        get majorStroke() {
            return this.b9;
        }
        set majorStroke(a) {
            this.b9 = a;
            this.g("MajorStroke");
        }
        get actualMajorStroke() {
            return this.bt;
        }
        set actualMajorStroke(a) {
            this.bt = a;
            this.g("ActualMajorStroke");
        }
        get majorStrokeThickness() {
            return this.au;
        }
        set majorStrokeThickness(a) {
            this.au = a;
            this.g("MajorStrokeThickness");
        }
        get majorStrokeDashArray() {
            return this.j;
        }
        set majorStrokeDashArray(a) {
            this.j = a;
            this.g("MajorStrokeDashArray");
        }
        get minorStroke() {
            return this.ca;
        }
        set minorStroke(a) {
            this.ca = a;
            this.g("MinorStroke");
        }
        get actualMinorStroke() {
            return this.bu;
        }
        set actualMinorStroke(a) {
            this.bu = a;
            this.g("ActualMinorStroke");
        }
        get minorStrokeThickness() {
            return this.av;
        }
        set minorStrokeThickness(a) {
            this.av = a;
            this.g("MinorStrokeThickness");
        }
        get minorStrokeDashArray() {
            return this.k;
        }
        set minorStrokeDashArray(a) {
            this.k = a;
            this.g("MinorStrokeDashArray");
        }
        get tickStroke() {
            return this.cf;
        }
        set tickStroke(a) {
            this.cf = a;
            this.g("TickStroke");
        }
        get tickStrokeThickness() {
            return this.ay;
        }
        set tickStrokeThickness(a) {
            this.ay = a;
            this.g("TickStrokeThickness");
        }
        get tickStrokeDashArray() {
            return this.m;
        }
        set tickStrokeDashArray(a) {
            this.m = a;
            this.g("TickStrokeDashArray");
        }
        get tickLength() {
            return this.ax;
        }
        set tickLength(a) {
            this.ax = a;
            this.g("TickLength");
        }
        get isDisabled() {
            return this.v;
        }
        set isDisabled(a) {
            this.v = a;
            this.g("IsDisabled");
        }
        get isInverted() {
            return this.w;
        }
        set isInverted(a) {
            this.w = a;
            this.g("IsInverted");
        }
        get shouldAvoidAnnotationCollisions() {
            return this.y;
        }
        set shouldAvoidAnnotationCollisions(a) {
            this.y = a;
            this.g("ShouldAvoidAnnotationCollisions");
        }
        get shouldKeepAnnotationsInView() {
            return this.z;
        }
        set shouldKeepAnnotationsInView(a) {
            this.z = a;
            this.g("ShouldKeepAnnotationsInView");
        }
        get usePerLabelHeightMeasurement() {
            return this.ac;
        }
        set usePerLabelHeightMeasurement(a) {
            this.ac = a;
            this.g("UsePerLabelHeightMeasurement");
        }
        get useEnhancedIntervalManagement() {
            return this.ab;
        }
        set useEnhancedIntervalManagement(a) {
            this.ab = a;
            this.g("UseEnhancedIntervalManagement");
        }
        get enhancedIntervalMinimumCharacters() {
            return this.bp;
        }
        set enhancedIntervalMinimumCharacters(a) {
            this.bp = a;
            this.g("EnhancedIntervalMinimumCharacters");
        }
        get enhancedIntervalPreferMoreCategoryLabels() {
            return this.t;
        }
        set enhancedIntervalPreferMoreCategoryLabels(a) {
            this.t = a;
            this.g("EnhancedIntervalPreferMoreCategoryLabels");
        }
        get labelTextColor() {
            return this.b6;
        }
        set labelTextColor(a) {
            this.b6 = a;
            this.g("LabelTextColor");
        }
        get labelLocation() {
            return this.b5;
        }
        set labelLocation(a) {
            this.b5 = a;
            this.g("LabelLocation");
        }
        get labelShowFirstLabel() {
            return this.x;
        }
        set labelShowFirstLabel(a) {
            this.x = a;
            this.g("LabelShowFirstLabel");
        }
        get labelAngle() {
            return this.an;
        }
        set labelAngle(a) {
            this.an = a;
            this.g("LabelAngle");
        }
        get labelExtent() {
            return this.ap;
        }
        set labelExtent(a) {
            this.ap = a;
            this.g("LabelExtent");
        }
        get labelLeftMargin() {
            return this.ar;
        }
        set labelLeftMargin(a) {
            this.ar = a;
            this.g("LabelLeftMargin");
        }
        get labelRightMargin() {
            return this.as;
        }
        set labelRightMargin(a) {
            this.as = a;
            this.g("LabelRightMargin");
        }
        get labelTopMargin() {
            return this.at;
        }
        set labelTopMargin(a) {
            this.at = a;
            this.g("LabelTopMargin");
        }
        get labelBottomMargin() {
            return this.ao;
        }
        set labelBottomMargin(a) {
            this.ao = a;
            this.g("LabelBottomMargin");
        }
        get labelHorizontalAlignment() {
            return this.b4;
        }
        set labelHorizontalAlignment(a) {
            this.b4 = a;
            this.g("LabelHorizontalAlignment");
        }
        get labelVerticalAlignment() {
            return this.b7;
        }
        set labelVerticalAlignment(a) {
            this.b7 = a;
            this.g("LabelVerticalAlignment");
        }
        get crossingAxisRef() {
            return this.bx;
        }
        set crossingAxisRef(a) {
            this.bx = a;
            this.g("CrossingAxisRef");
        }
        get crossingValue() {
            return this.br;
        }
        set crossingValue(a) {
            this.br = a;
            this.g("CrossingValue");
        }
        get titlePosition() {
            return this.cm;
        }
        set titlePosition(a) {
            this.cm = a;
            this.g("TitlePosition");
        }
        get titleTextColor() {
            return this.cn;
        }
        set titleTextColor(a) {
            this.cn = a;
            this.g("TitleTextColor");
        }
        get titleLocation() {
            return this.cl;
        }
        set titleLocation(a) {
            this.cl = a;
            this.g("TitleLocation");
        }
        get titleShowFirstLabel() {
            return this.aa;
        }
        set titleShowFirstLabel(a) {
            this.aa = a;
            this.g("TitleShowFirstLabel");
        }
        get titleAngle() {
            return this.az;
        }
        set titleAngle(a) {
            this.az = a;
            this.g("TitleAngle");
        }
        get titleExtent() {
            return this.a1;
        }
        set titleExtent(a) {
            this.a1 = a;
            this.g("TitleExtent");
        }
        get titleLeftMargin() {
            return this.a3;
        }
        set titleLeftMargin(a) {
            this.a3 = a;
            this.g("TitleLeftMargin");
        }
        get titleRightMargin() {
            return this.a4;
        }
        set titleRightMargin(a) {
            this.a4 = a;
            this.g("TitleRightMargin");
        }
        get titleTopMargin() {
            return this.a5;
        }
        set titleTopMargin(a) {
            this.a5 = a;
            this.g("TitleTopMargin");
        }
        get titleBottomMargin() {
            return this.a0;
        }
        set titleBottomMargin(a) {
            this.a0 = a;
            this.g("TitleBottomMargin");
        }
        get titleHorizontalAlignment() {
            return this.ck;
        }
        set titleHorizontalAlignment(a) {
            this.ck = a;
            this.g("TitleHorizontalAlignment");
        }
        get titleVerticalAlignment() {
            return this.co;
        }
        set titleVerticalAlignment(a) {
            this.co = a;
            this.g("TitleVerticalAlignment");
        }
        get annotations() {
            return this.h;
        }
        set annotations(a) {
            this.h = a;
            this.g("Annotations");
        }
        get coercionMethodsRef() {
            return this.bw;
        }
        set coercionMethodsRef(a) {
            this.bw = a;
            this.g("CoercionMethodsRef");
        }
        get expectFunctions() {
            return this.u;
        }
        set expectFunctions(a) {
            this.u = a;
            this.g("ExpectFunctions");
        }
        get labelFormat() {
            return this.b3;
        }
        set labelFormat(a) {
            this.b3 = a;
            this.g("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.i;
        }
        set labelFormatSpecifiers(a) {
            this.i = a;
            this.g("LabelFormatSpecifiers");
        }
        get rangeChangedRef() {
            return this.cb;
        }
        set rangeChangedRef(a) {
            this.cb = a;
            this.g("RangeChangedRef");
        }
        get renderRequestedRef() {
            return this.cc;
        }
        set renderRequestedRef(a) {
            this.cc = a;
            this.g("RenderRequestedRef");
        }
        get label() {
            return this.bz;
        }
        set label(a) {
            this.bz = a;
            this.g("Label");
        }
        get labelFontFamily() {
            return this.b0;
        }
        set labelFontFamily(a) {
            this.b0 = a;
            this.g("LabelFontFamily");
        }
        get labelFontSize() {
            return this.aq;
        }
        set labelFontSize(a) {
            this.aq = a;
            this.g("LabelFontSize");
        }
        get labelFontWeight() {
            return this.b2;
        }
        set labelFontWeight(a) {
            this.b2 = a;
            this.g("LabelFontWeight");
        }
        get labelFontStyle() {
            return this.b1;
        }
        set labelFontStyle(a) {
            this.b1 = a;
            this.g("LabelFontStyle");
        }
        get titleFontFamily() {
            return this.ch;
        }
        set titleFontFamily(a) {
            this.ch = a;
            this.g("TitleFontFamily");
        }
        get titleFontSize() {
            return this.a2;
        }
        set titleFontSize(a) {
            this.a2 = a;
            this.g("TitleFontSize");
        }
        get titleFontWeight() {
            return this.cj;
        }
        set titleFontWeight(a) {
            this.cj = a;
            this.g("TitleFontWeight");
        }
        get titleFontStyle() {
            return this.ci;
        }
        set titleFontStyle(a) {
            this.ci = a;
            this.g("TitleFontStyle");
        }
        get labelVisibility() {
            return this.b8;
        }
        set labelVisibility(a) {
            this.b8 = a;
            this.g("LabelVisibility");
        }
    }
    AxisDescription.$t = /*@__PURE__*/ markType(AxisDescription, 'AxisDescription', Description.$);
    return AxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryAxisBaseDescription = /*@__PURE__*/ (() => {
    class CategoryAxisBaseDescription extends AxisDescription {
        get_type() {
            return "CategoryAxisBase";
        }
        constructor() {
            super();
            this.dz = null;
            this.dx = 0;
            this.dp = 0;
            this.dq = 0;
            this.dr = 0;
            this.ds = 0;
            this.dm = false;
            this.d0 = null;
        }
        get dataSourceRef() {
            return this.dz;
        }
        set dataSourceRef(a) {
            this.dz = a;
            this.g("DataSourceRef");
        }
        get itemsCount() {
            return this.dx;
        }
        set itemsCount(a) {
            this.dx = a;
            this.g("ItemsCount");
        }
        get gap() {
            return this.dp;
        }
        set gap(a) {
            this.dp = a;
            this.g("Gap");
        }
        get maximumGap() {
            return this.dq;
        }
        set maximumGap(a) {
            this.dq = a;
            this.g("MaximumGap");
        }
        get minimumGapSize() {
            return this.dr;
        }
        set minimumGapSize(a) {
            this.dr = a;
            this.g("MinimumGapSize");
        }
        get overlap() {
            return this.ds;
        }
        set overlap(a) {
            this.ds = a;
            this.g("Overlap");
        }
        get useClusteringMode() {
            return this.dm;
        }
        set useClusteringMode(a) {
            this.dm = a;
            this.g("UseClusteringMode");
        }
        get itemsCountChangeRef() {
            return this.d0;
        }
        set itemsCountChangeRef(a) {
            this.d0 = a;
            this.g("ItemsCountChangeRef");
        }
    }
    CategoryAxisBaseDescription.$t = /*@__PURE__*/ markType(CategoryAxisBaseDescription, 'CategoryAxisBaseDescription', AxisDescription.$);
    return CategoryAxisBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryXAxisDescription = /*@__PURE__*/ (() => {
    class CategoryXAxisDescription extends CategoryAxisBaseDescription {
        get_type() {
            return "CategoryXAxis";
        }
        constructor() {
            super();
            this.d7 = 0;
            this.d8 = 0;
            this.d9 = 0;
            this.ea = 0;
            this.eb = 0;
            this.d5 = 0;
            this.d3 = 0;
            this.d6 = 0;
            this.d4 = 0;
            this.el = null;
            this.em = null;
        }
        get zoomMaximumCategoryRange() {
            return this.d7;
        }
        set zoomMaximumCategoryRange(a) {
            this.d7 = a;
            this.g("ZoomMaximumCategoryRange");
        }
        get zoomMaximumItemSpan() {
            return this.d8;
        }
        set zoomMaximumItemSpan(a) {
            this.d8 = a;
            this.g("ZoomMaximumItemSpan");
        }
        get zoomToCategoryRange() {
            return this.d9;
        }
        set zoomToCategoryRange(a) {
            this.d9 = a;
            this.g("ZoomToCategoryRange");
        }
        get zoomToCategoryStart() {
            return this.ea;
        }
        set zoomToCategoryStart(a) {
            this.ea = a;
            this.g("ZoomToCategoryStart");
        }
        get zoomToItemSpan() {
            return this.eb;
        }
        set zoomToItemSpan(a) {
            this.eb = a;
            this.g("ZoomToItemSpan");
        }
        get interval() {
            return this.d5;
        }
        set interval(a) {
            this.d5 = a;
            this.g("Interval");
        }
        get actualInterval() {
            return this.d3;
        }
        set actualInterval(a) {
            this.d3 = a;
            this.g("ActualInterval");
        }
        get minorInterval() {
            return this.d6;
        }
        set minorInterval(a) {
            this.d6 = a;
            this.g("MinorInterval");
        }
        get actualMinorInterval() {
            return this.d4;
        }
        set actualMinorInterval(a) {
            this.d4 = a;
            this.g("ActualMinorInterval");
        }
        get actualIntervalChangeRef() {
            return this.el;
        }
        set actualIntervalChangeRef(a) {
            this.el = a;
            this.g("ActualIntervalChangeRef");
        }
        get actualMinorIntervalChangeRef() {
            return this.em;
        }
        set actualMinorIntervalChangeRef(a) {
            this.em = a;
            this.g("ActualMinorIntervalChangeRef");
        }
    }
    CategoryXAxisDescription.$t = /*@__PURE__*/ markType(CategoryXAxisDescription, 'CategoryXAxisDescription', CategoryAxisBaseDescription.$);
    return CategoryXAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryXAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryXAxisDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryXAxisDescriptionMetadata.a == null) {
                CategoryXAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryXAxisDescriptionMetadata.c(CategoryXAxisDescriptionMetadata.a);
            }
            if (a.k(CategoryXAxisDescriptionMetadata.a)) {
                return;
            }
            a.ac(CategoryXAxisDescriptionMetadata.a);
        }
        static c(a) {
            CategoryAxisBaseDescriptionMetadata.c(a);
            a.item("ZoomMaximumCategoryRange", "Number:double");
            a.item("ZoomMaximumItemSpan", "Number:double");
            a.item("ZoomToCategoryRange", "Number:double");
            a.item("ZoomToCategoryStart", "Number:double");
            a.item("ZoomToItemSpan", "Number:double");
            a.item("Interval", "Number:double");
            a.item("ActualInterval", "Number:double");
            a.item("MinorInterval", "Number:double");
            a.item("ActualMinorInterval", "Number:double");
            a.item("ActualIntervalChangeRef", "EventRef::actualIntervalChange");
            a.item("ActualMinorIntervalChangeRef", "EventRef::actualMinorIntervalChange");
        }
        static d(a) {
            CategoryXAxisDescriptionMetadata.b(a);
            a.ae("CategoryXAxis", () => new CategoryXAxisDescription());
            a.ad("CategoryXAxis", CategoryXAxisDescriptionMetadata.a);
        }
    }
    CategoryXAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryXAxisDescriptionMetadata, 'CategoryXAxisDescriptionMetadata');
    CategoryXAxisDescriptionMetadata.a = null;
    return CategoryXAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryXAxisDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryXAxisDescriptionModule extends Base {
        static register(a) {
            CategoryXAxisDescriptionMetadata.d(a);
        }
    }
    CategoryXAxisDescriptionModule.$t = /*@__PURE__*/ markType(CategoryXAxisDescriptionModule, 'CategoryXAxisDescriptionModule');
    return CategoryXAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericAxisBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumericAxisBaseDescriptionMetadata extends Base {
        static b(a) {
            if (NumericAxisBaseDescriptionMetadata.a == null) {
                NumericAxisBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumericAxisBaseDescriptionMetadata.c(NumericAxisBaseDescriptionMetadata.a);
            }
            if (a.k(NumericAxisBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(NumericAxisBaseDescriptionMetadata.a);
        }
        static c(a) {
            AxisDescriptionMetadata.c(a);
            a.item("AutoRangeBufferMode", "ExportedType:string:AxisRangeBufferMode");
            a.item("AutoRangeBufferMode@names", "Auto;Series;SeriesMinimum;SeriesMaximum;None");
            a.item("MinimumValue", "Number:double");
            a.item("ActualMinimumValue", "Number:double");
            a.item("ActualVisibleMinimumValue", "Number:double");
            a.item("MaximumValue", "Number:double");
            a.item("ActualMaximumValue", "Number:double");
            a.item("ActualVisibleMaximumValue", "Number:double");
            a.item("Interval", "Number:double");
            a.item("ActualInterval", "Number:double");
            a.item("MinorInterval", "Number:double");
            a.item("ActualMinorInterval", "Number:double");
            a.item("ReferenceValue", "Number:double");
            a.item("IsLogarithmic", "Boolean");
            a.item("ActualIsLogarithmic", "Boolean");
            a.item("FavorLabellingScaleEnd", "Boolean");
            a.item("LogarithmBase", "Number:int");
            a.item("FormatAbbreviatedLabelRef", "(w:FormatAbbreviatedLabel,wf:FormatAbbreviatedLabel)MethodRef");
            a.item("AbbreviatedLabelFormat", "String");
            a.item("AbbreviatedLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("AbbreviatedLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("IsFormattingAbbreviatedLargeNumber", "Boolean");
            a.item("AbbreviateLargeNumbers", "Boolean");
            a.item("ActualMinimumValueChangeRef", "EventRef::actualMinimumValueChange");
            a.item("ActualMaximumValueChangeRef", "EventRef::actualMaximumValueChange");
            a.item("ActualIntervalChangeRef", "EventRef::actualIntervalChange");
            a.item("ActualMinorIntervalChangeRef", "EventRef::actualMinorIntervalChange");
        }
        static d(a) {
            NumericAxisBaseDescriptionMetadata.b(a);
            a.ad("NumericAxisBase", NumericAxisBaseDescriptionMetadata.a);
        }
    }
    NumericAxisBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(NumericAxisBaseDescriptionMetadata, 'NumericAxisBaseDescriptionMetadata');
    NumericAxisBaseDescriptionMetadata.a = null;
    return NumericAxisBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StraightNumericAxisBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class StraightNumericAxisBaseDescriptionMetadata extends Base {
        static b(a) {
            if (StraightNumericAxisBaseDescriptionMetadata.a == null) {
                StraightNumericAxisBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StraightNumericAxisBaseDescriptionMetadata.c(StraightNumericAxisBaseDescriptionMetadata.a);
            }
            if (a.k(StraightNumericAxisBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(StraightNumericAxisBaseDescriptionMetadata.a);
        }
        static c(a) {
            NumericAxisBaseDescriptionMetadata.c(a);
            a.item("ScaleMode", "ExportedType:string:NumericScaleMode");
            a.item("ScaleMode@names", "Linear;Logarithmic");
        }
        static d(a) {
            StraightNumericAxisBaseDescriptionMetadata.b(a);
            a.ad("StraightNumericAxisBase", StraightNumericAxisBaseDescriptionMetadata.a);
        }
    }
    StraightNumericAxisBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(StraightNumericAxisBaseDescriptionMetadata, 'StraightNumericAxisBaseDescriptionMetadata');
    StraightNumericAxisBaseDescriptionMetadata.a = null;
    return StraightNumericAxisBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericAxisBaseDescription = /*@__PURE__*/ (() => {
    class NumericAxisBaseDescription extends AxisDescription {
        get_type() {
            return "NumericAxisBase";
        }
        constructor() {
            super();
            this.es = null;
            this.d7 = 0;
            this.d1 = 0;
            this.d4 = 0;
            this.d6 = 0;
            this.d0 = 0;
            this.d3 = 0;
            this.d5 = 0;
            this.dz = 0;
            this.d8 = 0;
            this.d2 = 0;
            this.d9 = 0;
            this.dt = false;
            this.dq = false;
            this.dr = false;
            this.el = 0;
            this.et = null;
            this.en = null;
            this.dm = null;
            this.ds = false;
            this.dp = false;
            this.eq = null;
            this.ep = null;
            this.eo = null;
            this.er = null;
        }
        get autoRangeBufferMode() {
            return this.es;
        }
        set autoRangeBufferMode(a) {
            this.es = a;
            this.g("AutoRangeBufferMode");
        }
        get minimumValue() {
            return this.d7;
        }
        set minimumValue(a) {
            this.d7 = a;
            this.g("MinimumValue");
        }
        get actualMinimumValue() {
            return this.d1;
        }
        set actualMinimumValue(a) {
            this.d1 = a;
            this.g("ActualMinimumValue");
        }
        get actualVisibleMinimumValue() {
            return this.d4;
        }
        set actualVisibleMinimumValue(a) {
            this.d4 = a;
            this.g("ActualVisibleMinimumValue");
        }
        get maximumValue() {
            return this.d6;
        }
        set maximumValue(a) {
            this.d6 = a;
            this.g("MaximumValue");
        }
        get actualMaximumValue() {
            return this.d0;
        }
        set actualMaximumValue(a) {
            this.d0 = a;
            this.g("ActualMaximumValue");
        }
        get actualVisibleMaximumValue() {
            return this.d3;
        }
        set actualVisibleMaximumValue(a) {
            this.d3 = a;
            this.g("ActualVisibleMaximumValue");
        }
        get interval() {
            return this.d5;
        }
        set interval(a) {
            this.d5 = a;
            this.g("Interval");
        }
        get actualInterval() {
            return this.dz;
        }
        set actualInterval(a) {
            this.dz = a;
            this.g("ActualInterval");
        }
        get minorInterval() {
            return this.d8;
        }
        set minorInterval(a) {
            this.d8 = a;
            this.g("MinorInterval");
        }
        get actualMinorInterval() {
            return this.d2;
        }
        set actualMinorInterval(a) {
            this.d2 = a;
            this.g("ActualMinorInterval");
        }
        get referenceValue() {
            return this.d9;
        }
        set referenceValue(a) {
            this.d9 = a;
            this.g("ReferenceValue");
        }
        get isLogarithmic() {
            return this.dt;
        }
        set isLogarithmic(a) {
            this.dt = a;
            this.g("IsLogarithmic");
        }
        get actualIsLogarithmic() {
            return this.dq;
        }
        set actualIsLogarithmic(a) {
            this.dq = a;
            this.g("ActualIsLogarithmic");
        }
        get favorLabellingScaleEnd() {
            return this.dr;
        }
        set favorLabellingScaleEnd(a) {
            this.dr = a;
            this.g("FavorLabellingScaleEnd");
        }
        get logarithmBase() {
            return this.el;
        }
        set logarithmBase(a) {
            this.el = a;
            this.g("LogarithmBase");
        }
        get formatAbbreviatedLabelRef() {
            return this.et;
        }
        set formatAbbreviatedLabelRef(a) {
            this.et = a;
            this.g("FormatAbbreviatedLabelRef");
        }
        get abbreviatedLabelFormat() {
            return this.en;
        }
        set abbreviatedLabelFormat(a) {
            this.en = a;
            this.g("AbbreviatedLabelFormat");
        }
        get abbreviatedLabelFormatSpecifiers() {
            return this.dm;
        }
        set abbreviatedLabelFormatSpecifiers(a) {
            this.dm = a;
            this.g("AbbreviatedLabelFormatSpecifiers");
        }
        get isFormattingAbbreviatedLargeNumber() {
            return this.ds;
        }
        set isFormattingAbbreviatedLargeNumber(a) {
            this.ds = a;
            this.g("IsFormattingAbbreviatedLargeNumber");
        }
        get abbreviateLargeNumbers() {
            return this.dp;
        }
        set abbreviateLargeNumbers(a) {
            this.dp = a;
            this.g("AbbreviateLargeNumbers");
        }
        get actualMinimumValueChangeRef() {
            return this.eq;
        }
        set actualMinimumValueChangeRef(a) {
            this.eq = a;
            this.g("ActualMinimumValueChangeRef");
        }
        get actualMaximumValueChangeRef() {
            return this.ep;
        }
        set actualMaximumValueChangeRef(a) {
            this.ep = a;
            this.g("ActualMaximumValueChangeRef");
        }
        get actualIntervalChangeRef() {
            return this.eo;
        }
        set actualIntervalChangeRef(a) {
            this.eo = a;
            this.g("ActualIntervalChangeRef");
        }
        get actualMinorIntervalChangeRef() {
            return this.er;
        }
        set actualMinorIntervalChangeRef(a) {
            this.er = a;
            this.g("ActualMinorIntervalChangeRef");
        }
    }
    NumericAxisBaseDescription.$t = /*@__PURE__*/ markType(NumericAxisBaseDescription, 'NumericAxisBaseDescription', AxisDescription.$);
    return NumericAxisBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StraightNumericAxisBaseDescription = /*@__PURE__*/ (() => {
    class StraightNumericAxisBaseDescription extends NumericAxisBaseDescription {
        get_type() {
            return "StraightNumericAxisBase";
        }
        constructor() {
            super();
            this.e1 = null;
        }
        get scaleMode() {
            return this.e1;
        }
        set scaleMode(a) {
            this.e1 = a;
            this.g("ScaleMode");
        }
    }
    StraightNumericAxisBaseDescription.$t = /*@__PURE__*/ markType(StraightNumericAxisBaseDescription, 'StraightNumericAxisBaseDescription', NumericAxisBaseDescription.$);
    return StraightNumericAxisBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericYAxisDescription = /*@__PURE__*/ (() => {
    class NumericYAxisDescription extends StraightNumericAxisBaseDescription {
        get_type() {
            return "NumericYAxis";
        }
        constructor() {
            super();
        }
    }
    NumericYAxisDescription.$t = /*@__PURE__*/ markType(NumericYAxisDescription, 'NumericYAxisDescription', StraightNumericAxisBaseDescription.$);
    return NumericYAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericYAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumericYAxisDescriptionMetadata extends Base {
        static b(a) {
            if (NumericYAxisDescriptionMetadata.a == null) {
                NumericYAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumericYAxisDescriptionMetadata.c(NumericYAxisDescriptionMetadata.a);
            }
            if (a.k(NumericYAxisDescriptionMetadata.a)) {
                return;
            }
            a.ac(NumericYAxisDescriptionMetadata.a);
        }
        static c(a) {
            StraightNumericAxisBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            NumericYAxisDescriptionMetadata.b(a);
            a.ae("NumericYAxis", () => new NumericYAxisDescription());
            a.ad("NumericYAxis", NumericYAxisDescriptionMetadata.a);
        }
    }
    NumericYAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(NumericYAxisDescriptionMetadata, 'NumericYAxisDescriptionMetadata');
    NumericYAxisDescriptionMetadata.a = null;
    return NumericYAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericYAxisDescriptionModule = /*@__PURE__*/ (() => {
    class NumericYAxisDescriptionModule extends Base {
        static register(a) {
            NumericYAxisDescriptionMetadata.d(a);
        }
    }
    NumericYAxisDescriptionModule.$t = /*@__PURE__*/ markType(NumericYAxisDescriptionModule, 'NumericYAxisDescriptionModule');
    return NumericYAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryChartCoreDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryChartCoreDescriptionModule extends Base {
        static register(a) {
            CategoryChartDescriptionMetadata.d(a);
            CategoryXAxisDescriptionModule.register(a);
            NumericYAxisDescriptionModule.register(a);
        }
    }
    CategoryChartCoreDescriptionModule.$t = /*@__PURE__*/ markType(CategoryChartCoreDescriptionModule, 'CategoryChartCoreDescriptionModule');
    return CategoryChartCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningCategoryStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningCategoryStyleEventArgsDescription extends AssigningSeriesShapeStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningCategoryStyleEventArgs";
        }
        constructor() {
            super();
        }
    }
    AssigningCategoryStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningCategoryStyleEventArgsDescription, 'AssigningCategoryStyleEventArgsDescription', AssigningSeriesShapeStyleEventArgsBaseDescription.$);
    return AssigningCategoryStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningCategoryStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningCategoryStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningCategoryStyleEventArgsDescriptionMetadata.a == null) {
                AssigningCategoryStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningCategoryStyleEventArgsDescriptionMetadata.c(AssigningCategoryStyleEventArgsDescriptionMetadata.a);
            }
            if (a.k(AssigningCategoryStyleEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningCategoryStyleEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningCategoryStyleEventArgsDescriptionMetadata.b(a);
            a.ae("AssigningCategoryStyleEventArgs", () => new AssigningCategoryStyleEventArgsDescription());
            a.ad("AssigningCategoryStyleEventArgs", AssigningCategoryStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningCategoryStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningCategoryStyleEventArgsDescriptionMetadata, 'AssigningCategoryStyleEventArgsDescriptionMetadata');
    AssigningCategoryStyleEventArgsDescriptionMetadata.a = null;
    return AssigningCategoryStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningCategoryStyleEventArgsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningCategoryStyleEventArgsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningCategoryStyleEventArgsBaseDescriptionMetadata.a == null) {
                AssigningCategoryStyleEventArgsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningCategoryStyleEventArgsBaseDescriptionMetadata.c(AssigningCategoryStyleEventArgsBaseDescriptionMetadata.a);
            }
            if (a.k(AssigningCategoryStyleEventArgsBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningCategoryStyleEventArgsBaseDescriptionMetadata.a);
        }
        static c(a) {
            AssigningSeriesStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningCategoryStyleEventArgsBaseDescriptionMetadata.b(a);
            a.ad("AssigningCategoryStyleEventArgsBase", AssigningCategoryStyleEventArgsBaseDescriptionMetadata.a);
        }
    }
    AssigningCategoryStyleEventArgsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningCategoryStyleEventArgsBaseDescriptionMetadata, 'AssigningCategoryStyleEventArgsBaseDescriptionMetadata');
    AssigningCategoryStyleEventArgsBaseDescriptionMetadata.a = null;
    return AssigningCategoryStyleEventArgsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningCategoryStyleEventArgsBaseDescription = /*@__PURE__*/ (() => {
    class AssigningCategoryStyleEventArgsBaseDescription extends AssigningSeriesStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningCategoryStyleEventArgsBase";
        }
        constructor() {
            super();
        }
    }
    AssigningCategoryStyleEventArgsBaseDescription.$t = /*@__PURE__*/ markType(AssigningCategoryStyleEventArgsBaseDescription, 'AssigningCategoryStyleEventArgsBaseDescription', AssigningSeriesStyleEventArgsBaseDescription.$);
    return AssigningCategoryStyleEventArgsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningCategoryMarkerStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningCategoryMarkerStyleEventArgsDescription extends AssigningCategoryStyleEventArgsBaseDescription {
        get_type() {
            return "AssigningCategoryMarkerStyleEventArgs";
        }
        constructor() {
            super();
        }
    }
    AssigningCategoryMarkerStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningCategoryMarkerStyleEventArgsDescription, 'AssigningCategoryMarkerStyleEventArgsDescription', AssigningCategoryStyleEventArgsBaseDescription.$);
    return AssigningCategoryMarkerStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningCategoryMarkerStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningCategoryMarkerStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.a == null) {
                AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.c(AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.a);
            }
            if (a.k(AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            AssigningCategoryStyleEventArgsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.b(a);
            a.ae("AssigningCategoryMarkerStyleEventArgs", () => new AssigningCategoryMarkerStyleEventArgsDescription());
            a.ad("AssigningCategoryMarkerStyleEventArgs", AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningCategoryMarkerStyleEventArgsDescriptionMetadata, 'AssigningCategoryMarkerStyleEventArgsDescriptionMetadata');
    AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.a = null;
    return AssigningCategoryMarkerStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MarkerSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class MarkerSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (MarkerSeriesDescriptionMetadata.a == null) {
                MarkerSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MarkerSeriesDescriptionMetadata.c(MarkerSeriesDescriptionMetadata.a);
            }
            if (a.k(MarkerSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(MarkerSeriesDescriptionMetadata.a);
        }
        static c(a) {
            SeriesDescriptionMetadata.c(a);
            a.item("MarkerType", "ExportedType:string:MarkerType");
            a.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            a.item("ActualMarkerType", "ExportedType:string:MarkerType");
            a.item("ActualMarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            a.item("MarkerOutlineMode", "ExportedType:string:MarkerOutlineMode");
            a.item("MarkerOutlineMode@names", "Auto;Normal;MatchMarkerBrush");
            a.item("MarkerFillMode", "ExportedType:string:MarkerFillMode");
            a.item("MarkerFillMode@names", "Auto;Normal;MatchMarkerOutline");
            a.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            a.item("MarkerThickness", "Number:double");
            a.item("ActualMarkerTemplateRef", "(w:ActualMarkerTemplate,wf:ActualMarkerTemplate)DataRef::object");
            a.item("MarkerBrush", "Brush");
            a.item("ActualMarkerBrush", "Brush");
            a.item("MarkerOutline", "Brush");
            a.item("ActualMarkerOutline", "Brush");
        }
        static d(a) {
            MarkerSeriesDescriptionMetadata.b(a);
            a.ad("MarkerSeries", MarkerSeriesDescriptionMetadata.a);
        }
    }
    MarkerSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(MarkerSeriesDescriptionMetadata, 'MarkerSeriesDescriptionMetadata');
    MarkerSeriesDescriptionMetadata.a = null;
    return MarkerSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategorySeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategorySeriesDescriptionMetadata extends Base {
        static b(a) {
            if (CategorySeriesDescriptionMetadata.a == null) {
                CategorySeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategorySeriesDescriptionMetadata.c(CategorySeriesDescriptionMetadata.a);
            }
            if (a.k(CategorySeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(CategorySeriesDescriptionMetadata.a);
            AssigningCategoryStyleEventArgsDescriptionMetadata.d(a);
            AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            MarkerSeriesDescriptionMetadata.c(a);
            a.item("IsCustomCategoryStyleAllowed", "Boolean");
            a.item("IsCustomCategoryMarkerStyleAllowed", "Boolean");
            a.item("UseHighMarkerFidelity", "Boolean");
            a.item("TransitionInMode", "ExportedType:string:CategoryTransitionInMode");
            a.item("TransitionInMode@names", "Auto;FromZero;SweepFromLeft;SweepFromRight;SweepFromTop;SweepFromBottom;SweepFromCenter;AccordionFromLeft;AccordionFromRight;AccordionFromTop;AccordionFromBottom;Expand;SweepFromCategoryAxisMinimum;SweepFromCategoryAxisMaximum;SweepFromValueAxisMinimum;SweepFromValueAxisMaximum;AccordionFromCategoryAxisMinimum;AccordionFromCategoryAxisMaximum;AccordionFromValueAxisMinimum;AccordionFromValueAxisMaximum;FromParent");
            a.item("IsTransitionInEnabled", "Boolean");
            a.item("AssigningCategoryStyleRef", "EventRef::assigningCategoryStyle");
            a.item("AssigningCategoryMarkerStyleRef", "EventRef::assigningCategoryMarkerStyle");
        }
        static d(a) {
            CategorySeriesDescriptionMetadata.b(a);
            a.ad("CategorySeries", CategorySeriesDescriptionMetadata.a);
        }
    }
    CategorySeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(CategorySeriesDescriptionMetadata, 'CategorySeriesDescriptionMetadata');
    CategorySeriesDescriptionMetadata.a = null;
    return CategorySeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnchoredCategorySeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class AnchoredCategorySeriesDescriptionMetadata extends Base {
        static b(a) {
            if (AnchoredCategorySeriesDescriptionMetadata.a == null) {
                AnchoredCategorySeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AnchoredCategorySeriesDescriptionMetadata.c(AnchoredCategorySeriesDescriptionMetadata.a);
            }
            if (a.k(AnchoredCategorySeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(AnchoredCategorySeriesDescriptionMetadata.a);
        }
        static c(a) {
            CategorySeriesDescriptionMetadata.c(a);
            a.item("ValueMemberPath", "String");
            a.item("HighlightedValueMemberPath", "String");
            a.item("ValueMemberAsLegendLabel", "String");
            a.item("ValueMemberAsLegendUnit", "String");
            a.item("TrendLineType", "ExportedType:string:TrendLineType");
            a.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            a.item("TrendLineBrush", "Brush");
            a.item("ActualTrendLineBrush", "Brush");
            a.item("TrendLineThickness", "Number:double");
            a.item("TrendLineDashArray", "DoubleCollection:double");
            a.item("TrendLinePeriod", "Number:int");
            a.item("MarkerCollisionAvoidance", "ExportedType:string:CategorySeriesMarkerCollisionAvoidance");
            a.item("MarkerCollisionAvoidance@names", "None;Omit");
            a.item("ConsolidatedItemHitTestBehavior", "ExportedType:string:ConsolidatedItemHitTestBehavior");
            a.item("ConsolidatedItemHitTestBehavior@names", "Basic;NearestY");
        }
        static d(a) {
            AnchoredCategorySeriesDescriptionMetadata.b(a);
            a.ad("AnchoredCategorySeries", AnchoredCategorySeriesDescriptionMetadata.a);
        }
    }
    AnchoredCategorySeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(AnchoredCategorySeriesDescriptionMetadata, 'AnchoredCategorySeriesDescriptionMetadata');
    AnchoredCategorySeriesDescriptionMetadata.a = null;
    return AnchoredCategorySeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalAnchoredCategorySeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class HorizontalAnchoredCategorySeriesDescriptionMetadata extends Base {
        static b(a) {
            if (HorizontalAnchoredCategorySeriesDescriptionMetadata.a == null) {
                HorizontalAnchoredCategorySeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HorizontalAnchoredCategorySeriesDescriptionMetadata.c(HorizontalAnchoredCategorySeriesDescriptionMetadata.a);
            }
            if (a.k(HorizontalAnchoredCategorySeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(HorizontalAnchoredCategorySeriesDescriptionMetadata.a);
        }
        static c(a) {
            AnchoredCategorySeriesDescriptionMetadata.c(a);
            a.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            a.item("XAxisRef@nameBinding", "true");
            a.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            a.item("YAxisRef@nameBinding", "true");
        }
        static d(a) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.b(a);
            a.ad("HorizontalAnchoredCategorySeries", HorizontalAnchoredCategorySeriesDescriptionMetadata.a);
        }
    }
    HorizontalAnchoredCategorySeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(HorizontalAnchoredCategorySeriesDescriptionMetadata, 'HorizontalAnchoredCategorySeriesDescriptionMetadata');
    HorizontalAnchoredCategorySeriesDescriptionMetadata.a = null;
    return HorizontalAnchoredCategorySeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesDescription = /*@__PURE__*/ (() => {
    class SeriesDescription extends Description {
        get_type() {
            return "Series";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.co = null;
            this.cv = null;
            this.l = null;
            this.cp = null;
            this.cs = null;
            this.c3 = null;
            this.c2 = null;
            this.c0 = null;
            this.cg = null;
            this.cf = null;
            this.ce = null;
            this.cz = null;
            this.cy = null;
            this.c1 = null;
            this.cq = null;
            this.de = null;
            this.df = null;
            this.di = null;
            this.b3 = 0;
            this.az = 0;
            this.a8 = 0;
            this.bg = 0;
            this.bd = 0;
            this.be = 0;
            this.bf = 0;
            this.cu = null;
            this.ct = null;
            this.cm = null;
            this.b9 = null;
            this.da = null;
            this.cr = null;
            this.ci = null;
            this.ca = null;
            this.c9 = null;
            this.c6 = null;
            this.ch = null;
            this.c5 = null;
            this.cw = null;
            this.aa = false;
            this.bc = 0;
            this.a0 = 0;
            this.k = null;
            this.cc = null;
            this.cj = null;
            this.cb = null;
            this.aw = 0;
            this.a3 = 0;
            this.ax = 0;
            this.a4 = 0;
            this.u = false;
            this.v = false;
            this.y = false;
            this.af = false;
            this.ad = false;
            this.ac = false;
            this.ab = false;
            this.x = false;
            this.a9 = 0;
            this.db = null;
            this.ag = false;
            this.ba = 0;
            this.bb = 0;
            this.a1 = 0;
            this.av = 0;
            this.a5 = 0;
            this.ay = 0;
            this.w = false;
            this.ae = false;
            this.dl = null;
            this.c7 = null;
            this.b4 = 0;
            this.b5 = 0;
            this.dg = null;
            this.dj = null;
            this.c4 = null;
            this.ck = null;
            this.i = null;
            this.cl = null;
            this.j = null;
            this.z = false;
            this.cn = null;
            this.t = false;
            this.cx = null;
            this.cd = null;
            this.a2 = 0;
            this.a7 = 0;
            this.m = null;
            this.h = null;
            this.a6 = 0;
            this.dk = null;
            this.dh = null;
            this.c8 = null;
            this.dd = null;
            this.dc = null;
        }
        get dataLegendGroup() {
            return this.co;
        }
        set dataLegendGroup(a) {
            this.co = a;
            this.g("DataLegendGroup");
        }
        get highlightedValuesDataLegendGroup() {
            return this.cv;
        }
        set highlightedValuesDataLegendGroup(a) {
            this.cv = a;
            this.g("HighlightedValuesDataLegendGroup");
        }
        get highlightedValuesExtraPropertyOverlays() {
            return this.l;
        }
        set highlightedValuesExtraPropertyOverlays(a) {
            this.l = a;
            this.g("HighlightedValuesExtraPropertyOverlays");
        }
        get dataSourceRef() {
            return this.cp;
        }
        set dataSourceRef(a) {
            this.cp = a;
            this.g("DataSourceRef");
        }
        get highlightedDataSourceRef() {
            return this.cs;
        }
        set highlightedDataSourceRef(a) {
            this.cs = a;
            this.g("HighlightedDataSourceRef");
        }
        get legendRef() {
            return this.c3;
        }
        set legendRef(a) {
            this.c3 = a;
            this.g("LegendRef");
        }
        get legendItemVisibility() {
            return this.c2;
        }
        set legendItemVisibility(a) {
            this.c2 = a;
            this.g("LegendItemVisibility");
        }
        get legendItemBadgeTemplateRef() {
            return this.c0;
        }
        set legendItemBadgeTemplateRef(a) {
            this.c0 = a;
            this.g("LegendItemBadgeTemplateRef");
        }
        get actualLegendItemBadgeTemplateRef() {
            return this.cg;
        }
        set actualLegendItemBadgeTemplateRef(a) {
            this.cg = a;
            this.g("ActualLegendItemBadgeTemplateRef");
        }
        get actualLegendItemBadgeOutline() {
            return this.cf;
        }
        set actualLegendItemBadgeOutline(a) {
            this.cf = a;
            this.g("ActualLegendItemBadgeOutline");
        }
        get actualLegendItemBadgeBrush() {
            return this.ce;
        }
        set actualLegendItemBadgeBrush(a) {
            this.ce = a;
            this.g("ActualLegendItemBadgeBrush");
        }
        get legendItemBadgeShape() {
            return this.cz;
        }
        set legendItemBadgeShape(a) {
            this.cz = a;
            this.g("LegendItemBadgeShape");
        }
        get legendItemBadgeMode() {
            return this.cy;
        }
        set legendItemBadgeMode(a) {
            this.cy = a;
            this.g("LegendItemBadgeMode");
        }
        get legendItemTemplateRef() {
            return this.c1;
        }
        set legendItemTemplateRef(a) {
            this.c1 = a;
            this.g("LegendItemTemplateRef");
        }
        get discreteLegendItemTemplateRef() {
            return this.cq;
        }
        set discreteLegendItemTemplateRef(a) {
            this.cq = a;
            this.g("DiscreteLegendItemTemplateRef");
        }
        get transitionEasingFunctionRef() {
            return this.de;
        }
        set transitionEasingFunctionRef(a) {
            this.de = a;
            this.g("TransitionEasingFunctionRef");
        }
        get transitionInEasingFunctionRef() {
            return this.df;
        }
        set transitionInEasingFunctionRef(a) {
            this.df = a;
            this.g("TransitionInEasingFunctionRef");
        }
        get transitionOutEasingFunctionRef() {
            return this.di;
        }
        set transitionOutEasingFunctionRef(a) {
            this.di = a;
            this.g("TransitionOutEasingFunctionRef");
        }
        get transitionDuration() {
            return this.b3;
        }
        set transitionDuration(a) {
            this.b3 = a;
            this.g("TransitionDuration");
        }
        get actualResolution() {
            return this.az;
        }
        set actualResolution(a) {
            this.az = a;
            this.g("ActualResolution");
        }
        get resolution() {
            return this.a8;
        }
        set resolution(a) {
            this.a8 = a;
            this.g("Resolution");
        }
        get visibleRangeMarginTop() {
            return this.bg;
        }
        set visibleRangeMarginTop(a) {
            this.bg = a;
            this.g("VisibleRangeMarginTop");
        }
        get visibleRangeMarginBottom() {
            return this.bd;
        }
        set visibleRangeMarginBottom(a) {
            this.bd = a;
            this.g("VisibleRangeMarginBottom");
        }
        get visibleRangeMarginLeft() {
            return this.be;
        }
        set visibleRangeMarginLeft(a) {
            this.be = a;
            this.g("VisibleRangeMarginLeft");
        }
        get visibleRangeMarginRight() {
            return this.bf;
        }
        set visibleRangeMarginRight(a) {
            this.bf = a;
            this.g("VisibleRangeMarginRight");
        }
        get highlightedTitleSuffix() {
            return this.cu;
        }
        set highlightedTitleSuffix(a) {
            this.cu = a;
            this.g("HighlightedTitleSuffix");
        }
        get highlightedLegendItemVisibility() {
            return this.ct;
        }
        set highlightedLegendItemVisibility(a) {
            this.ct = a;
            this.g("HighlightedLegendItemVisibility");
        }
        get brush() {
            return this.cm;
        }
        set brush(a) {
            this.cm = a;
            this.g("Brush");
        }
        get actualBrush() {
            return this.b9;
        }
        set actualBrush(a) {
            this.b9 = a;
            this.g("ActualBrush");
        }
        get selectionBrush() {
            return this.da;
        }
        set selectionBrush(a) {
            this.da = a;
            this.g("SelectionBrush");
        }
        get focusBrush() {
            return this.cr;
        }
        set focusBrush(a) {
            this.cr = a;
            this.g("FocusBrush");
        }
        get actualSelectionBrush() {
            return this.ci;
        }
        set actualSelectionBrush(a) {
            this.ci = a;
            this.g("ActualSelectionBrush");
        }
        get actualFocusBrush() {
            return this.ca;
        }
        set actualFocusBrush(a) {
            this.ca = a;
            this.g("ActualFocusBrush");
        }
        get safeActualBrush() {
            return this.c9;
        }
        set safeActualBrush(a) {
            this.c9 = a;
            this.g("SafeActualBrush");
        }
        get outline() {
            return this.c6;
        }
        set outline(a) {
            this.c6 = a;
            this.g("Outline");
        }
        get actualOutline() {
            return this.ch;
        }
        set actualOutline(a) {
            this.ch = a;
            this.g("ActualOutline");
        }
        get lineJoin() {
            return this.c5;
        }
        set lineJoin(a) {
            this.c5 = a;
            this.g("LineJoin");
        }
        get highlightedValuesDisplayMode() {
            return this.cw;
        }
        set highlightedValuesDisplayMode(a) {
            this.cw = a;
            this.g("HighlightedValuesDisplayMode");
        }
        get shouldAnimateOnDataSourceSwap() {
            return this.aa;
        }
        set shouldAnimateOnDataSourceSwap(a) {
            this.aa = a;
            this.g("ShouldAnimateOnDataSourceSwap");
        }
        get thickness() {
            return this.bc;
        }
        set thickness(a) {
            this.bc = a;
            this.g("Thickness");
        }
        get actualThickness() {
            return this.a0;
        }
        set actualThickness(a) {
            this.a0 = a;
            this.g("ActualThickness");
        }
        get dashArray() {
            return this.k;
        }
        set dashArray(a) {
            this.k = a;
            this.g("DashArray");
        }
        get actualHighlightingMode() {
            return this.cc;
        }
        set actualHighlightingMode(a) {
            this.cc = a;
            this.g("ActualHighlightingMode");
        }
        get actualSelectionMode() {
            return this.cj;
        }
        set actualSelectionMode(a) {
            this.cj = a;
            this.g("ActualSelectionMode");
        }
        get actualFocusMode() {
            return this.cb;
        }
        set actualFocusMode(a) {
            this.cb = a;
            this.g("ActualFocusMode");
        }
        get actualHighlightedValuesFadeOpacity() {
            return this.aw;
        }
        set actualHighlightedValuesFadeOpacity(a) {
            this.aw = a;
            this.g("ActualHighlightedValuesFadeOpacity");
        }
        get highlightedValuesFadeOpacity() {
            return this.a3;
        }
        set highlightedValuesFadeOpacity(a) {
            this.a3 = a;
            this.g("HighlightedValuesFadeOpacity");
        }
        get actualHighlightingFadeOpacity() {
            return this.ax;
        }
        set actualHighlightingFadeOpacity(a) {
            this.ax = a;
            this.g("ActualHighlightingFadeOpacity");
        }
        get highlightingFadeOpacity() {
            return this.a4;
        }
        set highlightingFadeOpacity(a) {
            this.a4 = a;
            this.g("HighlightingFadeOpacity");
        }
        get isActualLegendFinancial() {
            return this.u;
        }
        set isActualLegendFinancial(a) {
            this.u = a;
            this.g("IsActualLegendFinancial");
        }
        get isComponentHighlightingModeIgnored() {
            return this.v;
        }
        set isComponentHighlightingModeIgnored(a) {
            this.v = a;
            this.g("IsComponentHighlightingModeIgnored");
        }
        get isHighlightingEnabled() {
            return this.y;
        }
        set isHighlightingEnabled(a) {
            this.y = a;
            this.g("IsHighlightingEnabled");
        }
        get useItemWiseColors() {
            return this.af;
        }
        set useItemWiseColors(a) {
            this.af = a;
            this.g("UseItemWiseColors");
        }
        get shouldShiftOpacityForSafeActualBrush() {
            return this.ad;
        }
        set shouldShiftOpacityForSafeActualBrush(a) {
            this.ad = a;
            this.g("ShouldShiftOpacityForSafeActualBrush");
        }
        get shouldRemoveHighlightedDataOnLayerHidden() {
            return this.ac;
        }
        set shouldRemoveHighlightedDataOnLayerHidden(a) {
            this.ac = a;
            this.g("ShouldRemoveHighlightedDataOnLayerHidden");
        }
        get shouldHideAutoCallouts() {
            return this.ab;
        }
        set shouldHideAutoCallouts(a) {
            this.ab = a;
            this.g("ShouldHideAutoCallouts");
        }
        get isDropShadowEnabled() {
            return this.x;
        }
        set isDropShadowEnabled(a) {
            this.x = a;
            this.g("IsDropShadowEnabled");
        }
        get shadowBlur() {
            return this.a9;
        }
        set shadowBlur(a) {
            this.a9 = a;
            this.g("ShadowBlur");
        }
        get shadowColor() {
            return this.db;
        }
        set shadowColor(a) {
            this.db = a;
            this.g("ShadowColor");
        }
        get useSingleShadow() {
            return this.ag;
        }
        set useSingleShadow(a) {
            this.ag = a;
            this.g("UseSingleShadow");
        }
        get shadowOffsetX() {
            return this.ba;
        }
        set shadowOffsetX(a) {
            this.ba = a;
            this.g("ShadowOffsetX");
        }
        get shadowOffsetY() {
            return this.bb;
        }
        set shadowOffsetY(a) {
            this.bb = a;
            this.g("ShadowOffsetY");
        }
        get areaFillOpacity() {
            return this.a1;
        }
        set areaFillOpacity(a) {
            this.a1 = a;
            this.g("AreaFillOpacity");
        }
        get actualAreaFillOpacity() {
            return this.av;
        }
        set actualAreaFillOpacity(a) {
            this.av = a;
            this.g("ActualAreaFillOpacity");
        }
        get markerFillOpacity() {
            return this.a5;
        }
        set markerFillOpacity(a) {
            this.a5 = a;
            this.g("MarkerFillOpacity");
        }
        get actualMarkerFillOpacity() {
            return this.ay;
        }
        set actualMarkerFillOpacity(a) {
            this.ay = a;
            this.g("ActualMarkerFillOpacity");
        }
        get isDefaultToolTipSelected() {
            return this.w;
        }
        set isDefaultToolTipSelected(a) {
            this.w = a;
            this.g("IsDefaultToolTipSelected");
        }
        get showDefaultTooltip() {
            return this.ae;
        }
        set showDefaultTooltip(a) {
            this.ae = a;
            this.g("ShowDefaultTooltip");
        }
        get visibleRangeMode() {
            return this.dl;
        }
        set visibleRangeMode(a) {
            this.dl = a;
            this.g("VisibleRangeMode");
        }
        get outlineMode() {
            return this.c7;
        }
        set outlineMode(a) {
            this.c7 = a;
            this.g("OutlineMode");
        }
        get transitionInDuration() {
            return this.b4;
        }
        set transitionInDuration(a) {
            this.b4 = a;
            this.g("TransitionInDuration");
        }
        get transitionOutDuration() {
            return this.b5;
        }
        set transitionOutDuration(a) {
            this.b5 = a;
            this.g("TransitionOutDuration");
        }
        get transitionInSpeedType() {
            return this.dg;
        }
        set transitionInSpeedType(a) {
            this.dg = a;
            this.g("TransitionInSpeedType");
        }
        get transitionOutSpeedType() {
            return this.dj;
        }
        set transitionOutSpeedType(a) {
            this.dj = a;
            this.g("TransitionOutSpeedType");
        }
        get lineCap() {
            return this.c4;
        }
        set lineCap(a) {
            this.c4 = a;
            this.g("LineCap");
        }
        get autoCalloutLabelFormat() {
            return this.ck;
        }
        set autoCalloutLabelFormat(a) {
            this.ck = a;
            this.g("AutoCalloutLabelFormat");
        }
        get autoCalloutLabelFormatSpecifiers() {
            return this.i;
        }
        set autoCalloutLabelFormatSpecifiers(a) {
            this.i = a;
            this.g("AutoCalloutLabelFormatSpecifiers");
        }
        get autoCalloutValueLabelFormat() {
            return this.cl;
        }
        set autoCalloutValueLabelFormat(a) {
            this.cl = a;
            this.g("AutoCalloutValueLabelFormat");
        }
        get autoCalloutValueLabelFormatSpecifiers() {
            return this.j;
        }
        set autoCalloutValueLabelFormatSpecifiers(a) {
            this.j = a;
            this.g("AutoCalloutValueLabelFormatSpecifiers");
        }
        get mouseOverEnabled() {
            return this.z;
        }
        set mouseOverEnabled(a) {
            this.z = a;
            this.g("MouseOverEnabled");
        }
        get coercionMethodsRef() {
            return this.cn;
        }
        set coercionMethodsRef(a) {
            this.cn = a;
            this.g("CoercionMethodsRef");
        }
        get expectFunctions() {
            return this.t;
        }
        set expectFunctions(a) {
            this.t = a;
            this.g("ExpectFunctions");
        }
        get hitTestMode() {
            return this.cx;
        }
        set hitTestMode(a) {
            this.cx = a;
            this.g("HitTestMode");
        }
        get actualHitTestMode() {
            return this.cd;
        }
        set actualHitTestMode(a) {
            this.cd = a;
            this.g("ActualHitTestMode");
        }
        get finalValue() {
            return this.a2;
        }
        set finalValue(a) {
            this.a2 = a;
            this.g("FinalValue");
        }
        get percentChange() {
            return this.a7;
        }
        set percentChange(a) {
            this.a7 = a;
            this.g("PercentChange");
        }
        get layers() {
            return this.m;
        }
        set layers(a) {
            this.m = a;
            this.g("Layers");
        }
        get actualLayers() {
            return this.h;
        }
        set actualLayers(a) {
            this.h = a;
            this.g("ActualLayers");
        }
        get opacity() {
            return this.a6;
        }
        set opacity(a) {
            this.a6 = a;
            this.g("Opacity");
        }
        get visibility() {
            return this.dk;
        }
        set visibility(a) {
            this.dk = a;
            this.g("Visibility");
        }
        get transitionOutCompletedRef() {
            return this.dh;
        }
        set transitionOutCompletedRef(a) {
            this.dh = a;
            this.g("TransitionOutCompletedRef");
        }
        get renderRequestedRef() {
            return this.c8;
        }
        set renderRequestedRef(a) {
            this.c8 = a;
            this.g("RenderRequestedRef");
        }
        get tooltipTemplateRef() {
            return this.dd;
        }
        set tooltipTemplateRef(a) {
            this.dd = a;
            this.g("TooltipTemplateRef");
        }
        get title() {
            return this.dc;
        }
        set title(a) {
            this.dc = a;
            this.g("Title");
        }
    }
    SeriesDescription.$t = /*@__PURE__*/ markType(SeriesDescription, 'SeriesDescription', Description.$);
    return SeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MarkerSeriesDescription = /*@__PURE__*/ (() => {
    class MarkerSeriesDescription extends SeriesDescription {
        get_type() {
            return "MarkerSeries";
        }
        constructor() {
            super();
            this.fc = null;
            this.e6 = null;
            this.fa = null;
            this.e8 = null;
            this.fb = null;
            this.e1 = 0;
            this.e5 = null;
            this.e7 = null;
            this.e3 = null;
            this.e9 = null;
            this.e4 = null;
        }
        get markerType() {
            return this.fc;
        }
        set markerType(a) {
            this.fc = a;
            this.g("MarkerType");
        }
        get actualMarkerType() {
            return this.e6;
        }
        set actualMarkerType(a) {
            this.e6 = a;
            this.g("ActualMarkerType");
        }
        get markerOutlineMode() {
            return this.fa;
        }
        set markerOutlineMode(a) {
            this.fa = a;
            this.g("MarkerOutlineMode");
        }
        get markerFillMode() {
            return this.e8;
        }
        set markerFillMode(a) {
            this.e8 = a;
            this.g("MarkerFillMode");
        }
        get markerTemplateRef() {
            return this.fb;
        }
        set markerTemplateRef(a) {
            this.fb = a;
            this.g("MarkerTemplateRef");
        }
        get markerThickness() {
            return this.e1;
        }
        set markerThickness(a) {
            this.e1 = a;
            this.g("MarkerThickness");
        }
        get actualMarkerTemplateRef() {
            return this.e5;
        }
        set actualMarkerTemplateRef(a) {
            this.e5 = a;
            this.g("ActualMarkerTemplateRef");
        }
        get markerBrush() {
            return this.e7;
        }
        set markerBrush(a) {
            this.e7 = a;
            this.g("MarkerBrush");
        }
        get actualMarkerBrush() {
            return this.e3;
        }
        set actualMarkerBrush(a) {
            this.e3 = a;
            this.g("ActualMarkerBrush");
        }
        get markerOutline() {
            return this.e9;
        }
        set markerOutline(a) {
            this.e9 = a;
            this.g("MarkerOutline");
        }
        get actualMarkerOutline() {
            return this.e4;
        }
        set actualMarkerOutline(a) {
            this.e4 = a;
            this.g("ActualMarkerOutline");
        }
    }
    MarkerSeriesDescription.$t = /*@__PURE__*/ markType(MarkerSeriesDescription, 'MarkerSeriesDescription', SeriesDescription.$);
    return MarkerSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategorySeriesDescription = /*@__PURE__*/ (() => {
    class CategorySeriesDescription extends MarkerSeriesDescription {
        get_type() {
            return "CategorySeries";
        }
        constructor() {
            super();
            this.fo = false;
            this.fn = false;
            this.fq = false;
            this.fx = null;
            this.fp = false;
            this.fw = null;
            this.fv = null;
        }
        get isCustomCategoryStyleAllowed() {
            return this.fo;
        }
        set isCustomCategoryStyleAllowed(a) {
            this.fo = a;
            this.g("IsCustomCategoryStyleAllowed");
        }
        get isCustomCategoryMarkerStyleAllowed() {
            return this.fn;
        }
        set isCustomCategoryMarkerStyleAllowed(a) {
            this.fn = a;
            this.g("IsCustomCategoryMarkerStyleAllowed");
        }
        get useHighMarkerFidelity() {
            return this.fq;
        }
        set useHighMarkerFidelity(a) {
            this.fq = a;
            this.g("UseHighMarkerFidelity");
        }
        get transitionInMode() {
            return this.fx;
        }
        set transitionInMode(a) {
            this.fx = a;
            this.g("TransitionInMode");
        }
        get isTransitionInEnabled() {
            return this.fp;
        }
        set isTransitionInEnabled(a) {
            this.fp = a;
            this.g("IsTransitionInEnabled");
        }
        get assigningCategoryStyleRef() {
            return this.fw;
        }
        set assigningCategoryStyleRef(a) {
            this.fw = a;
            this.g("AssigningCategoryStyleRef");
        }
        get assigningCategoryMarkerStyleRef() {
            return this.fv;
        }
        set assigningCategoryMarkerStyleRef(a) {
            this.fv = a;
            this.g("AssigningCategoryMarkerStyleRef");
        }
    }
    CategorySeriesDescription.$t = /*@__PURE__*/ markType(CategorySeriesDescription, 'CategorySeriesDescription', MarkerSeriesDescription.$);
    return CategorySeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnchoredCategorySeriesDescription = /*@__PURE__*/ (() => {
    class AnchoredCategorySeriesDescription extends CategorySeriesDescription {
        get_type() {
            return "AnchoredCategorySeries";
        }
        constructor() {
            super();
            this.gf = null;
            this.f9 = null;
            this.gd = null;
            this.ge = null;
            this.gc = null;
            this.gb = null;
            this.f7 = null;
            this.f3 = 0;
            this.f1 = null;
            this.f5 = 0;
            this.ga = null;
            this.f8 = null;
        }
        get valueMemberPath() {
            return this.gf;
        }
        set valueMemberPath(a) {
            this.gf = a;
            this.g("ValueMemberPath");
        }
        get highlightedValueMemberPath() {
            return this.f9;
        }
        set highlightedValueMemberPath(a) {
            this.f9 = a;
            this.g("HighlightedValueMemberPath");
        }
        get valueMemberAsLegendLabel() {
            return this.gd;
        }
        set valueMemberAsLegendLabel(a) {
            this.gd = a;
            this.g("ValueMemberAsLegendLabel");
        }
        get valueMemberAsLegendUnit() {
            return this.ge;
        }
        set valueMemberAsLegendUnit(a) {
            this.ge = a;
            this.g("ValueMemberAsLegendUnit");
        }
        get trendLineType() {
            return this.gc;
        }
        set trendLineType(a) {
            this.gc = a;
            this.g("TrendLineType");
        }
        get trendLineBrush() {
            return this.gb;
        }
        set trendLineBrush(a) {
            this.gb = a;
            this.g("TrendLineBrush");
        }
        get actualTrendLineBrush() {
            return this.f7;
        }
        set actualTrendLineBrush(a) {
            this.f7 = a;
            this.g("ActualTrendLineBrush");
        }
        get trendLineThickness() {
            return this.f3;
        }
        set trendLineThickness(a) {
            this.f3 = a;
            this.g("TrendLineThickness");
        }
        get trendLineDashArray() {
            return this.f1;
        }
        set trendLineDashArray(a) {
            this.f1 = a;
            this.g("TrendLineDashArray");
        }
        get trendLinePeriod() {
            return this.f5;
        }
        set trendLinePeriod(a) {
            this.f5 = a;
            this.g("TrendLinePeriod");
        }
        get markerCollisionAvoidance() {
            return this.ga;
        }
        set markerCollisionAvoidance(a) {
            this.ga = a;
            this.g("MarkerCollisionAvoidance");
        }
        get consolidatedItemHitTestBehavior() {
            return this.f8;
        }
        set consolidatedItemHitTestBehavior(a) {
            this.f8 = a;
            this.g("ConsolidatedItemHitTestBehavior");
        }
    }
    AnchoredCategorySeriesDescription.$t = /*@__PURE__*/ markType(AnchoredCategorySeriesDescription, 'AnchoredCategorySeriesDescription', CategorySeriesDescription.$);
    return AnchoredCategorySeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalAnchoredCategorySeriesDescription = /*@__PURE__*/ (() => {
    class HorizontalAnchoredCategorySeriesDescription extends AnchoredCategorySeriesDescription {
        get_type() {
            return "HorizontalAnchoredCategorySeries";
        }
        constructor() {
            super();
            this.gp = null;
            this.gq = null;
        }
        get xAxisRef() {
            return this.gp;
        }
        set xAxisRef(a) {
            this.gp = a;
            this.g("XAxisRef");
        }
        get yAxisRef() {
            return this.gq;
        }
        set yAxisRef(a) {
            this.gq = a;
            this.g("YAxisRef");
        }
    }
    HorizontalAnchoredCategorySeriesDescription.$t = /*@__PURE__*/ markType(HorizontalAnchoredCategorySeriesDescription, 'HorizontalAnchoredCategorySeriesDescription', AnchoredCategorySeriesDescription.$);
    return HorizontalAnchoredCategorySeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineSeriesDescription = /*@__PURE__*/ (() => {
    class LineSeriesDescription extends HorizontalAnchoredCategorySeriesDescription {
        get_type() {
            return "LineSeries";
        }
        constructor() {
            super();
            this.gt = null;
        }
        get unknownValuePlotting() {
            return this.gt;
        }
        set unknownValuePlotting(a) {
            this.gt = a;
            this.g("UnknownValuePlotting");
        }
    }
    LineSeriesDescription.$t = /*@__PURE__*/ markType(LineSeriesDescription, 'LineSeriesDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return LineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class LineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (LineSeriesDescriptionMetadata.a == null) {
                LineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LineSeriesDescriptionMetadata.c(LineSeriesDescriptionMetadata.a);
            }
            if (a.k(LineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(LineSeriesDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a);
            a.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            a.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
        }
        static d(a) {
            LineSeriesDescriptionMetadata.b(a);
            a.ae("LineSeries", () => new LineSeriesDescription());
            a.ad("LineSeries", LineSeriesDescriptionMetadata.a);
        }
    }
    LineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(LineSeriesDescriptionMetadata, 'LineSeriesDescriptionMetadata');
    LineSeriesDescriptionMetadata.a = null;
    return LineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class LineSeriesDescriptionModule extends Base {
        static register(a) {
            LineSeriesDescriptionMetadata.d(a);
        }
    }
    LineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(LineSeriesDescriptionModule, 'LineSeriesDescriptionModule');
    return LineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AreaSeriesDescription = /*@__PURE__*/ (() => {
    class AreaSeriesDescription extends HorizontalAnchoredCategorySeriesDescription {
        get_type() {
            return "AreaSeries";
        }
        constructor() {
            super();
            this.gt = null;
        }
        get unknownValuePlotting() {
            return this.gt;
        }
        set unknownValuePlotting(a) {
            this.gt = a;
            this.g("UnknownValuePlotting");
        }
    }
    AreaSeriesDescription.$t = /*@__PURE__*/ markType(AreaSeriesDescription, 'AreaSeriesDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return AreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class AreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (AreaSeriesDescriptionMetadata.a == null) {
                AreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AreaSeriesDescriptionMetadata.c(AreaSeriesDescriptionMetadata.a);
            }
            if (a.k(AreaSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(AreaSeriesDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a);
            a.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            a.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
        }
        static d(a) {
            AreaSeriesDescriptionMetadata.b(a);
            a.ae("AreaSeries", () => new AreaSeriesDescription());
            a.ad("AreaSeries", AreaSeriesDescriptionMetadata.a);
        }
    }
    AreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(AreaSeriesDescriptionMetadata, 'AreaSeriesDescriptionMetadata');
    AreaSeriesDescriptionMetadata.a = null;
    return AreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class AreaSeriesDescriptionModule extends Base {
        static register(a) {
            AreaSeriesDescriptionMetadata.d(a);
        }
    }
    AreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(AreaSeriesDescriptionModule, 'AreaSeriesDescriptionModule');
    return AreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSeriesDescription = /*@__PURE__*/ (() => {
    class ColumnSeriesDescription extends HorizontalAnchoredCategorySeriesDescription {
        get_type() {
            return "ColumnSeries";
        }
        constructor() {
            super();
            this.gt = 0;
            this.gu = 0;
            this.gx = null;
        }
        get radiusX() {
            return this.gt;
        }
        set radiusX(a) {
            this.gt = a;
            this.g("RadiusX");
        }
        get radiusY() {
            return this.gu;
        }
        set radiusY(a) {
            this.gu = a;
            this.g("RadiusY");
        }
        get consolidatedColumnVerticalPosition() {
            return this.gx;
        }
        set consolidatedColumnVerticalPosition(a) {
            this.gx = a;
            this.g("ConsolidatedColumnVerticalPosition");
        }
    }
    ColumnSeriesDescription.$t = /*@__PURE__*/ markType(ColumnSeriesDescription, 'ColumnSeriesDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return ColumnSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnSeriesDescriptionMetadata.a == null) {
                ColumnSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnSeriesDescriptionMetadata.c(ColumnSeriesDescriptionMetadata.a);
            }
            if (a.k(ColumnSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnSeriesDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a);
            a.item("RadiusX", "Number:double");
            a.item("RadiusY", "Number:double");
            a.item("ConsolidatedColumnVerticalPosition", "ExportedType:string:ConsolidatedItemsPosition");
            a.item("ConsolidatedColumnVerticalPosition@names", "Minimum;Maximum;Median;RelativeMinimum;RelativeMaximum");
        }
        static d(a) {
            ColumnSeriesDescriptionMetadata.b(a);
            a.ae("ColumnSeries", () => new ColumnSeriesDescription());
            a.ad("ColumnSeries", ColumnSeriesDescriptionMetadata.a);
        }
    }
    ColumnSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnSeriesDescriptionMetadata, 'ColumnSeriesDescriptionMetadata');
    ColumnSeriesDescriptionMetadata.a = null;
    return ColumnSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnSeriesDescriptionModule extends Base {
        static register(a) {
            ColumnSeriesDescriptionMetadata.d(a);
        }
    }
    ColumnSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ColumnSeriesDescriptionModule, 'ColumnSeriesDescriptionModule');
    return ColumnSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class SplineSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (SplineSeriesBaseDescriptionMetadata.a == null) {
                SplineSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SplineSeriesBaseDescriptionMetadata.c(SplineSeriesBaseDescriptionMetadata.a);
            }
            if (a.k(SplineSeriesBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(SplineSeriesBaseDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a);
            a.item("IsSplineShapePartOfRange", "Boolean");
            a.item("SplineType", "ExportedType:string:SplineType");
            a.item("SplineType@names", "Natural;Clamped");
        }
        static d(a) {
            SplineSeriesBaseDescriptionMetadata.b(a);
            a.ad("SplineSeriesBase", SplineSeriesBaseDescriptionMetadata.a);
        }
    }
    SplineSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(SplineSeriesBaseDescriptionMetadata, 'SplineSeriesBaseDescriptionMetadata');
    SplineSeriesBaseDescriptionMetadata.a = null;
    return SplineSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineSeriesBaseDescription = /*@__PURE__*/ (() => {
    class SplineSeriesBaseDescription extends HorizontalAnchoredCategorySeriesDescription {
        get_type() {
            return "SplineSeriesBase";
        }
        constructor() {
            super();
            this.gt = false;
            this.gv = null;
        }
        get isSplineShapePartOfRange() {
            return this.gt;
        }
        set isSplineShapePartOfRange(a) {
            this.gt = a;
            this.g("IsSplineShapePartOfRange");
        }
        get splineType() {
            return this.gv;
        }
        set splineType(a) {
            this.gv = a;
            this.g("SplineType");
        }
    }
    SplineSeriesBaseDescription.$t = /*@__PURE__*/ markType(SplineSeriesBaseDescription, 'SplineSeriesBaseDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return SplineSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineSeriesDescription = /*@__PURE__*/ (() => {
    class SplineSeriesDescription extends SplineSeriesBaseDescription {
        get_type() {
            return "SplineSeries";
        }
        constructor() {
            super();
        }
    }
    SplineSeriesDescription.$t = /*@__PURE__*/ markType(SplineSeriesDescription, 'SplineSeriesDescription', SplineSeriesBaseDescription.$);
    return SplineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class SplineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (SplineSeriesDescriptionMetadata.a == null) {
                SplineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SplineSeriesDescriptionMetadata.c(SplineSeriesDescriptionMetadata.a);
            }
            if (a.k(SplineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(SplineSeriesDescriptionMetadata.a);
        }
        static c(a) {
            SplineSeriesBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            SplineSeriesDescriptionMetadata.b(a);
            a.ae("SplineSeries", () => new SplineSeriesDescription());
            a.ad("SplineSeries", SplineSeriesDescriptionMetadata.a);
        }
    }
    SplineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(SplineSeriesDescriptionMetadata, 'SplineSeriesDescriptionMetadata');
    SplineSeriesDescriptionMetadata.a = null;
    return SplineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class SplineSeriesDescriptionModule extends Base {
        static register(a) {
            SplineSeriesDescriptionMetadata.d(a);
        }
    }
    SplineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(SplineSeriesDescriptionModule, 'SplineSeriesDescriptionModule');
    return SplineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineAreaSeriesDescription = /*@__PURE__*/ (() => {
    class SplineAreaSeriesDescription extends SplineSeriesBaseDescription {
        get_type() {
            return "SplineAreaSeries";
        }
        constructor() {
            super();
        }
    }
    SplineAreaSeriesDescription.$t = /*@__PURE__*/ markType(SplineAreaSeriesDescription, 'SplineAreaSeriesDescription', SplineSeriesBaseDescription.$);
    return SplineAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class SplineAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (SplineAreaSeriesDescriptionMetadata.a == null) {
                SplineAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SplineAreaSeriesDescriptionMetadata.c(SplineAreaSeriesDescriptionMetadata.a);
            }
            if (a.k(SplineAreaSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(SplineAreaSeriesDescriptionMetadata.a);
        }
        static c(a) {
            SplineSeriesBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            SplineAreaSeriesDescriptionMetadata.b(a);
            a.ae("SplineAreaSeries", () => new SplineAreaSeriesDescription());
            a.ad("SplineAreaSeries", SplineAreaSeriesDescriptionMetadata.a);
        }
    }
    SplineAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(SplineAreaSeriesDescriptionMetadata, 'SplineAreaSeriesDescriptionMetadata');
    SplineAreaSeriesDescriptionMetadata.a = null;
    return SplineAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class SplineAreaSeriesDescriptionModule extends Base {
        static register(a) {
            SplineAreaSeriesDescriptionMetadata.d(a);
        }
    }
    SplineAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(SplineAreaSeriesDescriptionModule, 'SplineAreaSeriesDescriptionModule');
    return SplineAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StepLineSeriesDescription = /*@__PURE__*/ (() => {
    class StepLineSeriesDescription extends HorizontalAnchoredCategorySeriesDescription {
        get_type() {
            return "StepLineSeries";
        }
        constructor() {
            super();
        }
    }
    StepLineSeriesDescription.$t = /*@__PURE__*/ markType(StepLineSeriesDescription, 'StepLineSeriesDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return StepLineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StepLineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StepLineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StepLineSeriesDescriptionMetadata.a == null) {
                StepLineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StepLineSeriesDescriptionMetadata.c(StepLineSeriesDescriptionMetadata.a);
            }
            if (a.k(StepLineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(StepLineSeriesDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a);
        }
        static d(a) {
            StepLineSeriesDescriptionMetadata.b(a);
            a.ae("StepLineSeries", () => new StepLineSeriesDescription());
            a.ad("StepLineSeries", StepLineSeriesDescriptionMetadata.a);
        }
    }
    StepLineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StepLineSeriesDescriptionMetadata, 'StepLineSeriesDescriptionMetadata');
    StepLineSeriesDescriptionMetadata.a = null;
    return StepLineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StepLineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StepLineSeriesDescriptionModule extends Base {
        static register(a) {
            StepLineSeriesDescriptionMetadata.d(a);
        }
    }
    StepLineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StepLineSeriesDescriptionModule, 'StepLineSeriesDescriptionModule');
    return StepLineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StepAreaSeriesDescription = /*@__PURE__*/ (() => {
    class StepAreaSeriesDescription extends HorizontalAnchoredCategorySeriesDescription {
        get_type() {
            return "StepAreaSeries";
        }
        constructor() {
            super();
        }
    }
    StepAreaSeriesDescription.$t = /*@__PURE__*/ markType(StepAreaSeriesDescription, 'StepAreaSeriesDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return StepAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StepAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StepAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StepAreaSeriesDescriptionMetadata.a == null) {
                StepAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StepAreaSeriesDescriptionMetadata.c(StepAreaSeriesDescriptionMetadata.a);
            }
            if (a.k(StepAreaSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(StepAreaSeriesDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a);
        }
        static d(a) {
            StepAreaSeriesDescriptionMetadata.b(a);
            a.ae("StepAreaSeries", () => new StepAreaSeriesDescription());
            a.ad("StepAreaSeries", StepAreaSeriesDescriptionMetadata.a);
        }
    }
    StepAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StepAreaSeriesDescriptionMetadata, 'StepAreaSeriesDescriptionMetadata');
    StepAreaSeriesDescriptionMetadata.a = null;
    return StepAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StepAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StepAreaSeriesDescriptionModule extends Base {
        static register(a) {
            StepAreaSeriesDescriptionMetadata.d(a);
        }
    }
    StepAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StepAreaSeriesDescriptionModule, 'StepAreaSeriesDescriptionModule');
    return StepAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointSeriesDescription = /*@__PURE__*/ (() => {
    class PointSeriesDescription extends HorizontalAnchoredCategorySeriesDescription {
        get_type() {
            return "PointSeries";
        }
        constructor() {
            super();
        }
    }
    PointSeriesDescription.$t = /*@__PURE__*/ markType(PointSeriesDescription, 'PointSeriesDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return PointSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class PointSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (PointSeriesDescriptionMetadata.a == null) {
                PointSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PointSeriesDescriptionMetadata.c(PointSeriesDescriptionMetadata.a);
            }
            if (a.k(PointSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(PointSeriesDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a);
        }
        static d(a) {
            PointSeriesDescriptionMetadata.b(a);
            a.ae("PointSeries", () => new PointSeriesDescription());
            a.ad("PointSeries", PointSeriesDescriptionMetadata.a);
        }
    }
    PointSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(PointSeriesDescriptionMetadata, 'PointSeriesDescriptionMetadata');
    PointSeriesDescriptionMetadata.a = null;
    return PointSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class PointSeriesDescriptionModule extends Base {
        static register(a) {
            PointSeriesDescriptionMetadata.d(a);
        }
    }
    PointSeriesDescriptionModule.$t = /*@__PURE__*/ markType(PointSeriesDescriptionModule, 'PointSeriesDescriptionModule');
    return PointSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WaterfallSeriesDescription = /*@__PURE__*/ (() => {
    class WaterfallSeriesDescription extends HorizontalAnchoredCategorySeriesDescription {
        get_type() {
            return "WaterfallSeries";
        }
        constructor() {
            super();
            this.gx = null;
            this.gt = 0;
            this.gu = 0;
            this.gy = null;
        }
        get negativeBrush() {
            return this.gx;
        }
        set negativeBrush(a) {
            this.gx = a;
            this.g("NegativeBrush");
        }
        get radiusX() {
            return this.gt;
        }
        set radiusX(a) {
            this.gt = a;
            this.g("RadiusX");
        }
        get radiusY() {
            return this.gu;
        }
        set radiusY(a) {
            this.gu = a;
            this.g("RadiusY");
        }
        get negativeOutline() {
            return this.gy;
        }
        set negativeOutline(a) {
            this.gy = a;
            this.g("NegativeOutline");
        }
    }
    WaterfallSeriesDescription.$t = /*@__PURE__*/ markType(WaterfallSeriesDescription, 'WaterfallSeriesDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return WaterfallSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WaterfallSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class WaterfallSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (WaterfallSeriesDescriptionMetadata.a == null) {
                WaterfallSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WaterfallSeriesDescriptionMetadata.c(WaterfallSeriesDescriptionMetadata.a);
            }
            if (a.k(WaterfallSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(WaterfallSeriesDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a);
            a.item("NegativeBrush", "Brush");
            a.item("RadiusX", "Number:double");
            a.item("RadiusY", "Number:double");
            a.item("NegativeOutline", "Brush");
        }
        static d(a) {
            WaterfallSeriesDescriptionMetadata.b(a);
            a.ae("WaterfallSeries", () => new WaterfallSeriesDescription());
            a.ad("WaterfallSeries", WaterfallSeriesDescriptionMetadata.a);
        }
    }
    WaterfallSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(WaterfallSeriesDescriptionMetadata, 'WaterfallSeriesDescriptionMetadata');
    WaterfallSeriesDescriptionMetadata.a = null;
    return WaterfallSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WaterfallSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class WaterfallSeriesDescriptionModule extends Base {
        static register(a) {
            WaterfallSeriesDescriptionMetadata.d(a);
        }
    }
    WaterfallSeriesDescriptionModule.$t = /*@__PURE__*/ markType(WaterfallSeriesDescriptionModule, 'WaterfallSeriesDescriptionModule');
    return WaterfallSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnnotationLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class AnnotationLayerDescriptionMetadata extends Base {
        static b(a) {
            if (AnnotationLayerDescriptionMetadata.a == null) {
                AnnotationLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AnnotationLayerDescriptionMetadata.c(AnnotationLayerDescriptionMetadata.a);
            }
            if (a.k(AnnotationLayerDescriptionMetadata.a)) {
                return;
            }
            a.ac(AnnotationLayerDescriptionMetadata.a);
        }
        static c(a) {
            SeriesDescriptionMetadata.c(a);
            a.item("UseIndex", "Boolean");
            a.item("UseLegend", "Boolean");
            a.item("CursorPosition", "Point");
            a.item("IsDefaultCrosshairDisabled", "Boolean");
            a.item("AppearanceMode", "ExportedType:string:AnnotationAppearanceMode");
            a.item("AppearanceMode@names", "Auto;BrightnessShift;SaturationShift;DashPattern;OpacityShift");
            a.item("ActualAppearanceMode", "ExportedType:string:AnnotationAppearanceMode");
            a.item("ActualAppearanceMode@names", "Auto;BrightnessShift;SaturationShift;DashPattern;OpacityShift");
            a.item("ShiftAmount", "Number:double");
            a.item("ActualShiftAmount", "Number:double");
            a.item("HorizontalAppearanceMode", "ExportedType:string:AnnotationAppearanceMode");
            a.item("HorizontalAppearanceMode@names", "Auto;BrightnessShift;SaturationShift;DashPattern;OpacityShift");
            a.item("ActualHorizontalAppearanceMode", "ExportedType:string:AnnotationAppearanceMode");
            a.item("ActualHorizontalAppearanceMode@names", "Auto;BrightnessShift;SaturationShift;DashPattern;OpacityShift");
            a.item("VerticalAppearanceMode", "ExportedType:string:AnnotationAppearanceMode");
            a.item("VerticalAppearanceMode@names", "Auto;BrightnessShift;SaturationShift;DashPattern;OpacityShift");
            a.item("ActualVerticalAppearanceMode", "ExportedType:string:AnnotationAppearanceMode");
            a.item("ActualVerticalAppearanceMode@names", "Auto;BrightnessShift;SaturationShift;DashPattern;OpacityShift");
            a.item("HorizontalShiftAmount", "Number:double");
            a.item("ActualHorizontalShiftAmount", "Number:double");
            a.item("VerticalShiftAmount", "Number:double");
            a.item("ActualVerticalShiftAmount", "Number:double");
            a.item("HorizontalDashArray", "DoubleCollection:double");
            a.item("ActualHorizontalDashArray", "DoubleCollection:double");
            a.item("VerticalDashArray", "DoubleCollection:double");
            a.item("ActualVerticalDashArray", "DoubleCollection:double");
            a.item("ShouldRenderAsOverlay", "Boolean");
        }
        static d(a) {
            AnnotationLayerDescriptionMetadata.b(a);
            a.ad("AnnotationLayer", AnnotationLayerDescriptionMetadata.a);
        }
    }
    AnnotationLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(AnnotationLayerDescriptionMetadata, 'AnnotationLayerDescriptionMetadata');
    AnnotationLayerDescriptionMetadata.a = null;
    return AnnotationLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnnotationLayerDescription = /*@__PURE__*/ (() => {
    class AnnotationLayerDescription extends SeriesDescription {
        get_type() {
            return "AnnotationLayer";
        }
        constructor() {
            super();
            this.fd = false;
            this.fe = false;
            this.e9 = null;
            this.fb = false;
            this.fy = null;
            this.fv = null;
            this.fn = 0;
            this.fk = 0;
            this.fz = null;
            this.fw = null;
            this.f0 = null;
            this.fx = null;
            this.fm = 0;
            this.fj = 0;
            this.fo = 0;
            this.fl = 0;
            this.e3 = null;
            this.e1 = null;
            this.e4 = null;
            this.e2 = null;
            this.fc = false;
        }
        get useIndex() {
            return this.fd;
        }
        set useIndex(a) {
            this.fd = a;
            this.g("UseIndex");
        }
        get useLegend() {
            return this.fe;
        }
        set useLegend(a) {
            this.fe = a;
            this.g("UseLegend");
        }
        get cursorPosition() {
            return this.e9;
        }
        set cursorPosition(a) {
            this.e9 = a;
            this.g("CursorPosition");
        }
        get isDefaultCrosshairDisabled() {
            return this.fb;
        }
        set isDefaultCrosshairDisabled(a) {
            this.fb = a;
            this.g("IsDefaultCrosshairDisabled");
        }
        get appearanceMode() {
            return this.fy;
        }
        set appearanceMode(a) {
            this.fy = a;
            this.g("AppearanceMode");
        }
        get actualAppearanceMode() {
            return this.fv;
        }
        set actualAppearanceMode(a) {
            this.fv = a;
            this.g("ActualAppearanceMode");
        }
        get shiftAmount() {
            return this.fn;
        }
        set shiftAmount(a) {
            this.fn = a;
            this.g("ShiftAmount");
        }
        get actualShiftAmount() {
            return this.fk;
        }
        set actualShiftAmount(a) {
            this.fk = a;
            this.g("ActualShiftAmount");
        }
        get horizontalAppearanceMode() {
            return this.fz;
        }
        set horizontalAppearanceMode(a) {
            this.fz = a;
            this.g("HorizontalAppearanceMode");
        }
        get actualHorizontalAppearanceMode() {
            return this.fw;
        }
        set actualHorizontalAppearanceMode(a) {
            this.fw = a;
            this.g("ActualHorizontalAppearanceMode");
        }
        get verticalAppearanceMode() {
            return this.f0;
        }
        set verticalAppearanceMode(a) {
            this.f0 = a;
            this.g("VerticalAppearanceMode");
        }
        get actualVerticalAppearanceMode() {
            return this.fx;
        }
        set actualVerticalAppearanceMode(a) {
            this.fx = a;
            this.g("ActualVerticalAppearanceMode");
        }
        get horizontalShiftAmount() {
            return this.fm;
        }
        set horizontalShiftAmount(a) {
            this.fm = a;
            this.g("HorizontalShiftAmount");
        }
        get actualHorizontalShiftAmount() {
            return this.fj;
        }
        set actualHorizontalShiftAmount(a) {
            this.fj = a;
            this.g("ActualHorizontalShiftAmount");
        }
        get verticalShiftAmount() {
            return this.fo;
        }
        set verticalShiftAmount(a) {
            this.fo = a;
            this.g("VerticalShiftAmount");
        }
        get actualVerticalShiftAmount() {
            return this.fl;
        }
        set actualVerticalShiftAmount(a) {
            this.fl = a;
            this.g("ActualVerticalShiftAmount");
        }
        get horizontalDashArray() {
            return this.e3;
        }
        set horizontalDashArray(a) {
            this.e3 = a;
            this.g("HorizontalDashArray");
        }
        get actualHorizontalDashArray() {
            return this.e1;
        }
        set actualHorizontalDashArray(a) {
            this.e1 = a;
            this.g("ActualHorizontalDashArray");
        }
        get verticalDashArray() {
            return this.e4;
        }
        set verticalDashArray(a) {
            this.e4 = a;
            this.g("VerticalDashArray");
        }
        get actualVerticalDashArray() {
            return this.e2;
        }
        set actualVerticalDashArray(a) {
            this.e2 = a;
            this.g("ActualVerticalDashArray");
        }
        get shouldRenderAsOverlay() {
            return this.fc;
        }
        set shouldRenderAsOverlay(a) {
            this.fc = a;
            this.g("ShouldRenderAsOverlay");
        }
    }
    AnnotationLayerDescription.$t = /*@__PURE__*/ markType(AnnotationLayerDescription, 'AnnotationLayerDescription', SeriesDescription.$);
    return AnnotationLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CrosshairLayerDescription = /*@__PURE__*/ (() => {
    class CrosshairLayerDescription extends AnnotationLayerDescription {
        get_type() {
            return "CrosshairLayer";
        }
        constructor() {
            super();
            this.g5 = null;
            this.g9 = null;
            this.g7 = null;
            this.g8 = null;
            this.f9 = false;
            this.f7 = false;
            this.he = null;
            this.hb = null;
            this.gd = 0;
            this.g1 = 0;
            this.hd = null;
            this.gf = 0;
            this.gh = 0;
            this.gg = 0;
            this.ge = 0;
            this.gl = 0;
            this.gn = 0;
            this.gm = 0;
            this.gk = 0;
            this.gi = 0;
            this.hi = null;
            this.hf = null;
            this.gj = 0;
            this.g2 = 0;
            this.hh = null;
            this.go = 0;
            this.ha = null;
            this.g6 = null;
            this.f8 = false;
            this.hc = null;
            this.hg = null;
        }
        get horizontalLineStroke() {
            return this.g5;
        }
        set horizontalLineStroke(a) {
            this.g5 = a;
            this.g("HorizontalLineStroke");
        }
        get verticalLineStroke() {
            return this.g9;
        }
        set verticalLineStroke(a) {
            this.g9 = a;
            this.g("VerticalLineStroke");
        }
        get targetSeriesName() {
            return this.g7;
        }
        set targetSeriesName(a) {
            this.g7 = a;
            this.g("TargetSeriesName");
        }
        get targetSeriesRef() {
            return this.g8;
        }
        set targetSeriesRef(a) {
            this.g8 = a;
            this.g("TargetSeriesRef");
        }
        get useInterpolation() {
            return this.f9;
        }
        set useInterpolation(a) {
            this.f9 = a;
            this.g("UseInterpolation");
        }
        get isAxisAnnotationEnabled() {
            return this.f7;
        }
        set isAxisAnnotationEnabled(a) {
            this.f7 = a;
            this.g("IsAxisAnnotationEnabled");
        }
        get xAxisAnnotationTextColor() {
            return this.he;
        }
        set xAxisAnnotationTextColor(a) {
            this.he = a;
            this.g("XAxisAnnotationTextColor");
        }
        get xAxisAnnotationBackground() {
            return this.hb;
        }
        set xAxisAnnotationBackground(a) {
            this.hb = a;
            this.g("XAxisAnnotationBackground");
        }
        get xAxisAnnotationBackgroundCornerRadius() {
            return this.gd;
        }
        set xAxisAnnotationBackgroundCornerRadius(a) {
            this.gd = a;
            this.g("XAxisAnnotationBackgroundCornerRadius");
        }
        get xAxisAnnotationInterpolatedValuePrecision() {
            return this.g1;
        }
        set xAxisAnnotationInterpolatedValuePrecision(a) {
            this.g1 = a;
            this.g("XAxisAnnotationInterpolatedValuePrecision");
        }
        get xAxisAnnotationOutline() {
            return this.hd;
        }
        set xAxisAnnotationOutline(a) {
            this.hd = a;
            this.g("XAxisAnnotationOutline");
        }
        get xAxisAnnotationPaddingLeft() {
            return this.gf;
        }
        set xAxisAnnotationPaddingLeft(a) {
            this.gf = a;
            this.g("XAxisAnnotationPaddingLeft");
        }
        get xAxisAnnotationPaddingTop() {
            return this.gh;
        }
        set xAxisAnnotationPaddingTop(a) {
            this.gh = a;
            this.g("XAxisAnnotationPaddingTop");
        }
        get xAxisAnnotationPaddingRight() {
            return this.gg;
        }
        set xAxisAnnotationPaddingRight(a) {
            this.gg = a;
            this.g("XAxisAnnotationPaddingRight");
        }
        get xAxisAnnotationPaddingBottom() {
            return this.ge;
        }
        set xAxisAnnotationPaddingBottom(a) {
            this.ge = a;
            this.g("XAxisAnnotationPaddingBottom");
        }
        get yAxisAnnotationPaddingLeft() {
            return this.gl;
        }
        set yAxisAnnotationPaddingLeft(a) {
            this.gl = a;
            this.g("YAxisAnnotationPaddingLeft");
        }
        get yAxisAnnotationPaddingTop() {
            return this.gn;
        }
        set yAxisAnnotationPaddingTop(a) {
            this.gn = a;
            this.g("YAxisAnnotationPaddingTop");
        }
        get yAxisAnnotationPaddingRight() {
            return this.gm;
        }
        set yAxisAnnotationPaddingRight(a) {
            this.gm = a;
            this.g("YAxisAnnotationPaddingRight");
        }
        get yAxisAnnotationPaddingBottom() {
            return this.gk;
        }
        set yAxisAnnotationPaddingBottom(a) {
            this.gk = a;
            this.g("YAxisAnnotationPaddingBottom");
        }
        get xAxisAnnotationStrokeThickness() {
            return this.gi;
        }
        set xAxisAnnotationStrokeThickness(a) {
            this.gi = a;
            this.g("XAxisAnnotationStrokeThickness");
        }
        get yAxisAnnotationTextColor() {
            return this.hi;
        }
        set yAxisAnnotationTextColor(a) {
            this.hi = a;
            this.g("YAxisAnnotationTextColor");
        }
        get yAxisAnnotationBackground() {
            return this.hf;
        }
        set yAxisAnnotationBackground(a) {
            this.hf = a;
            this.g("YAxisAnnotationBackground");
        }
        get yAxisAnnotationBackgroundCornerRadius() {
            return this.gj;
        }
        set yAxisAnnotationBackgroundCornerRadius(a) {
            this.gj = a;
            this.g("YAxisAnnotationBackgroundCornerRadius");
        }
        get yAxisAnnotationInterpolatedValuePrecision() {
            return this.g2;
        }
        set yAxisAnnotationInterpolatedValuePrecision(a) {
            this.g2 = a;
            this.g("YAxisAnnotationInterpolatedValuePrecision");
        }
        get yAxisAnnotationOutline() {
            return this.hh;
        }
        set yAxisAnnotationOutline(a) {
            this.hh = a;
            this.g("YAxisAnnotationOutline");
        }
        get yAxisAnnotationStrokeThickness() {
            return this.go;
        }
        set yAxisAnnotationStrokeThickness(a) {
            this.go = a;
            this.g("YAxisAnnotationStrokeThickness");
        }
        get verticalLineVisibility() {
            return this.ha;
        }
        set verticalLineVisibility(a) {
            this.ha = a;
            this.g("VerticalLineVisibility");
        }
        get horizontalLineVisibility() {
            return this.g6;
        }
        set horizontalLineVisibility(a) {
            this.g6 = a;
            this.g("HorizontalLineVisibility");
        }
        get skipUnknownValues() {
            return this.f8;
        }
        set skipUnknownValues(a) {
            this.f8 = a;
            this.g("SkipUnknownValues");
        }
        get xAxisAnnotationFormatLabelRef() {
            return this.hc;
        }
        set xAxisAnnotationFormatLabelRef(a) {
            this.hc = a;
            this.g("XAxisAnnotationFormatLabelRef");
        }
        get yAxisAnnotationFormatLabelRef() {
            return this.hg;
        }
        set yAxisAnnotationFormatLabelRef(a) {
            this.hg = a;
            this.g("YAxisAnnotationFormatLabelRef");
        }
    }
    CrosshairLayerDescription.$t = /*@__PURE__*/ markType(CrosshairLayerDescription, 'CrosshairLayerDescription', AnnotationLayerDescription.$);
    return CrosshairLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CrosshairLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class CrosshairLayerDescriptionMetadata extends Base {
        static b(a) {
            if (CrosshairLayerDescriptionMetadata.a == null) {
                CrosshairLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CrosshairLayerDescriptionMetadata.c(CrosshairLayerDescriptionMetadata.a);
            }
            if (a.k(CrosshairLayerDescriptionMetadata.a)) {
                return;
            }
            a.ac(CrosshairLayerDescriptionMetadata.a);
        }
        static c(a) {
            AnnotationLayerDescriptionMetadata.c(a);
            a.item("HorizontalLineStroke", "Brush");
            a.item("VerticalLineStroke", "Brush");
            a.item("TargetSeriesName", "String");
            a.item("TargetSeriesRef", "(w:TargetSeries,wf:TargetSeries)DataRef::object");
            a.item("UseInterpolation", "Boolean");
            a.item("IsAxisAnnotationEnabled", "Boolean");
            a.item("XAxisAnnotationTextColor", "Brush");
            a.item("XAxisAnnotationBackground", "Brush");
            a.item("XAxisAnnotationBackgroundCornerRadius", "Number:double");
            a.item("XAxisAnnotationInterpolatedValuePrecision", "Number:int");
            a.item("XAxisAnnotationOutline", "Brush");
            a.item("XAxisAnnotationPaddingLeft", "Number:double");
            a.item("XAxisAnnotationPaddingTop", "Number:double");
            a.item("XAxisAnnotationPaddingRight", "Number:double");
            a.item("XAxisAnnotationPaddingBottom", "Number:double");
            a.item("YAxisAnnotationPaddingLeft", "Number:double");
            a.item("YAxisAnnotationPaddingTop", "Number:double");
            a.item("YAxisAnnotationPaddingRight", "Number:double");
            a.item("YAxisAnnotationPaddingBottom", "Number:double");
            a.item("XAxisAnnotationStrokeThickness", "Number:double");
            a.item("YAxisAnnotationTextColor", "Brush");
            a.item("YAxisAnnotationBackground", "Brush");
            a.item("YAxisAnnotationBackgroundCornerRadius", "Number:double");
            a.item("YAxisAnnotationInterpolatedValuePrecision", "Number:int");
            a.item("YAxisAnnotationOutline", "Brush");
            a.item("YAxisAnnotationStrokeThickness", "Number:double");
            a.item("VerticalLineVisibility", "ExportedType:string:Visibility");
            a.item("VerticalLineVisibility@names", "Visible;Collapsed");
            a.item("HorizontalLineVisibility", "ExportedType:string:Visibility");
            a.item("HorizontalLineVisibility@names", "Visible;Collapsed");
            a.item("SkipUnknownValues", "Boolean");
            a.item("XAxisAnnotationFormatLabelRef", "EventRef::xAxisAnnotationFormatLabel");
            a.item("YAxisAnnotationFormatLabelRef", "EventRef::yAxisAnnotationFormatLabel");
        }
        static d(a) {
            CrosshairLayerDescriptionMetadata.b(a);
            a.ae("CrosshairLayer", () => new CrosshairLayerDescription());
            a.ad("CrosshairLayer", CrosshairLayerDescriptionMetadata.a);
        }
    }
    CrosshairLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(CrosshairLayerDescriptionMetadata, 'CrosshairLayerDescriptionMetadata');
    CrosshairLayerDescriptionMetadata.a = null;
    return CrosshairLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CrosshairLayerDescriptionModule = /*@__PURE__*/ (() => {
    class CrosshairLayerDescriptionModule extends Base {
        static register(a) {
            CrosshairLayerDescriptionMetadata.d(a);
        }
    }
    CrosshairLayerDescriptionModule.$t = /*@__PURE__*/ markType(CrosshairLayerDescriptionModule, 'CrosshairLayerDescriptionModule');
    return CrosshairLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutContentUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class CalloutContentUpdatingEventArgsDescription extends Description {
        get_type() {
            return "CalloutContentUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.k = null;
            this.i = null;
            this.h = null;
        }
        get xValueRef() {
            return this.j;
        }
        set xValueRef(a) {
            this.j = a;
            this.g("XValueRef");
        }
        get yValueRef() {
            return this.k;
        }
        set yValueRef(a) {
            this.k = a;
            this.g("YValueRef");
        }
        get itemRef() {
            return this.i;
        }
        set itemRef(a) {
            this.i = a;
            this.g("ItemRef");
        }
        get contentRef() {
            return this.h;
        }
        set contentRef(a) {
            this.h = a;
            this.g("ContentRef");
        }
    }
    CalloutContentUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(CalloutContentUpdatingEventArgsDescription, 'CalloutContentUpdatingEventArgsDescription', Description.$);
    return CalloutContentUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutContentUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalloutContentUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CalloutContentUpdatingEventArgsDescriptionMetadata.a == null) {
                CalloutContentUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalloutContentUpdatingEventArgsDescriptionMetadata.c(CalloutContentUpdatingEventArgsDescriptionMetadata.a);
            }
            if (a.k(CalloutContentUpdatingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(CalloutContentUpdatingEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("XValueRef", "(w:XValue,j:xValue,wf:XValue)DataRef");
            a.item("YValueRef", "(w:YValue,j:yValue,wf:YValue)DataRef");
            a.item("ItemRef", "(w:Item,j:item,wf:Item)DataRef");
            a.item("ContentRef", "(w:Content,j:content,wf:Content)DataRef");
        }
        static d(a) {
            CalloutContentUpdatingEventArgsDescriptionMetadata.b(a);
            a.ae("CalloutContentUpdatingEventArgs", () => new CalloutContentUpdatingEventArgsDescription());
            a.ad("CalloutContentUpdatingEventArgs", CalloutContentUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    CalloutContentUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CalloutContentUpdatingEventArgsDescriptionMetadata, 'CalloutContentUpdatingEventArgsDescriptionMetadata');
    CalloutContentUpdatingEventArgsDescriptionMetadata.a = null;
    return CalloutContentUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutLabelUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class CalloutLabelUpdatingEventArgsDescription extends Description {
        get_type() {
            return "CalloutLabelUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.m = null;
            this.n = null;
            this.j = null;
            this.h = null;
            this.l = null;
            this.k = null;
        }
        get xValueRef() {
            return this.m;
        }
        set xValueRef(a) {
            this.m = a;
            this.g("XValueRef");
        }
        get yValueRef() {
            return this.n;
        }
        set yValueRef(a) {
            this.n = a;
            this.g("YValueRef");
        }
        get itemRef() {
            return this.j;
        }
        set itemRef(a) {
            this.j = a;
            this.g("ItemRef");
        }
        get series() {
            return this.h;
        }
        set series(a) {
            this.h = a;
            this.g("Series");
        }
        get seriesName() {
            return this.l;
        }
        set seriesName(a) {
            this.l = a;
            this.g("SeriesName");
        }
        get labelRef() {
            return this.k;
        }
        set labelRef(a) {
            this.k = a;
            this.g("LabelRef");
        }
    }
    CalloutLabelUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(CalloutLabelUpdatingEventArgsDescription, 'CalloutLabelUpdatingEventArgsDescription', Description.$);
    return CalloutLabelUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutLabelUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalloutLabelUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CalloutLabelUpdatingEventArgsDescriptionMetadata.a == null) {
                CalloutLabelUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalloutLabelUpdatingEventArgsDescriptionMetadata.c(CalloutLabelUpdatingEventArgsDescriptionMetadata.a);
            }
            if (a.k(CalloutLabelUpdatingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(CalloutLabelUpdatingEventArgsDescriptionMetadata.a);
            SeriesDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("XValueRef", "(w:XValue,j:xValue,wf:XValue)DataRef");
            a.item("YValueRef", "(w:YValue,j:yValue,wf:YValue)DataRef");
            a.item("ItemRef", "(w:Item,j:item,wf:Item)DataRef");
            a.item("Series", "ExportedType:Series");
            a.item("SeriesName", "String");
            a.item("LabelRef", "(w:Label,j:label,wf:Label)DataRef");
        }
        static d(a) {
            CalloutLabelUpdatingEventArgsDescriptionMetadata.b(a);
            a.ae("CalloutLabelUpdatingEventArgs", () => new CalloutLabelUpdatingEventArgsDescription());
            a.ad("CalloutLabelUpdatingEventArgs", CalloutLabelUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    CalloutLabelUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CalloutLabelUpdatingEventArgsDescriptionMetadata, 'CalloutLabelUpdatingEventArgsDescriptionMetadata');
    CalloutLabelUpdatingEventArgsDescriptionMetadata.a = null;
    return CalloutLabelUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutSeriesSelectingEventArgsDescription = /*@__PURE__*/ (() => {
    class CalloutSeriesSelectingEventArgsDescription extends Description {
        get_type() {
            return "CalloutSeriesSelectingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.m = null;
            this.j = null;
            this.h = null;
            this.k = null;
        }
        get xValueRef() {
            return this.l;
        }
        set xValueRef(a) {
            this.l = a;
            this.g("XValueRef");
        }
        get yValueRef() {
            return this.m;
        }
        set yValueRef(a) {
            this.m = a;
            this.g("YValueRef");
        }
        get itemRef() {
            return this.j;
        }
        set itemRef(a) {
            this.j = a;
            this.g("ItemRef");
        }
        get series() {
            return this.h;
        }
        set series(a) {
            this.h = a;
            this.g("Series");
        }
        get seriesName() {
            return this.k;
        }
        set seriesName(a) {
            this.k = a;
            this.g("SeriesName");
        }
    }
    CalloutSeriesSelectingEventArgsDescription.$t = /*@__PURE__*/ markType(CalloutSeriesSelectingEventArgsDescription, 'CalloutSeriesSelectingEventArgsDescription', Description.$);
    return CalloutSeriesSelectingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutSeriesSelectingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalloutSeriesSelectingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CalloutSeriesSelectingEventArgsDescriptionMetadata.a == null) {
                CalloutSeriesSelectingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalloutSeriesSelectingEventArgsDescriptionMetadata.c(CalloutSeriesSelectingEventArgsDescriptionMetadata.a);
            }
            if (a.k(CalloutSeriesSelectingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(CalloutSeriesSelectingEventArgsDescriptionMetadata.a);
            SeriesDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("XValueRef", "(w:XValue,j:xValue,wf:XValue)DataRef");
            a.item("YValueRef", "(w:YValue,j:yValue,wf:YValue)DataRef");
            a.item("ItemRef", "(w:Item,j:item,wf:Item)DataRef");
            a.item("Series", "(j:_internalSeries)ExportedType:Series");
            a.item("SeriesName", "String");
        }
        static d(a) {
            CalloutSeriesSelectingEventArgsDescriptionMetadata.b(a);
            a.ae("CalloutSeriesSelectingEventArgs", () => new CalloutSeriesSelectingEventArgsDescription());
            a.ad("CalloutSeriesSelectingEventArgs", CalloutSeriesSelectingEventArgsDescriptionMetadata.a);
        }
    }
    CalloutSeriesSelectingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CalloutSeriesSelectingEventArgsDescriptionMetadata, 'CalloutSeriesSelectingEventArgsDescriptionMetadata');
    CalloutSeriesSelectingEventArgsDescriptionMetadata.a = null;
    return CalloutSeriesSelectingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutLayerDescription = /*@__PURE__*/ (() => {
    class CalloutLayerDescription extends AnnotationLayerDescription {
        get_type() {
            return "CalloutLayer";
        }
        constructor() {
            super();
            this.hv = null;
            this.hz = null;
            this.h0 = null;
            this.ht = null;
            this.gc = false;
            this.hu = null;
            this.f8 = null;
            this.hr = null;
            this.hw = null;
            this.hx = null;
            this.hq = null;
            this.f7 = null;
            this.gb = false;
            this.gg = false;
            this.gj = false;
            this.gf = false;
            this.gh = false;
            this.gi = false;
            this.gk = false;
            this.hs = null;
            this.hd = null;
            this.gv = 0;
            this.ge = false;
            this.gd = false;
            this.g9 = 0;
            this.hp = null;
            this.hk = null;
            this.hh = null;
            this.he = null;
            this.ha = 0;
            this.hl = null;
            this.hj = null;
            this.gx = 0;
            this.gz = 0;
            this.gy = 0;
            this.gw = 0;
            this.hf = null;
            this.g0 = 0;
            this.g1 = 0;
            this.hy = null;
            this.ho = null;
            this.hm = null;
            this.hg = null;
            this.hi = null;
            this.hn = null;
        }
        get labelMemberPath() {
            return this.hv;
        }
        set labelMemberPath(a) {
            this.hv = a;
            this.g("LabelMemberPath");
        }
        get xMemberPath() {
            return this.hz;
        }
        set xMemberPath(a) {
            this.hz = a;
            this.g("XMemberPath");
        }
        get yMemberPath() {
            return this.h0;
        }
        set yMemberPath(a) {
            this.h0 = a;
            this.g("YMemberPath");
        }
        get keyMemberPath() {
            return this.ht;
        }
        set keyMemberPath(a) {
            this.ht = a;
            this.g("KeyMemberPath");
        }
        get isCalloutOffsettingEnabled() {
            return this.gc;
        }
        set isCalloutOffsettingEnabled(a) {
            this.gc = a;
            this.g("IsCalloutOffsettingEnabled");
        }
        get labelFormat() {
            return this.hu;
        }
        set labelFormat(a) {
            this.hu = a;
            this.g("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.f8;
        }
        set labelFormatSpecifiers(a) {
            this.f8 = a;
            this.g("LabelFormatSpecifiers");
        }
        get contentMemberPath() {
            return this.hr;
        }
        set contentMemberPath(a) {
            this.hr = a;
            this.g("ContentMemberPath");
        }
        get targetSeriesName() {
            return this.hw;
        }
        set targetSeriesName(a) {
            this.hw = a;
            this.g("TargetSeriesName");
        }
        get targetSeriesRef() {
            return this.hx;
        }
        set targetSeriesRef(a) {
            this.hx = a;
            this.g("TargetSeriesRef");
        }
        get collisionChannel() {
            return this.hq;
        }
        set collisionChannel(a) {
            this.hq = a;
            this.g("CollisionChannel");
        }
        get allowedPositions() {
            return this.f7;
        }
        set allowedPositions(a) {
            this.f7 = a;
            this.g("AllowedPositions");
        }
        get isAutoCalloutBehaviorEnabled() {
            return this.gb;
        }
        set isAutoCalloutBehaviorEnabled(a) {
            this.gb = a;
            this.g("IsAutoCalloutBehaviorEnabled");
        }
        get useInterpolatedValueForAutoCalloutLabels() {
            return this.gg;
        }
        set useInterpolatedValueForAutoCalloutLabels(a) {
            this.gg = a;
            this.g("UseInterpolatedValueForAutoCalloutLabels");
        }
        get useSeriesColorForOutline() {
            return this.gj;
        }
        set useSeriesColorForOutline(a) {
            this.gj = a;
            this.g("UseSeriesColorForOutline");
        }
        get useAutoContrastingLabelColors() {
            return this.gf;
        }
        set useAutoContrastingLabelColors(a) {
            this.gf = a;
            this.g("UseAutoContrastingLabelColors");
        }
        get useItemColorForFill() {
            return this.gh;
        }
        set useItemColorForFill(a) {
            this.gh = a;
            this.g("UseItemColorForFill");
        }
        get useItemColorForOutline() {
            return this.gi;
        }
        set useItemColorForOutline(a) {
            this.gi = a;
            this.g("UseItemColorForOutline");
        }
        get useValueForAutoCalloutLabels() {
            return this.gk;
        }
        set useValueForAutoCalloutLabels(a) {
            this.gk = a;
            this.g("UseValueForAutoCalloutLabels");
        }
        get highlightedValueLabelMode() {
            return this.hs;
        }
        set highlightedValueLabelMode(a) {
            this.hs = a;
            this.g("HighlightedValueLabelMode");
        }
        get autoCalloutVisibilityMode() {
            return this.hd;
        }
        set autoCalloutVisibilityMode(a) {
            this.hd = a;
            this.g("AutoCalloutVisibilityMode");
        }
        get calloutCornerRadius() {
            return this.gv;
        }
        set calloutCornerRadius(a) {
            this.gv = a;
            this.g("CalloutCornerRadius");
        }
        get isCustomCalloutStyleEnabled() {
            return this.ge;
        }
        set isCustomCalloutStyleEnabled(a) {
            this.ge = a;
            this.g("IsCustomCalloutStyleEnabled");
        }
        get isCustomCalloutRenderStyleEnabled() {
            return this.gd;
        }
        set isCustomCalloutRenderStyleEnabled(a) {
            this.gd = a;
            this.g("IsCustomCalloutRenderStyleEnabled");
        }
        get autoCalloutLabelPrecision() {
            return this.g9;
        }
        set autoCalloutLabelPrecision(a) {
            this.g9 = a;
            this.g("AutoCalloutLabelPrecision");
        }
        get calloutTextColor() {
            return this.hp;
        }
        set calloutTextColor(a) {
            this.hp = a;
            this.g("CalloutTextColor");
        }
        get calloutLightTextColor() {
            return this.hk;
        }
        set calloutLightTextColor(a) {
            this.hk = a;
            this.g("CalloutLightTextColor");
        }
        get calloutDarkTextColor() {
            return this.hh;
        }
        set calloutDarkTextColor(a) {
            this.hh = a;
            this.g("CalloutDarkTextColor");
        }
        get calloutBackground() {
            return this.he;
        }
        set calloutBackground(a) {
            this.he = a;
            this.g("CalloutBackground");
        }
        get calloutInterpolatedValuePrecision() {
            return this.ha;
        }
        set calloutInterpolatedValuePrecision(a) {
            this.ha = a;
            this.g("CalloutInterpolatedValuePrecision");
        }
        get calloutOutline() {
            return this.hl;
        }
        set calloutOutline(a) {
            this.hl = a;
            this.g("CalloutOutline");
        }
        get calloutLeaderBrush() {
            return this.hj;
        }
        set calloutLeaderBrush(a) {
            this.hj = a;
            this.g("CalloutLeaderBrush");
        }
        get calloutPaddingLeft() {
            return this.gx;
        }
        set calloutPaddingLeft(a) {
            this.gx = a;
            this.g("CalloutPaddingLeft");
        }
        get calloutPaddingTop() {
            return this.gz;
        }
        set calloutPaddingTop(a) {
            this.gz = a;
            this.g("CalloutPaddingTop");
        }
        get calloutPaddingRight() {
            return this.gy;
        }
        set calloutPaddingRight(a) {
            this.gy = a;
            this.g("CalloutPaddingRight");
        }
        get calloutPaddingBottom() {
            return this.gw;
        }
        set calloutPaddingBottom(a) {
            this.gw = a;
            this.g("CalloutPaddingBottom");
        }
        get calloutCollisionMode() {
            return this.hf;
        }
        set calloutCollisionMode(a) {
            this.hf = a;
            this.g("CalloutCollisionMode");
        }
        get calloutPositionPadding() {
            return this.g0;
        }
        set calloutPositionPadding(a) {
            this.g0 = a;
            this.g("CalloutPositionPadding");
        }
        get calloutStrokeThickness() {
            return this.g1;
        }
        set calloutStrokeThickness(a) {
            this.g1 = a;
            this.g("CalloutStrokeThickness");
        }
        get textStyle() {
            return this.hy;
        }
        set textStyle(a) {
            this.hy = a;
            this.g("TextStyle");
        }
        get calloutStyleUpdatingRef() {
            return this.ho;
        }
        set calloutStyleUpdatingRef(a) {
            this.ho = a;
            this.g("CalloutStyleUpdatingRef");
        }
        get calloutRenderStyleUpdatingRef() {
            return this.hm;
        }
        set calloutRenderStyleUpdatingRef(a) {
            this.hm = a;
            this.g("CalloutRenderStyleUpdatingRef");
        }
        get calloutContentUpdatingRef() {
            return this.hg;
        }
        set calloutContentUpdatingRef(a) {
            this.hg = a;
            this.g("CalloutContentUpdatingRef");
        }
        get calloutLabelUpdatingRef() {
            return this.hi;
        }
        set calloutLabelUpdatingRef(a) {
            this.hi = a;
            this.g("CalloutLabelUpdatingRef");
        }
        get calloutSeriesSelectingRef() {
            return this.hn;
        }
        set calloutSeriesSelectingRef(a) {
            this.hn = a;
            this.g("CalloutSeriesSelectingRef");
        }
    }
    CalloutLayerDescription.$t = /*@__PURE__*/ markType(CalloutLayerDescription, 'CalloutLayerDescription', AnnotationLayerDescription.$);
    return CalloutLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalloutLayerDescriptionMetadata extends Base {
        static b(a) {
            if (CalloutLayerDescriptionMetadata.a == null) {
                CalloutLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalloutLayerDescriptionMetadata.c(CalloutLayerDescriptionMetadata.a);
            }
            if (a.k(CalloutLayerDescriptionMetadata.a)) {
                return;
            }
            a.ac(CalloutLayerDescriptionMetadata.a);
            CalloutStyleUpdatingEventArgsDescriptionMetadata.d(a);
            CalloutRenderStyleUpdatingEventArgsDescriptionMetadata.d(a);
            CalloutContentUpdatingEventArgsDescriptionMetadata.d(a);
            CalloutLabelUpdatingEventArgsDescriptionMetadata.d(a);
            CalloutSeriesSelectingEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            AnnotationLayerDescriptionMetadata.c(a);
            a.item("LabelMemberPath", "String");
            a.item("XMemberPath", "String");
            a.item("YMemberPath", "String");
            a.item("KeyMemberPath", "String");
            a.item("IsCalloutOffsettingEnabled", "Boolean");
            a.item("LabelFormat", "String");
            a.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("ContentMemberPath", "String");
            a.item("TargetSeriesName", "String");
            a.item("TargetSeriesRef", "(w:TargetSeries,wf:TargetSeries)DataRef::object");
            a.item("CollisionChannel", "String");
            a.item("AllowedPositions", "Collection:string:CalloutPlacementPositionsCollection:CalloutPlacementPositions");
            a.item("AllowedPositions@names", "Top;Left;Right;Bottom;TopLeft;TopRight;BottomLeft;BottomRight");
            a.item("IsAutoCalloutBehaviorEnabled", "Boolean");
            a.item("UseInterpolatedValueForAutoCalloutLabels", "Boolean");
            a.item("UseSeriesColorForOutline", "Boolean");
            a.item("UseAutoContrastingLabelColors", "Boolean");
            a.item("UseItemColorForFill", "Boolean");
            a.item("UseItemColorForOutline", "Boolean");
            a.item("UseValueForAutoCalloutLabels", "Boolean");
            a.item("HighlightedValueLabelMode", "ExportedType:string:HighlightedValueLabelMode");
            a.item("HighlightedValueLabelMode@names", "Auto;PreferOriginal;PreferHighlighted;LabelBoth");
            a.item("AutoCalloutVisibilityMode", "ExportedType:string:AutoCalloutVisibilityMode");
            a.item("AutoCalloutVisibilityMode@names", "Auto;Normal;DedicatedLanes");
            a.item("CalloutCornerRadius", "Number:double");
            a.item("IsCustomCalloutStyleEnabled", "Boolean");
            a.item("IsCustomCalloutRenderStyleEnabled", "Boolean");
            a.item("AutoCalloutLabelPrecision", "Number:int");
            a.item("CalloutTextColor", "Brush");
            a.item("CalloutLightTextColor", "Brush");
            a.item("CalloutDarkTextColor", "Brush");
            a.item("CalloutBackground", "Brush");
            a.item("CalloutInterpolatedValuePrecision", "Number:int");
            a.item("CalloutOutline", "Brush");
            a.item("CalloutLeaderBrush", "Brush");
            a.item("CalloutPaddingLeft", "Number:double");
            a.item("CalloutPaddingTop", "Number:double");
            a.item("CalloutPaddingRight", "Number:double");
            a.item("CalloutPaddingBottom", "Number:double");
            a.item("CalloutCollisionMode", "ExportedType:string:CalloutCollisionMode");
            a.item("CalloutCollisionMode@names", "Auto;SimulatedAnnealing;Greedy;GreedyCenterOfMass;RadialBestFit;RadialInsideEnd;RadialOutsideEnd;RadialCenter");
            a.item("CalloutPositionPadding", "Number:double");
            a.item("CalloutStrokeThickness", "Number:double");
            a.item("TextStyle", "String");
            a.item("CalloutStyleUpdatingRef", "EventRef::calloutStyleUpdating");
            a.item("CalloutRenderStyleUpdatingRef", "EventRef::calloutRenderStyleUpdating");
            a.item("CalloutContentUpdatingRef", "EventRef::calloutContentUpdating");
            a.item("CalloutLabelUpdatingRef", "EventRef::calloutLabelUpdating");
            a.item("CalloutSeriesSelectingRef", "EventRef::calloutSeriesSelecting");
        }
        static d(a) {
            CalloutLayerDescriptionMetadata.b(a);
            a.ae("CalloutLayer", () => new CalloutLayerDescription());
            a.ad("CalloutLayer", CalloutLayerDescriptionMetadata.a);
        }
    }
    CalloutLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(CalloutLayerDescriptionMetadata, 'CalloutLayerDescriptionMetadata');
    CalloutLayerDescriptionMetadata.a = null;
    return CalloutLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutLayerDescriptionModule = /*@__PURE__*/ (() => {
    class CalloutLayerDescriptionModule extends Base {
        static register(a) {
            CalloutLayerDescriptionMetadata.d(a);
        }
    }
    CalloutLayerDescriptionModule.$t = /*@__PURE__*/ markType(CalloutLayerDescriptionModule, 'CalloutLayerDescriptionModule');
    return CalloutLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemToolTipLayerDescription = /*@__PURE__*/ (() => {
    class ItemToolTipLayerDescription extends AnnotationLayerDescription {
        get_type() {
            return "ItemToolTipLayer";
        }
        constructor() {
            super();
            this.gb = null;
            this.gc = null;
            this.f8 = false;
            this.f7 = false;
        }
        get targetSeriesName() {
            return this.gb;
        }
        set targetSeriesName(a) {
            this.gb = a;
            this.g("TargetSeriesName");
        }
        get targetSeriesRef() {
            return this.gc;
        }
        set targetSeriesRef(a) {
            this.gc = a;
            this.g("TargetSeriesRef");
        }
        get useInterpolation() {
            return this.f8;
        }
        set useInterpolation(a) {
            this.f8 = a;
            this.g("UseInterpolation");
        }
        get skipUnknownValues() {
            return this.f7;
        }
        set skipUnknownValues(a) {
            this.f7 = a;
            this.g("SkipUnknownValues");
        }
    }
    ItemToolTipLayerDescription.$t = /*@__PURE__*/ markType(ItemToolTipLayerDescription, 'ItemToolTipLayerDescription', AnnotationLayerDescription.$);
    return ItemToolTipLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemToolTipLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class ItemToolTipLayerDescriptionMetadata extends Base {
        static b(a) {
            if (ItemToolTipLayerDescriptionMetadata.a == null) {
                ItemToolTipLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ItemToolTipLayerDescriptionMetadata.c(ItemToolTipLayerDescriptionMetadata.a);
            }
            if (a.k(ItemToolTipLayerDescriptionMetadata.a)) {
                return;
            }
            a.ac(ItemToolTipLayerDescriptionMetadata.a);
        }
        static c(a) {
            AnnotationLayerDescriptionMetadata.c(a);
            a.item("TargetSeriesName", "String");
            a.item("TargetSeriesRef", "(w:TargetSeries,wf:TargetSeries)DataRef::object");
            a.item("UseInterpolation", "Boolean");
            a.item("SkipUnknownValues", "Boolean");
        }
        static d(a) {
            ItemToolTipLayerDescriptionMetadata.b(a);
            a.ae("ItemToolTipLayer", () => new ItemToolTipLayerDescription());
            a.ad("ItemToolTipLayer", ItemToolTipLayerDescriptionMetadata.a);
        }
    }
    ItemToolTipLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(ItemToolTipLayerDescriptionMetadata, 'ItemToolTipLayerDescriptionMetadata');
    ItemToolTipLayerDescriptionMetadata.a = null;
    return ItemToolTipLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemToolTipLayerDescriptionModule = /*@__PURE__*/ (() => {
    class ItemToolTipLayerDescriptionModule extends Base {
        static register(a) {
            ItemToolTipLayerDescriptionMetadata.d(a);
        }
    }
    ItemToolTipLayerDescriptionModule.$t = /*@__PURE__*/ markType(ItemToolTipLayerDescriptionModule, 'ItemToolTipLayerDescriptionModule');
    return ItemToolTipLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryToolTipLayerDescription = /*@__PURE__*/ (() => {
    class CategoryToolTipLayerDescription extends AnnotationLayerDescription {
        get_type() {
            return "CategoryToolTipLayer";
        }
        constructor() {
            super();
            this.f9 = null;
            this.f7 = false;
        }
        get targetAxisRef() {
            return this.f9;
        }
        set targetAxisRef(a) {
            this.f9 = a;
            this.g("TargetAxisRef");
        }
        get useInterpolation() {
            return this.f7;
        }
        set useInterpolation(a) {
            this.f7 = a;
            this.g("UseInterpolation");
        }
    }
    CategoryToolTipLayerDescription.$t = /*@__PURE__*/ markType(CategoryToolTipLayerDescription, 'CategoryToolTipLayerDescription', AnnotationLayerDescription.$);
    return CategoryToolTipLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryToolTipLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryToolTipLayerDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryToolTipLayerDescriptionMetadata.a == null) {
                CategoryToolTipLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryToolTipLayerDescriptionMetadata.c(CategoryToolTipLayerDescriptionMetadata.a);
            }
            if (a.k(CategoryToolTipLayerDescriptionMetadata.a)) {
                return;
            }
            a.ac(CategoryToolTipLayerDescriptionMetadata.a);
        }
        static c(a) {
            AnnotationLayerDescriptionMetadata.c(a);
            a.item("TargetAxisRef", "(w:TargetAxis,wf:TargetAxis)DataRef::object");
            a.item("UseInterpolation", "Boolean");
        }
        static d(a) {
            CategoryToolTipLayerDescriptionMetadata.b(a);
            a.ae("CategoryToolTipLayer", () => new CategoryToolTipLayerDescription());
            a.ad("CategoryToolTipLayer", CategoryToolTipLayerDescriptionMetadata.a);
        }
    }
    CategoryToolTipLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryToolTipLayerDescriptionMetadata, 'CategoryToolTipLayerDescriptionMetadata');
    CategoryToolTipLayerDescriptionMetadata.a = null;
    return CategoryToolTipLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryToolTipLayerDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryToolTipLayerDescriptionModule extends Base {
        static register(a) {
            CategoryToolTipLayerDescriptionMetadata.d(a);
        }
    }
    CategoryToolTipLayerDescriptionModule.$t = /*@__PURE__*/ markType(CategoryToolTipLayerDescriptionModule, 'CategoryToolTipLayerDescriptionModule');
    return CategoryToolTipLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryHighlightLayerDescription = /*@__PURE__*/ (() => {
    class CategoryHighlightLayerDescription extends AnnotationLayerDescription {
        get_type() {
            return "CategoryHighlightLayer";
        }
        constructor() {
            super();
            this.gb = null;
            this.f7 = false;
            this.f9 = 0;
        }
        get targetAxisRef() {
            return this.gb;
        }
        set targetAxisRef(a) {
            this.gb = a;
            this.g("TargetAxisRef");
        }
        get useInterpolation() {
            return this.f7;
        }
        set useInterpolation(a) {
            this.f7 = a;
            this.g("UseInterpolation");
        }
        get bandHighlightWidth() {
            return this.f9;
        }
        set bandHighlightWidth(a) {
            this.f9 = a;
            this.g("BandHighlightWidth");
        }
    }
    CategoryHighlightLayerDescription.$t = /*@__PURE__*/ markType(CategoryHighlightLayerDescription, 'CategoryHighlightLayerDescription', AnnotationLayerDescription.$);
    return CategoryHighlightLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryHighlightLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryHighlightLayerDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryHighlightLayerDescriptionMetadata.a == null) {
                CategoryHighlightLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryHighlightLayerDescriptionMetadata.c(CategoryHighlightLayerDescriptionMetadata.a);
            }
            if (a.k(CategoryHighlightLayerDescriptionMetadata.a)) {
                return;
            }
            a.ac(CategoryHighlightLayerDescriptionMetadata.a);
        }
        static c(a) {
            AnnotationLayerDescriptionMetadata.c(a);
            a.item("TargetAxisRef", "(w:TargetAxis,wf:TargetAxis)DataRef::object");
            a.item("UseInterpolation", "Boolean");
            a.item("BandHighlightWidth", "Number:double");
        }
        static d(a) {
            CategoryHighlightLayerDescriptionMetadata.b(a);
            a.ae("CategoryHighlightLayer", () => new CategoryHighlightLayerDescription());
            a.ad("CategoryHighlightLayer", CategoryHighlightLayerDescriptionMetadata.a);
        }
    }
    CategoryHighlightLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryHighlightLayerDescriptionMetadata, 'CategoryHighlightLayerDescriptionMetadata');
    CategoryHighlightLayerDescriptionMetadata.a = null;
    return CategoryHighlightLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryHighlightLayerDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryHighlightLayerDescriptionModule extends Base {
        static register(a) {
            CategoryHighlightLayerDescriptionMetadata.d(a);
        }
    }
    CategoryHighlightLayerDescriptionModule.$t = /*@__PURE__*/ markType(CategoryHighlightLayerDescriptionModule, 'CategoryHighlightLayerDescriptionModule');
    return CategoryHighlightLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryItemHighlightLayerDescription = /*@__PURE__*/ (() => {
    class CategoryItemHighlightLayerDescription extends AnnotationLayerDescription {
        get_type() {
            return "CategoryItemHighlightLayer";
        }
        constructor() {
            super();
            this.gj = null;
            this.gi = null;
            this.f8 = false;
            this.gd = null;
            this.gh = null;
            this.ge = null;
            this.gf = null;
            this.gg = null;
            this.gb = 0;
            this.f7 = false;
        }
        get targetSeriesRef() {
            return this.gj;
        }
        set targetSeriesRef(a) {
            this.gj = a;
            this.g("TargetSeriesRef");
        }
        get targetSeriesName() {
            return this.gi;
        }
        set targetSeriesName(a) {
            this.gi = a;
            this.g("TargetSeriesName");
        }
        get useInterpolation() {
            return this.f8;
        }
        set useInterpolation(a) {
            this.f8 = a;
            this.g("UseInterpolation");
        }
        get highlightType() {
            return this.gd;
        }
        set highlightType(a) {
            this.gd = a;
            this.g("HighlightType");
        }
        get markerType() {
            return this.gh;
        }
        set markerType(a) {
            this.gh = a;
            this.g("MarkerType");
        }
        get markerBrush() {
            return this.ge;
        }
        set markerBrush(a) {
            this.ge = a;
            this.g("MarkerBrush");
        }
        get markerOutline() {
            return this.gf;
        }
        set markerOutline(a) {
            this.gf = a;
            this.g("MarkerOutline");
        }
        get markerTemplateRef() {
            return this.gg;
        }
        set markerTemplateRef(a) {
            this.gg = a;
            this.g("MarkerTemplateRef");
        }
        get bandHighlightWidth() {
            return this.gb;
        }
        set bandHighlightWidth(a) {
            this.gb = a;
            this.g("BandHighlightWidth");
        }
        get skipUnknownValues() {
            return this.f7;
        }
        set skipUnknownValues(a) {
            this.f7 = a;
            this.g("SkipUnknownValues");
        }
    }
    CategoryItemHighlightLayerDescription.$t = /*@__PURE__*/ markType(CategoryItemHighlightLayerDescription, 'CategoryItemHighlightLayerDescription', AnnotationLayerDescription.$);
    return CategoryItemHighlightLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryItemHighlightLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryItemHighlightLayerDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryItemHighlightLayerDescriptionMetadata.a == null) {
                CategoryItemHighlightLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryItemHighlightLayerDescriptionMetadata.c(CategoryItemHighlightLayerDescriptionMetadata.a);
            }
            if (a.k(CategoryItemHighlightLayerDescriptionMetadata.a)) {
                return;
            }
            a.ac(CategoryItemHighlightLayerDescriptionMetadata.a);
        }
        static c(a) {
            AnnotationLayerDescriptionMetadata.c(a);
            a.item("TargetSeriesRef", "(w:TargetSeries,wf:TargetSeries)DataRef::object");
            a.item("TargetSeriesName", "String");
            a.item("UseInterpolation", "Boolean");
            a.item("HighlightType", "ExportedType:string:CategoryItemHighlightType");
            a.item("HighlightType@names", "Auto;Marker;Shape");
            a.item("MarkerType", "ExportedType:string:MarkerType");
            a.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            a.item("MarkerBrush", "Brush");
            a.item("MarkerOutline", "Brush");
            a.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            a.item("BandHighlightWidth", "Number:double");
            a.item("SkipUnknownValues", "Boolean");
        }
        static d(a) {
            CategoryItemHighlightLayerDescriptionMetadata.b(a);
            a.ae("CategoryItemHighlightLayer", () => new CategoryItemHighlightLayerDescription());
            a.ad("CategoryItemHighlightLayer", CategoryItemHighlightLayerDescriptionMetadata.a);
        }
    }
    CategoryItemHighlightLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryItemHighlightLayerDescriptionMetadata, 'CategoryItemHighlightLayerDescriptionMetadata');
    CategoryItemHighlightLayerDescriptionMetadata.a = null;
    return CategoryItemHighlightLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryItemHighlightLayerDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryItemHighlightLayerDescriptionModule extends Base {
        static register(a) {
            CategoryItemHighlightLayerDescriptionMetadata.d(a);
        }
    }
    CategoryItemHighlightLayerDescriptionModule.$t = /*@__PURE__*/ markType(CategoryItemHighlightLayerDescriptionModule, 'CategoryItemHighlightLayerDescriptionModule');
    return CategoryItemHighlightLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataToolTipLayerDescription = /*@__PURE__*/ (() => {
    class DataToolTipLayerDescription extends AnnotationLayerDescription {
        get_type() {
            return "DataToolTipLayer";
        }
        constructor() {
            super();
            this.ls = null;
            this.gm = false;
            this.kp = null;
            this.kl = null;
            this.hq = 0;
            this.hr = 0;
            this.g1 = 0;
            this.g2 = 0;
            this.kn = null;
            this.kj = null;
            this.ko = null;
            this.kk = null;
            this.gl = false;
            this.gb = null;
            this.f8 = null;
            this.ga = null;
            this.f7 = null;
            this.l3 = null;
            this.kf = 0;
            this.kg = 0;
            this.l5 = null;
            this.l4 = null;
            this.gn = false;
            this.l6 = null;
            this.gc = null;
            this.ie = 0;
            this.ig = 0;
            this.ih = 0;
            this.ii = 0;
            this.go = false;
            this.mb = null;
            this.gp = false;
            this.ik = 0;
            this.il = 0;
            this.im = 0;
            this.io = 0;
            this.l7 = null;
            this.l8 = null;
            this.ij = 0;
            this.l9 = null;
            this.ma = null;
            this.kw = null;
            this.f9 = null;
            this.ku = null;
            this.kv = null;
            this.kx = null;
            this.ky = null;
            this.kz = null;
            this.hh = 0;
            this.hi = 0;
            this.hj = 0;
            this.hk = 0;
            this.hc = 0;
            this.hd = 0;
            this.he = 0;
            this.hf = 0;
            this.gk = false;
            this.k0 = null;
            this.hg = 0;
            this.k1 = null;
            this.k2 = null;
            this.gj = false;
            this.kq = null;
            this.g8 = 0;
            this.g9 = 0;
            this.ha = 0;
            this.hb = 0;
            this.g3 = 0;
            this.g4 = 0;
            this.g5 = 0;
            this.g6 = 0;
            this.kr = null;
            this.g7 = 0;
            this.ks = null;
            this.kt = null;
            this.le = null;
            this.lf = null;
            this.hx = 0;
            this.lg = null;
            this.lh = null;
            this.li = null;
            this.ld = null;
            this.hy = 0;
            this.hz = 0;
            this.h0 = 0;
            this.h1 = 0;
            this.ht = 0;
            this.hu = 0;
            this.hv = 0;
            this.hw = 0;
            this.lo = null;
            this.lp = null;
            this.h3 = 0;
            this.lq = null;
            this.lr = null;
            this.k8 = null;
            this.k9 = null;
            this.la = null;
            this.hs = 0;
            this.lb = null;
            this.lc = null;
            this.lj = null;
            this.lk = null;
            this.ll = null;
            this.h2 = 0;
            this.lm = null;
            this.ln = null;
            this.gx = 0;
            this.gy = 0;
            this.gz = 0;
            this.g0 = 0;
            this.km = null;
            this.lx = null;
            this.ly = null;
            this.lz = null;
            this.ia = 0;
            this.ib = 0;
            this.ic = 0;
            this.id = 0;
            this.l0 = null;
            this.h9 = 0;
            this.l1 = null;
            this.l2 = null;
            this.h5 = 0;
            this.h6 = 0;
            this.h7 = 0;
            this.h8 = 0;
            this.lt = null;
            this.lu = null;
            this.h4 = 0;
            this.lv = null;
            this.lw = null;
            this.k3 = null;
            this.k4 = null;
            this.hm = 0;
            this.hn = 0;
            this.ho = 0;
            this.hp = 0;
            this.k5 = null;
            this.hl = 0;
            this.k6 = null;
            this.k7 = null;
        }
        get targetAxisRef() {
            return this.ls;
        }
        set targetAxisRef(a) {
            this.ls = a;
            this.g("TargetAxisRef");
        }
        get useInterpolation() {
            return this.gm;
        }
        set useInterpolation(a) {
            this.gm = a;
            this.g("UseInterpolation");
        }
        get groupingMode() {
            return this.kp;
        }
        set groupingMode(a) {
            this.kp = a;
            this.g("GroupingMode");
        }
        get actualGroupingMode() {
            return this.kl;
        }
        set actualGroupingMode(a) {
            this.kl = a;
            this.g("ActualGroupingMode");
        }
        get positionOffsetX() {
            return this.hq;
        }
        set positionOffsetX(a) {
            this.hq = a;
            this.g("PositionOffsetX");
        }
        get positionOffsetY() {
            return this.hr;
        }
        set positionOffsetY(a) {
            this.hr = a;
            this.g("PositionOffsetY");
        }
        get defaultPositionOffsetX() {
            return this.g1;
        }
        set defaultPositionOffsetX(a) {
            this.g1 = a;
            this.g("DefaultPositionOffsetX");
        }
        get defaultPositionOffsetY() {
            return this.g2;
        }
        set defaultPositionOffsetY(a) {
            this.g2 = a;
            this.g("DefaultPositionOffsetY");
        }
        get groupedPositionModeX() {
            return this.kn;
        }
        set groupedPositionModeX(a) {
            this.kn = a;
            this.g("GroupedPositionModeX");
        }
        get actualGroupedPositionModeX() {
            return this.kj;
        }
        set actualGroupedPositionModeX(a) {
            this.kj = a;
            this.g("ActualGroupedPositionModeX");
        }
        get groupedPositionModeY() {
            return this.ko;
        }
        set groupedPositionModeY(a) {
            this.ko = a;
            this.g("GroupedPositionModeY");
        }
        get actualGroupedPositionModeY() {
            return this.kk;
        }
        set actualGroupedPositionModeY(a) {
            this.kk = a;
            this.g("ActualGroupedPositionModeY");
        }
        get shouldUpdateWhenSeriesDataChanges() {
            return this.gl;
        }
        set shouldUpdateWhenSeriesDataChanges(a) {
            this.gl = a;
            this.g("ShouldUpdateWhenSeriesDataChanges");
        }
        get includedSeries() {
            return this.gb;
        }
        set includedSeries(a) {
            this.gb = a;
            this.g("IncludedSeries");
        }
        get excludedSeries() {
            return this.f8;
        }
        set excludedSeries(a) {
            this.f8 = a;
            this.g("ExcludedSeries");
        }
        get includedColumns() {
            return this.ga;
        }
        set includedColumns(a) {
            this.ga = a;
            this.g("IncludedColumns");
        }
        get excludedColumns() {
            return this.f7;
        }
        set excludedColumns(a) {
            this.f7 = a;
            this.g("ExcludedColumns");
        }
        get valueFormatAbbreviation() {
            return this.l3;
        }
        set valueFormatAbbreviation(a) {
            this.l3 = a;
            this.g("ValueFormatAbbreviation");
        }
        get valueFormatMaxFractions() {
            return this.kf;
        }
        set valueFormatMaxFractions(a) {
            this.kf = a;
            this.g("ValueFormatMaxFractions");
        }
        get valueFormatMinFractions() {
            return this.kg;
        }
        set valueFormatMinFractions(a) {
            this.kg = a;
            this.g("ValueFormatMinFractions");
        }
        get valueFormatMode() {
            return this.l5;
        }
        set valueFormatMode(a) {
            this.l5 = a;
            this.g("ValueFormatMode");
        }
        get valueFormatCulture() {
            return this.l4;
        }
        set valueFormatCulture(a) {
            this.l4 = a;
            this.g("ValueFormatCulture");
        }
        get valueFormatUseGrouping() {
            return this.gn;
        }
        set valueFormatUseGrouping(a) {
            this.gn = a;
            this.g("ValueFormatUseGrouping");
        }
        get valueFormatString() {
            return this.l6;
        }
        set valueFormatString(a) {
            this.l6 = a;
            this.g("ValueFormatString");
        }
        get valueFormatSpecifiers() {
            return this.gc;
        }
        set valueFormatSpecifiers(a) {
            this.gc = a;
            this.g("ValueFormatSpecifiers");
        }
        get valueRowMarginBottom() {
            return this.ie;
        }
        set valueRowMarginBottom(a) {
            this.ie = a;
            this.g("ValueRowMarginBottom");
        }
        get valueRowMarginLeft() {
            return this.ig;
        }
        set valueRowMarginLeft(a) {
            this.ig = a;
            this.g("ValueRowMarginLeft");
        }
        get valueRowMarginRight() {
            return this.ih;
        }
        set valueRowMarginRight(a) {
            this.ih = a;
            this.g("ValueRowMarginRight");
        }
        get valueRowMarginTop() {
            return this.ii;
        }
        set valueRowMarginTop(a) {
            this.ii = a;
            this.g("ValueRowMarginTop");
        }
        get valueRowVisible() {
            return this.go;
        }
        set valueRowVisible(a) {
            this.go = a;
            this.g("ValueRowVisible");
        }
        get valueTextWhenMissingData() {
            return this.mb;
        }
        set valueTextWhenMissingData(a) {
            this.mb = a;
            this.g("ValueTextWhenMissingData");
        }
        get valueTextUseSeriesColors() {
            return this.gp;
        }
        set valueTextUseSeriesColors(a) {
            this.gp = a;
            this.g("ValueTextUseSeriesColors");
        }
        get valueTextMarginBottom() {
            return this.ik;
        }
        set valueTextMarginBottom(a) {
            this.ik = a;
            this.g("ValueTextMarginBottom");
        }
        get valueTextMarginLeft() {
            return this.il;
        }
        set valueTextMarginLeft(a) {
            this.il = a;
            this.g("ValueTextMarginLeft");
        }
        get valueTextMarginRight() {
            return this.im;
        }
        set valueTextMarginRight(a) {
            this.im = a;
            this.g("ValueTextMarginRight");
        }
        get valueTextMarginTop() {
            return this.io;
        }
        set valueTextMarginTop(a) {
            this.io = a;
            this.g("ValueTextMarginTop");
        }
        get valueTextColor() {
            return this.l7;
        }
        set valueTextColor(a) {
            this.l7 = a;
            this.g("ValueTextColor");
        }
        get valueTextFontFamily() {
            return this.l8;
        }
        set valueTextFontFamily(a) {
            this.l8 = a;
            this.g("ValueTextFontFamily");
        }
        get valueTextFontSize() {
            return this.ij;
        }
        set valueTextFontSize(a) {
            this.ij = a;
            this.g("ValueTextFontSize");
        }
        get valueTextFontStyle() {
            return this.l9;
        }
        set valueTextFontStyle(a) {
            this.l9 = a;
            this.g("ValueTextFontStyle");
        }
        get valueTextFontWeight() {
            return this.ma;
        }
        set valueTextFontWeight(a) {
            this.ma = a;
            this.g("ValueTextFontWeight");
        }
        get headerFormatString() {
            return this.kw;
        }
        set headerFormatString(a) {
            this.kw = a;
            this.g("HeaderFormatString");
        }
        get headerFormatSpecifiers() {
            return this.f9;
        }
        set headerFormatSpecifiers(a) {
            this.f9 = a;
            this.g("HeaderFormatSpecifiers");
        }
        get headerFormatCulture() {
            return this.ku;
        }
        set headerFormatCulture(a) {
            this.ku = a;
            this.g("HeaderFormatCulture");
        }
        get headerFormatDate() {
            return this.kv;
        }
        set headerFormatDate(a) {
            this.kv = a;
            this.g("HeaderFormatDate");
        }
        get headerFormatTime() {
            return this.kx;
        }
        set headerFormatTime(a) {
            this.kx = a;
            this.g("HeaderFormatTime");
        }
        get headerText() {
            return this.ky;
        }
        set headerText(a) {
            this.ky = a;
            this.g("HeaderText");
        }
        get headerTextColor() {
            return this.kz;
        }
        set headerTextColor(a) {
            this.kz = a;
            this.g("HeaderTextColor");
        }
        get headerTextMarginBottom() {
            return this.hh;
        }
        set headerTextMarginBottom(a) {
            this.hh = a;
            this.g("HeaderTextMarginBottom");
        }
        get headerTextMarginLeft() {
            return this.hi;
        }
        set headerTextMarginLeft(a) {
            this.hi = a;
            this.g("HeaderTextMarginLeft");
        }
        get headerTextMarginRight() {
            return this.hj;
        }
        set headerTextMarginRight(a) {
            this.hj = a;
            this.g("HeaderTextMarginRight");
        }
        get headerTextMarginTop() {
            return this.hk;
        }
        set headerTextMarginTop(a) {
            this.hk = a;
            this.g("HeaderTextMarginTop");
        }
        get headerRowMarginBottom() {
            return this.hc;
        }
        set headerRowMarginBottom(a) {
            this.hc = a;
            this.g("HeaderRowMarginBottom");
        }
        get headerRowMarginLeft() {
            return this.hd;
        }
        set headerRowMarginLeft(a) {
            this.hd = a;
            this.g("HeaderRowMarginLeft");
        }
        get headerRowMarginRight() {
            return this.he;
        }
        set headerRowMarginRight(a) {
            this.he = a;
            this.g("HeaderRowMarginRight");
        }
        get headerRowMarginTop() {
            return this.hf;
        }
        set headerRowMarginTop(a) {
            this.hf = a;
            this.g("HeaderRowMarginTop");
        }
        get headerRowVisible() {
            return this.gk;
        }
        set headerRowVisible(a) {
            this.gk = a;
            this.g("HeaderRowVisible");
        }
        get headerTextFontFamily() {
            return this.k0;
        }
        set headerTextFontFamily(a) {
            this.k0 = a;
            this.g("HeaderTextFontFamily");
        }
        get headerTextFontSize() {
            return this.hg;
        }
        set headerTextFontSize(a) {
            this.hg = a;
            this.g("HeaderTextFontSize");
        }
        get headerTextFontStyle() {
            return this.k1;
        }
        set headerTextFontStyle(a) {
            this.k1 = a;
            this.g("HeaderTextFontStyle");
        }
        get headerTextFontWeight() {
            return this.k2;
        }
        set headerTextFontWeight(a) {
            this.k2 = a;
            this.g("HeaderTextFontWeight");
        }
        get groupRowVisible() {
            return this.gj;
        }
        set groupRowVisible(a) {
            this.gj = a;
            this.g("GroupRowVisible");
        }
        get groupTextColor() {
            return this.kq;
        }
        set groupTextColor(a) {
            this.kq = a;
            this.g("GroupTextColor");
        }
        get groupTextMarginBottom() {
            return this.g8;
        }
        set groupTextMarginBottom(a) {
            this.g8 = a;
            this.g("GroupTextMarginBottom");
        }
        get groupTextMarginLeft() {
            return this.g9;
        }
        set groupTextMarginLeft(a) {
            this.g9 = a;
            this.g("GroupTextMarginLeft");
        }
        get groupTextMarginRight() {
            return this.ha;
        }
        set groupTextMarginRight(a) {
            this.ha = a;
            this.g("GroupTextMarginRight");
        }
        get groupTextMarginTop() {
            return this.hb;
        }
        set groupTextMarginTop(a) {
            this.hb = a;
            this.g("GroupTextMarginTop");
        }
        get groupRowMarginBottom() {
            return this.g3;
        }
        set groupRowMarginBottom(a) {
            this.g3 = a;
            this.g("GroupRowMarginBottom");
        }
        get groupRowMarginLeft() {
            return this.g4;
        }
        set groupRowMarginLeft(a) {
            this.g4 = a;
            this.g("GroupRowMarginLeft");
        }
        get groupRowMarginRight() {
            return this.g5;
        }
        set groupRowMarginRight(a) {
            this.g5 = a;
            this.g("GroupRowMarginRight");
        }
        get groupRowMarginTop() {
            return this.g6;
        }
        set groupRowMarginTop(a) {
            this.g6 = a;
            this.g("GroupRowMarginTop");
        }
        get groupTextFontFamily() {
            return this.kr;
        }
        set groupTextFontFamily(a) {
            this.kr = a;
            this.g("GroupTextFontFamily");
        }
        get groupTextFontSize() {
            return this.g7;
        }
        set groupTextFontSize(a) {
            this.g7 = a;
            this.g("GroupTextFontSize");
        }
        get groupTextFontStyle() {
            return this.ks;
        }
        set groupTextFontStyle(a) {
            this.ks = a;
            this.g("GroupTextFontStyle");
        }
        get groupTextFontWeight() {
            return this.kt;
        }
        set groupTextFontWeight(a) {
            this.kt = a;
            this.g("GroupTextFontWeight");
        }
        get summaryTitleTextColor() {
            return this.le;
        }
        set summaryTitleTextColor(a) {
            this.le = a;
            this.g("SummaryTitleTextColor");
        }
        get summaryTitleTextFontFamily() {
            return this.lf;
        }
        set summaryTitleTextFontFamily(a) {
            this.lf = a;
            this.g("SummaryTitleTextFontFamily");
        }
        get summaryTitleTextFontSize() {
            return this.hx;
        }
        set summaryTitleTextFontSize(a) {
            this.hx = a;
            this.g("SummaryTitleTextFontSize");
        }
        get summaryTitleTextFontStyle() {
            return this.lg;
        }
        set summaryTitleTextFontStyle(a) {
            this.lg = a;
            this.g("SummaryTitleTextFontStyle");
        }
        get summaryTitleTextFontWeight() {
            return this.lh;
        }
        set summaryTitleTextFontWeight(a) {
            this.lh = a;
            this.g("SummaryTitleTextFontWeight");
        }
        get summaryType() {
            return this.li;
        }
        set summaryType(a) {
            this.li = a;
            this.g("SummaryType");
        }
        get summaryTitleText() {
            return this.ld;
        }
        set summaryTitleText(a) {
            this.ld = a;
            this.g("SummaryTitleText");
        }
        get summaryTitleTextMarginBottom() {
            return this.hy;
        }
        set summaryTitleTextMarginBottom(a) {
            this.hy = a;
            this.g("SummaryTitleTextMarginBottom");
        }
        get summaryTitleTextMarginLeft() {
            return this.hz;
        }
        set summaryTitleTextMarginLeft(a) {
            this.hz = a;
            this.g("SummaryTitleTextMarginLeft");
        }
        get summaryTitleTextMarginRight() {
            return this.h0;
        }
        set summaryTitleTextMarginRight(a) {
            this.h0 = a;
            this.g("SummaryTitleTextMarginRight");
        }
        get summaryTitleTextMarginTop() {
            return this.h1;
        }
        set summaryTitleTextMarginTop(a) {
            this.h1 = a;
            this.g("SummaryTitleTextMarginTop");
        }
        get summaryRowMarginBottom() {
            return this.ht;
        }
        set summaryRowMarginBottom(a) {
            this.ht = a;
            this.g("SummaryRowMarginBottom");
        }
        get summaryRowMarginLeft() {
            return this.hu;
        }
        set summaryRowMarginLeft(a) {
            this.hu = a;
            this.g("SummaryRowMarginLeft");
        }
        get summaryRowMarginRight() {
            return this.hv;
        }
        set summaryRowMarginRight(a) {
            this.hv = a;
            this.g("SummaryRowMarginRight");
        }
        get summaryRowMarginTop() {
            return this.hw;
        }
        set summaryRowMarginTop(a) {
            this.hw = a;
            this.g("SummaryRowMarginTop");
        }
        get summaryValueTextColor() {
            return this.lo;
        }
        set summaryValueTextColor(a) {
            this.lo = a;
            this.g("SummaryValueTextColor");
        }
        get summaryValueTextFontFamily() {
            return this.lp;
        }
        set summaryValueTextFontFamily(a) {
            this.lp = a;
            this.g("SummaryValueTextFontFamily");
        }
        get summaryValueTextFontSize() {
            return this.h3;
        }
        set summaryValueTextFontSize(a) {
            this.h3 = a;
            this.g("SummaryValueTextFontSize");
        }
        get summaryValueTextFontStyle() {
            return this.lq;
        }
        set summaryValueTextFontStyle(a) {
            this.lq = a;
            this.g("SummaryValueTextFontStyle");
        }
        get summaryValueTextFontWeight() {
            return this.lr;
        }
        set summaryValueTextFontWeight(a) {
            this.lr = a;
            this.g("SummaryValueTextFontWeight");
        }
        get summaryLabelText() {
            return this.k8;
        }
        set summaryLabelText(a) {
            this.k8 = a;
            this.g("SummaryLabelText");
        }
        get summaryLabelTextColor() {
            return this.k9;
        }
        set summaryLabelTextColor(a) {
            this.k9 = a;
            this.g("SummaryLabelTextColor");
        }
        get summaryLabelTextFontFamily() {
            return this.la;
        }
        set summaryLabelTextFontFamily(a) {
            this.la = a;
            this.g("SummaryLabelTextFontFamily");
        }
        get summaryLabelTextFontSize() {
            return this.hs;
        }
        set summaryLabelTextFontSize(a) {
            this.hs = a;
            this.g("SummaryLabelTextFontSize");
        }
        get summaryLabelTextFontStyle() {
            return this.lb;
        }
        set summaryLabelTextFontStyle(a) {
            this.lb = a;
            this.g("SummaryLabelTextFontStyle");
        }
        get summaryLabelTextFontWeight() {
            return this.lc;
        }
        set summaryLabelTextFontWeight(a) {
            this.lc = a;
            this.g("SummaryLabelTextFontWeight");
        }
        get summaryUnitsText() {
            return this.lj;
        }
        set summaryUnitsText(a) {
            this.lj = a;
            this.g("SummaryUnitsText");
        }
        get summaryUnitsTextColor() {
            return this.lk;
        }
        set summaryUnitsTextColor(a) {
            this.lk = a;
            this.g("SummaryUnitsTextColor");
        }
        get summaryUnitsTextFontFamily() {
            return this.ll;
        }
        set summaryUnitsTextFontFamily(a) {
            this.ll = a;
            this.g("SummaryUnitsTextFontFamily");
        }
        get summaryUnitsTextFontSize() {
            return this.h2;
        }
        set summaryUnitsTextFontSize(a) {
            this.h2 = a;
            this.g("SummaryUnitsTextFontSize");
        }
        get summaryUnitsTextFontStyle() {
            return this.lm;
        }
        set summaryUnitsTextFontStyle(a) {
            this.lm = a;
            this.g("SummaryUnitsTextFontStyle");
        }
        get summaryUnitsTextFontWeight() {
            return this.ln;
        }
        set summaryUnitsTextFontWeight(a) {
            this.ln = a;
            this.g("SummaryUnitsTextFontWeight");
        }
        get badgeMarginBottom() {
            return this.gx;
        }
        set badgeMarginBottom(a) {
            this.gx = a;
            this.g("BadgeMarginBottom");
        }
        get badgeMarginLeft() {
            return this.gy;
        }
        set badgeMarginLeft(a) {
            this.gy = a;
            this.g("BadgeMarginLeft");
        }
        get badgeMarginRight() {
            return this.gz;
        }
        set badgeMarginRight(a) {
            this.gz = a;
            this.g("BadgeMarginRight");
        }
        get badgeMarginTop() {
            return this.g0;
        }
        set badgeMarginTop(a) {
            this.g0 = a;
            this.g("BadgeMarginTop");
        }
        get badgeShape() {
            return this.km;
        }
        set badgeShape(a) {
            this.km = a;
            this.g("BadgeShape");
        }
        get unitsDisplayMode() {
            return this.lx;
        }
        set unitsDisplayMode(a) {
            this.lx = a;
            this.g("UnitsDisplayMode");
        }
        get unitsText() {
            return this.ly;
        }
        set unitsText(a) {
            this.ly = a;
            this.g("UnitsText");
        }
        get unitsTextColor() {
            return this.lz;
        }
        set unitsTextColor(a) {
            this.lz = a;
            this.g("UnitsTextColor");
        }
        get unitsTextMarginBottom() {
            return this.ia;
        }
        set unitsTextMarginBottom(a) {
            this.ia = a;
            this.g("UnitsTextMarginBottom");
        }
        get unitsTextMarginLeft() {
            return this.ib;
        }
        set unitsTextMarginLeft(a) {
            this.ib = a;
            this.g("UnitsTextMarginLeft");
        }
        get unitsTextMarginRight() {
            return this.ic;
        }
        set unitsTextMarginRight(a) {
            this.ic = a;
            this.g("UnitsTextMarginRight");
        }
        get unitsTextMarginTop() {
            return this.id;
        }
        set unitsTextMarginTop(a) {
            this.id = a;
            this.g("UnitsTextMarginTop");
        }
        get unitsTextFontFamily() {
            return this.l0;
        }
        set unitsTextFontFamily(a) {
            this.l0 = a;
            this.g("UnitsTextFontFamily");
        }
        get unitsTextFontSize() {
            return this.h9;
        }
        set unitsTextFontSize(a) {
            this.h9 = a;
            this.g("UnitsTextFontSize");
        }
        get unitsTextFontStyle() {
            return this.l1;
        }
        set unitsTextFontStyle(a) {
            this.l1 = a;
            this.g("UnitsTextFontStyle");
        }
        get unitsTextFontWeight() {
            return this.l2;
        }
        set unitsTextFontWeight(a) {
            this.l2 = a;
            this.g("UnitsTextFontWeight");
        }
        get titleTextMarginBottom() {
            return this.h5;
        }
        set titleTextMarginBottom(a) {
            this.h5 = a;
            this.g("TitleTextMarginBottom");
        }
        get titleTextMarginLeft() {
            return this.h6;
        }
        set titleTextMarginLeft(a) {
            this.h6 = a;
            this.g("TitleTextMarginLeft");
        }
        get titleTextMarginRight() {
            return this.h7;
        }
        set titleTextMarginRight(a) {
            this.h7 = a;
            this.g("TitleTextMarginRight");
        }
        get titleTextMarginTop() {
            return this.h8;
        }
        set titleTextMarginTop(a) {
            this.h8 = a;
            this.g("TitleTextMarginTop");
        }
        get titleTextColor() {
            return this.lt;
        }
        set titleTextColor(a) {
            this.lt = a;
            this.g("TitleTextColor");
        }
        get titleTextFontFamily() {
            return this.lu;
        }
        set titleTextFontFamily(a) {
            this.lu = a;
            this.g("TitleTextFontFamily");
        }
        get titleTextFontSize() {
            return this.h4;
        }
        set titleTextFontSize(a) {
            this.h4 = a;
            this.g("TitleTextFontSize");
        }
        get titleTextFontStyle() {
            return this.lv;
        }
        set titleTextFontStyle(a) {
            this.lv = a;
            this.g("TitleTextFontStyle");
        }
        get titleTextFontWeight() {
            return this.lw;
        }
        set titleTextFontWeight(a) {
            this.lw = a;
            this.g("TitleTextFontWeight");
        }
        get labelDisplayMode() {
            return this.k3;
        }
        set labelDisplayMode(a) {
            this.k3 = a;
            this.g("LabelDisplayMode");
        }
        get labelTextColor() {
            return this.k4;
        }
        set labelTextColor(a) {
            this.k4 = a;
            this.g("LabelTextColor");
        }
        get labelTextMarginBottom() {
            return this.hm;
        }
        set labelTextMarginBottom(a) {
            this.hm = a;
            this.g("LabelTextMarginBottom");
        }
        get labelTextMarginLeft() {
            return this.hn;
        }
        set labelTextMarginLeft(a) {
            this.hn = a;
            this.g("LabelTextMarginLeft");
        }
        get labelTextMarginRight() {
            return this.ho;
        }
        set labelTextMarginRight(a) {
            this.ho = a;
            this.g("LabelTextMarginRight");
        }
        get labelTextMarginTop() {
            return this.hp;
        }
        set labelTextMarginTop(a) {
            this.hp = a;
            this.g("LabelTextMarginTop");
        }
        get labelTextFontFamily() {
            return this.k5;
        }
        set labelTextFontFamily(a) {
            this.k5 = a;
            this.g("LabelTextFontFamily");
        }
        get labelTextFontSize() {
            return this.hl;
        }
        set labelTextFontSize(a) {
            this.hl = a;
            this.g("LabelTextFontSize");
        }
        get labelTextFontStyle() {
            return this.k6;
        }
        set labelTextFontStyle(a) {
            this.k6 = a;
            this.g("LabelTextFontStyle");
        }
        get labelTextFontWeight() {
            return this.k7;
        }
        set labelTextFontWeight(a) {
            this.k7 = a;
            this.g("LabelTextFontWeight");
        }
    }
    DataToolTipLayerDescription.$t = /*@__PURE__*/ markType(DataToolTipLayerDescription, 'DataToolTipLayerDescription', AnnotationLayerDescription.$);
    return DataToolTipLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataToolTipLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataToolTipLayerDescriptionMetadata extends Base {
        static b(a) {
            if (DataToolTipLayerDescriptionMetadata.a == null) {
                DataToolTipLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataToolTipLayerDescriptionMetadata.c(DataToolTipLayerDescriptionMetadata.a);
            }
            if (a.k(DataToolTipLayerDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataToolTipLayerDescriptionMetadata.a);
        }
        static c(a) {
            AnnotationLayerDescriptionMetadata.c(a);
            a.item("TargetAxisRef", "(w:TargetAxis,wf:TargetAxis)DataRef::object");
            a.item("UseInterpolation", "Boolean");
            a.item("GroupingMode", "ExportedType:string:DataToolTipLayerGroupingMode");
            a.item("GroupingMode@names", "Auto;Grouped;Individual");
            a.item("ActualGroupingMode", "ExportedType:string:DataToolTipLayerGroupingMode");
            a.item("ActualGroupingMode@names", "Auto;Grouped;Individual");
            a.item("PositionOffsetX", "Number:double");
            a.item("PositionOffsetY", "Number:double");
            a.item("DefaultPositionOffsetX", "Number:double");
            a.item("DefaultPositionOffsetY", "Number:double");
            a.item("GroupedPositionModeX", "ExportedType:string:DataTooltipGroupedPositionX");
            a.item("GroupedPositionModeX@names", "Auto;SnapLeft;SnapRight;SnapMiddle;LeftEdgeSnapLeft;LeftEdgeSnapRight;LeftEdgeSnapMiddle;RightEdgeSnapLeft;RightEdgeSnapRight;RightEdgeSnapMiddle;TrackLeft;TrackRight;TrackMiddle;PinLeft;PinRight;PinMiddle");
            a.item("ActualGroupedPositionModeX", "ExportedType:string:DataTooltipGroupedPositionX");
            a.item("ActualGroupedPositionModeX@names", "Auto;SnapLeft;SnapRight;SnapMiddle;LeftEdgeSnapLeft;LeftEdgeSnapRight;LeftEdgeSnapMiddle;RightEdgeSnapLeft;RightEdgeSnapRight;RightEdgeSnapMiddle;TrackLeft;TrackRight;TrackMiddle;PinLeft;PinRight;PinMiddle");
            a.item("GroupedPositionModeY", "ExportedType:string:DataTooltipGroupedPositionY");
            a.item("GroupedPositionModeY@names", "Auto;SnapTop;SnapBottom;SnapMiddle;TopEdgeSnapTop;TopEdgeSnapBottom;TopEdgeSnapMiddle;BottomEdgeSnapTop;BottomEdgeSnapBottom;BottomEdgeSnapMiddle;TrackTop;TrackBottom;TrackMiddle;PinTop;PinBottom;PinMiddle");
            a.item("ActualGroupedPositionModeY", "ExportedType:string:DataTooltipGroupedPositionY");
            a.item("ActualGroupedPositionModeY@names", "Auto;SnapTop;SnapBottom;SnapMiddle;TopEdgeSnapTop;TopEdgeSnapBottom;TopEdgeSnapMiddle;BottomEdgeSnapTop;BottomEdgeSnapBottom;BottomEdgeSnapMiddle;TrackTop;TrackBottom;TrackMiddle;PinTop;PinBottom;PinMiddle");
            a.item("ShouldUpdateWhenSeriesDataChanges", "Boolean");
            a.item("IncludedSeries", "Array:string");
            a.item("ExcludedSeries", "Array:string");
            a.item("IncludedColumns", "Array:string");
            a.item("ExcludedColumns", "Array:string");
            a.item("ValueFormatAbbreviation", "ExportedType:string:DataAbbreviationMode");
            a.item("ValueFormatAbbreviation@names", "Auto;Independent;Shared;Kilo;Million;Billion;Trillion;Quadrillion;Unset;None");
            a.item("ValueFormatMaxFractions", "Number:int");
            a.item("ValueFormatMinFractions", "Number:int");
            a.item("ValueFormatMode", "ExportedType:string:DataLegendValueMode");
            a.item("ValueFormatMode@names", "Auto;Decimal;Currency");
            a.item("ValueFormatCulture", "String");
            a.item("ValueFormatUseGrouping", "Boolean");
            a.item("ValueFormatString", "String");
            a.item("ValueFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("ValueFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("ValueRowMarginBottom", "(w:ValueRowMargin.Bottom,wf:ValueRowMarginBottom)Number:double");
            a.item("ValueRowMarginLeft", "(w:ValueRowMargin.Left,wf:ValueRowMarginLeft)Number:double");
            a.item("ValueRowMarginRight", "(w:ValueRowMargin.Right,wf:ValueRowMarginRight)Number:double");
            a.item("ValueRowMarginTop", "(w:ValueRowMargin.Top,wf:ValueRowMarginTop)Number:double");
            a.item("ValueRowVisible", "Boolean");
            a.item("ValueTextWhenMissingData", "String");
            a.item("ValueTextUseSeriesColors", "Boolean");
            a.item("ValueTextMarginBottom", "(w:ValueTextMargin.Bottom,wf:ValueTextMarginBottom)Number:double");
            a.item("ValueTextMarginLeft", "(w:ValueTextMargin.Left,wf:ValueTextMarginLeft)Number:double");
            a.item("ValueTextMarginRight", "(w:ValueTextMargin.Right,wf:ValueTextMarginRight)Number:double");
            a.item("ValueTextMarginTop", "(w:ValueTextMargin.Top,wf:ValueTextMarginTop)Number:double");
            a.item("ValueTextColor", "Brush");
            a.item("ValueTextFontFamily", "(w:ValueTextFontFamily/FontFamilyTransform,xam:ValueTextFontFamily,wf:ValueTextFontFamily,web:valueTextStyle/FontFamilyTransform)String");
            a.item("ValueTextFontSize", "(w:ValueTextFontSize,xam:ValueTextFontSize,wf:ValueTextFontSize,web:valueTextStyle/FontSizeTransform)Number:double");
            a.item("ValueTextFontStyle", "(w:ValueTextFontStyle/FontStyleTransform,xam:ValueTextFontFamily/FontStyleTransform,wf:ValueTextFontFamily/FontStyleTransform,web:valueTextStyle/FontStyleTransform)String");
            a.item("ValueTextFontWeight", "(w:ValueTextFontWeight/FontWeightTransform,xam:ValueTextFontFamily/FontWeightTransform,wf:ValueTextFontFamily/FontWeightTransform,web:valueTextStyle/FontWeightTransform)String");
            a.item("HeaderFormatString", "String");
            a.item("HeaderFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("HeaderFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("HeaderFormatCulture", "String");
            a.item("HeaderFormatDate", "ExportedType:string:DataLegendHeaderDateMode");
            a.item("HeaderFormatDate@names", "Auto;ShortStyle;LongStyle;MediumStyle;FullStyle;None");
            a.item("HeaderFormatTime", "ExportedType:string:DataLegendHeaderTimeMode");
            a.item("HeaderFormatTime@names", "Auto;ShortStyle;LongStyle;MediumStyle;FullStyle;None");
            a.item("HeaderText", "String");
            a.item("HeaderTextColor", "Brush");
            a.item("HeaderTextMarginBottom", "(w:HeaderTextMargin.Bottom,wf:HeaderTextMarginBottom)Number:double");
            a.item("HeaderTextMarginLeft", "(w:HeaderTextMargin.Left,wf:HeaderTextMarginLeft)Number:double");
            a.item("HeaderTextMarginRight", "(w:HeaderTextMargin.Right,wf:HeaderTextMarginRight)Number:double");
            a.item("HeaderTextMarginTop", "(w:HeaderTextMargin.Top,wf:HeaderTextMarginTop)Number:double");
            a.item("HeaderRowMarginBottom", "(w:HeaderRowMargin.Bottom,wf:HeaderRowMarginBottom)Number:double");
            a.item("HeaderRowMarginLeft", "(w:HeaderRowMargin.Left,wf:HeaderRowMarginLeft)Number:double");
            a.item("HeaderRowMarginRight", "(w:HeaderRowMargin.Right,wf:HeaderRowMarginRight)Number:double");
            a.item("HeaderRowMarginTop", "(w:HeaderRowMargin.Top,wf:HeaderRowMarginTop)Number:double");
            a.item("HeaderRowVisible", "Boolean");
            a.item("HeaderTextFontFamily", "(w:HeaderTextFontFamily/FontFamilyTransform,xam:HeaderTextFontFamily,wf:HeaderTextFontFamily,web:headerTextStyle/FontFamilyTransform)String");
            a.item("HeaderTextFontSize", "(w:HeaderTextFontSize,xam:HeaderTextFontSize,wf:HeaderTextFontSize,web:headerTextStyle/FontSizeTransform)Number:double");
            a.item("HeaderTextFontStyle", "(w:HeaderTextFontStyle/FontStyleTransform,xam:HeaderTextFontFamily/FontStyleTransform,wf:HeaderTextFontFamily/FontStyleTransform,web:headerTextStyle/FontStyleTransform)String");
            a.item("HeaderTextFontWeight", "(w:HeaderTextFontWeight/FontWeightTransform,xam:HeaderTextFontFamily/FontWeightTransform,wf:HeaderTextFontFamily/FontWeightTransform,web:headerTextStyle/FontWeightTransform)String");
            a.item("GroupRowVisible", "Boolean");
            a.item("GroupTextColor", "Brush");
            a.item("GroupTextMarginBottom", "(w:GroupTextMargin.Bottom,wf:GroupTextMarginBottom)Number:double");
            a.item("GroupTextMarginLeft", "(w:GroupTextMargin.Left,wf:GroupTextMarginLeft)Number:double");
            a.item("GroupTextMarginRight", "(w:GroupTextMargin.Right,wf:GroupTextMarginRight)Number:double");
            a.item("GroupTextMarginTop", "(w:GroupTextMargin.Top,wf:GroupTextMarginTop)Number:double");
            a.item("GroupRowMarginBottom", "(w:GroupRowMargin.Bottom,wf:GroupRowMarginBottom)Number:double");
            a.item("GroupRowMarginLeft", "(w:GroupRowMargin.Left,wf:GroupRowMarginLeft)Number:double");
            a.item("GroupRowMarginRight", "(w:GroupRowMargin.Right,wf:GroupRowMarginRight)Number:double");
            a.item("GroupRowMarginTop", "(w:GroupRowMargin.Top,wf:GroupRowMarginTop)Number:double");
            a.item("GroupTextFontFamily", "(w:GroupTextFontFamily/FontFamilyTransform,xam:GroupTextFontFamily,wf:GroupTextFontFamily,web:groupTextStyle/FontFamilyTransform)String");
            a.item("GroupTextFontSize", "(w:GroupTextFontSize,xam:GroupTextFontSize,wf:GroupTextFontSize,web:groupTextStyle/FontSizeTransform)Number:double");
            a.item("GroupTextFontStyle", "(w:GroupTextFontStyle/FontStyleTransform,xam:GroupTextFontFamily/FontStyleTransform,wf:GroupTextFontFamily/FontStyleTransform,web:groupTextStyle/FontStyleTransform)String");
            a.item("GroupTextFontWeight", "(w:GroupTextFontWeight/FontWeightTransform,xam:GroupTextFontFamily/FontWeightTransform,wf:GroupTextFontFamily/FontWeightTransform,web:groupTextStyle/FontWeightTransform)String");
            a.item("SummaryTitleTextColor", "Brush");
            a.item("SummaryTitleTextFontFamily", "(w:SummaryTitleTextFontFamily/FontFamilyTransform,xam:SummaryTitleTextFontFamily,wf:SummaryTitleTextFontFamily,web:summaryTitleTextStyle/FontFamilyTransform)String");
            a.item("SummaryTitleTextFontSize", "(w:SummaryTitleTextFontSize,xam:SummaryTitleTextFontSize,wf:SummaryTitleTextFontSize,web:summaryTitleTextStyle/FontSizeTransform)Number:double");
            a.item("SummaryTitleTextFontStyle", "(w:SummaryTitleTextFontStyle/FontStyleTransform,xam:SummaryTitleTextFontFamily/FontStyleTransform,wf:SummaryTitleTextFontFamily/FontStyleTransform,web:summaryTitleTextStyle/FontStyleTransform)String");
            a.item("SummaryTitleTextFontWeight", "(w:SummaryTitleTextFontWeight/FontWeightTransform,xam:SummaryTitleTextFontFamily/FontWeightTransform,wf:SummaryTitleTextFontFamily/FontWeightTransform,web:summaryTitleTextStyle/FontWeightTransform)String");
            a.item("SummaryType", "ExportedType:string:DataLegendSummaryType");
            a.item("SummaryType@names", "Auto;Total;Average;Min;Max;None");
            a.item("SummaryTitleText", "String");
            a.item("SummaryTitleTextMarginBottom", "(w:SummaryTitleTextMargin.Bottom,wf:SummaryTitleTextMarginBottom)Number:double");
            a.item("SummaryTitleTextMarginLeft", "(w:SummaryTitleTextMargin.Left,wf:SummaryTitleTextMarginLeft)Number:double");
            a.item("SummaryTitleTextMarginRight", "(w:SummaryTitleTextMargin.Right,wf:SummaryTitleTextMarginRight)Number:double");
            a.item("SummaryTitleTextMarginTop", "(w:SummaryTitleTextMargin.Top,wf:SummaryTitleTextMarginTop)Number:double");
            a.item("SummaryRowMarginBottom", "(w:SummaryRowMargin.Bottom,wf:SummaryRowMarginBottom)Number:double");
            a.item("SummaryRowMarginLeft", "(w:SummaryRowMargin.Left,wf:SummaryRowMarginLeft)Number:double");
            a.item("SummaryRowMarginRight", "(w:SummaryRowMargin.Right,wf:SummaryRowMarginRight)Number:double");
            a.item("SummaryRowMarginTop", "(w:SummaryRowMargin.Top,wf:SummaryRowMarginTop)Number:double");
            a.item("SummaryValueTextColor", "Brush");
            a.item("SummaryValueTextFontFamily", "(w:SummaryValueTextFontFamily/FontFamilyTransform,xam:SummaryValueTextFontFamily,wf:SummaryValueTextFontFamily,web:summaryValueTextStyle/FontFamilyTransform)String");
            a.item("SummaryValueTextFontSize", "(w:SummaryValueTextFontSize,xam:SummaryValueTextFontSize,wf:SummaryValueTextFontSize,web:summaryValueTextStyle/FontSizeTransform)Number:double");
            a.item("SummaryValueTextFontStyle", "(w:SummaryValueTextFontStyle/FontStyleTransform,xam:SummaryValueTextFontFamily/FontStyleTransform,wf:SummaryValueTextFontFamily/FontStyleTransform,web:summaryValueTextStyle/FontStyleTransform)String");
            a.item("SummaryValueTextFontWeight", "(w:SummaryValueTextFontWeight/FontWeightTransform,xam:SummaryValueTextFontFamily/FontWeightTransform,wf:SummaryValueTextFontFamily/FontWeightTransform,web:summaryValueTextStyle/FontWeightTransform)String");
            a.item("SummaryLabelText", "String");
            a.item("SummaryLabelTextColor", "Brush");
            a.item("SummaryLabelTextFontFamily", "(w:SummaryLabelTextFontFamily/FontFamilyTransform,xam:SummaryLabelTextFontFamily,wf:SummaryLabelTextFontFamily,web:summaryLabelTextStyle/FontFamilyTransform)String");
            a.item("SummaryLabelTextFontSize", "(w:SummaryLabelTextFontSize,xam:SummaryLabelTextFontSize,wf:SummaryLabelTextFontSize,web:summaryLabelTextStyle/FontSizeTransform)Number:double");
            a.item("SummaryLabelTextFontStyle", "(w:SummaryLabelTextFontStyle/FontStyleTransform,xam:SummaryLabelTextFontFamily/FontStyleTransform,wf:SummaryLabelTextFontFamily/FontStyleTransform,web:summaryLabelTextStyle/FontStyleTransform)String");
            a.item("SummaryLabelTextFontWeight", "(w:SummaryLabelTextFontWeight/FontWeightTransform,xam:SummaryLabelTextFontFamily/FontWeightTransform,wf:SummaryLabelTextFontFamily/FontWeightTransform,web:summaryLabelTextStyle/FontWeightTransform)String");
            a.item("SummaryUnitsText", "String");
            a.item("SummaryUnitsTextColor", "Brush");
            a.item("SummaryUnitsTextFontFamily", "(w:SummaryUnitsTextFontFamily/FontFamilyTransform,xam:SummaryUnitsTextFontFamily,wf:SummaryUnitsTextFontFamily,web:summaryUnitsTextStyle/FontFamilyTransform)String");
            a.item("SummaryUnitsTextFontSize", "(w:SummaryUnitsTextFontSize,xam:SummaryUnitsTextFontSize,wf:SummaryUnitsTextFontSize,web:summaryUnitsTextStyle/FontSizeTransform)Number:double");
            a.item("SummaryUnitsTextFontStyle", "(w:SummaryUnitsTextFontStyle/FontStyleTransform,xam:SummaryUnitsTextFontFamily/FontStyleTransform,wf:SummaryUnitsTextFontFamily/FontStyleTransform,web:summaryUnitsTextStyle/FontStyleTransform)String");
            a.item("SummaryUnitsTextFontWeight", "(w:SummaryUnitsTextFontWeight/FontWeightTransform,xam:SummaryUnitsTextFontFamily/FontWeightTransform,wf:SummaryUnitsTextFontFamily/FontWeightTransform,web:summaryUnitsTextStyle/FontWeightTransform)String");
            a.item("BadgeMarginBottom", "(w:BadgeMargin.Bottom,wf:BadgeMarginBottom)Number:double");
            a.item("BadgeMarginLeft", "(w:BadgeMargin.Left,wf:BadgeMarginLeft)Number:double");
            a.item("BadgeMarginRight", "(w:BadgeMargin.Right,wf:BadgeMarginRight)Number:double");
            a.item("BadgeMarginTop", "(w:BadgeMargin.Top,wf:BadgeMarginTop)Number:double");
            a.item("BadgeShape", "ExportedType:string:LegendItemBadgeShape");
            a.item("BadgeShape@names", "Automatic;Circle;Line;Square;Marker;Bar;Column;Hidden");
            a.item("UnitsDisplayMode", "ExportedType:string:DataLegendUnitsMode");
            a.item("UnitsDisplayMode@names", "Auto;Visible;Hidden");
            a.item("UnitsText", "String");
            a.item("UnitsTextColor", "Brush");
            a.item("UnitsTextMarginBottom", "(w:UnitsTextMargin.Bottom,wf:UnitsTextMarginBottom)Number:double");
            a.item("UnitsTextMarginLeft", "(w:UnitsTextMargin.Left,wf:UnitsTextMarginLeft)Number:double");
            a.item("UnitsTextMarginRight", "(w:UnitsTextMargin.Right,wf:UnitsTextMarginRight)Number:double");
            a.item("UnitsTextMarginTop", "(w:UnitsTextMargin.Top,wf:UnitsTextMarginTop)Number:double");
            a.item("UnitsTextFontFamily", "(w:UnitsTextFontFamily/FontFamilyTransform,xam:UnitsTextFontFamily,wf:UnitsTextFontFamily,web:unitsTextStyle/FontFamilyTransform)String");
            a.item("UnitsTextFontSize", "(w:UnitsTextFontSize,xam:UnitsTextFontSize,wf:UnitsTextFontSize,web:unitsTextStyle/FontSizeTransform)Number:double");
            a.item("UnitsTextFontStyle", "(w:UnitsTextFontStyle/FontStyleTransform,xam:UnitsTextFontFamily/FontStyleTransform,wf:UnitsTextFontFamily/FontStyleTransform,web:unitsTextStyle/FontStyleTransform)String");
            a.item("UnitsTextFontWeight", "(w:UnitsTextFontWeight/FontWeightTransform,xam:UnitsTextFontFamily/FontWeightTransform,wf:UnitsTextFontFamily/FontWeightTransform,web:unitsTextStyle/FontWeightTransform)String");
            a.item("TitleTextMarginBottom", "(w:TitleTextMargin.Bottom,wf:TitleTextMarginBottom)Number:double");
            a.item("TitleTextMarginLeft", "(w:TitleTextMargin.Left,wf:TitleTextMarginLeft)Number:double");
            a.item("TitleTextMarginRight", "(w:TitleTextMargin.Right,wf:TitleTextMarginRight)Number:double");
            a.item("TitleTextMarginTop", "(w:TitleTextMargin.Top,wf:TitleTextMarginTop)Number:double");
            a.item("TitleTextColor", "Brush");
            a.item("TitleTextFontFamily", "(w:TitleTextFontFamily/FontFamilyTransform,xam:TitleTextFontFamily,wf:TitleTextFontFamily,web:titleTextStyle/FontFamilyTransform)String");
            a.item("TitleTextFontSize", "(w:TitleTextFontSize,xam:TitleTextFontSize,wf:TitleTextFontSize,web:titleTextStyle/FontSizeTransform)Number:double");
            a.item("TitleTextFontStyle", "(w:TitleTextFontStyle/FontStyleTransform,xam:TitleTextFontFamily/FontStyleTransform,wf:TitleTextFontFamily/FontStyleTransform,web:titleTextStyle/FontStyleTransform)String");
            a.item("TitleTextFontWeight", "(w:TitleTextFontWeight/FontWeightTransform,xam:TitleTextFontFamily/FontWeightTransform,wf:TitleTextFontFamily/FontWeightTransform,web:titleTextStyle/FontWeightTransform)String");
            a.item("LabelDisplayMode", "ExportedType:string:DataLegendLabelMode");
            a.item("LabelDisplayMode@names", "Auto;Visible;Hidden");
            a.item("LabelTextColor", "Brush");
            a.item("LabelTextMarginBottom", "(w:LabelTextMargin.Bottom,wf:LabelTextMarginBottom)Number:double");
            a.item("LabelTextMarginLeft", "(w:LabelTextMargin.Left,wf:LabelTextMarginLeft)Number:double");
            a.item("LabelTextMarginRight", "(w:LabelTextMargin.Right,wf:LabelTextMarginRight)Number:double");
            a.item("LabelTextMarginTop", "(w:LabelTextMargin.Top,wf:LabelTextMarginTop)Number:double");
            a.item("LabelTextFontFamily", "(w:LabelTextFontFamily/FontFamilyTransform,xam:LabelTextFontFamily,wf:LabelTextFontFamily,web:labelTextStyle/FontFamilyTransform)String");
            a.item("LabelTextFontSize", "(w:LabelTextFontSize,xam:LabelTextFontSize,wf:LabelTextFontSize,web:labelTextStyle/FontSizeTransform)Number:double");
            a.item("LabelTextFontStyle", "(w:LabelTextFontStyle/FontStyleTransform,xam:LabelTextFontFamily/FontStyleTransform,wf:LabelTextFontFamily/FontStyleTransform,web:labelTextStyle/FontStyleTransform)String");
            a.item("LabelTextFontWeight", "(w:LabelTextFontWeight/FontWeightTransform,xam:LabelTextFontFamily/FontWeightTransform,wf:LabelTextFontFamily/FontWeightTransform,web:labelTextStyle/FontWeightTransform)String");
        }
        static d(a) {
            DataToolTipLayerDescriptionMetadata.b(a);
            a.ae("DataToolTipLayer", () => new DataToolTipLayerDescription());
            a.ad("DataToolTipLayer", DataToolTipLayerDescriptionMetadata.a);
        }
    }
    DataToolTipLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(DataToolTipLayerDescriptionMetadata, 'DataToolTipLayerDescriptionMetadata');
    DataToolTipLayerDescriptionMetadata.a = null;
    return DataToolTipLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataToolTipLayerDescriptionModule = /*@__PURE__*/ (() => {
    class DataToolTipLayerDescriptionModule extends Base {
        static register(a) {
            DataToolTipLayerDescriptionMetadata.d(a);
        }
    }
    DataToolTipLayerDescriptionModule.$t = /*@__PURE__*/ markType(DataToolTipLayerDescriptionModule, 'DataToolTipLayerDescriptionModule');
    return DataToolTipLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinalValueLayerDescription = /*@__PURE__*/ (() => {
    class FinalValueLayerDescription extends AnnotationLayerDescription {
        get_type() {
            return "FinalValueLayer";
        }
        constructor() {
            super();
            this.gq = null;
            this.gr = null;
            this.gp = null;
            this.go = null;
            this.gl = null;
            this.f7 = 0;
            this.gj = 0;
            this.gn = null;
            this.f9 = 0;
            this.gb = 0;
            this.ga = 0;
            this.f8 = 0;
            this.gc = 0;
            this.gm = null;
        }
        get targetSeriesName() {
            return this.gq;
        }
        set targetSeriesName(a) {
            this.gq = a;
            this.g("TargetSeriesName");
        }
        get targetSeriesRef() {
            return this.gr;
        }
        set targetSeriesRef(a) {
            this.gr = a;
            this.g("TargetSeriesRef");
        }
        get finalValueSelectionMode() {
            return this.gp;
        }
        set finalValueSelectionMode(a) {
            this.gp = a;
            this.g("FinalValueSelectionMode");
        }
        get axisAnnotationTextColor() {
            return this.go;
        }
        set axisAnnotationTextColor(a) {
            this.go = a;
            this.g("AxisAnnotationTextColor");
        }
        get axisAnnotationBackground() {
            return this.gl;
        }
        set axisAnnotationBackground(a) {
            this.gl = a;
            this.g("AxisAnnotationBackground");
        }
        get axisAnnotationBackgroundCornerRadius() {
            return this.f7;
        }
        set axisAnnotationBackgroundCornerRadius(a) {
            this.f7 = a;
            this.g("AxisAnnotationBackgroundCornerRadius");
        }
        get axisAnnotationInterpolatedValuePrecision() {
            return this.gj;
        }
        set axisAnnotationInterpolatedValuePrecision(a) {
            this.gj = a;
            this.g("AxisAnnotationInterpolatedValuePrecision");
        }
        get axisAnnotationOutline() {
            return this.gn;
        }
        set axisAnnotationOutline(a) {
            this.gn = a;
            this.g("AxisAnnotationOutline");
        }
        get axisAnnotationPaddingLeft() {
            return this.f9;
        }
        set axisAnnotationPaddingLeft(a) {
            this.f9 = a;
            this.g("AxisAnnotationPaddingLeft");
        }
        get axisAnnotationPaddingTop() {
            return this.gb;
        }
        set axisAnnotationPaddingTop(a) {
            this.gb = a;
            this.g("AxisAnnotationPaddingTop");
        }
        get axisAnnotationPaddingRight() {
            return this.ga;
        }
        set axisAnnotationPaddingRight(a) {
            this.ga = a;
            this.g("AxisAnnotationPaddingRight");
        }
        get axisAnnotationPaddingBottom() {
            return this.f8;
        }
        set axisAnnotationPaddingBottom(a) {
            this.f8 = a;
            this.g("AxisAnnotationPaddingBottom");
        }
        get axisAnnotationStrokeThickness() {
            return this.gc;
        }
        set axisAnnotationStrokeThickness(a) {
            this.gc = a;
            this.g("AxisAnnotationStrokeThickness");
        }
        get axisAnnotationFormatLabelRef() {
            return this.gm;
        }
        set axisAnnotationFormatLabelRef(a) {
            this.gm = a;
            this.g("AxisAnnotationFormatLabelRef");
        }
    }
    FinalValueLayerDescription.$t = /*@__PURE__*/ markType(FinalValueLayerDescription, 'FinalValueLayerDescription', AnnotationLayerDescription.$);
    return FinalValueLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinalValueLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinalValueLayerDescriptionMetadata extends Base {
        static b(a) {
            if (FinalValueLayerDescriptionMetadata.a == null) {
                FinalValueLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinalValueLayerDescriptionMetadata.c(FinalValueLayerDescriptionMetadata.a);
            }
            if (a.k(FinalValueLayerDescriptionMetadata.a)) {
                return;
            }
            a.ac(FinalValueLayerDescriptionMetadata.a);
        }
        static c(a) {
            AnnotationLayerDescriptionMetadata.c(a);
            a.item("TargetSeriesName", "String");
            a.item("TargetSeriesRef", "(w:TargetSeries,wf:TargetSeries)DataRef::object");
            a.item("FinalValueSelectionMode", "ExportedType:string:FinalValueSelectionMode");
            a.item("FinalValueSelectionMode@names", "Auto;FinalVisible;FinalVisibleInterpolated;Final");
            a.item("AxisAnnotationTextColor", "Brush");
            a.item("AxisAnnotationBackground", "Brush");
            a.item("AxisAnnotationBackgroundCornerRadius", "Number:double");
            a.item("AxisAnnotationInterpolatedValuePrecision", "Number:int");
            a.item("AxisAnnotationOutline", "Brush");
            a.item("AxisAnnotationPaddingLeft", "Number:double");
            a.item("AxisAnnotationPaddingTop", "Number:double");
            a.item("AxisAnnotationPaddingRight", "Number:double");
            a.item("AxisAnnotationPaddingBottom", "Number:double");
            a.item("AxisAnnotationStrokeThickness", "Number:double");
            a.item("AxisAnnotationFormatLabelRef", "EventRef::axisAnnotationFormatLabel");
        }
        static d(a) {
            FinalValueLayerDescriptionMetadata.b(a);
            a.ae("FinalValueLayer", () => new FinalValueLayerDescription());
            a.ad("FinalValueLayer", FinalValueLayerDescriptionMetadata.a);
        }
    }
    FinalValueLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(FinalValueLayerDescriptionMetadata, 'FinalValueLayerDescriptionMetadata');
    FinalValueLayerDescriptionMetadata.a = null;
    return FinalValueLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinalValueLayerDescriptionModule = /*@__PURE__*/ (() => {
    class FinalValueLayerDescriptionModule extends Base {
        static register(a) {
            FinalValueLayerDescriptionMetadata.d(a);
        }
    }
    FinalValueLayerDescriptionModule.$t = /*@__PURE__*/ markType(FinalValueLayerDescriptionModule, 'FinalValueLayerDescriptionModule');
    return FinalValueLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumberAbbreviatorDescriptionModule = /*@__PURE__*/ (() => {
    class NumberAbbreviatorDescriptionModule extends Base {
        static register(a) {
        }
    }
    NumberAbbreviatorDescriptionModule.$t = /*@__PURE__*/ markType(NumberAbbreviatorDescriptionModule, 'NumberAbbreviatorDescriptionModule');
    return NumberAbbreviatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartDefaultTooltipsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataChartDefaultTooltipsDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    DataChartDefaultTooltipsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataChartDefaultTooltipsDescriptionMetadata, 'DataChartDefaultTooltipsDescriptionMetadata');
    return DataChartDefaultTooltipsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartInteractivityDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartInteractivityDescriptionModule extends Base {
        static register(a) {
            DataChartDefaultTooltipsDescriptionMetadata.register(a);
            DVInteractivityDescriptionModule.register(a);
        }
    }
    DataChartInteractivityDescriptionModule.$t = /*@__PURE__*/ markType(DataChartInteractivityDescriptionModule, 'DataChartInteractivityDescriptionModule');
    return DataChartInteractivityDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartCategoryTrendLineDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartCategoryTrendLineDescriptionModule extends Base {
        static register(a) {
        }
    }
    DataChartCategoryTrendLineDescriptionModule.$t = /*@__PURE__*/ markType(DataChartCategoryTrendLineDescriptionModule, 'DataChartCategoryTrendLineDescriptionModule');
    return DataChartCategoryTrendLineDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueLayerDescription = /*@__PURE__*/ (() => {
    class ValueLayerDescription extends AnnotationLayerDescription {
        get_type() {
            return "ValueLayer";
        }
        constructor() {
            super();
            this.ha = null;
            this.g5 = null;
            this.hb = null;
            this.g8 = null;
            this.g9 = null;
            this.g6 = null;
            this.g7 = null;
            this.f9 = false;
            this.f7 = false;
            this.hd = null;
            this.hh = null;
            this.hf = null;
            this.hc = null;
            this.gd = 0;
            this.g1 = 0;
            this.he = null;
            this.gf = 0;
            this.gh = 0;
            this.gg = 0;
            this.ge = 0;
            this.gl = 0;
            this.gn = 0;
            this.gm = 0;
            this.gk = 0;
            this.gi = 0;
            this.hj = null;
            this.hg = null;
            this.gj = 0;
            this.g2 = 0;
            this.hi = null;
            this.go = 0;
            this.f8 = false;
        }
        get valueMode() {
            return this.ha;
        }
        set valueMode(a) {
            this.ha = a;
            this.g("ValueMode");
        }
        get horizontalLineStroke() {
            return this.g5;
        }
        set horizontalLineStroke(a) {
            this.g5 = a;
            this.g("HorizontalLineStroke");
        }
        get verticalLineStroke() {
            return this.hb;
        }
        set verticalLineStroke(a) {
            this.hb = a;
            this.g("VerticalLineStroke");
        }
        get targetSeriesName() {
            return this.g8;
        }
        set targetSeriesName(a) {
            this.g8 = a;
            this.g("TargetSeriesName");
        }
        get targetSeriesRef() {
            return this.g9;
        }
        set targetSeriesRef(a) {
            this.g9 = a;
            this.g("TargetSeriesRef");
        }
        get targetAxisName() {
            return this.g6;
        }
        set targetAxisName(a) {
            this.g6 = a;
            this.g("TargetAxisName");
        }
        get targetAxisRef() {
            return this.g7;
        }
        set targetAxisRef(a) {
            this.g7 = a;
            this.g("TargetAxisRef");
        }
        get useInterpolation() {
            return this.f9;
        }
        set useInterpolation(a) {
            this.f9 = a;
            this.g("UseInterpolation");
        }
        get isAxisAnnotationEnabled() {
            return this.f7;
        }
        set isAxisAnnotationEnabled(a) {
            this.f7 = a;
            this.g("IsAxisAnnotationEnabled");
        }
        get xAxisAnnotationFormatLabelRef() {
            return this.hd;
        }
        set xAxisAnnotationFormatLabelRef(a) {
            this.hd = a;
            this.g("XAxisAnnotationFormatLabelRef");
        }
        get yAxisAnnotationFormatLabelRef() {
            return this.hh;
        }
        set yAxisAnnotationFormatLabelRef(a) {
            this.hh = a;
            this.g("YAxisAnnotationFormatLabelRef");
        }
        get xAxisAnnotationTextColor() {
            return this.hf;
        }
        set xAxisAnnotationTextColor(a) {
            this.hf = a;
            this.g("XAxisAnnotationTextColor");
        }
        get xAxisAnnotationBackground() {
            return this.hc;
        }
        set xAxisAnnotationBackground(a) {
            this.hc = a;
            this.g("XAxisAnnotationBackground");
        }
        get xAxisAnnotationBackgroundCornerRadius() {
            return this.gd;
        }
        set xAxisAnnotationBackgroundCornerRadius(a) {
            this.gd = a;
            this.g("XAxisAnnotationBackgroundCornerRadius");
        }
        get xAxisAnnotationInterpolatedValuePrecision() {
            return this.g1;
        }
        set xAxisAnnotationInterpolatedValuePrecision(a) {
            this.g1 = a;
            this.g("XAxisAnnotationInterpolatedValuePrecision");
        }
        get xAxisAnnotationOutline() {
            return this.he;
        }
        set xAxisAnnotationOutline(a) {
            this.he = a;
            this.g("XAxisAnnotationOutline");
        }
        get xAxisAnnotationPaddingLeft() {
            return this.gf;
        }
        set xAxisAnnotationPaddingLeft(a) {
            this.gf = a;
            this.g("XAxisAnnotationPaddingLeft");
        }
        get xAxisAnnotationPaddingTop() {
            return this.gh;
        }
        set xAxisAnnotationPaddingTop(a) {
            this.gh = a;
            this.g("XAxisAnnotationPaddingTop");
        }
        get xAxisAnnotationPaddingRight() {
            return this.gg;
        }
        set xAxisAnnotationPaddingRight(a) {
            this.gg = a;
            this.g("XAxisAnnotationPaddingRight");
        }
        get xAxisAnnotationPaddingBottom() {
            return this.ge;
        }
        set xAxisAnnotationPaddingBottom(a) {
            this.ge = a;
            this.g("XAxisAnnotationPaddingBottom");
        }
        get yAxisAnnotationPaddingLeft() {
            return this.gl;
        }
        set yAxisAnnotationPaddingLeft(a) {
            this.gl = a;
            this.g("YAxisAnnotationPaddingLeft");
        }
        get yAxisAnnotationPaddingTop() {
            return this.gn;
        }
        set yAxisAnnotationPaddingTop(a) {
            this.gn = a;
            this.g("YAxisAnnotationPaddingTop");
        }
        get yAxisAnnotationPaddingRight() {
            return this.gm;
        }
        set yAxisAnnotationPaddingRight(a) {
            this.gm = a;
            this.g("YAxisAnnotationPaddingRight");
        }
        get yAxisAnnotationPaddingBottom() {
            return this.gk;
        }
        set yAxisAnnotationPaddingBottom(a) {
            this.gk = a;
            this.g("YAxisAnnotationPaddingBottom");
        }
        get xAxisAnnotationStrokeThickness() {
            return this.gi;
        }
        set xAxisAnnotationStrokeThickness(a) {
            this.gi = a;
            this.g("XAxisAnnotationStrokeThickness");
        }
        get yAxisAnnotationTextColor() {
            return this.hj;
        }
        set yAxisAnnotationTextColor(a) {
            this.hj = a;
            this.g("YAxisAnnotationTextColor");
        }
        get yAxisAnnotationBackground() {
            return this.hg;
        }
        set yAxisAnnotationBackground(a) {
            this.hg = a;
            this.g("YAxisAnnotationBackground");
        }
        get yAxisAnnotationBackgroundCornerRadius() {
            return this.gj;
        }
        set yAxisAnnotationBackgroundCornerRadius(a) {
            this.gj = a;
            this.g("YAxisAnnotationBackgroundCornerRadius");
        }
        get yAxisAnnotationInterpolatedValuePrecision() {
            return this.g2;
        }
        set yAxisAnnotationInterpolatedValuePrecision(a) {
            this.g2 = a;
            this.g("YAxisAnnotationInterpolatedValuePrecision");
        }
        get yAxisAnnotationOutline() {
            return this.hi;
        }
        set yAxisAnnotationOutline(a) {
            this.hi = a;
            this.g("YAxisAnnotationOutline");
        }
        get yAxisAnnotationStrokeThickness() {
            return this.go;
        }
        set yAxisAnnotationStrokeThickness(a) {
            this.go = a;
            this.g("YAxisAnnotationStrokeThickness");
        }
        get skipUnknownValues() {
            return this.f8;
        }
        set skipUnknownValues(a) {
            this.f8 = a;
            this.g("SkipUnknownValues");
        }
    }
    ValueLayerDescription.$t = /*@__PURE__*/ markType(ValueLayerDescription, 'ValueLayerDescription', AnnotationLayerDescription.$);
    return ValueLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class ValueLayerDescriptionMetadata extends Base {
        static b(a) {
            if (ValueLayerDescriptionMetadata.a == null) {
                ValueLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ValueLayerDescriptionMetadata.c(ValueLayerDescriptionMetadata.a);
            }
            if (a.k(ValueLayerDescriptionMetadata.a)) {
                return;
            }
            a.ac(ValueLayerDescriptionMetadata.a);
        }
        static c(a) {
            AnnotationLayerDescriptionMetadata.c(a);
            a.item("ValueMode", "ExportedType:string:ValueLayerValueMode");
            a.item("ValueMode@names", "Auto;Minimum;Maximum;Average;GlobalMinimum;GlobalMaximum;GlobalAverage");
            a.item("HorizontalLineStroke", "Brush");
            a.item("VerticalLineStroke", "Brush");
            a.item("TargetSeriesName", "String");
            a.item("TargetSeriesRef", "(w:TargetSeries,wf:TargetSeries)DataRef::object");
            a.item("TargetAxisName", "String");
            a.item("TargetAxisRef", "(w:TargetAxis,wf:TargetAxis)DataRef::object");
            a.item("UseInterpolation", "Boolean");
            a.item("IsAxisAnnotationEnabled", "Boolean");
            a.item("XAxisAnnotationFormatLabelRef", "(w:XAxisAnnotationFormatLabel,wf:XAxisAnnotationFormatLabel)MethodRef");
            a.item("YAxisAnnotationFormatLabelRef", "(w:YAxisAnnotationFormatLabel,wf:YAxisAnnotationFormatLabel)MethodRef");
            a.item("XAxisAnnotationTextColor", "Brush");
            a.item("XAxisAnnotationBackground", "Brush");
            a.item("XAxisAnnotationBackgroundCornerRadius", "Number:double");
            a.item("XAxisAnnotationInterpolatedValuePrecision", "Number:int");
            a.item("XAxisAnnotationOutline", "Brush");
            a.item("XAxisAnnotationPaddingLeft", "Number:double");
            a.item("XAxisAnnotationPaddingTop", "Number:double");
            a.item("XAxisAnnotationPaddingRight", "Number:double");
            a.item("XAxisAnnotationPaddingBottom", "Number:double");
            a.item("YAxisAnnotationPaddingLeft", "Number:double");
            a.item("YAxisAnnotationPaddingTop", "Number:double");
            a.item("YAxisAnnotationPaddingRight", "Number:double");
            a.item("YAxisAnnotationPaddingBottom", "Number:double");
            a.item("XAxisAnnotationStrokeThickness", "Number:double");
            a.item("YAxisAnnotationTextColor", "Brush");
            a.item("YAxisAnnotationBackground", "Brush");
            a.item("YAxisAnnotationBackgroundCornerRadius", "Number:double");
            a.item("YAxisAnnotationInterpolatedValuePrecision", "Number:int");
            a.item("YAxisAnnotationOutline", "Brush");
            a.item("YAxisAnnotationStrokeThickness", "Number:double");
            a.item("SkipUnknownValues", "Boolean");
        }
        static d(a) {
            ValueLayerDescriptionMetadata.b(a);
            a.ae("ValueLayer", () => new ValueLayerDescription());
            a.ad("ValueLayer", ValueLayerDescriptionMetadata.a);
        }
    }
    ValueLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(ValueLayerDescriptionMetadata, 'ValueLayerDescriptionMetadata');
    ValueLayerDescriptionMetadata.a = null;
    return ValueLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueLayerDescriptionModule = /*@__PURE__*/ (() => {
    class ValueLayerDescriptionModule extends Base {
        static register(a) {
            ValueLayerDescriptionMetadata.d(a);
        }
    }
    ValueLayerDescriptionModule.$t = /*@__PURE__*/ markType(ValueLayerDescriptionModule, 'ValueLayerDescriptionModule');
    return ValueLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartAnnotationDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartAnnotationDescriptionModule extends Base {
        static register(a) {
            CrosshairLayerDescriptionModule.register(a);
            CategoryToolTipLayerDescriptionModule.register(a);
            ItemToolTipLayerDescriptionModule.register(a);
            CategoryItemHighlightLayerDescriptionModule.register(a);
            CategoryHighlightLayerDescriptionModule.register(a);
            FinalValueLayerDescriptionModule.register(a);
            CalloutLayerDescriptionModule.register(a);
            DataToolTipLayerDescriptionModule.register(a);
            ValueLayerDescriptionModule.register(a);
        }
    }
    DataChartAnnotationDescriptionModule.$t = /*@__PURE__*/ markType(DataChartAnnotationDescriptionModule, 'DataChartAnnotationDescriptionModule');
    return DataChartAnnotationDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryChartDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryChartDescriptionModule extends Base {
        static register(a) {
            CategoryChartCoreDescriptionModule.register(a);
            LineSeriesDescriptionModule.register(a);
            AreaSeriesDescriptionModule.register(a);
            ColumnSeriesDescriptionModule.register(a);
            SplineSeriesDescriptionModule.register(a);
            SplineAreaSeriesDescriptionModule.register(a);
            StepLineSeriesDescriptionModule.register(a);
            StepAreaSeriesDescriptionModule.register(a);
            PointSeriesDescriptionModule.register(a);
            WaterfallSeriesDescriptionModule.register(a);
            CrosshairLayerDescriptionModule.register(a);
            CalloutLayerDescriptionModule.register(a);
            ItemToolTipLayerDescriptionModule.register(a);
            CategoryToolTipLayerDescriptionModule.register(a);
            CategoryHighlightLayerDescriptionModule.register(a);
            CategoryItemHighlightLayerDescriptionModule.register(a);
            DataToolTipLayerDescriptionModule.register(a);
            FinalValueLayerDescriptionModule.register(a);
            NumberAbbreviatorDescriptionModule.register(a);
            DataChartInteractivityDescriptionModule.register(a);
            DataChartCategoryTrendLineDescriptionModule.register(a);
            DataChartAnnotationDescriptionModule.register(a);
        }
    }
    CategoryChartDescriptionModule.$t = /*@__PURE__*/ markType(CategoryChartDescriptionModule, 'CategoryChartDescriptionModule');
    return CategoryChartDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartToolbarIconsDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartToolbarIconsDescriptionModule extends Base {
        static register(a) {
        }
    }
    DataChartToolbarIconsDescriptionModule.$t = /*@__PURE__*/ markType(DataChartToolbarIconsDescriptionModule, 'DataChartToolbarIconsDescriptionModule');
    return DataChartToolbarIconsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryChartToolbarDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryChartToolbarDescriptionModule extends Base {
        static register(a) {
            DataChartToolbarIconsDescriptionModule.register(a);
        }
    }
    CategoryChartToolbarDescriptionModule.$t = /*@__PURE__*/ markType(CategoryChartToolbarDescriptionModule, 'CategoryChartToolbarDescriptionModule');
    return CategoryChartToolbarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellKeyDescription = /*@__PURE__*/ (() => {
    class CellKeyDescription extends Description {
        get_type() {
            return "CellKey";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.k = null;
            this.n = null;
        }
        get primaryKey() {
            return this.h;
        }
        set primaryKey(a) {
            this.h = a;
            this.g("PrimaryKey");
        }
        get rowItem() {
            return this.k;
        }
        set rowItem(a) {
            this.k = a;
            this.g("RowItem");
        }
        get columnUniqueKey() {
            return this.n;
        }
        set columnUniqueKey(a) {
            this.n = a;
            this.g("ColumnUniqueKey");
        }
    }
    CellKeyDescription.$t = /*@__PURE__*/ markType(CellKeyDescription, 'CellKeyDescription', Description.$);
    CellKeyDescription.__marshalByValue = true;
    CellKeyDescription.__marshalByValueAlias = "CellKey";
    return CellKeyDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrimaryKeyValueDescription = /*@__PURE__*/ (() => {
    class PrimaryKeyValueDescription extends Description {
        get_type() {
            return "PrimaryKeyValue";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.i = null;
        }
        get key() {
            return this.h;
        }
        set key(a) {
            this.h = a;
            this.g("Key");
        }
        get value() {
            return this.i;
        }
        set value(a) {
            this.i = a;
            this.g("Value");
        }
    }
    PrimaryKeyValueDescription.$t = /*@__PURE__*/ markType(PrimaryKeyValueDescription, 'PrimaryKeyValueDescription', Description.$);
    PrimaryKeyValueDescription.__marshalByValue = true;
    PrimaryKeyValueDescription.__marshalByValueAlias = "PrimaryKeyValue";
    return PrimaryKeyValueDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrimaryKeyValueDescriptionMetadata = /*@__PURE__*/ (() => {
    class PrimaryKeyValueDescriptionMetadata extends Base {
        static b(a) {
            if (PrimaryKeyValueDescriptionMetadata.a == null) {
                PrimaryKeyValueDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PrimaryKeyValueDescriptionMetadata.c(PrimaryKeyValueDescriptionMetadata.a);
            }
            if (a.k(PrimaryKeyValueDescriptionMetadata.a)) {
                return;
            }
            a.ac(PrimaryKeyValueDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("Key", "Array:string");
            a.item("Value", "Collection:object:Array:Object");
        }
        static d(a) {
            PrimaryKeyValueDescriptionMetadata.b(a);
            a.ae("PrimaryKeyValue", () => new PrimaryKeyValueDescription());
            a.ad("PrimaryKeyValue", PrimaryKeyValueDescriptionMetadata.a);
        }
    }
    PrimaryKeyValueDescriptionMetadata.$t = /*@__PURE__*/ markType(PrimaryKeyValueDescriptionMetadata, 'PrimaryKeyValueDescriptionMetadata');
    PrimaryKeyValueDescriptionMetadata.a = null;
    return PrimaryKeyValueDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellKeyDescriptionMetadata = /*@__PURE__*/ (() => {
    class CellKeyDescriptionMetadata extends Base {
        static b(a) {
            if (CellKeyDescriptionMetadata.a == null) {
                CellKeyDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CellKeyDescriptionMetadata.c(CellKeyDescriptionMetadata.a);
            }
            if (a.k(CellKeyDescriptionMetadata.a)) {
                return;
            }
            a.ac(CellKeyDescriptionMetadata.a);
            PrimaryKeyValueDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("PrimaryKey", "ExportedType:PrimaryKeyValue");
            a.item("RowItem", "Unknown");
            a.item("ColumnUniqueKey", "String");
        }
        static d(a) {
            CellKeyDescriptionMetadata.b(a);
            a.ae("CellKey", () => new CellKeyDescription());
            a.ad("CellKey", CellKeyDescriptionMetadata.a);
        }
    }
    CellKeyDescriptionMetadata.$t = /*@__PURE__*/ markType(CellKeyDescriptionMetadata, 'CellKeyDescriptionMetadata');
    CellKeyDescriptionMetadata.a = null;
    return CellKeyDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellKeyDescriptionModule = /*@__PURE__*/ (() => {
    class CellKeyDescriptionModule extends Base {
        static register(a) {
            CellKeyDescriptionMetadata.d(a);
        }
    }
    CellKeyDescriptionModule.$t = /*@__PURE__*/ markType(CellKeyDescriptionModule, 'CellKeyDescriptionModule');
    return CellKeyDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellRangeDescription = /*@__PURE__*/ (() => {
    class CellRangeDescription extends Description {
        get_type() {
            return "CellRange";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = 0;
            this.i = 0;
            this.l = 0;
            this.j = 0;
        }
        get startColumn() {
            return this.k;
        }
        set startColumn(a) {
            this.k = a;
            this.g("StartColumn");
        }
        get endColumn() {
            return this.i;
        }
        set endColumn(a) {
            this.i = a;
            this.g("EndColumn");
        }
        get startRow() {
            return this.l;
        }
        set startRow(a) {
            this.l = a;
            this.g("StartRow");
        }
        get endRow() {
            return this.j;
        }
        set endRow(a) {
            this.j = a;
            this.g("EndRow");
        }
    }
    CellRangeDescription.$t = /*@__PURE__*/ markType(CellRangeDescription, 'CellRangeDescription', Description.$);
    CellRangeDescription.__marshalByValue = true;
    CellRangeDescription.__marshalByValueAlias = "CellRange";
    return CellRangeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellRangeDescriptionMetadata = /*@__PURE__*/ (() => {
    class CellRangeDescriptionMetadata extends Base {
        static b(a) {
            if (CellRangeDescriptionMetadata.a == null) {
                CellRangeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CellRangeDescriptionMetadata.c(CellRangeDescriptionMetadata.a);
            }
            if (a.k(CellRangeDescriptionMetadata.a)) {
                return;
            }
            a.ac(CellRangeDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("StartColumn", "Number:int");
            a.item("EndColumn", "Number:int");
            a.item("StartRow", "Number:int");
            a.item("EndRow", "Number:int");
        }
        static d(a) {
            CellRangeDescriptionMetadata.b(a);
            a.ae("CellRange", () => new CellRangeDescription());
            a.ad("CellRange", CellRangeDescriptionMetadata.a);
        }
    }
    CellRangeDescriptionMetadata.$t = /*@__PURE__*/ markType(CellRangeDescriptionMetadata, 'CellRangeDescriptionMetadata');
    CellRangeDescriptionMetadata.a = null;
    return CellRangeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellRangeDescriptionModule = /*@__PURE__*/ (() => {
    class CellRangeDescriptionModule extends Base {
        static register(a) {
            CellRangeDescriptionMetadata.d(a);
        }
    }
    CellRangeDescriptionModule.$t = /*@__PURE__*/ markType(CellRangeDescriptionModule, 'CellRangeDescriptionModule');
    return CellRangeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartSortDescriptionDescription = /*@__PURE__*/ (() => {
    class ChartSortDescriptionDescription extends Description {
        get_type() {
            return "ChartSortDescription";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.k = null;
        }
        get field() {
            return this.j;
        }
        set field(a) {
            this.j = a;
            this.g("Field");
        }
        get sortDirection() {
            return this.k;
        }
        set sortDirection(a) {
            this.k = a;
            this.g("SortDirection");
        }
    }
    ChartSortDescriptionDescription.$t = /*@__PURE__*/ markType(ChartSortDescriptionDescription, 'ChartSortDescriptionDescription', Description.$);
    ChartSortDescriptionDescription.__marshalByValue = true;
    ChartSortDescriptionDescription.__marshalByValueAlias = "ChartSortDescription";
    return ChartSortDescriptionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartGroupDescriptionDescription = /*@__PURE__*/ (() => {
    class ChartGroupDescriptionDescription extends ChartSortDescriptionDescription {
        get_type() {
            return "ChartGroupDescription";
        }
        constructor() {
            super();
        }
    }
    ChartGroupDescriptionDescription.$t = /*@__PURE__*/ markType(ChartGroupDescriptionDescription, 'ChartGroupDescriptionDescription', ChartSortDescriptionDescription.$);
    ChartGroupDescriptionDescription.__marshalByValue1 = true;
    ChartGroupDescriptionDescription.__marshalByValueAlias1 = "ChartGroupDescription";
    return ChartGroupDescriptionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartSortDescriptionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ChartSortDescriptionDescriptionMetadata extends Base {
        static b(a) {
            if (ChartSortDescriptionDescriptionMetadata.a == null) {
                ChartSortDescriptionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ChartSortDescriptionDescriptionMetadata.c(ChartSortDescriptionDescriptionMetadata.a);
            }
            if (a.k(ChartSortDescriptionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ChartSortDescriptionDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("Field", "String");
            a.item("SortDirection", "ExportedType:string:ListSortDirection");
            a.item("SortDirection@names", "Ascending;Descending");
        }
        static d(a) {
            ChartSortDescriptionDescriptionMetadata.b(a);
            a.ae("ChartSortDescription", () => new ChartSortDescriptionDescription());
            a.ad("ChartSortDescription", ChartSortDescriptionDescriptionMetadata.a);
        }
    }
    ChartSortDescriptionDescriptionMetadata.$t = /*@__PURE__*/ markType(ChartSortDescriptionDescriptionMetadata, 'ChartSortDescriptionDescriptionMetadata');
    ChartSortDescriptionDescriptionMetadata.a = null;
    return ChartSortDescriptionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartGroupDescriptionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ChartGroupDescriptionDescriptionMetadata extends Base {
        static b(a) {
            if (ChartGroupDescriptionDescriptionMetadata.a == null) {
                ChartGroupDescriptionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ChartGroupDescriptionDescriptionMetadata.c(ChartGroupDescriptionDescriptionMetadata.a);
            }
            if (a.k(ChartGroupDescriptionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ChartGroupDescriptionDescriptionMetadata.a);
        }
        static c(a) {
            ChartSortDescriptionDescriptionMetadata.c(a);
            a.item("__marshalByValue", "Boolean");
        }
        static d(a) {
            ChartGroupDescriptionDescriptionMetadata.b(a);
            a.ae("ChartGroupDescription", () => new ChartGroupDescriptionDescription());
            a.ad("ChartGroupDescription", ChartGroupDescriptionDescriptionMetadata.a);
        }
    }
    ChartGroupDescriptionDescriptionMetadata.$t = /*@__PURE__*/ markType(ChartGroupDescriptionDescriptionMetadata, 'ChartGroupDescriptionDescriptionMetadata');
    ChartGroupDescriptionDescriptionMetadata.a = null;
    return ChartGroupDescriptionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartSortDescriptionDescriptionModule = /*@__PURE__*/ (() => {
    class ChartSortDescriptionDescriptionModule extends Base {
        static register(a) {
            ChartSortDescriptionDescriptionMetadata.d(a);
        }
    }
    ChartSortDescriptionDescriptionModule.$t = /*@__PURE__*/ markType(ChartSortDescriptionDescriptionModule, 'ChartSortDescriptionDescriptionModule');
    return ChartSortDescriptionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartGroupDescriptionDescriptionModule = /*@__PURE__*/ (() => {
    class ChartGroupDescriptionDescriptionModule extends Base {
        static register(a) {
            ChartSortDescriptionDescriptionModule.register(a);
            ChartGroupDescriptionDescriptionMetadata.d(a);
        }
    }
    ChartGroupDescriptionDescriptionModule.$t = /*@__PURE__*/ markType(ChartGroupDescriptionDescriptionModule, 'ChartGroupDescriptionDescriptionModule');
    return ChartGroupDescriptionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartSelectionDescription = /*@__PURE__*/ (() => {
    class ChartSelectionDescription extends Description {
        get_type() {
            return "ChartSelection";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = null;
            this.n = null;
            this.h = null;
        }
        get item() {
            return this.k;
        }
        set item(a) {
            this.k = a;
            this.g("Item");
        }
        get seriesRef() {
            return this.n;
        }
        set seriesRef(a) {
            this.n = a;
            this.g("SeriesRef");
        }
        get matcher() {
            return this.h;
        }
        set matcher(a) {
            this.h = a;
            this.g("Matcher");
        }
    }
    ChartSelectionDescription.$t = /*@__PURE__*/ markType(ChartSelectionDescription, 'ChartSelectionDescription', Description.$);
    ChartSelectionDescription.__marshalByValue = true;
    ChartSelectionDescription.__marshalByValueAlias = "ChartSelection";
    return ChartSelectionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesMatcherDescription = /*@__PURE__*/ (() => {
    class SeriesMatcherDescription extends Description {
        get_type() {
            return "SeriesMatcher";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.o = null;
            this.i = 0;
            this.m = null;
            this.l = null;
        }
        get name() {
            return this.n;
        }
        set name(a) {
            this.n = a;
            this.g("Name");
        }
        get title() {
            return this.o;
        }
        set title(a) {
            this.o = a;
            this.g("Title");
        }
        get index() {
            return this.i;
        }
        set index(a) {
            this.i = a;
            this.g("Index");
        }
        get memberPathType() {
            return this.m;
        }
        set memberPathType(a) {
            this.m = a;
            this.g("MemberPathType");
        }
        get memberPath() {
            return this.l;
        }
        set memberPath(a) {
            this.l = a;
            this.g("MemberPath");
        }
    }
    SeriesMatcherDescription.$t = /*@__PURE__*/ markType(SeriesMatcherDescription, 'SeriesMatcherDescription', Description.$);
    SeriesMatcherDescription.__marshalByValue = true;
    SeriesMatcherDescription.__marshalByValueAlias = "SeriesMatcher";
    return SeriesMatcherDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesMatcherDescriptionMetadata = /*@__PURE__*/ (() => {
    class SeriesMatcherDescriptionMetadata extends Base {
        static b(a) {
            if (SeriesMatcherDescriptionMetadata.a == null) {
                SeriesMatcherDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SeriesMatcherDescriptionMetadata.c(SeriesMatcherDescriptionMetadata.a);
            }
            if (a.k(SeriesMatcherDescriptionMetadata.a)) {
                return;
            }
            a.ac(SeriesMatcherDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("Name", "String");
            a.item("Title", "String");
            a.item("Index", "Number:int");
            a.item("MemberPathType", "String");
            a.item("MemberPath", "String");
        }
        static d(a) {
            SeriesMatcherDescriptionMetadata.b(a);
            a.ae("SeriesMatcher", () => new SeriesMatcherDescription());
            a.ad("SeriesMatcher", SeriesMatcherDescriptionMetadata.a);
        }
    }
    SeriesMatcherDescriptionMetadata.$t = /*@__PURE__*/ markType(SeriesMatcherDescriptionMetadata, 'SeriesMatcherDescriptionMetadata');
    SeriesMatcherDescriptionMetadata.a = null;
    return SeriesMatcherDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartSelectionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ChartSelectionDescriptionMetadata extends Base {
        static b(a) {
            if (ChartSelectionDescriptionMetadata.a == null) {
                ChartSelectionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ChartSelectionDescriptionMetadata.c(ChartSelectionDescriptionMetadata.a);
            }
            if (a.k(ChartSelectionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ChartSelectionDescriptionMetadata.a);
            SeriesMatcherDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("Item", "Unknown");
            a.item("SeriesRef", "(w:Series,wf:Series)DataRef::object");
            a.item("Matcher", "ExportedType:SeriesMatcher");
        }
        static d(a) {
            ChartSelectionDescriptionMetadata.b(a);
            a.ae("ChartSelection", () => new ChartSelectionDescription());
            a.ad("ChartSelection", ChartSelectionDescriptionMetadata.a);
        }
    }
    ChartSelectionDescriptionMetadata.$t = /*@__PURE__*/ markType(ChartSelectionDescriptionMetadata, 'ChartSelectionDescriptionMetadata');
    ChartSelectionDescriptionMetadata.a = null;
    return ChartSelectionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartSelectionDescriptionModule = /*@__PURE__*/ (() => {
    class ChartSelectionDescriptionModule extends Base {
        static register(a) {
            ChartSelectionDescriptionMetadata.d(a);
        }
    }
    ChartSelectionDescriptionModule.$t = /*@__PURE__*/ markType(ChartSelectionDescriptionModule, 'ChartSelectionDescriptionModule');
    return ChartSelectionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartSummaryDescriptionDescription = /*@__PURE__*/ (() => {
    class ChartSummaryDescriptionDescription extends Description {
        get_type() {
            return "ChartSummaryDescription";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.m = null;
            this.j = null;
            this.k = null;
            this.n = null;
        }
        get field() {
            return this.l;
        }
        set field(a) {
            this.l = a;
            this.g("Field");
        }
        get operand() {
            return this.m;
        }
        set operand(a) {
            this.m = a;
            this.g("Operand");
        }
        get alias() {
            return this.j;
        }
        set alias(a) {
            this.j = a;
            this.g("Alias");
        }
        get calculatorDisplayName() {
            return this.k;
        }
        set calculatorDisplayName(a) {
            this.k = a;
            this.g("CalculatorDisplayName");
        }
        get provideCalculatorRef() {
            return this.n;
        }
        set provideCalculatorRef(a) {
            this.n = a;
            this.g("ProvideCalculatorRef");
        }
    }
    ChartSummaryDescriptionDescription.$t = /*@__PURE__*/ markType(ChartSummaryDescriptionDescription, 'ChartSummaryDescriptionDescription', Description.$);
    ChartSummaryDescriptionDescription.__marshalByValue = true;
    ChartSummaryDescriptionDescription.__marshalByValueAlias = "ChartSummaryDescription";
    return ChartSummaryDescriptionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ProvideCalculatorEventArgsDescription = /*@__PURE__*/ (() => {
    class ProvideCalculatorEventArgsDescription extends Description {
        get_type() {
            return "ProvideCalculatorEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ProvideCalculatorEventArgsDescription.$t = /*@__PURE__*/ markType(ProvideCalculatorEventArgsDescription, 'ProvideCalculatorEventArgsDescription', Description.$);
    return ProvideCalculatorEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ProvideCalculatorEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ProvideCalculatorEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ProvideCalculatorEventArgsDescriptionMetadata.a == null) {
                ProvideCalculatorEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ProvideCalculatorEventArgsDescriptionMetadata.c(ProvideCalculatorEventArgsDescriptionMetadata.a);
            }
            if (a.k(ProvideCalculatorEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ProvideCalculatorEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ProvideCalculatorEventArgsDescriptionMetadata.b(a);
            a.ae("ProvideCalculatorEventArgs", () => new ProvideCalculatorEventArgsDescription());
            a.ad("ProvideCalculatorEventArgs", ProvideCalculatorEventArgsDescriptionMetadata.a);
        }
    }
    ProvideCalculatorEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ProvideCalculatorEventArgsDescriptionMetadata, 'ProvideCalculatorEventArgsDescriptionMetadata');
    ProvideCalculatorEventArgsDescriptionMetadata.a = null;
    return ProvideCalculatorEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartSummaryDescriptionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ChartSummaryDescriptionDescriptionMetadata extends Base {
        static b(a) {
            if (ChartSummaryDescriptionDescriptionMetadata.a == null) {
                ChartSummaryDescriptionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ChartSummaryDescriptionDescriptionMetadata.c(ChartSummaryDescriptionDescriptionMetadata.a);
            }
            if (a.k(ChartSummaryDescriptionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ChartSummaryDescriptionDescriptionMetadata.a);
            ProvideCalculatorEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("Field", "String");
            a.item("Operand", "ExportedType:string:DataSourceSummaryOperand");
            a.item("Operand@names", "Min;Max;Sum;Average;Count;Custom");
            a.item("Alias", "String");
            a.item("CalculatorDisplayName", "String");
            a.item("ProvideCalculatorRef", "EventRef::provideCalculator");
        }
        static d(a) {
            ChartSummaryDescriptionDescriptionMetadata.b(a);
            a.ae("ChartSummaryDescription", () => new ChartSummaryDescriptionDescription());
            a.ad("ChartSummaryDescription", ChartSummaryDescriptionDescriptionMetadata.a);
        }
    }
    ChartSummaryDescriptionDescriptionMetadata.$t = /*@__PURE__*/ markType(ChartSummaryDescriptionDescriptionMetadata, 'ChartSummaryDescriptionDescriptionMetadata');
    ChartSummaryDescriptionDescriptionMetadata.a = null;
    return ChartSummaryDescriptionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartSummaryDescriptionDescriptionModule = /*@__PURE__*/ (() => {
    class ChartSummaryDescriptionDescriptionModule extends Base {
        static register(a) {
            ChartSummaryDescriptionDescriptionMetadata.d(a);
        }
    }
    ChartSummaryDescriptionDescriptionModule.$t = /*@__PURE__*/ markType(ChartSummaryDescriptionDescriptionModule, 'ChartSummaryDescriptionDescriptionModule');
    return ChartSummaryDescriptionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxDescription = /*@__PURE__*/ (() => {
    class CheckboxDescription extends Description {
        get_type() {
            return "Checkbox";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.aq = null;
            this.a0 = null;
            this.am = null;
            this.as = null;
            this.az = null;
            this.al = null;
            this.a1 = null;
            this.at = null;
            this.an = null;
            this.ak = null;
            this.w = 0;
            this.t = 0;
            this.x = 0;
            this.y = 0;
            this.v = 0;
            this.u = 0;
            this.aj = null;
            this.av = null;
            this.au = null;
            this.aw = null;
            this.ay = null;
            this.ag = 0;
            this.af = 0;
            this.ap = null;
            this.ao = null;
            this.a2 = null;
            this.l = false;
            this.ax = null;
            this.j = false;
            this.h = false;
            this.m = false;
            this.i = false;
            this.k = false;
            this.ar = null;
        }
        get baseTheme() {
            return this.aq;
        }
        set baseTheme(a) {
            this.aq = a;
            this.g("BaseTheme");
        }
        get uncheckedBackgroundColor() {
            return this.a0;
        }
        set uncheckedBackgroundColor(a) {
            this.a0 = a;
            this.g("UncheckedBackgroundColor");
        }
        get actualUncheckedBackgroundColor() {
            return this.am;
        }
        set actualUncheckedBackgroundColor(a) {
            this.am = a;
            this.g("ActualUncheckedBackgroundColor");
        }
        get checkedBackgroundColor() {
            return this.as;
        }
        set checkedBackgroundColor(a) {
            this.as = a;
            this.g("CheckedBackgroundColor");
        }
        get tickColor() {
            return this.az;
        }
        set tickColor(a) {
            this.az = a;
            this.g("TickColor");
        }
        get actualTickColor() {
            return this.al;
        }
        set actualTickColor(a) {
            this.al = a;
            this.g("ActualTickColor");
        }
        get uncheckedBorderColor() {
            return this.a1;
        }
        set uncheckedBorderColor(a) {
            this.a1 = a;
            this.g("UncheckedBorderColor");
        }
        get checkedBorderColor() {
            return this.at;
        }
        set checkedBorderColor(a) {
            this.at = a;
            this.g("CheckedBorderColor");
        }
        get actualUncheckedBorderColor() {
            return this.an;
        }
        set actualUncheckedBorderColor(a) {
            this.an = a;
            this.g("ActualUncheckedBorderColor");
        }
        get actualCheckedBorderColor() {
            return this.ak;
        }
        set actualCheckedBorderColor(a) {
            this.ak = a;
            this.g("ActualCheckedBorderColor");
        }
        get borderWidth() {
            return this.w;
        }
        set borderWidth(a) {
            this.w = a;
            this.g("BorderWidth");
        }
        get actualBorderWidth() {
            return this.t;
        }
        set actualBorderWidth(a) {
            this.t = a;
            this.g("ActualBorderWidth");
        }
        get cornerRadius() {
            return this.x;
        }
        set cornerRadius(a) {
            this.x = a;
            this.g("CornerRadius");
        }
        get tickStrokeWidth() {
            return this.y;
        }
        set tickStrokeWidth(a) {
            this.y = a;
            this.g("TickStrokeWidth");
        }
        get actualTickStrokeWidth() {
            return this.v;
        }
        set actualTickStrokeWidth(a) {
            this.v = a;
            this.g("ActualTickStrokeWidth");
        }
        get actualCornerRadius() {
            return this.u;
        }
        set actualCornerRadius(a) {
            this.u = a;
            this.g("ActualCornerRadius");
        }
        get actualCheckedBackgroundColor() {
            return this.aj;
        }
        set actualCheckedBackgroundColor(a) {
            this.aj = a;
            this.g("ActualCheckedBackgroundColor");
        }
        get inputId() {
            return this.av;
        }
        set inputId(a) {
            this.av = a;
            this.g("InputId");
        }
        get id() {
            return this.au;
        }
        set id(a) {
            this.au = a;
            this.g("Id");
        }
        get labelId() {
            return this.aw;
        }
        set labelId(a) {
            this.aw = a;
            this.g("LabelId");
        }
        get name() {
            return this.ay;
        }
        set name(a) {
            this.ay = a;
            this.g("Name");
        }
        get tabIndex() {
            return this.ag;
        }
        set tabIndex(a) {
            this.ag = a;
            this.g("TabIndex");
        }
        get required() {
            return this.af;
        }
        set required(a) {
            this.af = a;
            this.g("Required");
        }
        get ariaLabelledBy() {
            return this.ap;
        }
        set ariaLabelledBy(a) {
            this.ap = a;
            this.g("AriaLabelledBy");
        }
        get ariaLabel() {
            return this.ao;
        }
        set ariaLabel(a) {
            this.ao = a;
            this.g("AriaLabel");
        }
        get valueRef() {
            return this.a2;
        }
        set valueRef(a) {
            this.a2 = a;
            this.g("ValueRef");
        }
        get focused() {
            return this.l;
        }
        set focused(a) {
            this.l = a;
            this.g("Focused");
        }
        get labelPosition() {
            return this.ax;
        }
        set labelPosition(a) {
            this.ax = a;
            this.g("LabelPosition");
        }
        get disableRipple() {
            return this.j;
        }
        set disableRipple(a) {
            this.j = a;
            this.g("DisableRipple");
        }
        get checked() {
            return this.h;
        }
        set checked(a) {
            this.h = a;
            this.g("Checked");
        }
        get indeterminate() {
            return this.m;
        }
        set indeterminate(a) {
            this.m = a;
            this.g("Indeterminate");
        }
        get disabled() {
            return this.i;
        }
        set disabled(a) {
            this.i = a;
            this.g("Disabled");
        }
        get disableTransitions() {
            return this.k;
        }
        set disableTransitions(a) {
            this.k = a;
            this.g("DisableTransitions");
        }
        get changeRef() {
            return this.ar;
        }
        set changeRef(a) {
            this.ar = a;
            this.g("ChangeRef");
        }
    }
    CheckboxDescription.$t = /*@__PURE__*/ markType(CheckboxDescription, 'CheckboxDescription', Description.$);
    return CheckboxDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxChangeEventArgsDescription = /*@__PURE__*/ (() => {
    class CheckboxChangeEventArgsDescription extends Description {
        get_type() {
            return "CheckboxChangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
            this.i = false;
        }
        get isChecked() {
            return this.h;
        }
        set isChecked(a) {
            this.h = a;
            this.g("IsChecked");
        }
        get isIndeterminate() {
            return this.i;
        }
        set isIndeterminate(a) {
            this.i = a;
            this.g("IsIndeterminate");
        }
    }
    CheckboxChangeEventArgsDescription.$t = /*@__PURE__*/ markType(CheckboxChangeEventArgsDescription, 'CheckboxChangeEventArgsDescription', Description.$);
    return CheckboxChangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxChangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CheckboxChangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CheckboxChangeEventArgsDescriptionMetadata.a == null) {
                CheckboxChangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CheckboxChangeEventArgsDescriptionMetadata.c(CheckboxChangeEventArgsDescriptionMetadata.a);
            }
            if (a.k(CheckboxChangeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(CheckboxChangeEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("IsChecked", "Boolean");
            a.item("IsIndeterminate", "Boolean");
        }
        static d(a) {
            CheckboxChangeEventArgsDescriptionMetadata.b(a);
            a.ae("CheckboxChangeEventArgs", () => new CheckboxChangeEventArgsDescription());
            a.ad("CheckboxChangeEventArgs", CheckboxChangeEventArgsDescriptionMetadata.a);
        }
    }
    CheckboxChangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CheckboxChangeEventArgsDescriptionMetadata, 'CheckboxChangeEventArgsDescriptionMetadata');
    CheckboxChangeEventArgsDescriptionMetadata.a = null;
    return CheckboxChangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxDescriptionMetadata = /*@__PURE__*/ (() => {
    class CheckboxDescriptionMetadata extends Base {
        static b(a) {
            if (CheckboxDescriptionMetadata.a == null) {
                CheckboxDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CheckboxDescriptionMetadata.c(CheckboxDescriptionMetadata.a);
            }
            if (a.k(CheckboxDescriptionMetadata.a)) {
                return;
            }
            a.ac(CheckboxDescriptionMetadata.a);
            CheckboxChangeEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:XCheckbox");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("UncheckedBackgroundColor", "Brush");
            a.item("ActualUncheckedBackgroundColor", "Brush");
            a.item("CheckedBackgroundColor", "Brush");
            a.item("TickColor", "Brush");
            a.item("ActualTickColor", "Brush");
            a.item("UncheckedBorderColor", "Brush");
            a.item("CheckedBorderColor", "Brush");
            a.item("ActualUncheckedBorderColor", "Brush");
            a.item("ActualCheckedBorderColor", "Brush");
            a.item("BorderWidth", "Number:double");
            a.item("ActualBorderWidth", "Number:double");
            a.item("CornerRadius", "Number:double");
            a.item("TickStrokeWidth", "Number:double");
            a.item("ActualTickStrokeWidth", "Number:double");
            a.item("ActualCornerRadius", "Number:double");
            a.item("ActualCheckedBackgroundColor", "Brush");
            a.item("InputId", "String");
            a.item("Id", "String");
            a.item("LabelId", "String");
            a.item("Name", "String");
            a.item("TabIndex", "Number:int");
            a.item("Required", "Number:int");
            a.item("AriaLabelledBy", "String");
            a.item("AriaLabel", "String");
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
            a.item("Focused", "(w:IsFocused,xam:IsFocused,wf:IsFocused)Boolean");
            a.item("LabelPosition", "ExportedType:string:CheckboxLabelPosition");
            a.item("LabelPosition@names", "After;Before");
            a.item("DisableRipple", "Boolean");
            a.item("Checked", "(w:IsChecked,xam:IsChecked,wf:IsChecked)Boolean");
            a.item("Indeterminate", "(w:IsIndeterminate,xam:IsIndeterminate,wf:IsIndeterminate)Boolean");
            a.item("Disabled", "(w:IsDisabled,xam:IsDisabled,wf:IsDisabled)Boolean");
            a.item("DisableTransitions", "Boolean");
            a.item("ChangeRef", "EventRef::change");
        }
        static d(a) {
            CheckboxDescriptionMetadata.b(a);
            a.ae("Checkbox", () => new CheckboxDescription());
            a.ad("Checkbox", CheckboxDescriptionMetadata.a);
        }
    }
    CheckboxDescriptionMetadata.$t = /*@__PURE__*/ markType(CheckboxDescriptionMetadata, 'CheckboxDescriptionMetadata');
    CheckboxDescriptionMetadata.a = null;
    return CheckboxDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxListDescription = /*@__PURE__*/ (() => {
    class CheckboxListDescription extends Description {
        get_type() {
            return "CheckboxList";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.i = null;
            this.ak = null;
            this.aj = null;
            this.a4 = null;
            this.am = null;
            this.ax = null;
            this.v = 0;
            this.aa = null;
            this.r = 0;
            this.ab = null;
            this.ac = null;
            this.an = null;
            this.z = null;
            this.al = null;
            this.aw = null;
            this.ar = null;
            this.ay = null;
            this.as = null;
            this.at = null;
            this.s = 0;
            this.au = null;
            this.av = null;
            this.af = null;
            this.ad = null;
            this.ag = null;
            this.ae = null;
            this.ah = null;
            this.aq = null;
            this.ap = null;
            this.az = null;
            this.a0 = null;
            this.x = null;
            this.n = false;
            this.y = null;
            this.ao = null;
            this.a5 = null;
            this.m = false;
            this.l = false;
            this.a2 = null;
            this.a3 = null;
            this.ai = null;
            this.a1 = null;
        }
        get keys() {
            return this.h;
        }
        set keys(a) {
            this.h = a;
            this.g("Keys");
        }
        get primaryKey() {
            return this.i;
        }
        set primaryKey(a) {
            this.i = a;
            this.g("PrimaryKey");
        }
        get dataSourceRef() {
            return this.ak;
        }
        set dataSourceRef(a) {
            this.ak = a;
            this.g("DataSourceRef");
        }
        get dataMemberPath() {
            return this.aj;
        }
        set dataMemberPath(a) {
            this.aj = a;
            this.g("DataMemberPath");
        }
        get selectedMemberPath() {
            return this.a4;
        }
        set selectedMemberPath(a) {
            this.a4 = a;
            this.g("SelectedMemberPath");
        }
        get filterPlaceholderText() {
            return this.am;
        }
        set filterPlaceholderText(a) {
            this.am = a;
            this.g("FilterPlaceholderText");
        }
        get searchInputType() {
            return this.ax;
        }
        set searchInputType(a) {
            this.ax = a;
            this.g("SearchInputType");
        }
        get rowHeight() {
            return this.v;
        }
        set rowHeight(a) {
            this.v = a;
            this.g("RowHeight");
        }
        get cellFontFamily() {
            return this.aa;
        }
        set cellFontFamily(a) {
            this.aa = a;
            this.g("CellFontFamily");
        }
        get cellFontSize() {
            return this.r;
        }
        set cellFontSize(a) {
            this.r = a;
            this.g("CellFontSize");
        }
        get cellFontStyle() {
            return this.ab;
        }
        set cellFontStyle(a) {
            this.ab = a;
            this.g("CellFontStyle");
        }
        get cellFontWeight() {
            return this.ac;
        }
        set cellFontWeight(a) {
            this.ac = a;
            this.g("CellFontWeight");
        }
        get indexType() {
            return this.an;
        }
        set indexType(a) {
            this.an = a;
            this.g("IndexType");
        }
        get baseTheme() {
            return this.z;
        }
        set baseTheme(a) {
            this.z = a;
            this.g("BaseTheme");
        }
        get density() {
            return this.al;
        }
        set density(a) {
            this.al = a;
            this.g("Density");
        }
        get searchIconColor() {
            return this.aw;
        }
        set searchIconColor(a) {
            this.aw = a;
            this.g("SearchIconColor");
        }
        get searchBackgroundColor() {
            return this.ar;
        }
        set searchBackgroundColor(a) {
            this.ar = a;
            this.g("SearchBackgroundColor");
        }
        get searchTextColor() {
            return this.ay;
        }
        set searchTextColor(a) {
            this.ay = a;
            this.g("SearchTextColor");
        }
        get searchBorderColor() {
            return this.as;
        }
        set searchBorderColor(a) {
            this.as = a;
            this.g("SearchBorderColor");
        }
        get searchFontFamily() {
            return this.at;
        }
        set searchFontFamily(a) {
            this.at = a;
            this.g("SearchFontFamily");
        }
        get searchFontSize() {
            return this.s;
        }
        set searchFontSize(a) {
            this.s = a;
            this.g("SearchFontSize");
        }
        get searchFontStyle() {
            return this.au;
        }
        set searchFontStyle(a) {
            this.au = a;
            this.g("SearchFontStyle");
        }
        get searchFontWeight() {
            return this.av;
        }
        set searchFontWeight(a) {
            this.av = a;
            this.g("SearchFontWeight");
        }
        get checkboxTickColor() {
            return this.af;
        }
        set checkboxTickColor(a) {
            this.af = a;
            this.g("CheckboxTickColor");
        }
        get checkboxCheckedBackgroundColor() {
            return this.ad;
        }
        set checkboxCheckedBackgroundColor(a) {
            this.ad = a;
            this.g("CheckboxCheckedBackgroundColor");
        }
        get checkboxUncheckedBackgroundColor() {
            return this.ag;
        }
        set checkboxUncheckedBackgroundColor(a) {
            this.ag = a;
            this.g("CheckboxUncheckedBackgroundColor");
        }
        get checkboxCheckedBorderColor() {
            return this.ae;
        }
        set checkboxCheckedBorderColor(a) {
            this.ae = a;
            this.g("CheckboxCheckedBorderColor");
        }
        get checkboxUncheckedBorderColor() {
            return this.ah;
        }
        set checkboxUncheckedBorderColor(a) {
            this.ah = a;
            this.g("CheckboxUncheckedBorderColor");
        }
        get scrollbarStyle() {
            return this.aq;
        }
        set scrollbarStyle(a) {
            this.aq = a;
            this.g("ScrollbarStyle");
        }
        get scrollbarBackground() {
            return this.ap;
        }
        set scrollbarBackground(a) {
            this.ap = a;
            this.g("ScrollbarBackground");
        }
        get selectAllCaption() {
            return this.az;
        }
        set selectAllCaption(a) {
            this.az = a;
            this.g("SelectAllCaption");
        }
        get selectAllCaptionTextColor() {
            return this.a0;
        }
        set selectAllCaptionTextColor(a) {
            this.a0 = a;
            this.g("SelectAllCaptionTextColor");
        }
        get actualSelectAllCaptionTextColor() {
            return this.x;
        }
        set actualSelectAllCaptionTextColor(a) {
            this.x = a;
            this.g("ActualSelectAllCaptionTextColor");
        }
        get showSelectAll() {
            return this.n;
        }
        set showSelectAll(a) {
            this.n = a;
            this.g("ShowSelectAll");
        }
        get backgroundColor() {
            return this.y;
        }
        set backgroundColor(a) {
            this.y = a;
            this.g("BackgroundColor");
        }
        get rowHoverBackgroundColor() {
            return this.ao;
        }
        set rowHoverBackgroundColor(a) {
            this.ao = a;
            this.g("RowHoverBackgroundColor");
        }
        get textColor() {
            return this.a5;
        }
        set textColor(a) {
            this.a5 = a;
            this.g("TextColor");
        }
        get showFilter() {
            return this.m;
        }
        set showFilter(a) {
            this.m = a;
            this.g("ShowFilter");
        }
        get isRowHoverEnabled() {
            return this.l;
        }
        set isRowHoverEnabled(a) {
            this.l = a;
            this.g("IsRowHoverEnabled");
        }
        get selectedKeyAddedRef() {
            return this.a2;
        }
        set selectedKeyAddedRef(a) {
            this.a2 = a;
            this.g("SelectedKeyAddedRef");
        }
        get selectedKeyRemovedRef() {
            return this.a3;
        }
        set selectedKeyRemovedRef(a) {
            this.a3 = a;
            this.g("SelectedKeyRemovedRef");
        }
        get checkedChangedRef() {
            return this.ai;
        }
        set checkedChangedRef(a) {
            this.ai = a;
            this.g("CheckedChangedRef");
        }
        get selectAllCheckboxChangedRef() {
            return this.a1;
        }
        set selectAllCheckboxChangedRef(a) {
            this.a1 = a;
            this.g("SelectAllCheckboxChangedRef");
        }
    }
    CheckboxListDescription.$t = /*@__PURE__*/ markType(CheckboxListDescription, 'CheckboxListDescription', Description.$);
    return CheckboxListDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckedChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class CheckedChangedEventArgsDescription extends Description {
        get_type() {
            return "CheckedChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = 0;
            this.h = false;
            this.l = null;
        }
        get index() {
            return this.j;
        }
        set index(a) {
            this.j = a;
            this.g("Index");
        }
        get isChecked() {
            return this.h;
        }
        set isChecked(a) {
            this.h = a;
            this.g("IsChecked");
        }
        get primaryKeyRef() {
            return this.l;
        }
        set primaryKeyRef(a) {
            this.l = a;
            this.g("PrimaryKeyRef");
        }
    }
    CheckedChangedEventArgsDescription.$t = /*@__PURE__*/ markType(CheckedChangedEventArgsDescription, 'CheckedChangedEventArgsDescription', Description.$);
    return CheckedChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckedChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CheckedChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CheckedChangedEventArgsDescriptionMetadata.a == null) {
                CheckedChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CheckedChangedEventArgsDescriptionMetadata.c(CheckedChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(CheckedChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(CheckedChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Index", "Number:int");
            a.item("IsChecked", "Boolean");
            a.item("PrimaryKeyRef", "(w:PrimaryKey,wf:PrimaryKey)DataRef:object");
        }
        static d(a) {
            CheckedChangedEventArgsDescriptionMetadata.b(a);
            a.ae("CheckedChangedEventArgs", () => new CheckedChangedEventArgsDescription());
            a.ad("CheckedChangedEventArgs", CheckedChangedEventArgsDescriptionMetadata.a);
        }
    }
    CheckedChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CheckedChangedEventArgsDescriptionMetadata, 'CheckedChangedEventArgsDescriptionMetadata');
    CheckedChangedEventArgsDescriptionMetadata.a = null;
    return CheckedChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectAllCheckboxChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class SelectAllCheckboxChangedEventArgsDescription extends Description {
        get_type() {
            return "SelectAllCheckboxChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
        }
        get isChecked() {
            return this.h;
        }
        set isChecked(a) {
            this.h = a;
            this.g("IsChecked");
        }
    }
    SelectAllCheckboxChangedEventArgsDescription.$t = /*@__PURE__*/ markType(SelectAllCheckboxChangedEventArgsDescription, 'SelectAllCheckboxChangedEventArgsDescription', Description.$);
    return SelectAllCheckboxChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectAllCheckboxChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SelectAllCheckboxChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SelectAllCheckboxChangedEventArgsDescriptionMetadata.a == null) {
                SelectAllCheckboxChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SelectAllCheckboxChangedEventArgsDescriptionMetadata.c(SelectAllCheckboxChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(SelectAllCheckboxChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(SelectAllCheckboxChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("IsChecked", "Boolean");
        }
        static d(a) {
            SelectAllCheckboxChangedEventArgsDescriptionMetadata.b(a);
            a.ae("SelectAllCheckboxChangedEventArgs", () => new SelectAllCheckboxChangedEventArgsDescription());
            a.ad("SelectAllCheckboxChangedEventArgs", SelectAllCheckboxChangedEventArgsDescriptionMetadata.a);
        }
    }
    SelectAllCheckboxChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SelectAllCheckboxChangedEventArgsDescriptionMetadata, 'SelectAllCheckboxChangedEventArgsDescriptionMetadata');
    SelectAllCheckboxChangedEventArgsDescriptionMetadata.a = null;
    return SelectAllCheckboxChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxListDescriptionMetadata = /*@__PURE__*/ (() => {
    class CheckboxListDescriptionMetadata extends Base {
        static b(a) {
            if (CheckboxListDescriptionMetadata.a == null) {
                CheckboxListDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CheckboxListDescriptionMetadata.c(CheckboxListDescriptionMetadata.a);
            }
            if (a.k(CheckboxListDescriptionMetadata.a)) {
                return;
            }
            a.ac(CheckboxListDescriptionMetadata.a);
            CheckedChangedEventArgsDescriptionMetadata.d(a);
            SelectAllCheckboxChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Keys", "Collection:PrimaryKeyValue:GridSelectedKeysCollection:PrimaryKeyValue");
            a.item("PrimaryKey", "Array:string");
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)DataRef::object");
            a.item("DataMemberPath", "String");
            a.item("SelectedMemberPath", "String");
            a.item("FilterPlaceholderText", "String");
            a.item("SearchInputType", "ExportedType:string:InputGroupDisplayType");
            a.item("SearchInputType@names", "Line;Box;Border;Search");
            a.item("RowHeight", "Number:int");
            a.item("CellFontFamily", "(w:CellFontFamily/FontFamilyTransform,xam:CellFontFamily,wf:CellFontFamily,web:cellTextStyle/FontFamilyTransform)String");
            a.item("CellFontSize", "(w:CellFontSize,xam:CellFontSize,wf:CellFontSize,web:cellTextStyle/FontSizeTransform)Number:double");
            a.item("CellFontStyle", "(w:CellFontStyle/FontStyleTransform,xam:CellFontFamily/FontStyleTransform,wf:CellFontFamily/FontStyleTransform,web:cellTextStyle/FontStyleTransform)String");
            a.item("CellFontWeight", "(w:CellFontWeight/FontWeightTransform,xam:CellFontFamily/FontWeightTransform,wf:CellFontFamily/FontWeightTransform,web:cellTextStyle/FontWeightTransform)String");
            a.item("IndexType", "ExportedType:string:CheckboxListIndexType");
            a.item("IndexType@names", "Selected;DeSelected");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("SearchIconColor", "Brush");
            a.item("SearchBackgroundColor", "Brush");
            a.item("SearchTextColor", "Brush");
            a.item("SearchBorderColor", "Brush");
            a.item("SearchFontFamily", "(w:SearchFontFamily/FontFamilyTransform,xam:SearchFontFamily,wf:SearchFontFamily,web:searchTextStyle/FontFamilyTransform)String");
            a.item("SearchFontSize", "(w:SearchFontSize,xam:SearchFontSize,wf:SearchFontSize,web:searchTextStyle/FontSizeTransform)Number:double");
            a.item("SearchFontStyle", "(w:SearchFontStyle/FontStyleTransform,xam:SearchFontFamily/FontStyleTransform,wf:SearchFontFamily/FontStyleTransform,web:searchTextStyle/FontStyleTransform)String");
            a.item("SearchFontWeight", "(w:SearchFontWeight/FontWeightTransform,xam:SearchFontFamily/FontWeightTransform,wf:SearchFontFamily/FontWeightTransform,web:searchTextStyle/FontWeightTransform)String");
            a.item("CheckboxTickColor", "Brush");
            a.item("CheckboxCheckedBackgroundColor", "Brush");
            a.item("CheckboxUncheckedBackgroundColor", "Brush");
            a.item("CheckboxCheckedBorderColor", "Brush");
            a.item("CheckboxUncheckedBorderColor", "Brush");
            a.item("ScrollbarStyle", "ExportedType:string:ScrollbarStyle");
            a.item("ScrollbarStyle@names", "Default;Fading;Thin");
            a.item("ScrollbarBackground", "Brush");
            a.item("SelectAllCaption", "String");
            a.item("SelectAllCaptionTextColor", "Brush");
            a.item("ActualSelectAllCaptionTextColor", "Brush");
            a.item("ShowSelectAll", "Boolean");
            a.item("BackgroundColor", "Brush");
            a.item("RowHoverBackgroundColor", "Brush");
            a.item("TextColor", "Brush");
            a.item("ShowFilter", "Boolean");
            a.item("IsRowHoverEnabled", "Boolean");
            a.item("SelectedKeyAddedRef", "EventRef::selectedKeyAdded");
            a.item("SelectedKeyRemovedRef", "EventRef::selectedKeyRemoved");
            a.item("CheckedChangedRef", "EventRef::checkedChanged");
            a.item("SelectAllCheckboxChangedRef", "EventRef::selectAllCheckboxChanged");
        }
        static d(a) {
            CheckboxListDescriptionMetadata.b(a);
            a.ae("CheckboxList", () => new CheckboxListDescription());
            a.ad("CheckboxList", CheckboxListDescriptionMetadata.a);
        }
    }
    CheckboxListDescriptionMetadata.$t = /*@__PURE__*/ markType(CheckboxListDescriptionMetadata, 'CheckboxListDescriptionMetadata');
    CheckboxListDescriptionMetadata.a = null;
    return CheckboxListDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataBindingEventArgsDescription = /*@__PURE__*/ (() => {
    class DataBindingEventArgsDescription extends Description {
        get_type() {
            return "DataBindingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.i = null;
        }
        get resolvedValueRef() {
            return this.h;
        }
        set resolvedValueRef(a) {
            this.h = a;
            this.g("ResolvedValueRef");
        }
        get rowObjectRef() {
            return this.i;
        }
        set rowObjectRef(a) {
            this.i = a;
            this.g("RowObjectRef");
        }
    }
    DataBindingEventArgsDescription.$t = /*@__PURE__*/ markType(DataBindingEventArgsDescription, 'DataBindingEventArgsDescription', Description.$);
    return DataBindingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataBindingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataBindingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DataBindingEventArgsDescriptionMetadata.a == null) {
                DataBindingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataBindingEventArgsDescriptionMetadata.c(DataBindingEventArgsDescriptionMetadata.a);
            }
            if (a.k(DataBindingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataBindingEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ResolvedValueRef", "(w:ResolvedValue,wf:ResolvedValue)DataRef");
            a.item("RowObjectRef", "(w:RowObject,wf:RowObject)DataRef");
        }
        static d(a) {
            DataBindingEventArgsDescriptionMetadata.b(a);
            a.ae("DataBindingEventArgs", () => new DataBindingEventArgsDescription());
            a.ad("DataBindingEventArgs", DataBindingEventArgsDescriptionMetadata.a);
        }
    }
    DataBindingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataBindingEventArgsDescriptionMetadata, 'DataBindingEventArgsDescriptionMetadata');
    DataBindingEventArgsDescriptionMetadata.a = null;
    return DataBindingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellStyleRequestedEventArgsDescription = /*@__PURE__*/ (() => {
    class CellStyleRequestedEventArgsDescription extends Description {
        get_type() {
            return "CellStyleRequestedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = null;
            this.j = null;
            this.h = 0;
        }
        get styleKey() {
            return this.k;
        }
        set styleKey(a) {
            this.k = a;
            this.g("StyleKey");
        }
        get resolvedValueRef() {
            return this.j;
        }
        set resolvedValueRef(a) {
            this.j = a;
            this.g("ResolvedValueRef");
        }
        get rowNumber() {
            return this.h;
        }
        set rowNumber(a) {
            this.h = a;
            this.g("RowNumber");
        }
    }
    CellStyleRequestedEventArgsDescription.$t = /*@__PURE__*/ markType(CellStyleRequestedEventArgsDescription, 'CellStyleRequestedEventArgsDescription', Description.$);
    return CellStyleRequestedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellStyleRequestedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CellStyleRequestedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CellStyleRequestedEventArgsDescriptionMetadata.a == null) {
                CellStyleRequestedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CellStyleRequestedEventArgsDescriptionMetadata.c(CellStyleRequestedEventArgsDescriptionMetadata.a);
            }
            if (a.k(CellStyleRequestedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(CellStyleRequestedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("StyleKey", "String");
            a.item("ResolvedValueRef", "(w:ResolvedValue,wf:ResolvedValue)DataRef");
            a.item("RowNumber", "Number:int");
        }
        static d(a) {
            CellStyleRequestedEventArgsDescriptionMetadata.b(a);
            a.ae("CellStyleRequestedEventArgs", () => new CellStyleRequestedEventArgsDescription());
            a.ad("CellStyleRequestedEventArgs", CellStyleRequestedEventArgsDescriptionMetadata.a);
        }
    }
    CellStyleRequestedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CellStyleRequestedEventArgsDescriptionMetadata, 'CellStyleRequestedEventArgsDescriptionMetadata');
    CellStyleRequestedEventArgsDescriptionMetadata.a = null;
    return CellStyleRequestedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DefinitionBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class DefinitionBaseDescriptionMetadata extends Base {
        static b(a) {
            if (DefinitionBaseDescriptionMetadata.a == null) {
                DefinitionBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DefinitionBaseDescriptionMetadata.c(DefinitionBaseDescriptionMetadata.a);
            }
            if (a.k(DefinitionBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(DefinitionBaseDescriptionMetadata.a);
            DataBindingEventArgsDescriptionMetadata.d(a);
            CellStyleRequestedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Background", "Brush");
            a.item("Border", "Brush");
            a.item("ActivationBorder", "Brush");
            a.item("ErrorBorder", "Brush");
            a.item("ActualBorder", "Brush");
            a.item("BorderLeftWidth", "Number:int");
            a.item("BorderTopWidth", "Number:int");
            a.item("BorderRightWidth", "Number:int");
            a.item("BorderBottomWidth", "Number:int");
            a.item("ActivationBorderLeftWidth", "Number:int");
            a.item("ActivationBorderTopWidth", "Number:int");
            a.item("ActivationBorderRightWidth", "Number:int");
            a.item("ActivationBorderBottomWidth", "Number:int");
            a.item("ErrorBorderLeftWidth", "Number:int");
            a.item("ErrorBorderTopWidth", "Number:int");
            a.item("ErrorBorderRightWidth", "Number:int");
            a.item("ErrorBorderBottomWidth", "Number:int");
            a.item("ActualBackground", "Brush");
            a.item("ActualActivationBorder", "Brush");
            a.item("ActualErrorBorder", "Brush");
            a.item("StickyRowBackground", "Brush");
            a.item("ActualStickyRowBackground", "Brush");
            a.item("PinnedRowBackground", "Brush");
            a.item("ActualPinnedRowBackground", "Brush");
            a.item("LastStickyRowBackground", "Brush");
            a.item("ActualLastStickyRowBackground", "Brush");
            a.item("ContentOpacity", "Number:double");
            a.item("HorizontalAlignment", "ExportedType:string:CellContentHorizontalAlignment");
            a.item("HorizontalAlignment@names", "Left;Center;Right;Stretch;Auto");
            a.item("VerticalAlignment", "ExportedType:string:CellContentVerticalAlignment");
            a.item("VerticalAlignment@names", "Top;Center;Bottom;Stretch;Auto");
            a.item("LineBreakMode", "ExportedType:string:TextCellLineBreakMode");
            a.item("LineBreakMode@names", "Ellipsis;NoWrap;WordWrap;CharacterWrap");
            a.item("ActualLineBreakMode", "ExportedType:string:TextCellLineBreakMode");
            a.item("ActualLineBreakMode@names", "Ellipsis;NoWrap;WordWrap;CharacterWrap");
            a.item("TextColor", "Brush");
            a.item("ActualTextColor", "Brush");
            a.item("PinnedRowOpacity", "Number:double");
            a.item("ActualPinnedRowOpacity", "Number:double");
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontFamily/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontFamily/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            a.item("DataBindingRef", "EventRef::dataBinding");
            a.item("DataBoundRef", "EventRef::dataBound");
            a.item("CellStyleKeyRequestedRef", "EventRef::cellStyleKeyRequested");
        }
        static d(a) {
            DefinitionBaseDescriptionMetadata.b(a);
            a.ad("DefinitionBase", DefinitionBaseDescriptionMetadata.a);
        }
    }
    DefinitionBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(DefinitionBaseDescriptionMetadata, 'DefinitionBaseDescriptionMetadata');
    DefinitionBaseDescriptionMetadata.a = null;
    return DefinitionBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class HeaderDescriptionMetadata extends Base {
        static b(a) {
            if (HeaderDescriptionMetadata.a == null) {
                HeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HeaderDescriptionMetadata.c(HeaderDescriptionMetadata.a);
            }
            if (a.k(HeaderDescriptionMetadata.a)) {
                return;
            }
            a.ac(HeaderDescriptionMetadata.a);
        }
        static c(a) {
            DefinitionBaseDescriptionMetadata.c(a);
            a.item("SortIndicatorColor", "Brush");
            a.item("ActualSortIndicatorColor", "Brush");
            a.item("SortIndicatorStyle", "ExportedType:string:SortIndicatorStyle");
            a.item("SortIndicatorStyle@names", "Default;FadingUpDownArrows;FadingSimpleUpDownArrows;Unset");
            a.item("ActualSortIndicatorStyle", "ExportedType:string:SortIndicatorStyle");
            a.item("ActualSortIndicatorStyle@names", "Default;FadingUpDownArrows;FadingSimpleUpDownArrows;Unset");
            a.item("PaddingLeft", "Number:int");
            a.item("PaddingTop", "Number:int");
            a.item("PaddingRight", "Number:int");
            a.item("PaddingBottom", "Number:int");
        }
        static d(a) {
            HeaderDescriptionMetadata.b(a);
            a.ad("Header", HeaderDescriptionMetadata.a);
        }
    }
    HeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(HeaderDescriptionMetadata, 'HeaderDescriptionMetadata');
    HeaderDescriptionMetadata.a = null;
    return HeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DefinitionBaseDescription = /*@__PURE__*/ (() => {
    class DefinitionBaseDescription extends Description {
        get_type() {
            return "DefinitionBase";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.ax = null;
            this.ay = null;
            this.an = null;
            this.a2 = null;
            this.aq = null;
            this.u = 0;
            this.w = 0;
            this.v = 0;
            this.t = 0;
            this.q = 0;
            this.s = 0;
            this.r = 0;
            this.p = 0;
            this.y = 0;
            this.aa = 0;
            this.z = 0;
            this.x = 0;
            this.ap = null;
            this.ao = null;
            this.ar = null;
            this.ba = null;
            this.av = null;
            this.a9 = null;
            this.au = null;
            this.a7 = null;
            this.as = null;
            this.i = 0;
            this.a6 = null;
            this.bc = null;
            this.a8 = null;
            this.at = null;
            this.bb = null;
            this.aw = null;
            this.k = 0;
            this.h = 0;
            this.a3 = null;
            this.j = 0;
            this.a4 = null;
            this.a5 = null;
            this.a0 = null;
            this.a1 = null;
            this.az = null;
        }
        get background() {
            return this.ax;
        }
        set background(a) {
            this.ax = a;
            this.g("Background");
        }
        get border() {
            return this.ay;
        }
        set border(a) {
            this.ay = a;
            this.g("Border");
        }
        get activationBorder() {
            return this.an;
        }
        set activationBorder(a) {
            this.an = a;
            this.g("ActivationBorder");
        }
        get errorBorder() {
            return this.a2;
        }
        set errorBorder(a) {
            this.a2 = a;
            this.g("ErrorBorder");
        }
        get actualBorder() {
            return this.aq;
        }
        set actualBorder(a) {
            this.aq = a;
            this.g("ActualBorder");
        }
        get borderLeftWidth() {
            return this.u;
        }
        set borderLeftWidth(a) {
            this.u = a;
            this.g("BorderLeftWidth");
        }
        get borderTopWidth() {
            return this.w;
        }
        set borderTopWidth(a) {
            this.w = a;
            this.g("BorderTopWidth");
        }
        get borderRightWidth() {
            return this.v;
        }
        set borderRightWidth(a) {
            this.v = a;
            this.g("BorderRightWidth");
        }
        get borderBottomWidth() {
            return this.t;
        }
        set borderBottomWidth(a) {
            this.t = a;
            this.g("BorderBottomWidth");
        }
        get activationBorderLeftWidth() {
            return this.q;
        }
        set activationBorderLeftWidth(a) {
            this.q = a;
            this.g("ActivationBorderLeftWidth");
        }
        get activationBorderTopWidth() {
            return this.s;
        }
        set activationBorderTopWidth(a) {
            this.s = a;
            this.g("ActivationBorderTopWidth");
        }
        get activationBorderRightWidth() {
            return this.r;
        }
        set activationBorderRightWidth(a) {
            this.r = a;
            this.g("ActivationBorderRightWidth");
        }
        get activationBorderBottomWidth() {
            return this.p;
        }
        set activationBorderBottomWidth(a) {
            this.p = a;
            this.g("ActivationBorderBottomWidth");
        }
        get errorBorderLeftWidth() {
            return this.y;
        }
        set errorBorderLeftWidth(a) {
            this.y = a;
            this.g("ErrorBorderLeftWidth");
        }
        get errorBorderTopWidth() {
            return this.aa;
        }
        set errorBorderTopWidth(a) {
            this.aa = a;
            this.g("ErrorBorderTopWidth");
        }
        get errorBorderRightWidth() {
            return this.z;
        }
        set errorBorderRightWidth(a) {
            this.z = a;
            this.g("ErrorBorderRightWidth");
        }
        get errorBorderBottomWidth() {
            return this.x;
        }
        set errorBorderBottomWidth(a) {
            this.x = a;
            this.g("ErrorBorderBottomWidth");
        }
        get actualBackground() {
            return this.ap;
        }
        set actualBackground(a) {
            this.ap = a;
            this.g("ActualBackground");
        }
        get actualActivationBorder() {
            return this.ao;
        }
        set actualActivationBorder(a) {
            this.ao = a;
            this.g("ActualActivationBorder");
        }
        get actualErrorBorder() {
            return this.ar;
        }
        set actualErrorBorder(a) {
            this.ar = a;
            this.g("ActualErrorBorder");
        }
        get stickyRowBackground() {
            return this.ba;
        }
        set stickyRowBackground(a) {
            this.ba = a;
            this.g("StickyRowBackground");
        }
        get actualStickyRowBackground() {
            return this.av;
        }
        set actualStickyRowBackground(a) {
            this.av = a;
            this.g("ActualStickyRowBackground");
        }
        get pinnedRowBackground() {
            return this.a9;
        }
        set pinnedRowBackground(a) {
            this.a9 = a;
            this.g("PinnedRowBackground");
        }
        get actualPinnedRowBackground() {
            return this.au;
        }
        set actualPinnedRowBackground(a) {
            this.au = a;
            this.g("ActualPinnedRowBackground");
        }
        get lastStickyRowBackground() {
            return this.a7;
        }
        set lastStickyRowBackground(a) {
            this.a7 = a;
            this.g("LastStickyRowBackground");
        }
        get actualLastStickyRowBackground() {
            return this.as;
        }
        set actualLastStickyRowBackground(a) {
            this.as = a;
            this.g("ActualLastStickyRowBackground");
        }
        get contentOpacity() {
            return this.i;
        }
        set contentOpacity(a) {
            this.i = a;
            this.g("ContentOpacity");
        }
        get horizontalAlignment() {
            return this.a6;
        }
        set horizontalAlignment(a) {
            this.a6 = a;
            this.g("HorizontalAlignment");
        }
        get verticalAlignment() {
            return this.bc;
        }
        set verticalAlignment(a) {
            this.bc = a;
            this.g("VerticalAlignment");
        }
        get lineBreakMode() {
            return this.a8;
        }
        set lineBreakMode(a) {
            this.a8 = a;
            this.g("LineBreakMode");
        }
        get actualLineBreakMode() {
            return this.at;
        }
        set actualLineBreakMode(a) {
            this.at = a;
            this.g("ActualLineBreakMode");
        }
        get textColor() {
            return this.bb;
        }
        set textColor(a) {
            this.bb = a;
            this.g("TextColor");
        }
        get actualTextColor() {
            return this.aw;
        }
        set actualTextColor(a) {
            this.aw = a;
            this.g("ActualTextColor");
        }
        get pinnedRowOpacity() {
            return this.k;
        }
        set pinnedRowOpacity(a) {
            this.k = a;
            this.g("PinnedRowOpacity");
        }
        get actualPinnedRowOpacity() {
            return this.h;
        }
        set actualPinnedRowOpacity(a) {
            this.h = a;
            this.g("ActualPinnedRowOpacity");
        }
        get fontFamily() {
            return this.a3;
        }
        set fontFamily(a) {
            this.a3 = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.j;
        }
        set fontSize(a) {
            this.j = a;
            this.g("FontSize");
        }
        get fontStyle() {
            return this.a4;
        }
        set fontStyle(a) {
            this.a4 = a;
            this.g("FontStyle");
        }
        get fontWeight() {
            return this.a5;
        }
        set fontWeight(a) {
            this.a5 = a;
            this.g("FontWeight");
        }
        get dataBindingRef() {
            return this.a0;
        }
        set dataBindingRef(a) {
            this.a0 = a;
            this.g("DataBindingRef");
        }
        get dataBoundRef() {
            return this.a1;
        }
        set dataBoundRef(a) {
            this.a1 = a;
            this.g("DataBoundRef");
        }
        get cellStyleKeyRequestedRef() {
            return this.az;
        }
        set cellStyleKeyRequestedRef(a) {
            this.az = a;
            this.g("CellStyleKeyRequestedRef");
        }
    }
    DefinitionBaseDescription.$t = /*@__PURE__*/ markType(DefinitionBaseDescription, 'DefinitionBaseDescription', Description.$);
    return DefinitionBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderDescription = /*@__PURE__*/ (() => {
    class HeaderDescription extends DefinitionBaseDescription {
        get_type() {
            return "Header";
        }
        constructor() {
            super();
            this.cg = null;
            this.ce = null;
            this.ch = null;
            this.cf = null;
            this.b6 = 0;
            this.b8 = 0;
            this.b7 = 0;
            this.b5 = 0;
        }
        get sortIndicatorColor() {
            return this.cg;
        }
        set sortIndicatorColor(a) {
            this.cg = a;
            this.g("SortIndicatorColor");
        }
        get actualSortIndicatorColor() {
            return this.ce;
        }
        set actualSortIndicatorColor(a) {
            this.ce = a;
            this.g("ActualSortIndicatorColor");
        }
        get sortIndicatorStyle() {
            return this.ch;
        }
        set sortIndicatorStyle(a) {
            this.ch = a;
            this.g("SortIndicatorStyle");
        }
        get actualSortIndicatorStyle() {
            return this.cf;
        }
        set actualSortIndicatorStyle(a) {
            this.cf = a;
            this.g("ActualSortIndicatorStyle");
        }
        get paddingLeft() {
            return this.b6;
        }
        set paddingLeft(a) {
            this.b6 = a;
            this.g("PaddingLeft");
        }
        get paddingTop() {
            return this.b8;
        }
        set paddingTop(a) {
            this.b8 = a;
            this.g("PaddingTop");
        }
        get paddingRight() {
            return this.b7;
        }
        set paddingRight(a) {
            this.b7 = a;
            this.g("PaddingRight");
        }
        get paddingBottom() {
            return this.b5;
        }
        set paddingBottom(a) {
            this.b5 = a;
            this.g("PaddingBottom");
        }
    }
    HeaderDescription.$t = /*@__PURE__*/ markType(HeaderDescription, 'HeaderDescription', DefinitionBaseDescription.$);
    HeaderDescription.__canMarshalByValue = true;
    HeaderDescription.__marshalByValueAlias = "Header";
    return HeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextHeaderDescription = /*@__PURE__*/ (() => {
    class TextHeaderDescription extends HeaderDescription {
        get_type() {
            return "TextHeader";
        }
        constructor() {
            super();
        }
    }
    TextHeaderDescription.$t = /*@__PURE__*/ markType(TextHeaderDescription, 'TextHeaderDescription', HeaderDescription.$);
    TextHeaderDescription.__canMarshalByValue1 = true;
    TextHeaderDescription.__marshalByValueAlias1 = "TextHeader";
    return TextHeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextHeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class TextHeaderDescriptionMetadata extends Base {
        static b(a) {
            if (TextHeaderDescriptionMetadata.a == null) {
                TextHeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TextHeaderDescriptionMetadata.c(TextHeaderDescriptionMetadata.a);
            }
            if (a.k(TextHeaderDescriptionMetadata.a)) {
                return;
            }
            a.ac(TextHeaderDescriptionMetadata.a);
        }
        static c(a) {
            HeaderDescriptionMetadata.c(a);
        }
        static d(a) {
            TextHeaderDescriptionMetadata.b(a);
            a.ae("TextHeader", () => new TextHeaderDescription());
            a.ad("TextHeader", TextHeaderDescriptionMetadata.a);
        }
    }
    TextHeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(TextHeaderDescriptionMetadata, 'TextHeaderDescriptionMetadata');
    TextHeaderDescriptionMetadata.a = null;
    return TextHeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextHeaderDescriptionModule = /*@__PURE__*/ (() => {
    class TextHeaderDescriptionModule extends Base {
        static register(a) {
            TextHeaderDescriptionMetadata.d(a);
        }
    }
    TextHeaderDescriptionModule.$t = /*@__PURE__*/ markType(TextHeaderDescriptionModule, 'TextHeaderDescriptionModule');
    return TextHeaderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionHeaderDescription = /*@__PURE__*/ (() => {
    class SectionHeaderDescription extends DefinitionBaseDescription {
        get_type() {
            return "SectionHeader";
        }
        constructor() {
            super();
            this.cf = null;
            this.ce = null;
            this.b7 = 0;
            this.b9 = 0;
            this.b8 = 0;
            this.b6 = 0;
            this.b4 = false;
            this.cg = null;
        }
        get selectedBackground() {
            return this.cf;
        }
        set selectedBackground(a) {
            this.cf = a;
            this.g("SelectedBackground");
        }
        get actualSelectedBackground() {
            return this.ce;
        }
        set actualSelectedBackground(a) {
            this.ce = a;
            this.g("ActualSelectedBackground");
        }
        get paddingLeft() {
            return this.b7;
        }
        set paddingLeft(a) {
            this.b7 = a;
            this.g("PaddingLeft");
        }
        get paddingTop() {
            return this.b9;
        }
        set paddingTop(a) {
            this.b9 = a;
            this.g("PaddingTop");
        }
        get paddingRight() {
            return this.b8;
        }
        set paddingRight(a) {
            this.b8 = a;
            this.g("PaddingRight");
        }
        get paddingBottom() {
            return this.b6;
        }
        set paddingBottom(a) {
            this.b6 = a;
            this.g("PaddingBottom");
        }
        get isCollapsable() {
            return this.b4;
        }
        set isCollapsable(a) {
            this.b4 = a;
            this.g("IsCollapsable");
        }
        get summaryDisplayMode() {
            return this.cg;
        }
        set summaryDisplayMode(a) {
            this.cg = a;
            this.g("SummaryDisplayMode");
        }
    }
    SectionHeaderDescription.$t = /*@__PURE__*/ markType(SectionHeaderDescription, 'SectionHeaderDescription', DefinitionBaseDescription.$);
    return SectionHeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionHeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class SectionHeaderDescriptionMetadata extends Base {
        static b(a) {
            if (SectionHeaderDescriptionMetadata.a == null) {
                SectionHeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SectionHeaderDescriptionMetadata.c(SectionHeaderDescriptionMetadata.a);
            }
            if (a.k(SectionHeaderDescriptionMetadata.a)) {
                return;
            }
            a.ac(SectionHeaderDescriptionMetadata.a);
        }
        static c(a) {
            DefinitionBaseDescriptionMetadata.c(a);
            a.item("SelectedBackground", "Brush");
            a.item("ActualSelectedBackground", "Brush");
            a.item("PaddingLeft", "Number:int");
            a.item("PaddingTop", "Number:int");
            a.item("PaddingRight", "Number:int");
            a.item("PaddingBottom", "Number:int");
            a.item("IsCollapsable", "Boolean");
            a.item("SummaryDisplayMode", "ExportedType:string:GroupSummaryDisplayMode");
            a.item("SummaryDisplayMode@names", "List;Cells;RowTop;RowBottom;None");
        }
        static d(a) {
            SectionHeaderDescriptionMetadata.b(a);
            a.ae("SectionHeader", () => new SectionHeaderDescription());
            a.ad("SectionHeader", SectionHeaderDescriptionMetadata.a);
        }
    }
    SectionHeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(SectionHeaderDescriptionMetadata, 'SectionHeaderDescriptionMetadata');
    SectionHeaderDescriptionMetadata.a = null;
    return SectionHeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionHeaderDescriptionModule = /*@__PURE__*/ (() => {
    class SectionHeaderDescriptionModule extends Base {
        static register(a) {
            SectionHeaderDescriptionMetadata.d(a);
        }
    }
    SectionHeaderDescriptionModule.$t = /*@__PURE__*/ markType(SectionHeaderDescriptionModule, 'SectionHeaderDescriptionModule');
    return SectionHeaderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RowSeparatorDescription = /*@__PURE__*/ (() => {
    class RowSeparatorDescription extends DefinitionBaseDescription {
        get_type() {
            return "RowSeparator";
        }
        constructor() {
            super();
        }
    }
    RowSeparatorDescription.$t = /*@__PURE__*/ markType(RowSeparatorDescription, 'RowSeparatorDescription', DefinitionBaseDescription.$);
    return RowSeparatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RowSeparatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class RowSeparatorDescriptionMetadata extends Base {
        static b(a) {
            if (RowSeparatorDescriptionMetadata.a == null) {
                RowSeparatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RowSeparatorDescriptionMetadata.c(RowSeparatorDescriptionMetadata.a);
            }
            if (a.k(RowSeparatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(RowSeparatorDescriptionMetadata.a);
        }
        static c(a) {
            DefinitionBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            RowSeparatorDescriptionMetadata.b(a);
            a.ae("RowSeparator", () => new RowSeparatorDescription());
            a.ad("RowSeparator", RowSeparatorDescriptionMetadata.a);
        }
    }
    RowSeparatorDescriptionMetadata.$t = /*@__PURE__*/ markType(RowSeparatorDescriptionMetadata, 'RowSeparatorDescriptionMetadata');
    RowSeparatorDescriptionMetadata.a = null;
    return RowSeparatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RowSeparatorDescriptionModule = /*@__PURE__*/ (() => {
    class RowSeparatorDescriptionModule extends Base {
        static register(a) {
            RowSeparatorDescriptionMetadata.d(a);
        }
    }
    RowSeparatorDescriptionModule.$t = /*@__PURE__*/ markType(RowSeparatorDescriptionModule, 'RowSeparatorDescriptionModule');
    return RowSeparatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderSeparatorDescription = /*@__PURE__*/ (() => {
    class HeaderSeparatorDescription extends DefinitionBaseDescription {
        get_type() {
            return "HeaderSeparator";
        }
        constructor() {
            super();
        }
    }
    HeaderSeparatorDescription.$t = /*@__PURE__*/ markType(HeaderSeparatorDescription, 'HeaderSeparatorDescription', DefinitionBaseDescription.$);
    return HeaderSeparatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderSeparatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class HeaderSeparatorDescriptionMetadata extends Base {
        static b(a) {
            if (HeaderSeparatorDescriptionMetadata.a == null) {
                HeaderSeparatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HeaderSeparatorDescriptionMetadata.c(HeaderSeparatorDescriptionMetadata.a);
            }
            if (a.k(HeaderSeparatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(HeaderSeparatorDescriptionMetadata.a);
        }
        static c(a) {
            DefinitionBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            HeaderSeparatorDescriptionMetadata.b(a);
            a.ae("HeaderSeparator", () => new HeaderSeparatorDescription());
            a.ad("HeaderSeparator", HeaderSeparatorDescriptionMetadata.a);
        }
    }
    HeaderSeparatorDescriptionMetadata.$t = /*@__PURE__*/ markType(HeaderSeparatorDescriptionMetadata, 'HeaderSeparatorDescriptionMetadata');
    HeaderSeparatorDescriptionMetadata.a = null;
    return HeaderSeparatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderSeparatorDescriptionModule = /*@__PURE__*/ (() => {
    class HeaderSeparatorDescriptionModule extends Base {
        static register(a) {
            HeaderSeparatorDescriptionMetadata.d(a);
        }
    }
    HeaderSeparatorDescriptionModule.$t = /*@__PURE__*/ markType(HeaderSeparatorDescriptionModule, 'HeaderSeparatorDescriptionModule');
    return HeaderSeparatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnResizingSeparatorDescription = /*@__PURE__*/ (() => {
    class ColumnResizingSeparatorDescription extends DefinitionBaseDescription {
        get_type() {
            return "ColumnResizingSeparator";
        }
        constructor() {
            super();
            this.b4 = 0;
            this.b5 = 0;
        }
        get actualOpacity() {
            return this.b4;
        }
        set actualOpacity(a) {
            this.b4 = a;
            this.g("ActualOpacity");
        }
        get opacity() {
            return this.b5;
        }
        set opacity(a) {
            this.b5 = a;
            this.g("Opacity");
        }
    }
    ColumnResizingSeparatorDescription.$t = /*@__PURE__*/ markType(ColumnResizingSeparatorDescription, 'ColumnResizingSeparatorDescription', DefinitionBaseDescription.$);
    return ColumnResizingSeparatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnResizingSeparatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnResizingSeparatorDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnResizingSeparatorDescriptionMetadata.a == null) {
                ColumnResizingSeparatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnResizingSeparatorDescriptionMetadata.c(ColumnResizingSeparatorDescriptionMetadata.a);
            }
            if (a.k(ColumnResizingSeparatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnResizingSeparatorDescriptionMetadata.a);
        }
        static c(a) {
            DefinitionBaseDescriptionMetadata.c(a);
            a.item("ActualOpacity", "Number:double");
            a.item("Opacity", "Number:double");
        }
        static d(a) {
            ColumnResizingSeparatorDescriptionMetadata.b(a);
            a.ae("ColumnResizingSeparator", () => new ColumnResizingSeparatorDescription());
            a.ad("ColumnResizingSeparator", ColumnResizingSeparatorDescriptionMetadata.a);
        }
    }
    ColumnResizingSeparatorDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnResizingSeparatorDescriptionMetadata, 'ColumnResizingSeparatorDescriptionMetadata');
    ColumnResizingSeparatorDescriptionMetadata.a = null;
    return ColumnResizingSeparatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnResizingSeparatorDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnResizingSeparatorDescriptionModule extends Base {
        static register(a) {
            ColumnResizingSeparatorDescriptionMetadata.d(a);
        }
    }
    ColumnResizingSeparatorDescriptionModule.$t = /*@__PURE__*/ markType(ColumnResizingSeparatorDescriptionModule, 'ColumnResizingSeparatorDescriptionModule');
    return ColumnResizingSeparatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnMovingSeparatorDescription = /*@__PURE__*/ (() => {
    class ColumnMovingSeparatorDescription extends DefinitionBaseDescription {
        get_type() {
            return "ColumnMovingSeparator";
        }
        constructor() {
            super();
            this.b8 = 0;
            this.b4 = 0;
            this.b5 = 0;
        }
        get separatorWidth() {
            return this.b8;
        }
        set separatorWidth(a) {
            this.b8 = a;
            this.g("SeparatorWidth");
        }
        get actualOpacity() {
            return this.b4;
        }
        set actualOpacity(a) {
            this.b4 = a;
            this.g("ActualOpacity");
        }
        get opacity() {
            return this.b5;
        }
        set opacity(a) {
            this.b5 = a;
            this.g("Opacity");
        }
    }
    ColumnMovingSeparatorDescription.$t = /*@__PURE__*/ markType(ColumnMovingSeparatorDescription, 'ColumnMovingSeparatorDescription', DefinitionBaseDescription.$);
    return ColumnMovingSeparatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnMovingSeparatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnMovingSeparatorDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnMovingSeparatorDescriptionMetadata.a == null) {
                ColumnMovingSeparatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnMovingSeparatorDescriptionMetadata.c(ColumnMovingSeparatorDescriptionMetadata.a);
            }
            if (a.k(ColumnMovingSeparatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnMovingSeparatorDescriptionMetadata.a);
        }
        static c(a) {
            DefinitionBaseDescriptionMetadata.c(a);
            a.item("SeparatorWidth", "Number:int");
            a.item("ActualOpacity", "Number:double");
            a.item("Opacity", "Number:double");
        }
        static d(a) {
            ColumnMovingSeparatorDescriptionMetadata.b(a);
            a.ae("ColumnMovingSeparator", () => new ColumnMovingSeparatorDescription());
            a.ad("ColumnMovingSeparator", ColumnMovingSeparatorDescriptionMetadata.a);
        }
    }
    ColumnMovingSeparatorDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnMovingSeparatorDescriptionMetadata, 'ColumnMovingSeparatorDescriptionMetadata');
    ColumnMovingSeparatorDescriptionMetadata.a = null;
    return ColumnMovingSeparatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnMovingSeparatorDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnMovingSeparatorDescriptionModule extends Base {
        static register(a) {
            ColumnMovingSeparatorDescriptionMetadata.d(a);
        }
    }
    ColumnMovingSeparatorDescriptionModule.$t = /*@__PURE__*/ markType(ColumnMovingSeparatorDescriptionModule, 'ColumnMovingSeparatorDescriptionModule');
    return ColumnMovingSeparatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowDescriptionMetadata = /*@__PURE__*/ (() => {
    class SummaryRowDescriptionMetadata extends Base {
        static b(a) {
            if (SummaryRowDescriptionMetadata.a == null) {
                SummaryRowDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SummaryRowDescriptionMetadata.c(SummaryRowDescriptionMetadata.a);
            }
            if (a.k(SummaryRowDescriptionMetadata.a)) {
                return;
            }
            a.ac(SummaryRowDescriptionMetadata.a);
        }
        static c(a) {
            DefinitionBaseDescriptionMetadata.c(a);
            a.item("SelectedBackground", "Brush");
            a.item("ActualSelectedBackground", "Brush");
            a.item("SummaryLabelTextColor", "Brush");
            a.item("ActualSummaryLabelTextColor", "Brush");
            a.item("SummaryLabelFontFamily", "(w:SummaryLabelFontFamily/FontFamilyTransform,xam:SummaryLabelFontFamily,wf:SummaryLabelFontFamily,web:summaryNameTextStyle/FontFamilyTransform)String");
            a.item("SummaryLabelFontSize", "(w:SummaryLabelFontSize,xam:SummaryLabelFontSize,wf:SummaryLabelFontSize,web:summaryNameTextStyle/FontSizeTransform)Number:double");
            a.item("SummaryLabelFontStyle", "(w:SummaryLabelFontStyle/FontStyleTransform,xam:SummaryLabelFontFamily/FontStyleTransform,wf:SummaryLabelFontFamily/FontStyleTransform,web:summaryNameTextStyle/FontStyleTransform)String");
            a.item("SummaryLabelFontWeight", "(w:SummaryLabelFontWeight/FontWeightTransform,xam:SummaryLabelFontFamily/FontWeightTransform,wf:SummaryLabelFontFamily/FontWeightTransform,web:summaryNameTextStyle/FontWeightTransform)String");
            a.item("PaddingLeft", "Number:int");
            a.item("PaddingTop", "Number:int");
            a.item("PaddingRight", "Number:int");
            a.item("PaddingBottom", "Number:int");
        }
        static d(a) {
            SummaryRowDescriptionMetadata.b(a);
            a.ad("SummaryRow", SummaryRowDescriptionMetadata.a);
        }
    }
    SummaryRowDescriptionMetadata.$t = /*@__PURE__*/ markType(SummaryRowDescriptionMetadata, 'SummaryRowDescriptionMetadata');
    SummaryRowDescriptionMetadata.a = null;
    return SummaryRowDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowDescription = /*@__PURE__*/ (() => {
    class SummaryRowDescription extends DefinitionBaseDescription {
        get_type() {
            return "SummaryRow";
        }
        constructor() {
            super();
            this.cg = null;
            this.ce = null;
            this.ck = null;
            this.cf = null;
            this.ch = null;
            this.b4 = 0;
            this.ci = null;
            this.cj = null;
            this.b7 = 0;
            this.b9 = 0;
            this.b8 = 0;
            this.b6 = 0;
        }
        get selectedBackground() {
            return this.cg;
        }
        set selectedBackground(a) {
            this.cg = a;
            this.g("SelectedBackground");
        }
        get actualSelectedBackground() {
            return this.ce;
        }
        set actualSelectedBackground(a) {
            this.ce = a;
            this.g("ActualSelectedBackground");
        }
        get summaryLabelTextColor() {
            return this.ck;
        }
        set summaryLabelTextColor(a) {
            this.ck = a;
            this.g("SummaryLabelTextColor");
        }
        get actualSummaryLabelTextColor() {
            return this.cf;
        }
        set actualSummaryLabelTextColor(a) {
            this.cf = a;
            this.g("ActualSummaryLabelTextColor");
        }
        get summaryLabelFontFamily() {
            return this.ch;
        }
        set summaryLabelFontFamily(a) {
            this.ch = a;
            this.g("SummaryLabelFontFamily");
        }
        get summaryLabelFontSize() {
            return this.b4;
        }
        set summaryLabelFontSize(a) {
            this.b4 = a;
            this.g("SummaryLabelFontSize");
        }
        get summaryLabelFontStyle() {
            return this.ci;
        }
        set summaryLabelFontStyle(a) {
            this.ci = a;
            this.g("SummaryLabelFontStyle");
        }
        get summaryLabelFontWeight() {
            return this.cj;
        }
        set summaryLabelFontWeight(a) {
            this.cj = a;
            this.g("SummaryLabelFontWeight");
        }
        get paddingLeft() {
            return this.b7;
        }
        set paddingLeft(a) {
            this.b7 = a;
            this.g("PaddingLeft");
        }
        get paddingTop() {
            return this.b9;
        }
        set paddingTop(a) {
            this.b9 = a;
            this.g("PaddingTop");
        }
        get paddingRight() {
            return this.b8;
        }
        set paddingRight(a) {
            this.b8 = a;
            this.g("PaddingRight");
        }
        get paddingBottom() {
            return this.b6;
        }
        set paddingBottom(a) {
            this.b6 = a;
            this.g("PaddingBottom");
        }
    }
    SummaryRowDescription.$t = /*@__PURE__*/ markType(SummaryRowDescription, 'SummaryRowDescription', DefinitionBaseDescription.$);
    return SummaryRowDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowRootDescription = /*@__PURE__*/ (() => {
    class SummaryRowRootDescription extends SummaryRowDescription {
        get_type() {
            return "SummaryRowRoot";
        }
        constructor() {
            super();
        }
    }
    SummaryRowRootDescription.$t = /*@__PURE__*/ markType(SummaryRowRootDescription, 'SummaryRowRootDescription', SummaryRowDescription.$);
    return SummaryRowRootDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowRootDescriptionMetadata = /*@__PURE__*/ (() => {
    class SummaryRowRootDescriptionMetadata extends Base {
        static b(a) {
            if (SummaryRowRootDescriptionMetadata.a == null) {
                SummaryRowRootDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SummaryRowRootDescriptionMetadata.c(SummaryRowRootDescriptionMetadata.a);
            }
            if (a.k(SummaryRowRootDescriptionMetadata.a)) {
                return;
            }
            a.ac(SummaryRowRootDescriptionMetadata.a);
        }
        static c(a) {
            SummaryRowDescriptionMetadata.c(a);
        }
        static d(a) {
            SummaryRowRootDescriptionMetadata.b(a);
            a.ae("SummaryRowRoot", () => new SummaryRowRootDescription());
            a.ad("SummaryRowRoot", SummaryRowRootDescriptionMetadata.a);
        }
    }
    SummaryRowRootDescriptionMetadata.$t = /*@__PURE__*/ markType(SummaryRowRootDescriptionMetadata, 'SummaryRowRootDescriptionMetadata');
    SummaryRowRootDescriptionMetadata.a = null;
    return SummaryRowRootDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowRootDescriptionModule = /*@__PURE__*/ (() => {
    class SummaryRowRootDescriptionModule extends Base {
        static register(a) {
            SummaryRowRootDescriptionMetadata.d(a);
        }
    }
    SummaryRowRootDescriptionModule.$t = /*@__PURE__*/ markType(SummaryRowRootDescriptionModule, 'SummaryRowRootDescriptionModule');
    return SummaryRowRootDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowSectionDescription = /*@__PURE__*/ (() => {
    class SummaryRowSectionDescription extends SummaryRowDescription {
        get_type() {
            return "SummaryRowSection";
        }
        constructor() {
            super();
        }
    }
    SummaryRowSectionDescription.$t = /*@__PURE__*/ markType(SummaryRowSectionDescription, 'SummaryRowSectionDescription', SummaryRowDescription.$);
    return SummaryRowSectionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowSectionDescriptionMetadata = /*@__PURE__*/ (() => {
    class SummaryRowSectionDescriptionMetadata extends Base {
        static b(a) {
            if (SummaryRowSectionDescriptionMetadata.a == null) {
                SummaryRowSectionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SummaryRowSectionDescriptionMetadata.c(SummaryRowSectionDescriptionMetadata.a);
            }
            if (a.k(SummaryRowSectionDescriptionMetadata.a)) {
                return;
            }
            a.ac(SummaryRowSectionDescriptionMetadata.a);
        }
        static c(a) {
            SummaryRowDescriptionMetadata.c(a);
        }
        static d(a) {
            SummaryRowSectionDescriptionMetadata.b(a);
            a.ae("SummaryRowSection", () => new SummaryRowSectionDescription());
            a.ad("SummaryRowSection", SummaryRowSectionDescriptionMetadata.a);
        }
    }
    SummaryRowSectionDescriptionMetadata.$t = /*@__PURE__*/ markType(SummaryRowSectionDescriptionMetadata, 'SummaryRowSectionDescriptionMetadata');
    SummaryRowSectionDescriptionMetadata.a = null;
    return SummaryRowSectionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowSectionDescriptionModule = /*@__PURE__*/ (() => {
    class SummaryRowSectionDescriptionModule extends Base {
        static register(a) {
            SummaryRowSectionDescriptionMetadata.d(a);
        }
    }
    SummaryRowSectionDescriptionModule.$t = /*@__PURE__*/ markType(SummaryRowSectionDescriptionModule, 'SummaryRowSectionDescriptionModule');
    return SummaryRowSectionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnWidthDescription = /*@__PURE__*/ (() => {
    class ColumnWidthDescription extends Description {
        get_type() {
            return "ColumnWidth";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = false;
            this.l = 0;
            this.k = 0;
        }
        get isStarSized() {
            return this.i;
        }
        set isStarSized(a) {
            this.i = a;
            this.g("IsStarSized");
        }
        get value() {
            return this.l;
        }
        set value(a) {
            this.l = a;
            this.g("Value");
        }
        get minimumWidth() {
            return this.k;
        }
        set minimumWidth(a) {
            this.k = a;
            this.g("MinimumWidth");
        }
    }
    ColumnWidthDescription.$t = /*@__PURE__*/ markType(ColumnWidthDescription, 'ColumnWidthDescription', Description.$);
    ColumnWidthDescription.__marshalByValue = true;
    ColumnWidthDescription.__marshalByValueAlias = "ColumnWidth";
    return ColumnWidthDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnWidthDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnWidthDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnWidthDescriptionMetadata.a == null) {
                ColumnWidthDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnWidthDescriptionMetadata.c(ColumnWidthDescriptionMetadata.a);
            }
            if (a.k(ColumnWidthDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnWidthDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("IsStarSized", "Boolean");
            a.item("Value", "Number:double");
            a.item("MinimumWidth", "Number:double");
        }
        static d(a) {
            ColumnWidthDescriptionMetadata.b(a);
            a.ae("ColumnWidth", () => new ColumnWidthDescription());
            a.ad("ColumnWidth", ColumnWidthDescriptionMetadata.a);
        }
    }
    ColumnWidthDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnWidthDescriptionMetadata, 'ColumnWidthDescriptionMetadata');
    ColumnWidthDescriptionMetadata.a = null;
    return ColumnWidthDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnWidthDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnWidthDescriptionModule extends Base {
        static register(a) {
            ColumnWidthDescriptionMetadata.d(a);
        }
    }
    ColumnWidthDescriptionModule.$t = /*@__PURE__*/ markType(ColumnWidthDescriptionModule, 'ColumnWidthDescriptionModule');
    return ColumnWidthDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSortDescriptionDescription = /*@__PURE__*/ (() => {
    class ColumnSortDescriptionDescription extends Description {
        get_type() {
            return "ColumnSortDescription";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.k = null;
        }
        get field() {
            return this.j;
        }
        set field(a) {
            this.j = a;
            this.g("Field");
        }
        get sortDirection() {
            return this.k;
        }
        set sortDirection(a) {
            this.k = a;
            this.g("SortDirection");
        }
    }
    ColumnSortDescriptionDescription.$t = /*@__PURE__*/ markType(ColumnSortDescriptionDescription, 'ColumnSortDescriptionDescription', Description.$);
    ColumnSortDescriptionDescription.__marshalByValue = true;
    ColumnSortDescriptionDescription.__marshalByValueAlias = "ColumnSortDescription";
    return ColumnSortDescriptionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSortDescriptionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnSortDescriptionDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnSortDescriptionDescriptionMetadata.a == null) {
                ColumnSortDescriptionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnSortDescriptionDescriptionMetadata.c(ColumnSortDescriptionDescriptionMetadata.a);
            }
            if (a.k(ColumnSortDescriptionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnSortDescriptionDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("Field", "String");
            a.item("SortDirection", "ExportedType:string:ListSortDirection");
            a.item("SortDirection@names", "Ascending;Descending");
        }
        static d(a) {
            ColumnSortDescriptionDescriptionMetadata.b(a);
            a.ae("ColumnSortDescription", () => new ColumnSortDescriptionDescription());
            a.ad("ColumnSortDescription", ColumnSortDescriptionDescriptionMetadata.a);
        }
    }
    ColumnSortDescriptionDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnSortDescriptionDescriptionMetadata, 'ColumnSortDescriptionDescriptionMetadata');
    ColumnSortDescriptionDescriptionMetadata.a = null;
    return ColumnSortDescriptionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSortDescriptionDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnSortDescriptionDescriptionModule extends Base {
        static register(a) {
            ColumnSortDescriptionDescriptionMetadata.d(a);
        }
    }
    ColumnSortDescriptionDescriptionModule.$t = /*@__PURE__*/ markType(ColumnSortDescriptionDescriptionModule, 'ColumnSortDescriptionDescriptionModule');
    return ColumnSortDescriptionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatGroupTextEventArgsDescription = /*@__PURE__*/ (() => {
    class FormatGroupTextEventArgsDescription extends Description {
        get_type() {
            return "FormatGroupTextEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.k = null;
            this.i = null;
            this.h = null;
        }
        get groupName() {
            return this.j;
        }
        set groupName(a) {
            this.j = a;
            this.g("GroupName");
        }
        get groupValueRef() {
            return this.k;
        }
        set groupValueRef(a) {
            this.k = a;
            this.g("GroupValueRef");
        }
        get formattedValue() {
            return this.i;
        }
        set formattedValue(a) {
            this.i = a;
            this.g("FormattedValue");
        }
        get formattedText() {
            return this.h;
        }
        set formattedText(a) {
            this.h = a;
            this.g("FormattedText");
        }
    }
    FormatGroupTextEventArgsDescription.$t = /*@__PURE__*/ markType(FormatGroupTextEventArgsDescription, 'FormatGroupTextEventArgsDescription', Description.$);
    return FormatGroupTextEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatGroupTextEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FormatGroupTextEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FormatGroupTextEventArgsDescriptionMetadata.a == null) {
                FormatGroupTextEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FormatGroupTextEventArgsDescriptionMetadata.c(FormatGroupTextEventArgsDescriptionMetadata.a);
            }
            if (a.k(FormatGroupTextEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(FormatGroupTextEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("GroupName", "String");
            a.item("GroupValueRef", "(w:GroupValue,wf:GroupValue)DataRef");
            a.item("FormattedValue", "String");
            a.item("FormattedText", "String");
        }
        static d(a) {
            FormatGroupTextEventArgsDescriptionMetadata.b(a);
            a.ae("FormatGroupTextEventArgs", () => new FormatGroupTextEventArgsDescription());
            a.ad("FormatGroupTextEventArgs", FormatGroupTextEventArgsDescriptionMetadata.a);
        }
    }
    FormatGroupTextEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FormatGroupTextEventArgsDescriptionMetadata, 'FormatGroupTextEventArgsDescriptionMetadata');
    FormatGroupTextEventArgsDescriptionMetadata.a = null;
    return FormatGroupTextEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnGroupDescriptionDescription = /*@__PURE__*/ (() => {
    class ColumnGroupDescriptionDescription extends ColumnSortDescriptionDescription {
        get_type() {
            return "ColumnGroupDescription";
        }
        constructor() {
            super();
            this.x = null;
            this.p = null;
            this.u = null;
            this.o = null;
            this.v = null;
            this.w = null;
        }
        get valueFormat() {
            return this.x;
        }
        set valueFormat(a) {
            this.x = a;
            this.g("ValueFormat");
        }
        get valueFormatSpecifiers() {
            return this.p;
        }
        set valueFormatSpecifiers(a) {
            this.p = a;
            this.g("ValueFormatSpecifiers");
        }
        get displayFormat() {
            return this.u;
        }
        set displayFormat(a) {
            this.u = a;
            this.g("DisplayFormat");
        }
        get displayFormatSpecifiers() {
            return this.o;
        }
        set displayFormatSpecifiers(a) {
            this.o = a;
            this.g("DisplayFormatSpecifiers");
        }
        get displayName() {
            return this.v;
        }
        set displayName(a) {
            this.v = a;
            this.g("DisplayName");
        }
        get formatTextRef() {
            return this.w;
        }
        set formatTextRef(a) {
            this.w = a;
            this.g("FormatTextRef");
        }
    }
    ColumnGroupDescriptionDescription.$t = /*@__PURE__*/ markType(ColumnGroupDescriptionDescription, 'ColumnGroupDescriptionDescription', ColumnSortDescriptionDescription.$);
    ColumnGroupDescriptionDescription.__marshalByValue1 = true;
    ColumnGroupDescriptionDescription.__marshalByValueAlias1 = "ColumnGroupDescription";
    return ColumnGroupDescriptionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnGroupDescriptionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnGroupDescriptionDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnGroupDescriptionDescriptionMetadata.a == null) {
                ColumnGroupDescriptionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnGroupDescriptionDescriptionMetadata.c(ColumnGroupDescriptionDescriptionMetadata.a);
            }
            if (a.k(ColumnGroupDescriptionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnGroupDescriptionDescriptionMetadata.a);
            FormatGroupTextEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            ColumnSortDescriptionDescriptionMetadata.c(a);
            a.item("__marshalByValue", "Boolean");
            a.item("ValueFormat", "String");
            a.item("ValueFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("ValueFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("DisplayFormat", "String");
            a.item("DisplayFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("DisplayFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("DisplayName", "String");
            a.item("FormatTextRef", "EventRef::formatText");
        }
        static d(a) {
            ColumnGroupDescriptionDescriptionMetadata.b(a);
            a.ae("ColumnGroupDescription", () => new ColumnGroupDescriptionDescription());
            a.ad("ColumnGroupDescription", ColumnGroupDescriptionDescriptionMetadata.a);
        }
    }
    ColumnGroupDescriptionDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnGroupDescriptionDescriptionMetadata, 'ColumnGroupDescriptionDescriptionMetadata');
    ColumnGroupDescriptionDescriptionMetadata.a = null;
    return ColumnGroupDescriptionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnGroupDescriptionDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnGroupDescriptionDescriptionModule extends Base {
        static register(a) {
            ColumnSortDescriptionDescriptionModule.register(a);
            ColumnGroupDescriptionDescriptionMetadata.d(a);
        }
    }
    ColumnGroupDescriptionDescriptionModule.$t = /*@__PURE__*/ markType(ColumnGroupDescriptionDescriptionModule, 'ColumnGroupDescriptionDescriptionModule');
    return ColumnGroupDescriptionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatSummaryTextEventArgsDescription = /*@__PURE__*/ (() => {
    class FormatSummaryTextEventArgsDescription extends Description {
        get_type() {
            return "FormatSummaryTextEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
            this.l = null;
            this.j = null;
            this.k = null;
        }
        get field() {
            return this.i;
        }
        set field(a) {
            this.i = a;
            this.g("Field");
        }
        get displayName() {
            return this.h;
        }
        set displayName(a) {
            this.h = a;
            this.g("DisplayName");
        }
        get summaryResultRef() {
            return this.l;
        }
        set summaryResultRef(a) {
            this.l = a;
            this.g("SummaryResultRef");
        }
        get formattedResult() {
            return this.j;
        }
        set formattedResult(a) {
            this.j = a;
            this.g("FormattedResult");
        }
        get formattedText() {
            return this.k;
        }
        set formattedText(a) {
            this.k = a;
            this.g("FormattedText");
        }
    }
    FormatSummaryTextEventArgsDescription.$t = /*@__PURE__*/ markType(FormatSummaryTextEventArgsDescription, 'FormatSummaryTextEventArgsDescription', Description.$);
    return FormatSummaryTextEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatSummaryTextEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FormatSummaryTextEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FormatSummaryTextEventArgsDescriptionMetadata.a == null) {
                FormatSummaryTextEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FormatSummaryTextEventArgsDescriptionMetadata.c(FormatSummaryTextEventArgsDescriptionMetadata.a);
            }
            if (a.k(FormatSummaryTextEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(FormatSummaryTextEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Field", "String");
            a.item("DisplayName", "String");
            a.item("SummaryResultRef", "(w:SummaryResult,wf:SummaryResult)DataRef");
            a.item("FormattedResult", "String");
            a.item("FormattedText", "String");
        }
        static d(a) {
            FormatSummaryTextEventArgsDescriptionMetadata.b(a);
            a.ae("FormatSummaryTextEventArgs", () => new FormatSummaryTextEventArgsDescription());
            a.ad("FormatSummaryTextEventArgs", FormatSummaryTextEventArgsDescriptionMetadata.a);
        }
    }
    FormatSummaryTextEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FormatSummaryTextEventArgsDescriptionMetadata, 'FormatSummaryTextEventArgsDescriptionMetadata');
    FormatSummaryTextEventArgsDescriptionMetadata.a = null;
    return FormatSummaryTextEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSummaryDescriptionDescription = /*@__PURE__*/ (() => {
    class ColumnSummaryDescriptionDescription extends Description {
        get_type() {
            return "ColumnSummaryDescription";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.s = null;
            this.u = null;
            this.p = null;
            this.r = null;
            this.w = null;
            this.i = null;
            this.q = null;
            this.h = null;
            this.m = 0;
            this.t = null;
            this.v = null;
        }
        get field() {
            return this.s;
        }
        set field(a) {
            this.s = a;
            this.g("Field");
        }
        get operand() {
            return this.u;
        }
        set operand(a) {
            this.u = a;
            this.g("Operand");
        }
        get calculatorDisplayName() {
            return this.p;
        }
        set calculatorDisplayName(a) {
            this.p = a;
            this.g("CalculatorDisplayName");
        }
        get displayName() {
            return this.r;
        }
        set displayName(a) {
            this.r = a;
            this.g("DisplayName");
        }
        get valueFormat() {
            return this.w;
        }
        set valueFormat(a) {
            this.w = a;
            this.g("ValueFormat");
        }
        get valueFormatSpecifiers() {
            return this.i;
        }
        set valueFormatSpecifiers(a) {
            this.i = a;
            this.g("ValueFormatSpecifiers");
        }
        get displayFormat() {
            return this.q;
        }
        set displayFormat(a) {
            this.q = a;
            this.g("DisplayFormat");
        }
        get displayFormatSpecifiers() {
            return this.h;
        }
        set displayFormatSpecifiers(a) {
            this.h = a;
            this.g("DisplayFormatSpecifiers");
        }
        get maxFractionDigits() {
            return this.m;
        }
        set maxFractionDigits(a) {
            this.m = a;
            this.g("MaxFractionDigits");
        }
        get formatTextRef() {
            return this.t;
        }
        set formatTextRef(a) {
            this.t = a;
            this.g("FormatTextRef");
        }
        get provideCalculatorRef() {
            return this.v;
        }
        set provideCalculatorRef(a) {
            this.v = a;
            this.g("ProvideCalculatorRef");
        }
    }
    ColumnSummaryDescriptionDescription.$t = /*@__PURE__*/ markType(ColumnSummaryDescriptionDescription, 'ColumnSummaryDescriptionDescription', Description.$);
    ColumnSummaryDescriptionDescription.__marshalByValue = true;
    ColumnSummaryDescriptionDescription.__marshalByValueAlias = "ColumnSummaryDescription";
    return ColumnSummaryDescriptionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSummaryDescriptionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnSummaryDescriptionDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnSummaryDescriptionDescriptionMetadata.a == null) {
                ColumnSummaryDescriptionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnSummaryDescriptionDescriptionMetadata.c(ColumnSummaryDescriptionDescriptionMetadata.a);
            }
            if (a.k(ColumnSummaryDescriptionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnSummaryDescriptionDescriptionMetadata.a);
            FormatSummaryTextEventArgsDescriptionMetadata.d(a);
            ProvideCalculatorEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("Field", "String");
            a.item("Operand", "ExportedType:string:DataSourceSummaryOperand");
            a.item("Operand@names", "Min;Max;Sum;Average;Count;Custom");
            a.item("CalculatorDisplayName", "String");
            a.item("DisplayName", "String");
            a.item("ValueFormat", "String");
            a.item("ValueFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("ValueFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("DisplayFormat", "String");
            a.item("DisplayFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("DisplayFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("MaxFractionDigits", "Number:int");
            a.item("FormatTextRef", "EventRef::formatText");
            a.item("ProvideCalculatorRef", "EventRef::provideCalculator");
        }
        static d(a) {
            ColumnSummaryDescriptionDescriptionMetadata.b(a);
            a.ae("ColumnSummaryDescription", () => new ColumnSummaryDescriptionDescription());
            a.ad("ColumnSummaryDescription", ColumnSummaryDescriptionDescriptionMetadata.a);
        }
    }
    ColumnSummaryDescriptionDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnSummaryDescriptionDescriptionMetadata, 'ColumnSummaryDescriptionDescriptionMetadata');
    ColumnSummaryDescriptionDescriptionMetadata.a = null;
    return ColumnSummaryDescriptionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSummaryDescriptionDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnSummaryDescriptionDescriptionModule extends Base {
        static register(a) {
            ColumnSummaryDescriptionDescriptionMetadata.d(a);
        }
    }
    ColumnSummaryDescriptionDescriptionModule.$t = /*@__PURE__*/ markType(ColumnSummaryDescriptionDescriptionModule, 'ColumnSummaryDescriptionDescriptionModule');
    return ColumnSummaryDescriptionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrimaryKeyValueDescriptionModule = /*@__PURE__*/ (() => {
    class PrimaryKeyValueDescriptionModule extends Base {
        static register(a) {
            PrimaryKeyValueDescriptionMetadata.d(a);
        }
    }
    PrimaryKeyValueDescriptionModule.$t = /*@__PURE__*/ markType(PrimaryKeyValueDescriptionModule, 'PrimaryKeyValueDescriptionModule');
    return PrimaryKeyValueDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellPositionDescription = /*@__PURE__*/ (() => {
    class GridCellPositionDescription extends Description {
        get_type() {
            return "GridCellPosition";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = 0;
            this.l = null;
        }
        get rowIndex() {
            return this.i;
        }
        set rowIndex(a) {
            this.i = a;
            this.g("RowIndex");
        }
        get columnUniqueKey() {
            return this.l;
        }
        set columnUniqueKey(a) {
            this.l = a;
            this.g("ColumnUniqueKey");
        }
    }
    GridCellPositionDescription.$t = /*@__PURE__*/ markType(GridCellPositionDescription, 'GridCellPositionDescription', Description.$);
    GridCellPositionDescription.__marshalByValue = true;
    GridCellPositionDescription.__marshalByValueAlias = "GridCellPosition";
    return GridCellPositionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellPositionDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridCellPositionDescriptionMetadata extends Base {
        static b(a) {
            if (GridCellPositionDescriptionMetadata.a == null) {
                GridCellPositionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridCellPositionDescriptionMetadata.c(GridCellPositionDescriptionMetadata.a);
            }
            if (a.k(GridCellPositionDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridCellPositionDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("RowIndex", "Number:int");
            a.item("ColumnUniqueKey", "String");
        }
        static d(a) {
            GridCellPositionDescriptionMetadata.b(a);
            a.ae("GridCellPosition", () => new GridCellPositionDescription());
            a.ad("GridCellPosition", GridCellPositionDescriptionMetadata.a);
        }
    }
    GridCellPositionDescriptionMetadata.$t = /*@__PURE__*/ markType(GridCellPositionDescriptionMetadata, 'GridCellPositionDescriptionMetadata');
    GridCellPositionDescriptionMetadata.a = null;
    return GridCellPositionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellPositionDescriptionModule = /*@__PURE__*/ (() => {
    class GridCellPositionDescriptionModule extends Base {
        static register(a) {
            GridCellPositionDescriptionMetadata.d(a);
        }
    }
    GridCellPositionDescriptionModule.$t = /*@__PURE__*/ markType(GridCellPositionDescriptionModule, 'GridCellPositionDescriptionModule');
    return GridCellPositionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LocalDataSourceDescription = /*@__PURE__*/ (() => {
    class LocalDataSourceDescription extends BaseDataSourceDescription {
        get_type() {
            return "LocalDataSource";
        }
        constructor() {
            super();
            this.ay = null;
        }
        get dataSourceRef() {
            return this.ay;
        }
        set dataSourceRef(a) {
            this.ay = a;
            this.g("DataSourceRef");
        }
    }
    LocalDataSourceDescription.$t = /*@__PURE__*/ markType(LocalDataSourceDescription, 'LocalDataSourceDescription', BaseDataSourceDescription.$);
    return LocalDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LocalDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class LocalDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (LocalDataSourceDescriptionMetadata.a == null) {
                LocalDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LocalDataSourceDescriptionMetadata.c(LocalDataSourceDescriptionMetadata.a);
            }
            if (a.k(LocalDataSourceDescriptionMetadata.a)) {
                return;
            }
            a.ac(LocalDataSourceDescriptionMetadata.a);
        }
        static c(a) {
            BaseDataSourceDescriptionMetadata.c(a);
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,j:dataSource,wf:ItemsSource)DataRef::object");
        }
        static d(a) {
            LocalDataSourceDescriptionMetadata.b(a);
            a.ae("LocalDataSource", () => new LocalDataSourceDescription());
            a.ad("LocalDataSource", LocalDataSourceDescriptionMetadata.a);
        }
    }
    LocalDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(LocalDataSourceDescriptionMetadata, 'LocalDataSourceDescriptionMetadata');
    LocalDataSourceDescriptionMetadata.a = null;
    return LocalDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class FilterExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (FilterExpressionDescriptionMetadata.a == null) {
                FilterExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FilterExpressionDescriptionMetadata.c(FilterExpressionDescriptionMetadata.a);
            }
            if (a.k(FilterExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(FilterExpressionDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
        }
        static d(a) {
            FilterExpressionDescriptionMetadata.b(a);
            a.ad("FilterExpression", FilterExpressionDescriptionMetadata.a);
        }
    }
    FilterExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(FilterExpressionDescriptionMetadata, 'FilterExpressionDescriptionMetadata');
    FilterExpressionDescriptionMetadata.a = null;
    return FilterExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterExpressionDescription = /*@__PURE__*/ (() => {
    class FilterExpressionDescription extends Description {
        get_type() {
            return "FilterExpression";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    FilterExpressionDescription.$t = /*@__PURE__*/ markType(FilterExpressionDescription, 'FilterExpressionDescription', Description.$);
    FilterExpressionDescription.__marshalByValue = true;
    FilterExpressionDescription.__marshalByValueAlias = "FilterExpression";
    return FilterExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LiteralFilterExpressionDescription = /*@__PURE__*/ (() => {
    class LiteralFilterExpressionDescription extends FilterExpressionDescription {
        get_type() {
            return "LiteralFilterExpression";
        }
        constructor() {
            super();
            this.n = null;
            this.l = false;
        }
        get literalValue() {
            return this.n;
        }
        set literalValue(a) {
            this.n = a;
            this.g("LiteralValue");
        }
        get leaveUnquoted() {
            return this.l;
        }
        set leaveUnquoted(a) {
            this.l = a;
            this.g("LeaveUnquoted");
        }
    }
    LiteralFilterExpressionDescription.$t = /*@__PURE__*/ markType(LiteralFilterExpressionDescription, 'LiteralFilterExpressionDescription', FilterExpressionDescription.$);
    LiteralFilterExpressionDescription.__marshalByValue1 = true;
    LiteralFilterExpressionDescription.__marshalByValueAlias1 = "LiteralFilterExpression";
    return LiteralFilterExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LiteralFilterExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class LiteralFilterExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (LiteralFilterExpressionDescriptionMetadata.a == null) {
                LiteralFilterExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LiteralFilterExpressionDescriptionMetadata.c(LiteralFilterExpressionDescriptionMetadata.a);
            }
            if (a.k(LiteralFilterExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(LiteralFilterExpressionDescriptionMetadata.a);
        }
        static c(a) {
            FilterExpressionDescriptionMetadata.c(a);
            a.item("LiteralValue", "Unknown");
            a.item("LeaveUnquoted", "Boolean");
        }
        static d(a) {
            LiteralFilterExpressionDescriptionMetadata.b(a);
            a.ae("LiteralFilterExpression", () => new LiteralFilterExpressionDescription());
            a.ad("LiteralFilterExpression", LiteralFilterExpressionDescriptionMetadata.a);
        }
    }
    LiteralFilterExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(LiteralFilterExpressionDescriptionMetadata, 'LiteralFilterExpressionDescriptionMetadata');
    LiteralFilterExpressionDescriptionMetadata.a = null;
    return LiteralFilterExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyReferenceFilterExpressionDescription = /*@__PURE__*/ (() => {
    class PropertyReferenceFilterExpressionDescription extends FilterExpressionDescription {
        get_type() {
            return "PropertyReferenceFilterExpression";
        }
        constructor() {
            super();
            this.m = null;
        }
        get propertyReference() {
            return this.m;
        }
        set propertyReference(a) {
            this.m = a;
            this.g("PropertyReference");
        }
    }
    PropertyReferenceFilterExpressionDescription.$t = /*@__PURE__*/ markType(PropertyReferenceFilterExpressionDescription, 'PropertyReferenceFilterExpressionDescription', FilterExpressionDescription.$);
    PropertyReferenceFilterExpressionDescription.__marshalByValue1 = true;
    PropertyReferenceFilterExpressionDescription.__marshalByValueAlias1 = "PropertyReferenceFilterExpression";
    return PropertyReferenceFilterExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyReferenceFilterExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyReferenceFilterExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyReferenceFilterExpressionDescriptionMetadata.a == null) {
                PropertyReferenceFilterExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyReferenceFilterExpressionDescriptionMetadata.c(PropertyReferenceFilterExpressionDescriptionMetadata.a);
            }
            if (a.k(PropertyReferenceFilterExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(PropertyReferenceFilterExpressionDescriptionMetadata.a);
        }
        static c(a) {
            FilterExpressionDescriptionMetadata.c(a);
            a.item("PropertyReference", "String");
        }
        static d(a) {
            PropertyReferenceFilterExpressionDescriptionMetadata.b(a);
            a.ae("PropertyReferenceFilterExpression", () => new PropertyReferenceFilterExpressionDescription());
            a.ad("PropertyReferenceFilterExpression", PropertyReferenceFilterExpressionDescriptionMetadata.a);
        }
    }
    PropertyReferenceFilterExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyReferenceFilterExpressionDescriptionMetadata, 'PropertyReferenceFilterExpressionDescriptionMetadata');
    PropertyReferenceFilterExpressionDescriptionMetadata.a = null;
    return PropertyReferenceFilterExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OperationFilterExpressionDescription = /*@__PURE__*/ (() => {
    class OperationFilterExpressionDescription extends FilterExpressionDescription {
        get_type() {
            return "OperationFilterExpression";
        }
        constructor() {
            super();
            this.r = null;
            this.s = null;
            this.k = null;
            this.l = null;
            this.q = null;
        }
        get propertyName() {
            return this.r;
        }
        set propertyName(a) {
            this.r = a;
            this.g("PropertyName");
        }
        get valueRef() {
            return this.s;
        }
        set valueRef(a) {
            this.s = a;
            this.g("ValueRef");
        }
        get left() {
            return this.k;
        }
        set left(a) {
            this.k = a;
            this.g("Left");
        }
        get right() {
            return this.l;
        }
        set right(a) {
            this.l = a;
            this.g("Right");
        }
        get operator() {
            return this.q;
        }
        set operator(a) {
            this.q = a;
            this.g("Operator");
        }
    }
    OperationFilterExpressionDescription.$t = /*@__PURE__*/ markType(OperationFilterExpressionDescription, 'OperationFilterExpressionDescription', FilterExpressionDescription.$);
    OperationFilterExpressionDescription.__marshalByValue1 = true;
    OperationFilterExpressionDescription.__marshalByValueAlias1 = "OperationFilterExpression";
    return OperationFilterExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OperationFilterExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class OperationFilterExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (OperationFilterExpressionDescriptionMetadata.a == null) {
                OperationFilterExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OperationFilterExpressionDescriptionMetadata.c(OperationFilterExpressionDescriptionMetadata.a);
            }
            if (a.k(OperationFilterExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(OperationFilterExpressionDescriptionMetadata.a);
            FilterExpressionDescriptionMetadata.d(a);
        }
        static c(a) {
            FilterExpressionDescriptionMetadata.c(a);
            a.item("PropertyName", "String");
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
            a.item("Left", "ExportedType:IFilterExpression");
            a.item("Right", "ExportedType:IFilterExpression");
            a.item("Operator", "ExportedType:string:FilterExpressionOperatorType");
            a.item("Operator@names", "None;Equal;NotEqual;GreaterThan;GreaterThanOrEqual;LessThan;LessThanOrEqual;And;Or;Not;Add;Subtract;Multiply;Divide;Modulo;Grouping");
        }
        static d(a) {
            OperationFilterExpressionDescriptionMetadata.b(a);
            a.ae("OperationFilterExpression", () => new OperationFilterExpressionDescription());
            a.ad("OperationFilterExpression", OperationFilterExpressionDescriptionMetadata.a);
        }
    }
    OperationFilterExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(OperationFilterExpressionDescriptionMetadata, 'OperationFilterExpressionDescriptionMetadata');
    OperationFilterExpressionDescriptionMetadata.a = null;
    return OperationFilterExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunctionFilterExpressionDescription = /*@__PURE__*/ (() => {
    class FunctionFilterExpressionDescription extends FilterExpressionDescription {
        get_type() {
            return "FunctionFilterExpression";
        }
        constructor() {
            super();
            this.o = null;
            this.k = null;
        }
        get functionType() {
            return this.o;
        }
        set functionType(a) {
            this.o = a;
            this.g("FunctionType");
        }
        get functionArguments() {
            return this.k;
        }
        set functionArguments(a) {
            this.k = a;
            this.g("FunctionArguments");
        }
    }
    FunctionFilterExpressionDescription.$t = /*@__PURE__*/ markType(FunctionFilterExpressionDescription, 'FunctionFilterExpressionDescription', FilterExpressionDescription.$);
    FunctionFilterExpressionDescription.__marshalByValue1 = true;
    FunctionFilterExpressionDescription.__marshalByValueAlias1 = "FunctionFilterExpression";
    return FunctionFilterExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunctionFilterExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class FunctionFilterExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (FunctionFilterExpressionDescriptionMetadata.a == null) {
                FunctionFilterExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FunctionFilterExpressionDescriptionMetadata.c(FunctionFilterExpressionDescriptionMetadata.a);
            }
            if (a.k(FunctionFilterExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(FunctionFilterExpressionDescriptionMetadata.a);
        }
        static c(a) {
            FilterExpressionDescriptionMetadata.c(a);
            a.item("FunctionType", "ExportedType:string:FilterExpressionFunctionType");
            a.item("FunctionType@names", "Contains;EndsWith;StartsWith;Length;IndexOf;Replace;Substring;ToLower;ToUpper;Trim;Concat;Day;Hour;Minute;Month;Second;Year;Round;Floor;Ceiling;Date;Time;Now;IsOf;Cast");
            a.item("FunctionArguments", "Collection:FilterExpression:FilterExpressionCollection:FilterExpression");
        }
        static d(a) {
            FunctionFilterExpressionDescriptionMetadata.b(a);
            a.ae("FunctionFilterExpression", () => new FunctionFilterExpressionDescription());
            a.ad("FunctionFilterExpression", FunctionFilterExpressionDescriptionMetadata.a);
        }
    }
    FunctionFilterExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(FunctionFilterExpressionDescriptionMetadata, 'FunctionFilterExpressionDescriptionMetadata');
    FunctionFilterExpressionDescriptionMetadata.a = null;
    return FunctionFilterExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LocalDataSourceDescriptionModule = /*@__PURE__*/ (() => {
    class LocalDataSourceDescriptionModule extends Base {
        static register(a) {
            LocalDataSourceDescriptionMetadata.d(a);
            LiteralFilterExpressionDescriptionMetadata.d(a);
            PropertyReferenceFilterExpressionDescriptionMetadata.d(a);
            OperationFilterExpressionDescriptionMetadata.d(a);
            FunctionFilterExpressionDescriptionMetadata.d(a);
        }
    }
    LocalDataSourceDescriptionModule.$t = /*@__PURE__*/ markType(LocalDataSourceDescriptionModule, 'LocalDataSourceDescriptionModule');
    return LocalDataSourceDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeFormatSpecifierDescription = /*@__PURE__*/ (() => {
    class DateTimeFormatSpecifierDescription extends FormatSpecifierDescription {
        get_type() {
            return "DateTimeFormatSpecifier";
        }
        constructor() {
            super();
            this.x = null;
            this.p = null;
            this.ad = null;
            this.l = 0;
            this.o = null;
            this.r = null;
            this.ab = null;
            this.y = null;
            this.ae = null;
            this.v = null;
            this.w = null;
            this.t = null;
            this.ag = null;
            this.s = null;
            this.ah = null;
            this.aa = null;
            this.q = null;
            this.u = null;
            this.z = null;
            this.ac = null;
            this.af = null;
        }
        get locale() {
            return this.x;
        }
        set locale(a) {
            this.x = a;
            this.g("Locale");
        }
        get dateStyle() {
            return this.p;
        }
        set dateStyle(a) {
            this.p = a;
            this.g("DateStyle");
        }
        get timeStyle() {
            return this.ad;
        }
        set timeStyle(a) {
            this.ad = a;
            this.g("TimeStyle");
        }
        get fractionalSecondDigits() {
            return this.l;
        }
        set fractionalSecondDigits(a) {
            this.l = a;
            this.g("FractionalSecondDigits");
        }
        get calendar() {
            return this.o;
        }
        set calendar(a) {
            this.o = a;
            this.g("Calendar");
        }
        get dayPeriod() {
            return this.r;
        }
        set dayPeriod(a) {
            this.r = a;
            this.g("DayPeriod");
        }
        get numberingSystem() {
            return this.ab;
        }
        set numberingSystem(a) {
            this.ab = a;
            this.g("NumberingSystem");
        }
        get localeMatcher() {
            return this.y;
        }
        set localeMatcher(a) {
            this.y = a;
            this.g("LocaleMatcher");
        }
        get timeZone() {
            return this.ae;
        }
        set timeZone(a) {
            this.ae = a;
            this.g("TimeZone");
        }
        get hour12() {
            return this.v;
        }
        set hour12(a) {
            this.v = a;
            this.g("Hour12");
        }
        get hourCycle() {
            return this.w;
        }
        set hourCycle(a) {
            this.w = a;
            this.g("HourCycle");
        }
        get formatMatcher() {
            return this.t;
        }
        set formatMatcher(a) {
            this.t = a;
            this.g("FormatMatcher");
        }
        get weekDay() {
            return this.ag;
        }
        set weekDay(a) {
            this.ag = a;
            this.g("WeekDay");
        }
        get era() {
            return this.s;
        }
        set era(a) {
            this.s = a;
            this.g("Era");
        }
        get year() {
            return this.ah;
        }
        set year(a) {
            this.ah = a;
            this.g("Year");
        }
        get month() {
            return this.aa;
        }
        set month(a) {
            this.aa = a;
            this.g("Month");
        }
        get day() {
            return this.q;
        }
        set day(a) {
            this.q = a;
            this.g("Day");
        }
        get hour() {
            return this.u;
        }
        set hour(a) {
            this.u = a;
            this.g("Hour");
        }
        get minute() {
            return this.z;
        }
        set minute(a) {
            this.z = a;
            this.g("Minute");
        }
        get second() {
            return this.ac;
        }
        set second(a) {
            this.ac = a;
            this.g("Second");
        }
        get timeZoneName() {
            return this.af;
        }
        set timeZoneName(a) {
            this.af = a;
            this.g("TimeZoneName");
        }
    }
    DateTimeFormatSpecifierDescription.$t = /*@__PURE__*/ markType(DateTimeFormatSpecifierDescription, 'DateTimeFormatSpecifierDescription', FormatSpecifierDescription.$);
    DateTimeFormatSpecifierDescription.__marshalByValue1 = true;
    DateTimeFormatSpecifierDescription.__marshalByValueAlias1 = "DateTimeFormatSpecifier";
    return DateTimeFormatSpecifierDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeFormatSpecifierDescriptionMetadata = /*@__PURE__*/ (() => {
    class DateTimeFormatSpecifierDescriptionMetadata extends Base {
        static b(a) {
            if (DateTimeFormatSpecifierDescriptionMetadata.a == null) {
                DateTimeFormatSpecifierDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DateTimeFormatSpecifierDescriptionMetadata.c(DateTimeFormatSpecifierDescriptionMetadata.a);
            }
            if (a.k(DateTimeFormatSpecifierDescriptionMetadata.a)) {
                return;
            }
            a.ac(DateTimeFormatSpecifierDescriptionMetadata.a);
        }
        static c(a) {
            FormatSpecifierDescriptionMetadata.c(a);
            a.item("Locale", "String");
            a.item("DateStyle", "String");
            a.item("TimeStyle", "String");
            a.item("FractionalSecondDigits", "Number:int");
            a.item("Calendar", "String");
            a.item("DayPeriod", "String");
            a.item("NumberingSystem", "String");
            a.item("LocaleMatcher", "String");
            a.item("TimeZone", "String");
            a.item("Hour12", "String");
            a.item("HourCycle", "String");
            a.item("FormatMatcher", "String");
            a.item("WeekDay", "String");
            a.item("Era", "String");
            a.item("Year", "String");
            a.item("Month", "String");
            a.item("Day", "String");
            a.item("Hour", "String");
            a.item("Minute", "String");
            a.item("Second", "String");
            a.item("TimeZoneName", "String");
            DateTimeFormatSpecifierDescriptionMetadata.e(a);
        }
        static d(a) {
            DateTimeFormatSpecifierDescriptionMetadata.b(a);
            a.ae("DateTimeFormatSpecifier", () => new DateTimeFormatSpecifierDescription());
            a.ad("DateTimeFormatSpecifier", DateTimeFormatSpecifierDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-core");
            a.item("__importTypesReact", "String:igniteui-react-core");
            a.item("__importTypesAngular", "String:igniteui-angular-core");
            a.item("__skipSuffix", "Boolean");
        }
    }
    DateTimeFormatSpecifierDescriptionMetadata.$t = /*@__PURE__*/ markType(DateTimeFormatSpecifierDescriptionMetadata, 'DateTimeFormatSpecifierDescriptionMetadata');
    DateTimeFormatSpecifierDescriptionMetadata.a = null;
    return DateTimeFormatSpecifierDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeFormatSpecifierDescriptionModule = /*@__PURE__*/ (() => {
    class DateTimeFormatSpecifierDescriptionModule extends Base {
        static register(a) {
            FormatSpecifierDescriptionModule.register(a);
            DateTimeFormatSpecifierDescriptionMetadata.d(a);
        }
    }
    DateTimeFormatSpecifierDescriptionModule.$t = /*@__PURE__*/ markType(DateTimeFormatSpecifierDescriptionModule, 'DateTimeFormatSpecifierDescriptionModule');
    return DateTimeFormatSpecifierDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class CellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (CellInfoDescriptionMetadata.a == null) {
                CellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CellInfoDescriptionMetadata.c(CellInfoDescriptionMetadata.a);
            }
            if (a.k(CellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(CellInfoDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("StyleKey", "String");
            a.item("DataRow", "Number:int");
            a.item("IsPositionDirty", "Boolean");
            a.item("IsSizeDirty", "Boolean");
            a.item("IsContentDirty", "Boolean");
            a.item("IsBorderDirty", "Boolean");
            a.item("IsLayerDirty", "Boolean");
            a.item("IsStateDirty", "Boolean");
            a.item("IsDataDirty", "Boolean");
            a.item("IsPlaceholdContentNeeded", "Boolean");
            a.item("ActionManager", "ExportedType");
            a.item("IsHitTestVisible", "Boolean");
            a.item("IsRowPinned", "Boolean");
            a.item("IsRowSticky", "Boolean");
            a.item("IsLastStickyRow", "Boolean");
            a.item("IsFilterRow", "Boolean");
            a.item("Indent", "Number:int");
            a.item("RowItemRef", "(w:RowItem,wf:RowItem)DataRef");
            a.item("X", "Number:double");
            a.item("Y", "Number:double");
            a.item("SnappedX", "Number:int");
            a.item("SnappedY", "Number:int");
            a.item("EditOpacity", "Number:double");
            a.item("ContentOpacity", "Number:double");
            a.item("ActualContentOpacity", "Number:double");
            a.item("Opacity", "Number:double");
            a.item("ActualOpacity", "Number:double");
            a.item("Height", "Number:int");
            a.item("Width", "Number:int");
            a.item("IsSelected", "Boolean");
            a.item("SelectedStatus", "Number:double");
            a.item("ActivationStatus", "Number:double");
            a.item("HoverStatus", "Number:double");
            a.item("IsHoverable", "Boolean");
            a.item("HorizontalAlignment", "ExportedType:string:CellContentHorizontalAlignment");
            a.item("HorizontalAlignment@names", "Left;Center;Right;Stretch;Auto");
            a.item("VerticalAlignment", "ExportedType:string:CellContentVerticalAlignment");
            a.item("VerticalAlignment@names", "Top;Center;Bottom;Stretch;Auto");
            a.item("Background", "Brush");
            a.item("Border", "Brush");
            a.item("ActualBackground", "Brush");
            a.item("ActualBorder", "Brush");
            a.item("ActivationBorder", "Brush");
            a.item("ErrorBorder", "Brush");
            a.item("SelectedBackground", "Brush");
            a.item("HoverBackground", "Brush");
            a.item("HoverTextColor", "Brush");
            a.item("SortIndicatorColor", "Brush");
            a.item("StickyRowBackground", "Brush");
            a.item("PinnedRowBackground", "Brush");
            a.item("LastStickyRowBackground", "Brush");
            a.item("FilterRowBackground", "Brush");
            a.item("PinnedRowOpacity", "Number:double");
            a.item("OriginalValueRef", "(w:OriginalValue,wf:OriginalValue)DataRef");
            a.item("RenderValue", "String");
            a.item("TextColor", "Brush");
            a.item("ActualTextColor", "Brush");
            a.item("DeletedTextColor", "Brush");
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:font/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:font/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontFamily/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:font/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontFamily/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:font/FontWeightTransform)String");
            a.item("ActualFontFamily", "(w:ActualFontFamily/FontFamilyTransform,xam:ActualFontFamily,wf:ActualFontFamily,web:actualFont/FontFamilyTransform)String");
            a.item("ActualFontSize", "(w:ActualFontSize,xam:ActualFontSize,wf:ActualFontSize,web:actualFont/FontSizeTransform)Number:double");
            a.item("ActualFontStyle", "(w:ActualFontStyle/FontStyleTransform,xam:ActualFontFamily/FontStyleTransform,wf:ActualFontFamily/FontStyleTransform,web:actualFont/FontStyleTransform)String");
            a.item("ActualFontWeight", "(w:ActualFontWeight/FontWeightTransform,xam:ActualFontFamily/FontWeightTransform,wf:ActualFontFamily/FontWeightTransform,web:actualFont/FontWeightTransform)String");
            a.item("LineBreakMode", "ExportedType:string:TextCellLineBreakMode");
            a.item("LineBreakMode@names", "Ellipsis;NoWrap;WordWrap;CharacterWrap");
            a.item("VirtualizationPercentage", "Number:double");
            a.item("PaddingLeft", "Number:int");
            a.item("PaddingTop", "Number:int");
            a.item("PaddingRight", "Number:int");
            a.item("PaddingBottom", "Number:int");
            a.item("ActualPaddingLeft", "Number:int");
            a.item("ActualPaddingTop", "Number:int");
            a.item("ActualPaddingRight", "Number:int");
            a.item("ActualPaddingBottom", "Number:int");
            a.item("BorderLeftWidth", "Number:int");
            a.item("BorderTopWidth", "Number:int");
            a.item("BorderRightWidth", "Number:int");
            a.item("BorderBottomWidth", "Number:int");
            a.item("ActivationBorderLeftWidth", "Number:int");
            a.item("ActivationBorderTopWidth", "Number:int");
            a.item("ActivationBorderRightWidth", "Number:int");
            a.item("ActivationBorderBottomWidth", "Number:int");
            a.item("ErrorBorderLeftWidth", "Number:int");
            a.item("ErrorBorderTopWidth", "Number:int");
            a.item("ErrorBorderRightWidth", "Number:int");
            a.item("ErrorBorderBottomWidth", "Number:int");
            a.item("ActualBorderLeftWidth", "Number:int");
            a.item("ActualBorderTopWidth", "Number:int");
            a.item("ActualBorderRightWidth", "Number:int");
            a.item("ActualBorderBottomWidth", "Number:int");
            a.item("SortDirection", "ExportedType:string:ColumnSortDirection");
            a.item("SortDirection@names", "None;Ascending;Descending");
            a.item("IsExpanded", "Boolean");
            a.item("IsCollapsable", "Boolean");
            a.item("Pinned", "ExportedType:string:PinnedPositions");
            a.item("Pinned@names", "None;Left;Right");
            a.item("EditFontFamily", "(w:EditFontFamily/FontFamilyTransform,xam:EditFontFamily,wf:EditFontFamily,web:editFont/FontFamilyTransform)String");
            a.item("EditFontSize", "(w:EditFontSize,xam:EditFontSize,wf:EditFontSize,web:editFont/FontSizeTransform)Number:double");
            a.item("EditFontStyle", "(w:EditFontStyle/FontStyleTransform,xam:EditFontFamily/FontStyleTransform,wf:EditFontFamily/FontStyleTransform,web:editFont/FontStyleTransform)String");
            a.item("EditFontWeight", "(w:EditFontWeight/FontWeightTransform,xam:EditFontFamily/FontWeightTransform,wf:EditFontFamily/FontWeightTransform,web:editFont/FontWeightTransform)String");
            a.item("IsEdited", "Boolean");
            a.item("IsDeleted", "Boolean");
            a.item("EditError", "String");
            a.item("IsInEditMode", "Boolean");
            a.item("EditID", "Number:int");
        }
        static d(a) {
            CellInfoDescriptionMetadata.b(a);
            a.ad("CellInfo", CellInfoDescriptionMetadata.a);
        }
    }
    CellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(CellInfoDescriptionMetadata, 'CellInfoDescriptionMetadata');
    CellInfoDescriptionMetadata.a = null;
    return CellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridCellEventArgsDescription = /*@__PURE__*/ (() => {
    class DataGridCellEventArgsDescription extends Description {
        get_type() {
            return "DataGridCellEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = null;
            this.n = null;
            this.l = false;
        }
        get cellInfo() {
            return this.h;
        }
        set cellInfo(a) {
            this.h = a;
            this.g("CellInfo");
        }
        get grid() {
            return this.j;
        }
        set grid(a) {
            this.j = a;
            this.g("Grid");
        }
        get button() {
            return this.n;
        }
        set button(a) {
            this.n = a;
            this.g("Button");
        }
        get isDoubleClick() {
            return this.l;
        }
        set isDoubleClick(a) {
            this.l = a;
            this.g("IsDoubleClick");
        }
    }
    DataGridCellEventArgsDescription.$t = /*@__PURE__*/ markType(DataGridCellEventArgsDescription, 'DataGridCellEventArgsDescription', Description.$);
    return DataGridCellEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderRowSeparatorDescription = /*@__PURE__*/ (() => {
    class HeaderRowSeparatorDescription extends DefinitionBaseDescription {
        get_type() {
            return "HeaderRowSeparator";
        }
        constructor() {
            super();
        }
    }
    HeaderRowSeparatorDescription.$t = /*@__PURE__*/ markType(HeaderRowSeparatorDescription, 'HeaderRowSeparatorDescription', DefinitionBaseDescription.$);
    return HeaderRowSeparatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderRowSeparatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class HeaderRowSeparatorDescriptionMetadata extends Base {
        static b(a) {
            if (HeaderRowSeparatorDescriptionMetadata.a == null) {
                HeaderRowSeparatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HeaderRowSeparatorDescriptionMetadata.c(HeaderRowSeparatorDescriptionMetadata.a);
            }
            if (a.k(HeaderRowSeparatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(HeaderRowSeparatorDescriptionMetadata.a);
        }
        static c(a) {
            DefinitionBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            HeaderRowSeparatorDescriptionMetadata.b(a);
            a.ae("HeaderRowSeparator", () => new HeaderRowSeparatorDescription());
            a.ad("HeaderRowSeparator", HeaderRowSeparatorDescriptionMetadata.a);
        }
    }
    HeaderRowSeparatorDescriptionMetadata.$t = /*@__PURE__*/ markType(HeaderRowSeparatorDescriptionMetadata, 'HeaderRowSeparatorDescriptionMetadata');
    HeaderRowSeparatorDescriptionMetadata.a = null;
    return HeaderRowSeparatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PinnedAreaSeparatorDescription = /*@__PURE__*/ (() => {
    class PinnedAreaSeparatorDescription extends DefinitionBaseDescription {
        get_type() {
            return "PinnedAreaSeparator";
        }
        constructor() {
            super();
        }
    }
    PinnedAreaSeparatorDescription.$t = /*@__PURE__*/ markType(PinnedAreaSeparatorDescription, 'PinnedAreaSeparatorDescription', DefinitionBaseDescription.$);
    return PinnedAreaSeparatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PinnedAreaSeparatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class PinnedAreaSeparatorDescriptionMetadata extends Base {
        static b(a) {
            if (PinnedAreaSeparatorDescriptionMetadata.a == null) {
                PinnedAreaSeparatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PinnedAreaSeparatorDescriptionMetadata.c(PinnedAreaSeparatorDescriptionMetadata.a);
            }
            if (a.k(PinnedAreaSeparatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(PinnedAreaSeparatorDescriptionMetadata.a);
        }
        static c(a) {
            DefinitionBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            PinnedAreaSeparatorDescriptionMetadata.b(a);
            a.ae("PinnedAreaSeparator", () => new PinnedAreaSeparatorDescription());
            a.ad("PinnedAreaSeparator", PinnedAreaSeparatorDescriptionMetadata.a);
        }
    }
    PinnedAreaSeparatorDescriptionMetadata.$t = /*@__PURE__*/ markType(PinnedAreaSeparatorDescriptionMetadata, 'PinnedAreaSeparatorDescriptionMetadata');
    PinnedAreaSeparatorDescriptionMetadata.a = null;
    return PinnedAreaSeparatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridAnimationSettingsDescription = /*@__PURE__*/ (() => {
    class GridAnimationSettingsDescription extends Description {
        get_type() {
            return "GridAnimationSettings";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    GridAnimationSettingsDescription.$t = /*@__PURE__*/ markType(GridAnimationSettingsDescription, 'GridAnimationSettingsDescription', Description.$);
    return GridAnimationSettingsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridAnimationSettingsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridAnimationSettingsDescriptionMetadata extends Base {
        static b(a) {
            if (GridAnimationSettingsDescriptionMetadata.a == null) {
                GridAnimationSettingsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridAnimationSettingsDescriptionMetadata.c(GridAnimationSettingsDescriptionMetadata.a);
            }
            if (a.k(GridAnimationSettingsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridAnimationSettingsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            GridAnimationSettingsDescriptionMetadata.b(a);
            a.ae("GridAnimationSettings", () => new GridAnimationSettingsDescription());
            a.ad("GridAnimationSettings", GridAnimationSettingsDescriptionMetadata.a);
        }
    }
    GridAnimationSettingsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridAnimationSettingsDescriptionMetadata, 'GridAnimationSettingsDescriptionMetadata');
    GridAnimationSettingsDescriptionMetadata.a = null;
    return GridAnimationSettingsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterExpressionsEventArgsDescription = /*@__PURE__*/ (() => {
    class GridFilterExpressionsEventArgsDescription extends Description {
        get_type() {
            return "GridFilterExpressionsEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get filterExpressions() {
            return this.h;
        }
        set filterExpressions(a) {
            this.h = a;
            this.g("FilterExpressions");
        }
    }
    GridFilterExpressionsEventArgsDescription.$t = /*@__PURE__*/ markType(GridFilterExpressionsEventArgsDescription, 'GridFilterExpressionsEventArgsDescription', Description.$);
    return GridFilterExpressionsEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterExpressionsEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridFilterExpressionsEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridFilterExpressionsEventArgsDescriptionMetadata.a == null) {
                GridFilterExpressionsEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridFilterExpressionsEventArgsDescriptionMetadata.c(GridFilterExpressionsEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridFilterExpressionsEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridFilterExpressionsEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("FilterExpressions", "Collection:FilterExpression:FilterExpressionCollection:FilterExpression");
        }
        static d(a) {
            GridFilterExpressionsEventArgsDescriptionMetadata.b(a);
            a.ae("GridFilterExpressionsEventArgs", () => new GridFilterExpressionsEventArgsDescription());
            a.ad("GridFilterExpressionsEventArgs", GridFilterExpressionsEventArgsDescriptionMetadata.a);
        }
    }
    GridFilterExpressionsEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridFilterExpressionsEventArgsDescriptionMetadata, 'GridFilterExpressionsEventArgsDescriptionMetadata');
    GridFilterExpressionsEventArgsDescriptionMetadata.a = null;
    return GridFilterExpressionsEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSortDescriptionsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridSortDescriptionsChangedEventArgsDescription extends Description {
        get_type() {
            return "GridSortDescriptionsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get sortDescriptions() {
            return this.h;
        }
        set sortDescriptions(a) {
            this.h = a;
            this.g("SortDescriptions");
        }
    }
    GridSortDescriptionsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridSortDescriptionsChangedEventArgsDescription, 'GridSortDescriptionsChangedEventArgsDescription', Description.$);
    return GridSortDescriptionsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSortDescriptionsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridSortDescriptionsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridSortDescriptionsChangedEventArgsDescriptionMetadata.a == null) {
                GridSortDescriptionsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridSortDescriptionsChangedEventArgsDescriptionMetadata.c(GridSortDescriptionsChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridSortDescriptionsChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridSortDescriptionsChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("SortDescriptions", "Collection:ColumnSortDescription:ColumnSortDescriptionCollection:ColumnSortDescription");
        }
        static d(a) {
            GridSortDescriptionsChangedEventArgsDescriptionMetadata.b(a);
            a.ae("GridSortDescriptionsChangedEventArgs", () => new GridSortDescriptionsChangedEventArgsDescription());
            a.ad("GridSortDescriptionsChangedEventArgs", GridSortDescriptionsChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridSortDescriptionsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridSortDescriptionsChangedEventArgsDescriptionMetadata, 'GridSortDescriptionsChangedEventArgsDescriptionMetadata');
    GridSortDescriptionsChangedEventArgsDescriptionMetadata.a = null;
    return GridSortDescriptionsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridGroupDescriptionsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridGroupDescriptionsChangedEventArgsDescription extends Description {
        get_type() {
            return "GridGroupDescriptionsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get groupDescriptions() {
            return this.h;
        }
        set groupDescriptions(a) {
            this.h = a;
            this.g("GroupDescriptions");
        }
    }
    GridGroupDescriptionsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridGroupDescriptionsChangedEventArgsDescription, 'GridGroupDescriptionsChangedEventArgsDescription', Description.$);
    return GridGroupDescriptionsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridGroupDescriptionsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridGroupDescriptionsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridGroupDescriptionsChangedEventArgsDescriptionMetadata.a == null) {
                GridGroupDescriptionsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridGroupDescriptionsChangedEventArgsDescriptionMetadata.c(GridGroupDescriptionsChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridGroupDescriptionsChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridGroupDescriptionsChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("GroupDescriptions", "Collection:ColumnGroupDescription:ColumnGroupDescriptionCollection:ColumnGroupDescription");
        }
        static d(a) {
            GridGroupDescriptionsChangedEventArgsDescriptionMetadata.b(a);
            a.ae("GridGroupDescriptionsChangedEventArgs", () => new GridGroupDescriptionsChangedEventArgsDescription());
            a.ad("GridGroupDescriptionsChangedEventArgs", GridGroupDescriptionsChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridGroupDescriptionsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridGroupDescriptionsChangedEventArgsDescriptionMetadata, 'GridGroupDescriptionsChangedEventArgsDescriptionMetadata');
    GridGroupDescriptionsChangedEventArgsDescriptionMetadata.a = null;
    return GridGroupDescriptionsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSummaryDescriptionsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridSummaryDescriptionsChangedEventArgsDescription extends Description {
        get_type() {
            return "GridSummaryDescriptionsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get summaryDescriptions() {
            return this.h;
        }
        set summaryDescriptions(a) {
            this.h = a;
            this.g("SummaryDescriptions");
        }
    }
    GridSummaryDescriptionsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridSummaryDescriptionsChangedEventArgsDescription, 'GridSummaryDescriptionsChangedEventArgsDescription', Description.$);
    return GridSummaryDescriptionsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSummaryDescriptionsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridSummaryDescriptionsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridSummaryDescriptionsChangedEventArgsDescriptionMetadata.a == null) {
                GridSummaryDescriptionsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridSummaryDescriptionsChangedEventArgsDescriptionMetadata.c(GridSummaryDescriptionsChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridSummaryDescriptionsChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridSummaryDescriptionsChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("SummaryDescriptions", "Collection:ColumnSummaryDescription:ColumnSummaryDescriptionCollection:ColumnSummaryDescription");
        }
        static d(a) {
            GridSummaryDescriptionsChangedEventArgsDescriptionMetadata.b(a);
            a.ae("GridSummaryDescriptionsChangedEventArgs", () => new GridSummaryDescriptionsChangedEventArgsDescription());
            a.ad("GridSummaryDescriptionsChangedEventArgs", GridSummaryDescriptionsChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridSummaryDescriptionsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridSummaryDescriptionsChangedEventArgsDescriptionMetadata, 'GridSummaryDescriptionsChangedEventArgsDescriptionMetadata');
    GridSummaryDescriptionsChangedEventArgsDescriptionMetadata.a = null;
    return GridSummaryDescriptionsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnAnimationSettingsDescription = /*@__PURE__*/ (() => {
    class GridColumnAnimationSettingsDescription extends Description {
        get_type() {
            return "GridColumnAnimationSettings";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    GridColumnAnimationSettingsDescription.$t = /*@__PURE__*/ markType(GridColumnAnimationSettingsDescription, 'GridColumnAnimationSettingsDescription', Description.$);
    return GridColumnAnimationSettingsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnAnimationSettingsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnAnimationSettingsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnAnimationSettingsDescriptionMetadata.a == null) {
                GridColumnAnimationSettingsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnAnimationSettingsDescriptionMetadata.c(GridColumnAnimationSettingsDescriptionMetadata.a);
            }
            if (a.k(GridColumnAnimationSettingsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnAnimationSettingsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            GridColumnAnimationSettingsDescriptionMetadata.b(a);
            a.ae("GridColumnAnimationSettings", () => new GridColumnAnimationSettingsDescription());
            a.ad("GridColumnAnimationSettings", GridColumnAnimationSettingsDescriptionMetadata.a);
        }
    }
    GridColumnAnimationSettingsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnAnimationSettingsDescriptionMetadata, 'GridColumnAnimationSettingsDescriptionMetadata');
    GridColumnAnimationSettingsDescriptionMetadata.a = null;
    return GridColumnAnimationSettingsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnFilterConditionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnFilterConditionDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnFilterConditionDescriptionMetadata.a == null) {
                ColumnFilterConditionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnFilterConditionDescriptionMetadata.c(ColumnFilterConditionDescriptionMetadata.a);
            }
            if (a.k(ColumnFilterConditionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnFilterConditionDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ColumnFilterConditionDescriptionMetadata.b(a);
            a.ad("ColumnFilterCondition", ColumnFilterConditionDescriptionMetadata.a);
        }
    }
    ColumnFilterConditionDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnFilterConditionDescriptionMetadata, 'ColumnFilterConditionDescriptionMetadata');
    ColumnFilterConditionDescriptionMetadata.a = null;
    return ColumnFilterConditionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridColumnDescriptionMetadata extends Base {
        static b(a) {
            if (DataGridColumnDescriptionMetadata.a == null) {
                DataGridColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridColumnDescriptionMetadata.c(DataGridColumnDescriptionMetadata.a);
            }
            if (a.k(DataGridColumnDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataGridColumnDescriptionMetadata.a);
            GridColumnAnimationSettingsDescriptionMetadata.d(a);
            ColumnWidthDescriptionMetadata.d(a);
            ColumnFilterConditionDescriptionMetadata.d(a);
            FilterExpressionDescriptionMetadata.d(a);
            HeaderDescriptionMetadata.d(a);
        }
        static c(a) {
            DefinitionBaseDescriptionMetadata.c(a);
            a.item("PaddingLeft", "Number:int");
            a.item("PaddingTop", "Number:int");
            a.item("PaddingRight", "Number:int");
            a.item("PaddingBottom", "Number:int");
            a.item("Name", "String");
            a.item("Field", "String");
            a.item("HeaderText", "String");
            a.item("ActualHeaderText", "String");
            a.item("SelectedBackground", "Brush");
            a.item("ActualSelectedBackground", "Brush");
            a.item("RowHoverBackground", "Brush");
            a.item("ActualHoverBackground", "Brush");
            a.item("RowHoverTextColor", "Brush");
            a.item("ActualRowHoverTextColor", "Brush");
            a.item("AnimationSettings", "ExportedType:GridColumnAnimationSettings");
            a.item("Width", "ExportedType:ColumnWidth");
            a.item("MinWidth", "Number:double");
            a.item("IsFromMarkup", "Boolean");
            a.item("IsAutoGenerated", "Boolean");
            a.item("Filter", "ExportedType:ColumnFilterCondition");
            a.item("FilterExpression", "ExportedType:IFilterExpression");
            a.item("Header", "ExportedType:Header");
            a.item("IsFilteringEnabled", "Boolean");
            a.item("IsResizingEnabled", "Boolean");
            a.item("IsHidden", "Boolean");
            a.item("ShouldRemoveWhenHidden", "Boolean");
            a.item("SortDirection", "ExportedType:string:ColumnSortDirection");
            a.item("SortDirection@names", "None;Ascending;Descending");
            a.item("Pinned", "ExportedType:string:PinnedPositions");
            a.item("Pinned@names", "None;Left;Right");
            a.item("ActualColumnOptionsIconAlignment", "ExportedType:string:ColumnOptionsIconAlignment");
            a.item("ActualColumnOptionsIconAlignment@names", "Unset;None;Opposite");
            a.item("ColumnOptionsIconAlignment", "ExportedType:string:ColumnOptionsIconAlignment");
            a.item("ColumnOptionsIconAlignment@names", "Unset;None;Opposite");
            a.item("ActualColumnOptionsIconColor", "Brush");
            a.item("ColumnOptionsIconColor", "Brush");
            a.item("ColumnOptionsIconBehavior", "ExportedType:string:ColumnOptionsIconBehavior");
            a.item("ColumnOptionsIconBehavior@names", "Unset;AlwaysVisible;AppearOnHover;AppearOnHoverAnimate");
            a.item("ActualColumnOptionsIconBehavior", "ExportedType:string:ColumnOptionsIconBehavior");
            a.item("ActualColumnOptionsIconBehavior@names", "Unset;AlwaysVisible;AppearOnHover;AppearOnHoverAnimate");
            a.item("ActualIsColumnOptionsEnabled", "Boolean");
            a.item("IsColumnOptionsEnabled", "Boolean");
            a.item("ActualIsColumnOptionsSummariesEnabled", "Boolean");
            a.item("IsColumnOptionsSummariesEnabled", "Boolean");
            a.item("ActualIsColumnOptionsGroupingEnabled", "Boolean");
            a.item("IsColumnOptionsGroupingEnabled", "Boolean");
            a.item("IsEditable", "Boolean");
            a.item("DeletedTextColor", "Brush");
            a.item("ActualDeletedTextColor", "Brush");
            a.item("EditOpacity", "Number:double");
            a.item("ActualEditOpacity", "Number:double");
            a.item("EditFontFamily", "(w:EditFontFamily/FontFamilyTransform,xam:EditFontFamily,wf:EditFontFamily,web:textEditStyle/FontFamilyTransform)String");
            a.item("EditFontSize", "(w:EditFontSize,xam:EditFontSize,wf:EditFontSize,web:textEditStyle/FontSizeTransform)Number:double");
            a.item("EditFontStyle", "(w:EditFontStyle/FontStyleTransform,xam:EditFontFamily/FontStyleTransform,wf:EditFontFamily/FontStyleTransform,web:textEditStyle/FontStyleTransform)String");
            a.item("EditFontWeight", "(w:EditFontWeight/FontWeightTransform,xam:EditFontFamily/FontWeightTransform,wf:EditFontFamily/FontWeightTransform,web:textEditStyle/FontWeightTransform)String");
            a.item("MergedCellMode", "ExportedType:string:MergedCellMode");
            a.item("MergedCellMode@names", "Default;Never;Always;OnlyWhenSorted");
            a.item("MergedCellEvaluationCriteria", "ExportedType:string:MergedCellEvaluationCriteria");
            a.item("MergedCellEvaluationCriteria@names", "Default;RawValue;FormattedText");
            a.item("MergedCellVerticalAlignment", "ExportedType:string:CellContentVerticalAlignment");
            a.item("MergedCellVerticalAlignment@names", "Top;Center;Bottom;Stretch;Auto");
            a.item("MergedCellPaddingLeft", "Number:int");
            a.item("MergedCellPaddingTop", "Number:int");
            a.item("MergedCellPaddingRight", "Number:int");
            a.item("MergedCellPaddingBottom", "Number:int");
            a.item("FilterComparisonType", "ExportedType:string:FilterComparisonType");
            a.item("FilterComparisonType@names", "Default;CaseInsensitive;CaseSensitive");
            a.item("FilterOperands", "Collection:FilterOperand:GridFilterOperandsCollection:FilterOperand");
            a.item("ActualHeaderTextChangeRef", "EventRef::actualHeaderTextChange");
        }
        static d(a) {
            DataGridColumnDescriptionMetadata.b(a);
            a.ad("DataGridColumn", DataGridColumnDescriptionMetadata.a);
        }
    }
    DataGridColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridColumnDescriptionMetadata, 'DataGridColumnDescriptionMetadata');
    DataGridColumnDescriptionMetadata.a = null;
    return DataGridColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnHiddenChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class ColumnHiddenChangedEventArgsDescription extends Description {
        get_type() {
            return "ColumnHiddenChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = false;
        }
        get column() {
            return this.h;
        }
        set column(a) {
            this.h = a;
            this.g("Column");
        }
        get isHidden() {
            return this.j;
        }
        set isHidden(a) {
            this.j = a;
            this.g("IsHidden");
        }
    }
    ColumnHiddenChangedEventArgsDescription.$t = /*@__PURE__*/ markType(ColumnHiddenChangedEventArgsDescription, 'ColumnHiddenChangedEventArgsDescription', Description.$);
    return ColumnHiddenChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnHiddenChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnHiddenChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnHiddenChangedEventArgsDescriptionMetadata.a == null) {
                ColumnHiddenChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnHiddenChangedEventArgsDescriptionMetadata.c(ColumnHiddenChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(ColumnHiddenChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnHiddenChangedEventArgsDescriptionMetadata.a);
            DataGridColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Column", "ExportedType:DataGridColumn");
            a.item("IsHidden", "Boolean");
        }
        static d(a) {
            ColumnHiddenChangedEventArgsDescriptionMetadata.b(a);
            a.ae("ColumnHiddenChangedEventArgs", () => new ColumnHiddenChangedEventArgsDescription());
            a.ad("ColumnHiddenChangedEventArgs", ColumnHiddenChangedEventArgsDescriptionMetadata.a);
        }
    }
    ColumnHiddenChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnHiddenChangedEventArgsDescriptionMetadata, 'ColumnHiddenChangedEventArgsDescriptionMetadata');
    ColumnHiddenChangedEventArgsDescriptionMetadata.a = null;
    return ColumnHiddenChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnPinnedChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class ColumnPinnedChangedEventArgsDescription extends Description {
        get_type() {
            return "ColumnPinnedChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = null;
        }
        get column() {
            return this.h;
        }
        set column(a) {
            this.h = a;
            this.g("Column");
        }
        get pinned() {
            return this.j;
        }
        set pinned(a) {
            this.j = a;
            this.g("Pinned");
        }
    }
    ColumnPinnedChangedEventArgsDescription.$t = /*@__PURE__*/ markType(ColumnPinnedChangedEventArgsDescription, 'ColumnPinnedChangedEventArgsDescription', Description.$);
    return ColumnPinnedChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnPinnedChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnPinnedChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnPinnedChangedEventArgsDescriptionMetadata.a == null) {
                ColumnPinnedChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnPinnedChangedEventArgsDescriptionMetadata.c(ColumnPinnedChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(ColumnPinnedChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnPinnedChangedEventArgsDescriptionMetadata.a);
            DataGridColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Column", "ExportedType:DataGridColumn");
            a.item("Pinned", "ExportedType:string:PinnedPositions");
            a.item("Pinned@names", "None;Left;Right");
        }
        static d(a) {
            ColumnPinnedChangedEventArgsDescriptionMetadata.b(a);
            a.ae("ColumnPinnedChangedEventArgs", () => new ColumnPinnedChangedEventArgsDescription());
            a.ad("ColumnPinnedChangedEventArgs", ColumnPinnedChangedEventArgsDescriptionMetadata.a);
        }
    }
    ColumnPinnedChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnPinnedChangedEventArgsDescriptionMetadata, 'ColumnPinnedChangedEventArgsDescriptionMetadata');
    ColumnPinnedChangedEventArgsDescriptionMetadata.a = null;
    return ColumnPinnedChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellValueChangingEventArgsDescription = /*@__PURE__*/ (() => {
    class GridCellValueChangingEventArgsDescription extends Description {
        get_type() {
            return "GridCellValueChangingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = 0;
            this.h = null;
            this.j = null;
            this.r = null;
            this.o = null;
            this.n = null;
        }
        get editID() {
            return this.l;
        }
        set editID(a) {
            this.l = a;
            this.g("EditID");
        }
        get cellInfo() {
            return this.h;
        }
        set cellInfo(a) {
            this.h = a;
            this.g("CellInfo");
        }
        get column() {
            return this.j;
        }
        set column(a) {
            this.j = a;
            this.g("Column");
        }
        get itemRef() {
            return this.r;
        }
        set itemRef(a) {
            this.r = a;
            this.g("ItemRef");
        }
        get oldValue() {
            return this.o;
        }
        set oldValue(a) {
            this.o = a;
            this.g("OldValue");
        }
        get newValue() {
            return this.n;
        }
        set newValue(a) {
            this.n = a;
            this.g("NewValue");
        }
    }
    GridCellValueChangingEventArgsDescription.$t = /*@__PURE__*/ markType(GridCellValueChangingEventArgsDescription, 'GridCellValueChangingEventArgsDescription', Description.$);
    return GridCellValueChangingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellValueChangingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridCellValueChangingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridCellValueChangingEventArgsDescriptionMetadata.a == null) {
                GridCellValueChangingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridCellValueChangingEventArgsDescriptionMetadata.c(GridCellValueChangingEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridCellValueChangingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridCellValueChangingEventArgsDescriptionMetadata.a);
            CellInfoDescriptionMetadata.d(a);
            DataGridColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("EditID", "Number:int");
            a.item("CellInfo", "ExportedType:CellModel");
            a.item("Column", "ExportedType:DataGridColumn");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("OldValue", "Unknown");
            a.item("NewValue", "Unknown");
        }
        static d(a) {
            GridCellValueChangingEventArgsDescriptionMetadata.b(a);
            a.ae("GridCellValueChangingEventArgs", () => new GridCellValueChangingEventArgsDescription());
            a.ad("GridCellValueChangingEventArgs", GridCellValueChangingEventArgsDescriptionMetadata.a);
        }
    }
    GridCellValueChangingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridCellValueChangingEventArgsDescriptionMetadata, 'GridCellValueChangingEventArgsDescriptionMetadata');
    GridCellValueChangingEventArgsDescriptionMetadata.a = null;
    return GridCellValueChangingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceAggregatedResultDescription = /*@__PURE__*/ (() => {
    class DataSourceAggregatedResultDescription extends Description {
        get_type() {
            return "DataSourceAggregatedResult";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.m = null;
            this.h = null;
            this.n = null;
        }
        get itemRef() {
            return this.l;
        }
        set itemRef(a) {
            this.l = a;
            this.g("ItemRef");
        }
        get transactionType() {
            return this.m;
        }
        set transactionType(a) {
            this.m = a;
            this.g("TransactionType");
        }
        get keys() {
            return this.h;
        }
        set keys(a) {
            this.h = a;
            this.g("Keys");
        }
        get valuesRef() {
            return this.n;
        }
        set valuesRef(a) {
            this.n = a;
            this.g("ValuesRef");
        }
    }
    DataSourceAggregatedResultDescription.$t = /*@__PURE__*/ markType(DataSourceAggregatedResultDescription, 'DataSourceAggregatedResultDescription', Description.$);
    DataSourceAggregatedResultDescription.__marshalByValue = true;
    DataSourceAggregatedResultDescription.__marshalByValueAlias = "DataSourceAggregatedResult";
    return DataSourceAggregatedResultDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceAggregatedResultDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataSourceAggregatedResultDescriptionMetadata extends Base {
        static b(a) {
            if (DataSourceAggregatedResultDescriptionMetadata.a == null) {
                DataSourceAggregatedResultDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataSourceAggregatedResultDescriptionMetadata.c(DataSourceAggregatedResultDescriptionMetadata.a);
            }
            if (a.k(DataSourceAggregatedResultDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataSourceAggregatedResultDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("TransactionType", "ExportedType:string:TransactionType");
            a.item("TransactionType@names", "Add;Update;Delete");
            a.item("Keys", "Array:string");
            a.item("ValuesRef", "(w:Values,wf:Values)DataRef:object");
        }
        static d(a) {
            DataSourceAggregatedResultDescriptionMetadata.b(a);
            a.ae("DataSourceAggregatedResult", () => new DataSourceAggregatedResultDescription());
            a.ad("DataSourceAggregatedResult", DataSourceAggregatedResultDescriptionMetadata.a);
        }
    }
    DataSourceAggregatedResultDescriptionMetadata.$t = /*@__PURE__*/ markType(DataSourceAggregatedResultDescriptionMetadata, 'DataSourceAggregatedResultDescriptionMetadata');
    DataSourceAggregatedResultDescriptionMetadata.a = null;
    return DataSourceAggregatedResultDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridDataCommittedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridDataCommittedEventArgsDescription extends Description {
        get_type() {
            return "GridDataCommittedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = 0;
            this.h = null;
        }
        get commitID() {
            return this.j;
        }
        set commitID(a) {
            this.j = a;
            this.g("CommitID");
        }
        get changes() {
            return this.h;
        }
        set changes(a) {
            this.h = a;
            this.g("Changes");
        }
    }
    GridDataCommittedEventArgsDescription.$t = /*@__PURE__*/ markType(GridDataCommittedEventArgsDescription, 'GridDataCommittedEventArgsDescription', Description.$);
    return GridDataCommittedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridDataCommittedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridDataCommittedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridDataCommittedEventArgsDescriptionMetadata.a == null) {
                GridDataCommittedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridDataCommittedEventArgsDescriptionMetadata.c(GridDataCommittedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridDataCommittedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridDataCommittedEventArgsDescriptionMetadata.a);
            DataSourceAggregatedResultDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("CommitID", "Number:int");
            a.item("Changes", "Array:DataSourceAggregatedResultDescription:DataSourceAggregatedResult");
        }
        static d(a) {
            GridDataCommittedEventArgsDescriptionMetadata.b(a);
            a.ae("GridDataCommittedEventArgs", () => new GridDataCommittedEventArgsDescription());
            a.ad("GridDataCommittedEventArgs", GridDataCommittedEventArgsDescriptionMetadata.a);
        }
    }
    GridDataCommittedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridDataCommittedEventArgsDescriptionMetadata, 'GridDataCommittedEventArgsDescriptionMetadata');
    GridDataCommittedEventArgsDescriptionMetadata.a = null;
    return GridDataCommittedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridDataCommittingEventArgsDescription = /*@__PURE__*/ (() => {
    class GridDataCommittingEventArgsDescription extends Description {
        get_type() {
            return "GridDataCommittingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = 0;
        }
        get changes() {
            return this.h;
        }
        set changes(a) {
            this.h = a;
            this.g("Changes");
        }
        get commitID() {
            return this.j;
        }
        set commitID(a) {
            this.j = a;
            this.g("CommitID");
        }
    }
    GridDataCommittingEventArgsDescription.$t = /*@__PURE__*/ markType(GridDataCommittingEventArgsDescription, 'GridDataCommittingEventArgsDescription', Description.$);
    return GridDataCommittingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridDataCommittingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridDataCommittingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridDataCommittingEventArgsDescriptionMetadata.a == null) {
                GridDataCommittingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridDataCommittingEventArgsDescriptionMetadata.c(GridDataCommittingEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridDataCommittingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridDataCommittingEventArgsDescriptionMetadata.a);
            DataSourceAggregatedResultDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Changes", "Array:DataSourceAggregatedResultDescription:DataSourceAggregatedResult");
            a.item("CommitID", "Number:int");
        }
        static d(a) {
            GridDataCommittingEventArgsDescriptionMetadata.b(a);
            a.ae("GridDataCommittingEventArgs", () => new GridDataCommittingEventArgsDescription());
            a.ad("GridDataCommittingEventArgs", GridDataCommittingEventArgsDescriptionMetadata.a);
        }
    }
    GridDataCommittingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridDataCommittingEventArgsDescriptionMetadata, 'GridDataCommittingEventArgsDescriptionMetadata');
    GridDataCommittingEventArgsDescriptionMetadata.a = null;
    return GridDataCommittingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSizeChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridSizeChangedEventArgsDescription extends Description {
        get_type() {
            return "GridSizeChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = 0;
            this.h = 0;
        }
        get width() {
            return this.i;
        }
        set width(a) {
            this.i = a;
            this.g("Width");
        }
        get height() {
            return this.h;
        }
        set height(a) {
            this.h = a;
            this.g("Height");
        }
    }
    GridSizeChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridSizeChangedEventArgsDescription, 'GridSizeChangedEventArgsDescription', Description.$);
    return GridSizeChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSizeChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridSizeChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridSizeChangedEventArgsDescriptionMetadata.a == null) {
                GridSizeChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridSizeChangedEventArgsDescriptionMetadata.c(GridSizeChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridSizeChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridSizeChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Width", "Number:double");
            a.item("Height", "Number:double");
        }
        static d(a) {
            GridSizeChangedEventArgsDescriptionMetadata.b(a);
            a.ae("GridSizeChangedEventArgs", () => new GridSizeChangedEventArgsDescription());
            a.ad("GridSizeChangedEventArgs", GridSizeChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridSizeChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridSizeChangedEventArgsDescriptionMetadata, 'GridSizeChangedEventArgsDescriptionMetadata');
    GridSizeChangedEventArgsDescriptionMetadata.a = null;
    return GridSizeChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridColumnsChangedEventArgsDescription extends Description {
        get_type() {
            return "GridColumnsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get columns() {
            return this.h;
        }
        set columns(a) {
            this.h = a;
            this.g("Columns");
        }
    }
    GridColumnsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridColumnsChangedEventArgsDescription, 'GridColumnsChangedEventArgsDescription', Description.$);
    return GridColumnsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnsChangedEventArgsDescriptionMetadata.a == null) {
                GridColumnsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnsChangedEventArgsDescriptionMetadata.c(GridColumnsChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridColumnsChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnsChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Columns", "Collection:DataGridColumn:GridColumnCollection:DataGridColumn");
        }
        static d(a) {
            GridColumnsChangedEventArgsDescriptionMetadata.b(a);
            a.ae("GridColumnsChangedEventArgs", () => new GridColumnsChangedEventArgsDescription());
            a.ad("GridColumnsChangedEventArgs", GridColumnsChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridColumnsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnsChangedEventArgsDescriptionMetadata, 'GridColumnsChangedEventArgsDescriptionMetadata');
    GridColumnsChangedEventArgsDescriptionMetadata.a = null;
    return GridColumnsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnsAutoGeneratedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridColumnsAutoGeneratedEventArgsDescription extends Description {
        get_type() {
            return "GridColumnsAutoGeneratedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get columns() {
            return this.h;
        }
        set columns(a) {
            this.h = a;
            this.g("Columns");
        }
    }
    GridColumnsAutoGeneratedEventArgsDescription.$t = /*@__PURE__*/ markType(GridColumnsAutoGeneratedEventArgsDescription, 'GridColumnsAutoGeneratedEventArgsDescription', Description.$);
    return GridColumnsAutoGeneratedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnsAutoGeneratedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnsAutoGeneratedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnsAutoGeneratedEventArgsDescriptionMetadata.a == null) {
                GridColumnsAutoGeneratedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnsAutoGeneratedEventArgsDescriptionMetadata.c(GridColumnsAutoGeneratedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridColumnsAutoGeneratedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnsAutoGeneratedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Columns", "Collection:DataGridColumn:GridColumnCollection:DataGridColumn");
        }
        static d(a) {
            GridColumnsAutoGeneratedEventArgsDescriptionMetadata.b(a);
            a.ae("GridColumnsAutoGeneratedEventArgs", () => new GridColumnsAutoGeneratedEventArgsDescription());
            a.ad("GridColumnsAutoGeneratedEventArgs", GridColumnsAutoGeneratedEventArgsDescriptionMetadata.a);
        }
    }
    GridColumnsAutoGeneratedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnsAutoGeneratedEventArgsDescriptionMetadata, 'GridColumnsAutoGeneratedEventArgsDescriptionMetadata');
    GridColumnsAutoGeneratedEventArgsDescriptionMetadata.a = null;
    return GridColumnsAutoGeneratedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedItemsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridSelectedItemsChangedEventArgsDescription extends Description {
        get_type() {
            return "GridSelectedItemsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
            this.j = null;
        }
        get currentItems() {
            return this.i;
        }
        set currentItems(a) {
            this.i = a;
            this.g("CurrentItems");
        }
        get addedItems() {
            return this.h;
        }
        set addedItems(a) {
            this.h = a;
            this.g("AddedItems");
        }
        get removedItems() {
            return this.j;
        }
        set removedItems(a) {
            this.j = a;
            this.g("RemovedItems");
        }
    }
    GridSelectedItemsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridSelectedItemsChangedEventArgsDescription, 'GridSelectedItemsChangedEventArgsDescription', Description.$);
    return GridSelectedItemsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedItemsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridSelectedItemsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridSelectedItemsChangedEventArgsDescriptionMetadata.a == null) {
                GridSelectedItemsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridSelectedItemsChangedEventArgsDescriptionMetadata.c(GridSelectedItemsChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridSelectedItemsChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridSelectedItemsChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("CurrentItems", "Collection:object:GridSelectedItemsCollection:Object");
            a.item("AddedItems", "Collection:object:GridSelectedItemsCollection:Object");
            a.item("RemovedItems", "Collection:object:GridSelectedItemsCollection:Object");
        }
        static d(a) {
            GridSelectedItemsChangedEventArgsDescriptionMetadata.b(a);
            a.ae("GridSelectedItemsChangedEventArgs", () => new GridSelectedItemsChangedEventArgsDescription());
            a.ad("GridSelectedItemsChangedEventArgs", GridSelectedItemsChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridSelectedItemsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridSelectedItemsChangedEventArgsDescriptionMetadata, 'GridSelectedItemsChangedEventArgsDescriptionMetadata');
    GridSelectedItemsChangedEventArgsDescriptionMetadata.a = null;
    return GridSelectedItemsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedKeysChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridSelectedKeysChangedEventArgsDescription extends Description {
        get_type() {
            return "GridSelectedKeysChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
            this.j = null;
        }
        get currentKeys() {
            return this.i;
        }
        set currentKeys(a) {
            this.i = a;
            this.g("CurrentKeys");
        }
        get addedKeys() {
            return this.h;
        }
        set addedKeys(a) {
            this.h = a;
            this.g("AddedKeys");
        }
        get removedKeys() {
            return this.j;
        }
        set removedKeys(a) {
            this.j = a;
            this.g("RemovedKeys");
        }
    }
    GridSelectedKeysChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridSelectedKeysChangedEventArgsDescription, 'GridSelectedKeysChangedEventArgsDescription', Description.$);
    return GridSelectedKeysChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedKeysChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridSelectedKeysChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridSelectedKeysChangedEventArgsDescriptionMetadata.a == null) {
                GridSelectedKeysChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridSelectedKeysChangedEventArgsDescriptionMetadata.c(GridSelectedKeysChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridSelectedKeysChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridSelectedKeysChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("CurrentKeys", "Collection:PrimaryKeyValue:GridSelectedKeysCollection:PrimaryKeyValue");
            a.item("AddedKeys", "Collection:PrimaryKeyValue:GridSelectedKeysCollection:PrimaryKeyValue");
            a.item("RemovedKeys", "Collection:PrimaryKeyValue:GridSelectedKeysCollection:PrimaryKeyValue");
        }
        static d(a) {
            GridSelectedKeysChangedEventArgsDescriptionMetadata.b(a);
            a.ae("GridSelectedKeysChangedEventArgs", () => new GridSelectedKeysChangedEventArgsDescription());
            a.ad("GridSelectedKeysChangedEventArgs", GridSelectedKeysChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridSelectedKeysChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridSelectedKeysChangedEventArgsDescriptionMetadata, 'GridSelectedKeysChangedEventArgsDescriptionMetadata');
    GridSelectedKeysChangedEventArgsDescriptionMetadata.a = null;
    return GridSelectedKeysChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedCellsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridSelectedCellsChangedEventArgsDescription extends Description {
        get_type() {
            return "GridSelectedCellsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
            this.j = null;
        }
        get currentCells() {
            return this.i;
        }
        set currentCells(a) {
            this.i = a;
            this.g("CurrentCells");
        }
        get addedCells() {
            return this.h;
        }
        set addedCells(a) {
            this.h = a;
            this.g("AddedCells");
        }
        get removedCells() {
            return this.j;
        }
        set removedCells(a) {
            this.j = a;
            this.g("RemovedCells");
        }
    }
    GridSelectedCellsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridSelectedCellsChangedEventArgsDescription, 'GridSelectedCellsChangedEventArgsDescription', Description.$);
    return GridSelectedCellsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedCellsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridSelectedCellsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridSelectedCellsChangedEventArgsDescriptionMetadata.a == null) {
                GridSelectedCellsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridSelectedCellsChangedEventArgsDescriptionMetadata.c(GridSelectedCellsChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridSelectedCellsChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridSelectedCellsChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("CurrentCells", "Collection:CellKey:GridSelectedCellsCollection:CellKey");
            a.item("AddedCells", "Collection:CellKey:GridSelectedCellsCollection:CellKey");
            a.item("RemovedCells", "Collection:CellKey:GridSelectedCellsCollection:CellKey");
        }
        static d(a) {
            GridSelectedCellsChangedEventArgsDescriptionMetadata.b(a);
            a.ae("GridSelectedCellsChangedEventArgs", () => new GridSelectedCellsChangedEventArgsDescription());
            a.ad("GridSelectedCellsChangedEventArgs", GridSelectedCellsChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridSelectedCellsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridSelectedCellsChangedEventArgsDescriptionMetadata, 'GridSelectedCellsChangedEventArgsDescriptionMetadata');
    GridSelectedCellsChangedEventArgsDescriptionMetadata.a = null;
    return GridSelectedCellsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectionChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridSelectionChangedEventArgsDescription extends Description {
        get_type() {
            return "GridSelectionChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    GridSelectionChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridSelectionChangedEventArgsDescription, 'GridSelectionChangedEventArgsDescription', Description.$);
    return GridSelectionChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectionChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridSelectionChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridSelectionChangedEventArgsDescriptionMetadata.a == null) {
                GridSelectionChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridSelectionChangedEventArgsDescriptionMetadata.c(GridSelectionChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridSelectionChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridSelectionChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            GridSelectionChangedEventArgsDescriptionMetadata.b(a);
            a.ae("GridSelectionChangedEventArgs", () => new GridSelectionChangedEventArgsDescription());
            a.ad("GridSelectionChangedEventArgs", GridSelectionChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridSelectionChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridSelectionChangedEventArgsDescriptionMetadata, 'GridSelectionChangedEventArgsDescriptionMetadata');
    GridSelectionChangedEventArgsDescriptionMetadata.a = null;
    return GridSelectionChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridActiveCellChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridActiveCellChangedEventArgsDescription extends Description {
        get_type() {
            return "GridActiveCellChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.i = null;
        }
        get newActiveCell() {
            return this.h;
        }
        set newActiveCell(a) {
            this.h = a;
            this.g("NewActiveCell");
        }
        get oldActiveCell() {
            return this.i;
        }
        set oldActiveCell(a) {
            this.i = a;
            this.g("OldActiveCell");
        }
    }
    GridActiveCellChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridActiveCellChangedEventArgsDescription, 'GridActiveCellChangedEventArgsDescription', Description.$);
    return GridActiveCellChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridActiveCellChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridActiveCellChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridActiveCellChangedEventArgsDescriptionMetadata.a == null) {
                GridActiveCellChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridActiveCellChangedEventArgsDescriptionMetadata.c(GridActiveCellChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridActiveCellChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridActiveCellChangedEventArgsDescriptionMetadata.a);
            GridCellPositionDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("NewActiveCell", "ExportedType:GridCellPosition");
            a.item("OldActiveCell", "ExportedType:GridCellPosition");
        }
        static d(a) {
            GridActiveCellChangedEventArgsDescriptionMetadata.b(a);
            a.ae("GridActiveCellChangedEventArgs", () => new GridActiveCellChangedEventArgsDescription());
            a.ad("GridActiveCellChangedEventArgs", GridActiveCellChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridActiveCellChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridActiveCellChangedEventArgsDescriptionMetadata, 'GridActiveCellChangedEventArgsDescriptionMetadata');
    GridActiveCellChangedEventArgsDescriptionMetadata.a = null;
    return GridActiveCellChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedCellRangesChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridSelectedCellRangesChangedEventArgsDescription extends Description {
        get_type() {
            return "GridSelectedCellRangesChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
            this.j = null;
            this.k = null;
        }
        get currentRanges() {
            return this.i;
        }
        set currentRanges(a) {
            this.i = a;
            this.g("CurrentRanges");
        }
        get addedRanges() {
            return this.h;
        }
        set addedRanges(a) {
            this.h = a;
            this.g("AddedRanges");
        }
        get removedRanges() {
            return this.j;
        }
        set removedRanges(a) {
            this.j = a;
            this.g("RemovedRanges");
        }
        get updatedRanges() {
            return this.k;
        }
        set updatedRanges(a) {
            this.k = a;
            this.g("UpdatedRanges");
        }
    }
    GridSelectedCellRangesChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridSelectedCellRangesChangedEventArgsDescription, 'GridSelectedCellRangesChangedEventArgsDescription', Description.$);
    return GridSelectedCellRangesChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedCellRangesChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridSelectedCellRangesChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridSelectedCellRangesChangedEventArgsDescriptionMetadata.a == null) {
                GridSelectedCellRangesChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridSelectedCellRangesChangedEventArgsDescriptionMetadata.c(GridSelectedCellRangesChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridSelectedCellRangesChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridSelectedCellRangesChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("CurrentRanges", "Collection:CellRange:GridSelectedCellRangesCollection:CellRange");
            a.item("AddedRanges", "Collection:CellRange:GridSelectedCellRangesCollection:CellRange");
            a.item("RemovedRanges", "Collection:CellRange:GridSelectedCellRangesCollection:CellRange");
            a.item("UpdatedRanges", "Collection:CellRange:GridSelectedCellRangesCollection:CellRange");
        }
        static d(a) {
            GridSelectedCellRangesChangedEventArgsDescriptionMetadata.b(a);
            a.ae("GridSelectedCellRangesChangedEventArgs", () => new GridSelectedCellRangesChangedEventArgsDescription());
            a.ad("GridSelectedCellRangesChangedEventArgs", GridSelectedCellRangesChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridSelectedCellRangesChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridSelectedCellRangesChangedEventArgsDescriptionMetadata, 'GridSelectedCellRangesChangedEventArgsDescriptionMetadata');
    GridSelectedCellRangesChangedEventArgsDescriptionMetadata.a = null;
    return GridSelectedCellRangesChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnWidthChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridColumnWidthChangedEventArgsDescription extends Description {
        get_type() {
            return "GridColumnWidthChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.i = null;
            this.h = null;
        }
        get column() {
            return this.l;
        }
        set column(a) {
            this.l = a;
            this.g("Column");
        }
        get oldWidth() {
            return this.i;
        }
        set oldWidth(a) {
            this.i = a;
            this.g("OldWidth");
        }
        get newWidth() {
            return this.h;
        }
        set newWidth(a) {
            this.h = a;
            this.g("NewWidth");
        }
    }
    GridColumnWidthChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridColumnWidthChangedEventArgsDescription, 'GridColumnWidthChangedEventArgsDescription', Description.$);
    return GridColumnWidthChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnWidthChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnWidthChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnWidthChangedEventArgsDescriptionMetadata.a == null) {
                GridColumnWidthChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnWidthChangedEventArgsDescriptionMetadata.c(GridColumnWidthChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridColumnWidthChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnWidthChangedEventArgsDescriptionMetadata.a);
            DataGridColumnDescriptionMetadata.d(a);
            ColumnWidthDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Column", "ExportedType:DataGridColumn");
            a.item("OldWidth", "ExportedType:ColumnWidth");
            a.item("NewWidth", "ExportedType:ColumnWidth");
        }
        static d(a) {
            GridColumnWidthChangedEventArgsDescriptionMetadata.b(a);
            a.ae("GridColumnWidthChangedEventArgs", () => new GridColumnWidthChangedEventArgsDescription());
            a.ad("GridColumnWidthChangedEventArgs", GridColumnWidthChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridColumnWidthChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnWidthChangedEventArgsDescriptionMetadata, 'GridColumnWidthChangedEventArgsDescriptionMetadata');
    GridColumnWidthChangedEventArgsDescriptionMetadata.a = null;
    return GridColumnWidthChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellEditStartedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridCellEditStartedEventArgsDescription extends Description {
        get_type() {
            return "GridCellEditStartedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = 0;
            this.l = null;
        }
        get column() {
            return this.h;
        }
        set column(a) {
            this.h = a;
            this.g("Column");
        }
        get row() {
            return this.j;
        }
        set row(a) {
            this.j = a;
            this.g("Row");
        }
        get itemRef() {
            return this.l;
        }
        set itemRef(a) {
            this.l = a;
            this.g("ItemRef");
        }
    }
    GridCellEditStartedEventArgsDescription.$t = /*@__PURE__*/ markType(GridCellEditStartedEventArgsDescription, 'GridCellEditStartedEventArgsDescription', Description.$);
    return GridCellEditStartedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellEditStartedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridCellEditStartedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridCellEditStartedEventArgsDescriptionMetadata.a == null) {
                GridCellEditStartedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridCellEditStartedEventArgsDescriptionMetadata.c(GridCellEditStartedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridCellEditStartedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridCellEditStartedEventArgsDescriptionMetadata.a);
            DataGridColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Column", "ExportedType:DataGridColumn");
            a.item("Row", "Number:int");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
        }
        static d(a) {
            GridCellEditStartedEventArgsDescriptionMetadata.b(a);
            a.ae("GridCellEditStartedEventArgs", () => new GridCellEditStartedEventArgsDescription());
            a.ad("GridCellEditStartedEventArgs", GridCellEditStartedEventArgsDescriptionMetadata.a);
        }
    }
    GridCellEditStartedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridCellEditStartedEventArgsDescriptionMetadata, 'GridCellEditStartedEventArgsDescriptionMetadata');
    GridCellEditStartedEventArgsDescriptionMetadata.a = null;
    return GridCellEditStartedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellEditEndedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridCellEditEndedEventArgsDescription extends Description {
        get_type() {
            return "GridCellEditEndedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = 0;
            this.l = null;
        }
        get column() {
            return this.h;
        }
        set column(a) {
            this.h = a;
            this.g("Column");
        }
        get row() {
            return this.j;
        }
        set row(a) {
            this.j = a;
            this.g("Row");
        }
        get itemRef() {
            return this.l;
        }
        set itemRef(a) {
            this.l = a;
            this.g("ItemRef");
        }
    }
    GridCellEditEndedEventArgsDescription.$t = /*@__PURE__*/ markType(GridCellEditEndedEventArgsDescription, 'GridCellEditEndedEventArgsDescription', Description.$);
    return GridCellEditEndedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellEditEndedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridCellEditEndedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridCellEditEndedEventArgsDescriptionMetadata.a == null) {
                GridCellEditEndedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridCellEditEndedEventArgsDescriptionMetadata.c(GridCellEditEndedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridCellEditEndedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridCellEditEndedEventArgsDescriptionMetadata.a);
            DataGridColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Column", "ExportedType:DataGridColumn");
            a.item("Row", "Number:int");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
        }
        static d(a) {
            GridCellEditEndedEventArgsDescriptionMetadata.b(a);
            a.ae("GridCellEditEndedEventArgs", () => new GridCellEditEndedEventArgsDescription());
            a.ad("GridCellEditEndedEventArgs", GridCellEditEndedEventArgsDescriptionMetadata.a);
        }
    }
    GridCellEditEndedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridCellEditEndedEventArgsDescriptionMetadata, 'GridCellEditEndedEventArgsDescriptionMetadata');
    GridCellEditEndedEventArgsDescriptionMetadata.a = null;
    return GridCellEditEndedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridRowEditStartedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridRowEditStartedEventArgsDescription extends Description {
        get_type() {
            return "GridRowEditStartedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = 0;
            this.j = null;
        }
        get row() {
            return this.h;
        }
        set row(a) {
            this.h = a;
            this.g("Row");
        }
        get itemRef() {
            return this.j;
        }
        set itemRef(a) {
            this.j = a;
            this.g("ItemRef");
        }
    }
    GridRowEditStartedEventArgsDescription.$t = /*@__PURE__*/ markType(GridRowEditStartedEventArgsDescription, 'GridRowEditStartedEventArgsDescription', Description.$);
    return GridRowEditStartedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridRowEditStartedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridRowEditStartedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridRowEditStartedEventArgsDescriptionMetadata.a == null) {
                GridRowEditStartedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridRowEditStartedEventArgsDescriptionMetadata.c(GridRowEditStartedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridRowEditStartedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridRowEditStartedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Row", "Number:int");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
        }
        static d(a) {
            GridRowEditStartedEventArgsDescriptionMetadata.b(a);
            a.ae("GridRowEditStartedEventArgs", () => new GridRowEditStartedEventArgsDescription());
            a.ad("GridRowEditStartedEventArgs", GridRowEditStartedEventArgsDescriptionMetadata.a);
        }
    }
    GridRowEditStartedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridRowEditStartedEventArgsDescriptionMetadata, 'GridRowEditStartedEventArgsDescriptionMetadata');
    GridRowEditStartedEventArgsDescriptionMetadata.a = null;
    return GridRowEditStartedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridRowEditEndedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridRowEditEndedEventArgsDescription extends Description {
        get_type() {
            return "GridRowEditEndedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = 0;
            this.j = null;
        }
        get row() {
            return this.h;
        }
        set row(a) {
            this.h = a;
            this.g("Row");
        }
        get itemRef() {
            return this.j;
        }
        set itemRef(a) {
            this.j = a;
            this.g("ItemRef");
        }
    }
    GridRowEditEndedEventArgsDescription.$t = /*@__PURE__*/ markType(GridRowEditEndedEventArgsDescription, 'GridRowEditEndedEventArgsDescription', Description.$);
    return GridRowEditEndedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridRowEditEndedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridRowEditEndedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridRowEditEndedEventArgsDescriptionMetadata.a == null) {
                GridRowEditEndedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridRowEditEndedEventArgsDescriptionMetadata.c(GridRowEditEndedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridRowEditEndedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridRowEditEndedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Row", "Number:int");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
        }
        static d(a) {
            GridRowEditEndedEventArgsDescriptionMetadata.b(a);
            a.ae("GridRowEditEndedEventArgs", () => new GridRowEditEndedEventArgsDescription());
            a.ad("GridRowEditEndedEventArgs", GridRowEditEndedEventArgsDescriptionMetadata.a);
        }
    }
    GridRowEditEndedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridRowEditEndedEventArgsDescriptionMetadata, 'GridRowEditEndedEventArgsDescriptionMetadata');
    GridRowEditEndedEventArgsDescriptionMetadata.a = null;
    return GridRowEditEndedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterOperandDescription = /*@__PURE__*/ (() => {
    class FilterOperandDescription extends Description {
        get_type() {
            return "FilterOperand";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.p = null;
            this.l = null;
            this.o = null;
            this.i = false;
            this.m = null;
            this.n = null;
        }
        get iD() {
            return this.p;
        }
        set iD(a) {
            this.p = a;
            this.g("ID");
        }
        get displayName() {
            return this.l;
        }
        set displayName(a) {
            this.l = a;
            this.g("DisplayName");
        }
        get icon() {
            return this.o;
        }
        set icon(a) {
            this.o = a;
            this.g("Icon");
        }
        get isInputRequired() {
            return this.i;
        }
        set isInputRequired(a) {
            this.i = a;
            this.g("IsInputRequired");
        }
        get editorType() {
            return this.m;
        }
        set editorType(a) {
            this.m = a;
            this.g("EditorType");
        }
        get filterRequestedRef() {
            return this.n;
        }
        set filterRequestedRef(a) {
            this.n = a;
            this.g("FilterRequestedRef");
        }
    }
    FilterOperandDescription.$t = /*@__PURE__*/ markType(FilterOperandDescription, 'FilterOperandDescription', Description.$);
    FilterOperandDescription.__marshalByValue = true;
    FilterOperandDescription.__marshalByValueAlias = "FilterOperand";
    return FilterOperandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCustomFilterRequestedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridCustomFilterRequestedEventArgsDescription extends Description {
        get_type() {
            return "GridCustomFilterRequestedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.l = null;
            this.n = null;
            this.j = null;
        }
        get column() {
            return this.h;
        }
        set column(a) {
            this.h = a;
            this.g("Column");
        }
        get filter() {
            return this.l;
        }
        set filter(a) {
            this.l = a;
            this.g("Filter");
        }
        get valueRef() {
            return this.n;
        }
        set valueRef(a) {
            this.n = a;
            this.g("ValueRef");
        }
        get expression() {
            return this.j;
        }
        set expression(a) {
            this.j = a;
            this.g("Expression");
        }
    }
    GridCustomFilterRequestedEventArgsDescription.$t = /*@__PURE__*/ markType(GridCustomFilterRequestedEventArgsDescription, 'GridCustomFilterRequestedEventArgsDescription', Description.$);
    return GridCustomFilterRequestedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterOperandDescriptionMetadata = /*@__PURE__*/ (() => {
    class FilterOperandDescriptionMetadata extends Base {
        static b(a) {
            if (FilterOperandDescriptionMetadata.a == null) {
                FilterOperandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FilterOperandDescriptionMetadata.c(FilterOperandDescriptionMetadata.a);
            }
            if (a.k(FilterOperandDescriptionMetadata.a)) {
                return;
            }
            a.ac(FilterOperandDescriptionMetadata.a);
            GridCustomFilterRequestedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("ID", "String");
            a.item("DisplayName", "String");
            a.item("Icon", "String");
            a.item("IsInputRequired", "Boolean");
            a.item("EditorType", "ExportedType:string:EditorType");
            a.item("EditorType@names", "Default;Text;Numeric;Date;Combo");
            a.item("FilterRequestedRef", "EventRef::filterRequested");
        }
        static d(a) {
            FilterOperandDescriptionMetadata.b(a);
            a.ae("FilterOperand", () => new FilterOperandDescription());
            a.ad("FilterOperand", FilterOperandDescriptionMetadata.a);
        }
    }
    FilterOperandDescriptionMetadata.$t = /*@__PURE__*/ markType(FilterOperandDescriptionMetadata, 'FilterOperandDescriptionMetadata');
    FilterOperandDescriptionMetadata.a = null;
    return FilterOperandDescriptionMetadata;
})();
/**
 * @hidden
 */
let GridCustomFilterRequestedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridCustomFilterRequestedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridCustomFilterRequestedEventArgsDescriptionMetadata.a == null) {
                GridCustomFilterRequestedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridCustomFilterRequestedEventArgsDescriptionMetadata.c(GridCustomFilterRequestedEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridCustomFilterRequestedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridCustomFilterRequestedEventArgsDescriptionMetadata.a);
            DataGridColumnDescriptionMetadata.d(a);
            FilterOperandDescriptionMetadata.d(a);
            FilterExpressionDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Column", "ExportedType:DataGridColumn");
            a.item("Filter", "ExportedType:FilterOperand");
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
            a.item("Expression", "ExportedType:IFilterExpression");
        }
        static d(a) {
            GridCustomFilterRequestedEventArgsDescriptionMetadata.b(a);
            a.ae("GridCustomFilterRequestedEventArgs", () => new GridCustomFilterRequestedEventArgsDescription());
            a.ad("GridCustomFilterRequestedEventArgs", GridCustomFilterRequestedEventArgsDescriptionMetadata.a);
        }
    }
    GridCustomFilterRequestedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridCustomFilterRequestedEventArgsDescriptionMetadata, 'GridCustomFilterRequestedEventArgsDescriptionMetadata');
    GridCustomFilterRequestedEventArgsDescriptionMetadata.a = null;
    return GridCustomFilterRequestedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridDescription = /*@__PURE__*/ (() => {
    class DataGridDescription extends Description {
        get width() {
            return this.iw;
        }
        set width(a) {
            this.iw = a;
            this.g("Width");
        }
        get height() {
            return this.g2;
        }
        set height(a) {
            this.g2 = a;
            this.g("Height");
        }
        get background() {
            return this.e6;
        }
        set background(a) {
            this.e6 = a;
            this.g("Background");
        }
        get isGroupByAreaVisible() {
            return this.bt;
        }
        set isGroupByAreaVisible(a) {
            this.bt = a;
            this.g("IsGroupByAreaVisible");
        }
        get isPagerVisible() {
            return this.by;
        }
        set isPagerVisible(a) {
            this.by = a;
            this.g("IsPagerVisible");
        }
        get isToolbarVisible() {
            return this.b3;
        }
        set isToolbarVisible(a) {
            this.b3 = a;
            this.g("IsToolbarVisible");
        }
        get_type() {
            return "DataGrid";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.iw = null;
            this.g2 = null;
            this.e6 = null;
            this.bt = false;
            this.by = false;
            this.b3 = false;
            this.f1 = null;
            this.ft = null;
            this.b0 = false;
            this.he = null;
            this.hf = null;
            this.gh = null;
            this.dh = 0;
            this.di = 0;
            this.dj = 0;
            this.dk = 0;
            this.bd = null;
            this.bf = null;
            this.bh = null;
            this.bb = null;
            this.a5 = null;
            this.a7 = null;
            this.az = null;
            this.ax = null;
            this.a9 = null;
            this.j = null;
            this.l = null;
            this.gb = null;
            this.ej = 0;
            this.eq = 0;
            this.de = 0;
            this.ei = 0;
            this.em = 0;
            this.f9 = null;
            this.av = null;
            this.gt = null;
            this.gf = null;
            this.gg = null;
            this.bo = false;
            this.bl = false;
            this.er = 0;
            this.bz = false;
            this.fo = null;
            this.fz = null;
            this.fa = null;
            this.hg = null;
            this.hd = null;
            this.fl = null;
            this.a1 = null;
            this.f0 = null;
            this.f4 = null;
            this.fs = null;
            this.fr = null;
            this.fp = null;
            this.hz = null;
            this.e2 = null;
            this.hx = null;
            this.b4 = false;
            this.x = null;
            this.y = null;
            this.w = null;
            this.v = null;
            this.r = null;
            this.s = null;
            this.bq = false;
            this.bw = false;
            this.bx = false;
            this.fk = null;
            this.hr = null;
            this.h4 = null;
            this.ig = null;
            this.dm = 0;
            this.gc = null;
            this.df = 0;
            this.gd = null;
            this.ge = null;
            this.dg = 0;
            this.ga = null;
            this.h2 = null;
            this.ha = null;
            this.g6 = null;
            this.a3 = null;
            this.e8 = null;
            this.fm = null;
            this.gz = null;
            this.g0 = null;
            this.fd = null;
            this.c7 = 0;
            this.fe = null;
            this.ff = null;
            this.hn = null;
            this.hs = null;
            this.ho = null;
            this.dn = 0;
            this.hp = null;
            this.hq = null;
            this.h5 = null;
            this.dp = 0;
            this.h6 = null;
            this.h7 = null;
            this.ih = null;
            this.dr = 0;
            this.ii = null;
            this.ij = null;
            this.id = null;
            this.ia = null;
            this.dq = 0;
            this.ib = null;
            this.ic = null;
            this.im = null;
            this.ds = 0;
            this.io = null;
            this.ip = null;
            this.iq = null;
            this.h8 = null;
            this.ik = null;
            this.h9 = null;
            this.il = null;
            this.ep = 0;
            this.en = 0;
            this.gy = null;
            this.gs = null;
            this.g1 = null;
            this.gu = null;
            this.dl = 0;
            this.gv = null;
            this.gw = null;
            this.hh = null;
            this.gx = null;
            this.hk = null;
            this.hi = null;
            this.hj = null;
            this.el = 0;
            this.c9 = 0;
            this.ek = 0;
            this.c8 = 0;
            this.f2 = null;
            this.fu = null;
            this.b9 = false;
            this.fv = null;
            this.fx = null;
            this.fw = null;
            this.e7 = null;
            this.c3 = 0;
            this.c4 = 0;
            this.c5 = 0;
            this.c6 = 0;
            this.b5 = false;
            this.db = 0;
            this.da = 0;
            this.dc = 0;
            this.dd = 0;
            this.bp = false;
            this.u = null;
            this.p = null;
            this.o = null;
            this.q = null;
            this.g4 = null;
            this.g3 = null;
            this.g5 = null;
            this.z = null;
            this.n = null;
            this.m = null;
            this.aa = null;
            this.ie = null;
            this.bu = false;
            this.gq = null;
            this.bv = false;
            this.gr = null;
            this.bk = false;
            this.t = null;
            this.i = null;
            this.h = null;
            this.k = null;
            this.b8 = false;
            this.b7 = false;
            this.b6 = false;
            this.gi = null;
            this.gj = null;
            this.bs = false;
            this.br = false;
            this.g8 = null;
            this.g7 = null;
            this.g9 = null;
            this.go = null;
            this.gn = null;
            this.gk = null;
            this.c1 = new Date();
            this.bm = false;
            this.eo = 0;
            this.b1 = false;
            this.b2 = false;
            this.iv = null;
            this.ir = null;
            this.is = null;
            this.it = null;
            this.iu = null;
            this.hm = null;
            this.hl = null;
            this.bj = false;
            this.bn = false;
            this.gm = null;
            this.gl = null;
            this.fi = null;
            this.fj = null;
            this.fg = null;
            this.fh = null;
            this.e9 = null;
            this.h1 = null;
            this.gp = null;
            this.h3 = null;
            this.fq = null;
            this.fy = null;
            this.fn = null;
            this.f7 = null;
            this.f8 = null;
            this.h0 = null;
            this.e4 = null;
            this.f3 = null;
            this.hv = null;
            this.hw = null;
            this.hu = null;
            this.hy = null;
            this.e3 = null;
            this.ht = null;
            this.f5 = null;
            this.fc = null;
            this.fb = null;
            this.hc = null;
            this.hb = null;
            this.f6 = null;
            this.e5 = null;
        }
        get columnResizingMode() {
            return this.f1;
        }
        set columnResizingMode(a) {
            this.f1 = a;
            this.g("ColumnResizingMode");
        }
        get columnMovingMode() {
            return this.ft;
        }
        set columnMovingMode(a) {
            this.ft = a;
            this.g("ColumnMovingMode");
        }
        get isRowHoverEnabled() {
            return this.b0;
        }
        set isRowHoverEnabled(a) {
            this.b0 = a;
            this.g("IsRowHoverEnabled");
        }
        get rowHoverBackground() {
            return this.he;
        }
        set rowHoverBackground(a) {
            this.he = a;
            this.g("RowHoverBackground");
        }
        get rowHoverTextColor() {
            return this.hf;
        }
        set rowHoverTextColor(a) {
            this.hf = a;
            this.g("RowHoverTextColor");
        }
        get editRowBorder() {
            return this.gh;
        }
        set editRowBorder(a) {
            this.gh = a;
            this.g("EditRowBorder");
        }
        get editRowBorderWidthBottom() {
            return this.dh;
        }
        set editRowBorderWidthBottom(a) {
            this.dh = a;
            this.g("EditRowBorderWidthBottom");
        }
        get editRowBorderWidthLeft() {
            return this.di;
        }
        set editRowBorderWidthLeft(a) {
            this.di = a;
            this.g("EditRowBorderWidthLeft");
        }
        get editRowBorderWidthRight() {
            return this.dj;
        }
        set editRowBorderWidthRight(a) {
            this.dj = a;
            this.g("EditRowBorderWidthRight");
        }
        get editRowBorderWidthTop() {
            return this.dk;
        }
        set editRowBorderWidthTop(a) {
            this.dk = a;
            this.g("EditRowBorderWidthTop");
        }
        get sectionHeader() {
            return this.bd;
        }
        set sectionHeader(a) {
            this.bd = a;
            this.g("SectionHeader");
        }
        get summaryRowRoot() {
            return this.bf;
        }
        set summaryRowRoot(a) {
            this.bf = a;
            this.g("SummaryRowRoot");
        }
        get summaryRowSection() {
            return this.bh;
        }
        set summaryRowSection(a) {
            this.bh = a;
            this.g("SummaryRowSection");
        }
        get rowSeparator() {
            return this.bb;
        }
        set rowSeparator(a) {
            this.bb = a;
            this.g("RowSeparator");
        }
        get headerRowSeparator() {
            return this.a5;
        }
        set headerRowSeparator(a) {
            this.a5 = a;
            this.g("HeaderRowSeparator");
        }
        get headerSeparator() {
            return this.a7;
        }
        set headerSeparator(a) {
            this.a7 = a;
            this.g("HeaderSeparator");
        }
        get columnResizingSeparator() {
            return this.az;
        }
        set columnResizingSeparator(a) {
            this.az = a;
            this.g("ColumnResizingSeparator");
        }
        get columnMovingSeparator() {
            return this.ax;
        }
        set columnMovingSeparator(a) {
            this.ax = a;
            this.g("ColumnMovingSeparator");
        }
        get pinnedAreaSeparator() {
            return this.a9;
        }
        set pinnedAreaSeparator(a) {
            this.a9 = a;
            this.g("PinnedAreaSeparator");
        }
        get autoGenerateDesiredProperties() {
            return this.j;
        }
        set autoGenerateDesiredProperties(a) {
            this.j = a;
            this.g("AutoGenerateDesiredProperties");
        }
        get dataSourceDesiredProperties() {
            return this.l;
        }
        set dataSourceDesiredProperties(a) {
            this.l = a;
            this.g("DataSourceDesiredProperties");
        }
        get density() {
            return this.gb;
        }
        set density(a) {
            this.gb = a;
            this.g("Density");
        }
        get actualRowHeight() {
            return this.ej;
        }
        set actualRowHeight(a) {
            this.ej = a;
            this.g("ActualRowHeight");
        }
        get rowHeight() {
            return this.eq;
        }
        set rowHeight(a) {
            this.eq = a;
            this.g("RowHeight");
        }
        get defaultColumnMinWidth() {
            return this.de;
        }
        set defaultColumnMinWidth(a) {
            this.de = a;
            this.g("DefaultColumnMinWidth");
        }
        get actualHeaderHeight() {
            return this.ei;
        }
        set actualHeaderHeight(a) {
            this.ei = a;
            this.g("ActualHeaderHeight");
        }
        get headerHeight() {
            return this.em;
        }
        set headerHeight(a) {
            this.em = a;
            this.g("HeaderHeight");
        }
        get dataSourceRef() {
            return this.f9;
        }
        set dataSourceRef(a) {
            this.f9 = a;
            this.g("DataSourceRef");
        }
        get dataSource() {
            return this.av;
        }
        set dataSource(a) {
            this.av = a;
            this.g("DataSource");
        }
        get headerClickAction() {
            return this.gt;
        }
        set headerClickAction(a) {
            this.gt = a;
            this.g("HeaderClickAction");
        }
        get editMode() {
            return this.gf;
        }
        set editMode(a) {
            this.gf = a;
            this.g("EditMode");
        }
        get editModeClickAction() {
            return this.gg;
        }
        set editModeClickAction(a) {
            this.gg = a;
            this.g("EditModeClickAction");
        }
        get editOnKeyPress() {
            return this.bo;
        }
        set editOnKeyPress(a) {
            this.bo = a;
            this.g("EditOnKeyPress");
        }
        get autoGenerateColumns() {
            return this.bl;
        }
        set autoGenerateColumns(a) {
            this.bl = a;
            this.g("AutoGenerateColumns");
        }
        get rowSeparatorHeight() {
            return this.er;
        }
        set rowSeparatorHeight(a) {
            this.er = a;
            this.g("RowSeparatorHeight");
        }
        get isPlaceholderRenderingEnabled() {
            return this.bz;
        }
        set isPlaceholderRenderingEnabled(a) {
            this.bz = a;
            this.g("IsPlaceholderRenderingEnabled");
        }
        get columnAddingAnimationMode() {
            return this.fo;
        }
        set columnAddingAnimationMode(a) {
            this.fo = a;
            this.g("ColumnAddingAnimationMode");
        }
        get columnPropertyUpdatingAnimationMode() {
            return this.fz;
        }
        set columnPropertyUpdatingAnimationMode(a) {
            this.fz = a;
            this.g("ColumnPropertyUpdatingAnimationMode");
        }
        get cellDataLoadedAnimationMode() {
            return this.fa;
        }
        set cellDataLoadedAnimationMode(a) {
            this.fa = a;
            this.g("CellDataLoadedAnimationMode");
        }
        get rowSelectionAnimationMode() {
            return this.hg;
        }
        set rowSelectionAnimationMode(a) {
            this.hg = a;
            this.g("RowSelectionAnimationMode");
        }
        get rowHoverAnimationMode() {
            return this.hd;
        }
        set rowHoverAnimationMode(a) {
            this.hd = a;
            this.g("RowHoverAnimationMode");
        }
        get cellSelectionAnimationMode() {
            return this.fl;
        }
        set cellSelectionAnimationMode(a) {
            this.fl = a;
            this.g("CellSelectionAnimationMode");
        }
        get animationSettings() {
            return this.a1;
        }
        set animationSettings(a) {
            this.a1 = a;
            this.g("AnimationSettings");
        }
        get columnResizingAnimationMode() {
            return this.f0;
        }
        set columnResizingAnimationMode(a) {
            this.f0 = a;
            this.g("ColumnResizingAnimationMode");
        }
        get columnShowingAnimationMode() {
            return this.f4;
        }
        set columnShowingAnimationMode(a) {
            this.f4 = a;
            this.g("ColumnShowingAnimationMode");
        }
        get columnMovingAnimationMode() {
            return this.fs;
        }
        set columnMovingAnimationMode(a) {
            this.fs = a;
            this.g("ColumnMovingAnimationMode");
        }
        get columnHidingAnimationMode() {
            return this.fr;
        }
        set columnHidingAnimationMode(a) {
            this.fr = a;
            this.g("ColumnHidingAnimationMode");
        }
        get columnExchangingAnimationMode() {
            return this.fp;
        }
        set columnExchangingAnimationMode(a) {
            this.fp = a;
            this.g("ColumnExchangingAnimationMode");
        }
        get selectionMode() {
            return this.hz;
        }
        set selectionMode(a) {
            this.hz = a;
            this.g("SelectionMode");
        }
        get activationMode() {
            return this.e2;
        }
        set activationMode(a) {
            this.e2 = a;
            this.g("ActivationMode");
        }
        get selectionBehavior() {
            return this.hx;
        }
        set selectionBehavior(a) {
            this.hx = a;
            this.g("SelectionBehavior");
        }
        get mouseDragSelectionEnabled() {
            return this.b4;
        }
        set mouseDragSelectionEnabled(a) {
            this.b4 = a;
            this.g("MouseDragSelectionEnabled");
        }
        get selectedItems() {
            return this.x;
        }
        set selectedItems(a) {
            this.x = a;
            this.g("SelectedItems");
        }
        get selectedKeys() {
            return this.y;
        }
        set selectedKeys(a) {
            this.y = a;
            this.g("SelectedKeys");
        }
        get selectedCells() {
            return this.w;
        }
        set selectedCells(a) {
            this.w = a;
            this.g("SelectedCells");
        }
        get selectedCellRanges() {
            return this.v;
        }
        set selectedCellRanges(a) {
            this.v = a;
            this.g("SelectedCellRanges");
        }
        get pinnedItems() {
            return this.r;
        }
        set pinnedItems(a) {
            this.r = a;
            this.g("PinnedItems");
        }
        get pinnedKeys() {
            return this.s;
        }
        set pinnedKeys(a) {
            this.s = a;
            this.g("PinnedKeys");
        }
        get isColumnOptionsEnabled() {
            return this.bq;
        }
        set isColumnOptionsEnabled(a) {
            this.bq = a;
            this.g("IsColumnOptionsEnabled");
        }
        get isGroupRowSticky() {
            return this.bw;
        }
        set isGroupRowSticky(a) {
            this.bw = a;
            this.g("IsGroupRowSticky");
        }
        get isHeaderSeparatorVisible() {
            return this.bx;
        }
        set isHeaderSeparatorVisible(a) {
            this.bx = a;
            this.g("IsHeaderSeparatorVisible");
        }
        get cellSelectedBackground() {
            return this.fk;
        }
        set cellSelectedBackground(a) {
            this.fk = a;
            this.g("CellSelectedBackground");
        }
        get sectionHeaderSelectedBackground() {
            return this.hr;
        }
        set sectionHeaderSelectedBackground(a) {
            this.hr = a;
            this.g("SectionHeaderSelectedBackground");
        }
        get summaryRootBackground() {
            return this.h4;
        }
        set summaryRootBackground(a) {
            this.h4 = a;
            this.g("SummaryRootBackground");
        }
        get summarySectionBackground() {
            return this.ig;
        }
        set summarySectionBackground(a) {
            this.ig = a;
            this.g("SummarySectionBackground");
        }
        get pinnedRowOpacity() {
            return this.dm;
        }
        set pinnedRowOpacity(a) {
            this.dm = a;
            this.g("PinnedRowOpacity");
        }
        get editFontFamily() {
            return this.gc;
        }
        set editFontFamily(a) {
            this.gc = a;
            this.g("EditFontFamily");
        }
        get editFontSize() {
            return this.df;
        }
        set editFontSize(a) {
            this.df = a;
            this.g("EditFontSize");
        }
        get editFontStyle() {
            return this.gd;
        }
        set editFontStyle(a) {
            this.gd = a;
            this.g("EditFontStyle");
        }
        get editFontWeight() {
            return this.ge;
        }
        set editFontWeight(a) {
            this.ge = a;
            this.g("EditFontWeight");
        }
        get editOpacity() {
            return this.dg;
        }
        set editOpacity(a) {
            this.dg = a;
            this.g("EditOpacity");
        }
        get deletedTextColor() {
            return this.ga;
        }
        set deletedTextColor(a) {
            this.ga = a;
            this.g("DeletedTextColor");
        }
        get stickyRowBackground() {
            return this.h2;
        }
        set stickyRowBackground(a) {
            this.h2 = a;
            this.g("StickyRowBackground");
        }
        get pinnedRowBackground() {
            return this.ha;
        }
        set pinnedRowBackground(a) {
            this.ha = a;
            this.g("PinnedRowBackground");
        }
        get lastStickyRowBackground() {
            return this.g6;
        }
        set lastStickyRowBackground(a) {
            this.g6 = a;
            this.g("LastStickyRowBackground");
        }
        get activeCell() {
            return this.a3;
        }
        set activeCell(a) {
            this.a3 = a;
            this.g("ActiveCell");
        }
        get cellBackground() {
            return this.e8;
        }
        set cellBackground(a) {
            this.e8 = a;
            this.g("CellBackground");
        }
        get cellTextColor() {
            return this.fm;
        }
        set cellTextColor(a) {
            this.fm = a;
            this.g("CellTextColor");
        }
        get headerSortIndicatorColor() {
            return this.gz;
        }
        set headerSortIndicatorColor(a) {
            this.gz = a;
            this.g("HeaderSortIndicatorColor");
        }
        get headerSortIndicatorStyle() {
            return this.g0;
        }
        set headerSortIndicatorStyle(a) {
            this.g0 = a;
            this.g("HeaderSortIndicatorStyle");
        }
        get cellFontFamily() {
            return this.fd;
        }
        set cellFontFamily(a) {
            this.fd = a;
            this.g("CellFontFamily");
        }
        get cellFontSize() {
            return this.c7;
        }
        set cellFontSize(a) {
            this.c7 = a;
            this.g("CellFontSize");
        }
        get cellFontStyle() {
            return this.fe;
        }
        set cellFontStyle(a) {
            this.fe = a;
            this.g("CellFontStyle");
        }
        get cellFontWeight() {
            return this.ff;
        }
        set cellFontWeight(a) {
            this.ff = a;
            this.g("CellFontWeight");
        }
        get sectionHeaderBackground() {
            return this.hn;
        }
        set sectionHeaderBackground(a) {
            this.hn = a;
            this.g("SectionHeaderBackground");
        }
        get sectionHeaderTextColor() {
            return this.hs;
        }
        set sectionHeaderTextColor(a) {
            this.hs = a;
            this.g("SectionHeaderTextColor");
        }
        get sectionHeaderFontFamily() {
            return this.ho;
        }
        set sectionHeaderFontFamily(a) {
            this.ho = a;
            this.g("SectionHeaderFontFamily");
        }
        get sectionHeaderFontSize() {
            return this.dn;
        }
        set sectionHeaderFontSize(a) {
            this.dn = a;
            this.g("SectionHeaderFontSize");
        }
        get sectionHeaderFontStyle() {
            return this.hp;
        }
        set sectionHeaderFontStyle(a) {
            this.hp = a;
            this.g("SectionHeaderFontStyle");
        }
        get sectionHeaderFontWeight() {
            return this.hq;
        }
        set sectionHeaderFontWeight(a) {
            this.hq = a;
            this.g("SectionHeaderFontWeight");
        }
        get summaryRootLabelFontFamily() {
            return this.h5;
        }
        set summaryRootLabelFontFamily(a) {
            this.h5 = a;
            this.g("SummaryRootLabelFontFamily");
        }
        get summaryRootLabelFontSize() {
            return this.dp;
        }
        set summaryRootLabelFontSize(a) {
            this.dp = a;
            this.g("SummaryRootLabelFontSize");
        }
        get summaryRootLabelFontStyle() {
            return this.h6;
        }
        set summaryRootLabelFontStyle(a) {
            this.h6 = a;
            this.g("SummaryRootLabelFontStyle");
        }
        get summaryRootLabelFontWeight() {
            return this.h7;
        }
        set summaryRootLabelFontWeight(a) {
            this.h7 = a;
            this.g("SummaryRootLabelFontWeight");
        }
        get summarySectionLabelFontFamily() {
            return this.ih;
        }
        set summarySectionLabelFontFamily(a) {
            this.ih = a;
            this.g("SummarySectionLabelFontFamily");
        }
        get summarySectionLabelFontSize() {
            return this.dr;
        }
        set summarySectionLabelFontSize(a) {
            this.dr = a;
            this.g("SummarySectionLabelFontSize");
        }
        get summarySectionLabelFontStyle() {
            return this.ii;
        }
        set summarySectionLabelFontStyle(a) {
            this.ii = a;
            this.g("SummarySectionLabelFontStyle");
        }
        get summarySectionLabelFontWeight() {
            return this.ij;
        }
        set summarySectionLabelFontWeight(a) {
            this.ij = a;
            this.g("SummarySectionLabelFontWeight");
        }
        get summaryRootValueTextColor() {
            return this.id;
        }
        set summaryRootValueTextColor(a) {
            this.id = a;
            this.g("SummaryRootValueTextColor");
        }
        get summaryRootValueFontFamily() {
            return this.ia;
        }
        set summaryRootValueFontFamily(a) {
            this.ia = a;
            this.g("SummaryRootValueFontFamily");
        }
        get summaryRootValueFontSize() {
            return this.dq;
        }
        set summaryRootValueFontSize(a) {
            this.dq = a;
            this.g("SummaryRootValueFontSize");
        }
        get summaryRootValueFontStyle() {
            return this.ib;
        }
        set summaryRootValueFontStyle(a) {
            this.ib = a;
            this.g("SummaryRootValueFontStyle");
        }
        get summaryRootValueFontWeight() {
            return this.ic;
        }
        set summaryRootValueFontWeight(a) {
            this.ic = a;
            this.g("SummaryRootValueFontWeight");
        }
        get summarySectionValueFontFamily() {
            return this.im;
        }
        set summarySectionValueFontFamily(a) {
            this.im = a;
            this.g("SummarySectionValueFontFamily");
        }
        get summarySectionValueFontSize() {
            return this.ds;
        }
        set summarySectionValueFontSize(a) {
            this.ds = a;
            this.g("SummarySectionValueFontSize");
        }
        get summarySectionValueFontStyle() {
            return this.io;
        }
        set summarySectionValueFontStyle(a) {
            this.io = a;
            this.g("SummarySectionValueFontStyle");
        }
        get summarySectionValueFontWeight() {
            return this.ip;
        }
        set summarySectionValueFontWeight(a) {
            this.ip = a;
            this.g("SummarySectionValueFontWeight");
        }
        get summarySectionValueTextColor() {
            return this.iq;
        }
        set summarySectionValueTextColor(a) {
            this.iq = a;
            this.g("SummarySectionValueTextColor");
        }
        get summaryRootLabelTextColor() {
            return this.h8;
        }
        set summaryRootLabelTextColor(a) {
            this.h8 = a;
            this.g("SummaryRootLabelTextColor");
        }
        get summarySectionLabelTextColor() {
            return this.ik;
        }
        set summarySectionLabelTextColor(a) {
            this.ik = a;
            this.g("SummarySectionLabelTextColor");
        }
        get summaryRootSelectedBackground() {
            return this.h9;
        }
        set summaryRootSelectedBackground(a) {
            this.h9 = a;
            this.g("SummaryRootSelectedBackground");
        }
        get summarySectionSelectedBackground() {
            return this.il;
        }
        set summarySectionSelectedBackground(a) {
            this.il = a;
            this.g("SummarySectionSelectedBackground");
        }
        get pinnedAreaSeparatorWidth() {
            return this.ep;
        }
        set pinnedAreaSeparatorWidth(a) {
            this.ep = a;
            this.g("PinnedAreaSeparatorWidth");
        }
        get headerSeparatorWidth() {
            return this.en;
        }
        set headerSeparatorWidth(a) {
            this.en = a;
            this.g("HeaderSeparatorWidth");
        }
        get headerSeparatorBackground() {
            return this.gy;
        }
        set headerSeparatorBackground(a) {
            this.gy = a;
            this.g("HeaderSeparatorBackground");
        }
        get headerBackground() {
            return this.gs;
        }
        set headerBackground(a) {
            this.gs = a;
            this.g("HeaderBackground");
        }
        get headerTextColor() {
            return this.g1;
        }
        set headerTextColor(a) {
            this.g1 = a;
            this.g("HeaderTextColor");
        }
        get headerFontFamily() {
            return this.gu;
        }
        set headerFontFamily(a) {
            this.gu = a;
            this.g("HeaderFontFamily");
        }
        get headerFontSize() {
            return this.dl;
        }
        set headerFontSize(a) {
            this.dl = a;
            this.g("HeaderFontSize");
        }
        get headerFontStyle() {
            return this.gv;
        }
        set headerFontStyle(a) {
            this.gv = a;
            this.g("HeaderFontStyle");
        }
        get headerFontWeight() {
            return this.gw;
        }
        set headerFontWeight(a) {
            this.gw = a;
            this.g("HeaderFontWeight");
        }
        get rowSeparatorBackground() {
            return this.hh;
        }
        set rowSeparatorBackground(a) {
            this.hh = a;
            this.g("RowSeparatorBackground");
        }
        get headerRowSeparatorBackground() {
            return this.gx;
        }
        set headerRowSeparatorBackground(a) {
            this.gx = a;
            this.g("HeaderRowSeparatorBackground");
        }
        get rowSeparatorStickyRowBackground() {
            return this.hk;
        }
        set rowSeparatorStickyRowBackground(a) {
            this.hk = a;
            this.g("RowSeparatorStickyRowBackground");
        }
        get rowSeparatorLastStickyRowBackground() {
            return this.hi;
        }
        set rowSeparatorLastStickyRowBackground(a) {
            this.hi = a;
            this.g("RowSeparatorLastStickyRowBackground");
        }
        get rowSeparatorPinnedRowBackground() {
            return this.hj;
        }
        set rowSeparatorPinnedRowBackground(a) {
            this.hj = a;
            this.g("RowSeparatorPinnedRowBackground");
        }
        get columnResizingSeparatorWidth() {
            return this.el;
        }
        set columnResizingSeparatorWidth(a) {
            this.el = a;
            this.g("ColumnResizingSeparatorWidth");
        }
        get columnResizingSeparatorOpacity() {
            return this.c9;
        }
        set columnResizingSeparatorOpacity(a) {
            this.c9 = a;
            this.g("ColumnResizingSeparatorOpacity");
        }
        get columnMovingSeparatorWidth() {
            return this.ek;
        }
        set columnMovingSeparatorWidth(a) {
            this.ek = a;
            this.g("ColumnMovingSeparatorWidth");
        }
        get columnMovingSeparatorOpacity() {
            return this.c8;
        }
        set columnMovingSeparatorOpacity(a) {
            this.c8 = a;
            this.g("ColumnMovingSeparatorOpacity");
        }
        get columnResizingSeparatorBackground() {
            return this.f2;
        }
        set columnResizingSeparatorBackground(a) {
            this.f2 = a;
            this.g("ColumnResizingSeparatorBackground");
        }
        get columnMovingSeparatorBackground() {
            return this.fu;
        }
        set columnMovingSeparatorBackground(a) {
            this.fu = a;
            this.g("ColumnMovingSeparatorBackground");
        }
        get shiftSectionContent() {
            return this.b9;
        }
        set shiftSectionContent(a) {
            this.b9 = a;
            this.g("ShiftSectionContent");
        }
        get columnOptionsIconAlignment() {
            return this.fv;
        }
        set columnOptionsIconAlignment(a) {
            this.fv = a;
            this.g("ColumnOptionsIconAlignment");
        }
        get columnOptionsIconColor() {
            return this.fx;
        }
        set columnOptionsIconColor(a) {
            this.fx = a;
            this.g("ColumnOptionsIconColor");
        }
        get columnOptionsIconBehavior() {
            return this.fw;
        }
        set columnOptionsIconBehavior(a) {
            this.fw = a;
            this.g("ColumnOptionsIconBehavior");
        }
        get border() {
            return this.e7;
        }
        set border(a) {
            this.e7 = a;
            this.g("Border");
        }
        get borderWidthBottom() {
            return this.c3;
        }
        set borderWidthBottom(a) {
            this.c3 = a;
            this.g("BorderWidthBottom");
        }
        get borderWidthLeft() {
            return this.c4;
        }
        set borderWidthLeft(a) {
            this.c4 = a;
            this.g("BorderWidthLeft");
        }
        get borderWidthRight() {
            return this.c5;
        }
        set borderWidthRight(a) {
            this.c5 = a;
            this.g("BorderWidthRight");
        }
        get borderWidthTop() {
            return this.c6;
        }
        set borderWidthTop(a) {
            this.c6 = a;
            this.g("BorderWidthTop");
        }
        get notifyOnAllSelectionChanges() {
            return this.b5;
        }
        set notifyOnAllSelectionChanges(a) {
            this.b5 = a;
            this.g("NotifyOnAllSelectionChanges");
        }
        get cornerRadiusBottomRight() {
            return this.db;
        }
        set cornerRadiusBottomRight(a) {
            this.db = a;
            this.g("CornerRadiusBottomRight");
        }
        get cornerRadiusBottomLeft() {
            return this.da;
        }
        set cornerRadiusBottomLeft(a) {
            this.da = a;
            this.g("CornerRadiusBottomLeft");
        }
        get cornerRadiusTopLeft() {
            return this.dc;
        }
        set cornerRadiusTopLeft(a) {
            this.dc = a;
            this.g("CornerRadiusTopLeft");
        }
        get cornerRadiusTopRight() {
            return this.dd;
        }
        set cornerRadiusTopRight(a) {
            this.dd = a;
            this.g("CornerRadiusTopRight");
        }
        get isActiveCellStyleEnabled() {
            return this.bp;
        }
        set isActiveCellStyleEnabled(a) {
            this.bp = a;
            this.g("IsActiveCellStyleEnabled");
        }
        get responsiveStates() {
            return this.u;
        }
        set responsiveStates(a) {
            this.u = a;
            this.g("ResponsiveStates");
        }
        get initialSortDescriptions() {
            return this.p;
        }
        set initialSortDescriptions(a) {
            this.p = a;
            this.g("InitialSortDescriptions");
        }
        get initialGroupDescriptions() {
            return this.o;
        }
        set initialGroupDescriptions(a) {
            this.o = a;
            this.g("InitialGroupDescriptions");
        }
        get initialSummaryDescriptions() {
            return this.q;
        }
        set initialSummaryDescriptions(a) {
            this.q = a;
            this.g("InitialSummaryDescriptions");
        }
        get initialSorts() {
            return this.g4;
        }
        set initialSorts(a) {
            this.g4 = a;
            this.g("InitialSorts");
        }
        get initialGroups() {
            return this.g3;
        }
        set initialGroups(a) {
            this.g3 = a;
            this.g("InitialGroups");
        }
        get initialSummaries() {
            return this.g5;
        }
        set initialSummaries(a) {
            this.g5 = a;
            this.g("InitialSummaries");
        }
        get sortDescriptions() {
            return this.z;
        }
        set sortDescriptions(a) {
            this.z = a;
            this.g("SortDescriptions");
        }
        get groupDescriptions() {
            return this.n;
        }
        set groupDescriptions(a) {
            this.n = a;
            this.g("GroupDescriptions");
        }
        get filterExpressions() {
            return this.m;
        }
        set filterExpressions(a) {
            this.m = a;
            this.g("FilterExpressions");
        }
        get summaryDescriptions() {
            return this.aa;
        }
        set summaryDescriptions(a) {
            this.aa = a;
            this.g("SummaryDescriptions");
        }
        get summaryScope() {
            return this.ie;
        }
        set summaryScope(a) {
            this.ie = a;
            this.g("SummaryScope");
        }
        get isGroupCollapsable() {
            return this.bu;
        }
        set isGroupCollapsable(a) {
            this.bu = a;
            this.g("IsGroupCollapsable");
        }
        get groupHeaderDisplayMode() {
            return this.gq;
        }
        set groupHeaderDisplayMode(a) {
            this.gq = a;
            this.g("GroupHeaderDisplayMode");
        }
        get isGroupExpandedDefault() {
            return this.bv;
        }
        set isGroupExpandedDefault(a) {
            this.bv = a;
            this.g("IsGroupExpandedDefault");
        }
        get groupSummaryDisplayMode() {
            return this.gr;
        }
        set groupSummaryDisplayMode(a) {
            this.gr = a;
            this.g("GroupSummaryDisplayMode");
        }
        get autoAcceptEdits() {
            return this.bk;
        }
        set autoAcceptEdits(a) {
            this.bk = a;
            this.g("AutoAcceptEdits");
        }
        get primaryKey() {
            return this.t;
        }
        set primaryKey(a) {
            this.t = a;
            this.g("PrimaryKey");
        }
        get actualPrimaryKey() {
            return this.i;
        }
        set actualPrimaryKey(a) {
            this.i = a;
            this.g("ActualPrimaryKey");
        }
        get actualColumns() {
            return this.h;
        }
        set actualColumns(a) {
            this.h = a;
            this.g("ActualColumns");
        }
        get columns() {
            return this.k;
        }
        set columns(a) {
            this.k = a;
            this.g("Columns");
        }
        get reactsToSortChanges() {
            return this.b8;
        }
        set reactsToSortChanges(a) {
            this.b8 = a;
            this.g("ReactsToSortChanges");
        }
        get reactsToGroupChanges() {
            return this.b7;
        }
        set reactsToGroupChanges(a) {
            this.b7 = a;
            this.g("ReactsToGroupChanges");
        }
        get reactsToFilterChanges() {
            return this.b6;
        }
        set reactsToFilterChanges(a) {
            this.b6 = a;
            this.g("ReactsToFilterChanges");
        }
        get enterBehavior() {
            return this.gi;
        }
        set enterBehavior(a) {
            this.gi = a;
            this.g("EnterBehavior");
        }
        get enterBehaviorAfterEdit() {
            return this.gj;
        }
        set enterBehaviorAfterEdit(a) {
            this.gj = a;
            this.g("EnterBehaviorAfterEdit");
        }
        get isColumnOptionsSummariesEnabled() {
            return this.bs;
        }
        set isColumnOptionsSummariesEnabled(a) {
            this.bs = a;
            this.g("IsColumnOptionsSummariesEnabled");
        }
        get isColumnOptionsGroupingEnabled() {
            return this.br;
        }
        set isColumnOptionsGroupingEnabled(a) {
            this.br = a;
            this.g("IsColumnOptionsGroupingEnabled");
        }
        get mergedCellMode() {
            return this.g8;
        }
        set mergedCellMode(a) {
            this.g8 = a;
            this.g("MergedCellMode");
        }
        get mergedCellEvaluationCriteria() {
            return this.g7;
        }
        set mergedCellEvaluationCriteria(a) {
            this.g7 = a;
            this.g("MergedCellEvaluationCriteria");
        }
        get mergedCellVerticalAlignment() {
            return this.g9;
        }
        set mergedCellVerticalAlignment(a) {
            this.g9 = a;
            this.g("MergedCellVerticalAlignment");
        }
        get filterUIType() {
            return this.go;
        }
        set filterUIType(a) {
            this.go = a;
            this.g("FilterUIType");
        }
        get filterLogicalOperator() {
            return this.gn;
        }
        set filterLogicalOperator(a) {
            this.gn = a;
            this.g("FilterLogicalOperator");
        }
        get filterComparisonType() {
            return this.gk;
        }
        set filterComparisonType(a) {
            this.gk = a;
            this.g("FilterComparisonType");
        }
        get todayOverride() {
            return this.c1;
        }
        set todayOverride(a) {
            this.c1 = a;
            this.g("TodayOverride");
        }
        get clearSelectionOnEscape() {
            return this.bm;
        }
        set clearSelectionOnEscape(a) {
            this.bm = a;
            this.g("ClearSelectionOnEscape");
        }
        get pageSize() {
            return this.eo;
        }
        set pageSize(a) {
            this.eo = a;
            this.g("PageSize");
        }
        get isToolbarColumnChooserVisible() {
            return this.b1;
        }
        set isToolbarColumnChooserVisible(a) {
            this.b1 = a;
            this.g("IsToolbarColumnChooserVisible");
        }
        get isToolbarColumnPinningVisible() {
            return this.b2;
        }
        set isToolbarColumnPinningVisible(a) {
            this.b2 = a;
            this.g("IsToolbarColumnPinningVisible");
        }
        get toolbarTitle() {
            return this.iv;
        }
        set toolbarTitle(a) {
            this.iv = a;
            this.g("ToolbarTitle");
        }
        get toolbarColumnChooserText() {
            return this.ir;
        }
        set toolbarColumnChooserText(a) {
            this.ir = a;
            this.g("ToolbarColumnChooserText");
        }
        get toolbarColumnChooserTitle() {
            return this.is;
        }
        set toolbarColumnChooserTitle(a) {
            this.is = a;
            this.g("ToolbarColumnChooserTitle");
        }
        get toolbarColumnPinningText() {
            return this.it;
        }
        set toolbarColumnPinningText(a) {
            this.it = a;
            this.g("ToolbarColumnPinningText");
        }
        get toolbarColumnPinningTitle() {
            return this.iu;
        }
        set toolbarColumnPinningTitle(a) {
            this.iu = a;
            this.g("ToolbarColumnPinningTitle");
        }
        get scrollbarStyle() {
            return this.hm;
        }
        set scrollbarStyle(a) {
            this.hm = a;
            this.g("ScrollbarStyle");
        }
        get scrollbarBackground() {
            return this.hl;
        }
        set scrollbarBackground(a) {
            this.hl = a;
            this.g("ScrollbarBackground");
        }
        get allowCopyOperation() {
            return this.bj;
        }
        set allowCopyOperation(a) {
            this.bj = a;
            this.g("AllowCopyOperation");
        }
        get deferEventForRowDragSelection() {
            return this.bn;
        }
        set deferEventForRowDragSelection(a) {
            this.bn = a;
            this.g("DeferEventForRowDragSelection");
        }
        get filterExpressionsChangingRef() {
            return this.gm;
        }
        set filterExpressionsChangingRef(a) {
            this.gm = a;
            this.g("FilterExpressionsChangingRef");
        }
        get filterExpressionsChangedRef() {
            return this.gl;
        }
        set filterExpressionsChangedRef(a) {
            this.gl = a;
            this.g("FilterExpressionsChangedRef");
        }
        get cellPreviewPointerDownRef() {
            return this.fi;
        }
        set cellPreviewPointerDownRef(a) {
            this.fi = a;
            this.g("CellPreviewPointerDownRef");
        }
        get cellPreviewPointerUpRef() {
            return this.fj;
        }
        set cellPreviewPointerUpRef(a) {
            this.fj = a;
            this.g("CellPreviewPointerUpRef");
        }
        get cellPointerDownRef() {
            return this.fg;
        }
        set cellPointerDownRef(a) {
            this.fg = a;
            this.g("CellPointerDownRef");
        }
        get cellPointerUpRef() {
            return this.fh;
        }
        set cellPointerUpRef(a) {
            this.fh = a;
            this.g("CellPointerUpRef");
        }
        get cellClickedRef() {
            return this.e9;
        }
        set cellClickedRef(a) {
            this.e9 = a;
            this.g("CellClickedRef");
        }
        get sortDescriptionsChangedRef() {
            return this.h1;
        }
        set sortDescriptionsChangedRef(a) {
            this.h1 = a;
            this.g("SortDescriptionsChangedRef");
        }
        get groupDescriptionsChangedRef() {
            return this.gp;
        }
        set groupDescriptionsChangedRef(a) {
            this.gp = a;
            this.g("GroupDescriptionsChangedRef");
        }
        get summaryDescriptionsChangedRef() {
            return this.h3;
        }
        set summaryDescriptionsChangedRef(a) {
            this.h3 = a;
            this.g("SummaryDescriptionsChangedRef");
        }
        get columnHiddenChangedRef() {
            return this.fq;
        }
        set columnHiddenChangedRef(a) {
            this.fq = a;
            this.g("ColumnHiddenChangedRef");
        }
        get columnPinnedChangedRef() {
            return this.fy;
        }
        set columnPinnedChangedRef(a) {
            this.fy = a;
            this.g("ColumnPinnedChangedRef");
        }
        get cellValueChangingRef() {
            return this.fn;
        }
        set cellValueChangingRef(a) {
            this.fn = a;
            this.g("CellValueChangingRef");
        }
        get dataCommittedRef() {
            return this.f7;
        }
        set dataCommittedRef(a) {
            this.f7 = a;
            this.g("DataCommittedRef");
        }
        get dataCommittingRef() {
            return this.f8;
        }
        set dataCommittingRef(a) {
            this.f8 = a;
            this.g("DataCommittingRef");
        }
        get sizeChangedRef() {
            return this.h0;
        }
        set sizeChangedRef(a) {
            this.h0 = a;
            this.g("SizeChangedRef");
        }
        get actualColumnsChangedRef() {
            return this.e4;
        }
        set actualColumnsChangedRef(a) {
            this.e4 = a;
            this.g("ActualColumnsChangedRef");
        }
        get columnsAutoGeneratedRef() {
            return this.f3;
        }
        set columnsAutoGeneratedRef(a) {
            this.f3 = a;
            this.g("ColumnsAutoGeneratedRef");
        }
        get selectedItemsChangedRef() {
            return this.hv;
        }
        set selectedItemsChangedRef(a) {
            this.hv = a;
            this.g("SelectedItemsChangedRef");
        }
        get selectedKeysChangedRef() {
            return this.hw;
        }
        set selectedKeysChangedRef(a) {
            this.hw = a;
            this.g("SelectedKeysChangedRef");
        }
        get selectedCellsChangedRef() {
            return this.hu;
        }
        set selectedCellsChangedRef(a) {
            this.hu = a;
            this.g("SelectedCellsChangedRef");
        }
        get selectionChangedRef() {
            return this.hy;
        }
        set selectionChangedRef(a) {
            this.hy = a;
            this.g("SelectionChangedRef");
        }
        get activeCellChangedRef() {
            return this.e3;
        }
        set activeCellChangedRef(a) {
            this.e3 = a;
            this.g("ActiveCellChangedRef");
        }
        get selectedCellRangesChangedRef() {
            return this.ht;
        }
        set selectedCellRangesChangedRef(a) {
            this.ht = a;
            this.g("SelectedCellRangesChangedRef");
        }
        get columnWidthChangedRef() {
            return this.f5;
        }
        set columnWidthChangedRef(a) {
            this.f5 = a;
            this.g("ColumnWidthChangedRef");
        }
        get cellEditStartedRef() {
            return this.fc;
        }
        set cellEditStartedRef(a) {
            this.fc = a;
            this.g("CellEditStartedRef");
        }
        get cellEditEndedRef() {
            return this.fb;
        }
        set cellEditEndedRef(a) {
            this.fb = a;
            this.g("CellEditEndedRef");
        }
        get rowEditStartedRef() {
            return this.hc;
        }
        set rowEditStartedRef(a) {
            this.hc = a;
            this.g("RowEditStartedRef");
        }
        get rowEditEndedRef() {
            return this.hb;
        }
        set rowEditEndedRef(a) {
            this.hb = a;
            this.g("RowEditEndedRef");
        }
        get customFilterRequestedRef() {
            return this.f6;
        }
        set customFilterRequestedRef(a) {
            this.f6 = a;
            this.g("CustomFilterRequestedRef");
        }
        get actualPrimaryKeyChangeRef() {
            return this.e5;
        }
        set actualPrimaryKeyChangeRef(a) {
            this.e5 = a;
            this.g("ActualPrimaryKeyChangeRef");
        }
    }
    DataGridDescription.$t = /*@__PURE__*/ markType(DataGridDescription, 'DataGridDescription', Description.$);
    return DataGridDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridCellEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridCellEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DataGridCellEventArgsDescriptionMetadata.a == null) {
                DataGridCellEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridCellEventArgsDescriptionMetadata.c(DataGridCellEventArgsDescriptionMetadata.a);
            }
            if (a.k(DataGridCellEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataGridCellEventArgsDescriptionMetadata.a);
            CellInfoDescriptionMetadata.d(a);
            DataGridDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("CellInfo", "ExportedType:CellModel");
            a.item("Grid", "ExportedType:DataGrid");
            a.item("Button", "ExportedType:string:MouseButton");
            a.item("Button@names", "Left;Middle;Right;Unkown");
            a.item("IsDoubleClick", "Boolean");
        }
        static d(a) {
            DataGridCellEventArgsDescriptionMetadata.b(a);
            a.ae("DataGridCellEventArgs", () => new DataGridCellEventArgsDescription());
            a.ad("DataGridCellEventArgs", DataGridCellEventArgsDescriptionMetadata.a);
        }
    }
    DataGridCellEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridCellEventArgsDescriptionMetadata, 'DataGridCellEventArgsDescriptionMetadata');
    DataGridCellEventArgsDescriptionMetadata.a = null;
    return DataGridCellEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let DataGridDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridDescriptionMetadata extends Base {
        static e(a) {
            a.item("_qualifiedName", "String:Infragistics.Controls.Grids.XamDataGrid");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
            a.item("IsGroupByAreaVisible", "Boolean");
            a.item("IsPagerVisible", "Boolean");
            a.item("IsToolbarVisible", "Boolean");
        }
        static f(a) {
            CellKeyDescriptionMetadata.d(a);
            PrimaryKeyValueDescriptionMetadata.d(a);
        }
        static b(a) {
            if (DataGridDescriptionMetadata.a == null) {
                DataGridDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridDescriptionMetadata.c(DataGridDescriptionMetadata.a);
            }
            if (a.k(DataGridDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataGridDescriptionMetadata.a);
            DataGridDescriptionMetadata.f(a);
            SectionHeaderDescriptionMetadata.d(a);
            SummaryRowRootDescriptionMetadata.d(a);
            SummaryRowSectionDescriptionMetadata.d(a);
            RowSeparatorDescriptionMetadata.d(a);
            HeaderRowSeparatorDescriptionMetadata.d(a);
            HeaderSeparatorDescriptionMetadata.d(a);
            ColumnResizingSeparatorDescriptionMetadata.d(a);
            ColumnMovingSeparatorDescriptionMetadata.d(a);
            PinnedAreaSeparatorDescriptionMetadata.d(a);
            GridAnimationSettingsDescriptionMetadata.d(a);
            GridCellPositionDescriptionMetadata.d(a);
            GridFilterExpressionsEventArgsDescriptionMetadata.d(a);
            DataGridCellEventArgsDescriptionMetadata.d(a);
            GridSortDescriptionsChangedEventArgsDescriptionMetadata.d(a);
            GridGroupDescriptionsChangedEventArgsDescriptionMetadata.d(a);
            GridSummaryDescriptionsChangedEventArgsDescriptionMetadata.d(a);
            ColumnHiddenChangedEventArgsDescriptionMetadata.d(a);
            ColumnPinnedChangedEventArgsDescriptionMetadata.d(a);
            GridCellValueChangingEventArgsDescriptionMetadata.d(a);
            GridDataCommittedEventArgsDescriptionMetadata.d(a);
            GridDataCommittingEventArgsDescriptionMetadata.d(a);
            GridSizeChangedEventArgsDescriptionMetadata.d(a);
            GridColumnsChangedEventArgsDescriptionMetadata.d(a);
            GridColumnsAutoGeneratedEventArgsDescriptionMetadata.d(a);
            GridSelectedItemsChangedEventArgsDescriptionMetadata.d(a);
            GridSelectedKeysChangedEventArgsDescriptionMetadata.d(a);
            GridSelectedCellsChangedEventArgsDescriptionMetadata.d(a);
            GridSelectionChangedEventArgsDescriptionMetadata.d(a);
            GridActiveCellChangedEventArgsDescriptionMetadata.d(a);
            GridSelectedCellRangesChangedEventArgsDescriptionMetadata.d(a);
            GridColumnWidthChangedEventArgsDescriptionMetadata.d(a);
            GridCellEditStartedEventArgsDescriptionMetadata.d(a);
            GridCellEditEndedEventArgsDescriptionMetadata.d(a);
            GridRowEditStartedEventArgsDescriptionMetadata.d(a);
            GridRowEditEndedEventArgsDescriptionMetadata.d(a);
            GridCustomFilterRequestedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("ColumnResizingMode", "ExportedType:string:ColumnResizingMode");
            a.item("ColumnResizingMode@names", "Deferred;Immediate;None");
            a.item("ColumnMovingMode", "ExportedType:string:ColumnMovingMode");
            a.item("ColumnMovingMode@names", "Deferred;None");
            a.item("IsRowHoverEnabled", "Boolean");
            a.item("RowHoverBackground", "Brush");
            a.item("RowHoverTextColor", "Brush");
            a.item("EditRowBorder", "Brush");
            a.item("EditRowBorderWidthBottom", "(w:EditRowBorderWidth.Bottom,wf:EditRowBorderWidthBottom)Number:double");
            a.item("EditRowBorderWidthLeft", "(w:EditRowBorderWidth.Left,wf:EditRowBorderWidthLeft)Number:double");
            a.item("EditRowBorderWidthRight", "(w:EditRowBorderWidth.Right,wf:EditRowBorderWidthRight)Number:double");
            a.item("EditRowBorderWidthTop", "(w:EditRowBorderWidth.Top,wf:EditRowBorderWidthTop)Number:double");
            a.item("SectionHeader", "ExportedType:SectionHeader");
            a.item("SummaryRowRoot", "ExportedType:SummaryRowRoot");
            a.item("SummaryRowSection", "ExportedType:SummaryRowSection");
            a.item("RowSeparator", "ExportedType:RowSeparator");
            a.item("HeaderRowSeparator", "ExportedType:HeaderRowSeparator");
            a.item("HeaderSeparator", "ExportedType:HeaderSeparator");
            a.item("ColumnResizingSeparator", "ExportedType:ColumnResizingSeparator");
            a.item("ColumnMovingSeparator", "ExportedType:ColumnMovingSeparator");
            a.item("PinnedAreaSeparator", "ExportedType:PinnedAreaSeparator");
            a.item("AutoGenerateDesiredProperties", "Array:string");
            a.item("DataSourceDesiredProperties", "Array:string");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActualRowHeight", "Number:int");
            a.item("RowHeight", "Number:int");
            a.item("DefaultColumnMinWidth", "Number:double");
            a.item("ActualHeaderHeight", "Number:int");
            a.item("HeaderHeight", "Number:int");
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)DataRef::object");
            a.item("DataSource", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            a.item("HeaderClickAction", "ExportedType:string:HeaderClickAction");
            a.item("HeaderClickAction@names", "SortByOneColumnOnly;SortByMultipleColumns;SortByOneColumnOnlyTriState;SortByMultipleColumnsTriState;None");
            a.item("EditMode", "ExportedType:string:EditModeType");
            a.item("EditMode@names", "None;Cell;CellBatch;Row");
            a.item("EditModeClickAction", "ExportedType:string:EditModeClickAction");
            a.item("EditModeClickAction@names", "None;SingleClick;DoubleClick");
            a.item("EditOnKeyPress", "Boolean");
            a.item("AutoGenerateColumns", "Boolean");
            a.item("RowSeparatorHeight", "Number:int");
            a.item("IsPlaceholderRenderingEnabled", "Boolean");
            a.item("ColumnAddingAnimationMode", "ExportedType:string:ColumnShowingAnimationMode");
            a.item("ColumnAddingAnimationMode@names", "Auto;None;SlideFromLeft;SlideFromRight;SlideFromTop;SlideFromBottom;FadeIn;SlideFromLeftAndFadeIn;SlideFromRightAndFadeIn;SlideFromTopAndFadeIn;SlideFromBottomAndFadeIn");
            a.item("ColumnPropertyUpdatingAnimationMode", "ExportedType:string:ColumnPropertyUpdatingAnimationMode");
            a.item("ColumnPropertyUpdatingAnimationMode@names", "Auto;None;Interpolate;InterpolateDeep");
            a.item("CellDataLoadedAnimationMode", "ExportedType:string:CellDataLoadedAnimationMode");
            a.item("CellDataLoadedAnimationMode@names", "Auto;None;CrossFade");
            a.item("RowSelectionAnimationMode", "ExportedType:string:RowSelectionAnimationMode");
            a.item("RowSelectionAnimationMode@names", "Auto;None;ColorBlend");
            a.item("RowHoverAnimationMode", "ExportedType:string:RowHoverAnimationMode");
            a.item("RowHoverAnimationMode@names", "Auto;None;ColorBlend");
            a.item("CellSelectionAnimationMode", "ExportedType:string:CellSelectionAnimationMode");
            a.item("CellSelectionAnimationMode@names", "Auto;None;ColorBlend");
            a.item("AnimationSettings", "ExportedType:GridAnimationSettings");
            a.item("ColumnResizingAnimationMode", "ExportedType:string:ColumnResizingAnimationMode");
            a.item("ColumnResizingAnimationMode@names", "Auto;None;Interpolate");
            a.item("ColumnShowingAnimationMode", "ExportedType:string:ColumnShowingAnimationMode");
            a.item("ColumnShowingAnimationMode@names", "Auto;None;SlideFromLeft;SlideFromRight;SlideFromTop;SlideFromBottom;FadeIn;SlideFromLeftAndFadeIn;SlideFromRightAndFadeIn;SlideFromTopAndFadeIn;SlideFromBottomAndFadeIn");
            a.item("ColumnMovingAnimationMode", "ExportedType:string:ColumnMovingAnimationMode");
            a.item("ColumnMovingAnimationMode@names", "Auto;None;SlideOver");
            a.item("ColumnHidingAnimationMode", "ExportedType:string:ColumnHidingAnimationMode");
            a.item("ColumnHidingAnimationMode@names", "Auto;None;SlideToLeft;SlideToRight;SlideToTop;SlideToBottom;FadeOut;SlideToLeftAndFadeOut;SlideToRightAndFadeOut;SlideToTopAndFadeOut;SlideToBottomAndFadeOut");
            a.item("ColumnExchangingAnimationMode", "ExportedType:string:ColumnExchangingAnimationMode");
            a.item("ColumnExchangingAnimationMode@names", "Auto;None;SlideToLeft;SlideToRight;SlideToTop;SlideToBottom;Crossfade;SlideToLeftAndCrossfade;SlideToRightAndCrossfade;SlideToTopAndCrossfade;SlideToBottomAndCrossfade");
            a.item("SelectionMode", "ExportedType:string:DataGridSelectionMode");
            a.item("SelectionMode@names", "None;SingleRow;MultipleRow;SingleCell;MultipleCell;RangeCell");
            a.item("ActivationMode", "ExportedType:string:GridActivationMode");
            a.item("ActivationMode@names", "None;Cell");
            a.item("SelectionBehavior", "ExportedType:string:GridSelectionBehavior");
            a.item("SelectionBehavior@names", "Toggle;ModifierBased");
            a.item("MouseDragSelectionEnabled", "Boolean");
            a.item("SelectedItems", "Collection:object:GridSelectedItemsCollection:Object");
            a.item("SelectedKeys", "Collection:PrimaryKeyValue:GridSelectedKeysCollection:PrimaryKeyValue");
            a.item("SelectedCells", "Collection:CellKey:GridSelectedCellsCollection:CellKey");
            a.item("SelectedCellRanges", "Collection:CellRange:GridSelectedCellRangesCollection:CellRange");
            a.item("PinnedItems", "Collection:object:GridSelectedItemsCollection:Object");
            a.item("PinnedKeys", "Collection:PrimaryKeyValue:GridSelectedKeysCollection:PrimaryKeyValue");
            a.item("IsColumnOptionsEnabled", "Boolean");
            a.item("IsGroupRowSticky", "Boolean");
            a.item("IsHeaderSeparatorVisible", "Boolean");
            a.item("CellSelectedBackground", "Brush");
            a.item("SectionHeaderSelectedBackground", "Brush");
            a.item("SummaryRootBackground", "Brush");
            a.item("SummarySectionBackground", "Brush");
            a.item("PinnedRowOpacity", "Number:double");
            a.item("EditFontFamily", "(w:EditFontFamily/FontFamilyTransform,xam:EditFontFamily,wf:EditFontFamily,web:editTextStyle/FontFamilyTransform)String");
            a.item("EditFontSize", "(w:EditFontSize,xam:EditFontSize,wf:EditFontSize,web:editTextStyle/FontSizeTransform)Number:double");
            a.item("EditFontStyle", "(w:EditFontStyle/FontStyleTransform,xam:EditFontFamily/FontStyleTransform,wf:EditFontFamily/FontStyleTransform,web:editTextStyle/FontStyleTransform)String");
            a.item("EditFontWeight", "(w:EditFontWeight/FontWeightTransform,xam:EditFontFamily/FontWeightTransform,wf:EditFontFamily/FontWeightTransform,web:editTextStyle/FontWeightTransform)String");
            a.item("EditOpacity", "Number:double");
            a.item("DeletedTextColor", "Brush");
            a.item("StickyRowBackground", "Brush");
            a.item("PinnedRowBackground", "Brush");
            a.item("LastStickyRowBackground", "Brush");
            a.item("ActiveCell", "ExportedType:GridCellPosition");
            a.item("CellBackground", "Brush");
            a.item("CellTextColor", "Brush");
            a.item("HeaderSortIndicatorColor", "Brush");
            a.item("HeaderSortIndicatorStyle", "ExportedType:string:SortIndicatorStyle");
            a.item("HeaderSortIndicatorStyle@names", "Default;FadingUpDownArrows;FadingSimpleUpDownArrows;Unset");
            a.item("CellFontFamily", "(w:CellFontFamily/FontFamilyTransform,xam:CellFontFamily,wf:CellFontFamily,web:cellTextStyle/FontFamilyTransform)String");
            a.item("CellFontSize", "(w:CellFontSize,xam:CellFontSize,wf:CellFontSize,web:cellTextStyle/FontSizeTransform)Number:double");
            a.item("CellFontStyle", "(w:CellFontStyle/FontStyleTransform,xam:CellFontFamily/FontStyleTransform,wf:CellFontFamily/FontStyleTransform,web:cellTextStyle/FontStyleTransform)String");
            a.item("CellFontWeight", "(w:CellFontWeight/FontWeightTransform,xam:CellFontFamily/FontWeightTransform,wf:CellFontFamily/FontWeightTransform,web:cellTextStyle/FontWeightTransform)String");
            a.item("SectionHeaderBackground", "Brush");
            a.item("SectionHeaderTextColor", "Brush");
            a.item("SectionHeaderFontFamily", "(w:SectionHeaderFontFamily/FontFamilyTransform,xam:SectionHeaderFontFamily,wf:SectionHeaderFontFamily,web:sectionHeaderTextStyle/FontFamilyTransform)String");
            a.item("SectionHeaderFontSize", "(w:SectionHeaderFontSize,xam:SectionHeaderFontSize,wf:SectionHeaderFontSize,web:sectionHeaderTextStyle/FontSizeTransform)Number:double");
            a.item("SectionHeaderFontStyle", "(w:SectionHeaderFontStyle/FontStyleTransform,xam:SectionHeaderFontFamily/FontStyleTransform,wf:SectionHeaderFontFamily/FontStyleTransform,web:sectionHeaderTextStyle/FontStyleTransform)String");
            a.item("SectionHeaderFontWeight", "(w:SectionHeaderFontWeight/FontWeightTransform,xam:SectionHeaderFontFamily/FontWeightTransform,wf:SectionHeaderFontFamily/FontWeightTransform,web:sectionHeaderTextStyle/FontWeightTransform)String");
            a.item("SummaryRootLabelFontFamily", "(w:SummaryRootLabelFontFamily/FontFamilyTransform,xam:SummaryRootLabelFontFamily,wf:SummaryRootLabelFontFamily,web:summaryRootLabelTextStyle/FontFamilyTransform)String");
            a.item("SummaryRootLabelFontSize", "(w:SummaryRootLabelFontSize,xam:SummaryRootLabelFontSize,wf:SummaryRootLabelFontSize,web:summaryRootLabelTextStyle/FontSizeTransform)Number:double");
            a.item("SummaryRootLabelFontStyle", "(w:SummaryRootLabelFontStyle/FontStyleTransform,xam:SummaryRootLabelFontFamily/FontStyleTransform,wf:SummaryRootLabelFontFamily/FontStyleTransform,web:summaryRootLabelTextStyle/FontStyleTransform)String");
            a.item("SummaryRootLabelFontWeight", "(w:SummaryRootLabelFontWeight/FontWeightTransform,xam:SummaryRootLabelFontFamily/FontWeightTransform,wf:SummaryRootLabelFontFamily/FontWeightTransform,web:summaryRootLabelTextStyle/FontWeightTransform)String");
            a.item("SummarySectionLabelFontFamily", "(w:SummarySectionLabelFontFamily/FontFamilyTransform,xam:SummarySectionLabelFontFamily,wf:SummarySectionLabelFontFamily,web:summarySectionLabelTextStyle/FontFamilyTransform)String");
            a.item("SummarySectionLabelFontSize", "(w:SummarySectionLabelFontSize,xam:SummarySectionLabelFontSize,wf:SummarySectionLabelFontSize,web:summarySectionLabelTextStyle/FontSizeTransform)Number:double");
            a.item("SummarySectionLabelFontStyle", "(w:SummarySectionLabelFontStyle/FontStyleTransform,xam:SummarySectionLabelFontFamily/FontStyleTransform,wf:SummarySectionLabelFontFamily/FontStyleTransform,web:summarySectionLabelTextStyle/FontStyleTransform)String");
            a.item("SummarySectionLabelFontWeight", "(w:SummarySectionLabelFontWeight/FontWeightTransform,xam:SummarySectionLabelFontFamily/FontWeightTransform,wf:SummarySectionLabelFontFamily/FontWeightTransform,web:summarySectionLabelTextStyle/FontWeightTransform)String");
            a.item("SummaryRootValueTextColor", "Brush");
            a.item("SummaryRootValueFontFamily", "(w:SummaryRootValueFontFamily/FontFamilyTransform,xam:SummaryRootValueFontFamily,wf:SummaryRootValueFontFamily,web:summaryRootValueTextStyle/FontFamilyTransform)String");
            a.item("SummaryRootValueFontSize", "(w:SummaryRootValueFontSize,xam:SummaryRootValueFontSize,wf:SummaryRootValueFontSize,web:summaryRootValueTextStyle/FontSizeTransform)Number:double");
            a.item("SummaryRootValueFontStyle", "(w:SummaryRootValueFontStyle/FontStyleTransform,xam:SummaryRootValueFontFamily/FontStyleTransform,wf:SummaryRootValueFontFamily/FontStyleTransform,web:summaryRootValueTextStyle/FontStyleTransform)String");
            a.item("SummaryRootValueFontWeight", "(w:SummaryRootValueFontWeight/FontWeightTransform,xam:SummaryRootValueFontFamily/FontWeightTransform,wf:SummaryRootValueFontFamily/FontWeightTransform,web:summaryRootValueTextStyle/FontWeightTransform)String");
            a.item("SummarySectionValueFontFamily", "(w:SummarySectionValueFontFamily/FontFamilyTransform,xam:SummarySectionValueFontFamily,wf:SummarySectionValueFontFamily,web:summarySectionValueTextStyle/FontFamilyTransform)String");
            a.item("SummarySectionValueFontSize", "(w:SummarySectionValueFontSize,xam:SummarySectionValueFontSize,wf:SummarySectionValueFontSize,web:summarySectionValueTextStyle/FontSizeTransform)Number:double");
            a.item("SummarySectionValueFontStyle", "(w:SummarySectionValueFontStyle/FontStyleTransform,xam:SummarySectionValueFontFamily/FontStyleTransform,wf:SummarySectionValueFontFamily/FontStyleTransform,web:summarySectionValueTextStyle/FontStyleTransform)String");
            a.item("SummarySectionValueFontWeight", "(w:SummarySectionValueFontWeight/FontWeightTransform,xam:SummarySectionValueFontFamily/FontWeightTransform,wf:SummarySectionValueFontFamily/FontWeightTransform,web:summarySectionValueTextStyle/FontWeightTransform)String");
            a.item("SummarySectionValueTextColor", "Brush");
            a.item("SummaryRootLabelTextColor", "Brush");
            a.item("SummarySectionLabelTextColor", "Brush");
            a.item("SummaryRootSelectedBackground", "Brush");
            a.item("SummarySectionSelectedBackground", "Brush");
            a.item("PinnedAreaSeparatorWidth", "Number:int");
            a.item("HeaderSeparatorWidth", "Number:int");
            a.item("HeaderSeparatorBackground", "Brush");
            a.item("HeaderBackground", "Brush");
            a.item("HeaderTextColor", "Brush");
            a.item("HeaderFontFamily", "(w:HeaderFontFamily/FontFamilyTransform,xam:HeaderFontFamily,wf:HeaderFontFamily,web:headerTextStyle/FontFamilyTransform)String");
            a.item("HeaderFontSize", "(w:HeaderFontSize,xam:HeaderFontSize,wf:HeaderFontSize,web:headerTextStyle/FontSizeTransform)Number:double");
            a.item("HeaderFontStyle", "(w:HeaderFontStyle/FontStyleTransform,xam:HeaderFontFamily/FontStyleTransform,wf:HeaderFontFamily/FontStyleTransform,web:headerTextStyle/FontStyleTransform)String");
            a.item("HeaderFontWeight", "(w:HeaderFontWeight/FontWeightTransform,xam:HeaderFontFamily/FontWeightTransform,wf:HeaderFontFamily/FontWeightTransform,web:headerTextStyle/FontWeightTransform)String");
            a.item("RowSeparatorBackground", "Brush");
            a.item("HeaderRowSeparatorBackground", "Brush");
            a.item("RowSeparatorStickyRowBackground", "Brush");
            a.item("RowSeparatorLastStickyRowBackground", "Brush");
            a.item("RowSeparatorPinnedRowBackground", "Brush");
            a.item("ColumnResizingSeparatorWidth", "Number:int");
            a.item("ColumnResizingSeparatorOpacity", "Number:double");
            a.item("ColumnMovingSeparatorWidth", "Number:int");
            a.item("ColumnMovingSeparatorOpacity", "Number:double");
            a.item("ColumnResizingSeparatorBackground", "Brush");
            a.item("ColumnMovingSeparatorBackground", "Brush");
            a.item("ShiftSectionContent", "Boolean");
            a.item("ColumnOptionsIconAlignment", "ExportedType:string:ColumnOptionsIconAlignment");
            a.item("ColumnOptionsIconAlignment@names", "Unset;None;Opposite");
            a.item("ColumnOptionsIconColor", "Brush");
            a.item("ColumnOptionsIconBehavior", "ExportedType:string:ColumnOptionsIconBehavior");
            a.item("ColumnOptionsIconBehavior@names", "Unset;AlwaysVisible;AppearOnHover;AppearOnHoverAnimate");
            a.item("Border", "Brush");
            a.item("BorderWidthBottom", "(w:BorderWidth.Bottom,wf:BorderWidthBottom)Number:double");
            a.item("BorderWidthLeft", "(w:BorderWidth.Left,wf:BorderWidthLeft)Number:double");
            a.item("BorderWidthRight", "(w:BorderWidth.Right,wf:BorderWidthRight)Number:double");
            a.item("BorderWidthTop", "(w:BorderWidth.Top,wf:BorderWidthTop)Number:double");
            a.item("NotifyOnAllSelectionChanges", "Boolean");
            a.item("CornerRadiusBottomRight", "(w:CornerRadius.BottomRight,wf:CornerRadiusBottomRight)Number:double");
            a.item("CornerRadiusBottomLeft", "(w:CornerRadius.BottomLeft,wf:CornerRadiusBottomLeft)Number:double");
            a.item("CornerRadiusTopLeft", "(w:CornerRadius.TopLeft,wf:CornerRadiusTopLeft)Number:double");
            a.item("CornerRadiusTopRight", "(w:CornerRadius.TopRight,wf:CornerRadiusTopRight)Number:double");
            a.item("IsActiveCellStyleEnabled", "Boolean");
            a.item("ResponsiveStates", "Collection:ResponsiveState:ResponsiveStatesCollection:ResponsiveState");
            a.item("InitialSortDescriptions", "Collection:ColumnSortDescription:ColumnSortDescriptionCollection:ColumnSortDescription");
            a.item("InitialGroupDescriptions", "Collection:ColumnGroupDescription:ColumnGroupDescriptionCollection:ColumnGroupDescription");
            a.item("InitialSummaryDescriptions", "Collection:ColumnSummaryDescription:ColumnSummaryDescriptionCollection:ColumnSummaryDescription");
            a.item("InitialSorts", "String");
            a.item("InitialGroups", "String");
            a.item("InitialSummaries", "String");
            a.item("SortDescriptions", "Collection:ColumnSortDescription:ColumnSortDescriptionCollection:ColumnSortDescription");
            a.item("GroupDescriptions", "Collection:ColumnGroupDescription:ColumnGroupDescriptionCollection:ColumnGroupDescription");
            a.item("FilterExpressions", "Collection:FilterExpression:FilterExpressionCollection:FilterExpression");
            a.item("SummaryDescriptions", "Collection:ColumnSummaryDescription:ColumnSummaryDescriptionCollection:ColumnSummaryDescription");
            a.item("SummaryScope", "ExportedType:string:SummaryScope");
            a.item("SummaryScope@names", "Both;Root;Groups;None");
            a.item("IsGroupCollapsable", "Boolean");
            a.item("GroupHeaderDisplayMode", "ExportedType:string:GroupHeaderDisplayMode");
            a.item("GroupHeaderDisplayMode@names", "Combined;Split");
            a.item("IsGroupExpandedDefault", "Boolean");
            a.item("GroupSummaryDisplayMode", "ExportedType:string:GroupSummaryDisplayMode");
            a.item("GroupSummaryDisplayMode@names", "List;Cells;RowTop;RowBottom;None");
            a.item("AutoAcceptEdits", "Boolean");
            a.item("PrimaryKey", "Array:string");
            a.item("ActualPrimaryKey", "Array:string");
            a.item("ActualColumns", "Collection:DataGridColumn:GridColumnCollection:DataGridColumn");
            a.item("Columns", "Collection:DataGridColumn:GridColumnCollection:DataGridColumn");
            a.item("ReactsToSortChanges", "Boolean");
            a.item("ReactsToGroupChanges", "Boolean");
            a.item("ReactsToFilterChanges", "Boolean");
            a.item("EnterBehavior", "ExportedType:string:EnterKeyBehaviors");
            a.item("EnterBehavior@names", "None;Edit;MoveDown;MoveRight;MoveUp;MoveLeft");
            a.item("EnterBehaviorAfterEdit", "ExportedType:string:EnterKeyBehaviorAfterEdit");
            a.item("EnterBehaviorAfterEdit@names", "None;MoveDown;MoveRight;MoveUp;MoveLeft");
            a.item("IsColumnOptionsSummariesEnabled", "Boolean");
            a.item("IsColumnOptionsGroupingEnabled", "Boolean");
            a.item("MergedCellMode", "ExportedType:string:MergedCellMode");
            a.item("MergedCellMode@names", "Default;Never;Always;OnlyWhenSorted");
            a.item("MergedCellEvaluationCriteria", "ExportedType:string:MergedCellEvaluationCriteria");
            a.item("MergedCellEvaluationCriteria@names", "Default;RawValue;FormattedText");
            a.item("MergedCellVerticalAlignment", "ExportedType:string:CellContentVerticalAlignment");
            a.item("MergedCellVerticalAlignment@names", "Top;Center;Bottom;Stretch;Auto");
            a.item("FilterUIType", "ExportedType:string:FilterUIType");
            a.item("FilterUIType@names", "ColumnOptions;FilterRow;None");
            a.item("FilterLogicalOperator", "ExportedType:string:FilterLogicalOperator");
            a.item("FilterLogicalOperator@names", "And;Or");
            a.item("FilterComparisonType", "ExportedType:string:FilterComparisonType");
            a.item("FilterComparisonType@names", "Default;CaseInsensitive;CaseSensitive");
            a.item("TodayOverride", "Date");
            a.item("ClearSelectionOnEscape", "Boolean");
            a.item("PageSize", "Number:int");
            a.item("IsToolbarColumnChooserVisible", "Boolean");
            a.item("IsToolbarColumnPinningVisible", "Boolean");
            a.item("ToolbarTitle", "String");
            a.item("ToolbarColumnChooserText", "String");
            a.item("ToolbarColumnChooserTitle", "String");
            a.item("ToolbarColumnPinningText", "String");
            a.item("ToolbarColumnPinningTitle", "String");
            a.item("ScrollbarStyle", "ExportedType:string:ScrollbarStyle");
            a.item("ScrollbarStyle@names", "Default;Fading;Thin");
            a.item("ScrollbarBackground", "Brush");
            a.item("AllowCopyOperation", "Boolean");
            a.item("DeferEventForRowDragSelection", "Boolean");
            a.item("FilterExpressionsChangingRef", "EventRef::filterExpressionsChanging");
            a.item("FilterExpressionsChangedRef", "EventRef::filterExpressionsChanged");
            a.item("CellPreviewPointerDownRef", "EventRef::cellPreviewPointerDown");
            a.item("CellPreviewPointerUpRef", "EventRef::cellPreviewPointerUp");
            a.item("CellPointerDownRef", "EventRef::cellPointerDown");
            a.item("CellPointerUpRef", "EventRef::cellPointerUp");
            a.item("CellClickedRef", "EventRef::cellClicked");
            a.item("SortDescriptionsChangedRef", "EventRef::sortDescriptionsChanged");
            a.item("GroupDescriptionsChangedRef", "EventRef::groupDescriptionsChanged");
            a.item("SummaryDescriptionsChangedRef", "EventRef::summaryDescriptionsChanged");
            a.item("ColumnHiddenChangedRef", "EventRef::columnHiddenChanged");
            a.item("ColumnPinnedChangedRef", "EventRef::columnPinnedChanged");
            a.item("CellValueChangingRef", "EventRef::cellValueChanging");
            a.item("DataCommittedRef", "EventRef::dataCommitted");
            a.item("DataCommittingRef", "EventRef::dataCommitting");
            a.item("SizeChangedRef", "EventRef::sizeChanged");
            a.item("ActualColumnsChangedRef", "EventRef::actualColumnsChanged");
            a.item("ColumnsAutoGeneratedRef", "EventRef::columnsAutoGenerated");
            a.item("SelectedItemsChangedRef", "EventRef::selectedItemsChanged");
            a.item("SelectedKeysChangedRef", "EventRef::selectedKeysChanged");
            a.item("SelectedCellsChangedRef", "EventRef::selectedCellsChanged");
            a.item("SelectionChangedRef", "EventRef::selectionChanged");
            a.item("ActiveCellChangedRef", "EventRef::activeCellChanged");
            a.item("SelectedCellRangesChangedRef", "EventRef::selectedCellRangesChanged");
            a.item("ColumnWidthChangedRef", "EventRef::columnWidthChanged");
            a.item("CellEditStartedRef", "EventRef::cellEditStarted");
            a.item("CellEditEndedRef", "EventRef::cellEditEnded");
            a.item("RowEditStartedRef", "EventRef::rowEditStarted");
            a.item("RowEditEndedRef", "EventRef::rowEditEnded");
            a.item("CustomFilterRequestedRef", "EventRef::customFilterRequested");
            a.item("ActualPrimaryKeyChangeRef", "EventRef::actualPrimaryKeyChange");
            DataGridDescriptionMetadata.e(a);
        }
        static d(a) {
            DataGridDescriptionMetadata.b(a);
            a.ae("DataGrid", () => new DataGridDescription());
            a.ad("DataGrid", DataGridDescriptionMetadata.a);
        }
    }
    DataGridDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridDescriptionMetadata, 'DataGridDescriptionMetadata');
    DataGridDescriptionMetadata.a = null;
    return DataGridDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataGridCoreDescriptionModule extends Base {
        static register(a) {
            TextHeaderDescriptionModule.register(a);
            SectionHeaderDescriptionModule.register(a);
            RowSeparatorDescriptionModule.register(a);
            HeaderSeparatorDescriptionModule.register(a);
            ColumnResizingSeparatorDescriptionModule.register(a);
            ColumnMovingSeparatorDescriptionModule.register(a);
            SummaryRowRootDescriptionModule.register(a);
            SummaryRowSectionDescriptionModule.register(a);
            ColumnWidthDescriptionModule.register(a);
            ColumnSortDescriptionDescriptionModule.register(a);
            ColumnGroupDescriptionDescriptionModule.register(a);
            ColumnSummaryDescriptionDescriptionModule.register(a);
            PrimaryKeyValueDescriptionModule.register(a);
            CellKeyDescriptionModule.register(a);
            CellRangeDescriptionModule.register(a);
            GridCellPositionDescriptionModule.register(a);
            LocalDataSourceDescriptionModule.register(a);
            NumberFormatSpecifierDescriptionModule.register(a);
            DateTimeFormatSpecifierDescriptionModule.register(a);
            DataGridDescriptionMetadata.d(a);
        }
    }
    DataGridCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataGridCoreDescriptionModule, 'DataGridCoreDescriptionModule');
    return DataGridCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridColumnDescription = /*@__PURE__*/ (() => {
    class DataGridColumnDescription extends DefinitionBaseDescription {
        get_type() {
            return "DataGridColumn";
        }
        constructor() {
            super();
            this.dk = 0;
            this.dm = 0;
            this.dl = 0;
            this.dj = 0;
            this.ej = null;
            this.ed = null;
            this.ef = null;
            this.d1 = null;
            this.en = null;
            this.d5 = null;
            this.el = null;
            this.d3 = null;
            this.em = null;
            this.d4 = null;
            this.cc = null;
            this.b8 = null;
            this.da = 0;
            this.cq = false;
            this.ck = false;
            this.b6 = null;
            this.ca = null;
            this.ce = null;
            this.cp = false;
            this.cs = false;
            this.cr = false;
            this.ct = false;
            this.eo = null;
            this.ek = null;
            this.dx = null;
            this.d6 = null;
            this.dz = null;
            this.d8 = null;
            this.d7 = null;
            this.dy = null;
            this.ch = false;
            this.cl = false;
            this.cj = false;
            this.cn = false;
            this.ci = false;
            this.cm = false;
            this.co = false;
            this.d9 = null;
            this.d0 = null;
            this.c9 = 0;
            this.c7 = 0;
            this.ea = null;
            this.c8 = 0;
            this.eb = null;
            this.ec = null;
            this.eh = null;
            this.eg = null;
            this.ei = null;
            this.dg = 0;
            this.di = 0;
            this.dh = 0;
            this.df = 0;
            this.ee = null;
            this.b4 = null;
            this.d2 = null;
        }
        get paddingLeft() {
            return this.dk;
        }
        set paddingLeft(a) {
            this.dk = a;
            this.g("PaddingLeft");
        }
        get paddingTop() {
            return this.dm;
        }
        set paddingTop(a) {
            this.dm = a;
            this.g("PaddingTop");
        }
        get paddingRight() {
            return this.dl;
        }
        set paddingRight(a) {
            this.dl = a;
            this.g("PaddingRight");
        }
        get paddingBottom() {
            return this.dj;
        }
        set paddingBottom(a) {
            this.dj = a;
            this.g("PaddingBottom");
        }
        get name() {
            return this.ej;
        }
        set name(a) {
            this.ej = a;
            this.g("Name");
        }
        get field() {
            return this.ed;
        }
        set field(a) {
            this.ed = a;
            this.g("Field");
        }
        get headerText() {
            return this.ef;
        }
        set headerText(a) {
            this.ef = a;
            this.g("HeaderText");
        }
        get actualHeaderText() {
            return this.d1;
        }
        set actualHeaderText(a) {
            this.d1 = a;
            this.g("ActualHeaderText");
        }
        get selectedBackground() {
            return this.en;
        }
        set selectedBackground(a) {
            this.en = a;
            this.g("SelectedBackground");
        }
        get actualSelectedBackground() {
            return this.d5;
        }
        set actualSelectedBackground(a) {
            this.d5 = a;
            this.g("ActualSelectedBackground");
        }
        get rowHoverBackground() {
            return this.el;
        }
        set rowHoverBackground(a) {
            this.el = a;
            this.g("RowHoverBackground");
        }
        get actualHoverBackground() {
            return this.d3;
        }
        set actualHoverBackground(a) {
            this.d3 = a;
            this.g("ActualHoverBackground");
        }
        get rowHoverTextColor() {
            return this.em;
        }
        set rowHoverTextColor(a) {
            this.em = a;
            this.g("RowHoverTextColor");
        }
        get actualRowHoverTextColor() {
            return this.d4;
        }
        set actualRowHoverTextColor(a) {
            this.d4 = a;
            this.g("ActualRowHoverTextColor");
        }
        get animationSettings() {
            return this.cc;
        }
        set animationSettings(a) {
            this.cc = a;
            this.g("AnimationSettings");
        }
        get width() {
            return this.b8;
        }
        set width(a) {
            this.b8 = a;
            this.g("Width");
        }
        get minWidth() {
            return this.da;
        }
        set minWidth(a) {
            this.da = a;
            this.g("MinWidth");
        }
        get isFromMarkup() {
            return this.cq;
        }
        set isFromMarkup(a) {
            this.cq = a;
            this.g("IsFromMarkup");
        }
        get isAutoGenerated() {
            return this.ck;
        }
        set isAutoGenerated(a) {
            this.ck = a;
            this.g("IsAutoGenerated");
        }
        get filter() {
            return this.b6;
        }
        set filter(a) {
            this.b6 = a;
            this.g("Filter");
        }
        get filterExpression() {
            return this.ca;
        }
        set filterExpression(a) {
            this.ca = a;
            this.g("FilterExpression");
        }
        get header() {
            return this.ce;
        }
        set header(a) {
            this.ce = a;
            this.g("Header");
        }
        get isFilteringEnabled() {
            return this.cp;
        }
        set isFilteringEnabled(a) {
            this.cp = a;
            this.g("IsFilteringEnabled");
        }
        get isResizingEnabled() {
            return this.cs;
        }
        set isResizingEnabled(a) {
            this.cs = a;
            this.g("IsResizingEnabled");
        }
        get isHidden() {
            return this.cr;
        }
        set isHidden(a) {
            this.cr = a;
            this.g("IsHidden");
        }
        get shouldRemoveWhenHidden() {
            return this.ct;
        }
        set shouldRemoveWhenHidden(a) {
            this.ct = a;
            this.g("ShouldRemoveWhenHidden");
        }
        get sortDirection() {
            return this.eo;
        }
        set sortDirection(a) {
            this.eo = a;
            this.g("SortDirection");
        }
        get pinned() {
            return this.ek;
        }
        set pinned(a) {
            this.ek = a;
            this.g("Pinned");
        }
        get actualColumnOptionsIconAlignment() {
            return this.dx;
        }
        set actualColumnOptionsIconAlignment(a) {
            this.dx = a;
            this.g("ActualColumnOptionsIconAlignment");
        }
        get columnOptionsIconAlignment() {
            return this.d6;
        }
        set columnOptionsIconAlignment(a) {
            this.d6 = a;
            this.g("ColumnOptionsIconAlignment");
        }
        get actualColumnOptionsIconColor() {
            return this.dz;
        }
        set actualColumnOptionsIconColor(a) {
            this.dz = a;
            this.g("ActualColumnOptionsIconColor");
        }
        get columnOptionsIconColor() {
            return this.d8;
        }
        set columnOptionsIconColor(a) {
            this.d8 = a;
            this.g("ColumnOptionsIconColor");
        }
        get columnOptionsIconBehavior() {
            return this.d7;
        }
        set columnOptionsIconBehavior(a) {
            this.d7 = a;
            this.g("ColumnOptionsIconBehavior");
        }
        get actualColumnOptionsIconBehavior() {
            return this.dy;
        }
        set actualColumnOptionsIconBehavior(a) {
            this.dy = a;
            this.g("ActualColumnOptionsIconBehavior");
        }
        get actualIsColumnOptionsEnabled() {
            return this.ch;
        }
        set actualIsColumnOptionsEnabled(a) {
            this.ch = a;
            this.g("ActualIsColumnOptionsEnabled");
        }
        get isColumnOptionsEnabled() {
            return this.cl;
        }
        set isColumnOptionsEnabled(a) {
            this.cl = a;
            this.g("IsColumnOptionsEnabled");
        }
        get actualIsColumnOptionsSummariesEnabled() {
            return this.cj;
        }
        set actualIsColumnOptionsSummariesEnabled(a) {
            this.cj = a;
            this.g("ActualIsColumnOptionsSummariesEnabled");
        }
        get isColumnOptionsSummariesEnabled() {
            return this.cn;
        }
        set isColumnOptionsSummariesEnabled(a) {
            this.cn = a;
            this.g("IsColumnOptionsSummariesEnabled");
        }
        get actualIsColumnOptionsGroupingEnabled() {
            return this.ci;
        }
        set actualIsColumnOptionsGroupingEnabled(a) {
            this.ci = a;
            this.g("ActualIsColumnOptionsGroupingEnabled");
        }
        get isColumnOptionsGroupingEnabled() {
            return this.cm;
        }
        set isColumnOptionsGroupingEnabled(a) {
            this.cm = a;
            this.g("IsColumnOptionsGroupingEnabled");
        }
        get isEditable() {
            return this.co;
        }
        set isEditable(a) {
            this.co = a;
            this.g("IsEditable");
        }
        get deletedTextColor() {
            return this.d9;
        }
        set deletedTextColor(a) {
            this.d9 = a;
            this.g("DeletedTextColor");
        }
        get actualDeletedTextColor() {
            return this.d0;
        }
        set actualDeletedTextColor(a) {
            this.d0 = a;
            this.g("ActualDeletedTextColor");
        }
        get editOpacity() {
            return this.c9;
        }
        set editOpacity(a) {
            this.c9 = a;
            this.g("EditOpacity");
        }
        get actualEditOpacity() {
            return this.c7;
        }
        set actualEditOpacity(a) {
            this.c7 = a;
            this.g("ActualEditOpacity");
        }
        get editFontFamily() {
            return this.ea;
        }
        set editFontFamily(a) {
            this.ea = a;
            this.g("EditFontFamily");
        }
        get editFontSize() {
            return this.c8;
        }
        set editFontSize(a) {
            this.c8 = a;
            this.g("EditFontSize");
        }
        get editFontStyle() {
            return this.eb;
        }
        set editFontStyle(a) {
            this.eb = a;
            this.g("EditFontStyle");
        }
        get editFontWeight() {
            return this.ec;
        }
        set editFontWeight(a) {
            this.ec = a;
            this.g("EditFontWeight");
        }
        get mergedCellMode() {
            return this.eh;
        }
        set mergedCellMode(a) {
            this.eh = a;
            this.g("MergedCellMode");
        }
        get mergedCellEvaluationCriteria() {
            return this.eg;
        }
        set mergedCellEvaluationCriteria(a) {
            this.eg = a;
            this.g("MergedCellEvaluationCriteria");
        }
        get mergedCellVerticalAlignment() {
            return this.ei;
        }
        set mergedCellVerticalAlignment(a) {
            this.ei = a;
            this.g("MergedCellVerticalAlignment");
        }
        get mergedCellPaddingLeft() {
            return this.dg;
        }
        set mergedCellPaddingLeft(a) {
            this.dg = a;
            this.g("MergedCellPaddingLeft");
        }
        get mergedCellPaddingTop() {
            return this.di;
        }
        set mergedCellPaddingTop(a) {
            this.di = a;
            this.g("MergedCellPaddingTop");
        }
        get mergedCellPaddingRight() {
            return this.dh;
        }
        set mergedCellPaddingRight(a) {
            this.dh = a;
            this.g("MergedCellPaddingRight");
        }
        get mergedCellPaddingBottom() {
            return this.df;
        }
        set mergedCellPaddingBottom(a) {
            this.df = a;
            this.g("MergedCellPaddingBottom");
        }
        get filterComparisonType() {
            return this.ee;
        }
        set filterComparisonType(a) {
            this.ee = a;
            this.g("FilterComparisonType");
        }
        get filterOperands() {
            return this.b4;
        }
        set filterOperands(a) {
            this.b4 = a;
            this.g("FilterOperands");
        }
        get actualHeaderTextChangeRef() {
            return this.d2;
        }
        set actualHeaderTextChangeRef(a) {
            this.d2 = a;
            this.g("ActualHeaderTextChangeRef");
        }
    }
    DataGridColumnDescription.$t = /*@__PURE__*/ markType(DataGridColumnDescription, 'DataGridColumnDescription', DefinitionBaseDescription.$);
    DataGridColumnDescription.__canMarshalByValue = true;
    DataGridColumnDescription.__marshalByValueAlias = "DataGridColumn";
    return DataGridColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextColumnDescription = /*@__PURE__*/ (() => {
    class TextColumnDescription extends DataGridColumnDescription {
        get_type() {
            return "TextColumn";
        }
        constructor() {
            super();
            this.fn = null;
            this.fl = null;
            this.fh = null;
            this.fm = null;
            this.fo = null;
        }
        get editorType() {
            return this.fn;
        }
        set editorType(a) {
            this.fn = a;
            this.g("EditorType");
        }
        get editorDataSourceRef() {
            return this.fl;
        }
        set editorDataSourceRef(a) {
            this.fl = a;
            this.g("EditorDataSourceRef");
        }
        get editorDataSource() {
            return this.fh;
        }
        set editorDataSource(a) {
            this.fh = a;
            this.g("EditorDataSource");
        }
        get editorTextField() {
            return this.fm;
        }
        set editorTextField(a) {
            this.fm = a;
            this.g("EditorTextField");
        }
        get editorValueField() {
            return this.fo;
        }
        set editorValueField(a) {
            this.fo = a;
            this.g("EditorValueField");
        }
    }
    TextColumnDescription.$t = /*@__PURE__*/ markType(TextColumnDescription, 'TextColumnDescription', DataGridColumnDescription.$);
    TextColumnDescription.__canMarshalByValue1 = true;
    TextColumnDescription.__marshalByValueAlias1 = "TextColumn";
    return TextColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class TextColumnDescriptionMetadata extends Base {
        static b(a) {
            if (TextColumnDescriptionMetadata.a == null) {
                TextColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TextColumnDescriptionMetadata.c(TextColumnDescriptionMetadata.a);
            }
            if (a.k(TextColumnDescriptionMetadata.a)) {
                return;
            }
            a.ac(TextColumnDescriptionMetadata.a);
        }
        static c(a) {
            DataGridColumnDescriptionMetadata.c(a);
            a.item("EditorType", "ExportedType:string:EditorType");
            a.item("EditorType@names", "Default;Text;Numeric;Date;Combo");
            a.item("EditorDataSourceRef", "(w:EditorItemsSource,xam:EditorItemsSource,wf:EditorItemsSource)DataRef::object");
            a.item("EditorDataSource", "(w:EditorItemsSource,xam:EditorItemsSource,wf:EditorItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            a.item("EditorTextField", "String");
            a.item("EditorValueField", "String");
        }
        static d(a) {
            TextColumnDescriptionMetadata.b(a);
            a.ae("TextColumn", () => new TextColumnDescription());
            a.ad("TextColumn", TextColumnDescriptionMetadata.a);
        }
    }
    TextColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(TextColumnDescriptionMetadata, 'TextColumnDescriptionMetadata');
    TextColumnDescriptionMetadata.a = null;
    return TextColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextColumnDescriptionModule = /*@__PURE__*/ (() => {
    class TextColumnDescriptionModule extends Base {
        static register(a) {
            TextColumnDescriptionMetadata.d(a);
        }
    }
    TextColumnDescriptionModule.$t = /*@__PURE__*/ markType(TextColumnDescriptionModule, 'TextColumnDescriptionModule');
    return TextColumnDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericColumnDescription = /*@__PURE__*/ (() => {
    class NumericColumnDescription extends DataGridColumnDescription {
        get_type() {
            return "NumericColumn";
        }
        constructor() {
            super();
            this.f1 = null;
            this.f3 = null;
            this.f2 = null;
            this.f4 = null;
            this.fo = 0;
            this.fp = 0;
            this.fq = 0;
            this.fm = false;
            this.f0 = null;
            this.fh = null;
            this.fz = null;
            this.fx = null;
            this.fv = null;
            this.fj = null;
            this.fw = null;
            this.fy = null;
        }
        get negativePrefix() {
            return this.f1;
        }
        set negativePrefix(a) {
            this.f1 = a;
            this.g("NegativePrefix");
        }
        get positivePrefix() {
            return this.f3;
        }
        set positivePrefix(a) {
            this.f3 = a;
            this.g("PositivePrefix");
        }
        get negativeSuffix() {
            return this.f2;
        }
        set negativeSuffix(a) {
            this.f2 = a;
            this.g("NegativeSuffix");
        }
        get positiveSuffix() {
            return this.f4;
        }
        set positiveSuffix(a) {
            this.f4 = a;
            this.g("PositiveSuffix");
        }
        get maxFractionDigits() {
            return this.fo;
        }
        set maxFractionDigits(a) {
            this.fo = a;
            this.g("MaxFractionDigits");
        }
        get minFractionDigits() {
            return this.fp;
        }
        set minFractionDigits(a) {
            this.fp = a;
            this.g("MinFractionDigits");
        }
        get minIntegerDigits() {
            return this.fq;
        }
        set minIntegerDigits(a) {
            this.fq = a;
            this.g("MinIntegerDigits");
        }
        get showGroupingSeparator() {
            return this.fm;
        }
        set showGroupingSeparator(a) {
            this.fm = a;
            this.g("ShowGroupingSeparator");
        }
        get formatString() {
            return this.f0;
        }
        set formatString(a) {
            this.f0 = a;
            this.g("FormatString");
        }
        get formatSpecifiers() {
            return this.fh;
        }
        set formatSpecifiers(a) {
            this.fh = a;
            this.g("FormatSpecifiers");
        }
        get formatOverrideRef() {
            return this.fz;
        }
        set formatOverrideRef(a) {
            this.fz = a;
            this.g("FormatOverrideRef");
        }
        get editorType() {
            return this.fx;
        }
        set editorType(a) {
            this.fx = a;
            this.g("EditorType");
        }
        get editorDataSourceRef() {
            return this.fv;
        }
        set editorDataSourceRef(a) {
            this.fv = a;
            this.g("EditorDataSourceRef");
        }
        get editorDataSource() {
            return this.fj;
        }
        set editorDataSource(a) {
            this.fj = a;
            this.g("EditorDataSource");
        }
        get editorTextField() {
            return this.fw;
        }
        set editorTextField(a) {
            this.fw = a;
            this.g("EditorTextField");
        }
        get editorValueField() {
            return this.fy;
        }
        set editorValueField(a) {
            this.fy = a;
            this.g("EditorValueField");
        }
    }
    NumericColumnDescription.$t = /*@__PURE__*/ markType(NumericColumnDescription, 'NumericColumnDescription', DataGridColumnDescription.$);
    NumericColumnDescription.__canMarshalByValue1 = true;
    NumericColumnDescription.__marshalByValueAlias1 = "NumericColumn";
    return NumericColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumericColumnDescriptionMetadata extends Base {
        static b(a) {
            if (NumericColumnDescriptionMetadata.a == null) {
                NumericColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumericColumnDescriptionMetadata.c(NumericColumnDescriptionMetadata.a);
            }
            if (a.k(NumericColumnDescriptionMetadata.a)) {
                return;
            }
            a.ac(NumericColumnDescriptionMetadata.a);
        }
        static c(a) {
            DataGridColumnDescriptionMetadata.c(a);
            a.item("NegativePrefix", "String");
            a.item("PositivePrefix", "String");
            a.item("NegativeSuffix", "String");
            a.item("PositiveSuffix", "String");
            a.item("MaxFractionDigits", "Number:int");
            a.item("MinFractionDigits", "Number:int");
            a.item("MinIntegerDigits", "Number:int");
            a.item("ShowGroupingSeparator", "Boolean");
            a.item("FormatString", "String");
            a.item("FormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("FormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("FormatOverrideRef", "(w:FormatOverride,wf:FormatOverride)DataRef");
            a.item("EditorType", "ExportedType:string:EditorType");
            a.item("EditorType@names", "Default;Text;Numeric;Date;Combo");
            a.item("EditorDataSourceRef", "(w:EditorItemsSource,xam:EditorItemsSource,wf:EditorItemsSource)DataRef::object");
            a.item("EditorDataSource", "(w:EditorItemsSource,xam:EditorItemsSource,wf:EditorItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            a.item("EditorTextField", "String");
            a.item("EditorValueField", "String");
        }
        static d(a) {
            NumericColumnDescriptionMetadata.b(a);
            a.ae("NumericColumn", () => new NumericColumnDescription());
            a.ad("NumericColumn", NumericColumnDescriptionMetadata.a);
        }
    }
    NumericColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(NumericColumnDescriptionMetadata, 'NumericColumnDescriptionMetadata');
    NumericColumnDescriptionMetadata.a = null;
    return NumericColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericColumnDescriptionModule = /*@__PURE__*/ (() => {
    class NumericColumnDescriptionModule extends Base {
        static register(a) {
            NumericColumnDescriptionMetadata.d(a);
        }
    }
    NumericColumnDescriptionModule.$t = /*@__PURE__*/ markType(NumericColumnDescriptionModule, 'NumericColumnDescriptionModule');
    return NumericColumnDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeColumnDescription = /*@__PURE__*/ (() => {
    class DateTimeColumnDescription extends DataGridColumnDescription {
        get_type() {
            return "DateTimeColumn";
        }
        constructor() {
            super();
            this.fp = null;
            this.fw = null;
            this.fr = null;
            this.fh = null;
            this.fv = null;
            this.fm = false;
            this.ft = null;
            this.fq = null;
            this.fj = null;
            this.fs = null;
            this.fu = null;
        }
        get dateTimeFormat() {
            return this.fp;
        }
        set dateTimeFormat(a) {
            this.fp = a;
            this.g("DateTimeFormat");
        }
        get formatString() {
            return this.fw;
        }
        set formatString(a) {
            this.fw = a;
            this.g("FormatString");
        }
        get editorFormatString() {
            return this.fr;
        }
        set editorFormatString(a) {
            this.fr = a;
            this.g("EditorFormatString");
        }
        get formatSpecifiers() {
            return this.fh;
        }
        set formatSpecifiers(a) {
            this.fh = a;
            this.g("FormatSpecifiers");
        }
        get formatOverrideRef() {
            return this.fv;
        }
        set formatOverrideRef(a) {
            this.fv = a;
            this.g("FormatOverrideRef");
        }
        get showTodayButton() {
            return this.fm;
        }
        set showTodayButton(a) {
            this.fm = a;
            this.g("ShowTodayButton");
        }
        get editorType() {
            return this.ft;
        }
        set editorType(a) {
            this.ft = a;
            this.g("EditorType");
        }
        get editorDataSourceRef() {
            return this.fq;
        }
        set editorDataSourceRef(a) {
            this.fq = a;
            this.g("EditorDataSourceRef");
        }
        get editorDataSource() {
            return this.fj;
        }
        set editorDataSource(a) {
            this.fj = a;
            this.g("EditorDataSource");
        }
        get editorTextField() {
            return this.fs;
        }
        set editorTextField(a) {
            this.fs = a;
            this.g("EditorTextField");
        }
        get editorValueField() {
            return this.fu;
        }
        set editorValueField(a) {
            this.fu = a;
            this.g("EditorValueField");
        }
    }
    DateTimeColumnDescription.$t = /*@__PURE__*/ markType(DateTimeColumnDescription, 'DateTimeColumnDescription', DataGridColumnDescription.$);
    DateTimeColumnDescription.__canMarshalByValue1 = true;
    DateTimeColumnDescription.__marshalByValueAlias1 = "DateTimeColumn";
    return DateTimeColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class DateTimeColumnDescriptionMetadata extends Base {
        static b(a) {
            if (DateTimeColumnDescriptionMetadata.a == null) {
                DateTimeColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DateTimeColumnDescriptionMetadata.c(DateTimeColumnDescriptionMetadata.a);
            }
            if (a.k(DateTimeColumnDescriptionMetadata.a)) {
                return;
            }
            a.ac(DateTimeColumnDescriptionMetadata.a);
        }
        static c(a) {
            DataGridColumnDescriptionMetadata.c(a);
            a.item("DateTimeFormat", "ExportedType:string:DateTimeFormats");
            a.item("DateTimeFormat@names", "DateShort;DateLong;TimeShort;TimeLong;DateTimeShort;DateTimeLong");
            a.item("FormatString", "String");
            a.item("EditorFormatString", "String");
            a.item("FormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("FormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("FormatOverrideRef", "(w:FormatOverride,wf:FormatOverride)DataRef");
            a.item("ShowTodayButton", "Boolean");
            a.item("EditorType", "ExportedType:string:EditorType");
            a.item("EditorType@names", "Default;Text;Numeric;Date;Combo");
            a.item("EditorDataSourceRef", "(w:EditorItemsSource,xam:EditorItemsSource,wf:EditorItemsSource)DataRef::object");
            a.item("EditorDataSource", "(w:EditorItemsSource,xam:EditorItemsSource,wf:EditorItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            a.item("EditorTextField", "String");
            a.item("EditorValueField", "String");
        }
        static d(a) {
            DateTimeColumnDescriptionMetadata.b(a);
            a.ae("DateTimeColumn", () => new DateTimeColumnDescription());
            a.ad("DateTimeColumn", DateTimeColumnDescriptionMetadata.a);
        }
    }
    DateTimeColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(DateTimeColumnDescriptionMetadata, 'DateTimeColumnDescriptionMetadata');
    DateTimeColumnDescriptionMetadata.a = null;
    return DateTimeColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeColumnDescriptionModule = /*@__PURE__*/ (() => {
    class DateTimeColumnDescriptionModule extends Base {
        static register(a) {
            DateTimeColumnDescriptionMetadata.d(a);
        }
    }
    DateTimeColumnDescriptionModule.$t = /*@__PURE__*/ markType(DateTimeColumnDescriptionModule, 'DateTimeColumnDescriptionModule');
    return DateTimeColumnDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateCellUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class TemplateCellUpdatingEventArgsDescription extends Description {
        get_type() {
            return "TemplateCellUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    TemplateCellUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(TemplateCellUpdatingEventArgsDescription, 'TemplateCellUpdatingEventArgsDescription', Description.$);
    return TemplateCellUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateCellUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateCellUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateCellUpdatingEventArgsDescriptionMetadata.a == null) {
                TemplateCellUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateCellUpdatingEventArgsDescriptionMetadata.c(TemplateCellUpdatingEventArgsDescriptionMetadata.a);
            }
            if (a.k(TemplateCellUpdatingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(TemplateCellUpdatingEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            TemplateCellUpdatingEventArgsDescriptionMetadata.b(a);
            a.ae("TemplateCellUpdatingEventArgs", () => new TemplateCellUpdatingEventArgsDescription());
            a.ad("TemplateCellUpdatingEventArgs", TemplateCellUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    TemplateCellUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateCellUpdatingEventArgsDescriptionMetadata, 'TemplateCellUpdatingEventArgsDescriptionMetadata');
    TemplateCellUpdatingEventArgsDescriptionMetadata.a = null;
    return TemplateCellUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateColumnDescription = /*@__PURE__*/ (() => {
    class TemplateColumnDescription extends DataGridColumnDescription {
        get templateRef() {
            return this.fk;
        }
        set templateRef(a) {
            this.fk = a;
            this.g("TemplateRef");
        }
        get_type() {
            return "TemplateColumn";
        }
        constructor() {
            super();
            this.fk = null;
            this.fj = null;
        }
        get cellUpdatingRef() {
            return this.fj;
        }
        set cellUpdatingRef(a) {
            this.fj = a;
            this.g("CellUpdatingRef");
        }
    }
    TemplateColumnDescription.$t = /*@__PURE__*/ markType(TemplateColumnDescription, 'TemplateColumnDescription', DataGridColumnDescription.$);
    TemplateColumnDescription.__canMarshalByValue1 = true;
    TemplateColumnDescription.__marshalByValueAlias1 = "TemplateColumn";
    return TemplateColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateColumnDescriptionMetadata extends Base {
        static e(a) {
            a.item("TemplateRef", "(w:Template,wf:Template,xam:Template)DataRef:String");
        }
        static b(a) {
            if (TemplateColumnDescriptionMetadata.a == null) {
                TemplateColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateColumnDescriptionMetadata.c(TemplateColumnDescriptionMetadata.a);
            }
            if (a.k(TemplateColumnDescriptionMetadata.a)) {
                return;
            }
            a.ac(TemplateColumnDescriptionMetadata.a);
            TemplateCellUpdatingEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            DataGridColumnDescriptionMetadata.c(a);
            a.item("CellUpdatingRef", "EventRef::cellUpdating");
            TemplateColumnDescriptionMetadata.e(a);
        }
        static d(a) {
            TemplateColumnDescriptionMetadata.b(a);
            a.ae("TemplateColumn", () => new TemplateColumnDescription());
            a.ad("TemplateColumn", TemplateColumnDescriptionMetadata.a);
        }
    }
    TemplateColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateColumnDescriptionMetadata, 'TemplateColumnDescriptionMetadata');
    TemplateColumnDescriptionMetadata.a = null;
    return TemplateColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateColumnDescriptionModule = /*@__PURE__*/ (() => {
    class TemplateColumnDescriptionModule extends Base {
        static register(a) {
            TemplateColumnDescriptionMetadata.d(a);
        }
    }
    TemplateColumnDescriptionModule.$t = /*@__PURE__*/ markType(TemplateColumnDescriptionModule, 'TemplateColumnDescriptionModule');
    return TemplateColumnDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxDescriptionModule = /*@__PURE__*/ (() => {
    class CheckboxDescriptionModule extends Base {
        static register(a) {
            RippleDescriptionModule.register(a);
            ChildContentDescriptionModule.register(a);
            CheckboxDescriptionMetadata.d(a);
        }
    }
    CheckboxDescriptionModule.$t = /*@__PURE__*/ markType(CheckboxDescriptionModule, 'CheckboxDescriptionModule');
    return CheckboxDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyEventArgsDescription = /*@__PURE__*/ (() => {
    class KeyEventArgsDescription extends Description {
        get_type() {
            return "KeyEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    KeyEventArgsDescription.$t = /*@__PURE__*/ markType(KeyEventArgsDescription, 'KeyEventArgsDescription', Description.$);
    return KeyEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class KeyEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (KeyEventArgsDescriptionMetadata.a == null) {
                KeyEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                KeyEventArgsDescriptionMetadata.c(KeyEventArgsDescriptionMetadata.a);
            }
            if (a.k(KeyEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(KeyEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            KeyEventArgsDescriptionMetadata.b(a);
            a.ae("KeyEventArgs", () => new KeyEventArgsDescription());
            a.ad("KeyEventArgs", KeyEventArgsDescriptionMetadata.a);
        }
    }
    KeyEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(KeyEventArgsDescriptionMetadata, 'KeyEventArgsDescriptionMetadata');
    KeyEventArgsDescriptionMetadata.a = null;
    return KeyEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputChangeEventArgsDescription = /*@__PURE__*/ (() => {
    class InputChangeEventArgsDescription extends Description {
        get_type() {
            return "InputChangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = false;
        }
        get value() {
            return this.j;
        }
        set value(a) {
            this.j = a;
            this.g("Value");
        }
        get isCompositionInProgress() {
            return this.h;
        }
        set isCompositionInProgress(a) {
            this.h = a;
            this.g("IsCompositionInProgress");
        }
    }
    InputChangeEventArgsDescription.$t = /*@__PURE__*/ markType(InputChangeEventArgsDescription, 'InputChangeEventArgsDescription', Description.$);
    return InputChangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputChangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class InputChangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (InputChangeEventArgsDescriptionMetadata.a == null) {
                InputChangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                InputChangeEventArgsDescriptionMetadata.c(InputChangeEventArgsDescriptionMetadata.a);
            }
            if (a.k(InputChangeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(InputChangeEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Value", "String");
            a.item("IsCompositionInProgress", "Boolean");
        }
        static d(a) {
            InputChangeEventArgsDescriptionMetadata.b(a);
            a.ae("InputChangeEventArgs", () => new InputChangeEventArgsDescription());
            a.ad("InputChangeEventArgs", InputChangeEventArgsDescriptionMetadata.a);
        }
    }
    InputChangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(InputChangeEventArgsDescriptionMetadata, 'InputChangeEventArgsDescriptionMetadata');
    InputChangeEventArgsDescriptionMetadata.a = null;
    return InputChangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputGroupItemDescriptionMetadata = /*@__PURE__*/ (() => {
    class InputGroupItemDescriptionMetadata extends Base {
        static b(a) {
            if (InputGroupItemDescriptionMetadata.a == null) {
                InputGroupItemDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                InputGroupItemDescriptionMetadata.c(InputGroupItemDescriptionMetadata.a);
            }
            if (a.k(InputGroupItemDescriptionMetadata.a)) {
                return;
            }
            a.ac(InputGroupItemDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:XInputGroupItem");
            a.item("Name", "String");
        }
        static d(a) {
            InputGroupItemDescriptionMetadata.b(a);
            a.ad("InputGroupItem", InputGroupItemDescriptionMetadata.a);
        }
    }
    InputGroupItemDescriptionMetadata.$t = /*@__PURE__*/ markType(InputGroupItemDescriptionMetadata, 'InputGroupItemDescriptionMetadata');
    InputGroupItemDescriptionMetadata.a = null;
    return InputGroupItemDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputGroupItemDescription = /*@__PURE__*/ (() => {
    class InputGroupItemDescription extends Description {
        get_type() {
            return "InputGroupItem";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get name() {
            return this.h;
        }
        set name(a) {
            this.h = a;
            this.g("Name");
        }
    }
    InputGroupItemDescription.$t = /*@__PURE__*/ markType(InputGroupItemDescription, 'InputGroupItemDescription', Description.$);
    return InputGroupItemDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputDescription = /*@__PURE__*/ (() => {
    class InputDescription extends InputGroupItemDescription {
        get_type() {
            return "Input";
        }
        constructor() {
            super();
            this.ag = null;
            this.ak = null;
            this.ac = null;
            this.av = null;
            this.ax = null;
            this.l = false;
            this.o = false;
            this.ae = null;
            this.ad = null;
            this.az = null;
            this.al = null;
            this.u = 0;
            this.am = null;
            this.an = null;
            this.ar = null;
            this.aw = null;
            this.ap = null;
            this.aq = null;
            this.y = 0;
            this.ao = null;
            this.af = null;
            this.m = false;
            this.a0 = null;
            this.k = false;
            this.n = false;
            this.ay = null;
            this.x = 0;
            this.w = 0;
            this.as = null;
            this.au = null;
            this.at = null;
            this.ah = null;
            this.ai = null;
            this.aj = null;
        }
        get baseTheme() {
            return this.ag;
        }
        set baseTheme(a) {
            this.ag = a;
            this.g("BaseTheme");
        }
        get density() {
            return this.ak;
        }
        set density(a) {
            this.ak = a;
            this.g("Density");
        }
        get actualDensity() {
            return this.ac;
        }
        set actualDensity(a) {
            this.ac = a;
            this.g("ActualDensity");
        }
        get mask() {
            return this.av;
        }
        set mask(a) {
            this.av = a;
            this.g("Mask");
        }
        get promptChar() {
            return this.ax;
        }
        set promptChar(a) {
            this.ax = a;
            this.g("PromptChar");
        }
        get includeLiterals() {
            return this.l;
        }
        set includeLiterals(a) {
            this.l = a;
            this.g("IncludeLiterals");
        }
        get showSpinner() {
            return this.o;
        }
        set showSpinner(a) {
            this.o = a;
            this.g("ShowSpinner");
        }
        get actualTextColor() {
            return this.ae;
        }
        set actualTextColor(a) {
            this.ae = a;
            this.g("ActualTextColor");
        }
        get actualHoverTextColor() {
            return this.ad;
        }
        set actualHoverTextColor(a) {
            this.ad = a;
            this.g("ActualHoverTextColor");
        }
        get textColor() {
            return this.az;
        }
        set textColor(a) {
            this.az = a;
            this.g("TextColor");
        }
        get fontFamily() {
            return this.al;
        }
        set fontFamily(a) {
            this.al = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.u;
        }
        set fontSize(a) {
            this.u = a;
            this.g("FontSize");
        }
        get fontStyle() {
            return this.am;
        }
        set fontStyle(a) {
            this.am = a;
            this.g("FontStyle");
        }
        get fontWeight() {
            return this.an;
        }
        set fontWeight(a) {
            this.an = a;
            this.g("FontWeight");
        }
        get inputType() {
            return this.ar;
        }
        set inputType(a) {
            this.ar = a;
            this.g("InputType");
        }
        get placeholder() {
            return this.aw;
        }
        set placeholder(a) {
            this.aw = a;
            this.g("Placeholder");
        }
        get hoverTextColor() {
            return this.ap;
        }
        set hoverTextColor(a) {
            this.ap = a;
            this.g("HoverTextColor");
        }
        get id() {
            return this.aq;
        }
        set id(a) {
            this.aq = a;
            this.g("Id");
        }
        get tabIndex() {
            return this.y;
        }
        set tabIndex(a) {
            this.y = a;
            this.g("TabIndex");
        }
        get $for() {
            return this.ao;
        }
        set $for(a) {
            this.ao = a;
            this.g("For");
        }
        get ariaLabel() {
            return this.af;
        }
        set ariaLabel(a) {
            this.af = a;
            this.g("AriaLabel");
        }
        get isHover() {
            return this.m;
        }
        set isHover(a) {
            this.m = a;
            this.g("IsHover");
        }
        get value() {
            return this.a0;
        }
        set value(a) {
            this.a0 = a;
            this.g("Value");
        }
        get disabled() {
            return this.k;
        }
        set disabled(a) {
            this.k = a;
            this.g("Disabled");
        }
        get readonly() {
            return this.n;
        }
        set readonly(a) {
            this.n = a;
            this.g("Readonly");
        }
        get textAlignment() {
            return this.ay;
        }
        set textAlignment(a) {
            this.ay = a;
            this.g("TextAlignment");
        }
        get selectionStart() {
            return this.x;
        }
        set selectionStart(a) {
            this.x = a;
            this.g("SelectionStart");
        }
        get selectionEnd() {
            return this.w;
        }
        set selectionEnd(a) {
            this.w = a;
            this.g("SelectionEnd");
        }
        get keyDownRef() {
            return this.as;
        }
        set keyDownRef(a) {
            this.as = a;
            this.g("KeyDownRef");
        }
        get keyUpRef() {
            return this.au;
        }
        set keyUpRef(a) {
            this.au = a;
            this.g("KeyUpRef");
        }
        get keyPressRef() {
            return this.at;
        }
        set keyPressRef(a) {
            this.at = a;
            this.g("KeyPressRef");
        }
        get changeRef() {
            return this.ah;
        }
        set changeRef(a) {
            this.ah = a;
            this.g("ChangeRef");
        }
        get changingRef() {
            return this.ai;
        }
        set changingRef(a) {
            this.ai = a;
            this.g("ChangingRef");
        }
        get compositionEndRef() {
            return this.aj;
        }
        set compositionEndRef(a) {
            this.aj = a;
            this.g("CompositionEndRef");
        }
    }
    InputDescription.$t = /*@__PURE__*/ markType(InputDescription, 'InputDescription', InputGroupItemDescription.$);
    return InputDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputDescriptionMetadata = /*@__PURE__*/ (() => {
    class InputDescriptionMetadata extends Base {
        static b(a) {
            if (InputDescriptionMetadata.a == null) {
                InputDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                InputDescriptionMetadata.c(InputDescriptionMetadata.a);
            }
            if (a.k(InputDescriptionMetadata.a)) {
                return;
            }
            a.ac(InputDescriptionMetadata.a);
            KeyEventArgsDescriptionMetadata.d(a);
            InputChangeEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            InputGroupItemDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:XInput");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActualDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("ActualDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("Mask", "String");
            a.item("PromptChar", "String");
            a.item("IncludeLiterals", "Boolean");
            a.item("ShowSpinner", "Boolean");
            a.item("ActualTextColor", "Brush");
            a.item("ActualHoverTextColor", "Brush");
            a.item("TextColor", "Brush");
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontFamily/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontFamily/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            a.item("InputType", "String");
            a.item("Placeholder", "String");
            a.item("HoverTextColor", "Brush");
            a.item("Id", "String");
            a.item("TabIndex", "Number:int");
            a.item("For", "(w:ForAttribute,xam:ForAttribute,wf:ForAttribute)String");
            a.item("AriaLabel", "String");
            a.item("IsHover", "Boolean");
            a.item("Value", "String");
            a.item("Disabled", "(w:IsDisabled,xam:IsDisabled,wf:IsDisabled)Boolean");
            a.item("Readonly", "(w:IsReadOnly,xam:IsReadOnly,wf:IsReadOnly)Boolean");
            a.item("TextAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("TextAlignment@names", "Left;Center;Right;Stretch");
            a.item("SelectionStart", "Number:int");
            a.item("SelectionEnd", "Number:int");
            a.item("KeyDownRef", "EventRef::keyDown");
            a.item("KeyUpRef", "EventRef::keyUp");
            a.item("KeyPressRef", "EventRef::keyPress");
            a.item("ChangeRef", "EventRef::change");
            a.item("ChangingRef", "EventRef::changing");
            a.item("CompositionEndRef", "EventRef::compositionEnd");
        }
        static d(a) {
            InputDescriptionMetadata.b(a);
            a.ae("Input", () => new InputDescription());
            a.ad("Input", InputDescriptionMetadata.a);
        }
    }
    InputDescriptionMetadata.$t = /*@__PURE__*/ markType(InputDescriptionMetadata, 'InputDescriptionMetadata');
    InputDescriptionMetadata.a = null;
    return InputDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputDescriptionModule = /*@__PURE__*/ (() => {
    class InputDescriptionModule extends Base {
        static register(a) {
            ChildContentDescriptionModule.register(a);
            InputDescriptionMetadata.d(a);
        }
    }
    InputDescriptionModule.$t = /*@__PURE__*/ markType(InputDescriptionModule, 'InputDescriptionModule');
    return InputDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelDescription = /*@__PURE__*/ (() => {
    class LabelDescription extends InputGroupItemDescription {
        get_type() {
            return "Label";
        }
        constructor() {
            super();
            this.ac = null;
            this.ad = null;
            this.u = null;
            this.y = null;
            this.v = null;
            this.w = null;
            this.x = null;
            this.aq = null;
            this.al = null;
            this.am = null;
            this.ah = null;
            this.q = 0;
            this.ai = null;
            this.aj = null;
            this.an = null;
            this.ao = null;
            this.ae = null;
            this.af = null;
            this.ag = null;
            this.z = null;
            this.aa = null;
            this.s = 0;
            this.ak = null;
            this.ab = null;
            this.ap = null;
            this.l = false;
            this.m = false;
            this.k = false;
        }
        get baseTheme() {
            return this.ac;
        }
        set baseTheme(a) {
            this.ac = a;
            this.g("BaseTheme");
        }
        get density() {
            return this.ad;
        }
        set density(a) {
            this.ad = a;
            this.g("Density");
        }
        get actualDensity() {
            return this.u;
        }
        set actualDensity(a) {
            this.u = a;
            this.g("ActualDensity");
        }
        get actualTextColor() {
            return this.y;
        }
        set actualTextColor(a) {
            this.y = a;
            this.g("ActualTextColor");
        }
        get actualHighlightTextColor() {
            return this.v;
        }
        set actualHighlightTextColor(a) {
            this.v = a;
            this.g("ActualHighlightTextColor");
        }
        get actualHoverHighlightTextColor() {
            return this.w;
        }
        set actualHoverHighlightTextColor(a) {
            this.w = a;
            this.g("ActualHoverHighlightTextColor");
        }
        get actualHoverTextColor() {
            return this.x;
        }
        set actualHoverTextColor(a) {
            this.x = a;
            this.g("ActualHoverTextColor");
        }
        get textColor() {
            return this.aq;
        }
        set textColor(a) {
            this.aq = a;
            this.g("TextColor");
        }
        get highlightTextColor() {
            return this.al;
        }
        set highlightTextColor(a) {
            this.al = a;
            this.g("HighlightTextColor");
        }
        get hoverHighlightTextColor() {
            return this.am;
        }
        set hoverHighlightTextColor(a) {
            this.am = a;
            this.g("HoverHighlightTextColor");
        }
        get fontFamily() {
            return this.ah;
        }
        set fontFamily(a) {
            this.ah = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.q;
        }
        set fontSize(a) {
            this.q = a;
            this.g("FontSize");
        }
        get fontStyle() {
            return this.ai;
        }
        set fontStyle(a) {
            this.ai = a;
            this.g("FontStyle");
        }
        get fontWeight() {
            return this.aj;
        }
        set fontWeight(a) {
            this.aj = a;
            this.g("FontWeight");
        }
        get hoverTextColor() {
            return this.an;
        }
        set hoverTextColor(a) {
            this.an = a;
            this.g("HoverTextColor");
        }
        get id() {
            return this.ao;
        }
        set id(a) {
            this.ao = a;
            this.g("Id");
        }
        get display() {
            return this.ae;
        }
        set display(a) {
            this.ae = a;
            this.g("Display");
        }
        get flexDirection() {
            return this.af;
        }
        set flexDirection(a) {
            this.af = a;
            this.g("FlexDirection");
        }
        get flexGrow() {
            return this.ag;
        }
        set flexGrow(a) {
            this.ag = a;
            this.g("FlexGrow");
        }
        get alignItems() {
            return this.z;
        }
        set alignItems(a) {
            this.z = a;
            this.g("AlignItems");
        }
        get alignSelf() {
            return this.aa;
        }
        set alignSelf(a) {
            this.aa = a;
            this.g("AlignSelf");
        }
        get tabIndex() {
            return this.s;
        }
        set tabIndex(a) {
            this.s = a;
            this.g("TabIndex");
        }
        get $for() {
            return this.ak;
        }
        set $for(a) {
            this.ak = a;
            this.g("For");
        }
        get ariaLabel() {
            return this.ab;
        }
        set ariaLabel(a) {
            this.ab = a;
            this.g("AriaLabel");
        }
        get text() {
            return this.ap;
        }
        set text(a) {
            this.ap = a;
            this.g("Text");
        }
        get isHover() {
            return this.l;
        }
        set isHover(a) {
            this.l = a;
            this.g("IsHover");
        }
        get value() {
            return this.m;
        }
        set value(a) {
            this.m = a;
            this.g("Value");
        }
        get disabled() {
            return this.k;
        }
        set disabled(a) {
            this.k = a;
            this.g("Disabled");
        }
    }
    LabelDescription.$t = /*@__PURE__*/ markType(LabelDescription, 'LabelDescription', InputGroupItemDescription.$);
    return LabelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelDescriptionMetadata = /*@__PURE__*/ (() => {
    class LabelDescriptionMetadata extends Base {
        static b(a) {
            if (LabelDescriptionMetadata.a == null) {
                LabelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LabelDescriptionMetadata.c(LabelDescriptionMetadata.a);
            }
            if (a.k(LabelDescriptionMetadata.a)) {
                return;
            }
            a.ac(LabelDescriptionMetadata.a);
        }
        static c(a) {
            InputGroupItemDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:XLabel");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActualDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("ActualDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActualTextColor", "Brush");
            a.item("ActualHighlightTextColor", "Brush");
            a.item("ActualHoverHighlightTextColor", "Brush");
            a.item("ActualHoverTextColor", "Brush");
            a.item("TextColor", "Brush");
            a.item("HighlightTextColor", "Brush");
            a.item("HoverHighlightTextColor", "Brush");
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontFamily/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontFamily/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            a.item("HoverTextColor", "Brush");
            a.item("Id", "String");
            a.item("Display", "String");
            a.item("FlexDirection", "String");
            a.item("FlexGrow", "String");
            a.item("AlignItems", "String");
            a.item("AlignSelf", "String");
            a.item("TabIndex", "Number:int");
            a.item("For", "(w:ForAttribute,xam:ForAttribute,wf:ForAttribute)String");
            a.item("AriaLabel", "String");
            a.item("Text", "String");
            a.item("IsHover", "Boolean");
            a.item("Value", "Boolean");
            a.item("Disabled", "(w:IsDisabled,xam:IsDisabled,wf:IsDisabled)Boolean");
        }
        static d(a) {
            LabelDescriptionMetadata.b(a);
            a.ae("Label", () => new LabelDescription());
            a.ad("Label", LabelDescriptionMetadata.a);
        }
    }
    LabelDescriptionMetadata.$t = /*@__PURE__*/ markType(LabelDescriptionMetadata, 'LabelDescriptionMetadata');
    LabelDescriptionMetadata.a = null;
    return LabelDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelDescriptionModule = /*@__PURE__*/ (() => {
    class LabelDescriptionModule extends Base {
        static register(a) {
            ChildContentDescriptionModule.register(a);
            LabelDescriptionMetadata.d(a);
        }
    }
    LabelDescriptionModule.$t = /*@__PURE__*/ markType(LabelDescriptionModule, 'LabelDescriptionModule');
    return LabelDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputGroupDescription = /*@__PURE__*/ (() => {
    class InputGroupDescription extends Description {
        get_type() {
            return "InputGroup";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.gu = null;
            this.gt = null;
            this.f6 = null;
            this.gd = null;
            this.f5 = null;
            this.f7 = null;
            this.t = 0;
            this.ac = 0;
            this.z = 0;
            this.y = 0;
            this.aa = 0;
            this.ab = 0;
            this.u = 0;
            this.v = 0;
            this.w = 0;
            this.x = 0;
            this.ak = 0;
            this.aj = 0;
            this.ag = 0;
            this.ga = null;
            this.gb = null;
            this.f9 = null;
            this.f8 = null;
            this.ah = 0;
            this.af = 0;
            this.ad = 0;
            this.ae = 0;
            this.ai = 0;
            this.f4 = null;
            this.a3 = 0;
            this.bu = 0;
            this.ge = null;
            this.br = 0;
            this.bq = 0;
            this.bs = 0;
            this.bt = 0;
            this.bm = 0;
            this.bn = 0;
            this.bo = 0;
            this.bp = 0;
            this.c2 = 0;
            this.c1 = 0;
            this.by = 0;
            this.hd = null;
            this.he = null;
            this.gx = null;
            this.gw = null;
            this.cz = 0;
            this.bx = 0;
            this.bv = 0;
            this.bw = 0;
            this.c0 = 0;
            this.gc = null;
            this.bz = 0;
            this.b8 = 0;
            this.g1 = null;
            this.g0 = null;
            this.b5 = 0;
            this.b4 = 0;
            this.b6 = 0;
            this.b7 = 0;
            this.b0 = 0;
            this.b1 = 0;
            this.b2 = 0;
            this.b3 = 0;
            this.cg = 0;
            this.cf = 0;
            this.cc = 0;
            this.g4 = null;
            this.g5 = null;
            this.g3 = null;
            this.g2 = null;
            this.cd = 0;
            this.cb = 0;
            this.b9 = 0;
            this.ca = 0;
            this.ce = 0;
            this.gz = null;
            this.a4 = 0;
            this.bd = 0;
            this.go = null;
            this.gn = null;
            this.ba = 0;
            this.a9 = 0;
            this.bb = 0;
            this.bc = 0;
            this.a5 = 0;
            this.a6 = 0;
            this.a7 = 0;
            this.a8 = 0;
            this.bl = 0;
            this.bk = 0;
            this.bh = 0;
            this.gr = null;
            this.gs = null;
            this.gq = null;
            this.gp = null;
            this.bi = 0;
            this.bg = 0;
            this.be = 0;
            this.bf = 0;
            this.bj = 0;
            this.gm = null;
            this.al = 0;
            this.au = 0;
            this.gh = null;
            this.gg = null;
            this.ar = 0;
            this.aq = 0;
            this.as = 0;
            this.at = 0;
            this.am = 0;
            this.an = 0;
            this.ao = 0;
            this.ap = 0;
            this.a2 = 0;
            this.a1 = 0;
            this.ay = 0;
            this.gk = null;
            this.gl = null;
            this.gj = null;
            this.gi = null;
            this.az = 0;
            this.ax = 0;
            this.av = 0;
            this.aw = 0;
            this.a0 = 0;
            this.gf = null;
            this.ch = 0;
            this.cq = 0;
            this.g8 = null;
            this.g7 = null;
            this.cn = 0;
            this.cm = 0;
            this.co = 0;
            this.cp = 0;
            this.ci = 0;
            this.cj = 0;
            this.ck = 0;
            this.cl = 0;
            this.cy = 0;
            this.cx = 0;
            this.cu = 0;
            this.hb = null;
            this.hc = null;
            this.ha = null;
            this.g9 = null;
            this.cv = 0;
            this.ct = 0;
            this.cr = 0;
            this.cs = 0;
            this.cw = 0;
            this.g6 = null;
            this.l = false;
            this.n = false;
            this.m = false;
            this.j = false;
            this.gv = null;
            this.gy = null;
            this.k = false;
            this.h = null;
        }
        get displayType() {
            return this.gu;
        }
        set displayType(a) {
            this.gu = a;
            this.g("DisplayType");
        }
        get density() {
            return this.gt;
        }
        set density(a) {
            this.gt = a;
            this.g("Density");
        }
        get actualDensity() {
            return this.f6;
        }
        set actualDensity(a) {
            this.f6 = a;
            this.g("ActualDensity");
        }
        get baseTheme() {
            return this.gd;
        }
        set baseTheme(a) {
            this.gd = a;
            this.g("BaseTheme");
        }
        get actualBorderColor() {
            return this.f5;
        }
        set actualBorderColor(a) {
            this.f5 = a;
            this.g("ActualBorderColor");
        }
        get actualFocusBorderColor() {
            return this.f7;
        }
        set actualFocusBorderColor(a) {
            this.f7 = a;
            this.g("ActualFocusBorderColor");
        }
        get actualBorderWidth() {
            return this.t;
        }
        set actualBorderWidth(a) {
            this.t = a;
            this.g("ActualBorderWidth");
        }
        get actualFocusBorderWidth() {
            return this.ac;
        }
        set actualFocusBorderWidth(a) {
            this.ac = a;
            this.g("ActualFocusBorderWidth");
        }
        get actualCornerRadiusBottomRight() {
            return this.z;
        }
        set actualCornerRadiusBottomRight(a) {
            this.z = a;
            this.g("ActualCornerRadiusBottomRight");
        }
        get actualCornerRadiusBottomLeft() {
            return this.y;
        }
        set actualCornerRadiusBottomLeft(a) {
            this.y = a;
            this.g("ActualCornerRadiusBottomLeft");
        }
        get actualCornerRadiusTopLeft() {
            return this.aa;
        }
        set actualCornerRadiusTopLeft(a) {
            this.aa = a;
            this.g("ActualCornerRadiusTopLeft");
        }
        get actualCornerRadiusTopRight() {
            return this.ab;
        }
        set actualCornerRadiusTopRight(a) {
            this.ab = a;
            this.g("ActualCornerRadiusTopRight");
        }
        get actualContentPaddingBottom() {
            return this.u;
        }
        set actualContentPaddingBottom(a) {
            this.u = a;
            this.g("ActualContentPaddingBottom");
        }
        get actualContentPaddingLeft() {
            return this.v;
        }
        set actualContentPaddingLeft(a) {
            this.v = a;
            this.g("ActualContentPaddingLeft");
        }
        get actualContentPaddingRight() {
            return this.w;
        }
        set actualContentPaddingRight(a) {
            this.w = a;
            this.g("ActualContentPaddingRight");
        }
        get actualContentPaddingTop() {
            return this.x;
        }
        set actualContentPaddingTop(a) {
            this.x = a;
            this.g("ActualContentPaddingTop");
        }
        get actualUnderlineWidth() {
            return this.ak;
        }
        set actualUnderlineWidth(a) {
            this.ak = a;
            this.g("ActualUnderlineWidth");
        }
        get actualUnderlineRippleWidth() {
            return this.aj;
        }
        set actualUnderlineRippleWidth(a) {
            this.aj = a;
            this.g("ActualUnderlineRippleWidth");
        }
        get actualHoverUnderlineWidth() {
            return this.ag;
        }
        set actualHoverUnderlineWidth(a) {
            this.ag = a;
            this.g("ActualHoverUnderlineWidth");
        }
        get actualUnderlineColor() {
            return this.ga;
        }
        set actualUnderlineColor(a) {
            this.ga = a;
            this.g("ActualUnderlineColor");
        }
        get actualUnderlineRippleColor() {
            return this.gb;
        }
        set actualUnderlineRippleColor(a) {
            this.gb = a;
            this.g("ActualUnderlineRippleColor");
        }
        get actualHoverUnderlineColor() {
            return this.f9;
        }
        set actualHoverUnderlineColor(a) {
            this.f9 = a;
            this.g("ActualHoverUnderlineColor");
        }
        get actualFocusUnderlineColor() {
            return this.f8;
        }
        set actualFocusUnderlineColor(a) {
            this.f8 = a;
            this.g("ActualFocusUnderlineColor");
        }
        get actualUnderlineOpacity() {
            return this.ah;
        }
        set actualUnderlineOpacity(a) {
            this.ah = a;
            this.g("ActualUnderlineOpacity");
        }
        get actualHoverUnderlineOpacity() {
            return this.af;
        }
        set actualHoverUnderlineOpacity(a) {
            this.af = a;
            this.g("ActualHoverUnderlineOpacity");
        }
        get actualFocusUnderlineOpacity() {
            return this.ad;
        }
        set actualFocusUnderlineOpacity(a) {
            this.ad = a;
            this.g("ActualFocusUnderlineOpacity");
        }
        get actualFocusUnderlineRippleOpacity() {
            return this.ae;
        }
        set actualFocusUnderlineRippleOpacity(a) {
            this.ae = a;
            this.g("ActualFocusUnderlineRippleOpacity");
        }
        get actualUnderlineRippleOpacity() {
            return this.ai;
        }
        set actualUnderlineRippleOpacity(a) {
            this.ai = a;
            this.g("ActualUnderlineRippleOpacity");
        }
        get actualBackgroundColor() {
            return this.f4;
        }
        set actualBackgroundColor(a) {
            this.f4 = a;
            this.g("ActualBackgroundColor");
        }
        get borderWidth() {
            return this.a3;
        }
        set borderWidth(a) {
            this.a3 = a;
            this.g("BorderWidth");
        }
        get focusBorderWidth() {
            return this.bu;
        }
        set focusBorderWidth(a) {
            this.bu = a;
            this.g("FocusBorderWidth");
        }
        get borderColor() {
            return this.ge;
        }
        set borderColor(a) {
            this.ge = a;
            this.g("BorderColor");
        }
        get cornerRadiusBottomRight() {
            return this.br;
        }
        set cornerRadiusBottomRight(a) {
            this.br = a;
            this.g("CornerRadiusBottomRight");
        }
        get cornerRadiusBottomLeft() {
            return this.bq;
        }
        set cornerRadiusBottomLeft(a) {
            this.bq = a;
            this.g("CornerRadiusBottomLeft");
        }
        get cornerRadiusTopLeft() {
            return this.bs;
        }
        set cornerRadiusTopLeft(a) {
            this.bs = a;
            this.g("CornerRadiusTopLeft");
        }
        get cornerRadiusTopRight() {
            return this.bt;
        }
        set cornerRadiusTopRight(a) {
            this.bt = a;
            this.g("CornerRadiusTopRight");
        }
        get contentPaddingBottom() {
            return this.bm;
        }
        set contentPaddingBottom(a) {
            this.bm = a;
            this.g("ContentPaddingBottom");
        }
        get contentPaddingLeft() {
            return this.bn;
        }
        set contentPaddingLeft(a) {
            this.bn = a;
            this.g("ContentPaddingLeft");
        }
        get contentPaddingRight() {
            return this.bo;
        }
        set contentPaddingRight(a) {
            this.bo = a;
            this.g("ContentPaddingRight");
        }
        get contentPaddingTop() {
            return this.bp;
        }
        set contentPaddingTop(a) {
            this.bp = a;
            this.g("ContentPaddingTop");
        }
        get underlineWidth() {
            return this.c2;
        }
        set underlineWidth(a) {
            this.c2 = a;
            this.g("UnderlineWidth");
        }
        get underlineRippleWidth() {
            return this.c1;
        }
        set underlineRippleWidth(a) {
            this.c1 = a;
            this.g("UnderlineRippleWidth");
        }
        get hoverUnderlineWidth() {
            return this.by;
        }
        set hoverUnderlineWidth(a) {
            this.by = a;
            this.g("HoverUnderlineWidth");
        }
        get underlineColor() {
            return this.hd;
        }
        set underlineColor(a) {
            this.hd = a;
            this.g("UnderlineColor");
        }
        get underlineRippleColor() {
            return this.he;
        }
        set underlineRippleColor(a) {
            this.he = a;
            this.g("UnderlineRippleColor");
        }
        get hoverUnderlineColor() {
            return this.gx;
        }
        set hoverUnderlineColor(a) {
            this.gx = a;
            this.g("HoverUnderlineColor");
        }
        get focusUnderlineColor() {
            return this.gw;
        }
        set focusUnderlineColor(a) {
            this.gw = a;
            this.g("FocusUnderlineColor");
        }
        get underlineOpacity() {
            return this.cz;
        }
        set underlineOpacity(a) {
            this.cz = a;
            this.g("UnderlineOpacity");
        }
        get hoverUnderlineOpacity() {
            return this.bx;
        }
        set hoverUnderlineOpacity(a) {
            this.bx = a;
            this.g("HoverUnderlineOpacity");
        }
        get focusUnderlineOpacity() {
            return this.bv;
        }
        set focusUnderlineOpacity(a) {
            this.bv = a;
            this.g("FocusUnderlineOpacity");
        }
        get focusUnderlineRippleOpacity() {
            return this.bw;
        }
        set focusUnderlineRippleOpacity(a) {
            this.bw = a;
            this.g("FocusUnderlineRippleOpacity");
        }
        get underlineRippleOpacity() {
            return this.c0;
        }
        set underlineRippleOpacity(a) {
            this.c0 = a;
            this.g("UnderlineRippleOpacity");
        }
        get backgroundColor() {
            return this.gc;
        }
        set backgroundColor(a) {
            this.gc = a;
            this.g("BackgroundColor");
        }
        get lineTypeBorderWidth() {
            return this.bz;
        }
        set lineTypeBorderWidth(a) {
            this.bz = a;
            this.g("LineTypeBorderWidth");
        }
        get lineTypeFocusBorderWidth() {
            return this.b8;
        }
        set lineTypeFocusBorderWidth(a) {
            this.b8 = a;
            this.g("LineTypeFocusBorderWidth");
        }
        get lineTypeFocusBorderColor() {
            return this.g1;
        }
        set lineTypeFocusBorderColor(a) {
            this.g1 = a;
            this.g("LineTypeFocusBorderColor");
        }
        get lineTypeBorderColor() {
            return this.g0;
        }
        set lineTypeBorderColor(a) {
            this.g0 = a;
            this.g("LineTypeBorderColor");
        }
        get lineTypeCornerRadiusBottomRight() {
            return this.b5;
        }
        set lineTypeCornerRadiusBottomRight(a) {
            this.b5 = a;
            this.g("LineTypeCornerRadiusBottomRight");
        }
        get lineTypeCornerRadiusBottomLeft() {
            return this.b4;
        }
        set lineTypeCornerRadiusBottomLeft(a) {
            this.b4 = a;
            this.g("LineTypeCornerRadiusBottomLeft");
        }
        get lineTypeCornerRadiusTopLeft() {
            return this.b6;
        }
        set lineTypeCornerRadiusTopLeft(a) {
            this.b6 = a;
            this.g("LineTypeCornerRadiusTopLeft");
        }
        get lineTypeCornerRadiusTopRight() {
            return this.b7;
        }
        set lineTypeCornerRadiusTopRight(a) {
            this.b7 = a;
            this.g("LineTypeCornerRadiusTopRight");
        }
        get lineTypeContentPaddingBottom() {
            return this.b0;
        }
        set lineTypeContentPaddingBottom(a) {
            this.b0 = a;
            this.g("LineTypeContentPaddingBottom");
        }
        get lineTypeContentPaddingLeft() {
            return this.b1;
        }
        set lineTypeContentPaddingLeft(a) {
            this.b1 = a;
            this.g("LineTypeContentPaddingLeft");
        }
        get lineTypeContentPaddingRight() {
            return this.b2;
        }
        set lineTypeContentPaddingRight(a) {
            this.b2 = a;
            this.g("LineTypeContentPaddingRight");
        }
        get lineTypeContentPaddingTop() {
            return this.b3;
        }
        set lineTypeContentPaddingTop(a) {
            this.b3 = a;
            this.g("LineTypeContentPaddingTop");
        }
        get lineTypeUnderlineWidth() {
            return this.cg;
        }
        set lineTypeUnderlineWidth(a) {
            this.cg = a;
            this.g("LineTypeUnderlineWidth");
        }
        get lineTypeUnderlineRippleWidth() {
            return this.cf;
        }
        set lineTypeUnderlineRippleWidth(a) {
            this.cf = a;
            this.g("LineTypeUnderlineRippleWidth");
        }
        get lineTypeHoverUnderlineWidth() {
            return this.cc;
        }
        set lineTypeHoverUnderlineWidth(a) {
            this.cc = a;
            this.g("LineTypeHoverUnderlineWidth");
        }
        get lineTypeUnderlineColor() {
            return this.g4;
        }
        set lineTypeUnderlineColor(a) {
            this.g4 = a;
            this.g("LineTypeUnderlineColor");
        }
        get lineTypeUnderlineRippleColor() {
            return this.g5;
        }
        set lineTypeUnderlineRippleColor(a) {
            this.g5 = a;
            this.g("LineTypeUnderlineRippleColor");
        }
        get lineTypeHoverUnderlineColor() {
            return this.g3;
        }
        set lineTypeHoverUnderlineColor(a) {
            this.g3 = a;
            this.g("LineTypeHoverUnderlineColor");
        }
        get lineTypeFocusUnderlineColor() {
            return this.g2;
        }
        set lineTypeFocusUnderlineColor(a) {
            this.g2 = a;
            this.g("LineTypeFocusUnderlineColor");
        }
        get lineTypeUnderlineOpacity() {
            return this.cd;
        }
        set lineTypeUnderlineOpacity(a) {
            this.cd = a;
            this.g("LineTypeUnderlineOpacity");
        }
        get lineTypeHoverUnderlineOpacity() {
            return this.cb;
        }
        set lineTypeHoverUnderlineOpacity(a) {
            this.cb = a;
            this.g("LineTypeHoverUnderlineOpacity");
        }
        get lineTypeFocusUnderlineOpacity() {
            return this.b9;
        }
        set lineTypeFocusUnderlineOpacity(a) {
            this.b9 = a;
            this.g("LineTypeFocusUnderlineOpacity");
        }
        get lineTypeFocusUnderlineRippleOpacity() {
            return this.ca;
        }
        set lineTypeFocusUnderlineRippleOpacity(a) {
            this.ca = a;
            this.g("LineTypeFocusUnderlineRippleOpacity");
        }
        get lineTypeUnderlineRippleOpacity() {
            return this.ce;
        }
        set lineTypeUnderlineRippleOpacity(a) {
            this.ce = a;
            this.g("LineTypeUnderlineRippleOpacity");
        }
        get lineTypeBackgroundColor() {
            return this.gz;
        }
        set lineTypeBackgroundColor(a) {
            this.gz = a;
            this.g("LineTypeBackgroundColor");
        }
        get boxTypeBorderWidth() {
            return this.a4;
        }
        set boxTypeBorderWidth(a) {
            this.a4 = a;
            this.g("BoxTypeBorderWidth");
        }
        get boxTypeFocusBorderWidth() {
            return this.bd;
        }
        set boxTypeFocusBorderWidth(a) {
            this.bd = a;
            this.g("BoxTypeFocusBorderWidth");
        }
        get boxTypeFocusBorderColor() {
            return this.go;
        }
        set boxTypeFocusBorderColor(a) {
            this.go = a;
            this.g("BoxTypeFocusBorderColor");
        }
        get boxTypeBorderColor() {
            return this.gn;
        }
        set boxTypeBorderColor(a) {
            this.gn = a;
            this.g("BoxTypeBorderColor");
        }
        get boxTypeCornerRadiusBottomRight() {
            return this.ba;
        }
        set boxTypeCornerRadiusBottomRight(a) {
            this.ba = a;
            this.g("BoxTypeCornerRadiusBottomRight");
        }
        get boxTypeCornerRadiusBottomLeft() {
            return this.a9;
        }
        set boxTypeCornerRadiusBottomLeft(a) {
            this.a9 = a;
            this.g("BoxTypeCornerRadiusBottomLeft");
        }
        get boxTypeCornerRadiusTopLeft() {
            return this.bb;
        }
        set boxTypeCornerRadiusTopLeft(a) {
            this.bb = a;
            this.g("BoxTypeCornerRadiusTopLeft");
        }
        get boxTypeCornerRadiusTopRight() {
            return this.bc;
        }
        set boxTypeCornerRadiusTopRight(a) {
            this.bc = a;
            this.g("BoxTypeCornerRadiusTopRight");
        }
        get boxTypeContentPaddingBottom() {
            return this.a5;
        }
        set boxTypeContentPaddingBottom(a) {
            this.a5 = a;
            this.g("BoxTypeContentPaddingBottom");
        }
        get boxTypeContentPaddingLeft() {
            return this.a6;
        }
        set boxTypeContentPaddingLeft(a) {
            this.a6 = a;
            this.g("BoxTypeContentPaddingLeft");
        }
        get boxTypeContentPaddingRight() {
            return this.a7;
        }
        set boxTypeContentPaddingRight(a) {
            this.a7 = a;
            this.g("BoxTypeContentPaddingRight");
        }
        get boxTypeContentPaddingTop() {
            return this.a8;
        }
        set boxTypeContentPaddingTop(a) {
            this.a8 = a;
            this.g("BoxTypeContentPaddingTop");
        }
        get boxTypeUnderlineWidth() {
            return this.bl;
        }
        set boxTypeUnderlineWidth(a) {
            this.bl = a;
            this.g("BoxTypeUnderlineWidth");
        }
        get boxTypeUnderlineRippleWidth() {
            return this.bk;
        }
        set boxTypeUnderlineRippleWidth(a) {
            this.bk = a;
            this.g("BoxTypeUnderlineRippleWidth");
        }
        get boxTypeHoverUnderlineWidth() {
            return this.bh;
        }
        set boxTypeHoverUnderlineWidth(a) {
            this.bh = a;
            this.g("BoxTypeHoverUnderlineWidth");
        }
        get boxTypeUnderlineColor() {
            return this.gr;
        }
        set boxTypeUnderlineColor(a) {
            this.gr = a;
            this.g("BoxTypeUnderlineColor");
        }
        get boxTypeUnderlineRippleColor() {
            return this.gs;
        }
        set boxTypeUnderlineRippleColor(a) {
            this.gs = a;
            this.g("BoxTypeUnderlineRippleColor");
        }
        get boxTypeHoverUnderlineColor() {
            return this.gq;
        }
        set boxTypeHoverUnderlineColor(a) {
            this.gq = a;
            this.g("BoxTypeHoverUnderlineColor");
        }
        get boxTypeFocusUnderlineColor() {
            return this.gp;
        }
        set boxTypeFocusUnderlineColor(a) {
            this.gp = a;
            this.g("BoxTypeFocusUnderlineColor");
        }
        get boxTypeUnderlineOpacity() {
            return this.bi;
        }
        set boxTypeUnderlineOpacity(a) {
            this.bi = a;
            this.g("BoxTypeUnderlineOpacity");
        }
        get boxTypeHoverUnderlineOpacity() {
            return this.bg;
        }
        set boxTypeHoverUnderlineOpacity(a) {
            this.bg = a;
            this.g("BoxTypeHoverUnderlineOpacity");
        }
        get boxTypeFocusUnderlineOpacity() {
            return this.be;
        }
        set boxTypeFocusUnderlineOpacity(a) {
            this.be = a;
            this.g("BoxTypeFocusUnderlineOpacity");
        }
        get boxTypeFocusUnderlineRippleOpacity() {
            return this.bf;
        }
        set boxTypeFocusUnderlineRippleOpacity(a) {
            this.bf = a;
            this.g("BoxTypeFocusUnderlineRippleOpacity");
        }
        get boxTypeUnderlineRippleOpacity() {
            return this.bj;
        }
        set boxTypeUnderlineRippleOpacity(a) {
            this.bj = a;
            this.g("BoxTypeUnderlineRippleOpacity");
        }
        get boxTypeBackgroundColor() {
            return this.gm;
        }
        set boxTypeBackgroundColor(a) {
            this.gm = a;
            this.g("BoxTypeBackgroundColor");
        }
        get borderTypeBorderWidth() {
            return this.al;
        }
        set borderTypeBorderWidth(a) {
            this.al = a;
            this.g("BorderTypeBorderWidth");
        }
        get borderTypeFocusBorderWidth() {
            return this.au;
        }
        set borderTypeFocusBorderWidth(a) {
            this.au = a;
            this.g("BorderTypeFocusBorderWidth");
        }
        get borderTypeFocusBorderColor() {
            return this.gh;
        }
        set borderTypeFocusBorderColor(a) {
            this.gh = a;
            this.g("BorderTypeFocusBorderColor");
        }
        get borderTypeBorderColor() {
            return this.gg;
        }
        set borderTypeBorderColor(a) {
            this.gg = a;
            this.g("BorderTypeBorderColor");
        }
        get borderTypeCornerRadiusBottomRight() {
            return this.ar;
        }
        set borderTypeCornerRadiusBottomRight(a) {
            this.ar = a;
            this.g("BorderTypeCornerRadiusBottomRight");
        }
        get borderTypeCornerRadiusBottomLeft() {
            return this.aq;
        }
        set borderTypeCornerRadiusBottomLeft(a) {
            this.aq = a;
            this.g("BorderTypeCornerRadiusBottomLeft");
        }
        get borderTypeCornerRadiusTopLeft() {
            return this.as;
        }
        set borderTypeCornerRadiusTopLeft(a) {
            this.as = a;
            this.g("BorderTypeCornerRadiusTopLeft");
        }
        get borderTypeCornerRadiusTopRight() {
            return this.at;
        }
        set borderTypeCornerRadiusTopRight(a) {
            this.at = a;
            this.g("BorderTypeCornerRadiusTopRight");
        }
        get borderTypeContentPaddingBottom() {
            return this.am;
        }
        set borderTypeContentPaddingBottom(a) {
            this.am = a;
            this.g("BorderTypeContentPaddingBottom");
        }
        get borderTypeContentPaddingLeft() {
            return this.an;
        }
        set borderTypeContentPaddingLeft(a) {
            this.an = a;
            this.g("BorderTypeContentPaddingLeft");
        }
        get borderTypeContentPaddingRight() {
            return this.ao;
        }
        set borderTypeContentPaddingRight(a) {
            this.ao = a;
            this.g("BorderTypeContentPaddingRight");
        }
        get borderTypeContentPaddingTop() {
            return this.ap;
        }
        set borderTypeContentPaddingTop(a) {
            this.ap = a;
            this.g("BorderTypeContentPaddingTop");
        }
        get borderTypeUnderlineWidth() {
            return this.a2;
        }
        set borderTypeUnderlineWidth(a) {
            this.a2 = a;
            this.g("BorderTypeUnderlineWidth");
        }
        get borderTypeUnderlineRippleWidth() {
            return this.a1;
        }
        set borderTypeUnderlineRippleWidth(a) {
            this.a1 = a;
            this.g("BorderTypeUnderlineRippleWidth");
        }
        get borderTypeHoverUnderlineWidth() {
            return this.ay;
        }
        set borderTypeHoverUnderlineWidth(a) {
            this.ay = a;
            this.g("BorderTypeHoverUnderlineWidth");
        }
        get borderTypeUnderlineColor() {
            return this.gk;
        }
        set borderTypeUnderlineColor(a) {
            this.gk = a;
            this.g("BorderTypeUnderlineColor");
        }
        get borderTypeUnderlineRippleColor() {
            return this.gl;
        }
        set borderTypeUnderlineRippleColor(a) {
            this.gl = a;
            this.g("BorderTypeUnderlineRippleColor");
        }
        get borderTypeHoverUnderlineColor() {
            return this.gj;
        }
        set borderTypeHoverUnderlineColor(a) {
            this.gj = a;
            this.g("BorderTypeHoverUnderlineColor");
        }
        get borderTypeFocusUnderlineColor() {
            return this.gi;
        }
        set borderTypeFocusUnderlineColor(a) {
            this.gi = a;
            this.g("BorderTypeFocusUnderlineColor");
        }
        get borderTypeUnderlineOpacity() {
            return this.az;
        }
        set borderTypeUnderlineOpacity(a) {
            this.az = a;
            this.g("BorderTypeUnderlineOpacity");
        }
        get borderTypeHoverUnderlineOpacity() {
            return this.ax;
        }
        set borderTypeHoverUnderlineOpacity(a) {
            this.ax = a;
            this.g("BorderTypeHoverUnderlineOpacity");
        }
        get borderTypeFocusUnderlineOpacity() {
            return this.av;
        }
        set borderTypeFocusUnderlineOpacity(a) {
            this.av = a;
            this.g("BorderTypeFocusUnderlineOpacity");
        }
        get borderTypeFocusUnderlineRippleOpacity() {
            return this.aw;
        }
        set borderTypeFocusUnderlineRippleOpacity(a) {
            this.aw = a;
            this.g("BorderTypeFocusUnderlineRippleOpacity");
        }
        get borderTypeUnderlineRippleOpacity() {
            return this.a0;
        }
        set borderTypeUnderlineRippleOpacity(a) {
            this.a0 = a;
            this.g("BorderTypeUnderlineRippleOpacity");
        }
        get borderTypeBackgroundColor() {
            return this.gf;
        }
        set borderTypeBackgroundColor(a) {
            this.gf = a;
            this.g("BorderTypeBackgroundColor");
        }
        get searchTypeBorderWidth() {
            return this.ch;
        }
        set searchTypeBorderWidth(a) {
            this.ch = a;
            this.g("SearchTypeBorderWidth");
        }
        get searchTypeFocusBorderWidth() {
            return this.cq;
        }
        set searchTypeFocusBorderWidth(a) {
            this.cq = a;
            this.g("SearchTypeFocusBorderWidth");
        }
        get searchTypeFocusBorderColor() {
            return this.g8;
        }
        set searchTypeFocusBorderColor(a) {
            this.g8 = a;
            this.g("SearchTypeFocusBorderColor");
        }
        get searchTypeBorderColor() {
            return this.g7;
        }
        set searchTypeBorderColor(a) {
            this.g7 = a;
            this.g("SearchTypeBorderColor");
        }
        get searchTypeCornerRadiusBottomRight() {
            return this.cn;
        }
        set searchTypeCornerRadiusBottomRight(a) {
            this.cn = a;
            this.g("SearchTypeCornerRadiusBottomRight");
        }
        get searchTypeCornerRadiusBottomLeft() {
            return this.cm;
        }
        set searchTypeCornerRadiusBottomLeft(a) {
            this.cm = a;
            this.g("SearchTypeCornerRadiusBottomLeft");
        }
        get searchTypeCornerRadiusTopLeft() {
            return this.co;
        }
        set searchTypeCornerRadiusTopLeft(a) {
            this.co = a;
            this.g("SearchTypeCornerRadiusTopLeft");
        }
        get searchTypeCornerRadiusTopRight() {
            return this.cp;
        }
        set searchTypeCornerRadiusTopRight(a) {
            this.cp = a;
            this.g("SearchTypeCornerRadiusTopRight");
        }
        get searchTypeContentPaddingBottom() {
            return this.ci;
        }
        set searchTypeContentPaddingBottom(a) {
            this.ci = a;
            this.g("SearchTypeContentPaddingBottom");
        }
        get searchTypeContentPaddingLeft() {
            return this.cj;
        }
        set searchTypeContentPaddingLeft(a) {
            this.cj = a;
            this.g("SearchTypeContentPaddingLeft");
        }
        get searchTypeContentPaddingRight() {
            return this.ck;
        }
        set searchTypeContentPaddingRight(a) {
            this.ck = a;
            this.g("SearchTypeContentPaddingRight");
        }
        get searchTypeContentPaddingTop() {
            return this.cl;
        }
        set searchTypeContentPaddingTop(a) {
            this.cl = a;
            this.g("SearchTypeContentPaddingTop");
        }
        get searchTypeUnderlineWidth() {
            return this.cy;
        }
        set searchTypeUnderlineWidth(a) {
            this.cy = a;
            this.g("SearchTypeUnderlineWidth");
        }
        get searchTypeUnderlineRippleWidth() {
            return this.cx;
        }
        set searchTypeUnderlineRippleWidth(a) {
            this.cx = a;
            this.g("SearchTypeUnderlineRippleWidth");
        }
        get searchTypeHoverUnderlineWidth() {
            return this.cu;
        }
        set searchTypeHoverUnderlineWidth(a) {
            this.cu = a;
            this.g("SearchTypeHoverUnderlineWidth");
        }
        get searchTypeUnderlineColor() {
            return this.hb;
        }
        set searchTypeUnderlineColor(a) {
            this.hb = a;
            this.g("SearchTypeUnderlineColor");
        }
        get searchTypeUnderlineRippleColor() {
            return this.hc;
        }
        set searchTypeUnderlineRippleColor(a) {
            this.hc = a;
            this.g("SearchTypeUnderlineRippleColor");
        }
        get searchTypeHoverUnderlineColor() {
            return this.ha;
        }
        set searchTypeHoverUnderlineColor(a) {
            this.ha = a;
            this.g("SearchTypeHoverUnderlineColor");
        }
        get searchTypeFocusUnderlineColor() {
            return this.g9;
        }
        set searchTypeFocusUnderlineColor(a) {
            this.g9 = a;
            this.g("SearchTypeFocusUnderlineColor");
        }
        get searchTypeUnderlineOpacity() {
            return this.cv;
        }
        set searchTypeUnderlineOpacity(a) {
            this.cv = a;
            this.g("SearchTypeUnderlineOpacity");
        }
        get searchTypeHoverUnderlineOpacity() {
            return this.ct;
        }
        set searchTypeHoverUnderlineOpacity(a) {
            this.ct = a;
            this.g("SearchTypeHoverUnderlineOpacity");
        }
        get searchTypeFocusUnderlineOpacity() {
            return this.cr;
        }
        set searchTypeFocusUnderlineOpacity(a) {
            this.cr = a;
            this.g("SearchTypeFocusUnderlineOpacity");
        }
        get searchTypeFocusUnderlineRippleOpacity() {
            return this.cs;
        }
        set searchTypeFocusUnderlineRippleOpacity(a) {
            this.cs = a;
            this.g("SearchTypeFocusUnderlineRippleOpacity");
        }
        get searchTypeUnderlineRippleOpacity() {
            return this.cw;
        }
        set searchTypeUnderlineRippleOpacity(a) {
            this.cw = a;
            this.g("SearchTypeUnderlineRippleOpacity");
        }
        get searchTypeBackgroundColor() {
            return this.g6;
        }
        set searchTypeBackgroundColor(a) {
            this.g6 = a;
            this.g("SearchTypeBackgroundColor");
        }
        get isExpanded() {
            return this.l;
        }
        set isExpanded(a) {
            this.l = a;
            this.g("IsExpanded");
        }
        get isHovered() {
            return this.n;
        }
        set isHovered(a) {
            this.n = a;
            this.g("IsHovered");
        }
        get isFocused() {
            return this.m;
        }
        set isFocused(a) {
            this.m = a;
            this.g("IsFocused");
        }
        get actualIsExpanded() {
            return this.j;
        }
        set actualIsExpanded(a) {
            this.j = a;
            this.g("ActualIsExpanded");
        }
        get focusBorderColor() {
            return this.gv;
        }
        set focusBorderColor(a) {
            this.gv = a;
            this.g("FocusBorderColor");
        }
        get id() {
            return this.gy;
        }
        set id(a) {
            this.gy = a;
            this.g("Id");
        }
        get disabled() {
            return this.k;
        }
        set disabled(a) {
            this.k = a;
            this.g("Disabled");
        }
        get inputs() {
            return this.h;
        }
        set inputs(a) {
            this.h = a;
            this.g("Inputs");
        }
    }
    InputGroupDescription.$t = /*@__PURE__*/ markType(InputGroupDescription, 'InputGroupDescription', Description.$);
    return InputGroupDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputGroupDescriptionMetadata = /*@__PURE__*/ (() => {
    class InputGroupDescriptionMetadata extends Base {
        static b(a) {
            if (InputGroupDescriptionMetadata.a == null) {
                InputGroupDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                InputGroupDescriptionMetadata.c(InputGroupDescriptionMetadata.a);
            }
            if (a.k(InputGroupDescriptionMetadata.a)) {
                return;
            }
            a.ac(InputGroupDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:XInputGroup");
            a.item("DisplayType", "ExportedType:string:InputGroupDisplayType");
            a.item("DisplayType@names", "Line;Box;Border;Search");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActualDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("ActualDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("ActualBorderColor", "Brush");
            a.item("ActualFocusBorderColor", "Brush");
            a.item("ActualBorderWidth", "Number:double");
            a.item("ActualFocusBorderWidth", "Number:double");
            a.item("ActualCornerRadiusBottomRight", "(w:ActualCornerRadius.BottomRight,wf:ActualCornerRadiusBottomRight)Number:double");
            a.item("ActualCornerRadiusBottomLeft", "(w:ActualCornerRadius.BottomLeft,wf:ActualCornerRadiusBottomLeft)Number:double");
            a.item("ActualCornerRadiusTopLeft", "(w:ActualCornerRadius.TopLeft,wf:ActualCornerRadiusTopLeft)Number:double");
            a.item("ActualCornerRadiusTopRight", "(w:ActualCornerRadius.TopRight,wf:ActualCornerRadiusTopRight)Number:double");
            a.item("ActualContentPaddingBottom", "(w:ActualContentPadding.Bottom,wf:ActualContentPaddingBottom)Number:double");
            a.item("ActualContentPaddingLeft", "(w:ActualContentPadding.Left,wf:ActualContentPaddingLeft)Number:double");
            a.item("ActualContentPaddingRight", "(w:ActualContentPadding.Right,wf:ActualContentPaddingRight)Number:double");
            a.item("ActualContentPaddingTop", "(w:ActualContentPadding.Top,wf:ActualContentPaddingTop)Number:double");
            a.item("ActualUnderlineWidth", "Number:double");
            a.item("ActualUnderlineRippleWidth", "Number:double");
            a.item("ActualHoverUnderlineWidth", "Number:double");
            a.item("ActualUnderlineColor", "Brush");
            a.item("ActualUnderlineRippleColor", "Brush");
            a.item("ActualHoverUnderlineColor", "Brush");
            a.item("ActualFocusUnderlineColor", "Brush");
            a.item("ActualUnderlineOpacity", "Number:double");
            a.item("ActualHoverUnderlineOpacity", "Number:double");
            a.item("ActualFocusUnderlineOpacity", "Number:double");
            a.item("ActualFocusUnderlineRippleOpacity", "Number:double");
            a.item("ActualUnderlineRippleOpacity", "Number:double");
            a.item("ActualBackgroundColor", "Brush");
            a.item("BorderWidth", "Number:double");
            a.item("FocusBorderWidth", "Number:double");
            a.item("BorderColor", "Brush");
            a.item("CornerRadiusBottomRight", "(w:CornerRadius.BottomRight,wf:CornerRadiusBottomRight)Number:double");
            a.item("CornerRadiusBottomLeft", "(w:CornerRadius.BottomLeft,wf:CornerRadiusBottomLeft)Number:double");
            a.item("CornerRadiusTopLeft", "(w:CornerRadius.TopLeft,wf:CornerRadiusTopLeft)Number:double");
            a.item("CornerRadiusTopRight", "(w:CornerRadius.TopRight,wf:CornerRadiusTopRight)Number:double");
            a.item("ContentPaddingBottom", "(w:ContentPadding.Bottom,wf:ContentPaddingBottom)Number:double");
            a.item("ContentPaddingLeft", "(w:ContentPadding.Left,wf:ContentPaddingLeft)Number:double");
            a.item("ContentPaddingRight", "(w:ContentPadding.Right,wf:ContentPaddingRight)Number:double");
            a.item("ContentPaddingTop", "(w:ContentPadding.Top,wf:ContentPaddingTop)Number:double");
            a.item("UnderlineWidth", "Number:double");
            a.item("UnderlineRippleWidth", "Number:double");
            a.item("HoverUnderlineWidth", "Number:double");
            a.item("UnderlineColor", "Brush");
            a.item("UnderlineRippleColor", "Brush");
            a.item("HoverUnderlineColor", "Brush");
            a.item("FocusUnderlineColor", "Brush");
            a.item("UnderlineOpacity", "Number:double");
            a.item("HoverUnderlineOpacity", "Number:double");
            a.item("FocusUnderlineOpacity", "Number:double");
            a.item("FocusUnderlineRippleOpacity", "Number:double");
            a.item("UnderlineRippleOpacity", "Number:double");
            a.item("BackgroundColor", "Brush");
            a.item("LineTypeBorderWidth", "Number:double");
            a.item("LineTypeFocusBorderWidth", "Number:double");
            a.item("LineTypeFocusBorderColor", "Brush");
            a.item("LineTypeBorderColor", "Brush");
            a.item("LineTypeCornerRadiusBottomRight", "(w:LineTypeCornerRadius.BottomRight,wf:LineTypeCornerRadiusBottomRight)Number:double");
            a.item("LineTypeCornerRadiusBottomLeft", "(w:LineTypeCornerRadius.BottomLeft,wf:LineTypeCornerRadiusBottomLeft)Number:double");
            a.item("LineTypeCornerRadiusTopLeft", "(w:LineTypeCornerRadius.TopLeft,wf:LineTypeCornerRadiusTopLeft)Number:double");
            a.item("LineTypeCornerRadiusTopRight", "(w:LineTypeCornerRadius.TopRight,wf:LineTypeCornerRadiusTopRight)Number:double");
            a.item("LineTypeContentPaddingBottom", "(w:LineTypeContentPadding.Bottom,wf:LineTypeContentPaddingBottom)Number:double");
            a.item("LineTypeContentPaddingLeft", "(w:LineTypeContentPadding.Left,wf:LineTypeContentPaddingLeft)Number:double");
            a.item("LineTypeContentPaddingRight", "(w:LineTypeContentPadding.Right,wf:LineTypeContentPaddingRight)Number:double");
            a.item("LineTypeContentPaddingTop", "(w:LineTypeContentPadding.Top,wf:LineTypeContentPaddingTop)Number:double");
            a.item("LineTypeUnderlineWidth", "Number:double");
            a.item("LineTypeUnderlineRippleWidth", "Number:double");
            a.item("LineTypeHoverUnderlineWidth", "Number:double");
            a.item("LineTypeUnderlineColor", "Brush");
            a.item("LineTypeUnderlineRippleColor", "Brush");
            a.item("LineTypeHoverUnderlineColor", "Brush");
            a.item("LineTypeFocusUnderlineColor", "Brush");
            a.item("LineTypeUnderlineOpacity", "Number:double");
            a.item("LineTypeHoverUnderlineOpacity", "Number:double");
            a.item("LineTypeFocusUnderlineOpacity", "Number:double");
            a.item("LineTypeFocusUnderlineRippleOpacity", "Number:double");
            a.item("LineTypeUnderlineRippleOpacity", "Number:double");
            a.item("LineTypeBackgroundColor", "Brush");
            a.item("BoxTypeBorderWidth", "Number:double");
            a.item("BoxTypeFocusBorderWidth", "Number:double");
            a.item("BoxTypeFocusBorderColor", "Brush");
            a.item("BoxTypeBorderColor", "Brush");
            a.item("BoxTypeCornerRadiusBottomRight", "(w:BoxTypeCornerRadius.BottomRight,wf:BoxTypeCornerRadiusBottomRight)Number:double");
            a.item("BoxTypeCornerRadiusBottomLeft", "(w:BoxTypeCornerRadius.BottomLeft,wf:BoxTypeCornerRadiusBottomLeft)Number:double");
            a.item("BoxTypeCornerRadiusTopLeft", "(w:BoxTypeCornerRadius.TopLeft,wf:BoxTypeCornerRadiusTopLeft)Number:double");
            a.item("BoxTypeCornerRadiusTopRight", "(w:BoxTypeCornerRadius.TopRight,wf:BoxTypeCornerRadiusTopRight)Number:double");
            a.item("BoxTypeContentPaddingBottom", "(w:BoxTypeContentPadding.Bottom,wf:BoxTypeContentPaddingBottom)Number:double");
            a.item("BoxTypeContentPaddingLeft", "(w:BoxTypeContentPadding.Left,wf:BoxTypeContentPaddingLeft)Number:double");
            a.item("BoxTypeContentPaddingRight", "(w:BoxTypeContentPadding.Right,wf:BoxTypeContentPaddingRight)Number:double");
            a.item("BoxTypeContentPaddingTop", "(w:BoxTypeContentPadding.Top,wf:BoxTypeContentPaddingTop)Number:double");
            a.item("BoxTypeUnderlineWidth", "Number:double");
            a.item("BoxTypeUnderlineRippleWidth", "Number:double");
            a.item("BoxTypeHoverUnderlineWidth", "Number:double");
            a.item("BoxTypeUnderlineColor", "Brush");
            a.item("BoxTypeUnderlineRippleColor", "Brush");
            a.item("BoxTypeHoverUnderlineColor", "Brush");
            a.item("BoxTypeFocusUnderlineColor", "Brush");
            a.item("BoxTypeUnderlineOpacity", "Number:double");
            a.item("BoxTypeHoverUnderlineOpacity", "Number:double");
            a.item("BoxTypeFocusUnderlineOpacity", "Number:double");
            a.item("BoxTypeFocusUnderlineRippleOpacity", "Number:double");
            a.item("BoxTypeUnderlineRippleOpacity", "Number:double");
            a.item("BoxTypeBackgroundColor", "Brush");
            a.item("BorderTypeBorderWidth", "Number:double");
            a.item("BorderTypeFocusBorderWidth", "Number:double");
            a.item("BorderTypeFocusBorderColor", "Brush");
            a.item("BorderTypeBorderColor", "Brush");
            a.item("BorderTypeCornerRadiusBottomRight", "(w:BorderTypeCornerRadius.BottomRight,wf:BorderTypeCornerRadiusBottomRight)Number:double");
            a.item("BorderTypeCornerRadiusBottomLeft", "(w:BorderTypeCornerRadius.BottomLeft,wf:BorderTypeCornerRadiusBottomLeft)Number:double");
            a.item("BorderTypeCornerRadiusTopLeft", "(w:BorderTypeCornerRadius.TopLeft,wf:BorderTypeCornerRadiusTopLeft)Number:double");
            a.item("BorderTypeCornerRadiusTopRight", "(w:BorderTypeCornerRadius.TopRight,wf:BorderTypeCornerRadiusTopRight)Number:double");
            a.item("BorderTypeContentPaddingBottom", "(w:BorderTypeContentPadding.Bottom,wf:BorderTypeContentPaddingBottom)Number:double");
            a.item("BorderTypeContentPaddingLeft", "(w:BorderTypeContentPadding.Left,wf:BorderTypeContentPaddingLeft)Number:double");
            a.item("BorderTypeContentPaddingRight", "(w:BorderTypeContentPadding.Right,wf:BorderTypeContentPaddingRight)Number:double");
            a.item("BorderTypeContentPaddingTop", "(w:BorderTypeContentPadding.Top,wf:BorderTypeContentPaddingTop)Number:double");
            a.item("BorderTypeUnderlineWidth", "Number:double");
            a.item("BorderTypeUnderlineRippleWidth", "Number:double");
            a.item("BorderTypeHoverUnderlineWidth", "Number:double");
            a.item("BorderTypeUnderlineColor", "Brush");
            a.item("BorderTypeUnderlineRippleColor", "Brush");
            a.item("BorderTypeHoverUnderlineColor", "Brush");
            a.item("BorderTypeFocusUnderlineColor", "Brush");
            a.item("BorderTypeUnderlineOpacity", "Number:double");
            a.item("BorderTypeHoverUnderlineOpacity", "Number:double");
            a.item("BorderTypeFocusUnderlineOpacity", "Number:double");
            a.item("BorderTypeFocusUnderlineRippleOpacity", "Number:double");
            a.item("BorderTypeUnderlineRippleOpacity", "Number:double");
            a.item("BorderTypeBackgroundColor", "Brush");
            a.item("SearchTypeBorderWidth", "Number:double");
            a.item("SearchTypeFocusBorderWidth", "Number:double");
            a.item("SearchTypeFocusBorderColor", "Brush");
            a.item("SearchTypeBorderColor", "Brush");
            a.item("SearchTypeCornerRadiusBottomRight", "(w:SearchTypeCornerRadius.BottomRight,wf:SearchTypeCornerRadiusBottomRight)Number:double");
            a.item("SearchTypeCornerRadiusBottomLeft", "(w:SearchTypeCornerRadius.BottomLeft,wf:SearchTypeCornerRadiusBottomLeft)Number:double");
            a.item("SearchTypeCornerRadiusTopLeft", "(w:SearchTypeCornerRadius.TopLeft,wf:SearchTypeCornerRadiusTopLeft)Number:double");
            a.item("SearchTypeCornerRadiusTopRight", "(w:SearchTypeCornerRadius.TopRight,wf:SearchTypeCornerRadiusTopRight)Number:double");
            a.item("SearchTypeContentPaddingBottom", "(w:SearchTypeContentPadding.Bottom,wf:SearchTypeContentPaddingBottom)Number:double");
            a.item("SearchTypeContentPaddingLeft", "(w:SearchTypeContentPadding.Left,wf:SearchTypeContentPaddingLeft)Number:double");
            a.item("SearchTypeContentPaddingRight", "(w:SearchTypeContentPadding.Right,wf:SearchTypeContentPaddingRight)Number:double");
            a.item("SearchTypeContentPaddingTop", "(w:SearchTypeContentPadding.Top,wf:SearchTypeContentPaddingTop)Number:double");
            a.item("SearchTypeUnderlineWidth", "Number:double");
            a.item("SearchTypeUnderlineRippleWidth", "Number:double");
            a.item("SearchTypeHoverUnderlineWidth", "Number:double");
            a.item("SearchTypeUnderlineColor", "Brush");
            a.item("SearchTypeUnderlineRippleColor", "Brush");
            a.item("SearchTypeHoverUnderlineColor", "Brush");
            a.item("SearchTypeFocusUnderlineColor", "Brush");
            a.item("SearchTypeUnderlineOpacity", "Number:double");
            a.item("SearchTypeHoverUnderlineOpacity", "Number:double");
            a.item("SearchTypeFocusUnderlineOpacity", "Number:double");
            a.item("SearchTypeFocusUnderlineRippleOpacity", "Number:double");
            a.item("SearchTypeUnderlineRippleOpacity", "Number:double");
            a.item("SearchTypeBackgroundColor", "Brush");
            a.item("IsExpanded", "Boolean");
            a.item("IsHovered", "Boolean");
            a.item("IsFocused", "Boolean");
            a.item("ActualIsExpanded", "Boolean");
            a.item("FocusBorderColor", "Brush");
            a.item("Id", "String");
            a.item("Disabled", "(w:IsDisabled,xam:IsDisabled,wf:IsDisabled)Boolean");
            a.item("Inputs", "Collection:InputGroupItem:InputGroupInputCollection:InputGroupItem");
        }
        static d(a) {
            InputGroupDescriptionMetadata.b(a);
            a.ae("InputGroup", () => new InputGroupDescription());
            a.ad("InputGroup", InputGroupDescriptionMetadata.a);
        }
    }
    InputGroupDescriptionMetadata.$t = /*@__PURE__*/ markType(InputGroupDescriptionMetadata, 'InputGroupDescriptionMetadata');
    InputGroupDescriptionMetadata.a = null;
    return InputGroupDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputGroupDescriptionModule = /*@__PURE__*/ (() => {
    class InputGroupDescriptionModule extends Base {
        static register(a) {
            ChildContentDescriptionModule.register(a);
            InputDescriptionModule.register(a);
            LabelDescriptionModule.register(a);
            InputGroupDescriptionMetadata.d(a);
        }
    }
    InputGroupDescriptionModule.$t = /*@__PURE__*/ markType(InputGroupDescriptionModule, 'InputGroupDescriptionModule');
    return InputGroupDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxListDescriptionModule = /*@__PURE__*/ (() => {
    class CheckboxListDescriptionModule extends Base {
        static register(a) {
            DataGridCoreDescriptionModule.register(a);
            TextColumnDescriptionModule.register(a);
            NumericColumnDescriptionModule.register(a);
            DateTimeColumnDescriptionModule.register(a);
            TemplateColumnDescriptionModule.register(a);
            CheckboxDescriptionModule.register(a);
            InputGroupDescriptionModule.register(a);
            CheckboxListDescriptionMetadata.d(a);
        }
    }
    CheckboxListDescriptionModule.$t = /*@__PURE__*/ markType(CheckboxListDescriptionModule, 'CheckboxListDescriptionModule');
    return CheckboxListDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnChooserDescription = /*@__PURE__*/ (() => {
    class ColumnChooserDescription extends Description {
        get_type() {
            return "ColumnChooser";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.o = null;
            this.q = null;
            this.h = 0;
            this.r = null;
            this.s = null;
            this.p = null;
            this.m = null;
            this.k = null;
            this.l = null;
            this.j = null;
        }
        get targetGridRef() {
            return this.n;
        }
        set targetGridRef(a) {
            this.n = a;
            this.g("TargetGridRef");
        }
        get title() {
            return this.o;
        }
        set title(a) {
            this.o = a;
            this.g("Title");
        }
        get titleFontFamily() {
            return this.q;
        }
        set titleFontFamily(a) {
            this.q = a;
            this.g("TitleFontFamily");
        }
        get titleFontSize() {
            return this.h;
        }
        set titleFontSize(a) {
            this.h = a;
            this.g("TitleFontSize");
        }
        get titleFontStyle() {
            return this.r;
        }
        set titleFontStyle(a) {
            this.r = a;
            this.g("TitleFontStyle");
        }
        get titleFontWeight() {
            return this.s;
        }
        set titleFontWeight(a) {
            this.s = a;
            this.g("TitleFontWeight");
        }
        get titleColor() {
            return this.p;
        }
        set titleColor(a) {
            this.p = a;
            this.g("TitleColor");
        }
        get filterPlaceholderText() {
            return this.m;
        }
        set filterPlaceholderText(a) {
            this.m = a;
            this.g("FilterPlaceholderText");
        }
        get baseTheme() {
            return this.k;
        }
        set baseTheme(a) {
            this.k = a;
            this.g("BaseTheme");
        }
        get density() {
            return this.l;
        }
        set density(a) {
            this.l = a;
            this.g("Density");
        }
        get backgroundColor() {
            return this.j;
        }
        set backgroundColor(a) {
            this.j = a;
            this.g("BackgroundColor");
        }
    }
    ColumnChooserDescription.$t = /*@__PURE__*/ markType(ColumnChooserDescription, 'ColumnChooserDescription', Description.$);
    return ColumnChooserDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnChooserDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnChooserDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnChooserDescriptionMetadata.a == null) {
                ColumnChooserDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnChooserDescriptionMetadata.c(ColumnChooserDescriptionMetadata.a);
            }
            if (a.k(ColumnChooserDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnChooserDescriptionMetadata.a);
        }
        static c(a) {
            a.item("TargetGridRef", "(w:TargetGrid,wf:TargetGrid)DataRef::object");
            a.item("Title", "String");
            a.item("TitleFontFamily", "(w:TitleFontFamily/FontFamilyTransform,xam:TitleFontFamily,wf:TitleFontFamily,web:titleStyle/FontFamilyTransform)String");
            a.item("TitleFontSize", "(w:TitleFontSize,xam:TitleFontSize,wf:TitleFontSize,web:titleStyle/FontSizeTransform)Number:double");
            a.item("TitleFontStyle", "(w:TitleFontStyle/FontStyleTransform,xam:TitleFontFamily/FontStyleTransform,wf:TitleFontFamily/FontStyleTransform,web:titleStyle/FontStyleTransform)String");
            a.item("TitleFontWeight", "(w:TitleFontWeight/FontWeightTransform,xam:TitleFontFamily/FontWeightTransform,wf:TitleFontFamily/FontWeightTransform,web:titleStyle/FontWeightTransform)String");
            a.item("TitleColor", "Brush");
            a.item("FilterPlaceholderText", "String");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("BackgroundColor", "Brush");
        }
        static d(a) {
            ColumnChooserDescriptionMetadata.b(a);
            a.ae("ColumnChooser", () => new ColumnChooserDescription());
            a.ad("ColumnChooser", ColumnChooserDescriptionMetadata.a);
        }
    }
    ColumnChooserDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnChooserDescriptionMetadata, 'ColumnChooserDescriptionMetadata');
    ColumnChooserDescriptionMetadata.a = null;
    return ColumnChooserDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnChooserDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnChooserDescriptionModule extends Base {
        static register(a) {
            CheckboxListDescriptionModule.register(a);
            ButtonDescriptionModule.register(a);
            ColumnChooserDescriptionMetadata.d(a);
        }
    }
    ColumnChooserDescriptionModule.$t = /*@__PURE__*/ markType(ColumnChooserDescriptionModule, 'ColumnChooserDescriptionModule');
    return ColumnChooserDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnFilterConditionDescription = /*@__PURE__*/ (() => {
    class ColumnFilterConditionDescription extends Description {
        get_type() {
            return "ColumnFilterCondition";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ColumnFilterConditionDescription.$t = /*@__PURE__*/ markType(ColumnFilterConditionDescription, 'ColumnFilterConditionDescription', Description.$);
    return ColumnFilterConditionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnCustomFilterConditionDescription = /*@__PURE__*/ (() => {
    class ColumnCustomFilterConditionDescription extends ColumnFilterConditionDescription {
        get_type() {
            return "ColumnCustomFilterCondition";
        }
        constructor() {
            super();
            this.l = null;
            this.k = null;
            this.i = 0;
        }
        get valueRef() {
            return this.l;
        }
        set valueRef(a) {
            this.l = a;
            this.g("ValueRef");
        }
        get id() {
            return this.k;
        }
        set id(a) {
            this.k = a;
            this.g("Id");
        }
        get index() {
            return this.i;
        }
        set index(a) {
            this.i = a;
            this.g("Index");
        }
    }
    ColumnCustomFilterConditionDescription.$t = /*@__PURE__*/ markType(ColumnCustomFilterConditionDescription, 'ColumnCustomFilterConditionDescription', ColumnFilterConditionDescription.$);
    return ColumnCustomFilterConditionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnCustomFilterConditionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnCustomFilterConditionDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnCustomFilterConditionDescriptionMetadata.a == null) {
                ColumnCustomFilterConditionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnCustomFilterConditionDescriptionMetadata.c(ColumnCustomFilterConditionDescriptionMetadata.a);
            }
            if (a.k(ColumnCustomFilterConditionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnCustomFilterConditionDescriptionMetadata.a);
        }
        static c(a) {
            ColumnFilterConditionDescriptionMetadata.c(a);
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
            a.item("Id", "(w:ID,wf:ID)String");
            a.item("Index", "Number:int");
        }
        static d(a) {
            ColumnCustomFilterConditionDescriptionMetadata.b(a);
            a.ae("ColumnCustomFilterCondition", () => new ColumnCustomFilterConditionDescription());
            a.ad("ColumnCustomFilterCondition", ColumnCustomFilterConditionDescriptionMetadata.a);
        }
    }
    ColumnCustomFilterConditionDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnCustomFilterConditionDescriptionMetadata, 'ColumnCustomFilterConditionDescriptionMetadata');
    ColumnCustomFilterConditionDescriptionMetadata.a = null;
    return ColumnCustomFilterConditionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSummaryResultDescription = /*@__PURE__*/ (() => {
    class WebSummaryResultDescription extends Description {
        get_type() {
            return "WebSummaryResult";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.o = null;
            this.k = null;
            this.i = false;
        }
        get key() {
            return this.n;
        }
        set key(a) {
            this.n = a;
            this.g("Key");
        }
        get label() {
            return this.o;
        }
        set label(a) {
            this.o = a;
            this.g("Label");
        }
        get result() {
            return this.k;
        }
        set result(a) {
            this.k = a;
            this.g("Result");
        }
        get defaultFormatting() {
            return this.i;
        }
        set defaultFormatting(a) {
            this.i = a;
            this.g("DefaultFormatting");
        }
    }
    WebSummaryResultDescription.$t = /*@__PURE__*/ markType(WebSummaryResultDescription, 'WebSummaryResultDescription', Description.$);
    WebSummaryResultDescription.__marshalByValue = true;
    WebSummaryResultDescription.__marshalByValueAlias = "SummaryResult";
    return WebSummaryResultDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSummaryResultDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSummaryResultDescriptionMetadata extends Base {
        static b(a) {
            if (WebSummaryResultDescriptionMetadata.a == null) {
                WebSummaryResultDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSummaryResultDescriptionMetadata.c(WebSummaryResultDescriptionMetadata.a);
            }
            if (a.k(WebSummaryResultDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSummaryResultDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:SummaryResult");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("Key", "String");
            a.item("Label", "String");
            a.item("Result", "(wc:SummaryResult)Unknown");
            a.item("DefaultFormatting", "Boolean");
        }
        static d(a) {
            WebSummaryResultDescriptionMetadata.b(a);
            a.ae("WebSummaryResult", () => new WebSummaryResultDescription());
            a.ad("WebSummaryResult", WebSummaryResultDescriptionMetadata.a);
        }
    }
    WebSummaryResultDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSummaryResultDescriptionMetadata, 'WebSummaryResultDescriptionMetadata');
    WebSummaryResultDescriptionMetadata.a = null;
    return WebSummaryResultDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSummaryTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebSummaryTemplateContextDescription extends Description {
        get_type() {
            return "WebSummaryTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get implicit() {
            return this.h;
        }
        set implicit(a) {
            this.h = a;
            this.g("Implicit");
        }
    }
    WebSummaryTemplateContextDescription.$t = /*@__PURE__*/ markType(WebSummaryTemplateContextDescription, 'WebSummaryTemplateContextDescription', Description.$);
    WebSummaryTemplateContextDescription.__marshalByValue = true;
    WebSummaryTemplateContextDescription.__marshalByValueAlias = "SummaryTemplateContext";
    return WebSummaryTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSummaryTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSummaryTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebSummaryTemplateContextDescriptionMetadata.a == null) {
                WebSummaryTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSummaryTemplateContextDescriptionMetadata.c(WebSummaryTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebSummaryTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSummaryTemplateContextDescriptionMetadata.a);
            WebSummaryResultDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:SummaryTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "Array:WebSummaryResultDescription:SummaryResult");
        }
        static d(a) {
            WebSummaryTemplateContextDescriptionMetadata.b(a);
            a.ae("WebSummaryTemplateContext", () => new WebSummaryTemplateContextDescription());
            a.ad("WebSummaryTemplateContext", WebSummaryTemplateContextDescriptionMetadata.a);
        }
    }
    WebSummaryTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSummaryTemplateContextDescriptionMetadata, 'WebSummaryTemplateContextDescriptionMetadata');
    WebSummaryTemplateContextDescriptionMetadata.a = null;
    return WebSummaryTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebBaseEventArgsDetailDescription extends Description {
        get_type() {
            return "WebBaseEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
        }
        get owner() {
            return this.i;
        }
        set owner(a) {
            this.i = a;
            this.g("Owner");
        }
    }
    WebBaseEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebBaseEventArgsDetailDescription, 'WebBaseEventArgsDetailDescription', Description.$);
    WebBaseEventArgsDetailDescription.__marshalByValue = true;
    WebBaseEventArgsDetailDescription.__marshalByValueAlias = "BaseEventArgsDetail";
    return WebBaseEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebBaseEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebBaseEventArgsDetailDescriptionMetadata.a == null) {
                WebBaseEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebBaseEventArgsDetailDescriptionMetadata.c(WebBaseEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebBaseEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebBaseEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:BaseEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Owner", "Unknown");
        }
        static d(a) {
            WebBaseEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebBaseEventArgsDetail", () => new WebBaseEventArgsDetailDescription());
            a.ad("WebBaseEventArgsDetail", WebBaseEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebBaseEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebBaseEventArgsDetailDescriptionMetadata, 'WebBaseEventArgsDetailDescriptionMetadata');
    WebBaseEventArgsDetailDescriptionMetadata.a = null;
    return WebBaseEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseEventArgsDescription = /*@__PURE__*/ (() => {
    class WebBaseEventArgsDescription extends Description {
        get_type() {
            return "WebBaseEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebBaseEventArgsDescription.$t = /*@__PURE__*/ markType(WebBaseEventArgsDescription, 'WebBaseEventArgsDescription', Description.$);
    WebBaseEventArgsDescription.__marshalByValue = true;
    WebBaseEventArgsDescription.__marshalByValueAlias = "BaseEventArgs";
    return WebBaseEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebBaseEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebBaseEventArgsDescriptionMetadata.a == null) {
                WebBaseEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebBaseEventArgsDescriptionMetadata.c(WebBaseEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebBaseEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebBaseEventArgsDescriptionMetadata.a);
            WebBaseEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:BaseEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebBaseEventArgsDetail");
        }
        static d(a) {
            WebBaseEventArgsDescriptionMetadata.b(a);
            a.ae("WebBaseEventArgs", () => new WebBaseEventArgsDescription());
            a.ad("WebBaseEventArgs", WebBaseEventArgsDescriptionMetadata.a);
        }
    }
    WebBaseEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebBaseEventArgsDescriptionMetadata, 'WebBaseEventArgsDescriptionMetadata');
    WebBaseEventArgsDescriptionMetadata.a = null;
    return WebBaseEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowExportingEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebRowExportingEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebRowExportingEventArgsDetail";
        }
        constructor() {
            super();
            this.r = null;
            this.p = 0;
            this.n = false;
        }
        get rowData() {
            return this.r;
        }
        set rowData(a) {
            this.r = a;
            this.g("RowData");
        }
        get rowIndex() {
            return this.p;
        }
        set rowIndex(a) {
            this.p = a;
            this.g("RowIndex");
        }
        get cancel() {
            return this.n;
        }
        set cancel(a) {
            this.n = a;
            this.g("Cancel");
        }
    }
    WebRowExportingEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebRowExportingEventArgsDetailDescription, 'WebRowExportingEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebRowExportingEventArgsDetailDescription.__marshalByValue1 = true;
    WebRowExportingEventArgsDetailDescription.__marshalByValueAlias1 = "RowExportingEventArgsDetail";
    return WebRowExportingEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowExportingEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowExportingEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowExportingEventArgsDetailDescriptionMetadata.a == null) {
                WebRowExportingEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowExportingEventArgsDetailDescriptionMetadata.c(WebRowExportingEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebRowExportingEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowExportingEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:RowExportingEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("RowData", "Unknown");
            a.item("RowIndex", "Number:double");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebRowExportingEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebRowExportingEventArgsDetail", () => new WebRowExportingEventArgsDetailDescription());
            a.ad("WebRowExportingEventArgsDetail", WebRowExportingEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebRowExportingEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowExportingEventArgsDetailDescriptionMetadata, 'WebRowExportingEventArgsDetailDescriptionMetadata');
    WebRowExportingEventArgsDetailDescriptionMetadata.a = null;
    return WebRowExportingEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowExportingEventArgsDescription = /*@__PURE__*/ (() => {
    class WebRowExportingEventArgsDescription extends Description {
        get_type() {
            return "WebRowExportingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebRowExportingEventArgsDescription.$t = /*@__PURE__*/ markType(WebRowExportingEventArgsDescription, 'WebRowExportingEventArgsDescription', Description.$);
    WebRowExportingEventArgsDescription.__marshalByValue = true;
    WebRowExportingEventArgsDescription.__marshalByValueAlias = "RowExportingEventArgs";
    return WebRowExportingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowExportingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowExportingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowExportingEventArgsDescriptionMetadata.a == null) {
                WebRowExportingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowExportingEventArgsDescriptionMetadata.c(WebRowExportingEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebRowExportingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowExportingEventArgsDescriptionMetadata.a);
            WebRowExportingEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowExportingEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebRowExportingEventArgsDetail");
        }
        static d(a) {
            WebRowExportingEventArgsDescriptionMetadata.b(a);
            a.ae("WebRowExportingEventArgs", () => new WebRowExportingEventArgsDescription());
            a.ad("WebRowExportingEventArgs", WebRowExportingEventArgsDescriptionMetadata.a);
        }
    }
    WebRowExportingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowExportingEventArgsDescriptionMetadata, 'WebRowExportingEventArgsDescriptionMetadata');
    WebRowExportingEventArgsDescriptionMetadata.a = null;
    return WebRowExportingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringOperationDescription = /*@__PURE__*/ (() => {
    class WebFilteringOperationDescription extends Description {
        get_type() {
            return "WebFilteringOperation";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.p = null;
            this.j = false;
            this.n = null;
            this.i = false;
            this.o = null;
        }
        get name() {
            return this.p;
        }
        set name(a) {
            this.p = a;
            this.g("Name");
        }
        get isUnary() {
            return this.j;
        }
        set isUnary(a) {
            this.j = a;
            this.g("IsUnary");
        }
        get iconName() {
            return this.n;
        }
        set iconName(a) {
            this.n = a;
            this.g("IconName");
        }
        get hidden() {
            return this.i;
        }
        set hidden(a) {
            this.i = a;
            this.g("Hidden");
        }
        get logicRef() {
            return this.o;
        }
        set logicRef(a) {
            this.o = a;
            this.g("LogicRef");
        }
    }
    WebFilteringOperationDescription.$t = /*@__PURE__*/ markType(WebFilteringOperationDescription, 'WebFilteringOperationDescription', Description.$);
    WebFilteringOperationDescription.__marshalByValue = true;
    WebFilteringOperationDescription.__marshalByValueAlias = "FilteringOperation";
    return WebFilteringOperationDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringOperationDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFilteringOperationDescriptionMetadata extends Base {
        static b(a) {
            if (WebFilteringOperationDescriptionMetadata.a == null) {
                WebFilteringOperationDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFilteringOperationDescriptionMetadata.c(WebFilteringOperationDescriptionMetadata.a);
            }
            if (a.k(WebFilteringOperationDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFilteringOperationDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FilteringOperation");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("Name", "String");
            a.item("IsUnary", "Boolean");
            a.item("IconName", "String");
            a.item("Hidden", "Boolean");
            a.item("LogicRef", "(w:Logic,wf:Logic)MethodRef");
        }
        static d(a) {
            WebFilteringOperationDescriptionMetadata.b(a);
            a.ae("WebFilteringOperation", () => new WebFilteringOperationDescription());
            a.ad("WebFilteringOperation", WebFilteringOperationDescriptionMetadata.a);
        }
    }
    WebFilteringOperationDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFilteringOperationDescriptionMetadata, 'WebFilteringOperationDescriptionMetadata');
    WebFilteringOperationDescriptionMetadata.a = null;
    return WebFilteringOperationDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringOperandDescription = /*@__PURE__*/ (() => {
    class WebFilteringOperandDescription extends Description {
        get_type() {
            return "WebFilteringOperand";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get operations() {
            return this.h;
        }
        set operations(a) {
            this.h = a;
            this.g("Operations");
        }
    }
    WebFilteringOperandDescription.$t = /*@__PURE__*/ markType(WebFilteringOperandDescription, 'WebFilteringOperandDescription', Description.$);
    return WebFilteringOperandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringOperandDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFilteringOperandDescriptionMetadata extends Base {
        static b(a) {
            if (WebFilteringOperandDescriptionMetadata.a == null) {
                WebFilteringOperandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFilteringOperandDescriptionMetadata.c(WebFilteringOperandDescriptionMetadata.a);
            }
            if (a.k(WebFilteringOperandDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFilteringOperandDescriptionMetadata.a);
            WebFilteringOperationDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FilteringOperand");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("Operations", "Array:WebFilteringOperationDescription:FilteringOperation");
        }
        static d(a) {
            WebFilteringOperandDescriptionMetadata.b(a);
            a.ae("WebFilteringOperand", () => new WebFilteringOperandDescription());
            a.ad("WebFilteringOperand", WebFilteringOperandDescriptionMetadata.a);
        }
    }
    WebFilteringOperandDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFilteringOperandDescriptionMetadata, 'WebFilteringOperandDescriptionMetadata');
    WebFilteringOperandDescriptionMetadata.a = null;
    return WebFilteringOperandDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSortingStrategyDescription = /*@__PURE__*/ (() => {
    class WebSortingStrategyDescription extends Description {
        get_type() {
            return "WebSortingStrategy";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebSortingStrategyDescription.$t = /*@__PURE__*/ markType(WebSortingStrategyDescription, 'WebSortingStrategyDescription', Description.$);
    return WebSortingStrategyDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSortingStrategyDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSortingStrategyDescriptionMetadata extends Base {
        static b(a) {
            if (WebSortingStrategyDescriptionMetadata.a == null) {
                WebSortingStrategyDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSortingStrategyDescriptionMetadata.c(WebSortingStrategyDescriptionMetadata.a);
            }
            if (a.k(WebSortingStrategyDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSortingStrategyDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:SortingStrategy");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebSortingStrategyDescriptionMetadata.b(a);
            a.ae("WebSortingStrategy", () => new WebSortingStrategyDescription());
            a.ad("WebSortingStrategy", WebSortingStrategyDescriptionMetadata.a);
        }
    }
    WebSortingStrategyDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSortingStrategyDescriptionMetadata, 'WebSortingStrategyDescriptionMetadata');
    WebSortingStrategyDescriptionMetadata.a = null;
    return WebSortingStrategyDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFieldPipeArgsDescription = /*@__PURE__*/ (() => {
    class WebFieldPipeArgsDescription extends Description {
        get_type() {
            return "WebFieldPipeArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.m = null;
            this.n = null;
            this.k = null;
            this.j = null;
            this.l = null;
            this.h = 0;
        }
        get format() {
            return this.m;
        }
        set format(a) {
            this.m = a;
            this.g("Format");
        }
        get timezone() {
            return this.n;
        }
        set timezone(a) {
            this.n = a;
            this.g("Timezone");
        }
        get digitsInfo() {
            return this.k;
        }
        set digitsInfo(a) {
            this.k = a;
            this.g("DigitsInfo");
        }
        get currencyCode() {
            return this.j;
        }
        set currencyCode(a) {
            this.j = a;
            this.g("CurrencyCode");
        }
        get display() {
            return this.l;
        }
        set display(a) {
            this.l = a;
            this.g("Display");
        }
        get weekStart() {
            return this.h;
        }
        set weekStart(a) {
            this.h = a;
            this.g("WeekStart");
        }
    }
    WebFieldPipeArgsDescription.$t = /*@__PURE__*/ markType(WebFieldPipeArgsDescription, 'WebFieldPipeArgsDescription', Description.$);
    return WebFieldPipeArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFieldPipeArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFieldPipeArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebFieldPipeArgsDescriptionMetadata.a == null) {
                WebFieldPipeArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFieldPipeArgsDescriptionMetadata.c(WebFieldPipeArgsDescriptionMetadata.a);
            }
            if (a.k(WebFieldPipeArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFieldPipeArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FieldPipeArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Format", "String");
            a.item("Timezone", "String");
            a.item("DigitsInfo", "String");
            a.item("CurrencyCode", "String");
            a.item("Display", "String");
            a.item("WeekStart", "Number:double");
        }
        static d(a) {
            WebFieldPipeArgsDescriptionMetadata.b(a);
            a.ae("WebFieldPipeArgs", () => new WebFieldPipeArgsDescription());
            a.ad("WebFieldPipeArgs", WebFieldPipeArgsDescriptionMetadata.a);
        }
    }
    WebFieldPipeArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFieldPipeArgsDescriptionMetadata, 'WebFieldPipeArgsDescriptionMetadata');
    WebFieldPipeArgsDescriptionMetadata.a = null;
    return WebFieldPipeArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnPipeArgsDescription = /*@__PURE__*/ (() => {
    class WebColumnPipeArgsDescription extends WebFieldPipeArgsDescription {
        get_type() {
            return "WebColumnPipeArgs";
        }
        constructor() {
            super();
        }
    }
    WebColumnPipeArgsDescription.$t = /*@__PURE__*/ markType(WebColumnPipeArgsDescription, 'WebColumnPipeArgsDescription', WebFieldPipeArgsDescription.$);
    return WebColumnPipeArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnPipeArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnPipeArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnPipeArgsDescriptionMetadata.a == null) {
                WebColumnPipeArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnPipeArgsDescriptionMetadata.c(WebColumnPipeArgsDescriptionMetadata.a);
            }
            if (a.k(WebColumnPipeArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnPipeArgsDescriptionMetadata.a);
        }
        static c(a) {
            WebFieldPipeArgsDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ColumnPipeArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebColumnPipeArgsDescriptionMetadata.b(a);
            a.ae("WebColumnPipeArgs", () => new WebColumnPipeArgsDescription());
            a.ad("WebColumnPipeArgs", WebColumnPipeArgsDescriptionMetadata.a);
        }
    }
    WebColumnPipeArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnPipeArgsDescriptionMetadata, 'WebColumnPipeArgsDescriptionMetadata');
    WebColumnPipeArgsDescriptionMetadata.a = null;
    return WebColumnPipeArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnDescription = /*@__PURE__*/ (() => {
    class WebColumnDescription extends Description {
        get_type() {
            return "WebColumn";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.bi = null;
            this.bl = null;
            this.bw = null;
            this.ac = false;
            this.aa = false;
            this.u = false;
            this.r = false;
            this.s = false;
            this.y = false;
            this.o = false;
            this.v = false;
            this.w = false;
            this.ab = false;
            this.p = false;
            this.q = false;
            this.bx = null;
            this.bq = null;
            this.bm = null;
            this.a6 = null;
            this.bn = null;
            this.a5 = null;
            this.be = null;
            this.bf = null;
            this.bk = null;
            this.bu = null;
            this.t = false;
            this.ad = false;
            this.z = false;
            this.bg = null;
            this.ay = 0;
            this.aw = 0;
            this.az = 0;
            this.ax = 0;
            this.a4 = null;
            this.br = null;
            this.x = false;
            this.bt = null;
            this.j = null;
            this.l = null;
            this.bv = null;
            this.bd = null;
            this.bo = null;
            this.bp = null;
            this.bh = null;
            this.bj = null;
            this.ae = false;
            this.h = null;
            this.a7 = null;
            this.bs = null;
        }
        get field() {
            return this.bi;
        }
        set field(a) {
            this.bi = a;
            this.g("Field");
        }
        get header() {
            return this.bl;
        }
        set header(a) {
            this.bl = a;
            this.g("Header");
        }
        get title() {
            return this.bw;
        }
        set title(a) {
            this.bw = a;
            this.g("Title");
        }
        get sortable() {
            return this.ac;
        }
        set sortable(a) {
            this.ac = a;
            this.g("Sortable");
        }
        get selectable() {
            return this.aa;
        }
        set selectable(a) {
            this.aa = a;
            this.g("Selectable");
        }
        get groupable() {
            return this.u;
        }
        set groupable(a) {
            this.u = a;
            this.g("Groupable");
        }
        get editable() {
            return this.r;
        }
        set editable(a) {
            this.r = a;
            this.g("Editable");
        }
        get filterable() {
            return this.s;
        }
        set filterable(a) {
            this.s = a;
            this.g("Filterable");
        }
        get resizable() {
            return this.y;
        }
        set resizable(a) {
            this.y = a;
            this.g("Resizable");
        }
        get autosizeHeader() {
            return this.o;
        }
        set autosizeHeader(a) {
            this.o = a;
            this.g("AutosizeHeader");
        }
        get hasSummary() {
            return this.v;
        }
        set hasSummary(a) {
            this.v = a;
            this.g("HasSummary");
        }
        get hidden() {
            return this.w;
        }
        set hidden(a) {
            this.w = a;
            this.g("Hidden");
        }
        get selected() {
            return this.ab;
        }
        set selected(a) {
            this.ab = a;
            this.g("Selected");
        }
        get disableHiding() {
            return this.p;
        }
        set disableHiding(a) {
            this.p = a;
            this.g("DisableHiding");
        }
        get disablePinning() {
            return this.q;
        }
        set disablePinning(a) {
            this.q = a;
            this.g("DisablePinning");
        }
        get width() {
            return this.bx;
        }
        set width(a) {
            this.bx = a;
            this.g("Width");
        }
        get maxWidth() {
            return this.bq;
        }
        set maxWidth(a) {
            this.bq = a;
            this.g("MaxWidth");
        }
        get headerClasses() {
            return this.bm;
        }
        set headerClasses(a) {
            this.bm = a;
            this.g("HeaderClasses");
        }
        get headerStyles() {
            return this.a6;
        }
        set headerStyles(a) {
            this.a6 = a;
            this.g("HeaderStyles");
        }
        get headerGroupClasses() {
            return this.bn;
        }
        set headerGroupClasses(a) {
            this.bn = a;
            this.g("HeaderGroupClasses");
        }
        get headerGroupStyles() {
            return this.a5;
        }
        set headerGroupStyles(a) {
            this.a5 = a;
            this.g("HeaderGroupStyles");
        }
        get cellClassesRef() {
            return this.be;
        }
        set cellClassesRef(a) {
            this.be = a;
            this.g("CellClassesRef");
        }
        get cellStylesRef() {
            return this.bf;
        }
        set cellStylesRef(a) {
            this.bf = a;
            this.g("CellStylesRef");
        }
        get formatterRef() {
            return this.bk;
        }
        set formatterRef(a) {
            this.bk = a;
            this.g("FormatterRef");
        }
        get summaryFormatterRef() {
            return this.bu;
        }
        set summaryFormatterRef(a) {
            this.bu = a;
            this.g("SummaryFormatterRef");
        }
        get filteringIgnoreCase() {
            return this.t;
        }
        set filteringIgnoreCase(a) {
            this.t = a;
            this.g("FilteringIgnoreCase");
        }
        get sortingIgnoreCase() {
            return this.ad;
        }
        set sortingIgnoreCase(a) {
            this.ad = a;
            this.g("SortingIgnoreCase");
        }
        get searchable() {
            return this.z;
        }
        set searchable(a) {
            this.z = a;
            this.g("Searchable");
        }
        get dataType() {
            return this.bg;
        }
        set dataType(a) {
            this.bg = a;
            this.g("DataType");
        }
        get rowEnd() {
            return this.ay;
        }
        set rowEnd(a) {
            this.ay = a;
            this.g("RowEnd");
        }
        get colEnd() {
            return this.aw;
        }
        set colEnd(a) {
            this.aw = a;
            this.g("ColEnd");
        }
        get rowStart() {
            return this.az;
        }
        set rowStart(a) {
            this.az = a;
            this.g("RowStart");
        }
        get colStart() {
            return this.ax;
        }
        set colStart(a) {
            this.ax = a;
            this.g("ColStart");
        }
        get additionalTemplateContext() {
            return this.a4;
        }
        set additionalTemplateContext(a) {
            this.a4 = a;
            this.g("AdditionalTemplateContext");
        }
        get minWidth() {
            return this.br;
        }
        set minWidth(a) {
            this.br = a;
            this.g("MinWidth");
        }
        get pinned() {
            return this.x;
        }
        set pinned(a) {
            this.x = a;
            this.g("Pinned");
        }
        get summariesRef() {
            return this.bt;
        }
        set summariesRef(a) {
            this.bt = a;
            this.g("SummariesRef");
        }
        get filters() {
            return this.j;
        }
        set filters(a) {
            this.j = a;
            this.g("Filters");
        }
        get sortStrategy() {
            return this.l;
        }
        set sortStrategy(a) {
            this.l = a;
            this.g("SortStrategy");
        }
        get summaryTemplateRef() {
            return this.bv;
        }
        set summaryTemplateRef(a) {
            this.bv = a;
            this.g("SummaryTemplateRef");
        }
        get bodyTemplateRef() {
            return this.bd;
        }
        set bodyTemplateRef(a) {
            this.bd = a;
            this.g("BodyTemplateRef");
        }
        get headerTemplateRef() {
            return this.bo;
        }
        set headerTemplateRef(a) {
            this.bo = a;
            this.g("HeaderTemplateRef");
        }
        get inlineEditorTemplateRef() {
            return this.bp;
        }
        set inlineEditorTemplateRef(a) {
            this.bp = a;
            this.g("InlineEditorTemplateRef");
        }
        get errorTemplateRef() {
            return this.bh;
        }
        set errorTemplateRef(a) {
            this.bh = a;
            this.g("ErrorTemplateRef");
        }
        get filterCellTemplateRef() {
            return this.bj;
        }
        set filterCellTemplateRef(a) {
            this.bj = a;
            this.g("FilterCellTemplateRef");
        }
        get visibleWhenCollapsed() {
            return this.ae;
        }
        set visibleWhenCollapsed(a) {
            this.ae = a;
            this.g("VisibleWhenCollapsed");
        }
        get pipeArgs() {
            return this.h;
        }
        set pipeArgs(a) {
            this.h = a;
            this.g("PipeArgs");
        }
        get parentColumn() {
            return this.a7;
        }
        set parentColumn(a) {
            this.a7 = a;
            this.g("ParentColumn");
        }
        get name() {
            return this.bs;
        }
        set name(a) {
            this.bs = a;
            this.g("Name");
        }
    }
    WebColumnDescription.$t = /*@__PURE__*/ markType(WebColumnDescription, 'WebColumnDescription', Description.$);
    WebColumnDescription.__canMarshalByValue = true;
    WebColumnDescription.__marshalByValueAlias = "Column";
    return WebColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnDescriptionMetadata.a == null) {
                WebColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnDescriptionMetadata.c(WebColumnDescriptionMetadata.a);
            }
            if (a.k(WebColumnDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnDescriptionMetadata.a);
            WebFilteringOperandDescriptionMetadata.d(a);
            WebSortingStrategyDescriptionMetadata.d(a);
            WebColumnPipeArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Column");
            a.item("__tagNameWC", "String:igc-column");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__manageCollectionInMarkup", "Boolean");
            a.item("Field", "String");
            a.item("Header", "String");
            a.item("Title", "String");
            a.item("Sortable", "Boolean");
            a.item("Selectable", "Boolean");
            a.item("Groupable", "Boolean");
            a.item("Editable", "Boolean");
            a.item("Filterable", "Boolean");
            a.item("Resizable", "Boolean");
            a.item("AutosizeHeader", "Boolean");
            a.item("HasSummary", "Boolean");
            a.item("Hidden", "Boolean");
            a.item("Selected", "Boolean");
            a.item("DisableHiding", "Boolean");
            a.item("DisablePinning", "Boolean");
            a.item("Width", "String");
            a.item("MaxWidth", "String");
            a.item("HeaderClasses", "String");
            a.item("HeaderStyles", "Unknown");
            a.item("HeaderGroupClasses", "String");
            a.item("HeaderGroupStyles", "Unknown");
            a.item("CellClassesRef", "(w:CellClasses,wf:CellClasses)DataRef::object");
            a.item("CellStylesRef", "(w:CellStyles,wf:CellStyles)DataRef::object");
            a.item("FormatterRef", "(w:Formatter,wf:Formatter)MethodRef");
            a.item("SummaryFormatterRef", "(w:SummaryFormatter,wf:SummaryFormatter)MethodRef");
            a.item("FilteringIgnoreCase", "Boolean");
            a.item("SortingIgnoreCase", "Boolean");
            a.item("Searchable", "Boolean");
            a.item("DataType", "ExportedType:string:GridColumnDataType");
            a.item("DataType@stringUnion", "WebComponents;React");
            a.item("DataType@names", "String;Number;Boolean;Date;DateTime;Time;Currency;Percent;Image");
            a.item("RowEnd", "Number:double");
            a.item("ColEnd", "Number:double");
            a.item("RowStart", "Number:double");
            a.item("ColStart", "Number:double");
            a.item("AdditionalTemplateContext", "Unknown");
            a.item("MinWidth", "String");
            a.item("Pinned", "Boolean");
            a.item("SummariesRef", "(w:Summaries,wf:Summaries)DataRef::object");
            a.item("Filters", "ExportedType:WebFilteringOperand");
            a.item("SortStrategy", "ExportedType:WebSortingStrategy");
            a.item("SummaryTemplateRef", "(w:SummaryTemplate,wf:SummaryTemplate)TemplateRef::object");
            a.item("BodyTemplateRef", "(w:BodyTemplate,wf:BodyTemplate)TemplateRef::object");
            a.item("HeaderTemplateRef", "(w:HeaderTemplate,wf:HeaderTemplate)TemplateRef::object");
            a.item("InlineEditorTemplateRef", "(w:InlineEditorTemplate,wf:InlineEditorTemplate)TemplateRef::object");
            a.item("ErrorTemplateRef", "(w:ErrorTemplate,wf:ErrorTemplate)TemplateRef::object");
            a.item("FilterCellTemplateRef", "(w:FilterCellTemplate,wf:FilterCellTemplate)TemplateRef::object");
            a.item("VisibleWhenCollapsed", "Boolean");
            a.item("PipeArgs", "ExportedType:WebColumnPipeArgs");
            a.item("PipeArgs@mustSetInCode", "WebComponents;Blazor;React");
            a.item("ParentColumn", "(wc:Parent)Unknown");
            a.item("Name", "String");
            WebColumnDescriptionMetadata.e(a);
        }
        static d(a) {
            WebColumnDescriptionMetadata.b(a);
            a.ae("WebColumn", () => new WebColumnDescription());
            a.ad("WebColumn", WebColumnDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__qualifiedNameNG", "String:Column");
            a.item("__tagNameWCSubstitutable", "String:igc-column-group,igc-column-layout");
        }
    }
    WebColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnDescriptionMetadata, 'WebColumnDescriptionMetadata');
    WebColumnDescriptionMetadata.a = null;
    return WebColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridCellIdentifierDescription = /*@__PURE__*/ (() => {
    class WebGridCellIdentifierDescription extends Description {
        get_type() {
            return "WebGridCellIdentifier";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.i = 0;
            this.j = 0;
        }
        get rowID() {
            return this.n;
        }
        set rowID(a) {
            this.n = a;
            this.g("RowID");
        }
        get columnID() {
            return this.i;
        }
        set columnID(a) {
            this.i = a;
            this.g("ColumnID");
        }
        get rowIndex() {
            return this.j;
        }
        set rowIndex(a) {
            this.j = a;
            this.g("RowIndex");
        }
    }
    WebGridCellIdentifierDescription.$t = /*@__PURE__*/ markType(WebGridCellIdentifierDescription, 'WebGridCellIdentifierDescription', Description.$);
    WebGridCellIdentifierDescription.__marshalByValue = true;
    WebGridCellIdentifierDescription.__marshalByValueAlias = "GridCellIdentifier";
    return WebGridCellIdentifierDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridCellIdentifierDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridCellIdentifierDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridCellIdentifierDescriptionMetadata.a == null) {
                WebGridCellIdentifierDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridCellIdentifierDescriptionMetadata.c(WebGridCellIdentifierDescriptionMetadata.a);
            }
            if (a.k(WebGridCellIdentifierDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridCellIdentifierDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridCellIdentifier");
            a.item("__marshalByValue", "Boolean");
            a.item("RowID", "String");
            a.item("ColumnID", "Number:int");
            a.item("RowIndex", "Number:int");
        }
        static d(a) {
            WebGridCellIdentifierDescriptionMetadata.b(a);
            a.ae("WebGridCellIdentifier", () => new WebGridCellIdentifierDescription());
            a.ad("WebGridCellIdentifier", WebGridCellIdentifierDescriptionMetadata.a);
        }
    }
    WebGridCellIdentifierDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridCellIdentifierDescriptionMetadata, 'WebGridCellIdentifierDescriptionMetadata');
    WebGridCellIdentifierDescriptionMetadata.a = null;
    return WebGridCellIdentifierDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebValidationErrorsDescription = /*@__PURE__*/ (() => {
    class WebValidationErrorsDescription extends Description {
        get_type() {
            return "WebValidationErrors";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebValidationErrorsDescription.$t = /*@__PURE__*/ markType(WebValidationErrorsDescription, 'WebValidationErrorsDescription', Description.$);
    return WebValidationErrorsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebValidationErrorsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebValidationErrorsDescriptionMetadata extends Base {
        static b(a) {
            if (WebValidationErrorsDescriptionMetadata.a == null) {
                WebValidationErrorsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebValidationErrorsDescriptionMetadata.c(WebValidationErrorsDescriptionMetadata.a);
            }
            if (a.k(WebValidationErrorsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebValidationErrorsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ValidationErrors");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebValidationErrorsDescriptionMetadata.b(a);
            a.ae("WebValidationErrors", () => new WebValidationErrorsDescription());
            a.ad("WebValidationErrors", WebValidationErrorsDescriptionMetadata.a);
        }
    }
    WebValidationErrorsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebValidationErrorsDescriptionMetadata, 'WebValidationErrorsDescriptionMetadata');
    WebValidationErrorsDescriptionMetadata.a = null;
    return WebValidationErrorsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridValidationStateDescription = /*@__PURE__*/ (() => {
    class WebGridValidationStateDescription extends Description {
        get_type() {
            return "WebGridValidationState";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = null;
        }
        get status() {
            return this.j;
        }
        set status(a) {
            this.j = a;
            this.g("Status");
        }
        get errors() {
            return this.h;
        }
        set errors(a) {
            this.h = a;
            this.g("Errors");
        }
    }
    WebGridValidationStateDescription.$t = /*@__PURE__*/ markType(WebGridValidationStateDescription, 'WebGridValidationStateDescription', Description.$);
    return WebGridValidationStateDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridValidationStateDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridValidationStateDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridValidationStateDescriptionMetadata.a == null) {
                WebGridValidationStateDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridValidationStateDescriptionMetadata.c(WebGridValidationStateDescriptionMetadata.a);
            }
            if (a.k(WebGridValidationStateDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridValidationStateDescriptionMetadata.a);
            WebValidationErrorsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridValidationState");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Status", "ExportedType:string:ValidationStatus");
            a.item("Status@stringUnion", "WebComponents;React");
            a.item("Status@names", "VALID;INVALID");
            a.item("Errors", "ExportedType:WebValidationErrors");
        }
        static d(a) {
            WebGridValidationStateDescriptionMetadata.b(a);
            a.ae("WebGridValidationState", () => new WebGridValidationStateDescription());
            a.ad("WebGridValidationState", WebGridValidationStateDescriptionMetadata.a);
        }
    }
    WebGridValidationStateDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridValidationStateDescriptionMetadata, 'WebGridValidationStateDescriptionMetadata');
    WebGridValidationStateDescriptionMetadata.a = null;
    return WebGridValidationStateDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCellTypeDescription = /*@__PURE__*/ (() => {
    class WebCellTypeDescription extends Description {
        get_type() {
            return "WebCellType";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.ah = null;
            this.af = null;
            this.w = false;
            this.s = false;
            this.t = false;
            this.u = false;
            this.h = null;
            this.p = null;
            this.j = null;
            this.l = null;
            this.ae = null;
            this.n = null;
            this.v = false;
            this.ag = null;
            this.an = null;
            this.ac = 0;
        }
        get value() {
            return this.ah;
        }
        set value(a) {
            this.ah = a;
            this.g("Value");
        }
        get editValue() {
            return this.af;
        }
        set editValue(a) {
            this.af = a;
            this.g("EditValue");
        }
        get selected() {
            return this.w;
        }
        set selected(a) {
            this.w = a;
            this.g("Selected");
        }
        get active() {
            return this.s;
        }
        set active(a) {
            this.s = a;
            this.g("Active");
        }
        get editable() {
            return this.t;
        }
        set editable(a) {
            this.t = a;
            this.g("Editable");
        }
        get editMode() {
            return this.u;
        }
        set editMode(a) {
            this.u = a;
            this.g("EditMode");
        }
        get column() {
            return this.h;
        }
        set column(a) {
            this.h = a;
            this.g("Column");
        }
        get row() {
            return this.p;
        }
        set row(a) {
            this.p = a;
            this.g("Row");
        }
        get grid() {
            return this.j;
        }
        set grid(a) {
            this.j = a;
            this.g("Grid");
        }
        get id() {
            return this.l;
        }
        set id(a) {
            this.l = a;
            this.g("Id");
        }
        get cellID() {
            return this.ae;
        }
        set cellID(a) {
            this.ae = a;
            this.g("CellID");
        }
        get validation() {
            return this.n;
        }
        set validation(a) {
            this.n = a;
            this.g("Validation");
        }
        get readonly() {
            return this.v;
        }
        set readonly(a) {
            this.v = a;
            this.g("Readonly");
        }
        get title() {
            return this.ag;
        }
        set title(a) {
            this.ag = a;
            this.g("Title");
        }
        get width() {
            return this.an;
        }
        set width(a) {
            this.an = a;
            this.g("Width");
        }
        get visibleColumnIndex() {
            return this.ac;
        }
        set visibleColumnIndex(a) {
            this.ac = a;
            this.g("VisibleColumnIndex");
        }
    }
    WebCellTypeDescription.$t = /*@__PURE__*/ markType(WebCellTypeDescription, 'WebCellTypeDescription', Description.$);
    WebCellTypeDescription.__marshalByValue = true;
    WebCellTypeDescription.__marshalByValueAlias = "CellType";
    return WebCellTypeDescription;
})();
/**
 * @hidden
 */
let WebRowTypeDescription = /*@__PURE__*/ (() => {
    class WebRowTypeDescription extends Description {
        get_type() {
            return "WebRowType";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.as = 0;
            this.at = 0;
            this.ad = false;
            this.ae = false;
            this.p = null;
            this.ax = null;
            this.n = null;
            this.aw = null;
            this.h = null;
            this.y = false;
            this.af = false;
            this.ag = false;
            this.z = false;
            this.x = false;
            this.ac = false;
            this.i = null;
            this.r = null;
            this.ab = false;
            this.t = null;
            this.w = false;
            this.aa = false;
            this.l = null;
        }
        get index() {
            return this.as;
        }
        set index(a) {
            this.as = a;
            this.g("Index");
        }
        get viewIndex() {
            return this.at;
        }
        set viewIndex(a) {
            this.at = a;
            this.g("ViewIndex");
        }
        get isGroupByRow() {
            return this.ad;
        }
        set isGroupByRow(a) {
            this.ad = a;
            this.g("IsGroupByRow");
        }
        get isSummaryRow() {
            return this.ae;
        }
        set isSummaryRow(a) {
            this.ae = a;
            this.g("IsSummaryRow");
        }
        get groupRow() {
            return this.p;
        }
        set groupRow(a) {
            this.p = a;
            this.g("GroupRow");
        }
        get key() {
            return this.ax;
        }
        set key(a) {
            this.ax = a;
            this.g("Key");
        }
        get validation() {
            return this.n;
        }
        set validation(a) {
            this.n = a;
            this.g("Validation");
        }
        get data() {
            return this.aw;
        }
        set data(a) {
            this.aw = a;
            this.g("Data");
        }
        get cells() {
            return this.h;
        }
        set cells(a) {
            this.h = a;
            this.g("Cells");
        }
        get disabled() {
            return this.y;
        }
        set disabled(a) {
            this.y = a;
            this.g("Disabled");
        }
        get pinned() {
            return this.af;
        }
        set pinned(a) {
            this.af = a;
            this.g("Pinned");
        }
        get selected() {
            return this.ag;
        }
        set selected(a) {
            this.ag = a;
            this.g("Selected");
        }
        get expanded() {
            return this.z;
        }
        set expanded(a) {
            this.z = a;
            this.g("Expanded");
        }
        get deleted() {
            return this.x;
        }
        set deleted(a) {
            this.x = a;
            this.g("Deleted");
        }
        get inEditMode() {
            return this.ac;
        }
        set inEditMode(a) {
            this.ac = a;
            this.g("InEditMode");
        }
        get children() {
            return this.i;
        }
        set children(a) {
            this.i = a;
            this.g("Children");
        }
        get rowParent() {
            return this.r;
        }
        set rowParent(a) {
            this.r = a;
            this.g("RowParent");
        }
        get hasChildren() {
            return this.ab;
        }
        set hasChildren(a) {
            this.ab = a;
            this.g("HasChildren");
        }
        get treeRow() {
            return this.t;
        }
        set treeRow(a) {
            this.t = a;
            this.g("TreeRow");
        }
        get addRowUI() {
            return this.w;
        }
        set addRowUI(a) {
            this.w = a;
            this.g("AddRowUI");
        }
        get focused() {
            return this.aa;
        }
        set focused(a) {
            this.aa = a;
            this.g("Focused");
        }
        get grid() {
            return this.l;
        }
        set grid(a) {
            this.l = a;
            this.g("Grid");
        }
    }
    WebRowTypeDescription.$t = /*@__PURE__*/ markType(WebRowTypeDescription, 'WebRowTypeDescription', Description.$);
    WebRowTypeDescription.__marshalByValue = true;
    WebRowTypeDescription.__marshalByValueAlias = "RowType";
    return WebRowTypeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnExportingEventArgsDescription = /*@__PURE__*/ (() => {
    class WebColumnExportingEventArgsDescription extends Description {
        get_type() {
            return "WebColumnExportingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebColumnExportingEventArgsDescription.$t = /*@__PURE__*/ markType(WebColumnExportingEventArgsDescription, 'WebColumnExportingEventArgsDescription', Description.$);
    WebColumnExportingEventArgsDescription.__marshalByValue = true;
    WebColumnExportingEventArgsDescription.__marshalByValueAlias = "ColumnExportingEventArgs";
    return WebColumnExportingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnExportingEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebColumnExportingEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebColumnExportingEventArgsDetail";
        }
        constructor() {
            super();
            this.x = null;
            this.w = null;
            this.t = 0;
            this.p = false;
            this.q = false;
            this.m = null;
        }
        get header() {
            return this.x;
        }
        set header(a) {
            this.x = a;
            this.g("Header");
        }
        get field() {
            return this.w;
        }
        set field(a) {
            this.w = a;
            this.g("Field");
        }
        get columnIndex() {
            return this.t;
        }
        set columnIndex(a) {
            this.t = a;
            this.g("ColumnIndex");
        }
        get cancel() {
            return this.p;
        }
        set cancel(a) {
            this.p = a;
            this.g("Cancel");
        }
        get skipFormatter() {
            return this.q;
        }
        set skipFormatter(a) {
            this.q = a;
            this.g("SkipFormatter");
        }
        get grid() {
            return this.m;
        }
        set grid(a) {
            this.m = a;
            this.g("Grid");
        }
    }
    WebColumnExportingEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebColumnExportingEventArgsDetailDescription, 'WebColumnExportingEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebColumnExportingEventArgsDetailDescription.__marshalByValue1 = true;
    WebColumnExportingEventArgsDetailDescription.__marshalByValueAlias1 = "ColumnExportingEventArgsDetail";
    return WebColumnExportingEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDataCloneStrategyDescription = /*@__PURE__*/ (() => {
    class WebDataCloneStrategyDescription extends Description {
        get_type() {
            return "WebDataCloneStrategy";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebDataCloneStrategyDescription.$t = /*@__PURE__*/ markType(WebDataCloneStrategyDescription, 'WebDataCloneStrategyDescription', Description.$);
    return WebDataCloneStrategyDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDataCloneStrategyDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDataCloneStrategyDescriptionMetadata extends Base {
        static b(a) {
            if (WebDataCloneStrategyDescriptionMetadata.a == null) {
                WebDataCloneStrategyDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDataCloneStrategyDescriptionMetadata.c(WebDataCloneStrategyDescriptionMetadata.a);
            }
            if (a.k(WebDataCloneStrategyDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDataCloneStrategyDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:DataCloneStrategy");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebDataCloneStrategyDescriptionMetadata.b(a);
            a.ae("WebDataCloneStrategy", () => new WebDataCloneStrategyDescription());
            a.ad("WebDataCloneStrategy", WebDataCloneStrategyDescriptionMetadata.a);
        }
    }
    WebDataCloneStrategyDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDataCloneStrategyDescriptionMetadata, 'WebDataCloneStrategyDescriptionMetadata');
    WebDataCloneStrategyDescriptionMetadata.a = null;
    return WebDataCloneStrategyDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebClipboardOptionsDescription = /*@__PURE__*/ (() => {
    class WebClipboardOptionsDescription extends Description {
        get_type() {
            return "WebClipboardOptions";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = false;
            this.i = false;
            this.h = false;
            this.n = null;
        }
        get enabled() {
            return this.j;
        }
        set enabled(a) {
            this.j = a;
            this.g("Enabled");
        }
        get copyHeaders() {
            return this.i;
        }
        set copyHeaders(a) {
            this.i = a;
            this.g("CopyHeaders");
        }
        get copyFormatters() {
            return this.h;
        }
        set copyFormatters(a) {
            this.h = a;
            this.g("CopyFormatters");
        }
        get separator() {
            return this.n;
        }
        set separator(a) {
            this.n = a;
            this.g("Separator");
        }
    }
    WebClipboardOptionsDescription.$t = /*@__PURE__*/ markType(WebClipboardOptionsDescription, 'WebClipboardOptionsDescription', Description.$);
    return WebClipboardOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebClipboardOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebClipboardOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (WebClipboardOptionsDescriptionMetadata.a == null) {
                WebClipboardOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebClipboardOptionsDescriptionMetadata.c(WebClipboardOptionsDescriptionMetadata.a);
            }
            if (a.k(WebClipboardOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebClipboardOptionsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ClipboardOptions");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Enabled", "Boolean");
            a.item("CopyHeaders", "Boolean");
            a.item("CopyFormatters", "Boolean");
            a.item("Separator", "String");
        }
        static d(a) {
            WebClipboardOptionsDescriptionMetadata.b(a);
            a.ae("WebClipboardOptions", () => new WebClipboardOptionsDescription());
            a.ad("WebClipboardOptions", WebClipboardOptionsDescriptionMetadata.a);
        }
    }
    WebClipboardOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebClipboardOptionsDescriptionMetadata, 'WebClipboardOptionsDescriptionMetadata');
    WebClipboardOptionsDescriptionMetadata.a = null;
    return WebClipboardOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridResourceStringsDescription = /*@__PURE__*/ (() => {
    class WebGridResourceStringsDescription extends Description {
        get_type() {
            return "WebGridResourceStrings";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.co = null;
            this.cp = null;
            this.cn = null;
            this.ah = null;
            this.ai = null;
            this.bi = null;
            this.cc = null;
            this.cf = null;
            this.ce = null;
            this.cb = null;
            this.cd = null;
            this.cg = null;
            this.b9 = null;
            this.af = null;
            this.ca = null;
            this.bq = null;
            this.br = null;
            this.ch = null;
            this.bu = null;
            this.bv = null;
            this.bs = null;
            this.bt = null;
            this.b6 = null;
            this.b8 = null;
            this.b7 = null;
            this.bo = null;
            this.bj = null;
            this.bl = null;
            this.b5 = null;
            this.bn = null;
            this.bm = null;
            this.ck = null;
            this.cm = null;
            this.ci = null;
            this.bz = null;
            this.b3 = null;
            this.cj = null;
            this.b0 = null;
            this.b4 = null;
            this.bx = null;
            this.b1 = null;
            this.by = null;
            this.b2 = null;
            this.cl = null;
            this.bw = null;
            this.bk = null;
            this.bp = null;
            this.dv = null;
            this.dz = null;
            this.dy = null;
            this.d0 = null;
            this.du = null;
            this.dw = null;
            this.dx = null;
            this.ax = null;
            this.ay = null;
            this.az = null;
            this.a0 = null;
            this.aw = null;
            this.a1 = null;
            this.a2 = null;
            this.a3 = null;
            this.a4 = null;
            this.a5 = null;
            this.av = null;
            this.ap = null;
            this.aq = null;
            this.ar = null;
            this.an = null;
            this.ak = null;
            this.bb = null;
            this.bd = null;
            this.be = null;
            this.aj = null;
            this.al = null;
            this.a6 = null;
            this.bf = null;
            this.ba = null;
            this.bh = null;
            this.bc = null;
            this.au = null;
            this.bg = null;
            this.a9 = null;
            this.at = null;
            this.am = null;
            this.ao = null;
            this.as = null;
            this.a8 = null;
            this.a7 = null;
            this.ac = null;
            this.r = null;
            this.aa = null;
            this.y = null;
            this.u = null;
            this.v = null;
            this.s = null;
            this.ab = null;
            this.q = null;
            this.ad = null;
            this.w = null;
            this.x = null;
            this.z = null;
            this.t = null;
            this.ae = null;
            this.cx = null;
            this.cq = null;
            this.cr = null;
            this.cy = null;
            this.cz = null;
            this.dr = null;
            this.dq = null;
            this.d1 = null;
            this.ea = null;
            this.d8 = null;
            this.eb = null;
            this.d9 = null;
            this.d3 = null;
            this.d2 = null;
            this.d5 = null;
            this.d4 = null;
            this.d7 = null;
            this.d6 = null;
            this.dt = null;
            this.ds = null;
            this.k = null;
            this.i = null;
            this.p = null;
            this.h = null;
            this.j = null;
            this.n = null;
            this.o = null;
            this.m = null;
            this.l = null;
            this.da = null;
            this.c1 = null;
            this.c5 = null;
            this.c4 = null;
            this.c6 = null;
            this.c0 = null;
            this.c3 = null;
            this.c2 = null;
            this.c8 = null;
            this.c7 = null;
            this.de = null;
            this.db = null;
            this.dc = null;
            this.df = null;
            this.dh = null;
            this.c9 = null;
            this.dg = null;
            this.dn = null;
            this.dd = null;
            this.dj = null;
            this.dl = null;
            this.di = null;
            this.dm = null;
            this.dk = null;
            this.dp = null;
            this.cv = null;
            this.ct = null;
            this.cu = null;
            this.cs = null;
            this.ag = null;
            this.cw = null;
        }
        get igx_grid_groupByArea_message() {
            return this.co;
        }
        set igx_grid_groupByArea_message(a) {
            this.co = a;
            this.g("Igx_grid_groupByArea_message");
        }
        get igx_grid_groupByArea_select_message() {
            return this.cp;
        }
        set igx_grid_groupByArea_select_message(a) {
            this.cp = a;
            this.g("Igx_grid_groupByArea_select_message");
        }
        get igx_grid_groupByArea_deselect_message() {
            return this.cn;
        }
        set igx_grid_groupByArea_deselect_message(a) {
            this.cn = a;
            this.g("Igx_grid_groupByArea_deselect_message");
        }
        get igx_grid_emptyFilteredGrid_message() {
            return this.ah;
        }
        set igx_grid_emptyFilteredGrid_message(a) {
            this.ah = a;
            this.g("Igx_grid_emptyFilteredGrid_message");
        }
        get igx_grid_emptyGrid_message() {
            return this.ai;
        }
        set igx_grid_emptyGrid_message(a) {
            this.ai = a;
            this.g("Igx_grid_emptyGrid_message");
        }
        get igx_grid_filter() {
            return this.bi;
        }
        set igx_grid_filter(a) {
            this.bi = a;
            this.g("Igx_grid_filter");
        }
        get igx_grid_filter_row_close() {
            return this.cc;
        }
        set igx_grid_filter_row_close(a) {
            this.cc = a;
            this.g("Igx_grid_filter_row_close");
        }
        get igx_grid_filter_row_reset() {
            return this.cf;
        }
        set igx_grid_filter_row_reset(a) {
            this.cf = a;
            this.g("Igx_grid_filter_row_reset");
        }
        get igx_grid_filter_row_placeholder() {
            return this.ce;
        }
        set igx_grid_filter_row_placeholder(a) {
            this.ce = a;
            this.g("Igx_grid_filter_row_placeholder");
        }
        get igx_grid_filter_row_boolean_placeholder() {
            return this.cb;
        }
        set igx_grid_filter_row_boolean_placeholder(a) {
            this.cb = a;
            this.g("Igx_grid_filter_row_boolean_placeholder");
        }
        get igx_grid_filter_row_date_placeholder() {
            return this.cd;
        }
        set igx_grid_filter_row_date_placeholder(a) {
            this.cd = a;
            this.g("Igx_grid_filter_row_date_placeholder");
        }
        get igx_grid_filter_row_time_placeholder() {
            return this.cg;
        }
        set igx_grid_filter_row_time_placeholder(a) {
            this.cg = a;
            this.g("Igx_grid_filter_row_time_placeholder");
        }
        get igx_grid_filter_operator_and() {
            return this.b9;
        }
        set igx_grid_filter_operator_and(a) {
            this.b9 = a;
            this.g("Igx_grid_filter_operator_and");
        }
        get igx_grid_complex_filter() {
            return this.af;
        }
        set igx_grid_complex_filter(a) {
            this.af = a;
            this.g("Igx_grid_complex_filter");
        }
        get igx_grid_filter_operator_or() {
            return this.ca;
        }
        set igx_grid_filter_operator_or(a) {
            this.ca = a;
            this.g("Igx_grid_filter_operator_or");
        }
        get igx_grid_filter_contains() {
            return this.bq;
        }
        set igx_grid_filter_contains(a) {
            this.bq = a;
            this.g("Igx_grid_filter_contains");
        }
        get igx_grid_filter_doesNotContain() {
            return this.br;
        }
        set igx_grid_filter_doesNotContain(a) {
            this.br = a;
            this.g("Igx_grid_filter_doesNotContain");
        }
        get igx_grid_filter_startsWith() {
            return this.ch;
        }
        set igx_grid_filter_startsWith(a) {
            this.ch = a;
            this.g("Igx_grid_filter_startsWith");
        }
        get igx_grid_filter_endsWith() {
            return this.bu;
        }
        set igx_grid_filter_endsWith(a) {
            this.bu = a;
            this.g("Igx_grid_filter_endsWith");
        }
        get igx_grid_filter_equals() {
            return this.bv;
        }
        set igx_grid_filter_equals(a) {
            this.bv = a;
            this.g("Igx_grid_filter_equals");
        }
        get igx_grid_filter_doesNotEqual() {
            return this.bs;
        }
        set igx_grid_filter_doesNotEqual(a) {
            this.bs = a;
            this.g("Igx_grid_filter_doesNotEqual");
        }
        get igx_grid_filter_empty() {
            return this.bt;
        }
        set igx_grid_filter_empty(a) {
            this.bt = a;
            this.g("Igx_grid_filter_empty");
        }
        get igx_grid_filter_notEmpty() {
            return this.b6;
        }
        set igx_grid_filter_notEmpty(a) {
            this.b6 = a;
            this.g("Igx_grid_filter_notEmpty");
        }
        get igx_grid_filter_null() {
            return this.b8;
        }
        set igx_grid_filter_null(a) {
            this.b8 = a;
            this.g("Igx_grid_filter_null");
        }
        get igx_grid_filter_notNull() {
            return this.b7;
        }
        set igx_grid_filter_notNull(a) {
            this.b7 = a;
            this.g("Igx_grid_filter_notNull");
        }
        get igx_grid_filter_before() {
            return this.bo;
        }
        set igx_grid_filter_before(a) {
            this.bo = a;
            this.g("Igx_grid_filter_before");
        }
        get igx_grid_filter_after() {
            return this.bj;
        }
        set igx_grid_filter_after(a) {
            this.bj = a;
            this.g("Igx_grid_filter_after");
        }
        get igx_grid_filter_at() {
            return this.bl;
        }
        set igx_grid_filter_at(a) {
            this.bl = a;
            this.g("Igx_grid_filter_at");
        }
        get igx_grid_filter_not_at() {
            return this.b5;
        }
        set igx_grid_filter_not_at(a) {
            this.b5 = a;
            this.g("Igx_grid_filter_not_at");
        }
        get igx_grid_filter_at_before() {
            return this.bn;
        }
        set igx_grid_filter_at_before(a) {
            this.bn = a;
            this.g("Igx_grid_filter_at_before");
        }
        get igx_grid_filter_at_after() {
            return this.bm;
        }
        set igx_grid_filter_at_after(a) {
            this.bm = a;
            this.g("Igx_grid_filter_at_after");
        }
        get igx_grid_filter_today() {
            return this.ck;
        }
        set igx_grid_filter_today(a) {
            this.ck = a;
            this.g("Igx_grid_filter_today");
        }
        get igx_grid_filter_yesterday() {
            return this.cm;
        }
        set igx_grid_filter_yesterday(a) {
            this.cm = a;
            this.g("Igx_grid_filter_yesterday");
        }
        get igx_grid_filter_thisMonth() {
            return this.ci;
        }
        set igx_grid_filter_thisMonth(a) {
            this.ci = a;
            this.g("Igx_grid_filter_thisMonth");
        }
        get igx_grid_filter_lastMonth() {
            return this.bz;
        }
        set igx_grid_filter_lastMonth(a) {
            this.bz = a;
            this.g("Igx_grid_filter_lastMonth");
        }
        get igx_grid_filter_nextMonth() {
            return this.b3;
        }
        set igx_grid_filter_nextMonth(a) {
            this.b3 = a;
            this.g("Igx_grid_filter_nextMonth");
        }
        get igx_grid_filter_thisYear() {
            return this.cj;
        }
        set igx_grid_filter_thisYear(a) {
            this.cj = a;
            this.g("Igx_grid_filter_thisYear");
        }
        get igx_grid_filter_lastYear() {
            return this.b0;
        }
        set igx_grid_filter_lastYear(a) {
            this.b0 = a;
            this.g("Igx_grid_filter_lastYear");
        }
        get igx_grid_filter_nextYear() {
            return this.b4;
        }
        set igx_grid_filter_nextYear(a) {
            this.b4 = a;
            this.g("Igx_grid_filter_nextYear");
        }
        get igx_grid_filter_greaterThan() {
            return this.bx;
        }
        set igx_grid_filter_greaterThan(a) {
            this.bx = a;
            this.g("Igx_grid_filter_greaterThan");
        }
        get igx_grid_filter_lessThan() {
            return this.b1;
        }
        set igx_grid_filter_lessThan(a) {
            this.b1 = a;
            this.g("Igx_grid_filter_lessThan");
        }
        get igx_grid_filter_greaterThanOrEqualTo() {
            return this.by;
        }
        set igx_grid_filter_greaterThanOrEqualTo(a) {
            this.by = a;
            this.g("Igx_grid_filter_greaterThanOrEqualTo");
        }
        get igx_grid_filter_lessThanOrEqualTo() {
            return this.b2;
        }
        set igx_grid_filter_lessThanOrEqualTo(a) {
            this.b2 = a;
            this.g("Igx_grid_filter_lessThanOrEqualTo");
        }
        get igx_grid_filter_true() {
            return this.cl;
        }
        set igx_grid_filter_true(a) {
            this.cl = a;
            this.g("Igx_grid_filter_true");
        }
        get igx_grid_filter_false() {
            return this.bw;
        }
        set igx_grid_filter_false(a) {
            this.bw = a;
            this.g("Igx_grid_filter_false");
        }
        get igx_grid_filter_all() {
            return this.bk;
        }
        set igx_grid_filter_all(a) {
            this.bk = a;
            this.g("Igx_grid_filter_all");
        }
        get igx_grid_filter_condition_placeholder() {
            return this.bp;
        }
        set igx_grid_filter_condition_placeholder(a) {
            this.bp = a;
            this.g("Igx_grid_filter_condition_placeholder");
        }
        get igx_grid_summary_count() {
            return this.dv;
        }
        set igx_grid_summary_count(a) {
            this.dv = a;
            this.g("Igx_grid_summary_count");
        }
        get igx_grid_summary_min() {
            return this.dz;
        }
        set igx_grid_summary_min(a) {
            this.dz = a;
            this.g("Igx_grid_summary_min");
        }
        get igx_grid_summary_max() {
            return this.dy;
        }
        set igx_grid_summary_max(a) {
            this.dy = a;
            this.g("Igx_grid_summary_max");
        }
        get igx_grid_summary_sum() {
            return this.d0;
        }
        set igx_grid_summary_sum(a) {
            this.d0 = a;
            this.g("Igx_grid_summary_sum");
        }
        get igx_grid_summary_average() {
            return this.du;
        }
        set igx_grid_summary_average(a) {
            this.du = a;
            this.g("Igx_grid_summary_average");
        }
        get igx_grid_summary_earliest() {
            return this.dw;
        }
        set igx_grid_summary_earliest(a) {
            this.dw = a;
            this.g("Igx_grid_summary_earliest");
        }
        get igx_grid_summary_latest() {
            return this.dx;
        }
        set igx_grid_summary_latest(a) {
            this.dx = a;
            this.g("Igx_grid_summary_latest");
        }
        get igx_grid_excel_filter_moving_left() {
            return this.ax;
        }
        set igx_grid_excel_filter_moving_left(a) {
            this.ax = a;
            this.g("Igx_grid_excel_filter_moving_left");
        }
        get igx_grid_excel_filter_moving_left_short() {
            return this.ay;
        }
        set igx_grid_excel_filter_moving_left_short(a) {
            this.ay = a;
            this.g("Igx_grid_excel_filter_moving_left_short");
        }
        get igx_grid_excel_filter_moving_right() {
            return this.az;
        }
        set igx_grid_excel_filter_moving_right(a) {
            this.az = a;
            this.g("Igx_grid_excel_filter_moving_right");
        }
        get igx_grid_excel_filter_moving_right_short() {
            return this.a0;
        }
        set igx_grid_excel_filter_moving_right_short(a) {
            this.a0 = a;
            this.g("Igx_grid_excel_filter_moving_right_short");
        }
        get igx_grid_excel_filter_moving_header() {
            return this.aw;
        }
        set igx_grid_excel_filter_moving_header(a) {
            this.aw = a;
            this.g("Igx_grid_excel_filter_moving_header");
        }
        get igx_grid_excel_filter_sorting_asc() {
            return this.a1;
        }
        set igx_grid_excel_filter_sorting_asc(a) {
            this.a1 = a;
            this.g("Igx_grid_excel_filter_sorting_asc");
        }
        get igx_grid_excel_filter_sorting_asc_short() {
            return this.a2;
        }
        set igx_grid_excel_filter_sorting_asc_short(a) {
            this.a2 = a;
            this.g("Igx_grid_excel_filter_sorting_asc_short");
        }
        get igx_grid_excel_filter_sorting_desc() {
            return this.a3;
        }
        set igx_grid_excel_filter_sorting_desc(a) {
            this.a3 = a;
            this.g("Igx_grid_excel_filter_sorting_desc");
        }
        get igx_grid_excel_filter_sorting_desc_short() {
            return this.a4;
        }
        set igx_grid_excel_filter_sorting_desc_short(a) {
            this.a4 = a;
            this.g("Igx_grid_excel_filter_sorting_desc_short");
        }
        get igx_grid_excel_filter_sorting_header() {
            return this.a5;
        }
        set igx_grid_excel_filter_sorting_header(a) {
            this.a5 = a;
            this.g("Igx_grid_excel_filter_sorting_header");
        }
        get igx_grid_excel_filter_clear() {
            return this.av;
        }
        set igx_grid_excel_filter_clear(a) {
            this.av = a;
            this.g("Igx_grid_excel_filter_clear");
        }
        get igx_grid_excel_custom_dialog_add() {
            return this.ap;
        }
        set igx_grid_excel_custom_dialog_add(a) {
            this.ap = a;
            this.g("Igx_grid_excel_custom_dialog_add");
        }
        get igx_grid_excel_custom_dialog_clear() {
            return this.aq;
        }
        set igx_grid_excel_custom_dialog_clear(a) {
            this.aq = a;
            this.g("Igx_grid_excel_custom_dialog_clear");
        }
        get igx_grid_excel_custom_dialog_header() {
            return this.ar;
        }
        set igx_grid_excel_custom_dialog_header(a) {
            this.ar = a;
            this.g("Igx_grid_excel_custom_dialog_header");
        }
        get igx_grid_excel_cancel() {
            return this.an;
        }
        set igx_grid_excel_cancel(a) {
            this.an = a;
            this.g("Igx_grid_excel_cancel");
        }
        get igx_grid_excel_apply() {
            return this.ak;
        }
        set igx_grid_excel_apply(a) {
            this.ak = a;
            this.g("Igx_grid_excel_apply");
        }
        get igx_grid_excel_search_placeholder() {
            return this.bb;
        }
        set igx_grid_excel_search_placeholder(a) {
            this.bb = a;
            this.g("Igx_grid_excel_search_placeholder");
        }
        get igx_grid_excel_select_all() {
            return this.bd;
        }
        set igx_grid_excel_select_all(a) {
            this.bd = a;
            this.g("Igx_grid_excel_select_all");
        }
        get igx_grid_excel_select_all_search_results() {
            return this.be;
        }
        set igx_grid_excel_select_all_search_results(a) {
            this.be = a;
            this.g("Igx_grid_excel_select_all_search_results");
        }
        get igx_grid_excel_add_to_filter() {
            return this.aj;
        }
        set igx_grid_excel_add_to_filter(a) {
            this.aj = a;
            this.g("Igx_grid_excel_add_to_filter");
        }
        get igx_grid_excel_blanks() {
            return this.al;
        }
        set igx_grid_excel_blanks(a) {
            this.al = a;
            this.g("Igx_grid_excel_blanks");
        }
        get igx_grid_excel_hide() {
            return this.a6;
        }
        set igx_grid_excel_hide(a) {
            this.a6 = a;
            this.g("Igx_grid_excel_hide");
        }
        get igx_grid_excel_show() {
            return this.bf;
        }
        set igx_grid_excel_show(a) {
            this.bf = a;
            this.g("Igx_grid_excel_show");
        }
        get igx_grid_excel_pin() {
            return this.ba;
        }
        set igx_grid_excel_pin(a) {
            this.ba = a;
            this.g("Igx_grid_excel_pin");
        }
        get igx_grid_excel_unpin() {
            return this.bh;
        }
        set igx_grid_excel_unpin(a) {
            this.bh = a;
            this.g("Igx_grid_excel_unpin");
        }
        get igx_grid_excel_select() {
            return this.bc;
        }
        set igx_grid_excel_select(a) {
            this.bc = a;
            this.g("Igx_grid_excel_select");
        }
        get igx_grid_excel_deselect() {
            return this.au;
        }
        set igx_grid_excel_deselect(a) {
            this.au = a;
            this.g("Igx_grid_excel_deselect");
        }
        get igx_grid_excel_text_filter() {
            return this.bg;
        }
        set igx_grid_excel_text_filter(a) {
            this.bg = a;
            this.g("Igx_grid_excel_text_filter");
        }
        get igx_grid_excel_number_filter() {
            return this.a9;
        }
        set igx_grid_excel_number_filter(a) {
            this.a9 = a;
            this.g("Igx_grid_excel_number_filter");
        }
        get igx_grid_excel_date_filter() {
            return this.at;
        }
        set igx_grid_excel_date_filter(a) {
            this.at = a;
            this.g("Igx_grid_excel_date_filter");
        }
        get igx_grid_excel_boolean_filter() {
            return this.am;
        }
        set igx_grid_excel_boolean_filter(a) {
            this.am = a;
            this.g("Igx_grid_excel_boolean_filter");
        }
        get igx_grid_excel_currency_filter() {
            return this.ao;
        }
        set igx_grid_excel_currency_filter(a) {
            this.ao = a;
            this.g("Igx_grid_excel_currency_filter");
        }
        get igx_grid_excel_custom_filter() {
            return this.as;
        }
        set igx_grid_excel_custom_filter(a) {
            this.as = a;
            this.g("Igx_grid_excel_custom_filter");
        }
        get igx_grid_excel_no_matches() {
            return this.a8;
        }
        set igx_grid_excel_no_matches(a) {
            this.a8 = a;
            this.g("Igx_grid_excel_no_matches");
        }
        get igx_grid_excel_matches_count() {
            return this.a7;
        }
        set igx_grid_excel_matches_count(a) {
            this.a7 = a;
            this.g("Igx_grid_excel_matches_count");
        }
        get igx_grid_advanced_filter_title() {
            return this.ac;
        }
        set igx_grid_advanced_filter_title(a) {
            this.ac = a;
            this.g("Igx_grid_advanced_filter_title");
        }
        get igx_grid_advanced_filter_and_group() {
            return this.r;
        }
        set igx_grid_advanced_filter_and_group(a) {
            this.r = a;
            this.g("Igx_grid_advanced_filter_and_group");
        }
        get igx_grid_advanced_filter_or_group() {
            return this.aa;
        }
        set igx_grid_advanced_filter_or_group(a) {
            this.aa = a;
            this.g("Igx_grid_advanced_filter_or_group");
        }
        get igx_grid_advanced_filter_end_group() {
            return this.y;
        }
        set igx_grid_advanced_filter_end_group(a) {
            this.y = a;
            this.g("Igx_grid_advanced_filter_end_group");
        }
        get igx_grid_advanced_filter_create_and_group() {
            return this.u;
        }
        set igx_grid_advanced_filter_create_and_group(a) {
            this.u = a;
            this.g("Igx_grid_advanced_filter_create_and_group");
        }
        get igx_grid_advanced_filter_create_or_group() {
            return this.v;
        }
        set igx_grid_advanced_filter_create_or_group(a) {
            this.v = a;
            this.g("Igx_grid_advanced_filter_create_or_group");
        }
        get igx_grid_advanced_filter_and_label() {
            return this.s;
        }
        set igx_grid_advanced_filter_and_label(a) {
            this.s = a;
            this.g("Igx_grid_advanced_filter_and_label");
        }
        get igx_grid_advanced_filter_or_label() {
            return this.ab;
        }
        set igx_grid_advanced_filter_or_label(a) {
            this.ab = a;
            this.g("Igx_grid_advanced_filter_or_label");
        }
        get igx_grid_advanced_filter_add_condition() {
            return this.q;
        }
        set igx_grid_advanced_filter_add_condition(a) {
            this.q = a;
            this.g("Igx_grid_advanced_filter_add_condition");
        }
        get igx_grid_advanced_filter_ungroup() {
            return this.ad;
        }
        set igx_grid_advanced_filter_ungroup(a) {
            this.ad = a;
            this.g("Igx_grid_advanced_filter_ungroup");
        }
        get igx_grid_advanced_filter_delete() {
            return this.w;
        }
        set igx_grid_advanced_filter_delete(a) {
            this.w = a;
            this.g("Igx_grid_advanced_filter_delete");
        }
        get igx_grid_advanced_filter_delete_filters() {
            return this.x;
        }
        set igx_grid_advanced_filter_delete_filters(a) {
            this.x = a;
            this.g("Igx_grid_advanced_filter_delete_filters");
        }
        get igx_grid_advanced_filter_initial_text() {
            return this.z;
        }
        set igx_grid_advanced_filter_initial_text(a) {
            this.z = a;
            this.g("Igx_grid_advanced_filter_initial_text");
        }
        get igx_grid_advanced_filter_column_placeholder() {
            return this.t;
        }
        set igx_grid_advanced_filter_column_placeholder(a) {
            this.t = a;
            this.g("Igx_grid_advanced_filter_column_placeholder");
        }
        get igx_grid_advanced_filter_value_placeholder() {
            return this.ae;
        }
        set igx_grid_advanced_filter_value_placeholder(a) {
            this.ae = a;
            this.g("Igx_grid_advanced_filter_value_placeholder");
        }
        get igx_grid_pinned_row_indicator() {
            return this.cx;
        }
        set igx_grid_pinned_row_indicator(a) {
            this.cx = a;
            this.g("Igx_grid_pinned_row_indicator");
        }
        get igx_grid_hiding_check_all_label() {
            return this.cq;
        }
        set igx_grid_hiding_check_all_label(a) {
            this.cq = a;
            this.g("Igx_grid_hiding_check_all_label");
        }
        get igx_grid_hiding_uncheck_all_label() {
            return this.cr;
        }
        set igx_grid_hiding_uncheck_all_label(a) {
            this.cr = a;
            this.g("Igx_grid_hiding_uncheck_all_label");
        }
        get igx_grid_pinning_check_all_label() {
            return this.cy;
        }
        set igx_grid_pinning_check_all_label(a) {
            this.cy = a;
            this.g("Igx_grid_pinning_check_all_label");
        }
        get igx_grid_pinning_uncheck_all_label() {
            return this.cz;
        }
        set igx_grid_pinning_uncheck_all_label(a) {
            this.cz = a;
            this.g("Igx_grid_pinning_uncheck_all_label");
        }
        get igx_grid_row_edit_btn_done() {
            return this.dr;
        }
        set igx_grid_row_edit_btn_done(a) {
            this.dr = a;
            this.g("Igx_grid_row_edit_btn_done");
        }
        get igx_grid_row_edit_btn_cancel() {
            return this.dq;
        }
        set igx_grid_row_edit_btn_cancel(a) {
            this.dq = a;
            this.g("Igx_grid_row_edit_btn_cancel");
        }
        get igx_grid_toolbar_actions_filter_prompt() {
            return this.d1;
        }
        set igx_grid_toolbar_actions_filter_prompt(a) {
            this.d1 = a;
            this.g("Igx_grid_toolbar_actions_filter_prompt");
        }
        get igx_grid_toolbar_pinning_button_tooltip() {
            return this.ea;
        }
        set igx_grid_toolbar_pinning_button_tooltip(a) {
            this.ea = a;
            this.g("Igx_grid_toolbar_pinning_button_tooltip");
        }
        get igx_grid_toolbar_hiding_button_tooltip() {
            return this.d8;
        }
        set igx_grid_toolbar_hiding_button_tooltip(a) {
            this.d8 = a;
            this.g("Igx_grid_toolbar_hiding_button_tooltip");
        }
        get igx_grid_toolbar_pinning_title() {
            return this.eb;
        }
        set igx_grid_toolbar_pinning_title(a) {
            this.eb = a;
            this.g("Igx_grid_toolbar_pinning_title");
        }
        get igx_grid_toolbar_hiding_title() {
            return this.d9;
        }
        set igx_grid_toolbar_hiding_title(a) {
            this.d9 = a;
            this.g("Igx_grid_toolbar_hiding_title");
        }
        get igx_grid_toolbar_advanced_filtering_button_tooltip() {
            return this.d3;
        }
        set igx_grid_toolbar_advanced_filtering_button_tooltip(a) {
            this.d3 = a;
            this.g("Igx_grid_toolbar_advanced_filtering_button_tooltip");
        }
        get igx_grid_toolbar_advanced_filtering_button_label() {
            return this.d2;
        }
        set igx_grid_toolbar_advanced_filtering_button_label(a) {
            this.d2 = a;
            this.g("Igx_grid_toolbar_advanced_filtering_button_label");
        }
        get igx_grid_toolbar_exporter_button_tooltip() {
            return this.d5;
        }
        set igx_grid_toolbar_exporter_button_tooltip(a) {
            this.d5 = a;
            this.g("Igx_grid_toolbar_exporter_button_tooltip");
        }
        get igx_grid_toolbar_exporter_button_label() {
            return this.d4;
        }
        set igx_grid_toolbar_exporter_button_label(a) {
            this.d4 = a;
            this.g("Igx_grid_toolbar_exporter_button_label");
        }
        get igx_grid_toolbar_exporter_excel_entry_text() {
            return this.d7;
        }
        set igx_grid_toolbar_exporter_excel_entry_text(a) {
            this.d7 = a;
            this.g("Igx_grid_toolbar_exporter_excel_entry_text");
        }
        get igx_grid_toolbar_exporter_csv_entry_text() {
            return this.d6;
        }
        set igx_grid_toolbar_exporter_csv_entry_text(a) {
            this.d6 = a;
            this.g("Igx_grid_toolbar_exporter_csv_entry_text");
        }
        get igx_grid_snackbar_addrow_label() {
            return this.dt;
        }
        set igx_grid_snackbar_addrow_label(a) {
            this.dt = a;
            this.g("Igx_grid_snackbar_addrow_label");
        }
        get igx_grid_snackbar_addrow_actiontext() {
            return this.ds;
        }
        set igx_grid_snackbar_addrow_actiontext(a) {
            this.ds = a;
            this.g("Igx_grid_snackbar_addrow_actiontext");
        }
        get igx_grid_actions_edit_label() {
            return this.k;
        }
        set igx_grid_actions_edit_label(a) {
            this.k = a;
            this.g("Igx_grid_actions_edit_label");
        }
        get igx_grid_actions_add_label() {
            return this.i;
        }
        set igx_grid_actions_add_label(a) {
            this.i = a;
            this.g("Igx_grid_actions_add_label");
        }
        get igx_grid_add_row_label() {
            return this.p;
        }
        set igx_grid_add_row_label(a) {
            this.p = a;
            this.g("Igx_grid_add_row_label");
        }
        get igx_grid_actions_add_child_label() {
            return this.h;
        }
        set igx_grid_actions_add_child_label(a) {
            this.h = a;
            this.g("Igx_grid_actions_add_child_label");
        }
        get igx_grid_actions_delete_label() {
            return this.j;
        }
        set igx_grid_actions_delete_label(a) {
            this.j = a;
            this.g("Igx_grid_actions_delete_label");
        }
        get igx_grid_actions_pin_label() {
            return this.n;
        }
        set igx_grid_actions_pin_label(a) {
            this.n = a;
            this.g("Igx_grid_actions_pin_label");
        }
        get igx_grid_actions_unpin_label() {
            return this.o;
        }
        set igx_grid_actions_unpin_label(a) {
            this.o = a;
            this.g("Igx_grid_actions_unpin_label");
        }
        get igx_grid_actions_jumpUp_label() {
            return this.m;
        }
        set igx_grid_actions_jumpUp_label(a) {
            this.m = a;
            this.g("Igx_grid_actions_jumpUp_label");
        }
        get igx_grid_actions_jumpDown_label() {
            return this.l;
        }
        set igx_grid_actions_jumpDown_label(a) {
            this.l = a;
            this.g("Igx_grid_actions_jumpDown_label");
        }
        get igx_grid_pivot_date_dimension_total() {
            return this.da;
        }
        set igx_grid_pivot_date_dimension_total(a) {
            this.da = a;
            this.g("Igx_grid_pivot_date_dimension_total");
        }
        get igx_grid_pivot_aggregate_count() {
            return this.c1;
        }
        set igx_grid_pivot_aggregate_count(a) {
            this.c1 = a;
            this.g("Igx_grid_pivot_aggregate_count");
        }
        get igx_grid_pivot_aggregate_min() {
            return this.c5;
        }
        set igx_grid_pivot_aggregate_min(a) {
            this.c5 = a;
            this.g("Igx_grid_pivot_aggregate_min");
        }
        get igx_grid_pivot_aggregate_max() {
            return this.c4;
        }
        set igx_grid_pivot_aggregate_max(a) {
            this.c4 = a;
            this.g("Igx_grid_pivot_aggregate_max");
        }
        get igx_grid_pivot_aggregate_sum() {
            return this.c6;
        }
        set igx_grid_pivot_aggregate_sum(a) {
            this.c6 = a;
            this.g("Igx_grid_pivot_aggregate_sum");
        }
        get igx_grid_pivot_aggregate_avg() {
            return this.c0;
        }
        set igx_grid_pivot_aggregate_avg(a) {
            this.c0 = a;
            this.g("Igx_grid_pivot_aggregate_avg");
        }
        get igx_grid_pivot_aggregate_date_latest() {
            return this.c3;
        }
        set igx_grid_pivot_aggregate_date_latest(a) {
            this.c3 = a;
            this.g("Igx_grid_pivot_aggregate_date_latest");
        }
        get igx_grid_pivot_aggregate_date_earliest() {
            return this.c2;
        }
        set igx_grid_pivot_aggregate_date_earliest(a) {
            this.c2 = a;
            this.g("Igx_grid_pivot_aggregate_date_earliest");
        }
        get igx_grid_pivot_aggregate_time_latest() {
            return this.c8;
        }
        set igx_grid_pivot_aggregate_time_latest(a) {
            this.c8 = a;
            this.g("Igx_grid_pivot_aggregate_time_latest");
        }
        get igx_grid_pivot_aggregate_time_earliest() {
            return this.c7;
        }
        set igx_grid_pivot_aggregate_time_earliest(a) {
            this.c7 = a;
            this.g("Igx_grid_pivot_aggregate_time_earliest");
        }
        get igx_grid_pivot_empty_row_drop_area() {
            return this.de;
        }
        set igx_grid_pivot_empty_row_drop_area(a) {
            this.de = a;
            this.g("Igx_grid_pivot_empty_row_drop_area");
        }
        get igx_grid_pivot_empty_column_drop_area() {
            return this.db;
        }
        set igx_grid_pivot_empty_column_drop_area(a) {
            this.db = a;
            this.g("Igx_grid_pivot_empty_column_drop_area");
        }
        get igx_grid_pivot_empty_filter_drop_area() {
            return this.dc;
        }
        set igx_grid_pivot_empty_filter_drop_area(a) {
            this.dc = a;
            this.g("Igx_grid_pivot_empty_filter_drop_area");
        }
        get igx_grid_pivot_empty_value_drop_area() {
            return this.df;
        }
        set igx_grid_pivot_empty_value_drop_area(a) {
            this.df = a;
            this.g("Igx_grid_pivot_empty_value_drop_area");
        }
        get igx_grid_pivot_row_drop_chip() {
            return this.dh;
        }
        set igx_grid_pivot_row_drop_chip(a) {
            this.dh = a;
            this.g("Igx_grid_pivot_row_drop_chip");
        }
        get igx_grid_pivot_column_drop_chip() {
            return this.c9;
        }
        set igx_grid_pivot_column_drop_chip(a) {
            this.c9 = a;
            this.g("Igx_grid_pivot_column_drop_chip");
        }
        get igx_grid_pivot_filter_drop_chip() {
            return this.dg;
        }
        set igx_grid_pivot_filter_drop_chip(a) {
            this.dg = a;
            this.g("Igx_grid_pivot_filter_drop_chip");
        }
        get igx_grid_pivot_value_drop_chip() {
            return this.dn;
        }
        set igx_grid_pivot_value_drop_chip(a) {
            this.dn = a;
            this.g("Igx_grid_pivot_value_drop_chip");
        }
        get igx_grid_pivot_empty_message() {
            return this.dd;
        }
        set igx_grid_pivot_empty_message(a) {
            this.dd = a;
            this.g("Igx_grid_pivot_empty_message");
        }
        get igx_grid_pivot_selector_filters() {
            return this.dj;
        }
        set igx_grid_pivot_selector_filters(a) {
            this.dj = a;
            this.g("Igx_grid_pivot_selector_filters");
        }
        get igx_grid_pivot_selector_rows() {
            return this.dl;
        }
        set igx_grid_pivot_selector_rows(a) {
            this.dl = a;
            this.g("Igx_grid_pivot_selector_rows");
        }
        get igx_grid_pivot_selector_columns() {
            return this.di;
        }
        set igx_grid_pivot_selector_columns(a) {
            this.di = a;
            this.g("Igx_grid_pivot_selector_columns");
        }
        get igx_grid_pivot_selector_values() {
            return this.dm;
        }
        set igx_grid_pivot_selector_values(a) {
            this.dm = a;
            this.g("Igx_grid_pivot_selector_values");
        }
        get igx_grid_pivot_selector_panel_empty() {
            return this.dk;
        }
        set igx_grid_pivot_selector_panel_empty(a) {
            this.dk = a;
            this.g("Igx_grid_pivot_selector_panel_empty");
        }
        get igx_grid_required_validation_error() {
            return this.dp;
        }
        set igx_grid_required_validation_error(a) {
            this.dp = a;
            this.g("Igx_grid_required_validation_error");
        }
        get igx_grid_min_validation_error() {
            return this.cv;
        }
        set igx_grid_min_validation_error(a) {
            this.cv = a;
            this.g("Igx_grid_min_validation_error");
        }
        get igx_grid_max_validation_error() {
            return this.ct;
        }
        set igx_grid_max_validation_error(a) {
            this.ct = a;
            this.g("Igx_grid_max_validation_error");
        }
        get igx_grid_min_length_validation_error() {
            return this.cu;
        }
        set igx_grid_min_length_validation_error(a) {
            this.cu = a;
            this.g("Igx_grid_min_length_validation_error");
        }
        get igx_grid_max_length_validation_error() {
            return this.cs;
        }
        set igx_grid_max_length_validation_error(a) {
            this.cs = a;
            this.g("Igx_grid_max_length_validation_error");
        }
        get igx_grid_email_validation_error() {
            return this.ag;
        }
        set igx_grid_email_validation_error(a) {
            this.ag = a;
            this.g("Igx_grid_email_validation_error");
        }
        get igx_grid_pattern_validation_error() {
            return this.cw;
        }
        set igx_grid_pattern_validation_error(a) {
            this.cw = a;
            this.g("Igx_grid_pattern_validation_error");
        }
    }
    WebGridResourceStringsDescription.$t = /*@__PURE__*/ markType(WebGridResourceStringsDescription, 'WebGridResourceStringsDescription', Description.$);
    return WebGridResourceStringsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridResourceStringsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridResourceStringsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridResourceStringsDescriptionMetadata.a == null) {
                WebGridResourceStringsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridResourceStringsDescriptionMetadata.c(WebGridResourceStringsDescriptionMetadata.a);
            }
            if (a.k(WebGridResourceStringsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridResourceStringsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridResourceStrings");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Igx_grid_groupByArea_message", "String");
            a.item("Igx_grid_groupByArea_select_message", "String");
            a.item("Igx_grid_groupByArea_deselect_message", "String");
            a.item("Igx_grid_emptyFilteredGrid_message", "String");
            a.item("Igx_grid_emptyGrid_message", "String");
            a.item("Igx_grid_filter", "String");
            a.item("Igx_grid_filter_row_close", "String");
            a.item("Igx_grid_filter_row_reset", "String");
            a.item("Igx_grid_filter_row_placeholder", "String");
            a.item("Igx_grid_filter_row_boolean_placeholder", "String");
            a.item("Igx_grid_filter_row_date_placeholder", "String");
            a.item("Igx_grid_filter_row_time_placeholder", "String");
            a.item("Igx_grid_filter_operator_and", "String");
            a.item("Igx_grid_complex_filter", "String");
            a.item("Igx_grid_filter_operator_or", "String");
            a.item("Igx_grid_filter_contains", "String");
            a.item("Igx_grid_filter_doesNotContain", "String");
            a.item("Igx_grid_filter_startsWith", "String");
            a.item("Igx_grid_filter_endsWith", "String");
            a.item("Igx_grid_filter_equals", "String");
            a.item("Igx_grid_filter_doesNotEqual", "String");
            a.item("Igx_grid_filter_empty", "String");
            a.item("Igx_grid_filter_notEmpty", "String");
            a.item("Igx_grid_filter_null", "String");
            a.item("Igx_grid_filter_notNull", "String");
            a.item("Igx_grid_filter_before", "String");
            a.item("Igx_grid_filter_after", "String");
            a.item("Igx_grid_filter_at", "String");
            a.item("Igx_grid_filter_not_at", "String");
            a.item("Igx_grid_filter_at_before", "String");
            a.item("Igx_grid_filter_at_after", "String");
            a.item("Igx_grid_filter_today", "String");
            a.item("Igx_grid_filter_yesterday", "String");
            a.item("Igx_grid_filter_thisMonth", "String");
            a.item("Igx_grid_filter_lastMonth", "String");
            a.item("Igx_grid_filter_nextMonth", "String");
            a.item("Igx_grid_filter_thisYear", "String");
            a.item("Igx_grid_filter_lastYear", "String");
            a.item("Igx_grid_filter_nextYear", "String");
            a.item("Igx_grid_filter_greaterThan", "String");
            a.item("Igx_grid_filter_lessThan", "String");
            a.item("Igx_grid_filter_greaterThanOrEqualTo", "String");
            a.item("Igx_grid_filter_lessThanOrEqualTo", "String");
            a.item("Igx_grid_filter_true", "String");
            a.item("Igx_grid_filter_false", "String");
            a.item("Igx_grid_filter_all", "String");
            a.item("Igx_grid_filter_condition_placeholder", "String");
            a.item("Igx_grid_summary_count", "String");
            a.item("Igx_grid_summary_min", "String");
            a.item("Igx_grid_summary_max", "String");
            a.item("Igx_grid_summary_sum", "String");
            a.item("Igx_grid_summary_average", "String");
            a.item("Igx_grid_summary_earliest", "String");
            a.item("Igx_grid_summary_latest", "String");
            a.item("Igx_grid_excel_filter_moving_left", "String");
            a.item("Igx_grid_excel_filter_moving_left_short", "String");
            a.item("Igx_grid_excel_filter_moving_right", "String");
            a.item("Igx_grid_excel_filter_moving_right_short", "String");
            a.item("Igx_grid_excel_filter_moving_header", "String");
            a.item("Igx_grid_excel_filter_sorting_asc", "String");
            a.item("Igx_grid_excel_filter_sorting_asc_short", "String");
            a.item("Igx_grid_excel_filter_sorting_desc", "String");
            a.item("Igx_grid_excel_filter_sorting_desc_short", "String");
            a.item("Igx_grid_excel_filter_sorting_header", "String");
            a.item("Igx_grid_excel_filter_clear", "String");
            a.item("Igx_grid_excel_custom_dialog_add", "String");
            a.item("Igx_grid_excel_custom_dialog_clear", "String");
            a.item("Igx_grid_excel_custom_dialog_header", "String");
            a.item("Igx_grid_excel_cancel", "String");
            a.item("Igx_grid_excel_apply", "String");
            a.item("Igx_grid_excel_search_placeholder", "String");
            a.item("Igx_grid_excel_select_all", "String");
            a.item("Igx_grid_excel_select_all_search_results", "String");
            a.item("Igx_grid_excel_add_to_filter", "String");
            a.item("Igx_grid_excel_blanks", "String");
            a.item("Igx_grid_excel_hide", "String");
            a.item("Igx_grid_excel_show", "String");
            a.item("Igx_grid_excel_pin", "String");
            a.item("Igx_grid_excel_unpin", "String");
            a.item("Igx_grid_excel_select", "String");
            a.item("Igx_grid_excel_deselect", "String");
            a.item("Igx_grid_excel_text_filter", "String");
            a.item("Igx_grid_excel_number_filter", "String");
            a.item("Igx_grid_excel_date_filter", "String");
            a.item("Igx_grid_excel_boolean_filter", "String");
            a.item("Igx_grid_excel_currency_filter", "String");
            a.item("Igx_grid_excel_custom_filter", "String");
            a.item("Igx_grid_excel_no_matches", "String");
            a.item("Igx_grid_excel_matches_count", "String");
            a.item("Igx_grid_advanced_filter_title", "String");
            a.item("Igx_grid_advanced_filter_and_group", "String");
            a.item("Igx_grid_advanced_filter_or_group", "String");
            a.item("Igx_grid_advanced_filter_end_group", "String");
            a.item("Igx_grid_advanced_filter_create_and_group", "String");
            a.item("Igx_grid_advanced_filter_create_or_group", "String");
            a.item("Igx_grid_advanced_filter_and_label", "String");
            a.item("Igx_grid_advanced_filter_or_label", "String");
            a.item("Igx_grid_advanced_filter_add_condition", "String");
            a.item("Igx_grid_advanced_filter_ungroup", "String");
            a.item("Igx_grid_advanced_filter_delete", "String");
            a.item("Igx_grid_advanced_filter_delete_filters", "String");
            a.item("Igx_grid_advanced_filter_initial_text", "String");
            a.item("Igx_grid_advanced_filter_column_placeholder", "String");
            a.item("Igx_grid_advanced_filter_value_placeholder", "String");
            a.item("Igx_grid_pinned_row_indicator", "String");
            a.item("Igx_grid_hiding_check_all_label", "String");
            a.item("Igx_grid_hiding_uncheck_all_label", "String");
            a.item("Igx_grid_pinning_check_all_label", "String");
            a.item("Igx_grid_pinning_uncheck_all_label", "String");
            a.item("Igx_grid_row_edit_btn_done", "String");
            a.item("Igx_grid_row_edit_btn_cancel", "String");
            a.item("Igx_grid_toolbar_actions_filter_prompt", "String");
            a.item("Igx_grid_toolbar_pinning_button_tooltip", "String");
            a.item("Igx_grid_toolbar_hiding_button_tooltip", "String");
            a.item("Igx_grid_toolbar_pinning_title", "String");
            a.item("Igx_grid_toolbar_hiding_title", "String");
            a.item("Igx_grid_toolbar_advanced_filtering_button_tooltip", "String");
            a.item("Igx_grid_toolbar_advanced_filtering_button_label", "String");
            a.item("Igx_grid_toolbar_exporter_button_tooltip", "String");
            a.item("Igx_grid_toolbar_exporter_button_label", "String");
            a.item("Igx_grid_toolbar_exporter_excel_entry_text", "String");
            a.item("Igx_grid_toolbar_exporter_csv_entry_text", "String");
            a.item("Igx_grid_snackbar_addrow_label", "String");
            a.item("Igx_grid_snackbar_addrow_actiontext", "String");
            a.item("Igx_grid_actions_edit_label", "String");
            a.item("Igx_grid_actions_add_label", "String");
            a.item("Igx_grid_add_row_label", "String");
            a.item("Igx_grid_actions_add_child_label", "String");
            a.item("Igx_grid_actions_delete_label", "String");
            a.item("Igx_grid_actions_pin_label", "String");
            a.item("Igx_grid_actions_unpin_label", "String");
            a.item("Igx_grid_actions_jumpUp_label", "String");
            a.item("Igx_grid_actions_jumpDown_label", "String");
            a.item("Igx_grid_pivot_date_dimension_total", "String");
            a.item("Igx_grid_pivot_aggregate_count", "String");
            a.item("Igx_grid_pivot_aggregate_min", "String");
            a.item("Igx_grid_pivot_aggregate_max", "String");
            a.item("Igx_grid_pivot_aggregate_sum", "String");
            a.item("Igx_grid_pivot_aggregate_avg", "String");
            a.item("Igx_grid_pivot_aggregate_date_latest", "String");
            a.item("Igx_grid_pivot_aggregate_date_earliest", "String");
            a.item("Igx_grid_pivot_aggregate_time_latest", "String");
            a.item("Igx_grid_pivot_aggregate_time_earliest", "String");
            a.item("Igx_grid_pivot_empty_row_drop_area", "String");
            a.item("Igx_grid_pivot_empty_column_drop_area", "String");
            a.item("Igx_grid_pivot_empty_filter_drop_area", "String");
            a.item("Igx_grid_pivot_empty_value_drop_area", "String");
            a.item("Igx_grid_pivot_row_drop_chip", "String");
            a.item("Igx_grid_pivot_column_drop_chip", "String");
            a.item("Igx_grid_pivot_filter_drop_chip", "String");
            a.item("Igx_grid_pivot_value_drop_chip", "String");
            a.item("Igx_grid_pivot_empty_message", "String");
            a.item("Igx_grid_pivot_selector_filters", "String");
            a.item("Igx_grid_pivot_selector_rows", "String");
            a.item("Igx_grid_pivot_selector_columns", "String");
            a.item("Igx_grid_pivot_selector_values", "String");
            a.item("Igx_grid_pivot_selector_panel_empty", "String");
            a.item("Igx_grid_required_validation_error", "String");
            a.item("Igx_grid_min_validation_error", "String");
            a.item("Igx_grid_max_validation_error", "String");
            a.item("Igx_grid_min_length_validation_error", "String");
            a.item("Igx_grid_max_length_validation_error", "String");
            a.item("Igx_grid_email_validation_error", "String");
            a.item("Igx_grid_pattern_validation_error", "String");
        }
        static d(a) {
            WebGridResourceStringsDescriptionMetadata.b(a);
            a.ae("WebGridResourceStrings", () => new WebGridResourceStringsDescription());
            a.ad("WebGridResourceStrings", WebGridResourceStringsDescriptionMetadata.a);
        }
    }
    WebGridResourceStringsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridResourceStringsDescriptionMetadata, 'WebGridResourceStringsDescriptionMetadata');
    WebGridResourceStringsDescriptionMetadata.a = null;
    return WebGridResourceStringsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringExpressionsTreeOrFilteringExpressionDescription = /*@__PURE__*/ (() => {
    class WebFilteringExpressionsTreeOrFilteringExpressionDescription extends Description {
        get_type() {
            return "WebFilteringExpressionsTreeOrFilteringExpression";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebFilteringExpressionsTreeOrFilteringExpressionDescription.$t = /*@__PURE__*/ markType(WebFilteringExpressionsTreeOrFilteringExpressionDescription, 'WebFilteringExpressionsTreeOrFilteringExpressionDescription', Description.$);
    return WebFilteringExpressionsTreeOrFilteringExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata.a == null) {
                WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata.c(WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata.a);
            }
            if (a.k(WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FilteringExpressionsTreeOrFilteringExpression");
        }
        static d(a) {
            WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata.b(a);
            a.ae("WebFilteringExpressionsTreeOrFilteringExpression", () => new WebFilteringExpressionsTreeOrFilteringExpressionDescription());
            a.ad("WebFilteringExpressionsTreeOrFilteringExpression", WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata.a);
        }
    }
    WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata, 'WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata');
    WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata.a = null;
    return WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringExpressionsTreeDescription = /*@__PURE__*/ (() => {
    class WebFilteringExpressionsTreeDescription extends Description {
        get_type() {
            return "WebFilteringExpressionsTree";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.p = null;
            this.k = null;
            this.o = null;
            this.n = null;
        }
        get filteringOperands() {
            return this.h;
        }
        set filteringOperands(a) {
            this.h = a;
            this.g("FilteringOperands");
        }
        get treeType() {
            return this.p;
        }
        set treeType(a) {
            this.p = a;
            this.g("TreeType");
        }
        get owner() {
            return this.k;
        }
        set owner(a) {
            this.k = a;
            this.g("Owner");
        }
        get operator() {
            return this.o;
        }
        set operator(a) {
            this.o = a;
            this.g("Operator");
        }
        get fieldName() {
            return this.n;
        }
        set fieldName(a) {
            this.n = a;
            this.g("FieldName");
        }
    }
    WebFilteringExpressionsTreeDescription.$t = /*@__PURE__*/ markType(WebFilteringExpressionsTreeDescription, 'WebFilteringExpressionsTreeDescription', Description.$);
    WebFilteringExpressionsTreeDescription.__marshalByValue = true;
    WebFilteringExpressionsTreeDescription.__marshalByValueAlias = "FilteringExpressionsTree";
    return WebFilteringExpressionsTreeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringExpressionsTreeDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFilteringExpressionsTreeDescriptionMetadata extends Base {
        static b(a) {
            if (WebFilteringExpressionsTreeDescriptionMetadata.a == null) {
                WebFilteringExpressionsTreeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFilteringExpressionsTreeDescriptionMetadata.c(WebFilteringExpressionsTreeDescriptionMetadata.a);
            }
            if (a.k(WebFilteringExpressionsTreeDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFilteringExpressionsTreeDescriptionMetadata.a);
            WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FilteringExpressionsTree");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("FilteringOperands", "Array:WebFilteringExpressionsTreeOrFilteringExpressionDescription:FilteringExpressionsTreeOrFilteringExpression");
            a.item("TreeType", "(wc:Type)ExportedType:string:FilteringExpressionsTreeType");
            a.item("TreeType@names", "Regular;Advanced");
            a.item("Owner", "Unknown");
            a.item("Operator", "ExportedType:string:FilteringLogic");
            a.item("Operator@names", "And;Or");
            a.item("FieldName", "String");
        }
        static d(a) {
            WebFilteringExpressionsTreeDescriptionMetadata.b(a);
            a.ae("WebFilteringExpressionsTree", () => new WebFilteringExpressionsTreeDescription());
            a.ad("WebFilteringExpressionsTree", WebFilteringExpressionsTreeDescriptionMetadata.a);
        }
    }
    WebFilteringExpressionsTreeDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFilteringExpressionsTreeDescriptionMetadata, 'WebFilteringExpressionsTreeDescriptionMetadata');
    WebFilteringExpressionsTreeDescriptionMetadata.a = null;
    return WebFilteringExpressionsTreeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPinningConfigDescription = /*@__PURE__*/ (() => {
    class WebPinningConfigDescription extends Description {
        get_type() {
            return "WebPinningConfig";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.k = null;
        }
        get columns() {
            return this.j;
        }
        set columns(a) {
            this.j = a;
            this.g("Columns");
        }
        get rows() {
            return this.k;
        }
        set rows(a) {
            this.k = a;
            this.g("Rows");
        }
    }
    WebPinningConfigDescription.$t = /*@__PURE__*/ markType(WebPinningConfigDescription, 'WebPinningConfigDescription', Description.$);
    WebPinningConfigDescription.__marshalByValue = true;
    WebPinningConfigDescription.__marshalByValueAlias = "PinningConfig";
    return WebPinningConfigDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPinningConfigDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPinningConfigDescriptionMetadata extends Base {
        static b(a) {
            if (WebPinningConfigDescriptionMetadata.a == null) {
                WebPinningConfigDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPinningConfigDescriptionMetadata.c(WebPinningConfigDescriptionMetadata.a);
            }
            if (a.k(WebPinningConfigDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPinningConfigDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PinningConfig");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("Columns", "ExportedType:string:ColumnPinningPosition");
            a.item("Columns@names", "Start;End");
            a.item("Rows", "ExportedType:string:RowPinningPosition");
            a.item("Rows@names", "Top;Bottom");
        }
        static d(a) {
            WebPinningConfigDescriptionMetadata.b(a);
            a.ae("WebPinningConfig", () => new WebPinningConfigDescription());
            a.ad("WebPinningConfig", WebPinningConfigDescriptionMetadata.a);
        }
    }
    WebPinningConfigDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPinningConfigDescriptionMetadata, 'WebPinningConfigDescriptionMetadata');
    WebPinningConfigDescriptionMetadata.a = null;
    return WebPinningConfigDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringStrategyDescription = /*@__PURE__*/ (() => {
    class WebFilteringStrategyDescription extends Description {
        get_type() {
            return "WebFilteringStrategy";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebFilteringStrategyDescription.$t = /*@__PURE__*/ markType(WebFilteringStrategyDescription, 'WebFilteringStrategyDescription', Description.$);
    return WebFilteringStrategyDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringStrategyDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFilteringStrategyDescriptionMetadata extends Base {
        static b(a) {
            if (WebFilteringStrategyDescriptionMetadata.a == null) {
                WebFilteringStrategyDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFilteringStrategyDescriptionMetadata.c(WebFilteringStrategyDescriptionMetadata.a);
            }
            if (a.k(WebFilteringStrategyDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFilteringStrategyDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FilteringStrategy");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebFilteringStrategyDescriptionMetadata.b(a);
            a.ae("WebFilteringStrategy", () => new WebFilteringStrategyDescription());
            a.ad("WebFilteringStrategy", WebFilteringStrategyDescriptionMetadata.a);
        }
    }
    WebFilteringStrategyDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFilteringStrategyDescriptionMetadata, 'WebFilteringStrategyDescriptionMetadata');
    WebFilteringStrategyDescriptionMetadata.a = null;
    return WebFilteringStrategyDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridSortingStrategyDescription = /*@__PURE__*/ (() => {
    class WebGridSortingStrategyDescription extends Description {
        get_type() {
            return "WebGridSortingStrategy";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebGridSortingStrategyDescription.$t = /*@__PURE__*/ markType(WebGridSortingStrategyDescription, 'WebGridSortingStrategyDescription', Description.$);
    return WebGridSortingStrategyDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridSortingStrategyDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridSortingStrategyDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridSortingStrategyDescriptionMetadata.a == null) {
                WebGridSortingStrategyDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridSortingStrategyDescriptionMetadata.c(WebGridSortingStrategyDescriptionMetadata.a);
            }
            if (a.k(WebGridSortingStrategyDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridSortingStrategyDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridSortingStrategy");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebGridSortingStrategyDescriptionMetadata.b(a);
            a.ae("WebGridSortingStrategy", () => new WebGridSortingStrategyDescription());
            a.ad("WebGridSortingStrategy", WebGridSortingStrategyDescriptionMetadata.a);
        }
    }
    WebGridSortingStrategyDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridSortingStrategyDescriptionMetadata, 'WebGridSortingStrategyDescriptionMetadata');
    WebGridSortingStrategyDescriptionMetadata.a = null;
    return WebGridSortingStrategyDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSortingOptionsDescription = /*@__PURE__*/ (() => {
    class WebSortingOptionsDescription extends Description {
        get_type() {
            return "WebSortingOptions";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get mode() {
            return this.h;
        }
        set mode(a) {
            this.h = a;
            this.g("Mode");
        }
    }
    WebSortingOptionsDescription.$t = /*@__PURE__*/ markType(WebSortingOptionsDescription, 'WebSortingOptionsDescription', Description.$);
    return WebSortingOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSortingOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSortingOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (WebSortingOptionsDescriptionMetadata.a == null) {
                WebSortingOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSortingOptionsDescriptionMetadata.c(WebSortingOptionsDescriptionMetadata.a);
            }
            if (a.k(WebSortingOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSortingOptionsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:SortingOptions");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Mode", "ExportedType:string:SortingOptionsMode");
            a.item("Mode@stringUnion", "WebComponents;React");
            a.item("Mode@names", "Single;Multiple");
        }
        static d(a) {
            WebSortingOptionsDescriptionMetadata.b(a);
            a.ae("WebSortingOptions", () => new WebSortingOptionsDescription());
            a.ad("WebSortingOptions", WebSortingOptionsDescriptionMetadata.a);
        }
    }
    WebSortingOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSortingOptionsDescriptionMetadata, 'WebSortingOptionsDescriptionMetadata');
    WebSortingOptionsDescriptionMetadata.a = null;
    return WebSortingOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSortingExpressionDescription = /*@__PURE__*/ (() => {
    class WebSortingExpressionDescription extends WebBaseEventArgsDescription {
        get_type() {
            return "WebSortingExpression";
        }
        constructor() {
            super();
            this.t = null;
            this.s = null;
            this.p = false;
            this.m = null;
        }
        get fieldName() {
            return this.t;
        }
        set fieldName(a) {
            this.t = a;
            this.g("FieldName");
        }
        get dir() {
            return this.s;
        }
        set dir(a) {
            this.s = a;
            this.g("Dir");
        }
        get ignoreCase() {
            return this.p;
        }
        set ignoreCase(a) {
            this.p = a;
            this.g("IgnoreCase");
        }
        get strategy() {
            return this.m;
        }
        set strategy(a) {
            this.m = a;
            this.g("Strategy");
        }
    }
    WebSortingExpressionDescription.$t = /*@__PURE__*/ markType(WebSortingExpressionDescription, 'WebSortingExpressionDescription', WebBaseEventArgsDescription.$);
    WebSortingExpressionDescription.__marshalByValue1 = true;
    WebSortingExpressionDescription.__marshalByValueAlias1 = "SortingExpression";
    return WebSortingExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSortingExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSortingExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (WebSortingExpressionDescriptionMetadata.a == null) {
                WebSortingExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSortingExpressionDescriptionMetadata.c(WebSortingExpressionDescriptionMetadata.a);
            }
            if (a.k(WebSortingExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSortingExpressionDescriptionMetadata.a);
            WebSortingStrategyDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:SortingExpression");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("FieldName", "String");
            a.item("Dir", "ExportedType:string:SortingDirection");
            a.item("Dir@names", "None;Asc;Desc");
            a.item("Dir@constantValues", "0;1;2");
            a.item("IgnoreCase", "Boolean");
            a.item("Strategy", "ExportedType:WebSortingStrategy");
        }
        static d(a) {
            WebSortingExpressionDescriptionMetadata.b(a);
            a.ae("WebSortingExpression", () => new WebSortingExpressionDescription());
            a.ad("WebSortingExpression", WebSortingExpressionDescriptionMetadata.a);
        }
    }
    WebSortingExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSortingExpressionDescriptionMetadata, 'WebSortingExpressionDescriptionMetadata');
    WebSortingExpressionDescriptionMetadata.a = null;
    return WebSortingExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebOverlayOutletDirectiveDescription = /*@__PURE__*/ (() => {
    class WebOverlayOutletDirectiveDescription extends Description {
        get_type() {
            return "WebOverlayOutletDirective";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebOverlayOutletDirectiveDescription.$t = /*@__PURE__*/ markType(WebOverlayOutletDirectiveDescription, 'WebOverlayOutletDirectiveDescription', Description.$);
    return WebOverlayOutletDirectiveDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebOverlayOutletDirectiveDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebOverlayOutletDirectiveDescriptionMetadata extends Base {
        static b(a) {
            if (WebOverlayOutletDirectiveDescriptionMetadata.a == null) {
                WebOverlayOutletDirectiveDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebOverlayOutletDirectiveDescriptionMetadata.c(WebOverlayOutletDirectiveDescriptionMetadata.a);
            }
            if (a.k(WebOverlayOutletDirectiveDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebOverlayOutletDirectiveDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:OverlayOutletDirective");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebOverlayOutletDirectiveDescriptionMetadata.b(a);
            a.ae("WebOverlayOutletDirective", () => new WebOverlayOutletDirectiveDescription());
            a.ad("WebOverlayOutletDirective", WebOverlayOutletDirectiveDescriptionMetadata.a);
        }
    }
    WebOverlayOutletDirectiveDescriptionMetadata.$t = /*@__PURE__*/ markType(WebOverlayOutletDirectiveDescriptionMetadata, 'WebOverlayOutletDirectiveDescriptionMetadata');
    WebOverlayOutletDirectiveDescriptionMetadata.a = null;
    return WebOverlayOutletDirectiveDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringExpressionsTreeDetailDescription = /*@__PURE__*/ (() => {
    class WebFilteringExpressionsTreeDetailDescription extends Description {
        get_type() {
            return "WebFilteringExpressionsTreeDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.p = null;
            this.k = null;
            this.o = null;
            this.n = null;
        }
        get filteringOperands() {
            return this.h;
        }
        set filteringOperands(a) {
            this.h = a;
            this.g("FilteringOperands");
        }
        get treeType() {
            return this.p;
        }
        set treeType(a) {
            this.p = a;
            this.g("TreeType");
        }
        get owner() {
            return this.k;
        }
        set owner(a) {
            this.k = a;
            this.g("Owner");
        }
        get operator() {
            return this.o;
        }
        set operator(a) {
            this.o = a;
            this.g("Operator");
        }
        get fieldName() {
            return this.n;
        }
        set fieldName(a) {
            this.n = a;
            this.g("FieldName");
        }
    }
    WebFilteringExpressionsTreeDetailDescription.$t = /*@__PURE__*/ markType(WebFilteringExpressionsTreeDetailDescription, 'WebFilteringExpressionsTreeDetailDescription', Description.$);
    WebFilteringExpressionsTreeDetailDescription.__marshalByValue = true;
    WebFilteringExpressionsTreeDetailDescription.__marshalByValueAlias = "FilteringExpressionsTreeDetail";
    return WebFilteringExpressionsTreeDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringExpressionsTreeDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFilteringExpressionsTreeDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebFilteringExpressionsTreeDetailDescriptionMetadata.a == null) {
                WebFilteringExpressionsTreeDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFilteringExpressionsTreeDetailDescriptionMetadata.c(WebFilteringExpressionsTreeDetailDescriptionMetadata.a);
            }
            if (a.k(WebFilteringExpressionsTreeDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFilteringExpressionsTreeDetailDescriptionMetadata.a);
            WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FilteringExpressionsTreeDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("FilteringOperands", "Array:WebFilteringExpressionsTreeOrFilteringExpressionDescription:FilteringExpressionsTreeOrFilteringExpression");
            a.item("TreeType", "(wc:Type)ExportedType:string:FilteringExpressionsTreeType");
            a.item("TreeType@names", "Regular;Advanced");
            a.item("Owner", "Unknown");
            a.item("Operator", "ExportedType:string:FilteringLogic");
            a.item("Operator@names", "And;Or");
            a.item("FieldName", "String");
        }
        static d(a) {
            WebFilteringExpressionsTreeDetailDescriptionMetadata.b(a);
            a.ae("WebFilteringExpressionsTreeDetail", () => new WebFilteringExpressionsTreeDetailDescription());
            a.ad("WebFilteringExpressionsTreeDetail", WebFilteringExpressionsTreeDetailDescriptionMetadata.a);
        }
    }
    WebFilteringExpressionsTreeDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFilteringExpressionsTreeDetailDescriptionMetadata, 'WebFilteringExpressionsTreeDetailDescriptionMetadata');
    WebFilteringExpressionsTreeDetailDescriptionMetadata.a = null;
    return WebFilteringExpressionsTreeDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringExpressionsTreeEventArgsDescription = /*@__PURE__*/ (() => {
    class WebFilteringExpressionsTreeEventArgsDescription extends Description {
        get_type() {
            return "WebFilteringExpressionsTreeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebFilteringExpressionsTreeEventArgsDescription.$t = /*@__PURE__*/ markType(WebFilteringExpressionsTreeEventArgsDescription, 'WebFilteringExpressionsTreeEventArgsDescription', Description.$);
    WebFilteringExpressionsTreeEventArgsDescription.__marshalByValue = true;
    WebFilteringExpressionsTreeEventArgsDescription.__marshalByValueAlias = "FilteringExpressionsTreeEventArgs";
    return WebFilteringExpressionsTreeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringExpressionsTreeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFilteringExpressionsTreeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebFilteringExpressionsTreeEventArgsDescriptionMetadata.a == null) {
                WebFilteringExpressionsTreeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFilteringExpressionsTreeEventArgsDescriptionMetadata.c(WebFilteringExpressionsTreeEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebFilteringExpressionsTreeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFilteringExpressionsTreeEventArgsDescriptionMetadata.a);
            WebFilteringExpressionsTreeDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FilteringExpressionsTreeEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebFilteringExpressionsTreeDetail");
        }
        static d(a) {
            WebFilteringExpressionsTreeEventArgsDescriptionMetadata.b(a);
            a.ae("WebFilteringExpressionsTreeEventArgs", () => new WebFilteringExpressionsTreeEventArgsDescription());
            a.ad("WebFilteringExpressionsTreeEventArgs", WebFilteringExpressionsTreeEventArgsDescriptionMetadata.a);
        }
    }
    WebFilteringExpressionsTreeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFilteringExpressionsTreeEventArgsDescriptionMetadata, 'WebFilteringExpressionsTreeEventArgsDescriptionMetadata');
    WebFilteringExpressionsTreeEventArgsDescriptionMetadata.a = null;
    return WebFilteringExpressionsTreeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridScrollEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebGridScrollEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebGridScrollEventArgsDetail";
        }
        constructor() {
            super();
            this.s = null;
            this.p = null;
            this.n = 0;
        }
        get direction() {
            return this.s;
        }
        set direction(a) {
            this.s = a;
            this.g("Direction");
        }
        get event() {
            return this.p;
        }
        set event(a) {
            this.p = a;
            this.g("Event");
        }
        get scrollPosition() {
            return this.n;
        }
        set scrollPosition(a) {
            this.n = a;
            this.g("ScrollPosition");
        }
    }
    WebGridScrollEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebGridScrollEventArgsDetailDescription, 'WebGridScrollEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebGridScrollEventArgsDetailDescription.__marshalByValue1 = true;
    WebGridScrollEventArgsDetailDescription.__marshalByValueAlias1 = "GridScrollEventArgsDetail";
    return WebGridScrollEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridScrollEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridScrollEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridScrollEventArgsDetailDescriptionMetadata.a == null) {
                WebGridScrollEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridScrollEventArgsDetailDescriptionMetadata.c(WebGridScrollEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebGridScrollEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridScrollEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridScrollEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Direction", "String");
            a.item("Event", "Unknown");
            a.item("ScrollPosition", "Number:double");
        }
        static d(a) {
            WebGridScrollEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebGridScrollEventArgsDetail", () => new WebGridScrollEventArgsDetailDescription());
            a.ad("WebGridScrollEventArgsDetail", WebGridScrollEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebGridScrollEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridScrollEventArgsDetailDescriptionMetadata, 'WebGridScrollEventArgsDetailDescriptionMetadata');
    WebGridScrollEventArgsDetailDescriptionMetadata.a = null;
    return WebGridScrollEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridScrollEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGridScrollEventArgsDescription extends Description {
        get_type() {
            return "WebGridScrollEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGridScrollEventArgsDescription.$t = /*@__PURE__*/ markType(WebGridScrollEventArgsDescription, 'WebGridScrollEventArgsDescription', Description.$);
    WebGridScrollEventArgsDescription.__marshalByValue = true;
    WebGridScrollEventArgsDescription.__marshalByValueAlias = "GridScrollEventArgs";
    return WebGridScrollEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridScrollEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridScrollEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridScrollEventArgsDescriptionMetadata.a == null) {
                WebGridScrollEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridScrollEventArgsDescriptionMetadata.c(WebGridScrollEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGridScrollEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridScrollEventArgsDescriptionMetadata.a);
            WebGridScrollEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridScrollEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebGridScrollEventArgsDetail");
        }
        static d(a) {
            WebGridScrollEventArgsDescriptionMetadata.b(a);
            a.ae("WebGridScrollEventArgs", () => new WebGridScrollEventArgsDescription());
            a.ad("WebGridScrollEventArgs", WebGridScrollEventArgsDescriptionMetadata.a);
        }
    }
    WebGridScrollEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridScrollEventArgsDescriptionMetadata, 'WebGridScrollEventArgsDescriptionMetadata');
    WebGridScrollEventArgsDescriptionMetadata.a = null;
    return WebGridScrollEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowSelectionEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebRowSelectionEventArgsDetailDescription extends Description {
        get_type() {
            return "WebRowSelectionEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.r = null;
            this.q = null;
            this.p = null;
            this.s = null;
            this.i = false;
            this.j = false;
            this.m = null;
        }
        get oldSelectionRef() {
            return this.r;
        }
        set oldSelectionRef(a) {
            this.r = a;
            this.g("OldSelectionRef");
        }
        get newSelectionRef() {
            return this.q;
        }
        set newSelectionRef(a) {
            this.q = a;
            this.g("NewSelectionRef");
        }
        get addedRef() {
            return this.p;
        }
        set addedRef(a) {
            this.p = a;
            this.g("AddedRef");
        }
        get removedRef() {
            return this.s;
        }
        set removedRef(a) {
            this.s = a;
            this.g("RemovedRef");
        }
        get allRowsSelected() {
            return this.i;
        }
        set allRowsSelected(a) {
            this.i = a;
            this.g("AllRowsSelected");
        }
        get cancel() {
            return this.j;
        }
        set cancel(a) {
            this.j = a;
            this.g("Cancel");
        }
        get owner() {
            return this.m;
        }
        set owner(a) {
            this.m = a;
            this.g("Owner");
        }
    }
    WebRowSelectionEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebRowSelectionEventArgsDetailDescription, 'WebRowSelectionEventArgsDetailDescription', Description.$);
    WebRowSelectionEventArgsDetailDescription.__marshalByValue = true;
    WebRowSelectionEventArgsDetailDescription.__marshalByValueAlias = "RowSelectionEventArgsDetail";
    return WebRowSelectionEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowSelectionEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowSelectionEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowSelectionEventArgsDetailDescriptionMetadata.a == null) {
                WebRowSelectionEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowSelectionEventArgsDetailDescriptionMetadata.c(WebRowSelectionEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebRowSelectionEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowSelectionEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowSelectionEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("OldSelectionRef", "(w:OldSelection,wf:OldSelection)DataRef:object");
            a.item("NewSelectionRef", "(w:NewSelection,wf:NewSelection)DataRef:object");
            a.item("AddedRef", "(w:Added,wf:Added)DataRef:object");
            a.item("RemovedRef", "(w:Removed,wf:Removed)DataRef:object");
            a.item("AllRowsSelected", "Boolean");
            a.item("Cancel", "Boolean");
            a.item("Owner", "Unknown");
        }
        static d(a) {
            WebRowSelectionEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebRowSelectionEventArgsDetail", () => new WebRowSelectionEventArgsDetailDescription());
            a.ad("WebRowSelectionEventArgsDetail", WebRowSelectionEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebRowSelectionEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowSelectionEventArgsDetailDescriptionMetadata, 'WebRowSelectionEventArgsDetailDescriptionMetadata');
    WebRowSelectionEventArgsDetailDescriptionMetadata.a = null;
    return WebRowSelectionEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowSelectionEventArgsDescription = /*@__PURE__*/ (() => {
    class WebRowSelectionEventArgsDescription extends Description {
        get_type() {
            return "WebRowSelectionEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebRowSelectionEventArgsDescription.$t = /*@__PURE__*/ markType(WebRowSelectionEventArgsDescription, 'WebRowSelectionEventArgsDescription', Description.$);
    WebRowSelectionEventArgsDescription.__marshalByValue = true;
    WebRowSelectionEventArgsDescription.__marshalByValueAlias = "RowSelectionEventArgs";
    return WebRowSelectionEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowSelectionEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowSelectionEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowSelectionEventArgsDescriptionMetadata.a == null) {
                WebRowSelectionEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowSelectionEventArgsDescriptionMetadata.c(WebRowSelectionEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebRowSelectionEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowSelectionEventArgsDescriptionMetadata.a);
            WebRowSelectionEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowSelectionEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebRowSelectionEventArgsDetail");
        }
        static d(a) {
            WebRowSelectionEventArgsDescriptionMetadata.b(a);
            a.ae("WebRowSelectionEventArgs", () => new WebRowSelectionEventArgsDescription());
            a.ad("WebRowSelectionEventArgs", WebRowSelectionEventArgsDescriptionMetadata.a);
        }
    }
    WebRowSelectionEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowSelectionEventArgsDescriptionMetadata, 'WebRowSelectionEventArgsDescriptionMetadata');
    WebRowSelectionEventArgsDescriptionMetadata.a = null;
    return WebRowSelectionEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnSelectionEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebColumnSelectionEventArgsDetailDescription extends Description {
        get_type() {
            return "WebColumnSelectionEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.i = null;
            this.h = null;
            this.k = null;
            this.q = false;
            this.s = null;
        }
        get oldSelection() {
            return this.j;
        }
        set oldSelection(a) {
            this.j = a;
            this.g("OldSelection");
        }
        get newSelection() {
            return this.i;
        }
        set newSelection(a) {
            this.i = a;
            this.g("NewSelection");
        }
        get added() {
            return this.h;
        }
        set added(a) {
            this.h = a;
            this.g("Added");
        }
        get removed() {
            return this.k;
        }
        set removed(a) {
            this.k = a;
            this.g("Removed");
        }
        get cancel() {
            return this.q;
        }
        set cancel(a) {
            this.q = a;
            this.g("Cancel");
        }
        get owner() {
            return this.s;
        }
        set owner(a) {
            this.s = a;
            this.g("Owner");
        }
    }
    WebColumnSelectionEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebColumnSelectionEventArgsDetailDescription, 'WebColumnSelectionEventArgsDetailDescription', Description.$);
    WebColumnSelectionEventArgsDetailDescription.__marshalByValue = true;
    WebColumnSelectionEventArgsDetailDescription.__marshalByValueAlias = "ColumnSelectionEventArgsDetail";
    return WebColumnSelectionEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnSelectionEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnSelectionEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnSelectionEventArgsDetailDescriptionMetadata.a == null) {
                WebColumnSelectionEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnSelectionEventArgsDetailDescriptionMetadata.c(WebColumnSelectionEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebColumnSelectionEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnSelectionEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnSelectionEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("OldSelection", "Array:string");
            a.item("NewSelection", "Array:string");
            a.item("Added", "Array:string");
            a.item("Removed", "Array:string");
            a.item("Cancel", "Boolean");
            a.item("Owner", "Unknown");
        }
        static d(a) {
            WebColumnSelectionEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebColumnSelectionEventArgsDetail", () => new WebColumnSelectionEventArgsDetailDescription());
            a.ad("WebColumnSelectionEventArgsDetail", WebColumnSelectionEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebColumnSelectionEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnSelectionEventArgsDetailDescriptionMetadata, 'WebColumnSelectionEventArgsDetailDescriptionMetadata');
    WebColumnSelectionEventArgsDetailDescriptionMetadata.a = null;
    return WebColumnSelectionEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnSelectionEventArgsDescription = /*@__PURE__*/ (() => {
    class WebColumnSelectionEventArgsDescription extends Description {
        get_type() {
            return "WebColumnSelectionEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebColumnSelectionEventArgsDescription.$t = /*@__PURE__*/ markType(WebColumnSelectionEventArgsDescription, 'WebColumnSelectionEventArgsDescription', Description.$);
    WebColumnSelectionEventArgsDescription.__marshalByValue = true;
    WebColumnSelectionEventArgsDescription.__marshalByValueAlias = "ColumnSelectionEventArgs";
    return WebColumnSelectionEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnSelectionEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnSelectionEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnSelectionEventArgsDescriptionMetadata.a == null) {
                WebColumnSelectionEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnSelectionEventArgsDescriptionMetadata.c(WebColumnSelectionEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebColumnSelectionEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnSelectionEventArgsDescriptionMetadata.a);
            WebColumnSelectionEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnSelectionEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebColumnSelectionEventArgsDetail");
        }
        static d(a) {
            WebColumnSelectionEventArgsDescriptionMetadata.b(a);
            a.ae("WebColumnSelectionEventArgs", () => new WebColumnSelectionEventArgsDescription());
            a.ad("WebColumnSelectionEventArgs", WebColumnSelectionEventArgsDescriptionMetadata.a);
        }
    }
    WebColumnSelectionEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnSelectionEventArgsDescriptionMetadata, 'WebColumnSelectionEventArgsDescriptionMetadata');
    WebColumnSelectionEventArgsDescriptionMetadata.a = null;
    return WebColumnSelectionEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPinColumnCancellableEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebPinColumnCancellableEventArgsDetailDescription extends Description {
        get_type() {
            return "WebPinColumnCancellableEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.o = 0;
            this.l = false;
            this.k = false;
        }
        get column() {
            return this.h;
        }
        set column(a) {
            this.h = a;
            this.g("Column");
        }
        get insertAtIndex() {
            return this.o;
        }
        set insertAtIndex(a) {
            this.o = a;
            this.g("InsertAtIndex");
        }
        get isPinned() {
            return this.l;
        }
        set isPinned(a) {
            this.l = a;
            this.g("IsPinned");
        }
        get cancel() {
            return this.k;
        }
        set cancel(a) {
            this.k = a;
            this.g("Cancel");
        }
    }
    WebPinColumnCancellableEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebPinColumnCancellableEventArgsDetailDescription, 'WebPinColumnCancellableEventArgsDetailDescription', Description.$);
    WebPinColumnCancellableEventArgsDetailDescription.__marshalByValue = true;
    WebPinColumnCancellableEventArgsDetailDescription.__marshalByValueAlias = "PinColumnCancellableEventArgsDetail";
    return WebPinColumnCancellableEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPinColumnCancellableEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPinColumnCancellableEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebPinColumnCancellableEventArgsDetailDescriptionMetadata.a == null) {
                WebPinColumnCancellableEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPinColumnCancellableEventArgsDetailDescriptionMetadata.c(WebPinColumnCancellableEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebPinColumnCancellableEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPinColumnCancellableEventArgsDetailDescriptionMetadata.a);
            WebColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PinColumnCancellableEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Column", "ExportedType:WebColumn");
            a.item("InsertAtIndex", "Number:double");
            a.item("IsPinned", "Boolean");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebPinColumnCancellableEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebPinColumnCancellableEventArgsDetail", () => new WebPinColumnCancellableEventArgsDetailDescription());
            a.ad("WebPinColumnCancellableEventArgsDetail", WebPinColumnCancellableEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebPinColumnCancellableEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPinColumnCancellableEventArgsDetailDescriptionMetadata, 'WebPinColumnCancellableEventArgsDetailDescriptionMetadata');
    WebPinColumnCancellableEventArgsDetailDescriptionMetadata.a = null;
    return WebPinColumnCancellableEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPinColumnCancellableEventArgsDescription = /*@__PURE__*/ (() => {
    class WebPinColumnCancellableEventArgsDescription extends Description {
        get_type() {
            return "WebPinColumnCancellableEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebPinColumnCancellableEventArgsDescription.$t = /*@__PURE__*/ markType(WebPinColumnCancellableEventArgsDescription, 'WebPinColumnCancellableEventArgsDescription', Description.$);
    WebPinColumnCancellableEventArgsDescription.__marshalByValue = true;
    WebPinColumnCancellableEventArgsDescription.__marshalByValueAlias = "PinColumnCancellableEventArgs";
    return WebPinColumnCancellableEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPinColumnCancellableEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPinColumnCancellableEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPinColumnCancellableEventArgsDescriptionMetadata.a == null) {
                WebPinColumnCancellableEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPinColumnCancellableEventArgsDescriptionMetadata.c(WebPinColumnCancellableEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebPinColumnCancellableEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPinColumnCancellableEventArgsDescriptionMetadata.a);
            WebPinColumnCancellableEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PinColumnCancellableEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebPinColumnCancellableEventArgsDetail");
        }
        static d(a) {
            WebPinColumnCancellableEventArgsDescriptionMetadata.b(a);
            a.ae("WebPinColumnCancellableEventArgs", () => new WebPinColumnCancellableEventArgsDescription());
            a.ad("WebPinColumnCancellableEventArgs", WebPinColumnCancellableEventArgsDescriptionMetadata.a);
        }
    }
    WebPinColumnCancellableEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPinColumnCancellableEventArgsDescriptionMetadata, 'WebPinColumnCancellableEventArgsDescriptionMetadata');
    WebPinColumnCancellableEventArgsDescriptionMetadata.a = null;
    return WebPinColumnCancellableEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPinColumnEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebPinColumnEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebPinColumnEventArgsDetail";
        }
        constructor() {
            super();
            this.m = null;
            this.r = 0;
            this.p = false;
        }
        get column() {
            return this.m;
        }
        set column(a) {
            this.m = a;
            this.g("Column");
        }
        get insertAtIndex() {
            return this.r;
        }
        set insertAtIndex(a) {
            this.r = a;
            this.g("InsertAtIndex");
        }
        get isPinned() {
            return this.p;
        }
        set isPinned(a) {
            this.p = a;
            this.g("IsPinned");
        }
    }
    WebPinColumnEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebPinColumnEventArgsDetailDescription, 'WebPinColumnEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebPinColumnEventArgsDetailDescription.__marshalByValue1 = true;
    WebPinColumnEventArgsDetailDescription.__marshalByValueAlias1 = "PinColumnEventArgsDetail";
    return WebPinColumnEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPinColumnEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPinColumnEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebPinColumnEventArgsDetailDescriptionMetadata.a == null) {
                WebPinColumnEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPinColumnEventArgsDetailDescriptionMetadata.c(WebPinColumnEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebPinColumnEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPinColumnEventArgsDetailDescriptionMetadata.a);
            WebColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:PinColumnEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Column", "ExportedType:WebColumn");
            a.item("InsertAtIndex", "Number:double");
            a.item("IsPinned", "Boolean");
        }
        static d(a) {
            WebPinColumnEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebPinColumnEventArgsDetail", () => new WebPinColumnEventArgsDetailDescription());
            a.ad("WebPinColumnEventArgsDetail", WebPinColumnEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebPinColumnEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPinColumnEventArgsDetailDescriptionMetadata, 'WebPinColumnEventArgsDetailDescriptionMetadata');
    WebPinColumnEventArgsDetailDescriptionMetadata.a = null;
    return WebPinColumnEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPinColumnEventArgsDescription = /*@__PURE__*/ (() => {
    class WebPinColumnEventArgsDescription extends Description {
        get_type() {
            return "WebPinColumnEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebPinColumnEventArgsDescription.$t = /*@__PURE__*/ markType(WebPinColumnEventArgsDescription, 'WebPinColumnEventArgsDescription', Description.$);
    WebPinColumnEventArgsDescription.__marshalByValue = true;
    WebPinColumnEventArgsDescription.__marshalByValueAlias = "PinColumnEventArgs";
    return WebPinColumnEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPinColumnEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPinColumnEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPinColumnEventArgsDescriptionMetadata.a == null) {
                WebPinColumnEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPinColumnEventArgsDescriptionMetadata.c(WebPinColumnEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebPinColumnEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPinColumnEventArgsDescriptionMetadata.a);
            WebPinColumnEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PinColumnEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebPinColumnEventArgsDetail");
        }
        static d(a) {
            WebPinColumnEventArgsDescriptionMetadata.b(a);
            a.ae("WebPinColumnEventArgs", () => new WebPinColumnEventArgsDescription());
            a.ad("WebPinColumnEventArgs", WebPinColumnEventArgsDescriptionMetadata.a);
        }
    }
    WebPinColumnEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPinColumnEventArgsDescriptionMetadata, 'WebPinColumnEventArgsDescriptionMetadata');
    WebPinColumnEventArgsDescriptionMetadata.a = null;
    return WebPinColumnEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnComponentEventArgsDescription = /*@__PURE__*/ (() => {
    class WebColumnComponentEventArgsDescription extends Description {
        get_type() {
            return "WebColumnComponentEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebColumnComponentEventArgsDescription.$t = /*@__PURE__*/ markType(WebColumnComponentEventArgsDescription, 'WebColumnComponentEventArgsDescription', Description.$);
    WebColumnComponentEventArgsDescription.__marshalByValue = true;
    WebColumnComponentEventArgsDescription.__marshalByValueAlias = "ColumnComponentEventArgs";
    return WebColumnComponentEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnComponentEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnComponentEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnComponentEventArgsDescriptionMetadata.a == null) {
                WebColumnComponentEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnComponentEventArgsDescriptionMetadata.c(WebColumnComponentEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebColumnComponentEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnComponentEventArgsDescriptionMetadata.a);
            WebColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnComponentEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebColumn");
        }
        static d(a) {
            WebColumnComponentEventArgsDescriptionMetadata.b(a);
            a.ae("WebColumnComponentEventArgs", () => new WebColumnComponentEventArgsDescription());
            a.ad("WebColumnComponentEventArgs", WebColumnComponentEventArgsDescriptionMetadata.a);
        }
    }
    WebColumnComponentEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnComponentEventArgsDescriptionMetadata, 'WebColumnComponentEventArgsDescriptionMetadata');
    WebColumnComponentEventArgsDescriptionMetadata.a = null;
    return WebColumnComponentEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnsAutoGeneratedEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebColumnsAutoGeneratedEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebColumnsAutoGeneratedEventArgsDetail";
        }
        constructor() {
            super();
            this.m = null;
        }
        get columns() {
            return this.m;
        }
        set columns(a) {
            this.m = a;
            this.g("Columns");
        }
    }
    WebColumnsAutoGeneratedEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebColumnsAutoGeneratedEventArgsDetailDescription, 'WebColumnsAutoGeneratedEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebColumnsAutoGeneratedEventArgsDetailDescription.__marshalByValue1 = true;
    WebColumnsAutoGeneratedEventArgsDetailDescription.__marshalByValueAlias1 = "ColumnsAutoGeneratedEventArgsDetail";
    return WebColumnsAutoGeneratedEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata.a == null) {
                WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata.c(WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ColumnsAutoGeneratedEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Columns", "Collection:WebColumn:ColumnCollection:WebColumn");
        }
        static d(a) {
            WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebColumnsAutoGeneratedEventArgsDetail", () => new WebColumnsAutoGeneratedEventArgsDetailDescription());
            a.ad("WebColumnsAutoGeneratedEventArgsDetail", WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata, 'WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata');
    WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata.a = null;
    return WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnsAutoGeneratedEventArgsDescription = /*@__PURE__*/ (() => {
    class WebColumnsAutoGeneratedEventArgsDescription extends Description {
        get_type() {
            return "WebColumnsAutoGeneratedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebColumnsAutoGeneratedEventArgsDescription.$t = /*@__PURE__*/ markType(WebColumnsAutoGeneratedEventArgsDescription, 'WebColumnsAutoGeneratedEventArgsDescription', Description.$);
    WebColumnsAutoGeneratedEventArgsDescription.__marshalByValue = true;
    WebColumnsAutoGeneratedEventArgsDescription.__marshalByValueAlias = "ColumnsAutoGeneratedEventArgs";
    return WebColumnsAutoGeneratedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnsAutoGeneratedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnsAutoGeneratedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnsAutoGeneratedEventArgsDescriptionMetadata.a == null) {
                WebColumnsAutoGeneratedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnsAutoGeneratedEventArgsDescriptionMetadata.c(WebColumnsAutoGeneratedEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebColumnsAutoGeneratedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnsAutoGeneratedEventArgsDescriptionMetadata.a);
            WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnsAutoGeneratedEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebColumnsAutoGeneratedEventArgsDetail");
        }
        static d(a) {
            WebColumnsAutoGeneratedEventArgsDescriptionMetadata.b(a);
            a.ae("WebColumnsAutoGeneratedEventArgs", () => new WebColumnsAutoGeneratedEventArgsDescription());
            a.ad("WebColumnsAutoGeneratedEventArgs", WebColumnsAutoGeneratedEventArgsDescriptionMetadata.a);
        }
    }
    WebColumnsAutoGeneratedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnsAutoGeneratedEventArgsDescriptionMetadata, 'WebColumnsAutoGeneratedEventArgsDescriptionMetadata');
    WebColumnsAutoGeneratedEventArgsDescriptionMetadata.a = null;
    return WebColumnsAutoGeneratedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupingExpressionDescription = /*@__PURE__*/ (() => {
    class WebGroupingExpressionDescription extends WebSortingExpressionDescription {
        get_type() {
            return "WebGroupingExpression";
        }
        constructor() {
            super();
        }
    }
    WebGroupingExpressionDescription.$t = /*@__PURE__*/ markType(WebGroupingExpressionDescription, 'WebGroupingExpressionDescription', WebSortingExpressionDescription.$);
    WebGroupingExpressionDescription.__marshalByValue2 = true;
    WebGroupingExpressionDescription.__marshalByValueAlias2 = "GroupingExpression";
    return WebGroupingExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupingExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGroupingExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (WebGroupingExpressionDescriptionMetadata.a == null) {
                WebGroupingExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGroupingExpressionDescriptionMetadata.c(WebGroupingExpressionDescriptionMetadata.a);
            }
            if (a.k(WebGroupingExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGroupingExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WebSortingExpressionDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GroupingExpression");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
        }
        static d(a) {
            WebGroupingExpressionDescriptionMetadata.b(a);
            a.ae("WebGroupingExpression", () => new WebGroupingExpressionDescription());
            a.ad("WebGroupingExpression", WebGroupingExpressionDescriptionMetadata.a);
        }
    }
    WebGroupingExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGroupingExpressionDescriptionMetadata, 'WebGroupingExpressionDescriptionMetadata');
    WebGroupingExpressionDescriptionMetadata.a = null;
    return WebGroupingExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSortingEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebSortingEventArgsDetailDescription extends Description {
        get_type() {
            return "WebSortingEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
            this.o = null;
            this.m = false;
        }
        get sortingExpressions() {
            return this.i;
        }
        set sortingExpressions(a) {
            this.i = a;
            this.g("SortingExpressions");
        }
        get groupingExpressions() {
            return this.h;
        }
        set groupingExpressions(a) {
            this.h = a;
            this.g("GroupingExpressions");
        }
        get owner() {
            return this.o;
        }
        set owner(a) {
            this.o = a;
            this.g("Owner");
        }
        get cancel() {
            return this.m;
        }
        set cancel(a) {
            this.m = a;
            this.g("Cancel");
        }
    }
    WebSortingEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebSortingEventArgsDetailDescription, 'WebSortingEventArgsDetailDescription', Description.$);
    WebSortingEventArgsDetailDescription.__marshalByValue = true;
    WebSortingEventArgsDetailDescription.__marshalByValueAlias = "SortingEventArgsDetail";
    return WebSortingEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSortingEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSortingEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebSortingEventArgsDetailDescriptionMetadata.a == null) {
                WebSortingEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSortingEventArgsDetailDescriptionMetadata.c(WebSortingEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebSortingEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSortingEventArgsDetailDescriptionMetadata.a);
            WebSortingExpressionDescriptionMetadata.d(a);
            WebGroupingExpressionDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:SortingEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("SortingExpressions", "Array:WebSortingExpressionDescription:SortingExpression");
            a.item("GroupingExpressions", "Array:WebGroupingExpressionDescription:GroupingExpression");
            a.item("Owner", "Unknown");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebSortingEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebSortingEventArgsDetail", () => new WebSortingEventArgsDetailDescription());
            a.ad("WebSortingEventArgsDetail", WebSortingEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebSortingEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSortingEventArgsDetailDescriptionMetadata, 'WebSortingEventArgsDetailDescriptionMetadata');
    WebSortingEventArgsDetailDescriptionMetadata.a = null;
    return WebSortingEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSortingEventArgsDescription = /*@__PURE__*/ (() => {
    class WebSortingEventArgsDescription extends Description {
        get_type() {
            return "WebSortingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebSortingEventArgsDescription.$t = /*@__PURE__*/ markType(WebSortingEventArgsDescription, 'WebSortingEventArgsDescription', Description.$);
    WebSortingEventArgsDescription.__marshalByValue = true;
    WebSortingEventArgsDescription.__marshalByValueAlias = "SortingEventArgs";
    return WebSortingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSortingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSortingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebSortingEventArgsDescriptionMetadata.a == null) {
                WebSortingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSortingEventArgsDescriptionMetadata.c(WebSortingEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebSortingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSortingEventArgsDescriptionMetadata.a);
            WebSortingEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:SortingEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebSortingEventArgsDetail");
        }
        static d(a) {
            WebSortingEventArgsDescriptionMetadata.b(a);
            a.ae("WebSortingEventArgs", () => new WebSortingEventArgsDescription());
            a.ad("WebSortingEventArgs", WebSortingEventArgsDescriptionMetadata.a);
        }
    }
    WebSortingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSortingEventArgsDescriptionMetadata, 'WebSortingEventArgsDescriptionMetadata');
    WebSortingEventArgsDescriptionMetadata.a = null;
    return WebSortingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSortingExpressionEventArgsDescription = /*@__PURE__*/ (() => {
    class WebSortingExpressionEventArgsDescription extends Description {
        get_type() {
            return "WebSortingExpressionEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebSortingExpressionEventArgsDescription.$t = /*@__PURE__*/ markType(WebSortingExpressionEventArgsDescription, 'WebSortingExpressionEventArgsDescription', Description.$);
    WebSortingExpressionEventArgsDescription.__marshalByValue = true;
    WebSortingExpressionEventArgsDescription.__marshalByValueAlias = "SortingExpressionEventArgs";
    return WebSortingExpressionEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSortingExpressionEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSortingExpressionEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebSortingExpressionEventArgsDescriptionMetadata.a == null) {
                WebSortingExpressionEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSortingExpressionEventArgsDescriptionMetadata.c(WebSortingExpressionEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebSortingExpressionEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSortingExpressionEventArgsDescriptionMetadata.a);
            WebSortingExpressionDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:SortingExpressionEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "Array:WebSortingExpressionDescription:SortingExpression");
        }
        static d(a) {
            WebSortingExpressionEventArgsDescriptionMetadata.b(a);
            a.ae("WebSortingExpressionEventArgs", () => new WebSortingExpressionEventArgsDescription());
            a.ad("WebSortingExpressionEventArgs", WebSortingExpressionEventArgsDescriptionMetadata.a);
        }
    }
    WebSortingExpressionEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSortingExpressionEventArgsDescriptionMetadata, 'WebSortingExpressionEventArgsDescriptionMetadata');
    WebSortingExpressionEventArgsDescriptionMetadata.a = null;
    return WebSortingExpressionEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebFilteringEventArgsDetailDescription extends Description {
        get_type() {
            return "WebFilteringEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.m = null;
            this.k = false;
        }
        get filteringExpressions() {
            return this.h;
        }
        set filteringExpressions(a) {
            this.h = a;
            this.g("FilteringExpressions");
        }
        get owner() {
            return this.m;
        }
        set owner(a) {
            this.m = a;
            this.g("Owner");
        }
        get cancel() {
            return this.k;
        }
        set cancel(a) {
            this.k = a;
            this.g("Cancel");
        }
    }
    WebFilteringEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebFilteringEventArgsDetailDescription, 'WebFilteringEventArgsDetailDescription', Description.$);
    WebFilteringEventArgsDetailDescription.__marshalByValue = true;
    WebFilteringEventArgsDetailDescription.__marshalByValueAlias = "FilteringEventArgsDetail";
    return WebFilteringEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFilteringEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebFilteringEventArgsDetailDescriptionMetadata.a == null) {
                WebFilteringEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFilteringEventArgsDetailDescriptionMetadata.c(WebFilteringEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebFilteringEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFilteringEventArgsDetailDescriptionMetadata.a);
            WebFilteringExpressionsTreeDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FilteringEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("FilteringExpressions", "ExportedType:WebFilteringExpressionsTree");
            a.item("Owner", "Unknown");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebFilteringEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebFilteringEventArgsDetail", () => new WebFilteringEventArgsDetailDescription());
            a.ad("WebFilteringEventArgsDetail", WebFilteringEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebFilteringEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFilteringEventArgsDetailDescriptionMetadata, 'WebFilteringEventArgsDetailDescriptionMetadata');
    WebFilteringEventArgsDetailDescriptionMetadata.a = null;
    return WebFilteringEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringEventArgsDescription = /*@__PURE__*/ (() => {
    class WebFilteringEventArgsDescription extends Description {
        get_type() {
            return "WebFilteringEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebFilteringEventArgsDescription.$t = /*@__PURE__*/ markType(WebFilteringEventArgsDescription, 'WebFilteringEventArgsDescription', Description.$);
    WebFilteringEventArgsDescription.__marshalByValue = true;
    WebFilteringEventArgsDescription.__marshalByValueAlias = "FilteringEventArgs";
    return WebFilteringEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFilteringEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebFilteringEventArgsDescriptionMetadata.a == null) {
                WebFilteringEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFilteringEventArgsDescriptionMetadata.c(WebFilteringEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebFilteringEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFilteringEventArgsDescriptionMetadata.a);
            WebFilteringEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FilteringEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebFilteringEventArgsDetail");
        }
        static d(a) {
            WebFilteringEventArgsDescriptionMetadata.b(a);
            a.ae("WebFilteringEventArgs", () => new WebFilteringEventArgsDescription());
            a.ad("WebFilteringEventArgs", WebFilteringEventArgsDescriptionMetadata.a);
        }
    }
    WebFilteringEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFilteringEventArgsDescriptionMetadata, 'WebFilteringEventArgsDescriptionMetadata');
    WebFilteringEventArgsDescriptionMetadata.a = null;
    return WebFilteringEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowDataEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebRowDataEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebRowDataEventArgsDetail";
        }
        constructor() {
            super();
            this.n = null;
            this.p = null;
            this.o = null;
            this.q = null;
        }
        get data() {
            return this.n;
        }
        set data(a) {
            this.n = a;
            this.g("Data");
        }
        get rowData() {
            return this.p;
        }
        set rowData(a) {
            this.p = a;
            this.g("RowData");
        }
        get primaryKey() {
            return this.o;
        }
        set primaryKey(a) {
            this.o = a;
            this.g("PrimaryKey");
        }
        get rowKey() {
            return this.q;
        }
        set rowKey(a) {
            this.q = a;
            this.g("RowKey");
        }
    }
    WebRowDataEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebRowDataEventArgsDetailDescription, 'WebRowDataEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebRowDataEventArgsDetailDescription.__marshalByValue1 = true;
    WebRowDataEventArgsDetailDescription.__marshalByValueAlias1 = "RowDataEventArgsDetail";
    return WebRowDataEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowDataEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowDataEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowDataEventArgsDetailDescriptionMetadata.a == null) {
                WebRowDataEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowDataEventArgsDetailDescriptionMetadata.c(WebRowDataEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebRowDataEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowDataEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:RowDataEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Data", "Unknown");
            a.item("RowData", "Unknown");
            a.item("PrimaryKey", "Unknown");
            a.item("RowKey", "Unknown");
        }
        static d(a) {
            WebRowDataEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebRowDataEventArgsDetail", () => new WebRowDataEventArgsDetailDescription());
            a.ad("WebRowDataEventArgsDetail", WebRowDataEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebRowDataEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowDataEventArgsDetailDescriptionMetadata, 'WebRowDataEventArgsDetailDescriptionMetadata');
    WebRowDataEventArgsDetailDescriptionMetadata.a = null;
    return WebRowDataEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowDataEventArgsDescription = /*@__PURE__*/ (() => {
    class WebRowDataEventArgsDescription extends Description {
        get_type() {
            return "WebRowDataEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebRowDataEventArgsDescription.$t = /*@__PURE__*/ markType(WebRowDataEventArgsDescription, 'WebRowDataEventArgsDescription', Description.$);
    WebRowDataEventArgsDescription.__marshalByValue = true;
    WebRowDataEventArgsDescription.__marshalByValueAlias = "RowDataEventArgs";
    return WebRowDataEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowDataEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowDataEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowDataEventArgsDescriptionMetadata.a == null) {
                WebRowDataEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowDataEventArgsDescriptionMetadata.c(WebRowDataEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebRowDataEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowDataEventArgsDescriptionMetadata.a);
            WebRowDataEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowDataEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebRowDataEventArgsDetail");
        }
        static d(a) {
            WebRowDataEventArgsDescriptionMetadata.b(a);
            a.ae("WebRowDataEventArgs", () => new WebRowDataEventArgsDescription());
            a.ad("WebRowDataEventArgs", WebRowDataEventArgsDescriptionMetadata.a);
        }
    }
    WebRowDataEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowDataEventArgsDescriptionMetadata, 'WebRowDataEventArgsDescriptionMetadata');
    WebRowDataEventArgsDescriptionMetadata.a = null;
    return WebRowDataEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnResizeEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebColumnResizeEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebColumnResizeEventArgsDetail";
        }
        constructor() {
            super();
            this.m = null;
            this.r = null;
            this.q = null;
        }
        get column() {
            return this.m;
        }
        set column(a) {
            this.m = a;
            this.g("Column");
        }
        get prevWidth() {
            return this.r;
        }
        set prevWidth(a) {
            this.r = a;
            this.g("PrevWidth");
        }
        get newWidth() {
            return this.q;
        }
        set newWidth(a) {
            this.q = a;
            this.g("NewWidth");
        }
    }
    WebColumnResizeEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebColumnResizeEventArgsDetailDescription, 'WebColumnResizeEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebColumnResizeEventArgsDetailDescription.__marshalByValue1 = true;
    WebColumnResizeEventArgsDetailDescription.__marshalByValueAlias1 = "ColumnResizeEventArgsDetail";
    return WebColumnResizeEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnResizeEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnResizeEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnResizeEventArgsDetailDescriptionMetadata.a == null) {
                WebColumnResizeEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnResizeEventArgsDetailDescriptionMetadata.c(WebColumnResizeEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebColumnResizeEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnResizeEventArgsDetailDescriptionMetadata.a);
            WebColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ColumnResizeEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Column", "ExportedType:WebColumn");
            a.item("PrevWidth", "String");
            a.item("NewWidth", "String");
        }
        static d(a) {
            WebColumnResizeEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebColumnResizeEventArgsDetail", () => new WebColumnResizeEventArgsDetailDescription());
            a.ad("WebColumnResizeEventArgsDetail", WebColumnResizeEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebColumnResizeEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnResizeEventArgsDetailDescriptionMetadata, 'WebColumnResizeEventArgsDetailDescriptionMetadata');
    WebColumnResizeEventArgsDetailDescriptionMetadata.a = null;
    return WebColumnResizeEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnResizeEventArgsDescription = /*@__PURE__*/ (() => {
    class WebColumnResizeEventArgsDescription extends Description {
        get_type() {
            return "WebColumnResizeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebColumnResizeEventArgsDescription.$t = /*@__PURE__*/ markType(WebColumnResizeEventArgsDescription, 'WebColumnResizeEventArgsDescription', Description.$);
    WebColumnResizeEventArgsDescription.__marshalByValue = true;
    WebColumnResizeEventArgsDescription.__marshalByValueAlias = "ColumnResizeEventArgs";
    return WebColumnResizeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnResizeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnResizeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnResizeEventArgsDescriptionMetadata.a == null) {
                WebColumnResizeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnResizeEventArgsDescriptionMetadata.c(WebColumnResizeEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebColumnResizeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnResizeEventArgsDescriptionMetadata.a);
            WebColumnResizeEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnResizeEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebColumnResizeEventArgsDetail");
        }
        static d(a) {
            WebColumnResizeEventArgsDescriptionMetadata.b(a);
            a.ae("WebColumnResizeEventArgs", () => new WebColumnResizeEventArgsDescription());
            a.ad("WebColumnResizeEventArgs", WebColumnResizeEventArgsDescriptionMetadata.a);
        }
    }
    WebColumnResizeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnResizeEventArgsDescriptionMetadata, 'WebColumnResizeEventArgsDescriptionMetadata');
    WebColumnResizeEventArgsDescriptionMetadata.a = null;
    return WebColumnResizeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnVisibilityChangingEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebColumnVisibilityChangingEventArgsDetailDescription extends Description {
        get_type() {
            return "WebColumnVisibilityChangingEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.m = null;
            this.j = false;
            this.i = false;
        }
        get column() {
            return this.m;
        }
        set column(a) {
            this.m = a;
            this.g("Column");
        }
        get newValue() {
            return this.j;
        }
        set newValue(a) {
            this.j = a;
            this.g("NewValue");
        }
        get cancel() {
            return this.i;
        }
        set cancel(a) {
            this.i = a;
            this.g("Cancel");
        }
    }
    WebColumnVisibilityChangingEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebColumnVisibilityChangingEventArgsDetailDescription, 'WebColumnVisibilityChangingEventArgsDetailDescription', Description.$);
    WebColumnVisibilityChangingEventArgsDetailDescription.__marshalByValue = true;
    WebColumnVisibilityChangingEventArgsDetailDescription.__marshalByValueAlias = "ColumnVisibilityChangingEventArgsDetail";
    return WebColumnVisibilityChangingEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata.a == null) {
                WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata.c(WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnVisibilityChangingEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Column", "Unknown");
            a.item("NewValue", "Boolean");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebColumnVisibilityChangingEventArgsDetail", () => new WebColumnVisibilityChangingEventArgsDetailDescription());
            a.ad("WebColumnVisibilityChangingEventArgsDetail", WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata, 'WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata');
    WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata.a = null;
    return WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnVisibilityChangingEventArgsDescription = /*@__PURE__*/ (() => {
    class WebColumnVisibilityChangingEventArgsDescription extends Description {
        get_type() {
            return "WebColumnVisibilityChangingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebColumnVisibilityChangingEventArgsDescription.$t = /*@__PURE__*/ markType(WebColumnVisibilityChangingEventArgsDescription, 'WebColumnVisibilityChangingEventArgsDescription', Description.$);
    WebColumnVisibilityChangingEventArgsDescription.__marshalByValue = true;
    WebColumnVisibilityChangingEventArgsDescription.__marshalByValueAlias = "ColumnVisibilityChangingEventArgs";
    return WebColumnVisibilityChangingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnVisibilityChangingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnVisibilityChangingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnVisibilityChangingEventArgsDescriptionMetadata.a == null) {
                WebColumnVisibilityChangingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnVisibilityChangingEventArgsDescriptionMetadata.c(WebColumnVisibilityChangingEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebColumnVisibilityChangingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnVisibilityChangingEventArgsDescriptionMetadata.a);
            WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnVisibilityChangingEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebColumnVisibilityChangingEventArgsDetail");
        }
        static d(a) {
            WebColumnVisibilityChangingEventArgsDescriptionMetadata.b(a);
            a.ae("WebColumnVisibilityChangingEventArgs", () => new WebColumnVisibilityChangingEventArgsDescription());
            a.ad("WebColumnVisibilityChangingEventArgs", WebColumnVisibilityChangingEventArgsDescriptionMetadata.a);
        }
    }
    WebColumnVisibilityChangingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnVisibilityChangingEventArgsDescriptionMetadata, 'WebColumnVisibilityChangingEventArgsDescriptionMetadata');
    WebColumnVisibilityChangingEventArgsDescriptionMetadata.a = null;
    return WebColumnVisibilityChangingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnVisibilityChangedEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebColumnVisibilityChangedEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebColumnVisibilityChangedEventArgsDetail";
        }
        constructor() {
            super();
            this.p = null;
            this.n = false;
        }
        get column() {
            return this.p;
        }
        set column(a) {
            this.p = a;
            this.g("Column");
        }
        get newValue() {
            return this.n;
        }
        set newValue(a) {
            this.n = a;
            this.g("NewValue");
        }
    }
    WebColumnVisibilityChangedEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebColumnVisibilityChangedEventArgsDetailDescription, 'WebColumnVisibilityChangedEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebColumnVisibilityChangedEventArgsDetailDescription.__marshalByValue1 = true;
    WebColumnVisibilityChangedEventArgsDetailDescription.__marshalByValueAlias1 = "ColumnVisibilityChangedEventArgsDetail";
    return WebColumnVisibilityChangedEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata.a == null) {
                WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata.c(WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ColumnVisibilityChangedEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Column", "Unknown");
            a.item("NewValue", "Boolean");
        }
        static d(a) {
            WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebColumnVisibilityChangedEventArgsDetail", () => new WebColumnVisibilityChangedEventArgsDetailDescription());
            a.ad("WebColumnVisibilityChangedEventArgsDetail", WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata, 'WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata');
    WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata.a = null;
    return WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnVisibilityChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class WebColumnVisibilityChangedEventArgsDescription extends Description {
        get_type() {
            return "WebColumnVisibilityChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebColumnVisibilityChangedEventArgsDescription.$t = /*@__PURE__*/ markType(WebColumnVisibilityChangedEventArgsDescription, 'WebColumnVisibilityChangedEventArgsDescription', Description.$);
    WebColumnVisibilityChangedEventArgsDescription.__marshalByValue = true;
    WebColumnVisibilityChangedEventArgsDescription.__marshalByValueAlias = "ColumnVisibilityChangedEventArgs";
    return WebColumnVisibilityChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnVisibilityChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnVisibilityChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnVisibilityChangedEventArgsDescriptionMetadata.a == null) {
                WebColumnVisibilityChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnVisibilityChangedEventArgsDescriptionMetadata.c(WebColumnVisibilityChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebColumnVisibilityChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnVisibilityChangedEventArgsDescriptionMetadata.a);
            WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnVisibilityChangedEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebColumnVisibilityChangedEventArgsDetail");
        }
        static d(a) {
            WebColumnVisibilityChangedEventArgsDescriptionMetadata.b(a);
            a.ae("WebColumnVisibilityChangedEventArgs", () => new WebColumnVisibilityChangedEventArgsDescription());
            a.ad("WebColumnVisibilityChangedEventArgs", WebColumnVisibilityChangedEventArgsDescriptionMetadata.a);
        }
    }
    WebColumnVisibilityChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnVisibilityChangedEventArgsDescriptionMetadata, 'WebColumnVisibilityChangedEventArgsDescriptionMetadata');
    WebColumnVisibilityChangedEventArgsDescriptionMetadata.a = null;
    return WebColumnVisibilityChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnMovingStartEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebColumnMovingStartEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebColumnMovingStartEventArgsDetail";
        }
        constructor() {
            super();
            this.m = null;
        }
        get source() {
            return this.m;
        }
        set source(a) {
            this.m = a;
            this.g("Source");
        }
    }
    WebColumnMovingStartEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebColumnMovingStartEventArgsDetailDescription, 'WebColumnMovingStartEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebColumnMovingStartEventArgsDetailDescription.__marshalByValue1 = true;
    WebColumnMovingStartEventArgsDetailDescription.__marshalByValueAlias1 = "ColumnMovingStartEventArgsDetail";
    return WebColumnMovingStartEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnMovingStartEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnMovingStartEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnMovingStartEventArgsDetailDescriptionMetadata.a == null) {
                WebColumnMovingStartEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnMovingStartEventArgsDetailDescriptionMetadata.c(WebColumnMovingStartEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebColumnMovingStartEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnMovingStartEventArgsDetailDescriptionMetadata.a);
            WebColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ColumnMovingStartEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Source", "ExportedType:WebColumn");
        }
        static d(a) {
            WebColumnMovingStartEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebColumnMovingStartEventArgsDetail", () => new WebColumnMovingStartEventArgsDetailDescription());
            a.ad("WebColumnMovingStartEventArgsDetail", WebColumnMovingStartEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebColumnMovingStartEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnMovingStartEventArgsDetailDescriptionMetadata, 'WebColumnMovingStartEventArgsDetailDescriptionMetadata');
    WebColumnMovingStartEventArgsDetailDescriptionMetadata.a = null;
    return WebColumnMovingStartEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnMovingStartEventArgsDescription = /*@__PURE__*/ (() => {
    class WebColumnMovingStartEventArgsDescription extends Description {
        get_type() {
            return "WebColumnMovingStartEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebColumnMovingStartEventArgsDescription.$t = /*@__PURE__*/ markType(WebColumnMovingStartEventArgsDescription, 'WebColumnMovingStartEventArgsDescription', Description.$);
    WebColumnMovingStartEventArgsDescription.__marshalByValue = true;
    WebColumnMovingStartEventArgsDescription.__marshalByValueAlias = "ColumnMovingStartEventArgs";
    return WebColumnMovingStartEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnMovingStartEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnMovingStartEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnMovingStartEventArgsDescriptionMetadata.a == null) {
                WebColumnMovingStartEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnMovingStartEventArgsDescriptionMetadata.c(WebColumnMovingStartEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebColumnMovingStartEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnMovingStartEventArgsDescriptionMetadata.a);
            WebColumnMovingStartEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnMovingStartEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebColumnMovingStartEventArgsDetail");
        }
        static d(a) {
            WebColumnMovingStartEventArgsDescriptionMetadata.b(a);
            a.ae("WebColumnMovingStartEventArgs", () => new WebColumnMovingStartEventArgsDescription());
            a.ad("WebColumnMovingStartEventArgs", WebColumnMovingStartEventArgsDescriptionMetadata.a);
        }
    }
    WebColumnMovingStartEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnMovingStartEventArgsDescriptionMetadata, 'WebColumnMovingStartEventArgsDescriptionMetadata');
    WebColumnMovingStartEventArgsDescriptionMetadata.a = null;
    return WebColumnMovingStartEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnMovingEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebColumnMovingEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebColumnMovingEventArgsDetail";
        }
        constructor() {
            super();
            this.m = null;
            this.p = false;
        }
        get source() {
            return this.m;
        }
        set source(a) {
            this.m = a;
            this.g("Source");
        }
        get cancel() {
            return this.p;
        }
        set cancel(a) {
            this.p = a;
            this.g("Cancel");
        }
    }
    WebColumnMovingEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebColumnMovingEventArgsDetailDescription, 'WebColumnMovingEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebColumnMovingEventArgsDetailDescription.__marshalByValue1 = true;
    WebColumnMovingEventArgsDetailDescription.__marshalByValueAlias1 = "ColumnMovingEventArgsDetail";
    return WebColumnMovingEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnMovingEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnMovingEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnMovingEventArgsDetailDescriptionMetadata.a == null) {
                WebColumnMovingEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnMovingEventArgsDetailDescriptionMetadata.c(WebColumnMovingEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebColumnMovingEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnMovingEventArgsDetailDescriptionMetadata.a);
            WebColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ColumnMovingEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Source", "ExportedType:WebColumn");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebColumnMovingEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebColumnMovingEventArgsDetail", () => new WebColumnMovingEventArgsDetailDescription());
            a.ad("WebColumnMovingEventArgsDetail", WebColumnMovingEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebColumnMovingEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnMovingEventArgsDetailDescriptionMetadata, 'WebColumnMovingEventArgsDetailDescriptionMetadata');
    WebColumnMovingEventArgsDetailDescriptionMetadata.a = null;
    return WebColumnMovingEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnMovingEventArgsDescription = /*@__PURE__*/ (() => {
    class WebColumnMovingEventArgsDescription extends Description {
        get_type() {
            return "WebColumnMovingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebColumnMovingEventArgsDescription.$t = /*@__PURE__*/ markType(WebColumnMovingEventArgsDescription, 'WebColumnMovingEventArgsDescription', Description.$);
    WebColumnMovingEventArgsDescription.__marshalByValue = true;
    WebColumnMovingEventArgsDescription.__marshalByValueAlias = "ColumnMovingEventArgs";
    return WebColumnMovingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnMovingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnMovingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnMovingEventArgsDescriptionMetadata.a == null) {
                WebColumnMovingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnMovingEventArgsDescriptionMetadata.c(WebColumnMovingEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebColumnMovingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnMovingEventArgsDescriptionMetadata.a);
            WebColumnMovingEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnMovingEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebColumnMovingEventArgsDetail");
        }
        static d(a) {
            WebColumnMovingEventArgsDescriptionMetadata.b(a);
            a.ae("WebColumnMovingEventArgs", () => new WebColumnMovingEventArgsDescription());
            a.ad("WebColumnMovingEventArgs", WebColumnMovingEventArgsDescriptionMetadata.a);
        }
    }
    WebColumnMovingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnMovingEventArgsDescriptionMetadata, 'WebColumnMovingEventArgsDescriptionMetadata');
    WebColumnMovingEventArgsDescriptionMetadata.a = null;
    return WebColumnMovingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnMovingEndEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebColumnMovingEndEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebColumnMovingEndEventArgsDetail";
        }
        constructor() {
            super();
            this.m = null;
            this.n = null;
            this.r = false;
        }
        get source() {
            return this.m;
        }
        set source(a) {
            this.m = a;
            this.g("Source");
        }
        get target() {
            return this.n;
        }
        set target(a) {
            this.n = a;
            this.g("Target");
        }
        get cancel() {
            return this.r;
        }
        set cancel(a) {
            this.r = a;
            this.g("Cancel");
        }
    }
    WebColumnMovingEndEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebColumnMovingEndEventArgsDetailDescription, 'WebColumnMovingEndEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebColumnMovingEndEventArgsDetailDescription.__marshalByValue1 = true;
    WebColumnMovingEndEventArgsDetailDescription.__marshalByValueAlias1 = "ColumnMovingEndEventArgsDetail";
    return WebColumnMovingEndEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnMovingEndEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnMovingEndEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnMovingEndEventArgsDetailDescriptionMetadata.a == null) {
                WebColumnMovingEndEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnMovingEndEventArgsDetailDescriptionMetadata.c(WebColumnMovingEndEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebColumnMovingEndEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnMovingEndEventArgsDetailDescriptionMetadata.a);
            WebColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ColumnMovingEndEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Source", "ExportedType:WebColumn");
            a.item("Target", "ExportedType:WebColumn");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebColumnMovingEndEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebColumnMovingEndEventArgsDetail", () => new WebColumnMovingEndEventArgsDetailDescription());
            a.ad("WebColumnMovingEndEventArgsDetail", WebColumnMovingEndEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebColumnMovingEndEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnMovingEndEventArgsDetailDescriptionMetadata, 'WebColumnMovingEndEventArgsDetailDescriptionMetadata');
    WebColumnMovingEndEventArgsDetailDescriptionMetadata.a = null;
    return WebColumnMovingEndEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnMovingEndEventArgsDescription = /*@__PURE__*/ (() => {
    class WebColumnMovingEndEventArgsDescription extends Description {
        get_type() {
            return "WebColumnMovingEndEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebColumnMovingEndEventArgsDescription.$t = /*@__PURE__*/ markType(WebColumnMovingEndEventArgsDescription, 'WebColumnMovingEndEventArgsDescription', Description.$);
    WebColumnMovingEndEventArgsDescription.__marshalByValue = true;
    WebColumnMovingEndEventArgsDescription.__marshalByValueAlias = "ColumnMovingEndEventArgs";
    return WebColumnMovingEndEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnMovingEndEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnMovingEndEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnMovingEndEventArgsDescriptionMetadata.a == null) {
                WebColumnMovingEndEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnMovingEndEventArgsDescriptionMetadata.c(WebColumnMovingEndEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebColumnMovingEndEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnMovingEndEventArgsDescriptionMetadata.a);
            WebColumnMovingEndEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnMovingEndEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebColumnMovingEndEventArgsDetail");
        }
        static d(a) {
            WebColumnMovingEndEventArgsDescriptionMetadata.b(a);
            a.ae("WebColumnMovingEndEventArgs", () => new WebColumnMovingEndEventArgsDescription());
            a.ad("WebColumnMovingEndEventArgs", WebColumnMovingEndEventArgsDescriptionMetadata.a);
        }
    }
    WebColumnMovingEndEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnMovingEndEventArgsDescriptionMetadata, 'WebColumnMovingEndEventArgsDescriptionMetadata');
    WebColumnMovingEndEventArgsDescriptionMetadata.a = null;
    return WebColumnMovingEndEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridKeydownEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebGridKeydownEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebGridKeydownEventArgsDetail";
        }
        constructor() {
            super();
            this.u = null;
            this.q = null;
            this.p = null;
            this.n = false;
        }
        get targetType() {
            return this.u;
        }
        set targetType(a) {
            this.u = a;
            this.g("TargetType");
        }
        get target() {
            return this.q;
        }
        set target(a) {
            this.q = a;
            this.g("Target");
        }
        get event() {
            return this.p;
        }
        set event(a) {
            this.p = a;
            this.g("Event");
        }
        get cancel() {
            return this.n;
        }
        set cancel(a) {
            this.n = a;
            this.g("Cancel");
        }
    }
    WebGridKeydownEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebGridKeydownEventArgsDetailDescription, 'WebGridKeydownEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebGridKeydownEventArgsDetailDescription.__marshalByValue1 = true;
    WebGridKeydownEventArgsDetailDescription.__marshalByValueAlias1 = "GridKeydownEventArgsDetail";
    return WebGridKeydownEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridKeydownEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridKeydownEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridKeydownEventArgsDetailDescriptionMetadata.a == null) {
                WebGridKeydownEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridKeydownEventArgsDetailDescriptionMetadata.c(WebGridKeydownEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebGridKeydownEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridKeydownEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridKeydownEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("TargetType", "ExportedType:string:GridKeydownTargetType");
            a.item("TargetType@stringUnion", "WebComponents;React");
            a.item("TargetType@names", "DataCell;SummaryCell;GroupRow;HierarchicalRow;HeaderCell;MasterDetailRow");
            a.item("Target", "Unknown");
            a.item("Event", "Unknown");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebGridKeydownEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebGridKeydownEventArgsDetail", () => new WebGridKeydownEventArgsDetailDescription());
            a.ad("WebGridKeydownEventArgsDetail", WebGridKeydownEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebGridKeydownEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridKeydownEventArgsDetailDescriptionMetadata, 'WebGridKeydownEventArgsDetailDescriptionMetadata');
    WebGridKeydownEventArgsDetailDescriptionMetadata.a = null;
    return WebGridKeydownEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridKeydownEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGridKeydownEventArgsDescription extends Description {
        get_type() {
            return "WebGridKeydownEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGridKeydownEventArgsDescription.$t = /*@__PURE__*/ markType(WebGridKeydownEventArgsDescription, 'WebGridKeydownEventArgsDescription', Description.$);
    WebGridKeydownEventArgsDescription.__marshalByValue = true;
    WebGridKeydownEventArgsDescription.__marshalByValueAlias = "GridKeydownEventArgs";
    return WebGridKeydownEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridKeydownEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridKeydownEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridKeydownEventArgsDescriptionMetadata.a == null) {
                WebGridKeydownEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridKeydownEventArgsDescriptionMetadata.c(WebGridKeydownEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGridKeydownEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridKeydownEventArgsDescriptionMetadata.a);
            WebGridKeydownEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridKeydownEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebGridKeydownEventArgsDetail");
        }
        static d(a) {
            WebGridKeydownEventArgsDescriptionMetadata.b(a);
            a.ae("WebGridKeydownEventArgs", () => new WebGridKeydownEventArgsDescription());
            a.ad("WebGridKeydownEventArgs", WebGridKeydownEventArgsDescriptionMetadata.a);
        }
    }
    WebGridKeydownEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridKeydownEventArgsDescriptionMetadata, 'WebGridKeydownEventArgsDescriptionMetadata');
    WebGridKeydownEventArgsDescriptionMetadata.a = null;
    return WebGridKeydownEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridClipboardEventDetailDescription = /*@__PURE__*/ (() => {
    class WebGridClipboardEventDetailDescription extends Description {
        get_type() {
            return "WebGridClipboardEventDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.i = false;
        }
        get dataRef() {
            return this.l;
        }
        set dataRef(a) {
            this.l = a;
            this.g("DataRef");
        }
        get cancel() {
            return this.i;
        }
        set cancel(a) {
            this.i = a;
            this.g("Cancel");
        }
    }
    WebGridClipboardEventDetailDescription.$t = /*@__PURE__*/ markType(WebGridClipboardEventDetailDescription, 'WebGridClipboardEventDetailDescription', Description.$);
    WebGridClipboardEventDetailDescription.__marshalByValue = true;
    WebGridClipboardEventDetailDescription.__marshalByValueAlias = "GridClipboardEventDetail";
    return WebGridClipboardEventDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridClipboardEventDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridClipboardEventDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridClipboardEventDetailDescriptionMetadata.a == null) {
                WebGridClipboardEventDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridClipboardEventDetailDescriptionMetadata.c(WebGridClipboardEventDetailDescriptionMetadata.a);
            }
            if (a.k(WebGridClipboardEventDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridClipboardEventDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridClipboardEventDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("DataRef", "(w:Data,wf:Data)DataRef:object");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebGridClipboardEventDetailDescriptionMetadata.b(a);
            a.ae("WebGridClipboardEventDetail", () => new WebGridClipboardEventDetailDescription());
            a.ad("WebGridClipboardEventDetail", WebGridClipboardEventDetailDescriptionMetadata.a);
        }
    }
    WebGridClipboardEventDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridClipboardEventDetailDescriptionMetadata, 'WebGridClipboardEventDetailDescriptionMetadata');
    WebGridClipboardEventDetailDescriptionMetadata.a = null;
    return WebGridClipboardEventDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridClipboardEventEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGridClipboardEventEventArgsDescription extends Description {
        get_type() {
            return "WebGridClipboardEventEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGridClipboardEventEventArgsDescription.$t = /*@__PURE__*/ markType(WebGridClipboardEventEventArgsDescription, 'WebGridClipboardEventEventArgsDescription', Description.$);
    WebGridClipboardEventEventArgsDescription.__marshalByValue = true;
    WebGridClipboardEventEventArgsDescription.__marshalByValueAlias = "GridClipboardEventEventArgs";
    return WebGridClipboardEventEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridClipboardEventEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridClipboardEventEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridClipboardEventEventArgsDescriptionMetadata.a == null) {
                WebGridClipboardEventEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridClipboardEventEventArgsDescriptionMetadata.c(WebGridClipboardEventEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGridClipboardEventEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridClipboardEventEventArgsDescriptionMetadata.a);
            WebGridClipboardEventDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridClipboardEventEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebGridClipboardEventDetail");
        }
        static d(a) {
            WebGridClipboardEventEventArgsDescriptionMetadata.b(a);
            a.ae("WebGridClipboardEventEventArgs", () => new WebGridClipboardEventEventArgsDescription());
            a.ad("WebGridClipboardEventEventArgs", WebGridClipboardEventEventArgsDescriptionMetadata.a);
        }
    }
    WebGridClipboardEventEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridClipboardEventEventArgsDescriptionMetadata, 'WebGridClipboardEventEventArgsDescriptionMetadata');
    WebGridClipboardEventEventArgsDescriptionMetadata.a = null;
    return WebGridClipboardEventEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowToggleEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebRowToggleEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebRowToggleEventArgsDetail";
        }
        constructor() {
            super();
            this.r = null;
            this.s = null;
            this.o = false;
            this.n = false;
        }
        get rowID() {
            return this.r;
        }
        set rowID(a) {
            this.r = a;
            this.g("RowID");
        }
        get rowKey() {
            return this.s;
        }
        set rowKey(a) {
            this.s = a;
            this.g("RowKey");
        }
        get expanded() {
            return this.o;
        }
        set expanded(a) {
            this.o = a;
            this.g("Expanded");
        }
        get cancel() {
            return this.n;
        }
        set cancel(a) {
            this.n = a;
            this.g("Cancel");
        }
    }
    WebRowToggleEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebRowToggleEventArgsDetailDescription, 'WebRowToggleEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebRowToggleEventArgsDetailDescription.__marshalByValue1 = true;
    WebRowToggleEventArgsDetailDescription.__marshalByValueAlias1 = "RowToggleEventArgsDetail";
    return WebRowToggleEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowToggleEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowToggleEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowToggleEventArgsDetailDescriptionMetadata.a == null) {
                WebRowToggleEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowToggleEventArgsDetailDescriptionMetadata.c(WebRowToggleEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebRowToggleEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowToggleEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:RowToggleEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("RowID", "Unknown");
            a.item("RowKey", "Unknown");
            a.item("Expanded", "Boolean");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebRowToggleEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebRowToggleEventArgsDetail", () => new WebRowToggleEventArgsDetailDescription());
            a.ad("WebRowToggleEventArgsDetail", WebRowToggleEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebRowToggleEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowToggleEventArgsDetailDescriptionMetadata, 'WebRowToggleEventArgsDetailDescriptionMetadata');
    WebRowToggleEventArgsDetailDescriptionMetadata.a = null;
    return WebRowToggleEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowToggleEventArgsDescription = /*@__PURE__*/ (() => {
    class WebRowToggleEventArgsDescription extends Description {
        get_type() {
            return "WebRowToggleEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebRowToggleEventArgsDescription.$t = /*@__PURE__*/ markType(WebRowToggleEventArgsDescription, 'WebRowToggleEventArgsDescription', Description.$);
    WebRowToggleEventArgsDescription.__marshalByValue = true;
    WebRowToggleEventArgsDescription.__marshalByValueAlias = "RowToggleEventArgs";
    return WebRowToggleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowToggleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowToggleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowToggleEventArgsDescriptionMetadata.a == null) {
                WebRowToggleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowToggleEventArgsDescriptionMetadata.c(WebRowToggleEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebRowToggleEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowToggleEventArgsDescriptionMetadata.a);
            WebRowToggleEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowToggleEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebRowToggleEventArgsDetail");
        }
        static d(a) {
            WebRowToggleEventArgsDescriptionMetadata.b(a);
            a.ae("WebRowToggleEventArgs", () => new WebRowToggleEventArgsDescription());
            a.ad("WebRowToggleEventArgs", WebRowToggleEventArgsDescriptionMetadata.a);
        }
    }
    WebRowToggleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowToggleEventArgsDescriptionMetadata, 'WebRowToggleEventArgsDescriptionMetadata');
    WebRowToggleEventArgsDescriptionMetadata.a = null;
    return WebRowToggleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActiveNodeChangeEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebActiveNodeChangeEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebActiveNodeChangeEventArgsDetail";
        }
        constructor() {
            super();
            this.p = 0;
            this.n = 0;
            this.o = 0;
            this.u = null;
        }
        get row() {
            return this.p;
        }
        set row(a) {
            this.p = a;
            this.g("Row");
        }
        get column() {
            return this.n;
        }
        set column(a) {
            this.n = a;
            this.g("Column");
        }
        get level() {
            return this.o;
        }
        set level(a) {
            this.o = a;
            this.g("Level");
        }
        get tag() {
            return this.u;
        }
        set tag(a) {
            this.u = a;
            this.g("Tag");
        }
    }
    WebActiveNodeChangeEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebActiveNodeChangeEventArgsDetailDescription, 'WebActiveNodeChangeEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebActiveNodeChangeEventArgsDetailDescription.__marshalByValue1 = true;
    WebActiveNodeChangeEventArgsDetailDescription.__marshalByValueAlias1 = "ActiveNodeChangeEventArgsDetail";
    return WebActiveNodeChangeEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActiveNodeChangeEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebActiveNodeChangeEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebActiveNodeChangeEventArgsDetailDescriptionMetadata.a == null) {
                WebActiveNodeChangeEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebActiveNodeChangeEventArgsDetailDescriptionMetadata.c(WebActiveNodeChangeEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebActiveNodeChangeEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebActiveNodeChangeEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ActiveNodeChangeEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Row", "Number:double");
            a.item("Column", "Number:double");
            a.item("Level", "Number:double");
            a.item("Tag", "ExportedType:string:GridKeydownTargetType");
            a.item("Tag@stringUnion", "WebComponents;React");
            a.item("Tag@names", "DataCell;SummaryCell;GroupRow;HierarchicalRow;HeaderCell;MasterDetailRow");
        }
        static d(a) {
            WebActiveNodeChangeEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebActiveNodeChangeEventArgsDetail", () => new WebActiveNodeChangeEventArgsDetailDescription());
            a.ad("WebActiveNodeChangeEventArgsDetail", WebActiveNodeChangeEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebActiveNodeChangeEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebActiveNodeChangeEventArgsDetailDescriptionMetadata, 'WebActiveNodeChangeEventArgsDetailDescriptionMetadata');
    WebActiveNodeChangeEventArgsDetailDescriptionMetadata.a = null;
    return WebActiveNodeChangeEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActiveNodeChangeEventArgsDescription = /*@__PURE__*/ (() => {
    class WebActiveNodeChangeEventArgsDescription extends Description {
        get_type() {
            return "WebActiveNodeChangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebActiveNodeChangeEventArgsDescription.$t = /*@__PURE__*/ markType(WebActiveNodeChangeEventArgsDescription, 'WebActiveNodeChangeEventArgsDescription', Description.$);
    WebActiveNodeChangeEventArgsDescription.__marshalByValue = true;
    WebActiveNodeChangeEventArgsDescription.__marshalByValueAlias = "ActiveNodeChangeEventArgs";
    return WebActiveNodeChangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActiveNodeChangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebActiveNodeChangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebActiveNodeChangeEventArgsDescriptionMetadata.a == null) {
                WebActiveNodeChangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebActiveNodeChangeEventArgsDescriptionMetadata.c(WebActiveNodeChangeEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebActiveNodeChangeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebActiveNodeChangeEventArgsDescriptionMetadata.a);
            WebActiveNodeChangeEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ActiveNodeChangeEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebActiveNodeChangeEventArgsDetail");
        }
        static d(a) {
            WebActiveNodeChangeEventArgsDescriptionMetadata.b(a);
            a.ae("WebActiveNodeChangeEventArgs", () => new WebActiveNodeChangeEventArgsDescription());
            a.ad("WebActiveNodeChangeEventArgs", WebActiveNodeChangeEventArgsDescriptionMetadata.a);
        }
    }
    WebActiveNodeChangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebActiveNodeChangeEventArgsDescriptionMetadata, 'WebActiveNodeChangeEventArgsDescriptionMetadata');
    WebActiveNodeChangeEventArgsDescriptionMetadata.a = null;
    return WebActiveNodeChangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridSelectionRangeDetailDescription = /*@__PURE__*/ (() => {
    class WebGridSelectionRangeDetailDescription extends Description {
        get_type() {
            return "WebGridSelectionRangeDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = 0;
            this.k = 0;
            this.j = 0;
            this.i = 0;
        }
        get rowStart() {
            return this.l;
        }
        set rowStart(a) {
            this.l = a;
            this.g("RowStart");
        }
        get rowEnd() {
            return this.k;
        }
        set rowEnd(a) {
            this.k = a;
            this.g("RowEnd");
        }
        get columnStart() {
            return this.j;
        }
        set columnStart(a) {
            this.j = a;
            this.g("ColumnStart");
        }
        get columnEnd() {
            return this.i;
        }
        set columnEnd(a) {
            this.i = a;
            this.g("ColumnEnd");
        }
    }
    WebGridSelectionRangeDetailDescription.$t = /*@__PURE__*/ markType(WebGridSelectionRangeDetailDescription, 'WebGridSelectionRangeDetailDescription', Description.$);
    WebGridSelectionRangeDetailDescription.__marshalByValue = true;
    WebGridSelectionRangeDetailDescription.__marshalByValueAlias = "GridSelectionRangeDetail";
    return WebGridSelectionRangeDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridSelectionRangeDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridSelectionRangeDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridSelectionRangeDetailDescriptionMetadata.a == null) {
                WebGridSelectionRangeDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridSelectionRangeDetailDescriptionMetadata.c(WebGridSelectionRangeDetailDescriptionMetadata.a);
            }
            if (a.k(WebGridSelectionRangeDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridSelectionRangeDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridSelectionRangeDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("RowStart", "Number:double");
            a.item("RowEnd", "Number:double");
            a.item("ColumnStart", "Number:double");
            a.item("ColumnEnd", "Number:double");
        }
        static d(a) {
            WebGridSelectionRangeDetailDescriptionMetadata.b(a);
            a.ae("WebGridSelectionRangeDetail", () => new WebGridSelectionRangeDetailDescription());
            a.ad("WebGridSelectionRangeDetail", WebGridSelectionRangeDetailDescriptionMetadata.a);
        }
    }
    WebGridSelectionRangeDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridSelectionRangeDetailDescriptionMetadata, 'WebGridSelectionRangeDetailDescriptionMetadata');
    WebGridSelectionRangeDetailDescriptionMetadata.a = null;
    return WebGridSelectionRangeDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridSelectionRangeEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGridSelectionRangeEventArgsDescription extends Description {
        get_type() {
            return "WebGridSelectionRangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGridSelectionRangeEventArgsDescription.$t = /*@__PURE__*/ markType(WebGridSelectionRangeEventArgsDescription, 'WebGridSelectionRangeEventArgsDescription', Description.$);
    WebGridSelectionRangeEventArgsDescription.__marshalByValue = true;
    WebGridSelectionRangeEventArgsDescription.__marshalByValueAlias = "GridSelectionRangeEventArgs";
    return WebGridSelectionRangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridSelectionRangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridSelectionRangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridSelectionRangeEventArgsDescriptionMetadata.a == null) {
                WebGridSelectionRangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridSelectionRangeEventArgsDescriptionMetadata.c(WebGridSelectionRangeEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGridSelectionRangeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridSelectionRangeEventArgsDescriptionMetadata.a);
            WebGridSelectionRangeDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridSelectionRangeEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebGridSelectionRangeDetail");
        }
        static d(a) {
            WebGridSelectionRangeEventArgsDescriptionMetadata.b(a);
            a.ae("WebGridSelectionRangeEventArgs", () => new WebGridSelectionRangeEventArgsDescription());
            a.ad("WebGridSelectionRangeEventArgs", WebGridSelectionRangeEventArgsDescriptionMetadata.a);
        }
    }
    WebGridSelectionRangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridSelectionRangeEventArgsDescriptionMetadata, 'WebGridSelectionRangeEventArgsDescriptionMetadata');
    WebGridSelectionRangeEventArgsDescriptionMetadata.a = null;
    return WebGridSelectionRangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VoidEventArgsDescription = /*@__PURE__*/ (() => {
    class VoidEventArgsDescription extends Description {
        get_type() {
            return "VoidEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    VoidEventArgsDescription.$t = /*@__PURE__*/ markType(VoidEventArgsDescription, 'VoidEventArgsDescription', Description.$);
    return VoidEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VoidEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class VoidEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (VoidEventArgsDescriptionMetadata.a == null) {
                VoidEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                VoidEventArgsDescriptionMetadata.c(VoidEventArgsDescriptionMetadata.a);
            }
            if (a.k(VoidEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(VoidEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            VoidEventArgsDescriptionMetadata.b(a);
            a.ae("VoidEventArgs", () => new VoidEventArgsDescription());
            a.ad("VoidEventArgs", VoidEventArgsDescriptionMetadata.a);
        }
    }
    VoidEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(VoidEventArgsDescriptionMetadata, 'VoidEventArgsDescriptionMetadata');
    VoidEventArgsDescriptionMetadata.a = null;
    return VoidEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebForOfStateDescription = /*@__PURE__*/ (() => {
    class WebForOfStateDescription extends WebBaseEventArgsDescription {
        get_type() {
            return "WebForOfState";
        }
        constructor() {
            super();
            this.o = 0;
            this.n = 0;
        }
        get startIndex() {
            return this.o;
        }
        set startIndex(a) {
            this.o = a;
            this.g("StartIndex");
        }
        get chunkSize() {
            return this.n;
        }
        set chunkSize(a) {
            this.n = a;
            this.g("ChunkSize");
        }
    }
    WebForOfStateDescription.$t = /*@__PURE__*/ markType(WebForOfStateDescription, 'WebForOfStateDescription', WebBaseEventArgsDescription.$);
    WebForOfStateDescription.__marshalByValue1 = true;
    WebForOfStateDescription.__marshalByValueAlias1 = "ForOfState";
    return WebForOfStateDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebForOfStateDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebForOfStateDescriptionMetadata extends Base {
        static b(a) {
            if (WebForOfStateDescriptionMetadata.a == null) {
                WebForOfStateDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebForOfStateDescriptionMetadata.c(WebForOfStateDescriptionMetadata.a);
            }
            if (a.k(WebForOfStateDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebForOfStateDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseEventArgsDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ForOfState");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("StartIndex", "Number:double");
            a.item("ChunkSize", "Number:double");
        }
        static d(a) {
            WebForOfStateDescriptionMetadata.b(a);
            a.ae("WebForOfState", () => new WebForOfStateDescription());
            a.ad("WebForOfState", WebForOfStateDescriptionMetadata.a);
        }
    }
    WebForOfStateDescriptionMetadata.$t = /*@__PURE__*/ markType(WebForOfStateDescriptionMetadata, 'WebForOfStateDescriptionMetadata');
    WebForOfStateDescriptionMetadata.a = null;
    return WebForOfStateDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebForOfDataChangingEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebForOfDataChangingEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebForOfDataChangingEventArgsDetail";
        }
        constructor() {
            super();
            this.p = 0;
            this.m = null;
        }
        get containerSize() {
            return this.p;
        }
        set containerSize(a) {
            this.p = a;
            this.g("ContainerSize");
        }
        get state() {
            return this.m;
        }
        set state(a) {
            this.m = a;
            this.g("State");
        }
    }
    WebForOfDataChangingEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebForOfDataChangingEventArgsDetailDescription, 'WebForOfDataChangingEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebForOfDataChangingEventArgsDetailDescription.__marshalByValue1 = true;
    WebForOfDataChangingEventArgsDetailDescription.__marshalByValueAlias1 = "ForOfDataChangingEventArgsDetail";
    return WebForOfDataChangingEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebForOfDataChangingEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebForOfDataChangingEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebForOfDataChangingEventArgsDetailDescriptionMetadata.a == null) {
                WebForOfDataChangingEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebForOfDataChangingEventArgsDetailDescriptionMetadata.c(WebForOfDataChangingEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebForOfDataChangingEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebForOfDataChangingEventArgsDetailDescriptionMetadata.a);
            WebForOfStateDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ForOfDataChangingEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("ContainerSize", "Number:double");
            a.item("State", "ExportedType:WebForOfState");
        }
        static d(a) {
            WebForOfDataChangingEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebForOfDataChangingEventArgsDetail", () => new WebForOfDataChangingEventArgsDetailDescription());
            a.ad("WebForOfDataChangingEventArgsDetail", WebForOfDataChangingEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebForOfDataChangingEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebForOfDataChangingEventArgsDetailDescriptionMetadata, 'WebForOfDataChangingEventArgsDetailDescriptionMetadata');
    WebForOfDataChangingEventArgsDetailDescriptionMetadata.a = null;
    return WebForOfDataChangingEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebForOfDataChangingEventArgsDescription = /*@__PURE__*/ (() => {
    class WebForOfDataChangingEventArgsDescription extends Description {
        get_type() {
            return "WebForOfDataChangingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebForOfDataChangingEventArgsDescription.$t = /*@__PURE__*/ markType(WebForOfDataChangingEventArgsDescription, 'WebForOfDataChangingEventArgsDescription', Description.$);
    WebForOfDataChangingEventArgsDescription.__marshalByValue = true;
    WebForOfDataChangingEventArgsDescription.__marshalByValueAlias = "ForOfDataChangingEventArgs";
    return WebForOfDataChangingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebForOfDataChangingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebForOfDataChangingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebForOfDataChangingEventArgsDescriptionMetadata.a == null) {
                WebForOfDataChangingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebForOfDataChangingEventArgsDescriptionMetadata.c(WebForOfDataChangingEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebForOfDataChangingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebForOfDataChangingEventArgsDescriptionMetadata.a);
            WebForOfDataChangingEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ForOfDataChangingEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebForOfDataChangingEventArgsDetail");
        }
        static d(a) {
            WebForOfDataChangingEventArgsDescriptionMetadata.b(a);
            a.ae("WebForOfDataChangingEventArgs", () => new WebForOfDataChangingEventArgsDescription());
            a.ad("WebForOfDataChangingEventArgs", WebForOfDataChangingEventArgsDescriptionMetadata.a);
        }
    }
    WebForOfDataChangingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebForOfDataChangingEventArgsDescriptionMetadata, 'WebForOfDataChangingEventArgsDescriptionMetadata');
    WebForOfDataChangingEventArgsDescriptionMetadata.a = null;
    return WebForOfDataChangingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridContextMenuEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGridContextMenuEventArgsDescription extends Description {
        get_type() {
            return "WebGridContextMenuEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGridContextMenuEventArgsDescription.$t = /*@__PURE__*/ markType(WebGridContextMenuEventArgsDescription, 'WebGridContextMenuEventArgsDescription', Description.$);
    WebGridContextMenuEventArgsDescription.__marshalByValue = true;
    WebGridContextMenuEventArgsDescription.__marshalByValueAlias = "GridContextMenuEventArgs";
    return WebGridContextMenuEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridContextMenuEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebGridContextMenuEventArgsDetailDescription extends Description {
        get_type() {
            return "WebGridContextMenuEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.m = null;
            this.j = null;
        }
        get cell() {
            return this.h;
        }
        set cell(a) {
            this.h = a;
            this.g("Cell");
        }
        get event() {
            return this.m;
        }
        set event(a) {
            this.m = a;
            this.g("Event");
        }
        get row() {
            return this.j;
        }
        set row(a) {
            this.j = a;
            this.g("Row");
        }
    }
    WebGridContextMenuEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebGridContextMenuEventArgsDetailDescription, 'WebGridContextMenuEventArgsDetailDescription', Description.$);
    WebGridContextMenuEventArgsDetailDescription.__marshalByValue = true;
    WebGridContextMenuEventArgsDetailDescription.__marshalByValueAlias = "GridContextMenuEventArgsDetail";
    return WebGridContextMenuEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridRowEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGridRowEventArgsDescription extends Description {
        get_type() {
            return "WebGridRowEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGridRowEventArgsDescription.$t = /*@__PURE__*/ markType(WebGridRowEventArgsDescription, 'WebGridRowEventArgsDescription', Description.$);
    WebGridRowEventArgsDescription.__marshalByValue = true;
    WebGridRowEventArgsDescription.__marshalByValueAlias = "GridRowEventArgs";
    return WebGridRowEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridRowEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebGridRowEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebGridRowEventArgsDetail";
        }
        constructor() {
            super();
            this.m = null;
            this.p = null;
        }
        get row() {
            return this.m;
        }
        set row(a) {
            this.m = a;
            this.g("Row");
        }
        get event() {
            return this.p;
        }
        set event(a) {
            this.p = a;
            this.g("Event");
        }
    }
    WebGridRowEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebGridRowEventArgsDetailDescription, 'WebGridRowEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebGridRowEventArgsDetailDescription.__marshalByValue1 = true;
    WebGridRowEventArgsDetailDescription.__marshalByValueAlias1 = "GridRowEventArgsDetail";
    return WebGridRowEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridCellEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGridCellEventArgsDescription extends Description {
        get_type() {
            return "WebGridCellEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGridCellEventArgsDescription.$t = /*@__PURE__*/ markType(WebGridCellEventArgsDescription, 'WebGridCellEventArgsDescription', Description.$);
    WebGridCellEventArgsDescription.__marshalByValue = true;
    WebGridCellEventArgsDescription.__marshalByValueAlias = "GridCellEventArgs";
    return WebGridCellEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridCellEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebGridCellEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebGridCellEventArgsDetail";
        }
        constructor() {
            super();
            this.m = null;
            this.p = null;
        }
        get cell() {
            return this.m;
        }
        set cell(a) {
            this.m = a;
            this.g("Cell");
        }
        get event() {
            return this.p;
        }
        set event(a) {
            this.p = a;
            this.g("Event");
        }
    }
    WebGridCellEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebGridCellEventArgsDetailDescription, 'WebGridCellEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebGridCellEventArgsDetailDescription.__marshalByValue1 = true;
    WebGridCellEventArgsDetailDescription.__marshalByValueAlias1 = "GridCellEventArgsDetail";
    return WebGridCellEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridEditDoneEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGridEditDoneEventArgsDescription extends Description {
        get_type() {
            return "WebGridEditDoneEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGridEditDoneEventArgsDescription.$t = /*@__PURE__*/ markType(WebGridEditDoneEventArgsDescription, 'WebGridEditDoneEventArgsDescription', Description.$);
    WebGridEditDoneEventArgsDescription.__marshalByValue = true;
    WebGridEditDoneEventArgsDescription.__marshalByValueAlias = "GridEditDoneEventArgs";
    return WebGridEditDoneEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridEditDoneEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebGridEditDoneEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebGridEditDoneEventArgsDetail";
        }
        constructor() {
            super();
            this.ab = null;
            this.z = null;
            this.ac = null;
            this.q = null;
            this.aa = null;
            this.y = null;
            this.x = null;
            this.m = null;
            this.o = null;
            this.t = false;
            this.u = false;
        }
        get rowID() {
            return this.ab;
        }
        set rowID(a) {
            this.ab = a;
            this.g("RowID");
        }
        get primaryKey() {
            return this.z;
        }
        set primaryKey(a) {
            this.z = a;
            this.g("PrimaryKey");
        }
        get rowKey() {
            return this.ac;
        }
        set rowKey(a) {
            this.ac = a;
            this.g("RowKey");
        }
        get cellID() {
            return this.q;
        }
        set cellID(a) {
            this.q = a;
            this.g("CellID");
        }
        get rowData() {
            return this.aa;
        }
        set rowData(a) {
            this.aa = a;
            this.g("RowData");
        }
        get oldValue() {
            return this.y;
        }
        set oldValue(a) {
            this.y = a;
            this.g("OldValue");
        }
        get newValue() {
            return this.x;
        }
        set newValue(a) {
            this.x = a;
            this.g("NewValue");
        }
        get column() {
            return this.m;
        }
        set column(a) {
            this.m = a;
            this.g("Column");
        }
        get owner() {
            return this.o;
        }
        set owner(a) {
            this.o = a;
            this.g("Owner");
        }
        get isAddRow() {
            return this.t;
        }
        set isAddRow(a) {
            this.t = a;
            this.g("IsAddRow");
        }
        get valid() {
            return this.u;
        }
        set valid(a) {
            this.u = a;
            this.g("Valid");
        }
    }
    WebGridEditDoneEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebGridEditDoneEventArgsDetailDescription, 'WebGridEditDoneEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebGridEditDoneEventArgsDetailDescription.__marshalByValue1 = true;
    WebGridEditDoneEventArgsDetailDescription.__marshalByValueAlias1 = "GridEditDoneEventArgsDetail";
    return WebGridEditDoneEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridEditEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGridEditEventArgsDescription extends Description {
        get_type() {
            return "WebGridEditEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGridEditEventArgsDescription.$t = /*@__PURE__*/ markType(WebGridEditEventArgsDescription, 'WebGridEditEventArgsDescription', Description.$);
    WebGridEditEventArgsDescription.__marshalByValue = true;
    WebGridEditEventArgsDescription.__marshalByValueAlias = "GridEditEventArgs";
    return WebGridEditEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridEditEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebGridEditEventArgsDetailDescription extends Description {
        get_type() {
            return "WebGridEditEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.o = false;
            this.y = null;
            this.w = null;
            this.z = null;
            this.l = null;
            this.x = null;
            this.v = null;
            this.u = null;
            this.h = null;
            this.j = null;
            this.p = false;
            this.q = false;
        }
        get cancel() {
            return this.o;
        }
        set cancel(a) {
            this.o = a;
            this.g("Cancel");
        }
        get rowID() {
            return this.y;
        }
        set rowID(a) {
            this.y = a;
            this.g("RowID");
        }
        get primaryKey() {
            return this.w;
        }
        set primaryKey(a) {
            this.w = a;
            this.g("PrimaryKey");
        }
        get rowKey() {
            return this.z;
        }
        set rowKey(a) {
            this.z = a;
            this.g("RowKey");
        }
        get cellID() {
            return this.l;
        }
        set cellID(a) {
            this.l = a;
            this.g("CellID");
        }
        get rowData() {
            return this.x;
        }
        set rowData(a) {
            this.x = a;
            this.g("RowData");
        }
        get oldValue() {
            return this.v;
        }
        set oldValue(a) {
            this.v = a;
            this.g("OldValue");
        }
        get newValue() {
            return this.u;
        }
        set newValue(a) {
            this.u = a;
            this.g("NewValue");
        }
        get column() {
            return this.h;
        }
        set column(a) {
            this.h = a;
            this.g("Column");
        }
        get owner() {
            return this.j;
        }
        set owner(a) {
            this.j = a;
            this.g("Owner");
        }
        get isAddRow() {
            return this.p;
        }
        set isAddRow(a) {
            this.p = a;
            this.g("IsAddRow");
        }
        get valid() {
            return this.q;
        }
        set valid(a) {
            this.q = a;
            this.g("Valid");
        }
    }
    WebGridEditEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebGridEditEventArgsDetailDescription, 'WebGridEditEventArgsDetailDescription', Description.$);
    WebGridEditEventArgsDetailDescription.__marshalByValue = true;
    WebGridEditEventArgsDetailDescription.__marshalByValueAlias = "GridEditEventArgsDetail";
    return WebGridEditEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridFormGroupCreatedEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGridFormGroupCreatedEventArgsDescription extends Description {
        get_type() {
            return "WebGridFormGroupCreatedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGridFormGroupCreatedEventArgsDescription.$t = /*@__PURE__*/ markType(WebGridFormGroupCreatedEventArgsDescription, 'WebGridFormGroupCreatedEventArgsDescription', Description.$);
    WebGridFormGroupCreatedEventArgsDescription.__marshalByValue = true;
    WebGridFormGroupCreatedEventArgsDescription.__marshalByValueAlias = "GridFormGroupCreatedEventArgs";
    return WebGridFormGroupCreatedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridFormGroupCreatedEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebGridFormGroupCreatedEventArgsDetailDescription extends Description {
        get_type() {
            return "WebGridFormGroupCreatedEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get owner() {
            return this.h;
        }
        set owner(a) {
            this.h = a;
            this.g("Owner");
        }
    }
    WebGridFormGroupCreatedEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebGridFormGroupCreatedEventArgsDetailDescription, 'WebGridFormGroupCreatedEventArgsDetailDescription', Description.$);
    WebGridFormGroupCreatedEventArgsDetailDescription.__marshalByValue = true;
    WebGridFormGroupCreatedEventArgsDetailDescription.__marshalByValueAlias = "GridFormGroupCreatedEventArgsDetail";
    return WebGridFormGroupCreatedEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarExportEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGridToolbarExportEventArgsDescription extends Description {
        get_type() {
            return "WebGridToolbarExportEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGridToolbarExportEventArgsDescription.$t = /*@__PURE__*/ markType(WebGridToolbarExportEventArgsDescription, 'WebGridToolbarExportEventArgsDescription', Description.$);
    WebGridToolbarExportEventArgsDescription.__marshalByValue = true;
    WebGridToolbarExportEventArgsDescription.__marshalByValueAlias = "GridToolbarExportEventArgs";
    return WebGridToolbarExportEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebExporterOptionsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebExporterOptionsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (WebExporterOptionsBaseDescriptionMetadata.a == null) {
                WebExporterOptionsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebExporterOptionsBaseDescriptionMetadata.c(WebExporterOptionsBaseDescriptionMetadata.a);
            }
            if (a.k(WebExporterOptionsBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebExporterOptionsBaseDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ExporterOptionsBase");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("IgnoreColumnsVisibility", "Boolean");
            a.item("IgnoreFiltering", "Boolean");
            a.item("IgnoreColumnsOrder", "Boolean");
            a.item("IgnoreSorting", "Boolean");
            a.item("IgnoreGrouping", "Boolean");
            a.item("IgnoreMultiColumnHeaders", "Boolean");
            a.item("ExportSummaries", "Boolean");
            a.item("FreezeHeaders", "Boolean");
            a.item("AlwaysExportHeaders", "Boolean");
            a.item("FileName", "String");
        }
        static d(a) {
            WebExporterOptionsBaseDescriptionMetadata.b(a);
            a.ad("WebExporterOptionsBase", WebExporterOptionsBaseDescriptionMetadata.a);
        }
    }
    WebExporterOptionsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(WebExporterOptionsBaseDescriptionMetadata, 'WebExporterOptionsBaseDescriptionMetadata');
    WebExporterOptionsBaseDescriptionMetadata.a = null;
    return WebExporterOptionsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarExportEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebGridToolbarExportEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebGridToolbarExportEventArgsDetail";
        }
        constructor() {
            super();
            this.q = null;
            this.m = null;
            this.o = null;
            this.t = false;
        }
        get grid() {
            return this.q;
        }
        set grid(a) {
            this.q = a;
            this.g("Grid");
        }
        get exporter() {
            return this.m;
        }
        set exporter(a) {
            this.m = a;
            this.g("Exporter");
        }
        get options() {
            return this.o;
        }
        set options(a) {
            this.o = a;
            this.g("Options");
        }
        get cancel() {
            return this.t;
        }
        set cancel(a) {
            this.t = a;
            this.g("Cancel");
        }
    }
    WebGridToolbarExportEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebGridToolbarExportEventArgsDetailDescription, 'WebGridToolbarExportEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebGridToolbarExportEventArgsDetailDescription.__marshalByValue1 = true;
    WebGridToolbarExportEventArgsDetailDescription.__marshalByValueAlias1 = "GridToolbarExportEventArgsDetail";
    return WebGridToolbarExportEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridValidationStatusEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGridValidationStatusEventArgsDescription extends Description {
        get_type() {
            return "WebGridValidationStatusEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGridValidationStatusEventArgsDescription.$t = /*@__PURE__*/ markType(WebGridValidationStatusEventArgsDescription, 'WebGridValidationStatusEventArgsDescription', Description.$);
    WebGridValidationStatusEventArgsDescription.__marshalByValue = true;
    WebGridValidationStatusEventArgsDescription.__marshalByValueAlias = "GridValidationStatusEventArgs";
    return WebGridValidationStatusEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridValidationStatusEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebGridValidationStatusEventArgsDetailDescription extends Description {
        get_type() {
            return "WebGridValidationStatusEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.h = null;
        }
        get status() {
            return this.l;
        }
        set status(a) {
            this.l = a;
            this.g("Status");
        }
        get owner() {
            return this.h;
        }
        set owner(a) {
            this.h = a;
            this.g("Owner");
        }
    }
    WebGridValidationStatusEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebGridValidationStatusEventArgsDetailDescription, 'WebGridValidationStatusEventArgsDetailDescription', Description.$);
    WebGridValidationStatusEventArgsDetailDescription.__marshalByValue = true;
    WebGridValidationStatusEventArgsDetailDescription.__marshalByValueAlias = "GridValidationStatusEventArgsDetail";
    return WebGridValidationStatusEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPinRowEventArgsDescription = /*@__PURE__*/ (() => {
    class WebPinRowEventArgsDescription extends Description {
        get_type() {
            return "WebPinRowEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebPinRowEventArgsDescription.$t = /*@__PURE__*/ markType(WebPinRowEventArgsDescription, 'WebPinRowEventArgsDescription', Description.$);
    WebPinRowEventArgsDescription.__marshalByValue = true;
    WebPinRowEventArgsDescription.__marshalByValueAlias = "PinRowEventArgs";
    return WebPinRowEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPinRowEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebPinRowEventArgsDetailDescription extends Description {
        get_type() {
            return "WebPinRowEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.r = null;
            this.s = null;
            this.h = null;
            this.o = 0;
            this.l = false;
            this.q = null;
            this.k = false;
        }
        get rowID() {
            return this.r;
        }
        set rowID(a) {
            this.r = a;
            this.g("RowID");
        }
        get rowKey() {
            return this.s;
        }
        set rowKey(a) {
            this.s = a;
            this.g("RowKey");
        }
        get row() {
            return this.h;
        }
        set row(a) {
            this.h = a;
            this.g("Row");
        }
        get insertAtIndex() {
            return this.o;
        }
        set insertAtIndex(a) {
            this.o = a;
            this.g("InsertAtIndex");
        }
        get isPinned() {
            return this.l;
        }
        set isPinned(a) {
            this.l = a;
            this.g("IsPinned");
        }
        get owner() {
            return this.q;
        }
        set owner(a) {
            this.q = a;
            this.g("Owner");
        }
        get cancel() {
            return this.k;
        }
        set cancel(a) {
            this.k = a;
            this.g("Cancel");
        }
    }
    WebPinRowEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebPinRowEventArgsDetailDescription, 'WebPinRowEventArgsDetailDescription', Description.$);
    WebPinRowEventArgsDetailDescription.__marshalByValue = true;
    WebPinRowEventArgsDetailDescription.__marshalByValueAlias = "PinRowEventArgsDetail";
    return WebPinRowEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowDataCancelableEventArgsDescription = /*@__PURE__*/ (() => {
    class WebRowDataCancelableEventArgsDescription extends Description {
        get_type() {
            return "WebRowDataCancelableEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebRowDataCancelableEventArgsDescription.$t = /*@__PURE__*/ markType(WebRowDataCancelableEventArgsDescription, 'WebRowDataCancelableEventArgsDescription', Description.$);
    WebRowDataCancelableEventArgsDescription.__marshalByValue = true;
    WebRowDataCancelableEventArgsDescription.__marshalByValueAlias = "RowDataCancelableEventArgs";
    return WebRowDataCancelableEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowDataCancelableEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebRowDataCancelableEventArgsDetailDescription extends Description {
        get_type() {
            return "WebRowDataCancelableEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.q = null;
            this.p = null;
            this.m = false;
            this.h = null;
            this.o = null;
            this.s = null;
            this.r = null;
            this.t = null;
        }
        get cellID() {
            return this.j;
        }
        set cellID(a) {
            this.j = a;
            this.g("CellID");
        }
        get oldValue() {
            return this.q;
        }
        set oldValue(a) {
            this.q = a;
            this.g("OldValue");
        }
        get newValue() {
            return this.p;
        }
        set newValue(a) {
            this.p = a;
            this.g("NewValue");
        }
        get isAddRow() {
            return this.m;
        }
        set isAddRow(a) {
            this.m = a;
            this.g("IsAddRow");
        }
        get owner() {
            return this.h;
        }
        set owner(a) {
            this.h = a;
            this.g("Owner");
        }
        get data() {
            return this.o;
        }
        set data(a) {
            this.o = a;
            this.g("Data");
        }
        get rowData() {
            return this.s;
        }
        set rowData(a) {
            this.s = a;
            this.g("RowData");
        }
        get primaryKey() {
            return this.r;
        }
        set primaryKey(a) {
            this.r = a;
            this.g("PrimaryKey");
        }
        get rowKey() {
            return this.t;
        }
        set rowKey(a) {
            this.t = a;
            this.g("RowKey");
        }
    }
    WebRowDataCancelableEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebRowDataCancelableEventArgsDetailDescription, 'WebRowDataCancelableEventArgsDetailDescription', Description.$);
    WebRowDataCancelableEventArgsDetailDescription.__marshalByValue = true;
    WebRowDataCancelableEventArgsDetailDescription.__marshalByValueAlias = "RowDataCancelableEventArgsDetail";
    return WebRowDataCancelableEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowDragEndEventArgsDescription = /*@__PURE__*/ (() => {
    class WebRowDragEndEventArgsDescription extends Description {
        get_type() {
            return "WebRowDragEndEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebRowDragEndEventArgsDescription.$t = /*@__PURE__*/ markType(WebRowDragEndEventArgsDescription, 'WebRowDragEndEventArgsDescription', Description.$);
    WebRowDragEndEventArgsDescription.__marshalByValue = true;
    WebRowDragEndEventArgsDescription.__marshalByValueAlias = "RowDragEndEventArgs";
    return WebRowDragEndEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowDragEndEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebRowDragEndEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebRowDragEndEventArgsDetail";
        }
        constructor() {
            super();
            this.r = null;
            this.m = null;
            this.p = false;
        }
        get dragDirective() {
            return this.r;
        }
        set dragDirective(a) {
            this.r = a;
            this.g("DragDirective");
        }
        get dragData() {
            return this.m;
        }
        set dragData(a) {
            this.m = a;
            this.g("DragData");
        }
        get animation() {
            return this.p;
        }
        set animation(a) {
            this.p = a;
            this.g("Animation");
        }
    }
    WebRowDragEndEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebRowDragEndEventArgsDetailDescription, 'WebRowDragEndEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebRowDragEndEventArgsDetailDescription.__marshalByValue1 = true;
    WebRowDragEndEventArgsDetailDescription.__marshalByValueAlias1 = "RowDragEndEventArgsDetail";
    return WebRowDragEndEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowDragStartEventArgsDescription = /*@__PURE__*/ (() => {
    class WebRowDragStartEventArgsDescription extends Description {
        get_type() {
            return "WebRowDragStartEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebRowDragStartEventArgsDescription.$t = /*@__PURE__*/ markType(WebRowDragStartEventArgsDescription, 'WebRowDragStartEventArgsDescription', Description.$);
    WebRowDragStartEventArgsDescription.__marshalByValue = true;
    WebRowDragStartEventArgsDescription.__marshalByValueAlias = "RowDragStartEventArgs";
    return WebRowDragStartEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowDragStartEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebRowDragStartEventArgsDetailDescription extends Description {
        get_type() {
            return "WebRowDragStartEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.m = null;
            this.h = null;
            this.k = false;
            this.n = null;
        }
        get dragDirective() {
            return this.m;
        }
        set dragDirective(a) {
            this.m = a;
            this.g("DragDirective");
        }
        get dragData() {
            return this.h;
        }
        set dragData(a) {
            this.h = a;
            this.g("DragData");
        }
        get cancel() {
            return this.k;
        }
        set cancel(a) {
            this.k = a;
            this.g("Cancel");
        }
        get owner() {
            return this.n;
        }
        set owner(a) {
            this.n = a;
            this.g("Owner");
        }
    }
    WebRowDragStartEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebRowDragStartEventArgsDetailDescription, 'WebRowDragStartEventArgsDetailDescription', Description.$);
    WebRowDragStartEventArgsDetailDescription.__marshalByValue = true;
    WebRowDragStartEventArgsDetailDescription.__marshalByValueAlias = "RowDragStartEventArgsDetail";
    return WebRowDragStartEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupByRecordDescription = /*@__PURE__*/ (() => {
    class WebGroupByRecordDescription extends Description {
        get_type() {
            return "WebGroupByRecord";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.q = 0;
            this.v = null;
            this.t = null;
            this.l = null;
            this.h = null;
            this.p = 0;
            this.j = null;
        }
        get expression() {
            return this.n;
        }
        set expression(a) {
            this.n = a;
            this.g("Expression");
        }
        get level() {
            return this.q;
        }
        set level(a) {
            this.q = a;
            this.g("Level");
        }
        get recordsRef() {
            return this.v;
        }
        set recordsRef(a) {
            this.v = a;
            this.g("RecordsRef");
        }
        get value() {
            return this.t;
        }
        set value(a) {
            this.t = a;
            this.g("Value");
        }
        get groupParent() {
            return this.l;
        }
        set groupParent(a) {
            this.l = a;
            this.g("GroupParent");
        }
        get groups() {
            return this.h;
        }
        set groups(a) {
            this.h = a;
            this.g("Groups");
        }
        get height() {
            return this.p;
        }
        set height(a) {
            this.p = a;
            this.g("Height");
        }
        get column() {
            return this.j;
        }
        set column(a) {
            this.j = a;
            this.g("Column");
        }
    }
    WebGroupByRecordDescription.$t = /*@__PURE__*/ markType(WebGroupByRecordDescription, 'WebGroupByRecordDescription', Description.$);
    return WebGroupByRecordDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupByRecordDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGroupByRecordDescriptionMetadata extends Base {
        static b(a) {
            if (WebGroupByRecordDescriptionMetadata.a == null) {
                WebGroupByRecordDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGroupByRecordDescriptionMetadata.c(WebGroupByRecordDescriptionMetadata.a);
            }
            if (a.k(WebGroupByRecordDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGroupByRecordDescriptionMetadata.a);
            WebSortingExpressionDescriptionMetadata.d(a);
            WebGroupByRecordDescriptionMetadata.d(a);
            WebColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GroupByRecord");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("Expression", "ExportedType:WebSortingExpression");
            a.item("Level", "Number:double");
            a.item("RecordsRef", "(w:Records,wf:Records)DataRef:object");
            a.item("Value", "Unknown");
            a.item("GroupParent", "ExportedType:WebGroupByRecord");
            a.item("Groups", "Array:WebGroupByRecordDescription:GroupByRecord");
            a.item("Height", "Number:double");
            a.item("Column", "ExportedType:WebColumn");
        }
        static d(a) {
            WebGroupByRecordDescriptionMetadata.b(a);
            a.ae("WebGroupByRecord", () => new WebGroupByRecordDescription());
            a.ad("WebGroupByRecord", WebGroupByRecordDescriptionMetadata.a);
        }
    }
    WebGroupByRecordDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGroupByRecordDescriptionMetadata, 'WebGroupByRecordDescriptionMetadata');
    WebGroupByRecordDescriptionMetadata.a = null;
    return WebGroupByRecordDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeGridRecordDescription = /*@__PURE__*/ (() => {
    class WebTreeGridRecordDescription extends Description {
        get_type() {
            return "WebTreeGridRecord";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.t = null;
            this.s = null;
            this.h = null;
            this.j = null;
            this.q = 0;
            this.n = false;
            this.m = false;
        }
        get key() {
            return this.t;
        }
        set key(a) {
            this.t = a;
            this.g("Key");
        }
        get data() {
            return this.s;
        }
        set data(a) {
            this.s = a;
            this.g("Data");
        }
        get children() {
            return this.h;
        }
        set children(a) {
            this.h = a;
            this.g("Children");
        }
        get recordParent() {
            return this.j;
        }
        set recordParent(a) {
            this.j = a;
            this.g("RecordParent");
        }
        get level() {
            return this.q;
        }
        set level(a) {
            this.q = a;
            this.g("Level");
        }
        get isFilteredOutParent() {
            return this.n;
        }
        set isFilteredOutParent(a) {
            this.n = a;
            this.g("IsFilteredOutParent");
        }
        get expanded() {
            return this.m;
        }
        set expanded(a) {
            this.m = a;
            this.g("Expanded");
        }
    }
    WebTreeGridRecordDescription.$t = /*@__PURE__*/ markType(WebTreeGridRecordDescription, 'WebTreeGridRecordDescription', Description.$);
    WebTreeGridRecordDescription.__marshalByValue = true;
    WebTreeGridRecordDescription.__marshalByValueAlias = "TreeGridRecord";
    return WebTreeGridRecordDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeGridRecordDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTreeGridRecordDescriptionMetadata extends Base {
        static b(a) {
            if (WebTreeGridRecordDescriptionMetadata.a == null) {
                WebTreeGridRecordDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTreeGridRecordDescriptionMetadata.c(WebTreeGridRecordDescriptionMetadata.a);
            }
            if (a.k(WebTreeGridRecordDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTreeGridRecordDescriptionMetadata.a);
            WebTreeGridRecordDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:TreeGridRecord");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Key", "Unknown");
            a.item("Data", "Unknown");
            a.item("Children", "Array:WebTreeGridRecordDescription:TreeGridRecord");
            a.item("RecordParent", "(wc:Parent)ExportedType:WebTreeGridRecord");
            a.item("Level", "Number:double");
            a.item("IsFilteredOutParent", "Boolean");
            a.item("Expanded", "Boolean");
        }
        static d(a) {
            WebTreeGridRecordDescriptionMetadata.b(a);
            a.ae("WebTreeGridRecord", () => new WebTreeGridRecordDescription());
            a.ad("WebTreeGridRecord", WebTreeGridRecordDescriptionMetadata.a);
        }
    }
    WebTreeGridRecordDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTreeGridRecordDescriptionMetadata, 'WebTreeGridRecordDescriptionMetadata');
    WebTreeGridRecordDescriptionMetadata.a = null;
    return WebTreeGridRecordDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseExporterDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebBaseExporterDescriptionMetadata extends Base {
        static b(a) {
            if (WebBaseExporterDescriptionMetadata.a == null) {
                WebBaseExporterDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebBaseExporterDescriptionMetadata.c(WebBaseExporterDescriptionMetadata.a);
            }
            if (a.k(WebBaseExporterDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebBaseExporterDescriptionMetadata.a);
            WebBaseEventArgsDescriptionMetadata.d(a);
            WebRowExportingEventArgsDescriptionMetadata.d(a);
            WebColumnExportingEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:BaseExporter");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("ExportEndedRef", "EventRef::exportEnded:customEvent");
            a.item("RowExportingRef", "EventRef::rowExporting:customEvent");
            a.item("ColumnExportingRef", "EventRef::columnExporting:customEvent");
        }
        static d(a) {
            WebBaseExporterDescriptionMetadata.b(a);
            a.ad("WebBaseExporter", WebBaseExporterDescriptionMetadata.a);
        }
    }
    WebBaseExporterDescriptionMetadata.$t = /*@__PURE__*/ markType(WebBaseExporterDescriptionMetadata, 'WebBaseExporterDescriptionMetadata');
    WebBaseExporterDescriptionMetadata.a = null;
    return WebBaseExporterDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebCellTypeDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCellTypeDescriptionMetadata extends Base {
        static b(a) {
            if (WebCellTypeDescriptionMetadata.a == null) {
                WebCellTypeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCellTypeDescriptionMetadata.c(WebCellTypeDescriptionMetadata.a);
            }
            if (a.k(WebCellTypeDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCellTypeDescriptionMetadata.a);
            WebColumnDescriptionMetadata.d(a);
            WebRowTypeDescriptionMetadata.d(a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
            WebGridCellIdentifierDescriptionMetadata.d(a);
            WebGridValidationStateDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CellType");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__manageCollectionInMarkup", "Boolean");
            a.item("Value", "Unknown");
            a.item("EditValue", "Unknown");
            a.item("Selected", "Boolean");
            a.item("Active", "Boolean");
            a.item("Editable", "Boolean");
            a.item("EditMode", "Boolean");
            a.item("Column", "ExportedType:WebColumn");
            a.item("Row", "ExportedType:WebRowType");
            a.item("Grid", "ExportedType:WebGridBaseDirective");
            a.item("Id", "ExportedType:WebGridCellIdentifier");
            a.item("CellID", "Unknown");
            a.item("Validation", "ExportedType:WebGridValidationState");
            a.item("Readonly", "Boolean");
            a.item("Title", "Unknown");
            a.item("Width", "String");
            a.item("VisibleColumnIndex", "Number:double");
        }
        static d(a) {
            WebCellTypeDescriptionMetadata.b(a);
            a.ae("WebCellType", () => new WebCellTypeDescription());
            a.ad("WebCellType", WebCellTypeDescriptionMetadata.a);
        }
    }
    WebCellTypeDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCellTypeDescriptionMetadata, 'WebCellTypeDescriptionMetadata');
    WebCellTypeDescriptionMetadata.a = null;
    return WebCellTypeDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebColumnExportingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnExportingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnExportingEventArgsDescriptionMetadata.a == null) {
                WebColumnExportingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnExportingEventArgsDescriptionMetadata.c(WebColumnExportingEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebColumnExportingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnExportingEventArgsDescriptionMetadata.a);
            WebColumnExportingEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnExportingEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebColumnExportingEventArgsDetail");
        }
        static d(a) {
            WebColumnExportingEventArgsDescriptionMetadata.b(a);
            a.ae("WebColumnExportingEventArgs", () => new WebColumnExportingEventArgsDescription());
            a.ad("WebColumnExportingEventArgs", WebColumnExportingEventArgsDescriptionMetadata.a);
        }
    }
    WebColumnExportingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnExportingEventArgsDescriptionMetadata, 'WebColumnExportingEventArgsDescriptionMetadata');
    WebColumnExportingEventArgsDescriptionMetadata.a = null;
    return WebColumnExportingEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebColumnExportingEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnExportingEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnExportingEventArgsDetailDescriptionMetadata.a == null) {
                WebColumnExportingEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnExportingEventArgsDetailDescriptionMetadata.c(WebColumnExportingEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebColumnExportingEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnExportingEventArgsDetailDescriptionMetadata.a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ColumnExportingEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Header", "String");
            a.item("Field", "String");
            a.item("ColumnIndex", "Number:double");
            a.item("Cancel", "Boolean");
            a.item("SkipFormatter", "Boolean");
            a.item("Grid", "ExportedType:WebGridBaseDirective");
        }
        static d(a) {
            WebColumnExportingEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebColumnExportingEventArgsDetail", () => new WebColumnExportingEventArgsDetailDescription());
            a.ad("WebColumnExportingEventArgsDetail", WebColumnExportingEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebColumnExportingEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnExportingEventArgsDetailDescriptionMetadata, 'WebColumnExportingEventArgsDetailDescriptionMetadata');
    WebColumnExportingEventArgsDetailDescriptionMetadata.a = null;
    return WebColumnExportingEventArgsDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridBaseDirectiveDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridBaseDirectiveDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridBaseDirectiveDescriptionMetadata.a == null) {
                WebGridBaseDirectiveDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridBaseDirectiveDescriptionMetadata.c(WebGridBaseDirectiveDescriptionMetadata.a);
            }
            if (a.k(WebGridBaseDirectiveDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridBaseDirectiveDescriptionMetadata.a);
            WebDataCloneStrategyDescriptionMetadata.d(a);
            WebClipboardOptionsDescriptionMetadata.d(a);
            WebGridResourceStringsDescriptionMetadata.d(a);
            WebFilteringExpressionsTreeDescriptionMetadata.d(a);
            WebPinningConfigDescriptionMetadata.d(a);
            WebFilteringStrategyDescriptionMetadata.d(a);
            WebGridSortingStrategyDescriptionMetadata.d(a);
            WebSortingOptionsDescriptionMetadata.d(a);
            WebSortingExpressionDescriptionMetadata.d(a);
            WebOverlayOutletDirectiveDescriptionMetadata.d(a);
            WebFilteringExpressionsTreeEventArgsDescriptionMetadata.d(a);
            WebGridScrollEventArgsDescriptionMetadata.d(a);
            WebGridCellEventArgsDescriptionMetadata.d(a);
            WebGridRowEventArgsDescriptionMetadata.d(a);
            WebGridFormGroupCreatedEventArgsDescriptionMetadata.d(a);
            WebGridValidationStatusEventArgsDescriptionMetadata.d(a);
            WebRowSelectionEventArgsDescriptionMetadata.d(a);
            WebColumnSelectionEventArgsDescriptionMetadata.d(a);
            WebPinColumnCancellableEventArgsDescriptionMetadata.d(a);
            WebPinColumnEventArgsDescriptionMetadata.d(a);
            WebGridEditEventArgsDescriptionMetadata.d(a);
            WebGridEditDoneEventArgsDescriptionMetadata.d(a);
            WebColumnComponentEventArgsDescriptionMetadata.d(a);
            WebColumnsAutoGeneratedEventArgsDescriptionMetadata.d(a);
            WebSortingEventArgsDescriptionMetadata.d(a);
            WebSortingExpressionEventArgsDescriptionMetadata.d(a);
            WebFilteringEventArgsDescriptionMetadata.d(a);
            WebRowDataEventArgsDescriptionMetadata.d(a);
            WebRowDataCancelableEventArgsDescriptionMetadata.d(a);
            WebColumnResizeEventArgsDescriptionMetadata.d(a);
            WebGridContextMenuEventArgsDescriptionMetadata.d(a);
            WebColumnVisibilityChangingEventArgsDescriptionMetadata.d(a);
            WebColumnVisibilityChangedEventArgsDescriptionMetadata.d(a);
            WebColumnMovingStartEventArgsDescriptionMetadata.d(a);
            WebColumnMovingEventArgsDescriptionMetadata.d(a);
            WebColumnMovingEndEventArgsDescriptionMetadata.d(a);
            WebGridKeydownEventArgsDescriptionMetadata.d(a);
            WebRowDragStartEventArgsDescriptionMetadata.d(a);
            WebRowDragEndEventArgsDescriptionMetadata.d(a);
            WebGridClipboardEventEventArgsDescriptionMetadata.d(a);
            WebRowToggleEventArgsDescriptionMetadata.d(a);
            WebPinRowEventArgsDescriptionMetadata.d(a);
            WebActiveNodeChangeEventArgsDescriptionMetadata.d(a);
            WebGridToolbarExportEventArgsDescriptionMetadata.d(a);
            WebGridSelectionRangeEventArgsDescriptionMetadata.d(a);
            VoidEventArgsDescriptionMetadata.d(a);
            WebForOfDataChangingEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridBaseDirective");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("SnackbarDisplayTime", "Number:double");
            a.item("AutoGenerate", "Boolean");
            a.item("AutoGenerateExclude", "Array:string");
            a.item("Moving", "Boolean");
            a.item("EmptyGridTemplateRef", "(w:EmptyGridTemplate,wf:EmptyGridTemplate)TemplateRef::object");
            a.item("AddRowEmptyTemplateRef", "(w:AddRowEmptyTemplate,wf:AddRowEmptyTemplate)TemplateRef::object");
            a.item("LoadingGridTemplateRef", "(w:LoadingGridTemplate,wf:LoadingGridTemplate)TemplateRef::object");
            a.item("SummaryRowHeight", "Number:double");
            a.item("DataCloneStrategy", "ExportedType:WebDataCloneStrategy");
            a.item("ClipboardOptions", "ExportedType:WebClipboardOptions");
            a.item("RowClassesRef", "(w:RowClasses,wf:RowClasses)DataRef::object");
            a.item("RowStylesRef", "(w:RowStyles,wf:RowStyles)DataRef::object");
            a.item("PrimaryKey", "String");
            a.item("ColumnList", "Collection:WebColumn:ColumnCollection:WebColumn");
            a.item("ColumnList@ngQueryList", "columnList");
            a.item("ActionStripComponents", "Collection:WebActionStrip:ActionStripCollection:WebActionStrip");
            a.item("ActionStripComponents@ngQueryList", "actionStripComponents");
            a.item("DragGhostCustomTemplateRef", "(w:DragGhostCustomTemplate,wf:DragGhostCustomTemplate)TemplateRef::object");
            a.item("RowEditTextTemplateRef", "(w:RowEditTextTemplate,wf:RowEditTextTemplate)TemplateRef::object");
            a.item("RowAddTextTemplateRef", "(w:RowAddTextTemplate,wf:RowAddTextTemplate)TemplateRef::object");
            a.item("RowEditActionsTemplateRef", "(w:RowEditActionsTemplate,wf:RowEditActionsTemplate)TemplateRef::object");
            a.item("RowExpandedIndicatorTemplateRef", "(w:RowExpandedIndicatorTemplate,wf:RowExpandedIndicatorTemplate)TemplateRef::object");
            a.item("RowCollapsedIndicatorTemplateRef", "(w:RowCollapsedIndicatorTemplate,wf:RowCollapsedIndicatorTemplate)TemplateRef::object");
            a.item("HeaderExpandedIndicatorTemplateRef", "(w:HeaderExpandedIndicatorTemplate,wf:HeaderExpandedIndicatorTemplate)TemplateRef::object");
            a.item("HeaderCollapsedIndicatorTemplateRef", "(w:HeaderCollapsedIndicatorTemplate,wf:HeaderCollapsedIndicatorTemplate)TemplateRef::object");
            a.item("ExcelStyleHeaderIconTemplateRef", "(w:ExcelStyleHeaderIconTemplate,wf:ExcelStyleHeaderIconTemplate)TemplateRef::object");
            a.item("SortAscendingHeaderIconTemplateRef", "(w:SortAscendingHeaderIconTemplate,wf:SortAscendingHeaderIconTemplate)TemplateRef::object");
            a.item("SortDescendingHeaderIconTemplateRef", "(w:SortDescendingHeaderIconTemplate,wf:SortDescendingHeaderIconTemplate)TemplateRef::object");
            a.item("SortHeaderIconTemplateRef", "(w:SortHeaderIconTemplate,wf:SortHeaderIconTemplate)TemplateRef::object");
            a.item("Toolbar", "Collection:WebGridToolbar:GridToolbarCollection:WebGridToolbar");
            a.item("Toolbar@ngQueryList", "toolbar");
            a.item("PaginationComponents", "Collection:WebPaginator:PaginatorCollection:WebPaginator");
            a.item("PaginationComponents@ngQueryList", "paginationComponents");
            a.item("ResourceStrings", "ExportedType:WebGridResourceStrings");
            a.item("FilteringLogic", "ExportedType:string:FilteringLogic");
            a.item("FilteringLogic@names", "And;Or");
            a.item("FilteringExpressionsTree", "ExportedType:WebFilteringExpressionsTree");
            a.item("FilteringExpressionsTree@mustSetInCode", "WebComponents;Blazor");
            a.item("AdvancedFilteringExpressionsTree", "ExportedType:WebFilteringExpressionsTree");
            a.item("Locale", "String");
            a.item("PagingMode", "ExportedType:string:GridPagingMode");
            a.item("PagingMode@names", "Local;Remote");
            a.item("HideRowSelectors", "Boolean");
            a.item("RowDraggable", "Boolean");
            a.item("ValidationTrigger", "ExportedType:string:GridValidationTrigger");
            a.item("ValidationTrigger@stringUnion", "WebComponents;React");
            a.item("ValidationTrigger@names", "Change;Blur");
            a.item("RowEditable", "Boolean");
            a.item("Height", "String");
            a.item("Width", "String");
            a.item("RowHeight", "Number:double");
            a.item("ColumnWidth", "String");
            a.item("EmptyGridMessage", "String");
            a.item("IsLoading", "Boolean");
            a.item("ShouldGenerate", "Boolean");
            a.item("EmptyFilteredGridMessage", "String");
            a.item("Pinning", "ExportedType:WebPinningConfig");
            a.item("Pinning@mustSetInCode", "WebComponents;Blazor;React");
            a.item("AllowFiltering", "Boolean");
            a.item("AllowAdvancedFiltering", "Boolean");
            a.item("FilterMode", "ExportedType:string:FilterMode");
            a.item("FilterMode@stringUnion", "WebComponents;React");
            a.item("FilterMode@names", "QuickFilter;ExcelStyleFilter");
            a.item("SummaryPosition", "ExportedType:string:GridSummaryPosition");
            a.item("SummaryPosition@stringUnion", "WebComponents;React");
            a.item("SummaryPosition@names", "Top;Bottom");
            a.item("SummaryCalculationMode", "ExportedType:string:GridSummaryCalculationMode");
            a.item("SummaryCalculationMode@stringUnion", "WebComponents;React");
            a.item("SummaryCalculationMode@names", "RootLevelOnly;ChildLevelsOnly;RootAndChildLevels");
            a.item("ShowSummaryOnCollapse", "Boolean");
            a.item("FilterStrategy", "ExportedType:WebFilteringStrategy");
            a.item("SortStrategy", "ExportedType:WebGridSortingStrategy");
            a.item("SortingOptions", "ExportedType:WebSortingOptions");
            a.item("SelectedRowsRef", "(w:SelectedRows,wf:SelectedRows)DataRef:object");
            a.item("HeadSelectorTemplateRef", "(w:HeadSelectorTemplate,wf:HeadSelectorTemplate)TemplateRef::object");
            a.item("RowSelectorTemplateRef", "(w:RowSelectorTemplate,wf:RowSelectorTemplate)TemplateRef::object");
            a.item("DragIndicatorIconTemplateRef", "(w:DragIndicatorIconTemplate,wf:DragIndicatorIconTemplate)TemplateRef::object");
            a.item("SortingExpressions", "Array:WebSortingExpressionDescription:SortingExpression");
            a.item("SortingExpressions@mustSetInCode", "WebComponents;Blazor;React");
            a.item("BatchEditing", "Boolean");
            a.item("CellSelection", "ExportedType:string:GridSelectionMode");
            a.item("CellSelection@stringUnion", "WebComponents;React");
            a.item("CellSelection@names", "None;Single;Multiple;MultipleCascade");
            a.item("RowSelection", "ExportedType:string:GridSelectionMode");
            a.item("RowSelection@stringUnion", "WebComponents;React");
            a.item("RowSelection@names", "None;Single;Multiple;MultipleCascade");
            a.item("ColumnSelection", "ExportedType:string:GridSelectionMode");
            a.item("ColumnSelection@stringUnion", "WebComponents;React");
            a.item("ColumnSelection@names", "None;Single;Multiple;MultipleCascade");
            a.item("Outlet", "ExportedType:WebOverlayOutletDirective");
            a.item("TotalRecords", "Number:double");
            a.item("SelectRowOnClick", "Boolean");
            a.item("ActualColumnList", "Collection:WebColumn:ColumnCollection:WebColumn");
            a.item("StateComponents", "Collection:WebGridState:StateCollection:WebGridState");
            a.item("StateComponents@ngQueryList", "stateComponents");
            a.item("FilteringExpressionsTreeChangeRef", "EventRef::filteringExpressionsTreeChange:customEvent");
            a.item("AdvancedFilteringExpressionsTreeChangeRef", "EventRef::advancedFilteringExpressionsTreeChange:customEvent");
            a.item("GridScrollRef", "EventRef::gridScroll:customEvent");
            a.item("CellClickRef", "EventRef::cellClick:customEvent");
            a.item("RowClickRef", "EventRef::rowClick:customEvent");
            a.item("FormGroupCreatedRef", "EventRef::formGroupCreated:customEvent");
            a.item("ValidationStatusChangeRef", "EventRef::validationStatusChange:customEvent");
            a.item("SelectedRef", "EventRef::selected:customEvent");
            a.item("RowSelectionChangingRef", "EventRef::rowSelectionChanging:customEvent");
            a.item("ColumnSelectionChangingRef", "EventRef::columnSelectionChanging:customEvent");
            a.item("ColumnPinRef", "EventRef::columnPin:customEvent");
            a.item("ColumnPinnedRef", "EventRef::columnPinned:customEvent");
            a.item("CellEditEnterRef", "EventRef::cellEditEnter:customEvent");
            a.item("CellEditExitRef", "EventRef::cellEditExit:customEvent");
            a.item("CellEditRef", "EventRef::cellEdit:customEvent");
            a.item("CellEditDoneRef", "EventRef::cellEditDone:customEvent");
            a.item("RowEditEnterRef", "EventRef::rowEditEnter:customEvent");
            a.item("RowEditRef", "EventRef::rowEdit:customEvent");
            a.item("RowEditDoneRef", "EventRef::rowEditDone:customEvent");
            a.item("RowEditExitRef", "EventRef::rowEditExit:customEvent");
            a.item("ColumnInitRef", "EventRef::columnInit:customEvent");
            a.item("ColumnsAutogeneratedRef", "EventRef::columnsAutogenerated:customEvent");
            a.item("SortingRef", "EventRef::sorting:customEvent");
            a.item("SortingDoneRef", "EventRef::sortingDone:customEvent");
            a.item("FilteringRef", "EventRef::filtering:customEvent");
            a.item("FilteringDoneRef", "EventRef::filteringDone:customEvent");
            a.item("RowAddedRef", "EventRef::rowAdded:customEvent");
            a.item("RowDeletedRef", "EventRef::rowDeleted:customEvent");
            a.item("RowDeleteRef", "EventRef::rowDelete:customEvent");
            a.item("RowAddRef", "EventRef::rowAdd:customEvent");
            a.item("ColumnResizedRef", "EventRef::columnResized:customEvent");
            a.item("ContextMenuRef", "EventRef::contextMenu:customEvent");
            a.item("DoubleClickRef", "EventRef::doubleClick:customEvent");
            a.item("ColumnVisibilityChangingRef", "EventRef::columnVisibilityChanging:customEvent");
            a.item("ColumnVisibilityChangedRef", "EventRef::columnVisibilityChanged:customEvent");
            a.item("ColumnMovingStartRef", "EventRef::columnMovingStart:customEvent");
            a.item("ColumnMovingRef", "EventRef::columnMoving:customEvent");
            a.item("ColumnMovingEndRef", "EventRef::columnMovingEnd:customEvent");
            a.item("GridKeydownRef", "EventRef::gridKeydown:customEvent");
            a.item("RowDragStartRef", "EventRef::rowDragStart:customEvent");
            a.item("RowDragEndRef", "EventRef::rowDragEnd:customEvent");
            a.item("GridCopyRef", "EventRef::gridCopy:customEvent");
            a.item("RowToggleRef", "EventRef::rowToggle:customEvent");
            a.item("RowPinningRef", "EventRef::rowPinning:customEvent");
            a.item("RowPinnedRef", "EventRef::rowPinned:customEvent");
            a.item("ActiveNodeChangeRef", "EventRef::activeNodeChange:customEvent");
            a.item("SortingExpressionsChangeRef", "EventRef::sortingExpressionsChange:customEvent");
            a.item("ToolbarExportingRef", "EventRef::toolbarExporting:customEvent");
            a.item("RangeSelectedRef", "EventRef::rangeSelected:customEvent");
            a.item("RenderedRef", "EventRef::rendered:customEvent");
            a.item("DataChangingRef", "EventRef::dataChanging:customEvent");
            a.item("DataChangedRef", "EventRef::dataChanged:customEvent");
            WebGridBaseDirectiveDescriptionMetadata.e(a);
        }
        static d(a) {
            WebGridBaseDirectiveDescriptionMetadata.b(a);
            a.ad("WebGridBaseDirective", WebGridBaseDirectiveDescriptionMetadata.a);
        }
        static e(a) {
            a.item("AutoGenerate", "*Boolean");
            a.item("ColumnsAutogeneratedRef", "*EventRef::columnsAutogenerated:customEvent");
        }
    }
    WebGridBaseDirectiveDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridBaseDirectiveDescriptionMetadata, 'WebGridBaseDirectiveDescriptionMetadata');
    WebGridBaseDirectiveDescriptionMetadata.a = null;
    return WebGridBaseDirectiveDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridContextMenuEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridContextMenuEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridContextMenuEventArgsDescriptionMetadata.a == null) {
                WebGridContextMenuEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridContextMenuEventArgsDescriptionMetadata.c(WebGridContextMenuEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGridContextMenuEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridContextMenuEventArgsDescriptionMetadata.a);
            WebGridContextMenuEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridContextMenuEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebGridContextMenuEventArgsDetail");
        }
        static d(a) {
            WebGridContextMenuEventArgsDescriptionMetadata.b(a);
            a.ae("WebGridContextMenuEventArgs", () => new WebGridContextMenuEventArgsDescription());
            a.ad("WebGridContextMenuEventArgs", WebGridContextMenuEventArgsDescriptionMetadata.a);
        }
    }
    WebGridContextMenuEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridContextMenuEventArgsDescriptionMetadata, 'WebGridContextMenuEventArgsDescriptionMetadata');
    WebGridContextMenuEventArgsDescriptionMetadata.a = null;
    return WebGridContextMenuEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridContextMenuEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridContextMenuEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridContextMenuEventArgsDetailDescriptionMetadata.a == null) {
                WebGridContextMenuEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridContextMenuEventArgsDetailDescriptionMetadata.c(WebGridContextMenuEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebGridContextMenuEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridContextMenuEventArgsDetailDescriptionMetadata.a);
            WebCellTypeDescriptionMetadata.d(a);
            WebRowTypeDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridContextMenuEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Cell", "ExportedType:WebCellType");
            a.item("Event", "Unknown");
            a.item("Row", "ExportedType:WebRowType");
        }
        static d(a) {
            WebGridContextMenuEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebGridContextMenuEventArgsDetail", () => new WebGridContextMenuEventArgsDetailDescription());
            a.ad("WebGridContextMenuEventArgsDetail", WebGridContextMenuEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebGridContextMenuEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridContextMenuEventArgsDetailDescriptionMetadata, 'WebGridContextMenuEventArgsDetailDescriptionMetadata');
    WebGridContextMenuEventArgsDetailDescriptionMetadata.a = null;
    return WebGridContextMenuEventArgsDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridRowEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridRowEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridRowEventArgsDescriptionMetadata.a == null) {
                WebGridRowEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridRowEventArgsDescriptionMetadata.c(WebGridRowEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGridRowEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridRowEventArgsDescriptionMetadata.a);
            WebGridRowEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridRowEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebGridRowEventArgsDetail");
        }
        static d(a) {
            WebGridRowEventArgsDescriptionMetadata.b(a);
            a.ae("WebGridRowEventArgs", () => new WebGridRowEventArgsDescription());
            a.ad("WebGridRowEventArgs", WebGridRowEventArgsDescriptionMetadata.a);
        }
    }
    WebGridRowEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridRowEventArgsDescriptionMetadata, 'WebGridRowEventArgsDescriptionMetadata');
    WebGridRowEventArgsDescriptionMetadata.a = null;
    return WebGridRowEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridRowEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridRowEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridRowEventArgsDetailDescriptionMetadata.a == null) {
                WebGridRowEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridRowEventArgsDetailDescriptionMetadata.c(WebGridRowEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebGridRowEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridRowEventArgsDetailDescriptionMetadata.a);
            WebRowTypeDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridRowEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Row", "ExportedType:WebRowType");
            a.item("Event", "Unknown");
        }
        static d(a) {
            WebGridRowEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebGridRowEventArgsDetail", () => new WebGridRowEventArgsDetailDescription());
            a.ad("WebGridRowEventArgsDetail", WebGridRowEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebGridRowEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridRowEventArgsDetailDescriptionMetadata, 'WebGridRowEventArgsDetailDescriptionMetadata');
    WebGridRowEventArgsDetailDescriptionMetadata.a = null;
    return WebGridRowEventArgsDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridCellEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridCellEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridCellEventArgsDescriptionMetadata.a == null) {
                WebGridCellEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridCellEventArgsDescriptionMetadata.c(WebGridCellEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGridCellEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridCellEventArgsDescriptionMetadata.a);
            WebGridCellEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridCellEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebGridCellEventArgsDetail");
        }
        static d(a) {
            WebGridCellEventArgsDescriptionMetadata.b(a);
            a.ae("WebGridCellEventArgs", () => new WebGridCellEventArgsDescription());
            a.ad("WebGridCellEventArgs", WebGridCellEventArgsDescriptionMetadata.a);
        }
    }
    WebGridCellEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridCellEventArgsDescriptionMetadata, 'WebGridCellEventArgsDescriptionMetadata');
    WebGridCellEventArgsDescriptionMetadata.a = null;
    return WebGridCellEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridCellEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridCellEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridCellEventArgsDetailDescriptionMetadata.a == null) {
                WebGridCellEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridCellEventArgsDetailDescriptionMetadata.c(WebGridCellEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebGridCellEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridCellEventArgsDetailDescriptionMetadata.a);
            WebCellTypeDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridCellEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Cell", "ExportedType:WebCellType");
            a.item("Event", "Unknown");
        }
        static d(a) {
            WebGridCellEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebGridCellEventArgsDetail", () => new WebGridCellEventArgsDetailDescription());
            a.ad("WebGridCellEventArgsDetail", WebGridCellEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebGridCellEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridCellEventArgsDetailDescriptionMetadata, 'WebGridCellEventArgsDetailDescriptionMetadata');
    WebGridCellEventArgsDetailDescriptionMetadata.a = null;
    return WebGridCellEventArgsDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridEditDoneEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridEditDoneEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridEditDoneEventArgsDescriptionMetadata.a == null) {
                WebGridEditDoneEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridEditDoneEventArgsDescriptionMetadata.c(WebGridEditDoneEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGridEditDoneEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridEditDoneEventArgsDescriptionMetadata.a);
            WebGridEditDoneEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridEditDoneEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebGridEditDoneEventArgsDetail");
        }
        static d(a) {
            WebGridEditDoneEventArgsDescriptionMetadata.b(a);
            a.ae("WebGridEditDoneEventArgs", () => new WebGridEditDoneEventArgsDescription());
            a.ad("WebGridEditDoneEventArgs", WebGridEditDoneEventArgsDescriptionMetadata.a);
        }
    }
    WebGridEditDoneEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridEditDoneEventArgsDescriptionMetadata, 'WebGridEditDoneEventArgsDescriptionMetadata');
    WebGridEditDoneEventArgsDescriptionMetadata.a = null;
    return WebGridEditDoneEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridEditDoneEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridEditDoneEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridEditDoneEventArgsDetailDescriptionMetadata.a == null) {
                WebGridEditDoneEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridEditDoneEventArgsDetailDescriptionMetadata.c(WebGridEditDoneEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebGridEditDoneEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridEditDoneEventArgsDetailDescriptionMetadata.a);
            WebGridCellIdentifierDescriptionMetadata.d(a);
            WebColumnDescriptionMetadata.d(a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridEditDoneEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("RowID", "Unknown");
            a.item("PrimaryKey", "Unknown");
            a.item("RowKey", "Unknown");
            a.item("CellID", "ExportedType:WebGridCellIdentifier");
            a.item("RowData", "Unknown");
            a.item("OldValue", "Unknown");
            a.item("NewValue", "Unknown");
            a.item("Column", "ExportedType:WebColumn");
            a.item("Owner", "ExportedType:WebGridBaseDirective");
            a.item("IsAddRow", "Boolean");
            a.item("Valid", "Boolean");
        }
        static d(a) {
            WebGridEditDoneEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebGridEditDoneEventArgsDetail", () => new WebGridEditDoneEventArgsDetailDescription());
            a.ad("WebGridEditDoneEventArgsDetail", WebGridEditDoneEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebGridEditDoneEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridEditDoneEventArgsDetailDescriptionMetadata, 'WebGridEditDoneEventArgsDetailDescriptionMetadata');
    WebGridEditDoneEventArgsDetailDescriptionMetadata.a = null;
    return WebGridEditDoneEventArgsDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridEditEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridEditEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridEditEventArgsDescriptionMetadata.a == null) {
                WebGridEditEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridEditEventArgsDescriptionMetadata.c(WebGridEditEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGridEditEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridEditEventArgsDescriptionMetadata.a);
            WebGridEditEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridEditEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebGridEditEventArgsDetail");
        }
        static d(a) {
            WebGridEditEventArgsDescriptionMetadata.b(a);
            a.ae("WebGridEditEventArgs", () => new WebGridEditEventArgsDescription());
            a.ad("WebGridEditEventArgs", WebGridEditEventArgsDescriptionMetadata.a);
        }
    }
    WebGridEditEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridEditEventArgsDescriptionMetadata, 'WebGridEditEventArgsDescriptionMetadata');
    WebGridEditEventArgsDescriptionMetadata.a = null;
    return WebGridEditEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridEditEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridEditEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridEditEventArgsDetailDescriptionMetadata.a == null) {
                WebGridEditEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridEditEventArgsDetailDescriptionMetadata.c(WebGridEditEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebGridEditEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridEditEventArgsDetailDescriptionMetadata.a);
            WebGridCellIdentifierDescriptionMetadata.d(a);
            WebColumnDescriptionMetadata.d(a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridEditEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Cancel", "Boolean");
            a.item("RowID", "Unknown");
            a.item("PrimaryKey", "Unknown");
            a.item("RowKey", "Unknown");
            a.item("CellID", "ExportedType:WebGridCellIdentifier");
            a.item("RowData", "Unknown");
            a.item("OldValue", "Unknown");
            a.item("NewValue", "Unknown");
            a.item("Column", "ExportedType:WebColumn");
            a.item("Owner", "ExportedType:WebGridBaseDirective");
            a.item("IsAddRow", "Boolean");
            a.item("Valid", "Boolean");
        }
        static d(a) {
            WebGridEditEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebGridEditEventArgsDetail", () => new WebGridEditEventArgsDetailDescription());
            a.ad("WebGridEditEventArgsDetail", WebGridEditEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebGridEditEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridEditEventArgsDetailDescriptionMetadata, 'WebGridEditEventArgsDetailDescriptionMetadata');
    WebGridEditEventArgsDetailDescriptionMetadata.a = null;
    return WebGridEditEventArgsDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridFormGroupCreatedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridFormGroupCreatedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridFormGroupCreatedEventArgsDescriptionMetadata.a == null) {
                WebGridFormGroupCreatedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridFormGroupCreatedEventArgsDescriptionMetadata.c(WebGridFormGroupCreatedEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGridFormGroupCreatedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridFormGroupCreatedEventArgsDescriptionMetadata.a);
            WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridFormGroupCreatedEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebGridFormGroupCreatedEventArgsDetail");
        }
        static d(a) {
            WebGridFormGroupCreatedEventArgsDescriptionMetadata.b(a);
            a.ae("WebGridFormGroupCreatedEventArgs", () => new WebGridFormGroupCreatedEventArgsDescription());
            a.ad("WebGridFormGroupCreatedEventArgs", WebGridFormGroupCreatedEventArgsDescriptionMetadata.a);
        }
    }
    WebGridFormGroupCreatedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridFormGroupCreatedEventArgsDescriptionMetadata, 'WebGridFormGroupCreatedEventArgsDescriptionMetadata');
    WebGridFormGroupCreatedEventArgsDescriptionMetadata.a = null;
    return WebGridFormGroupCreatedEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata.a == null) {
                WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata.c(WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata.a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridFormGroupCreatedEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Owner", "ExportedType:WebGridBaseDirective");
        }
        static d(a) {
            WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebGridFormGroupCreatedEventArgsDetail", () => new WebGridFormGroupCreatedEventArgsDetailDescription());
            a.ad("WebGridFormGroupCreatedEventArgsDetail", WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata, 'WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata');
    WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata.a = null;
    return WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridToolbarExportEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridToolbarExportEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridToolbarExportEventArgsDescriptionMetadata.a == null) {
                WebGridToolbarExportEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridToolbarExportEventArgsDescriptionMetadata.c(WebGridToolbarExportEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGridToolbarExportEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridToolbarExportEventArgsDescriptionMetadata.a);
            WebGridToolbarExportEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridToolbarExportEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("Detail", "ExportedType:WebGridToolbarExportEventArgsDetail");
        }
        static d(a) {
            WebGridToolbarExportEventArgsDescriptionMetadata.b(a);
            a.ae("WebGridToolbarExportEventArgs", () => new WebGridToolbarExportEventArgsDescription());
            a.ad("WebGridToolbarExportEventArgs", WebGridToolbarExportEventArgsDescriptionMetadata.a);
        }
    }
    WebGridToolbarExportEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridToolbarExportEventArgsDescriptionMetadata, 'WebGridToolbarExportEventArgsDescriptionMetadata');
    WebGridToolbarExportEventArgsDescriptionMetadata.a = null;
    return WebGridToolbarExportEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridToolbarExportEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridToolbarExportEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridToolbarExportEventArgsDetailDescriptionMetadata.a == null) {
                WebGridToolbarExportEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridToolbarExportEventArgsDetailDescriptionMetadata.c(WebGridToolbarExportEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebGridToolbarExportEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridToolbarExportEventArgsDetailDescriptionMetadata.a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
            WebBaseExporterDescriptionMetadata.d(a);
            WebExporterOptionsBaseDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridToolbarExportEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("Grid", "ExportedType:WebGridBaseDirective");
            a.item("Exporter", "ExportedType:WebBaseExporter");
            a.item("Options", "ExportedType:WebExporterOptionsBase");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebGridToolbarExportEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebGridToolbarExportEventArgsDetail", () => new WebGridToolbarExportEventArgsDetailDescription());
            a.ad("WebGridToolbarExportEventArgsDetail", WebGridToolbarExportEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebGridToolbarExportEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridToolbarExportEventArgsDetailDescriptionMetadata, 'WebGridToolbarExportEventArgsDetailDescriptionMetadata');
    WebGridToolbarExportEventArgsDetailDescriptionMetadata.a = null;
    return WebGridToolbarExportEventArgsDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridValidationStatusEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridValidationStatusEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridValidationStatusEventArgsDescriptionMetadata.a == null) {
                WebGridValidationStatusEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridValidationStatusEventArgsDescriptionMetadata.c(WebGridValidationStatusEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGridValidationStatusEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridValidationStatusEventArgsDescriptionMetadata.a);
            WebGridValidationStatusEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridValidationStatusEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebGridValidationStatusEventArgsDetail");
        }
        static d(a) {
            WebGridValidationStatusEventArgsDescriptionMetadata.b(a);
            a.ae("WebGridValidationStatusEventArgs", () => new WebGridValidationStatusEventArgsDescription());
            a.ad("WebGridValidationStatusEventArgs", WebGridValidationStatusEventArgsDescriptionMetadata.a);
        }
    }
    WebGridValidationStatusEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridValidationStatusEventArgsDescriptionMetadata, 'WebGridValidationStatusEventArgsDescriptionMetadata');
    WebGridValidationStatusEventArgsDescriptionMetadata.a = null;
    return WebGridValidationStatusEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridValidationStatusEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridValidationStatusEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridValidationStatusEventArgsDetailDescriptionMetadata.a == null) {
                WebGridValidationStatusEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridValidationStatusEventArgsDetailDescriptionMetadata.c(WebGridValidationStatusEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebGridValidationStatusEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridValidationStatusEventArgsDetailDescriptionMetadata.a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridValidationStatusEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Status", "ExportedType:string:ValidationStatus");
            a.item("Status@stringUnion", "WebComponents;React");
            a.item("Status@names", "VALID;INVALID");
            a.item("Owner", "ExportedType:WebGridBaseDirective");
        }
        static d(a) {
            WebGridValidationStatusEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebGridValidationStatusEventArgsDetail", () => new WebGridValidationStatusEventArgsDetailDescription());
            a.ad("WebGridValidationStatusEventArgsDetail", WebGridValidationStatusEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebGridValidationStatusEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridValidationStatusEventArgsDetailDescriptionMetadata, 'WebGridValidationStatusEventArgsDetailDescriptionMetadata');
    WebGridValidationStatusEventArgsDetailDescriptionMetadata.a = null;
    return WebGridValidationStatusEventArgsDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebPinRowEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPinRowEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPinRowEventArgsDescriptionMetadata.a == null) {
                WebPinRowEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPinRowEventArgsDescriptionMetadata.c(WebPinRowEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebPinRowEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPinRowEventArgsDescriptionMetadata.a);
            WebPinRowEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PinRowEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebPinRowEventArgsDetail");
        }
        static d(a) {
            WebPinRowEventArgsDescriptionMetadata.b(a);
            a.ae("WebPinRowEventArgs", () => new WebPinRowEventArgsDescription());
            a.ad("WebPinRowEventArgs", WebPinRowEventArgsDescriptionMetadata.a);
        }
    }
    WebPinRowEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPinRowEventArgsDescriptionMetadata, 'WebPinRowEventArgsDescriptionMetadata');
    WebPinRowEventArgsDescriptionMetadata.a = null;
    return WebPinRowEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebPinRowEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPinRowEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebPinRowEventArgsDetailDescriptionMetadata.a == null) {
                WebPinRowEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPinRowEventArgsDetailDescriptionMetadata.c(WebPinRowEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebPinRowEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPinRowEventArgsDetailDescriptionMetadata.a);
            WebRowTypeDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PinRowEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("RowID", "Unknown");
            a.item("RowKey", "Unknown");
            a.item("Row", "ExportedType:WebRowType");
            a.item("InsertAtIndex", "Number:double");
            a.item("IsPinned", "Boolean");
            a.item("Owner", "Unknown");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebPinRowEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebPinRowEventArgsDetail", () => new WebPinRowEventArgsDetailDescription());
            a.ad("WebPinRowEventArgsDetail", WebPinRowEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebPinRowEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPinRowEventArgsDetailDescriptionMetadata, 'WebPinRowEventArgsDetailDescriptionMetadata');
    WebPinRowEventArgsDetailDescriptionMetadata.a = null;
    return WebPinRowEventArgsDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebRowDataCancelableEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowDataCancelableEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowDataCancelableEventArgsDescriptionMetadata.a == null) {
                WebRowDataCancelableEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowDataCancelableEventArgsDescriptionMetadata.c(WebRowDataCancelableEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebRowDataCancelableEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowDataCancelableEventArgsDescriptionMetadata.a);
            WebRowDataCancelableEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowDataCancelableEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebRowDataCancelableEventArgsDetail");
        }
        static d(a) {
            WebRowDataCancelableEventArgsDescriptionMetadata.b(a);
            a.ae("WebRowDataCancelableEventArgs", () => new WebRowDataCancelableEventArgsDescription());
            a.ad("WebRowDataCancelableEventArgs", WebRowDataCancelableEventArgsDescriptionMetadata.a);
        }
    }
    WebRowDataCancelableEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowDataCancelableEventArgsDescriptionMetadata, 'WebRowDataCancelableEventArgsDescriptionMetadata');
    WebRowDataCancelableEventArgsDescriptionMetadata.a = null;
    return WebRowDataCancelableEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebRowDataCancelableEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowDataCancelableEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowDataCancelableEventArgsDetailDescriptionMetadata.a == null) {
                WebRowDataCancelableEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowDataCancelableEventArgsDetailDescriptionMetadata.c(WebRowDataCancelableEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebRowDataCancelableEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowDataCancelableEventArgsDetailDescriptionMetadata.a);
            WebGridCellIdentifierDescriptionMetadata.d(a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowDataCancelableEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("CellID", "ExportedType:WebGridCellIdentifier");
            a.item("OldValue", "Unknown");
            a.item("NewValue", "Unknown");
            a.item("IsAddRow", "Boolean");
            a.item("Owner", "ExportedType:WebGridBaseDirective");
            a.item("Data", "Unknown");
            a.item("RowData", "Unknown");
            a.item("PrimaryKey", "Unknown");
            a.item("RowKey", "Unknown");
        }
        static d(a) {
            WebRowDataCancelableEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebRowDataCancelableEventArgsDetail", () => new WebRowDataCancelableEventArgsDetailDescription());
            a.ad("WebRowDataCancelableEventArgsDetail", WebRowDataCancelableEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebRowDataCancelableEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowDataCancelableEventArgsDetailDescriptionMetadata, 'WebRowDataCancelableEventArgsDetailDescriptionMetadata');
    WebRowDataCancelableEventArgsDetailDescriptionMetadata.a = null;
    return WebRowDataCancelableEventArgsDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebRowDragEndEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowDragEndEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowDragEndEventArgsDescriptionMetadata.a == null) {
                WebRowDragEndEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowDragEndEventArgsDescriptionMetadata.c(WebRowDragEndEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebRowDragEndEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowDragEndEventArgsDescriptionMetadata.a);
            WebRowDragEndEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowDragEndEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebRowDragEndEventArgsDetail");
        }
        static d(a) {
            WebRowDragEndEventArgsDescriptionMetadata.b(a);
            a.ae("WebRowDragEndEventArgs", () => new WebRowDragEndEventArgsDescription());
            a.ad("WebRowDragEndEventArgs", WebRowDragEndEventArgsDescriptionMetadata.a);
        }
    }
    WebRowDragEndEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowDragEndEventArgsDescriptionMetadata, 'WebRowDragEndEventArgsDescriptionMetadata');
    WebRowDragEndEventArgsDescriptionMetadata.a = null;
    return WebRowDragEndEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebRowDragEndEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowDragEndEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowDragEndEventArgsDetailDescriptionMetadata.a == null) {
                WebRowDragEndEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowDragEndEventArgsDetailDescriptionMetadata.c(WebRowDragEndEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebRowDragEndEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowDragEndEventArgsDetailDescriptionMetadata.a);
            WebRowTypeDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:RowDragEndEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("DragDirective", "Unknown");
            a.item("DragData", "ExportedType:WebRowType");
            a.item("Animation", "Boolean");
        }
        static d(a) {
            WebRowDragEndEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebRowDragEndEventArgsDetail", () => new WebRowDragEndEventArgsDetailDescription());
            a.ad("WebRowDragEndEventArgsDetail", WebRowDragEndEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebRowDragEndEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowDragEndEventArgsDetailDescriptionMetadata, 'WebRowDragEndEventArgsDetailDescriptionMetadata');
    WebRowDragEndEventArgsDetailDescriptionMetadata.a = null;
    return WebRowDragEndEventArgsDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebRowDragStartEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowDragStartEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowDragStartEventArgsDescriptionMetadata.a == null) {
                WebRowDragStartEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowDragStartEventArgsDescriptionMetadata.c(WebRowDragStartEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebRowDragStartEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowDragStartEventArgsDescriptionMetadata.a);
            WebRowDragStartEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowDragStartEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebRowDragStartEventArgsDetail");
        }
        static d(a) {
            WebRowDragStartEventArgsDescriptionMetadata.b(a);
            a.ae("WebRowDragStartEventArgs", () => new WebRowDragStartEventArgsDescription());
            a.ad("WebRowDragStartEventArgs", WebRowDragStartEventArgsDescriptionMetadata.a);
        }
    }
    WebRowDragStartEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowDragStartEventArgsDescriptionMetadata, 'WebRowDragStartEventArgsDescriptionMetadata');
    WebRowDragStartEventArgsDescriptionMetadata.a = null;
    return WebRowDragStartEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebRowDragStartEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowDragStartEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowDragStartEventArgsDetailDescriptionMetadata.a == null) {
                WebRowDragStartEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowDragStartEventArgsDetailDescriptionMetadata.c(WebRowDragStartEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebRowDragStartEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowDragStartEventArgsDetailDescriptionMetadata.a);
            WebRowTypeDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowDragStartEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("DragDirective", "Unknown");
            a.item("DragData", "ExportedType:WebRowType");
            a.item("Cancel", "Boolean");
            a.item("Owner", "Unknown");
        }
        static d(a) {
            WebRowDragStartEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebRowDragStartEventArgsDetail", () => new WebRowDragStartEventArgsDetailDescription());
            a.ad("WebRowDragStartEventArgsDetail", WebRowDragStartEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebRowDragStartEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowDragStartEventArgsDetailDescriptionMetadata, 'WebRowDragStartEventArgsDetailDescriptionMetadata');
    WebRowDragStartEventArgsDetailDescriptionMetadata.a = null;
    return WebRowDragStartEventArgsDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebRowTypeDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowTypeDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowTypeDescriptionMetadata.a == null) {
                WebRowTypeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowTypeDescriptionMetadata.c(WebRowTypeDescriptionMetadata.a);
            }
            if (a.k(WebRowTypeDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowTypeDescriptionMetadata.a);
            WebGroupByRecordDescriptionMetadata.d(a);
            WebGridValidationStateDescriptionMetadata.d(a);
            WebCellTypeDescriptionMetadata.d(a);
            WebRowTypeDescriptionMetadata.d(a);
            WebTreeGridRecordDescriptionMetadata.d(a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowType");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Index", "Number:double");
            a.item("ViewIndex", "Number:double");
            a.item("IsGroupByRow", "Boolean");
            a.item("IsSummaryRow", "Boolean");
            a.item("GroupRow", "ExportedType:WebGroupByRecord");
            a.item("Key", "Unknown");
            a.item("Validation", "ExportedType:WebGridValidationState");
            a.item("Data", "Unknown");
            a.item("Cells", "Array:WebCellTypeDescription:CellType");
            a.item("Disabled", "Boolean");
            a.item("Pinned", "Boolean");
            a.item("Selected", "Boolean");
            a.item("Expanded", "Boolean");
            a.item("Deleted", "Boolean");
            a.item("InEditMode", "Boolean");
            a.item("Children", "Array:WebRowTypeDescription:RowType");
            a.item("RowParent", "(wc:Parent)ExportedType:WebRowType");
            a.item("HasChildren", "Boolean");
            a.item("TreeRow", "ExportedType:WebTreeGridRecord");
            a.item("AddRowUI", "Boolean");
            a.item("Focused", "Boolean");
            a.item("Grid", "ExportedType:WebGridBaseDirective");
        }
        static d(a) {
            WebRowTypeDescriptionMetadata.b(a);
            a.ae("WebRowType", () => new WebRowTypeDescription());
            a.ad("WebRowType", WebRowTypeDescriptionMetadata.a);
        }
    }
    WebRowTypeDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowTypeDescriptionMetadata, 'WebRowTypeDescriptionMetadata');
    WebRowTypeDescriptionMetadata.a = null;
    return WebRowTypeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCellTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebCellTemplateContextDescription extends Description {
        get_type() {
            return "WebCellTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.k = null;
            this.h = null;
        }
        get implicit() {
            return this.l;
        }
        set implicit(a) {
            this.l = a;
            this.g("Implicit");
        }
        get additionalTemplateContext() {
            return this.k;
        }
        set additionalTemplateContext(a) {
            this.k = a;
            this.g("AdditionalTemplateContext");
        }
        get cell() {
            return this.h;
        }
        set cell(a) {
            this.h = a;
            this.g("Cell");
        }
    }
    WebCellTemplateContextDescription.$t = /*@__PURE__*/ markType(WebCellTemplateContextDescription, 'WebCellTemplateContextDescription', Description.$);
    WebCellTemplateContextDescription.__marshalByValue = true;
    WebCellTemplateContextDescription.__marshalByValueAlias = "CellTemplateContext";
    return WebCellTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCellTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCellTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebCellTemplateContextDescriptionMetadata.a == null) {
                WebCellTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCellTemplateContextDescriptionMetadata.c(WebCellTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebCellTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCellTemplateContextDescriptionMetadata.a);
            WebCellTypeDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CellTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "Unknown");
            a.item("AdditionalTemplateContext", "Unknown");
            a.item("Cell", "ExportedType:WebCellType");
        }
        static d(a) {
            WebCellTemplateContextDescriptionMetadata.b(a);
            a.ae("WebCellTemplateContext", () => new WebCellTemplateContextDescription());
            a.ad("WebCellTemplateContext", WebCellTemplateContextDescriptionMetadata.a);
        }
    }
    WebCellTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCellTemplateContextDescriptionMetadata, 'WebCellTemplateContextDescriptionMetadata');
    WebCellTemplateContextDescriptionMetadata.a = null;
    return WebCellTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebColumnTemplateContextDescription extends Description {
        get_type() {
            return "WebColumnTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
        }
        get implicit() {
            return this.i;
        }
        set implicit(a) {
            this.i = a;
            this.g("Implicit");
        }
        get column() {
            return this.h;
        }
        set column(a) {
            this.h = a;
            this.g("Column");
        }
    }
    WebColumnTemplateContextDescription.$t = /*@__PURE__*/ markType(WebColumnTemplateContextDescription, 'WebColumnTemplateContextDescription', Description.$);
    WebColumnTemplateContextDescription.__marshalByValue = true;
    WebColumnTemplateContextDescription.__marshalByValueAlias = "ColumnTemplateContext";
    return WebColumnTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnTemplateContextDescriptionMetadata.a == null) {
                WebColumnTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnTemplateContextDescriptionMetadata.c(WebColumnTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebColumnTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnTemplateContextDescriptionMetadata.a);
            WebColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "ExportedType:WebColumn");
            a.item("Column", "ExportedType:WebColumn");
        }
        static d(a) {
            WebColumnTemplateContextDescriptionMetadata.b(a);
            a.ae("WebColumnTemplateContext", () => new WebColumnTemplateContextDescription());
            a.ad("WebColumnTemplateContext", WebColumnTemplateContextDescriptionMetadata.a);
        }
    }
    WebColumnTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnTemplateContextDescriptionMetadata, 'WebColumnTemplateContextDescriptionMetadata');
    WebColumnTemplateContextDescriptionMetadata.a = null;
    return WebColumnTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateContainerDescriptionModule = /*@__PURE__*/ (() => {
    class TemplateContainerDescriptionModule extends Base {
        static register(a) {
        }
    }
    TemplateContainerDescriptionModule.$t = /*@__PURE__*/ markType(TemplateContainerDescriptionModule, 'TemplateContainerDescriptionModule');
    return TemplateContainerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnDependenciesDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnDependenciesDescriptionModule extends Base {
        static register(a) {
            WebSummaryTemplateContextDescriptionMetadata.d(a);
            WebCellTemplateContextDescriptionMetadata.d(a);
            WebColumnTemplateContextDescriptionMetadata.d(a);
            TemplateContainerDescriptionModule.register(a);
        }
    }
    ColumnDependenciesDescriptionModule.$t = /*@__PURE__*/ markType(ColumnDependenciesDescriptionModule, 'ColumnDependenciesDescriptionModule');
    return ColumnDependenciesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnGroupingDescription = /*@__PURE__*/ (() => {
    class ColumnGroupingDescription extends Description {
        get_type() {
            return "ColumnGrouping";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.s = null;
            this.k = null;
            this.o = null;
            this.u = null;
            this.v = null;
            this.l = null;
            this.h = 0;
            this.m = null;
            this.n = null;
            this.t = null;
            this.p = null;
            this.q = null;
            this.r = null;
            this.j = null;
        }
        get targetGridRef() {
            return this.s;
        }
        set targetGridRef(a) {
            this.s = a;
            this.g("TargetGridRef");
        }
        get baseTheme() {
            return this.k;
        }
        set baseTheme(a) {
            this.k = a;
            this.g("BaseTheme");
        }
        get density() {
            return this.o;
        }
        set density(a) {
            this.o = a;
            this.g("Density");
        }
        get title() {
            return this.u;
        }
        set title(a) {
            this.u = a;
            this.g("Title");
        }
        get titleColor() {
            return this.v;
        }
        set titleColor(a) {
            this.v = a;
            this.g("TitleColor");
        }
        get columnGroupTitleFontFamily() {
            return this.l;
        }
        set columnGroupTitleFontFamily(a) {
            this.l = a;
            this.g("ColumnGroupTitleFontFamily");
        }
        get columnGroupTitleFontSize() {
            return this.h;
        }
        set columnGroupTitleFontSize(a) {
            this.h = a;
            this.g("ColumnGroupTitleFontSize");
        }
        get columnGroupTitleFontStyle() {
            return this.m;
        }
        set columnGroupTitleFontStyle(a) {
            this.m = a;
            this.g("ColumnGroupTitleFontStyle");
        }
        get columnGroupTitleFontWeight() {
            return this.n;
        }
        set columnGroupTitleFontWeight(a) {
            this.n = a;
            this.g("ColumnGroupTitleFontWeight");
        }
        get textColor() {
            return this.t;
        }
        set textColor(a) {
            this.t = a;
            this.g("TextColor");
        }
        get iconColor() {
            return this.p;
        }
        set iconColor(a) {
            this.p = a;
            this.g("IconColor");
        }
        get itemBackgroundColor() {
            return this.q;
        }
        set itemBackgroundColor(a) {
            this.q = a;
            this.g("ItemBackgroundColor");
        }
        get itemHoverBackgroundColor() {
            return this.r;
        }
        set itemHoverBackgroundColor(a) {
            this.r = a;
            this.g("ItemHoverBackgroundColor");
        }
        get backgroundColor() {
            return this.j;
        }
        set backgroundColor(a) {
            this.j = a;
            this.g("BackgroundColor");
        }
    }
    ColumnGroupingDescription.$t = /*@__PURE__*/ markType(ColumnGroupingDescription, 'ColumnGroupingDescription', Description.$);
    return ColumnGroupingDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnGroupingDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnGroupingDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnGroupingDescriptionMetadata.a == null) {
                ColumnGroupingDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnGroupingDescriptionMetadata.c(ColumnGroupingDescriptionMetadata.a);
            }
            if (a.k(ColumnGroupingDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnGroupingDescriptionMetadata.a);
        }
        static c(a) {
            a.item("TargetGridRef", "(w:TargetGrid,wf:TargetGrid)DataRef::object");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("Title", "String");
            a.item("TitleColor", "Brush");
            a.item("ColumnGroupTitleFontFamily", "(w:ColumnGroupTitleFontFamily/FontFamilyTransform,xam:ColumnGroupTitleFontFamily,wf:ColumnGroupTitleFontFamily,web:textStyle/FontFamilyTransform)String");
            a.item("ColumnGroupTitleFontSize", "(w:ColumnGroupTitleFontSize,xam:ColumnGroupTitleFontSize,wf:ColumnGroupTitleFontSize,web:textStyle/FontSizeTransform)Number:double");
            a.item("ColumnGroupTitleFontStyle", "(w:ColumnGroupTitleFontStyle/FontStyleTransform,xam:ColumnGroupTitleFontFamily/FontStyleTransform,wf:ColumnGroupTitleFontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            a.item("ColumnGroupTitleFontWeight", "(w:ColumnGroupTitleFontWeight/FontWeightTransform,xam:ColumnGroupTitleFontFamily/FontWeightTransform,wf:ColumnGroupTitleFontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            a.item("TextColor", "Brush");
            a.item("IconColor", "Brush");
            a.item("ItemBackgroundColor", "Brush");
            a.item("ItemHoverBackgroundColor", "Brush");
            a.item("BackgroundColor", "Brush");
        }
        static d(a) {
            ColumnGroupingDescriptionMetadata.b(a);
            a.ae("ColumnGrouping", () => new ColumnGroupingDescription());
            a.ad("ColumnGrouping", ColumnGroupingDescriptionMetadata.a);
        }
    }
    ColumnGroupingDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnGroupingDescriptionMetadata, 'ColumnGroupingDescriptionMetadata');
    ColumnGroupingDescriptionMetadata.a = null;
    return ColumnGroupingDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnGroupingDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnGroupingDescriptionModule extends Base {
        static register(a) {
            ColumnGroupingDescriptionMetadata.d(a);
        }
    }
    ColumnGroupingDescriptionModule.$t = /*@__PURE__*/ markType(ColumnGroupingDescriptionModule, 'ColumnGroupingDescriptionModule');
    return ColumnGroupingDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnPinningDescription = /*@__PURE__*/ (() => {
    class ColumnPinningDescription extends Description {
        get_type() {
            return "ColumnPinning";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.o = null;
            this.q = null;
            this.h = 0;
            this.r = null;
            this.s = null;
            this.p = null;
            this.m = null;
            this.k = null;
            this.l = null;
            this.j = null;
        }
        get targetGridRef() {
            return this.n;
        }
        set targetGridRef(a) {
            this.n = a;
            this.g("TargetGridRef");
        }
        get title() {
            return this.o;
        }
        set title(a) {
            this.o = a;
            this.g("Title");
        }
        get titleFontFamily() {
            return this.q;
        }
        set titleFontFamily(a) {
            this.q = a;
            this.g("TitleFontFamily");
        }
        get titleFontSize() {
            return this.h;
        }
        set titleFontSize(a) {
            this.h = a;
            this.g("TitleFontSize");
        }
        get titleFontStyle() {
            return this.r;
        }
        set titleFontStyle(a) {
            this.r = a;
            this.g("TitleFontStyle");
        }
        get titleFontWeight() {
            return this.s;
        }
        set titleFontWeight(a) {
            this.s = a;
            this.g("TitleFontWeight");
        }
        get titleColor() {
            return this.p;
        }
        set titleColor(a) {
            this.p = a;
            this.g("TitleColor");
        }
        get filterPlaceholderText() {
            return this.m;
        }
        set filterPlaceholderText(a) {
            this.m = a;
            this.g("FilterPlaceholderText");
        }
        get baseTheme() {
            return this.k;
        }
        set baseTheme(a) {
            this.k = a;
            this.g("BaseTheme");
        }
        get density() {
            return this.l;
        }
        set density(a) {
            this.l = a;
            this.g("Density");
        }
        get backgroundColor() {
            return this.j;
        }
        set backgroundColor(a) {
            this.j = a;
            this.g("BackgroundColor");
        }
    }
    ColumnPinningDescription.$t = /*@__PURE__*/ markType(ColumnPinningDescription, 'ColumnPinningDescription', Description.$);
    return ColumnPinningDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnPinningDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnPinningDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnPinningDescriptionMetadata.a == null) {
                ColumnPinningDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnPinningDescriptionMetadata.c(ColumnPinningDescriptionMetadata.a);
            }
            if (a.k(ColumnPinningDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnPinningDescriptionMetadata.a);
        }
        static c(a) {
            a.item("TargetGridRef", "(w:TargetGrid,wf:TargetGrid)DataRef::object");
            a.item("Title", "String");
            a.item("TitleFontFamily", "(w:TitleFontFamily/FontFamilyTransform,xam:TitleFontFamily,wf:TitleFontFamily,web:titleStyle/FontFamilyTransform)String");
            a.item("TitleFontSize", "(w:TitleFontSize,xam:TitleFontSize,wf:TitleFontSize,web:titleStyle/FontSizeTransform)Number:double");
            a.item("TitleFontStyle", "(w:TitleFontStyle/FontStyleTransform,xam:TitleFontFamily/FontStyleTransform,wf:TitleFontFamily/FontStyleTransform,web:titleStyle/FontStyleTransform)String");
            a.item("TitleFontWeight", "(w:TitleFontWeight/FontWeightTransform,xam:TitleFontFamily/FontWeightTransform,wf:TitleFontFamily/FontWeightTransform,web:titleStyle/FontWeightTransform)String");
            a.item("TitleColor", "Brush");
            a.item("FilterPlaceholderText", "String");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("BackgroundColor", "Brush");
        }
        static d(a) {
            ColumnPinningDescriptionMetadata.b(a);
            a.ae("ColumnPinning", () => new ColumnPinningDescription());
            a.ad("ColumnPinning", ColumnPinningDescriptionMetadata.a);
        }
    }
    ColumnPinningDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnPinningDescriptionMetadata, 'ColumnPinningDescriptionMetadata');
    ColumnPinningDescriptionMetadata.a = null;
    return ColumnPinningDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnPinningDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnPinningDescriptionModule extends Base {
        static register(a) {
            CheckboxListDescriptionModule.register(a);
            ColumnPinningDescriptionMetadata.d(a);
        }
    }
    ColumnPinningDescriptionModule.$t = /*@__PURE__*/ markType(ColumnPinningDescriptionModule, 'ColumnPinningDescriptionModule');
    return ColumnPinningDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ComboBoxColumnDescription = /*@__PURE__*/ (() => {
    class ComboBoxColumnDescription extends DataGridColumnDescription {
        get_type() {
            return "ComboBoxColumn";
        }
        constructor() {
            super();
            this.fl = null;
            this.fh = null;
            this.fm = null;
            this.fn = null;
        }
        get dataSourceRef() {
            return this.fl;
        }
        set dataSourceRef(a) {
            this.fl = a;
            this.g("DataSourceRef");
        }
        get dataSource() {
            return this.fh;
        }
        set dataSource(a) {
            this.fh = a;
            this.g("DataSource");
        }
        get textField() {
            return this.fm;
        }
        set textField(a) {
            this.fm = a;
            this.g("TextField");
        }
        get valueField() {
            return this.fn;
        }
        set valueField(a) {
            this.fn = a;
            this.g("ValueField");
        }
    }
    ComboBoxColumnDescription.$t = /*@__PURE__*/ markType(ComboBoxColumnDescription, 'ComboBoxColumnDescription', DataGridColumnDescription.$);
    ComboBoxColumnDescription.__canMarshalByValue1 = true;
    ComboBoxColumnDescription.__marshalByValueAlias1 = "ComboBoxColumn";
    return ComboBoxColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ComboBoxColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class ComboBoxColumnDescriptionMetadata extends Base {
        static b(a) {
            if (ComboBoxColumnDescriptionMetadata.a == null) {
                ComboBoxColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ComboBoxColumnDescriptionMetadata.c(ComboBoxColumnDescriptionMetadata.a);
            }
            if (a.k(ComboBoxColumnDescriptionMetadata.a)) {
                return;
            }
            a.ac(ComboBoxColumnDescriptionMetadata.a);
        }
        static c(a) {
            DataGridColumnDescriptionMetadata.c(a);
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)DataRef::object");
            a.item("DataSource", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            a.item("TextField", "String");
            a.item("ValueField", "String");
        }
        static d(a) {
            ComboBoxColumnDescriptionMetadata.b(a);
            a.ae("ComboBoxColumn", () => new ComboBoxColumnDescription());
            a.ad("ComboBoxColumn", ComboBoxColumnDescriptionMetadata.a);
        }
    }
    ComboBoxColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(ComboBoxColumnDescriptionMetadata, 'ComboBoxColumnDescriptionMetadata');
    ComboBoxColumnDescriptionMetadata.a = null;
    return ComboBoxColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ComboBoxColumnDescriptionModule = /*@__PURE__*/ (() => {
    class ComboBoxColumnDescriptionModule extends Base {
        static register(a) {
            ComboBoxColumnDescriptionMetadata.d(a);
        }
    }
    ComboBoxColumnDescriptionModule.$t = /*@__PURE__*/ markType(ComboBoxColumnDescriptionModule, 'ComboBoxColumnDescriptionModule');
    return ComboBoxColumnDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomMapImageryDescription = /*@__PURE__*/ (() => {
    class CustomMapImageryDescription extends GeographicMapImageryDescription {
        get_type() {
            return "CustomMapImagery";
        }
        constructor() {
            super();
            this.ac = null;
        }
        get getTileImageUriRef() {
            return this.ac;
        }
        set getTileImageUriRef(a) {
            this.ac = a;
            this.g("GetTileImageUriRef");
        }
    }
    CustomMapImageryDescription.$t = /*@__PURE__*/ markType(CustomMapImageryDescription, 'CustomMapImageryDescription', GeographicMapImageryDescription.$);
    return CustomMapImageryDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GetTileImageUriArgsDescription = /*@__PURE__*/ (() => {
    class GetTileImageUriArgsDescription extends Description {
        get_type() {
            return "GetTileImageUriArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = 0;
            this.i = 0;
            this.j = 0;
            this.n = null;
        }
        get tileLevel() {
            return this.h;
        }
        set tileLevel(a) {
            this.h = a;
            this.g("TileLevel");
        }
        get tilePositionX() {
            return this.i;
        }
        set tilePositionX(a) {
            this.i = a;
            this.g("TilePositionX");
        }
        get tilePositionY() {
            return this.j;
        }
        set tilePositionY(a) {
            this.j = a;
            this.g("TilePositionY");
        }
        get tileImageUri() {
            return this.n;
        }
        set tileImageUri(a) {
            this.n = a;
            this.g("TileImageUri");
        }
    }
    GetTileImageUriArgsDescription.$t = /*@__PURE__*/ markType(GetTileImageUriArgsDescription, 'GetTileImageUriArgsDescription', Description.$);
    return GetTileImageUriArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GetTileImageUriArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GetTileImageUriArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GetTileImageUriArgsDescriptionMetadata.a == null) {
                GetTileImageUriArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GetTileImageUriArgsDescriptionMetadata.c(GetTileImageUriArgsDescriptionMetadata.a);
            }
            if (a.k(GetTileImageUriArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GetTileImageUriArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("TileLevel", "Number:int");
            a.item("TilePositionX", "Number:int");
            a.item("TilePositionY", "Number:int");
            a.item("TileImageUri", "String");
        }
        static d(a) {
            GetTileImageUriArgsDescriptionMetadata.b(a);
            a.ae("GetTileImageUriArgs", () => new GetTileImageUriArgsDescription());
            a.ad("GetTileImageUriArgs", GetTileImageUriArgsDescriptionMetadata.a);
        }
    }
    GetTileImageUriArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GetTileImageUriArgsDescriptionMetadata, 'GetTileImageUriArgsDescriptionMetadata');
    GetTileImageUriArgsDescriptionMetadata.a = null;
    return GetTileImageUriArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomMapImageryDescriptionMetadata = /*@__PURE__*/ (() => {
    class CustomMapImageryDescriptionMetadata extends Base {
        static b(a) {
            if (CustomMapImageryDescriptionMetadata.a == null) {
                CustomMapImageryDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CustomMapImageryDescriptionMetadata.c(CustomMapImageryDescriptionMetadata.a);
            }
            if (a.k(CustomMapImageryDescriptionMetadata.a)) {
                return;
            }
            a.ac(CustomMapImageryDescriptionMetadata.a);
            GetTileImageUriArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            GeographicMapImageryDescriptionMetadata.c(a);
            a.item("GetTileImageUriRef", "EventRef::getTileImageUri");
        }
        static d(a) {
            CustomMapImageryDescriptionMetadata.b(a);
            a.ae("CustomMapImagery", () => new CustomMapImageryDescription());
            a.ad("CustomMapImagery", CustomMapImageryDescriptionMetadata.a);
        }
    }
    CustomMapImageryDescriptionMetadata.$t = /*@__PURE__*/ markType(CustomMapImageryDescriptionMetadata, 'CustomMapImageryDescriptionMetadata');
    CustomMapImageryDescriptionMetadata.a = null;
    return CustomMapImageryDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomMapImageryDescriptionModule = /*@__PURE__*/ (() => {
    class CustomMapImageryDescriptionModule extends Base {
        static register(a) {
            CustomMapImageryDescriptionMetadata.d(a);
        }
    }
    CustomMapImageryDescriptionModule.$t = /*@__PURE__*/ markType(CustomMapImageryDescriptionModule, 'CustomMapImageryDescriptionModule');
    return CustomMapImageryDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesMatcherDescriptionModule = /*@__PURE__*/ (() => {
    class SeriesMatcherDescriptionModule extends Base {
        static register(a) {
            SeriesMatcherDescriptionMetadata.d(a);
        }
    }
    SeriesMatcherDescriptionModule.$t = /*@__PURE__*/ markType(SeriesMatcherDescriptionModule, 'SeriesMatcherDescriptionModule');
    return SeriesMatcherDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartDescription = /*@__PURE__*/ (() => {
    class DataChartDescription extends SeriesViewerDescription {
        get_type() {
            return "DataChart";
        }
        constructor() {
            super();
            this.h1 = false;
            this.it = 0;
            this.iu = 0;
            this.ik = 0;
            this.il = 0;
            this.h0 = false;
            this.h2 = false;
            this.je = null;
            this.hz = false;
            this.io = 0;
            this.im = 0;
            this.h5 = false;
            this.h3 = false;
            this.h4 = false;
            this.h6 = false;
            this.i9 = null;
            this.jd = null;
            this.jb = null;
            this.jc = null;
            this.hx = null;
            this.ih = 0;
            this.ij = 0;
            this.ii = 0;
            this.ig = 0;
            this.ja = null;
            this.jg = null;
            this.jh = null;
            this.iq = 0;
            this.is = 0;
            this.ir = 0;
            this.ip = 0;
            this.ji = null;
            this.jf = null;
        }
        get isSquare() {
            return this.h1;
        }
        set isSquare(a) {
            this.h1 = a;
            this.g("IsSquare");
        }
        get windowScaleHorizontal() {
            return this.it;
        }
        set windowScaleHorizontal(a) {
            this.it = a;
            this.g("WindowScaleHorizontal");
        }
        get windowScaleVertical() {
            return this.iu;
        }
        set windowScaleVertical(a) {
            this.iu = a;
            this.g("WindowScaleVertical");
        }
        get actualWindowScaleHorizontal() {
            return this.ik;
        }
        set actualWindowScaleHorizontal(a) {
            this.ik = a;
            this.g("ActualWindowScaleHorizontal");
        }
        get actualWindowScaleVertical() {
            return this.il;
        }
        set actualWindowScaleVertical(a) {
            this.il = a;
            this.g("ActualWindowScaleVertical");
        }
        get isHorizontalZoomEnabled() {
            return this.h0;
        }
        set isHorizontalZoomEnabled(a) {
            this.h0 = a;
            this.g("IsHorizontalZoomEnabled");
        }
        get isVerticalZoomEnabled() {
            return this.h2;
        }
        set isVerticalZoomEnabled(a) {
            this.h2 = a;
            this.g("IsVerticalZoomEnabled");
        }
        get gridMode() {
            return this.je;
        }
        set gridMode(a) {
            this.je = a;
            this.g("GridMode");
        }
        get alignsGridLinesToPixels() {
            return this.hz;
        }
        set alignsGridLinesToPixels(a) {
            this.hz = a;
            this.g("AlignsGridLinesToPixels");
        }
        get autoExpandMarginMaximumValue() {
            return this.io;
        }
        set autoExpandMarginMaximumValue(a) {
            this.io = a;
            this.g("AutoExpandMarginMaximumValue");
        }
        get autoExpandMarginExtraPadding() {
            return this.im;
        }
        set autoExpandMarginExtraPadding(a) {
            this.im = a;
            this.g("AutoExpandMarginExtraPadding");
        }
        get shouldSuppressAxisLabelTruncation() {
            return this.h5;
        }
        set shouldSuppressAxisLabelTruncation(a) {
            this.h5 = a;
            this.g("ShouldSuppressAxisLabelTruncation");
        }
        get shouldAutoExpandMarginForInitialLabels() {
            return this.h3;
        }
        set shouldAutoExpandMarginForInitialLabels(a) {
            this.h3 = a;
            this.g("ShouldAutoExpandMarginForInitialLabels");
        }
        get shouldConsiderAutoRotationForInitialLabels() {
            return this.h4;
        }
        set shouldConsiderAutoRotationForInitialLabels(a) {
            this.h4 = a;
            this.g("ShouldConsiderAutoRotationForInitialLabels");
        }
        get suppressAutoMarginAndAngleRecalculation() {
            return this.h6;
        }
        set suppressAutoMarginAndAngleRecalculation(a) {
            this.h6 = a;
            this.g("SuppressAutoMarginAndAngleRecalculation");
        }
        get autoMarginAndAngleUpdateMode() {
            return this.i9;
        }
        set autoMarginAndAngleUpdateMode(a) {
            this.i9 = a;
            this.g("AutoMarginAndAngleUpdateMode");
        }
        get defaultAxisStroke() {
            return this.jd;
        }
        set defaultAxisStroke(a) {
            this.jd = a;
            this.g("DefaultAxisStroke");
        }
        get defaultAxisMajorStroke() {
            return this.jb;
        }
        set defaultAxisMajorStroke(a) {
            this.jb = a;
            this.g("DefaultAxisMajorStroke");
        }
        get defaultAxisMinorStroke() {
            return this.jc;
        }
        set defaultAxisMinorStroke(a) {
            this.jc = a;
            this.g("DefaultAxisMinorStroke");
        }
        get axes() {
            return this.hx;
        }
        set axes(a) {
            this.hx = a;
            this.g("Axes");
        }
        get actualPlotAreaMarginLeft() {
            return this.ih;
        }
        set actualPlotAreaMarginLeft(a) {
            this.ih = a;
            this.g("ActualPlotAreaMarginLeft");
        }
        get actualPlotAreaMarginTop() {
            return this.ij;
        }
        set actualPlotAreaMarginTop(a) {
            this.ij = a;
            this.g("ActualPlotAreaMarginTop");
        }
        get actualPlotAreaMarginRight() {
            return this.ii;
        }
        set actualPlotAreaMarginRight(a) {
            this.ii = a;
            this.g("ActualPlotAreaMarginRight");
        }
        get actualPlotAreaMarginBottom() {
            return this.ig;
        }
        set actualPlotAreaMarginBottom(a) {
            this.ig = a;
            this.g("ActualPlotAreaMarginBottom");
        }
        get computedPlotAreaMarginMode() {
            return this.ja;
        }
        set computedPlotAreaMarginMode(a) {
            this.ja = a;
            this.g("ComputedPlotAreaMarginMode");
        }
        get seriesPlotAreaMarginHorizontalMode() {
            return this.jg;
        }
        set seriesPlotAreaMarginHorizontalMode(a) {
            this.jg = a;
            this.g("SeriesPlotAreaMarginHorizontalMode");
        }
        get seriesPlotAreaMarginVerticalMode() {
            return this.jh;
        }
        set seriesPlotAreaMarginVerticalMode(a) {
            this.jh = a;
            this.g("SeriesPlotAreaMarginVerticalMode");
        }
        get plotAreaMarginLeft() {
            return this.iq;
        }
        set plotAreaMarginLeft(a) {
            this.iq = a;
            this.g("PlotAreaMarginLeft");
        }
        get plotAreaMarginTop() {
            return this.is;
        }
        set plotAreaMarginTop(a) {
            this.is = a;
            this.g("PlotAreaMarginTop");
        }
        get plotAreaMarginRight() {
            return this.ir;
        }
        set plotAreaMarginRight(a) {
            this.ir = a;
            this.g("PlotAreaMarginRight");
        }
        get plotAreaMarginBottom() {
            return this.ip;
        }
        set plotAreaMarginBottom(a) {
            this.ip = a;
            this.g("PlotAreaMarginBottom");
        }
        get width() {
            return this.ji;
        }
        set width(a) {
            this.ji = a;
            this.g("Width");
        }
        get height() {
            return this.jf;
        }
        set height(a) {
            this.jf = a;
            this.g("Height");
        }
    }
    DataChartDescription.$t = /*@__PURE__*/ markType(DataChartDescription, 'DataChartDescription', SeriesViewerDescription.$);
    return DataChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataChartDescriptionMetadata extends Base {
        static b(a) {
            if (DataChartDescriptionMetadata.a == null) {
                DataChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataChartDescriptionMetadata.c(DataChartDescriptionMetadata.a);
            }
            if (a.k(DataChartDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataChartDescriptionMetadata.a);
        }
        static c(a) {
            SeriesViewerDescriptionMetadata.c(a);
            a.item("IsSquare", "Boolean");
            a.item("WindowScaleHorizontal", "Number:double");
            a.item("WindowScaleVertical", "Number:double");
            a.item("ActualWindowScaleHorizontal", "Number:double");
            a.item("ActualWindowScaleVertical", "Number:double");
            a.item("IsHorizontalZoomEnabled", "Boolean");
            a.item("IsVerticalZoomEnabled", "Boolean");
            a.item("GridMode", "ExportedType:string:GridMode");
            a.item("GridMode@names", "None;BeforeSeries;BehindSeries");
            a.item("AlignsGridLinesToPixels", "Boolean");
            a.item("AutoExpandMarginMaximumValue", "Number:double");
            a.item("AutoExpandMarginExtraPadding", "Number:double");
            a.item("ShouldSuppressAxisLabelTruncation", "Boolean");
            a.item("ShouldAutoExpandMarginForInitialLabels", "Boolean");
            a.item("ShouldConsiderAutoRotationForInitialLabels", "Boolean");
            a.item("SuppressAutoMarginAndAngleRecalculation", "Boolean");
            a.item("AutoMarginAndAngleUpdateMode", "ExportedType:string:AutoMarginsAndAngleUpdateMode");
            a.item("AutoMarginAndAngleUpdateMode@names", "None;SizeChanging;SizeChangingAndZoom");
            a.item("DefaultAxisStroke", "Brush");
            a.item("DefaultAxisMajorStroke", "Brush");
            a.item("DefaultAxisMinorStroke", "Brush");
            a.item("Axes", "Collection:Axis:AxisCollection:Axis");
            a.item("ActualPlotAreaMarginLeft", "Number:double");
            a.item("ActualPlotAreaMarginTop", "Number:double");
            a.item("ActualPlotAreaMarginRight", "Number:double");
            a.item("ActualPlotAreaMarginBottom", "Number:double");
            a.item("ComputedPlotAreaMarginMode", "ExportedType:string:ComputedPlotAreaMarginMode");
            a.item("ComputedPlotAreaMarginMode@names", "Auto;Series;None");
            a.item("SeriesPlotAreaMarginHorizontalMode", "ExportedType:string:SeriesPlotAreaMarginHorizontalMode");
            a.item("SeriesPlotAreaMarginHorizontalMode@names", "Auto;LeftMarginRightMargin;LeftBufferRightBuffer;LeftMarginRightBuffer;LeftBufferRightMargin;None");
            a.item("SeriesPlotAreaMarginVerticalMode", "ExportedType:string:SeriesPlotAreaMarginVerticalMode");
            a.item("SeriesPlotAreaMarginVerticalMode@names", "Auto;BottomMarginTopMargin;BottomBufferTopBuffer;BottomMarginTopBuffer;BottomBufferTopMargin;None");
            a.item("PlotAreaMarginLeft", "Number:double");
            a.item("PlotAreaMarginTop", "Number:double");
            a.item("PlotAreaMarginRight", "Number:double");
            a.item("PlotAreaMarginBottom", "Number:double");
            DataChartDescriptionMetadata.e(a);
        }
        static d(a) {
            DataChartDescriptionMetadata.b(a);
            a.ae("DataChart", () => new DataChartDescription());
            a.ad("DataChart", DataChartDescriptionMetadata.a);
        }
        static e(a) {
            a.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamDataChart");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
        }
    }
    DataChartDescriptionMetadata.$t = /*@__PURE__*/ markType(DataChartDescriptionMetadata, 'DataChartDescriptionMetadata');
    DataChartDescriptionMetadata.a = null;
    return DataChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartCoreDescriptionModule extends Base {
        static register(a) {
            NumberFormatSpecifierDescriptionModule.register(a);
            DateTimeFormatSpecifierDescriptionModule.register(a);
            ChartSelectionDescriptionModule.register(a);
            SeriesMatcherDescriptionModule.register(a);
            DataChartDescriptionMetadata.d(a);
        }
    }
    DataChartCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartCoreDescriptionModule, 'DataChartCoreDescriptionModule');
    return DataChartCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartCategoryCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartCategoryCoreDescriptionModule extends Base {
        static register(a) {
            CategoryXAxisDescriptionModule.register(a);
            NumericYAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartCategoryCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartCategoryCoreDescriptionModule, 'DataChartCategoryCoreDescriptionModule');
    return DataChartCategoryCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeCategorySeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RangeCategorySeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RangeCategorySeriesDescriptionMetadata.a == null) {
                RangeCategorySeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RangeCategorySeriesDescriptionMetadata.c(RangeCategorySeriesDescriptionMetadata.a);
            }
            if (a.k(RangeCategorySeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(RangeCategorySeriesDescriptionMetadata.a);
        }
        static c(a) {
            CategorySeriesDescriptionMetadata.c(a);
            a.item("LowMemberPath", "String");
            a.item("HighMemberPath", "String");
            a.item("HighlightedLowMemberPath", "String");
            a.item("HighlightedHighMemberPath", "String");
        }
        static d(a) {
            RangeCategorySeriesDescriptionMetadata.b(a);
            a.ad("RangeCategorySeries", RangeCategorySeriesDescriptionMetadata.a);
        }
    }
    RangeCategorySeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RangeCategorySeriesDescriptionMetadata, 'RangeCategorySeriesDescriptionMetadata');
    RangeCategorySeriesDescriptionMetadata.a = null;
    return RangeCategorySeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalRangeCategorySeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class HorizontalRangeCategorySeriesDescriptionMetadata extends Base {
        static b(a) {
            if (HorizontalRangeCategorySeriesDescriptionMetadata.a == null) {
                HorizontalRangeCategorySeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HorizontalRangeCategorySeriesDescriptionMetadata.c(HorizontalRangeCategorySeriesDescriptionMetadata.a);
            }
            if (a.k(HorizontalRangeCategorySeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(HorizontalRangeCategorySeriesDescriptionMetadata.a);
        }
        static c(a) {
            RangeCategorySeriesDescriptionMetadata.c(a);
            a.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            a.item("XAxisRef@nameBinding", "true");
            a.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            a.item("YAxisRef@nameBinding", "true");
            a.item("LowMemberAsLegendLabel", "String");
            a.item("HighMemberAsLegendLabel", "String");
            a.item("LowMemberAsLegendUnit", "String");
            a.item("HighMemberAsLegendUnit", "String");
        }
        static d(a) {
            HorizontalRangeCategorySeriesDescriptionMetadata.b(a);
            a.ad("HorizontalRangeCategorySeries", HorizontalRangeCategorySeriesDescriptionMetadata.a);
        }
    }
    HorizontalRangeCategorySeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(HorizontalRangeCategorySeriesDescriptionMetadata, 'HorizontalRangeCategorySeriesDescriptionMetadata');
    HorizontalRangeCategorySeriesDescriptionMetadata.a = null;
    return HorizontalRangeCategorySeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeCategorySeriesDescription = /*@__PURE__*/ (() => {
    class RangeCategorySeriesDescription extends CategorySeriesDescription {
        get_type() {
            return "RangeCategorySeries";
        }
        constructor() {
            super();
            this.f4 = null;
            this.f3 = null;
            this.f2 = null;
            this.f1 = null;
        }
        get lowMemberPath() {
            return this.f4;
        }
        set lowMemberPath(a) {
            this.f4 = a;
            this.g("LowMemberPath");
        }
        get highMemberPath() {
            return this.f3;
        }
        set highMemberPath(a) {
            this.f3 = a;
            this.g("HighMemberPath");
        }
        get highlightedLowMemberPath() {
            return this.f2;
        }
        set highlightedLowMemberPath(a) {
            this.f2 = a;
            this.g("HighlightedLowMemberPath");
        }
        get highlightedHighMemberPath() {
            return this.f1;
        }
        set highlightedHighMemberPath(a) {
            this.f1 = a;
            this.g("HighlightedHighMemberPath");
        }
    }
    RangeCategorySeriesDescription.$t = /*@__PURE__*/ markType(RangeCategorySeriesDescription, 'RangeCategorySeriesDescription', CategorySeriesDescription.$);
    return RangeCategorySeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalRangeCategorySeriesDescription = /*@__PURE__*/ (() => {
    class HorizontalRangeCategorySeriesDescription extends RangeCategorySeriesDescription {
        get_type() {
            return "HorizontalRangeCategorySeries";
        }
        constructor() {
            super();
            this.gd = null;
            this.ge = null;
            this.gb = null;
            this.f9 = null;
            this.gc = null;
            this.ga = null;
        }
        get xAxisRef() {
            return this.gd;
        }
        set xAxisRef(a) {
            this.gd = a;
            this.g("XAxisRef");
        }
        get yAxisRef() {
            return this.ge;
        }
        set yAxisRef(a) {
            this.ge = a;
            this.g("YAxisRef");
        }
        get lowMemberAsLegendLabel() {
            return this.gb;
        }
        set lowMemberAsLegendLabel(a) {
            this.gb = a;
            this.g("LowMemberAsLegendLabel");
        }
        get highMemberAsLegendLabel() {
            return this.f9;
        }
        set highMemberAsLegendLabel(a) {
            this.f9 = a;
            this.g("HighMemberAsLegendLabel");
        }
        get lowMemberAsLegendUnit() {
            return this.gc;
        }
        set lowMemberAsLegendUnit(a) {
            this.gc = a;
            this.g("LowMemberAsLegendUnit");
        }
        get highMemberAsLegendUnit() {
            return this.ga;
        }
        set highMemberAsLegendUnit(a) {
            this.ga = a;
            this.g("HighMemberAsLegendUnit");
        }
    }
    HorizontalRangeCategorySeriesDescription.$t = /*@__PURE__*/ markType(HorizontalRangeCategorySeriesDescription, 'HorizontalRangeCategorySeriesDescription', RangeCategorySeriesDescription.$);
    return HorizontalRangeCategorySeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeAreaSeriesDescription = /*@__PURE__*/ (() => {
    class RangeAreaSeriesDescription extends HorizontalRangeCategorySeriesDescription {
        get_type() {
            return "RangeAreaSeries";
        }
        constructor() {
            super();
        }
    }
    RangeAreaSeriesDescription.$t = /*@__PURE__*/ markType(RangeAreaSeriesDescription, 'RangeAreaSeriesDescription', HorizontalRangeCategorySeriesDescription.$);
    return RangeAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RangeAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RangeAreaSeriesDescriptionMetadata.a == null) {
                RangeAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RangeAreaSeriesDescriptionMetadata.c(RangeAreaSeriesDescriptionMetadata.a);
            }
            if (a.k(RangeAreaSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(RangeAreaSeriesDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalRangeCategorySeriesDescriptionMetadata.c(a);
        }
        static d(a) {
            RangeAreaSeriesDescriptionMetadata.b(a);
            a.ae("RangeAreaSeries", () => new RangeAreaSeriesDescription());
            a.ad("RangeAreaSeries", RangeAreaSeriesDescriptionMetadata.a);
        }
    }
    RangeAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RangeAreaSeriesDescriptionMetadata, 'RangeAreaSeriesDescriptionMetadata');
    RangeAreaSeriesDescriptionMetadata.a = null;
    return RangeAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class RangeAreaSeriesDescriptionModule extends Base {
        static register(a) {
            RangeAreaSeriesDescriptionMetadata.d(a);
        }
    }
    RangeAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(RangeAreaSeriesDescriptionModule, 'RangeAreaSeriesDescriptionModule');
    return RangeAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeColumnSeriesDescription = /*@__PURE__*/ (() => {
    class RangeColumnSeriesDescription extends HorizontalRangeCategorySeriesDescription {
        get_type() {
            return "RangeColumnSeries";
        }
        constructor() {
            super();
            this.gl = 0;
            this.gm = 0;
        }
        get radiusX() {
            return this.gl;
        }
        set radiusX(a) {
            this.gl = a;
            this.g("RadiusX");
        }
        get radiusY() {
            return this.gm;
        }
        set radiusY(a) {
            this.gm = a;
            this.g("RadiusY");
        }
    }
    RangeColumnSeriesDescription.$t = /*@__PURE__*/ markType(RangeColumnSeriesDescription, 'RangeColumnSeriesDescription', HorizontalRangeCategorySeriesDescription.$);
    return RangeColumnSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeColumnSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RangeColumnSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RangeColumnSeriesDescriptionMetadata.a == null) {
                RangeColumnSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RangeColumnSeriesDescriptionMetadata.c(RangeColumnSeriesDescriptionMetadata.a);
            }
            if (a.k(RangeColumnSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(RangeColumnSeriesDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalRangeCategorySeriesDescriptionMetadata.c(a);
            a.item("RadiusX", "Number:double");
            a.item("RadiusY", "Number:double");
        }
        static d(a) {
            RangeColumnSeriesDescriptionMetadata.b(a);
            a.ae("RangeColumnSeries", () => new RangeColumnSeriesDescription());
            a.ad("RangeColumnSeries", RangeColumnSeriesDescriptionMetadata.a);
        }
    }
    RangeColumnSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RangeColumnSeriesDescriptionMetadata, 'RangeColumnSeriesDescriptionMetadata');
    RangeColumnSeriesDescriptionMetadata.a = null;
    return RangeColumnSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeColumnSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class RangeColumnSeriesDescriptionModule extends Base {
        static register(a) {
            RangeColumnSeriesDescriptionMetadata.d(a);
        }
    }
    RangeColumnSeriesDescriptionModule.$t = /*@__PURE__*/ markType(RangeColumnSeriesDescriptionModule, 'RangeColumnSeriesDescriptionModule');
    return RangeColumnSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartCategoryDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartCategoryDescriptionModule extends Base {
        static register(a) {
            LineSeriesDescriptionModule.register(a);
            AreaSeriesDescriptionModule.register(a);
            ColumnSeriesDescriptionModule.register(a);
            SplineSeriesDescriptionModule.register(a);
            SplineAreaSeriesDescriptionModule.register(a);
            StepLineSeriesDescriptionModule.register(a);
            StepAreaSeriesDescriptionModule.register(a);
            PointSeriesDescriptionModule.register(a);
            WaterfallSeriesDescriptionModule.register(a);
            RangeAreaSeriesDescriptionModule.register(a);
            RangeColumnSeriesDescriptionModule.register(a);
            DataChartCategoryCoreDescriptionModule.register(a);
        }
    }
    DataChartCategoryDescriptionModule.$t = /*@__PURE__*/ markType(DataChartCategoryDescriptionModule, 'DataChartCategoryDescriptionModule');
    return DataChartCategoryDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class TimeAxisBaseDescriptionMetadata extends Base {
        static b(a) {
            if (TimeAxisBaseDescriptionMetadata.a == null) {
                TimeAxisBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TimeAxisBaseDescriptionMetadata.c(TimeAxisBaseDescriptionMetadata.a);
            }
            if (a.k(TimeAxisBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(TimeAxisBaseDescriptionMetadata.a);
        }
        static c(a) {
            CategoryAxisBaseDescriptionMetadata.c(a);
            a.item("DateTimeMemberPath", "String");
            a.item("IsDataPreSorted", "Boolean");
            a.item("ActualMinimumValue", "Date");
            a.item("ActualMaximumValue", "Date");
            a.item("MinimumValue", "Date");
            a.item("MaximumValue", "Date");
            a.item("ActualMinimumValueChangeRef", "EventRef::actualMinimumValueChange");
            a.item("ActualMaximumValueChangeRef", "EventRef::actualMaximumValueChange");
        }
        static d(a) {
            TimeAxisBaseDescriptionMetadata.b(a);
            a.ad("TimeAxisBase", TimeAxisBaseDescriptionMetadata.a);
        }
    }
    TimeAxisBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(TimeAxisBaseDescriptionMetadata, 'TimeAxisBaseDescriptionMetadata');
    TimeAxisBaseDescriptionMetadata.a = null;
    return TimeAxisBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisBaseDescription = /*@__PURE__*/ (() => {
    class TimeAxisBaseDescription extends CategoryAxisBaseDescription {
        get_type() {
            return "TimeAxisBase";
        }
        constructor() {
            super();
            this.ef = null;
            this.d3 = false;
            this.d6 = new Date();
            this.d5 = new Date();
            this.d8 = new Date();
            this.d7 = new Date();
            this.ee = null;
            this.ed = null;
        }
        get dateTimeMemberPath() {
            return this.ef;
        }
        set dateTimeMemberPath(a) {
            this.ef = a;
            this.g("DateTimeMemberPath");
        }
        get isDataPreSorted() {
            return this.d3;
        }
        set isDataPreSorted(a) {
            this.d3 = a;
            this.g("IsDataPreSorted");
        }
        get actualMinimumValue() {
            return this.d6;
        }
        set actualMinimumValue(a) {
            this.d6 = a;
            this.g("ActualMinimumValue");
        }
        get actualMaximumValue() {
            return this.d5;
        }
        set actualMaximumValue(a) {
            this.d5 = a;
            this.g("ActualMaximumValue");
        }
        get minimumValue() {
            return this.d8;
        }
        set minimumValue(a) {
            this.d8 = a;
            this.g("MinimumValue");
        }
        get maximumValue() {
            return this.d7;
        }
        set maximumValue(a) {
            this.d7 = a;
            this.g("MaximumValue");
        }
        get actualMinimumValueChangeRef() {
            return this.ee;
        }
        set actualMinimumValueChangeRef(a) {
            this.ee = a;
            this.g("ActualMinimumValueChangeRef");
        }
        get actualMaximumValueChangeRef() {
            return this.ed;
        }
        set actualMaximumValueChangeRef(a) {
            this.ed = a;
            this.g("ActualMaximumValueChangeRef");
        }
    }
    TimeAxisBaseDescription.$t = /*@__PURE__*/ markType(TimeAxisBaseDescription, 'TimeAxisBaseDescription', CategoryAxisBaseDescription.$);
    return TimeAxisBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryDateTimeXAxisDescription = /*@__PURE__*/ (() => {
    class CategoryDateTimeXAxisDescription extends TimeAxisBaseDescription {
        get_type() {
            return "CategoryDateTimeXAxis";
        }
        constructor() {
            super();
            this.ej = false;
            this.ev = null;
            this.en = 0;
            this.el = 0;
            this.eo = 0;
            this.em = 0;
            this.et = null;
            this.eu = null;
        }
        get unevenlySpacedLabels() {
            return this.ej;
        }
        set unevenlySpacedLabels(a) {
            this.ej = a;
            this.g("UnevenlySpacedLabels");
        }
        get displayType() {
            return this.ev;
        }
        set displayType(a) {
            this.ev = a;
            this.g("DisplayType");
        }
        get interval() {
            return this.en;
        }
        set interval(a) {
            this.en = a;
            this.g("Interval");
        }
        get actualInterval() {
            return this.el;
        }
        set actualInterval(a) {
            this.el = a;
            this.g("ActualInterval");
        }
        get minorInterval() {
            return this.eo;
        }
        set minorInterval(a) {
            this.eo = a;
            this.g("MinorInterval");
        }
        get actualMinorInterval() {
            return this.em;
        }
        set actualMinorInterval(a) {
            this.em = a;
            this.g("ActualMinorInterval");
        }
        get actualIntervalChangeRef() {
            return this.et;
        }
        set actualIntervalChangeRef(a) {
            this.et = a;
            this.g("ActualIntervalChangeRef");
        }
        get actualMinorIntervalChangeRef() {
            return this.eu;
        }
        set actualMinorIntervalChangeRef(a) {
            this.eu = a;
            this.g("ActualMinorIntervalChangeRef");
        }
    }
    CategoryDateTimeXAxisDescription.$t = /*@__PURE__*/ markType(CategoryDateTimeXAxisDescription, 'CategoryDateTimeXAxisDescription', TimeAxisBaseDescription.$);
    return CategoryDateTimeXAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryDateTimeXAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryDateTimeXAxisDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryDateTimeXAxisDescriptionMetadata.a == null) {
                CategoryDateTimeXAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryDateTimeXAxisDescriptionMetadata.c(CategoryDateTimeXAxisDescriptionMetadata.a);
            }
            if (a.k(CategoryDateTimeXAxisDescriptionMetadata.a)) {
                return;
            }
            a.ac(CategoryDateTimeXAxisDescriptionMetadata.a);
        }
        static c(a) {
            TimeAxisBaseDescriptionMetadata.c(a);
            a.item("UnevenlySpacedLabels", "Boolean");
            a.item("DisplayType", "ExportedType:string:TimeAxisDisplayType");
            a.item("DisplayType@names", "Continuous;Discrete");
            a.item("Interval", "Number:long");
            a.item("ActualInterval", "Number:long");
            a.item("MinorInterval", "Number:long");
            a.item("ActualMinorInterval", "Number:long");
            a.item("ActualIntervalChangeRef", "EventRef::actualIntervalChange");
            a.item("ActualMinorIntervalChangeRef", "EventRef::actualMinorIntervalChange");
        }
        static d(a) {
            CategoryDateTimeXAxisDescriptionMetadata.b(a);
            a.ae("CategoryDateTimeXAxis", () => new CategoryDateTimeXAxisDescription());
            a.ad("CategoryDateTimeXAxis", CategoryDateTimeXAxisDescriptionMetadata.a);
        }
    }
    CategoryDateTimeXAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryDateTimeXAxisDescriptionMetadata, 'CategoryDateTimeXAxisDescriptionMetadata');
    CategoryDateTimeXAxisDescriptionMetadata.a = null;
    return CategoryDateTimeXAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryDateTimeXAxisDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryDateTimeXAxisDescriptionModule extends Base {
        static register(a) {
            CategoryDateTimeXAxisDescriptionMetadata.d(a);
        }
    }
    CategoryDateTimeXAxisDescriptionModule.$t = /*@__PURE__*/ markType(CategoryDateTimeXAxisDescriptionModule, 'CategoryDateTimeXAxisDescriptionModule');
    return CategoryDateTimeXAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisBreakDescription = /*@__PURE__*/ (() => {
    class TimeAxisBreakDescription extends Description {
        get_type() {
            return "TimeAxisBreak";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = new Date();
            this.h = new Date();
            this.l = 0;
        }
        get start() {
            return this.i;
        }
        set start(a) {
            this.i = a;
            this.g("Start");
        }
        get end() {
            return this.h;
        }
        set end(a) {
            this.h = a;
            this.g("End");
        }
        get interval() {
            return this.l;
        }
        set interval(a) {
            this.l = a;
            this.g("Interval");
        }
    }
    TimeAxisBreakDescription.$t = /*@__PURE__*/ markType(TimeAxisBreakDescription, 'TimeAxisBreakDescription', Description.$);
    return TimeAxisBreakDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisBreakDescriptionMetadata = /*@__PURE__*/ (() => {
    class TimeAxisBreakDescriptionMetadata extends Base {
        static b(a) {
            if (TimeAxisBreakDescriptionMetadata.a == null) {
                TimeAxisBreakDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TimeAxisBreakDescriptionMetadata.c(TimeAxisBreakDescriptionMetadata.a);
            }
            if (a.k(TimeAxisBreakDescriptionMetadata.a)) {
                return;
            }
            a.ac(TimeAxisBreakDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Start", "Date");
            a.item("End", "Date");
            a.item("Interval", "TimeSpan");
        }
        static d(a) {
            TimeAxisBreakDescriptionMetadata.b(a);
            a.ae("TimeAxisBreak", () => new TimeAxisBreakDescription());
            a.ad("TimeAxisBreak", TimeAxisBreakDescriptionMetadata.a);
        }
    }
    TimeAxisBreakDescriptionMetadata.$t = /*@__PURE__*/ markType(TimeAxisBreakDescriptionMetadata, 'TimeAxisBreakDescriptionMetadata');
    TimeAxisBreakDescriptionMetadata.a = null;
    return TimeAxisBreakDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisBreakDescriptionModule = /*@__PURE__*/ (() => {
    class TimeAxisBreakDescriptionModule extends Base {
        static register(a) {
            TimeAxisBreakDescriptionMetadata.d(a);
        }
    }
    TimeAxisBreakDescriptionModule.$t = /*@__PURE__*/ markType(TimeAxisBreakDescriptionModule, 'TimeAxisBreakDescriptionModule');
    return TimeAxisBreakDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisIntervalDescription = /*@__PURE__*/ (() => {
    class TimeAxisIntervalDescription extends Description {
        get_type() {
            return "TimeAxisInterval";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = 0;
            this.h = 0;
            this.l = null;
        }
        get range() {
            return this.j;
        }
        set range(a) {
            this.j = a;
            this.g("Range");
        }
        get interval() {
            return this.h;
        }
        set interval(a) {
            this.h = a;
            this.g("Interval");
        }
        get intervalType() {
            return this.l;
        }
        set intervalType(a) {
            this.l = a;
            this.g("IntervalType");
        }
    }
    TimeAxisIntervalDescription.$t = /*@__PURE__*/ markType(TimeAxisIntervalDescription, 'TimeAxisIntervalDescription', Description.$);
    return TimeAxisIntervalDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisIntervalDescriptionMetadata = /*@__PURE__*/ (() => {
    class TimeAxisIntervalDescriptionMetadata extends Base {
        static b(a) {
            if (TimeAxisIntervalDescriptionMetadata.a == null) {
                TimeAxisIntervalDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TimeAxisIntervalDescriptionMetadata.c(TimeAxisIntervalDescriptionMetadata.a);
            }
            if (a.k(TimeAxisIntervalDescriptionMetadata.a)) {
                return;
            }
            a.ac(TimeAxisIntervalDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Range", "TimeSpan");
            a.item("Interval", "Number:double");
            a.item("IntervalType", "ExportedType:string:TimeAxisIntervalType");
            a.item("IntervalType@names", "Ticks;Milliseconds;Seconds;Minutes;Hours;Days;Weeks;Months;Years");
        }
        static d(a) {
            TimeAxisIntervalDescriptionMetadata.b(a);
            a.ae("TimeAxisInterval", () => new TimeAxisIntervalDescription());
            a.ad("TimeAxisInterval", TimeAxisIntervalDescriptionMetadata.a);
        }
    }
    TimeAxisIntervalDescriptionMetadata.$t = /*@__PURE__*/ markType(TimeAxisIntervalDescriptionMetadata, 'TimeAxisIntervalDescriptionMetadata');
    TimeAxisIntervalDescriptionMetadata.a = null;
    return TimeAxisIntervalDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisIntervalDescriptionModule = /*@__PURE__*/ (() => {
    class TimeAxisIntervalDescriptionModule extends Base {
        static register(a) {
            TimeAxisIntervalDescriptionMetadata.d(a);
        }
    }
    TimeAxisIntervalDescriptionModule.$t = /*@__PURE__*/ markType(TimeAxisIntervalDescriptionModule, 'TimeAxisIntervalDescriptionModule');
    return TimeAxisIntervalDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisLabelFormatDescription = /*@__PURE__*/ (() => {
    class TimeAxisLabelFormatDescription extends Description {
        get_type() {
            return "TimeAxisLabelFormat";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = 0;
            this.j = null;
            this.m = null;
            this.l = null;
            this.k = null;
        }
        get range() {
            return this.h;
        }
        set range(a) {
            this.h = a;
            this.g("Range");
        }
        get format() {
            return this.j;
        }
        set format(a) {
            this.j = a;
            this.g("Format");
        }
        get repeatedYearFormat() {
            return this.m;
        }
        set repeatedYearFormat(a) {
            this.m = a;
            this.g("RepeatedYearFormat");
        }
        get repeatedMonthFormat() {
            return this.l;
        }
        set repeatedMonthFormat(a) {
            this.l = a;
            this.g("RepeatedMonthFormat");
        }
        get repeatedDayFormat() {
            return this.k;
        }
        set repeatedDayFormat(a) {
            this.k = a;
            this.g("RepeatedDayFormat");
        }
    }
    TimeAxisLabelFormatDescription.$t = /*@__PURE__*/ markType(TimeAxisLabelFormatDescription, 'TimeAxisLabelFormatDescription', Description.$);
    return TimeAxisLabelFormatDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisLabelFormatDescriptionMetadata = /*@__PURE__*/ (() => {
    class TimeAxisLabelFormatDescriptionMetadata extends Base {
        static b(a) {
            if (TimeAxisLabelFormatDescriptionMetadata.a == null) {
                TimeAxisLabelFormatDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TimeAxisLabelFormatDescriptionMetadata.c(TimeAxisLabelFormatDescriptionMetadata.a);
            }
            if (a.k(TimeAxisLabelFormatDescriptionMetadata.a)) {
                return;
            }
            a.ac(TimeAxisLabelFormatDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Range", "TimeSpan");
            a.item("Format", "String");
            a.item("RepeatedYearFormat", "String");
            a.item("RepeatedMonthFormat", "String");
            a.item("RepeatedDayFormat", "String");
        }
        static d(a) {
            TimeAxisLabelFormatDescriptionMetadata.b(a);
            a.ae("TimeAxisLabelFormat", () => new TimeAxisLabelFormatDescription());
            a.ad("TimeAxisLabelFormat", TimeAxisLabelFormatDescriptionMetadata.a);
        }
    }
    TimeAxisLabelFormatDescriptionMetadata.$t = /*@__PURE__*/ markType(TimeAxisLabelFormatDescriptionMetadata, 'TimeAxisLabelFormatDescriptionMetadata');
    TimeAxisLabelFormatDescriptionMetadata.a = null;
    return TimeAxisLabelFormatDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisLabelFormatDescriptionModule = /*@__PURE__*/ (() => {
    class TimeAxisLabelFormatDescriptionModule extends Base {
        static register(a) {
            TimeAxisLabelFormatDescriptionMetadata.d(a);
        }
    }
    TimeAxisLabelFormatDescriptionModule.$t = /*@__PURE__*/ markType(TimeAxisLabelFormatDescriptionModule, 'TimeAxisLabelFormatDescriptionModule');
    return TimeAxisLabelFormatDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeXAxisDescription = /*@__PURE__*/ (() => {
    class TimeXAxisDescription extends TimeAxisBaseDescription {
        get_type() {
            return "TimeXAxis";
        }
        constructor() {
            super();
            this.ej = null;
            this.ep = null;
            this.el = null;
            this.ek = null;
        }
        get breaks() {
            return this.ej;
        }
        set breaks(a) {
            this.ej = a;
            this.g("Breaks");
        }
        get labellingMode() {
            return this.ep;
        }
        set labellingMode(a) {
            this.ep = a;
            this.g("LabellingMode");
        }
        get labelFormats() {
            return this.el;
        }
        set labelFormats(a) {
            this.el = a;
            this.g("LabelFormats");
        }
        get intervals() {
            return this.ek;
        }
        set intervals(a) {
            this.ek = a;
            this.g("Intervals");
        }
    }
    TimeXAxisDescription.$t = /*@__PURE__*/ markType(TimeXAxisDescription, 'TimeXAxisDescription', TimeAxisBaseDescription.$);
    return TimeXAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeXAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class TimeXAxisDescriptionMetadata extends Base {
        static b(a) {
            if (TimeXAxisDescriptionMetadata.a == null) {
                TimeXAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TimeXAxisDescriptionMetadata.c(TimeXAxisDescriptionMetadata.a);
            }
            if (a.k(TimeXAxisDescriptionMetadata.a)) {
                return;
            }
            a.ac(TimeXAxisDescriptionMetadata.a);
        }
        static c(a) {
            TimeAxisBaseDescriptionMetadata.c(a);
            a.item("Breaks", "Collection:TimeAxisBreak:TimeAxisBreakCollection:TimeAxisBreak");
            a.item("LabellingMode", "ExportedType:string:TimeAxisLabellingMode");
            a.item("LabellingMode@names", "Auto;Normal;Compressed");
            a.item("LabelFormats", "Collection:TimeAxisLabelFormat:TimeAxisLabelFormatCollection:TimeAxisLabelFormat");
            a.item("Intervals", "Collection:TimeAxisInterval:TimeAxisIntervalCollection:TimeAxisInterval");
        }
        static d(a) {
            TimeXAxisDescriptionMetadata.b(a);
            a.ae("TimeXAxis", () => new TimeXAxisDescription());
            a.ad("TimeXAxis", TimeXAxisDescriptionMetadata.a);
        }
    }
    TimeXAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(TimeXAxisDescriptionMetadata, 'TimeXAxisDescriptionMetadata');
    TimeXAxisDescriptionMetadata.a = null;
    return TimeXAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeXAxisDescriptionModule = /*@__PURE__*/ (() => {
    class TimeXAxisDescriptionModule extends Base {
        static register(a) {
            TimeXAxisDescriptionMetadata.d(a);
        }
    }
    TimeXAxisDescriptionModule.$t = /*@__PURE__*/ markType(TimeXAxisDescriptionModule, 'TimeXAxisDescriptionModule');
    return TimeXAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OrdinalTimeXAxisDescription = /*@__PURE__*/ (() => {
    class OrdinalTimeXAxisDescription extends CategoryXAxisDescription {
        get_type() {
            return "OrdinalTimeXAxis";
        }
        constructor() {
            super();
            this.ev = null;
            this.ew = null;
            this.ep = null;
            this.es = new Date();
            this.er = new Date();
        }
        get dateTimeMemberPath() {
            return this.ev;
        }
        set dateTimeMemberPath(a) {
            this.ev = a;
            this.g("DateTimeMemberPath");
        }
        get labellingMode() {
            return this.ew;
        }
        set labellingMode(a) {
            this.ew = a;
            this.g("LabellingMode");
        }
        get labelFormats() {
            return this.ep;
        }
        set labelFormats(a) {
            this.ep = a;
            this.g("LabelFormats");
        }
        get minimumValue() {
            return this.es;
        }
        set minimumValue(a) {
            this.es = a;
            this.g("MinimumValue");
        }
        get maximumValue() {
            return this.er;
        }
        set maximumValue(a) {
            this.er = a;
            this.g("MaximumValue");
        }
    }
    OrdinalTimeXAxisDescription.$t = /*@__PURE__*/ markType(OrdinalTimeXAxisDescription, 'OrdinalTimeXAxisDescription', CategoryXAxisDescription.$);
    return OrdinalTimeXAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OrdinalTimeXAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class OrdinalTimeXAxisDescriptionMetadata extends Base {
        static b(a) {
            if (OrdinalTimeXAxisDescriptionMetadata.a == null) {
                OrdinalTimeXAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OrdinalTimeXAxisDescriptionMetadata.c(OrdinalTimeXAxisDescriptionMetadata.a);
            }
            if (a.k(OrdinalTimeXAxisDescriptionMetadata.a)) {
                return;
            }
            a.ac(OrdinalTimeXAxisDescriptionMetadata.a);
        }
        static c(a) {
            CategoryXAxisDescriptionMetadata.c(a);
            a.item("DateTimeMemberPath", "String");
            a.item("LabellingMode", "ExportedType:string:TimeAxisLabellingMode");
            a.item("LabellingMode@names", "Auto;Normal;Compressed");
            a.item("LabelFormats", "Collection:TimeAxisLabelFormat:TimeAxisLabelFormatCollection:TimeAxisLabelFormat");
            a.item("MinimumValue", "Date");
            a.item("MaximumValue", "Date");
        }
        static d(a) {
            OrdinalTimeXAxisDescriptionMetadata.b(a);
            a.ae("OrdinalTimeXAxis", () => new OrdinalTimeXAxisDescription());
            a.ad("OrdinalTimeXAxis", OrdinalTimeXAxisDescriptionMetadata.a);
        }
    }
    OrdinalTimeXAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(OrdinalTimeXAxisDescriptionMetadata, 'OrdinalTimeXAxisDescriptionMetadata');
    OrdinalTimeXAxisDescriptionMetadata.a = null;
    return OrdinalTimeXAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OrdinalTimeXAxisDescriptionModule = /*@__PURE__*/ (() => {
    class OrdinalTimeXAxisDescriptionModule extends Base {
        static register(a) {
            CategoryXAxisDescriptionModule.register(a);
            OrdinalTimeXAxisDescriptionMetadata.d(a);
        }
    }
    OrdinalTimeXAxisDescriptionModule.$t = /*@__PURE__*/ markType(OrdinalTimeXAxisDescriptionModule, 'OrdinalTimeXAxisDescriptionModule');
    return OrdinalTimeXAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartExtendedAxesDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartExtendedAxesDescriptionModule extends Base {
        static register(a) {
            CategoryDateTimeXAxisDescriptionModule.register(a);
            TimeAxisBreakDescriptionModule.register(a);
            TimeAxisIntervalDescriptionModule.register(a);
            TimeAxisLabelFormatDescriptionModule.register(a);
            TimeXAxisDescriptionModule.register(a);
            OrdinalTimeXAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartExtendedAxesDescriptionModule.$t = /*@__PURE__*/ markType(DataChartExtendedAxesDescriptionModule, 'DataChartExtendedAxesDescriptionModule');
    return DataChartExtendedAxesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartFinancialCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartFinancialCoreDescriptionModule extends Base {
        static register(a) {
            CategoryXAxisDescriptionModule.register(a);
            NumericYAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartFinancialCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartFinancialCoreDescriptionModule, 'DataChartFinancialCoreDescriptionModule');
    return DataChartFinancialCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalculatedColumnDescription = /*@__PURE__*/ (() => {
    class CalculatedColumnDescription extends Description {
        get_type() {
            return "CalculatedColumn";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    CalculatedColumnDescription.$t = /*@__PURE__*/ markType(CalculatedColumnDescription, 'CalculatedColumnDescription', Description.$);
    return CalculatedColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalculatedColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalculatedColumnDescriptionMetadata extends Base {
        static b(a) {
            if (CalculatedColumnDescriptionMetadata.a == null) {
                CalculatedColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalculatedColumnDescriptionMetadata.c(CalculatedColumnDescriptionMetadata.a);
            }
            if (a.k(CalculatedColumnDescriptionMetadata.a)) {
                return;
            }
            a.ac(CalculatedColumnDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            CalculatedColumnDescriptionMetadata.b(a);
            a.ae("CalculatedColumn", () => new CalculatedColumnDescription());
            a.ad("CalculatedColumn", CalculatedColumnDescriptionMetadata.a);
        }
    }
    CalculatedColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(CalculatedColumnDescriptionMetadata, 'CalculatedColumnDescriptionMetadata');
    CalculatedColumnDescriptionMetadata.a = null;
    return CalculatedColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialCalculationDataSourceDescription = /*@__PURE__*/ (() => {
    class FinancialCalculationDataSourceDescription extends Description {
        get_type() {
            return "FinancialCalculationDataSource";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.i = null;
            this.h = null;
            this.z = 0;
            this.aa = 0;
            this.y = 0;
            this.x = 0;
            this.w = 0;
            this.v = 0;
            this.r = 0;
            this.q = 0;
            this.p = 0;
            this.n = false;
        }
        get typicalColumn() {
            return this.j;
        }
        set typicalColumn(a) {
            this.j = a;
            this.g("TypicalColumn");
        }
        get trueRange() {
            return this.i;
        }
        set trueRange(a) {
            this.i = a;
            this.g("TrueRange");
        }
        get trueLow() {
            return this.h;
        }
        set trueLow(a) {
            this.h = a;
            this.g("TrueLow");
        }
        get period() {
            return this.z;
        }
        set period(a) {
            this.z = a;
            this.g("Period");
        }
        get shortPeriod() {
            return this.aa;
        }
        set shortPeriod(a) {
            this.aa = a;
            this.g("ShortPeriod");
        }
        get longPeriod() {
            return this.y;
        }
        set longPeriod(a) {
            this.y = a;
            this.g("LongPeriod");
        }
        get count() {
            return this.x;
        }
        set count(a) {
            this.x = a;
            this.g("Count");
        }
        get calculateFrom() {
            return this.w;
        }
        set calculateFrom(a) {
            this.w = a;
            this.g("CalculateFrom");
        }
        get calculateCount() {
            return this.v;
        }
        set calculateCount(a) {
            this.v = a;
            this.g("CalculateCount");
        }
        get multiplier() {
            return this.r;
        }
        set multiplier(a) {
            this.r = a;
            this.g("Multiplier");
        }
        get minimumValue() {
            return this.q;
        }
        set minimumValue(a) {
            this.q = a;
            this.g("MinimumValue");
        }
        get maximumValue() {
            return this.p;
        }
        set maximumValue(a) {
            this.p = a;
            this.g("MaximumValue");
        }
        get specifiesRange() {
            return this.n;
        }
        set specifiesRange(a) {
            this.n = a;
            this.g("SpecifiesRange");
        }
    }
    FinancialCalculationDataSourceDescription.$t = /*@__PURE__*/ markType(FinancialCalculationDataSourceDescription, 'FinancialCalculationDataSourceDescription', Description.$);
    return FinancialCalculationDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialCalculationDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialCalculationDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialCalculationDataSourceDescriptionMetadata.a == null) {
                FinancialCalculationDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialCalculationDataSourceDescriptionMetadata.c(FinancialCalculationDataSourceDescriptionMetadata.a);
            }
            if (a.k(FinancialCalculationDataSourceDescriptionMetadata.a)) {
                return;
            }
            a.ac(FinancialCalculationDataSourceDescriptionMetadata.a);
            CalculatedColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("TypicalColumn", "ExportedType:CalculatedColumn");
            a.item("TrueRange", "ExportedType:CalculatedColumn");
            a.item("TrueLow", "ExportedType:CalculatedColumn");
            a.item("Period", "Number:int");
            a.item("ShortPeriod", "Number:int");
            a.item("LongPeriod", "Number:int");
            a.item("Count", "Number:int");
            a.item("CalculateFrom", "Number:int");
            a.item("CalculateCount", "Number:int");
            a.item("Multiplier", "Number:double");
            a.item("MinimumValue", "Number:double");
            a.item("MaximumValue", "Number:double");
            a.item("SpecifiesRange", "Boolean");
        }
        static d(a) {
            FinancialCalculationDataSourceDescriptionMetadata.b(a);
            a.ae("FinancialCalculationDataSource", () => new FinancialCalculationDataSourceDescription());
            a.ad("FinancialCalculationDataSource", FinancialCalculationDataSourceDescriptionMetadata.a);
        }
    }
    FinancialCalculationDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialCalculationDataSourceDescriptionMetadata, 'FinancialCalculationDataSourceDescriptionMetadata');
    FinancialCalculationDataSourceDescriptionMetadata.a = null;
    return FinancialCalculationDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSupportingCalculationDescription = /*@__PURE__*/ (() => {
    class ColumnSupportingCalculationDescription extends Description {
        get_type() {
            return "ColumnSupportingCalculation";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ColumnSupportingCalculationDescription.$t = /*@__PURE__*/ markType(ColumnSupportingCalculationDescription, 'ColumnSupportingCalculationDescription', Description.$);
    return ColumnSupportingCalculationDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSupportingCalculationDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnSupportingCalculationDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnSupportingCalculationDescriptionMetadata.a == null) {
                ColumnSupportingCalculationDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnSupportingCalculationDescriptionMetadata.c(ColumnSupportingCalculationDescriptionMetadata.a);
            }
            if (a.k(ColumnSupportingCalculationDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnSupportingCalculationDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ColumnSupportingCalculationDescriptionMetadata.b(a);
            a.ae("ColumnSupportingCalculation", () => new ColumnSupportingCalculationDescription());
            a.ad("ColumnSupportingCalculation", ColumnSupportingCalculationDescriptionMetadata.a);
        }
    }
    ColumnSupportingCalculationDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnSupportingCalculationDescriptionMetadata, 'ColumnSupportingCalculationDescriptionMetadata');
    ColumnSupportingCalculationDescriptionMetadata.a = null;
    return ColumnSupportingCalculationDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSupportingCalculationDescription = /*@__PURE__*/ (() => {
    class DataSourceSupportingCalculationDescription extends Description {
        get_type() {
            return "DataSourceSupportingCalculation";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    DataSourceSupportingCalculationDescription.$t = /*@__PURE__*/ markType(DataSourceSupportingCalculationDescription, 'DataSourceSupportingCalculationDescription', Description.$);
    return DataSourceSupportingCalculationDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSupportingCalculationDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataSourceSupportingCalculationDescriptionMetadata extends Base {
        static b(a) {
            if (DataSourceSupportingCalculationDescriptionMetadata.a == null) {
                DataSourceSupportingCalculationDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataSourceSupportingCalculationDescriptionMetadata.c(DataSourceSupportingCalculationDescriptionMetadata.a);
            }
            if (a.k(DataSourceSupportingCalculationDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataSourceSupportingCalculationDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            DataSourceSupportingCalculationDescriptionMetadata.b(a);
            a.ae("DataSourceSupportingCalculation", () => new DataSourceSupportingCalculationDescription());
            a.ad("DataSourceSupportingCalculation", DataSourceSupportingCalculationDescriptionMetadata.a);
        }
    }
    DataSourceSupportingCalculationDescriptionMetadata.$t = /*@__PURE__*/ markType(DataSourceSupportingCalculationDescriptionMetadata, 'DataSourceSupportingCalculationDescriptionMetadata');
    DataSourceSupportingCalculationDescriptionMetadata.a = null;
    return DataSourceSupportingCalculationDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialCalculationSupportingCalculationsDescription = /*@__PURE__*/ (() => {
    class FinancialCalculationSupportingCalculationsDescription extends Description {
        get_type() {
            return "FinancialCalculationSupportingCalculations";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = null;
            this.k = null;
            this.i = null;
            this.s = null;
            this.q = null;
            this.r = null;
            this.p = null;
            this.x = null;
        }
        get eMA() {
            return this.h;
        }
        set eMA(a) {
            this.h = a;
            this.g("EMA");
        }
        get sMA() {
            return this.j;
        }
        set sMA(a) {
            this.j = a;
            this.g("SMA");
        }
        get sTDEV() {
            return this.k;
        }
        set sTDEV(a) {
            this.k = a;
            this.g("STDEV");
        }
        get movingSum() {
            return this.i;
        }
        set movingSum(a) {
            this.i = a;
            this.g("MovingSum");
        }
        get shortVolumeOscillatorAverage() {
            return this.s;
        }
        set shortVolumeOscillatorAverage(a) {
            this.s = a;
            this.g("ShortVolumeOscillatorAverage");
        }
        get longVolumeOscillatorAverage() {
            return this.q;
        }
        set longVolumeOscillatorAverage(a) {
            this.q = a;
            this.g("LongVolumeOscillatorAverage");
        }
        get shortPriceOscillatorAverage() {
            return this.r;
        }
        set shortPriceOscillatorAverage(a) {
            this.r = a;
            this.g("ShortPriceOscillatorAverage");
        }
        get longPriceOscillatorAverage() {
            return this.p;
        }
        set longPriceOscillatorAverage(a) {
            this.p = a;
            this.g("LongPriceOscillatorAverage");
        }
        get makeSafeRef() {
            return this.x;
        }
        set makeSafeRef(a) {
            this.x = a;
            this.g("MakeSafeRef");
        }
    }
    FinancialCalculationSupportingCalculationsDescription.$t = /*@__PURE__*/ markType(FinancialCalculationSupportingCalculationsDescription, 'FinancialCalculationSupportingCalculationsDescription', Description.$);
    return FinancialCalculationSupportingCalculationsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialCalculationSupportingCalculationsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialCalculationSupportingCalculationsDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialCalculationSupportingCalculationsDescriptionMetadata.a == null) {
                FinancialCalculationSupportingCalculationsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialCalculationSupportingCalculationsDescriptionMetadata.c(FinancialCalculationSupportingCalculationsDescriptionMetadata.a);
            }
            if (a.k(FinancialCalculationSupportingCalculationsDescriptionMetadata.a)) {
                return;
            }
            a.ac(FinancialCalculationSupportingCalculationsDescriptionMetadata.a);
            ColumnSupportingCalculationDescriptionMetadata.d(a);
            DataSourceSupportingCalculationDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("EMA", "ExportedType:ColumnSupportingCalculation");
            a.item("SMA", "ExportedType:ColumnSupportingCalculation");
            a.item("STDEV", "ExportedType:ColumnSupportingCalculation");
            a.item("MovingSum", "ExportedType:ColumnSupportingCalculation");
            a.item("ShortVolumeOscillatorAverage", "ExportedType:DataSourceSupportingCalculation");
            a.item("LongVolumeOscillatorAverage", "ExportedType:DataSourceSupportingCalculation");
            a.item("ShortPriceOscillatorAverage", "ExportedType:DataSourceSupportingCalculation");
            a.item("LongPriceOscillatorAverage", "ExportedType:DataSourceSupportingCalculation");
            a.item("MakeSafeRef", "(w:MakeSafe,wf:MakeSafe)MethodRef");
        }
        static d(a) {
            FinancialCalculationSupportingCalculationsDescriptionMetadata.b(a);
            a.ae("FinancialCalculationSupportingCalculations", () => new FinancialCalculationSupportingCalculationsDescription());
            a.ad("FinancialCalculationSupportingCalculations", FinancialCalculationSupportingCalculationsDescriptionMetadata.a);
        }
    }
    FinancialCalculationSupportingCalculationsDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialCalculationSupportingCalculationsDescriptionMetadata, 'FinancialCalculationSupportingCalculationsDescriptionMetadata');
    FinancialCalculationSupportingCalculationsDescriptionMetadata.a = null;
    return FinancialCalculationSupportingCalculationsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialEventArgsDescription = /*@__PURE__*/ (() => {
    class FinancialEventArgsDescription extends Description {
        get_type() {
            return "FinancialEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.m = 0;
            this.l = 0;
            this.h = null;
            this.j = null;
        }
        get position() {
            return this.m;
        }
        set position(a) {
            this.m = a;
            this.g("Position");
        }
        get count() {
            return this.l;
        }
        set count(a) {
            this.l = a;
            this.g("Count");
        }
        get dataSource() {
            return this.h;
        }
        set dataSource(a) {
            this.h = a;
            this.g("DataSource");
        }
        get supportingCalculations() {
            return this.j;
        }
        set supportingCalculations(a) {
            this.j = a;
            this.g("SupportingCalculations");
        }
    }
    FinancialEventArgsDescription.$t = /*@__PURE__*/ markType(FinancialEventArgsDescription, 'FinancialEventArgsDescription', Description.$);
    return FinancialEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialEventArgsDescriptionMetadata.a == null) {
                FinancialEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialEventArgsDescriptionMetadata.c(FinancialEventArgsDescriptionMetadata.a);
            }
            if (a.k(FinancialEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(FinancialEventArgsDescriptionMetadata.a);
            FinancialCalculationDataSourceDescriptionMetadata.d(a);
            FinancialCalculationSupportingCalculationsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Position", "Number:int");
            a.item("Count", "Number:int");
            a.item("DataSource", "ExportedType:FinancialCalculationDataSource");
            a.item("SupportingCalculations", "ExportedType:FinancialCalculationSupportingCalculations");
        }
        static d(a) {
            FinancialEventArgsDescriptionMetadata.b(a);
            a.ae("FinancialEventArgs", () => new FinancialEventArgsDescription());
            a.ad("FinancialEventArgs", FinancialEventArgsDescriptionMetadata.a);
        }
    }
    FinancialEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialEventArgsDescriptionMetadata, 'FinancialEventArgsDescriptionMetadata');
    FinancialEventArgsDescriptionMetadata.a = null;
    return FinancialEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialSeriesDescriptionMetadata.a == null) {
                FinancialSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialSeriesDescriptionMetadata.c(FinancialSeriesDescriptionMetadata.a);
            }
            if (a.k(FinancialSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(FinancialSeriesDescriptionMetadata.a);
            AssigningCategoryStyleEventArgsDescriptionMetadata.d(a);
            FinancialEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            SeriesDescriptionMetadata.c(a);
            a.item("NegativeBrush", "Brush");
            a.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            a.item("XAxisRef@nameBinding", "true");
            a.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            a.item("YAxisRef@nameBinding", "true");
            a.item("OpenMemberPath", "String");
            a.item("HighMemberPath", "String");
            a.item("LowMemberPath", "String");
            a.item("CloseMemberPath", "String");
            a.item("VolumeMemberPath", "String");
            a.item("HighlightedOpenMemberPath", "String");
            a.item("HighlightedHighMemberPath", "String");
            a.item("HighlightedLowMemberPath", "String");
            a.item("HighlightedCloseMemberPath", "String");
            a.item("HighlightedVolumeMemberPath", "String");
            a.item("IsCustomCategoryStyleAllowed", "Boolean");
            a.item("TransitionInMode", "ExportedType:string:CategoryTransitionInMode");
            a.item("TransitionInMode@names", "Auto;FromZero;SweepFromLeft;SweepFromRight;SweepFromTop;SweepFromBottom;SweepFromCenter;AccordionFromLeft;AccordionFromRight;AccordionFromTop;AccordionFromBottom;Expand;SweepFromCategoryAxisMinimum;SweepFromCategoryAxisMaximum;SweepFromValueAxisMinimum;SweepFromValueAxisMaximum;AccordionFromCategoryAxisMinimum;AccordionFromCategoryAxisMaximum;AccordionFromValueAxisMinimum;AccordionFromValueAxisMaximum;FromParent");
            a.item("IsTransitionInEnabled", "Boolean");
            a.item("AssigningCategoryStyleRef", "EventRef::assigningCategoryStyle");
            a.item("TypicalRef", "EventRef::typical");
            a.item("TypicalBasedOnRef", "EventRef::typicalBasedOn");
        }
        static d(a) {
            FinancialSeriesDescriptionMetadata.b(a);
            a.ad("FinancialSeries", FinancialSeriesDescriptionMetadata.a);
        }
    }
    FinancialSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialSeriesDescriptionMetadata, 'FinancialSeriesDescriptionMetadata');
    FinancialSeriesDescriptionMetadata.a = null;
    return FinancialSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialIndicatorDescriptionMetadata.a == null) {
                FinancialIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialIndicatorDescriptionMetadata.c(FinancialIndicatorDescriptionMetadata.a);
            }
            if (a.k(FinancialIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(FinancialIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            FinancialSeriesDescriptionMetadata.c(a);
            a.item("DisplayType", "ExportedType:string:IndicatorDisplayType");
            a.item("DisplayType@names", "Line;Area;Column");
            a.item("IgnoreFirst", "Number:int");
            a.item("TrendLineType", "ExportedType:string:TrendLineType");
            a.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            a.item("TrendLineBrush", "Brush");
            a.item("ActualTrendLineBrush", "Brush");
            a.item("TrendLineThickness", "Number:double");
            a.item("TrendLineDashArray", "DoubleCollection:double");
            a.item("TrendLinePeriod", "Number:int");
        }
        static d(a) {
            FinancialIndicatorDescriptionMetadata.b(a);
            a.ad("FinancialIndicator", FinancialIndicatorDescriptionMetadata.a);
        }
    }
    FinancialIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialIndicatorDescriptionMetadata, 'FinancialIndicatorDescriptionMetadata');
    FinancialIndicatorDescriptionMetadata.a = null;
    return FinancialIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StrategyBasedIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class StrategyBasedIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (StrategyBasedIndicatorDescriptionMetadata.a == null) {
                StrategyBasedIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StrategyBasedIndicatorDescriptionMetadata.c(StrategyBasedIndicatorDescriptionMetadata.a);
            }
            if (a.k(StrategyBasedIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(StrategyBasedIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            FinancialIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            StrategyBasedIndicatorDescriptionMetadata.b(a);
            a.ad("StrategyBasedIndicator", StrategyBasedIndicatorDescriptionMetadata.a);
        }
    }
    StrategyBasedIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(StrategyBasedIndicatorDescriptionMetadata, 'StrategyBasedIndicatorDescriptionMetadata');
    StrategyBasedIndicatorDescriptionMetadata.a = null;
    return StrategyBasedIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialSeriesDescription = /*@__PURE__*/ (() => {
    class FinancialSeriesDescription extends SeriesDescription {
        get_type() {
            return "FinancialSeries";
        }
        constructor() {
            super();
            this.fe = null;
            this.fk = null;
            this.fl = null;
            this.ff = null;
            this.fc = null;
            this.fd = null;
            this.e6 = null;
            this.fj = null;
            this.fa = null;
            this.e8 = null;
            this.e9 = null;
            this.e7 = null;
            this.fb = null;
            this.e1 = false;
            this.fg = null;
            this.e2 = false;
            this.e5 = null;
            this.fh = null;
            this.fi = null;
        }
        get negativeBrush() {
            return this.fe;
        }
        set negativeBrush(a) {
            this.fe = a;
            this.g("NegativeBrush");
        }
        get xAxisRef() {
            return this.fk;
        }
        set xAxisRef(a) {
            this.fk = a;
            this.g("XAxisRef");
        }
        get yAxisRef() {
            return this.fl;
        }
        set yAxisRef(a) {
            this.fl = a;
            this.g("YAxisRef");
        }
        get openMemberPath() {
            return this.ff;
        }
        set openMemberPath(a) {
            this.ff = a;
            this.g("OpenMemberPath");
        }
        get highMemberPath() {
            return this.fc;
        }
        set highMemberPath(a) {
            this.fc = a;
            this.g("HighMemberPath");
        }
        get lowMemberPath() {
            return this.fd;
        }
        set lowMemberPath(a) {
            this.fd = a;
            this.g("LowMemberPath");
        }
        get closeMemberPath() {
            return this.e6;
        }
        set closeMemberPath(a) {
            this.e6 = a;
            this.g("CloseMemberPath");
        }
        get volumeMemberPath() {
            return this.fj;
        }
        set volumeMemberPath(a) {
            this.fj = a;
            this.g("VolumeMemberPath");
        }
        get highlightedOpenMemberPath() {
            return this.fa;
        }
        set highlightedOpenMemberPath(a) {
            this.fa = a;
            this.g("HighlightedOpenMemberPath");
        }
        get highlightedHighMemberPath() {
            return this.e8;
        }
        set highlightedHighMemberPath(a) {
            this.e8 = a;
            this.g("HighlightedHighMemberPath");
        }
        get highlightedLowMemberPath() {
            return this.e9;
        }
        set highlightedLowMemberPath(a) {
            this.e9 = a;
            this.g("HighlightedLowMemberPath");
        }
        get highlightedCloseMemberPath() {
            return this.e7;
        }
        set highlightedCloseMemberPath(a) {
            this.e7 = a;
            this.g("HighlightedCloseMemberPath");
        }
        get highlightedVolumeMemberPath() {
            return this.fb;
        }
        set highlightedVolumeMemberPath(a) {
            this.fb = a;
            this.g("HighlightedVolumeMemberPath");
        }
        get isCustomCategoryStyleAllowed() {
            return this.e1;
        }
        set isCustomCategoryStyleAllowed(a) {
            this.e1 = a;
            this.g("IsCustomCategoryStyleAllowed");
        }
        get transitionInMode() {
            return this.fg;
        }
        set transitionInMode(a) {
            this.fg = a;
            this.g("TransitionInMode");
        }
        get isTransitionInEnabled() {
            return this.e2;
        }
        set isTransitionInEnabled(a) {
            this.e2 = a;
            this.g("IsTransitionInEnabled");
        }
        get assigningCategoryStyleRef() {
            return this.e5;
        }
        set assigningCategoryStyleRef(a) {
            this.e5 = a;
            this.g("AssigningCategoryStyleRef");
        }
        get typicalRef() {
            return this.fh;
        }
        set typicalRef(a) {
            this.fh = a;
            this.g("TypicalRef");
        }
        get typicalBasedOnRef() {
            return this.fi;
        }
        set typicalBasedOnRef(a) {
            this.fi = a;
            this.g("TypicalBasedOnRef");
        }
    }
    FinancialSeriesDescription.$t = /*@__PURE__*/ markType(FinancialSeriesDescription, 'FinancialSeriesDescription', SeriesDescription.$);
    return FinancialSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialIndicatorDescription = /*@__PURE__*/ (() => {
    class FinancialIndicatorDescription extends FinancialSeriesDescription {
        get_type() {
            return "FinancialIndicator";
        }
        constructor() {
            super();
            this.gc = null;
            this.f7 = 0;
            this.ge = null;
            this.gd = null;
            this.gb = null;
            this.f5 = 0;
            this.f3 = null;
            this.f8 = 0;
        }
        get displayType() {
            return this.gc;
        }
        set displayType(a) {
            this.gc = a;
            this.g("DisplayType");
        }
        get ignoreFirst() {
            return this.f7;
        }
        set ignoreFirst(a) {
            this.f7 = a;
            this.g("IgnoreFirst");
        }
        get trendLineType() {
            return this.ge;
        }
        set trendLineType(a) {
            this.ge = a;
            this.g("TrendLineType");
        }
        get trendLineBrush() {
            return this.gd;
        }
        set trendLineBrush(a) {
            this.gd = a;
            this.g("TrendLineBrush");
        }
        get actualTrendLineBrush() {
            return this.gb;
        }
        set actualTrendLineBrush(a) {
            this.gb = a;
            this.g("ActualTrendLineBrush");
        }
        get trendLineThickness() {
            return this.f5;
        }
        set trendLineThickness(a) {
            this.f5 = a;
            this.g("TrendLineThickness");
        }
        get trendLineDashArray() {
            return this.f3;
        }
        set trendLineDashArray(a) {
            this.f3 = a;
            this.g("TrendLineDashArray");
        }
        get trendLinePeriod() {
            return this.f8;
        }
        set trendLinePeriod(a) {
            this.f8 = a;
            this.g("TrendLinePeriod");
        }
    }
    FinancialIndicatorDescription.$t = /*@__PURE__*/ markType(FinancialIndicatorDescription, 'FinancialIndicatorDescription', FinancialSeriesDescription.$);
    return FinancialIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StrategyBasedIndicatorDescription = /*@__PURE__*/ (() => {
    class StrategyBasedIndicatorDescription extends FinancialIndicatorDescription {
        get_type() {
            return "StrategyBasedIndicator";
        }
        constructor() {
            super();
        }
    }
    StrategyBasedIndicatorDescription.$t = /*@__PURE__*/ markType(StrategyBasedIndicatorDescription, 'StrategyBasedIndicatorDescription', FinancialIndicatorDescription.$);
    return StrategyBasedIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AbsoluteVolumeOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class AbsoluteVolumeOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "AbsoluteVolumeOscillatorIndicator";
        }
        constructor() {
            super();
            this.gk = 0;
            this.gj = 0;
        }
        get shortPeriod() {
            return this.gk;
        }
        set shortPeriod(a) {
            this.gk = a;
            this.g("ShortPeriod");
        }
        get longPeriod() {
            return this.gj;
        }
        set longPeriod(a) {
            this.gj = a;
            this.g("LongPeriod");
        }
    }
    AbsoluteVolumeOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(AbsoluteVolumeOscillatorIndicatorDescription, 'AbsoluteVolumeOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return AbsoluteVolumeOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AbsoluteVolumeOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class AbsoluteVolumeOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.a == null) {
                AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.c(AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.a);
            }
            if (a.k(AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("ShortPeriod", "Number:int");
            a.item("LongPeriod", "Number:int");
        }
        static d(a) {
            AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.b(a);
            a.ae("AbsoluteVolumeOscillatorIndicator", () => new AbsoluteVolumeOscillatorIndicatorDescription());
            a.ad("AbsoluteVolumeOscillatorIndicator", AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(AbsoluteVolumeOscillatorIndicatorDescriptionMetadata, 'AbsoluteVolumeOscillatorIndicatorDescriptionMetadata');
    AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.a = null;
    return AbsoluteVolumeOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AbsoluteVolumeOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class AbsoluteVolumeOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    AbsoluteVolumeOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(AbsoluteVolumeOscillatorIndicatorDescriptionModule, 'AbsoluteVolumeOscillatorIndicatorDescriptionModule');
    return AbsoluteVolumeOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AccumulationDistributionIndicatorDescription = /*@__PURE__*/ (() => {
    class AccumulationDistributionIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "AccumulationDistributionIndicator";
        }
        constructor() {
            super();
        }
    }
    AccumulationDistributionIndicatorDescription.$t = /*@__PURE__*/ markType(AccumulationDistributionIndicatorDescription, 'AccumulationDistributionIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return AccumulationDistributionIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AccumulationDistributionIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class AccumulationDistributionIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (AccumulationDistributionIndicatorDescriptionMetadata.a == null) {
                AccumulationDistributionIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AccumulationDistributionIndicatorDescriptionMetadata.c(AccumulationDistributionIndicatorDescriptionMetadata.a);
            }
            if (a.k(AccumulationDistributionIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(AccumulationDistributionIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            AccumulationDistributionIndicatorDescriptionMetadata.b(a);
            a.ae("AccumulationDistributionIndicator", () => new AccumulationDistributionIndicatorDescription());
            a.ad("AccumulationDistributionIndicator", AccumulationDistributionIndicatorDescriptionMetadata.a);
        }
    }
    AccumulationDistributionIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(AccumulationDistributionIndicatorDescriptionMetadata, 'AccumulationDistributionIndicatorDescriptionMetadata');
    AccumulationDistributionIndicatorDescriptionMetadata.a = null;
    return AccumulationDistributionIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AccumulationDistributionIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class AccumulationDistributionIndicatorDescriptionModule extends Base {
        static register(a) {
            AccumulationDistributionIndicatorDescriptionMetadata.d(a);
        }
    }
    AccumulationDistributionIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(AccumulationDistributionIndicatorDescriptionModule, 'AccumulationDistributionIndicatorDescriptionModule');
    return AccumulationDistributionIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AverageDirectionalIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class AverageDirectionalIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "AverageDirectionalIndexIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    AverageDirectionalIndexIndicatorDescription.$t = /*@__PURE__*/ markType(AverageDirectionalIndexIndicatorDescription, 'AverageDirectionalIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return AverageDirectionalIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AverageDirectionalIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class AverageDirectionalIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (AverageDirectionalIndexIndicatorDescriptionMetadata.a == null) {
                AverageDirectionalIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AverageDirectionalIndexIndicatorDescriptionMetadata.c(AverageDirectionalIndexIndicatorDescriptionMetadata.a);
            }
            if (a.k(AverageDirectionalIndexIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(AverageDirectionalIndexIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            AverageDirectionalIndexIndicatorDescriptionMetadata.b(a);
            a.ae("AverageDirectionalIndexIndicator", () => new AverageDirectionalIndexIndicatorDescription());
            a.ad("AverageDirectionalIndexIndicator", AverageDirectionalIndexIndicatorDescriptionMetadata.a);
        }
    }
    AverageDirectionalIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(AverageDirectionalIndexIndicatorDescriptionMetadata, 'AverageDirectionalIndexIndicatorDescriptionMetadata');
    AverageDirectionalIndexIndicatorDescriptionMetadata.a = null;
    return AverageDirectionalIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AverageDirectionalIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class AverageDirectionalIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            AverageDirectionalIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    AverageDirectionalIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(AverageDirectionalIndexIndicatorDescriptionModule, 'AverageDirectionalIndexIndicatorDescriptionModule');
    return AverageDirectionalIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AverageTrueRangeIndicatorDescription = /*@__PURE__*/ (() => {
    class AverageTrueRangeIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "AverageTrueRangeIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    AverageTrueRangeIndicatorDescription.$t = /*@__PURE__*/ markType(AverageTrueRangeIndicatorDescription, 'AverageTrueRangeIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return AverageTrueRangeIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AverageTrueRangeIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class AverageTrueRangeIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (AverageTrueRangeIndicatorDescriptionMetadata.a == null) {
                AverageTrueRangeIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AverageTrueRangeIndicatorDescriptionMetadata.c(AverageTrueRangeIndicatorDescriptionMetadata.a);
            }
            if (a.k(AverageTrueRangeIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(AverageTrueRangeIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            AverageTrueRangeIndicatorDescriptionMetadata.b(a);
            a.ae("AverageTrueRangeIndicator", () => new AverageTrueRangeIndicatorDescription());
            a.ad("AverageTrueRangeIndicator", AverageTrueRangeIndicatorDescriptionMetadata.a);
        }
    }
    AverageTrueRangeIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(AverageTrueRangeIndicatorDescriptionMetadata, 'AverageTrueRangeIndicatorDescriptionMetadata');
    AverageTrueRangeIndicatorDescriptionMetadata.a = null;
    return AverageTrueRangeIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AverageTrueRangeIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class AverageTrueRangeIndicatorDescriptionModule extends Base {
        static register(a) {
            AverageTrueRangeIndicatorDescriptionMetadata.d(a);
        }
    }
    AverageTrueRangeIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(AverageTrueRangeIndicatorDescriptionModule, 'AverageTrueRangeIndicatorDescriptionModule');
    return AverageTrueRangeIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BollingerBandWidthIndicatorDescription = /*@__PURE__*/ (() => {
    class BollingerBandWidthIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "BollingerBandWidthIndicator";
        }
        constructor() {
            super();
            this.gl = 0;
            this.gj = 0;
        }
        get period() {
            return this.gl;
        }
        set period(a) {
            this.gl = a;
            this.g("Period");
        }
        get multiplier() {
            return this.gj;
        }
        set multiplier(a) {
            this.gj = a;
            this.g("Multiplier");
        }
    }
    BollingerBandWidthIndicatorDescription.$t = /*@__PURE__*/ markType(BollingerBandWidthIndicatorDescription, 'BollingerBandWidthIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return BollingerBandWidthIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BollingerBandWidthIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class BollingerBandWidthIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (BollingerBandWidthIndicatorDescriptionMetadata.a == null) {
                BollingerBandWidthIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BollingerBandWidthIndicatorDescriptionMetadata.c(BollingerBandWidthIndicatorDescriptionMetadata.a);
            }
            if (a.k(BollingerBandWidthIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(BollingerBandWidthIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
            a.item("Multiplier", "Number:double");
        }
        static d(a) {
            BollingerBandWidthIndicatorDescriptionMetadata.b(a);
            a.ae("BollingerBandWidthIndicator", () => new BollingerBandWidthIndicatorDescription());
            a.ad("BollingerBandWidthIndicator", BollingerBandWidthIndicatorDescriptionMetadata.a);
        }
    }
    BollingerBandWidthIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(BollingerBandWidthIndicatorDescriptionMetadata, 'BollingerBandWidthIndicatorDescriptionMetadata');
    BollingerBandWidthIndicatorDescriptionMetadata.a = null;
    return BollingerBandWidthIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BollingerBandWidthIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class BollingerBandWidthIndicatorDescriptionModule extends Base {
        static register(a) {
            BollingerBandWidthIndicatorDescriptionMetadata.d(a);
        }
    }
    BollingerBandWidthIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(BollingerBandWidthIndicatorDescriptionModule, 'BollingerBandWidthIndicatorDescriptionModule');
    return BollingerBandWidthIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChaikinOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class ChaikinOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "ChaikinOscillatorIndicator";
        }
        constructor() {
            super();
            this.gk = 0;
            this.gj = 0;
        }
        get shortPeriod() {
            return this.gk;
        }
        set shortPeriod(a) {
            this.gk = a;
            this.g("ShortPeriod");
        }
        get longPeriod() {
            return this.gj;
        }
        set longPeriod(a) {
            this.gj = a;
            this.g("LongPeriod");
        }
    }
    ChaikinOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(ChaikinOscillatorIndicatorDescription, 'ChaikinOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return ChaikinOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChaikinOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class ChaikinOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (ChaikinOscillatorIndicatorDescriptionMetadata.a == null) {
                ChaikinOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ChaikinOscillatorIndicatorDescriptionMetadata.c(ChaikinOscillatorIndicatorDescriptionMetadata.a);
            }
            if (a.k(ChaikinOscillatorIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(ChaikinOscillatorIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("ShortPeriod", "Number:int");
            a.item("LongPeriod", "Number:int");
        }
        static d(a) {
            ChaikinOscillatorIndicatorDescriptionMetadata.b(a);
            a.ae("ChaikinOscillatorIndicator", () => new ChaikinOscillatorIndicatorDescription());
            a.ad("ChaikinOscillatorIndicator", ChaikinOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    ChaikinOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(ChaikinOscillatorIndicatorDescriptionMetadata, 'ChaikinOscillatorIndicatorDescriptionMetadata');
    ChaikinOscillatorIndicatorDescriptionMetadata.a = null;
    return ChaikinOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChaikinOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class ChaikinOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            ChaikinOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    ChaikinOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(ChaikinOscillatorIndicatorDescriptionModule, 'ChaikinOscillatorIndicatorDescriptionModule');
    return ChaikinOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChaikinVolatilityIndicatorDescription = /*@__PURE__*/ (() => {
    class ChaikinVolatilityIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "ChaikinVolatilityIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    ChaikinVolatilityIndicatorDescription.$t = /*@__PURE__*/ markType(ChaikinVolatilityIndicatorDescription, 'ChaikinVolatilityIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return ChaikinVolatilityIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChaikinVolatilityIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class ChaikinVolatilityIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (ChaikinVolatilityIndicatorDescriptionMetadata.a == null) {
                ChaikinVolatilityIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ChaikinVolatilityIndicatorDescriptionMetadata.c(ChaikinVolatilityIndicatorDescriptionMetadata.a);
            }
            if (a.k(ChaikinVolatilityIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(ChaikinVolatilityIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            ChaikinVolatilityIndicatorDescriptionMetadata.b(a);
            a.ae("ChaikinVolatilityIndicator", () => new ChaikinVolatilityIndicatorDescription());
            a.ad("ChaikinVolatilityIndicator", ChaikinVolatilityIndicatorDescriptionMetadata.a);
        }
    }
    ChaikinVolatilityIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(ChaikinVolatilityIndicatorDescriptionMetadata, 'ChaikinVolatilityIndicatorDescriptionMetadata');
    ChaikinVolatilityIndicatorDescriptionMetadata.a = null;
    return ChaikinVolatilityIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChaikinVolatilityIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class ChaikinVolatilityIndicatorDescriptionModule extends Base {
        static register(a) {
            ChaikinVolatilityIndicatorDescriptionMetadata.d(a);
        }
    }
    ChaikinVolatilityIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(ChaikinVolatilityIndicatorDescriptionModule, 'ChaikinVolatilityIndicatorDescriptionModule');
    return ChaikinVolatilityIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CommodityChannelIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class CommodityChannelIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "CommodityChannelIndexIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    CommodityChannelIndexIndicatorDescription.$t = /*@__PURE__*/ markType(CommodityChannelIndexIndicatorDescription, 'CommodityChannelIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return CommodityChannelIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CommodityChannelIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class CommodityChannelIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (CommodityChannelIndexIndicatorDescriptionMetadata.a == null) {
                CommodityChannelIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CommodityChannelIndexIndicatorDescriptionMetadata.c(CommodityChannelIndexIndicatorDescriptionMetadata.a);
            }
            if (a.k(CommodityChannelIndexIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(CommodityChannelIndexIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            CommodityChannelIndexIndicatorDescriptionMetadata.b(a);
            a.ae("CommodityChannelIndexIndicator", () => new CommodityChannelIndexIndicatorDescription());
            a.ad("CommodityChannelIndexIndicator", CommodityChannelIndexIndicatorDescriptionMetadata.a);
        }
    }
    CommodityChannelIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(CommodityChannelIndexIndicatorDescriptionMetadata, 'CommodityChannelIndexIndicatorDescriptionMetadata');
    CommodityChannelIndexIndicatorDescriptionMetadata.a = null;
    return CommodityChannelIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CommodityChannelIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class CommodityChannelIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            CommodityChannelIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    CommodityChannelIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(CommodityChannelIndexIndicatorDescriptionModule, 'CommodityChannelIndexIndicatorDescriptionModule');
    return CommodityChannelIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DetrendedPriceOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class DetrendedPriceOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "DetrendedPriceOscillatorIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    DetrendedPriceOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(DetrendedPriceOscillatorIndicatorDescription, 'DetrendedPriceOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return DetrendedPriceOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DetrendedPriceOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class DetrendedPriceOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (DetrendedPriceOscillatorIndicatorDescriptionMetadata.a == null) {
                DetrendedPriceOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DetrendedPriceOscillatorIndicatorDescriptionMetadata.c(DetrendedPriceOscillatorIndicatorDescriptionMetadata.a);
            }
            if (a.k(DetrendedPriceOscillatorIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(DetrendedPriceOscillatorIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            DetrendedPriceOscillatorIndicatorDescriptionMetadata.b(a);
            a.ae("DetrendedPriceOscillatorIndicator", () => new DetrendedPriceOscillatorIndicatorDescription());
            a.ad("DetrendedPriceOscillatorIndicator", DetrendedPriceOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    DetrendedPriceOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(DetrendedPriceOscillatorIndicatorDescriptionMetadata, 'DetrendedPriceOscillatorIndicatorDescriptionMetadata');
    DetrendedPriceOscillatorIndicatorDescriptionMetadata.a = null;
    return DetrendedPriceOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DetrendedPriceOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class DetrendedPriceOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            DetrendedPriceOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    DetrendedPriceOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(DetrendedPriceOscillatorIndicatorDescriptionModule, 'DetrendedPriceOscillatorIndicatorDescriptionModule');
    return DetrendedPriceOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EaseOfMovementIndicatorDescription = /*@__PURE__*/ (() => {
    class EaseOfMovementIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "EaseOfMovementIndicator";
        }
        constructor() {
            super();
        }
    }
    EaseOfMovementIndicatorDescription.$t = /*@__PURE__*/ markType(EaseOfMovementIndicatorDescription, 'EaseOfMovementIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return EaseOfMovementIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EaseOfMovementIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class EaseOfMovementIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (EaseOfMovementIndicatorDescriptionMetadata.a == null) {
                EaseOfMovementIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                EaseOfMovementIndicatorDescriptionMetadata.c(EaseOfMovementIndicatorDescriptionMetadata.a);
            }
            if (a.k(EaseOfMovementIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(EaseOfMovementIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            EaseOfMovementIndicatorDescriptionMetadata.b(a);
            a.ae("EaseOfMovementIndicator", () => new EaseOfMovementIndicatorDescription());
            a.ad("EaseOfMovementIndicator", EaseOfMovementIndicatorDescriptionMetadata.a);
        }
    }
    EaseOfMovementIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(EaseOfMovementIndicatorDescriptionMetadata, 'EaseOfMovementIndicatorDescriptionMetadata');
    EaseOfMovementIndicatorDescriptionMetadata.a = null;
    return EaseOfMovementIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EaseOfMovementIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class EaseOfMovementIndicatorDescriptionModule extends Base {
        static register(a) {
            EaseOfMovementIndicatorDescriptionMetadata.d(a);
        }
    }
    EaseOfMovementIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(EaseOfMovementIndicatorDescriptionModule, 'EaseOfMovementIndicatorDescriptionModule');
    return EaseOfMovementIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastStochasticOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class FastStochasticOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "FastStochasticOscillatorIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    FastStochasticOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(FastStochasticOscillatorIndicatorDescription, 'FastStochasticOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return FastStochasticOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastStochasticOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class FastStochasticOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (FastStochasticOscillatorIndicatorDescriptionMetadata.a == null) {
                FastStochasticOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FastStochasticOscillatorIndicatorDescriptionMetadata.c(FastStochasticOscillatorIndicatorDescriptionMetadata.a);
            }
            if (a.k(FastStochasticOscillatorIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(FastStochasticOscillatorIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            FastStochasticOscillatorIndicatorDescriptionMetadata.b(a);
            a.ae("FastStochasticOscillatorIndicator", () => new FastStochasticOscillatorIndicatorDescription());
            a.ad("FastStochasticOscillatorIndicator", FastStochasticOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    FastStochasticOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(FastStochasticOscillatorIndicatorDescriptionMetadata, 'FastStochasticOscillatorIndicatorDescriptionMetadata');
    FastStochasticOscillatorIndicatorDescriptionMetadata.a = null;
    return FastStochasticOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastStochasticOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class FastStochasticOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            FastStochasticOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    FastStochasticOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(FastStochasticOscillatorIndicatorDescriptionModule, 'FastStochasticOscillatorIndicatorDescriptionModule');
    return FastStochasticOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ForceIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class ForceIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "ForceIndexIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    ForceIndexIndicatorDescription.$t = /*@__PURE__*/ markType(ForceIndexIndicatorDescription, 'ForceIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return ForceIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ForceIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class ForceIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (ForceIndexIndicatorDescriptionMetadata.a == null) {
                ForceIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ForceIndexIndicatorDescriptionMetadata.c(ForceIndexIndicatorDescriptionMetadata.a);
            }
            if (a.k(ForceIndexIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(ForceIndexIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            ForceIndexIndicatorDescriptionMetadata.b(a);
            a.ae("ForceIndexIndicator", () => new ForceIndexIndicatorDescription());
            a.ad("ForceIndexIndicator", ForceIndexIndicatorDescriptionMetadata.a);
        }
    }
    ForceIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(ForceIndexIndicatorDescriptionMetadata, 'ForceIndexIndicatorDescriptionMetadata');
    ForceIndexIndicatorDescriptionMetadata.a = null;
    return ForceIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ForceIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class ForceIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            ForceIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    ForceIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(ForceIndexIndicatorDescriptionModule, 'ForceIndexIndicatorDescriptionModule');
    return ForceIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FullStochasticOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class FullStochasticOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "FullStochasticOscillatorIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
            this.gk = 0;
            this.gl = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
        get smoothingPeriod() {
            return this.gk;
        }
        set smoothingPeriod(a) {
            this.gk = a;
            this.g("SmoothingPeriod");
        }
        get triggerPeriod() {
            return this.gl;
        }
        set triggerPeriod(a) {
            this.gl = a;
            this.g("TriggerPeriod");
        }
    }
    FullStochasticOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(FullStochasticOscillatorIndicatorDescription, 'FullStochasticOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return FullStochasticOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FullStochasticOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class FullStochasticOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (FullStochasticOscillatorIndicatorDescriptionMetadata.a == null) {
                FullStochasticOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FullStochasticOscillatorIndicatorDescriptionMetadata.c(FullStochasticOscillatorIndicatorDescriptionMetadata.a);
            }
            if (a.k(FullStochasticOscillatorIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(FullStochasticOscillatorIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
            a.item("SmoothingPeriod", "Number:int");
            a.item("TriggerPeriod", "Number:int");
        }
        static d(a) {
            FullStochasticOscillatorIndicatorDescriptionMetadata.b(a);
            a.ae("FullStochasticOscillatorIndicator", () => new FullStochasticOscillatorIndicatorDescription());
            a.ad("FullStochasticOscillatorIndicator", FullStochasticOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    FullStochasticOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(FullStochasticOscillatorIndicatorDescriptionMetadata, 'FullStochasticOscillatorIndicatorDescriptionMetadata');
    FullStochasticOscillatorIndicatorDescriptionMetadata.a = null;
    return FullStochasticOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FullStochasticOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class FullStochasticOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            FullStochasticOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    FullStochasticOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(FullStochasticOscillatorIndicatorDescriptionModule, 'FullStochasticOscillatorIndicatorDescriptionModule');
    return FullStochasticOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemwiseStrategyBasedIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class ItemwiseStrategyBasedIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (ItemwiseStrategyBasedIndicatorDescriptionMetadata.a == null) {
                ItemwiseStrategyBasedIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ItemwiseStrategyBasedIndicatorDescriptionMetadata.c(ItemwiseStrategyBasedIndicatorDescriptionMetadata.a);
            }
            if (a.k(ItemwiseStrategyBasedIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(ItemwiseStrategyBasedIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            ItemwiseStrategyBasedIndicatorDescriptionMetadata.b(a);
            a.ad("ItemwiseStrategyBasedIndicator", ItemwiseStrategyBasedIndicatorDescriptionMetadata.a);
        }
    }
    ItemwiseStrategyBasedIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(ItemwiseStrategyBasedIndicatorDescriptionMetadata, 'ItemwiseStrategyBasedIndicatorDescriptionMetadata');
    ItemwiseStrategyBasedIndicatorDescriptionMetadata.a = null;
    return ItemwiseStrategyBasedIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemwiseStrategyBasedIndicatorDescription = /*@__PURE__*/ (() => {
    class ItemwiseStrategyBasedIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "ItemwiseStrategyBasedIndicator";
        }
        constructor() {
            super();
        }
    }
    ItemwiseStrategyBasedIndicatorDescription.$t = /*@__PURE__*/ markType(ItemwiseStrategyBasedIndicatorDescription, 'ItemwiseStrategyBasedIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return ItemwiseStrategyBasedIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MarketFacilitationIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class MarketFacilitationIndexIndicatorDescription extends ItemwiseStrategyBasedIndicatorDescription {
        get_type() {
            return "MarketFacilitationIndexIndicator";
        }
        constructor() {
            super();
        }
    }
    MarketFacilitationIndexIndicatorDescription.$t = /*@__PURE__*/ markType(MarketFacilitationIndexIndicatorDescription, 'MarketFacilitationIndexIndicatorDescription', ItemwiseStrategyBasedIndicatorDescription.$);
    return MarketFacilitationIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MarketFacilitationIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class MarketFacilitationIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (MarketFacilitationIndexIndicatorDescriptionMetadata.a == null) {
                MarketFacilitationIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MarketFacilitationIndexIndicatorDescriptionMetadata.c(MarketFacilitationIndexIndicatorDescriptionMetadata.a);
            }
            if (a.k(MarketFacilitationIndexIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(MarketFacilitationIndexIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            ItemwiseStrategyBasedIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            MarketFacilitationIndexIndicatorDescriptionMetadata.b(a);
            a.ae("MarketFacilitationIndexIndicator", () => new MarketFacilitationIndexIndicatorDescription());
            a.ad("MarketFacilitationIndexIndicator", MarketFacilitationIndexIndicatorDescriptionMetadata.a);
        }
    }
    MarketFacilitationIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(MarketFacilitationIndexIndicatorDescriptionMetadata, 'MarketFacilitationIndexIndicatorDescriptionMetadata');
    MarketFacilitationIndexIndicatorDescriptionMetadata.a = null;
    return MarketFacilitationIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MarketFacilitationIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class MarketFacilitationIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            MarketFacilitationIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    MarketFacilitationIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(MarketFacilitationIndexIndicatorDescriptionModule, 'MarketFacilitationIndexIndicatorDescriptionModule');
    return MarketFacilitationIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MassIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class MassIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "MassIndexIndicator";
        }
        constructor() {
            super();
        }
    }
    MassIndexIndicatorDescription.$t = /*@__PURE__*/ markType(MassIndexIndicatorDescription, 'MassIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return MassIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MassIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class MassIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (MassIndexIndicatorDescriptionMetadata.a == null) {
                MassIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MassIndexIndicatorDescriptionMetadata.c(MassIndexIndicatorDescriptionMetadata.a);
            }
            if (a.k(MassIndexIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(MassIndexIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            MassIndexIndicatorDescriptionMetadata.b(a);
            a.ae("MassIndexIndicator", () => new MassIndexIndicatorDescription());
            a.ad("MassIndexIndicator", MassIndexIndicatorDescriptionMetadata.a);
        }
    }
    MassIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(MassIndexIndicatorDescriptionMetadata, 'MassIndexIndicatorDescriptionMetadata');
    MassIndexIndicatorDescriptionMetadata.a = null;
    return MassIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MassIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class MassIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            MassIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    MassIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(MassIndexIndicatorDescriptionModule, 'MassIndexIndicatorDescriptionModule');
    return MassIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MedianPriceIndicatorDescription = /*@__PURE__*/ (() => {
    class MedianPriceIndicatorDescription extends ItemwiseStrategyBasedIndicatorDescription {
        get_type() {
            return "MedianPriceIndicator";
        }
        constructor() {
            super();
        }
    }
    MedianPriceIndicatorDescription.$t = /*@__PURE__*/ markType(MedianPriceIndicatorDescription, 'MedianPriceIndicatorDescription', ItemwiseStrategyBasedIndicatorDescription.$);
    return MedianPriceIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MedianPriceIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class MedianPriceIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (MedianPriceIndicatorDescriptionMetadata.a == null) {
                MedianPriceIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MedianPriceIndicatorDescriptionMetadata.c(MedianPriceIndicatorDescriptionMetadata.a);
            }
            if (a.k(MedianPriceIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(MedianPriceIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            ItemwiseStrategyBasedIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            MedianPriceIndicatorDescriptionMetadata.b(a);
            a.ae("MedianPriceIndicator", () => new MedianPriceIndicatorDescription());
            a.ad("MedianPriceIndicator", MedianPriceIndicatorDescriptionMetadata.a);
        }
    }
    MedianPriceIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(MedianPriceIndicatorDescriptionMetadata, 'MedianPriceIndicatorDescriptionMetadata');
    MedianPriceIndicatorDescriptionMetadata.a = null;
    return MedianPriceIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MedianPriceIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class MedianPriceIndicatorDescriptionModule extends Base {
        static register(a) {
            MedianPriceIndicatorDescriptionMetadata.d(a);
        }
    }
    MedianPriceIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(MedianPriceIndicatorDescriptionModule, 'MedianPriceIndicatorDescriptionModule');
    return MedianPriceIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MoneyFlowIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class MoneyFlowIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "MoneyFlowIndexIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    MoneyFlowIndexIndicatorDescription.$t = /*@__PURE__*/ markType(MoneyFlowIndexIndicatorDescription, 'MoneyFlowIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return MoneyFlowIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MoneyFlowIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class MoneyFlowIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (MoneyFlowIndexIndicatorDescriptionMetadata.a == null) {
                MoneyFlowIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MoneyFlowIndexIndicatorDescriptionMetadata.c(MoneyFlowIndexIndicatorDescriptionMetadata.a);
            }
            if (a.k(MoneyFlowIndexIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(MoneyFlowIndexIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            MoneyFlowIndexIndicatorDescriptionMetadata.b(a);
            a.ae("MoneyFlowIndexIndicator", () => new MoneyFlowIndexIndicatorDescription());
            a.ad("MoneyFlowIndexIndicator", MoneyFlowIndexIndicatorDescriptionMetadata.a);
        }
    }
    MoneyFlowIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(MoneyFlowIndexIndicatorDescriptionMetadata, 'MoneyFlowIndexIndicatorDescriptionMetadata');
    MoneyFlowIndexIndicatorDescriptionMetadata.a = null;
    return MoneyFlowIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MoneyFlowIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class MoneyFlowIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            MoneyFlowIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    MoneyFlowIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(MoneyFlowIndexIndicatorDescriptionModule, 'MoneyFlowIndexIndicatorDescriptionModule');
    return MoneyFlowIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MovingAverageConvergenceDivergenceIndicatorDescription = /*@__PURE__*/ (() => {
    class MovingAverageConvergenceDivergenceIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "MovingAverageConvergenceDivergenceIndicator";
        }
        constructor() {
            super();
            this.gk = 0;
            this.gj = 0;
            this.gl = 0;
        }
        get shortPeriod() {
            return this.gk;
        }
        set shortPeriod(a) {
            this.gk = a;
            this.g("ShortPeriod");
        }
        get longPeriod() {
            return this.gj;
        }
        set longPeriod(a) {
            this.gj = a;
            this.g("LongPeriod");
        }
        get signalPeriod() {
            return this.gl;
        }
        set signalPeriod(a) {
            this.gl = a;
            this.g("SignalPeriod");
        }
    }
    MovingAverageConvergenceDivergenceIndicatorDescription.$t = /*@__PURE__*/ markType(MovingAverageConvergenceDivergenceIndicatorDescription, 'MovingAverageConvergenceDivergenceIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return MovingAverageConvergenceDivergenceIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.a == null) {
                MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.c(MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.a);
            }
            if (a.k(MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("ShortPeriod", "Number:int");
            a.item("LongPeriod", "Number:int");
            a.item("SignalPeriod", "Number:int");
        }
        static d(a) {
            MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.b(a);
            a.ae("MovingAverageConvergenceDivergenceIndicator", () => new MovingAverageConvergenceDivergenceIndicatorDescription());
            a.ad("MovingAverageConvergenceDivergenceIndicator", MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.a);
        }
    }
    MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata, 'MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata');
    MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.a = null;
    return MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MovingAverageConvergenceDivergenceIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class MovingAverageConvergenceDivergenceIndicatorDescriptionModule extends Base {
        static register(a) {
            MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.d(a);
        }
    }
    MovingAverageConvergenceDivergenceIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(MovingAverageConvergenceDivergenceIndicatorDescriptionModule, 'MovingAverageConvergenceDivergenceIndicatorDescriptionModule');
    return MovingAverageConvergenceDivergenceIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NegativeVolumeIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class NegativeVolumeIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "NegativeVolumeIndexIndicator";
        }
        constructor() {
            super();
        }
    }
    NegativeVolumeIndexIndicatorDescription.$t = /*@__PURE__*/ markType(NegativeVolumeIndexIndicatorDescription, 'NegativeVolumeIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return NegativeVolumeIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NegativeVolumeIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class NegativeVolumeIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (NegativeVolumeIndexIndicatorDescriptionMetadata.a == null) {
                NegativeVolumeIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NegativeVolumeIndexIndicatorDescriptionMetadata.c(NegativeVolumeIndexIndicatorDescriptionMetadata.a);
            }
            if (a.k(NegativeVolumeIndexIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(NegativeVolumeIndexIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            NegativeVolumeIndexIndicatorDescriptionMetadata.b(a);
            a.ae("NegativeVolumeIndexIndicator", () => new NegativeVolumeIndexIndicatorDescription());
            a.ad("NegativeVolumeIndexIndicator", NegativeVolumeIndexIndicatorDescriptionMetadata.a);
        }
    }
    NegativeVolumeIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(NegativeVolumeIndexIndicatorDescriptionMetadata, 'NegativeVolumeIndexIndicatorDescriptionMetadata');
    NegativeVolumeIndexIndicatorDescriptionMetadata.a = null;
    return NegativeVolumeIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NegativeVolumeIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class NegativeVolumeIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            NegativeVolumeIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    NegativeVolumeIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(NegativeVolumeIndexIndicatorDescriptionModule, 'NegativeVolumeIndexIndicatorDescriptionModule');
    return NegativeVolumeIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnBalanceVolumeIndicatorDescription = /*@__PURE__*/ (() => {
    class OnBalanceVolumeIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "OnBalanceVolumeIndicator";
        }
        constructor() {
            super();
        }
    }
    OnBalanceVolumeIndicatorDescription.$t = /*@__PURE__*/ markType(OnBalanceVolumeIndicatorDescription, 'OnBalanceVolumeIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return OnBalanceVolumeIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnBalanceVolumeIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class OnBalanceVolumeIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (OnBalanceVolumeIndicatorDescriptionMetadata.a == null) {
                OnBalanceVolumeIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OnBalanceVolumeIndicatorDescriptionMetadata.c(OnBalanceVolumeIndicatorDescriptionMetadata.a);
            }
            if (a.k(OnBalanceVolumeIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(OnBalanceVolumeIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            OnBalanceVolumeIndicatorDescriptionMetadata.b(a);
            a.ae("OnBalanceVolumeIndicator", () => new OnBalanceVolumeIndicatorDescription());
            a.ad("OnBalanceVolumeIndicator", OnBalanceVolumeIndicatorDescriptionMetadata.a);
        }
    }
    OnBalanceVolumeIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(OnBalanceVolumeIndicatorDescriptionMetadata, 'OnBalanceVolumeIndicatorDescriptionMetadata');
    OnBalanceVolumeIndicatorDescriptionMetadata.a = null;
    return OnBalanceVolumeIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnBalanceVolumeIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class OnBalanceVolumeIndicatorDescriptionModule extends Base {
        static register(a) {
            OnBalanceVolumeIndicatorDescriptionMetadata.d(a);
        }
    }
    OnBalanceVolumeIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(OnBalanceVolumeIndicatorDescriptionModule, 'OnBalanceVolumeIndicatorDescriptionModule');
    return OnBalanceVolumeIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentagePriceOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class PercentagePriceOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "PercentagePriceOscillatorIndicator";
        }
        constructor() {
            super();
            this.gk = 0;
            this.gj = 0;
        }
        get shortPeriod() {
            return this.gk;
        }
        set shortPeriod(a) {
            this.gk = a;
            this.g("ShortPeriod");
        }
        get longPeriod() {
            return this.gj;
        }
        set longPeriod(a) {
            this.gj = a;
            this.g("LongPeriod");
        }
    }
    PercentagePriceOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(PercentagePriceOscillatorIndicatorDescription, 'PercentagePriceOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return PercentagePriceOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentagePriceOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class PercentagePriceOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (PercentagePriceOscillatorIndicatorDescriptionMetadata.a == null) {
                PercentagePriceOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PercentagePriceOscillatorIndicatorDescriptionMetadata.c(PercentagePriceOscillatorIndicatorDescriptionMetadata.a);
            }
            if (a.k(PercentagePriceOscillatorIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(PercentagePriceOscillatorIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("ShortPeriod", "Number:int");
            a.item("LongPeriod", "Number:int");
        }
        static d(a) {
            PercentagePriceOscillatorIndicatorDescriptionMetadata.b(a);
            a.ae("PercentagePriceOscillatorIndicator", () => new PercentagePriceOscillatorIndicatorDescription());
            a.ad("PercentagePriceOscillatorIndicator", PercentagePriceOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    PercentagePriceOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(PercentagePriceOscillatorIndicatorDescriptionMetadata, 'PercentagePriceOscillatorIndicatorDescriptionMetadata');
    PercentagePriceOscillatorIndicatorDescriptionMetadata.a = null;
    return PercentagePriceOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentagePriceOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class PercentagePriceOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            PercentagePriceOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    PercentagePriceOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(PercentagePriceOscillatorIndicatorDescriptionModule, 'PercentagePriceOscillatorIndicatorDescriptionModule');
    return PercentagePriceOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentageVolumeOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class PercentageVolumeOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "PercentageVolumeOscillatorIndicator";
        }
        constructor() {
            super();
            this.gk = 0;
            this.gj = 0;
        }
        get shortPeriod() {
            return this.gk;
        }
        set shortPeriod(a) {
            this.gk = a;
            this.g("ShortPeriod");
        }
        get longPeriod() {
            return this.gj;
        }
        set longPeriod(a) {
            this.gj = a;
            this.g("LongPeriod");
        }
    }
    PercentageVolumeOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(PercentageVolumeOscillatorIndicatorDescription, 'PercentageVolumeOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return PercentageVolumeOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentageVolumeOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class PercentageVolumeOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (PercentageVolumeOscillatorIndicatorDescriptionMetadata.a == null) {
                PercentageVolumeOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PercentageVolumeOscillatorIndicatorDescriptionMetadata.c(PercentageVolumeOscillatorIndicatorDescriptionMetadata.a);
            }
            if (a.k(PercentageVolumeOscillatorIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(PercentageVolumeOscillatorIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("ShortPeriod", "Number:int");
            a.item("LongPeriod", "Number:int");
        }
        static d(a) {
            PercentageVolumeOscillatorIndicatorDescriptionMetadata.b(a);
            a.ae("PercentageVolumeOscillatorIndicator", () => new PercentageVolumeOscillatorIndicatorDescription());
            a.ad("PercentageVolumeOscillatorIndicator", PercentageVolumeOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    PercentageVolumeOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(PercentageVolumeOscillatorIndicatorDescriptionMetadata, 'PercentageVolumeOscillatorIndicatorDescriptionMetadata');
    PercentageVolumeOscillatorIndicatorDescriptionMetadata.a = null;
    return PercentageVolumeOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentageVolumeOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class PercentageVolumeOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            PercentageVolumeOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    PercentageVolumeOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(PercentageVolumeOscillatorIndicatorDescriptionModule, 'PercentageVolumeOscillatorIndicatorDescriptionModule');
    return PercentageVolumeOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PositiveVolumeIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class PositiveVolumeIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "PositiveVolumeIndexIndicator";
        }
        constructor() {
            super();
        }
    }
    PositiveVolumeIndexIndicatorDescription.$t = /*@__PURE__*/ markType(PositiveVolumeIndexIndicatorDescription, 'PositiveVolumeIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return PositiveVolumeIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PositiveVolumeIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class PositiveVolumeIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (PositiveVolumeIndexIndicatorDescriptionMetadata.a == null) {
                PositiveVolumeIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PositiveVolumeIndexIndicatorDescriptionMetadata.c(PositiveVolumeIndexIndicatorDescriptionMetadata.a);
            }
            if (a.k(PositiveVolumeIndexIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(PositiveVolumeIndexIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            PositiveVolumeIndexIndicatorDescriptionMetadata.b(a);
            a.ae("PositiveVolumeIndexIndicator", () => new PositiveVolumeIndexIndicatorDescription());
            a.ad("PositiveVolumeIndexIndicator", PositiveVolumeIndexIndicatorDescriptionMetadata.a);
        }
    }
    PositiveVolumeIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(PositiveVolumeIndexIndicatorDescriptionMetadata, 'PositiveVolumeIndexIndicatorDescriptionMetadata');
    PositiveVolumeIndexIndicatorDescriptionMetadata.a = null;
    return PositiveVolumeIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PositiveVolumeIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class PositiveVolumeIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            PositiveVolumeIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    PositiveVolumeIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(PositiveVolumeIndexIndicatorDescriptionModule, 'PositiveVolumeIndexIndicatorDescriptionModule');
    return PositiveVolumeIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PriceVolumeTrendIndicatorDescription = /*@__PURE__*/ (() => {
    class PriceVolumeTrendIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "PriceVolumeTrendIndicator";
        }
        constructor() {
            super();
        }
    }
    PriceVolumeTrendIndicatorDescription.$t = /*@__PURE__*/ markType(PriceVolumeTrendIndicatorDescription, 'PriceVolumeTrendIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return PriceVolumeTrendIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PriceVolumeTrendIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class PriceVolumeTrendIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (PriceVolumeTrendIndicatorDescriptionMetadata.a == null) {
                PriceVolumeTrendIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PriceVolumeTrendIndicatorDescriptionMetadata.c(PriceVolumeTrendIndicatorDescriptionMetadata.a);
            }
            if (a.k(PriceVolumeTrendIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(PriceVolumeTrendIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            PriceVolumeTrendIndicatorDescriptionMetadata.b(a);
            a.ae("PriceVolumeTrendIndicator", () => new PriceVolumeTrendIndicatorDescription());
            a.ad("PriceVolumeTrendIndicator", PriceVolumeTrendIndicatorDescriptionMetadata.a);
        }
    }
    PriceVolumeTrendIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(PriceVolumeTrendIndicatorDescriptionMetadata, 'PriceVolumeTrendIndicatorDescriptionMetadata');
    PriceVolumeTrendIndicatorDescriptionMetadata.a = null;
    return PriceVolumeTrendIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PriceVolumeTrendIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class PriceVolumeTrendIndicatorDescriptionModule extends Base {
        static register(a) {
            PriceVolumeTrendIndicatorDescriptionMetadata.d(a);
        }
    }
    PriceVolumeTrendIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(PriceVolumeTrendIndicatorDescriptionModule, 'PriceVolumeTrendIndicatorDescriptionModule');
    return PriceVolumeTrendIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RateOfChangeAndMomentumIndicatorDescription = /*@__PURE__*/ (() => {
    class RateOfChangeAndMomentumIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "RateOfChangeAndMomentumIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    RateOfChangeAndMomentumIndicatorDescription.$t = /*@__PURE__*/ markType(RateOfChangeAndMomentumIndicatorDescription, 'RateOfChangeAndMomentumIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return RateOfChangeAndMomentumIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RateOfChangeAndMomentumIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class RateOfChangeAndMomentumIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (RateOfChangeAndMomentumIndicatorDescriptionMetadata.a == null) {
                RateOfChangeAndMomentumIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RateOfChangeAndMomentumIndicatorDescriptionMetadata.c(RateOfChangeAndMomentumIndicatorDescriptionMetadata.a);
            }
            if (a.k(RateOfChangeAndMomentumIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(RateOfChangeAndMomentumIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            RateOfChangeAndMomentumIndicatorDescriptionMetadata.b(a);
            a.ae("RateOfChangeAndMomentumIndicator", () => new RateOfChangeAndMomentumIndicatorDescription());
            a.ad("RateOfChangeAndMomentumIndicator", RateOfChangeAndMomentumIndicatorDescriptionMetadata.a);
        }
    }
    RateOfChangeAndMomentumIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(RateOfChangeAndMomentumIndicatorDescriptionMetadata, 'RateOfChangeAndMomentumIndicatorDescriptionMetadata');
    RateOfChangeAndMomentumIndicatorDescriptionMetadata.a = null;
    return RateOfChangeAndMomentumIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RateOfChangeAndMomentumIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class RateOfChangeAndMomentumIndicatorDescriptionModule extends Base {
        static register(a) {
            RateOfChangeAndMomentumIndicatorDescriptionMetadata.d(a);
        }
    }
    RateOfChangeAndMomentumIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(RateOfChangeAndMomentumIndicatorDescriptionModule, 'RateOfChangeAndMomentumIndicatorDescriptionModule');
    return RateOfChangeAndMomentumIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RelativeStrengthIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class RelativeStrengthIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "RelativeStrengthIndexIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    RelativeStrengthIndexIndicatorDescription.$t = /*@__PURE__*/ markType(RelativeStrengthIndexIndicatorDescription, 'RelativeStrengthIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return RelativeStrengthIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RelativeStrengthIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class RelativeStrengthIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (RelativeStrengthIndexIndicatorDescriptionMetadata.a == null) {
                RelativeStrengthIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RelativeStrengthIndexIndicatorDescriptionMetadata.c(RelativeStrengthIndexIndicatorDescriptionMetadata.a);
            }
            if (a.k(RelativeStrengthIndexIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(RelativeStrengthIndexIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            RelativeStrengthIndexIndicatorDescriptionMetadata.b(a);
            a.ae("RelativeStrengthIndexIndicator", () => new RelativeStrengthIndexIndicatorDescription());
            a.ad("RelativeStrengthIndexIndicator", RelativeStrengthIndexIndicatorDescriptionMetadata.a);
        }
    }
    RelativeStrengthIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(RelativeStrengthIndexIndicatorDescriptionMetadata, 'RelativeStrengthIndexIndicatorDescriptionMetadata');
    RelativeStrengthIndexIndicatorDescriptionMetadata.a = null;
    return RelativeStrengthIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RelativeStrengthIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class RelativeStrengthIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            RelativeStrengthIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    RelativeStrengthIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(RelativeStrengthIndexIndicatorDescriptionModule, 'RelativeStrengthIndexIndicatorDescriptionModule');
    return RelativeStrengthIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SlowStochasticOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class SlowStochasticOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "SlowStochasticOscillatorIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    SlowStochasticOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(SlowStochasticOscillatorIndicatorDescription, 'SlowStochasticOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return SlowStochasticOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SlowStochasticOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class SlowStochasticOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (SlowStochasticOscillatorIndicatorDescriptionMetadata.a == null) {
                SlowStochasticOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SlowStochasticOscillatorIndicatorDescriptionMetadata.c(SlowStochasticOscillatorIndicatorDescriptionMetadata.a);
            }
            if (a.k(SlowStochasticOscillatorIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(SlowStochasticOscillatorIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            SlowStochasticOscillatorIndicatorDescriptionMetadata.b(a);
            a.ae("SlowStochasticOscillatorIndicator", () => new SlowStochasticOscillatorIndicatorDescription());
            a.ad("SlowStochasticOscillatorIndicator", SlowStochasticOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    SlowStochasticOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(SlowStochasticOscillatorIndicatorDescriptionMetadata, 'SlowStochasticOscillatorIndicatorDescriptionMetadata');
    SlowStochasticOscillatorIndicatorDescriptionMetadata.a = null;
    return SlowStochasticOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SlowStochasticOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class SlowStochasticOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            SlowStochasticOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    SlowStochasticOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(SlowStochasticOscillatorIndicatorDescriptionModule, 'SlowStochasticOscillatorIndicatorDescriptionModule');
    return SlowStochasticOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StandardDeviationIndicatorDescription = /*@__PURE__*/ (() => {
    class StandardDeviationIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "StandardDeviationIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    StandardDeviationIndicatorDescription.$t = /*@__PURE__*/ markType(StandardDeviationIndicatorDescription, 'StandardDeviationIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return StandardDeviationIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StandardDeviationIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class StandardDeviationIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (StandardDeviationIndicatorDescriptionMetadata.a == null) {
                StandardDeviationIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StandardDeviationIndicatorDescriptionMetadata.c(StandardDeviationIndicatorDescriptionMetadata.a);
            }
            if (a.k(StandardDeviationIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(StandardDeviationIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            StandardDeviationIndicatorDescriptionMetadata.b(a);
            a.ae("StandardDeviationIndicator", () => new StandardDeviationIndicatorDescription());
            a.ad("StandardDeviationIndicator", StandardDeviationIndicatorDescriptionMetadata.a);
        }
    }
    StandardDeviationIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(StandardDeviationIndicatorDescriptionMetadata, 'StandardDeviationIndicatorDescriptionMetadata');
    StandardDeviationIndicatorDescriptionMetadata.a = null;
    return StandardDeviationIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StandardDeviationIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class StandardDeviationIndicatorDescriptionModule extends Base {
        static register(a) {
            StandardDeviationIndicatorDescriptionMetadata.d(a);
        }
    }
    StandardDeviationIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(StandardDeviationIndicatorDescriptionModule, 'StandardDeviationIndicatorDescriptionModule');
    return StandardDeviationIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StochRSIIndicatorDescription = /*@__PURE__*/ (() => {
    class StochRSIIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "StochRSIIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    StochRSIIndicatorDescription.$t = /*@__PURE__*/ markType(StochRSIIndicatorDescription, 'StochRSIIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return StochRSIIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StochRSIIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class StochRSIIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (StochRSIIndicatorDescriptionMetadata.a == null) {
                StochRSIIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StochRSIIndicatorDescriptionMetadata.c(StochRSIIndicatorDescriptionMetadata.a);
            }
            if (a.k(StochRSIIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(StochRSIIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            StochRSIIndicatorDescriptionMetadata.b(a);
            a.ae("StochRSIIndicator", () => new StochRSIIndicatorDescription());
            a.ad("StochRSIIndicator", StochRSIIndicatorDescriptionMetadata.a);
        }
    }
    StochRSIIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(StochRSIIndicatorDescriptionMetadata, 'StochRSIIndicatorDescriptionMetadata');
    StochRSIIndicatorDescriptionMetadata.a = null;
    return StochRSIIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StochRSIIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class StochRSIIndicatorDescriptionModule extends Base {
        static register(a) {
            StochRSIIndicatorDescriptionMetadata.d(a);
        }
    }
    StochRSIIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(StochRSIIndicatorDescriptionModule, 'StochRSIIndicatorDescriptionModule');
    return StochRSIIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TRIXIndicatorDescription = /*@__PURE__*/ (() => {
    class TRIXIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "TRIXIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    TRIXIndicatorDescription.$t = /*@__PURE__*/ markType(TRIXIndicatorDescription, 'TRIXIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return TRIXIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TRIXIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class TRIXIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (TRIXIndicatorDescriptionMetadata.a == null) {
                TRIXIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TRIXIndicatorDescriptionMetadata.c(TRIXIndicatorDescriptionMetadata.a);
            }
            if (a.k(TRIXIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(TRIXIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            TRIXIndicatorDescriptionMetadata.b(a);
            a.ae("TRIXIndicator", () => new TRIXIndicatorDescription());
            a.ad("TRIXIndicator", TRIXIndicatorDescriptionMetadata.a);
        }
    }
    TRIXIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(TRIXIndicatorDescriptionMetadata, 'TRIXIndicatorDescriptionMetadata');
    TRIXIndicatorDescriptionMetadata.a = null;
    return TRIXIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TRIXIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class TRIXIndicatorDescriptionModule extends Base {
        static register(a) {
            TRIXIndicatorDescriptionMetadata.d(a);
        }
    }
    TRIXIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(TRIXIndicatorDescriptionModule, 'TRIXIndicatorDescriptionModule');
    return TRIXIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TypicalPriceIndicatorDescription = /*@__PURE__*/ (() => {
    class TypicalPriceIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "TypicalPriceIndicator";
        }
        constructor() {
            super();
        }
    }
    TypicalPriceIndicatorDescription.$t = /*@__PURE__*/ markType(TypicalPriceIndicatorDescription, 'TypicalPriceIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return TypicalPriceIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TypicalPriceIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class TypicalPriceIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (TypicalPriceIndicatorDescriptionMetadata.a == null) {
                TypicalPriceIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TypicalPriceIndicatorDescriptionMetadata.c(TypicalPriceIndicatorDescriptionMetadata.a);
            }
            if (a.k(TypicalPriceIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(TypicalPriceIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            TypicalPriceIndicatorDescriptionMetadata.b(a);
            a.ae("TypicalPriceIndicator", () => new TypicalPriceIndicatorDescription());
            a.ad("TypicalPriceIndicator", TypicalPriceIndicatorDescriptionMetadata.a);
        }
    }
    TypicalPriceIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(TypicalPriceIndicatorDescriptionMetadata, 'TypicalPriceIndicatorDescriptionMetadata');
    TypicalPriceIndicatorDescriptionMetadata.a = null;
    return TypicalPriceIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TypicalPriceIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class TypicalPriceIndicatorDescriptionModule extends Base {
        static register(a) {
            TypicalPriceIndicatorDescriptionMetadata.d(a);
        }
    }
    TypicalPriceIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(TypicalPriceIndicatorDescriptionModule, 'TypicalPriceIndicatorDescriptionModule');
    return TypicalPriceIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UltimateOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class UltimateOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "UltimateOscillatorIndicator";
        }
        constructor() {
            super();
        }
    }
    UltimateOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(UltimateOscillatorIndicatorDescription, 'UltimateOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return UltimateOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UltimateOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class UltimateOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (UltimateOscillatorIndicatorDescriptionMetadata.a == null) {
                UltimateOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                UltimateOscillatorIndicatorDescriptionMetadata.c(UltimateOscillatorIndicatorDescriptionMetadata.a);
            }
            if (a.k(UltimateOscillatorIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(UltimateOscillatorIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            UltimateOscillatorIndicatorDescriptionMetadata.b(a);
            a.ae("UltimateOscillatorIndicator", () => new UltimateOscillatorIndicatorDescription());
            a.ad("UltimateOscillatorIndicator", UltimateOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    UltimateOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(UltimateOscillatorIndicatorDescriptionMetadata, 'UltimateOscillatorIndicatorDescriptionMetadata');
    UltimateOscillatorIndicatorDescriptionMetadata.a = null;
    return UltimateOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UltimateOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class UltimateOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            UltimateOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    UltimateOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(UltimateOscillatorIndicatorDescriptionModule, 'UltimateOscillatorIndicatorDescriptionModule');
    return UltimateOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WeightedCloseIndicatorDescription = /*@__PURE__*/ (() => {
    class WeightedCloseIndicatorDescription extends ItemwiseStrategyBasedIndicatorDescription {
        get_type() {
            return "WeightedCloseIndicator";
        }
        constructor() {
            super();
        }
    }
    WeightedCloseIndicatorDescription.$t = /*@__PURE__*/ markType(WeightedCloseIndicatorDescription, 'WeightedCloseIndicatorDescription', ItemwiseStrategyBasedIndicatorDescription.$);
    return WeightedCloseIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WeightedCloseIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class WeightedCloseIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (WeightedCloseIndicatorDescriptionMetadata.a == null) {
                WeightedCloseIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WeightedCloseIndicatorDescriptionMetadata.c(WeightedCloseIndicatorDescriptionMetadata.a);
            }
            if (a.k(WeightedCloseIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(WeightedCloseIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            ItemwiseStrategyBasedIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            WeightedCloseIndicatorDescriptionMetadata.b(a);
            a.ae("WeightedCloseIndicator", () => new WeightedCloseIndicatorDescription());
            a.ad("WeightedCloseIndicator", WeightedCloseIndicatorDescriptionMetadata.a);
        }
    }
    WeightedCloseIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(WeightedCloseIndicatorDescriptionMetadata, 'WeightedCloseIndicatorDescriptionMetadata');
    WeightedCloseIndicatorDescriptionMetadata.a = null;
    return WeightedCloseIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WeightedCloseIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class WeightedCloseIndicatorDescriptionModule extends Base {
        static register(a) {
            WeightedCloseIndicatorDescriptionMetadata.d(a);
        }
    }
    WeightedCloseIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(WeightedCloseIndicatorDescriptionModule, 'WeightedCloseIndicatorDescriptionModule');
    return WeightedCloseIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WilliamsPercentRIndicatorDescription = /*@__PURE__*/ (() => {
    class WilliamsPercentRIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "WilliamsPercentRIndicator";
        }
        constructor() {
            super();
            this.gj = 0;
        }
        get period() {
            return this.gj;
        }
        set period(a) {
            this.gj = a;
            this.g("Period");
        }
    }
    WilliamsPercentRIndicatorDescription.$t = /*@__PURE__*/ markType(WilliamsPercentRIndicatorDescription, 'WilliamsPercentRIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return WilliamsPercentRIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WilliamsPercentRIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class WilliamsPercentRIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (WilliamsPercentRIndicatorDescriptionMetadata.a == null) {
                WilliamsPercentRIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WilliamsPercentRIndicatorDescriptionMetadata.c(WilliamsPercentRIndicatorDescriptionMetadata.a);
            }
            if (a.k(WilliamsPercentRIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(WilliamsPercentRIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            WilliamsPercentRIndicatorDescriptionMetadata.b(a);
            a.ae("WilliamsPercentRIndicator", () => new WilliamsPercentRIndicatorDescription());
            a.ad("WilliamsPercentRIndicator", WilliamsPercentRIndicatorDescriptionMetadata.a);
        }
    }
    WilliamsPercentRIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(WilliamsPercentRIndicatorDescriptionMetadata, 'WilliamsPercentRIndicatorDescriptionMetadata');
    WilliamsPercentRIndicatorDescriptionMetadata.a = null;
    return WilliamsPercentRIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WilliamsPercentRIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class WilliamsPercentRIndicatorDescriptionModule extends Base {
        static register(a) {
            WilliamsPercentRIndicatorDescriptionMetadata.d(a);
        }
    }
    WilliamsPercentRIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(WilliamsPercentRIndicatorDescriptionModule, 'WilliamsPercentRIndicatorDescriptionModule');
    return WilliamsPercentRIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomIndicatorDescription = /*@__PURE__*/ (() => {
    class CustomIndicatorDescription extends StrategyBasedIndicatorDescription {
        get_type() {
            return "CustomIndicator";
        }
        constructor() {
            super();
        }
    }
    CustomIndicatorDescription.$t = /*@__PURE__*/ markType(CustomIndicatorDescription, 'CustomIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return CustomIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class CustomIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (CustomIndicatorDescriptionMetadata.a == null) {
                CustomIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CustomIndicatorDescriptionMetadata.c(CustomIndicatorDescriptionMetadata.a);
            }
            if (a.k(CustomIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(CustomIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            StrategyBasedIndicatorDescriptionMetadata.c(a);
        }
        static d(a) {
            CustomIndicatorDescriptionMetadata.b(a);
            a.ae("CustomIndicator", () => new CustomIndicatorDescription());
            a.ad("CustomIndicator", CustomIndicatorDescriptionMetadata.a);
        }
    }
    CustomIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(CustomIndicatorDescriptionMetadata, 'CustomIndicatorDescriptionMetadata');
    CustomIndicatorDescriptionMetadata.a = null;
    return CustomIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class CustomIndicatorDescriptionModule extends Base {
        static register(a) {
            CustomIndicatorDescriptionMetadata.d(a);
        }
    }
    CustomIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(CustomIndicatorDescriptionModule, 'CustomIndicatorDescriptionModule');
    return CustomIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IndicatorsDescriptionModule = /*@__PURE__*/ (() => {
    class IndicatorsDescriptionModule extends Base {
        static register(a) {
            AbsoluteVolumeOscillatorIndicatorDescriptionModule.register(a);
            AccumulationDistributionIndicatorDescriptionModule.register(a);
            AverageDirectionalIndexIndicatorDescriptionModule.register(a);
            AverageTrueRangeIndicatorDescriptionModule.register(a);
            BollingerBandWidthIndicatorDescriptionModule.register(a);
            ChaikinOscillatorIndicatorDescriptionModule.register(a);
            ChaikinVolatilityIndicatorDescriptionModule.register(a);
            CommodityChannelIndexIndicatorDescriptionModule.register(a);
            DetrendedPriceOscillatorIndicatorDescriptionModule.register(a);
            EaseOfMovementIndicatorDescriptionModule.register(a);
            FastStochasticOscillatorIndicatorDescriptionModule.register(a);
            ForceIndexIndicatorDescriptionModule.register(a);
            FullStochasticOscillatorIndicatorDescriptionModule.register(a);
            MarketFacilitationIndexIndicatorDescriptionModule.register(a);
            MassIndexIndicatorDescriptionModule.register(a);
            MedianPriceIndicatorDescriptionModule.register(a);
            MoneyFlowIndexIndicatorDescriptionModule.register(a);
            MovingAverageConvergenceDivergenceIndicatorDescriptionModule.register(a);
            NegativeVolumeIndexIndicatorDescriptionModule.register(a);
            OnBalanceVolumeIndicatorDescriptionModule.register(a);
            PercentagePriceOscillatorIndicatorDescriptionModule.register(a);
            PercentageVolumeOscillatorIndicatorDescriptionModule.register(a);
            PositiveVolumeIndexIndicatorDescriptionModule.register(a);
            PriceVolumeTrendIndicatorDescriptionModule.register(a);
            RateOfChangeAndMomentumIndicatorDescriptionModule.register(a);
            RelativeStrengthIndexIndicatorDescriptionModule.register(a);
            SlowStochasticOscillatorIndicatorDescriptionModule.register(a);
            StandardDeviationIndicatorDescriptionModule.register(a);
            StochRSIIndicatorDescriptionModule.register(a);
            TRIXIndicatorDescriptionModule.register(a);
            TypicalPriceIndicatorDescriptionModule.register(a);
            UltimateOscillatorIndicatorDescriptionModule.register(a);
            WeightedCloseIndicatorDescriptionModule.register(a);
            WilliamsPercentRIndicatorDescriptionModule.register(a);
            CustomIndicatorDescriptionModule.register(a);
        }
    }
    IndicatorsDescriptionModule.$t = /*@__PURE__*/ markType(IndicatorsDescriptionModule, 'IndicatorsDescriptionModule');
    return IndicatorsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartFinancialIndicatorsDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartFinancialIndicatorsDescriptionModule extends Base {
        static register(a) {
            IndicatorsDescriptionModule.register(a);
            DataChartFinancialCoreDescriptionModule.register(a);
        }
    }
    DataChartFinancialIndicatorsDescriptionModule.$t = /*@__PURE__*/ markType(DataChartFinancialIndicatorsDescriptionModule, 'DataChartFinancialIndicatorsDescriptionModule');
    return DataChartFinancialIndicatorsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialPriceSeriesDescription = /*@__PURE__*/ (() => {
    class FinancialPriceSeriesDescription extends FinancialSeriesDescription {
        get_type() {
            return "FinancialPriceSeries";
        }
        constructor() {
            super();
            this.gl = null;
            this.gk = null;
            this.f9 = null;
            this.f5 = 0;
            this.f3 = null;
            this.f7 = 0;
            this.gc = null;
            this.gh = null;
            this.gf = null;
            this.gd = null;
            this.ga = null;
            this.gi = null;
            this.gg = null;
            this.ge = null;
            this.gb = null;
            this.gj = null;
        }
        get trendLineType() {
            return this.gl;
        }
        set trendLineType(a) {
            this.gl = a;
            this.g("TrendLineType");
        }
        get trendLineBrush() {
            return this.gk;
        }
        set trendLineBrush(a) {
            this.gk = a;
            this.g("TrendLineBrush");
        }
        get actualTrendLineBrush() {
            return this.f9;
        }
        set actualTrendLineBrush(a) {
            this.f9 = a;
            this.g("ActualTrendLineBrush");
        }
        get trendLineThickness() {
            return this.f5;
        }
        set trendLineThickness(a) {
            this.f5 = a;
            this.g("TrendLineThickness");
        }
        get trendLineDashArray() {
            return this.f3;
        }
        set trendLineDashArray(a) {
            this.f3 = a;
            this.g("TrendLineDashArray");
        }
        get trendLinePeriod() {
            return this.f7;
        }
        set trendLinePeriod(a) {
            this.f7 = a;
            this.g("TrendLinePeriod");
        }
        get displayType() {
            return this.gc;
        }
        set displayType(a) {
            this.gc = a;
            this.g("DisplayType");
        }
        get negativeOutline() {
            return this.gh;
        }
        set negativeOutline(a) {
            this.gh = a;
            this.g("NegativeOutline");
        }
        get lowMemberAsLegendLabel() {
            return this.gf;
        }
        set lowMemberAsLegendLabel(a) {
            this.gf = a;
            this.g("LowMemberAsLegendLabel");
        }
        get highMemberAsLegendLabel() {
            return this.gd;
        }
        set highMemberAsLegendLabel(a) {
            this.gd = a;
            this.g("HighMemberAsLegendLabel");
        }
        get closeMemberAsLegendLabel() {
            return this.ga;
        }
        set closeMemberAsLegendLabel(a) {
            this.ga = a;
            this.g("CloseMemberAsLegendLabel");
        }
        get openMemberAsLegendLabel() {
            return this.gi;
        }
        set openMemberAsLegendLabel(a) {
            this.gi = a;
            this.g("OpenMemberAsLegendLabel");
        }
        get lowMemberAsLegendUnit() {
            return this.gg;
        }
        set lowMemberAsLegendUnit(a) {
            this.gg = a;
            this.g("LowMemberAsLegendUnit");
        }
        get highMemberAsLegendUnit() {
            return this.ge;
        }
        set highMemberAsLegendUnit(a) {
            this.ge = a;
            this.g("HighMemberAsLegendUnit");
        }
        get closeMemberAsLegendUnit() {
            return this.gb;
        }
        set closeMemberAsLegendUnit(a) {
            this.gb = a;
            this.g("CloseMemberAsLegendUnit");
        }
        get openMemberAsLegendUnit() {
            return this.gj;
        }
        set openMemberAsLegendUnit(a) {
            this.gj = a;
            this.g("OpenMemberAsLegendUnit");
        }
    }
    FinancialPriceSeriesDescription.$t = /*@__PURE__*/ markType(FinancialPriceSeriesDescription, 'FinancialPriceSeriesDescription', FinancialSeriesDescription.$);
    return FinancialPriceSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialPriceSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialPriceSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialPriceSeriesDescriptionMetadata.a == null) {
                FinancialPriceSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialPriceSeriesDescriptionMetadata.c(FinancialPriceSeriesDescriptionMetadata.a);
            }
            if (a.k(FinancialPriceSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(FinancialPriceSeriesDescriptionMetadata.a);
        }
        static c(a) {
            FinancialSeriesDescriptionMetadata.c(a);
            a.item("TrendLineType", "ExportedType:string:TrendLineType");
            a.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            a.item("TrendLineBrush", "Brush");
            a.item("ActualTrendLineBrush", "Brush");
            a.item("TrendLineThickness", "Number:double");
            a.item("TrendLineDashArray", "DoubleCollection:double");
            a.item("TrendLinePeriod", "Number:int");
            a.item("DisplayType", "ExportedType:string:PriceDisplayType");
            a.item("DisplayType@names", "Candlestick;OHLC");
            a.item("NegativeOutline", "Brush");
            a.item("LowMemberAsLegendLabel", "String");
            a.item("HighMemberAsLegendLabel", "String");
            a.item("CloseMemberAsLegendLabel", "String");
            a.item("OpenMemberAsLegendLabel", "String");
            a.item("LowMemberAsLegendUnit", "String");
            a.item("HighMemberAsLegendUnit", "String");
            a.item("CloseMemberAsLegendUnit", "String");
            a.item("OpenMemberAsLegendUnit", "String");
        }
        static d(a) {
            FinancialPriceSeriesDescriptionMetadata.b(a);
            a.ae("FinancialPriceSeries", () => new FinancialPriceSeriesDescription());
            a.ad("FinancialPriceSeries", FinancialPriceSeriesDescriptionMetadata.a);
        }
    }
    FinancialPriceSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialPriceSeriesDescriptionMetadata, 'FinancialPriceSeriesDescriptionMetadata');
    FinancialPriceSeriesDescriptionMetadata.a = null;
    return FinancialPriceSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialPriceSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class FinancialPriceSeriesDescriptionModule extends Base {
        static register(a) {
            FinancialPriceSeriesDescriptionMetadata.d(a);
        }
    }
    FinancialPriceSeriesDescriptionModule.$t = /*@__PURE__*/ markType(FinancialPriceSeriesDescriptionModule, 'FinancialPriceSeriesDescriptionModule');
    return FinancialPriceSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartFinancialDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartFinancialDescriptionModule extends Base {
        static register(a) {
            FinancialPriceSeriesDescriptionModule.register(a);
            DataChartFinancialCoreDescriptionModule.register(a);
        }
    }
    DataChartFinancialDescriptionModule.$t = /*@__PURE__*/ markType(DataChartFinancialDescriptionModule, 'DataChartFinancialDescriptionModule');
    return DataChartFinancialDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialOverlayDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialOverlayDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialOverlayDescriptionMetadata.a == null) {
                FinancialOverlayDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialOverlayDescriptionMetadata.c(FinancialOverlayDescriptionMetadata.a);
            }
            if (a.k(FinancialOverlayDescriptionMetadata.a)) {
                return;
            }
            a.ac(FinancialOverlayDescriptionMetadata.a);
        }
        static c(a) {
            FinancialSeriesDescriptionMetadata.c(a);
            a.item("IgnoreFirst", "Number:int");
        }
        static d(a) {
            FinancialOverlayDescriptionMetadata.b(a);
            a.ad("FinancialOverlay", FinancialOverlayDescriptionMetadata.a);
        }
    }
    FinancialOverlayDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialOverlayDescriptionMetadata, 'FinancialOverlayDescriptionMetadata');
    FinancialOverlayDescriptionMetadata.a = null;
    return FinancialOverlayDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialOverlayDescription = /*@__PURE__*/ (() => {
    class FinancialOverlayDescription extends FinancialSeriesDescription {
        get_type() {
            return "FinancialOverlay";
        }
        constructor() {
            super();
            this.f3 = 0;
        }
        get ignoreFirst() {
            return this.f3;
        }
        set ignoreFirst(a) {
            this.f3 = a;
            this.g("IgnoreFirst");
        }
    }
    FinancialOverlayDescription.$t = /*@__PURE__*/ markType(FinancialOverlayDescription, 'FinancialOverlayDescription', FinancialSeriesDescription.$);
    return FinancialOverlayDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PriceChannelOverlayDescription = /*@__PURE__*/ (() => {
    class PriceChannelOverlayDescription extends FinancialOverlayDescription {
        get_type() {
            return "PriceChannelOverlay";
        }
        constructor() {
            super();
            this.f5 = 0;
        }
        get period() {
            return this.f5;
        }
        set period(a) {
            this.f5 = a;
            this.g("Period");
        }
    }
    PriceChannelOverlayDescription.$t = /*@__PURE__*/ markType(PriceChannelOverlayDescription, 'PriceChannelOverlayDescription', FinancialOverlayDescription.$);
    return PriceChannelOverlayDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PriceChannelOverlayDescriptionMetadata = /*@__PURE__*/ (() => {
    class PriceChannelOverlayDescriptionMetadata extends Base {
        static b(a) {
            if (PriceChannelOverlayDescriptionMetadata.a == null) {
                PriceChannelOverlayDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PriceChannelOverlayDescriptionMetadata.c(PriceChannelOverlayDescriptionMetadata.a);
            }
            if (a.k(PriceChannelOverlayDescriptionMetadata.a)) {
                return;
            }
            a.ac(PriceChannelOverlayDescriptionMetadata.a);
        }
        static c(a) {
            FinancialOverlayDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
        }
        static d(a) {
            PriceChannelOverlayDescriptionMetadata.b(a);
            a.ae("PriceChannelOverlay", () => new PriceChannelOverlayDescription());
            a.ad("PriceChannelOverlay", PriceChannelOverlayDescriptionMetadata.a);
        }
    }
    PriceChannelOverlayDescriptionMetadata.$t = /*@__PURE__*/ markType(PriceChannelOverlayDescriptionMetadata, 'PriceChannelOverlayDescriptionMetadata');
    PriceChannelOverlayDescriptionMetadata.a = null;
    return PriceChannelOverlayDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PriceChannelOverlayDescriptionModule = /*@__PURE__*/ (() => {
    class PriceChannelOverlayDescriptionModule extends Base {
        static register(a) {
            PriceChannelOverlayDescriptionMetadata.d(a);
        }
    }
    PriceChannelOverlayDescriptionModule.$t = /*@__PURE__*/ markType(PriceChannelOverlayDescriptionModule, 'PriceChannelOverlayDescriptionModule');
    return PriceChannelOverlayDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BollingerBandsOverlayDescription = /*@__PURE__*/ (() => {
    class BollingerBandsOverlayDescription extends FinancialOverlayDescription {
        get_type() {
            return "BollingerBandsOverlay";
        }
        constructor() {
            super();
            this.f7 = 0;
            this.f5 = 0;
        }
        get period() {
            return this.f7;
        }
        set period(a) {
            this.f7 = a;
            this.g("Period");
        }
        get multiplier() {
            return this.f5;
        }
        set multiplier(a) {
            this.f5 = a;
            this.g("Multiplier");
        }
    }
    BollingerBandsOverlayDescription.$t = /*@__PURE__*/ markType(BollingerBandsOverlayDescription, 'BollingerBandsOverlayDescription', FinancialOverlayDescription.$);
    return BollingerBandsOverlayDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BollingerBandsOverlayDescriptionMetadata = /*@__PURE__*/ (() => {
    class BollingerBandsOverlayDescriptionMetadata extends Base {
        static b(a) {
            if (BollingerBandsOverlayDescriptionMetadata.a == null) {
                BollingerBandsOverlayDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BollingerBandsOverlayDescriptionMetadata.c(BollingerBandsOverlayDescriptionMetadata.a);
            }
            if (a.k(BollingerBandsOverlayDescriptionMetadata.a)) {
                return;
            }
            a.ac(BollingerBandsOverlayDescriptionMetadata.a);
        }
        static c(a) {
            FinancialOverlayDescriptionMetadata.c(a);
            a.item("Period", "Number:int");
            a.item("Multiplier", "Number:double");
        }
        static d(a) {
            BollingerBandsOverlayDescriptionMetadata.b(a);
            a.ae("BollingerBandsOverlay", () => new BollingerBandsOverlayDescription());
            a.ad("BollingerBandsOverlay", BollingerBandsOverlayDescriptionMetadata.a);
        }
    }
    BollingerBandsOverlayDescriptionMetadata.$t = /*@__PURE__*/ markType(BollingerBandsOverlayDescriptionMetadata, 'BollingerBandsOverlayDescriptionMetadata');
    BollingerBandsOverlayDescriptionMetadata.a = null;
    return BollingerBandsOverlayDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BollingerBandsOverlayDescriptionModule = /*@__PURE__*/ (() => {
    class BollingerBandsOverlayDescriptionModule extends Base {
        static register(a) {
            BollingerBandsOverlayDescriptionMetadata.d(a);
        }
    }
    BollingerBandsOverlayDescriptionModule.$t = /*@__PURE__*/ markType(BollingerBandsOverlayDescriptionModule, 'BollingerBandsOverlayDescriptionModule');
    return BollingerBandsOverlayDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OverlaysDescriptionModule = /*@__PURE__*/ (() => {
    class OverlaysDescriptionModule extends Base {
        static register(a) {
            PriceChannelOverlayDescriptionModule.register(a);
            BollingerBandsOverlayDescriptionModule.register(a);
        }
    }
    OverlaysDescriptionModule.$t = /*@__PURE__*/ markType(OverlaysDescriptionModule, 'OverlaysDescriptionModule');
    return OverlaysDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartFinancialOverlaysDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartFinancialOverlaysDescriptionModule extends Base {
        static register(a) {
            OverlaysDescriptionModule.register(a);
            DataChartFinancialCoreDescriptionModule.register(a);
        }
    }
    DataChartFinancialOverlaysDescriptionModule.$t = /*@__PURE__*/ markType(DataChartFinancialOverlaysDescriptionModule, 'DataChartFinancialOverlaysDescriptionModule');
    return DataChartFinancialOverlaysDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericAngleAxisDescription = /*@__PURE__*/ (() => {
    class NumericAngleAxisDescription extends NumericAxisBaseDescription {
        get_type() {
            return "NumericAngleAxis";
        }
        constructor() {
            super();
            this.e1 = 0;
            this.e3 = null;
        }
        get startAngleOffset() {
            return this.e1;
        }
        set startAngleOffset(a) {
            this.e1 = a;
            this.g("StartAngleOffset");
        }
        get labelMode() {
            return this.e3;
        }
        set labelMode(a) {
            this.e3 = a;
            this.g("LabelMode");
        }
    }
    NumericAngleAxisDescription.$t = /*@__PURE__*/ markType(NumericAngleAxisDescription, 'NumericAngleAxisDescription', NumericAxisBaseDescription.$);
    return NumericAngleAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericAngleAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumericAngleAxisDescriptionMetadata extends Base {
        static b(a) {
            if (NumericAngleAxisDescriptionMetadata.a == null) {
                NumericAngleAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumericAngleAxisDescriptionMetadata.c(NumericAngleAxisDescriptionMetadata.a);
            }
            if (a.k(NumericAngleAxisDescriptionMetadata.a)) {
                return;
            }
            a.ac(NumericAngleAxisDescriptionMetadata.a);
        }
        static c(a) {
            NumericAxisBaseDescriptionMetadata.c(a);
            a.item("StartAngleOffset", "Number:double");
            a.item("LabelMode", "ExportedType:string:AxisAngleLabelMode");
            a.item("LabelMode@names", "Auto;Center;ClosestPoint");
        }
        static d(a) {
            NumericAngleAxisDescriptionMetadata.b(a);
            a.ae("NumericAngleAxis", () => new NumericAngleAxisDescription());
            a.ad("NumericAngleAxis", NumericAngleAxisDescriptionMetadata.a);
        }
    }
    NumericAngleAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(NumericAngleAxisDescriptionMetadata, 'NumericAngleAxisDescriptionMetadata');
    NumericAngleAxisDescriptionMetadata.a = null;
    return NumericAngleAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericAngleAxisDescriptionModule = /*@__PURE__*/ (() => {
    class NumericAngleAxisDescriptionModule extends Base {
        static register(a) {
            NumericAngleAxisDescriptionMetadata.d(a);
        }
    }
    NumericAngleAxisDescriptionModule.$t = /*@__PURE__*/ markType(NumericAngleAxisDescriptionModule, 'NumericAngleAxisDescriptionModule');
    return NumericAngleAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericRadiusAxisDescription = /*@__PURE__*/ (() => {
    class NumericRadiusAxisDescription extends NumericAxisBaseDescription {
        get_type() {
            return "NumericRadiusAxis";
        }
        constructor() {
            super();
            this.e2 = 0;
            this.e1 = 0;
        }
        get radiusExtentScale() {
            return this.e2;
        }
        set radiusExtentScale(a) {
            this.e2 = a;
            this.g("RadiusExtentScale");
        }
        get innerRadiusExtentScale() {
            return this.e1;
        }
        set innerRadiusExtentScale(a) {
            this.e1 = a;
            this.g("InnerRadiusExtentScale");
        }
    }
    NumericRadiusAxisDescription.$t = /*@__PURE__*/ markType(NumericRadiusAxisDescription, 'NumericRadiusAxisDescription', NumericAxisBaseDescription.$);
    return NumericRadiusAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericRadiusAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumericRadiusAxisDescriptionMetadata extends Base {
        static b(a) {
            if (NumericRadiusAxisDescriptionMetadata.a == null) {
                NumericRadiusAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumericRadiusAxisDescriptionMetadata.c(NumericRadiusAxisDescriptionMetadata.a);
            }
            if (a.k(NumericRadiusAxisDescriptionMetadata.a)) {
                return;
            }
            a.ac(NumericRadiusAxisDescriptionMetadata.a);
        }
        static c(a) {
            NumericAxisBaseDescriptionMetadata.c(a);
            a.item("RadiusExtentScale", "Number:double");
            a.item("InnerRadiusExtentScale", "Number:double");
        }
        static d(a) {
            NumericRadiusAxisDescriptionMetadata.b(a);
            a.ae("NumericRadiusAxis", () => new NumericRadiusAxisDescription());
            a.ad("NumericRadiusAxis", NumericRadiusAxisDescriptionMetadata.a);
        }
    }
    NumericRadiusAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(NumericRadiusAxisDescriptionMetadata, 'NumericRadiusAxisDescriptionMetadata');
    NumericRadiusAxisDescriptionMetadata.a = null;
    return NumericRadiusAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericRadiusAxisDescriptionModule = /*@__PURE__*/ (() => {
    class NumericRadiusAxisDescriptionModule extends Base {
        static register(a) {
            NumericRadiusAxisDescriptionMetadata.d(a);
        }
    }
    NumericRadiusAxisDescriptionModule.$t = /*@__PURE__*/ markType(NumericRadiusAxisDescriptionModule, 'NumericRadiusAxisDescriptionModule');
    return NumericRadiusAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartPolarCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartPolarCoreDescriptionModule extends Base {
        static register(a) {
            NumericAngleAxisDescriptionModule.register(a);
            NumericRadiusAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartPolarCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartPolarCoreDescriptionModule, 'DataChartPolarCoreDescriptionModule');
    return DataChartPolarCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class PolarBaseDescriptionMetadata extends Base {
        static b(a) {
            if (PolarBaseDescriptionMetadata.a == null) {
                PolarBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PolarBaseDescriptionMetadata.c(PolarBaseDescriptionMetadata.a);
            }
            if (a.k(PolarBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(PolarBaseDescriptionMetadata.a);
            AssigningPolarStyleEventArgsDescriptionMetadata.d(a);
            AssigningPolarMarkerStyleEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            MarkerSeriesDescriptionMetadata.c(a);
            a.item("AngleMemberPath", "String");
            a.item("RadiusMemberPath", "String");
            a.item("HighlightedRadiusMemberPath", "String");
            a.item("HighlightedAngleMemberPath", "String");
            a.item("AngleAxisRef", "(w:AngleAxis,wf:AngleAxis)DataRef::object");
            a.item("AngleAxisRef@nameBinding", "true");
            a.item("RadiusAxisRef", "(w:RadiusAxis,wf:RadiusAxis)DataRef::object");
            a.item("RadiusAxisRef@nameBinding", "true");
            a.item("UseCartesianInterpolation", "Boolean");
            a.item("MaximumMarkers", "Number:int");
            a.item("TrendLineType", "ExportedType:string:TrendLineType");
            a.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            a.item("TrendLineBrush", "Brush");
            a.item("ActualTrendLineBrush", "Brush");
            a.item("TrendLineThickness", "Number:double");
            a.item("TrendLineDashArray", "DoubleCollection:double");
            a.item("TrendLinePeriod", "Number:int");
            a.item("TrendLineZIndex", "Number:int");
            a.item("ClipSeriesToBounds", "Boolean");
            a.item("ActualItemSearchMode", "ExportedType:string:ScatterItemSearchMode");
            a.item("ActualItemSearchMode@names", "Auto;ClosestVisiblePoint;ClosestPoint;ClosestVisiblePointOnClosestLine;ClosestPointOnClosestLine;None");
            a.item("ItemSearchMode", "ExportedType:string:ScatterItemSearchMode");
            a.item("ItemSearchMode@names", "Auto;ClosestVisiblePoint;ClosestPoint;ClosestVisiblePointOnClosestLine;ClosestPointOnClosestLine;None");
            a.item("ItemSearchThreshold", "Number:int");
            a.item("IsCustomPolarStyleAllowed", "Boolean");
            a.item("IsCustomPolarMarkerStyleAllowed", "Boolean");
            a.item("RadiusMemberAsLegendLabel", "String");
            a.item("AngleMemberAsLegendLabel", "String");
            a.item("RadiusMemberAsLegendUnit", "String");
            a.item("AngleMemberAsLegendUnit", "String");
            a.item("AssigningPolarStyleRef", "EventRef::assigningPolarStyle");
            a.item("AssigningPolarMarkerStyleRef", "EventRef::assigningPolarMarkerStyle");
        }
        static d(a) {
            PolarBaseDescriptionMetadata.b(a);
            a.ad("PolarBase", PolarBaseDescriptionMetadata.a);
        }
    }
    PolarBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(PolarBaseDescriptionMetadata, 'PolarBaseDescriptionMetadata');
    PolarBaseDescriptionMetadata.a = null;
    return PolarBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarLineSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class PolarLineSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (PolarLineSeriesBaseDescriptionMetadata.a == null) {
                PolarLineSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PolarLineSeriesBaseDescriptionMetadata.c(PolarLineSeriesBaseDescriptionMetadata.a);
            }
            if (a.k(PolarLineSeriesBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(PolarLineSeriesBaseDescriptionMetadata.a);
        }
        static c(a) {
            PolarBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            PolarLineSeriesBaseDescriptionMetadata.b(a);
            a.ad("PolarLineSeriesBase", PolarLineSeriesBaseDescriptionMetadata.a);
        }
    }
    PolarLineSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(PolarLineSeriesBaseDescriptionMetadata, 'PolarLineSeriesBaseDescriptionMetadata');
    PolarLineSeriesBaseDescriptionMetadata.a = null;
    return PolarLineSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarBaseDescription = /*@__PURE__*/ (() => {
    class PolarBaseDescription extends MarkerSeriesDescription {
        get_type() {
            return "PolarBase";
        }
        constructor() {
            super();
            this.gc = null;
            this.gl = null;
            this.gg = null;
            this.gf = null;
            this.f9 = null;
            this.gi = null;
            this.fs = false;
            this.f0 = 0;
            this.gn = null;
            this.gm = null;
            this.f8 = null;
            this.fx = 0;
            this.fn = null;
            this.f1 = 0;
            this.f2 = 0;
            this.fp = false;
            this.f7 = null;
            this.gh = null;
            this.fz = 0;
            this.fr = false;
            this.fq = false;
            this.gj = null;
            this.ga = null;
            this.gk = null;
            this.gb = null;
            this.ge = null;
            this.gd = null;
        }
        get angleMemberPath() {
            return this.gc;
        }
        set angleMemberPath(a) {
            this.gc = a;
            this.g("AngleMemberPath");
        }
        get radiusMemberPath() {
            return this.gl;
        }
        set radiusMemberPath(a) {
            this.gl = a;
            this.g("RadiusMemberPath");
        }
        get highlightedRadiusMemberPath() {
            return this.gg;
        }
        set highlightedRadiusMemberPath(a) {
            this.gg = a;
            this.g("HighlightedRadiusMemberPath");
        }
        get highlightedAngleMemberPath() {
            return this.gf;
        }
        set highlightedAngleMemberPath(a) {
            this.gf = a;
            this.g("HighlightedAngleMemberPath");
        }
        get angleAxisRef() {
            return this.f9;
        }
        set angleAxisRef(a) {
            this.f9 = a;
            this.g("AngleAxisRef");
        }
        get radiusAxisRef() {
            return this.gi;
        }
        set radiusAxisRef(a) {
            this.gi = a;
            this.g("RadiusAxisRef");
        }
        get useCartesianInterpolation() {
            return this.fs;
        }
        set useCartesianInterpolation(a) {
            this.fs = a;
            this.g("UseCartesianInterpolation");
        }
        get maximumMarkers() {
            return this.f0;
        }
        set maximumMarkers(a) {
            this.f0 = a;
            this.g("MaximumMarkers");
        }
        get trendLineType() {
            return this.gn;
        }
        set trendLineType(a) {
            this.gn = a;
            this.g("TrendLineType");
        }
        get trendLineBrush() {
            return this.gm;
        }
        set trendLineBrush(a) {
            this.gm = a;
            this.g("TrendLineBrush");
        }
        get actualTrendLineBrush() {
            return this.f8;
        }
        set actualTrendLineBrush(a) {
            this.f8 = a;
            this.g("ActualTrendLineBrush");
        }
        get trendLineThickness() {
            return this.fx;
        }
        set trendLineThickness(a) {
            this.fx = a;
            this.g("TrendLineThickness");
        }
        get trendLineDashArray() {
            return this.fn;
        }
        set trendLineDashArray(a) {
            this.fn = a;
            this.g("TrendLineDashArray");
        }
        get trendLinePeriod() {
            return this.f1;
        }
        set trendLinePeriod(a) {
            this.f1 = a;
            this.g("TrendLinePeriod");
        }
        get trendLineZIndex() {
            return this.f2;
        }
        set trendLineZIndex(a) {
            this.f2 = a;
            this.g("TrendLineZIndex");
        }
        get clipSeriesToBounds() {
            return this.fp;
        }
        set clipSeriesToBounds(a) {
            this.fp = a;
            this.g("ClipSeriesToBounds");
        }
        get actualItemSearchMode() {
            return this.f7;
        }
        set actualItemSearchMode(a) {
            this.f7 = a;
            this.g("ActualItemSearchMode");
        }
        get itemSearchMode() {
            return this.gh;
        }
        set itemSearchMode(a) {
            this.gh = a;
            this.g("ItemSearchMode");
        }
        get itemSearchThreshold() {
            return this.fz;
        }
        set itemSearchThreshold(a) {
            this.fz = a;
            this.g("ItemSearchThreshold");
        }
        get isCustomPolarStyleAllowed() {
            return this.fr;
        }
        set isCustomPolarStyleAllowed(a) {
            this.fr = a;
            this.g("IsCustomPolarStyleAllowed");
        }
        get isCustomPolarMarkerStyleAllowed() {
            return this.fq;
        }
        set isCustomPolarMarkerStyleAllowed(a) {
            this.fq = a;
            this.g("IsCustomPolarMarkerStyleAllowed");
        }
        get radiusMemberAsLegendLabel() {
            return this.gj;
        }
        set radiusMemberAsLegendLabel(a) {
            this.gj = a;
            this.g("RadiusMemberAsLegendLabel");
        }
        get angleMemberAsLegendLabel() {
            return this.ga;
        }
        set angleMemberAsLegendLabel(a) {
            this.ga = a;
            this.g("AngleMemberAsLegendLabel");
        }
        get radiusMemberAsLegendUnit() {
            return this.gk;
        }
        set radiusMemberAsLegendUnit(a) {
            this.gk = a;
            this.g("RadiusMemberAsLegendUnit");
        }
        get angleMemberAsLegendUnit() {
            return this.gb;
        }
        set angleMemberAsLegendUnit(a) {
            this.gb = a;
            this.g("AngleMemberAsLegendUnit");
        }
        get assigningPolarStyleRef() {
            return this.ge;
        }
        set assigningPolarStyleRef(a) {
            this.ge = a;
            this.g("AssigningPolarStyleRef");
        }
        get assigningPolarMarkerStyleRef() {
            return this.gd;
        }
        set assigningPolarMarkerStyleRef(a) {
            this.gd = a;
            this.g("AssigningPolarMarkerStyleRef");
        }
    }
    PolarBaseDescription.$t = /*@__PURE__*/ markType(PolarBaseDescription, 'PolarBaseDescription', MarkerSeriesDescription.$);
    return PolarBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarLineSeriesBaseDescription = /*@__PURE__*/ (() => {
    class PolarLineSeriesBaseDescription extends PolarBaseDescription {
        get_type() {
            return "PolarLineSeriesBase";
        }
        constructor() {
            super();
        }
    }
    PolarLineSeriesBaseDescription.$t = /*@__PURE__*/ markType(PolarLineSeriesBaseDescription, 'PolarLineSeriesBaseDescription', PolarBaseDescription.$);
    return PolarLineSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarAreaSeriesDescription = /*@__PURE__*/ (() => {
    class PolarAreaSeriesDescription extends PolarLineSeriesBaseDescription {
        get_type() {
            return "PolarAreaSeries";
        }
        constructor() {
            super();
            this.g5 = null;
        }
        get unknownValuePlotting() {
            return this.g5;
        }
        set unknownValuePlotting(a) {
            this.g5 = a;
            this.g("UnknownValuePlotting");
        }
    }
    PolarAreaSeriesDescription.$t = /*@__PURE__*/ markType(PolarAreaSeriesDescription, 'PolarAreaSeriesDescription', PolarLineSeriesBaseDescription.$);
    return PolarAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class PolarAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (PolarAreaSeriesDescriptionMetadata.a == null) {
                PolarAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PolarAreaSeriesDescriptionMetadata.c(PolarAreaSeriesDescriptionMetadata.a);
            }
            if (a.k(PolarAreaSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(PolarAreaSeriesDescriptionMetadata.a);
        }
        static c(a) {
            PolarLineSeriesBaseDescriptionMetadata.c(a);
            a.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            a.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
        }
        static d(a) {
            PolarAreaSeriesDescriptionMetadata.b(a);
            a.ae("PolarAreaSeries", () => new PolarAreaSeriesDescription());
            a.ad("PolarAreaSeries", PolarAreaSeriesDescriptionMetadata.a);
        }
    }
    PolarAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(PolarAreaSeriesDescriptionMetadata, 'PolarAreaSeriesDescriptionMetadata');
    PolarAreaSeriesDescriptionMetadata.a = null;
    return PolarAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class PolarAreaSeriesDescriptionModule extends Base {
        static register(a) {
            PolarAreaSeriesDescriptionMetadata.d(a);
        }
    }
    PolarAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(PolarAreaSeriesDescriptionModule, 'PolarAreaSeriesDescriptionModule');
    return PolarAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarLineSeriesDescription = /*@__PURE__*/ (() => {
    class PolarLineSeriesDescription extends PolarLineSeriesBaseDescription {
        get_type() {
            return "PolarLineSeries";
        }
        constructor() {
            super();
            this.g5 = null;
        }
        get unknownValuePlotting() {
            return this.g5;
        }
        set unknownValuePlotting(a) {
            this.g5 = a;
            this.g("UnknownValuePlotting");
        }
    }
    PolarLineSeriesDescription.$t = /*@__PURE__*/ markType(PolarLineSeriesDescription, 'PolarLineSeriesDescription', PolarLineSeriesBaseDescription.$);
    return PolarLineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarLineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class PolarLineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (PolarLineSeriesDescriptionMetadata.a == null) {
                PolarLineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PolarLineSeriesDescriptionMetadata.c(PolarLineSeriesDescriptionMetadata.a);
            }
            if (a.k(PolarLineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(PolarLineSeriesDescriptionMetadata.a);
        }
        static c(a) {
            PolarLineSeriesBaseDescriptionMetadata.c(a);
            a.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            a.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
        }
        static d(a) {
            PolarLineSeriesDescriptionMetadata.b(a);
            a.ae("PolarLineSeries", () => new PolarLineSeriesDescription());
            a.ad("PolarLineSeries", PolarLineSeriesDescriptionMetadata.a);
        }
    }
    PolarLineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(PolarLineSeriesDescriptionMetadata, 'PolarLineSeriesDescriptionMetadata');
    PolarLineSeriesDescriptionMetadata.a = null;
    return PolarLineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarLineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class PolarLineSeriesDescriptionModule extends Base {
        static register(a) {
            PolarLineSeriesDescriptionMetadata.d(a);
        }
    }
    PolarLineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(PolarLineSeriesDescriptionModule, 'PolarLineSeriesDescriptionModule');
    return PolarLineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarScatterSeriesDescription = /*@__PURE__*/ (() => {
    class PolarScatterSeriesDescription extends PolarBaseDescription {
        get_type() {
            return "PolarScatterSeries";
        }
        constructor() {
            super();
        }
    }
    PolarScatterSeriesDescription.$t = /*@__PURE__*/ markType(PolarScatterSeriesDescription, 'PolarScatterSeriesDescription', PolarBaseDescription.$);
    return PolarScatterSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarScatterSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class PolarScatterSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (PolarScatterSeriesDescriptionMetadata.a == null) {
                PolarScatterSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PolarScatterSeriesDescriptionMetadata.c(PolarScatterSeriesDescriptionMetadata.a);
            }
            if (a.k(PolarScatterSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(PolarScatterSeriesDescriptionMetadata.a);
        }
        static c(a) {
            PolarBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            PolarScatterSeriesDescriptionMetadata.b(a);
            a.ae("PolarScatterSeries", () => new PolarScatterSeriesDescription());
            a.ad("PolarScatterSeries", PolarScatterSeriesDescriptionMetadata.a);
        }
    }
    PolarScatterSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(PolarScatterSeriesDescriptionMetadata, 'PolarScatterSeriesDescriptionMetadata');
    PolarScatterSeriesDescriptionMetadata.a = null;
    return PolarScatterSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarScatterSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class PolarScatterSeriesDescriptionModule extends Base {
        static register(a) {
            PolarScatterSeriesDescriptionMetadata.d(a);
        }
    }
    PolarScatterSeriesDescriptionModule.$t = /*@__PURE__*/ markType(PolarScatterSeriesDescriptionModule, 'PolarScatterSeriesDescriptionModule');
    return PolarScatterSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarSplineSeriesDescription = /*@__PURE__*/ (() => {
    class PolarSplineSeriesDescription extends PolarLineSeriesBaseDescription {
        get_type() {
            return "PolarSplineSeries";
        }
        constructor() {
            super();
            this.g5 = 0;
        }
        get stiffness() {
            return this.g5;
        }
        set stiffness(a) {
            this.g5 = a;
            this.g("Stiffness");
        }
    }
    PolarSplineSeriesDescription.$t = /*@__PURE__*/ markType(PolarSplineSeriesDescription, 'PolarSplineSeriesDescription', PolarLineSeriesBaseDescription.$);
    return PolarSplineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarSplineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class PolarSplineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (PolarSplineSeriesDescriptionMetadata.a == null) {
                PolarSplineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PolarSplineSeriesDescriptionMetadata.c(PolarSplineSeriesDescriptionMetadata.a);
            }
            if (a.k(PolarSplineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(PolarSplineSeriesDescriptionMetadata.a);
        }
        static c(a) {
            PolarLineSeriesBaseDescriptionMetadata.c(a);
            a.item("Stiffness", "Number:double");
        }
        static d(a) {
            PolarSplineSeriesDescriptionMetadata.b(a);
            a.ae("PolarSplineSeries", () => new PolarSplineSeriesDescription());
            a.ad("PolarSplineSeries", PolarSplineSeriesDescriptionMetadata.a);
        }
    }
    PolarSplineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(PolarSplineSeriesDescriptionMetadata, 'PolarSplineSeriesDescriptionMetadata');
    PolarSplineSeriesDescriptionMetadata.a = null;
    return PolarSplineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarSplineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class PolarSplineSeriesDescriptionModule extends Base {
        static register(a) {
            PolarSplineSeriesDescriptionMetadata.d(a);
        }
    }
    PolarSplineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(PolarSplineSeriesDescriptionModule, 'PolarSplineSeriesDescriptionModule');
    return PolarSplineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarSplineAreaSeriesDescription = /*@__PURE__*/ (() => {
    class PolarSplineAreaSeriesDescription extends PolarLineSeriesBaseDescription {
        get_type() {
            return "PolarSplineAreaSeries";
        }
        constructor() {
            super();
            this.g5 = 0;
        }
        get stiffness() {
            return this.g5;
        }
        set stiffness(a) {
            this.g5 = a;
            this.g("Stiffness");
        }
    }
    PolarSplineAreaSeriesDescription.$t = /*@__PURE__*/ markType(PolarSplineAreaSeriesDescription, 'PolarSplineAreaSeriesDescription', PolarLineSeriesBaseDescription.$);
    return PolarSplineAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarSplineAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class PolarSplineAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (PolarSplineAreaSeriesDescriptionMetadata.a == null) {
                PolarSplineAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PolarSplineAreaSeriesDescriptionMetadata.c(PolarSplineAreaSeriesDescriptionMetadata.a);
            }
            if (a.k(PolarSplineAreaSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(PolarSplineAreaSeriesDescriptionMetadata.a);
        }
        static c(a) {
            PolarLineSeriesBaseDescriptionMetadata.c(a);
            a.item("Stiffness", "Number:double");
        }
        static d(a) {
            PolarSplineAreaSeriesDescriptionMetadata.b(a);
            a.ae("PolarSplineAreaSeries", () => new PolarSplineAreaSeriesDescription());
            a.ad("PolarSplineAreaSeries", PolarSplineAreaSeriesDescriptionMetadata.a);
        }
    }
    PolarSplineAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(PolarSplineAreaSeriesDescriptionMetadata, 'PolarSplineAreaSeriesDescriptionMetadata');
    PolarSplineAreaSeriesDescriptionMetadata.a = null;
    return PolarSplineAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarSplineAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class PolarSplineAreaSeriesDescriptionModule extends Base {
        static register(a) {
            PolarSplineAreaSeriesDescriptionMetadata.d(a);
        }
    }
    PolarSplineAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(PolarSplineAreaSeriesDescriptionModule, 'PolarSplineAreaSeriesDescriptionModule');
    return PolarSplineAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartPolarDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartPolarDescriptionModule extends Base {
        static register(a) {
            PolarAreaSeriesDescriptionModule.register(a);
            PolarLineSeriesDescriptionModule.register(a);
            PolarScatterSeriesDescriptionModule.register(a);
            PolarSplineSeriesDescriptionModule.register(a);
            PolarSplineAreaSeriesDescriptionModule.register(a);
            DataChartPolarCoreDescriptionModule.register(a);
        }
    }
    DataChartPolarDescriptionModule.$t = /*@__PURE__*/ markType(DataChartPolarDescriptionModule, 'DataChartPolarDescriptionModule');
    return DataChartPolarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryAngleAxisDescription = /*@__PURE__*/ (() => {
    class CategoryAngleAxisDescription extends CategoryAxisBaseDescription {
        get_type() {
            return "CategoryAngleAxis";
        }
        constructor() {
            super();
            this.d7 = 0;
            this.ee = null;
            this.d5 = 0;
            this.d3 = 0;
            this.d6 = 0;
            this.d4 = 0;
            this.ed = null;
        }
        get startAngleOffset() {
            return this.d7;
        }
        set startAngleOffset(a) {
            this.d7 = a;
            this.g("StartAngleOffset");
        }
        get labelMode() {
            return this.ee;
        }
        set labelMode(a) {
            this.ee = a;
            this.g("LabelMode");
        }
        get interval() {
            return this.d5;
        }
        set interval(a) {
            this.d5 = a;
            this.g("Interval");
        }
        get actualInterval() {
            return this.d3;
        }
        set actualInterval(a) {
            this.d3 = a;
            this.g("ActualInterval");
        }
        get minorInterval() {
            return this.d6;
        }
        set minorInterval(a) {
            this.d6 = a;
            this.g("MinorInterval");
        }
        get actualMinorInterval() {
            return this.d4;
        }
        set actualMinorInterval(a) {
            this.d4 = a;
            this.g("ActualMinorInterval");
        }
        get actualIntervalChangeRef() {
            return this.ed;
        }
        set actualIntervalChangeRef(a) {
            this.ed = a;
            this.g("ActualIntervalChangeRef");
        }
    }
    CategoryAngleAxisDescription.$t = /*@__PURE__*/ markType(CategoryAngleAxisDescription, 'CategoryAngleAxisDescription', CategoryAxisBaseDescription.$);
    return CategoryAngleAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryAngleAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryAngleAxisDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryAngleAxisDescriptionMetadata.a == null) {
                CategoryAngleAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryAngleAxisDescriptionMetadata.c(CategoryAngleAxisDescriptionMetadata.a);
            }
            if (a.k(CategoryAngleAxisDescriptionMetadata.a)) {
                return;
            }
            a.ac(CategoryAngleAxisDescriptionMetadata.a);
        }
        static c(a) {
            CategoryAxisBaseDescriptionMetadata.c(a);
            a.item("StartAngleOffset", "Number:double");
            a.item("LabelMode", "ExportedType:string:AxisAngleLabelMode");
            a.item("LabelMode@names", "Auto;Center;ClosestPoint");
            a.item("Interval", "Number:double");
            a.item("ActualInterval", "Number:double");
            a.item("MinorInterval", "Number:double");
            a.item("ActualMinorInterval", "Number:double");
            a.item("ActualIntervalChangeRef", "EventRef::actualIntervalChange");
        }
        static d(a) {
            CategoryAngleAxisDescriptionMetadata.b(a);
            a.ae("CategoryAngleAxis", () => new CategoryAngleAxisDescription());
            a.ad("CategoryAngleAxis", CategoryAngleAxisDescriptionMetadata.a);
        }
    }
    CategoryAngleAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryAngleAxisDescriptionMetadata, 'CategoryAngleAxisDescriptionMetadata');
    CategoryAngleAxisDescriptionMetadata.a = null;
    return CategoryAngleAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryAngleAxisDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryAngleAxisDescriptionModule extends Base {
        static register(a) {
            CategoryAngleAxisDescriptionMetadata.d(a);
        }
    }
    CategoryAngleAxisDescriptionModule.$t = /*@__PURE__*/ markType(CategoryAngleAxisDescriptionModule, 'CategoryAngleAxisDescriptionModule');
    return CategoryAngleAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartRadialCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartRadialCoreDescriptionModule extends Base {
        static register(a) {
            CategoryAngleAxisDescriptionModule.register(a);
            NumericRadiusAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartRadialCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartRadialCoreDescriptionModule, 'DataChartRadialCoreDescriptionModule');
    return DataChartRadialCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialBaseDescriptionMetadata extends Base {
        static b(a) {
            if (RadialBaseDescriptionMetadata.a == null) {
                RadialBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialBaseDescriptionMetadata.c(RadialBaseDescriptionMetadata.a);
            }
            if (a.k(RadialBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(RadialBaseDescriptionMetadata.a);
            AssigningRadialStyleEventArgsDescriptionMetadata.d(a);
            AssigningRadialMarkerStyleEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            MarkerSeriesDescriptionMetadata.c(a);
            a.item("AutoCalloutLabelPrecision", "Number:int");
            a.item("AutoCalloutPercentagePrecision", "Number:int");
            a.item("AutoCalloutLabelValueSeparator", "String");
            a.item("LegendRadialLabelMode", "ExportedType:string:RadialLabelMode");
            a.item("LegendRadialLabelMode@names", "Auto;Normal;Value;Percentage;ValueAndPercentage;Label;LabelAndValue;LabelAndPercentage;LabelAndValueAndPercentage");
            a.item("AutoCalloutRadialLabelMode", "ExportedType:string:RadialLabelMode");
            a.item("AutoCalloutRadialLabelMode@names", "Auto;Normal;Value;Percentage;ValueAndPercentage;Label;LabelAndValue;LabelAndPercentage;LabelAndValueAndPercentage");
            a.item("AutoCalloutOthersLabelFormat", "String");
            a.item("AutoCalloutOthersLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("AutoCalloutOthersLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("ProportionalRadialLabelFormat", "String");
            a.item("ProportionalRadialLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("ProportionalRadialLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("LegendProportionalRadialLabelFormat", "String");
            a.item("LegendProportionalRadialLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LegendProportionalRadialLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("OthersProportionalRadialLabelFormat", "String");
            a.item("OthersProportionalRadialLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("OthersProportionalRadialLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("OthersLegendProportionalRadialLabelFormat", "String");
            a.item("OthersLegendProportionalRadialLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("OthersLegendProportionalRadialLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("IsCustomRadialStyleAllowed", "Boolean");
            a.item("IsCustomRadialMarkerStyleAllowed", "Boolean");
            a.item("TransitionInMode", "ExportedType:string:CategoryTransitionInMode");
            a.item("TransitionInMode@names", "Auto;FromZero;SweepFromLeft;SweepFromRight;SweepFromTop;SweepFromBottom;SweepFromCenter;AccordionFromLeft;AccordionFromRight;AccordionFromTop;AccordionFromBottom;Expand;SweepFromCategoryAxisMinimum;SweepFromCategoryAxisMaximum;SweepFromValueAxisMinimum;SweepFromValueAxisMaximum;AccordionFromCategoryAxisMinimum;AccordionFromCategoryAxisMaximum;AccordionFromValueAxisMinimum;AccordionFromValueAxisMaximum;FromParent");
            a.item("IsTransitionInEnabled", "Boolean");
            a.item("AngleAxisRef", "(w:AngleAxis,wf:AngleAxis)DataRef::object");
            a.item("AngleAxisRef@nameBinding", "true");
            a.item("ValueAxisRef", "(w:ValueAxis,wf:ValueAxis)DataRef::object");
            a.item("ValueAxisRef@nameBinding", "true");
            a.item("ClipSeriesToBounds", "Boolean");
            a.item("AssigningRadialStyleRef", "EventRef::assigningRadialStyle");
            a.item("AssigningRadialMarkerStyleRef", "EventRef::assigningRadialMarkerStyle");
        }
        static d(a) {
            RadialBaseDescriptionMetadata.b(a);
            a.ad("RadialBase", RadialBaseDescriptionMetadata.a);
        }
    }
    RadialBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialBaseDescriptionMetadata, 'RadialBaseDescriptionMetadata');
    RadialBaseDescriptionMetadata.a = null;
    return RadialBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnchoredRadialSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class AnchoredRadialSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (AnchoredRadialSeriesDescriptionMetadata.a == null) {
                AnchoredRadialSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AnchoredRadialSeriesDescriptionMetadata.c(AnchoredRadialSeriesDescriptionMetadata.a);
            }
            if (a.k(AnchoredRadialSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(AnchoredRadialSeriesDescriptionMetadata.a);
        }
        static c(a) {
            RadialBaseDescriptionMetadata.c(a);
            a.item("UseCategoryNormalizedValues", "Boolean");
            a.item("ValueMemberPath", "String");
            a.item("HighlightedValueMemberPath", "String");
            a.item("ValueMemberAsLegendLabel", "String");
            a.item("ValueMemberAsLegendUnit", "String");
            a.item("TrendLineType", "ExportedType:string:TrendLineType");
            a.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            a.item("TrendLineBrush", "Brush");
            a.item("ActualTrendLineBrush", "Brush");
            a.item("TrendLineThickness", "Number:double");
            a.item("TrendLineDashArray", "DoubleCollection:double");
            a.item("TrendLinePeriod", "Number:int");
            a.item("TrendLineZIndex", "Number:int");
        }
        static d(a) {
            AnchoredRadialSeriesDescriptionMetadata.b(a);
            a.ad("AnchoredRadialSeries", AnchoredRadialSeriesDescriptionMetadata.a);
        }
    }
    AnchoredRadialSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(AnchoredRadialSeriesDescriptionMetadata, 'AnchoredRadialSeriesDescriptionMetadata');
    AnchoredRadialSeriesDescriptionMetadata.a = null;
    return AnchoredRadialSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialBaseDescription = /*@__PURE__*/ (() => {
    class RadialBaseDescription extends MarkerSeriesDescription {
        get_type() {
            return "RadialBase";
        }
        constructor() {
            super();
            this.f5 = 0;
            this.f6 = 0;
            this.gc = null;
            this.gg = null;
            this.ge = null;
            this.gd = null;
            this.fn = null;
            this.gj = null;
            this.fr = null;
            this.gf = null;
            this.fo = null;
            this.gi = null;
            this.fq = null;
            this.gh = null;
            this.fp = null;
            this.fz = false;
            this.fy = false;
            this.gk = null;
            this.f0 = false;
            this.f9 = null;
            this.gl = null;
            this.fx = false;
            this.gb = null;
            this.ga = null;
        }
        get autoCalloutLabelPrecision() {
            return this.f5;
        }
        set autoCalloutLabelPrecision(a) {
            this.f5 = a;
            this.g("AutoCalloutLabelPrecision");
        }
        get autoCalloutPercentagePrecision() {
            return this.f6;
        }
        set autoCalloutPercentagePrecision(a) {
            this.f6 = a;
            this.g("AutoCalloutPercentagePrecision");
        }
        get autoCalloutLabelValueSeparator() {
            return this.gc;
        }
        set autoCalloutLabelValueSeparator(a) {
            this.gc = a;
            this.g("AutoCalloutLabelValueSeparator");
        }
        get legendRadialLabelMode() {
            return this.gg;
        }
        set legendRadialLabelMode(a) {
            this.gg = a;
            this.g("LegendRadialLabelMode");
        }
        get autoCalloutRadialLabelMode() {
            return this.ge;
        }
        set autoCalloutRadialLabelMode(a) {
            this.ge = a;
            this.g("AutoCalloutRadialLabelMode");
        }
        get autoCalloutOthersLabelFormat() {
            return this.gd;
        }
        set autoCalloutOthersLabelFormat(a) {
            this.gd = a;
            this.g("AutoCalloutOthersLabelFormat");
        }
        get autoCalloutOthersLabelFormatSpecifiers() {
            return this.fn;
        }
        set autoCalloutOthersLabelFormatSpecifiers(a) {
            this.fn = a;
            this.g("AutoCalloutOthersLabelFormatSpecifiers");
        }
        get proportionalRadialLabelFormat() {
            return this.gj;
        }
        set proportionalRadialLabelFormat(a) {
            this.gj = a;
            this.g("ProportionalRadialLabelFormat");
        }
        get proportionalRadialLabelFormatSpecifiers() {
            return this.fr;
        }
        set proportionalRadialLabelFormatSpecifiers(a) {
            this.fr = a;
            this.g("ProportionalRadialLabelFormatSpecifiers");
        }
        get legendProportionalRadialLabelFormat() {
            return this.gf;
        }
        set legendProportionalRadialLabelFormat(a) {
            this.gf = a;
            this.g("LegendProportionalRadialLabelFormat");
        }
        get legendProportionalRadialLabelFormatSpecifiers() {
            return this.fo;
        }
        set legendProportionalRadialLabelFormatSpecifiers(a) {
            this.fo = a;
            this.g("LegendProportionalRadialLabelFormatSpecifiers");
        }
        get othersProportionalRadialLabelFormat() {
            return this.gi;
        }
        set othersProportionalRadialLabelFormat(a) {
            this.gi = a;
            this.g("OthersProportionalRadialLabelFormat");
        }
        get othersProportionalRadialLabelFormatSpecifiers() {
            return this.fq;
        }
        set othersProportionalRadialLabelFormatSpecifiers(a) {
            this.fq = a;
            this.g("OthersProportionalRadialLabelFormatSpecifiers");
        }
        get othersLegendProportionalRadialLabelFormat() {
            return this.gh;
        }
        set othersLegendProportionalRadialLabelFormat(a) {
            this.gh = a;
            this.g("OthersLegendProportionalRadialLabelFormat");
        }
        get othersLegendProportionalRadialLabelFormatSpecifiers() {
            return this.fp;
        }
        set othersLegendProportionalRadialLabelFormatSpecifiers(a) {
            this.fp = a;
            this.g("OthersLegendProportionalRadialLabelFormatSpecifiers");
        }
        get isCustomRadialStyleAllowed() {
            return this.fz;
        }
        set isCustomRadialStyleAllowed(a) {
            this.fz = a;
            this.g("IsCustomRadialStyleAllowed");
        }
        get isCustomRadialMarkerStyleAllowed() {
            return this.fy;
        }
        set isCustomRadialMarkerStyleAllowed(a) {
            this.fy = a;
            this.g("IsCustomRadialMarkerStyleAllowed");
        }
        get transitionInMode() {
            return this.gk;
        }
        set transitionInMode(a) {
            this.gk = a;
            this.g("TransitionInMode");
        }
        get isTransitionInEnabled() {
            return this.f0;
        }
        set isTransitionInEnabled(a) {
            this.f0 = a;
            this.g("IsTransitionInEnabled");
        }
        get angleAxisRef() {
            return this.f9;
        }
        set angleAxisRef(a) {
            this.f9 = a;
            this.g("AngleAxisRef");
        }
        get valueAxisRef() {
            return this.gl;
        }
        set valueAxisRef(a) {
            this.gl = a;
            this.g("ValueAxisRef");
        }
        get clipSeriesToBounds() {
            return this.fx;
        }
        set clipSeriesToBounds(a) {
            this.fx = a;
            this.g("ClipSeriesToBounds");
        }
        get assigningRadialStyleRef() {
            return this.gb;
        }
        set assigningRadialStyleRef(a) {
            this.gb = a;
            this.g("AssigningRadialStyleRef");
        }
        get assigningRadialMarkerStyleRef() {
            return this.ga;
        }
        set assigningRadialMarkerStyleRef(a) {
            this.ga = a;
            this.g("AssigningRadialMarkerStyleRef");
        }
    }
    RadialBaseDescription.$t = /*@__PURE__*/ markType(RadialBaseDescription, 'RadialBaseDescription', MarkerSeriesDescription.$);
    return RadialBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnchoredRadialSeriesDescription = /*@__PURE__*/ (() => {
    class AnchoredRadialSeriesDescription extends RadialBaseDescription {
        get_type() {
            return "AnchoredRadialSeries";
        }
        constructor() {
            super();
            this.g1 = false;
            this.hf = null;
            this.ha = null;
            this.hd = null;
            this.he = null;
            this.hc = null;
            this.hb = null;
            this.g9 = null;
            this.g3 = 0;
            this.gz = null;
            this.g5 = 0;
            this.g6 = 0;
        }
        get useCategoryNormalizedValues() {
            return this.g1;
        }
        set useCategoryNormalizedValues(a) {
            this.g1 = a;
            this.g("UseCategoryNormalizedValues");
        }
        get valueMemberPath() {
            return this.hf;
        }
        set valueMemberPath(a) {
            this.hf = a;
            this.g("ValueMemberPath");
        }
        get highlightedValueMemberPath() {
            return this.ha;
        }
        set highlightedValueMemberPath(a) {
            this.ha = a;
            this.g("HighlightedValueMemberPath");
        }
        get valueMemberAsLegendLabel() {
            return this.hd;
        }
        set valueMemberAsLegendLabel(a) {
            this.hd = a;
            this.g("ValueMemberAsLegendLabel");
        }
        get valueMemberAsLegendUnit() {
            return this.he;
        }
        set valueMemberAsLegendUnit(a) {
            this.he = a;
            this.g("ValueMemberAsLegendUnit");
        }
        get trendLineType() {
            return this.hc;
        }
        set trendLineType(a) {
            this.hc = a;
            this.g("TrendLineType");
        }
        get trendLineBrush() {
            return this.hb;
        }
        set trendLineBrush(a) {
            this.hb = a;
            this.g("TrendLineBrush");
        }
        get actualTrendLineBrush() {
            return this.g9;
        }
        set actualTrendLineBrush(a) {
            this.g9 = a;
            this.g("ActualTrendLineBrush");
        }
        get trendLineThickness() {
            return this.g3;
        }
        set trendLineThickness(a) {
            this.g3 = a;
            this.g("TrendLineThickness");
        }
        get trendLineDashArray() {
            return this.gz;
        }
        set trendLineDashArray(a) {
            this.gz = a;
            this.g("TrendLineDashArray");
        }
        get trendLinePeriod() {
            return this.g5;
        }
        set trendLinePeriod(a) {
            this.g5 = a;
            this.g("TrendLinePeriod");
        }
        get trendLineZIndex() {
            return this.g6;
        }
        set trendLineZIndex(a) {
            this.g6 = a;
            this.g("TrendLineZIndex");
        }
    }
    AnchoredRadialSeriesDescription.$t = /*@__PURE__*/ markType(AnchoredRadialSeriesDescription, 'AnchoredRadialSeriesDescription', RadialBaseDescription.$);
    return AnchoredRadialSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialAreaSeriesDescription = /*@__PURE__*/ (() => {
    class RadialAreaSeriesDescription extends AnchoredRadialSeriesDescription {
        get_type() {
            return "RadialAreaSeries";
        }
        constructor() {
            super();
            this.hn = null;
        }
        get unknownValuePlotting() {
            return this.hn;
        }
        set unknownValuePlotting(a) {
            this.hn = a;
            this.g("UnknownValuePlotting");
        }
    }
    RadialAreaSeriesDescription.$t = /*@__PURE__*/ markType(RadialAreaSeriesDescription, 'RadialAreaSeriesDescription', AnchoredRadialSeriesDescription.$);
    return RadialAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RadialAreaSeriesDescriptionMetadata.a == null) {
                RadialAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialAreaSeriesDescriptionMetadata.c(RadialAreaSeriesDescriptionMetadata.a);
            }
            if (a.k(RadialAreaSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(RadialAreaSeriesDescriptionMetadata.a);
        }
        static c(a) {
            AnchoredRadialSeriesDescriptionMetadata.c(a);
            a.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            a.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
        }
        static d(a) {
            RadialAreaSeriesDescriptionMetadata.b(a);
            a.ae("RadialAreaSeries", () => new RadialAreaSeriesDescription());
            a.ad("RadialAreaSeries", RadialAreaSeriesDescriptionMetadata.a);
        }
    }
    RadialAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialAreaSeriesDescriptionMetadata, 'RadialAreaSeriesDescriptionMetadata');
    RadialAreaSeriesDescriptionMetadata.a = null;
    return RadialAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class RadialAreaSeriesDescriptionModule extends Base {
        static register(a) {
            RadialAreaSeriesDescriptionMetadata.d(a);
        }
    }
    RadialAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(RadialAreaSeriesDescriptionModule, 'RadialAreaSeriesDescriptionModule');
    return RadialAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialColumnSeriesDescription = /*@__PURE__*/ (() => {
    class RadialColumnSeriesDescription extends AnchoredRadialSeriesDescription {
        get_type() {
            return "RadialColumnSeries";
        }
        constructor() {
            super();
            this.hn = 0;
            this.ho = 0;
        }
        get radiusX() {
            return this.hn;
        }
        set radiusX(a) {
            this.hn = a;
            this.g("RadiusX");
        }
        get radiusY() {
            return this.ho;
        }
        set radiusY(a) {
            this.ho = a;
            this.g("RadiusY");
        }
    }
    RadialColumnSeriesDescription.$t = /*@__PURE__*/ markType(RadialColumnSeriesDescription, 'RadialColumnSeriesDescription', AnchoredRadialSeriesDescription.$);
    return RadialColumnSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialColumnSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialColumnSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RadialColumnSeriesDescriptionMetadata.a == null) {
                RadialColumnSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialColumnSeriesDescriptionMetadata.c(RadialColumnSeriesDescriptionMetadata.a);
            }
            if (a.k(RadialColumnSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(RadialColumnSeriesDescriptionMetadata.a);
        }
        static c(a) {
            AnchoredRadialSeriesDescriptionMetadata.c(a);
            a.item("RadiusX", "Number:double");
            a.item("RadiusY", "Number:double");
        }
        static d(a) {
            RadialColumnSeriesDescriptionMetadata.b(a);
            a.ae("RadialColumnSeries", () => new RadialColumnSeriesDescription());
            a.ad("RadialColumnSeries", RadialColumnSeriesDescriptionMetadata.a);
        }
    }
    RadialColumnSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialColumnSeriesDescriptionMetadata, 'RadialColumnSeriesDescriptionMetadata');
    RadialColumnSeriesDescriptionMetadata.a = null;
    return RadialColumnSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialColumnSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class RadialColumnSeriesDescriptionModule extends Base {
        static register(a) {
            RadialColumnSeriesDescriptionMetadata.d(a);
        }
    }
    RadialColumnSeriesDescriptionModule.$t = /*@__PURE__*/ markType(RadialColumnSeriesDescriptionModule, 'RadialColumnSeriesDescriptionModule');
    return RadialColumnSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialLineSeriesDescription = /*@__PURE__*/ (() => {
    class RadialLineSeriesDescription extends AnchoredRadialSeriesDescription {
        get_type() {
            return "RadialLineSeries";
        }
        constructor() {
            super();
            this.hn = null;
        }
        get unknownValuePlotting() {
            return this.hn;
        }
        set unknownValuePlotting(a) {
            this.hn = a;
            this.g("UnknownValuePlotting");
        }
    }
    RadialLineSeriesDescription.$t = /*@__PURE__*/ markType(RadialLineSeriesDescription, 'RadialLineSeriesDescription', AnchoredRadialSeriesDescription.$);
    return RadialLineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialLineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialLineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RadialLineSeriesDescriptionMetadata.a == null) {
                RadialLineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialLineSeriesDescriptionMetadata.c(RadialLineSeriesDescriptionMetadata.a);
            }
            if (a.k(RadialLineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(RadialLineSeriesDescriptionMetadata.a);
        }
        static c(a) {
            AnchoredRadialSeriesDescriptionMetadata.c(a);
            a.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            a.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
        }
        static d(a) {
            RadialLineSeriesDescriptionMetadata.b(a);
            a.ae("RadialLineSeries", () => new RadialLineSeriesDescription());
            a.ad("RadialLineSeries", RadialLineSeriesDescriptionMetadata.a);
        }
    }
    RadialLineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialLineSeriesDescriptionMetadata, 'RadialLineSeriesDescriptionMetadata');
    RadialLineSeriesDescriptionMetadata.a = null;
    return RadialLineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialLineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class RadialLineSeriesDescriptionModule extends Base {
        static register(a) {
            RadialLineSeriesDescriptionMetadata.d(a);
        }
    }
    RadialLineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(RadialLineSeriesDescriptionModule, 'RadialLineSeriesDescriptionModule');
    return RadialLineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialPieSeriesDescription = /*@__PURE__*/ (() => {
    class RadialPieSeriesDescription extends AnchoredRadialSeriesDescription {
        get_type() {
            return "RadialPieSeries";
        }
        constructor() {
            super();
            this.hn = 0;
            this.ho = 0;
        }
        get radiusX() {
            return this.hn;
        }
        set radiusX(a) {
            this.hn = a;
            this.g("RadiusX");
        }
        get radiusY() {
            return this.ho;
        }
        set radiusY(a) {
            this.ho = a;
            this.g("RadiusY");
        }
    }
    RadialPieSeriesDescription.$t = /*@__PURE__*/ markType(RadialPieSeriesDescription, 'RadialPieSeriesDescription', AnchoredRadialSeriesDescription.$);
    return RadialPieSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialPieSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialPieSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RadialPieSeriesDescriptionMetadata.a == null) {
                RadialPieSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialPieSeriesDescriptionMetadata.c(RadialPieSeriesDescriptionMetadata.a);
            }
            if (a.k(RadialPieSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(RadialPieSeriesDescriptionMetadata.a);
        }
        static c(a) {
            AnchoredRadialSeriesDescriptionMetadata.c(a);
            a.item("RadiusX", "Number:double");
            a.item("RadiusY", "Number:double");
        }
        static d(a) {
            RadialPieSeriesDescriptionMetadata.b(a);
            a.ae("RadialPieSeries", () => new RadialPieSeriesDescription());
            a.ad("RadialPieSeries", RadialPieSeriesDescriptionMetadata.a);
        }
    }
    RadialPieSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialPieSeriesDescriptionMetadata, 'RadialPieSeriesDescriptionMetadata');
    RadialPieSeriesDescriptionMetadata.a = null;
    return RadialPieSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialPieSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class RadialPieSeriesDescriptionModule extends Base {
        static register(a) {
            RadialPieSeriesDescriptionMetadata.d(a);
        }
    }
    RadialPieSeriesDescriptionModule.$t = /*@__PURE__*/ markType(RadialPieSeriesDescriptionModule, 'RadialPieSeriesDescriptionModule');
    return RadialPieSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartRadialDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartRadialDescriptionModule extends Base {
        static register(a) {
            RadialAreaSeriesDescriptionModule.register(a);
            RadialColumnSeriesDescriptionModule.register(a);
            RadialLineSeriesDescriptionModule.register(a);
            RadialPieSeriesDescriptionModule.register(a);
            DataChartRadialCoreDescriptionModule.register(a);
        }
    }
    DataChartRadialDescriptionModule.$t = /*@__PURE__*/ markType(DataChartRadialDescriptionModule, 'DataChartRadialDescriptionModule');
    return DataChartRadialDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericXAxisDescription = /*@__PURE__*/ (() => {
    class NumericXAxisDescription extends StraightNumericAxisBaseDescription {
        get_type() {
            return "NumericXAxis";
        }
        constructor() {
            super();
        }
    }
    NumericXAxisDescription.$t = /*@__PURE__*/ markType(NumericXAxisDescription, 'NumericXAxisDescription', StraightNumericAxisBaseDescription.$);
    return NumericXAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericXAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumericXAxisDescriptionMetadata extends Base {
        static b(a) {
            if (NumericXAxisDescriptionMetadata.a == null) {
                NumericXAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumericXAxisDescriptionMetadata.c(NumericXAxisDescriptionMetadata.a);
            }
            if (a.k(NumericXAxisDescriptionMetadata.a)) {
                return;
            }
            a.ac(NumericXAxisDescriptionMetadata.a);
        }
        static c(a) {
            StraightNumericAxisBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            NumericXAxisDescriptionMetadata.b(a);
            a.ae("NumericXAxis", () => new NumericXAxisDescription());
            a.ad("NumericXAxis", NumericXAxisDescriptionMetadata.a);
        }
    }
    NumericXAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(NumericXAxisDescriptionMetadata, 'NumericXAxisDescriptionMetadata');
    NumericXAxisDescriptionMetadata.a = null;
    return NumericXAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericXAxisDescriptionModule = /*@__PURE__*/ (() => {
    class NumericXAxisDescriptionModule extends Base {
        static register(a) {
            NumericXAxisDescriptionMetadata.d(a);
        }
    }
    NumericXAxisDescriptionModule.$t = /*@__PURE__*/ markType(NumericXAxisDescriptionModule, 'NumericXAxisDescriptionModule');
    return NumericXAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartScatterCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartScatterCoreDescriptionModule extends Base {
        static register(a) {
            NumericXAxisDescriptionModule.register(a);
            NumericYAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartScatterCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartScatterCoreDescriptionModule, 'DataChartScatterCoreDescriptionModule');
    return DataChartScatterCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyUpdatedEventArgsDescription = /*@__PURE__*/ (() => {
    class PropertyUpdatedEventArgsDescription extends Description {
        get_type() {
            return "PropertyUpdatedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.i = null;
            this.h = null;
        }
        get propertyName() {
            return this.j;
        }
        set propertyName(a) {
            this.j = a;
            this.g("PropertyName");
        }
        get oldValueRef() {
            return this.i;
        }
        set oldValueRef(a) {
            this.i = a;
            this.g("OldValueRef");
        }
        get newValueRef() {
            return this.h;
        }
        set newValueRef(a) {
            this.h = a;
            this.g("NewValueRef");
        }
    }
    PropertyUpdatedEventArgsDescription.$t = /*@__PURE__*/ markType(PropertyUpdatedEventArgsDescription, 'PropertyUpdatedEventArgsDescription', Description.$);
    return PropertyUpdatedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyUpdatedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyUpdatedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyUpdatedEventArgsDescriptionMetadata.a == null) {
                PropertyUpdatedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyUpdatedEventArgsDescriptionMetadata.c(PropertyUpdatedEventArgsDescriptionMetadata.a);
            }
            if (a.k(PropertyUpdatedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(PropertyUpdatedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("PropertyName", "String");
            a.item("OldValueRef", "(w:OldValue,wf:OldValue)DataRef");
            a.item("NewValueRef", "(w:NewValue,wf:NewValue)DataRef");
        }
        static d(a) {
            PropertyUpdatedEventArgsDescriptionMetadata.b(a);
            a.ae("PropertyUpdatedEventArgs", () => new PropertyUpdatedEventArgsDescription());
            a.ad("PropertyUpdatedEventArgs", PropertyUpdatedEventArgsDescriptionMetadata.a);
        }
    }
    PropertyUpdatedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyUpdatedEventArgsDescriptionMetadata, 'PropertyUpdatedEventArgsDescriptionMetadata');
    PropertyUpdatedEventArgsDescriptionMetadata.a = null;
    return PropertyUpdatedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SizeScaleDescription = /*@__PURE__*/ (() => {
    class SizeScaleDescription extends Description {
        get_type() {
            return "SizeScale";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = 0;
            this.j = 0;
            this.m = 0;
            this.l = 0;
            this.h = false;
            this.r = 0;
            this.t = null;
        }
        get globalMinimum() {
            return this.k;
        }
        set globalMinimum(a) {
            this.k = a;
            this.g("GlobalMinimum");
        }
        get globalMaximum() {
            return this.j;
        }
        set globalMaximum(a) {
            this.j = a;
            this.g("GlobalMaximum");
        }
        get minimumValue() {
            return this.m;
        }
        set minimumValue(a) {
            this.m = a;
            this.g("MinimumValue");
        }
        get maximumValue() {
            return this.l;
        }
        set maximumValue(a) {
            this.l = a;
            this.g("MaximumValue");
        }
        get isLogarithmic() {
            return this.h;
        }
        set isLogarithmic(a) {
            this.h = a;
            this.g("IsLogarithmic");
        }
        get logarithmBase() {
            return this.r;
        }
        set logarithmBase(a) {
            this.r = a;
            this.g("LogarithmBase");
        }
        get propertyUpdatedRef() {
            return this.t;
        }
        set propertyUpdatedRef(a) {
            this.t = a;
            this.g("PropertyUpdatedRef");
        }
    }
    SizeScaleDescription.$t = /*@__PURE__*/ markType(SizeScaleDescription, 'SizeScaleDescription', Description.$);
    return SizeScaleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SizeScaleDescriptionMetadata = /*@__PURE__*/ (() => {
    class SizeScaleDescriptionMetadata extends Base {
        static b(a) {
            if (SizeScaleDescriptionMetadata.a == null) {
                SizeScaleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SizeScaleDescriptionMetadata.c(SizeScaleDescriptionMetadata.a);
            }
            if (a.k(SizeScaleDescriptionMetadata.a)) {
                return;
            }
            a.ac(SizeScaleDescriptionMetadata.a);
            PropertyUpdatedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("GlobalMinimum", "Number:double");
            a.item("GlobalMaximum", "Number:double");
            a.item("MinimumValue", "Number:double");
            a.item("MaximumValue", "Number:double");
            a.item("IsLogarithmic", "Boolean");
            a.item("LogarithmBase", "Number:int");
            a.item("PropertyUpdatedRef", "EventRef::propertyUpdated");
        }
        static d(a) {
            SizeScaleDescriptionMetadata.b(a);
            a.ae("SizeScale", () => new SizeScaleDescription());
            a.ad("SizeScale", SizeScaleDescriptionMetadata.a);
        }
    }
    SizeScaleDescriptionMetadata.$t = /*@__PURE__*/ markType(SizeScaleDescriptionMetadata, 'SizeScaleDescriptionMetadata');
    SizeScaleDescriptionMetadata.a = null;
    return SizeScaleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SizeScaleDescriptionModule = /*@__PURE__*/ (() => {
    class SizeScaleDescriptionModule extends Base {
        static register(a) {
            SizeScaleDescriptionMetadata.d(a);
        }
    }
    SizeScaleDescriptionModule.$t = /*@__PURE__*/ markType(SizeScaleDescriptionModule, 'SizeScaleDescriptionModule');
    return SizeScaleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushScaleDescription = /*@__PURE__*/ (() => {
    class BrushScaleDescription extends Description {
        get_type() {
            return "BrushScale";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = null;
        }
        get brushes() {
            return this.h;
        }
        set brushes(a) {
            this.h = a;
            this.g("Brushes");
        }
        get propertyUpdatedRef() {
            return this.j;
        }
        set propertyUpdatedRef(a) {
            this.j = a;
            this.g("PropertyUpdatedRef");
        }
    }
    BrushScaleDescription.$t = /*@__PURE__*/ markType(BrushScaleDescription, 'BrushScaleDescription', Description.$);
    return BrushScaleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushScaleDescriptionMetadata = /*@__PURE__*/ (() => {
    class BrushScaleDescriptionMetadata extends Base {
        static b(a) {
            if (BrushScaleDescriptionMetadata.a == null) {
                BrushScaleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BrushScaleDescriptionMetadata.c(BrushScaleDescriptionMetadata.a);
            }
            if (a.k(BrushScaleDescriptionMetadata.a)) {
                return;
            }
            a.ac(BrushScaleDescriptionMetadata.a);
            PropertyUpdatedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Brushes", "BrushCollection:string");
            a.item("PropertyUpdatedRef", "EventRef::propertyUpdated");
        }
        static d(a) {
            BrushScaleDescriptionMetadata.b(a);
            a.ae("BrushScale", () => new BrushScaleDescription());
            a.ad("BrushScale", BrushScaleDescriptionMetadata.a);
        }
    }
    BrushScaleDescriptionMetadata.$t = /*@__PURE__*/ markType(BrushScaleDescriptionMetadata, 'BrushScaleDescriptionMetadata');
    BrushScaleDescriptionMetadata.a = null;
    return BrushScaleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushScaleDescriptionModule = /*@__PURE__*/ (() => {
    class BrushScaleDescriptionModule extends Base {
        static register(a) {
            BrushScaleDescriptionMetadata.d(a);
        }
    }
    BrushScaleDescriptionModule.$t = /*@__PURE__*/ markType(BrushScaleDescriptionModule, 'BrushScaleDescriptionModule');
    return BrushScaleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueBrushScaleDescription = /*@__PURE__*/ (() => {
    class ValueBrushScaleDescription extends BrushScaleDescription {
        get_type() {
            return "ValueBrushScale";
        }
        constructor() {
            super();
            this.p = 0;
            this.o = 0;
            this.m = false;
            this.s = 0;
        }
        get minimumValue() {
            return this.p;
        }
        set minimumValue(a) {
            this.p = a;
            this.g("MinimumValue");
        }
        get maximumValue() {
            return this.o;
        }
        set maximumValue(a) {
            this.o = a;
            this.g("MaximumValue");
        }
        get isLogarithmic() {
            return this.m;
        }
        set isLogarithmic(a) {
            this.m = a;
            this.g("IsLogarithmic");
        }
        get logarithmBase() {
            return this.s;
        }
        set logarithmBase(a) {
            this.s = a;
            this.g("LogarithmBase");
        }
    }
    ValueBrushScaleDescription.$t = /*@__PURE__*/ markType(ValueBrushScaleDescription, 'ValueBrushScaleDescription', BrushScaleDescription.$);
    return ValueBrushScaleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueBrushScaleDescriptionMetadata = /*@__PURE__*/ (() => {
    class ValueBrushScaleDescriptionMetadata extends Base {
        static b(a) {
            if (ValueBrushScaleDescriptionMetadata.a == null) {
                ValueBrushScaleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ValueBrushScaleDescriptionMetadata.c(ValueBrushScaleDescriptionMetadata.a);
            }
            if (a.k(ValueBrushScaleDescriptionMetadata.a)) {
                return;
            }
            a.ac(ValueBrushScaleDescriptionMetadata.a);
        }
        static c(a) {
            BrushScaleDescriptionMetadata.c(a);
            a.item("MinimumValue", "Number:double");
            a.item("MaximumValue", "Number:double");
            a.item("IsLogarithmic", "Boolean");
            a.item("LogarithmBase", "Number:int");
        }
        static d(a) {
            ValueBrushScaleDescriptionMetadata.b(a);
            a.ae("ValueBrushScale", () => new ValueBrushScaleDescription());
            a.ad("ValueBrushScale", ValueBrushScaleDescriptionMetadata.a);
        }
    }
    ValueBrushScaleDescriptionMetadata.$t = /*@__PURE__*/ markType(ValueBrushScaleDescriptionMetadata, 'ValueBrushScaleDescriptionMetadata');
    ValueBrushScaleDescriptionMetadata.a = null;
    return ValueBrushScaleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueBrushScaleDescriptionModule = /*@__PURE__*/ (() => {
    class ValueBrushScaleDescriptionModule extends Base {
        static register(a) {
            BrushScaleDescriptionModule.register(a);
            ValueBrushScaleDescriptionMetadata.d(a);
        }
    }
    ValueBrushScaleDescriptionModule.$t = /*@__PURE__*/ markType(ValueBrushScaleDescriptionModule, 'ValueBrushScaleDescriptionModule');
    return ValueBrushScaleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColorScaleDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColorScaleDescriptionMetadata extends Base {
        static b(a) {
            if (ColorScaleDescriptionMetadata.a == null) {
                ColorScaleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColorScaleDescriptionMetadata.c(ColorScaleDescriptionMetadata.a);
            }
            if (a.k(ColorScaleDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColorScaleDescriptionMetadata.a);
            PropertyUpdatedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("PropertyUpdatedRef", "EventRef::propertyUpdated");
        }
        static d(a) {
            ColorScaleDescriptionMetadata.b(a);
            a.ad("ColorScale", ColorScaleDescriptionMetadata.a);
        }
    }
    ColorScaleDescriptionMetadata.$t = /*@__PURE__*/ markType(ColorScaleDescriptionMetadata, 'ColorScaleDescriptionMetadata');
    ColorScaleDescriptionMetadata.a = null;
    return ColorScaleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColorScaleDescription = /*@__PURE__*/ (() => {
    class ColorScaleDescription extends Description {
        get_type() {
            return "ColorScale";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get propertyUpdatedRef() {
            return this.h;
        }
        set propertyUpdatedRef(a) {
            this.h = a;
            this.g("PropertyUpdatedRef");
        }
    }
    ColorScaleDescription.$t = /*@__PURE__*/ markType(ColorScaleDescription, 'ColorScaleDescription', Description.$);
    return ColorScaleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomPaletteColorScaleDescription = /*@__PURE__*/ (() => {
    class CustomPaletteColorScaleDescription extends ColorScaleDescription {
        get_type() {
            return "CustomPaletteColorScale";
        }
        constructor() {
            super();
            this.n = 0;
            this.m = 0;
            this.k = null;
            this.q = null;
        }
        get minimumValue() {
            return this.n;
        }
        set minimumValue(a) {
            this.n = a;
            this.g("MinimumValue");
        }
        get maximumValue() {
            return this.m;
        }
        set maximumValue(a) {
            this.m = a;
            this.g("MaximumValue");
        }
        get palette() {
            return this.k;
        }
        set palette(a) {
            this.k = a;
            this.g("Palette");
        }
        get interpolationMode() {
            return this.q;
        }
        set interpolationMode(a) {
            this.q = a;
            this.g("InterpolationMode");
        }
    }
    CustomPaletteColorScaleDescription.$t = /*@__PURE__*/ markType(CustomPaletteColorScaleDescription, 'CustomPaletteColorScaleDescription', ColorScaleDescription.$);
    return CustomPaletteColorScaleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomPaletteColorScaleDescriptionMetadata = /*@__PURE__*/ (() => {
    class CustomPaletteColorScaleDescriptionMetadata extends Base {
        static b(a) {
            if (CustomPaletteColorScaleDescriptionMetadata.a == null) {
                CustomPaletteColorScaleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CustomPaletteColorScaleDescriptionMetadata.c(CustomPaletteColorScaleDescriptionMetadata.a);
            }
            if (a.k(CustomPaletteColorScaleDescriptionMetadata.a)) {
                return;
            }
            a.ac(CustomPaletteColorScaleDescriptionMetadata.a);
        }
        static c(a) {
            ColorScaleDescriptionMetadata.c(a);
            a.item("MinimumValue", "Number:double");
            a.item("MaximumValue", "Number:double");
            a.item("Palette", "ColorCollection:string");
            a.item("InterpolationMode", "ExportedType:string:ColorScaleInterpolationMode");
            a.item("InterpolationMode@names", "Select;InterpolateRGB;InterpolateHSV");
        }
        static d(a) {
            CustomPaletteColorScaleDescriptionMetadata.b(a);
            a.ae("CustomPaletteColorScale", () => new CustomPaletteColorScaleDescription());
            a.ad("CustomPaletteColorScale", CustomPaletteColorScaleDescriptionMetadata.a);
        }
    }
    CustomPaletteColorScaleDescriptionMetadata.$t = /*@__PURE__*/ markType(CustomPaletteColorScaleDescriptionMetadata, 'CustomPaletteColorScaleDescriptionMetadata');
    CustomPaletteColorScaleDescriptionMetadata.a = null;
    return CustomPaletteColorScaleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomPaletteColorScaleDescriptionModule = /*@__PURE__*/ (() => {
    class CustomPaletteColorScaleDescriptionModule extends Base {
        static register(a) {
            CustomPaletteColorScaleDescriptionMetadata.d(a);
        }
    }
    CustomPaletteColorScaleDescriptionModule.$t = /*@__PURE__*/ markType(CustomPaletteColorScaleDescriptionModule, 'CustomPaletteColorScaleDescriptionModule');
    return CustomPaletteColorScaleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterBaseDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterBaseDescriptionMetadata.a == null) {
                ScatterBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterBaseDescriptionMetadata.c(ScatterBaseDescriptionMetadata.a);
            }
            if (a.k(ScatterBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(ScatterBaseDescriptionMetadata.a);
            AssigningScatterStyleEventArgsDescriptionMetadata.d(a);
            AssigningScatterMarkerStyleEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            MarkerSeriesDescriptionMetadata.c(a);
            a.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            a.item("XAxisRef@nameBinding", "true");
            a.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            a.item("YAxisRef@nameBinding", "true");
            a.item("XMemberPath", "String");
            a.item("YMemberPath", "String");
            a.item("HighlightedXMemberPath", "String");
            a.item("HighlightedYMemberPath", "String");
            a.item("XMemberAsLegendLabel", "String");
            a.item("YMemberAsLegendLabel", "String");
            a.item("XMemberAsLegendUnit", "String");
            a.item("YMemberAsLegendUnit", "String");
            a.item("TrendLineType", "ExportedType:string:TrendLineType");
            a.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            a.item("TrendLineBrush", "Brush");
            a.item("ActualTrendLineBrush", "Brush");
            a.item("TrendLineThickness", "Number:double");
            a.item("TrendLineDashArray", "DoubleCollection:double");
            a.item("TrendLinePeriod", "Number:int");
            a.item("MarkerCollisionAvoidance", "ExportedType:string:CollisionAvoidanceType");
            a.item("MarkerCollisionAvoidance@names", "None;Omit;Fade;OmitAndShift;FadeAndShift");
            a.item("TrendLineZIndex", "Number:int");
            a.item("MaximumMarkers", "Number:int");
            a.item("ItemSearchMode", "ExportedType:string:ScatterItemSearchMode");
            a.item("ItemSearchMode@names", "Auto;ClosestVisiblePoint;ClosestPoint;ClosestVisiblePointOnClosestLine;ClosestPointOnClosestLine;None");
            a.item("ItemSearchThreshold", "Number:int");
            a.item("ActualItemSearchMode", "ExportedType:string:ScatterItemSearchMode");
            a.item("ActualItemSearchMode@names", "Auto;ClosestVisiblePoint;ClosestPoint;ClosestVisiblePointOnClosestLine;ClosestPointOnClosestLine;None");
            a.item("IsCustomScatterStyleAllowed", "Boolean");
            a.item("IsCustomScatterMarkerStyleAllowed", "Boolean");
            a.item("AssigningScatterStyleRef", "EventRef::assigningScatterStyle");
            a.item("AssigningScatterMarkerStyleRef", "EventRef::assigningScatterMarkerStyle");
        }
        static d(a) {
            ScatterBaseDescriptionMetadata.b(a);
            a.ad("ScatterBase", ScatterBaseDescriptionMetadata.a);
        }
    }
    ScatterBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterBaseDescriptionMetadata, 'ScatterBaseDescriptionMetadata');
    ScatterBaseDescriptionMetadata.a = null;
    return ScatterBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterBaseDescription = /*@__PURE__*/ (() => {
    class ScatterBaseDescription extends MarkerSeriesDescription {
        get_type() {
            return "ScatterBase";
        }
        constructor() {
            super();
            this.gd = null;
            this.gh = null;
            this.gg = null;
            this.gk = null;
            this.f7 = null;
            this.f8 = null;
            this.ge = null;
            this.gi = null;
            this.gf = null;
            this.gj = null;
            this.gc = null;
            this.gb = null;
            this.f4 = null;
            this.ft = 0;
            this.fn = null;
            this.fx = 0;
            this.ga = null;
            this.fy = 0;
            this.fw = 0;
            this.f9 = null;
            this.fv = 0;
            this.f3 = null;
            this.fq = false;
            this.fp = false;
            this.f6 = null;
            this.f5 = null;
        }
        get xAxisRef() {
            return this.gd;
        }
        set xAxisRef(a) {
            this.gd = a;
            this.g("XAxisRef");
        }
        get yAxisRef() {
            return this.gh;
        }
        set yAxisRef(a) {
            this.gh = a;
            this.g("YAxisRef");
        }
        get xMemberPath() {
            return this.gg;
        }
        set xMemberPath(a) {
            this.gg = a;
            this.g("XMemberPath");
        }
        get yMemberPath() {
            return this.gk;
        }
        set yMemberPath(a) {
            this.gk = a;
            this.g("YMemberPath");
        }
        get highlightedXMemberPath() {
            return this.f7;
        }
        set highlightedXMemberPath(a) {
            this.f7 = a;
            this.g("HighlightedXMemberPath");
        }
        get highlightedYMemberPath() {
            return this.f8;
        }
        set highlightedYMemberPath(a) {
            this.f8 = a;
            this.g("HighlightedYMemberPath");
        }
        get xMemberAsLegendLabel() {
            return this.ge;
        }
        set xMemberAsLegendLabel(a) {
            this.ge = a;
            this.g("XMemberAsLegendLabel");
        }
        get yMemberAsLegendLabel() {
            return this.gi;
        }
        set yMemberAsLegendLabel(a) {
            this.gi = a;
            this.g("YMemberAsLegendLabel");
        }
        get xMemberAsLegendUnit() {
            return this.gf;
        }
        set xMemberAsLegendUnit(a) {
            this.gf = a;
            this.g("XMemberAsLegendUnit");
        }
        get yMemberAsLegendUnit() {
            return this.gj;
        }
        set yMemberAsLegendUnit(a) {
            this.gj = a;
            this.g("YMemberAsLegendUnit");
        }
        get trendLineType() {
            return this.gc;
        }
        set trendLineType(a) {
            this.gc = a;
            this.g("TrendLineType");
        }
        get trendLineBrush() {
            return this.gb;
        }
        set trendLineBrush(a) {
            this.gb = a;
            this.g("TrendLineBrush");
        }
        get actualTrendLineBrush() {
            return this.f4;
        }
        set actualTrendLineBrush(a) {
            this.f4 = a;
            this.g("ActualTrendLineBrush");
        }
        get trendLineThickness() {
            return this.ft;
        }
        set trendLineThickness(a) {
            this.ft = a;
            this.g("TrendLineThickness");
        }
        get trendLineDashArray() {
            return this.fn;
        }
        set trendLineDashArray(a) {
            this.fn = a;
            this.g("TrendLineDashArray");
        }
        get trendLinePeriod() {
            return this.fx;
        }
        set trendLinePeriod(a) {
            this.fx = a;
            this.g("TrendLinePeriod");
        }
        get markerCollisionAvoidance() {
            return this.ga;
        }
        set markerCollisionAvoidance(a) {
            this.ga = a;
            this.g("MarkerCollisionAvoidance");
        }
        get trendLineZIndex() {
            return this.fy;
        }
        set trendLineZIndex(a) {
            this.fy = a;
            this.g("TrendLineZIndex");
        }
        get maximumMarkers() {
            return this.fw;
        }
        set maximumMarkers(a) {
            this.fw = a;
            this.g("MaximumMarkers");
        }
        get itemSearchMode() {
            return this.f9;
        }
        set itemSearchMode(a) {
            this.f9 = a;
            this.g("ItemSearchMode");
        }
        get itemSearchThreshold() {
            return this.fv;
        }
        set itemSearchThreshold(a) {
            this.fv = a;
            this.g("ItemSearchThreshold");
        }
        get actualItemSearchMode() {
            return this.f3;
        }
        set actualItemSearchMode(a) {
            this.f3 = a;
            this.g("ActualItemSearchMode");
        }
        get isCustomScatterStyleAllowed() {
            return this.fq;
        }
        set isCustomScatterStyleAllowed(a) {
            this.fq = a;
            this.g("IsCustomScatterStyleAllowed");
        }
        get isCustomScatterMarkerStyleAllowed() {
            return this.fp;
        }
        set isCustomScatterMarkerStyleAllowed(a) {
            this.fp = a;
            this.g("IsCustomScatterMarkerStyleAllowed");
        }
        get assigningScatterStyleRef() {
            return this.f6;
        }
        set assigningScatterStyleRef(a) {
            this.f6 = a;
            this.g("AssigningScatterStyleRef");
        }
        get assigningScatterMarkerStyleRef() {
            return this.f5;
        }
        set assigningScatterMarkerStyleRef(a) {
            this.f5 = a;
            this.g("AssigningScatterMarkerStyleRef");
        }
    }
    ScatterBaseDescription.$t = /*@__PURE__*/ markType(ScatterBaseDescription, 'ScatterBaseDescription', MarkerSeriesDescription.$);
    return ScatterBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BubbleSeriesDescription = /*@__PURE__*/ (() => {
    class BubbleSeriesDescription extends ScatterBaseDescription {
        get_type() {
            return "BubbleSeries";
        }
        constructor() {
            super();
            this.hn = null;
            this.g5 = null;
            this.hk = null;
            this.hj = null;
            this.g3 = null;
            this.g7 = false;
            this.g8 = false;
            this.he = 0;
            this.hd = 0;
            this.g9 = false;
            this.hl = null;
            this.hh = null;
            this.hm = null;
            this.hi = null;
        }
        get radiusMemberPath() {
            return this.hn;
        }
        set radiusMemberPath(a) {
            this.hn = a;
            this.g("RadiusMemberPath");
        }
        get radiusScale() {
            return this.g5;
        }
        set radiusScale(a) {
            this.g5 = a;
            this.g("RadiusScale");
        }
        get labelMemberPath() {
            return this.hk;
        }
        set labelMemberPath(a) {
            this.hk = a;
            this.g("LabelMemberPath");
        }
        get fillMemberPath() {
            return this.hj;
        }
        set fillMemberPath(a) {
            this.hj = a;
            this.g("FillMemberPath");
        }
        get fillScale() {
            return this.g3;
        }
        set fillScale(a) {
            this.g3 = a;
            this.g("FillScale");
        }
        get fillScaleUseGlobalValues() {
            return this.g7;
        }
        set fillScaleUseGlobalValues(a) {
            this.g7 = a;
            this.g("FillScaleUseGlobalValues");
        }
        get markerOutlineUsesFillScale() {
            return this.g8;
        }
        set markerOutlineUsesFillScale(a) {
            this.g8 = a;
            this.g("MarkerOutlineUsesFillScale");
        }
        get markerOutlineBrightness() {
            return this.he;
        }
        set markerOutlineBrightness(a) {
            this.he = a;
            this.g("MarkerOutlineBrightness");
        }
        get markerBrushBrightness() {
            return this.hd;
        }
        set markerBrushBrightness(a) {
            this.hd = a;
            this.g("MarkerBrushBrightness");
        }
        get radiusScaleUseGlobalValues() {
            return this.g9;
        }
        set radiusScaleUseGlobalValues(a) {
            this.g9 = a;
            this.g("RadiusScaleUseGlobalValues");
        }
        get radiusMemberAsLegendLabel() {
            return this.hl;
        }
        set radiusMemberAsLegendLabel(a) {
            this.hl = a;
            this.g("RadiusMemberAsLegendLabel");
        }
        get fillMemberAsLegendLabel() {
            return this.hh;
        }
        set fillMemberAsLegendLabel(a) {
            this.hh = a;
            this.g("FillMemberAsLegendLabel");
        }
        get radiusMemberAsLegendUnit() {
            return this.hm;
        }
        set radiusMemberAsLegendUnit(a) {
            this.hm = a;
            this.g("RadiusMemberAsLegendUnit");
        }
        get fillMemberAsLegendUnit() {
            return this.hi;
        }
        set fillMemberAsLegendUnit(a) {
            this.hi = a;
            this.g("FillMemberAsLegendUnit");
        }
    }
    BubbleSeriesDescription.$t = /*@__PURE__*/ markType(BubbleSeriesDescription, 'BubbleSeriesDescription', ScatterBaseDescription.$);
    return BubbleSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BubbleSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class BubbleSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (BubbleSeriesDescriptionMetadata.a == null) {
                BubbleSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BubbleSeriesDescriptionMetadata.c(BubbleSeriesDescriptionMetadata.a);
            }
            if (a.k(BubbleSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(BubbleSeriesDescriptionMetadata.a);
            SizeScaleDescriptionMetadata.d(a);
            BrushScaleDescriptionMetadata.d(a);
        }
        static c(a) {
            ScatterBaseDescriptionMetadata.c(a);
            a.item("RadiusMemberPath", "String");
            a.item("RadiusScale", "ExportedType:SizeScale");
            a.item("RadiusScale@mustSetInCode", "WebComponents;Blazor;React;Angular");
            a.item("LabelMemberPath", "String");
            a.item("FillMemberPath", "String");
            a.item("FillScale", "ExportedType:BrushScale");
            a.item("FillScale@mustSetInCode", "WebComponents;Blazor;React;Angular");
            a.item("FillScaleUseGlobalValues", "Boolean");
            a.item("MarkerOutlineUsesFillScale", "Boolean");
            a.item("MarkerOutlineBrightness", "Number:double");
            a.item("MarkerBrushBrightness", "Number:double");
            a.item("RadiusScaleUseGlobalValues", "Boolean");
            a.item("RadiusMemberAsLegendLabel", "String");
            a.item("FillMemberAsLegendLabel", "String");
            a.item("RadiusMemberAsLegendUnit", "String");
            a.item("FillMemberAsLegendUnit", "String");
        }
        static d(a) {
            BubbleSeriesDescriptionMetadata.b(a);
            a.ae("BubbleSeries", () => new BubbleSeriesDescription());
            a.ad("BubbleSeries", BubbleSeriesDescriptionMetadata.a);
        }
    }
    BubbleSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(BubbleSeriesDescriptionMetadata, 'BubbleSeriesDescriptionMetadata');
    BubbleSeriesDescriptionMetadata.a = null;
    return BubbleSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BubbleSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class BubbleSeriesDescriptionModule extends Base {
        static register(a) {
            BubbleSeriesDescriptionMetadata.d(a);
        }
    }
    BubbleSeriesDescriptionModule.$t = /*@__PURE__*/ markType(BubbleSeriesDescriptionModule, 'BubbleSeriesDescriptionModule');
    return BubbleSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterSeriesDescription extends ScatterBaseDescription {
        get_type() {
            return "ScatterSeries";
        }
        constructor() {
            super();
        }
    }
    ScatterSeriesDescription.$t = /*@__PURE__*/ markType(ScatterSeriesDescription, 'ScatterSeriesDescription', ScatterBaseDescription.$);
    return ScatterSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterSeriesDescriptionMetadata.a == null) {
                ScatterSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterSeriesDescriptionMetadata.c(ScatterSeriesDescriptionMetadata.a);
            }
            if (a.k(ScatterSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(ScatterSeriesDescriptionMetadata.a);
        }
        static c(a) {
            ScatterBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            ScatterSeriesDescriptionMetadata.b(a);
            a.ae("ScatterSeries", () => new ScatterSeriesDescription());
            a.ad("ScatterSeries", ScatterSeriesDescriptionMetadata.a);
        }
    }
    ScatterSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterSeriesDescriptionMetadata, 'ScatterSeriesDescriptionMetadata');
    ScatterSeriesDescriptionMetadata.a = null;
    return ScatterSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ScatterSeriesDescriptionModule extends Base {
        static register(a) {
            ScatterSeriesDescriptionMetadata.d(a);
        }
    }
    ScatterSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ScatterSeriesDescriptionModule, 'ScatterSeriesDescriptionModule');
    return ScatterSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterLineSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterLineSeriesDescription extends ScatterBaseDescription {
        get_type() {
            return "ScatterLineSeries";
        }
        constructor() {
            super();
            this.g3 = null;
        }
        get unknownValuePlotting() {
            return this.g3;
        }
        set unknownValuePlotting(a) {
            this.g3 = a;
            this.g("UnknownValuePlotting");
        }
    }
    ScatterLineSeriesDescription.$t = /*@__PURE__*/ markType(ScatterLineSeriesDescription, 'ScatterLineSeriesDescription', ScatterBaseDescription.$);
    return ScatterLineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterLineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterLineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterLineSeriesDescriptionMetadata.a == null) {
                ScatterLineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterLineSeriesDescriptionMetadata.c(ScatterLineSeriesDescriptionMetadata.a);
            }
            if (a.k(ScatterLineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(ScatterLineSeriesDescriptionMetadata.a);
        }
        static c(a) {
            ScatterBaseDescriptionMetadata.c(a);
            a.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            a.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
        }
        static d(a) {
            ScatterLineSeriesDescriptionMetadata.b(a);
            a.ae("ScatterLineSeries", () => new ScatterLineSeriesDescription());
            a.ad("ScatterLineSeries", ScatterLineSeriesDescriptionMetadata.a);
        }
    }
    ScatterLineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterLineSeriesDescriptionMetadata, 'ScatterLineSeriesDescriptionMetadata');
    ScatterLineSeriesDescriptionMetadata.a = null;
    return ScatterLineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterLineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ScatterLineSeriesDescriptionModule extends Base {
        static register(a) {
            ScatterLineSeriesDescriptionMetadata.d(a);
        }
    }
    ScatterLineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ScatterLineSeriesDescriptionModule, 'ScatterLineSeriesDescriptionModule');
    return ScatterLineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterSplineSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterSplineSeriesDescription extends ScatterBaseDescription {
        get_type() {
            return "ScatterSplineSeries";
        }
        constructor() {
            super();
            this.g3 = 0;
        }
        get stiffness() {
            return this.g3;
        }
        set stiffness(a) {
            this.g3 = a;
            this.g("Stiffness");
        }
    }
    ScatterSplineSeriesDescription.$t = /*@__PURE__*/ markType(ScatterSplineSeriesDescription, 'ScatterSplineSeriesDescription', ScatterBaseDescription.$);
    return ScatterSplineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterSplineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterSplineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterSplineSeriesDescriptionMetadata.a == null) {
                ScatterSplineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterSplineSeriesDescriptionMetadata.c(ScatterSplineSeriesDescriptionMetadata.a);
            }
            if (a.k(ScatterSplineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(ScatterSplineSeriesDescriptionMetadata.a);
        }
        static c(a) {
            ScatterBaseDescriptionMetadata.c(a);
            a.item("Stiffness", "Number:double");
        }
        static d(a) {
            ScatterSplineSeriesDescriptionMetadata.b(a);
            a.ae("ScatterSplineSeries", () => new ScatterSplineSeriesDescription());
            a.ad("ScatterSplineSeries", ScatterSplineSeriesDescriptionMetadata.a);
        }
    }
    ScatterSplineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterSplineSeriesDescriptionMetadata, 'ScatterSplineSeriesDescriptionMetadata');
    ScatterSplineSeriesDescriptionMetadata.a = null;
    return ScatterSplineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterSplineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ScatterSplineSeriesDescriptionModule extends Base {
        static register(a) {
            ScatterSplineSeriesDescriptionMetadata.d(a);
        }
    }
    ScatterSplineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ScatterSplineSeriesDescriptionModule, 'ScatterSplineSeriesDescriptionModule');
    return ScatterSplineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ProgressiveLoadStatusEventArgsDescription = /*@__PURE__*/ (() => {
    class ProgressiveLoadStatusEventArgsDescription extends Description {
        get_type() {
            return "ProgressiveLoadStatusEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = 0;
        }
        get currentStatus() {
            return this.h;
        }
        set currentStatus(a) {
            this.h = a;
            this.g("CurrentStatus");
        }
    }
    ProgressiveLoadStatusEventArgsDescription.$t = /*@__PURE__*/ markType(ProgressiveLoadStatusEventArgsDescription, 'ProgressiveLoadStatusEventArgsDescription', Description.$);
    return ProgressiveLoadStatusEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ProgressiveLoadStatusEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ProgressiveLoadStatusEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ProgressiveLoadStatusEventArgsDescriptionMetadata.a == null) {
                ProgressiveLoadStatusEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ProgressiveLoadStatusEventArgsDescriptionMetadata.c(ProgressiveLoadStatusEventArgsDescriptionMetadata.a);
            }
            if (a.k(ProgressiveLoadStatusEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ProgressiveLoadStatusEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("CurrentStatus", "Number:int");
        }
        static d(a) {
            ProgressiveLoadStatusEventArgsDescriptionMetadata.b(a);
            a.ae("ProgressiveLoadStatusEventArgs", () => new ProgressiveLoadStatusEventArgsDescription());
            a.ad("ProgressiveLoadStatusEventArgs", ProgressiveLoadStatusEventArgsDescriptionMetadata.a);
        }
    }
    ProgressiveLoadStatusEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ProgressiveLoadStatusEventArgsDescriptionMetadata, 'ProgressiveLoadStatusEventArgsDescriptionMetadata');
    ProgressiveLoadStatusEventArgsDescriptionMetadata.a = null;
    return ProgressiveLoadStatusEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HighDensityScatterSeriesDescription = /*@__PURE__*/ (() => {
    class HighDensityScatterSeriesDescription extends SeriesDescription {
        get_type() {
            return "HighDensityScatterSeries";
        }
        constructor() {
            super();
            this.fg = null;
            this.fk = null;
            this.fj = null;
            this.fh = null;
            this.fl = null;
            this.fi = null;
            this.fm = null;
            this.fn = null;
            this.e2 = false;
            this.e1 = false;
            this.e6 = 0;
            this.e5 = 0;
            this.fe = null;
            this.fd = null;
            this.e9 = 0;
            this.fa = 0;
            this.ff = null;
        }
        get xAxisRef() {
            return this.fg;
        }
        set xAxisRef(a) {
            this.fg = a;
            this.g("XAxisRef");
        }
        get yAxisRef() {
            return this.fk;
        }
        set yAxisRef(a) {
            this.fk = a;
            this.g("YAxisRef");
        }
        get xMemberPath() {
            return this.fj;
        }
        set xMemberPath(a) {
            this.fj = a;
            this.g("XMemberPath");
        }
        get xMemberAsLegendLabel() {
            return this.fh;
        }
        set xMemberAsLegendLabel(a) {
            this.fh = a;
            this.g("XMemberAsLegendLabel");
        }
        get yMemberAsLegendLabel() {
            return this.fl;
        }
        set yMemberAsLegendLabel(a) {
            this.fl = a;
            this.g("YMemberAsLegendLabel");
        }
        get xMemberAsLegendUnit() {
            return this.fi;
        }
        set xMemberAsLegendUnit(a) {
            this.fi = a;
            this.g("XMemberAsLegendUnit");
        }
        get yMemberAsLegendUnit() {
            return this.fm;
        }
        set yMemberAsLegendUnit(a) {
            this.fm = a;
            this.g("YMemberAsLegendUnit");
        }
        get yMemberPath() {
            return this.fn;
        }
        set yMemberPath(a) {
            this.fn = a;
            this.g("YMemberPath");
        }
        get useBruteForce() {
            return this.e2;
        }
        set useBruteForce(a) {
            this.e2 = a;
            this.g("UseBruteForce");
        }
        get progressiveLoad() {
            return this.e1;
        }
        set progressiveLoad(a) {
            this.e1 = a;
            this.g("ProgressiveLoad");
        }
        get heatMinimum() {
            return this.e6;
        }
        set heatMinimum(a) {
            this.e6 = a;
            this.g("HeatMinimum");
        }
        get heatMaximum() {
            return this.e5;
        }
        set heatMaximum(a) {
            this.e5 = a;
            this.g("HeatMaximum");
        }
        get heatMinimumColor() {
            return this.fe;
        }
        set heatMinimumColor(a) {
            this.fe = a;
            this.g("HeatMinimumColor");
        }
        get heatMaximumColor() {
            return this.fd;
        }
        set heatMaximumColor(a) {
            this.fd = a;
            this.g("HeatMaximumColor");
        }
        get pointExtent() {
            return this.e9;
        }
        set pointExtent(a) {
            this.e9 = a;
            this.g("PointExtent");
        }
        get progressiveStatus() {
            return this.fa;
        }
        set progressiveStatus(a) {
            this.fa = a;
            this.g("ProgressiveStatus");
        }
        get progressiveLoadStatusChangedRef() {
            return this.ff;
        }
        set progressiveLoadStatusChangedRef(a) {
            this.ff = a;
            this.g("ProgressiveLoadStatusChangedRef");
        }
    }
    HighDensityScatterSeriesDescription.$t = /*@__PURE__*/ markType(HighDensityScatterSeriesDescription, 'HighDensityScatterSeriesDescription', SeriesDescription.$);
    return HighDensityScatterSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HighDensityScatterSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class HighDensityScatterSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (HighDensityScatterSeriesDescriptionMetadata.a == null) {
                HighDensityScatterSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HighDensityScatterSeriesDescriptionMetadata.c(HighDensityScatterSeriesDescriptionMetadata.a);
            }
            if (a.k(HighDensityScatterSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(HighDensityScatterSeriesDescriptionMetadata.a);
            ProgressiveLoadStatusEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            SeriesDescriptionMetadata.c(a);
            a.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            a.item("XAxisRef@nameBinding", "true");
            a.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            a.item("YAxisRef@nameBinding", "true");
            a.item("XMemberPath", "String");
            a.item("XMemberAsLegendLabel", "String");
            a.item("YMemberAsLegendLabel", "String");
            a.item("XMemberAsLegendUnit", "String");
            a.item("YMemberAsLegendUnit", "String");
            a.item("YMemberPath", "String");
            a.item("UseBruteForce", "Boolean");
            a.item("ProgressiveLoad", "Boolean");
            a.item("HeatMinimum", "Number:double");
            a.item("HeatMaximum", "Number:double");
            a.item("HeatMinimumColor", "Color");
            a.item("HeatMaximumColor", "Color");
            a.item("PointExtent", "Number:int");
            a.item("ProgressiveStatus", "Number:int");
            a.item("ProgressiveLoadStatusChangedRef", "EventRef::progressiveLoadStatusChanged");
        }
        static d(a) {
            HighDensityScatterSeriesDescriptionMetadata.b(a);
            a.ae("HighDensityScatterSeries", () => new HighDensityScatterSeriesDescription());
            a.ad("HighDensityScatterSeries", HighDensityScatterSeriesDescriptionMetadata.a);
        }
    }
    HighDensityScatterSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(HighDensityScatterSeriesDescriptionMetadata, 'HighDensityScatterSeriesDescriptionMetadata');
    HighDensityScatterSeriesDescriptionMetadata.a = null;
    return HighDensityScatterSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HighDensityScatterSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class HighDensityScatterSeriesDescriptionModule extends Base {
        static register(a) {
            HighDensityScatterSeriesDescriptionMetadata.d(a);
        }
    }
    HighDensityScatterSeriesDescriptionModule.$t = /*@__PURE__*/ markType(HighDensityScatterSeriesDescriptionModule, 'HighDensityScatterSeriesDescriptionModule');
    return HighDensityScatterSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartScatterDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartScatterDescriptionModule extends Base {
        static register(a) {
            SizeScaleDescriptionModule.register(a);
            ValueBrushScaleDescriptionModule.register(a);
            CustomPaletteColorScaleDescriptionModule.register(a);
            BubbleSeriesDescriptionModule.register(a);
            ScatterSeriesDescriptionModule.register(a);
            ScatterLineSeriesDescriptionModule.register(a);
            ScatterSplineSeriesDescriptionModule.register(a);
            HighDensityScatterSeriesDescriptionModule.register(a);
            DataChartScatterCoreDescriptionModule.register(a);
        }
    }
    DataChartScatterDescriptionModule.$t = /*@__PURE__*/ markType(DataChartScatterDescriptionModule, 'DataChartScatterDescriptionModule');
    return DataChartScatterDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartShapeCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartShapeCoreDescriptionModule extends Base {
        static register(a) {
            NumericXAxisDescriptionModule.register(a);
            NumericYAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartShapeCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartShapeCoreDescriptionModule, 'DataChartShapeCoreDescriptionModule');
    return DataChartShapeCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulationStatusEventArgsDescription = /*@__PURE__*/ (() => {
    class TriangulationStatusEventArgsDescription extends Description {
        get_type() {
            return "TriangulationStatusEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = 0;
        }
        get currentStatus() {
            return this.h;
        }
        set currentStatus(a) {
            this.h = a;
            this.g("CurrentStatus");
        }
    }
    TriangulationStatusEventArgsDescription.$t = /*@__PURE__*/ markType(TriangulationStatusEventArgsDescription, 'TriangulationStatusEventArgsDescription', Description.$);
    return TriangulationStatusEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulationStatusEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class TriangulationStatusEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (TriangulationStatusEventArgsDescriptionMetadata.a == null) {
                TriangulationStatusEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TriangulationStatusEventArgsDescriptionMetadata.c(TriangulationStatusEventArgsDescriptionMetadata.a);
            }
            if (a.k(TriangulationStatusEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(TriangulationStatusEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("CurrentStatus", "Number:int");
        }
        static d(a) {
            TriangulationStatusEventArgsDescriptionMetadata.b(a);
            a.ae("TriangulationStatusEventArgs", () => new TriangulationStatusEventArgsDescription());
            a.ad("TriangulationStatusEventArgs", TriangulationStatusEventArgsDescriptionMetadata.a);
        }
    }
    TriangulationStatusEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(TriangulationStatusEventArgsDescriptionMetadata, 'TriangulationStatusEventArgsDescriptionMetadata');
    TriangulationStatusEventArgsDescriptionMetadata.a = null;
    return TriangulationStatusEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterTriangulationSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterTriangulationSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterTriangulationSeriesDescriptionMetadata.a == null) {
                ScatterTriangulationSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterTriangulationSeriesDescriptionMetadata.c(ScatterTriangulationSeriesDescriptionMetadata.a);
            }
            if (a.k(ScatterTriangulationSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(ScatterTriangulationSeriesDescriptionMetadata.a);
            TriangulationStatusEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            SeriesDescriptionMetadata.c(a);
            a.item("XMemberPath", "String");
            a.item("YMemberPath", "String");
            a.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            a.item("XAxisRef@nameBinding", "true");
            a.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            a.item("YAxisRef@nameBinding", "true");
            a.item("TrianglesSourceRef", "(w:TrianglesSource,wf:TrianglesSource)DataRef::object");
            a.item("TriangleVertexMemberPath1", "String");
            a.item("TriangleVertexMemberPath2", "String");
            a.item("TriangleVertexMemberPath3", "String");
            a.item("XMemberAsLegendLabel", "String");
            a.item("YMemberAsLegendLabel", "String");
            a.item("XMemberAsLegendUnit", "String");
            a.item("YMemberAsLegendUnit", "String");
            a.item("TriangulationStatusChangedRef", "EventRef::triangulationStatusChanged");
        }
        static d(a) {
            ScatterTriangulationSeriesDescriptionMetadata.b(a);
            a.ad("ScatterTriangulationSeries", ScatterTriangulationSeriesDescriptionMetadata.a);
        }
    }
    ScatterTriangulationSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterTriangulationSeriesDescriptionMetadata, 'ScatterTriangulationSeriesDescriptionMetadata');
    ScatterTriangulationSeriesDescriptionMetadata.a = null;
    return ScatterTriangulationSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterTriangulationSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterTriangulationSeriesDescription extends SeriesDescription {
        get_type() {
            return "ScatterTriangulationSeries";
        }
        constructor() {
            super();
            this.e9 = null;
            this.fd = null;
            this.e6 = null;
            this.fa = null;
            this.e1 = null;
            this.e2 = null;
            this.e3 = null;
            this.e4 = null;
            this.e7 = null;
            this.fb = null;
            this.e8 = null;
            this.fc = null;
            this.e5 = null;
        }
        get xMemberPath() {
            return this.e9;
        }
        set xMemberPath(a) {
            this.e9 = a;
            this.g("XMemberPath");
        }
        get yMemberPath() {
            return this.fd;
        }
        set yMemberPath(a) {
            this.fd = a;
            this.g("YMemberPath");
        }
        get xAxisRef() {
            return this.e6;
        }
        set xAxisRef(a) {
            this.e6 = a;
            this.g("XAxisRef");
        }
        get yAxisRef() {
            return this.fa;
        }
        set yAxisRef(a) {
            this.fa = a;
            this.g("YAxisRef");
        }
        get trianglesSourceRef() {
            return this.e1;
        }
        set trianglesSourceRef(a) {
            this.e1 = a;
            this.g("TrianglesSourceRef");
        }
        get triangleVertexMemberPath1() {
            return this.e2;
        }
        set triangleVertexMemberPath1(a) {
            this.e2 = a;
            this.g("TriangleVertexMemberPath1");
        }
        get triangleVertexMemberPath2() {
            return this.e3;
        }
        set triangleVertexMemberPath2(a) {
            this.e3 = a;
            this.g("TriangleVertexMemberPath2");
        }
        get triangleVertexMemberPath3() {
            return this.e4;
        }
        set triangleVertexMemberPath3(a) {
            this.e4 = a;
            this.g("TriangleVertexMemberPath3");
        }
        get xMemberAsLegendLabel() {
            return this.e7;
        }
        set xMemberAsLegendLabel(a) {
            this.e7 = a;
            this.g("XMemberAsLegendLabel");
        }
        get yMemberAsLegendLabel() {
            return this.fb;
        }
        set yMemberAsLegendLabel(a) {
            this.fb = a;
            this.g("YMemberAsLegendLabel");
        }
        get xMemberAsLegendUnit() {
            return this.e8;
        }
        set xMemberAsLegendUnit(a) {
            this.e8 = a;
            this.g("XMemberAsLegendUnit");
        }
        get yMemberAsLegendUnit() {
            return this.fc;
        }
        set yMemberAsLegendUnit(a) {
            this.fc = a;
            this.g("YMemberAsLegendUnit");
        }
        get triangulationStatusChangedRef() {
            return this.e5;
        }
        set triangulationStatusChangedRef(a) {
            this.e5 = a;
            this.g("TriangulationStatusChangedRef");
        }
    }
    ScatterTriangulationSeriesDescription.$t = /*@__PURE__*/ markType(ScatterTriangulationSeriesDescription, 'ScatterTriangulationSeriesDescription', SeriesDescription.$);
    return ScatterTriangulationSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterAreaSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterAreaSeriesDescription extends ScatterTriangulationSeriesDescription {
        get_type() {
            return "ScatterAreaSeries";
        }
        constructor() {
            super();
            this.fs = null;
            this.fx = null;
            this.fr = null;
            this.fv = null;
            this.fw = null;
        }
        get colorScale() {
            return this.fs;
        }
        set colorScale(a) {
            this.fs = a;
            this.g("ColorScale");
        }
        get colorMemberPath() {
            return this.fx;
        }
        set colorMemberPath(a) {
            this.fx = a;
            this.g("ColorMemberPath");
        }
        get actualColorScale() {
            return this.fr;
        }
        set actualColorScale(a) {
            this.fr = a;
            this.g("ActualColorScale");
        }
        get colorMemberAsLegendLabel() {
            return this.fv;
        }
        set colorMemberAsLegendLabel(a) {
            this.fv = a;
            this.g("ColorMemberAsLegendLabel");
        }
        get colorMemberAsLegendUnit() {
            return this.fw;
        }
        set colorMemberAsLegendUnit(a) {
            this.fw = a;
            this.g("ColorMemberAsLegendUnit");
        }
    }
    ScatterAreaSeriesDescription.$t = /*@__PURE__*/ markType(ScatterAreaSeriesDescription, 'ScatterAreaSeriesDescription', ScatterTriangulationSeriesDescription.$);
    return ScatterAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterAreaSeriesDescriptionMetadata.a == null) {
                ScatterAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterAreaSeriesDescriptionMetadata.c(ScatterAreaSeriesDescriptionMetadata.a);
            }
            if (a.k(ScatterAreaSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(ScatterAreaSeriesDescriptionMetadata.a);
            ColorScaleDescriptionMetadata.d(a);
        }
        static c(a) {
            ScatterTriangulationSeriesDescriptionMetadata.c(a);
            a.item("ColorScale", "ExportedType:ColorScale");
            a.item("ColorMemberPath", "String");
            a.item("ActualColorScale", "ExportedType:ColorScale");
            a.item("ColorMemberAsLegendLabel", "String");
            a.item("ColorMemberAsLegendUnit", "String");
        }
        static d(a) {
            ScatterAreaSeriesDescriptionMetadata.b(a);
            a.ae("ScatterAreaSeries", () => new ScatterAreaSeriesDescription());
            a.ad("ScatterAreaSeries", ScatterAreaSeriesDescriptionMetadata.a);
        }
    }
    ScatterAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterAreaSeriesDescriptionMetadata, 'ScatterAreaSeriesDescriptionMetadata');
    ScatterAreaSeriesDescriptionMetadata.a = null;
    return ScatterAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ScatterAreaSeriesDescriptionModule extends Base {
        static register(a) {
            ScatterAreaSeriesDescriptionMetadata.d(a);
        }
    }
    ScatterAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ScatterAreaSeriesDescriptionModule, 'ScatterAreaSeriesDescriptionModule');
    return ScatterAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ContourValueResolverDescriptionMetadata = /*@__PURE__*/ (() => {
    class ContourValueResolverDescriptionMetadata extends Base {
        static b(a) {
            if (ContourValueResolverDescriptionMetadata.a == null) {
                ContourValueResolverDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ContourValueResolverDescriptionMetadata.c(ContourValueResolverDescriptionMetadata.a);
            }
            if (a.k(ContourValueResolverDescriptionMetadata.a)) {
                return;
            }
            a.ac(ContourValueResolverDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ContourValueResolverDescriptionMetadata.b(a);
            a.ad("ContourValueResolver", ContourValueResolverDescriptionMetadata.a);
        }
    }
    ContourValueResolverDescriptionMetadata.$t = /*@__PURE__*/ markType(ContourValueResolverDescriptionMetadata, 'ContourValueResolverDescriptionMetadata');
    ContourValueResolverDescriptionMetadata.a = null;
    return ContourValueResolverDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterContourSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterContourSeriesDescription extends ScatterTriangulationSeriesDescription {
        get_type() {
            return "ScatterContourSeries";
        }
        constructor() {
            super();
            this.fz = null;
            this.fx = null;
            this.fy = null;
            this.fu = null;
            this.ft = null;
            this.fr = null;
        }
        get valueMemberPath() {
            return this.fz;
        }
        set valueMemberPath(a) {
            this.fz = a;
            this.g("ValueMemberPath");
        }
        get valueMemberAsLegendLabel() {
            return this.fx;
        }
        set valueMemberAsLegendLabel(a) {
            this.fx = a;
            this.g("ValueMemberAsLegendLabel");
        }
        get valueMemberAsLegendUnit() {
            return this.fy;
        }
        set valueMemberAsLegendUnit(a) {
            this.fy = a;
            this.g("ValueMemberAsLegendUnit");
        }
        get fillScale() {
            return this.fu;
        }
        set fillScale(a) {
            this.fu = a;
            this.g("FillScale");
        }
        get actualFillScale() {
            return this.ft;
        }
        set actualFillScale(a) {
            this.ft = a;
            this.g("ActualFillScale");
        }
        get valueResolver() {
            return this.fr;
        }
        set valueResolver(a) {
            this.fr = a;
            this.g("ValueResolver");
        }
    }
    ScatterContourSeriesDescription.$t = /*@__PURE__*/ markType(ScatterContourSeriesDescription, 'ScatterContourSeriesDescription', ScatterTriangulationSeriesDescription.$);
    return ScatterContourSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterContourSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterContourSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterContourSeriesDescriptionMetadata.a == null) {
                ScatterContourSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterContourSeriesDescriptionMetadata.c(ScatterContourSeriesDescriptionMetadata.a);
            }
            if (a.k(ScatterContourSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(ScatterContourSeriesDescriptionMetadata.a);
            ValueBrushScaleDescriptionMetadata.d(a);
            ContourValueResolverDescriptionMetadata.d(a);
        }
        static c(a) {
            ScatterTriangulationSeriesDescriptionMetadata.c(a);
            a.item("ValueMemberPath", "String");
            a.item("ValueMemberAsLegendLabel", "String");
            a.item("ValueMemberAsLegendUnit", "String");
            a.item("FillScale", "ExportedType:ValueBrushScale");
            a.item("ActualFillScale", "ExportedType:ValueBrushScale");
            a.item("ValueResolver", "ExportedType:ContourValueResolver");
        }
        static d(a) {
            ScatterContourSeriesDescriptionMetadata.b(a);
            a.ae("ScatterContourSeries", () => new ScatterContourSeriesDescription());
            a.ad("ScatterContourSeries", ScatterContourSeriesDescriptionMetadata.a);
        }
    }
    ScatterContourSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterContourSeriesDescriptionMetadata, 'ScatterContourSeriesDescriptionMetadata');
    ScatterContourSeriesDescriptionMetadata.a = null;
    return ScatterContourSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterContourSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ScatterContourSeriesDescriptionModule extends Base {
        static register(a) {
            ScatterContourSeriesDescriptionMetadata.d(a);
        }
    }
    ScatterContourSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ScatterContourSeriesDescriptionModule, 'ScatterContourSeriesDescriptionModule');
    return ScatterContourSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StyleDescription = /*@__PURE__*/ (() => {
    class StyleDescription extends Description {
        get_type() {
            return "Style";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    StyleDescription.$t = /*@__PURE__*/ markType(StyleDescription, 'StyleDescription', Description.$);
    return StyleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StyleDescriptionMetadata = /*@__PURE__*/ (() => {
    class StyleDescriptionMetadata extends Base {
        static b(a) {
            if (StyleDescriptionMetadata.a == null) {
                StyleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StyleDescriptionMetadata.c(StyleDescriptionMetadata.a);
            }
            if (a.k(StyleDescriptionMetadata.a)) {
                return;
            }
            a.ac(StyleDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            StyleDescriptionMetadata.b(a);
            a.ae("Style", () => new StyleDescription());
            a.ad("Style", StyleDescriptionMetadata.a);
        }
    }
    StyleDescriptionMetadata.$t = /*@__PURE__*/ markType(StyleDescriptionMetadata, 'StyleDescriptionMetadata');
    StyleDescriptionMetadata.a = null;
    return StyleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StyleShapeEventArgsDescription = /*@__PURE__*/ (() => {
    class StyleShapeEventArgsDescription extends Description {
        get_type() {
            return "StyleShapeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.m = null;
            this.n = null;
            this.i = 0;
            this.h = 0;
        }
        get itemRef() {
            return this.l;
        }
        set itemRef(a) {
            this.l = a;
            this.g("ItemRef");
        }
        get shapeFill() {
            return this.m;
        }
        set shapeFill(a) {
            this.m = a;
            this.g("ShapeFill");
        }
        get shapeStroke() {
            return this.n;
        }
        set shapeStroke(a) {
            this.n = a;
            this.g("ShapeStroke");
        }
        get shapeStrokeThickness() {
            return this.i;
        }
        set shapeStrokeThickness(a) {
            this.i = a;
            this.g("ShapeStrokeThickness");
        }
        get shapeOpacity() {
            return this.h;
        }
        set shapeOpacity(a) {
            this.h = a;
            this.g("ShapeOpacity");
        }
    }
    StyleShapeEventArgsDescription.$t = /*@__PURE__*/ markType(StyleShapeEventArgsDescription, 'StyleShapeEventArgsDescription', Description.$);
    return StyleShapeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StyleShapeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class StyleShapeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (StyleShapeEventArgsDescriptionMetadata.a == null) {
                StyleShapeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StyleShapeEventArgsDescriptionMetadata.c(StyleShapeEventArgsDescriptionMetadata.a);
            }
            if (a.k(StyleShapeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(StyleShapeEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("ShapeFill", "(w:ShapeStyle.Fill,wf:ShapeFill)String");
            a.item("ShapeStroke", "(w:ShapeStyle.Stroke,wf:ShapeStroke)String");
            a.item("ShapeStrokeThickness", "(w:ShapeStyle.StrokeThickness,wf:ShapeStrokeThickness)Number:double");
            a.item("ShapeOpacity", "(w:ShapeStyle.Opacity,wf:ShapeOpacity)Number:double");
        }
        static d(a) {
            StyleShapeEventArgsDescriptionMetadata.b(a);
            a.ae("StyleShapeEventArgs", () => new StyleShapeEventArgsDescription());
            a.ad("StyleShapeEventArgs", StyleShapeEventArgsDescriptionMetadata.a);
        }
    }
    StyleShapeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(StyleShapeEventArgsDescriptionMetadata, 'StyleShapeEventArgsDescriptionMetadata');
    StyleShapeEventArgsDescriptionMetadata.a = null;
    return StyleShapeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class ShapeSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (ShapeSeriesBaseDescriptionMetadata.a == null) {
                ShapeSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ShapeSeriesBaseDescriptionMetadata.c(ShapeSeriesBaseDescriptionMetadata.a);
            }
            if (a.k(ShapeSeriesBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(ShapeSeriesBaseDescriptionMetadata.a);
            AssigningShapeStyleEventArgsDescriptionMetadata.d(a);
            AssigningShapeMarkerStyleEventArgsDescriptionMetadata.d(a);
            StyleShapeEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            SeriesDescriptionMetadata.c(a);
            a.item("IsCustomShapeStyleAllowed", "Boolean");
            a.item("IsCustomShapeMarkerStyleAllowed", "Boolean");
            a.item("ActualItemSearchMode", "ExportedType:string:ShapeItemSearchMode");
            a.item("ActualItemSearchMode@names", "Auto;ClosestBoundingBox;ClosestShape;ClosestPointOnClosestShape;None");
            a.item("ItemSearchMode", "ExportedType:string:ShapeItemSearchMode");
            a.item("ItemSearchMode@names", "Auto;ClosestBoundingBox;ClosestShape;ClosestPointOnClosestShape;None");
            a.item("ItemSearchThreshold", "Number:int");
            a.item("ItemSearchPointsThreshold", "Number:int");
            a.item("ShapeMemberPath", "String");
            a.item("HighlightedShapeMemberPath", "String");
            a.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            a.item("XAxisRef@nameBinding", "true");
            a.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            a.item("YAxisRef@nameBinding", "true");
            a.item("ShapeFilterResolution", "Number:double");
            a.item("AssigningShapeStyleRef", "EventRef::assigningShapeStyle");
            a.item("AssigningShapeMarkerStyleRef", "EventRef::assigningShapeMarkerStyle");
            a.item("StyleShapeRef", "EventRef::styleShape");
        }
        static d(a) {
            ShapeSeriesBaseDescriptionMetadata.b(a);
            a.ad("ShapeSeriesBase", ShapeSeriesBaseDescriptionMetadata.a);
        }
    }
    ShapeSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(ShapeSeriesBaseDescriptionMetadata, 'ShapeSeriesBaseDescriptionMetadata');
    ShapeSeriesBaseDescriptionMetadata.a = null;
    return ShapeSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeSeriesBaseDescription = /*@__PURE__*/ (() => {
    class ShapeSeriesBaseDescription extends SeriesDescription {
        get_type() {
            return "ShapeSeriesBase";
        }
        constructor() {
            super();
            this.e2 = false;
            this.e1 = false;
            this.fb = null;
            this.ff = null;
            this.e8 = 0;
            this.e7 = 0;
            this.fg = null;
            this.fe = null;
            this.fi = null;
            this.fj = null;
            this.e5 = 0;
            this.fd = null;
            this.fc = null;
            this.fh = null;
        }
        get isCustomShapeStyleAllowed() {
            return this.e2;
        }
        set isCustomShapeStyleAllowed(a) {
            this.e2 = a;
            this.g("IsCustomShapeStyleAllowed");
        }
        get isCustomShapeMarkerStyleAllowed() {
            return this.e1;
        }
        set isCustomShapeMarkerStyleAllowed(a) {
            this.e1 = a;
            this.g("IsCustomShapeMarkerStyleAllowed");
        }
        get actualItemSearchMode() {
            return this.fb;
        }
        set actualItemSearchMode(a) {
            this.fb = a;
            this.g("ActualItemSearchMode");
        }
        get itemSearchMode() {
            return this.ff;
        }
        set itemSearchMode(a) {
            this.ff = a;
            this.g("ItemSearchMode");
        }
        get itemSearchThreshold() {
            return this.e8;
        }
        set itemSearchThreshold(a) {
            this.e8 = a;
            this.g("ItemSearchThreshold");
        }
        get itemSearchPointsThreshold() {
            return this.e7;
        }
        set itemSearchPointsThreshold(a) {
            this.e7 = a;
            this.g("ItemSearchPointsThreshold");
        }
        get shapeMemberPath() {
            return this.fg;
        }
        set shapeMemberPath(a) {
            this.fg = a;
            this.g("ShapeMemberPath");
        }
        get highlightedShapeMemberPath() {
            return this.fe;
        }
        set highlightedShapeMemberPath(a) {
            this.fe = a;
            this.g("HighlightedShapeMemberPath");
        }
        get xAxisRef() {
            return this.fi;
        }
        set xAxisRef(a) {
            this.fi = a;
            this.g("XAxisRef");
        }
        get yAxisRef() {
            return this.fj;
        }
        set yAxisRef(a) {
            this.fj = a;
            this.g("YAxisRef");
        }
        get shapeFilterResolution() {
            return this.e5;
        }
        set shapeFilterResolution(a) {
            this.e5 = a;
            this.g("ShapeFilterResolution");
        }
        get assigningShapeStyleRef() {
            return this.fd;
        }
        set assigningShapeStyleRef(a) {
            this.fd = a;
            this.g("AssigningShapeStyleRef");
        }
        get assigningShapeMarkerStyleRef() {
            return this.fc;
        }
        set assigningShapeMarkerStyleRef(a) {
            this.fc = a;
            this.g("AssigningShapeMarkerStyleRef");
        }
        get styleShapeRef() {
            return this.fh;
        }
        set styleShapeRef(a) {
            this.fh = a;
            this.g("StyleShapeRef");
        }
    }
    ShapeSeriesBaseDescription.$t = /*@__PURE__*/ markType(ShapeSeriesBaseDescription, 'ShapeSeriesBaseDescription', SeriesDescription.$);
    return ShapeSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterPolygonSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterPolygonSeriesDescription extends ShapeSeriesBaseDescription {
        get_type() {
            return "ScatterPolygonSeries";
        }
        constructor() {
            super();
            this.ft = null;
            this.f6 = null;
            this.f5 = null;
            this.fv = 0;
            this.fz = null;
            this.f0 = null;
            this.fx = null;
            this.f3 = null;
            this.fy = null;
            this.f1 = null;
            this.f4 = null;
            this.f2 = null;
        }
        get shapeStyle() {
            return this.ft;
        }
        set shapeStyle(a) {
            this.ft = a;
            this.g("ShapeStyle");
        }
        get markerType() {
            return this.f6;
        }
        set markerType(a) {
            this.f6 = a;
            this.g("MarkerType");
        }
        get markerTemplateRef() {
            return this.f5;
        }
        set markerTemplateRef(a) {
            this.f5 = a;
            this.g("MarkerTemplateRef");
        }
        get markerThickness() {
            return this.fv;
        }
        set markerThickness(a) {
            this.fv = a;
            this.g("MarkerThickness");
        }
        get actualMarkerTemplateRef() {
            return this.fz;
        }
        set actualMarkerTemplateRef(a) {
            this.fz = a;
            this.g("ActualMarkerTemplateRef");
        }
        get markerBrush() {
            return this.f0;
        }
        set markerBrush(a) {
            this.f0 = a;
            this.g("MarkerBrush");
        }
        get actualMarkerBrush() {
            return this.fx;
        }
        set actualMarkerBrush(a) {
            this.fx = a;
            this.g("ActualMarkerBrush");
        }
        get markerOutline() {
            return this.f3;
        }
        set markerOutline(a) {
            this.f3 = a;
            this.g("MarkerOutline");
        }
        get actualMarkerOutline() {
            return this.fy;
        }
        set actualMarkerOutline(a) {
            this.fy = a;
            this.g("ActualMarkerOutline");
        }
        get markerCollisionAvoidance() {
            return this.f1;
        }
        set markerCollisionAvoidance(a) {
            this.f1 = a;
            this.g("MarkerCollisionAvoidance");
        }
        get markerOutlineMode() {
            return this.f4;
        }
        set markerOutlineMode(a) {
            this.f4 = a;
            this.g("MarkerOutlineMode");
        }
        get markerFillMode() {
            return this.f2;
        }
        set markerFillMode(a) {
            this.f2 = a;
            this.g("MarkerFillMode");
        }
    }
    ScatterPolygonSeriesDescription.$t = /*@__PURE__*/ markType(ScatterPolygonSeriesDescription, 'ScatterPolygonSeriesDescription', ShapeSeriesBaseDescription.$);
    return ScatterPolygonSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterPolygonSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterPolygonSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterPolygonSeriesDescriptionMetadata.a == null) {
                ScatterPolygonSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterPolygonSeriesDescriptionMetadata.c(ScatterPolygonSeriesDescriptionMetadata.a);
            }
            if (a.k(ScatterPolygonSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(ScatterPolygonSeriesDescriptionMetadata.a);
            StyleDescriptionMetadata.d(a);
        }
        static c(a) {
            ShapeSeriesBaseDescriptionMetadata.c(a);
            a.item("ShapeStyle", "ExportedType:Style");
            a.item("MarkerType", "ExportedType:string:MarkerType");
            a.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            a.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            a.item("MarkerThickness", "Number:double");
            a.item("ActualMarkerTemplateRef", "(w:ActualMarkerTemplate,wf:ActualMarkerTemplate)DataRef::object");
            a.item("MarkerBrush", "Brush");
            a.item("ActualMarkerBrush", "Brush");
            a.item("MarkerOutline", "Brush");
            a.item("ActualMarkerOutline", "Brush");
            a.item("MarkerCollisionAvoidance", "ExportedType:string:CollisionAvoidanceType");
            a.item("MarkerCollisionAvoidance@names", "None;Omit;Fade;OmitAndShift;FadeAndShift");
            a.item("MarkerOutlineMode", "ExportedType:string:MarkerOutlineMode");
            a.item("MarkerOutlineMode@names", "Auto;Normal;MatchMarkerBrush");
            a.item("MarkerFillMode", "ExportedType:string:MarkerFillMode");
            a.item("MarkerFillMode@names", "Auto;Normal;MatchMarkerOutline");
        }
        static d(a) {
            ScatterPolygonSeriesDescriptionMetadata.b(a);
            a.ae("ScatterPolygonSeries", () => new ScatterPolygonSeriesDescription());
            a.ad("ScatterPolygonSeries", ScatterPolygonSeriesDescriptionMetadata.a);
        }
    }
    ScatterPolygonSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterPolygonSeriesDescriptionMetadata, 'ScatterPolygonSeriesDescriptionMetadata');
    ScatterPolygonSeriesDescriptionMetadata.a = null;
    return ScatterPolygonSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterPolygonSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ScatterPolygonSeriesDescriptionModule extends Base {
        static register(a) {
            ScatterPolygonSeriesDescriptionMetadata.d(a);
        }
    }
    ScatterPolygonSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ScatterPolygonSeriesDescriptionModule, 'ScatterPolygonSeriesDescriptionModule');
    return ScatterPolygonSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterPolylineSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterPolylineSeriesDescription extends ShapeSeriesBaseDescription {
        get_type() {
            return "ScatterPolylineSeries";
        }
        constructor() {
            super();
            this.ft = null;
        }
        get shapeStyle() {
            return this.ft;
        }
        set shapeStyle(a) {
            this.ft = a;
            this.g("ShapeStyle");
        }
    }
    ScatterPolylineSeriesDescription.$t = /*@__PURE__*/ markType(ScatterPolylineSeriesDescription, 'ScatterPolylineSeriesDescription', ShapeSeriesBaseDescription.$);
    return ScatterPolylineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterPolylineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterPolylineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterPolylineSeriesDescriptionMetadata.a == null) {
                ScatterPolylineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterPolylineSeriesDescriptionMetadata.c(ScatterPolylineSeriesDescriptionMetadata.a);
            }
            if (a.k(ScatterPolylineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(ScatterPolylineSeriesDescriptionMetadata.a);
            StyleDescriptionMetadata.d(a);
        }
        static c(a) {
            ShapeSeriesBaseDescriptionMetadata.c(a);
            a.item("ShapeStyle", "ExportedType:Style");
        }
        static d(a) {
            ScatterPolylineSeriesDescriptionMetadata.b(a);
            a.ae("ScatterPolylineSeries", () => new ScatterPolylineSeriesDescription());
            a.ad("ScatterPolylineSeries", ScatterPolylineSeriesDescriptionMetadata.a);
        }
    }
    ScatterPolylineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterPolylineSeriesDescriptionMetadata, 'ScatterPolylineSeriesDescriptionMetadata');
    ScatterPolylineSeriesDescriptionMetadata.a = null;
    return ScatterPolylineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterPolylineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ScatterPolylineSeriesDescriptionModule extends Base {
        static register(a) {
            ScatterPolylineSeriesDescriptionMetadata.d(a);
        }
    }
    ScatterPolylineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ScatterPolylineSeriesDescriptionModule, 'ScatterPolylineSeriesDescriptionModule');
    return ScatterPolylineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartShapeDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartShapeDescriptionModule extends Base {
        static register(a) {
            ScatterAreaSeriesDescriptionModule.register(a);
            ScatterContourSeriesDescriptionModule.register(a);
            ScatterPolygonSeriesDescriptionModule.register(a);
            ScatterPolylineSeriesDescriptionModule.register(a);
            DataChartShapeCoreDescriptionModule.register(a);
        }
    }
    DataChartShapeDescriptionModule.$t = /*@__PURE__*/ markType(DataChartShapeDescriptionModule, 'DataChartShapeDescriptionModule');
    return DataChartShapeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedFragmentSeriesDescription = /*@__PURE__*/ (() => {
    class StackedFragmentSeriesDescription extends Description {
        get_type() {
            return "StackedFragmentSeries";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.cj = null;
            this.ck = null;
            this.ch = null;
            this.br = null;
            this.h = null;
            this.n = false;
            this.j = false;
            this.ar = 0;
            this.ag = 0;
            this.c3 = null;
            this.b9 = null;
            this.q = false;
            this.m = false;
            this.as = 0;
            this.ah = 0;
            this.at = 0;
            this.ai = 0;
            this.cr = null;
            this.b0 = null;
            this.co = null;
            this.bx = null;
            this.cp = null;
            this.by = null;
            this.cq = null;
            this.bz = null;
            this.cn = null;
            this.cm = null;
            this.bw = null;
            this.bv = null;
            this.cs = null;
            this.b1 = null;
            this.cu = null;
            this.b3 = null;
            this.cw = null;
            this.b5 = null;
            this.cx = null;
            this.b6 = null;
            this.ct = null;
            this.b2 = null;
            this.cv = null;
            this.b4 = null;
            this.cy = null;
            this.ao = 0;
            this.ad = 0;
            this.cz = null;
            this.b7 = null;
            this.ak = 0;
            this.z = 0;
            this.am = 0;
            this.ab = 0;
            this.c0 = null;
            this.b8 = null;
            this.al = 0;
            this.aa = 0;
            this.bu = null;
            this.ap = 0;
            this.ae = 0;
            this.k = false;
            this.o = false;
            this.aq = 0;
            this.af = 0;
            this.au = 0;
            this.aj = 0;
            this.an = 0;
            this.ac = 0;
            this.bp = null;
            this.c4 = null;
            this.bj = 0;
            this.bk = 0;
            this.c5 = null;
            this.c6 = null;
            this.p = false;
            this.c7 = null;
            this.l = false;
            this.bi = 0;
            this.cc = null;
            this.cd = null;
            this.cb = null;
            this.ca = null;
            this.bh = 0;
            this.da = null;
            this.c8 = null;
            this.c9 = null;
            this.ce = null;
            this.cf = null;
            this.ci = null;
            this.cl = null;
            this.bs = null;
            this.bt = null;
            this.db = null;
            this.cg = null;
            this.c1 = null;
            this.c2 = null;
        }
        get dataSourceRef() {
            return this.cj;
        }
        set dataSourceRef(a) {
            this.cj = a;
            this.g("DataSourceRef");
        }
        get highlightedDataSourceRef() {
            return this.ck;
        }
        set highlightedDataSourceRef(a) {
            this.ck = a;
            this.g("HighlightedDataSourceRef");
        }
        get brush() {
            return this.ch;
        }
        set brush(a) {
            this.ch = a;
            this.g("Brush");
        }
        get actualBrush() {
            return this.br;
        }
        set actualBrush(a) {
            this.br = a;
            this.g("ActualBrush");
        }
        get dashArray() {
            return this.h;
        }
        set dashArray(a) {
            this.h = a;
            this.g("DashArray");
        }
        get isDropShadowEnabled() {
            return this.n;
        }
        set isDropShadowEnabled(a) {
            this.n = a;
            this.g("IsDropShadowEnabled");
        }
        get actualIsDropShadowEnabled() {
            return this.j;
        }
        set actualIsDropShadowEnabled(a) {
            this.j = a;
            this.g("ActualIsDropShadowEnabled");
        }
        get shadowBlur() {
            return this.ar;
        }
        set shadowBlur(a) {
            this.ar = a;
            this.g("ShadowBlur");
        }
        get actualShadowBlur() {
            return this.ag;
        }
        set actualShadowBlur(a) {
            this.ag = a;
            this.g("ActualShadowBlur");
        }
        get shadowColor() {
            return this.c3;
        }
        set shadowColor(a) {
            this.c3 = a;
            this.g("ShadowColor");
        }
        get actualShadowColor() {
            return this.b9;
        }
        set actualShadowColor(a) {
            this.b9 = a;
            this.g("ActualShadowColor");
        }
        get useSingleShadow() {
            return this.q;
        }
        set useSingleShadow(a) {
            this.q = a;
            this.g("UseSingleShadow");
        }
        get actualUseSingleShadow() {
            return this.m;
        }
        set actualUseSingleShadow(a) {
            this.m = a;
            this.g("ActualUseSingleShadow");
        }
        get shadowOffsetX() {
            return this.as;
        }
        set shadowOffsetX(a) {
            this.as = a;
            this.g("ShadowOffsetX");
        }
        get actualShadowOffsetX() {
            return this.ah;
        }
        set actualShadowOffsetX(a) {
            this.ah = a;
            this.g("ActualShadowOffsetX");
        }
        get shadowOffsetY() {
            return this.at;
        }
        set shadowOffsetY(a) {
            this.at = a;
            this.g("ShadowOffsetY");
        }
        get actualShadowOffsetY() {
            return this.ai;
        }
        set actualShadowOffsetY(a) {
            this.ai = a;
            this.g("ActualShadowOffsetY");
        }
        get lineCap() {
            return this.cr;
        }
        set lineCap(a) {
            this.cr = a;
            this.g("LineCap");
        }
        get actualLineCap() {
            return this.b0;
        }
        set actualLineCap(a) {
            this.b0 = a;
            this.g("ActualLineCap");
        }
        get legendItemBadgeTemplateRef() {
            return this.co;
        }
        set legendItemBadgeTemplateRef(a) {
            this.co = a;
            this.g("LegendItemBadgeTemplateRef");
        }
        get actualLegendItemBadgeTemplateRef() {
            return this.bx;
        }
        set actualLegendItemBadgeTemplateRef(a) {
            this.bx = a;
            this.g("ActualLegendItemBadgeTemplateRef");
        }
        get legendItemTemplateRef() {
            return this.cp;
        }
        set legendItemTemplateRef(a) {
            this.cp = a;
            this.g("LegendItemTemplateRef");
        }
        get actualLegendItemTemplateRef() {
            return this.by;
        }
        set actualLegendItemTemplateRef(a) {
            this.by = a;
            this.g("ActualLegendItemTemplateRef");
        }
        get legendItemVisibility() {
            return this.cq;
        }
        set legendItemVisibility(a) {
            this.cq = a;
            this.g("LegendItemVisibility");
        }
        get actualLegendItemVisibility() {
            return this.bz;
        }
        set actualLegendItemVisibility(a) {
            this.bz = a;
            this.g("ActualLegendItemVisibility");
        }
        get legendItemBadgeShape() {
            return this.cn;
        }
        set legendItemBadgeShape(a) {
            this.cn = a;
            this.g("LegendItemBadgeShape");
        }
        get legendItemBadgeMode() {
            return this.cm;
        }
        set legendItemBadgeMode(a) {
            this.cm = a;
            this.g("LegendItemBadgeMode");
        }
        get actualLegendItemBadgeShape() {
            return this.bw;
        }
        set actualLegendItemBadgeShape(a) {
            this.bw = a;
            this.g("ActualLegendItemBadgeShape");
        }
        get actualLegendItemBadgeMode() {
            return this.bv;
        }
        set actualLegendItemBadgeMode(a) {
            this.bv = a;
            this.g("ActualLegendItemBadgeMode");
        }
        get markerBrush() {
            return this.cs;
        }
        set markerBrush(a) {
            this.cs = a;
            this.g("MarkerBrush");
        }
        get actualMarkerBrush() {
            return this.b1;
        }
        set actualMarkerBrush(a) {
            this.b1 = a;
            this.g("ActualMarkerBrush");
        }
        get markerOutline() {
            return this.cu;
        }
        set markerOutline(a) {
            this.cu = a;
            this.g("MarkerOutline");
        }
        get actualMarkerOutline() {
            return this.b3;
        }
        set actualMarkerOutline(a) {
            this.b3 = a;
            this.g("ActualMarkerOutline");
        }
        get markerTemplateRef() {
            return this.cw;
        }
        set markerTemplateRef(a) {
            this.cw = a;
            this.g("MarkerTemplateRef");
        }
        get actualMarkerTemplateRef() {
            return this.b5;
        }
        set actualMarkerTemplateRef(a) {
            this.b5 = a;
            this.g("ActualMarkerTemplateRef");
        }
        get markerType() {
            return this.cx;
        }
        set markerType(a) {
            this.cx = a;
            this.g("MarkerType");
        }
        get actualMarkerType() {
            return this.b6;
        }
        set actualMarkerType(a) {
            this.b6 = a;
            this.g("ActualMarkerType");
        }
        get markerFillMode() {
            return this.ct;
        }
        set markerFillMode(a) {
            this.ct = a;
            this.g("MarkerFillMode");
        }
        get actualMarkerFillMode() {
            return this.b2;
        }
        set actualMarkerFillMode(a) {
            this.b2 = a;
            this.g("ActualMarkerFillMode");
        }
        get markerOutlineMode() {
            return this.cv;
        }
        set markerOutlineMode(a) {
            this.cv = a;
            this.g("MarkerOutlineMode");
        }
        get actualMarkerOutlineMode() {
            return this.b4;
        }
        set actualMarkerOutlineMode(a) {
            this.b4 = a;
            this.g("ActualMarkerOutlineMode");
        }
        get name() {
            return this.cy;
        }
        set name(a) {
            this.cy = a;
            this.g("Name");
        }
        get opacity() {
            return this.ao;
        }
        set opacity(a) {
            this.ao = a;
            this.g("Opacity");
        }
        get actualOpacity() {
            return this.ad;
        }
        set actualOpacity(a) {
            this.ad = a;
            this.g("ActualOpacity");
        }
        get outline() {
            return this.cz;
        }
        set outline(a) {
            this.cz = a;
            this.g("Outline");
        }
        get actualOutline() {
            return this.b7;
        }
        set actualOutline(a) {
            this.b7 = a;
            this.g("ActualOutline");
        }
        get areaFillOpacity() {
            return this.ak;
        }
        set areaFillOpacity(a) {
            this.ak = a;
            this.g("AreaFillOpacity");
        }
        get actualAreaFillOpacity() {
            return this.z;
        }
        set actualAreaFillOpacity(a) {
            this.z = a;
            this.g("ActualAreaFillOpacity");
        }
        get markerFillOpacity() {
            return this.am;
        }
        set markerFillOpacity(a) {
            this.am = a;
            this.g("MarkerFillOpacity");
        }
        get actualMarkerFillOpacity() {
            return this.ab;
        }
        set actualMarkerFillOpacity(a) {
            this.ab = a;
            this.g("ActualMarkerFillOpacity");
        }
        get outlineMode() {
            return this.c0;
        }
        set outlineMode(a) {
            this.c0 = a;
            this.g("OutlineMode");
        }
        get actualOutlineMode() {
            return this.b8;
        }
        set actualOutlineMode(a) {
            this.b8 = a;
            this.g("ActualOutlineMode");
        }
        get highlightingFadeOpacity() {
            return this.al;
        }
        set highlightingFadeOpacity(a) {
            this.al = a;
            this.g("HighlightingFadeOpacity");
        }
        get actualHighlightingFadeOpacity() {
            return this.aa;
        }
        set actualHighlightingFadeOpacity(a) {
            this.aa = a;
            this.g("ActualHighlightingFadeOpacity");
        }
        get actualHighlightedValuesDisplayMode() {
            return this.bu;
        }
        set actualHighlightedValuesDisplayMode(a) {
            this.bu = a;
            this.g("ActualHighlightedValuesDisplayMode");
        }
        get radiusX() {
            return this.ap;
        }
        set radiusX(a) {
            this.ap = a;
            this.g("RadiusX");
        }
        get actualRadiusX() {
            return this.ae;
        }
        set actualRadiusX(a) {
            this.ae = a;
            this.g("ActualRadiusX");
        }
        get actualIsSplineShapePartOfRange() {
            return this.k;
        }
        set actualIsSplineShapePartOfRange(a) {
            this.k = a;
            this.g("ActualIsSplineShapePartOfRange");
        }
        get isSplineShapePartOfRange() {
            return this.o;
        }
        set isSplineShapePartOfRange(a) {
            this.o = a;
            this.g("IsSplineShapePartOfRange");
        }
        get radiusY() {
            return this.aq;
        }
        set radiusY(a) {
            this.aq = a;
            this.g("RadiusY");
        }
        get actualRadiusY() {
            return this.af;
        }
        set actualRadiusY(a) {
            this.af = a;
            this.g("ActualRadiusY");
        }
        get thickness() {
            return this.au;
        }
        set thickness(a) {
            this.au = a;
            this.g("Thickness");
        }
        get actualThickness() {
            return this.aj;
        }
        set actualThickness(a) {
            this.aj = a;
            this.g("ActualThickness");
        }
        get markerThickness() {
            return this.an;
        }
        set markerThickness(a) {
            this.an = a;
            this.g("MarkerThickness");
        }
        get actualMarkerThickness() {
            return this.ac;
        }
        set actualMarkerThickness(a) {
            this.ac = a;
            this.g("ActualMarkerThickness");
        }
        get title() {
            return this.bp;
        }
        set title(a) {
            this.bp = a;
            this.g("Title");
        }
        get transitionEasingFunctionRef() {
            return this.c4;
        }
        set transitionEasingFunctionRef(a) {
            this.c4 = a;
            this.g("TransitionEasingFunctionRef");
        }
        get transitionDuration() {
            return this.bj;
        }
        set transitionDuration(a) {
            this.bj = a;
            this.g("TransitionDuration");
        }
        get transitionInDuration() {
            return this.bk;
        }
        set transitionInDuration(a) {
            this.bk = a;
            this.g("TransitionInDuration");
        }
        get transitionInEasingFunctionRef() {
            return this.c5;
        }
        set transitionInEasingFunctionRef(a) {
            this.c5 = a;
            this.g("TransitionInEasingFunctionRef");
        }
        get transitionInMode() {
            return this.c6;
        }
        set transitionInMode(a) {
            this.c6 = a;
            this.g("TransitionInMode");
        }
        get isTransitionInEnabled() {
            return this.p;
        }
        set isTransitionInEnabled(a) {
            this.p = a;
            this.g("IsTransitionInEnabled");
        }
        get transitionInSpeedType() {
            return this.c7;
        }
        set transitionInSpeedType(a) {
            this.c7 = a;
            this.g("TransitionInSpeedType");
        }
        get actualIsTransitionInEnabled() {
            return this.l;
        }
        set actualIsTransitionInEnabled(a) {
            this.l = a;
            this.g("ActualIsTransitionInEnabled");
        }
        get actualTransitionInDuration() {
            return this.bi;
        }
        set actualTransitionInDuration(a) {
            this.bi = a;
            this.g("ActualTransitionInDuration");
        }
        get actualTransitionInMode() {
            return this.cc;
        }
        set actualTransitionInMode(a) {
            this.cc = a;
            this.g("ActualTransitionInMode");
        }
        get actualTransitionInSpeedType() {
            return this.cd;
        }
        set actualTransitionInSpeedType(a) {
            this.cd = a;
            this.g("ActualTransitionInSpeedType");
        }
        get actualTransitionInEasingFunctionRef() {
            return this.cb;
        }
        set actualTransitionInEasingFunctionRef(a) {
            this.cb = a;
            this.g("ActualTransitionInEasingFunctionRef");
        }
        get actualTransitionEasingFunctionRef() {
            return this.ca;
        }
        set actualTransitionEasingFunctionRef(a) {
            this.ca = a;
            this.g("ActualTransitionEasingFunctionRef");
        }
        get actualTransitionDuration() {
            return this.bh;
        }
        set actualTransitionDuration(a) {
            this.bh = a;
            this.g("ActualTransitionDuration");
        }
        get valueMemberPath() {
            return this.da;
        }
        set valueMemberPath(a) {
            this.da = a;
            this.g("ValueMemberPath");
        }
        get valueMemberAsLegendLabel() {
            return this.c8;
        }
        set valueMemberAsLegendLabel(a) {
            this.c8 = a;
            this.g("ValueMemberAsLegendLabel");
        }
        get valueMemberAsLegendUnit() {
            return this.c9;
        }
        set valueMemberAsLegendUnit(a) {
            this.c9 = a;
            this.g("ValueMemberAsLegendUnit");
        }
        get actualValueMemberAsLegendLabel() {
            return this.ce;
        }
        set actualValueMemberAsLegendLabel(a) {
            this.ce = a;
            this.g("ActualValueMemberAsLegendLabel");
        }
        get actualValueMemberAsLegendUnit() {
            return this.cf;
        }
        set actualValueMemberAsLegendUnit(a) {
            this.cf = a;
            this.g("ActualValueMemberAsLegendUnit");
        }
        get dataLegendGroup() {
            return this.ci;
        }
        set dataLegendGroup(a) {
            this.ci = a;
            this.g("DataLegendGroup");
        }
        get highlightedValuesDataLegendGroup() {
            return this.cl;
        }
        set highlightedValuesDataLegendGroup(a) {
            this.cl = a;
            this.g("HighlightedValuesDataLegendGroup");
        }
        get actualDataLegendGroup() {
            return this.bs;
        }
        set actualDataLegendGroup(a) {
            this.bs = a;
            this.g("ActualDataLegendGroup");
        }
        get actualHighlightedValuesDataLegendGroup() {
            return this.bt;
        }
        set actualHighlightedValuesDataLegendGroup(a) {
            this.bt = a;
            this.g("ActualHighlightedValuesDataLegendGroup");
        }
        get visibility() {
            return this.db;
        }
        set visibility(a) {
            this.db = a;
            this.g("Visibility");
        }
        get actualVisibility() {
            return this.cg;
        }
        set actualVisibility(a) {
            this.cg = a;
            this.g("ActualVisibility");
        }
        get parentOrLocalBrush() {
            return this.c1;
        }
        set parentOrLocalBrush(a) {
            this.c1 = a;
            this.g("ParentOrLocalBrush");
        }
        get propertyUpdatedRef() {
            return this.c2;
        }
        set propertyUpdatedRef(a) {
            this.c2 = a;
            this.g("PropertyUpdatedRef");
        }
    }
    StackedFragmentSeriesDescription.$t = /*@__PURE__*/ markType(StackedFragmentSeriesDescription, 'StackedFragmentSeriesDescription', Description.$);
    return StackedFragmentSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedFragmentSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedFragmentSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StackedFragmentSeriesDescriptionMetadata.a == null) {
                StackedFragmentSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedFragmentSeriesDescriptionMetadata.c(StackedFragmentSeriesDescriptionMetadata.a);
            }
            if (a.k(StackedFragmentSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(StackedFragmentSeriesDescriptionMetadata.a);
            PropertyUpdatedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)DataRef::object");
            a.item("HighlightedDataSourceRef", "(w:HighlightedItemsSource,xam:HighlightedItemsSource,wf:HighlightedItemsSource)DataRef::object");
            a.item("Brush", "Brush");
            a.item("ActualBrush", "Brush");
            a.item("DashArray", "DoubleCollection:double");
            a.item("IsDropShadowEnabled", "Boolean");
            a.item("ActualIsDropShadowEnabled", "Boolean");
            a.item("ShadowBlur", "Number:double");
            a.item("ActualShadowBlur", "Number:double");
            a.item("ShadowColor", "Color");
            a.item("ActualShadowColor", "Color");
            a.item("UseSingleShadow", "Boolean");
            a.item("ActualUseSingleShadow", "Boolean");
            a.item("ShadowOffsetX", "Number:double");
            a.item("ActualShadowOffsetX", "Number:double");
            a.item("ShadowOffsetY", "Number:double");
            a.item("ActualShadowOffsetY", "Number:double");
            a.item("LineCap", "ExportedType:string:PenLineCap");
            a.item("LineCap@names", "Flat;Square;Round;Triangle");
            a.item("ActualLineCap", "ExportedType:string:PenLineCap");
            a.item("ActualLineCap@names", "Flat;Square;Round;Triangle");
            a.item("LegendItemBadgeTemplateRef", "(w:LegendItemBadgeTemplate,wf:LegendItemBadgeTemplate)DataRef::object");
            a.item("ActualLegendItemBadgeTemplateRef", "(w:ActualLegendItemBadgeTemplate,wf:ActualLegendItemBadgeTemplate)DataRef::object");
            a.item("LegendItemTemplateRef", "(w:LegendItemTemplate,wf:LegendItemTemplate)DataRef::object");
            a.item("ActualLegendItemTemplateRef", "(w:ActualLegendItemTemplate,wf:ActualLegendItemTemplate)DataRef::object");
            a.item("LegendItemVisibility", "ExportedType:string:Visibility");
            a.item("LegendItemVisibility@names", "Visible;Collapsed");
            a.item("ActualLegendItemVisibility", "ExportedType:string:Visibility");
            a.item("ActualLegendItemVisibility@names", "Visible;Collapsed");
            a.item("LegendItemBadgeShape", "ExportedType:string:LegendItemBadgeShape");
            a.item("LegendItemBadgeShape@names", "Automatic;Circle;Line;Square;Marker;Bar;Column;Hidden");
            a.item("LegendItemBadgeMode", "ExportedType:string:LegendItemBadgeMode");
            a.item("LegendItemBadgeMode@names", "Simplified;MatchSeries");
            a.item("ActualLegendItemBadgeShape", "ExportedType:string:LegendItemBadgeShape");
            a.item("ActualLegendItemBadgeShape@names", "Automatic;Circle;Line;Square;Marker;Bar;Column;Hidden");
            a.item("ActualLegendItemBadgeMode", "ExportedType:string:LegendItemBadgeMode");
            a.item("ActualLegendItemBadgeMode@names", "Simplified;MatchSeries");
            a.item("MarkerBrush", "Brush");
            a.item("ActualMarkerBrush", "Brush");
            a.item("MarkerOutline", "Brush");
            a.item("ActualMarkerOutline", "Brush");
            a.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            a.item("ActualMarkerTemplateRef", "(w:ActualMarkerTemplate,wf:ActualMarkerTemplate)DataRef::object");
            a.item("MarkerType", "ExportedType:string:MarkerType");
            a.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            a.item("ActualMarkerType", "ExportedType:string:MarkerType");
            a.item("ActualMarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            a.item("MarkerFillMode", "ExportedType:string:MarkerFillMode");
            a.item("MarkerFillMode@names", "Auto;Normal;MatchMarkerOutline");
            a.item("ActualMarkerFillMode", "ExportedType:string:MarkerFillMode");
            a.item("ActualMarkerFillMode@names", "Auto;Normal;MatchMarkerOutline");
            a.item("MarkerOutlineMode", "ExportedType:string:MarkerOutlineMode");
            a.item("MarkerOutlineMode@names", "Auto;Normal;MatchMarkerBrush");
            a.item("ActualMarkerOutlineMode", "ExportedType:string:MarkerOutlineMode");
            a.item("ActualMarkerOutlineMode@names", "Auto;Normal;MatchMarkerBrush");
            a.item("Name", "String");
            a.item("Opacity", "Number:double");
            a.item("ActualOpacity", "Number:double");
            a.item("Outline", "Brush");
            a.item("ActualOutline", "Brush");
            a.item("AreaFillOpacity", "Number:double");
            a.item("ActualAreaFillOpacity", "Number:double");
            a.item("MarkerFillOpacity", "Number:double");
            a.item("ActualMarkerFillOpacity", "Number:double");
            a.item("OutlineMode", "ExportedType:string:SeriesOutlineMode");
            a.item("OutlineMode@names", "Auto;Visible;Collapsed");
            a.item("ActualOutlineMode", "ExportedType:string:SeriesOutlineMode");
            a.item("ActualOutlineMode@names", "Auto;Visible;Collapsed");
            a.item("HighlightingFadeOpacity", "Number:double");
            a.item("ActualHighlightingFadeOpacity", "Number:double");
            a.item("ActualHighlightedValuesDisplayMode", "ExportedType:string:SeriesHighlightedValuesDisplayMode");
            a.item("ActualHighlightedValuesDisplayMode@names", "Auto;Hidden;Overlay");
            a.item("RadiusX", "Number:double");
            a.item("ActualRadiusX", "Number:double");
            a.item("ActualIsSplineShapePartOfRange", "Boolean");
            a.item("IsSplineShapePartOfRange", "Boolean");
            a.item("RadiusY", "Number:double");
            a.item("ActualRadiusY", "Number:double");
            a.item("Thickness", "Number:double");
            a.item("ActualThickness", "Number:double");
            a.item("MarkerThickness", "Number:double");
            a.item("ActualMarkerThickness", "Number:double");
            a.item("Title", "Unknown");
            a.item("TransitionEasingFunctionRef", "(w:TransitionEasingFunction,wf:TransitionEasingFunction)MethodRef");
            a.item("TransitionDuration", "Number:int");
            a.item("TransitionInDuration", "Number:int");
            a.item("TransitionInEasingFunctionRef", "(w:TransitionInEasingFunction,wf:TransitionInEasingFunction)MethodRef");
            a.item("TransitionInMode", "ExportedType:string:CategoryTransitionInMode");
            a.item("TransitionInMode@names", "Auto;FromZero;SweepFromLeft;SweepFromRight;SweepFromTop;SweepFromBottom;SweepFromCenter;AccordionFromLeft;AccordionFromRight;AccordionFromTop;AccordionFromBottom;Expand;SweepFromCategoryAxisMinimum;SweepFromCategoryAxisMaximum;SweepFromValueAxisMinimum;SweepFromValueAxisMaximum;AccordionFromCategoryAxisMinimum;AccordionFromCategoryAxisMaximum;AccordionFromValueAxisMinimum;AccordionFromValueAxisMaximum;FromParent");
            a.item("IsTransitionInEnabled", "Boolean");
            a.item("TransitionInSpeedType", "ExportedType:string:TransitionInSpeedType");
            a.item("TransitionInSpeedType@names", "Auto;Normal;ValueScaled;IndexScaled;Random");
            a.item("ActualIsTransitionInEnabled", "Boolean");
            a.item("ActualTransitionInDuration", "Number:int");
            a.item("ActualTransitionInMode", "ExportedType:string:CategoryTransitionInMode");
            a.item("ActualTransitionInMode@names", "Auto;FromZero;SweepFromLeft;SweepFromRight;SweepFromTop;SweepFromBottom;SweepFromCenter;AccordionFromLeft;AccordionFromRight;AccordionFromTop;AccordionFromBottom;Expand;SweepFromCategoryAxisMinimum;SweepFromCategoryAxisMaximum;SweepFromValueAxisMinimum;SweepFromValueAxisMaximum;AccordionFromCategoryAxisMinimum;AccordionFromCategoryAxisMaximum;AccordionFromValueAxisMinimum;AccordionFromValueAxisMaximum;FromParent");
            a.item("ActualTransitionInSpeedType", "ExportedType:string:TransitionInSpeedType");
            a.item("ActualTransitionInSpeedType@names", "Auto;Normal;ValueScaled;IndexScaled;Random");
            a.item("ActualTransitionInEasingFunctionRef", "(w:ActualTransitionInEasingFunction,wf:ActualTransitionInEasingFunction)MethodRef");
            a.item("ActualTransitionEasingFunctionRef", "(w:ActualTransitionEasingFunction,wf:ActualTransitionEasingFunction)MethodRef");
            a.item("ActualTransitionDuration", "Number:int");
            a.item("ValueMemberPath", "String");
            a.item("ValueMemberAsLegendLabel", "String");
            a.item("ValueMemberAsLegendUnit", "String");
            a.item("ActualValueMemberAsLegendLabel", "String");
            a.item("ActualValueMemberAsLegendUnit", "String");
            a.item("DataLegendGroup", "String");
            a.item("HighlightedValuesDataLegendGroup", "String");
            a.item("ActualDataLegendGroup", "String");
            a.item("ActualHighlightedValuesDataLegendGroup", "String");
            a.item("Visibility", "ExportedType:string:Visibility");
            a.item("Visibility@names", "Visible;Collapsed");
            a.item("ActualVisibility", "ExportedType:string:Visibility");
            a.item("ActualVisibility@names", "Visible;Collapsed");
            a.item("ParentOrLocalBrush", "Brush");
            a.item("PropertyUpdatedRef", "EventRef::propertyUpdated");
        }
        static d(a) {
            StackedFragmentSeriesDescriptionMetadata.b(a);
            a.ae("StackedFragmentSeries", () => new StackedFragmentSeriesDescription());
            a.ad("StackedFragmentSeries", StackedFragmentSeriesDescriptionMetadata.a);
        }
    }
    StackedFragmentSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedFragmentSeriesDescriptionMetadata, 'StackedFragmentSeriesDescriptionMetadata');
    StackedFragmentSeriesDescriptionMetadata.a = null;
    return StackedFragmentSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedFragmentSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StackedFragmentSeriesDescriptionModule extends Base {
        static register(a) {
            StackedFragmentSeriesDescriptionMetadata.d(a);
        }
    }
    StackedFragmentSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StackedFragmentSeriesDescriptionModule, 'StackedFragmentSeriesDescriptionModule');
    return StackedFragmentSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSeriesCreatedEventArgsDescription = /*@__PURE__*/ (() => {
    class StackedSeriesCreatedEventArgsDescription extends Description {
        get_type() {
            return "StackedSeriesCreatedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.r = null;
            this.t = null;
            this.s = null;
            this.u = null;
            this.aa = null;
            this.h = null;
            this.m = 0;
            this.ab = null;
            this.p = 0;
            this.ac = null;
            this.w = null;
            this.x = null;
            this.j = null;
            this.y = null;
            this.z = null;
            this.l = 0;
            this.v = null;
        }
        get brush() {
            return this.r;
        }
        set brush(a) {
            this.r = a;
            this.g("Brush");
        }
        get legendItemTemplateRef() {
            return this.t;
        }
        set legendItemTemplateRef(a) {
            this.t = a;
            this.g("LegendItemTemplateRef");
        }
        get legendItemBadgeTemplateRef() {
            return this.s;
        }
        set legendItemBadgeTemplateRef(a) {
            this.s = a;
            this.g("LegendItemBadgeTemplateRef");
        }
        get legendItemVisibility() {
            return this.u;
        }
        set legendItemVisibility(a) {
            this.u = a;
            this.g("LegendItemVisibility");
        }
        get outline() {
            return this.aa;
        }
        set outline(a) {
            this.aa = a;
            this.g("Outline");
        }
        get dashArray() {
            return this.h;
        }
        set dashArray(a) {
            this.h = a;
            this.g("DashArray");
        }
        get thickness() {
            return this.m;
        }
        set thickness(a) {
            this.m = a;
            this.g("Thickness");
        }
        get titleRef() {
            return this.ab;
        }
        set titleRef(a) {
            this.ab = a;
            this.g("TitleRef");
        }
        get transitionDuration() {
            return this.p;
        }
        set transitionDuration(a) {
            this.p = a;
            this.g("TransitionDuration");
        }
        get transitionEasingFunctionRef() {
            return this.ac;
        }
        set transitionEasingFunctionRef(a) {
            this.ac = a;
            this.g("TransitionEasingFunctionRef");
        }
        get markerBrush() {
            return this.w;
        }
        set markerBrush(a) {
            this.w = a;
            this.g("MarkerBrush");
        }
        get markerOutline() {
            return this.x;
        }
        set markerOutline(a) {
            this.x = a;
            this.g("MarkerOutline");
        }
        get markerStyle() {
            return this.j;
        }
        set markerStyle(a) {
            this.j = a;
            this.g("MarkerStyle");
        }
        get markerTemplateRef() {
            return this.y;
        }
        set markerTemplateRef(a) {
            this.y = a;
            this.g("MarkerTemplateRef");
        }
        get markerType() {
            return this.z;
        }
        set markerType(a) {
            this.z = a;
            this.g("MarkerType");
        }
        get markerThickness() {
            return this.l;
        }
        set markerThickness(a) {
            this.l = a;
            this.g("MarkerThickness");
        }
        get lineCap() {
            return this.v;
        }
        set lineCap(a) {
            this.v = a;
            this.g("LineCap");
        }
    }
    StackedSeriesCreatedEventArgsDescription.$t = /*@__PURE__*/ markType(StackedSeriesCreatedEventArgsDescription, 'StackedSeriesCreatedEventArgsDescription', Description.$);
    return StackedSeriesCreatedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSeriesCreatedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedSeriesCreatedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (StackedSeriesCreatedEventArgsDescriptionMetadata.a == null) {
                StackedSeriesCreatedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedSeriesCreatedEventArgsDescriptionMetadata.c(StackedSeriesCreatedEventArgsDescriptionMetadata.a);
            }
            if (a.k(StackedSeriesCreatedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(StackedSeriesCreatedEventArgsDescriptionMetadata.a);
            StyleDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Brush", "Brush");
            a.item("LegendItemTemplateRef", "(w:LegendItemTemplate,wf:LegendItemTemplate)DataRef::object");
            a.item("LegendItemBadgeTemplateRef", "(w:LegendItemBadgeTemplate,wf:LegendItemBadgeTemplate)DataRef::object");
            a.item("LegendItemVisibility", "ExportedType:string:Visibility");
            a.item("LegendItemVisibility@names", "Visible;Collapsed");
            a.item("Outline", "Brush");
            a.item("DashArray", "DoubleCollection:double");
            a.item("Thickness", "Number:double");
            a.item("TitleRef", "(w:Title,wf:Title)DataRef");
            a.item("TransitionDuration", "Number:int");
            a.item("TransitionEasingFunctionRef", "(w:TransitionEasingFunction,wf:TransitionEasingFunction)MethodRef");
            a.item("MarkerBrush", "Brush");
            a.item("MarkerOutline", "Brush");
            a.item("MarkerStyle", "ExportedType:Style");
            a.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            a.item("MarkerType", "ExportedType:string:MarkerType");
            a.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            a.item("MarkerThickness", "Number:double");
            a.item("LineCap", "ExportedType:string:PenLineCap");
            a.item("LineCap@names", "Flat;Square;Round;Triangle");
        }
        static d(a) {
            StackedSeriesCreatedEventArgsDescriptionMetadata.b(a);
            a.ae("StackedSeriesCreatedEventArgs", () => new StackedSeriesCreatedEventArgsDescription());
            a.ad("StackedSeriesCreatedEventArgs", StackedSeriesCreatedEventArgsDescriptionMetadata.a);
        }
    }
    StackedSeriesCreatedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedSeriesCreatedEventArgsDescriptionMetadata, 'StackedSeriesCreatedEventArgsDescriptionMetadata');
    StackedSeriesCreatedEventArgsDescriptionMetadata.a = null;
    return StackedSeriesCreatedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (StackedSeriesBaseDescriptionMetadata.a == null) {
                StackedSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedSeriesBaseDescriptionMetadata.c(StackedSeriesBaseDescriptionMetadata.a);
            }
            if (a.k(StackedSeriesBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(StackedSeriesBaseDescriptionMetadata.a);
            StackedSeriesCreatedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            CategorySeriesDescriptionMetadata.c(a);
            a.item("Series", "Collection:StackedFragmentSeries:StackedSeriesCollection:StackedFragmentSeries");
            a.item("AutoGenerateSeries", "Boolean");
            a.item("ReverseLegendOrder", "Boolean");
            a.item("SeriesCreatedRef", "EventRef::seriesCreated");
            StackedSeriesBaseDescriptionMetadata.e(a);
        }
        static d(a) {
            StackedSeriesBaseDescriptionMetadata.b(a);
            a.ad("StackedSeriesBase", StackedSeriesBaseDescriptionMetadata.a);
        }
        static e(a) {
        }
    }
    StackedSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedSeriesBaseDescriptionMetadata, 'StackedSeriesBaseDescriptionMetadata');
    StackedSeriesBaseDescriptionMetadata.a = null;
    return StackedSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalStackedSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class HorizontalStackedSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (HorizontalStackedSeriesBaseDescriptionMetadata.a == null) {
                HorizontalStackedSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HorizontalStackedSeriesBaseDescriptionMetadata.c(HorizontalStackedSeriesBaseDescriptionMetadata.a);
            }
            if (a.k(HorizontalStackedSeriesBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(HorizontalStackedSeriesBaseDescriptionMetadata.a);
        }
        static c(a) {
            StackedSeriesBaseDescriptionMetadata.c(a);
            a.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            a.item("XAxisRef@nameBinding", "true");
            a.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            a.item("YAxisRef@nameBinding", "true");
        }
        static d(a) {
            HorizontalStackedSeriesBaseDescriptionMetadata.b(a);
            a.ad("HorizontalStackedSeriesBase", HorizontalStackedSeriesBaseDescriptionMetadata.a);
        }
    }
    HorizontalStackedSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(HorizontalStackedSeriesBaseDescriptionMetadata, 'HorizontalStackedSeriesBaseDescriptionMetadata');
    HorizontalStackedSeriesBaseDescriptionMetadata.a = null;
    return HorizontalStackedSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSeriesBaseDescription = /*@__PURE__*/ (() => {
    class StackedSeriesBaseDescription extends CategorySeriesDescription {
        get_type() {
            return "StackedSeriesBase";
        }
        constructor() {
            super();
            this.f1 = null;
            this.f3 = false;
            this.f4 = false;
            this.f7 = null;
        }
        get series() {
            return this.f1;
        }
        set series(a) {
            this.f1 = a;
            this.g("Series");
        }
        get autoGenerateSeries() {
            return this.f3;
        }
        set autoGenerateSeries(a) {
            this.f3 = a;
            this.g("AutoGenerateSeries");
        }
        get reverseLegendOrder() {
            return this.f4;
        }
        set reverseLegendOrder(a) {
            this.f4 = a;
            this.g("ReverseLegendOrder");
        }
        get seriesCreatedRef() {
            return this.f7;
        }
        set seriesCreatedRef(a) {
            this.f7 = a;
            this.g("SeriesCreatedRef");
        }
    }
    StackedSeriesBaseDescription.$t = /*@__PURE__*/ markType(StackedSeriesBaseDescription, 'StackedSeriesBaseDescription', CategorySeriesDescription.$);
    return StackedSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalStackedSeriesBaseDescription = /*@__PURE__*/ (() => {
    class HorizontalStackedSeriesBaseDescription extends StackedSeriesBaseDescription {
        get_type() {
            return "HorizontalStackedSeriesBase";
        }
        constructor() {
            super();
            this.f9 = null;
            this.ga = null;
        }
        get xAxisRef() {
            return this.f9;
        }
        set xAxisRef(a) {
            this.f9 = a;
            this.g("XAxisRef");
        }
        get yAxisRef() {
            return this.ga;
        }
        set yAxisRef(a) {
            this.ga = a;
            this.g("YAxisRef");
        }
    }
    HorizontalStackedSeriesBaseDescription.$t = /*@__PURE__*/ markType(HorizontalStackedSeriesBaseDescription, 'HorizontalStackedSeriesBaseDescription', StackedSeriesBaseDescription.$);
    return HorizontalStackedSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedAreaSeriesDescription = /*@__PURE__*/ (() => {
    class StackedAreaSeriesDescription extends HorizontalStackedSeriesBaseDescription {
        get_type() {
            return "StackedAreaSeries";
        }
        constructor() {
            super();
        }
    }
    StackedAreaSeriesDescription.$t = /*@__PURE__*/ markType(StackedAreaSeriesDescription, 'StackedAreaSeriesDescription', HorizontalStackedSeriesBaseDescription.$);
    return StackedAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StackedAreaSeriesDescriptionMetadata.a == null) {
                StackedAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedAreaSeriesDescriptionMetadata.c(StackedAreaSeriesDescriptionMetadata.a);
            }
            if (a.k(StackedAreaSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(StackedAreaSeriesDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalStackedSeriesBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            StackedAreaSeriesDescriptionMetadata.b(a);
            a.ae("StackedAreaSeries", () => new StackedAreaSeriesDescription());
            a.ad("StackedAreaSeries", StackedAreaSeriesDescriptionMetadata.a);
        }
    }
    StackedAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedAreaSeriesDescriptionMetadata, 'StackedAreaSeriesDescriptionMetadata');
    StackedAreaSeriesDescriptionMetadata.a = null;
    return StackedAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StackedAreaSeriesDescriptionModule extends Base {
        static register(a) {
            StackedAreaSeriesDescriptionMetadata.d(a);
        }
    }
    StackedAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StackedAreaSeriesDescriptionModule, 'StackedAreaSeriesDescriptionModule');
    return StackedAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100AreaSeriesDescription = /*@__PURE__*/ (() => {
    class Stacked100AreaSeriesDescription extends StackedAreaSeriesDescription {
        get_type() {
            return "Stacked100AreaSeries";
        }
        constructor() {
            super();
        }
    }
    Stacked100AreaSeriesDescription.$t = /*@__PURE__*/ markType(Stacked100AreaSeriesDescription, 'Stacked100AreaSeriesDescription', StackedAreaSeriesDescription.$);
    return Stacked100AreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100AreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class Stacked100AreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (Stacked100AreaSeriesDescriptionMetadata.a == null) {
                Stacked100AreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Stacked100AreaSeriesDescriptionMetadata.c(Stacked100AreaSeriesDescriptionMetadata.a);
            }
            if (a.k(Stacked100AreaSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(Stacked100AreaSeriesDescriptionMetadata.a);
        }
        static c(a) {
            StackedAreaSeriesDescriptionMetadata.c(a);
        }
        static d(a) {
            Stacked100AreaSeriesDescriptionMetadata.b(a);
            a.ae("Stacked100AreaSeries", () => new Stacked100AreaSeriesDescription());
            a.ad("Stacked100AreaSeries", Stacked100AreaSeriesDescriptionMetadata.a);
        }
    }
    Stacked100AreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(Stacked100AreaSeriesDescriptionMetadata, 'Stacked100AreaSeriesDescriptionMetadata');
    Stacked100AreaSeriesDescriptionMetadata.a = null;
    return Stacked100AreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100AreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class Stacked100AreaSeriesDescriptionModule extends Base {
        static register(a) {
            StackedAreaSeriesDescriptionModule.register(a);
            Stacked100AreaSeriesDescriptionMetadata.d(a);
        }
    }
    Stacked100AreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(Stacked100AreaSeriesDescriptionModule, 'Stacked100AreaSeriesDescriptionModule');
    return Stacked100AreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VerticalStackedSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class VerticalStackedSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (VerticalStackedSeriesBaseDescriptionMetadata.a == null) {
                VerticalStackedSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                VerticalStackedSeriesBaseDescriptionMetadata.c(VerticalStackedSeriesBaseDescriptionMetadata.a);
            }
            if (a.k(VerticalStackedSeriesBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(VerticalStackedSeriesBaseDescriptionMetadata.a);
        }
        static c(a) {
            StackedSeriesBaseDescriptionMetadata.c(a);
            a.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            a.item("XAxisRef@nameBinding", "true");
            a.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            a.item("YAxisRef@nameBinding", "true");
        }
        static d(a) {
            VerticalStackedSeriesBaseDescriptionMetadata.b(a);
            a.ad("VerticalStackedSeriesBase", VerticalStackedSeriesBaseDescriptionMetadata.a);
        }
    }
    VerticalStackedSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(VerticalStackedSeriesBaseDescriptionMetadata, 'VerticalStackedSeriesBaseDescriptionMetadata');
    VerticalStackedSeriesBaseDescriptionMetadata.a = null;
    return VerticalStackedSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VerticalStackedSeriesBaseDescription = /*@__PURE__*/ (() => {
    class VerticalStackedSeriesBaseDescription extends StackedSeriesBaseDescription {
        get_type() {
            return "VerticalStackedSeriesBase";
        }
        constructor() {
            super();
            this.f9 = null;
            this.ga = null;
        }
        get xAxisRef() {
            return this.f9;
        }
        set xAxisRef(a) {
            this.f9 = a;
            this.g("XAxisRef");
        }
        get yAxisRef() {
            return this.ga;
        }
        set yAxisRef(a) {
            this.ga = a;
            this.g("YAxisRef");
        }
    }
    VerticalStackedSeriesBaseDescription.$t = /*@__PURE__*/ markType(VerticalStackedSeriesBaseDescription, 'VerticalStackedSeriesBaseDescription', StackedSeriesBaseDescription.$);
    return VerticalStackedSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedBarSeriesDescription = /*@__PURE__*/ (() => {
    class StackedBarSeriesDescription extends VerticalStackedSeriesBaseDescription {
        get_type() {
            return "StackedBarSeries";
        }
        constructor() {
            super();
            this.gd = 0;
            this.ge = 0;
        }
        get radiusX() {
            return this.gd;
        }
        set radiusX(a) {
            this.gd = a;
            this.g("RadiusX");
        }
        get radiusY() {
            return this.ge;
        }
        set radiusY(a) {
            this.ge = a;
            this.g("RadiusY");
        }
    }
    StackedBarSeriesDescription.$t = /*@__PURE__*/ markType(StackedBarSeriesDescription, 'StackedBarSeriesDescription', VerticalStackedSeriesBaseDescription.$);
    return StackedBarSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedBarSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedBarSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StackedBarSeriesDescriptionMetadata.a == null) {
                StackedBarSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedBarSeriesDescriptionMetadata.c(StackedBarSeriesDescriptionMetadata.a);
            }
            if (a.k(StackedBarSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(StackedBarSeriesDescriptionMetadata.a);
        }
        static c(a) {
            VerticalStackedSeriesBaseDescriptionMetadata.c(a);
            a.item("RadiusX", "Number:double");
            a.item("RadiusY", "Number:double");
        }
        static d(a) {
            StackedBarSeriesDescriptionMetadata.b(a);
            a.ae("StackedBarSeries", () => new StackedBarSeriesDescription());
            a.ad("StackedBarSeries", StackedBarSeriesDescriptionMetadata.a);
        }
    }
    StackedBarSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedBarSeriesDescriptionMetadata, 'StackedBarSeriesDescriptionMetadata');
    StackedBarSeriesDescriptionMetadata.a = null;
    return StackedBarSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedBarSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StackedBarSeriesDescriptionModule extends Base {
        static register(a) {
            StackedBarSeriesDescriptionMetadata.d(a);
        }
    }
    StackedBarSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StackedBarSeriesDescriptionModule, 'StackedBarSeriesDescriptionModule');
    return StackedBarSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100BarSeriesDescription = /*@__PURE__*/ (() => {
    class Stacked100BarSeriesDescription extends StackedBarSeriesDescription {
        get_type() {
            return "Stacked100BarSeries";
        }
        constructor() {
            super();
        }
    }
    Stacked100BarSeriesDescription.$t = /*@__PURE__*/ markType(Stacked100BarSeriesDescription, 'Stacked100BarSeriesDescription', StackedBarSeriesDescription.$);
    return Stacked100BarSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100BarSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class Stacked100BarSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (Stacked100BarSeriesDescriptionMetadata.a == null) {
                Stacked100BarSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Stacked100BarSeriesDescriptionMetadata.c(Stacked100BarSeriesDescriptionMetadata.a);
            }
            if (a.k(Stacked100BarSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(Stacked100BarSeriesDescriptionMetadata.a);
        }
        static c(a) {
            StackedBarSeriesDescriptionMetadata.c(a);
        }
        static d(a) {
            Stacked100BarSeriesDescriptionMetadata.b(a);
            a.ae("Stacked100BarSeries", () => new Stacked100BarSeriesDescription());
            a.ad("Stacked100BarSeries", Stacked100BarSeriesDescriptionMetadata.a);
        }
    }
    Stacked100BarSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(Stacked100BarSeriesDescriptionMetadata, 'Stacked100BarSeriesDescriptionMetadata');
    Stacked100BarSeriesDescriptionMetadata.a = null;
    return Stacked100BarSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100BarSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class Stacked100BarSeriesDescriptionModule extends Base {
        static register(a) {
            StackedBarSeriesDescriptionModule.register(a);
            Stacked100BarSeriesDescriptionMetadata.d(a);
        }
    }
    Stacked100BarSeriesDescriptionModule.$t = /*@__PURE__*/ markType(Stacked100BarSeriesDescriptionModule, 'Stacked100BarSeriesDescriptionModule');
    return Stacked100BarSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedColumnSeriesDescription = /*@__PURE__*/ (() => {
    class StackedColumnSeriesDescription extends HorizontalStackedSeriesBaseDescription {
        get_type() {
            return "StackedColumnSeries";
        }
        constructor() {
            super();
            this.gd = 0;
            this.ge = 0;
        }
        get radiusX() {
            return this.gd;
        }
        set radiusX(a) {
            this.gd = a;
            this.g("RadiusX");
        }
        get radiusY() {
            return this.ge;
        }
        set radiusY(a) {
            this.ge = a;
            this.g("RadiusY");
        }
    }
    StackedColumnSeriesDescription.$t = /*@__PURE__*/ markType(StackedColumnSeriesDescription, 'StackedColumnSeriesDescription', HorizontalStackedSeriesBaseDescription.$);
    return StackedColumnSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedColumnSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedColumnSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StackedColumnSeriesDescriptionMetadata.a == null) {
                StackedColumnSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedColumnSeriesDescriptionMetadata.c(StackedColumnSeriesDescriptionMetadata.a);
            }
            if (a.k(StackedColumnSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(StackedColumnSeriesDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalStackedSeriesBaseDescriptionMetadata.c(a);
            a.item("RadiusX", "Number:double");
            a.item("RadiusY", "Number:double");
        }
        static d(a) {
            StackedColumnSeriesDescriptionMetadata.b(a);
            a.ae("StackedColumnSeries", () => new StackedColumnSeriesDescription());
            a.ad("StackedColumnSeries", StackedColumnSeriesDescriptionMetadata.a);
        }
    }
    StackedColumnSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedColumnSeriesDescriptionMetadata, 'StackedColumnSeriesDescriptionMetadata');
    StackedColumnSeriesDescriptionMetadata.a = null;
    return StackedColumnSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedColumnSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StackedColumnSeriesDescriptionModule extends Base {
        static register(a) {
            StackedColumnSeriesDescriptionMetadata.d(a);
        }
    }
    StackedColumnSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StackedColumnSeriesDescriptionModule, 'StackedColumnSeriesDescriptionModule');
    return StackedColumnSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100ColumnSeriesDescription = /*@__PURE__*/ (() => {
    class Stacked100ColumnSeriesDescription extends StackedColumnSeriesDescription {
        get_type() {
            return "Stacked100ColumnSeries";
        }
        constructor() {
            super();
        }
    }
    Stacked100ColumnSeriesDescription.$t = /*@__PURE__*/ markType(Stacked100ColumnSeriesDescription, 'Stacked100ColumnSeriesDescription', StackedColumnSeriesDescription.$);
    return Stacked100ColumnSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100ColumnSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class Stacked100ColumnSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (Stacked100ColumnSeriesDescriptionMetadata.a == null) {
                Stacked100ColumnSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Stacked100ColumnSeriesDescriptionMetadata.c(Stacked100ColumnSeriesDescriptionMetadata.a);
            }
            if (a.k(Stacked100ColumnSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(Stacked100ColumnSeriesDescriptionMetadata.a);
        }
        static c(a) {
            StackedColumnSeriesDescriptionMetadata.c(a);
        }
        static d(a) {
            Stacked100ColumnSeriesDescriptionMetadata.b(a);
            a.ae("Stacked100ColumnSeries", () => new Stacked100ColumnSeriesDescription());
            a.ad("Stacked100ColumnSeries", Stacked100ColumnSeriesDescriptionMetadata.a);
        }
    }
    Stacked100ColumnSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(Stacked100ColumnSeriesDescriptionMetadata, 'Stacked100ColumnSeriesDescriptionMetadata');
    Stacked100ColumnSeriesDescriptionMetadata.a = null;
    return Stacked100ColumnSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100ColumnSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class Stacked100ColumnSeriesDescriptionModule extends Base {
        static register(a) {
            StackedColumnSeriesDescriptionModule.register(a);
            Stacked100ColumnSeriesDescriptionMetadata.d(a);
        }
    }
    Stacked100ColumnSeriesDescriptionModule.$t = /*@__PURE__*/ markType(Stacked100ColumnSeriesDescriptionModule, 'Stacked100ColumnSeriesDescriptionModule');
    return Stacked100ColumnSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedLineSeriesDescription = /*@__PURE__*/ (() => {
    class StackedLineSeriesDescription extends HorizontalStackedSeriesBaseDescription {
        get_type() {
            return "StackedLineSeries";
        }
        constructor() {
            super();
        }
    }
    StackedLineSeriesDescription.$t = /*@__PURE__*/ markType(StackedLineSeriesDescription, 'StackedLineSeriesDescription', HorizontalStackedSeriesBaseDescription.$);
    return StackedLineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedLineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedLineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StackedLineSeriesDescriptionMetadata.a == null) {
                StackedLineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedLineSeriesDescriptionMetadata.c(StackedLineSeriesDescriptionMetadata.a);
            }
            if (a.k(StackedLineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(StackedLineSeriesDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalStackedSeriesBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            StackedLineSeriesDescriptionMetadata.b(a);
            a.ae("StackedLineSeries", () => new StackedLineSeriesDescription());
            a.ad("StackedLineSeries", StackedLineSeriesDescriptionMetadata.a);
        }
    }
    StackedLineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedLineSeriesDescriptionMetadata, 'StackedLineSeriesDescriptionMetadata');
    StackedLineSeriesDescriptionMetadata.a = null;
    return StackedLineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedLineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StackedLineSeriesDescriptionModule extends Base {
        static register(a) {
            StackedLineSeriesDescriptionMetadata.d(a);
        }
    }
    StackedLineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StackedLineSeriesDescriptionModule, 'StackedLineSeriesDescriptionModule');
    return StackedLineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100LineSeriesDescription = /*@__PURE__*/ (() => {
    class Stacked100LineSeriesDescription extends StackedLineSeriesDescription {
        get_type() {
            return "Stacked100LineSeries";
        }
        constructor() {
            super();
        }
    }
    Stacked100LineSeriesDescription.$t = /*@__PURE__*/ markType(Stacked100LineSeriesDescription, 'Stacked100LineSeriesDescription', StackedLineSeriesDescription.$);
    return Stacked100LineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100LineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class Stacked100LineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (Stacked100LineSeriesDescriptionMetadata.a == null) {
                Stacked100LineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Stacked100LineSeriesDescriptionMetadata.c(Stacked100LineSeriesDescriptionMetadata.a);
            }
            if (a.k(Stacked100LineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(Stacked100LineSeriesDescriptionMetadata.a);
        }
        static c(a) {
            StackedLineSeriesDescriptionMetadata.c(a);
        }
        static d(a) {
            Stacked100LineSeriesDescriptionMetadata.b(a);
            a.ae("Stacked100LineSeries", () => new Stacked100LineSeriesDescription());
            a.ad("Stacked100LineSeries", Stacked100LineSeriesDescriptionMetadata.a);
        }
    }
    Stacked100LineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(Stacked100LineSeriesDescriptionMetadata, 'Stacked100LineSeriesDescriptionMetadata');
    Stacked100LineSeriesDescriptionMetadata.a = null;
    return Stacked100LineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100LineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class Stacked100LineSeriesDescriptionModule extends Base {
        static register(a) {
            StackedLineSeriesDescriptionModule.register(a);
            Stacked100LineSeriesDescriptionMetadata.d(a);
        }
    }
    Stacked100LineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(Stacked100LineSeriesDescriptionModule, 'Stacked100LineSeriesDescriptionModule');
    return Stacked100LineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSplineSeriesDescription = /*@__PURE__*/ (() => {
    class StackedSplineSeriesDescription extends HorizontalStackedSeriesBaseDescription {
        get_type() {
            return "StackedSplineSeries";
        }
        constructor() {
            super();
            this.gd = false;
        }
        get isSplineShapePartOfRange() {
            return this.gd;
        }
        set isSplineShapePartOfRange(a) {
            this.gd = a;
            this.g("IsSplineShapePartOfRange");
        }
    }
    StackedSplineSeriesDescription.$t = /*@__PURE__*/ markType(StackedSplineSeriesDescription, 'StackedSplineSeriesDescription', HorizontalStackedSeriesBaseDescription.$);
    return StackedSplineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSplineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedSplineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StackedSplineSeriesDescriptionMetadata.a == null) {
                StackedSplineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedSplineSeriesDescriptionMetadata.c(StackedSplineSeriesDescriptionMetadata.a);
            }
            if (a.k(StackedSplineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(StackedSplineSeriesDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalStackedSeriesBaseDescriptionMetadata.c(a);
            a.item("IsSplineShapePartOfRange", "Boolean");
        }
        static d(a) {
            StackedSplineSeriesDescriptionMetadata.b(a);
            a.ae("StackedSplineSeries", () => new StackedSplineSeriesDescription());
            a.ad("StackedSplineSeries", StackedSplineSeriesDescriptionMetadata.a);
        }
    }
    StackedSplineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedSplineSeriesDescriptionMetadata, 'StackedSplineSeriesDescriptionMetadata');
    StackedSplineSeriesDescriptionMetadata.a = null;
    return StackedSplineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSplineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StackedSplineSeriesDescriptionModule extends Base {
        static register(a) {
            StackedSplineSeriesDescriptionMetadata.d(a);
        }
    }
    StackedSplineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StackedSplineSeriesDescriptionModule, 'StackedSplineSeriesDescriptionModule');
    return StackedSplineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100SplineSeriesDescription = /*@__PURE__*/ (() => {
    class Stacked100SplineSeriesDescription extends StackedSplineSeriesDescription {
        get_type() {
            return "Stacked100SplineSeries";
        }
        constructor() {
            super();
        }
    }
    Stacked100SplineSeriesDescription.$t = /*@__PURE__*/ markType(Stacked100SplineSeriesDescription, 'Stacked100SplineSeriesDescription', StackedSplineSeriesDescription.$);
    return Stacked100SplineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100SplineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class Stacked100SplineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (Stacked100SplineSeriesDescriptionMetadata.a == null) {
                Stacked100SplineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Stacked100SplineSeriesDescriptionMetadata.c(Stacked100SplineSeriesDescriptionMetadata.a);
            }
            if (a.k(Stacked100SplineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(Stacked100SplineSeriesDescriptionMetadata.a);
        }
        static c(a) {
            StackedSplineSeriesDescriptionMetadata.c(a);
        }
        static d(a) {
            Stacked100SplineSeriesDescriptionMetadata.b(a);
            a.ae("Stacked100SplineSeries", () => new Stacked100SplineSeriesDescription());
            a.ad("Stacked100SplineSeries", Stacked100SplineSeriesDescriptionMetadata.a);
        }
    }
    Stacked100SplineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(Stacked100SplineSeriesDescriptionMetadata, 'Stacked100SplineSeriesDescriptionMetadata');
    Stacked100SplineSeriesDescriptionMetadata.a = null;
    return Stacked100SplineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100SplineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class Stacked100SplineSeriesDescriptionModule extends Base {
        static register(a) {
            StackedSplineSeriesDescriptionModule.register(a);
            Stacked100SplineSeriesDescriptionMetadata.d(a);
        }
    }
    Stacked100SplineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(Stacked100SplineSeriesDescriptionModule, 'Stacked100SplineSeriesDescriptionModule');
    return Stacked100SplineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSplineAreaSeriesDescription = /*@__PURE__*/ (() => {
    class StackedSplineAreaSeriesDescription extends HorizontalStackedSeriesBaseDescription {
        get_type() {
            return "StackedSplineAreaSeries";
        }
        constructor() {
            super();
            this.gd = false;
        }
        get isSplineShapePartOfRange() {
            return this.gd;
        }
        set isSplineShapePartOfRange(a) {
            this.gd = a;
            this.g("IsSplineShapePartOfRange");
        }
    }
    StackedSplineAreaSeriesDescription.$t = /*@__PURE__*/ markType(StackedSplineAreaSeriesDescription, 'StackedSplineAreaSeriesDescription', HorizontalStackedSeriesBaseDescription.$);
    return StackedSplineAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSplineAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedSplineAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StackedSplineAreaSeriesDescriptionMetadata.a == null) {
                StackedSplineAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedSplineAreaSeriesDescriptionMetadata.c(StackedSplineAreaSeriesDescriptionMetadata.a);
            }
            if (a.k(StackedSplineAreaSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(StackedSplineAreaSeriesDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalStackedSeriesBaseDescriptionMetadata.c(a);
            a.item("IsSplineShapePartOfRange", "Boolean");
        }
        static d(a) {
            StackedSplineAreaSeriesDescriptionMetadata.b(a);
            a.ae("StackedSplineAreaSeries", () => new StackedSplineAreaSeriesDescription());
            a.ad("StackedSplineAreaSeries", StackedSplineAreaSeriesDescriptionMetadata.a);
        }
    }
    StackedSplineAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedSplineAreaSeriesDescriptionMetadata, 'StackedSplineAreaSeriesDescriptionMetadata');
    StackedSplineAreaSeriesDescriptionMetadata.a = null;
    return StackedSplineAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSplineAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StackedSplineAreaSeriesDescriptionModule extends Base {
        static register(a) {
            StackedSplineAreaSeriesDescriptionMetadata.d(a);
        }
    }
    StackedSplineAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StackedSplineAreaSeriesDescriptionModule, 'StackedSplineAreaSeriesDescriptionModule');
    return StackedSplineAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100SplineAreaSeriesDescription = /*@__PURE__*/ (() => {
    class Stacked100SplineAreaSeriesDescription extends StackedSplineAreaSeriesDescription {
        get_type() {
            return "Stacked100SplineAreaSeries";
        }
        constructor() {
            super();
        }
    }
    Stacked100SplineAreaSeriesDescription.$t = /*@__PURE__*/ markType(Stacked100SplineAreaSeriesDescription, 'Stacked100SplineAreaSeriesDescription', StackedSplineAreaSeriesDescription.$);
    return Stacked100SplineAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100SplineAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class Stacked100SplineAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (Stacked100SplineAreaSeriesDescriptionMetadata.a == null) {
                Stacked100SplineAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Stacked100SplineAreaSeriesDescriptionMetadata.c(Stacked100SplineAreaSeriesDescriptionMetadata.a);
            }
            if (a.k(Stacked100SplineAreaSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(Stacked100SplineAreaSeriesDescriptionMetadata.a);
        }
        static c(a) {
            StackedSplineAreaSeriesDescriptionMetadata.c(a);
        }
        static d(a) {
            Stacked100SplineAreaSeriesDescriptionMetadata.b(a);
            a.ae("Stacked100SplineAreaSeries", () => new Stacked100SplineAreaSeriesDescription());
            a.ad("Stacked100SplineAreaSeries", Stacked100SplineAreaSeriesDescriptionMetadata.a);
        }
    }
    Stacked100SplineAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(Stacked100SplineAreaSeriesDescriptionMetadata, 'Stacked100SplineAreaSeriesDescriptionMetadata');
    Stacked100SplineAreaSeriesDescriptionMetadata.a = null;
    return Stacked100SplineAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100SplineAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class Stacked100SplineAreaSeriesDescriptionModule extends Base {
        static register(a) {
            StackedSplineAreaSeriesDescriptionModule.register(a);
            Stacked100SplineAreaSeriesDescriptionMetadata.d(a);
        }
    }
    Stacked100SplineAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(Stacked100SplineAreaSeriesDescriptionModule, 'Stacked100SplineAreaSeriesDescriptionModule');
    return Stacked100SplineAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FragmentBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class FragmentBaseDescriptionMetadata extends Base {
        static b(a) {
            if (FragmentBaseDescriptionMetadata.a == null) {
                FragmentBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FragmentBaseDescriptionMetadata.c(FragmentBaseDescriptionMetadata.a);
            }
            if (a.k(FragmentBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(FragmentBaseDescriptionMetadata.a);
        }
        static c(a) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a);
        }
        static d(a) {
            FragmentBaseDescriptionMetadata.b(a);
            a.ad("FragmentBase", FragmentBaseDescriptionMetadata.a);
        }
    }
    FragmentBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(FragmentBaseDescriptionMetadata, 'FragmentBaseDescriptionMetadata');
    FragmentBaseDescriptionMetadata.a = null;
    return FragmentBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FragmentBaseDescription = /*@__PURE__*/ (() => {
    class FragmentBaseDescription extends HorizontalAnchoredCategorySeriesDescription {
        get_type() {
            return "FragmentBase";
        }
        constructor() {
            super();
        }
    }
    FragmentBaseDescription.$t = /*@__PURE__*/ markType(FragmentBaseDescription, 'FragmentBaseDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return FragmentBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AreaFragmentDescription = /*@__PURE__*/ (() => {
    class AreaFragmentDescription extends FragmentBaseDescription {
        get_type() {
            return "AreaFragment";
        }
        constructor() {
            super();
        }
    }
    AreaFragmentDescription.$t = /*@__PURE__*/ markType(AreaFragmentDescription, 'AreaFragmentDescription', FragmentBaseDescription.$);
    return AreaFragmentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AreaFragmentDescriptionMetadata = /*@__PURE__*/ (() => {
    class AreaFragmentDescriptionMetadata extends Base {
        static b(a) {
            if (AreaFragmentDescriptionMetadata.a == null) {
                AreaFragmentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AreaFragmentDescriptionMetadata.c(AreaFragmentDescriptionMetadata.a);
            }
            if (a.k(AreaFragmentDescriptionMetadata.a)) {
                return;
            }
            a.ac(AreaFragmentDescriptionMetadata.a);
        }
        static c(a) {
            FragmentBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            AreaFragmentDescriptionMetadata.b(a);
            a.ae("AreaFragment", () => new AreaFragmentDescription());
            a.ad("AreaFragment", AreaFragmentDescriptionMetadata.a);
        }
    }
    AreaFragmentDescriptionMetadata.$t = /*@__PURE__*/ markType(AreaFragmentDescriptionMetadata, 'AreaFragmentDescriptionMetadata');
    AreaFragmentDescriptionMetadata.a = null;
    return AreaFragmentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AreaFragmentDescriptionModule = /*@__PURE__*/ (() => {
    class AreaFragmentDescriptionModule extends Base {
        static register(a) {
            AreaFragmentDescriptionMetadata.d(a);
        }
    }
    AreaFragmentDescriptionModule.$t = /*@__PURE__*/ markType(AreaFragmentDescriptionModule, 'AreaFragmentDescriptionModule');
    return AreaFragmentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnFragmentDescription = /*@__PURE__*/ (() => {
    class ColumnFragmentDescription extends FragmentBaseDescription {
        get_type() {
            return "ColumnFragment";
        }
        constructor() {
            super();
            this.gt = 0;
            this.gu = 0;
        }
        get radiusX() {
            return this.gt;
        }
        set radiusX(a) {
            this.gt = a;
            this.g("RadiusX");
        }
        get radiusY() {
            return this.gu;
        }
        set radiusY(a) {
            this.gu = a;
            this.g("RadiusY");
        }
    }
    ColumnFragmentDescription.$t = /*@__PURE__*/ markType(ColumnFragmentDescription, 'ColumnFragmentDescription', FragmentBaseDescription.$);
    return ColumnFragmentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnFragmentDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnFragmentDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnFragmentDescriptionMetadata.a == null) {
                ColumnFragmentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnFragmentDescriptionMetadata.c(ColumnFragmentDescriptionMetadata.a);
            }
            if (a.k(ColumnFragmentDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnFragmentDescriptionMetadata.a);
        }
        static c(a) {
            FragmentBaseDescriptionMetadata.c(a);
            a.item("RadiusX", "Number:double");
            a.item("RadiusY", "Number:double");
        }
        static d(a) {
            ColumnFragmentDescriptionMetadata.b(a);
            a.ae("ColumnFragment", () => new ColumnFragmentDescription());
            a.ad("ColumnFragment", ColumnFragmentDescriptionMetadata.a);
        }
    }
    ColumnFragmentDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnFragmentDescriptionMetadata, 'ColumnFragmentDescriptionMetadata');
    ColumnFragmentDescriptionMetadata.a = null;
    return ColumnFragmentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnFragmentDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnFragmentDescriptionModule extends Base {
        static register(a) {
            ColumnFragmentDescriptionMetadata.d(a);
        }
    }
    ColumnFragmentDescriptionModule.$t = /*@__PURE__*/ markType(ColumnFragmentDescriptionModule, 'ColumnFragmentDescriptionModule');
    return ColumnFragmentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BarFragmentDescription = /*@__PURE__*/ (() => {
    class BarFragmentDescription extends ColumnFragmentDescription {
        get_type() {
            return "BarFragment";
        }
        constructor() {
            super();
        }
    }
    BarFragmentDescription.$t = /*@__PURE__*/ markType(BarFragmentDescription, 'BarFragmentDescription', ColumnFragmentDescription.$);
    return BarFragmentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BarFragmentDescriptionMetadata = /*@__PURE__*/ (() => {
    class BarFragmentDescriptionMetadata extends Base {
        static b(a) {
            if (BarFragmentDescriptionMetadata.a == null) {
                BarFragmentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BarFragmentDescriptionMetadata.c(BarFragmentDescriptionMetadata.a);
            }
            if (a.k(BarFragmentDescriptionMetadata.a)) {
                return;
            }
            a.ac(BarFragmentDescriptionMetadata.a);
        }
        static c(a) {
            ColumnFragmentDescriptionMetadata.c(a);
        }
        static d(a) {
            BarFragmentDescriptionMetadata.b(a);
            a.ae("BarFragment", () => new BarFragmentDescription());
            a.ad("BarFragment", BarFragmentDescriptionMetadata.a);
        }
    }
    BarFragmentDescriptionMetadata.$t = /*@__PURE__*/ markType(BarFragmentDescriptionMetadata, 'BarFragmentDescriptionMetadata');
    BarFragmentDescriptionMetadata.a = null;
    return BarFragmentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BarFragmentDescriptionModule = /*@__PURE__*/ (() => {
    class BarFragmentDescriptionModule extends Base {
        static register(a) {
            ColumnFragmentDescriptionModule.register(a);
            BarFragmentDescriptionMetadata.d(a);
        }
    }
    BarFragmentDescriptionModule.$t = /*@__PURE__*/ markType(BarFragmentDescriptionModule, 'BarFragmentDescriptionModule');
    return BarFragmentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineFragmentDescription = /*@__PURE__*/ (() => {
    class LineFragmentDescription extends FragmentBaseDescription {
        get_type() {
            return "LineFragment";
        }
        constructor() {
            super();
        }
    }
    LineFragmentDescription.$t = /*@__PURE__*/ markType(LineFragmentDescription, 'LineFragmentDescription', FragmentBaseDescription.$);
    return LineFragmentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineFragmentDescriptionMetadata = /*@__PURE__*/ (() => {
    class LineFragmentDescriptionMetadata extends Base {
        static b(a) {
            if (LineFragmentDescriptionMetadata.a == null) {
                LineFragmentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LineFragmentDescriptionMetadata.c(LineFragmentDescriptionMetadata.a);
            }
            if (a.k(LineFragmentDescriptionMetadata.a)) {
                return;
            }
            a.ac(LineFragmentDescriptionMetadata.a);
        }
        static c(a) {
            FragmentBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            LineFragmentDescriptionMetadata.b(a);
            a.ae("LineFragment", () => new LineFragmentDescription());
            a.ad("LineFragment", LineFragmentDescriptionMetadata.a);
        }
    }
    LineFragmentDescriptionMetadata.$t = /*@__PURE__*/ markType(LineFragmentDescriptionMetadata, 'LineFragmentDescriptionMetadata');
    LineFragmentDescriptionMetadata.a = null;
    return LineFragmentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineFragmentDescriptionModule = /*@__PURE__*/ (() => {
    class LineFragmentDescriptionModule extends Base {
        static register(a) {
            LineFragmentDescriptionMetadata.d(a);
        }
    }
    LineFragmentDescriptionModule.$t = /*@__PURE__*/ markType(LineFragmentDescriptionModule, 'LineFragmentDescriptionModule');
    return LineFragmentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineFragmentBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class SplineFragmentBaseDescriptionMetadata extends Base {
        static b(a) {
            if (SplineFragmentBaseDescriptionMetadata.a == null) {
                SplineFragmentBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SplineFragmentBaseDescriptionMetadata.c(SplineFragmentBaseDescriptionMetadata.a);
            }
            if (a.k(SplineFragmentBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(SplineFragmentBaseDescriptionMetadata.a);
        }
        static c(a) {
            SplineSeriesBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            SplineFragmentBaseDescriptionMetadata.b(a);
            a.ad("SplineFragmentBase", SplineFragmentBaseDescriptionMetadata.a);
        }
    }
    SplineFragmentBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(SplineFragmentBaseDescriptionMetadata, 'SplineFragmentBaseDescriptionMetadata');
    SplineFragmentBaseDescriptionMetadata.a = null;
    return SplineFragmentBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineFragmentBaseDescription = /*@__PURE__*/ (() => {
    class SplineFragmentBaseDescription extends SplineSeriesBaseDescription {
        get_type() {
            return "SplineFragmentBase";
        }
        constructor() {
            super();
        }
    }
    SplineFragmentBaseDescription.$t = /*@__PURE__*/ markType(SplineFragmentBaseDescription, 'SplineFragmentBaseDescription', SplineSeriesBaseDescription.$);
    return SplineFragmentBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineFragmentDescription = /*@__PURE__*/ (() => {
    class SplineFragmentDescription extends SplineFragmentBaseDescription {
        get_type() {
            return "SplineFragment";
        }
        constructor() {
            super();
        }
    }
    SplineFragmentDescription.$t = /*@__PURE__*/ markType(SplineFragmentDescription, 'SplineFragmentDescription', SplineFragmentBaseDescription.$);
    return SplineFragmentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineFragmentDescriptionMetadata = /*@__PURE__*/ (() => {
    class SplineFragmentDescriptionMetadata extends Base {
        static b(a) {
            if (SplineFragmentDescriptionMetadata.a == null) {
                SplineFragmentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SplineFragmentDescriptionMetadata.c(SplineFragmentDescriptionMetadata.a);
            }
            if (a.k(SplineFragmentDescriptionMetadata.a)) {
                return;
            }
            a.ac(SplineFragmentDescriptionMetadata.a);
        }
        static c(a) {
            SplineFragmentBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            SplineFragmentDescriptionMetadata.b(a);
            a.ae("SplineFragment", () => new SplineFragmentDescription());
            a.ad("SplineFragment", SplineFragmentDescriptionMetadata.a);
        }
    }
    SplineFragmentDescriptionMetadata.$t = /*@__PURE__*/ markType(SplineFragmentDescriptionMetadata, 'SplineFragmentDescriptionMetadata');
    SplineFragmentDescriptionMetadata.a = null;
    return SplineFragmentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineFragmentDescriptionModule = /*@__PURE__*/ (() => {
    class SplineFragmentDescriptionModule extends Base {
        static register(a) {
            SplineFragmentDescriptionMetadata.d(a);
        }
    }
    SplineFragmentDescriptionModule.$t = /*@__PURE__*/ markType(SplineFragmentDescriptionModule, 'SplineFragmentDescriptionModule');
    return SplineFragmentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineAreaFragmentDescription = /*@__PURE__*/ (() => {
    class SplineAreaFragmentDescription extends SplineFragmentBaseDescription {
        get_type() {
            return "SplineAreaFragment";
        }
        constructor() {
            super();
        }
    }
    SplineAreaFragmentDescription.$t = /*@__PURE__*/ markType(SplineAreaFragmentDescription, 'SplineAreaFragmentDescription', SplineFragmentBaseDescription.$);
    return SplineAreaFragmentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineAreaFragmentDescriptionMetadata = /*@__PURE__*/ (() => {
    class SplineAreaFragmentDescriptionMetadata extends Base {
        static b(a) {
            if (SplineAreaFragmentDescriptionMetadata.a == null) {
                SplineAreaFragmentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SplineAreaFragmentDescriptionMetadata.c(SplineAreaFragmentDescriptionMetadata.a);
            }
            if (a.k(SplineAreaFragmentDescriptionMetadata.a)) {
                return;
            }
            a.ac(SplineAreaFragmentDescriptionMetadata.a);
        }
        static c(a) {
            SplineFragmentBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            SplineAreaFragmentDescriptionMetadata.b(a);
            a.ae("SplineAreaFragment", () => new SplineAreaFragmentDescription());
            a.ad("SplineAreaFragment", SplineAreaFragmentDescriptionMetadata.a);
        }
    }
    SplineAreaFragmentDescriptionMetadata.$t = /*@__PURE__*/ markType(SplineAreaFragmentDescriptionMetadata, 'SplineAreaFragmentDescriptionMetadata');
    SplineAreaFragmentDescriptionMetadata.a = null;
    return SplineAreaFragmentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineAreaFragmentDescriptionModule = /*@__PURE__*/ (() => {
    class SplineAreaFragmentDescriptionModule extends Base {
        static register(a) {
            SplineAreaFragmentDescriptionMetadata.d(a);
        }
    }
    SplineAreaFragmentDescriptionModule.$t = /*@__PURE__*/ markType(SplineAreaFragmentDescriptionModule, 'SplineAreaFragmentDescriptionModule');
    return SplineAreaFragmentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryYAxisDescription = /*@__PURE__*/ (() => {
    class CategoryYAxisDescription extends CategoryAxisBaseDescription {
        get_type() {
            return "CategoryYAxis";
        }
        constructor() {
            super();
            this.d5 = 0;
            this.d3 = 0;
            this.d6 = 0;
            this.d4 = 0;
            this.d7 = 0;
            this.d8 = 0;
            this.d9 = 0;
            this.ea = 0;
            this.eb = 0;
            this.el = null;
            this.em = null;
        }
        get interval() {
            return this.d5;
        }
        set interval(a) {
            this.d5 = a;
            this.g("Interval");
        }
        get actualInterval() {
            return this.d3;
        }
        set actualInterval(a) {
            this.d3 = a;
            this.g("ActualInterval");
        }
        get minorInterval() {
            return this.d6;
        }
        set minorInterval(a) {
            this.d6 = a;
            this.g("MinorInterval");
        }
        get actualMinorInterval() {
            return this.d4;
        }
        set actualMinorInterval(a) {
            this.d4 = a;
            this.g("ActualMinorInterval");
        }
        get zoomMaximumCategoryRange() {
            return this.d7;
        }
        set zoomMaximumCategoryRange(a) {
            this.d7 = a;
            this.g("ZoomMaximumCategoryRange");
        }
        get zoomMaximumItemSpan() {
            return this.d8;
        }
        set zoomMaximumItemSpan(a) {
            this.d8 = a;
            this.g("ZoomMaximumItemSpan");
        }
        get zoomToCategoryRange() {
            return this.d9;
        }
        set zoomToCategoryRange(a) {
            this.d9 = a;
            this.g("ZoomToCategoryRange");
        }
        get zoomToCategoryStart() {
            return this.ea;
        }
        set zoomToCategoryStart(a) {
            this.ea = a;
            this.g("ZoomToCategoryStart");
        }
        get zoomToItemSpan() {
            return this.eb;
        }
        set zoomToItemSpan(a) {
            this.eb = a;
            this.g("ZoomToItemSpan");
        }
        get actualIntervalChangeRef() {
            return this.el;
        }
        set actualIntervalChangeRef(a) {
            this.el = a;
            this.g("ActualIntervalChangeRef");
        }
        get actualMinorIntervalChangeRef() {
            return this.em;
        }
        set actualMinorIntervalChangeRef(a) {
            this.em = a;
            this.g("ActualMinorIntervalChangeRef");
        }
    }
    CategoryYAxisDescription.$t = /*@__PURE__*/ markType(CategoryYAxisDescription, 'CategoryYAxisDescription', CategoryAxisBaseDescription.$);
    return CategoryYAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryYAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryYAxisDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryYAxisDescriptionMetadata.a == null) {
                CategoryYAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryYAxisDescriptionMetadata.c(CategoryYAxisDescriptionMetadata.a);
            }
            if (a.k(CategoryYAxisDescriptionMetadata.a)) {
                return;
            }
            a.ac(CategoryYAxisDescriptionMetadata.a);
        }
        static c(a) {
            CategoryAxisBaseDescriptionMetadata.c(a);
            a.item("Interval", "Number:double");
            a.item("ActualInterval", "Number:double");
            a.item("MinorInterval", "Number:double");
            a.item("ActualMinorInterval", "Number:double");
            a.item("ZoomMaximumCategoryRange", "Number:double");
            a.item("ZoomMaximumItemSpan", "Number:double");
            a.item("ZoomToCategoryRange", "Number:double");
            a.item("ZoomToCategoryStart", "Number:double");
            a.item("ZoomToItemSpan", "Number:double");
            a.item("ActualIntervalChangeRef", "EventRef::actualIntervalChange");
            a.item("ActualMinorIntervalChangeRef", "EventRef::actualMinorIntervalChange");
        }
        static d(a) {
            CategoryYAxisDescriptionMetadata.b(a);
            a.ae("CategoryYAxis", () => new CategoryYAxisDescription());
            a.ad("CategoryYAxis", CategoryYAxisDescriptionMetadata.a);
        }
    }
    CategoryYAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryYAxisDescriptionMetadata, 'CategoryYAxisDescriptionMetadata');
    CategoryYAxisDescriptionMetadata.a = null;
    return CategoryYAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryYAxisDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryYAxisDescriptionModule extends Base {
        static register(a) {
            CategoryYAxisDescriptionMetadata.d(a);
        }
    }
    CategoryYAxisDescriptionModule.$t = /*@__PURE__*/ markType(CategoryYAxisDescriptionModule, 'CategoryYAxisDescriptionModule');
    return CategoryYAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartVerticalCategoryCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartVerticalCategoryCoreDescriptionModule extends Base {
        static register(a) {
            NumericXAxisDescriptionModule.register(a);
            CategoryYAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartVerticalCategoryCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartVerticalCategoryCoreDescriptionModule, 'DataChartVerticalCategoryCoreDescriptionModule');
    return DataChartVerticalCategoryCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartStackedDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartStackedDescriptionModule extends Base {
        static register(a) {
            StackedFragmentSeriesDescriptionModule.register(a);
            Stacked100AreaSeriesDescriptionModule.register(a);
            Stacked100BarSeriesDescriptionModule.register(a);
            Stacked100ColumnSeriesDescriptionModule.register(a);
            Stacked100LineSeriesDescriptionModule.register(a);
            Stacked100SplineSeriesDescriptionModule.register(a);
            Stacked100SplineAreaSeriesDescriptionModule.register(a);
            StackedAreaSeriesDescriptionModule.register(a);
            StackedBarSeriesDescriptionModule.register(a);
            StackedColumnSeriesDescriptionModule.register(a);
            StackedLineSeriesDescriptionModule.register(a);
            StackedSplineSeriesDescriptionModule.register(a);
            StackedSplineAreaSeriesDescriptionModule.register(a);
            AreaFragmentDescriptionModule.register(a);
            BarFragmentDescriptionModule.register(a);
            ColumnFragmentDescriptionModule.register(a);
            LineFragmentDescriptionModule.register(a);
            SplineFragmentDescriptionModule.register(a);
            SplineAreaFragmentDescriptionModule.register(a);
            DataChartCategoryCoreDescriptionModule.register(a);
            DataChartVerticalCategoryCoreDescriptionModule.register(a);
        }
    }
    DataChartStackedDescriptionModule.$t = /*@__PURE__*/ markType(DataChartStackedDescriptionModule, 'DataChartStackedDescriptionModule');
    return DataChartStackedDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartToolbarDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartToolbarDescriptionModule extends Base {
        static register(a) {
            DataChartToolbarIconsDescriptionModule.register(a);
            DataChartAnnotationDescriptionModule.register(a);
            AnnotationLayerProxyDescriptionModule.register(a);
            DataChartCategoryTrendLineDescriptionModule.register(a);
            DataChartInteractivityDescriptionModule.register(a);
            CalloutLayerDescriptionModule.register(a);
            ValueLayerDescriptionModule.register(a);
            CrosshairLayerDescriptionModule.register(a);
        }
    }
    DataChartToolbarDescriptionModule.$t = /*@__PURE__*/ markType(DataChartToolbarDescriptionModule, 'DataChartToolbarDescriptionModule');
    return DataChartToolbarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VerticalAnchoredCategorySeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class VerticalAnchoredCategorySeriesDescriptionMetadata extends Base {
        static b(a) {
            if (VerticalAnchoredCategorySeriesDescriptionMetadata.a == null) {
                VerticalAnchoredCategorySeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                VerticalAnchoredCategorySeriesDescriptionMetadata.c(VerticalAnchoredCategorySeriesDescriptionMetadata.a);
            }
            if (a.k(VerticalAnchoredCategorySeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(VerticalAnchoredCategorySeriesDescriptionMetadata.a);
        }
        static c(a) {
            AnchoredCategorySeriesDescriptionMetadata.c(a);
            a.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            a.item("XAxisRef@nameBinding", "true");
            a.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            a.item("YAxisRef@nameBinding", "true");
        }
        static d(a) {
            VerticalAnchoredCategorySeriesDescriptionMetadata.b(a);
            a.ad("VerticalAnchoredCategorySeries", VerticalAnchoredCategorySeriesDescriptionMetadata.a);
        }
    }
    VerticalAnchoredCategorySeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(VerticalAnchoredCategorySeriesDescriptionMetadata, 'VerticalAnchoredCategorySeriesDescriptionMetadata');
    VerticalAnchoredCategorySeriesDescriptionMetadata.a = null;
    return VerticalAnchoredCategorySeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VerticalAnchoredCategorySeriesDescription = /*@__PURE__*/ (() => {
    class VerticalAnchoredCategorySeriesDescription extends AnchoredCategorySeriesDescription {
        get_type() {
            return "VerticalAnchoredCategorySeries";
        }
        constructor() {
            super();
            this.gp = null;
            this.gq = null;
        }
        get xAxisRef() {
            return this.gp;
        }
        set xAxisRef(a) {
            this.gp = a;
            this.g("XAxisRef");
        }
        get yAxisRef() {
            return this.gq;
        }
        set yAxisRef(a) {
            this.gq = a;
            this.g("YAxisRef");
        }
    }
    VerticalAnchoredCategorySeriesDescription.$t = /*@__PURE__*/ markType(VerticalAnchoredCategorySeriesDescription, 'VerticalAnchoredCategorySeriesDescription', AnchoredCategorySeriesDescription.$);
    return VerticalAnchoredCategorySeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BarSeriesDescription = /*@__PURE__*/ (() => {
    class BarSeriesDescription extends VerticalAnchoredCategorySeriesDescription {
        get_type() {
            return "BarSeries";
        }
        constructor() {
            super();
            this.gt = 0;
            this.gu = 0;
        }
        get radiusX() {
            return this.gt;
        }
        set radiusX(a) {
            this.gt = a;
            this.g("RadiusX");
        }
        get radiusY() {
            return this.gu;
        }
        set radiusY(a) {
            this.gu = a;
            this.g("RadiusY");
        }
    }
    BarSeriesDescription.$t = /*@__PURE__*/ markType(BarSeriesDescription, 'BarSeriesDescription', VerticalAnchoredCategorySeriesDescription.$);
    return BarSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BarSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class BarSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (BarSeriesDescriptionMetadata.a == null) {
                BarSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BarSeriesDescriptionMetadata.c(BarSeriesDescriptionMetadata.a);
            }
            if (a.k(BarSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(BarSeriesDescriptionMetadata.a);
        }
        static c(a) {
            VerticalAnchoredCategorySeriesDescriptionMetadata.c(a);
            a.item("RadiusX", "Number:double");
            a.item("RadiusY", "Number:double");
        }
        static d(a) {
            BarSeriesDescriptionMetadata.b(a);
            a.ae("BarSeries", () => new BarSeriesDescription());
            a.ad("BarSeries", BarSeriesDescriptionMetadata.a);
        }
    }
    BarSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(BarSeriesDescriptionMetadata, 'BarSeriesDescriptionMetadata');
    BarSeriesDescriptionMetadata.a = null;
    return BarSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BarSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class BarSeriesDescriptionModule extends Base {
        static register(a) {
            BarSeriesDescriptionMetadata.d(a);
        }
    }
    BarSeriesDescriptionModule.$t = /*@__PURE__*/ markType(BarSeriesDescriptionModule, 'BarSeriesDescriptionModule');
    return BarSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartVerticalCategoryDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartVerticalCategoryDescriptionModule extends Base {
        static register(a) {
            BarSeriesDescriptionModule.register(a);
            DataChartVerticalCategoryCoreDescriptionModule.register(a);
        }
    }
    DataChartVerticalCategoryDescriptionModule.$t = /*@__PURE__*/ markType(DataChartVerticalCategoryDescriptionModule, 'DataChartVerticalCategoryDescriptionModule');
    return DataChartVerticalCategoryDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartVisualDataDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartVisualDataDescriptionModule extends Base {
        static register(a) {
        }
    }
    DataChartVisualDataDescriptionModule.$t = /*@__PURE__*/ markType(DataChartVisualDataDescriptionModule, 'DataChartVisualDataDescriptionModule');
    return DataChartVisualDataDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageColumnDescription = /*@__PURE__*/ (() => {
    class ImageColumnDescription extends DataGridColumnDescription {
        get_type() {
            return "ImageColumn";
        }
        constructor() {
            super();
            this.fp = null;
            this.fn = null;
            this.fl = null;
            this.fh = null;
            this.fm = null;
            this.fo = null;
        }
        get imageStretchOption() {
            return this.fp;
        }
        set imageStretchOption(a) {
            this.fp = a;
            this.g("ImageStretchOption");
        }
        get editorType() {
            return this.fn;
        }
        set editorType(a) {
            this.fn = a;
            this.g("EditorType");
        }
        get editorDataSourceRef() {
            return this.fl;
        }
        set editorDataSourceRef(a) {
            this.fl = a;
            this.g("EditorDataSourceRef");
        }
        get editorDataSource() {
            return this.fh;
        }
        set editorDataSource(a) {
            this.fh = a;
            this.g("EditorDataSource");
        }
        get editorTextField() {
            return this.fm;
        }
        set editorTextField(a) {
            this.fm = a;
            this.g("EditorTextField");
        }
        get editorValueField() {
            return this.fo;
        }
        set editorValueField(a) {
            this.fo = a;
            this.g("EditorValueField");
        }
    }
    ImageColumnDescription.$t = /*@__PURE__*/ markType(ImageColumnDescription, 'ImageColumnDescription', DataGridColumnDescription.$);
    ImageColumnDescription.__canMarshalByValue1 = true;
    ImageColumnDescription.__marshalByValueAlias1 = "ImageColumn";
    return ImageColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class ImageColumnDescriptionMetadata extends Base {
        static b(a) {
            if (ImageColumnDescriptionMetadata.a == null) {
                ImageColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ImageColumnDescriptionMetadata.c(ImageColumnDescriptionMetadata.a);
            }
            if (a.k(ImageColumnDescriptionMetadata.a)) {
                return;
            }
            a.ac(ImageColumnDescriptionMetadata.a);
        }
        static c(a) {
            DataGridColumnDescriptionMetadata.c(a);
            a.item("ImageStretchOption", "ExportedType:string:ImageStretchOptions");
            a.item("ImageStretchOption@names", "Uniform;Fill;None");
            a.item("EditorType", "ExportedType:string:EditorType");
            a.item("EditorType@names", "Default;Text;Numeric;Date;Combo");
            a.item("EditorDataSourceRef", "(w:EditorItemsSource,xam:EditorItemsSource,wf:EditorItemsSource)DataRef::object");
            a.item("EditorDataSource", "(w:EditorItemsSource,xam:EditorItemsSource,wf:EditorItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            a.item("EditorTextField", "String");
            a.item("EditorValueField", "String");
        }
        static d(a) {
            ImageColumnDescriptionMetadata.b(a);
            a.ae("ImageColumn", () => new ImageColumnDescription());
            a.ad("ImageColumn", ImageColumnDescriptionMetadata.a);
        }
    }
    ImageColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(ImageColumnDescriptionMetadata, 'ImageColumnDescriptionMetadata');
    ImageColumnDescriptionMetadata.a = null;
    return ImageColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageColumnDescriptionModule = /*@__PURE__*/ (() => {
    class ImageColumnDescriptionModule extends Base {
        static register(a) {
            ImageColumnDescriptionMetadata.d(a);
        }
    }
    ImageColumnDescriptionModule.$t = /*@__PURE__*/ markType(ImageColumnDescriptionModule, 'ImageColumnDescriptionModule');
    return ImageColumnDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateContentDescriptionModule = /*@__PURE__*/ (() => {
    class TemplateContentDescriptionModule extends Base {
        static register(a) {
        }
    }
    TemplateContentDescriptionModule.$t = /*@__PURE__*/ markType(TemplateContentDescriptionModule, 'TemplateContentDescriptionModule');
    return TemplateContentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateHeaderCellUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class TemplateHeaderCellUpdatingEventArgsDescription extends Description {
        get_type() {
            return "TemplateHeaderCellUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    TemplateHeaderCellUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(TemplateHeaderCellUpdatingEventArgsDescription, 'TemplateHeaderCellUpdatingEventArgsDescription', Description.$);
    return TemplateHeaderCellUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateHeaderCellUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateHeaderCellUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.a == null) {
                TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.c(TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.a);
            }
            if (a.k(TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.b(a);
            a.ae("TemplateHeaderCellUpdatingEventArgs", () => new TemplateHeaderCellUpdatingEventArgsDescription());
            a.ad("TemplateHeaderCellUpdatingEventArgs", TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateHeaderCellUpdatingEventArgsDescriptionMetadata, 'TemplateHeaderCellUpdatingEventArgsDescriptionMetadata');
    TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.a = null;
    return TemplateHeaderCellUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateHeaderDescription = /*@__PURE__*/ (() => {
    class TemplateHeaderDescription extends HeaderDescription {
        get_type() {
            return "TemplateHeader";
        }
        constructor() {
            super();
            this.co = null;
        }
        get cellUpdatingRef() {
            return this.co;
        }
        set cellUpdatingRef(a) {
            this.co = a;
            this.g("CellUpdatingRef");
        }
    }
    TemplateHeaderDescription.$t = /*@__PURE__*/ markType(TemplateHeaderDescription, 'TemplateHeaderDescription', HeaderDescription.$);
    TemplateHeaderDescription.__canMarshalByValue1 = true;
    TemplateHeaderDescription.__marshalByValueAlias1 = "TemplateHeader";
    return TemplateHeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateHeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateHeaderDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateHeaderDescriptionMetadata.a == null) {
                TemplateHeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateHeaderDescriptionMetadata.c(TemplateHeaderDescriptionMetadata.a);
            }
            if (a.k(TemplateHeaderDescriptionMetadata.a)) {
                return;
            }
            a.ac(TemplateHeaderDescriptionMetadata.a);
            TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            HeaderDescriptionMetadata.c(a);
            a.item("CellUpdatingRef", "EventRef::cellUpdating");
        }
        static d(a) {
            TemplateHeaderDescriptionMetadata.b(a);
            a.ae("TemplateHeader", () => new TemplateHeaderDescription());
            a.ad("TemplateHeader", TemplateHeaderDescriptionMetadata.a);
        }
    }
    TemplateHeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateHeaderDescriptionMetadata, 'TemplateHeaderDescriptionMetadata');
    TemplateHeaderDescriptionMetadata.a = null;
    return TemplateHeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateHeaderDescriptionModule = /*@__PURE__*/ (() => {
    class TemplateHeaderDescriptionModule extends Base {
        static register(a) {
            TemplateHeaderDescriptionMetadata.d(a);
        }
    }
    TemplateHeaderDescriptionModule.$t = /*@__PURE__*/ markType(TemplateHeaderDescriptionModule, 'TemplateHeaderDescriptionModule');
    return TemplateHeaderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridAllColumnsDescriptionModule = /*@__PURE__*/ (() => {
    class DataGridAllColumnsDescriptionModule extends Base {
        static register(a) {
            NumericColumnDescriptionModule.register(a);
            DateTimeColumnDescriptionModule.register(a);
            ImageColumnDescriptionModule.register(a);
            TemplateColumnDescriptionModule.register(a);
            TemplateContentDescriptionModule.register(a);
            TextColumnDescriptionModule.register(a);
            TemplateHeaderDescriptionModule.register(a);
            ComboBoxColumnDescriptionModule.register(a);
            DataGridCoreDescriptionModule.register(a);
        }
    }
    DataGridAllColumnsDescriptionModule.$t = /*@__PURE__*/ markType(DataGridAllColumnsDescriptionModule, 'DataGridAllColumnsDescriptionModule');
    return DataGridAllColumnsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridComparisonOperatorSelectorDescription = /*@__PURE__*/ (() => {
    class DataGridComparisonOperatorSelectorDescription extends Description {
        get_type() {
            return "DataGridComparisonOperatorSelector";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.s = null;
            this.n = null;
            this.h = 0;
            this.o = null;
            this.i = 0;
            this.r = null;
            this.l = null;
            this.t = null;
            this.q = null;
            this.p = null;
            this.m = null;
        }
        get value() {
            return this.s;
        }
        set value(a) {
            this.s = a;
            this.g("Value");
        }
        get customFilterID() {
            return this.n;
        }
        set customFilterID(a) {
            this.n = a;
            this.g("CustomFilterID");
        }
        get customFilterIndex() {
            return this.h;
        }
        set customFilterIndex(a) {
            this.h = a;
            this.g("CustomFilterIndex");
        }
        get dataType() {
            return this.o;
        }
        set dataType(a) {
            this.o = a;
            this.g("DataType");
        }
        get maxHeight() {
            return this.i;
        }
        set maxHeight(a) {
            this.i = a;
            this.g("MaxHeight");
        }
        get textColor() {
            return this.r;
        }
        set textColor(a) {
            this.r = a;
            this.g("TextColor");
        }
        get background() {
            return this.l;
        }
        set background(a) {
            this.l = a;
            this.g("Background");
        }
        get valueChangedRef() {
            return this.t;
        }
        set valueChangedRef(a) {
            this.t = a;
            this.g("ValueChangedRef");
        }
        get openingRef() {
            return this.q;
        }
        set openingRef(a) {
            this.q = a;
            this.g("OpeningRef");
        }
        get openedRef() {
            return this.p;
        }
        set openedRef(a) {
            this.p = a;
            this.g("OpenedRef");
        }
        get closingRef() {
            return this.m;
        }
        set closingRef(a) {
            this.m = a;
            this.g("ClosingRef");
        }
    }
    DataGridComparisonOperatorSelectorDescription.$t = /*@__PURE__*/ markType(DataGridComparisonOperatorSelectorDescription, 'DataGridComparisonOperatorSelectorDescription', Description.$);
    return DataGridComparisonOperatorSelectorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OperatorSelectorValueChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class OperatorSelectorValueChangedEventArgsDescription extends Description {
        get_type() {
            return "OperatorSelectorValueChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
        }
        get oldValue() {
            return this.i;
        }
        set oldValue(a) {
            this.i = a;
            this.g("OldValue");
        }
        get newValue() {
            return this.h;
        }
        set newValue(a) {
            this.h = a;
            this.g("NewValue");
        }
    }
    OperatorSelectorValueChangedEventArgsDescription.$t = /*@__PURE__*/ markType(OperatorSelectorValueChangedEventArgsDescription, 'OperatorSelectorValueChangedEventArgsDescription', Description.$);
    return OperatorSelectorValueChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OperatorSelectorValueChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class OperatorSelectorValueChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (OperatorSelectorValueChangedEventArgsDescriptionMetadata.a == null) {
                OperatorSelectorValueChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OperatorSelectorValueChangedEventArgsDescriptionMetadata.c(OperatorSelectorValueChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(OperatorSelectorValueChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(OperatorSelectorValueChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("OldValue", "ExportedType:string:ColumnComparisonConditionOperatorType");
            a.item("OldValue@names", "Equals;NotEquals;LessThan;LessThanOrEqualTo;GreaterThan;GreaterThanOrEqualTo;Top;Bottom;TopPercentile;BottomPercentile;True;False;Contains;DoesNotContain;StartsWith;DoesNotStartWith;EndsWith;DoesNotEndWith;Today;Tomorrow;Yesterday;NextWeek;ThisWeek;LastWeek;NextMonth;ThisMonth;LastMonth;NextQuarter;ThisQuarter;LastQuarter;NextYear;ThisYear;LastYear;YearToDate;Q1;Q2;Q3;Q4;Month;Year;Empty;NotEmpty;IsNull;IsNotNull;Custom");
            a.item("NewValue", "ExportedType:string:ColumnComparisonConditionOperatorType");
            a.item("NewValue@names", "Equals;NotEquals;LessThan;LessThanOrEqualTo;GreaterThan;GreaterThanOrEqualTo;Top;Bottom;TopPercentile;BottomPercentile;True;False;Contains;DoesNotContain;StartsWith;DoesNotStartWith;EndsWith;DoesNotEndWith;Today;Tomorrow;Yesterday;NextWeek;ThisWeek;LastWeek;NextMonth;ThisMonth;LastMonth;NextQuarter;ThisQuarter;LastQuarter;NextYear;ThisYear;LastYear;YearToDate;Q1;Q2;Q3;Q4;Month;Year;Empty;NotEmpty;IsNull;IsNotNull;Custom");
        }
        static d(a) {
            OperatorSelectorValueChangedEventArgsDescriptionMetadata.b(a);
            a.ae("OperatorSelectorValueChangedEventArgs", () => new OperatorSelectorValueChangedEventArgsDescription());
            a.ad("OperatorSelectorValueChangedEventArgs", OperatorSelectorValueChangedEventArgsDescriptionMetadata.a);
        }
    }
    OperatorSelectorValueChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(OperatorSelectorValueChangedEventArgsDescriptionMetadata, 'OperatorSelectorValueChangedEventArgsDescriptionMetadata');
    OperatorSelectorValueChangedEventArgsDescriptionMetadata.a = null;
    return OperatorSelectorValueChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OperatorSelectorOpeningEventArgsDescription = /*@__PURE__*/ (() => {
    class OperatorSelectorOpeningEventArgsDescription extends Description {
        get_type() {
            return "OperatorSelectorOpeningEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    OperatorSelectorOpeningEventArgsDescription.$t = /*@__PURE__*/ markType(OperatorSelectorOpeningEventArgsDescription, 'OperatorSelectorOpeningEventArgsDescription', Description.$);
    return OperatorSelectorOpeningEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OperatorSelectorOpeningEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class OperatorSelectorOpeningEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (OperatorSelectorOpeningEventArgsDescriptionMetadata.a == null) {
                OperatorSelectorOpeningEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OperatorSelectorOpeningEventArgsDescriptionMetadata.c(OperatorSelectorOpeningEventArgsDescriptionMetadata.a);
            }
            if (a.k(OperatorSelectorOpeningEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(OperatorSelectorOpeningEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            OperatorSelectorOpeningEventArgsDescriptionMetadata.b(a);
            a.ae("OperatorSelectorOpeningEventArgs", () => new OperatorSelectorOpeningEventArgsDescription());
            a.ad("OperatorSelectorOpeningEventArgs", OperatorSelectorOpeningEventArgsDescriptionMetadata.a);
        }
    }
    OperatorSelectorOpeningEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(OperatorSelectorOpeningEventArgsDescriptionMetadata, 'OperatorSelectorOpeningEventArgsDescriptionMetadata');
    OperatorSelectorOpeningEventArgsDescriptionMetadata.a = null;
    return OperatorSelectorOpeningEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OperatorSelectorClosingEventArgsDescription = /*@__PURE__*/ (() => {
    class OperatorSelectorClosingEventArgsDescription extends Description {
        get_type() {
            return "OperatorSelectorClosingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    OperatorSelectorClosingEventArgsDescription.$t = /*@__PURE__*/ markType(OperatorSelectorClosingEventArgsDescription, 'OperatorSelectorClosingEventArgsDescription', Description.$);
    return OperatorSelectorClosingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OperatorSelectorClosingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class OperatorSelectorClosingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (OperatorSelectorClosingEventArgsDescriptionMetadata.a == null) {
                OperatorSelectorClosingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OperatorSelectorClosingEventArgsDescriptionMetadata.c(OperatorSelectorClosingEventArgsDescriptionMetadata.a);
            }
            if (a.k(OperatorSelectorClosingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(OperatorSelectorClosingEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            OperatorSelectorClosingEventArgsDescriptionMetadata.b(a);
            a.ae("OperatorSelectorClosingEventArgs", () => new OperatorSelectorClosingEventArgsDescription());
            a.ad("OperatorSelectorClosingEventArgs", OperatorSelectorClosingEventArgsDescriptionMetadata.a);
        }
    }
    OperatorSelectorClosingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(OperatorSelectorClosingEventArgsDescriptionMetadata, 'OperatorSelectorClosingEventArgsDescriptionMetadata');
    OperatorSelectorClosingEventArgsDescriptionMetadata.a = null;
    return OperatorSelectorClosingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridComparisonOperatorSelectorDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridComparisonOperatorSelectorDescriptionMetadata extends Base {
        static b(a) {
            if (DataGridComparisonOperatorSelectorDescriptionMetadata.a == null) {
                DataGridComparisonOperatorSelectorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridComparisonOperatorSelectorDescriptionMetadata.c(DataGridComparisonOperatorSelectorDescriptionMetadata.a);
            }
            if (a.k(DataGridComparisonOperatorSelectorDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataGridComparisonOperatorSelectorDescriptionMetadata.a);
            OperatorSelectorValueChangedEventArgsDescriptionMetadata.d(a);
            OperatorSelectorOpeningEventArgsDescriptionMetadata.d(a);
            OperatorSelectorClosingEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Value", "ExportedType:string:ColumnComparisonConditionOperatorType");
            a.item("Value@names", "Equals;NotEquals;LessThan;LessThanOrEqualTo;GreaterThan;GreaterThanOrEqualTo;Top;Bottom;TopPercentile;BottomPercentile;True;False;Contains;DoesNotContain;StartsWith;DoesNotStartWith;EndsWith;DoesNotEndWith;Today;Tomorrow;Yesterday;NextWeek;ThisWeek;LastWeek;NextMonth;ThisMonth;LastMonth;NextQuarter;ThisQuarter;LastQuarter;NextYear;ThisYear;LastYear;YearToDate;Q1;Q2;Q3;Q4;Month;Year;Empty;NotEmpty;IsNull;IsNotNull;Custom");
            a.item("CustomFilterID", "String");
            a.item("CustomFilterIndex", "Number:int");
            a.item("DataType", "ExportedType:string:DataSourceSchemaPropertyType");
            a.item("DataType@names", "StringValue;IntValue;BooleanValue;LongValue;ShortValue;DoubleValue;DecimalValue;SingleValue;DateTimeValue;DateTimeOffsetValue;ByteValue;ObjectValue");
            a.item("MaxHeight", "Number:int");
            a.item("TextColor", "Brush");
            a.item("Background", "Brush");
            a.item("ValueChangedRef", "EventRef::valueChanged");
            a.item("OpeningRef", "EventRef::opening");
            a.item("OpenedRef", "EventRef::opened");
            a.item("ClosingRef", "EventRef::closing");
        }
        static d(a) {
            DataGridComparisonOperatorSelectorDescriptionMetadata.b(a);
            a.ae("DataGridComparisonOperatorSelector", () => new DataGridComparisonOperatorSelectorDescription());
            a.ad("DataGridComparisonOperatorSelector", DataGridComparisonOperatorSelectorDescriptionMetadata.a);
        }
    }
    DataGridComparisonOperatorSelectorDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridComparisonOperatorSelectorDescriptionMetadata, 'DataGridComparisonOperatorSelectorDescriptionMetadata');
    DataGridComparisonOperatorSelectorDescriptionMetadata.a = null;
    return DataGridComparisonOperatorSelectorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridExpansionIndicatorDescription = /*@__PURE__*/ (() => {
    class DataGridExpansionIndicatorDescription extends Description {
        get_type() {
            return "DataGridExpansionIndicator";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = false;
            this.p = null;
            this.h = false;
            this.m = 0;
            this.l = 0;
        }
        get isExpanded() {
            return this.i;
        }
        set isExpanded(a) {
            this.i = a;
            this.g("IsExpanded");
        }
        get iconColor() {
            return this.p;
        }
        set iconColor(a) {
            this.p = a;
            this.g("IconColor");
        }
        get isAnimationEnabled() {
            return this.h;
        }
        set isAnimationEnabled(a) {
            this.h = a;
            this.g("IsAnimationEnabled");
        }
        get pixelScalingRatio() {
            return this.m;
        }
        set pixelScalingRatio(a) {
            this.m = a;
            this.g("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.l;
        }
        set actualPixelScalingRatio(a) {
            this.l = a;
            this.g("ActualPixelScalingRatio");
        }
    }
    DataGridExpansionIndicatorDescription.$t = /*@__PURE__*/ markType(DataGridExpansionIndicatorDescription, 'DataGridExpansionIndicatorDescription', Description.$);
    return DataGridExpansionIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridExpansionIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridExpansionIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (DataGridExpansionIndicatorDescriptionMetadata.a == null) {
                DataGridExpansionIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridExpansionIndicatorDescriptionMetadata.c(DataGridExpansionIndicatorDescriptionMetadata.a);
            }
            if (a.k(DataGridExpansionIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataGridExpansionIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            a.item("IsExpanded", "Boolean");
            a.item("IconColor", "Brush");
            a.item("IsAnimationEnabled", "Boolean");
            a.item("PixelScalingRatio", "Number:double");
            a.item("ActualPixelScalingRatio", "Number:double");
        }
        static d(a) {
            DataGridExpansionIndicatorDescriptionMetadata.b(a);
            a.ae("DataGridExpansionIndicator", () => new DataGridExpansionIndicatorDescription());
            a.ad("DataGridExpansionIndicator", DataGridExpansionIndicatorDescriptionMetadata.a);
        }
    }
    DataGridExpansionIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridExpansionIndicatorDescriptionMetadata, 'DataGridExpansionIndicatorDescriptionMetadata');
    DataGridExpansionIndicatorDescriptionMetadata.a = null;
    return DataGridExpansionIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnOptionsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnOptionsBaseDescriptionMetadata.a == null) {
                GridColumnOptionsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnOptionsBaseDescriptionMetadata.c(GridColumnOptionsBaseDescriptionMetadata.a);
            }
            if (a.k(GridColumnOptionsBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnOptionsBaseDescriptionMetadata.a);
            DataGridColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("AutoSize", "Boolean");
            a.item("BackgroundColor", "Brush");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("ActualBaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("ActualBaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("ButtonDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("ButtonDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActualButtonDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("ActualButtonDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ButtonFontFamily", "(w:ButtonFontFamily/FontFamilyTransform,xam:ButtonFontFamily,wf:ButtonFontFamily,web:buttonTextStyle/FontFamilyTransform)String");
            a.item("ButtonFontSize", "(w:ButtonFontSize,xam:ButtonFontSize,wf:ButtonFontSize,web:buttonTextStyle/FontSizeTransform)Number:double");
            a.item("ButtonFontStyle", "(w:ButtonFontStyle/FontStyleTransform,xam:ButtonFontFamily/FontStyleTransform,wf:ButtonFontFamily/FontStyleTransform,web:buttonTextStyle/FontStyleTransform)String");
            a.item("ButtonFontWeight", "(w:ButtonFontWeight/FontWeightTransform,xam:ButtonFontFamily/FontWeightTransform,wf:ButtonFontFamily/FontWeightTransform,web:buttonTextStyle/FontWeightTransform)String");
            a.item("Column", "ExportedType:DataGridColumn");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActualDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("ActualDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("LabelFontFamily", "(w:LabelFontFamily/FontFamilyTransform,xam:LabelFontFamily,wf:LabelFontFamily,web:labelTextStyle/FontFamilyTransform)String");
            a.item("LabelFontSize", "(w:LabelFontSize,xam:LabelFontSize,wf:LabelFontSize,web:labelTextStyle/FontSizeTransform)Number:double");
            a.item("LabelFontStyle", "(w:LabelFontStyle/FontStyleTransform,xam:LabelFontFamily/FontStyleTransform,wf:LabelFontFamily/FontStyleTransform,web:labelTextStyle/FontStyleTransform)String");
            a.item("LabelFontWeight", "(w:LabelFontWeight/FontWeightTransform,xam:LabelFontFamily/FontWeightTransform,wf:LabelFontFamily/FontWeightTransform,web:labelTextStyle/FontWeightTransform)String");
            a.item("TextColor", "Brush");
        }
        static d(a) {
            GridColumnOptionsBaseDescriptionMetadata.b(a);
            a.ad("GridColumnOptionsBase", GridColumnOptionsBaseDescriptionMetadata.a);
        }
    }
    GridColumnOptionsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnOptionsBaseDescriptionMetadata, 'GridColumnOptionsBaseDescriptionMetadata');
    GridColumnOptionsBaseDescriptionMetadata.a = null;
    return GridColumnOptionsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsSectionBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnOptionsSectionBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnOptionsSectionBaseDescriptionMetadata.a == null) {
                GridColumnOptionsSectionBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnOptionsSectionBaseDescriptionMetadata.c(GridColumnOptionsSectionBaseDescriptionMetadata.a);
            }
            if (a.k(GridColumnOptionsSectionBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnOptionsSectionBaseDescriptionMetadata.a);
        }
        static c(a) {
            GridColumnOptionsBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            GridColumnOptionsSectionBaseDescriptionMetadata.b(a);
            a.ad("GridColumnOptionsSectionBase", GridColumnOptionsSectionBaseDescriptionMetadata.a);
        }
    }
    GridColumnOptionsSectionBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnOptionsSectionBaseDescriptionMetadata, 'GridColumnOptionsSectionBaseDescriptionMetadata');
    GridColumnOptionsSectionBaseDescriptionMetadata.a = null;
    return GridColumnOptionsSectionBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsSimpleSectionBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnOptionsSimpleSectionBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnOptionsSimpleSectionBaseDescriptionMetadata.a == null) {
                GridColumnOptionsSimpleSectionBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnOptionsSimpleSectionBaseDescriptionMetadata.c(GridColumnOptionsSimpleSectionBaseDescriptionMetadata.a);
            }
            if (a.k(GridColumnOptionsSimpleSectionBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnOptionsSimpleSectionBaseDescriptionMetadata.a);
        }
        static c(a) {
            GridColumnOptionsSectionBaseDescriptionMetadata.c(a);
            a.item("Caption", "String");
            a.item("ShowCaption", "Boolean");
        }
        static d(a) {
            GridColumnOptionsSimpleSectionBaseDescriptionMetadata.b(a);
            a.ad("GridColumnOptionsSimpleSectionBase", GridColumnOptionsSimpleSectionBaseDescriptionMetadata.a);
        }
    }
    GridColumnOptionsSimpleSectionBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnOptionsSimpleSectionBaseDescriptionMetadata, 'GridColumnOptionsSimpleSectionBaseDescriptionMetadata');
    GridColumnOptionsSimpleSectionBaseDescriptionMetadata.a = null;
    return GridColumnOptionsSimpleSectionBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsBaseDescription = /*@__PURE__*/ (() => {
    class GridColumnOptionsBaseDescription extends Description {
        get_type() {
            return "GridColumnOptionsBase";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = false;
            this.s = null;
            this.t = null;
            this.p = null;
            this.u = null;
            this.q = null;
            this.v = null;
            this.l = 0;
            this.w = null;
            this.x = null;
            this.h = null;
            this.y = null;
            this.r = null;
            this.z = null;
            this.m = 0;
            this.aa = null;
            this.ab = null;
            this.ac = null;
        }
        get autoSize() {
            return this.j;
        }
        set autoSize(a) {
            this.j = a;
            this.g("AutoSize");
        }
        get backgroundColor() {
            return this.s;
        }
        set backgroundColor(a) {
            this.s = a;
            this.g("BackgroundColor");
        }
        get baseTheme() {
            return this.t;
        }
        set baseTheme(a) {
            this.t = a;
            this.g("BaseTheme");
        }
        get actualBaseTheme() {
            return this.p;
        }
        set actualBaseTheme(a) {
            this.p = a;
            this.g("ActualBaseTheme");
        }
        get buttonDensity() {
            return this.u;
        }
        set buttonDensity(a) {
            this.u = a;
            this.g("ButtonDensity");
        }
        get actualButtonDensity() {
            return this.q;
        }
        set actualButtonDensity(a) {
            this.q = a;
            this.g("ActualButtonDensity");
        }
        get buttonFontFamily() {
            return this.v;
        }
        set buttonFontFamily(a) {
            this.v = a;
            this.g("ButtonFontFamily");
        }
        get buttonFontSize() {
            return this.l;
        }
        set buttonFontSize(a) {
            this.l = a;
            this.g("ButtonFontSize");
        }
        get buttonFontStyle() {
            return this.w;
        }
        set buttonFontStyle(a) {
            this.w = a;
            this.g("ButtonFontStyle");
        }
        get buttonFontWeight() {
            return this.x;
        }
        set buttonFontWeight(a) {
            this.x = a;
            this.g("ButtonFontWeight");
        }
        get column() {
            return this.h;
        }
        set column(a) {
            this.h = a;
            this.g("Column");
        }
        get density() {
            return this.y;
        }
        set density(a) {
            this.y = a;
            this.g("Density");
        }
        get actualDensity() {
            return this.r;
        }
        set actualDensity(a) {
            this.r = a;
            this.g("ActualDensity");
        }
        get labelFontFamily() {
            return this.z;
        }
        set labelFontFamily(a) {
            this.z = a;
            this.g("LabelFontFamily");
        }
        get labelFontSize() {
            return this.m;
        }
        set labelFontSize(a) {
            this.m = a;
            this.g("LabelFontSize");
        }
        get labelFontStyle() {
            return this.aa;
        }
        set labelFontStyle(a) {
            this.aa = a;
            this.g("LabelFontStyle");
        }
        get labelFontWeight() {
            return this.ab;
        }
        set labelFontWeight(a) {
            this.ab = a;
            this.g("LabelFontWeight");
        }
        get textColor() {
            return this.ac;
        }
        set textColor(a) {
            this.ac = a;
            this.g("TextColor");
        }
    }
    GridColumnOptionsBaseDescription.$t = /*@__PURE__*/ markType(GridColumnOptionsBaseDescription, 'GridColumnOptionsBaseDescription', Description.$);
    return GridColumnOptionsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsSectionBaseDescription = /*@__PURE__*/ (() => {
    class GridColumnOptionsSectionBaseDescription extends GridColumnOptionsBaseDescription {
        get_type() {
            return "GridColumnOptionsSectionBase";
        }
        constructor() {
            super();
        }
    }
    GridColumnOptionsSectionBaseDescription.$t = /*@__PURE__*/ markType(GridColumnOptionsSectionBaseDescription, 'GridColumnOptionsSectionBaseDescription', GridColumnOptionsBaseDescription.$);
    return GridColumnOptionsSectionBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsSimpleSectionBaseDescription = /*@__PURE__*/ (() => {
    class GridColumnOptionsSimpleSectionBaseDescription extends GridColumnOptionsSectionBaseDescription {
        get_type() {
            return "GridColumnOptionsSimpleSectionBase";
        }
        constructor() {
            super();
            this.au = null;
            this.as = false;
        }
        get caption() {
            return this.au;
        }
        set caption(a) {
            this.au = a;
            this.g("Caption");
        }
        get showCaption() {
            return this.as;
        }
        set showCaption(a) {
            this.as = a;
            this.g("ShowCaption");
        }
    }
    GridColumnOptionsSimpleSectionBaseDescription.$t = /*@__PURE__*/ markType(GridColumnOptionsSimpleSectionBaseDescription, 'GridColumnOptionsSimpleSectionBaseDescription', GridColumnOptionsSectionBaseDescription.$);
    return GridColumnOptionsSimpleSectionBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnSortOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnSortOptionsDescription extends GridColumnOptionsSimpleSectionBaseDescription {
        get_type() {
            return "GridColumnSortOptions";
        }
        constructor() {
            super();
            this.aw = null;
            this.ax = null;
            this.ay = null;
        }
        get ascendingCaption() {
            return this.aw;
        }
        set ascendingCaption(a) {
            this.aw = a;
            this.g("AscendingCaption");
        }
        get descendingCaption() {
            return this.ax;
        }
        set descendingCaption(a) {
            this.ax = a;
            this.g("DescendingCaption");
        }
        get sortDirection() {
            return this.ay;
        }
        set sortDirection(a) {
            this.ay = a;
            this.g("SortDirection");
        }
    }
    GridColumnSortOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnSortOptionsDescription, 'GridColumnSortOptionsDescription', GridColumnOptionsSimpleSectionBaseDescription.$);
    return GridColumnSortOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnSortOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnSortOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnSortOptionsDescriptionMetadata.a == null) {
                GridColumnSortOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnSortOptionsDescriptionMetadata.c(GridColumnSortOptionsDescriptionMetadata.a);
            }
            if (a.k(GridColumnSortOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnSortOptionsDescriptionMetadata.a);
        }
        static c(a) {
            GridColumnOptionsSimpleSectionBaseDescriptionMetadata.c(a);
            a.item("AscendingCaption", "String");
            a.item("DescendingCaption", "String");
            a.item("SortDirection", "ExportedType:string:ColumnSortDirection");
            a.item("SortDirection@names", "None;Ascending;Descending");
        }
        static d(a) {
            GridColumnSortOptionsDescriptionMetadata.b(a);
            a.ae("GridColumnSortOptions", () => new GridColumnSortOptionsDescription());
            a.ad("GridColumnSortOptions", GridColumnSortOptionsDescriptionMetadata.a);
        }
    }
    GridColumnSortOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnSortOptionsDescriptionMetadata, 'GridColumnSortOptionsDescriptionMetadata');
    GridColumnSortOptionsDescriptionMetadata.a = null;
    return GridColumnSortOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnSortOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnSortOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnSortOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnSortOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnSortOptionsDescriptionModule, 'GridColumnSortOptionsDescriptionModule');
    return GridColumnSortOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnMoveOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnMoveOptionsDescription extends GridColumnOptionsSimpleSectionBaseDescription {
        get_type() {
            return "GridColumnMoveOptions";
        }
        constructor() {
            super();
            this.aw = null;
            this.ax = null;
        }
        get moveLeftCaption() {
            return this.aw;
        }
        set moveLeftCaption(a) {
            this.aw = a;
            this.g("MoveLeftCaption");
        }
        get moveRightCaption() {
            return this.ax;
        }
        set moveRightCaption(a) {
            this.ax = a;
            this.g("MoveRightCaption");
        }
    }
    GridColumnMoveOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnMoveOptionsDescription, 'GridColumnMoveOptionsDescription', GridColumnOptionsSimpleSectionBaseDescription.$);
    return GridColumnMoveOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnMoveOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnMoveOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnMoveOptionsDescriptionMetadata.a == null) {
                GridColumnMoveOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnMoveOptionsDescriptionMetadata.c(GridColumnMoveOptionsDescriptionMetadata.a);
            }
            if (a.k(GridColumnMoveOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnMoveOptionsDescriptionMetadata.a);
        }
        static c(a) {
            GridColumnOptionsSimpleSectionBaseDescriptionMetadata.c(a);
            a.item("MoveLeftCaption", "String");
            a.item("MoveRightCaption", "String");
        }
        static d(a) {
            GridColumnMoveOptionsDescriptionMetadata.b(a);
            a.ae("GridColumnMoveOptions", () => new GridColumnMoveOptionsDescription());
            a.ad("GridColumnMoveOptions", GridColumnMoveOptionsDescriptionMetadata.a);
        }
    }
    GridColumnMoveOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnMoveOptionsDescriptionMetadata, 'GridColumnMoveOptionsDescriptionMetadata');
    GridColumnMoveOptionsDescriptionMetadata.a = null;
    return GridColumnMoveOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnMoveOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnMoveOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnMoveOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnMoveOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnMoveOptionsDescriptionModule, 'GridColumnMoveOptionsDescriptionModule');
    return GridColumnMoveOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnPinOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnPinOptionsDescription extends GridColumnOptionsSimpleSectionBaseDescription {
        get_type() {
            return "GridColumnPinOptions";
        }
        constructor() {
            super();
            this.aw = null;
            this.ax = null;
        }
        get pinLeftCaption() {
            return this.aw;
        }
        set pinLeftCaption(a) {
            this.aw = a;
            this.g("PinLeftCaption");
        }
        get pinRightCaption() {
            return this.ax;
        }
        set pinRightCaption(a) {
            this.ax = a;
            this.g("PinRightCaption");
        }
    }
    GridColumnPinOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnPinOptionsDescription, 'GridColumnPinOptionsDescription', GridColumnOptionsSimpleSectionBaseDescription.$);
    return GridColumnPinOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnPinOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnPinOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnPinOptionsDescriptionMetadata.a == null) {
                GridColumnPinOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnPinOptionsDescriptionMetadata.c(GridColumnPinOptionsDescriptionMetadata.a);
            }
            if (a.k(GridColumnPinOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnPinOptionsDescriptionMetadata.a);
        }
        static c(a) {
            GridColumnOptionsSimpleSectionBaseDescriptionMetadata.c(a);
            a.item("PinLeftCaption", "String");
            a.item("PinRightCaption", "String");
        }
        static d(a) {
            GridColumnPinOptionsDescriptionMetadata.b(a);
            a.ae("GridColumnPinOptions", () => new GridColumnPinOptionsDescription());
            a.ad("GridColumnPinOptions", GridColumnPinOptionsDescriptionMetadata.a);
        }
    }
    GridColumnPinOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnPinOptionsDescriptionMetadata, 'GridColumnPinOptionsDescriptionMetadata');
    GridColumnPinOptionsDescriptionMetadata.a = null;
    return GridColumnPinOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnPinOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnPinOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnPinOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnPinOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnPinOptionsDescriptionModule, 'GridColumnPinOptionsDescriptionModule');
    return GridColumnPinOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnHideOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnHideOptionsDescription extends GridColumnOptionsSimpleSectionBaseDescription {
        get_type() {
            return "GridColumnHideOptions";
        }
        constructor() {
            super();
        }
    }
    GridColumnHideOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnHideOptionsDescription, 'GridColumnHideOptionsDescription', GridColumnOptionsSimpleSectionBaseDescription.$);
    return GridColumnHideOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnHideOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnHideOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnHideOptionsDescriptionMetadata.a == null) {
                GridColumnHideOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnHideOptionsDescriptionMetadata.c(GridColumnHideOptionsDescriptionMetadata.a);
            }
            if (a.k(GridColumnHideOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnHideOptionsDescriptionMetadata.a);
        }
        static c(a) {
            GridColumnOptionsSimpleSectionBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            GridColumnHideOptionsDescriptionMetadata.b(a);
            a.ae("GridColumnHideOptions", () => new GridColumnHideOptionsDescription());
            a.ad("GridColumnHideOptions", GridColumnHideOptionsDescriptionMetadata.a);
        }
    }
    GridColumnHideOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnHideOptionsDescriptionMetadata, 'GridColumnHideOptionsDescriptionMetadata');
    GridColumnHideOptionsDescriptionMetadata.a = null;
    return GridColumnHideOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnHideOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnHideOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnHideOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnHideOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnHideOptionsDescriptionModule, 'GridColumnHideOptionsDescriptionModule');
    return GridColumnHideOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnGroupOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnGroupOptionsDescription extends GridColumnOptionsSimpleSectionBaseDescription {
        get_type() {
            return "GridColumnGroupOptions";
        }
        constructor() {
            super();
        }
    }
    GridColumnGroupOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnGroupOptionsDescription, 'GridColumnGroupOptionsDescription', GridColumnOptionsSimpleSectionBaseDescription.$);
    return GridColumnGroupOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnGroupOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnGroupOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnGroupOptionsDescriptionMetadata.a == null) {
                GridColumnGroupOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnGroupOptionsDescriptionMetadata.c(GridColumnGroupOptionsDescriptionMetadata.a);
            }
            if (a.k(GridColumnGroupOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnGroupOptionsDescriptionMetadata.a);
        }
        static c(a) {
            GridColumnOptionsSimpleSectionBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            GridColumnGroupOptionsDescriptionMetadata.b(a);
            a.ae("GridColumnGroupOptions", () => new GridColumnGroupOptionsDescription());
            a.ad("GridColumnGroupOptions", GridColumnGroupOptionsDescriptionMetadata.a);
        }
    }
    GridColumnGroupOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnGroupOptionsDescriptionMetadata, 'GridColumnGroupOptionsDescriptionMetadata');
    GridColumnGroupOptionsDescriptionMetadata.a = null;
    return GridColumnGroupOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnGroupOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnGroupOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnGroupOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnGroupOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnGroupOptionsDescriptionModule, 'GridColumnGroupOptionsDescriptionModule');
    return GridColumnGroupOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnFilterOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnFilterOptionsDescription extends GridColumnOptionsSectionBaseDescription {
        get_type() {
            return "GridColumnFilterOptions";
        }
        constructor() {
            super();
            this.at = null;
            this.av = null;
            this.au = null;
            this.as = null;
            this.aw = null;
        }
        get clearColumnFiltersCaption() {
            return this.at;
        }
        set clearColumnFiltersCaption(a) {
            this.at = a;
            this.g("ClearColumnFiltersCaption");
        }
        get filterListPlaceholderText() {
            return this.av;
        }
        set filterListPlaceholderText(a) {
            this.av = a;
            this.g("FilterListPlaceholderText");
        }
        get filterListDensity() {
            return this.au;
        }
        set filterListDensity(a) {
            this.au = a;
            this.g("FilterListDensity");
        }
        get actualFilterListDensity() {
            return this.as;
        }
        set actualFilterListDensity(a) {
            this.as = a;
            this.g("ActualFilterListDensity");
        }
        get textFilterCaption() {
            return this.aw;
        }
        set textFilterCaption(a) {
            this.aw = a;
            this.g("TextFilterCaption");
        }
    }
    GridColumnFilterOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnFilterOptionsDescription, 'GridColumnFilterOptionsDescription', GridColumnOptionsSectionBaseDescription.$);
    return GridColumnFilterOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnFilterOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnFilterOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnFilterOptionsDescriptionMetadata.a == null) {
                GridColumnFilterOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnFilterOptionsDescriptionMetadata.c(GridColumnFilterOptionsDescriptionMetadata.a);
            }
            if (a.k(GridColumnFilterOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnFilterOptionsDescriptionMetadata.a);
        }
        static c(a) {
            GridColumnOptionsSectionBaseDescriptionMetadata.c(a);
            a.item("ClearColumnFiltersCaption", "String");
            a.item("FilterListPlaceholderText", "String");
            a.item("FilterListDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("FilterListDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActualFilterListDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("ActualFilterListDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("TextFilterCaption", "String");
        }
        static d(a) {
            GridColumnFilterOptionsDescriptionMetadata.b(a);
            a.ae("GridColumnFilterOptions", () => new GridColumnFilterOptionsDescription());
            a.ad("GridColumnFilterOptions", GridColumnFilterOptionsDescriptionMetadata.a);
        }
    }
    GridColumnFilterOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnFilterOptionsDescriptionMetadata, 'GridColumnFilterOptionsDescriptionMetadata');
    GridColumnFilterOptionsDescriptionMetadata.a = null;
    return GridColumnFilterOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnFilterOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnFilterOptionsDescriptionModule extends Base {
        static register(a) {
            CheckboxListDescriptionModule.register(a);
            GridColumnFilterOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnFilterOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnFilterOptionsDescriptionModule, 'GridColumnFilterOptionsDescriptionModule');
    return GridColumnFilterOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnSummaryOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnSummaryOptionsDescription extends GridColumnOptionsSectionBaseDescription {
        get_type() {
            return "GridColumnSummaryOptions";
        }
        constructor() {
            super();
            this.av = null;
            this.ax = null;
            this.au = null;
            this.as = 0;
            this.ay = null;
            this.aw = null;
        }
        get summaryCaption() {
            return this.av;
        }
        set summaryCaption(a) {
            this.av = a;
            this.g("SummaryCaption");
        }
        get summaryListDensity() {
            return this.ax;
        }
        set summaryListDensity(a) {
            this.ax = a;
            this.g("SummaryListDensity");
        }
        get actualSummaryListDensity() {
            return this.au;
        }
        set actualSummaryListDensity(a) {
            this.au = a;
            this.g("ActualSummaryListDensity");
        }
        get activeCount() {
            return this.as;
        }
        set activeCount(a) {
            this.as = a;
            this.g("ActiveCount");
        }
        get summaryListTextColor() {
            return this.ay;
        }
        set summaryListTextColor(a) {
            this.ay = a;
            this.g("SummaryListTextColor");
        }
        get summaryListBackground() {
            return this.aw;
        }
        set summaryListBackground(a) {
            this.aw = a;
            this.g("SummaryListBackground");
        }
    }
    GridColumnSummaryOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnSummaryOptionsDescription, 'GridColumnSummaryOptionsDescription', GridColumnOptionsSectionBaseDescription.$);
    return GridColumnSummaryOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnSummaryOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnSummaryOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnSummaryOptionsDescriptionMetadata.a == null) {
                GridColumnSummaryOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnSummaryOptionsDescriptionMetadata.c(GridColumnSummaryOptionsDescriptionMetadata.a);
            }
            if (a.k(GridColumnSummaryOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnSummaryOptionsDescriptionMetadata.a);
        }
        static c(a) {
            GridColumnOptionsSectionBaseDescriptionMetadata.c(a);
            a.item("SummaryCaption", "String");
            a.item("SummaryListDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("SummaryListDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActualSummaryListDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("ActualSummaryListDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActiveCount", "Number:int");
            a.item("SummaryListTextColor", "Brush");
            a.item("SummaryListBackground", "Brush");
        }
        static d(a) {
            GridColumnSummaryOptionsDescriptionMetadata.b(a);
            a.ae("GridColumnSummaryOptions", () => new GridColumnSummaryOptionsDescription());
            a.ad("GridColumnSummaryOptions", GridColumnSummaryOptionsDescriptionMetadata.a);
        }
    }
    GridColumnSummaryOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnSummaryOptionsDescriptionMetadata, 'GridColumnSummaryOptionsDescriptionMetadata');
    GridColumnSummaryOptionsDescriptionMetadata.a = null;
    return GridColumnSummaryOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryChooserDescriptionModule = /*@__PURE__*/ (() => {
    class SummaryChooserDescriptionModule extends Base {
        static register(a) {
        }
    }
    SummaryChooserDescriptionModule.$t = /*@__PURE__*/ markType(SummaryChooserDescriptionModule, 'SummaryChooserDescriptionModule');
    return SummaryChooserDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnSummaryOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnSummaryOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnSummaryOptionsDescriptionMetadata.d(a);
            CheckboxListDescriptionModule.register(a);
            SummaryChooserDescriptionModule.register(a);
        }
    }
    GridColumnSummaryOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnSummaryOptionsDescriptionModule, 'GridColumnSummaryOptionsDescriptionModule');
    return GridColumnSummaryOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnButtonOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnButtonOptionsDescription extends GridColumnOptionsSectionBaseDescription {
        get_type() {
            return "GridColumnButtonOptions";
        }
        constructor() {
            super();
            this.as = null;
            this.au = null;
            this.at = null;
            this.av = null;
        }
        get applyButtonCaption() {
            return this.as;
        }
        set applyButtonCaption(a) {
            this.as = a;
            this.g("ApplyButtonCaption");
        }
        get cancelButtonCaption() {
            return this.au;
        }
        set cancelButtonCaption(a) {
            this.au = a;
            this.g("CancelButtonCaption");
        }
        get applyButtonClickRef() {
            return this.at;
        }
        set applyButtonClickRef(a) {
            this.at = a;
            this.g("ApplyButtonClickRef");
        }
        get cancelButtonClickRef() {
            return this.av;
        }
        set cancelButtonClickRef(a) {
            this.av = a;
            this.g("CancelButtonClickRef");
        }
    }
    GridColumnButtonOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnButtonOptionsDescription, 'GridColumnButtonOptionsDescription', GridColumnOptionsSectionBaseDescription.$);
    return GridColumnButtonOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnButtonOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnButtonOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnButtonOptionsDescriptionMetadata.a == null) {
                GridColumnButtonOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnButtonOptionsDescriptionMetadata.c(GridColumnButtonOptionsDescriptionMetadata.a);
            }
            if (a.k(GridColumnButtonOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnButtonOptionsDescriptionMetadata.a);
            ApplyButtonClickEventArgsDescriptionMetadata.d(a);
            CancelButtonClickEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            GridColumnOptionsSectionBaseDescriptionMetadata.c(a);
            a.item("ApplyButtonCaption", "String");
            a.item("CancelButtonCaption", "String");
            a.item("ApplyButtonClickRef", "EventRef::applyButtonClick");
            a.item("CancelButtonClickRef", "EventRef::cancelButtonClick");
        }
        static d(a) {
            GridColumnButtonOptionsDescriptionMetadata.b(a);
            a.ae("GridColumnButtonOptions", () => new GridColumnButtonOptionsDescription());
            a.ad("GridColumnButtonOptions", GridColumnButtonOptionsDescriptionMetadata.a);
        }
    }
    GridColumnButtonOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnButtonOptionsDescriptionMetadata, 'GridColumnButtonOptionsDescriptionMetadata');
    GridColumnButtonOptionsDescriptionMetadata.a = null;
    return GridColumnButtonOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnButtonOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnButtonOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnButtonOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnButtonOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnButtonOptionsDescriptionModule, 'GridColumnButtonOptionsDescriptionModule');
    return GridColumnButtonOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnOptionsDescription extends GridColumnOptionsBaseDescription {
        get_type() {
            return "GridColumnOptions";
        }
        constructor() {
            super();
            this.bp = null;
            this.a8 = 0;
            this.bq = null;
            this.br = null;
            this.bb = 0;
            this.bd = 0;
            this.bc = 0;
            this.ba = 0;
            this.au = false;
            this.ay = false;
            this.aw = false;
            this.ax = false;
            this.av = false;
            this.at = false;
            this.as = false;
            this.az = false;
            this.b2 = null;
            this.b0 = null;
            this.b1 = null;
            this.bu = null;
            this.bv = null;
            this.bw = null;
            this.bx = null;
            this.by = null;
            this.bz = null;
            this.bl = null;
            this.bn = null;
            this.bo = null;
            this.b4 = null;
            this.bj = null;
            this.bs = null;
            this.bi = null;
            this.bt = null;
            this.b5 = null;
            this.b3 = null;
            this.bk = null;
            this.bm = null;
        }
        get columnNameFontFamily() {
            return this.bp;
        }
        set columnNameFontFamily(a) {
            this.bp = a;
            this.g("ColumnNameFontFamily");
        }
        get columnNameFontSize() {
            return this.a8;
        }
        set columnNameFontSize(a) {
            this.a8 = a;
            this.g("ColumnNameFontSize");
        }
        get columnNameFontStyle() {
            return this.bq;
        }
        set columnNameFontStyle(a) {
            this.bq = a;
            this.g("ColumnNameFontStyle");
        }
        get columnNameFontWeight() {
            return this.br;
        }
        set columnNameFontWeight(a) {
            this.br = a;
            this.g("ColumnNameFontWeight");
        }
        get paddingLeft() {
            return this.bb;
        }
        set paddingLeft(a) {
            this.bb = a;
            this.g("PaddingLeft");
        }
        get paddingTop() {
            return this.bd;
        }
        set paddingTop(a) {
            this.bd = a;
            this.g("PaddingTop");
        }
        get paddingRight() {
            return this.bc;
        }
        set paddingRight(a) {
            this.bc = a;
            this.g("PaddingRight");
        }
        get paddingBottom() {
            return this.ba;
        }
        set paddingBottom(a) {
            this.ba = a;
            this.g("PaddingBottom");
        }
        get headerVisible() {
            return this.au;
        }
        set headerVisible(a) {
            this.au = a;
            this.g("HeaderVisible");
        }
        get sortOptionsVisible() {
            return this.ay;
        }
        set sortOptionsVisible(a) {
            this.ay = a;
            this.g("SortOptionsVisible");
        }
        get moveOptionsVisible() {
            return this.aw;
        }
        set moveOptionsVisible(a) {
            this.aw = a;
            this.g("MoveOptionsVisible");
        }
        get pinOptionsVisible() {
            return this.ax;
        }
        set pinOptionsVisible(a) {
            this.ax = a;
            this.g("PinOptionsVisible");
        }
        get hideOptionsVisible() {
            return this.av;
        }
        set hideOptionsVisible(a) {
            this.av = a;
            this.g("HideOptionsVisible");
        }
        get groupOptionsVisible() {
            return this.at;
        }
        set groupOptionsVisible(a) {
            this.at = a;
            this.g("GroupOptionsVisible");
        }
        get filterOptionsVisible() {
            return this.as;
        }
        set filterOptionsVisible(a) {
            this.as = a;
            this.g("FilterOptionsVisible");
        }
        get summaryOptionsVisible() {
            return this.az;
        }
        set summaryOptionsVisible(a) {
            this.az = a;
            this.g("SummaryOptionsVisible");
        }
        get sortHeaderCaption() {
            return this.b2;
        }
        set sortHeaderCaption(a) {
            this.b2 = a;
            this.g("SortHeaderCaption");
        }
        get sortAscendingCaption() {
            return this.b0;
        }
        set sortAscendingCaption(a) {
            this.b0 = a;
            this.g("SortAscendingCaption");
        }
        get sortDescendingCaption() {
            return this.b1;
        }
        set sortDescendingCaption(a) {
            this.b1 = a;
            this.g("SortDescendingCaption");
        }
        get moveHeaderCaption() {
            return this.bu;
        }
        set moveHeaderCaption(a) {
            this.bu = a;
            this.g("MoveHeaderCaption");
        }
        get moveLeftCaption() {
            return this.bv;
        }
        set moveLeftCaption(a) {
            this.bv = a;
            this.g("MoveLeftCaption");
        }
        get moveRightCaption() {
            return this.bw;
        }
        set moveRightCaption(a) {
            this.bw = a;
            this.g("MoveRightCaption");
        }
        get pinHeaderCaption() {
            return this.bx;
        }
        set pinHeaderCaption(a) {
            this.bx = a;
            this.g("PinHeaderCaption");
        }
        get pinLeftCaption() {
            return this.by;
        }
        set pinLeftCaption(a) {
            this.by = a;
            this.g("PinLeftCaption");
        }
        get pinRightCaption() {
            return this.bz;
        }
        set pinRightCaption(a) {
            this.bz = a;
            this.g("PinRightCaption");
        }
        get applyFiltersButtonCaption() {
            return this.bl;
        }
        set applyFiltersButtonCaption(a) {
            this.bl = a;
            this.g("ApplyFiltersButtonCaption");
        }
        get cancelFiltersButtonCaption() {
            return this.bn;
        }
        set cancelFiltersButtonCaption(a) {
            this.bn = a;
            this.g("CancelFiltersButtonCaption");
        }
        get clearColumnFiltersCaption() {
            return this.bo;
        }
        set clearColumnFiltersCaption(a) {
            this.bo = a;
            this.g("ClearColumnFiltersCaption");
        }
        get summaryListDensity() {
            return this.b4;
        }
        set summaryListDensity(a) {
            this.b4 = a;
            this.g("SummaryListDensity");
        }
        get actualSummaryListDensity() {
            return this.bj;
        }
        set actualSummaryListDensity(a) {
            this.bj = a;
            this.g("ActualSummaryListDensity");
        }
        get filterListDensity() {
            return this.bs;
        }
        set filterListDensity(a) {
            this.bs = a;
            this.g("FilterListDensity");
        }
        get actualFilterListDensity() {
            return this.bi;
        }
        set actualFilterListDensity(a) {
            this.bi = a;
            this.g("ActualFilterListDensity");
        }
        get filterListPlaceholderText() {
            return this.bt;
        }
        set filterListPlaceholderText(a) {
            this.bt = a;
            this.g("FilterListPlaceholderText");
        }
        get summaryListTextColor() {
            return this.b5;
        }
        set summaryListTextColor(a) {
            this.b5 = a;
            this.g("SummaryListTextColor");
        }
        get summaryListBackground() {
            return this.b3;
        }
        set summaryListBackground(a) {
            this.b3 = a;
            this.g("SummaryListBackground");
        }
        get applyButtonClickRef() {
            return this.bk;
        }
        set applyButtonClickRef(a) {
            this.bk = a;
            this.g("ApplyButtonClickRef");
        }
        get cancelButtonClickRef() {
            return this.bm;
        }
        set cancelButtonClickRef(a) {
            this.bm = a;
            this.g("CancelButtonClickRef");
        }
    }
    GridColumnOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnOptionsDescription, 'GridColumnOptionsDescription', GridColumnOptionsBaseDescription.$);
    return GridColumnOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnOptionsDescriptionMetadata.a == null) {
                GridColumnOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnOptionsDescriptionMetadata.c(GridColumnOptionsDescriptionMetadata.a);
            }
            if (a.k(GridColumnOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridColumnOptionsDescriptionMetadata.a);
            ApplyButtonClickEventArgsDescriptionMetadata.d(a);
            CancelButtonClickEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            GridColumnOptionsBaseDescriptionMetadata.c(a);
            a.item("ColumnNameFontFamily", "(w:ColumnNameFontFamily/FontFamilyTransform,xam:ColumnNameFontFamily,wf:ColumnNameFontFamily,web:columnNameTextStyle/FontFamilyTransform)String");
            a.item("ColumnNameFontSize", "(w:ColumnNameFontSize,xam:ColumnNameFontSize,wf:ColumnNameFontSize,web:columnNameTextStyle/FontSizeTransform)Number:double");
            a.item("ColumnNameFontStyle", "(w:ColumnNameFontStyle/FontStyleTransform,xam:ColumnNameFontFamily/FontStyleTransform,wf:ColumnNameFontFamily/FontStyleTransform,web:columnNameTextStyle/FontStyleTransform)String");
            a.item("ColumnNameFontWeight", "(w:ColumnNameFontWeight/FontWeightTransform,xam:ColumnNameFontFamily/FontWeightTransform,wf:ColumnNameFontFamily/FontWeightTransform,web:columnNameTextStyle/FontWeightTransform)String");
            a.item("PaddingLeft", "Number:int");
            a.item("PaddingTop", "Number:int");
            a.item("PaddingRight", "Number:int");
            a.item("PaddingBottom", "Number:int");
            a.item("HeaderVisible", "Boolean");
            a.item("SortOptionsVisible", "Boolean");
            a.item("MoveOptionsVisible", "Boolean");
            a.item("PinOptionsVisible", "Boolean");
            a.item("HideOptionsVisible", "Boolean");
            a.item("GroupOptionsVisible", "Boolean");
            a.item("FilterOptionsVisible", "Boolean");
            a.item("SummaryOptionsVisible", "Boolean");
            a.item("SortHeaderCaption", "String");
            a.item("SortAscendingCaption", "String");
            a.item("SortDescendingCaption", "String");
            a.item("MoveHeaderCaption", "String");
            a.item("MoveLeftCaption", "String");
            a.item("MoveRightCaption", "String");
            a.item("PinHeaderCaption", "String");
            a.item("PinLeftCaption", "String");
            a.item("PinRightCaption", "String");
            a.item("ApplyFiltersButtonCaption", "String");
            a.item("CancelFiltersButtonCaption", "String");
            a.item("ClearColumnFiltersCaption", "String");
            a.item("SummaryListDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("SummaryListDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActualSummaryListDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("ActualSummaryListDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("FilterListDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("FilterListDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActualFilterListDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("ActualFilterListDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("FilterListPlaceholderText", "String");
            a.item("SummaryListTextColor", "Brush");
            a.item("SummaryListBackground", "Brush");
            a.item("ApplyButtonClickRef", "EventRef::applyButtonClick");
            a.item("CancelButtonClickRef", "EventRef::cancelButtonClick");
        }
        static d(a) {
            GridColumnOptionsDescriptionMetadata.b(a);
            a.ae("GridColumnOptions", () => new GridColumnOptionsDescription());
            a.ad("GridColumnOptions", GridColumnOptionsDescriptionMetadata.a);
        }
    }
    GridColumnOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnOptionsDescriptionMetadata, 'GridColumnOptionsDescriptionMetadata');
    GridColumnOptionsDescriptionMetadata.a = null;
    return GridColumnOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnSortOptionsDescriptionModule.register(a);
            GridColumnMoveOptionsDescriptionModule.register(a);
            GridColumnPinOptionsDescriptionModule.register(a);
            GridColumnHideOptionsDescriptionModule.register(a);
            GridColumnGroupOptionsDescriptionModule.register(a);
            GridColumnFilterOptionsDescriptionModule.register(a);
            GridColumnSummaryOptionsDescriptionModule.register(a);
            GridColumnButtonOptionsDescriptionModule.register(a);
            GridColumnOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnOptionsDescriptionModule, 'GridColumnOptionsDescriptionModule');
    return GridColumnOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GotFocusEventArgsDescription = /*@__PURE__*/ (() => {
    class GotFocusEventArgsDescription extends Description {
        get_type() {
            return "GotFocusEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    GotFocusEventArgsDescription.$t = /*@__PURE__*/ markType(GotFocusEventArgsDescription, 'GotFocusEventArgsDescription', Description.$);
    return GotFocusEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GotFocusEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GotFocusEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GotFocusEventArgsDescriptionMetadata.a == null) {
                GotFocusEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GotFocusEventArgsDescriptionMetadata.c(GotFocusEventArgsDescriptionMetadata.a);
            }
            if (a.k(GotFocusEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GotFocusEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            GotFocusEventArgsDescriptionMetadata.b(a);
            a.ae("GotFocusEventArgs", () => new GotFocusEventArgsDescription());
            a.ad("GotFocusEventArgs", GotFocusEventArgsDescriptionMetadata.a);
        }
    }
    GotFocusEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GotFocusEventArgsDescriptionMetadata, 'GotFocusEventArgsDescriptionMetadata');
    GotFocusEventArgsDescriptionMetadata.a = null;
    return GotFocusEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LostFocusEventArgsDescription = /*@__PURE__*/ (() => {
    class LostFocusEventArgsDescription extends Description {
        get_type() {
            return "LostFocusEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    LostFocusEventArgsDescription.$t = /*@__PURE__*/ markType(LostFocusEventArgsDescription, 'LostFocusEventArgsDescription', Description.$);
    return LostFocusEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LostFocusEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class LostFocusEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (LostFocusEventArgsDescriptionMetadata.a == null) {
                LostFocusEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LostFocusEventArgsDescriptionMetadata.c(LostFocusEventArgsDescriptionMetadata.a);
            }
            if (a.k(LostFocusEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(LostFocusEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            LostFocusEventArgsDescriptionMetadata.b(a);
            a.ae("LostFocusEventArgs", () => new LostFocusEventArgsDescription());
            a.ad("LostFocusEventArgs", LostFocusEventArgsDescriptionMetadata.a);
        }
    }
    LostFocusEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(LostFocusEventArgsDescriptionMetadata, 'LostFocusEventArgsDescriptionMetadata');
    LostFocusEventArgsDescriptionMetadata.a = null;
    return LostFocusEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MultiColumnComboBoxTextChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class MultiColumnComboBoxTextChangedEventArgsDescription extends Description {
        get_type() {
            return "MultiColumnComboBoxTextChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    MultiColumnComboBoxTextChangedEventArgsDescription.$t = /*@__PURE__*/ markType(MultiColumnComboBoxTextChangedEventArgsDescription, 'MultiColumnComboBoxTextChangedEventArgsDescription', Description.$);
    return MultiColumnComboBoxTextChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.a == null) {
                MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.c(MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.b(a);
            a.ae("MultiColumnComboBoxTextChangedEventArgs", () => new MultiColumnComboBoxTextChangedEventArgsDescription());
            a.ad("MultiColumnComboBoxTextChangedEventArgs", MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.a);
        }
    }
    MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata, 'MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata');
    MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.a = null;
    return MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MultiColumnComboBoxValueChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class MultiColumnComboBoxValueChangedEventArgsDescription extends Description {
        get_type() {
            return "MultiColumnComboBoxValueChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    MultiColumnComboBoxValueChangedEventArgsDescription.$t = /*@__PURE__*/ markType(MultiColumnComboBoxValueChangedEventArgsDescription, 'MultiColumnComboBoxValueChangedEventArgsDescription', Description.$);
    return MultiColumnComboBoxValueChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.a == null) {
                MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.c(MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.b(a);
            a.ae("MultiColumnComboBoxValueChangedEventArgs", () => new MultiColumnComboBoxValueChangedEventArgsDescription());
            a.ad("MultiColumnComboBoxValueChangedEventArgs", MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.a);
        }
    }
    MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata, 'MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata');
    MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.a = null;
    return MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MultiColumnComboBoxDescription = /*@__PURE__*/ (() => {
    class MultiColumnComboBoxDescription extends Description {
        get_type() {
            return "MultiColumnComboBox";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.w = false;
            this.j = null;
            this.c5 = null;
            this.cr = null;
            this.c6 = null;
            this.cs = null;
            this.c7 = null;
            this.ct = null;
            this.az = 0;
            this.ah = 0;
            this.r = false;
            this.a0 = 0;
            this.a1 = 0;
            this.a2 = 0;
            this.a3 = 0;
            this.ai = 0;
            this.aj = 0;
            this.ak = 0;
            this.al = 0;
            this.a5 = 0;
            this.a4 = 0;
            this.a6 = 0;
            this.a7 = 0;
            this.an = 0;
            this.am = 0;
            this.ao = 0;
            this.ap = 0;
            this.i = null;
            this.db = null;
            this.cu = null;
            this.s = false;
            this.dc = null;
            this.cv = null;
            this.a9 = 0;
            this.aq = 0;
            this.dd = null;
            this.cw = null;
            this.ba = 0;
            this.ar = 0;
            this.bb = 0;
            this.as = 0;
            this.di = null;
            this.cx = null;
            this.bd = 0;
            this.at = 0;
            this.be = 0;
            this.au = 0;
            this.da = null;
            this.dk = null;
            this.dp = null;
            this.cy = null;
            this.dl = null;
            this.bf = 0;
            this.dm = null;
            this.dn = null;
            this.p = false;
            this.dr = null;
            this.cz = null;
            this.ds = null;
            this.c0 = null;
            this.dw = null;
            this.c1 = null;
            this.dt = null;
            this.bg = 0;
            this.du = null;
            this.dv = null;
            this.dx = null;
            this.v = false;
            this.d2 = null;
            this.c2 = null;
            this.de = null;
            this.bc = 0;
            this.df = null;
            this.dg = null;
            this.d5 = null;
            this.c3 = null;
            this.bh = 0;
            this.av = 0;
            this.d6 = null;
            this.c4 = null;
            this.bi = 0;
            this.aw = 0;
            this.bj = 0;
            this.ax = 0;
            this.bk = 0;
            this.ay = 0;
            this.q = false;
            this.dz = null;
            this.d3 = null;
            this.d0 = null;
            this.k = null;
            this.h = null;
            this.cp = null;
            this.t = false;
            this.u = false;
            this.x = false;
            this.dh = null;
            this.dq = null;
            this.d4 = null;
            this.dy = null;
            this.dj = null;
            this.c8 = null;
            this.c9 = null;
            this.d1 = null;
            this.d7 = null;
            this.a8 = 0;
        }
        get showClearButton() {
            return this.w;
        }
        set showClearButton(a) {
            this.w = a;
            this.g("ShowClearButton");
        }
        get fields() {
            return this.j;
        }
        set fields(a) {
            this.j = a;
            this.g("Fields");
        }
        get backgroundColor() {
            return this.c5;
        }
        set backgroundColor(a) {
            this.c5 = a;
            this.g("BackgroundColor");
        }
        get actualBackgroundColor() {
            return this.cr;
        }
        set actualBackgroundColor(a) {
            this.cr = a;
            this.g("ActualBackgroundColor");
        }
        get baseTheme() {
            return this.c6;
        }
        set baseTheme(a) {
            this.c6 = a;
            this.g("BaseTheme");
        }
        get actualBaseTheme() {
            return this.cs;
        }
        set actualBaseTheme(a) {
            this.cs = a;
            this.g("ActualBaseTheme");
        }
        get borderColor() {
            return this.c7;
        }
        set borderColor(a) {
            this.c7 = a;
            this.g("BorderColor");
        }
        get actualBorderColor() {
            return this.ct;
        }
        set actualBorderColor(a) {
            this.ct = a;
            this.g("ActualBorderColor");
        }
        get borderWidth() {
            return this.az;
        }
        set borderWidth(a) {
            this.az = a;
            this.g("BorderWidth");
        }
        get actualBorderWidth() {
            return this.ah;
        }
        set actualBorderWidth(a) {
            this.ah = a;
            this.g("ActualBorderWidth");
        }
        get columnHeadersVisible() {
            return this.r;
        }
        set columnHeadersVisible(a) {
            this.r = a;
            this.g("ColumnHeadersVisible");
        }
        get contentPaddingBottom() {
            return this.a0;
        }
        set contentPaddingBottom(a) {
            this.a0 = a;
            this.g("ContentPaddingBottom");
        }
        get contentPaddingLeft() {
            return this.a1;
        }
        set contentPaddingLeft(a) {
            this.a1 = a;
            this.g("ContentPaddingLeft");
        }
        get contentPaddingRight() {
            return this.a2;
        }
        set contentPaddingRight(a) {
            this.a2 = a;
            this.g("ContentPaddingRight");
        }
        get contentPaddingTop() {
            return this.a3;
        }
        set contentPaddingTop(a) {
            this.a3 = a;
            this.g("ContentPaddingTop");
        }
        get actualContentPaddingBottom() {
            return this.ai;
        }
        set actualContentPaddingBottom(a) {
            this.ai = a;
            this.g("ActualContentPaddingBottom");
        }
        get actualContentPaddingLeft() {
            return this.aj;
        }
        set actualContentPaddingLeft(a) {
            this.aj = a;
            this.g("ActualContentPaddingLeft");
        }
        get actualContentPaddingRight() {
            return this.ak;
        }
        set actualContentPaddingRight(a) {
            this.ak = a;
            this.g("ActualContentPaddingRight");
        }
        get actualContentPaddingTop() {
            return this.al;
        }
        set actualContentPaddingTop(a) {
            this.al = a;
            this.g("ActualContentPaddingTop");
        }
        get cornerRadiusBottomRight() {
            return this.a5;
        }
        set cornerRadiusBottomRight(a) {
            this.a5 = a;
            this.g("CornerRadiusBottomRight");
        }
        get cornerRadiusBottomLeft() {
            return this.a4;
        }
        set cornerRadiusBottomLeft(a) {
            this.a4 = a;
            this.g("CornerRadiusBottomLeft");
        }
        get cornerRadiusTopLeft() {
            return this.a6;
        }
        set cornerRadiusTopLeft(a) {
            this.a6 = a;
            this.g("CornerRadiusTopLeft");
        }
        get cornerRadiusTopRight() {
            return this.a7;
        }
        set cornerRadiusTopRight(a) {
            this.a7 = a;
            this.g("CornerRadiusTopRight");
        }
        get actualCornerRadiusBottomRight() {
            return this.an;
        }
        set actualCornerRadiusBottomRight(a) {
            this.an = a;
            this.g("ActualCornerRadiusBottomRight");
        }
        get actualCornerRadiusBottomLeft() {
            return this.am;
        }
        set actualCornerRadiusBottomLeft(a) {
            this.am = a;
            this.g("ActualCornerRadiusBottomLeft");
        }
        get actualCornerRadiusTopLeft() {
            return this.ao;
        }
        set actualCornerRadiusTopLeft(a) {
            this.ao = a;
            this.g("ActualCornerRadiusTopLeft");
        }
        get actualCornerRadiusTopRight() {
            return this.ap;
        }
        set actualCornerRadiusTopRight(a) {
            this.ap = a;
            this.g("ActualCornerRadiusTopRight");
        }
        get dataSourceDesiredProperties() {
            return this.i;
        }
        set dataSourceDesiredProperties(a) {
            this.i = a;
            this.g("DataSourceDesiredProperties");
        }
        get density() {
            return this.db;
        }
        set density(a) {
            this.db = a;
            this.g("Density");
        }
        get actualDensity() {
            return this.cu;
        }
        set actualDensity(a) {
            this.cu = a;
            this.g("ActualDensity");
        }
        get dropDownButtonVisible() {
            return this.s;
        }
        set dropDownButtonVisible(a) {
            this.s = a;
            this.g("DropDownButtonVisible");
        }
        get focusBorderColor() {
            return this.dc;
        }
        set focusBorderColor(a) {
            this.dc = a;
            this.g("FocusBorderColor");
        }
        get actualFocusBorderColor() {
            return this.cv;
        }
        set actualFocusBorderColor(a) {
            this.cv = a;
            this.g("ActualFocusBorderColor");
        }
        get focusBorderWidth() {
            return this.a9;
        }
        set focusBorderWidth(a) {
            this.a9 = a;
            this.g("FocusBorderWidth");
        }
        get actualFocusBorderWidth() {
            return this.aq;
        }
        set actualFocusBorderWidth(a) {
            this.aq = a;
            this.g("ActualFocusBorderWidth");
        }
        get focusUnderlineColor() {
            return this.dd;
        }
        set focusUnderlineColor(a) {
            this.dd = a;
            this.g("FocusUnderlineColor");
        }
        get actualFocusUnderlineColor() {
            return this.cw;
        }
        set actualFocusUnderlineColor(a) {
            this.cw = a;
            this.g("ActualFocusUnderlineColor");
        }
        get focusUnderlineOpacity() {
            return this.ba;
        }
        set focusUnderlineOpacity(a) {
            this.ba = a;
            this.g("FocusUnderlineOpacity");
        }
        get actualFocusUnderlineOpacity() {
            return this.ar;
        }
        set actualFocusUnderlineOpacity(a) {
            this.ar = a;
            this.g("ActualFocusUnderlineOpacity");
        }
        get focusUnderlineRippleOpacity() {
            return this.bb;
        }
        set focusUnderlineRippleOpacity(a) {
            this.bb = a;
            this.g("FocusUnderlineRippleOpacity");
        }
        get actualFocusUnderlineRippleOpacity() {
            return this.as;
        }
        set actualFocusUnderlineRippleOpacity(a) {
            this.as = a;
            this.g("ActualFocusUnderlineRippleOpacity");
        }
        get hoverUnderlineColor() {
            return this.di;
        }
        set hoverUnderlineColor(a) {
            this.di = a;
            this.g("HoverUnderlineColor");
        }
        get actualHoverUnderlineColor() {
            return this.cx;
        }
        set actualHoverUnderlineColor(a) {
            this.cx = a;
            this.g("ActualHoverUnderlineColor");
        }
        get hoverUnderlineOpacity() {
            return this.bd;
        }
        set hoverUnderlineOpacity(a) {
            this.bd = a;
            this.g("HoverUnderlineOpacity");
        }
        get actualHoverUnderlineOpacity() {
            return this.at;
        }
        set actualHoverUnderlineOpacity(a) {
            this.at = a;
            this.g("ActualHoverUnderlineOpacity");
        }
        get hoverUnderlineWidth() {
            return this.be;
        }
        set hoverUnderlineWidth(a) {
            this.be = a;
            this.g("HoverUnderlineWidth");
        }
        get actualHoverUnderlineWidth() {
            return this.au;
        }
        set actualHoverUnderlineWidth(a) {
            this.au = a;
            this.g("ActualHoverUnderlineWidth");
        }
        get dataSourceRef() {
            return this.da;
        }
        set dataSourceRef(a) {
            this.da = a;
            this.g("DataSourceRef");
        }
        get label() {
            return this.dk;
        }
        set label(a) {
            this.dk = a;
            this.g("Label");
        }
        get labelTextColor() {
            return this.dp;
        }
        set labelTextColor(a) {
            this.dp = a;
            this.g("LabelTextColor");
        }
        get actualLabelTextColor() {
            return this.cy;
        }
        set actualLabelTextColor(a) {
            this.cy = a;
            this.g("ActualLabelTextColor");
        }
        get labelFontFamily() {
            return this.dl;
        }
        set labelFontFamily(a) {
            this.dl = a;
            this.g("LabelFontFamily");
        }
        get labelFontSize() {
            return this.bf;
        }
        set labelFontSize(a) {
            this.bf = a;
            this.g("LabelFontSize");
        }
        get labelFontStyle() {
            return this.dm;
        }
        set labelFontStyle(a) {
            this.dm = a;
            this.g("LabelFontStyle");
        }
        get labelFontWeight() {
            return this.dn;
        }
        set labelFontWeight(a) {
            this.dn = a;
            this.g("LabelFontWeight");
        }
        get actualLabelVisible() {
            return this.p;
        }
        set actualLabelVisible(a) {
            this.p = a;
            this.g("ActualLabelVisible");
        }
        get noMatchesFoundLabel() {
            return this.dr;
        }
        set noMatchesFoundLabel(a) {
            this.dr = a;
            this.g("NoMatchesFoundLabel");
        }
        get actualNoMatchesFoundLabel() {
            return this.cz;
        }
        set actualNoMatchesFoundLabel(a) {
            this.cz = a;
            this.g("ActualNoMatchesFoundLabel");
        }
        get noMatchesFoundLabelBackgroundColor() {
            return this.ds;
        }
        set noMatchesFoundLabelBackgroundColor(a) {
            this.ds = a;
            this.g("NoMatchesFoundLabelBackgroundColor");
        }
        get actualNoMatchesFoundLabelBackgroundColor() {
            return this.c0;
        }
        set actualNoMatchesFoundLabelBackgroundColor(a) {
            this.c0 = a;
            this.g("ActualNoMatchesFoundLabelBackgroundColor");
        }
        get noMatchesFoundLabelTextColor() {
            return this.dw;
        }
        set noMatchesFoundLabelTextColor(a) {
            this.dw = a;
            this.g("NoMatchesFoundLabelTextColor");
        }
        get actualNoMatchesFoundLabelTextColor() {
            return this.c1;
        }
        set actualNoMatchesFoundLabelTextColor(a) {
            this.c1 = a;
            this.g("ActualNoMatchesFoundLabelTextColor");
        }
        get noMatchesFoundLabelFontFamily() {
            return this.dt;
        }
        set noMatchesFoundLabelFontFamily(a) {
            this.dt = a;
            this.g("NoMatchesFoundLabelFontFamily");
        }
        get noMatchesFoundLabelFontSize() {
            return this.bg;
        }
        set noMatchesFoundLabelFontSize(a) {
            this.bg = a;
            this.g("NoMatchesFoundLabelFontSize");
        }
        get noMatchesFoundLabelFontStyle() {
            return this.du;
        }
        set noMatchesFoundLabelFontStyle(a) {
            this.du = a;
            this.g("NoMatchesFoundLabelFontStyle");
        }
        get noMatchesFoundLabelFontWeight() {
            return this.dv;
        }
        set noMatchesFoundLabelFontWeight(a) {
            this.dv = a;
            this.g("NoMatchesFoundLabelFontWeight");
        }
        get placeholder() {
            return this.dx;
        }
        set placeholder(a) {
            this.dx = a;
            this.g("Placeholder");
        }
        get rowSeparatorsVisible() {
            return this.v;
        }
        set rowSeparatorsVisible(a) {
            this.v = a;
            this.g("RowSeparatorsVisible");
        }
        get textColor() {
            return this.d2;
        }
        set textColor(a) {
            this.d2 = a;
            this.g("TextColor");
        }
        get actualTextColor() {
            return this.c2;
        }
        set actualTextColor(a) {
            this.c2 = a;
            this.g("ActualTextColor");
        }
        get fontFamily() {
            return this.de;
        }
        set fontFamily(a) {
            this.de = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.bc;
        }
        set fontSize(a) {
            this.bc = a;
            this.g("FontSize");
        }
        get fontStyle() {
            return this.df;
        }
        set fontStyle(a) {
            this.df = a;
            this.g("FontStyle");
        }
        get fontWeight() {
            return this.dg;
        }
        set fontWeight(a) {
            this.dg = a;
            this.g("FontWeight");
        }
        get underlineColor() {
            return this.d5;
        }
        set underlineColor(a) {
            this.d5 = a;
            this.g("UnderlineColor");
        }
        get actualUnderlineColor() {
            return this.c3;
        }
        set actualUnderlineColor(a) {
            this.c3 = a;
            this.g("ActualUnderlineColor");
        }
        get underlineOpacity() {
            return this.bh;
        }
        set underlineOpacity(a) {
            this.bh = a;
            this.g("UnderlineOpacity");
        }
        get actualUnderlineOpacity() {
            return this.av;
        }
        set actualUnderlineOpacity(a) {
            this.av = a;
            this.g("ActualUnderlineOpacity");
        }
        get underlineRippleColor() {
            return this.d6;
        }
        set underlineRippleColor(a) {
            this.d6 = a;
            this.g("UnderlineRippleColor");
        }
        get actualUnderlineRippleColor() {
            return this.c4;
        }
        set actualUnderlineRippleColor(a) {
            this.c4 = a;
            this.g("ActualUnderlineRippleColor");
        }
        get underlineRippleOpacity() {
            return this.bi;
        }
        set underlineRippleOpacity(a) {
            this.bi = a;
            this.g("UnderlineRippleOpacity");
        }
        get actualUnderlineRippleOpacity() {
            return this.aw;
        }
        set actualUnderlineRippleOpacity(a) {
            this.aw = a;
            this.g("ActualUnderlineRippleOpacity");
        }
        get underlineRippleWidth() {
            return this.bj;
        }
        set underlineRippleWidth(a) {
            this.bj = a;
            this.g("UnderlineRippleWidth");
        }
        get actualUnderlineRippleWidth() {
            return this.ax;
        }
        set actualUnderlineRippleWidth(a) {
            this.ax = a;
            this.g("ActualUnderlineRippleWidth");
        }
        get underlineWidth() {
            return this.bk;
        }
        set underlineWidth(a) {
            this.bk = a;
            this.g("UnderlineWidth");
        }
        get actualUnderlineWidth() {
            return this.ay;
        }
        set actualUnderlineWidth(a) {
            this.ay = a;
            this.g("ActualUnderlineWidth");
        }
        get allowFilter() {
            return this.q;
        }
        set allowFilter(a) {
            this.q = a;
            this.g("AllowFilter");
        }
        get sortMode() {
            return this.dz;
        }
        set sortMode(a) {
            this.dz = a;
            this.g("SortMode");
        }
        get textField() {
            return this.d3;
        }
        set textField(a) {
            this.d3 = a;
            this.g("TextField");
        }
        get text() {
            return this.d0;
        }
        set text(a) {
            this.d0 = a;
            this.g("Text");
        }
        get valueField() {
            return this.k;
        }
        set valueField(a) {
            this.k = a;
            this.g("ValueField");
        }
        get actualValueField() {
            return this.h;
        }
        set actualValueField(a) {
            this.h = a;
            this.g("ActualValueField");
        }
        get value() {
            return this.cp;
        }
        set value(a) {
            this.cp = a;
            this.g("Value");
        }
        get isFixed() {
            return this.t;
        }
        set isFixed(a) {
            this.t = a;
            this.g("IsFixed");
        }
        get openAsChild() {
            return this.u;
        }
        set openAsChild(a) {
            this.u = a;
            this.g("OpenAsChild");
        }
        get useTopLayer() {
            return this.x;
        }
        set useTopLayer(a) {
            this.x = a;
            this.g("UseTopLayer");
        }
        get gotFocusRef() {
            return this.dh;
        }
        set gotFocusRef(a) {
            this.dh = a;
            this.g("GotFocusRef");
        }
        get lostFocusRef() {
            return this.dq;
        }
        set lostFocusRef(a) {
            this.dq = a;
            this.g("LostFocusRef");
        }
        get textValueChangedRef() {
            return this.d4;
        }
        set textValueChangedRef(a) {
            this.d4 = a;
            this.g("TextValueChangedRef");
        }
        get selectedValueChangedRef() {
            return this.dy;
        }
        set selectedValueChangedRef(a) {
            this.dy = a;
            this.g("SelectedValueChangedRef");
        }
        get keyDownRef() {
            return this.dj;
        }
        set keyDownRef(a) {
            this.dj = a;
            this.g("KeyDownRef");
        }
        get changeRef() {
            return this.c8;
        }
        set changeRef(a) {
            this.c8 = a;
            this.g("ChangeRef");
        }
        get changingRef() {
            return this.c9;
        }
        set changingRef(a) {
            this.c9 = a;
            this.g("ChangingRef");
        }
        get textChangeRef() {
            return this.d1;
        }
        set textChangeRef(a) {
            this.d1 = a;
            this.g("TextChangeRef");
        }
        get valueChangeRef() {
            return this.d7;
        }
        set valueChangeRef(a) {
            this.d7 = a;
            this.g("ValueChangeRef");
        }
        get defaultColumnWidth() {
            return this.a8;
        }
        set defaultColumnWidth(a) {
            this.a8 = a;
            this.g("DefaultColumnWidth");
        }
    }
    MultiColumnComboBoxDescription.$t = /*@__PURE__*/ markType(MultiColumnComboBoxDescription, 'MultiColumnComboBoxDescription', Description.$);
    return MultiColumnComboBoxDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MultiColumnComboBoxDescriptionMetadata = /*@__PURE__*/ (() => {
    class MultiColumnComboBoxDescriptionMetadata extends Base {
        static b(a) {
            if (MultiColumnComboBoxDescriptionMetadata.a == null) {
                MultiColumnComboBoxDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MultiColumnComboBoxDescriptionMetadata.c(MultiColumnComboBoxDescriptionMetadata.a);
            }
            if (a.k(MultiColumnComboBoxDescriptionMetadata.a)) {
                return;
            }
            a.ac(MultiColumnComboBoxDescriptionMetadata.a);
            GotFocusEventArgsDescriptionMetadata.d(a);
            LostFocusEventArgsDescriptionMetadata.d(a);
            MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.d(a);
            MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.d(a);
            KeyEventArgsDescriptionMetadata.d(a);
            InputChangeEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("ShowClearButton", "Boolean");
            a.item("Fields", "Array:string");
            a.item("BackgroundColor", "Brush");
            a.item("ActualBackgroundColor", "Brush");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("ActualBaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("ActualBaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("BorderColor", "Brush");
            a.item("ActualBorderColor", "Brush");
            a.item("BorderWidth", "Number:double");
            a.item("ActualBorderWidth", "Number:double");
            a.item("ColumnHeadersVisible", "Boolean");
            a.item("ContentPaddingBottom", "(w:ContentPadding.Bottom,wf:ContentPaddingBottom)Number:double");
            a.item("ContentPaddingLeft", "(w:ContentPadding.Left,wf:ContentPaddingLeft)Number:double");
            a.item("ContentPaddingRight", "(w:ContentPadding.Right,wf:ContentPaddingRight)Number:double");
            a.item("ContentPaddingTop", "(w:ContentPadding.Top,wf:ContentPaddingTop)Number:double");
            a.item("ActualContentPaddingBottom", "(w:ActualContentPadding.Bottom,wf:ActualContentPaddingBottom)Number:double");
            a.item("ActualContentPaddingLeft", "(w:ActualContentPadding.Left,wf:ActualContentPaddingLeft)Number:double");
            a.item("ActualContentPaddingRight", "(w:ActualContentPadding.Right,wf:ActualContentPaddingRight)Number:double");
            a.item("ActualContentPaddingTop", "(w:ActualContentPadding.Top,wf:ActualContentPaddingTop)Number:double");
            a.item("CornerRadiusBottomRight", "(w:CornerRadius.BottomRight,wf:CornerRadiusBottomRight)Number:double");
            a.item("CornerRadiusBottomLeft", "(w:CornerRadius.BottomLeft,wf:CornerRadiusBottomLeft)Number:double");
            a.item("CornerRadiusTopLeft", "(w:CornerRadius.TopLeft,wf:CornerRadiusTopLeft)Number:double");
            a.item("CornerRadiusTopRight", "(w:CornerRadius.TopRight,wf:CornerRadiusTopRight)Number:double");
            a.item("ActualCornerRadiusBottomRight", "(w:ActualCornerRadius.BottomRight,wf:ActualCornerRadiusBottomRight)Number:double");
            a.item("ActualCornerRadiusBottomLeft", "(w:ActualCornerRadius.BottomLeft,wf:ActualCornerRadiusBottomLeft)Number:double");
            a.item("ActualCornerRadiusTopLeft", "(w:ActualCornerRadius.TopLeft,wf:ActualCornerRadiusTopLeft)Number:double");
            a.item("ActualCornerRadiusTopRight", "(w:ActualCornerRadius.TopRight,wf:ActualCornerRadiusTopRight)Number:double");
            a.item("DataSourceDesiredProperties", "Array:string");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("ActualDensity", "ExportedType:string:ControlDisplayDensity");
            a.item("ActualDensity@names", "Auto;Comfortable;Cosy;Compact");
            a.item("DropDownButtonVisible", "Boolean");
            a.item("FocusBorderColor", "Brush");
            a.item("ActualFocusBorderColor", "Brush");
            a.item("FocusBorderWidth", "Number:double");
            a.item("ActualFocusBorderWidth", "Number:double");
            a.item("FocusUnderlineColor", "Brush");
            a.item("ActualFocusUnderlineColor", "Brush");
            a.item("FocusUnderlineOpacity", "Number:double");
            a.item("ActualFocusUnderlineOpacity", "Number:double");
            a.item("FocusUnderlineRippleOpacity", "Number:double");
            a.item("ActualFocusUnderlineRippleOpacity", "Number:double");
            a.item("HoverUnderlineColor", "Brush");
            a.item("ActualHoverUnderlineColor", "Brush");
            a.item("HoverUnderlineOpacity", "Number:double");
            a.item("ActualHoverUnderlineOpacity", "Number:double");
            a.item("HoverUnderlineWidth", "Number:double");
            a.item("ActualHoverUnderlineWidth", "Number:double");
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)DataRef::object");
            a.item("Label", "String");
            a.item("LabelTextColor", "Brush");
            a.item("ActualLabelTextColor", "Brush");
            a.item("LabelFontFamily", "(w:LabelFontFamily/FontFamilyTransform,xam:LabelFontFamily,wf:LabelFontFamily,web:labelTextStyle/FontFamilyTransform)String");
            a.item("LabelFontSize", "(w:LabelFontSize,xam:LabelFontSize,wf:LabelFontSize,web:labelTextStyle/FontSizeTransform)Number:double");
            a.item("LabelFontStyle", "(w:LabelFontStyle/FontStyleTransform,xam:LabelFontFamily/FontStyleTransform,wf:LabelFontFamily/FontStyleTransform,web:labelTextStyle/FontStyleTransform)String");
            a.item("LabelFontWeight", "(w:LabelFontWeight/FontWeightTransform,xam:LabelFontFamily/FontWeightTransform,wf:LabelFontFamily/FontWeightTransform,web:labelTextStyle/FontWeightTransform)String");
            a.item("ActualLabelVisible", "Boolean");
            a.item("NoMatchesFoundLabel", "String");
            a.item("ActualNoMatchesFoundLabel", "String");
            a.item("NoMatchesFoundLabelBackgroundColor", "Brush");
            a.item("ActualNoMatchesFoundLabelBackgroundColor", "Brush");
            a.item("NoMatchesFoundLabelTextColor", "Brush");
            a.item("ActualNoMatchesFoundLabelTextColor", "Brush");
            a.item("NoMatchesFoundLabelFontFamily", "(w:NoMatchesFoundLabelFontFamily/FontFamilyTransform,xam:NoMatchesFoundLabelFontFamily,wf:NoMatchesFoundLabelFontFamily,web:noMatchesFoundLabelTextStyle/FontFamilyTransform)String");
            a.item("NoMatchesFoundLabelFontSize", "(w:NoMatchesFoundLabelFontSize,xam:NoMatchesFoundLabelFontSize,wf:NoMatchesFoundLabelFontSize,web:noMatchesFoundLabelTextStyle/FontSizeTransform)Number:double");
            a.item("NoMatchesFoundLabelFontStyle", "(w:NoMatchesFoundLabelFontStyle/FontStyleTransform,xam:NoMatchesFoundLabelFontFamily/FontStyleTransform,wf:NoMatchesFoundLabelFontFamily/FontStyleTransform,web:noMatchesFoundLabelTextStyle/FontStyleTransform)String");
            a.item("NoMatchesFoundLabelFontWeight", "(w:NoMatchesFoundLabelFontWeight/FontWeightTransform,xam:NoMatchesFoundLabelFontFamily/FontWeightTransform,wf:NoMatchesFoundLabelFontFamily/FontWeightTransform,web:noMatchesFoundLabelTextStyle/FontWeightTransform)String");
            a.item("Placeholder", "String");
            a.item("RowSeparatorsVisible", "Boolean");
            a.item("TextColor", "Brush");
            a.item("ActualTextColor", "Brush");
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontFamily/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontFamily/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            a.item("UnderlineColor", "Brush");
            a.item("ActualUnderlineColor", "Brush");
            a.item("UnderlineOpacity", "Number:double");
            a.item("ActualUnderlineOpacity", "Number:double");
            a.item("UnderlineRippleColor", "Brush");
            a.item("ActualUnderlineRippleColor", "Brush");
            a.item("UnderlineRippleOpacity", "Number:double");
            a.item("ActualUnderlineRippleOpacity", "Number:double");
            a.item("UnderlineRippleWidth", "Number:double");
            a.item("ActualUnderlineRippleWidth", "Number:double");
            a.item("UnderlineWidth", "Number:double");
            a.item("ActualUnderlineWidth", "Number:double");
            a.item("AllowFilter", "Boolean");
            a.item("SortMode", "ExportedType:string:SortMode");
            a.item("SortMode@names", "SortByOneColumnOnly;SortByMultipleColumns;SortByOneColumnOnlyTriState;SortByMultipleColumnsTriState;None");
            a.item("TextField", "String");
            a.item("Text", "String");
            a.item("ValueField", "Array:string");
            a.item("ActualValueField", "Array:string");
            a.item("Value", "Unknown");
            a.item("IsFixed", "Boolean");
            a.item("OpenAsChild", "Boolean");
            a.item("UseTopLayer", "Boolean");
            a.item("GotFocusRef", "EventRef::gotFocus");
            a.item("LostFocusRef", "EventRef::lostFocus");
            a.item("TextValueChangedRef", "EventRef::textValueChanged");
            a.item("SelectedValueChangedRef", "EventRef::selectedValueChanged");
            a.item("KeyDownRef", "EventRef::keyDown");
            a.item("ChangeRef", "EventRef::change");
            a.item("ChangingRef", "EventRef::changing");
            a.item("TextChangeRef", "EventRef::textChange");
            a.item("ValueChangeRef", "EventRef::valueChange");
            MultiColumnComboBoxDescriptionMetadata.e(a);
        }
        static d(a) {
            MultiColumnComboBoxDescriptionMetadata.b(a);
            a.ae("MultiColumnComboBox", () => new MultiColumnComboBoxDescription());
            a.ad("MultiColumnComboBox", MultiColumnComboBoxDescriptionMetadata.a);
        }
        static e(a) {
            a.item("DefaultColumnWidth", "Number:double");
        }
    }
    MultiColumnComboBoxDescriptionMetadata.$t = /*@__PURE__*/ markType(MultiColumnComboBoxDescriptionMetadata, 'MultiColumnComboBoxDescriptionMetadata');
    MultiColumnComboBoxDescriptionMetadata.a = null;
    return MultiColumnComboBoxDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MultiColumnComboBoxDescriptionModule = /*@__PURE__*/ (() => {
    class MultiColumnComboBoxDescriptionModule extends Base {
        static register(a) {
            InputGroupDescriptionModule.register(a);
            DataGridCoreDescriptionModule.register(a);
            NumericColumnDescriptionModule.register(a);
            DateTimeColumnDescriptionModule.register(a);
            ImageColumnDescriptionModule.register(a);
            TextColumnDescriptionModule.register(a);
            MultiColumnComboBoxDescriptionMetadata.d(a);
        }
    }
    MultiColumnComboBoxDescriptionModule.$t = /*@__PURE__*/ markType(MultiColumnComboBoxDescriptionModule, 'MultiColumnComboBoxDescriptionModule');
    return MultiColumnComboBoxDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterOperandDescriptionModule = /*@__PURE__*/ (() => {
    class FilterOperandDescriptionModule extends Base {
        static register(a) {
            FilterOperandDescriptionMetadata.d(a);
        }
    }
    FilterOperandDescriptionModule.$t = /*@__PURE__*/ markType(FilterOperandDescriptionModule, 'FilterOperandDescriptionModule');
    return FilterOperandDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PageChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class PageChangedEventArgsDescription extends Description {
        get_type() {
            return "PageChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = 0;
            this.j = null;
        }
        get page() {
            return this.h;
        }
        set page(a) {
            this.h = a;
            this.g("Page");
        }
        get dataRef() {
            return this.j;
        }
        set dataRef(a) {
            this.j = a;
            this.g("DataRef");
        }
    }
    PageChangedEventArgsDescription.$t = /*@__PURE__*/ markType(PageChangedEventArgsDescription, 'PageChangedEventArgsDescription', Description.$);
    return PageChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PageChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class PageChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (PageChangedEventArgsDescriptionMetadata.a == null) {
                PageChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PageChangedEventArgsDescriptionMetadata.c(PageChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(PageChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(PageChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Page", "Number:int");
            a.item("DataRef", "(w:Data,wf:Data)DataRef:object");
        }
        static d(a) {
            PageChangedEventArgsDescriptionMetadata.b(a);
            a.ae("PageChangedEventArgs", () => new PageChangedEventArgsDescription());
            a.ad("PageChangedEventArgs", PageChangedEventArgsDescriptionMetadata.a);
        }
    }
    PageChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(PageChangedEventArgsDescriptionMetadata, 'PageChangedEventArgsDescriptionMetadata');
    PageChangedEventArgsDescriptionMetadata.a = null;
    return PageChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridPagerDescription = /*@__PURE__*/ (() => {
    class DataGridPagerDescription extends Description {
        get_type() {
            return "DataGridPager";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.y = null;
            this.n = 0;
            this.m = 0;
            this.t = null;
            this.h = null;
            this.l = 0;
            this.u = null;
            this.j = 0;
            this.v = null;
            this.w = null;
            this.r = null;
            this.s = null;
            this.x = null;
        }
        get pagerText() {
            return this.y;
        }
        set pagerText(a) {
            this.y = a;
            this.g("PagerText");
        }
        get pageSize() {
            return this.n;
        }
        set pageSize(a) {
            this.n = a;
            this.g("PageSize");
        }
        get pageCount() {
            return this.m;
        }
        set pageCount(a) {
            this.m = a;
            this.g("PageCount");
        }
        get dataSourceRef() {
            return this.t;
        }
        set dataSourceRef(a) {
            this.t = a;
            this.g("DataSourceRef");
        }
        get dataSource() {
            return this.h;
        }
        set dataSource(a) {
            this.h = a;
            this.g("DataSource");
        }
        get currentPage() {
            return this.l;
        }
        set currentPage(a) {
            this.l = a;
            this.g("CurrentPage");
        }
        get fontFamily() {
            return this.u;
        }
        set fontFamily(a) {
            this.u = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.j;
        }
        set fontSize(a) {
            this.j = a;
            this.g("FontSize");
        }
        get fontStyle() {
            return this.v;
        }
        set fontStyle(a) {
            this.v = a;
            this.g("FontStyle");
        }
        get fontWeight() {
            return this.w;
        }
        set fontWeight(a) {
            this.w = a;
            this.g("FontWeight");
        }
        get background() {
            return this.r;
        }
        set background(a) {
            this.r = a;
            this.g("Background");
        }
        get border() {
            return this.s;
        }
        set border(a) {
            this.s = a;
            this.g("Border");
        }
        get pageChangedRef() {
            return this.x;
        }
        set pageChangedRef(a) {
            this.x = a;
            this.g("PageChangedRef");
        }
    }
    DataGridPagerDescription.$t = /*@__PURE__*/ markType(DataGridPagerDescription, 'DataGridPagerDescription', Description.$);
    return DataGridPagerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridPagerDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridPagerDescriptionMetadata extends Base {
        static b(a) {
            if (DataGridPagerDescriptionMetadata.a == null) {
                DataGridPagerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridPagerDescriptionMetadata.c(DataGridPagerDescriptionMetadata.a);
            }
            if (a.k(DataGridPagerDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataGridPagerDescriptionMetadata.a);
            PageChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("PagerText", "String");
            a.item("PageSize", "Number:int");
            a.item("PageCount", "Number:int");
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)DataRef::object");
            a.item("DataSource", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            a.item("CurrentPage", "Number:int");
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontFamily/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontFamily/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            a.item("Background", "Brush");
            a.item("Border", "Brush");
            a.item("PageChangedRef", "EventRef::pageChanged");
        }
        static d(a) {
            DataGridPagerDescriptionMetadata.b(a);
            a.ae("DataGridPager", () => new DataGridPagerDescription());
            a.ad("DataGridPager", DataGridPagerDescriptionMetadata.a);
        }
    }
    DataGridPagerDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridPagerDescriptionMetadata, 'DataGridPagerDescriptionMetadata');
    DataGridPagerDescriptionMetadata.a = null;
    return DataGridPagerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridPagerDescriptionModule = /*@__PURE__*/ (() => {
    class DataGridPagerDescriptionModule extends Base {
        static register(a) {
            ButtonDescriptionModule.register(a);
            DataGridPagerDescriptionMetadata.d(a);
        }
    }
    DataGridPagerDescriptionModule.$t = /*@__PURE__*/ markType(DataGridPagerDescriptionModule, 'DataGridPagerDescriptionModule');
    return DataGridPagerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridToolbarDescription = /*@__PURE__*/ (() => {
    class DataGridToolbarDescription extends Description {
        get_type() {
            return "DataGridToolbar";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.ad = null;
            this.ae = null;
            this.ag = null;
            this.p = 0;
            this.ah = null;
            this.ai = null;
            this.af = null;
            this.v = null;
            this.ac = null;
            this.h = false;
            this.x = null;
            this.y = null;
            this.i = false;
            this.z = null;
            this.aa = null;
            this.l = 0;
            this.m = 0;
            this.n = 0;
            this.o = 0;
            this.ab = null;
            this.w = null;
        }
        get targetGridRef() {
            return this.ad;
        }
        set targetGridRef(a) {
            this.ad = a;
            this.g("TargetGridRef");
        }
        get toolbarTitle() {
            return this.ae;
        }
        set toolbarTitle(a) {
            this.ae = a;
            this.g("ToolbarTitle");
        }
        get toolbarTitleFontFamily() {
            return this.ag;
        }
        set toolbarTitleFontFamily(a) {
            this.ag = a;
            this.g("ToolbarTitleFontFamily");
        }
        get toolbarTitleFontSize() {
            return this.p;
        }
        set toolbarTitleFontSize(a) {
            this.p = a;
            this.g("ToolbarTitleFontSize");
        }
        get toolbarTitleFontStyle() {
            return this.ah;
        }
        set toolbarTitleFontStyle(a) {
            this.ah = a;
            this.g("ToolbarTitleFontStyle");
        }
        get toolbarTitleFontWeight() {
            return this.ai;
        }
        set toolbarTitleFontWeight(a) {
            this.ai = a;
            this.g("ToolbarTitleFontWeight");
        }
        get toolbarTitleColor() {
            return this.af;
        }
        set toolbarTitleColor(a) {
            this.af = a;
            this.g("ToolbarTitleColor");
        }
        get backgroundColor() {
            return this.v;
        }
        set backgroundColor(a) {
            this.v = a;
            this.g("BackgroundColor");
        }
        get dialogBackgroundColor() {
            return this.ac;
        }
        set dialogBackgroundColor(a) {
            this.ac = a;
            this.g("DialogBackgroundColor");
        }
        get columnChooser() {
            return this.h;
        }
        set columnChooser(a) {
            this.h = a;
            this.g("ColumnChooser");
        }
        get columnChooserText() {
            return this.x;
        }
        set columnChooserText(a) {
            this.x = a;
            this.g("ColumnChooserText");
        }
        get columnChooserTitle() {
            return this.y;
        }
        set columnChooserTitle(a) {
            this.y = a;
            this.g("ColumnChooserTitle");
        }
        get columnPinning() {
            return this.i;
        }
        set columnPinning(a) {
            this.i = a;
            this.g("ColumnPinning");
        }
        get columnPinningText() {
            return this.z;
        }
        set columnPinningText(a) {
            this.z = a;
            this.g("ColumnPinningText");
        }
        get columnPinningTitle() {
            return this.aa;
        }
        set columnPinningTitle(a) {
            this.aa = a;
            this.g("ColumnPinningTitle");
        }
        get borderWidthBottom() {
            return this.l;
        }
        set borderWidthBottom(a) {
            this.l = a;
            this.g("BorderWidthBottom");
        }
        get borderWidthLeft() {
            return this.m;
        }
        set borderWidthLeft(a) {
            this.m = a;
            this.g("BorderWidthLeft");
        }
        get borderWidthRight() {
            return this.n;
        }
        set borderWidthRight(a) {
            this.n = a;
            this.g("BorderWidthRight");
        }
        get borderWidthTop() {
            return this.o;
        }
        set borderWidthTop(a) {
            this.o = a;
            this.g("BorderWidthTop");
        }
        get density() {
            return this.ab;
        }
        set density(a) {
            this.ab = a;
            this.g("Density");
        }
        get baseTheme() {
            return this.w;
        }
        set baseTheme(a) {
            this.w = a;
            this.g("BaseTheme");
        }
    }
    DataGridToolbarDescription.$t = /*@__PURE__*/ markType(DataGridToolbarDescription, 'DataGridToolbarDescription', Description.$);
    return DataGridToolbarDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridToolbarDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridToolbarDescriptionMetadata extends Base {
        static b(a) {
            if (DataGridToolbarDescriptionMetadata.a == null) {
                DataGridToolbarDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridToolbarDescriptionMetadata.c(DataGridToolbarDescriptionMetadata.a);
            }
            if (a.k(DataGridToolbarDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataGridToolbarDescriptionMetadata.a);
        }
        static c(a) {
            a.item("TargetGridRef", "(w:TargetGrid,wf:TargetGrid)DataRef::object");
            a.item("ToolbarTitle", "String");
            a.item("ToolbarTitleFontFamily", "(w:ToolbarTitleFontFamily/FontFamilyTransform,xam:ToolbarTitleFontFamily,wf:ToolbarTitleFontFamily,web:toolbarTitleStyle/FontFamilyTransform)String");
            a.item("ToolbarTitleFontSize", "(w:ToolbarTitleFontSize,xam:ToolbarTitleFontSize,wf:ToolbarTitleFontSize,web:toolbarTitleStyle/FontSizeTransform)Number:double");
            a.item("ToolbarTitleFontStyle", "(w:ToolbarTitleFontStyle/FontStyleTransform,xam:ToolbarTitleFontFamily/FontStyleTransform,wf:ToolbarTitleFontFamily/FontStyleTransform,web:toolbarTitleStyle/FontStyleTransform)String");
            a.item("ToolbarTitleFontWeight", "(w:ToolbarTitleFontWeight/FontWeightTransform,xam:ToolbarTitleFontFamily/FontWeightTransform,wf:ToolbarTitleFontFamily/FontWeightTransform,web:toolbarTitleStyle/FontWeightTransform)String");
            a.item("ToolbarTitleColor", "Brush");
            a.item("BackgroundColor", "Brush");
            a.item("DialogBackgroundColor", "Brush");
            a.item("ColumnChooser", "Boolean");
            a.item("ColumnChooserText", "String");
            a.item("ColumnChooserTitle", "String");
            a.item("ColumnPinning", "Boolean");
            a.item("ColumnPinningText", "String");
            a.item("ColumnPinningTitle", "String");
            a.item("BorderWidthBottom", "(w:BorderWidth.Bottom,wf:BorderWidthBottom)Number:double");
            a.item("BorderWidthLeft", "(w:BorderWidth.Left,wf:BorderWidthLeft)Number:double");
            a.item("BorderWidthRight", "(w:BorderWidth.Right,wf:BorderWidthRight)Number:double");
            a.item("BorderWidthTop", "(w:BorderWidth.Top,wf:BorderWidthTop)Number:double");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
        }
        static d(a) {
            DataGridToolbarDescriptionMetadata.b(a);
            a.ae("DataGridToolbar", () => new DataGridToolbarDescription());
            a.ad("DataGridToolbar", DataGridToolbarDescriptionMetadata.a);
        }
    }
    DataGridToolbarDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridToolbarDescriptionMetadata, 'DataGridToolbarDescriptionMetadata');
    DataGridToolbarDescriptionMetadata.a = null;
    return DataGridToolbarDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridToolbarDescriptionModule = /*@__PURE__*/ (() => {
    class DataGridToolbarDescriptionModule extends Base {
        static register(a) {
            ColumnChooserDescriptionModule.register(a);
            ColumnPinningDescriptionModule.register(a);
            ButtonDescriptionModule.register(a);
            IconDescriptionModule.register(a);
            DataGridToolbarDescriptionMetadata.d(a);
        }
    }
    DataGridToolbarDescriptionModule.$t = /*@__PURE__*/ markType(DataGridToolbarDescriptionModule, 'DataGridToolbarDescriptionModule');
    return DataGridToolbarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridDescriptionModule = /*@__PURE__*/ (() => {
    class DataGridDescriptionModule extends Base {
        static register(a) {
            DataGridAllColumnsDescriptionModule.register(a);
            GridColumnOptionsDescriptionModule.register(a);
            ComboBoxColumnDescriptionModule.register(a);
            InputGroupDescriptionModule.register(a);
            MultiColumnComboBoxDescriptionModule.register(a);
            FilterOperandDescriptionModule.register(a);
            ColumnGroupingDescriptionModule.register(a);
            DataGridPagerDescriptionModule.register(a);
            DataGridToolbarDescriptionModule.register(a);
        }
    }
    DataGridDescriptionModule.$t = /*@__PURE__*/ markType(DataGridDescriptionModule, 'DataGridDescriptionModule');
    return DataGridDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridSummaryResultDescription = /*@__PURE__*/ (() => {
    class DataGridSummaryResultDescription extends Description {
        get_type() {
            return "DataGridSummaryResult";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.k = null;
            this.i = 0;
        }
        get groupKeyRef() {
            return this.n;
        }
        set groupKeyRef(a) {
            this.n = a;
            this.g("GroupKeyRef");
        }
        get value() {
            return this.k;
        }
        set value(a) {
            this.k = a;
            this.g("Value");
        }
        get summaryIndex() {
            return this.i;
        }
        set summaryIndex(a) {
            this.i = a;
            this.g("SummaryIndex");
        }
    }
    DataGridSummaryResultDescription.$t = /*@__PURE__*/ markType(DataGridSummaryResultDescription, 'DataGridSummaryResultDescription', Description.$);
    DataGridSummaryResultDescription.__marshalByValue = true;
    DataGridSummaryResultDescription.__marshalByValueAlias = "DefaultSummaryResult";
    return DataGridSummaryResultDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridSummaryResultDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridSummaryResultDescriptionMetadata extends Base {
        static b(a) {
            if (DataGridSummaryResultDescriptionMetadata.a == null) {
                DataGridSummaryResultDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridSummaryResultDescriptionMetadata.c(DataGridSummaryResultDescriptionMetadata.a);
            }
            if (a.k(DataGridSummaryResultDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataGridSummaryResultDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("GroupKeyRef", "(w:GroupKey,wf:GroupKey)DataRef:object");
            a.item("Value", "Unknown");
            a.item("SummaryIndex", "Number:int");
        }
        static d(a) {
            DataGridSummaryResultDescriptionMetadata.b(a);
            a.ae("DataGridSummaryResult", () => new DataGridSummaryResultDescription());
            a.ad("DataGridSummaryResult", DataGridSummaryResultDescriptionMetadata.a);
        }
    }
    DataGridSummaryResultDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridSummaryResultDescriptionMetadata, 'DataGridSummaryResultDescriptionMetadata');
    DataGridSummaryResultDescriptionMetadata.a = null;
    return DataGridSummaryResultDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendDescription = /*@__PURE__*/ (() => {
    class DataLegendDescription extends Description {
        get_type() {
            return "DataLegend";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.t = false;
            this.ah = 0;
            this.l = null;
            this.i = null;
            this.k = null;
            this.h = null;
            this.w = false;
            this.fo = null;
            this.dy = 0;
            this.dz = 0;
            this.fr = null;
            this.fp = null;
            this.fq = null;
            this.x = false;
            this.fs = null;
            this.m = null;
            this.by = 0;
            this.bz = 0;
            this.b0 = 0;
            this.b1 = 0;
            this.y = false;
            this.fx = null;
            this.z = false;
            this.b3 = 0;
            this.b4 = 0;
            this.b5 = 0;
            this.b6 = 0;
            this.ft = null;
            this.fu = null;
            this.b2 = 0;
            this.fv = null;
            this.fw = null;
            this.ea = null;
            this.j = null;
            this.d8 = null;
            this.d9 = null;
            this.eb = null;
            this.ec = null;
            this.ed = null;
            this.a0 = 0;
            this.a1 = 0;
            this.a2 = 0;
            this.a3 = 0;
            this.av = 0;
            this.aw = 0;
            this.ax = 0;
            this.ay = 0;
            this.v = false;
            this.ee = null;
            this.az = 0;
            this.ef = null;
            this.eg = null;
            this.u = false;
            this.d4 = null;
            this.ar = 0;
            this.as = 0;
            this.at = 0;
            this.au = 0;
            this.am = 0;
            this.an = 0;
            this.ao = 0;
            this.ap = 0;
            this.d5 = null;
            this.aq = 0;
            this.d6 = null;
            this.d7 = null;
            this.ez = null;
            this.e0 = null;
            this.bf = 0;
            this.e1 = null;
            this.e2 = null;
            this.e3 = null;
            this.ey = null;
            this.bg = 0;
            this.bh = 0;
            this.bi = 0;
            this.bj = 0;
            this.bb = 0;
            this.bc = 0;
            this.bd = 0;
            this.be = 0;
            this.e9 = null;
            this.fa = null;
            this.bl = 0;
            this.fb = null;
            this.fc = null;
            this.et = null;
            this.eu = null;
            this.ev = null;
            this.ba = 0;
            this.ew = null;
            this.ex = null;
            this.e4 = null;
            this.e5 = null;
            this.e6 = null;
            this.bk = 0;
            this.e7 = null;
            this.e8 = null;
            this.ai = 0;
            this.aj = 0;
            this.ak = 0;
            this.al = 0;
            this.d2 = null;
            this.bm = 0;
            this.bn = 0;
            this.fd = null;
            this.fi = null;
            this.fj = null;
            this.fk = null;
            this.bu = 0;
            this.bv = 0;
            this.bw = 0;
            this.bx = 0;
            this.fl = null;
            this.bt = 0;
            this.fm = null;
            this.fn = null;
            this.bp = 0;
            this.bq = 0;
            this.br = 0;
            this.bs = 0;
            this.fe = null;
            this.ff = null;
            this.bo = 0;
            this.fg = null;
            this.fh = null;
            this.ei = null;
            this.ej = null;
            this.a5 = 0;
            this.a6 = 0;
            this.a7 = 0;
            this.a8 = 0;
            this.ek = null;
            this.a4 = 0;
            this.el = null;
            this.em = null;
            this.a9 = 0;
            this.d3 = null;
            this.eo = null;
            this.en = null;
            this.eq = null;
            this.es = null;
            this.ep = null;
            this.er = null;
            this.fy = null;
            this.eh = null;
        }
        get actualBadgesVisible() {
            return this.t;
        }
        set actualBadgesVisible(a) {
            this.t = a;
            this.g("ActualBadgesVisible");
        }
        get actualPixelScalingRatio() {
            return this.ah;
        }
        set actualPixelScalingRatio(a) {
            this.ah = a;
            this.g("ActualPixelScalingRatio");
        }
        get includedSeries() {
            return this.l;
        }
        set includedSeries(a) {
            this.l = a;
            this.g("IncludedSeries");
        }
        get excludedSeries() {
            return this.i;
        }
        set excludedSeries(a) {
            this.i = a;
            this.g("ExcludedSeries");
        }
        get includedColumns() {
            return this.k;
        }
        set includedColumns(a) {
            this.k = a;
            this.g("IncludedColumns");
        }
        get excludedColumns() {
            return this.h;
        }
        set excludedColumns(a) {
            this.h = a;
            this.g("ExcludedColumns");
        }
        get shouldUpdateWhenSeriesDataChanges() {
            return this.w;
        }
        set shouldUpdateWhenSeriesDataChanges(a) {
            this.w = a;
            this.g("ShouldUpdateWhenSeriesDataChanges");
        }
        get valueFormatAbbreviation() {
            return this.fo;
        }
        set valueFormatAbbreviation(a) {
            this.fo = a;
            this.g("ValueFormatAbbreviation");
        }
        get valueFormatMaxFractions() {
            return this.dy;
        }
        set valueFormatMaxFractions(a) {
            this.dy = a;
            this.g("ValueFormatMaxFractions");
        }
        get valueFormatMinFractions() {
            return this.dz;
        }
        set valueFormatMinFractions(a) {
            this.dz = a;
            this.g("ValueFormatMinFractions");
        }
        get valueFormatMode() {
            return this.fr;
        }
        set valueFormatMode(a) {
            this.fr = a;
            this.g("ValueFormatMode");
        }
        get valueFormatCulture() {
            return this.fp;
        }
        set valueFormatCulture(a) {
            this.fp = a;
            this.g("ValueFormatCulture");
        }
        get valueFormatCurrencyCode() {
            return this.fq;
        }
        set valueFormatCurrencyCode(a) {
            this.fq = a;
            this.g("ValueFormatCurrencyCode");
        }
        get valueFormatUseGrouping() {
            return this.x;
        }
        set valueFormatUseGrouping(a) {
            this.x = a;
            this.g("ValueFormatUseGrouping");
        }
        get valueFormatString() {
            return this.fs;
        }
        set valueFormatString(a) {
            this.fs = a;
            this.g("ValueFormatString");
        }
        get valueFormatSpecifiers() {
            return this.m;
        }
        set valueFormatSpecifiers(a) {
            this.m = a;
            this.g("ValueFormatSpecifiers");
        }
        get valueRowMarginBottom() {
            return this.by;
        }
        set valueRowMarginBottom(a) {
            this.by = a;
            this.g("ValueRowMarginBottom");
        }
        get valueRowMarginLeft() {
            return this.bz;
        }
        set valueRowMarginLeft(a) {
            this.bz = a;
            this.g("ValueRowMarginLeft");
        }
        get valueRowMarginRight() {
            return this.b0;
        }
        set valueRowMarginRight(a) {
            this.b0 = a;
            this.g("ValueRowMarginRight");
        }
        get valueRowMarginTop() {
            return this.b1;
        }
        set valueRowMarginTop(a) {
            this.b1 = a;
            this.g("ValueRowMarginTop");
        }
        get valueRowVisible() {
            return this.y;
        }
        set valueRowVisible(a) {
            this.y = a;
            this.g("ValueRowVisible");
        }
        get valueTextWhenMissingData() {
            return this.fx;
        }
        set valueTextWhenMissingData(a) {
            this.fx = a;
            this.g("ValueTextWhenMissingData");
        }
        get valueTextUseSeriesColors() {
            return this.z;
        }
        set valueTextUseSeriesColors(a) {
            this.z = a;
            this.g("ValueTextUseSeriesColors");
        }
        get valueTextMarginBottom() {
            return this.b3;
        }
        set valueTextMarginBottom(a) {
            this.b3 = a;
            this.g("ValueTextMarginBottom");
        }
        get valueTextMarginLeft() {
            return this.b4;
        }
        set valueTextMarginLeft(a) {
            this.b4 = a;
            this.g("ValueTextMarginLeft");
        }
        get valueTextMarginRight() {
            return this.b5;
        }
        set valueTextMarginRight(a) {
            this.b5 = a;
            this.g("ValueTextMarginRight");
        }
        get valueTextMarginTop() {
            return this.b6;
        }
        set valueTextMarginTop(a) {
            this.b6 = a;
            this.g("ValueTextMarginTop");
        }
        get valueTextColor() {
            return this.ft;
        }
        set valueTextColor(a) {
            this.ft = a;
            this.g("ValueTextColor");
        }
        get valueTextFontFamily() {
            return this.fu;
        }
        set valueTextFontFamily(a) {
            this.fu = a;
            this.g("ValueTextFontFamily");
        }
        get valueTextFontSize() {
            return this.b2;
        }
        set valueTextFontSize(a) {
            this.b2 = a;
            this.g("ValueTextFontSize");
        }
        get valueTextFontStyle() {
            return this.fv;
        }
        set valueTextFontStyle(a) {
            this.fv = a;
            this.g("ValueTextFontStyle");
        }
        get valueTextFontWeight() {
            return this.fw;
        }
        set valueTextFontWeight(a) {
            this.fw = a;
            this.g("ValueTextFontWeight");
        }
        get headerFormatString() {
            return this.ea;
        }
        set headerFormatString(a) {
            this.ea = a;
            this.g("HeaderFormatString");
        }
        get headerFormatSpecifiers() {
            return this.j;
        }
        set headerFormatSpecifiers(a) {
            this.j = a;
            this.g("HeaderFormatSpecifiers");
        }
        get headerFormatCulture() {
            return this.d8;
        }
        set headerFormatCulture(a) {
            this.d8 = a;
            this.g("HeaderFormatCulture");
        }
        get headerFormatDate() {
            return this.d9;
        }
        set headerFormatDate(a) {
            this.d9 = a;
            this.g("HeaderFormatDate");
        }
        get headerFormatTime() {
            return this.eb;
        }
        set headerFormatTime(a) {
            this.eb = a;
            this.g("HeaderFormatTime");
        }
        get headerText() {
            return this.ec;
        }
        set headerText(a) {
            this.ec = a;
            this.g("HeaderText");
        }
        get headerTextColor() {
            return this.ed;
        }
        set headerTextColor(a) {
            this.ed = a;
            this.g("HeaderTextColor");
        }
        get headerTextMarginBottom() {
            return this.a0;
        }
        set headerTextMarginBottom(a) {
            this.a0 = a;
            this.g("HeaderTextMarginBottom");
        }
        get headerTextMarginLeft() {
            return this.a1;
        }
        set headerTextMarginLeft(a) {
            this.a1 = a;
            this.g("HeaderTextMarginLeft");
        }
        get headerTextMarginRight() {
            return this.a2;
        }
        set headerTextMarginRight(a) {
            this.a2 = a;
            this.g("HeaderTextMarginRight");
        }
        get headerTextMarginTop() {
            return this.a3;
        }
        set headerTextMarginTop(a) {
            this.a3 = a;
            this.g("HeaderTextMarginTop");
        }
        get headerRowMarginBottom() {
            return this.av;
        }
        set headerRowMarginBottom(a) {
            this.av = a;
            this.g("HeaderRowMarginBottom");
        }
        get headerRowMarginLeft() {
            return this.aw;
        }
        set headerRowMarginLeft(a) {
            this.aw = a;
            this.g("HeaderRowMarginLeft");
        }
        get headerRowMarginRight() {
            return this.ax;
        }
        set headerRowMarginRight(a) {
            this.ax = a;
            this.g("HeaderRowMarginRight");
        }
        get headerRowMarginTop() {
            return this.ay;
        }
        set headerRowMarginTop(a) {
            this.ay = a;
            this.g("HeaderRowMarginTop");
        }
        get headerRowVisible() {
            return this.v;
        }
        set headerRowVisible(a) {
            this.v = a;
            this.g("HeaderRowVisible");
        }
        get headerTextFontFamily() {
            return this.ee;
        }
        set headerTextFontFamily(a) {
            this.ee = a;
            this.g("HeaderTextFontFamily");
        }
        get headerTextFontSize() {
            return this.az;
        }
        set headerTextFontSize(a) {
            this.az = a;
            this.g("HeaderTextFontSize");
        }
        get headerTextFontStyle() {
            return this.ef;
        }
        set headerTextFontStyle(a) {
            this.ef = a;
            this.g("HeaderTextFontStyle");
        }
        get headerTextFontWeight() {
            return this.eg;
        }
        set headerTextFontWeight(a) {
            this.eg = a;
            this.g("HeaderTextFontWeight");
        }
        get groupRowVisible() {
            return this.u;
        }
        set groupRowVisible(a) {
            this.u = a;
            this.g("GroupRowVisible");
        }
        get groupTextColor() {
            return this.d4;
        }
        set groupTextColor(a) {
            this.d4 = a;
            this.g("GroupTextColor");
        }
        get groupTextMarginBottom() {
            return this.ar;
        }
        set groupTextMarginBottom(a) {
            this.ar = a;
            this.g("GroupTextMarginBottom");
        }
        get groupTextMarginLeft() {
            return this.as;
        }
        set groupTextMarginLeft(a) {
            this.as = a;
            this.g("GroupTextMarginLeft");
        }
        get groupTextMarginRight() {
            return this.at;
        }
        set groupTextMarginRight(a) {
            this.at = a;
            this.g("GroupTextMarginRight");
        }
        get groupTextMarginTop() {
            return this.au;
        }
        set groupTextMarginTop(a) {
            this.au = a;
            this.g("GroupTextMarginTop");
        }
        get groupRowMarginBottom() {
            return this.am;
        }
        set groupRowMarginBottom(a) {
            this.am = a;
            this.g("GroupRowMarginBottom");
        }
        get groupRowMarginLeft() {
            return this.an;
        }
        set groupRowMarginLeft(a) {
            this.an = a;
            this.g("GroupRowMarginLeft");
        }
        get groupRowMarginRight() {
            return this.ao;
        }
        set groupRowMarginRight(a) {
            this.ao = a;
            this.g("GroupRowMarginRight");
        }
        get groupRowMarginTop() {
            return this.ap;
        }
        set groupRowMarginTop(a) {
            this.ap = a;
            this.g("GroupRowMarginTop");
        }
        get groupTextFontFamily() {
            return this.d5;
        }
        set groupTextFontFamily(a) {
            this.d5 = a;
            this.g("GroupTextFontFamily");
        }
        get groupTextFontSize() {
            return this.aq;
        }
        set groupTextFontSize(a) {
            this.aq = a;
            this.g("GroupTextFontSize");
        }
        get groupTextFontStyle() {
            return this.d6;
        }
        set groupTextFontStyle(a) {
            this.d6 = a;
            this.g("GroupTextFontStyle");
        }
        get groupTextFontWeight() {
            return this.d7;
        }
        set groupTextFontWeight(a) {
            this.d7 = a;
            this.g("GroupTextFontWeight");
        }
        get summaryTitleTextColor() {
            return this.ez;
        }
        set summaryTitleTextColor(a) {
            this.ez = a;
            this.g("SummaryTitleTextColor");
        }
        get summaryTitleTextFontFamily() {
            return this.e0;
        }
        set summaryTitleTextFontFamily(a) {
            this.e0 = a;
            this.g("SummaryTitleTextFontFamily");
        }
        get summaryTitleTextFontSize() {
            return this.bf;
        }
        set summaryTitleTextFontSize(a) {
            this.bf = a;
            this.g("SummaryTitleTextFontSize");
        }
        get summaryTitleTextFontStyle() {
            return this.e1;
        }
        set summaryTitleTextFontStyle(a) {
            this.e1 = a;
            this.g("SummaryTitleTextFontStyle");
        }
        get summaryTitleTextFontWeight() {
            return this.e2;
        }
        set summaryTitleTextFontWeight(a) {
            this.e2 = a;
            this.g("SummaryTitleTextFontWeight");
        }
        get summaryType() {
            return this.e3;
        }
        set summaryType(a) {
            this.e3 = a;
            this.g("SummaryType");
        }
        get summaryTitleText() {
            return this.ey;
        }
        set summaryTitleText(a) {
            this.ey = a;
            this.g("SummaryTitleText");
        }
        get summaryTitleTextMarginBottom() {
            return this.bg;
        }
        set summaryTitleTextMarginBottom(a) {
            this.bg = a;
            this.g("SummaryTitleTextMarginBottom");
        }
        get summaryTitleTextMarginLeft() {
            return this.bh;
        }
        set summaryTitleTextMarginLeft(a) {
            this.bh = a;
            this.g("SummaryTitleTextMarginLeft");
        }
        get summaryTitleTextMarginRight() {
            return this.bi;
        }
        set summaryTitleTextMarginRight(a) {
            this.bi = a;
            this.g("SummaryTitleTextMarginRight");
        }
        get summaryTitleTextMarginTop() {
            return this.bj;
        }
        set summaryTitleTextMarginTop(a) {
            this.bj = a;
            this.g("SummaryTitleTextMarginTop");
        }
        get summaryRowMarginBottom() {
            return this.bb;
        }
        set summaryRowMarginBottom(a) {
            this.bb = a;
            this.g("SummaryRowMarginBottom");
        }
        get summaryRowMarginLeft() {
            return this.bc;
        }
        set summaryRowMarginLeft(a) {
            this.bc = a;
            this.g("SummaryRowMarginLeft");
        }
        get summaryRowMarginRight() {
            return this.bd;
        }
        set summaryRowMarginRight(a) {
            this.bd = a;
            this.g("SummaryRowMarginRight");
        }
        get summaryRowMarginTop() {
            return this.be;
        }
        set summaryRowMarginTop(a) {
            this.be = a;
            this.g("SummaryRowMarginTop");
        }
        get summaryValueTextColor() {
            return this.e9;
        }
        set summaryValueTextColor(a) {
            this.e9 = a;
            this.g("SummaryValueTextColor");
        }
        get summaryValueTextFontFamily() {
            return this.fa;
        }
        set summaryValueTextFontFamily(a) {
            this.fa = a;
            this.g("SummaryValueTextFontFamily");
        }
        get summaryValueTextFontSize() {
            return this.bl;
        }
        set summaryValueTextFontSize(a) {
            this.bl = a;
            this.g("SummaryValueTextFontSize");
        }
        get summaryValueTextFontStyle() {
            return this.fb;
        }
        set summaryValueTextFontStyle(a) {
            this.fb = a;
            this.g("SummaryValueTextFontStyle");
        }
        get summaryValueTextFontWeight() {
            return this.fc;
        }
        set summaryValueTextFontWeight(a) {
            this.fc = a;
            this.g("SummaryValueTextFontWeight");
        }
        get summaryLabelText() {
            return this.et;
        }
        set summaryLabelText(a) {
            this.et = a;
            this.g("SummaryLabelText");
        }
        get summaryLabelTextColor() {
            return this.eu;
        }
        set summaryLabelTextColor(a) {
            this.eu = a;
            this.g("SummaryLabelTextColor");
        }
        get summaryLabelTextFontFamily() {
            return this.ev;
        }
        set summaryLabelTextFontFamily(a) {
            this.ev = a;
            this.g("SummaryLabelTextFontFamily");
        }
        get summaryLabelTextFontSize() {
            return this.ba;
        }
        set summaryLabelTextFontSize(a) {
            this.ba = a;
            this.g("SummaryLabelTextFontSize");
        }
        get summaryLabelTextFontStyle() {
            return this.ew;
        }
        set summaryLabelTextFontStyle(a) {
            this.ew = a;
            this.g("SummaryLabelTextFontStyle");
        }
        get summaryLabelTextFontWeight() {
            return this.ex;
        }
        set summaryLabelTextFontWeight(a) {
            this.ex = a;
            this.g("SummaryLabelTextFontWeight");
        }
        get summaryUnitsText() {
            return this.e4;
        }
        set summaryUnitsText(a) {
            this.e4 = a;
            this.g("SummaryUnitsText");
        }
        get summaryUnitsTextColor() {
            return this.e5;
        }
        set summaryUnitsTextColor(a) {
            this.e5 = a;
            this.g("SummaryUnitsTextColor");
        }
        get summaryUnitsTextFontFamily() {
            return this.e6;
        }
        set summaryUnitsTextFontFamily(a) {
            this.e6 = a;
            this.g("SummaryUnitsTextFontFamily");
        }
        get summaryUnitsTextFontSize() {
            return this.bk;
        }
        set summaryUnitsTextFontSize(a) {
            this.bk = a;
            this.g("SummaryUnitsTextFontSize");
        }
        get summaryUnitsTextFontStyle() {
            return this.e7;
        }
        set summaryUnitsTextFontStyle(a) {
            this.e7 = a;
            this.g("SummaryUnitsTextFontStyle");
        }
        get summaryUnitsTextFontWeight() {
            return this.e8;
        }
        set summaryUnitsTextFontWeight(a) {
            this.e8 = a;
            this.g("SummaryUnitsTextFontWeight");
        }
        get badgeMarginBottom() {
            return this.ai;
        }
        set badgeMarginBottom(a) {
            this.ai = a;
            this.g("BadgeMarginBottom");
        }
        get badgeMarginLeft() {
            return this.aj;
        }
        set badgeMarginLeft(a) {
            this.aj = a;
            this.g("BadgeMarginLeft");
        }
        get badgeMarginRight() {
            return this.ak;
        }
        set badgeMarginRight(a) {
            this.ak = a;
            this.g("BadgeMarginRight");
        }
        get badgeMarginTop() {
            return this.al;
        }
        set badgeMarginTop(a) {
            this.al = a;
            this.g("BadgeMarginTop");
        }
        get badgeShape() {
            return this.d2;
        }
        set badgeShape(a) {
            this.d2 = a;
            this.g("BadgeShape");
        }
        get targetCursorPositionX() {
            return this.bm;
        }
        set targetCursorPositionX(a) {
            this.bm = a;
            this.g("TargetCursorPositionX");
        }
        get targetCursorPositionY() {
            return this.bn;
        }
        set targetCursorPositionY(a) {
            this.bn = a;
            this.g("TargetCursorPositionY");
        }
        get targetRef() {
            return this.fd;
        }
        set targetRef(a) {
            this.fd = a;
            this.g("TargetRef");
        }
        get unitsDisplayMode() {
            return this.fi;
        }
        set unitsDisplayMode(a) {
            this.fi = a;
            this.g("UnitsDisplayMode");
        }
        get unitsText() {
            return this.fj;
        }
        set unitsText(a) {
            this.fj = a;
            this.g("UnitsText");
        }
        get unitsTextColor() {
            return this.fk;
        }
        set unitsTextColor(a) {
            this.fk = a;
            this.g("UnitsTextColor");
        }
        get unitsTextMarginBottom() {
            return this.bu;
        }
        set unitsTextMarginBottom(a) {
            this.bu = a;
            this.g("UnitsTextMarginBottom");
        }
        get unitsTextMarginLeft() {
            return this.bv;
        }
        set unitsTextMarginLeft(a) {
            this.bv = a;
            this.g("UnitsTextMarginLeft");
        }
        get unitsTextMarginRight() {
            return this.bw;
        }
        set unitsTextMarginRight(a) {
            this.bw = a;
            this.g("UnitsTextMarginRight");
        }
        get unitsTextMarginTop() {
            return this.bx;
        }
        set unitsTextMarginTop(a) {
            this.bx = a;
            this.g("UnitsTextMarginTop");
        }
        get unitsTextFontFamily() {
            return this.fl;
        }
        set unitsTextFontFamily(a) {
            this.fl = a;
            this.g("UnitsTextFontFamily");
        }
        get unitsTextFontSize() {
            return this.bt;
        }
        set unitsTextFontSize(a) {
            this.bt = a;
            this.g("UnitsTextFontSize");
        }
        get unitsTextFontStyle() {
            return this.fm;
        }
        set unitsTextFontStyle(a) {
            this.fm = a;
            this.g("UnitsTextFontStyle");
        }
        get unitsTextFontWeight() {
            return this.fn;
        }
        set unitsTextFontWeight(a) {
            this.fn = a;
            this.g("UnitsTextFontWeight");
        }
        get titleTextMarginBottom() {
            return this.bp;
        }
        set titleTextMarginBottom(a) {
            this.bp = a;
            this.g("TitleTextMarginBottom");
        }
        get titleTextMarginLeft() {
            return this.bq;
        }
        set titleTextMarginLeft(a) {
            this.bq = a;
            this.g("TitleTextMarginLeft");
        }
        get titleTextMarginRight() {
            return this.br;
        }
        set titleTextMarginRight(a) {
            this.br = a;
            this.g("TitleTextMarginRight");
        }
        get titleTextMarginTop() {
            return this.bs;
        }
        set titleTextMarginTop(a) {
            this.bs = a;
            this.g("TitleTextMarginTop");
        }
        get titleTextColor() {
            return this.fe;
        }
        set titleTextColor(a) {
            this.fe = a;
            this.g("TitleTextColor");
        }
        get titleTextFontFamily() {
            return this.ff;
        }
        set titleTextFontFamily(a) {
            this.ff = a;
            this.g("TitleTextFontFamily");
        }
        get titleTextFontSize() {
            return this.bo;
        }
        set titleTextFontSize(a) {
            this.bo = a;
            this.g("TitleTextFontSize");
        }
        get titleTextFontStyle() {
            return this.fg;
        }
        set titleTextFontStyle(a) {
            this.fg = a;
            this.g("TitleTextFontStyle");
        }
        get titleTextFontWeight() {
            return this.fh;
        }
        set titleTextFontWeight(a) {
            this.fh = a;
            this.g("TitleTextFontWeight");
        }
        get labelDisplayMode() {
            return this.ei;
        }
        set labelDisplayMode(a) {
            this.ei = a;
            this.g("LabelDisplayMode");
        }
        get labelTextColor() {
            return this.ej;
        }
        set labelTextColor(a) {
            this.ej = a;
            this.g("LabelTextColor");
        }
        get labelTextMarginBottom() {
            return this.a5;
        }
        set labelTextMarginBottom(a) {
            this.a5 = a;
            this.g("LabelTextMarginBottom");
        }
        get labelTextMarginLeft() {
            return this.a6;
        }
        set labelTextMarginLeft(a) {
            this.a6 = a;
            this.g("LabelTextMarginLeft");
        }
        get labelTextMarginRight() {
            return this.a7;
        }
        set labelTextMarginRight(a) {
            this.a7 = a;
            this.g("LabelTextMarginRight");
        }
        get labelTextMarginTop() {
            return this.a8;
        }
        set labelTextMarginTop(a) {
            this.a8 = a;
            this.g("LabelTextMarginTop");
        }
        get labelTextFontFamily() {
            return this.ek;
        }
        set labelTextFontFamily(a) {
            this.ek = a;
            this.g("LabelTextFontFamily");
        }
        get labelTextFontSize() {
            return this.a4;
        }
        set labelTextFontSize(a) {
            this.a4 = a;
            this.g("LabelTextFontSize");
        }
        get labelTextFontStyle() {
            return this.el;
        }
        set labelTextFontStyle(a) {
            this.el = a;
            this.g("LabelTextFontStyle");
        }
        get labelTextFontWeight() {
            return this.em;
        }
        set labelTextFontWeight(a) {
            this.em = a;
            this.g("LabelTextFontWeight");
        }
        get pixelScalingRatio() {
            return this.a9;
        }
        set pixelScalingRatio(a) {
            this.a9 = a;
            this.g("PixelScalingRatio");
        }
        get calculateColumnSummaryRef() {
            return this.d3;
        }
        set calculateColumnSummaryRef(a) {
            this.d3 = a;
            this.g("CalculateColumnSummaryRef");
        }
        get styleHeaderRowRef() {
            return this.eo;
        }
        set styleHeaderRowRef(a) {
            this.eo = a;
            this.g("StyleHeaderRowRef");
        }
        get styleGroupRowRef() {
            return this.en;
        }
        set styleGroupRowRef(a) {
            this.en = a;
            this.g("StyleGroupRowRef");
        }
        get styleSeriesRowRef() {
            return this.eq;
        }
        set styleSeriesRowRef(a) {
            this.eq = a;
            this.g("StyleSeriesRowRef");
        }
        get styleSummaryRowRef() {
            return this.es;
        }
        set styleSummaryRowRef(a) {
            this.es = a;
            this.g("StyleSummaryRowRef");
        }
        get styleSeriesColumnRef() {
            return this.ep;
        }
        set styleSeriesColumnRef(a) {
            this.ep = a;
            this.g("StyleSeriesColumnRef");
        }
        get styleSummaryColumnRef() {
            return this.er;
        }
        set styleSummaryColumnRef(a) {
            this.er = a;
            this.g("StyleSummaryColumnRef");
        }
        get width() {
            return this.fy;
        }
        set width(a) {
            this.fy = a;
            this.g("Width");
        }
        get height() {
            return this.eh;
        }
        set height(a) {
            this.eh = a;
            this.g("Height");
        }
    }
    DataLegendDescription.$t = /*@__PURE__*/ markType(DataLegendDescription, 'DataLegendDescription', Description.$);
    return DataLegendDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendSummaryEventArgsDescription = /*@__PURE__*/ (() => {
    class DataLegendSummaryEventArgsDescription extends Description {
        get_type() {
            return "DataLegendSummaryEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.l = null;
            this.j = 0;
            this.n = null;
            this.m = null;
        }
        get columnValues() {
            return this.h;
        }
        set columnValues(a) {
            this.h = a;
            this.g("ColumnValues");
        }
        get columnMemberPath() {
            return this.l;
        }
        set columnMemberPath(a) {
            this.l = a;
            this.g("ColumnMemberPath");
        }
        get summaryValue() {
            return this.j;
        }
        set summaryValue(a) {
            this.j = a;
            this.g("SummaryValue");
        }
        get summaryUnits() {
            return this.n;
        }
        set summaryUnits(a) {
            this.n = a;
            this.g("SummaryUnits");
        }
        get summaryLabel() {
            return this.m;
        }
        set summaryLabel(a) {
            this.m = a;
            this.g("SummaryLabel");
        }
    }
    DataLegendSummaryEventArgsDescription.$t = /*@__PURE__*/ markType(DataLegendSummaryEventArgsDescription, 'DataLegendSummaryEventArgsDescription', Description.$);
    return DataLegendSummaryEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendSummaryEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataLegendSummaryEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DataLegendSummaryEventArgsDescriptionMetadata.a == null) {
                DataLegendSummaryEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataLegendSummaryEventArgsDescriptionMetadata.c(DataLegendSummaryEventArgsDescriptionMetadata.a);
            }
            if (a.k(DataLegendSummaryEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataLegendSummaryEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ColumnValues", "Array:double");
            a.item("ColumnMemberPath", "String");
            a.item("SummaryValue", "Number:double");
            a.item("SummaryUnits", "String");
            a.item("SummaryLabel", "String");
        }
        static d(a) {
            DataLegendSummaryEventArgsDescriptionMetadata.b(a);
            a.ae("DataLegendSummaryEventArgs", () => new DataLegendSummaryEventArgsDescription());
            a.ad("DataLegendSummaryEventArgs", DataLegendSummaryEventArgsDescriptionMetadata.a);
        }
    }
    DataLegendSummaryEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataLegendSummaryEventArgsDescriptionMetadata, 'DataLegendSummaryEventArgsDescriptionMetadata');
    DataLegendSummaryEventArgsDescriptionMetadata.a = null;
    return DataLegendSummaryEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendStylingRowEventArgsDescription = /*@__PURE__*/ (() => {
    class DataLegendStylingRowEventArgsDescription extends Description {
        get_type() {
            return "DataLegendStylingRowEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.h = false;
            this.i = false;
            this.l = 0;
            this.p = null;
            this.q = null;
            this.o = null;
            this.r = null;
        }
        get badgeShape() {
            return this.n;
        }
        set badgeShape(a) {
            this.n = a;
            this.g("BadgeShape");
        }
        get isBadgeVisible() {
            return this.h;
        }
        set isBadgeVisible(a) {
            this.h = a;
            this.g("IsBadgeVisible");
        }
        get isRowVisible() {
            return this.i;
        }
        set isRowVisible(a) {
            this.i = a;
            this.g("IsRowVisible");
        }
        get seriesIndex() {
            return this.l;
        }
        set seriesIndex(a) {
            this.l = a;
            this.g("SeriesIndex");
        }
        get seriesTitle() {
            return this.p;
        }
        set seriesTitle(a) {
            this.p = a;
            this.g("SeriesTitle");
        }
        get titleText() {
            return this.q;
        }
        set titleText(a) {
            this.q = a;
            this.g("TitleText");
        }
        get groupName() {
            return this.o;
        }
        set groupName(a) {
            this.o = a;
            this.g("GroupName");
        }
        get titleTextColor() {
            return this.r;
        }
        set titleTextColor(a) {
            this.r = a;
            this.g("TitleTextColor");
        }
    }
    DataLegendStylingRowEventArgsDescription.$t = /*@__PURE__*/ markType(DataLegendStylingRowEventArgsDescription, 'DataLegendStylingRowEventArgsDescription', Description.$);
    return DataLegendStylingRowEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendStylingRowEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataLegendStylingRowEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DataLegendStylingRowEventArgsDescriptionMetadata.a == null) {
                DataLegendStylingRowEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataLegendStylingRowEventArgsDescriptionMetadata.c(DataLegendStylingRowEventArgsDescriptionMetadata.a);
            }
            if (a.k(DataLegendStylingRowEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataLegendStylingRowEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("BadgeShape", "ExportedType:string:LegendItemBadgeShape");
            a.item("BadgeShape@names", "Automatic;Circle;Line;Square;Marker;Bar;Column;Hidden");
            a.item("IsBadgeVisible", "Boolean");
            a.item("IsRowVisible", "Boolean");
            a.item("SeriesIndex", "Number:int");
            a.item("SeriesTitle", "String");
            a.item("TitleText", "String");
            a.item("GroupName", "String");
            a.item("TitleTextColor", "Brush");
        }
        static d(a) {
            DataLegendStylingRowEventArgsDescriptionMetadata.b(a);
            a.ae("DataLegendStylingRowEventArgs", () => new DataLegendStylingRowEventArgsDescription());
            a.ad("DataLegendStylingRowEventArgs", DataLegendStylingRowEventArgsDescriptionMetadata.a);
        }
    }
    DataLegendStylingRowEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataLegendStylingRowEventArgsDescriptionMetadata, 'DataLegendStylingRowEventArgsDescriptionMetadata');
    DataLegendStylingRowEventArgsDescriptionMetadata.a = null;
    return DataLegendStylingRowEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendStylingColumnEventArgsDescription = /*@__PURE__*/ (() => {
    class DataLegendStylingColumnEventArgsDescription extends Description {
        get_type() {
            return "DataLegendStylingColumnEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = 0;
            this.k = 0;
            this.q = null;
            this.h = 0;
            this.v = null;
            this.u = null;
            this.t = null;
            this.o = null;
            this.r = null;
            this.w = null;
            this.p = null;
            this.s = null;
            this.x = null;
            this.n = null;
        }
        get columnIndex() {
            return this.j;
        }
        set columnIndex(a) {
            this.j = a;
            this.g("ColumnIndex");
        }
        get seriesIndex() {
            return this.k;
        }
        set seriesIndex(a) {
            this.k = a;
            this.g("SeriesIndex");
        }
        get seriesTitle() {
            return this.q;
        }
        set seriesTitle(a) {
            this.q = a;
            this.g("SeriesTitle");
        }
        get valueOriginal() {
            return this.h;
        }
        set valueOriginal(a) {
            this.h = a;
            this.g("ValueOriginal");
        }
        get valueMemberPath() {
            return this.v;
        }
        set valueMemberPath(a) {
            this.v = a;
            this.g("ValueMemberPath");
        }
        get valueMemberLabel() {
            return this.u;
        }
        set valueMemberLabel(a) {
            this.u = a;
            this.g("ValueMemberLabel");
        }
        get valueAbbreviation() {
            return this.t;
        }
        set valueAbbreviation(a) {
            this.t = a;
            this.g("ValueAbbreviation");
        }
        get labelText() {
            return this.o;
        }
        set labelText(a) {
            this.o = a;
            this.g("LabelText");
        }
        get unitsText() {
            return this.r;
        }
        set unitsText(a) {
            this.r = a;
            this.g("UnitsText");
        }
        get valueText() {
            return this.w;
        }
        set valueText(a) {
            this.w = a;
            this.g("ValueText");
        }
        get labelTextColor() {
            return this.p;
        }
        set labelTextColor(a) {
            this.p = a;
            this.g("LabelTextColor");
        }
        get unitsTextColor() {
            return this.s;
        }
        set unitsTextColor(a) {
            this.s = a;
            this.g("UnitsTextColor");
        }
        get valueTextColor() {
            return this.x;
        }
        set valueTextColor(a) {
            this.x = a;
            this.g("ValueTextColor");
        }
        get groupName() {
            return this.n;
        }
        set groupName(a) {
            this.n = a;
            this.g("GroupName");
        }
    }
    DataLegendStylingColumnEventArgsDescription.$t = /*@__PURE__*/ markType(DataLegendStylingColumnEventArgsDescription, 'DataLegendStylingColumnEventArgsDescription', Description.$);
    return DataLegendStylingColumnEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendStylingColumnEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataLegendStylingColumnEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DataLegendStylingColumnEventArgsDescriptionMetadata.a == null) {
                DataLegendStylingColumnEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataLegendStylingColumnEventArgsDescriptionMetadata.c(DataLegendStylingColumnEventArgsDescriptionMetadata.a);
            }
            if (a.k(DataLegendStylingColumnEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataLegendStylingColumnEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ColumnIndex", "Number:int");
            a.item("SeriesIndex", "Number:int");
            a.item("SeriesTitle", "String");
            a.item("ValueOriginal", "Number:double");
            a.item("ValueMemberPath", "String");
            a.item("ValueMemberLabel", "String");
            a.item("ValueAbbreviation", "ExportedType:string:DataAbbreviationMode");
            a.item("ValueAbbreviation@names", "Auto;Independent;Shared;Kilo;Million;Billion;Trillion;Quadrillion;Unset;None");
            a.item("LabelText", "String");
            a.item("UnitsText", "String");
            a.item("ValueText", "String");
            a.item("LabelTextColor", "Brush");
            a.item("UnitsTextColor", "Brush");
            a.item("ValueTextColor", "Brush");
            a.item("GroupName", "String");
        }
        static d(a) {
            DataLegendStylingColumnEventArgsDescriptionMetadata.b(a);
            a.ae("DataLegendStylingColumnEventArgs", () => new DataLegendStylingColumnEventArgsDescription());
            a.ad("DataLegendStylingColumnEventArgs", DataLegendStylingColumnEventArgsDescriptionMetadata.a);
        }
    }
    DataLegendStylingColumnEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataLegendStylingColumnEventArgsDescriptionMetadata, 'DataLegendStylingColumnEventArgsDescriptionMetadata');
    DataLegendStylingColumnEventArgsDescriptionMetadata.a = null;
    return DataLegendStylingColumnEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataLegendDescriptionMetadata extends Base {
        static b(a) {
            if (DataLegendDescriptionMetadata.a == null) {
                DataLegendDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataLegendDescriptionMetadata.c(DataLegendDescriptionMetadata.a);
            }
            if (a.k(DataLegendDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataLegendDescriptionMetadata.a);
            DataLegendSummaryEventArgsDescriptionMetadata.d(a);
            DataLegendStylingRowEventArgsDescriptionMetadata.d(a);
            DataLegendStylingColumnEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("ActualBadgesVisible", "Boolean");
            a.item("ActualPixelScalingRatio", "Number:double");
            a.item("IncludedSeries", "Array:string");
            a.item("ExcludedSeries", "Array:string");
            a.item("IncludedColumns", "Array:string");
            a.item("ExcludedColumns", "Array:string");
            a.item("ShouldUpdateWhenSeriesDataChanges", "Boolean");
            a.item("ValueFormatAbbreviation", "ExportedType:string:DataAbbreviationMode");
            a.item("ValueFormatAbbreviation@names", "Auto;Independent;Shared;Kilo;Million;Billion;Trillion;Quadrillion;Unset;None");
            a.item("ValueFormatMaxFractions", "Number:int");
            a.item("ValueFormatMinFractions", "Number:int");
            a.item("ValueFormatMode", "ExportedType:string:DataLegendValueMode");
            a.item("ValueFormatMode@names", "Auto;Decimal;Currency");
            a.item("ValueFormatCulture", "String");
            a.item("ValueFormatCurrencyCode", "String");
            a.item("ValueFormatUseGrouping", "Boolean");
            a.item("ValueFormatString", "String");
            a.item("ValueFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("ValueFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("ValueRowMarginBottom", "(w:ValueRowMargin.Bottom,wf:ValueRowMarginBottom)Number:double");
            a.item("ValueRowMarginLeft", "(w:ValueRowMargin.Left,wf:ValueRowMarginLeft)Number:double");
            a.item("ValueRowMarginRight", "(w:ValueRowMargin.Right,wf:ValueRowMarginRight)Number:double");
            a.item("ValueRowMarginTop", "(w:ValueRowMargin.Top,wf:ValueRowMarginTop)Number:double");
            a.item("ValueRowVisible", "Boolean");
            a.item("ValueTextWhenMissingData", "String");
            a.item("ValueTextUseSeriesColors", "Boolean");
            a.item("ValueTextMarginBottom", "(w:ValueTextMargin.Bottom,wf:ValueTextMarginBottom)Number:double");
            a.item("ValueTextMarginLeft", "(w:ValueTextMargin.Left,wf:ValueTextMarginLeft)Number:double");
            a.item("ValueTextMarginRight", "(w:ValueTextMargin.Right,wf:ValueTextMarginRight)Number:double");
            a.item("ValueTextMarginTop", "(w:ValueTextMargin.Top,wf:ValueTextMarginTop)Number:double");
            a.item("ValueTextColor", "Brush");
            a.item("ValueTextFontFamily", "(w:ValueTextFontFamily/FontFamilyTransform,xam:ValueTextFontFamily,wf:ValueTextFontFamily,web:valueTextStyle/FontFamilyTransform)String");
            a.item("ValueTextFontSize", "(w:ValueTextFontSize,xam:ValueTextFontSize,wf:ValueTextFontSize,web:valueTextStyle/FontSizeTransform)Number:double");
            a.item("ValueTextFontStyle", "(w:ValueTextFontStyle/FontStyleTransform,xam:ValueTextFontFamily/FontStyleTransform,wf:ValueTextFontFamily/FontStyleTransform,web:valueTextStyle/FontStyleTransform)String");
            a.item("ValueTextFontWeight", "(w:ValueTextFontWeight/FontWeightTransform,xam:ValueTextFontFamily/FontWeightTransform,wf:ValueTextFontFamily/FontWeightTransform,web:valueTextStyle/FontWeightTransform)String");
            a.item("HeaderFormatString", "String");
            a.item("HeaderFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("HeaderFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("HeaderFormatCulture", "String");
            a.item("HeaderFormatDate", "ExportedType:string:DataLegendHeaderDateMode");
            a.item("HeaderFormatDate@names", "Auto;ShortStyle;LongStyle;MediumStyle;FullStyle;None");
            a.item("HeaderFormatTime", "ExportedType:string:DataLegendHeaderTimeMode");
            a.item("HeaderFormatTime@names", "Auto;ShortStyle;LongStyle;MediumStyle;FullStyle;None");
            a.item("HeaderText", "String");
            a.item("HeaderTextColor", "Brush");
            a.item("HeaderTextMarginBottom", "(w:HeaderTextMargin.Bottom,wf:HeaderTextMarginBottom)Number:double");
            a.item("HeaderTextMarginLeft", "(w:HeaderTextMargin.Left,wf:HeaderTextMarginLeft)Number:double");
            a.item("HeaderTextMarginRight", "(w:HeaderTextMargin.Right,wf:HeaderTextMarginRight)Number:double");
            a.item("HeaderTextMarginTop", "(w:HeaderTextMargin.Top,wf:HeaderTextMarginTop)Number:double");
            a.item("HeaderRowMarginBottom", "(w:HeaderRowMargin.Bottom,wf:HeaderRowMarginBottom)Number:double");
            a.item("HeaderRowMarginLeft", "(w:HeaderRowMargin.Left,wf:HeaderRowMarginLeft)Number:double");
            a.item("HeaderRowMarginRight", "(w:HeaderRowMargin.Right,wf:HeaderRowMarginRight)Number:double");
            a.item("HeaderRowMarginTop", "(w:HeaderRowMargin.Top,wf:HeaderRowMarginTop)Number:double");
            a.item("HeaderRowVisible", "Boolean");
            a.item("HeaderTextFontFamily", "(w:HeaderTextFontFamily/FontFamilyTransform,xam:HeaderTextFontFamily,wf:HeaderTextFontFamily,web:headerTextStyle/FontFamilyTransform)String");
            a.item("HeaderTextFontSize", "(w:HeaderTextFontSize,xam:HeaderTextFontSize,wf:HeaderTextFontSize,web:headerTextStyle/FontSizeTransform)Number:double");
            a.item("HeaderTextFontStyle", "(w:HeaderTextFontStyle/FontStyleTransform,xam:HeaderTextFontFamily/FontStyleTransform,wf:HeaderTextFontFamily/FontStyleTransform,web:headerTextStyle/FontStyleTransform)String");
            a.item("HeaderTextFontWeight", "(w:HeaderTextFontWeight/FontWeightTransform,xam:HeaderTextFontFamily/FontWeightTransform,wf:HeaderTextFontFamily/FontWeightTransform,web:headerTextStyle/FontWeightTransform)String");
            a.item("GroupRowVisible", "Boolean");
            a.item("GroupTextColor", "Brush");
            a.item("GroupTextMarginBottom", "(w:GroupTextMargin.Bottom,wf:GroupTextMarginBottom)Number:double");
            a.item("GroupTextMarginLeft", "(w:GroupTextMargin.Left,wf:GroupTextMarginLeft)Number:double");
            a.item("GroupTextMarginRight", "(w:GroupTextMargin.Right,wf:GroupTextMarginRight)Number:double");
            a.item("GroupTextMarginTop", "(w:GroupTextMargin.Top,wf:GroupTextMarginTop)Number:double");
            a.item("GroupRowMarginBottom", "(w:GroupRowMargin.Bottom,wf:GroupRowMarginBottom)Number:double");
            a.item("GroupRowMarginLeft", "(w:GroupRowMargin.Left,wf:GroupRowMarginLeft)Number:double");
            a.item("GroupRowMarginRight", "(w:GroupRowMargin.Right,wf:GroupRowMarginRight)Number:double");
            a.item("GroupRowMarginTop", "(w:GroupRowMargin.Top,wf:GroupRowMarginTop)Number:double");
            a.item("GroupTextFontFamily", "(w:GroupTextFontFamily/FontFamilyTransform,xam:GroupTextFontFamily,wf:GroupTextFontFamily,web:groupTextStyle/FontFamilyTransform)String");
            a.item("GroupTextFontSize", "(w:GroupTextFontSize,xam:GroupTextFontSize,wf:GroupTextFontSize,web:groupTextStyle/FontSizeTransform)Number:double");
            a.item("GroupTextFontStyle", "(w:GroupTextFontStyle/FontStyleTransform,xam:GroupTextFontFamily/FontStyleTransform,wf:GroupTextFontFamily/FontStyleTransform,web:groupTextStyle/FontStyleTransform)String");
            a.item("GroupTextFontWeight", "(w:GroupTextFontWeight/FontWeightTransform,xam:GroupTextFontFamily/FontWeightTransform,wf:GroupTextFontFamily/FontWeightTransform,web:groupTextStyle/FontWeightTransform)String");
            a.item("SummaryTitleTextColor", "Brush");
            a.item("SummaryTitleTextFontFamily", "(w:SummaryTitleTextFontFamily/FontFamilyTransform,xam:SummaryTitleTextFontFamily,wf:SummaryTitleTextFontFamily,web:summaryTitleTextStyle/FontFamilyTransform)String");
            a.item("SummaryTitleTextFontSize", "(w:SummaryTitleTextFontSize,xam:SummaryTitleTextFontSize,wf:SummaryTitleTextFontSize,web:summaryTitleTextStyle/FontSizeTransform)Number:double");
            a.item("SummaryTitleTextFontStyle", "(w:SummaryTitleTextFontStyle/FontStyleTransform,xam:SummaryTitleTextFontFamily/FontStyleTransform,wf:SummaryTitleTextFontFamily/FontStyleTransform,web:summaryTitleTextStyle/FontStyleTransform)String");
            a.item("SummaryTitleTextFontWeight", "(w:SummaryTitleTextFontWeight/FontWeightTransform,xam:SummaryTitleTextFontFamily/FontWeightTransform,wf:SummaryTitleTextFontFamily/FontWeightTransform,web:summaryTitleTextStyle/FontWeightTransform)String");
            a.item("SummaryType", "ExportedType:string:DataLegendSummaryType");
            a.item("SummaryType@names", "Auto;Total;Average;Min;Max;None");
            a.item("SummaryTitleText", "String");
            a.item("SummaryTitleTextMarginBottom", "(w:SummaryTitleTextMargin.Bottom,wf:SummaryTitleTextMarginBottom)Number:double");
            a.item("SummaryTitleTextMarginLeft", "(w:SummaryTitleTextMargin.Left,wf:SummaryTitleTextMarginLeft)Number:double");
            a.item("SummaryTitleTextMarginRight", "(w:SummaryTitleTextMargin.Right,wf:SummaryTitleTextMarginRight)Number:double");
            a.item("SummaryTitleTextMarginTop", "(w:SummaryTitleTextMargin.Top,wf:SummaryTitleTextMarginTop)Number:double");
            a.item("SummaryRowMarginBottom", "(w:SummaryRowMargin.Bottom,wf:SummaryRowMarginBottom)Number:double");
            a.item("SummaryRowMarginLeft", "(w:SummaryRowMargin.Left,wf:SummaryRowMarginLeft)Number:double");
            a.item("SummaryRowMarginRight", "(w:SummaryRowMargin.Right,wf:SummaryRowMarginRight)Number:double");
            a.item("SummaryRowMarginTop", "(w:SummaryRowMargin.Top,wf:SummaryRowMarginTop)Number:double");
            a.item("SummaryValueTextColor", "Brush");
            a.item("SummaryValueTextFontFamily", "(w:SummaryValueTextFontFamily/FontFamilyTransform,xam:SummaryValueTextFontFamily,wf:SummaryValueTextFontFamily,web:summaryValueTextStyle/FontFamilyTransform)String");
            a.item("SummaryValueTextFontSize", "(w:SummaryValueTextFontSize,xam:SummaryValueTextFontSize,wf:SummaryValueTextFontSize,web:summaryValueTextStyle/FontSizeTransform)Number:double");
            a.item("SummaryValueTextFontStyle", "(w:SummaryValueTextFontStyle/FontStyleTransform,xam:SummaryValueTextFontFamily/FontStyleTransform,wf:SummaryValueTextFontFamily/FontStyleTransform,web:summaryValueTextStyle/FontStyleTransform)String");
            a.item("SummaryValueTextFontWeight", "(w:SummaryValueTextFontWeight/FontWeightTransform,xam:SummaryValueTextFontFamily/FontWeightTransform,wf:SummaryValueTextFontFamily/FontWeightTransform,web:summaryValueTextStyle/FontWeightTransform)String");
            a.item("SummaryLabelText", "String");
            a.item("SummaryLabelTextColor", "Brush");
            a.item("SummaryLabelTextFontFamily", "(w:SummaryLabelTextFontFamily/FontFamilyTransform,xam:SummaryLabelTextFontFamily,wf:SummaryLabelTextFontFamily,web:summaryLabelTextStyle/FontFamilyTransform)String");
            a.item("SummaryLabelTextFontSize", "(w:SummaryLabelTextFontSize,xam:SummaryLabelTextFontSize,wf:SummaryLabelTextFontSize,web:summaryLabelTextStyle/FontSizeTransform)Number:double");
            a.item("SummaryLabelTextFontStyle", "(w:SummaryLabelTextFontStyle/FontStyleTransform,xam:SummaryLabelTextFontFamily/FontStyleTransform,wf:SummaryLabelTextFontFamily/FontStyleTransform,web:summaryLabelTextStyle/FontStyleTransform)String");
            a.item("SummaryLabelTextFontWeight", "(w:SummaryLabelTextFontWeight/FontWeightTransform,xam:SummaryLabelTextFontFamily/FontWeightTransform,wf:SummaryLabelTextFontFamily/FontWeightTransform,web:summaryLabelTextStyle/FontWeightTransform)String");
            a.item("SummaryUnitsText", "String");
            a.item("SummaryUnitsTextColor", "Brush");
            a.item("SummaryUnitsTextFontFamily", "(w:SummaryUnitsTextFontFamily/FontFamilyTransform,xam:SummaryUnitsTextFontFamily,wf:SummaryUnitsTextFontFamily,web:summaryUnitsTextStyle/FontFamilyTransform)String");
            a.item("SummaryUnitsTextFontSize", "(w:SummaryUnitsTextFontSize,xam:SummaryUnitsTextFontSize,wf:SummaryUnitsTextFontSize,web:summaryUnitsTextStyle/FontSizeTransform)Number:double");
            a.item("SummaryUnitsTextFontStyle", "(w:SummaryUnitsTextFontStyle/FontStyleTransform,xam:SummaryUnitsTextFontFamily/FontStyleTransform,wf:SummaryUnitsTextFontFamily/FontStyleTransform,web:summaryUnitsTextStyle/FontStyleTransform)String");
            a.item("SummaryUnitsTextFontWeight", "(w:SummaryUnitsTextFontWeight/FontWeightTransform,xam:SummaryUnitsTextFontFamily/FontWeightTransform,wf:SummaryUnitsTextFontFamily/FontWeightTransform,web:summaryUnitsTextStyle/FontWeightTransform)String");
            a.item("BadgeMarginBottom", "(w:BadgeMargin.Bottom,wf:BadgeMarginBottom)Number:double");
            a.item("BadgeMarginLeft", "(w:BadgeMargin.Left,wf:BadgeMarginLeft)Number:double");
            a.item("BadgeMarginRight", "(w:BadgeMargin.Right,wf:BadgeMarginRight)Number:double");
            a.item("BadgeMarginTop", "(w:BadgeMargin.Top,wf:BadgeMarginTop)Number:double");
            a.item("BadgeShape", "ExportedType:string:LegendItemBadgeShape");
            a.item("BadgeShape@names", "Automatic;Circle;Line;Square;Marker;Bar;Column;Hidden");
            a.item("TargetCursorPositionX", "Number:double");
            a.item("TargetCursorPositionY", "Number:double");
            a.item("TargetRef", "(w:Target,wf:Target)DataRef::object");
            a.item("UnitsDisplayMode", "ExportedType:string:DataLegendUnitsMode");
            a.item("UnitsDisplayMode@names", "Auto;Visible;Hidden");
            a.item("UnitsText", "String");
            a.item("UnitsTextColor", "Brush");
            a.item("UnitsTextMarginBottom", "(w:UnitsTextMargin.Bottom,wf:UnitsTextMarginBottom)Number:double");
            a.item("UnitsTextMarginLeft", "(w:UnitsTextMargin.Left,wf:UnitsTextMarginLeft)Number:double");
            a.item("UnitsTextMarginRight", "(w:UnitsTextMargin.Right,wf:UnitsTextMarginRight)Number:double");
            a.item("UnitsTextMarginTop", "(w:UnitsTextMargin.Top,wf:UnitsTextMarginTop)Number:double");
            a.item("UnitsTextFontFamily", "(w:UnitsTextFontFamily/FontFamilyTransform,xam:UnitsTextFontFamily,wf:UnitsTextFontFamily,web:unitsTextStyle/FontFamilyTransform)String");
            a.item("UnitsTextFontSize", "(w:UnitsTextFontSize,xam:UnitsTextFontSize,wf:UnitsTextFontSize,web:unitsTextStyle/FontSizeTransform)Number:double");
            a.item("UnitsTextFontStyle", "(w:UnitsTextFontStyle/FontStyleTransform,xam:UnitsTextFontFamily/FontStyleTransform,wf:UnitsTextFontFamily/FontStyleTransform,web:unitsTextStyle/FontStyleTransform)String");
            a.item("UnitsTextFontWeight", "(w:UnitsTextFontWeight/FontWeightTransform,xam:UnitsTextFontFamily/FontWeightTransform,wf:UnitsTextFontFamily/FontWeightTransform,web:unitsTextStyle/FontWeightTransform)String");
            a.item("TitleTextMarginBottom", "(w:TitleTextMargin.Bottom,wf:TitleTextMarginBottom)Number:double");
            a.item("TitleTextMarginLeft", "(w:TitleTextMargin.Left,wf:TitleTextMarginLeft)Number:double");
            a.item("TitleTextMarginRight", "(w:TitleTextMargin.Right,wf:TitleTextMarginRight)Number:double");
            a.item("TitleTextMarginTop", "(w:TitleTextMargin.Top,wf:TitleTextMarginTop)Number:double");
            a.item("TitleTextColor", "Brush");
            a.item("TitleTextFontFamily", "(w:TitleTextFontFamily/FontFamilyTransform,xam:TitleTextFontFamily,wf:TitleTextFontFamily,web:titleTextStyle/FontFamilyTransform)String");
            a.item("TitleTextFontSize", "(w:TitleTextFontSize,xam:TitleTextFontSize,wf:TitleTextFontSize,web:titleTextStyle/FontSizeTransform)Number:double");
            a.item("TitleTextFontStyle", "(w:TitleTextFontStyle/FontStyleTransform,xam:TitleTextFontFamily/FontStyleTransform,wf:TitleTextFontFamily/FontStyleTransform,web:titleTextStyle/FontStyleTransform)String");
            a.item("TitleTextFontWeight", "(w:TitleTextFontWeight/FontWeightTransform,xam:TitleTextFontFamily/FontWeightTransform,wf:TitleTextFontFamily/FontWeightTransform,web:titleTextStyle/FontWeightTransform)String");
            a.item("LabelDisplayMode", "ExportedType:string:DataLegendLabelMode");
            a.item("LabelDisplayMode@names", "Auto;Visible;Hidden");
            a.item("LabelTextColor", "Brush");
            a.item("LabelTextMarginBottom", "(w:LabelTextMargin.Bottom,wf:LabelTextMarginBottom)Number:double");
            a.item("LabelTextMarginLeft", "(w:LabelTextMargin.Left,wf:LabelTextMarginLeft)Number:double");
            a.item("LabelTextMarginRight", "(w:LabelTextMargin.Right,wf:LabelTextMarginRight)Number:double");
            a.item("LabelTextMarginTop", "(w:LabelTextMargin.Top,wf:LabelTextMarginTop)Number:double");
            a.item("LabelTextFontFamily", "(w:LabelTextFontFamily/FontFamilyTransform,xam:LabelTextFontFamily,wf:LabelTextFontFamily,web:labelTextStyle/FontFamilyTransform)String");
            a.item("LabelTextFontSize", "(w:LabelTextFontSize,xam:LabelTextFontSize,wf:LabelTextFontSize,web:labelTextStyle/FontSizeTransform)Number:double");
            a.item("LabelTextFontStyle", "(w:LabelTextFontStyle/FontStyleTransform,xam:LabelTextFontFamily/FontStyleTransform,wf:LabelTextFontFamily/FontStyleTransform,web:labelTextStyle/FontStyleTransform)String");
            a.item("LabelTextFontWeight", "(w:LabelTextFontWeight/FontWeightTransform,xam:LabelTextFontFamily/FontWeightTransform,wf:LabelTextFontFamily/FontWeightTransform,web:labelTextStyle/FontWeightTransform)String");
            a.item("PixelScalingRatio", "Number:double");
            a.item("CalculateColumnSummaryRef", "EventRef::calculateColumnSummary");
            a.item("StyleHeaderRowRef", "EventRef::styleHeaderRow");
            a.item("StyleGroupRowRef", "EventRef::styleGroupRow");
            a.item("StyleSeriesRowRef", "EventRef::styleSeriesRow");
            a.item("StyleSummaryRowRef", "EventRef::styleSummaryRow");
            a.item("StyleSeriesColumnRef", "EventRef::styleSeriesColumn");
            a.item("StyleSummaryColumnRef", "EventRef::styleSummaryColumn");
            DataLegendDescriptionMetadata.e(a);
        }
        static d(a) {
            DataLegendDescriptionMetadata.b(a);
            a.ae("DataLegend", () => new DataLegendDescription());
            a.ad("DataLegend", DataLegendDescriptionMetadata.a);
        }
        static e(a) {
            a.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamDataLegend");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
        }
    }
    DataLegendDescriptionMetadata.$t = /*@__PURE__*/ markType(DataLegendDescriptionMetadata, 'DataLegendDescriptionMetadata');
    DataLegendDescriptionMetadata.a = null;
    return DataLegendDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendDescriptionModule = /*@__PURE__*/ (() => {
    class DataLegendDescriptionModule extends Base {
        static register(a) {
            DataLegendDescriptionMetadata.d(a);
        }
    }
    DataLegendDescriptionModule.$t = /*@__PURE__*/ markType(DataLegendDescriptionModule, 'DataLegendDescriptionModule');
    return DataLegendDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendSeriesContextDescription = /*@__PURE__*/ (() => {
    class DataLegendSeriesContextDescription extends Description {
        get_type() {
            return "DataLegendSeriesContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get seriesFamily() {
            return this.h;
        }
        set seriesFamily(a) {
            this.h = a;
            this.g("SeriesFamily");
        }
    }
    DataLegendSeriesContextDescription.$t = /*@__PURE__*/ markType(DataLegendSeriesContextDescription, 'DataLegendSeriesContextDescription', Description.$);
    return DataLegendSeriesContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendSeriesContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataLegendSeriesContextDescriptionMetadata extends Base {
        static b(a) {
            if (DataLegendSeriesContextDescriptionMetadata.a == null) {
                DataLegendSeriesContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataLegendSeriesContextDescriptionMetadata.c(DataLegendSeriesContextDescriptionMetadata.a);
            }
            if (a.k(DataLegendSeriesContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataLegendSeriesContextDescriptionMetadata.a);
        }
        static c(a) {
            a.item("SeriesFamily", "String");
        }
        static d(a) {
            DataLegendSeriesContextDescriptionMetadata.b(a);
            a.ae("DataLegendSeriesContext", () => new DataLegendSeriesContextDescription());
            a.ad("DataLegendSeriesContext", DataLegendSeriesContextDescriptionMetadata.a);
        }
    }
    DataLegendSeriesContextDescriptionMetadata.$t = /*@__PURE__*/ markType(DataLegendSeriesContextDescriptionMetadata, 'DataLegendSeriesContextDescriptionMetadata');
    DataLegendSeriesContextDescriptionMetadata.a = null;
    return DataLegendSeriesContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendSeriesValueInfoDescription = /*@__PURE__*/ (() => {
    class DataLegendSeriesValueInfoDescription extends Description {
        get_type() {
            return "DataLegendSeriesValueInfo";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.ab = 0;
            this.aq = null;
            this.ar = null;
            this.as = null;
            this.at = null;
            this.al = null;
            this.ae = 0;
            this.ad = 0;
            this.p = false;
            this.o = false;
            this.k = false;
            this.n = false;
            this.l = false;
            this.m = false;
            this.j = false;
            this.au = null;
            this.af = 0;
            this.ag = 0;
            this.q = false;
            this.i = false;
            this.h = false;
            this.an = null;
            this.am = null;
            this.ao = null;
            this.ap = null;
        }
        get value() {
            return this.ab;
        }
        set value(a) {
            this.ab = a;
            this.g("Value");
        }
        get valueNegativePrefix() {
            return this.aq;
        }
        set valueNegativePrefix(a) {
            this.aq = a;
            this.g("ValueNegativePrefix");
        }
        get valueNegativeSuffix() {
            return this.ar;
        }
        set valueNegativeSuffix(a) {
            this.ar = a;
            this.g("ValueNegativeSuffix");
        }
        get valuePositivePrefix() {
            return this.as;
        }
        set valuePositivePrefix(a) {
            this.as = a;
            this.g("ValuePositivePrefix");
        }
        get valuePositiveSuffix() {
            return this.at;
        }
        set valuePositiveSuffix(a) {
            this.at = a;
            this.g("ValuePositiveSuffix");
        }
        get formatWithSeriesColor() {
            return this.al;
        }
        set formatWithSeriesColor(a) {
            this.al = a;
            this.g("FormatWithSeriesColor");
        }
        get formatMinFractions() {
            return this.ae;
        }
        set formatMinFractions(a) {
            this.ae = a;
            this.g("FormatMinFractions");
        }
        get formatMaxFractions() {
            return this.ad;
        }
        set formatMaxFractions(a) {
            this.ad = a;
            this.g("FormatMaxFractions");
        }
        get formatUsePositiveColor() {
            return this.p;
        }
        set formatUsePositiveColor(a) {
            this.p = a;
            this.g("FormatUsePositiveColor");
        }
        get formatUseNegativeColor() {
            return this.o;
        }
        set formatUseNegativeColor(a) {
            this.o = a;
            this.g("FormatUseNegativeColor");
        }
        get formatAllowCurrency() {
            return this.k;
        }
        set formatAllowCurrency(a) {
            this.k = a;
            this.g("FormatAllowCurrency");
        }
        get formatAllowPercent() {
            return this.n;
        }
        set formatAllowPercent(a) {
            this.n = a;
            this.g("FormatAllowPercent");
        }
        get formatAllowDecimal() {
            return this.l;
        }
        set formatAllowDecimal(a) {
            this.l = a;
            this.g("FormatAllowDecimal");
        }
        get formatAllowInteger() {
            return this.m;
        }
        set formatAllowInteger(a) {
            this.m = a;
            this.g("FormatAllowInteger");
        }
        get formatAllowAbbreviation() {
            return this.j;
        }
        set formatAllowAbbreviation(a) {
            this.j = a;
            this.g("FormatAllowAbbreviation");
        }
        get valueType() {
            return this.au;
        }
        set valueType(a) {
            this.au = a;
            this.g("ValueType");
        }
        get index() {
            return this.af;
        }
        set index(a) {
            this.af = a;
            this.g("Index");
        }
        get orderIndex() {
            return this.ag;
        }
        set orderIndex(a) {
            this.ag = a;
            this.g("OrderIndex");
        }
        get isExcludeByDefault() {
            return this.q;
        }
        set isExcludeByDefault(a) {
            this.q = a;
            this.g("IsExcludeByDefault");
        }
        get allowUnits() {
            return this.i;
        }
        set allowUnits(a) {
            this.i = a;
            this.g("AllowUnits");
        }
        get allowLabels() {
            return this.h;
        }
        set allowLabels(a) {
            this.h = a;
            this.g("AllowLabels");
        }
        get memberPath() {
            return this.an;
        }
        set memberPath(a) {
            this.an = a;
            this.g("MemberPath");
        }
        get memberLabel() {
            return this.am;
        }
        set memberLabel(a) {
            this.am = a;
            this.g("MemberLabel");
        }
        get memberSymbol() {
            return this.ao;
        }
        set memberSymbol(a) {
            this.ao = a;
            this.g("MemberSymbol");
        }
        get memberUnit() {
            return this.ap;
        }
        set memberUnit(a) {
            this.ap = a;
            this.g("MemberUnit");
        }
    }
    DataLegendSeriesValueInfoDescription.$t = /*@__PURE__*/ markType(DataLegendSeriesValueInfoDescription, 'DataLegendSeriesValueInfoDescription', Description.$);
    return DataLegendSeriesValueInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendSeriesValueInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataLegendSeriesValueInfoDescriptionMetadata extends Base {
        static b(a) {
            if (DataLegendSeriesValueInfoDescriptionMetadata.a == null) {
                DataLegendSeriesValueInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataLegendSeriesValueInfoDescriptionMetadata.c(DataLegendSeriesValueInfoDescriptionMetadata.a);
            }
            if (a.k(DataLegendSeriesValueInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataLegendSeriesValueInfoDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Value", "Number:double");
            a.item("ValueNegativePrefix", "String");
            a.item("ValueNegativeSuffix", "String");
            a.item("ValuePositivePrefix", "String");
            a.item("ValuePositiveSuffix", "String");
            a.item("FormatWithSeriesColor", "Brush");
            a.item("FormatMinFractions", "Number:int");
            a.item("FormatMaxFractions", "Number:int");
            a.item("FormatUsePositiveColor", "Boolean");
            a.item("FormatUseNegativeColor", "Boolean");
            a.item("FormatAllowCurrency", "Boolean");
            a.item("FormatAllowPercent", "Boolean");
            a.item("FormatAllowDecimal", "Boolean");
            a.item("FormatAllowInteger", "Boolean");
            a.item("FormatAllowAbbreviation", "Boolean");
            a.item("ValueType", "ExportedType:string:DataLegendSeriesValueType");
            a.item("ValueType@names", "Value;Low;High;Open;Close;TypicalPrice;Average;Range;Volume;Change;Angle;Radius;Fill;XValue;YValue;Summary");
            a.item("Index", "Number:int");
            a.item("OrderIndex", "Number:int");
            a.item("IsExcludeByDefault", "Boolean");
            a.item("AllowUnits", "Boolean");
            a.item("AllowLabels", "Boolean");
            a.item("MemberPath", "String");
            a.item("MemberLabel", "String");
            a.item("MemberSymbol", "String");
            a.item("MemberUnit", "String");
        }
        static d(a) {
            DataLegendSeriesValueInfoDescriptionMetadata.b(a);
            a.ae("DataLegendSeriesValueInfo", () => new DataLegendSeriesValueInfoDescription());
            a.ad("DataLegendSeriesValueInfo", DataLegendSeriesValueInfoDescriptionMetadata.a);
        }
    }
    DataLegendSeriesValueInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(DataLegendSeriesValueInfoDescriptionMetadata, 'DataLegendSeriesValueInfoDescriptionMetadata');
    DataLegendSeriesValueInfoDescriptionMetadata.a = null;
    return DataLegendSeriesValueInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendSummaryColumnDescription = /*@__PURE__*/ (() => {
    class DataLegendSummaryColumnDescription extends DataLegendSeriesValueInfoDescription {
        get_type() {
            return "DataLegendSummaryColumn";
        }
        constructor() {
            super();
        }
    }
    DataLegendSummaryColumnDescription.$t = /*@__PURE__*/ markType(DataLegendSummaryColumnDescription, 'DataLegendSummaryColumnDescription', DataLegendSeriesValueInfoDescription.$);
    return DataLegendSummaryColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataLegendSummaryColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataLegendSummaryColumnDescriptionMetadata extends Base {
        static b(a) {
            if (DataLegendSummaryColumnDescriptionMetadata.a == null) {
                DataLegendSummaryColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataLegendSummaryColumnDescriptionMetadata.c(DataLegendSummaryColumnDescriptionMetadata.a);
            }
            if (a.k(DataLegendSummaryColumnDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataLegendSummaryColumnDescriptionMetadata.a);
        }
        static c(a) {
            DataLegendSeriesValueInfoDescriptionMetadata.c(a);
        }
        static d(a) {
            DataLegendSummaryColumnDescriptionMetadata.b(a);
            a.ae("DataLegendSummaryColumn", () => new DataLegendSummaryColumnDescription());
            a.ad("DataLegendSummaryColumn", DataLegendSummaryColumnDescriptionMetadata.a);
        }
    }
    DataLegendSummaryColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(DataLegendSummaryColumnDescriptionMetadata, 'DataLegendSummaryColumnDescriptionMetadata');
    DataLegendSummaryColumnDescriptionMetadata.a = null;
    return DataLegendSummaryColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialBaseChartDescription = /*@__PURE__*/ (() => {
    class RadialBaseChartDescription extends DomainChartDescription {
        get_type() {
            return "RadialBaseChart";
        }
        constructor() {
            super();
            this.tp = null;
            this.t7 = null;
            this.ru = 0;
            this.rw = 0;
            this.rv = 0;
            this.rt = 0;
            this.sb = 0;
            this.sd = 0;
            this.sc = 0;
            this.sa = 0;
            this.tu = null;
            this.uc = null;
            this.tn = null;
            this.to = null;
            this.r5 = 0;
            this.sm = 0;
            this.r4 = 0;
            this.sl = 0;
            this.r7 = 0;
            this.so = 0;
            this.r6 = 0;
            this.sn = 0;
            this.r3 = 0;
            this.sk = 0;
            this.t5 = null;
            this.un = null;
            this.tv = null;
            this.ud = null;
            this.t6 = null;
            this.uo = null;
            this.tt = null;
            this.ub = null;
            this.ty = null;
            this.ug = null;
            this.rx = 0;
            this.se = 0;
            this.ry = 0;
            this.sf = 0;
            this.t0 = null;
            this.ui = null;
            this.t1 = null;
            this.uj = null;
            this.rz = 0;
            this.sg = 0;
            this.r0 = 0;
            this.sh = 0;
            this.t2 = null;
            this.uk = null;
            this.r1 = 0;
            this.si = 0;
            this.t3 = null;
            this.ul = null;
            this.tz = null;
            this.uh = null;
            this.rs = 0;
            this.r9 = 0;
            this.rr = 0;
            this.r8 = 0;
            this.r2 = 0;
            this.sj = 0;
            this.rn = false;
            this.ro = false;
            this.t4 = null;
            this.um = null;
            this.tr = null;
            this.t9 = null;
            this.tw = null;
            this.ue = null;
            this.tx = null;
            this.uf = null;
            this.ua = null;
            this.ts = null;
            this.tq = null;
            this.rj = null;
            this.t8 = null;
            this.rk = null;
        }
        get angleAxisFormatLabelRef() {
            return this.tp;
        }
        set angleAxisFormatLabelRef(a) {
            this.tp = a;
            this.g("AngleAxisFormatLabelRef");
        }
        get valueAxisFormatLabelRef() {
            return this.t7;
        }
        set valueAxisFormatLabelRef(a) {
            this.t7 = a;
            this.g("ValueAxisFormatLabelRef");
        }
        get angleAxisLabelLeftMargin() {
            return this.ru;
        }
        set angleAxisLabelLeftMargin(a) {
            this.ru = a;
            this.g("AngleAxisLabelLeftMargin");
        }
        get angleAxisLabelTopMargin() {
            return this.rw;
        }
        set angleAxisLabelTopMargin(a) {
            this.rw = a;
            this.g("AngleAxisLabelTopMargin");
        }
        get angleAxisLabelRightMargin() {
            return this.rv;
        }
        set angleAxisLabelRightMargin(a) {
            this.rv = a;
            this.g("AngleAxisLabelRightMargin");
        }
        get angleAxisLabelBottomMargin() {
            return this.rt;
        }
        set angleAxisLabelBottomMargin(a) {
            this.rt = a;
            this.g("AngleAxisLabelBottomMargin");
        }
        get valueAxisLabelLeftMargin() {
            return this.sb;
        }
        set valueAxisLabelLeftMargin(a) {
            this.sb = a;
            this.g("ValueAxisLabelLeftMargin");
        }
        get valueAxisLabelTopMargin() {
            return this.sd;
        }
        set valueAxisLabelTopMargin(a) {
            this.sd = a;
            this.g("ValueAxisLabelTopMargin");
        }
        get valueAxisLabelRightMargin() {
            return this.sc;
        }
        set valueAxisLabelRightMargin(a) {
            this.sc = a;
            this.g("ValueAxisLabelRightMargin");
        }
        get valueAxisLabelBottomMargin() {
            return this.sa;
        }
        set valueAxisLabelBottomMargin(a) {
            this.sa = a;
            this.g("ValueAxisLabelBottomMargin");
        }
        get angleAxisLabelTextColor() {
            return this.tu;
        }
        set angleAxisLabelTextColor(a) {
            this.tu = a;
            this.g("AngleAxisLabelTextColor");
        }
        get valueAxisLabelTextColor() {
            return this.uc;
        }
        set valueAxisLabelTextColor(a) {
            this.uc = a;
            this.g("ValueAxisLabelTextColor");
        }
        get actualAngleAxisLabelTextColor() {
            return this.tn;
        }
        set actualAngleAxisLabelTextColor(a) {
            this.tn = a;
            this.g("ActualAngleAxisLabelTextColor");
        }
        get actualValueAxisLabelTextColor() {
            return this.to;
        }
        set actualValueAxisLabelTextColor(a) {
            this.to = a;
            this.g("ActualValueAxisLabelTextColor");
        }
        get angleAxisTitleMargin() {
            return this.r5;
        }
        set angleAxisTitleMargin(a) {
            this.r5 = a;
            this.g("AngleAxisTitleMargin");
        }
        get valueAxisTitleMargin() {
            return this.sm;
        }
        set valueAxisTitleMargin(a) {
            this.sm = a;
            this.g("ValueAxisTitleMargin");
        }
        get angleAxisTitleLeftMargin() {
            return this.r4;
        }
        set angleAxisTitleLeftMargin(a) {
            this.r4 = a;
            this.g("AngleAxisTitleLeftMargin");
        }
        get valueAxisTitleLeftMargin() {
            return this.sl;
        }
        set valueAxisTitleLeftMargin(a) {
            this.sl = a;
            this.g("ValueAxisTitleLeftMargin");
        }
        get angleAxisTitleTopMargin() {
            return this.r7;
        }
        set angleAxisTitleTopMargin(a) {
            this.r7 = a;
            this.g("AngleAxisTitleTopMargin");
        }
        get valueAxisTitleTopMargin() {
            return this.so;
        }
        set valueAxisTitleTopMargin(a) {
            this.so = a;
            this.g("ValueAxisTitleTopMargin");
        }
        get angleAxisTitleRightMargin() {
            return this.r6;
        }
        set angleAxisTitleRightMargin(a) {
            this.r6 = a;
            this.g("AngleAxisTitleRightMargin");
        }
        get valueAxisTitleRightMargin() {
            return this.sn;
        }
        set valueAxisTitleRightMargin(a) {
            this.sn = a;
            this.g("ValueAxisTitleRightMargin");
        }
        get angleAxisTitleBottomMargin() {
            return this.r3;
        }
        set angleAxisTitleBottomMargin(a) {
            this.r3 = a;
            this.g("AngleAxisTitleBottomMargin");
        }
        get valueAxisTitleBottomMargin() {
            return this.sk;
        }
        set valueAxisTitleBottomMargin(a) {
            this.sk = a;
            this.g("ValueAxisTitleBottomMargin");
        }
        get angleAxisTitleTextColor() {
            return this.t5;
        }
        set angleAxisTitleTextColor(a) {
            this.t5 = a;
            this.g("AngleAxisTitleTextColor");
        }
        get valueAxisTitleTextColor() {
            return this.un;
        }
        set valueAxisTitleTextColor(a) {
            this.un = a;
            this.g("ValueAxisTitleTextColor");
        }
        get angleAxisLabelTextStyle() {
            return this.tv;
        }
        set angleAxisLabelTextStyle(a) {
            this.tv = a;
            this.g("AngleAxisLabelTextStyle");
        }
        get valueAxisLabelTextStyle() {
            return this.ud;
        }
        set valueAxisLabelTextStyle(a) {
            this.ud = a;
            this.g("ValueAxisLabelTextStyle");
        }
        get angleAxisTitleTextStyle() {
            return this.t6;
        }
        set angleAxisTitleTextStyle(a) {
            this.t6 = a;
            this.g("AngleAxisTitleTextStyle");
        }
        get valueAxisTitleTextStyle() {
            return this.uo;
        }
        set valueAxisTitleTextStyle(a) {
            this.uo = a;
            this.g("ValueAxisTitleTextStyle");
        }
        get angleAxisLabelRef() {
            return this.tt;
        }
        set angleAxisLabelRef(a) {
            this.tt = a;
            this.g("AngleAxisLabelRef");
        }
        get valueAxisLabelRef() {
            return this.ub;
        }
        set valueAxisLabelRef(a) {
            this.ub = a;
            this.g("ValueAxisLabelRef");
        }
        get angleAxisMajorStroke() {
            return this.ty;
        }
        set angleAxisMajorStroke(a) {
            this.ty = a;
            this.g("AngleAxisMajorStroke");
        }
        get valueAxisMajorStroke() {
            return this.ug;
        }
        set valueAxisMajorStroke(a) {
            this.ug = a;
            this.g("ValueAxisMajorStroke");
        }
        get angleAxisMajorStrokeThickness() {
            return this.rx;
        }
        set angleAxisMajorStrokeThickness(a) {
            this.rx = a;
            this.g("AngleAxisMajorStrokeThickness");
        }
        get valueAxisMajorStrokeThickness() {
            return this.se;
        }
        set valueAxisMajorStrokeThickness(a) {
            this.se = a;
            this.g("ValueAxisMajorStrokeThickness");
        }
        get angleAxisMinorStrokeThickness() {
            return this.ry;
        }
        set angleAxisMinorStrokeThickness(a) {
            this.ry = a;
            this.g("AngleAxisMinorStrokeThickness");
        }
        get valueAxisMinorStrokeThickness() {
            return this.sf;
        }
        set valueAxisMinorStrokeThickness(a) {
            this.sf = a;
            this.g("ValueAxisMinorStrokeThickness");
        }
        get angleAxisStrip() {
            return this.t0;
        }
        set angleAxisStrip(a) {
            this.t0 = a;
            this.g("AngleAxisStrip");
        }
        get valueAxisStrip() {
            return this.ui;
        }
        set valueAxisStrip(a) {
            this.ui = a;
            this.g("ValueAxisStrip");
        }
        get angleAxisStroke() {
            return this.t1;
        }
        set angleAxisStroke(a) {
            this.t1 = a;
            this.g("AngleAxisStroke");
        }
        get valueAxisStroke() {
            return this.uj;
        }
        set valueAxisStroke(a) {
            this.uj = a;
            this.g("ValueAxisStroke");
        }
        get angleAxisStrokeThickness() {
            return this.rz;
        }
        set angleAxisStrokeThickness(a) {
            this.rz = a;
            this.g("AngleAxisStrokeThickness");
        }
        get valueAxisStrokeThickness() {
            return this.sg;
        }
        set valueAxisStrokeThickness(a) {
            this.sg = a;
            this.g("ValueAxisStrokeThickness");
        }
        get angleAxisTickLength() {
            return this.r0;
        }
        set angleAxisTickLength(a) {
            this.r0 = a;
            this.g("AngleAxisTickLength");
        }
        get valueAxisTickLength() {
            return this.sh;
        }
        set valueAxisTickLength(a) {
            this.sh = a;
            this.g("ValueAxisTickLength");
        }
        get angleAxisTickStroke() {
            return this.t2;
        }
        set angleAxisTickStroke(a) {
            this.t2 = a;
            this.g("AngleAxisTickStroke");
        }
        get valueAxisTickStroke() {
            return this.uk;
        }
        set valueAxisTickStroke(a) {
            this.uk = a;
            this.g("ValueAxisTickStroke");
        }
        get angleAxisTickStrokeThickness() {
            return this.r1;
        }
        set angleAxisTickStrokeThickness(a) {
            this.r1 = a;
            this.g("AngleAxisTickStrokeThickness");
        }
        get valueAxisTickStrokeThickness() {
            return this.si;
        }
        set valueAxisTickStrokeThickness(a) {
            this.si = a;
            this.g("ValueAxisTickStrokeThickness");
        }
        get angleAxisTitle() {
            return this.t3;
        }
        set angleAxisTitle(a) {
            this.t3 = a;
            this.g("AngleAxisTitle");
        }
        get valueAxisTitle() {
            return this.ul;
        }
        set valueAxisTitle(a) {
            this.ul = a;
            this.g("ValueAxisTitle");
        }
        get angleAxisMinorStroke() {
            return this.tz;
        }
        set angleAxisMinorStroke(a) {
            this.tz = a;
            this.g("AngleAxisMinorStroke");
        }
        get valueAxisMinorStroke() {
            return this.uh;
        }
        set valueAxisMinorStroke(a) {
            this.uh = a;
            this.g("ValueAxisMinorStroke");
        }
        get angleAxisLabelAngle() {
            return this.rs;
        }
        set angleAxisLabelAngle(a) {
            this.rs = a;
            this.g("AngleAxisLabelAngle");
        }
        get valueAxisLabelAngle() {
            return this.r9;
        }
        set valueAxisLabelAngle(a) {
            this.r9 = a;
            this.g("ValueAxisLabelAngle");
        }
        get angleAxisExtent() {
            return this.rr;
        }
        set angleAxisExtent(a) {
            this.rr = a;
            this.g("AngleAxisExtent");
        }
        get valueAxisExtent() {
            return this.r8;
        }
        set valueAxisExtent(a) {
            this.r8 = a;
            this.g("ValueAxisExtent");
        }
        get angleAxisTitleAngle() {
            return this.r2;
        }
        set angleAxisTitleAngle(a) {
            this.r2 = a;
            this.g("AngleAxisTitleAngle");
        }
        get valueAxisTitleAngle() {
            return this.sj;
        }
        set valueAxisTitleAngle(a) {
            this.sj = a;
            this.g("ValueAxisTitleAngle");
        }
        get angleAxisInverted() {
            return this.rn;
        }
        set angleAxisInverted(a) {
            this.rn = a;
            this.g("AngleAxisInverted");
        }
        get valueAxisInverted() {
            return this.ro;
        }
        set valueAxisInverted(a) {
            this.ro = a;
            this.g("ValueAxisInverted");
        }
        get angleAxisTitleAlignment() {
            return this.t4;
        }
        set angleAxisTitleAlignment(a) {
            this.t4 = a;
            this.g("AngleAxisTitleAlignment");
        }
        get valueAxisTitleAlignment() {
            return this.um;
        }
        set valueAxisTitleAlignment(a) {
            this.um = a;
            this.g("ValueAxisTitleAlignment");
        }
        get angleAxisLabelHorizontalAlignment() {
            return this.tr;
        }
        set angleAxisLabelHorizontalAlignment(a) {
            this.tr = a;
            this.g("AngleAxisLabelHorizontalAlignment");
        }
        get valueAxisLabelHorizontalAlignment() {
            return this.t9;
        }
        set valueAxisLabelHorizontalAlignment(a) {
            this.t9 = a;
            this.g("ValueAxisLabelHorizontalAlignment");
        }
        get angleAxisLabelVerticalAlignment() {
            return this.tw;
        }
        set angleAxisLabelVerticalAlignment(a) {
            this.tw = a;
            this.g("AngleAxisLabelVerticalAlignment");
        }
        get valueAxisLabelVerticalAlignment() {
            return this.ue;
        }
        set valueAxisLabelVerticalAlignment(a) {
            this.ue = a;
            this.g("ValueAxisLabelVerticalAlignment");
        }
        get angleAxisLabelVisibility() {
            return this.tx;
        }
        set angleAxisLabelVisibility(a) {
            this.tx = a;
            this.g("AngleAxisLabelVisibility");
        }
        get valueAxisLabelVisibility() {
            return this.uf;
        }
        set valueAxisLabelVisibility(a) {
            this.uf = a;
            this.g("ValueAxisLabelVisibility");
        }
        get valueAxisLabelLocation() {
            return this.ua;
        }
        set valueAxisLabelLocation(a) {
            this.ua = a;
            this.g("ValueAxisLabelLocation");
        }
        get angleAxisLabelLocation() {
            return this.ts;
        }
        set angleAxisLabelLocation(a) {
            this.ts = a;
            this.g("AngleAxisLabelLocation");
        }
        get angleAxisLabelFormat() {
            return this.tq;
        }
        set angleAxisLabelFormat(a) {
            this.tq = a;
            this.g("AngleAxisLabelFormat");
        }
        get angleAxisLabelFormatSpecifiers() {
            return this.rj;
        }
        set angleAxisLabelFormatSpecifiers(a) {
            this.rj = a;
            this.g("AngleAxisLabelFormatSpecifiers");
        }
        get valueAxisLabelFormat() {
            return this.t8;
        }
        set valueAxisLabelFormat(a) {
            this.t8 = a;
            this.g("ValueAxisLabelFormat");
        }
        get valueAxisLabelFormatSpecifiers() {
            return this.rk;
        }
        set valueAxisLabelFormatSpecifiers(a) {
            this.rk = a;
            this.g("ValueAxisLabelFormatSpecifiers");
        }
    }
    RadialBaseChartDescription.$t = /*@__PURE__*/ markType(RadialBaseChartDescription, 'RadialBaseChartDescription', DomainChartDescription.$);
    return RadialBaseChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataPieBaseChartDescription = /*@__PURE__*/ (() => {
    class DataPieBaseChartDescription extends RadialBaseChartDescription {
        get_type() {
            return "DataPieBaseChart";
        }
        constructor() {
            super();
            this.w5 = null;
            this.vu = null;
            this.wx = null;
            this.vs = null;
            this.w2 = null;
            this.vt = null;
            this.wv = null;
            this.vr = null;
            this.v9 = 0;
            this.w7 = null;
            this.w6 = null;
            this.wy = null;
            this.wt = null;
            this.w9 = null;
            this.w1 = null;
            this.wa = 0;
            this.w0 = null;
            this.wu = null;
            this.v1 = false;
            this.w8 = null;
            this.v7 = 0;
            this.v8 = 0;
            this.wd = 0;
            this.v2 = false;
            this.wr = 0;
            this.wf = 0;
            this.we = 0;
            this.wg = 0;
            this.wb = 0;
            this.wc = 0;
            this.w4 = null;
            this.w3 = null;
            this.ww = null;
            this.vz = false;
            this.v0 = false;
            this.wz = null;
        }
        get sliceLabelFormat() {
            return this.w5;
        }
        set sliceLabelFormat(a) {
            this.w5 = a;
            this.g("SliceLabelFormat");
        }
        get sliceLabelFormatSpecifiers() {
            return this.vu;
        }
        set sliceLabelFormatSpecifiers(a) {
            this.vu = a;
            this.g("SliceLabelFormatSpecifiers");
        }
        get legendSliceLabelFormat() {
            return this.wx;
        }
        set legendSliceLabelFormat(a) {
            this.wx = a;
            this.g("LegendSliceLabelFormat");
        }
        get legendSliceLabelFormatSpecifiers() {
            return this.vs;
        }
        set legendSliceLabelFormatSpecifiers(a) {
            this.vs = a;
            this.g("LegendSliceLabelFormatSpecifiers");
        }
        get othersSliceLabelFormat() {
            return this.w2;
        }
        set othersSliceLabelFormat(a) {
            this.w2 = a;
            this.g("OthersSliceLabelFormat");
        }
        get othersSliceLabelFormatSpecifiers() {
            return this.vt;
        }
        set othersSliceLabelFormatSpecifiers(a) {
            this.vt = a;
            this.g("OthersSliceLabelFormatSpecifiers");
        }
        get legendOthersSliceLabelFormat() {
            return this.wv;
        }
        set legendOthersSliceLabelFormat(a) {
            this.wv = a;
            this.g("LegendOthersSliceLabelFormat");
        }
        get legendOthersSliceLabelFormatSpecifiers() {
            return this.vr;
        }
        set legendOthersSliceLabelFormatSpecifiers(a) {
            this.vr = a;
            this.g("LegendOthersSliceLabelFormatSpecifiers");
        }
        get innerExtent() {
            return this.v9;
        }
        set innerExtent(a) {
            this.v9 = a;
            this.g("InnerExtent");
        }
        get sweepDirection() {
            return this.w7;
        }
        set sweepDirection(a) {
            this.w7 = a;
            this.g("SweepDirection");
        }
        get sliceLabelPositionMode() {
            return this.w6;
        }
        set sliceLabelPositionMode(a) {
            this.w6 = a;
            this.g("SliceLabelPositionMode");
        }
        get lightSliceLabelColor() {
            return this.wy;
        }
        set lightSliceLabelColor(a) {
            this.wy = a;
            this.g("LightSliceLabelColor");
        }
        get darkSliceLabelColor() {
            return this.wt;
        }
        set darkSliceLabelColor(a) {
            this.wt = a;
            this.g("DarkSliceLabelColor");
        }
        get valueMemberPath() {
            return this.w9;
        }
        set valueMemberPath(a) {
            this.w9 = a;
            this.g("ValueMemberPath");
        }
        get othersCategoryType() {
            return this.w1;
        }
        set othersCategoryType(a) {
            this.w1 = a;
            this.g("OthersCategoryType");
        }
        get othersCategoryThreshold() {
            return this.wa;
        }
        set othersCategoryThreshold(a) {
            this.wa = a;
            this.g("OthersCategoryThreshold");
        }
        get othersCategoryText() {
            return this.w0;
        }
        set othersCategoryText(a) {
            this.w0 = a;
            this.g("OthersCategoryText");
        }
        get labelMemberPath() {
            return this.wu;
        }
        set labelMemberPath(a) {
            this.wu = a;
            this.g("LabelMemberPath");
        }
        get valueAxisFavorLabellingScaleEnd() {
            return this.v1;
        }
        set valueAxisFavorLabellingScaleEnd(a) {
            this.v1 = a;
            this.g("ValueAxisFavorLabellingScaleEnd");
        }
        get valueAxisAutoRangeBufferMode() {
            return this.w8;
        }
        set valueAxisAutoRangeBufferMode(a) {
            this.w8 = a;
            this.g("ValueAxisAutoRangeBufferMode");
        }
        get angleAxisInterval() {
            return this.v7;
        }
        set angleAxisInterval(a) {
            this.v7 = a;
            this.g("AngleAxisInterval");
        }
        get angleAxisMinorInterval() {
            return this.v8;
        }
        set angleAxisMinorInterval(a) {
            this.v8 = a;
            this.g("AngleAxisMinorInterval");
        }
        get valueAxisInterval() {
            return this.wd;
        }
        set valueAxisInterval(a) {
            this.wd = a;
            this.g("ValueAxisInterval");
        }
        get valueAxisIsLogarithmic() {
            return this.v2;
        }
        set valueAxisIsLogarithmic(a) {
            this.v2 = a;
            this.g("ValueAxisIsLogarithmic");
        }
        get valueAxisLogarithmBase() {
            return this.wr;
        }
        set valueAxisLogarithmBase(a) {
            this.wr = a;
            this.g("ValueAxisLogarithmBase");
        }
        get valueAxisMinimumValue() {
            return this.wf;
        }
        set valueAxisMinimumValue(a) {
            this.wf = a;
            this.g("ValueAxisMinimumValue");
        }
        get valueAxisMaximumValue() {
            return this.we;
        }
        set valueAxisMaximumValue(a) {
            this.we = a;
            this.g("ValueAxisMaximumValue");
        }
        get valueAxisMinorInterval() {
            return this.wg;
        }
        set valueAxisMinorInterval(a) {
            this.wg = a;
            this.g("ValueAxisMinorInterval");
        }
        get radiusExtent() {
            return this.wb;
        }
        set radiusExtent(a) {
            this.wb = a;
            this.g("RadiusExtent");
        }
        get startAngle() {
            return this.wc;
        }
        set startAngle(a) {
            this.wc = a;
            this.g("StartAngle");
        }
        get sliceLabelContentSeparator() {
            return this.w4;
        }
        set sliceLabelContentSeparator(a) {
            this.w4 = a;
            this.g("SliceLabelContentSeparator");
        }
        get sliceLabelContentMode() {
            return this.w3;
        }
        set sliceLabelContentMode(a) {
            this.w3 = a;
            this.g("SliceLabelContentMode");
        }
        get legendSliceLabelContentMode() {
            return this.ww;
        }
        set legendSliceLabelContentMode(a) {
            this.ww = a;
            this.g("LegendSliceLabelContentMode");
        }
        get angleAxisFavorLabellingScaleEnd() {
            return this.vz;
        }
        set angleAxisFavorLabellingScaleEnd(a) {
            this.vz = a;
            this.g("AngleAxisFavorLabellingScaleEnd");
        }
        get valueAxisAbbreviateLargeNumbers() {
            return this.v0;
        }
        set valueAxisAbbreviateLargeNumbers(a) {
            this.v0 = a;
            this.g("ValueAxisAbbreviateLargeNumbers");
        }
        get markerCollision() {
            return this.wz;
        }
        set markerCollision(a) {
            this.wz = a;
            this.g("MarkerCollision");
        }
    }
    DataPieBaseChartDescription.$t = /*@__PURE__*/ markType(DataPieBaseChartDescription, 'DataPieBaseChartDescription', RadialBaseChartDescription.$);
    return DataPieBaseChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialBaseChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialBaseChartDescriptionMetadata extends Base {
        static b(a) {
            if (RadialBaseChartDescriptionMetadata.a == null) {
                RadialBaseChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialBaseChartDescriptionMetadata.c(RadialBaseChartDescriptionMetadata.a);
            }
            if (a.k(RadialBaseChartDescriptionMetadata.a)) {
                return;
            }
            a.ac(RadialBaseChartDescriptionMetadata.a);
        }
        static c(a) {
            DomainChartDescriptionMetadata.c(a);
            a.item("AngleAxisFormatLabelRef", "(w:AngleAxisFormatLabel,wf:AngleAxisFormatLabel)MethodRef");
            a.item("ValueAxisFormatLabelRef", "(w:ValueAxisFormatLabel,wf:ValueAxisFormatLabel)MethodRef");
            a.item("AngleAxisLabelLeftMargin", "Number:double");
            a.item("AngleAxisLabelTopMargin", "Number:double");
            a.item("AngleAxisLabelRightMargin", "Number:double");
            a.item("AngleAxisLabelBottomMargin", "Number:double");
            a.item("ValueAxisLabelLeftMargin", "Number:double");
            a.item("ValueAxisLabelTopMargin", "Number:double");
            a.item("ValueAxisLabelRightMargin", "Number:double");
            a.item("ValueAxisLabelBottomMargin", "Number:double");
            a.item("AngleAxisLabelTextColor", "Brush");
            a.item("ValueAxisLabelTextColor", "Brush");
            a.item("ActualAngleAxisLabelTextColor", "Brush");
            a.item("ActualValueAxisLabelTextColor", "Brush");
            a.item("AngleAxisTitleMargin", "Number:double");
            a.item("ValueAxisTitleMargin", "Number:double");
            a.item("AngleAxisTitleLeftMargin", "Number:double");
            a.item("ValueAxisTitleLeftMargin", "Number:double");
            a.item("AngleAxisTitleTopMargin", "Number:double");
            a.item("ValueAxisTitleTopMargin", "Number:double");
            a.item("AngleAxisTitleRightMargin", "Number:double");
            a.item("ValueAxisTitleRightMargin", "Number:double");
            a.item("AngleAxisTitleBottomMargin", "Number:double");
            a.item("ValueAxisTitleBottomMargin", "Number:double");
            a.item("AngleAxisTitleTextColor", "Brush");
            a.item("ValueAxisTitleTextColor", "Brush");
            a.item("AngleAxisLabelTextStyle", "String");
            a.item("ValueAxisLabelTextStyle", "String");
            a.item("AngleAxisTitleTextStyle", "String");
            a.item("ValueAxisTitleTextStyle", "String");
            a.item("AngleAxisLabelRef", "(w:AngleAxisLabel,wf:AngleAxisLabel)DataRef");
            a.item("ValueAxisLabelRef", "(w:ValueAxisLabel,wf:ValueAxisLabel)DataRef");
            a.item("AngleAxisMajorStroke", "Brush");
            a.item("ValueAxisMajorStroke", "Brush");
            a.item("AngleAxisMajorStrokeThickness", "Number:double");
            a.item("ValueAxisMajorStrokeThickness", "Number:double");
            a.item("AngleAxisMinorStrokeThickness", "Number:double");
            a.item("ValueAxisMinorStrokeThickness", "Number:double");
            a.item("AngleAxisStrip", "Brush");
            a.item("ValueAxisStrip", "Brush");
            a.item("AngleAxisStroke", "Brush");
            a.item("ValueAxisStroke", "Brush");
            a.item("AngleAxisStrokeThickness", "Number:double");
            a.item("ValueAxisStrokeThickness", "Number:double");
            a.item("AngleAxisTickLength", "Number:double");
            a.item("ValueAxisTickLength", "Number:double");
            a.item("AngleAxisTickStroke", "Brush");
            a.item("ValueAxisTickStroke", "Brush");
            a.item("AngleAxisTickStrokeThickness", "Number:double");
            a.item("ValueAxisTickStrokeThickness", "Number:double");
            a.item("AngleAxisTitle", "String");
            a.item("ValueAxisTitle", "String");
            a.item("AngleAxisMinorStroke", "Brush");
            a.item("ValueAxisMinorStroke", "Brush");
            a.item("AngleAxisLabelAngle", "Number:double");
            a.item("ValueAxisLabelAngle", "Number:double");
            a.item("AngleAxisExtent", "Number:double");
            a.item("ValueAxisExtent", "Number:double");
            a.item("AngleAxisTitleAngle", "Number:double");
            a.item("ValueAxisTitleAngle", "Number:double");
            a.item("AngleAxisInverted", "Boolean");
            a.item("ValueAxisInverted", "Boolean");
            a.item("AngleAxisTitleAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("AngleAxisTitleAlignment@names", "Left;Center;Right;Stretch");
            a.item("ValueAxisTitleAlignment", "ExportedType:string:VerticalAlignment");
            a.item("ValueAxisTitleAlignment@names", "Top;Center;Bottom;Stretch");
            a.item("AngleAxisLabelHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("AngleAxisLabelHorizontalAlignment@names", "Left;Center;Right;Stretch");
            a.item("ValueAxisLabelHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("ValueAxisLabelHorizontalAlignment@names", "Left;Center;Right;Stretch");
            a.item("AngleAxisLabelVerticalAlignment", "ExportedType:string:VerticalAlignment");
            a.item("AngleAxisLabelVerticalAlignment@names", "Top;Center;Bottom;Stretch");
            a.item("ValueAxisLabelVerticalAlignment", "ExportedType:string:VerticalAlignment");
            a.item("ValueAxisLabelVerticalAlignment@names", "Top;Center;Bottom;Stretch");
            a.item("AngleAxisLabelVisibility", "ExportedType:string:Visibility");
            a.item("AngleAxisLabelVisibility@names", "Visible;Collapsed");
            a.item("ValueAxisLabelVisibility", "ExportedType:string:Visibility");
            a.item("ValueAxisLabelVisibility@names", "Visible;Collapsed");
            a.item("ValueAxisLabelLocation", "ExportedType:string:ValueAxisLabelLocation");
            a.item("ValueAxisLabelLocation@names", "OutsideLeft;OutsideRight;InsideLeft;InsideRight;Auto");
            a.item("AngleAxisLabelLocation", "ExportedType:string:AngleAxisLabelLocation");
            a.item("AngleAxisLabelLocation@names", "OutsideTop;OutsideBottom;InsideTop;InsideBottom;Auto");
            a.item("AngleAxisLabelFormat", "String");
            a.item("AngleAxisLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("AngleAxisLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("ValueAxisLabelFormat", "String");
            a.item("ValueAxisLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("ValueAxisLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
        }
        static d(a) {
            RadialBaseChartDescriptionMetadata.b(a);
            a.ad("RadialBaseChart", RadialBaseChartDescriptionMetadata.a);
        }
    }
    RadialBaseChartDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialBaseChartDescriptionMetadata, 'RadialBaseChartDescriptionMetadata');
    RadialBaseChartDescriptionMetadata.a = null;
    return RadialBaseChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataPieBaseChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataPieBaseChartDescriptionMetadata extends Base {
        static b(a) {
            if (DataPieBaseChartDescriptionMetadata.a == null) {
                DataPieBaseChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataPieBaseChartDescriptionMetadata.c(DataPieBaseChartDescriptionMetadata.a);
            }
            if (a.k(DataPieBaseChartDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataPieBaseChartDescriptionMetadata.a);
        }
        static c(a) {
            RadialBaseChartDescriptionMetadata.c(a);
            a.item("SliceLabelFormat", "String");
            a.item("SliceLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("SliceLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("LegendSliceLabelFormat", "String");
            a.item("LegendSliceLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LegendSliceLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("OthersSliceLabelFormat", "String");
            a.item("OthersSliceLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("OthersSliceLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("LegendOthersSliceLabelFormat", "String");
            a.item("LegendOthersSliceLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LegendOthersSliceLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("InnerExtent", "Number:double");
            a.item("SweepDirection", "ExportedType:string:PieChartSweepDirection");
            a.item("SweepDirection@names", "Auto;Clockwise;Counterclockwise");
            a.item("SliceLabelPositionMode", "ExportedType:string:CalloutCollisionMode");
            a.item("SliceLabelPositionMode@names", "Auto;SimulatedAnnealing;Greedy;GreedyCenterOfMass;RadialBestFit;RadialInsideEnd;RadialOutsideEnd;RadialCenter");
            a.item("LightSliceLabelColor", "Brush");
            a.item("DarkSliceLabelColor", "Brush");
            a.item("ValueMemberPath", "String");
            a.item("OthersCategoryType", "ExportedType:string:OthersCategoryType");
            a.item("OthersCategoryType@names", "Number;Percent");
            a.item("OthersCategoryThreshold", "Number:double");
            a.item("OthersCategoryText", "String");
            a.item("LabelMemberPath", "String");
            a.item("ValueAxisFavorLabellingScaleEnd", "Boolean");
            a.item("ValueAxisAutoRangeBufferMode", "ExportedType:string:AxisRangeBufferMode");
            a.item("ValueAxisAutoRangeBufferMode@names", "Auto;Series;SeriesMinimum;SeriesMaximum;None");
            a.item("AngleAxisInterval", "Number:double");
            a.item("AngleAxisMinorInterval", "Number:double");
            a.item("ValueAxisInterval", "Number:double");
            a.item("ValueAxisIsLogarithmic", "Boolean");
            a.item("ValueAxisLogarithmBase", "Number:int");
            a.item("ValueAxisMinimumValue", "Number:double");
            a.item("ValueAxisMaximumValue", "Number:double");
            a.item("ValueAxisMinorInterval", "Number:double");
            a.item("RadiusExtent", "Number:double");
            a.item("StartAngle", "Number:double");
            a.item("SliceLabelContentSeparator", "String");
            a.item("SliceLabelContentMode", "ExportedType:string:RadialLabelMode");
            a.item("SliceLabelContentMode@names", "Auto;Normal;Value;Percentage;ValueAndPercentage;Label;LabelAndValue;LabelAndPercentage;LabelAndValueAndPercentage");
            a.item("LegendSliceLabelContentMode", "ExportedType:string:RadialLabelMode");
            a.item("LegendSliceLabelContentMode@names", "Auto;Normal;Value;Percentage;ValueAndPercentage;Label;LabelAndValue;LabelAndPercentage;LabelAndValueAndPercentage");
            a.item("AngleAxisFavorLabellingScaleEnd", "Boolean");
            a.item("ValueAxisAbbreviateLargeNumbers", "Boolean");
            a.item("MarkerCollision", "ExportedType:string:CollisionAvoidanceType");
            a.item("MarkerCollision@names", "None;Omit;Fade;OmitAndShift;FadeAndShift");
        }
        static d(a) {
            DataPieBaseChartDescriptionMetadata.b(a);
            a.ad("DataPieBaseChart", DataPieBaseChartDescriptionMetadata.a);
        }
    }
    DataPieBaseChartDescriptionMetadata.$t = /*@__PURE__*/ markType(DataPieBaseChartDescriptionMetadata, 'DataPieBaseChartDescriptionMetadata');
    DataPieBaseChartDescriptionMetadata.a = null;
    return DataPieBaseChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataPieChartDescription = /*@__PURE__*/ (() => {
    class DataPieChartDescription extends DataPieBaseChartDescription {
        get_type() {
            return "DataPieChart";
        }
        constructor() {
            super();
            this.xt = 0;
            this.xu = 0;
            this.x1 = null;
            this.x4 = null;
            this.xy = null;
            this.xr = false;
            this.x2 = null;
            this.x3 = null;
            this.x0 = null;
            this.x5 = null;
            this.xz = null;
            this.xx = null;
        }
        get transitionInDuration() {
            return this.xt;
        }
        set transitionInDuration(a) {
            this.xt = a;
            this.g("TransitionInDuration");
        }
        get transitionOutDuration() {
            return this.xu;
        }
        set transitionOutDuration(a) {
            this.xu = a;
            this.g("TransitionOutDuration");
        }
        get transitionInEasingFunctionRef() {
            return this.x1;
        }
        set transitionInEasingFunctionRef(a) {
            this.x1 = a;
            this.g("TransitionInEasingFunctionRef");
        }
        get transitionOutEasingFunctionRef() {
            return this.x4;
        }
        set transitionOutEasingFunctionRef(a) {
            this.x4 = a;
            this.g("TransitionOutEasingFunctionRef");
        }
        get chartType() {
            return this.xy;
        }
        set chartType(a) {
            this.xy = a;
            this.g("ChartType");
        }
        get isTransitionInEnabled() {
            return this.xr;
        }
        set isTransitionInEnabled(a) {
            this.xr = a;
            this.g("IsTransitionInEnabled");
        }
        get transitionInMode() {
            return this.x2;
        }
        set transitionInMode(a) {
            this.x2 = a;
            this.g("TransitionInMode");
        }
        get transitionInSpeedType() {
            return this.x3;
        }
        set transitionInSpeedType(a) {
            this.x3 = a;
            this.g("TransitionInSpeedType");
        }
        get tooltipTemplateRef() {
            return this.x0;
        }
        set tooltipTemplateRef(a) {
            this.x0 = a;
            this.g("TooltipTemplateRef");
        }
        get width() {
            return this.x5;
        }
        set width(a) {
            this.x5 = a;
            this.g("Width");
        }
        get height() {
            return this.xz;
        }
        set height(a) {
            this.xz = a;
            this.g("Height");
        }
        get background() {
            return this.xx;
        }
        set background(a) {
            this.xx = a;
            this.g("Background");
        }
    }
    DataPieChartDescription.$t = /*@__PURE__*/ markType(DataPieChartDescription, 'DataPieChartDescription', DataPieBaseChartDescription.$);
    return DataPieChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataPieChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataPieChartDescriptionMetadata extends Base {
        static b(a) {
            if (DataPieChartDescriptionMetadata.a == null) {
                DataPieChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataPieChartDescriptionMetadata.c(DataPieChartDescriptionMetadata.a);
            }
            if (a.k(DataPieChartDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataPieChartDescriptionMetadata.a);
        }
        static c(a) {
            DataPieBaseChartDescriptionMetadata.c(a);
            a.item("TransitionInDuration", "Number:int");
            a.item("TransitionOutDuration", "Number:int");
            a.item("TransitionInEasingFunctionRef", "(w:TransitionInEasingFunction,wf:TransitionInEasingFunction)MethodRef");
            a.item("TransitionOutEasingFunctionRef", "(w:TransitionOutEasingFunction,wf:TransitionOutEasingFunction)MethodRef");
            a.item("ChartType", "ExportedType:string:DataPieChartType");
            a.item("ChartType@names", "Auto;PieSingleRing");
            a.item("IsTransitionInEnabled", "Boolean");
            a.item("TransitionInMode", "ExportedType:string:CategoryTransitionInMode");
            a.item("TransitionInMode@names", "Auto;FromZero;SweepFromLeft;SweepFromRight;SweepFromTop;SweepFromBottom;SweepFromCenter;AccordionFromLeft;AccordionFromRight;AccordionFromTop;AccordionFromBottom;Expand;SweepFromCategoryAxisMinimum;SweepFromCategoryAxisMaximum;SweepFromValueAxisMinimum;SweepFromValueAxisMaximum;AccordionFromCategoryAxisMinimum;AccordionFromCategoryAxisMaximum;AccordionFromValueAxisMinimum;AccordionFromValueAxisMaximum;FromParent");
            a.item("TransitionInSpeedType", "ExportedType:string:TransitionInSpeedType");
            a.item("TransitionInSpeedType@names", "Auto;Normal;ValueScaled;IndexScaled;Random");
            DataPieChartDescriptionMetadata.e(a);
        }
        static d(a) {
            DataPieChartDescriptionMetadata.b(a);
            a.ae("DataPieChart", () => new DataPieChartDescription());
            a.ad("DataPieChart", DataPieChartDescriptionMetadata.a);
        }
        static e(a) {
            a.item("TooltipTemplateRef", "(w:ToolTip)DataRef:String");
            a.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamDataPieChart");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
    }
    DataPieChartDescriptionMetadata.$t = /*@__PURE__*/ markType(DataPieChartDescriptionMetadata, 'DataPieChartDescriptionMetadata');
    DataPieChartDescriptionMetadata.a = null;
    return DataPieChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ProportionalCategoryAngleAxisDescription = /*@__PURE__*/ (() => {
    class ProportionalCategoryAngleAxisDescription extends CategoryAngleAxisDescription {
        get_type() {
            return "ProportionalCategoryAngleAxis";
        }
        constructor() {
            super();
            this.el = null;
            this.eh = 0;
            this.ek = null;
            this.ej = null;
        }
        get valueMemberPath() {
            return this.el;
        }
        set valueMemberPath(a) {
            this.el = a;
            this.g("ValueMemberPath");
        }
        get othersCategoryThreshold() {
            return this.eh;
        }
        set othersCategoryThreshold(a) {
            this.eh = a;
            this.g("OthersCategoryThreshold");
        }
        get othersCategoryType() {
            return this.ek;
        }
        set othersCategoryType(a) {
            this.ek = a;
            this.g("OthersCategoryType");
        }
        get othersCategoryText() {
            return this.ej;
        }
        set othersCategoryText(a) {
            this.ej = a;
            this.g("OthersCategoryText");
        }
    }
    ProportionalCategoryAngleAxisDescription.$t = /*@__PURE__*/ markType(ProportionalCategoryAngleAxisDescription, 'ProportionalCategoryAngleAxisDescription', CategoryAngleAxisDescription.$);
    return ProportionalCategoryAngleAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ProportionalCategoryAngleAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class ProportionalCategoryAngleAxisDescriptionMetadata extends Base {
        static b(a) {
            if (ProportionalCategoryAngleAxisDescriptionMetadata.a == null) {
                ProportionalCategoryAngleAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ProportionalCategoryAngleAxisDescriptionMetadata.c(ProportionalCategoryAngleAxisDescriptionMetadata.a);
            }
            if (a.k(ProportionalCategoryAngleAxisDescriptionMetadata.a)) {
                return;
            }
            a.ac(ProportionalCategoryAngleAxisDescriptionMetadata.a);
        }
        static c(a) {
            CategoryAngleAxisDescriptionMetadata.c(a);
            a.item("ValueMemberPath", "String");
            a.item("OthersCategoryThreshold", "Number:double");
            a.item("OthersCategoryType", "ExportedType:string:OthersCategoryType");
            a.item("OthersCategoryType@names", "Number;Percent");
            a.item("OthersCategoryText", "String");
        }
        static d(a) {
            ProportionalCategoryAngleAxisDescriptionMetadata.b(a);
            a.ae("ProportionalCategoryAngleAxis", () => new ProportionalCategoryAngleAxisDescription());
            a.ad("ProportionalCategoryAngleAxis", ProportionalCategoryAngleAxisDescriptionMetadata.a);
        }
    }
    ProportionalCategoryAngleAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(ProportionalCategoryAngleAxisDescriptionMetadata, 'ProportionalCategoryAngleAxisDescriptionMetadata');
    ProportionalCategoryAngleAxisDescriptionMetadata.a = null;
    return ProportionalCategoryAngleAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ProportionalCategoryAngleAxisDescriptionModule = /*@__PURE__*/ (() => {
    class ProportionalCategoryAngleAxisDescriptionModule extends Base {
        static register(a) {
            CategoryAngleAxisDescriptionModule.register(a);
            ProportionalCategoryAngleAxisDescriptionMetadata.d(a);
        }
    }
    ProportionalCategoryAngleAxisDescriptionModule.$t = /*@__PURE__*/ markType(ProportionalCategoryAngleAxisDescriptionModule, 'ProportionalCategoryAngleAxisDescriptionModule');
    return ProportionalCategoryAngleAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataPieChartCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataPieChartCoreDescriptionModule extends Base {
        static register(a) {
            DataPieChartDescriptionMetadata.d(a);
            ProportionalCategoryAngleAxisDescriptionModule.register(a);
            NumericRadiusAxisDescriptionModule.register(a);
        }
    }
    DataPieChartCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataPieChartCoreDescriptionModule, 'DataPieChartCoreDescriptionModule');
    return DataPieChartCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataPieChartDescriptionModule = /*@__PURE__*/ (() => {
    class DataPieChartDescriptionModule extends Base {
        static register(a) {
            DataPieChartCoreDescriptionModule.register(a);
            RadialPieSeriesDescriptionModule.register(a);
            CrosshairLayerDescriptionModule.register(a);
            CalloutLayerDescriptionModule.register(a);
            ItemToolTipLayerDescriptionModule.register(a);
            CategoryToolTipLayerDescriptionModule.register(a);
            CategoryHighlightLayerDescriptionModule.register(a);
            CategoryItemHighlightLayerDescriptionModule.register(a);
            DataToolTipLayerDescriptionModule.register(a);
            NumberAbbreviatorDescriptionModule.register(a);
            DataChartInteractivityDescriptionModule.register(a);
            DataChartAnnotationDescriptionModule.register(a);
        }
    }
    DataPieChartDescriptionModule.$t = /*@__PURE__*/ markType(DataPieChartDescriptionModule, 'DataPieChartDescriptionModule');
    return DataPieChartDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataPieChartToolbarDescriptionModule = /*@__PURE__*/ (() => {
    class DataPieChartToolbarDescriptionModule extends Base {
        static register(a) {
            DataChartToolbarIconsDescriptionModule.register(a);
        }
    }
    DataPieChartToolbarDescriptionModule.$t = /*@__PURE__*/ markType(DataPieChartToolbarDescriptionModule, 'DataPieChartToolbarDescriptionModule');
    return DataPieChartToolbarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSpecialRowDescription = /*@__PURE__*/ (() => {
    class DataSourceSpecialRowDescription extends Description {
        get_type() {
            return "DataSourceSpecialRow";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.p = null;
            this.m = null;
            this.k = 0;
            this.h = null;
        }
        get rowType() {
            return this.p;
        }
        set rowType(a) {
            this.p = a;
            this.g("RowType");
        }
        get targetRow() {
            return this.m;
        }
        set targetRow(a) {
            this.m = a;
            this.g("TargetRow");
        }
        get level() {
            return this.k;
        }
        set level(a) {
            this.k = a;
            this.g("Level");
        }
        get summaryResults() {
            return this.h;
        }
        set summaryResults(a) {
            this.h = a;
            this.g("SummaryResults");
        }
    }
    DataSourceSpecialRowDescription.$t = /*@__PURE__*/ markType(DataSourceSpecialRowDescription, 'DataSourceSpecialRowDescription', Description.$);
    DataSourceSpecialRowDescription.__marshalByValue = true;
    DataSourceSpecialRowDescription.__marshalByValueAlias = "DataSourceSpecialRow";
    return DataSourceSpecialRowDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSpecialRowDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataSourceSpecialRowDescriptionMetadata extends Base {
        static b(a) {
            if (DataSourceSpecialRowDescriptionMetadata.a == null) {
                DataSourceSpecialRowDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataSourceSpecialRowDescriptionMetadata.c(DataSourceSpecialRowDescriptionMetadata.a);
            }
            if (a.k(DataSourceSpecialRowDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataSourceSpecialRowDescriptionMetadata.a);
            DataGridSummaryResultDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("RowType", "ExportedType:string:DataSourceRowType");
            a.item("RowType@names", "Normal;SectionHeader;SectionFooter;ShiftedRow;SummaryRowRoot;SummaryRowSection;Custom");
            a.item("TargetRow", "Unknown");
            a.item("Level", "Number:int");
            a.item("SummaryResults", "Array:DataGridSummaryResultDescription:ISummaryResult");
        }
        static d(a) {
            DataSourceSpecialRowDescriptionMetadata.b(a);
            a.ae("DataSourceSpecialRow", () => new DataSourceSpecialRowDescription());
            a.ad("DataSourceSpecialRow", DataSourceSpecialRowDescriptionMetadata.a);
        }
    }
    DataSourceSpecialRowDescriptionMetadata.$t = /*@__PURE__*/ markType(DataSourceSpecialRowDescriptionMetadata, 'DataSourceSpecialRowDescriptionMetadata');
    DataSourceSpecialRowDescriptionMetadata.a = null;
    return DataSourceSpecialRowDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DatePartDeltasDescription = /*@__PURE__*/ (() => {
    class DatePartDeltasDescription extends Description {
        get_type() {
            return "DatePartDeltas";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = 0;
            this.k = 0;
            this.m = 0;
            this.i = 0;
            this.j = 0;
            this.l = 0;
        }
        get date() {
            return this.h;
        }
        set date(a) {
            this.h = a;
            this.g("Date");
        }
        get month() {
            return this.k;
        }
        set month(a) {
            this.k = a;
            this.g("Month");
        }
        get year() {
            return this.m;
        }
        set year(a) {
            this.m = a;
            this.g("Year");
        }
        get hours() {
            return this.i;
        }
        set hours(a) {
            this.i = a;
            this.g("Hours");
        }
        get minutes() {
            return this.j;
        }
        set minutes(a) {
            this.j = a;
            this.g("Minutes");
        }
        get seconds() {
            return this.l;
        }
        set seconds(a) {
            this.l = a;
            this.g("Seconds");
        }
    }
    DatePartDeltasDescription.$t = /*@__PURE__*/ markType(DatePartDeltasDescription, 'DatePartDeltasDescription', Description.$);
    return DatePartDeltasDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DatePartDeltasDescriptionMetadata = /*@__PURE__*/ (() => {
    class DatePartDeltasDescriptionMetadata extends Base {
        static b(a) {
            if (DatePartDeltasDescriptionMetadata.a == null) {
                DatePartDeltasDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DatePartDeltasDescriptionMetadata.c(DatePartDeltasDescriptionMetadata.a);
            }
            if (a.k(DatePartDeltasDescriptionMetadata.a)) {
                return;
            }
            a.ac(DatePartDeltasDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Date", "Number:double");
            a.item("Month", "Number:double");
            a.item("Year", "Number:double");
            a.item("Hours", "Number:double");
            a.item("Minutes", "Number:double");
            a.item("Seconds", "Number:double");
        }
        static d(a) {
            DatePartDeltasDescriptionMetadata.b(a);
            a.ae("DatePartDeltas", () => new DatePartDeltasDescription());
            a.ad("DatePartDeltas", DatePartDeltasDescriptionMetadata.a);
        }
    }
    DatePartDeltasDescriptionMetadata.$t = /*@__PURE__*/ markType(DatePartDeltasDescriptionMetadata, 'DatePartDeltasDescriptionMetadata');
    DatePartDeltasDescriptionMetadata.a = null;
    return DatePartDeltasDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DatePickerDescription = /*@__PURE__*/ (() => {
    class DatePickerDescription extends Description {
        get_type() {
            return "DatePicker";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.ac = new Date();
            this.ab = new Date();
            this.av = null;
            this.az = null;
            this.aw = null;
            this.ah = 0;
            this.ax = null;
            this.ay = null;
            this.a1 = null;
            this.aa = new Date();
            this.z = new Date();
            this.ao = null;
            this.al = null;
            this.a4 = null;
            this.ai = 0;
            this.a5 = null;
            this.a6 = null;
            this.a3 = null;
            this.at = null;
            this.m = false;
            this.n = false;
            this.h = false;
            this.l = false;
            this.ap = null;
            this.aq = null;
            this.o = false;
            this.an = null;
            this.ar = null;
            this.i = false;
            this.j = false;
            this.k = false;
            this.p = false;
            this.a2 = null;
            this.as = null;
            this.a0 = null;
            this.au = null;
            this.am = null;
            this.a7 = null;
        }
        get value() {
            return this.ac;
        }
        set value(a) {
            this.ac = a;
            this.g("Value");
        }
        get today() {
            return this.ab;
        }
        set today(a) {
            this.ab = a;
            this.g("Today");
        }
        get label() {
            return this.av;
        }
        set label(a) {
            this.av = a;
            this.g("Label");
        }
        get labelTextColor() {
            return this.az;
        }
        set labelTextColor(a) {
            this.az = a;
            this.g("LabelTextColor");
        }
        get labelFontFamily() {
            return this.aw;
        }
        set labelFontFamily(a) {
            this.aw = a;
            this.g("LabelFontFamily");
        }
        get labelFontSize() {
            return this.ah;
        }
        set labelFontSize(a) {
            this.ah = a;
            this.g("LabelFontSize");
        }
        get labelFontStyle() {
            return this.ax;
        }
        set labelFontStyle(a) {
            this.ax = a;
            this.g("LabelFontStyle");
        }
        get labelFontWeight() {
            return this.ay;
        }
        set labelFontWeight(a) {
            this.ay = a;
            this.g("LabelFontWeight");
        }
        get placeholder() {
            return this.a1;
        }
        set placeholder(a) {
            this.a1 = a;
            this.g("Placeholder");
        }
        get minDate() {
            return this.aa;
        }
        set minDate(a) {
            this.aa = a;
            this.g("MinDate");
        }
        get maxDate() {
            return this.z;
        }
        set maxDate(a) {
            this.z = a;
            this.g("MaxDate");
        }
        get density() {
            return this.ao;
        }
        set density(a) {
            this.ao = a;
            this.g("Density");
        }
        get baseTheme() {
            return this.al;
        }
        set baseTheme(a) {
            this.al = a;
            this.g("BaseTheme");
        }
        get textFontFamily() {
            return this.a4;
        }
        set textFontFamily(a) {
            this.a4 = a;
            this.g("TextFontFamily");
        }
        get textFontSize() {
            return this.ai;
        }
        set textFontSize(a) {
            this.ai = a;
            this.g("TextFontSize");
        }
        get textFontStyle() {
            return this.a5;
        }
        set textFontStyle(a) {
            this.a5 = a;
            this.g("TextFontStyle");
        }
        get textFontWeight() {
            return this.a6;
        }
        set textFontWeight(a) {
            this.a6 = a;
            this.g("TextFontWeight");
        }
        get textColor() {
            return this.a3;
        }
        set textColor(a) {
            this.a3 = a;
            this.g("TextColor");
        }
        get iconColor() {
            return this.at;
        }
        set iconColor(a) {
            this.at = a;
            this.g("IconColor");
        }
        get showClearButton() {
            return this.m;
        }
        set showClearButton(a) {
            this.m = a;
            this.g("ShowClearButton");
        }
        get showTodayButton() {
            return this.n;
        }
        set showTodayButton(a) {
            this.n = a;
            this.g("ShowTodayButton");
        }
        get allowTextInput() {
            return this.h;
        }
        set allowTextInput(a) {
            this.h = a;
            this.g("AllowTextInput");
        }
        get openOnFocus() {
            return this.l;
        }
        set openOnFocus(a) {
            this.l = a;
            this.g("OpenOnFocus");
        }
        get firstDayOfWeek() {
            return this.ap;
        }
        set firstDayOfWeek(a) {
            this.ap = a;
            this.g("FirstDayOfWeek");
        }
        get firstWeekOfYear() {
            return this.aq;
        }
        set firstWeekOfYear(a) {
            this.aq = a;
            this.g("FirstWeekOfYear");
        }
        get showWeekNumbers() {
            return this.o;
        }
        set showWeekNumbers(a) {
            this.o = a;
            this.g("ShowWeekNumbers");
        }
        get dateFormat() {
            return this.an;
        }
        set dateFormat(a) {
            this.an = a;
            this.g("DateFormat");
        }
        get formatString() {
            return this.ar;
        }
        set formatString(a) {
            this.ar = a;
            this.g("FormatString");
        }
        get isDisabled() {
            return this.i;
        }
        set isDisabled(a) {
            this.i = a;
            this.g("IsDisabled");
        }
        get isFixed() {
            return this.j;
        }
        set isFixed(a) {
            this.j = a;
            this.g("IsFixed");
        }
        get openAsChild() {
            return this.k;
        }
        set openAsChild(a) {
            this.k = a;
            this.g("OpenAsChild");
        }
        get useTopLayer() {
            return this.p;
        }
        set useTopLayer(a) {
            this.p = a;
            this.g("UseTopLayer");
        }
        get selectedValueChangedRef() {
            return this.a2;
        }
        set selectedValueChangedRef(a) {
            this.a2 = a;
            this.g("SelectedValueChangedRef");
        }
        get gotFocusRef() {
            return this.as;
        }
        set gotFocusRef(a) {
            this.as = a;
            this.g("GotFocusRef");
        }
        get lostFocusRef() {
            return this.a0;
        }
        set lostFocusRef(a) {
            this.a0 = a;
            this.g("LostFocusRef");
        }
        get keyDownRef() {
            return this.au;
        }
        set keyDownRef(a) {
            this.au = a;
            this.g("KeyDownRef");
        }
        get changingRef() {
            return this.am;
        }
        set changingRef(a) {
            this.am = a;
            this.g("ChangingRef");
        }
        get valueChangeRef() {
            return this.a7;
        }
        set valueChangeRef(a) {
            this.a7 = a;
            this.g("ValueChangeRef");
        }
    }
    DatePickerDescription.$t = /*@__PURE__*/ markType(DatePickerDescription, 'DatePickerDescription', Description.$);
    return DatePickerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DatePickerDescriptionMetadata = /*@__PURE__*/ (() => {
    class DatePickerDescriptionMetadata extends Base {
        static b(a) {
            if (DatePickerDescriptionMetadata.a == null) {
                DatePickerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DatePickerDescriptionMetadata.c(DatePickerDescriptionMetadata.a);
            }
            if (a.k(DatePickerDescriptionMetadata.a)) {
                return;
            }
            a.ac(DatePickerDescriptionMetadata.a);
            SelectedValueChangedEventArgsDescriptionMetadata.d(a);
            GotFocusEventArgsDescriptionMetadata.d(a);
            LostFocusEventArgsDescriptionMetadata.d(a);
            KeyEventArgsDescriptionMetadata.d(a);
            InputChangeEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:XDatePicker");
            a.item("Value", "Date");
            a.item("Today", "Date");
            a.item("Label", "String");
            a.item("LabelTextColor", "Brush");
            a.item("LabelFontFamily", "(w:LabelFontFamily/FontFamilyTransform,xam:LabelFontFamily,wf:LabelFontFamily,web:labelTextStyle/FontFamilyTransform)String");
            a.item("LabelFontSize", "(w:LabelFontSize,xam:LabelFontSize,wf:LabelFontSize,web:labelTextStyle/FontSizeTransform)Number:double");
            a.item("LabelFontStyle", "(w:LabelFontStyle/FontStyleTransform,xam:LabelFontFamily/FontStyleTransform,wf:LabelFontFamily/FontStyleTransform,web:labelTextStyle/FontStyleTransform)String");
            a.item("LabelFontWeight", "(w:LabelFontWeight/FontWeightTransform,xam:LabelFontFamily/FontWeightTransform,wf:LabelFontFamily/FontWeightTransform,web:labelTextStyle/FontWeightTransform)String");
            a.item("Placeholder", "String");
            a.item("MinDate", "Date");
            a.item("MaxDate", "Date");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("TextFontFamily", "(w:TextFontFamily/FontFamilyTransform,xam:TextFontFamily,wf:TextFontFamily,web:textStyle/FontFamilyTransform)String");
            a.item("TextFontSize", "(w:TextFontSize,xam:TextFontSize,wf:TextFontSize,web:textStyle/FontSizeTransform)Number:double");
            a.item("TextFontStyle", "(w:TextFontStyle/FontStyleTransform,xam:TextFontFamily/FontStyleTransform,wf:TextFontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            a.item("TextFontWeight", "(w:TextFontWeight/FontWeightTransform,xam:TextFontFamily/FontWeightTransform,wf:TextFontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            a.item("TextColor", "Brush");
            a.item("IconColor", "Brush");
            a.item("ShowClearButton", "Boolean");
            a.item("ShowTodayButton", "Boolean");
            a.item("AllowTextInput", "Boolean");
            a.item("OpenOnFocus", "Boolean");
            a.item("FirstDayOfWeek", "ExportedType:string:DayOfWeek");
            a.item("FirstDayOfWeek@names", "Sunday;Monday;Tuesday;Wednesday;Thursday;Friday;Saturday");
            a.item("FirstWeekOfYear", "ExportedType:string:FirstWeek");
            a.item("FirstWeekOfYear@names", "FirstDay;FirstFullWeek;FirstFourDayWeek");
            a.item("ShowWeekNumbers", "Boolean");
            a.item("DateFormat", "ExportedType:string:DateFormats");
            a.item("DateFormat@names", "DateShort;DateLong");
            a.item("FormatString", "String");
            a.item("IsDisabled", "Boolean");
            a.item("IsFixed", "Boolean");
            a.item("OpenAsChild", "Boolean");
            a.item("UseTopLayer", "Boolean");
            a.item("SelectedValueChangedRef", "EventRef::selectedValueChanged");
            a.item("GotFocusRef", "EventRef::gotFocus");
            a.item("LostFocusRef", "EventRef::lostFocus");
            a.item("KeyDownRef", "EventRef::keyDown");
            a.item("ChangingRef", "EventRef::changing");
            a.item("ValueChangeRef", "EventRef::valueChange");
        }
        static d(a) {
            DatePickerDescriptionMetadata.b(a);
            a.ae("DatePicker", () => new DatePickerDescription());
            a.ad("DatePicker", DatePickerDescriptionMetadata.a);
        }
    }
    DatePickerDescriptionMetadata.$t = /*@__PURE__*/ markType(DatePickerDescriptionMetadata, 'DatePickerDescriptionMetadata');
    DatePickerDescriptionMetadata.a = null;
    return DatePickerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DatePickerDescriptionModule = /*@__PURE__*/ (() => {
    class DatePickerDescriptionModule extends Base {
        static register(a) {
            CalendarDescriptionModule.register(a);
            ButtonDescriptionModule.register(a);
            IconDescriptionModule.register(a);
            InputGroupDescriptionModule.register(a);
            DatePickerDescriptionMetadata.d(a);
        }
    }
    DatePickerDescriptionModule.$t = /*@__PURE__*/ markType(DatePickerDescriptionModule, 'DatePickerDescriptionModule');
    return DatePickerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateRangeDescriptorDescription = /*@__PURE__*/ (() => {
    class DateRangeDescriptorDescription extends Description {
        get_type() {
            return "DateRangeDescriptor";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.i = null;
        }
        get rangeType() {
            return this.l;
        }
        set rangeType(a) {
            this.l = a;
            this.g("RangeType");
        }
        get dateRange() {
            return this.i;
        }
        set dateRange(a) {
            this.i = a;
            this.g("DateRange");
        }
    }
    DateRangeDescriptorDescription.$t = /*@__PURE__*/ markType(DateRangeDescriptorDescription, 'DateRangeDescriptorDescription', Description.$);
    DateRangeDescriptorDescription.__marshalByValue = true;
    DateRangeDescriptorDescription.__marshalByValueAlias = "DateRangeDescriptor";
    return DateRangeDescriptorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateRangeDescriptorDescriptionMetadata = /*@__PURE__*/ (() => {
    class DateRangeDescriptorDescriptionMetadata extends Base {
        static b(a) {
            if (DateRangeDescriptorDescriptionMetadata.a == null) {
                DateRangeDescriptorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DateRangeDescriptorDescriptionMetadata.c(DateRangeDescriptorDescriptionMetadata.a);
            }
            if (a.k(DateRangeDescriptorDescriptionMetadata.a)) {
                return;
            }
            a.ac(DateRangeDescriptorDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("RangeType", "(wc:Type)ExportedType:string:DateRangeType");
            a.item("RangeType@names", "After;Before;Between;Specific;Weekdays;Weekends");
            a.item("DateRange", "Unknown");
        }
        static d(a) {
            DateRangeDescriptorDescriptionMetadata.b(a);
            a.ae("DateRangeDescriptor", () => new DateRangeDescriptorDescription());
            a.ad("DateRangeDescriptor", DateRangeDescriptorDescriptionMetadata.a);
        }
    }
    DateRangeDescriptorDescriptionMetadata.$t = /*@__PURE__*/ markType(DateRangeDescriptorDescriptionMetadata, 'DateRangeDescriptorDescriptionMetadata');
    DateRangeDescriptorDescriptionMetadata.a = null;
    return DateRangeDescriptorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DomainChartToolbarDescriptionModule = /*@__PURE__*/ (() => {
    class DomainChartToolbarDescriptionModule extends Base {
        static register(a) {
            DataChartToolbarIconsDescriptionModule.register(a);
        }
    }
    DomainChartToolbarDescriptionModule.$t = /*@__PURE__*/ markType(DomainChartToolbarDescriptionModule, 'DomainChartToolbarDescriptionModule');
    return DomainChartToolbarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoubleValueChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class DoubleValueChangedEventArgsDescription extends Description {
        get_type() {
            return "DoubleValueChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = 0;
            this.h = 0;
        }
        get oldValue() {
            return this.i;
        }
        set oldValue(a) {
            this.i = a;
            this.g("OldValue");
        }
        get newValue() {
            return this.h;
        }
        set newValue(a) {
            this.h = a;
            this.g("NewValue");
        }
    }
    DoubleValueChangedEventArgsDescription.$t = /*@__PURE__*/ markType(DoubleValueChangedEventArgsDescription, 'DoubleValueChangedEventArgsDescription', Description.$);
    return DoubleValueChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoubleValueChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DoubleValueChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DoubleValueChangedEventArgsDescriptionMetadata.a == null) {
                DoubleValueChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DoubleValueChangedEventArgsDescriptionMetadata.c(DoubleValueChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(DoubleValueChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(DoubleValueChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("OldValue", "Number:double");
            a.item("NewValue", "Number:double");
        }
        static d(a) {
            DoubleValueChangedEventArgsDescriptionMetadata.b(a);
            a.ae("DoubleValueChangedEventArgs", () => new DoubleValueChangedEventArgsDescription());
            a.ad("DoubleValueChangedEventArgs", DoubleValueChangedEventArgsDescriptionMetadata.a);
        }
    }
    DoubleValueChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DoubleValueChangedEventArgsDescriptionMetadata, 'DoubleValueChangedEventArgsDescriptionMetadata');
    DoubleValueChangedEventArgsDescriptionMetadata.a = null;
    return DoubleValueChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RingSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class RingSeriesBaseDescriptionMetadata extends Base {
        static e(a) {
            a.item("DataSourceRef", "(w:ItemsSource)DataRef:String");
            a.item("TooltipTemplateRef", "(w:ToolTip)DataRef:String");
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:TextStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:TextStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontStyle/FontStyleTransform,wf:FontStyle/FontStyleTransform,web:TextStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontStyle/FontWeightTransform,wf:FontStyle/FontWeightTransform,web:TextStyle/FontWeightTransform)String");
        }
        static b(a) {
            if (RingSeriesBaseDescriptionMetadata.a == null) {
                RingSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RingSeriesBaseDescriptionMetadata.c(RingSeriesBaseDescriptionMetadata.a);
            }
            if (a.k(RingSeriesBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(RingSeriesBaseDescriptionMetadata.a);
            PropertyUpdatedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)DataRef::object");
            a.item("ValueMemberPath", "String");
            a.item("LabelMemberPath", "String");
            a.item("LegendLabelMemberPath", "String");
            a.item("LabelsPosition", "ExportedType:string:LabelsPosition");
            a.item("LabelsPosition@names", "None;Center;InsideEnd;OutsideEnd;BestFit");
            a.item("LeaderLineVisibility", "ExportedType:string:Visibility");
            a.item("LeaderLineVisibility@names", "Visible;Collapsed");
            a.item("LeaderLineFill", "(w:LeaderLineStyle.Fill,wf:LeaderLineFill)String");
            a.item("LeaderLineStroke", "(w:LeaderLineStyle.Stroke,wf:LeaderLineStroke)String");
            a.item("LeaderLineStrokeThickness", "(w:LeaderLineStyle.StrokeThickness,wf:LeaderLineStrokeThickness)Number:double");
            a.item("LeaderLineOpacity", "(w:LeaderLineStyle.Opacity,wf:LeaderLineOpacity)Number:double");
            a.item("LeaderLineType", "ExportedType:string:LeaderLineType");
            a.item("LeaderLineType@names", "Straight;Arc;Spline");
            a.item("LeaderLineMargin", "Number:double");
            a.item("OthersCategoryThreshold", "Number:double");
            a.item("OthersCategoryType", "ExportedType:string:OthersCategoryType");
            a.item("OthersCategoryType@names", "Number;Percent");
            a.item("OthersCategoryText", "String");
            a.item("LegendRef", "(w:Legend,wf:Legend)DataRef::object");
            a.item("FormatLabelRef", "(w:FormatLabel,wf:FormatLabel)MethodRef");
            a.item("FormatLegendLabelRef", "(w:FormatLegendLabel,wf:FormatLegendLabel)MethodRef");
            a.item("LabelFormat", "String");
            a.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("OthersLabelFormat", "String");
            a.item("OthersLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("OthersLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("LegendLabelFormat", "String");
            a.item("LegendLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LegendLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("LegendOthersLabelFormat", "String");
            a.item("LegendOthersLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LegendOthersLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("LabelExtent", "Number:double");
            a.item("StartAngle", "Number:double");
            a.item("OthersCategoryFill", "(w:OthersCategoryStyle.Fill,wf:OthersCategoryFill)String");
            a.item("OthersCategoryStroke", "(w:OthersCategoryStyle.Stroke,wf:OthersCategoryStroke)String");
            a.item("OthersCategoryStrokeThickness", "(w:OthersCategoryStyle.StrokeThickness,wf:OthersCategoryStrokeThickness)Number:double");
            a.item("OthersCategoryOpacity", "(w:OthersCategoryStyle.Opacity,wf:OthersCategoryOpacity)Number:double");
            a.item("SelectedSliceFill", "(w:SelectedStyle.Fill,wf:SelectedSliceFill)String");
            a.item("SelectedSliceStroke", "(w:SelectedStyle.Stroke,wf:SelectedSliceStroke)String");
            a.item("SelectedSliceStrokeThickness", "(w:SelectedStyle.StrokeThickness,wf:SelectedSliceStrokeThickness)Number:double");
            a.item("SelectedSliceOpacity", "(w:SelectedStyle.Opacity,wf:SelectedSliceOpacity)Number:double");
            a.item("Brushes", "BrushCollection:string");
            a.item("Outlines", "BrushCollection:string");
            a.item("LabelOuterColor", "Brush");
            a.item("LabelInnerColor", "Brush");
            a.item("IsSurfaceInteractionDisabled", "Boolean");
            a.item("RadiusFactor", "Number:double");
            a.item("PropertyUpdatedRef", "EventRef::propertyUpdated");
            RingSeriesBaseDescriptionMetadata.e(a);
        }
        static d(a) {
            RingSeriesBaseDescriptionMetadata.b(a);
            a.ad("RingSeriesBase", RingSeriesBaseDescriptionMetadata.a);
        }
    }
    RingSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(RingSeriesBaseDescriptionMetadata, 'RingSeriesBaseDescriptionMetadata');
    RingSeriesBaseDescriptionMetadata.a = null;
    return RingSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RingDescription = /*@__PURE__*/ (() => {
    class RingDescription extends Description {
        get_type() {
            return "Ring";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.r = 0;
            this.n = 0;
            this.l = null;
            this.h = null;
            this.j = null;
            this.o = 0;
        }
        get index() {
            return this.r;
        }
        set index(a) {
            this.r = a;
            this.g("Index");
        }
        get innerExtend() {
            return this.n;
        }
        set innerExtend(a) {
            this.n = a;
            this.g("InnerExtend");
        }
        get controlSize() {
            return this.l;
        }
        set controlSize(a) {
            this.l = a;
            this.g("ControlSize");
        }
        get center() {
            return this.h;
        }
        set center(a) {
            this.h = a;
            this.g("Center");
        }
        get ringSeries() {
            return this.j;
        }
        set ringSeries(a) {
            this.j = a;
            this.g("RingSeries");
        }
        get ringBreadth() {
            return this.o;
        }
        set ringBreadth(a) {
            this.o = a;
            this.g("RingBreadth");
        }
    }
    RingDescription.$t = /*@__PURE__*/ markType(RingDescription, 'RingDescription', Description.$);
    return RingDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RingDescriptionMetadata = /*@__PURE__*/ (() => {
    class RingDescriptionMetadata extends Base {
        static b(a) {
            if (RingDescriptionMetadata.a == null) {
                RingDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RingDescriptionMetadata.c(RingDescriptionMetadata.a);
            }
            if (a.k(RingDescriptionMetadata.a)) {
                return;
            }
            a.ac(RingDescriptionMetadata.a);
            RingSeriesBaseDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Index", "Number:int");
            a.item("InnerExtend", "Number:double");
            a.item("ControlSize", "Size");
            a.item("Center", "Point");
            a.item("RingSeries", "ExportedType:RingSeriesBase");
            a.item("RingBreadth", "Number:double");
        }
        static d(a) {
            RingDescriptionMetadata.b(a);
            a.ae("Ring", () => new RingDescription());
            a.ad("Ring", RingDescriptionMetadata.a);
        }
    }
    RingDescriptionMetadata.$t = /*@__PURE__*/ markType(RingDescriptionMetadata, 'RingDescriptionMetadata');
    RingDescriptionMetadata.a = null;
    return RingDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RingSeriesBaseDescription = /*@__PURE__*/ (() => {
    class RingSeriesBaseDescription extends Description {
        get tooltipTemplateRef() {
            return this.bk;
        }
        set tooltipTemplateRef(a) {
            this.bk = a;
            this.g("TooltipTemplateRef");
        }
        get fontFamily() {
            return this.au;
        }
        set fontFamily(a) {
            this.au = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.v;
        }
        set fontSize(a) {
            this.v = a;
            this.g("FontSize");
        }
        get fontWeight() {
            return this.aw;
        }
        set fontWeight(a) {
            this.aw = a;
            this.g("FontWeight");
        }
        get fontStyle() {
            return this.av;
        }
        set fontStyle(a) {
            this.av = a;
            this.g("FontStyle");
        }
        get_type() {
            return "RingSeriesBase";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.bk = null;
            this.au = null;
            this.v = 0;
            this.aw = null;
            this.av = null;
            this.at = null;
            this.bl = null;
            this.a1 = null;
            this.a9 = null;
            this.a3 = null;
            this.a7 = null;
            this.a4 = null;
            this.a5 = null;
            this.z = 0;
            this.y = 0;
            this.a6 = null;
            this.x = 0;
            this.ac = 0;
            this.bf = null;
            this.be = null;
            this.bb = null;
            this.ax = null;
            this.ay = null;
            this.az = null;
            this.i = null;
            this.bg = null;
            this.l = null;
            this.a8 = null;
            this.j = null;
            this.ba = null;
            this.k = null;
            this.w = 0;
            this.ag = 0;
            this.bc = null;
            this.bd = null;
            this.ab = 0;
            this.aa = 0;
            this.bi = null;
            this.bj = null;
            this.af = 0;
            this.ae = 0;
            this.h = null;
            this.m = null;
            this.a2 = null;
            this.a0 = null;
            this.t = false;
            this.ad = 0;
            this.bh = null;
        }
        get dataSourceRef() {
            return this.at;
        }
        set dataSourceRef(a) {
            this.at = a;
            this.g("DataSourceRef");
        }
        get valueMemberPath() {
            return this.bl;
        }
        set valueMemberPath(a) {
            this.bl = a;
            this.g("ValueMemberPath");
        }
        get labelMemberPath() {
            return this.a1;
        }
        set labelMemberPath(a) {
            this.a1 = a;
            this.g("LabelMemberPath");
        }
        get legendLabelMemberPath() {
            return this.a9;
        }
        set legendLabelMemberPath(a) {
            this.a9 = a;
            this.g("LegendLabelMemberPath");
        }
        get labelsPosition() {
            return this.a3;
        }
        set labelsPosition(a) {
            this.a3 = a;
            this.g("LabelsPosition");
        }
        get leaderLineVisibility() {
            return this.a7;
        }
        set leaderLineVisibility(a) {
            this.a7 = a;
            this.g("LeaderLineVisibility");
        }
        get leaderLineFill() {
            return this.a4;
        }
        set leaderLineFill(a) {
            this.a4 = a;
            this.g("LeaderLineFill");
        }
        get leaderLineStroke() {
            return this.a5;
        }
        set leaderLineStroke(a) {
            this.a5 = a;
            this.g("LeaderLineStroke");
        }
        get leaderLineStrokeThickness() {
            return this.z;
        }
        set leaderLineStrokeThickness(a) {
            this.z = a;
            this.g("LeaderLineStrokeThickness");
        }
        get leaderLineOpacity() {
            return this.y;
        }
        set leaderLineOpacity(a) {
            this.y = a;
            this.g("LeaderLineOpacity");
        }
        get leaderLineType() {
            return this.a6;
        }
        set leaderLineType(a) {
            this.a6 = a;
            this.g("LeaderLineType");
        }
        get leaderLineMargin() {
            return this.x;
        }
        set leaderLineMargin(a) {
            this.x = a;
            this.g("LeaderLineMargin");
        }
        get othersCategoryThreshold() {
            return this.ac;
        }
        set othersCategoryThreshold(a) {
            this.ac = a;
            this.g("OthersCategoryThreshold");
        }
        get othersCategoryType() {
            return this.bf;
        }
        set othersCategoryType(a) {
            this.bf = a;
            this.g("OthersCategoryType");
        }
        get othersCategoryText() {
            return this.be;
        }
        set othersCategoryText(a) {
            this.be = a;
            this.g("OthersCategoryText");
        }
        get legendRef() {
            return this.bb;
        }
        set legendRef(a) {
            this.bb = a;
            this.g("LegendRef");
        }
        get formatLabelRef() {
            return this.ax;
        }
        set formatLabelRef(a) {
            this.ax = a;
            this.g("FormatLabelRef");
        }
        get formatLegendLabelRef() {
            return this.ay;
        }
        set formatLegendLabelRef(a) {
            this.ay = a;
            this.g("FormatLegendLabelRef");
        }
        get labelFormat() {
            return this.az;
        }
        set labelFormat(a) {
            this.az = a;
            this.g("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.i;
        }
        set labelFormatSpecifiers(a) {
            this.i = a;
            this.g("LabelFormatSpecifiers");
        }
        get othersLabelFormat() {
            return this.bg;
        }
        set othersLabelFormat(a) {
            this.bg = a;
            this.g("OthersLabelFormat");
        }
        get othersLabelFormatSpecifiers() {
            return this.l;
        }
        set othersLabelFormatSpecifiers(a) {
            this.l = a;
            this.g("OthersLabelFormatSpecifiers");
        }
        get legendLabelFormat() {
            return this.a8;
        }
        set legendLabelFormat(a) {
            this.a8 = a;
            this.g("LegendLabelFormat");
        }
        get legendLabelFormatSpecifiers() {
            return this.j;
        }
        set legendLabelFormatSpecifiers(a) {
            this.j = a;
            this.g("LegendLabelFormatSpecifiers");
        }
        get legendOthersLabelFormat() {
            return this.ba;
        }
        set legendOthersLabelFormat(a) {
            this.ba = a;
            this.g("LegendOthersLabelFormat");
        }
        get legendOthersLabelFormatSpecifiers() {
            return this.k;
        }
        set legendOthersLabelFormatSpecifiers(a) {
            this.k = a;
            this.g("LegendOthersLabelFormatSpecifiers");
        }
        get labelExtent() {
            return this.w;
        }
        set labelExtent(a) {
            this.w = a;
            this.g("LabelExtent");
        }
        get startAngle() {
            return this.ag;
        }
        set startAngle(a) {
            this.ag = a;
            this.g("StartAngle");
        }
        get othersCategoryFill() {
            return this.bc;
        }
        set othersCategoryFill(a) {
            this.bc = a;
            this.g("OthersCategoryFill");
        }
        get othersCategoryStroke() {
            return this.bd;
        }
        set othersCategoryStroke(a) {
            this.bd = a;
            this.g("OthersCategoryStroke");
        }
        get othersCategoryStrokeThickness() {
            return this.ab;
        }
        set othersCategoryStrokeThickness(a) {
            this.ab = a;
            this.g("OthersCategoryStrokeThickness");
        }
        get othersCategoryOpacity() {
            return this.aa;
        }
        set othersCategoryOpacity(a) {
            this.aa = a;
            this.g("OthersCategoryOpacity");
        }
        get selectedSliceFill() {
            return this.bi;
        }
        set selectedSliceFill(a) {
            this.bi = a;
            this.g("SelectedSliceFill");
        }
        get selectedSliceStroke() {
            return this.bj;
        }
        set selectedSliceStroke(a) {
            this.bj = a;
            this.g("SelectedSliceStroke");
        }
        get selectedSliceStrokeThickness() {
            return this.af;
        }
        set selectedSliceStrokeThickness(a) {
            this.af = a;
            this.g("SelectedSliceStrokeThickness");
        }
        get selectedSliceOpacity() {
            return this.ae;
        }
        set selectedSliceOpacity(a) {
            this.ae = a;
            this.g("SelectedSliceOpacity");
        }
        get brushes() {
            return this.h;
        }
        set brushes(a) {
            this.h = a;
            this.g("Brushes");
        }
        get outlines() {
            return this.m;
        }
        set outlines(a) {
            this.m = a;
            this.g("Outlines");
        }
        get labelOuterColor() {
            return this.a2;
        }
        set labelOuterColor(a) {
            this.a2 = a;
            this.g("LabelOuterColor");
        }
        get labelInnerColor() {
            return this.a0;
        }
        set labelInnerColor(a) {
            this.a0 = a;
            this.g("LabelInnerColor");
        }
        get isSurfaceInteractionDisabled() {
            return this.t;
        }
        set isSurfaceInteractionDisabled(a) {
            this.t = a;
            this.g("IsSurfaceInteractionDisabled");
        }
        get radiusFactor() {
            return this.ad;
        }
        set radiusFactor(a) {
            this.ad = a;
            this.g("RadiusFactor");
        }
        get propertyUpdatedRef() {
            return this.bh;
        }
        set propertyUpdatedRef(a) {
            this.bh = a;
            this.g("PropertyUpdatedRef");
        }
    }
    RingSeriesBaseDescription.$t = /*@__PURE__*/ markType(RingSeriesBaseDescription, 'RingSeriesBaseDescription', Description.$);
    return RingSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RingSeriesDescription = /*@__PURE__*/ (() => {
    class RingSeriesDescription extends RingSeriesBaseDescription {
        get_type() {
            return "RingSeries";
        }
        constructor() {
            super();
            this.cg = null;
        }
        get ring() {
            return this.cg;
        }
        set ring(a) {
            this.cg = a;
            this.g("Ring");
        }
    }
    RingSeriesDescription.$t = /*@__PURE__*/ markType(RingSeriesDescription, 'RingSeriesDescription', RingSeriesBaseDescription.$);
    return RingSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RingSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RingSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RingSeriesDescriptionMetadata.a == null) {
                RingSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RingSeriesDescriptionMetadata.c(RingSeriesDescriptionMetadata.a);
            }
            if (a.k(RingSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(RingSeriesDescriptionMetadata.a);
            RingDescriptionMetadata.d(a);
        }
        static c(a) {
            RingSeriesBaseDescriptionMetadata.c(a);
            a.item("Ring", "ExportedType:Ring");
        }
        static d(a) {
            RingSeriesDescriptionMetadata.b(a);
            a.ae("RingSeries", () => new RingSeriesDescription());
            a.ad("RingSeries", RingSeriesDescriptionMetadata.a);
        }
    }
    RingSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RingSeriesDescriptionMetadata, 'RingSeriesDescriptionMetadata');
    RingSeriesDescriptionMetadata.a = null;
    return RingSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RingSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class RingSeriesDescriptionModule extends Base {
        static register(a) {
            RingSeriesDescriptionMetadata.d(a);
        }
    }
    RingSeriesDescriptionModule.$t = /*@__PURE__*/ markType(RingSeriesDescriptionModule, 'RingSeriesDescriptionModule');
    return RingSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SliceClickEventArgsDescription = /*@__PURE__*/ (() => {
    class SliceClickEventArgsDescription extends Description {
        get_type() {
            return "SliceClickEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = false;
            this.h = false;
            this.l = null;
        }
        get isSelected() {
            return this.i;
        }
        set isSelected(a) {
            this.i = a;
            this.g("IsSelected");
        }
        get isExploded() {
            return this.h;
        }
        set isExploded(a) {
            this.h = a;
            this.g("IsExploded");
        }
        get originalEventRef() {
            return this.l;
        }
        set originalEventRef(a) {
            this.l = a;
            this.g("OriginalEventRef");
        }
    }
    SliceClickEventArgsDescription.$t = /*@__PURE__*/ markType(SliceClickEventArgsDescription, 'SliceClickEventArgsDescription', Description.$);
    return SliceClickEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SliceClickEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SliceClickEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SliceClickEventArgsDescriptionMetadata.a == null) {
                SliceClickEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SliceClickEventArgsDescriptionMetadata.c(SliceClickEventArgsDescriptionMetadata.a);
            }
            if (a.k(SliceClickEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(SliceClickEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("IsSelected", "Boolean");
            a.item("IsExploded", "Boolean");
            a.item("OriginalEventRef", "(w:OriginalEvent,wf:OriginalEvent)DataRef");
        }
        static d(a) {
            SliceClickEventArgsDescriptionMetadata.b(a);
            a.ae("SliceClickEventArgs", () => new SliceClickEventArgsDescription());
            a.ad("SliceClickEventArgs", SliceClickEventArgsDescriptionMetadata.a);
        }
    }
    SliceClickEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SliceClickEventArgsDescriptionMetadata, 'SliceClickEventArgsDescriptionMetadata');
    SliceClickEventArgsDescriptionMetadata.a = null;
    return SliceClickEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HoleDimensionsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class HoleDimensionsChangedEventArgsDescription extends Description {
        get_type() {
            return "HoleDimensionsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    HoleDimensionsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(HoleDimensionsChangedEventArgsDescription, 'HoleDimensionsChangedEventArgsDescription', Description.$);
    return HoleDimensionsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HoleDimensionsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class HoleDimensionsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (HoleDimensionsChangedEventArgsDescriptionMetadata.a == null) {
                HoleDimensionsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HoleDimensionsChangedEventArgsDescriptionMetadata.c(HoleDimensionsChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(HoleDimensionsChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(HoleDimensionsChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            HoleDimensionsChangedEventArgsDescriptionMetadata.b(a);
            a.ae("HoleDimensionsChangedEventArgs", () => new HoleDimensionsChangedEventArgsDescription());
            a.ad("HoleDimensionsChangedEventArgs", HoleDimensionsChangedEventArgsDescriptionMetadata.a);
        }
    }
    HoleDimensionsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(HoleDimensionsChangedEventArgsDescriptionMetadata, 'HoleDimensionsChangedEventArgsDescriptionMetadata');
    HoleDimensionsChangedEventArgsDescriptionMetadata.a = null;
    return HoleDimensionsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoughnutChartDescription = /*@__PURE__*/ (() => {
    class DoughnutChartDescription extends Description {
        get background() {
            return this.z;
        }
        set background(a) {
            this.z = a;
            this.g("Background");
        }
        get_type() {
            return "DoughnutChart";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.z = null;
            this.k = false;
            this.l = false;
            this.j = false;
            this.h = null;
            this.q = 0;
            this.ab = null;
            this.ac = null;
            this.t = 0;
            this.s = 0;
            this.r = 0;
            this.p = 0;
            this.ad = null;
            this.aa = null;
        }
        get allowSliceSelection() {
            return this.k;
        }
        set allowSliceSelection(a) {
            this.k = a;
            this.g("AllowSliceSelection");
        }
        get isSurfaceInteractionDisabled() {
            return this.l;
        }
        set isSurfaceInteractionDisabled(a) {
            this.l = a;
            this.g("IsSurfaceInteractionDisabled");
        }
        get allowSliceExplosion() {
            return this.j;
        }
        set allowSliceExplosion(a) {
            this.j = a;
            this.g("AllowSliceExplosion");
        }
        get series() {
            return this.h;
        }
        set series(a) {
            this.h = a;
            this.g("Series");
        }
        get innerExtent() {
            return this.q;
        }
        set innerExtent(a) {
            this.q = a;
            this.g("InnerExtent");
        }
        get selectedSliceFill() {
            return this.ab;
        }
        set selectedSliceFill(a) {
            this.ab = a;
            this.g("SelectedSliceFill");
        }
        get selectedSliceStroke() {
            return this.ac;
        }
        set selectedSliceStroke(a) {
            this.ac = a;
            this.g("SelectedSliceStroke");
        }
        get selectedSliceStrokeThickness() {
            return this.t;
        }
        set selectedSliceStrokeThickness(a) {
            this.t = a;
            this.g("SelectedSliceStrokeThickness");
        }
        get selectedSliceOpacity() {
            return this.s;
        }
        set selectedSliceOpacity(a) {
            this.s = a;
            this.g("SelectedSliceOpacity");
        }
        get pixelScalingRatio() {
            return this.r;
        }
        set pixelScalingRatio(a) {
            this.r = a;
            this.g("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.p;
        }
        set actualPixelScalingRatio(a) {
            this.p = a;
            this.g("ActualPixelScalingRatio");
        }
        get sliceClickRef() {
            return this.ad;
        }
        set sliceClickRef(a) {
            this.ad = a;
            this.g("SliceClickRef");
        }
        get holeDimensionsChangedRef() {
            return this.aa;
        }
        set holeDimensionsChangedRef(a) {
            this.aa = a;
            this.g("HoleDimensionsChangedRef");
        }
    }
    DoughnutChartDescription.$t = /*@__PURE__*/ markType(DoughnutChartDescription, 'DoughnutChartDescription', Description.$);
    return DoughnutChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoughnutChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class DoughnutChartDescriptionMetadata extends Base {
        static e(a) {
            a.item("DataSourceRef", "(w:ItemsSource)DataRef:String");
            a.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamDoughnutChart");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
        }
        static b(a) {
            if (DoughnutChartDescriptionMetadata.a == null) {
                DoughnutChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DoughnutChartDescriptionMetadata.c(DoughnutChartDescriptionMetadata.a);
            }
            if (a.k(DoughnutChartDescriptionMetadata.a)) {
                return;
            }
            a.ac(DoughnutChartDescriptionMetadata.a);
            SliceClickEventArgsDescriptionMetadata.d(a);
            HoleDimensionsChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("AllowSliceSelection", "Boolean");
            a.item("IsSurfaceInteractionDisabled", "Boolean");
            a.item("AllowSliceExplosion", "Boolean");
            a.item("Series", "Collection:RingSeriesBase:RingSeriesCollection:RingSeriesBase");
            a.item("InnerExtent", "Number:double");
            a.item("SelectedSliceFill", "(w:SelectedStyle.Fill,wf:SelectedSliceFill)String");
            a.item("SelectedSliceStroke", "(w:SelectedStyle.Stroke,wf:SelectedSliceStroke)String");
            a.item("SelectedSliceStrokeThickness", "(w:SelectedStyle.StrokeThickness,wf:SelectedSliceStrokeThickness)Number:double");
            a.item("SelectedSliceOpacity", "(w:SelectedStyle.Opacity,wf:SelectedSliceOpacity)Number:double");
            a.item("PixelScalingRatio", "Number:double");
            a.item("ActualPixelScalingRatio", "Number:double");
            a.item("SliceClickRef", "EventRef::sliceClick");
            a.item("HoleDimensionsChangedRef", "EventRef::holeDimensionsChanged");
            DoughnutChartDescriptionMetadata.e(a);
        }
        static d(a) {
            DoughnutChartDescriptionMetadata.b(a);
            a.ae("DoughnutChart", () => new DoughnutChartDescription());
            a.ad("DoughnutChart", DoughnutChartDescriptionMetadata.a);
        }
    }
    DoughnutChartDescriptionMetadata.$t = /*@__PURE__*/ markType(DoughnutChartDescriptionMetadata, 'DoughnutChartDescriptionMetadata');
    DoughnutChartDescriptionMetadata.a = null;
    return DoughnutChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoughnutChartCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DoughnutChartCoreDescriptionModule extends Base {
        static register(a) {
            RingSeriesDescriptionModule.register(a);
            DoughnutChartDescriptionMetadata.d(a);
        }
    }
    DoughnutChartCoreDescriptionModule.$t = /*@__PURE__*/ markType(DoughnutChartCoreDescriptionModule, 'DoughnutChartCoreDescriptionModule');
    return DoughnutChartCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoughnutChartDefaultTooltipsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DoughnutChartDefaultTooltipsDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    DoughnutChartDefaultTooltipsDescriptionMetadata.$t = /*@__PURE__*/ markType(DoughnutChartDefaultTooltipsDescriptionMetadata, 'DoughnutChartDefaultTooltipsDescriptionMetadata');
    return DoughnutChartDefaultTooltipsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoughnutChartInteractivityDescriptionModule = /*@__PURE__*/ (() => {
    class DoughnutChartInteractivityDescriptionModule extends Base {
        static register(a) {
            DoughnutChartDefaultTooltipsDescriptionMetadata.register(a);
            DVInteractivityDescriptionModule.register(a);
        }
    }
    DoughnutChartInteractivityDescriptionModule.$t = /*@__PURE__*/ markType(DoughnutChartInteractivityDescriptionModule, 'DoughnutChartInteractivityDescriptionModule');
    return DoughnutChartInteractivityDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoughnutChartDescriptionModule = /*@__PURE__*/ (() => {
    class DoughnutChartDescriptionModule extends Base {
        static register(a) {
            DoughnutChartInteractivityDescriptionModule.register(a);
            DoughnutChartCoreDescriptionModule.register(a);
        }
    }
    DoughnutChartDescriptionModule.$t = /*@__PURE__*/ markType(DoughnutChartDescriptionModule, 'DoughnutChartDescriptionModule');
    return DoughnutChartDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellInfoDescription = /*@__PURE__*/ (() => {
    class CellInfoDescription extends Description {
        get_type() {
            return "CellInfo";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.eh = null;
            this.b8 = 0;
            this.y_1 = false;
            this.ac = false;
            this.m = false;
            this.k = false;
            this.w = false;
            this.ad = false;
            this.n = false;
            this.x_1 = false;
            this.h = null;
            this.s = false;
            this.z = false;
            this.aa = false;
            this.v = false;
            this.r = false;
            this.cf = 0;
            this.ec = null;
            this.bb = 0;
            this.bc = 0;
            this.ck = 0;
            this.cl = 0;
            this.a4 = 0;
            this.a2 = 0;
            this.az = 0;
            this.a7 = 0;
            this.a1 = 0;
            this.ce = 0;
            this.cm = 0;
            this.ab = false;
            this.a9 = 0;
            this.ay = 0;
            this.a6 = 0;
            this.t = false;
            this.d3 = null;
            this.ej = null;
            this.dr = null;
            this.ds = null;
            this.dk = null;
            this.dl = null;
            this.dj = null;
            this.dy = null;
            this.ed = null;
            this.d4 = null;
            this.d5 = null;
            this.ef = null;
            this.eg = null;
            this.ea = null;
            this.d6 = null;
            this.dz = null;
            this.a8 = 0;
            this.d8 = null;
            this.eb = null;
            this.ei = null;
            this.dq = null;
            this.dt = null;
            this.d0 = null;
            this.a5 = 0;
            this.d1 = null;
            this.d2 = null;
            this.dm = null;
            this.a0 = 0;
            this.dn = null;
            this.dp = null;
            this.d7 = null;
            this.ba = 0;
            this.ch = 0;
            this.cj = 0;
            this.ci = 0;
            this.cg = 0;
            this.b1 = 0;
            this.b3 = 0;
            this.b2 = 0;
            this.b0 = 0;
            this.b5 = 0;
            this.b7 = 0;
            this.b6 = 0;
            this.b4 = 0;
            this.bt = 0;
            this.bv = 0;
            this.bu = 0;
            this.bs = 0;
            this.cb = 0;
            this.cd = 0;
            this.cc = 0;
            this.ca = 0;
            this.bx = 0;
            this.bz = 0;
            this.by = 0;
            this.bw = 0;
            this.ee = null;
            this.q = false;
            this.l = false;
            this.d9 = null;
            this.dv = null;
            this.a3 = 0;
            this.dw = null;
            this.dx = null;
            this.p = false;
            this.o = false;
            this.du = null;
            this.u = false;
            this.b9 = 0;
        }
        get styleKey() {
            return this.eh;
        }
        set styleKey(a) {
            this.eh = a;
            this.g("StyleKey");
        }
        get dataRow() {
            return this.b8;
        }
        set dataRow(a) {
            this.b8 = a;
            this.g("DataRow");
        }
        get isPositionDirty() {
            return this.y_1;
        }
        set isPositionDirty(a) {
            this.y_1 = a;
            this.g("IsPositionDirty");
        }
        get isSizeDirty() {
            return this.ac;
        }
        set isSizeDirty(a) {
            this.ac = a;
            this.g("IsSizeDirty");
        }
        get isContentDirty() {
            return this.m;
        }
        set isContentDirty(a) {
            this.m = a;
            this.g("IsContentDirty");
        }
        get isBorderDirty() {
            return this.k;
        }
        set isBorderDirty(a) {
            this.k = a;
            this.g("IsBorderDirty");
        }
        get isLayerDirty() {
            return this.w;
        }
        set isLayerDirty(a) {
            this.w = a;
            this.g("IsLayerDirty");
        }
        get isStateDirty() {
            return this.ad;
        }
        set isStateDirty(a) {
            this.ad = a;
            this.g("IsStateDirty");
        }
        get isDataDirty() {
            return this.n;
        }
        set isDataDirty(a) {
            this.n = a;
            this.g("IsDataDirty");
        }
        get isPlaceholdContentNeeded() {
            return this.x_1;
        }
        set isPlaceholdContentNeeded(a) {
            this.x_1 = a;
            this.g("IsPlaceholdContentNeeded");
        }
        get actionManager() {
            return this.h;
        }
        set actionManager(a) {
            this.h = a;
            this.g("ActionManager");
        }
        get isHitTestVisible() {
            return this.s;
        }
        set isHitTestVisible(a) {
            this.s = a;
            this.g("IsHitTestVisible");
        }
        get isRowPinned() {
            return this.z;
        }
        set isRowPinned(a) {
            this.z = a;
            this.g("IsRowPinned");
        }
        get isRowSticky() {
            return this.aa;
        }
        set isRowSticky(a) {
            this.aa = a;
            this.g("IsRowSticky");
        }
        get isLastStickyRow() {
            return this.v;
        }
        set isLastStickyRow(a) {
            this.v = a;
            this.g("IsLastStickyRow");
        }
        get isFilterRow() {
            return this.r;
        }
        set isFilterRow(a) {
            this.r = a;
            this.g("IsFilterRow");
        }
        get indent() {
            return this.cf;
        }
        set indent(a) {
            this.cf = a;
            this.g("Indent");
        }
        get rowItemRef() {
            return this.ec;
        }
        set rowItemRef(a) {
            this.ec = a;
            this.g("RowItemRef");
        }
        get x() {
            return this.bb;
        }
        set x(a) {
            this.bb = a;
            this.g("X");
        }
        get y() {
            return this.bc;
        }
        set y(a) {
            this.bc = a;
            this.g("Y");
        }
        get snappedX() {
            return this.ck;
        }
        set snappedX(a) {
            this.ck = a;
            this.g("SnappedX");
        }
        get snappedY() {
            return this.cl;
        }
        set snappedY(a) {
            this.cl = a;
            this.g("SnappedY");
        }
        get editOpacity() {
            return this.a4;
        }
        set editOpacity(a) {
            this.a4 = a;
            this.g("EditOpacity");
        }
        get contentOpacity() {
            return this.a2;
        }
        set contentOpacity(a) {
            this.a2 = a;
            this.g("ContentOpacity");
        }
        get actualContentOpacity() {
            return this.az;
        }
        set actualContentOpacity(a) {
            this.az = a;
            this.g("ActualContentOpacity");
        }
        get opacity() {
            return this.a7;
        }
        set opacity(a) {
            this.a7 = a;
            this.g("Opacity");
        }
        get actualOpacity() {
            return this.a1;
        }
        set actualOpacity(a) {
            this.a1 = a;
            this.g("ActualOpacity");
        }
        get height() {
            return this.ce;
        }
        set height(a) {
            this.ce = a;
            this.g("Height");
        }
        get width() {
            return this.cm;
        }
        set width(a) {
            this.cm = a;
            this.g("Width");
        }
        get isSelected() {
            return this.ab;
        }
        set isSelected(a) {
            this.ab = a;
            this.g("IsSelected");
        }
        get selectedStatus() {
            return this.a9;
        }
        set selectedStatus(a) {
            this.a9 = a;
            this.g("SelectedStatus");
        }
        get activationStatus() {
            return this.ay;
        }
        set activationStatus(a) {
            this.ay = a;
            this.g("ActivationStatus");
        }
        get hoverStatus() {
            return this.a6;
        }
        set hoverStatus(a) {
            this.a6 = a;
            this.g("HoverStatus");
        }
        get isHoverable() {
            return this.t;
        }
        set isHoverable(a) {
            this.t = a;
            this.g("IsHoverable");
        }
        get horizontalAlignment() {
            return this.d3;
        }
        set horizontalAlignment(a) {
            this.d3 = a;
            this.g("HorizontalAlignment");
        }
        get verticalAlignment() {
            return this.ej;
        }
        set verticalAlignment(a) {
            this.ej = a;
            this.g("VerticalAlignment");
        }
        get background() {
            return this.dr;
        }
        set background(a) {
            this.dr = a;
            this.g("Background");
        }
        get border() {
            return this.ds;
        }
        set border(a) {
            this.ds = a;
            this.g("Border");
        }
        get actualBackground() {
            return this.dk;
        }
        set actualBackground(a) {
            this.dk = a;
            this.g("ActualBackground");
        }
        get actualBorder() {
            return this.dl;
        }
        set actualBorder(a) {
            this.dl = a;
            this.g("ActualBorder");
        }
        get activationBorder() {
            return this.dj;
        }
        set activationBorder(a) {
            this.dj = a;
            this.g("ActivationBorder");
        }
        get errorBorder() {
            return this.dy;
        }
        set errorBorder(a) {
            this.dy = a;
            this.g("ErrorBorder");
        }
        get selectedBackground() {
            return this.ed;
        }
        set selectedBackground(a) {
            this.ed = a;
            this.g("SelectedBackground");
        }
        get hoverBackground() {
            return this.d4;
        }
        set hoverBackground(a) {
            this.d4 = a;
            this.g("HoverBackground");
        }
        get hoverTextColor() {
            return this.d5;
        }
        set hoverTextColor(a) {
            this.d5 = a;
            this.g("HoverTextColor");
        }
        get sortIndicatorColor() {
            return this.ef;
        }
        set sortIndicatorColor(a) {
            this.ef = a;
            this.g("SortIndicatorColor");
        }
        get stickyRowBackground() {
            return this.eg;
        }
        set stickyRowBackground(a) {
            this.eg = a;
            this.g("StickyRowBackground");
        }
        get pinnedRowBackground() {
            return this.ea;
        }
        set pinnedRowBackground(a) {
            this.ea = a;
            this.g("PinnedRowBackground");
        }
        get lastStickyRowBackground() {
            return this.d6;
        }
        set lastStickyRowBackground(a) {
            this.d6 = a;
            this.g("LastStickyRowBackground");
        }
        get filterRowBackground() {
            return this.dz;
        }
        set filterRowBackground(a) {
            this.dz = a;
            this.g("FilterRowBackground");
        }
        get pinnedRowOpacity() {
            return this.a8;
        }
        set pinnedRowOpacity(a) {
            this.a8 = a;
            this.g("PinnedRowOpacity");
        }
        get originalValueRef() {
            return this.d8;
        }
        set originalValueRef(a) {
            this.d8 = a;
            this.g("OriginalValueRef");
        }
        get renderValue() {
            return this.eb;
        }
        set renderValue(a) {
            this.eb = a;
            this.g("RenderValue");
        }
        get textColor() {
            return this.ei;
        }
        set textColor(a) {
            this.ei = a;
            this.g("TextColor");
        }
        get actualTextColor() {
            return this.dq;
        }
        set actualTextColor(a) {
            this.dq = a;
            this.g("ActualTextColor");
        }
        get deletedTextColor() {
            return this.dt;
        }
        set deletedTextColor(a) {
            this.dt = a;
            this.g("DeletedTextColor");
        }
        get fontFamily() {
            return this.d0;
        }
        set fontFamily(a) {
            this.d0 = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.a5;
        }
        set fontSize(a) {
            this.a5 = a;
            this.g("FontSize");
        }
        get fontStyle() {
            return this.d1;
        }
        set fontStyle(a) {
            this.d1 = a;
            this.g("FontStyle");
        }
        get fontWeight() {
            return this.d2;
        }
        set fontWeight(a) {
            this.d2 = a;
            this.g("FontWeight");
        }
        get actualFontFamily() {
            return this.dm;
        }
        set actualFontFamily(a) {
            this.dm = a;
            this.g("ActualFontFamily");
        }
        get actualFontSize() {
            return this.a0;
        }
        set actualFontSize(a) {
            this.a0 = a;
            this.g("ActualFontSize");
        }
        get actualFontStyle() {
            return this.dn;
        }
        set actualFontStyle(a) {
            this.dn = a;
            this.g("ActualFontStyle");
        }
        get actualFontWeight() {
            return this.dp;
        }
        set actualFontWeight(a) {
            this.dp = a;
            this.g("ActualFontWeight");
        }
        get lineBreakMode() {
            return this.d7;
        }
        set lineBreakMode(a) {
            this.d7 = a;
            this.g("LineBreakMode");
        }
        get virtualizationPercentage() {
            return this.ba;
        }
        set virtualizationPercentage(a) {
            this.ba = a;
            this.g("VirtualizationPercentage");
        }
        get paddingLeft() {
            return this.ch;
        }
        set paddingLeft(a) {
            this.ch = a;
            this.g("PaddingLeft");
        }
        get paddingTop() {
            return this.cj;
        }
        set paddingTop(a) {
            this.cj = a;
            this.g("PaddingTop");
        }
        get paddingRight() {
            return this.ci;
        }
        set paddingRight(a) {
            this.ci = a;
            this.g("PaddingRight");
        }
        get paddingBottom() {
            return this.cg;
        }
        set paddingBottom(a) {
            this.cg = a;
            this.g("PaddingBottom");
        }
        get actualPaddingLeft() {
            return this.b1;
        }
        set actualPaddingLeft(a) {
            this.b1 = a;
            this.g("ActualPaddingLeft");
        }
        get actualPaddingTop() {
            return this.b3;
        }
        set actualPaddingTop(a) {
            this.b3 = a;
            this.g("ActualPaddingTop");
        }
        get actualPaddingRight() {
            return this.b2;
        }
        set actualPaddingRight(a) {
            this.b2 = a;
            this.g("ActualPaddingRight");
        }
        get actualPaddingBottom() {
            return this.b0;
        }
        set actualPaddingBottom(a) {
            this.b0 = a;
            this.g("ActualPaddingBottom");
        }
        get borderLeftWidth() {
            return this.b5;
        }
        set borderLeftWidth(a) {
            this.b5 = a;
            this.g("BorderLeftWidth");
        }
        get borderTopWidth() {
            return this.b7;
        }
        set borderTopWidth(a) {
            this.b7 = a;
            this.g("BorderTopWidth");
        }
        get borderRightWidth() {
            return this.b6;
        }
        set borderRightWidth(a) {
            this.b6 = a;
            this.g("BorderRightWidth");
        }
        get borderBottomWidth() {
            return this.b4;
        }
        set borderBottomWidth(a) {
            this.b4 = a;
            this.g("BorderBottomWidth");
        }
        get activationBorderLeftWidth() {
            return this.bt;
        }
        set activationBorderLeftWidth(a) {
            this.bt = a;
            this.g("ActivationBorderLeftWidth");
        }
        get activationBorderTopWidth() {
            return this.bv;
        }
        set activationBorderTopWidth(a) {
            this.bv = a;
            this.g("ActivationBorderTopWidth");
        }
        get activationBorderRightWidth() {
            return this.bu;
        }
        set activationBorderRightWidth(a) {
            this.bu = a;
            this.g("ActivationBorderRightWidth");
        }
        get activationBorderBottomWidth() {
            return this.bs;
        }
        set activationBorderBottomWidth(a) {
            this.bs = a;
            this.g("ActivationBorderBottomWidth");
        }
        get errorBorderLeftWidth() {
            return this.cb;
        }
        set errorBorderLeftWidth(a) {
            this.cb = a;
            this.g("ErrorBorderLeftWidth");
        }
        get errorBorderTopWidth() {
            return this.cd;
        }
        set errorBorderTopWidth(a) {
            this.cd = a;
            this.g("ErrorBorderTopWidth");
        }
        get errorBorderRightWidth() {
            return this.cc;
        }
        set errorBorderRightWidth(a) {
            this.cc = a;
            this.g("ErrorBorderRightWidth");
        }
        get errorBorderBottomWidth() {
            return this.ca;
        }
        set errorBorderBottomWidth(a) {
            this.ca = a;
            this.g("ErrorBorderBottomWidth");
        }
        get actualBorderLeftWidth() {
            return this.bx;
        }
        set actualBorderLeftWidth(a) {
            this.bx = a;
            this.g("ActualBorderLeftWidth");
        }
        get actualBorderTopWidth() {
            return this.bz;
        }
        set actualBorderTopWidth(a) {
            this.bz = a;
            this.g("ActualBorderTopWidth");
        }
        get actualBorderRightWidth() {
            return this.by;
        }
        set actualBorderRightWidth(a) {
            this.by = a;
            this.g("ActualBorderRightWidth");
        }
        get actualBorderBottomWidth() {
            return this.bw;
        }
        set actualBorderBottomWidth(a) {
            this.bw = a;
            this.g("ActualBorderBottomWidth");
        }
        get sortDirection() {
            return this.ee;
        }
        set sortDirection(a) {
            this.ee = a;
            this.g("SortDirection");
        }
        get isExpanded() {
            return this.q;
        }
        set isExpanded(a) {
            this.q = a;
            this.g("IsExpanded");
        }
        get isCollapsable() {
            return this.l;
        }
        set isCollapsable(a) {
            this.l = a;
            this.g("IsCollapsable");
        }
        get pinned() {
            return this.d9;
        }
        set pinned(a) {
            this.d9 = a;
            this.g("Pinned");
        }
        get editFontFamily() {
            return this.dv;
        }
        set editFontFamily(a) {
            this.dv = a;
            this.g("EditFontFamily");
        }
        get editFontSize() {
            return this.a3;
        }
        set editFontSize(a) {
            this.a3 = a;
            this.g("EditFontSize");
        }
        get editFontStyle() {
            return this.dw;
        }
        set editFontStyle(a) {
            this.dw = a;
            this.g("EditFontStyle");
        }
        get editFontWeight() {
            return this.dx;
        }
        set editFontWeight(a) {
            this.dx = a;
            this.g("EditFontWeight");
        }
        get isEdited() {
            return this.p;
        }
        set isEdited(a) {
            this.p = a;
            this.g("IsEdited");
        }
        get isDeleted() {
            return this.o;
        }
        set isDeleted(a) {
            this.o = a;
            this.g("IsDeleted");
        }
        get editError() {
            return this.du;
        }
        set editError(a) {
            this.du = a;
            this.g("EditError");
        }
        get isInEditMode() {
            return this.u;
        }
        set isInEditMode(a) {
            this.u = a;
            this.g("IsInEditMode");
        }
        get editID() {
            return this.b9;
        }
        set editID(a) {
            this.b9 = a;
            this.g("EditID");
        }
    }
    CellInfoDescription.$t = /*@__PURE__*/ markType(CellInfoDescription, 'CellInfoDescription', Description.$);
    CellInfoDescription.__marshalByValue = true;
    CellInfoDescription.__marshalByValueAlias = "CellModel";
    return CellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EditorCellInfoDescription = /*@__PURE__*/ (() => {
    class EditorCellInfoDescription extends CellInfoDescription {
        get_type() {
            return "EditorCellInfo";
        }
        constructor() {
            super();
            this.fn = null;
            this.ft = null;
            this.fz = null;
            this.fy = null;
            this.fx = null;
            this.fv = null;
            this.fw = null;
            this.fl = null;
            this.fu = null;
            this.fq = false;
        }
        get editTarget() {
            return this.fn;
        }
        set editTarget(a) {
            this.fn = a;
            this.g("EditTarget");
        }
        get dataType() {
            return this.ft;
        }
        set dataType(a) {
            this.ft = a;
            this.g("DataType");
        }
        get errorMessage() {
            return this.fz;
        }
        set errorMessage(a) {
            this.fz = a;
            this.g("ErrorMessage");
        }
        get editValueRef() {
            return this.fy;
        }
        set editValueRef(a) {
            this.fy = a;
            this.g("EditValueRef");
        }
        get editorType() {
            return this.fx;
        }
        set editorType(a) {
            this.fx = a;
            this.g("EditorType");
        }
        get editorDataSourceRef() {
            return this.fv;
        }
        set editorDataSourceRef(a) {
            this.fv = a;
            this.g("EditorDataSourceRef");
        }
        get editorTextField() {
            return this.fw;
        }
        set editorTextField(a) {
            this.fw = a;
            this.g("EditorTextField");
        }
        get editorValueField() {
            return this.fl;
        }
        set editorValueField(a) {
            this.fl = a;
            this.g("EditorValueField");
        }
        get dateFormatString() {
            return this.fu;
        }
        set dateFormatString(a) {
            this.fu = a;
            this.g("DateFormatString");
        }
        get showTodayButton() {
            return this.fq;
        }
        set showTodayButton(a) {
            this.fq = a;
            this.g("ShowTodayButton");
        }
    }
    EditorCellInfoDescription.$t = /*@__PURE__*/ markType(EditorCellInfoDescription, 'EditorCellInfoDescription', CellInfoDescription.$);
    EditorCellInfoDescription.__marshalByValue1 = true;
    EditorCellInfoDescription.__marshalByValueAlias1 = "EditorCellModel";
    return EditorCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EditorCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class EditorCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (EditorCellInfoDescriptionMetadata.a == null) {
                EditorCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                EditorCellInfoDescriptionMetadata.c(EditorCellInfoDescriptionMetadata.a);
            }
            if (a.k(EditorCellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(EditorCellInfoDescriptionMetadata.a);
            CellInfoDescriptionMetadata.d(a);
        }
        static c(a) {
            CellInfoDescriptionMetadata.c(a);
            a.item("EditTarget", "ExportedType:CellModel");
            a.item("DataType", "ExportedType:string:DataSourceSchemaPropertyType");
            a.item("DataType@names", "StringValue;IntValue;BooleanValue;LongValue;ShortValue;DoubleValue;DecimalValue;SingleValue;DateTimeValue;DateTimeOffsetValue;ByteValue;ObjectValue");
            a.item("ErrorMessage", "String");
            a.item("EditValueRef", "(w:EditValue,wf:EditValue)DataRef");
            a.item("EditorType", "ExportedType:string:EditorType");
            a.item("EditorType@names", "Default;Text;Numeric;Date;Combo");
            a.item("EditorDataSourceRef", "(w:EditorItemsSource,xam:EditorItemsSource,wf:EditorItemsSource)DataRef");
            a.item("EditorTextField", "String");
            a.item("EditorValueField", "Array:string");
            a.item("DateFormatString", "String");
            a.item("ShowTodayButton", "Boolean");
        }
        static d(a) {
            EditorCellInfoDescriptionMetadata.b(a);
            a.ae("EditorCellInfo", () => new EditorCellInfoDescription());
            a.ad("EditorCellInfo", EditorCellInfoDescriptionMetadata.a);
        }
    }
    EditorCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(EditorCellInfoDescriptionMetadata, 'EditorCellInfoDescriptionMetadata');
    EditorCellInfoDescriptionMetadata.a = null;
    return EditorCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EditorDefinitionDescription = /*@__PURE__*/ (() => {
    class EditorDefinitionDescription extends DefinitionBaseDescription {
        get_type() {
            return "EditorDefinition";
        }
        constructor() {
            super();
        }
    }
    EditorDefinitionDescription.$t = /*@__PURE__*/ markType(EditorDefinitionDescription, 'EditorDefinitionDescription', DefinitionBaseDescription.$);
    EditorDefinitionDescription.__canMarshalByValue = true;
    EditorDefinitionDescription.__marshalByValueAlias = "EditorDefinition";
    return EditorDefinitionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EditorDefinitionDescriptionMetadata = /*@__PURE__*/ (() => {
    class EditorDefinitionDescriptionMetadata extends Base {
        static b(a) {
            if (EditorDefinitionDescriptionMetadata.a == null) {
                EditorDefinitionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                EditorDefinitionDescriptionMetadata.c(EditorDefinitionDescriptionMetadata.a);
            }
            if (a.k(EditorDefinitionDescriptionMetadata.a)) {
                return;
            }
            a.ac(EditorDefinitionDescriptionMetadata.a);
        }
        static c(a) {
            DefinitionBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            EditorDefinitionDescriptionMetadata.b(a);
            a.ae("EditorDefinition", () => new EditorDefinitionDescription());
            a.ad("EditorDefinition", EditorDefinitionDescriptionMetadata.a);
        }
    }
    EditorDefinitionDescriptionMetadata.$t = /*@__PURE__*/ markType(EditorDefinitionDescriptionMetadata, 'EditorDefinitionDescriptionMetadata');
    EditorDefinitionDescriptionMetadata.a = null;
    return EditorDefinitionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EditorDefinitionDescriptionModule = /*@__PURE__*/ (() => {
    class EditorDefinitionDescriptionModule extends Base {
        static register(a) {
            EditorDefinitionDescriptionMetadata.d(a);
        }
    }
    EditorDefinitionDescriptionModule.$t = /*@__PURE__*/ markType(EditorDefinitionDescriptionModule, 'EditorDefinitionDescriptionModule');
    return EditorDefinitionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EditorRowCellInfoDescription = /*@__PURE__*/ (() => {
    class EditorRowCellInfoDescription extends CellInfoDescription {
        get_type() {
            return "EditorRowCellInfo";
        }
        constructor() {
            super();
        }
    }
    EditorRowCellInfoDescription.$t = /*@__PURE__*/ markType(EditorRowCellInfoDescription, 'EditorRowCellInfoDescription', CellInfoDescription.$);
    EditorRowCellInfoDescription.__marshalByValue1 = true;
    EditorRowCellInfoDescription.__marshalByValueAlias1 = "EditorRowCellModel";
    return EditorRowCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EditorRowCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class EditorRowCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (EditorRowCellInfoDescriptionMetadata.a == null) {
                EditorRowCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                EditorRowCellInfoDescriptionMetadata.c(EditorRowCellInfoDescriptionMetadata.a);
            }
            if (a.k(EditorRowCellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(EditorRowCellInfoDescriptionMetadata.a);
        }
        static c(a) {
            CellInfoDescriptionMetadata.c(a);
        }
        static d(a) {
            EditorRowCellInfoDescriptionMetadata.b(a);
            a.ae("EditorRowCellInfo", () => new EditorRowCellInfoDescription());
            a.ad("EditorRowCellInfo", EditorRowCellInfoDescriptionMetadata.a);
        }
    }
    EditorRowCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(EditorRowCellInfoDescriptionMetadata, 'EditorRowCellInfoDescriptionMetadata');
    EditorRowCellInfoDescriptionMetadata.a = null;
    return EditorRowCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EditRowDefinitionDescription = /*@__PURE__*/ (() => {
    class EditRowDefinitionDescription extends DefinitionBaseDescription {
        get_type() {
            return "EditRowDefinition";
        }
        constructor() {
            super();
        }
    }
    EditRowDefinitionDescription.$t = /*@__PURE__*/ markType(EditRowDefinitionDescription, 'EditRowDefinitionDescription', DefinitionBaseDescription.$);
    EditRowDefinitionDescription.__canMarshalByValue = true;
    EditRowDefinitionDescription.__marshalByValueAlias = "EditRowDefinition";
    return EditRowDefinitionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EditRowDefinitionDescriptionMetadata = /*@__PURE__*/ (() => {
    class EditRowDefinitionDescriptionMetadata extends Base {
        static b(a) {
            if (EditRowDefinitionDescriptionMetadata.a == null) {
                EditRowDefinitionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                EditRowDefinitionDescriptionMetadata.c(EditRowDefinitionDescriptionMetadata.a);
            }
            if (a.k(EditRowDefinitionDescriptionMetadata.a)) {
                return;
            }
            a.ac(EditRowDefinitionDescriptionMetadata.a);
        }
        static c(a) {
            DefinitionBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            EditRowDefinitionDescriptionMetadata.b(a);
            a.ae("EditRowDefinition", () => new EditRowDefinitionDescription());
            a.ad("EditRowDefinition", EditRowDefinitionDescriptionMetadata.a);
        }
    }
    EditRowDefinitionDescriptionMetadata.$t = /*@__PURE__*/ markType(EditRowDefinitionDescriptionMetadata, 'EditRowDefinitionDescriptionMetadata');
    EditRowDefinitionDescriptionMetadata.a = null;
    return EditRowDefinitionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EditRowDefinitionDescriptionModule = /*@__PURE__*/ (() => {
    class EditRowDefinitionDescriptionModule extends Base {
        static register(a) {
            EditRowDefinitionDescriptionMetadata.d(a);
        }
    }
    EditRowDefinitionDescriptionModule.$t = /*@__PURE__*/ markType(EditRowDefinitionDescriptionModule, 'EditRowDefinitionDescriptionModule');
    return EditRowDefinitionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ExpansionPanelDescription = /*@__PURE__*/ (() => {
    class ExpansionPanelDescription extends Description {
        get_type() {
            return "ExpansionPanel";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.t = null;
            this.w = null;
            this.o = null;
            this.u = null;
            this.v = null;
            this.x = null;
            this.aa = null;
            this.p = null;
            this.y = null;
            this.z = null;
            this.k = 0;
            this.j = 0;
            this.h = false;
            this.ab = null;
            this.q = null;
            this.ac = null;
            this.ad = null;
            this.s = null;
            this.r = null;
            this.n = null;
            this.ae = null;
            this.af = null;
        }
        get caption() {
            return this.t;
        }
        set caption(a) {
            this.t = a;
            this.g("Caption");
        }
        get captionTextColor() {
            return this.w;
        }
        set captionTextColor(a) {
            this.w = a;
            this.g("CaptionTextColor");
        }
        get actualCaptionTextColor() {
            return this.o;
        }
        set actualCaptionTextColor(a) {
            this.o = a;
            this.g("ActualCaptionTextColor");
        }
        get captionCollapsedTextColor() {
            return this.u;
        }
        set captionCollapsedTextColor(a) {
            this.u = a;
            this.g("CaptionCollapsedTextColor");
        }
        get captionExpandedTextColor() {
            return this.v;
        }
        set captionExpandedTextColor(a) {
            this.v = a;
            this.g("CaptionExpandedTextColor");
        }
        get description() {
            return this.x;
        }
        set description(a) {
            this.x = a;
            this.g("Description");
        }
        get descriptionTextColor() {
            return this.aa;
        }
        set descriptionTextColor(a) {
            this.aa = a;
            this.g("DescriptionTextColor");
        }
        get actualDescriptionTextColor() {
            return this.p;
        }
        set actualDescriptionTextColor(a) {
            this.p = a;
            this.g("ActualDescriptionTextColor");
        }
        get descriptionCollapsedTextColor() {
            return this.y;
        }
        set descriptionCollapsedTextColor(a) {
            this.y = a;
            this.g("DescriptionCollapsedTextColor");
        }
        get descriptionExpandedTextColor() {
            return this.z;
        }
        set descriptionExpandedTextColor(a) {
            this.z = a;
            this.g("DescriptionExpandedTextColor");
        }
        get elevation() {
            return this.k;
        }
        set elevation(a) {
            this.k = a;
            this.g("Elevation");
        }
        get actualElevation() {
            return this.j;
        }
        set actualElevation(a) {
            this.j = a;
            this.g("ActualElevation");
        }
        get expanded() {
            return this.h;
        }
        set expanded(a) {
            this.h = a;
            this.g("Expanded");
        }
        get headerBackgroundColor() {
            return this.ab;
        }
        set headerBackgroundColor(a) {
            this.ab = a;
            this.g("HeaderBackgroundColor");
        }
        get actualHeaderBackgroundColor() {
            return this.q;
        }
        set actualHeaderBackgroundColor(a) {
            this.q = a;
            this.g("ActualHeaderBackgroundColor");
        }
        get headerCollapsedBackgroundColor() {
            return this.ac;
        }
        set headerCollapsedBackgroundColor(a) {
            this.ac = a;
            this.g("HeaderCollapsedBackgroundColor");
        }
        get headerExpandedBackgroundColor() {
            return this.ad;
        }
        set headerExpandedBackgroundColor(a) {
            this.ad = a;
            this.g("HeaderExpandedBackgroundColor");
        }
        get actualUmbraShadowColor() {
            return this.s;
        }
        set actualUmbraShadowColor(a) {
            this.s = a;
            this.g("ActualUmbraShadowColor");
        }
        get actualPenumbraShadowColor() {
            return this.r;
        }
        set actualPenumbraShadowColor(a) {
            this.r = a;
            this.g("ActualPenumbraShadowColor");
        }
        get actualAmbientShadowColor() {
            return this.n;
        }
        set actualAmbientShadowColor(a) {
            this.n = a;
            this.g("ActualAmbientShadowColor");
        }
        get onCollapsedRef() {
            return this.ae;
        }
        set onCollapsedRef(a) {
            this.ae = a;
            this.g("OnCollapsedRef");
        }
        get onExpandedRef() {
            return this.af;
        }
        set onExpandedRef(a) {
            this.af = a;
            this.g("OnExpandedRef");
        }
    }
    ExpansionPanelDescription.$t = /*@__PURE__*/ markType(ExpansionPanelDescription, 'ExpansionPanelDescription', Description.$);
    return ExpansionPanelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnCollapsedEventArgsDescription = /*@__PURE__*/ (() => {
    class OnCollapsedEventArgsDescription extends Description {
        get_type() {
            return "OnCollapsedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    OnCollapsedEventArgsDescription.$t = /*@__PURE__*/ markType(OnCollapsedEventArgsDescription, 'OnCollapsedEventArgsDescription', Description.$);
    return OnCollapsedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnCollapsedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class OnCollapsedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (OnCollapsedEventArgsDescriptionMetadata.a == null) {
                OnCollapsedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OnCollapsedEventArgsDescriptionMetadata.c(OnCollapsedEventArgsDescriptionMetadata.a);
            }
            if (a.k(OnCollapsedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(OnCollapsedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            OnCollapsedEventArgsDescriptionMetadata.b(a);
            a.ae("OnCollapsedEventArgs", () => new OnCollapsedEventArgsDescription());
            a.ad("OnCollapsedEventArgs", OnCollapsedEventArgsDescriptionMetadata.a);
        }
    }
    OnCollapsedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(OnCollapsedEventArgsDescriptionMetadata, 'OnCollapsedEventArgsDescriptionMetadata');
    OnCollapsedEventArgsDescriptionMetadata.a = null;
    return OnCollapsedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnExpandedEventArgsDescription = /*@__PURE__*/ (() => {
    class OnExpandedEventArgsDescription extends Description {
        get_type() {
            return "OnExpandedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    OnExpandedEventArgsDescription.$t = /*@__PURE__*/ markType(OnExpandedEventArgsDescription, 'OnExpandedEventArgsDescription', Description.$);
    return OnExpandedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnExpandedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class OnExpandedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (OnExpandedEventArgsDescriptionMetadata.a == null) {
                OnExpandedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OnExpandedEventArgsDescriptionMetadata.c(OnExpandedEventArgsDescriptionMetadata.a);
            }
            if (a.k(OnExpandedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(OnExpandedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            OnExpandedEventArgsDescriptionMetadata.b(a);
            a.ae("OnExpandedEventArgs", () => new OnExpandedEventArgsDescription());
            a.ad("OnExpandedEventArgs", OnExpandedEventArgsDescriptionMetadata.a);
        }
    }
    OnExpandedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(OnExpandedEventArgsDescriptionMetadata, 'OnExpandedEventArgsDescriptionMetadata');
    OnExpandedEventArgsDescriptionMetadata.a = null;
    return OnExpandedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ExpansionPanelDescriptionMetadata = /*@__PURE__*/ (() => {
    class ExpansionPanelDescriptionMetadata extends Base {
        static b(a) {
            if (ExpansionPanelDescriptionMetadata.a == null) {
                ExpansionPanelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ExpansionPanelDescriptionMetadata.c(ExpansionPanelDescriptionMetadata.a);
            }
            if (a.k(ExpansionPanelDescriptionMetadata.a)) {
                return;
            }
            a.ac(ExpansionPanelDescriptionMetadata.a);
            OnCollapsedEventArgsDescriptionMetadata.d(a);
            OnExpandedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:XExpansionPanel");
            a.item("Caption", "String");
            a.item("CaptionTextColor", "Brush");
            a.item("ActualCaptionTextColor", "Brush");
            a.item("CaptionCollapsedTextColor", "Brush");
            a.item("CaptionExpandedTextColor", "Brush");
            a.item("Description", "String");
            a.item("DescriptionTextColor", "Brush");
            a.item("ActualDescriptionTextColor", "Brush");
            a.item("DescriptionCollapsedTextColor", "Brush");
            a.item("DescriptionExpandedTextColor", "Brush");
            a.item("Elevation", "Number:int");
            a.item("ActualElevation", "Number:int");
            a.item("Expanded", "Boolean");
            a.item("HeaderBackgroundColor", "Brush");
            a.item("ActualHeaderBackgroundColor", "Brush");
            a.item("HeaderCollapsedBackgroundColor", "Brush");
            a.item("HeaderExpandedBackgroundColor", "Brush");
            a.item("ActualUmbraShadowColor", "Brush");
            a.item("ActualPenumbraShadowColor", "Brush");
            a.item("ActualAmbientShadowColor", "Brush");
            a.item("OnCollapsedRef", "EventRef::onCollapsed");
            a.item("OnExpandedRef", "EventRef::onExpanded");
        }
        static d(a) {
            ExpansionPanelDescriptionMetadata.b(a);
            a.ae("ExpansionPanel", () => new ExpansionPanelDescription());
            a.ad("ExpansionPanel", ExpansionPanelDescriptionMetadata.a);
        }
    }
    ExpansionPanelDescriptionMetadata.$t = /*@__PURE__*/ markType(ExpansionPanelDescriptionMetadata, 'ExpansionPanelDescriptionMetadata');
    ExpansionPanelDescriptionMetadata.a = null;
    return ExpansionPanelDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ExpansionPanelDescriptionModule = /*@__PURE__*/ (() => {
    class ExpansionPanelDescriptionModule extends Base {
        static register(a) {
            ExpansionPanelDescriptionMetadata.d(a);
        }
    }
    ExpansionPanelDescriptionModule.$t = /*@__PURE__*/ markType(ExpansionPanelDescriptionModule, 'ExpansionPanelDescriptionModule');
    return ExpansionPanelDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterCellInfoDescription = /*@__PURE__*/ (() => {
    class FilterCellInfoDescription extends CellInfoDescription {
        get_type() {
            return "FilterCellInfo";
        }
        constructor() {
            super();
            this.f5 = null;
            this.fn = null;
            this.fp = null;
            this.fl = null;
            this.f7 = null;
            this.f6 = null;
            this.fx = 0;
            this.fw = 0;
            this.fv = 0;
            this.fu = 0;
            this.ft = 0;
            this.fs = 0;
        }
        get dataType() {
            return this.f5;
        }
        set dataType(a) {
            this.f5 = a;
            this.g("DataType");
        }
        get filter() {
            return this.fn;
        }
        set filter(a) {
            this.fn = a;
            this.g("Filter");
        }
        get filterExpression() {
            return this.fp;
        }
        set filterExpression(a) {
            this.fp = a;
            this.g("FilterExpression");
        }
        get filterOperands() {
            return this.fl;
        }
        set filterOperands(a) {
            this.fl = a;
            this.g("FilterOperands");
        }
        get operatorType() {
            return this.f7;
        }
        set operatorType(a) {
            this.f7 = a;
            this.g("OperatorType");
        }
        get filterValueRef() {
            return this.f6;
        }
        set filterValueRef(a) {
            this.f6 = a;
            this.g("FilterValueRef");
        }
        get selectorTop() {
            return this.fx;
        }
        set selectorTop(a) {
            this.fx = a;
            this.g("SelectorTop");
        }
        get selectorLeft() {
            return this.fw;
        }
        set selectorLeft(a) {
            this.fw = a;
            this.g("SelectorLeft");
        }
        get editorTop() {
            return this.fv;
        }
        set editorTop(a) {
            this.fv = a;
            this.g("EditorTop");
        }
        get editorLeft() {
            return this.fu;
        }
        set editorLeft(a) {
            this.fu = a;
            this.g("EditorLeft");
        }
        get clearIconTop() {
            return this.ft;
        }
        set clearIconTop(a) {
            this.ft = a;
            this.g("ClearIconTop");
        }
        get clearIconLeft() {
            return this.fs;
        }
        set clearIconLeft(a) {
            this.fs = a;
            this.g("ClearIconLeft");
        }
    }
    FilterCellInfoDescription.$t = /*@__PURE__*/ markType(FilterCellInfoDescription, 'FilterCellInfoDescription', CellInfoDescription.$);
    FilterCellInfoDescription.__marshalByValue1 = true;
    FilterCellInfoDescription.__marshalByValueAlias1 = "FilterCellModel";
    return FilterCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class FilterCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (FilterCellInfoDescriptionMetadata.a == null) {
                FilterCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FilterCellInfoDescriptionMetadata.c(FilterCellInfoDescriptionMetadata.a);
            }
            if (a.k(FilterCellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(FilterCellInfoDescriptionMetadata.a);
            ColumnFilterConditionDescriptionMetadata.d(a);
            FilterExpressionDescriptionMetadata.d(a);
        }
        static c(a) {
            CellInfoDescriptionMetadata.c(a);
            a.item("DataType", "ExportedType:string:DataSourceSchemaPropertyType");
            a.item("DataType@names", "StringValue;IntValue;BooleanValue;LongValue;ShortValue;DoubleValue;DecimalValue;SingleValue;DateTimeValue;DateTimeOffsetValue;ByteValue;ObjectValue");
            a.item("Filter", "ExportedType:ColumnFilterCondition");
            a.item("FilterExpression", "ExportedType:IFilterExpression");
            a.item("FilterOperands", "Collection:FilterOperand:GridFilterOperandsCollection:FilterOperand");
            a.item("OperatorType", "ExportedType:string:ColumnComparisonConditionOperatorType");
            a.item("OperatorType@names", "Equals;NotEquals;LessThan;LessThanOrEqualTo;GreaterThan;GreaterThanOrEqualTo;Top;Bottom;TopPercentile;BottomPercentile;True;False;Contains;DoesNotContain;StartsWith;DoesNotStartWith;EndsWith;DoesNotEndWith;Today;Tomorrow;Yesterday;NextWeek;ThisWeek;LastWeek;NextMonth;ThisMonth;LastMonth;NextQuarter;ThisQuarter;LastQuarter;NextYear;ThisYear;LastYear;YearToDate;Q1;Q2;Q3;Q4;Month;Year;Empty;NotEmpty;IsNull;IsNotNull;Custom");
            a.item("FilterValueRef", "(w:FilterValue,wf:FilterValue)DataRef");
            a.item("SelectorTop", "Number:double");
            a.item("SelectorLeft", "Number:double");
            a.item("EditorTop", "Number:double");
            a.item("EditorLeft", "Number:double");
            a.item("ClearIconTop", "Number:double");
            a.item("ClearIconLeft", "Number:double");
        }
        static d(a) {
            FilterCellInfoDescriptionMetadata.b(a);
            a.ae("FilterCellInfo", () => new FilterCellInfoDescription());
            a.ad("FilterCellInfo", FilterCellInfoDescriptionMetadata.a);
        }
    }
    FilterCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(FilterCellInfoDescriptionMetadata, 'FilterCellInfoDescriptionMetadata');
    FilterCellInfoDescriptionMetadata.a = null;
    return FilterCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterDialogRenderCompletedEventArgsDescription = /*@__PURE__*/ (() => {
    class FilterDialogRenderCompletedEventArgsDescription extends Description {
        get_type() {
            return "FilterDialogRenderCompletedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    FilterDialogRenderCompletedEventArgsDescription.$t = /*@__PURE__*/ markType(FilterDialogRenderCompletedEventArgsDescription, 'FilterDialogRenderCompletedEventArgsDescription', Description.$);
    return FilterDialogRenderCompletedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterDialogRenderCompletedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FilterDialogRenderCompletedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FilterDialogRenderCompletedEventArgsDescriptionMetadata.a == null) {
                FilterDialogRenderCompletedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FilterDialogRenderCompletedEventArgsDescriptionMetadata.c(FilterDialogRenderCompletedEventArgsDescriptionMetadata.a);
            }
            if (a.k(FilterDialogRenderCompletedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(FilterDialogRenderCompletedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            FilterDialogRenderCompletedEventArgsDescriptionMetadata.b(a);
            a.ae("FilterDialogRenderCompletedEventArgs", () => new FilterDialogRenderCompletedEventArgsDescription());
            a.ad("FilterDialogRenderCompletedEventArgs", FilterDialogRenderCompletedEventArgsDescriptionMetadata.a);
        }
    }
    FilterDialogRenderCompletedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FilterDialogRenderCompletedEventArgsDescriptionMetadata, 'FilterDialogRenderCompletedEventArgsDescriptionMetadata');
    FilterDialogRenderCompletedEventArgsDescriptionMetadata.a = null;
    return FilterDialogRenderCompletedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterRowDefinitionDescription = /*@__PURE__*/ (() => {
    class FilterRowDefinitionDescription extends DefinitionBaseDescription {
        get_type() {
            return "FilterRowDefinition";
        }
        constructor() {
            super();
            this.b6 = 0;
            this.b8 = 0;
            this.b7 = 0;
            this.b5 = 0;
        }
        get paddingLeft() {
            return this.b6;
        }
        set paddingLeft(a) {
            this.b6 = a;
            this.g("PaddingLeft");
        }
        get paddingTop() {
            return this.b8;
        }
        set paddingTop(a) {
            this.b8 = a;
            this.g("PaddingTop");
        }
        get paddingRight() {
            return this.b7;
        }
        set paddingRight(a) {
            this.b7 = a;
            this.g("PaddingRight");
        }
        get paddingBottom() {
            return this.b5;
        }
        set paddingBottom(a) {
            this.b5 = a;
            this.g("PaddingBottom");
        }
    }
    FilterRowDefinitionDescription.$t = /*@__PURE__*/ markType(FilterRowDefinitionDescription, 'FilterRowDefinitionDescription', DefinitionBaseDescription.$);
    FilterRowDefinitionDescription.__canMarshalByValue = true;
    FilterRowDefinitionDescription.__marshalByValueAlias = "FilterRowDefinition";
    return FilterRowDefinitionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterRowDefinitionDescriptionMetadata = /*@__PURE__*/ (() => {
    class FilterRowDefinitionDescriptionMetadata extends Base {
        static b(a) {
            if (FilterRowDefinitionDescriptionMetadata.a == null) {
                FilterRowDefinitionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FilterRowDefinitionDescriptionMetadata.c(FilterRowDefinitionDescriptionMetadata.a);
            }
            if (a.k(FilterRowDefinitionDescriptionMetadata.a)) {
                return;
            }
            a.ac(FilterRowDefinitionDescriptionMetadata.a);
        }
        static c(a) {
            DefinitionBaseDescriptionMetadata.c(a);
            a.item("PaddingLeft", "Number:int");
            a.item("PaddingTop", "Number:int");
            a.item("PaddingRight", "Number:int");
            a.item("PaddingBottom", "Number:int");
        }
        static d(a) {
            FilterRowDefinitionDescriptionMetadata.b(a);
            a.ae("FilterRowDefinition", () => new FilterRowDefinitionDescription());
            a.ad("FilterRowDefinition", FilterRowDefinitionDescriptionMetadata.a);
        }
    }
    FilterRowDefinitionDescriptionMetadata.$t = /*@__PURE__*/ markType(FilterRowDefinitionDescriptionMetadata, 'FilterRowDefinitionDescriptionMetadata');
    FilterRowDefinitionDescriptionMetadata.a = null;
    return FilterRowDefinitionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterRowDefinitionDescriptionModule = /*@__PURE__*/ (() => {
    class FilterRowDefinitionDescriptionModule extends Base {
        static register(a) {
            FilterRowDefinitionDescriptionMetadata.d(a);
        }
    }
    FilterRowDefinitionDescriptionModule.$t = /*@__PURE__*/ markType(FilterRowDefinitionDescriptionModule, 'FilterRowDefinitionDescriptionModule');
    return FilterRowDefinitionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartCustomIndicatorArgsDescription = /*@__PURE__*/ (() => {
    class FinancialChartCustomIndicatorArgsDescription extends Description {
        get_type() {
            return "FinancialChartCustomIndicatorArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = 0;
        }
        get series() {
            return this.h;
        }
        set series(a) {
            this.h = a;
            this.g("Series");
        }
        get index() {
            return this.j;
        }
        set index(a) {
            this.j = a;
            this.g("Index");
        }
    }
    FinancialChartCustomIndicatorArgsDescription.$t = /*@__PURE__*/ markType(FinancialChartCustomIndicatorArgsDescription, 'FinancialChartCustomIndicatorArgsDescription', Description.$);
    return FinancialChartCustomIndicatorArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartCustomIndicatorArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialChartCustomIndicatorArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialChartCustomIndicatorArgsDescriptionMetadata.a == null) {
                FinancialChartCustomIndicatorArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialChartCustomIndicatorArgsDescriptionMetadata.c(FinancialChartCustomIndicatorArgsDescriptionMetadata.a);
            }
            if (a.k(FinancialChartCustomIndicatorArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(FinancialChartCustomIndicatorArgsDescriptionMetadata.a);
            SeriesDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Series", "ExportedType:Series");
            a.item("Index", "Number:int");
        }
        static d(a) {
            FinancialChartCustomIndicatorArgsDescriptionMetadata.b(a);
            a.ae("FinancialChartCustomIndicatorArgs", () => new FinancialChartCustomIndicatorArgsDescription());
            a.ad("FinancialChartCustomIndicatorArgs", FinancialChartCustomIndicatorArgsDescriptionMetadata.a);
        }
    }
    FinancialChartCustomIndicatorArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialChartCustomIndicatorArgsDescriptionMetadata, 'FinancialChartCustomIndicatorArgsDescriptionMetadata');
    FinancialChartCustomIndicatorArgsDescriptionMetadata.a = null;
    return FinancialChartCustomIndicatorArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartDescription = /*@__PURE__*/ (() => {
    class FinancialChartDescription extends XYChartDescription {
        get tooltipTemplateRef() {
            return this.yl;
        }
        set tooltipTemplateRef(a) {
            this.yl = a;
            this.g("TooltipTemplateRef");
        }
        get width() {
            return this.yn;
        }
        set width(a) {
            this.yn = a;
            this.g("Width");
        }
        get height() {
            return this.yk;
        }
        set height(a) {
            this.yk = a;
            this.g("Height");
        }
        get background() {
            return this.yi;
        }
        set background(a) {
            this.yi = a;
            this.g("Background");
        }
        get_type() {
            return "FinancialChart";
        }
        constructor() {
            super();
            this.yl = null;
            this.yn = null;
            this.yk = null;
            this.yi = null;
            this.w7 = 0;
            this.wj = false;
            this.xb = 0;
            this.wr = false;
            this.ya = 0;
            this.xi = 0;
            this.xk = 0;
            this.xj = 0;
            this.xl = 0;
            this.ym = null;
            this.yo = null;
            this.xd = 0;
            this.xg = 0;
            this.xe = 0;
            this.xf = 0;
            this.xh = 0;
            this.yq = null;
            this.wl = false;
            this.yj = null;
            this.yp = null;
            this.wn = false;
            this.vv = null;
            this.v0 = null;
            this.wp = false;
            this.xa = 0;
            this.wo = false;
            this.wq = false;
            this.yr = null;
            this.vw = null;
            this.vx = null;
            this.vy = null;
            this.vz = null;
            this.v3 = null;
            this.v2 = null;
            this.vu = null;
            this.vs = null;
            this.xc = 0;
            this.w9 = 0;
            this.w8 = 0;
            this.w6 = 0;
            this.vt = null;
            this.x6 = 0;
            this.w5 = 0;
            this.x9 = 0;
            this.x7 = 0;
            this.x5 = 0;
            this.x8 = 0;
            this.v1 = null;
            this.vr = null;
            this.wm = false;
            this.ys = null;
            this.xm = 0;
            this.wk = false;
            this.w2 = new Date();
            this.w1 = new Date();
            this.v4 = null;
            this.yh = null;
        }
        get leftMargin() {
            return this.w7;
        }
        set leftMargin(a) {
            this.w7 = a;
            this.g("LeftMargin");
        }
        get isHorizontalZoomEnabled() {
            return this.wj;
        }
        set isHorizontalZoomEnabled(a) {
            this.wj = a;
            this.g("IsHorizontalZoomEnabled");
        }
        get toolbarHeight() {
            return this.xb;
        }
        set toolbarHeight(a) {
            this.xb = a;
            this.g("ToolbarHeight");
        }
        get yAxisIsLogarithmic() {
            return this.wr;
        }
        set yAxisIsLogarithmic(a) {
            this.wr = a;
            this.g("YAxisIsLogarithmic");
        }
        get yAxisLogarithmBase() {
            return this.ya;
        }
        set yAxisLogarithmBase(a) {
            this.ya = a;
            this.g("YAxisLogarithmBase");
        }
        get yAxisInterval() {
            return this.xi;
        }
        set yAxisInterval(a) {
            this.xi = a;
            this.g("YAxisInterval");
        }
        get yAxisMinimumValue() {
            return this.xk;
        }
        set yAxisMinimumValue(a) {
            this.xk = a;
            this.g("YAxisMinimumValue");
        }
        get yAxisMaximumValue() {
            return this.xj;
        }
        set yAxisMaximumValue(a) {
            this.xj = a;
            this.g("YAxisMaximumValue");
        }
        get yAxisMinorInterval() {
            return this.xl;
        }
        set yAxisMinorInterval(a) {
            this.xl = a;
            this.g("YAxisMinorInterval");
        }
        get volumeType() {
            return this.ym;
        }
        set volumeType(a) {
            this.ym = a;
            this.g("VolumeType");
        }
        get xAxisMode() {
            return this.yo;
        }
        set xAxisMode(a) {
            this.yo = a;
            this.g("XAxisMode");
        }
        get xAxisZoomMaximumCategoryRange() {
            return this.xd;
        }
        set xAxisZoomMaximumCategoryRange(a) {
            this.xd = a;
            this.g("XAxisZoomMaximumCategoryRange");
        }
        get xAxisZoomToCategoryStart() {
            return this.xg;
        }
        set xAxisZoomToCategoryStart(a) {
            this.xg = a;
            this.g("XAxisZoomToCategoryStart");
        }
        get xAxisZoomMaximumItemSpan() {
            return this.xe;
        }
        set xAxisZoomMaximumItemSpan(a) {
            this.xe = a;
            this.g("XAxisZoomMaximumItemSpan");
        }
        get xAxisZoomToCategoryRange() {
            return this.xf;
        }
        set xAxisZoomToCategoryRange(a) {
            this.xf = a;
            this.g("XAxisZoomToCategoryRange");
        }
        get xAxisZoomToItemSpan() {
            return this.xh;
        }
        set xAxisZoomToItemSpan(a) {
            this.xh = a;
            this.g("XAxisZoomToItemSpan");
        }
        get yAxisMode() {
            return this.yq;
        }
        set yAxisMode(a) {
            this.yq = a;
            this.g("YAxisMode");
        }
        get isToolbarVisible() {
            return this.wl;
        }
        set isToolbarVisible(a) {
            this.wl = a;
            this.g("IsToolbarVisible");
        }
        get chartType() {
            return this.yj;
        }
        set chartType(a) {
            this.yj = a;
            this.g("ChartType");
        }
        get yAxisLabelHorizontalAlignment() {
            return this.yp;
        }
        set yAxisLabelHorizontalAlignment(a) {
            this.yp = a;
            this.g("YAxisLabelHorizontalAlignment");
        }
        get isWindowSyncedToVisibleRange() {
            return this.wn;
        }
        set isWindowSyncedToVisibleRange(a) {
            this.wn = a;
            this.g("IsWindowSyncedToVisibleRange");
        }
        get indicatorTypes() {
            return this.vv;
        }
        set indicatorTypes(a) {
            this.vv = a;
            this.g("IndicatorTypes");
        }
        get overlayTypes() {
            return this.v0;
        }
        set overlayTypes(a) {
            this.v0 = a;
            this.g("OverlayTypes");
        }
        get yAxisAbbreviateLargeNumbers() {
            return this.wp;
        }
        set yAxisAbbreviateLargeNumbers(a) {
            this.wp = a;
            this.g("YAxisAbbreviateLargeNumbers");
        }
        get resolution() {
            return this.xa;
        }
        set resolution(a) {
            this.xa = a;
            this.g("Resolution");
        }
        get xAxisEnhancedIntervalPreferMoreCategoryLabels() {
            return this.wo;
        }
        set xAxisEnhancedIntervalPreferMoreCategoryLabels(a) {
            this.wo = a;
            this.g("XAxisEnhancedIntervalPreferMoreCategoryLabels");
        }
        get yAxisEnhancedIntervalPreferMoreCategoryLabels() {
            return this.wq;
        }
        set yAxisEnhancedIntervalPreferMoreCategoryLabels(a) {
            this.wq = a;
            this.g("YAxisEnhancedIntervalPreferMoreCategoryLabels");
        }
        get zoomSliderType() {
            return this.yr;
        }
        set zoomSliderType(a) {
            this.yr = a;
            this.g("ZoomSliderType");
        }
        get negativeBrushes() {
            return this.vw;
        }
        set negativeBrushes(a) {
            this.vw = a;
            this.g("NegativeBrushes");
        }
        get negativeOutlines() {
            return this.vx;
        }
        set negativeOutlines(a) {
            this.vx = a;
            this.g("NegativeOutlines");
        }
        get overlayBrushes() {
            return this.vy;
        }
        set overlayBrushes(a) {
            this.vy = a;
            this.g("OverlayBrushes");
        }
        get overlayOutlines() {
            return this.vz;
        }
        set overlayOutlines(a) {
            this.vz = a;
            this.g("OverlayOutlines");
        }
        get volumeOutlines() {
            return this.v3;
        }
        set volumeOutlines(a) {
            this.v3 = a;
            this.g("VolumeOutlines");
        }
        get volumeBrushes() {
            return this.v2;
        }
        set volumeBrushes(a) {
            this.v2 = a;
            this.g("VolumeBrushes");
        }
        get indicatorNegativeBrushes() {
            return this.vu;
        }
        set indicatorNegativeBrushes(a) {
            this.vu = a;
            this.g("IndicatorNegativeBrushes");
        }
        get indicatorBrushes() {
            return this.vs;
        }
        set indicatorBrushes(a) {
            this.vs = a;
            this.g("IndicatorBrushes");
        }
        get volumeThickness() {
            return this.xc;
        }
        set volumeThickness(a) {
            this.xc = a;
            this.g("VolumeThickness");
        }
        get overlayThickness() {
            return this.w9;
        }
        set overlayThickness(a) {
            this.w9 = a;
            this.g("OverlayThickness");
        }
        get overlayMultiplier() {
            return this.w8;
        }
        set overlayMultiplier(a) {
            this.w8 = a;
            this.g("OverlayMultiplier");
        }
        get indicatorThickness() {
            return this.w6;
        }
        set indicatorThickness(a) {
            this.w6 = a;
            this.g("IndicatorThickness");
        }
        get indicatorDisplayTypes() {
            return this.vt;
        }
        set indicatorDisplayTypes(a) {
            this.vt = a;
            this.g("IndicatorDisplayTypes");
        }
        get indicatorPeriod() {
            return this.x6;
        }
        set indicatorPeriod(a) {
            this.x6 = a;
            this.g("IndicatorPeriod");
        }
        get indicatorMultiplier() {
            return this.w5;
        }
        set indicatorMultiplier(a) {
            this.w5 = a;
            this.g("IndicatorMultiplier");
        }
        get indicatorSmoothingPeriod() {
            return this.x9;
        }
        set indicatorSmoothingPeriod(a) {
            this.x9 = a;
            this.g("IndicatorSmoothingPeriod");
        }
        get indicatorShortPeriod() {
            return this.x7;
        }
        set indicatorShortPeriod(a) {
            this.x7 = a;
            this.g("IndicatorShortPeriod");
        }
        get indicatorLongPeriod() {
            return this.x5;
        }
        set indicatorLongPeriod(a) {
            this.x5 = a;
            this.g("IndicatorLongPeriod");
        }
        get indicatorSignalPeriod() {
            return this.x8;
        }
        set indicatorSignalPeriod(a) {
            this.x8 = a;
            this.g("IndicatorSignalPeriod");
        }
        get rangeSelectorOptions() {
            return this.v1;
        }
        set rangeSelectorOptions(a) {
            this.v1 = a;
            this.g("RangeSelectorOptions");
        }
        get customIndicatorNames() {
            return this.vr;
        }
        set customIndicatorNames(a) {
            this.vr = a;
            this.g("CustomIndicatorNames");
        }
        get isVerticalZoomEnabled() {
            return this.wm;
        }
        set isVerticalZoomEnabled(a) {
            this.wm = a;
            this.g("IsVerticalZoomEnabled");
        }
        get zoomSliderXAxisMajorStroke() {
            return this.ys;
        }
        set zoomSliderXAxisMajorStroke(a) {
            this.ys = a;
            this.g("ZoomSliderXAxisMajorStroke");
        }
        get zoomSliderXAxisMajorStrokeThickness() {
            return this.xm;
        }
        set zoomSliderXAxisMajorStrokeThickness(a) {
            this.xm = a;
            this.g("ZoomSliderXAxisMajorStrokeThickness");
        }
        get isLegendVisible() {
            return this.wk;
        }
        set isLegendVisible(a) {
            this.wk = a;
            this.g("IsLegendVisible");
        }
        get xAxisMinimumValue() {
            return this.w2;
        }
        set xAxisMinimumValue(a) {
            this.w2 = a;
            this.g("XAxisMinimumValue");
        }
        get xAxisMaximumValue() {
            return this.w1;
        }
        set xAxisMaximumValue(a) {
            this.w1 = a;
            this.g("XAxisMaximumValue");
        }
        get xAxisBreaks() {
            return this.v4;
        }
        set xAxisBreaks(a) {
            this.v4 = a;
            this.g("XAxisBreaks");
        }
        get applyCustomIndicatorsRef() {
            return this.yh;
        }
        set applyCustomIndicatorsRef(a) {
            this.yh = a;
            this.g("ApplyCustomIndicatorsRef");
        }
    }
    FinancialChartDescription.$t = /*@__PURE__*/ markType(FinancialChartDescription, 'FinancialChartDescription', XYChartDescription.$);
    return FinancialChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialChartDescriptionMetadata extends Base {
        static e(a) {
            a.item("TooltipTemplateRef", "(w:ToolTip)DataRef:String");
            a.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamFinancialChart");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (FinancialChartDescriptionMetadata.a == null) {
                FinancialChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialChartDescriptionMetadata.c(FinancialChartDescriptionMetadata.a);
            }
            if (a.k(FinancialChartDescriptionMetadata.a)) {
                return;
            }
            a.ac(FinancialChartDescriptionMetadata.a);
            FinancialChartCustomIndicatorArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            XYChartDescriptionMetadata.c(a);
            a.item("LeftMargin", "Number:double");
            a.item("IsHorizontalZoomEnabled", "Boolean");
            a.item("ToolbarHeight", "Number:double");
            a.item("YAxisIsLogarithmic", "Boolean");
            a.item("YAxisLogarithmBase", "Number:int");
            a.item("YAxisInterval", "Number:double");
            a.item("YAxisMinimumValue", "Number:double");
            a.item("YAxisMaximumValue", "Number:double");
            a.item("YAxisMinorInterval", "Number:double");
            a.item("VolumeType", "ExportedType:string:FinancialChartVolumeType");
            a.item("VolumeType@names", "None;Column;Line;Area");
            a.item("XAxisMode", "ExportedType:string:FinancialChartXAxisMode");
            a.item("XAxisMode@names", "Ordinal;Time");
            a.item("XAxisZoomMaximumCategoryRange", "Number:double");
            a.item("XAxisZoomToCategoryStart", "Number:double");
            a.item("XAxisZoomMaximumItemSpan", "Number:double");
            a.item("XAxisZoomToCategoryRange", "Number:double");
            a.item("XAxisZoomToItemSpan", "Number:double");
            a.item("YAxisMode", "ExportedType:string:FinancialChartYAxisMode");
            a.item("YAxisMode@names", "Numeric;PercentChange");
            a.item("IsToolbarVisible", "Boolean");
            a.item("ChartType", "ExportedType:string:FinancialChartType");
            a.item("ChartType@names", "Auto;Bar;Candle;Column;Line");
            a.item("YAxisLabelHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("YAxisLabelHorizontalAlignment@names", "Left;Center;Right;Stretch");
            a.item("IsWindowSyncedToVisibleRange", "Boolean");
            a.item("IndicatorTypes", "Collection:string:FinancialIndicatorTypeCollection:FinancialIndicatorType");
            a.item("IndicatorTypes@names", "AbsoluteVolumeOscillator;AccumulationDistribution;AverageDirectionalIndex;AverageTrueRange;BollingerBandWidth;ChaikinOscillator;ChaikinVolatility;CommodityChannelIndex;DetrendedPriceOscillator;EaseOfMovement;FastStochasticOscillator;ForceIndex;FullStochasticOscillator;MarketFacilitationIndex;MassIndex;MedianPrice;MoneyFlowIndex;MovingAverageConvergenceDivergence;NegativeVolumeIndex;OnBalanceVolume;PercentagePriceOscillator;PercentageVolumeOscillator;PositiveVolumeIndex;PriceVolumeTrend;RateOfChangeAndMomentum;RelativeStrengthIndex;SlowStochasticOscillator;StandardDeviation;StochRSI;TRIX;TypicalPrice;UltimateOscillator;WeightedClose;WilliamsPercentR");
            a.item("OverlayTypes", "Collection:string:FinancialOverlayTypeCollection:FinancialOverlayType");
            a.item("OverlayTypes@names", "BollingerBands;PriceChannel");
            a.item("YAxisAbbreviateLargeNumbers", "Boolean");
            a.item("Resolution", "Number:double");
            a.item("XAxisEnhancedIntervalPreferMoreCategoryLabels", "Boolean");
            a.item("YAxisEnhancedIntervalPreferMoreCategoryLabels", "Boolean");
            a.item("ZoomSliderType", "ExportedType:string:FinancialChartZoomSliderType");
            a.item("ZoomSliderType@names", "None;Auto;Bar;Candle;Column;Line;Area");
            a.item("NegativeBrushes", "BrushCollection:string");
            a.item("NegativeOutlines", "BrushCollection:string");
            a.item("OverlayBrushes", "BrushCollection:string");
            a.item("OverlayOutlines", "BrushCollection:string");
            a.item("VolumeOutlines", "BrushCollection:string");
            a.item("VolumeBrushes", "BrushCollection:string");
            a.item("IndicatorNegativeBrushes", "BrushCollection:string");
            a.item("IndicatorBrushes", "BrushCollection:string");
            a.item("VolumeThickness", "Number:double");
            a.item("OverlayThickness", "Number:double");
            a.item("OverlayMultiplier", "Number:double");
            a.item("IndicatorThickness", "Number:double");
            a.item("IndicatorDisplayTypes", "Collection:string:IndicatorDisplayTypeCollection:IndicatorDisplayType");
            a.item("IndicatorDisplayTypes@names", "Line;Area;Column");
            a.item("IndicatorPeriod", "Number:int");
            a.item("IndicatorMultiplier", "Number:double");
            a.item("IndicatorSmoothingPeriod", "Number:int");
            a.item("IndicatorShortPeriod", "Number:int");
            a.item("IndicatorLongPeriod", "Number:int");
            a.item("IndicatorSignalPeriod", "Number:int");
            a.item("RangeSelectorOptions", "Collection:string:FinancialChartRangeSelectorOptionCollection:FinancialChartRangeSelectorOption");
            a.item("RangeSelectorOptions@names", "OneMonth;ThreeMonths;SixMonths;YearToDate;OneYear;All");
            a.item("CustomIndicatorNames", "Collection:String:CustomIndicatorNameCollection:String");
            a.item("IsVerticalZoomEnabled", "Boolean");
            a.item("ZoomSliderXAxisMajorStroke", "Brush");
            a.item("ZoomSliderXAxisMajorStrokeThickness", "Number:double");
            a.item("IsLegendVisible", "Boolean");
            a.item("XAxisMinimumValue", "Date");
            a.item("XAxisMaximumValue", "Date");
            a.item("XAxisBreaks", "Collection:TimeAxisBreak:TimeAxisBreakCollection:TimeAxisBreak");
            a.item("ApplyCustomIndicatorsRef", "EventRef::applyCustomIndicators");
            FinancialChartDescriptionMetadata.e(a);
        }
        static d(a) {
            FinancialChartDescriptionMetadata.b(a);
            a.ae("FinancialChart", () => new FinancialChartDescription());
            a.ad("FinancialChart", FinancialChartDescriptionMetadata.a);
        }
    }
    FinancialChartDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialChartDescriptionMetadata, 'FinancialChartDescriptionMetadata');
    FinancialChartDescriptionMetadata.a = null;
    return FinancialChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartDefaultTemplatesDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialChartDefaultTemplatesDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    FinancialChartDefaultTemplatesDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialChartDefaultTemplatesDescriptionMetadata, 'FinancialChartDefaultTemplatesDescriptionMetadata');
    return FinancialChartDefaultTemplatesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartCoreDescriptionModule = /*@__PURE__*/ (() => {
    class FinancialChartCoreDescriptionModule extends Base {
        static register(a) {
            FinancialChartDescriptionMetadata.d(a);
            FinancialChartDefaultTemplatesDescriptionMetadata.register(a);
            TemplateContentDescriptionModule.register(a);
        }
    }
    FinancialChartCoreDescriptionModule.$t = /*@__PURE__*/ markType(FinancialChartCoreDescriptionModule, 'FinancialChartCoreDescriptionModule');
    return FinancialChartCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentChangeYAxisDescription = /*@__PURE__*/ (() => {
    class PercentChangeYAxisDescription extends NumericYAxisDescription {
        get_type() {
            return "PercentChangeYAxis";
        }
        constructor() {
            super();
        }
    }
    PercentChangeYAxisDescription.$t = /*@__PURE__*/ markType(PercentChangeYAxisDescription, 'PercentChangeYAxisDescription', NumericYAxisDescription.$);
    return PercentChangeYAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentChangeYAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class PercentChangeYAxisDescriptionMetadata extends Base {
        static b(a) {
            if (PercentChangeYAxisDescriptionMetadata.a == null) {
                PercentChangeYAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PercentChangeYAxisDescriptionMetadata.c(PercentChangeYAxisDescriptionMetadata.a);
            }
            if (a.k(PercentChangeYAxisDescriptionMetadata.a)) {
                return;
            }
            a.ac(PercentChangeYAxisDescriptionMetadata.a);
        }
        static c(a) {
            NumericYAxisDescriptionMetadata.c(a);
        }
        static d(a) {
            PercentChangeYAxisDescriptionMetadata.b(a);
            a.ae("PercentChangeYAxis", () => new PercentChangeYAxisDescription());
            a.ad("PercentChangeYAxis", PercentChangeYAxisDescriptionMetadata.a);
        }
    }
    PercentChangeYAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(PercentChangeYAxisDescriptionMetadata, 'PercentChangeYAxisDescriptionMetadata');
    PercentChangeYAxisDescriptionMetadata.a = null;
    return PercentChangeYAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentChangeYAxisDescriptionModule = /*@__PURE__*/ (() => {
    class PercentChangeYAxisDescriptionModule extends Base {
        static register(a) {
            NumericYAxisDescriptionModule.register(a);
            PercentChangeYAxisDescriptionMetadata.d(a);
        }
    }
    PercentChangeYAxisDescriptionModule.$t = /*@__PURE__*/ markType(PercentChangeYAxisDescriptionModule, 'PercentChangeYAxisDescriptionModule');
    return PercentChangeYAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ZoomSliderResolvingAxisValueEventArgsDescription = /*@__PURE__*/ (() => {
    class ZoomSliderResolvingAxisValueEventArgsDescription extends Description {
        get_type() {
            return "ZoomSliderResolvingAxisValueEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = 0;
            this.j = null;
        }
        get position() {
            return this.h;
        }
        set position(a) {
            this.h = a;
            this.g("Position");
        }
        get valueRef() {
            return this.j;
        }
        set valueRef(a) {
            this.j = a;
            this.g("ValueRef");
        }
    }
    ZoomSliderResolvingAxisValueEventArgsDescription.$t = /*@__PURE__*/ markType(ZoomSliderResolvingAxisValueEventArgsDescription, 'ZoomSliderResolvingAxisValueEventArgsDescription', Description.$);
    return ZoomSliderResolvingAxisValueEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.a == null) {
                ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.c(ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.a);
            }
            if (a.k(ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Position", "Number:double");
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
        }
        static d(a) {
            ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.b(a);
            a.ae("ZoomSliderResolvingAxisValueEventArgs", () => new ZoomSliderResolvingAxisValueEventArgsDescription());
            a.ad("ZoomSliderResolvingAxisValueEventArgs", ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.a);
        }
    }
    ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata, 'ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata');
    ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.a = null;
    return ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ZoomSliderDescription = /*@__PURE__*/ (() => {
    class ZoomSliderDescription extends Description {
        get width() {
            return this.bx;
        }
        set width(a) {
            this.bx = a;
            this.g("Width");
        }
        get height() {
            return this.a8;
        }
        set height(a) {
            this.a8 = a;
            this.g("Height");
        }
        get background() {
            return this.a5;
        }
        set background(a) {
            this.a5 = a;
            this.g("Background");
        }
        get_type() {
            return "ZoomSlider";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.bx = null;
            this.a8 = null;
            this.a5 = null;
            this.a3 = 0;
            this.z = 0;
            this.ab = 0;
            this.l = 0;
            this.h = null;
            this.aa = 0;
            this.ad = 0;
            this.o = 0;
            this.ag = 0;
            this.af = 0;
            this.m = 0;
            this.bp = null;
            this.bm = null;
            this.x = 0;
            this.s = 0;
            this.be = null;
            this.bn = null;
            this.bf = null;
            this.bo = null;
            this.bg = null;
            this.y = 0;
            this.t = 0;
            this.w = 0;
            this.r = 0;
            this.bk = null;
            this.bl = null;
            this.v = 0;
            this.bc = null;
            this.bd = null;
            this.q = 0;
            this.a6 = null;
            this.a7 = null;
            this.n = 0;
            this.bq = null;
            this.br = null;
            this.ac = 0;
            this.bs = null;
            this.bh = null;
            this.bj = null;
            this.bi = null;
            this.u = 0;
            this.a9 = null;
            this.bb = null;
            this.ba = null;
            this.p = 0;
            this.j = false;
            this.bu = null;
            this.ae = 0;
            this.bv = null;
            this.bw = null;
            this.bt = null;
            this.by = null;
        }
        get panTransitionDuration() {
            return this.a3;
        }
        set panTransitionDuration(a) {
            this.a3 = a;
            this.g("PanTransitionDuration");
        }
        get maxZoomWidth() {
            return this.z;
        }
        set maxZoomWidth(a) {
            this.z = a;
            this.g("MaxZoomWidth");
        }
        get pixelScalingRatio() {
            return this.ab;
        }
        set pixelScalingRatio(a) {
            this.ab = a;
            this.g("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.l;
        }
        set actualPixelScalingRatio(a) {
            this.l = a;
            this.g("ActualPixelScalingRatio");
        }
        get windowRect() {
            return this.h;
        }
        set windowRect(a) {
            this.h = a;
            this.g("WindowRect");
        }
        get minZoomWidth() {
            return this.aa;
        }
        set minZoomWidth(a) {
            this.aa = a;
            this.g("MinZoomWidth");
        }
        get startInset() {
            return this.ad;
        }
        set startInset(a) {
            this.ad = a;
            this.g("StartInset");
        }
        get endInset() {
            return this.o;
        }
        set endInset(a) {
            this.o = a;
            this.g("EndInset");
        }
        get trackStartInset() {
            return this.ag;
        }
        set trackStartInset(a) {
            this.ag = a;
            this.g("TrackStartInset");
        }
        get trackEndInset() {
            return this.af;
        }
        set trackEndInset(a) {
            this.af = a;
            this.g("TrackEndInset");
        }
        get barExtent() {
            return this.m;
        }
        set barExtent(a) {
            this.m = a;
            this.g("BarExtent");
        }
        get orientation() {
            return this.bp;
        }
        set orientation(a) {
            this.bp = a;
            this.g("Orientation");
        }
        get lowerThumbBrush() {
            return this.bm;
        }
        set lowerThumbBrush(a) {
            this.bm = a;
            this.g("LowerThumbBrush");
        }
        get lowerThumbStrokeThickness() {
            return this.x;
        }
        set lowerThumbStrokeThickness(a) {
            this.x = a;
            this.g("LowerThumbStrokeThickness");
        }
        get higherThumbStrokeThickness() {
            return this.s;
        }
        set higherThumbStrokeThickness(a) {
            this.s = a;
            this.g("HigherThumbStrokeThickness");
        }
        get higherThumbBrush() {
            return this.be;
        }
        set higherThumbBrush(a) {
            this.be = a;
            this.g("HigherThumbBrush");
        }
        get lowerThumbOutline() {
            return this.bn;
        }
        set lowerThumbOutline(a) {
            this.bn = a;
            this.g("LowerThumbOutline");
        }
        get higherThumbOutline() {
            return this.bf;
        }
        set higherThumbOutline(a) {
            this.bf = a;
            this.g("HigherThumbOutline");
        }
        get lowerThumbRidgesBrush() {
            return this.bo;
        }
        set lowerThumbRidgesBrush(a) {
            this.bo = a;
            this.g("LowerThumbRidgesBrush");
        }
        get higherThumbRidgesBrush() {
            return this.bg;
        }
        set higherThumbRidgesBrush(a) {
            this.bg = a;
            this.g("HigherThumbRidgesBrush");
        }
        get lowerThumbWidth() {
            return this.y;
        }
        set lowerThumbWidth(a) {
            this.y = a;
            this.g("LowerThumbWidth");
        }
        get higherThumbWidth() {
            return this.t;
        }
        set higherThumbWidth(a) {
            this.t = a;
            this.g("HigherThumbWidth");
        }
        get lowerThumbHeight() {
            return this.w;
        }
        set lowerThumbHeight(a) {
            this.w = a;
            this.g("LowerThumbHeight");
        }
        get higherThumbHeight() {
            return this.r;
        }
        set higherThumbHeight(a) {
            this.r = a;
            this.g("HigherThumbHeight");
        }
        get lowerShadeBrush() {
            return this.bk;
        }
        set lowerShadeBrush(a) {
            this.bk = a;
            this.g("LowerShadeBrush");
        }
        get lowerShadeOutline() {
            return this.bl;
        }
        set lowerShadeOutline(a) {
            this.bl = a;
            this.g("LowerShadeOutline");
        }
        get lowerShadeStrokeThickness() {
            return this.v;
        }
        set lowerShadeStrokeThickness(a) {
            this.v = a;
            this.g("LowerShadeStrokeThickness");
        }
        get higherShadeBrush() {
            return this.bc;
        }
        set higherShadeBrush(a) {
            this.bc = a;
            this.g("HigherShadeBrush");
        }
        get higherShadeOutline() {
            return this.bd;
        }
        set higherShadeOutline(a) {
            this.bd = a;
            this.g("HigherShadeOutline");
        }
        get higherShadeStrokeThickness() {
            return this.q;
        }
        set higherShadeStrokeThickness(a) {
            this.q = a;
            this.g("HigherShadeStrokeThickness");
        }
        get barBrush() {
            return this.a6;
        }
        set barBrush(a) {
            this.a6 = a;
            this.g("BarBrush");
        }
        get barOutline() {
            return this.a7;
        }
        set barOutline(a) {
            this.a7 = a;
            this.g("BarOutline");
        }
        get barStrokeThickness() {
            return this.n;
        }
        set barStrokeThickness(a) {
            this.n = a;
            this.g("BarStrokeThickness");
        }
        get rangeThumbBrush() {
            return this.bq;
        }
        set rangeThumbBrush(a) {
            this.bq = a;
            this.g("RangeThumbBrush");
        }
        get rangeThumbOutline() {
            return this.br;
        }
        set rangeThumbOutline(a) {
            this.br = a;
            this.g("RangeThumbOutline");
        }
        get rangeThumbStrokeThickness() {
            return this.ac;
        }
        set rangeThumbStrokeThickness(a) {
            this.ac = a;
            this.g("RangeThumbStrokeThickness");
        }
        get rangeThumbRidgesBrush() {
            return this.bs;
        }
        set rangeThumbRidgesBrush(a) {
            this.bs = a;
            this.g("RangeThumbRidgesBrush");
        }
        get lowerCalloutBrush() {
            return this.bh;
        }
        set lowerCalloutBrush(a) {
            this.bh = a;
            this.g("LowerCalloutBrush");
        }
        get lowerCalloutTextColor() {
            return this.bj;
        }
        set lowerCalloutTextColor(a) {
            this.bj = a;
            this.g("LowerCalloutTextColor");
        }
        get lowerCalloutOutline() {
            return this.bi;
        }
        set lowerCalloutOutline(a) {
            this.bi = a;
            this.g("LowerCalloutOutline");
        }
        get lowerCalloutStrokeThickness() {
            return this.u;
        }
        set lowerCalloutStrokeThickness(a) {
            this.u = a;
            this.g("LowerCalloutStrokeThickness");
        }
        get higherCalloutBrush() {
            return this.a9;
        }
        set higherCalloutBrush(a) {
            this.a9 = a;
            this.g("HigherCalloutBrush");
        }
        get higherCalloutTextColor() {
            return this.bb;
        }
        set higherCalloutTextColor(a) {
            this.bb = a;
            this.g("HigherCalloutTextColor");
        }
        get higherCalloutOutline() {
            return this.ba;
        }
        set higherCalloutOutline(a) {
            this.ba = a;
            this.g("HigherCalloutOutline");
        }
        get higherCalloutStrokeThickness() {
            return this.p;
        }
        set higherCalloutStrokeThickness(a) {
            this.p = a;
            this.g("HigherCalloutStrokeThickness");
        }
        get areThumbCalloutsEnabled() {
            return this.j;
        }
        set areThumbCalloutsEnabled(a) {
            this.j = a;
            this.g("AreThumbCalloutsEnabled");
        }
        get thumbCalloutFontFamily() {
            return this.bu;
        }
        set thumbCalloutFontFamily(a) {
            this.bu = a;
            this.g("ThumbCalloutFontFamily");
        }
        get thumbCalloutFontSize() {
            return this.ae;
        }
        set thumbCalloutFontSize(a) {
            this.ae = a;
            this.g("ThumbCalloutFontSize");
        }
        get thumbCalloutFontStyle() {
            return this.bv;
        }
        set thumbCalloutFontStyle(a) {
            this.bv = a;
            this.g("ThumbCalloutFontStyle");
        }
        get thumbCalloutFontWeight() {
            return this.bw;
        }
        set thumbCalloutFontWeight(a) {
            this.bw = a;
            this.g("ThumbCalloutFontWeight");
        }
        get resolvingAxisValueRef() {
            return this.bt;
        }
        set resolvingAxisValueRef(a) {
            this.bt = a;
            this.g("ResolvingAxisValueRef");
        }
        get windowRectChangedRef() {
            return this.by;
        }
        set windowRectChangedRef(a) {
            this.by = a;
            this.g("WindowRectChangedRef");
        }
    }
    ZoomSliderDescription.$t = /*@__PURE__*/ markType(ZoomSliderDescription, 'ZoomSliderDescription', Description.$);
    return ZoomSliderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ZoomSliderDescriptionMetadata = /*@__PURE__*/ (() => {
    class ZoomSliderDescriptionMetadata extends Base {
        static e(a) {
            a.item("_qualifiedName", "String:Infragistics.Controls.Navigation.XamZoomSlider");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (ZoomSliderDescriptionMetadata.a == null) {
                ZoomSliderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ZoomSliderDescriptionMetadata.c(ZoomSliderDescriptionMetadata.a);
            }
            if (a.k(ZoomSliderDescriptionMetadata.a)) {
                return;
            }
            a.ac(ZoomSliderDescriptionMetadata.a);
            ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.d(a);
            RectChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("PanTransitionDuration", "Number:int");
            a.item("MaxZoomWidth", "Number:double");
            a.item("PixelScalingRatio", "Number:double");
            a.item("ActualPixelScalingRatio", "Number:double");
            a.item("WindowRect", "Rect");
            a.item("MinZoomWidth", "Number:double");
            a.item("StartInset", "Number:double");
            a.item("EndInset", "Number:double");
            a.item("TrackStartInset", "Number:double");
            a.item("TrackEndInset", "Number:double");
            a.item("BarExtent", "Number:double");
            a.item("Orientation", "ExportedType:string:ZoomSliderOrientation");
            a.item("Orientation@names", "Horizontal;Vertical");
            a.item("LowerThumbBrush", "Brush");
            a.item("LowerThumbStrokeThickness", "Number:double");
            a.item("HigherThumbStrokeThickness", "Number:double");
            a.item("HigherThumbBrush", "Brush");
            a.item("LowerThumbOutline", "Brush");
            a.item("HigherThumbOutline", "Brush");
            a.item("LowerThumbRidgesBrush", "Brush");
            a.item("HigherThumbRidgesBrush", "Brush");
            a.item("LowerThumbWidth", "Number:double");
            a.item("HigherThumbWidth", "Number:double");
            a.item("LowerThumbHeight", "Number:double");
            a.item("HigherThumbHeight", "Number:double");
            a.item("LowerShadeBrush", "Brush");
            a.item("LowerShadeOutline", "Brush");
            a.item("LowerShadeStrokeThickness", "Number:double");
            a.item("HigherShadeBrush", "Brush");
            a.item("HigherShadeOutline", "Brush");
            a.item("HigherShadeStrokeThickness", "Number:double");
            a.item("BarBrush", "Brush");
            a.item("BarOutline", "Brush");
            a.item("BarStrokeThickness", "Number:double");
            a.item("RangeThumbBrush", "Brush");
            a.item("RangeThumbOutline", "Brush");
            a.item("RangeThumbStrokeThickness", "Number:double");
            a.item("RangeThumbRidgesBrush", "Brush");
            a.item("LowerCalloutBrush", "Brush");
            a.item("LowerCalloutTextColor", "Brush");
            a.item("LowerCalloutOutline", "Brush");
            a.item("LowerCalloutStrokeThickness", "Number:double");
            a.item("HigherCalloutBrush", "Brush");
            a.item("HigherCalloutTextColor", "Brush");
            a.item("HigherCalloutOutline", "Brush");
            a.item("HigherCalloutStrokeThickness", "Number:double");
            a.item("AreThumbCalloutsEnabled", "Boolean");
            a.item("ThumbCalloutFontFamily", "(w:ThumbCalloutFontFamily/FontFamilyTransform,xam:ThumbCalloutFontFamily,wf:ThumbCalloutFontFamily,web:thumbCalloutTextStyle/FontFamilyTransform)String");
            a.item("ThumbCalloutFontSize", "(w:ThumbCalloutFontSize,xam:ThumbCalloutFontSize,wf:ThumbCalloutFontSize,web:thumbCalloutTextStyle/FontSizeTransform)Number:double");
            a.item("ThumbCalloutFontStyle", "(w:ThumbCalloutFontStyle/FontStyleTransform,xam:ThumbCalloutFontFamily/FontStyleTransform,wf:ThumbCalloutFontFamily/FontStyleTransform,web:thumbCalloutTextStyle/FontStyleTransform)String");
            a.item("ThumbCalloutFontWeight", "(w:ThumbCalloutFontWeight/FontWeightTransform,xam:ThumbCalloutFontFamily/FontWeightTransform,wf:ThumbCalloutFontFamily/FontWeightTransform,web:thumbCalloutTextStyle/FontWeightTransform)String");
            a.item("ResolvingAxisValueRef", "EventRef::resolvingAxisValue");
            a.item("WindowRectChangedRef", "EventRef::windowRectChanged");
            ZoomSliderDescriptionMetadata.e(a);
        }
        static d(a) {
            ZoomSliderDescriptionMetadata.b(a);
            a.ae("ZoomSlider", () => new ZoomSliderDescription());
            a.ad("ZoomSlider", ZoomSliderDescriptionMetadata.a);
        }
    }
    ZoomSliderDescriptionMetadata.$t = /*@__PURE__*/ markType(ZoomSliderDescriptionMetadata, 'ZoomSliderDescriptionMetadata');
    ZoomSliderDescriptionMetadata.a = null;
    return ZoomSliderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ZoomSliderDescriptionModule = /*@__PURE__*/ (() => {
    class ZoomSliderDescriptionModule extends Base {
        static register(a) {
            ZoomSliderDescriptionMetadata.d(a);
        }
    }
    ZoomSliderDescriptionModule.$t = /*@__PURE__*/ markType(ZoomSliderDescriptionModule, 'ZoomSliderDescriptionModule');
    return ZoomSliderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendMouseButtonEventArgsDescription = /*@__PURE__*/ (() => {
    class LegendMouseButtonEventArgsDescription extends Description {
        get_type() {
            return "LegendMouseButtonEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
            this.j = null;
            this.k = null;
        }
        get handled() {
            return this.h;
        }
        set handled(a) {
            this.h = a;
            this.g("Handled");
        }
        get itemRef() {
            return this.j;
        }
        set itemRef(a) {
            this.j = a;
            this.g("ItemRef");
        }
        get legendItemRef() {
            return this.k;
        }
        set legendItemRef(a) {
            this.k = a;
            this.g("LegendItemRef");
        }
    }
    LegendMouseButtonEventArgsDescription.$t = /*@__PURE__*/ markType(LegendMouseButtonEventArgsDescription, 'LegendMouseButtonEventArgsDescription', Description.$);
    return LegendMouseButtonEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendMouseButtonEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class LegendMouseButtonEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (LegendMouseButtonEventArgsDescriptionMetadata.a == null) {
                LegendMouseButtonEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LegendMouseButtonEventArgsDescriptionMetadata.c(LegendMouseButtonEventArgsDescriptionMetadata.a);
            }
            if (a.k(LegendMouseButtonEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(LegendMouseButtonEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Handled", "Boolean");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("LegendItemRef", "(w:LegendItem,wf:LegendItem)DataRef");
        }
        static d(a) {
            LegendMouseButtonEventArgsDescriptionMetadata.b(a);
            a.ae("LegendMouseButtonEventArgs", () => new LegendMouseButtonEventArgsDescription());
            a.ad("LegendMouseButtonEventArgs", LegendMouseButtonEventArgsDescriptionMetadata.a);
        }
    }
    LegendMouseButtonEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(LegendMouseButtonEventArgsDescriptionMetadata, 'LegendMouseButtonEventArgsDescriptionMetadata');
    LegendMouseButtonEventArgsDescriptionMetadata.a = null;
    return LegendMouseButtonEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendMouseEventArgsDescription = /*@__PURE__*/ (() => {
    class LegendMouseEventArgsDescription extends Description {
        get_type() {
            return "LegendMouseEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.i = null;
        }
        get itemRef() {
            return this.h;
        }
        set itemRef(a) {
            this.h = a;
            this.g("ItemRef");
        }
        get legendItemRef() {
            return this.i;
        }
        set legendItemRef(a) {
            this.i = a;
            this.g("LegendItemRef");
        }
    }
    LegendMouseEventArgsDescription.$t = /*@__PURE__*/ markType(LegendMouseEventArgsDescription, 'LegendMouseEventArgsDescription', Description.$);
    return LegendMouseEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendMouseEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class LegendMouseEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (LegendMouseEventArgsDescriptionMetadata.a == null) {
                LegendMouseEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LegendMouseEventArgsDescriptionMetadata.c(LegendMouseEventArgsDescriptionMetadata.a);
            }
            if (a.k(LegendMouseEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(LegendMouseEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("LegendItemRef", "(w:LegendItem,wf:LegendItem)DataRef");
        }
        static d(a) {
            LegendMouseEventArgsDescriptionMetadata.b(a);
            a.ae("LegendMouseEventArgs", () => new LegendMouseEventArgsDescription());
            a.ad("LegendMouseEventArgs", LegendMouseEventArgsDescriptionMetadata.a);
        }
    }
    LegendMouseEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(LegendMouseEventArgsDescriptionMetadata, 'LegendMouseEventArgsDescriptionMetadata');
    LegendMouseEventArgsDescriptionMetadata.a = null;
    return LegendMouseEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class LegendBaseDescriptionMetadata extends Base {
        static e(a) {
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (LegendBaseDescriptionMetadata.a == null) {
                LegendBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LegendBaseDescriptionMetadata.c(LegendBaseDescriptionMetadata.a);
            }
            if (a.k(LegendBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(LegendBaseDescriptionMetadata.a);
            LegendMouseButtonEventArgsDescriptionMetadata.d(a);
            LegendMouseEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("LegendItemMouseLeftButtonDownRef", "EventRef::legendItemMouseLeftButtonDown");
            a.item("LegendItemMouseLeftButtonUpRef", "EventRef::legendItemMouseLeftButtonUp");
            a.item("LegendItemMouseEnterRef", "EventRef::legendItemMouseEnter");
            a.item("LegendItemMouseLeaveRef", "EventRef::legendItemMouseLeave");
            a.item("LegendItemMouseMoveRef", "EventRef::legendItemMouseMove");
            LegendBaseDescriptionMetadata.e(a);
        }
        static d(a) {
            LegendBaseDescriptionMetadata.b(a);
            a.ad("LegendBase", LegendBaseDescriptionMetadata.a);
        }
    }
    LegendBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(LegendBaseDescriptionMetadata, 'LegendBaseDescriptionMetadata');
    LegendBaseDescriptionMetadata.a = null;
    return LegendBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendBaseDescription = /*@__PURE__*/ (() => {
    class LegendBaseDescription extends Description {
        get background() {
            return this.h;
        }
        set background(a) {
            this.h = a;
            this.g("Background");
        }
        get_type() {
            return "LegendBase";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.k = null;
            this.l = null;
            this.i = null;
            this.j = null;
            this.m = null;
        }
        get legendItemMouseLeftButtonDownRef() {
            return this.k;
        }
        set legendItemMouseLeftButtonDownRef(a) {
            this.k = a;
            this.g("LegendItemMouseLeftButtonDownRef");
        }
        get legendItemMouseLeftButtonUpRef() {
            return this.l;
        }
        set legendItemMouseLeftButtonUpRef(a) {
            this.l = a;
            this.g("LegendItemMouseLeftButtonUpRef");
        }
        get legendItemMouseEnterRef() {
            return this.i;
        }
        set legendItemMouseEnterRef(a) {
            this.i = a;
            this.g("LegendItemMouseEnterRef");
        }
        get legendItemMouseLeaveRef() {
            return this.j;
        }
        set legendItemMouseLeaveRef(a) {
            this.j = a;
            this.g("LegendItemMouseLeaveRef");
        }
        get legendItemMouseMoveRef() {
            return this.m;
        }
        set legendItemMouseMoveRef(a) {
            this.m = a;
            this.g("LegendItemMouseMoveRef");
        }
    }
    LegendBaseDescription.$t = /*@__PURE__*/ markType(LegendBaseDescription, 'LegendBaseDescription', Description.$);
    return LegendBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialLegendDescription = /*@__PURE__*/ (() => {
    class FinancialLegendDescription extends LegendBaseDescription {
        get_type() {
            return "FinancialLegend";
        }
        constructor() {
            super();
        }
    }
    FinancialLegendDescription.$t = /*@__PURE__*/ markType(FinancialLegendDescription, 'FinancialLegendDescription', LegendBaseDescription.$);
    return FinancialLegendDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialLegendDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialLegendDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialLegendDescriptionMetadata.a == null) {
                FinancialLegendDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialLegendDescriptionMetadata.c(FinancialLegendDescriptionMetadata.a);
            }
            if (a.k(FinancialLegendDescriptionMetadata.a)) {
                return;
            }
            a.ac(FinancialLegendDescriptionMetadata.a);
        }
        static c(a) {
            LegendBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            FinancialLegendDescriptionMetadata.b(a);
            a.ae("FinancialLegend", () => new FinancialLegendDescription());
            a.ad("FinancialLegend", FinancialLegendDescriptionMetadata.a);
        }
    }
    FinancialLegendDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialLegendDescriptionMetadata, 'FinancialLegendDescriptionMetadata');
    FinancialLegendDescriptionMetadata.a = null;
    return FinancialLegendDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialLegendDescriptionModule = /*@__PURE__*/ (() => {
    class FinancialLegendDescriptionModule extends Base {
        static register(a) {
            FinancialLegendDescriptionMetadata.d(a);
        }
    }
    FinancialLegendDescriptionModule.$t = /*@__PURE__*/ markType(FinancialLegendDescriptionModule, 'FinancialLegendDescriptionModule');
    return FinancialLegendDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartDescriptionModule = /*@__PURE__*/ (() => {
    class FinancialChartDescriptionModule extends Base {
        static register(a) {
            LineSeriesDescriptionModule.register(a);
            AreaSeriesDescriptionModule.register(a);
            ColumnSeriesDescriptionModule.register(a);
            NumericYAxisDescriptionModule.register(a);
            TimeXAxisDescriptionModule.register(a);
            TimeAxisBreakDescriptionModule.register(a);
            TimeAxisIntervalDescriptionModule.register(a);
            TimeAxisLabelFormatDescriptionModule.register(a);
            CategoryXAxisDescriptionModule.register(a);
            OrdinalTimeXAxisDescriptionModule.register(a);
            PercentChangeYAxisDescriptionModule.register(a);
            FinancialPriceSeriesDescriptionModule.register(a);
            DataChartCategoryTrendLineDescriptionModule.register(a);
            IndicatorsDescriptionModule.register(a);
            OverlaysDescriptionModule.register(a);
            ZoomSliderDescriptionModule.register(a);
            CrosshairLayerDescriptionModule.register(a);
            CalloutLayerDescriptionModule.register(a);
            ItemToolTipLayerDescriptionModule.register(a);
            CategoryToolTipLayerDescriptionModule.register(a);
            CategoryHighlightLayerDescriptionModule.register(a);
            CategoryItemHighlightLayerDescriptionModule.register(a);
            DataToolTipLayerDescriptionModule.register(a);
            FinalValueLayerDescriptionModule.register(a);
            NumberAbbreviatorDescriptionModule.register(a);
            DataChartInteractivityDescriptionModule.register(a);
            DataChartAnnotationDescriptionModule.register(a);
            FinancialLegendDescriptionModule.register(a);
            FinancialChartCoreDescriptionModule.register(a);
        }
    }
    FinancialChartDescriptionModule.$t = /*@__PURE__*/ markType(FinancialChartDescriptionModule, 'FinancialChartDescriptionModule');
    return FinancialChartDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FocusOptionsDescription = /*@__PURE__*/ (() => {
    class FocusOptionsDescription extends Description {
        get_type() {
            return "FocusOptions";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = false;
        }
        get preventScroll() {
            return this.i;
        }
        set preventScroll(a) {
            this.i = a;
            this.g("PreventScroll");
        }
    }
    FocusOptionsDescription.$t = /*@__PURE__*/ markType(FocusOptionsDescription, 'FocusOptionsDescription', Description.$);
    FocusOptionsDescription.__marshalByValue = true;
    FocusOptionsDescription.__marshalByValueAlias = "FocusOptions";
    return FocusOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FocusOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FocusOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (FocusOptionsDescriptionMetadata.a == null) {
                FocusOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FocusOptionsDescriptionMetadata.c(FocusOptionsDescriptionMetadata.a);
            }
            if (a.k(FocusOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(FocusOptionsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("PreventScroll", "Boolean");
        }
        static d(a) {
            FocusOptionsDescriptionMetadata.b(a);
            a.ae("FocusOptions", () => new FocusOptionsDescription());
            a.ad("FocusOptions", FocusOptionsDescriptionMetadata.a);
        }
    }
    FocusOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(FocusOptionsDescriptionMetadata, 'FocusOptionsDescriptionMetadata');
    FocusOptionsDescriptionMetadata.a = null;
    return FocusOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunnelChartDescription = /*@__PURE__*/ (() => {
    class FunnelChartDescription extends Description {
        get_type() {
            return "FunnelChart";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.aq = null;
            this.be = null;
            this.au = null;
            this.v = 0;
            this.x = 0;
            this.ap = null;
            this.av = null;
            this.h = null;
            this.i = null;
            this.w = 0;
            this.aw = null;
            this.a0 = null;
            this.ax = null;
            this.a3 = null;
            this.az = null;
            this.at = null;
            this.ar = null;
            this.as = null;
            this.an = 0;
            this.m = false;
            this.n = false;
            this.l = false;
            this.p = false;
            this.a4 = null;
            this.a5 = null;
            this.ab = 0;
            this.aa = 0;
            this.bc = null;
            this.bd = null;
            this.ad = 0;
            this.ac = 0;
            this.ay = null;
            this.o = false;
            this.bb = null;
            this.a2 = null;
            this.y = 0;
            this.z = 0;
            this.a1 = null;
            this.ba = null;
            this.a6 = null;
            this.a7 = null;
            this.a9 = null;
            this.a8 = null;
        }
        get dataSourceRef() {
            return this.aq;
        }
        set dataSourceRef(a) {
            this.aq = a;
            this.g("DataSourceRef");
        }
        get valueMemberPath() {
            return this.be;
        }
        set valueMemberPath(a) {
            this.be = a;
            this.g("ValueMemberPath");
        }
        get highlightedValueMemberPath() {
            return this.au;
        }
        set highlightedValueMemberPath(a) {
            this.au = a;
            this.g("HighlightedValueMemberPath");
        }
        get actualHighlightValueOpacity() {
            return this.v;
        }
        set actualHighlightValueOpacity(a) {
            this.v = a;
            this.g("ActualHighlightValueOpacity");
        }
        get highlightValueOpacity() {
            return this.x;
        }
        set highlightValueOpacity(a) {
            this.x = a;
            this.g("HighlightValueOpacity");
        }
        get actualHighlightValueDisplayMode() {
            return this.ap;
        }
        set actualHighlightValueDisplayMode(a) {
            this.ap = a;
            this.g("ActualHighlightValueDisplayMode");
        }
        get highlightValueDisplayMode() {
            return this.av;
        }
        set highlightValueDisplayMode(a) {
            this.av = a;
            this.g("HighlightValueDisplayMode");
        }
        get brushes() {
            return this.h;
        }
        set brushes(a) {
            this.h = a;
            this.g("Brushes");
        }
        get outlines() {
            return this.i;
        }
        set outlines(a) {
            this.i = a;
            this.g("Outlines");
        }
        get bottomEdgeWidth() {
            return this.w;
        }
        set bottomEdgeWidth(a) {
            this.w = a;
            this.g("BottomEdgeWidth");
        }
        get innerLabelMemberPath() {
            return this.aw;
        }
        set innerLabelMemberPath(a) {
            this.aw = a;
            this.g("InnerLabelMemberPath");
        }
        get outerLabelMemberPath() {
            return this.a0;
        }
        set outerLabelMemberPath(a) {
            this.a0 = a;
            this.g("OuterLabelMemberPath");
        }
        get innerLabelVisibility() {
            return this.ax;
        }
        set innerLabelVisibility(a) {
            this.ax = a;
            this.g("InnerLabelVisibility");
        }
        get outerLabelVisibility() {
            return this.a3;
        }
        set outerLabelVisibility(a) {
            this.a3 = a;
            this.g("OuterLabelVisibility");
        }
        get outerLabelAlignment() {
            return this.az;
        }
        set outerLabelAlignment(a) {
            this.az = a;
            this.g("OuterLabelAlignment");
        }
        get funnelSliceDisplay() {
            return this.at;
        }
        set funnelSliceDisplay(a) {
            this.at = a;
            this.g("FunnelSliceDisplay");
        }
        get formatInnerLabelRef() {
            return this.ar;
        }
        set formatInnerLabelRef(a) {
            this.ar = a;
            this.g("FormatInnerLabelRef");
        }
        get formatOuterLabelRef() {
            return this.as;
        }
        set formatOuterLabelRef(a) {
            this.as = a;
            this.g("FormatOuterLabelRef");
        }
        get transitionDuration() {
            return this.an;
        }
        set transitionDuration(a) {
            this.an = a;
            this.g("TransitionDuration");
        }
        get isInverted() {
            return this.m;
        }
        set isInverted(a) {
            this.m = a;
            this.g("IsInverted");
        }
        get useBezierCurve() {
            return this.n;
        }
        set useBezierCurve(a) {
            this.n = a;
            this.g("UseBezierCurve");
        }
        get allowSliceSelection() {
            return this.l;
        }
        set allowSliceSelection(a) {
            this.l = a;
            this.g("AllowSliceSelection");
        }
        get useUnselectedStyle() {
            return this.p;
        }
        set useUnselectedStyle(a) {
            this.p = a;
            this.g("UseUnselectedStyle");
        }
        get selectedSliceFill() {
            return this.a4;
        }
        set selectedSliceFill(a) {
            this.a4 = a;
            this.g("SelectedSliceFill");
        }
        get selectedSliceStroke() {
            return this.a5;
        }
        set selectedSliceStroke(a) {
            this.a5 = a;
            this.g("SelectedSliceStroke");
        }
        get selectedSliceStrokeThickness() {
            return this.ab;
        }
        set selectedSliceStrokeThickness(a) {
            this.ab = a;
            this.g("SelectedSliceStrokeThickness");
        }
        get selectedSliceOpacity() {
            return this.aa;
        }
        set selectedSliceOpacity(a) {
            this.aa = a;
            this.g("SelectedSliceOpacity");
        }
        get unselectedSliceFill() {
            return this.bc;
        }
        set unselectedSliceFill(a) {
            this.bc = a;
            this.g("UnselectedSliceFill");
        }
        get unselectedSliceStroke() {
            return this.bd;
        }
        set unselectedSliceStroke(a) {
            this.bd = a;
            this.g("UnselectedSliceStroke");
        }
        get unselectedSliceStrokeThickness() {
            return this.ad;
        }
        set unselectedSliceStrokeThickness(a) {
            this.ad = a;
            this.g("UnselectedSliceStrokeThickness");
        }
        get unselectedSliceOpacity() {
            return this.ac;
        }
        set unselectedSliceOpacity(a) {
            this.ac = a;
            this.g("UnselectedSliceOpacity");
        }
        get legendItemBadgeTemplateRef() {
            return this.ay;
        }
        set legendItemBadgeTemplateRef(a) {
            this.ay = a;
            this.g("LegendItemBadgeTemplateRef");
        }
        get useOuterLabelsForLegend() {
            return this.o;
        }
        set useOuterLabelsForLegend(a) {
            this.o = a;
            this.g("UseOuterLabelsForLegend");
        }
        get textStyle() {
            return this.bb;
        }
        set textStyle(a) {
            this.bb = a;
            this.g("TextStyle");
        }
        get outerLabelTextStyle() {
            return this.a2;
        }
        set outerLabelTextStyle(a) {
            this.a2 = a;
            this.g("OuterLabelTextStyle");
        }
        get outlineThickness() {
            return this.y;
        }
        set outlineThickness(a) {
            this.y = a;
            this.g("OutlineThickness");
        }
        get pixelScalingRatio() {
            return this.z;
        }
        set pixelScalingRatio(a) {
            this.z = a;
            this.g("PixelScalingRatio");
        }
        get outerLabelTextColor() {
            return this.a1;
        }
        set outerLabelTextColor(a) {
            this.a1 = a;
            this.g("OuterLabelTextColor");
        }
        get textColor() {
            return this.ba;
        }
        set textColor(a) {
            this.ba = a;
            this.g("TextColor");
        }
        get sliceClickedRef() {
            return this.a6;
        }
        set sliceClickedRef(a) {
            this.a6 = a;
            this.g("SliceClickedRef");
        }
        get sliceEnterRef() {
            return this.a7;
        }
        set sliceEnterRef(a) {
            this.a7 = a;
            this.g("SliceEnterRef");
        }
        get sliceLeaveRef() {
            return this.a9;
        }
        set sliceLeaveRef(a) {
            this.a9 = a;
            this.g("SliceLeaveRef");
        }
        get sliceHoverRef() {
            return this.a8;
        }
        set sliceHoverRef(a) {
            this.a8 = a;
            this.g("SliceHoverRef");
        }
    }
    FunnelChartDescription.$t = /*@__PURE__*/ markType(FunnelChartDescription, 'FunnelChartDescription', Description.$);
    return FunnelChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunnelSliceClickedEventArgsDescription = /*@__PURE__*/ (() => {
    class FunnelSliceClickedEventArgsDescription extends Description {
        get_type() {
            return "FunnelSliceClickedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = 0;
            this.h = null;
            this.l = null;
        }
        get index() {
            return this.j;
        }
        set index(a) {
            this.j = a;
            this.g("Index");
        }
        get bounds() {
            return this.h;
        }
        set bounds(a) {
            this.h = a;
            this.g("Bounds");
        }
        get itemRef() {
            return this.l;
        }
        set itemRef(a) {
            this.l = a;
            this.g("ItemRef");
        }
    }
    FunnelSliceClickedEventArgsDescription.$t = /*@__PURE__*/ markType(FunnelSliceClickedEventArgsDescription, 'FunnelSliceClickedEventArgsDescription', Description.$);
    return FunnelSliceClickedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunnelSliceClickedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FunnelSliceClickedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FunnelSliceClickedEventArgsDescriptionMetadata.a == null) {
                FunnelSliceClickedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FunnelSliceClickedEventArgsDescriptionMetadata.c(FunnelSliceClickedEventArgsDescriptionMetadata.a);
            }
            if (a.k(FunnelSliceClickedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(FunnelSliceClickedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Index", "Number:int");
            a.item("Bounds", "Rect");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
        }
        static d(a) {
            FunnelSliceClickedEventArgsDescriptionMetadata.b(a);
            a.ae("FunnelSliceClickedEventArgs", () => new FunnelSliceClickedEventArgsDescription());
            a.ad("FunnelSliceClickedEventArgs", FunnelSliceClickedEventArgsDescriptionMetadata.a);
        }
    }
    FunnelSliceClickedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FunnelSliceClickedEventArgsDescriptionMetadata, 'FunnelSliceClickedEventArgsDescriptionMetadata');
    FunnelSliceClickedEventArgsDescriptionMetadata.a = null;
    return FunnelSliceClickedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunnelSliceEventArgsDescription = /*@__PURE__*/ (() => {
    class FunnelSliceEventArgsDescription extends Description {
        get_type() {
            return "FunnelSliceEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = 0;
            this.j = null;
            this.n = null;
            this.h = null;
        }
        get index() {
            return this.l;
        }
        set index(a) {
            this.l = a;
            this.g("Index");
        }
        get bounds() {
            return this.j;
        }
        set bounds(a) {
            this.j = a;
            this.g("Bounds");
        }
        get itemRef() {
            return this.n;
        }
        set itemRef(a) {
            this.n = a;
            this.g("ItemRef");
        }
        get position() {
            return this.h;
        }
        set position(a) {
            this.h = a;
            this.g("Position");
        }
    }
    FunnelSliceEventArgsDescription.$t = /*@__PURE__*/ markType(FunnelSliceEventArgsDescription, 'FunnelSliceEventArgsDescription', Description.$);
    return FunnelSliceEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunnelSliceEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FunnelSliceEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FunnelSliceEventArgsDescriptionMetadata.a == null) {
                FunnelSliceEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FunnelSliceEventArgsDescriptionMetadata.c(FunnelSliceEventArgsDescriptionMetadata.a);
            }
            if (a.k(FunnelSliceEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(FunnelSliceEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Index", "Number:int");
            a.item("Bounds", "Rect");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("Position", "Point");
        }
        static d(a) {
            FunnelSliceEventArgsDescriptionMetadata.b(a);
            a.ae("FunnelSliceEventArgs", () => new FunnelSliceEventArgsDescription());
            a.ad("FunnelSliceEventArgs", FunnelSliceEventArgsDescriptionMetadata.a);
        }
    }
    FunnelSliceEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FunnelSliceEventArgsDescriptionMetadata, 'FunnelSliceEventArgsDescriptionMetadata');
    FunnelSliceEventArgsDescriptionMetadata.a = null;
    return FunnelSliceEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunnelChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class FunnelChartDescriptionMetadata extends Base {
        static b(a) {
            if (FunnelChartDescriptionMetadata.a == null) {
                FunnelChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FunnelChartDescriptionMetadata.c(FunnelChartDescriptionMetadata.a);
            }
            if (a.k(FunnelChartDescriptionMetadata.a)) {
                return;
            }
            a.ac(FunnelChartDescriptionMetadata.a);
            FunnelSliceClickedEventArgsDescriptionMetadata.d(a);
            FunnelSliceEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)DataRef::object");
            a.item("ValueMemberPath", "String");
            a.item("HighlightedValueMemberPath", "String");
            a.item("ActualHighlightValueOpacity", "Number:double");
            a.item("HighlightValueOpacity", "Number:double");
            a.item("ActualHighlightValueDisplayMode", "ExportedType:string:HighlightedValueDisplayMode");
            a.item("ActualHighlightValueDisplayMode@names", "Auto;Hidden;Overlay");
            a.item("HighlightValueDisplayMode", "ExportedType:string:HighlightedValueDisplayMode");
            a.item("HighlightValueDisplayMode@names", "Auto;Hidden;Overlay");
            a.item("Brushes", "BrushCollection:string");
            a.item("Outlines", "BrushCollection:string");
            a.item("BottomEdgeWidth", "Number:double");
            a.item("InnerLabelMemberPath", "String");
            a.item("OuterLabelMemberPath", "String");
            a.item("InnerLabelVisibility", "ExportedType:string:Visibility");
            a.item("InnerLabelVisibility@names", "Visible;Collapsed");
            a.item("OuterLabelVisibility", "ExportedType:string:Visibility");
            a.item("OuterLabelVisibility@names", "Visible;Collapsed");
            a.item("OuterLabelAlignment", "ExportedType:string:OuterLabelAlignment");
            a.item("OuterLabelAlignment@names", "Left;Right");
            a.item("FunnelSliceDisplay", "ExportedType:string:FunnelSliceDisplay");
            a.item("FunnelSliceDisplay@names", "Uniform;Weighted");
            a.item("FormatInnerLabelRef", "(w:FormatInnerLabel,wf:FormatInnerLabel)MethodRef");
            a.item("FormatOuterLabelRef", "(w:FormatOuterLabel,wf:FormatOuterLabel)MethodRef");
            a.item("TransitionDuration", "Number:int");
            a.item("IsInverted", "Boolean");
            a.item("UseBezierCurve", "Boolean");
            a.item("AllowSliceSelection", "Boolean");
            a.item("UseUnselectedStyle", "Boolean");
            a.item("SelectedSliceFill", "(w:SelectedSliceStyle.Fill,wf:SelectedSliceFill)String");
            a.item("SelectedSliceStroke", "(w:SelectedSliceStyle.Stroke,wf:SelectedSliceStroke)String");
            a.item("SelectedSliceStrokeThickness", "(w:SelectedSliceStyle.StrokeThickness,wf:SelectedSliceStrokeThickness)Number:double");
            a.item("SelectedSliceOpacity", "(w:SelectedSliceStyle.Opacity,wf:SelectedSliceOpacity)Number:double");
            a.item("UnselectedSliceFill", "(w:UnselectedSliceStyle.Fill,wf:UnselectedSliceFill)String");
            a.item("UnselectedSliceStroke", "(w:UnselectedSliceStyle.Stroke,wf:UnselectedSliceStroke)String");
            a.item("UnselectedSliceStrokeThickness", "(w:UnselectedSliceStyle.StrokeThickness,wf:UnselectedSliceStrokeThickness)Number:double");
            a.item("UnselectedSliceOpacity", "(w:UnselectedSliceStyle.Opacity,wf:UnselectedSliceOpacity)Number:double");
            a.item("LegendItemBadgeTemplateRef", "(w:LegendItemBadgeTemplate,wf:LegendItemBadgeTemplate)DataRef::object");
            a.item("UseOuterLabelsForLegend", "Boolean");
            a.item("TextStyle", "String");
            a.item("OuterLabelTextStyle", "String");
            a.item("OutlineThickness", "Number:double");
            a.item("PixelScalingRatio", "Number:double");
            a.item("OuterLabelTextColor", "Brush");
            a.item("TextColor", "Brush");
            a.item("SliceClickedRef", "EventRef::sliceClicked");
            a.item("SliceEnterRef", "EventRef::sliceEnter");
            a.item("SliceLeaveRef", "EventRef::sliceLeave");
            a.item("SliceHoverRef", "EventRef::sliceHover");
        }
        static d(a) {
            FunnelChartDescriptionMetadata.b(a);
            a.ae("FunnelChart", () => new FunnelChartDescription());
            a.ad("FunnelChart", FunnelChartDescriptionMetadata.a);
        }
    }
    FunnelChartDescriptionMetadata.$t = /*@__PURE__*/ markType(FunnelChartDescriptionMetadata, 'FunnelChartDescriptionMetadata');
    FunnelChartDescriptionMetadata.a = null;
    return FunnelChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunnelChartCoreDescriptionModule = /*@__PURE__*/ (() => {
    class FunnelChartCoreDescriptionModule extends Base {
        static register(a) {
            NumberFormatSpecifierDescriptionModule.register(a);
            DateTimeFormatSpecifierDescriptionModule.register(a);
            FunnelChartDescriptionMetadata.d(a);
        }
    }
    FunnelChartCoreDescriptionModule.$t = /*@__PURE__*/ markType(FunnelChartCoreDescriptionModule, 'FunnelChartCoreDescriptionModule');
    return FunnelChartCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunnelChartDescriptionModule = /*@__PURE__*/ (() => {
    class FunnelChartDescriptionModule extends Base {
        static register(a) {
            FunnelChartCoreDescriptionModule.register(a);
            DataChartInteractivityDescriptionModule.register(a);
        }
    }
    FunnelChartDescriptionModule.$t = /*@__PURE__*/ markType(FunnelChartDescriptionModule, 'FunnelChartDescriptionModule');
    return FunnelChartDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunnelDataContextDescription = /*@__PURE__*/ (() => {
    class FunnelDataContextDescription extends Description {
        get_type() {
            return "FunnelDataContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = 0;
        }
        get itemRef() {
            return this.j;
        }
        set itemRef(a) {
            this.j = a;
            this.g("ItemRef");
        }
        get index() {
            return this.h;
        }
        set index(a) {
            this.h = a;
            this.g("Index");
        }
    }
    FunnelDataContextDescription.$t = /*@__PURE__*/ markType(FunnelDataContextDescription, 'FunnelDataContextDescription', Description.$);
    return FunnelDataContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunnelDataContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class FunnelDataContextDescriptionMetadata extends Base {
        static b(a) {
            if (FunnelDataContextDescriptionMetadata.a == null) {
                FunnelDataContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FunnelDataContextDescriptionMetadata.c(FunnelDataContextDescriptionMetadata.a);
            }
            if (a.k(FunnelDataContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(FunnelDataContextDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("Index", "Number:int");
        }
        static d(a) {
            FunnelDataContextDescriptionMetadata.b(a);
            a.ae("FunnelDataContext", () => new FunnelDataContextDescription());
            a.ad("FunnelDataContext", FunnelDataContextDescriptionMetadata.a);
        }
    }
    FunnelDataContextDescriptionMetadata.$t = /*@__PURE__*/ markType(FunnelDataContextDescriptionMetadata, 'FunnelDataContextDescriptionMetadata');
    FunnelDataContextDescriptionMetadata.a = null;
    return FunnelDataContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataContextDescription = /*@__PURE__*/ (() => {
    class DataContextDescription extends Description {
        get_type() {
            return "DataContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.o = null;
            this.l = null;
            this.q = null;
            this.n = null;
            this.m = null;
            this.i = 0;
            this.p = null;
        }
        get itemRef() {
            return this.o;
        }
        set itemRef(a) {
            this.o = a;
            this.g("ItemRef");
        }
        get actualItemBrush() {
            return this.l;
        }
        set actualItemBrush(a) {
            this.l = a;
            this.g("ActualItemBrush");
        }
        get outline() {
            return this.q;
        }
        set outline(a) {
            this.q = a;
            this.g("Outline");
        }
        get itemLabelRef() {
            return this.n;
        }
        set itemLabelRef(a) {
            this.n = a;
            this.g("ItemLabelRef");
        }
        get itemBrush() {
            return this.m;
        }
        set itemBrush(a) {
            this.m = a;
            this.g("ItemBrush");
        }
        get thickness() {
            return this.i;
        }
        set thickness(a) {
            this.i = a;
            this.g("Thickness");
        }
        get legendLabelRef() {
            return this.p;
        }
        set legendLabelRef(a) {
            this.p = a;
            this.g("LegendLabelRef");
        }
    }
    DataContextDescription.$t = /*@__PURE__*/ markType(DataContextDescription, 'DataContextDescription', Description.$);
    DataContextDescription.__marshalByValue = true;
    DataContextDescription.__marshalByValueAlias = "DataContext";
    return DataContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunnelSliceDataContextDescription = /*@__PURE__*/ (() => {
    class FunnelSliceDataContextDescription extends DataContextDescription {
        get_type() {
            return "FunnelSliceDataContext";
        }
        constructor() {
            super();
            this.aa = null;
        }
        get itemOutline() {
            return this.aa;
        }
        set itemOutline(a) {
            this.aa = a;
            this.g("ItemOutline");
        }
    }
    FunnelSliceDataContextDescription.$t = /*@__PURE__*/ markType(FunnelSliceDataContextDescription, 'FunnelSliceDataContextDescription', DataContextDescription.$);
    FunnelSliceDataContextDescription.__marshalByValue1 = true;
    FunnelSliceDataContextDescription.__marshalByValueAlias1 = "FunnelSliceDataContext";
    return FunnelSliceDataContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataContextDescriptionMetadata extends Base {
        static b(a) {
            if (DataContextDescriptionMetadata.a == null) {
                DataContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataContextDescriptionMetadata.c(DataContextDescriptionMetadata.a);
            }
            if (a.k(DataContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataContextDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("ActualItemBrush", "Brush");
            a.item("Outline", "Brush");
            a.item("ItemLabelRef", "(w:ItemLabel,wf:ItemLabel)DataRef");
            a.item("ItemBrush", "Brush");
            a.item("Thickness", "Number:double");
            a.item("LegendLabelRef", "(w:LegendLabel,wf:LegendLabel)DataRef");
        }
        static d(a) {
            DataContextDescriptionMetadata.b(a);
            a.ae("DataContext", () => new DataContextDescription());
            a.ad("DataContext", DataContextDescriptionMetadata.a);
        }
    }
    DataContextDescriptionMetadata.$t = /*@__PURE__*/ markType(DataContextDescriptionMetadata, 'DataContextDescriptionMetadata');
    DataContextDescriptionMetadata.a = null;
    return DataContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunnelSliceDataContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class FunnelSliceDataContextDescriptionMetadata extends Base {
        static b(a) {
            if (FunnelSliceDataContextDescriptionMetadata.a == null) {
                FunnelSliceDataContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FunnelSliceDataContextDescriptionMetadata.c(FunnelSliceDataContextDescriptionMetadata.a);
            }
            if (a.k(FunnelSliceDataContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(FunnelSliceDataContextDescriptionMetadata.a);
        }
        static c(a) {
            DataContextDescriptionMetadata.c(a);
            a.item("ItemOutline", "Brush");
        }
        static d(a) {
            FunnelSliceDataContextDescriptionMetadata.b(a);
            a.ae("FunnelSliceDataContext", () => new FunnelSliceDataContextDescription());
            a.ad("FunnelSliceDataContext", FunnelSliceDataContextDescriptionMetadata.a);
        }
    }
    FunnelSliceDataContextDescriptionMetadata.$t = /*@__PURE__*/ markType(FunnelSliceDataContextDescriptionMetadata, 'FunnelSliceDataContextDescriptionMetadata');
    FunnelSliceDataContextDescriptionMetadata.a = null;
    return FunnelSliceDataContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMapSeriesHostDescription = /*@__PURE__*/ (() => {
    class GeographicMapSeriesHostDescription extends SeriesDescription {
        get_type() {
            return "GeographicMapSeriesHost";
        }
        constructor() {
            super();
            this.e1 = 0;
            this.e3 = null;
        }
        get visibleFromScale() {
            return this.e1;
        }
        set visibleFromScale(a) {
            this.e1 = a;
            this.g("VisibleFromScale");
        }
        get coercionMethodsRef() {
            return this.e3;
        }
        set coercionMethodsRef(a) {
            this.e3 = a;
            this.g("CoercionMethodsRef");
        }
    }
    GeographicMapSeriesHostDescription.$t = /*@__PURE__*/ markType(GeographicMapSeriesHostDescription, 'GeographicMapSeriesHostDescription', SeriesDescription.$);
    return GeographicMapSeriesHostDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicXYTriangulatingSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicXYTriangulatingSeriesDescription extends GeographicMapSeriesHostDescription {
        get_type() {
            return "GeographicXYTriangulatingSeries";
        }
        constructor() {
            super();
            this.e6 = null;
            this.e5 = null;
            this.e7 = null;
            this.e8 = null;
            this.e9 = null;
            this.fa = null;
        }
        get longitudeMemberPath() {
            return this.e6;
        }
        set longitudeMemberPath(a) {
            this.e6 = a;
            this.g("LongitudeMemberPath");
        }
        get latitudeMemberPath() {
            return this.e5;
        }
        set latitudeMemberPath(a) {
            this.e5 = a;
            this.g("LatitudeMemberPath");
        }
        get trianglesSourceRef() {
            return this.e7;
        }
        set trianglesSourceRef(a) {
            this.e7 = a;
            this.g("TrianglesSourceRef");
        }
        get triangleVertexMemberPath1() {
            return this.e8;
        }
        set triangleVertexMemberPath1(a) {
            this.e8 = a;
            this.g("TriangleVertexMemberPath1");
        }
        get triangleVertexMemberPath2() {
            return this.e9;
        }
        set triangleVertexMemberPath2(a) {
            this.e9 = a;
            this.g("TriangleVertexMemberPath2");
        }
        get triangleVertexMemberPath3() {
            return this.fa;
        }
        set triangleVertexMemberPath3(a) {
            this.fa = a;
            this.g("TriangleVertexMemberPath3");
        }
    }
    GeographicXYTriangulatingSeriesDescription.$t = /*@__PURE__*/ markType(GeographicXYTriangulatingSeriesDescription, 'GeographicXYTriangulatingSeriesDescription', GeographicMapSeriesHostDescription.$);
    return GeographicXYTriangulatingSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicContourLineSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicContourLineSeriesDescription extends GeographicXYTriangulatingSeriesDescription {
        get_type() {
            return "GeographicContourLineSeries";
        }
        constructor() {
            super();
            this.fo = null;
            this.fk = null;
            this.fj = null;
            this.fh = null;
            this.fn = null;
        }
        get valueMemberPath() {
            return this.fo;
        }
        set valueMemberPath(a) {
            this.fo = a;
            this.g("ValueMemberPath");
        }
        get fillScale() {
            return this.fk;
        }
        set fillScale(a) {
            this.fk = a;
            this.g("FillScale");
        }
        get actualFillScale() {
            return this.fj;
        }
        set actualFillScale(a) {
            this.fj = a;
            this.g("ActualFillScale");
        }
        get valueResolver() {
            return this.fh;
        }
        set valueResolver(a) {
            this.fh = a;
            this.g("ValueResolver");
        }
        get triangulationStatusChangedRef() {
            return this.fn;
        }
        set triangulationStatusChangedRef(a) {
            this.fn = a;
            this.g("TriangulationStatusChangedRef");
        }
    }
    GeographicContourLineSeriesDescription.$t = /*@__PURE__*/ markType(GeographicContourLineSeriesDescription, 'GeographicContourLineSeriesDescription', GeographicXYTriangulatingSeriesDescription.$);
    return GeographicContourLineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMapSeriesHostDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicMapSeriesHostDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicMapSeriesHostDescriptionMetadata.a == null) {
                GeographicMapSeriesHostDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicMapSeriesHostDescriptionMetadata.c(GeographicMapSeriesHostDescriptionMetadata.a);
            }
            if (a.k(GeographicMapSeriesHostDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicMapSeriesHostDescriptionMetadata.a);
        }
        static c(a) {
            SeriesDescriptionMetadata.c(a);
            a.item("VisibleFromScale", "Number:double");
            a.item("CoercionMethodsRef", "(w:CoercionMethods,wf:CoercionMethods)DataRef");
        }
        static d(a) {
            GeographicMapSeriesHostDescriptionMetadata.b(a);
            a.ad("GeographicMapSeriesHost", GeographicMapSeriesHostDescriptionMetadata.a);
        }
    }
    GeographicMapSeriesHostDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicMapSeriesHostDescriptionMetadata, 'GeographicMapSeriesHostDescriptionMetadata');
    GeographicMapSeriesHostDescriptionMetadata.a = null;
    return GeographicMapSeriesHostDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicXYTriangulatingSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicXYTriangulatingSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicXYTriangulatingSeriesDescriptionMetadata.a == null) {
                GeographicXYTriangulatingSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicXYTriangulatingSeriesDescriptionMetadata.c(GeographicXYTriangulatingSeriesDescriptionMetadata.a);
            }
            if (a.k(GeographicXYTriangulatingSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicXYTriangulatingSeriesDescriptionMetadata.a);
        }
        static c(a) {
            GeographicMapSeriesHostDescriptionMetadata.c(a);
            a.item("LongitudeMemberPath", "String");
            a.item("LatitudeMemberPath", "String");
            a.item("TrianglesSourceRef", "(w:TrianglesSource,wf:TrianglesSource)DataRef::object");
            a.item("TriangleVertexMemberPath1", "String");
            a.item("TriangleVertexMemberPath2", "String");
            a.item("TriangleVertexMemberPath3", "String");
        }
        static d(a) {
            GeographicXYTriangulatingSeriesDescriptionMetadata.b(a);
            a.ad("GeographicXYTriangulatingSeries", GeographicXYTriangulatingSeriesDescriptionMetadata.a);
        }
    }
    GeographicXYTriangulatingSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicXYTriangulatingSeriesDescriptionMetadata, 'GeographicXYTriangulatingSeriesDescriptionMetadata');
    GeographicXYTriangulatingSeriesDescriptionMetadata.a = null;
    return GeographicXYTriangulatingSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicContourLineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicContourLineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicContourLineSeriesDescriptionMetadata.a == null) {
                GeographicContourLineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicContourLineSeriesDescriptionMetadata.c(GeographicContourLineSeriesDescriptionMetadata.a);
            }
            if (a.k(GeographicContourLineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicContourLineSeriesDescriptionMetadata.a);
            ValueBrushScaleDescriptionMetadata.d(a);
            ContourValueResolverDescriptionMetadata.d(a);
            TriangulationStatusEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            GeographicXYTriangulatingSeriesDescriptionMetadata.c(a);
            a.item("ValueMemberPath", "String");
            a.item("FillScale", "ExportedType:ValueBrushScale");
            a.item("ActualFillScale", "ExportedType:ValueBrushScale");
            a.item("ValueResolver", "ExportedType:ContourValueResolver");
            a.item("TriangulationStatusChangedRef", "EventRef::triangulationStatusChanged");
        }
        static d(a) {
            GeographicContourLineSeriesDescriptionMetadata.b(a);
            a.ae("GeographicContourLineSeries", () => new GeographicContourLineSeriesDescription());
            a.ad("GeographicContourLineSeries", GeographicContourLineSeriesDescriptionMetadata.a);
        }
    }
    GeographicContourLineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicContourLineSeriesDescriptionMetadata, 'GeographicContourLineSeriesDescriptionMetadata');
    GeographicContourLineSeriesDescriptionMetadata.a = null;
    return GeographicContourLineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicContourLineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicContourLineSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicContourLineSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicContourLineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicContourLineSeriesDescriptionModule, 'GeographicContourLineSeriesDescriptionModule');
    return GeographicContourLineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicHighDensityScatterSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicHighDensityScatterSeriesDescription extends GeographicMapSeriesHostDescription {
        get_type() {
            return "GeographicHighDensityScatterSeries";
        }
        constructor() {
            super();
            this.fj = null;
            this.fk = null;
            this.e6 = false;
            this.e5 = false;
            this.fa = 0;
            this.e9 = 0;
            this.fi = null;
            this.fh = null;
            this.fd = 0;
            this.fe = 0;
            this.fl = null;
        }
        get latitudeMemberPath() {
            return this.fj;
        }
        set latitudeMemberPath(a) {
            this.fj = a;
            this.g("LatitudeMemberPath");
        }
        get longitudeMemberPath() {
            return this.fk;
        }
        set longitudeMemberPath(a) {
            this.fk = a;
            this.g("LongitudeMemberPath");
        }
        get useBruteForce() {
            return this.e6;
        }
        set useBruteForce(a) {
            this.e6 = a;
            this.g("UseBruteForce");
        }
        get progressiveLoad() {
            return this.e5;
        }
        set progressiveLoad(a) {
            this.e5 = a;
            this.g("ProgressiveLoad");
        }
        get heatMinimum() {
            return this.fa;
        }
        set heatMinimum(a) {
            this.fa = a;
            this.g("HeatMinimum");
        }
        get heatMaximum() {
            return this.e9;
        }
        set heatMaximum(a) {
            this.e9 = a;
            this.g("HeatMaximum");
        }
        get heatMinimumColor() {
            return this.fi;
        }
        set heatMinimumColor(a) {
            this.fi = a;
            this.g("HeatMinimumColor");
        }
        get heatMaximumColor() {
            return this.fh;
        }
        set heatMaximumColor(a) {
            this.fh = a;
            this.g("HeatMaximumColor");
        }
        get pointExtent() {
            return this.fd;
        }
        set pointExtent(a) {
            this.fd = a;
            this.g("PointExtent");
        }
        get progressiveStatus() {
            return this.fe;
        }
        set progressiveStatus(a) {
            this.fe = a;
            this.g("ProgressiveStatus");
        }
        get progressiveLoadStatusChangedRef() {
            return this.fl;
        }
        set progressiveLoadStatusChangedRef(a) {
            this.fl = a;
            this.g("ProgressiveLoadStatusChangedRef");
        }
    }
    GeographicHighDensityScatterSeriesDescription.$t = /*@__PURE__*/ markType(GeographicHighDensityScatterSeriesDescription, 'GeographicHighDensityScatterSeriesDescription', GeographicMapSeriesHostDescription.$);
    return GeographicHighDensityScatterSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicHighDensityScatterSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicHighDensityScatterSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicHighDensityScatterSeriesDescriptionMetadata.a == null) {
                GeographicHighDensityScatterSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicHighDensityScatterSeriesDescriptionMetadata.c(GeographicHighDensityScatterSeriesDescriptionMetadata.a);
            }
            if (a.k(GeographicHighDensityScatterSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicHighDensityScatterSeriesDescriptionMetadata.a);
            ProgressiveLoadStatusEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            GeographicMapSeriesHostDescriptionMetadata.c(a);
            a.item("LatitudeMemberPath", "String");
            a.item("LongitudeMemberPath", "String");
            a.item("UseBruteForce", "Boolean");
            a.item("ProgressiveLoad", "Boolean");
            a.item("HeatMinimum", "Number:double");
            a.item("HeatMaximum", "Number:double");
            a.item("HeatMinimumColor", "Color");
            a.item("HeatMaximumColor", "Color");
            a.item("PointExtent", "Number:int");
            a.item("ProgressiveStatus", "Number:int");
            a.item("ProgressiveLoadStatusChangedRef", "EventRef::progressiveLoadStatusChanged");
        }
        static d(a) {
            GeographicHighDensityScatterSeriesDescriptionMetadata.b(a);
            a.ae("GeographicHighDensityScatterSeries", () => new GeographicHighDensityScatterSeriesDescription());
            a.ad("GeographicHighDensityScatterSeries", GeographicHighDensityScatterSeriesDescriptionMetadata.a);
        }
    }
    GeographicHighDensityScatterSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicHighDensityScatterSeriesDescriptionMetadata, 'GeographicHighDensityScatterSeriesDescriptionMetadata');
    GeographicHighDensityScatterSeriesDescriptionMetadata.a = null;
    return GeographicHighDensityScatterSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicHighDensityScatterSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicHighDensityScatterSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicHighDensityScatterSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicHighDensityScatterSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicHighDensityScatterSeriesDescriptionModule, 'GeographicHighDensityScatterSeriesDescriptionModule');
    return GeographicHighDensityScatterSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OpenStreetMapImageryDescription = /*@__PURE__*/ (() => {
    class OpenStreetMapImageryDescription extends GeographicMapImageryDescription {
        get_type() {
            return "OpenStreetMapImagery";
        }
        constructor() {
            super();
            this.ac = null;
        }
        get tilePath() {
            return this.ac;
        }
        set tilePath(a) {
            this.ac = a;
            this.g("TilePath");
        }
    }
    OpenStreetMapImageryDescription.$t = /*@__PURE__*/ markType(OpenStreetMapImageryDescription, 'OpenStreetMapImageryDescription', GeographicMapImageryDescription.$);
    return OpenStreetMapImageryDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OpenStreetMapImageryDescriptionMetadata = /*@__PURE__*/ (() => {
    class OpenStreetMapImageryDescriptionMetadata extends Base {
        static b(a) {
            if (OpenStreetMapImageryDescriptionMetadata.a == null) {
                OpenStreetMapImageryDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OpenStreetMapImageryDescriptionMetadata.c(OpenStreetMapImageryDescriptionMetadata.a);
            }
            if (a.k(OpenStreetMapImageryDescriptionMetadata.a)) {
                return;
            }
            a.ac(OpenStreetMapImageryDescriptionMetadata.a);
        }
        static c(a) {
            GeographicMapImageryDescriptionMetadata.c(a);
            a.item("TilePath", "String");
        }
        static d(a) {
            OpenStreetMapImageryDescriptionMetadata.b(a);
            a.ae("OpenStreetMapImagery", () => new OpenStreetMapImageryDescription());
            a.ad("OpenStreetMapImagery", OpenStreetMapImageryDescriptionMetadata.a);
        }
    }
    OpenStreetMapImageryDescriptionMetadata.$t = /*@__PURE__*/ markType(OpenStreetMapImageryDescriptionMetadata, 'OpenStreetMapImageryDescriptionMetadata');
    OpenStreetMapImageryDescriptionMetadata.a = null;
    return OpenStreetMapImageryDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OpenStreetMapImageryDescriptionModule = /*@__PURE__*/ (() => {
    class OpenStreetMapImageryDescriptionModule extends Base {
        static register(a) {
            OpenStreetMapImageryDescriptionMetadata.d(a);
        }
    }
    OpenStreetMapImageryDescriptionModule.$t = /*@__PURE__*/ markType(OpenStreetMapImageryDescriptionModule, 'OpenStreetMapImageryDescriptionModule');
    return OpenStreetMapImageryDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMapCoreDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicMapCoreDescriptionModule extends Base {
        static register(a) {
            BingMapsMapImageryDescriptionModule.register(a);
            OpenStreetMapImageryDescriptionModule.register(a);
            CustomMapImageryDescriptionModule.register(a);
            ArcGISOnlineMapImageryDescriptionModule.register(a);
            GeographicMapDescriptionMetadata.d(a);
        }
    }
    GeographicMapCoreDescriptionModule.$t = /*@__PURE__*/ markType(GeographicMapCoreDescriptionModule, 'GeographicMapCoreDescriptionModule');
    return GeographicMapCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapefileRecordDescription = /*@__PURE__*/ (() => {
    class ShapefileRecordDescription extends Description {
        get_type() {
            return "ShapefileRecord";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = null;
        }
        get fieldValuesRef() {
            return this.j;
        }
        set fieldValuesRef(a) {
            this.j = a;
            this.g("FieldValuesRef");
        }
        get bounds() {
            return this.h;
        }
        set bounds(a) {
            this.h = a;
            this.g("Bounds");
        }
    }
    ShapefileRecordDescription.$t = /*@__PURE__*/ markType(ShapefileRecordDescription, 'ShapefileRecordDescription', Description.$);
    return ShapefileRecordDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapefileRecordDescriptionMetadata = /*@__PURE__*/ (() => {
    class ShapefileRecordDescriptionMetadata extends Base {
        static b(a) {
            if (ShapefileRecordDescriptionMetadata.a == null) {
                ShapefileRecordDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ShapefileRecordDescriptionMetadata.c(ShapefileRecordDescriptionMetadata.a);
            }
            if (a.k(ShapefileRecordDescriptionMetadata.a)) {
                return;
            }
            a.ac(ShapefileRecordDescriptionMetadata.a);
        }
        static c(a) {
            a.item("FieldValuesRef", "(w:FieldValues,wf:FieldValues)DataRef");
            a.item("Bounds", "Rect");
        }
        static d(a) {
            ShapefileRecordDescriptionMetadata.b(a);
            a.ae("ShapefileRecord", () => new ShapefileRecordDescription());
            a.ad("ShapefileRecord", ShapefileRecordDescriptionMetadata.a);
        }
    }
    ShapefileRecordDescriptionMetadata.$t = /*@__PURE__*/ markType(ShapefileRecordDescriptionMetadata, 'ShapefileRecordDescriptionMetadata');
    ShapefileRecordDescriptionMetadata.a = null;
    return ShapefileRecordDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeFilterRecordEventArgsDescription = /*@__PURE__*/ (() => {
    class ShapeFilterRecordEventArgsDescription extends Description {
        get_type() {
            return "ShapeFilterRecordEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = false;
        }
        get record() {
            return this.h;
        }
        set record(a) {
            this.h = a;
            this.g("Record");
        }
        get shouldInclude() {
            return this.j;
        }
        set shouldInclude(a) {
            this.j = a;
            this.g("ShouldInclude");
        }
    }
    ShapeFilterRecordEventArgsDescription.$t = /*@__PURE__*/ markType(ShapeFilterRecordEventArgsDescription, 'ShapeFilterRecordEventArgsDescription', Description.$);
    return ShapeFilterRecordEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeFilterRecordEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ShapeFilterRecordEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ShapeFilterRecordEventArgsDescriptionMetadata.a == null) {
                ShapeFilterRecordEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ShapeFilterRecordEventArgsDescriptionMetadata.c(ShapeFilterRecordEventArgsDescriptionMetadata.a);
            }
            if (a.k(ShapeFilterRecordEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ShapeFilterRecordEventArgsDescriptionMetadata.a);
            ShapefileRecordDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Record", "ExportedType:ShapefileRecord");
            a.item("ShouldInclude", "Boolean");
        }
        static d(a) {
            ShapeFilterRecordEventArgsDescriptionMetadata.b(a);
            a.ae("ShapeFilterRecordEventArgs", () => new ShapeFilterRecordEventArgsDescription());
            a.ad("ShapeFilterRecordEventArgs", ShapeFilterRecordEventArgsDescriptionMetadata.a);
        }
    }
    ShapeFilterRecordEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ShapeFilterRecordEventArgsDescriptionMetadata, 'ShapeFilterRecordEventArgsDescriptionMetadata');
    ShapeFilterRecordEventArgsDescriptionMetadata.a = null;
    return ShapeFilterRecordEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeDataSourceDescription = /*@__PURE__*/ (() => {
    class ShapeDataSourceDescription extends Description {
        get_type() {
            return "ShapeDataSource";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
            this.l = false;
            this.r = null;
            this.n = null;
            this.q = null;
            this.p = null;
            this.o = null;
        }
        get worldRect() {
            return this.i;
        }
        set worldRect(a) {
            this.i = a;
            this.g("WorldRect");
        }
        get computedWorldRect() {
            return this.h;
        }
        set computedWorldRect(a) {
            this.h = a;
            this.g("ComputedWorldRect");
        }
        get deferImportCompleted() {
            return this.l;
        }
        set deferImportCompleted(a) {
            this.l = a;
            this.g("DeferImportCompleted");
        }
        get shapefileSource() {
            return this.r;
        }
        set shapefileSource(a) {
            this.r = a;
            this.g("ShapefileSource");
        }
        get databaseSource() {
            return this.n;
        }
        set databaseSource(a) {
            this.n = a;
            this.g("DatabaseSource");
        }
        get importPendingRef() {
            return this.q;
        }
        set importPendingRef(a) {
            this.q = a;
            this.g("ImportPendingRef");
        }
        get importCompletedRef() {
            return this.p;
        }
        set importCompletedRef(a) {
            this.p = a;
            this.g("ImportCompletedRef");
        }
        get filterRef() {
            return this.o;
        }
        set filterRef(a) {
            this.o = a;
            this.g("FilterRef");
        }
    }
    ShapeDataSourceDescription.$t = /*@__PURE__*/ markType(ShapeDataSourceDescription, 'ShapeDataSourceDescription', Description.$);
    return ShapeDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class ShapeDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (ShapeDataSourceDescriptionMetadata.a == null) {
                ShapeDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ShapeDataSourceDescriptionMetadata.c(ShapeDataSourceDescriptionMetadata.a);
            }
            if (a.k(ShapeDataSourceDescriptionMetadata.a)) {
                return;
            }
            a.ac(ShapeDataSourceDescriptionMetadata.a);
            AsyncCompletedEventArgsDescriptionMetadata.d(a);
            ShapeFilterRecordEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("WorldRect", "Rect");
            a.item("ComputedWorldRect", "Rect");
            a.item("DeferImportCompleted", "Boolean");
            a.item("ShapefileSource", "String");
            a.item("DatabaseSource", "String");
            a.item("ImportPendingRef", "EventRef::importPending");
            a.item("ImportCompletedRef", "EventRef::importCompleted");
            a.item("FilterRef", "EventRef::filter");
        }
        static d(a) {
            ShapeDataSourceDescriptionMetadata.b(a);
            a.ae("ShapeDataSource", () => new ShapeDataSourceDescription());
            a.ad("ShapeDataSource", ShapeDataSourceDescriptionMetadata.a);
        }
    }
    ShapeDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(ShapeDataSourceDescriptionMetadata, 'ShapeDataSourceDescriptionMetadata');
    ShapeDataSourceDescriptionMetadata.a = null;
    return ShapeDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicShapeSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicShapeSeriesBaseDescriptionMetadata.a == null) {
                GeographicShapeSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicShapeSeriesBaseDescriptionMetadata.c(GeographicShapeSeriesBaseDescriptionMetadata.a);
            }
            if (a.k(GeographicShapeSeriesBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicShapeSeriesBaseDescriptionMetadata.a);
            ShapeDataSourceDescriptionMetadata.d(a);
            AssigningShapeStyleEventArgsDescriptionMetadata.d(a);
            AssigningShapeMarkerStyleEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            GeographicMapSeriesHostDescriptionMetadata.c(a);
            a.item("ShapeMemberPath", "String");
            a.item("IsCustomShapeStyleAllowed", "Boolean");
            a.item("IsCustomShapeMarkerStyleAllowed", "Boolean");
            a.item("ItemSearchMode", "ExportedType:string:ShapeItemSearchMode");
            a.item("ItemSearchMode@names", "Auto;ClosestBoundingBox;ClosestShape;ClosestPointOnClosestShape;None");
            a.item("ItemSearchThreshold", "Number:int");
            a.item("ItemSearchPointsThreshold", "Number:int");
            a.item("ShapefileDataSource", "ExportedType:ShapefileConverter");
            a.item("ShapeFilterResolution", "Number:double");
            a.item("AssigningShapeStyleRef", "EventRef::assigningShapeStyle");
            a.item("AssigningShapeMarkerStyleRef", "EventRef::assigningShapeMarkerStyle");
        }
        static d(a) {
            GeographicShapeSeriesBaseDescriptionMetadata.b(a);
            a.ad("GeographicShapeSeriesBase", GeographicShapeSeriesBaseDescriptionMetadata.a);
        }
    }
    GeographicShapeSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicShapeSeriesBaseDescriptionMetadata, 'GeographicShapeSeriesBaseDescriptionMetadata');
    GeographicShapeSeriesBaseDescriptionMetadata.a = null;
    return GeographicShapeSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicShapeSeriesBaseDescription = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesBaseDescription extends GeographicMapSeriesHostDescription {
        get_type() {
            return "GeographicShapeSeriesBase";
        }
        constructor() {
            super();
            this.fk = null;
            this.e8 = false;
            this.e7 = false;
            this.fj = null;
            this.fe = 0;
            this.fd = 0;
            this.e5 = null;
            this.fb = 0;
            this.fi = null;
            this.fh = null;
        }
        get shapeMemberPath() {
            return this.fk;
        }
        set shapeMemberPath(a) {
            this.fk = a;
            this.g("ShapeMemberPath");
        }
        get isCustomShapeStyleAllowed() {
            return this.e8;
        }
        set isCustomShapeStyleAllowed(a) {
            this.e8 = a;
            this.g("IsCustomShapeStyleAllowed");
        }
        get isCustomShapeMarkerStyleAllowed() {
            return this.e7;
        }
        set isCustomShapeMarkerStyleAllowed(a) {
            this.e7 = a;
            this.g("IsCustomShapeMarkerStyleAllowed");
        }
        get itemSearchMode() {
            return this.fj;
        }
        set itemSearchMode(a) {
            this.fj = a;
            this.g("ItemSearchMode");
        }
        get itemSearchThreshold() {
            return this.fe;
        }
        set itemSearchThreshold(a) {
            this.fe = a;
            this.g("ItemSearchThreshold");
        }
        get itemSearchPointsThreshold() {
            return this.fd;
        }
        set itemSearchPointsThreshold(a) {
            this.fd = a;
            this.g("ItemSearchPointsThreshold");
        }
        get shapefileDataSource() {
            return this.e5;
        }
        set shapefileDataSource(a) {
            this.e5 = a;
            this.g("ShapefileDataSource");
        }
        get shapeFilterResolution() {
            return this.fb;
        }
        set shapeFilterResolution(a) {
            this.fb = a;
            this.g("ShapeFilterResolution");
        }
        get assigningShapeStyleRef() {
            return this.fi;
        }
        set assigningShapeStyleRef(a) {
            this.fi = a;
            this.g("AssigningShapeStyleRef");
        }
        get assigningShapeMarkerStyleRef() {
            return this.fh;
        }
        set assigningShapeMarkerStyleRef(a) {
            this.fh = a;
            this.g("AssigningShapeMarkerStyleRef");
        }
    }
    GeographicShapeSeriesBaseDescription.$t = /*@__PURE__*/ markType(GeographicShapeSeriesBaseDescription, 'GeographicShapeSeriesBaseDescription', GeographicMapSeriesHostDescription.$);
    return GeographicShapeSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicShapeSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesDescription extends GeographicShapeSeriesBaseDescription {
        get_type() {
            return "GeographicShapeSeries";
        }
        constructor() {
            super();
            this.f7 = null;
            this.f5 = null;
            this.f6 = null;
            this.fr = 0;
            this.fq = 0;
            this.f4 = null;
            this.f2 = null;
            this.f0 = null;
            this.f3 = null;
            this.fy = null;
            this.f1 = null;
            this.fp = 0;
            this.fz = null;
            this.fx = null;
            this.fv = null;
            this.fw = null;
            this.f8 = null;
        }
        get shapeStyleSelectorRef() {
            return this.f7;
        }
        set shapeStyleSelectorRef(a) {
            this.f7 = a;
            this.g("ShapeStyleSelectorRef");
        }
        get shapeFill() {
            return this.f5;
        }
        set shapeFill(a) {
            this.f5 = a;
            this.g("ShapeFill");
        }
        get shapeStroke() {
            return this.f6;
        }
        set shapeStroke(a) {
            this.f6 = a;
            this.g("ShapeStroke");
        }
        get shapeStrokeThickness() {
            return this.fr;
        }
        set shapeStrokeThickness(a) {
            this.fr = a;
            this.g("ShapeStrokeThickness");
        }
        get shapeOpacity() {
            return this.fq;
        }
        set shapeOpacity(a) {
            this.fq = a;
            this.g("ShapeOpacity");
        }
        get markerType() {
            return this.f4;
        }
        set markerType(a) {
            this.f4 = a;
            this.g("MarkerType");
        }
        get markerOutlineMode() {
            return this.f2;
        }
        set markerOutlineMode(a) {
            this.f2 = a;
            this.g("MarkerOutlineMode");
        }
        get markerFillMode() {
            return this.f0;
        }
        set markerFillMode(a) {
            this.f0 = a;
            this.g("MarkerFillMode");
        }
        get markerTemplateRef() {
            return this.f3;
        }
        set markerTemplateRef(a) {
            this.f3 = a;
            this.g("MarkerTemplateRef");
        }
        get markerBrush() {
            return this.fy;
        }
        set markerBrush(a) {
            this.fy = a;
            this.g("MarkerBrush");
        }
        get markerOutline() {
            return this.f1;
        }
        set markerOutline(a) {
            this.f1 = a;
            this.g("MarkerOutline");
        }
        get markerThickness() {
            return this.fp;
        }
        set markerThickness(a) {
            this.fp = a;
            this.g("MarkerThickness");
        }
        get markerCollisionAvoidance() {
            return this.fz;
        }
        set markerCollisionAvoidance(a) {
            this.fz = a;
            this.g("MarkerCollisionAvoidance");
        }
        get actualMarkerTemplateRef() {
            return this.fx;
        }
        set actualMarkerTemplateRef(a) {
            this.fx = a;
            this.g("ActualMarkerTemplateRef");
        }
        get actualMarkerBrush() {
            return this.fv;
        }
        set actualMarkerBrush(a) {
            this.fv = a;
            this.g("ActualMarkerBrush");
        }
        get actualMarkerOutline() {
            return this.fw;
        }
        set actualMarkerOutline(a) {
            this.fw = a;
            this.g("ActualMarkerOutline");
        }
        get styleShapeRef() {
            return this.f8;
        }
        set styleShapeRef(a) {
            this.f8 = a;
            this.g("StyleShapeRef");
        }
    }
    GeographicShapeSeriesDescription.$t = /*@__PURE__*/ markType(GeographicShapeSeriesDescription, 'GeographicShapeSeriesDescription', GeographicShapeSeriesBaseDescription.$);
    return GeographicShapeSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicShapeSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicShapeSeriesDescriptionMetadata.a == null) {
                GeographicShapeSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicShapeSeriesDescriptionMetadata.c(GeographicShapeSeriesDescriptionMetadata.a);
            }
            if (a.k(GeographicShapeSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicShapeSeriesDescriptionMetadata.a);
            StyleShapeEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            GeographicShapeSeriesBaseDescriptionMetadata.c(a);
            a.item("ShapeStyleSelectorRef", "(w:ShapeStyleSelector,wf:ShapeStyleSelector)DataRef::object");
            a.item("ShapeFill", "(w:ShapeStyle.Fill,wf:ShapeFill)String");
            a.item("ShapeStroke", "(w:ShapeStyle.Stroke,wf:ShapeStroke)String");
            a.item("ShapeStrokeThickness", "(w:ShapeStyle.StrokeThickness,wf:ShapeStrokeThickness)Number:double");
            a.item("ShapeOpacity", "(w:ShapeStyle.Opacity,wf:ShapeOpacity)Number:double");
            a.item("MarkerType", "ExportedType:string:MarkerType");
            a.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            a.item("MarkerOutlineMode", "ExportedType:string:MarkerOutlineMode");
            a.item("MarkerOutlineMode@names", "Auto;Normal;MatchMarkerBrush");
            a.item("MarkerFillMode", "ExportedType:string:MarkerFillMode");
            a.item("MarkerFillMode@names", "Auto;Normal;MatchMarkerOutline");
            a.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            a.item("MarkerBrush", "Brush");
            a.item("MarkerOutline", "Brush");
            a.item("MarkerThickness", "Number:double");
            a.item("MarkerCollisionAvoidance", "ExportedType:string:CollisionAvoidanceType");
            a.item("MarkerCollisionAvoidance@names", "None;Omit;Fade;OmitAndShift;FadeAndShift");
            a.item("ActualMarkerTemplateRef", "(w:ActualMarkerTemplate,wf:ActualMarkerTemplate)DataRef::object");
            a.item("ActualMarkerBrush", "Brush");
            a.item("ActualMarkerOutline", "Brush");
            a.item("StyleShapeRef", "EventRef::styleShape");
        }
        static d(a) {
            GeographicShapeSeriesDescriptionMetadata.b(a);
            a.ae("GeographicShapeSeries", () => new GeographicShapeSeriesDescription());
            a.ad("GeographicShapeSeries", GeographicShapeSeriesDescriptionMetadata.a);
        }
    }
    GeographicShapeSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicShapeSeriesDescriptionMetadata, 'GeographicShapeSeriesDescriptionMetadata');
    GeographicShapeSeriesDescriptionMetadata.a = null;
    return GeographicShapeSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicShapeSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicShapeSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicShapeSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicShapeSeriesDescriptionModule, 'GeographicShapeSeriesDescriptionModule');
    return GeographicShapeSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicPolylineSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicPolylineSeriesDescription extends GeographicShapeSeriesBaseDescription {
        get_type() {
            return "GeographicPolylineSeries";
        }
        constructor() {
            super();
            this.fv = null;
            this.ft = null;
            this.fu = null;
            this.fq = 0;
            this.fp = 0;
            this.fw = null;
        }
        get shapeStyleSelectorRef() {
            return this.fv;
        }
        set shapeStyleSelectorRef(a) {
            this.fv = a;
            this.g("ShapeStyleSelectorRef");
        }
        get shapeFill() {
            return this.ft;
        }
        set shapeFill(a) {
            this.ft = a;
            this.g("ShapeFill");
        }
        get shapeStroke() {
            return this.fu;
        }
        set shapeStroke(a) {
            this.fu = a;
            this.g("ShapeStroke");
        }
        get shapeStrokeThickness() {
            return this.fq;
        }
        set shapeStrokeThickness(a) {
            this.fq = a;
            this.g("ShapeStrokeThickness");
        }
        get shapeOpacity() {
            return this.fp;
        }
        set shapeOpacity(a) {
            this.fp = a;
            this.g("ShapeOpacity");
        }
        get styleShapeRef() {
            return this.fw;
        }
        set styleShapeRef(a) {
            this.fw = a;
            this.g("StyleShapeRef");
        }
    }
    GeographicPolylineSeriesDescription.$t = /*@__PURE__*/ markType(GeographicPolylineSeriesDescription, 'GeographicPolylineSeriesDescription', GeographicShapeSeriesBaseDescription.$);
    return GeographicPolylineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicPolylineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicPolylineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicPolylineSeriesDescriptionMetadata.a == null) {
                GeographicPolylineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicPolylineSeriesDescriptionMetadata.c(GeographicPolylineSeriesDescriptionMetadata.a);
            }
            if (a.k(GeographicPolylineSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicPolylineSeriesDescriptionMetadata.a);
            StyleShapeEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            GeographicShapeSeriesBaseDescriptionMetadata.c(a);
            a.item("ShapeStyleSelectorRef", "(w:ShapeStyleSelector,wf:ShapeStyleSelector)DataRef::object");
            a.item("ShapeFill", "(w:ShapeStyle.Fill,wf:ShapeFill)String");
            a.item("ShapeStroke", "(w:ShapeStyle.Stroke,wf:ShapeStroke)String");
            a.item("ShapeStrokeThickness", "(w:ShapeStyle.StrokeThickness,wf:ShapeStrokeThickness)Number:double");
            a.item("ShapeOpacity", "(w:ShapeStyle.Opacity,wf:ShapeOpacity)Number:double");
            a.item("StyleShapeRef", "EventRef::styleShape");
        }
        static d(a) {
            GeographicPolylineSeriesDescriptionMetadata.b(a);
            a.ae("GeographicPolylineSeries", () => new GeographicPolylineSeriesDescription());
            a.ad("GeographicPolylineSeries", GeographicPolylineSeriesDescriptionMetadata.a);
        }
    }
    GeographicPolylineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicPolylineSeriesDescriptionMetadata, 'GeographicPolylineSeriesDescriptionMetadata');
    GeographicPolylineSeriesDescriptionMetadata.a = null;
    return GeographicPolylineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicPolylineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicPolylineSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicPolylineSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicPolylineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicPolylineSeriesDescriptionModule, 'GeographicPolylineSeriesDescriptionModule');
    return GeographicPolylineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileGeneratorMapImageryDescription = /*@__PURE__*/ (() => {
    class TileGeneratorMapImageryDescription extends GeographicMapImageryDescription {
        get_type() {
            return "TileGeneratorMapImagery";
        }
        constructor() {
            super();
            this.ac = null;
        }
        get tileGenerator() {
            return this.ac;
        }
        set tileGenerator(a) {
            this.ac = a;
            this.g("TileGenerator");
        }
    }
    TileGeneratorMapImageryDescription.$t = /*@__PURE__*/ markType(TileGeneratorMapImageryDescription, 'TileGeneratorMapImageryDescription', GeographicMapImageryDescription.$);
    return TileGeneratorMapImageryDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileGeneratorMapImageryDescriptionMetadata = /*@__PURE__*/ (() => {
    class TileGeneratorMapImageryDescriptionMetadata extends Base {
        static b(a) {
            if (TileGeneratorMapImageryDescriptionMetadata.a == null) {
                TileGeneratorMapImageryDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TileGeneratorMapImageryDescriptionMetadata.c(TileGeneratorMapImageryDescriptionMetadata.a);
            }
            if (a.k(TileGeneratorMapImageryDescriptionMetadata.a)) {
                return;
            }
            a.ac(TileGeneratorMapImageryDescriptionMetadata.a);
        }
        static c(a) {
            GeographicMapImageryDescriptionMetadata.c(a);
            a.item("TileGenerator", "ExportedType");
        }
        static d(a) {
            TileGeneratorMapImageryDescriptionMetadata.b(a);
            a.ae("TileGeneratorMapImagery", () => new TileGeneratorMapImageryDescription());
            a.ad("TileGeneratorMapImagery", TileGeneratorMapImageryDescriptionMetadata.a);
        }
    }
    TileGeneratorMapImageryDescriptionMetadata.$t = /*@__PURE__*/ markType(TileGeneratorMapImageryDescriptionMetadata, 'TileGeneratorMapImageryDescriptionMetadata');
    TileGeneratorMapImageryDescriptionMetadata.a = null;
    return TileGeneratorMapImageryDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileGeneratorMapImageryDescriptionModule = /*@__PURE__*/ (() => {
    class TileGeneratorMapImageryDescriptionModule extends Base {
        static register(a) {
            TileGeneratorMapImageryDescriptionMetadata.d(a);
        }
    }
    TileGeneratorMapImageryDescriptionModule.$t = /*@__PURE__*/ markType(TileGeneratorMapImageryDescriptionModule, 'TileGeneratorMapImageryDescriptionModule');
    return TileGeneratorMapImageryDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileGeneratorDescription = /*@__PURE__*/ (() => {
    class TileGeneratorDescription extends Description {
        get_type() {
            return "TileGenerator";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    TileGeneratorDescription.$t = /*@__PURE__*/ markType(TileGeneratorDescription, 'TileGeneratorDescription', Description.$);
    return TileGeneratorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileGeneratorDescription = /*@__PURE__*/ (() => {
    class HeatTileGeneratorDescription extends TileGeneratorDescription {
        get_type() {
            return "HeatTileGenerator";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.m = null;
            this.l = null;
            this.k = null;
            this.an = null;
            this.am = null;
            this.j = null;
            this.i = null;
            this.ac = 0;
            this.ae = 0;
            this.s = false;
            this.t = false;
            this.u = false;
            this.ag = 0;
            this.af = 0;
            this.ad = 0;
            this.v = false;
            this.w = false;
            this.ap = null;
            this.ao = null;
        }
        get yValues() {
            return this.m;
        }
        set yValues(a) {
            this.m = a;
            this.g("YValues");
        }
        get xValues() {
            return this.l;
        }
        set xValues(a) {
            this.l = a;
            this.g("XValues");
        }
        get values() {
            return this.k;
        }
        set values(a) {
            this.k = a;
            this.g("Values");
        }
        get minimumColor() {
            return this.an;
        }
        set minimumColor(a) {
            this.an = a;
            this.g("MinimumColor");
        }
        get maximumColor() {
            return this.am;
        }
        set maximumColor(a) {
            this.am = a;
            this.g("MaximumColor");
        }
        get scaleColors() {
            return this.j;
        }
        set scaleColors(a) {
            this.j = a;
            this.g("ScaleColors");
        }
        get scaleColorOffsets() {
            return this.i;
        }
        set scaleColorOffsets(a) {
            this.i = a;
            this.g("ScaleColorOffsets");
        }
        get blurRadius() {
            return this.ac;
        }
        set blurRadius(a) {
            this.ac = a;
            this.g("BlurRadius");
        }
        get maxBlurRadius() {
            return this.ae;
        }
        set maxBlurRadius(a) {
            this.ae = a;
            this.g("MaxBlurRadius");
        }
        get useBlurRadiusAdjustedForZoom() {
            return this.s;
        }
        set useBlurRadiusAdjustedForZoom(a) {
            this.s = a;
            this.g("UseBlurRadiusAdjustedForZoom");
        }
        get useGlobalMinMax() {
            return this.t;
        }
        set useGlobalMinMax(a) {
            this.t = a;
            this.g("UseGlobalMinMax");
        }
        get useGlobalMinMaxAdjustedForZoom() {
            return this.u;
        }
        set useGlobalMinMaxAdjustedForZoom(a) {
            this.u = a;
            this.g("UseGlobalMinMaxAdjustedForZoom");
        }
        get minimumValue() {
            return this.ag;
        }
        set minimumValue(a) {
            this.ag = a;
            this.g("MinimumValue");
        }
        get maximumValue() {
            return this.af;
        }
        set maximumValue(a) {
            this.af = a;
            this.g("MaximumValue");
        }
        get logarithmBase() {
            return this.ad;
        }
        set logarithmBase(a) {
            this.ad = a;
            this.g("LogarithmBase");
        }
        get useLogarithmicScale() {
            return this.v;
        }
        set useLogarithmicScale(a) {
            this.v = a;
            this.g("UseLogarithmicScale");
        }
        get useWebWorkers() {
            return this.w;
        }
        set useWebWorkers(a) {
            this.w = a;
            this.g("UseWebWorkers");
        }
        get webWorkerScriptPath() {
            return this.ap;
        }
        set webWorkerScriptPath(a) {
            this.ap = a;
            this.g("WebWorkerScriptPath");
        }
        get webWorkerInstanceRef() {
            return this.ao;
        }
        set webWorkerInstanceRef(a) {
            this.ao = a;
            this.g("WebWorkerInstanceRef");
        }
    }
    HeatTileGeneratorDescription.$t = /*@__PURE__*/ markType(HeatTileGeneratorDescription, 'HeatTileGeneratorDescription', TileGeneratorDescription.$);
    return HeatTileGeneratorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileGeneratorDescriptionMetadata = /*@__PURE__*/ (() => {
    class HeatTileGeneratorDescriptionMetadata extends Base {
        static b(a) {
            if (HeatTileGeneratorDescriptionMetadata.a == null) {
                HeatTileGeneratorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HeatTileGeneratorDescriptionMetadata.c(HeatTileGeneratorDescriptionMetadata.a);
            }
            if (a.k(HeatTileGeneratorDescriptionMetadata.a)) {
                return;
            }
            a.ac(HeatTileGeneratorDescriptionMetadata.a);
        }
        static c(a) {
            a.item("YValues", "Array:double");
            a.item("XValues", "Array:double");
            a.item("Values", "Array:double");
            a.item("MinimumColor", "Color");
            a.item("MaximumColor", "Color");
            a.item("ScaleColors", "Array:string:Color");
            a.item("ScaleColorOffsets", "Array:double");
            a.item("BlurRadius", "Number:double");
            a.item("MaxBlurRadius", "Number:double");
            a.item("UseBlurRadiusAdjustedForZoom", "Boolean");
            a.item("UseGlobalMinMax", "Boolean");
            a.item("UseGlobalMinMaxAdjustedForZoom", "Boolean");
            a.item("MinimumValue", "Number:double");
            a.item("MaximumValue", "Number:double");
            a.item("LogarithmBase", "Number:double");
            a.item("UseLogarithmicScale", "Boolean");
            a.item("UseWebWorkers", "Boolean");
            a.item("WebWorkerScriptPath", "String");
            a.item("WebWorkerInstanceRef", "(w:WebWorkerInstance,wf:WebWorkerInstance)DataRef");
        }
        static d(a) {
            HeatTileGeneratorDescriptionMetadata.b(a);
            a.ae("HeatTileGenerator", () => new HeatTileGeneratorDescription());
            a.ad("HeatTileGenerator", HeatTileGeneratorDescriptionMetadata.a);
        }
    }
    HeatTileGeneratorDescriptionMetadata.$t = /*@__PURE__*/ markType(HeatTileGeneratorDescriptionMetadata, 'HeatTileGeneratorDescriptionMetadata');
    HeatTileGeneratorDescriptionMetadata.a = null;
    return HeatTileGeneratorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileGeneratorDescriptionModule = /*@__PURE__*/ (() => {
    class HeatTileGeneratorDescriptionModule extends Base {
        static register(a) {
            HeatTileGeneratorDescriptionMetadata.d(a);
        }
    }
    HeatTileGeneratorDescriptionModule.$t = /*@__PURE__*/ markType(HeatTileGeneratorDescriptionModule, 'HeatTileGeneratorDescriptionModule');
    return HeatTileGeneratorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicTileSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicTileSeriesDescription extends GeographicShapeSeriesBaseDescription {
        get_type() {
            return "GeographicTileSeries";
        }
        constructor() {
            super();
            this.fp = null;
            this.fr = null;
        }
        get tileImagery() {
            return this.fp;
        }
        set tileImagery(a) {
            this.fp = a;
            this.g("TileImagery");
        }
        get imageTilesReadyRef() {
            return this.fr;
        }
        set imageTilesReadyRef(a) {
            this.fr = a;
            this.g("ImageTilesReadyRef");
        }
    }
    GeographicTileSeriesDescription.$t = /*@__PURE__*/ markType(GeographicTileSeriesDescription, 'GeographicTileSeriesDescription', GeographicShapeSeriesBaseDescription.$);
    return GeographicTileSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicTileSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicTileSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicTileSeriesDescriptionMetadata.a == null) {
                GeographicTileSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicTileSeriesDescriptionMetadata.c(GeographicTileSeriesDescriptionMetadata.a);
            }
            if (a.k(GeographicTileSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicTileSeriesDescriptionMetadata.a);
            GeographicMapImageryDescriptionMetadata.d(a);
            ImageTilesReadyEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            GeographicShapeSeriesBaseDescriptionMetadata.c(a);
            a.item("TileImagery", "ExportedType:GeographicMapImagery");
            a.item("ImageTilesReadyRef", "EventRef::imageTilesReady");
        }
        static d(a) {
            GeographicTileSeriesDescriptionMetadata.b(a);
            a.ae("GeographicTileSeries", () => new GeographicTileSeriesDescription());
            a.ad("GeographicTileSeries", GeographicTileSeriesDescriptionMetadata.a);
        }
    }
    GeographicTileSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicTileSeriesDescriptionMetadata, 'GeographicTileSeriesDescriptionMetadata');
    GeographicTileSeriesDescriptionMetadata.a = null;
    return GeographicTileSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicTileSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicTileSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicTileSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicTileSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicTileSeriesDescriptionModule, 'GeographicTileSeriesDescriptionModule');
    return GeographicTileSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMarkerSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicMarkerSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicMarkerSeriesDescriptionMetadata.a == null) {
                GeographicMarkerSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicMarkerSeriesDescriptionMetadata.c(GeographicMarkerSeriesDescriptionMetadata.a);
            }
            if (a.k(GeographicMarkerSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicMarkerSeriesDescriptionMetadata.a);
        }
        static c(a) {
            GeographicMapSeriesHostDescriptionMetadata.c(a);
            a.item("MarkerType", "ExportedType:string:MarkerType");
            a.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            a.item("MarkerThickness", "Number:double");
            a.item("MarkerOutlineMode", "ExportedType:string:MarkerOutlineMode");
            a.item("MarkerOutlineMode@names", "Auto;Normal;MatchMarkerBrush");
            a.item("MarkerFillMode", "ExportedType:string:MarkerFillMode");
            a.item("MarkerFillMode@names", "Auto;Normal;MatchMarkerOutline");
            a.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            a.item("MarkerBrush", "Brush");
            a.item("MarkerOutline", "Brush");
            a.item("MaximumMarkers", "Number:int");
            a.item("ActualMarkerTemplateRef", "(w:ActualMarkerTemplate,wf:ActualMarkerTemplate)DataRef::object");
            a.item("ActualMarkerBrush", "Brush");
            a.item("ActualMarkerOutline", "Brush");
        }
        static d(a) {
            GeographicMarkerSeriesDescriptionMetadata.b(a);
            a.ad("GeographicMarkerSeries", GeographicMarkerSeriesDescriptionMetadata.a);
        }
    }
    GeographicMarkerSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicMarkerSeriesDescriptionMetadata, 'GeographicMarkerSeriesDescriptionMetadata');
    GeographicMarkerSeriesDescriptionMetadata.a = null;
    return GeographicMarkerSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMarkerSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicMarkerSeriesDescription extends GeographicMapSeriesHostDescription {
        get_type() {
            return "GeographicMarkerSeries";
        }
        constructor() {
            super();
            this.fh = null;
            this.e5 = 0;
            this.ff = null;
            this.fd = null;
            this.fg = null;
            this.fc = null;
            this.fe = null;
            this.e7 = 0;
            this.fb = null;
            this.e9 = null;
            this.fa = null;
        }
        get markerType() {
            return this.fh;
        }
        set markerType(a) {
            this.fh = a;
            this.g("MarkerType");
        }
        get markerThickness() {
            return this.e5;
        }
        set markerThickness(a) {
            this.e5 = a;
            this.g("MarkerThickness");
        }
        get markerOutlineMode() {
            return this.ff;
        }
        set markerOutlineMode(a) {
            this.ff = a;
            this.g("MarkerOutlineMode");
        }
        get markerFillMode() {
            return this.fd;
        }
        set markerFillMode(a) {
            this.fd = a;
            this.g("MarkerFillMode");
        }
        get markerTemplateRef() {
            return this.fg;
        }
        set markerTemplateRef(a) {
            this.fg = a;
            this.g("MarkerTemplateRef");
        }
        get markerBrush() {
            return this.fc;
        }
        set markerBrush(a) {
            this.fc = a;
            this.g("MarkerBrush");
        }
        get markerOutline() {
            return this.fe;
        }
        set markerOutline(a) {
            this.fe = a;
            this.g("MarkerOutline");
        }
        get maximumMarkers() {
            return this.e7;
        }
        set maximumMarkers(a) {
            this.e7 = a;
            this.g("MaximumMarkers");
        }
        get actualMarkerTemplateRef() {
            return this.fb;
        }
        set actualMarkerTemplateRef(a) {
            this.fb = a;
            this.g("ActualMarkerTemplateRef");
        }
        get actualMarkerBrush() {
            return this.e9;
        }
        set actualMarkerBrush(a) {
            this.e9 = a;
            this.g("ActualMarkerBrush");
        }
        get actualMarkerOutline() {
            return this.fa;
        }
        set actualMarkerOutline(a) {
            this.fa = a;
            this.g("ActualMarkerOutline");
        }
    }
    GeographicMarkerSeriesDescription.$t = /*@__PURE__*/ markType(GeographicMarkerSeriesDescription, 'GeographicMarkerSeriesDescription', GeographicMapSeriesHostDescription.$);
    return GeographicMarkerSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicProportionalSymbolSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeriesDescription extends GeographicMarkerSeriesDescription {
        get_type() {
            return "GeographicProportionalSymbolSeries";
        }
        constructor() {
            super();
            this.gg = null;
            this.gh = null;
            this.gi = null;
            this.ft = null;
            this.gf = null;
            this.gd = null;
            this.fr = null;
            this.fv = false;
            this.fy = false;
            this.f6 = 0;
            this.f5 = 0;
            this.fz = false;
            this.fx = false;
            this.fw = false;
            this.ge = null;
            this.f9 = 0;
            this.gc = null;
            this.gb = null;
        }
        get latitudeMemberPath() {
            return this.gg;
        }
        set latitudeMemberPath(a) {
            this.gg = a;
            this.g("LatitudeMemberPath");
        }
        get longitudeMemberPath() {
            return this.gh;
        }
        set longitudeMemberPath(a) {
            this.gh = a;
            this.g("LongitudeMemberPath");
        }
        get radiusMemberPath() {
            return this.gi;
        }
        set radiusMemberPath(a) {
            this.gi = a;
            this.g("RadiusMemberPath");
        }
        get radiusScale() {
            return this.ft;
        }
        set radiusScale(a) {
            this.ft = a;
            this.g("RadiusScale");
        }
        get labelMemberPath() {
            return this.gf;
        }
        set labelMemberPath(a) {
            this.gf = a;
            this.g("LabelMemberPath");
        }
        get fillMemberPath() {
            return this.gd;
        }
        set fillMemberPath(a) {
            this.gd = a;
            this.g("FillMemberPath");
        }
        get fillScale() {
            return this.fr;
        }
        set fillScale(a) {
            this.fr = a;
            this.g("FillScale");
        }
        get fillScaleUseGlobalValues() {
            return this.fv;
        }
        set fillScaleUseGlobalValues(a) {
            this.fv = a;
            this.g("FillScaleUseGlobalValues");
        }
        get markerOutlineUsesFillScale() {
            return this.fy;
        }
        set markerOutlineUsesFillScale(a) {
            this.fy = a;
            this.g("MarkerOutlineUsesFillScale");
        }
        get markerOutlineBrightness() {
            return this.f6;
        }
        set markerOutlineBrightness(a) {
            this.f6 = a;
            this.g("MarkerOutlineBrightness");
        }
        get markerBrushBrightness() {
            return this.f5;
        }
        set markerBrushBrightness(a) {
            this.f5 = a;
            this.g("MarkerBrushBrightness");
        }
        get radiusScaleUseGlobalValues() {
            return this.fz;
        }
        set radiusScaleUseGlobalValues(a) {
            this.fz = a;
            this.g("RadiusScaleUseGlobalValues");
        }
        get isCustomScatterStyleAllowed() {
            return this.fx;
        }
        set isCustomScatterStyleAllowed(a) {
            this.fx = a;
            this.g("IsCustomScatterStyleAllowed");
        }
        get isCustomScatterMarkerStyleAllowed() {
            return this.fw;
        }
        set isCustomScatterMarkerStyleAllowed(a) {
            this.fw = a;
            this.g("IsCustomScatterMarkerStyleAllowed");
        }
        get itemSearchMode() {
            return this.ge;
        }
        set itemSearchMode(a) {
            this.ge = a;
            this.g("ItemSearchMode");
        }
        get itemSearchThreshold() {
            return this.f9;
        }
        set itemSearchThreshold(a) {
            this.f9 = a;
            this.g("ItemSearchThreshold");
        }
        get assigningScatterStyleRef() {
            return this.gc;
        }
        set assigningScatterStyleRef(a) {
            this.gc = a;
            this.g("AssigningScatterStyleRef");
        }
        get assigningScatterMarkerStyleRef() {
            return this.gb;
        }
        set assigningScatterMarkerStyleRef(a) {
            this.gb = a;
            this.g("AssigningScatterMarkerStyleRef");
        }
    }
    GeographicProportionalSymbolSeriesDescription.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeriesDescription, 'GeographicProportionalSymbolSeriesDescription', GeographicMarkerSeriesDescription.$);
    return GeographicProportionalSymbolSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicProportionalSymbolSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicProportionalSymbolSeriesDescriptionMetadata.a == null) {
                GeographicProportionalSymbolSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicProportionalSymbolSeriesDescriptionMetadata.c(GeographicProportionalSymbolSeriesDescriptionMetadata.a);
            }
            if (a.k(GeographicProportionalSymbolSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicProportionalSymbolSeriesDescriptionMetadata.a);
            SizeScaleDescriptionMetadata.d(a);
            BrushScaleDescriptionMetadata.d(a);
            AssigningScatterStyleEventArgsDescriptionMetadata.d(a);
            AssigningScatterMarkerStyleEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            GeographicMarkerSeriesDescriptionMetadata.c(a);
            a.item("LatitudeMemberPath", "String");
            a.item("LongitudeMemberPath", "String");
            a.item("RadiusMemberPath", "String");
            a.item("RadiusScale", "ExportedType:SizeScale");
            a.item("LabelMemberPath", "String");
            a.item("FillMemberPath", "String");
            a.item("FillScale", "ExportedType:BrushScale");
            a.item("FillScaleUseGlobalValues", "Boolean");
            a.item("MarkerOutlineUsesFillScale", "Boolean");
            a.item("MarkerOutlineBrightness", "Number:double");
            a.item("MarkerBrushBrightness", "Number:double");
            a.item("RadiusScaleUseGlobalValues", "Boolean");
            a.item("IsCustomScatterStyleAllowed", "Boolean");
            a.item("IsCustomScatterMarkerStyleAllowed", "Boolean");
            a.item("ItemSearchMode", "ExportedType:string:ScatterItemSearchMode");
            a.item("ItemSearchMode@names", "Auto;ClosestVisiblePoint;ClosestPoint;ClosestVisiblePointOnClosestLine;ClosestPointOnClosestLine;None");
            a.item("ItemSearchThreshold", "Number:int");
            a.item("AssigningScatterStyleRef", "EventRef::assigningScatterStyle");
            a.item("AssigningScatterMarkerStyleRef", "EventRef::assigningScatterMarkerStyle");
        }
        static d(a) {
            GeographicProportionalSymbolSeriesDescriptionMetadata.b(a);
            a.ae("GeographicProportionalSymbolSeries", () => new GeographicProportionalSymbolSeriesDescription());
            a.ad("GeographicProportionalSymbolSeries", GeographicProportionalSymbolSeriesDescriptionMetadata.a);
        }
    }
    GeographicProportionalSymbolSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeriesDescriptionMetadata, 'GeographicProportionalSymbolSeriesDescriptionMetadata');
    GeographicProportionalSymbolSeriesDescriptionMetadata.a = null;
    return GeographicProportionalSymbolSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicProportionalSymbolSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicProportionalSymbolSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicProportionalSymbolSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeriesDescriptionModule, 'GeographicProportionalSymbolSeriesDescriptionModule');
    return GeographicProportionalSymbolSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicSymbolSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicSymbolSeriesDescription extends GeographicMarkerSeriesDescription {
        get_type() {
            return "GeographicSymbolSeries";
        }
        constructor() {
            super();
            this.f0 = null;
            this.f1 = null;
            this.f2 = null;
            this.fs = false;
            this.fr = false;
            this.fz = null;
            this.fv = 0;
            this.fy = null;
            this.fx = null;
        }
        get latitudeMemberPath() {
            return this.f0;
        }
        set latitudeMemberPath(a) {
            this.f0 = a;
            this.g("LatitudeMemberPath");
        }
        get longitudeMemberPath() {
            return this.f1;
        }
        set longitudeMemberPath(a) {
            this.f1 = a;
            this.g("LongitudeMemberPath");
        }
        get markerCollisionAvoidance() {
            return this.f2;
        }
        set markerCollisionAvoidance(a) {
            this.f2 = a;
            this.g("MarkerCollisionAvoidance");
        }
        get isCustomScatterStyleAllowed() {
            return this.fs;
        }
        set isCustomScatterStyleAllowed(a) {
            this.fs = a;
            this.g("IsCustomScatterStyleAllowed");
        }
        get isCustomScatterMarkerStyleAllowed() {
            return this.fr;
        }
        set isCustomScatterMarkerStyleAllowed(a) {
            this.fr = a;
            this.g("IsCustomScatterMarkerStyleAllowed");
        }
        get itemSearchMode() {
            return this.fz;
        }
        set itemSearchMode(a) {
            this.fz = a;
            this.g("ItemSearchMode");
        }
        get itemSearchThreshold() {
            return this.fv;
        }
        set itemSearchThreshold(a) {
            this.fv = a;
            this.g("ItemSearchThreshold");
        }
        get assigningScatterStyleRef() {
            return this.fy;
        }
        set assigningScatterStyleRef(a) {
            this.fy = a;
            this.g("AssigningScatterStyleRef");
        }
        get assigningScatterMarkerStyleRef() {
            return this.fx;
        }
        set assigningScatterMarkerStyleRef(a) {
            this.fx = a;
            this.g("AssigningScatterMarkerStyleRef");
        }
    }
    GeographicSymbolSeriesDescription.$t = /*@__PURE__*/ markType(GeographicSymbolSeriesDescription, 'GeographicSymbolSeriesDescription', GeographicMarkerSeriesDescription.$);
    return GeographicSymbolSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicSymbolSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicSymbolSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicSymbolSeriesDescriptionMetadata.a == null) {
                GeographicSymbolSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicSymbolSeriesDescriptionMetadata.c(GeographicSymbolSeriesDescriptionMetadata.a);
            }
            if (a.k(GeographicSymbolSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicSymbolSeriesDescriptionMetadata.a);
            AssigningScatterStyleEventArgsDescriptionMetadata.d(a);
            AssigningScatterMarkerStyleEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            GeographicMarkerSeriesDescriptionMetadata.c(a);
            a.item("LatitudeMemberPath", "String");
            a.item("LongitudeMemberPath", "String");
            a.item("MarkerCollisionAvoidance", "ExportedType:string:CollisionAvoidanceType");
            a.item("MarkerCollisionAvoidance@names", "None;Omit;Fade;OmitAndShift;FadeAndShift");
            a.item("IsCustomScatterStyleAllowed", "Boolean");
            a.item("IsCustomScatterMarkerStyleAllowed", "Boolean");
            a.item("ItemSearchMode", "ExportedType:string:ScatterItemSearchMode");
            a.item("ItemSearchMode@names", "Auto;ClosestVisiblePoint;ClosestPoint;ClosestVisiblePointOnClosestLine;ClosestPointOnClosestLine;None");
            a.item("ItemSearchThreshold", "Number:int");
            a.item("AssigningScatterStyleRef", "EventRef::assigningScatterStyle");
            a.item("AssigningScatterMarkerStyleRef", "EventRef::assigningScatterMarkerStyle");
        }
        static d(a) {
            GeographicSymbolSeriesDescriptionMetadata.b(a);
            a.ae("GeographicSymbolSeries", () => new GeographicSymbolSeriesDescription());
            a.ad("GeographicSymbolSeries", GeographicSymbolSeriesDescriptionMetadata.a);
        }
    }
    GeographicSymbolSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicSymbolSeriesDescriptionMetadata, 'GeographicSymbolSeriesDescriptionMetadata');
    GeographicSymbolSeriesDescriptionMetadata.a = null;
    return GeographicSymbolSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicSymbolSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicSymbolSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicSymbolSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicSymbolSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicSymbolSeriesDescriptionModule, 'GeographicSymbolSeriesDescriptionModule');
    return GeographicSymbolSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicScatterAreaSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicScatterAreaSeriesDescription extends GeographicXYTriangulatingSeriesDescription {
        get_type() {
            return "GeographicScatterAreaSeries";
        }
        constructor() {
            super();
            this.fl = null;
            this.fi = null;
            this.fh = null;
            this.fm = null;
        }
        get colorMemberPath() {
            return this.fl;
        }
        set colorMemberPath(a) {
            this.fl = a;
            this.g("ColorMemberPath");
        }
        get colorScale() {
            return this.fi;
        }
        set colorScale(a) {
            this.fi = a;
            this.g("ColorScale");
        }
        get actualColorScale() {
            return this.fh;
        }
        set actualColorScale(a) {
            this.fh = a;
            this.g("ActualColorScale");
        }
        get triangulationStatusChangedRef() {
            return this.fm;
        }
        set triangulationStatusChangedRef(a) {
            this.fm = a;
            this.g("TriangulationStatusChangedRef");
        }
    }
    GeographicScatterAreaSeriesDescription.$t = /*@__PURE__*/ markType(GeographicScatterAreaSeriesDescription, 'GeographicScatterAreaSeriesDescription', GeographicXYTriangulatingSeriesDescription.$);
    return GeographicScatterAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicScatterAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicScatterAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicScatterAreaSeriesDescriptionMetadata.a == null) {
                GeographicScatterAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicScatterAreaSeriesDescriptionMetadata.c(GeographicScatterAreaSeriesDescriptionMetadata.a);
            }
            if (a.k(GeographicScatterAreaSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicScatterAreaSeriesDescriptionMetadata.a);
            ColorScaleDescriptionMetadata.d(a);
            TriangulationStatusEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            GeographicXYTriangulatingSeriesDescriptionMetadata.c(a);
            a.item("ColorMemberPath", "String");
            a.item("ColorScale", "ExportedType:ColorScale");
            a.item("ActualColorScale", "ExportedType:ColorScale");
            a.item("TriangulationStatusChangedRef", "EventRef::triangulationStatusChanged");
        }
        static d(a) {
            GeographicScatterAreaSeriesDescriptionMetadata.b(a);
            a.ae("GeographicScatterAreaSeries", () => new GeographicScatterAreaSeriesDescription());
            a.ad("GeographicScatterAreaSeries", GeographicScatterAreaSeriesDescriptionMetadata.a);
        }
    }
    GeographicScatterAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicScatterAreaSeriesDescriptionMetadata, 'GeographicScatterAreaSeriesDescriptionMetadata');
    GeographicScatterAreaSeriesDescriptionMetadata.a = null;
    return GeographicScatterAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicScatterAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicScatterAreaSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicScatterAreaSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicScatterAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicScatterAreaSeriesDescriptionModule, 'GeographicScatterAreaSeriesDescriptionModule');
    return GeographicScatterAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeDataSourceDescriptionModule = /*@__PURE__*/ (() => {
    class ShapeDataSourceDescriptionModule extends Base {
        static register(a) {
            ShapeDataSourceDescriptionMetadata.d(a);
        }
    }
    ShapeDataSourceDescriptionModule.$t = /*@__PURE__*/ markType(ShapeDataSourceDescriptionModule, 'ShapeDataSourceDescriptionModule');
    return ShapeDataSourceDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMapDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicMapDescriptionModule extends Base {
        static register(a) {
            GeographicShapeSeriesDescriptionModule.register(a);
            GeographicPolylineSeriesDescriptionModule.register(a);
            TileGeneratorMapImageryDescriptionModule.register(a);
            HeatTileGeneratorDescriptionModule.register(a);
            GeographicTileSeriesDescriptionModule.register(a);
            SizeScaleDescriptionModule.register(a);
            ValueBrushScaleDescriptionModule.register(a);
            CustomPaletteColorScaleDescriptionModule.register(a);
            GeographicProportionalSymbolSeriesDescriptionModule.register(a);
            GeographicSymbolSeriesDescriptionModule.register(a);
            GeographicScatterAreaSeriesDescriptionModule.register(a);
            GeographicHighDensityScatterSeriesDescriptionModule.register(a);
            GeographicContourLineSeriesDescriptionModule.register(a);
            GeographicMapCoreDescriptionModule.register(a);
            ShapeDataSourceDescriptionModule.register(a);
        }
    }
    GeographicMapDescriptionModule.$t = /*@__PURE__*/ markType(GeographicMapDescriptionModule, 'GeographicMapDescriptionModule');
    return GeographicMapDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMarkerSeriesBaseDescription = /*@__PURE__*/ (() => {
    class GeographicMarkerSeriesBaseDescription extends GeographicMarkerSeriesDescription {
        get_type() {
            return "GeographicMarkerSeriesBase";
        }
        constructor() {
            super();
        }
    }
    GeographicMarkerSeriesBaseDescription.$t = /*@__PURE__*/ markType(GeographicMarkerSeriesBaseDescription, 'GeographicMarkerSeriesBaseDescription', GeographicMarkerSeriesDescription.$);
    return GeographicMarkerSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMarkerSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicMarkerSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicMarkerSeriesBaseDescriptionMetadata.a == null) {
                GeographicMarkerSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicMarkerSeriesBaseDescriptionMetadata.c(GeographicMarkerSeriesBaseDescriptionMetadata.a);
            }
            if (a.k(GeographicMarkerSeriesBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicMarkerSeriesBaseDescriptionMetadata.a);
        }
        static c(a) {
            GeographicMarkerSeriesDescriptionMetadata.c(a);
        }
        static d(a) {
            GeographicMarkerSeriesBaseDescriptionMetadata.b(a);
            a.ad("GeographicMarkerSeriesBase", GeographicMarkerSeriesBaseDescriptionMetadata.a);
        }
    }
    GeographicMarkerSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicMarkerSeriesBaseDescriptionMetadata, 'GeographicMarkerSeriesBaseDescriptionMetadata');
    GeographicMarkerSeriesBaseDescriptionMetadata.a = null;
    return GeographicMarkerSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicProportionalSymbolSeriesBaseDescription = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeriesBaseDescription extends GeographicMarkerSeriesBaseDescription {
        get_type() {
            return "GeographicProportionalSymbolSeriesBase";
        }
        constructor() {
            super();
        }
    }
    GeographicProportionalSymbolSeriesBaseDescription.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeriesBaseDescription, 'GeographicProportionalSymbolSeriesBaseDescription', GeographicMarkerSeriesBaseDescription.$);
    return GeographicProportionalSymbolSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicProportionalSymbolSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicProportionalSymbolSeriesBaseDescriptionMetadata.a == null) {
                GeographicProportionalSymbolSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicProportionalSymbolSeriesBaseDescriptionMetadata.c(GeographicProportionalSymbolSeriesBaseDescriptionMetadata.a);
            }
            if (a.k(GeographicProportionalSymbolSeriesBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicProportionalSymbolSeriesBaseDescriptionMetadata.a);
        }
        static c(a) {
            GeographicMarkerSeriesBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            GeographicProportionalSymbolSeriesBaseDescriptionMetadata.b(a);
            a.ad("GeographicProportionalSymbolSeriesBase", GeographicProportionalSymbolSeriesBaseDescriptionMetadata.a);
        }
    }
    GeographicProportionalSymbolSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeriesBaseDescriptionMetadata, 'GeographicProportionalSymbolSeriesBaseDescriptionMetadata');
    GeographicProportionalSymbolSeriesBaseDescriptionMetadata.a = null;
    return GeographicProportionalSymbolSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicShapeSeriesBaseBaseDescription = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesBaseBaseDescription extends GeographicMapSeriesHostDescription {
        get_type() {
            return "GeographicShapeSeriesBaseBase";
        }
        constructor() {
            super();
        }
    }
    GeographicShapeSeriesBaseBaseDescription.$t = /*@__PURE__*/ markType(GeographicShapeSeriesBaseBaseDescription, 'GeographicShapeSeriesBaseBaseDescription', GeographicMapSeriesHostDescription.$);
    return GeographicShapeSeriesBaseBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicShapeSeriesBaseBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesBaseBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicShapeSeriesBaseBaseDescriptionMetadata.a == null) {
                GeographicShapeSeriesBaseBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicShapeSeriesBaseBaseDescriptionMetadata.c(GeographicShapeSeriesBaseBaseDescriptionMetadata.a);
            }
            if (a.k(GeographicShapeSeriesBaseBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicShapeSeriesBaseBaseDescriptionMetadata.a);
        }
        static c(a) {
            GeographicMapSeriesHostDescriptionMetadata.c(a);
        }
        static d(a) {
            GeographicShapeSeriesBaseBaseDescriptionMetadata.b(a);
            a.ad("GeographicShapeSeriesBaseBase", GeographicShapeSeriesBaseBaseDescriptionMetadata.a);
        }
    }
    GeographicShapeSeriesBaseBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicShapeSeriesBaseBaseDescriptionMetadata, 'GeographicShapeSeriesBaseBaseDescriptionMetadata');
    GeographicShapeSeriesBaseBaseDescriptionMetadata.a = null;
    return GeographicShapeSeriesBaseBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicSymbolSeriesBaseDescription = /*@__PURE__*/ (() => {
    class GeographicSymbolSeriesBaseDescription extends GeographicMarkerSeriesBaseDescription {
        get_type() {
            return "GeographicSymbolSeriesBase";
        }
        constructor() {
            super();
        }
    }
    GeographicSymbolSeriesBaseDescription.$t = /*@__PURE__*/ markType(GeographicSymbolSeriesBaseDescription, 'GeographicSymbolSeriesBaseDescription', GeographicMarkerSeriesBaseDescription.$);
    return GeographicSymbolSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicSymbolSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicSymbolSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicSymbolSeriesBaseDescriptionMetadata.a == null) {
                GeographicSymbolSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicSymbolSeriesBaseDescriptionMetadata.c(GeographicSymbolSeriesBaseDescriptionMetadata.a);
            }
            if (a.k(GeographicSymbolSeriesBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicSymbolSeriesBaseDescriptionMetadata.a);
        }
        static c(a) {
            GeographicMarkerSeriesBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            GeographicSymbolSeriesBaseDescriptionMetadata.b(a);
            a.ad("GeographicSymbolSeriesBase", GeographicSymbolSeriesBaseDescriptionMetadata.a);
        }
    }
    GeographicSymbolSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicSymbolSeriesBaseDescriptionMetadata, 'GeographicSymbolSeriesBaseDescriptionMetadata');
    GeographicSymbolSeriesBaseDescriptionMetadata.a = null;
    return GeographicSymbolSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicXYTriangulatingSeriesBaseDescription = /*@__PURE__*/ (() => {
    class GeographicXYTriangulatingSeriesBaseDescription extends GeographicMapSeriesHostDescription {
        get_type() {
            return "GeographicXYTriangulatingSeriesBase";
        }
        constructor() {
            super();
        }
    }
    GeographicXYTriangulatingSeriesBaseDescription.$t = /*@__PURE__*/ markType(GeographicXYTriangulatingSeriesBaseDescription, 'GeographicXYTriangulatingSeriesBaseDescription', GeographicMapSeriesHostDescription.$);
    return GeographicXYTriangulatingSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicXYTriangulatingSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicXYTriangulatingSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicXYTriangulatingSeriesBaseDescriptionMetadata.a == null) {
                GeographicXYTriangulatingSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicXYTriangulatingSeriesBaseDescriptionMetadata.c(GeographicXYTriangulatingSeriesBaseDescriptionMetadata.a);
            }
            if (a.k(GeographicXYTriangulatingSeriesBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(GeographicXYTriangulatingSeriesBaseDescriptionMetadata.a);
        }
        static c(a) {
            GeographicMapSeriesHostDescriptionMetadata.c(a);
        }
        static d(a) {
            GeographicXYTriangulatingSeriesBaseDescriptionMetadata.b(a);
            a.ad("GeographicXYTriangulatingSeriesBase", GeographicXYTriangulatingSeriesBaseDescriptionMetadata.a);
        }
    }
    GeographicXYTriangulatingSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicXYTriangulatingSeriesBaseDescriptionMetadata, 'GeographicXYTriangulatingSeriesBaseDescriptionMetadata');
    GeographicXYTriangulatingSeriesBaseDescriptionMetadata.a = null;
    return GeographicXYTriangulatingSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellEventArgsDescription = /*@__PURE__*/ (() => {
    class GridCellEventArgsDescription extends Description {
        get_type() {
            return "GridCellEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = null;
            this.n = null;
            this.l = false;
        }
        get cellInfo() {
            return this.h;
        }
        set cellInfo(a) {
            this.h = a;
            this.g("CellInfo");
        }
        get grid() {
            return this.j;
        }
        set grid(a) {
            this.j = a;
            this.g("Grid");
        }
        get button() {
            return this.n;
        }
        set button(a) {
            this.n = a;
            this.g("Button");
        }
        get isDoubleClick() {
            return this.l;
        }
        set isDoubleClick(a) {
            this.l = a;
            this.g("IsDoubleClick");
        }
    }
    GridCellEventArgsDescription.$t = /*@__PURE__*/ markType(GridCellEventArgsDescription, 'GridCellEventArgsDescription', Description.$);
    return GridCellEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridCellEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridCellEventArgsDescriptionMetadata.a == null) {
                GridCellEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridCellEventArgsDescriptionMetadata.c(GridCellEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridCellEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridCellEventArgsDescriptionMetadata.a);
            CellInfoDescriptionMetadata.d(a);
            DataGridDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("CellInfo", "ExportedType:CellModel");
            a.item("Grid", "ExportedType:Grid");
            a.item("Button", "ExportedType:string:MouseButton");
            a.item("Button@names", "Left;Middle;Right;Unkown");
            a.item("IsDoubleClick", "Boolean");
        }
        static d(a) {
            GridCellEventArgsDescriptionMetadata.b(a);
            a.ae("GridCellEventArgs", () => new GridCellEventArgsDescription());
            a.ad("GridCellEventArgs", GridCellEventArgsDescriptionMetadata.a);
        }
    }
    GridCellEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridCellEventArgsDescriptionMetadata, 'GridCellEventArgsDescriptionMetadata');
    GridCellEventArgsDescriptionMetadata.a = null;
    return GridCellEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderRowSeparatorDescriptionModule = /*@__PURE__*/ (() => {
    class HeaderRowSeparatorDescriptionModule extends Base {
        static register(a) {
            HeaderRowSeparatorDescriptionMetadata.d(a);
        }
    }
    HeaderRowSeparatorDescriptionModule.$t = /*@__PURE__*/ markType(HeaderRowSeparatorDescriptionModule, 'HeaderRowSeparatorDescriptionModule');
    return HeaderRowSeparatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalAnchoredCategorySeriesProxyDescriptionModule = /*@__PURE__*/ (() => {
    class HorizontalAnchoredCategorySeriesProxyDescriptionModule extends Base {
        static register(a) {
        }
    }
    HorizontalAnchoredCategorySeriesProxyDescriptionModule.$t = /*@__PURE__*/ markType(HorizontalAnchoredCategorySeriesProxyDescriptionModule, 'HorizontalAnchoredCategorySeriesProxyDescriptionModule');
    return HorizontalAnchoredCategorySeriesProxyDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalRangeCategorySeriesProxyDescriptionModule = /*@__PURE__*/ (() => {
    class HorizontalRangeCategorySeriesProxyDescriptionModule extends Base {
        static register(a) {
        }
    }
    HorizontalRangeCategorySeriesProxyDescriptionModule.$t = /*@__PURE__*/ markType(HorizontalRangeCategorySeriesProxyDescriptionModule, 'HorizontalRangeCategorySeriesProxyDescriptionModule');
    return HorizontalRangeCategorySeriesProxyDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IndicatorProxyDescriptionModule = /*@__PURE__*/ (() => {
    class IndicatorProxyDescriptionModule extends Base {
        static register(a) {
        }
    }
    IndicatorProxyDescriptionModule.$t = /*@__PURE__*/ markType(IndicatorProxyDescriptionModule, 'IndicatorProxyDescriptionModule');
    return IndicatorProxyDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemLegendDescription = /*@__PURE__*/ (() => {
    class ItemLegendDescription extends LegendBaseDescription {
        get width() {
            return this.y;
        }
        set width(a) {
            this.y = a;
            this.g("Width");
        }
        get height() {
            return this.u;
        }
        set height(a) {
            this.u = a;
            this.g("Height");
        }
        get_type() {
            return "ItemLegend";
        }
        constructor() {
            super();
            this.y = null;
            this.u = null;
            this.v = null;
            this.w = null;
            this.x = null;
        }
        get orientation() {
            return this.v;
        }
        set orientation(a) {
            this.v = a;
            this.g("Orientation");
        }
        get textColor() {
            return this.w;
        }
        set textColor(a) {
            this.w = a;
            this.g("TextColor");
        }
        get textStyle() {
            return this.x;
        }
        set textStyle(a) {
            this.x = a;
            this.g("TextStyle");
        }
    }
    ItemLegendDescription.$t = /*@__PURE__*/ markType(ItemLegendDescription, 'ItemLegendDescription', LegendBaseDescription.$);
    return ItemLegendDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemLegendDescriptionMetadata = /*@__PURE__*/ (() => {
    class ItemLegendDescriptionMetadata extends Base {
        static e(a) {
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
        }
        static b(a) {
            if (ItemLegendDescriptionMetadata.a == null) {
                ItemLegendDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ItemLegendDescriptionMetadata.c(ItemLegendDescriptionMetadata.a);
            }
            if (a.k(ItemLegendDescriptionMetadata.a)) {
                return;
            }
            a.ac(ItemLegendDescriptionMetadata.a);
        }
        static c(a) {
            LegendBaseDescriptionMetadata.c(a);
            a.item("Orientation", "ExportedType:string:LegendOrientation");
            a.item("Orientation@names", "Horizontal;Vertical");
            a.item("TextColor", "String");
            a.item("TextStyle", "String");
            ItemLegendDescriptionMetadata.e(a);
        }
        static d(a) {
            ItemLegendDescriptionMetadata.b(a);
            a.ae("ItemLegend", () => new ItemLegendDescription());
            a.ad("ItemLegend", ItemLegendDescriptionMetadata.a);
        }
    }
    ItemLegendDescriptionMetadata.$t = /*@__PURE__*/ markType(ItemLegendDescriptionMetadata, 'ItemLegendDescriptionMetadata');
    ItemLegendDescriptionMetadata.a = null;
    return ItemLegendDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemLegendDescriptionModule = /*@__PURE__*/ (() => {
    class ItemLegendDescriptionModule extends Base {
        static register(a) {
            ItemLegendDescriptionMetadata.d(a);
        }
    }
    ItemLegendDescriptionModule.$t = /*@__PURE__*/ markType(ItemLegendDescriptionModule, 'ItemLegendDescriptionModule');
    return ItemLegendDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WrapperExpressionDescription = /*@__PURE__*/ (() => {
    class WrapperExpressionDescription extends FilterExpressionDescription {
        get_type() {
            return "WrapperExpression";
        }
        constructor() {
            super();
            this.l = null;
            this.k = null;
            this.q = null;
        }
        get innerExpression() {
            return this.l;
        }
        set innerExpression(a) {
            this.l = a;
            this.g("InnerExpression");
        }
        get expression() {
            return this.k;
        }
        set expression(a) {
            this.k = a;
            this.g("Expression");
        }
        get propertyName() {
            return this.q;
        }
        set propertyName(a) {
            this.q = a;
            this.g("PropertyName");
        }
    }
    WrapperExpressionDescription.$t = /*@__PURE__*/ markType(WrapperExpressionDescription, 'WrapperExpressionDescription', FilterExpressionDescription.$);
    WrapperExpressionDescription.__marshalByValue1 = true;
    WrapperExpressionDescription.__marshalByValueAlias1 = "WrapperExpression";
    return WrapperExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LastMonthExpressionDescription = /*@__PURE__*/ (() => {
    class LastMonthExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "LastMonthExpression";
        }
        constructor() {
            super();
        }
    }
    LastMonthExpressionDescription.$t = /*@__PURE__*/ markType(LastMonthExpressionDescription, 'LastMonthExpressionDescription', WrapperExpressionDescription.$);
    LastMonthExpressionDescription.__marshalByValue2 = true;
    LastMonthExpressionDescription.__marshalByValueAlias2 = "LastMonthExpression";
    return LastMonthExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WrapperExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WrapperExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (WrapperExpressionDescriptionMetadata.a == null) {
                WrapperExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WrapperExpressionDescriptionMetadata.c(WrapperExpressionDescriptionMetadata.a);
            }
            if (a.k(WrapperExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WrapperExpressionDescriptionMetadata.a);
            FilterExpressionDescriptionMetadata.d(a);
        }
        static c(a) {
            FilterExpressionDescriptionMetadata.c(a);
            a.item("InnerExpression", "ExportedType:IFilterExpression");
            a.item("Expression", "ExportedType:FilterExpression");
            a.item("PropertyName", "String");
        }
        static d(a) {
            WrapperExpressionDescriptionMetadata.b(a);
            a.ad("WrapperExpression", WrapperExpressionDescriptionMetadata.a);
        }
    }
    WrapperExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(WrapperExpressionDescriptionMetadata, 'WrapperExpressionDescriptionMetadata');
    WrapperExpressionDescriptionMetadata.a = null;
    return WrapperExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LastMonthExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class LastMonthExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (LastMonthExpressionDescriptionMetadata.a == null) {
                LastMonthExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LastMonthExpressionDescriptionMetadata.c(LastMonthExpressionDescriptionMetadata.a);
            }
            if (a.k(LastMonthExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(LastMonthExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            LastMonthExpressionDescriptionMetadata.b(a);
            a.ae("LastMonthExpression", () => new LastMonthExpressionDescription());
            a.ad("LastMonthExpression", LastMonthExpressionDescriptionMetadata.a);
        }
    }
    LastMonthExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(LastMonthExpressionDescriptionMetadata, 'LastMonthExpressionDescriptionMetadata');
    LastMonthExpressionDescriptionMetadata.a = null;
    return LastMonthExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LastQuarterExpressionDescription = /*@__PURE__*/ (() => {
    class LastQuarterExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "LastQuarterExpression";
        }
        constructor() {
            super();
        }
    }
    LastQuarterExpressionDescription.$t = /*@__PURE__*/ markType(LastQuarterExpressionDescription, 'LastQuarterExpressionDescription', WrapperExpressionDescription.$);
    LastQuarterExpressionDescription.__marshalByValue2 = true;
    LastQuarterExpressionDescription.__marshalByValueAlias2 = "LastQuarterExpression";
    return LastQuarterExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LastQuarterExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class LastQuarterExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (LastQuarterExpressionDescriptionMetadata.a == null) {
                LastQuarterExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LastQuarterExpressionDescriptionMetadata.c(LastQuarterExpressionDescriptionMetadata.a);
            }
            if (a.k(LastQuarterExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(LastQuarterExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            LastQuarterExpressionDescriptionMetadata.b(a);
            a.ae("LastQuarterExpression", () => new LastQuarterExpressionDescription());
            a.ad("LastQuarterExpression", LastQuarterExpressionDescriptionMetadata.a);
        }
    }
    LastQuarterExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(LastQuarterExpressionDescriptionMetadata, 'LastQuarterExpressionDescriptionMetadata');
    LastQuarterExpressionDescriptionMetadata.a = null;
    return LastQuarterExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OffsettableWeekExpressionDescription = /*@__PURE__*/ (() => {
    class OffsettableWeekExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "OffsettableWeekExpression";
        }
        constructor() {
            super();
        }
    }
    OffsettableWeekExpressionDescription.$t = /*@__PURE__*/ markType(OffsettableWeekExpressionDescription, 'OffsettableWeekExpressionDescription', WrapperExpressionDescription.$);
    OffsettableWeekExpressionDescription.__marshalByValue2 = true;
    OffsettableWeekExpressionDescription.__marshalByValueAlias2 = "OffsettableWeekExpression";
    return OffsettableWeekExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LastWeekExpressionDescription = /*@__PURE__*/ (() => {
    class LastWeekExpressionDescription extends OffsettableWeekExpressionDescription {
        get_type() {
            return "LastWeekExpression";
        }
        constructor() {
            super();
        }
    }
    LastWeekExpressionDescription.$t = /*@__PURE__*/ markType(LastWeekExpressionDescription, 'LastWeekExpressionDescription', OffsettableWeekExpressionDescription.$);
    LastWeekExpressionDescription.__marshalByValue3 = true;
    LastWeekExpressionDescription.__marshalByValueAlias3 = "LastWeekExpression";
    return LastWeekExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OffsettableWeekExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class OffsettableWeekExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (OffsettableWeekExpressionDescriptionMetadata.a == null) {
                OffsettableWeekExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OffsettableWeekExpressionDescriptionMetadata.c(OffsettableWeekExpressionDescriptionMetadata.a);
            }
            if (a.k(OffsettableWeekExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(OffsettableWeekExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            OffsettableWeekExpressionDescriptionMetadata.b(a);
            a.ad("OffsettableWeekExpression", OffsettableWeekExpressionDescriptionMetadata.a);
        }
    }
    OffsettableWeekExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(OffsettableWeekExpressionDescriptionMetadata, 'OffsettableWeekExpressionDescriptionMetadata');
    OffsettableWeekExpressionDescriptionMetadata.a = null;
    return OffsettableWeekExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LastWeekExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class LastWeekExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (LastWeekExpressionDescriptionMetadata.a == null) {
                LastWeekExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LastWeekExpressionDescriptionMetadata.c(LastWeekExpressionDescriptionMetadata.a);
            }
            if (a.k(LastWeekExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(LastWeekExpressionDescriptionMetadata.a);
        }
        static c(a) {
            OffsettableWeekExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            LastWeekExpressionDescriptionMetadata.b(a);
            a.ae("LastWeekExpression", () => new LastWeekExpressionDescription());
            a.ad("LastWeekExpression", LastWeekExpressionDescriptionMetadata.a);
        }
    }
    LastWeekExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(LastWeekExpressionDescriptionMetadata, 'LastWeekExpressionDescriptionMetadata');
    LastWeekExpressionDescriptionMetadata.a = null;
    return LastWeekExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LastYearExpressionDescription = /*@__PURE__*/ (() => {
    class LastYearExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "LastYearExpression";
        }
        constructor() {
            super();
        }
    }
    LastYearExpressionDescription.$t = /*@__PURE__*/ markType(LastYearExpressionDescription, 'LastYearExpressionDescription', WrapperExpressionDescription.$);
    LastYearExpressionDescription.__marshalByValue2 = true;
    LastYearExpressionDescription.__marshalByValueAlias2 = "LastYearExpression";
    return LastYearExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LastYearExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class LastYearExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (LastYearExpressionDescriptionMetadata.a == null) {
                LastYearExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LastYearExpressionDescriptionMetadata.c(LastYearExpressionDescriptionMetadata.a);
            }
            if (a.k(LastYearExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(LastYearExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            LastYearExpressionDescriptionMetadata.b(a);
            a.ae("LastYearExpression", () => new LastYearExpressionDescription());
            a.ad("LastYearExpression", LastYearExpressionDescriptionMetadata.a);
        }
    }
    LastYearExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(LastYearExpressionDescriptionMetadata, 'LastYearExpressionDescriptionMetadata');
    LastYearExpressionDescriptionMetadata.a = null;
    return LastYearExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LayoutPrimaryKeyValueDescription = /*@__PURE__*/ (() => {
    class LayoutPrimaryKeyValueDescription extends Description {
        get_type() {
            return "LayoutPrimaryKeyValue";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.i = null;
        }
        get key() {
            return this.h;
        }
        set key(a) {
            this.h = a;
            this.g("Key");
        }
        get value() {
            return this.i;
        }
        set value(a) {
            this.i = a;
            this.g("Value");
        }
    }
    LayoutPrimaryKeyValueDescription.$t = /*@__PURE__*/ markType(LayoutPrimaryKeyValueDescription, 'LayoutPrimaryKeyValueDescription', Description.$);
    LayoutPrimaryKeyValueDescription.__marshalByValue = true;
    LayoutPrimaryKeyValueDescription.__marshalByValueAlias = "LayoutPrimaryKeyValue";
    return LayoutPrimaryKeyValueDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LayoutPrimaryKeyValueDescriptionMetadata = /*@__PURE__*/ (() => {
    class LayoutPrimaryKeyValueDescriptionMetadata extends Base {
        static b(a) {
            if (LayoutPrimaryKeyValueDescriptionMetadata.a == null) {
                LayoutPrimaryKeyValueDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LayoutPrimaryKeyValueDescriptionMetadata.c(LayoutPrimaryKeyValueDescriptionMetadata.a);
            }
            if (a.k(LayoutPrimaryKeyValueDescriptionMetadata.a)) {
                return;
            }
            a.ac(LayoutPrimaryKeyValueDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("Key", "Array:string");
            a.item("Value", "Collection:object:Array:Object");
        }
        static d(a) {
            LayoutPrimaryKeyValueDescriptionMetadata.b(a);
            a.ae("LayoutPrimaryKeyValue", () => new LayoutPrimaryKeyValueDescription());
            a.ad("LayoutPrimaryKeyValue", LayoutPrimaryKeyValueDescriptionMetadata.a);
        }
    }
    LayoutPrimaryKeyValueDescriptionMetadata.$t = /*@__PURE__*/ markType(LayoutPrimaryKeyValueDescriptionMetadata, 'LayoutPrimaryKeyValueDescriptionMetadata');
    LayoutPrimaryKeyValueDescriptionMetadata.a = null;
    return LayoutPrimaryKeyValueDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LayoutPrimaryKeyValueDescriptionModule = /*@__PURE__*/ (() => {
    class LayoutPrimaryKeyValueDescriptionModule extends Base {
        static register(a) {
            LayoutPrimaryKeyValueDescriptionMetadata.d(a);
        }
    }
    LayoutPrimaryKeyValueDescriptionModule.$t = /*@__PURE__*/ markType(LayoutPrimaryKeyValueDescriptionModule, 'LayoutPrimaryKeyValueDescriptionModule');
    return LayoutPrimaryKeyValueDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendDescription = /*@__PURE__*/ (() => {
    class LegendDescription extends LegendBaseDescription {
        get width() {
            return this.y;
        }
        set width(a) {
            this.y = a;
            this.g("Width");
        }
        get height() {
            return this.u;
        }
        set height(a) {
            this.u = a;
            this.g("Height");
        }
        get_type() {
            return "Legend";
        }
        constructor() {
            super();
            this.y = null;
            this.u = null;
            this.v = null;
            this.w = null;
            this.x = null;
        }
        get orientation() {
            return this.v;
        }
        set orientation(a) {
            this.v = a;
            this.g("Orientation");
        }
        get textColor() {
            return this.w;
        }
        set textColor(a) {
            this.w = a;
            this.g("TextColor");
        }
        get textStyle() {
            return this.x;
        }
        set textStyle(a) {
            this.x = a;
            this.g("TextStyle");
        }
    }
    LegendDescription.$t = /*@__PURE__*/ markType(LegendDescription, 'LegendDescription', LegendBaseDescription.$);
    return LegendDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendDescriptionMetadata = /*@__PURE__*/ (() => {
    class LegendDescriptionMetadata extends Base {
        static e(a) {
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
        }
        static b(a) {
            if (LegendDescriptionMetadata.a == null) {
                LegendDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LegendDescriptionMetadata.c(LegendDescriptionMetadata.a);
            }
            if (a.k(LegendDescriptionMetadata.a)) {
                return;
            }
            a.ac(LegendDescriptionMetadata.a);
        }
        static c(a) {
            LegendBaseDescriptionMetadata.c(a);
            a.item("Orientation", "ExportedType:string:LegendOrientation");
            a.item("Orientation@names", "Horizontal;Vertical");
            a.item("TextColor", "String");
            a.item("TextStyle", "String");
            LegendDescriptionMetadata.e(a);
        }
        static d(a) {
            LegendDescriptionMetadata.b(a);
            a.ae("Legend", () => new LegendDescription());
            a.ad("Legend", LegendDescriptionMetadata.a);
        }
    }
    LegendDescriptionMetadata.$t = /*@__PURE__*/ markType(LegendDescriptionMetadata, 'LegendDescriptionMetadata');
    LegendDescriptionMetadata.a = null;
    return LegendDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendDescriptionModule = /*@__PURE__*/ (() => {
    class LegendDescriptionModule extends Base {
        static register(a) {
            LegendDescriptionMetadata.d(a);
        }
    }
    LegendDescriptionModule.$t = /*@__PURE__*/ markType(LegendDescriptionModule, 'LegendDescriptionModule');
    return LegendDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGaugeDescription = /*@__PURE__*/ (() => {
    class LinearGaugeDescription extends Description {
        get fontFamily() {
            return this.c6;
        }
        set fontFamily(a) {
            this.c6 = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.ag;
        }
        set fontSize(a) {
            this.ag = a;
            this.g("FontSize");
        }
        get fontWeight() {
            return this.c8;
        }
        set fontWeight(a) {
            this.c8 = a;
            this.g("FontWeight");
        }
        get fontStyle() {
            return this.c7;
        }
        set fontStyle(a) {
            this.c7 = a;
            this.g("FontStyle");
        }
        get width() {
            return this.dp;
        }
        set width(a) {
            this.dp = a;
            this.g("Width");
        }
        get height() {
            return this.da;
        }
        set height(a) {
            this.da = a;
            this.g("Height");
        }
        get background() {
            return this.c1;
        }
        set background(a) {
            this.c1 = a;
            this.g("Background");
        }
        get_type() {
            return "LinearGauge";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.c6 = null;
            this.ag = 0;
            this.c8 = null;
            this.c7 = null;
            this.dp = null;
            this.da = null;
            this.c1 = null;
            this.bh = 0;
            this.dj = null;
            this.k = null;
            this.i = null;
            this.j = null;
            this.ap = 0;
            this.ab = 0;
            this.ao = 0;
            this.aa = 0;
            this.bi = 0;
            this.di = null;
            this.dg = null;
            this.a5 = 0;
            this.a8 = 0;
            this.a6 = 0;
            this.a9 = 0;
            this.aw = 0;
            this.a0 = 0;
            this.av = 0;
            this.az = 0;
            this.ay = 0;
            this.a2 = 0;
            this.ax = 0;
            this.a1 = 0;
            this.aj = 0;
            this.bd = 0;
            this.be = 0;
            this.al = 0;
            this.ak = 0;
            this.am = 0;
            this.an = 0;
            this.aq = 0;
            this.bf = 0;
            this.bc = 0;
            this.bg = 0;
            this.dm = null;
            this.c5 = null;
            this.au = 0;
            this.df = null;
            this.dh = null;
            this.a3 = 0;
            this.as = 0;
            this.ar = 0;
            this.at = 0;
            this.de = null;
            this.r = false;
            this.c2 = null;
            this.c3 = null;
            this.af = 0;
            this.ad = 0;
            this.ae = 0;
            this.ba = 0;
            this.a7 = 0;
            this.dk = null;
            this.dl = null;
            this.bb = 0;
            this.s = false;
            this.q = false;
            this.p = false;
            this.dd = null;
            this.h = null;
            this.cu = 0;
            this.ah = 0;
            this.z = 0;
            this.ai = 0;
            this.cx = null;
            this.dc = null;
            this.ct = 0;
            this.t = false;
            this.c4 = null;
            this.a4 = 0;
            this.ac = 0;
            this.c9 = null;
            this.c0 = null;
            this.dn = null;
            this.db = null;
            this.cz = null;
            this.cy = null;
        }
        get transitionProgress() {
            return this.bh;
        }
        set transitionProgress(a) {
            this.bh = a;
            this.g("TransitionProgress");
        }
        get orientation() {
            return this.dj;
        }
        set orientation(a) {
            this.dj = a;
            this.g("Orientation");
        }
        get ranges() {
            return this.k;
        }
        set ranges(a) {
            this.k = a;
            this.g("Ranges");
        }
        get rangeBrushes() {
            return this.i;
        }
        set rangeBrushes(a) {
            this.i = a;
            this.g("RangeBrushes");
        }
        get rangeOutlines() {
            return this.j;
        }
        set rangeOutlines(a) {
            this.j = a;
            this.g("RangeOutlines");
        }
        get minimumValue() {
            return this.ap;
        }
        set minimumValue(a) {
            this.ap = a;
            this.g("MinimumValue");
        }
        get actualMinimumValue() {
            return this.ab;
        }
        set actualMinimumValue(a) {
            this.ab = a;
            this.g("ActualMinimumValue");
        }
        get maximumValue() {
            return this.ao;
        }
        set maximumValue(a) {
            this.ao = a;
            this.g("MaximumValue");
        }
        get actualMaximumValue() {
            return this.aa;
        }
        set actualMaximumValue(a) {
            this.aa = a;
            this.g("ActualMaximumValue");
        }
        get value() {
            return this.bi;
        }
        set value(a) {
            this.bi = a;
            this.g("Value");
        }
        get needleShape() {
            return this.di;
        }
        set needleShape(a) {
            this.di = a;
            this.g("NeedleShape");
        }
        get needleName() {
            return this.dg;
        }
        set needleName(a) {
            this.dg = a;
            this.g("NeedleName");
        }
        get rangeInnerExtent() {
            return this.a5;
        }
        set rangeInnerExtent(a) {
            this.a5 = a;
            this.g("RangeInnerExtent");
        }
        get scaleInnerExtent() {
            return this.a8;
        }
        set scaleInnerExtent(a) {
            this.a8 = a;
            this.g("ScaleInnerExtent");
        }
        get rangeOuterExtent() {
            return this.a6;
        }
        set rangeOuterExtent(a) {
            this.a6 = a;
            this.g("RangeOuterExtent");
        }
        get scaleOuterExtent() {
            return this.a9;
        }
        set scaleOuterExtent(a) {
            this.a9 = a;
            this.g("ScaleOuterExtent");
        }
        get needleInnerExtent() {
            return this.aw;
        }
        set needleInnerExtent(a) {
            this.aw = a;
            this.g("NeedleInnerExtent");
        }
        get needleOuterExtent() {
            return this.a0;
        }
        set needleOuterExtent(a) {
            this.a0 = a;
            this.g("NeedleOuterExtent");
        }
        get needleInnerBaseWidth() {
            return this.av;
        }
        set needleInnerBaseWidth(a) {
            this.av = a;
            this.g("NeedleInnerBaseWidth");
        }
        get needleOuterBaseWidth() {
            return this.az;
        }
        set needleOuterBaseWidth(a) {
            this.az = a;
            this.g("NeedleOuterBaseWidth");
        }
        get needleInnerPointWidth() {
            return this.ay;
        }
        set needleInnerPointWidth(a) {
            this.ay = a;
            this.g("NeedleInnerPointWidth");
        }
        get needleOuterPointWidth() {
            return this.a2;
        }
        set needleOuterPointWidth(a) {
            this.a2 = a;
            this.g("NeedleOuterPointWidth");
        }
        get needleInnerPointExtent() {
            return this.ax;
        }
        set needleInnerPointExtent(a) {
            this.ax = a;
            this.g("NeedleInnerPointExtent");
        }
        get needleOuterPointExtent() {
            return this.a1;
        }
        set needleOuterPointExtent(a) {
            this.a1 = a;
            this.g("NeedleOuterPointExtent");
        }
        get interval() {
            return this.aj;
        }
        set interval(a) {
            this.aj = a;
            this.g("Interval");
        }
        get ticksPostInitial() {
            return this.bd;
        }
        set ticksPostInitial(a) {
            this.bd = a;
            this.g("TicksPostInitial");
        }
        get ticksPreTerminal() {
            return this.be;
        }
        set ticksPreTerminal(a) {
            this.be = a;
            this.g("TicksPreTerminal");
        }
        get labelInterval() {
            return this.al;
        }
        set labelInterval(a) {
            this.al = a;
            this.g("LabelInterval");
        }
        get labelExtent() {
            return this.ak;
        }
        set labelExtent(a) {
            this.ak = a;
            this.g("LabelExtent");
        }
        get labelsPostInitial() {
            return this.am;
        }
        set labelsPostInitial(a) {
            this.am = a;
            this.g("LabelsPostInitial");
        }
        get labelsPreTerminal() {
            return this.an;
        }
        set labelsPreTerminal(a) {
            this.an = a;
            this.g("LabelsPreTerminal");
        }
        get minorTickCount() {
            return this.aq;
        }
        set minorTickCount(a) {
            this.aq = a;
            this.g("MinorTickCount");
        }
        get tickStartExtent() {
            return this.bf;
        }
        set tickStartExtent(a) {
            this.bf = a;
            this.g("TickStartExtent");
        }
        get tickEndExtent() {
            return this.bc;
        }
        set tickEndExtent(a) {
            this.bc = a;
            this.g("TickEndExtent");
        }
        get tickStrokeThickness() {
            return this.bg;
        }
        set tickStrokeThickness(a) {
            this.bg = a;
            this.g("TickStrokeThickness");
        }
        get tickBrush() {
            return this.dm;
        }
        set tickBrush(a) {
            this.dm = a;
            this.g("TickBrush");
        }
        get fontBrush() {
            return this.c5;
        }
        set fontBrush(a) {
            this.c5 = a;
            this.g("FontBrush");
        }
        get needleBreadth() {
            return this.au;
        }
        set needleBreadth(a) {
            this.au = a;
            this.g("NeedleBreadth");
        }
        get needleBrush() {
            return this.df;
        }
        set needleBrush(a) {
            this.df = a;
            this.g("NeedleBrush");
        }
        get needleOutline() {
            return this.dh;
        }
        set needleOutline(a) {
            this.dh = a;
            this.g("NeedleOutline");
        }
        get needleStrokeThickness() {
            return this.a3;
        }
        set needleStrokeThickness(a) {
            this.a3 = a;
            this.g("NeedleStrokeThickness");
        }
        get minorTickStartExtent() {
            return this.as;
        }
        set minorTickStartExtent(a) {
            this.as = a;
            this.g("MinorTickStartExtent");
        }
        get minorTickEndExtent() {
            return this.ar;
        }
        set minorTickEndExtent(a) {
            this.ar = a;
            this.g("MinorTickEndExtent");
        }
        get minorTickStrokeThickness() {
            return this.at;
        }
        set minorTickStrokeThickness(a) {
            this.at = a;
            this.g("MinorTickStrokeThickness");
        }
        get minorTickBrush() {
            return this.de;
        }
        set minorTickBrush(a) {
            this.de = a;
            this.g("MinorTickBrush");
        }
        get isScaleInverted() {
            return this.r;
        }
        set isScaleInverted(a) {
            this.r = a;
            this.g("IsScaleInverted");
        }
        get backingBrush() {
            return this.c2;
        }
        set backingBrush(a) {
            this.c2 = a;
            this.g("BackingBrush");
        }
        get backingOutline() {
            return this.c3;
        }
        set backingOutline(a) {
            this.c3 = a;
            this.g("BackingOutline");
        }
        get backingStrokeThickness() {
            return this.af;
        }
        set backingStrokeThickness(a) {
            this.af = a;
            this.g("BackingStrokeThickness");
        }
        get backingInnerExtent() {
            return this.ad;
        }
        set backingInnerExtent(a) {
            this.ad = a;
            this.g("BackingInnerExtent");
        }
        get backingOuterExtent() {
            return this.ae;
        }
        set backingOuterExtent(a) {
            this.ae = a;
            this.g("BackingOuterExtent");
        }
        get scaleStartExtent() {
            return this.ba;
        }
        set scaleStartExtent(a) {
            this.ba = a;
            this.g("ScaleStartExtent");
        }
        get scaleEndExtent() {
            return this.a7;
        }
        set scaleEndExtent(a) {
            this.a7 = a;
            this.g("ScaleEndExtent");
        }
        get scaleBrush() {
            return this.dk;
        }
        set scaleBrush(a) {
            this.dk = a;
            this.g("ScaleBrush");
        }
        get scaleOutline() {
            return this.dl;
        }
        set scaleOutline(a) {
            this.dl = a;
            this.g("ScaleOutline");
        }
        get scaleStrokeThickness() {
            return this.bb;
        }
        set scaleStrokeThickness(a) {
            this.bb = a;
            this.g("ScaleStrokeThickness");
        }
        get mergeViewports() {
            return this.s;
        }
        set mergeViewports(a) {
            this.s = a;
            this.g("MergeViewports");
        }
        get isNeedleDraggingEnabled() {
            return this.q;
        }
        set isNeedleDraggingEnabled(a) {
            this.q = a;
            this.g("IsNeedleDraggingEnabled");
        }
        get isHighlightNeedleDraggingEnabled() {
            return this.p;
        }
        set isHighlightNeedleDraggingEnabled(a) {
            this.p = a;
            this.g("IsHighlightNeedleDraggingEnabled");
        }
        get labelFormat() {
            return this.dd;
        }
        set labelFormat(a) {
            this.dd = a;
            this.g("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.h;
        }
        set labelFormatSpecifiers(a) {
            this.h = a;
            this.g("LabelFormatSpecifiers");
        }
        get transitionDuration() {
            return this.cu;
        }
        set transitionDuration(a) {
            this.cu = a;
            this.g("TransitionDuration");
        }
        get highlightValue() {
            return this.ah;
        }
        set highlightValue(a) {
            this.ah = a;
            this.g("HighlightValue");
        }
        get actualHighlightValueOpacity() {
            return this.z;
        }
        set actualHighlightValueOpacity(a) {
            this.z = a;
            this.g("ActualHighlightValueOpacity");
        }
        get highlightValueOpacity() {
            return this.ai;
        }
        set highlightValueOpacity(a) {
            this.ai = a;
            this.g("HighlightValueOpacity");
        }
        get actualHighlightValueDisplayMode() {
            return this.cx;
        }
        set actualHighlightValueDisplayMode(a) {
            this.cx = a;
            this.g("ActualHighlightValueDisplayMode");
        }
        get highlightValueDisplayMode() {
            return this.dc;
        }
        set highlightValueDisplayMode(a) {
            this.dc = a;
            this.g("HighlightValueDisplayMode");
        }
        get showToolTipTimeout() {
            return this.ct;
        }
        set showToolTipTimeout(a) {
            this.ct = a;
            this.g("ShowToolTipTimeout");
        }
        get showToolTip() {
            return this.t;
        }
        set showToolTip(a) {
            this.t = a;
            this.g("ShowToolTip");
        }
        get font() {
            return this.c4;
        }
        set font(a) {
            this.c4 = a;
            this.g("Font");
        }
        get pixelScalingRatio() {
            return this.a4;
        }
        set pixelScalingRatio(a) {
            this.a4 = a;
            this.g("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.ac;
        }
        set actualPixelScalingRatio(a) {
            this.ac = a;
            this.g("ActualPixelScalingRatio");
        }
        get formatLabelRef() {
            return this.c9;
        }
        set formatLabelRef(a) {
            this.c9 = a;
            this.g("FormatLabelRef");
        }
        get alignLabelRef() {
            return this.c0;
        }
        set alignLabelRef(a) {
            this.c0 = a;
            this.g("AlignLabelRef");
        }
        get valueChangedRef() {
            return this.dn;
        }
        set valueChangedRef(a) {
            this.dn = a;
            this.g("ValueChangedRef");
        }
        get highlightValueChangedRef() {
            return this.db;
        }
        set highlightValueChangedRef(a) {
            this.db = a;
            this.g("HighlightValueChangedRef");
        }
        get actualMinimumValueChangeRef() {
            return this.cz;
        }
        set actualMinimumValueChangeRef(a) {
            this.cz = a;
            this.g("ActualMinimumValueChangeRef");
        }
        get actualMaximumValueChangeRef() {
            return this.cy;
        }
        set actualMaximumValueChangeRef(a) {
            this.cy = a;
            this.g("ActualMaximumValueChangeRef");
        }
    }
    LinearGaugeDescription.$t = /*@__PURE__*/ markType(LinearGaugeDescription, 'LinearGaugeDescription', Description.$);
    return LinearGaugeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGaugeDescriptionMetadata = /*@__PURE__*/ (() => {
    class LinearGaugeDescriptionMetadata extends Base {
        static e(a) {
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:TextStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:TextStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontStyle/FontStyleTransform,wf:FontStyle/FontStyleTransform,web:TextStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontStyle/FontWeightTransform,wf:FontStyle/FontWeightTransform,web:TextStyle/FontWeightTransform)String");
            a.item("_qualifiedName", "String:Infragistics.Controls.Gauges.XamLinearGauge");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
            a.item("LegendRef", "(w:Legend)DataRef:String");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (LinearGaugeDescriptionMetadata.a == null) {
                LinearGaugeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LinearGaugeDescriptionMetadata.c(LinearGaugeDescriptionMetadata.a);
            }
            if (a.k(LinearGaugeDescriptionMetadata.a)) {
                return;
            }
            a.ac(LinearGaugeDescriptionMetadata.a);
            FormatLinearGraphLabelEventArgsDescriptionMetadata.d(a);
            AlignLinearGraphLabelEventArgsDescriptionMetadata.d(a);
            DoubleValueChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("TransitionProgress", "Number:double");
            a.item("Orientation", "ExportedType:string:LinearScaleOrientation");
            a.item("Orientation@names", "Horizontal;Vertical");
            a.item("Ranges", "Collection:LinearGraphRange:LinearGraphRangeCollection:LinearGraphRange");
            a.item("RangeBrushes", "BrushCollection:string");
            a.item("RangeOutlines", "BrushCollection:string");
            a.item("MinimumValue", "Number:double");
            a.item("ActualMinimumValue", "Number:double");
            a.item("MaximumValue", "Number:double");
            a.item("ActualMaximumValue", "Number:double");
            a.item("Value", "Number:double");
            a.item("NeedleShape", "ExportedType:string:LinearGraphNeedleShape");
            a.item("NeedleShape@names", "Custom;Rectangle;Triangle;Needle;Trapezoid");
            a.item("NeedleName", "String");
            a.item("RangeInnerExtent", "Number:double");
            a.item("ScaleInnerExtent", "Number:double");
            a.item("RangeOuterExtent", "Number:double");
            a.item("ScaleOuterExtent", "Number:double");
            a.item("NeedleInnerExtent", "Number:double");
            a.item("NeedleOuterExtent", "Number:double");
            a.item("NeedleInnerBaseWidth", "Number:double");
            a.item("NeedleOuterBaseWidth", "Number:double");
            a.item("NeedleInnerPointWidth", "Number:double");
            a.item("NeedleOuterPointWidth", "Number:double");
            a.item("NeedleInnerPointExtent", "Number:double");
            a.item("NeedleOuterPointExtent", "Number:double");
            a.item("Interval", "Number:double");
            a.item("TicksPostInitial", "Number:double");
            a.item("TicksPreTerminal", "Number:double");
            a.item("LabelInterval", "Number:double");
            a.item("LabelExtent", "Number:double");
            a.item("LabelsPostInitial", "Number:double");
            a.item("LabelsPreTerminal", "Number:double");
            a.item("MinorTickCount", "Number:double");
            a.item("TickStartExtent", "Number:double");
            a.item("TickEndExtent", "Number:double");
            a.item("TickStrokeThickness", "Number:double");
            a.item("TickBrush", "Brush");
            a.item("FontBrush", "Brush");
            a.item("NeedleBreadth", "Number:double");
            a.item("NeedleBrush", "Brush");
            a.item("NeedleOutline", "Brush");
            a.item("NeedleStrokeThickness", "Number:double");
            a.item("MinorTickStartExtent", "Number:double");
            a.item("MinorTickEndExtent", "Number:double");
            a.item("MinorTickStrokeThickness", "Number:double");
            a.item("MinorTickBrush", "Brush");
            a.item("IsScaleInverted", "Boolean");
            a.item("BackingBrush", "Brush");
            a.item("BackingOutline", "Brush");
            a.item("BackingStrokeThickness", "Number:double");
            a.item("BackingInnerExtent", "Number:double");
            a.item("BackingOuterExtent", "Number:double");
            a.item("ScaleStartExtent", "Number:double");
            a.item("ScaleEndExtent", "Number:double");
            a.item("ScaleBrush", "Brush");
            a.item("ScaleOutline", "Brush");
            a.item("ScaleStrokeThickness", "Number:double");
            a.item("MergeViewports", "Boolean");
            a.item("IsNeedleDraggingEnabled", "Boolean");
            a.item("IsHighlightNeedleDraggingEnabled", "Boolean");
            a.item("LabelFormat", "String");
            a.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("TransitionDuration", "Number:int");
            a.item("HighlightValue", "Number:double");
            a.item("ActualHighlightValueOpacity", "Number:double");
            a.item("HighlightValueOpacity", "Number:double");
            a.item("ActualHighlightValueDisplayMode", "ExportedType:string:HighlightedValueDisplayMode");
            a.item("ActualHighlightValueDisplayMode@names", "Auto;Hidden;Overlay");
            a.item("HighlightValueDisplayMode", "ExportedType:string:HighlightedValueDisplayMode");
            a.item("HighlightValueDisplayMode@names", "Auto;Hidden;Overlay");
            a.item("ShowToolTipTimeout", "Number:int");
            a.item("ShowToolTip", "Boolean");
            a.item("Font", "String");
            a.item("PixelScalingRatio", "Number:double");
            a.item("ActualPixelScalingRatio", "Number:double");
            a.item("FormatLabelRef", "EventRef::formatLabel");
            a.item("AlignLabelRef", "EventRef::alignLabel");
            a.item("ValueChangedRef", "EventRef::valueChanged");
            a.item("HighlightValueChangedRef", "EventRef::highlightValueChanged");
            a.item("ActualMinimumValueChangeRef", "EventRef::actualMinimumValueChange");
            a.item("ActualMaximumValueChangeRef", "EventRef::actualMaximumValueChange");
            LinearGaugeDescriptionMetadata.e(a);
        }
        static d(a) {
            LinearGaugeDescriptionMetadata.b(a);
            a.ae("LinearGauge", () => new LinearGaugeDescription());
            a.ad("LinearGauge", LinearGaugeDescriptionMetadata.a);
        }
    }
    LinearGaugeDescriptionMetadata.$t = /*@__PURE__*/ markType(LinearGaugeDescriptionMetadata, 'LinearGaugeDescriptionMetadata');
    LinearGaugeDescriptionMetadata.a = null;
    return LinearGaugeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGaugeCoreDescriptionModule = /*@__PURE__*/ (() => {
    class LinearGaugeCoreDescriptionModule extends Base {
        static register(a) {
            LinearGaugeDescriptionMetadata.d(a);
            LinearGraphRangeDescriptionModule.register(a);
            NumberFormatSpecifierDescriptionModule.register(a);
        }
    }
    LinearGaugeCoreDescriptionModule.$t = /*@__PURE__*/ markType(LinearGaugeCoreDescriptionModule, 'LinearGaugeCoreDescriptionModule');
    return LinearGaugeCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGaugeDescriptionModule = /*@__PURE__*/ (() => {
    class LinearGaugeDescriptionModule extends Base {
        static register(a) {
            LinearGaugeCoreDescriptionModule.register(a);
            DVInteractivityDescriptionModule.register(a);
        }
    }
    LinearGaugeDescriptionModule.$t = /*@__PURE__*/ markType(LinearGaugeDescriptionModule, 'LinearGaugeDescriptionModule');
    return LinearGaugeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ListPanelDescription = /*@__PURE__*/ (() => {
    class ListPanelDescription extends Description {
        get_type() {
            return "ListPanel";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.w = null;
            this.h = null;
            this.p = 0;
            this.l = 0;
            this.s = null;
            this.m = 0;
            this.t = null;
            this.u = null;
            this.r = null;
            this.z = null;
            this.j = false;
            this.ab = null;
            this.v = null;
            this.aa = null;
            this.y = null;
            this.x = null;
        }
        get dataSourceRef() {
            return this.w;
        }
        set dataSourceRef(a) {
            this.w = a;
            this.g("DataSourceRef");
        }
        get dataSource() {
            return this.h;
        }
        set dataSource(a) {
            this.h = a;
            this.g("DataSource");
        }
        get rowHeight() {
            return this.p;
        }
        set rowHeight(a) {
            this.p = a;
            this.g("RowHeight");
        }
        get actualRowHeight() {
            return this.l;
        }
        set actualRowHeight(a) {
            this.l = a;
            this.g("ActualRowHeight");
        }
        get cellFontFamily() {
            return this.s;
        }
        set cellFontFamily(a) {
            this.s = a;
            this.g("CellFontFamily");
        }
        get cellFontSize() {
            return this.m;
        }
        set cellFontSize(a) {
            this.m = a;
            this.g("CellFontSize");
        }
        get cellFontStyle() {
            return this.t;
        }
        set cellFontStyle(a) {
            this.t = a;
            this.g("CellFontStyle");
        }
        get cellFontWeight() {
            return this.u;
        }
        set cellFontWeight(a) {
            this.u = a;
            this.g("CellFontWeight");
        }
        get backgroundColor() {
            return this.r;
        }
        set backgroundColor(a) {
            this.r = a;
            this.g("BackgroundColor");
        }
        get orientation() {
            return this.z;
        }
        set orientation(a) {
            this.z = a;
            this.g("Orientation");
        }
        get isCustomRowHeightEnabled() {
            return this.j;
        }
        set isCustomRowHeightEnabled(a) {
            this.j = a;
            this.g("IsCustomRowHeightEnabled");
        }
        get textColor() {
            return this.ab;
        }
        set textColor(a) {
            this.ab = a;
            this.g("TextColor");
        }
        get contentRefreshedRef() {
            return this.v;
        }
        set contentRefreshedRef(a) {
            this.v = a;
            this.g("ContentRefreshedRef");
        }
        get rowUpdatingRef() {
            return this.aa;
        }
        set rowUpdatingRef(a) {
            this.aa = a;
            this.g("RowUpdatingRef");
        }
        get itemWidthRequestedRef() {
            return this.y;
        }
        set itemWidthRequestedRef(a) {
            this.y = a;
            this.g("ItemWidthRequestedRef");
        }
        get itemHeightRequestedRef() {
            return this.x;
        }
        set itemHeightRequestedRef(a) {
            this.x = a;
            this.g("ItemHeightRequestedRef");
        }
    }
    ListPanelDescription.$t = /*@__PURE__*/ markType(ListPanelDescription, 'ListPanelDescription', Description.$);
    return ListPanelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ListPanelContentRefreshedEventArgsDescription = /*@__PURE__*/ (() => {
    class ListPanelContentRefreshedEventArgsDescription extends Description {
        get_type() {
            return "ListPanelContentRefreshedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ListPanelContentRefreshedEventArgsDescription.$t = /*@__PURE__*/ markType(ListPanelContentRefreshedEventArgsDescription, 'ListPanelContentRefreshedEventArgsDescription', Description.$);
    return ListPanelContentRefreshedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ListPanelContentRefreshedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ListPanelContentRefreshedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ListPanelContentRefreshedEventArgsDescriptionMetadata.a == null) {
                ListPanelContentRefreshedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ListPanelContentRefreshedEventArgsDescriptionMetadata.c(ListPanelContentRefreshedEventArgsDescriptionMetadata.a);
            }
            if (a.k(ListPanelContentRefreshedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ListPanelContentRefreshedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ListPanelContentRefreshedEventArgsDescriptionMetadata.b(a);
            a.ae("ListPanelContentRefreshedEventArgs", () => new ListPanelContentRefreshedEventArgsDescription());
            a.ad("ListPanelContentRefreshedEventArgs", ListPanelContentRefreshedEventArgsDescriptionMetadata.a);
        }
    }
    ListPanelContentRefreshedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ListPanelContentRefreshedEventArgsDescriptionMetadata, 'ListPanelContentRefreshedEventArgsDescriptionMetadata');
    ListPanelContentRefreshedEventArgsDescriptionMetadata.a = null;
    return ListPanelContentRefreshedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ListPanelItemModelDescription = /*@__PURE__*/ (() => {
    class ListPanelItemModelDescription extends Description {
        get_type() {
            return "ListPanelItemModel";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = 0;
            this.j = 0;
            this.n = null;
            this.h = false;
        }
        get dataRow() {
            return this.l;
        }
        set dataRow(a) {
            this.l = a;
            this.g("DataRow");
        }
        get rowHeight() {
            return this.j;
        }
        set rowHeight(a) {
            this.j = a;
            this.g("RowHeight");
        }
        get rowObjectRef() {
            return this.n;
        }
        set rowObjectRef(a) {
            this.n = a;
            this.g("RowObjectRef");
        }
        get isModelDirty() {
            return this.h;
        }
        set isModelDirty(a) {
            this.h = a;
            this.g("IsModelDirty");
        }
    }
    ListPanelItemModelDescription.$t = /*@__PURE__*/ markType(ListPanelItemModelDescription, 'ListPanelItemModelDescription', Description.$);
    return ListPanelItemModelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ListPanelItemModelDescriptionMetadata = /*@__PURE__*/ (() => {
    class ListPanelItemModelDescriptionMetadata extends Base {
        static b(a) {
            if (ListPanelItemModelDescriptionMetadata.a == null) {
                ListPanelItemModelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ListPanelItemModelDescriptionMetadata.c(ListPanelItemModelDescriptionMetadata.a);
            }
            if (a.k(ListPanelItemModelDescriptionMetadata.a)) {
                return;
            }
            a.ac(ListPanelItemModelDescriptionMetadata.a);
        }
        static c(a) {
            a.item("DataRow", "Number:int");
            a.item("RowHeight", "Number:double");
            a.item("RowObjectRef", "(w:RowObject,wf:RowObject)DataRef");
            a.item("IsModelDirty", "Boolean");
        }
        static d(a) {
            ListPanelItemModelDescriptionMetadata.b(a);
            a.ae("ListPanelItemModel", () => new ListPanelItemModelDescription());
            a.ad("ListPanelItemModel", ListPanelItemModelDescriptionMetadata.a);
        }
    }
    ListPanelItemModelDescriptionMetadata.$t = /*@__PURE__*/ markType(ListPanelItemModelDescriptionMetadata, 'ListPanelItemModelDescriptionMetadata');
    ListPanelItemModelDescriptionMetadata.a = null;
    return ListPanelItemModelDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ListPanelTemplateItemUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class ListPanelTemplateItemUpdatingEventArgsDescription extends Description {
        get_type() {
            return "ListPanelTemplateItemUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = null;
        }
        get model() {
            return this.h;
        }
        set model(a) {
            this.h = a;
            this.g("Model");
        }
        get contentRef() {
            return this.j;
        }
        set contentRef(a) {
            this.j = a;
            this.g("ContentRef");
        }
    }
    ListPanelTemplateItemUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(ListPanelTemplateItemUpdatingEventArgsDescription, 'ListPanelTemplateItemUpdatingEventArgsDescription', Description.$);
    return ListPanelTemplateItemUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata.a == null) {
                ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata.c(ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata.a);
            }
            if (a.k(ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata.a);
            ListPanelItemModelDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Model", "ExportedType:ListPanelItemModel");
            a.item("ContentRef", "(w:Content,wf:Content)DataRef");
        }
        static d(a) {
            ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata.b(a);
            a.ae("ListPanelTemplateItemUpdatingEventArgs", () => new ListPanelTemplateItemUpdatingEventArgsDescription());
            a.ad("ListPanelTemplateItemUpdatingEventArgs", ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata, 'ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata');
    ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata.a = null;
    return ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ListPanelTemplateWidthRequestedEventArgsDescription = /*@__PURE__*/ (() => {
    class ListPanelTemplateWidthRequestedEventArgsDescription extends Description {
        get_type() {
            return "ListPanelTemplateWidthRequestedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = 0;
            this.l = null;
            this.h = 0;
        }
        get dataRow() {
            return this.j;
        }
        set dataRow(a) {
            this.j = a;
            this.g("DataRow");
        }
        get dataItemRef() {
            return this.l;
        }
        set dataItemRef(a) {
            this.l = a;
            this.g("DataItemRef");
        }
        get width() {
            return this.h;
        }
        set width(a) {
            this.h = a;
            this.g("Width");
        }
    }
    ListPanelTemplateWidthRequestedEventArgsDescription.$t = /*@__PURE__*/ markType(ListPanelTemplateWidthRequestedEventArgsDescription, 'ListPanelTemplateWidthRequestedEventArgsDescription', Description.$);
    return ListPanelTemplateWidthRequestedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata.a == null) {
                ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata.c(ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata.a);
            }
            if (a.k(ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("DataRow", "Number:int");
            a.item("DataItemRef", "(w:DataItem,wf:DataItem)DataRef");
            a.item("Width", "Number:double");
        }
        static d(a) {
            ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata.b(a);
            a.ae("ListPanelTemplateWidthRequestedEventArgs", () => new ListPanelTemplateWidthRequestedEventArgsDescription());
            a.ad("ListPanelTemplateWidthRequestedEventArgs", ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata.a);
        }
    }
    ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata, 'ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata');
    ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata.a = null;
    return ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ListPanelTemplateHeightRequestedEventArgsDescription = /*@__PURE__*/ (() => {
    class ListPanelTemplateHeightRequestedEventArgsDescription extends Description {
        get_type() {
            return "ListPanelTemplateHeightRequestedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = 0;
            this.l = null;
            this.h = 0;
        }
        get dataRow() {
            return this.j;
        }
        set dataRow(a) {
            this.j = a;
            this.g("DataRow");
        }
        get dataItemRef() {
            return this.l;
        }
        set dataItemRef(a) {
            this.l = a;
            this.g("DataItemRef");
        }
        get height() {
            return this.h;
        }
        set height(a) {
            this.h = a;
            this.g("Height");
        }
    }
    ListPanelTemplateHeightRequestedEventArgsDescription.$t = /*@__PURE__*/ markType(ListPanelTemplateHeightRequestedEventArgsDescription, 'ListPanelTemplateHeightRequestedEventArgsDescription', Description.$);
    return ListPanelTemplateHeightRequestedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata.a == null) {
                ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata.c(ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata.a);
            }
            if (a.k(ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("DataRow", "Number:int");
            a.item("DataItemRef", "(w:DataItem,wf:DataItem)DataRef");
            a.item("Height", "Number:double");
        }
        static d(a) {
            ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata.b(a);
            a.ae("ListPanelTemplateHeightRequestedEventArgs", () => new ListPanelTemplateHeightRequestedEventArgsDescription());
            a.ad("ListPanelTemplateHeightRequestedEventArgs", ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata.a);
        }
    }
    ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata, 'ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata');
    ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata.a = null;
    return ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ListPanelDescriptionMetadata = /*@__PURE__*/ (() => {
    class ListPanelDescriptionMetadata extends Base {
        static b(a) {
            if (ListPanelDescriptionMetadata.a == null) {
                ListPanelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ListPanelDescriptionMetadata.c(ListPanelDescriptionMetadata.a);
            }
            if (a.k(ListPanelDescriptionMetadata.a)) {
                return;
            }
            a.ac(ListPanelDescriptionMetadata.a);
            ListPanelContentRefreshedEventArgsDescriptionMetadata.d(a);
            ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata.d(a);
            ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata.d(a);
            ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)DataRef::object");
            a.item("DataSource", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            a.item("RowHeight", "Number:int");
            a.item("ActualRowHeight", "Number:double");
            a.item("CellFontFamily", "(w:CellFontFamily/FontFamilyTransform,xam:CellFontFamily,wf:CellFontFamily,web:cellTextStyle/FontFamilyTransform)String");
            a.item("CellFontSize", "(w:CellFontSize,xam:CellFontSize,wf:CellFontSize,web:cellTextStyle/FontSizeTransform)Number:double");
            a.item("CellFontStyle", "(w:CellFontStyle/FontStyleTransform,xam:CellFontFamily/FontStyleTransform,wf:CellFontFamily/FontStyleTransform,web:cellTextStyle/FontStyleTransform)String");
            a.item("CellFontWeight", "(w:CellFontWeight/FontWeightTransform,xam:CellFontFamily/FontWeightTransform,wf:CellFontFamily/FontWeightTransform,web:cellTextStyle/FontWeightTransform)String");
            a.item("BackgroundColor", "Brush");
            a.item("Orientation", "ExportedType:string:ListPanelOrientation");
            a.item("Orientation@names", "Vertical;Horizontal");
            a.item("IsCustomRowHeightEnabled", "Boolean");
            a.item("TextColor", "Brush");
            a.item("ContentRefreshedRef", "EventRef::contentRefreshed");
            a.item("RowUpdatingRef", "EventRef::rowUpdating");
            a.item("ItemWidthRequestedRef", "EventRef::itemWidthRequested");
            a.item("ItemHeightRequestedRef", "EventRef::itemHeightRequested");
        }
        static d(a) {
            ListPanelDescriptionMetadata.b(a);
            a.ae("ListPanel", () => new ListPanelDescription());
            a.ad("ListPanel", ListPanelDescriptionMetadata.a);
        }
    }
    ListPanelDescriptionMetadata.$t = /*@__PURE__*/ markType(ListPanelDescriptionMetadata, 'ListPanelDescriptionMetadata');
    ListPanelDescriptionMetadata.a = null;
    return ListPanelDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ListPanelDescriptionModule = /*@__PURE__*/ (() => {
    class ListPanelDescriptionModule extends Base {
        static register(a) {
            ListPanelDescriptionMetadata.d(a);
        }
    }
    ListPanelDescriptionModule.$t = /*@__PURE__*/ markType(ListPanelDescriptionModule, 'ListPanelDescriptionModule');
    return ListPanelDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NextMonthExpressionDescription = /*@__PURE__*/ (() => {
    class NextMonthExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "NextMonthExpression";
        }
        constructor() {
            super();
        }
    }
    NextMonthExpressionDescription.$t = /*@__PURE__*/ markType(NextMonthExpressionDescription, 'NextMonthExpressionDescription', WrapperExpressionDescription.$);
    NextMonthExpressionDescription.__marshalByValue2 = true;
    NextMonthExpressionDescription.__marshalByValueAlias2 = "NextMonthExpression";
    return NextMonthExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NextMonthExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class NextMonthExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (NextMonthExpressionDescriptionMetadata.a == null) {
                NextMonthExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NextMonthExpressionDescriptionMetadata.c(NextMonthExpressionDescriptionMetadata.a);
            }
            if (a.k(NextMonthExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(NextMonthExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            NextMonthExpressionDescriptionMetadata.b(a);
            a.ae("NextMonthExpression", () => new NextMonthExpressionDescription());
            a.ad("NextMonthExpression", NextMonthExpressionDescriptionMetadata.a);
        }
    }
    NextMonthExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(NextMonthExpressionDescriptionMetadata, 'NextMonthExpressionDescriptionMetadata');
    NextMonthExpressionDescriptionMetadata.a = null;
    return NextMonthExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NextQuarterExpressionDescription = /*@__PURE__*/ (() => {
    class NextQuarterExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "NextQuarterExpression";
        }
        constructor() {
            super();
        }
    }
    NextQuarterExpressionDescription.$t = /*@__PURE__*/ markType(NextQuarterExpressionDescription, 'NextQuarterExpressionDescription', WrapperExpressionDescription.$);
    NextQuarterExpressionDescription.__marshalByValue2 = true;
    NextQuarterExpressionDescription.__marshalByValueAlias2 = "NextQuarterExpression";
    return NextQuarterExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NextQuarterExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class NextQuarterExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (NextQuarterExpressionDescriptionMetadata.a == null) {
                NextQuarterExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NextQuarterExpressionDescriptionMetadata.c(NextQuarterExpressionDescriptionMetadata.a);
            }
            if (a.k(NextQuarterExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(NextQuarterExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            NextQuarterExpressionDescriptionMetadata.b(a);
            a.ae("NextQuarterExpression", () => new NextQuarterExpressionDescription());
            a.ad("NextQuarterExpression", NextQuarterExpressionDescriptionMetadata.a);
        }
    }
    NextQuarterExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(NextQuarterExpressionDescriptionMetadata, 'NextQuarterExpressionDescriptionMetadata');
    NextQuarterExpressionDescriptionMetadata.a = null;
    return NextQuarterExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NextWeekExpressionDescription = /*@__PURE__*/ (() => {
    class NextWeekExpressionDescription extends OffsettableWeekExpressionDescription {
        get_type() {
            return "NextWeekExpression";
        }
        constructor() {
            super();
        }
    }
    NextWeekExpressionDescription.$t = /*@__PURE__*/ markType(NextWeekExpressionDescription, 'NextWeekExpressionDescription', OffsettableWeekExpressionDescription.$);
    NextWeekExpressionDescription.__marshalByValue3 = true;
    NextWeekExpressionDescription.__marshalByValueAlias3 = "NextWeekExpression";
    return NextWeekExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NextWeekExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class NextWeekExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (NextWeekExpressionDescriptionMetadata.a == null) {
                NextWeekExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NextWeekExpressionDescriptionMetadata.c(NextWeekExpressionDescriptionMetadata.a);
            }
            if (a.k(NextWeekExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(NextWeekExpressionDescriptionMetadata.a);
        }
        static c(a) {
            OffsettableWeekExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            NextWeekExpressionDescriptionMetadata.b(a);
            a.ae("NextWeekExpression", () => new NextWeekExpressionDescription());
            a.ad("NextWeekExpression", NextWeekExpressionDescriptionMetadata.a);
        }
    }
    NextWeekExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(NextWeekExpressionDescriptionMetadata, 'NextWeekExpressionDescriptionMetadata');
    NextWeekExpressionDescriptionMetadata.a = null;
    return NextWeekExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NextYearExpressionDescription = /*@__PURE__*/ (() => {
    class NextYearExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "NextYearExpression";
        }
        constructor() {
            super();
        }
    }
    NextYearExpressionDescription.$t = /*@__PURE__*/ markType(NextYearExpressionDescription, 'NextYearExpressionDescription', WrapperExpressionDescription.$);
    NextYearExpressionDescription.__marshalByValue2 = true;
    NextYearExpressionDescription.__marshalByValueAlias2 = "NextYearExpression";
    return NextYearExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NextYearExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class NextYearExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (NextYearExpressionDescriptionMetadata.a == null) {
                NextYearExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NextYearExpressionDescriptionMetadata.c(NextYearExpressionDescriptionMetadata.a);
            }
            if (a.k(NextYearExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(NextYearExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            NextYearExpressionDescriptionMetadata.b(a);
            a.ae("NextYearExpression", () => new NextYearExpressionDescription());
            a.ad("NextYearExpression", NextYearExpressionDescriptionMetadata.a);
        }
    }
    NextYearExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(NextYearExpressionDescriptionMetadata, 'NextYearExpressionDescriptionMetadata');
    NextYearExpressionDescriptionMetadata.a = null;
    return NextYearExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnClosedEventArgsDescription = /*@__PURE__*/ (() => {
    class OnClosedEventArgsDescription extends Description {
        get_type() {
            return "OnClosedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    OnClosedEventArgsDescription.$t = /*@__PURE__*/ markType(OnClosedEventArgsDescription, 'OnClosedEventArgsDescription', Description.$);
    return OnClosedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnClosedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class OnClosedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (OnClosedEventArgsDescriptionMetadata.a == null) {
                OnClosedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OnClosedEventArgsDescriptionMetadata.c(OnClosedEventArgsDescriptionMetadata.a);
            }
            if (a.k(OnClosedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(OnClosedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            OnClosedEventArgsDescriptionMetadata.b(a);
            a.ae("OnClosedEventArgs", () => new OnClosedEventArgsDescription());
            a.ad("OnClosedEventArgs", OnClosedEventArgsDescriptionMetadata.a);
        }
    }
    OnClosedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(OnClosedEventArgsDescriptionMetadata, 'OnClosedEventArgsDescriptionMetadata');
    OnClosedEventArgsDescriptionMetadata.a = null;
    return OnClosedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnPopupEventArgsDescription = /*@__PURE__*/ (() => {
    class OnPopupEventArgsDescription extends Description {
        get_type() {
            return "OnPopupEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    OnPopupEventArgsDescription.$t = /*@__PURE__*/ markType(OnPopupEventArgsDescription, 'OnPopupEventArgsDescription', Description.$);
    return OnPopupEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnPopupEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class OnPopupEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (OnPopupEventArgsDescriptionMetadata.a == null) {
                OnPopupEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OnPopupEventArgsDescriptionMetadata.c(OnPopupEventArgsDescriptionMetadata.a);
            }
            if (a.k(OnPopupEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(OnPopupEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            OnPopupEventArgsDescriptionMetadata.b(a);
            a.ae("OnPopupEventArgs", () => new OnPopupEventArgsDescription());
            a.ad("OnPopupEventArgs", OnPopupEventArgsDescriptionMetadata.a);
        }
    }
    OnPopupEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(OnPopupEventArgsDescriptionMetadata, 'OnPopupEventArgsDescriptionMetadata');
    OnPopupEventArgsDescriptionMetadata.a = null;
    return OnPopupEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OverlayProxyDescriptionModule = /*@__PURE__*/ (() => {
    class OverlayProxyDescriptionModule extends Base {
        static register(a) {
        }
    }
    OverlayProxyDescriptionModule.$t = /*@__PURE__*/ markType(OverlayProxyDescriptionModule, 'OverlayProxyDescriptionModule');
    return OverlayProxyDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PagedDataSourceDescription = /*@__PURE__*/ (() => {
    class PagedDataSourceDescription extends LocalDataSourceDescription {
        get_type() {
            return "PagedDataSource";
        }
        constructor() {
            super();
        }
    }
    PagedDataSourceDescription.$t = /*@__PURE__*/ markType(PagedDataSourceDescription, 'PagedDataSourceDescription', LocalDataSourceDescription.$);
    return PagedDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PagedDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class PagedDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (PagedDataSourceDescriptionMetadata.a == null) {
                PagedDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PagedDataSourceDescriptionMetadata.c(PagedDataSourceDescriptionMetadata.a);
            }
            if (a.k(PagedDataSourceDescriptionMetadata.a)) {
                return;
            }
            a.ac(PagedDataSourceDescriptionMetadata.a);
        }
        static c(a) {
            LocalDataSourceDescriptionMetadata.c(a);
        }
        static d(a) {
            PagedDataSourceDescriptionMetadata.b(a);
            a.ae("PagedDataSource", () => new PagedDataSourceDescription());
            a.ad("PagedDataSource", PagedDataSourceDescriptionMetadata.a);
        }
    }
    PagedDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(PagedDataSourceDescriptionMetadata, 'PagedDataSourceDescriptionMetadata');
    PagedDataSourceDescriptionMetadata.a = null;
    return PagedDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelClickEventArgsDescription = /*@__PURE__*/ (() => {
    class LabelClickEventArgsDescription extends Description {
        get_type() {
            return "LabelClickEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
        }
        get allowSliceClick() {
            return this.h;
        }
        set allowSliceClick(a) {
            this.h = a;
            this.g("AllowSliceClick");
        }
    }
    LabelClickEventArgsDescription.$t = /*@__PURE__*/ markType(LabelClickEventArgsDescription, 'LabelClickEventArgsDescription', Description.$);
    return LabelClickEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelClickEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class LabelClickEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (LabelClickEventArgsDescriptionMetadata.a == null) {
                LabelClickEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LabelClickEventArgsDescriptionMetadata.c(LabelClickEventArgsDescriptionMetadata.a);
            }
            if (a.k(LabelClickEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(LabelClickEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("AllowSliceClick", "Boolean");
        }
        static d(a) {
            LabelClickEventArgsDescriptionMetadata.b(a);
            a.ae("LabelClickEventArgs", () => new LabelClickEventArgsDescription());
            a.ad("LabelClickEventArgs", LabelClickEventArgsDescriptionMetadata.a);
        }
    }
    LabelClickEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(LabelClickEventArgsDescriptionMetadata, 'LabelClickEventArgsDescriptionMetadata');
    LabelClickEventArgsDescriptionMetadata.a = null;
    return LabelClickEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class SelectedItemChangedEventArgsDescription extends Description {
        get_type() {
            return "SelectedItemChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
        }
        get oldItem() {
            return this.i;
        }
        set oldItem(a) {
            this.i = a;
            this.g("OldItem");
        }
        get newItem() {
            return this.h;
        }
        set newItem(a) {
            this.h = a;
            this.g("NewItem");
        }
    }
    SelectedItemChangedEventArgsDescription.$t = /*@__PURE__*/ markType(SelectedItemChangedEventArgsDescription, 'SelectedItemChangedEventArgsDescription', Description.$);
    return SelectedItemChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SelectedItemChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SelectedItemChangedEventArgsDescriptionMetadata.a == null) {
                SelectedItemChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SelectedItemChangedEventArgsDescriptionMetadata.c(SelectedItemChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(SelectedItemChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(SelectedItemChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("OldItem", "Unknown");
            a.item("NewItem", "Unknown");
        }
        static d(a) {
            SelectedItemChangedEventArgsDescriptionMetadata.b(a);
            a.ae("SelectedItemChangedEventArgs", () => new SelectedItemChangedEventArgsDescription());
            a.ad("SelectedItemChangedEventArgs", SelectedItemChangedEventArgsDescriptionMetadata.a);
        }
    }
    SelectedItemChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SelectedItemChangedEventArgsDescriptionMetadata, 'SelectedItemChangedEventArgsDescriptionMetadata');
    SelectedItemChangedEventArgsDescriptionMetadata.a = null;
    return SelectedItemChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemChangingEventArgsDescription = /*@__PURE__*/ (() => {
    class SelectedItemChangingEventArgsDescription extends SelectedItemChangedEventArgsDescription {
        get_type() {
            return "SelectedItemChangingEventArgs";
        }
        constructor() {
            super();
            this.m = false;
        }
        get cancel() {
            return this.m;
        }
        set cancel(a) {
            this.m = a;
            this.g("Cancel");
        }
    }
    SelectedItemChangingEventArgsDescription.$t = /*@__PURE__*/ markType(SelectedItemChangingEventArgsDescription, 'SelectedItemChangingEventArgsDescription', SelectedItemChangedEventArgsDescription.$);
    return SelectedItemChangingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemChangingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SelectedItemChangingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SelectedItemChangingEventArgsDescriptionMetadata.a == null) {
                SelectedItemChangingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SelectedItemChangingEventArgsDescriptionMetadata.c(SelectedItemChangingEventArgsDescriptionMetadata.a);
            }
            if (a.k(SelectedItemChangingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(SelectedItemChangingEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            SelectedItemChangedEventArgsDescriptionMetadata.c(a);
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            SelectedItemChangingEventArgsDescriptionMetadata.b(a);
            a.ae("SelectedItemChangingEventArgs", () => new SelectedItemChangingEventArgsDescription());
            a.ad("SelectedItemChangingEventArgs", SelectedItemChangingEventArgsDescriptionMetadata.a);
        }
    }
    SelectedItemChangingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SelectedItemChangingEventArgsDescriptionMetadata, 'SelectedItemChangingEventArgsDescriptionMetadata');
    SelectedItemChangingEventArgsDescriptionMetadata.a = null;
    return SelectedItemChangingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class SelectedItemsChangedEventArgsDescription extends Description {
        get_type() {
            return "SelectedItemsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.i = null;
            this.h = null;
        }
        get oldItems() {
            return this.j;
        }
        set oldItems(a) {
            this.j = a;
            this.g("OldItems");
        }
        get newItems() {
            return this.i;
        }
        set newItems(a) {
            this.i = a;
            this.g("NewItems");
        }
        get currentItems() {
            return this.h;
        }
        set currentItems(a) {
            this.h = a;
            this.g("CurrentItems");
        }
    }
    SelectedItemsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(SelectedItemsChangedEventArgsDescription, 'SelectedItemsChangedEventArgsDescription', Description.$);
    return SelectedItemsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SelectedItemsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SelectedItemsChangedEventArgsDescriptionMetadata.a == null) {
                SelectedItemsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SelectedItemsChangedEventArgsDescriptionMetadata.c(SelectedItemsChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(SelectedItemsChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(SelectedItemsChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("OldItems", "Collection:object:ObjectCollection:Object");
            a.item("NewItems", "Collection:object:ObjectCollection:Object");
            a.item("CurrentItems", "Collection:object:ObjectCollection:Object");
        }
        static d(a) {
            SelectedItemsChangedEventArgsDescriptionMetadata.b(a);
            a.ae("SelectedItemsChangedEventArgs", () => new SelectedItemsChangedEventArgsDescription());
            a.ad("SelectedItemsChangedEventArgs", SelectedItemsChangedEventArgsDescriptionMetadata.a);
        }
    }
    SelectedItemsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SelectedItemsChangedEventArgsDescriptionMetadata, 'SelectedItemsChangedEventArgsDescriptionMetadata');
    SelectedItemsChangedEventArgsDescriptionMetadata.a = null;
    return SelectedItemsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemsChangingEventArgsDescription = /*@__PURE__*/ (() => {
    class SelectedItemsChangingEventArgsDescription extends SelectedItemsChangedEventArgsDescription {
        get_type() {
            return "SelectedItemsChangingEventArgs";
        }
        constructor() {
            super();
            this.o = false;
        }
        get cancel() {
            return this.o;
        }
        set cancel(a) {
            this.o = a;
            this.g("Cancel");
        }
    }
    SelectedItemsChangingEventArgsDescription.$t = /*@__PURE__*/ markType(SelectedItemsChangingEventArgsDescription, 'SelectedItemsChangingEventArgsDescription', SelectedItemsChangedEventArgsDescription.$);
    return SelectedItemsChangingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemsChangingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SelectedItemsChangingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SelectedItemsChangingEventArgsDescriptionMetadata.a == null) {
                SelectedItemsChangingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SelectedItemsChangingEventArgsDescriptionMetadata.c(SelectedItemsChangingEventArgsDescriptionMetadata.a);
            }
            if (a.k(SelectedItemsChangingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(SelectedItemsChangingEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            SelectedItemsChangedEventArgsDescriptionMetadata.c(a);
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            SelectedItemsChangingEventArgsDescriptionMetadata.b(a);
            a.ae("SelectedItemsChangingEventArgs", () => new SelectedItemsChangingEventArgsDescription());
            a.ad("SelectedItemsChangingEventArgs", SelectedItemsChangingEventArgsDescriptionMetadata.a);
        }
    }
    SelectedItemsChangingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SelectedItemsChangingEventArgsDescriptionMetadata, 'SelectedItemsChangingEventArgsDescriptionMetadata');
    SelectedItemsChangingEventArgsDescriptionMetadata.a = null;
    return SelectedItemsChangingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SliceEventArgsDescription = /*@__PURE__*/ (() => {
    class SliceEventArgsDescription extends Description {
        get_type() {
            return "SliceEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = false;
            this.j = false;
            this.h = null;
            this.n = null;
        }
        get isSelected() {
            return this.k;
        }
        set isSelected(a) {
            this.k = a;
            this.g("IsSelected");
        }
        get isExploded() {
            return this.j;
        }
        set isExploded(a) {
            this.j = a;
            this.g("IsExploded");
        }
        get position() {
            return this.h;
        }
        set position(a) {
            this.h = a;
            this.g("Position");
        }
        get originalEventRef() {
            return this.n;
        }
        set originalEventRef(a) {
            this.n = a;
            this.g("OriginalEventRef");
        }
    }
    SliceEventArgsDescription.$t = /*@__PURE__*/ markType(SliceEventArgsDescription, 'SliceEventArgsDescription', Description.$);
    return SliceEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SliceEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SliceEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SliceEventArgsDescriptionMetadata.a == null) {
                SliceEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SliceEventArgsDescriptionMetadata.c(SliceEventArgsDescriptionMetadata.a);
            }
            if (a.k(SliceEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(SliceEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("IsSelected", "Boolean");
            a.item("IsExploded", "Boolean");
            a.item("Position", "Point");
            a.item("OriginalEventRef", "(w:OriginalEvent,wf:OriginalEvent)DataRef");
        }
        static d(a) {
            SliceEventArgsDescriptionMetadata.b(a);
            a.ae("SliceEventArgs", () => new SliceEventArgsDescription());
            a.ad("SliceEventArgs", SliceEventArgsDescriptionMetadata.a);
        }
    }
    SliceEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SliceEventArgsDescriptionMetadata, 'SliceEventArgsDescriptionMetadata');
    SliceEventArgsDescriptionMetadata.a = null;
    return SliceEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieChartBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class PieChartBaseDescriptionMetadata extends Base {
        static e(a) {
            a.item("TooltipTemplateRef", "(w:ToolTip)DataRef:String");
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource)DataRef:String");
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:TextStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:TextStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontStyle/FontStyleTransform,wf:FontStyle/FontStyleTransform,web:TextStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontStyle/FontWeightTransform,wf:FontStyle/FontWeightTransform,web:TextStyle/FontWeightTransform)String");
        }
        static b(a) {
            if (PieChartBaseDescriptionMetadata.a == null) {
                PieChartBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PieChartBaseDescriptionMetadata.c(PieChartBaseDescriptionMetadata.a);
            }
            if (a.k(PieChartBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(PieChartBaseDescriptionMetadata.a);
            LabelClickEventArgsDescriptionMetadata.d(a);
            SelectedItemChangingEventArgsDescriptionMetadata.d(a);
            SelectedItemsChangingEventArgsDescriptionMetadata.d(a);
            SelectedItemChangedEventArgsDescriptionMetadata.d(a);
            SelectedItemsChangedEventArgsDescriptionMetadata.d(a);
            SliceClickEventArgsDescriptionMetadata.d(a);
            SliceEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)DataRef::object");
            a.item("InnerExtent", "Number:double");
            a.item("ValueMemberPath", "String");
            a.item("LabelMemberPath", "String");
            a.item("LegendLabelMemberPath", "String");
            a.item("LabelsPosition", "ExportedType:string:LabelsPosition");
            a.item("LabelsPosition@names", "None;Center;InsideEnd;OutsideEnd;BestFit");
            a.item("LabelOuterColor", "Brush");
            a.item("LabelInnerColor", "Brush");
            a.item("ActualLabelOuterColor", "Brush");
            a.item("ActualLabelInnerColor", "Brush");
            a.item("LeaderLineVisibility", "ExportedType:string:Visibility");
            a.item("LeaderLineVisibility@names", "Visible;Collapsed");
            a.item("LeaderLineType", "ExportedType:string:LeaderLineType");
            a.item("LeaderLineType@names", "Straight;Arc;Spline");
            a.item("LeaderLineMargin", "Number:double");
            a.item("OthersCategoryThreshold", "Number:double");
            a.item("OthersCategoryType", "ExportedType:string:OthersCategoryType");
            a.item("OthersCategoryType@names", "Number;Percent");
            a.item("OthersCategoryText", "String");
            a.item("ExplodedRadius", "Number:double");
            a.item("RadiusFactor", "Number:double");
            a.item("AllowSliceSelection", "Boolean");
            a.item("AllowSliceExplosion", "Boolean");
            a.item("ExplodedSlices", "Collection:int:IndexCollection:Int32");
            a.item("LegendRef", "(w:Legend,wf:Legend)DataRef::object");
            a.item("LabelExtent", "Number:double");
            a.item("StartAngle", "Number:double");
            a.item("SweepDirection", "ExportedType:string:SweepDirection");
            a.item("SweepDirection@names", "Counterclockwise;Clockwise");
            a.item("OthersCategoryFill", "(w:OthersCategoryStyle.Fill,wf:OthersCategoryFill)String");
            a.item("OthersCategoryStroke", "(w:OthersCategoryStyle.Stroke,wf:OthersCategoryStroke)String");
            a.item("OthersCategoryStrokeThickness", "(w:OthersCategoryStyle.StrokeThickness,wf:OthersCategoryStrokeThickness)Number:double");
            a.item("OthersCategoryOpacity", "(w:OthersCategoryStyle.Opacity,wf:OthersCategoryOpacity)Number:double");
            a.item("SelectedSliceFill", "(w:SelectedStyle.Fill,wf:SelectedSliceFill)String");
            a.item("SelectedSliceStroke", "(w:SelectedStyle.Stroke,wf:SelectedSliceStroke)String");
            a.item("SelectedSliceStrokeThickness", "(w:SelectedStyle.StrokeThickness,wf:SelectedSliceStrokeThickness)Number:double");
            a.item("SelectedSliceOpacity", "(w:SelectedStyle.Opacity,wf:SelectedSliceOpacity)Number:double");
            a.item("Brushes", "BrushCollection:string");
            a.item("ActualBrushes", "BrushCollection:string");
            a.item("Outlines", "BrushCollection:string");
            a.item("ActualOutlines", "BrushCollection:string");
            a.item("LabelFormat", "String");
            a.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("OthersLabelFormat", "String");
            a.item("OthersLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("OthersLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("LegendLabelFormat", "String");
            a.item("LegendLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LegendLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("LegendOthersLabelFormat", "String");
            a.item("LegendOthersLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LegendOthersLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("LegendItemTemplateRef", "(w:LegendItemTemplate,wf:LegendItemTemplate)DataRef::object");
            a.item("LegendItemBadgeTemplateRef", "(w:LegendItemBadgeTemplate,wf:LegendItemBadgeTemplate)DataRef::object");
            a.item("IsDragInteractionEnabled", "Boolean");
            a.item("IsSurfaceInteractionDisabled", "Boolean");
            a.item("ShouldDisplayMockData", "Boolean");
            a.item("ShouldUseSkeletonStyleForMockData", "Boolean");
            a.item("LegendEmptyValuesMode", "ExportedType:string:LegendEmptyValuesMode");
            a.item("LegendEmptyValuesMode@names", "AlwaysHidden;AlwaysVisible;ShowWhenNoOthersCategory");
            a.item("FormatLabelRef", "(w:FormatLabel,wf:FormatLabel)MethodRef");
            a.item("FormatLegendLabelRef", "(w:FormatLegendLabel,wf:FormatLegendLabel)MethodRef");
            a.item("PixelScalingRatio", "Number:double");
            a.item("ActualPixelScalingRatio", "Number:double");
            a.item("SelectionMode", "ExportedType:string:SliceSelectionMode");
            a.item("SelectionMode@names", "Manual;Single;Multiple");
            a.item("SelectedItem", "Unknown");
            a.item("SelectedItems", "Collection:object:ObjectCollection:Object");
            a.item("TextStyle", "String");
            a.item("LabelClickRef", "EventRef::labelClick");
            a.item("SelectedItemChangingRef", "EventRef::selectedItemChanging");
            a.item("SelectedItemsChangingRef", "EventRef::selectedItemsChanging");
            a.item("SelectedItemChangedRef", "EventRef::selectedItemChanged");
            a.item("SelectedItemsChangedRef", "EventRef::selectedItemsChanged");
            a.item("SliceClickRef", "EventRef::sliceClick");
            a.item("SliceEnterRef", "EventRef::sliceEnter");
            a.item("SliceLeaveRef", "EventRef::sliceLeave");
            a.item("SliceHoverRef", "EventRef::sliceHover");
            PieChartBaseDescriptionMetadata.e(a);
        }
        static d(a) {
            PieChartBaseDescriptionMetadata.b(a);
            a.ad("PieChartBase", PieChartBaseDescriptionMetadata.a);
        }
    }
    PieChartBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(PieChartBaseDescriptionMetadata, 'PieChartBaseDescriptionMetadata');
    PieChartBaseDescriptionMetadata.a = null;
    return PieChartBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieChartBaseDescription = /*@__PURE__*/ (() => {
    class PieChartBaseDescription extends Description {
        get tooltipTemplateRef() {
            return this.cm;
        }
        set tooltipTemplateRef(a) {
            this.cm = a;
            this.g("TooltipTemplateRef");
        }
        get fontFamily() {
            return this.bk;
        }
        set fontFamily(a) {
            this.bk = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.ap;
        }
        set fontSize(a) {
            this.ap = a;
            this.g("FontSize");
        }
        get fontWeight() {
            return this.bm;
        }
        set fontWeight(a) {
            this.bm = a;
            this.g("FontWeight");
        }
        get fontStyle() {
            return this.bl;
        }
        set fontStyle(a) {
            this.bl = a;
            this.g("FontStyle");
        }
        get_type() {
            return "PieChartBase";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.cm = null;
            this.bk = null;
            this.ap = 0;
            this.bm = null;
            this.bl = null;
            this.bj = null;
            this.aq = 0;
            this.cn = null;
            this.bs = null;
            this.b1 = null;
            this.bu = null;
            this.bt = null;
            this.br = null;
            this.bi = null;
            this.bh = null;
            this.bw = null;
            this.bv = null;
            this.as = 0;
            this.av = 0;
            this.b7 = null;
            this.b6 = null;
            this.ao = 0;
            this.ax = 0;
            this.ac = false;
            this.ab = false;
            this.k = null;
            this.b3 = null;
            this.ar = 0;
            this.a0 = 0;
            this.ck = null;
            this.b4 = null;
            this.b5 = null;
            this.au = 0;
            this.at = 0;
            this.cd = null;
            this.ce = null;
            this.az = 0;
            this.ay = 0;
            this.j = null;
            this.h = null;
            this.p = null;
            this.i = null;
            this.bq = null;
            this.l = null;
            this.b8 = null;
            this.o = null;
            this.b0 = null;
            this.m = null;
            this.b2 = null;
            this.n = null;
            this.bz = null;
            this.by = null;
            this.ad = false;
            this.ae = false;
            this.af = false;
            this.ag = false;
            this.bx = null;
            this.bn = null;
            this.bo = null;
            this.aw = 0;
            this.an = 0;
            this.cf = null;
            this.bf = null;
            this.q = null;
            this.cl = null;
            this.bp = null;
            this.ca = null;
            this.cc = null;
            this.b9 = null;
            this.cb = null;
            this.cg = null;
            this.ch = null;
            this.cj = null;
            this.ci = null;
        }
        get dataSourceRef() {
            return this.bj;
        }
        set dataSourceRef(a) {
            this.bj = a;
            this.g("DataSourceRef");
        }
        get innerExtent() {
            return this.aq;
        }
        set innerExtent(a) {
            this.aq = a;
            this.g("InnerExtent");
        }
        get valueMemberPath() {
            return this.cn;
        }
        set valueMemberPath(a) {
            this.cn = a;
            this.g("ValueMemberPath");
        }
        get labelMemberPath() {
            return this.bs;
        }
        set labelMemberPath(a) {
            this.bs = a;
            this.g("LabelMemberPath");
        }
        get legendLabelMemberPath() {
            return this.b1;
        }
        set legendLabelMemberPath(a) {
            this.b1 = a;
            this.g("LegendLabelMemberPath");
        }
        get labelsPosition() {
            return this.bu;
        }
        set labelsPosition(a) {
            this.bu = a;
            this.g("LabelsPosition");
        }
        get labelOuterColor() {
            return this.bt;
        }
        set labelOuterColor(a) {
            this.bt = a;
            this.g("LabelOuterColor");
        }
        get labelInnerColor() {
            return this.br;
        }
        set labelInnerColor(a) {
            this.br = a;
            this.g("LabelInnerColor");
        }
        get actualLabelOuterColor() {
            return this.bi;
        }
        set actualLabelOuterColor(a) {
            this.bi = a;
            this.g("ActualLabelOuterColor");
        }
        get actualLabelInnerColor() {
            return this.bh;
        }
        set actualLabelInnerColor(a) {
            this.bh = a;
            this.g("ActualLabelInnerColor");
        }
        get leaderLineVisibility() {
            return this.bw;
        }
        set leaderLineVisibility(a) {
            this.bw = a;
            this.g("LeaderLineVisibility");
        }
        get leaderLineType() {
            return this.bv;
        }
        set leaderLineType(a) {
            this.bv = a;
            this.g("LeaderLineType");
        }
        get leaderLineMargin() {
            return this.as;
        }
        set leaderLineMargin(a) {
            this.as = a;
            this.g("LeaderLineMargin");
        }
        get othersCategoryThreshold() {
            return this.av;
        }
        set othersCategoryThreshold(a) {
            this.av = a;
            this.g("OthersCategoryThreshold");
        }
        get othersCategoryType() {
            return this.b7;
        }
        set othersCategoryType(a) {
            this.b7 = a;
            this.g("OthersCategoryType");
        }
        get othersCategoryText() {
            return this.b6;
        }
        set othersCategoryText(a) {
            this.b6 = a;
            this.g("OthersCategoryText");
        }
        get explodedRadius() {
            return this.ao;
        }
        set explodedRadius(a) {
            this.ao = a;
            this.g("ExplodedRadius");
        }
        get radiusFactor() {
            return this.ax;
        }
        set radiusFactor(a) {
            this.ax = a;
            this.g("RadiusFactor");
        }
        get allowSliceSelection() {
            return this.ac;
        }
        set allowSliceSelection(a) {
            this.ac = a;
            this.g("AllowSliceSelection");
        }
        get allowSliceExplosion() {
            return this.ab;
        }
        set allowSliceExplosion(a) {
            this.ab = a;
            this.g("AllowSliceExplosion");
        }
        get explodedSlices() {
            return this.k;
        }
        set explodedSlices(a) {
            this.k = a;
            this.g("ExplodedSlices");
        }
        get legendRef() {
            return this.b3;
        }
        set legendRef(a) {
            this.b3 = a;
            this.g("LegendRef");
        }
        get labelExtent() {
            return this.ar;
        }
        set labelExtent(a) {
            this.ar = a;
            this.g("LabelExtent");
        }
        get startAngle() {
            return this.a0;
        }
        set startAngle(a) {
            this.a0 = a;
            this.g("StartAngle");
        }
        get sweepDirection() {
            return this.ck;
        }
        set sweepDirection(a) {
            this.ck = a;
            this.g("SweepDirection");
        }
        get othersCategoryFill() {
            return this.b4;
        }
        set othersCategoryFill(a) {
            this.b4 = a;
            this.g("OthersCategoryFill");
        }
        get othersCategoryStroke() {
            return this.b5;
        }
        set othersCategoryStroke(a) {
            this.b5 = a;
            this.g("OthersCategoryStroke");
        }
        get othersCategoryStrokeThickness() {
            return this.au;
        }
        set othersCategoryStrokeThickness(a) {
            this.au = a;
            this.g("OthersCategoryStrokeThickness");
        }
        get othersCategoryOpacity() {
            return this.at;
        }
        set othersCategoryOpacity(a) {
            this.at = a;
            this.g("OthersCategoryOpacity");
        }
        get selectedSliceFill() {
            return this.cd;
        }
        set selectedSliceFill(a) {
            this.cd = a;
            this.g("SelectedSliceFill");
        }
        get selectedSliceStroke() {
            return this.ce;
        }
        set selectedSliceStroke(a) {
            this.ce = a;
            this.g("SelectedSliceStroke");
        }
        get selectedSliceStrokeThickness() {
            return this.az;
        }
        set selectedSliceStrokeThickness(a) {
            this.az = a;
            this.g("SelectedSliceStrokeThickness");
        }
        get selectedSliceOpacity() {
            return this.ay;
        }
        set selectedSliceOpacity(a) {
            this.ay = a;
            this.g("SelectedSliceOpacity");
        }
        get brushes() {
            return this.j;
        }
        set brushes(a) {
            this.j = a;
            this.g("Brushes");
        }
        get actualBrushes() {
            return this.h;
        }
        set actualBrushes(a) {
            this.h = a;
            this.g("ActualBrushes");
        }
        get outlines() {
            return this.p;
        }
        set outlines(a) {
            this.p = a;
            this.g("Outlines");
        }
        get actualOutlines() {
            return this.i;
        }
        set actualOutlines(a) {
            this.i = a;
            this.g("ActualOutlines");
        }
        get labelFormat() {
            return this.bq;
        }
        set labelFormat(a) {
            this.bq = a;
            this.g("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.l;
        }
        set labelFormatSpecifiers(a) {
            this.l = a;
            this.g("LabelFormatSpecifiers");
        }
        get othersLabelFormat() {
            return this.b8;
        }
        set othersLabelFormat(a) {
            this.b8 = a;
            this.g("OthersLabelFormat");
        }
        get othersLabelFormatSpecifiers() {
            return this.o;
        }
        set othersLabelFormatSpecifiers(a) {
            this.o = a;
            this.g("OthersLabelFormatSpecifiers");
        }
        get legendLabelFormat() {
            return this.b0;
        }
        set legendLabelFormat(a) {
            this.b0 = a;
            this.g("LegendLabelFormat");
        }
        get legendLabelFormatSpecifiers() {
            return this.m;
        }
        set legendLabelFormatSpecifiers(a) {
            this.m = a;
            this.g("LegendLabelFormatSpecifiers");
        }
        get legendOthersLabelFormat() {
            return this.b2;
        }
        set legendOthersLabelFormat(a) {
            this.b2 = a;
            this.g("LegendOthersLabelFormat");
        }
        get legendOthersLabelFormatSpecifiers() {
            return this.n;
        }
        set legendOthersLabelFormatSpecifiers(a) {
            this.n = a;
            this.g("LegendOthersLabelFormatSpecifiers");
        }
        get legendItemTemplateRef() {
            return this.bz;
        }
        set legendItemTemplateRef(a) {
            this.bz = a;
            this.g("LegendItemTemplateRef");
        }
        get legendItemBadgeTemplateRef() {
            return this.by;
        }
        set legendItemBadgeTemplateRef(a) {
            this.by = a;
            this.g("LegendItemBadgeTemplateRef");
        }
        get isDragInteractionEnabled() {
            return this.ad;
        }
        set isDragInteractionEnabled(a) {
            this.ad = a;
            this.g("IsDragInteractionEnabled");
        }
        get isSurfaceInteractionDisabled() {
            return this.ae;
        }
        set isSurfaceInteractionDisabled(a) {
            this.ae = a;
            this.g("IsSurfaceInteractionDisabled");
        }
        get shouldDisplayMockData() {
            return this.af;
        }
        set shouldDisplayMockData(a) {
            this.af = a;
            this.g("ShouldDisplayMockData");
        }
        get shouldUseSkeletonStyleForMockData() {
            return this.ag;
        }
        set shouldUseSkeletonStyleForMockData(a) {
            this.ag = a;
            this.g("ShouldUseSkeletonStyleForMockData");
        }
        get legendEmptyValuesMode() {
            return this.bx;
        }
        set legendEmptyValuesMode(a) {
            this.bx = a;
            this.g("LegendEmptyValuesMode");
        }
        get formatLabelRef() {
            return this.bn;
        }
        set formatLabelRef(a) {
            this.bn = a;
            this.g("FormatLabelRef");
        }
        get formatLegendLabelRef() {
            return this.bo;
        }
        set formatLegendLabelRef(a) {
            this.bo = a;
            this.g("FormatLegendLabelRef");
        }
        get pixelScalingRatio() {
            return this.aw;
        }
        set pixelScalingRatio(a) {
            this.aw = a;
            this.g("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.an;
        }
        set actualPixelScalingRatio(a) {
            this.an = a;
            this.g("ActualPixelScalingRatio");
        }
        get selectionMode() {
            return this.cf;
        }
        set selectionMode(a) {
            this.cf = a;
            this.g("SelectionMode");
        }
        get selectedItem() {
            return this.bf;
        }
        set selectedItem(a) {
            this.bf = a;
            this.g("SelectedItem");
        }
        get selectedItems() {
            return this.q;
        }
        set selectedItems(a) {
            this.q = a;
            this.g("SelectedItems");
        }
        get textStyle() {
            return this.cl;
        }
        set textStyle(a) {
            this.cl = a;
            this.g("TextStyle");
        }
        get labelClickRef() {
            return this.bp;
        }
        set labelClickRef(a) {
            this.bp = a;
            this.g("LabelClickRef");
        }
        get selectedItemChangingRef() {
            return this.ca;
        }
        set selectedItemChangingRef(a) {
            this.ca = a;
            this.g("SelectedItemChangingRef");
        }
        get selectedItemsChangingRef() {
            return this.cc;
        }
        set selectedItemsChangingRef(a) {
            this.cc = a;
            this.g("SelectedItemsChangingRef");
        }
        get selectedItemChangedRef() {
            return this.b9;
        }
        set selectedItemChangedRef(a) {
            this.b9 = a;
            this.g("SelectedItemChangedRef");
        }
        get selectedItemsChangedRef() {
            return this.cb;
        }
        set selectedItemsChangedRef(a) {
            this.cb = a;
            this.g("SelectedItemsChangedRef");
        }
        get sliceClickRef() {
            return this.cg;
        }
        set sliceClickRef(a) {
            this.cg = a;
            this.g("SliceClickRef");
        }
        get sliceEnterRef() {
            return this.ch;
        }
        set sliceEnterRef(a) {
            this.ch = a;
            this.g("SliceEnterRef");
        }
        get sliceLeaveRef() {
            return this.cj;
        }
        set sliceLeaveRef(a) {
            this.cj = a;
            this.g("SliceLeaveRef");
        }
        get sliceHoverRef() {
            return this.ci;
        }
        set sliceHoverRef(a) {
            this.ci = a;
            this.g("SliceHoverRef");
        }
    }
    PieChartBaseDescription.$t = /*@__PURE__*/ markType(PieChartBaseDescription, 'PieChartBaseDescription', Description.$);
    return PieChartBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieChartDescription = /*@__PURE__*/ (() => {
    class PieChartDescription extends PieChartBaseDescription {
        get width() {
            return this.dz;
        }
        set width(a) {
            this.dz = a;
            this.g("Width");
        }
        get height() {
            return this.dy;
        }
        set height(a) {
            this.dy = a;
            this.g("Height");
        }
        get background() {
            return this.dx;
        }
        set background(a) {
            this.dx = a;
            this.g("Background");
        }
        get_type() {
            return "PieChart";
        }
        constructor() {
            super();
            this.dz = null;
            this.dy = null;
            this.dx = null;
        }
    }
    PieChartDescription.$t = /*@__PURE__*/ markType(PieChartDescription, 'PieChartDescription', PieChartBaseDescription.$);
    return PieChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class PieChartDescriptionMetadata extends Base {
        static e(a) {
            a.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamPieChart");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (PieChartDescriptionMetadata.a == null) {
                PieChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PieChartDescriptionMetadata.c(PieChartDescriptionMetadata.a);
            }
            if (a.k(PieChartDescriptionMetadata.a)) {
                return;
            }
            a.ac(PieChartDescriptionMetadata.a);
        }
        static c(a) {
            PieChartBaseDescriptionMetadata.c(a);
            PieChartDescriptionMetadata.e(a);
        }
        static d(a) {
            PieChartDescriptionMetadata.b(a);
            a.ae("PieChart", () => new PieChartDescription());
            a.ad("PieChart", PieChartDescriptionMetadata.a);
        }
    }
    PieChartDescriptionMetadata.$t = /*@__PURE__*/ markType(PieChartDescriptionMetadata, 'PieChartDescriptionMetadata');
    PieChartDescriptionMetadata.a = null;
    return PieChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieChartCoreDescriptionModule = /*@__PURE__*/ (() => {
    class PieChartCoreDescriptionModule extends Base {
        static register(a) {
            NumberFormatSpecifierDescriptionModule.register(a);
            DateTimeFormatSpecifierDescriptionModule.register(a);
            PieChartDescriptionMetadata.d(a);
        }
    }
    PieChartCoreDescriptionModule.$t = /*@__PURE__*/ markType(PieChartCoreDescriptionModule, 'PieChartCoreDescriptionModule');
    return PieChartCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieChartDescriptionModule = /*@__PURE__*/ (() => {
    class PieChartDescriptionModule extends Base {
        static register(a) {
            PieChartCoreDescriptionModule.register(a);
            DataChartInteractivityDescriptionModule.register(a);
        }
    }
    PieChartDescriptionModule.$t = /*@__PURE__*/ markType(PieChartDescriptionModule, 'PieChartDescriptionModule');
    return PieChartDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PinnedAreaSeparatorDescriptionModule = /*@__PURE__*/ (() => {
    class PinnedAreaSeparatorDescriptionModule extends Base {
        static register(a) {
            PinnedAreaSeparatorDescriptionMetadata.d(a);
        }
    }
    PinnedAreaSeparatorDescriptionModule.$t = /*@__PURE__*/ markType(PinnedAreaSeparatorDescriptionModule, 'PinnedAreaSeparatorDescriptionModule');
    return PinnedAreaSeparatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PopupDescription = /*@__PURE__*/ (() => {
    class PopupDescription extends Description {
        get_type() {
            return "Popup";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = false;
            this.ae = 0;
            this.h = false;
            this.am = null;
            this.af = 0;
            this.ad = 0;
            this.al = null;
            this.ak = null;
            this.aj = null;
            this.an = null;
            this.z = 0;
            this.m = false;
            this.i = false;
            this.n = false;
            this.ar = null;
            this.aq = null;
            this.aa = 0;
            this.o = false;
            this.j = false;
            this.k = false;
            this.p = false;
            this.ao = null;
            this.ap = null;
            this.as = null;
            this.at = null;
        }
        get isFocusable() {
            return this.l;
        }
        set isFocusable(a) {
            this.l = a;
            this.g("IsFocusable");
        }
        get animationDuration() {
            return this.ae;
        }
        set animationDuration(a) {
            this.ae = a;
            this.g("AnimationDuration");
        }
        get animationEnabled() {
            return this.h;
        }
        set animationEnabled(a) {
            this.h = a;
            this.g("AnimationEnabled");
        }
        get animationType() {
            return this.am;
        }
        set animationType(a) {
            this.am = a;
            this.g("AnimationType");
        }
        get elevation() {
            return this.af;
        }
        set elevation(a) {
            this.af = a;
            this.g("Elevation");
        }
        get actualElevation() {
            return this.ad;
        }
        set actualElevation(a) {
            this.ad = a;
            this.g("ActualElevation");
        }
        get actualUmbraShadowColor() {
            return this.al;
        }
        set actualUmbraShadowColor(a) {
            this.al = a;
            this.g("ActualUmbraShadowColor");
        }
        get actualPenumbraShadowColor() {
            return this.ak;
        }
        set actualPenumbraShadowColor(a) {
            this.ak = a;
            this.g("ActualPenumbraShadowColor");
        }
        get actualAmbientShadowColor() {
            return this.aj;
        }
        set actualAmbientShadowColor(a) {
            this.aj = a;
            this.g("ActualAmbientShadowColor");
        }
        get background() {
            return this.an;
        }
        set background(a) {
            this.an = a;
            this.g("Background");
        }
        get cornerRadius() {
            return this.z;
        }
        set cornerRadius(a) {
            this.z = a;
            this.g("CornerRadius");
        }
        get isHitTestVisible() {
            return this.m;
        }
        set isHitTestVisible(a) {
            this.m = a;
            this.g("IsHitTestVisible");
        }
        get disableHitTestDuringAnimation() {
            return this.i;
        }
        set disableHitTestDuringAnimation(a) {
            this.i = a;
            this.g("DisableHitTestDuringAnimation");
        }
        get isPointerEnabled() {
            return this.n;
        }
        set isPointerEnabled(a) {
            this.n = a;
            this.g("IsPointerEnabled");
        }
        get pointerPosition() {
            return this.ar;
        }
        set pointerPosition(a) {
            this.ar = a;
            this.g("PointerPosition");
        }
        get pointerBackground() {
            return this.aq;
        }
        set pointerBackground(a) {
            this.aq = a;
            this.g("PointerBackground");
        }
        get pointerSize() {
            return this.aa;
        }
        set pointerSize(a) {
            this.aa = a;
            this.g("PointerSize");
        }
        get isShowing() {
            return this.o;
        }
        set isShowing(a) {
            this.o = a;
            this.g("IsShowing");
        }
        get isClosing() {
            return this.j;
        }
        set isClosing(a) {
            this.j = a;
            this.g("IsClosing");
        }
        get isFixed() {
            return this.k;
        }
        set isFixed(a) {
            this.k = a;
            this.g("IsFixed");
        }
        get useTopLayer() {
            return this.p;
        }
        set useTopLayer(a) {
            this.p = a;
            this.g("UseTopLayer");
        }
        get onClosedRef() {
            return this.ao;
        }
        set onClosedRef(a) {
            this.ao = a;
            this.g("OnClosedRef");
        }
        get onPopupRef() {
            return this.ap;
        }
        set onPopupRef(a) {
            this.ap = a;
            this.g("OnPopupRef");
        }
        get popupGotFocusRef() {
            return this.as;
        }
        set popupGotFocusRef(a) {
            this.as = a;
            this.g("PopupGotFocusRef");
        }
        get popupLostFocusRef() {
            return this.at;
        }
        set popupLostFocusRef(a) {
            this.at = a;
            this.g("PopupLostFocusRef");
        }
    }
    PopupDescription.$t = /*@__PURE__*/ markType(PopupDescription, 'PopupDescription', Description.$);
    return PopupDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PopupDescriptionMetadata = /*@__PURE__*/ (() => {
    class PopupDescriptionMetadata extends Base {
        static b(a) {
            if (PopupDescriptionMetadata.a == null) {
                PopupDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PopupDescriptionMetadata.c(PopupDescriptionMetadata.a);
            }
            if (a.k(PopupDescriptionMetadata.a)) {
                return;
            }
            a.ac(PopupDescriptionMetadata.a);
            OnClosedEventArgsDescriptionMetadata.d(a);
            OnPopupEventArgsDescriptionMetadata.d(a);
            FocusEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("IsFocusable", "Boolean");
            a.item("AnimationDuration", "Number:int");
            a.item("AnimationEnabled", "Boolean");
            a.item("AnimationType", "ExportedType:string:PopupAnimationType");
            a.item("AnimationType@names", "GrowShrink;FadeInOutSlide");
            a.item("Elevation", "Number:int");
            a.item("ActualElevation", "Number:int");
            a.item("ActualUmbraShadowColor", "Brush");
            a.item("ActualPenumbraShadowColor", "Brush");
            a.item("ActualAmbientShadowColor", "Brush");
            a.item("Background", "Brush");
            a.item("CornerRadius", "Number:double");
            a.item("IsHitTestVisible", "Boolean");
            a.item("DisableHitTestDuringAnimation", "Boolean");
            a.item("IsPointerEnabled", "Boolean");
            a.item("PointerPosition", "ExportedType:string:PopupPointerPosition");
            a.item("PointerPosition@names", "Auto;Top;Bottom;Left;Right");
            a.item("PointerBackground", "Brush");
            a.item("PointerSize", "Number:double");
            a.item("IsShowing", "Boolean");
            a.item("IsClosing", "Boolean");
            a.item("IsFixed", "Boolean");
            a.item("UseTopLayer", "Boolean");
            a.item("OnClosedRef", "EventRef::onClosed");
            a.item("OnPopupRef", "EventRef::onPopup");
            a.item("PopupGotFocusRef", "EventRef::popupGotFocus");
            a.item("PopupLostFocusRef", "EventRef::popupLostFocus");
        }
        static d(a) {
            PopupDescriptionMetadata.b(a);
            a.ae("Popup", () => new PopupDescription());
            a.ad("Popup", PopupDescriptionMetadata.a);
        }
    }
    PopupDescriptionMetadata.$t = /*@__PURE__*/ markType(PopupDescriptionMetadata, 'PopupDescriptionMetadata');
    PopupDescriptionMetadata.a = null;
    return PopupDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PopupDescriptionModule = /*@__PURE__*/ (() => {
    class PopupDescriptionModule extends Base {
        static register(a) {
            ChildContentDescriptionModule.register(a);
            PopupDescriptionMetadata.d(a);
        }
    }
    PopupDescriptionModule.$t = /*@__PURE__*/ markType(PopupDescriptionModule, 'PopupDescriptionModule');
    return PopupDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrefixDescription = /*@__PURE__*/ (() => {
    class PrefixDescription extends InputGroupItemDescription {
        get_type() {
            return "Prefix";
        }
        constructor() {
            super();
            this.p = null;
            this.o = null;
            this.l = false;
            this.k = false;
        }
        get id() {
            return this.p;
        }
        set id(a) {
            this.p = a;
            this.g("Id");
        }
        get ariaLabel() {
            return this.o;
        }
        set ariaLabel(a) {
            this.o = a;
            this.g("AriaLabel");
        }
        get isHover() {
            return this.l;
        }
        set isHover(a) {
            this.l = a;
            this.g("IsHover");
        }
        get disabled() {
            return this.k;
        }
        set disabled(a) {
            this.k = a;
            this.g("Disabled");
        }
    }
    PrefixDescription.$t = /*@__PURE__*/ markType(PrefixDescription, 'PrefixDescription', InputGroupItemDescription.$);
    return PrefixDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrefixDescriptionMetadata = /*@__PURE__*/ (() => {
    class PrefixDescriptionMetadata extends Base {
        static b(a) {
            if (PrefixDescriptionMetadata.a == null) {
                PrefixDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PrefixDescriptionMetadata.c(PrefixDescriptionMetadata.a);
            }
            if (a.k(PrefixDescriptionMetadata.a)) {
                return;
            }
            a.ac(PrefixDescriptionMetadata.a);
        }
        static c(a) {
            InputGroupItemDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:XPrefix");
            a.item("Id", "String");
            a.item("AriaLabel", "String");
            a.item("IsHover", "Boolean");
            a.item("Disabled", "(w:IsDisabled,xam:IsDisabled,wf:IsDisabled)Boolean");
        }
        static d(a) {
            PrefixDescriptionMetadata.b(a);
            a.ae("Prefix", () => new PrefixDescription());
            a.ad("Prefix", PrefixDescriptionMetadata.a);
        }
    }
    PrefixDescriptionMetadata.$t = /*@__PURE__*/ markType(PrefixDescriptionMetadata, 'PrefixDescriptionMetadata');
    PrefixDescriptionMetadata.a = null;
    return PrefixDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrefixDescriptionModule = /*@__PURE__*/ (() => {
    class PrefixDescriptionModule extends Base {
        static register(a) {
            ChildContentDescriptionModule.register(a);
            PrefixDescriptionMetadata.d(a);
        }
    }
    PrefixDescriptionModule.$t = /*@__PURE__*/ markType(PrefixDescriptionModule, 'PrefixDescriptionModule');
    return PrefixDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorDescription = /*@__PURE__*/ (() => {
    class PropertyEditorDescription extends Description {
        get_type() {
            return "PropertyEditor";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.i = null;
            this.af = null;
            this.ah = null;
            this.t = 0;
            this.y = null;
            this.r = 0;
            this.z = null;
            this.aa = null;
            this.x = null;
            this.ac = null;
            this.ad = null;
            this.ab = null;
            this.ai = null;
            this.ae = null;
            this.l = false;
            this.n = false;
            this.m = false;
            this.w = null;
            this.aj = null;
            this.ak = null;
            this.ag = null;
            this.v = null;
        }
        get actualDataSource() {
            return this.h;
        }
        set actualDataSource(a) {
            this.h = a;
            this.g("ActualDataSource");
        }
        get properties() {
            return this.i;
        }
        set properties(a) {
            this.i = a;
            this.g("Properties");
        }
        get filterPlaceholderText() {
            return this.af;
        }
        set filterPlaceholderText(a) {
            this.af = a;
            this.g("FilterPlaceholderText");
        }
        get searchInputType() {
            return this.ah;
        }
        set searchInputType(a) {
            this.ah = a;
            this.g("SearchInputType");
        }
        get rowHeight() {
            return this.t;
        }
        set rowHeight(a) {
            this.t = a;
            this.g("RowHeight");
        }
        get cellFontFamily() {
            return this.y;
        }
        set cellFontFamily(a) {
            this.y = a;
            this.g("CellFontFamily");
        }
        get cellFontSize() {
            return this.r;
        }
        set cellFontSize(a) {
            this.r = a;
            this.g("CellFontSize");
        }
        get cellFontStyle() {
            return this.z;
        }
        set cellFontStyle(a) {
            this.z = a;
            this.g("CellFontStyle");
        }
        get cellFontWeight() {
            return this.aa;
        }
        set cellFontWeight(a) {
            this.aa = a;
            this.g("CellFontWeight");
        }
        get baseTheme() {
            return this.x;
        }
        set baseTheme(a) {
            this.x = a;
            this.g("BaseTheme");
        }
        get density() {
            return this.ac;
        }
        set density(a) {
            this.ac = a;
            this.g("Density");
        }
        get descriptionContextRef() {
            return this.ad;
        }
        set descriptionContextRef(a) {
            this.ad = a;
            this.g("DescriptionContextRef");
        }
        get componentRendererRef() {
            return this.ab;
        }
        set componentRendererRef(a) {
            this.ab = a;
            this.g("ComponentRendererRef");
        }
        get targetRef() {
            return this.ai;
        }
        set targetRef(a) {
            this.ai = a;
            this.g("TargetRef");
        }
        get descriptionType() {
            return this.ae;
        }
        set descriptionType(a) {
            this.ae = a;
            this.g("DescriptionType");
        }
        get isHorizontal() {
            return this.l;
        }
        set isHorizontal(a) {
            this.l = a;
            this.g("IsHorizontal");
        }
        get isWrappingEnabled() {
            return this.n;
        }
        set isWrappingEnabled(a) {
            this.n = a;
            this.g("IsWrappingEnabled");
        }
        get isIndirectModeEnabled() {
            return this.m;
        }
        set isIndirectModeEnabled(a) {
            this.m = a;
            this.g("IsIndirectModeEnabled");
        }
        get backgroundColor() {
            return this.w;
        }
        set backgroundColor(a) {
            this.w = a;
            this.g("BackgroundColor");
        }
        get textColor() {
            return this.aj;
        }
        set textColor(a) {
            this.aj = a;
            this.g("TextColor");
        }
        get width() {
            return this.ak;
        }
        set width(a) {
            this.ak = a;
            this.g("Width");
        }
        get height() {
            return this.ag;
        }
        set height(a) {
            this.ag = a;
            this.g("Height");
        }
        get background() {
            return this.v;
        }
        set background(a) {
            this.v = a;
            this.g("Background");
        }
    }
    PropertyEditorDescription.$t = /*@__PURE__*/ markType(PropertyEditorDescription, 'PropertyEditorDescription', Description.$);
    return PropertyEditorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorDescriptionMetadata.a == null) {
                PropertyEditorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorDescriptionMetadata.c(PropertyEditorDescriptionMetadata.a);
            }
            if (a.k(PropertyEditorDescriptionMetadata.a)) {
                return;
            }
            a.ac(PropertyEditorDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ActualDataSource", "(w:ActualProperties,xam:ActualProperties,wf:ActualProperties)Collection:PropertyEditorPropertyDescription:PropertyEditorPropertyDescriptionCollection:PropertyEditorPropertyDescription");
            a.item("Properties", "Collection:PropertyEditorPropertyDescription:PropertyEditorPropertyDescriptionCollection:PropertyEditorPropertyDescription");
            a.item("FilterPlaceholderText", "String");
            a.item("SearchInputType", "ExportedType:string:InputGroupDisplayType");
            a.item("SearchInputType@names", "Line;Box;Border;Search");
            a.item("RowHeight", "Number:int");
            a.item("CellFontFamily", "(w:CellFontFamily/FontFamilyTransform,xam:CellFontFamily,wf:CellFontFamily,web:cellTextStyle/FontFamilyTransform)String");
            a.item("CellFontSize", "(w:CellFontSize,xam:CellFontSize,wf:CellFontSize,web:cellTextStyle/FontSizeTransform)Number:double");
            a.item("CellFontStyle", "(w:CellFontStyle/FontStyleTransform,xam:CellFontFamily/FontStyleTransform,wf:CellFontFamily/FontStyleTransform,web:cellTextStyle/FontStyleTransform)String");
            a.item("CellFontWeight", "(w:CellFontWeight/FontWeightTransform,xam:CellFontFamily/FontWeightTransform,wf:CellFontFamily/FontWeightTransform,web:cellTextStyle/FontWeightTransform)String");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("Density", "ExportedType:string:ControlDisplayDensity");
            a.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            a.item("DescriptionContextRef", "(w:DescriptionContext,wf:DescriptionContext)DataRef::object");
            a.item("ComponentRendererRef", "(w:ComponentRenderer,wf:ComponentRenderer)DataRef::object");
            a.item("TargetRef", "(w:Target,wf:Target)DataRef::object");
            a.item("DescriptionType", "String");
            a.item("IsHorizontal", "Boolean");
            a.item("IsWrappingEnabled", "Boolean");
            a.item("IsIndirectModeEnabled", "Boolean");
            a.item("BackgroundColor", "Brush");
            a.item("TextColor", "Brush");
            PropertyEditorDescriptionMetadata.e(a);
        }
        static d(a) {
            PropertyEditorDescriptionMetadata.b(a);
            a.ae("PropertyEditor", () => new PropertyEditorDescription());
            a.ad("PropertyEditor", PropertyEditorDescriptionMetadata.a);
        }
        static e(a) {
            a.item("_qualifiedName", "String:Infragistics.Controls.Grids.XamPropertyEditor");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
    }
    PropertyEditorDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorDescriptionMetadata, 'PropertyEditorDescriptionMetadata');
    PropertyEditorDescriptionMetadata.a = null;
    return PropertyEditorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorDataSourceDescription = /*@__PURE__*/ (() => {
    class PropertyEditorDataSourceDescription extends Description {
        get_type() {
            return "PropertyEditorDataSource";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
        }
        get descriptionType() {
            return this.i;
        }
        set descriptionType(a) {
            this.i = a;
            this.g("DescriptionType");
        }
        get contextRef() {
            return this.h;
        }
        set contextRef(a) {
            this.h = a;
            this.g("ContextRef");
        }
    }
    PropertyEditorDataSourceDescription.$t = /*@__PURE__*/ markType(PropertyEditorDataSourceDescription, 'PropertyEditorDataSourceDescription', Description.$);
    return PropertyEditorDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorDataSourceDescriptionMetadata.a == null) {
                PropertyEditorDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorDataSourceDescriptionMetadata.c(PropertyEditorDataSourceDescriptionMetadata.a);
            }
            if (a.k(PropertyEditorDataSourceDescriptionMetadata.a)) {
                return;
            }
            a.ac(PropertyEditorDataSourceDescriptionMetadata.a);
        }
        static c(a) {
            a.item("DescriptionType", "String");
            a.item("ContextRef", "(w:Context,wf:Context)DataRef::object");
        }
        static d(a) {
            PropertyEditorDataSourceDescriptionMetadata.b(a);
            a.ae("PropertyEditorDataSource", () => new PropertyEditorDataSourceDescription());
            a.ad("PropertyEditorDataSource", PropertyEditorDataSourceDescriptionMetadata.a);
        }
    }
    PropertyEditorDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorDataSourceDescriptionMetadata, 'PropertyEditorDataSourceDescriptionMetadata');
    PropertyEditorDataSourceDescriptionMetadata.a = null;
    return PropertyEditorDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorDescriptionObjectDescription = /*@__PURE__*/ (() => {
    class PropertyEditorDescriptionObjectDescription extends Description {
        get_type() {
            return "PropertyEditorDescriptionObject";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = null;
        }
        get descriptionType() {
            return this.j;
        }
        set descriptionType(a) {
            this.j = a;
            this.g("DescriptionType");
        }
        get properties() {
            return this.h;
        }
        set properties(a) {
            this.h = a;
            this.g("Properties");
        }
    }
    PropertyEditorDescriptionObjectDescription.$t = /*@__PURE__*/ markType(PropertyEditorDescriptionObjectDescription, 'PropertyEditorDescriptionObjectDescription', Description.$);
    return PropertyEditorDescriptionObjectDescription;
})();
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionDescription = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionDescription extends Description {
        get_type() {
            return "PropertyEditorPropertyDescription";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.ak = null;
            this.ai = null;
            this.am = null;
            this.aj = null;
            this.r = false;
            this.ah = null;
            this.i = null;
            this.j = null;
            this.ad = null;
            this.w = 0;
            this.t = 0;
            this.u = 0;
            this.v = 0;
            this.x = 0;
            this.p = null;
            this.h = null;
            this.k = null;
            this.af = null;
            this.ag = null;
            this.al = null;
        }
        get propertyPath() {
            return this.ak;
        }
        set propertyPath(a) {
            this.ak = a;
            this.g("PropertyPath");
        }
        get label() {
            return this.ai;
        }
        set label(a) {
            this.ai = a;
            this.g("Label");
        }
        get valueType() {
            return this.am;
        }
        set valueType(a) {
            this.am = a;
            this.g("ValueType");
        }
        get propertyDescriptionType() {
            return this.aj;
        }
        set propertyDescriptionType(a) {
            this.aj = a;
            this.g("PropertyDescriptionType");
        }
        get shouldOverrideDefaultEditor() {
            return this.r;
        }
        set shouldOverrideDefaultEditor(a) {
            this.r = a;
            this.g("ShouldOverrideDefaultEditor");
        }
        get elementDescriptionType() {
            return this.ah;
        }
        set elementDescriptionType(a) {
            this.ah = a;
            this.g("ElementDescriptionType");
        }
        get dropDownNames() {
            return this.i;
        }
        set dropDownNames(a) {
            this.i = a;
            this.g("DropDownNames");
        }
        get dropDownValues() {
            return this.j;
        }
        set dropDownValues(a) {
            this.j = a;
            this.g("DropDownValues");
        }
        get primitiveValue() {
            return this.ad;
        }
        set primitiveValue(a) {
            this.ad = a;
            this.g("PrimitiveValue");
        }
        get min() {
            return this.w;
        }
        set min(a) {
            this.w = a;
            this.g("Min");
        }
        get editorWidth() {
            return this.t;
        }
        set editorWidth(a) {
            this.t = a;
            this.g("EditorWidth");
        }
        get labelWidth() {
            return this.u;
        }
        set labelWidth(a) {
            this.u = a;
            this.g("LabelWidth");
        }
        get max() {
            return this.v;
        }
        set max(a) {
            this.v = a;
            this.g("Max");
        }
        get step() {
            return this.x;
        }
        set step(a) {
            this.x = a;
            this.g("Step");
        }
        get complexValue() {
            return this.p;
        }
        set complexValue(a) {
            this.p = a;
            this.g("ComplexValue");
        }
        get complexValues() {
            return this.h;
        }
        set complexValues(a) {
            this.h = a;
            this.g("ComplexValues");
        }
        get properties() {
            return this.k;
        }
        set properties(a) {
            this.k = a;
            this.g("Properties");
        }
        get buttonClickedRef() {
            return this.af;
        }
        set buttonClickedRef(a) {
            this.af = a;
            this.g("ButtonClickedRef");
        }
        get changedRef() {
            return this.ag;
        }
        set changedRef(a) {
            this.ag = a;
            this.g("ChangedRef");
        }
        get targetPropertyUpdatingRef() {
            return this.al;
        }
        set targetPropertyUpdatingRef(a) {
            this.al = a;
            this.g("TargetPropertyUpdatingRef");
        }
    }
    PropertyEditorPropertyDescriptionDescription.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionDescription, 'PropertyEditorPropertyDescriptionDescription', Description.$);
    return PropertyEditorPropertyDescriptionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorDescriptionObjectDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorDescriptionObjectDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorDescriptionObjectDescriptionMetadata.a == null) {
                PropertyEditorDescriptionObjectDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorDescriptionObjectDescriptionMetadata.c(PropertyEditorDescriptionObjectDescriptionMetadata.a);
            }
            if (a.k(PropertyEditorDescriptionObjectDescriptionMetadata.a)) {
                return;
            }
            a.ac(PropertyEditorDescriptionObjectDescriptionMetadata.a);
        }
        static c(a) {
            a.item("DescriptionType", "String");
            a.item("Properties", "Collection:PropertyEditorPropertyDescription:PropertyEditorPropertyDescriptionCollection:PropertyEditorPropertyDescription");
        }
        static d(a) {
            PropertyEditorDescriptionObjectDescriptionMetadata.b(a);
            a.ae("PropertyEditorDescriptionObject", () => new PropertyEditorDescriptionObjectDescription());
            a.ad("PropertyEditorDescriptionObject", PropertyEditorDescriptionObjectDescriptionMetadata.a);
        }
    }
    PropertyEditorDescriptionObjectDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorDescriptionObjectDescriptionMetadata, 'PropertyEditorDescriptionObjectDescriptionMetadata');
    PropertyEditorDescriptionObjectDescriptionMetadata.a = null;
    return PropertyEditorDescriptionObjectDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionButtonClickEventArgsDescription = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionButtonClickEventArgsDescription extends Description {
        get_type() {
            return "PropertyEditorPropertyDescriptionButtonClickEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    PropertyEditorPropertyDescriptionButtonClickEventArgsDescription.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionButtonClickEventArgsDescription, 'PropertyEditorPropertyDescriptionButtonClickEventArgsDescription', Description.$);
    return PropertyEditorPropertyDescriptionButtonClickEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.a == null) {
                PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.c(PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.a);
            }
            if (a.k(PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.b(a);
            a.ae("PropertyEditorPropertyDescriptionButtonClickEventArgs", () => new PropertyEditorPropertyDescriptionButtonClickEventArgsDescription());
            a.ad("PropertyEditorPropertyDescriptionButtonClickEventArgs", PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.a);
        }
    }
    PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata, 'PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata');
    PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.a = null;
    return PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionChangedEventArgsDescription extends Description {
        get_type() {
            return "PropertyEditorPropertyDescriptionChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get newValue() {
            return this.h;
        }
        set newValue(a) {
            this.h = a;
            this.g("NewValue");
        }
    }
    PropertyEditorPropertyDescriptionChangedEventArgsDescription.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionChangedEventArgsDescription, 'PropertyEditorPropertyDescriptionChangedEventArgsDescription', Description.$);
    return PropertyEditorPropertyDescriptionChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.a == null) {
                PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.c(PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("NewValue", "Unknown");
        }
        static d(a) {
            PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.b(a);
            a.ae("PropertyEditorPropertyDescriptionChangedEventArgs", () => new PropertyEditorPropertyDescriptionChangedEventArgsDescription());
            a.ad("PropertyEditorPropertyDescriptionChangedEventArgs", PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.a);
        }
    }
    PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata, 'PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata');
    PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.a = null;
    return PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription extends Description {
        get_type() {
            return "PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.j = null;
            this.h = null;
        }
        get targetRef() {
            return this.i;
        }
        set targetRef(a) {
            this.i = a;
            this.g("TargetRef");
        }
        get valueRef() {
            return this.j;
        }
        set valueRef(a) {
            this.j = a;
            this.g("ValueRef");
        }
        get propertyPath() {
            return this.h;
        }
        set propertyPath(a) {
            this.h = a;
            this.g("PropertyPath");
        }
    }
    PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription, 'PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription', Description.$);
    return PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.a == null) {
                PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.c(PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.a);
            }
            if (a.k(PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("TargetRef", "(w:Target,wf:Target)DataRef");
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
            a.item("PropertyPath", "String");
        }
        static d(a) {
            PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.b(a);
            a.ae("PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs", () => new PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription());
            a.ad("PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs", PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata, 'PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata');
    PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.a = null;
    return PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorPropertyDescriptionDescriptionMetadata.a == null) {
                PropertyEditorPropertyDescriptionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorPropertyDescriptionDescriptionMetadata.c(PropertyEditorPropertyDescriptionDescriptionMetadata.a);
            }
            if (a.k(PropertyEditorPropertyDescriptionDescriptionMetadata.a)) {
                return;
            }
            a.ac(PropertyEditorPropertyDescriptionDescriptionMetadata.a);
            PropertyEditorDescriptionObjectDescriptionMetadata.d(a);
            PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.d(a);
            PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.d(a);
            PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("PropertyPath", "String");
            a.item("Label", "String");
            a.item("ValueType", "ExportedType:string:PropertyEditorValueType");
            a.item("ValueType@names", "Unhandled;Number;StringValue;Date;Brush;Color;BrushCollection;Boolean1;SubType;Collection;Array;Point;Size;Rect;ColorCollection;EnumValue;MethodRef;EventRef;DataRef;TimeSpan;Button;Slider;TemplateRef;DoubleCollection");
            a.item("PropertyDescriptionType", "String");
            a.item("ShouldOverrideDefaultEditor", "Boolean");
            a.item("ElementDescriptionType", "String");
            a.item("DropDownNames", "Array:string");
            a.item("DropDownValues", "Array:string");
            a.item("PrimitiveValue", "Unknown");
            a.item("Min", "Number:double");
            a.item("EditorWidth", "Number:double");
            a.item("LabelWidth", "Number:double");
            a.item("Max", "Number:double");
            a.item("Step", "Number:double");
            a.item("ComplexValue", "ExportedType:PropertyEditorDescriptionObject");
            a.item("ComplexValues", "Collection:PropertyEditorDescriptionObject:PropertyEditorDescriptionObjectCollection:PropertyEditorDescriptionObject");
            a.item("Properties", "Collection:PropertyEditorPropertyDescription:PropertyEditorPropertyDescriptionCollection:PropertyEditorPropertyDescription");
            a.item("ButtonClickedRef", "EventRef::buttonClicked");
            a.item("ChangedRef", "EventRef::changed");
            a.item("TargetPropertyUpdatingRef", "EventRef::targetPropertyUpdating");
        }
        static d(a) {
            PropertyEditorPropertyDescriptionDescriptionMetadata.b(a);
            a.ae("PropertyEditorPropertyDescription", () => new PropertyEditorPropertyDescriptionDescription());
            a.ad("PropertyEditorPropertyDescription", PropertyEditorPropertyDescriptionDescriptionMetadata.a);
        }
    }
    PropertyEditorPropertyDescriptionDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionDescriptionMetadata, 'PropertyEditorPropertyDescriptionDescriptionMetadata');
    PropertyEditorPropertyDescriptionDescriptionMetadata.a = null;
    return PropertyEditorPropertyDescriptionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionDescriptionModule = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionDescriptionModule extends Base {
        static register(a) {
            PropertyEditorPropertyDescriptionDescriptionMetadata.d(a);
        }
    }
    PropertyEditorPropertyDescriptionDescriptionModule.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionDescriptionModule, 'PropertyEditorPropertyDescriptionDescriptionModule');
    return PropertyEditorPropertyDescriptionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorDescriptionModule = /*@__PURE__*/ (() => {
    class PropertyEditorDescriptionModule extends Base {
        static register(a) {
            InputGroupDescriptionModule.register(a);
            CheckboxDescriptionModule.register(a);
            ButtonDescriptionModule.register(a);
            DataGridCoreDescriptionModule.register(a);
            MultiColumnComboBoxDescriptionModule.register(a);
            NumericColumnDescriptionModule.register(a);
            DateTimeColumnDescriptionModule.register(a);
            ImageColumnDescriptionModule.register(a);
            TextColumnDescriptionModule.register(a);
            TemplateColumnDescriptionModule.register(a);
            PropertyEditorPropertyDescriptionDescriptionModule.register(a);
            PropertyEditorDescriptionMetadata.d(a);
        }
    }
    PropertyEditorDescriptionModule.$t = /*@__PURE__*/ markType(PropertyEditorDescriptionModule, 'PropertyEditorDescriptionModule');
    return PropertyEditorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPanelDescription = /*@__PURE__*/ (() => {
    class PropertyEditorPanelDescription extends Description {
        get_type() {
            return "PropertyEditorPanel";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.i = null;
            this.v = 0;
            this.r = 0;
            this.z = null;
            this.s = 0;
            this.aa = null;
            this.ab = null;
            this.ad = null;
            this.ac = null;
            this.ag = null;
            this.ae = null;
            this.l = false;
            this.n = false;
            this.m = false;
            this.y = null;
            this.ah = null;
            this.ai = null;
            this.af = null;
            this.x = null;
        }
        get actualDataSource() {
            return this.h;
        }
        set actualDataSource(a) {
            this.h = a;
            this.g("ActualDataSource");
        }
        get properties() {
            return this.i;
        }
        set properties(a) {
            this.i = a;
            this.g("Properties");
        }
        get rowHeight() {
            return this.v;
        }
        set rowHeight(a) {
            this.v = a;
            this.g("RowHeight");
        }
        get actualRowHeight() {
            return this.r;
        }
        set actualRowHeight(a) {
            this.r = a;
            this.g("ActualRowHeight");
        }
        get cellFontFamily() {
            return this.z;
        }
        set cellFontFamily(a) {
            this.z = a;
            this.g("CellFontFamily");
        }
        get cellFontSize() {
            return this.s;
        }
        set cellFontSize(a) {
            this.s = a;
            this.g("CellFontSize");
        }
        get cellFontStyle() {
            return this.aa;
        }
        set cellFontStyle(a) {
            this.aa = a;
            this.g("CellFontStyle");
        }
        get cellFontWeight() {
            return this.ab;
        }
        set cellFontWeight(a) {
            this.ab = a;
            this.g("CellFontWeight");
        }
        get descriptionContextRef() {
            return this.ad;
        }
        set descriptionContextRef(a) {
            this.ad = a;
            this.g("DescriptionContextRef");
        }
        get componentRendererRef() {
            return this.ac;
        }
        set componentRendererRef(a) {
            this.ac = a;
            this.g("ComponentRendererRef");
        }
        get targetRef() {
            return this.ag;
        }
        set targetRef(a) {
            this.ag = a;
            this.g("TargetRef");
        }
        get descriptionType() {
            return this.ae;
        }
        set descriptionType(a) {
            this.ae = a;
            this.g("DescriptionType");
        }
        get isHorizontal() {
            return this.l;
        }
        set isHorizontal(a) {
            this.l = a;
            this.g("IsHorizontal");
        }
        get isWrappingEnabled() {
            return this.n;
        }
        set isWrappingEnabled(a) {
            this.n = a;
            this.g("IsWrappingEnabled");
        }
        get isIndirectModeEnabled() {
            return this.m;
        }
        set isIndirectModeEnabled(a) {
            this.m = a;
            this.g("IsIndirectModeEnabled");
        }
        get backgroundColor() {
            return this.y;
        }
        set backgroundColor(a) {
            this.y = a;
            this.g("BackgroundColor");
        }
        get textColor() {
            return this.ah;
        }
        set textColor(a) {
            this.ah = a;
            this.g("TextColor");
        }
        get width() {
            return this.ai;
        }
        set width(a) {
            this.ai = a;
            this.g("Width");
        }
        get height() {
            return this.af;
        }
        set height(a) {
            this.af = a;
            this.g("Height");
        }
        get background() {
            return this.x;
        }
        set background(a) {
            this.x = a;
            this.g("Background");
        }
    }
    PropertyEditorPanelDescription.$t = /*@__PURE__*/ markType(PropertyEditorPanelDescription, 'PropertyEditorPanelDescription', Description.$);
    return PropertyEditorPanelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPanelDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorPanelDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorPanelDescriptionMetadata.a == null) {
                PropertyEditorPanelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorPanelDescriptionMetadata.c(PropertyEditorPanelDescriptionMetadata.a);
            }
            if (a.k(PropertyEditorPanelDescriptionMetadata.a)) {
                return;
            }
            a.ac(PropertyEditorPanelDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ActualDataSource", "(w:ActualProperties,xam:ActualProperties,wf:ActualProperties)Collection:PropertyEditorPropertyDescription:PropertyEditorPropertyDescriptionCollection:PropertyEditorPropertyDescription");
            a.item("Properties", "Collection:PropertyEditorPropertyDescription:PropertyEditorPropertyDescriptionCollection:PropertyEditorPropertyDescription");
            a.item("RowHeight", "Number:int");
            a.item("ActualRowHeight", "Number:double");
            a.item("CellFontFamily", "(w:CellFontFamily/FontFamilyTransform,xam:CellFontFamily,wf:CellFontFamily,web:cellTextStyle/FontFamilyTransform)String");
            a.item("CellFontSize", "(w:CellFontSize,xam:CellFontSize,wf:CellFontSize,web:cellTextStyle/FontSizeTransform)Number:double");
            a.item("CellFontStyle", "(w:CellFontStyle/FontStyleTransform,xam:CellFontFamily/FontStyleTransform,wf:CellFontFamily/FontStyleTransform,web:cellTextStyle/FontStyleTransform)String");
            a.item("CellFontWeight", "(w:CellFontWeight/FontWeightTransform,xam:CellFontFamily/FontWeightTransform,wf:CellFontFamily/FontWeightTransform,web:cellTextStyle/FontWeightTransform)String");
            a.item("DescriptionContextRef", "(w:DescriptionContext,wf:DescriptionContext)DataRef::object");
            a.item("ComponentRendererRef", "(w:ComponentRenderer,wf:ComponentRenderer)DataRef::object");
            a.item("TargetRef", "(w:Target,wf:Target)DataRef::object");
            a.item("DescriptionType", "String");
            a.item("IsHorizontal", "Boolean");
            a.item("IsWrappingEnabled", "Boolean");
            a.item("IsIndirectModeEnabled", "Boolean");
            a.item("BackgroundColor", "Brush");
            a.item("TextColor", "Brush");
            PropertyEditorPanelDescriptionMetadata.e(a);
        }
        static d(a) {
            PropertyEditorPanelDescriptionMetadata.b(a);
            a.ae("PropertyEditorPanel", () => new PropertyEditorPanelDescription());
            a.ad("PropertyEditorPanel", PropertyEditorPanelDescriptionMetadata.a);
        }
        static e(a) {
            a.item("_qualifiedName", "String:Infragistics.Controls.Layouts.XamPropertyEditorPanel");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
    }
    PropertyEditorPanelDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorPanelDescriptionMetadata, 'PropertyEditorPanelDescriptionMetadata');
    PropertyEditorPanelDescriptionMetadata.a = null;
    return PropertyEditorPanelDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPanelDescriptionModule = /*@__PURE__*/ (() => {
    class PropertyEditorPanelDescriptionModule extends Base {
        static register(a) {
            PropertyEditorPropertyDescriptionDescriptionModule.register(a);
            PropertyEditorPanelDescriptionMetadata.d(a);
        }
    }
    PropertyEditorPanelDescriptionModule.$t = /*@__PURE__*/ markType(PropertyEditorPanelDescriptionModule, 'PropertyEditorPanelDescriptionModule');
    return PropertyEditorPanelDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Q1ExpressionDescription = /*@__PURE__*/ (() => {
    class Q1ExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "Q1Expression";
        }
        constructor() {
            super();
        }
    }
    Q1ExpressionDescription.$t = /*@__PURE__*/ markType(Q1ExpressionDescription, 'Q1ExpressionDescription', WrapperExpressionDescription.$);
    Q1ExpressionDescription.__marshalByValue2 = true;
    Q1ExpressionDescription.__marshalByValueAlias2 = "Q1Expression";
    return Q1ExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Q1ExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class Q1ExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (Q1ExpressionDescriptionMetadata.a == null) {
                Q1ExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Q1ExpressionDescriptionMetadata.c(Q1ExpressionDescriptionMetadata.a);
            }
            if (a.k(Q1ExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(Q1ExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            Q1ExpressionDescriptionMetadata.b(a);
            a.ae("Q1Expression", () => new Q1ExpressionDescription());
            a.ad("Q1Expression", Q1ExpressionDescriptionMetadata.a);
        }
    }
    Q1ExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(Q1ExpressionDescriptionMetadata, 'Q1ExpressionDescriptionMetadata');
    Q1ExpressionDescriptionMetadata.a = null;
    return Q1ExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Q2ExpressionDescription = /*@__PURE__*/ (() => {
    class Q2ExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "Q2Expression";
        }
        constructor() {
            super();
        }
    }
    Q2ExpressionDescription.$t = /*@__PURE__*/ markType(Q2ExpressionDescription, 'Q2ExpressionDescription', WrapperExpressionDescription.$);
    Q2ExpressionDescription.__marshalByValue2 = true;
    Q2ExpressionDescription.__marshalByValueAlias2 = "Q2Expression";
    return Q2ExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Q2ExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class Q2ExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (Q2ExpressionDescriptionMetadata.a == null) {
                Q2ExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Q2ExpressionDescriptionMetadata.c(Q2ExpressionDescriptionMetadata.a);
            }
            if (a.k(Q2ExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(Q2ExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            Q2ExpressionDescriptionMetadata.b(a);
            a.ae("Q2Expression", () => new Q2ExpressionDescription());
            a.ad("Q2Expression", Q2ExpressionDescriptionMetadata.a);
        }
    }
    Q2ExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(Q2ExpressionDescriptionMetadata, 'Q2ExpressionDescriptionMetadata');
    Q2ExpressionDescriptionMetadata.a = null;
    return Q2ExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Q3ExpressionDescription = /*@__PURE__*/ (() => {
    class Q3ExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "Q3Expression";
        }
        constructor() {
            super();
        }
    }
    Q3ExpressionDescription.$t = /*@__PURE__*/ markType(Q3ExpressionDescription, 'Q3ExpressionDescription', WrapperExpressionDescription.$);
    Q3ExpressionDescription.__marshalByValue2 = true;
    Q3ExpressionDescription.__marshalByValueAlias2 = "Q3Expression";
    return Q3ExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Q3ExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class Q3ExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (Q3ExpressionDescriptionMetadata.a == null) {
                Q3ExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Q3ExpressionDescriptionMetadata.c(Q3ExpressionDescriptionMetadata.a);
            }
            if (a.k(Q3ExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(Q3ExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            Q3ExpressionDescriptionMetadata.b(a);
            a.ae("Q3Expression", () => new Q3ExpressionDescription());
            a.ad("Q3Expression", Q3ExpressionDescriptionMetadata.a);
        }
    }
    Q3ExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(Q3ExpressionDescriptionMetadata, 'Q3ExpressionDescriptionMetadata');
    Q3ExpressionDescriptionMetadata.a = null;
    return Q3ExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Q4ExpressionDescription = /*@__PURE__*/ (() => {
    class Q4ExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "Q4Expression";
        }
        constructor() {
            super();
        }
    }
    Q4ExpressionDescription.$t = /*@__PURE__*/ markType(Q4ExpressionDescription, 'Q4ExpressionDescription', WrapperExpressionDescription.$);
    Q4ExpressionDescription.__marshalByValue2 = true;
    Q4ExpressionDescription.__marshalByValueAlias2 = "Q4Expression";
    return Q4ExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Q4ExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class Q4ExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (Q4ExpressionDescriptionMetadata.a == null) {
                Q4ExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Q4ExpressionDescriptionMetadata.c(Q4ExpressionDescriptionMetadata.a);
            }
            if (a.k(Q4ExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(Q4ExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            Q4ExpressionDescriptionMetadata.b(a);
            a.ae("Q4Expression", () => new Q4ExpressionDescription());
            a.ad("Q4Expression", Q4ExpressionDescriptionMetadata.a);
        }
    }
    Q4ExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(Q4ExpressionDescriptionMetadata, 'Q4ExpressionDescriptionMetadata');
    Q4ExpressionDescriptionMetadata.a = null;
    return Q4ExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatRadialGaugeLabelEventArgsDescription = /*@__PURE__*/ (() => {
    class FormatRadialGaugeLabelEventArgsDescription extends Description {
        get_type() {
            return "FormatRadialGaugeLabelEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    FormatRadialGaugeLabelEventArgsDescription.$t = /*@__PURE__*/ markType(FormatRadialGaugeLabelEventArgsDescription, 'FormatRadialGaugeLabelEventArgsDescription', Description.$);
    return FormatRadialGaugeLabelEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatRadialGaugeLabelEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FormatRadialGaugeLabelEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FormatRadialGaugeLabelEventArgsDescriptionMetadata.a == null) {
                FormatRadialGaugeLabelEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FormatRadialGaugeLabelEventArgsDescriptionMetadata.c(FormatRadialGaugeLabelEventArgsDescriptionMetadata.a);
            }
            if (a.k(FormatRadialGaugeLabelEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(FormatRadialGaugeLabelEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            FormatRadialGaugeLabelEventArgsDescriptionMetadata.b(a);
            a.ae("FormatRadialGaugeLabelEventArgs", () => new FormatRadialGaugeLabelEventArgsDescription());
            a.ad("FormatRadialGaugeLabelEventArgs", FormatRadialGaugeLabelEventArgsDescriptionMetadata.a);
        }
    }
    FormatRadialGaugeLabelEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FormatRadialGaugeLabelEventArgsDescriptionMetadata, 'FormatRadialGaugeLabelEventArgsDescriptionMetadata');
    FormatRadialGaugeLabelEventArgsDescriptionMetadata.a = null;
    return FormatRadialGaugeLabelEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AlignRadialGaugeLabelEventArgsDescription = /*@__PURE__*/ (() => {
    class AlignRadialGaugeLabelEventArgsDescription extends FormatRadialGaugeLabelEventArgsDescription {
        get_type() {
            return "AlignRadialGaugeLabelEventArgs";
        }
        constructor() {
            super();
        }
    }
    AlignRadialGaugeLabelEventArgsDescription.$t = /*@__PURE__*/ markType(AlignRadialGaugeLabelEventArgsDescription, 'AlignRadialGaugeLabelEventArgsDescription', FormatRadialGaugeLabelEventArgsDescription.$);
    return AlignRadialGaugeLabelEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AlignRadialGaugeLabelEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AlignRadialGaugeLabelEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AlignRadialGaugeLabelEventArgsDescriptionMetadata.a == null) {
                AlignRadialGaugeLabelEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AlignRadialGaugeLabelEventArgsDescriptionMetadata.c(AlignRadialGaugeLabelEventArgsDescriptionMetadata.a);
            }
            if (a.k(AlignRadialGaugeLabelEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(AlignRadialGaugeLabelEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            FormatRadialGaugeLabelEventArgsDescriptionMetadata.c(a);
        }
        static d(a) {
            AlignRadialGaugeLabelEventArgsDescriptionMetadata.b(a);
            a.ae("AlignRadialGaugeLabelEventArgs", () => new AlignRadialGaugeLabelEventArgsDescription());
            a.ad("AlignRadialGaugeLabelEventArgs", AlignRadialGaugeLabelEventArgsDescriptionMetadata.a);
        }
    }
    AlignRadialGaugeLabelEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AlignRadialGaugeLabelEventArgsDescriptionMetadata, 'AlignRadialGaugeLabelEventArgsDescriptionMetadata');
    AlignRadialGaugeLabelEventArgsDescriptionMetadata.a = null;
    return AlignRadialGaugeLabelEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialGaugeDescription = /*@__PURE__*/ (() => {
    class RadialGaugeDescription extends Description {
        get fontFamily() {
            return this.eg;
        }
        set fontFamily(a) {
            this.eg = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.a2;
        }
        set fontSize(a) {
            this.a2 = a;
            this.g("FontSize");
        }
        get fontWeight() {
            return this.ei;
        }
        set fontWeight(a) {
            this.ei = a;
            this.g("FontWeight");
        }
        get fontStyle() {
            return this.eh;
        }
        set fontStyle(a) {
            this.eh = a;
            this.g("FontStyle");
        }
        get width() {
            return this.fm;
        }
        set width(a) {
            this.fm = a;
            this.g("Width");
        }
        get height() {
            return this.en;
        }
        set height(a) {
            this.en = a;
            this.g("Height");
        }
        get background() {
            return this.d9;
        }
        set background(a) {
            this.d9 = a;
            this.g("Background");
        }
        get_type() {
            return "RadialGauge";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.eg = null;
            this.a2 = 0;
            this.ei = null;
            this.eh = null;
            this.fm = null;
            this.en = null;
            this.d9 = null;
            this.j = null;
            this.k = null;
            this.bc = 0;
            this.at = 0;
            this.bb = 0;
            this.as = 0;
            this.a8 = 0;
            this.a0 = 0;
            this.a1 = 0;
            this.cc = 0;
            this.a6 = 0;
            this.ar = 0;
            this.a7 = 0;
            this.d2 = null;
            this.ev = null;
            this.b0 = 0;
            this.bx = 0;
            this.e6 = null;
            this.d0 = 0;
            this.fk = null;
            this.ey = null;
            this.ez = null;
            this.bq = 0;
            this.bj = 0;
            this.e3 = null;
            this.br = 0;
            this.bk = 0;
            this.bi = 0;
            this.bh = 0;
            this.bp = 0;
            this.bo = 0;
            this.bn = 0;
            this.bl = 0;
            this.e2 = null;
            this.b1 = 0;
            this.e0 = null;
            this.e1 = null;
            this.bs = 0;
            this.bm = 0;
            this.by = 0;
            this.a9 = 0;
            this.ba = 0;
            this.b6 = 0;
            this.b5 = 0;
            this.b7 = 0;
            this.fd = null;
            this.ef = null;
            this.bf = 0;
            this.be = 0;
            this.bg = 0;
            this.ex = null;
            this.bd = 0;
            this.e4 = null;
            this.ea = null;
            this.eb = null;
            this.az = 0;
            this.ax = 0;
            this.ay = 0;
            this.bz = 0;
            this.e5 = null;
            this.av = 0;
            this.aw = 0;
            this.ec = null;
            this.l = null;
            this.bw = 0;
            this.ed = null;
            this.aa = false;
            this.z = false;
            this.y = false;
            this.x = false;
            this.ee = null;
            this.ew = null;
            this.i = null;
            this.cb = 0;
            this.bv = 0;
            this.au = 0;
            this.bt = 0;
            this.ab = false;
            this.bu = 0;
            this.fj = null;
            this.fc = null;
            this.b8 = 0;
            this.b2 = 0;
            this.b9 = 0;
            this.b3 = 0;
            this.fe = null;
            this.e7 = null;
            this.ae = false;
            this.ac = false;
            this.af = false;
            this.ad = false;
            this.fb = null;
            this.m = null;
            this.fi = null;
            this.n = null;
            this.et = null;
            this.a3 = 0;
            this.a4 = 0;
            this.eo = null;
            this.v = false;
            this.w = false;
            this.es = null;
            this.h = null;
            this.ep = null;
            this.a5 = 0;
            this.eq = null;
            this.er = null;
            this.e8 = null;
            this.b4 = 0;
            this.e9 = null;
            this.fa = null;
            this.ff = null;
            this.ca = 0;
            this.fg = null;
            this.fh = null;
            this.d8 = null;
            this.d7 = null;
            this.d5 = null;
            this.em = null;
            this.el = null;
            this.ej = null;
            this.ek = null;
            this.d6 = null;
            this.fl = null;
            this.eu = null;
            this.d4 = null;
            this.d3 = null;
        }
        get rangeBrushes() {
            return this.j;
        }
        set rangeBrushes(a) {
            this.j = a;
            this.g("RangeBrushes");
        }
        get rangeOutlines() {
            return this.k;
        }
        set rangeOutlines(a) {
            this.k = a;
            this.g("RangeOutlines");
        }
        get minimumValue() {
            return this.bc;
        }
        set minimumValue(a) {
            this.bc = a;
            this.g("MinimumValue");
        }
        get actualMinimumValue() {
            return this.at;
        }
        set actualMinimumValue(a) {
            this.at = a;
            this.g("ActualMinimumValue");
        }
        get maximumValue() {
            return this.bb;
        }
        set maximumValue(a) {
            this.bb = a;
            this.g("MaximumValue");
        }
        get actualMaximumValue() {
            return this.as;
        }
        set actualMaximumValue(a) {
            this.as = a;
            this.g("ActualMaximumValue");
        }
        get interval() {
            return this.a8;
        }
        set interval(a) {
            this.a8 = a;
            this.g("Interval");
        }
        get centerX() {
            return this.a0;
        }
        set centerX(a) {
            this.a0 = a;
            this.g("CenterX");
        }
        get centerY() {
            return this.a1;
        }
        set centerY(a) {
            this.a1 = a;
            this.g("CenterY");
        }
        get value() {
            return this.cc;
        }
        set value(a) {
            this.cc = a;
            this.g("Value");
        }
        get highlightValue() {
            return this.a6;
        }
        set highlightValue(a) {
            this.a6 = a;
            this.g("HighlightValue");
        }
        get actualHighlightValueOpacity() {
            return this.ar;
        }
        set actualHighlightValueOpacity(a) {
            this.ar = a;
            this.g("ActualHighlightValueOpacity");
        }
        get highlightValueOpacity() {
            return this.a7;
        }
        set highlightValueOpacity(a) {
            this.a7 = a;
            this.g("HighlightValueOpacity");
        }
        get actualHighlightValueDisplayMode() {
            return this.d2;
        }
        set actualHighlightValueDisplayMode(a) {
            this.d2 = a;
            this.g("ActualHighlightValueDisplayMode");
        }
        get highlightValueDisplayMode() {
            return this.ev;
        }
        set highlightValueDisplayMode(a) {
            this.ev = a;
            this.g("HighlightValueDisplayMode");
        }
        get scaleStartAngle() {
            return this.b0;
        }
        set scaleStartAngle(a) {
            this.b0 = a;
            this.g("ScaleStartAngle");
        }
        get scaleEndAngle() {
            return this.bx;
        }
        set scaleEndAngle(a) {
            this.bx = a;
            this.g("ScaleEndAngle");
        }
        get scaleSweepDirection() {
            return this.e6;
        }
        set scaleSweepDirection(a) {
            this.e6 = a;
            this.g("ScaleSweepDirection");
        }
        get transitionDuration() {
            return this.d0;
        }
        set transitionDuration(a) {
            this.d0 = a;
            this.g("TransitionDuration");
        }
        get transitionEasingFunctionRef() {
            return this.fk;
        }
        set transitionEasingFunctionRef(a) {
            this.fk = a;
            this.g("TransitionEasingFunctionRef");
        }
        get needleBrush() {
            return this.ey;
        }
        set needleBrush(a) {
            this.ey = a;
            this.g("NeedleBrush");
        }
        get needleOutline() {
            return this.ez;
        }
        set needleOutline(a) {
            this.ez = a;
            this.g("NeedleOutline");
        }
        get needleStartExtent() {
            return this.bq;
        }
        set needleStartExtent(a) {
            this.bq = a;
            this.g("NeedleStartExtent");
        }
        get needleEndExtent() {
            return this.bj;
        }
        set needleEndExtent(a) {
            this.bj = a;
            this.g("NeedleEndExtent");
        }
        get needleShape() {
            return this.e3;
        }
        set needleShape(a) {
            this.e3 = a;
            this.g("NeedleShape");
        }
        get needleStartWidthRatio() {
            return this.br;
        }
        set needleStartWidthRatio(a) {
            this.br = a;
            this.g("NeedleStartWidthRatio");
        }
        get needleEndWidthRatio() {
            return this.bk;
        }
        set needleEndWidthRatio(a) {
            this.bk = a;
            this.g("NeedleEndWidthRatio");
        }
        get needleBaseFeatureWidthRatio() {
            return this.bi;
        }
        set needleBaseFeatureWidthRatio(a) {
            this.bi = a;
            this.g("NeedleBaseFeatureWidthRatio");
        }
        get needleBaseFeatureExtent() {
            return this.bh;
        }
        set needleBaseFeatureExtent(a) {
            this.bh = a;
            this.g("NeedleBaseFeatureExtent");
        }
        get needlePointFeatureWidthRatio() {
            return this.bp;
        }
        set needlePointFeatureWidthRatio(a) {
            this.bp = a;
            this.g("NeedlePointFeatureWidthRatio");
        }
        get needlePointFeatureExtent() {
            return this.bo;
        }
        set needlePointFeatureExtent(a) {
            this.bo = a;
            this.g("NeedlePointFeatureExtent");
        }
        get needlePivotWidthRatio() {
            return this.bn;
        }
        set needlePivotWidthRatio(a) {
            this.bn = a;
            this.g("NeedlePivotWidthRatio");
        }
        get needlePivotInnerWidthRatio() {
            return this.bl;
        }
        set needlePivotInnerWidthRatio(a) {
            this.bl = a;
            this.g("NeedlePivotInnerWidthRatio");
        }
        get needlePivotShape() {
            return this.e2;
        }
        set needlePivotShape(a) {
            this.e2 = a;
            this.g("NeedlePivotShape");
        }
        get scaleStartExtent() {
            return this.b1;
        }
        set scaleStartExtent(a) {
            this.b1 = a;
            this.g("ScaleStartExtent");
        }
        get needlePivotBrush() {
            return this.e0;
        }
        set needlePivotBrush(a) {
            this.e0 = a;
            this.g("NeedlePivotBrush");
        }
        get needlePivotOutline() {
            return this.e1;
        }
        set needlePivotOutline(a) {
            this.e1 = a;
            this.g("NeedlePivotOutline");
        }
        get needleStrokeThickness() {
            return this.bs;
        }
        set needleStrokeThickness(a) {
            this.bs = a;
            this.g("NeedleStrokeThickness");
        }
        get needlePivotStrokeThickness() {
            return this.bm;
        }
        set needlePivotStrokeThickness(a) {
            this.bm = a;
            this.g("NeedlePivotStrokeThickness");
        }
        get scaleEndExtent() {
            return this.by;
        }
        set scaleEndExtent(a) {
            this.by = a;
            this.g("ScaleEndExtent");
        }
        get labelExtent() {
            return this.a9;
        }
        set labelExtent(a) {
            this.a9 = a;
            this.g("LabelExtent");
        }
        get labelInterval() {
            return this.ba;
        }
        set labelInterval(a) {
            this.ba = a;
            this.g("LabelInterval");
        }
        get tickStartExtent() {
            return this.b6;
        }
        set tickStartExtent(a) {
            this.b6 = a;
            this.g("TickStartExtent");
        }
        get tickEndExtent() {
            return this.b5;
        }
        set tickEndExtent(a) {
            this.b5 = a;
            this.g("TickEndExtent");
        }
        get tickStrokeThickness() {
            return this.b7;
        }
        set tickStrokeThickness(a) {
            this.b7 = a;
            this.g("TickStrokeThickness");
        }
        get tickBrush() {
            return this.fd;
        }
        set tickBrush(a) {
            this.fd = a;
            this.g("TickBrush");
        }
        get fontBrush() {
            return this.ef;
        }
        set fontBrush(a) {
            this.ef = a;
            this.g("FontBrush");
        }
        get minorTickStartExtent() {
            return this.bf;
        }
        set minorTickStartExtent(a) {
            this.bf = a;
            this.g("MinorTickStartExtent");
        }
        get minorTickEndExtent() {
            return this.be;
        }
        set minorTickEndExtent(a) {
            this.be = a;
            this.g("MinorTickEndExtent");
        }
        get minorTickStrokeThickness() {
            return this.bg;
        }
        set minorTickStrokeThickness(a) {
            this.bg = a;
            this.g("MinorTickStrokeThickness");
        }
        get minorTickBrush() {
            return this.ex;
        }
        set minorTickBrush(a) {
            this.ex = a;
            this.g("MinorTickBrush");
        }
        get minorTickCount() {
            return this.bd;
        }
        set minorTickCount(a) {
            this.bd = a;
            this.g("MinorTickCount");
        }
        get scaleBrush() {
            return this.e4;
        }
        set scaleBrush(a) {
            this.e4 = a;
            this.g("ScaleBrush");
        }
        get backingBrush() {
            return this.ea;
        }
        set backingBrush(a) {
            this.ea = a;
            this.g("BackingBrush");
        }
        get backingOutline() {
            return this.eb;
        }
        set backingOutline(a) {
            this.eb = a;
            this.g("BackingOutline");
        }
        get backingStrokeThickness() {
            return this.az;
        }
        set backingStrokeThickness(a) {
            this.az = a;
            this.g("BackingStrokeThickness");
        }
        get backingOuterExtent() {
            return this.ax;
        }
        set backingOuterExtent(a) {
            this.ax = a;
            this.g("BackingOuterExtent");
        }
        get backingOversweep() {
            return this.ay;
        }
        set backingOversweep(a) {
            this.ay = a;
            this.g("BackingOversweep");
        }
        get scaleOversweep() {
            return this.bz;
        }
        set scaleOversweep(a) {
            this.bz = a;
            this.g("ScaleOversweep");
        }
        get scaleOversweepShape() {
            return this.e5;
        }
        set scaleOversweepShape(a) {
            this.e5 = a;
            this.g("ScaleOversweepShape");
        }
        get backingCornerRadius() {
            return this.av;
        }
        set backingCornerRadius(a) {
            this.av = a;
            this.g("BackingCornerRadius");
        }
        get backingInnerExtent() {
            return this.aw;
        }
        set backingInnerExtent(a) {
            this.aw = a;
            this.g("BackingInnerExtent");
        }
        get backingShape() {
            return this.ec;
        }
        set backingShape(a) {
            this.ec = a;
            this.g("BackingShape");
        }
        get ranges() {
            return this.l;
        }
        set ranges(a) {
            this.l = a;
            this.g("Ranges");
        }
        get radiusMultiplier() {
            return this.bw;
        }
        set radiusMultiplier(a) {
            this.bw = a;
            this.g("RadiusMultiplier");
        }
        get duplicateLabelOmissionStrategy() {
            return this.ed;
        }
        set duplicateLabelOmissionStrategy(a) {
            this.ed = a;
            this.g("DuplicateLabelOmissionStrategy");
        }
        get isNeedleDraggingEnabled() {
            return this.aa;
        }
        set isNeedleDraggingEnabled(a) {
            this.aa = a;
            this.g("IsNeedleDraggingEnabled");
        }
        get isNeedleDraggingConstrained() {
            return this.z;
        }
        set isNeedleDraggingConstrained(a) {
            this.z = a;
            this.g("IsNeedleDraggingConstrained");
        }
        get isHighlightNeedleDraggingEnabled() {
            return this.y;
        }
        set isHighlightNeedleDraggingEnabled(a) {
            this.y = a;
            this.g("IsHighlightNeedleDraggingEnabled");
        }
        get isHighlightNeedleDraggingConstrained() {
            return this.x;
        }
        set isHighlightNeedleDraggingConstrained(a) {
            this.x = a;
            this.g("IsHighlightNeedleDraggingConstrained");
        }
        get font() {
            return this.ee;
        }
        set font(a) {
            this.ee = a;
            this.g("Font");
        }
        get labelFormat() {
            return this.ew;
        }
        set labelFormat(a) {
            this.ew = a;
            this.g("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.i;
        }
        set labelFormatSpecifiers(a) {
            this.i = a;
            this.g("LabelFormatSpecifiers");
        }
        get transitionProgress() {
            return this.cb;
        }
        set transitionProgress(a) {
            this.cb = a;
            this.g("TransitionProgress");
        }
        get pixelScalingRatio() {
            return this.bv;
        }
        set pixelScalingRatio(a) {
            this.bv = a;
            this.g("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.au;
        }
        set actualPixelScalingRatio(a) {
            this.au = a;
            this.g("ActualPixelScalingRatio");
        }
        get opticalScalingRatio() {
            return this.bt;
        }
        set opticalScalingRatio(a) {
            this.bt = a;
            this.g("OpticalScalingRatio");
        }
        get opticalScalingEnabled() {
            return this.ab;
        }
        set opticalScalingEnabled(a) {
            this.ab = a;
            this.g("OpticalScalingEnabled");
        }
        get opticalScalingSize() {
            return this.bu;
        }
        set opticalScalingSize(a) {
            this.bu = a;
            this.g("OpticalScalingSize");
        }
        get titleText() {
            return this.fj;
        }
        set titleText(a) {
            this.fj = a;
            this.g("TitleText");
        }
        get subtitleText() {
            return this.fc;
        }
        set subtitleText(a) {
            this.fc = a;
            this.g("SubtitleText");
        }
        get titleAngle() {
            return this.b8;
        }
        set titleAngle(a) {
            this.b8 = a;
            this.g("TitleAngle");
        }
        get subtitleAngle() {
            return this.b2;
        }
        set subtitleAngle(a) {
            this.b2 = a;
            this.g("SubtitleAngle");
        }
        get titleExtent() {
            return this.b9;
        }
        set titleExtent(a) {
            this.b9 = a;
            this.g("TitleExtent");
        }
        get subtitleExtent() {
            return this.b3;
        }
        set subtitleExtent(a) {
            this.b3 = a;
            this.g("SubtitleExtent");
        }
        get titleBrush() {
            return this.fe;
        }
        set titleBrush(a) {
            this.fe = a;
            this.g("TitleBrush");
        }
        get subtitleBrush() {
            return this.e7;
        }
        set subtitleBrush(a) {
            this.e7 = a;
            this.g("SubtitleBrush");
        }
        get titleDisplaysValue() {
            return this.ae;
        }
        set titleDisplaysValue(a) {
            this.ae = a;
            this.g("TitleDisplaysValue");
        }
        get subtitleDisplaysValue() {
            return this.ac;
        }
        set subtitleDisplaysValue(a) {
            this.ac = a;
            this.g("SubtitleDisplaysValue");
        }
        get titleSnapsToNeedlePivot() {
            return this.af;
        }
        set titleSnapsToNeedlePivot(a) {
            this.af = a;
            this.g("TitleSnapsToNeedlePivot");
        }
        get subtitleSnapsToNeedlePivot() {
            return this.ad;
        }
        set subtitleSnapsToNeedlePivot(a) {
            this.ad = a;
            this.g("SubtitleSnapsToNeedlePivot");
        }
        get subtitleFormat() {
            return this.fb;
        }
        set subtitleFormat(a) {
            this.fb = a;
            this.g("SubtitleFormat");
        }
        get subtitleFormatSpecifiers() {
            return this.m;
        }
        set subtitleFormatSpecifiers(a) {
            this.m = a;
            this.g("SubtitleFormatSpecifiers");
        }
        get titleFormat() {
            return this.fi;
        }
        set titleFormat(a) {
            this.fi = a;
            this.g("TitleFormat");
        }
        get titleFormatSpecifiers() {
            return this.n;
        }
        set titleFormatSpecifiers(a) {
            this.n = a;
            this.g("TitleFormatSpecifiers");
        }
        get highlightLabelText() {
            return this.et;
        }
        set highlightLabelText(a) {
            this.et = a;
            this.g("HighlightLabelText");
        }
        get highlightLabelAngle() {
            return this.a3;
        }
        set highlightLabelAngle(a) {
            this.a3 = a;
            this.g("HighlightLabelAngle");
        }
        get highlightLabelExtent() {
            return this.a4;
        }
        set highlightLabelExtent(a) {
            this.a4 = a;
            this.g("HighlightLabelExtent");
        }
        get highlightLabelBrush() {
            return this.eo;
        }
        set highlightLabelBrush(a) {
            this.eo = a;
            this.g("HighlightLabelBrush");
        }
        get highlightLabelDisplaysValue() {
            return this.v;
        }
        set highlightLabelDisplaysValue(a) {
            this.v = a;
            this.g("HighlightLabelDisplaysValue");
        }
        get highlightLabelSnapsToNeedlePivot() {
            return this.w;
        }
        set highlightLabelSnapsToNeedlePivot(a) {
            this.w = a;
            this.g("HighlightLabelSnapsToNeedlePivot");
        }
        get highlightLabelFormat() {
            return this.es;
        }
        set highlightLabelFormat(a) {
            this.es = a;
            this.g("HighlightLabelFormat");
        }
        get highlightLabelFormatSpecifiers() {
            return this.h;
        }
        set highlightLabelFormatSpecifiers(a) {
            this.h = a;
            this.g("HighlightLabelFormatSpecifiers");
        }
        get highlightLabelFontFamily() {
            return this.ep;
        }
        set highlightLabelFontFamily(a) {
            this.ep = a;
            this.g("HighlightLabelFontFamily");
        }
        get highlightLabelFontSize() {
            return this.a5;
        }
        set highlightLabelFontSize(a) {
            this.a5 = a;
            this.g("HighlightLabelFontSize");
        }
        get highlightLabelFontStyle() {
            return this.eq;
        }
        set highlightLabelFontStyle(a) {
            this.eq = a;
            this.g("HighlightLabelFontStyle");
        }
        get highlightLabelFontWeight() {
            return this.er;
        }
        set highlightLabelFontWeight(a) {
            this.er = a;
            this.g("HighlightLabelFontWeight");
        }
        get subtitleFontFamily() {
            return this.e8;
        }
        set subtitleFontFamily(a) {
            this.e8 = a;
            this.g("SubtitleFontFamily");
        }
        get subtitleFontSize() {
            return this.b4;
        }
        set subtitleFontSize(a) {
            this.b4 = a;
            this.g("SubtitleFontSize");
        }
        get subtitleFontStyle() {
            return this.e9;
        }
        set subtitleFontStyle(a) {
            this.e9 = a;
            this.g("SubtitleFontStyle");
        }
        get subtitleFontWeight() {
            return this.fa;
        }
        set subtitleFontWeight(a) {
            this.fa = a;
            this.g("SubtitleFontWeight");
        }
        get titleFontFamily() {
            return this.ff;
        }
        set titleFontFamily(a) {
            this.ff = a;
            this.g("TitleFontFamily");
        }
        get titleFontSize() {
            return this.ca;
        }
        set titleFontSize(a) {
            this.ca = a;
            this.g("TitleFontSize");
        }
        get titleFontStyle() {
            return this.fg;
        }
        set titleFontStyle(a) {
            this.fg = a;
            this.g("TitleFontStyle");
        }
        get titleFontWeight() {
            return this.fh;
        }
        set titleFontWeight(a) {
            this.fh = a;
            this.g("TitleFontWeight");
        }
        get alignTitleRef() {
            return this.d8;
        }
        set alignTitleRef(a) {
            this.d8 = a;
            this.g("AlignTitleRef");
        }
        get alignSubtitleRef() {
            return this.d7;
        }
        set alignSubtitleRef(a) {
            this.d7 = a;
            this.g("AlignSubtitleRef");
        }
        get alignHighlightLabelRef() {
            return this.d5;
        }
        set alignHighlightLabelRef(a) {
            this.d5 = a;
            this.g("AlignHighlightLabelRef");
        }
        get formatTitleRef() {
            return this.em;
        }
        set formatTitleRef(a) {
            this.em = a;
            this.g("FormatTitleRef");
        }
        get formatSubtitleRef() {
            return this.el;
        }
        set formatSubtitleRef(a) {
            this.el = a;
            this.g("FormatSubtitleRef");
        }
        get formatHighlightLabelRef() {
            return this.ej;
        }
        set formatHighlightLabelRef(a) {
            this.ej = a;
            this.g("FormatHighlightLabelRef");
        }
        get formatLabelRef() {
            return this.ek;
        }
        set formatLabelRef(a) {
            this.ek = a;
            this.g("FormatLabelRef");
        }
        get alignLabelRef() {
            return this.d6;
        }
        set alignLabelRef(a) {
            this.d6 = a;
            this.g("AlignLabelRef");
        }
        get valueChangedRef() {
            return this.fl;
        }
        set valueChangedRef(a) {
            this.fl = a;
            this.g("ValueChangedRef");
        }
        get highlightValueChangedRef() {
            return this.eu;
        }
        set highlightValueChangedRef(a) {
            this.eu = a;
            this.g("HighlightValueChangedRef");
        }
        get actualMinimumValueChangeRef() {
            return this.d4;
        }
        set actualMinimumValueChangeRef(a) {
            this.d4 = a;
            this.g("ActualMinimumValueChangeRef");
        }
        get actualMaximumValueChangeRef() {
            return this.d3;
        }
        set actualMaximumValueChangeRef(a) {
            this.d3 = a;
            this.g("ActualMaximumValueChangeRef");
        }
    }
    RadialGaugeDescription.$t = /*@__PURE__*/ markType(RadialGaugeDescription, 'RadialGaugeDescription', Description.$);
    return RadialGaugeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialGaugeDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialGaugeDescriptionMetadata extends Base {
        static e(a) {
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:TextStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:TextStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontStyle/FontStyleTransform,wf:FontStyle/FontStyleTransform,web:TextStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontStyle/FontWeightTransform,wf:FontStyle/FontWeightTransform,web:TextStyle/FontWeightTransform)String");
            a.item("_qualifiedName", "String:Infragistics.Controls.Gauges.XamRadialGauge");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
            a.item("LegendRef", "(w:Legend)DataRef:String");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (RadialGaugeDescriptionMetadata.a == null) {
                RadialGaugeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialGaugeDescriptionMetadata.c(RadialGaugeDescriptionMetadata.a);
            }
            if (a.k(RadialGaugeDescriptionMetadata.a)) {
                return;
            }
            a.ac(RadialGaugeDescriptionMetadata.a);
            AlignRadialGaugeLabelEventArgsDescriptionMetadata.d(a);
            FormatRadialGaugeLabelEventArgsDescriptionMetadata.d(a);
            DoubleValueChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("RangeBrushes", "BrushCollection:string");
            a.item("RangeOutlines", "BrushCollection:string");
            a.item("MinimumValue", "Number:double");
            a.item("ActualMinimumValue", "Number:double");
            a.item("MaximumValue", "Number:double");
            a.item("ActualMaximumValue", "Number:double");
            a.item("Interval", "Number:double");
            a.item("CenterX", "Number:double");
            a.item("CenterY", "Number:double");
            a.item("Value", "Number:double");
            a.item("HighlightValue", "Number:double");
            a.item("ActualHighlightValueOpacity", "Number:double");
            a.item("HighlightValueOpacity", "Number:double");
            a.item("ActualHighlightValueDisplayMode", "ExportedType:string:HighlightedValueDisplayMode");
            a.item("ActualHighlightValueDisplayMode@names", "Auto;Hidden;Overlay");
            a.item("HighlightValueDisplayMode", "ExportedType:string:HighlightedValueDisplayMode");
            a.item("HighlightValueDisplayMode@names", "Auto;Hidden;Overlay");
            a.item("ScaleStartAngle", "Number:double");
            a.item("ScaleEndAngle", "Number:double");
            a.item("ScaleSweepDirection", "ExportedType:string:SweepDirection");
            a.item("ScaleSweepDirection@names", "Counterclockwise;Clockwise");
            a.item("TransitionDuration", "Number:int");
            a.item("TransitionEasingFunctionRef", "(w:TransitionEasingFunction,wf:TransitionEasingFunction)MethodRef");
            a.item("NeedleBrush", "Brush");
            a.item("NeedleOutline", "Brush");
            a.item("NeedleStartExtent", "Number:double");
            a.item("NeedleEndExtent", "Number:double");
            a.item("NeedleShape", "ExportedType:string:RadialGaugeNeedleShape");
            a.item("NeedleShape@names", "None;Rectangle;Triangle;Needle;Trapezoid;RectangleWithBulb;TriangleWithBulb;NeedleWithBulb;TrapezoidWithBulb");
            a.item("NeedleStartWidthRatio", "Number:double");
            a.item("NeedleEndWidthRatio", "Number:double");
            a.item("NeedleBaseFeatureWidthRatio", "Number:double");
            a.item("NeedleBaseFeatureExtent", "Number:double");
            a.item("NeedlePointFeatureWidthRatio", "Number:double");
            a.item("NeedlePointFeatureExtent", "Number:double");
            a.item("NeedlePivotWidthRatio", "Number:double");
            a.item("NeedlePivotInnerWidthRatio", "Number:double");
            a.item("NeedlePivotShape", "ExportedType:string:RadialGaugePivotShape");
            a.item("NeedlePivotShape@names", "None;Circle;CircleWithHole;CircleOverlay;CircleOverlayWithHole;CircleUnderlay;CircleUnderlayWithHole");
            a.item("ScaleStartExtent", "Number:double");
            a.item("NeedlePivotBrush", "Brush");
            a.item("NeedlePivotOutline", "Brush");
            a.item("NeedleStrokeThickness", "Number:double");
            a.item("NeedlePivotStrokeThickness", "Number:double");
            a.item("ScaleEndExtent", "Number:double");
            a.item("LabelExtent", "Number:double");
            a.item("LabelInterval", "Number:double");
            a.item("TickStartExtent", "Number:double");
            a.item("TickEndExtent", "Number:double");
            a.item("TickStrokeThickness", "Number:double");
            a.item("TickBrush", "Brush");
            a.item("FontBrush", "Brush");
            a.item("MinorTickStartExtent", "Number:double");
            a.item("MinorTickEndExtent", "Number:double");
            a.item("MinorTickStrokeThickness", "Number:double");
            a.item("MinorTickBrush", "Brush");
            a.item("MinorTickCount", "Number:double");
            a.item("ScaleBrush", "Brush");
            a.item("BackingBrush", "Brush");
            a.item("BackingOutline", "Brush");
            a.item("BackingStrokeThickness", "Number:double");
            a.item("BackingOuterExtent", "Number:double");
            a.item("BackingOversweep", "Number:double");
            a.item("ScaleOversweep", "Number:double");
            a.item("ScaleOversweepShape", "ExportedType:string:RadialGaugeScaleOversweepShape");
            a.item("ScaleOversweepShape@names", "Auto;Circular;Fitted");
            a.item("BackingCornerRadius", "Number:double");
            a.item("BackingInnerExtent", "Number:double");
            a.item("BackingShape", "ExportedType:string:RadialGaugeBackingShape");
            a.item("BackingShape@names", "Circular;Fitted");
            a.item("Ranges", "Collection:RadialGaugeRange:RadialGaugeRangeCollection:RadialGaugeRange");
            a.item("RadiusMultiplier", "Number:double");
            a.item("DuplicateLabelOmissionStrategy", "ExportedType:string:RadialGaugeDuplicateLabelOmissionStrategy");
            a.item("DuplicateLabelOmissionStrategy@names", "OmitLast;OmitFirst;OmitNeither;OmitBoth");
            a.item("IsNeedleDraggingEnabled", "Boolean");
            a.item("IsNeedleDraggingConstrained", "Boolean");
            a.item("IsHighlightNeedleDraggingEnabled", "Boolean");
            a.item("IsHighlightNeedleDraggingConstrained", "Boolean");
            a.item("Font", "String");
            a.item("LabelFormat", "String");
            a.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("TransitionProgress", "Number:double");
            a.item("PixelScalingRatio", "Number:double");
            a.item("ActualPixelScalingRatio", "Number:double");
            a.item("OpticalScalingRatio", "Number:double");
            a.item("OpticalScalingEnabled", "Boolean");
            a.item("OpticalScalingSize", "Number:double");
            a.item("TitleText", "String");
            a.item("SubtitleText", "String");
            a.item("TitleAngle", "Number:double");
            a.item("SubtitleAngle", "Number:double");
            a.item("TitleExtent", "Number:double");
            a.item("SubtitleExtent", "Number:double");
            a.item("TitleBrush", "Brush");
            a.item("SubtitleBrush", "Brush");
            a.item("TitleDisplaysValue", "Boolean");
            a.item("SubtitleDisplaysValue", "Boolean");
            a.item("TitleSnapsToNeedlePivot", "Boolean");
            a.item("SubtitleSnapsToNeedlePivot", "Boolean");
            a.item("SubtitleFormat", "String");
            a.item("SubtitleFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("SubtitleFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("TitleFormat", "String");
            a.item("TitleFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("TitleFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("HighlightLabelText", "String");
            a.item("HighlightLabelAngle", "Number:double");
            a.item("HighlightLabelExtent", "Number:double");
            a.item("HighlightLabelBrush", "Brush");
            a.item("HighlightLabelDisplaysValue", "Boolean");
            a.item("HighlightLabelSnapsToNeedlePivot", "Boolean");
            a.item("HighlightLabelFormat", "String");
            a.item("HighlightLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("HighlightLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("HighlightLabelFontFamily", "(w:HighlightLabelFontFamily/FontFamilyTransform,xam:HighlightLabelFontFamily,wf:HighlightLabelFontFamily,web:highlightLabelTextStyle/FontFamilyTransform)String");
            a.item("HighlightLabelFontSize", "(w:HighlightLabelFontSize,xam:HighlightLabelFontSize,wf:HighlightLabelFontSize,web:highlightLabelTextStyle/FontSizeTransform)Number:double");
            a.item("HighlightLabelFontStyle", "(w:HighlightLabelFontStyle/FontStyleTransform,xam:HighlightLabelFontFamily/FontStyleTransform,wf:HighlightLabelFontFamily/FontStyleTransform,web:highlightLabelTextStyle/FontStyleTransform)String");
            a.item("HighlightLabelFontWeight", "(w:HighlightLabelFontWeight/FontWeightTransform,xam:HighlightLabelFontFamily/FontWeightTransform,wf:HighlightLabelFontFamily/FontWeightTransform,web:highlightLabelTextStyle/FontWeightTransform)String");
            a.item("SubtitleFontFamily", "(w:SubtitleFontFamily/FontFamilyTransform,xam:SubtitleFontFamily,wf:SubtitleFontFamily,web:subtitleTextStyle/FontFamilyTransform)String");
            a.item("SubtitleFontSize", "(w:SubtitleFontSize,xam:SubtitleFontSize,wf:SubtitleFontSize,web:subtitleTextStyle/FontSizeTransform)Number:double");
            a.item("SubtitleFontStyle", "(w:SubtitleFontStyle/FontStyleTransform,xam:SubtitleFontFamily/FontStyleTransform,wf:SubtitleFontFamily/FontStyleTransform,web:subtitleTextStyle/FontStyleTransform)String");
            a.item("SubtitleFontWeight", "(w:SubtitleFontWeight/FontWeightTransform,xam:SubtitleFontFamily/FontWeightTransform,wf:SubtitleFontFamily/FontWeightTransform,web:subtitleTextStyle/FontWeightTransform)String");
            a.item("TitleFontFamily", "(w:TitleFontFamily/FontFamilyTransform,xam:TitleFontFamily,wf:TitleFontFamily,web:titleTextStyle/FontFamilyTransform)String");
            a.item("TitleFontSize", "(w:TitleFontSize,xam:TitleFontSize,wf:TitleFontSize,web:titleTextStyle/FontSizeTransform)Number:double");
            a.item("TitleFontStyle", "(w:TitleFontStyle/FontStyleTransform,xam:TitleFontFamily/FontStyleTransform,wf:TitleFontFamily/FontStyleTransform,web:titleTextStyle/FontStyleTransform)String");
            a.item("TitleFontWeight", "(w:TitleFontWeight/FontWeightTransform,xam:TitleFontFamily/FontWeightTransform,wf:TitleFontFamily/FontWeightTransform,web:titleTextStyle/FontWeightTransform)String");
            a.item("AlignTitleRef", "EventRef::alignTitle");
            a.item("AlignSubtitleRef", "EventRef::alignSubtitle");
            a.item("AlignHighlightLabelRef", "EventRef::alignHighlightLabel");
            a.item("FormatTitleRef", "EventRef::formatTitle");
            a.item("FormatSubtitleRef", "EventRef::formatSubtitle");
            a.item("FormatHighlightLabelRef", "EventRef::formatHighlightLabel");
            a.item("FormatLabelRef", "EventRef::formatLabel");
            a.item("AlignLabelRef", "EventRef::alignLabel");
            a.item("ValueChangedRef", "EventRef::valueChanged");
            a.item("HighlightValueChangedRef", "EventRef::highlightValueChanged");
            a.item("ActualMinimumValueChangeRef", "EventRef::actualMinimumValueChange");
            a.item("ActualMaximumValueChangeRef", "EventRef::actualMaximumValueChange");
            RadialGaugeDescriptionMetadata.e(a);
        }
        static d(a) {
            RadialGaugeDescriptionMetadata.b(a);
            a.ae("RadialGauge", () => new RadialGaugeDescription());
            a.ad("RadialGauge", RadialGaugeDescriptionMetadata.a);
        }
    }
    RadialGaugeDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialGaugeDescriptionMetadata, 'RadialGaugeDescriptionMetadata');
    RadialGaugeDescriptionMetadata.a = null;
    return RadialGaugeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialGaugeRangeDescription = /*@__PURE__*/ (() => {
    class RadialGaugeRangeDescription extends Description {
        get_type() {
            return "RadialGaugeRange";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.w = null;
            this.v = null;
            this.x = null;
            this.m = 0;
            this.h = 0;
            this.j = 0;
            this.i = 0;
            this.l = 0;
            this.k = 0;
            this.n = 0;
        }
        get name() {
            return this.w;
        }
        set name(a) {
            this.w = a;
            this.g("Name");
        }
        get brush() {
            return this.v;
        }
        set brush(a) {
            this.v = a;
            this.g("Brush");
        }
        get outline() {
            return this.x;
        }
        set outline(a) {
            this.x = a;
            this.g("Outline");
        }
        get startValue() {
            return this.m;
        }
        set startValue(a) {
            this.m = a;
            this.g("StartValue");
        }
        get endValue() {
            return this.h;
        }
        set endValue(a) {
            this.h = a;
            this.g("EndValue");
        }
        get innerStartExtent() {
            return this.j;
        }
        set innerStartExtent(a) {
            this.j = a;
            this.g("InnerStartExtent");
        }
        get innerEndExtent() {
            return this.i;
        }
        set innerEndExtent(a) {
            this.i = a;
            this.g("InnerEndExtent");
        }
        get outerStartExtent() {
            return this.l;
        }
        set outerStartExtent(a) {
            this.l = a;
            this.g("OuterStartExtent");
        }
        get outerEndExtent() {
            return this.k;
        }
        set outerEndExtent(a) {
            this.k = a;
            this.g("OuterEndExtent");
        }
        get strokeThickness() {
            return this.n;
        }
        set strokeThickness(a) {
            this.n = a;
            this.g("StrokeThickness");
        }
    }
    RadialGaugeRangeDescription.$t = /*@__PURE__*/ markType(RadialGaugeRangeDescription, 'RadialGaugeRangeDescription', Description.$);
    return RadialGaugeRangeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialGaugeRangeDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialGaugeRangeDescriptionMetadata extends Base {
        static b(a) {
            if (RadialGaugeRangeDescriptionMetadata.a == null) {
                RadialGaugeRangeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialGaugeRangeDescriptionMetadata.c(RadialGaugeRangeDescriptionMetadata.a);
            }
            if (a.k(RadialGaugeRangeDescriptionMetadata.a)) {
                return;
            }
            a.ac(RadialGaugeRangeDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Name", "String");
            a.item("Brush", "Brush");
            a.item("Outline", "Brush");
            a.item("StartValue", "Number:double");
            a.item("EndValue", "Number:double");
            a.item("InnerStartExtent", "Number:double");
            a.item("InnerEndExtent", "Number:double");
            a.item("OuterStartExtent", "Number:double");
            a.item("OuterEndExtent", "Number:double");
            a.item("StrokeThickness", "Number:double");
        }
        static d(a) {
            RadialGaugeRangeDescriptionMetadata.b(a);
            a.ae("RadialGaugeRange", () => new RadialGaugeRangeDescription());
            a.ad("RadialGaugeRange", RadialGaugeRangeDescriptionMetadata.a);
        }
    }
    RadialGaugeRangeDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialGaugeRangeDescriptionMetadata, 'RadialGaugeRangeDescriptionMetadata');
    RadialGaugeRangeDescriptionMetadata.a = null;
    return RadialGaugeRangeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialGaugeRangeDescriptionModule = /*@__PURE__*/ (() => {
    class RadialGaugeRangeDescriptionModule extends Base {
        static register(a) {
            RadialGaugeRangeDescriptionMetadata.d(a);
        }
    }
    RadialGaugeRangeDescriptionModule.$t = /*@__PURE__*/ markType(RadialGaugeRangeDescriptionModule, 'RadialGaugeRangeDescriptionModule');
    return RadialGaugeRangeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialGaugeCoreDescriptionModule = /*@__PURE__*/ (() => {
    class RadialGaugeCoreDescriptionModule extends Base {
        static register(a) {
            RadialGaugeDescriptionMetadata.d(a);
            RadialGaugeRangeDescriptionModule.register(a);
            NumberFormatSpecifierDescriptionModule.register(a);
        }
    }
    RadialGaugeCoreDescriptionModule.$t = /*@__PURE__*/ markType(RadialGaugeCoreDescriptionModule, 'RadialGaugeCoreDescriptionModule');
    return RadialGaugeCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialGaugeDescriptionModule = /*@__PURE__*/ (() => {
    class RadialGaugeDescriptionModule extends Base {
        static register(a) {
            RadialGaugeCoreDescriptionModule.register(a);
            DVInteractivityDescriptionModule.register(a);
        }
    }
    RadialGaugeDescriptionModule.$t = /*@__PURE__*/ markType(RadialGaugeDescriptionModule, 'RadialGaugeDescriptionModule');
    return RadialGaugeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScaleLegendDescription = /*@__PURE__*/ (() => {
    class ScaleLegendDescription extends LegendBaseDescription {
        get_type() {
            return "ScaleLegend";
        }
        constructor() {
            super();
        }
    }
    ScaleLegendDescription.$t = /*@__PURE__*/ markType(ScaleLegendDescription, 'ScaleLegendDescription', LegendBaseDescription.$);
    return ScaleLegendDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScaleLegendDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScaleLegendDescriptionMetadata extends Base {
        static b(a) {
            if (ScaleLegendDescriptionMetadata.a == null) {
                ScaleLegendDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScaleLegendDescriptionMetadata.c(ScaleLegendDescriptionMetadata.a);
            }
            if (a.k(ScaleLegendDescriptionMetadata.a)) {
                return;
            }
            a.ac(ScaleLegendDescriptionMetadata.a);
        }
        static c(a) {
            LegendBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            ScaleLegendDescriptionMetadata.b(a);
            a.ae("ScaleLegend", () => new ScaleLegendDescription());
            a.ad("ScaleLegend", ScaleLegendDescriptionMetadata.a);
        }
    }
    ScaleLegendDescriptionMetadata.$t = /*@__PURE__*/ markType(ScaleLegendDescriptionMetadata, 'ScaleLegendDescriptionMetadata');
    ScaleLegendDescriptionMetadata.a = null;
    return ScaleLegendDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScaleLegendDescriptionModule = /*@__PURE__*/ (() => {
    class ScaleLegendDescriptionModule extends Base {
        static register(a) {
            ScaleLegendDescriptionMetadata.d(a);
        }
    }
    ScaleLegendDescriptionModule.$t = /*@__PURE__*/ markType(ScaleLegendDescriptionModule, 'ScaleLegendDescriptionModule');
    return ScaleLegendDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionInformationDescription = /*@__PURE__*/ (() => {
    class SectionInformationDescription extends Description {
        get_type() {
            return "SectionInformation";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    SectionInformationDescription.$t = /*@__PURE__*/ markType(SectionInformationDescription, 'SectionInformationDescription', Description.$);
    SectionInformationDescription.__marshalByValue = true;
    SectionInformationDescription.__marshalByValueAlias = "DefaultSectionInformation";
    return SectionInformationDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionInformationDescriptionMetadata = /*@__PURE__*/ (() => {
    class SectionInformationDescriptionMetadata extends Base {
        static b(a) {
            if (SectionInformationDescriptionMetadata.a == null) {
                SectionInformationDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SectionInformationDescriptionMetadata.c(SectionInformationDescriptionMetadata.a);
            }
            if (a.k(SectionInformationDescriptionMetadata.a)) {
                return;
            }
            a.ac(SectionInformationDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
        }
        static d(a) {
            SectionInformationDescriptionMetadata.b(a);
            a.ae("SectionInformation", () => new SectionInformationDescription());
            a.ad("SectionInformation", SectionInformationDescriptionMetadata.a);
        }
    }
    SectionInformationDescriptionMetadata.$t = /*@__PURE__*/ markType(SectionInformationDescriptionMetadata, 'SectionInformationDescriptionMetadata');
    SectionInformationDescriptionMetadata.a = null;
    return SectionInformationDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesLayerDescription = /*@__PURE__*/ (() => {
    class SeriesLayerDescription extends Description {
        get_type() {
            return "SeriesLayer";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = 0;
            this.h = null;
        }
        get zIndex() {
            return this.j;
        }
        set zIndex(a) {
            this.j = a;
            this.g("ZIndex");
        }
        get propertyOverlays() {
            return this.h;
        }
        set propertyOverlays(a) {
            this.h = a;
            this.g("PropertyOverlays");
        }
    }
    SeriesLayerDescription.$t = /*@__PURE__*/ markType(SeriesLayerDescription, 'SeriesLayerDescription', Description.$);
    return SeriesLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class SeriesLayerDescriptionMetadata extends Base {
        static b(a) {
            if (SeriesLayerDescriptionMetadata.a == null) {
                SeriesLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SeriesLayerDescriptionMetadata.c(SeriesLayerDescriptionMetadata.a);
            }
            if (a.k(SeriesLayerDescriptionMetadata.a)) {
                return;
            }
            a.ac(SeriesLayerDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ZIndex", "Number:double");
            a.item("PropertyOverlays", "Collection:SeriesLayerPropertyOverlay:SeriesLayerPropertyOverlayCollection:SeriesLayerPropertyOverlay");
        }
        static d(a) {
            SeriesLayerDescriptionMetadata.b(a);
            a.ae("SeriesLayer", () => new SeriesLayerDescription());
            a.ad("SeriesLayer", SeriesLayerDescriptionMetadata.a);
        }
    }
    SeriesLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(SeriesLayerDescriptionMetadata, 'SeriesLayerDescriptionMetadata');
    SeriesLayerDescriptionMetadata.a = null;
    return SeriesLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesLayerPropertyOverlayDescription = /*@__PURE__*/ (() => {
    class SeriesLayerPropertyOverlayDescription extends Description {
        get_type() {
            return "SeriesLayerPropertyOverlay";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = false;
            this.h = false;
            this.m = null;
            this.l = null;
            this.o = null;
            this.n = null;
            this.p = null;
        }
        get isSourceOverlay() {
            return this.i;
        }
        set isSourceOverlay(a) {
            this.i = a;
            this.g("IsSourceOverlay");
        }
        get isAlwaysApplied() {
            return this.h;
        }
        set isAlwaysApplied(a) {
            this.h = a;
            this.g("IsAlwaysApplied");
        }
        get propertyName() {
            return this.m;
        }
        set propertyName(a) {
            this.m = a;
            this.g("PropertyName");
        }
        get currentValuePropertyName() {
            return this.l;
        }
        set currentValuePropertyName(a) {
            this.l = a;
            this.g("CurrentValuePropertyName");
        }
        get valueRef() {
            return this.o;
        }
        set valueRef(a) {
            this.o = a;
            this.g("ValueRef");
        }
        get propertyUpdatedRef() {
            return this.n;
        }
        set propertyUpdatedRef(a) {
            this.n = a;
            this.g("PropertyUpdatedRef");
        }
        get valueResolvingRef() {
            return this.p;
        }
        set valueResolvingRef(a) {
            this.p = a;
            this.g("ValueResolvingRef");
        }
    }
    SeriesLayerPropertyOverlayDescription.$t = /*@__PURE__*/ markType(SeriesLayerPropertyOverlayDescription, 'SeriesLayerPropertyOverlayDescription', Description.$);
    return SeriesLayerPropertyOverlayDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesLayerPropertyOverlayValueResolvingEventArgsDescription = /*@__PURE__*/ (() => {
    class SeriesLayerPropertyOverlayValueResolvingEventArgsDescription extends Description {
        get_type() {
            return "SeriesLayerPropertyOverlayValueResolvingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get valueRef() {
            return this.h;
        }
        set valueRef(a) {
            this.h = a;
            this.g("ValueRef");
        }
    }
    SeriesLayerPropertyOverlayValueResolvingEventArgsDescription.$t = /*@__PURE__*/ markType(SeriesLayerPropertyOverlayValueResolvingEventArgsDescription, 'SeriesLayerPropertyOverlayValueResolvingEventArgsDescription', Description.$);
    return SeriesLayerPropertyOverlayValueResolvingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata.a == null) {
                SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata.c(SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata.a);
            }
            if (a.k(SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
        }
        static d(a) {
            SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata.b(a);
            a.ae("SeriesLayerPropertyOverlayValueResolvingEventArgs", () => new SeriesLayerPropertyOverlayValueResolvingEventArgsDescription());
            a.ad("SeriesLayerPropertyOverlayValueResolvingEventArgs", SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata.a);
        }
    }
    SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata, 'SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata');
    SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata.a = null;
    return SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesLayerPropertyOverlayDescriptionMetadata = /*@__PURE__*/ (() => {
    class SeriesLayerPropertyOverlayDescriptionMetadata extends Base {
        static b(a) {
            if (SeriesLayerPropertyOverlayDescriptionMetadata.a == null) {
                SeriesLayerPropertyOverlayDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SeriesLayerPropertyOverlayDescriptionMetadata.c(SeriesLayerPropertyOverlayDescriptionMetadata.a);
            }
            if (a.k(SeriesLayerPropertyOverlayDescriptionMetadata.a)) {
                return;
            }
            a.ac(SeriesLayerPropertyOverlayDescriptionMetadata.a);
            PropertyUpdatedEventArgsDescriptionMetadata.d(a);
            SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("IsSourceOverlay", "Boolean");
            a.item("IsAlwaysApplied", "Boolean");
            a.item("PropertyName", "String");
            a.item("CurrentValuePropertyName", "String");
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
            a.item("PropertyUpdatedRef", "EventRef::propertyUpdated");
            a.item("ValueResolvingRef", "EventRef::valueResolving");
        }
        static d(a) {
            SeriesLayerPropertyOverlayDescriptionMetadata.b(a);
            a.ae("SeriesLayerPropertyOverlay", () => new SeriesLayerPropertyOverlayDescription());
            a.ad("SeriesLayerPropertyOverlay", SeriesLayerPropertyOverlayDescriptionMetadata.a);
        }
    }
    SeriesLayerPropertyOverlayDescriptionMetadata.$t = /*@__PURE__*/ markType(SeriesLayerPropertyOverlayDescriptionMetadata, 'SeriesLayerPropertyOverlayDescriptionMetadata');
    SeriesLayerPropertyOverlayDescriptionMetadata.a = null;
    return SeriesLayerPropertyOverlayDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesViewerSelectedSeriesItemsChangingEventArgsDescription = /*@__PURE__*/ (() => {
    class SeriesViewerSelectedSeriesItemsChangingEventArgsDescription extends SeriesViewerSelectedSeriesItemsChangedEventArgsDescription {
        get_type() {
            return "SeriesViewerSelectedSeriesItemsChangingEventArgs";
        }
        constructor() {
            super();
            this.o = false;
        }
        get cancel() {
            return this.o;
        }
        set cancel(a) {
            this.o = a;
            this.g("Cancel");
        }
    }
    SeriesViewerSelectedSeriesItemsChangingEventArgsDescription.$t = /*@__PURE__*/ markType(SeriesViewerSelectedSeriesItemsChangingEventArgsDescription, 'SeriesViewerSelectedSeriesItemsChangingEventArgsDescription', SeriesViewerSelectedSeriesItemsChangedEventArgsDescription.$);
    return SeriesViewerSelectedSeriesItemsChangingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata.a == null) {
                SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata.c(SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata.a);
            }
            if (a.k(SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata.c(a);
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata.b(a);
            a.ae("SeriesViewerSelectedSeriesItemsChangingEventArgs", () => new SeriesViewerSelectedSeriesItemsChangingEventArgsDescription());
            a.ad("SeriesViewerSelectedSeriesItemsChangingEventArgs", SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata.a);
        }
    }
    SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata, 'SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata');
    SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata.a = null;
    return SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SortIndicatorRenderCompletedEventArgsDescription = /*@__PURE__*/ (() => {
    class SortIndicatorRenderCompletedEventArgsDescription extends Description {
        get_type() {
            return "SortIndicatorRenderCompletedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    SortIndicatorRenderCompletedEventArgsDescription.$t = /*@__PURE__*/ markType(SortIndicatorRenderCompletedEventArgsDescription, 'SortIndicatorRenderCompletedEventArgsDescription', Description.$);
    return SortIndicatorRenderCompletedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SortIndicatorRenderCompletedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SortIndicatorRenderCompletedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SortIndicatorRenderCompletedEventArgsDescriptionMetadata.a == null) {
                SortIndicatorRenderCompletedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SortIndicatorRenderCompletedEventArgsDescriptionMetadata.c(SortIndicatorRenderCompletedEventArgsDescriptionMetadata.a);
            }
            if (a.k(SortIndicatorRenderCompletedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(SortIndicatorRenderCompletedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            SortIndicatorRenderCompletedEventArgsDescriptionMetadata.b(a);
            a.ae("SortIndicatorRenderCompletedEventArgs", () => new SortIndicatorRenderCompletedEventArgsDescription());
            a.ad("SortIndicatorRenderCompletedEventArgs", SortIndicatorRenderCompletedEventArgsDescriptionMetadata.a);
        }
    }
    SortIndicatorRenderCompletedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SortIndicatorRenderCompletedEventArgsDescriptionMetadata, 'SortIndicatorRenderCompletedEventArgsDescriptionMetadata');
    SortIndicatorRenderCompletedEventArgsDescriptionMetadata.a = null;
    return SortIndicatorRenderCompletedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SparklineDescription = /*@__PURE__*/ (() => {
    class SparklineDescription extends Description {
        get_type() {
            return "Sparkline";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.as = null;
            this.bc = null;
            this.ba = null;
            this.bd = null;
            this.av = null;
            this.a6 = null;
            this.az = null;
            this.a8 = null;
            this.bh = null;
            this.a1 = null;
            this.bl = null;
            this.bf = null;
            this.a3 = null;
            this.bn = null;
            this.bb = null;
            this.be = null;
            this.aw = null;
            this.a7 = null;
            this.a9 = null;
            this.a0 = null;
            this.bg = null;
            this.l = false;
            this.t = 0;
            this.o = 0;
            this.q = 0;
            this.p = 0;
            this.s = 0;
            this.w = 0;
            this.r = 0;
            this.v = 0;
            this.u = 0;
            this.at = null;
            this.bk = null;
            this.a5 = null;
            this.bi = null;
            this.ap = 0;
            this.aa = 0;
            this.y = 0;
            this.x = 0;
            this.au = null;
            this.bj = null;
            this.bm = null;
            this.a2 = null;
            this.ax = null;
            this.a4 = null;
            this.h = null;
            this.bo = null;
            this.i = null;
            this.z = 0;
            this.n = 0;
            this.bp = null;
            this.ay = null;
            this.ar = null;
        }
        get brush() {
            return this.as;
        }
        set brush(a) {
            this.as = a;
            this.g("Brush");
        }
        get negativeBrush() {
            return this.bc;
        }
        set negativeBrush(a) {
            this.bc = a;
            this.g("NegativeBrush");
        }
        get markerBrush() {
            return this.ba;
        }
        set markerBrush(a) {
            this.ba = a;
            this.g("MarkerBrush");
        }
        get negativeMarkerBrush() {
            return this.bd;
        }
        set negativeMarkerBrush(a) {
            this.bd = a;
            this.g("NegativeMarkerBrush");
        }
        get firstMarkerBrush() {
            return this.av;
        }
        set firstMarkerBrush(a) {
            this.av = a;
            this.g("FirstMarkerBrush");
        }
        get lastMarkerBrush() {
            return this.a6;
        }
        set lastMarkerBrush(a) {
            this.a6 = a;
            this.g("LastMarkerBrush");
        }
        get highMarkerBrush() {
            return this.az;
        }
        set highMarkerBrush(a) {
            this.az = a;
            this.g("HighMarkerBrush");
        }
        get lowMarkerBrush() {
            return this.a8;
        }
        set lowMarkerBrush(a) {
            this.a8 = a;
            this.g("LowMarkerBrush");
        }
        get trendLineBrush() {
            return this.bh;
        }
        set trendLineBrush(a) {
            this.bh = a;
            this.g("TrendLineBrush");
        }
        get horizontalAxisBrush() {
            return this.a1;
        }
        set horizontalAxisBrush(a) {
            this.a1 = a;
            this.g("HorizontalAxisBrush");
        }
        get verticalAxisBrush() {
            return this.bl;
        }
        set verticalAxisBrush(a) {
            this.bl = a;
            this.g("VerticalAxisBrush");
        }
        get normalRangeFill() {
            return this.bf;
        }
        set normalRangeFill(a) {
            this.bf = a;
            this.g("NormalRangeFill");
        }
        get horizontalAxisVisibility() {
            return this.a3;
        }
        set horizontalAxisVisibility(a) {
            this.a3 = a;
            this.g("HorizontalAxisVisibility");
        }
        get verticalAxisVisibility() {
            return this.bn;
        }
        set verticalAxisVisibility(a) {
            this.bn = a;
            this.g("VerticalAxisVisibility");
        }
        get markerVisibility() {
            return this.bb;
        }
        set markerVisibility(a) {
            this.bb = a;
            this.g("MarkerVisibility");
        }
        get negativeMarkerVisibility() {
            return this.be;
        }
        set negativeMarkerVisibility(a) {
            this.be = a;
            this.g("NegativeMarkerVisibility");
        }
        get firstMarkerVisibility() {
            return this.aw;
        }
        set firstMarkerVisibility(a) {
            this.aw = a;
            this.g("FirstMarkerVisibility");
        }
        get lastMarkerVisibility() {
            return this.a7;
        }
        set lastMarkerVisibility(a) {
            this.a7 = a;
            this.g("LastMarkerVisibility");
        }
        get lowMarkerVisibility() {
            return this.a9;
        }
        set lowMarkerVisibility(a) {
            this.a9 = a;
            this.g("LowMarkerVisibility");
        }
        get highMarkerVisibility() {
            return this.a0;
        }
        set highMarkerVisibility(a) {
            this.a0 = a;
            this.g("HighMarkerVisibility");
        }
        get normalRangeVisibility() {
            return this.bg;
        }
        set normalRangeVisibility(a) {
            this.bg = a;
            this.g("NormalRangeVisibility");
        }
        get displayNormalRangeInFront() {
            return this.l;
        }
        set displayNormalRangeInFront(a) {
            this.l = a;
            this.g("DisplayNormalRangeInFront");
        }
        get markerSize() {
            return this.t;
        }
        set markerSize(a) {
            this.t = a;
            this.g("MarkerSize");
        }
        get firstMarkerSize() {
            return this.o;
        }
        set firstMarkerSize(a) {
            this.o = a;
            this.g("FirstMarkerSize");
        }
        get lastMarkerSize() {
            return this.q;
        }
        set lastMarkerSize(a) {
            this.q = a;
            this.g("LastMarkerSize");
        }
        get highMarkerSize() {
            return this.p;
        }
        set highMarkerSize(a) {
            this.p = a;
            this.g("HighMarkerSize");
        }
        get lowMarkerSize() {
            return this.s;
        }
        set lowMarkerSize(a) {
            this.s = a;
            this.g("LowMarkerSize");
        }
        get negativeMarkerSize() {
            return this.w;
        }
        set negativeMarkerSize(a) {
            this.w = a;
            this.g("NegativeMarkerSize");
        }
        get lineThickness() {
            return this.r;
        }
        set lineThickness(a) {
            this.r = a;
            this.g("LineThickness");
        }
        get minimum() {
            return this.v;
        }
        set minimum(a) {
            this.v = a;
            this.g("Minimum");
        }
        get maximum() {
            return this.u;
        }
        set maximum(a) {
            this.u = a;
            this.g("Maximum");
        }
        get dataSourceRef() {
            return this.at;
        }
        set dataSourceRef(a) {
            this.at = a;
            this.g("DataSourceRef");
        }
        get valueMemberPath() {
            return this.bk;
        }
        set valueMemberPath(a) {
            this.bk = a;
            this.g("ValueMemberPath");
        }
        get labelMemberPath() {
            return this.a5;
        }
        set labelMemberPath(a) {
            this.a5 = a;
            this.g("LabelMemberPath");
        }
        get trendLineType() {
            return this.bi;
        }
        set trendLineType(a) {
            this.bi = a;
            this.g("TrendLineType");
        }
        get trendLinePeriod() {
            return this.ap;
        }
        set trendLinePeriod(a) {
            this.ap = a;
            this.g("TrendLinePeriod");
        }
        get trendLineThickness() {
            return this.aa;
        }
        set trendLineThickness(a) {
            this.aa = a;
            this.g("TrendLineThickness");
        }
        get normalRangeMinimum() {
            return this.y;
        }
        set normalRangeMinimum(a) {
            this.y = a;
            this.g("NormalRangeMinimum");
        }
        get normalRangeMaximum() {
            return this.x;
        }
        set normalRangeMaximum(a) {
            this.x = a;
            this.g("NormalRangeMaximum");
        }
        get displayType() {
            return this.au;
        }
        set displayType(a) {
            this.au = a;
            this.g("DisplayType");
        }
        get unknownValuePlotting() {
            return this.bj;
        }
        set unknownValuePlotting(a) {
            this.bj = a;
            this.g("UnknownValuePlotting");
        }
        get verticalAxisLabelRef() {
            return this.bm;
        }
        set verticalAxisLabelRef(a) {
            this.bm = a;
            this.g("VerticalAxisLabelRef");
        }
        get horizontalAxisLabelRef() {
            return this.a2;
        }
        set horizontalAxisLabelRef(a) {
            this.a2 = a;
            this.g("HorizontalAxisLabelRef");
        }
        get formatLabelRef() {
            return this.ax;
        }
        set formatLabelRef(a) {
            this.ax = a;
            this.g("FormatLabelRef");
        }
        get horizontalLabelFormat() {
            return this.a4;
        }
        set horizontalLabelFormat(a) {
            this.a4 = a;
            this.g("HorizontalLabelFormat");
        }
        get horizontalLabelFormatSpecifiers() {
            return this.h;
        }
        set horizontalLabelFormatSpecifiers(a) {
            this.h = a;
            this.g("HorizontalLabelFormatSpecifiers");
        }
        get verticalLabelFormat() {
            return this.bo;
        }
        set verticalLabelFormat(a) {
            this.bo = a;
            this.g("VerticalLabelFormat");
        }
        get verticalLabelFormatSpecifiers() {
            return this.i;
        }
        set verticalLabelFormatSpecifiers(a) {
            this.i = a;
            this.g("VerticalLabelFormatSpecifiers");
        }
        get pixelScalingRatio() {
            return this.z;
        }
        set pixelScalingRatio(a) {
            this.z = a;
            this.g("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.n;
        }
        set actualPixelScalingRatio(a) {
            this.n = a;
            this.g("ActualPixelScalingRatio");
        }
        get width() {
            return this.bp;
        }
        set width(a) {
            this.bp = a;
            this.g("Width");
        }
        get height() {
            return this.ay;
        }
        set height(a) {
            this.ay = a;
            this.g("Height");
        }
        get background() {
            return this.ar;
        }
        set background(a) {
            this.ar = a;
            this.g("Background");
        }
    }
    SparklineDescription.$t = /*@__PURE__*/ markType(SparklineDescription, 'SparklineDescription', Description.$);
    return SparklineDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SparklineDescriptionMetadata = /*@__PURE__*/ (() => {
    class SparklineDescriptionMetadata extends Base {
        static b(a) {
            if (SparklineDescriptionMetadata.a == null) {
                SparklineDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SparklineDescriptionMetadata.c(SparklineDescriptionMetadata.a);
            }
            if (a.k(SparklineDescriptionMetadata.a)) {
                return;
            }
            a.ac(SparklineDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Brush", "Brush");
            a.item("NegativeBrush", "Brush");
            a.item("MarkerBrush", "Brush");
            a.item("NegativeMarkerBrush", "Brush");
            a.item("FirstMarkerBrush", "Brush");
            a.item("LastMarkerBrush", "Brush");
            a.item("HighMarkerBrush", "Brush");
            a.item("LowMarkerBrush", "Brush");
            a.item("TrendLineBrush", "Brush");
            a.item("HorizontalAxisBrush", "Brush");
            a.item("VerticalAxisBrush", "Brush");
            a.item("NormalRangeFill", "Brush");
            a.item("HorizontalAxisVisibility", "ExportedType:string:Visibility");
            a.item("HorizontalAxisVisibility@names", "Visible;Collapsed");
            a.item("VerticalAxisVisibility", "ExportedType:string:Visibility");
            a.item("VerticalAxisVisibility@names", "Visible;Collapsed");
            a.item("MarkerVisibility", "ExportedType:string:Visibility");
            a.item("MarkerVisibility@names", "Visible;Collapsed");
            a.item("NegativeMarkerVisibility", "ExportedType:string:Visibility");
            a.item("NegativeMarkerVisibility@names", "Visible;Collapsed");
            a.item("FirstMarkerVisibility", "ExportedType:string:Visibility");
            a.item("FirstMarkerVisibility@names", "Visible;Collapsed");
            a.item("LastMarkerVisibility", "ExportedType:string:Visibility");
            a.item("LastMarkerVisibility@names", "Visible;Collapsed");
            a.item("LowMarkerVisibility", "ExportedType:string:Visibility");
            a.item("LowMarkerVisibility@names", "Visible;Collapsed");
            a.item("HighMarkerVisibility", "ExportedType:string:Visibility");
            a.item("HighMarkerVisibility@names", "Visible;Collapsed");
            a.item("NormalRangeVisibility", "ExportedType:string:Visibility");
            a.item("NormalRangeVisibility@names", "Visible;Collapsed");
            a.item("DisplayNormalRangeInFront", "Boolean");
            a.item("MarkerSize", "Number:double");
            a.item("FirstMarkerSize", "Number:double");
            a.item("LastMarkerSize", "Number:double");
            a.item("HighMarkerSize", "Number:double");
            a.item("LowMarkerSize", "Number:double");
            a.item("NegativeMarkerSize", "Number:double");
            a.item("LineThickness", "Number:double");
            a.item("Minimum", "Number:double");
            a.item("Maximum", "Number:double");
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:DataSource)DataRef::object");
            a.item("ValueMemberPath", "String");
            a.item("LabelMemberPath", "String");
            a.item("TrendLineType", "ExportedType:string:TrendLineType");
            a.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            a.item("TrendLinePeriod", "Number:int");
            a.item("TrendLineThickness", "Number:double");
            a.item("NormalRangeMinimum", "Number:double");
            a.item("NormalRangeMaximum", "Number:double");
            a.item("DisplayType", "ExportedType:string:SparklineDisplayType");
            a.item("DisplayType@names", "Line;Area;Column;WinLoss");
            a.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            a.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
            a.item("VerticalAxisLabelRef", "(w:VerticalAxisLabel,wf:VerticalAxisLabel)DataRef");
            a.item("HorizontalAxisLabelRef", "(w:HorizontalAxisLabel,wf:HorizontalAxisLabel)DataRef");
            a.item("FormatLabelRef", "(w:FormatLabel,wf:FormatLabel)MethodRef");
            a.item("HorizontalLabelFormat", "String");
            a.item("HorizontalLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("HorizontalLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("VerticalLabelFormat", "String");
            a.item("VerticalLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("VerticalLabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("PixelScalingRatio", "Number:double");
            a.item("ActualPixelScalingRatio", "Number:double");
            SparklineDescriptionMetadata.e(a);
        }
        static d(a) {
            SparklineDescriptionMetadata.b(a);
            a.ae("Sparkline", () => new SparklineDescription());
            a.ad("Sparkline", SparklineDescriptionMetadata.a);
        }
        static e(a) {
            a.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamSparkline");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
    }
    SparklineDescriptionMetadata.$t = /*@__PURE__*/ markType(SparklineDescriptionMetadata, 'SparklineDescriptionMetadata');
    SparklineDescriptionMetadata.a = null;
    return SparklineDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SparklineCoreDescriptionModule = /*@__PURE__*/ (() => {
    class SparklineCoreDescriptionModule extends Base {
        static register(a) {
            SparklineDescriptionMetadata.d(a);
            NumberFormatSpecifierDescriptionModule.register(a);
            DateTimeFormatSpecifierDescriptionModule.register(a);
        }
    }
    SparklineCoreDescriptionModule.$t = /*@__PURE__*/ markType(SparklineCoreDescriptionModule, 'SparklineCoreDescriptionModule');
    return SparklineCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SparklineDescriptionModule = /*@__PURE__*/ (() => {
    class SparklineDescriptionModule extends Base {
        static register(a) {
            SparklineCoreDescriptionModule.register(a);
            DataChartInteractivityDescriptionModule.register(a);
        }
    }
    SparklineDescriptionModule.$t = /*@__PURE__*/ markType(SparklineDescriptionModule, 'SparklineDescriptionModule');
    return SparklineDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class StockChangedEventArgsDescription extends Description {
        get_type() {
            return "StockChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.i = null;
        }
        get addedSymbols() {
            return this.h;
        }
        set addedSymbols(a) {
            this.h = a;
            this.g("AddedSymbols");
        }
        get removedSymbols() {
            return this.i;
        }
        set removedSymbols(a) {
            this.i = a;
            this.g("RemovedSymbols");
        }
    }
    StockChangedEventArgsDescription.$t = /*@__PURE__*/ markType(StockChangedEventArgsDescription, 'StockChangedEventArgsDescription', Description.$);
    return StockChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class StockChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (StockChangedEventArgsDescriptionMetadata.a == null) {
                StockChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StockChangedEventArgsDescriptionMetadata.c(StockChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(StockChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(StockChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("AddedSymbols", "Array:string");
            a.item("RemovedSymbols", "Array:string");
        }
        static d(a) {
            StockChangedEventArgsDescriptionMetadata.b(a);
            a.ae("StockChangedEventArgs", () => new StockChangedEventArgsDescription());
            a.ad("StockChangedEventArgs", StockChangedEventArgsDescriptionMetadata.a);
        }
    }
    StockChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(StockChangedEventArgsDescriptionMetadata, 'StockChangedEventArgsDescriptionMetadata');
    StockChangedEventArgsDescriptionMetadata.a = null;
    return StockChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SuffixDescription = /*@__PURE__*/ (() => {
    class SuffixDescription extends InputGroupItemDescription {
        get_type() {
            return "Suffix";
        }
        constructor() {
            super();
            this.p = null;
            this.o = null;
            this.l = false;
            this.k = false;
        }
        get id() {
            return this.p;
        }
        set id(a) {
            this.p = a;
            this.g("Id");
        }
        get ariaLabel() {
            return this.o;
        }
        set ariaLabel(a) {
            this.o = a;
            this.g("AriaLabel");
        }
        get isHover() {
            return this.l;
        }
        set isHover(a) {
            this.l = a;
            this.g("IsHover");
        }
        get disabled() {
            return this.k;
        }
        set disabled(a) {
            this.k = a;
            this.g("Disabled");
        }
    }
    SuffixDescription.$t = /*@__PURE__*/ markType(SuffixDescription, 'SuffixDescription', InputGroupItemDescription.$);
    return SuffixDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SuffixDescriptionMetadata = /*@__PURE__*/ (() => {
    class SuffixDescriptionMetadata extends Base {
        static b(a) {
            if (SuffixDescriptionMetadata.a == null) {
                SuffixDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SuffixDescriptionMetadata.c(SuffixDescriptionMetadata.a);
            }
            if (a.k(SuffixDescriptionMetadata.a)) {
                return;
            }
            a.ac(SuffixDescriptionMetadata.a);
        }
        static c(a) {
            InputGroupItemDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:XSuffix");
            a.item("Id", "String");
            a.item("AriaLabel", "String");
            a.item("IsHover", "Boolean");
            a.item("Disabled", "(w:IsDisabled,xam:IsDisabled,wf:IsDisabled)Boolean");
        }
        static d(a) {
            SuffixDescriptionMetadata.b(a);
            a.ae("Suffix", () => new SuffixDescription());
            a.ad("Suffix", SuffixDescriptionMetadata.a);
        }
    }
    SuffixDescriptionMetadata.$t = /*@__PURE__*/ markType(SuffixDescriptionMetadata, 'SuffixDescriptionMetadata');
    SuffixDescriptionMetadata.a = null;
    return SuffixDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryCellInfoDescription = /*@__PURE__*/ (() => {
    class SummaryCellInfoDescription extends CellInfoDescription {
        get_type() {
            return "SummaryCellInfo";
        }
        constructor() {
            super();
            this.fp = null;
            this.fq = null;
            this.fu = null;
            this.fr = null;
            this.fm = 0;
            this.fs = null;
            this.ft = null;
        }
        get resolvedSummaryLabel() {
            return this.fp;
        }
        set resolvedSummaryLabel(a) {
            this.fp = a;
            this.g("ResolvedSummaryLabel");
        }
        get resolvedSummaryValue() {
            return this.fq;
        }
        set resolvedSummaryValue(a) {
            this.fq = a;
            this.g("ResolvedSummaryValue");
        }
        get summaryLabelTextColor() {
            return this.fu;
        }
        set summaryLabelTextColor(a) {
            this.fu = a;
            this.g("SummaryLabelTextColor");
        }
        get summaryLabelFontFamily() {
            return this.fr;
        }
        set summaryLabelFontFamily(a) {
            this.fr = a;
            this.g("SummaryLabelFontFamily");
        }
        get summaryLabelFontSize() {
            return this.fm;
        }
        set summaryLabelFontSize(a) {
            this.fm = a;
            this.g("SummaryLabelFontSize");
        }
        get summaryLabelFontStyle() {
            return this.fs;
        }
        set summaryLabelFontStyle(a) {
            this.fs = a;
            this.g("SummaryLabelFontStyle");
        }
        get summaryLabelFontWeight() {
            return this.ft;
        }
        set summaryLabelFontWeight(a) {
            this.ft = a;
            this.g("SummaryLabelFontWeight");
        }
    }
    SummaryCellInfoDescription.$t = /*@__PURE__*/ markType(SummaryCellInfoDescription, 'SummaryCellInfoDescription', CellInfoDescription.$);
    SummaryCellInfoDescription.__marshalByValue1 = true;
    SummaryCellInfoDescription.__marshalByValueAlias1 = "SummaryCellModel";
    return SummaryCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class SummaryCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (SummaryCellInfoDescriptionMetadata.a == null) {
                SummaryCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SummaryCellInfoDescriptionMetadata.c(SummaryCellInfoDescriptionMetadata.a);
            }
            if (a.k(SummaryCellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(SummaryCellInfoDescriptionMetadata.a);
        }
        static c(a) {
            CellInfoDescriptionMetadata.c(a);
            a.item("ResolvedSummaryLabel", "String");
            a.item("ResolvedSummaryValue", "String");
            a.item("SummaryLabelTextColor", "Brush");
            a.item("SummaryLabelFontFamily", "(w:SummaryLabelFontFamily/FontFamilyTransform,xam:SummaryLabelFontFamily,wf:SummaryLabelFontFamily,web:font/FontFamilyTransform)String");
            a.item("SummaryLabelFontSize", "(w:SummaryLabelFontSize,xam:SummaryLabelFontSize,wf:SummaryLabelFontSize,web:font/FontSizeTransform)Number:double");
            a.item("SummaryLabelFontStyle", "(w:SummaryLabelFontStyle/FontStyleTransform,xam:SummaryLabelFontFamily/FontStyleTransform,wf:SummaryLabelFontFamily/FontStyleTransform,web:font/FontStyleTransform)String");
            a.item("SummaryLabelFontWeight", "(w:SummaryLabelFontWeight/FontWeightTransform,xam:SummaryLabelFontFamily/FontWeightTransform,wf:SummaryLabelFontFamily/FontWeightTransform,web:font/FontWeightTransform)String");
        }
        static d(a) {
            SummaryCellInfoDescriptionMetadata.b(a);
            a.ae("SummaryCellInfo", () => new SummaryCellInfoDescription());
            a.ad("SummaryCellInfo", SummaryCellInfoDescriptionMetadata.a);
        }
    }
    SummaryCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(SummaryCellInfoDescriptionMetadata, 'SummaryCellInfoDescriptionMetadata');
    SummaryCellInfoDescriptionMetadata.a = null;
    return SummaryCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class SummaryChangedEventArgsDescription extends Description {
        get_type() {
            return "SummaryChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = false;
        }
        get iD() {
            return this.j;
        }
        set iD(a) {
            this.j = a;
            this.g("ID");
        }
        get isEnabled() {
            return this.h;
        }
        set isEnabled(a) {
            this.h = a;
            this.g("IsEnabled");
        }
    }
    SummaryChangedEventArgsDescription.$t = /*@__PURE__*/ markType(SummaryChangedEventArgsDescription, 'SummaryChangedEventArgsDescription', Description.$);
    return SummaryChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SummaryChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SummaryChangedEventArgsDescriptionMetadata.a == null) {
                SummaryChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SummaryChangedEventArgsDescriptionMetadata.c(SummaryChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(SummaryChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(SummaryChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ID", "String");
            a.item("IsEnabled", "Boolean");
        }
        static d(a) {
            SummaryChangedEventArgsDescriptionMetadata.b(a);
            a.ae("SummaryChangedEventArgs", () => new SummaryChangedEventArgsDescription());
            a.ad("SummaryChangedEventArgs", SummaryChangedEventArgsDescriptionMetadata.a);
        }
    }
    SummaryChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SummaryChangedEventArgsDescriptionMetadata, 'SummaryChangedEventArgsDescriptionMetadata');
    SummaryChangedEventArgsDescriptionMetadata.a = null;
    return SummaryChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryDataDescription = /*@__PURE__*/ (() => {
    class SummaryDataDescription extends Description {
        get_type() {
            return "SummaryData";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.l = null;
            this.k = null;
            this.h = null;
            this.i = null;
        }
        get summaryName() {
            return this.j;
        }
        set summaryName(a) {
            this.j = a;
            this.g("SummaryName");
        }
        get summaryValueRef() {
            return this.l;
        }
        set summaryValueRef(a) {
            this.l = a;
            this.g("SummaryValueRef");
        }
        get summaryOperand() {
            return this.k;
        }
        set summaryOperand(a) {
            this.k = a;
            this.g("SummaryOperand");
        }
        get formattedText() {
            return this.h;
        }
        set formattedText(a) {
            this.h = a;
            this.g("FormattedText");
        }
        get formattedValue() {
            return this.i;
        }
        set formattedValue(a) {
            this.i = a;
            this.g("FormattedValue");
        }
    }
    SummaryDataDescription.$t = /*@__PURE__*/ markType(SummaryDataDescription, 'SummaryDataDescription', Description.$);
    return SummaryDataDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryDataDescriptionMetadata = /*@__PURE__*/ (() => {
    class SummaryDataDescriptionMetadata extends Base {
        static b(a) {
            if (SummaryDataDescriptionMetadata.a == null) {
                SummaryDataDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SummaryDataDescriptionMetadata.c(SummaryDataDescriptionMetadata.a);
            }
            if (a.k(SummaryDataDescriptionMetadata.a)) {
                return;
            }
            a.ac(SummaryDataDescriptionMetadata.a);
        }
        static c(a) {
            a.item("SummaryName", "String");
            a.item("SummaryValueRef", "(w:SummaryValue,wf:SummaryValue)DataRef");
            a.item("SummaryOperand", "ExportedType:string:DataSourceSummaryOperand");
            a.item("SummaryOperand@names", "Min;Max;Sum;Average;Count;Custom");
            a.item("FormattedText", "String");
            a.item("FormattedValue", "String");
        }
        static d(a) {
            SummaryDataDescriptionMetadata.b(a);
            a.ae("SummaryData", () => new SummaryDataDescription());
            a.ad("SummaryData", SummaryDataDescriptionMetadata.a);
        }
    }
    SummaryDataDescriptionMetadata.$t = /*@__PURE__*/ markType(SummaryDataDescriptionMetadata, 'SummaryDataDescriptionMetadata');
    SummaryDataDescriptionMetadata.a = null;
    return SummaryDataDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ThisMonthExpressionDescription = /*@__PURE__*/ (() => {
    class ThisMonthExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "ThisMonthExpression";
        }
        constructor() {
            super();
        }
    }
    ThisMonthExpressionDescription.$t = /*@__PURE__*/ markType(ThisMonthExpressionDescription, 'ThisMonthExpressionDescription', WrapperExpressionDescription.$);
    ThisMonthExpressionDescription.__marshalByValue2 = true;
    ThisMonthExpressionDescription.__marshalByValueAlias2 = "ThisMonthExpression";
    return ThisMonthExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ThisMonthExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ThisMonthExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (ThisMonthExpressionDescriptionMetadata.a == null) {
                ThisMonthExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ThisMonthExpressionDescriptionMetadata.c(ThisMonthExpressionDescriptionMetadata.a);
            }
            if (a.k(ThisMonthExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ThisMonthExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            ThisMonthExpressionDescriptionMetadata.b(a);
            a.ae("ThisMonthExpression", () => new ThisMonthExpressionDescription());
            a.ad("ThisMonthExpression", ThisMonthExpressionDescriptionMetadata.a);
        }
    }
    ThisMonthExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(ThisMonthExpressionDescriptionMetadata, 'ThisMonthExpressionDescriptionMetadata');
    ThisMonthExpressionDescriptionMetadata.a = null;
    return ThisMonthExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ThisQuarterExpressionDescription = /*@__PURE__*/ (() => {
    class ThisQuarterExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "ThisQuarterExpression";
        }
        constructor() {
            super();
        }
    }
    ThisQuarterExpressionDescription.$t = /*@__PURE__*/ markType(ThisQuarterExpressionDescription, 'ThisQuarterExpressionDescription', WrapperExpressionDescription.$);
    ThisQuarterExpressionDescription.__marshalByValue2 = true;
    ThisQuarterExpressionDescription.__marshalByValueAlias2 = "ThisQuarterExpression";
    return ThisQuarterExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ThisQuarterExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ThisQuarterExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (ThisQuarterExpressionDescriptionMetadata.a == null) {
                ThisQuarterExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ThisQuarterExpressionDescriptionMetadata.c(ThisQuarterExpressionDescriptionMetadata.a);
            }
            if (a.k(ThisQuarterExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ThisQuarterExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            ThisQuarterExpressionDescriptionMetadata.b(a);
            a.ae("ThisQuarterExpression", () => new ThisQuarterExpressionDescription());
            a.ad("ThisQuarterExpression", ThisQuarterExpressionDescriptionMetadata.a);
        }
    }
    ThisQuarterExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(ThisQuarterExpressionDescriptionMetadata, 'ThisQuarterExpressionDescriptionMetadata');
    ThisQuarterExpressionDescriptionMetadata.a = null;
    return ThisQuarterExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ThisWeekExpressionDescription = /*@__PURE__*/ (() => {
    class ThisWeekExpressionDescription extends OffsettableWeekExpressionDescription {
        get_type() {
            return "ThisWeekExpression";
        }
        constructor() {
            super();
        }
    }
    ThisWeekExpressionDescription.$t = /*@__PURE__*/ markType(ThisWeekExpressionDescription, 'ThisWeekExpressionDescription', OffsettableWeekExpressionDescription.$);
    ThisWeekExpressionDescription.__marshalByValue3 = true;
    ThisWeekExpressionDescription.__marshalByValueAlias3 = "ThisWeekExpression";
    return ThisWeekExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ThisWeekExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ThisWeekExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (ThisWeekExpressionDescriptionMetadata.a == null) {
                ThisWeekExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ThisWeekExpressionDescriptionMetadata.c(ThisWeekExpressionDescriptionMetadata.a);
            }
            if (a.k(ThisWeekExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ThisWeekExpressionDescriptionMetadata.a);
        }
        static c(a) {
            OffsettableWeekExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            ThisWeekExpressionDescriptionMetadata.b(a);
            a.ae("ThisWeekExpression", () => new ThisWeekExpressionDescription());
            a.ad("ThisWeekExpression", ThisWeekExpressionDescriptionMetadata.a);
        }
    }
    ThisWeekExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(ThisWeekExpressionDescriptionMetadata, 'ThisWeekExpressionDescriptionMetadata');
    ThisWeekExpressionDescriptionMetadata.a = null;
    return ThisWeekExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ThisYearExpressionDescription = /*@__PURE__*/ (() => {
    class ThisYearExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "ThisYearExpression";
        }
        constructor() {
            super();
        }
    }
    ThisYearExpressionDescription.$t = /*@__PURE__*/ markType(ThisYearExpressionDescription, 'ThisYearExpressionDescription', WrapperExpressionDescription.$);
    ThisYearExpressionDescription.__marshalByValue2 = true;
    ThisYearExpressionDescription.__marshalByValueAlias2 = "ThisYearExpression";
    return ThisYearExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ThisYearExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ThisYearExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (ThisYearExpressionDescriptionMetadata.a == null) {
                ThisYearExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ThisYearExpressionDescriptionMetadata.c(ThisYearExpressionDescriptionMetadata.a);
            }
            if (a.k(ThisYearExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ThisYearExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            ThisYearExpressionDescriptionMetadata.b(a);
            a.ae("ThisYearExpression", () => new ThisYearExpressionDescription());
            a.ad("ThisYearExpression", ThisYearExpressionDescriptionMetadata.a);
        }
    }
    ThisYearExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(ThisYearExpressionDescriptionMetadata, 'ThisYearExpressionDescriptionMetadata');
    ThisYearExpressionDescriptionMetadata.a = null;
    return ThisYearExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileGeneratorDescriptionMetadata = /*@__PURE__*/ (() => {
    class TileGeneratorDescriptionMetadata extends Base {
        static b(a) {
            if (TileGeneratorDescriptionMetadata.a == null) {
                TileGeneratorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TileGeneratorDescriptionMetadata.c(TileGeneratorDescriptionMetadata.a);
            }
            if (a.k(TileGeneratorDescriptionMetadata.a)) {
                return;
            }
            a.ac(TileGeneratorDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            TileGeneratorDescriptionMetadata.b(a);
            a.ad("TileGenerator", TileGeneratorDescriptionMetadata.a);
        }
    }
    TileGeneratorDescriptionMetadata.$t = /*@__PURE__*/ markType(TileGeneratorDescriptionMetadata, 'TileGeneratorDescriptionMetadata');
    TileGeneratorDescriptionMetadata.a = null;
    return TileGeneratorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileSeriesDescription = /*@__PURE__*/ (() => {
    class TileSeriesDescription extends ShapeSeriesBaseDescription {
        get_type() {
            return "TileSeries";
        }
        constructor() {
            super();
            this.ft = null;
        }
        get tileImagery() {
            return this.ft;
        }
        set tileImagery(a) {
            this.ft = a;
            this.g("TileImagery");
        }
    }
    TileSeriesDescription.$t = /*@__PURE__*/ markType(TileSeriesDescription, 'TileSeriesDescription', ShapeSeriesBaseDescription.$);
    return TileSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class TileSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (TileSeriesDescriptionMetadata.a == null) {
                TileSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TileSeriesDescriptionMetadata.c(TileSeriesDescriptionMetadata.a);
            }
            if (a.k(TileSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(TileSeriesDescriptionMetadata.a);
            GeographicMapImageryDescriptionMetadata.d(a);
        }
        static c(a) {
            ShapeSeriesBaseDescriptionMetadata.c(a);
            a.item("TileImagery", "ExportedType:GeographicMapImagery");
        }
        static d(a) {
            TileSeriesDescriptionMetadata.b(a);
            a.ae("TileSeries", () => new TileSeriesDescription());
            a.ad("TileSeries", TileSeriesDescriptionMetadata.a);
        }
    }
    TileSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(TileSeriesDescriptionMetadata, 'TileSeriesDescriptionMetadata');
    TileSeriesDescriptionMetadata.a = null;
    return TileSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class TileSeriesDescriptionModule extends Base {
        static register(a) {
            TileSeriesDescriptionMetadata.d(a);
        }
    }
    TileSeriesDescriptionModule.$t = /*@__PURE__*/ markType(TileSeriesDescriptionModule, 'TileSeriesDescriptionModule');
    return TileSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TodayExpressionDescription = /*@__PURE__*/ (() => {
    class TodayExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "TodayExpression";
        }
        constructor() {
            super();
        }
    }
    TodayExpressionDescription.$t = /*@__PURE__*/ markType(TodayExpressionDescription, 'TodayExpressionDescription', WrapperExpressionDescription.$);
    TodayExpressionDescription.__marshalByValue2 = true;
    TodayExpressionDescription.__marshalByValueAlias2 = "TodayExpression";
    return TodayExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TodayExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class TodayExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (TodayExpressionDescriptionMetadata.a == null) {
                TodayExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TodayExpressionDescriptionMetadata.c(TodayExpressionDescriptionMetadata.a);
            }
            if (a.k(TodayExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(TodayExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            TodayExpressionDescriptionMetadata.b(a);
            a.ae("TodayExpression", () => new TodayExpressionDescription());
            a.ad("TodayExpression", TodayExpressionDescriptionMetadata.a);
        }
    }
    TodayExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(TodayExpressionDescriptionMetadata, 'TodayExpressionDescriptionMetadata');
    TodayExpressionDescriptionMetadata.a = null;
    return TodayExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TomorrowExpressionDescription = /*@__PURE__*/ (() => {
    class TomorrowExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "TomorrowExpression";
        }
        constructor() {
            super();
        }
    }
    TomorrowExpressionDescription.$t = /*@__PURE__*/ markType(TomorrowExpressionDescription, 'TomorrowExpressionDescription', WrapperExpressionDescription.$);
    TomorrowExpressionDescription.__marshalByValue2 = true;
    TomorrowExpressionDescription.__marshalByValueAlias2 = "TomorrowExpression";
    return TomorrowExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TomorrowExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class TomorrowExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (TomorrowExpressionDescriptionMetadata.a == null) {
                TomorrowExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TomorrowExpressionDescriptionMetadata.c(TomorrowExpressionDescriptionMetadata.a);
            }
            if (a.k(TomorrowExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(TomorrowExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            TomorrowExpressionDescriptionMetadata.b(a);
            a.ae("TomorrowExpression", () => new TomorrowExpressionDescription());
            a.ad("TomorrowExpression", TomorrowExpressionDescriptionMetadata.a);
        }
    }
    TomorrowExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(TomorrowExpressionDescriptionMetadata, 'TomorrowExpressionDescriptionMetadata');
    TomorrowExpressionDescriptionMetadata.a = null;
    return TomorrowExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionDescription = /*@__PURE__*/ (() => {
    class ToolActionDescription extends Description {
        get_type() {
            return "ToolAction";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.aq = 0;
            this.b7 = null;
            this.br = null;
            this.bp = null;
            this.b6 = null;
            this.bt = null;
            this.bs = null;
            this.bf = null;
            this.am = 0;
            this.y = 0;
            this.an = 0;
            this.z = 0;
            this.al = 0;
            this.x = 0;
            this.ao = 0;
            this.aa = 0;
            this.bk = null;
            this.bz = null;
            this.bh = null;
            this.bq = null;
            this.bo = null;
            this.ce = null;
            this.bn = null;
            this.cd = null;
            this.bi = null;
            this.bu = null;
            this.bv = null;
            this.ab = 0;
            this.bw = null;
            this.bx = null;
            this.ca = null;
            this.ap = 0;
            this.cb = null;
            this.cc = null;
            this.o = false;
            this.p = false;
            this.b4 = null;
            this.cf = null;
            this.b9 = null;
            this.b2 = null;
            this.b0 = null;
            this.ah = 0;
            this.ai = 0;
            this.aj = 0;
            this.ag = 0;
            this.b1 = null;
            this.bl = null;
            this.i = null;
            this.b3 = null;
            this.bm = null;
            this.j = null;
            this.af = 0;
            this.ak = 0;
            this.w = 0;
            this.ae = 0;
            this.v = 0;
            this.cg = null;
            this.n = false;
            this.ad = 0;
            this.u = 0;
            this.ac = 0;
            this.t = 0;
            this.by = null;
            this.bj = null;
            this.b5 = null;
            this.b8 = null;
        }
        get actions() {
            return this.h;
        }
        set actions(a) {
            this.h = a;
            this.g("Actions");
        }
        get width() {
            return this.aq;
        }
        set width(a) {
            this.aq = a;
            this.g("Width");
        }
        get parentId() {
            return this.b7;
        }
        set parentId(a) {
            this.b7 = a;
            this.g("ParentId");
        }
        get beforeId() {
            return this.br;
        }
        set beforeId(a) {
            this.br = a;
            this.g("BeforeId");
        }
        get afterId() {
            return this.bp;
        }
        set afterId(a) {
            this.bp = a;
            this.g("AfterId");
        }
        get overlayId() {
            return this.b6;
        }
        set overlayId(a) {
            this.b6 = a;
            this.g("OverlayId");
        }
        get commandId() {
            return this.bt;
        }
        set commandId(a) {
            this.bt = a;
            this.g("CommandId");
        }
        get commandArgument() {
            return this.bs;
        }
        set commandArgument(a) {
            this.bs = a;
            this.g("CommandArgument");
        }
        get commandArgumentValue() {
            return this.bf;
        }
        set commandArgumentValue(a) {
            this.bf = a;
            this.g("CommandArgumentValue");
        }
        get paddingLeft() {
            return this.am;
        }
        set paddingLeft(a) {
            this.am = a;
            this.g("PaddingLeft");
        }
        get actualPaddingLeft() {
            return this.y;
        }
        set actualPaddingLeft(a) {
            this.y = a;
            this.g("ActualPaddingLeft");
        }
        get paddingRight() {
            return this.an;
        }
        set paddingRight(a) {
            this.an = a;
            this.g("PaddingRight");
        }
        get actualPaddingRight() {
            return this.z;
        }
        set actualPaddingRight(a) {
            this.z = a;
            this.g("ActualPaddingRight");
        }
        get paddingBottom() {
            return this.al;
        }
        set paddingBottom(a) {
            this.al = a;
            this.g("PaddingBottom");
        }
        get actualPaddingBottom() {
            return this.x;
        }
        set actualPaddingBottom(a) {
            this.x = a;
            this.g("ActualPaddingBottom");
        }
        get paddingTop() {
            return this.ao;
        }
        set paddingTop(a) {
            this.ao = a;
            this.g("PaddingTop");
        }
        get actualPaddingTop() {
            return this.aa;
        }
        set actualPaddingTop(a) {
            this.aa = a;
            this.g("ActualPaddingTop");
        }
        get actualHoverBackground() {
            return this.bk;
        }
        set actualHoverBackground(a) {
            this.bk = a;
            this.g("ActualHoverBackground");
        }
        get hoverBackground() {
            return this.bz;
        }
        set hoverBackground(a) {
            this.bz = a;
            this.g("HoverBackground");
        }
        get actualBackground() {
            return this.bh;
        }
        set actualBackground(a) {
            this.bh = a;
            this.g("ActualBackground");
        }
        get background() {
            return this.bq;
        }
        set background(a) {
            this.bq = a;
            this.g("Background");
        }
        get actualTextColor() {
            return this.bo;
        }
        set actualTextColor(a) {
            this.bo = a;
            this.g("ActualTextColor");
        }
        get textColor() {
            return this.ce;
        }
        set textColor(a) {
            this.ce = a;
            this.g("TextColor");
        }
        get actualSubtitleTextColor() {
            return this.bn;
        }
        set actualSubtitleTextColor(a) {
            this.bn = a;
            this.g("ActualSubtitleTextColor");
        }
        get subtitleTextColor() {
            return this.cd;
        }
        set subtitleTextColor(a) {
            this.cd = a;
            this.g("SubtitleTextColor");
        }
        get actualDisabledTextColor() {
            return this.bi;
        }
        set actualDisabledTextColor(a) {
            this.bi = a;
            this.g("ActualDisabledTextColor");
        }
        get disabledTextColor() {
            return this.bu;
        }
        set disabledTextColor(a) {
            this.bu = a;
            this.g("DisabledTextColor");
        }
        get fontFamily() {
            return this.bv;
        }
        set fontFamily(a) {
            this.bv = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.ab;
        }
        set fontSize(a) {
            this.ab = a;
            this.g("FontSize");
        }
        get fontStyle() {
            return this.bw;
        }
        set fontStyle(a) {
            this.bw = a;
            this.g("FontStyle");
        }
        get fontWeight() {
            return this.bx;
        }
        set fontWeight(a) {
            this.bx = a;
            this.g("FontWeight");
        }
        get subtitleFontFamily() {
            return this.ca;
        }
        set subtitleFontFamily(a) {
            this.ca = a;
            this.g("SubtitleFontFamily");
        }
        get subtitleFontSize() {
            return this.ap;
        }
        set subtitleFontSize(a) {
            this.ap = a;
            this.g("SubtitleFontSize");
        }
        get subtitleFontStyle() {
            return this.cb;
        }
        set subtitleFontStyle(a) {
            this.cb = a;
            this.g("SubtitleFontStyle");
        }
        get subtitleFontWeight() {
            return this.cc;
        }
        set subtitleFontWeight(a) {
            this.cc = a;
            this.g("SubtitleFontWeight");
        }
        get isDisabled() {
            return this.o;
        }
        set isDisabled(a) {
            this.o = a;
            this.g("IsDisabled");
        }
        get isHighlighted() {
            return this.p;
        }
        set isHighlighted(a) {
            this.p = a;
            this.g("IsHighlighted");
        }
        get name() {
            return this.b4;
        }
        set name(a) {
            this.b4 = a;
            this.g("Name");
        }
        get title() {
            return this.cf;
        }
        set title(a) {
            this.cf = a;
            this.g("Title");
        }
        get subtitle() {
            return this.b9;
        }
        set subtitle(a) {
            this.b9 = a;
            this.g("Subtitle");
        }
        get iconName() {
            return this.b2;
        }
        set iconName(a) {
            this.b2 = a;
            this.g("IconName");
        }
        get iconCollectionName() {
            return this.b0;
        }
        set iconCollectionName(a) {
            this.b0 = a;
            this.g("IconCollectionName");
        }
        get iconViewBoxLeft() {
            return this.ah;
        }
        set iconViewBoxLeft(a) {
            this.ah = a;
            this.g("IconViewBoxLeft");
        }
        get iconViewBoxTop() {
            return this.ai;
        }
        set iconViewBoxTop(a) {
            this.ai = a;
            this.g("IconViewBoxTop");
        }
        get iconViewBoxWidth() {
            return this.aj;
        }
        set iconViewBoxWidth(a) {
            this.aj = a;
            this.g("IconViewBoxWidth");
        }
        get iconViewBoxHeight() {
            return this.ag;
        }
        set iconViewBoxHeight(a) {
            this.ag = a;
            this.g("IconViewBoxHeight");
        }
        get iconFill() {
            return this.b1;
        }
        set iconFill(a) {
            this.b1 = a;
            this.g("IconFill");
        }
        get actualIconFill() {
            return this.bl;
        }
        set actualIconFill(a) {
            this.bl = a;
            this.g("ActualIconFill");
        }
        get iconFillColors() {
            return this.i;
        }
        set iconFillColors(a) {
            this.i = a;
            this.g("IconFillColors");
        }
        get iconStroke() {
            return this.b3;
        }
        set iconStroke(a) {
            this.b3 = a;
            this.g("IconStroke");
        }
        get actualIconStroke() {
            return this.bm;
        }
        set actualIconStroke(a) {
            this.bm = a;
            this.g("ActualIconStroke");
        }
        get iconStrokeColors() {
            return this.j;
        }
        set iconStrokeColors(a) {
            this.j = a;
            this.g("IconStrokeColors");
        }
        get iconStrokeWidth() {
            return this.af;
        }
        set iconStrokeWidth(a) {
            this.af = a;
            this.g("IconStrokeWidth");
        }
        get iconWidth() {
            return this.ak;
        }
        set iconWidth(a) {
            this.ak = a;
            this.g("IconWidth");
        }
        get actualIconWidth() {
            return this.w;
        }
        set actualIconWidth(a) {
            this.w = a;
            this.g("ActualIconWidth");
        }
        get iconHeight() {
            return this.ae;
        }
        set iconHeight(a) {
            this.ae = a;
            this.g("IconHeight");
        }
        get actualIconHeight() {
            return this.v;
        }
        set actualIconHeight(a) {
            this.v = a;
            this.g("ActualIconHeight");
        }
        get visibility() {
            return this.cg;
        }
        set visibility(a) {
            this.cg = a;
            this.g("Visibility");
        }
        get closeOnExecute() {
            return this.n;
        }
        set closeOnExecute(a) {
            this.n = a;
            this.g("CloseOnExecute");
        }
        get highlightWidth() {
            return this.ad;
        }
        set highlightWidth(a) {
            this.ad = a;
            this.g("HighlightWidth");
        }
        get actualHighlightWidth() {
            return this.u;
        }
        set actualHighlightWidth(a) {
            this.u = a;
            this.g("ActualHighlightWidth");
        }
        get highlightRadius() {
            return this.ac;
        }
        set highlightRadius(a) {
            this.ac = a;
            this.g("HighlightRadius");
        }
        get actualHighlightRadius() {
            return this.t;
        }
        set actualHighlightRadius(a) {
            this.t = a;
            this.g("ActualHighlightRadius");
        }
        get highlightColor() {
            return this.by;
        }
        set highlightColor(a) {
            this.by = a;
            this.g("HighlightColor");
        }
        get actualHighlightColor() {
            return this.bj;
        }
        set actualHighlightColor(a) {
            this.bj = a;
            this.g("ActualHighlightColor");
        }
        get onCommandRef() {
            return this.b5;
        }
        set onCommandRef(a) {
            this.b5 = a;
            this.g("OnCommandRef");
        }
        get performedRef() {
            return this.b8;
        }
        set performedRef(a) {
            this.b8 = a;
            this.g("PerformedRef");
        }
    }
    ToolActionDescription.$t = /*@__PURE__*/ markType(ToolActionDescription, 'ToolActionDescription', Description.$);
    return ToolActionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolCommandArgumentDescription = /*@__PURE__*/ (() => {
    class ToolCommandArgumentDescription extends Description {
        get_type() {
            return "ToolCommandArgument";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.i = null;
        }
        get argumentName() {
            return this.l;
        }
        set argumentName(a) {
            this.l = a;
            this.g("ArgumentName");
        }
        get value() {
            return this.i;
        }
        set value(a) {
            this.i = a;
            this.g("Value");
        }
    }
    ToolCommandArgumentDescription.$t = /*@__PURE__*/ markType(ToolCommandArgumentDescription, 'ToolCommandArgumentDescription', Description.$);
    ToolCommandArgumentDescription.__marshalByValue = true;
    ToolCommandArgumentDescription.__marshalByValueAlias = "ToolCommandArgument";
    return ToolCommandArgumentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolCommandArgumentDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolCommandArgumentDescriptionMetadata extends Base {
        static b(a) {
            if (ToolCommandArgumentDescriptionMetadata.a == null) {
                ToolCommandArgumentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolCommandArgumentDescriptionMetadata.c(ToolCommandArgumentDescriptionMetadata.a);
            }
            if (a.k(ToolCommandArgumentDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolCommandArgumentDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("ArgumentName", "String");
            a.item("Value", "Unknown");
        }
        static d(a) {
            ToolCommandArgumentDescriptionMetadata.b(a);
            a.ae("ToolCommandArgument", () => new ToolCommandArgumentDescription());
            a.ad("ToolCommandArgument", ToolCommandArgumentDescriptionMetadata.a);
        }
    }
    ToolCommandArgumentDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolCommandArgumentDescriptionMetadata, 'ToolCommandArgumentDescriptionMetadata');
    ToolCommandArgumentDescriptionMetadata.a = null;
    return ToolCommandArgumentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolCommandDescription = /*@__PURE__*/ (() => {
    class ToolCommandDescription extends Description {
        get_type() {
            return "ToolCommand";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.h = null;
        }
        get commandId() {
            return this.l;
        }
        set commandId(a) {
            this.l = a;
            this.g("CommandId");
        }
        get argumentsList() {
            return this.h;
        }
        set argumentsList(a) {
            this.h = a;
            this.g("ArgumentsList");
        }
    }
    ToolCommandDescription.$t = /*@__PURE__*/ markType(ToolCommandDescription, 'ToolCommandDescription', Description.$);
    ToolCommandDescription.__marshalByValue = true;
    ToolCommandDescription.__marshalByValueAlias = "ToolCommand";
    return ToolCommandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolCommandDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolCommandDescriptionMetadata extends Base {
        static b(a) {
            if (ToolCommandDescriptionMetadata.a == null) {
                ToolCommandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolCommandDescriptionMetadata.c(ToolCommandDescriptionMetadata.a);
            }
            if (a.k(ToolCommandDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolCommandDescriptionMetadata.a);
            ToolCommandDescriptionMetadata.e(a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("CommandId", "String");
            a.item("ArgumentsList", "Collection:ToolCommandArgument:ToolCommandArgumentCollection:ToolCommandArgument");
        }
        static d(a) {
            ToolCommandDescriptionMetadata.b(a);
            a.ae("ToolCommand", () => new ToolCommandDescription());
            a.ad("ToolCommand", ToolCommandDescriptionMetadata.a);
        }
        static e(a) {
            ToolCommandArgumentDescriptionMetadata.d(a);
        }
    }
    ToolCommandDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolCommandDescriptionMetadata, 'ToolCommandDescriptionMetadata');
    ToolCommandDescriptionMetadata.a = null;
    return ToolCommandDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolCommandEventArgsDescription = /*@__PURE__*/ (() => {
    class ToolCommandEventArgsDescription extends Description {
        get_type() {
            return "ToolCommandEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get command() {
            return this.h;
        }
        set command(a) {
            this.h = a;
            this.g("Command");
        }
    }
    ToolCommandEventArgsDescription.$t = /*@__PURE__*/ markType(ToolCommandEventArgsDescription, 'ToolCommandEventArgsDescription', Description.$);
    return ToolCommandEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolCommandEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolCommandEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ToolCommandEventArgsDescriptionMetadata.a == null) {
                ToolCommandEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolCommandEventArgsDescriptionMetadata.c(ToolCommandEventArgsDescriptionMetadata.a);
            }
            if (a.k(ToolCommandEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolCommandEventArgsDescriptionMetadata.a);
            ToolCommandDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Command", "ExportedType:ToolCommand");
        }
        static d(a) {
            ToolCommandEventArgsDescriptionMetadata.b(a);
            a.ae("ToolCommandEventArgs", () => new ToolCommandEventArgsDescription());
            a.ad("ToolCommandEventArgs", ToolCommandEventArgsDescriptionMetadata.a);
        }
    }
    ToolCommandEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolCommandEventArgsDescriptionMetadata, 'ToolCommandEventArgsDescriptionMetadata');
    ToolCommandEventArgsDescriptionMetadata.a = null;
    return ToolCommandEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionEventDetailDescription = /*@__PURE__*/ (() => {
    class ToolActionEventDetailDescription extends Description {
        get_type() {
            return "ToolActionEventDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.p = null;
            this.q = null;
            this.i = false;
            this.h = false;
            this.n = 0;
            this.l = new Date();
            this.r = null;
        }
        get actionId() {
            return this.p;
        }
        set actionId(a) {
            this.p = a;
            this.g("ActionId");
        }
        get actionType() {
            return this.q;
        }
        set actionType(a) {
            this.q = a;
            this.g("ActionType");
        }
        get isModified() {
            return this.i;
        }
        set isModified(a) {
            this.i = a;
            this.g("IsModified");
        }
        get boolValue() {
            return this.h;
        }
        set boolValue(a) {
            this.h = a;
            this.g("BoolValue");
        }
        get numberValue() {
            return this.n;
        }
        set numberValue(a) {
            this.n = a;
            this.g("NumberValue");
        }
        get dateTimeValue() {
            return this.l;
        }
        set dateTimeValue(a) {
            this.l = a;
            this.g("DateTimeValue");
        }
        get untypedValueRef() {
            return this.r;
        }
        set untypedValueRef(a) {
            this.r = a;
            this.g("UntypedValueRef");
        }
    }
    ToolActionEventDetailDescription.$t = /*@__PURE__*/ markType(ToolActionEventDetailDescription, 'ToolActionEventDetailDescription', Description.$);
    return ToolActionEventDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionEventDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionEventDetailDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionEventDetailDescriptionMetadata.a == null) {
                ToolActionEventDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionEventDetailDescriptionMetadata.c(ToolActionEventDetailDescriptionMetadata.a);
            }
            if (a.k(ToolActionEventDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionEventDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ActionId", "String");
            a.item("ActionType", "ExportedType:string:ToolActionType");
            a.item("ActionType@names", "Unknown;GroupHeader;Checkbox;IconButton;Label;NumberInput;Radio;Separator;IconMenu;Button;SubPanel;CheckboxList");
            a.item("IsModified", "Boolean");
            a.item("BoolValue", "Boolean");
            a.item("NumberValue", "Number:double");
            a.item("DateTimeValue", "Date");
            a.item("UntypedValueRef", "(w:UntypedValue,wf:UntypedValue)DataRef");
        }
        static d(a) {
            ToolActionEventDetailDescriptionMetadata.b(a);
            a.ae("ToolActionEventDetail", () => new ToolActionEventDetailDescription());
            a.ad("ToolActionEventDetail", ToolActionEventDetailDescriptionMetadata.a);
        }
    }
    ToolActionEventDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionEventDetailDescriptionMetadata, 'ToolActionEventDetailDescriptionMetadata');
    ToolActionEventDetailDescriptionMetadata.a = null;
    return ToolActionEventDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionPerformedEventArgsDescription = /*@__PURE__*/ (() => {
    class ToolActionPerformedEventArgsDescription extends Description {
        get_type() {
            return "ToolActionPerformedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = false;
            this.j = null;
            this.h = null;
        }
        get isAggregate() {
            return this.l;
        }
        set isAggregate(a) {
            this.l = a;
            this.g("IsAggregate");
        }
        get detail() {
            return this.j;
        }
        set detail(a) {
            this.j = a;
            this.g("Detail");
        }
        get detailCollection() {
            return this.h;
        }
        set detailCollection(a) {
            this.h = a;
            this.g("DetailCollection");
        }
    }
    ToolActionPerformedEventArgsDescription.$t = /*@__PURE__*/ markType(ToolActionPerformedEventArgsDescription, 'ToolActionPerformedEventArgsDescription', Description.$);
    return ToolActionPerformedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionPerformedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionPerformedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionPerformedEventArgsDescriptionMetadata.a == null) {
                ToolActionPerformedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionPerformedEventArgsDescriptionMetadata.c(ToolActionPerformedEventArgsDescriptionMetadata.a);
            }
            if (a.k(ToolActionPerformedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionPerformedEventArgsDescriptionMetadata.a);
            ToolActionEventDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("IsAggregate", "Boolean");
            a.item("Detail", "ExportedType:ToolActionEventDetail");
            a.item("DetailCollection", "Collection:ToolActionEventDetail:ToolActionEventDetailCollection:ToolActionEventDetail");
        }
        static d(a) {
            ToolActionPerformedEventArgsDescriptionMetadata.b(a);
            a.ae("ToolActionPerformedEventArgs", () => new ToolActionPerformedEventArgsDescription());
            a.ad("ToolActionPerformedEventArgs", ToolActionPerformedEventArgsDescriptionMetadata.a);
        }
    }
    ToolActionPerformedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionPerformedEventArgsDescriptionMetadata, 'ToolActionPerformedEventArgsDescriptionMetadata');
    ToolActionPerformedEventArgsDescriptionMetadata.a = null;
    return ToolActionPerformedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionDescriptionMetadata.a == null) {
                ToolActionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionDescriptionMetadata.c(ToolActionDescriptionMetadata.a);
            }
            if (a.k(ToolActionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionDescriptionMetadata.a);
            ToolCommandEventArgsDescriptionMetadata.d(a);
            ToolActionPerformedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Actions", "Collection:ToolAction:ToolActionCollection:ToolAction");
            a.item("Width", "Number:double");
            a.item("ParentId", "String");
            a.item("BeforeId", "String");
            a.item("AfterId", "String");
            a.item("OverlayId", "String");
            a.item("CommandId", "String");
            a.item("CommandArgument", "String");
            a.item("CommandArgumentValue", "Unknown");
            a.item("PaddingLeft", "Number:double");
            a.item("ActualPaddingLeft", "Number:double");
            a.item("PaddingRight", "Number:double");
            a.item("ActualPaddingRight", "Number:double");
            a.item("PaddingBottom", "Number:double");
            a.item("ActualPaddingBottom", "Number:double");
            a.item("PaddingTop", "Number:double");
            a.item("ActualPaddingTop", "Number:double");
            a.item("ActualHoverBackground", "Brush");
            a.item("HoverBackground", "Brush");
            a.item("ActualBackground", "Brush");
            a.item("Background", "Brush");
            a.item("ActualTextColor", "Brush");
            a.item("TextColor", "Brush");
            a.item("ActualSubtitleTextColor", "Brush");
            a.item("SubtitleTextColor", "Brush");
            a.item("ActualDisabledTextColor", "Brush");
            a.item("DisabledTextColor", "Brush");
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontFamily/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontFamily/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            a.item("SubtitleFontFamily", "(w:SubtitleFontFamily/FontFamilyTransform,xam:SubtitleFontFamily,wf:SubtitleFontFamily,web:subtitleTextStyle/FontFamilyTransform)String");
            a.item("SubtitleFontSize", "(w:SubtitleFontSize,xam:SubtitleFontSize,wf:SubtitleFontSize,web:subtitleTextStyle/FontSizeTransform)Number:double");
            a.item("SubtitleFontStyle", "(w:SubtitleFontStyle/FontStyleTransform,xam:SubtitleFontFamily/FontStyleTransform,wf:SubtitleFontFamily/FontStyleTransform,web:subtitleTextStyle/FontStyleTransform)String");
            a.item("SubtitleFontWeight", "(w:SubtitleFontWeight/FontWeightTransform,xam:SubtitleFontFamily/FontWeightTransform,wf:SubtitleFontFamily/FontWeightTransform,web:subtitleTextStyle/FontWeightTransform)String");
            a.item("IsDisabled", "Boolean");
            a.item("IsHighlighted", "Boolean");
            a.item("Name", "String");
            a.item("Title", "String");
            a.item("Subtitle", "String");
            a.item("IconName", "String");
            a.item("IconCollectionName", "String");
            a.item("IconViewBoxLeft", "Number:double");
            a.item("IconViewBoxTop", "Number:double");
            a.item("IconViewBoxWidth", "Number:double");
            a.item("IconViewBoxHeight", "Number:double");
            a.item("IconFill", "Brush");
            a.item("ActualIconFill", "Brush");
            a.item("IconFillColors", "BrushCollection:string");
            a.item("IconStroke", "Brush");
            a.item("ActualIconStroke", "Brush");
            a.item("IconStrokeColors", "BrushCollection:string");
            a.item("IconStrokeWidth", "Number:double");
            a.item("IconWidth", "Number:double");
            a.item("ActualIconWidth", "Number:double");
            a.item("IconHeight", "Number:double");
            a.item("ActualIconHeight", "Number:double");
            a.item("Visibility", "ExportedType:string:Visibility");
            a.item("Visibility@names", "Visible;Collapsed");
            a.item("CloseOnExecute", "Boolean");
            a.item("HighlightWidth", "Number:double");
            a.item("ActualHighlightWidth", "Number:double");
            a.item("HighlightRadius", "Number:double");
            a.item("ActualHighlightRadius", "Number:double");
            a.item("HighlightColor", "Brush");
            a.item("ActualHighlightColor", "Brush");
            a.item("OnCommandRef", "EventRef::onCommand");
            a.item("PerformedRef", "EventRef::performed");
        }
        static d(a) {
            ToolActionDescriptionMetadata.b(a);
            a.ad("ToolAction", ToolActionDescriptionMetadata.a);
        }
    }
    ToolActionDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionDescriptionMetadata, 'ToolActionDescriptionMetadata');
    ToolActionDescriptionMetadata.a = null;
    return ToolActionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionButtonDescription = /*@__PURE__*/ (() => {
    class ToolActionButtonDescription extends ToolActionDescription {
        get_type() {
            return "ToolActionButton";
        }
        constructor() {
            super();
            this.dk = null;
            this.di = 0;
        }
        get displayType() {
            return this.dk;
        }
        set displayType(a) {
            this.dk = a;
            this.g("DisplayType");
        }
        get cornerRadius() {
            return this.di;
        }
        set cornerRadius(a) {
            this.di = a;
            this.g("CornerRadius");
        }
    }
    ToolActionButtonDescription.$t = /*@__PURE__*/ markType(ToolActionButtonDescription, 'ToolActionButtonDescription', ToolActionDescription.$);
    return ToolActionButtonDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionButtonDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionButtonDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionButtonDescriptionMetadata.a == null) {
                ToolActionButtonDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionButtonDescriptionMetadata.c(ToolActionButtonDescriptionMetadata.a);
            }
            if (a.k(ToolActionButtonDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionButtonDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionDescriptionMetadata.c(a);
            a.item("DisplayType", "ExportedType:string:ToolActionButtonDisplayType");
            a.item("DisplayType@names", "Raised;Flat;Outlined");
            a.item("CornerRadius", "Number:double");
        }
        static d(a) {
            ToolActionButtonDescriptionMetadata.b(a);
            a.ae("ToolActionButton", () => new ToolActionButtonDescription());
            a.ad("ToolActionButton", ToolActionButtonDescriptionMetadata.a);
        }
    }
    ToolActionButtonDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionButtonDescriptionMetadata, 'ToolActionButtonDescriptionMetadata');
    ToolActionButtonDescriptionMetadata.a = null;
    return ToolActionButtonDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionButtonDescriptionModule = /*@__PURE__*/ (() => {
    class ToolActionButtonDescriptionModule extends Base {
        static register(a) {
            ToolActionButtonDescriptionMetadata.d(a);
        }
    }
    ToolActionButtonDescriptionModule.$t = /*@__PURE__*/ markType(ToolActionButtonDescriptionModule, 'ToolActionButtonDescriptionModule');
    return ToolActionButtonDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionCheckboxDescription = /*@__PURE__*/ (() => {
    class ToolActionCheckboxDescription extends ToolActionDescription {
        get_type() {
            return "ToolActionCheckbox";
        }
        constructor() {
            super();
            this.di = false;
            this.dr = null;
            this.dm = null;
            this.dp = null;
            this.dk = null;
            this.ds = null;
            this.dn = null;
            this.dq = null;
            this.dl = null;
        }
        get isChecked() {
            return this.di;
        }
        set isChecked(a) {
            this.di = a;
            this.g("IsChecked");
        }
        get uncheckedBackgroundColor() {
            return this.dr;
        }
        set uncheckedBackgroundColor(a) {
            this.dr = a;
            this.g("UncheckedBackgroundColor");
        }
        get actualUncheckedBackgroundColor() {
            return this.dm;
        }
        set actualUncheckedBackgroundColor(a) {
            this.dm = a;
            this.g("ActualUncheckedBackgroundColor");
        }
        get checkedBackgroundColor() {
            return this.dp;
        }
        set checkedBackgroundColor(a) {
            this.dp = a;
            this.g("CheckedBackgroundColor");
        }
        get actualCheckedBackgroundColor() {
            return this.dk;
        }
        set actualCheckedBackgroundColor(a) {
            this.dk = a;
            this.g("ActualCheckedBackgroundColor");
        }
        get uncheckedBorderColor() {
            return this.ds;
        }
        set uncheckedBorderColor(a) {
            this.ds = a;
            this.g("UncheckedBorderColor");
        }
        get actualUncheckedBorderColor() {
            return this.dn;
        }
        set actualUncheckedBorderColor(a) {
            this.dn = a;
            this.g("ActualUncheckedBorderColor");
        }
        get checkedBorderColor() {
            return this.dq;
        }
        set checkedBorderColor(a) {
            this.dq = a;
            this.g("CheckedBorderColor");
        }
        get actualCheckedBorderColor() {
            return this.dl;
        }
        set actualCheckedBorderColor(a) {
            this.dl = a;
            this.g("ActualCheckedBorderColor");
        }
    }
    ToolActionCheckboxDescription.$t = /*@__PURE__*/ markType(ToolActionCheckboxDescription, 'ToolActionCheckboxDescription', ToolActionDescription.$);
    return ToolActionCheckboxDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionCheckboxDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionCheckboxDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionCheckboxDescriptionMetadata.a == null) {
                ToolActionCheckboxDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionCheckboxDescriptionMetadata.c(ToolActionCheckboxDescriptionMetadata.a);
            }
            if (a.k(ToolActionCheckboxDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionCheckboxDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionDescriptionMetadata.c(a);
            a.item("IsChecked", "Boolean");
            a.item("UncheckedBackgroundColor", "Brush");
            a.item("ActualUncheckedBackgroundColor", "Brush");
            a.item("CheckedBackgroundColor", "Brush");
            a.item("ActualCheckedBackgroundColor", "Brush");
            a.item("UncheckedBorderColor", "Brush");
            a.item("ActualUncheckedBorderColor", "Brush");
            a.item("CheckedBorderColor", "Brush");
            a.item("ActualCheckedBorderColor", "Brush");
        }
        static d(a) {
            ToolActionCheckboxDescriptionMetadata.b(a);
            a.ae("ToolActionCheckbox", () => new ToolActionCheckboxDescription());
            a.ad("ToolActionCheckbox", ToolActionCheckboxDescriptionMetadata.a);
        }
    }
    ToolActionCheckboxDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionCheckboxDescriptionMetadata, 'ToolActionCheckboxDescriptionMetadata');
    ToolActionCheckboxDescriptionMetadata.a = null;
    return ToolActionCheckboxDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionCheckboxDescriptionModule = /*@__PURE__*/ (() => {
    class ToolActionCheckboxDescriptionModule extends Base {
        static register(a) {
            ToolActionCheckboxDescriptionMetadata.d(a);
        }
    }
    ToolActionCheckboxDescriptionModule.$t = /*@__PURE__*/ markType(ToolActionCheckboxDescriptionModule, 'ToolActionCheckboxDescriptionModule');
    return ToolActionCheckboxDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionInfoDescription = /*@__PURE__*/ (() => {
    class ToolActionInfoDescription extends Description {
        get_type() {
            return "ToolActionInfo";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.as = null;
            this.an = null;
            this.al = null;
            this.am = null;
            this.x = 0;
            this.y = 0;
            this.w = 0;
            this.z = 0;
            this.ar = null;
            this.av = null;
            this.at = null;
            this.aq = null;
            this.ap = null;
            this.s = 0;
            this.t = 0;
            this.u = 0;
            this.r = 0;
            this.v = 0;
            this.q = 0;
            this.l = false;
            this.m = false;
            this.au = null;
            this.ao = null;
            this.k = false;
            this.h = null;
        }
        get parentId() {
            return this.as;
        }
        set parentId(a) {
            this.as = a;
            this.g("ParentId");
        }
        get commandId() {
            return this.an;
        }
        set commandId(a) {
            this.an = a;
            this.g("CommandId");
        }
        get commandArgument() {
            return this.al;
        }
        set commandArgument(a) {
            this.al = a;
            this.g("CommandArgument");
        }
        get commandArgumentValueRef() {
            return this.am;
        }
        set commandArgumentValueRef(a) {
            this.am = a;
            this.g("CommandArgumentValueRef");
        }
        get paddingLeft() {
            return this.x;
        }
        set paddingLeft(a) {
            this.x = a;
            this.g("PaddingLeft");
        }
        get paddingRight() {
            return this.y;
        }
        set paddingRight(a) {
            this.y = a;
            this.g("PaddingRight");
        }
        get paddingBottom() {
            return this.w;
        }
        set paddingBottom(a) {
            this.w = a;
            this.g("PaddingBottom");
        }
        get paddingTop() {
            return this.z;
        }
        set paddingTop(a) {
            this.z = a;
            this.g("PaddingTop");
        }
        get name() {
            return this.ar;
        }
        set name(a) {
            this.ar = a;
            this.g("Name");
        }
        get title() {
            return this.av;
        }
        set title(a) {
            this.av = a;
            this.g("Title");
        }
        get subtitle() {
            return this.at;
        }
        set subtitle(a) {
            this.at = a;
            this.g("Subtitle");
        }
        get iconName() {
            return this.aq;
        }
        set iconName(a) {
            this.aq = a;
            this.g("IconName");
        }
        get iconCollectionName() {
            return this.ap;
        }
        set iconCollectionName(a) {
            this.ap = a;
            this.g("IconCollectionName");
        }
        get iconViewBoxLeft() {
            return this.s;
        }
        set iconViewBoxLeft(a) {
            this.s = a;
            this.g("IconViewBoxLeft");
        }
        get iconViewBoxTop() {
            return this.t;
        }
        set iconViewBoxTop(a) {
            this.t = a;
            this.g("IconViewBoxTop");
        }
        get iconViewBoxWidth() {
            return this.u;
        }
        set iconViewBoxWidth(a) {
            this.u = a;
            this.g("IconViewBoxWidth");
        }
        get iconViewBoxHeight() {
            return this.r;
        }
        set iconViewBoxHeight(a) {
            this.r = a;
            this.g("IconViewBoxHeight");
        }
        get iconWidth() {
            return this.v;
        }
        set iconWidth(a) {
            this.v = a;
            this.g("IconWidth");
        }
        get iconHeight() {
            return this.q;
        }
        set iconHeight(a) {
            this.q = a;
            this.g("IconHeight");
        }
        get isDisabled() {
            return this.l;
        }
        set isDisabled(a) {
            this.l = a;
            this.g("IsDisabled");
        }
        get isHighlighted() {
            return this.m;
        }
        set isHighlighted(a) {
            this.m = a;
            this.g("IsHighlighted");
        }
        get textColor() {
            return this.au;
        }
        set textColor(a) {
            this.au = a;
            this.g("TextColor");
        }
        get disabledTextColor() {
            return this.ao;
        }
        set disabledTextColor(a) {
            this.ao = a;
            this.g("DisabledTextColor");
        }
        get closeOnExecute() {
            return this.k;
        }
        set closeOnExecute(a) {
            this.k = a;
            this.g("CloseOnExecute");
        }
        get actions() {
            return this.h;
        }
        set actions(a) {
            this.h = a;
            this.g("Actions");
        }
    }
    ToolActionInfoDescription.$t = /*@__PURE__*/ markType(ToolActionInfoDescription, 'ToolActionInfoDescription', Description.$);
    ToolActionInfoDescription.__marshalByValue = true;
    ToolActionInfoDescription.__marshalByValueAlias = "ToolActionInfo";
    return ToolActionInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionCheckboxInfoDescription = /*@__PURE__*/ (() => {
    class ToolActionCheckboxInfoDescription extends ToolActionInfoDescription {
        get_type() {
            return "ToolActionCheckboxInfo";
        }
        constructor() {
            super();
            this.a9 = false;
        }
        get isChecked() {
            return this.a9;
        }
        set isChecked(a) {
            this.a9 = a;
            this.g("IsChecked");
        }
    }
    ToolActionCheckboxInfoDescription.$t = /*@__PURE__*/ markType(ToolActionCheckboxInfoDescription, 'ToolActionCheckboxInfoDescription', ToolActionInfoDescription.$);
    ToolActionCheckboxInfoDescription.__marshalByValue1 = true;
    ToolActionCheckboxInfoDescription.__marshalByValueAlias1 = "ToolActionCheckboxInfo";
    return ToolActionCheckboxInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionInfoDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionInfoDescriptionMetadata.a == null) {
                ToolActionInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionInfoDescriptionMetadata.c(ToolActionInfoDescriptionMetadata.a);
            }
            if (a.k(ToolActionInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionInfoDescriptionMetadata.a);
            ToolActionInfoDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__marshalByValue", "Boolean");
            a.item("ParentId", "String");
            a.item("CommandId", "String");
            a.item("CommandArgument", "String");
            a.item("CommandArgumentValueRef", "(w:CommandArgumentValue,wf:CommandArgumentValue)DataRef");
            a.item("PaddingLeft", "Number:double");
            a.item("PaddingRight", "Number:double");
            a.item("PaddingBottom", "Number:double");
            a.item("PaddingTop", "Number:double");
            a.item("Name", "String");
            a.item("Title", "String");
            a.item("Subtitle", "String");
            a.item("IconName", "String");
            a.item("IconCollectionName", "String");
            a.item("IconViewBoxLeft", "Number:double");
            a.item("IconViewBoxTop", "Number:double");
            a.item("IconViewBoxWidth", "Number:double");
            a.item("IconViewBoxHeight", "Number:double");
            a.item("IconWidth", "Number:double");
            a.item("IconHeight", "Number:double");
            a.item("IsDisabled", "Boolean");
            a.item("IsHighlighted", "Boolean");
            a.item("TextColor", "String");
            a.item("DisabledTextColor", "String");
            a.item("CloseOnExecute", "Boolean");
            a.item("Actions", "Array:ToolActionInfoDescription:ToolActionInfo");
        }
        static d(a) {
            ToolActionInfoDescriptionMetadata.b(a);
            a.ae("ToolActionInfo", () => new ToolActionInfoDescription());
            a.ad("ToolActionInfo", ToolActionInfoDescriptionMetadata.a);
        }
    }
    ToolActionInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionInfoDescriptionMetadata, 'ToolActionInfoDescriptionMetadata');
    ToolActionInfoDescriptionMetadata.a = null;
    return ToolActionInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionCheckboxInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionCheckboxInfoDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionCheckboxInfoDescriptionMetadata.a == null) {
                ToolActionCheckboxInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionCheckboxInfoDescriptionMetadata.c(ToolActionCheckboxInfoDescriptionMetadata.a);
            }
            if (a.k(ToolActionCheckboxInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionCheckboxInfoDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionInfoDescriptionMetadata.c(a);
            a.item("IsChecked", "Boolean");
        }
        static d(a) {
            ToolActionCheckboxInfoDescriptionMetadata.b(a);
            a.ae("ToolActionCheckboxInfo", () => new ToolActionCheckboxInfoDescription());
            a.ad("ToolActionCheckboxInfo", ToolActionCheckboxInfoDescriptionMetadata.a);
        }
    }
    ToolActionCheckboxInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionCheckboxInfoDescriptionMetadata, 'ToolActionCheckboxInfoDescriptionMetadata');
    ToolActionCheckboxInfoDescriptionMetadata.a = null;
    return ToolActionCheckboxInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionCheckboxListDescription = /*@__PURE__*/ (() => {
    class ToolActionCheckboxListDescription extends ToolActionDescription {
        get_type() {
            return "ToolActionCheckboxList";
        }
        constructor() {
            super();
            this.dn = null;
            this.dp = null;
            this.dm = null;
            this.di = null;
            this.dj = null;
        }
        get dataSourceRef() {
            return this.dn;
        }
        set dataSourceRef(a) {
            this.dn = a;
            this.g("DataSourceRef");
        }
        get selectedMemberPath() {
            return this.dp;
        }
        set selectedMemberPath(a) {
            this.dp = a;
            this.g("SelectedMemberPath");
        }
        get dataMemberPath() {
            return this.dm;
        }
        set dataMemberPath(a) {
            this.dm = a;
            this.g("DataMemberPath");
        }
        get primaryKey() {
            return this.di;
        }
        set primaryKey(a) {
            this.di = a;
            this.g("PrimaryKey");
        }
        get selectedKeys() {
            return this.dj;
        }
        set selectedKeys(a) {
            this.dj = a;
            this.g("SelectedKeys");
        }
    }
    ToolActionCheckboxListDescription.$t = /*@__PURE__*/ markType(ToolActionCheckboxListDescription, 'ToolActionCheckboxListDescription', ToolActionDescription.$);
    return ToolActionCheckboxListDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionCheckboxListDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionCheckboxListDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionCheckboxListDescriptionMetadata.a == null) {
                ToolActionCheckboxListDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionCheckboxListDescriptionMetadata.c(ToolActionCheckboxListDescriptionMetadata.a);
            }
            if (a.k(ToolActionCheckboxListDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionCheckboxListDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionDescriptionMetadata.c(a);
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)DataRef::object");
            a.item("SelectedMemberPath", "String");
            a.item("DataMemberPath", "String");
            a.item("PrimaryKey", "Array:string");
            a.item("SelectedKeys", "Collection:LayoutPrimaryKeyValue:LayoutSelectedKeysCollection:LayoutPrimaryKeyValue");
        }
        static d(a) {
            ToolActionCheckboxListDescriptionMetadata.b(a);
            a.ae("ToolActionCheckboxList", () => new ToolActionCheckboxListDescription());
            a.ad("ToolActionCheckboxList", ToolActionCheckboxListDescriptionMetadata.a);
        }
    }
    ToolActionCheckboxListDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionCheckboxListDescriptionMetadata, 'ToolActionCheckboxListDescriptionMetadata');
    ToolActionCheckboxListDescriptionMetadata.a = null;
    return ToolActionCheckboxListDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionCheckboxListDescriptionModule = /*@__PURE__*/ (() => {
    class ToolActionCheckboxListDescriptionModule extends Base {
        static register(a) {
            ToolActionCheckboxListDescriptionMetadata.d(a);
        }
    }
    ToolActionCheckboxListDescriptionModule.$t = /*@__PURE__*/ markType(ToolActionCheckboxListDescriptionModule, 'ToolActionCheckboxListDescriptionModule');
    return ToolActionCheckboxListDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionCheckboxListInfoDescription = /*@__PURE__*/ (() => {
    class ToolActionCheckboxListInfoDescription extends ToolActionInfoDescription {
        get_type() {
            return "ToolActionCheckboxListInfo";
        }
        constructor() {
            super();
            this.bd = null;
            this.bc = null;
            this.be = null;
            this.a8 = null;
        }
        get dataSourceRef() {
            return this.bd;
        }
        set dataSourceRef(a) {
            this.bd = a;
            this.g("DataSourceRef");
        }
        get dataMemberPath() {
            return this.bc;
        }
        set dataMemberPath(a) {
            this.bc = a;
            this.g("DataMemberPath");
        }
        get selectedMemberPath() {
            return this.be;
        }
        set selectedMemberPath(a) {
            this.be = a;
            this.g("SelectedMemberPath");
        }
        get primaryKey() {
            return this.a8;
        }
        set primaryKey(a) {
            this.a8 = a;
            this.g("PrimaryKey");
        }
    }
    ToolActionCheckboxListInfoDescription.$t = /*@__PURE__*/ markType(ToolActionCheckboxListInfoDescription, 'ToolActionCheckboxListInfoDescription', ToolActionInfoDescription.$);
    ToolActionCheckboxListInfoDescription.__marshalByValue1 = true;
    ToolActionCheckboxListInfoDescription.__marshalByValueAlias1 = "ToolActionCheckboxListInfo";
    return ToolActionCheckboxListInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionCheckboxListInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionCheckboxListInfoDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionCheckboxListInfoDescriptionMetadata.a == null) {
                ToolActionCheckboxListInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionCheckboxListInfoDescriptionMetadata.c(ToolActionCheckboxListInfoDescriptionMetadata.a);
            }
            if (a.k(ToolActionCheckboxListInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionCheckboxListInfoDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionInfoDescriptionMetadata.c(a);
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,wf:ItemsSource)DataRef::object");
            a.item("DataMemberPath", "String");
            a.item("SelectedMemberPath", "String");
            a.item("PrimaryKey", "Array:string");
        }
        static d(a) {
            ToolActionCheckboxListInfoDescriptionMetadata.b(a);
            a.ae("ToolActionCheckboxListInfo", () => new ToolActionCheckboxListInfoDescription());
            a.ad("ToolActionCheckboxListInfo", ToolActionCheckboxListInfoDescriptionMetadata.a);
        }
    }
    ToolActionCheckboxListInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionCheckboxListInfoDescriptionMetadata, 'ToolActionCheckboxListInfoDescriptionMetadata');
    ToolActionCheckboxListInfoDescriptionMetadata.a = null;
    return ToolActionCheckboxListInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionGroupHeaderDescription = /*@__PURE__*/ (() => {
    class ToolActionGroupHeaderDescription extends ToolActionDescription {
        get_type() {
            return "ToolActionGroupHeader";
        }
        constructor() {
            super();
            this.di = null;
            this.dj = null;
        }
        get actualBackIconColor() {
            return this.di;
        }
        set actualBackIconColor(a) {
            this.di = a;
            this.g("ActualBackIconColor");
        }
        get backIconColor() {
            return this.dj;
        }
        set backIconColor(a) {
            this.dj = a;
            this.g("BackIconColor");
        }
    }
    ToolActionGroupHeaderDescription.$t = /*@__PURE__*/ markType(ToolActionGroupHeaderDescription, 'ToolActionGroupHeaderDescription', ToolActionDescription.$);
    return ToolActionGroupHeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionGroupHeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionGroupHeaderDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionGroupHeaderDescriptionMetadata.a == null) {
                ToolActionGroupHeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionGroupHeaderDescriptionMetadata.c(ToolActionGroupHeaderDescriptionMetadata.a);
            }
            if (a.k(ToolActionGroupHeaderDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionGroupHeaderDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionDescriptionMetadata.c(a);
            a.item("ActualBackIconColor", "Brush");
            a.item("BackIconColor", "Brush");
        }
        static d(a) {
            ToolActionGroupHeaderDescriptionMetadata.b(a);
            a.ae("ToolActionGroupHeader", () => new ToolActionGroupHeaderDescription());
            a.ad("ToolActionGroupHeader", ToolActionGroupHeaderDescriptionMetadata.a);
        }
    }
    ToolActionGroupHeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionGroupHeaderDescriptionMetadata, 'ToolActionGroupHeaderDescriptionMetadata');
    ToolActionGroupHeaderDescriptionMetadata.a = null;
    return ToolActionGroupHeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionGroupHeaderDescriptionModule = /*@__PURE__*/ (() => {
    class ToolActionGroupHeaderDescriptionModule extends Base {
        static register(a) {
            ToolActionGroupHeaderDescriptionMetadata.d(a);
        }
    }
    ToolActionGroupHeaderDescriptionModule.$t = /*@__PURE__*/ markType(ToolActionGroupHeaderDescriptionModule, 'ToolActionGroupHeaderDescriptionModule');
    return ToolActionGroupHeaderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionGroupHeaderInfoDescription = /*@__PURE__*/ (() => {
    class ToolActionGroupHeaderInfoDescription extends ToolActionInfoDescription {
        get_type() {
            return "ToolActionGroupHeaderInfo";
        }
        constructor() {
            super();
        }
    }
    ToolActionGroupHeaderInfoDescription.$t = /*@__PURE__*/ markType(ToolActionGroupHeaderInfoDescription, 'ToolActionGroupHeaderInfoDescription', ToolActionInfoDescription.$);
    ToolActionGroupHeaderInfoDescription.__marshalByValue1 = true;
    ToolActionGroupHeaderInfoDescription.__marshalByValueAlias1 = "ToolActionGroupHeaderInfo";
    return ToolActionGroupHeaderInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionGroupHeaderInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionGroupHeaderInfoDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionGroupHeaderInfoDescriptionMetadata.a == null) {
                ToolActionGroupHeaderInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionGroupHeaderInfoDescriptionMetadata.c(ToolActionGroupHeaderInfoDescriptionMetadata.a);
            }
            if (a.k(ToolActionGroupHeaderInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionGroupHeaderInfoDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionInfoDescriptionMetadata.c(a);
        }
        static d(a) {
            ToolActionGroupHeaderInfoDescriptionMetadata.b(a);
            a.ae("ToolActionGroupHeaderInfo", () => new ToolActionGroupHeaderInfoDescription());
            a.ad("ToolActionGroupHeaderInfo", ToolActionGroupHeaderInfoDescriptionMetadata.a);
        }
    }
    ToolActionGroupHeaderInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionGroupHeaderInfoDescriptionMetadata, 'ToolActionGroupHeaderInfoDescriptionMetadata');
    ToolActionGroupHeaderInfoDescriptionMetadata.a = null;
    return ToolActionGroupHeaderInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionIconButtonDescription = /*@__PURE__*/ (() => {
    class ToolActionIconButtonDescription extends ToolActionDescription {
        get_type() {
            return "ToolActionIconButton";
        }
        constructor() {
            super();
            this.d0 = 0;
            this.dz = 0;
            this.dn = 0;
            this.dj = 0;
            this.dq = 0;
            this.dl = 0;
            this.dp = 0;
            this.dk = 0;
            this.dm = 0;
            this.di = 0;
        }
        get tooltipDelay() {
            return this.d0;
        }
        set tooltipDelay(a) {
            this.d0 = a;
            this.g("TooltipDelay");
        }
        get actualTooltipDelay() {
            return this.dz;
        }
        set actualTooltipDelay(a) {
            this.dz = a;
            this.g("ActualTooltipDelay");
        }
        get contentPaddingLeft() {
            return this.dn;
        }
        set contentPaddingLeft(a) {
            this.dn = a;
            this.g("ContentPaddingLeft");
        }
        get actualContentPaddingLeft() {
            return this.dj;
        }
        set actualContentPaddingLeft(a) {
            this.dj = a;
            this.g("ActualContentPaddingLeft");
        }
        get contentPaddingTop() {
            return this.dq;
        }
        set contentPaddingTop(a) {
            this.dq = a;
            this.g("ContentPaddingTop");
        }
        get actualContentPaddingTop() {
            return this.dl;
        }
        set actualContentPaddingTop(a) {
            this.dl = a;
            this.g("ActualContentPaddingTop");
        }
        get contentPaddingRight() {
            return this.dp;
        }
        set contentPaddingRight(a) {
            this.dp = a;
            this.g("ContentPaddingRight");
        }
        get actualContentPaddingRight() {
            return this.dk;
        }
        set actualContentPaddingRight(a) {
            this.dk = a;
            this.g("ActualContentPaddingRight");
        }
        get contentPaddingBottom() {
            return this.dm;
        }
        set contentPaddingBottom(a) {
            this.dm = a;
            this.g("ContentPaddingBottom");
        }
        get actualContentPaddingBottom() {
            return this.di;
        }
        set actualContentPaddingBottom(a) {
            this.di = a;
            this.g("ActualContentPaddingBottom");
        }
    }
    ToolActionIconButtonDescription.$t = /*@__PURE__*/ markType(ToolActionIconButtonDescription, 'ToolActionIconButtonDescription', ToolActionDescription.$);
    return ToolActionIconButtonDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionIconButtonDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionIconButtonDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionIconButtonDescriptionMetadata.a == null) {
                ToolActionIconButtonDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionIconButtonDescriptionMetadata.c(ToolActionIconButtonDescriptionMetadata.a);
            }
            if (a.k(ToolActionIconButtonDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionIconButtonDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionDescriptionMetadata.c(a);
            a.item("TooltipDelay", "Number:int");
            a.item("ActualTooltipDelay", "Number:int");
            a.item("ContentPaddingLeft", "Number:double");
            a.item("ActualContentPaddingLeft", "Number:double");
            a.item("ContentPaddingTop", "Number:double");
            a.item("ActualContentPaddingTop", "Number:double");
            a.item("ContentPaddingRight", "Number:double");
            a.item("ActualContentPaddingRight", "Number:double");
            a.item("ContentPaddingBottom", "Number:double");
            a.item("ActualContentPaddingBottom", "Number:double");
        }
        static d(a) {
            ToolActionIconButtonDescriptionMetadata.b(a);
            a.ae("ToolActionIconButton", () => new ToolActionIconButtonDescription());
            a.ad("ToolActionIconButton", ToolActionIconButtonDescriptionMetadata.a);
        }
    }
    ToolActionIconButtonDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionIconButtonDescriptionMetadata, 'ToolActionIconButtonDescriptionMetadata');
    ToolActionIconButtonDescriptionMetadata.a = null;
    return ToolActionIconButtonDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionIconButtonDescriptionModule = /*@__PURE__*/ (() => {
    class ToolActionIconButtonDescriptionModule extends Base {
        static register(a) {
            ToolActionIconButtonDescriptionMetadata.d(a);
        }
    }
    ToolActionIconButtonDescriptionModule.$t = /*@__PURE__*/ markType(ToolActionIconButtonDescriptionModule, 'ToolActionIconButtonDescriptionModule');
    return ToolActionIconButtonDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionIconButtonInfoDescription = /*@__PURE__*/ (() => {
    class ToolActionIconButtonInfoDescription extends ToolActionInfoDescription {
        get_type() {
            return "ToolActionIconButtonInfo";
        }
        constructor() {
            super();
            this.bb = 0;
            this.a9 = false;
        }
        get tooltipDelay() {
            return this.bb;
        }
        set tooltipDelay(a) {
            this.bb = a;
            this.g("TooltipDelay");
        }
        get isMenuOpenOnStart() {
            return this.a9;
        }
        set isMenuOpenOnStart(a) {
            this.a9 = a;
            this.g("IsMenuOpenOnStart");
        }
    }
    ToolActionIconButtonInfoDescription.$t = /*@__PURE__*/ markType(ToolActionIconButtonInfoDescription, 'ToolActionIconButtonInfoDescription', ToolActionInfoDescription.$);
    ToolActionIconButtonInfoDescription.__marshalByValue1 = true;
    ToolActionIconButtonInfoDescription.__marshalByValueAlias1 = "ToolActionIconButtonInfo";
    return ToolActionIconButtonInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionIconButtonInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionIconButtonInfoDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionIconButtonInfoDescriptionMetadata.a == null) {
                ToolActionIconButtonInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionIconButtonInfoDescriptionMetadata.c(ToolActionIconButtonInfoDescriptionMetadata.a);
            }
            if (a.k(ToolActionIconButtonInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionIconButtonInfoDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionInfoDescriptionMetadata.c(a);
            a.item("TooltipDelay", "Number:int");
            a.item("IsMenuOpenOnStart", "Boolean");
        }
        static d(a) {
            ToolActionIconButtonInfoDescriptionMetadata.b(a);
            a.ae("ToolActionIconButtonInfo", () => new ToolActionIconButtonInfoDescription());
            a.ad("ToolActionIconButtonInfo", ToolActionIconButtonInfoDescriptionMetadata.a);
        }
    }
    ToolActionIconButtonInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionIconButtonInfoDescriptionMetadata, 'ToolActionIconButtonInfoDescriptionMetadata');
    ToolActionIconButtonInfoDescriptionMetadata.a = null;
    return ToolActionIconButtonInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionIconMenuDescription = /*@__PURE__*/ (() => {
    class ToolActionIconMenuDescription extends ToolActionIconButtonDescription {
        get_type() {
            return "ToolActionIconMenu";
        }
        constructor() {
            super();
            this.d6 = null;
            this.d5 = null;
            this.d3 = false;
        }
        get arrowStroke() {
            return this.d6;
        }
        set arrowStroke(a) {
            this.d6 = a;
            this.g("ArrowStroke");
        }
        get actualArrowStroke() {
            return this.d5;
        }
        set actualArrowStroke(a) {
            this.d5 = a;
            this.g("ActualArrowStroke");
        }
        get showArrowIcon() {
            return this.d3;
        }
        set showArrowIcon(a) {
            this.d3 = a;
            this.g("ShowArrowIcon");
        }
    }
    ToolActionIconMenuDescription.$t = /*@__PURE__*/ markType(ToolActionIconMenuDescription, 'ToolActionIconMenuDescription', ToolActionIconButtonDescription.$);
    return ToolActionIconMenuDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionIconMenuDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionIconMenuDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionIconMenuDescriptionMetadata.a == null) {
                ToolActionIconMenuDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionIconMenuDescriptionMetadata.c(ToolActionIconMenuDescriptionMetadata.a);
            }
            if (a.k(ToolActionIconMenuDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionIconMenuDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionIconButtonDescriptionMetadata.c(a);
            a.item("ArrowStroke", "Brush");
            a.item("ActualArrowStroke", "Brush");
            a.item("ShowArrowIcon", "Boolean");
        }
        static d(a) {
            ToolActionIconMenuDescriptionMetadata.b(a);
            a.ae("ToolActionIconMenu", () => new ToolActionIconMenuDescription());
            a.ad("ToolActionIconMenu", ToolActionIconMenuDescriptionMetadata.a);
        }
    }
    ToolActionIconMenuDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionIconMenuDescriptionMetadata, 'ToolActionIconMenuDescriptionMetadata');
    ToolActionIconMenuDescriptionMetadata.a = null;
    return ToolActionIconMenuDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionIconMenuDescriptionModule = /*@__PURE__*/ (() => {
    class ToolActionIconMenuDescriptionModule extends Base {
        static register(a) {
            ToolActionIconButtonDescriptionModule.register(a);
            ToolActionIconMenuDescriptionMetadata.d(a);
        }
    }
    ToolActionIconMenuDescriptionModule.$t = /*@__PURE__*/ markType(ToolActionIconMenuDescriptionModule, 'ToolActionIconMenuDescriptionModule');
    return ToolActionIconMenuDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionIconMenuInfoDescription = /*@__PURE__*/ (() => {
    class ToolActionIconMenuInfoDescription extends ToolActionIconButtonInfoDescription {
        get_type() {
            return "ToolActionIconMenuInfo";
        }
        constructor() {
            super();
        }
    }
    ToolActionIconMenuInfoDescription.$t = /*@__PURE__*/ markType(ToolActionIconMenuInfoDescription, 'ToolActionIconMenuInfoDescription', ToolActionIconButtonInfoDescription.$);
    ToolActionIconMenuInfoDescription.__marshalByValue2 = true;
    ToolActionIconMenuInfoDescription.__marshalByValueAlias2 = "ToolActionIconMenuInfo";
    return ToolActionIconMenuInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionIconMenuInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionIconMenuInfoDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionIconMenuInfoDescriptionMetadata.a == null) {
                ToolActionIconMenuInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionIconMenuInfoDescriptionMetadata.c(ToolActionIconMenuInfoDescriptionMetadata.a);
            }
            if (a.k(ToolActionIconMenuInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionIconMenuInfoDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionIconButtonInfoDescriptionMetadata.c(a);
        }
        static d(a) {
            ToolActionIconMenuInfoDescriptionMetadata.b(a);
            a.ae("ToolActionIconMenuInfo", () => new ToolActionIconMenuInfoDescription());
            a.ad("ToolActionIconMenuInfo", ToolActionIconMenuInfoDescriptionMetadata.a);
        }
    }
    ToolActionIconMenuInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionIconMenuInfoDescriptionMetadata, 'ToolActionIconMenuInfoDescriptionMetadata');
    ToolActionIconMenuInfoDescriptionMetadata.a = null;
    return ToolActionIconMenuInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionLabelDescription = /*@__PURE__*/ (() => {
    class ToolActionLabelDescription extends ToolActionDescription {
        get_type() {
            return "ToolActionLabel";
        }
        constructor() {
            super();
        }
    }
    ToolActionLabelDescription.$t = /*@__PURE__*/ markType(ToolActionLabelDescription, 'ToolActionLabelDescription', ToolActionDescription.$);
    return ToolActionLabelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionLabelDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionLabelDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionLabelDescriptionMetadata.a == null) {
                ToolActionLabelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionLabelDescriptionMetadata.c(ToolActionLabelDescriptionMetadata.a);
            }
            if (a.k(ToolActionLabelDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionLabelDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionDescriptionMetadata.c(a);
        }
        static d(a) {
            ToolActionLabelDescriptionMetadata.b(a);
            a.ae("ToolActionLabel", () => new ToolActionLabelDescription());
            a.ad("ToolActionLabel", ToolActionLabelDescriptionMetadata.a);
        }
    }
    ToolActionLabelDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionLabelDescriptionMetadata, 'ToolActionLabelDescriptionMetadata');
    ToolActionLabelDescriptionMetadata.a = null;
    return ToolActionLabelDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionLabelDescriptionModule = /*@__PURE__*/ (() => {
    class ToolActionLabelDescriptionModule extends Base {
        static register(a) {
            ToolActionLabelDescriptionMetadata.d(a);
        }
    }
    ToolActionLabelDescriptionModule.$t = /*@__PURE__*/ markType(ToolActionLabelDescriptionModule, 'ToolActionLabelDescriptionModule');
    return ToolActionLabelDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionLabelInfoDescription = /*@__PURE__*/ (() => {
    class ToolActionLabelInfoDescription extends ToolActionInfoDescription {
        get_type() {
            return "ToolActionLabelInfo";
        }
        constructor() {
            super();
        }
    }
    ToolActionLabelInfoDescription.$t = /*@__PURE__*/ markType(ToolActionLabelInfoDescription, 'ToolActionLabelInfoDescription', ToolActionInfoDescription.$);
    ToolActionLabelInfoDescription.__marshalByValue1 = true;
    ToolActionLabelInfoDescription.__marshalByValueAlias1 = "ToolActionLabelInfo";
    return ToolActionLabelInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionLabelInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionLabelInfoDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionLabelInfoDescriptionMetadata.a == null) {
                ToolActionLabelInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionLabelInfoDescriptionMetadata.c(ToolActionLabelInfoDescriptionMetadata.a);
            }
            if (a.k(ToolActionLabelInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionLabelInfoDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionInfoDescriptionMetadata.c(a);
        }
        static d(a) {
            ToolActionLabelInfoDescriptionMetadata.b(a);
            a.ae("ToolActionLabelInfo", () => new ToolActionLabelInfoDescription());
            a.ad("ToolActionLabelInfo", ToolActionLabelInfoDescriptionMetadata.a);
        }
    }
    ToolActionLabelInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionLabelInfoDescriptionMetadata, 'ToolActionLabelInfoDescriptionMetadata');
    ToolActionLabelInfoDescriptionMetadata.a = null;
    return ToolActionLabelInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionNumberInputDescription = /*@__PURE__*/ (() => {
    class ToolActionNumberInputDescription extends ToolActionDescription {
        get_type() {
            return "ToolActionNumberInput";
        }
        constructor() {
            super();
            this.di = 0;
        }
        get value() {
            return this.di;
        }
        set value(a) {
            this.di = a;
            this.g("Value");
        }
    }
    ToolActionNumberInputDescription.$t = /*@__PURE__*/ markType(ToolActionNumberInputDescription, 'ToolActionNumberInputDescription', ToolActionDescription.$);
    return ToolActionNumberInputDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionNumberInputDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionNumberInputDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionNumberInputDescriptionMetadata.a == null) {
                ToolActionNumberInputDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionNumberInputDescriptionMetadata.c(ToolActionNumberInputDescriptionMetadata.a);
            }
            if (a.k(ToolActionNumberInputDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionNumberInputDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionDescriptionMetadata.c(a);
            a.item("Value", "Number:double");
        }
        static d(a) {
            ToolActionNumberInputDescriptionMetadata.b(a);
            a.ae("ToolActionNumberInput", () => new ToolActionNumberInputDescription());
            a.ad("ToolActionNumberInput", ToolActionNumberInputDescriptionMetadata.a);
        }
    }
    ToolActionNumberInputDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionNumberInputDescriptionMetadata, 'ToolActionNumberInputDescriptionMetadata');
    ToolActionNumberInputDescriptionMetadata.a = null;
    return ToolActionNumberInputDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionNumberInputDescriptionModule = /*@__PURE__*/ (() => {
    class ToolActionNumberInputDescriptionModule extends Base {
        static register(a) {
            ToolActionNumberInputDescriptionMetadata.d(a);
        }
    }
    ToolActionNumberInputDescriptionModule.$t = /*@__PURE__*/ markType(ToolActionNumberInputDescriptionModule, 'ToolActionNumberInputDescriptionModule');
    return ToolActionNumberInputDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionNumberInputInfoDescription = /*@__PURE__*/ (() => {
    class ToolActionNumberInputInfoDescription extends ToolActionInfoDescription {
        get_type() {
            return "ToolActionNumberInputInfo";
        }
        constructor() {
            super();
            this.a9 = 0;
        }
        get value() {
            return this.a9;
        }
        set value(a) {
            this.a9 = a;
            this.g("Value");
        }
    }
    ToolActionNumberInputInfoDescription.$t = /*@__PURE__*/ markType(ToolActionNumberInputInfoDescription, 'ToolActionNumberInputInfoDescription', ToolActionInfoDescription.$);
    ToolActionNumberInputInfoDescription.__marshalByValue1 = true;
    ToolActionNumberInputInfoDescription.__marshalByValueAlias1 = "ToolActionNumberInputInfo";
    return ToolActionNumberInputInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionNumberInputInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionNumberInputInfoDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionNumberInputInfoDescriptionMetadata.a == null) {
                ToolActionNumberInputInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionNumberInputInfoDescriptionMetadata.c(ToolActionNumberInputInfoDescriptionMetadata.a);
            }
            if (a.k(ToolActionNumberInputInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionNumberInputInfoDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionInfoDescriptionMetadata.c(a);
            a.item("Value", "Number:double");
        }
        static d(a) {
            ToolActionNumberInputInfoDescriptionMetadata.b(a);
            a.ae("ToolActionNumberInputInfo", () => new ToolActionNumberInputInfoDescription());
            a.ad("ToolActionNumberInputInfo", ToolActionNumberInputInfoDescriptionMetadata.a);
        }
    }
    ToolActionNumberInputInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionNumberInputInfoDescriptionMetadata, 'ToolActionNumberInputInfoDescriptionMetadata');
    ToolActionNumberInputInfoDescriptionMetadata.a = null;
    return ToolActionNumberInputInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionRadioDescription = /*@__PURE__*/ (() => {
    class ToolActionRadioDescription extends ToolActionDescription {
        get_type() {
            return "ToolActionRadio";
        }
        constructor() {
            super();
            this.dr = null;
            this.di = false;
            this.dj = false;
            this.du = null;
            this.dp = null;
            this.ds = null;
            this.dm = null;
            this.dv = null;
            this.dq = null;
            this.dt = null;
            this.dn = null;
        }
        get channel() {
            return this.dr;
        }
        set channel(a) {
            this.dr = a;
            this.g("Channel");
        }
        get isChecked() {
            return this.di;
        }
        set isChecked(a) {
            this.di = a;
            this.g("IsChecked");
        }
        get isManual() {
            return this.dj;
        }
        set isManual(a) {
            this.dj = a;
            this.g("IsManual");
        }
        get uncheckedBackgroundColor() {
            return this.du;
        }
        set uncheckedBackgroundColor(a) {
            this.du = a;
            this.g("UncheckedBackgroundColor");
        }
        get actualUncheckedBackgroundColor() {
            return this.dp;
        }
        set actualUncheckedBackgroundColor(a) {
            this.dp = a;
            this.g("ActualUncheckedBackgroundColor");
        }
        get checkedBackgroundColor() {
            return this.ds;
        }
        set checkedBackgroundColor(a) {
            this.ds = a;
            this.g("CheckedBackgroundColor");
        }
        get actualCheckedBackgroundColor() {
            return this.dm;
        }
        set actualCheckedBackgroundColor(a) {
            this.dm = a;
            this.g("ActualCheckedBackgroundColor");
        }
        get uncheckedBorderColor() {
            return this.dv;
        }
        set uncheckedBorderColor(a) {
            this.dv = a;
            this.g("UncheckedBorderColor");
        }
        get actualUncheckedBorderColor() {
            return this.dq;
        }
        set actualUncheckedBorderColor(a) {
            this.dq = a;
            this.g("ActualUncheckedBorderColor");
        }
        get checkedBorderColor() {
            return this.dt;
        }
        set checkedBorderColor(a) {
            this.dt = a;
            this.g("CheckedBorderColor");
        }
        get actualCheckedBorderColor() {
            return this.dn;
        }
        set actualCheckedBorderColor(a) {
            this.dn = a;
            this.g("ActualCheckedBorderColor");
        }
    }
    ToolActionRadioDescription.$t = /*@__PURE__*/ markType(ToolActionRadioDescription, 'ToolActionRadioDescription', ToolActionDescription.$);
    return ToolActionRadioDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionRadioDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionRadioDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionRadioDescriptionMetadata.a == null) {
                ToolActionRadioDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionRadioDescriptionMetadata.c(ToolActionRadioDescriptionMetadata.a);
            }
            if (a.k(ToolActionRadioDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionRadioDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionDescriptionMetadata.c(a);
            a.item("Channel", "String");
            a.item("IsChecked", "Boolean");
            a.item("IsManual", "Boolean");
            a.item("UncheckedBackgroundColor", "Brush");
            a.item("ActualUncheckedBackgroundColor", "Brush");
            a.item("CheckedBackgroundColor", "Brush");
            a.item("ActualCheckedBackgroundColor", "Brush");
            a.item("UncheckedBorderColor", "Brush");
            a.item("ActualUncheckedBorderColor", "Brush");
            a.item("CheckedBorderColor", "Brush");
            a.item("ActualCheckedBorderColor", "Brush");
        }
        static d(a) {
            ToolActionRadioDescriptionMetadata.b(a);
            a.ae("ToolActionRadio", () => new ToolActionRadioDescription());
            a.ad("ToolActionRadio", ToolActionRadioDescriptionMetadata.a);
        }
    }
    ToolActionRadioDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionRadioDescriptionMetadata, 'ToolActionRadioDescriptionMetadata');
    ToolActionRadioDescriptionMetadata.a = null;
    return ToolActionRadioDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionRadioDescriptionModule = /*@__PURE__*/ (() => {
    class ToolActionRadioDescriptionModule extends Base {
        static register(a) {
            ToolActionRadioDescriptionMetadata.d(a);
        }
    }
    ToolActionRadioDescriptionModule.$t = /*@__PURE__*/ markType(ToolActionRadioDescriptionModule, 'ToolActionRadioDescriptionModule');
    return ToolActionRadioDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionRadioInfoDescription = /*@__PURE__*/ (() => {
    class ToolActionRadioInfoDescription extends ToolActionInfoDescription {
        get_type() {
            return "ToolActionRadioInfo";
        }
        constructor() {
            super();
            this.a9 = false;
            this.bc = null;
        }
        get isChecked() {
            return this.a9;
        }
        set isChecked(a) {
            this.a9 = a;
            this.g("IsChecked");
        }
        get channel() {
            return this.bc;
        }
        set channel(a) {
            this.bc = a;
            this.g("Channel");
        }
    }
    ToolActionRadioInfoDescription.$t = /*@__PURE__*/ markType(ToolActionRadioInfoDescription, 'ToolActionRadioInfoDescription', ToolActionInfoDescription.$);
    ToolActionRadioInfoDescription.__marshalByValue1 = true;
    ToolActionRadioInfoDescription.__marshalByValueAlias1 = "ToolActionRadioInfo";
    return ToolActionRadioInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionRadioInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionRadioInfoDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionRadioInfoDescriptionMetadata.a == null) {
                ToolActionRadioInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionRadioInfoDescriptionMetadata.c(ToolActionRadioInfoDescriptionMetadata.a);
            }
            if (a.k(ToolActionRadioInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionRadioInfoDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionInfoDescriptionMetadata.c(a);
            a.item("IsChecked", "Boolean");
            a.item("Channel", "String");
        }
        static d(a) {
            ToolActionRadioInfoDescriptionMetadata.b(a);
            a.ae("ToolActionRadioInfo", () => new ToolActionRadioInfoDescription());
            a.ad("ToolActionRadioInfo", ToolActionRadioInfoDescriptionMetadata.a);
        }
    }
    ToolActionRadioInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionRadioInfoDescriptionMetadata, 'ToolActionRadioInfoDescriptionMetadata');
    ToolActionRadioInfoDescriptionMetadata.a = null;
    return ToolActionRadioInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionSeparatorDescription = /*@__PURE__*/ (() => {
    class ToolActionSeparatorDescription extends ToolActionDescription {
        get_type() {
            return "ToolActionSeparator";
        }
        constructor() {
            super();
            this.dk = 0;
            this.di = false;
        }
        get size() {
            return this.dk;
        }
        set size(a) {
            this.dk = a;
            this.g("Size");
        }
        get isGroupHeaderSeparator() {
            return this.di;
        }
        set isGroupHeaderSeparator(a) {
            this.di = a;
            this.g("IsGroupHeaderSeparator");
        }
    }
    ToolActionSeparatorDescription.$t = /*@__PURE__*/ markType(ToolActionSeparatorDescription, 'ToolActionSeparatorDescription', ToolActionDescription.$);
    return ToolActionSeparatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionSeparatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionSeparatorDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionSeparatorDescriptionMetadata.a == null) {
                ToolActionSeparatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionSeparatorDescriptionMetadata.c(ToolActionSeparatorDescriptionMetadata.a);
            }
            if (a.k(ToolActionSeparatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionSeparatorDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionDescriptionMetadata.c(a);
            a.item("Size", "Number:double");
            a.item("IsGroupHeaderSeparator", "Boolean");
        }
        static d(a) {
            ToolActionSeparatorDescriptionMetadata.b(a);
            a.ae("ToolActionSeparator", () => new ToolActionSeparatorDescription());
            a.ad("ToolActionSeparator", ToolActionSeparatorDescriptionMetadata.a);
        }
    }
    ToolActionSeparatorDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionSeparatorDescriptionMetadata, 'ToolActionSeparatorDescriptionMetadata');
    ToolActionSeparatorDescriptionMetadata.a = null;
    return ToolActionSeparatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionSeparatorDescriptionModule = /*@__PURE__*/ (() => {
    class ToolActionSeparatorDescriptionModule extends Base {
        static register(a) {
            ToolActionSeparatorDescriptionMetadata.d(a);
        }
    }
    ToolActionSeparatorDescriptionModule.$t = /*@__PURE__*/ markType(ToolActionSeparatorDescriptionModule, 'ToolActionSeparatorDescriptionModule');
    return ToolActionSeparatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionSeparatorInfoDescription = /*@__PURE__*/ (() => {
    class ToolActionSeparatorInfoDescription extends ToolActionInfoDescription {
        get_type() {
            return "ToolActionSeparatorInfo";
        }
        constructor() {
            super();
            this.bb = 0;
            this.a9 = false;
        }
        get size() {
            return this.bb;
        }
        set size(a) {
            this.bb = a;
            this.g("Size");
        }
        get isGroupHeaderSeparator() {
            return this.a9;
        }
        set isGroupHeaderSeparator(a) {
            this.a9 = a;
            this.g("IsGroupHeaderSeparator");
        }
    }
    ToolActionSeparatorInfoDescription.$t = /*@__PURE__*/ markType(ToolActionSeparatorInfoDescription, 'ToolActionSeparatorInfoDescription', ToolActionInfoDescription.$);
    ToolActionSeparatorInfoDescription.__marshalByValue1 = true;
    ToolActionSeparatorInfoDescription.__marshalByValueAlias1 = "ToolActionSeparatorInfo";
    return ToolActionSeparatorInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionSeparatorInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionSeparatorInfoDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionSeparatorInfoDescriptionMetadata.a == null) {
                ToolActionSeparatorInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionSeparatorInfoDescriptionMetadata.c(ToolActionSeparatorInfoDescriptionMetadata.a);
            }
            if (a.k(ToolActionSeparatorInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionSeparatorInfoDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionInfoDescriptionMetadata.c(a);
            a.item("Size", "Number:double");
            a.item("IsGroupHeaderSeparator", "Boolean");
        }
        static d(a) {
            ToolActionSeparatorInfoDescriptionMetadata.b(a);
            a.ae("ToolActionSeparatorInfo", () => new ToolActionSeparatorInfoDescription());
            a.ad("ToolActionSeparatorInfo", ToolActionSeparatorInfoDescriptionMetadata.a);
        }
    }
    ToolActionSeparatorInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionSeparatorInfoDescriptionMetadata, 'ToolActionSeparatorInfoDescriptionMetadata');
    ToolActionSeparatorInfoDescriptionMetadata.a = null;
    return ToolActionSeparatorInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionSubPanelDescription = /*@__PURE__*/ (() => {
    class ToolActionSubPanelDescription extends ToolActionDescription {
        get_type() {
            return "ToolActionSubPanel";
        }
        constructor() {
            super();
        }
    }
    ToolActionSubPanelDescription.$t = /*@__PURE__*/ markType(ToolActionSubPanelDescription, 'ToolActionSubPanelDescription', ToolActionDescription.$);
    return ToolActionSubPanelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionSubPanelDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolActionSubPanelDescriptionMetadata extends Base {
        static b(a) {
            if (ToolActionSubPanelDescriptionMetadata.a == null) {
                ToolActionSubPanelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolActionSubPanelDescriptionMetadata.c(ToolActionSubPanelDescriptionMetadata.a);
            }
            if (a.k(ToolActionSubPanelDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolActionSubPanelDescriptionMetadata.a);
        }
        static c(a) {
            ToolActionDescriptionMetadata.c(a);
        }
        static d(a) {
            ToolActionSubPanelDescriptionMetadata.b(a);
            a.ae("ToolActionSubPanel", () => new ToolActionSubPanelDescription());
            a.ad("ToolActionSubPanel", ToolActionSubPanelDescriptionMetadata.a);
        }
    }
    ToolActionSubPanelDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolActionSubPanelDescriptionMetadata, 'ToolActionSubPanelDescriptionMetadata');
    ToolActionSubPanelDescriptionMetadata.a = null;
    return ToolActionSubPanelDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolActionSubPanelDescriptionModule = /*@__PURE__*/ (() => {
    class ToolActionSubPanelDescriptionModule extends Base {
        static register(a) {
            ToolActionSubPanelDescriptionMetadata.d(a);
        }
    }
    ToolActionSubPanelDescriptionModule.$t = /*@__PURE__*/ markType(ToolActionSubPanelDescriptionModule, 'ToolActionSubPanelDescriptionModule');
    return ToolActionSubPanelDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolbarDescription = /*@__PURE__*/ (() => {
    class ToolbarDescription extends Description {
        get_type() {
            return "Toolbar";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.ax = null;
            this.j = null;
            this.h = null;
            this.i = null;
            this.be = null;
            this.bl = null;
            this.aw = null;
            this.bg = null;
            this.a4 = null;
            this.bf = null;
            this.a9 = null;
            this.bm = null;
            this.a3 = null;
            this.a6 = null;
            this.bo = null;
            this.bn = null;
            this.ab = 0;
            this.ac = 0;
            this.ba = null;
            this.bb = null;
            this.ay = null;
            this.p = 0;
            this.az = null;
            this.a0 = null;
            this.bh = null;
            this.aa = 0;
            this.bi = null;
            this.bj = null;
            this.x = 0;
            this.y = 0;
            this.z = 0;
            this.w = 0;
            this.t = 0;
            this.u = 0;
            this.v = 0;
            this.s = 0;
            this.n = false;
            this.r = 0;
            this.q = 0;
            this.a8 = null;
            this.bc = null;
            this.bp = null;
            this.a1 = null;
            this.bq = null;
            this.a2 = null;
            this.as = 0;
            this.bk = null;
            this.a5 = null;
            this.ar = 0;
            this.bd = null;
            this.br = null;
            this.a7 = null;
            this.av = null;
        }
        get baseTheme() {
            return this.ax;
        }
        set baseTheme(a) {
            this.ax = a;
            this.g("BaseTheme");
        }
        get autoGeneratedActions() {
            return this.j;
        }
        set autoGeneratedActions(a) {
            this.j = a;
            this.g("AutoGeneratedActions");
        }
        get actions() {
            return this.h;
        }
        set actions(a) {
            this.h = a;
            this.g("Actions");
        }
        get actualActions() {
            return this.i;
        }
        set actualActions(a) {
            this.i = a;
            this.g("ActualActions");
        }
        get orientation() {
            return this.be;
        }
        set orientation(a) {
            this.be = a;
            this.g("Orientation");
        }
        get targetRef() {
            return this.bl;
        }
        set targetRef(a) {
            this.bl = a;
            this.g("TargetRef");
        }
        get backgroundColor() {
            return this.aw;
        }
        set backgroundColor(a) {
            this.aw = a;
            this.g("BackgroundColor");
        }
        get submenuBackgroundColor() {
            return this.bg;
        }
        set submenuBackgroundColor(a) {
            this.bg = a;
            this.g("SubmenuBackgroundColor");
        }
        get groupHeaderBackgroundColor() {
            return this.a4;
        }
        set groupHeaderBackgroundColor(a) {
            this.a4 = a;
            this.g("GroupHeaderBackgroundColor");
        }
        get separatorBackgroundColor() {
            return this.bf;
        }
        set separatorBackgroundColor(a) {
            this.bf = a;
            this.g("SeparatorBackgroundColor");
        }
        get hoverBackgroundColor() {
            return this.a9;
        }
        set hoverBackgroundColor(a) {
            this.a9 = a;
            this.g("HoverBackgroundColor");
        }
        get textColor() {
            return this.bm;
        }
        set textColor(a) {
            this.bm = a;
            this.g("TextColor");
        }
        get disabledTextColor() {
            return this.a3;
        }
        set disabledTextColor(a) {
            this.a3 = a;
            this.g("DisabledTextColor");
        }
        get groupHeaderTextColor() {
            return this.a6;
        }
        set groupHeaderTextColor(a) {
            this.a6 = a;
            this.g("GroupHeaderTextColor");
        }
        get toolTipTextColor() {
            return this.bo;
        }
        set toolTipTextColor(a) {
            this.bo = a;
            this.g("ToolTipTextColor");
        }
        get toolTipBackgroundColor() {
            return this.bn;
        }
        set toolTipBackgroundColor(a) {
            this.bn = a;
            this.g("ToolTipBackgroundColor");
        }
        get toolTipCornerRadius() {
            return this.ab;
        }
        set toolTipCornerRadius(a) {
            this.ab = a;
            this.g("ToolTipCornerRadius");
        }
        get toolTipElevation() {
            return this.ac;
        }
        set toolTipElevation(a) {
            this.ac = a;
            this.g("ToolTipElevation");
        }
        get iconFill() {
            return this.ba;
        }
        set iconFill(a) {
            this.ba = a;
            this.g("IconFill");
        }
        get iconStroke() {
            return this.bb;
        }
        set iconStroke(a) {
            this.bb = a;
            this.g("IconStroke");
        }
        get cellFontFamily() {
            return this.ay;
        }
        set cellFontFamily(a) {
            this.ay = a;
            this.g("CellFontFamily");
        }
        get cellFontSize() {
            return this.p;
        }
        set cellFontSize(a) {
            this.p = a;
            this.g("CellFontSize");
        }
        get cellFontStyle() {
            return this.az;
        }
        set cellFontStyle(a) {
            this.az = a;
            this.g("CellFontStyle");
        }
        get cellFontWeight() {
            return this.a0;
        }
        set cellFontWeight(a) {
            this.a0 = a;
            this.g("CellFontWeight");
        }
        get subtitleFontFamily() {
            return this.bh;
        }
        set subtitleFontFamily(a) {
            this.bh = a;
            this.g("SubtitleFontFamily");
        }
        get subtitleFontSize() {
            return this.aa;
        }
        set subtitleFontSize(a) {
            this.aa = a;
            this.g("SubtitleFontSize");
        }
        get subtitleFontStyle() {
            return this.bi;
        }
        set subtitleFontStyle(a) {
            this.bi = a;
            this.g("SubtitleFontStyle");
        }
        get subtitleFontWeight() {
            return this.bj;
        }
        set subtitleFontWeight(a) {
            this.bj = a;
            this.g("SubtitleFontWeight");
        }
        get separatorVerticalPaddingLeft() {
            return this.x;
        }
        set separatorVerticalPaddingLeft(a) {
            this.x = a;
            this.g("SeparatorVerticalPaddingLeft");
        }
        get separatorVerticalPaddingRight() {
            return this.y;
        }
        set separatorVerticalPaddingRight(a) {
            this.y = a;
            this.g("SeparatorVerticalPaddingRight");
        }
        get separatorVerticalPaddingTop() {
            return this.z;
        }
        set separatorVerticalPaddingTop(a) {
            this.z = a;
            this.g("SeparatorVerticalPaddingTop");
        }
        get separatorVerticalPaddingBottom() {
            return this.w;
        }
        set separatorVerticalPaddingBottom(a) {
            this.w = a;
            this.g("SeparatorVerticalPaddingBottom");
        }
        get separatorHorizontalPaddingLeft() {
            return this.t;
        }
        set separatorHorizontalPaddingLeft(a) {
            this.t = a;
            this.g("SeparatorHorizontalPaddingLeft");
        }
        get separatorHorizontalPaddingRight() {
            return this.u;
        }
        set separatorHorizontalPaddingRight(a) {
            this.u = a;
            this.g("SeparatorHorizontalPaddingRight");
        }
        get separatorHorizontalPaddingTop() {
            return this.v;
        }
        set separatorHorizontalPaddingTop(a) {
            this.v = a;
            this.g("SeparatorHorizontalPaddingTop");
        }
        get separatorHorizontalPaddingBottom() {
            return this.s;
        }
        set separatorHorizontalPaddingBottom(a) {
            this.s = a;
            this.g("SeparatorHorizontalPaddingBottom");
        }
        get showOnHover() {
            return this.n;
        }
        set showOnHover(a) {
            this.n = a;
            this.g("ShowOnHover");
        }
        get highlightWidth() {
            return this.r;
        }
        set highlightWidth(a) {
            this.r = a;
            this.g("HighlightWidth");
        }
        get highlightRadius() {
            return this.q;
        }
        set highlightRadius(a) {
            this.q = a;
            this.g("HighlightRadius");
        }
        get highlightColor() {
            return this.a8;
        }
        set highlightColor(a) {
            this.a8 = a;
            this.g("HighlightColor");
        }
        get menuArrowStroke() {
            return this.bc;
        }
        set menuArrowStroke(a) {
            this.bc = a;
            this.g("MenuArrowStroke");
        }
        get uncheckedBackgroundColor() {
            return this.bp;
        }
        set uncheckedBackgroundColor(a) {
            this.bp = a;
            this.g("UncheckedBackgroundColor");
        }
        get checkedBackgroundColor() {
            return this.a1;
        }
        set checkedBackgroundColor(a) {
            this.a1 = a;
            this.g("CheckedBackgroundColor");
        }
        get uncheckedBorderColor() {
            return this.bq;
        }
        set uncheckedBorderColor(a) {
            this.bq = a;
            this.g("UncheckedBorderColor");
        }
        get checkedBorderColor() {
            return this.a2;
        }
        set checkedBorderColor(a) {
            this.a2 = a;
            this.g("CheckedBorderColor");
        }
        get rowHeight() {
            return this.as;
        }
        set rowHeight(a) {
            this.as = a;
            this.g("RowHeight");
        }
        get subtitleTextColor() {
            return this.bk;
        }
        set subtitleTextColor(a) {
            this.bk = a;
            this.g("SubtitleTextColor");
        }
        get groupHeaderSubtitleTextColor() {
            return this.a5;
        }
        set groupHeaderSubtitleTextColor(a) {
            this.a5 = a;
            this.g("GroupHeaderSubtitleTextColor");
        }
        get dropdownDelay() {
            return this.ar;
        }
        set dropdownDelay(a) {
            this.ar = a;
            this.g("DropdownDelay");
        }
        get onCommandRef() {
            return this.bd;
        }
        set onCommandRef(a) {
            this.bd = a;
            this.g("OnCommandRef");
        }
        get width() {
            return this.br;
        }
        set width(a) {
            this.br = a;
            this.g("Width");
        }
        get height() {
            return this.a7;
        }
        set height(a) {
            this.a7 = a;
            this.g("Height");
        }
        get background() {
            return this.av;
        }
        set background(a) {
            this.av = a;
            this.g("Background");
        }
    }
    ToolbarDescription.$t = /*@__PURE__*/ markType(ToolbarDescription, 'ToolbarDescription', Description.$);
    return ToolbarDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolbarDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolbarDescriptionMetadata extends Base {
        static b(a) {
            if (ToolbarDescriptionMetadata.a == null) {
                ToolbarDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolbarDescriptionMetadata.c(ToolbarDescriptionMetadata.a);
            }
            if (a.k(ToolbarDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolbarDescriptionMetadata.a);
            ToolCommandEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("AutoGeneratedActions", "Collection:ToolAction:ToolActionCollection:ToolAction");
            a.item("Actions", "Collection:ToolAction:ToolActionCollection:ToolAction");
            a.item("ActualActions", "Collection:ToolAction:ToolActionCollection:ToolAction");
            a.item("Orientation", "ExportedType:string:ToolbarOrientation");
            a.item("Orientation@names", "Vertical;Horizontal");
            a.item("TargetRef", "(w:Target,wf:Target)DataRef::object");
            a.item("BackgroundColor", "Brush");
            a.item("SubmenuBackgroundColor", "Brush");
            a.item("GroupHeaderBackgroundColor", "Brush");
            a.item("SeparatorBackgroundColor", "Brush");
            a.item("HoverBackgroundColor", "Brush");
            a.item("TextColor", "Brush");
            a.item("DisabledTextColor", "Brush");
            a.item("GroupHeaderTextColor", "Brush");
            a.item("ToolTipTextColor", "Brush");
            a.item("ToolTipBackgroundColor", "Brush");
            a.item("ToolTipCornerRadius", "Number:double");
            a.item("ToolTipElevation", "Number:double");
            a.item("IconFill", "Brush");
            a.item("IconStroke", "Brush");
            a.item("CellFontFamily", "(w:CellFontFamily/FontFamilyTransform,xam:CellFontFamily,wf:CellFontFamily,web:cellTextStyle/FontFamilyTransform)String");
            a.item("CellFontSize", "(w:CellFontSize,xam:CellFontSize,wf:CellFontSize,web:cellTextStyle/FontSizeTransform)Number:double");
            a.item("CellFontStyle", "(w:CellFontStyle/FontStyleTransform,xam:CellFontFamily/FontStyleTransform,wf:CellFontFamily/FontStyleTransform,web:cellTextStyle/FontStyleTransform)String");
            a.item("CellFontWeight", "(w:CellFontWeight/FontWeightTransform,xam:CellFontFamily/FontWeightTransform,wf:CellFontFamily/FontWeightTransform,web:cellTextStyle/FontWeightTransform)String");
            a.item("SubtitleFontFamily", "(w:SubtitleFontFamily/FontFamilyTransform,xam:SubtitleFontFamily,wf:SubtitleFontFamily,web:subtitleTextStyle/FontFamilyTransform)String");
            a.item("SubtitleFontSize", "(w:SubtitleFontSize,xam:SubtitleFontSize,wf:SubtitleFontSize,web:subtitleTextStyle/FontSizeTransform)Number:double");
            a.item("SubtitleFontStyle", "(w:SubtitleFontStyle/FontStyleTransform,xam:SubtitleFontFamily/FontStyleTransform,wf:SubtitleFontFamily/FontStyleTransform,web:subtitleTextStyle/FontStyleTransform)String");
            a.item("SubtitleFontWeight", "(w:SubtitleFontWeight/FontWeightTransform,xam:SubtitleFontFamily/FontWeightTransform,wf:SubtitleFontFamily/FontWeightTransform,web:subtitleTextStyle/FontWeightTransform)String");
            a.item("SeparatorVerticalPaddingLeft", "Number:double");
            a.item("SeparatorVerticalPaddingRight", "Number:double");
            a.item("SeparatorVerticalPaddingTop", "Number:double");
            a.item("SeparatorVerticalPaddingBottom", "Number:double");
            a.item("SeparatorHorizontalPaddingLeft", "Number:double");
            a.item("SeparatorHorizontalPaddingRight", "Number:double");
            a.item("SeparatorHorizontalPaddingTop", "Number:double");
            a.item("SeparatorHorizontalPaddingBottom", "Number:double");
            a.item("ShowOnHover", "Boolean");
            a.item("HighlightWidth", "Number:double");
            a.item("HighlightRadius", "Number:double");
            a.item("HighlightColor", "Brush");
            a.item("MenuArrowStroke", "Brush");
            a.item("UncheckedBackgroundColor", "Brush");
            a.item("CheckedBackgroundColor", "Brush");
            a.item("UncheckedBorderColor", "Brush");
            a.item("CheckedBorderColor", "Brush");
            a.item("RowHeight", "Number:int");
            a.item("SubtitleTextColor", "Brush");
            a.item("GroupHeaderSubtitleTextColor", "Brush");
            a.item("DropdownDelay", "Number:int");
            a.item("OnCommandRef", "EventRef::onCommand");
            ToolbarDescriptionMetadata.e(a);
        }
        static d(a) {
            ToolbarDescriptionMetadata.b(a);
            a.ae("Toolbar", () => new ToolbarDescription());
            a.ad("Toolbar", ToolbarDescriptionMetadata.a);
        }
        static e(a) {
            a.item("_qualifiedName", "String:Infragistics.Controls.Layouts.XamToolbar");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
    }
    ToolbarDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolbarDescriptionMetadata, 'ToolbarDescriptionMetadata');
    ToolbarDescriptionMetadata.a = null;
    return ToolbarDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolPanelDescription = /*@__PURE__*/ (() => {
    class ToolPanelDescription extends Description {
        get_type() {
            return "ToolPanel";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = false;
            this.b4 = null;
            this.x = 0;
            this.b5 = null;
            this.b6 = null;
            this.cp = null;
            this.ai = 0;
            this.cq = null;
            this.cr = null;
            this.b3 = null;
            this.b2 = null;
            this.bh = null;
            this.co = null;
            this.bv = null;
            this.cb = null;
            this.bl = null;
            this.cn = null;
            this.bu = null;
            this.cc = null;
            this.bm = null;
            this.cg = null;
            this.bq = null;
            this.ct = null;
            this.bx = null;
            this.bw = null;
            this.cs = null;
            this.ca = null;
            this.bk = null;
            this.ce = null;
            this.bo = null;
            this.cd = null;
            this.bn = null;
            this.cv = null;
            this.bz = null;
            this.cu = null;
            this.by = null;
            this.aj = 0;
            this.v = 0;
            this.ak = 0;
            this.w = 0;
            this.ch = null;
            this.br = null;
            this.ci = null;
            this.bs = null;
            this.af = 0;
            this.s = 0;
            this.ag = 0;
            this.t = 0;
            this.ah = 0;
            this.u = 0;
            this.ae = 0;
            this.r = 0;
            this.ab = 0;
            this.o = 0;
            this.ac = 0;
            this.p = 0;
            this.ad = 0;
            this.q = 0;
            this.aa = 0;
            this.n = 0;
            this.cm = null;
            this.bd = 0;
            this.z = 0;
            this.m = 0;
            this.y = 0;
            this.l = 0;
            this.cf = null;
            this.bp = null;
            this.cj = null;
            this.bt = null;
            this.cw = null;
            this.b0 = null;
            this.b7 = null;
            this.bi = null;
            this.cx = null;
            this.b1 = null;
            this.b8 = null;
            this.bj = null;
            this.bc = 0;
            this.bb = 0;
            this.ck = null;
            this.b9 = null;
            this.cl = null;
        }
        get actions() {
            return this.h;
        }
        set actions(a) {
            this.h = a;
            this.g("Actions");
        }
        get showOnHover() {
            return this.j;
        }
        set showOnHover(a) {
            this.j = a;
            this.g("ShowOnHover");
        }
        get cellFontFamily() {
            return this.b4;
        }
        set cellFontFamily(a) {
            this.b4 = a;
            this.g("CellFontFamily");
        }
        get cellFontSize() {
            return this.x;
        }
        set cellFontSize(a) {
            this.x = a;
            this.g("CellFontSize");
        }
        get cellFontStyle() {
            return this.b5;
        }
        set cellFontStyle(a) {
            this.b5 = a;
            this.g("CellFontStyle");
        }
        get cellFontWeight() {
            return this.b6;
        }
        set cellFontWeight(a) {
            this.b6 = a;
            this.g("CellFontWeight");
        }
        get subtitleFontFamily() {
            return this.cp;
        }
        set subtitleFontFamily(a) {
            this.cp = a;
            this.g("SubtitleFontFamily");
        }
        get subtitleFontSize() {
            return this.ai;
        }
        set subtitleFontSize(a) {
            this.ai = a;
            this.g("SubtitleFontSize");
        }
        get subtitleFontStyle() {
            return this.cq;
        }
        set subtitleFontStyle(a) {
            this.cq = a;
            this.g("SubtitleFontStyle");
        }
        get subtitleFontWeight() {
            return this.cr;
        }
        set subtitleFontWeight(a) {
            this.cr = a;
            this.g("SubtitleFontWeight");
        }
        get baseTheme() {
            return this.b3;
        }
        set baseTheme(a) {
            this.b3 = a;
            this.g("BaseTheme");
        }
        get backgroundColor() {
            return this.b2;
        }
        set backgroundColor(a) {
            this.b2 = a;
            this.g("BackgroundColor");
        }
        get actualBackgroundColor() {
            return this.bh;
        }
        set actualBackgroundColor(a) {
            this.bh = a;
            this.g("ActualBackgroundColor");
        }
        get submenuBackgroundColor() {
            return this.co;
        }
        set submenuBackgroundColor(a) {
            this.co = a;
            this.g("SubmenuBackgroundColor");
        }
        get actualSubmenuBackgroundColor() {
            return this.bv;
        }
        set actualSubmenuBackgroundColor(a) {
            this.bv = a;
            this.g("ActualSubmenuBackgroundColor");
        }
        get groupHeaderBackgroundColor() {
            return this.cb;
        }
        set groupHeaderBackgroundColor(a) {
            this.cb = a;
            this.g("GroupHeaderBackgroundColor");
        }
        get actualGroupHeaderBackgroundColor() {
            return this.bl;
        }
        set actualGroupHeaderBackgroundColor(a) {
            this.bl = a;
            this.g("ActualGroupHeaderBackgroundColor");
        }
        get separatorBackgroundColor() {
            return this.cn;
        }
        set separatorBackgroundColor(a) {
            this.cn = a;
            this.g("SeparatorBackgroundColor");
        }
        get actualSeparatorBackgroundColor() {
            return this.bu;
        }
        set actualSeparatorBackgroundColor(a) {
            this.bu = a;
            this.g("ActualSeparatorBackgroundColor");
        }
        get groupHeaderSeparatorBackgroundColor() {
            return this.cc;
        }
        set groupHeaderSeparatorBackgroundColor(a) {
            this.cc = a;
            this.g("GroupHeaderSeparatorBackgroundColor");
        }
        get actualGroupHeaderSeparatorBackgroundColor() {
            return this.bm;
        }
        set actualGroupHeaderSeparatorBackgroundColor(a) {
            this.bm = a;
            this.g("ActualGroupHeaderSeparatorBackgroundColor");
        }
        get hoverBackgroundColor() {
            return this.cg;
        }
        set hoverBackgroundColor(a) {
            this.cg = a;
            this.g("HoverBackgroundColor");
        }
        get actualHoverBackgroundColor() {
            return this.bq;
        }
        set actualHoverBackgroundColor(a) {
            this.bq = a;
            this.g("ActualHoverBackgroundColor");
        }
        get textColor() {
            return this.ct;
        }
        set textColor(a) {
            this.ct = a;
            this.g("TextColor");
        }
        get actualTextColor() {
            return this.bx;
        }
        set actualTextColor(a) {
            this.bx = a;
            this.g("ActualTextColor");
        }
        get actualSubtitleTextColor() {
            return this.bw;
        }
        set actualSubtitleTextColor(a) {
            this.bw = a;
            this.g("ActualSubtitleTextColor");
        }
        get subtitleTextColor() {
            return this.cs;
        }
        set subtitleTextColor(a) {
            this.cs = a;
            this.g("SubtitleTextColor");
        }
        get disabledTextColor() {
            return this.ca;
        }
        set disabledTextColor(a) {
            this.ca = a;
            this.g("DisabledTextColor");
        }
        get actualDisabledTextColor() {
            return this.bk;
        }
        set actualDisabledTextColor(a) {
            this.bk = a;
            this.g("ActualDisabledTextColor");
        }
        get groupHeaderTextColor() {
            return this.ce;
        }
        set groupHeaderTextColor(a) {
            this.ce = a;
            this.g("GroupHeaderTextColor");
        }
        get actualGroupHeaderTextColor() {
            return this.bo;
        }
        set actualGroupHeaderTextColor(a) {
            this.bo = a;
            this.g("ActualGroupHeaderTextColor");
        }
        get groupHeaderSubtitleTextColor() {
            return this.cd;
        }
        set groupHeaderSubtitleTextColor(a) {
            this.cd = a;
            this.g("GroupHeaderSubtitleTextColor");
        }
        get actualGroupHeaderSubtitleTextColor() {
            return this.bn;
        }
        set actualGroupHeaderSubtitleTextColor(a) {
            this.bn = a;
            this.g("ActualGroupHeaderSubtitleTextColor");
        }
        get toolTipTextColor() {
            return this.cv;
        }
        set toolTipTextColor(a) {
            this.cv = a;
            this.g("ToolTipTextColor");
        }
        get actualToolTipTextColor() {
            return this.bz;
        }
        set actualToolTipTextColor(a) {
            this.bz = a;
            this.g("ActualToolTipTextColor");
        }
        get toolTipBackgroundColor() {
            return this.cu;
        }
        set toolTipBackgroundColor(a) {
            this.cu = a;
            this.g("ToolTipBackgroundColor");
        }
        get actualToolTipBackgroundColor() {
            return this.by;
        }
        set actualToolTipBackgroundColor(a) {
            this.by = a;
            this.g("ActualToolTipBackgroundColor");
        }
        get toolTipCornerRadius() {
            return this.aj;
        }
        set toolTipCornerRadius(a) {
            this.aj = a;
            this.g("ToolTipCornerRadius");
        }
        get actualToolTipCornerRadius() {
            return this.v;
        }
        set actualToolTipCornerRadius(a) {
            this.v = a;
            this.g("ActualToolTipCornerRadius");
        }
        get toolTipElevation() {
            return this.ak;
        }
        set toolTipElevation(a) {
            this.ak = a;
            this.g("ToolTipElevation");
        }
        get actualToolTipElevation() {
            return this.w;
        }
        set actualToolTipElevation(a) {
            this.w = a;
            this.g("ActualToolTipElevation");
        }
        get iconFill() {
            return this.ch;
        }
        set iconFill(a) {
            this.ch = a;
            this.g("IconFill");
        }
        get actualIconFill() {
            return this.br;
        }
        set actualIconFill(a) {
            this.br = a;
            this.g("ActualIconFill");
        }
        get iconStroke() {
            return this.ci;
        }
        set iconStroke(a) {
            this.ci = a;
            this.g("IconStroke");
        }
        get actualIconStroke() {
            return this.bs;
        }
        set actualIconStroke(a) {
            this.bs = a;
            this.g("ActualIconStroke");
        }
        get separatorVerticalPaddingLeft() {
            return this.af;
        }
        set separatorVerticalPaddingLeft(a) {
            this.af = a;
            this.g("SeparatorVerticalPaddingLeft");
        }
        get actualSeparatorVerticalPaddingLeft() {
            return this.s;
        }
        set actualSeparatorVerticalPaddingLeft(a) {
            this.s = a;
            this.g("ActualSeparatorVerticalPaddingLeft");
        }
        get separatorVerticalPaddingRight() {
            return this.ag;
        }
        set separatorVerticalPaddingRight(a) {
            this.ag = a;
            this.g("SeparatorVerticalPaddingRight");
        }
        get actualSeparatorVerticalPaddingRight() {
            return this.t;
        }
        set actualSeparatorVerticalPaddingRight(a) {
            this.t = a;
            this.g("ActualSeparatorVerticalPaddingRight");
        }
        get separatorVerticalPaddingTop() {
            return this.ah;
        }
        set separatorVerticalPaddingTop(a) {
            this.ah = a;
            this.g("SeparatorVerticalPaddingTop");
        }
        get actualSeparatorVerticalPaddingTop() {
            return this.u;
        }
        set actualSeparatorVerticalPaddingTop(a) {
            this.u = a;
            this.g("ActualSeparatorVerticalPaddingTop");
        }
        get separatorVerticalPaddingBottom() {
            return this.ae;
        }
        set separatorVerticalPaddingBottom(a) {
            this.ae = a;
            this.g("SeparatorVerticalPaddingBottom");
        }
        get actualSeparatorVerticalPaddingBottom() {
            return this.r;
        }
        set actualSeparatorVerticalPaddingBottom(a) {
            this.r = a;
            this.g("ActualSeparatorVerticalPaddingBottom");
        }
        get separatorHorizontalPaddingLeft() {
            return this.ab;
        }
        set separatorHorizontalPaddingLeft(a) {
            this.ab = a;
            this.g("SeparatorHorizontalPaddingLeft");
        }
        get actualSeparatorHorizontalPaddingLeft() {
            return this.o;
        }
        set actualSeparatorHorizontalPaddingLeft(a) {
            this.o = a;
            this.g("ActualSeparatorHorizontalPaddingLeft");
        }
        get separatorHorizontalPaddingRight() {
            return this.ac;
        }
        set separatorHorizontalPaddingRight(a) {
            this.ac = a;
            this.g("SeparatorHorizontalPaddingRight");
        }
        get actualSeparatorHorizontalPaddingRight() {
            return this.p;
        }
        set actualSeparatorHorizontalPaddingRight(a) {
            this.p = a;
            this.g("ActualSeparatorHorizontalPaddingRight");
        }
        get separatorHorizontalPaddingTop() {
            return this.ad;
        }
        set separatorHorizontalPaddingTop(a) {
            this.ad = a;
            this.g("SeparatorHorizontalPaddingTop");
        }
        get actualSeparatorHorizontalPaddingTop() {
            return this.q;
        }
        set actualSeparatorHorizontalPaddingTop(a) {
            this.q = a;
            this.g("ActualSeparatorHorizontalPaddingTop");
        }
        get separatorHorizontalPaddingBottom() {
            return this.aa;
        }
        set separatorHorizontalPaddingBottom(a) {
            this.aa = a;
            this.g("SeparatorHorizontalPaddingBottom");
        }
        get actualSeparatorHorizontalPaddingBottom() {
            return this.n;
        }
        set actualSeparatorHorizontalPaddingBottom(a) {
            this.n = a;
            this.g("ActualSeparatorHorizontalPaddingBottom");
        }
        get orientation() {
            return this.cm;
        }
        set orientation(a) {
            this.cm = a;
            this.g("Orientation");
        }
        get rowHeight() {
            return this.bd;
        }
        set rowHeight(a) {
            this.bd = a;
            this.g("RowHeight");
        }
        get highlightWidth() {
            return this.z;
        }
        set highlightWidth(a) {
            this.z = a;
            this.g("HighlightWidth");
        }
        get actualHighlightWidth() {
            return this.m;
        }
        set actualHighlightWidth(a) {
            this.m = a;
            this.g("ActualHighlightWidth");
        }
        get highlightRadius() {
            return this.y;
        }
        set highlightRadius(a) {
            this.y = a;
            this.g("HighlightRadius");
        }
        get actualHighlightRadius() {
            return this.l;
        }
        set actualHighlightRadius(a) {
            this.l = a;
            this.g("ActualHighlightRadius");
        }
        get highlightColor() {
            return this.cf;
        }
        set highlightColor(a) {
            this.cf = a;
            this.g("HighlightColor");
        }
        get actualHighlightColor() {
            return this.bp;
        }
        set actualHighlightColor(a) {
            this.bp = a;
            this.g("ActualHighlightColor");
        }
        get menuArrowStroke() {
            return this.cj;
        }
        set menuArrowStroke(a) {
            this.cj = a;
            this.g("MenuArrowStroke");
        }
        get actualMenuArrowStroke() {
            return this.bt;
        }
        set actualMenuArrowStroke(a) {
            this.bt = a;
            this.g("ActualMenuArrowStroke");
        }
        get uncheckedBackgroundColor() {
            return this.cw;
        }
        set uncheckedBackgroundColor(a) {
            this.cw = a;
            this.g("UncheckedBackgroundColor");
        }
        get actualUncheckedBackgroundColor() {
            return this.b0;
        }
        set actualUncheckedBackgroundColor(a) {
            this.b0 = a;
            this.g("ActualUncheckedBackgroundColor");
        }
        get checkedBackgroundColor() {
            return this.b7;
        }
        set checkedBackgroundColor(a) {
            this.b7 = a;
            this.g("CheckedBackgroundColor");
        }
        get actualCheckedBackgroundColor() {
            return this.bi;
        }
        set actualCheckedBackgroundColor(a) {
            this.bi = a;
            this.g("ActualCheckedBackgroundColor");
        }
        get uncheckedBorderColor() {
            return this.cx;
        }
        set uncheckedBorderColor(a) {
            this.cx = a;
            this.g("UncheckedBorderColor");
        }
        get actualUncheckedBorderColor() {
            return this.b1;
        }
        set actualUncheckedBorderColor(a) {
            this.b1 = a;
            this.g("ActualUncheckedBorderColor");
        }
        get checkedBorderColor() {
            return this.b8;
        }
        set checkedBorderColor(a) {
            this.b8 = a;
            this.g("CheckedBorderColor");
        }
        get actualCheckedBorderColor() {
            return this.bj;
        }
        set actualCheckedBorderColor(a) {
            this.bj = a;
            this.g("ActualCheckedBorderColor");
        }
        get dropdownDelay() {
            return this.bc;
        }
        set dropdownDelay(a) {
            this.bc = a;
            this.g("DropdownDelay");
        }
        get actualDropdownDelay() {
            return this.bb;
        }
        set actualDropdownDelay(a) {
            this.bb = a;
            this.g("ActualDropdownDelay");
        }
        get nestedActionMode() {
            return this.ck;
        }
        set nestedActionMode(a) {
            this.ck = a;
            this.g("NestedActionMode");
        }
        get contentRefreshedRef() {
            return this.b9;
        }
        set contentRefreshedRef(a) {
            this.b9 = a;
            this.g("ContentRefreshedRef");
        }
        get onCommandRef() {
            return this.cl;
        }
        set onCommandRef(a) {
            this.cl = a;
            this.g("OnCommandRef");
        }
    }
    ToolPanelDescription.$t = /*@__PURE__*/ markType(ToolPanelDescription, 'ToolPanelDescription', Description.$);
    return ToolPanelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolPanelContentRefreshedEventArgsDescription = /*@__PURE__*/ (() => {
    class ToolPanelContentRefreshedEventArgsDescription extends Description {
        get_type() {
            return "ToolPanelContentRefreshedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ToolPanelContentRefreshedEventArgsDescription.$t = /*@__PURE__*/ markType(ToolPanelContentRefreshedEventArgsDescription, 'ToolPanelContentRefreshedEventArgsDescription', Description.$);
    return ToolPanelContentRefreshedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolPanelContentRefreshedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolPanelContentRefreshedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ToolPanelContentRefreshedEventArgsDescriptionMetadata.a == null) {
                ToolPanelContentRefreshedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolPanelContentRefreshedEventArgsDescriptionMetadata.c(ToolPanelContentRefreshedEventArgsDescriptionMetadata.a);
            }
            if (a.k(ToolPanelContentRefreshedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolPanelContentRefreshedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ToolPanelContentRefreshedEventArgsDescriptionMetadata.b(a);
            a.ae("ToolPanelContentRefreshedEventArgs", () => new ToolPanelContentRefreshedEventArgsDescription());
            a.ad("ToolPanelContentRefreshedEventArgs", ToolPanelContentRefreshedEventArgsDescriptionMetadata.a);
        }
    }
    ToolPanelContentRefreshedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolPanelContentRefreshedEventArgsDescriptionMetadata, 'ToolPanelContentRefreshedEventArgsDescriptionMetadata');
    ToolPanelContentRefreshedEventArgsDescriptionMetadata.a = null;
    return ToolPanelContentRefreshedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolPanelDescriptionMetadata = /*@__PURE__*/ (() => {
    class ToolPanelDescriptionMetadata extends Base {
        static b(a) {
            if (ToolPanelDescriptionMetadata.a == null) {
                ToolPanelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ToolPanelDescriptionMetadata.c(ToolPanelDescriptionMetadata.a);
            }
            if (a.k(ToolPanelDescriptionMetadata.a)) {
                return;
            }
            a.ac(ToolPanelDescriptionMetadata.a);
            ToolPanelContentRefreshedEventArgsDescriptionMetadata.d(a);
            ToolCommandEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Actions", "Collection:ToolAction:ToolActionCollection:ToolAction");
            a.item("ShowOnHover", "Boolean");
            a.item("CellFontFamily", "(w:CellFontFamily/FontFamilyTransform,xam:CellFontFamily,wf:CellFontFamily,web:cellTextStyle/FontFamilyTransform)String");
            a.item("CellFontSize", "(w:CellFontSize,xam:CellFontSize,wf:CellFontSize,web:cellTextStyle/FontSizeTransform)Number:double");
            a.item("CellFontStyle", "(w:CellFontStyle/FontStyleTransform,xam:CellFontFamily/FontStyleTransform,wf:CellFontFamily/FontStyleTransform,web:cellTextStyle/FontStyleTransform)String");
            a.item("CellFontWeight", "(w:CellFontWeight/FontWeightTransform,xam:CellFontFamily/FontWeightTransform,wf:CellFontFamily/FontWeightTransform,web:cellTextStyle/FontWeightTransform)String");
            a.item("SubtitleFontFamily", "(w:SubtitleFontFamily/FontFamilyTransform,xam:SubtitleFontFamily,wf:SubtitleFontFamily,web:subtitleTextStyle/FontFamilyTransform)String");
            a.item("SubtitleFontSize", "(w:SubtitleFontSize,xam:SubtitleFontSize,wf:SubtitleFontSize,web:subtitleTextStyle/FontSizeTransform)Number:double");
            a.item("SubtitleFontStyle", "(w:SubtitleFontStyle/FontStyleTransform,xam:SubtitleFontFamily/FontStyleTransform,wf:SubtitleFontFamily/FontStyleTransform,web:subtitleTextStyle/FontStyleTransform)String");
            a.item("SubtitleFontWeight", "(w:SubtitleFontWeight/FontWeightTransform,xam:SubtitleFontFamily/FontWeightTransform,wf:SubtitleFontFamily/FontWeightTransform,web:subtitleTextStyle/FontWeightTransform)String");
            a.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            a.item("BaseTheme@names", "Default;DenaliLight;MaterialLight;SlingshotLight;SlingshotDark;RevealLight;RevealDark");
            a.item("BackgroundColor", "Brush");
            a.item("ActualBackgroundColor", "Brush");
            a.item("SubmenuBackgroundColor", "Brush");
            a.item("ActualSubmenuBackgroundColor", "Brush");
            a.item("GroupHeaderBackgroundColor", "Brush");
            a.item("ActualGroupHeaderBackgroundColor", "Brush");
            a.item("SeparatorBackgroundColor", "Brush");
            a.item("ActualSeparatorBackgroundColor", "Brush");
            a.item("GroupHeaderSeparatorBackgroundColor", "Brush");
            a.item("ActualGroupHeaderSeparatorBackgroundColor", "Brush");
            a.item("HoverBackgroundColor", "Brush");
            a.item("ActualHoverBackgroundColor", "Brush");
            a.item("TextColor", "Brush");
            a.item("ActualTextColor", "Brush");
            a.item("ActualSubtitleTextColor", "Brush");
            a.item("SubtitleTextColor", "Brush");
            a.item("DisabledTextColor", "Brush");
            a.item("ActualDisabledTextColor", "Brush");
            a.item("GroupHeaderTextColor", "Brush");
            a.item("ActualGroupHeaderTextColor", "Brush");
            a.item("GroupHeaderSubtitleTextColor", "Brush");
            a.item("ActualGroupHeaderSubtitleTextColor", "Brush");
            a.item("ToolTipTextColor", "Brush");
            a.item("ActualToolTipTextColor", "Brush");
            a.item("ToolTipBackgroundColor", "Brush");
            a.item("ActualToolTipBackgroundColor", "Brush");
            a.item("ToolTipCornerRadius", "Number:double");
            a.item("ActualToolTipCornerRadius", "Number:double");
            a.item("ToolTipElevation", "Number:double");
            a.item("ActualToolTipElevation", "Number:double");
            a.item("IconFill", "Brush");
            a.item("ActualIconFill", "Brush");
            a.item("IconStroke", "Brush");
            a.item("ActualIconStroke", "Brush");
            a.item("SeparatorVerticalPaddingLeft", "Number:double");
            a.item("ActualSeparatorVerticalPaddingLeft", "Number:double");
            a.item("SeparatorVerticalPaddingRight", "Number:double");
            a.item("ActualSeparatorVerticalPaddingRight", "Number:double");
            a.item("SeparatorVerticalPaddingTop", "Number:double");
            a.item("ActualSeparatorVerticalPaddingTop", "Number:double");
            a.item("SeparatorVerticalPaddingBottom", "Number:double");
            a.item("ActualSeparatorVerticalPaddingBottom", "Number:double");
            a.item("SeparatorHorizontalPaddingLeft", "Number:double");
            a.item("ActualSeparatorHorizontalPaddingLeft", "Number:double");
            a.item("SeparatorHorizontalPaddingRight", "Number:double");
            a.item("ActualSeparatorHorizontalPaddingRight", "Number:double");
            a.item("SeparatorHorizontalPaddingTop", "Number:double");
            a.item("ActualSeparatorHorizontalPaddingTop", "Number:double");
            a.item("SeparatorHorizontalPaddingBottom", "Number:double");
            a.item("ActualSeparatorHorizontalPaddingBottom", "Number:double");
            a.item("Orientation", "ExportedType:string:ToolPanelOrientation");
            a.item("Orientation@names", "Vertical;Horizontal");
            a.item("RowHeight", "Number:int");
            a.item("HighlightWidth", "Number:double");
            a.item("ActualHighlightWidth", "Number:double");
            a.item("HighlightRadius", "Number:double");
            a.item("ActualHighlightRadius", "Number:double");
            a.item("HighlightColor", "Brush");
            a.item("ActualHighlightColor", "Brush");
            a.item("MenuArrowStroke", "Brush");
            a.item("ActualMenuArrowStroke", "Brush");
            a.item("UncheckedBackgroundColor", "Brush");
            a.item("ActualUncheckedBackgroundColor", "Brush");
            a.item("CheckedBackgroundColor", "Brush");
            a.item("ActualCheckedBackgroundColor", "Brush");
            a.item("UncheckedBorderColor", "Brush");
            a.item("ActualUncheckedBorderColor", "Brush");
            a.item("CheckedBorderColor", "Brush");
            a.item("ActualCheckedBorderColor", "Brush");
            a.item("DropdownDelay", "Number:int");
            a.item("ActualDropdownDelay", "Number:int");
            a.item("NestedActionMode", "ExportedType:string:NestedActionMode");
            a.item("NestedActionMode@names", "Replace");
            a.item("ContentRefreshedRef", "EventRef::contentRefreshed");
            a.item("OnCommandRef", "EventRef::onCommand");
        }
        static d(a) {
            ToolPanelDescriptionMetadata.b(a);
            a.ae("ToolPanel", () => new ToolPanelDescription());
            a.ad("ToolPanel", ToolPanelDescriptionMetadata.a);
        }
    }
    ToolPanelDescriptionMetadata.$t = /*@__PURE__*/ markType(ToolPanelDescriptionMetadata, 'ToolPanelDescriptionMetadata');
    ToolPanelDescriptionMetadata.a = null;
    return ToolPanelDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransactionStateDescription = /*@__PURE__*/ (() => {
    class TransactionStateDescription extends Description {
        get_type() {
            return "TransactionState";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.i = null;
            this.j = null;
            this.k = null;
        }
        get idRef() {
            return this.h;
        }
        set idRef(a) {
            this.h = a;
            this.g("IdRef");
        }
        get transactionType() {
            return this.i;
        }
        set transactionType(a) {
            this.i = a;
            this.g("TransactionType");
        }
        get valueRef() {
            return this.j;
        }
        set valueRef(a) {
            this.j = a;
            this.g("ValueRef");
        }
        get versionRef() {
            return this.k;
        }
        set versionRef(a) {
            this.k = a;
            this.g("VersionRef");
        }
    }
    TransactionStateDescription.$t = /*@__PURE__*/ markType(TransactionStateDescription, 'TransactionStateDescription', Description.$);
    return TransactionStateDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransactionStateDescriptionMetadata = /*@__PURE__*/ (() => {
    class TransactionStateDescriptionMetadata extends Base {
        static b(a) {
            if (TransactionStateDescriptionMetadata.a == null) {
                TransactionStateDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TransactionStateDescriptionMetadata.c(TransactionStateDescriptionMetadata.a);
            }
            if (a.k(TransactionStateDescriptionMetadata.a)) {
                return;
            }
            a.ac(TransactionStateDescriptionMetadata.a);
        }
        static c(a) {
            a.item("IdRef", "(w:ID,xam:ID,wf:ID)DataRef");
            a.item("TransactionType", "ExportedType:string:TransactionType");
            a.item("TransactionType@names", "Add;Update;Delete");
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
            a.item("VersionRef", "(w:Version,wf:Version)DataRef");
        }
        static d(a) {
            TransactionStateDescriptionMetadata.b(a);
            a.ae("TransactionState", () => new TransactionStateDescription());
            a.ad("TransactionState", TransactionStateDescriptionMetadata.a);
        }
    }
    TransactionStateDescriptionMetadata.$t = /*@__PURE__*/ markType(TransactionStateDescriptionMetadata, 'TransactionStateDescriptionMetadata');
    TransactionStateDescriptionMetadata.a = null;
    return TransactionStateDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapDescription = /*@__PURE__*/ (() => {
    class TreemapDescription extends Description {
        get_type() {
            return "Treemap";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.da = null;
            this.c8 = null;
            this.b1 = null;
            this.c7 = null;
            this.cs = null;
            this.b2 = null;
            this.cp = null;
            this.b4 = null;
            this.cl = null;
            this.cm = null;
            this.y = 0;
            this.cn = null;
            this.h = null;
            this.i = null;
            this.b5 = null;
            this.l = false;
            this.bt = 0;
            this.q = 0;
            this.p = 0;
            this.cu = null;
            this.cr = null;
            this.c6 = null;
            this.cg = null;
            this.ca = null;
            this.c5 = null;
            this.cj = null;
            this.cb = null;
            this.c9 = null;
            this.b3 = null;
            this.ci = null;
            this.ch = null;
            this.b7 = null;
            this.r = 0;
            this.b8 = null;
            this.b9 = null;
            this.cd = null;
            this.s = 0;
            this.ce = null;
            this.cf = null;
            this.cc = null;
            this.v = 0;
            this.x = 0;
            this.w = 0;
            this.u = 0;
            this.ai = 0;
            this.ak = 0;
            this.aj = 0;
            this.ah = 0;
            this.ac = 0;
            this.ae = 0;
            this.ad = 0;
            this.ab = 0;
            this.an = 0;
            this.ar = 0;
            this.ap = 0;
            this.al = 0;
            this.ao = 0;
            this.as = 0;
            this.aq = 0;
            this.am = 0;
            this.cq = null;
            this.ct = null;
            this.t = 0;
            this.c4 = null;
            this.au = 0;
            this.ag = 0;
            this.cv = null;
            this.cw = null;
            this.af = 0;
            this.bv = 0;
            this.at = 0;
            this.o = 0;
            this.aa = 0;
            this.n = 0;
            this.bu = 0;
            this.co = null;
            this.bz = null;
            this.z = 0;
            this.b6 = null;
            this.c3 = null;
            this.c2 = null;
            this.cz = null;
            this.cx = null;
            this.cy = null;
            this.c0 = null;
            this.c1 = null;
            this.db = null;
            this.ck = null;
            this.b0 = null;
        }
        get valueMemberPath() {
            return this.da;
        }
        set valueMemberPath(a) {
            this.da = a;
            this.g("ValueMemberPath");
        }
        get rootTitle() {
            return this.c8;
        }
        set rootTitle(a) {
            this.c8 = a;
            this.g("RootTitle");
        }
        get breadcrumbSequence() {
            return this.b1;
        }
        set breadcrumbSequence(a) {
            this.b1 = a;
            this.g("BreadcrumbSequence");
        }
        get parentIdMemberPath() {
            return this.c7;
        }
        set parentIdMemberPath(a) {
            this.c7 = a;
            this.g("ParentIdMemberPath");
        }
        get labelMemberPath() {
            return this.cs;
        }
        set labelMemberPath(a) {
            this.cs = a;
            this.g("LabelMemberPath");
        }
        get customValueMemberPath() {
            return this.b2;
        }
        set customValueMemberPath(a) {
            this.b2 = a;
            this.g("CustomValueMemberPath");
        }
        get idMemberPath() {
            return this.cp;
        }
        set idMemberPath(a) {
            this.cp = a;
            this.g("IdMemberPath");
        }
        get dataSourceRef() {
            return this.b4;
        }
        set dataSourceRef(a) {
            this.b4 = a;
            this.g("DataSourceRef");
        }
        get highlightedDataSourceRef() {
            return this.cl;
        }
        set highlightedDataSourceRef(a) {
            this.cl = a;
            this.g("HighlightedDataSourceRef");
        }
        get highlightedValueMemberPath() {
            return this.cm;
        }
        set highlightedValueMemberPath(a) {
            this.cm = a;
            this.g("HighlightedValueMemberPath");
        }
        get highlightedValueOpacity() {
            return this.y;
        }
        set highlightedValueOpacity(a) {
            this.y = a;
            this.g("HighlightedValueOpacity");
        }
        get highlightedValuesDisplayMode() {
            return this.cn;
        }
        set highlightedValuesDisplayMode(a) {
            this.cn = a;
            this.g("HighlightedValuesDisplayMode");
        }
        get fillBrushes() {
            return this.h;
        }
        set fillBrushes(a) {
            this.h = a;
            this.g("FillBrushes");
        }
        get styleMappings() {
            return this.i;
        }
        set styleMappings(a) {
            this.i = a;
            this.g("StyleMappings");
        }
        get fillScaleMode() {
            return this.b5;
        }
        set fillScaleMode(a) {
            this.b5 = a;
            this.g("FillScaleMode");
        }
        get isFillScaleLogarithmic() {
            return this.l;
        }
        set isFillScaleLogarithmic(a) {
            this.l = a;
            this.g("IsFillScaleLogarithmic");
        }
        get fillScaleLogarithmBase() {
            return this.bt;
        }
        set fillScaleLogarithmBase(a) {
            this.bt = a;
            this.g("FillScaleLogarithmBase");
        }
        get fillScaleMinimumValue() {
            return this.q;
        }
        set fillScaleMinimumValue(a) {
            this.q = a;
            this.g("FillScaleMinimumValue");
        }
        get fillScaleMaximumValue() {
            return this.p;
        }
        set fillScaleMaximumValue(a) {
            this.p = a;
            this.g("FillScaleMaximumValue");
        }
        get labelVerticalFitMode() {
            return this.cu;
        }
        set labelVerticalFitMode(a) {
            this.cu = a;
            this.g("LabelVerticalFitMode");
        }
        get labelHorizontalFitMode() {
            return this.cr;
        }
        set labelHorizontalFitMode(a) {
            this.cr = a;
            this.g("LabelHorizontalFitMode");
        }
        get overlayHeaderHoverBackground() {
            return this.c6;
        }
        set overlayHeaderHoverBackground(a) {
            this.c6 = a;
            this.g("OverlayHeaderHoverBackground");
        }
        get headerHoverBackground() {
            return this.cg;
        }
        set headerHoverBackground(a) {
            this.cg = a;
            this.g("HeaderHoverBackground");
        }
        get headerBackground() {
            return this.ca;
        }
        set headerBackground(a) {
            this.ca = a;
            this.g("HeaderBackground");
        }
        get overlayHeaderBackground() {
            return this.c5;
        }
        set overlayHeaderBackground(a) {
            this.c5 = a;
            this.g("OverlayHeaderBackground");
        }
        get headerTextColor() {
            return this.cj;
        }
        set headerTextColor(a) {
            this.cj = a;
            this.g("HeaderTextColor");
        }
        get headerDarkTextColor() {
            return this.cb;
        }
        set headerDarkTextColor(a) {
            this.cb = a;
            this.g("HeaderDarkTextColor");
        }
        get textColor() {
            return this.c9;
        }
        set textColor(a) {
            this.c9 = a;
            this.g("TextColor");
        }
        get darkTextColor() {
            return this.b3;
        }
        set darkTextColor(a) {
            this.b3 = a;
            this.g("DarkTextColor");
        }
        get headerHoverTextColor() {
            return this.ci;
        }
        set headerHoverTextColor(a) {
            this.ci = a;
            this.g("HeaderHoverTextColor");
        }
        get headerHoverDarkTextColor() {
            return this.ch;
        }
        set headerHoverDarkTextColor(a) {
            this.ch = a;
            this.g("HeaderHoverDarkTextColor");
        }
        get fontFamily() {
            return this.b7;
        }
        set fontFamily(a) {
            this.b7 = a;
            this.g("FontFamily");
        }
        get fontSize() {
            return this.r;
        }
        set fontSize(a) {
            this.r = a;
            this.g("FontSize");
        }
        get fontStyle() {
            return this.b8;
        }
        set fontStyle(a) {
            this.b8 = a;
            this.g("FontStyle");
        }
        get fontWeight() {
            return this.b9;
        }
        set fontWeight(a) {
            this.b9 = a;
            this.g("FontWeight");
        }
        get headerFontFamily() {
            return this.cd;
        }
        set headerFontFamily(a) {
            this.cd = a;
            this.g("HeaderFontFamily");
        }
        get headerFontSize() {
            return this.s;
        }
        set headerFontSize(a) {
            this.s = a;
            this.g("HeaderFontSize");
        }
        get headerFontStyle() {
            return this.ce;
        }
        set headerFontStyle(a) {
            this.ce = a;
            this.g("HeaderFontStyle");
        }
        get headerFontWeight() {
            return this.cf;
        }
        set headerFontWeight(a) {
            this.cf = a;
            this.g("HeaderFontWeight");
        }
        get headerDisplayMode() {
            return this.cc;
        }
        set headerDisplayMode(a) {
            this.cc = a;
            this.g("HeaderDisplayMode");
        }
        get headerLabelLeftMargin() {
            return this.v;
        }
        set headerLabelLeftMargin(a) {
            this.v = a;
            this.g("HeaderLabelLeftMargin");
        }
        get headerLabelTopMargin() {
            return this.x;
        }
        set headerLabelTopMargin(a) {
            this.x = a;
            this.g("HeaderLabelTopMargin");
        }
        get headerLabelRightMargin() {
            return this.w;
        }
        set headerLabelRightMargin(a) {
            this.w = a;
            this.g("HeaderLabelRightMargin");
        }
        get headerLabelBottomMargin() {
            return this.u;
        }
        set headerLabelBottomMargin(a) {
            this.u = a;
            this.g("HeaderLabelBottomMargin");
        }
        get overlayHeaderLabelLeftMargin() {
            return this.ai;
        }
        set overlayHeaderLabelLeftMargin(a) {
            this.ai = a;
            this.g("OverlayHeaderLabelLeftMargin");
        }
        get overlayHeaderLabelTopMargin() {
            return this.ak;
        }
        set overlayHeaderLabelTopMargin(a) {
            this.ak = a;
            this.g("OverlayHeaderLabelTopMargin");
        }
        get overlayHeaderLabelRightMargin() {
            return this.aj;
        }
        set overlayHeaderLabelRightMargin(a) {
            this.aj = a;
            this.g("OverlayHeaderLabelRightMargin");
        }
        get overlayHeaderLabelBottomMargin() {
            return this.ah;
        }
        set overlayHeaderLabelBottomMargin(a) {
            this.ah = a;
            this.g("OverlayHeaderLabelBottomMargin");
        }
        get labelLeftMargin() {
            return this.ac;
        }
        set labelLeftMargin(a) {
            this.ac = a;
            this.g("LabelLeftMargin");
        }
        get labelTopMargin() {
            return this.ae;
        }
        set labelTopMargin(a) {
            this.ae = a;
            this.g("LabelTopMargin");
        }
        get labelRightMargin() {
            return this.ad;
        }
        set labelRightMargin(a) {
            this.ad = a;
            this.g("LabelRightMargin");
        }
        get labelBottomMargin() {
            return this.ab;
        }
        set labelBottomMargin(a) {
            this.ab = a;
            this.g("LabelBottomMargin");
        }
        get parentNodeLeftMargin() {
            return this.an;
        }
        set parentNodeLeftMargin(a) {
            this.an = a;
            this.g("ParentNodeLeftMargin");
        }
        get parentNodeTopMargin() {
            return this.ar;
        }
        set parentNodeTopMargin(a) {
            this.ar = a;
            this.g("ParentNodeTopMargin");
        }
        get parentNodeRightMargin() {
            return this.ap;
        }
        set parentNodeRightMargin(a) {
            this.ap = a;
            this.g("ParentNodeRightMargin");
        }
        get parentNodeBottomMargin() {
            return this.al;
        }
        set parentNodeBottomMargin(a) {
            this.al = a;
            this.g("ParentNodeBottomMargin");
        }
        get parentNodeLeftPadding() {
            return this.ao;
        }
        set parentNodeLeftPadding(a) {
            this.ao = a;
            this.g("ParentNodeLeftPadding");
        }
        get parentNodeTopPadding() {
            return this.as;
        }
        set parentNodeTopPadding(a) {
            this.as = a;
            this.g("ParentNodeTopPadding");
        }
        get parentNodeRightPadding() {
            return this.aq;
        }
        set parentNodeRightPadding(a) {
            this.aq = a;
            this.g("ParentNodeRightPadding");
        }
        get parentNodeBottomPadding() {
            return this.am;
        }
        set parentNodeBottomPadding(a) {
            this.am = a;
            this.g("ParentNodeBottomPadding");
        }
        get labelHorizontalAlignment() {
            return this.cq;
        }
        set labelHorizontalAlignment(a) {
            this.cq = a;
            this.g("LabelHorizontalAlignment");
        }
        get labelVerticalAlignment() {
            return this.ct;
        }
        set labelVerticalAlignment(a) {
            this.ct = a;
            this.g("LabelVerticalAlignment");
        }
        get headerHeight() {
            return this.t;
        }
        set headerHeight(a) {
            this.t = a;
            this.g("HeaderHeight");
        }
        get outline() {
            return this.c4;
        }
        set outline(a) {
            this.c4 = a;
            this.g("Outline");
        }
        get strokeThickness() {
            return this.au;
        }
        set strokeThickness(a) {
            this.au = a;
            this.g("StrokeThickness");
        }
        get nodeOpacity() {
            return this.ag;
        }
        set nodeOpacity(a) {
            this.ag = a;
            this.g("NodeOpacity");
        }
        get layoutOrientation() {
            return this.cv;
        }
        set layoutOrientation(a) {
            this.cv = a;
            this.g("LayoutOrientation");
        }
        get layoutType() {
            return this.cw;
        }
        set layoutType(a) {
            this.cw = a;
            this.g("LayoutType");
        }
        get minimumDisplaySize() {
            return this.af;
        }
        set minimumDisplaySize(a) {
            this.af = a;
            this.g("MinimumDisplaySize");
        }
        get transitionDuration() {
            return this.bv;
        }
        set transitionDuration(a) {
            this.bv = a;
            this.g("TransitionDuration");
        }
        get pixelScalingRatio() {
            return this.at;
        }
        set pixelScalingRatio(a) {
            this.at = a;
            this.g("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.o;
        }
        set actualPixelScalingRatio(a) {
            this.o = a;
            this.g("ActualPixelScalingRatio");
        }
        get interactionPixelScalingRatio() {
            return this.aa;
        }
        set interactionPixelScalingRatio(a) {
            this.aa = a;
            this.g("InteractionPixelScalingRatio");
        }
        get actualInteractionPixelScalingRatio() {
            return this.n;
        }
        set actualInteractionPixelScalingRatio(a) {
            this.n = a;
            this.g("ActualInteractionPixelScalingRatio");
        }
        get highlightingTransitionDuration() {
            return this.bu;
        }
        set highlightingTransitionDuration(a) {
            this.bu = a;
            this.g("HighlightingTransitionDuration");
        }
        get highlightingMode() {
            return this.co;
        }
        set highlightingMode(a) {
            this.co = a;
            this.g("HighlightingMode");
        }
        get actualHighlightingMode() {
            return this.bz;
        }
        set actualHighlightingMode(a) {
            this.bz = a;
            this.g("ActualHighlightingMode");
        }
        get highlightingFadeOpacity() {
            return this.z;
        }
        set highlightingFadeOpacity(a) {
            this.z = a;
            this.g("HighlightingFadeOpacity");
        }
        get focusItemRef() {
            return this.b6;
        }
        set focusItemRef(a) {
            this.b6 = a;
            this.g("FocusItemRef");
        }
        get nodeStylingRef() {
            return this.c3;
        }
        set nodeStylingRef(a) {
            this.c3 = a;
            this.g("NodeStylingRef");
        }
        get nodeRenderStylingRef() {
            return this.c2;
        }
        set nodeRenderStylingRef(a) {
            this.c2 = a;
            this.g("NodeRenderStylingRef");
        }
        get nodePointerOverRef() {
            return this.cz;
        }
        set nodePointerOverRef(a) {
            this.cz = a;
            this.g("NodePointerOverRef");
        }
        get nodePointerEnterRef() {
            return this.cx;
        }
        set nodePointerEnterRef(a) {
            this.cx = a;
            this.g("NodePointerEnterRef");
        }
        get nodePointerLeaveRef() {
            return this.cy;
        }
        set nodePointerLeaveRef(a) {
            this.cy = a;
            this.g("NodePointerLeaveRef");
        }
        get nodePointerPressedRef() {
            return this.c0;
        }
        set nodePointerPressedRef(a) {
            this.c0 = a;
            this.g("NodePointerPressedRef");
        }
        get nodePointerReleasedRef() {
            return this.c1;
        }
        set nodePointerReleasedRef(a) {
            this.c1 = a;
            this.g("NodePointerReleasedRef");
        }
        get width() {
            return this.db;
        }
        set width(a) {
            this.db = a;
            this.g("Width");
        }
        get height() {
            return this.ck;
        }
        set height(a) {
            this.ck = a;
            this.g("Height");
        }
        get background() {
            return this.b0;
        }
        set background(a) {
            this.b0 = a;
            this.g("Background");
        }
    }
    TreemapDescription.$t = /*@__PURE__*/ markType(TreemapDescription, 'TreemapDescription', Description.$);
    return TreemapDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStyleDescription = /*@__PURE__*/ (() => {
    class TreemapNodeStyleDescription extends Description {
        get_type() {
            return "TreemapNodeStyle";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.aj = null;
            this.ai = null;
            this.al = null;
            this.am = null;
            this.aq = null;
            this.ak = null;
            this.m = 0;
            this.o = 0;
            this.n = 0;
            this.l = 0;
            this.q = 0;
            this.s = 0;
            this.r = 0;
            this.p = 0;
            this.k = 0;
            this.an = null;
            this.ao = null;
            this.ah = null;
            this.ap = null;
            this.u = 0;
            this.t = 0;
            this.j = 0;
            this.h = false;
        }
        get headerHoverBackground() {
            return this.aj;
        }
        set headerHoverBackground(a) {
            this.aj = a;
            this.g("HeaderHoverBackground");
        }
        get headerBackground() {
            return this.ai;
        }
        set headerBackground(a) {
            this.ai = a;
            this.g("HeaderBackground");
        }
        get headerTextColor() {
            return this.al;
        }
        set headerTextColor(a) {
            this.al = a;
            this.g("HeaderTextColor");
        }
        get label() {
            return this.am;
        }
        set label(a) {
            this.am = a;
            this.g("Label");
        }
        get textColor() {
            return this.aq;
        }
        set textColor(a) {
            this.aq = a;
            this.g("TextColor");
        }
        get headerHoverTextColor() {
            return this.ak;
        }
        set headerHoverTextColor(a) {
            this.ak = a;
            this.g("HeaderHoverTextColor");
        }
        get headerLabelLeftMargin() {
            return this.m;
        }
        set headerLabelLeftMargin(a) {
            this.m = a;
            this.g("HeaderLabelLeftMargin");
        }
        get headerLabelTopMargin() {
            return this.o;
        }
        set headerLabelTopMargin(a) {
            this.o = a;
            this.g("HeaderLabelTopMargin");
        }
        get headerLabelRightMargin() {
            return this.n;
        }
        set headerLabelRightMargin(a) {
            this.n = a;
            this.g("HeaderLabelRightMargin");
        }
        get headerLabelBottomMargin() {
            return this.l;
        }
        set headerLabelBottomMargin(a) {
            this.l = a;
            this.g("HeaderLabelBottomMargin");
        }
        get labelLeftMargin() {
            return this.q;
        }
        set labelLeftMargin(a) {
            this.q = a;
            this.g("LabelLeftMargin");
        }
        get labelTopMargin() {
            return this.s;
        }
        set labelTopMargin(a) {
            this.s = a;
            this.g("LabelTopMargin");
        }
        get labelRightMargin() {
            return this.r;
        }
        set labelRightMargin(a) {
            this.r = a;
            this.g("LabelRightMargin");
        }
        get labelBottomMargin() {
            return this.p;
        }
        set labelBottomMargin(a) {
            this.p = a;
            this.g("LabelBottomMargin");
        }
        get headerHeight() {
            return this.k;
        }
        set headerHeight(a) {
            this.k = a;
            this.g("HeaderHeight");
        }
        get labelHorizontalAlignment() {
            return this.an;
        }
        set labelHorizontalAlignment(a) {
            this.an = a;
            this.g("LabelHorizontalAlignment");
        }
        get labelVerticalAlignment() {
            return this.ao;
        }
        set labelVerticalAlignment(a) {
            this.ao = a;
            this.g("LabelVerticalAlignment");
        }
        get fill() {
            return this.ah;
        }
        set fill(a) {
            this.ah = a;
            this.g("Fill");
        }
        get outline() {
            return this.ap;
        }
        set outline(a) {
            this.ap = a;
            this.g("Outline");
        }
        get strokeThickness() {
            return this.u;
        }
        set strokeThickness(a) {
            this.u = a;
            this.g("StrokeThickness");
        }
        get opacity() {
            return this.t;
        }
        set opacity(a) {
            this.t = a;
            this.g("Opacity");
        }
        get fadeOpacity() {
            return this.j;
        }
        set fadeOpacity(a) {
            this.j = a;
            this.g("FadeOpacity");
        }
        get highlightingHandled() {
            return this.h;
        }
        set highlightingHandled(a) {
            this.h = a;
            this.g("HighlightingHandled");
        }
    }
    TreemapNodeStyleDescription.$t = /*@__PURE__*/ markType(TreemapNodeStyleDescription, 'TreemapNodeStyleDescription', Description.$);
    return TreemapNodeStyleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStyleDescriptionMetadata = /*@__PURE__*/ (() => {
    class TreemapNodeStyleDescriptionMetadata extends Base {
        static b(a) {
            if (TreemapNodeStyleDescriptionMetadata.a == null) {
                TreemapNodeStyleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TreemapNodeStyleDescriptionMetadata.c(TreemapNodeStyleDescriptionMetadata.a);
            }
            if (a.k(TreemapNodeStyleDescriptionMetadata.a)) {
                return;
            }
            a.ac(TreemapNodeStyleDescriptionMetadata.a);
        }
        static c(a) {
            a.item("HeaderHoverBackground", "Brush");
            a.item("HeaderBackground", "Brush");
            a.item("HeaderTextColor", "Brush");
            a.item("Label", "String");
            a.item("TextColor", "Brush");
            a.item("HeaderHoverTextColor", "Brush");
            a.item("HeaderLabelLeftMargin", "Number:double");
            a.item("HeaderLabelTopMargin", "Number:double");
            a.item("HeaderLabelRightMargin", "Number:double");
            a.item("HeaderLabelBottomMargin", "Number:double");
            a.item("LabelLeftMargin", "Number:double");
            a.item("LabelTopMargin", "Number:double");
            a.item("LabelRightMargin", "Number:double");
            a.item("LabelBottomMargin", "Number:double");
            a.item("HeaderHeight", "Number:double");
            a.item("LabelHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("LabelHorizontalAlignment@names", "Left;Center;Right;Stretch");
            a.item("LabelVerticalAlignment", "ExportedType:string:VerticalAlignment");
            a.item("LabelVerticalAlignment@names", "Top;Center;Bottom;Stretch");
            a.item("Fill", "Brush");
            a.item("Outline", "Brush");
            a.item("StrokeThickness", "Number:double");
            a.item("Opacity", "Number:double");
            a.item("FadeOpacity", "Number:double");
            a.item("HighlightingHandled", "Boolean");
        }
        static d(a) {
            TreemapNodeStyleDescriptionMetadata.b(a);
            a.ae("TreemapNodeStyle", () => new TreemapNodeStyleDescription());
            a.ad("TreemapNodeStyle", TreemapNodeStyleDescriptionMetadata.a);
        }
    }
    TreemapNodeStyleDescriptionMetadata.$t = /*@__PURE__*/ markType(TreemapNodeStyleDescriptionMetadata, 'TreemapNodeStyleDescriptionMetadata');
    TreemapNodeStyleDescriptionMetadata.a = null;
    return TreemapNodeStyleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStylingEventArgsDescription = /*@__PURE__*/ (() => {
    class TreemapNodeStylingEventArgsDescription extends Description {
        get_type() {
            return "TreemapNodeStylingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.v = 0;
            this.t = 0;
            this.ab = null;
            this.ac = null;
            this.ae = null;
            this.ad = null;
            this.s = 0;
            this.af = null;
            this.r = 0;
            this.n = false;
            this.j = null;
            this.h = null;
            this.l = false;
            this.m = false;
            this.u = 0;
        }
        get value() {
            return this.v;
        }
        set value(a) {
            this.v = a;
            this.g("Value");
        }
        get sum() {
            return this.t;
        }
        set sum(a) {
            this.t = a;
            this.g("Sum");
        }
        get customValueRef() {
            return this.ab;
        }
        set customValueRef(a) {
            this.ab = a;
            this.g("CustomValueRef");
        }
        get itemRef() {
            return this.ac;
        }
        set itemRef(a) {
            this.ac = a;
            this.g("ItemRef");
        }
        get parentItemRef() {
            return this.ae;
        }
        set parentItemRef(a) {
            this.ae = a;
            this.g("ParentItemRef");
        }
        get label() {
            return this.ad;
        }
        set label(a) {
            this.ad = a;
            this.g("Label");
        }
        get parentValue() {
            return this.s;
        }
        set parentValue(a) {
            this.s = a;
            this.g("ParentValue");
        }
        get parentLabel() {
            return this.af;
        }
        set parentLabel(a) {
            this.af = a;
            this.g("ParentLabel");
        }
        get parentSum() {
            return this.r;
        }
        set parentSum(a) {
            this.r = a;
            this.g("ParentSum");
        }
        get isParent() {
            return this.n;
        }
        set isParent(a) {
            this.n = a;
            this.g("IsParent");
        }
        get style() {
            return this.j;
        }
        set style(a) {
            this.j = a;
            this.g("Style");
        }
        get highlightingInfo() {
            return this.h;
        }
        set highlightingInfo(a) {
            this.h = a;
            this.g("HighlightingInfo");
        }
        get highlightingHandled() {
            return this.l;
        }
        set highlightingHandled(a) {
            this.l = a;
            this.g("HighlightingHandled");
        }
        get isHighlightInProgress() {
            return this.m;
        }
        set isHighlightInProgress(a) {
            this.m = a;
            this.g("IsHighlightInProgress");
        }
        get totalHighlightProgress() {
            return this.u;
        }
        set totalHighlightProgress(a) {
            this.u = a;
            this.g("TotalHighlightProgress");
        }
    }
    TreemapNodeStylingEventArgsDescription.$t = /*@__PURE__*/ markType(TreemapNodeStylingEventArgsDescription, 'TreemapNodeStylingEventArgsDescription', Description.$);
    return TreemapNodeStylingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStylingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class TreemapNodeStylingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (TreemapNodeStylingEventArgsDescriptionMetadata.a == null) {
                TreemapNodeStylingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TreemapNodeStylingEventArgsDescriptionMetadata.c(TreemapNodeStylingEventArgsDescriptionMetadata.a);
            }
            if (a.k(TreemapNodeStylingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(TreemapNodeStylingEventArgsDescriptionMetadata.a);
            TreemapNodeStyleDescriptionMetadata.d(a);
            HighlightingInfoDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Value", "Number:double");
            a.item("Sum", "Number:double");
            a.item("CustomValueRef", "(w:CustomValue,wf:CustomValue)DataRef");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("ParentItemRef", "(w:ParentItem,wf:ParentItem)DataRef");
            a.item("Label", "String");
            a.item("ParentValue", "Number:double");
            a.item("ParentLabel", "String");
            a.item("ParentSum", "Number:double");
            a.item("IsParent", "Boolean");
            a.item("Style", "ExportedType:TreemapNodeStyle");
            a.item("HighlightingInfo", "ExportedType:HighlightingInfo");
            a.item("HighlightingHandled", "Boolean");
            a.item("IsHighlightInProgress", "Boolean");
            a.item("TotalHighlightProgress", "Number:double");
        }
        static d(a) {
            TreemapNodeStylingEventArgsDescriptionMetadata.b(a);
            a.ae("TreemapNodeStylingEventArgs", () => new TreemapNodeStylingEventArgsDescription());
            a.ad("TreemapNodeStylingEventArgs", TreemapNodeStylingEventArgsDescriptionMetadata.a);
        }
    }
    TreemapNodeStylingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(TreemapNodeStylingEventArgsDescriptionMetadata, 'TreemapNodeStylingEventArgsDescriptionMetadata');
    TreemapNodeStylingEventArgsDescriptionMetadata.a = null;
    return TreemapNodeStylingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodePointerEventArgsDescription = /*@__PURE__*/ (() => {
    class TreemapNodePointerEventArgsDescription extends Description {
        get_type() {
            return "TreemapNodePointerEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.s = 0;
            this.r = 0;
            this.x = null;
            this.y = null;
            this.aa = null;
            this.h = null;
            this.l = false;
            this.j = false;
            this.k = false;
            this.z = null;
            this.q = 0;
            this.ab = null;
            this.p = 0;
        }
        get value() {
            return this.s;
        }
        set value(a) {
            this.s = a;
            this.g("Value");
        }
        get sum() {
            return this.r;
        }
        set sum(a) {
            this.r = a;
            this.g("Sum");
        }
        get customValueRef() {
            return this.x;
        }
        set customValueRef(a) {
            this.x = a;
            this.g("CustomValueRef");
        }
        get itemRef() {
            return this.y;
        }
        set itemRef(a) {
            this.y = a;
            this.g("ItemRef");
        }
        get parentItemRef() {
            return this.aa;
        }
        set parentItemRef(a) {
            this.aa = a;
            this.g("ParentItemRef");
        }
        get position() {
            return this.h;
        }
        set position(a) {
            this.h = a;
            this.g("Position");
        }
        get isRightButton() {
            return this.l;
        }
        set isRightButton(a) {
            this.l = a;
            this.g("IsRightButton");
        }
        get isHandled() {
            return this.j;
        }
        set isHandled(a) {
            this.j = a;
            this.g("IsHandled");
        }
        get isOverHeader() {
            return this.k;
        }
        set isOverHeader(a) {
            this.k = a;
            this.g("IsOverHeader");
        }
        get label() {
            return this.z;
        }
        set label(a) {
            this.z = a;
            this.g("Label");
        }
        get parentValue() {
            return this.q;
        }
        set parentValue(a) {
            this.q = a;
            this.g("ParentValue");
        }
        get parentLabel() {
            return this.ab;
        }
        set parentLabel(a) {
            this.ab = a;
            this.g("ParentLabel");
        }
        get parentSum() {
            return this.p;
        }
        set parentSum(a) {
            this.p = a;
            this.g("ParentSum");
        }
    }
    TreemapNodePointerEventArgsDescription.$t = /*@__PURE__*/ markType(TreemapNodePointerEventArgsDescription, 'TreemapNodePointerEventArgsDescription', Description.$);
    return TreemapNodePointerEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodePointerEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class TreemapNodePointerEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (TreemapNodePointerEventArgsDescriptionMetadata.a == null) {
                TreemapNodePointerEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TreemapNodePointerEventArgsDescriptionMetadata.c(TreemapNodePointerEventArgsDescriptionMetadata.a);
            }
            if (a.k(TreemapNodePointerEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(TreemapNodePointerEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Value", "Number:double");
            a.item("Sum", "Number:double");
            a.item("CustomValueRef", "(w:CustomValue,wf:CustomValue)DataRef");
            a.item("ItemRef", "(w:Item,wf:Item)DataRef");
            a.item("ParentItemRef", "(w:ParentItem,wf:ParentItem)DataRef");
            a.item("Position", "Point");
            a.item("IsRightButton", "Boolean");
            a.item("IsHandled", "Boolean");
            a.item("IsOverHeader", "Boolean");
            a.item("Label", "String");
            a.item("ParentValue", "Number:double");
            a.item("ParentLabel", "String");
            a.item("ParentSum", "Number:double");
        }
        static d(a) {
            TreemapNodePointerEventArgsDescriptionMetadata.b(a);
            a.ae("TreemapNodePointerEventArgs", () => new TreemapNodePointerEventArgsDescription());
            a.ad("TreemapNodePointerEventArgs", TreemapNodePointerEventArgsDescriptionMetadata.a);
        }
    }
    TreemapNodePointerEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(TreemapNodePointerEventArgsDescriptionMetadata, 'TreemapNodePointerEventArgsDescriptionMetadata');
    TreemapNodePointerEventArgsDescriptionMetadata.a = null;
    return TreemapNodePointerEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapDescriptionMetadata = /*@__PURE__*/ (() => {
    class TreemapDescriptionMetadata extends Base {
        static b(a) {
            if (TreemapDescriptionMetadata.a == null) {
                TreemapDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TreemapDescriptionMetadata.c(TreemapDescriptionMetadata.a);
            }
            if (a.k(TreemapDescriptionMetadata.a)) {
                return;
            }
            a.ac(TreemapDescriptionMetadata.a);
            TreemapNodeStylingEventArgsDescriptionMetadata.d(a);
            TreemapNodePointerEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("ValueMemberPath", "String");
            a.item("RootTitle", "String");
            a.item("BreadcrumbSequence", "String");
            a.item("ParentIdMemberPath", "String");
            a.item("LabelMemberPath", "String");
            a.item("CustomValueMemberPath", "String");
            a.item("IdMemberPath", "String");
            a.item("DataSourceRef", "(w:ItemsSource,xam:ItemsSource,j:dataSource,wf:ItemsSource)DataRef::object");
            a.item("HighlightedDataSourceRef", "(w:HighlightedItemsSource,xam:HighlightedItemsSource,j:highlightedDataSource,wf:HighlightedItemsSource)DataRef::object");
            a.item("HighlightedValueMemberPath", "String");
            a.item("HighlightedValueOpacity", "Number:double");
            a.item("HighlightedValuesDisplayMode", "ExportedType:string:TreemapHighlightedValueDisplayMode");
            a.item("HighlightedValuesDisplayMode@names", "Auto;Overlay;Hidden");
            a.item("FillBrushes", "BrushCollection:string");
            a.item("StyleMappings", "Collection:TreemapNodeStyleMapping:TreemapNodeStyleMappingCollection:TreemapNodeStyleMapping");
            a.item("FillScaleMode", "ExportedType:string:TreemapFillScaleMode");
            a.item("FillScaleMode@names", "Sum;GlobalSum;Value;GlobalValue");
            a.item("IsFillScaleLogarithmic", "Boolean");
            a.item("FillScaleLogarithmBase", "Number:int");
            a.item("FillScaleMinimumValue", "Number:double");
            a.item("FillScaleMaximumValue", "Number:double");
            a.item("LabelVerticalFitMode", "ExportedType:string:TreemapLabelVerticalFitMode");
            a.item("LabelVerticalFitMode@names", "Auto;Show;Hide");
            a.item("LabelHorizontalFitMode", "ExportedType:string:TreemapLabelHorizontalFitMode");
            a.item("LabelHorizontalFitMode@names", "Auto;Ellipsis;Hide");
            a.item("OverlayHeaderHoverBackground", "Brush");
            a.item("HeaderHoverBackground", "Brush");
            a.item("HeaderBackground", "Brush");
            a.item("OverlayHeaderBackground", "Brush");
            a.item("HeaderTextColor", "Brush");
            a.item("HeaderDarkTextColor", "Brush");
            a.item("TextColor", "Brush");
            a.item("DarkTextColor", "Brush");
            a.item("HeaderHoverTextColor", "Brush");
            a.item("HeaderHoverDarkTextColor", "Brush");
            a.item("FontFamily", "(w:FontFamily/FontFamilyTransform,xam:FontFamily,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            a.item("FontSize", "(w:FontSize,xam:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            a.item("FontStyle", "(w:FontStyle/FontStyleTransform,xam:FontFamily/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            a.item("FontWeight", "(w:FontWeight/FontWeightTransform,xam:FontFamily/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            a.item("HeaderFontFamily", "(w:HeaderFontFamily/FontFamilyTransform,xam:HeaderFontFamily,wf:HeaderFontFamily,web:headerTextStyle/FontFamilyTransform)String");
            a.item("HeaderFontSize", "(w:HeaderFontSize,xam:HeaderFontSize,wf:HeaderFontSize,web:headerTextStyle/FontSizeTransform)Number:double");
            a.item("HeaderFontStyle", "(w:HeaderFontStyle/FontStyleTransform,xam:HeaderFontFamily/FontStyleTransform,wf:HeaderFontFamily/FontStyleTransform,web:headerTextStyle/FontStyleTransform)String");
            a.item("HeaderFontWeight", "(w:HeaderFontWeight/FontWeightTransform,xam:HeaderFontFamily/FontWeightTransform,wf:HeaderFontFamily/FontWeightTransform,web:headerTextStyle/FontWeightTransform)String");
            a.item("HeaderDisplayMode", "ExportedType:string:TreemapHeaderDisplayMode");
            a.item("HeaderDisplayMode@names", "Auto;Header;Overlay");
            a.item("HeaderLabelLeftMargin", "Number:double");
            a.item("HeaderLabelTopMargin", "Number:double");
            a.item("HeaderLabelRightMargin", "Number:double");
            a.item("HeaderLabelBottomMargin", "Number:double");
            a.item("OverlayHeaderLabelLeftMargin", "Number:double");
            a.item("OverlayHeaderLabelTopMargin", "Number:double");
            a.item("OverlayHeaderLabelRightMargin", "Number:double");
            a.item("OverlayHeaderLabelBottomMargin", "Number:double");
            a.item("LabelLeftMargin", "Number:double");
            a.item("LabelTopMargin", "Number:double");
            a.item("LabelRightMargin", "Number:double");
            a.item("LabelBottomMargin", "Number:double");
            a.item("ParentNodeLeftMargin", "Number:double");
            a.item("ParentNodeTopMargin", "Number:double");
            a.item("ParentNodeRightMargin", "Number:double");
            a.item("ParentNodeBottomMargin", "Number:double");
            a.item("ParentNodeLeftPadding", "Number:double");
            a.item("ParentNodeTopPadding", "Number:double");
            a.item("ParentNodeRightPadding", "Number:double");
            a.item("ParentNodeBottomPadding", "Number:double");
            a.item("LabelHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            a.item("LabelHorizontalAlignment@names", "Left;Center;Right;Stretch");
            a.item("LabelVerticalAlignment", "ExportedType:string:VerticalAlignment");
            a.item("LabelVerticalAlignment@names", "Top;Center;Bottom;Stretch");
            a.item("HeaderHeight", "Number:double");
            a.item("Outline", "Brush");
            a.item("StrokeThickness", "Number:double");
            a.item("NodeOpacity", "Number:double");
            a.item("LayoutOrientation", "ExportedType:string:TreemapOrientation");
            a.item("LayoutOrientation@names", "Horizontal;Vertical");
            a.item("LayoutType", "ExportedType:string:TreemapLayoutType");
            a.item("LayoutType@names", "Squarified;SliceAndDice;Stripped");
            a.item("MinimumDisplaySize", "Number:double");
            a.item("TransitionDuration", "Number:int");
            a.item("PixelScalingRatio", "Number:double");
            a.item("ActualPixelScalingRatio", "Number:double");
            a.item("InteractionPixelScalingRatio", "Number:double");
            a.item("ActualInteractionPixelScalingRatio", "Number:double");
            a.item("HighlightingTransitionDuration", "Number:int");
            a.item("HighlightingMode", "ExportedType:string:TreemapHighlightingMode");
            a.item("HighlightingMode@names", "Auto;None;Brighten;FadeOthers");
            a.item("ActualHighlightingMode", "ExportedType:string:TreemapHighlightingMode");
            a.item("ActualHighlightingMode@names", "Auto;None;Brighten;FadeOthers");
            a.item("HighlightingFadeOpacity", "Number:double");
            a.item("FocusItemRef", "(w:FocusItem,wf:FocusItem)DataRef");
            a.item("NodeStylingRef", "EventRef::nodeStyling");
            a.item("NodeRenderStylingRef", "EventRef::nodeRenderStyling");
            a.item("NodePointerOverRef", "EventRef::nodePointerOver");
            a.item("NodePointerEnterRef", "EventRef::nodePointerEnter");
            a.item("NodePointerLeaveRef", "EventRef::nodePointerLeave");
            a.item("NodePointerPressedRef", "EventRef::nodePointerPressed");
            a.item("NodePointerReleasedRef", "EventRef::nodePointerReleased");
            TreemapDescriptionMetadata.e(a);
        }
        static d(a) {
            TreemapDescriptionMetadata.b(a);
            a.ae("Treemap", () => new TreemapDescription());
            a.ad("Treemap", TreemapDescriptionMetadata.a);
        }
        static e(a) {
            a.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamTreemap");
            a.item("Width", "(w:Width/DimensionTransform,xam:Width/DimensionTransform)String");
            a.item("Height", "(w:Height/DimensionTransform,xam:Height/DimensionTransform)String");
            a.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
    }
    TreemapDescriptionMetadata.$t = /*@__PURE__*/ markType(TreemapDescriptionMetadata, 'TreemapDescriptionMetadata');
    TreemapDescriptionMetadata.a = null;
    return TreemapDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStyleDescriptionModule = /*@__PURE__*/ (() => {
    class TreemapNodeStyleDescriptionModule extends Base {
        static register(a) {
            TreemapNodeStyleDescriptionMetadata.d(a);
        }
    }
    TreemapNodeStyleDescriptionModule.$t = /*@__PURE__*/ markType(TreemapNodeStyleDescriptionModule, 'TreemapNodeStyleDescriptionModule');
    return TreemapNodeStyleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStyleMappingDescription = /*@__PURE__*/ (() => {
    class TreemapNodeStyleMappingDescription extends TreemapNodeStyleDescription {
        get_type() {
            return "TreemapNodeStyleMapping";
        }
        constructor() {
            super();
            this.a9 = null;
            this.a3 = 0;
            this.a2 = 0;
            this.a6 = null;
            this.a8 = null;
        }
        get targetType() {
            return this.a9;
        }
        set targetType(a) {
            this.a9 = a;
            this.g("TargetType");
        }
        get minimumValue() {
            return this.a3;
        }
        set minimumValue(a) {
            this.a3 = a;
            this.g("MinimumValue");
        }
        get maximumValue() {
            return this.a2;
        }
        set maximumValue(a) {
            this.a2 = a;
            this.g("MaximumValue");
        }
        get value() {
            return this.a6;
        }
        set value(a) {
            this.a6 = a;
            this.g("Value");
        }
        get mappingMode() {
            return this.a8;
        }
        set mappingMode(a) {
            this.a8 = a;
            this.g("MappingMode");
        }
    }
    TreemapNodeStyleMappingDescription.$t = /*@__PURE__*/ markType(TreemapNodeStyleMappingDescription, 'TreemapNodeStyleMappingDescription', TreemapNodeStyleDescription.$);
    return TreemapNodeStyleMappingDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStyleMappingDescriptionMetadata = /*@__PURE__*/ (() => {
    class TreemapNodeStyleMappingDescriptionMetadata extends Base {
        static b(a) {
            if (TreemapNodeStyleMappingDescriptionMetadata.a == null) {
                TreemapNodeStyleMappingDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TreemapNodeStyleMappingDescriptionMetadata.c(TreemapNodeStyleMappingDescriptionMetadata.a);
            }
            if (a.k(TreemapNodeStyleMappingDescriptionMetadata.a)) {
                return;
            }
            a.ac(TreemapNodeStyleMappingDescriptionMetadata.a);
        }
        static c(a) {
            TreemapNodeStyleDescriptionMetadata.c(a);
            a.item("TargetType", "ExportedType:string:TreemapNodeStyleMappingTargetType");
            a.item("TargetType@names", "All;Parent;Child");
            a.item("MinimumValue", "Number:double");
            a.item("MaximumValue", "Number:double");
            a.item("Value", "Unknown");
            a.item("MappingMode", "ExportedType:string:TreemapValueMappingMode");
            a.item("MappingMode@names", "Sum;Value;CustomValue");
        }
        static d(a) {
            TreemapNodeStyleMappingDescriptionMetadata.b(a);
            a.ae("TreemapNodeStyleMapping", () => new TreemapNodeStyleMappingDescription());
            a.ad("TreemapNodeStyleMapping", TreemapNodeStyleMappingDescriptionMetadata.a);
        }
    }
    TreemapNodeStyleMappingDescriptionMetadata.$t = /*@__PURE__*/ markType(TreemapNodeStyleMappingDescriptionMetadata, 'TreemapNodeStyleMappingDescriptionMetadata');
    TreemapNodeStyleMappingDescriptionMetadata.a = null;
    return TreemapNodeStyleMappingDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStyleMappingDescriptionModule = /*@__PURE__*/ (() => {
    class TreemapNodeStyleMappingDescriptionModule extends Base {
        static register(a) {
            TreemapNodeStyleDescriptionModule.register(a);
            TreemapNodeStyleMappingDescriptionMetadata.d(a);
        }
    }
    TreemapNodeStyleMappingDescriptionModule.$t = /*@__PURE__*/ markType(TreemapNodeStyleMappingDescriptionModule, 'TreemapNodeStyleMappingDescriptionModule');
    return TreemapNodeStyleMappingDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapDescriptionModule = /*@__PURE__*/ (() => {
    class TreemapDescriptionModule extends Base {
        static register(a) {
            TreemapDescriptionMetadata.d(a);
            TreemapNodeStyleDescriptionModule.register(a);
            TreemapNodeStyleMappingDescriptionModule.register(a);
        }
    }
    TreemapDescriptionModule.$t = /*@__PURE__*/ markType(TreemapDescriptionModule, 'TreemapDescriptionModule');
    return TreemapDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulationDataSourceDescription = /*@__PURE__*/ (() => {
    class TriangulationDataSourceDescription extends Description {
        get_type() {
            return "TriangulationDataSource";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get importCompletedRef() {
            return this.h;
        }
        set importCompletedRef(a) {
            this.h = a;
            this.g("ImportCompletedRef");
        }
    }
    TriangulationDataSourceDescription.$t = /*@__PURE__*/ markType(TriangulationDataSourceDescription, 'TriangulationDataSourceDescription', Description.$);
    return TriangulationDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulationDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class TriangulationDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (TriangulationDataSourceDescriptionMetadata.a == null) {
                TriangulationDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TriangulationDataSourceDescriptionMetadata.c(TriangulationDataSourceDescriptionMetadata.a);
            }
            if (a.k(TriangulationDataSourceDescriptionMetadata.a)) {
                return;
            }
            a.ac(TriangulationDataSourceDescriptionMetadata.a);
            AsyncCompletedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("ImportCompletedRef", "EventRef::importCompleted");
        }
        static d(a) {
            TriangulationDataSourceDescriptionMetadata.b(a);
            a.ae("TriangulationDataSource", () => new TriangulationDataSourceDescription());
            a.ad("TriangulationDataSource", TriangulationDataSourceDescriptionMetadata.a);
        }
    }
    TriangulationDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(TriangulationDataSourceDescriptionMetadata, 'TriangulationDataSourceDescriptionMetadata');
    TriangulationDataSourceDescriptionMetadata.a = null;
    return TriangulationDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UploadDataCompletedEventArgsDescription = /*@__PURE__*/ (() => {
    class UploadDataCompletedEventArgsDescription extends AsyncCompletedEventArgsDescription {
        get_type() {
            return "UploadDataCompletedEventArgs";
        }
        constructor() {
            super();
        }
    }
    UploadDataCompletedEventArgsDescription.$t = /*@__PURE__*/ markType(UploadDataCompletedEventArgsDescription, 'UploadDataCompletedEventArgsDescription', AsyncCompletedEventArgsDescription.$);
    return UploadDataCompletedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UploadDataCompletedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class UploadDataCompletedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (UploadDataCompletedEventArgsDescriptionMetadata.a == null) {
                UploadDataCompletedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                UploadDataCompletedEventArgsDescriptionMetadata.c(UploadDataCompletedEventArgsDescriptionMetadata.a);
            }
            if (a.k(UploadDataCompletedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(UploadDataCompletedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            AsyncCompletedEventArgsDescriptionMetadata.c(a);
        }
        static d(a) {
            UploadDataCompletedEventArgsDescriptionMetadata.b(a);
            a.ae("UploadDataCompletedEventArgs", () => new UploadDataCompletedEventArgsDescription());
            a.ad("UploadDataCompletedEventArgs", UploadDataCompletedEventArgsDescriptionMetadata.a);
        }
    }
    UploadDataCompletedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(UploadDataCompletedEventArgsDescriptionMetadata, 'UploadDataCompletedEventArgsDescriptionMetadata');
    UploadDataCompletedEventArgsDescriptionMetadata.a = null;
    return UploadDataCompletedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UploadStringCompletedEventArgsDescription = /*@__PURE__*/ (() => {
    class UploadStringCompletedEventArgsDescription extends AsyncCompletedEventArgsDescription {
        get_type() {
            return "UploadStringCompletedEventArgs";
        }
        constructor() {
            super();
        }
    }
    UploadStringCompletedEventArgsDescription.$t = /*@__PURE__*/ markType(UploadStringCompletedEventArgsDescription, 'UploadStringCompletedEventArgsDescription', AsyncCompletedEventArgsDescription.$);
    return UploadStringCompletedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UploadStringCompletedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class UploadStringCompletedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (UploadStringCompletedEventArgsDescriptionMetadata.a == null) {
                UploadStringCompletedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                UploadStringCompletedEventArgsDescriptionMetadata.c(UploadStringCompletedEventArgsDescriptionMetadata.a);
            }
            if (a.k(UploadStringCompletedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(UploadStringCompletedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            AsyncCompletedEventArgsDescriptionMetadata.c(a);
        }
        static d(a) {
            UploadStringCompletedEventArgsDescriptionMetadata.b(a);
            a.ae("UploadStringCompletedEventArgs", () => new UploadStringCompletedEventArgsDescription());
            a.ad("UploadStringCompletedEventArgs", UploadStringCompletedEventArgsDescriptionMetadata.a);
        }
    }
    UploadStringCompletedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(UploadStringCompletedEventArgsDescriptionMetadata, 'UploadStringCompletedEventArgsDescriptionMetadata');
    UploadStringCompletedEventArgsDescriptionMetadata.a = null;
    return UploadStringCompletedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueOverlayDescription = /*@__PURE__*/ (() => {
    class ValueOverlayDescription extends SeriesDescription {
        get_type() {
            return "ValueOverlay";
        }
        constructor() {
            super();
            this.fn = null;
            this.e9 = 0;
            this.e1 = false;
            this.fk = null;
            this.fm = null;
            this.fj = null;
            this.e3 = 0;
            this.fh = 0;
            this.fl = null;
            this.e5 = 0;
            this.e7 = 0;
            this.e6 = 0;
            this.e4 = 0;
            this.e8 = 0;
        }
        get axisRef() {
            return this.fn;
        }
        set axisRef(a) {
            this.fn = a;
            this.g("AxisRef");
        }
        get value() {
            return this.e9;
        }
        set value(a) {
            this.e9 = a;
            this.g("Value");
        }
        get isAxisAnnotationEnabled() {
            return this.e1;
        }
        set isAxisAnnotationEnabled(a) {
            this.e1 = a;
            this.g("IsAxisAnnotationEnabled");
        }
        get axisAnnotationFormatLabelRef() {
            return this.fk;
        }
        set axisAnnotationFormatLabelRef(a) {
            this.fk = a;
            this.g("AxisAnnotationFormatLabelRef");
        }
        get axisAnnotationTextColor() {
            return this.fm;
        }
        set axisAnnotationTextColor(a) {
            this.fm = a;
            this.g("AxisAnnotationTextColor");
        }
        get axisAnnotationBackground() {
            return this.fj;
        }
        set axisAnnotationBackground(a) {
            this.fj = a;
            this.g("AxisAnnotationBackground");
        }
        get axisAnnotationBackgroundCornerRadius() {
            return this.e3;
        }
        set axisAnnotationBackgroundCornerRadius(a) {
            this.e3 = a;
            this.g("AxisAnnotationBackgroundCornerRadius");
        }
        get axisAnnotationInterpolatedValuePrecision() {
            return this.fh;
        }
        set axisAnnotationInterpolatedValuePrecision(a) {
            this.fh = a;
            this.g("AxisAnnotationInterpolatedValuePrecision");
        }
        get axisAnnotationOutline() {
            return this.fl;
        }
        set axisAnnotationOutline(a) {
            this.fl = a;
            this.g("AxisAnnotationOutline");
        }
        get axisAnnotationPaddingLeft() {
            return this.e5;
        }
        set axisAnnotationPaddingLeft(a) {
            this.e5 = a;
            this.g("AxisAnnotationPaddingLeft");
        }
        get axisAnnotationPaddingTop() {
            return this.e7;
        }
        set axisAnnotationPaddingTop(a) {
            this.e7 = a;
            this.g("AxisAnnotationPaddingTop");
        }
        get axisAnnotationPaddingRight() {
            return this.e6;
        }
        set axisAnnotationPaddingRight(a) {
            this.e6 = a;
            this.g("AxisAnnotationPaddingRight");
        }
        get axisAnnotationPaddingBottom() {
            return this.e4;
        }
        set axisAnnotationPaddingBottom(a) {
            this.e4 = a;
            this.g("AxisAnnotationPaddingBottom");
        }
        get axisAnnotationStrokeThickness() {
            return this.e8;
        }
        set axisAnnotationStrokeThickness(a) {
            this.e8 = a;
            this.g("AxisAnnotationStrokeThickness");
        }
    }
    ValueOverlayDescription.$t = /*@__PURE__*/ markType(ValueOverlayDescription, 'ValueOverlayDescription', SeriesDescription.$);
    return ValueOverlayDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueOverlayDescriptionMetadata = /*@__PURE__*/ (() => {
    class ValueOverlayDescriptionMetadata extends Base {
        static b(a) {
            if (ValueOverlayDescriptionMetadata.a == null) {
                ValueOverlayDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ValueOverlayDescriptionMetadata.c(ValueOverlayDescriptionMetadata.a);
            }
            if (a.k(ValueOverlayDescriptionMetadata.a)) {
                return;
            }
            a.ac(ValueOverlayDescriptionMetadata.a);
        }
        static c(a) {
            SeriesDescriptionMetadata.c(a);
            a.item("AxisRef", "(w:Axis,wf:Axis)DataRef::object");
            a.item("AxisRef@nameBinding", "true");
            a.item("Value", "Number:double");
            a.item("IsAxisAnnotationEnabled", "Boolean");
            a.item("AxisAnnotationFormatLabelRef", "(w:AxisAnnotationFormatLabel,wf:AxisAnnotationFormatLabel)MethodRef");
            a.item("AxisAnnotationTextColor", "Brush");
            a.item("AxisAnnotationBackground", "Brush");
            a.item("AxisAnnotationBackgroundCornerRadius", "Number:double");
            a.item("AxisAnnotationInterpolatedValuePrecision", "Number:int");
            a.item("AxisAnnotationOutline", "Brush");
            a.item("AxisAnnotationPaddingLeft", "Number:double");
            a.item("AxisAnnotationPaddingTop", "Number:double");
            a.item("AxisAnnotationPaddingRight", "Number:double");
            a.item("AxisAnnotationPaddingBottom", "Number:double");
            a.item("AxisAnnotationStrokeThickness", "Number:double");
        }
        static d(a) {
            ValueOverlayDescriptionMetadata.b(a);
            a.ae("ValueOverlay", () => new ValueOverlayDescription());
            a.ad("ValueOverlay", ValueOverlayDescriptionMetadata.a);
        }
    }
    ValueOverlayDescriptionMetadata.$t = /*@__PURE__*/ markType(ValueOverlayDescriptionMetadata, 'ValueOverlayDescriptionMetadata');
    ValueOverlayDescriptionMetadata.a = null;
    return ValueOverlayDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueOverlayDescriptionModule = /*@__PURE__*/ (() => {
    class ValueOverlayDescriptionModule extends Base {
        static register(a) {
            ValueOverlayDescriptionMetadata.d(a);
        }
    }
    ValueOverlayDescriptionModule.$t = /*@__PURE__*/ markType(ValueOverlayDescriptionModule, 'ValueOverlayDescriptionModule');
    return ValueOverlayDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VerticalSeparatorCellInfoDescription = /*@__PURE__*/ (() => {
    class VerticalSeparatorCellInfoDescription extends CellInfoDescription {
        get_type() {
            return "VerticalSeparatorCellInfo";
        }
        constructor() {
            super();
        }
    }
    VerticalSeparatorCellInfoDescription.$t = /*@__PURE__*/ markType(VerticalSeparatorCellInfoDescription, 'VerticalSeparatorCellInfoDescription', CellInfoDescription.$);
    VerticalSeparatorCellInfoDescription.__marshalByValue1 = true;
    VerticalSeparatorCellInfoDescription.__marshalByValueAlias1 = "VerticalSeparatorCellModel";
    return VerticalSeparatorCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VerticalSeparatorCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class VerticalSeparatorCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (VerticalSeparatorCellInfoDescriptionMetadata.a == null) {
                VerticalSeparatorCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                VerticalSeparatorCellInfoDescriptionMetadata.c(VerticalSeparatorCellInfoDescriptionMetadata.a);
            }
            if (a.k(VerticalSeparatorCellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(VerticalSeparatorCellInfoDescriptionMetadata.a);
        }
        static c(a) {
            CellInfoDescriptionMetadata.c(a);
        }
        static d(a) {
            VerticalSeparatorCellInfoDescriptionMetadata.b(a);
            a.ae("VerticalSeparatorCellInfo", () => new VerticalSeparatorCellInfoDescription());
            a.ad("VerticalSeparatorCellInfo", VerticalSeparatorCellInfoDescriptionMetadata.a);
        }
    }
    VerticalSeparatorCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(VerticalSeparatorCellInfoDescriptionMetadata, 'VerticalSeparatorCellInfoDescriptionMetadata');
    VerticalSeparatorCellInfoDescriptionMetadata.a = null;
    return VerticalSeparatorCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VirtualDataSourceDescription = /*@__PURE__*/ (() => {
    class VirtualDataSourceDescription extends BaseDataSourceDescription {
        get_type() {
            return "VirtualDataSource";
        }
        constructor() {
            super();
            this.az = false;
            this.a0 = false;
            this.a6 = 0;
            this.a5 = 0;
            this.a4 = 0;
            this.ba = null;
            this.ay = false;
        }
        get isSectionCollapsable() {
            return this.az;
        }
        set isSectionCollapsable(a) {
            this.az = a;
            this.g("IsSectionCollapsable");
        }
        get isSectionExpandedDefault() {
            return this.a0;
        }
        set isSectionExpandedDefault(a) {
            this.a0 = a;
            this.g("IsSectionExpandedDefault");
        }
        get pageSizeRequested() {
            return this.a6;
        }
        set pageSizeRequested(a) {
            this.a6 = a;
            this.g("PageSizeRequested");
        }
        get maxCachedPages() {
            return this.a5;
        }
        set maxCachedPages(a) {
            this.a5 = a;
            this.g("MaxCachedPages");
        }
        get actualPageSize() {
            return this.a4;
        }
        set actualPageSize(a) {
            this.a4 = a;
            this.g("ActualPageSize");
        }
        get concurrencyTag() {
            return this.ba;
        }
        set concurrencyTag(a) {
            this.ba = a;
            this.g("ConcurrencyTag");
        }
        get isBatchingEnabled() {
            return this.ay;
        }
        set isBatchingEnabled(a) {
            this.ay = a;
            this.g("IsBatchingEnabled");
        }
    }
    VirtualDataSourceDescription.$t = /*@__PURE__*/ markType(VirtualDataSourceDescription, 'VirtualDataSourceDescription', BaseDataSourceDescription.$);
    return VirtualDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VirtualDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class VirtualDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (VirtualDataSourceDescriptionMetadata.a == null) {
                VirtualDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                VirtualDataSourceDescriptionMetadata.c(VirtualDataSourceDescriptionMetadata.a);
            }
            if (a.k(VirtualDataSourceDescriptionMetadata.a)) {
                return;
            }
            a.ac(VirtualDataSourceDescriptionMetadata.a);
        }
        static c(a) {
            BaseDataSourceDescriptionMetadata.c(a);
            a.item("IsSectionCollapsable", "Boolean");
            a.item("IsSectionExpandedDefault", "Boolean");
            a.item("PageSizeRequested", "Number:int");
            a.item("MaxCachedPages", "Number:int");
            a.item("ActualPageSize", "Number:int");
            a.item("ConcurrencyTag", "String");
            a.item("IsBatchingEnabled", "Boolean");
        }
        static d(a) {
            VirtualDataSourceDescriptionMetadata.b(a);
            a.ae("VirtualDataSource", () => new VirtualDataSourceDescription());
            a.ad("VirtualDataSource", VirtualDataSourceDescriptionMetadata.a);
        }
    }
    VirtualDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(VirtualDataSourceDescriptionMetadata, 'VirtualDataSourceDescriptionMetadata');
    VirtualDataSourceDescriptionMetadata.a = null;
    return VirtualDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActionStripDescription = /*@__PURE__*/ (() => {
    class WebActionStripDescription extends Description {
        get_type() {
            return "WebActionStrip";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.l = false;
            this.j = null;
            this.n = null;
        }
        get actionButtons() {
            return this.h;
        }
        set actionButtons(a) {
            this.h = a;
            this.g("ActionButtons");
        }
        get hidden() {
            return this.l;
        }
        set hidden(a) {
            this.l = a;
            this.g("Hidden");
        }
        get resourceStrings() {
            return this.j;
        }
        set resourceStrings(a) {
            this.j = a;
            this.g("ResourceStrings");
        }
        get name() {
            return this.n;
        }
        set name(a) {
            this.n = a;
            this.g("Name");
        }
    }
    WebActionStripDescription.$t = /*@__PURE__*/ markType(WebActionStripDescription, 'WebActionStripDescription', Description.$);
    return WebActionStripDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActionStripResourceStringsDescription = /*@__PURE__*/ (() => {
    class WebActionStripResourceStringsDescription extends Description {
        get_type() {
            return "WebActionStripResourceStrings";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get igx_action_strip_button_more_title() {
            return this.h;
        }
        set igx_action_strip_button_more_title(a) {
            this.h = a;
            this.g("Igx_action_strip_button_more_title");
        }
    }
    WebActionStripResourceStringsDescription.$t = /*@__PURE__*/ markType(WebActionStripResourceStringsDescription, 'WebActionStripResourceStringsDescription', Description.$);
    return WebActionStripResourceStringsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActionStripResourceStringsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebActionStripResourceStringsDescriptionMetadata extends Base {
        static b(a) {
            if (WebActionStripResourceStringsDescriptionMetadata.a == null) {
                WebActionStripResourceStringsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebActionStripResourceStringsDescriptionMetadata.c(WebActionStripResourceStringsDescriptionMetadata.a);
            }
            if (a.k(WebActionStripResourceStringsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebActionStripResourceStringsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ActionStripResourceStrings");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Igx_action_strip_button_more_title", "String");
        }
        static d(a) {
            WebActionStripResourceStringsDescriptionMetadata.b(a);
            a.ae("WebActionStripResourceStrings", () => new WebActionStripResourceStringsDescription());
            a.ad("WebActionStripResourceStrings", WebActionStripResourceStringsDescriptionMetadata.a);
        }
    }
    WebActionStripResourceStringsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebActionStripResourceStringsDescriptionMetadata, 'WebActionStripResourceStringsDescriptionMetadata');
    WebActionStripResourceStringsDescriptionMetadata.a = null;
    return WebActionStripResourceStringsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActionStripDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebActionStripDescriptionMetadata extends Base {
        static b(a) {
            if (WebActionStripDescriptionMetadata.a == null) {
                WebActionStripDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebActionStripDescriptionMetadata.c(WebActionStripDescriptionMetadata.a);
            }
            if (a.k(WebActionStripDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebActionStripDescriptionMetadata.a);
            WebActionStripResourceStringsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ActionStrip");
            a.item("__tagNameWC", "String:igc-action-strip");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__portalChildrenWC", "Boolean");
            a.item("__manageCollectionInMarkup", "Boolean");
            a.item("__manageItemInMarkup", "Boolean");
            a.item("ActionButtons", "Collection:WebGridActionsBaseDirective:GridActionsBaseDirectiveCollection:WebGridActionsBaseDirective");
            a.item("Hidden", "Boolean");
            a.item("ResourceStrings", "ExportedType:WebActionStripResourceStrings");
            a.item("Name", "String");
        }
        static d(a) {
            WebActionStripDescriptionMetadata.b(a);
            a.ae("WebActionStrip", () => new WebActionStripDescription());
            a.ad("WebActionStrip", WebActionStripDescriptionMetadata.a);
        }
    }
    WebActionStripDescriptionMetadata.$t = /*@__PURE__*/ markType(WebActionStripDescriptionMetadata, 'WebActionStripDescriptionMetadata');
    WebActionStripDescriptionMetadata.a = null;
    return WebActionStripDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActionStripDescriptionModule = /*@__PURE__*/ (() => {
    class WebActionStripDescriptionModule extends Base {
        static register(a) {
            WebActionStripDescriptionMetadata.d(a);
        }
    }
    WebActionStripDescriptionModule.$t = /*@__PURE__*/ markType(WebActionStripDescriptionModule, 'WebActionStripDescriptionModule');
    return WebActionStripDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActivePaneEventArgsDescription = /*@__PURE__*/ (() => {
    class WebActivePaneEventArgsDescription extends Description {
        get_type() {
            return "WebActivePaneEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebActivePaneEventArgsDescription.$t = /*@__PURE__*/ markType(WebActivePaneEventArgsDescription, 'WebActivePaneEventArgsDescription', Description.$);
    WebActivePaneEventArgsDescription.__marshalByValue = true;
    WebActivePaneEventArgsDescription.__marshalByValueAlias = "ActivePaneEventArgs";
    return WebActivePaneEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockManagerPaneDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDockManagerPaneDescriptionMetadata extends Base {
        static b(a) {
            if (WebDockManagerPaneDescriptionMetadata.a == null) {
                WebDockManagerPaneDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDockManagerPaneDescriptionMetadata.c(WebDockManagerPaneDescriptionMetadata.a);
            }
            if (a.k(WebDockManagerPaneDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDockManagerPaneDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:DockManagerPane");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Name", "String");
        }
        static d(a) {
            WebDockManagerPaneDescriptionMetadata.b(a);
            a.ad("WebDockManagerPane", WebDockManagerPaneDescriptionMetadata.a);
        }
    }
    WebDockManagerPaneDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDockManagerPaneDescriptionMetadata, 'WebDockManagerPaneDescriptionMetadata');
    WebDockManagerPaneDescriptionMetadata.a = null;
    return WebDockManagerPaneDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockManagerPaneDescription = /*@__PURE__*/ (() => {
    class WebDockManagerPaneDescription extends Description {
        get_type() {
            return "WebDockManagerPane";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
        }
        get name() {
            return this.j;
        }
        set name(a) {
            this.j = a;
            this.g("Name");
        }
    }
    WebDockManagerPaneDescription.$t = /*@__PURE__*/ markType(WebDockManagerPaneDescription, 'WebDockManagerPaneDescription', Description.$);
    WebDockManagerPaneDescription.__marshalByValue = true;
    WebDockManagerPaneDescription.__marshalByValueAlias = "DockManagerPane";
    return WebDockManagerPaneDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebContentPaneDescription = /*@__PURE__*/ (() => {
    class WebContentPaneDescription extends WebDockManagerPaneDescription {
        get_type() {
            return "WebContentPane";
        }
        constructor() {
            super();
            this.as = null;
            this.at = null;
            this.ao = null;
            this.aq = null;
            this.ar = null;
            this.au = null;
            this.av = null;
            this.ap = null;
            this.aj = 0;
            this.o = false;
            this.r = false;
            this.s = false;
            this.p = false;
            this.n = false;
            this.q = false;
            this.ak = 0;
            this.x = false;
            this.w = false;
            this.aw = null;
            this.v = false;
            this.t = false;
            this.u = false;
        }
        get id() {
            return this.as;
        }
        set id(a) {
            this.as = a;
            this.g("Id");
        }
        get paneType() {
            return this.at;
        }
        set paneType(a) {
            this.at = a;
            this.g("PaneType");
        }
        get contentId() {
            return this.ao;
        }
        set contentId(a) {
            this.ao = a;
            this.g("ContentId");
        }
        get header() {
            return this.aq;
        }
        set header(a) {
            this.aq = a;
            this.g("Header");
        }
        get headerId() {
            return this.ar;
        }
        set headerId(a) {
            this.ar = a;
            this.g("HeaderId");
        }
        get tabHeaderId() {
            return this.au;
        }
        set tabHeaderId(a) {
            this.au = a;
            this.g("TabHeaderId");
        }
        get unpinnedHeaderId() {
            return this.av;
        }
        set unpinnedHeaderId(a) {
            this.av = a;
            this.g("UnpinnedHeaderId");
        }
        get floatingHeaderId() {
            return this.ap;
        }
        set floatingHeaderId(a) {
            this.ap = a;
            this.g("FloatingHeaderId");
        }
        get size() {
            return this.aj;
        }
        set size(a) {
            this.aj = a;
            this.g("Size");
        }
        get allowClose() {
            return this.o;
        }
        set allowClose(a) {
            this.o = a;
            this.g("AllowClose");
        }
        get allowMaximize() {
            return this.r;
        }
        set allowMaximize(a) {
            this.r = a;
            this.g("AllowMaximize");
        }
        get allowPinning() {
            return this.s;
        }
        set allowPinning(a) {
            this.s = a;
            this.g("AllowPinning");
        }
        get allowDocking() {
            return this.p;
        }
        set allowDocking(a) {
            this.p = a;
            this.g("AllowDocking");
        }
        get acceptsInnerDock() {
            return this.n;
        }
        set acceptsInnerDock(a) {
            this.n = a;
            this.g("AcceptsInnerDock");
        }
        get allowFloating() {
            return this.q;
        }
        set allowFloating(a) {
            this.q = a;
            this.g("AllowFloating");
        }
        get unpinnedSize() {
            return this.ak;
        }
        set unpinnedSize(a) {
            this.ak = a;
            this.g("UnpinnedSize");
        }
        get isPinned() {
            return this.x;
        }
        set isPinned(a) {
            this.x = a;
            this.g("IsPinned");
        }
        get isMaximized() {
            return this.w;
        }
        set isMaximized(a) {
            this.w = a;
            this.g("IsMaximized");
        }
        get unpinnedLocation() {
            return this.aw;
        }
        set unpinnedLocation(a) {
            this.aw = a;
            this.g("UnpinnedLocation");
        }
        get hidden() {
            return this.v;
        }
        set hidden(a) {
            this.v = a;
            this.g("Hidden");
        }
        get disabled() {
            return this.t;
        }
        set disabled(a) {
            this.t = a;
            this.g("Disabled");
        }
        get documentOnly() {
            return this.u;
        }
        set documentOnly(a) {
            this.u = a;
            this.g("DocumentOnly");
        }
    }
    WebContentPaneDescription.$t = /*@__PURE__*/ markType(WebContentPaneDescription, 'WebContentPaneDescription', WebDockManagerPaneDescription.$);
    WebContentPaneDescription.__marshalByValue1 = true;
    WebContentPaneDescription.__marshalByValueAlias1 = "ContentPane";
    return WebContentPaneDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebContentPaneDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebContentPaneDescriptionMetadata extends Base {
        static b(a) {
            if (WebContentPaneDescriptionMetadata.a == null) {
                WebContentPaneDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebContentPaneDescriptionMetadata.c(WebContentPaneDescriptionMetadata.a);
            }
            if (a.k(WebContentPaneDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebContentPaneDescriptionMetadata.a);
        }
        static c(a) {
            WebDockManagerPaneDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ContentPane");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Id", "String");
            a.item("PaneType", "(wc:Type)ExportedType:string:DockManagerPaneType");
            a.item("PaneType@names", "SplitPane;ContentPane;TabGroupPane;DocumentHost");
            a.item("ContentId", "String");
            a.item("Header", "String");
            a.item("HeaderId", "String");
            a.item("TabHeaderId", "String");
            a.item("UnpinnedHeaderId", "String");
            a.item("FloatingHeaderId", "String");
            a.item("Size", "Number:double");
            a.item("AllowClose", "Boolean");
            a.item("AllowMaximize", "Boolean");
            a.item("AllowPinning", "Boolean");
            a.item("AllowDocking", "Boolean");
            a.item("AcceptsInnerDock", "Boolean");
            a.item("AllowFloating", "Boolean");
            a.item("UnpinnedSize", "Number:double");
            a.item("IsPinned", "Boolean");
            a.item("IsMaximized", "Boolean");
            a.item("UnpinnedLocation", "ExportedType:string:UnpinnedLocation");
            a.item("UnpinnedLocation@stringUnion", "WebComponents;React");
            a.item("UnpinnedLocation@names", "Top;Bottom;Left;Right");
            a.item("Hidden", "Boolean");
            a.item("Disabled", "Boolean");
            a.item("DocumentOnly", "Boolean");
            WebContentPaneDescriptionMetadata.e(a);
        }
        static d(a) {
            WebContentPaneDescriptionMetadata.b(a);
            a.ae("WebContentPane", () => new WebContentPaneDescription());
            a.ad("WebContentPane", WebContentPaneDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__preferUnsuffixed", "Boolean");
        }
    }
    WebContentPaneDescriptionMetadata.$t = /*@__PURE__*/ markType(WebContentPaneDescriptionMetadata, 'WebContentPaneDescriptionMetadata');
    WebContentPaneDescriptionMetadata.a = null;
    return WebContentPaneDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActivePaneEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebActivePaneEventArgsDetailDescription extends Description {
        get_type() {
            return "WebActivePaneEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.i = null;
        }
        get newPane() {
            return this.h;
        }
        set newPane(a) {
            this.h = a;
            this.g("NewPane");
        }
        get oldPane() {
            return this.i;
        }
        set oldPane(a) {
            this.i = a;
            this.g("OldPane");
        }
    }
    WebActivePaneEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebActivePaneEventArgsDetailDescription, 'WebActivePaneEventArgsDetailDescription', Description.$);
    WebActivePaneEventArgsDetailDescription.__marshalByValue = true;
    WebActivePaneEventArgsDetailDescription.__marshalByValueAlias = "ActivePaneEventArgsDetail";
    return WebActivePaneEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActivePaneEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebActivePaneEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebActivePaneEventArgsDetailDescriptionMetadata.a == null) {
                WebActivePaneEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebActivePaneEventArgsDetailDescriptionMetadata.c(WebActivePaneEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebActivePaneEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebActivePaneEventArgsDetailDescriptionMetadata.a);
            WebContentPaneDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ActivePaneEventArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("NewPane", "ExportedType:WebContentPane");
            a.item("OldPane", "ExportedType:WebContentPane");
        }
        static d(a) {
            WebActivePaneEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebActivePaneEventArgsDetail", () => new WebActivePaneEventArgsDetailDescription());
            a.ad("WebActivePaneEventArgsDetail", WebActivePaneEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebActivePaneEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebActivePaneEventArgsDetailDescriptionMetadata, 'WebActivePaneEventArgsDetailDescriptionMetadata');
    WebActivePaneEventArgsDetailDescriptionMetadata.a = null;
    return WebActivePaneEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActivePaneEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebActivePaneEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebActivePaneEventArgsDescriptionMetadata.a == null) {
                WebActivePaneEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebActivePaneEventArgsDescriptionMetadata.c(WebActivePaneEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebActivePaneEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebActivePaneEventArgsDescriptionMetadata.a);
            WebActivePaneEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ActivePaneEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebActivePaneEventArgsDetail");
        }
        static d(a) {
            WebActivePaneEventArgsDescriptionMetadata.b(a);
            a.ae("WebActivePaneEventArgs", () => new WebActivePaneEventArgsDescription());
            a.ad("WebActivePaneEventArgs", WebActivePaneEventArgsDescriptionMetadata.a);
        }
    }
    WebActivePaneEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebActivePaneEventArgsDescriptionMetadata, 'WebActivePaneEventArgsDescriptionMetadata');
    WebActivePaneEventArgsDescriptionMetadata.a = null;
    return WebActivePaneEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActiveStepChangedArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebActiveStepChangedArgsDetailDescription extends Description {
        get_type() {
            return "WebActiveStepChangedArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = 0;
        }
        get index() {
            return this.i;
        }
        set index(a) {
            this.i = a;
            this.g("Index");
        }
    }
    WebActiveStepChangedArgsDetailDescription.$t = /*@__PURE__*/ markType(WebActiveStepChangedArgsDetailDescription, 'WebActiveStepChangedArgsDetailDescription', Description.$);
    WebActiveStepChangedArgsDetailDescription.__marshalByValue = true;
    WebActiveStepChangedArgsDetailDescription.__marshalByValueAlias = "ActiveStepChangedArgsDetail";
    return WebActiveStepChangedArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActiveStepChangedArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebActiveStepChangedArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebActiveStepChangedArgsDetailDescriptionMetadata.a == null) {
                WebActiveStepChangedArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebActiveStepChangedArgsDetailDescriptionMetadata.c(WebActiveStepChangedArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebActiveStepChangedArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebActiveStepChangedArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ActiveStepChangedArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Index", "Number:double");
        }
        static d(a) {
            WebActiveStepChangedArgsDetailDescriptionMetadata.b(a);
            a.ae("WebActiveStepChangedArgsDetail", () => new WebActiveStepChangedArgsDetailDescription());
            a.ad("WebActiveStepChangedArgsDetail", WebActiveStepChangedArgsDetailDescriptionMetadata.a);
        }
    }
    WebActiveStepChangedArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebActiveStepChangedArgsDetailDescriptionMetadata, 'WebActiveStepChangedArgsDetailDescriptionMetadata');
    WebActiveStepChangedArgsDetailDescriptionMetadata.a = null;
    return WebActiveStepChangedArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActiveStepChangedArgsEventArgsDescription = /*@__PURE__*/ (() => {
    class WebActiveStepChangedArgsEventArgsDescription extends Description {
        get_type() {
            return "WebActiveStepChangedArgsEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebActiveStepChangedArgsEventArgsDescription.$t = /*@__PURE__*/ markType(WebActiveStepChangedArgsEventArgsDescription, 'WebActiveStepChangedArgsEventArgsDescription', Description.$);
    WebActiveStepChangedArgsEventArgsDescription.__marshalByValue = true;
    WebActiveStepChangedArgsEventArgsDescription.__marshalByValueAlias = "ActiveStepChangedArgsEventArgs";
    return WebActiveStepChangedArgsEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActiveStepChangedArgsEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebActiveStepChangedArgsEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebActiveStepChangedArgsEventArgsDescriptionMetadata.a == null) {
                WebActiveStepChangedArgsEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebActiveStepChangedArgsEventArgsDescriptionMetadata.c(WebActiveStepChangedArgsEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebActiveStepChangedArgsEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebActiveStepChangedArgsEventArgsDescriptionMetadata.a);
            WebActiveStepChangedArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ActiveStepChangedArgsEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebActiveStepChangedArgsDetail");
        }
        static d(a) {
            WebActiveStepChangedArgsEventArgsDescriptionMetadata.b(a);
            a.ae("WebActiveStepChangedArgsEventArgs", () => new WebActiveStepChangedArgsEventArgsDescription());
            a.ad("WebActiveStepChangedArgsEventArgs", WebActiveStepChangedArgsEventArgsDescriptionMetadata.a);
        }
    }
    WebActiveStepChangedArgsEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebActiveStepChangedArgsEventArgsDescriptionMetadata, 'WebActiveStepChangedArgsEventArgsDescriptionMetadata');
    WebActiveStepChangedArgsEventArgsDescriptionMetadata.a = null;
    return WebActiveStepChangedArgsEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActiveStepChangingArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebActiveStepChangingArgsDetailDescription extends Description {
        get_type() {
            return "WebActiveStepChangingArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = 0;
            this.i = 0;
        }
        get oldIndex() {
            return this.j;
        }
        set oldIndex(a) {
            this.j = a;
            this.g("OldIndex");
        }
        get newIndex() {
            return this.i;
        }
        set newIndex(a) {
            this.i = a;
            this.g("NewIndex");
        }
    }
    WebActiveStepChangingArgsDetailDescription.$t = /*@__PURE__*/ markType(WebActiveStepChangingArgsDetailDescription, 'WebActiveStepChangingArgsDetailDescription', Description.$);
    WebActiveStepChangingArgsDetailDescription.__marshalByValue = true;
    WebActiveStepChangingArgsDetailDescription.__marshalByValueAlias = "ActiveStepChangingArgsDetail";
    return WebActiveStepChangingArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActiveStepChangingArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebActiveStepChangingArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebActiveStepChangingArgsDetailDescriptionMetadata.a == null) {
                WebActiveStepChangingArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebActiveStepChangingArgsDetailDescriptionMetadata.c(WebActiveStepChangingArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebActiveStepChangingArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebActiveStepChangingArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ActiveStepChangingArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("OldIndex", "Number:double");
            a.item("NewIndex", "Number:double");
        }
        static d(a) {
            WebActiveStepChangingArgsDetailDescriptionMetadata.b(a);
            a.ae("WebActiveStepChangingArgsDetail", () => new WebActiveStepChangingArgsDetailDescription());
            a.ad("WebActiveStepChangingArgsDetail", WebActiveStepChangingArgsDetailDescriptionMetadata.a);
        }
    }
    WebActiveStepChangingArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebActiveStepChangingArgsDetailDescriptionMetadata, 'WebActiveStepChangingArgsDetailDescriptionMetadata');
    WebActiveStepChangingArgsDetailDescriptionMetadata.a = null;
    return WebActiveStepChangingArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActiveStepChangingArgsEventArgsDescription = /*@__PURE__*/ (() => {
    class WebActiveStepChangingArgsEventArgsDescription extends Description {
        get_type() {
            return "WebActiveStepChangingArgsEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebActiveStepChangingArgsEventArgsDescription.$t = /*@__PURE__*/ markType(WebActiveStepChangingArgsEventArgsDescription, 'WebActiveStepChangingArgsEventArgsDescription', Description.$);
    WebActiveStepChangingArgsEventArgsDescription.__marshalByValue = true;
    WebActiveStepChangingArgsEventArgsDescription.__marshalByValueAlias = "ActiveStepChangingArgsEventArgs";
    return WebActiveStepChangingArgsEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebActiveStepChangingArgsEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebActiveStepChangingArgsEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebActiveStepChangingArgsEventArgsDescriptionMetadata.a == null) {
                WebActiveStepChangingArgsEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebActiveStepChangingArgsEventArgsDescriptionMetadata.c(WebActiveStepChangingArgsEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebActiveStepChangingArgsEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebActiveStepChangingArgsEventArgsDescriptionMetadata.a);
            WebActiveStepChangingArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ActiveStepChangingArgsEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebActiveStepChangingArgsDetail");
        }
        static d(a) {
            WebActiveStepChangingArgsEventArgsDescriptionMetadata.b(a);
            a.ae("WebActiveStepChangingArgsEventArgs", () => new WebActiveStepChangingArgsEventArgsDescription());
            a.ad("WebActiveStepChangingArgsEventArgs", WebActiveStepChangingArgsEventArgsDescriptionMetadata.a);
        }
    }
    WebActiveStepChangingArgsEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebActiveStepChangingArgsEventArgsDescriptionMetadata, 'WebActiveStepChangingArgsEventArgsDescriptionMetadata');
    WebActiveStepChangingArgsEventArgsDescriptionMetadata.a = null;
    return WebActiveStepChangingArgsEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBadgeDescription = /*@__PURE__*/ (() => {
    class WebBadgeDescription extends Description {
        get_type() {
            return "WebBadge";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = null;
            this.h = false;
            this.j = null;
        }
        get variant() {
            return this.k;
        }
        set variant(a) {
            this.k = a;
            this.g("Variant");
        }
        get outlined() {
            return this.h;
        }
        set outlined(a) {
            this.h = a;
            this.g("Outlined");
        }
        get shape() {
            return this.j;
        }
        set shape(a) {
            this.j = a;
            this.g("Shape");
        }
    }
    WebBadgeDescription.$t = /*@__PURE__*/ markType(WebBadgeDescription, 'WebBadgeDescription', Description.$);
    return WebBadgeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBadgeDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebBadgeDescriptionMetadata extends Base {
        static b(a) {
            if (WebBadgeDescriptionMetadata.a == null) {
                WebBadgeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebBadgeDescriptionMetadata.c(WebBadgeDescriptionMetadata.a);
            }
            if (a.k(WebBadgeDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebBadgeDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Badge");
            a.item("__tagNameWC", "String:igc-badge");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Variant", "ExportedType:string:StyleVariant");
            a.item("Variant@stringUnion", "WebComponents;React");
            a.item("Variant@names", "Primary;Info;Success;Warning;Danger");
            a.item("Outlined", "Boolean");
            a.item("Shape", "ExportedType:string:BadgeShape");
            a.item("Shape@stringUnion", "WebComponents;React");
            a.item("Shape@names", "Rounded;Square");
        }
        static d(a) {
            WebBadgeDescriptionMetadata.b(a);
            a.ae("WebBadge", () => new WebBadgeDescription());
            a.ad("WebBadge", WebBadgeDescriptionMetadata.a);
        }
    }
    WebBadgeDescriptionMetadata.$t = /*@__PURE__*/ markType(WebBadgeDescriptionMetadata, 'WebBadgeDescriptionMetadata');
    WebBadgeDescriptionMetadata.a = null;
    return WebBadgeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBadgeDescriptionModule = /*@__PURE__*/ (() => {
    class WebBadgeDescriptionModule extends Base {
        static register(a) {
            WebBadgeDescriptionMetadata.d(a);
        }
    }
    WebBadgeDescriptionModule.$t = /*@__PURE__*/ markType(WebBadgeDescriptionModule, 'WebBadgeDescriptionModule');
    return WebBadgeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBannerDescription = /*@__PURE__*/ (() => {
    class WebBannerDescription extends Description {
        get_type() {
            return "WebBanner";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
            this.k = null;
            this.j = null;
        }
        get open() {
            return this.h;
        }
        set open(a) {
            this.h = a;
            this.g("Open");
        }
        get closingRef() {
            return this.k;
        }
        set closingRef(a) {
            this.k = a;
            this.g("ClosingRef");
        }
        get closedRef() {
            return this.j;
        }
        set closedRef(a) {
            this.j = a;
            this.g("ClosedRef");
        }
    }
    WebBannerDescription.$t = /*@__PURE__*/ markType(WebBannerDescription, 'WebBannerDescription', Description.$);
    return WebBannerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBannerDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebBannerDescriptionMetadata extends Base {
        static b(a) {
            if (WebBannerDescriptionMetadata.a == null) {
                WebBannerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebBannerDescriptionMetadata.c(WebBannerDescriptionMetadata.a);
            }
            if (a.k(WebBannerDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebBannerDescriptionMetadata.a);
            VoidEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Banner");
            a.item("__tagNameWC", "String:igc-banner");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Open", "Boolean");
            a.item("ClosingRef", "EventRef::closing");
            a.item("ClosedRef", "EventRef::closed");
        }
        static d(a) {
            WebBannerDescriptionMetadata.b(a);
            a.ae("WebBanner", () => new WebBannerDescription());
            a.ad("WebBanner", WebBannerDescriptionMetadata.a);
        }
    }
    WebBannerDescriptionMetadata.$t = /*@__PURE__*/ markType(WebBannerDescriptionMetadata, 'WebBannerDescriptionMetadata');
    WebBannerDescriptionMetadata.a = null;
    return WebBannerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBannerDescriptionModule = /*@__PURE__*/ (() => {
    class WebBannerDescriptionModule extends Base {
        static register(a) {
            WebBannerDescriptionMetadata.d(a);
        }
    }
    WebBannerDescriptionModule.$t = /*@__PURE__*/ markType(WebBannerDescriptionModule, 'WebBannerDescriptionModule');
    return WebBannerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseAlertLikeDescription = /*@__PURE__*/ (() => {
    class WebBaseAlertLikeDescription extends Description {
        get_type() {
            return "WebBaseAlertLike";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = false;
            this.l = 0;
            this.h = false;
            this.n = null;
        }
        get open() {
            return this.i;
        }
        set open(a) {
            this.i = a;
            this.g("Open");
        }
        get displayTime() {
            return this.l;
        }
        set displayTime(a) {
            this.l = a;
            this.g("DisplayTime");
        }
        get keepOpen() {
            return this.h;
        }
        set keepOpen(a) {
            this.h = a;
            this.g("KeepOpen");
        }
        get position() {
            return this.n;
        }
        set position(a) {
            this.n = a;
            this.g("Position");
        }
    }
    WebBaseAlertLikeDescription.$t = /*@__PURE__*/ markType(WebBaseAlertLikeDescription, 'WebBaseAlertLikeDescription', Description.$);
    return WebBaseAlertLikeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseAlertLikeDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebBaseAlertLikeDescriptionMetadata extends Base {
        static b(a) {
            if (WebBaseAlertLikeDescriptionMetadata.a == null) {
                WebBaseAlertLikeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebBaseAlertLikeDescriptionMetadata.c(WebBaseAlertLikeDescriptionMetadata.a);
            }
            if (a.k(WebBaseAlertLikeDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebBaseAlertLikeDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:BaseAlertLike");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Open", "Boolean");
            a.item("DisplayTime", "Number:double");
            a.item("KeepOpen", "Boolean");
            a.item("Position", "ExportedType:string:BaseAlertLikePosition");
            a.item("Position@stringUnion", "WebComponents;React");
            a.item("Position@names", "Bottom;Middle;Top");
        }
        static d(a) {
            WebBaseAlertLikeDescriptionMetadata.b(a);
            a.ad("WebBaseAlertLike", WebBaseAlertLikeDescriptionMetadata.a);
        }
    }
    WebBaseAlertLikeDescriptionMetadata.$t = /*@__PURE__*/ markType(WebBaseAlertLikeDescriptionMetadata, 'WebBaseAlertLikeDescriptionMetadata');
    WebBaseAlertLikeDescriptionMetadata.a = null;
    return WebBaseAlertLikeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseAlertLikeDescriptionModule = /*@__PURE__*/ (() => {
    class WebBaseAlertLikeDescriptionModule extends Base {
        static register(a) {
        }
    }
    WebBaseAlertLikeDescriptionModule.$t = /*@__PURE__*/ markType(WebBaseAlertLikeDescriptionModule, 'WebBaseAlertLikeDescriptionModule');
    return WebBaseAlertLikeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseComboBoxLikeDescription = /*@__PURE__*/ (() => {
    class WebBaseComboBoxLikeDescription extends Description {
        get_type() {
            return "WebBaseComboBoxLike";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.i = false;
            this.h = false;
            this.j = false;
        }
        get emitEvent() {
            return this.n;
        }
        set emitEvent(a) {
            this.n = a;
            this.g("EmitEvent");
        }
        get keepOpenOnSelect() {
            return this.i;
        }
        set keepOpenOnSelect(a) {
            this.i = a;
            this.g("KeepOpenOnSelect");
        }
        get keepOpenOnOutsideClick() {
            return this.h;
        }
        set keepOpenOnOutsideClick(a) {
            this.h = a;
            this.g("KeepOpenOnOutsideClick");
        }
        get open() {
            return this.j;
        }
        set open(a) {
            this.j = a;
            this.g("Open");
        }
    }
    WebBaseComboBoxLikeDescription.$t = /*@__PURE__*/ markType(WebBaseComboBoxLikeDescription, 'WebBaseComboBoxLikeDescription', Description.$);
    return WebBaseComboBoxLikeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseComboBoxLikeDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebBaseComboBoxLikeDescriptionMetadata extends Base {
        static b(a) {
            if (WebBaseComboBoxLikeDescriptionMetadata.a == null) {
                WebBaseComboBoxLikeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebBaseComboBoxLikeDescriptionMetadata.c(WebBaseComboBoxLikeDescriptionMetadata.a);
            }
            if (a.k(WebBaseComboBoxLikeDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebBaseComboBoxLikeDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:BaseComboBoxLike");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("EmitEvent", "Unknown");
            a.item("KeepOpenOnSelect", "Boolean");
            a.item("KeepOpenOnOutsideClick", "Boolean");
            a.item("Open", "Boolean");
        }
        static d(a) {
            WebBaseComboBoxLikeDescriptionMetadata.b(a);
            a.ad("WebBaseComboBoxLike", WebBaseComboBoxLikeDescriptionMetadata.a);
        }
    }
    WebBaseComboBoxLikeDescriptionMetadata.$t = /*@__PURE__*/ markType(WebBaseComboBoxLikeDescriptionMetadata, 'WebBaseComboBoxLikeDescriptionMetadata');
    WebBaseComboBoxLikeDescriptionMetadata.a = null;
    return WebBaseComboBoxLikeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseComboBoxLikeDescriptionModule = /*@__PURE__*/ (() => {
    class WebBaseComboBoxLikeDescriptionModule extends Base {
        static register(a) {
        }
    }
    WebBaseComboBoxLikeDescriptionModule.$t = /*@__PURE__*/ markType(WebBaseComboBoxLikeDescriptionModule, 'WebBaseComboBoxLikeDescriptionModule');
    return WebBaseComboBoxLikeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseDateTimeFilteringOperandDescription = /*@__PURE__*/ (() => {
    class WebBaseDateTimeFilteringOperandDescription extends WebFilteringOperandDescription {
        get_type() {
            return "WebBaseDateTimeFilteringOperand";
        }
        constructor() {
            super();
        }
    }
    WebBaseDateTimeFilteringOperandDescription.$t = /*@__PURE__*/ markType(WebBaseDateTimeFilteringOperandDescription, 'WebBaseDateTimeFilteringOperandDescription', WebFilteringOperandDescription.$);
    return WebBaseDateTimeFilteringOperandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseDateTimeFilteringOperandDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebBaseDateTimeFilteringOperandDescriptionMetadata extends Base {
        static b(a) {
            if (WebBaseDateTimeFilteringOperandDescriptionMetadata.a == null) {
                WebBaseDateTimeFilteringOperandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebBaseDateTimeFilteringOperandDescriptionMetadata.c(WebBaseDateTimeFilteringOperandDescriptionMetadata.a);
            }
            if (a.k(WebBaseDateTimeFilteringOperandDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebBaseDateTimeFilteringOperandDescriptionMetadata.a);
        }
        static c(a) {
            WebFilteringOperandDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:BaseDateTimeFilteringOperand");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebBaseDateTimeFilteringOperandDescriptionMetadata.b(a);
            a.ae("WebBaseDateTimeFilteringOperand", () => new WebBaseDateTimeFilteringOperandDescription());
            a.ad("WebBaseDateTimeFilteringOperand", WebBaseDateTimeFilteringOperandDescriptionMetadata.a);
        }
    }
    WebBaseDateTimeFilteringOperandDescriptionMetadata.$t = /*@__PURE__*/ markType(WebBaseDateTimeFilteringOperandDescriptionMetadata, 'WebBaseDateTimeFilteringOperandDescriptionMetadata');
    WebBaseDateTimeFilteringOperandDescriptionMetadata.a = null;
    return WebBaseDateTimeFilteringOperandDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseExporterDescription = /*@__PURE__*/ (() => {
    class WebBaseExporterDescription extends Description {
        get_type() {
            return "WebBaseExporter";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.j = null;
            this.h = null;
        }
        get exportEndedRef() {
            return this.i;
        }
        set exportEndedRef(a) {
            this.i = a;
            this.g("ExportEndedRef");
        }
        get rowExportingRef() {
            return this.j;
        }
        set rowExportingRef(a) {
            this.j = a;
            this.g("RowExportingRef");
        }
        get columnExportingRef() {
            return this.h;
        }
        set columnExportingRef(a) {
            this.h = a;
            this.g("ColumnExportingRef");
        }
    }
    WebBaseExporterDescription.$t = /*@__PURE__*/ markType(WebBaseExporterDescription, 'WebBaseExporterDescription', Description.$);
    return WebBaseExporterDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseOptionLikeDescription = /*@__PURE__*/ (() => {
    class WebBaseOptionLikeDescription extends Description {
        get_type() {
            return "WebBaseOptionLike";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
            this.i = false;
            this.j = false;
            this.n = null;
        }
        get active() {
            return this.h;
        }
        set active(a) {
            this.h = a;
            this.g("Active");
        }
        get disabled() {
            return this.i;
        }
        set disabled(a) {
            this.i = a;
            this.g("Disabled");
        }
        get selected() {
            return this.j;
        }
        set selected(a) {
            this.j = a;
            this.g("Selected");
        }
        get value() {
            return this.n;
        }
        set value(a) {
            this.n = a;
            this.g("Value");
        }
    }
    WebBaseOptionLikeDescription.$t = /*@__PURE__*/ markType(WebBaseOptionLikeDescription, 'WebBaseOptionLikeDescription', Description.$);
    return WebBaseOptionLikeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseOptionLikeDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebBaseOptionLikeDescriptionMetadata extends Base {
        static b(a) {
            if (WebBaseOptionLikeDescriptionMetadata.a == null) {
                WebBaseOptionLikeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebBaseOptionLikeDescriptionMetadata.c(WebBaseOptionLikeDescriptionMetadata.a);
            }
            if (a.k(WebBaseOptionLikeDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebBaseOptionLikeDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:BaseOptionLike");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Active", "Boolean");
            a.item("Disabled", "Boolean");
            a.item("Selected", "Boolean");
            a.item("Value", "String");
        }
        static d(a) {
            WebBaseOptionLikeDescriptionMetadata.b(a);
            a.ad("WebBaseOptionLike", WebBaseOptionLikeDescriptionMetadata.a);
        }
    }
    WebBaseOptionLikeDescriptionMetadata.$t = /*@__PURE__*/ markType(WebBaseOptionLikeDescriptionMetadata, 'WebBaseOptionLikeDescriptionMetadata');
    WebBaseOptionLikeDescriptionMetadata.a = null;
    return WebBaseOptionLikeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseOptionLikeDescriptionModule = /*@__PURE__*/ (() => {
    class WebBaseOptionLikeDescriptionModule extends Base {
        static register(a) {
        }
    }
    WebBaseOptionLikeDescriptionModule.$t = /*@__PURE__*/ markType(WebBaseOptionLikeDescriptionModule, 'WebBaseOptionLikeDescriptionModule');
    return WebBaseOptionLikeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseSearchInfoDescription = /*@__PURE__*/ (() => {
    class WebBaseSearchInfoDescription extends Description {
        get_type() {
            return "WebBaseSearchInfo";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.o = null;
            this.h = false;
            this.i = false;
            this.l = 0;
            this.n = null;
        }
        get searchText() {
            return this.o;
        }
        set searchText(a) {
            this.o = a;
            this.g("SearchText");
        }
        get caseSensitive() {
            return this.h;
        }
        set caseSensitive(a) {
            this.h = a;
            this.g("CaseSensitive");
        }
        get exactMatch() {
            return this.i;
        }
        set exactMatch(a) {
            this.i = a;
            this.g("ExactMatch");
        }
        get matchCount() {
            return this.l;
        }
        set matchCount(a) {
            this.l = a;
            this.g("MatchCount");
        }
        get content() {
            return this.n;
        }
        set content(a) {
            this.n = a;
            this.g("Content");
        }
    }
    WebBaseSearchInfoDescription.$t = /*@__PURE__*/ markType(WebBaseSearchInfoDescription, 'WebBaseSearchInfoDescription', Description.$);
    return WebBaseSearchInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseSearchInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebBaseSearchInfoDescriptionMetadata extends Base {
        static b(a) {
            if (WebBaseSearchInfoDescriptionMetadata.a == null) {
                WebBaseSearchInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebBaseSearchInfoDescriptionMetadata.c(WebBaseSearchInfoDescriptionMetadata.a);
            }
            if (a.k(WebBaseSearchInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebBaseSearchInfoDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:BaseSearchInfo");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("SearchText", "String");
            a.item("CaseSensitive", "Boolean");
            a.item("ExactMatch", "Boolean");
            a.item("MatchCount", "Number:double");
            a.item("Content", "String");
        }
        static d(a) {
            WebBaseSearchInfoDescriptionMetadata.b(a);
            a.ae("WebBaseSearchInfo", () => new WebBaseSearchInfoDescription());
            a.ad("WebBaseSearchInfo", WebBaseSearchInfoDescriptionMetadata.a);
        }
    }
    WebBaseSearchInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(WebBaseSearchInfoDescriptionMetadata, 'WebBaseSearchInfoDescriptionMetadata');
    WebBaseSearchInfoDescriptionMetadata.a = null;
    return WebBaseSearchInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarBaseActionDescription = /*@__PURE__*/ (() => {
    class WebGridToolbarBaseActionDescription extends Description {
        get_type() {
            return "WebGridToolbarBaseAction";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get name() {
            return this.h;
        }
        set name(a) {
            this.h = a;
            this.g("Name");
        }
    }
    WebGridToolbarBaseActionDescription.$t = /*@__PURE__*/ markType(WebGridToolbarBaseActionDescription, 'WebGridToolbarBaseActionDescription', Description.$);
    return WebGridToolbarBaseActionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseToolbarDirectiveDescription = /*@__PURE__*/ (() => {
    class WebBaseToolbarDirectiveDescription extends WebGridToolbarBaseActionDescription {
        get_type() {
            return "WebBaseToolbarDirective";
        }
        constructor() {
            super();
            this.o = null;
            this.u = null;
            this.t = null;
            this.k = null;
            this.q = null;
            this.s = null;
            this.r = null;
            this.n = null;
            this.m = null;
            this.p = null;
        }
        get columnListHeight() {
            return this.o;
        }
        set columnListHeight(a) {
            this.o = a;
            this.g("ColumnListHeight");
        }
        get title() {
            return this.u;
        }
        set title(a) {
            this.u = a;
            this.g("Title");
        }
        get prompt() {
            return this.t;
        }
        set prompt(a) {
            this.t = a;
            this.g("Prompt");
        }
        get overlaySettings() {
            return this.k;
        }
        set overlaySettings(a) {
            this.k = a;
            this.g("OverlaySettings");
        }
        get name() {
            return this.q;
        }
        set name(a) {
            this.q = a;
            this.g("Name");
        }
        get openingRef() {
            return this.s;
        }
        set openingRef(a) {
            this.s = a;
            this.g("OpeningRef");
        }
        get openedRef() {
            return this.r;
        }
        set openedRef(a) {
            this.r = a;
            this.g("OpenedRef");
        }
        get closingRef() {
            return this.n;
        }
        set closingRef(a) {
            this.n = a;
            this.g("ClosingRef");
        }
        get closedRef() {
            return this.m;
        }
        set closedRef(a) {
            this.m = a;
            this.g("ClosedRef");
        }
        get columnToggleRef() {
            return this.p;
        }
        set columnToggleRef(a) {
            this.p = a;
            this.g("ColumnToggleRef");
        }
    }
    WebBaseToolbarDirectiveDescription.$t = /*@__PURE__*/ markType(WebBaseToolbarDirectiveDescription, 'WebBaseToolbarDirectiveDescription', WebGridToolbarBaseActionDescription.$);
    return WebBaseToolbarDirectiveDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseToolbarColumnActionsDirectiveDescription = /*@__PURE__*/ (() => {
    class WebBaseToolbarColumnActionsDirectiveDescription extends WebBaseToolbarDirectiveDescription {
        get_type() {
            return "WebBaseToolbarColumnActionsDirective";
        }
        constructor() {
            super();
            this.ae = null;
        }
        get name() {
            return this.ae;
        }
        set name(a) {
            this.ae = a;
            this.g("Name");
        }
    }
    WebBaseToolbarColumnActionsDirectiveDescription.$t = /*@__PURE__*/ markType(WebBaseToolbarColumnActionsDirectiveDescription, 'WebBaseToolbarColumnActionsDirectiveDescription', WebBaseToolbarDirectiveDescription.$);
    return WebBaseToolbarColumnActionsDirectiveDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSizeDescription = /*@__PURE__*/ (() => {
    class WebSizeDescription extends Description {
        get_type() {
            return "WebSize";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = 0;
            this.h = 0;
        }
        get width() {
            return this.i;
        }
        set width(a) {
            this.i = a;
            this.g("Width");
        }
        get height() {
            return this.h;
        }
        set height(a) {
            this.h = a;
            this.g("Height");
        }
    }
    WebSizeDescription.$t = /*@__PURE__*/ markType(WebSizeDescription, 'WebSizeDescription', Description.$);
    return WebSizeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSizeDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSizeDescriptionMetadata extends Base {
        static b(a) {
            if (WebSizeDescriptionMetadata.a == null) {
                WebSizeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSizeDescriptionMetadata.c(WebSizeDescriptionMetadata.a);
            }
            if (a.k(WebSizeDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSizeDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Size");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Width", "Number:double");
            a.item("Height", "Number:double");
        }
        static d(a) {
            WebSizeDescriptionMetadata.b(a);
            a.ae("WebSize", () => new WebSizeDescription());
            a.ad("WebSize", WebSizeDescriptionMetadata.a);
        }
    }
    WebSizeDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSizeDescriptionMetadata, 'WebSizeDescriptionMetadata');
    WebSizeDescriptionMetadata.a = null;
    return WebSizeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPositionSettingsDescription = /*@__PURE__*/ (() => {
    class WebPositionSettingsDescription extends Description {
        get_type() {
            return "WebPositionSettings";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.l = null;
            this.k = null;
            this.m = null;
            this.h = null;
        }
        get horizontalDirection() {
            return this.j;
        }
        set horizontalDirection(a) {
            this.j = a;
            this.g("HorizontalDirection");
        }
        get verticalDirection() {
            return this.l;
        }
        set verticalDirection(a) {
            this.l = a;
            this.g("VerticalDirection");
        }
        get horizontalStartPoint() {
            return this.k;
        }
        set horizontalStartPoint(a) {
            this.k = a;
            this.g("HorizontalStartPoint");
        }
        get verticalStartPoint() {
            return this.m;
        }
        set verticalStartPoint(a) {
            this.m = a;
            this.g("VerticalStartPoint");
        }
        get minSize() {
            return this.h;
        }
        set minSize(a) {
            this.h = a;
            this.g("MinSize");
        }
    }
    WebPositionSettingsDescription.$t = /*@__PURE__*/ markType(WebPositionSettingsDescription, 'WebPositionSettingsDescription', Description.$);
    return WebPositionSettingsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPositionSettingsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPositionSettingsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPositionSettingsDescriptionMetadata.a == null) {
                WebPositionSettingsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPositionSettingsDescriptionMetadata.c(WebPositionSettingsDescriptionMetadata.a);
            }
            if (a.k(WebPositionSettingsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPositionSettingsDescriptionMetadata.a);
            WebSizeDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PositionSettings");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("HorizontalDirection", "ExportedType:string:GridHorizontalAlignment");
            a.item("HorizontalDirection@names", "Left;Center;Right");
            a.item("VerticalDirection", "ExportedType:string:GridVerticalAlignment");
            a.item("VerticalDirection@names", "Top;Middle;Bottom");
            a.item("HorizontalStartPoint", "ExportedType:string:GridHorizontalAlignment");
            a.item("HorizontalStartPoint@names", "Left;Center;Right");
            a.item("VerticalStartPoint", "ExportedType:string:GridVerticalAlignment");
            a.item("VerticalStartPoint@names", "Top;Middle;Bottom");
            a.item("MinSize", "ExportedType:WebSize");
        }
        static d(a) {
            WebPositionSettingsDescriptionMetadata.b(a);
            a.ae("WebPositionSettings", () => new WebPositionSettingsDescription());
            a.ad("WebPositionSettings", WebPositionSettingsDescriptionMetadata.a);
        }
    }
    WebPositionSettingsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPositionSettingsDescriptionMetadata, 'WebPositionSettingsDescriptionMetadata');
    WebPositionSettingsDescriptionMetadata.a = null;
    return WebPositionSettingsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPositionStrategyDescription = /*@__PURE__*/ (() => {
    class WebPositionStrategyDescription extends Description {
        get_type() {
            return "WebPositionStrategy";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get settings() {
            return this.h;
        }
        set settings(a) {
            this.h = a;
            this.g("Settings");
        }
    }
    WebPositionStrategyDescription.$t = /*@__PURE__*/ markType(WebPositionStrategyDescription, 'WebPositionStrategyDescription', Description.$);
    return WebPositionStrategyDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPositionStrategyDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPositionStrategyDescriptionMetadata extends Base {
        static b(a) {
            if (WebPositionStrategyDescriptionMetadata.a == null) {
                WebPositionStrategyDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPositionStrategyDescriptionMetadata.c(WebPositionStrategyDescriptionMetadata.a);
            }
            if (a.k(WebPositionStrategyDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPositionStrategyDescriptionMetadata.a);
            WebPositionSettingsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PositionStrategy");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Settings", "ExportedType:WebPositionSettings");
        }
        static d(a) {
            WebPositionStrategyDescriptionMetadata.b(a);
            a.ae("WebPositionStrategy", () => new WebPositionStrategyDescription());
            a.ad("WebPositionStrategy", WebPositionStrategyDescriptionMetadata.a);
        }
    }
    WebPositionStrategyDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPositionStrategyDescriptionMetadata, 'WebPositionStrategyDescriptionMetadata');
    WebPositionStrategyDescriptionMetadata.a = null;
    return WebPositionStrategyDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebScrollStrategyDescription = /*@__PURE__*/ (() => {
    class WebScrollStrategyDescription extends Description {
        get_type() {
            return "WebScrollStrategy";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebScrollStrategyDescription.$t = /*@__PURE__*/ markType(WebScrollStrategyDescription, 'WebScrollStrategyDescription', Description.$);
    return WebScrollStrategyDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebScrollStrategyDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebScrollStrategyDescriptionMetadata extends Base {
        static b(a) {
            if (WebScrollStrategyDescriptionMetadata.a == null) {
                WebScrollStrategyDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebScrollStrategyDescriptionMetadata.c(WebScrollStrategyDescriptionMetadata.a);
            }
            if (a.k(WebScrollStrategyDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebScrollStrategyDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ScrollStrategy");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebScrollStrategyDescriptionMetadata.b(a);
            a.ae("WebScrollStrategy", () => new WebScrollStrategyDescription());
            a.ad("WebScrollStrategy", WebScrollStrategyDescriptionMetadata.a);
        }
    }
    WebScrollStrategyDescriptionMetadata.$t = /*@__PURE__*/ markType(WebScrollStrategyDescriptionMetadata, 'WebScrollStrategyDescriptionMetadata');
    WebScrollStrategyDescriptionMetadata.a = null;
    return WebScrollStrategyDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebOverlaySettingsDescription = /*@__PURE__*/ (() => {
    class WebOverlaySettingsDescription extends Description {
        get_type() {
            return "WebOverlaySettings";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.r = null;
            this.h = null;
            this.j = null;
            this.n = false;
            this.m = false;
            this.l = false;
        }
        get target() {
            return this.r;
        }
        set target(a) {
            this.r = a;
            this.g("Target");
        }
        get positionStrategy() {
            return this.h;
        }
        set positionStrategy(a) {
            this.h = a;
            this.g("PositionStrategy");
        }
        get scrollStrategy() {
            return this.j;
        }
        set scrollStrategy(a) {
            this.j = a;
            this.g("ScrollStrategy");
        }
        get modal() {
            return this.n;
        }
        set modal(a) {
            this.n = a;
            this.g("Modal");
        }
        get closeOnOutsideClick() {
            return this.m;
        }
        set closeOnOutsideClick(a) {
            this.m = a;
            this.g("CloseOnOutsideClick");
        }
        get closeOnEscape() {
            return this.l;
        }
        set closeOnEscape(a) {
            this.l = a;
            this.g("CloseOnEscape");
        }
    }
    WebOverlaySettingsDescription.$t = /*@__PURE__*/ markType(WebOverlaySettingsDescription, 'WebOverlaySettingsDescription', Description.$);
    return WebOverlaySettingsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebOverlaySettingsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebOverlaySettingsDescriptionMetadata extends Base {
        static b(a) {
            if (WebOverlaySettingsDescriptionMetadata.a == null) {
                WebOverlaySettingsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebOverlaySettingsDescriptionMetadata.c(WebOverlaySettingsDescriptionMetadata.a);
            }
            if (a.k(WebOverlaySettingsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebOverlaySettingsDescriptionMetadata.a);
            WebPositionStrategyDescriptionMetadata.d(a);
            WebScrollStrategyDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:OverlaySettings");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Target", "Unknown");
            a.item("PositionStrategy", "ExportedType:WebPositionStrategy");
            a.item("ScrollStrategy", "ExportedType:WebScrollStrategy");
            a.item("Modal", "Boolean");
            a.item("CloseOnOutsideClick", "Boolean");
            a.item("CloseOnEscape", "Boolean");
        }
        static d(a) {
            WebOverlaySettingsDescriptionMetadata.b(a);
            a.ae("WebOverlaySettings", () => new WebOverlaySettingsDescription());
            a.ad("WebOverlaySettings", WebOverlaySettingsDescriptionMetadata.a);
        }
    }
    WebOverlaySettingsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebOverlaySettingsDescriptionMetadata, 'WebOverlaySettingsDescriptionMetadata');
    WebOverlaySettingsDescriptionMetadata.a = null;
    return WebOverlaySettingsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebToggleViewCancelableEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebToggleViewCancelableEventArgsDetailDescription extends Description {
        get_type() {
            return "WebToggleViewCancelableEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
        }
        get id() {
            return this.j;
        }
        set id(a) {
            this.j = a;
            this.g("Id");
        }
    }
    WebToggleViewCancelableEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebToggleViewCancelableEventArgsDetailDescription, 'WebToggleViewCancelableEventArgsDetailDescription', Description.$);
    WebToggleViewCancelableEventArgsDetailDescription.__marshalByValue = true;
    WebToggleViewCancelableEventArgsDetailDescription.__marshalByValueAlias = "ToggleViewCancelableEventArgsDetail";
    return WebToggleViewCancelableEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebToggleViewCancelableEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebToggleViewCancelableEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebToggleViewCancelableEventArgsDetailDescriptionMetadata.a == null) {
                WebToggleViewCancelableEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebToggleViewCancelableEventArgsDetailDescriptionMetadata.c(WebToggleViewCancelableEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebToggleViewCancelableEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebToggleViewCancelableEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ToggleViewCancelableEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Id", "String");
        }
        static d(a) {
            WebToggleViewCancelableEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebToggleViewCancelableEventArgsDetail", () => new WebToggleViewCancelableEventArgsDetailDescription());
            a.ad("WebToggleViewCancelableEventArgsDetail", WebToggleViewCancelableEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebToggleViewCancelableEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebToggleViewCancelableEventArgsDetailDescriptionMetadata, 'WebToggleViewCancelableEventArgsDetailDescriptionMetadata');
    WebToggleViewCancelableEventArgsDetailDescriptionMetadata.a = null;
    return WebToggleViewCancelableEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebToggleViewCancelableEventArgsDescription = /*@__PURE__*/ (() => {
    class WebToggleViewCancelableEventArgsDescription extends Description {
        get_type() {
            return "WebToggleViewCancelableEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebToggleViewCancelableEventArgsDescription.$t = /*@__PURE__*/ markType(WebToggleViewCancelableEventArgsDescription, 'WebToggleViewCancelableEventArgsDescription', Description.$);
    WebToggleViewCancelableEventArgsDescription.__marshalByValue = true;
    WebToggleViewCancelableEventArgsDescription.__marshalByValueAlias = "ToggleViewCancelableEventArgs";
    return WebToggleViewCancelableEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebToggleViewCancelableEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebToggleViewCancelableEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebToggleViewCancelableEventArgsDescriptionMetadata.a == null) {
                WebToggleViewCancelableEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebToggleViewCancelableEventArgsDescriptionMetadata.c(WebToggleViewCancelableEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebToggleViewCancelableEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebToggleViewCancelableEventArgsDescriptionMetadata.a);
            WebToggleViewCancelableEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ToggleViewCancelableEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebToggleViewCancelableEventArgsDetail");
        }
        static d(a) {
            WebToggleViewCancelableEventArgsDescriptionMetadata.b(a);
            a.ae("WebToggleViewCancelableEventArgs", () => new WebToggleViewCancelableEventArgsDescription());
            a.ad("WebToggleViewCancelableEventArgs", WebToggleViewCancelableEventArgsDescriptionMetadata.a);
        }
    }
    WebToggleViewCancelableEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebToggleViewCancelableEventArgsDescriptionMetadata, 'WebToggleViewCancelableEventArgsDescriptionMetadata');
    WebToggleViewCancelableEventArgsDescriptionMetadata.a = null;
    return WebToggleViewCancelableEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebToggleViewEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebToggleViewEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebToggleViewEventArgsDetail";
        }
        constructor() {
            super();
            this.o = null;
        }
        get id() {
            return this.o;
        }
        set id(a) {
            this.o = a;
            this.g("Id");
        }
    }
    WebToggleViewEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebToggleViewEventArgsDetailDescription, 'WebToggleViewEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebToggleViewEventArgsDetailDescription.__marshalByValue1 = true;
    WebToggleViewEventArgsDetailDescription.__marshalByValueAlias1 = "ToggleViewEventArgsDetail";
    return WebToggleViewEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebToggleViewEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebToggleViewEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebToggleViewEventArgsDetailDescriptionMetadata.a == null) {
                WebToggleViewEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebToggleViewEventArgsDetailDescriptionMetadata.c(WebToggleViewEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebToggleViewEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebToggleViewEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ToggleViewEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Id", "String");
        }
        static d(a) {
            WebToggleViewEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebToggleViewEventArgsDetail", () => new WebToggleViewEventArgsDetailDescription());
            a.ad("WebToggleViewEventArgsDetail", WebToggleViewEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebToggleViewEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebToggleViewEventArgsDetailDescriptionMetadata, 'WebToggleViewEventArgsDetailDescriptionMetadata');
    WebToggleViewEventArgsDetailDescriptionMetadata.a = null;
    return WebToggleViewEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebToggleViewEventArgsDescription = /*@__PURE__*/ (() => {
    class WebToggleViewEventArgsDescription extends Description {
        get_type() {
            return "WebToggleViewEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebToggleViewEventArgsDescription.$t = /*@__PURE__*/ markType(WebToggleViewEventArgsDescription, 'WebToggleViewEventArgsDescription', Description.$);
    WebToggleViewEventArgsDescription.__marshalByValue = true;
    WebToggleViewEventArgsDescription.__marshalByValueAlias = "ToggleViewEventArgs";
    return WebToggleViewEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebToggleViewEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebToggleViewEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebToggleViewEventArgsDescriptionMetadata.a == null) {
                WebToggleViewEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebToggleViewEventArgsDescriptionMetadata.c(WebToggleViewEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebToggleViewEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebToggleViewEventArgsDescriptionMetadata.a);
            WebToggleViewEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ToggleViewEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebToggleViewEventArgsDetail");
        }
        static d(a) {
            WebToggleViewEventArgsDescriptionMetadata.b(a);
            a.ae("WebToggleViewEventArgs", () => new WebToggleViewEventArgsDescription());
            a.ad("WebToggleViewEventArgs", WebToggleViewEventArgsDescriptionMetadata.a);
        }
    }
    WebToggleViewEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebToggleViewEventArgsDescriptionMetadata, 'WebToggleViewEventArgsDescriptionMetadata');
    WebToggleViewEventArgsDescriptionMetadata.a = null;
    return WebToggleViewEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnToggledEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebColumnToggledEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebColumnToggledEventArgsDetail";
        }
        constructor() {
            super();
            this.m = null;
            this.p = false;
        }
        get column() {
            return this.m;
        }
        set column(a) {
            this.m = a;
            this.g("Column");
        }
        get checked() {
            return this.p;
        }
        set checked(a) {
            this.p = a;
            this.g("Checked");
        }
    }
    WebColumnToggledEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebColumnToggledEventArgsDetailDescription, 'WebColumnToggledEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebColumnToggledEventArgsDetailDescription.__marshalByValue1 = true;
    WebColumnToggledEventArgsDetailDescription.__marshalByValueAlias1 = "ColumnToggledEventArgsDetail";
    return WebColumnToggledEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnToggledEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnToggledEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnToggledEventArgsDetailDescriptionMetadata.a == null) {
                WebColumnToggledEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnToggledEventArgsDetailDescriptionMetadata.c(WebColumnToggledEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebColumnToggledEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnToggledEventArgsDetailDescriptionMetadata.a);
            WebColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ColumnToggledEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Column", "ExportedType:WebColumn");
            a.item("Checked", "Boolean");
        }
        static d(a) {
            WebColumnToggledEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebColumnToggledEventArgsDetail", () => new WebColumnToggledEventArgsDetailDescription());
            a.ad("WebColumnToggledEventArgsDetail", WebColumnToggledEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebColumnToggledEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnToggledEventArgsDetailDescriptionMetadata, 'WebColumnToggledEventArgsDetailDescriptionMetadata');
    WebColumnToggledEventArgsDetailDescriptionMetadata.a = null;
    return WebColumnToggledEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnToggledEventArgsDescription = /*@__PURE__*/ (() => {
    class WebColumnToggledEventArgsDescription extends Description {
        get_type() {
            return "WebColumnToggledEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebColumnToggledEventArgsDescription.$t = /*@__PURE__*/ markType(WebColumnToggledEventArgsDescription, 'WebColumnToggledEventArgsDescription', Description.$);
    WebColumnToggledEventArgsDescription.__marshalByValue = true;
    WebColumnToggledEventArgsDescription.__marshalByValueAlias = "ColumnToggledEventArgs";
    return WebColumnToggledEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnToggledEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnToggledEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnToggledEventArgsDescriptionMetadata.a == null) {
                WebColumnToggledEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnToggledEventArgsDescriptionMetadata.c(WebColumnToggledEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebColumnToggledEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnToggledEventArgsDescriptionMetadata.a);
            WebColumnToggledEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnToggledEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebColumnToggledEventArgsDetail");
        }
        static d(a) {
            WebColumnToggledEventArgsDescriptionMetadata.b(a);
            a.ae("WebColumnToggledEventArgs", () => new WebColumnToggledEventArgsDescription());
            a.ad("WebColumnToggledEventArgs", WebColumnToggledEventArgsDescriptionMetadata.a);
        }
    }
    WebColumnToggledEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnToggledEventArgsDescriptionMetadata, 'WebColumnToggledEventArgsDescriptionMetadata');
    WebColumnToggledEventArgsDescriptionMetadata.a = null;
    return WebColumnToggledEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarBaseActionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridToolbarBaseActionDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridToolbarBaseActionDescriptionMetadata.a == null) {
                WebGridToolbarBaseActionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridToolbarBaseActionDescriptionMetadata.c(WebGridToolbarBaseActionDescriptionMetadata.a);
            }
            if (a.k(WebGridToolbarBaseActionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridToolbarBaseActionDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridToolbarBaseAction");
            a.item("__tagNameWC", "String:igc-grid-toolbar-base-action");
            a.item("__manageCollectionInMarkup", "Boolean");
            a.item("Name", "String");
            WebGridToolbarBaseActionDescriptionMetadata.e(a);
        }
        static d(a) {
            WebGridToolbarBaseActionDescriptionMetadata.b(a);
            a.ad("WebGridToolbarBaseAction", WebGridToolbarBaseActionDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__tagNameWCSubstitutable", "String:igc-grid-toolbar-advanced-filtering,igc-grid-toolbar-exporter,igc-grid-toolbar-hiding,igc-grid-toolbar-pinning");
        }
    }
    WebGridToolbarBaseActionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridToolbarBaseActionDescriptionMetadata, 'WebGridToolbarBaseActionDescriptionMetadata');
    WebGridToolbarBaseActionDescriptionMetadata.a = null;
    return WebGridToolbarBaseActionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseToolbarDirectiveDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebBaseToolbarDirectiveDescriptionMetadata extends Base {
        static b(a) {
            if (WebBaseToolbarDirectiveDescriptionMetadata.a == null) {
                WebBaseToolbarDirectiveDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebBaseToolbarDirectiveDescriptionMetadata.c(WebBaseToolbarDirectiveDescriptionMetadata.a);
            }
            if (a.k(WebBaseToolbarDirectiveDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebBaseToolbarDirectiveDescriptionMetadata.a);
            WebOverlaySettingsDescriptionMetadata.d(a);
            WebToggleViewCancelableEventArgsDescriptionMetadata.d(a);
            WebToggleViewEventArgsDescriptionMetadata.d(a);
            WebColumnToggledEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebGridToolbarBaseActionDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:BaseToolbarDirective");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("ColumnListHeight", "String");
            a.item("Title", "String");
            a.item("Prompt", "String");
            a.item("OverlaySettings", "ExportedType:WebOverlaySettings");
            a.item("Name", "String");
            a.item("OpeningRef", "EventRef::opening:customEvent");
            a.item("OpenedRef", "EventRef::opened:customEvent");
            a.item("ClosingRef", "EventRef::closing:customEvent");
            a.item("ClosedRef", "EventRef::closed:customEvent");
            a.item("ColumnToggleRef", "EventRef::columnToggle:customEvent");
        }
        static d(a) {
            WebBaseToolbarDirectiveDescriptionMetadata.b(a);
            a.ad("WebBaseToolbarDirective", WebBaseToolbarDirectiveDescriptionMetadata.a);
        }
    }
    WebBaseToolbarDirectiveDescriptionMetadata.$t = /*@__PURE__*/ markType(WebBaseToolbarDirectiveDescriptionMetadata, 'WebBaseToolbarDirectiveDescriptionMetadata');
    WebBaseToolbarDirectiveDescriptionMetadata.a = null;
    return WebBaseToolbarDirectiveDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseToolbarColumnActionsDirectiveDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebBaseToolbarColumnActionsDirectiveDescriptionMetadata extends Base {
        static b(a) {
            if (WebBaseToolbarColumnActionsDirectiveDescriptionMetadata.a == null) {
                WebBaseToolbarColumnActionsDirectiveDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebBaseToolbarColumnActionsDirectiveDescriptionMetadata.c(WebBaseToolbarColumnActionsDirectiveDescriptionMetadata.a);
            }
            if (a.k(WebBaseToolbarColumnActionsDirectiveDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebBaseToolbarColumnActionsDirectiveDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseToolbarDirectiveDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:BaseToolbarColumnActionsDirective");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("Name", "String");
        }
        static d(a) {
            WebBaseToolbarColumnActionsDirectiveDescriptionMetadata.b(a);
            a.ae("WebBaseToolbarColumnActionsDirective", () => new WebBaseToolbarColumnActionsDirectiveDescription());
            a.ad("WebBaseToolbarColumnActionsDirective", WebBaseToolbarColumnActionsDirectiveDescriptionMetadata.a);
        }
    }
    WebBaseToolbarColumnActionsDirectiveDescriptionMetadata.$t = /*@__PURE__*/ markType(WebBaseToolbarColumnActionsDirectiveDescriptionMetadata, 'WebBaseToolbarColumnActionsDirectiveDescriptionMetadata');
    WebBaseToolbarColumnActionsDirectiveDescriptionMetadata.a = null;
    return WebBaseToolbarColumnActionsDirectiveDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBaseToolbarColumnActionsDirectiveDescriptionModule = /*@__PURE__*/ (() => {
    class WebBaseToolbarColumnActionsDirectiveDescriptionModule extends Base {
        static register(a) {
            WebBaseToolbarColumnActionsDirectiveDescriptionMetadata.d(a);
        }
    }
    WebBaseToolbarColumnActionsDirectiveDescriptionModule.$t = /*@__PURE__*/ markType(WebBaseToolbarColumnActionsDirectiveDescriptionModule, 'WebBaseToolbarColumnActionsDirectiveDescriptionModule');
    return WebBaseToolbarColumnActionsDirectiveDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBooleanFilteringOperandDescription = /*@__PURE__*/ (() => {
    class WebBooleanFilteringOperandDescription extends WebFilteringOperandDescription {
        get_type() {
            return "WebBooleanFilteringOperand";
        }
        constructor() {
            super();
        }
    }
    WebBooleanFilteringOperandDescription.$t = /*@__PURE__*/ markType(WebBooleanFilteringOperandDescription, 'WebBooleanFilteringOperandDescription', WebFilteringOperandDescription.$);
    return WebBooleanFilteringOperandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebBooleanFilteringOperandDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebBooleanFilteringOperandDescriptionMetadata extends Base {
        static b(a) {
            if (WebBooleanFilteringOperandDescriptionMetadata.a == null) {
                WebBooleanFilteringOperandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebBooleanFilteringOperandDescriptionMetadata.c(WebBooleanFilteringOperandDescriptionMetadata.a);
            }
            if (a.k(WebBooleanFilteringOperandDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebBooleanFilteringOperandDescriptionMetadata.a);
        }
        static c(a) {
            WebFilteringOperandDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:BooleanFilteringOperand");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebBooleanFilteringOperandDescriptionMetadata.b(a);
            a.ae("WebBooleanFilteringOperand", () => new WebBooleanFilteringOperandDescription());
            a.ad("WebBooleanFilteringOperand", WebBooleanFilteringOperandDescriptionMetadata.a);
        }
    }
    WebBooleanFilteringOperandDescriptionMetadata.$t = /*@__PURE__*/ markType(WebBooleanFilteringOperandDescriptionMetadata, 'WebBooleanFilteringOperandDescriptionMetadata');
    WebBooleanFilteringOperandDescriptionMetadata.a = null;
    return WebBooleanFilteringOperandDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebButtonBaseDescription = /*@__PURE__*/ (() => {
    class WebButtonBaseDescription extends Description {
        get_type() {
            return "WebButtonBase";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.o = null;
            this.m = null;
            this.q = null;
            this.p = null;
            this.h = false;
            this.k = null;
            this.n = null;
            this.j = null;
        }
        get displayType() {
            return this.l;
        }
        set displayType(a) {
            this.l = a;
            this.g("DisplayType");
        }
        get href() {
            return this.o;
        }
        set href(a) {
            this.o = a;
            this.g("Href");
        }
        get download() {
            return this.m;
        }
        set download(a) {
            this.m = a;
            this.g("Download");
        }
        get target() {
            return this.q;
        }
        set target(a) {
            this.q = a;
            this.g("Target");
        }
        get rel() {
            return this.p;
        }
        set rel(a) {
            this.p = a;
            this.g("Rel");
        }
        get disabled() {
            return this.h;
        }
        set disabled(a) {
            this.h = a;
            this.g("Disabled");
        }
        get clickedRef() {
            return this.k;
        }
        set clickedRef(a) {
            this.k = a;
            this.g("ClickedRef");
        }
        get focusRef() {
            return this.n;
        }
        set focusRef(a) {
            this.n = a;
            this.g("FocusRef");
        }
        get blurRef() {
            return this.j;
        }
        set blurRef(a) {
            this.j = a;
            this.g("BlurRef");
        }
    }
    WebButtonBaseDescription.$t = /*@__PURE__*/ markType(WebButtonBaseDescription, 'WebButtonBaseDescription', Description.$);
    return WebButtonBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebButtonDescription = /*@__PURE__*/ (() => {
    class WebButtonDescription extends WebButtonBaseDescription {
        get_type() {
            return "WebButton";
        }
        constructor() {
            super();
            this.aa = null;
        }
        get variant() {
            return this.aa;
        }
        set variant(a) {
            this.aa = a;
            this.g("Variant");
        }
    }
    WebButtonDescription.$t = /*@__PURE__*/ markType(WebButtonDescription, 'WebButtonDescription', WebButtonBaseDescription.$);
    return WebButtonDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebButtonBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebButtonBaseDescriptionMetadata extends Base {
        static b(a) {
            if (WebButtonBaseDescriptionMetadata.a == null) {
                WebButtonBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebButtonBaseDescriptionMetadata.c(WebButtonBaseDescriptionMetadata.a);
            }
            if (a.k(WebButtonBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebButtonBaseDescriptionMetadata.a);
            VoidEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ButtonBase");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("DisplayType", "(wc:Type)ExportedType:string:ButtonBaseType");
            a.item("DisplayType@stringUnion", "WebComponents;React");
            a.item("DisplayType@names", "Button;Reset;Submit");
            a.item("Href", "String");
            a.item("Download", "String");
            a.item("Target", "ExportedType:string:ButtonBaseTarget");
            a.item("Target@stringUnion", "WebComponents;React");
            a.item("Target@names", "_blank;_parent;_self;_top");
            a.item("Rel", "String");
            a.item("Disabled", "Boolean");
            a.item("ClickedRef", "EventRef::clicked");
            a.item("FocusRef", "EventRef::focus");
            a.item("BlurRef", "EventRef::blur");
        }
        static d(a) {
            WebButtonBaseDescriptionMetadata.b(a);
            a.ad("WebButtonBase", WebButtonBaseDescriptionMetadata.a);
        }
    }
    WebButtonBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(WebButtonBaseDescriptionMetadata, 'WebButtonBaseDescriptionMetadata');
    WebButtonBaseDescriptionMetadata.a = null;
    return WebButtonBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebButtonDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebButtonDescriptionMetadata extends Base {
        static b(a) {
            if (WebButtonDescriptionMetadata.a == null) {
                WebButtonDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebButtonDescriptionMetadata.c(WebButtonDescriptionMetadata.a);
            }
            if (a.k(WebButtonDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebButtonDescriptionMetadata.a);
        }
        static c(a) {
            WebButtonBaseDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:Button");
            a.item("__tagNameWC", "String:igc-button");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Variant", "ExportedType:string:ButtonVariant");
            a.item("Variant@stringUnion", "WebComponents;React");
            a.item("Variant@names", "Flat;Contained;Outlined;Fab");
        }
        static d(a) {
            WebButtonDescriptionMetadata.b(a);
            a.ae("WebButton", () => new WebButtonDescription());
            a.ad("WebButton", WebButtonDescriptionMetadata.a);
        }
    }
    WebButtonDescriptionMetadata.$t = /*@__PURE__*/ markType(WebButtonDescriptionMetadata, 'WebButtonDescriptionMetadata');
    WebButtonDescriptionMetadata.a = null;
    return WebButtonDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebButtonBaseDescriptionModule = /*@__PURE__*/ (() => {
    class WebButtonBaseDescriptionModule extends Base {
        static register(a) {
        }
    }
    WebButtonBaseDescriptionModule.$t = /*@__PURE__*/ markType(WebButtonBaseDescriptionModule, 'WebButtonBaseDescriptionModule');
    return WebButtonBaseDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebButtonGroupDescription = /*@__PURE__*/ (() => {
    class WebButtonGroupDescription extends Description {
        get_type() {
            return "WebButtonGroup";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = false;
            this.l = null;
            this.o = null;
            this.h = null;
            this.n = null;
            this.m = null;
        }
        get disabled() {
            return this.j;
        }
        set disabled(a) {
            this.j = a;
            this.g("Disabled");
        }
        get alignment() {
            return this.l;
        }
        set alignment(a) {
            this.l = a;
            this.g("Alignment");
        }
        get selection() {
            return this.o;
        }
        set selection(a) {
            this.o = a;
            this.g("Selection");
        }
        get selectedItems() {
            return this.h;
        }
        set selectedItems(a) {
            this.h = a;
            this.g("SelectedItems");
        }
        get selectRef() {
            return this.n;
        }
        set selectRef(a) {
            this.n = a;
            this.g("SelectRef");
        }
        get deselectRef() {
            return this.m;
        }
        set deselectRef(a) {
            this.m = a;
            this.g("DeselectRef");
        }
    }
    WebButtonGroupDescription.$t = /*@__PURE__*/ markType(WebButtonGroupDescription, 'WebButtonGroupDescription', Description.$);
    return WebButtonGroupDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComponentValueChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class WebComponentValueChangedEventArgsDescription extends Description {
        get_type() {
            return "WebComponentValueChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
        }
        get detail() {
            return this.j;
        }
        set detail(a) {
            this.j = a;
            this.g("Detail");
        }
    }
    WebComponentValueChangedEventArgsDescription.$t = /*@__PURE__*/ markType(WebComponentValueChangedEventArgsDescription, 'WebComponentValueChangedEventArgsDescription', Description.$);
    WebComponentValueChangedEventArgsDescription.__marshalByValue = true;
    WebComponentValueChangedEventArgsDescription.__marshalByValueAlias = "ComponentValueChangedEventArgs";
    return WebComponentValueChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComponentValueChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebComponentValueChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebComponentValueChangedEventArgsDescriptionMetadata.a == null) {
                WebComponentValueChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebComponentValueChangedEventArgsDescriptionMetadata.c(WebComponentValueChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebComponentValueChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebComponentValueChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ComponentValueChangedEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "String");
        }
        static d(a) {
            WebComponentValueChangedEventArgsDescriptionMetadata.b(a);
            a.ae("WebComponentValueChangedEventArgs", () => new WebComponentValueChangedEventArgsDescription());
            a.ad("WebComponentValueChangedEventArgs", WebComponentValueChangedEventArgsDescriptionMetadata.a);
        }
    }
    WebComponentValueChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebComponentValueChangedEventArgsDescriptionMetadata, 'WebComponentValueChangedEventArgsDescriptionMetadata');
    WebComponentValueChangedEventArgsDescriptionMetadata.a = null;
    return WebComponentValueChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebButtonGroupDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebButtonGroupDescriptionMetadata extends Base {
        static b(a) {
            if (WebButtonGroupDescriptionMetadata.a == null) {
                WebButtonGroupDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebButtonGroupDescriptionMetadata.c(WebButtonGroupDescriptionMetadata.a);
            }
            if (a.k(WebButtonGroupDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebButtonGroupDescriptionMetadata.a);
            WebComponentValueChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ButtonGroup");
            a.item("__tagNameWC", "String:igc-button-group");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Disabled", "Boolean");
            a.item("Alignment", "ExportedType:string:ButtonGroupAlignment");
            a.item("Alignment@stringUnion", "WebComponents;React");
            a.item("Alignment@names", "Horizontal;Vertical");
            a.item("Selection", "ExportedType:string:ButtonGroupSelection");
            a.item("Selection@stringUnion", "WebComponents;React");
            a.item("Selection@names", "Single;SingleRequired;Multiple");
            a.item("SelectedItems", "Array:string");
            a.item("SelectRef", "EventRef::select");
            a.item("DeselectRef", "EventRef::deselect");
        }
        static d(a) {
            WebButtonGroupDescriptionMetadata.b(a);
            a.ae("WebButtonGroup", () => new WebButtonGroupDescription());
            a.ad("WebButtonGroup", WebButtonGroupDescriptionMetadata.a);
        }
    }
    WebButtonGroupDescriptionMetadata.$t = /*@__PURE__*/ markType(WebButtonGroupDescriptionMetadata, 'WebButtonGroupDescriptionMetadata');
    WebButtonGroupDescriptionMetadata.a = null;
    return WebButtonGroupDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebToggleButtonDescription = /*@__PURE__*/ (() => {
    class WebToggleButtonDescription extends Description {
        get_type() {
            return "WebToggleButton";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.i = false;
            this.h = false;
        }
        get value() {
            return this.l;
        }
        set value(a) {
            this.l = a;
            this.g("Value");
        }
        get selected() {
            return this.i;
        }
        set selected(a) {
            this.i = a;
            this.g("Selected");
        }
        get disabled() {
            return this.h;
        }
        set disabled(a) {
            this.h = a;
            this.g("Disabled");
        }
    }
    WebToggleButtonDescription.$t = /*@__PURE__*/ markType(WebToggleButtonDescription, 'WebToggleButtonDescription', Description.$);
    return WebToggleButtonDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebToggleButtonDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebToggleButtonDescriptionMetadata extends Base {
        static b(a) {
            if (WebToggleButtonDescriptionMetadata.a == null) {
                WebToggleButtonDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebToggleButtonDescriptionMetadata.c(WebToggleButtonDescriptionMetadata.a);
            }
            if (a.k(WebToggleButtonDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebToggleButtonDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ToggleButton");
            a.item("__tagNameWC", "String:igc-toggle-button");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Value", "String");
            a.item("Selected", "Boolean");
            a.item("Disabled", "Boolean");
        }
        static d(a) {
            WebToggleButtonDescriptionMetadata.b(a);
            a.ae("WebToggleButton", () => new WebToggleButtonDescription());
            a.ad("WebToggleButton", WebToggleButtonDescriptionMetadata.a);
        }
    }
    WebToggleButtonDescriptionMetadata.$t = /*@__PURE__*/ markType(WebToggleButtonDescriptionMetadata, 'WebToggleButtonDescriptionMetadata');
    WebToggleButtonDescriptionMetadata.a = null;
    return WebToggleButtonDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebToggleButtonDescriptionModule = /*@__PURE__*/ (() => {
    class WebToggleButtonDescriptionModule extends Base {
        static register(a) {
            WebToggleButtonDescriptionMetadata.d(a);
        }
    }
    WebToggleButtonDescriptionModule.$t = /*@__PURE__*/ markType(WebToggleButtonDescriptionModule, 'WebToggleButtonDescriptionModule');
    return WebToggleButtonDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebButtonGroupDescriptionModule = /*@__PURE__*/ (() => {
    class WebButtonGroupDescriptionModule extends Base {
        static register(a) {
            WebToggleButtonDescriptionModule.register(a);
            WebButtonGroupDescriptionMetadata.d(a);
        }
    }
    WebButtonGroupDescriptionModule.$t = /*@__PURE__*/ markType(WebButtonGroupDescriptionModule, 'WebButtonGroupDescriptionModule');
    return WebButtonGroupDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebButtonDescriptionModule = /*@__PURE__*/ (() => {
    class WebButtonDescriptionModule extends Base {
        static register(a) {
            WebButtonBaseDescriptionModule.register(a);
            WebButtonDescriptionMetadata.d(a);
        }
    }
    WebButtonDescriptionModule.$t = /*@__PURE__*/ markType(WebButtonDescriptionModule, 'WebButtonDescriptionModule');
    return WebButtonDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCalendarBaseDescription = /*@__PURE__*/ (() => {
    class WebCalendarBaseDescription extends Description {
        get_type() {
            return "WebCalendarBase";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.o = null;
            this.l = false;
            this.p = null;
            this.n = null;
            this.i = null;
            this.h = null;
        }
        get selection() {
            return this.o;
        }
        set selection(a) {
            this.o = a;
            this.g("Selection");
        }
        get showWeekNumbers() {
            return this.l;
        }
        set showWeekNumbers(a) {
            this.l = a;
            this.g("ShowWeekNumbers");
        }
        get weekStart() {
            return this.p;
        }
        set weekStart(a) {
            this.p = a;
            this.g("WeekStart");
        }
        get locale() {
            return this.n;
        }
        set locale(a) {
            this.n = a;
            this.g("Locale");
        }
        get specialDates() {
            return this.i;
        }
        set specialDates(a) {
            this.i = a;
            this.g("SpecialDates");
        }
        get disabledDates() {
            return this.h;
        }
        set disabledDates(a) {
            this.h = a;
            this.g("DisabledDates");
        }
    }
    WebCalendarBaseDescription.$t = /*@__PURE__*/ markType(WebCalendarBaseDescription, 'WebCalendarBaseDescription', Description.$);
    return WebCalendarBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCalendarDescription = /*@__PURE__*/ (() => {
    class WebCalendarDescription extends WebCalendarBaseDescription {
        get_type() {
            return "WebCalendar";
        }
        constructor() {
            super();
            this.af = new Date();
            this.u = null;
            this.ae = new Date();
            this.ab = false;
            this.aa = false;
            this.am = null;
            this.an = null;
            this.ai = 0;
            this.ak = null;
            this.w = null;
            this.y = null;
            this.al = null;
        }
        get value() {
            return this.af;
        }
        set value(a) {
            this.af = a;
            this.g("Value");
        }
        get values() {
            return this.u;
        }
        set values(a) {
            this.u = a;
            this.g("Values");
        }
        get activeDate() {
            return this.ae;
        }
        set activeDate(a) {
            this.ae = a;
            this.g("ActiveDate");
        }
        get hideOutsideDays() {
            return this.ab;
        }
        set hideOutsideDays(a) {
            this.ab = a;
            this.g("HideOutsideDays");
        }
        get hideHeader() {
            return this.aa;
        }
        set hideHeader(a) {
            this.aa = a;
            this.g("HideHeader");
        }
        get headerOrientation() {
            return this.am;
        }
        set headerOrientation(a) {
            this.am = a;
            this.g("HeaderOrientation");
        }
        get orientation() {
            return this.an;
        }
        set orientation(a) {
            this.an = a;
            this.g("Orientation");
        }
        get visibleMonths() {
            return this.ai;
        }
        set visibleMonths(a) {
            this.ai = a;
            this.g("VisibleMonths");
        }
        get activeView() {
            return this.ak;
        }
        set activeView(a) {
            this.ak = a;
            this.g("ActiveView");
        }
        get formatOptions() {
            return this.w;
        }
        set formatOptions(a) {
            this.w = a;
            this.g("FormatOptions");
        }
        get resourceStrings() {
            return this.y;
        }
        set resourceStrings(a) {
            this.y = a;
            this.g("ResourceStrings");
        }
        get changeRef() {
            return this.al;
        }
        set changeRef(a) {
            this.al = a;
            this.g("ChangeRef");
        }
    }
    WebCalendarDescription.$t = /*@__PURE__*/ markType(WebCalendarDescription, 'WebCalendarDescription', WebCalendarBaseDescription.$);
    return WebCalendarDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCalendarResourceStringsDescription = /*@__PURE__*/ (() => {
    class WebCalendarResourceStringsDescription extends Description {
        get_type() {
            return "WebCalendarResourceStrings";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.s = null;
            this.u = null;
            this.q = null;
            this.t = null;
            this.r = null;
            this.v = null;
            this.j = null;
            this.n = null;
            this.k = null;
            this.o = null;
            this.l = null;
            this.p = null;
            this.m = null;
            this.w = null;
        }
        get selectMonth() {
            return this.s;
        }
        set selectMonth(a) {
            this.s = a;
            this.g("SelectMonth");
        }
        get selectYear() {
            return this.u;
        }
        set selectYear(a) {
            this.u = a;
            this.g("SelectYear");
        }
        get selectDate() {
            return this.q;
        }
        set selectDate(a) {
            this.q = a;
            this.g("SelectDate");
        }
        get selectRange() {
            return this.t;
        }
        set selectRange(a) {
            this.t = a;
            this.g("SelectRange");
        }
        get selectedDate() {
            return this.r;
        }
        set selectedDate(a) {
            this.r = a;
            this.g("SelectedDate");
        }
        get startDate() {
            return this.v;
        }
        set startDate(a) {
            this.v = a;
            this.g("StartDate");
        }
        get endDate() {
            return this.j;
        }
        set endDate(a) {
            this.j = a;
            this.g("EndDate");
        }
        get previousMonth() {
            return this.n;
        }
        set previousMonth(a) {
            this.n = a;
            this.g("PreviousMonth");
        }
        get nextMonth() {
            return this.k;
        }
        set nextMonth(a) {
            this.k = a;
            this.g("NextMonth");
        }
        get previousYear() {
            return this.o;
        }
        set previousYear(a) {
            this.o = a;
            this.g("PreviousYear");
        }
        get nextYear() {
            return this.l;
        }
        set nextYear(a) {
            this.l = a;
            this.g("NextYear");
        }
        get previousYears() {
            return this.p;
        }
        set previousYears(a) {
            this.p = a;
            this.g("PreviousYears");
        }
        get nextYears() {
            return this.m;
        }
        set nextYears(a) {
            this.m = a;
            this.g("NextYears");
        }
        get weekLabel() {
            return this.w;
        }
        set weekLabel(a) {
            this.w = a;
            this.g("WeekLabel");
        }
    }
    WebCalendarResourceStringsDescription.$t = /*@__PURE__*/ markType(WebCalendarResourceStringsDescription, 'WebCalendarResourceStringsDescription', Description.$);
    WebCalendarResourceStringsDescription.__marshalByValue = true;
    WebCalendarResourceStringsDescription.__marshalByValueAlias = "CalendarResourceStrings";
    return WebCalendarResourceStringsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCalendarResourceStringsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCalendarResourceStringsDescriptionMetadata extends Base {
        static b(a) {
            if (WebCalendarResourceStringsDescriptionMetadata.a == null) {
                WebCalendarResourceStringsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCalendarResourceStringsDescriptionMetadata.c(WebCalendarResourceStringsDescriptionMetadata.a);
            }
            if (a.k(WebCalendarResourceStringsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCalendarResourceStringsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CalendarResourceStrings");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("SelectMonth", "String");
            a.item("SelectYear", "String");
            a.item("SelectDate", "String");
            a.item("SelectRange", "String");
            a.item("SelectedDate", "String");
            a.item("StartDate", "String");
            a.item("EndDate", "String");
            a.item("PreviousMonth", "String");
            a.item("NextMonth", "String");
            a.item("PreviousYear", "String");
            a.item("NextYear", "String");
            a.item("PreviousYears", "String");
            a.item("NextYears", "String");
            a.item("WeekLabel", "String");
        }
        static d(a) {
            WebCalendarResourceStringsDescriptionMetadata.b(a);
            a.ae("WebCalendarResourceStrings", () => new WebCalendarResourceStringsDescription());
            a.ad("WebCalendarResourceStrings", WebCalendarResourceStringsDescriptionMetadata.a);
        }
    }
    WebCalendarResourceStringsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCalendarResourceStringsDescriptionMetadata, 'WebCalendarResourceStringsDescriptionMetadata');
    WebCalendarResourceStringsDescriptionMetadata.a = null;
    return WebCalendarResourceStringsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComponentDataValueChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class WebComponentDataValueChangedEventArgsDescription extends Description {
        get_type() {
            return "WebComponentDataValueChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebComponentDataValueChangedEventArgsDescription.$t = /*@__PURE__*/ markType(WebComponentDataValueChangedEventArgsDescription, 'WebComponentDataValueChangedEventArgsDescription', Description.$);
    return WebComponentDataValueChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComponentDataValueChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebComponentDataValueChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebComponentDataValueChangedEventArgsDescriptionMetadata.a == null) {
                WebComponentDataValueChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebComponentDataValueChangedEventArgsDescriptionMetadata.c(WebComponentDataValueChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebComponentDataValueChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebComponentDataValueChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ComponentDataValueChangedEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Detail", "Unknown");
        }
        static d(a) {
            WebComponentDataValueChangedEventArgsDescriptionMetadata.b(a);
            a.ae("WebComponentDataValueChangedEventArgs", () => new WebComponentDataValueChangedEventArgsDescription());
            a.ad("WebComponentDataValueChangedEventArgs", WebComponentDataValueChangedEventArgsDescriptionMetadata.a);
        }
    }
    WebComponentDataValueChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebComponentDataValueChangedEventArgsDescriptionMetadata, 'WebComponentDataValueChangedEventArgsDescriptionMetadata');
    WebComponentDataValueChangedEventArgsDescriptionMetadata.a = null;
    return WebComponentDataValueChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCalendarBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCalendarBaseDescriptionMetadata extends Base {
        static b(a) {
            if (WebCalendarBaseDescriptionMetadata.a == null) {
                WebCalendarBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCalendarBaseDescriptionMetadata.c(WebCalendarBaseDescriptionMetadata.a);
            }
            if (a.k(WebCalendarBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCalendarBaseDescriptionMetadata.a);
            DateRangeDescriptorDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CalendarBase");
            a.item("__tagNameWC", "String:igc-calendar-base");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Selection", "ExportedType:string:CalendarBaseSelection");
            a.item("Selection@stringUnion", "WebComponents;React");
            a.item("Selection@names", "Single;Multiple;Range");
            a.item("ShowWeekNumbers", "Boolean");
            a.item("WeekStart", "ExportedType:string:WeekDays");
            a.item("WeekStart@stringUnion", "WebComponents;React");
            a.item("WeekStart@names", "Sunday;Monday;Tuesday;Wednesday;Thursday;Friday;Saturday");
            a.item("Locale", "String");
            a.item("SpecialDates", "Array:DateRangeDescriptorDescription:IDateRangeDescriptor");
            a.item("DisabledDates", "Array:DateRangeDescriptorDescription:IDateRangeDescriptor");
        }
        static d(a) {
            WebCalendarBaseDescriptionMetadata.b(a);
            a.ae("WebCalendarBase", () => new WebCalendarBaseDescription());
            a.ad("WebCalendarBase", WebCalendarBaseDescriptionMetadata.a);
        }
    }
    WebCalendarBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCalendarBaseDescriptionMetadata, 'WebCalendarBaseDescriptionMetadata');
    WebCalendarBaseDescriptionMetadata.a = null;
    return WebCalendarBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCalendarDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCalendarDescriptionMetadata extends Base {
        static b(a) {
            if (WebCalendarDescriptionMetadata.a == null) {
                WebCalendarDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCalendarDescriptionMetadata.c(WebCalendarDescriptionMetadata.a);
            }
            if (a.k(WebCalendarDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCalendarDescriptionMetadata.a);
            CalendarFormatOptionsDescriptionMetadata.d(a);
            WebCalendarResourceStringsDescriptionMetadata.d(a);
            WebComponentDataValueChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebCalendarBaseDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:Calendar");
            a.item("__tagNameWC", "String:igc-calendar");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Value", "Date");
            a.item("Values", "Array:Date");
            a.item("ActiveDate", "Date");
            a.item("HideOutsideDays", "Boolean");
            a.item("HideHeader", "Boolean");
            a.item("HeaderOrientation", "ExportedType:string:CalendarHeaderOrientation");
            a.item("HeaderOrientation@stringUnion", "WebComponents;React");
            a.item("HeaderOrientation@names", "Horizontal;Vertical");
            a.item("Orientation", "ExportedType:string:CalendarOrientation");
            a.item("Orientation@stringUnion", "WebComponents;React");
            a.item("Orientation@names", "Horizontal;Vertical");
            a.item("VisibleMonths", "Number:double");
            a.item("ActiveView", "ExportedType:string:CalendarActiveView");
            a.item("ActiveView@stringUnion", "WebComponents;React");
            a.item("ActiveView@names", "Days;Months;Years");
            a.item("FormatOptions", "ExportedType:CalendarFormatOptions");
            a.item("ResourceStrings", "ExportedType:WebCalendarResourceStrings");
            a.item("ChangeRef", "EventRef::change");
        }
        static d(a) {
            WebCalendarDescriptionMetadata.b(a);
            a.ae("WebCalendar", () => new WebCalendarDescription());
            a.ad("WebCalendar", WebCalendarDescriptionMetadata.a);
        }
    }
    WebCalendarDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCalendarDescriptionMetadata, 'WebCalendarDescriptionMetadata');
    WebCalendarDescriptionMetadata.a = null;
    return WebCalendarDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCalendarBaseDescriptionModule = /*@__PURE__*/ (() => {
    class WebCalendarBaseDescriptionModule extends Base {
        static register(a) {
            WebCalendarBaseDescriptionMetadata.d(a);
        }
    }
    WebCalendarBaseDescriptionModule.$t = /*@__PURE__*/ markType(WebCalendarBaseDescriptionModule, 'WebCalendarBaseDescriptionModule');
    return WebCalendarBaseDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCalendarDateEventArgsDescription = /*@__PURE__*/ (() => {
    class WebCalendarDateEventArgsDescription extends Description {
        get_type() {
            return "WebCalendarDateEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebCalendarDateEventArgsDescription.$t = /*@__PURE__*/ markType(WebCalendarDateEventArgsDescription, 'WebCalendarDateEventArgsDescription', Description.$);
    return WebCalendarDateEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCalendarDateEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCalendarDateEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebCalendarDateEventArgsDescriptionMetadata.a == null) {
                WebCalendarDateEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCalendarDateEventArgsDescriptionMetadata.c(WebCalendarDateEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebCalendarDateEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCalendarDateEventArgsDescriptionMetadata.a);
            CalendarDateDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CalendarDateEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Detail", "ExportedType:CalendarDate");
        }
        static d(a) {
            WebCalendarDateEventArgsDescriptionMetadata.b(a);
            a.ae("WebCalendarDateEventArgs", () => new WebCalendarDateEventArgsDescription());
            a.ad("WebCalendarDateEventArgs", WebCalendarDateEventArgsDescriptionMetadata.a);
        }
    }
    WebCalendarDateEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCalendarDateEventArgsDescriptionMetadata, 'WebCalendarDateEventArgsDescriptionMetadata');
    WebCalendarDateEventArgsDescriptionMetadata.a = null;
    return WebCalendarDateEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCalendarDescriptionModule = /*@__PURE__*/ (() => {
    class WebCalendarDescriptionModule extends Base {
        static register(a) {
            WebCalendarBaseDescriptionModule.register(a);
            WebComponentDataValueChangedEventArgsDescriptionMetadata.d(a);
            WebCalendarDescriptionMetadata.d(a);
        }
    }
    WebCalendarDescriptionModule.$t = /*@__PURE__*/ markType(WebCalendarDescriptionModule, 'WebCalendarDescriptionModule');
    return WebCalendarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCancelableEventArgsDescription = /*@__PURE__*/ (() => {
    class WebCancelableEventArgsDescription extends Description {
        get_type() {
            return "WebCancelableEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebCancelableEventArgsDescription.$t = /*@__PURE__*/ markType(WebCancelableEventArgsDescription, 'WebCancelableEventArgsDescription', Description.$);
    WebCancelableEventArgsDescription.__marshalByValue = true;
    WebCancelableEventArgsDescription.__marshalByValueAlias = "CancelableEventArgs";
    return WebCancelableEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCancelableBrowserEventArgsDescription = /*@__PURE__*/ (() => {
    class WebCancelableBrowserEventArgsDescription extends WebCancelableEventArgsDescription {
        get_type() {
            return "WebCancelableBrowserEventArgs";
        }
        constructor() {
            super();
        }
    }
    WebCancelableBrowserEventArgsDescription.$t = /*@__PURE__*/ markType(WebCancelableBrowserEventArgsDescription, 'WebCancelableBrowserEventArgsDescription', WebCancelableEventArgsDescription.$);
    WebCancelableBrowserEventArgsDescription.__marshalByValue1 = true;
    WebCancelableBrowserEventArgsDescription.__marshalByValueAlias1 = "CancelableBrowserEventArgs";
    return WebCancelableBrowserEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCancelableEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebCancelableEventArgsDetailDescription extends Description {
        get_type() {
            return "WebCancelableEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = false;
        }
        get cancel() {
            return this.i;
        }
        set cancel(a) {
            this.i = a;
            this.g("Cancel");
        }
    }
    WebCancelableEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebCancelableEventArgsDetailDescription, 'WebCancelableEventArgsDetailDescription', Description.$);
    WebCancelableEventArgsDetailDescription.__marshalByValue = true;
    WebCancelableEventArgsDetailDescription.__marshalByValueAlias = "CancelableEventArgsDetail";
    return WebCancelableEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCancelableEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCancelableEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebCancelableEventArgsDetailDescriptionMetadata.a == null) {
                WebCancelableEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCancelableEventArgsDetailDescriptionMetadata.c(WebCancelableEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebCancelableEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCancelableEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CancelableEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebCancelableEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebCancelableEventArgsDetail", () => new WebCancelableEventArgsDetailDescription());
            a.ad("WebCancelableEventArgsDetail", WebCancelableEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebCancelableEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCancelableEventArgsDetailDescriptionMetadata, 'WebCancelableEventArgsDetailDescriptionMetadata');
    WebCancelableEventArgsDetailDescriptionMetadata.a = null;
    return WebCancelableEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCancelableEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCancelableEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebCancelableEventArgsDescriptionMetadata.a == null) {
                WebCancelableEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCancelableEventArgsDescriptionMetadata.c(WebCancelableEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebCancelableEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCancelableEventArgsDescriptionMetadata.a);
            WebCancelableEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CancelableEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebCancelableEventArgsDetail");
        }
        static d(a) {
            WebCancelableEventArgsDescriptionMetadata.b(a);
            a.ae("WebCancelableEventArgs", () => new WebCancelableEventArgsDescription());
            a.ad("WebCancelableEventArgs", WebCancelableEventArgsDescriptionMetadata.a);
        }
    }
    WebCancelableEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCancelableEventArgsDescriptionMetadata, 'WebCancelableEventArgsDescriptionMetadata');
    WebCancelableEventArgsDescriptionMetadata.a = null;
    return WebCancelableEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCancelableBrowserEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCancelableBrowserEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebCancelableBrowserEventArgsDescriptionMetadata.a == null) {
                WebCancelableBrowserEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCancelableBrowserEventArgsDescriptionMetadata.c(WebCancelableBrowserEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebCancelableBrowserEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCancelableBrowserEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            WebCancelableEventArgsDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:CancelableBrowserEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebCancelableBrowserEventArgsDescriptionMetadata.b(a);
            a.ae("WebCancelableBrowserEventArgs", () => new WebCancelableBrowserEventArgsDescription());
            a.ad("WebCancelableBrowserEventArgs", WebCancelableBrowserEventArgsDescriptionMetadata.a);
        }
    }
    WebCancelableBrowserEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCancelableBrowserEventArgsDescriptionMetadata, 'WebCancelableBrowserEventArgsDescriptionMetadata');
    WebCancelableBrowserEventArgsDescriptionMetadata.a = null;
    return WebCancelableBrowserEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCancelableBrowserEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebCancelableBrowserEventArgsDetailDescription extends Description {
        get_type() {
            return "WebCancelableBrowserEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebCancelableBrowserEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebCancelableBrowserEventArgsDetailDescription, 'WebCancelableBrowserEventArgsDetailDescription', Description.$);
    WebCancelableBrowserEventArgsDetailDescription.__marshalByValue = true;
    WebCancelableBrowserEventArgsDetailDescription.__marshalByValueAlias = "CancelableBrowserEventArgsDetail";
    return WebCancelableBrowserEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCancelableBrowserEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCancelableBrowserEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebCancelableBrowserEventArgsDetailDescriptionMetadata.a == null) {
                WebCancelableBrowserEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCancelableBrowserEventArgsDetailDescriptionMetadata.c(WebCancelableBrowserEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebCancelableBrowserEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCancelableBrowserEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CancelableBrowserEventArgsDetail");
            a.item("__marshalByValue", "Boolean");
        }
        static d(a) {
            WebCancelableBrowserEventArgsDetailDescriptionMetadata.b(a);
            a.ad("WebCancelableBrowserEventArgsDetail", WebCancelableBrowserEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebCancelableBrowserEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCancelableBrowserEventArgsDetailDescriptionMetadata, 'WebCancelableBrowserEventArgsDetailDescriptionMetadata');
    WebCancelableBrowserEventArgsDetailDescriptionMetadata.a = null;
    return WebCancelableBrowserEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardDescription = /*@__PURE__*/ (() => {
    class WebCardDescription extends Description {
        get_type() {
            return "WebCard";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
        }
        get elevated() {
            return this.h;
        }
        set elevated(a) {
            this.h = a;
            this.g("Elevated");
        }
    }
    WebCardDescription.$t = /*@__PURE__*/ markType(WebCardDescription, 'WebCardDescription', Description.$);
    return WebCardDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCardDescriptionMetadata extends Base {
        static b(a) {
            if (WebCardDescriptionMetadata.a == null) {
                WebCardDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCardDescriptionMetadata.c(WebCardDescriptionMetadata.a);
            }
            if (a.k(WebCardDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCardDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Card");
            a.item("__tagNameWC", "String:igc-card");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Elevated", "Boolean");
        }
        static d(a) {
            WebCardDescriptionMetadata.b(a);
            a.ae("WebCard", () => new WebCardDescription());
            a.ad("WebCard", WebCardDescriptionMetadata.a);
        }
    }
    WebCardDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCardDescriptionMetadata, 'WebCardDescriptionMetadata');
    WebCardDescriptionMetadata.a = null;
    return WebCardDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardActionsDescription = /*@__PURE__*/ (() => {
    class WebCardActionsDescription extends Description {
        get_type() {
            return "WebCardActions";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get orientation() {
            return this.h;
        }
        set orientation(a) {
            this.h = a;
            this.g("Orientation");
        }
    }
    WebCardActionsDescription.$t = /*@__PURE__*/ markType(WebCardActionsDescription, 'WebCardActionsDescription', Description.$);
    return WebCardActionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardActionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCardActionsDescriptionMetadata extends Base {
        static b(a) {
            if (WebCardActionsDescriptionMetadata.a == null) {
                WebCardActionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCardActionsDescriptionMetadata.c(WebCardActionsDescriptionMetadata.a);
            }
            if (a.k(WebCardActionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCardActionsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CardActions");
            a.item("__tagNameWC", "String:igc-card-actions");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Orientation", "ExportedType:string:CardActionsOrientation");
            a.item("Orientation@stringUnion", "WebComponents;React");
            a.item("Orientation@names", "Horizontal;Vertical");
        }
        static d(a) {
            WebCardActionsDescriptionMetadata.b(a);
            a.ae("WebCardActions", () => new WebCardActionsDescription());
            a.ad("WebCardActions", WebCardActionsDescriptionMetadata.a);
        }
    }
    WebCardActionsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCardActionsDescriptionMetadata, 'WebCardActionsDescriptionMetadata');
    WebCardActionsDescriptionMetadata.a = null;
    return WebCardActionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardActionsDescriptionModule = /*@__PURE__*/ (() => {
    class WebCardActionsDescriptionModule extends Base {
        static register(a) {
            WebCardActionsDescriptionMetadata.d(a);
        }
    }
    WebCardActionsDescriptionModule.$t = /*@__PURE__*/ markType(WebCardActionsDescriptionModule, 'WebCardActionsDescriptionModule');
    return WebCardActionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardContentDescription = /*@__PURE__*/ (() => {
    class WebCardContentDescription extends Description {
        get_type() {
            return "WebCardContent";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebCardContentDescription.$t = /*@__PURE__*/ markType(WebCardContentDescription, 'WebCardContentDescription', Description.$);
    return WebCardContentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardContentDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCardContentDescriptionMetadata extends Base {
        static b(a) {
            if (WebCardContentDescriptionMetadata.a == null) {
                WebCardContentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCardContentDescriptionMetadata.c(WebCardContentDescriptionMetadata.a);
            }
            if (a.k(WebCardContentDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCardContentDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CardContent");
            a.item("__tagNameWC", "String:igc-card-content");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebCardContentDescriptionMetadata.b(a);
            a.ae("WebCardContent", () => new WebCardContentDescription());
            a.ad("WebCardContent", WebCardContentDescriptionMetadata.a);
        }
    }
    WebCardContentDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCardContentDescriptionMetadata, 'WebCardContentDescriptionMetadata');
    WebCardContentDescriptionMetadata.a = null;
    return WebCardContentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardContentDescriptionModule = /*@__PURE__*/ (() => {
    class WebCardContentDescriptionModule extends Base {
        static register(a) {
            WebCardContentDescriptionMetadata.d(a);
        }
    }
    WebCardContentDescriptionModule.$t = /*@__PURE__*/ markType(WebCardContentDescriptionModule, 'WebCardContentDescriptionModule');
    return WebCardContentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardHeaderDescription = /*@__PURE__*/ (() => {
    class WebCardHeaderDescription extends Description {
        get_type() {
            return "WebCardHeader";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebCardHeaderDescription.$t = /*@__PURE__*/ markType(WebCardHeaderDescription, 'WebCardHeaderDescription', Description.$);
    return WebCardHeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardHeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCardHeaderDescriptionMetadata extends Base {
        static b(a) {
            if (WebCardHeaderDescriptionMetadata.a == null) {
                WebCardHeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCardHeaderDescriptionMetadata.c(WebCardHeaderDescriptionMetadata.a);
            }
            if (a.k(WebCardHeaderDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCardHeaderDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CardHeader");
            a.item("__tagNameWC", "String:igc-card-header");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebCardHeaderDescriptionMetadata.b(a);
            a.ae("WebCardHeader", () => new WebCardHeaderDescription());
            a.ad("WebCardHeader", WebCardHeaderDescriptionMetadata.a);
        }
    }
    WebCardHeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCardHeaderDescriptionMetadata, 'WebCardHeaderDescriptionMetadata');
    WebCardHeaderDescriptionMetadata.a = null;
    return WebCardHeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardHeaderDescriptionModule = /*@__PURE__*/ (() => {
    class WebCardHeaderDescriptionModule extends Base {
        static register(a) {
            WebCardHeaderDescriptionMetadata.d(a);
        }
    }
    WebCardHeaderDescriptionModule.$t = /*@__PURE__*/ markType(WebCardHeaderDescriptionModule, 'WebCardHeaderDescriptionModule');
    return WebCardHeaderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardMediaDescription = /*@__PURE__*/ (() => {
    class WebCardMediaDescription extends Description {
        get_type() {
            return "WebCardMedia";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebCardMediaDescription.$t = /*@__PURE__*/ markType(WebCardMediaDescription, 'WebCardMediaDescription', Description.$);
    return WebCardMediaDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardMediaDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCardMediaDescriptionMetadata extends Base {
        static b(a) {
            if (WebCardMediaDescriptionMetadata.a == null) {
                WebCardMediaDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCardMediaDescriptionMetadata.c(WebCardMediaDescriptionMetadata.a);
            }
            if (a.k(WebCardMediaDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCardMediaDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CardMedia");
            a.item("__tagNameWC", "String:igc-card-media");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebCardMediaDescriptionMetadata.b(a);
            a.ae("WebCardMedia", () => new WebCardMediaDescription());
            a.ad("WebCardMedia", WebCardMediaDescriptionMetadata.a);
        }
    }
    WebCardMediaDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCardMediaDescriptionMetadata, 'WebCardMediaDescriptionMetadata');
    WebCardMediaDescriptionMetadata.a = null;
    return WebCardMediaDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardMediaDescriptionModule = /*@__PURE__*/ (() => {
    class WebCardMediaDescriptionModule extends Base {
        static register(a) {
            WebCardMediaDescriptionMetadata.d(a);
        }
    }
    WebCardMediaDescriptionModule.$t = /*@__PURE__*/ markType(WebCardMediaDescriptionModule, 'WebCardMediaDescriptionModule');
    return WebCardMediaDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCardDescriptionModule = /*@__PURE__*/ (() => {
    class WebCardDescriptionModule extends Base {
        static register(a) {
            WebCardDescriptionMetadata.d(a);
        }
    }
    WebCardDescriptionModule.$t = /*@__PURE__*/ markType(WebCardDescriptionModule, 'WebCardDescriptionModule');
    return WebCardDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCellPositionDescription = /*@__PURE__*/ (() => {
    class WebCellPositionDescription extends Description {
        get_type() {
            return "WebCellPosition";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = 0;
            this.i = 0;
        }
        get rowIndex() {
            return this.h;
        }
        set rowIndex(a) {
            this.h = a;
            this.g("RowIndex");
        }
        get visibleColumnIndex() {
            return this.i;
        }
        set visibleColumnIndex(a) {
            this.i = a;
            this.g("VisibleColumnIndex");
        }
    }
    WebCellPositionDescription.$t = /*@__PURE__*/ markType(WebCellPositionDescription, 'WebCellPositionDescription', Description.$);
    return WebCellPositionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCellPositionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCellPositionDescriptionMetadata extends Base {
        static b(a) {
            if (WebCellPositionDescriptionMetadata.a == null) {
                WebCellPositionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCellPositionDescriptionMetadata.c(WebCellPositionDescriptionMetadata.a);
            }
            if (a.k(WebCellPositionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCellPositionDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CellPosition");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("RowIndex", "Number:double");
            a.item("VisibleColumnIndex", "Number:double");
        }
        static d(a) {
            WebCellPositionDescriptionMetadata.b(a);
            a.ae("WebCellPosition", () => new WebCellPositionDescription());
            a.ad("WebCellPosition", WebCellPositionDescriptionMetadata.a);
        }
    }
    WebCellPositionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCellPositionDescriptionMetadata, 'WebCellPositionDescriptionMetadata');
    WebCellPositionDescriptionMetadata.a = null;
    return WebCellPositionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCheckboxBaseDescription = /*@__PURE__*/ (() => {
    class WebCheckboxBaseDescription extends Description {
        get_type() {
            return "WebCheckboxBase";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.u = null;
            this.h = false;
            this.s = null;
            this.i = false;
            this.k = false;
            this.t = null;
            this.j = false;
            this.q = null;
            this.r = null;
            this.p = null;
        }
        get value() {
            return this.u;
        }
        set value(a) {
            this.u = a;
            this.g("Value");
        }
        get checked() {
            return this.h;
        }
        set checked(a) {
            this.h = a;
            this.g("Checked");
        }
        get labelPosition() {
            return this.s;
        }
        set labelPosition(a) {
            this.s = a;
            this.g("LabelPosition");
        }
        get disabled() {
            return this.i;
        }
        set disabled(a) {
            this.i = a;
            this.g("Disabled");
        }
        get required() {
            return this.k;
        }
        set required(a) {
            this.k = a;
            this.g("Required");
        }
        get name() {
            return this.t;
        }
        set name(a) {
            this.t = a;
            this.g("Name");
        }
        get invalid() {
            return this.j;
        }
        set invalid(a) {
            this.j = a;
            this.g("Invalid");
        }
        get changeRef() {
            return this.q;
        }
        set changeRef(a) {
            this.q = a;
            this.g("ChangeRef");
        }
        get focusRef() {
            return this.r;
        }
        set focusRef(a) {
            this.r = a;
            this.g("FocusRef");
        }
        get blurRef() {
            return this.p;
        }
        set blurRef(a) {
            this.p = a;
            this.g("BlurRef");
        }
    }
    WebCheckboxBaseDescription.$t = /*@__PURE__*/ markType(WebCheckboxBaseDescription, 'WebCheckboxBaseDescription', Description.$);
    return WebCheckboxBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCheckboxDescription = /*@__PURE__*/ (() => {
    class WebCheckboxDescription extends WebCheckboxBaseDescription {
        get_type() {
            return "WebCheckbox";
        }
        constructor() {
            super();
            this.ac = false;
        }
        get indeterminate() {
            return this.ac;
        }
        set indeterminate(a) {
            this.ac = a;
            this.g("Indeterminate");
        }
    }
    WebCheckboxDescription.$t = /*@__PURE__*/ markType(WebCheckboxDescription, 'WebCheckboxDescription', WebCheckboxBaseDescription.$);
    return WebCheckboxDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCheckboxChangeEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebCheckboxChangeEventArgsDetailDescription extends Description {
        get_type() {
            return "WebCheckboxChangeEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = false;
            this.l = null;
        }
        get checked() {
            return this.i;
        }
        set checked(a) {
            this.i = a;
            this.g("Checked");
        }
        get value() {
            return this.l;
        }
        set value(a) {
            this.l = a;
            this.g("Value");
        }
    }
    WebCheckboxChangeEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebCheckboxChangeEventArgsDetailDescription, 'WebCheckboxChangeEventArgsDetailDescription', Description.$);
    WebCheckboxChangeEventArgsDetailDescription.__marshalByValue = true;
    WebCheckboxChangeEventArgsDetailDescription.__marshalByValueAlias = "CheckboxChangeEventArgsDetail";
    return WebCheckboxChangeEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCheckboxChangeEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCheckboxChangeEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebCheckboxChangeEventArgsDetailDescriptionMetadata.a == null) {
                WebCheckboxChangeEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCheckboxChangeEventArgsDetailDescriptionMetadata.c(WebCheckboxChangeEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebCheckboxChangeEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCheckboxChangeEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CheckboxChangeEventArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Checked", "Boolean");
            a.item("Value", "String");
        }
        static d(a) {
            WebCheckboxChangeEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebCheckboxChangeEventArgsDetail", () => new WebCheckboxChangeEventArgsDetailDescription());
            a.ad("WebCheckboxChangeEventArgsDetail", WebCheckboxChangeEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebCheckboxChangeEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCheckboxChangeEventArgsDetailDescriptionMetadata, 'WebCheckboxChangeEventArgsDetailDescriptionMetadata');
    WebCheckboxChangeEventArgsDetailDescriptionMetadata.a = null;
    return WebCheckboxChangeEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCheckboxChangeEventArgsDescription = /*@__PURE__*/ (() => {
    class WebCheckboxChangeEventArgsDescription extends Description {
        get_type() {
            return "WebCheckboxChangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebCheckboxChangeEventArgsDescription.$t = /*@__PURE__*/ markType(WebCheckboxChangeEventArgsDescription, 'WebCheckboxChangeEventArgsDescription', Description.$);
    WebCheckboxChangeEventArgsDescription.__marshalByValue = true;
    WebCheckboxChangeEventArgsDescription.__marshalByValueAlias = "CheckboxChangeEventArgs";
    return WebCheckboxChangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCheckboxChangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCheckboxChangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebCheckboxChangeEventArgsDescriptionMetadata.a == null) {
                WebCheckboxChangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCheckboxChangeEventArgsDescriptionMetadata.c(WebCheckboxChangeEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebCheckboxChangeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCheckboxChangeEventArgsDescriptionMetadata.a);
            WebCheckboxChangeEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CheckboxChangeEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebCheckboxChangeEventArgsDetail");
        }
        static d(a) {
            WebCheckboxChangeEventArgsDescriptionMetadata.b(a);
            a.ae("WebCheckboxChangeEventArgs", () => new WebCheckboxChangeEventArgsDescription());
            a.ad("WebCheckboxChangeEventArgs", WebCheckboxChangeEventArgsDescriptionMetadata.a);
        }
    }
    WebCheckboxChangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCheckboxChangeEventArgsDescriptionMetadata, 'WebCheckboxChangeEventArgsDescriptionMetadata');
    WebCheckboxChangeEventArgsDescriptionMetadata.a = null;
    return WebCheckboxChangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCheckboxBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCheckboxBaseDescriptionMetadata extends Base {
        static b(a) {
            if (WebCheckboxBaseDescriptionMetadata.a == null) {
                WebCheckboxBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCheckboxBaseDescriptionMetadata.c(WebCheckboxBaseDescriptionMetadata.a);
            }
            if (a.k(WebCheckboxBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCheckboxBaseDescriptionMetadata.a);
            WebCheckboxChangeEventArgsDescriptionMetadata.d(a);
            VoidEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CheckboxBase");
            a.item("__tagNameWC", "String:igc-checkbox-base");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Value", "String");
            a.item("Checked", "Boolean");
            a.item("LabelPosition", "ExportedType:string:CheckboxBaseLabelPosition");
            a.item("LabelPosition@stringUnion", "WebComponents;React");
            a.item("LabelPosition@names", "Before;After");
            a.item("Disabled", "Boolean");
            a.item("Required", "Boolean");
            a.item("Name", "String");
            a.item("Invalid", "Boolean");
            a.item("ChangeRef", "EventRef::change");
            a.item("FocusRef", "EventRef::focus");
            a.item("BlurRef", "EventRef::blur");
        }
        static d(a) {
            WebCheckboxBaseDescriptionMetadata.b(a);
            a.ae("WebCheckboxBase", () => new WebCheckboxBaseDescription());
            a.ad("WebCheckboxBase", WebCheckboxBaseDescriptionMetadata.a);
        }
    }
    WebCheckboxBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCheckboxBaseDescriptionMetadata, 'WebCheckboxBaseDescriptionMetadata');
    WebCheckboxBaseDescriptionMetadata.a = null;
    return WebCheckboxBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCheckboxDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCheckboxDescriptionMetadata extends Base {
        static b(a) {
            if (WebCheckboxDescriptionMetadata.a == null) {
                WebCheckboxDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCheckboxDescriptionMetadata.c(WebCheckboxDescriptionMetadata.a);
            }
            if (a.k(WebCheckboxDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCheckboxDescriptionMetadata.a);
        }
        static c(a) {
            WebCheckboxBaseDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:Checkbox");
            a.item("__tagNameWC", "String:igc-checkbox");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Indeterminate", "Boolean");
        }
        static d(a) {
            WebCheckboxDescriptionMetadata.b(a);
            a.ae("WebCheckbox", () => new WebCheckboxDescription());
            a.ad("WebCheckbox", WebCheckboxDescriptionMetadata.a);
        }
    }
    WebCheckboxDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCheckboxDescriptionMetadata, 'WebCheckboxDescriptionMetadata');
    WebCheckboxDescriptionMetadata.a = null;
    return WebCheckboxDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCheckboxBaseDescriptionModule = /*@__PURE__*/ (() => {
    class WebCheckboxBaseDescriptionModule extends Base {
        static register(a) {
            WebCheckboxChangeEventArgsDescriptionMetadata.d(a);
            WebCheckboxBaseDescriptionMetadata.d(a);
        }
    }
    WebCheckboxBaseDescriptionModule.$t = /*@__PURE__*/ markType(WebCheckboxBaseDescriptionModule, 'WebCheckboxBaseDescriptionModule');
    return WebCheckboxBaseDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCheckboxDescriptionModule = /*@__PURE__*/ (() => {
    class WebCheckboxDescriptionModule extends Base {
        static register(a) {
            WebCheckboxBaseDescriptionModule.register(a);
            WebCheckboxDescriptionMetadata.d(a);
        }
    }
    WebCheckboxDescriptionModule.$t = /*@__PURE__*/ markType(WebCheckboxDescriptionModule, 'WebCheckboxDescriptionModule');
    return WebCheckboxDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebChildGridRowDescription = /*@__PURE__*/ (() => {
    class WebChildGridRowDescription extends Description {
        get_type() {
            return "WebChildGridRow";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.n = null;
            this.l = 0;
            this.j = false;
        }
        get layout() {
            return this.h;
        }
        set layout(a) {
            this.h = a;
            this.g("Layout");
        }
        get data() {
            return this.n;
        }
        set data(a) {
            this.n = a;
            this.g("Data");
        }
        get index() {
            return this.l;
        }
        set index(a) {
            this.l = a;
            this.g("Index");
        }
        get expanded() {
            return this.j;
        }
        set expanded(a) {
            this.j = a;
            this.g("Expanded");
        }
    }
    WebChildGridRowDescription.$t = /*@__PURE__*/ markType(WebChildGridRowDescription, 'WebChildGridRowDescription', Description.$);
    return WebChildGridRowDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridCreatedEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGridCreatedEventArgsDescription extends Description {
        get_type() {
            return "WebGridCreatedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGridCreatedEventArgsDescription.$t = /*@__PURE__*/ markType(WebGridCreatedEventArgsDescription, 'WebGridCreatedEventArgsDescription', Description.$);
    WebGridCreatedEventArgsDescription.__marshalByValue = true;
    WebGridCreatedEventArgsDescription.__marshalByValueAlias = "GridCreatedEventArgs";
    return WebGridCreatedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridBaseDirectiveDescription = /*@__PURE__*/ (() => {
    class WebGridBaseDirectiveDescription extends Description {
        get_type() {
            return "WebGridBaseDirective";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.bg = 0;
            this.at = false;
            this.j = null;
            this.ax = false;
            this.ch = null;
            this.bo = null;
            this.cw = null;
            this.bh = 0;
            this.z = null;
            this.x = null;
            this.c5 = null;
            this.dp = null;
            this.cz = null;
            this.k = null;
            this.h = null;
            this.cd = null;
            this.dh = null;
            this.c4 = null;
            this.dd = null;
            this.di = null;
            this.c7 = null;
            this.ct = null;
            this.cs = null;
            this.ci = null;
            this.dt = null;
            this.du = null;
            this.dv = null;
            this.o = null;
            this.l = null;
            this.ah = null;
            this.cm = null;
            this.ac = null;
            this.ab = null;
            this.cx = null;
            this.cy = null;
            this.av = false;
            this.ay = false;
            this.d3 = null;
            this.az = false;
            this.cv = null;
            this.d4 = null;
            this.bf = 0;
            this.b8 = null;
            this.cg = null;
            this.aw = false;
            this.a1 = false;
            this.cf = null;
            this.an = null;
            this.as = false;
            this.ar = false;
            this.cn = null;
            this.d0 = null;
            this.dz = null;
            this.a2 = false;
            this.af = null;
            this.aj = null;
            this.ap = null;
            this.ds = null;
            this.cu = null;
            this.dn = null;
            this.ce = null;
            this.m = null;
            this.au = false;
            this.bv = null;
            this.dl = null;
            this.b4 = null;
            this.al = null;
            this.bi = 0;
            this.a0 = false;
            this.i = null;
            this.n = null;
            this.cl = null;
            this.bp = null;
            this.cr = null;
            this.bq = null;
            this.c6 = null;
            this.co = null;
            this.d2 = null;
            this.dr = null;
            this.dm = null;
            this.b5 = null;
            this.b0 = null;
            this.b1 = null;
            this.bt = null;
            this.bu = null;
            this.br = null;
            this.bs = null;
            this.df = null;
            this.dc = null;
            this.de = null;
            this.dg = null;
            this.bw = null;
            this.b3 = null;
            this.dw = null;
            this.dx = null;
            this.cj = null;
            this.ck = null;
            this.c3 = null;
            this.c9 = null;
            this.c8 = null;
            this.c2 = null;
            this.b2 = null;
            this.b9 = null;
            this.cc = null;
            this.b7 = null;
            this.b6 = null;
            this.bz = null;
            this.bx = null;
            this.by = null;
            this.cq = null;
            this.db = null;
            this.da = null;
            this.cp = null;
            this.dq = null;
            this.dk = null;
            this.dj = null;
            this.bn = null;
            this.dy = null;
            this.d1 = null;
            this.c0 = null;
            this.c1 = null;
            this.cb = null;
            this.ca = null;
        }
        get snackbarDisplayTime() {
            return this.bg;
        }
        set snackbarDisplayTime(a) {
            this.bg = a;
            this.g("SnackbarDisplayTime");
        }
        get autoGenerate() {
            return this.at;
        }
        set autoGenerate(a) {
            this.at = a;
            this.g("AutoGenerate");
        }
        get autoGenerateExclude() {
            return this.j;
        }
        set autoGenerateExclude(a) {
            this.j = a;
            this.g("AutoGenerateExclude");
        }
        get moving() {
            return this.ax;
        }
        set moving(a) {
            this.ax = a;
            this.g("Moving");
        }
        get emptyGridTemplateRef() {
            return this.ch;
        }
        set emptyGridTemplateRef(a) {
            this.ch = a;
            this.g("EmptyGridTemplateRef");
        }
        get addRowEmptyTemplateRef() {
            return this.bo;
        }
        set addRowEmptyTemplateRef(a) {
            this.bo = a;
            this.g("AddRowEmptyTemplateRef");
        }
        get loadingGridTemplateRef() {
            return this.cw;
        }
        set loadingGridTemplateRef(a) {
            this.cw = a;
            this.g("LoadingGridTemplateRef");
        }
        get summaryRowHeight() {
            return this.bh;
        }
        set summaryRowHeight(a) {
            this.bh = a;
            this.g("SummaryRowHeight");
        }
        get dataCloneStrategy() {
            return this.z;
        }
        set dataCloneStrategy(a) {
            this.z = a;
            this.g("DataCloneStrategy");
        }
        get clipboardOptions() {
            return this.x;
        }
        set clipboardOptions(a) {
            this.x = a;
            this.g("ClipboardOptions");
        }
        get rowClassesRef() {
            return this.c5;
        }
        set rowClassesRef(a) {
            this.c5 = a;
            this.g("RowClassesRef");
        }
        get rowStylesRef() {
            return this.dp;
        }
        set rowStylesRef(a) {
            this.dp = a;
            this.g("RowStylesRef");
        }
        get primaryKey() {
            return this.cz;
        }
        set primaryKey(a) {
            this.cz = a;
            this.g("PrimaryKey");
        }
        get columnList() {
            return this.k;
        }
        set columnList(a) {
            this.k = a;
            this.g("ColumnList");
        }
        get actionStripComponents() {
            return this.h;
        }
        set actionStripComponents(a) {
            this.h = a;
            this.g("ActionStripComponents");
        }
        get dragGhostCustomTemplateRef() {
            return this.cd;
        }
        set dragGhostCustomTemplateRef(a) {
            this.cd = a;
            this.g("DragGhostCustomTemplateRef");
        }
        get rowEditTextTemplateRef() {
            return this.dh;
        }
        set rowEditTextTemplateRef(a) {
            this.dh = a;
            this.g("RowEditTextTemplateRef");
        }
        get rowAddTextTemplateRef() {
            return this.c4;
        }
        set rowAddTextTemplateRef(a) {
            this.c4 = a;
            this.g("RowAddTextTemplateRef");
        }
        get rowEditActionsTemplateRef() {
            return this.dd;
        }
        set rowEditActionsTemplateRef(a) {
            this.dd = a;
            this.g("RowEditActionsTemplateRef");
        }
        get rowExpandedIndicatorTemplateRef() {
            return this.di;
        }
        set rowExpandedIndicatorTemplateRef(a) {
            this.di = a;
            this.g("RowExpandedIndicatorTemplateRef");
        }
        get rowCollapsedIndicatorTemplateRef() {
            return this.c7;
        }
        set rowCollapsedIndicatorTemplateRef(a) {
            this.c7 = a;
            this.g("RowCollapsedIndicatorTemplateRef");
        }
        get headerExpandedIndicatorTemplateRef() {
            return this.ct;
        }
        set headerExpandedIndicatorTemplateRef(a) {
            this.ct = a;
            this.g("HeaderExpandedIndicatorTemplateRef");
        }
        get headerCollapsedIndicatorTemplateRef() {
            return this.cs;
        }
        set headerCollapsedIndicatorTemplateRef(a) {
            this.cs = a;
            this.g("HeaderCollapsedIndicatorTemplateRef");
        }
        get excelStyleHeaderIconTemplateRef() {
            return this.ci;
        }
        set excelStyleHeaderIconTemplateRef(a) {
            this.ci = a;
            this.g("ExcelStyleHeaderIconTemplateRef");
        }
        get sortAscendingHeaderIconTemplateRef() {
            return this.dt;
        }
        set sortAscendingHeaderIconTemplateRef(a) {
            this.dt = a;
            this.g("SortAscendingHeaderIconTemplateRef");
        }
        get sortDescendingHeaderIconTemplateRef() {
            return this.du;
        }
        set sortDescendingHeaderIconTemplateRef(a) {
            this.du = a;
            this.g("SortDescendingHeaderIconTemplateRef");
        }
        get sortHeaderIconTemplateRef() {
            return this.dv;
        }
        set sortHeaderIconTemplateRef(a) {
            this.dv = a;
            this.g("SortHeaderIconTemplateRef");
        }
        get toolbar() {
            return this.o;
        }
        set toolbar(a) {
            this.o = a;
            this.g("Toolbar");
        }
        get paginationComponents() {
            return this.l;
        }
        set paginationComponents(a) {
            this.l = a;
            this.g("PaginationComponents");
        }
        get resourceStrings() {
            return this.ah;
        }
        set resourceStrings(a) {
            this.ah = a;
            this.g("ResourceStrings");
        }
        get filteringLogic() {
            return this.cm;
        }
        set filteringLogic(a) {
            this.cm = a;
            this.g("FilteringLogic");
        }
        get filteringExpressionsTree() {
            return this.ac;
        }
        set filteringExpressionsTree(a) {
            this.ac = a;
            this.g("FilteringExpressionsTree");
        }
        get advancedFilteringExpressionsTree() {
            return this.ab;
        }
        set advancedFilteringExpressionsTree(a) {
            this.ab = a;
            this.g("AdvancedFilteringExpressionsTree");
        }
        get locale() {
            return this.cx;
        }
        set locale(a) {
            this.cx = a;
            this.g("Locale");
        }
        get pagingMode() {
            return this.cy;
        }
        set pagingMode(a) {
            this.cy = a;
            this.g("PagingMode");
        }
        get hideRowSelectors() {
            return this.av;
        }
        set hideRowSelectors(a) {
            this.av = a;
            this.g("HideRowSelectors");
        }
        get rowDraggable() {
            return this.ay;
        }
        set rowDraggable(a) {
            this.ay = a;
            this.g("RowDraggable");
        }
        get validationTrigger() {
            return this.d3;
        }
        set validationTrigger(a) {
            this.d3 = a;
            this.g("ValidationTrigger");
        }
        get rowEditable() {
            return this.az;
        }
        set rowEditable(a) {
            this.az = a;
            this.g("RowEditable");
        }
        get height() {
            return this.cv;
        }
        set height(a) {
            this.cv = a;
            this.g("Height");
        }
        get width() {
            return this.d4;
        }
        set width(a) {
            this.d4 = a;
            this.g("Width");
        }
        get rowHeight() {
            return this.bf;
        }
        set rowHeight(a) {
            this.bf = a;
            this.g("RowHeight");
        }
        get columnWidth() {
            return this.b8;
        }
        set columnWidth(a) {
            this.b8 = a;
            this.g("ColumnWidth");
        }
        get emptyGridMessage() {
            return this.cg;
        }
        set emptyGridMessage(a) {
            this.cg = a;
            this.g("EmptyGridMessage");
        }
        get isLoading() {
            return this.aw;
        }
        set isLoading(a) {
            this.aw = a;
            this.g("IsLoading");
        }
        get shouldGenerate() {
            return this.a1;
        }
        set shouldGenerate(a) {
            this.a1 = a;
            this.g("ShouldGenerate");
        }
        get emptyFilteredGridMessage() {
            return this.cf;
        }
        set emptyFilteredGridMessage(a) {
            this.cf = a;
            this.g("EmptyFilteredGridMessage");
        }
        get pinning() {
            return this.an;
        }
        set pinning(a) {
            this.an = a;
            this.g("Pinning");
        }
        get allowFiltering() {
            return this.as;
        }
        set allowFiltering(a) {
            this.as = a;
            this.g("AllowFiltering");
        }
        get allowAdvancedFiltering() {
            return this.ar;
        }
        set allowAdvancedFiltering(a) {
            this.ar = a;
            this.g("AllowAdvancedFiltering");
        }
        get filterMode() {
            return this.cn;
        }
        set filterMode(a) {
            this.cn = a;
            this.g("FilterMode");
        }
        get summaryPosition() {
            return this.d0;
        }
        set summaryPosition(a) {
            this.d0 = a;
            this.g("SummaryPosition");
        }
        get summaryCalculationMode() {
            return this.dz;
        }
        set summaryCalculationMode(a) {
            this.dz = a;
            this.g("SummaryCalculationMode");
        }
        get showSummaryOnCollapse() {
            return this.a2;
        }
        set showSummaryOnCollapse(a) {
            this.a2 = a;
            this.g("ShowSummaryOnCollapse");
        }
        get filterStrategy() {
            return this.af;
        }
        set filterStrategy(a) {
            this.af = a;
            this.g("FilterStrategy");
        }
        get sortStrategy() {
            return this.aj;
        }
        set sortStrategy(a) {
            this.aj = a;
            this.g("SortStrategy");
        }
        get sortingOptions() {
            return this.ap;
        }
        set sortingOptions(a) {
            this.ap = a;
            this.g("SortingOptions");
        }
        get selectedRowsRef() {
            return this.ds;
        }
        set selectedRowsRef(a) {
            this.ds = a;
            this.g("SelectedRowsRef");
        }
        get headSelectorTemplateRef() {
            return this.cu;
        }
        set headSelectorTemplateRef(a) {
            this.cu = a;
            this.g("HeadSelectorTemplateRef");
        }
        get rowSelectorTemplateRef() {
            return this.dn;
        }
        set rowSelectorTemplateRef(a) {
            this.dn = a;
            this.g("RowSelectorTemplateRef");
        }
        get dragIndicatorIconTemplateRef() {
            return this.ce;
        }
        set dragIndicatorIconTemplateRef(a) {
            this.ce = a;
            this.g("DragIndicatorIconTemplateRef");
        }
        get sortingExpressions() {
            return this.m;
        }
        set sortingExpressions(a) {
            this.m = a;
            this.g("SortingExpressions");
        }
        get batchEditing() {
            return this.au;
        }
        set batchEditing(a) {
            this.au = a;
            this.g("BatchEditing");
        }
        get cellSelection() {
            return this.bv;
        }
        set cellSelection(a) {
            this.bv = a;
            this.g("CellSelection");
        }
        get rowSelection() {
            return this.dl;
        }
        set rowSelection(a) {
            this.dl = a;
            this.g("RowSelection");
        }
        get columnSelection() {
            return this.b4;
        }
        set columnSelection(a) {
            this.b4 = a;
            this.g("ColumnSelection");
        }
        get outlet() {
            return this.al;
        }
        set outlet(a) {
            this.al = a;
            this.g("Outlet");
        }
        get totalRecords() {
            return this.bi;
        }
        set totalRecords(a) {
            this.bi = a;
            this.g("TotalRecords");
        }
        get selectRowOnClick() {
            return this.a0;
        }
        set selectRowOnClick(a) {
            this.a0 = a;
            this.g("SelectRowOnClick");
        }
        get actualColumnList() {
            return this.i;
        }
        set actualColumnList(a) {
            this.i = a;
            this.g("ActualColumnList");
        }
        get stateComponents() {
            return this.n;
        }
        set stateComponents(a) {
            this.n = a;
            this.g("StateComponents");
        }
        get filteringExpressionsTreeChangeRef() {
            return this.cl;
        }
        set filteringExpressionsTreeChangeRef(a) {
            this.cl = a;
            this.g("FilteringExpressionsTreeChangeRef");
        }
        get advancedFilteringExpressionsTreeChangeRef() {
            return this.bp;
        }
        set advancedFilteringExpressionsTreeChangeRef(a) {
            this.bp = a;
            this.g("AdvancedFilteringExpressionsTreeChangeRef");
        }
        get gridScrollRef() {
            return this.cr;
        }
        set gridScrollRef(a) {
            this.cr = a;
            this.g("GridScrollRef");
        }
        get cellClickRef() {
            return this.bq;
        }
        set cellClickRef(a) {
            this.bq = a;
            this.g("CellClickRef");
        }
        get rowClickRef() {
            return this.c6;
        }
        set rowClickRef(a) {
            this.c6 = a;
            this.g("RowClickRef");
        }
        get formGroupCreatedRef() {
            return this.co;
        }
        set formGroupCreatedRef(a) {
            this.co = a;
            this.g("FormGroupCreatedRef");
        }
        get validationStatusChangeRef() {
            return this.d2;
        }
        set validationStatusChangeRef(a) {
            this.d2 = a;
            this.g("ValidationStatusChangeRef");
        }
        get selectedRef() {
            return this.dr;
        }
        set selectedRef(a) {
            this.dr = a;
            this.g("SelectedRef");
        }
        get rowSelectionChangingRef() {
            return this.dm;
        }
        set rowSelectionChangingRef(a) {
            this.dm = a;
            this.g("RowSelectionChangingRef");
        }
        get columnSelectionChangingRef() {
            return this.b5;
        }
        set columnSelectionChangingRef(a) {
            this.b5 = a;
            this.g("ColumnSelectionChangingRef");
        }
        get columnPinRef() {
            return this.b0;
        }
        set columnPinRef(a) {
            this.b0 = a;
            this.g("ColumnPinRef");
        }
        get columnPinnedRef() {
            return this.b1;
        }
        set columnPinnedRef(a) {
            this.b1 = a;
            this.g("ColumnPinnedRef");
        }
        get cellEditEnterRef() {
            return this.bt;
        }
        set cellEditEnterRef(a) {
            this.bt = a;
            this.g("CellEditEnterRef");
        }
        get cellEditExitRef() {
            return this.bu;
        }
        set cellEditExitRef(a) {
            this.bu = a;
            this.g("CellEditExitRef");
        }
        get cellEditRef() {
            return this.br;
        }
        set cellEditRef(a) {
            this.br = a;
            this.g("CellEditRef");
        }
        get cellEditDoneRef() {
            return this.bs;
        }
        set cellEditDoneRef(a) {
            this.bs = a;
            this.g("CellEditDoneRef");
        }
        get rowEditEnterRef() {
            return this.df;
        }
        set rowEditEnterRef(a) {
            this.df = a;
            this.g("RowEditEnterRef");
        }
        get rowEditRef() {
            return this.dc;
        }
        set rowEditRef(a) {
            this.dc = a;
            this.g("RowEditRef");
        }
        get rowEditDoneRef() {
            return this.de;
        }
        set rowEditDoneRef(a) {
            this.de = a;
            this.g("RowEditDoneRef");
        }
        get rowEditExitRef() {
            return this.dg;
        }
        set rowEditExitRef(a) {
            this.dg = a;
            this.g("RowEditExitRef");
        }
        get columnInitRef() {
            return this.bw;
        }
        set columnInitRef(a) {
            this.bw = a;
            this.g("ColumnInitRef");
        }
        get columnsAutogeneratedRef() {
            return this.b3;
        }
        set columnsAutogeneratedRef(a) {
            this.b3 = a;
            this.g("ColumnsAutogeneratedRef");
        }
        get sortingRef() {
            return this.dw;
        }
        set sortingRef(a) {
            this.dw = a;
            this.g("SortingRef");
        }
        get sortingDoneRef() {
            return this.dx;
        }
        set sortingDoneRef(a) {
            this.dx = a;
            this.g("SortingDoneRef");
        }
        get filteringRef() {
            return this.cj;
        }
        set filteringRef(a) {
            this.cj = a;
            this.g("FilteringRef");
        }
        get filteringDoneRef() {
            return this.ck;
        }
        set filteringDoneRef(a) {
            this.ck = a;
            this.g("FilteringDoneRef");
        }
        get rowAddedRef() {
            return this.c3;
        }
        set rowAddedRef(a) {
            this.c3 = a;
            this.g("RowAddedRef");
        }
        get rowDeletedRef() {
            return this.c9;
        }
        set rowDeletedRef(a) {
            this.c9 = a;
            this.g("RowDeletedRef");
        }
        get rowDeleteRef() {
            return this.c8;
        }
        set rowDeleteRef(a) {
            this.c8 = a;
            this.g("RowDeleteRef");
        }
        get rowAddRef() {
            return this.c2;
        }
        set rowAddRef(a) {
            this.c2 = a;
            this.g("RowAddRef");
        }
        get columnResizedRef() {
            return this.b2;
        }
        set columnResizedRef(a) {
            this.b2 = a;
            this.g("ColumnResizedRef");
        }
        get contextMenuRef() {
            return this.b9;
        }
        set contextMenuRef(a) {
            this.b9 = a;
            this.g("ContextMenuRef");
        }
        get doubleClickRef() {
            return this.cc;
        }
        set doubleClickRef(a) {
            this.cc = a;
            this.g("DoubleClickRef");
        }
        get columnVisibilityChangingRef() {
            return this.b7;
        }
        set columnVisibilityChangingRef(a) {
            this.b7 = a;
            this.g("ColumnVisibilityChangingRef");
        }
        get columnVisibilityChangedRef() {
            return this.b6;
        }
        set columnVisibilityChangedRef(a) {
            this.b6 = a;
            this.g("ColumnVisibilityChangedRef");
        }
        get columnMovingStartRef() {
            return this.bz;
        }
        set columnMovingStartRef(a) {
            this.bz = a;
            this.g("ColumnMovingStartRef");
        }
        get columnMovingRef() {
            return this.bx;
        }
        set columnMovingRef(a) {
            this.bx = a;
            this.g("ColumnMovingRef");
        }
        get columnMovingEndRef() {
            return this.by;
        }
        set columnMovingEndRef(a) {
            this.by = a;
            this.g("ColumnMovingEndRef");
        }
        get gridKeydownRef() {
            return this.cq;
        }
        set gridKeydownRef(a) {
            this.cq = a;
            this.g("GridKeydownRef");
        }
        get rowDragStartRef() {
            return this.db;
        }
        set rowDragStartRef(a) {
            this.db = a;
            this.g("RowDragStartRef");
        }
        get rowDragEndRef() {
            return this.da;
        }
        set rowDragEndRef(a) {
            this.da = a;
            this.g("RowDragEndRef");
        }
        get gridCopyRef() {
            return this.cp;
        }
        set gridCopyRef(a) {
            this.cp = a;
            this.g("GridCopyRef");
        }
        get rowToggleRef() {
            return this.dq;
        }
        set rowToggleRef(a) {
            this.dq = a;
            this.g("RowToggleRef");
        }
        get rowPinningRef() {
            return this.dk;
        }
        set rowPinningRef(a) {
            this.dk = a;
            this.g("RowPinningRef");
        }
        get rowPinnedRef() {
            return this.dj;
        }
        set rowPinnedRef(a) {
            this.dj = a;
            this.g("RowPinnedRef");
        }
        get activeNodeChangeRef() {
            return this.bn;
        }
        set activeNodeChangeRef(a) {
            this.bn = a;
            this.g("ActiveNodeChangeRef");
        }
        get sortingExpressionsChangeRef() {
            return this.dy;
        }
        set sortingExpressionsChangeRef(a) {
            this.dy = a;
            this.g("SortingExpressionsChangeRef");
        }
        get toolbarExportingRef() {
            return this.d1;
        }
        set toolbarExportingRef(a) {
            this.d1 = a;
            this.g("ToolbarExportingRef");
        }
        get rangeSelectedRef() {
            return this.c0;
        }
        set rangeSelectedRef(a) {
            this.c0 = a;
            this.g("RangeSelectedRef");
        }
        get renderedRef() {
            return this.c1;
        }
        set renderedRef(a) {
            this.c1 = a;
            this.g("RenderedRef");
        }
        get dataChangingRef() {
            return this.cb;
        }
        set dataChangingRef(a) {
            this.cb = a;
            this.g("DataChangingRef");
        }
        get dataChangedRef() {
            return this.ca;
        }
        set dataChangedRef(a) {
            this.ca = a;
            this.g("DataChangedRef");
        }
    }
    WebGridBaseDirectiveDescription.$t = /*@__PURE__*/ markType(WebGridBaseDirectiveDescription, 'WebGridBaseDirectiveDescription', Description.$);
    return WebGridBaseDirectiveDescription;
})();
/**
 * @hidden
 */
let WebGridToolbarDescription = /*@__PURE__*/ (() => {
    class WebGridToolbarDescription extends Description {
        get_type() {
            return "WebGridToolbar";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = false;
            this.j = null;
            this.n = null;
            this.h = null;
        }
        get showProgress() {
            return this.l;
        }
        set showProgress(a) {
            this.l = a;
            this.g("ShowProgress");
        }
        get grid() {
            return this.j;
        }
        set grid(a) {
            this.j = a;
            this.g("Grid");
        }
        get name() {
            return this.n;
        }
        set name(a) {
            this.n = a;
            this.g("Name");
        }
        get tools() {
            return this.h;
        }
        set tools(a) {
            this.h = a;
            this.g("Tools");
        }
    }
    WebGridToolbarDescription.$t = /*@__PURE__*/ markType(WebGridToolbarDescription, 'WebGridToolbarDescription', Description.$);
    return WebGridToolbarDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridToolbarDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridToolbarDescriptionMetadata.a == null) {
                WebGridToolbarDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridToolbarDescriptionMetadata.c(WebGridToolbarDescriptionMetadata.a);
            }
            if (a.k(WebGridToolbarDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridToolbarDescriptionMetadata.a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridToolbar");
            a.item("__tagNameWC", "String:igc-grid-toolbar");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__portalChildrenWC", "Boolean");
            a.item("__manageCollectionInMarkup", "Boolean");
            a.item("__manageItemInMarkup", "Boolean");
            a.item("__mustUseNGParentAnchor", "Boolean");
            a.item("ShowProgress", "Boolean");
            a.item("Grid", "ExportedType:WebGridBaseDirective");
            a.item("Name", "String");
            a.item("Tools", "Collection:WebGridToolbarContent:WebGridToolbarContentCollection:WebGridToolbarContent");
        }
        static d(a) {
            WebGridToolbarDescriptionMetadata.b(a);
            a.ae("WebGridToolbar", () => new WebGridToolbarDescription());
            a.ad("WebGridToolbar", WebGridToolbarDescriptionMetadata.a);
        }
    }
    WebGridToolbarDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridToolbarDescriptionMetadata, 'WebGridToolbarDescriptionMetadata');
    WebGridToolbarDescriptionMetadata.a = null;
    return WebGridToolbarDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarContentDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridToolbarContentDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridToolbarContentDescriptionMetadata.a == null) {
                WebGridToolbarContentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridToolbarContentDescriptionMetadata.c(WebGridToolbarContentDescriptionMetadata.a);
            }
            if (a.k(WebGridToolbarContentDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridToolbarContentDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridToolbarContent");
            a.item("__tagNameWC", "String:igc-grid-toolbar-content");
            a.item("__manageCollectionInMarkup", "Boolean");
            a.item("Name", "String");
            WebGridToolbarContentDescriptionMetadata.e(a);
        }
        static d(a) {
            WebGridToolbarContentDescriptionMetadata.b(a);
            a.ad("WebGridToolbarContent", WebGridToolbarContentDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__tagNameWCSubstitutable", "String:igc-grid-toolbar-actions,igc-grid-toolbar-title");
        }
    }
    WebGridToolbarContentDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridToolbarContentDescriptionMetadata, 'WebGridToolbarContentDescriptionMetadata');
    WebGridToolbarContentDescriptionMetadata.a = null;
    return WebGridToolbarContentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarContentDescription = /*@__PURE__*/ (() => {
    class WebGridToolbarContentDescription extends Description {
        get_type() {
            return "WebGridToolbarContent";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get name() {
            return this.h;
        }
        set name(a) {
            this.h = a;
            this.g("Name");
        }
    }
    WebGridToolbarContentDescription.$t = /*@__PURE__*/ markType(WebGridToolbarContentDescription, 'WebGridToolbarContentDescription', Description.$);
    return WebGridToolbarContentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarActionsDescription = /*@__PURE__*/ (() => {
    class WebGridToolbarActionsDescription extends WebGridToolbarContentDescription {
        get_type() {
            return "WebGridToolbarActions";
        }
        constructor() {
            super();
            this.k = null;
            this.m = null;
        }
        get actions() {
            return this.k;
        }
        set actions(a) {
            this.k = a;
            this.g("Actions");
        }
        get name() {
            return this.m;
        }
        set name(a) {
            this.m = a;
            this.g("Name");
        }
    }
    WebGridToolbarActionsDescription.$t = /*@__PURE__*/ markType(WebGridToolbarActionsDescription, 'WebGridToolbarActionsDescription', WebGridToolbarContentDescription.$);
    return WebGridToolbarActionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarActionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridToolbarActionsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridToolbarActionsDescriptionMetadata.a == null) {
                WebGridToolbarActionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridToolbarActionsDescriptionMetadata.c(WebGridToolbarActionsDescriptionMetadata.a);
            }
            if (a.k(WebGridToolbarActionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridToolbarActionsDescriptionMetadata.a);
        }
        static c(a) {
            WebGridToolbarContentDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridToolbarActions");
            a.item("__tagNameWC", "String:igc-grid-toolbar-actions");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("Actions", "Collection:WebGridToolbarBaseAction:WebGridToolbarBaseActionCollection:WebGridToolbarBaseAction");
            a.item("Name", "String");
        }
        static d(a) {
            WebGridToolbarActionsDescriptionMetadata.b(a);
            a.ae("WebGridToolbarActions", () => new WebGridToolbarActionsDescription());
            a.ad("WebGridToolbarActions", WebGridToolbarActionsDescriptionMetadata.a);
        }
    }
    WebGridToolbarActionsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridToolbarActionsDescriptionMetadata, 'WebGridToolbarActionsDescriptionMetadata');
    WebGridToolbarActionsDescriptionMetadata.a = null;
    return WebGridToolbarActionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarTitleDescription = /*@__PURE__*/ (() => {
    class WebGridToolbarTitleDescription extends WebGridToolbarContentDescription {
        get_type() {
            return "WebGridToolbarTitle";
        }
        constructor() {
            super();
            this.k = null;
        }
        get name() {
            return this.k;
        }
        set name(a) {
            this.k = a;
            this.g("Name");
        }
    }
    WebGridToolbarTitleDescription.$t = /*@__PURE__*/ markType(WebGridToolbarTitleDescription, 'WebGridToolbarTitleDescription', WebGridToolbarContentDescription.$);
    return WebGridToolbarTitleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarTitleDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridToolbarTitleDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridToolbarTitleDescriptionMetadata.a == null) {
                WebGridToolbarTitleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridToolbarTitleDescriptionMetadata.c(WebGridToolbarTitleDescriptionMetadata.a);
            }
            if (a.k(WebGridToolbarTitleDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridToolbarTitleDescriptionMetadata.a);
        }
        static c(a) {
            WebGridToolbarContentDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridToolbarTitle");
            a.item("__tagNameWC", "String:igc-grid-toolbar-title");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__portalChildrenWC", "Boolean");
            a.item("Name", "String");
            WebGridToolbarTitleDescriptionMetadata.e(a);
        }
        static d(a) {
            WebGridToolbarTitleDescriptionMetadata.b(a);
            a.ae("WebGridToolbarTitle", () => new WebGridToolbarTitleDescription());
            a.ad("WebGridToolbarTitle", WebGridToolbarTitleDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__portalChildrenWC", "Boolean");
        }
    }
    WebGridToolbarTitleDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridToolbarTitleDescriptionMetadata, 'WebGridToolbarTitleDescriptionMetadata');
    WebGridToolbarTitleDescriptionMetadata.a = null;
    return WebGridToolbarTitleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebExporterEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebExporterEventArgsDetailDescription extends Description {
        get_type() {
            return "WebExporterEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = null;
            this.l = null;
            this.o = false;
        }
        get exporter() {
            return this.h;
        }
        set exporter(a) {
            this.h = a;
            this.g("Exporter");
        }
        get options() {
            return this.j;
        }
        set options(a) {
            this.j = a;
            this.g("Options");
        }
        get grid() {
            return this.l;
        }
        set grid(a) {
            this.l = a;
            this.g("Grid");
        }
        get cancel() {
            return this.o;
        }
        set cancel(a) {
            this.o = a;
            this.g("Cancel");
        }
    }
    WebExporterEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebExporterEventArgsDetailDescription, 'WebExporterEventArgsDetailDescription', Description.$);
    WebExporterEventArgsDetailDescription.__marshalByValue = true;
    WebExporterEventArgsDetailDescription.__marshalByValueAlias = "ExporterEventArgsDetail";
    return WebExporterEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebExporterEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebExporterEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebExporterEventArgsDetailDescriptionMetadata.a == null) {
                WebExporterEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebExporterEventArgsDetailDescriptionMetadata.c(WebExporterEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebExporterEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebExporterEventArgsDetailDescriptionMetadata.a);
            WebBaseExporterDescriptionMetadata.d(a);
            WebExporterOptionsBaseDescriptionMetadata.d(a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ExporterEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Exporter", "ExportedType:WebBaseExporter");
            a.item("Options", "ExportedType:WebExporterOptionsBase");
            a.item("Grid", "ExportedType:WebGridBaseDirective");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebExporterEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebExporterEventArgsDetail", () => new WebExporterEventArgsDetailDescription());
            a.ad("WebExporterEventArgsDetail", WebExporterEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebExporterEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebExporterEventArgsDetailDescriptionMetadata, 'WebExporterEventArgsDetailDescriptionMetadata');
    WebExporterEventArgsDetailDescriptionMetadata.a = null;
    return WebExporterEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebExporterEventArgsDescription = /*@__PURE__*/ (() => {
    class WebExporterEventArgsDescription extends Description {
        get_type() {
            return "WebExporterEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebExporterEventArgsDescription.$t = /*@__PURE__*/ markType(WebExporterEventArgsDescription, 'WebExporterEventArgsDescription', Description.$);
    WebExporterEventArgsDescription.__marshalByValue = true;
    WebExporterEventArgsDescription.__marshalByValueAlias = "ExporterEventArgs";
    return WebExporterEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebExporterEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebExporterEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebExporterEventArgsDescriptionMetadata.a == null) {
                WebExporterEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebExporterEventArgsDescriptionMetadata.c(WebExporterEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebExporterEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebExporterEventArgsDescriptionMetadata.a);
            WebExporterEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ExporterEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebExporterEventArgsDetail");
        }
        static d(a) {
            WebExporterEventArgsDescriptionMetadata.b(a);
            a.ae("WebExporterEventArgs", () => new WebExporterEventArgsDescription());
            a.ad("WebExporterEventArgs", WebExporterEventArgsDescriptionMetadata.a);
        }
    }
    WebExporterEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebExporterEventArgsDescriptionMetadata, 'WebExporterEventArgsDescriptionMetadata');
    WebExporterEventArgsDescriptionMetadata.a = null;
    return WebExporterEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarExporterDescription = /*@__PURE__*/ (() => {
    class WebGridToolbarExporterDescription extends WebBaseToolbarDirectiveDescription {
        get_type() {
            return "WebGridToolbarExporter";
        }
        constructor() {
            super();
            this.ae = false;
            this.af = false;
            this.ak = null;
            this.aj = null;
            this.ai = null;
        }
        get exportCSV() {
            return this.ae;
        }
        set exportCSV(a) {
            this.ae = a;
            this.g("ExportCSV");
        }
        get exportExcel() {
            return this.af;
        }
        set exportExcel(a) {
            this.af = a;
            this.g("ExportExcel");
        }
        get filename() {
            return this.ak;
        }
        set filename(a) {
            this.ak = a;
            this.g("Filename");
        }
        get exportStartedRef() {
            return this.aj;
        }
        set exportStartedRef(a) {
            this.aj = a;
            this.g("ExportStartedRef");
        }
        get exportEndedRef() {
            return this.ai;
        }
        set exportEndedRef(a) {
            this.ai = a;
            this.g("ExportEndedRef");
        }
    }
    WebGridToolbarExporterDescription.$t = /*@__PURE__*/ markType(WebGridToolbarExporterDescription, 'WebGridToolbarExporterDescription', WebBaseToolbarDirectiveDescription.$);
    return WebGridToolbarExporterDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarExporterDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridToolbarExporterDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridToolbarExporterDescriptionMetadata.a == null) {
                WebGridToolbarExporterDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridToolbarExporterDescriptionMetadata.c(WebGridToolbarExporterDescriptionMetadata.a);
            }
            if (a.k(WebGridToolbarExporterDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridToolbarExporterDescriptionMetadata.a);
            WebExporterEventArgsDescriptionMetadata.d(a);
            VoidEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseToolbarDirectiveDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridToolbarExporter");
            a.item("__tagNameWC", "String:igc-grid-toolbar-exporter");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            if (a.containsKey("__skipSuffix")) {
                a.removeItem("__skipSuffix");
            }
            a.item("__portalChildrenWC", "Boolean");
            a.item("__manageItemInMarkup", "Boolean");
            a.item("ExportCSV", "Boolean");
            a.item("ExportExcel", "Boolean");
            a.item("Filename", "String");
            a.item("ExportStartedRef", "EventRef::exportStarted:customEvent");
            a.item("ExportEndedRef", "EventRef::exportEnded:customEvent");
        }
        static d(a) {
            WebGridToolbarExporterDescriptionMetadata.b(a);
            a.ae("WebGridToolbarExporter", () => new WebGridToolbarExporterDescription());
            a.ad("WebGridToolbarExporter", WebGridToolbarExporterDescriptionMetadata.a);
        }
    }
    WebGridToolbarExporterDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridToolbarExporterDescriptionMetadata, 'WebGridToolbarExporterDescriptionMetadata');
    WebGridToolbarExporterDescriptionMetadata.a = null;
    return WebGridToolbarExporterDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarHidingDescription = /*@__PURE__*/ (() => {
    class WebGridToolbarHidingDescription extends WebBaseToolbarColumnActionsDirectiveDescription {
        get_type() {
            return "WebGridToolbarHiding";
        }
        constructor() {
            super();
        }
    }
    WebGridToolbarHidingDescription.$t = /*@__PURE__*/ markType(WebGridToolbarHidingDescription, 'WebGridToolbarHidingDescription', WebBaseToolbarColumnActionsDirectiveDescription.$);
    return WebGridToolbarHidingDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarHidingDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridToolbarHidingDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridToolbarHidingDescriptionMetadata.a == null) {
                WebGridToolbarHidingDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridToolbarHidingDescriptionMetadata.c(WebGridToolbarHidingDescriptionMetadata.a);
            }
            if (a.k(WebGridToolbarHidingDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridToolbarHidingDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseToolbarColumnActionsDirectiveDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridToolbarHiding");
            a.item("__tagNameWC", "String:igc-grid-toolbar-hiding");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            if (a.containsKey("__skipSuffix")) {
                a.removeItem("__skipSuffix");
            }
            a.item("__manageItemInMarkup", "Boolean");
        }
        static d(a) {
            WebGridToolbarHidingDescriptionMetadata.b(a);
            a.ae("WebGridToolbarHiding", () => new WebGridToolbarHidingDescription());
            a.ad("WebGridToolbarHiding", WebGridToolbarHidingDescriptionMetadata.a);
        }
    }
    WebGridToolbarHidingDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridToolbarHidingDescriptionMetadata, 'WebGridToolbarHidingDescriptionMetadata');
    WebGridToolbarHidingDescriptionMetadata.a = null;
    return WebGridToolbarHidingDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarPinningDescription = /*@__PURE__*/ (() => {
    class WebGridToolbarPinningDescription extends WebBaseToolbarColumnActionsDirectiveDescription {
        get_type() {
            return "WebGridToolbarPinning";
        }
        constructor() {
            super();
        }
    }
    WebGridToolbarPinningDescription.$t = /*@__PURE__*/ markType(WebGridToolbarPinningDescription, 'WebGridToolbarPinningDescription', WebBaseToolbarColumnActionsDirectiveDescription.$);
    return WebGridToolbarPinningDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarPinningDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridToolbarPinningDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridToolbarPinningDescriptionMetadata.a == null) {
                WebGridToolbarPinningDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridToolbarPinningDescriptionMetadata.c(WebGridToolbarPinningDescriptionMetadata.a);
            }
            if (a.k(WebGridToolbarPinningDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridToolbarPinningDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseToolbarColumnActionsDirectiveDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridToolbarPinning");
            a.item("__tagNameWC", "String:igc-grid-toolbar-pinning");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            if (a.containsKey("__skipSuffix")) {
                a.removeItem("__skipSuffix");
            }
            a.item("__manageItemInMarkup", "Boolean");
        }
        static d(a) {
            WebGridToolbarPinningDescriptionMetadata.b(a);
            a.ae("WebGridToolbarPinning", () => new WebGridToolbarPinningDescription());
            a.ad("WebGridToolbarPinning", WebGridToolbarPinningDescriptionMetadata.a);
        }
    }
    WebGridToolbarPinningDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridToolbarPinningDescriptionMetadata, 'WebGridToolbarPinningDescriptionMetadata');
    WebGridToolbarPinningDescriptionMetadata.a = null;
    return WebGridToolbarPinningDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarAdvancedFilteringDescription = /*@__PURE__*/ (() => {
    class WebGridToolbarAdvancedFilteringDescription extends WebGridToolbarBaseActionDescription {
        get_type() {
            return "WebGridToolbarAdvancedFiltering";
        }
        constructor() {
            super();
            this.k = null;
            this.m = null;
        }
        get overlaySettings() {
            return this.k;
        }
        set overlaySettings(a) {
            this.k = a;
            this.g("OverlaySettings");
        }
        get name() {
            return this.m;
        }
        set name(a) {
            this.m = a;
            this.g("Name");
        }
    }
    WebGridToolbarAdvancedFilteringDescription.$t = /*@__PURE__*/ markType(WebGridToolbarAdvancedFilteringDescription, 'WebGridToolbarAdvancedFilteringDescription', WebGridToolbarBaseActionDescription.$);
    return WebGridToolbarAdvancedFilteringDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarAdvancedFilteringDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridToolbarAdvancedFilteringDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridToolbarAdvancedFilteringDescriptionMetadata.a == null) {
                WebGridToolbarAdvancedFilteringDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridToolbarAdvancedFilteringDescriptionMetadata.c(WebGridToolbarAdvancedFilteringDescriptionMetadata.a);
            }
            if (a.k(WebGridToolbarAdvancedFilteringDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridToolbarAdvancedFilteringDescriptionMetadata.a);
            WebOverlaySettingsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebGridToolbarBaseActionDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridToolbarAdvancedFiltering");
            a.item("__tagNameWC", "String:igc-grid-toolbar-advanced-filtering");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__portalChildrenWC", "Boolean");
            a.item("__manageItemInMarkup", "Boolean");
            a.item("OverlaySettings", "ExportedType:WebOverlaySettings");
            a.item("Name", "String");
        }
        static d(a) {
            WebGridToolbarAdvancedFilteringDescriptionMetadata.b(a);
            a.ae("WebGridToolbarAdvancedFiltering", () => new WebGridToolbarAdvancedFilteringDescription());
            a.ad("WebGridToolbarAdvancedFiltering", WebGridToolbarAdvancedFilteringDescriptionMetadata.a);
        }
    }
    WebGridToolbarAdvancedFilteringDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridToolbarAdvancedFilteringDescriptionMetadata, 'WebGridToolbarAdvancedFilteringDescriptionMetadata');
    WebGridToolbarAdvancedFilteringDescriptionMetadata.a = null;
    return WebGridToolbarAdvancedFilteringDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebForOfStateDetailDescription = /*@__PURE__*/ (() => {
    class WebForOfStateDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebForOfStateDetail";
        }
        constructor() {
            super();
            this.o = 0;
            this.n = 0;
        }
        get startIndex() {
            return this.o;
        }
        set startIndex(a) {
            this.o = a;
            this.g("StartIndex");
        }
        get chunkSize() {
            return this.n;
        }
        set chunkSize(a) {
            this.n = a;
            this.g("ChunkSize");
        }
    }
    WebForOfStateDetailDescription.$t = /*@__PURE__*/ markType(WebForOfStateDetailDescription, 'WebForOfStateDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebForOfStateDetailDescription.__marshalByValue1 = true;
    WebForOfStateDetailDescription.__marshalByValueAlias1 = "ForOfStateDetail";
    return WebForOfStateDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebForOfStateDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebForOfStateDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebForOfStateDetailDescriptionMetadata.a == null) {
                WebForOfStateDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebForOfStateDetailDescriptionMetadata.c(WebForOfStateDetailDescriptionMetadata.a);
            }
            if (a.k(WebForOfStateDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebForOfStateDetailDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ForOfStateDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("StartIndex", "Number:double");
            a.item("ChunkSize", "Number:double");
        }
        static d(a) {
            WebForOfStateDetailDescriptionMetadata.b(a);
            a.ae("WebForOfStateDetail", () => new WebForOfStateDetailDescription());
            a.ad("WebForOfStateDetail", WebForOfStateDetailDescriptionMetadata.a);
        }
    }
    WebForOfStateDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebForOfStateDetailDescriptionMetadata, 'WebForOfStateDetailDescriptionMetadata');
    WebForOfStateDetailDescriptionMetadata.a = null;
    return WebForOfStateDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebForOfStateEventArgsDescription = /*@__PURE__*/ (() => {
    class WebForOfStateEventArgsDescription extends Description {
        get_type() {
            return "WebForOfStateEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebForOfStateEventArgsDescription.$t = /*@__PURE__*/ markType(WebForOfStateEventArgsDescription, 'WebForOfStateEventArgsDescription', Description.$);
    WebForOfStateEventArgsDescription.__marshalByValue = true;
    WebForOfStateEventArgsDescription.__marshalByValueAlias = "ForOfStateEventArgs";
    return WebForOfStateEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebForOfStateEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebForOfStateEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebForOfStateEventArgsDescriptionMetadata.a == null) {
                WebForOfStateEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebForOfStateEventArgsDescriptionMetadata.c(WebForOfStateEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebForOfStateEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebForOfStateEventArgsDescriptionMetadata.a);
            WebForOfStateDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ForOfStateEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebForOfStateDetail");
        }
        static d(a) {
            WebForOfStateEventArgsDescriptionMetadata.b(a);
            a.ae("WebForOfStateEventArgs", () => new WebForOfStateEventArgsDescription());
            a.ad("WebForOfStateEventArgs", WebForOfStateEventArgsDescriptionMetadata.a);
        }
    }
    WebForOfStateEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebForOfStateEventArgsDescriptionMetadata, 'WebForOfStateEventArgsDescriptionMetadata');
    WebForOfStateEventArgsDescriptionMetadata.a = null;
    return WebForOfStateEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebHierarchicalGridBaseDirectiveDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebHierarchicalGridBaseDirectiveDescriptionMetadata extends Base {
        static b(a) {
            if (WebHierarchicalGridBaseDirectiveDescriptionMetadata.a == null) {
                WebHierarchicalGridBaseDirectiveDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebHierarchicalGridBaseDirectiveDescriptionMetadata.c(WebHierarchicalGridBaseDirectiveDescriptionMetadata.a);
            }
            if (a.k(WebHierarchicalGridBaseDirectiveDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebHierarchicalGridBaseDirectiveDescriptionMetadata.a);
            WebHierarchicalGridBaseDirectiveDescriptionMetadata.f(a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
            WebForOfStateEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebGridBaseDirectiveDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:HierarchicalGridBaseDirective");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("HasChildrenKey", "String");
            a.item("ShowExpandAll", "Boolean");
            a.item("RootGrid", "ExportedType:WebGridBaseDirective");
            a.item("DataPreLoadRef", "EventRef::dataPreLoad:customEvent");
            WebHierarchicalGridBaseDirectiveDescriptionMetadata.e(a);
        }
        static d(a) {
            WebHierarchicalGridBaseDirectiveDescriptionMetadata.b(a);
            a.ad("WebHierarchicalGridBaseDirective", WebHierarchicalGridBaseDirectiveDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__deferAttachWC", "Boolean");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
        }
        static f(a) {
            WebGridToolbarDescriptionMetadata.d(a);
            WebGridToolbarActionsDescriptionMetadata.d(a);
            WebGridToolbarTitleDescriptionMetadata.d(a);
            WebGridToolbarExporterDescriptionMetadata.d(a);
            WebGridToolbarHidingDescriptionMetadata.d(a);
            WebGridToolbarPinningDescriptionMetadata.d(a);
            WebGridToolbarAdvancedFilteringDescriptionMetadata.d(a);
            WebGridToolbarBaseActionDescriptionMetadata.d(a);
            WebGridToolbarContentDescriptionMetadata.d(a);
        }
    }
    WebHierarchicalGridBaseDirectiveDescriptionMetadata.$t = /*@__PURE__*/ markType(WebHierarchicalGridBaseDirectiveDescriptionMetadata, 'WebHierarchicalGridBaseDirectiveDescriptionMetadata');
    WebHierarchicalGridBaseDirectiveDescriptionMetadata.a = null;
    return WebHierarchicalGridBaseDirectiveDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebHierarchicalGridBaseDirectiveDescription = /*@__PURE__*/ (() => {
    class WebHierarchicalGridBaseDirectiveDescription extends WebGridBaseDirectiveDescription {
        get_type() {
            return "WebHierarchicalGridBaseDirective";
        }
        constructor() {
            super();
            this.gs = null;
            this.gp = false;
            this.gn = null;
            this.gr = null;
        }
        get hasChildrenKey() {
            return this.gs;
        }
        set hasChildrenKey(a) {
            this.gs = a;
            this.g("HasChildrenKey");
        }
        get showExpandAll() {
            return this.gp;
        }
        set showExpandAll(a) {
            this.gp = a;
            this.g("ShowExpandAll");
        }
        get rootGrid() {
            return this.gn;
        }
        set rootGrid(a) {
            this.gn = a;
            this.g("RootGrid");
        }
        get dataPreLoadRef() {
            return this.gr;
        }
        set dataPreLoadRef(a) {
            this.gr = a;
            this.g("DataPreLoadRef");
        }
    }
    WebHierarchicalGridBaseDirectiveDescription.$t = /*@__PURE__*/ markType(WebHierarchicalGridBaseDirectiveDescription, 'WebHierarchicalGridBaseDirectiveDescription', WebGridBaseDirectiveDescription.$);
    return WebHierarchicalGridBaseDirectiveDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebHierarchicalGridDescription = /*@__PURE__*/ (() => {
    class WebHierarchicalGridDescription extends WebHierarchicalGridBaseDirectiveDescription {
        get_type() {
            return "WebHierarchicalGrid";
        }
        constructor() {
            super();
            this.gv = null;
            this.g2 = null;
            this.g1 = null;
            this.gz = 0;
            this.gx = false;
        }
        get childLayoutList() {
            return this.gv;
        }
        set childLayoutList(a) {
            this.gv = a;
            this.g("ChildLayoutList");
        }
        get id() {
            return this.g2;
        }
        set id(a) {
            this.g2 = a;
            this.g("Id");
        }
        get dataRef() {
            return this.g1;
        }
        set dataRef(a) {
            this.g1 = a;
            this.g("DataRef");
        }
        get totalItemCount() {
            return this.gz;
        }
        set totalItemCount(a) {
            this.gz = a;
            this.g("TotalItemCount");
        }
        get expandChildren() {
            return this.gx;
        }
        set expandChildren(a) {
            this.gx = a;
            this.g("ExpandChildren");
        }
    }
    WebHierarchicalGridDescription.$t = /*@__PURE__*/ markType(WebHierarchicalGridDescription, 'WebHierarchicalGridDescription', WebHierarchicalGridBaseDirectiveDescription.$);
    return WebHierarchicalGridDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebHierarchicalGridDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebHierarchicalGridDescriptionMetadata extends Base {
        static b(a) {
            if (WebHierarchicalGridDescriptionMetadata.a == null) {
                WebHierarchicalGridDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebHierarchicalGridDescriptionMetadata.c(WebHierarchicalGridDescriptionMetadata.a);
            }
            if (a.k(WebHierarchicalGridDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebHierarchicalGridDescriptionMetadata.a);
            WebHierarchicalGridDescriptionMetadata.f(a);
        }
        static c(a) {
            WebHierarchicalGridBaseDirectiveDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:HierarchicalGrid");
            a.item("__tagNameWC", "String:igc-hierarchical-grid");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            if (a.containsKey("__skipSuffix")) {
                a.removeItem("__skipSuffix");
            }
            a.item("ChildLayoutList", "Collection:WebRowIsland:RowIslandCollection:WebRowIsland");
            a.item("ChildLayoutList@ngQueryList", "childLayoutList");
            a.item("Id", "String");
            a.item("DataRef", "(w:Data,wf:Data)DataRef::object");
            a.item("TotalItemCount", "Number:double");
            a.item("ExpandChildren", "Boolean");
            WebHierarchicalGridDescriptionMetadata.e(a);
        }
        static d(a) {
            WebHierarchicalGridDescriptionMetadata.b(a);
            a.ae("WebHierarchicalGrid", () => new WebHierarchicalGridDescription());
            a.ad("WebHierarchicalGrid", WebHierarchicalGridDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__deferAttachWC", "Boolean");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
        }
        static f(a) {
            WebGridToolbarDescriptionMetadata.d(a);
            WebGridToolbarActionsDescriptionMetadata.d(a);
            WebGridToolbarTitleDescriptionMetadata.d(a);
            WebGridToolbarExporterDescriptionMetadata.d(a);
            WebGridToolbarHidingDescriptionMetadata.d(a);
            WebGridToolbarPinningDescriptionMetadata.d(a);
            WebGridToolbarAdvancedFilteringDescriptionMetadata.d(a);
            WebGridToolbarBaseActionDescriptionMetadata.d(a);
            WebGridToolbarContentDescriptionMetadata.d(a);
        }
    }
    WebHierarchicalGridDescriptionMetadata.$t = /*@__PURE__*/ markType(WebHierarchicalGridDescriptionMetadata, 'WebHierarchicalGridDescriptionMetadata');
    WebHierarchicalGridDescriptionMetadata.a = null;
    return WebHierarchicalGridDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridCreatedEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebGridCreatedEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebGridCreatedEventArgsDetail";
        }
        constructor() {
            super();
            this.o = null;
            this.r = null;
            this.m = null;
        }
        get owner() {
            return this.o;
        }
        set owner(a) {
            this.o = a;
            this.g("Owner");
        }
        get parentID() {
            return this.r;
        }
        set parentID(a) {
            this.r = a;
            this.g("ParentID");
        }
        get grid() {
            return this.m;
        }
        set grid(a) {
            this.m = a;
            this.g("Grid");
        }
    }
    WebGridCreatedEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebGridCreatedEventArgsDetailDescription, 'WebGridCreatedEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebGridCreatedEventArgsDetailDescription.__marshalByValue1 = true;
    WebGridCreatedEventArgsDetailDescription.__marshalByValueAlias1 = "GridCreatedEventArgsDetail";
    return WebGridCreatedEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowIslandDescription = /*@__PURE__*/ (() => {
    class WebRowIslandDescription extends Description {
        get_type() {
            return "WebRowIsland";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.bw = null;
            this.j = null;
            this.h = null;
            this.ar = false;
            this.cw = null;
            this.az = false;
            this.aq = false;
            this.bg = 0;
            this.ap = false;
            this.i = null;
            this.au = false;
            this.cj = null;
            this.bo = null;
            this.c1 = null;
            this.bh = 0;
            this.x = null;
            this.v = null;
            this.db = null;
            this.dv = null;
            this.c5 = null;
            this.k = null;
            this.cf = null;
            this.dn = null;
            this.da = null;
            this.dj = null;
            this.dp = null;
            this.dd = null;
            this.cy = null;
            this.cx = null;
            this.ck = null;
            this.dz = null;
            this.d0 = null;
            this.d1 = null;
            this.n = null;
            this.l = null;
            this.af = null;
            this.co = null;
            this.aa = null;
            this.z = null;
            this.c2 = null;
            this.c4 = null;
            this.as = false;
            this.av = false;
            this.d9 = null;
            this.aw = false;
            this.c0 = null;
            this.ea = null;
            this.bf = 0;
            this.b9 = null;
            this.ci = null;
            this.at = false;
            this.ay = false;
            this.ch = null;
            this.aj = null;
            this.ao = false;
            this.an = false;
            this.cp = null;
            this.d6 = null;
            this.d5 = null;
            this.a0 = false;
            this.ad = null;
            this.ah = null;
            this.al = null;
            this.dy = null;
            this.cz = null;
            this.du = null;
            this.cg = null;
            this.m = null;
            this.bv = null;
            this.ds = null;
            this.b5 = null;
            this.bi = 0;
            this.ax = false;
            this.c3 = null;
            this.cs = null;
            this.ct = null;
            this.cd = null;
            this.cn = null;
            this.bp = null;
            this.cv = null;
            this.bq = null;
            this.dc = null;
            this.cq = null;
            this.d8 = null;
            this.dx = null;
            this.dt = null;
            this.b6 = null;
            this.b1 = null;
            this.b2 = null;
            this.bt = null;
            this.bu = null;
            this.br = null;
            this.bs = null;
            this.dl = null;
            this.di = null;
            this.dk = null;
            this.dm = null;
            this.bx = null;
            this.b4 = null;
            this.d2 = null;
            this.d3 = null;
            this.cl = null;
            this.cm = null;
            this.c9 = null;
            this.df = null;
            this.de = null;
            this.c8 = null;
            this.b3 = null;
            this.ca = null;
            this.ce = null;
            this.b8 = null;
            this.b7 = null;
            this.b0 = null;
            this.by = null;
            this.bz = null;
            this.cu = null;
            this.dh = null;
            this.dg = null;
            this.cr = null;
            this.dw = null;
            this.dr = null;
            this.dq = null;
            this.bn = null;
            this.d4 = null;
            this.d7 = null;
            this.c6 = null;
            this.c7 = null;
            this.cc = null;
            this.cb = null;
        }
        get childDataKey() {
            return this.bw;
        }
        set childDataKey(a) {
            this.bw = a;
            this.g("ChildDataKey");
        }
        get childLayoutList() {
            return this.j;
        }
        set childLayoutList(a) {
            this.j = a;
            this.g("ChildLayoutList");
        }
        get actionStripComponents() {
            return this.h;
        }
        set actionStripComponents(a) {
            this.h = a;
            this.g("ActionStripComponents");
        }
        get expandChildren() {
            return this.ar;
        }
        set expandChildren(a) {
            this.ar = a;
            this.g("ExpandChildren");
        }
        get hasChildrenKey() {
            return this.cw;
        }
        set hasChildrenKey(a) {
            this.cw = a;
            this.g("HasChildrenKey");
        }
        get showExpandAll() {
            return this.az;
        }
        set showExpandAll(a) {
            this.az = a;
            this.g("ShowExpandAll");
        }
        get batchEditing() {
            return this.aq;
        }
        set batchEditing(a) {
            this.aq = a;
            this.g("BatchEditing");
        }
        get snackbarDisplayTime() {
            return this.bg;
        }
        set snackbarDisplayTime(a) {
            this.bg = a;
            this.g("SnackbarDisplayTime");
        }
        get autoGenerate() {
            return this.ap;
        }
        set autoGenerate(a) {
            this.ap = a;
            this.g("AutoGenerate");
        }
        get autoGenerateExclude() {
            return this.i;
        }
        set autoGenerateExclude(a) {
            this.i = a;
            this.g("AutoGenerateExclude");
        }
        get moving() {
            return this.au;
        }
        set moving(a) {
            this.au = a;
            this.g("Moving");
        }
        get emptyGridTemplateRef() {
            return this.cj;
        }
        set emptyGridTemplateRef(a) {
            this.cj = a;
            this.g("EmptyGridTemplateRef");
        }
        get addRowEmptyTemplateRef() {
            return this.bo;
        }
        set addRowEmptyTemplateRef(a) {
            this.bo = a;
            this.g("AddRowEmptyTemplateRef");
        }
        get loadingGridTemplateRef() {
            return this.c1;
        }
        set loadingGridTemplateRef(a) {
            this.c1 = a;
            this.g("LoadingGridTemplateRef");
        }
        get summaryRowHeight() {
            return this.bh;
        }
        set summaryRowHeight(a) {
            this.bh = a;
            this.g("SummaryRowHeight");
        }
        get dataCloneStrategy() {
            return this.x;
        }
        set dataCloneStrategy(a) {
            this.x = a;
            this.g("DataCloneStrategy");
        }
        get clipboardOptions() {
            return this.v;
        }
        set clipboardOptions(a) {
            this.v = a;
            this.g("ClipboardOptions");
        }
        get rowClassesRef() {
            return this.db;
        }
        set rowClassesRef(a) {
            this.db = a;
            this.g("RowClassesRef");
        }
        get rowStylesRef() {
            return this.dv;
        }
        set rowStylesRef(a) {
            this.dv = a;
            this.g("RowStylesRef");
        }
        get primaryKey() {
            return this.c5;
        }
        set primaryKey(a) {
            this.c5 = a;
            this.g("PrimaryKey");
        }
        get columnList() {
            return this.k;
        }
        set columnList(a) {
            this.k = a;
            this.g("ColumnList");
        }
        get dragGhostCustomTemplateRef() {
            return this.cf;
        }
        set dragGhostCustomTemplateRef(a) {
            this.cf = a;
            this.g("DragGhostCustomTemplateRef");
        }
        get rowEditTextTemplateRef() {
            return this.dn;
        }
        set rowEditTextTemplateRef(a) {
            this.dn = a;
            this.g("RowEditTextTemplateRef");
        }
        get rowAddTextTemplateRef() {
            return this.da;
        }
        set rowAddTextTemplateRef(a) {
            this.da = a;
            this.g("RowAddTextTemplateRef");
        }
        get rowEditActionsTemplateRef() {
            return this.dj;
        }
        set rowEditActionsTemplateRef(a) {
            this.dj = a;
            this.g("RowEditActionsTemplateRef");
        }
        get rowExpandedIndicatorTemplateRef() {
            return this.dp;
        }
        set rowExpandedIndicatorTemplateRef(a) {
            this.dp = a;
            this.g("RowExpandedIndicatorTemplateRef");
        }
        get rowCollapsedIndicatorTemplateRef() {
            return this.dd;
        }
        set rowCollapsedIndicatorTemplateRef(a) {
            this.dd = a;
            this.g("RowCollapsedIndicatorTemplateRef");
        }
        get headerExpandedIndicatorTemplateRef() {
            return this.cy;
        }
        set headerExpandedIndicatorTemplateRef(a) {
            this.cy = a;
            this.g("HeaderExpandedIndicatorTemplateRef");
        }
        get headerCollapsedIndicatorTemplateRef() {
            return this.cx;
        }
        set headerCollapsedIndicatorTemplateRef(a) {
            this.cx = a;
            this.g("HeaderCollapsedIndicatorTemplateRef");
        }
        get excelStyleHeaderIconTemplateRef() {
            return this.ck;
        }
        set excelStyleHeaderIconTemplateRef(a) {
            this.ck = a;
            this.g("ExcelStyleHeaderIconTemplateRef");
        }
        get sortAscendingHeaderIconTemplateRef() {
            return this.dz;
        }
        set sortAscendingHeaderIconTemplateRef(a) {
            this.dz = a;
            this.g("SortAscendingHeaderIconTemplateRef");
        }
        get sortDescendingHeaderIconTemplateRef() {
            return this.d0;
        }
        set sortDescendingHeaderIconTemplateRef(a) {
            this.d0 = a;
            this.g("SortDescendingHeaderIconTemplateRef");
        }
        get sortHeaderIconTemplateRef() {
            return this.d1;
        }
        set sortHeaderIconTemplateRef(a) {
            this.d1 = a;
            this.g("SortHeaderIconTemplateRef");
        }
        get toolbar() {
            return this.n;
        }
        set toolbar(a) {
            this.n = a;
            this.g("Toolbar");
        }
        get paginationComponents() {
            return this.l;
        }
        set paginationComponents(a) {
            this.l = a;
            this.g("PaginationComponents");
        }
        get resourceStrings() {
            return this.af;
        }
        set resourceStrings(a) {
            this.af = a;
            this.g("ResourceStrings");
        }
        get filteringLogic() {
            return this.co;
        }
        set filteringLogic(a) {
            this.co = a;
            this.g("FilteringLogic");
        }
        get filteringExpressionsTree() {
            return this.aa;
        }
        set filteringExpressionsTree(a) {
            this.aa = a;
            this.g("FilteringExpressionsTree");
        }
        get advancedFilteringExpressionsTree() {
            return this.z;
        }
        set advancedFilteringExpressionsTree(a) {
            this.z = a;
            this.g("AdvancedFilteringExpressionsTree");
        }
        get locale() {
            return this.c2;
        }
        set locale(a) {
            this.c2 = a;
            this.g("Locale");
        }
        get pagingMode() {
            return this.c4;
        }
        set pagingMode(a) {
            this.c4 = a;
            this.g("PagingMode");
        }
        get hideRowSelectors() {
            return this.as;
        }
        set hideRowSelectors(a) {
            this.as = a;
            this.g("HideRowSelectors");
        }
        get rowDraggable() {
            return this.av;
        }
        set rowDraggable(a) {
            this.av = a;
            this.g("RowDraggable");
        }
        get validationTrigger() {
            return this.d9;
        }
        set validationTrigger(a) {
            this.d9 = a;
            this.g("ValidationTrigger");
        }
        get rowEditable() {
            return this.aw;
        }
        set rowEditable(a) {
            this.aw = a;
            this.g("RowEditable");
        }
        get height() {
            return this.c0;
        }
        set height(a) {
            this.c0 = a;
            this.g("Height");
        }
        get width() {
            return this.ea;
        }
        set width(a) {
            this.ea = a;
            this.g("Width");
        }
        get rowHeight() {
            return this.bf;
        }
        set rowHeight(a) {
            this.bf = a;
            this.g("RowHeight");
        }
        get columnWidth() {
            return this.b9;
        }
        set columnWidth(a) {
            this.b9 = a;
            this.g("ColumnWidth");
        }
        get emptyGridMessage() {
            return this.ci;
        }
        set emptyGridMessage(a) {
            this.ci = a;
            this.g("EmptyGridMessage");
        }
        get isLoading() {
            return this.at;
        }
        set isLoading(a) {
            this.at = a;
            this.g("IsLoading");
        }
        get shouldGenerate() {
            return this.ay;
        }
        set shouldGenerate(a) {
            this.ay = a;
            this.g("ShouldGenerate");
        }
        get emptyFilteredGridMessage() {
            return this.ch;
        }
        set emptyFilteredGridMessage(a) {
            this.ch = a;
            this.g("EmptyFilteredGridMessage");
        }
        get pinning() {
            return this.aj;
        }
        set pinning(a) {
            this.aj = a;
            this.g("Pinning");
        }
        get allowFiltering() {
            return this.ao;
        }
        set allowFiltering(a) {
            this.ao = a;
            this.g("AllowFiltering");
        }
        get allowAdvancedFiltering() {
            return this.an;
        }
        set allowAdvancedFiltering(a) {
            this.an = a;
            this.g("AllowAdvancedFiltering");
        }
        get filterMode() {
            return this.cp;
        }
        set filterMode(a) {
            this.cp = a;
            this.g("FilterMode");
        }
        get summaryPosition() {
            return this.d6;
        }
        set summaryPosition(a) {
            this.d6 = a;
            this.g("SummaryPosition");
        }
        get summaryCalculationMode() {
            return this.d5;
        }
        set summaryCalculationMode(a) {
            this.d5 = a;
            this.g("SummaryCalculationMode");
        }
        get showSummaryOnCollapse() {
            return this.a0;
        }
        set showSummaryOnCollapse(a) {
            this.a0 = a;
            this.g("ShowSummaryOnCollapse");
        }
        get filterStrategy() {
            return this.ad;
        }
        set filterStrategy(a) {
            this.ad = a;
            this.g("FilterStrategy");
        }
        get sortStrategy() {
            return this.ah;
        }
        set sortStrategy(a) {
            this.ah = a;
            this.g("SortStrategy");
        }
        get sortingOptions() {
            return this.al;
        }
        set sortingOptions(a) {
            this.al = a;
            this.g("SortingOptions");
        }
        get selectedRowsRef() {
            return this.dy;
        }
        set selectedRowsRef(a) {
            this.dy = a;
            this.g("SelectedRowsRef");
        }
        get headSelectorTemplateRef() {
            return this.cz;
        }
        set headSelectorTemplateRef(a) {
            this.cz = a;
            this.g("HeadSelectorTemplateRef");
        }
        get rowSelectorTemplateRef() {
            return this.du;
        }
        set rowSelectorTemplateRef(a) {
            this.du = a;
            this.g("RowSelectorTemplateRef");
        }
        get dragIndicatorIconTemplateRef() {
            return this.cg;
        }
        set dragIndicatorIconTemplateRef(a) {
            this.cg = a;
            this.g("DragIndicatorIconTemplateRef");
        }
        get sortingExpressions() {
            return this.m;
        }
        set sortingExpressions(a) {
            this.m = a;
            this.g("SortingExpressions");
        }
        get cellSelection() {
            return this.bv;
        }
        set cellSelection(a) {
            this.bv = a;
            this.g("CellSelection");
        }
        get rowSelection() {
            return this.ds;
        }
        set rowSelection(a) {
            this.ds = a;
            this.g("RowSelection");
        }
        get columnSelection() {
            return this.b5;
        }
        set columnSelection(a) {
            this.b5 = a;
            this.g("ColumnSelection");
        }
        get totalRecords() {
            return this.bi;
        }
        set totalRecords(a) {
            this.bi = a;
            this.g("TotalRecords");
        }
        get selectRowOnClick() {
            return this.ax;
        }
        set selectRowOnClick(a) {
            this.ax = a;
            this.g("SelectRowOnClick");
        }
        get name() {
            return this.c3;
        }
        set name(a) {
            this.c3 = a;
            this.g("Name");
        }
        get gridCreatedRef() {
            return this.cs;
        }
        set gridCreatedRef(a) {
            this.cs = a;
            this.g("GridCreatedRef");
        }
        get gridInitializedRef() {
            return this.ct;
        }
        set gridInitializedRef(a) {
            this.ct = a;
            this.g("GridInitializedRef");
        }
        get dataPreLoadRef() {
            return this.cd;
        }
        set dataPreLoadRef(a) {
            this.cd = a;
            this.g("DataPreLoadRef");
        }
        get filteringExpressionsTreeChangeRef() {
            return this.cn;
        }
        set filteringExpressionsTreeChangeRef(a) {
            this.cn = a;
            this.g("FilteringExpressionsTreeChangeRef");
        }
        get advancedFilteringExpressionsTreeChangeRef() {
            return this.bp;
        }
        set advancedFilteringExpressionsTreeChangeRef(a) {
            this.bp = a;
            this.g("AdvancedFilteringExpressionsTreeChangeRef");
        }
        get gridScrollRef() {
            return this.cv;
        }
        set gridScrollRef(a) {
            this.cv = a;
            this.g("GridScrollRef");
        }
        get cellClickRef() {
            return this.bq;
        }
        set cellClickRef(a) {
            this.bq = a;
            this.g("CellClickRef");
        }
        get rowClickRef() {
            return this.dc;
        }
        set rowClickRef(a) {
            this.dc = a;
            this.g("RowClickRef");
        }
        get formGroupCreatedRef() {
            return this.cq;
        }
        set formGroupCreatedRef(a) {
            this.cq = a;
            this.g("FormGroupCreatedRef");
        }
        get validationStatusChangeRef() {
            return this.d8;
        }
        set validationStatusChangeRef(a) {
            this.d8 = a;
            this.g("ValidationStatusChangeRef");
        }
        get selectedRef() {
            return this.dx;
        }
        set selectedRef(a) {
            this.dx = a;
            this.g("SelectedRef");
        }
        get rowSelectionChangingRef() {
            return this.dt;
        }
        set rowSelectionChangingRef(a) {
            this.dt = a;
            this.g("RowSelectionChangingRef");
        }
        get columnSelectionChangingRef() {
            return this.b6;
        }
        set columnSelectionChangingRef(a) {
            this.b6 = a;
            this.g("ColumnSelectionChangingRef");
        }
        get columnPinRef() {
            return this.b1;
        }
        set columnPinRef(a) {
            this.b1 = a;
            this.g("ColumnPinRef");
        }
        get columnPinnedRef() {
            return this.b2;
        }
        set columnPinnedRef(a) {
            this.b2 = a;
            this.g("ColumnPinnedRef");
        }
        get cellEditEnterRef() {
            return this.bt;
        }
        set cellEditEnterRef(a) {
            this.bt = a;
            this.g("CellEditEnterRef");
        }
        get cellEditExitRef() {
            return this.bu;
        }
        set cellEditExitRef(a) {
            this.bu = a;
            this.g("CellEditExitRef");
        }
        get cellEditRef() {
            return this.br;
        }
        set cellEditRef(a) {
            this.br = a;
            this.g("CellEditRef");
        }
        get cellEditDoneRef() {
            return this.bs;
        }
        set cellEditDoneRef(a) {
            this.bs = a;
            this.g("CellEditDoneRef");
        }
        get rowEditEnterRef() {
            return this.dl;
        }
        set rowEditEnterRef(a) {
            this.dl = a;
            this.g("RowEditEnterRef");
        }
        get rowEditRef() {
            return this.di;
        }
        set rowEditRef(a) {
            this.di = a;
            this.g("RowEditRef");
        }
        get rowEditDoneRef() {
            return this.dk;
        }
        set rowEditDoneRef(a) {
            this.dk = a;
            this.g("RowEditDoneRef");
        }
        get rowEditExitRef() {
            return this.dm;
        }
        set rowEditExitRef(a) {
            this.dm = a;
            this.g("RowEditExitRef");
        }
        get columnInitRef() {
            return this.bx;
        }
        set columnInitRef(a) {
            this.bx = a;
            this.g("ColumnInitRef");
        }
        get columnsAutogeneratedRef() {
            return this.b4;
        }
        set columnsAutogeneratedRef(a) {
            this.b4 = a;
            this.g("ColumnsAutogeneratedRef");
        }
        get sortingRef() {
            return this.d2;
        }
        set sortingRef(a) {
            this.d2 = a;
            this.g("SortingRef");
        }
        get sortingDoneRef() {
            return this.d3;
        }
        set sortingDoneRef(a) {
            this.d3 = a;
            this.g("SortingDoneRef");
        }
        get filteringRef() {
            return this.cl;
        }
        set filteringRef(a) {
            this.cl = a;
            this.g("FilteringRef");
        }
        get filteringDoneRef() {
            return this.cm;
        }
        set filteringDoneRef(a) {
            this.cm = a;
            this.g("FilteringDoneRef");
        }
        get rowAddedRef() {
            return this.c9;
        }
        set rowAddedRef(a) {
            this.c9 = a;
            this.g("RowAddedRef");
        }
        get rowDeletedRef() {
            return this.df;
        }
        set rowDeletedRef(a) {
            this.df = a;
            this.g("RowDeletedRef");
        }
        get rowDeleteRef() {
            return this.de;
        }
        set rowDeleteRef(a) {
            this.de = a;
            this.g("RowDeleteRef");
        }
        get rowAddRef() {
            return this.c8;
        }
        set rowAddRef(a) {
            this.c8 = a;
            this.g("RowAddRef");
        }
        get columnResizedRef() {
            return this.b3;
        }
        set columnResizedRef(a) {
            this.b3 = a;
            this.g("ColumnResizedRef");
        }
        get contextMenuRef() {
            return this.ca;
        }
        set contextMenuRef(a) {
            this.ca = a;
            this.g("ContextMenuRef");
        }
        get doubleClickRef() {
            return this.ce;
        }
        set doubleClickRef(a) {
            this.ce = a;
            this.g("DoubleClickRef");
        }
        get columnVisibilityChangingRef() {
            return this.b8;
        }
        set columnVisibilityChangingRef(a) {
            this.b8 = a;
            this.g("ColumnVisibilityChangingRef");
        }
        get columnVisibilityChangedRef() {
            return this.b7;
        }
        set columnVisibilityChangedRef(a) {
            this.b7 = a;
            this.g("ColumnVisibilityChangedRef");
        }
        get columnMovingStartRef() {
            return this.b0;
        }
        set columnMovingStartRef(a) {
            this.b0 = a;
            this.g("ColumnMovingStartRef");
        }
        get columnMovingRef() {
            return this.by;
        }
        set columnMovingRef(a) {
            this.by = a;
            this.g("ColumnMovingRef");
        }
        get columnMovingEndRef() {
            return this.bz;
        }
        set columnMovingEndRef(a) {
            this.bz = a;
            this.g("ColumnMovingEndRef");
        }
        get gridKeydownRef() {
            return this.cu;
        }
        set gridKeydownRef(a) {
            this.cu = a;
            this.g("GridKeydownRef");
        }
        get rowDragStartRef() {
            return this.dh;
        }
        set rowDragStartRef(a) {
            this.dh = a;
            this.g("RowDragStartRef");
        }
        get rowDragEndRef() {
            return this.dg;
        }
        set rowDragEndRef(a) {
            this.dg = a;
            this.g("RowDragEndRef");
        }
        get gridCopyRef() {
            return this.cr;
        }
        set gridCopyRef(a) {
            this.cr = a;
            this.g("GridCopyRef");
        }
        get rowToggleRef() {
            return this.dw;
        }
        set rowToggleRef(a) {
            this.dw = a;
            this.g("RowToggleRef");
        }
        get rowPinningRef() {
            return this.dr;
        }
        set rowPinningRef(a) {
            this.dr = a;
            this.g("RowPinningRef");
        }
        get rowPinnedRef() {
            return this.dq;
        }
        set rowPinnedRef(a) {
            this.dq = a;
            this.g("RowPinnedRef");
        }
        get activeNodeChangeRef() {
            return this.bn;
        }
        set activeNodeChangeRef(a) {
            this.bn = a;
            this.g("ActiveNodeChangeRef");
        }
        get sortingExpressionsChangeRef() {
            return this.d4;
        }
        set sortingExpressionsChangeRef(a) {
            this.d4 = a;
            this.g("SortingExpressionsChangeRef");
        }
        get toolbarExportingRef() {
            return this.d7;
        }
        set toolbarExportingRef(a) {
            this.d7 = a;
            this.g("ToolbarExportingRef");
        }
        get rangeSelectedRef() {
            return this.c6;
        }
        set rangeSelectedRef(a) {
            this.c6 = a;
            this.g("RangeSelectedRef");
        }
        get renderedRef() {
            return this.c7;
        }
        set renderedRef(a) {
            this.c7 = a;
            this.g("RenderedRef");
        }
        get dataChangingRef() {
            return this.cc;
        }
        set dataChangingRef(a) {
            this.cc = a;
            this.g("DataChangingRef");
        }
        get dataChangedRef() {
            return this.cb;
        }
        set dataChangedRef(a) {
            this.cb = a;
            this.g("DataChangedRef");
        }
    }
    WebRowIslandDescription.$t = /*@__PURE__*/ markType(WebRowIslandDescription, 'WebRowIslandDescription', Description.$);
    return WebRowIslandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridCreatedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridCreatedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridCreatedEventArgsDescriptionMetadata.a == null) {
                WebGridCreatedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridCreatedEventArgsDescriptionMetadata.c(WebGridCreatedEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGridCreatedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridCreatedEventArgsDescriptionMetadata.a);
            WebGridCreatedEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridCreatedEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebGridCreatedEventArgsDetail");
        }
        static d(a) {
            WebGridCreatedEventArgsDescriptionMetadata.b(a);
            a.ae("WebGridCreatedEventArgs", () => new WebGridCreatedEventArgsDescription());
            a.ad("WebGridCreatedEventArgs", WebGridCreatedEventArgsDescriptionMetadata.a);
        }
    }
    WebGridCreatedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridCreatedEventArgsDescriptionMetadata, 'WebGridCreatedEventArgsDescriptionMetadata');
    WebGridCreatedEventArgsDescriptionMetadata.a = null;
    return WebGridCreatedEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridCreatedEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridCreatedEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridCreatedEventArgsDetailDescriptionMetadata.a == null) {
                WebGridCreatedEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridCreatedEventArgsDetailDescriptionMetadata.c(WebGridCreatedEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebGridCreatedEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridCreatedEventArgsDetailDescriptionMetadata.a);
            WebRowIslandDescriptionMetadata.d(a);
            WebHierarchicalGridDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridCreatedEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Owner", "ExportedType:WebRowIsland");
            a.item("ParentID", "Unknown");
            a.item("Grid", "ExportedType:WebHierarchicalGrid");
        }
        static d(a) {
            WebGridCreatedEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebGridCreatedEventArgsDetail", () => new WebGridCreatedEventArgsDetailDescription());
            a.ad("WebGridCreatedEventArgsDetail", WebGridCreatedEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebGridCreatedEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridCreatedEventArgsDetailDescriptionMetadata, 'WebGridCreatedEventArgsDetailDescriptionMetadata');
    WebGridCreatedEventArgsDetailDescriptionMetadata.a = null;
    return WebGridCreatedEventArgsDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebRowIslandDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowIslandDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowIslandDescriptionMetadata.a == null) {
                WebRowIslandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowIslandDescriptionMetadata.c(WebRowIslandDescriptionMetadata.a);
            }
            if (a.k(WebRowIslandDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowIslandDescriptionMetadata.a);
            WebDataCloneStrategyDescriptionMetadata.d(a);
            WebClipboardOptionsDescriptionMetadata.d(a);
            WebGridResourceStringsDescriptionMetadata.d(a);
            WebFilteringExpressionsTreeDescriptionMetadata.d(a);
            WebPinningConfigDescriptionMetadata.d(a);
            WebFilteringStrategyDescriptionMetadata.d(a);
            WebGridSortingStrategyDescriptionMetadata.d(a);
            WebSortingOptionsDescriptionMetadata.d(a);
            WebSortingExpressionDescriptionMetadata.d(a);
            WebGridCreatedEventArgsDescriptionMetadata.d(a);
            WebForOfStateEventArgsDescriptionMetadata.d(a);
            WebFilteringExpressionsTreeEventArgsDescriptionMetadata.d(a);
            WebGridScrollEventArgsDescriptionMetadata.d(a);
            WebGridCellEventArgsDescriptionMetadata.d(a);
            WebGridRowEventArgsDescriptionMetadata.d(a);
            WebGridFormGroupCreatedEventArgsDescriptionMetadata.d(a);
            WebGridValidationStatusEventArgsDescriptionMetadata.d(a);
            WebRowSelectionEventArgsDescriptionMetadata.d(a);
            WebColumnSelectionEventArgsDescriptionMetadata.d(a);
            WebPinColumnCancellableEventArgsDescriptionMetadata.d(a);
            WebPinColumnEventArgsDescriptionMetadata.d(a);
            WebGridEditEventArgsDescriptionMetadata.d(a);
            WebGridEditDoneEventArgsDescriptionMetadata.d(a);
            WebColumnComponentEventArgsDescriptionMetadata.d(a);
            WebColumnsAutoGeneratedEventArgsDescriptionMetadata.d(a);
            WebSortingEventArgsDescriptionMetadata.d(a);
            WebSortingExpressionEventArgsDescriptionMetadata.d(a);
            WebFilteringEventArgsDescriptionMetadata.d(a);
            WebRowDataEventArgsDescriptionMetadata.d(a);
            WebRowDataCancelableEventArgsDescriptionMetadata.d(a);
            WebColumnResizeEventArgsDescriptionMetadata.d(a);
            WebGridContextMenuEventArgsDescriptionMetadata.d(a);
            WebColumnVisibilityChangingEventArgsDescriptionMetadata.d(a);
            WebColumnVisibilityChangedEventArgsDescriptionMetadata.d(a);
            WebColumnMovingStartEventArgsDescriptionMetadata.d(a);
            WebColumnMovingEventArgsDescriptionMetadata.d(a);
            WebColumnMovingEndEventArgsDescriptionMetadata.d(a);
            WebGridKeydownEventArgsDescriptionMetadata.d(a);
            WebRowDragStartEventArgsDescriptionMetadata.d(a);
            WebRowDragEndEventArgsDescriptionMetadata.d(a);
            WebGridClipboardEventEventArgsDescriptionMetadata.d(a);
            WebRowToggleEventArgsDescriptionMetadata.d(a);
            WebPinRowEventArgsDescriptionMetadata.d(a);
            WebActiveNodeChangeEventArgsDescriptionMetadata.d(a);
            WebGridToolbarExportEventArgsDescriptionMetadata.d(a);
            WebGridSelectionRangeEventArgsDescriptionMetadata.d(a);
            VoidEventArgsDescriptionMetadata.d(a);
            WebForOfDataChangingEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowIsland");
            a.item("__tagNameWC", "String:igc-row-island");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__manageCollectionInMarkup", "Boolean");
            a.item("__manageItemInMarkup", "Boolean");
            a.item("__mustUseNGParentAnchor", "Boolean");
            a.item("ChildDataKey", "String");
            a.item("ChildLayoutList", "Collection:WebRowIsland:RowIslandCollection:WebRowIsland");
            a.item("ActionStripComponents", "Collection:WebActionStrip:ActionStripCollection:WebActionStrip");
            a.item("ActionStripComponents@ngQueryList", "actionStripComponents");
            a.item("ExpandChildren", "Boolean");
            a.item("HasChildrenKey", "String");
            a.item("ShowExpandAll", "Boolean");
            a.item("BatchEditing", "Boolean");
            a.item("SnackbarDisplayTime", "Number:double");
            a.item("AutoGenerate", "Boolean");
            a.item("AutoGenerateExclude", "Array:string");
            a.item("Moving", "Boolean");
            a.item("EmptyGridTemplateRef", "(w:EmptyGridTemplate,wf:EmptyGridTemplate)TemplateRef::object");
            a.item("AddRowEmptyTemplateRef", "(w:AddRowEmptyTemplate,wf:AddRowEmptyTemplate)TemplateRef::object");
            a.item("LoadingGridTemplateRef", "(w:LoadingGridTemplate,wf:LoadingGridTemplate)TemplateRef::object");
            a.item("SummaryRowHeight", "Number:double");
            a.item("DataCloneStrategy", "ExportedType:WebDataCloneStrategy");
            a.item("ClipboardOptions", "ExportedType:WebClipboardOptions");
            a.item("RowClassesRef", "(w:RowClasses,wf:RowClasses)DataRef::object");
            a.item("RowStylesRef", "(w:RowStyles,wf:RowStyles)DataRef::object");
            a.item("PrimaryKey", "String");
            a.item("ColumnList", "Collection:WebColumn:ColumnCollection:WebColumn");
            a.item("ColumnList@ngQueryList", "columnList");
            a.item("DragGhostCustomTemplateRef", "(w:DragGhostCustomTemplate,wf:DragGhostCustomTemplate)TemplateRef::object");
            a.item("RowEditTextTemplateRef", "(w:RowEditTextTemplate,wf:RowEditTextTemplate)TemplateRef::object");
            a.item("RowAddTextTemplateRef", "(w:RowAddTextTemplate,wf:RowAddTextTemplate)TemplateRef::object");
            a.item("RowEditActionsTemplateRef", "(w:RowEditActionsTemplate,wf:RowEditActionsTemplate)TemplateRef::object");
            a.item("RowExpandedIndicatorTemplateRef", "(w:RowExpandedIndicatorTemplate,wf:RowExpandedIndicatorTemplate)TemplateRef::object");
            a.item("RowCollapsedIndicatorTemplateRef", "(w:RowCollapsedIndicatorTemplate,wf:RowCollapsedIndicatorTemplate)TemplateRef::object");
            a.item("HeaderExpandedIndicatorTemplateRef", "(w:HeaderExpandedIndicatorTemplate,wf:HeaderExpandedIndicatorTemplate)TemplateRef::object");
            a.item("HeaderCollapsedIndicatorTemplateRef", "(w:HeaderCollapsedIndicatorTemplate,wf:HeaderCollapsedIndicatorTemplate)TemplateRef::object");
            a.item("ExcelStyleHeaderIconTemplateRef", "(w:ExcelStyleHeaderIconTemplate,wf:ExcelStyleHeaderIconTemplate)TemplateRef::object");
            a.item("SortAscendingHeaderIconTemplateRef", "(w:SortAscendingHeaderIconTemplate,wf:SortAscendingHeaderIconTemplate)TemplateRef::object");
            a.item("SortDescendingHeaderIconTemplateRef", "(w:SortDescendingHeaderIconTemplate,wf:SortDescendingHeaderIconTemplate)TemplateRef::object");
            a.item("SortHeaderIconTemplateRef", "(w:SortHeaderIconTemplate,wf:SortHeaderIconTemplate)TemplateRef::object");
            a.item("Toolbar", "Collection:WebGridToolbar:GridToolbarCollection:WebGridToolbar");
            a.item("Toolbar@ngQueryList", "toolbar");
            a.item("PaginationComponents", "Collection:WebPaginator:PaginatorCollection:WebPaginator");
            a.item("PaginationComponents@ngQueryList", "paginationComponents");
            a.item("ResourceStrings", "ExportedType:WebGridResourceStrings");
            a.item("FilteringLogic", "ExportedType:string:FilteringLogic");
            a.item("FilteringLogic@names", "And;Or");
            a.item("FilteringExpressionsTree", "ExportedType:WebFilteringExpressionsTree");
            a.item("FilteringExpressionsTree@mustSetInCode", "WebComponents;Blazor");
            a.item("AdvancedFilteringExpressionsTree", "ExportedType:WebFilteringExpressionsTree");
            a.item("Locale", "String");
            a.item("PagingMode", "ExportedType:string:GridPagingMode");
            a.item("PagingMode@names", "Local;Remote");
            a.item("HideRowSelectors", "Boolean");
            a.item("RowDraggable", "Boolean");
            a.item("ValidationTrigger", "ExportedType:string:GridValidationTrigger");
            a.item("ValidationTrigger@stringUnion", "WebComponents;React");
            a.item("ValidationTrigger@names", "Change;Blur");
            a.item("RowEditable", "Boolean");
            a.item("Height", "String");
            a.item("Width", "String");
            a.item("RowHeight", "Number:double");
            a.item("ColumnWidth", "String");
            a.item("EmptyGridMessage", "String");
            a.item("IsLoading", "Boolean");
            a.item("ShouldGenerate", "Boolean");
            a.item("EmptyFilteredGridMessage", "String");
            a.item("Pinning", "ExportedType:WebPinningConfig");
            a.item("Pinning@mustSetInCode", "WebComponents;Blazor;React");
            a.item("AllowFiltering", "Boolean");
            a.item("AllowAdvancedFiltering", "Boolean");
            a.item("FilterMode", "ExportedType:string:FilterMode");
            a.item("FilterMode@stringUnion", "WebComponents;React");
            a.item("FilterMode@names", "QuickFilter;ExcelStyleFilter");
            a.item("SummaryPosition", "ExportedType:string:GridSummaryPosition");
            a.item("SummaryPosition@stringUnion", "WebComponents;React");
            a.item("SummaryPosition@names", "Top;Bottom");
            a.item("SummaryCalculationMode", "ExportedType:string:GridSummaryCalculationMode");
            a.item("SummaryCalculationMode@stringUnion", "WebComponents;React");
            a.item("SummaryCalculationMode@names", "RootLevelOnly;ChildLevelsOnly;RootAndChildLevels");
            a.item("ShowSummaryOnCollapse", "Boolean");
            a.item("FilterStrategy", "ExportedType:WebFilteringStrategy");
            a.item("SortStrategy", "ExportedType:WebGridSortingStrategy");
            a.item("SortingOptions", "ExportedType:WebSortingOptions");
            a.item("SelectedRowsRef", "(w:SelectedRows,wf:SelectedRows)DataRef:object");
            a.item("HeadSelectorTemplateRef", "(w:HeadSelectorTemplate,wf:HeadSelectorTemplate)TemplateRef::object");
            a.item("RowSelectorTemplateRef", "(w:RowSelectorTemplate,wf:RowSelectorTemplate)TemplateRef::object");
            a.item("DragIndicatorIconTemplateRef", "(w:DragIndicatorIconTemplate,wf:DragIndicatorIconTemplate)TemplateRef::object");
            a.item("SortingExpressions", "Array:WebSortingExpressionDescription:SortingExpression");
            a.item("SortingExpressions@mustSetInCode", "WebComponents;Blazor;React");
            a.item("CellSelection", "ExportedType:string:GridSelectionMode");
            a.item("CellSelection@stringUnion", "WebComponents;React");
            a.item("CellSelection@names", "None;Single;Multiple;MultipleCascade");
            a.item("RowSelection", "ExportedType:string:GridSelectionMode");
            a.item("RowSelection@stringUnion", "WebComponents;React");
            a.item("RowSelection@names", "None;Single;Multiple;MultipleCascade");
            a.item("ColumnSelection", "ExportedType:string:GridSelectionMode");
            a.item("ColumnSelection@stringUnion", "WebComponents;React");
            a.item("ColumnSelection@names", "None;Single;Multiple;MultipleCascade");
            a.item("TotalRecords", "Number:double");
            a.item("SelectRowOnClick", "Boolean");
            a.item("Name", "String");
            a.item("GridCreatedRef", "EventRef::gridCreated:customEvent");
            a.item("GridInitializedRef", "EventRef::gridInitialized:customEvent");
            a.item("DataPreLoadRef", "EventRef::dataPreLoad:customEvent");
            a.item("FilteringExpressionsTreeChangeRef", "EventRef::filteringExpressionsTreeChange:customEvent");
            a.item("AdvancedFilteringExpressionsTreeChangeRef", "EventRef::advancedFilteringExpressionsTreeChange:customEvent");
            a.item("GridScrollRef", "EventRef::gridScroll:customEvent");
            a.item("CellClickRef", "EventRef::cellClick:customEvent");
            a.item("RowClickRef", "EventRef::rowClick:customEvent");
            a.item("FormGroupCreatedRef", "EventRef::formGroupCreated:customEvent");
            a.item("ValidationStatusChangeRef", "EventRef::validationStatusChange:customEvent");
            a.item("SelectedRef", "EventRef::selected:customEvent");
            a.item("RowSelectionChangingRef", "EventRef::rowSelectionChanging:customEvent");
            a.item("ColumnSelectionChangingRef", "EventRef::columnSelectionChanging:customEvent");
            a.item("ColumnPinRef", "EventRef::columnPin:customEvent");
            a.item("ColumnPinnedRef", "EventRef::columnPinned:customEvent");
            a.item("CellEditEnterRef", "EventRef::cellEditEnter:customEvent");
            a.item("CellEditExitRef", "EventRef::cellEditExit:customEvent");
            a.item("CellEditRef", "EventRef::cellEdit:customEvent");
            a.item("CellEditDoneRef", "EventRef::cellEditDone:customEvent");
            a.item("RowEditEnterRef", "EventRef::rowEditEnter:customEvent");
            a.item("RowEditRef", "EventRef::rowEdit:customEvent");
            a.item("RowEditDoneRef", "EventRef::rowEditDone:customEvent");
            a.item("RowEditExitRef", "EventRef::rowEditExit:customEvent");
            a.item("ColumnInitRef", "EventRef::columnInit:customEvent");
            a.item("ColumnsAutogeneratedRef", "EventRef::columnsAutogenerated:customEvent");
            a.item("SortingRef", "EventRef::sorting:customEvent");
            a.item("SortingDoneRef", "EventRef::sortingDone:customEvent");
            a.item("FilteringRef", "EventRef::filtering:customEvent");
            a.item("FilteringDoneRef", "EventRef::filteringDone:customEvent");
            a.item("RowAddedRef", "EventRef::rowAdded:customEvent");
            a.item("RowDeletedRef", "EventRef::rowDeleted:customEvent");
            a.item("RowDeleteRef", "EventRef::rowDelete:customEvent");
            a.item("RowAddRef", "EventRef::rowAdd:customEvent");
            a.item("ColumnResizedRef", "EventRef::columnResized:customEvent");
            a.item("ContextMenuRef", "EventRef::contextMenu:customEvent");
            a.item("DoubleClickRef", "EventRef::doubleClick:customEvent");
            a.item("ColumnVisibilityChangingRef", "EventRef::columnVisibilityChanging:customEvent");
            a.item("ColumnVisibilityChangedRef", "EventRef::columnVisibilityChanged:customEvent");
            a.item("ColumnMovingStartRef", "EventRef::columnMovingStart:customEvent");
            a.item("ColumnMovingRef", "EventRef::columnMoving:customEvent");
            a.item("ColumnMovingEndRef", "EventRef::columnMovingEnd:customEvent");
            a.item("GridKeydownRef", "EventRef::gridKeydown:customEvent");
            a.item("RowDragStartRef", "EventRef::rowDragStart:customEvent");
            a.item("RowDragEndRef", "EventRef::rowDragEnd:customEvent");
            a.item("GridCopyRef", "EventRef::gridCopy:customEvent");
            a.item("RowToggleRef", "EventRef::rowToggle:customEvent");
            a.item("RowPinningRef", "EventRef::rowPinning:customEvent");
            a.item("RowPinnedRef", "EventRef::rowPinned:customEvent");
            a.item("ActiveNodeChangeRef", "EventRef::activeNodeChange:customEvent");
            a.item("SortingExpressionsChangeRef", "EventRef::sortingExpressionsChange:customEvent");
            a.item("ToolbarExportingRef", "EventRef::toolbarExporting:customEvent");
            a.item("RangeSelectedRef", "EventRef::rangeSelected:customEvent");
            a.item("RenderedRef", "EventRef::rendered:customEvent");
            a.item("DataChangingRef", "EventRef::dataChanging:customEvent");
            a.item("DataChangedRef", "EventRef::dataChanged:customEvent");
        }
        static d(a) {
            WebRowIslandDescriptionMetadata.b(a);
            a.ae("WebRowIsland", () => new WebRowIslandDescription());
            a.ad("WebRowIsland", WebRowIslandDescriptionMetadata.a);
        }
    }
    WebRowIslandDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowIslandDescriptionMetadata, 'WebRowIslandDescriptionMetadata');
    WebRowIslandDescriptionMetadata.a = null;
    return WebRowIslandDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebChildGridRowDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebChildGridRowDescriptionMetadata extends Base {
        static b(a) {
            if (WebChildGridRowDescriptionMetadata.a == null) {
                WebChildGridRowDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebChildGridRowDescriptionMetadata.c(WebChildGridRowDescriptionMetadata.a);
            }
            if (a.k(WebChildGridRowDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebChildGridRowDescriptionMetadata.a);
            WebRowIslandDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ChildGridRow");
            a.item("__tagNameWC", "String:igc-child-grid-row");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("Layout", "ExportedType:WebRowIsland");
            a.item("Data", "Unknown");
            a.item("Index", "Number:double");
            a.item("Expanded", "Boolean");
        }
        static d(a) {
            WebChildGridRowDescriptionMetadata.b(a);
            a.ae("WebChildGridRow", () => new WebChildGridRowDescription());
            a.ad("WebChildGridRow", WebChildGridRowDescriptionMetadata.a);
        }
    }
    WebChildGridRowDescriptionMetadata.$t = /*@__PURE__*/ markType(WebChildGridRowDescriptionMetadata, 'WebChildGridRowDescriptionMetadata');
    WebChildGridRowDescriptionMetadata.a = null;
    return WebChildGridRowDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebChildGridRowDescriptionModule = /*@__PURE__*/ (() => {
    class WebChildGridRowDescriptionModule extends Base {
        static register(a) {
            WebChildGridRowDescriptionMetadata.d(a);
        }
    }
    WebChildGridRowDescriptionModule.$t = /*@__PURE__*/ markType(WebChildGridRowDescriptionModule, 'WebChildGridRowDescriptionModule');
    return WebChildGridRowDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebChipDescription = /*@__PURE__*/ (() => {
    class WebChipDescription extends Description {
        get_type() {
            return "WebChip";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
            this.i = false;
            this.j = false;
            this.k = false;
            this.r = null;
            this.p = null;
            this.q = null;
        }
        get disabled() {
            return this.h;
        }
        set disabled(a) {
            this.h = a;
            this.g("Disabled");
        }
        get removable() {
            return this.i;
        }
        set removable(a) {
            this.i = a;
            this.g("Removable");
        }
        get selectable() {
            return this.j;
        }
        set selectable(a) {
            this.j = a;
            this.g("Selectable");
        }
        get selected() {
            return this.k;
        }
        set selected(a) {
            this.k = a;
            this.g("Selected");
        }
        get variant() {
            return this.r;
        }
        set variant(a) {
            this.r = a;
            this.g("Variant");
        }
        get removeRef() {
            return this.p;
        }
        set removeRef(a) {
            this.p = a;
            this.g("RemoveRef");
        }
        get selectRef() {
            return this.q;
        }
        set selectRef(a) {
            this.q = a;
            this.g("SelectRef");
        }
    }
    WebChipDescription.$t = /*@__PURE__*/ markType(WebChipDescription, 'WebChipDescription', Description.$);
    return WebChipDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComponentBoolValueChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class WebComponentBoolValueChangedEventArgsDescription extends Description {
        get_type() {
            return "WebComponentBoolValueChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = false;
        }
        get detail() {
            return this.i;
        }
        set detail(a) {
            this.i = a;
            this.g("Detail");
        }
    }
    WebComponentBoolValueChangedEventArgsDescription.$t = /*@__PURE__*/ markType(WebComponentBoolValueChangedEventArgsDescription, 'WebComponentBoolValueChangedEventArgsDescription', Description.$);
    WebComponentBoolValueChangedEventArgsDescription.__marshalByValue = true;
    WebComponentBoolValueChangedEventArgsDescription.__marshalByValueAlias = "ComponentBoolValueChangedEventArgs";
    return WebComponentBoolValueChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComponentBoolValueChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebComponentBoolValueChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebComponentBoolValueChangedEventArgsDescriptionMetadata.a == null) {
                WebComponentBoolValueChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebComponentBoolValueChangedEventArgsDescriptionMetadata.c(WebComponentBoolValueChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebComponentBoolValueChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebComponentBoolValueChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ComponentBoolValueChangedEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "Boolean");
        }
        static d(a) {
            WebComponentBoolValueChangedEventArgsDescriptionMetadata.b(a);
            a.ae("WebComponentBoolValueChangedEventArgs", () => new WebComponentBoolValueChangedEventArgsDescription());
            a.ad("WebComponentBoolValueChangedEventArgs", WebComponentBoolValueChangedEventArgsDescriptionMetadata.a);
        }
    }
    WebComponentBoolValueChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebComponentBoolValueChangedEventArgsDescriptionMetadata, 'WebComponentBoolValueChangedEventArgsDescriptionMetadata');
    WebComponentBoolValueChangedEventArgsDescriptionMetadata.a = null;
    return WebComponentBoolValueChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebChipDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebChipDescriptionMetadata extends Base {
        static b(a) {
            if (WebChipDescriptionMetadata.a == null) {
                WebChipDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebChipDescriptionMetadata.c(WebChipDescriptionMetadata.a);
            }
            if (a.k(WebChipDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebChipDescriptionMetadata.a);
            WebComponentBoolValueChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Chip");
            a.item("__tagNameWC", "String:igc-chip");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Disabled", "Boolean");
            a.item("Removable", "Boolean");
            a.item("Selectable", "Boolean");
            a.item("Selected", "Boolean");
            a.item("Variant", "ExportedType:string:StyleVariant");
            a.item("Variant@stringUnion", "WebComponents;React");
            a.item("Variant@names", "Primary;Info;Success;Warning;Danger");
            a.item("RemoveRef", "EventRef::remove");
            a.item("SelectRef", "EventRef::select");
        }
        static d(a) {
            WebChipDescriptionMetadata.b(a);
            a.ae("WebChip", () => new WebChipDescription());
            a.ad("WebChip", WebChipDescriptionMetadata.a);
        }
    }
    WebChipDescriptionMetadata.$t = /*@__PURE__*/ markType(WebChipDescriptionMetadata, 'WebChipDescriptionMetadata');
    WebChipDescriptionMetadata.a = null;
    return WebChipDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebChipDescriptionModule = /*@__PURE__*/ (() => {
    class WebChipDescriptionModule extends Base {
        static register(a) {
            WebChipDescriptionMetadata.d(a);
        }
    }
    WebChipDescriptionModule.$t = /*@__PURE__*/ markType(WebChipDescriptionModule, 'WebChipDescriptionModule');
    return WebChipDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCircularGradientDescription = /*@__PURE__*/ (() => {
    class WebCircularGradientDescription extends Description {
        get_type() {
            return "WebCircularGradient";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = null;
            this.j = null;
            this.h = 0;
        }
        get offset() {
            return this.k;
        }
        set offset(a) {
            this.k = a;
            this.g("Offset");
        }
        get color() {
            return this.j;
        }
        set color(a) {
            this.j = a;
            this.g("Color");
        }
        get opacity() {
            return this.h;
        }
        set opacity(a) {
            this.h = a;
            this.g("Opacity");
        }
    }
    WebCircularGradientDescription.$t = /*@__PURE__*/ markType(WebCircularGradientDescription, 'WebCircularGradientDescription', Description.$);
    return WebCircularGradientDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCircularGradientDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCircularGradientDescriptionMetadata extends Base {
        static b(a) {
            if (WebCircularGradientDescriptionMetadata.a == null) {
                WebCircularGradientDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCircularGradientDescriptionMetadata.c(WebCircularGradientDescriptionMetadata.a);
            }
            if (a.k(WebCircularGradientDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCircularGradientDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:CircularGradient");
            a.item("__tagNameWC", "String:igc-circular-gradient");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Offset", "String");
            a.item("Color", "String");
            a.item("Opacity", "Number:double");
        }
        static d(a) {
            WebCircularGradientDescriptionMetadata.b(a);
            a.ae("WebCircularGradient", () => new WebCircularGradientDescription());
            a.ad("WebCircularGradient", WebCircularGradientDescriptionMetadata.a);
        }
    }
    WebCircularGradientDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCircularGradientDescriptionMetadata, 'WebCircularGradientDescriptionMetadata');
    WebCircularGradientDescriptionMetadata.a = null;
    return WebCircularGradientDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCircularGradientDescriptionModule = /*@__PURE__*/ (() => {
    class WebCircularGradientDescriptionModule extends Base {
        static register(a) {
            WebCircularGradientDescriptionMetadata.d(a);
        }
    }
    WebCircularGradientDescriptionModule.$t = /*@__PURE__*/ markType(WebCircularGradientDescriptionModule, 'WebCircularGradientDescriptionModule');
    return WebCircularGradientDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebProgressBaseDescription = /*@__PURE__*/ (() => {
    class WebProgressBaseDescription extends Description {
        get_type() {
            return "WebProgressBase";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.m = 0;
            this.n = 0;
            this.s = null;
            this.l = 0;
            this.i = false;
            this.h = false;
            this.r = null;
        }
        get max() {
            return this.m;
        }
        set max(a) {
            this.m = a;
            this.g("Max");
        }
        get value() {
            return this.n;
        }
        set value(a) {
            this.n = a;
            this.g("Value");
        }
        get variant() {
            return this.s;
        }
        set variant(a) {
            this.s = a;
            this.g("Variant");
        }
        get animationDuration() {
            return this.l;
        }
        set animationDuration(a) {
            this.l = a;
            this.g("AnimationDuration");
        }
        get indeterminate() {
            return this.i;
        }
        set indeterminate(a) {
            this.i = a;
            this.g("Indeterminate");
        }
        get hideLabel() {
            return this.h;
        }
        set hideLabel(a) {
            this.h = a;
            this.g("HideLabel");
        }
        get labelFormat() {
            return this.r;
        }
        set labelFormat(a) {
            this.r = a;
            this.g("LabelFormat");
        }
    }
    WebProgressBaseDescription.$t = /*@__PURE__*/ markType(WebProgressBaseDescription, 'WebProgressBaseDescription', Description.$);
    return WebProgressBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCircularProgressDescription = /*@__PURE__*/ (() => {
    class WebCircularProgressDescription extends WebProgressBaseDescription {
        get_type() {
            return "WebCircularProgress";
        }
        constructor() {
            super();
        }
    }
    WebCircularProgressDescription.$t = /*@__PURE__*/ markType(WebCircularProgressDescription, 'WebCircularProgressDescription', WebProgressBaseDescription.$);
    return WebCircularProgressDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebProgressBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebProgressBaseDescriptionMetadata extends Base {
        static b(a) {
            if (WebProgressBaseDescriptionMetadata.a == null) {
                WebProgressBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebProgressBaseDescriptionMetadata.c(WebProgressBaseDescriptionMetadata.a);
            }
            if (a.k(WebProgressBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebProgressBaseDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ProgressBase");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Max", "Number:double");
            a.item("Value", "Number:double");
            a.item("Variant", "ExportedType:string:StyleVariant");
            a.item("Variant@stringUnion", "WebComponents;React");
            a.item("Variant@names", "Primary;Info;Success;Warning;Danger");
            a.item("AnimationDuration", "Number:double");
            a.item("Indeterminate", "Boolean");
            a.item("HideLabel", "Boolean");
            a.item("LabelFormat", "String");
        }
        static d(a) {
            WebProgressBaseDescriptionMetadata.b(a);
            a.ad("WebProgressBase", WebProgressBaseDescriptionMetadata.a);
        }
    }
    WebProgressBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(WebProgressBaseDescriptionMetadata, 'WebProgressBaseDescriptionMetadata');
    WebProgressBaseDescriptionMetadata.a = null;
    return WebProgressBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCircularProgressDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebCircularProgressDescriptionMetadata extends Base {
        static b(a) {
            if (WebCircularProgressDescriptionMetadata.a == null) {
                WebCircularProgressDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebCircularProgressDescriptionMetadata.c(WebCircularProgressDescriptionMetadata.a);
            }
            if (a.k(WebCircularProgressDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebCircularProgressDescriptionMetadata.a);
        }
        static c(a) {
            WebProgressBaseDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:CircularProgress");
            a.item("__tagNameWC", "String:igc-circular-progress");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebCircularProgressDescriptionMetadata.b(a);
            a.ae("WebCircularProgress", () => new WebCircularProgressDescription());
            a.ad("WebCircularProgress", WebCircularProgressDescriptionMetadata.a);
        }
    }
    WebCircularProgressDescriptionMetadata.$t = /*@__PURE__*/ markType(WebCircularProgressDescriptionMetadata, 'WebCircularProgressDescriptionMetadata');
    WebCircularProgressDescriptionMetadata.a = null;
    return WebCircularProgressDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebProgressBaseDescriptionModule = /*@__PURE__*/ (() => {
    class WebProgressBaseDescriptionModule extends Base {
        static register(a) {
        }
    }
    WebProgressBaseDescriptionModule.$t = /*@__PURE__*/ markType(WebProgressBaseDescriptionModule, 'WebProgressBaseDescriptionModule');
    return WebProgressBaseDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebCircularProgressDescriptionModule = /*@__PURE__*/ (() => {
    class WebCircularProgressDescriptionModule extends Base {
        static register(a) {
            WebProgressBaseDescriptionModule.register(a);
            WebCircularProgressDescriptionMetadata.d(a);
        }
    }
    WebCircularProgressDescriptionModule.$t = /*@__PURE__*/ markType(WebCircularProgressDescriptionModule, 'WebCircularProgressDescriptionModule');
    return WebCircularProgressDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnDescriptionModule = /*@__PURE__*/ (() => {
    class WebColumnDescriptionModule extends Base {
        static register(a) {
            WebColumnDescriptionMetadata.d(a);
        }
    }
    WebColumnDescriptionModule.$t = /*@__PURE__*/ markType(WebColumnDescriptionModule, 'WebColumnDescriptionModule');
    return WebColumnDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnGroupDescription = /*@__PURE__*/ (() => {
    class WebColumnGroupDescription extends WebColumnDescription {
        get_type() {
            return "WebColumnGroup";
        }
        constructor() {
            super();
            this.ck = null;
            this.cn = false;
            this.co = false;
            this.cs = null;
        }
        get children() {
            return this.ck;
        }
        set children(a) {
            this.ck = a;
            this.g("Children");
        }
        get collapsible() {
            return this.cn;
        }
        set collapsible(a) {
            this.cn = a;
            this.g("Collapsible");
        }
        get expanded() {
            return this.co;
        }
        set expanded(a) {
            this.co = a;
            this.g("Expanded");
        }
        get collapsibleIndicatorTemplateRef() {
            return this.cs;
        }
        set collapsibleIndicatorTemplateRef(a) {
            this.cs = a;
            this.g("CollapsibleIndicatorTemplateRef");
        }
    }
    WebColumnGroupDescription.$t = /*@__PURE__*/ markType(WebColumnGroupDescription, 'WebColumnGroupDescription', WebColumnDescription.$);
    WebColumnGroupDescription.__canMarshalByValue1 = true;
    WebColumnGroupDescription.__marshalByValueAlias1 = "ColumnGroup";
    return WebColumnGroupDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnGroupDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnGroupDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnGroupDescriptionMetadata.a == null) {
                WebColumnGroupDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnGroupDescriptionMetadata.c(WebColumnGroupDescriptionMetadata.a);
            }
            if (a.k(WebColumnGroupDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnGroupDescriptionMetadata.a);
        }
        static c(a) {
            WebColumnDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ColumnGroup");
            a.item("__tagNameWC", "String:igc-column-group");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__manageCollectionInMarkup", "Boolean");
            a.item("Children", "Collection:WebColumn:ColumnCollection:WebColumn");
            a.item("Collapsible", "Boolean");
            a.item("Expanded", "Boolean");
            a.item("CollapsibleIndicatorTemplateRef", "(w:CollapsibleIndicatorTemplate,wf:CollapsibleIndicatorTemplate)TemplateRef::object");
        }
        static d(a) {
            WebColumnGroupDescriptionMetadata.b(a);
            a.ae("WebColumnGroup", () => new WebColumnGroupDescription());
            a.ad("WebColumnGroup", WebColumnGroupDescriptionMetadata.a);
        }
    }
    WebColumnGroupDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnGroupDescriptionMetadata, 'WebColumnGroupDescriptionMetadata');
    WebColumnGroupDescriptionMetadata.a = null;
    return WebColumnGroupDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnGroupDescriptionModule = /*@__PURE__*/ (() => {
    class WebColumnGroupDescriptionModule extends Base {
        static register(a) {
            WebColumnDescriptionModule.register(a);
            WebColumnGroupDescriptionMetadata.d(a);
        }
    }
    WebColumnGroupDescriptionModule.$t = /*@__PURE__*/ markType(WebColumnGroupDescriptionModule, 'WebColumnGroupDescriptionModule');
    return WebColumnGroupDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnLayoutDescription = /*@__PURE__*/ (() => {
    class WebColumnLayoutDescription extends WebColumnGroupDescription {
        get_type() {
            return "WebColumnLayout";
        }
        constructor() {
            super();
        }
    }
    WebColumnLayoutDescription.$t = /*@__PURE__*/ markType(WebColumnLayoutDescription, 'WebColumnLayoutDescription', WebColumnGroupDescription.$);
    WebColumnLayoutDescription.__canMarshalByValue2 = true;
    WebColumnLayoutDescription.__marshalByValueAlias2 = "ColumnLayout";
    return WebColumnLayoutDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnLayoutDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnLayoutDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnLayoutDescriptionMetadata.a == null) {
                WebColumnLayoutDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnLayoutDescriptionMetadata.c(WebColumnLayoutDescriptionMetadata.a);
            }
            if (a.k(WebColumnLayoutDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnLayoutDescriptionMetadata.a);
        }
        static c(a) {
            WebColumnGroupDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:ColumnLayout");
            a.item("__tagNameWC", "String:igc-column-layout");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__manageCollectionInMarkup", "Boolean");
        }
        static d(a) {
            WebColumnLayoutDescriptionMetadata.b(a);
            a.ae("WebColumnLayout", () => new WebColumnLayoutDescription());
            a.ad("WebColumnLayout", WebColumnLayoutDescriptionMetadata.a);
        }
    }
    WebColumnLayoutDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnLayoutDescriptionMetadata, 'WebColumnLayoutDescriptionMetadata');
    WebColumnLayoutDescriptionMetadata.a = null;
    return WebColumnLayoutDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnLayoutDescriptionModule = /*@__PURE__*/ (() => {
    class WebColumnLayoutDescriptionModule extends Base {
        static register(a) {
            WebColumnGroupDescriptionModule.register(a);
            WebColumnLayoutDescriptionMetadata.d(a);
        }
    }
    WebColumnLayoutDescriptionModule.$t = /*@__PURE__*/ markType(WebColumnLayoutDescriptionModule, 'WebColumnLayoutDescriptionModule');
    return WebColumnLayoutDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComboDescription = /*@__PURE__*/ (() => {
    class WebComboDescription extends Description {
        get_type() {
            return "WebCombo";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.aj = null;
            this.s = false;
            this.u = false;
            this.l = false;
            this.m = false;
            this.aq = null;
            this.au = null;
            this.av = null;
            this.r = false;
            this.aw = null;
            this.ak = null;
            this.an = null;
            this.ao = null;
            this.j = null;
            this.n = false;
            this.p = false;
            this.h = null;
            this.o = false;
            this.t = false;
            this.ar = null;
            this.q = false;
            this.ap = null;
            this.am = null;
            this.ag = null;
            this.al = null;
            this.af = null;
            this.at = null;
            this.as = null;
            this.ai = null;
            this.ah = null;
        }
        get dataRef() {
            return this.aj;
        }
        set dataRef(a) {
            this.aj = a;
            this.g("DataRef");
        }
        get outlined() {
            return this.s;
        }
        set outlined(a) {
            this.s = a;
            this.g("Outlined");
        }
        get singleSelect() {
            return this.u;
        }
        set singleSelect(a) {
            this.u = a;
            this.g("SingleSelect");
        }
        get autofocus() {
            return this.l;
        }
        set autofocus(a) {
            this.l = a;
            this.g("Autofocus");
        }
        get autofocusList() {
            return this.m;
        }
        set autofocusList(a) {
            this.m = a;
            this.g("AutofocusList");
        }
        get label() {
            return this.aq;
        }
        set label(a) {
            this.aq = a;
            this.g("Label");
        }
        get placeholder() {
            return this.au;
        }
        set placeholder(a) {
            this.au = a;
            this.g("Placeholder");
        }
        get placeholderSearch() {
            return this.av;
        }
        set placeholderSearch(a) {
            this.av = a;
            this.g("PlaceholderSearch");
        }
        get open() {
            return this.r;
        }
        set open(a) {
            this.r = a;
            this.g("Open");
        }
        get valueKey() {
            return this.aw;
        }
        set valueKey(a) {
            this.aw = a;
            this.g("ValueKey");
        }
        get displayKey() {
            return this.ak;
        }
        set displayKey(a) {
            this.ak = a;
            this.g("DisplayKey");
        }
        get groupKey() {
            return this.an;
        }
        set groupKey(a) {
            this.an = a;
            this.g("GroupKey");
        }
        get groupSorting() {
            return this.ao;
        }
        set groupSorting(a) {
            this.ao = a;
            this.g("GroupSorting");
        }
        get filteringOptions() {
            return this.j;
        }
        set filteringOptions(a) {
            this.j = a;
            this.g("FilteringOptions");
        }
        get caseSensitiveIcon() {
            return this.n;
        }
        set caseSensitiveIcon(a) {
            this.n = a;
            this.g("CaseSensitiveIcon");
        }
        get disableFiltering() {
            return this.p;
        }
        set disableFiltering(a) {
            this.p = a;
            this.g("DisableFiltering");
        }
        get value() {
            return this.h;
        }
        set value(a) {
            this.h = a;
            this.g("Value");
        }
        get disabled() {
            return this.o;
        }
        set disabled(a) {
            this.o = a;
            this.g("Disabled");
        }
        get required() {
            return this.t;
        }
        set required(a) {
            this.t = a;
            this.g("Required");
        }
        get name() {
            return this.ar;
        }
        set name(a) {
            this.ar = a;
            this.g("Name");
        }
        get invalid() {
            return this.q;
        }
        set invalid(a) {
            this.q = a;
            this.g("Invalid");
        }
        get itemTemplateRef() {
            return this.ap;
        }
        set itemTemplateRef(a) {
            this.ap = a;
            this.g("ItemTemplateRef");
        }
        get groupHeaderTemplateRef() {
            return this.am;
        }
        set groupHeaderTemplateRef(a) {
            this.am = a;
            this.g("GroupHeaderTemplateRef");
        }
        get changeRef() {
            return this.ag;
        }
        set changeRef(a) {
            this.ag = a;
            this.g("ChangeRef");
        }
        get focusRef() {
            return this.al;
        }
        set focusRef(a) {
            this.al = a;
            this.g("FocusRef");
        }
        get blurRef() {
            return this.af;
        }
        set blurRef(a) {
            this.af = a;
            this.g("BlurRef");
        }
        get openingRef() {
            return this.at;
        }
        set openingRef(a) {
            this.at = a;
            this.g("OpeningRef");
        }
        get openedRef() {
            return this.as;
        }
        set openedRef(a) {
            this.as = a;
            this.g("OpenedRef");
        }
        get closingRef() {
            return this.ai;
        }
        set closingRef(a) {
            this.ai = a;
            this.g("ClosingRef");
        }
        get closedRef() {
            return this.ah;
        }
        set closedRef(a) {
            this.ah = a;
            this.g("ClosedRef");
        }
    }
    WebComboDescription.$t = /*@__PURE__*/ markType(WebComboDescription, 'WebComboDescription', Description.$);
    return WebComboDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringOptionsDescription = /*@__PURE__*/ (() => {
    class WebFilteringOptionsDescription extends Description {
        get_type() {
            return "WebFilteringOptions";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebFilteringOptionsDescription.$t = /*@__PURE__*/ markType(WebFilteringOptionsDescription, 'WebFilteringOptionsDescription', Description.$);
    return WebFilteringOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFilteringOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (WebFilteringOptionsDescriptionMetadata.a == null) {
                WebFilteringOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFilteringOptionsDescriptionMetadata.c(WebFilteringOptionsDescriptionMetadata.a);
            }
            if (a.k(WebFilteringOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFilteringOptionsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FilteringOptions");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebFilteringOptionsDescriptionMetadata.b(a);
            a.ae("WebFilteringOptions", () => new WebFilteringOptionsDescription());
            a.ad("WebFilteringOptions", WebFilteringOptionsDescriptionMetadata.a);
        }
    }
    WebFilteringOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFilteringOptionsDescriptionMetadata, 'WebFilteringOptionsDescriptionMetadata');
    WebFilteringOptionsDescriptionMetadata.a = null;
    return WebFilteringOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComboChangeEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebComboChangeEventArgsDetailDescription extends Description {
        get_type() {
            return "WebComboChangeEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.k = null;
            this.j = null;
        }
        get newValueRef() {
            return this.l;
        }
        set newValueRef(a) {
            this.l = a;
            this.g("NewValueRef");
        }
        get itemsRef() {
            return this.k;
        }
        set itemsRef(a) {
            this.k = a;
            this.g("ItemsRef");
        }
        get changeType() {
            return this.j;
        }
        set changeType(a) {
            this.j = a;
            this.g("ChangeType");
        }
    }
    WebComboChangeEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebComboChangeEventArgsDetailDescription, 'WebComboChangeEventArgsDetailDescription', Description.$);
    WebComboChangeEventArgsDetailDescription.__marshalByValue = true;
    WebComboChangeEventArgsDetailDescription.__marshalByValueAlias = "ComboChangeEventArgsDetail";
    return WebComboChangeEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComboChangeEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebComboChangeEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebComboChangeEventArgsDetailDescriptionMetadata.a == null) {
                WebComboChangeEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebComboChangeEventArgsDetailDescriptionMetadata.c(WebComboChangeEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebComboChangeEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebComboChangeEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ComboChangeEventArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("NewValueRef", "(w:NewValue,wf:NewValue)DataRef:object");
            a.item("ItemsRef", "(w:Items,wf:Items)DataRef:object");
            a.item("ChangeType", "(wc:Type)ExportedType:string:ComboChangeType");
            a.item("ChangeType@stringUnion", "WebComponents;React");
            a.item("ChangeType@names", "Selection;Deselection;Addition");
        }
        static d(a) {
            WebComboChangeEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebComboChangeEventArgsDetail", () => new WebComboChangeEventArgsDetailDescription());
            a.ad("WebComboChangeEventArgsDetail", WebComboChangeEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebComboChangeEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebComboChangeEventArgsDetailDescriptionMetadata, 'WebComboChangeEventArgsDetailDescriptionMetadata');
    WebComboChangeEventArgsDetailDescriptionMetadata.a = null;
    return WebComboChangeEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComboChangeEventArgsDescription = /*@__PURE__*/ (() => {
    class WebComboChangeEventArgsDescription extends Description {
        get_type() {
            return "WebComboChangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebComboChangeEventArgsDescription.$t = /*@__PURE__*/ markType(WebComboChangeEventArgsDescription, 'WebComboChangeEventArgsDescription', Description.$);
    WebComboChangeEventArgsDescription.__marshalByValue = true;
    WebComboChangeEventArgsDescription.__marshalByValueAlias = "ComboChangeEventArgs";
    return WebComboChangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComboChangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebComboChangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebComboChangeEventArgsDescriptionMetadata.a == null) {
                WebComboChangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebComboChangeEventArgsDescriptionMetadata.c(WebComboChangeEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebComboChangeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebComboChangeEventArgsDescriptionMetadata.a);
            WebComboChangeEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ComboChangeEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebComboChangeEventArgsDetail");
        }
        static d(a) {
            WebComboChangeEventArgsDescriptionMetadata.b(a);
            a.ae("WebComboChangeEventArgs", () => new WebComboChangeEventArgsDescription());
            a.ad("WebComboChangeEventArgs", WebComboChangeEventArgsDescriptionMetadata.a);
        }
    }
    WebComboChangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebComboChangeEventArgsDescriptionMetadata, 'WebComboChangeEventArgsDescriptionMetadata');
    WebComboChangeEventArgsDescriptionMetadata.a = null;
    return WebComboChangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComboDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebComboDescriptionMetadata extends Base {
        static b(a) {
            if (WebComboDescriptionMetadata.a == null) {
                WebComboDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebComboDescriptionMetadata.c(WebComboDescriptionMetadata.a);
            }
            if (a.k(WebComboDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebComboDescriptionMetadata.a);
            WebFilteringOptionsDescriptionMetadata.d(a);
            WebComboChangeEventArgsDescriptionMetadata.d(a);
            VoidEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Combo");
            a.item("__tagNameWC", "String:igc-combo");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("DataRef", "(w:Data,wf:Data)DataRef::object");
            a.item("Outlined", "Boolean");
            a.item("SingleSelect", "Boolean");
            a.item("Autofocus", "Boolean");
            a.item("AutofocusList", "Boolean");
            a.item("Label", "String");
            a.item("Placeholder", "String");
            a.item("PlaceholderSearch", "String");
            a.item("Open", "Boolean");
            a.item("ValueKey", "String");
            a.item("DisplayKey", "String");
            a.item("GroupKey", "String");
            a.item("GroupSorting", "ExportedType:string:GroupingDirection");
            a.item("GroupSorting@stringUnion", "WebComponents;React");
            a.item("GroupSorting@names", "Asc;Desc;None");
            a.item("FilteringOptions", "ExportedType:WebFilteringOptions");
            a.item("CaseSensitiveIcon", "Boolean");
            a.item("DisableFiltering", "Boolean");
            a.item("Value", "Array:object");
            a.item("Disabled", "Boolean");
            a.item("Required", "Boolean");
            a.item("Name", "String");
            a.item("Invalid", "Boolean");
            a.item("ItemTemplateRef", "(w:ItemTemplate,wf:ItemTemplate)TemplateRef::object");
            a.item("GroupHeaderTemplateRef", "(w:GroupHeaderTemplate,wf:GroupHeaderTemplate)TemplateRef::object");
            a.item("ChangeRef", "EventRef::change");
            a.item("FocusRef", "EventRef::focus");
            a.item("BlurRef", "EventRef::blur");
            a.item("OpeningRef", "EventRef::opening");
            a.item("OpenedRef", "EventRef::opened");
            a.item("ClosingRef", "EventRef::closing");
            a.item("ClosedRef", "EventRef::closed");
        }
        static d(a) {
            WebComboDescriptionMetadata.b(a);
            a.ae("WebCombo", () => new WebComboDescription());
            a.ad("WebCombo", WebComboDescriptionMetadata.a);
        }
    }
    WebComboDescriptionMetadata.$t = /*@__PURE__*/ markType(WebComboDescriptionMetadata, 'WebComboDescriptionMetadata');
    WebComboDescriptionMetadata.a = null;
    return WebComboDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebIconMetaDescription = /*@__PURE__*/ (() => {
    class WebIconMetaDescription extends Description {
        get_type() {
            return "WebIconMeta";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = null;
            this.j = null;
        }
        get name() {
            return this.k;
        }
        set name(a) {
            this.k = a;
            this.g("Name");
        }
        get collection() {
            return this.j;
        }
        set collection(a) {
            this.j = a;
            this.g("Collection");
        }
    }
    WebIconMetaDescription.$t = /*@__PURE__*/ markType(WebIconMetaDescription, 'WebIconMetaDescription', Description.$);
    WebIconMetaDescription.__marshalByValue = true;
    WebIconMetaDescription.__marshalByValueAlias = "IconMeta";
    return WebIconMetaDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebIconMetaDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebIconMetaDescriptionMetadata extends Base {
        static b(a) {
            if (WebIconMetaDescriptionMetadata.a == null) {
                WebIconMetaDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebIconMetaDescriptionMetadata.c(WebIconMetaDescriptionMetadata.a);
            }
            if (a.k(WebIconMetaDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebIconMetaDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:IconMeta");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("Name", "String");
            a.item("Collection", "String");
        }
        static d(a) {
            WebIconMetaDescriptionMetadata.b(a);
            a.ae("WebIconMeta", () => new WebIconMetaDescription());
            a.ad("WebIconMeta", WebIconMetaDescriptionMetadata.a);
        }
    }
    WebIconMetaDescriptionMetadata.$t = /*@__PURE__*/ markType(WebIconMetaDescriptionMetadata, 'WebIconMetaDescriptionMetadata');
    WebIconMetaDescriptionMetadata.a = null;
    return WebIconMetaDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebIconDescription = /*@__PURE__*/ (() => {
    class WebIconDescription extends Description {
        get_type() {
            return "WebIcon";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = null;
            this.j = null;
            this.h = false;
        }
        get iconName() {
            return this.k;
        }
        set iconName(a) {
            this.k = a;
            this.g("IconName");
        }
        get collection() {
            return this.j;
        }
        set collection(a) {
            this.j = a;
            this.g("Collection");
        }
        get mirrored() {
            return this.h;
        }
        set mirrored(a) {
            this.h = a;
            this.g("Mirrored");
        }
    }
    WebIconDescription.$t = /*@__PURE__*/ markType(WebIconDescription, 'WebIconDescription', Description.$);
    return WebIconDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebIconDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebIconDescriptionMetadata extends Base {
        static b(a) {
            if (WebIconDescriptionMetadata.a == null) {
                WebIconDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebIconDescriptionMetadata.c(WebIconDescriptionMetadata.a);
            }
            if (a.k(WebIconDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebIconDescriptionMetadata.a);
            WebIconDescriptionMetadata.e(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Icon");
            a.item("__tagNameWC", "String:igc-icon");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("IconName", "(wc:Name)String");
            a.item("Collection", "String");
            a.item("Mirrored", "Boolean");
        }
        static d(a) {
            WebIconDescriptionMetadata.b(a);
            a.ae("WebIcon", () => new WebIconDescription());
            a.ad("WebIcon", WebIconDescriptionMetadata.a);
        }
        static e(a) {
            WebIconMetaDescriptionMetadata.d(a);
        }
    }
    WebIconDescriptionMetadata.$t = /*@__PURE__*/ markType(WebIconDescriptionMetadata, 'WebIconDescriptionMetadata');
    WebIconDescriptionMetadata.a = null;
    return WebIconDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebIconDescriptionModule = /*@__PURE__*/ (() => {
    class WebIconDescriptionModule extends Base {
        static register(a) {
            WebIconDescriptionMetadata.d(a);
        }
    }
    WebIconDescriptionModule.$t = /*@__PURE__*/ markType(WebIconDescriptionModule, 'WebIconDescriptionModule');
    return WebIconDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebInputBaseDescriptionModule = /*@__PURE__*/ (() => {
    class WebInputBaseDescriptionModule extends Base {
        static register(a) {
        }
    }
    WebInputBaseDescriptionModule.$t = /*@__PURE__*/ markType(WebInputBaseDescriptionModule, 'WebInputBaseDescriptionModule');
    return WebInputBaseDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebInputBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebInputBaseDescriptionMetadata extends Base {
        static b(a) {
            if (WebInputBaseDescriptionMetadata.a == null) {
                WebInputBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebInputBaseDescriptionMetadata.c(WebInputBaseDescriptionMetadata.a);
            }
            if (a.k(WebInputBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebInputBaseDescriptionMetadata.a);
            WebComponentValueChangedEventArgsDescriptionMetadata.d(a);
            VoidEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:InputBase");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Outlined", "Boolean");
            a.item("ReadOnly", "Boolean");
            a.item("Placeholder", "String");
            a.item("Label", "String");
            a.item("Disabled", "Boolean");
            a.item("Required", "Boolean");
            a.item("Name", "String");
            a.item("Invalid", "Boolean");
            a.item("InputOcurredRef", "EventRef::inputOcurred");
            a.item("FocusRef", "EventRef::focus");
            a.item("BlurRef", "EventRef::blur");
        }
        static d(a) {
            WebInputBaseDescriptionMetadata.b(a);
            a.ad("WebInputBase", WebInputBaseDescriptionMetadata.a);
        }
    }
    WebInputBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(WebInputBaseDescriptionMetadata, 'WebInputBaseDescriptionMetadata');
    WebInputBaseDescriptionMetadata.a = null;
    return WebInputBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebInputBaseDescription = /*@__PURE__*/ (() => {
    class WebInputBaseDescription extends Description {
        get_type() {
            return "WebInputBase";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = false;
            this.k = false;
            this.w = null;
            this.u = null;
            this.h = false;
            this.l = false;
            this.v = null;
            this.i = false;
            this.t = null;
            this.s = null;
            this.r = null;
        }
        get outlined() {
            return this.j;
        }
        set outlined(a) {
            this.j = a;
            this.g("Outlined");
        }
        get readOnly() {
            return this.k;
        }
        set readOnly(a) {
            this.k = a;
            this.g("ReadOnly");
        }
        get placeholder() {
            return this.w;
        }
        set placeholder(a) {
            this.w = a;
            this.g("Placeholder");
        }
        get label() {
            return this.u;
        }
        set label(a) {
            this.u = a;
            this.g("Label");
        }
        get disabled() {
            return this.h;
        }
        set disabled(a) {
            this.h = a;
            this.g("Disabled");
        }
        get required() {
            return this.l;
        }
        set required(a) {
            this.l = a;
            this.g("Required");
        }
        get name() {
            return this.v;
        }
        set name(a) {
            this.v = a;
            this.g("Name");
        }
        get invalid() {
            return this.i;
        }
        set invalid(a) {
            this.i = a;
            this.g("Invalid");
        }
        get inputOcurredRef() {
            return this.t;
        }
        set inputOcurredRef(a) {
            this.t = a;
            this.g("InputOcurredRef");
        }
        get focusRef() {
            return this.s;
        }
        set focusRef(a) {
            this.s = a;
            this.g("FocusRef");
        }
        get blurRef() {
            return this.r;
        }
        set blurRef(a) {
            this.r = a;
            this.g("BlurRef");
        }
    }
    WebInputBaseDescription.$t = /*@__PURE__*/ markType(WebInputBaseDescription, 'WebInputBaseDescription', Description.$);
    return WebInputBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebInputDescription = /*@__PURE__*/ (() => {
    class WebInputDescription extends WebInputBaseDescription {
        get_type() {
            return "WebInput";
        }
        constructor() {
            super();
            this.av = null;
            this.aq = null;
            this.ar = null;
            this.au = null;
            this.aj = 0;
            this.ai = 0;
            this.at = null;
            this.as = null;
            this.ak = 0;
            this.ae = false;
            this.ao = null;
            this.af = false;
            this.ap = null;
        }
        get valueRef() {
            return this.av;
        }
        set valueRef(a) {
            this.av = a;
            this.g("ValueRef");
        }
        get displayType() {
            return this.aq;
        }
        set displayType(a) {
            this.aq = a;
            this.g("DisplayType");
        }
        get inputMode() {
            return this.ar;
        }
        set inputMode(a) {
            this.ar = a;
            this.g("InputMode");
        }
        get pattern() {
            return this.au;
        }
        set pattern(a) {
            this.au = a;
            this.g("Pattern");
        }
        get minLength() {
            return this.aj;
        }
        set minLength(a) {
            this.aj = a;
            this.g("MinLength");
        }
        get maxLength() {
            return this.ai;
        }
        set maxLength(a) {
            this.ai = a;
            this.g("MaxLength");
        }
        get min() {
            return this.at;
        }
        set min(a) {
            this.at = a;
            this.g("Min");
        }
        get max() {
            return this.as;
        }
        set max(a) {
            this.as = a;
            this.g("Max");
        }
        get step() {
            return this.ak;
        }
        set step(a) {
            this.ak = a;
            this.g("Step");
        }
        get autofocus() {
            return this.ae;
        }
        set autofocus(a) {
            this.ae = a;
            this.g("Autofocus");
        }
        get autocomplete() {
            return this.ao;
        }
        set autocomplete(a) {
            this.ao = a;
            this.g("Autocomplete");
        }
        get validateOnly() {
            return this.af;
        }
        set validateOnly(a) {
            this.af = a;
            this.g("ValidateOnly");
        }
        get changeRef() {
            return this.ap;
        }
        set changeRef(a) {
            this.ap = a;
            this.g("ChangeRef");
        }
    }
    WebInputDescription.$t = /*@__PURE__*/ markType(WebInputDescription, 'WebInputDescription', WebInputBaseDescription.$);
    return WebInputDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebInputDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebInputDescriptionMetadata extends Base {
        static b(a) {
            if (WebInputDescriptionMetadata.a == null) {
                WebInputDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebInputDescriptionMetadata.c(WebInputDescriptionMetadata.a);
            }
            if (a.k(WebInputDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebInputDescriptionMetadata.a);
            WebComponentDataValueChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebInputBaseDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:Input");
            a.item("__tagNameWC", "String:igc-input");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
            a.item("DisplayType", "(wc:Type)ExportedType:string:InputType");
            a.item("DisplayType@stringUnion", "WebComponents;React");
            a.item("DisplayType@names", "Number;Email;Password;Search;Tel;Text;Url");
            a.item("InputMode", "String");
            a.item("Pattern", "String");
            a.item("MinLength", "Number:double");
            a.item("MaxLength", "Number:double");
            a.item("Min", "String");
            a.item("Max", "String");
            a.item("Step", "Number:double");
            a.item("Autofocus", "Boolean");
            a.item("Autocomplete", "String");
            a.item("ValidateOnly", "Boolean");
            a.item("ChangeRef", "EventRef::change");
        }
        static d(a) {
            WebInputDescriptionMetadata.b(a);
            a.ae("WebInput", () => new WebInputDescription());
            a.ad("WebInput", WebInputDescriptionMetadata.a);
        }
    }
    WebInputDescriptionMetadata.$t = /*@__PURE__*/ markType(WebInputDescriptionMetadata, 'WebInputDescriptionMetadata');
    WebInputDescriptionMetadata.a = null;
    return WebInputDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebInputDescriptionModule = /*@__PURE__*/ (() => {
    class WebInputDescriptionModule extends Base {
        static register(a) {
            WebInputBaseDescriptionModule.register(a);
            WebInputDescriptionMetadata.d(a);
        }
    }
    WebInputDescriptionModule.$t = /*@__PURE__*/ markType(WebInputDescriptionModule, 'WebInputDescriptionModule');
    return WebInputDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComboDescriptionModule = /*@__PURE__*/ (() => {
    class WebComboDescriptionModule extends Base {
        static register(a) {
            WebIconDescriptionModule.register(a);
            WebInputDescriptionModule.register(a);
            WebComboChangeEventArgsDescriptionMetadata.d(a);
            WebComboDescriptionMetadata.d(a);
        }
    }
    WebComboDescriptionModule.$t = /*@__PURE__*/ markType(WebComboDescriptionModule, 'WebComboDescriptionModule');
    return WebComboDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComponentDateValueChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class WebComponentDateValueChangedEventArgsDescription extends Description {
        get_type() {
            return "WebComponentDateValueChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = new Date();
        }
        get detail() {
            return this.i;
        }
        set detail(a) {
            this.i = a;
            this.g("Detail");
        }
    }
    WebComponentDateValueChangedEventArgsDescription.$t = /*@__PURE__*/ markType(WebComponentDateValueChangedEventArgsDescription, 'WebComponentDateValueChangedEventArgsDescription', Description.$);
    WebComponentDateValueChangedEventArgsDescription.__marshalByValue = true;
    WebComponentDateValueChangedEventArgsDescription.__marshalByValueAlias = "ComponentDateValueChangedEventArgs";
    return WebComponentDateValueChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebComponentDateValueChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebComponentDateValueChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebComponentDateValueChangedEventArgsDescriptionMetadata.a == null) {
                WebComponentDateValueChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebComponentDateValueChangedEventArgsDescriptionMetadata.c(WebComponentDateValueChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebComponentDateValueChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebComponentDateValueChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ComponentDateValueChangedEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "Date");
        }
        static d(a) {
            WebComponentDateValueChangedEventArgsDescriptionMetadata.b(a);
            a.ae("WebComponentDateValueChangedEventArgs", () => new WebComponentDateValueChangedEventArgsDescription());
            a.ad("WebComponentDateValueChangedEventArgs", WebComponentDateValueChangedEventArgsDescriptionMetadata.a);
        }
    }
    WebComponentDateValueChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebComponentDateValueChangedEventArgsDescriptionMetadata, 'WebComponentDateValueChangedEventArgsDescriptionMetadata');
    WebComponentDateValueChangedEventArgsDescriptionMetadata.a = null;
    return WebComponentDateValueChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebContentPaneDescriptionModule = /*@__PURE__*/ (() => {
    class WebContentPaneDescriptionModule extends Base {
        static register(a) {
            WebContentPaneDescriptionMetadata.d(a);
        }
    }
    WebContentPaneDescriptionModule.$t = /*@__PURE__*/ markType(WebContentPaneDescriptionModule, 'WebContentPaneDescriptionModule');
    return WebContentPaneDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDateFilteringOperandDescription = /*@__PURE__*/ (() => {
    class WebDateFilteringOperandDescription extends WebBaseDateTimeFilteringOperandDescription {
        get_type() {
            return "WebDateFilteringOperand";
        }
        constructor() {
            super();
        }
    }
    WebDateFilteringOperandDescription.$t = /*@__PURE__*/ markType(WebDateFilteringOperandDescription, 'WebDateFilteringOperandDescription', WebBaseDateTimeFilteringOperandDescription.$);
    return WebDateFilteringOperandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDateFilteringOperandDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDateFilteringOperandDescriptionMetadata extends Base {
        static b(a) {
            if (WebDateFilteringOperandDescriptionMetadata.a == null) {
                WebDateFilteringOperandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDateFilteringOperandDescriptionMetadata.c(WebDateFilteringOperandDescriptionMetadata.a);
            }
            if (a.k(WebDateFilteringOperandDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDateFilteringOperandDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseDateTimeFilteringOperandDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:DateFilteringOperand");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebDateFilteringOperandDescriptionMetadata.b(a);
            a.ae("WebDateFilteringOperand", () => new WebDateFilteringOperandDescription());
            a.ad("WebDateFilteringOperand", WebDateFilteringOperandDescriptionMetadata.a);
        }
    }
    WebDateFilteringOperandDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDateFilteringOperandDescriptionMetadata, 'WebDateFilteringOperandDescriptionMetadata');
    WebDateFilteringOperandDescriptionMetadata.a = null;
    return WebDateFilteringOperandDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDatePickerDescription = /*@__PURE__*/ (() => {
    class WebDatePickerDescription extends WebBaseComboBoxLikeDescription {
        get_type() {
            return "WebDatePicker";
        }
        constructor() {
            super();
            this.a5 = null;
            this.a7 = null;
            this.aa = false;
            this.ac = false;
            this.ar = new Date();
            this.ao = new Date();
            this.aq = new Date();
            this.ap = new Date();
            this.a2 = null;
            this.bb = null;
            this.x = false;
            this.y = false;
            this.q = null;
            this.r = null;
            this.ab = false;
            this.bc = null;
            this.aw = 0;
            this.ae = false;
            this.a1 = null;
            this.a4 = null;
            this.a6 = null;
            this.bd = null;
            this.u = null;
            this.be = null;
            this.w = false;
            this.ad = false;
            this.a8 = null;
            this.z = false;
            this.ba = null;
            this.a9 = null;
            this.a0 = null;
            this.az = null;
            this.ay = null;
            this.a3 = null;
        }
        get label() {
            return this.a5;
        }
        set label(a) {
            this.a5 = a;
            this.g("Label");
        }
        get mode() {
            return this.a7;
        }
        set mode(a) {
            this.a7 = a;
            this.g("Mode");
        }
        get nonEditable() {
            return this.aa;
        }
        set nonEditable(a) {
            this.aa = a;
            this.g("NonEditable");
        }
        get readOnly() {
            return this.ac;
        }
        set readOnly(a) {
            this.ac = a;
            this.g("ReadOnly");
        }
        get value() {
            return this.ar;
        }
        set value(a) {
            this.ar = a;
            this.g("Value");
        }
        get activeDate() {
            return this.ao;
        }
        set activeDate(a) {
            this.ao = a;
            this.g("ActiveDate");
        }
        get min() {
            return this.aq;
        }
        set min(a) {
            this.aq = a;
            this.g("Min");
        }
        get max() {
            return this.ap;
        }
        set max(a) {
            this.ap = a;
            this.g("Max");
        }
        get headerOrientation() {
            return this.a2;
        }
        set headerOrientation(a) {
            this.a2 = a;
            this.g("HeaderOrientation");
        }
        get orientation() {
            return this.bb;
        }
        set orientation(a) {
            this.bb = a;
            this.g("Orientation");
        }
        get hideHeader() {
            return this.x;
        }
        set hideHeader(a) {
            this.x = a;
            this.g("HideHeader");
        }
        get hideOutsideDays() {
            return this.y;
        }
        set hideOutsideDays(a) {
            this.y = a;
            this.g("HideOutsideDays");
        }
        get disabledDates() {
            return this.q;
        }
        set disabledDates(a) {
            this.q = a;
            this.g("DisabledDates");
        }
        get specialDates() {
            return this.r;
        }
        set specialDates(a) {
            this.r = a;
            this.g("SpecialDates");
        }
        get outlined() {
            return this.ab;
        }
        set outlined(a) {
            this.ab = a;
            this.g("Outlined");
        }
        get placeholder() {
            return this.bc;
        }
        set placeholder(a) {
            this.bc = a;
            this.g("Placeholder");
        }
        get visibleMonths() {
            return this.aw;
        }
        set visibleMonths(a) {
            this.aw = a;
            this.g("VisibleMonths");
        }
        get showWeekNumbers() {
            return this.ae;
        }
        set showWeekNumbers(a) {
            this.ae = a;
            this.g("ShowWeekNumbers");
        }
        get displayFormat() {
            return this.a1;
        }
        set displayFormat(a) {
            this.a1 = a;
            this.g("DisplayFormat");
        }
        get inputFormat() {
            return this.a4;
        }
        set inputFormat(a) {
            this.a4 = a;
            this.g("InputFormat");
        }
        get locale() {
            return this.a6;
        }
        set locale(a) {
            this.a6 = a;
            this.g("Locale");
        }
        get prompt() {
            return this.bd;
        }
        set prompt(a) {
            this.bd = a;
            this.g("Prompt");
        }
        get resourceStrings() {
            return this.u;
        }
        set resourceStrings(a) {
            this.u = a;
            this.g("ResourceStrings");
        }
        get weekStart() {
            return this.be;
        }
        set weekStart(a) {
            this.be = a;
            this.g("WeekStart");
        }
        get disabled() {
            return this.w;
        }
        set disabled(a) {
            this.w = a;
            this.g("Disabled");
        }
        get required() {
            return this.ad;
        }
        set required(a) {
            this.ad = a;
            this.g("Required");
        }
        get name() {
            return this.a8;
        }
        set name(a) {
            this.a8 = a;
            this.g("Name");
        }
        get invalid() {
            return this.z;
        }
        set invalid(a) {
            this.z = a;
            this.g("Invalid");
        }
        get openingRef() {
            return this.ba;
        }
        set openingRef(a) {
            this.ba = a;
            this.g("OpeningRef");
        }
        get openedRef() {
            return this.a9;
        }
        set openedRef(a) {
            this.a9 = a;
            this.g("OpenedRef");
        }
        get closingRef() {
            return this.a0;
        }
        set closingRef(a) {
            this.a0 = a;
            this.g("ClosingRef");
        }
        get closedRef() {
            return this.az;
        }
        set closedRef(a) {
            this.az = a;
            this.g("ClosedRef");
        }
        get changeRef() {
            return this.ay;
        }
        set changeRef(a) {
            this.ay = a;
            this.g("ChangeRef");
        }
        get inputRef() {
            return this.a3;
        }
        set inputRef(a) {
            this.a3 = a;
            this.g("InputRef");
        }
    }
    WebDatePickerDescription.$t = /*@__PURE__*/ markType(WebDatePickerDescription, 'WebDatePickerDescription', WebBaseComboBoxLikeDescription.$);
    return WebDatePickerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDatePickerDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDatePickerDescriptionMetadata extends Base {
        static b(a) {
            if (WebDatePickerDescriptionMetadata.a == null) {
                WebDatePickerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDatePickerDescriptionMetadata.c(WebDatePickerDescriptionMetadata.a);
            }
            if (a.k(WebDatePickerDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDatePickerDescriptionMetadata.a);
            DateRangeDescriptorDescriptionMetadata.d(a);
            WebCalendarResourceStringsDescriptionMetadata.d(a);
            VoidEventArgsDescriptionMetadata.d(a);
            WebComponentDateValueChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseComboBoxLikeDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:DatePicker");
            a.item("__tagNameWC", "String:igc-date-picker");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Label", "String");
            a.item("Mode", "ExportedType:string:DatePickerMode");
            a.item("Mode@stringUnion", "WebComponents;React");
            a.item("Mode@names", "Dropdown;Dialog");
            a.item("NonEditable", "Boolean");
            a.item("ReadOnly", "Boolean");
            a.item("Value", "Date");
            a.item("ActiveDate", "Date");
            a.item("Min", "Date");
            a.item("Max", "Date");
            a.item("HeaderOrientation", "ExportedType:string:DatePickerHeaderOrientation");
            a.item("HeaderOrientation@stringUnion", "WebComponents;React");
            a.item("HeaderOrientation@names", "Horizontal;Vertical");
            a.item("Orientation", "ExportedType:string:DatePickerOrientation");
            a.item("Orientation@stringUnion", "WebComponents;React");
            a.item("Orientation@names", "Horizontal;Vertical");
            a.item("HideHeader", "Boolean");
            a.item("HideOutsideDays", "Boolean");
            a.item("DisabledDates", "Array:DateRangeDescriptorDescription:IDateRangeDescriptor");
            a.item("SpecialDates", "Array:DateRangeDescriptorDescription:IDateRangeDescriptor");
            a.item("Outlined", "Boolean");
            a.item("Placeholder", "String");
            a.item("VisibleMonths", "Number:double");
            a.item("ShowWeekNumbers", "Boolean");
            a.item("DisplayFormat", "String");
            a.item("InputFormat", "String");
            a.item("Locale", "String");
            a.item("Prompt", "String");
            a.item("ResourceStrings", "ExportedType:WebCalendarResourceStrings");
            a.item("WeekStart", "ExportedType:string:WeekDays");
            a.item("WeekStart@stringUnion", "WebComponents;React");
            a.item("WeekStart@names", "Sunday;Monday;Tuesday;Wednesday;Thursday;Friday;Saturday");
            a.item("Disabled", "Boolean");
            a.item("Required", "Boolean");
            a.item("Name", "String");
            a.item("Invalid", "Boolean");
            a.item("OpeningRef", "EventRef::opening");
            a.item("OpenedRef", "EventRef::opened");
            a.item("ClosingRef", "EventRef::closing");
            a.item("ClosedRef", "EventRef::closed");
            a.item("ChangeRef", "EventRef::change");
            a.item("InputRef", "EventRef::input");
        }
        static d(a) {
            WebDatePickerDescriptionMetadata.b(a);
            a.ae("WebDatePicker", () => new WebDatePickerDescription());
            a.ad("WebDatePicker", WebDatePickerDescriptionMetadata.a);
        }
    }
    WebDatePickerDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDatePickerDescriptionMetadata, 'WebDatePickerDescriptionMetadata');
    WebDatePickerDescriptionMetadata.a = null;
    return WebDatePickerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebMaskInputBaseDescriptionModule = /*@__PURE__*/ (() => {
    class WebMaskInputBaseDescriptionModule extends Base {
        static register(a) {
            WebInputBaseDescriptionModule.register(a);
        }
    }
    WebMaskInputBaseDescriptionModule.$t = /*@__PURE__*/ markType(WebMaskInputBaseDescriptionModule, 'WebMaskInputBaseDescriptionModule');
    return WebMaskInputBaseDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebMaskInputBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebMaskInputBaseDescriptionMetadata extends Base {
        static b(a) {
            if (WebMaskInputBaseDescriptionMetadata.a == null) {
                WebMaskInputBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebMaskInputBaseDescriptionMetadata.c(WebMaskInputBaseDescriptionMetadata.a);
            }
            if (a.k(WebMaskInputBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebMaskInputBaseDescriptionMetadata.a);
        }
        static c(a) {
            WebInputBaseDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:MaskInputBase");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Prompt", "String");
        }
        static d(a) {
            WebMaskInputBaseDescriptionMetadata.b(a);
            a.ad("WebMaskInputBase", WebMaskInputBaseDescriptionMetadata.a);
        }
    }
    WebMaskInputBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(WebMaskInputBaseDescriptionMetadata, 'WebMaskInputBaseDescriptionMetadata');
    WebMaskInputBaseDescriptionMetadata.a = null;
    return WebMaskInputBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebMaskInputBaseDescription = /*@__PURE__*/ (() => {
    class WebMaskInputBaseDescription extends WebInputBaseDescription {
        get_type() {
            return "WebMaskInputBase";
        }
        constructor() {
            super();
            this.ae = null;
        }
        get prompt() {
            return this.ae;
        }
        set prompt(a) {
            this.ae = a;
            this.g("Prompt");
        }
    }
    WebMaskInputBaseDescription.$t = /*@__PURE__*/ markType(WebMaskInputBaseDescription, 'WebMaskInputBaseDescription', WebInputBaseDescription.$);
    return WebMaskInputBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDateTimeInputDescription = /*@__PURE__*/ (() => {
    class WebDateTimeInputDescription extends WebMaskInputBaseDescription {
        get_type() {
            return "WebDateTimeInput";
        }
        constructor() {
            super();
            this.as = null;
            this.am = new Date();
            this.al = new Date();
            this.ak = new Date();
            this.ar = null;
            this.ag = null;
            this.ai = false;
            this.at = null;
            this.aq = null;
        }
        get inputFormat() {
            return this.as;
        }
        set inputFormat(a) {
            this.as = a;
            this.g("InputFormat");
        }
        get value() {
            return this.am;
        }
        set value(a) {
            this.am = a;
            this.g("Value");
        }
        get min() {
            return this.al;
        }
        set min(a) {
            this.al = a;
            this.g("Min");
        }
        get max() {
            return this.ak;
        }
        set max(a) {
            this.ak = a;
            this.g("Max");
        }
        get displayFormat() {
            return this.ar;
        }
        set displayFormat(a) {
            this.ar = a;
            this.g("DisplayFormat");
        }
        get spinDelta() {
            return this.ag;
        }
        set spinDelta(a) {
            this.ag = a;
            this.g("SpinDelta");
        }
        get spinLoop() {
            return this.ai;
        }
        set spinLoop(a) {
            this.ai = a;
            this.g("SpinLoop");
        }
        get locale() {
            return this.at;
        }
        set locale(a) {
            this.at = a;
            this.g("Locale");
        }
        get changeRef() {
            return this.aq;
        }
        set changeRef(a) {
            this.aq = a;
            this.g("ChangeRef");
        }
    }
    WebDateTimeInputDescription.$t = /*@__PURE__*/ markType(WebDateTimeInputDescription, 'WebDateTimeInputDescription', WebMaskInputBaseDescription.$);
    return WebDateTimeInputDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDateTimeInputDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDateTimeInputDescriptionMetadata extends Base {
        static b(a) {
            if (WebDateTimeInputDescriptionMetadata.a == null) {
                WebDateTimeInputDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDateTimeInputDescriptionMetadata.c(WebDateTimeInputDescriptionMetadata.a);
            }
            if (a.k(WebDateTimeInputDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDateTimeInputDescriptionMetadata.a);
            DatePartDeltasDescriptionMetadata.d(a);
            WebComponentDateValueChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebMaskInputBaseDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:DateTimeInput");
            a.item("__tagNameWC", "String:igc-date-time-input");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("InputFormat", "String");
            a.item("Value", "Date");
            a.item("Min", "Date");
            a.item("Max", "Date");
            a.item("DisplayFormat", "String");
            a.item("SpinDelta", "ExportedType:DatePartDeltas");
            a.item("SpinLoop", "Boolean");
            a.item("Locale", "String");
            a.item("ChangeRef", "EventRef::change");
        }
        static d(a) {
            WebDateTimeInputDescriptionMetadata.b(a);
            a.ae("WebDateTimeInput", () => new WebDateTimeInputDescription());
            a.ad("WebDateTimeInput", WebDateTimeInputDescriptionMetadata.a);
        }
    }
    WebDateTimeInputDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDateTimeInputDescriptionMetadata, 'WebDateTimeInputDescriptionMetadata');
    WebDateTimeInputDescriptionMetadata.a = null;
    return WebDateTimeInputDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDateTimeInputDescriptionModule = /*@__PURE__*/ (() => {
    class WebDateTimeInputDescriptionModule extends Base {
        static register(a) {
            WebMaskInputBaseDescriptionModule.register(a);
            WebDateTimeInputDescriptionMetadata.d(a);
        }
    }
    WebDateTimeInputDescriptionModule.$t = /*@__PURE__*/ markType(WebDateTimeInputDescriptionModule, 'WebDateTimeInputDescriptionModule');
    return WebDateTimeInputDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDialogDescription = /*@__PURE__*/ (() => {
    class WebDialogDescription extends Description {
        get_type() {
            return "WebDialog";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = false;
            this.h = false;
            this.i = false;
            this.k = false;
            this.s = null;
            this.r = null;
            this.q = null;
            this.p = null;
        }
        get keepOpenOnEscape() {
            return this.j;
        }
        set keepOpenOnEscape(a) {
            this.j = a;
            this.g("KeepOpenOnEscape");
        }
        get closeOnOutsideClick() {
            return this.h;
        }
        set closeOnOutsideClick(a) {
            this.h = a;
            this.g("CloseOnOutsideClick");
        }
        get hideDefaultAction() {
            return this.i;
        }
        set hideDefaultAction(a) {
            this.i = a;
            this.g("HideDefaultAction");
        }
        get open() {
            return this.k;
        }
        set open(a) {
            this.k = a;
            this.g("Open");
        }
        get title() {
            return this.s;
        }
        set title(a) {
            this.s = a;
            this.g("Title");
        }
        get returnValue() {
            return this.r;
        }
        set returnValue(a) {
            this.r = a;
            this.g("ReturnValue");
        }
        get closingRef() {
            return this.q;
        }
        set closingRef(a) {
            this.q = a;
            this.g("ClosingRef");
        }
        get closedRef() {
            return this.p;
        }
        set closedRef(a) {
            this.p = a;
            this.g("ClosedRef");
        }
    }
    WebDialogDescription.$t = /*@__PURE__*/ markType(WebDialogDescription, 'WebDialogDescription', Description.$);
    return WebDialogDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDialogDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDialogDescriptionMetadata extends Base {
        static b(a) {
            if (WebDialogDescriptionMetadata.a == null) {
                WebDialogDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDialogDescriptionMetadata.c(WebDialogDescriptionMetadata.a);
            }
            if (a.k(WebDialogDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDialogDescriptionMetadata.a);
            VoidEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Dialog");
            a.item("__tagNameWC", "String:igc-dialog");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("KeepOpenOnEscape", "Boolean");
            a.item("CloseOnOutsideClick", "Boolean");
            a.item("HideDefaultAction", "Boolean");
            a.item("Open", "Boolean");
            a.item("Title", "String");
            a.item("ReturnValue", "String");
            a.item("ClosingRef", "EventRef::closing");
            a.item("ClosedRef", "EventRef::closed");
        }
        static d(a) {
            WebDialogDescriptionMetadata.b(a);
            a.ae("WebDialog", () => new WebDialogDescription());
            a.ad("WebDialog", WebDialogDescriptionMetadata.a);
        }
    }
    WebDialogDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDialogDescriptionMetadata, 'WebDialogDescriptionMetadata');
    WebDialogDescriptionMetadata.a = null;
    return WebDialogDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDialogDescriptionModule = /*@__PURE__*/ (() => {
    class WebDialogDescriptionModule extends Base {
        static register(a) {
            WebButtonDescriptionModule.register(a);
            WebDialogDescriptionMetadata.d(a);
        }
    }
    WebDialogDescriptionModule.$t = /*@__PURE__*/ markType(WebDialogDescriptionModule, 'WebDialogDescriptionModule');
    return WebDialogDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDatePickerDescriptionModule = /*@__PURE__*/ (() => {
    class WebDatePickerDescriptionModule extends Base {
        static register(a) {
            WebBaseComboBoxLikeDescriptionModule.register(a);
            WebCalendarDescriptionModule.register(a);
            WebDateTimeInputDescriptionModule.register(a);
            WebDialogDescriptionModule.register(a);
            WebIconDescriptionModule.register(a);
            WebDatePickerDescriptionMetadata.d(a);
        }
    }
    WebDatePickerDescriptionModule.$t = /*@__PURE__*/ markType(WebDatePickerDescriptionModule, 'WebDatePickerDescriptionModule');
    return WebDatePickerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSummaryOperandDescription = /*@__PURE__*/ (() => {
    class WebSummaryOperandDescription extends Description {
        get_type() {
            return "WebSummaryOperand";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebSummaryOperandDescription.$t = /*@__PURE__*/ markType(WebSummaryOperandDescription, 'WebSummaryOperandDescription', Description.$);
    return WebSummaryOperandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDateSummaryOperandDescription = /*@__PURE__*/ (() => {
    class WebDateSummaryOperandDescription extends WebSummaryOperandDescription {
        get_type() {
            return "WebDateSummaryOperand";
        }
        constructor() {
            super();
        }
    }
    WebDateSummaryOperandDescription.$t = /*@__PURE__*/ markType(WebDateSummaryOperandDescription, 'WebDateSummaryOperandDescription', WebSummaryOperandDescription.$);
    return WebDateSummaryOperandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSummaryOperandDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSummaryOperandDescriptionMetadata extends Base {
        static b(a) {
            if (WebSummaryOperandDescriptionMetadata.a == null) {
                WebSummaryOperandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSummaryOperandDescriptionMetadata.c(WebSummaryOperandDescriptionMetadata.a);
            }
            if (a.k(WebSummaryOperandDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSummaryOperandDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:SummaryOperand");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebSummaryOperandDescriptionMetadata.b(a);
            a.ae("WebSummaryOperand", () => new WebSummaryOperandDescription());
            a.ad("WebSummaryOperand", WebSummaryOperandDescriptionMetadata.a);
        }
    }
    WebSummaryOperandDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSummaryOperandDescriptionMetadata, 'WebSummaryOperandDescriptionMetadata');
    WebSummaryOperandDescriptionMetadata.a = null;
    return WebSummaryOperandDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDateSummaryOperandDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDateSummaryOperandDescriptionMetadata extends Base {
        static b(a) {
            if (WebDateSummaryOperandDescriptionMetadata.a == null) {
                WebDateSummaryOperandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDateSummaryOperandDescriptionMetadata.c(WebDateSummaryOperandDescriptionMetadata.a);
            }
            if (a.k(WebDateSummaryOperandDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDateSummaryOperandDescriptionMetadata.a);
        }
        static c(a) {
            WebSummaryOperandDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:DateSummaryOperand");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebDateSummaryOperandDescriptionMetadata.b(a);
            a.ae("WebDateSummaryOperand", () => new WebDateSummaryOperandDescription());
            a.ad("WebDateSummaryOperand", WebDateSummaryOperandDescriptionMetadata.a);
        }
    }
    WebDateSummaryOperandDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDateSummaryOperandDescriptionMetadata, 'WebDateSummaryOperandDescriptionMetadata');
    WebDateSummaryOperandDescriptionMetadata.a = null;
    return WebDateSummaryOperandDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDateTimeFilteringOperandDescription = /*@__PURE__*/ (() => {
    class WebDateTimeFilteringOperandDescription extends WebBaseDateTimeFilteringOperandDescription {
        get_type() {
            return "WebDateTimeFilteringOperand";
        }
        constructor() {
            super();
        }
    }
    WebDateTimeFilteringOperandDescription.$t = /*@__PURE__*/ markType(WebDateTimeFilteringOperandDescription, 'WebDateTimeFilteringOperandDescription', WebBaseDateTimeFilteringOperandDescription.$);
    return WebDateTimeFilteringOperandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDateTimeFilteringOperandDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDateTimeFilteringOperandDescriptionMetadata extends Base {
        static b(a) {
            if (WebDateTimeFilteringOperandDescriptionMetadata.a == null) {
                WebDateTimeFilteringOperandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDateTimeFilteringOperandDescriptionMetadata.c(WebDateTimeFilteringOperandDescriptionMetadata.a);
            }
            if (a.k(WebDateTimeFilteringOperandDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDateTimeFilteringOperandDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseDateTimeFilteringOperandDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:DateTimeFilteringOperand");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebDateTimeFilteringOperandDescriptionMetadata.b(a);
            a.ae("WebDateTimeFilteringOperand", () => new WebDateTimeFilteringOperandDescription());
            a.ad("WebDateTimeFilteringOperand", WebDateTimeFilteringOperandDescriptionMetadata.a);
        }
    }
    WebDateTimeFilteringOperandDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDateTimeFilteringOperandDescriptionMetadata, 'WebDateTimeFilteringOperandDescriptionMetadata');
    WebDateTimeFilteringOperandDescriptionMetadata.a = null;
    return WebDateTimeFilteringOperandDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDimensionsChangeDescription = /*@__PURE__*/ (() => {
    class WebDimensionsChangeDescription extends Description {
        get_type() {
            return "WebDimensionsChange";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = null;
        }
        get dimensions() {
            return this.h;
        }
        set dimensions(a) {
            this.h = a;
            this.g("Dimensions");
        }
        get dimensionCollectionType() {
            return this.j;
        }
        set dimensionCollectionType(a) {
            this.j = a;
            this.g("DimensionCollectionType");
        }
    }
    WebDimensionsChangeDescription.$t = /*@__PURE__*/ markType(WebDimensionsChangeDescription, 'WebDimensionsChangeDescription', Description.$);
    return WebDimensionsChangeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDimensionDescription = /*@__PURE__*/ (() => {
    class WebPivotDimensionDescription extends Description {
        get_type() {
            return "WebPivotDimension";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.y = null;
            this.w = null;
            this.m = false;
            this.h = null;
            this.o = false;
            this.z = null;
            this.v = null;
            this.aa = null;
            this.s = 0;
            this.n = false;
            this.x = null;
        }
        get childLevel() {
            return this.j;
        }
        set childLevel(a) {
            this.j = a;
            this.g("ChildLevel");
        }
        get memberName() {
            return this.y;
        }
        set memberName(a) {
            this.y = a;
            this.g("MemberName");
        }
        get displayName() {
            return this.w;
        }
        set displayName(a) {
            this.w = a;
            this.g("DisplayName");
        }
        get enabled() {
            return this.m;
        }
        set enabled(a) {
            this.m = a;
            this.g("Enabled");
        }
        get filter() {
            return this.h;
        }
        set filter(a) {
            this.h = a;
            this.g("Filter");
        }
        get sortable() {
            return this.o;
        }
        set sortable(a) {
            this.o = a;
            this.g("Sortable");
        }
        get sortDirection() {
            return this.z;
        }
        set sortDirection(a) {
            this.z = a;
            this.g("SortDirection");
        }
        get dataType() {
            return this.v;
        }
        set dataType(a) {
            this.v = a;
            this.g("DataType");
        }
        get width() {
            return this.aa;
        }
        set width(a) {
            this.aa = a;
            this.g("Width");
        }
        get level() {
            return this.s;
        }
        set level(a) {
            this.s = a;
            this.g("Level");
        }
        get horizontalSummary() {
            return this.n;
        }
        set horizontalSummary(a) {
            this.n = a;
            this.g("HorizontalSummary");
        }
        get memberFunctionRef() {
            return this.x;
        }
        set memberFunctionRef(a) {
            this.x = a;
            this.g("MemberFunctionRef");
        }
    }
    WebPivotDimensionDescription.$t = /*@__PURE__*/ markType(WebPivotDimensionDescription, 'WebPivotDimensionDescription', Description.$);
    WebPivotDimensionDescription.__marshalByValue = true;
    WebPivotDimensionDescription.__marshalByValueAlias = "PivotDimension";
    return WebPivotDimensionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDimensionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotDimensionDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotDimensionDescriptionMetadata.a == null) {
                WebPivotDimensionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotDimensionDescriptionMetadata.c(WebPivotDimensionDescriptionMetadata.a);
            }
            if (a.k(WebPivotDimensionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotDimensionDescriptionMetadata.a);
            WebPivotDimensionDescriptionMetadata.d(a);
            WebFilteringExpressionsTreeDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotDimension");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("ChildLevel", "ExportedType:WebPivotDimension");
            a.item("MemberName", "String");
            a.item("DisplayName", "String");
            a.item("Enabled", "Boolean");
            a.item("Filter", "ExportedType:WebFilteringExpressionsTree");
            a.item("Sortable", "Boolean");
            a.item("SortDirection", "ExportedType:string:SortingDirection");
            a.item("SortDirection@names", "None;Asc;Desc");
            a.item("DataType", "ExportedType:string:GridColumnDataType");
            a.item("DataType@stringUnion", "WebComponents;React");
            a.item("DataType@names", "String;Number;Boolean;Date;DateTime;Time;Currency;Percent;Image");
            a.item("Width", "String");
            a.item("Level", "Number:double");
            a.item("HorizontalSummary", "Boolean");
            a.item("MemberFunctionRef", "EventRef::memberFunction");
        }
        static d(a) {
            WebPivotDimensionDescriptionMetadata.b(a);
            a.ae("WebPivotDimension", () => new WebPivotDimensionDescription());
            a.ad("WebPivotDimension", WebPivotDimensionDescriptionMetadata.a);
        }
    }
    WebPivotDimensionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotDimensionDescriptionMetadata, 'WebPivotDimensionDescriptionMetadata');
    WebPivotDimensionDescriptionMetadata.a = null;
    return WebPivotDimensionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDimensionsChangeDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDimensionsChangeDescriptionMetadata extends Base {
        static b(a) {
            if (WebDimensionsChangeDescriptionMetadata.a == null) {
                WebDimensionsChangeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDimensionsChangeDescriptionMetadata.c(WebDimensionsChangeDescriptionMetadata.a);
            }
            if (a.k(WebDimensionsChangeDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDimensionsChangeDescriptionMetadata.a);
            WebPivotDimensionDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:DimensionsChange");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Dimensions", "Array:WebPivotDimensionDescription:PivotDimension");
            a.item("DimensionCollectionType", "ExportedType:string:PivotDimensionType");
            a.item("DimensionCollectionType@names", "Row;Column;Filter");
        }
        static d(a) {
            WebDimensionsChangeDescriptionMetadata.b(a);
            a.ae("WebDimensionsChange", () => new WebDimensionsChangeDescription());
            a.ad("WebDimensionsChange", WebDimensionsChangeDescriptionMetadata.a);
        }
    }
    WebDimensionsChangeDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDimensionsChangeDescriptionMetadata, 'WebDimensionsChangeDescriptionMetadata');
    WebDimensionsChangeDescriptionMetadata.a = null;
    return WebDimensionsChangeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDimensionsChangeDetailDescription = /*@__PURE__*/ (() => {
    class WebDimensionsChangeDetailDescription extends Description {
        get_type() {
            return "WebDimensionsChangeDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.l = null;
        }
        get dimensions() {
            return this.h;
        }
        set dimensions(a) {
            this.h = a;
            this.g("Dimensions");
        }
        get dimensionCollectionType() {
            return this.l;
        }
        set dimensionCollectionType(a) {
            this.l = a;
            this.g("DimensionCollectionType");
        }
    }
    WebDimensionsChangeDetailDescription.$t = /*@__PURE__*/ markType(WebDimensionsChangeDetailDescription, 'WebDimensionsChangeDetailDescription', Description.$);
    WebDimensionsChangeDetailDescription.__marshalByValue = true;
    WebDimensionsChangeDetailDescription.__marshalByValueAlias = "DimensionsChangeDetail";
    return WebDimensionsChangeDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDimensionsChangeDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDimensionsChangeDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebDimensionsChangeDetailDescriptionMetadata.a == null) {
                WebDimensionsChangeDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDimensionsChangeDetailDescriptionMetadata.c(WebDimensionsChangeDetailDescriptionMetadata.a);
            }
            if (a.k(WebDimensionsChangeDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDimensionsChangeDetailDescriptionMetadata.a);
            WebPivotDimensionDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:DimensionsChangeDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Dimensions", "Array:WebPivotDimensionDescription:PivotDimension");
            a.item("DimensionCollectionType", "ExportedType:string:PivotDimensionType");
            a.item("DimensionCollectionType@names", "Row;Column;Filter");
        }
        static d(a) {
            WebDimensionsChangeDetailDescriptionMetadata.b(a);
            a.ae("WebDimensionsChangeDetail", () => new WebDimensionsChangeDetailDescription());
            a.ad("WebDimensionsChangeDetail", WebDimensionsChangeDetailDescriptionMetadata.a);
        }
    }
    WebDimensionsChangeDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDimensionsChangeDetailDescriptionMetadata, 'WebDimensionsChangeDetailDescriptionMetadata');
    WebDimensionsChangeDetailDescriptionMetadata.a = null;
    return WebDimensionsChangeDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDimensionsChangeEventArgsDescription = /*@__PURE__*/ (() => {
    class WebDimensionsChangeEventArgsDescription extends Description {
        get_type() {
            return "WebDimensionsChangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebDimensionsChangeEventArgsDescription.$t = /*@__PURE__*/ markType(WebDimensionsChangeEventArgsDescription, 'WebDimensionsChangeEventArgsDescription', Description.$);
    WebDimensionsChangeEventArgsDescription.__marshalByValue = true;
    WebDimensionsChangeEventArgsDescription.__marshalByValueAlias = "DimensionsChangeEventArgs";
    return WebDimensionsChangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDimensionsChangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDimensionsChangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebDimensionsChangeEventArgsDescriptionMetadata.a == null) {
                WebDimensionsChangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDimensionsChangeEventArgsDescriptionMetadata.c(WebDimensionsChangeEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebDimensionsChangeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDimensionsChangeEventArgsDescriptionMetadata.a);
            WebDimensionsChangeDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:DimensionsChangeEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebDimensionsChangeDetail");
        }
        static d(a) {
            WebDimensionsChangeEventArgsDescriptionMetadata.b(a);
            a.ae("WebDimensionsChangeEventArgs", () => new WebDimensionsChangeEventArgsDescription());
            a.ad("WebDimensionsChangeEventArgs", WebDimensionsChangeEventArgsDescriptionMetadata.a);
        }
    }
    WebDimensionsChangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDimensionsChangeEventArgsDescriptionMetadata, 'WebDimensionsChangeEventArgsDescriptionMetadata');
    WebDimensionsChangeEventArgsDescriptionMetadata.a = null;
    return WebDimensionsChangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDividerDescription = /*@__PURE__*/ (() => {
    class WebDividerDescription extends Description {
        get_type() {
            return "WebDivider";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = false;
            this.h = false;
            this.l = null;
        }
        get vertical() {
            return this.i;
        }
        set vertical(a) {
            this.i = a;
            this.g("Vertical");
        }
        get middle() {
            return this.h;
        }
        set middle(a) {
            this.h = a;
            this.g("Middle");
        }
        get lineType() {
            return this.l;
        }
        set lineType(a) {
            this.l = a;
            this.g("LineType");
        }
    }
    WebDividerDescription.$t = /*@__PURE__*/ markType(WebDividerDescription, 'WebDividerDescription', Description.$);
    return WebDividerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDividerDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDividerDescriptionMetadata extends Base {
        static b(a) {
            if (WebDividerDescriptionMetadata.a == null) {
                WebDividerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDividerDescriptionMetadata.c(WebDividerDescriptionMetadata.a);
            }
            if (a.k(WebDividerDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDividerDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Divider");
            a.item("__tagNameWC", "String:igc-divider");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Vertical", "Boolean");
            a.item("Middle", "Boolean");
            a.item("LineType", "(wc:Type)ExportedType:string:DividerType");
            a.item("LineType@stringUnion", "WebComponents;React");
            a.item("LineType@names", "Solid;Dashed");
        }
        static d(a) {
            WebDividerDescriptionMetadata.b(a);
            a.ae("WebDivider", () => new WebDividerDescription());
            a.ad("WebDivider", WebDividerDescriptionMetadata.a);
        }
    }
    WebDividerDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDividerDescriptionMetadata, 'WebDividerDescriptionMetadata');
    WebDividerDescriptionMetadata.a = null;
    return WebDividerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDividerDescriptionModule = /*@__PURE__*/ (() => {
    class WebDividerDescriptionModule extends Base {
        static register(a) {
            WebDividerDescriptionMetadata.d(a);
        }
    }
    WebDividerDescriptionModule.$t = /*@__PURE__*/ markType(WebDividerDescriptionModule, 'WebDividerDescriptionModule');
    return WebDividerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockingIndicatorDescription = /*@__PURE__*/ (() => {
    class WebDockingIndicatorDescription extends Description {
        get_type() {
            return "WebDockingIndicator";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = null;
            this.h = false;
            this.j = null;
        }
        get position() {
            return this.k;
        }
        set position(a) {
            this.k = a;
            this.g("Position");
        }
        get isRoot() {
            return this.h;
        }
        set isRoot(a) {
            this.h = a;
            this.g("IsRoot");
        }
        get direction() {
            return this.j;
        }
        set direction(a) {
            this.j = a;
            this.g("Direction");
        }
    }
    WebDockingIndicatorDescription.$t = /*@__PURE__*/ markType(WebDockingIndicatorDescription, 'WebDockingIndicatorDescription', Description.$);
    return WebDockingIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockingIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDockingIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (WebDockingIndicatorDescriptionMetadata.a == null) {
                WebDockingIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDockingIndicatorDescriptionMetadata.c(WebDockingIndicatorDescriptionMetadata.a);
            }
            if (a.k(WebDockingIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDockingIndicatorDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:DockingIndicator");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__skipSuffix", "Boolean");
            a.item("Position", "ExportedType:string:DockingIndicatorPosition");
            a.item("Position@stringUnion", "WebComponents;React");
            a.item("Position@names", "Left;OuterLeft;Right;OuterRight;Top;OuterTop;Bottom;OuterBottom;Center");
            a.item("IsRoot", "Boolean");
            a.item("Direction", "String");
        }
        static d(a) {
            WebDockingIndicatorDescriptionMetadata.b(a);
            a.ae("WebDockingIndicator", () => new WebDockingIndicatorDescription());
            a.ad("WebDockingIndicator", WebDockingIndicatorDescriptionMetadata.a);
        }
    }
    WebDockingIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDockingIndicatorDescriptionMetadata, 'WebDockingIndicatorDescriptionMetadata');
    WebDockingIndicatorDescriptionMetadata.a = null;
    return WebDockingIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockManagerDescription = /*@__PURE__*/ (() => {
    class WebDockManagerDescription extends Description {
        get_type() {
            return "WebDockManager";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.l = null;
            this.p = null;
            this.h = null;
            this.v = false;
            this.w = false;
            this.ag = null;
            this.m = null;
            this.r = null;
            this.t = false;
            this.x = false;
            this.u = false;
            this.ah = null;
            this.y = false;
            this.af = null;
        }
        get layout() {
            return this.j;
        }
        set layout(a) {
            this.j = a;
            this.g("Layout");
        }
        get draggedPane() {
            return this.l;
        }
        set draggedPane(a) {
            this.l = a;
            this.g("DraggedPane");
        }
        get dropPosition() {
            return this.p;
        }
        set dropPosition(a) {
            this.p = a;
            this.g("DropPosition");
        }
        get activePane() {
            return this.h;
        }
        set activePane(a) {
            this.h = a;
            this.g("ActivePane");
        }
        get allowMaximize() {
            return this.v;
        }
        set allowMaximize(a) {
            this.v = a;
            this.g("AllowMaximize");
        }
        get containedInBoundaries() {
            return this.w;
        }
        set containedInBoundaries(a) {
            this.w = a;
            this.g("ContainedInBoundaries");
        }
        get showHeaderIconOnHover() {
            return this.ag;
        }
        set showHeaderIconOnHover(a) {
            this.ag = a;
            this.g("ShowHeaderIconOnHover");
        }
        get maximizedPane() {
            return this.m;
        }
        set maximizedPane(a) {
            this.m = a;
            this.g("MaximizedPane");
        }
        get resourceStrings() {
            return this.r;
        }
        set resourceStrings(a) {
            this.r = a;
            this.g("ResourceStrings");
        }
        get allowFloatingPanesResize() {
            return this.t;
        }
        set allowFloatingPanesResize(a) {
            this.t = a;
            this.g("AllowFloatingPanesResize");
        }
        get disableKeyboardNavigation() {
            return this.x;
        }
        set disableKeyboardNavigation(a) {
            this.x = a;
            this.g("DisableKeyboardNavigation");
        }
        get allowInnerDock() {
            return this.u;
        }
        set allowInnerDock(a) {
            this.u = a;
            this.g("AllowInnerDock");
        }
        get showPaneHeaders() {
            return this.ah;
        }
        set showPaneHeaders(a) {
            this.ah = a;
            this.g("ShowPaneHeaders");
        }
        get proximityDock() {
            return this.y;
        }
        set proximityDock(a) {
            this.y = a;
            this.g("ProximityDock");
        }
        get layoutChangeRef() {
            return this.af;
        }
        set layoutChangeRef(a) {
            this.af = a;
            this.g("LayoutChangeRef");
        }
    }
    WebDockManagerDescription.$t = /*@__PURE__*/ markType(WebDockManagerDescription, 'WebDockManagerDescription', Description.$);
    return WebDockManagerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockManagerPointDescription = /*@__PURE__*/ (() => {
    class WebDockManagerPointDescription extends Description {
        get_type() {
            return "WebDockManagerPoint";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = 0;
            this.j = 0;
        }
        get x() {
            return this.i;
        }
        set x(a) {
            this.i = a;
            this.g("X");
        }
        get y() {
            return this.j;
        }
        set y(a) {
            this.j = a;
            this.g("Y");
        }
    }
    WebDockManagerPointDescription.$t = /*@__PURE__*/ markType(WebDockManagerPointDescription, 'WebDockManagerPointDescription', Description.$);
    WebDockManagerPointDescription.__marshalByValue = true;
    WebDockManagerPointDescription.__marshalByValueAlias = "DockManagerPoint";
    return WebDockManagerPointDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockManagerPointDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDockManagerPointDescriptionMetadata extends Base {
        static b(a) {
            if (WebDockManagerPointDescriptionMetadata.a == null) {
                WebDockManagerPointDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDockManagerPointDescriptionMetadata.c(WebDockManagerPointDescriptionMetadata.a);
            }
            if (a.k(WebDockManagerPointDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDockManagerPointDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:DockManagerPoint");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("X", "Number:double");
            a.item("Y", "Number:double");
        }
        static d(a) {
            WebDockManagerPointDescriptionMetadata.b(a);
            a.ae("WebDockManagerPoint", () => new WebDockManagerPointDescription());
            a.ad("WebDockManagerPoint", WebDockManagerPointDescriptionMetadata.a);
        }
    }
    WebDockManagerPointDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDockManagerPointDescriptionMetadata, 'WebDockManagerPointDescriptionMetadata');
    WebDockManagerPointDescriptionMetadata.a = null;
    return WebDockManagerPointDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSplitPaneDescription = /*@__PURE__*/ (() => {
    class WebSplitPaneDescription extends WebDockManagerPaneDescription {
        get_type() {
            return "WebSplitPane";
        }
        constructor() {
            super();
            this.ae = null;
            this.ag = null;
            this.af = null;
            this.m = null;
            this.z = 0;
            this.o = null;
            this.y = 0;
            this.x = 0;
            this.s = false;
            this.r = false;
            this.t = false;
        }
        get id() {
            return this.ae;
        }
        set id(a) {
            this.ae = a;
            this.g("Id");
        }
        get paneType() {
            return this.ag;
        }
        set paneType(a) {
            this.ag = a;
            this.g("PaneType");
        }
        get orientation() {
            return this.af;
        }
        set orientation(a) {
            this.af = a;
            this.g("Orientation");
        }
        get panes() {
            return this.m;
        }
        set panes(a) {
            this.m = a;
            this.g("Panes");
        }
        get size() {
            return this.z;
        }
        set size(a) {
            this.z = a;
            this.g("Size");
        }
        get floatingLocation() {
            return this.o;
        }
        set floatingLocation(a) {
            this.o = a;
            this.g("FloatingLocation");
        }
        get floatingWidth() {
            return this.y;
        }
        set floatingWidth(a) {
            this.y = a;
            this.g("FloatingWidth");
        }
        get floatingHeight() {
            return this.x;
        }
        set floatingHeight(a) {
            this.x = a;
            this.g("FloatingHeight");
        }
        get floatingResizable() {
            return this.s;
        }
        set floatingResizable(a) {
            this.s = a;
            this.g("FloatingResizable");
        }
        get allowEmpty() {
            return this.r;
        }
        set allowEmpty(a) {
            this.r = a;
            this.g("AllowEmpty");
        }
        get isMaximized() {
            return this.t;
        }
        set isMaximized(a) {
            this.t = a;
            this.g("IsMaximized");
        }
    }
    WebSplitPaneDescription.$t = /*@__PURE__*/ markType(WebSplitPaneDescription, 'WebSplitPaneDescription', WebDockManagerPaneDescription.$);
    WebSplitPaneDescription.__marshalByValue1 = true;
    WebSplitPaneDescription.__marshalByValueAlias1 = "SplitPane";
    return WebSplitPaneDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSplitPaneDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSplitPaneDescriptionMetadata extends Base {
        static b(a) {
            if (WebSplitPaneDescriptionMetadata.a == null) {
                WebSplitPaneDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSplitPaneDescriptionMetadata.c(WebSplitPaneDescriptionMetadata.a);
            }
            if (a.k(WebSplitPaneDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSplitPaneDescriptionMetadata.a);
            WebDockManagerPointDescriptionMetadata.d(a);
        }
        static c(a) {
            WebDockManagerPaneDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:SplitPane");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Id", "String");
            a.item("PaneType", "(wc:Type)ExportedType:string:DockManagerPaneType");
            a.item("PaneType@names", "SplitPane;ContentPane;TabGroupPane;DocumentHost");
            a.item("Orientation", "ExportedType:string:SplitPaneOrientation");
            a.item("Orientation@stringUnion", "WebComponents;React");
            a.item("Orientation@names", "Horizontal;Vertical");
            a.item("Panes", "Collection:WebDockManagerPane:DockManagerPaneCollection:WebDockManagerPane");
            a.item("Size", "Number:double");
            a.item("FloatingLocation", "ExportedType:WebDockManagerPoint");
            a.item("FloatingWidth", "Number:double");
            a.item("FloatingHeight", "Number:double");
            a.item("FloatingResizable", "Boolean");
            a.item("AllowEmpty", "Boolean");
            a.item("IsMaximized", "Boolean");
            WebSplitPaneDescriptionMetadata.e(a);
        }
        static d(a) {
            WebSplitPaneDescriptionMetadata.b(a);
            a.ae("WebSplitPane", () => new WebSplitPaneDescription());
            a.ad("WebSplitPane", WebSplitPaneDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__preferUnsuffixed", "Boolean");
        }
    }
    WebSplitPaneDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSplitPaneDescriptionMetadata, 'WebSplitPaneDescriptionMetadata');
    WebSplitPaneDescriptionMetadata.a = null;
    return WebSplitPaneDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockManagerLayoutDescription = /*@__PURE__*/ (() => {
    class WebDockManagerLayoutDescription extends Description {
        get_type() {
            return "WebDockManagerLayout";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.j = null;
            this.h = null;
        }
        get name() {
            return this.n;
        }
        set name(a) {
            this.n = a;
            this.g("Name");
        }
        get rootPane() {
            return this.j;
        }
        set rootPane(a) {
            this.j = a;
            this.g("RootPane");
        }
        get floatingPanes() {
            return this.h;
        }
        set floatingPanes(a) {
            this.h = a;
            this.g("FloatingPanes");
        }
    }
    WebDockManagerLayoutDescription.$t = /*@__PURE__*/ markType(WebDockManagerLayoutDescription, 'WebDockManagerLayoutDescription', Description.$);
    WebDockManagerLayoutDescription.__marshalByValue = true;
    WebDockManagerLayoutDescription.__marshalByValueAlias = "DockManagerLayout";
    return WebDockManagerLayoutDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockManagerLayoutDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDockManagerLayoutDescriptionMetadata extends Base {
        static b(a) {
            if (WebDockManagerLayoutDescriptionMetadata.a == null) {
                WebDockManagerLayoutDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDockManagerLayoutDescriptionMetadata.c(WebDockManagerLayoutDescriptionMetadata.a);
            }
            if (a.k(WebDockManagerLayoutDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDockManagerLayoutDescriptionMetadata.a);
            WebSplitPaneDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:DockManagerLayout");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Name", "String");
            a.item("RootPane", "ExportedType:WebSplitPane");
            a.item("FloatingPanes", "Collection:WebSplitPane:SplitPaneCollection:WebSplitPane");
        }
        static d(a) {
            WebDockManagerLayoutDescriptionMetadata.b(a);
            a.ae("WebDockManagerLayout", () => new WebDockManagerLayoutDescription());
            a.ad("WebDockManagerLayout", WebDockManagerLayoutDescriptionMetadata.a);
        }
    }
    WebDockManagerLayoutDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDockManagerLayoutDescriptionMetadata, 'WebDockManagerLayoutDescriptionMetadata');
    WebDockManagerLayoutDescriptionMetadata.a = null;
    return WebDockManagerLayoutDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockManagerResourceStringsDescription = /*@__PURE__*/ (() => {
    class WebDockManagerResourceStringsDescription extends Description {
        get_type() {
            return "WebDockManagerResourceStrings";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.o = null;
            this.p = null;
            this.j = null;
            this.k = null;
            this.l = null;
            this.m = null;
            this.n = null;
            this.i = null;
        }
        get close() {
            return this.h;
        }
        set close(a) {
            this.h = a;
            this.g("Close");
        }
        get pin() {
            return this.o;
        }
        set pin(a) {
            this.o = a;
            this.g("Pin");
        }
        get unpin() {
            return this.p;
        }
        set unpin(a) {
            this.p = a;
            this.g("Unpin");
        }
        get maximize() {
            return this.j;
        }
        set maximize(a) {
            this.j = a;
            this.g("Maximize");
        }
        get minimize() {
            return this.k;
        }
        set minimize(a) {
            this.k = a;
            this.g("Minimize");
        }
        get moreOptions() {
            return this.l;
        }
        set moreOptions(a) {
            this.l = a;
            this.g("MoreOptions");
        }
        get moreTabs() {
            return this.m;
        }
        set moreTabs(a) {
            this.m = a;
            this.g("MoreTabs");
        }
        get panes() {
            return this.n;
        }
        set panes(a) {
            this.n = a;
            this.g("Panes");
        }
        get documents() {
            return this.i;
        }
        set documents(a) {
            this.i = a;
            this.g("Documents");
        }
    }
    WebDockManagerResourceStringsDescription.$t = /*@__PURE__*/ markType(WebDockManagerResourceStringsDescription, 'WebDockManagerResourceStringsDescription', Description.$);
    return WebDockManagerResourceStringsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockManagerResourceStringsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDockManagerResourceStringsDescriptionMetadata extends Base {
        static b(a) {
            if (WebDockManagerResourceStringsDescriptionMetadata.a == null) {
                WebDockManagerResourceStringsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDockManagerResourceStringsDescriptionMetadata.c(WebDockManagerResourceStringsDescriptionMetadata.a);
            }
            if (a.k(WebDockManagerResourceStringsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDockManagerResourceStringsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:DockManagerResourceStrings");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__skipSuffix", "Boolean");
            a.item("Close", "String");
            a.item("Pin", "String");
            a.item("Unpin", "String");
            a.item("Maximize", "String");
            a.item("Minimize", "String");
            a.item("MoreOptions", "String");
            a.item("MoreTabs", "String");
            a.item("Panes", "String");
            a.item("Documents", "String");
        }
        static d(a) {
            WebDockManagerResourceStringsDescriptionMetadata.b(a);
            a.ae("WebDockManagerResourceStrings", () => new WebDockManagerResourceStringsDescription());
            a.ad("WebDockManagerResourceStrings", WebDockManagerResourceStringsDescriptionMetadata.a);
        }
    }
    WebDockManagerResourceStringsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDockManagerResourceStringsDescriptionMetadata, 'WebDockManagerResourceStringsDescriptionMetadata');
    WebDockManagerResourceStringsDescriptionMetadata.a = null;
    return WebDockManagerResourceStringsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebLayoutChangeEventArgsDescription = /*@__PURE__*/ (() => {
    class WebLayoutChangeEventArgsDescription extends Description {
        get_type() {
            return "WebLayoutChangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebLayoutChangeEventArgsDescription.$t = /*@__PURE__*/ markType(WebLayoutChangeEventArgsDescription, 'WebLayoutChangeEventArgsDescription', Description.$);
    WebLayoutChangeEventArgsDescription.__marshalByValue = true;
    WebLayoutChangeEventArgsDescription.__marshalByValueAlias = "LayoutChangeEventArgs";
    return WebLayoutChangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebLayoutChangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebLayoutChangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebLayoutChangeEventArgsDescriptionMetadata.a == null) {
                WebLayoutChangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebLayoutChangeEventArgsDescriptionMetadata.c(WebLayoutChangeEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebLayoutChangeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebLayoutChangeEventArgsDescriptionMetadata.a);
            WebDockManagerLayoutDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:LayoutChangeEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebDockManagerLayout");
        }
        static d(a) {
            WebLayoutChangeEventArgsDescriptionMetadata.b(a);
            a.ae("WebLayoutChangeEventArgs", () => new WebLayoutChangeEventArgsDescription());
            a.ad("WebLayoutChangeEventArgs", WebLayoutChangeEventArgsDescriptionMetadata.a);
        }
    }
    WebLayoutChangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebLayoutChangeEventArgsDescriptionMetadata, 'WebLayoutChangeEventArgsDescriptionMetadata');
    WebLayoutChangeEventArgsDescriptionMetadata.a = null;
    return WebLayoutChangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockManagerDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDockManagerDescriptionMetadata extends Base {
        static b(a) {
            if (WebDockManagerDescriptionMetadata.a == null) {
                WebDockManagerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDockManagerDescriptionMetadata.c(WebDockManagerDescriptionMetadata.a);
            }
            if (a.k(WebDockManagerDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDockManagerDescriptionMetadata.a);
            WebDockManagerLayoutDescriptionMetadata.d(a);
            WebDockManagerPaneDescriptionMetadata.d(a);
            WebDockManagerPointDescriptionMetadata.d(a);
            WebContentPaneDescriptionMetadata.d(a);
            WebDockManagerResourceStringsDescriptionMetadata.d(a);
            WebLayoutChangeEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:DockManager");
            a.item("__tagNameWC", "String:igc-dockmanager");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Layout", "ExportedType:WebDockManagerLayout");
            a.item("DraggedPane", "ExportedType:WebDockManagerPane");
            a.item("DropPosition", "ExportedType:WebDockManagerPoint");
            a.item("ActivePane", "ExportedType:WebContentPane");
            a.item("AllowMaximize", "Boolean");
            a.item("ContainedInBoundaries", "Boolean");
            a.item("ShowHeaderIconOnHover", "ExportedType:string:DockManagerShowHeaderIconOnHover");
            a.item("ShowHeaderIconOnHover@stringUnion", "WebComponents;React");
            a.item("ShowHeaderIconOnHover@names", "CloseOnly;MoreOptionsOnly;All");
            a.item("MaximizedPane", "ExportedType:WebDockManagerPane");
            a.item("ResourceStrings", "ExportedType:WebDockManagerResourceStrings");
            a.item("AllowFloatingPanesResize", "Boolean");
            a.item("DisableKeyboardNavigation", "Boolean");
            a.item("AllowInnerDock", "Boolean");
            a.item("ShowPaneHeaders", "ExportedType:string:DockManagerShowPaneHeaders");
            a.item("ShowPaneHeaders@stringUnion", "WebComponents;React");
            a.item("ShowPaneHeaders@names", "OnHoverOnly;Always");
            a.item("ProximityDock", "Boolean");
            a.item("LayoutChangeRef", "EventRef::layoutChange:customEvent");
        }
        static d(a) {
            WebDockManagerDescriptionMetadata.b(a);
            a.ae("WebDockManager", () => new WebDockManagerDescription());
            a.ad("WebDockManager", WebDockManagerDescriptionMetadata.a);
        }
    }
    WebDockManagerDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDockManagerDescriptionMetadata, 'WebDockManagerDescriptionMetadata');
    WebDockManagerDescriptionMetadata.a = null;
    return WebDockManagerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockManagerLayoutDescriptionModule = /*@__PURE__*/ (() => {
    class WebDockManagerLayoutDescriptionModule extends Base {
        static register(a) {
            WebDockManagerLayoutDescriptionMetadata.d(a);
        }
    }
    WebDockManagerLayoutDescriptionModule.$t = /*@__PURE__*/ markType(WebDockManagerLayoutDescriptionModule, 'WebDockManagerLayoutDescriptionModule');
    return WebDockManagerLayoutDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSplitPaneDescriptionModule = /*@__PURE__*/ (() => {
    class WebSplitPaneDescriptionModule extends Base {
        static register(a) {
            WebSplitPaneDescriptionMetadata.d(a);
        }
    }
    WebSplitPaneDescriptionModule.$t = /*@__PURE__*/ markType(WebSplitPaneDescriptionModule, 'WebSplitPaneDescriptionModule');
    return WebSplitPaneDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDocumentHostDescription = /*@__PURE__*/ (() => {
    class WebDocumentHostDescription extends WebDockManagerPaneDescription {
        get_type() {
            return "WebDocumentHost";
        }
        constructor() {
            super();
            this.s = null;
            this.t = null;
            this.m = null;
            this.p = 0;
        }
        get id() {
            return this.s;
        }
        set id(a) {
            this.s = a;
            this.g("Id");
        }
        get paneType() {
            return this.t;
        }
        set paneType(a) {
            this.t = a;
            this.g("PaneType");
        }
        get rootPane() {
            return this.m;
        }
        set rootPane(a) {
            this.m = a;
            this.g("RootPane");
        }
        get size() {
            return this.p;
        }
        set size(a) {
            this.p = a;
            this.g("Size");
        }
    }
    WebDocumentHostDescription.$t = /*@__PURE__*/ markType(WebDocumentHostDescription, 'WebDocumentHostDescription', WebDockManagerPaneDescription.$);
    WebDocumentHostDescription.__marshalByValue1 = true;
    WebDocumentHostDescription.__marshalByValueAlias1 = "DocumentHost";
    return WebDocumentHostDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDocumentHostDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDocumentHostDescriptionMetadata extends Base {
        static b(a) {
            if (WebDocumentHostDescriptionMetadata.a == null) {
                WebDocumentHostDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDocumentHostDescriptionMetadata.c(WebDocumentHostDescriptionMetadata.a);
            }
            if (a.k(WebDocumentHostDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDocumentHostDescriptionMetadata.a);
            WebSplitPaneDescriptionMetadata.d(a);
        }
        static c(a) {
            WebDockManagerPaneDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:DocumentHost");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Id", "String");
            a.item("PaneType", "(wc:Type)ExportedType:string:DockManagerPaneType");
            a.item("PaneType@names", "SplitPane;ContentPane;TabGroupPane;DocumentHost");
            a.item("RootPane", "ExportedType:WebSplitPane");
            a.item("Size", "Number:double");
            WebDocumentHostDescriptionMetadata.e(a);
        }
        static d(a) {
            WebDocumentHostDescriptionMetadata.b(a);
            a.ae("WebDocumentHost", () => new WebDocumentHostDescription());
            a.ad("WebDocumentHost", WebDocumentHostDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__preferUnsuffixed", "Boolean");
        }
    }
    WebDocumentHostDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDocumentHostDescriptionMetadata, 'WebDocumentHostDescriptionMetadata');
    WebDocumentHostDescriptionMetadata.a = null;
    return WebDocumentHostDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDocumentHostDescriptionModule = /*@__PURE__*/ (() => {
    class WebDocumentHostDescriptionModule extends Base {
        static register(a) {
            WebDocumentHostDescriptionMetadata.d(a);
        }
    }
    WebDocumentHostDescriptionModule.$t = /*@__PURE__*/ markType(WebDocumentHostDescriptionModule, 'WebDocumentHostDescriptionModule');
    return WebDocumentHostDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabGroupPaneDescription = /*@__PURE__*/ (() => {
    class WebTabGroupPaneDescription extends WebDockManagerPaneDescription {
        get_type() {
            return "WebTabGroupPane";
        }
        constructor() {
            super();
            this.y = null;
            this.z = null;
            this.m = null;
            this.u = 0;
            this.t = 0;
            this.p = false;
            this.q = false;
        }
        get id() {
            return this.y;
        }
        set id(a) {
            this.y = a;
            this.g("Id");
        }
        get paneType() {
            return this.z;
        }
        set paneType(a) {
            this.z = a;
            this.g("PaneType");
        }
        get panes() {
            return this.m;
        }
        set panes(a) {
            this.m = a;
            this.g("Panes");
        }
        get size() {
            return this.u;
        }
        set size(a) {
            this.u = a;
            this.g("Size");
        }
        get selectedIndex() {
            return this.t;
        }
        set selectedIndex(a) {
            this.t = a;
            this.g("SelectedIndex");
        }
        get allowEmpty() {
            return this.p;
        }
        set allowEmpty(a) {
            this.p = a;
            this.g("AllowEmpty");
        }
        get isMaximized() {
            return this.q;
        }
        set isMaximized(a) {
            this.q = a;
            this.g("IsMaximized");
        }
    }
    WebTabGroupPaneDescription.$t = /*@__PURE__*/ markType(WebTabGroupPaneDescription, 'WebTabGroupPaneDescription', WebDockManagerPaneDescription.$);
    WebTabGroupPaneDescription.__marshalByValue1 = true;
    WebTabGroupPaneDescription.__marshalByValueAlias1 = "TabGroupPane";
    return WebTabGroupPaneDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabGroupPaneDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTabGroupPaneDescriptionMetadata extends Base {
        static b(a) {
            if (WebTabGroupPaneDescriptionMetadata.a == null) {
                WebTabGroupPaneDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTabGroupPaneDescriptionMetadata.c(WebTabGroupPaneDescriptionMetadata.a);
            }
            if (a.k(WebTabGroupPaneDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTabGroupPaneDescriptionMetadata.a);
        }
        static c(a) {
            WebDockManagerPaneDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:TabGroupPane");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Id", "String");
            a.item("PaneType", "(wc:Type)ExportedType:string:DockManagerPaneType");
            a.item("PaneType@names", "SplitPane;ContentPane;TabGroupPane;DocumentHost");
            a.item("Panes", "Collection:WebContentPane:ContentPaneCollection:WebContentPane");
            a.item("Size", "Number:double");
            a.item("SelectedIndex", "Number:double");
            a.item("AllowEmpty", "Boolean");
            a.item("IsMaximized", "Boolean");
            WebTabGroupPaneDescriptionMetadata.e(a);
        }
        static d(a) {
            WebTabGroupPaneDescriptionMetadata.b(a);
            a.ae("WebTabGroupPane", () => new WebTabGroupPaneDescription());
            a.ad("WebTabGroupPane", WebTabGroupPaneDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__preferUnsuffixed", "Boolean");
        }
    }
    WebTabGroupPaneDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTabGroupPaneDescriptionMetadata, 'WebTabGroupPaneDescriptionMetadata');
    WebTabGroupPaneDescriptionMetadata.a = null;
    return WebTabGroupPaneDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabGroupPaneDescriptionModule = /*@__PURE__*/ (() => {
    class WebTabGroupPaneDescriptionModule extends Base {
        static register(a) {
            WebTabGroupPaneDescriptionMetadata.d(a);
        }
    }
    WebTabGroupPaneDescriptionModule.$t = /*@__PURE__*/ markType(WebTabGroupPaneDescriptionModule, 'WebTabGroupPaneDescriptionModule');
    return WebTabGroupPaneDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDragServiceDescription = /*@__PURE__*/ (() => {
    class WebDragServiceDescription extends Description {
        get_type() {
            return "WebDragService";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebDragServiceDescription.$t = /*@__PURE__*/ markType(WebDragServiceDescription, 'WebDragServiceDescription', Description.$);
    return WebDragServiceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDragServiceDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDragServiceDescriptionMetadata extends Base {
        static b(a) {
            if (WebDragServiceDescriptionMetadata.a == null) {
                WebDragServiceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDragServiceDescriptionMetadata.c(WebDragServiceDescriptionMetadata.a);
            }
            if (a.k(WebDragServiceDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDragServiceDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:DragService");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebDragServiceDescriptionMetadata.b(a);
            a.ae("WebDragService", () => new WebDragServiceDescription());
            a.ad("WebDragService", WebDragServiceDescriptionMetadata.a);
        }
    }
    WebDragServiceDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDragServiceDescriptionMetadata, 'WebDragServiceDescriptionMetadata');
    WebDragServiceDescriptionMetadata.a = null;
    return WebDragServiceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabHeaderElementDescription = /*@__PURE__*/ (() => {
    class WebTabHeaderElementDescription extends Description {
        get_type() {
            return "WebTabHeaderElement";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get dragService() {
            return this.h;
        }
        set dragService(a) {
            this.h = a;
            this.g("DragService");
        }
    }
    WebTabHeaderElementDescription.$t = /*@__PURE__*/ markType(WebTabHeaderElementDescription, 'WebTabHeaderElementDescription', Description.$);
    WebTabHeaderElementDescription.__marshalByValue = true;
    WebTabHeaderElementDescription.__marshalByValueAlias = "TabHeaderElement";
    return WebTabHeaderElementDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabHeaderElementDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTabHeaderElementDescriptionMetadata extends Base {
        static b(a) {
            if (WebTabHeaderElementDescriptionMetadata.a == null) {
                WebTabHeaderElementDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTabHeaderElementDescriptionMetadata.c(WebTabHeaderElementDescriptionMetadata.a);
            }
            if (a.k(WebTabHeaderElementDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTabHeaderElementDescriptionMetadata.a);
            WebDragServiceDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:TabHeaderElement");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("DragService", "ExportedType:WebDragService");
            WebTabHeaderElementDescriptionMetadata.e(a);
        }
        static d(a) {
            WebTabHeaderElementDescriptionMetadata.b(a);
            a.ae("WebTabHeaderElement", () => new WebTabHeaderElementDescription());
            a.ad("WebTabHeaderElement", WebTabHeaderElementDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__preferUnsuffixed", "Boolean");
        }
    }
    WebTabHeaderElementDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTabHeaderElementDescriptionMetadata, 'WebTabHeaderElementDescriptionMetadata');
    WebTabHeaderElementDescriptionMetadata.a = null;
    return WebTabHeaderElementDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabHeaderElementDescriptionModule = /*@__PURE__*/ (() => {
    class WebTabHeaderElementDescriptionModule extends Base {
        static register(a) {
            WebTabHeaderElementDescriptionMetadata.d(a);
        }
    }
    WebTabHeaderElementDescriptionModule.$t = /*@__PURE__*/ markType(WebTabHeaderElementDescriptionModule, 'WebTabHeaderElementDescriptionModule');
    return WebTabHeaderElementDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockManagerDescriptionModule = /*@__PURE__*/ (() => {
    class WebDockManagerDescriptionModule extends Base {
        static register(a) {
            WebDockManagerLayoutDescriptionModule.register(a);
            WebContentPaneDescriptionModule.register(a);
            WebSplitPaneDescriptionModule.register(a);
            WebDocumentHostDescriptionModule.register(a);
            WebTabGroupPaneDescriptionModule.register(a);
            WebTabHeaderElementDescriptionModule.register(a);
            WebDockManagerDescriptionMetadata.d(a);
        }
    }
    WebDockManagerDescriptionModule.$t = /*@__PURE__*/ markType(WebDockManagerDescriptionModule, 'WebDockManagerDescriptionModule');
    return WebDockManagerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockManagerPointDescriptionModule = /*@__PURE__*/ (() => {
    class WebDockManagerPointDescriptionModule extends Base {
        static register(a) {
            WebDockManagerPointDescriptionMetadata.d(a);
        }
    }
    WebDockManagerPointDescriptionModule.$t = /*@__PURE__*/ markType(WebDockManagerPointDescriptionModule, 'WebDockManagerPointDescriptionModule');
    return WebDockManagerPointDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneDragActionDescription = /*@__PURE__*/ (() => {
    class WebPaneDragActionDescription extends Description {
        get_type() {
            return "WebPaneDragAction";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebPaneDragActionDescription.$t = /*@__PURE__*/ markType(WebPaneDragActionDescription, 'WebPaneDragActionDescription', Description.$);
    WebPaneDragActionDescription.__marshalByValue = true;
    WebPaneDragActionDescription.__marshalByValueAlias = "PaneDragAction";
    return WebPaneDragActionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockPaneActionDescription = /*@__PURE__*/ (() => {
    class WebDockPaneActionDescription extends WebPaneDragActionDescription {
        get_type() {
            return "WebDockPaneAction";
        }
        constructor() {
            super();
            this.q = null;
            this.k = null;
            this.m = null;
        }
        get actionType() {
            return this.q;
        }
        set actionType(a) {
            this.q = a;
            this.g("ActionType");
        }
        get dockingIndicator() {
            return this.k;
        }
        set dockingIndicator(a) {
            this.k = a;
            this.g("DockingIndicator");
        }
        get targetPane() {
            return this.m;
        }
        set targetPane(a) {
            this.m = a;
            this.g("TargetPane");
        }
    }
    WebDockPaneActionDescription.$t = /*@__PURE__*/ markType(WebDockPaneActionDescription, 'WebDockPaneActionDescription', WebPaneDragActionDescription.$);
    WebDockPaneActionDescription.__marshalByValue1 = true;
    WebDockPaneActionDescription.__marshalByValueAlias1 = "DockPaneAction";
    return WebDockPaneActionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneDragActionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPaneDragActionDescriptionMetadata extends Base {
        static b(a) {
            if (WebPaneDragActionDescriptionMetadata.a == null) {
                WebPaneDragActionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPaneDragActionDescriptionMetadata.c(WebPaneDragActionDescriptionMetadata.a);
            }
            if (a.k(WebPaneDragActionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPaneDragActionDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PaneDragAction");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
        }
        static d(a) {
            WebPaneDragActionDescriptionMetadata.b(a);
            a.ae("WebPaneDragAction", () => new WebPaneDragActionDescription());
            a.ad("WebPaneDragAction", WebPaneDragActionDescriptionMetadata.a);
        }
    }
    WebPaneDragActionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPaneDragActionDescriptionMetadata, 'WebPaneDragActionDescriptionMetadata');
    WebPaneDragActionDescriptionMetadata.a = null;
    return WebPaneDragActionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDockPaneActionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDockPaneActionDescriptionMetadata extends Base {
        static b(a) {
            if (WebDockPaneActionDescriptionMetadata.a == null) {
                WebDockPaneActionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDockPaneActionDescriptionMetadata.c(WebDockPaneActionDescriptionMetadata.a);
            }
            if (a.k(WebDockPaneActionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDockPaneActionDescriptionMetadata.a);
            WebDockingIndicatorDescriptionMetadata.d(a);
            WebDockManagerPaneDescriptionMetadata.d(a);
        }
        static c(a) {
            WebPaneDragActionDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:DockPaneAction");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__skipSuffix", "Boolean");
            a.item("ActionType", "(wc:Type)ExportedType:string:PaneDragActionType");
            a.item("ActionType@names", "FloatPane;MoveFloatingPane;DockPane;MoveTab");
            a.item("DockingIndicator", "ExportedType:WebDockingIndicator");
            a.item("TargetPane", "ExportedType:WebDockManagerPane");
        }
        static d(a) {
            WebDockPaneActionDescriptionMetadata.b(a);
            a.ae("WebDockPaneAction", () => new WebDockPaneActionDescription());
            a.ad("WebDockPaneAction", WebDockPaneActionDescriptionMetadata.a);
        }
    }
    WebDockPaneActionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDockPaneActionDescriptionMetadata, 'WebDockPaneActionDescriptionMetadata');
    WebDockPaneActionDescriptionMetadata.a = null;
    return WebDockPaneActionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDragServiceDescriptionModule = /*@__PURE__*/ (() => {
    class WebDragServiceDescriptionModule extends Base {
        static register(a) {
            WebDragServiceDescriptionMetadata.d(a);
        }
    }
    WebDragServiceDescriptionModule.$t = /*@__PURE__*/ markType(WebDragServiceDescriptionModule, 'WebDragServiceDescriptionModule');
    return WebDragServiceDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDropdownDescription = /*@__PURE__*/ (() => {
    class WebDropdownDescription extends WebBaseComboBoxLikeDescription {
        get_type() {
            return "WebDropdown";
        }
        constructor() {
            super();
            this.ab = null;
            this.ac = null;
            this.q = false;
            this.u = 0;
            this.r = false;
            this.aa = null;
            this.z = null;
            this.y = null;
            this.x = null;
            this.w = null;
        }
        get placement() {
            return this.ab;
        }
        set placement(a) {
            this.ab = a;
            this.g("Placement");
        }
        get scrollStrategy() {
            return this.ac;
        }
        set scrollStrategy(a) {
            this.ac = a;
            this.g("ScrollStrategy");
        }
        get flip() {
            return this.q;
        }
        set flip(a) {
            this.q = a;
            this.g("Flip");
        }
        get distance() {
            return this.u;
        }
        set distance(a) {
            this.u = a;
            this.g("Distance");
        }
        get sameWidth() {
            return this.r;
        }
        set sameWidth(a) {
            this.r = a;
            this.g("SameWidth");
        }
        get openingRef() {
            return this.aa;
        }
        set openingRef(a) {
            this.aa = a;
            this.g("OpeningRef");
        }
        get openedRef() {
            return this.z;
        }
        set openedRef(a) {
            this.z = a;
            this.g("OpenedRef");
        }
        get closingRef() {
            return this.y;
        }
        set closingRef(a) {
            this.y = a;
            this.g("ClosingRef");
        }
        get closedRef() {
            return this.x;
        }
        set closedRef(a) {
            this.x = a;
            this.g("ClosedRef");
        }
        get changeRef() {
            return this.w;
        }
        set changeRef(a) {
            this.w = a;
            this.g("ChangeRef");
        }
    }
    WebDropdownDescription.$t = /*@__PURE__*/ markType(WebDropdownDescription, 'WebDropdownDescription', WebBaseComboBoxLikeDescription.$);
    return WebDropdownDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDropdownItemDescription = /*@__PURE__*/ (() => {
    class WebDropdownItemDescription extends WebBaseOptionLikeDescription {
        get_type() {
            return "WebDropdownItem";
        }
        constructor() {
            super();
        }
    }
    WebDropdownItemDescription.$t = /*@__PURE__*/ markType(WebDropdownItemDescription, 'WebDropdownItemDescription', WebBaseOptionLikeDescription.$);
    return WebDropdownItemDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDropdownItemDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDropdownItemDescriptionMetadata extends Base {
        static b(a) {
            if (WebDropdownItemDescriptionMetadata.a == null) {
                WebDropdownItemDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDropdownItemDescriptionMetadata.c(WebDropdownItemDescriptionMetadata.a);
            }
            if (a.k(WebDropdownItemDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDropdownItemDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseOptionLikeDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:DropdownItem");
            a.item("__tagNameWC", "String:igc-dropdown-item");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebDropdownItemDescriptionMetadata.b(a);
            a.ae("WebDropdownItem", () => new WebDropdownItemDescription());
            a.ad("WebDropdownItem", WebDropdownItemDescriptionMetadata.a);
        }
    }
    WebDropdownItemDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDropdownItemDescriptionMetadata, 'WebDropdownItemDescriptionMetadata');
    WebDropdownItemDescriptionMetadata.a = null;
    return WebDropdownItemDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDropdownItemComponentEventArgsDescription = /*@__PURE__*/ (() => {
    class WebDropdownItemComponentEventArgsDescription extends Description {
        get_type() {
            return "WebDropdownItemComponentEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebDropdownItemComponentEventArgsDescription.$t = /*@__PURE__*/ markType(WebDropdownItemComponentEventArgsDescription, 'WebDropdownItemComponentEventArgsDescription', Description.$);
    WebDropdownItemComponentEventArgsDescription.__marshalByValue = true;
    WebDropdownItemComponentEventArgsDescription.__marshalByValueAlias = "DropdownItemComponentEventArgs";
    return WebDropdownItemComponentEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDropdownItemComponentEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDropdownItemComponentEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebDropdownItemComponentEventArgsDescriptionMetadata.a == null) {
                WebDropdownItemComponentEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDropdownItemComponentEventArgsDescriptionMetadata.c(WebDropdownItemComponentEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebDropdownItemComponentEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDropdownItemComponentEventArgsDescriptionMetadata.a);
            WebDropdownItemDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:DropdownItemComponentEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebDropdownItem");
        }
        static d(a) {
            WebDropdownItemComponentEventArgsDescriptionMetadata.b(a);
            a.ae("WebDropdownItemComponentEventArgs", () => new WebDropdownItemComponentEventArgsDescription());
            a.ad("WebDropdownItemComponentEventArgs", WebDropdownItemComponentEventArgsDescriptionMetadata.a);
        }
    }
    WebDropdownItemComponentEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDropdownItemComponentEventArgsDescriptionMetadata, 'WebDropdownItemComponentEventArgsDescriptionMetadata');
    WebDropdownItemComponentEventArgsDescriptionMetadata.a = null;
    return WebDropdownItemComponentEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDropdownDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDropdownDescriptionMetadata extends Base {
        static b(a) {
            if (WebDropdownDescriptionMetadata.a == null) {
                WebDropdownDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDropdownDescriptionMetadata.c(WebDropdownDescriptionMetadata.a);
            }
            if (a.k(WebDropdownDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDropdownDescriptionMetadata.a);
            VoidEventArgsDescriptionMetadata.d(a);
            WebDropdownItemComponentEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseComboBoxLikeDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:Dropdown");
            a.item("__tagNameWC", "String:igc-dropdown");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Placement", "ExportedType:string:DropdownPlacement");
            a.item("Placement@names", "Top;TopStart;TopEnd;Bottom;BottomStart;BottomEnd;Right;RightStart;RightEnd;Left;LeftStart;LeftEnd");
            a.item("ScrollStrategy", "ExportedType:string:DropdownScrollStrategy");
            a.item("ScrollStrategy@stringUnion", "WebComponents;React");
            a.item("ScrollStrategy@names", "Scroll;Block;Close");
            a.item("Flip", "Boolean");
            a.item("Distance", "Number:double");
            a.item("SameWidth", "Boolean");
            a.item("OpeningRef", "EventRef::opening");
            a.item("OpenedRef", "EventRef::opened");
            a.item("ClosingRef", "EventRef::closing");
            a.item("ClosedRef", "EventRef::closed");
            a.item("ChangeRef", "EventRef::change");
        }
        static d(a) {
            WebDropdownDescriptionMetadata.b(a);
            a.ae("WebDropdown", () => new WebDropdownDescription());
            a.ad("WebDropdown", WebDropdownDescriptionMetadata.a);
        }
    }
    WebDropdownDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDropdownDescriptionMetadata, 'WebDropdownDescriptionMetadata');
    WebDropdownDescriptionMetadata.a = null;
    return WebDropdownDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDropdownGroupDescription = /*@__PURE__*/ (() => {
    class WebDropdownGroupDescription extends Description {
        get_type() {
            return "WebDropdownGroup";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebDropdownGroupDescription.$t = /*@__PURE__*/ markType(WebDropdownGroupDescription, 'WebDropdownGroupDescription', Description.$);
    return WebDropdownGroupDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDropdownGroupDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDropdownGroupDescriptionMetadata extends Base {
        static b(a) {
            if (WebDropdownGroupDescriptionMetadata.a == null) {
                WebDropdownGroupDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDropdownGroupDescriptionMetadata.c(WebDropdownGroupDescriptionMetadata.a);
            }
            if (a.k(WebDropdownGroupDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDropdownGroupDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:DropdownGroup");
            a.item("__tagNameWC", "String:igc-dropdown-group");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebDropdownGroupDescriptionMetadata.b(a);
            a.ae("WebDropdownGroup", () => new WebDropdownGroupDescription());
            a.ad("WebDropdownGroup", WebDropdownGroupDescriptionMetadata.a);
        }
    }
    WebDropdownGroupDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDropdownGroupDescriptionMetadata, 'WebDropdownGroupDescriptionMetadata');
    WebDropdownGroupDescriptionMetadata.a = null;
    return WebDropdownGroupDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDropdownGroupDescriptionModule = /*@__PURE__*/ (() => {
    class WebDropdownGroupDescriptionModule extends Base {
        static register(a) {
            WebDropdownGroupDescriptionMetadata.d(a);
        }
    }
    WebDropdownGroupDescriptionModule.$t = /*@__PURE__*/ markType(WebDropdownGroupDescriptionModule, 'WebDropdownGroupDescriptionModule');
    return WebDropdownGroupDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDropdownHeaderDescription = /*@__PURE__*/ (() => {
    class WebDropdownHeaderDescription extends Description {
        get_type() {
            return "WebDropdownHeader";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebDropdownHeaderDescription.$t = /*@__PURE__*/ markType(WebDropdownHeaderDescription, 'WebDropdownHeaderDescription', Description.$);
    return WebDropdownHeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDropdownHeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebDropdownHeaderDescriptionMetadata extends Base {
        static b(a) {
            if (WebDropdownHeaderDescriptionMetadata.a == null) {
                WebDropdownHeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebDropdownHeaderDescriptionMetadata.c(WebDropdownHeaderDescriptionMetadata.a);
            }
            if (a.k(WebDropdownHeaderDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebDropdownHeaderDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:DropdownHeader");
            a.item("__tagNameWC", "String:igc-dropdown-header");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebDropdownHeaderDescriptionMetadata.b(a);
            a.ae("WebDropdownHeader", () => new WebDropdownHeaderDescription());
            a.ad("WebDropdownHeader", WebDropdownHeaderDescriptionMetadata.a);
        }
    }
    WebDropdownHeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(WebDropdownHeaderDescriptionMetadata, 'WebDropdownHeaderDescriptionMetadata');
    WebDropdownHeaderDescriptionMetadata.a = null;
    return WebDropdownHeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDropdownHeaderDescriptionModule = /*@__PURE__*/ (() => {
    class WebDropdownHeaderDescriptionModule extends Base {
        static register(a) {
            WebDropdownHeaderDescriptionMetadata.d(a);
        }
    }
    WebDropdownHeaderDescriptionModule.$t = /*@__PURE__*/ markType(WebDropdownHeaderDescriptionModule, 'WebDropdownHeaderDescriptionModule');
    return WebDropdownHeaderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDropdownItemDescriptionModule = /*@__PURE__*/ (() => {
    class WebDropdownItemDescriptionModule extends Base {
        static register(a) {
            WebBaseOptionLikeDescriptionModule.register(a);
            WebDropdownItemDescriptionMetadata.d(a);
        }
    }
    WebDropdownItemDescriptionModule.$t = /*@__PURE__*/ markType(WebDropdownItemDescriptionModule, 'WebDropdownItemDescriptionModule');
    return WebDropdownItemDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebDropdownDescriptionModule = /*@__PURE__*/ (() => {
    class WebDropdownDescriptionModule extends Base {
        static register(a) {
            WebBaseComboBoxLikeDescriptionModule.register(a);
            WebDropdownItemDescriptionModule.register(a);
            WebDropdownHeaderDescriptionModule.register(a);
            WebDropdownGroupDescriptionModule.register(a);
            WebDropdownItemComponentEventArgsDescriptionMetadata.d(a);
            WebDropdownDescriptionMetadata.d(a);
        }
    }
    WebDropdownDescriptionModule.$t = /*@__PURE__*/ markType(WebDropdownDescriptionModule, 'WebDropdownDescriptionModule');
    return WebDropdownDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebExpansionPanelDescription = /*@__PURE__*/ (() => {
    class WebExpansionPanelDescription extends Description {
        get_type() {
            return "WebExpansionPanel";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = false;
            this.h = false;
            this.n = null;
            this.p = null;
            this.o = null;
            this.m = null;
            this.l = null;
        }
        get open() {
            return this.i;
        }
        set open(a) {
            this.i = a;
            this.g("Open");
        }
        get disabled() {
            return this.h;
        }
        set disabled(a) {
            this.h = a;
            this.g("Disabled");
        }
        get indicatorPosition() {
            return this.n;
        }
        set indicatorPosition(a) {
            this.n = a;
            this.g("IndicatorPosition");
        }
        get openingRef() {
            return this.p;
        }
        set openingRef(a) {
            this.p = a;
            this.g("OpeningRef");
        }
        get openedRef() {
            return this.o;
        }
        set openedRef(a) {
            this.o = a;
            this.g("OpenedRef");
        }
        get closingRef() {
            return this.m;
        }
        set closingRef(a) {
            this.m = a;
            this.g("ClosingRef");
        }
        get closedRef() {
            return this.l;
        }
        set closedRef(a) {
            this.l = a;
            this.g("ClosedRef");
        }
    }
    WebExpansionPanelDescription.$t = /*@__PURE__*/ markType(WebExpansionPanelDescription, 'WebExpansionPanelDescription', Description.$);
    return WebExpansionPanelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebExpansionPanelComponentEventArgsDescription = /*@__PURE__*/ (() => {
    class WebExpansionPanelComponentEventArgsDescription extends Description {
        get_type() {
            return "WebExpansionPanelComponentEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebExpansionPanelComponentEventArgsDescription.$t = /*@__PURE__*/ markType(WebExpansionPanelComponentEventArgsDescription, 'WebExpansionPanelComponentEventArgsDescription', Description.$);
    WebExpansionPanelComponentEventArgsDescription.__marshalByValue = true;
    WebExpansionPanelComponentEventArgsDescription.__marshalByValueAlias = "ExpansionPanelComponentEventArgs";
    return WebExpansionPanelComponentEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebExpansionPanelDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebExpansionPanelDescriptionMetadata extends Base {
        static b(a) {
            if (WebExpansionPanelDescriptionMetadata.a == null) {
                WebExpansionPanelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebExpansionPanelDescriptionMetadata.c(WebExpansionPanelDescriptionMetadata.a);
            }
            if (a.k(WebExpansionPanelDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebExpansionPanelDescriptionMetadata.a);
            WebExpansionPanelComponentEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ExpansionPanel");
            a.item("__tagNameWC", "String:igc-expansion-panel");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Open", "Boolean");
            a.item("Disabled", "Boolean");
            a.item("IndicatorPosition", "ExportedType:string:ExpansionPanelIndicatorPosition");
            a.item("IndicatorPosition@stringUnion", "WebComponents;React");
            a.item("IndicatorPosition@names", "None;Start;End");
            a.item("OpeningRef", "EventRef::opening");
            a.item("OpenedRef", "EventRef::opened");
            a.item("ClosingRef", "EventRef::closing");
            a.item("ClosedRef", "EventRef::closed");
        }
        static d(a) {
            WebExpansionPanelDescriptionMetadata.b(a);
            a.ae("WebExpansionPanel", () => new WebExpansionPanelDescription());
            a.ad("WebExpansionPanel", WebExpansionPanelDescriptionMetadata.a);
        }
    }
    WebExpansionPanelDescriptionMetadata.$t = /*@__PURE__*/ markType(WebExpansionPanelDescriptionMetadata, 'WebExpansionPanelDescriptionMetadata');
    WebExpansionPanelDescriptionMetadata.a = null;
    return WebExpansionPanelDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebExpansionPanelComponentEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebExpansionPanelComponentEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebExpansionPanelComponentEventArgsDescriptionMetadata.a == null) {
                WebExpansionPanelComponentEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebExpansionPanelComponentEventArgsDescriptionMetadata.c(WebExpansionPanelComponentEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebExpansionPanelComponentEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebExpansionPanelComponentEventArgsDescriptionMetadata.a);
            WebExpansionPanelDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ExpansionPanelComponentEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebExpansionPanel");
        }
        static d(a) {
            WebExpansionPanelComponentEventArgsDescriptionMetadata.b(a);
            a.ae("WebExpansionPanelComponentEventArgs", () => new WebExpansionPanelComponentEventArgsDescription());
            a.ad("WebExpansionPanelComponentEventArgs", WebExpansionPanelComponentEventArgsDescriptionMetadata.a);
        }
    }
    WebExpansionPanelComponentEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebExpansionPanelComponentEventArgsDescriptionMetadata, 'WebExpansionPanelComponentEventArgsDescriptionMetadata');
    WebExpansionPanelComponentEventArgsDescriptionMetadata.a = null;
    return WebExpansionPanelComponentEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebExpansionPanelDescriptionModule = /*@__PURE__*/ (() => {
    class WebExpansionPanelDescriptionModule extends Base {
        static register(a) {
            WebExpansionPanelComponentEventArgsDescriptionMetadata.d(a);
            WebExpansionPanelDescriptionMetadata.d(a);
        }
    }
    WebExpansionPanelDescriptionModule.$t = /*@__PURE__*/ markType(WebExpansionPanelDescriptionModule, 'WebExpansionPanelDescriptionModule');
    return WebExpansionPanelDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebExporterOptionsBaseDescription = /*@__PURE__*/ (() => {
    class WebExporterOptionsBaseDescription extends Description {
        get_type() {
            return "WebExporterOptionsBase";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = false;
            this.m = false;
            this.k = false;
            this.p = false;
            this.n = false;
            this.o = false;
            this.i = false;
            this.j = false;
            this.h = false;
            this.z = null;
        }
        get ignoreColumnsVisibility() {
            return this.l;
        }
        set ignoreColumnsVisibility(a) {
            this.l = a;
            this.g("IgnoreColumnsVisibility");
        }
        get ignoreFiltering() {
            return this.m;
        }
        set ignoreFiltering(a) {
            this.m = a;
            this.g("IgnoreFiltering");
        }
        get ignoreColumnsOrder() {
            return this.k;
        }
        set ignoreColumnsOrder(a) {
            this.k = a;
            this.g("IgnoreColumnsOrder");
        }
        get ignoreSorting() {
            return this.p;
        }
        set ignoreSorting(a) {
            this.p = a;
            this.g("IgnoreSorting");
        }
        get ignoreGrouping() {
            return this.n;
        }
        set ignoreGrouping(a) {
            this.n = a;
            this.g("IgnoreGrouping");
        }
        get ignoreMultiColumnHeaders() {
            return this.o;
        }
        set ignoreMultiColumnHeaders(a) {
            this.o = a;
            this.g("IgnoreMultiColumnHeaders");
        }
        get exportSummaries() {
            return this.i;
        }
        set exportSummaries(a) {
            this.i = a;
            this.g("ExportSummaries");
        }
        get freezeHeaders() {
            return this.j;
        }
        set freezeHeaders(a) {
            this.j = a;
            this.g("FreezeHeaders");
        }
        get alwaysExportHeaders() {
            return this.h;
        }
        set alwaysExportHeaders(a) {
            this.h = a;
            this.g("AlwaysExportHeaders");
        }
        get fileName() {
            return this.z;
        }
        set fileName(a) {
            this.z = a;
            this.g("FileName");
        }
    }
    WebExporterOptionsBaseDescription.$t = /*@__PURE__*/ markType(WebExporterOptionsBaseDescription, 'WebExporterOptionsBaseDescription', Description.$);
    return WebExporterOptionsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringExpressionDescription = /*@__PURE__*/ (() => {
    class WebFilteringExpressionDescription extends Description {
        get_type() {
            return "WebFilteringExpression";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.p = null;
            this.h = null;
            this.m = null;
            this.k = false;
        }
        get fieldName() {
            return this.p;
        }
        set fieldName(a) {
            this.p = a;
            this.g("FieldName");
        }
        get condition() {
            return this.h;
        }
        set condition(a) {
            this.h = a;
            this.g("Condition");
        }
        get searchVal() {
            return this.m;
        }
        set searchVal(a) {
            this.m = a;
            this.g("SearchVal");
        }
        get ignoreCase() {
            return this.k;
        }
        set ignoreCase(a) {
            this.k = a;
            this.g("IgnoreCase");
        }
    }
    WebFilteringExpressionDescription.$t = /*@__PURE__*/ markType(WebFilteringExpressionDescription, 'WebFilteringExpressionDescription', Description.$);
    WebFilteringExpressionDescription.__marshalByValue = true;
    WebFilteringExpressionDescription.__marshalByValueAlias = "FilteringExpression";
    return WebFilteringExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFilteringExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (WebFilteringExpressionDescriptionMetadata.a == null) {
                WebFilteringExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFilteringExpressionDescriptionMetadata.c(WebFilteringExpressionDescriptionMetadata.a);
            }
            if (a.k(WebFilteringExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFilteringExpressionDescriptionMetadata.a);
            WebFilteringOperationDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FilteringExpression");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("FieldName", "String");
            a.item("Condition", "ExportedType:WebFilteringOperation");
            a.item("SearchVal", "Unknown");
            a.item("IgnoreCase", "Boolean");
        }
        static d(a) {
            WebFilteringExpressionDescriptionMetadata.b(a);
            a.ae("WebFilteringExpression", () => new WebFilteringExpressionDescription());
            a.ad("WebFilteringExpression", WebFilteringExpressionDescriptionMetadata.a);
        }
    }
    WebFilteringExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFilteringExpressionDescriptionMetadata, 'WebFilteringExpressionDescriptionMetadata');
    WebFilteringExpressionDescriptionMetadata.a = null;
    return WebFilteringExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringExpressionsTreeOrFilteringOperationDescription = /*@__PURE__*/ (() => {
    class WebFilteringExpressionsTreeOrFilteringOperationDescription extends Description {
        get_type() {
            return "WebFilteringExpressionsTreeOrFilteringOperation";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebFilteringExpressionsTreeOrFilteringOperationDescription.$t = /*@__PURE__*/ markType(WebFilteringExpressionsTreeOrFilteringOperationDescription, 'WebFilteringExpressionsTreeOrFilteringOperationDescription', Description.$);
    return WebFilteringExpressionsTreeOrFilteringOperationDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata extends Base {
        static b(a) {
            if (WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata.a == null) {
                WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata.c(WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata.a);
            }
            if (a.k(WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FilteringExpressionsTreeOrFilteringOperation");
        }
        static d(a) {
            WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata.b(a);
            a.ae("WebFilteringExpressionsTreeOrFilteringOperation", () => new WebFilteringExpressionsTreeOrFilteringOperationDescription());
            a.ad("WebFilteringExpressionsTreeOrFilteringOperation", WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata.a);
        }
    }
    WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata, 'WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata');
    WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata.a = null;
    return WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFloatingPaneResizeEventArgsDescription = /*@__PURE__*/ (() => {
    class WebFloatingPaneResizeEventArgsDescription extends Description {
        get_type() {
            return "WebFloatingPaneResizeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebFloatingPaneResizeEventArgsDescription.$t = /*@__PURE__*/ markType(WebFloatingPaneResizeEventArgsDescription, 'WebFloatingPaneResizeEventArgsDescription', Description.$);
    WebFloatingPaneResizeEventArgsDescription.__marshalByValue = true;
    WebFloatingPaneResizeEventArgsDescription.__marshalByValueAlias = "FloatingPaneResizeEventArgs";
    return WebFloatingPaneResizeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFloatingPaneResizeEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebFloatingPaneResizeEventArgsDetailDescription extends Description {
        get_type() {
            return "WebFloatingPaneResizeEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.l = null;
        }
        get sourcePane() {
            return this.h;
        }
        set sourcePane(a) {
            this.h = a;
            this.g("SourcePane");
        }
        get resizerLocation() {
            return this.l;
        }
        set resizerLocation(a) {
            this.l = a;
            this.g("ResizerLocation");
        }
    }
    WebFloatingPaneResizeEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebFloatingPaneResizeEventArgsDetailDescription, 'WebFloatingPaneResizeEventArgsDetailDescription', Description.$);
    WebFloatingPaneResizeEventArgsDetailDescription.__marshalByValue = true;
    WebFloatingPaneResizeEventArgsDetailDescription.__marshalByValueAlias = "FloatingPaneResizeEventArgsDetail";
    return WebFloatingPaneResizeEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFloatingPaneResizeEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFloatingPaneResizeEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebFloatingPaneResizeEventArgsDetailDescriptionMetadata.a == null) {
                WebFloatingPaneResizeEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFloatingPaneResizeEventArgsDetailDescriptionMetadata.c(WebFloatingPaneResizeEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebFloatingPaneResizeEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFloatingPaneResizeEventArgsDetailDescriptionMetadata.a);
            WebSplitPaneDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FloatingPaneResizeEventArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("SourcePane", "ExportedType:WebSplitPane");
            a.item("ResizerLocation", "ExportedType:string:ResizerLocation");
            a.item("ResizerLocation@stringUnion", "WebComponents;React");
            a.item("ResizerLocation@names", "Top;Bottom;Left;Right;TopLeft;TopRight;BottomLeft;BottomRight");
        }
        static d(a) {
            WebFloatingPaneResizeEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebFloatingPaneResizeEventArgsDetail", () => new WebFloatingPaneResizeEventArgsDetailDescription());
            a.ad("WebFloatingPaneResizeEventArgsDetail", WebFloatingPaneResizeEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebFloatingPaneResizeEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFloatingPaneResizeEventArgsDetailDescriptionMetadata, 'WebFloatingPaneResizeEventArgsDetailDescriptionMetadata');
    WebFloatingPaneResizeEventArgsDetailDescriptionMetadata.a = null;
    return WebFloatingPaneResizeEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFloatingPaneResizeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFloatingPaneResizeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebFloatingPaneResizeEventArgsDescriptionMetadata.a == null) {
                WebFloatingPaneResizeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFloatingPaneResizeEventArgsDescriptionMetadata.c(WebFloatingPaneResizeEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebFloatingPaneResizeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFloatingPaneResizeEventArgsDescriptionMetadata.a);
            WebFloatingPaneResizeEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FloatingPaneResizeEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebFloatingPaneResizeEventArgsDetail");
        }
        static d(a) {
            WebFloatingPaneResizeEventArgsDescriptionMetadata.b(a);
            a.ae("WebFloatingPaneResizeEventArgs", () => new WebFloatingPaneResizeEventArgsDescription());
            a.ad("WebFloatingPaneResizeEventArgs", WebFloatingPaneResizeEventArgsDescriptionMetadata.a);
        }
    }
    WebFloatingPaneResizeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFloatingPaneResizeEventArgsDescriptionMetadata, 'WebFloatingPaneResizeEventArgsDescriptionMetadata');
    WebFloatingPaneResizeEventArgsDescriptionMetadata.a = null;
    return WebFloatingPaneResizeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFloatingPaneResizeMoveEventArgsDescription = /*@__PURE__*/ (() => {
    class WebFloatingPaneResizeMoveEventArgsDescription extends Description {
        get_type() {
            return "WebFloatingPaneResizeMoveEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebFloatingPaneResizeMoveEventArgsDescription.$t = /*@__PURE__*/ markType(WebFloatingPaneResizeMoveEventArgsDescription, 'WebFloatingPaneResizeMoveEventArgsDescription', Description.$);
    WebFloatingPaneResizeMoveEventArgsDescription.__marshalByValue = true;
    WebFloatingPaneResizeMoveEventArgsDescription.__marshalByValueAlias = "FloatingPaneResizeMoveEventArgs";
    return WebFloatingPaneResizeMoveEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFloatingPaneResizeMoveEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebFloatingPaneResizeMoveEventArgsDetailDescription extends WebFloatingPaneResizeEventArgsDetailDescription {
        get_type() {
            return "WebFloatingPaneResizeMoveEventArgsDetail";
        }
        constructor() {
            super();
            this.w = 0;
            this.u = 0;
            this.v = 0;
            this.t = 0;
            this.p = null;
            this.o = null;
        }
        get oldWidth() {
            return this.w;
        }
        set oldWidth(a) {
            this.w = a;
            this.g("OldWidth");
        }
        get newWidth() {
            return this.u;
        }
        set newWidth(a) {
            this.u = a;
            this.g("NewWidth");
        }
        get oldHeight() {
            return this.v;
        }
        set oldHeight(a) {
            this.v = a;
            this.g("OldHeight");
        }
        get newHeight() {
            return this.t;
        }
        set newHeight(a) {
            this.t = a;
            this.g("NewHeight");
        }
        get oldLocation() {
            return this.p;
        }
        set oldLocation(a) {
            this.p = a;
            this.g("OldLocation");
        }
        get newLocation() {
            return this.o;
        }
        set newLocation(a) {
            this.o = a;
            this.g("NewLocation");
        }
    }
    WebFloatingPaneResizeMoveEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebFloatingPaneResizeMoveEventArgsDetailDescription, 'WebFloatingPaneResizeMoveEventArgsDetailDescription', WebFloatingPaneResizeEventArgsDetailDescription.$);
    WebFloatingPaneResizeMoveEventArgsDetailDescription.__marshalByValue1 = true;
    WebFloatingPaneResizeMoveEventArgsDetailDescription.__marshalByValueAlias1 = "FloatingPaneResizeMoveEventArgsDetail";
    return WebFloatingPaneResizeMoveEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata.a == null) {
                WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata.c(WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata.a);
            WebDockManagerPointDescriptionMetadata.d(a);
        }
        static c(a) {
            WebFloatingPaneResizeEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:FloatingPaneResizeMoveEventArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("OldWidth", "Number:double");
            a.item("NewWidth", "Number:double");
            a.item("OldHeight", "Number:double");
            a.item("NewHeight", "Number:double");
            a.item("OldLocation", "ExportedType:WebDockManagerPoint");
            a.item("NewLocation", "ExportedType:WebDockManagerPoint");
        }
        static d(a) {
            WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebFloatingPaneResizeMoveEventArgsDetail", () => new WebFloatingPaneResizeMoveEventArgsDetailDescription());
            a.ad("WebFloatingPaneResizeMoveEventArgsDetail", WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata, 'WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata');
    WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata.a = null;
    return WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFloatingPaneResizeMoveEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFloatingPaneResizeMoveEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebFloatingPaneResizeMoveEventArgsDescriptionMetadata.a == null) {
                WebFloatingPaneResizeMoveEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFloatingPaneResizeMoveEventArgsDescriptionMetadata.c(WebFloatingPaneResizeMoveEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebFloatingPaneResizeMoveEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFloatingPaneResizeMoveEventArgsDescriptionMetadata.a);
            WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:FloatingPaneResizeMoveEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebFloatingPaneResizeMoveEventArgsDetail");
        }
        static d(a) {
            WebFloatingPaneResizeMoveEventArgsDescriptionMetadata.b(a);
            a.ae("WebFloatingPaneResizeMoveEventArgs", () => new WebFloatingPaneResizeMoveEventArgsDescription());
            a.ad("WebFloatingPaneResizeMoveEventArgs", WebFloatingPaneResizeMoveEventArgsDescriptionMetadata.a);
        }
    }
    WebFloatingPaneResizeMoveEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFloatingPaneResizeMoveEventArgsDescriptionMetadata, 'WebFloatingPaneResizeMoveEventArgsDescriptionMetadata');
    WebFloatingPaneResizeMoveEventArgsDescriptionMetadata.a = null;
    return WebFloatingPaneResizeMoveEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFloatPaneActionDescription = /*@__PURE__*/ (() => {
    class WebFloatPaneActionDescription extends WebPaneDragActionDescription {
        get_type() {
            return "WebFloatPaneAction";
        }
        constructor() {
            super();
            this.s = null;
            this.k = null;
            this.o = 0;
            this.n = 0;
        }
        get actionType() {
            return this.s;
        }
        set actionType(a) {
            this.s = a;
            this.g("ActionType");
        }
        get location() {
            return this.k;
        }
        set location(a) {
            this.k = a;
            this.g("Location");
        }
        get width() {
            return this.o;
        }
        set width(a) {
            this.o = a;
            this.g("Width");
        }
        get height() {
            return this.n;
        }
        set height(a) {
            this.n = a;
            this.g("Height");
        }
    }
    WebFloatPaneActionDescription.$t = /*@__PURE__*/ markType(WebFloatPaneActionDescription, 'WebFloatPaneActionDescription', WebPaneDragActionDescription.$);
    WebFloatPaneActionDescription.__marshalByValue1 = true;
    WebFloatPaneActionDescription.__marshalByValueAlias1 = "FloatPaneAction";
    return WebFloatPaneActionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebFloatPaneActionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebFloatPaneActionDescriptionMetadata extends Base {
        static b(a) {
            if (WebFloatPaneActionDescriptionMetadata.a == null) {
                WebFloatPaneActionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebFloatPaneActionDescriptionMetadata.c(WebFloatPaneActionDescriptionMetadata.a);
            }
            if (a.k(WebFloatPaneActionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebFloatPaneActionDescriptionMetadata.a);
            WebDockManagerPointDescriptionMetadata.d(a);
        }
        static c(a) {
            WebPaneDragActionDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:FloatPaneAction");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__skipSuffix", "Boolean");
            a.item("ActionType", "(wc:Type)ExportedType:string:PaneDragActionType");
            a.item("ActionType@names", "FloatPane;MoveFloatingPane;DockPane;MoveTab");
            a.item("Location", "ExportedType:WebDockManagerPoint");
            a.item("Width", "Number:double");
            a.item("Height", "Number:double");
        }
        static d(a) {
            WebFloatPaneActionDescriptionMetadata.b(a);
            a.ae("WebFloatPaneAction", () => new WebFloatPaneActionDescription());
            a.ad("WebFloatPaneAction", WebFloatPaneActionDescriptionMetadata.a);
        }
    }
    WebFloatPaneActionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebFloatPaneActionDescriptionMetadata, 'WebFloatPaneActionDescriptionMetadata');
    WebFloatPaneActionDescriptionMetadata.a = null;
    return WebFloatPaneActionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridDescription = /*@__PURE__*/ (() => {
    class WebGridDescription extends WebGridBaseDirectiveDescription {
        get_type() {
            return "WebGrid";
        }
        constructor() {
            super();
            this.gt = false;
            this.g5 = null;
            this.g3 = null;
            this.g9 = null;
            this.g2 = null;
            this.gz = 0;
            this.go = null;
            this.gn = null;
            this.gu = false;
            this.gr = null;
            this.g4 = null;
            this.g6 = null;
            this.g8 = null;
            this.gv = false;
            this.g1 = null;
            this.g7 = null;
        }
        get groupsExpanded() {
            return this.gt;
        }
        set groupsExpanded(a) {
            this.gt = a;
            this.g("GroupsExpanded");
        }
        get dropAreaTemplateRef() {
            return this.g5;
        }
        set dropAreaTemplateRef(a) {
            this.g5 = a;
            this.g("DropAreaTemplateRef");
        }
        get detailTemplateRef() {
            return this.g3;
        }
        set detailTemplateRef(a) {
            this.g3 = a;
            this.g("DetailTemplateRef");
        }
        get id() {
            return this.g9;
        }
        set id(a) {
            this.g9 = a;
            this.g("Id");
        }
        get dataRef() {
            return this.g2;
        }
        set dataRef(a) {
            this.g2 = a;
            this.g("DataRef");
        }
        get totalItemCount() {
            return this.gz;
        }
        set totalItemCount(a) {
            this.gz = a;
            this.g("TotalItemCount");
        }
        get groupingExpressions() {
            return this.go;
        }
        set groupingExpressions(a) {
            this.go = a;
            this.g("GroupingExpressions");
        }
        get groupingExpansionState() {
            return this.gn;
        }
        set groupingExpansionState(a) {
            this.gn = a;
            this.g("GroupingExpansionState");
        }
        get hideGroupedColumns() {
            return this.gu;
        }
        set hideGroupedColumns(a) {
            this.gu = a;
            this.g("HideGroupedColumns");
        }
        get groupStrategy() {
            return this.gr;
        }
        set groupStrategy(a) {
            this.gr = a;
            this.g("GroupStrategy");
        }
        get dropAreaMessage() {
            return this.g4;
        }
        set dropAreaMessage(a) {
            this.g4 = a;
            this.g("DropAreaMessage");
        }
        get groupByRowSelectorTemplateRef() {
            return this.g6;
        }
        set groupByRowSelectorTemplateRef(a) {
            this.g6 = a;
            this.g("GroupByRowSelectorTemplateRef");
        }
        get groupRowTemplateRef() {
            return this.g8;
        }
        set groupRowTemplateRef(a) {
            this.g8 = a;
            this.g("GroupRowTemplateRef");
        }
        get showGroupArea() {
            return this.gv;
        }
        set showGroupArea(a) {
            this.gv = a;
            this.g("ShowGroupArea");
        }
        get dataPreLoadRef() {
            return this.g1;
        }
        set dataPreLoadRef(a) {
            this.g1 = a;
            this.g("DataPreLoadRef");
        }
        get groupingDoneRef() {
            return this.g7;
        }
        set groupingDoneRef(a) {
            this.g7 = a;
            this.g("GroupingDoneRef");
        }
    }
    WebGridDescription.$t = /*@__PURE__*/ markType(WebGridDescription, 'WebGridDescription', WebGridBaseDirectiveDescription.$);
    return WebGridDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupByKeyDescription = /*@__PURE__*/ (() => {
    class WebGroupByKeyDescription extends Description {
        get_type() {
            return "WebGroupByKey";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = null;
        }
        get fieldName() {
            return this.j;
        }
        set fieldName(a) {
            this.j = a;
            this.g("FieldName");
        }
        get value() {
            return this.h;
        }
        set value(a) {
            this.h = a;
            this.g("Value");
        }
    }
    WebGroupByKeyDescription.$t = /*@__PURE__*/ markType(WebGroupByKeyDescription, 'WebGroupByKeyDescription', Description.$);
    return WebGroupByKeyDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupByKeyDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGroupByKeyDescriptionMetadata extends Base {
        static b(a) {
            if (WebGroupByKeyDescriptionMetadata.a == null) {
                WebGroupByKeyDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGroupByKeyDescriptionMetadata.c(WebGroupByKeyDescriptionMetadata.a);
            }
            if (a.k(WebGroupByKeyDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGroupByKeyDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GroupByKey");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("FieldName", "String");
            a.item("Value", "Unknown");
        }
        static d(a) {
            WebGroupByKeyDescriptionMetadata.b(a);
            a.ae("WebGroupByKey", () => new WebGroupByKeyDescription());
            a.ad("WebGroupByKey", WebGroupByKeyDescriptionMetadata.a);
        }
    }
    WebGroupByKeyDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGroupByKeyDescriptionMetadata, 'WebGroupByKeyDescriptionMetadata');
    WebGroupByKeyDescriptionMetadata.a = null;
    return WebGroupByKeyDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupByExpandStateDescription = /*@__PURE__*/ (() => {
    class WebGroupByExpandStateDescription extends Description {
        get_type() {
            return "WebGroupByExpandState";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = false;
            this.h = null;
        }
        get expanded() {
            return this.j;
        }
        set expanded(a) {
            this.j = a;
            this.g("Expanded");
        }
        get hierarchy() {
            return this.h;
        }
        set hierarchy(a) {
            this.h = a;
            this.g("Hierarchy");
        }
    }
    WebGroupByExpandStateDescription.$t = /*@__PURE__*/ markType(WebGroupByExpandStateDescription, 'WebGroupByExpandStateDescription', Description.$);
    return WebGroupByExpandStateDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupByExpandStateDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGroupByExpandStateDescriptionMetadata extends Base {
        static b(a) {
            if (WebGroupByExpandStateDescriptionMetadata.a == null) {
                WebGroupByExpandStateDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGroupByExpandStateDescriptionMetadata.c(WebGroupByExpandStateDescriptionMetadata.a);
            }
            if (a.k(WebGroupByExpandStateDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGroupByExpandStateDescriptionMetadata.a);
            WebGroupByKeyDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GroupByExpandState");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Expanded", "Boolean");
            a.item("Hierarchy", "Array:WebGroupByKeyDescription:GroupByKey");
        }
        static d(a) {
            WebGroupByExpandStateDescriptionMetadata.b(a);
            a.ae("WebGroupByExpandState", () => new WebGroupByExpandStateDescription());
            a.ad("WebGroupByExpandState", WebGroupByExpandStateDescriptionMetadata.a);
        }
    }
    WebGroupByExpandStateDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGroupByExpandStateDescriptionMetadata, 'WebGroupByExpandStateDescriptionMetadata');
    WebGroupByExpandStateDescriptionMetadata.a = null;
    return WebGroupByExpandStateDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridGroupingStrategyDescription = /*@__PURE__*/ (() => {
    class WebGridGroupingStrategyDescription extends WebGridSortingStrategyDescription {
        get_type() {
            return "WebGridGroupingStrategy";
        }
        constructor() {
            super();
        }
    }
    WebGridGroupingStrategyDescription.$t = /*@__PURE__*/ markType(WebGridGroupingStrategyDescription, 'WebGridGroupingStrategyDescription', WebGridSortingStrategyDescription.$);
    return WebGridGroupingStrategyDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridGroupingStrategyDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridGroupingStrategyDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridGroupingStrategyDescriptionMetadata.a == null) {
                WebGridGroupingStrategyDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridGroupingStrategyDescriptionMetadata.c(WebGridGroupingStrategyDescriptionMetadata.a);
            }
            if (a.k(WebGridGroupingStrategyDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridGroupingStrategyDescriptionMetadata.a);
        }
        static c(a) {
            WebGridSortingStrategyDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridGroupingStrategy");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebGridGroupingStrategyDescriptionMetadata.b(a);
            a.ae("WebGridGroupingStrategy", () => new WebGridGroupingStrategyDescription());
            a.ad("WebGridGroupingStrategy", WebGridGroupingStrategyDescriptionMetadata.a);
        }
    }
    WebGridGroupingStrategyDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridGroupingStrategyDescriptionMetadata, 'WebGridGroupingStrategyDescriptionMetadata');
    WebGridGroupingStrategyDescriptionMetadata.a = null;
    return WebGridGroupingStrategyDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupingDoneEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebGroupingDoneEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebGroupingDoneEventArgsDetail";
        }
        constructor() {
            super();
            this.m = null;
            this.n = null;
            this.o = null;
        }
        get expressions() {
            return this.m;
        }
        set expressions(a) {
            this.m = a;
            this.g("Expressions");
        }
        get groupedColumns() {
            return this.n;
        }
        set groupedColumns(a) {
            this.n = a;
            this.g("GroupedColumns");
        }
        get ungroupedColumns() {
            return this.o;
        }
        set ungroupedColumns(a) {
            this.o = a;
            this.g("UngroupedColumns");
        }
    }
    WebGroupingDoneEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebGroupingDoneEventArgsDetailDescription, 'WebGroupingDoneEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebGroupingDoneEventArgsDetailDescription.__marshalByValue1 = true;
    WebGroupingDoneEventArgsDetailDescription.__marshalByValueAlias1 = "GroupingDoneEventArgsDetail";
    return WebGroupingDoneEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupingDoneEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGroupingDoneEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGroupingDoneEventArgsDetailDescriptionMetadata.a == null) {
                WebGroupingDoneEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGroupingDoneEventArgsDetailDescriptionMetadata.c(WebGroupingDoneEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebGroupingDoneEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGroupingDoneEventArgsDetailDescriptionMetadata.a);
            WebSortingExpressionDescriptionMetadata.d(a);
            WebColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GroupingDoneEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Expressions", "Array:WebSortingExpressionDescription:SortingExpression");
            a.item("GroupedColumns", "Array:WebColumnDescription:Column");
            a.item("UngroupedColumns", "Array:WebColumnDescription:Column");
        }
        static d(a) {
            WebGroupingDoneEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebGroupingDoneEventArgsDetail", () => new WebGroupingDoneEventArgsDetailDescription());
            a.ad("WebGroupingDoneEventArgsDetail", WebGroupingDoneEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebGroupingDoneEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGroupingDoneEventArgsDetailDescriptionMetadata, 'WebGroupingDoneEventArgsDetailDescriptionMetadata');
    WebGroupingDoneEventArgsDetailDescriptionMetadata.a = null;
    return WebGroupingDoneEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupingDoneEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGroupingDoneEventArgsDescription extends Description {
        get_type() {
            return "WebGroupingDoneEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGroupingDoneEventArgsDescription.$t = /*@__PURE__*/ markType(WebGroupingDoneEventArgsDescription, 'WebGroupingDoneEventArgsDescription', Description.$);
    WebGroupingDoneEventArgsDescription.__marshalByValue = true;
    WebGroupingDoneEventArgsDescription.__marshalByValueAlias = "GroupingDoneEventArgs";
    return WebGroupingDoneEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupingDoneEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGroupingDoneEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGroupingDoneEventArgsDescriptionMetadata.a == null) {
                WebGroupingDoneEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGroupingDoneEventArgsDescriptionMetadata.c(WebGroupingDoneEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGroupingDoneEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGroupingDoneEventArgsDescriptionMetadata.a);
            WebGroupingDoneEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GroupingDoneEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebGroupingDoneEventArgsDetail");
        }
        static d(a) {
            WebGroupingDoneEventArgsDescriptionMetadata.b(a);
            a.ae("WebGroupingDoneEventArgs", () => new WebGroupingDoneEventArgsDescription());
            a.ad("WebGroupingDoneEventArgs", WebGroupingDoneEventArgsDescriptionMetadata.a);
        }
    }
    WebGroupingDoneEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGroupingDoneEventArgsDescriptionMetadata, 'WebGroupingDoneEventArgsDescriptionMetadata');
    WebGroupingDoneEventArgsDescriptionMetadata.a = null;
    return WebGroupingDoneEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridDescriptionMetadata.a == null) {
                WebGridDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridDescriptionMetadata.c(WebGridDescriptionMetadata.a);
            }
            if (a.k(WebGridDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridDescriptionMetadata.a);
            WebGridDescriptionMetadata.f(a);
            WebGroupingExpressionDescriptionMetadata.d(a);
            WebGroupByExpandStateDescriptionMetadata.d(a);
            WebGridGroupingStrategyDescriptionMetadata.d(a);
            WebForOfStateEventArgsDescriptionMetadata.d(a);
            WebGroupingDoneEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebGridBaseDirectiveDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:Grid");
            a.item("__tagNameWC", "String:igc-grid");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            if (a.containsKey("__skipSuffix")) {
                a.removeItem("__skipSuffix");
            }
            a.item("GroupsExpanded", "Boolean");
            a.item("DropAreaTemplateRef", "(w:DropAreaTemplate,wf:DropAreaTemplate)TemplateRef::object");
            a.item("DetailTemplateRef", "(w:DetailTemplate,wf:DetailTemplate)TemplateRef::object");
            a.item("Id", "String");
            a.item("DataRef", "(w:Data,wf:Data)DataRef::object");
            a.item("TotalItemCount", "Number:double");
            a.item("GroupingExpressions", "Array:WebGroupingExpressionDescription:GroupingExpression");
            a.item("GroupingExpressions@mustSetInCode", "WebComponents;Blazor;React");
            a.item("GroupingExpansionState", "Array:WebGroupByExpandStateDescription:GroupByExpandState");
            a.item("HideGroupedColumns", "Boolean");
            a.item("GroupStrategy", "ExportedType:WebGridGroupingStrategy");
            a.item("DropAreaMessage", "String");
            a.item("GroupByRowSelectorTemplateRef", "(w:GroupByRowSelectorTemplate,wf:GroupByRowSelectorTemplate)TemplateRef::object");
            a.item("GroupRowTemplateRef", "(w:GroupRowTemplate,wf:GroupRowTemplate)TemplateRef::object");
            a.item("ShowGroupArea", "Boolean");
            a.item("DataPreLoadRef", "EventRef::dataPreLoad:customEvent");
            a.item("GroupingDoneRef", "EventRef::groupingDone:customEvent");
            WebGridDescriptionMetadata.e(a);
        }
        static d(a) {
            WebGridDescriptionMetadata.b(a);
            a.ae("WebGrid", () => new WebGridDescription());
            a.ad("WebGrid", WebGridDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__deferAttachWC", "Boolean");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
        }
        static f(a) {
            WebGridToolbarDescriptionMetadata.d(a);
            WebGridToolbarActionsDescriptionMetadata.d(a);
            WebGridToolbarTitleDescriptionMetadata.d(a);
            WebGridToolbarExporterDescriptionMetadata.d(a);
            WebGridToolbarHidingDescriptionMetadata.d(a);
            WebGridToolbarPinningDescriptionMetadata.d(a);
            WebGridToolbarAdvancedFilteringDescriptionMetadata.d(a);
            WebGridToolbarBaseActionDescriptionMetadata.d(a);
            WebGridToolbarContentDescriptionMetadata.d(a);
        }
    }
    WebGridDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridDescriptionMetadata, 'WebGridDescriptionMetadata');
    WebGridDescriptionMetadata.a = null;
    return WebGridDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridActionButtonDescription = /*@__PURE__*/ (() => {
    class WebGridActionButtonDescription extends Description {
        get_type() {
            return "WebGridActionButton";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
            this.k = null;
            this.j = null;
            this.l = null;
            this.m = null;
        }
        get asMenuItem() {
            return this.h;
        }
        set asMenuItem(a) {
            this.h = a;
            this.g("AsMenuItem");
        }
        get iconName() {
            return this.k;
        }
        set iconName(a) {
            this.k = a;
            this.g("IconName");
        }
        get classNames() {
            return this.j;
        }
        set classNames(a) {
            this.j = a;
            this.g("ClassNames");
        }
        get iconSet() {
            return this.l;
        }
        set iconSet(a) {
            this.l = a;
            this.g("IconSet");
        }
        get labelText() {
            return this.m;
        }
        set labelText(a) {
            this.m = a;
            this.g("LabelText");
        }
    }
    WebGridActionButtonDescription.$t = /*@__PURE__*/ markType(WebGridActionButtonDescription, 'WebGridActionButtonDescription', Description.$);
    return WebGridActionButtonDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridActionButtonDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridActionButtonDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridActionButtonDescriptionMetadata.a == null) {
                WebGridActionButtonDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridActionButtonDescriptionMetadata.c(WebGridActionButtonDescriptionMetadata.a);
            }
            if (a.k(WebGridActionButtonDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridActionButtonDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridActionButton");
            a.item("__tagNameWC", "String:igc-grid-action-button");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("AsMenuItem", "Boolean");
            a.item("IconName", "String");
            a.item("ClassNames", "String");
            a.item("IconSet", "String");
            a.item("LabelText", "String");
        }
        static d(a) {
            WebGridActionButtonDescriptionMetadata.b(a);
            a.ae("WebGridActionButton", () => new WebGridActionButtonDescription());
            a.ad("WebGridActionButton", WebGridActionButtonDescriptionMetadata.a);
        }
    }
    WebGridActionButtonDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridActionButtonDescriptionMetadata, 'WebGridActionButtonDescriptionMetadata');
    WebGridActionButtonDescriptionMetadata.a = null;
    return WebGridActionButtonDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridActionsBaseDirectiveDescription = /*@__PURE__*/ (() => {
    class WebGridActionsBaseDirectiveDescription extends Description {
        get_type() {
            return "WebGridActionsBaseDirective";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
            this.j = null;
        }
        get asMenuItems() {
            return this.h;
        }
        set asMenuItems(a) {
            this.h = a;
            this.g("AsMenuItems");
        }
        get name() {
            return this.j;
        }
        set name(a) {
            this.j = a;
            this.g("Name");
        }
    }
    WebGridActionsBaseDirectiveDescription.$t = /*@__PURE__*/ markType(WebGridActionsBaseDirectiveDescription, 'WebGridActionsBaseDirectiveDescription', Description.$);
    return WebGridActionsBaseDirectiveDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridActionsBaseDirectiveDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridActionsBaseDirectiveDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridActionsBaseDirectiveDescriptionMetadata.a == null) {
                WebGridActionsBaseDirectiveDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridActionsBaseDirectiveDescriptionMetadata.c(WebGridActionsBaseDirectiveDescriptionMetadata.a);
            }
            if (a.k(WebGridActionsBaseDirectiveDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridActionsBaseDirectiveDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridActionsBaseDirective");
            a.item("__tagNameWC", "String:igc-grid-action-base-directive");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("__manageCollectionInMarkup", "Boolean");
            a.item("AsMenuItems", "Boolean");
            a.item("Name", "String");
        }
        static d(a) {
            WebGridActionsBaseDirectiveDescriptionMetadata.b(a);
            a.ae("WebGridActionsBaseDirective", () => new WebGridActionsBaseDirectiveDescription());
            a.ad("WebGridActionsBaseDirective", WebGridActionsBaseDirectiveDescriptionMetadata.a);
        }
    }
    WebGridActionsBaseDirectiveDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridActionsBaseDirectiveDescriptionMetadata, 'WebGridActionsBaseDirectiveDescriptionMetadata');
    WebGridActionsBaseDirectiveDescriptionMetadata.a = null;
    return WebGridActionsBaseDirectiveDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridActionsBaseDirectiveDescriptionModule = /*@__PURE__*/ (() => {
    class WebGridActionsBaseDirectiveDescriptionModule extends Base {
        static register(a) {
            WebGridActionsBaseDirectiveDescriptionMetadata.d(a);
        }
    }
    WebGridActionsBaseDirectiveDescriptionModule.$t = /*@__PURE__*/ markType(WebGridActionsBaseDirectiveDescriptionModule, 'WebGridActionsBaseDirectiveDescriptionModule');
    return WebGridActionsBaseDirectiveDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridPaginatorTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebGridPaginatorTemplateContextDescription extends Description {
        get_type() {
            return "WebGridPaginatorTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get implicit() {
            return this.h;
        }
        set implicit(a) {
            this.h = a;
            this.g("Implicit");
        }
    }
    WebGridPaginatorTemplateContextDescription.$t = /*@__PURE__*/ markType(WebGridPaginatorTemplateContextDescription, 'WebGridPaginatorTemplateContextDescription', Description.$);
    WebGridPaginatorTemplateContextDescription.__marshalByValue = true;
    WebGridPaginatorTemplateContextDescription.__marshalByValueAlias = "GridPaginatorTemplateContext";
    return WebGridPaginatorTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridPaginatorTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridPaginatorTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridPaginatorTemplateContextDescriptionMetadata.a == null) {
                WebGridPaginatorTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridPaginatorTemplateContextDescriptionMetadata.c(WebGridPaginatorTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebGridPaginatorTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridPaginatorTemplateContextDescriptionMetadata.a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridPaginatorTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "ExportedType:WebGridBaseDirective");
        }
        static d(a) {
            WebGridPaginatorTemplateContextDescriptionMetadata.b(a);
            a.ae("WebGridPaginatorTemplateContext", () => new WebGridPaginatorTemplateContextDescription());
            a.ad("WebGridPaginatorTemplateContext", WebGridPaginatorTemplateContextDescriptionMetadata.a);
        }
    }
    WebGridPaginatorTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridPaginatorTemplateContextDescriptionMetadata, 'WebGridPaginatorTemplateContextDescriptionMetadata');
    WebGridPaginatorTemplateContextDescriptionMetadata.a = null;
    return WebGridPaginatorTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridStateBaseDirectiveDescription = /*@__PURE__*/ (() => {
    class WebGridStateBaseDirectiveDescription extends Description {
        get_type() {
            return "WebGridStateBaseDirective";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = null;
        }
        get options() {
            return this.h;
        }
        set options(a) {
            this.h = a;
            this.g("Options");
        }
        get name() {
            return this.j;
        }
        set name(a) {
            this.j = a;
            this.g("Name");
        }
    }
    WebGridStateBaseDirectiveDescription.$t = /*@__PURE__*/ markType(WebGridStateBaseDirectiveDescription, 'WebGridStateBaseDirectiveDescription', Description.$);
    return WebGridStateBaseDirectiveDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridStateOptionsDescription = /*@__PURE__*/ (() => {
    class WebGridStateOptionsDescription extends Description {
        get_type() {
            return "WebGridStateOptions";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = false;
            this.m = false;
            this.h = false;
            this.v = false;
            this.n = false;
            this.p = false;
            this.i = false;
            this.u = false;
            this.k = false;
            this.t = false;
            this.q = false;
            this.l = false;
            this.s = false;
            this.o = false;
            this.r = false;
        }
        get columns() {
            return this.j;
        }
        set columns(a) {
            this.j = a;
            this.g("Columns");
        }
        get filtering() {
            return this.m;
        }
        set filtering(a) {
            this.m = a;
            this.g("Filtering");
        }
        get advancedFiltering() {
            return this.h;
        }
        set advancedFiltering(a) {
            this.h = a;
            this.g("AdvancedFiltering");
        }
        get sorting() {
            return this.v;
        }
        set sorting(a) {
            this.v = a;
            this.g("Sorting");
        }
        get groupBy() {
            return this.n;
        }
        set groupBy(a) {
            this.n = a;
            this.g("GroupBy");
        }
        get paging() {
            return this.p;
        }
        set paging(a) {
            this.p = a;
            this.g("Paging");
        }
        get cellSelection() {
            return this.i;
        }
        set cellSelection(a) {
            this.i = a;
            this.g("CellSelection");
        }
        get rowSelection() {
            return this.u;
        }
        set rowSelection(a) {
            this.u = a;
            this.g("RowSelection");
        }
        get columnSelection() {
            return this.k;
        }
        set columnSelection(a) {
            this.k = a;
            this.g("ColumnSelection");
        }
        get rowPinning() {
            return this.t;
        }
        set rowPinning(a) {
            this.t = a;
            this.g("RowPinning");
        }
        get pinningConfig() {
            return this.q;
        }
        set pinningConfig(a) {
            this.q = a;
            this.g("PinningConfig");
        }
        get expansion() {
            return this.l;
        }
        set expansion(a) {
            this.l = a;
            this.g("Expansion");
        }
        get rowIslands() {
            return this.s;
        }
        set rowIslands(a) {
            this.s = a;
            this.g("RowIslands");
        }
        get moving() {
            return this.o;
        }
        set moving(a) {
            this.o = a;
            this.g("Moving");
        }
        get pivotConfiguration() {
            return this.r;
        }
        set pivotConfiguration(a) {
            this.r = a;
            this.g("PivotConfiguration");
        }
    }
    WebGridStateOptionsDescription.$t = /*@__PURE__*/ markType(WebGridStateOptionsDescription, 'WebGridStateOptionsDescription', Description.$);
    return WebGridStateOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridStateOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridStateOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridStateOptionsDescriptionMetadata.a == null) {
                WebGridStateOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridStateOptionsDescriptionMetadata.c(WebGridStateOptionsDescriptionMetadata.a);
            }
            if (a.k(WebGridStateOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridStateOptionsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridStateOptions");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Columns", "Boolean");
            a.item("Filtering", "Boolean");
            a.item("AdvancedFiltering", "Boolean");
            a.item("Sorting", "Boolean");
            a.item("GroupBy", "Boolean");
            a.item("Paging", "Boolean");
            a.item("CellSelection", "Boolean");
            a.item("RowSelection", "Boolean");
            a.item("ColumnSelection", "Boolean");
            a.item("RowPinning", "Boolean");
            a.item("PinningConfig", "Boolean");
            a.item("Expansion", "Boolean");
            a.item("RowIslands", "Boolean");
            a.item("Moving", "Boolean");
            a.item("PivotConfiguration", "Boolean");
        }
        static d(a) {
            WebGridStateOptionsDescriptionMetadata.b(a);
            a.ae("WebGridStateOptions", () => new WebGridStateOptionsDescription());
            a.ad("WebGridStateOptions", WebGridStateOptionsDescriptionMetadata.a);
        }
    }
    WebGridStateOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridStateOptionsDescriptionMetadata, 'WebGridStateOptionsDescriptionMetadata');
    WebGridStateOptionsDescriptionMetadata.a = null;
    return WebGridStateOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridStateBaseDirectiveDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridStateBaseDirectiveDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridStateBaseDirectiveDescriptionMetadata.a == null) {
                WebGridStateBaseDirectiveDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridStateBaseDirectiveDescriptionMetadata.c(WebGridStateBaseDirectiveDescriptionMetadata.a);
            }
            if (a.k(WebGridStateBaseDirectiveDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridStateBaseDirectiveDescriptionMetadata.a);
            WebGridStateOptionsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridStateBaseDirective");
            a.item("__tagNameWC", "String:igc-grid-state-base-directive");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("Options", "ExportedType:WebGridStateOptions");
            a.item("Name", "String");
        }
        static d(a) {
            WebGridStateBaseDirectiveDescriptionMetadata.b(a);
            a.ae("WebGridStateBaseDirective", () => new WebGridStateBaseDirectiveDescription());
            a.ad("WebGridStateBaseDirective", WebGridStateBaseDirectiveDescriptionMetadata.a);
        }
    }
    WebGridStateBaseDirectiveDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridStateBaseDirectiveDescriptionMetadata, 'WebGridStateBaseDirectiveDescriptionMetadata');
    WebGridStateBaseDirectiveDescriptionMetadata.a = null;
    return WebGridStateBaseDirectiveDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridStateBaseDirectiveDescriptionModule = /*@__PURE__*/ (() => {
    class WebGridStateBaseDirectiveDescriptionModule extends Base {
        static register(a) {
            WebGridStateBaseDirectiveDescriptionMetadata.d(a);
        }
    }
    WebGridStateBaseDirectiveDescriptionModule.$t = /*@__PURE__*/ markType(WebGridStateBaseDirectiveDescriptionModule, 'WebGridStateBaseDirectiveDescriptionModule');
    return WebGridStateBaseDirectiveDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridStateDescription = /*@__PURE__*/ (() => {
    class WebGridStateDescription extends WebGridStateBaseDirectiveDescription {
        get_type() {
            return "WebGridState";
        }
        constructor() {
            super();
            this.m = null;
        }
        get stateParsedRef() {
            return this.m;
        }
        set stateParsedRef(a) {
            this.m = a;
            this.g("StateParsedRef");
        }
    }
    WebGridStateDescription.$t = /*@__PURE__*/ markType(WebGridStateDescription, 'WebGridStateDescription', WebGridStateBaseDirectiveDescription.$);
    return WebGridStateDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnStateDescription = /*@__PURE__*/ (() => {
    class WebColumnStateDescription extends Description {
        get_type() {
            return "WebColumnState";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.t = false;
            this.w = false;
            this.o = false;
            this.m = false;
            this.x = false;
            this.p = false;
            this.ay = null;
            this.az = null;
            this.a0 = null;
            this.q = false;
            this.s = false;
            this.av = null;
            this.r = false;
            this.aw = null;
            this.ar = null;
            this.ax = null;
            this.u = false;
            this.v = false;
            this.j = false;
            this.aq = null;
            this.k = false;
            this.l = false;
            this.i = false;
            this.n = false;
            this.y = false;
        }
        get pinned() {
            return this.t;
        }
        set pinned(a) {
            this.t = a;
            this.g("Pinned");
        }
        get sortable() {
            return this.w;
        }
        set sortable(a) {
            this.w = a;
            this.g("Sortable");
        }
        get filterable() {
            return this.o;
        }
        set filterable(a) {
            this.o = a;
            this.g("Filterable");
        }
        get editable() {
            return this.m;
        }
        set editable(a) {
            this.m = a;
            this.g("Editable");
        }
        get sortingIgnoreCase() {
            return this.x;
        }
        set sortingIgnoreCase(a) {
            this.x = a;
            this.g("SortingIgnoreCase");
        }
        get filteringIgnoreCase() {
            return this.p;
        }
        set filteringIgnoreCase(a) {
            this.p = a;
            this.g("FilteringIgnoreCase");
        }
        get headerClasses() {
            return this.ay;
        }
        set headerClasses(a) {
            this.ay = a;
            this.g("HeaderClasses");
        }
        get headerGroupClasses() {
            return this.az;
        }
        set headerGroupClasses(a) {
            this.az = a;
            this.g("HeaderGroupClasses");
        }
        get maxWidth() {
            return this.a0;
        }
        set maxWidth(a) {
            this.a0 = a;
            this.g("MaxWidth");
        }
        get groupable() {
            return this.q;
        }
        set groupable(a) {
            this.q = a;
            this.g("Groupable");
        }
        get hidden() {
            return this.s;
        }
        set hidden(a) {
            this.s = a;
            this.g("Hidden");
        }
        get dataType() {
            return this.av;
        }
        set dataType(a) {
            this.av = a;
            this.g("DataType");
        }
        get hasSummary() {
            return this.r;
        }
        set hasSummary(a) {
            this.r = a;
            this.g("HasSummary");
        }
        get field() {
            return this.aw;
        }
        set field(a) {
            this.aw = a;
            this.g("Field");
        }
        get width() {
            return this.ar;
        }
        set width(a) {
            this.ar = a;
            this.g("Width");
        }
        get header() {
            return this.ax;
        }
        set header(a) {
            this.ax = a;
            this.g("Header");
        }
        get resizable() {
            return this.u;
        }
        set resizable(a) {
            this.u = a;
            this.g("Resizable");
        }
        get searchable() {
            return this.v;
        }
        set searchable(a) {
            this.v = a;
            this.g("Searchable");
        }
        get columnGroup() {
            return this.j;
        }
        set columnGroup(a) {
            this.j = a;
            this.g("ColumnGroup");
        }
        get parent() {
            return this.aq;
        }
        set parent(a) {
            this.aq = a;
            this.g("Parent");
        }
        get disableHiding() {
            return this.k;
        }
        set disableHiding(a) {
            this.k = a;
            this.g("DisableHiding");
        }
        get disablePinning() {
            return this.l;
        }
        set disablePinning(a) {
            this.l = a;
            this.g("DisablePinning");
        }
        get collapsible() {
            return this.i;
        }
        set collapsible(a) {
            this.i = a;
            this.g("Collapsible");
        }
        get expanded() {
            return this.n;
        }
        set expanded(a) {
            this.n = a;
            this.g("Expanded");
        }
        get visibleWhenCollapsed() {
            return this.y;
        }
        set visibleWhenCollapsed(a) {
            this.y = a;
            this.g("VisibleWhenCollapsed");
        }
    }
    WebColumnStateDescription.$t = /*@__PURE__*/ markType(WebColumnStateDescription, 'WebColumnStateDescription', Description.$);
    WebColumnStateDescription.__marshalByValue = true;
    WebColumnStateDescription.__marshalByValueAlias = "ColumnState";
    return WebColumnStateDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebColumnStateDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebColumnStateDescriptionMetadata extends Base {
        static b(a) {
            if (WebColumnStateDescriptionMetadata.a == null) {
                WebColumnStateDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebColumnStateDescriptionMetadata.c(WebColumnStateDescriptionMetadata.a);
            }
            if (a.k(WebColumnStateDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebColumnStateDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ColumnState");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("Pinned", "Boolean");
            a.item("Sortable", "Boolean");
            a.item("Filterable", "Boolean");
            a.item("Editable", "Boolean");
            a.item("SortingIgnoreCase", "Boolean");
            a.item("FilteringIgnoreCase", "Boolean");
            a.item("HeaderClasses", "String");
            a.item("HeaderGroupClasses", "String");
            a.item("MaxWidth", "String");
            a.item("Groupable", "Boolean");
            a.item("Hidden", "Boolean");
            a.item("DataType", "ExportedType:string:GridColumnDataType");
            a.item("DataType@stringUnion", "WebComponents;React");
            a.item("DataType@names", "String;Number;Boolean;Date;DateTime;Time;Currency;Percent;Image");
            a.item("HasSummary", "Boolean");
            a.item("Field", "String");
            a.item("Width", "Unknown");
            a.item("Header", "String");
            a.item("Resizable", "Boolean");
            a.item("Searchable", "Boolean");
            a.item("ColumnGroup", "Boolean");
            a.item("Parent", "Unknown");
            a.item("DisableHiding", "Boolean");
            a.item("DisablePinning", "Boolean");
            a.item("Collapsible", "Boolean");
            a.item("Expanded", "Boolean");
            a.item("VisibleWhenCollapsed", "Boolean");
        }
        static d(a) {
            WebColumnStateDescriptionMetadata.b(a);
            a.ae("WebColumnState", () => new WebColumnStateDescription());
            a.ad("WebColumnState", WebColumnStateDescriptionMetadata.a);
        }
    }
    WebColumnStateDescriptionMetadata.$t = /*@__PURE__*/ markType(WebColumnStateDescriptionMetadata, 'WebColumnStateDescriptionMetadata');
    WebColumnStateDescriptionMetadata.a = null;
    return WebColumnStateDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPagingStateDescription = /*@__PURE__*/ (() => {
    class WebPagingStateDescription extends Description {
        get_type() {
            return "WebPagingState";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = 0;
            this.j = 0;
        }
        get index() {
            return this.i;
        }
        set index(a) {
            this.i = a;
            this.g("Index");
        }
        get recordsPerPage() {
            return this.j;
        }
        set recordsPerPage(a) {
            this.j = a;
            this.g("RecordsPerPage");
        }
    }
    WebPagingStateDescription.$t = /*@__PURE__*/ markType(WebPagingStateDescription, 'WebPagingStateDescription', Description.$);
    WebPagingStateDescription.__marshalByValue = true;
    WebPagingStateDescription.__marshalByValueAlias = "PagingState";
    return WebPagingStateDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPagingStateDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPagingStateDescriptionMetadata extends Base {
        static b(a) {
            if (WebPagingStateDescriptionMetadata.a == null) {
                WebPagingStateDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPagingStateDescriptionMetadata.c(WebPagingStateDescriptionMetadata.a);
            }
            if (a.k(WebPagingStateDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPagingStateDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PagingState");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("Index", "Number:double");
            a.item("RecordsPerPage", "Number:double");
        }
        static d(a) {
            WebPagingStateDescriptionMetadata.b(a);
            a.ae("WebPagingState", () => new WebPagingStateDescription());
            a.ad("WebPagingState", WebPagingStateDescriptionMetadata.a);
        }
    }
    WebPagingStateDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPagingStateDescriptionMetadata, 'WebPagingStateDescriptionMetadata');
    WebPagingStateDescriptionMetadata.a = null;
    return WebPagingStateDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupingStateDescription = /*@__PURE__*/ (() => {
    class WebGroupingStateDescription extends Description {
        get_type() {
            return "WebGroupingState";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
            this.m = false;
        }
        get expressions() {
            return this.i;
        }
        set expressions(a) {
            this.i = a;
            this.g("Expressions");
        }
        get expansion() {
            return this.h;
        }
        set expansion(a) {
            this.h = a;
            this.g("Expansion");
        }
        get defaultExpanded() {
            return this.m;
        }
        set defaultExpanded(a) {
            this.m = a;
            this.g("DefaultExpanded");
        }
    }
    WebGroupingStateDescription.$t = /*@__PURE__*/ markType(WebGroupingStateDescription, 'WebGroupingStateDescription', Description.$);
    WebGroupingStateDescription.__marshalByValue = true;
    WebGroupingStateDescription.__marshalByValueAlias = "GroupingState";
    return WebGroupingStateDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupingStateDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGroupingStateDescriptionMetadata extends Base {
        static b(a) {
            if (WebGroupingStateDescriptionMetadata.a == null) {
                WebGroupingStateDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGroupingStateDescriptionMetadata.c(WebGroupingStateDescriptionMetadata.a);
            }
            if (a.k(WebGroupingStateDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGroupingStateDescriptionMetadata.a);
            WebGroupingExpressionDescriptionMetadata.d(a);
            WebGroupByExpandStateDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GroupingState");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("Expressions", "Array:WebGroupingExpressionDescription:GroupingExpression");
            a.item("Expansion", "Array:WebGroupByExpandStateDescription:GroupByExpandState");
            a.item("DefaultExpanded", "Boolean");
        }
        static d(a) {
            WebGroupingStateDescriptionMetadata.b(a);
            a.ae("WebGroupingState", () => new WebGroupingStateDescription());
            a.ad("WebGroupingState", WebGroupingStateDescriptionMetadata.a);
        }
    }
    WebGroupingStateDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGroupingStateDescriptionMetadata, 'WebGroupingStateDescriptionMetadata');
    WebGroupingStateDescriptionMetadata.a = null;
    return WebGroupingStateDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridSelectionRangeDescription = /*@__PURE__*/ (() => {
    class WebGridSelectionRangeDescription extends Description {
        get_type() {
            return "WebGridSelectionRange";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = 0;
            this.k = 0;
            this.j = 0;
            this.i = 0;
        }
        get rowStart() {
            return this.l;
        }
        set rowStart(a) {
            this.l = a;
            this.g("RowStart");
        }
        get rowEnd() {
            return this.k;
        }
        set rowEnd(a) {
            this.k = a;
            this.g("RowEnd");
        }
        get columnStart() {
            return this.j;
        }
        set columnStart(a) {
            this.j = a;
            this.g("ColumnStart");
        }
        get columnEnd() {
            return this.i;
        }
        set columnEnd(a) {
            this.i = a;
            this.g("ColumnEnd");
        }
    }
    WebGridSelectionRangeDescription.$t = /*@__PURE__*/ markType(WebGridSelectionRangeDescription, 'WebGridSelectionRangeDescription', Description.$);
    WebGridSelectionRangeDescription.__marshalByValue = true;
    WebGridSelectionRangeDescription.__marshalByValueAlias = "GridSelectionRange";
    return WebGridSelectionRangeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridSelectionRangeDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridSelectionRangeDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridSelectionRangeDescriptionMetadata.a == null) {
                WebGridSelectionRangeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridSelectionRangeDescriptionMetadata.c(WebGridSelectionRangeDescriptionMetadata.a);
            }
            if (a.k(WebGridSelectionRangeDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridSelectionRangeDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridSelectionRange");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("RowStart", "Number:double");
            a.item("RowEnd", "Number:double");
            a.item("ColumnStart", "Number:double");
            a.item("ColumnEnd", "Number:double");
        }
        static d(a) {
            WebGridSelectionRangeDescriptionMetadata.b(a);
            a.ae("WebGridSelectionRange", () => new WebGridSelectionRangeDescription());
            a.ad("WebGridSelectionRange", WebGridSelectionRangeDescriptionMetadata.a);
        }
    }
    WebGridSelectionRangeDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridSelectionRangeDescriptionMetadata, 'WebGridSelectionRangeDescriptionMetadata');
    WebGridSelectionRangeDescriptionMetadata.a = null;
    return WebGridSelectionRangeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDimensionStrategyDescription = /*@__PURE__*/ (() => {
    class WebPivotDimensionStrategyDescription extends Description {
        get_type() {
            return "WebPivotDimensionStrategy";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebPivotDimensionStrategyDescription.$t = /*@__PURE__*/ markType(WebPivotDimensionStrategyDescription, 'WebPivotDimensionStrategyDescription', Description.$);
    return WebPivotDimensionStrategyDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDimensionStrategyDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotDimensionStrategyDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotDimensionStrategyDescriptionMetadata.a == null) {
                WebPivotDimensionStrategyDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotDimensionStrategyDescriptionMetadata.c(WebPivotDimensionStrategyDescriptionMetadata.a);
            }
            if (a.k(WebPivotDimensionStrategyDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotDimensionStrategyDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotDimensionStrategy");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebPivotDimensionStrategyDescriptionMetadata.b(a);
            a.ae("WebPivotDimensionStrategy", () => new WebPivotDimensionStrategyDescription());
            a.ad("WebPivotDimensionStrategy", WebPivotDimensionStrategyDescriptionMetadata.a);
        }
    }
    WebPivotDimensionStrategyDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotDimensionStrategyDescriptionMetadata, 'WebPivotDimensionStrategyDescriptionMetadata');
    WebPivotDimensionStrategyDescriptionMetadata.a = null;
    return WebPivotDimensionStrategyDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotAggregatorDescription = /*@__PURE__*/ (() => {
    class WebPivotAggregatorDescription extends Description {
        get_type() {
            return "WebPivotAggregator";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.m = null;
            this.j = null;
            this.k = null;
        }
        get key() {
            return this.l;
        }
        set key(a) {
            this.l = a;
            this.g("Key");
        }
        get label() {
            return this.m;
        }
        set label(a) {
            this.m = a;
            this.g("Label");
        }
        get aggregatorName() {
            return this.j;
        }
        set aggregatorName(a) {
            this.j = a;
            this.g("AggregatorName");
        }
        get aggregatorRef() {
            return this.k;
        }
        set aggregatorRef(a) {
            this.k = a;
            this.g("AggregatorRef");
        }
    }
    WebPivotAggregatorDescription.$t = /*@__PURE__*/ markType(WebPivotAggregatorDescription, 'WebPivotAggregatorDescription', Description.$);
    WebPivotAggregatorDescription.__marshalByValue = true;
    WebPivotAggregatorDescription.__marshalByValueAlias = "PivotAggregator";
    return WebPivotAggregatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotAggregatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotAggregatorDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotAggregatorDescriptionMetadata.a == null) {
                WebPivotAggregatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotAggregatorDescriptionMetadata.c(WebPivotAggregatorDescriptionMetadata.a);
            }
            if (a.k(WebPivotAggregatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotAggregatorDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotAggregator");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Key", "String");
            a.item("Label", "String");
            a.item("AggregatorName", "ExportedType:string:PivotAggregationType");
            a.item("AggregatorName@stringUnion", "WebComponents;React");
            a.item("AggregatorName@names", "SUM;AVG;MIN;MAX;COUNT;LATEST;EARLIEST");
            a.item("AggregatorRef", "(w:Aggregator,wf:Aggregator)MethodRef");
        }
        static d(a) {
            WebPivotAggregatorDescriptionMetadata.b(a);
            a.ae("WebPivotAggregator", () => new WebPivotAggregatorDescription());
            a.ad("WebPivotAggregator", WebPivotAggregatorDescriptionMetadata.a);
        }
    }
    WebPivotAggregatorDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotAggregatorDescriptionMetadata, 'WebPivotAggregatorDescriptionMetadata');
    WebPivotAggregatorDescriptionMetadata.a = null;
    return WebPivotAggregatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotValueDescription = /*@__PURE__*/ (() => {
    class WebPivotValueDescription extends Description {
        get_type() {
            return "WebPivotValue";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.u = null;
            this.s = null;
            this.j = null;
            this.h = null;
            this.m = false;
            this.o = null;
            this.r = null;
            this.t = null;
        }
        get member() {
            return this.u;
        }
        set member(a) {
            this.u = a;
            this.g("Member");
        }
        get displayName() {
            return this.s;
        }
        set displayName(a) {
            this.s = a;
            this.g("DisplayName");
        }
        get aggregate() {
            return this.j;
        }
        set aggregate(a) {
            this.j = a;
            this.g("Aggregate");
        }
        get aggregateList() {
            return this.h;
        }
        set aggregateList(a) {
            this.h = a;
            this.g("AggregateList");
        }
        get enabled() {
            return this.m;
        }
        set enabled(a) {
            this.m = a;
            this.g("Enabled");
        }
        get styles() {
            return this.o;
        }
        set styles(a) {
            this.o = a;
            this.g("Styles");
        }
        get dataType() {
            return this.r;
        }
        set dataType(a) {
            this.r = a;
            this.g("DataType");
        }
        get formatterRef() {
            return this.t;
        }
        set formatterRef(a) {
            this.t = a;
            this.g("FormatterRef");
        }
    }
    WebPivotValueDescription.$t = /*@__PURE__*/ markType(WebPivotValueDescription, 'WebPivotValueDescription', Description.$);
    WebPivotValueDescription.__marshalByValue = true;
    WebPivotValueDescription.__marshalByValueAlias = "PivotValue";
    return WebPivotValueDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotValueDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotValueDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotValueDescriptionMetadata.a == null) {
                WebPivotValueDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotValueDescriptionMetadata.c(WebPivotValueDescriptionMetadata.a);
            }
            if (a.k(WebPivotValueDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotValueDescriptionMetadata.a);
            WebPivotAggregatorDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotValue");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Member", "String");
            a.item("DisplayName", "String");
            a.item("Aggregate", "ExportedType:WebPivotAggregator");
            a.item("AggregateList", "Array:WebPivotAggregatorDescription:PivotAggregator");
            a.item("Enabled", "Boolean");
            a.item("Styles", "Unknown");
            a.item("DataType", "ExportedType:string:GridColumnDataType");
            a.item("DataType@stringUnion", "WebComponents;React");
            a.item("DataType@names", "String;Number;Boolean;Date;DateTime;Time;Currency;Percent;Image");
            a.item("FormatterRef", "EventRef::formatter");
        }
        static d(a) {
            WebPivotValueDescriptionMetadata.b(a);
            a.ae("WebPivotValue", () => new WebPivotValueDescription());
            a.ad("WebPivotValue", WebPivotValueDescriptionMetadata.a);
        }
    }
    WebPivotValueDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotValueDescriptionMetadata, 'WebPivotValueDescriptionMetadata');
    WebPivotValueDescriptionMetadata.a = null;
    return WebPivotValueDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotKeysDescription = /*@__PURE__*/ (() => {
    class WebPivotKeysDescription extends Description {
        get_type() {
            return "WebPivotKeys";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = null;
            this.n = null;
            this.j = null;
            this.m = null;
            this.l = null;
            this.o = null;
        }
        get children() {
            return this.k;
        }
        set children(a) {
            this.k = a;
            this.g("Children");
        }
        get records() {
            return this.n;
        }
        set records(a) {
            this.n = a;
            this.g("Records");
        }
        get aggregations() {
            return this.j;
        }
        set aggregations(a) {
            this.j = a;
            this.g("Aggregations");
        }
        get level() {
            return this.m;
        }
        set level(a) {
            this.m = a;
            this.g("Level");
        }
        get columnDimensionSeparator() {
            return this.l;
        }
        set columnDimensionSeparator(a) {
            this.l = a;
            this.g("ColumnDimensionSeparator");
        }
        get rowDimensionSeparator() {
            return this.o;
        }
        set rowDimensionSeparator(a) {
            this.o = a;
            this.g("RowDimensionSeparator");
        }
    }
    WebPivotKeysDescription.$t = /*@__PURE__*/ markType(WebPivotKeysDescription, 'WebPivotKeysDescription', Description.$);
    WebPivotKeysDescription.__marshalByValue = true;
    WebPivotKeysDescription.__marshalByValueAlias = "PivotKeys";
    return WebPivotKeysDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotKeysDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotKeysDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotKeysDescriptionMetadata.a == null) {
                WebPivotKeysDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotKeysDescriptionMetadata.c(WebPivotKeysDescriptionMetadata.a);
            }
            if (a.k(WebPivotKeysDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotKeysDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotKeys");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Children", "String");
            a.item("Records", "String");
            a.item("Aggregations", "String");
            a.item("Level", "String");
            a.item("ColumnDimensionSeparator", "String");
            a.item("RowDimensionSeparator", "String");
        }
        static d(a) {
            WebPivotKeysDescriptionMetadata.b(a);
            a.ae("WebPivotKeys", () => new WebPivotKeysDescription());
            a.ad("WebPivotKeys", WebPivotKeysDescriptionMetadata.a);
        }
    }
    WebPivotKeysDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotKeysDescriptionMetadata, 'WebPivotKeysDescriptionMetadata');
    WebPivotKeysDescriptionMetadata.a = null;
    return WebPivotKeysDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotConfigurationDescription = /*@__PURE__*/ (() => {
    class WebPivotConfigurationDescription extends Description {
        get_type() {
            return "WebPivotConfiguration";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.q = null;
            this.p = null;
            this.j = null;
            this.h = null;
            this.k = null;
            this.i = null;
            this.t = null;
        }
        get rowStrategy() {
            return this.q;
        }
        set rowStrategy(a) {
            this.q = a;
            this.g("RowStrategy");
        }
        get columnStrategy() {
            return this.p;
        }
        set columnStrategy(a) {
            this.p = a;
            this.g("ColumnStrategy");
        }
        get rows() {
            return this.j;
        }
        set rows(a) {
            this.j = a;
            this.g("Rows");
        }
        get columns() {
            return this.h;
        }
        set columns(a) {
            this.h = a;
            this.g("Columns");
        }
        get values() {
            return this.k;
        }
        set values(a) {
            this.k = a;
            this.g("Values");
        }
        get filters() {
            return this.i;
        }
        set filters(a) {
            this.i = a;
            this.g("Filters");
        }
        get pivotKeys() {
            return this.t;
        }
        set pivotKeys(a) {
            this.t = a;
            this.g("PivotKeys");
        }
    }
    WebPivotConfigurationDescription.$t = /*@__PURE__*/ markType(WebPivotConfigurationDescription, 'WebPivotConfigurationDescription', Description.$);
    WebPivotConfigurationDescription.__marshalByValue = true;
    WebPivotConfigurationDescription.__marshalByValueAlias = "PivotConfiguration";
    return WebPivotConfigurationDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotConfigurationDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotConfigurationDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotConfigurationDescriptionMetadata.a == null) {
                WebPivotConfigurationDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotConfigurationDescriptionMetadata.c(WebPivotConfigurationDescriptionMetadata.a);
            }
            if (a.k(WebPivotConfigurationDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotConfigurationDescriptionMetadata.a);
            WebPivotDimensionStrategyDescriptionMetadata.d(a);
            WebPivotDimensionDescriptionMetadata.d(a);
            WebPivotValueDescriptionMetadata.d(a);
            WebPivotKeysDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotConfiguration");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("RowStrategy", "ExportedType:WebPivotDimensionStrategy");
            a.item("ColumnStrategy", "ExportedType:WebPivotDimensionStrategy");
            a.item("Rows", "Array:WebPivotDimensionDescription:PivotDimension");
            a.item("Columns", "Array:WebPivotDimensionDescription:PivotDimension");
            a.item("Values", "Array:WebPivotValueDescription:PivotValue");
            a.item("Filters", "Array:WebPivotDimensionDescription:PivotDimension");
            a.item("PivotKeys", "ExportedType:WebPivotKeys");
        }
        static d(a) {
            WebPivotConfigurationDescriptionMetadata.b(a);
            a.ae("WebPivotConfiguration", () => new WebPivotConfigurationDescription());
            a.ad("WebPivotConfiguration", WebPivotConfigurationDescriptionMetadata.a);
        }
    }
    WebPivotConfigurationDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotConfigurationDescriptionMetadata, 'WebPivotConfigurationDescriptionMetadata');
    WebPivotConfigurationDescriptionMetadata.a = null;
    return WebPivotConfigurationDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridStateInfoDetailDescription = /*@__PURE__*/ (() => {
    class WebGridStateInfoDetailDescription extends Description {
        get_type() {
            return "WebGridStateInfoDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.y = null;
            this.x = null;
            this.ad = null;
            this.ak = false;
            this.o = null;
            this.ab = null;
            this.h = null;
            this.n = null;
            this.j = null;
            this.m = null;
            this.af = null;
            this.k = null;
            this.l = null;
            this.an = null;
            this.ah = null;
        }
        get columns() {
            return this.i;
        }
        set columns(a) {
            this.i = a;
            this.g("Columns");
        }
        get filtering() {
            return this.y;
        }
        set filtering(a) {
            this.y = a;
            this.g("Filtering");
        }
        get advancedFiltering() {
            return this.x;
        }
        set advancedFiltering(a) {
            this.x = a;
            this.g("AdvancedFiltering");
        }
        get paging() {
            return this.ad;
        }
        set paging(a) {
            this.ad = a;
            this.g("Paging");
        }
        get moving() {
            return this.ak;
        }
        set moving(a) {
            this.ak = a;
            this.g("Moving");
        }
        get sorting() {
            return this.o;
        }
        set sorting(a) {
            this.o = a;
            this.g("Sorting");
        }
        get groupBy() {
            return this.ab;
        }
        set groupBy(a) {
            this.ab = a;
            this.g("GroupBy");
        }
        get cellSelection() {
            return this.h;
        }
        set cellSelection(a) {
            this.h = a;
            this.g("CellSelection");
        }
        get rowSelection() {
            return this.n;
        }
        set rowSelection(a) {
            this.n = a;
            this.g("RowSelection");
        }
        get columnSelection() {
            return this.j;
        }
        set columnSelection(a) {
            this.j = a;
            this.g("ColumnSelection");
        }
        get rowPinning() {
            return this.m;
        }
        set rowPinning(a) {
            this.m = a;
            this.g("RowPinning");
        }
        get pinningConfig() {
            return this.af;
        }
        set pinningConfig(a) {
            this.af = a;
            this.g("PinningConfig");
        }
        get expansion() {
            return this.k;
        }
        set expansion(a) {
            this.k = a;
            this.g("Expansion");
        }
        get rowIslands() {
            return this.l;
        }
        set rowIslands(a) {
            this.l = a;
            this.g("RowIslands");
        }
        get id() {
            return this.an;
        }
        set id(a) {
            this.an = a;
            this.g("Id");
        }
        get pivotConfiguration() {
            return this.ah;
        }
        set pivotConfiguration(a) {
            this.ah = a;
            this.g("PivotConfiguration");
        }
    }
    WebGridStateInfoDetailDescription.$t = /*@__PURE__*/ markType(WebGridStateInfoDetailDescription, 'WebGridStateInfoDetailDescription', Description.$);
    WebGridStateInfoDetailDescription.__marshalByValue = true;
    WebGridStateInfoDetailDescription.__marshalByValueAlias = "GridStateInfoDetail";
    return WebGridStateInfoDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridStateInfoEventArgsDescription = /*@__PURE__*/ (() => {
    class WebGridStateInfoEventArgsDescription extends Description {
        get_type() {
            return "WebGridStateInfoEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebGridStateInfoEventArgsDescription.$t = /*@__PURE__*/ markType(WebGridStateInfoEventArgsDescription, 'WebGridStateInfoEventArgsDescription', Description.$);
    WebGridStateInfoEventArgsDescription.__marshalByValue = true;
    WebGridStateInfoEventArgsDescription.__marshalByValueAlias = "GridStateInfoEventArgs";
    return WebGridStateInfoEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridStateCollectionDescription = /*@__PURE__*/ (() => {
    class WebGridStateCollectionDescription extends Description {
        get_type() {
            return "WebGridStateCollection";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.k = null;
            this.h = null;
        }
        get id() {
            return this.n;
        }
        set id(a) {
            this.n = a;
            this.g("Id");
        }
        get parentRowID() {
            return this.k;
        }
        set parentRowID(a) {
            this.k = a;
            this.g("ParentRowID");
        }
        get state() {
            return this.h;
        }
        set state(a) {
            this.h = a;
            this.g("State");
        }
    }
    WebGridStateCollectionDescription.$t = /*@__PURE__*/ markType(WebGridStateCollectionDescription, 'WebGridStateCollectionDescription', Description.$);
    WebGridStateCollectionDescription.__marshalByValue = true;
    WebGridStateCollectionDescription.__marshalByValueAlias = "GridStateCollection";
    return WebGridStateCollectionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridStateDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridStateDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridStateDescriptionMetadata.a == null) {
                WebGridStateDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridStateDescriptionMetadata.c(WebGridStateDescriptionMetadata.a);
            }
            if (a.k(WebGridStateDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridStateDescriptionMetadata.a);
            WebGridStateInfoEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebGridStateBaseDirectiveDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridState");
            a.item("__tagNameWC", "String:igc-grid-state");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            if (a.containsKey("__skipSuffix")) {
                a.removeItem("__skipSuffix");
            }
            a.item("__manageCollectionInMarkup", "Boolean");
            a.item("StateParsedRef", "EventRef::stateParsed:customEvent");
        }
        static d(a) {
            WebGridStateDescriptionMetadata.b(a);
            a.ae("WebGridState", () => new WebGridStateDescription());
            a.ad("WebGridState", WebGridStateDescriptionMetadata.a);
        }
    }
    WebGridStateDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridStateDescriptionMetadata, 'WebGridStateDescriptionMetadata');
    WebGridStateDescriptionMetadata.a = null;
    return WebGridStateDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridStateInfoDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridStateInfoDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridStateInfoDetailDescriptionMetadata.a == null) {
                WebGridStateInfoDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridStateInfoDetailDescriptionMetadata.c(WebGridStateInfoDetailDescriptionMetadata.a);
            }
            if (a.k(WebGridStateInfoDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridStateInfoDetailDescriptionMetadata.a);
            WebColumnStateDescriptionMetadata.d(a);
            WebFilteringExpressionsTreeDescriptionMetadata.d(a);
            WebPagingStateDescriptionMetadata.d(a);
            WebSortingExpressionDescriptionMetadata.d(a);
            WebGroupingStateDescriptionMetadata.d(a);
            WebGridSelectionRangeDescriptionMetadata.d(a);
            WebPinningConfigDescriptionMetadata.d(a);
            WebGridStateCollectionDescriptionMetadata.d(a);
            WebPivotConfigurationDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridStateInfoDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("Columns", "Array:WebColumnStateDescription:ColumnState");
            a.item("Filtering", "ExportedType:WebFilteringExpressionsTree");
            a.item("AdvancedFiltering", "ExportedType:WebFilteringExpressionsTree");
            a.item("Paging", "ExportedType:WebPagingState");
            a.item("Moving", "Boolean");
            a.item("Sorting", "Array:WebSortingExpressionDescription:SortingExpression");
            a.item("GroupBy", "ExportedType:WebGroupingState");
            a.item("CellSelection", "Array:WebGridSelectionRangeDescription:GridSelectionRange");
            a.item("RowSelection", "Array:object");
            a.item("ColumnSelection", "Array:string");
            a.item("RowPinning", "Array:object");
            a.item("PinningConfig", "ExportedType:WebPinningConfig");
            a.item("Expansion", "Array:object");
            a.item("RowIslands", "Array:WebGridStateCollectionDescription:GridStateCollection");
            a.item("Id", "String");
            a.item("PivotConfiguration", "ExportedType:WebPivotConfiguration");
        }
        static d(a) {
            WebGridStateInfoDetailDescriptionMetadata.b(a);
            a.ae("WebGridStateInfoDetail", () => new WebGridStateInfoDetailDescription());
            a.ad("WebGridStateInfoDetail", WebGridStateInfoDetailDescriptionMetadata.a);
        }
    }
    WebGridStateInfoDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridStateInfoDetailDescriptionMetadata, 'WebGridStateInfoDetailDescriptionMetadata');
    WebGridStateInfoDetailDescriptionMetadata.a = null;
    return WebGridStateInfoDetailDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridStateInfoEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridStateInfoEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridStateInfoEventArgsDescriptionMetadata.a == null) {
                WebGridStateInfoEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridStateInfoEventArgsDescriptionMetadata.c(WebGridStateInfoEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebGridStateInfoEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridStateInfoEventArgsDescriptionMetadata.a);
            WebGridStateInfoDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridStateInfoEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebGridStateInfoDetail");
        }
        static d(a) {
            WebGridStateInfoEventArgsDescriptionMetadata.b(a);
            a.ae("WebGridStateInfoEventArgs", () => new WebGridStateInfoEventArgsDescription());
            a.ad("WebGridStateInfoEventArgs", WebGridStateInfoEventArgsDescriptionMetadata.a);
        }
    }
    WebGridStateInfoEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridStateInfoEventArgsDescriptionMetadata, 'WebGridStateInfoEventArgsDescriptionMetadata');
    WebGridStateInfoEventArgsDescriptionMetadata.a = null;
    return WebGridStateInfoEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let WebGridStateCollectionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridStateCollectionDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridStateCollectionDescriptionMetadata.a == null) {
                WebGridStateCollectionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridStateCollectionDescriptionMetadata.c(WebGridStateCollectionDescriptionMetadata.a);
            }
            if (a.k(WebGridStateCollectionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridStateCollectionDescriptionMetadata.a);
            WebGridStateDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridStateCollection");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Id", "String");
            a.item("ParentRowID", "Unknown");
            a.item("State", "ExportedType:WebGridState");
        }
        static d(a) {
            WebGridStateCollectionDescriptionMetadata.b(a);
            a.ae("WebGridStateCollection", () => new WebGridStateCollectionDescription());
            a.ad("WebGridStateCollection", WebGridStateCollectionDescriptionMetadata.a);
        }
    }
    WebGridStateCollectionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridStateCollectionDescriptionMetadata, 'WebGridStateCollectionDescriptionMetadata');
    WebGridStateCollectionDescriptionMetadata.a = null;
    return WebGridStateCollectionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridStateDescriptionModule = /*@__PURE__*/ (() => {
    class WebGridStateDescriptionModule extends Base {
        static register(a) {
            WebGridStateBaseDirectiveDescriptionModule.register(a);
            WebGridStateDescriptionMetadata.d(a);
        }
    }
    WebGridStateDescriptionModule.$t = /*@__PURE__*/ markType(WebGridStateDescriptionModule, 'WebGridStateDescriptionModule');
    return WebGridStateDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridStateInfoDescription = /*@__PURE__*/ (() => {
    class WebGridStateInfoDescription extends Description {
        get_type() {
            return "WebGridStateInfo";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.y = null;
            this.x = null;
            this.ad = null;
            this.ak = false;
            this.o = null;
            this.ab = null;
            this.h = null;
            this.n = null;
            this.j = null;
            this.m = null;
            this.af = null;
            this.k = null;
            this.l = null;
            this.an = null;
            this.ah = null;
        }
        get columns() {
            return this.i;
        }
        set columns(a) {
            this.i = a;
            this.g("Columns");
        }
        get filtering() {
            return this.y;
        }
        set filtering(a) {
            this.y = a;
            this.g("Filtering");
        }
        get advancedFiltering() {
            return this.x;
        }
        set advancedFiltering(a) {
            this.x = a;
            this.g("AdvancedFiltering");
        }
        get paging() {
            return this.ad;
        }
        set paging(a) {
            this.ad = a;
            this.g("Paging");
        }
        get moving() {
            return this.ak;
        }
        set moving(a) {
            this.ak = a;
            this.g("Moving");
        }
        get sorting() {
            return this.o;
        }
        set sorting(a) {
            this.o = a;
            this.g("Sorting");
        }
        get groupBy() {
            return this.ab;
        }
        set groupBy(a) {
            this.ab = a;
            this.g("GroupBy");
        }
        get cellSelection() {
            return this.h;
        }
        set cellSelection(a) {
            this.h = a;
            this.g("CellSelection");
        }
        get rowSelection() {
            return this.n;
        }
        set rowSelection(a) {
            this.n = a;
            this.g("RowSelection");
        }
        get columnSelection() {
            return this.j;
        }
        set columnSelection(a) {
            this.j = a;
            this.g("ColumnSelection");
        }
        get rowPinning() {
            return this.m;
        }
        set rowPinning(a) {
            this.m = a;
            this.g("RowPinning");
        }
        get pinningConfig() {
            return this.af;
        }
        set pinningConfig(a) {
            this.af = a;
            this.g("PinningConfig");
        }
        get expansion() {
            return this.k;
        }
        set expansion(a) {
            this.k = a;
            this.g("Expansion");
        }
        get rowIslands() {
            return this.l;
        }
        set rowIslands(a) {
            this.l = a;
            this.g("RowIslands");
        }
        get id() {
            return this.an;
        }
        set id(a) {
            this.an = a;
            this.g("Id");
        }
        get pivotConfiguration() {
            return this.ah;
        }
        set pivotConfiguration(a) {
            this.ah = a;
            this.g("PivotConfiguration");
        }
    }
    WebGridStateInfoDescription.$t = /*@__PURE__*/ markType(WebGridStateInfoDescription, 'WebGridStateInfoDescription', Description.$);
    WebGridStateInfoDescription.__marshalByValue = true;
    WebGridStateInfoDescription.__marshalByValueAlias = "GridStateInfo";
    return WebGridStateInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridStateInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridStateInfoDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridStateInfoDescriptionMetadata.a == null) {
                WebGridStateInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridStateInfoDescriptionMetadata.c(WebGridStateInfoDescriptionMetadata.a);
            }
            if (a.k(WebGridStateInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridStateInfoDescriptionMetadata.a);
            WebColumnStateDescriptionMetadata.d(a);
            WebFilteringExpressionsTreeDescriptionMetadata.d(a);
            WebPagingStateDescriptionMetadata.d(a);
            WebSortingExpressionDescriptionMetadata.d(a);
            WebGroupingStateDescriptionMetadata.d(a);
            WebGridSelectionRangeDescriptionMetadata.d(a);
            WebPinningConfigDescriptionMetadata.d(a);
            WebGridStateCollectionDescriptionMetadata.d(a);
            WebPivotConfigurationDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridStateInfo");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("Columns", "Array:WebColumnStateDescription:ColumnState");
            a.item("Filtering", "ExportedType:WebFilteringExpressionsTree");
            a.item("AdvancedFiltering", "ExportedType:WebFilteringExpressionsTree");
            a.item("Paging", "ExportedType:WebPagingState");
            a.item("Moving", "Boolean");
            a.item("Sorting", "Array:WebSortingExpressionDescription:SortingExpression");
            a.item("GroupBy", "ExportedType:WebGroupingState");
            a.item("CellSelection", "Array:WebGridSelectionRangeDescription:GridSelectionRange");
            a.item("RowSelection", "Array:object");
            a.item("ColumnSelection", "Array:string");
            a.item("RowPinning", "Array:object");
            a.item("PinningConfig", "ExportedType:WebPinningConfig");
            a.item("Expansion", "Array:object");
            a.item("RowIslands", "Array:WebGridStateCollectionDescription:GridStateCollection");
            a.item("Id", "String");
            a.item("PivotConfiguration", "ExportedType:WebPivotConfiguration");
        }
        static d(a) {
            WebGridStateInfoDescriptionMetadata.b(a);
            a.ae("WebGridStateInfo", () => new WebGridStateInfoDescription());
            a.ad("WebGridStateInfo", WebGridStateInfoDescriptionMetadata.a);
        }
    }
    WebGridStateInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridStateInfoDescriptionMetadata, 'WebGridStateInfoDescriptionMetadata');
    WebGridStateInfoDescriptionMetadata.a = null;
    return WebGridStateInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebGridToolbarTemplateContextDescription extends Description {
        get_type() {
            return "WebGridToolbarTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get implicit() {
            return this.h;
        }
        set implicit(a) {
            this.h = a;
            this.g("Implicit");
        }
    }
    WebGridToolbarTemplateContextDescription.$t = /*@__PURE__*/ markType(WebGridToolbarTemplateContextDescription, 'WebGridToolbarTemplateContextDescription', Description.$);
    WebGridToolbarTemplateContextDescription.__marshalByValue = true;
    WebGridToolbarTemplateContextDescription.__marshalByValueAlias = "GridToolbarTemplateContext";
    return WebGridToolbarTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridToolbarTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridToolbarTemplateContextDescriptionMetadata.a == null) {
                WebGridToolbarTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridToolbarTemplateContextDescriptionMetadata.c(WebGridToolbarTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebGridToolbarTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridToolbarTemplateContextDescriptionMetadata.a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridToolbarTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "ExportedType:WebGridBaseDirective");
        }
        static d(a) {
            WebGridToolbarTemplateContextDescriptionMetadata.b(a);
            a.ae("WebGridToolbarTemplateContext", () => new WebGridToolbarTemplateContextDescription());
            a.ad("WebGridToolbarTemplateContext", WebGridToolbarTemplateContextDescriptionMetadata.a);
        }
    }
    WebGridToolbarTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridToolbarTemplateContextDescriptionMetadata, 'WebGridToolbarTemplateContextDescriptionMetadata');
    WebGridToolbarTemplateContextDescriptionMetadata.a = null;
    return WebGridToolbarTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarDescriptionModule = /*@__PURE__*/ (() => {
    class WebGridToolbarDescriptionModule extends Base {
        static register(a) {
            WebGridToolbarDescriptionMetadata.d(a);
        }
    }
    WebGridToolbarDescriptionModule.$t = /*@__PURE__*/ markType(WebGridToolbarDescriptionModule, 'WebGridToolbarDescriptionModule');
    return WebGridToolbarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarActionsDescriptionModule = /*@__PURE__*/ (() => {
    class WebGridToolbarActionsDescriptionModule extends Base {
        static register(a) {
            WebGridToolbarActionsDescriptionMetadata.d(a);
        }
    }
    WebGridToolbarActionsDescriptionModule.$t = /*@__PURE__*/ markType(WebGridToolbarActionsDescriptionModule, 'WebGridToolbarActionsDescriptionModule');
    return WebGridToolbarActionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarTitleDescriptionModule = /*@__PURE__*/ (() => {
    class WebGridToolbarTitleDescriptionModule extends Base {
        static register(a) {
            WebGridToolbarTitleDescriptionMetadata.d(a);
        }
    }
    WebGridToolbarTitleDescriptionModule.$t = /*@__PURE__*/ markType(WebGridToolbarTitleDescriptionModule, 'WebGridToolbarTitleDescriptionModule');
    return WebGridToolbarTitleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarAdvancedFilteringDescriptionModule = /*@__PURE__*/ (() => {
    class WebGridToolbarAdvancedFilteringDescriptionModule extends Base {
        static register(a) {
            WebGridToolbarAdvancedFilteringDescriptionMetadata.d(a);
        }
    }
    WebGridToolbarAdvancedFilteringDescriptionModule.$t = /*@__PURE__*/ markType(WebGridToolbarAdvancedFilteringDescriptionModule, 'WebGridToolbarAdvancedFilteringDescriptionModule');
    return WebGridToolbarAdvancedFilteringDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarExporterDescriptionModule = /*@__PURE__*/ (() => {
    class WebGridToolbarExporterDescriptionModule extends Base {
        static register(a) {
            WebGridToolbarExporterDescriptionMetadata.d(a);
        }
    }
    WebGridToolbarExporterDescriptionModule.$t = /*@__PURE__*/ markType(WebGridToolbarExporterDescriptionModule, 'WebGridToolbarExporterDescriptionModule');
    return WebGridToolbarExporterDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarHidingDescriptionModule = /*@__PURE__*/ (() => {
    class WebGridToolbarHidingDescriptionModule extends Base {
        static register(a) {
            WebBaseToolbarColumnActionsDirectiveDescriptionModule.register(a);
            WebGridToolbarHidingDescriptionMetadata.d(a);
        }
    }
    WebGridToolbarHidingDescriptionModule.$t = /*@__PURE__*/ markType(WebGridToolbarHidingDescriptionModule, 'WebGridToolbarHidingDescriptionModule');
    return WebGridToolbarHidingDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridToolbarPinningDescriptionModule = /*@__PURE__*/ (() => {
    class WebGridToolbarPinningDescriptionModule extends Base {
        static register(a) {
            WebBaseToolbarColumnActionsDirectiveDescriptionModule.register(a);
            WebGridToolbarPinningDescriptionMetadata.d(a);
        }
    }
    WebGridToolbarPinningDescriptionModule.$t = /*@__PURE__*/ markType(WebGridToolbarPinningDescriptionModule, 'WebGridToolbarPinningDescriptionModule');
    return WebGridToolbarPinningDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridEditingActionsDescription = /*@__PURE__*/ (() => {
    class WebGridEditingActionsDescription extends WebGridActionsBaseDirectiveDescription {
        get_type() {
            return "WebGridEditingActions";
        }
        constructor() {
            super();
            this.n = false;
            this.p = false;
            this.o = false;
            this.m = false;
        }
        get addRow() {
            return this.n;
        }
        set addRow(a) {
            this.n = a;
            this.g("AddRow");
        }
        get editRow() {
            return this.p;
        }
        set editRow(a) {
            this.p = a;
            this.g("EditRow");
        }
        get deleteRow() {
            return this.o;
        }
        set deleteRow(a) {
            this.o = a;
            this.g("DeleteRow");
        }
        get addChild() {
            return this.m;
        }
        set addChild(a) {
            this.m = a;
            this.g("AddChild");
        }
    }
    WebGridEditingActionsDescription.$t = /*@__PURE__*/ markType(WebGridEditingActionsDescription, 'WebGridEditingActionsDescription', WebGridActionsBaseDirectiveDescription.$);
    return WebGridEditingActionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridEditingActionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridEditingActionsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridEditingActionsDescriptionMetadata.a == null) {
                WebGridEditingActionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridEditingActionsDescriptionMetadata.c(WebGridEditingActionsDescriptionMetadata.a);
            }
            if (a.k(WebGridEditingActionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridEditingActionsDescriptionMetadata.a);
        }
        static c(a) {
            WebGridActionsBaseDirectiveDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridEditingActions");
            a.item("__tagNameWC", "String:igc-grid-editing-actions");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            if (a.containsKey("__skipSuffix")) {
                a.removeItem("__skipSuffix");
            }
            a.item("AddRow", "Boolean");
            a.item("EditRow", "Boolean");
            a.item("DeleteRow", "Boolean");
            a.item("AddChild", "Boolean");
        }
        static d(a) {
            WebGridEditingActionsDescriptionMetadata.b(a);
            a.ae("WebGridEditingActions", () => new WebGridEditingActionsDescription());
            a.ad("WebGridEditingActions", WebGridEditingActionsDescriptionMetadata.a);
        }
    }
    WebGridEditingActionsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridEditingActionsDescriptionMetadata, 'WebGridEditingActionsDescriptionMetadata');
    WebGridEditingActionsDescriptionMetadata.a = null;
    return WebGridEditingActionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridEditingActionsDescriptionModule = /*@__PURE__*/ (() => {
    class WebGridEditingActionsDescriptionModule extends Base {
        static register(a) {
            WebGridActionsBaseDirectiveDescriptionModule.register(a);
            WebGridEditingActionsDescriptionMetadata.d(a);
        }
    }
    WebGridEditingActionsDescriptionModule.$t = /*@__PURE__*/ markType(WebGridEditingActionsDescriptionModule, 'WebGridEditingActionsDescriptionModule');
    return WebGridEditingActionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridPinningActionsDescription = /*@__PURE__*/ (() => {
    class WebGridPinningActionsDescription extends WebGridActionsBaseDirectiveDescription {
        get_type() {
            return "WebGridPinningActions";
        }
        constructor() {
            super();
        }
    }
    WebGridPinningActionsDescription.$t = /*@__PURE__*/ markType(WebGridPinningActionsDescription, 'WebGridPinningActionsDescription', WebGridActionsBaseDirectiveDescription.$);
    return WebGridPinningActionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridPinningActionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridPinningActionsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridPinningActionsDescriptionMetadata.a == null) {
                WebGridPinningActionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridPinningActionsDescriptionMetadata.c(WebGridPinningActionsDescriptionMetadata.a);
            }
            if (a.k(WebGridPinningActionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridPinningActionsDescriptionMetadata.a);
        }
        static c(a) {
            WebGridActionsBaseDirectiveDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridPinningActions");
            a.item("__tagNameWC", "String:igc-grid-pinning-actions");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            if (a.containsKey("__skipSuffix")) {
                a.removeItem("__skipSuffix");
            }
        }
        static d(a) {
            WebGridPinningActionsDescriptionMetadata.b(a);
            a.ae("WebGridPinningActions", () => new WebGridPinningActionsDescription());
            a.ad("WebGridPinningActions", WebGridPinningActionsDescriptionMetadata.a);
        }
    }
    WebGridPinningActionsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridPinningActionsDescriptionMetadata, 'WebGridPinningActionsDescriptionMetadata');
    WebGridPinningActionsDescriptionMetadata.a = null;
    return WebGridPinningActionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridPinningActionsDescriptionModule = /*@__PURE__*/ (() => {
    class WebGridPinningActionsDescriptionModule extends Base {
        static register(a) {
            WebGridActionsBaseDirectiveDescriptionModule.register(a);
            WebGridPinningActionsDescriptionMetadata.d(a);
        }
    }
    WebGridPinningActionsDescriptionModule.$t = /*@__PURE__*/ markType(WebGridPinningActionsDescriptionModule, 'WebGridPinningActionsDescriptionModule');
    return WebGridPinningActionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowIslandDescriptionModule = /*@__PURE__*/ (() => {
    class WebRowIslandDescriptionModule extends Base {
        static register(a) {
            WebRowIslandDescriptionMetadata.d(a);
        }
    }
    WebRowIslandDescriptionModule.$t = /*@__PURE__*/ markType(WebRowIslandDescriptionModule, 'WebRowIslandDescriptionModule');
    return WebRowIslandDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebHierarchicalGridDescriptionModule = /*@__PURE__*/ (() => {
    class WebHierarchicalGridDescriptionModule extends Base {
        static register(a) {
            WebColumnDescriptionModule.register(a);
            WebGridToolbarDescriptionModule.register(a);
            WebGridToolbarActionsDescriptionModule.register(a);
            WebGridToolbarTitleDescriptionModule.register(a);
            WebGridToolbarAdvancedFilteringDescriptionModule.register(a);
            WebGridToolbarExporterDescriptionModule.register(a);
            WebGridToolbarHidingDescriptionModule.register(a);
            WebGridToolbarPinningDescriptionModule.register(a);
            WebActionStripDescriptionModule.register(a);
            WebGridActionsBaseDirectiveDescriptionModule.register(a);
            WebGridEditingActionsDescriptionModule.register(a);
            WebGridPinningActionsDescriptionModule.register(a);
            WebRowIslandDescriptionModule.register(a);
            WebHierarchicalGridDescriptionMetadata.d(a);
            TemplateContainerDescriptionModule.register(a);
            ChildContentDescriptionModule.register(a);
        }
    }
    WebHierarchicalGridDescriptionModule.$t = /*@__PURE__*/ markType(WebHierarchicalGridDescriptionModule, 'WebHierarchicalGridDescriptionModule');
    return WebHierarchicalGridDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridClipboardEventDescription = /*@__PURE__*/ (() => {
    class WebGridClipboardEventDescription extends Description {
        get_type() {
            return "WebGridClipboardEvent";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = false;
        }
        get dataRef() {
            return this.j;
        }
        set dataRef(a) {
            this.j = a;
            this.g("DataRef");
        }
        get cancel() {
            return this.h;
        }
        set cancel(a) {
            this.h = a;
            this.g("Cancel");
        }
    }
    WebGridClipboardEventDescription.$t = /*@__PURE__*/ markType(WebGridClipboardEventDescription, 'WebGridClipboardEventDescription', Description.$);
    return WebGridClipboardEventDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridClipboardEventDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridClipboardEventDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridClipboardEventDescriptionMetadata.a == null) {
                WebGridClipboardEventDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridClipboardEventDescriptionMetadata.c(WebGridClipboardEventDescriptionMetadata.a);
            }
            if (a.k(WebGridClipboardEventDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridClipboardEventDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridClipboardEvent");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("DataRef", "(w:Data,wf:Data)DataRef:object");
            a.item("Cancel", "Boolean");
        }
        static d(a) {
            WebGridClipboardEventDescriptionMetadata.b(a);
            a.ae("WebGridClipboardEvent", () => new WebGridClipboardEventDescription());
            a.ad("WebGridClipboardEvent", WebGridClipboardEventDescriptionMetadata.a);
        }
    }
    WebGridClipboardEventDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridClipboardEventDescriptionMetadata, 'WebGridClipboardEventDescriptionMetadata');
    WebGridClipboardEventDescriptionMetadata.a = null;
    return WebGridClipboardEventDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridEmptyTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebGridEmptyTemplateContextDescription extends Description {
        get_type() {
            return "WebGridEmptyTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebGridEmptyTemplateContextDescription.$t = /*@__PURE__*/ markType(WebGridEmptyTemplateContextDescription, 'WebGridEmptyTemplateContextDescription', Description.$);
    WebGridEmptyTemplateContextDescription.__marshalByValue = true;
    WebGridEmptyTemplateContextDescription.__marshalByValueAlias = "GridEmptyTemplateContext";
    return WebGridEmptyTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridEmptyTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridEmptyTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridEmptyTemplateContextDescriptionMetadata.a == null) {
                WebGridEmptyTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridEmptyTemplateContextDescriptionMetadata.c(WebGridEmptyTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebGridEmptyTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridEmptyTemplateContextDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridEmptyTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebGridEmptyTemplateContextDescriptionMetadata.b(a);
            a.ae("WebGridEmptyTemplateContext", () => new WebGridEmptyTemplateContextDescription());
            a.ad("WebGridEmptyTemplateContext", WebGridEmptyTemplateContextDescriptionMetadata.a);
        }
    }
    WebGridEmptyTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridEmptyTemplateContextDescriptionMetadata, 'WebGridEmptyTemplateContextDescriptionMetadata');
    WebGridEmptyTemplateContextDescriptionMetadata.a = null;
    return WebGridEmptyTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridHeaderTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebGridHeaderTemplateContextDescription extends Description {
        get_type() {
            return "WebGridHeaderTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get implicit() {
            return this.h;
        }
        set implicit(a) {
            this.h = a;
            this.g("Implicit");
        }
    }
    WebGridHeaderTemplateContextDescription.$t = /*@__PURE__*/ markType(WebGridHeaderTemplateContextDescription, 'WebGridHeaderTemplateContextDescription', Description.$);
    WebGridHeaderTemplateContextDescription.__marshalByValue = true;
    WebGridHeaderTemplateContextDescription.__marshalByValueAlias = "GridHeaderTemplateContext";
    return WebGridHeaderTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebHeaderTypeDescription = /*@__PURE__*/ (() => {
    class WebHeaderTypeDescription extends Description {
        get_type() {
            return "WebHeaderType";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.l = false;
            this.j = false;
            this.k = false;
            this.m = false;
            this.r = null;
        }
        get column() {
            return this.h;
        }
        set column(a) {
            this.h = a;
            this.g("Column");
        }
        get sorted() {
            return this.l;
        }
        set sorted(a) {
            this.l = a;
            this.g("Sorted");
        }
        get selectable() {
            return this.j;
        }
        set selectable(a) {
            this.j = a;
            this.g("Selectable");
        }
        get selected() {
            return this.k;
        }
        set selected(a) {
            this.k = a;
            this.g("Selected");
        }
        get title() {
            return this.m;
        }
        set title(a) {
            this.m = a;
            this.g("Title");
        }
        get sortDirection() {
            return this.r;
        }
        set sortDirection(a) {
            this.r = a;
            this.g("SortDirection");
        }
    }
    WebHeaderTypeDescription.$t = /*@__PURE__*/ markType(WebHeaderTypeDescription, 'WebHeaderTypeDescription', Description.$);
    return WebHeaderTypeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebHeaderTypeDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebHeaderTypeDescriptionMetadata extends Base {
        static b(a) {
            if (WebHeaderTypeDescriptionMetadata.a == null) {
                WebHeaderTypeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebHeaderTypeDescriptionMetadata.c(WebHeaderTypeDescriptionMetadata.a);
            }
            if (a.k(WebHeaderTypeDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebHeaderTypeDescriptionMetadata.a);
            WebColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:HeaderType");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Column", "ExportedType:WebColumn");
            a.item("Sorted", "Boolean");
            a.item("Selectable", "Boolean");
            a.item("Selected", "Boolean");
            a.item("Title", "Boolean");
            a.item("SortDirection", "ExportedType:string:SortingDirection");
            a.item("SortDirection@names", "None;Asc;Desc");
        }
        static d(a) {
            WebHeaderTypeDescriptionMetadata.b(a);
            a.ae("WebHeaderType", () => new WebHeaderTypeDescription());
            a.ad("WebHeaderType", WebHeaderTypeDescriptionMetadata.a);
        }
    }
    WebHeaderTypeDescriptionMetadata.$t = /*@__PURE__*/ markType(WebHeaderTypeDescriptionMetadata, 'WebHeaderTypeDescriptionMetadata');
    WebHeaderTypeDescriptionMetadata.a = null;
    return WebHeaderTypeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridHeaderTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridHeaderTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridHeaderTemplateContextDescriptionMetadata.a == null) {
                WebGridHeaderTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridHeaderTemplateContextDescriptionMetadata.c(WebGridHeaderTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebGridHeaderTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridHeaderTemplateContextDescriptionMetadata.a);
            WebHeaderTypeDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridHeaderTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "ExportedType:WebHeaderType");
        }
        static d(a) {
            WebGridHeaderTemplateContextDescriptionMetadata.b(a);
            a.ae("WebGridHeaderTemplateContext", () => new WebGridHeaderTemplateContextDescription());
            a.ad("WebGridHeaderTemplateContext", WebGridHeaderTemplateContextDescriptionMetadata.a);
        }
    }
    WebGridHeaderTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridHeaderTemplateContextDescriptionMetadata, 'WebGridHeaderTemplateContextDescriptionMetadata');
    WebGridHeaderTemplateContextDescriptionMetadata.a = null;
    return WebGridHeaderTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridMasterDetailContextDescription = /*@__PURE__*/ (() => {
    class WebGridMasterDetailContextDescription extends Description {
        get_type() {
            return "WebGridMasterDetailContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = null;
            this.i = 0;
        }
        get implicit() {
            return this.k;
        }
        set implicit(a) {
            this.k = a;
            this.g("Implicit");
        }
        get index() {
            return this.i;
        }
        set index(a) {
            this.i = a;
            this.g("Index");
        }
    }
    WebGridMasterDetailContextDescription.$t = /*@__PURE__*/ markType(WebGridMasterDetailContextDescription, 'WebGridMasterDetailContextDescription', Description.$);
    WebGridMasterDetailContextDescription.__marshalByValue = true;
    WebGridMasterDetailContextDescription.__marshalByValueAlias = "GridMasterDetailContext";
    return WebGridMasterDetailContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridMasterDetailContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridMasterDetailContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridMasterDetailContextDescriptionMetadata.a == null) {
                WebGridMasterDetailContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridMasterDetailContextDescriptionMetadata.c(WebGridMasterDetailContextDescriptionMetadata.a);
            }
            if (a.k(WebGridMasterDetailContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridMasterDetailContextDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridMasterDetailContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "Unknown");
            a.item("Index", "Number:double");
        }
        static d(a) {
            WebGridMasterDetailContextDescriptionMetadata.b(a);
            a.ae("WebGridMasterDetailContext", () => new WebGridMasterDetailContextDescription());
            a.ad("WebGridMasterDetailContext", WebGridMasterDetailContextDescriptionMetadata.a);
        }
    }
    WebGridMasterDetailContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridMasterDetailContextDescriptionMetadata, 'WebGridMasterDetailContextDescriptionMetadata');
    WebGridMasterDetailContextDescriptionMetadata.a = null;
    return WebGridMasterDetailContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupByRowSelectorTemplateDetailsDescription = /*@__PURE__*/ (() => {
    class WebGroupByRowSelectorTemplateDetailsDescription extends Description {
        get_type() {
            return "WebGroupByRowSelectorTemplateDetails";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = 0;
            this.k = 0;
            this.h = null;
        }
        get selectedCount() {
            return this.j;
        }
        set selectedCount(a) {
            this.j = a;
            this.g("SelectedCount");
        }
        get totalCount() {
            return this.k;
        }
        set totalCount(a) {
            this.k = a;
            this.g("TotalCount");
        }
        get groupRow() {
            return this.h;
        }
        set groupRow(a) {
            this.h = a;
            this.g("GroupRow");
        }
    }
    WebGroupByRowSelectorTemplateDetailsDescription.$t = /*@__PURE__*/ markType(WebGroupByRowSelectorTemplateDetailsDescription, 'WebGroupByRowSelectorTemplateDetailsDescription', Description.$);
    return WebGroupByRowSelectorTemplateDetailsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupByRowSelectorTemplateDetailsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGroupByRowSelectorTemplateDetailsDescriptionMetadata extends Base {
        static b(a) {
            if (WebGroupByRowSelectorTemplateDetailsDescriptionMetadata.a == null) {
                WebGroupByRowSelectorTemplateDetailsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGroupByRowSelectorTemplateDetailsDescriptionMetadata.c(WebGroupByRowSelectorTemplateDetailsDescriptionMetadata.a);
            }
            if (a.k(WebGroupByRowSelectorTemplateDetailsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGroupByRowSelectorTemplateDetailsDescriptionMetadata.a);
            WebGroupByRecordDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GroupByRowSelectorTemplateDetails");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("SelectedCount", "Number:double");
            a.item("TotalCount", "Number:double");
            a.item("GroupRow", "ExportedType:WebGroupByRecord");
        }
        static d(a) {
            WebGroupByRowSelectorTemplateDetailsDescriptionMetadata.b(a);
            a.ae("WebGroupByRowSelectorTemplateDetails", () => new WebGroupByRowSelectorTemplateDetailsDescription());
            a.ad("WebGroupByRowSelectorTemplateDetails", WebGroupByRowSelectorTemplateDetailsDescriptionMetadata.a);
        }
    }
    WebGroupByRowSelectorTemplateDetailsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGroupByRowSelectorTemplateDetailsDescriptionMetadata, 'WebGroupByRowSelectorTemplateDetailsDescriptionMetadata');
    WebGroupByRowSelectorTemplateDetailsDescriptionMetadata.a = null;
    return WebGroupByRowSelectorTemplateDetailsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupByRowSelectorTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebGroupByRowSelectorTemplateContextDescription extends Description {
        get_type() {
            return "WebGroupByRowSelectorTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get implicit() {
            return this.h;
        }
        set implicit(a) {
            this.h = a;
            this.g("Implicit");
        }
    }
    WebGroupByRowSelectorTemplateContextDescription.$t = /*@__PURE__*/ markType(WebGroupByRowSelectorTemplateContextDescription, 'WebGroupByRowSelectorTemplateContextDescription', Description.$);
    WebGroupByRowSelectorTemplateContextDescription.__marshalByValue = true;
    WebGroupByRowSelectorTemplateContextDescription.__marshalByValueAlias = "GroupByRowSelectorTemplateContext";
    return WebGroupByRowSelectorTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupByRowSelectorTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGroupByRowSelectorTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebGroupByRowSelectorTemplateContextDescriptionMetadata.a == null) {
                WebGroupByRowSelectorTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGroupByRowSelectorTemplateContextDescriptionMetadata.c(WebGroupByRowSelectorTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebGroupByRowSelectorTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGroupByRowSelectorTemplateContextDescriptionMetadata.a);
            WebGroupByRowSelectorTemplateDetailsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GroupByRowSelectorTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "ExportedType:WebGroupByRowSelectorTemplateDetails");
        }
        static d(a) {
            WebGroupByRowSelectorTemplateContextDescriptionMetadata.b(a);
            a.ae("WebGroupByRowSelectorTemplateContext", () => new WebGroupByRowSelectorTemplateContextDescription());
            a.ad("WebGroupByRowSelectorTemplateContext", WebGroupByRowSelectorTemplateContextDescriptionMetadata.a);
        }
    }
    WebGroupByRowSelectorTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGroupByRowSelectorTemplateContextDescriptionMetadata, 'WebGroupByRowSelectorTemplateContextDescriptionMetadata');
    WebGroupByRowSelectorTemplateContextDescriptionMetadata.a = null;
    return WebGroupByRowSelectorTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupByRowTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebGroupByRowTemplateContextDescription extends Description {
        get_type() {
            return "WebGroupByRowTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get implicit() {
            return this.h;
        }
        set implicit(a) {
            this.h = a;
            this.g("Implicit");
        }
    }
    WebGroupByRowTemplateContextDescription.$t = /*@__PURE__*/ markType(WebGroupByRowTemplateContextDescription, 'WebGroupByRowTemplateContextDescription', Description.$);
    WebGroupByRowTemplateContextDescription.__marshalByValue = true;
    WebGroupByRowTemplateContextDescription.__marshalByValueAlias = "GroupByRowTemplateContext";
    return WebGroupByRowTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupByRowTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGroupByRowTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebGroupByRowTemplateContextDescriptionMetadata.a == null) {
                WebGroupByRowTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGroupByRowTemplateContextDescriptionMetadata.c(WebGroupByRowTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebGroupByRowTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGroupByRowTemplateContextDescriptionMetadata.a);
            WebGroupByRecordDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GroupByRowTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "ExportedType:WebGroupByRecord");
        }
        static d(a) {
            WebGroupByRowTemplateContextDescriptionMetadata.b(a);
            a.ae("WebGroupByRowTemplateContext", () => new WebGroupByRowTemplateContextDescription());
            a.ad("WebGroupByRowTemplateContext", WebGroupByRowTemplateContextDescriptionMetadata.a);
        }
    }
    WebGroupByRowTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGroupByRowTemplateContextDescriptionMetadata, 'WebGroupByRowTemplateContextDescriptionMetadata');
    WebGroupByRowTemplateContextDescriptionMetadata.a = null;
    return WebGroupByRowTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridDescriptionModule = /*@__PURE__*/ (() => {
    class WebGridDescriptionModule extends Base {
        static register(a) {
            WebColumnDescriptionModule.register(a);
            WebGridToolbarDescriptionModule.register(a);
            WebGridToolbarActionsDescriptionModule.register(a);
            WebGridToolbarTitleDescriptionModule.register(a);
            WebGridToolbarAdvancedFilteringDescriptionModule.register(a);
            WebGridToolbarExporterDescriptionModule.register(a);
            WebGridToolbarHidingDescriptionModule.register(a);
            WebGridToolbarPinningDescriptionModule.register(a);
            WebActionStripDescriptionModule.register(a);
            WebGridActionsBaseDirectiveDescriptionModule.register(a);
            WebGridEditingActionsDescriptionModule.register(a);
            WebGridPinningActionsDescriptionModule.register(a);
            WebForOfStateEventArgsDescriptionMetadata.d(a);
            WebGroupingDoneEventArgsDescriptionMetadata.d(a);
            WebGridMasterDetailContextDescriptionMetadata.d(a);
            WebGroupByRowSelectorTemplateContextDescriptionMetadata.d(a);
            WebGroupByRowTemplateContextDescriptionMetadata.d(a);
            WebGridDescriptionMetadata.d(a);
            TemplateContainerDescriptionModule.register(a);
            ChildContentDescriptionModule.register(a);
        }
    }
    WebGridDescriptionModule.$t = /*@__PURE__*/ markType(WebGridDescriptionModule, 'WebGridDescriptionModule');
    return WebGridDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowDirectiveDescription = /*@__PURE__*/ (() => {
    class WebRowDirectiveDescription extends Description {
        get_type() {
            return "WebRowDirective";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.p = null;
            this.n = 0;
            this.h = false;
            this.j = false;
            this.i = false;
        }
        get data() {
            return this.p;
        }
        set data(a) {
            this.p = a;
            this.g("Data");
        }
        get index() {
            return this.n;
        }
        set index(a) {
            this.n = a;
            this.g("Index");
        }
        get disabled() {
            return this.h;
        }
        set disabled(a) {
            this.h = a;
            this.g("Disabled");
        }
        get pinned() {
            return this.j;
        }
        set pinned(a) {
            this.j = a;
            this.g("Pinned");
        }
        get expanded() {
            return this.i;
        }
        set expanded(a) {
            this.i = a;
            this.g("Expanded");
        }
    }
    WebRowDirectiveDescription.$t = /*@__PURE__*/ markType(WebRowDirectiveDescription, 'WebRowDirectiveDescription', Description.$);
    return WebRowDirectiveDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridRowDescription = /*@__PURE__*/ (() => {
    class WebGridRowDescription extends WebRowDirectiveDescription {
        get_type() {
            return "WebGridRow";
        }
        constructor() {
            super();
        }
    }
    WebGridRowDescription.$t = /*@__PURE__*/ markType(WebGridRowDescription, 'WebGridRowDescription', WebRowDirectiveDescription.$);
    return WebGridRowDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowDirectiveDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowDirectiveDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowDirectiveDescriptionMetadata.a == null) {
                WebRowDirectiveDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowDirectiveDescriptionMetadata.c(WebRowDirectiveDescriptionMetadata.a);
            }
            if (a.k(WebRowDirectiveDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowDirectiveDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowDirective");
            a.item("__tagNameWC", "String:igc-row-directive");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("__manageCollectionInMarkup", "Boolean");
            a.item("Data", "Unknown");
            a.item("Index", "Number:double");
            a.item("Disabled", "Boolean");
            a.item("Pinned", "Boolean");
            a.item("Expanded", "Boolean");
        }
        static d(a) {
            WebRowDirectiveDescriptionMetadata.b(a);
            a.ae("WebRowDirective", () => new WebRowDirectiveDescription());
            a.ad("WebRowDirective", WebRowDirectiveDescriptionMetadata.a);
        }
    }
    WebRowDirectiveDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowDirectiveDescriptionMetadata, 'WebRowDirectiveDescriptionMetadata');
    WebRowDirectiveDescriptionMetadata.a = null;
    return WebRowDirectiveDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridRowDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridRowDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridRowDescriptionMetadata.a == null) {
                WebGridRowDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridRowDescriptionMetadata.c(WebGridRowDescriptionMetadata.a);
            }
            if (a.k(WebGridRowDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridRowDescriptionMetadata.a);
        }
        static c(a) {
            WebRowDirectiveDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:GridRow");
            a.item("__tagNameWC", "String:igc-grid-row");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            if (a.containsKey("__skipSuffix")) {
                a.removeItem("__skipSuffix");
            }
        }
        static d(a) {
            WebGridRowDescriptionMetadata.b(a);
            a.ae("WebGridRow", () => new WebGridRowDescription());
            a.ad("WebGridRow", WebGridRowDescriptionMetadata.a);
        }
    }
    WebGridRowDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridRowDescriptionMetadata, 'WebGridRowDescriptionMetadata');
    WebGridRowDescriptionMetadata.a = null;
    return WebGridRowDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridRowDragGhostContextDescription = /*@__PURE__*/ (() => {
    class WebGridRowDragGhostContextDescription extends Description {
        get_type() {
            return "WebGridRowDragGhostContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.k = null;
            this.h = null;
        }
        get implicit() {
            return this.l;
        }
        set implicit(a) {
            this.l = a;
            this.g("Implicit");
        }
        get data() {
            return this.k;
        }
        set data(a) {
            this.k = a;
            this.g("Data");
        }
        get grid() {
            return this.h;
        }
        set grid(a) {
            this.h = a;
            this.g("Grid");
        }
    }
    WebGridRowDragGhostContextDescription.$t = /*@__PURE__*/ markType(WebGridRowDragGhostContextDescription, 'WebGridRowDragGhostContextDescription', Description.$);
    WebGridRowDragGhostContextDescription.__marshalByValue = true;
    WebGridRowDragGhostContextDescription.__marshalByValueAlias = "GridRowDragGhostContext";
    return WebGridRowDragGhostContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridRowDragGhostContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridRowDragGhostContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridRowDragGhostContextDescriptionMetadata.a == null) {
                WebGridRowDragGhostContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridRowDragGhostContextDescriptionMetadata.c(WebGridRowDragGhostContextDescriptionMetadata.a);
            }
            if (a.k(WebGridRowDragGhostContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridRowDragGhostContextDescriptionMetadata.a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridRowDragGhostContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "Unknown");
            a.item("Data", "Unknown");
            a.item("Grid", "ExportedType:WebGridBaseDirective");
        }
        static d(a) {
            WebGridRowDragGhostContextDescriptionMetadata.b(a);
            a.ae("WebGridRowDragGhostContext", () => new WebGridRowDragGhostContextDescription());
            a.ad("WebGridRowDragGhostContext", WebGridRowDragGhostContextDescriptionMetadata.a);
        }
    }
    WebGridRowDragGhostContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridRowDragGhostContextDescriptionMetadata, 'WebGridRowDragGhostContextDescriptionMetadata');
    WebGridRowDragGhostContextDescriptionMetadata.a = null;
    return WebGridRowDragGhostContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridRowEditActionsTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebGridRowEditActionsTemplateContextDescription extends Description {
        get_type() {
            return "WebGridRowEditActionsTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
        }
        get implicitRef() {
            return this.j;
        }
        set implicitRef(a) {
            this.j = a;
            this.g("ImplicitRef");
        }
    }
    WebGridRowEditActionsTemplateContextDescription.$t = /*@__PURE__*/ markType(WebGridRowEditActionsTemplateContextDescription, 'WebGridRowEditActionsTemplateContextDescription', Description.$);
    WebGridRowEditActionsTemplateContextDescription.__marshalByValue = true;
    WebGridRowEditActionsTemplateContextDescription.__marshalByValueAlias = "GridRowEditActionsTemplateContext";
    return WebGridRowEditActionsTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridRowEditActionsTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridRowEditActionsTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridRowEditActionsTemplateContextDescriptionMetadata.a == null) {
                WebGridRowEditActionsTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridRowEditActionsTemplateContextDescriptionMetadata.c(WebGridRowEditActionsTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebGridRowEditActionsTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridRowEditActionsTemplateContextDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridRowEditActionsTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("ImplicitRef", "(w:Implicit,wf:Implicit)MethodRef");
        }
        static d(a) {
            WebGridRowEditActionsTemplateContextDescriptionMetadata.b(a);
            a.ae("WebGridRowEditActionsTemplateContext", () => new WebGridRowEditActionsTemplateContextDescription());
            a.ad("WebGridRowEditActionsTemplateContext", WebGridRowEditActionsTemplateContextDescriptionMetadata.a);
        }
    }
    WebGridRowEditActionsTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridRowEditActionsTemplateContextDescriptionMetadata, 'WebGridRowEditActionsTemplateContextDescriptionMetadata');
    WebGridRowEditActionsTemplateContextDescriptionMetadata.a = null;
    return WebGridRowEditActionsTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridRowEditTextTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebGridRowEditTextTemplateContextDescription extends Description {
        get_type() {
            return "WebGridRowEditTextTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = 0;
        }
        get implicit() {
            return this.i;
        }
        set implicit(a) {
            this.i = a;
            this.g("Implicit");
        }
    }
    WebGridRowEditTextTemplateContextDescription.$t = /*@__PURE__*/ markType(WebGridRowEditTextTemplateContextDescription, 'WebGridRowEditTextTemplateContextDescription', Description.$);
    WebGridRowEditTextTemplateContextDescription.__marshalByValue = true;
    WebGridRowEditTextTemplateContextDescription.__marshalByValueAlias = "GridRowEditTextTemplateContext";
    return WebGridRowEditTextTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridRowEditTextTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridRowEditTextTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridRowEditTextTemplateContextDescriptionMetadata.a == null) {
                WebGridRowEditTextTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridRowEditTextTemplateContextDescriptionMetadata.c(WebGridRowEditTextTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebGridRowEditTextTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridRowEditTextTemplateContextDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridRowEditTextTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "Number:double");
        }
        static d(a) {
            WebGridRowEditTextTemplateContextDescriptionMetadata.b(a);
            a.ae("WebGridRowEditTextTemplateContext", () => new WebGridRowEditTextTemplateContextDescription());
            a.ad("WebGridRowEditTextTemplateContext", WebGridRowEditTextTemplateContextDescriptionMetadata.a);
        }
    }
    WebGridRowEditTextTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridRowEditTextTemplateContextDescriptionMetadata, 'WebGridRowEditTextTemplateContextDescriptionMetadata');
    WebGridRowEditTextTemplateContextDescriptionMetadata.a = null;
    return WebGridRowEditTextTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridRowTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebGridRowTemplateContextDescription extends Description {
        get_type() {
            return "WebGridRowTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get implicit() {
            return this.h;
        }
        set implicit(a) {
            this.h = a;
            this.g("Implicit");
        }
    }
    WebGridRowTemplateContextDescription.$t = /*@__PURE__*/ markType(WebGridRowTemplateContextDescription, 'WebGridRowTemplateContextDescription', Description.$);
    WebGridRowTemplateContextDescription.__marshalByValue = true;
    WebGridRowTemplateContextDescription.__marshalByValueAlias = "GridRowTemplateContext";
    return WebGridRowTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridRowTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridRowTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridRowTemplateContextDescriptionMetadata.a == null) {
                WebGridRowTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridRowTemplateContextDescriptionMetadata.c(WebGridRowTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebGridRowTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridRowTemplateContextDescriptionMetadata.a);
            WebRowTypeDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridRowTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "ExportedType:WebRowType");
        }
        static d(a) {
            WebGridRowTemplateContextDescriptionMetadata.b(a);
            a.ae("WebGridRowTemplateContext", () => new WebGridRowTemplateContextDescription());
            a.ad("WebGridRowTemplateContext", WebGridRowTemplateContextDescriptionMetadata.a);
        }
    }
    WebGridRowTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridRowTemplateContextDescriptionMetadata, 'WebGridRowTemplateContextDescriptionMetadata');
    WebGridRowTemplateContextDescriptionMetadata.a = null;
    return WebGridRowTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebGridTemplateContextDescription extends Description {
        get_type() {
            return "WebGridTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get implicit() {
            return this.h;
        }
        set implicit(a) {
            this.h = a;
            this.g("Implicit");
        }
    }
    WebGridTemplateContextDescription.$t = /*@__PURE__*/ markType(WebGridTemplateContextDescription, 'WebGridTemplateContextDescription', Description.$);
    WebGridTemplateContextDescription.__marshalByValue = true;
    WebGridTemplateContextDescription.__marshalByValueAlias = "GridTemplateContext";
    return WebGridTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGridTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGridTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebGridTemplateContextDescriptionMetadata.a == null) {
                WebGridTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGridTemplateContextDescriptionMetadata.c(WebGridTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebGridTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGridTemplateContextDescriptionMetadata.a);
            WebGridBaseDirectiveDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GridTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "ExportedType:WebGridBaseDirective");
        }
        static d(a) {
            WebGridTemplateContextDescriptionMetadata.b(a);
            a.ae("WebGridTemplateContext", () => new WebGridTemplateContextDescription());
            a.ad("WebGridTemplateContext", WebGridTemplateContextDescriptionMetadata.a);
        }
    }
    WebGridTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGridTemplateContextDescriptionMetadata, 'WebGridTemplateContextDescriptionMetadata');
    WebGridTemplateContextDescriptionMetadata.a = null;
    return WebGridTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupByResultDescription = /*@__PURE__*/ (() => {
    class WebGroupByResultDescription extends Description {
        get_type() {
            return "WebGroupByResult";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = null;
        }
        get dataRef() {
            return this.j;
        }
        set dataRef(a) {
            this.j = a;
            this.g("DataRef");
        }
        get metadata() {
            return this.h;
        }
        set metadata(a) {
            this.h = a;
            this.g("Metadata");
        }
    }
    WebGroupByResultDescription.$t = /*@__PURE__*/ markType(WebGroupByResultDescription, 'WebGroupByResultDescription', Description.$);
    return WebGroupByResultDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebGroupByResultDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebGroupByResultDescriptionMetadata extends Base {
        static b(a) {
            if (WebGroupByResultDescriptionMetadata.a == null) {
                WebGroupByResultDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebGroupByResultDescriptionMetadata.c(WebGroupByResultDescriptionMetadata.a);
            }
            if (a.k(WebGroupByResultDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebGroupByResultDescriptionMetadata.a);
            WebGroupByRecordDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:GroupByResult");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("DataRef", "(w:Data,wf:Data)DataRef:object");
            a.item("Metadata", "Array:WebGroupByRecordDescription:GroupByRecord");
        }
        static d(a) {
            WebGroupByResultDescriptionMetadata.b(a);
            a.ae("WebGroupByResult", () => new WebGroupByResultDescription());
            a.ad("WebGroupByResult", WebGroupByResultDescriptionMetadata.a);
        }
    }
    WebGroupByResultDescriptionMetadata.$t = /*@__PURE__*/ markType(WebGroupByResultDescriptionMetadata, 'WebGroupByResultDescriptionMetadata');
    WebGroupByResultDescriptionMetadata.a = null;
    return WebGroupByResultDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebHeadSelectorTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebHeadSelectorTemplateContextDescription extends Description {
        get_type() {
            return "WebHeadSelectorTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get implicit() {
            return this.h;
        }
        set implicit(a) {
            this.h = a;
            this.g("Implicit");
        }
    }
    WebHeadSelectorTemplateContextDescription.$t = /*@__PURE__*/ markType(WebHeadSelectorTemplateContextDescription, 'WebHeadSelectorTemplateContextDescription', Description.$);
    WebHeadSelectorTemplateContextDescription.__marshalByValue = true;
    WebHeadSelectorTemplateContextDescription.__marshalByValueAlias = "HeadSelectorTemplateContext";
    return WebHeadSelectorTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebHeadSelectorTemplateDetailsDescription = /*@__PURE__*/ (() => {
    class WebHeadSelectorTemplateDetailsDescription extends Description {
        get_type() {
            return "WebHeadSelectorTemplateDetails";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = 0;
            this.i = 0;
        }
        get selectedCount() {
            return this.h;
        }
        set selectedCount(a) {
            this.h = a;
            this.g("SelectedCount");
        }
        get totalCount() {
            return this.i;
        }
        set totalCount(a) {
            this.i = a;
            this.g("TotalCount");
        }
    }
    WebHeadSelectorTemplateDetailsDescription.$t = /*@__PURE__*/ markType(WebHeadSelectorTemplateDetailsDescription, 'WebHeadSelectorTemplateDetailsDescription', Description.$);
    return WebHeadSelectorTemplateDetailsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebHeadSelectorTemplateDetailsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebHeadSelectorTemplateDetailsDescriptionMetadata extends Base {
        static b(a) {
            if (WebHeadSelectorTemplateDetailsDescriptionMetadata.a == null) {
                WebHeadSelectorTemplateDetailsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebHeadSelectorTemplateDetailsDescriptionMetadata.c(WebHeadSelectorTemplateDetailsDescriptionMetadata.a);
            }
            if (a.k(WebHeadSelectorTemplateDetailsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebHeadSelectorTemplateDetailsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:HeadSelectorTemplateDetails");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("SelectedCount", "Number:double");
            a.item("TotalCount", "Number:double");
        }
        static d(a) {
            WebHeadSelectorTemplateDetailsDescriptionMetadata.b(a);
            a.ae("WebHeadSelectorTemplateDetails", () => new WebHeadSelectorTemplateDetailsDescription());
            a.ad("WebHeadSelectorTemplateDetails", WebHeadSelectorTemplateDetailsDescriptionMetadata.a);
        }
    }
    WebHeadSelectorTemplateDetailsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebHeadSelectorTemplateDetailsDescriptionMetadata, 'WebHeadSelectorTemplateDetailsDescriptionMetadata');
    WebHeadSelectorTemplateDetailsDescriptionMetadata.a = null;
    return WebHeadSelectorTemplateDetailsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebHeadSelectorTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebHeadSelectorTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebHeadSelectorTemplateContextDescriptionMetadata.a == null) {
                WebHeadSelectorTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebHeadSelectorTemplateContextDescriptionMetadata.c(WebHeadSelectorTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebHeadSelectorTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebHeadSelectorTemplateContextDescriptionMetadata.a);
            WebHeadSelectorTemplateDetailsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:HeadSelectorTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "ExportedType:WebHeadSelectorTemplateDetails");
        }
        static d(a) {
            WebHeadSelectorTemplateContextDescriptionMetadata.b(a);
            a.ae("WebHeadSelectorTemplateContext", () => new WebHeadSelectorTemplateContextDescription());
            a.ad("WebHeadSelectorTemplateContext", WebHeadSelectorTemplateContextDescriptionMetadata.a);
        }
    }
    WebHeadSelectorTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebHeadSelectorTemplateContextDescriptionMetadata, 'WebHeadSelectorTemplateContextDescriptionMetadata');
    WebHeadSelectorTemplateContextDescriptionMetadata.a = null;
    return WebHeadSelectorTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebIconButtonDescription = /*@__PURE__*/ (() => {
    class WebIconButtonDescription extends WebButtonBaseDescription {
        get_type() {
            return "WebIconButton";
        }
        constructor() {
            super();
            this.ad = null;
            this.ac = null;
            this.aa = false;
            this.ae = null;
        }
        get iconName() {
            return this.ad;
        }
        set iconName(a) {
            this.ad = a;
            this.g("IconName");
        }
        get collection() {
            return this.ac;
        }
        set collection(a) {
            this.ac = a;
            this.g("Collection");
        }
        get mirrored() {
            return this.aa;
        }
        set mirrored(a) {
            this.aa = a;
            this.g("Mirrored");
        }
        get variant() {
            return this.ae;
        }
        set variant(a) {
            this.ae = a;
            this.g("Variant");
        }
    }
    WebIconButtonDescription.$t = /*@__PURE__*/ markType(WebIconButtonDescription, 'WebIconButtonDescription', WebButtonBaseDescription.$);
    return WebIconButtonDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebIconButtonDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebIconButtonDescriptionMetadata extends Base {
        static b(a) {
            if (WebIconButtonDescriptionMetadata.a == null) {
                WebIconButtonDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebIconButtonDescriptionMetadata.c(WebIconButtonDescriptionMetadata.a);
            }
            if (a.k(WebIconButtonDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebIconButtonDescriptionMetadata.a);
        }
        static c(a) {
            WebButtonBaseDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:IconButton");
            a.item("__tagNameWC", "String:igc-icon-button");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("IconName", "(wc:Name)String");
            a.item("Collection", "String");
            a.item("Mirrored", "Boolean");
            a.item("Variant", "ExportedType:string:IconButtonVariant");
            a.item("Variant@stringUnion", "WebComponents;React");
            a.item("Variant@names", "Flat;Contained;Outlined");
        }
        static d(a) {
            WebIconButtonDescriptionMetadata.b(a);
            a.ae("WebIconButton", () => new WebIconButtonDescription());
            a.ad("WebIconButton", WebIconButtonDescriptionMetadata.a);
        }
    }
    WebIconButtonDescriptionMetadata.$t = /*@__PURE__*/ markType(WebIconButtonDescriptionMetadata, 'WebIconButtonDescriptionMetadata');
    WebIconButtonDescriptionMetadata.a = null;
    return WebIconButtonDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebIconButtonDescriptionModule = /*@__PURE__*/ (() => {
    class WebIconButtonDescriptionModule extends Base {
        static register(a) {
            WebButtonBaseDescriptionModule.register(a);
            WebIconButtonDescriptionMetadata.d(a);
        }
    }
    WebIconButtonDescriptionModule.$t = /*@__PURE__*/ markType(WebIconButtonDescriptionModule, 'WebIconButtonDescriptionModule');
    return WebIconButtonDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebLinearProgressDescription = /*@__PURE__*/ (() => {
    class WebLinearProgressDescription extends WebProgressBaseDescription {
        get_type() {
            return "WebLinearProgress";
        }
        constructor() {
            super();
            this.w = false;
            this.y = null;
        }
        get striped() {
            return this.w;
        }
        set striped(a) {
            this.w = a;
            this.g("Striped");
        }
        get labelAlign() {
            return this.y;
        }
        set labelAlign(a) {
            this.y = a;
            this.g("LabelAlign");
        }
    }
    WebLinearProgressDescription.$t = /*@__PURE__*/ markType(WebLinearProgressDescription, 'WebLinearProgressDescription', WebProgressBaseDescription.$);
    return WebLinearProgressDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebLinearProgressDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebLinearProgressDescriptionMetadata extends Base {
        static b(a) {
            if (WebLinearProgressDescriptionMetadata.a == null) {
                WebLinearProgressDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebLinearProgressDescriptionMetadata.c(WebLinearProgressDescriptionMetadata.a);
            }
            if (a.k(WebLinearProgressDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebLinearProgressDescriptionMetadata.a);
        }
        static c(a) {
            WebProgressBaseDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:LinearProgress");
            a.item("__tagNameWC", "String:igc-linear-progress");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Striped", "Boolean");
            a.item("LabelAlign", "ExportedType:string:LinearProgressLabelAlign");
            a.item("LabelAlign@stringUnion", "WebComponents;React");
            a.item("LabelAlign@names", "Bottom;Top;TopStart;TopEnd;BottomStart;BottomEnd");
        }
        static d(a) {
            WebLinearProgressDescriptionMetadata.b(a);
            a.ae("WebLinearProgress", () => new WebLinearProgressDescription());
            a.ad("WebLinearProgress", WebLinearProgressDescriptionMetadata.a);
        }
    }
    WebLinearProgressDescriptionMetadata.$t = /*@__PURE__*/ markType(WebLinearProgressDescriptionMetadata, 'WebLinearProgressDescriptionMetadata');
    WebLinearProgressDescriptionMetadata.a = null;
    return WebLinearProgressDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebLinearProgressDescriptionModule = /*@__PURE__*/ (() => {
    class WebLinearProgressDescriptionModule extends Base {
        static register(a) {
            WebProgressBaseDescriptionModule.register(a);
            WebLinearProgressDescriptionMetadata.d(a);
        }
    }
    WebLinearProgressDescriptionModule.$t = /*@__PURE__*/ markType(WebLinearProgressDescriptionModule, 'WebLinearProgressDescriptionModule');
    return WebLinearProgressDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebListDescription = /*@__PURE__*/ (() => {
    class WebListDescription extends Description {
        get_type() {
            return "WebList";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebListDescription.$t = /*@__PURE__*/ markType(WebListDescription, 'WebListDescription', Description.$);
    return WebListDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebListDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebListDescriptionMetadata extends Base {
        static b(a) {
            if (WebListDescriptionMetadata.a == null) {
                WebListDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebListDescriptionMetadata.c(WebListDescriptionMetadata.a);
            }
            if (a.k(WebListDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebListDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:List");
            a.item("__tagNameWC", "String:igc-list");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebListDescriptionMetadata.b(a);
            a.ae("WebList", () => new WebListDescription());
            a.ad("WebList", WebListDescriptionMetadata.a);
        }
    }
    WebListDescriptionMetadata.$t = /*@__PURE__*/ markType(WebListDescriptionMetadata, 'WebListDescriptionMetadata');
    WebListDescriptionMetadata.a = null;
    return WebListDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebListHeaderDescription = /*@__PURE__*/ (() => {
    class WebListHeaderDescription extends Description {
        get_type() {
            return "WebListHeader";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebListHeaderDescription.$t = /*@__PURE__*/ markType(WebListHeaderDescription, 'WebListHeaderDescription', Description.$);
    return WebListHeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebListHeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebListHeaderDescriptionMetadata extends Base {
        static b(a) {
            if (WebListHeaderDescriptionMetadata.a == null) {
                WebListHeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebListHeaderDescriptionMetadata.c(WebListHeaderDescriptionMetadata.a);
            }
            if (a.k(WebListHeaderDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebListHeaderDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ListHeader");
            a.item("__tagNameWC", "String:igc-list-header");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebListHeaderDescriptionMetadata.b(a);
            a.ae("WebListHeader", () => new WebListHeaderDescription());
            a.ad("WebListHeader", WebListHeaderDescriptionMetadata.a);
        }
    }
    WebListHeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(WebListHeaderDescriptionMetadata, 'WebListHeaderDescriptionMetadata');
    WebListHeaderDescriptionMetadata.a = null;
    return WebListHeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebListHeaderDescriptionModule = /*@__PURE__*/ (() => {
    class WebListHeaderDescriptionModule extends Base {
        static register(a) {
            WebListHeaderDescriptionMetadata.d(a);
        }
    }
    WebListHeaderDescriptionModule.$t = /*@__PURE__*/ markType(WebListHeaderDescriptionModule, 'WebListHeaderDescriptionModule');
    return WebListHeaderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebListItemDescription = /*@__PURE__*/ (() => {
    class WebListItemDescription extends Description {
        get_type() {
            return "WebListItem";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebListItemDescription.$t = /*@__PURE__*/ markType(WebListItemDescription, 'WebListItemDescription', Description.$);
    return WebListItemDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebListItemDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebListItemDescriptionMetadata extends Base {
        static b(a) {
            if (WebListItemDescriptionMetadata.a == null) {
                WebListItemDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebListItemDescriptionMetadata.c(WebListItemDescriptionMetadata.a);
            }
            if (a.k(WebListItemDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebListItemDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ListItem");
            a.item("__tagNameWC", "String:igc-list-item");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebListItemDescriptionMetadata.b(a);
            a.ae("WebListItem", () => new WebListItemDescription());
            a.ad("WebListItem", WebListItemDescriptionMetadata.a);
        }
    }
    WebListItemDescriptionMetadata.$t = /*@__PURE__*/ markType(WebListItemDescriptionMetadata, 'WebListItemDescriptionMetadata');
    WebListItemDescriptionMetadata.a = null;
    return WebListItemDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebListItemDescriptionModule = /*@__PURE__*/ (() => {
    class WebListItemDescriptionModule extends Base {
        static register(a) {
            WebListItemDescriptionMetadata.d(a);
        }
    }
    WebListItemDescriptionModule.$t = /*@__PURE__*/ markType(WebListItemDescriptionModule, 'WebListItemDescriptionModule');
    return WebListItemDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebListDescriptionModule = /*@__PURE__*/ (() => {
    class WebListDescriptionModule extends Base {
        static register(a) {
            WebListDescriptionMetadata.d(a);
        }
    }
    WebListDescriptionModule.$t = /*@__PURE__*/ markType(WebListDescriptionModule, 'WebListDescriptionModule');
    return WebListDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebMaskInputDescription = /*@__PURE__*/ (() => {
    class WebMaskInputDescription extends WebMaskInputBaseDescription {
        get_type() {
            return "WebMaskInput";
        }
        constructor() {
            super();
            this.aj = null;
            this.ai = null;
            this.ah = null;
            this.ag = null;
        }
        get valueMode() {
            return this.aj;
        }
        set valueMode(a) {
            this.aj = a;
            this.g("ValueMode");
        }
        get value() {
            return this.ai;
        }
        set value(a) {
            this.ai = a;
            this.g("Value");
        }
        get mask() {
            return this.ah;
        }
        set mask(a) {
            this.ah = a;
            this.g("Mask");
        }
        get changeRef() {
            return this.ag;
        }
        set changeRef(a) {
            this.ag = a;
            this.g("ChangeRef");
        }
    }
    WebMaskInputDescription.$t = /*@__PURE__*/ markType(WebMaskInputDescription, 'WebMaskInputDescription', WebMaskInputBaseDescription.$);
    return WebMaskInputDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebMaskInputDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebMaskInputDescriptionMetadata extends Base {
        static b(a) {
            if (WebMaskInputDescriptionMetadata.a == null) {
                WebMaskInputDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebMaskInputDescriptionMetadata.c(WebMaskInputDescriptionMetadata.a);
            }
            if (a.k(WebMaskInputDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebMaskInputDescriptionMetadata.a);
            WebComponentDataValueChangedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebMaskInputBaseDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:MaskInput");
            a.item("__tagNameWC", "String:igc-mask-input");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("ValueMode", "ExportedType:string:MaskInputValueMode");
            a.item("ValueMode@stringUnion", "WebComponents;React");
            a.item("ValueMode@names", "Raw;WithFormatting");
            a.item("Value", "String");
            a.item("Mask", "String");
            a.item("ChangeRef", "EventRef::change");
        }
        static d(a) {
            WebMaskInputDescriptionMetadata.b(a);
            a.ae("WebMaskInput", () => new WebMaskInputDescription());
            a.ad("WebMaskInput", WebMaskInputDescriptionMetadata.a);
        }
    }
    WebMaskInputDescriptionMetadata.$t = /*@__PURE__*/ markType(WebMaskInputDescriptionMetadata, 'WebMaskInputDescriptionMetadata');
    WebMaskInputDescriptionMetadata.a = null;
    return WebMaskInputDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebMaskInputDescriptionModule = /*@__PURE__*/ (() => {
    class WebMaskInputDescriptionModule extends Base {
        static register(a) {
            WebMaskInputBaseDescriptionModule.register(a);
            WebMaskInputDescriptionMetadata.d(a);
        }
    }
    WebMaskInputDescriptionModule.$t = /*@__PURE__*/ markType(WebMaskInputDescriptionModule, 'WebMaskInputDescriptionModule');
    return WebMaskInputDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebMoveFloatingPaneActionDescription = /*@__PURE__*/ (() => {
    class WebMoveFloatingPaneActionDescription extends WebPaneDragActionDescription {
        get_type() {
            return "WebMoveFloatingPaneAction";
        }
        constructor() {
            super();
            this.q = null;
            this.l = null;
            this.k = null;
        }
        get actionType() {
            return this.q;
        }
        set actionType(a) {
            this.q = a;
            this.g("ActionType");
        }
        get oldLocation() {
            return this.l;
        }
        set oldLocation(a) {
            this.l = a;
            this.g("OldLocation");
        }
        get newLocation() {
            return this.k;
        }
        set newLocation(a) {
            this.k = a;
            this.g("NewLocation");
        }
    }
    WebMoveFloatingPaneActionDescription.$t = /*@__PURE__*/ markType(WebMoveFloatingPaneActionDescription, 'WebMoveFloatingPaneActionDescription', WebPaneDragActionDescription.$);
    WebMoveFloatingPaneActionDescription.__marshalByValue1 = true;
    WebMoveFloatingPaneActionDescription.__marshalByValueAlias1 = "MoveFloatingPaneAction";
    return WebMoveFloatingPaneActionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebMoveFloatingPaneActionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebMoveFloatingPaneActionDescriptionMetadata extends Base {
        static b(a) {
            if (WebMoveFloatingPaneActionDescriptionMetadata.a == null) {
                WebMoveFloatingPaneActionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebMoveFloatingPaneActionDescriptionMetadata.c(WebMoveFloatingPaneActionDescriptionMetadata.a);
            }
            if (a.k(WebMoveFloatingPaneActionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebMoveFloatingPaneActionDescriptionMetadata.a);
            WebDockManagerPointDescriptionMetadata.d(a);
        }
        static c(a) {
            WebPaneDragActionDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:MoveFloatingPaneAction");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__skipSuffix", "Boolean");
            a.item("ActionType", "(wc:Type)ExportedType:string:PaneDragActionType");
            a.item("ActionType@names", "FloatPane;MoveFloatingPane;DockPane;MoveTab");
            a.item("OldLocation", "ExportedType:WebDockManagerPoint");
            a.item("NewLocation", "ExportedType:WebDockManagerPoint");
        }
        static d(a) {
            WebMoveFloatingPaneActionDescriptionMetadata.b(a);
            a.ae("WebMoveFloatingPaneAction", () => new WebMoveFloatingPaneActionDescription());
            a.ad("WebMoveFloatingPaneAction", WebMoveFloatingPaneActionDescriptionMetadata.a);
        }
    }
    WebMoveFloatingPaneActionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebMoveFloatingPaneActionDescriptionMetadata, 'WebMoveFloatingPaneActionDescriptionMetadata');
    WebMoveFloatingPaneActionDescriptionMetadata.a = null;
    return WebMoveFloatingPaneActionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebMoveTabActionDescription = /*@__PURE__*/ (() => {
    class WebMoveTabActionDescription extends WebPaneDragActionDescription {
        get_type() {
            return "WebMoveTabAction";
        }
        constructor() {
            super();
            this.q = null;
            this.m = 0;
            this.l = 0;
        }
        get actionType() {
            return this.q;
        }
        set actionType(a) {
            this.q = a;
            this.g("ActionType");
        }
        get oldIndex() {
            return this.m;
        }
        set oldIndex(a) {
            this.m = a;
            this.g("OldIndex");
        }
        get newIndex() {
            return this.l;
        }
        set newIndex(a) {
            this.l = a;
            this.g("NewIndex");
        }
    }
    WebMoveTabActionDescription.$t = /*@__PURE__*/ markType(WebMoveTabActionDescription, 'WebMoveTabActionDescription', WebPaneDragActionDescription.$);
    WebMoveTabActionDescription.__marshalByValue1 = true;
    WebMoveTabActionDescription.__marshalByValueAlias1 = "MoveTabAction";
    return WebMoveTabActionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebMoveTabActionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebMoveTabActionDescriptionMetadata extends Base {
        static b(a) {
            if (WebMoveTabActionDescriptionMetadata.a == null) {
                WebMoveTabActionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebMoveTabActionDescriptionMetadata.c(WebMoveTabActionDescriptionMetadata.a);
            }
            if (a.k(WebMoveTabActionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebMoveTabActionDescriptionMetadata.a);
        }
        static c(a) {
            WebPaneDragActionDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:MoveTabAction");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__skipSuffix", "Boolean");
            a.item("ActionType", "(wc:Type)ExportedType:string:PaneDragActionType");
            a.item("ActionType@names", "FloatPane;MoveFloatingPane;DockPane;MoveTab");
            a.item("OldIndex", "Number:double");
            a.item("NewIndex", "Number:double");
        }
        static d(a) {
            WebMoveTabActionDescriptionMetadata.b(a);
            a.ae("WebMoveTabAction", () => new WebMoveTabActionDescription());
            a.ad("WebMoveTabAction", WebMoveTabActionDescriptionMetadata.a);
        }
    }
    WebMoveTabActionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebMoveTabActionDescriptionMetadata, 'WebMoveTabActionDescriptionMetadata');
    WebMoveTabActionDescriptionMetadata.a = null;
    return WebMoveTabActionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNavbarDescription = /*@__PURE__*/ (() => {
    class WebNavbarDescription extends Description {
        get_type() {
            return "WebNavbar";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebNavbarDescription.$t = /*@__PURE__*/ markType(WebNavbarDescription, 'WebNavbarDescription', Description.$);
    return WebNavbarDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNavbarDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebNavbarDescriptionMetadata extends Base {
        static b(a) {
            if (WebNavbarDescriptionMetadata.a == null) {
                WebNavbarDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebNavbarDescriptionMetadata.c(WebNavbarDescriptionMetadata.a);
            }
            if (a.k(WebNavbarDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebNavbarDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Navbar");
            a.item("__tagNameWC", "String:igc-navbar");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebNavbarDescriptionMetadata.b(a);
            a.ae("WebNavbar", () => new WebNavbarDescription());
            a.ad("WebNavbar", WebNavbarDescriptionMetadata.a);
        }
    }
    WebNavbarDescriptionMetadata.$t = /*@__PURE__*/ markType(WebNavbarDescriptionMetadata, 'WebNavbarDescriptionMetadata');
    WebNavbarDescriptionMetadata.a = null;
    return WebNavbarDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNavbarDescriptionModule = /*@__PURE__*/ (() => {
    class WebNavbarDescriptionModule extends Base {
        static register(a) {
            WebNavbarDescriptionMetadata.d(a);
        }
    }
    WebNavbarDescriptionModule.$t = /*@__PURE__*/ markType(WebNavbarDescriptionModule, 'WebNavbarDescriptionModule');
    return WebNavbarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNavDrawerDescription = /*@__PURE__*/ (() => {
    class WebNavDrawerDescription extends Description {
        get_type() {
            return "WebNavDrawer";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = false;
        }
        get position() {
            return this.j;
        }
        set position(a) {
            this.j = a;
            this.g("Position");
        }
        get open() {
            return this.h;
        }
        set open(a) {
            this.h = a;
            this.g("Open");
        }
    }
    WebNavDrawerDescription.$t = /*@__PURE__*/ markType(WebNavDrawerDescription, 'WebNavDrawerDescription', Description.$);
    return WebNavDrawerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNavDrawerDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebNavDrawerDescriptionMetadata extends Base {
        static b(a) {
            if (WebNavDrawerDescriptionMetadata.a == null) {
                WebNavDrawerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebNavDrawerDescriptionMetadata.c(WebNavDrawerDescriptionMetadata.a);
            }
            if (a.k(WebNavDrawerDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebNavDrawerDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:NavDrawer");
            a.item("__tagNameWC", "String:igc-nav-drawer");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Position", "ExportedType:string:NavDrawerPosition");
            a.item("Position@stringUnion", "WebComponents;React");
            a.item("Position@names", "Bottom;Top;Start;End;Relative");
            a.item("Open", "Boolean");
        }
        static d(a) {
            WebNavDrawerDescriptionMetadata.b(a);
            a.ae("WebNavDrawer", () => new WebNavDrawerDescription());
            a.ad("WebNavDrawer", WebNavDrawerDescriptionMetadata.a);
        }
    }
    WebNavDrawerDescriptionMetadata.$t = /*@__PURE__*/ markType(WebNavDrawerDescriptionMetadata, 'WebNavDrawerDescriptionMetadata');
    WebNavDrawerDescriptionMetadata.a = null;
    return WebNavDrawerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNavDrawerHeaderItemDescription = /*@__PURE__*/ (() => {
    class WebNavDrawerHeaderItemDescription extends Description {
        get_type() {
            return "WebNavDrawerHeaderItem";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebNavDrawerHeaderItemDescription.$t = /*@__PURE__*/ markType(WebNavDrawerHeaderItemDescription, 'WebNavDrawerHeaderItemDescription', Description.$);
    return WebNavDrawerHeaderItemDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNavDrawerHeaderItemDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebNavDrawerHeaderItemDescriptionMetadata extends Base {
        static b(a) {
            if (WebNavDrawerHeaderItemDescriptionMetadata.a == null) {
                WebNavDrawerHeaderItemDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebNavDrawerHeaderItemDescriptionMetadata.c(WebNavDrawerHeaderItemDescriptionMetadata.a);
            }
            if (a.k(WebNavDrawerHeaderItemDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebNavDrawerHeaderItemDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:NavDrawerHeaderItem");
            a.item("__tagNameWC", "String:igc-nav-drawer-header-item");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebNavDrawerHeaderItemDescriptionMetadata.b(a);
            a.ae("WebNavDrawerHeaderItem", () => new WebNavDrawerHeaderItemDescription());
            a.ad("WebNavDrawerHeaderItem", WebNavDrawerHeaderItemDescriptionMetadata.a);
        }
    }
    WebNavDrawerHeaderItemDescriptionMetadata.$t = /*@__PURE__*/ markType(WebNavDrawerHeaderItemDescriptionMetadata, 'WebNavDrawerHeaderItemDescriptionMetadata');
    WebNavDrawerHeaderItemDescriptionMetadata.a = null;
    return WebNavDrawerHeaderItemDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNavDrawerHeaderItemDescriptionModule = /*@__PURE__*/ (() => {
    class WebNavDrawerHeaderItemDescriptionModule extends Base {
        static register(a) {
            WebNavDrawerHeaderItemDescriptionMetadata.d(a);
        }
    }
    WebNavDrawerHeaderItemDescriptionModule.$t = /*@__PURE__*/ markType(WebNavDrawerHeaderItemDescriptionModule, 'WebNavDrawerHeaderItemDescriptionModule');
    return WebNavDrawerHeaderItemDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNavDrawerItemDescription = /*@__PURE__*/ (() => {
    class WebNavDrawerItemDescription extends Description {
        get_type() {
            return "WebNavDrawerItem";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = false;
            this.h = false;
        }
        get disabled() {
            return this.i;
        }
        set disabled(a) {
            this.i = a;
            this.g("Disabled");
        }
        get active() {
            return this.h;
        }
        set active(a) {
            this.h = a;
            this.g("Active");
        }
    }
    WebNavDrawerItemDescription.$t = /*@__PURE__*/ markType(WebNavDrawerItemDescription, 'WebNavDrawerItemDescription', Description.$);
    return WebNavDrawerItemDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNavDrawerItemDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebNavDrawerItemDescriptionMetadata extends Base {
        static b(a) {
            if (WebNavDrawerItemDescriptionMetadata.a == null) {
                WebNavDrawerItemDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebNavDrawerItemDescriptionMetadata.c(WebNavDrawerItemDescriptionMetadata.a);
            }
            if (a.k(WebNavDrawerItemDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebNavDrawerItemDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:NavDrawerItem");
            a.item("__tagNameWC", "String:igc-nav-drawer-item");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Disabled", "Boolean");
            a.item("Active", "Boolean");
        }
        static d(a) {
            WebNavDrawerItemDescriptionMetadata.b(a);
            a.ae("WebNavDrawerItem", () => new WebNavDrawerItemDescription());
            a.ad("WebNavDrawerItem", WebNavDrawerItemDescriptionMetadata.a);
        }
    }
    WebNavDrawerItemDescriptionMetadata.$t = /*@__PURE__*/ markType(WebNavDrawerItemDescriptionMetadata, 'WebNavDrawerItemDescriptionMetadata');
    WebNavDrawerItemDescriptionMetadata.a = null;
    return WebNavDrawerItemDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNavDrawerItemDescriptionModule = /*@__PURE__*/ (() => {
    class WebNavDrawerItemDescriptionModule extends Base {
        static register(a) {
            WebNavDrawerItemDescriptionMetadata.d(a);
        }
    }
    WebNavDrawerItemDescriptionModule.$t = /*@__PURE__*/ markType(WebNavDrawerItemDescriptionModule, 'WebNavDrawerItemDescriptionModule');
    return WebNavDrawerItemDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNavDrawerDescriptionModule = /*@__PURE__*/ (() => {
    class WebNavDrawerDescriptionModule extends Base {
        static register(a) {
            WebNavDrawerDescriptionMetadata.d(a);
        }
    }
    WebNavDrawerDescriptionModule.$t = /*@__PURE__*/ markType(WebNavDrawerDescriptionModule, 'WebNavDrawerDescriptionModule');
    return WebNavDrawerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNumberEventArgsDescription = /*@__PURE__*/ (() => {
    class WebNumberEventArgsDescription extends Description {
        get_type() {
            return "WebNumberEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = 0;
        }
        get detail() {
            return this.i;
        }
        set detail(a) {
            this.i = a;
            this.g("Detail");
        }
    }
    WebNumberEventArgsDescription.$t = /*@__PURE__*/ markType(WebNumberEventArgsDescription, 'WebNumberEventArgsDescription', Description.$);
    WebNumberEventArgsDescription.__marshalByValue = true;
    WebNumberEventArgsDescription.__marshalByValueAlias = "NumberEventArgs";
    return WebNumberEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNumberEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebNumberEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebNumberEventArgsDescriptionMetadata.a == null) {
                WebNumberEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebNumberEventArgsDescriptionMetadata.c(WebNumberEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebNumberEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebNumberEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:NumberEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "Number:double");
        }
        static d(a) {
            WebNumberEventArgsDescriptionMetadata.b(a);
            a.ae("WebNumberEventArgs", () => new WebNumberEventArgsDescription());
            a.ad("WebNumberEventArgs", WebNumberEventArgsDescriptionMetadata.a);
        }
    }
    WebNumberEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebNumberEventArgsDescriptionMetadata, 'WebNumberEventArgsDescriptionMetadata');
    WebNumberEventArgsDescriptionMetadata.a = null;
    return WebNumberEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNumberFilteringOperandDescription = /*@__PURE__*/ (() => {
    class WebNumberFilteringOperandDescription extends WebFilteringOperandDescription {
        get_type() {
            return "WebNumberFilteringOperand";
        }
        constructor() {
            super();
        }
    }
    WebNumberFilteringOperandDescription.$t = /*@__PURE__*/ markType(WebNumberFilteringOperandDescription, 'WebNumberFilteringOperandDescription', WebFilteringOperandDescription.$);
    return WebNumberFilteringOperandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNumberFilteringOperandDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebNumberFilteringOperandDescriptionMetadata extends Base {
        static b(a) {
            if (WebNumberFilteringOperandDescriptionMetadata.a == null) {
                WebNumberFilteringOperandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebNumberFilteringOperandDescriptionMetadata.c(WebNumberFilteringOperandDescriptionMetadata.a);
            }
            if (a.k(WebNumberFilteringOperandDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebNumberFilteringOperandDescriptionMetadata.a);
        }
        static c(a) {
            WebFilteringOperandDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:NumberFilteringOperand");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebNumberFilteringOperandDescriptionMetadata.b(a);
            a.ae("WebNumberFilteringOperand", () => new WebNumberFilteringOperandDescription());
            a.ad("WebNumberFilteringOperand", WebNumberFilteringOperandDescriptionMetadata.a);
        }
    }
    WebNumberFilteringOperandDescriptionMetadata.$t = /*@__PURE__*/ markType(WebNumberFilteringOperandDescriptionMetadata, 'WebNumberFilteringOperandDescriptionMetadata');
    WebNumberFilteringOperandDescriptionMetadata.a = null;
    return WebNumberFilteringOperandDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNumberSummaryOperandDescription = /*@__PURE__*/ (() => {
    class WebNumberSummaryOperandDescription extends WebSummaryOperandDescription {
        get_type() {
            return "WebNumberSummaryOperand";
        }
        constructor() {
            super();
        }
    }
    WebNumberSummaryOperandDescription.$t = /*@__PURE__*/ markType(WebNumberSummaryOperandDescription, 'WebNumberSummaryOperandDescription', WebSummaryOperandDescription.$);
    return WebNumberSummaryOperandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebNumberSummaryOperandDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebNumberSummaryOperandDescriptionMetadata extends Base {
        static b(a) {
            if (WebNumberSummaryOperandDescriptionMetadata.a == null) {
                WebNumberSummaryOperandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebNumberSummaryOperandDescriptionMetadata.c(WebNumberSummaryOperandDescriptionMetadata.a);
            }
            if (a.k(WebNumberSummaryOperandDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebNumberSummaryOperandDescriptionMetadata.a);
        }
        static c(a) {
            WebSummaryOperandDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:NumberSummaryOperand");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebNumberSummaryOperandDescriptionMetadata.b(a);
            a.ae("WebNumberSummaryOperand", () => new WebNumberSummaryOperandDescription());
            a.ad("WebNumberSummaryOperand", WebNumberSummaryOperandDescriptionMetadata.a);
        }
    }
    WebNumberSummaryOperandDescriptionMetadata.$t = /*@__PURE__*/ markType(WebNumberSummaryOperandDescriptionMetadata, 'WebNumberSummaryOperandDescriptionMetadata');
    WebNumberSummaryOperandDescriptionMetadata.a = null;
    return WebNumberSummaryOperandDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPageCancellableEventArgsDescription = /*@__PURE__*/ (() => {
    class WebPageCancellableEventArgsDescription extends Description {
        get_type() {
            return "WebPageCancellableEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebPageCancellableEventArgsDescription.$t = /*@__PURE__*/ markType(WebPageCancellableEventArgsDescription, 'WebPageCancellableEventArgsDescription', Description.$);
    WebPageCancellableEventArgsDescription.__marshalByValue = true;
    WebPageCancellableEventArgsDescription.__marshalByValueAlias = "PageCancellableEventArgs";
    return WebPageCancellableEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPageCancellableEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebPageCancellableEventArgsDetailDescription extends WebCancelableEventArgsDetailDescription {
        get_type() {
            return "WebPageCancellableEventArgsDetail";
        }
        constructor() {
            super();
            this.n = 0;
            this.o = 0;
        }
        get current() {
            return this.n;
        }
        set current(a) {
            this.n = a;
            this.g("Current");
        }
        get next() {
            return this.o;
        }
        set next(a) {
            this.o = a;
            this.g("Next");
        }
    }
    WebPageCancellableEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebPageCancellableEventArgsDetailDescription, 'WebPageCancellableEventArgsDetailDescription', WebCancelableEventArgsDetailDescription.$);
    WebPageCancellableEventArgsDetailDescription.__marshalByValue1 = true;
    WebPageCancellableEventArgsDetailDescription.__marshalByValueAlias1 = "PageCancellableEventArgsDetail";
    return WebPageCancellableEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPageCancellableEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPageCancellableEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebPageCancellableEventArgsDetailDescriptionMetadata.a == null) {
                WebPageCancellableEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPageCancellableEventArgsDetailDescriptionMetadata.c(WebPageCancellableEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebPageCancellableEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPageCancellableEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            WebCancelableEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:PageCancellableEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Current", "Number:double");
            a.item("Next", "Number:double");
        }
        static d(a) {
            WebPageCancellableEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebPageCancellableEventArgsDetail", () => new WebPageCancellableEventArgsDetailDescription());
            a.ad("WebPageCancellableEventArgsDetail", WebPageCancellableEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebPageCancellableEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPageCancellableEventArgsDetailDescriptionMetadata, 'WebPageCancellableEventArgsDetailDescriptionMetadata');
    WebPageCancellableEventArgsDetailDescriptionMetadata.a = null;
    return WebPageCancellableEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPageCancellableEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPageCancellableEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPageCancellableEventArgsDescriptionMetadata.a == null) {
                WebPageCancellableEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPageCancellableEventArgsDescriptionMetadata.c(WebPageCancellableEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebPageCancellableEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPageCancellableEventArgsDescriptionMetadata.a);
            WebPageCancellableEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PageCancellableEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebPageCancellableEventArgsDetail");
        }
        static d(a) {
            WebPageCancellableEventArgsDescriptionMetadata.b(a);
            a.ae("WebPageCancellableEventArgs", () => new WebPageCancellableEventArgsDescription());
            a.ad("WebPageCancellableEventArgs", WebPageCancellableEventArgsDescriptionMetadata.a);
        }
    }
    WebPageCancellableEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPageCancellableEventArgsDescriptionMetadata, 'WebPageCancellableEventArgsDescriptionMetadata');
    WebPageCancellableEventArgsDescriptionMetadata.a = null;
    return WebPageCancellableEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPageEventArgsDescription = /*@__PURE__*/ (() => {
    class WebPageEventArgsDescription extends Description {
        get_type() {
            return "WebPageEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebPageEventArgsDescription.$t = /*@__PURE__*/ markType(WebPageEventArgsDescription, 'WebPageEventArgsDescription', Description.$);
    WebPageEventArgsDescription.__marshalByValue = true;
    WebPageEventArgsDescription.__marshalByValueAlias = "PageEventArgs";
    return WebPageEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPageEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebPageEventArgsDetailDescription extends WebBaseEventArgsDetailDescription {
        get_type() {
            return "WebPageEventArgsDetail";
        }
        constructor() {
            super();
            this.o = 0;
            this.n = 0;
        }
        get previous() {
            return this.o;
        }
        set previous(a) {
            this.o = a;
            this.g("Previous");
        }
        get current() {
            return this.n;
        }
        set current(a) {
            this.n = a;
            this.g("Current");
        }
    }
    WebPageEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebPageEventArgsDetailDescription, 'WebPageEventArgsDetailDescription', WebBaseEventArgsDetailDescription.$);
    WebPageEventArgsDetailDescription.__marshalByValue1 = true;
    WebPageEventArgsDetailDescription.__marshalByValueAlias1 = "PageEventArgsDetail";
    return WebPageEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPageEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPageEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebPageEventArgsDetailDescriptionMetadata.a == null) {
                WebPageEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPageEventArgsDetailDescriptionMetadata.c(WebPageEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebPageEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPageEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseEventArgsDetailDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:PageEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Previous", "Number:double");
            a.item("Current", "Number:double");
        }
        static d(a) {
            WebPageEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebPageEventArgsDetail", () => new WebPageEventArgsDetailDescription());
            a.ad("WebPageEventArgsDetail", WebPageEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebPageEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPageEventArgsDetailDescriptionMetadata, 'WebPageEventArgsDetailDescriptionMetadata');
    WebPageEventArgsDetailDescriptionMetadata.a = null;
    return WebPageEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPageEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPageEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPageEventArgsDescriptionMetadata.a == null) {
                WebPageEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPageEventArgsDescriptionMetadata.c(WebPageEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebPageEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPageEventArgsDescriptionMetadata.a);
            WebPageEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PageEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebPageEventArgsDetail");
        }
        static d(a) {
            WebPageEventArgsDescriptionMetadata.b(a);
            a.ae("WebPageEventArgs", () => new WebPageEventArgsDescription());
            a.ad("WebPageEventArgs", WebPageEventArgsDescriptionMetadata.a);
        }
    }
    WebPageEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPageEventArgsDescriptionMetadata, 'WebPageEventArgsDescriptionMetadata');
    WebPageEventArgsDescriptionMetadata.a = null;
    return WebPageEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaginatorDescription = /*@__PURE__*/ (() => {
    class WebPaginatorDescription extends Description {
        get_type() {
            return "WebPaginator";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.p = 0;
            this.n = 0;
            this.o = 0;
            this.q = 0;
            this.h = null;
            this.j = null;
            this.l = null;
            this.v = null;
            this.z = null;
            this.w = null;
            this.x = null;
            this.y = null;
        }
        get totalPages() {
            return this.p;
        }
        set totalPages(a) {
            this.p = a;
            this.g("TotalPages");
        }
        get page() {
            return this.n;
        }
        set page(a) {
            this.n = a;
            this.g("Page");
        }
        get perPage() {
            return this.o;
        }
        set perPage(a) {
            this.o = a;
            this.g("PerPage");
        }
        get totalRecords() {
            return this.q;
        }
        set totalRecords(a) {
            this.q = a;
            this.g("TotalRecords");
        }
        get selectOptions() {
            return this.h;
        }
        set selectOptions(a) {
            this.h = a;
            this.g("SelectOptions");
        }
        get overlaySettings() {
            return this.j;
        }
        set overlaySettings(a) {
            this.j = a;
            this.g("OverlaySettings");
        }
        get resourceStrings() {
            return this.l;
        }
        set resourceStrings(a) {
            this.l = a;
            this.g("ResourceStrings");
        }
        get name() {
            return this.v;
        }
        set name(a) {
            this.v = a;
            this.g("Name");
        }
        get perPageChangeRef() {
            return this.z;
        }
        set perPageChangeRef(a) {
            this.z = a;
            this.g("PerPageChangeRef");
        }
        get pageChangeRef() {
            return this.w;
        }
        set pageChangeRef(a) {
            this.w = a;
            this.g("PageChangeRef");
        }
        get pagingRef() {
            return this.x;
        }
        set pagingRef(a) {
            this.x = a;
            this.g("PagingRef");
        }
        get pagingDoneRef() {
            return this.y;
        }
        set pagingDoneRef(a) {
            this.y = a;
            this.g("PagingDoneRef");
        }
    }
    WebPaginatorDescription.$t = /*@__PURE__*/ markType(WebPaginatorDescription, 'WebPaginatorDescription', Description.$);
    return WebPaginatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaginatorResourceStringsDescription = /*@__PURE__*/ (() => {
    class WebPaginatorResourceStringsDescription extends Description {
        get_type() {
            return "WebPaginatorResourceStrings";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.l = null;
            this.h = null;
            this.m = null;
            this.j = null;
            this.k = null;
        }
        get igx_paginator_label() {
            return this.i;
        }
        set igx_paginator_label(a) {
            this.i = a;
            this.g("Igx_paginator_label");
        }
        get igx_paginator_pager_text() {
            return this.l;
        }
        set igx_paginator_pager_text(a) {
            this.l = a;
            this.g("Igx_paginator_pager_text");
        }
        get igx_paginator_first_page_button_text() {
            return this.h;
        }
        set igx_paginator_first_page_button_text(a) {
            this.h = a;
            this.g("Igx_paginator_first_page_button_text");
        }
        get igx_paginator_previous_page_button_text() {
            return this.m;
        }
        set igx_paginator_previous_page_button_text(a) {
            this.m = a;
            this.g("Igx_paginator_previous_page_button_text");
        }
        get igx_paginator_last_page_button_text() {
            return this.j;
        }
        set igx_paginator_last_page_button_text(a) {
            this.j = a;
            this.g("Igx_paginator_last_page_button_text");
        }
        get igx_paginator_next_page_button_text() {
            return this.k;
        }
        set igx_paginator_next_page_button_text(a) {
            this.k = a;
            this.g("Igx_paginator_next_page_button_text");
        }
    }
    WebPaginatorResourceStringsDescription.$t = /*@__PURE__*/ markType(WebPaginatorResourceStringsDescription, 'WebPaginatorResourceStringsDescription', Description.$);
    return WebPaginatorResourceStringsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaginatorResourceStringsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPaginatorResourceStringsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPaginatorResourceStringsDescriptionMetadata.a == null) {
                WebPaginatorResourceStringsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPaginatorResourceStringsDescriptionMetadata.c(WebPaginatorResourceStringsDescriptionMetadata.a);
            }
            if (a.k(WebPaginatorResourceStringsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPaginatorResourceStringsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PaginatorResourceStrings");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Igx_paginator_label", "String");
            a.item("Igx_paginator_pager_text", "String");
            a.item("Igx_paginator_first_page_button_text", "String");
            a.item("Igx_paginator_previous_page_button_text", "String");
            a.item("Igx_paginator_last_page_button_text", "String");
            a.item("Igx_paginator_next_page_button_text", "String");
        }
        static d(a) {
            WebPaginatorResourceStringsDescriptionMetadata.b(a);
            a.ae("WebPaginatorResourceStrings", () => new WebPaginatorResourceStringsDescription());
            a.ad("WebPaginatorResourceStrings", WebPaginatorResourceStringsDescriptionMetadata.a);
        }
    }
    WebPaginatorResourceStringsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPaginatorResourceStringsDescriptionMetadata, 'WebPaginatorResourceStringsDescriptionMetadata');
    WebPaginatorResourceStringsDescriptionMetadata.a = null;
    return WebPaginatorResourceStringsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaginatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPaginatorDescriptionMetadata extends Base {
        static b(a) {
            if (WebPaginatorDescriptionMetadata.a == null) {
                WebPaginatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPaginatorDescriptionMetadata.c(WebPaginatorDescriptionMetadata.a);
            }
            if (a.k(WebPaginatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPaginatorDescriptionMetadata.a);
            WebOverlaySettingsDescriptionMetadata.d(a);
            WebPaginatorResourceStringsDescriptionMetadata.d(a);
            WebNumberEventArgsDescriptionMetadata.d(a);
            WebPageCancellableEventArgsDescriptionMetadata.d(a);
            WebPageEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Paginator");
            a.item("__tagNameWC", "String:igc-paginator");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__manageCollectionInMarkup", "Boolean");
            a.item("__mustUseNGParentAnchor", "Boolean");
            a.item("TotalPages", "Number:double");
            a.item("Page", "Number:double");
            a.item("PerPage", "Number:double");
            a.item("TotalRecords", "Number:double");
            a.item("SelectOptions", "Array:double");
            a.item("OverlaySettings", "ExportedType:WebOverlaySettings");
            a.item("ResourceStrings", "ExportedType:WebPaginatorResourceStrings");
            a.item("ResourceStrings@mustSetInCode", "WebComponents;Blazor;React");
            a.item("Name", "String");
            a.item("PerPageChangeRef", "EventRef::perPageChange:customEvent");
            a.item("PageChangeRef", "EventRef::pageChange:customEvent");
            a.item("PagingRef", "EventRef::paging:customEvent");
            a.item("PagingDoneRef", "EventRef::pagingDone:customEvent");
        }
        static d(a) {
            WebPaginatorDescriptionMetadata.b(a);
            a.ae("WebPaginator", () => new WebPaginatorDescription());
            a.ad("WebPaginator", WebPaginatorDescriptionMetadata.a);
        }
    }
    WebPaginatorDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPaginatorDescriptionMetadata, 'WebPaginatorDescriptionMetadata');
    WebPaginatorDescriptionMetadata.a = null;
    return WebPaginatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaginatorDescriptionModule = /*@__PURE__*/ (() => {
    class WebPaginatorDescriptionModule extends Base {
        static register(a) {
            WebPaginatorDescriptionMetadata.d(a);
        }
    }
    WebPaginatorDescriptionModule.$t = /*@__PURE__*/ markType(WebPaginatorDescriptionModule, 'WebPaginatorDescriptionModule');
    return WebPaginatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneCloseEventArgsDescription = /*@__PURE__*/ (() => {
    class WebPaneCloseEventArgsDescription extends Description {
        get_type() {
            return "WebPaneCloseEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebPaneCloseEventArgsDescription.$t = /*@__PURE__*/ markType(WebPaneCloseEventArgsDescription, 'WebPaneCloseEventArgsDescription', Description.$);
    WebPaneCloseEventArgsDescription.__marshalByValue = true;
    WebPaneCloseEventArgsDescription.__marshalByValueAlias = "PaneCloseEventArgs";
    return WebPaneCloseEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneCloseEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebPaneCloseEventArgsDetailDescription extends Description {
        get_type() {
            return "WebPaneCloseEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = null;
        }
        get sourcePane() {
            return this.j;
        }
        set sourcePane(a) {
            this.j = a;
            this.g("SourcePane");
        }
        get panes() {
            return this.h;
        }
        set panes(a) {
            this.h = a;
            this.g("Panes");
        }
    }
    WebPaneCloseEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebPaneCloseEventArgsDetailDescription, 'WebPaneCloseEventArgsDetailDescription', Description.$);
    WebPaneCloseEventArgsDetailDescription.__marshalByValue = true;
    WebPaneCloseEventArgsDetailDescription.__marshalByValueAlias = "PaneCloseEventArgsDetail";
    return WebPaneCloseEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneCloseEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPaneCloseEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebPaneCloseEventArgsDetailDescriptionMetadata.a == null) {
                WebPaneCloseEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPaneCloseEventArgsDetailDescriptionMetadata.c(WebPaneCloseEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebPaneCloseEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPaneCloseEventArgsDetailDescriptionMetadata.a);
            WebDockManagerPaneDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PaneCloseEventArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("SourcePane", "ExportedType:WebDockManagerPane");
            a.item("Panes", "Collection:WebContentPane:ContentPaneCollection:WebContentPane");
        }
        static d(a) {
            WebPaneCloseEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebPaneCloseEventArgsDetail", () => new WebPaneCloseEventArgsDetailDescription());
            a.ad("WebPaneCloseEventArgsDetail", WebPaneCloseEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebPaneCloseEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPaneCloseEventArgsDetailDescriptionMetadata, 'WebPaneCloseEventArgsDetailDescriptionMetadata');
    WebPaneCloseEventArgsDetailDescriptionMetadata.a = null;
    return WebPaneCloseEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneCloseEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPaneCloseEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPaneCloseEventArgsDescriptionMetadata.a == null) {
                WebPaneCloseEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPaneCloseEventArgsDescriptionMetadata.c(WebPaneCloseEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebPaneCloseEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPaneCloseEventArgsDescriptionMetadata.a);
            WebPaneCloseEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PaneCloseEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebPaneCloseEventArgsDetail");
        }
        static d(a) {
            WebPaneCloseEventArgsDescriptionMetadata.b(a);
            a.ae("WebPaneCloseEventArgs", () => new WebPaneCloseEventArgsDescription());
            a.ad("WebPaneCloseEventArgs", WebPaneCloseEventArgsDescriptionMetadata.a);
        }
    }
    WebPaneCloseEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPaneCloseEventArgsDescriptionMetadata, 'WebPaneCloseEventArgsDescriptionMetadata');
    WebPaneCloseEventArgsDescriptionMetadata.a = null;
    return WebPaneCloseEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneDragEndEventArgsDescription = /*@__PURE__*/ (() => {
    class WebPaneDragEndEventArgsDescription extends Description {
        get_type() {
            return "WebPaneDragEndEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebPaneDragEndEventArgsDescription.$t = /*@__PURE__*/ markType(WebPaneDragEndEventArgsDescription, 'WebPaneDragEndEventArgsDescription', Description.$);
    WebPaneDragEndEventArgsDescription.__marshalByValue = true;
    WebPaneDragEndEventArgsDescription.__marshalByValueAlias = "PaneDragEndEventArgs";
    return WebPaneDragEndEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneDragEndEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebPaneDragEndEventArgsDetailDescription extends Description {
        get_type() {
            return "WebPaneDragEndEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = null;
        }
        get sourcePane() {
            return this.j;
        }
        set sourcePane(a) {
            this.j = a;
            this.g("SourcePane");
        }
        get panes() {
            return this.h;
        }
        set panes(a) {
            this.h = a;
            this.g("Panes");
        }
    }
    WebPaneDragEndEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebPaneDragEndEventArgsDetailDescription, 'WebPaneDragEndEventArgsDetailDescription', Description.$);
    WebPaneDragEndEventArgsDetailDescription.__marshalByValue = true;
    WebPaneDragEndEventArgsDetailDescription.__marshalByValueAlias = "PaneDragEndEventArgsDetail";
    return WebPaneDragEndEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneDragEndEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPaneDragEndEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebPaneDragEndEventArgsDetailDescriptionMetadata.a == null) {
                WebPaneDragEndEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPaneDragEndEventArgsDetailDescriptionMetadata.c(WebPaneDragEndEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebPaneDragEndEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPaneDragEndEventArgsDetailDescriptionMetadata.a);
            WebDockManagerPaneDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PaneDragEndEventArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("SourcePane", "ExportedType:WebDockManagerPane");
            a.item("Panes", "Collection:WebContentPane:ContentPaneCollection:WebContentPane");
        }
        static d(a) {
            WebPaneDragEndEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebPaneDragEndEventArgsDetail", () => new WebPaneDragEndEventArgsDetailDescription());
            a.ad("WebPaneDragEndEventArgsDetail", WebPaneDragEndEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebPaneDragEndEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPaneDragEndEventArgsDetailDescriptionMetadata, 'WebPaneDragEndEventArgsDetailDescriptionMetadata');
    WebPaneDragEndEventArgsDetailDescriptionMetadata.a = null;
    return WebPaneDragEndEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneDragEndEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPaneDragEndEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPaneDragEndEventArgsDescriptionMetadata.a == null) {
                WebPaneDragEndEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPaneDragEndEventArgsDescriptionMetadata.c(WebPaneDragEndEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebPaneDragEndEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPaneDragEndEventArgsDescriptionMetadata.a);
            WebPaneDragEndEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PaneDragEndEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebPaneDragEndEventArgsDetail");
        }
        static d(a) {
            WebPaneDragEndEventArgsDescriptionMetadata.b(a);
            a.ae("WebPaneDragEndEventArgs", () => new WebPaneDragEndEventArgsDescription());
            a.ad("WebPaneDragEndEventArgs", WebPaneDragEndEventArgsDescriptionMetadata.a);
        }
    }
    WebPaneDragEndEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPaneDragEndEventArgsDescriptionMetadata, 'WebPaneDragEndEventArgsDescriptionMetadata');
    WebPaneDragEndEventArgsDescriptionMetadata.a = null;
    return WebPaneDragEndEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneDragOverEventArgsDescription = /*@__PURE__*/ (() => {
    class WebPaneDragOverEventArgsDescription extends Description {
        get_type() {
            return "WebPaneDragOverEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebPaneDragOverEventArgsDescription.$t = /*@__PURE__*/ markType(WebPaneDragOverEventArgsDescription, 'WebPaneDragOverEventArgsDescription', Description.$);
    WebPaneDragOverEventArgsDescription.__marshalByValue = true;
    WebPaneDragOverEventArgsDescription.__marshalByValueAlias = "PaneDragOverEventArgs";
    return WebPaneDragOverEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneDragOverEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebPaneDragOverEventArgsDetailDescription extends Description {
        get_type() {
            return "WebPaneDragOverEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = null;
            this.l = null;
            this.o = false;
        }
        get sourcePane() {
            return this.j;
        }
        set sourcePane(a) {
            this.j = a;
            this.g("SourcePane");
        }
        get panes() {
            return this.h;
        }
        set panes(a) {
            this.h = a;
            this.g("Panes");
        }
        get action() {
            return this.l;
        }
        set action(a) {
            this.l = a;
            this.g("Action");
        }
        get isValid() {
            return this.o;
        }
        set isValid(a) {
            this.o = a;
            this.g("IsValid");
        }
    }
    WebPaneDragOverEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebPaneDragOverEventArgsDetailDescription, 'WebPaneDragOverEventArgsDetailDescription', Description.$);
    WebPaneDragOverEventArgsDetailDescription.__marshalByValue = true;
    WebPaneDragOverEventArgsDetailDescription.__marshalByValueAlias = "PaneDragOverEventArgsDetail";
    return WebPaneDragOverEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneDragOverEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPaneDragOverEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebPaneDragOverEventArgsDetailDescriptionMetadata.a == null) {
                WebPaneDragOverEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPaneDragOverEventArgsDetailDescriptionMetadata.c(WebPaneDragOverEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebPaneDragOverEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPaneDragOverEventArgsDetailDescriptionMetadata.a);
            WebDockManagerPaneDescriptionMetadata.d(a);
            WebPaneDragActionDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PaneDragOverEventArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("SourcePane", "ExportedType:WebDockManagerPane");
            a.item("Panes", "Collection:WebContentPane:ContentPaneCollection:WebContentPane");
            a.item("Action", "ExportedType:WebPaneDragAction");
            a.item("IsValid", "Boolean");
        }
        static d(a) {
            WebPaneDragOverEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebPaneDragOverEventArgsDetail", () => new WebPaneDragOverEventArgsDetailDescription());
            a.ad("WebPaneDragOverEventArgsDetail", WebPaneDragOverEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebPaneDragOverEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPaneDragOverEventArgsDetailDescriptionMetadata, 'WebPaneDragOverEventArgsDetailDescriptionMetadata');
    WebPaneDragOverEventArgsDetailDescriptionMetadata.a = null;
    return WebPaneDragOverEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneDragOverEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPaneDragOverEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPaneDragOverEventArgsDescriptionMetadata.a == null) {
                WebPaneDragOverEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPaneDragOverEventArgsDescriptionMetadata.c(WebPaneDragOverEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebPaneDragOverEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPaneDragOverEventArgsDescriptionMetadata.a);
            WebPaneDragOverEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PaneDragOverEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebPaneDragOverEventArgsDetail");
        }
        static d(a) {
            WebPaneDragOverEventArgsDescriptionMetadata.b(a);
            a.ae("WebPaneDragOverEventArgs", () => new WebPaneDragOverEventArgsDescription());
            a.ad("WebPaneDragOverEventArgs", WebPaneDragOverEventArgsDescriptionMetadata.a);
        }
    }
    WebPaneDragOverEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPaneDragOverEventArgsDescriptionMetadata, 'WebPaneDragOverEventArgsDescriptionMetadata');
    WebPaneDragOverEventArgsDescriptionMetadata.a = null;
    return WebPaneDragOverEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneDragStartEventArgsDescription = /*@__PURE__*/ (() => {
    class WebPaneDragStartEventArgsDescription extends Description {
        get_type() {
            return "WebPaneDragStartEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebPaneDragStartEventArgsDescription.$t = /*@__PURE__*/ markType(WebPaneDragStartEventArgsDescription, 'WebPaneDragStartEventArgsDescription', Description.$);
    WebPaneDragStartEventArgsDescription.__marshalByValue = true;
    WebPaneDragStartEventArgsDescription.__marshalByValueAlias = "PaneDragStartEventArgs";
    return WebPaneDragStartEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneDragStartEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebPaneDragStartEventArgsDetailDescription extends Description {
        get_type() {
            return "WebPaneDragStartEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = null;
        }
        get sourcePane() {
            return this.j;
        }
        set sourcePane(a) {
            this.j = a;
            this.g("SourcePane");
        }
        get panes() {
            return this.h;
        }
        set panes(a) {
            this.h = a;
            this.g("Panes");
        }
    }
    WebPaneDragStartEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebPaneDragStartEventArgsDetailDescription, 'WebPaneDragStartEventArgsDetailDescription', Description.$);
    WebPaneDragStartEventArgsDetailDescription.__marshalByValue = true;
    WebPaneDragStartEventArgsDetailDescription.__marshalByValueAlias = "PaneDragStartEventArgsDetail";
    return WebPaneDragStartEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneDragStartEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPaneDragStartEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebPaneDragStartEventArgsDetailDescriptionMetadata.a == null) {
                WebPaneDragStartEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPaneDragStartEventArgsDetailDescriptionMetadata.c(WebPaneDragStartEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebPaneDragStartEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPaneDragStartEventArgsDetailDescriptionMetadata.a);
            WebDockManagerPaneDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PaneDragStartEventArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("SourcePane", "ExportedType:WebDockManagerPane");
            a.item("Panes", "Collection:WebContentPane:ContentPaneCollection:WebContentPane");
        }
        static d(a) {
            WebPaneDragStartEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebPaneDragStartEventArgsDetail", () => new WebPaneDragStartEventArgsDetailDescription());
            a.ad("WebPaneDragStartEventArgsDetail", WebPaneDragStartEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebPaneDragStartEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPaneDragStartEventArgsDetailDescriptionMetadata, 'WebPaneDragStartEventArgsDetailDescriptionMetadata');
    WebPaneDragStartEventArgsDetailDescriptionMetadata.a = null;
    return WebPaneDragStartEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneDragStartEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPaneDragStartEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPaneDragStartEventArgsDescriptionMetadata.a == null) {
                WebPaneDragStartEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPaneDragStartEventArgsDescriptionMetadata.c(WebPaneDragStartEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebPaneDragStartEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPaneDragStartEventArgsDescriptionMetadata.a);
            WebPaneDragStartEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PaneDragStartEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebPaneDragStartEventArgsDetail");
        }
        static d(a) {
            WebPaneDragStartEventArgsDescriptionMetadata.b(a);
            a.ae("WebPaneDragStartEventArgs", () => new WebPaneDragStartEventArgsDescription());
            a.ad("WebPaneDragStartEventArgs", WebPaneDragStartEventArgsDescriptionMetadata.a);
        }
    }
    WebPaneDragStartEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPaneDragStartEventArgsDescriptionMetadata, 'WebPaneDragStartEventArgsDescriptionMetadata');
    WebPaneDragStartEventArgsDescriptionMetadata.a = null;
    return WebPaneDragStartEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneHeaderConnectionEventArgsDescription = /*@__PURE__*/ (() => {
    class WebPaneHeaderConnectionEventArgsDescription extends Description {
        get_type() {
            return "WebPaneHeaderConnectionEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebPaneHeaderConnectionEventArgsDescription.$t = /*@__PURE__*/ markType(WebPaneHeaderConnectionEventArgsDescription, 'WebPaneHeaderConnectionEventArgsDescription', Description.$);
    WebPaneHeaderConnectionEventArgsDescription.__marshalByValue = true;
    WebPaneHeaderConnectionEventArgsDescription.__marshalByValueAlias = "PaneHeaderConnectionEventArgs";
    return WebPaneHeaderConnectionEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneHeaderElementDescription = /*@__PURE__*/ (() => {
    class WebPaneHeaderElementDescription extends Description {
        get_type() {
            return "WebPaneHeaderElement";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get dragService() {
            return this.h;
        }
        set dragService(a) {
            this.h = a;
            this.g("DragService");
        }
    }
    WebPaneHeaderElementDescription.$t = /*@__PURE__*/ markType(WebPaneHeaderElementDescription, 'WebPaneHeaderElementDescription', Description.$);
    WebPaneHeaderElementDescription.__marshalByValue = true;
    WebPaneHeaderElementDescription.__marshalByValueAlias = "PaneHeaderElement";
    return WebPaneHeaderElementDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneHeaderElementDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPaneHeaderElementDescriptionMetadata extends Base {
        static b(a) {
            if (WebPaneHeaderElementDescriptionMetadata.a == null) {
                WebPaneHeaderElementDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPaneHeaderElementDescriptionMetadata.c(WebPaneHeaderElementDescriptionMetadata.a);
            }
            if (a.k(WebPaneHeaderElementDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPaneHeaderElementDescriptionMetadata.a);
            WebDragServiceDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PaneHeaderElement");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("DragService", "ExportedType:WebDragService");
        }
        static d(a) {
            WebPaneHeaderElementDescriptionMetadata.b(a);
            a.ae("WebPaneHeaderElement", () => new WebPaneHeaderElementDescription());
            a.ad("WebPaneHeaderElement", WebPaneHeaderElementDescriptionMetadata.a);
        }
    }
    WebPaneHeaderElementDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPaneHeaderElementDescriptionMetadata, 'WebPaneHeaderElementDescriptionMetadata');
    WebPaneHeaderElementDescriptionMetadata.a = null;
    return WebPaneHeaderElementDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneHeaderConnectionEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebPaneHeaderConnectionEventArgsDetailDescription extends Description {
        get_type() {
            return "WebPaneHeaderConnectionEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = null;
        }
        get pane() {
            return this.h;
        }
        set pane(a) {
            this.h = a;
            this.g("Pane");
        }
        get element() {
            return this.j;
        }
        set element(a) {
            this.j = a;
            this.g("Element");
        }
    }
    WebPaneHeaderConnectionEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebPaneHeaderConnectionEventArgsDetailDescription, 'WebPaneHeaderConnectionEventArgsDetailDescription', Description.$);
    WebPaneHeaderConnectionEventArgsDetailDescription.__marshalByValue = true;
    WebPaneHeaderConnectionEventArgsDetailDescription.__marshalByValueAlias = "PaneHeaderConnectionEventArgsDetail";
    return WebPaneHeaderConnectionEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata.a == null) {
                WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata.c(WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata.a);
            WebContentPaneDescriptionMetadata.d(a);
            WebPaneHeaderElementDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PaneHeaderConnectionEventArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Pane", "ExportedType:WebContentPane");
            a.item("Element", "ExportedType:WebPaneHeaderElement");
        }
        static d(a) {
            WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebPaneHeaderConnectionEventArgsDetail", () => new WebPaneHeaderConnectionEventArgsDetailDescription());
            a.ad("WebPaneHeaderConnectionEventArgsDetail", WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata, 'WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata');
    WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata.a = null;
    return WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneHeaderConnectionEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPaneHeaderConnectionEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPaneHeaderConnectionEventArgsDescriptionMetadata.a == null) {
                WebPaneHeaderConnectionEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPaneHeaderConnectionEventArgsDescriptionMetadata.c(WebPaneHeaderConnectionEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebPaneHeaderConnectionEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPaneHeaderConnectionEventArgsDescriptionMetadata.a);
            WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PaneHeaderConnectionEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebPaneHeaderConnectionEventArgsDetail");
        }
        static d(a) {
            WebPaneHeaderConnectionEventArgsDescriptionMetadata.b(a);
            a.ae("WebPaneHeaderConnectionEventArgs", () => new WebPaneHeaderConnectionEventArgsDescription());
            a.ad("WebPaneHeaderConnectionEventArgs", WebPaneHeaderConnectionEventArgsDescriptionMetadata.a);
        }
    }
    WebPaneHeaderConnectionEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPaneHeaderConnectionEventArgsDescriptionMetadata, 'WebPaneHeaderConnectionEventArgsDescriptionMetadata');
    WebPaneHeaderConnectionEventArgsDescriptionMetadata.a = null;
    return WebPaneHeaderConnectionEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPaneHeaderElementDescriptionModule = /*@__PURE__*/ (() => {
    class WebPaneHeaderElementDescriptionModule extends Base {
        static register(a) {
            WebPaneHeaderElementDescriptionMetadata.d(a);
        }
    }
    WebPaneHeaderElementDescriptionModule.$t = /*@__PURE__*/ markType(WebPaneHeaderElementDescriptionModule, 'WebPaneHeaderElementDescriptionModule');
    return WebPaneHeaderElementDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPanePinnedEventArgsDescription = /*@__PURE__*/ (() => {
    class WebPanePinnedEventArgsDescription extends Description {
        get_type() {
            return "WebPanePinnedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebPanePinnedEventArgsDescription.$t = /*@__PURE__*/ markType(WebPanePinnedEventArgsDescription, 'WebPanePinnedEventArgsDescription', Description.$);
    WebPanePinnedEventArgsDescription.__marshalByValue = true;
    WebPanePinnedEventArgsDescription.__marshalByValueAlias = "PanePinnedEventArgs";
    return WebPanePinnedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPanePinnedEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebPanePinnedEventArgsDetailDescription extends Description {
        get_type() {
            return "WebPanePinnedEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = null;
            this.m = false;
            this.p = null;
        }
        get sourcePane() {
            return this.j;
        }
        set sourcePane(a) {
            this.j = a;
            this.g("SourcePane");
        }
        get panes() {
            return this.h;
        }
        set panes(a) {
            this.h = a;
            this.g("Panes");
        }
        get newValue() {
            return this.m;
        }
        set newValue(a) {
            this.m = a;
            this.g("NewValue");
        }
        get location() {
            return this.p;
        }
        set location(a) {
            this.p = a;
            this.g("Location");
        }
    }
    WebPanePinnedEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebPanePinnedEventArgsDetailDescription, 'WebPanePinnedEventArgsDetailDescription', Description.$);
    WebPanePinnedEventArgsDetailDescription.__marshalByValue = true;
    WebPanePinnedEventArgsDetailDescription.__marshalByValueAlias = "PanePinnedEventArgsDetail";
    return WebPanePinnedEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPanePinnedEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPanePinnedEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebPanePinnedEventArgsDetailDescriptionMetadata.a == null) {
                WebPanePinnedEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPanePinnedEventArgsDetailDescriptionMetadata.c(WebPanePinnedEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebPanePinnedEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPanePinnedEventArgsDetailDescriptionMetadata.a);
            WebContentPaneDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PanePinnedEventArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("SourcePane", "ExportedType:WebContentPane");
            a.item("Panes", "Collection:WebContentPane:ContentPaneCollection:WebContentPane");
            a.item("NewValue", "Boolean");
            a.item("Location", "ExportedType:string:UnpinnedLocation");
            a.item("Location@stringUnion", "WebComponents;React");
            a.item("Location@names", "Top;Bottom;Left;Right");
        }
        static d(a) {
            WebPanePinnedEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebPanePinnedEventArgsDetail", () => new WebPanePinnedEventArgsDetailDescription());
            a.ad("WebPanePinnedEventArgsDetail", WebPanePinnedEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebPanePinnedEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPanePinnedEventArgsDetailDescriptionMetadata, 'WebPanePinnedEventArgsDetailDescriptionMetadata');
    WebPanePinnedEventArgsDetailDescriptionMetadata.a = null;
    return WebPanePinnedEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPanePinnedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPanePinnedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPanePinnedEventArgsDescriptionMetadata.a == null) {
                WebPanePinnedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPanePinnedEventArgsDescriptionMetadata.c(WebPanePinnedEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebPanePinnedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPanePinnedEventArgsDescriptionMetadata.a);
            WebPanePinnedEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PanePinnedEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebPanePinnedEventArgsDetail");
        }
        static d(a) {
            WebPanePinnedEventArgsDescriptionMetadata.b(a);
            a.ae("WebPanePinnedEventArgs", () => new WebPanePinnedEventArgsDescription());
            a.ad("WebPanePinnedEventArgs", WebPanePinnedEventArgsDescriptionMetadata.a);
        }
    }
    WebPanePinnedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPanePinnedEventArgsDescriptionMetadata, 'WebPanePinnedEventArgsDescriptionMetadata');
    WebPanePinnedEventArgsDescriptionMetadata.a = null;
    return WebPanePinnedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotConfigurationChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class WebPivotConfigurationChangedEventArgsDescription extends Description {
        get_type() {
            return "WebPivotConfigurationChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebPivotConfigurationChangedEventArgsDescription.$t = /*@__PURE__*/ markType(WebPivotConfigurationChangedEventArgsDescription, 'WebPivotConfigurationChangedEventArgsDescription', Description.$);
    WebPivotConfigurationChangedEventArgsDescription.__marshalByValue = true;
    WebPivotConfigurationChangedEventArgsDescription.__marshalByValueAlias = "PivotConfigurationChangedEventArgs";
    return WebPivotConfigurationChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotConfigurationChangedEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebPivotConfigurationChangedEventArgsDetailDescription extends Description {
        get_type() {
            return "WebPivotConfigurationChangedEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get pivotConfiguration() {
            return this.h;
        }
        set pivotConfiguration(a) {
            this.h = a;
            this.g("PivotConfiguration");
        }
    }
    WebPivotConfigurationChangedEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebPivotConfigurationChangedEventArgsDetailDescription, 'WebPivotConfigurationChangedEventArgsDetailDescription', Description.$);
    WebPivotConfigurationChangedEventArgsDetailDescription.__marshalByValue = true;
    WebPivotConfigurationChangedEventArgsDetailDescription.__marshalByValueAlias = "PivotConfigurationChangedEventArgsDetail";
    return WebPivotConfigurationChangedEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata.a == null) {
                WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata.c(WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata.a);
            WebPivotConfigurationDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotConfigurationChangedEventArgsDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("PivotConfiguration", "ExportedType:WebPivotConfiguration");
        }
        static d(a) {
            WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebPivotConfigurationChangedEventArgsDetail", () => new WebPivotConfigurationChangedEventArgsDetailDescription());
            a.ad("WebPivotConfigurationChangedEventArgsDetail", WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata, 'WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata');
    WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata.a = null;
    return WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotConfigurationChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotConfigurationChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotConfigurationChangedEventArgsDescriptionMetadata.a == null) {
                WebPivotConfigurationChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotConfigurationChangedEventArgsDescriptionMetadata.c(WebPivotConfigurationChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebPivotConfigurationChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotConfigurationChangedEventArgsDescriptionMetadata.a);
            WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotConfigurationChangedEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebPivotConfigurationChangedEventArgsDetail");
        }
        static d(a) {
            WebPivotConfigurationChangedEventArgsDescriptionMetadata.b(a);
            a.ae("WebPivotConfigurationChangedEventArgs", () => new WebPivotConfigurationChangedEventArgsDescription());
            a.ad("WebPivotConfigurationChangedEventArgs", WebPivotConfigurationChangedEventArgsDescriptionMetadata.a);
        }
    }
    WebPivotConfigurationChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotConfigurationChangedEventArgsDescriptionMetadata, 'WebPivotConfigurationChangedEventArgsDescriptionMetadata');
    WebPivotConfigurationChangedEventArgsDescriptionMetadata.a = null;
    return WebPivotConfigurationChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDataSelectorDescription = /*@__PURE__*/ (() => {
    class WebPivotDataSelectorDescription extends Description {
        get_type() {
            return "WebPivotDataSelector";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
            this.j = false;
            this.i = false;
            this.k = false;
            this.p = null;
        }
        get columnsExpanded() {
            return this.h;
        }
        set columnsExpanded(a) {
            this.h = a;
            this.g("ColumnsExpanded");
        }
        get rowsExpanded() {
            return this.j;
        }
        set rowsExpanded(a) {
            this.j = a;
            this.g("RowsExpanded");
        }
        get filtersExpanded() {
            return this.i;
        }
        set filtersExpanded(a) {
            this.i = a;
            this.g("FiltersExpanded");
        }
        get valuesExpanded() {
            return this.k;
        }
        set valuesExpanded(a) {
            this.k = a;
            this.g("ValuesExpanded");
        }
        get gridRef() {
            return this.p;
        }
        set gridRef(a) {
            this.p = a;
            this.g("GridRef");
        }
    }
    WebPivotDataSelectorDescription.$t = /*@__PURE__*/ markType(WebPivotDataSelectorDescription, 'WebPivotDataSelectorDescription', Description.$);
    return WebPivotDataSelectorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDataSelectorDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotDataSelectorDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotDataSelectorDescriptionMetadata.a == null) {
                WebPivotDataSelectorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotDataSelectorDescriptionMetadata.c(WebPivotDataSelectorDescriptionMetadata.a);
            }
            if (a.k(WebPivotDataSelectorDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotDataSelectorDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotDataSelector");
            a.item("__tagNameWC", "String:igc-pivot-data-selector");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("ColumnsExpanded", "Boolean");
            a.item("RowsExpanded", "Boolean");
            a.item("FiltersExpanded", "Boolean");
            a.item("ValuesExpanded", "Boolean");
            a.item("GridRef", "(w:Grid,wf:Grid)DataRef::object");
        }
        static d(a) {
            WebPivotDataSelectorDescriptionMetadata.b(a);
            a.ae("WebPivotDataSelector", () => new WebPivotDataSelectorDescription());
            a.ad("WebPivotDataSelector", WebPivotDataSelectorDescriptionMetadata.a);
        }
    }
    WebPivotDataSelectorDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotDataSelectorDescriptionMetadata, 'WebPivotDataSelectorDescriptionMetadata');
    WebPivotDataSelectorDescriptionMetadata.a = null;
    return WebPivotDataSelectorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDateDimensionOptionsDescription = /*@__PURE__*/ (() => {
    class WebPivotDateDimensionOptionsDescription extends Description {
        get_type() {
            return "WebPivotDateDimensionOptions";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = false;
            this.l = false;
            this.j = false;
            this.i = false;
            this.h = false;
        }
        get total() {
            return this.k;
        }
        set total(a) {
            this.k = a;
            this.g("Total");
        }
        get years() {
            return this.l;
        }
        set years(a) {
            this.l = a;
            this.g("Years");
        }
        get quarters() {
            return this.j;
        }
        set quarters(a) {
            this.j = a;
            this.g("Quarters");
        }
        get months() {
            return this.i;
        }
        set months(a) {
            this.i = a;
            this.g("Months");
        }
        get fullDate() {
            return this.h;
        }
        set fullDate(a) {
            this.h = a;
            this.g("FullDate");
        }
    }
    WebPivotDateDimensionOptionsDescription.$t = /*@__PURE__*/ markType(WebPivotDateDimensionOptionsDescription, 'WebPivotDateDimensionOptionsDescription', Description.$);
    return WebPivotDateDimensionOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDateDimensionOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotDateDimensionOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotDateDimensionOptionsDescriptionMetadata.a == null) {
                WebPivotDateDimensionOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotDateDimensionOptionsDescriptionMetadata.c(WebPivotDateDimensionOptionsDescriptionMetadata.a);
            }
            if (a.k(WebPivotDateDimensionOptionsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotDateDimensionOptionsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotDateDimensionOptions");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Total", "Boolean");
            a.item("Years", "Boolean");
            a.item("Quarters", "Boolean");
            a.item("Months", "Boolean");
            a.item("FullDate", "Boolean");
        }
        static d(a) {
            WebPivotDateDimensionOptionsDescriptionMetadata.b(a);
            a.ae("WebPivotDateDimensionOptions", () => new WebPivotDateDimensionOptionsDescription());
            a.ad("WebPivotDateDimensionOptions", WebPivotDateDimensionOptionsDescriptionMetadata.a);
        }
    }
    WebPivotDateDimensionOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotDateDimensionOptionsDescriptionMetadata, 'WebPivotDateDimensionOptionsDescriptionMetadata');
    WebPivotDateDimensionOptionsDescriptionMetadata.a = null;
    return WebPivotDateDimensionOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDateDimensionDescription = /*@__PURE__*/ (() => {
    class WebPivotDateDimensionDescription extends WebPivotDimensionDescription {
        get_type() {
            return "WebPivotDateDimension";
        }
        constructor() {
            super();
            this.ap = false;
            this.as = null;
            this.ai = null;
            this.am = null;
            this.ak = null;
            this.at = null;
        }
        get enabled() {
            return this.ap;
        }
        set enabled(a) {
            this.ap = a;
            this.g("Enabled");
        }
        get dataType() {
            return this.as;
        }
        set dataType(a) {
            this.as = a;
            this.g("DataType");
        }
        get resourceStrings() {
            return this.ai;
        }
        set resourceStrings(a) {
            this.ai = a;
            this.g("ResourceStrings");
        }
        get baseDimension() {
            return this.am;
        }
        set baseDimension(a) {
            this.am = a;
            this.g("BaseDimension");
        }
        get options() {
            return this.ak;
        }
        set options(a) {
            this.ak = a;
            this.g("Options");
        }
        get displayName() {
            return this.at;
        }
        set displayName(a) {
            this.at = a;
            this.g("DisplayName");
        }
    }
    WebPivotDateDimensionDescription.$t = /*@__PURE__*/ markType(WebPivotDateDimensionDescription, 'WebPivotDateDimensionDescription', WebPivotDimensionDescription.$);
    WebPivotDateDimensionDescription.__marshalByValue1 = true;
    WebPivotDateDimensionDescription.__marshalByValueAlias1 = "PivotDateDimension";
    return WebPivotDateDimensionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDateDimensionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotDateDimensionDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotDateDimensionDescriptionMetadata.a == null) {
                WebPivotDateDimensionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotDateDimensionDescriptionMetadata.c(WebPivotDateDimensionDescriptionMetadata.a);
            }
            if (a.k(WebPivotDateDimensionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotDateDimensionDescriptionMetadata.a);
            WebPivotDateDimensionDescriptionMetadata.f(a);
            WebGridResourceStringsDescriptionMetadata.d(a);
            WebPivotDimensionDescriptionMetadata.d(a);
            WebPivotDateDimensionOptionsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebPivotDimensionDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:PivotDateDimension");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("Enabled", "Boolean");
            a.item("DataType", "ExportedType:string:GridColumnDataType");
            a.item("DataType@stringUnion", "WebComponents;React");
            a.item("DataType@names", "String;Number;Boolean;Date;DateTime;Time;Currency;Percent;Image");
            a.item("ResourceStrings", "ExportedType:WebGridResourceStrings");
            a.item("BaseDimension", "ExportedType:WebPivotDimension");
            a.item("Options", "ExportedType:WebPivotDateDimensionOptions");
            a.item("DisplayName", "String");
            WebPivotDateDimensionDescriptionMetadata.e(a);
        }
        static d(a) {
            WebPivotDateDimensionDescriptionMetadata.b(a);
            a.ae("WebPivotDateDimension", () => new WebPivotDateDimensionDescription());
            a.ad("WebPivotDateDimension", WebPivotDateDimensionDescriptionMetadata.a);
        }
        static e(a) {
            if (a.containsKey("__isPlainObject")) {
                a.removeItem("__isPlainObject");
            }
            a.item("__qualifiedNameBlazorTS", "String:WebPivotDateDimension");
        }
        static f(a) {
        }
    }
    WebPivotDateDimensionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotDateDimensionDescriptionMetadata, 'WebPivotDateDimensionDescriptionMetadata');
    WebPivotDateDimensionDescriptionMetadata.a = null;
    return WebPivotDateDimensionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDateDimensionDescriptionModule = /*@__PURE__*/ (() => {
    class WebPivotDateDimensionDescriptionModule extends Base {
        static register(a) {
            WebPivotDateDimensionDescriptionMetadata.d(a);
        }
    }
    WebPivotDateDimensionDescriptionModule.$t = /*@__PURE__*/ markType(WebPivotDateDimensionDescriptionModule, 'WebPivotDateDimensionDescriptionModule');
    return WebPivotDateDimensionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDimensionDetailDescription = /*@__PURE__*/ (() => {
    class WebPivotDimensionDetailDescription extends Description {
        get_type() {
            return "WebPivotDimensionDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.y = null;
            this.w = null;
            this.m = false;
            this.h = null;
            this.o = false;
            this.z = null;
            this.v = null;
            this.aa = null;
            this.s = 0;
            this.n = false;
            this.x = null;
        }
        get childLevel() {
            return this.j;
        }
        set childLevel(a) {
            this.j = a;
            this.g("ChildLevel");
        }
        get memberName() {
            return this.y;
        }
        set memberName(a) {
            this.y = a;
            this.g("MemberName");
        }
        get displayName() {
            return this.w;
        }
        set displayName(a) {
            this.w = a;
            this.g("DisplayName");
        }
        get enabled() {
            return this.m;
        }
        set enabled(a) {
            this.m = a;
            this.g("Enabled");
        }
        get filter() {
            return this.h;
        }
        set filter(a) {
            this.h = a;
            this.g("Filter");
        }
        get sortable() {
            return this.o;
        }
        set sortable(a) {
            this.o = a;
            this.g("Sortable");
        }
        get sortDirection() {
            return this.z;
        }
        set sortDirection(a) {
            this.z = a;
            this.g("SortDirection");
        }
        get dataType() {
            return this.v;
        }
        set dataType(a) {
            this.v = a;
            this.g("DataType");
        }
        get width() {
            return this.aa;
        }
        set width(a) {
            this.aa = a;
            this.g("Width");
        }
        get level() {
            return this.s;
        }
        set level(a) {
            this.s = a;
            this.g("Level");
        }
        get horizontalSummary() {
            return this.n;
        }
        set horizontalSummary(a) {
            this.n = a;
            this.g("HorizontalSummary");
        }
        get memberFunctionRef() {
            return this.x;
        }
        set memberFunctionRef(a) {
            this.x = a;
            this.g("MemberFunctionRef");
        }
    }
    WebPivotDimensionDetailDescription.$t = /*@__PURE__*/ markType(WebPivotDimensionDetailDescription, 'WebPivotDimensionDetailDescription', Description.$);
    WebPivotDimensionDetailDescription.__marshalByValue = true;
    WebPivotDimensionDetailDescription.__marshalByValueAlias = "PivotDimensionDetail";
    return WebPivotDimensionDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDimensionDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotDimensionDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotDimensionDetailDescriptionMetadata.a == null) {
                WebPivotDimensionDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotDimensionDetailDescriptionMetadata.c(WebPivotDimensionDetailDescriptionMetadata.a);
            }
            if (a.k(WebPivotDimensionDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotDimensionDetailDescriptionMetadata.a);
            WebPivotDimensionDescriptionMetadata.d(a);
            WebFilteringExpressionsTreeDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotDimensionDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("ChildLevel", "ExportedType:WebPivotDimension");
            a.item("MemberName", "String");
            a.item("DisplayName", "String");
            a.item("Enabled", "Boolean");
            a.item("Filter", "ExportedType:WebFilteringExpressionsTree");
            a.item("Sortable", "Boolean");
            a.item("SortDirection", "ExportedType:string:SortingDirection");
            a.item("SortDirection@names", "None;Asc;Desc");
            a.item("DataType", "ExportedType:string:GridColumnDataType");
            a.item("DataType@stringUnion", "WebComponents;React");
            a.item("DataType@names", "String;Number;Boolean;Date;DateTime;Time;Currency;Percent;Image");
            a.item("Width", "String");
            a.item("Level", "Number:double");
            a.item("HorizontalSummary", "Boolean");
            a.item("MemberFunctionRef", "EventRef::memberFunction");
        }
        static d(a) {
            WebPivotDimensionDetailDescriptionMetadata.b(a);
            a.ae("WebPivotDimensionDetail", () => new WebPivotDimensionDetailDescription());
            a.ad("WebPivotDimensionDetail", WebPivotDimensionDetailDescriptionMetadata.a);
        }
    }
    WebPivotDimensionDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotDimensionDetailDescriptionMetadata, 'WebPivotDimensionDetailDescriptionMetadata');
    WebPivotDimensionDetailDescriptionMetadata.a = null;
    return WebPivotDimensionDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDimensionEventArgsDescription = /*@__PURE__*/ (() => {
    class WebPivotDimensionEventArgsDescription extends Description {
        get_type() {
            return "WebPivotDimensionEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebPivotDimensionEventArgsDescription.$t = /*@__PURE__*/ markType(WebPivotDimensionEventArgsDescription, 'WebPivotDimensionEventArgsDescription', Description.$);
    WebPivotDimensionEventArgsDescription.__marshalByValue = true;
    WebPivotDimensionEventArgsDescription.__marshalByValueAlias = "PivotDimensionEventArgs";
    return WebPivotDimensionEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDimensionEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotDimensionEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotDimensionEventArgsDescriptionMetadata.a == null) {
                WebPivotDimensionEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotDimensionEventArgsDescriptionMetadata.c(WebPivotDimensionEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebPivotDimensionEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotDimensionEventArgsDescriptionMetadata.a);
            WebPivotDimensionDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotDimensionEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebPivotDimensionDetail");
        }
        static d(a) {
            WebPivotDimensionEventArgsDescriptionMetadata.b(a);
            a.ae("WebPivotDimensionEventArgs", () => new WebPivotDimensionEventArgsDescription());
            a.ad("WebPivotDimensionEventArgs", WebPivotDimensionEventArgsDescriptionMetadata.a);
        }
    }
    WebPivotDimensionEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotDimensionEventArgsDescriptionMetadata, 'WebPivotDimensionEventArgsDescriptionMetadata');
    WebPivotDimensionEventArgsDescriptionMetadata.a = null;
    return WebPivotDimensionEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotValueDetailDescription = /*@__PURE__*/ (() => {
    class WebPivotValueDetailDescription extends Description {
        get_type() {
            return "WebPivotValueDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.u = null;
            this.s = null;
            this.j = null;
            this.h = null;
            this.m = false;
            this.o = null;
            this.r = null;
            this.t = null;
        }
        get member() {
            return this.u;
        }
        set member(a) {
            this.u = a;
            this.g("Member");
        }
        get displayName() {
            return this.s;
        }
        set displayName(a) {
            this.s = a;
            this.g("DisplayName");
        }
        get aggregate() {
            return this.j;
        }
        set aggregate(a) {
            this.j = a;
            this.g("Aggregate");
        }
        get aggregateList() {
            return this.h;
        }
        set aggregateList(a) {
            this.h = a;
            this.g("AggregateList");
        }
        get enabled() {
            return this.m;
        }
        set enabled(a) {
            this.m = a;
            this.g("Enabled");
        }
        get styles() {
            return this.o;
        }
        set styles(a) {
            this.o = a;
            this.g("Styles");
        }
        get dataType() {
            return this.r;
        }
        set dataType(a) {
            this.r = a;
            this.g("DataType");
        }
        get formatterRef() {
            return this.t;
        }
        set formatterRef(a) {
            this.t = a;
            this.g("FormatterRef");
        }
    }
    WebPivotValueDetailDescription.$t = /*@__PURE__*/ markType(WebPivotValueDetailDescription, 'WebPivotValueDetailDescription', Description.$);
    WebPivotValueDetailDescription.__marshalByValue = true;
    WebPivotValueDetailDescription.__marshalByValueAlias = "PivotValueDetail";
    return WebPivotValueDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotValueDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotValueDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotValueDetailDescriptionMetadata.a == null) {
                WebPivotValueDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotValueDetailDescriptionMetadata.c(WebPivotValueDetailDescriptionMetadata.a);
            }
            if (a.k(WebPivotValueDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotValueDetailDescriptionMetadata.a);
            WebPivotAggregatorDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotValueDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Member", "String");
            a.item("DisplayName", "String");
            a.item("Aggregate", "ExportedType:WebPivotAggregator");
            a.item("AggregateList", "Array:WebPivotAggregatorDescription:PivotAggregator");
            a.item("Enabled", "Boolean");
            a.item("Styles", "Unknown");
            a.item("DataType", "ExportedType:string:GridColumnDataType");
            a.item("DataType@stringUnion", "WebComponents;React");
            a.item("DataType@names", "String;Number;Boolean;Date;DateTime;Time;Currency;Percent;Image");
            a.item("FormatterRef", "EventRef::formatter");
        }
        static d(a) {
            WebPivotValueDetailDescriptionMetadata.b(a);
            a.ae("WebPivotValueDetail", () => new WebPivotValueDetailDescription());
            a.ad("WebPivotValueDetail", WebPivotValueDetailDescriptionMetadata.a);
        }
    }
    WebPivotValueDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotValueDetailDescriptionMetadata, 'WebPivotValueDetailDescriptionMetadata');
    WebPivotValueDetailDescriptionMetadata.a = null;
    return WebPivotValueDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotValueEventArgsDescription = /*@__PURE__*/ (() => {
    class WebPivotValueEventArgsDescription extends Description {
        get_type() {
            return "WebPivotValueEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebPivotValueEventArgsDescription.$t = /*@__PURE__*/ markType(WebPivotValueEventArgsDescription, 'WebPivotValueEventArgsDescription', Description.$);
    WebPivotValueEventArgsDescription.__marshalByValue = true;
    WebPivotValueEventArgsDescription.__marshalByValueAlias = "PivotValueEventArgs";
    return WebPivotValueEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotValueEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotValueEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotValueEventArgsDescriptionMetadata.a == null) {
                WebPivotValueEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotValueEventArgsDescriptionMetadata.c(WebPivotValueEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebPivotValueEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotValueEventArgsDescriptionMetadata.a);
            WebPivotValueDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotValueEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebPivotValueDetail");
        }
        static d(a) {
            WebPivotValueEventArgsDescriptionMetadata.b(a);
            a.ae("WebPivotValueEventArgs", () => new WebPivotValueEventArgsDescription());
            a.ad("WebPivotValueEventArgs", WebPivotValueEventArgsDescriptionMetadata.a);
        }
    }
    WebPivotValueEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotValueEventArgsDescriptionMetadata, 'WebPivotValueEventArgsDescriptionMetadata');
    WebPivotValueEventArgsDescriptionMetadata.a = null;
    return WebPivotValueEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebValuesChangeDetailDescription = /*@__PURE__*/ (() => {
    class WebValuesChangeDetailDescription extends Description {
        get_type() {
            return "WebValuesChangeDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get values() {
            return this.h;
        }
        set values(a) {
            this.h = a;
            this.g("Values");
        }
    }
    WebValuesChangeDetailDescription.$t = /*@__PURE__*/ markType(WebValuesChangeDetailDescription, 'WebValuesChangeDetailDescription', Description.$);
    WebValuesChangeDetailDescription.__marshalByValue = true;
    WebValuesChangeDetailDescription.__marshalByValueAlias = "ValuesChangeDetail";
    return WebValuesChangeDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebValuesChangeDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebValuesChangeDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebValuesChangeDetailDescriptionMetadata.a == null) {
                WebValuesChangeDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebValuesChangeDetailDescriptionMetadata.c(WebValuesChangeDetailDescriptionMetadata.a);
            }
            if (a.k(WebValuesChangeDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebValuesChangeDetailDescriptionMetadata.a);
            WebPivotValueDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ValuesChangeDetail");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Values", "Array:WebPivotValueDescription:PivotValue");
        }
        static d(a) {
            WebValuesChangeDetailDescriptionMetadata.b(a);
            a.ae("WebValuesChangeDetail", () => new WebValuesChangeDetailDescription());
            a.ad("WebValuesChangeDetail", WebValuesChangeDetailDescriptionMetadata.a);
        }
    }
    WebValuesChangeDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebValuesChangeDetailDescriptionMetadata, 'WebValuesChangeDetailDescriptionMetadata');
    WebValuesChangeDetailDescriptionMetadata.a = null;
    return WebValuesChangeDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebValuesChangeEventArgsDescription = /*@__PURE__*/ (() => {
    class WebValuesChangeEventArgsDescription extends Description {
        get_type() {
            return "WebValuesChangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebValuesChangeEventArgsDescription.$t = /*@__PURE__*/ markType(WebValuesChangeEventArgsDescription, 'WebValuesChangeEventArgsDescription', Description.$);
    WebValuesChangeEventArgsDescription.__marshalByValue = true;
    WebValuesChangeEventArgsDescription.__marshalByValueAlias = "ValuesChangeEventArgs";
    return WebValuesChangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebValuesChangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebValuesChangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebValuesChangeEventArgsDescriptionMetadata.a == null) {
                WebValuesChangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebValuesChangeEventArgsDescriptionMetadata.c(WebValuesChangeEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebValuesChangeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebValuesChangeEventArgsDescriptionMetadata.a);
            WebValuesChangeDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ValuesChangeEventArgs");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebValuesChangeDetail");
        }
        static d(a) {
            WebValuesChangeEventArgsDescriptionMetadata.b(a);
            a.ae("WebValuesChangeEventArgs", () => new WebValuesChangeEventArgsDescription());
            a.ad("WebValuesChangeEventArgs", WebValuesChangeEventArgsDescriptionMetadata.a);
        }
    }
    WebValuesChangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebValuesChangeEventArgsDescriptionMetadata, 'WebValuesChangeEventArgsDescriptionMetadata');
    WebValuesChangeEventArgsDescriptionMetadata.a = null;
    return WebValuesChangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotGridValueTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebPivotGridValueTemplateContextDescription extends Description {
        get_type() {
            return "WebPivotGridValueTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get implicit() {
            return this.h;
        }
        set implicit(a) {
            this.h = a;
            this.g("Implicit");
        }
    }
    WebPivotGridValueTemplateContextDescription.$t = /*@__PURE__*/ markType(WebPivotGridValueTemplateContextDescription, 'WebPivotGridValueTemplateContextDescription', Description.$);
    WebPivotGridValueTemplateContextDescription.__marshalByValue = true;
    WebPivotGridValueTemplateContextDescription.__marshalByValueAlias = "PivotGridValueTemplateContext";
    return WebPivotGridValueTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotGridValueTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotGridValueTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotGridValueTemplateContextDescriptionMetadata.a == null) {
                WebPivotGridValueTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotGridValueTemplateContextDescriptionMetadata.c(WebPivotGridValueTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebPivotGridValueTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotGridValueTemplateContextDescriptionMetadata.a);
            WebPivotValueDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotGridValueTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "ExportedType:WebPivotValue");
        }
        static d(a) {
            WebPivotGridValueTemplateContextDescriptionMetadata.b(a);
            a.ae("WebPivotGridValueTemplateContext", () => new WebPivotGridValueTemplateContextDescription());
            a.ad("WebPivotGridValueTemplateContext", WebPivotGridValueTemplateContextDescriptionMetadata.a);
        }
    }
    WebPivotGridValueTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotGridValueTemplateContextDescriptionMetadata, 'WebPivotGridValueTemplateContextDescriptionMetadata');
    WebPivotGridValueTemplateContextDescriptionMetadata.a = null;
    return WebPivotGridValueTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotUISettingsDescription = /*@__PURE__*/ (() => {
    class WebPivotUISettingsDescription extends Description {
        get_type() {
            return "WebPivotUISettings";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
            this.i = false;
            this.m = null;
            this.l = null;
        }
        get showConfiguration() {
            return this.h;
        }
        set showConfiguration(a) {
            this.h = a;
            this.g("ShowConfiguration");
        }
        get showRowHeaders() {
            return this.i;
        }
        set showRowHeaders(a) {
            this.i = a;
            this.g("ShowRowHeaders");
        }
        get rowLayout() {
            return this.m;
        }
        set rowLayout(a) {
            this.m = a;
            this.g("RowLayout");
        }
        get horizontalSummariesPosition() {
            return this.l;
        }
        set horizontalSummariesPosition(a) {
            this.l = a;
            this.g("HorizontalSummariesPosition");
        }
    }
    WebPivotUISettingsDescription.$t = /*@__PURE__*/ markType(WebPivotUISettingsDescription, 'WebPivotUISettingsDescription', Description.$);
    return WebPivotUISettingsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotUISettingsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotUISettingsDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotUISettingsDescriptionMetadata.a == null) {
                WebPivotUISettingsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotUISettingsDescriptionMetadata.c(WebPivotUISettingsDescriptionMetadata.a);
            }
            if (a.k(WebPivotUISettingsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotUISettingsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotUISettings");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("ShowConfiguration", "Boolean");
            a.item("ShowRowHeaders", "Boolean");
            a.item("RowLayout", "ExportedType:string:PivotRowLayoutType");
            a.item("RowLayout@stringUnion", "WebComponents;React");
            a.item("RowLayout@names", "Vertical;Horizontal");
            a.item("HorizontalSummariesPosition", "ExportedType:string:PivotSummaryPosition");
            a.item("HorizontalSummariesPosition@stringUnion", "WebComponents;React");
            a.item("HorizontalSummariesPosition@names", "Top;Bottom");
        }
        static d(a) {
            WebPivotUISettingsDescriptionMetadata.b(a);
            a.ae("WebPivotUISettings", () => new WebPivotUISettingsDescription());
            a.ad("WebPivotUISettings", WebPivotUISettingsDescriptionMetadata.a);
        }
    }
    WebPivotUISettingsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotUISettingsDescriptionMetadata, 'WebPivotUISettingsDescriptionMetadata');
    WebPivotUISettingsDescriptionMetadata.a = null;
    return WebPivotUISettingsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotGridDescription = /*@__PURE__*/ (() => {
    class WebPivotGridDescription extends WebGridBaseDirectiveDescription {
        get_type() {
            return "WebPivotGrid";
        }
        constructor() {
            super();
            this.g4 = null;
            this.g3 = null;
            this.gn = null;
            this.gr = false;
            this.gp = null;
            this.gt = false;
            this.gs = false;
            this.gx = null;
            this.g1 = null;
            this.gz = null;
            this.g2 = null;
            this.gy = null;
            this.g5 = null;
            this.g0 = null;
            this.g6 = null;
        }
        get valueChipTemplateRef() {
            return this.g4;
        }
        set valueChipTemplateRef(a) {
            this.g4 = a;
            this.g("ValueChipTemplateRef");
        }
        get rowDimensionHeaderTemplateRef() {
            return this.g3;
        }
        set rowDimensionHeaderTemplateRef(a) {
            this.g3 = a;
            this.g("RowDimensionHeaderTemplateRef");
        }
        get pivotConfiguration() {
            return this.gn;
        }
        set pivotConfiguration(a) {
            this.gn = a;
            this.g("PivotConfiguration");
        }
        get autoGenerateConfig() {
            return this.gr;
        }
        set autoGenerateConfig(a) {
            this.gr = a;
            this.g("AutoGenerateConfig");
        }
        get pivotUI() {
            return this.gp;
        }
        set pivotUI(a) {
            this.gp = a;
            this.g("PivotUI");
        }
        get superCompactMode() {
            return this.gt;
        }
        set superCompactMode(a) {
            this.gt = a;
            this.g("SuperCompactMode");
        }
        get defaultExpandState() {
            return this.gs;
        }
        set defaultExpandState(a) {
            this.gs = a;
            this.g("DefaultExpandState");
        }
        get dataRef() {
            return this.gx;
        }
        set dataRef(a) {
            this.gx = a;
            this.g("DataRef");
        }
        get emptyPivotGridTemplateRef() {
            return this.g1;
        }
        set emptyPivotGridTemplateRef(a) {
            this.g1 = a;
            this.g("EmptyPivotGridTemplateRef");
        }
        get dimensionsChangeRef() {
            return this.gz;
        }
        set dimensionsChangeRef(a) {
            this.gz = a;
            this.g("DimensionsChangeRef");
        }
        get pivotConfigurationChangeRef() {
            return this.g2;
        }
        set pivotConfigurationChangeRef(a) {
            this.g2 = a;
            this.g("PivotConfigurationChangeRef");
        }
        get dimensionInitRef() {
            return this.gy;
        }
        set dimensionInitRef(a) {
            this.gy = a;
            this.g("DimensionInitRef");
        }
        get valueInitRef() {
            return this.g5;
        }
        set valueInitRef(a) {
            this.g5 = a;
            this.g("ValueInitRef");
        }
        get dimensionsSortingExpressionsChangeRef() {
            return this.g0;
        }
        set dimensionsSortingExpressionsChangeRef(a) {
            this.g0 = a;
            this.g("DimensionsSortingExpressionsChangeRef");
        }
        get valuesChangeRef() {
            return this.g6;
        }
        set valuesChangeRef(a) {
            this.g6 = a;
            this.g("ValuesChangeRef");
        }
    }
    WebPivotGridDescription.$t = /*@__PURE__*/ markType(WebPivotGridDescription, 'WebPivotGridDescription', WebGridBaseDirectiveDescription.$);
    return WebPivotGridDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotGridDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotGridDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotGridDescriptionMetadata.a == null) {
                WebPivotGridDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotGridDescriptionMetadata.c(WebPivotGridDescriptionMetadata.a);
            }
            if (a.k(WebPivotGridDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotGridDescriptionMetadata.a);
            WebPivotGridDescriptionMetadata.f(a);
            WebPivotConfigurationDescriptionMetadata.d(a);
            WebPivotUISettingsDescriptionMetadata.d(a);
            WebDimensionsChangeEventArgsDescriptionMetadata.d(a);
            WebPivotConfigurationChangedEventArgsDescriptionMetadata.d(a);
            WebPivotDimensionEventArgsDescriptionMetadata.d(a);
            WebPivotValueEventArgsDescriptionMetadata.d(a);
            WebSortingExpressionEventArgsDescriptionMetadata.d(a);
            WebValuesChangeEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebGridBaseDirectiveDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:PivotGrid");
            a.item("__tagNameWC", "String:igc-pivot-grid");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            if (a.containsKey("__skipSuffix")) {
                a.removeItem("__skipSuffix");
            }
            a.item("ValueChipTemplateRef", "(w:ValueChipTemplate,wf:ValueChipTemplate)TemplateRef::object");
            a.item("RowDimensionHeaderTemplateRef", "(w:RowDimensionHeaderTemplate,wf:RowDimensionHeaderTemplate)TemplateRef::object");
            a.item("PivotConfiguration", "ExportedType:WebPivotConfiguration");
            a.item("PivotConfiguration@mustSetInCode", "WebComponents;Blazor;React");
            a.item("AutoGenerateConfig", "Boolean");
            a.item("PivotUI", "ExportedType:WebPivotUISettings");
            a.item("SuperCompactMode", "Boolean");
            a.item("DefaultExpandState", "Boolean");
            a.item("DataRef", "(w:Data,wf:Data)DataRef::object");
            a.item("EmptyPivotGridTemplateRef", "(w:EmptyPivotGridTemplate,wf:EmptyPivotGridTemplate)TemplateRef::object");
            a.item("DimensionsChangeRef", "EventRef::dimensionsChange:customEvent");
            a.item("PivotConfigurationChangeRef", "EventRef::pivotConfigurationChange:customEvent");
            a.item("DimensionInitRef", "EventRef::dimensionInit:customEvent");
            a.item("ValueInitRef", "EventRef::valueInit:customEvent");
            a.item("DimensionsSortingExpressionsChangeRef", "EventRef::dimensionsSortingExpressionsChange:customEvent");
            a.item("ValuesChangeRef", "EventRef::valuesChange:customEvent");
            WebPivotGridDescriptionMetadata.e(a);
        }
        static d(a) {
            WebPivotGridDescriptionMetadata.b(a);
            a.ae("WebPivotGrid", () => new WebPivotGridDescription());
            a.ad("WebPivotGrid", WebPivotGridDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__deferAttachWC", "Boolean");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
        }
        static f(a) {
            WebGridToolbarDescriptionMetadata.d(a);
            WebGridToolbarActionsDescriptionMetadata.d(a);
            WebGridToolbarTitleDescriptionMetadata.d(a);
            WebGridToolbarExporterDescriptionMetadata.d(a);
            WebGridToolbarHidingDescriptionMetadata.d(a);
            WebGridToolbarPinningDescriptionMetadata.d(a);
            WebGridToolbarAdvancedFilteringDescriptionMetadata.d(a);
            WebGridToolbarBaseActionDescriptionMetadata.d(a);
            WebGridToolbarContentDescriptionMetadata.d(a);
        }
    }
    WebPivotGridDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotGridDescriptionMetadata, 'WebPivotGridDescriptionMetadata');
    WebPivotGridDescriptionMetadata.a = null;
    return WebPivotGridDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotGridDescriptionModule = /*@__PURE__*/ (() => {
    class WebPivotGridDescriptionModule extends Base {
        static register(a) {
            WebColumnDescriptionModule.register(a);
            WebGridToolbarDescriptionModule.register(a);
            WebGridToolbarActionsDescriptionModule.register(a);
            WebGridToolbarTitleDescriptionModule.register(a);
            WebGridToolbarAdvancedFilteringDescriptionModule.register(a);
            WebGridToolbarExporterDescriptionModule.register(a);
            WebGridToolbarHidingDescriptionModule.register(a);
            WebGridToolbarPinningDescriptionModule.register(a);
            WebActionStripDescriptionModule.register(a);
            WebGridActionsBaseDirectiveDescriptionModule.register(a);
            WebGridEditingActionsDescriptionModule.register(a);
            WebGridPinningActionsDescriptionModule.register(a);
            WebPivotDateDimensionDescriptionModule.register(a);
            WebDimensionsChangeEventArgsDescriptionMetadata.d(a);
            WebPivotConfigurationChangedEventArgsDescriptionMetadata.d(a);
            WebPivotDimensionEventArgsDescriptionMetadata.d(a);
            WebPivotValueEventArgsDescriptionMetadata.d(a);
            WebSortingExpressionEventArgsDescriptionMetadata.d(a);
            WebValuesChangeEventArgsDescriptionMetadata.d(a);
            WebPivotGridValueTemplateContextDescriptionMetadata.d(a);
            WebColumnTemplateContextDescriptionMetadata.d(a);
            WebPivotGridDescriptionMetadata.d(a);
            TemplateContainerDescriptionModule.register(a);
            ChildContentDescriptionModule.register(a);
        }
    }
    WebPivotGridDescriptionModule.$t = /*@__PURE__*/ markType(WebPivotGridDescriptionModule, 'WebPivotGridDescriptionModule');
    return WebPivotGridDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotDataSelectorDescriptionModule = /*@__PURE__*/ (() => {
    class WebPivotDataSelectorDescriptionModule extends Base {
        static register(a) {
            WebPivotGridDescriptionModule.register(a);
            WebPivotDataSelectorDescriptionMetadata.d(a);
            TemplateContainerDescriptionModule.register(a);
            ChildContentDescriptionModule.register(a);
        }
    }
    WebPivotDataSelectorDescriptionModule.$t = /*@__PURE__*/ markType(WebPivotDataSelectorDescriptionModule, 'WebPivotDataSelectorDescriptionModule');
    return WebPivotDataSelectorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotGridColumnDescription = /*@__PURE__*/ (() => {
    class WebPivotGridColumnDescription extends Description {
        get_type() {
            return "WebPivotGridColumn";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.h = null;
            this.j = null;
        }
        get field() {
            return this.l;
        }
        set field(a) {
            this.l = a;
            this.g("Field");
        }
        get dimensions() {
            return this.h;
        }
        set dimensions(a) {
            this.h = a;
            this.g("Dimensions");
        }
        get value() {
            return this.j;
        }
        set value(a) {
            this.j = a;
            this.g("Value");
        }
    }
    WebPivotGridColumnDescription.$t = /*@__PURE__*/ markType(WebPivotGridColumnDescription, 'WebPivotGridColumnDescription', Description.$);
    return WebPivotGridColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotGridColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotGridColumnDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotGridColumnDescriptionMetadata.a == null) {
                WebPivotGridColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotGridColumnDescriptionMetadata.c(WebPivotGridColumnDescriptionMetadata.a);
            }
            if (a.k(WebPivotGridColumnDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotGridColumnDescriptionMetadata.a);
            WebPivotDimensionDescriptionMetadata.d(a);
            WebPivotValueDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotGridColumn");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Field", "String");
            a.item("Dimensions", "Array:WebPivotDimensionDescription:PivotDimension");
            a.item("Value", "ExportedType:WebPivotValue");
        }
        static d(a) {
            WebPivotGridColumnDescriptionMetadata.b(a);
            a.ae("WebPivotGridColumn", () => new WebPivotGridColumnDescription());
            a.ad("WebPivotGridColumn", WebPivotGridColumnDescriptionMetadata.a);
        }
    }
    WebPivotGridColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotGridColumnDescriptionMetadata, 'WebPivotGridColumnDescriptionMetadata');
    WebPivotGridColumnDescriptionMetadata.a = null;
    return WebPivotGridColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotGridRecordDescription = /*@__PURE__*/ (() => {
    class WebPivotGridRecordDescription extends Description {
        get_type() {
            return "WebPivotGridRecord";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.k = 0;
            this.h = null;
            this.o = null;
            this.j = 0;
        }
        get recordsRef() {
            return this.n;
        }
        set recordsRef(a) {
            this.n = a;
            this.g("RecordsRef");
        }
        get level() {
            return this.k;
        }
        set level(a) {
            this.k = a;
            this.g("Level");
        }
        get dimensions() {
            return this.h;
        }
        set dimensions(a) {
            this.h = a;
            this.g("Dimensions");
        }
        get totalRecordDimensionName() {
            return this.o;
        }
        set totalRecordDimensionName(a) {
            this.o = a;
            this.g("TotalRecordDimensionName");
        }
        get dataIndex() {
            return this.j;
        }
        set dataIndex(a) {
            this.j = a;
            this.g("DataIndex");
        }
    }
    WebPivotGridRecordDescription.$t = /*@__PURE__*/ markType(WebPivotGridRecordDescription, 'WebPivotGridRecordDescription', Description.$);
    return WebPivotGridRecordDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebPivotGridRecordDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebPivotGridRecordDescriptionMetadata extends Base {
        static b(a) {
            if (WebPivotGridRecordDescriptionMetadata.a == null) {
                WebPivotGridRecordDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebPivotGridRecordDescriptionMetadata.c(WebPivotGridRecordDescriptionMetadata.a);
            }
            if (a.k(WebPivotGridRecordDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebPivotGridRecordDescriptionMetadata.a);
            WebPivotDimensionDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:PivotGridRecord");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("RecordsRef", "(w:Records,wf:Records)DataRef:object");
            a.item("Level", "Number:double");
            a.item("Dimensions", "Array:WebPivotDimensionDescription:PivotDimension");
            a.item("TotalRecordDimensionName", "String");
            a.item("DataIndex", "Number:double");
        }
        static d(a) {
            WebPivotGridRecordDescriptionMetadata.b(a);
            a.ae("WebPivotGridRecord", () => new WebPivotGridRecordDescription());
            a.ad("WebPivotGridRecord", WebPivotGridRecordDescriptionMetadata.a);
        }
    }
    WebPivotGridRecordDescriptionMetadata.$t = /*@__PURE__*/ markType(WebPivotGridRecordDescriptionMetadata, 'WebPivotGridRecordDescriptionMetadata');
    WebPivotGridRecordDescriptionMetadata.a = null;
    return WebPivotGridRecordDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRadioDescription = /*@__PURE__*/ (() => {
    class WebRadioDescription extends Description {
        get_type() {
            return "WebRadio";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.u = null;
            this.h = false;
            this.s = null;
            this.i = false;
            this.k = false;
            this.t = null;
            this.j = false;
            this.q = null;
            this.r = null;
            this.p = null;
        }
        get value() {
            return this.u;
        }
        set value(a) {
            this.u = a;
            this.g("Value");
        }
        get checked() {
            return this.h;
        }
        set checked(a) {
            this.h = a;
            this.g("Checked");
        }
        get labelPosition() {
            return this.s;
        }
        set labelPosition(a) {
            this.s = a;
            this.g("LabelPosition");
        }
        get disabled() {
            return this.i;
        }
        set disabled(a) {
            this.i = a;
            this.g("Disabled");
        }
        get required() {
            return this.k;
        }
        set required(a) {
            this.k = a;
            this.g("Required");
        }
        get name() {
            return this.t;
        }
        set name(a) {
            this.t = a;
            this.g("Name");
        }
        get invalid() {
            return this.j;
        }
        set invalid(a) {
            this.j = a;
            this.g("Invalid");
        }
        get changeRef() {
            return this.q;
        }
        set changeRef(a) {
            this.q = a;
            this.g("ChangeRef");
        }
        get focusRef() {
            return this.r;
        }
        set focusRef(a) {
            this.r = a;
            this.g("FocusRef");
        }
        get blurRef() {
            return this.p;
        }
        set blurRef(a) {
            this.p = a;
            this.g("BlurRef");
        }
    }
    WebRadioDescription.$t = /*@__PURE__*/ markType(WebRadioDescription, 'WebRadioDescription', Description.$);
    return WebRadioDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRadioChangeEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebRadioChangeEventArgsDetailDescription extends Description {
        get_type() {
            return "WebRadioChangeEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = false;
            this.l = null;
        }
        get checked() {
            return this.i;
        }
        set checked(a) {
            this.i = a;
            this.g("Checked");
        }
        get value() {
            return this.l;
        }
        set value(a) {
            this.l = a;
            this.g("Value");
        }
    }
    WebRadioChangeEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebRadioChangeEventArgsDetailDescription, 'WebRadioChangeEventArgsDetailDescription', Description.$);
    WebRadioChangeEventArgsDetailDescription.__marshalByValue = true;
    WebRadioChangeEventArgsDetailDescription.__marshalByValueAlias = "RadioChangeEventArgsDetail";
    return WebRadioChangeEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRadioChangeEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRadioChangeEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebRadioChangeEventArgsDetailDescriptionMetadata.a == null) {
                WebRadioChangeEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRadioChangeEventArgsDetailDescriptionMetadata.c(WebRadioChangeEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebRadioChangeEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRadioChangeEventArgsDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RadioChangeEventArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Checked", "Boolean");
            a.item("Value", "String");
        }
        static d(a) {
            WebRadioChangeEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebRadioChangeEventArgsDetail", () => new WebRadioChangeEventArgsDetailDescription());
            a.ad("WebRadioChangeEventArgsDetail", WebRadioChangeEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebRadioChangeEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRadioChangeEventArgsDetailDescriptionMetadata, 'WebRadioChangeEventArgsDetailDescriptionMetadata');
    WebRadioChangeEventArgsDetailDescriptionMetadata.a = null;
    return WebRadioChangeEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRadioChangeEventArgsDescription = /*@__PURE__*/ (() => {
    class WebRadioChangeEventArgsDescription extends Description {
        get_type() {
            return "WebRadioChangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebRadioChangeEventArgsDescription.$t = /*@__PURE__*/ markType(WebRadioChangeEventArgsDescription, 'WebRadioChangeEventArgsDescription', Description.$);
    WebRadioChangeEventArgsDescription.__marshalByValue = true;
    WebRadioChangeEventArgsDescription.__marshalByValueAlias = "RadioChangeEventArgs";
    return WebRadioChangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRadioChangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRadioChangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebRadioChangeEventArgsDescriptionMetadata.a == null) {
                WebRadioChangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRadioChangeEventArgsDescriptionMetadata.c(WebRadioChangeEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebRadioChangeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRadioChangeEventArgsDescriptionMetadata.a);
            WebRadioChangeEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RadioChangeEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebRadioChangeEventArgsDetail");
        }
        static d(a) {
            WebRadioChangeEventArgsDescriptionMetadata.b(a);
            a.ae("WebRadioChangeEventArgs", () => new WebRadioChangeEventArgsDescription());
            a.ad("WebRadioChangeEventArgs", WebRadioChangeEventArgsDescriptionMetadata.a);
        }
    }
    WebRadioChangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRadioChangeEventArgsDescriptionMetadata, 'WebRadioChangeEventArgsDescriptionMetadata');
    WebRadioChangeEventArgsDescriptionMetadata.a = null;
    return WebRadioChangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRadioDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRadioDescriptionMetadata extends Base {
        static b(a) {
            if (WebRadioDescriptionMetadata.a == null) {
                WebRadioDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRadioDescriptionMetadata.c(WebRadioDescriptionMetadata.a);
            }
            if (a.k(WebRadioDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRadioDescriptionMetadata.a);
            WebRadioChangeEventArgsDescriptionMetadata.d(a);
            VoidEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Radio");
            a.item("__tagNameWC", "String:igc-radio");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Value", "String");
            a.item("Checked", "Boolean");
            a.item("LabelPosition", "ExportedType:string:RadioLabelPosition");
            a.item("LabelPosition@stringUnion", "WebComponents;React");
            a.item("LabelPosition@names", "Before;After");
            a.item("Disabled", "Boolean");
            a.item("Required", "Boolean");
            a.item("Name", "String");
            a.item("Invalid", "Boolean");
            a.item("ChangeRef", "EventRef::change");
            a.item("FocusRef", "EventRef::focus");
            a.item("BlurRef", "EventRef::blur");
        }
        static d(a) {
            WebRadioDescriptionMetadata.b(a);
            a.ae("WebRadio", () => new WebRadioDescription());
            a.ad("WebRadio", WebRadioDescriptionMetadata.a);
        }
    }
    WebRadioDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRadioDescriptionMetadata, 'WebRadioDescriptionMetadata');
    WebRadioDescriptionMetadata.a = null;
    return WebRadioDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRadioGroupDescription = /*@__PURE__*/ (() => {
    class WebRadioGroupDescription extends Description {
        get_type() {
            return "WebRadioGroup";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = null;
            this.k = null;
            this.i = null;
        }
        get alignment() {
            return this.h;
        }
        set alignment(a) {
            this.h = a;
            this.g("Alignment");
        }
        get name() {
            return this.j;
        }
        set name(a) {
            this.j = a;
            this.g("Name");
        }
        get value() {
            return this.k;
        }
        set value(a) {
            this.k = a;
            this.g("Value");
        }
        get changeRef() {
            return this.i;
        }
        set changeRef(a) {
            this.i = a;
            this.g("ChangeRef");
        }
    }
    WebRadioGroupDescription.$t = /*@__PURE__*/ markType(WebRadioGroupDescription, 'WebRadioGroupDescription', Description.$);
    return WebRadioGroupDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRadioGroupDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRadioGroupDescriptionMetadata extends Base {
        static b(a) {
            if (WebRadioGroupDescriptionMetadata.a == null) {
                WebRadioGroupDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRadioGroupDescriptionMetadata.c(WebRadioGroupDescriptionMetadata.a);
            }
            if (a.k(WebRadioGroupDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRadioGroupDescriptionMetadata.a);
            WebRadioChangeEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RadioGroup");
            a.item("__tagNameWC", "String:igc-radio-group");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Alignment", "ExportedType:string:RadioGroupAlignment");
            a.item("Alignment@stringUnion", "WebComponents;React");
            a.item("Alignment@names", "Horizontal;Vertical");
            a.item("Name", "String");
            a.item("Value", "String");
            a.item("ChangeRef", "EventRef::change");
        }
        static d(a) {
            WebRadioGroupDescriptionMetadata.b(a);
            a.ae("WebRadioGroup", () => new WebRadioGroupDescription());
            a.ad("WebRadioGroup", WebRadioGroupDescriptionMetadata.a);
        }
    }
    WebRadioGroupDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRadioGroupDescriptionMetadata, 'WebRadioGroupDescriptionMetadata');
    WebRadioGroupDescriptionMetadata.a = null;
    return WebRadioGroupDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRadioGroupDescriptionModule = /*@__PURE__*/ (() => {
    class WebRadioGroupDescriptionModule extends Base {
        static register(a) {
            WebRadioGroupDescriptionMetadata.d(a);
        }
    }
    WebRadioGroupDescriptionModule.$t = /*@__PURE__*/ markType(WebRadioGroupDescriptionModule, 'WebRadioGroupDescriptionModule');
    return WebRadioGroupDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRadioDescriptionModule = /*@__PURE__*/ (() => {
    class WebRadioDescriptionModule extends Base {
        static register(a) {
            WebRadioChangeEventArgsDescriptionMetadata.d(a);
            WebRadioDescriptionMetadata.d(a);
        }
    }
    WebRadioDescriptionModule.$t = /*@__PURE__*/ markType(WebRadioDescriptionModule, 'WebRadioDescriptionModule');
    return WebRadioDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSliderBaseDescription = /*@__PURE__*/ (() => {
    class WebSliderBaseDescription extends Description {
        get_type() {
            return "WebSliderBase";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.v = 0;
            this.u = 0;
            this.t = 0;
            this.z = 0;
            this.j = false;
            this.k = false;
            this.n = false;
            this.y = 0;
            this.w = 0;
            this.x = 0;
            this.aj = null;
            this.l = false;
            this.m = false;
            this.ah = null;
            this.ak = null;
            this.ai = null;
            this.h = null;
        }
        get min() {
            return this.v;
        }
        set min(a) {
            this.v = a;
            this.g("Min");
        }
        get max() {
            return this.u;
        }
        set max(a) {
            this.u = a;
            this.g("Max");
        }
        get lowerBound() {
            return this.t;
        }
        set lowerBound(a) {
            this.t = a;
            this.g("LowerBound");
        }
        get upperBound() {
            return this.z;
        }
        set upperBound(a) {
            this.z = a;
            this.g("UpperBound");
        }
        get disabled() {
            return this.j;
        }
        set disabled(a) {
            this.j = a;
            this.g("Disabled");
        }
        get discreteTrack() {
            return this.k;
        }
        set discreteTrack(a) {
            this.k = a;
            this.g("DiscreteTrack");
        }
        get hideTooltip() {
            return this.n;
        }
        set hideTooltip(a) {
            this.n = a;
            this.g("HideTooltip");
        }
        get step() {
            return this.y;
        }
        set step(a) {
            this.y = a;
            this.g("Step");
        }
        get primaryTicks() {
            return this.w;
        }
        set primaryTicks(a) {
            this.w = a;
            this.g("PrimaryTicks");
        }
        get secondaryTicks() {
            return this.x;
        }
        set secondaryTicks(a) {
            this.x = a;
            this.g("SecondaryTicks");
        }
        get tickOrientation() {
            return this.aj;
        }
        set tickOrientation(a) {
            this.aj = a;
            this.g("TickOrientation");
        }
        get hidePrimaryLabels() {
            return this.l;
        }
        set hidePrimaryLabels(a) {
            this.l = a;
            this.g("HidePrimaryLabels");
        }
        get hideSecondaryLabels() {
            return this.m;
        }
        set hideSecondaryLabels(a) {
            this.m = a;
            this.g("HideSecondaryLabels");
        }
        get locale() {
            return this.ah;
        }
        set locale(a) {
            this.ah = a;
            this.g("Locale");
        }
        get valueFormat() {
            return this.ak;
        }
        set valueFormat(a) {
            this.ak = a;
            this.g("ValueFormat");
        }
        get tickLabelRotation() {
            return this.ai;
        }
        set tickLabelRotation(a) {
            this.ai = a;
            this.g("TickLabelRotation");
        }
        get valueFormatOptions() {
            return this.h;
        }
        set valueFormatOptions(a) {
            this.h = a;
            this.g("ValueFormatOptions");
        }
    }
    WebSliderBaseDescription.$t = /*@__PURE__*/ markType(WebSliderBaseDescription, 'WebSliderBaseDescription', Description.$);
    return WebSliderBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRangeSliderDescription = /*@__PURE__*/ (() => {
    class WebRangeSliderDescription extends WebSliderBaseDescription {
        get_type() {
            return "WebRangeSlider";
        }
        constructor() {
            super();
            this.aq = 0;
            this.ar = 0;
            this.aw = null;
            this.ax = null;
            this.av = null;
            this.au = null;
        }
        get lower() {
            return this.aq;
        }
        set lower(a) {
            this.aq = a;
            this.g("Lower");
        }
        get upper() {
            return this.ar;
        }
        set upper(a) {
            this.ar = a;
            this.g("Upper");
        }
        get thumbLabelLower() {
            return this.aw;
        }
        set thumbLabelLower(a) {
            this.aw = a;
            this.g("ThumbLabelLower");
        }
        get thumbLabelUpper() {
            return this.ax;
        }
        set thumbLabelUpper(a) {
            this.ax = a;
            this.g("ThumbLabelUpper");
        }
        get inputRef() {
            return this.av;
        }
        set inputRef(a) {
            this.av = a;
            this.g("InputRef");
        }
        get changeRef() {
            return this.au;
        }
        set changeRef(a) {
            this.au = a;
            this.g("ChangeRef");
        }
    }
    WebRangeSliderDescription.$t = /*@__PURE__*/ markType(WebRangeSliderDescription, 'WebRangeSliderDescription', WebSliderBaseDescription.$);
    return WebRangeSliderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRangeSliderValueDescription = /*@__PURE__*/ (() => {
    class WebRangeSliderValueDescription extends Description {
        get_type() {
            return "WebRangeSliderValue";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = 0;
            this.j = 0;
        }
        get lower() {
            return this.i;
        }
        set lower(a) {
            this.i = a;
            this.g("Lower");
        }
        get upper() {
            return this.j;
        }
        set upper(a) {
            this.j = a;
            this.g("Upper");
        }
    }
    WebRangeSliderValueDescription.$t = /*@__PURE__*/ markType(WebRangeSliderValueDescription, 'WebRangeSliderValueDescription', Description.$);
    WebRangeSliderValueDescription.__marshalByValue = true;
    WebRangeSliderValueDescription.__marshalByValueAlias = "RangeSliderValue";
    return WebRangeSliderValueDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRangeSliderValueDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRangeSliderValueDescriptionMetadata extends Base {
        static b(a) {
            if (WebRangeSliderValueDescriptionMetadata.a == null) {
                WebRangeSliderValueDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRangeSliderValueDescriptionMetadata.c(WebRangeSliderValueDescriptionMetadata.a);
            }
            if (a.k(WebRangeSliderValueDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRangeSliderValueDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RangeSliderValue");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Lower", "Number:double");
            a.item("Upper", "Number:double");
        }
        static d(a) {
            WebRangeSliderValueDescriptionMetadata.b(a);
            a.ae("WebRangeSliderValue", () => new WebRangeSliderValueDescription());
            a.ad("WebRangeSliderValue", WebRangeSliderValueDescriptionMetadata.a);
        }
    }
    WebRangeSliderValueDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRangeSliderValueDescriptionMetadata, 'WebRangeSliderValueDescriptionMetadata');
    WebRangeSliderValueDescriptionMetadata.a = null;
    return WebRangeSliderValueDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRangeSliderValueEventArgsDescription = /*@__PURE__*/ (() => {
    class WebRangeSliderValueEventArgsDescription extends Description {
        get_type() {
            return "WebRangeSliderValueEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebRangeSliderValueEventArgsDescription.$t = /*@__PURE__*/ markType(WebRangeSliderValueEventArgsDescription, 'WebRangeSliderValueEventArgsDescription', Description.$);
    return WebRangeSliderValueEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRangeSliderValueEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRangeSliderValueEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebRangeSliderValueEventArgsDescriptionMetadata.a == null) {
                WebRangeSliderValueEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRangeSliderValueEventArgsDescriptionMetadata.c(WebRangeSliderValueEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebRangeSliderValueEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRangeSliderValueEventArgsDescriptionMetadata.a);
            WebRangeSliderValueDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RangeSliderValueEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Detail", "ExportedType:WebRangeSliderValue");
        }
        static d(a) {
            WebRangeSliderValueEventArgsDescriptionMetadata.b(a);
            a.ae("WebRangeSliderValueEventArgs", () => new WebRangeSliderValueEventArgsDescription());
            a.ad("WebRangeSliderValueEventArgs", WebRangeSliderValueEventArgsDescriptionMetadata.a);
        }
    }
    WebRangeSliderValueEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRangeSliderValueEventArgsDescriptionMetadata, 'WebRangeSliderValueEventArgsDescriptionMetadata');
    WebRangeSliderValueEventArgsDescriptionMetadata.a = null;
    return WebRangeSliderValueEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSliderBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSliderBaseDescriptionMetadata extends Base {
        static b(a) {
            if (WebSliderBaseDescriptionMetadata.a == null) {
                WebSliderBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSliderBaseDescriptionMetadata.c(WebSliderBaseDescriptionMetadata.a);
            }
            if (a.k(WebSliderBaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSliderBaseDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:SliderBase");
            a.item("__tagNameWC", "String:igc-slider-base");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Min", "Number:double");
            a.item("Max", "Number:double");
            a.item("LowerBound", "Number:double");
            a.item("UpperBound", "Number:double");
            a.item("Disabled", "Boolean");
            a.item("DiscreteTrack", "Boolean");
            a.item("HideTooltip", "Boolean");
            a.item("Step", "Number:double");
            a.item("PrimaryTicks", "Number:double");
            a.item("SecondaryTicks", "Number:double");
            a.item("TickOrientation", "ExportedType:string:SliderBaseTickOrientation");
            a.item("TickOrientation@stringUnion", "WebComponents;React");
            a.item("TickOrientation@names", "Start;End;Mirror");
            a.item("HidePrimaryLabels", "Boolean");
            a.item("HideSecondaryLabels", "Boolean");
            a.item("Locale", "String");
            a.item("ValueFormat", "String");
            a.item("TickLabelRotation", "ExportedType:string:TickLabelRotation");
            a.item("TickLabelRotation@names", "Zero;Ninety;NegativeNinety");
            a.item("ValueFormatOptions", "ExportedType");
        }
        static d(a) {
            WebSliderBaseDescriptionMetadata.b(a);
            a.ae("WebSliderBase", () => new WebSliderBaseDescription());
            a.ad("WebSliderBase", WebSliderBaseDescriptionMetadata.a);
        }
    }
    WebSliderBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSliderBaseDescriptionMetadata, 'WebSliderBaseDescriptionMetadata');
    WebSliderBaseDescriptionMetadata.a = null;
    return WebSliderBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRangeSliderDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRangeSliderDescriptionMetadata extends Base {
        static b(a) {
            if (WebRangeSliderDescriptionMetadata.a == null) {
                WebRangeSliderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRangeSliderDescriptionMetadata.c(WebRangeSliderDescriptionMetadata.a);
            }
            if (a.k(WebRangeSliderDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRangeSliderDescriptionMetadata.a);
            WebRangeSliderValueEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebSliderBaseDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:RangeSlider");
            a.item("__tagNameWC", "String:igc-range-slider");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Lower", "Number:double");
            a.item("Upper", "Number:double");
            a.item("ThumbLabelLower", "String");
            a.item("ThumbLabelUpper", "String");
            a.item("InputRef", "EventRef::input");
            a.item("ChangeRef", "EventRef::change");
        }
        static d(a) {
            WebRangeSliderDescriptionMetadata.b(a);
            a.ae("WebRangeSlider", () => new WebRangeSliderDescription());
            a.ad("WebRangeSlider", WebRangeSliderDescriptionMetadata.a);
        }
    }
    WebRangeSliderDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRangeSliderDescriptionMetadata, 'WebRangeSliderDescriptionMetadata');
    WebRangeSliderDescriptionMetadata.a = null;
    return WebRangeSliderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSliderBaseDescriptionModule = /*@__PURE__*/ (() => {
    class WebSliderBaseDescriptionModule extends Base {
        static register(a) {
            WebSliderBaseDescriptionMetadata.d(a);
        }
    }
    WebSliderBaseDescriptionModule.$t = /*@__PURE__*/ markType(WebSliderBaseDescriptionModule, 'WebSliderBaseDescriptionModule');
    return WebSliderBaseDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRangeSliderDescriptionModule = /*@__PURE__*/ (() => {
    class WebRangeSliderDescriptionModule extends Base {
        static register(a) {
            WebSliderBaseDescriptionModule.register(a);
            WebRangeSliderValueEventArgsDescriptionMetadata.d(a);
            WebRangeSliderDescriptionMetadata.d(a);
        }
    }
    WebRangeSliderDescriptionModule.$t = /*@__PURE__*/ markType(WebRangeSliderDescriptionModule, 'WebRangeSliderDescriptionModule');
    return WebRangeSliderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRatingDescription = /*@__PURE__*/ (() => {
    class WebRatingDescription extends Description {
        get_type() {
            return "WebRating";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.t = 0;
            this.u = 0;
            this.ab = null;
            this.ad = null;
            this.v = 0;
            this.j = false;
            this.l = false;
            this.m = false;
            this.h = false;
            this.i = false;
            this.ac = null;
            this.k = false;
            this.z = null;
            this.aa = null;
        }
        get max() {
            return this.t;
        }
        set max(a) {
            this.t = a;
            this.g("Max");
        }
        get step() {
            return this.u;
        }
        set step(a) {
            this.u = a;
            this.g("Step");
        }
        get label() {
            return this.ab;
        }
        set label(a) {
            this.ab = a;
            this.g("Label");
        }
        get valueFormat() {
            return this.ad;
        }
        set valueFormat(a) {
            this.ad = a;
            this.g("ValueFormat");
        }
        get value() {
            return this.v;
        }
        set value(a) {
            this.v = a;
            this.g("Value");
        }
        get hoverPreview() {
            return this.j;
        }
        set hoverPreview(a) {
            this.j = a;
            this.g("HoverPreview");
        }
        get readOnly() {
            return this.l;
        }
        set readOnly(a) {
            this.l = a;
            this.g("ReadOnly");
        }
        get single() {
            return this.m;
        }
        set single(a) {
            this.m = a;
            this.g("Single");
        }
        get allowReset() {
            return this.h;
        }
        set allowReset(a) {
            this.h = a;
            this.g("AllowReset");
        }
        get disabled() {
            return this.i;
        }
        set disabled(a) {
            this.i = a;
            this.g("Disabled");
        }
        get name() {
            return this.ac;
        }
        set name(a) {
            this.ac = a;
            this.g("Name");
        }
        get invalid() {
            return this.k;
        }
        set invalid(a) {
            this.k = a;
            this.g("Invalid");
        }
        get changeRef() {
            return this.z;
        }
        set changeRef(a) {
            this.z = a;
            this.g("ChangeRef");
        }
        get hoverRef() {
            return this.aa;
        }
        set hoverRef(a) {
            this.aa = a;
            this.g("HoverRef");
        }
    }
    WebRatingDescription.$t = /*@__PURE__*/ markType(WebRatingDescription, 'WebRatingDescription', Description.$);
    return WebRatingDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRatingDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRatingDescriptionMetadata extends Base {
        static b(a) {
            if (WebRatingDescriptionMetadata.a == null) {
                WebRatingDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRatingDescriptionMetadata.c(WebRatingDescriptionMetadata.a);
            }
            if (a.k(WebRatingDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRatingDescriptionMetadata.a);
            WebNumberEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Rating");
            a.item("__tagNameWC", "String:igc-rating");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Max", "Number:double");
            a.item("Step", "Number:double");
            a.item("Label", "String");
            a.item("ValueFormat", "String");
            a.item("Value", "Number:double");
            a.item("HoverPreview", "Boolean");
            a.item("ReadOnly", "Boolean");
            a.item("Single", "Boolean");
            a.item("AllowReset", "Boolean");
            a.item("Disabled", "Boolean");
            a.item("Name", "String");
            a.item("Invalid", "Boolean");
            a.item("ChangeRef", "EventRef::change");
            a.item("HoverRef", "EventRef::hover");
        }
        static d(a) {
            WebRatingDescriptionMetadata.b(a);
            a.ae("WebRating", () => new WebRatingDescription());
            a.ad("WebRating", WebRatingDescriptionMetadata.a);
        }
    }
    WebRatingDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRatingDescriptionMetadata, 'WebRatingDescriptionMetadata');
    WebRatingDescriptionMetadata.a = null;
    return WebRatingDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRatingDescriptionModule = /*@__PURE__*/ (() => {
    class WebRatingDescriptionModule extends Base {
        static register(a) {
            WebRatingDescriptionMetadata.d(a);
        }
    }
    WebRatingDescriptionModule.$t = /*@__PURE__*/ markType(WebRatingDescriptionModule, 'WebRatingDescriptionModule');
    return WebRatingDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRatingSymbolDescription = /*@__PURE__*/ (() => {
    class WebRatingSymbolDescription extends Description {
        get_type() {
            return "WebRatingSymbol";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebRatingSymbolDescription.$t = /*@__PURE__*/ markType(WebRatingSymbolDescription, 'WebRatingSymbolDescription', Description.$);
    return WebRatingSymbolDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRatingSymbolDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRatingSymbolDescriptionMetadata extends Base {
        static b(a) {
            if (WebRatingSymbolDescriptionMetadata.a == null) {
                WebRatingSymbolDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRatingSymbolDescriptionMetadata.c(WebRatingSymbolDescriptionMetadata.a);
            }
            if (a.k(WebRatingSymbolDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRatingSymbolDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RatingSymbol");
            a.item("__tagNameWC", "String:igc-rating-symbol");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebRatingSymbolDescriptionMetadata.b(a);
            a.ae("WebRatingSymbol", () => new WebRatingSymbolDescription());
            a.ad("WebRatingSymbol", WebRatingSymbolDescriptionMetadata.a);
        }
    }
    WebRatingSymbolDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRatingSymbolDescriptionMetadata, 'WebRatingSymbolDescriptionMetadata');
    WebRatingSymbolDescriptionMetadata.a = null;
    return WebRatingSymbolDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRatingSymbolDescriptionModule = /*@__PURE__*/ (() => {
    class WebRatingSymbolDescriptionModule extends Base {
        static register(a) {
            WebRatingSymbolDescriptionMetadata.d(a);
        }
    }
    WebRatingSymbolDescriptionModule.$t = /*@__PURE__*/ markType(WebRatingSymbolDescriptionModule, 'WebRatingSymbolDescriptionModule');
    return WebRatingSymbolDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRippleDescription = /*@__PURE__*/ (() => {
    class WebRippleDescription extends Description {
        get_type() {
            return "WebRipple";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebRippleDescription.$t = /*@__PURE__*/ markType(WebRippleDescription, 'WebRippleDescription', Description.$);
    return WebRippleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRippleDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRippleDescriptionMetadata extends Base {
        static b(a) {
            if (WebRippleDescriptionMetadata.a == null) {
                WebRippleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRippleDescriptionMetadata.c(WebRippleDescriptionMetadata.a);
            }
            if (a.k(WebRippleDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRippleDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Ripple");
            a.item("__tagNameWC", "String:igc-ripple");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebRippleDescriptionMetadata.b(a);
            a.ae("WebRipple", () => new WebRippleDescription());
            a.ad("WebRipple", WebRippleDescriptionMetadata.a);
        }
    }
    WebRippleDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRippleDescriptionMetadata, 'WebRippleDescriptionMetadata');
    WebRippleDescriptionMetadata.a = null;
    return WebRippleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRippleDescriptionModule = /*@__PURE__*/ (() => {
    class WebRippleDescriptionModule extends Base {
        static register(a) {
            WebRippleDescriptionMetadata.d(a);
        }
    }
    WebRippleDescriptionModule.$t = /*@__PURE__*/ markType(WebRippleDescriptionModule, 'WebRippleDescriptionModule');
    return WebRippleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowSelectorTemplateContextDescription = /*@__PURE__*/ (() => {
    class WebRowSelectorTemplateContextDescription extends Description {
        get_type() {
            return "WebRowSelectorTemplateContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get implicit() {
            return this.h;
        }
        set implicit(a) {
            this.h = a;
            this.g("Implicit");
        }
    }
    WebRowSelectorTemplateContextDescription.$t = /*@__PURE__*/ markType(WebRowSelectorTemplateContextDescription, 'WebRowSelectorTemplateContextDescription', Description.$);
    WebRowSelectorTemplateContextDescription.__marshalByValue = true;
    WebRowSelectorTemplateContextDescription.__marshalByValueAlias = "RowSelectorTemplateContext";
    return WebRowSelectorTemplateContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowSelectorTemplateDetailsDescription = /*@__PURE__*/ (() => {
    class WebRowSelectorTemplateDetailsDescription extends Description {
        get_type() {
            return "WebRowSelectorTemplateDetails";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = 0;
            this.m = null;
            this.l = null;
            this.h = false;
        }
        get index() {
            return this.j;
        }
        set index(a) {
            this.j = a;
            this.g("Index");
        }
        get rowID() {
            return this.m;
        }
        set rowID(a) {
            this.m = a;
            this.g("RowID");
        }
        get key() {
            return this.l;
        }
        set key(a) {
            this.l = a;
            this.g("Key");
        }
        get selected() {
            return this.h;
        }
        set selected(a) {
            this.h = a;
            this.g("Selected");
        }
    }
    WebRowSelectorTemplateDetailsDescription.$t = /*@__PURE__*/ markType(WebRowSelectorTemplateDetailsDescription, 'WebRowSelectorTemplateDetailsDescription', Description.$);
    return WebRowSelectorTemplateDetailsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowSelectorTemplateDetailsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowSelectorTemplateDetailsDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowSelectorTemplateDetailsDescriptionMetadata.a == null) {
                WebRowSelectorTemplateDetailsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowSelectorTemplateDetailsDescriptionMetadata.c(WebRowSelectorTemplateDetailsDescriptionMetadata.a);
            }
            if (a.k(WebRowSelectorTemplateDetailsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowSelectorTemplateDetailsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowSelectorTemplateDetails");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
            a.item("Index", "Number:double");
            a.item("RowID", "Unknown");
            a.item("Key", "Unknown");
            a.item("Selected", "Boolean");
        }
        static d(a) {
            WebRowSelectorTemplateDetailsDescriptionMetadata.b(a);
            a.ae("WebRowSelectorTemplateDetails", () => new WebRowSelectorTemplateDetailsDescription());
            a.ad("WebRowSelectorTemplateDetails", WebRowSelectorTemplateDetailsDescriptionMetadata.a);
        }
    }
    WebRowSelectorTemplateDetailsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowSelectorTemplateDetailsDescriptionMetadata, 'WebRowSelectorTemplateDetailsDescriptionMetadata');
    WebRowSelectorTemplateDetailsDescriptionMetadata.a = null;
    return WebRowSelectorTemplateDetailsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebRowSelectorTemplateContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebRowSelectorTemplateContextDescriptionMetadata extends Base {
        static b(a) {
            if (WebRowSelectorTemplateContextDescriptionMetadata.a == null) {
                WebRowSelectorTemplateContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebRowSelectorTemplateContextDescriptionMetadata.c(WebRowSelectorTemplateContextDescriptionMetadata.a);
            }
            if (a.k(WebRowSelectorTemplateContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebRowSelectorTemplateContextDescriptionMetadata.a);
            WebRowSelectorTemplateDetailsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:RowSelectorTemplateContext");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Implicit", "ExportedType:WebRowSelectorTemplateDetails");
        }
        static d(a) {
            WebRowSelectorTemplateContextDescriptionMetadata.b(a);
            a.ae("WebRowSelectorTemplateContext", () => new WebRowSelectorTemplateContextDescription());
            a.ad("WebRowSelectorTemplateContext", WebRowSelectorTemplateContextDescriptionMetadata.a);
        }
    }
    WebRowSelectorTemplateContextDescriptionMetadata.$t = /*@__PURE__*/ markType(WebRowSelectorTemplateContextDescriptionMetadata, 'WebRowSelectorTemplateContextDescriptionMetadata');
    WebRowSelectorTemplateContextDescriptionMetadata.a = null;
    return WebRowSelectorTemplateContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSearchInfoDescription = /*@__PURE__*/ (() => {
    class WebSearchInfoDescription extends WebBaseSearchInfoDescription {
        get_type() {
            return "WebSearchInfo";
        }
        constructor() {
            super();
            this.u = null;
            this.s = 0;
        }
        get matchInfoCacheRef() {
            return this.u;
        }
        set matchInfoCacheRef(a) {
            this.u = a;
            this.g("MatchInfoCacheRef");
        }
        get activeMatchIndex() {
            return this.s;
        }
        set activeMatchIndex(a) {
            this.s = a;
            this.g("ActiveMatchIndex");
        }
    }
    WebSearchInfoDescription.$t = /*@__PURE__*/ markType(WebSearchInfoDescription, 'WebSearchInfoDescription', WebBaseSearchInfoDescription.$);
    return WebSearchInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSearchInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSearchInfoDescriptionMetadata extends Base {
        static b(a) {
            if (WebSearchInfoDescriptionMetadata.a == null) {
                WebSearchInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSearchInfoDescriptionMetadata.c(WebSearchInfoDescriptionMetadata.a);
            }
            if (a.k(WebSearchInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSearchInfoDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseSearchInfoDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:SearchInfo");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("MatchInfoCacheRef", "(w:MatchInfoCache,wf:MatchInfoCache)DataRef:object");
            a.item("ActiveMatchIndex", "Number:double");
        }
        static d(a) {
            WebSearchInfoDescriptionMetadata.b(a);
            a.ae("WebSearchInfo", () => new WebSearchInfoDescription());
            a.ad("WebSearchInfo", WebSearchInfoDescriptionMetadata.a);
        }
    }
    WebSearchInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSearchInfoDescriptionMetadata, 'WebSearchInfoDescriptionMetadata');
    WebSearchInfoDescriptionMetadata.a = null;
    return WebSearchInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSelectDescription = /*@__PURE__*/ (() => {
    class WebSelectDescription extends WebBaseComboBoxLikeDescription {
        get_type() {
            return "WebSelect";
        }
        constructor() {
            super();
            this.ao = null;
            this.t = false;
            this.q = false;
            this.aa = 0;
            this.ah = null;
            this.al = null;
            this.am = null;
            this.an = null;
            this.r = false;
            this.u = false;
            this.ai = null;
            this.s = false;
            this.ad = null;
            this.ag = null;
            this.ac = null;
            this.ak = null;
            this.aj = null;
            this.af = null;
            this.ae = null;
        }
        get value() {
            return this.ao;
        }
        set value(a) {
            this.ao = a;
            this.g("Value");
        }
        get outlined() {
            return this.t;
        }
        set outlined(a) {
            this.t = a;
            this.g("Outlined");
        }
        get autofocus() {
            return this.q;
        }
        set autofocus(a) {
            this.q = a;
            this.g("Autofocus");
        }
        get distance() {
            return this.aa;
        }
        set distance(a) {
            this.aa = a;
            this.g("Distance");
        }
        get label() {
            return this.ah;
        }
        set label(a) {
            this.ah = a;
            this.g("Label");
        }
        get placeholder() {
            return this.al;
        }
        set placeholder(a) {
            this.al = a;
            this.g("Placeholder");
        }
        get placement() {
            return this.am;
        }
        set placement(a) {
            this.am = a;
            this.g("Placement");
        }
        get scrollStrategy() {
            return this.an;
        }
        set scrollStrategy(a) {
            this.an = a;
            this.g("ScrollStrategy");
        }
        get disabled() {
            return this.r;
        }
        set disabled(a) {
            this.r = a;
            this.g("Disabled");
        }
        get required() {
            return this.u;
        }
        set required(a) {
            this.u = a;
            this.g("Required");
        }
        get name() {
            return this.ai;
        }
        set name(a) {
            this.ai = a;
            this.g("Name");
        }
        get invalid() {
            return this.s;
        }
        set invalid(a) {
            this.s = a;
            this.g("Invalid");
        }
        get changeRef() {
            return this.ad;
        }
        set changeRef(a) {
            this.ad = a;
            this.g("ChangeRef");
        }
        get focusRef() {
            return this.ag;
        }
        set focusRef(a) {
            this.ag = a;
            this.g("FocusRef");
        }
        get blurRef() {
            return this.ac;
        }
        set blurRef(a) {
            this.ac = a;
            this.g("BlurRef");
        }
        get openingRef() {
            return this.ak;
        }
        set openingRef(a) {
            this.ak = a;
            this.g("OpeningRef");
        }
        get openedRef() {
            return this.aj;
        }
        set openedRef(a) {
            this.aj = a;
            this.g("OpenedRef");
        }
        get closingRef() {
            return this.af;
        }
        set closingRef(a) {
            this.af = a;
            this.g("ClosingRef");
        }
        get closedRef() {
            return this.ae;
        }
        set closedRef(a) {
            this.ae = a;
            this.g("ClosedRef");
        }
    }
    WebSelectDescription.$t = /*@__PURE__*/ markType(WebSelectDescription, 'WebSelectDescription', WebBaseComboBoxLikeDescription.$);
    return WebSelectDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSelectItemDescription = /*@__PURE__*/ (() => {
    class WebSelectItemDescription extends WebBaseOptionLikeDescription {
        get_type() {
            return "WebSelectItem";
        }
        constructor() {
            super();
        }
    }
    WebSelectItemDescription.$t = /*@__PURE__*/ markType(WebSelectItemDescription, 'WebSelectItemDescription', WebBaseOptionLikeDescription.$);
    return WebSelectItemDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSelectItemDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSelectItemDescriptionMetadata extends Base {
        static b(a) {
            if (WebSelectItemDescriptionMetadata.a == null) {
                WebSelectItemDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSelectItemDescriptionMetadata.c(WebSelectItemDescriptionMetadata.a);
            }
            if (a.k(WebSelectItemDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSelectItemDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseOptionLikeDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:SelectItem");
            a.item("__tagNameWC", "String:igc-select-item");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebSelectItemDescriptionMetadata.b(a);
            a.ae("WebSelectItem", () => new WebSelectItemDescription());
            a.ad("WebSelectItem", WebSelectItemDescriptionMetadata.a);
        }
    }
    WebSelectItemDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSelectItemDescriptionMetadata, 'WebSelectItemDescriptionMetadata');
    WebSelectItemDescriptionMetadata.a = null;
    return WebSelectItemDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSelectItemComponentEventArgsDescription = /*@__PURE__*/ (() => {
    class WebSelectItemComponentEventArgsDescription extends Description {
        get_type() {
            return "WebSelectItemComponentEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebSelectItemComponentEventArgsDescription.$t = /*@__PURE__*/ markType(WebSelectItemComponentEventArgsDescription, 'WebSelectItemComponentEventArgsDescription', Description.$);
    WebSelectItemComponentEventArgsDescription.__marshalByValue = true;
    WebSelectItemComponentEventArgsDescription.__marshalByValueAlias = "SelectItemComponentEventArgs";
    return WebSelectItemComponentEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSelectItemComponentEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSelectItemComponentEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebSelectItemComponentEventArgsDescriptionMetadata.a == null) {
                WebSelectItemComponentEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSelectItemComponentEventArgsDescriptionMetadata.c(WebSelectItemComponentEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebSelectItemComponentEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSelectItemComponentEventArgsDescriptionMetadata.a);
            WebSelectItemDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:SelectItemComponentEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebSelectItem");
        }
        static d(a) {
            WebSelectItemComponentEventArgsDescriptionMetadata.b(a);
            a.ae("WebSelectItemComponentEventArgs", () => new WebSelectItemComponentEventArgsDescription());
            a.ad("WebSelectItemComponentEventArgs", WebSelectItemComponentEventArgsDescriptionMetadata.a);
        }
    }
    WebSelectItemComponentEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSelectItemComponentEventArgsDescriptionMetadata, 'WebSelectItemComponentEventArgsDescriptionMetadata');
    WebSelectItemComponentEventArgsDescriptionMetadata.a = null;
    return WebSelectItemComponentEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSelectDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSelectDescriptionMetadata extends Base {
        static b(a) {
            if (WebSelectDescriptionMetadata.a == null) {
                WebSelectDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSelectDescriptionMetadata.c(WebSelectDescriptionMetadata.a);
            }
            if (a.k(WebSelectDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSelectDescriptionMetadata.a);
            WebSelectItemComponentEventArgsDescriptionMetadata.d(a);
            VoidEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseComboBoxLikeDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:Select");
            a.item("__tagNameWC", "String:igc-select");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Value", "String");
            a.item("Outlined", "Boolean");
            a.item("Autofocus", "Boolean");
            a.item("Distance", "Number:double");
            a.item("Label", "String");
            a.item("Placeholder", "String");
            a.item("Placement", "ExportedType:string:DropdownPlacement");
            a.item("Placement@names", "Top;TopStart;TopEnd;Bottom;BottomStart;BottomEnd;Right;RightStart;RightEnd;Left;LeftStart;LeftEnd");
            a.item("ScrollStrategy", "ExportedType:string:SelectScrollStrategy");
            a.item("ScrollStrategy@stringUnion", "WebComponents;React");
            a.item("ScrollStrategy@names", "Scroll;Block;Close");
            a.item("Disabled", "Boolean");
            a.item("Required", "Boolean");
            a.item("Name", "String");
            a.item("Invalid", "Boolean");
            a.item("ChangeRef", "EventRef::change");
            a.item("FocusRef", "EventRef::focus");
            a.item("BlurRef", "EventRef::blur");
            a.item("OpeningRef", "EventRef::opening");
            a.item("OpenedRef", "EventRef::opened");
            a.item("ClosingRef", "EventRef::closing");
            a.item("ClosedRef", "EventRef::closed");
        }
        static d(a) {
            WebSelectDescriptionMetadata.b(a);
            a.ae("WebSelect", () => new WebSelectDescription());
            a.ad("WebSelect", WebSelectDescriptionMetadata.a);
        }
    }
    WebSelectDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSelectDescriptionMetadata, 'WebSelectDescriptionMetadata');
    WebSelectDescriptionMetadata.a = null;
    return WebSelectDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSelectGroupDescription = /*@__PURE__*/ (() => {
    class WebSelectGroupDescription extends Description {
        get_type() {
            return "WebSelectGroup";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = false;
        }
        get items() {
            return this.h;
        }
        set items(a) {
            this.h = a;
            this.g("Items");
        }
        get disabled() {
            return this.j;
        }
        set disabled(a) {
            this.j = a;
            this.g("Disabled");
        }
    }
    WebSelectGroupDescription.$t = /*@__PURE__*/ markType(WebSelectGroupDescription, 'WebSelectGroupDescription', Description.$);
    return WebSelectGroupDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSelectGroupDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSelectGroupDescriptionMetadata extends Base {
        static b(a) {
            if (WebSelectGroupDescriptionMetadata.a == null) {
                WebSelectGroupDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSelectGroupDescriptionMetadata.c(WebSelectGroupDescriptionMetadata.a);
            }
            if (a.k(WebSelectGroupDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSelectGroupDescriptionMetadata.a);
            WebSelectItemDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:SelectGroup");
            a.item("__tagNameWC", "String:igc-select-group");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Items", "Array:WebSelectItemDescription:SelectItem");
            a.item("Disabled", "Boolean");
        }
        static d(a) {
            WebSelectGroupDescriptionMetadata.b(a);
            a.ae("WebSelectGroup", () => new WebSelectGroupDescription());
            a.ad("WebSelectGroup", WebSelectGroupDescriptionMetadata.a);
        }
    }
    WebSelectGroupDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSelectGroupDescriptionMetadata, 'WebSelectGroupDescriptionMetadata');
    WebSelectGroupDescriptionMetadata.a = null;
    return WebSelectGroupDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSelectItemDescriptionModule = /*@__PURE__*/ (() => {
    class WebSelectItemDescriptionModule extends Base {
        static register(a) {
            WebBaseOptionLikeDescriptionModule.register(a);
            WebSelectItemDescriptionMetadata.d(a);
        }
    }
    WebSelectItemDescriptionModule.$t = /*@__PURE__*/ markType(WebSelectItemDescriptionModule, 'WebSelectItemDescriptionModule');
    return WebSelectItemDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSelectGroupDescriptionModule = /*@__PURE__*/ (() => {
    class WebSelectGroupDescriptionModule extends Base {
        static register(a) {
            WebSelectItemDescriptionModule.register(a);
            WebSelectGroupDescriptionMetadata.d(a);
        }
    }
    WebSelectGroupDescriptionModule.$t = /*@__PURE__*/ markType(WebSelectGroupDescriptionModule, 'WebSelectGroupDescriptionModule');
    return WebSelectGroupDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSelectHeaderDescription = /*@__PURE__*/ (() => {
    class WebSelectHeaderDescription extends Description {
        get_type() {
            return "WebSelectHeader";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebSelectHeaderDescription.$t = /*@__PURE__*/ markType(WebSelectHeaderDescription, 'WebSelectHeaderDescription', Description.$);
    return WebSelectHeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSelectHeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSelectHeaderDescriptionMetadata extends Base {
        static b(a) {
            if (WebSelectHeaderDescriptionMetadata.a == null) {
                WebSelectHeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSelectHeaderDescriptionMetadata.c(WebSelectHeaderDescriptionMetadata.a);
            }
            if (a.k(WebSelectHeaderDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSelectHeaderDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:SelectHeader");
            a.item("__tagNameWC", "String:igc-select-header");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebSelectHeaderDescriptionMetadata.b(a);
            a.ae("WebSelectHeader", () => new WebSelectHeaderDescription());
            a.ad("WebSelectHeader", WebSelectHeaderDescriptionMetadata.a);
        }
    }
    WebSelectHeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSelectHeaderDescriptionMetadata, 'WebSelectHeaderDescriptionMetadata');
    WebSelectHeaderDescriptionMetadata.a = null;
    return WebSelectHeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSelectHeaderDescriptionModule = /*@__PURE__*/ (() => {
    class WebSelectHeaderDescriptionModule extends Base {
        static register(a) {
            WebSelectHeaderDescriptionMetadata.d(a);
        }
    }
    WebSelectHeaderDescriptionModule.$t = /*@__PURE__*/ markType(WebSelectHeaderDescriptionModule, 'WebSelectHeaderDescriptionModule');
    return WebSelectHeaderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSelectDescriptionModule = /*@__PURE__*/ (() => {
    class WebSelectDescriptionModule extends Base {
        static register(a) {
            WebBaseComboBoxLikeDescriptionModule.register(a);
            WebIconDescriptionModule.register(a);
            WebInputDescriptionModule.register(a);
            WebSelectGroupDescriptionModule.register(a);
            WebSelectHeaderDescriptionModule.register(a);
            WebSelectItemDescriptionModule.register(a);
            WebSelectItemComponentEventArgsDescriptionMetadata.d(a);
            WebSelectDescriptionMetadata.d(a);
        }
    }
    WebSelectDescriptionModule.$t = /*@__PURE__*/ markType(WebSelectDescriptionModule, 'WebSelectDescriptionModule');
    return WebSelectDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSliderDescription = /*@__PURE__*/ (() => {
    class WebSliderDescription extends WebSliderBaseDescription {
        get_type() {
            return "WebSlider";
        }
        constructor() {
            super();
            this.as = 0;
            this.aw = null;
            this.aq = false;
            this.av = null;
            this.au = null;
        }
        get value() {
            return this.as;
        }
        set value(a) {
            this.as = a;
            this.g("Value");
        }
        get name() {
            return this.aw;
        }
        set name(a) {
            this.aw = a;
            this.g("Name");
        }
        get invalid() {
            return this.aq;
        }
        set invalid(a) {
            this.aq = a;
            this.g("Invalid");
        }
        get inputRef() {
            return this.av;
        }
        set inputRef(a) {
            this.av = a;
            this.g("InputRef");
        }
        get changeRef() {
            return this.au;
        }
        set changeRef(a) {
            this.au = a;
            this.g("ChangeRef");
        }
    }
    WebSliderDescription.$t = /*@__PURE__*/ markType(WebSliderDescription, 'WebSliderDescription', WebSliderBaseDescription.$);
    return WebSliderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSliderDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSliderDescriptionMetadata extends Base {
        static b(a) {
            if (WebSliderDescriptionMetadata.a == null) {
                WebSliderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSliderDescriptionMetadata.c(WebSliderDescriptionMetadata.a);
            }
            if (a.k(WebSliderDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSliderDescriptionMetadata.a);
            WebNumberEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebSliderBaseDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:Slider");
            a.item("__tagNameWC", "String:igc-slider");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Value", "Number:double");
            a.item("Name", "String");
            a.item("Invalid", "Boolean");
            a.item("InputRef", "EventRef::input");
            a.item("ChangeRef", "EventRef::change");
        }
        static d(a) {
            WebSliderDescriptionMetadata.b(a);
            a.ae("WebSlider", () => new WebSliderDescription());
            a.ad("WebSlider", WebSliderDescriptionMetadata.a);
        }
    }
    WebSliderDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSliderDescriptionMetadata, 'WebSliderDescriptionMetadata');
    WebSliderDescriptionMetadata.a = null;
    return WebSliderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSliderLabelDescription = /*@__PURE__*/ (() => {
    class WebSliderLabelDescription extends Description {
        get_type() {
            return "WebSliderLabel";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebSliderLabelDescription.$t = /*@__PURE__*/ markType(WebSliderLabelDescription, 'WebSliderLabelDescription', Description.$);
    return WebSliderLabelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSliderLabelDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSliderLabelDescriptionMetadata extends Base {
        static b(a) {
            if (WebSliderLabelDescriptionMetadata.a == null) {
                WebSliderLabelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSliderLabelDescriptionMetadata.c(WebSliderLabelDescriptionMetadata.a);
            }
            if (a.k(WebSliderLabelDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSliderLabelDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:SliderLabel");
            a.item("__tagNameWC", "String:igc-slider-label");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebSliderLabelDescriptionMetadata.b(a);
            a.ae("WebSliderLabel", () => new WebSliderLabelDescription());
            a.ad("WebSliderLabel", WebSliderLabelDescriptionMetadata.a);
        }
    }
    WebSliderLabelDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSliderLabelDescriptionMetadata, 'WebSliderLabelDescriptionMetadata');
    WebSliderLabelDescriptionMetadata.a = null;
    return WebSliderLabelDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSliderLabelDescriptionModule = /*@__PURE__*/ (() => {
    class WebSliderLabelDescriptionModule extends Base {
        static register(a) {
            WebSliderLabelDescriptionMetadata.d(a);
        }
    }
    WebSliderLabelDescriptionModule.$t = /*@__PURE__*/ markType(WebSliderLabelDescriptionModule, 'WebSliderLabelDescriptionModule');
    return WebSliderLabelDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSliderDescriptionModule = /*@__PURE__*/ (() => {
    class WebSliderDescriptionModule extends Base {
        static register(a) {
            WebSliderBaseDescriptionModule.register(a);
            WebSliderDescriptionMetadata.d(a);
        }
    }
    WebSliderDescriptionModule.$t = /*@__PURE__*/ markType(WebSliderDescriptionModule, 'WebSliderDescriptionModule');
    return WebSliderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSnackbarDescription = /*@__PURE__*/ (() => {
    class WebSnackbarDescription extends WebBaseAlertLikeDescription {
        get_type() {
            return "WebSnackbar";
        }
        constructor() {
            super();
            this.r = null;
            this.q = null;
        }
        get actionText() {
            return this.r;
        }
        set actionText(a) {
            this.r = a;
            this.g("ActionText");
        }
        get actionRef() {
            return this.q;
        }
        set actionRef(a) {
            this.q = a;
            this.g("ActionRef");
        }
    }
    WebSnackbarDescription.$t = /*@__PURE__*/ markType(WebSnackbarDescription, 'WebSnackbarDescription', WebBaseAlertLikeDescription.$);
    return WebSnackbarDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSnackbarDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSnackbarDescriptionMetadata extends Base {
        static b(a) {
            if (WebSnackbarDescriptionMetadata.a == null) {
                WebSnackbarDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSnackbarDescriptionMetadata.c(WebSnackbarDescriptionMetadata.a);
            }
            if (a.k(WebSnackbarDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSnackbarDescriptionMetadata.a);
            VoidEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            WebBaseAlertLikeDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:Snackbar");
            a.item("__tagNameWC", "String:igc-snackbar");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("ActionText", "String");
            a.item("ActionRef", "EventRef::action");
        }
        static d(a) {
            WebSnackbarDescriptionMetadata.b(a);
            a.ae("WebSnackbar", () => new WebSnackbarDescription());
            a.ad("WebSnackbar", WebSnackbarDescriptionMetadata.a);
        }
    }
    WebSnackbarDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSnackbarDescriptionMetadata, 'WebSnackbarDescriptionMetadata');
    WebSnackbarDescriptionMetadata.a = null;
    return WebSnackbarDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSnackbarDescriptionModule = /*@__PURE__*/ (() => {
    class WebSnackbarDescriptionModule extends Base {
        static register(a) {
            WebBaseAlertLikeDescriptionModule.register(a);
            WebSnackbarDescriptionMetadata.d(a);
        }
    }
    WebSnackbarDescriptionModule.$t = /*@__PURE__*/ markType(WebSnackbarDescriptionModule, 'WebSnackbarDescriptionModule');
    return WebSnackbarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebStepDescription = /*@__PURE__*/ (() => {
    class WebStepDescription extends Description {
        get_type() {
            return "WebStep";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = false;
            this.h = false;
            this.l = false;
            this.j = false;
            this.i = false;
        }
        get invalid() {
            return this.k;
        }
        set invalid(a) {
            this.k = a;
            this.g("Invalid");
        }
        get active() {
            return this.h;
        }
        set active(a) {
            this.h = a;
            this.g("Active");
        }
        get optional() {
            return this.l;
        }
        set optional(a) {
            this.l = a;
            this.g("Optional");
        }
        get disabled() {
            return this.j;
        }
        set disabled(a) {
            this.j = a;
            this.g("Disabled");
        }
        get complete() {
            return this.i;
        }
        set complete(a) {
            this.i = a;
            this.g("Complete");
        }
    }
    WebStepDescription.$t = /*@__PURE__*/ markType(WebStepDescription, 'WebStepDescription', Description.$);
    return WebStepDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebStepDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebStepDescriptionMetadata extends Base {
        static b(a) {
            if (WebStepDescriptionMetadata.a == null) {
                WebStepDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebStepDescriptionMetadata.c(WebStepDescriptionMetadata.a);
            }
            if (a.k(WebStepDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebStepDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Step");
            a.item("__tagNameWC", "String:igc-step");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Invalid", "Boolean");
            a.item("Active", "Boolean");
            a.item("Optional", "Boolean");
            a.item("Disabled", "Boolean");
            a.item("Complete", "Boolean");
        }
        static d(a) {
            WebStepDescriptionMetadata.b(a);
            a.ae("WebStep", () => new WebStepDescription());
            a.ad("WebStep", WebStepDescriptionMetadata.a);
        }
    }
    WebStepDescriptionMetadata.$t = /*@__PURE__*/ markType(WebStepDescriptionMetadata, 'WebStepDescriptionMetadata');
    WebStepDescriptionMetadata.a = null;
    return WebStepDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebStepDescriptionModule = /*@__PURE__*/ (() => {
    class WebStepDescriptionModule extends Base {
        static register(a) {
            WebStepDescriptionMetadata.d(a);
        }
    }
    WebStepDescriptionModule.$t = /*@__PURE__*/ markType(WebStepDescriptionModule, 'WebStepDescriptionModule');
    return WebStepDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebStepperDescription = /*@__PURE__*/ (() => {
    class WebStepperDescription extends Description {
        get_type() {
            return "WebStepper";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.s = null;
            this.t = null;
            this.k = false;
            this.j = false;
            this.v = null;
            this.r = null;
            this.n = 0;
            this.u = null;
            this.q = null;
            this.p = null;
        }
        get steps() {
            return this.h;
        }
        set steps(a) {
            this.h = a;
            this.g("Steps");
        }
        get orientation() {
            return this.s;
        }
        set orientation(a) {
            this.s = a;
            this.g("Orientation");
        }
        get stepType() {
            return this.t;
        }
        set stepType(a) {
            this.t = a;
            this.g("StepType");
        }
        get linear() {
            return this.k;
        }
        set linear(a) {
            this.k = a;
            this.g("Linear");
        }
        get contentTop() {
            return this.j;
        }
        set contentTop(a) {
            this.j = a;
            this.g("ContentTop");
        }
        get verticalAnimation() {
            return this.v;
        }
        set verticalAnimation(a) {
            this.v = a;
            this.g("VerticalAnimation");
        }
        get horizontalAnimation() {
            return this.r;
        }
        set horizontalAnimation(a) {
            this.r = a;
            this.g("HorizontalAnimation");
        }
        get animationDuration() {
            return this.n;
        }
        set animationDuration(a) {
            this.n = a;
            this.g("AnimationDuration");
        }
        get titlePosition() {
            return this.u;
        }
        set titlePosition(a) {
            this.u = a;
            this.g("TitlePosition");
        }
        get activeStepChangingRef() {
            return this.q;
        }
        set activeStepChangingRef(a) {
            this.q = a;
            this.g("ActiveStepChangingRef");
        }
        get activeStepChangedRef() {
            return this.p;
        }
        set activeStepChangedRef(a) {
            this.p = a;
            this.g("ActiveStepChangedRef");
        }
    }
    WebStepperDescription.$t = /*@__PURE__*/ markType(WebStepperDescription, 'WebStepperDescription', Description.$);
    return WebStepperDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebStepperDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebStepperDescriptionMetadata extends Base {
        static b(a) {
            if (WebStepperDescriptionMetadata.a == null) {
                WebStepperDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebStepperDescriptionMetadata.c(WebStepperDescriptionMetadata.a);
            }
            if (a.k(WebStepperDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebStepperDescriptionMetadata.a);
            WebStepDescriptionMetadata.d(a);
            WebActiveStepChangingArgsEventArgsDescriptionMetadata.d(a);
            WebActiveStepChangedArgsEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Stepper");
            a.item("__tagNameWC", "String:igc-stepper");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Steps", "Array:WebStepDescription:Step");
            a.item("Orientation", "ExportedType:string:StepperOrientation");
            a.item("Orientation@stringUnion", "WebComponents;React");
            a.item("Orientation@names", "Horizontal;Vertical");
            a.item("StepType", "ExportedType:string:StepperStepType");
            a.item("StepType@stringUnion", "WebComponents;React");
            a.item("StepType@names", "Indicator;Title;Full");
            a.item("Linear", "Boolean");
            a.item("ContentTop", "Boolean");
            a.item("VerticalAnimation", "ExportedType:string:StepperVerticalAnimation");
            a.item("VerticalAnimation@stringUnion", "WebComponents;React");
            a.item("VerticalAnimation@names", "None;Grow;Fade");
            a.item("HorizontalAnimation", "ExportedType:string:StepperHorizontalAnimation");
            a.item("HorizontalAnimation@stringUnion", "WebComponents;React");
            a.item("HorizontalAnimation@names", "None;Fade;Slide");
            a.item("AnimationDuration", "Number:double");
            a.item("TitlePosition", "ExportedType:string:StepperTitlePosition");
            a.item("TitlePosition@stringUnion", "WebComponents;React");
            a.item("TitlePosition@names", "Bottom;Top;Start;End");
            a.item("ActiveStepChangingRef", "EventRef::activeStepChanging");
            a.item("ActiveStepChangedRef", "EventRef::activeStepChanged");
        }
        static d(a) {
            WebStepperDescriptionMetadata.b(a);
            a.ae("WebStepper", () => new WebStepperDescription());
            a.ad("WebStepper", WebStepperDescriptionMetadata.a);
        }
    }
    WebStepperDescriptionMetadata.$t = /*@__PURE__*/ markType(WebStepperDescriptionMetadata, 'WebStepperDescriptionMetadata');
    WebStepperDescriptionMetadata.a = null;
    return WebStepperDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebStepperDescriptionModule = /*@__PURE__*/ (() => {
    class WebStepperDescriptionModule extends Base {
        static register(a) {
            WebActiveStepChangingArgsEventArgsDescriptionMetadata.d(a);
            WebActiveStepChangedArgsEventArgsDescriptionMetadata.d(a);
            WebStepDescriptionModule.register(a);
            WebStepperDescriptionMetadata.d(a);
        }
    }
    WebStepperDescriptionModule.$t = /*@__PURE__*/ markType(WebStepperDescriptionModule, 'WebStepperDescriptionModule');
    return WebStepperDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebStringFilteringOperandDescription = /*@__PURE__*/ (() => {
    class WebStringFilteringOperandDescription extends WebFilteringOperandDescription {
        get_type() {
            return "WebStringFilteringOperand";
        }
        constructor() {
            super();
        }
    }
    WebStringFilteringOperandDescription.$t = /*@__PURE__*/ markType(WebStringFilteringOperandDescription, 'WebStringFilteringOperandDescription', WebFilteringOperandDescription.$);
    return WebStringFilteringOperandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebStringFilteringOperandDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebStringFilteringOperandDescriptionMetadata extends Base {
        static b(a) {
            if (WebStringFilteringOperandDescriptionMetadata.a == null) {
                WebStringFilteringOperandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebStringFilteringOperandDescriptionMetadata.c(WebStringFilteringOperandDescriptionMetadata.a);
            }
            if (a.k(WebStringFilteringOperandDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebStringFilteringOperandDescriptionMetadata.a);
        }
        static c(a) {
            WebFilteringOperandDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:StringFilteringOperand");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebStringFilteringOperandDescriptionMetadata.b(a);
            a.ae("WebStringFilteringOperand", () => new WebStringFilteringOperandDescription());
            a.ad("WebStringFilteringOperand", WebStringFilteringOperandDescriptionMetadata.a);
        }
    }
    WebStringFilteringOperandDescriptionMetadata.$t = /*@__PURE__*/ markType(WebStringFilteringOperandDescriptionMetadata, 'WebStringFilteringOperandDescriptionMetadata');
    WebStringFilteringOperandDescriptionMetadata.a = null;
    return WebStringFilteringOperandDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSummaryExpressionDescription = /*@__PURE__*/ (() => {
    class WebSummaryExpressionDescription extends Description {
        get_type() {
            return "WebSummaryExpression";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.i = null;
        }
        get fieldName() {
            return this.l;
        }
        set fieldName(a) {
            this.l = a;
            this.g("FieldName");
        }
        get customSummary() {
            return this.i;
        }
        set customSummary(a) {
            this.i = a;
            this.g("CustomSummary");
        }
    }
    WebSummaryExpressionDescription.$t = /*@__PURE__*/ markType(WebSummaryExpressionDescription, 'WebSummaryExpressionDescription', Description.$);
    WebSummaryExpressionDescription.__marshalByValue = true;
    WebSummaryExpressionDescription.__marshalByValueAlias = "SummaryExpression";
    return WebSummaryExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSummaryExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSummaryExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (WebSummaryExpressionDescriptionMetadata.a == null) {
                WebSummaryExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSummaryExpressionDescriptionMetadata.c(WebSummaryExpressionDescriptionMetadata.a);
            }
            if (a.k(WebSummaryExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSummaryExpressionDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:SummaryExpression");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("__isTSPlainInterface", "Boolean");
            a.item("FieldName", "String");
            a.item("CustomSummary", "Unknown");
        }
        static d(a) {
            WebSummaryExpressionDescriptionMetadata.b(a);
            a.ae("WebSummaryExpression", () => new WebSummaryExpressionDescription());
            a.ad("WebSummaryExpression", WebSummaryExpressionDescriptionMetadata.a);
        }
    }
    WebSummaryExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSummaryExpressionDescriptionMetadata, 'WebSummaryExpressionDescriptionMetadata');
    WebSummaryExpressionDescriptionMetadata.a = null;
    return WebSummaryExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSwitchDescription = /*@__PURE__*/ (() => {
    class WebSwitchDescription extends WebCheckboxBaseDescription {
        get_type() {
            return "WebSwitch";
        }
        constructor() {
            super();
        }
    }
    WebSwitchDescription.$t = /*@__PURE__*/ markType(WebSwitchDescription, 'WebSwitchDescription', WebCheckboxBaseDescription.$);
    return WebSwitchDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSwitchDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebSwitchDescriptionMetadata extends Base {
        static b(a) {
            if (WebSwitchDescriptionMetadata.a == null) {
                WebSwitchDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebSwitchDescriptionMetadata.c(WebSwitchDescriptionMetadata.a);
            }
            if (a.k(WebSwitchDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebSwitchDescriptionMetadata.a);
        }
        static c(a) {
            WebCheckboxBaseDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:Switch");
            a.item("__tagNameWC", "String:igc-switch");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebSwitchDescriptionMetadata.b(a);
            a.ae("WebSwitch", () => new WebSwitchDescription());
            a.ad("WebSwitch", WebSwitchDescriptionMetadata.a);
        }
    }
    WebSwitchDescriptionMetadata.$t = /*@__PURE__*/ markType(WebSwitchDescriptionMetadata, 'WebSwitchDescriptionMetadata');
    WebSwitchDescriptionMetadata.a = null;
    return WebSwitchDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebSwitchDescriptionModule = /*@__PURE__*/ (() => {
    class WebSwitchDescriptionModule extends Base {
        static register(a) {
            WebCheckboxBaseDescriptionModule.register(a);
            WebSwitchDescriptionMetadata.d(a);
        }
    }
    WebSwitchDescriptionModule.$t = /*@__PURE__*/ markType(WebSwitchDescriptionModule, 'WebSwitchDescriptionModule');
    return WebSwitchDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabDescription = /*@__PURE__*/ (() => {
    class WebTabDescription extends Description {
        get_type() {
            return "WebTab";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.l = null;
            this.i = false;
            this.h = false;
        }
        get panel() {
            return this.l;
        }
        set panel(a) {
            this.l = a;
            this.g("Panel");
        }
        get selected() {
            return this.i;
        }
        set selected(a) {
            this.i = a;
            this.g("Selected");
        }
        get disabled() {
            return this.h;
        }
        set disabled(a) {
            this.h = a;
            this.g("Disabled");
        }
    }
    WebTabDescription.$t = /*@__PURE__*/ markType(WebTabDescription, 'WebTabDescription', Description.$);
    return WebTabDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTabDescriptionMetadata extends Base {
        static b(a) {
            if (WebTabDescriptionMetadata.a == null) {
                WebTabDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTabDescriptionMetadata.c(WebTabDescriptionMetadata.a);
            }
            if (a.k(WebTabDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTabDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Tab");
            a.item("__tagNameWC", "String:igc-tab");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Panel", "String");
            a.item("Selected", "Boolean");
            a.item("Disabled", "Boolean");
        }
        static d(a) {
            WebTabDescriptionMetadata.b(a);
            a.ae("WebTab", () => new WebTabDescription());
            a.ad("WebTab", WebTabDescriptionMetadata.a);
        }
    }
    WebTabDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTabDescriptionMetadata, 'WebTabDescriptionMetadata');
    WebTabDescriptionMetadata.a = null;
    return WebTabDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabComponentEventArgsDescription = /*@__PURE__*/ (() => {
    class WebTabComponentEventArgsDescription extends Description {
        get_type() {
            return "WebTabComponentEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebTabComponentEventArgsDescription.$t = /*@__PURE__*/ markType(WebTabComponentEventArgsDescription, 'WebTabComponentEventArgsDescription', Description.$);
    WebTabComponentEventArgsDescription.__marshalByValue = true;
    WebTabComponentEventArgsDescription.__marshalByValueAlias = "TabComponentEventArgs";
    return WebTabComponentEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabComponentEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTabComponentEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebTabComponentEventArgsDescriptionMetadata.a == null) {
                WebTabComponentEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTabComponentEventArgsDescriptionMetadata.c(WebTabComponentEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebTabComponentEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTabComponentEventArgsDescriptionMetadata.a);
            WebTabDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:TabComponentEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebTab");
        }
        static d(a) {
            WebTabComponentEventArgsDescriptionMetadata.b(a);
            a.ae("WebTabComponentEventArgs", () => new WebTabComponentEventArgsDescription());
            a.ad("WebTabComponentEventArgs", WebTabComponentEventArgsDescriptionMetadata.a);
        }
    }
    WebTabComponentEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTabComponentEventArgsDescriptionMetadata, 'WebTabComponentEventArgsDescriptionMetadata');
    WebTabComponentEventArgsDescriptionMetadata.a = null;
    return WebTabComponentEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabHeaderConnectionEventArgsDescription = /*@__PURE__*/ (() => {
    class WebTabHeaderConnectionEventArgsDescription extends Description {
        get_type() {
            return "WebTabHeaderConnectionEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebTabHeaderConnectionEventArgsDescription.$t = /*@__PURE__*/ markType(WebTabHeaderConnectionEventArgsDescription, 'WebTabHeaderConnectionEventArgsDescription', Description.$);
    WebTabHeaderConnectionEventArgsDescription.__marshalByValue = true;
    WebTabHeaderConnectionEventArgsDescription.__marshalByValueAlias = "TabHeaderConnectionEventArgs";
    return WebTabHeaderConnectionEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabHeaderConnectionEventArgsDetailDescription = /*@__PURE__*/ (() => {
    class WebTabHeaderConnectionEventArgsDetailDescription extends Description {
        get_type() {
            return "WebTabHeaderConnectionEventArgsDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.j = null;
        }
        get pane() {
            return this.h;
        }
        set pane(a) {
            this.h = a;
            this.g("Pane");
        }
        get element() {
            return this.j;
        }
        set element(a) {
            this.j = a;
            this.g("Element");
        }
    }
    WebTabHeaderConnectionEventArgsDetailDescription.$t = /*@__PURE__*/ markType(WebTabHeaderConnectionEventArgsDetailDescription, 'WebTabHeaderConnectionEventArgsDetailDescription', Description.$);
    WebTabHeaderConnectionEventArgsDetailDescription.__marshalByValue = true;
    WebTabHeaderConnectionEventArgsDetailDescription.__marshalByValueAlias = "TabHeaderConnectionEventArgsDetail";
    return WebTabHeaderConnectionEventArgsDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabHeaderConnectionEventArgsDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTabHeaderConnectionEventArgsDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebTabHeaderConnectionEventArgsDetailDescriptionMetadata.a == null) {
                WebTabHeaderConnectionEventArgsDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTabHeaderConnectionEventArgsDetailDescriptionMetadata.c(WebTabHeaderConnectionEventArgsDetailDescriptionMetadata.a);
            }
            if (a.k(WebTabHeaderConnectionEventArgsDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTabHeaderConnectionEventArgsDetailDescriptionMetadata.a);
            WebContentPaneDescriptionMetadata.d(a);
            WebTabHeaderElementDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:TabHeaderConnectionEventArgsDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Pane", "ExportedType:WebContentPane");
            a.item("Element", "ExportedType:WebTabHeaderElement");
        }
        static d(a) {
            WebTabHeaderConnectionEventArgsDetailDescriptionMetadata.b(a);
            a.ae("WebTabHeaderConnectionEventArgsDetail", () => new WebTabHeaderConnectionEventArgsDetailDescription());
            a.ad("WebTabHeaderConnectionEventArgsDetail", WebTabHeaderConnectionEventArgsDetailDescriptionMetadata.a);
        }
    }
    WebTabHeaderConnectionEventArgsDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTabHeaderConnectionEventArgsDetailDescriptionMetadata, 'WebTabHeaderConnectionEventArgsDetailDescriptionMetadata');
    WebTabHeaderConnectionEventArgsDetailDescriptionMetadata.a = null;
    return WebTabHeaderConnectionEventArgsDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabHeaderConnectionEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTabHeaderConnectionEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebTabHeaderConnectionEventArgsDescriptionMetadata.a == null) {
                WebTabHeaderConnectionEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTabHeaderConnectionEventArgsDescriptionMetadata.c(WebTabHeaderConnectionEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebTabHeaderConnectionEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTabHeaderConnectionEventArgsDescriptionMetadata.a);
            WebTabHeaderConnectionEventArgsDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:TabHeaderConnectionEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Detail", "ExportedType:WebTabHeaderConnectionEventArgsDetail");
        }
        static d(a) {
            WebTabHeaderConnectionEventArgsDescriptionMetadata.b(a);
            a.ae("WebTabHeaderConnectionEventArgs", () => new WebTabHeaderConnectionEventArgsDescription());
            a.ad("WebTabHeaderConnectionEventArgs", WebTabHeaderConnectionEventArgsDescriptionMetadata.a);
        }
    }
    WebTabHeaderConnectionEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTabHeaderConnectionEventArgsDescriptionMetadata, 'WebTabHeaderConnectionEventArgsDescriptionMetadata');
    WebTabHeaderConnectionEventArgsDescriptionMetadata.a = null;
    return WebTabHeaderConnectionEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabDescriptionModule = /*@__PURE__*/ (() => {
    class WebTabDescriptionModule extends Base {
        static register(a) {
            WebTabDescriptionMetadata.d(a);
        }
    }
    WebTabDescriptionModule.$t = /*@__PURE__*/ markType(WebTabDescriptionModule, 'WebTabDescriptionModule');
    return WebTabDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabPanelDescription = /*@__PURE__*/ (() => {
    class WebTabPanelDescription extends Description {
        get_type() {
            return "WebTabPanel";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebTabPanelDescription.$t = /*@__PURE__*/ markType(WebTabPanelDescription, 'WebTabPanelDescription', Description.$);
    return WebTabPanelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabPanelDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTabPanelDescriptionMetadata extends Base {
        static b(a) {
            if (WebTabPanelDescriptionMetadata.a == null) {
                WebTabPanelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTabPanelDescriptionMetadata.c(WebTabPanelDescriptionMetadata.a);
            }
            if (a.k(WebTabPanelDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTabPanelDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:TabPanel");
            a.item("__tagNameWC", "String:igc-tab-panel");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebTabPanelDescriptionMetadata.b(a);
            a.ae("WebTabPanel", () => new WebTabPanelDescription());
            a.ad("WebTabPanel", WebTabPanelDescriptionMetadata.a);
        }
    }
    WebTabPanelDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTabPanelDescriptionMetadata, 'WebTabPanelDescriptionMetadata');
    WebTabPanelDescriptionMetadata.a = null;
    return WebTabPanelDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabPanelDescriptionModule = /*@__PURE__*/ (() => {
    class WebTabPanelDescriptionModule extends Base {
        static register(a) {
            WebTabPanelDescriptionMetadata.d(a);
        }
    }
    WebTabPanelDescriptionModule.$t = /*@__PURE__*/ markType(WebTabPanelDescriptionModule, 'WebTabPanelDescriptionModule');
    return WebTabPanelDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabsDescription = /*@__PURE__*/ (() => {
    class WebTabsDescription extends Description {
        get_type() {
            return "WebTabs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.h = null;
            this.j = null;
        }
        get alignment() {
            return this.i;
        }
        set alignment(a) {
            this.i = a;
            this.g("Alignment");
        }
        get activation() {
            return this.h;
        }
        set activation(a) {
            this.h = a;
            this.g("Activation");
        }
        get changeRef() {
            return this.j;
        }
        set changeRef(a) {
            this.j = a;
            this.g("ChangeRef");
        }
    }
    WebTabsDescription.$t = /*@__PURE__*/ markType(WebTabsDescription, 'WebTabsDescription', Description.$);
    return WebTabsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTabsDescriptionMetadata extends Base {
        static b(a) {
            if (WebTabsDescriptionMetadata.a == null) {
                WebTabsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTabsDescriptionMetadata.c(WebTabsDescriptionMetadata.a);
            }
            if (a.k(WebTabsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTabsDescriptionMetadata.a);
            WebTabComponentEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Tabs");
            a.item("__tagNameWC", "String:igc-tabs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Alignment", "ExportedType:string:TabsAlignment");
            a.item("Alignment@stringUnion", "WebComponents;React");
            a.item("Alignment@names", "Start;End;Center;Justify");
            a.item("Activation", "ExportedType:string:TabsActivation");
            a.item("Activation@stringUnion", "WebComponents;React");
            a.item("Activation@names", "Manual;Auto");
            a.item("ChangeRef", "EventRef::change");
        }
        static d(a) {
            WebTabsDescriptionMetadata.b(a);
            a.ae("WebTabs", () => new WebTabsDescription());
            a.ad("WebTabs", WebTabsDescriptionMetadata.a);
        }
    }
    WebTabsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTabsDescriptionMetadata, 'WebTabsDescriptionMetadata');
    WebTabsDescriptionMetadata.a = null;
    return WebTabsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTabsDescriptionModule = /*@__PURE__*/ (() => {
    class WebTabsDescriptionModule extends Base {
        static register(a) {
            WebTabDescriptionModule.register(a);
            WebTabPanelDescriptionModule.register(a);
            WebTabComponentEventArgsDescriptionMetadata.d(a);
            WebTabsDescriptionMetadata.d(a);
        }
    }
    WebTabsDescriptionModule.$t = /*@__PURE__*/ markType(WebTabsDescriptionModule, 'WebTabsDescriptionModule');
    return WebTabsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTextareaDescription = /*@__PURE__*/ (() => {
    class WebTextareaDescription extends Description {
        get_type() {
            return "WebTextarea";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.ac = null;
            this.ab = null;
            this.ah = null;
            this.ai = null;
            this.v = 0;
            this.w = 0;
            this.j = false;
            this.ak = null;
            this.k = false;
            this.al = null;
            this.x = 0;
            this.am = null;
            this.m = false;
            this.an = null;
            this.n = false;
            this.h = false;
            this.l = false;
            this.aj = null;
            this.i = false;
            this.ag = null;
            this.ae = null;
            this.af = null;
            this.ad = null;
        }
        get autocomplete() {
            return this.ac;
        }
        set autocomplete(a) {
            this.ac = a;
            this.g("Autocomplete");
        }
        get autocapitalize() {
            return this.ab;
        }
        set autocapitalize(a) {
            this.ab = a;
            this.g("Autocapitalize");
        }
        get inputMode() {
            return this.ah;
        }
        set inputMode(a) {
            this.ah = a;
            this.g("InputMode");
        }
        get label() {
            return this.ai;
        }
        set label(a) {
            this.ai = a;
            this.g("Label");
        }
        get maxLength() {
            return this.v;
        }
        set maxLength(a) {
            this.v = a;
            this.g("MaxLength");
        }
        get minLength() {
            return this.w;
        }
        set minLength(a) {
            this.w = a;
            this.g("MinLength");
        }
        get outlined() {
            return this.j;
        }
        set outlined(a) {
            this.j = a;
            this.g("Outlined");
        }
        get placeholder() {
            return this.ak;
        }
        set placeholder(a) {
            this.ak = a;
            this.g("Placeholder");
        }
        get readOnly() {
            return this.k;
        }
        set readOnly(a) {
            this.k = a;
            this.g("ReadOnly");
        }
        get resize() {
            return this.al;
        }
        set resize(a) {
            this.al = a;
            this.g("Resize");
        }
        get rows() {
            return this.x;
        }
        set rows(a) {
            this.x = a;
            this.g("Rows");
        }
        get value() {
            return this.am;
        }
        set value(a) {
            this.am = a;
            this.g("Value");
        }
        get spellcheck() {
            return this.m;
        }
        set spellcheck(a) {
            this.m = a;
            this.g("Spellcheck");
        }
        get wrap() {
            return this.an;
        }
        set wrap(a) {
            this.an = a;
            this.g("Wrap");
        }
        get validateOnly() {
            return this.n;
        }
        set validateOnly(a) {
            this.n = a;
            this.g("ValidateOnly");
        }
        get disabled() {
            return this.h;
        }
        set disabled(a) {
            this.h = a;
            this.g("Disabled");
        }
        get required() {
            return this.l;
        }
        set required(a) {
            this.l = a;
            this.g("Required");
        }
        get name() {
            return this.aj;
        }
        set name(a) {
            this.aj = a;
            this.g("Name");
        }
        get invalid() {
            return this.i;
        }
        set invalid(a) {
            this.i = a;
            this.g("Invalid");
        }
        get inputRef() {
            return this.ag;
        }
        set inputRef(a) {
            this.ag = a;
            this.g("InputRef");
        }
        get changeRef() {
            return this.ae;
        }
        set changeRef(a) {
            this.ae = a;
            this.g("ChangeRef");
        }
        get focusRef() {
            return this.af;
        }
        set focusRef(a) {
            this.af = a;
            this.g("FocusRef");
        }
        get blurRef() {
            return this.ad;
        }
        set blurRef(a) {
            this.ad = a;
            this.g("BlurRef");
        }
    }
    WebTextareaDescription.$t = /*@__PURE__*/ markType(WebTextareaDescription, 'WebTextareaDescription', Description.$);
    return WebTextareaDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTextareaDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTextareaDescriptionMetadata extends Base {
        static b(a) {
            if (WebTextareaDescriptionMetadata.a == null) {
                WebTextareaDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTextareaDescriptionMetadata.c(WebTextareaDescriptionMetadata.a);
            }
            if (a.k(WebTextareaDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTextareaDescriptionMetadata.a);
            WebComponentValueChangedEventArgsDescriptionMetadata.d(a);
            VoidEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Textarea");
            a.item("__tagNameWC", "String:igc-textarea");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Autocomplete", "String");
            a.item("Autocapitalize", "ExportedType:string:TextareaAutocapitalize");
            a.item("Autocapitalize@stringUnion", "WebComponents;React");
            a.item("Autocapitalize@names", "None;Off;On;Sentences;Words;Characters");
            a.item("InputMode", "ExportedType:string:TextareaInputMode");
            a.item("InputMode@stringUnion", "WebComponents;React");
            a.item("InputMode@names", "None;Email;Search;Tel;Text;Url;Decimal;Numeric");
            a.item("Label", "String");
            a.item("MaxLength", "Number:double");
            a.item("MinLength", "Number:double");
            a.item("Outlined", "Boolean");
            a.item("Placeholder", "String");
            a.item("ReadOnly", "Boolean");
            a.item("Resize", "ExportedType:string:TextareaResize");
            a.item("Resize@stringUnion", "WebComponents;React");
            a.item("Resize@names", "None;Vertical;Auto");
            a.item("Rows", "Number:double");
            a.item("Value", "String");
            a.item("Spellcheck", "Boolean");
            a.item("Wrap", "ExportedType:string:TextareaWrap");
            a.item("Wrap@stringUnion", "WebComponents;React");
            a.item("Wrap@names", "Off;Hard;Soft");
            a.item("ValidateOnly", "Boolean");
            a.item("Disabled", "Boolean");
            a.item("Required", "Boolean");
            a.item("Name", "String");
            a.item("Invalid", "Boolean");
            a.item("InputRef", "EventRef::input");
            a.item("ChangeRef", "EventRef::change");
            a.item("FocusRef", "EventRef::focus");
            a.item("BlurRef", "EventRef::blur");
        }
        static d(a) {
            WebTextareaDescriptionMetadata.b(a);
            a.ae("WebTextarea", () => new WebTextareaDescription());
            a.ad("WebTextarea", WebTextareaDescriptionMetadata.a);
        }
    }
    WebTextareaDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTextareaDescriptionMetadata, 'WebTextareaDescriptionMetadata');
    WebTextareaDescriptionMetadata.a = null;
    return WebTextareaDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTextareaDescriptionModule = /*@__PURE__*/ (() => {
    class WebTextareaDescriptionModule extends Base {
        static register(a) {
            WebTextareaDescriptionMetadata.d(a);
        }
    }
    WebTextareaDescriptionModule.$t = /*@__PURE__*/ markType(WebTextareaDescriptionModule, 'WebTextareaDescriptionModule');
    return WebTextareaDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTimeFilteringOperandDescription = /*@__PURE__*/ (() => {
    class WebTimeFilteringOperandDescription extends WebBaseDateTimeFilteringOperandDescription {
        get_type() {
            return "WebTimeFilteringOperand";
        }
        constructor() {
            super();
        }
    }
    WebTimeFilteringOperandDescription.$t = /*@__PURE__*/ markType(WebTimeFilteringOperandDescription, 'WebTimeFilteringOperandDescription', WebBaseDateTimeFilteringOperandDescription.$);
    return WebTimeFilteringOperandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTimeFilteringOperandDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTimeFilteringOperandDescriptionMetadata extends Base {
        static b(a) {
            if (WebTimeFilteringOperandDescriptionMetadata.a == null) {
                WebTimeFilteringOperandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTimeFilteringOperandDescriptionMetadata.c(WebTimeFilteringOperandDescriptionMetadata.a);
            }
            if (a.k(WebTimeFilteringOperandDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTimeFilteringOperandDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseDateTimeFilteringOperandDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:TimeFilteringOperand");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebTimeFilteringOperandDescriptionMetadata.b(a);
            a.ae("WebTimeFilteringOperand", () => new WebTimeFilteringOperandDescription());
            a.ad("WebTimeFilteringOperand", WebTimeFilteringOperandDescriptionMetadata.a);
        }
    }
    WebTimeFilteringOperandDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTimeFilteringOperandDescriptionMetadata, 'WebTimeFilteringOperandDescriptionMetadata');
    WebTimeFilteringOperandDescriptionMetadata.a = null;
    return WebTimeFilteringOperandDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTimeSummaryOperandDescription = /*@__PURE__*/ (() => {
    class WebTimeSummaryOperandDescription extends WebSummaryOperandDescription {
        get_type() {
            return "WebTimeSummaryOperand";
        }
        constructor() {
            super();
        }
    }
    WebTimeSummaryOperandDescription.$t = /*@__PURE__*/ markType(WebTimeSummaryOperandDescription, 'WebTimeSummaryOperandDescription', WebSummaryOperandDescription.$);
    return WebTimeSummaryOperandDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTimeSummaryOperandDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTimeSummaryOperandDescriptionMetadata extends Base {
        static b(a) {
            if (WebTimeSummaryOperandDescriptionMetadata.a == null) {
                WebTimeSummaryOperandDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTimeSummaryOperandDescriptionMetadata.c(WebTimeSummaryOperandDescriptionMetadata.a);
            }
            if (a.k(WebTimeSummaryOperandDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTimeSummaryOperandDescriptionMetadata.a);
        }
        static c(a) {
            WebSummaryOperandDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:TimeSummaryOperand");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__skipSuffix", "Boolean");
        }
        static d(a) {
            WebTimeSummaryOperandDescriptionMetadata.b(a);
            a.ae("WebTimeSummaryOperand", () => new WebTimeSummaryOperandDescription());
            a.ad("WebTimeSummaryOperand", WebTimeSummaryOperandDescriptionMetadata.a);
        }
    }
    WebTimeSummaryOperandDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTimeSummaryOperandDescriptionMetadata, 'WebTimeSummaryOperandDescriptionMetadata');
    WebTimeSummaryOperandDescriptionMetadata.a = null;
    return WebTimeSummaryOperandDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebToastDescription = /*@__PURE__*/ (() => {
    class WebToastDescription extends WebBaseAlertLikeDescription {
        get_type() {
            return "WebToast";
        }
        constructor() {
            super();
        }
    }
    WebToastDescription.$t = /*@__PURE__*/ markType(WebToastDescription, 'WebToastDescription', WebBaseAlertLikeDescription.$);
    return WebToastDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebToastDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebToastDescriptionMetadata extends Base {
        static b(a) {
            if (WebToastDescriptionMetadata.a == null) {
                WebToastDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebToastDescriptionMetadata.c(WebToastDescriptionMetadata.a);
            }
            if (a.k(WebToastDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebToastDescriptionMetadata.a);
        }
        static c(a) {
            WebBaseAlertLikeDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:Toast");
            a.item("__tagNameWC", "String:igc-toast");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebToastDescriptionMetadata.b(a);
            a.ae("WebToast", () => new WebToastDescription());
            a.ad("WebToast", WebToastDescriptionMetadata.a);
        }
    }
    WebToastDescriptionMetadata.$t = /*@__PURE__*/ markType(WebToastDescriptionMetadata, 'WebToastDescriptionMetadata');
    WebToastDescriptionMetadata.a = null;
    return WebToastDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebToastDescriptionModule = /*@__PURE__*/ (() => {
    class WebToastDescriptionModule extends Base {
        static register(a) {
            WebBaseAlertLikeDescriptionModule.register(a);
            WebToastDescriptionMetadata.d(a);
        }
    }
    WebToastDescriptionModule.$t = /*@__PURE__*/ markType(WebToastDescriptionModule, 'WebToastDescriptionModule');
    return WebToastDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTransactionServiceDescription = /*@__PURE__*/ (() => {
    class WebTransactionServiceDescription extends Description {
        get_type() {
            return "WebTransactionService";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebTransactionServiceDescription.$t = /*@__PURE__*/ markType(WebTransactionServiceDescription, 'WebTransactionServiceDescription', Description.$);
    return WebTransactionServiceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTransactionServiceDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTransactionServiceDescriptionMetadata extends Base {
        static b(a) {
            if (WebTransactionServiceDescriptionMetadata.a == null) {
                WebTransactionServiceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTransactionServiceDescriptionMetadata.c(WebTransactionServiceDescriptionMetadata.a);
            }
            if (a.k(WebTransactionServiceDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTransactionServiceDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:TransactionService");
        }
        static d(a) {
            WebTransactionServiceDescriptionMetadata.b(a);
            a.ae("WebTransactionService", () => new WebTransactionServiceDescription());
            a.ad("WebTransactionService", WebTransactionServiceDescriptionMetadata.a);
        }
    }
    WebTransactionServiceDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTransactionServiceDescriptionMetadata, 'WebTransactionServiceDescriptionMetadata');
    WebTransactionServiceDescriptionMetadata.a = null;
    return WebTransactionServiceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeDescription = /*@__PURE__*/ (() => {
    class WebTreeDescription extends Description {
        get_type() {
            return "WebTree";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
            this.i = false;
            this.q = null;
            this.r = null;
            this.p = null;
            this.o = null;
            this.n = null;
            this.m = null;
            this.l = null;
        }
        get singleBranchExpand() {
            return this.h;
        }
        set singleBranchExpand(a) {
            this.h = a;
            this.g("SingleBranchExpand");
        }
        get toggleNodeOnClick() {
            return this.i;
        }
        set toggleNodeOnClick(a) {
            this.i = a;
            this.g("ToggleNodeOnClick");
        }
        get selection() {
            return this.q;
        }
        set selection(a) {
            this.q = a;
            this.g("Selection");
        }
        get selectionChangedRef() {
            return this.r;
        }
        set selectionChangedRef(a) {
            this.r = a;
            this.g("SelectionChangedRef");
        }
        get itemExpandingRef() {
            return this.p;
        }
        set itemExpandingRef(a) {
            this.p = a;
            this.g("ItemExpandingRef");
        }
        get itemExpandedRef() {
            return this.o;
        }
        set itemExpandedRef(a) {
            this.o = a;
            this.g("ItemExpandedRef");
        }
        get itemCollapsingRef() {
            return this.n;
        }
        set itemCollapsingRef(a) {
            this.n = a;
            this.g("ItemCollapsingRef");
        }
        get itemCollapsedRef() {
            return this.m;
        }
        set itemCollapsedRef(a) {
            this.m = a;
            this.g("ItemCollapsedRef");
        }
        get activeItemRef() {
            return this.l;
        }
        set activeItemRef(a) {
            this.l = a;
            this.g("ActiveItemRef");
        }
    }
    WebTreeDescription.$t = /*@__PURE__*/ markType(WebTreeDescription, 'WebTreeDescription', Description.$);
    return WebTreeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeItemDescription = /*@__PURE__*/ (() => {
    class WebTreeItemDescription extends Description {
        get_type() {
            return "WebTreeItem";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.t = 0;
            this.x = null;
            this.l = false;
            this.j = false;
            this.k = false;
            this.n = false;
            this.m = false;
            this.v = null;
        }
        get parent() {
            return this.h;
        }
        set parent(a) {
            this.h = a;
            this.g("Parent");
        }
        get level() {
            return this.t;
        }
        set level(a) {
            this.t = a;
            this.g("Level");
        }
        get label() {
            return this.x;
        }
        set label(a) {
            this.x = a;
            this.g("Label");
        }
        get expanded() {
            return this.l;
        }
        set expanded(a) {
            this.l = a;
            this.g("Expanded");
        }
        get active() {
            return this.j;
        }
        set active(a) {
            this.j = a;
            this.g("Active");
        }
        get disabled() {
            return this.k;
        }
        set disabled(a) {
            this.k = a;
            this.g("Disabled");
        }
        get selected() {
            return this.n;
        }
        set selected(a) {
            this.n = a;
            this.g("Selected");
        }
        get loading() {
            return this.m;
        }
        set loading(a) {
            this.m = a;
            this.g("Loading");
        }
        get value() {
            return this.v;
        }
        set value(a) {
            this.v = a;
            this.g("Value");
        }
    }
    WebTreeItemDescription.$t = /*@__PURE__*/ markType(WebTreeItemDescription, 'WebTreeItemDescription', Description.$);
    return WebTreeItemDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeItemDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTreeItemDescriptionMetadata extends Base {
        static b(a) {
            if (WebTreeItemDescriptionMetadata.a == null) {
                WebTreeItemDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTreeItemDescriptionMetadata.c(WebTreeItemDescriptionMetadata.a);
            }
            if (a.k(WebTreeItemDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTreeItemDescriptionMetadata.a);
            WebTreeItemDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:TreeItem");
            a.item("__tagNameWC", "String:igc-tree-item");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Parent", "ExportedType:WebTreeItem");
            a.item("Level", "Number:double");
            a.item("Label", "String");
            a.item("Expanded", "Boolean");
            a.item("Active", "Boolean");
            a.item("Disabled", "Boolean");
            a.item("Selected", "Boolean");
            a.item("Loading", "Boolean");
            a.item("Value", "Unknown");
        }
        static d(a) {
            WebTreeItemDescriptionMetadata.b(a);
            a.ae("WebTreeItem", () => new WebTreeItemDescription());
            a.ad("WebTreeItem", WebTreeItemDescriptionMetadata.a);
        }
    }
    WebTreeItemDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTreeItemDescriptionMetadata, 'WebTreeItemDescriptionMetadata');
    WebTreeItemDescriptionMetadata.a = null;
    return WebTreeItemDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeSelectionChangeDetailDescription = /*@__PURE__*/ (() => {
    class WebTreeSelectionChangeDetailDescription extends Description {
        get_type() {
            return "WebTreeSelectionChangeDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get newSelection() {
            return this.h;
        }
        set newSelection(a) {
            this.h = a;
            this.g("NewSelection");
        }
    }
    WebTreeSelectionChangeDetailDescription.$t = /*@__PURE__*/ markType(WebTreeSelectionChangeDetailDescription, 'WebTreeSelectionChangeDetailDescription', Description.$);
    WebTreeSelectionChangeDetailDescription.__marshalByValue = true;
    WebTreeSelectionChangeDetailDescription.__marshalByValueAlias = "TreeSelectionChangeDetail";
    return WebTreeSelectionChangeDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeSelectionChangeDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTreeSelectionChangeDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebTreeSelectionChangeDetailDescriptionMetadata.a == null) {
                WebTreeSelectionChangeDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTreeSelectionChangeDetailDescriptionMetadata.c(WebTreeSelectionChangeDetailDescriptionMetadata.a);
            }
            if (a.k(WebTreeSelectionChangeDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTreeSelectionChangeDetailDescriptionMetadata.a);
            WebTreeItemDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:TreeSelectionChangeDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("NewSelection", "Array:WebTreeItemDescription:TreeItem");
        }
        static d(a) {
            WebTreeSelectionChangeDetailDescriptionMetadata.b(a);
            a.ae("WebTreeSelectionChangeDetail", () => new WebTreeSelectionChangeDetailDescription());
            a.ad("WebTreeSelectionChangeDetail", WebTreeSelectionChangeDetailDescriptionMetadata.a);
        }
    }
    WebTreeSelectionChangeDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTreeSelectionChangeDetailDescriptionMetadata, 'WebTreeSelectionChangeDetailDescriptionMetadata');
    WebTreeSelectionChangeDetailDescriptionMetadata.a = null;
    return WebTreeSelectionChangeDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeSelectionChangeEventArgsDescription = /*@__PURE__*/ (() => {
    class WebTreeSelectionChangeEventArgsDescription extends Description {
        get_type() {
            return "WebTreeSelectionChangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebTreeSelectionChangeEventArgsDescription.$t = /*@__PURE__*/ markType(WebTreeSelectionChangeEventArgsDescription, 'WebTreeSelectionChangeEventArgsDescription', Description.$);
    WebTreeSelectionChangeEventArgsDescription.__marshalByValue = true;
    WebTreeSelectionChangeEventArgsDescription.__marshalByValueAlias = "TreeSelectionChangeEventArgs";
    return WebTreeSelectionChangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeSelectionChangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTreeSelectionChangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebTreeSelectionChangeEventArgsDescriptionMetadata.a == null) {
                WebTreeSelectionChangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTreeSelectionChangeEventArgsDescriptionMetadata.c(WebTreeSelectionChangeEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebTreeSelectionChangeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTreeSelectionChangeEventArgsDescriptionMetadata.a);
            WebTreeSelectionChangeDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:TreeSelectionChangeEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebTreeSelectionChangeDetail");
        }
        static d(a) {
            WebTreeSelectionChangeEventArgsDescriptionMetadata.b(a);
            a.ae("WebTreeSelectionChangeEventArgs", () => new WebTreeSelectionChangeEventArgsDescription());
            a.ad("WebTreeSelectionChangeEventArgs", WebTreeSelectionChangeEventArgsDescriptionMetadata.a);
        }
    }
    WebTreeSelectionChangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTreeSelectionChangeEventArgsDescriptionMetadata, 'WebTreeSelectionChangeEventArgsDescriptionMetadata');
    WebTreeSelectionChangeEventArgsDescriptionMetadata.a = null;
    return WebTreeSelectionChangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeItemComponentEventArgsDescription = /*@__PURE__*/ (() => {
    class WebTreeItemComponentEventArgsDescription extends Description {
        get_type() {
            return "WebTreeItemComponentEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebTreeItemComponentEventArgsDescription.$t = /*@__PURE__*/ markType(WebTreeItemComponentEventArgsDescription, 'WebTreeItemComponentEventArgsDescription', Description.$);
    WebTreeItemComponentEventArgsDescription.__marshalByValue = true;
    WebTreeItemComponentEventArgsDescription.__marshalByValueAlias = "TreeItemComponentEventArgs";
    return WebTreeItemComponentEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeItemComponentEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTreeItemComponentEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebTreeItemComponentEventArgsDescriptionMetadata.a == null) {
                WebTreeItemComponentEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTreeItemComponentEventArgsDescriptionMetadata.c(WebTreeItemComponentEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebTreeItemComponentEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTreeItemComponentEventArgsDescriptionMetadata.a);
            WebTreeItemDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:TreeItemComponentEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("Detail", "ExportedType:WebTreeItem");
        }
        static d(a) {
            WebTreeItemComponentEventArgsDescriptionMetadata.b(a);
            a.ae("WebTreeItemComponentEventArgs", () => new WebTreeItemComponentEventArgsDescription());
            a.ad("WebTreeItemComponentEventArgs", WebTreeItemComponentEventArgsDescriptionMetadata.a);
        }
    }
    WebTreeItemComponentEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTreeItemComponentEventArgsDescriptionMetadata, 'WebTreeItemComponentEventArgsDescriptionMetadata');
    WebTreeItemComponentEventArgsDescriptionMetadata.a = null;
    return WebTreeItemComponentEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTreeDescriptionMetadata extends Base {
        static b(a) {
            if (WebTreeDescriptionMetadata.a == null) {
                WebTreeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTreeDescriptionMetadata.c(WebTreeDescriptionMetadata.a);
            }
            if (a.k(WebTreeDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTreeDescriptionMetadata.a);
            WebTreeSelectionChangeEventArgsDescriptionMetadata.d(a);
            WebTreeItemComponentEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Tree");
            a.item("__tagNameWC", "String:igc-tree");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("SingleBranchExpand", "Boolean");
            a.item("ToggleNodeOnClick", "Boolean");
            a.item("Selection", "ExportedType:string:TreeSelection");
            a.item("Selection@stringUnion", "WebComponents;React");
            a.item("Selection@names", "None;Multiple;Cascade");
            a.item("SelectionChangedRef", "EventRef::selectionChanged");
            a.item("ItemExpandingRef", "EventRef::itemExpanding");
            a.item("ItemExpandedRef", "EventRef::itemExpanded");
            a.item("ItemCollapsingRef", "EventRef::itemCollapsing");
            a.item("ItemCollapsedRef", "EventRef::itemCollapsed");
            a.item("ActiveItemRef", "EventRef::activeItem");
        }
        static d(a) {
            WebTreeDescriptionMetadata.b(a);
            a.ae("WebTree", () => new WebTreeDescription());
            a.ad("WebTree", WebTreeDescriptionMetadata.a);
        }
    }
    WebTreeDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTreeDescriptionMetadata, 'WebTreeDescriptionMetadata');
    WebTreeDescriptionMetadata.a = null;
    return WebTreeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeGridDescription = /*@__PURE__*/ (() => {
    class WebTreeGridDescription extends WebGridBaseDirectiveDescription {
        get_type() {
            return "WebTreeGrid";
        }
        constructor() {
            super();
            this.gv = null;
            this.gx = null;
            this.gy = null;
            this.gr = false;
            this.gz = null;
            this.go = null;
            this.gn = null;
            this.gw = null;
            this.gt = 0;
            this.g0 = null;
        }
        get childDataKey() {
            return this.gv;
        }
        set childDataKey(a) {
            this.gv = a;
            this.g("ChildDataKey");
        }
        get foreignKey() {
            return this.gx;
        }
        set foreignKey(a) {
            this.gx = a;
            this.g("ForeignKey");
        }
        get hasChildrenKey() {
            return this.gy;
        }
        set hasChildrenKey(a) {
            this.gy = a;
            this.g("HasChildrenKey");
        }
        get cascadeOnDelete() {
            return this.gr;
        }
        set cascadeOnDelete(a) {
            this.gr = a;
            this.g("CascadeOnDelete");
        }
        get id() {
            return this.gz;
        }
        set id(a) {
            this.gz = a;
            this.g("Id");
        }
        get rootRecords() {
            return this.go;
        }
        set rootRecords(a) {
            this.go = a;
            this.g("RootRecords");
        }
        get processedRootRecords() {
            return this.gn;
        }
        set processedRootRecords(a) {
            this.gn = a;
            this.g("ProcessedRootRecords");
        }
        get dataRef() {
            return this.gw;
        }
        set dataRef(a) {
            this.gw = a;
            this.g("DataRef");
        }
        get expansionDepth() {
            return this.gt;
        }
        set expansionDepth(a) {
            this.gt = a;
            this.g("ExpansionDepth");
        }
        get rowLoadingIndicatorTemplateRef() {
            return this.g0;
        }
        set rowLoadingIndicatorTemplateRef(a) {
            this.g0 = a;
            this.g("RowLoadingIndicatorTemplateRef");
        }
    }
    WebTreeGridDescription.$t = /*@__PURE__*/ markType(WebTreeGridDescription, 'WebTreeGridDescription', WebGridBaseDirectiveDescription.$);
    return WebTreeGridDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeGridDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTreeGridDescriptionMetadata extends Base {
        static b(a) {
            if (WebTreeGridDescriptionMetadata.a == null) {
                WebTreeGridDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTreeGridDescriptionMetadata.c(WebTreeGridDescriptionMetadata.a);
            }
            if (a.k(WebTreeGridDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTreeGridDescriptionMetadata.a);
            WebTreeGridDescriptionMetadata.f(a);
            WebTreeGridRecordDescriptionMetadata.d(a);
        }
        static c(a) {
            WebGridBaseDirectiveDescriptionMetadata.c(a);
            a.item("__qualifiedNameTS", "String:TreeGrid");
            a.item("__tagNameWC", "String:igc-tree-grid");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            if (a.containsKey("__skipSuffix")) {
                a.removeItem("__skipSuffix");
            }
            a.item("ChildDataKey", "String");
            a.item("ForeignKey", "String");
            a.item("HasChildrenKey", "String");
            a.item("CascadeOnDelete", "Boolean");
            a.item("Id", "String");
            a.item("RootRecords", "Array:WebTreeGridRecordDescription:TreeGridRecord");
            a.item("ProcessedRootRecords", "Array:WebTreeGridRecordDescription:TreeGridRecord");
            a.item("DataRef", "(w:Data,wf:Data)DataRef::object");
            a.item("ExpansionDepth", "Number:double");
            a.item("RowLoadingIndicatorTemplateRef", "(w:RowLoadingIndicatorTemplate,wf:RowLoadingIndicatorTemplate)TemplateRef::object");
            WebTreeGridDescriptionMetadata.e(a);
        }
        static d(a) {
            WebTreeGridDescriptionMetadata.b(a);
            a.ae("WebTreeGrid", () => new WebTreeGridDescription());
            a.ad("WebTreeGrid", WebTreeGridDescriptionMetadata.a);
        }
        static e(a) {
            a.item("__deferAttachWC", "Boolean");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
        }
        static f(a) {
            WebGridToolbarDescriptionMetadata.d(a);
            WebGridToolbarActionsDescriptionMetadata.d(a);
            WebGridToolbarTitleDescriptionMetadata.d(a);
            WebGridToolbarExporterDescriptionMetadata.d(a);
            WebGridToolbarHidingDescriptionMetadata.d(a);
            WebGridToolbarPinningDescriptionMetadata.d(a);
            WebGridToolbarAdvancedFilteringDescriptionMetadata.d(a);
            WebGridToolbarBaseActionDescriptionMetadata.d(a);
            WebGridToolbarContentDescriptionMetadata.d(a);
        }
    }
    WebTreeGridDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTreeGridDescriptionMetadata, 'WebTreeGridDescriptionMetadata');
    WebTreeGridDescriptionMetadata.a = null;
    return WebTreeGridDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeGridDescriptionModule = /*@__PURE__*/ (() => {
    class WebTreeGridDescriptionModule extends Base {
        static register(a) {
            WebColumnDescriptionModule.register(a);
            WebGridToolbarDescriptionModule.register(a);
            WebGridToolbarActionsDescriptionModule.register(a);
            WebGridToolbarTitleDescriptionModule.register(a);
            WebGridToolbarAdvancedFilteringDescriptionModule.register(a);
            WebGridToolbarExporterDescriptionModule.register(a);
            WebGridToolbarHidingDescriptionModule.register(a);
            WebGridToolbarPinningDescriptionModule.register(a);
            WebActionStripDescriptionModule.register(a);
            WebGridActionsBaseDirectiveDescriptionModule.register(a);
            WebGridEditingActionsDescriptionModule.register(a);
            WebGridPinningActionsDescriptionModule.register(a);
            WebTreeGridDescriptionMetadata.d(a);
            TemplateContainerDescriptionModule.register(a);
            ChildContentDescriptionModule.register(a);
        }
    }
    WebTreeGridDescriptionModule.$t = /*@__PURE__*/ markType(WebTreeGridDescriptionModule, 'WebTreeGridDescriptionModule');
    return WebTreeGridDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeItemDescriptionModule = /*@__PURE__*/ (() => {
    class WebTreeItemDescriptionModule extends Base {
        static register(a) {
            WebTreeItemDescriptionMetadata.d(a);
        }
    }
    WebTreeItemDescriptionModule.$t = /*@__PURE__*/ markType(WebTreeItemDescriptionModule, 'WebTreeItemDescriptionModule');
    return WebTreeItemDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeDescriptionModule = /*@__PURE__*/ (() => {
    class WebTreeDescriptionModule extends Base {
        static register(a) {
            WebTreeItemDescriptionModule.register(a);
            WebTreeSelectionChangeEventArgsDescriptionMetadata.d(a);
            WebTreeItemComponentEventArgsDescriptionMetadata.d(a);
            WebTreeDescriptionMetadata.d(a);
        }
    }
    WebTreeDescriptionModule.$t = /*@__PURE__*/ markType(WebTreeDescriptionModule, 'WebTreeDescriptionModule');
    return WebTreeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeSelectionChangeDescription = /*@__PURE__*/ (() => {
    class WebTreeSelectionChangeDescription extends Description {
        get_type() {
            return "WebTreeSelectionChange";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebTreeSelectionChangeDescription.$t = /*@__PURE__*/ markType(WebTreeSelectionChangeDescription, 'WebTreeSelectionChangeDescription', Description.$);
    return WebTreeSelectionChangeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeSelectionChangeDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTreeSelectionChangeDescriptionMetadata extends Base {
        static b(a) {
            if (WebTreeSelectionChangeDescriptionMetadata.a == null) {
                WebTreeSelectionChangeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTreeSelectionChangeDescriptionMetadata.c(WebTreeSelectionChangeDescriptionMetadata.a);
            }
            if (a.k(WebTreeSelectionChangeDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTreeSelectionChangeDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:TreeSelectionChange");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebTreeSelectionChangeDescriptionMetadata.b(a);
            a.ae("WebTreeSelectionChange", () => new WebTreeSelectionChangeDescription());
            a.ad("WebTreeSelectionChange", WebTreeSelectionChangeDescriptionMetadata.a);
        }
    }
    WebTreeSelectionChangeDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTreeSelectionChangeDescriptionMetadata, 'WebTreeSelectionChangeDescriptionMetadata');
    WebTreeSelectionChangeDescriptionMetadata.a = null;
    return WebTreeSelectionChangeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeSelectionOptionsEventArgsDescription = /*@__PURE__*/ (() => {
    class WebTreeSelectionOptionsEventArgsDescription extends Description {
        get_type() {
            return "WebTreeSelectionOptionsEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get detail() {
            return this.h;
        }
        set detail(a) {
            this.h = a;
            this.g("Detail");
        }
    }
    WebTreeSelectionOptionsEventArgsDescription.$t = /*@__PURE__*/ markType(WebTreeSelectionOptionsEventArgsDescription, 'WebTreeSelectionOptionsEventArgsDescription', Description.$);
    return WebTreeSelectionOptionsEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeSelectionOptionsEventDetailDescription = /*@__PURE__*/ (() => {
    class WebTreeSelectionOptionsEventDetailDescription extends Description {
        get_type() {
            return "WebTreeSelectionOptionsEventDetail";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get newSelection() {
            return this.h;
        }
        set newSelection(a) {
            this.h = a;
            this.g("NewSelection");
        }
    }
    WebTreeSelectionOptionsEventDetailDescription.$t = /*@__PURE__*/ markType(WebTreeSelectionOptionsEventDetailDescription, 'WebTreeSelectionOptionsEventDetailDescription', Description.$);
    WebTreeSelectionOptionsEventDetailDescription.__marshalByValue = true;
    WebTreeSelectionOptionsEventDetailDescription.__marshalByValueAlias = "TreeSelectionOptionsEventDetail";
    return WebTreeSelectionOptionsEventDetailDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeSelectionOptionsEventDetailDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTreeSelectionOptionsEventDetailDescriptionMetadata extends Base {
        static b(a) {
            if (WebTreeSelectionOptionsEventDetailDescriptionMetadata.a == null) {
                WebTreeSelectionOptionsEventDetailDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTreeSelectionOptionsEventDetailDescriptionMetadata.c(WebTreeSelectionOptionsEventDetailDescriptionMetadata.a);
            }
            if (a.k(WebTreeSelectionOptionsEventDetailDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTreeSelectionOptionsEventDetailDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:TreeSelectionOptionsEventDetail");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("__marshalByValue", "Boolean");
            a.item("NewSelection", "Collection:WebTreeItem:WebTreeItemCollection:WebTreeItem");
        }
        static d(a) {
            WebTreeSelectionOptionsEventDetailDescriptionMetadata.b(a);
            a.ae("WebTreeSelectionOptionsEventDetail", () => new WebTreeSelectionOptionsEventDetailDescription());
            a.ad("WebTreeSelectionOptionsEventDetail", WebTreeSelectionOptionsEventDetailDescriptionMetadata.a);
        }
    }
    WebTreeSelectionOptionsEventDetailDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTreeSelectionOptionsEventDetailDescriptionMetadata, 'WebTreeSelectionOptionsEventDetailDescriptionMetadata');
    WebTreeSelectionOptionsEventDetailDescriptionMetadata.a = null;
    return WebTreeSelectionOptionsEventDetailDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebTreeSelectionOptionsEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebTreeSelectionOptionsEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (WebTreeSelectionOptionsEventArgsDescriptionMetadata.a == null) {
                WebTreeSelectionOptionsEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebTreeSelectionOptionsEventArgsDescriptionMetadata.c(WebTreeSelectionOptionsEventArgsDescriptionMetadata.a);
            }
            if (a.k(WebTreeSelectionOptionsEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebTreeSelectionOptionsEventArgsDescriptionMetadata.a);
            WebTreeSelectionOptionsEventDetailDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:TreeSelectionOptionsEventArgs");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Detail", "ExportedType:WebTreeSelectionOptionsEventDetail");
        }
        static d(a) {
            WebTreeSelectionOptionsEventArgsDescriptionMetadata.b(a);
            a.ae("WebTreeSelectionOptionsEventArgs", () => new WebTreeSelectionOptionsEventArgsDescription());
            a.ad("WebTreeSelectionOptionsEventArgs", WebTreeSelectionOptionsEventArgsDescriptionMetadata.a);
        }
    }
    WebTreeSelectionOptionsEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(WebTreeSelectionOptionsEventArgsDescriptionMetadata, 'WebTreeSelectionOptionsEventArgsDescriptionMetadata');
    WebTreeSelectionOptionsEventArgsDescriptionMetadata.a = null;
    return WebTreeSelectionOptionsEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebValidatorHandlerDescription = /*@__PURE__*/ (() => {
    class WebValidatorHandlerDescription extends Description {
        get_type() {
            return "WebValidatorHandler";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    WebValidatorHandlerDescription.$t = /*@__PURE__*/ markType(WebValidatorHandlerDescription, 'WebValidatorHandlerDescription', Description.$);
    return WebValidatorHandlerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebValidatorHandlerDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebValidatorHandlerDescriptionMetadata extends Base {
        static b(a) {
            if (WebValidatorHandlerDescriptionMetadata.a == null) {
                WebValidatorHandlerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebValidatorHandlerDescriptionMetadata.c(WebValidatorHandlerDescriptionMetadata.a);
            }
            if (a.k(WebValidatorHandlerDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebValidatorHandlerDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ValidatorHandler");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
        }
        static d(a) {
            WebValidatorHandlerDescriptionMetadata.b(a);
            a.ae("WebValidatorHandler", () => new WebValidatorHandlerDescription());
            a.ad("WebValidatorHandler", WebValidatorHandlerDescriptionMetadata.a);
        }
    }
    WebValidatorHandlerDescriptionMetadata.$t = /*@__PURE__*/ markType(WebValidatorHandlerDescriptionMetadata, 'WebValidatorHandlerDescriptionMetadata');
    WebValidatorHandlerDescriptionMetadata.a = null;
    return WebValidatorHandlerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebValuesChangeDescription = /*@__PURE__*/ (() => {
    class WebValuesChangeDescription extends Description {
        get_type() {
            return "WebValuesChange";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get values() {
            return this.h;
        }
        set values(a) {
            this.h = a;
            this.g("Values");
        }
    }
    WebValuesChangeDescription.$t = /*@__PURE__*/ markType(WebValuesChangeDescription, 'WebValuesChangeDescription', Description.$);
    return WebValuesChangeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebValuesChangeDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebValuesChangeDescriptionMetadata extends Base {
        static b(a) {
            if (WebValuesChangeDescriptionMetadata.a == null) {
                WebValuesChangeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebValuesChangeDescriptionMetadata.c(WebValuesChangeDescriptionMetadata.a);
            }
            if (a.k(WebValuesChangeDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebValuesChangeDescriptionMetadata.a);
            WebPivotValueDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:ValuesChange");
            a.item("__packageNameWC", "String:grids");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importOverrideWebComponents", "String:igniteui-webcomponents-grids/grids/combined");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents-grids/grids");
            a.item("__isPlainObject", "Boolean");
            a.item("__skipSuffix", "Boolean");
            a.item("Values", "Array:WebPivotValueDescription:PivotValue");
        }
        static d(a) {
            WebValuesChangeDescriptionMetadata.b(a);
            a.ae("WebValuesChange", () => new WebValuesChangeDescription());
            a.ad("WebValuesChange", WebValuesChangeDescriptionMetadata.a);
        }
    }
    WebValuesChangeDescriptionMetadata.$t = /*@__PURE__*/ markType(WebValuesChangeDescriptionMetadata, 'WebValuesChangeDescriptionMetadata');
    WebValuesChangeDescriptionMetadata.a = null;
    return WebValuesChangeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let YearToDateExpressionDescription = /*@__PURE__*/ (() => {
    class YearToDateExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "YearToDateExpression";
        }
        constructor() {
            super();
        }
    }
    YearToDateExpressionDescription.$t = /*@__PURE__*/ markType(YearToDateExpressionDescription, 'YearToDateExpressionDescription', WrapperExpressionDescription.$);
    YearToDateExpressionDescription.__marshalByValue2 = true;
    YearToDateExpressionDescription.__marshalByValueAlias2 = "YearToDateExpression";
    return YearToDateExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let YearToDateExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class YearToDateExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (YearToDateExpressionDescriptionMetadata.a == null) {
                YearToDateExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                YearToDateExpressionDescriptionMetadata.c(YearToDateExpressionDescriptionMetadata.a);
            }
            if (a.k(YearToDateExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(YearToDateExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            YearToDateExpressionDescriptionMetadata.b(a);
            a.ae("YearToDateExpression", () => new YearToDateExpressionDescription());
            a.ad("YearToDateExpression", YearToDateExpressionDescriptionMetadata.a);
        }
    }
    YearToDateExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(YearToDateExpressionDescriptionMetadata, 'YearToDateExpressionDescriptionMetadata');
    YearToDateExpressionDescriptionMetadata.a = null;
    return YearToDateExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let YesterdayExpressionDescription = /*@__PURE__*/ (() => {
    class YesterdayExpressionDescription extends WrapperExpressionDescription {
        get_type() {
            return "YesterdayExpression";
        }
        constructor() {
            super();
        }
    }
    YesterdayExpressionDescription.$t = /*@__PURE__*/ markType(YesterdayExpressionDescription, 'YesterdayExpressionDescription', WrapperExpressionDescription.$);
    YesterdayExpressionDescription.__marshalByValue2 = true;
    YesterdayExpressionDescription.__marshalByValueAlias2 = "YesterdayExpression";
    return YesterdayExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let YesterdayExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class YesterdayExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (YesterdayExpressionDescriptionMetadata.a == null) {
                YesterdayExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                YesterdayExpressionDescriptionMetadata.c(YesterdayExpressionDescriptionMetadata.a);
            }
            if (a.k(YesterdayExpressionDescriptionMetadata.a)) {
                return;
            }
            a.ac(YesterdayExpressionDescriptionMetadata.a);
        }
        static c(a) {
            WrapperExpressionDescriptionMetadata.c(a);
        }
        static d(a) {
            YesterdayExpressionDescriptionMetadata.b(a);
            a.ae("YesterdayExpression", () => new YesterdayExpressionDescription());
            a.ad("YesterdayExpression", YesterdayExpressionDescriptionMetadata.a);
        }
    }
    YesterdayExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(YesterdayExpressionDescriptionMetadata, 'YesterdayExpressionDescriptionMetadata');
    YesterdayExpressionDescriptionMetadata.a = null;
    return YesterdayExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionJsonValidator = /*@__PURE__*/ (() => {
    class DescriptionJsonValidator extends Base {
        constructor() {
            super();
            this.i = new List$1(String_$type, 0);
            this.h = new Dictionary$2(String_$type, List$1.$.specialize(String_$type), 0);
            this.e = null;
            this.g = null;
        }
        getContainingModules(a) {
            if (this.h.containsKey(a)) {
                return this.h.item(a).toArray();
            }
            return null;
        }
        validate(a) {
            let b = new JsonDictionaryParser();
            let c = b.parse(a);
            let d = this.b(c);
            let e = this.a(c);
            let f = new HashSet$1(String_$type, 0);
            for (let h = 0; h < e.length; h++) {
                let g = e[h];
                f.add_1(g);
            }
            let i = null;
            for (let k = 0; k < d.length; k++) {
                let j = d[k];
                let l = this.getContainingModules(j);
                let m = false;
                if (l != null) {
                    for (let o = 0; o < l.length; o++) {
                        let n = l[o];
                        if (f.contains(n)) {
                            m = true;
                        }
                    }
                }
                if (!m) {
                    let p = a.indexOf("\"" + j + "\"");
                    let q = this.l(a, p);
                    let r = q.c;
                    let s = q.d;
                    let t = s + ("\"" + j + "\"").length;
                    i = this.f(i, r, s, r, t, "Type " + j + " appears not to have a containing module, consider adding one of: " + stringJoin(", ", ...l));
                }
            }
            for (let v = 0; v < d.length; v++) {
                let u = d[v];
                if (u == "PropertyEditor") {
                    let w = a.indexOf("\"" + u + "\"");
                    let x = this.l(a, w);
                    let y = x.c;
                    let z = x.d;
                    let aa = z + ("\"" + u + "\"").length;
                    if (!f.contains("withDescriptions")) {
                        i = this.f(i, y, z, y, aa, "Property editor is included, but withDescriptions is not in modules, did you forget it?");
                    }
                }
            }
            return i == null ? null : i.b();
        }
        l(a, b) {
            let c = a.split('\n');
            let d = 0;
            let e = 0;
            while (e <= b && d < c.length) {
                let f = c[d];
                if ((f.length + 1) >= (b - e)) {
                    return new Tuple$2(Number_$type, Number_$type, d + 1, (b - e) + 1);
                }
                e += (f.length + 1);
                d++;
            }
            return new Tuple$2(Number_$type, Number_$type, d + 1, (b - e) + 1);
        }
        f(a, b, c, d, e, f) {
            if (a == null) {
                a = new JsonDictionaryObject();
                a.item("warnings", new JsonDictionaryArray());
            }
            let g = a.item("warnings");
            let h = g.items;
            let i = new List$1(JsonDictionaryItem.$, 0);
            if (h != null) {
                for (let j = 0; j < h.length; j++) {
                    i.add(h[j]);
                }
            }
            let k = new JsonDictionaryObject();
            k.item("line", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = b;
                return $ret;
            })()));
            k.item("column", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = c;
                return $ret;
            })()));
            k.item("endLine", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = d;
                return $ret;
            })()));
            k.item("endColumn", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 0;
                $ret.value = e;
                return $ret;
            })()));
            k.item("message", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = f;
                return $ret;
            })()));
            i.add(k);
            g.items = i.toArray();
            return a;
        }
        a(a) {
            let b = new List$1(String_$type, 0);
            if (a != null && a.g("modules")) {
                if (typeCast(JsonDictionaryArray.$, a.item("modules")) !== null) {
                    let c = a.item("modules");
                    if (c.items != null) {
                        for (let d = 0; d < c.items.length; d++) {
                            let e = c.items[d];
                            let f = e.value.toString();
                            if (stringContains(f, "/")) {
                                let g = f.split('/');
                                b.add(g[1]);
                            }
                            else {
                                b.add(f);
                            }
                        }
                    }
                }
            }
            return b.toArray();
        }
        b(a) {
            let b = new HashSet$1(String_$type, 0);
            this.m(b, null, a);
            let c = new List$1(String_$type, 0);
            for (let d of fromEnum(b)) {
                c.add(d);
            }
            return c.toArray();
        }
        m(a, b, c) {
            if (typeCast(JsonDictionaryObject.$, c) !== null) {
                let d = c;
                let e = d.e();
                for (let g = 0; g < e.length; g++) {
                    let f = e[g];
                    this.m(a, f, d.item(f));
                }
            }
            if (typeCast(JsonDictionaryArray.$, c) !== null) {
                let h = c;
                if (h.items != null) {
                    for (let i = 0; i < h.items.length; i++) {
                        this.m(a, b + "[" + i + "]", h.items[i]);
                    }
                }
            }
            if (typeCast(JsonDictionaryValue.$, c) !== null) {
                if (b != null && b == "type") {
                    a.add_1(c.value.toString());
                }
            }
        }
        static fromJson(a) {
            let b = new DescriptionJsonValidator();
            let c = new JsonDictionaryParser();
            let d = c.parse(a);
            let e = typeCast(JsonDictionaryObject.$, d);
            if (e != null) {
                if (e.g("types")) {
                    let f = e.item("types");
                    if (f.items != null) {
                        for (let g = 0; g < f.items.length; g++) {
                            b.i.add(f.items[g].value.toString());
                        }
                    }
                }
                if (e.g("containingModules")) {
                    let h = e.item("containingModules");
                    let i = h.e();
                    for (let j = 0; j < i.length; j++) {
                        let k = i[j];
                        let l = h.item(k);
                        b.h.item(k, new List$1(String_$type, 0));
                        for (let m = 0; m < l.items.length; m++) {
                            let n = l.items[m];
                            b.h.item(k).add(n.value.toString());
                        }
                    }
                }
            }
            return b;
        }
        toJson() {
            let a = new JsonDictionaryObject();
            let b = new JsonDictionaryArray();
            let c = new List$1(JsonDictionaryItem.$, 0);
            for (let d of fromEnum(this.i)) {
                c.add(((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.value = d;
                    $ret.e = 2;
                    return $ret;
                })()));
            }
            b.items = c.toArray();
            a.item("types", b);
            let e = new JsonDictionaryObject();
            for (let f of fromEnum(this.h.keys)) {
                let g = new List$1(JsonDictionaryItem.$, 0);
                for (let h of fromEnum(this.h.item(f))) {
                    g.add(((() => {
                        let $ret = new JsonDictionaryValue();
                        $ret.value = h;
                        $ret.e = 2;
                        return $ret;
                    })()));
                }
                e.item(f, ((() => {
                    let $ret = new JsonDictionaryArray();
                    $ret.items = g.toArray();
                    return $ret;
                })()));
            }
            a.item("containingModules", e);
            return a.b();
        }
    }
    DescriptionJsonValidator.$t = /*@__PURE__*/ markType(DescriptionJsonValidator, 'DescriptionJsonValidator');
    return DescriptionJsonValidator;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisAnnotationDescription = /*@__PURE__*/ (() => {
    class AxisAnnotationDescription extends Description {
        get_type() {
            return "AxisAnnotation";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.ab = null;
            this.z = null;
            this.j = 0;
            this.x = null;
            this.h = null;
            this.w = null;
            this.aa = null;
            this.v = null;
            this.y = null;
            this.o = 0;
            this.l = 0;
            this.n = 0;
            this.m = 0;
            this.k = 0;
        }
        get valueRef() {
            return this.ab;
        }
        set valueRef(a) {
            this.ab = a;
            this.g("ValueRef");
        }
        get text() {
            return this.z;
        }
        set text(a) {
            this.z = a;
            this.g("Text");
        }
        get backgroundCornerRadius() {
            return this.j;
        }
        set backgroundCornerRadius(a) {
            this.j = a;
            this.g("BackgroundCornerRadius");
        }
        get labelFormat() {
            return this.x;
        }
        set labelFormat(a) {
            this.x = a;
            this.g("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.h;
        }
        set labelFormatSpecifiers(a) {
            this.h = a;
            this.g("LabelFormatSpecifiers");
        }
        get formatLabelRef() {
            return this.w;
        }
        set formatLabelRef(a) {
            this.w = a;
            this.g("FormatLabelRef");
        }
        get textColor() {
            return this.aa;
        }
        set textColor(a) {
            this.aa = a;
            this.g("TextColor");
        }
        get background() {
            return this.v;
        }
        set background(a) {
            this.v = a;
            this.g("Background");
        }
        get outline() {
            return this.y;
        }
        set outline(a) {
            this.y = a;
            this.g("Outline");
        }
        get strokeThickness() {
            return this.o;
        }
        set strokeThickness(a) {
            this.o = a;
            this.g("StrokeThickness");
        }
        get backgroundPaddingLeft() {
            return this.l;
        }
        set backgroundPaddingLeft(a) {
            this.l = a;
            this.g("BackgroundPaddingLeft");
        }
        get backgroundPaddingTop() {
            return this.n;
        }
        set backgroundPaddingTop(a) {
            this.n = a;
            this.g("BackgroundPaddingTop");
        }
        get backgroundPaddingRight() {
            return this.m;
        }
        set backgroundPaddingRight(a) {
            this.m = a;
            this.g("BackgroundPaddingRight");
        }
        get backgroundPaddingBottom() {
            return this.k;
        }
        set backgroundPaddingBottom(a) {
            this.k = a;
            this.g("BackgroundPaddingBottom");
        }
    }
    AxisAnnotationDescription.$t = /*@__PURE__*/ markType(AxisAnnotationDescription, 'AxisAnnotationDescription', Description.$);
    return AxisAnnotationDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisAnnotationDescriptionMetadata = /*@__PURE__*/ (() => {
    class AxisAnnotationDescriptionMetadata extends Base {
        static b(a) {
            if (AxisAnnotationDescriptionMetadata.a == null) {
                AxisAnnotationDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AxisAnnotationDescriptionMetadata.c(AxisAnnotationDescriptionMetadata.a);
            }
            if (a.k(AxisAnnotationDescriptionMetadata.a)) {
                return;
            }
            a.ac(AxisAnnotationDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
            a.item("Text", "String");
            a.item("BackgroundCornerRadius", "Number:double");
            a.item("LabelFormat", "String");
            a.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("LabelFormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("FormatLabelRef", "(w:FormatLabel,wf:FormatLabel)MethodRef");
            a.item("TextColor", "Brush");
            a.item("Background", "Brush");
            a.item("Outline", "Brush");
            a.item("StrokeThickness", "Number:double");
            a.item("BackgroundPaddingLeft", "Number:double");
            a.item("BackgroundPaddingTop", "Number:double");
            a.item("BackgroundPaddingRight", "Number:double");
            a.item("BackgroundPaddingBottom", "Number:double");
        }
        static d(a) {
            AxisAnnotationDescriptionMetadata.b(a);
            a.ae("AxisAnnotation", () => new AxisAnnotationDescription());
            a.ad("AxisAnnotation", AxisAnnotationDescriptionMetadata.a);
        }
    }
    AxisAnnotationDescriptionMetadata.$t = /*@__PURE__*/ markType(AxisAnnotationDescriptionMetadata, 'AxisAnnotationDescriptionMetadata');
    AxisAnnotationDescriptionMetadata.a = null;
    return AxisAnnotationDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutAnnotationDescription = /*@__PURE__*/ (() => {
    class CalloutAnnotationDescription extends Description {
        get_type() {
            return "CalloutAnnotation";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.ae = null;
            this.af = null;
            this.ac = null;
            this.z = null;
            this.w = null;
            this.h = null;
            this.y = null;
            this.x = null;
            this.ad = null;
            this.v = null;
            this.ab = null;
            this.aa = null;
            this.o = 0;
            this.l = 0;
            this.n = 0;
            this.m = 0;
            this.k = 0;
            this.j = 0;
        }
        get xValueRef() {
            return this.ae;
        }
        set xValueRef(a) {
            this.ae = a;
            this.g("XValueRef");
        }
        get yValueRef() {
            return this.af;
        }
        set yValueRef(a) {
            this.af = a;
            this.g("YValueRef");
        }
        get text() {
            return this.ac;
        }
        set text(a) {
            this.ac = a;
            this.g("Text");
        }
        get keyRef() {
            return this.z;
        }
        set keyRef(a) {
            this.z = a;
            this.g("KeyRef");
        }
        get contentRef() {
            return this.w;
        }
        set contentRef(a) {
            this.w = a;
            this.g("ContentRef");
        }
        get series() {
            return this.h;
        }
        set series(a) {
            this.h = a;
            this.g("Series");
        }
        get itemColor() {
            return this.y;
        }
        set itemColor(a) {
            this.y = a;
            this.g("ItemColor");
        }
        get formatLabelRef() {
            return this.x;
        }
        set formatLabelRef(a) {
            this.x = a;
            this.g("FormatLabelRef");
        }
        get textColor() {
            return this.ad;
        }
        set textColor(a) {
            this.ad = a;
            this.g("TextColor");
        }
        get background() {
            return this.v;
        }
        set background(a) {
            this.v = a;
            this.g("Background");
        }
        get outline() {
            return this.ab;
        }
        set outline(a) {
            this.ab = a;
            this.g("Outline");
        }
        get leaderBrush() {
            return this.aa;
        }
        set leaderBrush(a) {
            this.aa = a;
            this.g("LeaderBrush");
        }
        get strokeThickness() {
            return this.o;
        }
        set strokeThickness(a) {
            this.o = a;
            this.g("StrokeThickness");
        }
        get backgroundPaddingLeft() {
            return this.l;
        }
        set backgroundPaddingLeft(a) {
            this.l = a;
            this.g("BackgroundPaddingLeft");
        }
        get backgroundPaddingTop() {
            return this.n;
        }
        set backgroundPaddingTop(a) {
            this.n = a;
            this.g("BackgroundPaddingTop");
        }
        get backgroundPaddingRight() {
            return this.m;
        }
        set backgroundPaddingRight(a) {
            this.m = a;
            this.g("BackgroundPaddingRight");
        }
        get backgroundPaddingBottom() {
            return this.k;
        }
        set backgroundPaddingBottom(a) {
            this.k = a;
            this.g("BackgroundPaddingBottom");
        }
        get backgroundCornerRadius() {
            return this.j;
        }
        set backgroundCornerRadius(a) {
            this.j = a;
            this.g("BackgroundCornerRadius");
        }
    }
    CalloutAnnotationDescription.$t = /*@__PURE__*/ markType(CalloutAnnotationDescription, 'CalloutAnnotationDescription', Description.$);
    return CalloutAnnotationDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutAnnotationDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalloutAnnotationDescriptionMetadata extends Base {
        static b(a) {
            if (CalloutAnnotationDescriptionMetadata.a == null) {
                CalloutAnnotationDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalloutAnnotationDescriptionMetadata.c(CalloutAnnotationDescriptionMetadata.a);
            }
            if (a.k(CalloutAnnotationDescriptionMetadata.a)) {
                return;
            }
            a.ac(CalloutAnnotationDescriptionMetadata.a);
            SeriesDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("XValueRef", "(w:XValue,wf:XValue)DataRef");
            a.item("YValueRef", "(w:YValue,wf:YValue)DataRef");
            a.item("Text", "String");
            a.item("KeyRef", "(w:Key,wf:Key)DataRef");
            a.item("ContentRef", "(w:Content,wf:Content)DataRef");
            a.item("Series", "ExportedType:Series");
            a.item("ItemColor", "Brush");
            a.item("FormatLabelRef", "(w:FormatLabel,wf:FormatLabel)MethodRef");
            a.item("TextColor", "Brush");
            a.item("Background", "Brush");
            a.item("Outline", "Brush");
            a.item("LeaderBrush", "Brush");
            a.item("StrokeThickness", "Number:double");
            a.item("BackgroundPaddingLeft", "Number:double");
            a.item("BackgroundPaddingTop", "Number:double");
            a.item("BackgroundPaddingRight", "Number:double");
            a.item("BackgroundPaddingBottom", "Number:double");
            a.item("BackgroundCornerRadius", "Number:double");
        }
        static d(a) {
            CalloutAnnotationDescriptionMetadata.b(a);
            a.ae("CalloutAnnotation", () => new CalloutAnnotationDescription());
            a.ad("CalloutAnnotation", CalloutAnnotationDescriptionMetadata.a);
        }
    }
    CalloutAnnotationDescriptionMetadata.$t = /*@__PURE__*/ markType(CalloutAnnotationDescriptionMetadata, 'CalloutAnnotationDescriptionMetadata');
    CalloutAnnotationDescriptionMetadata.a = null;
    return CalloutAnnotationDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnComparisonFilterConditionDescription = /*@__PURE__*/ (() => {
    class ColumnComparisonFilterConditionDescription extends ColumnFilterConditionDescription {
        get_type() {
            return "ColumnComparisonFilterCondition";
        }
        constructor() {
            super();
            this.k = null;
            this.l = null;
            this.i = false;
        }
        get operator() {
            return this.k;
        }
        set operator(a) {
            this.k = a;
            this.g("Operator");
        }
        get valueRef() {
            return this.l;
        }
        set valueRef(a) {
            this.l = a;
            this.g("ValueRef");
        }
        get isCaseSensitive() {
            return this.i;
        }
        set isCaseSensitive(a) {
            this.i = a;
            this.g("IsCaseSensitive");
        }
    }
    ColumnComparisonFilterConditionDescription.$t = /*@__PURE__*/ markType(ColumnComparisonFilterConditionDescription, 'ColumnComparisonFilterConditionDescription', ColumnFilterConditionDescription.$);
    return ColumnComparisonFilterConditionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnComparisonFilterConditionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnComparisonFilterConditionDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnComparisonFilterConditionDescriptionMetadata.a == null) {
                ColumnComparisonFilterConditionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnComparisonFilterConditionDescriptionMetadata.c(ColumnComparisonFilterConditionDescriptionMetadata.a);
            }
            if (a.k(ColumnComparisonFilterConditionDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnComparisonFilterConditionDescriptionMetadata.a);
        }
        static c(a) {
            ColumnFilterConditionDescriptionMetadata.c(a);
            a.item("Operator", "ExportedType:string:ColumnComparisonConditionOperatorType");
            a.item("Operator@names", "Equals;NotEquals;LessThan;LessThanOrEqualTo;GreaterThan;GreaterThanOrEqualTo;Top;Bottom;TopPercentile;BottomPercentile;True;False;Contains;DoesNotContain;StartsWith;DoesNotStartWith;EndsWith;DoesNotEndWith;Today;Tomorrow;Yesterday;NextWeek;ThisWeek;LastWeek;NextMonth;ThisMonth;LastMonth;NextQuarter;ThisQuarter;LastQuarter;NextYear;ThisYear;LastYear;YearToDate;Q1;Q2;Q3;Q4;Month;Year;Empty;NotEmpty;IsNull;IsNotNull;Custom");
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
            a.item("IsCaseSensitive", "Boolean");
        }
        static d(a) {
            ColumnComparisonFilterConditionDescriptionMetadata.b(a);
            a.ae("ColumnComparisonFilterCondition", () => new ColumnComparisonFilterConditionDescription());
            a.ad("ColumnComparisonFilterCondition", ColumnComparisonFilterConditionDescriptionMetadata.a);
        }
    }
    ColumnComparisonFilterConditionDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnComparisonFilterConditionDescriptionMetadata, 'ColumnComparisonFilterConditionDescriptionMetadata');
    ColumnComparisonFilterConditionDescriptionMetadata.a = null;
    return ColumnComparisonFilterConditionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnExchangerDescription = /*@__PURE__*/ (() => {
    class ColumnExchangerDescription extends Description {
        get_type() {
            return "ColumnExchanger";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = 0;
        }
        get targetIndex() {
            return this.h;
        }
        set targetIndex(a) {
            this.h = a;
            this.g("TargetIndex");
        }
    }
    ColumnExchangerDescription.$t = /*@__PURE__*/ markType(ColumnExchangerDescription, 'ColumnExchangerDescription', Description.$);
    return ColumnExchangerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnExchangerDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnExchangerDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnExchangerDescriptionMetadata.a == null) {
                ColumnExchangerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnExchangerDescriptionMetadata.c(ColumnExchangerDescriptionMetadata.a);
            }
            if (a.k(ColumnExchangerDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnExchangerDescriptionMetadata.a);
        }
        static c(a) {
            a.item("TargetIndex", "Number:int");
        }
        static d(a) {
            ColumnExchangerDescriptionMetadata.b(a);
            a.ae("ColumnExchanger", () => new ColumnExchangerDescription());
            a.ad("ColumnExchanger", ColumnExchangerDescriptionMetadata.a);
        }
    }
    ColumnExchangerDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnExchangerDescriptionMetadata, 'ColumnExchangerDescriptionMetadata');
    ColumnExchangerDescriptionMetadata.a = null;
    return ColumnExchangerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnFilterConditionGroupDescription = /*@__PURE__*/ (() => {
    class ColumnFilterConditionGroupDescription extends ColumnFilterConditionDescription {
        get_type() {
            return "ColumnFilterConditionGroup";
        }
        constructor() {
            super();
            this.k = false;
            this.i = null;
        }
        get usesOrOperator() {
            return this.k;
        }
        set usesOrOperator(a) {
            this.k = a;
            this.g("UsesOrOperator");
        }
        get item() {
            return this.i;
        }
        set item(a) {
            this.i = a;
            this.g("Item");
        }
    }
    ColumnFilterConditionGroupDescription.$t = /*@__PURE__*/ markType(ColumnFilterConditionGroupDescription, 'ColumnFilterConditionGroupDescription', ColumnFilterConditionDescription.$);
    return ColumnFilterConditionGroupDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnFilterConditionGroupDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnFilterConditionGroupDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnFilterConditionGroupDescriptionMetadata.a == null) {
                ColumnFilterConditionGroupDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnFilterConditionGroupDescriptionMetadata.c(ColumnFilterConditionGroupDescriptionMetadata.a);
            }
            if (a.k(ColumnFilterConditionGroupDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnFilterConditionGroupDescriptionMetadata.a);
            ColumnFilterConditionDescriptionMetadata.d(a);
        }
        static c(a) {
            ColumnFilterConditionDescriptionMetadata.c(a);
            a.item("UsesOrOperator", "Boolean");
            a.item("Item", "(w:this[],wf:this[])ExportedType:ColumnFilterCondition");
        }
        static d(a) {
            ColumnFilterConditionGroupDescriptionMetadata.b(a);
            a.ae("ColumnFilterConditionGroup", () => new ColumnFilterConditionGroupDescription());
            a.ad("ColumnFilterConditionGroup", ColumnFilterConditionGroupDescriptionMetadata.a);
        }
    }
    ColumnFilterConditionGroupDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnFilterConditionGroupDescriptionMetadata, 'ColumnFilterConditionGroupDescriptionMetadata');
    ColumnFilterConditionGroupDescriptionMetadata.a = null;
    return ColumnFilterConditionGroupDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnPropertySetterDescription = /*@__PURE__*/ (() => {
    class ColumnPropertySetterDescription extends Description {
        get_type() {
            return "ColumnPropertySetter";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
            this.i = null;
            this.j = null;
        }
        get columnName() {
            return this.h;
        }
        set columnName(a) {
            this.h = a;
            this.g("ColumnName");
        }
        get propertyName() {
            return this.i;
        }
        set propertyName(a) {
            this.i = a;
            this.g("PropertyName");
        }
        get valueRef() {
            return this.j;
        }
        set valueRef(a) {
            this.j = a;
            this.g("ValueRef");
        }
    }
    ColumnPropertySetterDescription.$t = /*@__PURE__*/ markType(ColumnPropertySetterDescription, 'ColumnPropertySetterDescription', Description.$);
    return ColumnPropertySetterDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnPropertySetterDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnPropertySetterDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnPropertySetterDescriptionMetadata.a == null) {
                ColumnPropertySetterDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnPropertySetterDescriptionMetadata.c(ColumnPropertySetterDescriptionMetadata.a);
            }
            if (a.k(ColumnPropertySetterDescriptionMetadata.a)) {
                return;
            }
            a.ac(ColumnPropertySetterDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ColumnName", "String");
            a.item("PropertyName", "String");
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
        }
        static d(a) {
            ColumnPropertySetterDescriptionMetadata.b(a);
            a.ae("ColumnPropertySetter", () => new ColumnPropertySetterDescription());
            a.ad("ColumnPropertySetter", ColumnPropertySetterDescriptionMetadata.a);
        }
    }
    ColumnPropertySetterDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnPropertySetterDescriptionMetadata, 'ColumnPropertySetterDescriptionMetadata');
    ColumnPropertySetterDescriptionMetadata.a = null;
    return ColumnPropertySetterDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ContourValueResolverDescription = /*@__PURE__*/ (() => {
    class ContourValueResolverDescription extends Description {
        get_type() {
            return "ContourValueResolver";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ContourValueResolverDescription.$t = /*@__PURE__*/ markType(ContourValueResolverDescription, 'ContourValueResolverDescription', Description.$);
    return ContourValueResolverDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomContourValueResolverDescription = /*@__PURE__*/ (() => {
    class CustomContourValueResolverDescription extends ContourValueResolverDescription {
        get_type() {
            return "CustomContourValueResolver";
        }
        constructor() {
            super();
            this.i = null;
        }
        get getCustomContourValuesRef() {
            return this.i;
        }
        set getCustomContourValuesRef(a) {
            this.i = a;
            this.g("GetCustomContourValuesRef");
        }
    }
    CustomContourValueResolverDescription.$t = /*@__PURE__*/ markType(CustomContourValueResolverDescription, 'CustomContourValueResolverDescription', ContourValueResolverDescription.$);
    return CustomContourValueResolverDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomContourValueResolverEventArgsDescription = /*@__PURE__*/ (() => {
    class CustomContourValueResolverEventArgsDescription extends Description {
        get_type() {
            return "CustomContourValueResolverEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get contourValues() {
            return this.h;
        }
        set contourValues(a) {
            this.h = a;
            this.g("ContourValues");
        }
    }
    CustomContourValueResolverEventArgsDescription.$t = /*@__PURE__*/ markType(CustomContourValueResolverEventArgsDescription, 'CustomContourValueResolverEventArgsDescription', Description.$);
    return CustomContourValueResolverEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomContourValueResolverEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CustomContourValueResolverEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CustomContourValueResolverEventArgsDescriptionMetadata.a == null) {
                CustomContourValueResolverEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CustomContourValueResolverEventArgsDescriptionMetadata.c(CustomContourValueResolverEventArgsDescriptionMetadata.a);
            }
            if (a.k(CustomContourValueResolverEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(CustomContourValueResolverEventArgsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ContourValues", "Array:double");
        }
        static d(a) {
            CustomContourValueResolverEventArgsDescriptionMetadata.b(a);
            a.ae("CustomContourValueResolverEventArgs", () => new CustomContourValueResolverEventArgsDescription());
            a.ad("CustomContourValueResolverEventArgs", CustomContourValueResolverEventArgsDescriptionMetadata.a);
        }
    }
    CustomContourValueResolverEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CustomContourValueResolverEventArgsDescriptionMetadata, 'CustomContourValueResolverEventArgsDescriptionMetadata');
    CustomContourValueResolverEventArgsDescriptionMetadata.a = null;
    return CustomContourValueResolverEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomContourValueResolverDescriptionMetadata = /*@__PURE__*/ (() => {
    class CustomContourValueResolverDescriptionMetadata extends Base {
        static b(a) {
            if (CustomContourValueResolverDescriptionMetadata.a == null) {
                CustomContourValueResolverDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CustomContourValueResolverDescriptionMetadata.c(CustomContourValueResolverDescriptionMetadata.a);
            }
            if (a.k(CustomContourValueResolverDescriptionMetadata.a)) {
                return;
            }
            a.ac(CustomContourValueResolverDescriptionMetadata.a);
            CustomContourValueResolverEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            ContourValueResolverDescriptionMetadata.c(a);
            a.item("GetCustomContourValuesRef", "EventRef::getCustomContourValues");
        }
        static d(a) {
            CustomContourValueResolverDescriptionMetadata.b(a);
            a.ae("CustomContourValueResolver", () => new CustomContourValueResolverDescription());
            a.ad("CustomContourValueResolver", CustomContourValueResolverDescriptionMetadata.a);
        }
    }
    CustomContourValueResolverDescriptionMetadata.$t = /*@__PURE__*/ markType(CustomContourValueResolverDescriptionMetadata, 'CustomContourValueResolverDescriptionMetadata');
    CustomContourValueResolverDescriptionMetadata.a = null;
    return CustomContourValueResolverDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomContourValueResolverDescriptionModule = /*@__PURE__*/ (() => {
    class CustomContourValueResolverDescriptionModule extends Base {
        static register(a) {
            CustomContourValueResolverDescriptionMetadata.d(a);
        }
    }
    CustomContourValueResolverDescriptionModule.$t = /*@__PURE__*/ markType(CustomContourValueResolverDescriptionModule, 'CustomContourValueResolverDescriptionModule');
    return CustomContourValueResolverDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomPaletteBrushScaleDescription = /*@__PURE__*/ (() => {
    class CustomPaletteBrushScaleDescription extends BrushScaleDescription {
        get_type() {
            return "CustomPaletteBrushScale";
        }
        constructor() {
            super();
            this.m = null;
        }
        get brushSelectionMode() {
            return this.m;
        }
        set brushSelectionMode(a) {
            this.m = a;
            this.g("BrushSelectionMode");
        }
    }
    CustomPaletteBrushScaleDescription.$t = /*@__PURE__*/ markType(CustomPaletteBrushScaleDescription, 'CustomPaletteBrushScaleDescription', BrushScaleDescription.$);
    return CustomPaletteBrushScaleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomPaletteBrushScaleDescriptionMetadata = /*@__PURE__*/ (() => {
    class CustomPaletteBrushScaleDescriptionMetadata extends Base {
        static b(a) {
            if (CustomPaletteBrushScaleDescriptionMetadata.a == null) {
                CustomPaletteBrushScaleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CustomPaletteBrushScaleDescriptionMetadata.c(CustomPaletteBrushScaleDescriptionMetadata.a);
            }
            if (a.k(CustomPaletteBrushScaleDescriptionMetadata.a)) {
                return;
            }
            a.ac(CustomPaletteBrushScaleDescriptionMetadata.a);
        }
        static c(a) {
            BrushScaleDescriptionMetadata.c(a);
            a.item("BrushSelectionMode", "ExportedType:string:BrushSelectionMode");
            a.item("BrushSelectionMode@names", "Select;Interpolate");
        }
        static d(a) {
            CustomPaletteBrushScaleDescriptionMetadata.b(a);
            a.ae("CustomPaletteBrushScale", () => new CustomPaletteBrushScaleDescription());
            a.ad("CustomPaletteBrushScale", CustomPaletteBrushScaleDescriptionMetadata.a);
        }
    }
    CustomPaletteBrushScaleDescriptionMetadata.$t = /*@__PURE__*/ markType(CustomPaletteBrushScaleDescriptionMetadata, 'CustomPaletteBrushScaleDescriptionMetadata');
    CustomPaletteBrushScaleDescriptionMetadata.a = null;
    return CustomPaletteBrushScaleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomPaletteBrushScaleDescriptionModule = /*@__PURE__*/ (() => {
    class CustomPaletteBrushScaleDescriptionModule extends Base {
        static register(a) {
            BrushScaleDescriptionModule.register(a);
            CustomPaletteBrushScaleDescriptionMetadata.d(a);
        }
    }
    CustomPaletteBrushScaleDescriptionModule.$t = /*@__PURE__*/ markType(CustomPaletteBrushScaleDescriptionModule, 'CustomPaletteBrushScaleDescriptionModule');
    return CustomPaletteBrushScaleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceDataProviderSchemaChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class DataSourceDataProviderSchemaChangedEventArgsDescription extends Description {
        get_type() {
            return "DataSourceDataProviderSchemaChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    DataSourceDataProviderSchemaChangedEventArgsDescription.$t = /*@__PURE__*/ markType(DataSourceDataProviderSchemaChangedEventArgsDescription, 'DataSourceDataProviderSchemaChangedEventArgsDescription', Description.$);
    return DataSourceDataProviderSchemaChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.a == null) {
                DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.c(DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.a);
            }
            if (a.k(DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.b(a);
            a.ae("DataSourceDataProviderSchemaChangedEventArgs", () => new DataSourceDataProviderSchemaChangedEventArgsDescription());
            a.ad("DataSourceDataProviderSchemaChangedEventArgs", DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.a);
        }
    }
    DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata, 'DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata');
    DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.a = null;
    return DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeCellInfoDescription = /*@__PURE__*/ (() => {
    class DateTimeCellInfoDescription extends CellInfoDescription {
        get_type() {
            return "DateTimeCellInfo";
        }
        constructor() {
            super();
            this.fq = new Date();
            this.fv = null;
            this.fl = null;
            this.fu = null;
            this.ft = null;
            this.fo = false;
        }
        get dateTimeValue() {
            return this.fq;
        }
        set dateTimeValue(a) {
            this.fq = a;
            this.g("DateTimeValue");
        }
        get formatStringOverride() {
            return this.fv;
        }
        set formatStringOverride(a) {
            this.fv = a;
            this.g("FormatStringOverride");
        }
        get formatSpecifiers() {
            return this.fl;
        }
        set formatSpecifiers(a) {
            this.fl = a;
            this.g("FormatSpecifiers");
        }
        get formatOverrideRef() {
            return this.fu;
        }
        set formatOverrideRef(a) {
            this.fu = a;
            this.g("FormatOverrideRef");
        }
        get dateTimeFormat() {
            return this.ft;
        }
        set dateTimeFormat(a) {
            this.ft = a;
            this.g("DateTimeFormat");
        }
        get isOffsetValue() {
            return this.fo;
        }
        set isOffsetValue(a) {
            this.fo = a;
            this.g("IsOffsetValue");
        }
    }
    DateTimeCellInfoDescription.$t = /*@__PURE__*/ markType(DateTimeCellInfoDescription, 'DateTimeCellInfoDescription', CellInfoDescription.$);
    DateTimeCellInfoDescription.__marshalByValue1 = true;
    DateTimeCellInfoDescription.__marshalByValueAlias1 = "DateTimeCellModel";
    return DateTimeCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class DateTimeCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (DateTimeCellInfoDescriptionMetadata.a == null) {
                DateTimeCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DateTimeCellInfoDescriptionMetadata.c(DateTimeCellInfoDescriptionMetadata.a);
            }
            if (a.k(DateTimeCellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(DateTimeCellInfoDescriptionMetadata.a);
        }
        static c(a) {
            CellInfoDescriptionMetadata.c(a);
            a.item("DateTimeValue", "Date");
            a.item("FormatStringOverride", "String");
            a.item("FormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("FormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("FormatOverrideRef", "(w:FormatOverride,wf:FormatOverride)DataRef");
            a.item("DateTimeFormat", "ExportedType:string:DateTimeFormats");
            a.item("DateTimeFormat@names", "DateShort;DateLong;TimeShort;TimeLong;DateTimeShort;DateTimeLong");
            a.item("IsOffsetValue", "Boolean");
        }
        static d(a) {
            DateTimeCellInfoDescriptionMetadata.b(a);
            a.ae("DateTimeCellInfo", () => new DateTimeCellInfoDescription());
            a.ad("DateTimeCellInfo", DateTimeCellInfoDescriptionMetadata.a);
        }
    }
    DateTimeCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(DateTimeCellInfoDescriptionMetadata, 'DateTimeCellInfoDescriptionMetadata');
    DateTimeCellInfoDescriptionMetadata.a = null;
    return DateTimeCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridAnimationPhaseSettingsDescription = /*@__PURE__*/ (() => {
    class GridAnimationPhaseSettingsDescription extends Description {
        get_type() {
            return "GridAnimationPhaseSettings";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = 0;
            this.l = 0;
            this.m = 0;
            this.n = 0;
            this.j = 0;
            this.h = false;
            this.t = null;
        }
        get durationMilliseconds() {
            return this.k;
        }
        set durationMilliseconds(a) {
            this.k = a;
            this.g("DurationMilliseconds");
        }
        get holdInitialMilliseconds() {
            return this.l;
        }
        set holdInitialMilliseconds(a) {
            this.l = a;
            this.g("HoldInitialMilliseconds");
        }
        get perItemDelayMilliseconds() {
            return this.m;
        }
        set perItemDelayMilliseconds(a) {
            this.m = a;
            this.g("PerItemDelayMilliseconds");
        }
        get subItemDurationMilliseconds() {
            return this.n;
        }
        set subItemDurationMilliseconds(a) {
            this.n = a;
            this.g("SubItemDurationMilliseconds");
        }
        get desiredSubItemDurationMilliseconds() {
            return this.j;
        }
        set desiredSubItemDurationMilliseconds(a) {
            this.j = a;
            this.g("DesiredSubItemDurationMilliseconds");
        }
        get shouldItemsFinishSimultaneously() {
            return this.h;
        }
        set shouldItemsFinishSimultaneously(a) {
            this.h = a;
            this.g("ShouldItemsFinishSimultaneously");
        }
        get easingFunctionType() {
            return this.t;
        }
        set easingFunctionType(a) {
            this.t = a;
            this.g("EasingFunctionType");
        }
    }
    GridAnimationPhaseSettingsDescription.$t = /*@__PURE__*/ markType(GridAnimationPhaseSettingsDescription, 'GridAnimationPhaseSettingsDescription', Description.$);
    return GridAnimationPhaseSettingsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridAnimationPhaseSettingsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridAnimationPhaseSettingsDescriptionMetadata extends Base {
        static b(a) {
            if (GridAnimationPhaseSettingsDescriptionMetadata.a == null) {
                GridAnimationPhaseSettingsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridAnimationPhaseSettingsDescriptionMetadata.c(GridAnimationPhaseSettingsDescriptionMetadata.a);
            }
            if (a.k(GridAnimationPhaseSettingsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridAnimationPhaseSettingsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("DurationMilliseconds", "Number:int");
            a.item("HoldInitialMilliseconds", "Number:int");
            a.item("PerItemDelayMilliseconds", "Number:int");
            a.item("SubItemDurationMilliseconds", "Number:int");
            a.item("DesiredSubItemDurationMilliseconds", "Number:int");
            a.item("ShouldItemsFinishSimultaneously", "Boolean");
            a.item("EasingFunctionType", "ExportedType:string:GridEasingFunctionType");
            a.item("EasingFunctionType@names", "Linear;CubicInOut;ExponentialInOut;CircleInOut");
        }
        static d(a) {
            GridAnimationPhaseSettingsDescriptionMetadata.b(a);
            a.ae("GridAnimationPhaseSettings", () => new GridAnimationPhaseSettingsDescription());
            a.ad("GridAnimationPhaseSettings", GridAnimationPhaseSettingsDescriptionMetadata.a);
        }
    }
    GridAnimationPhaseSettingsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridAnimationPhaseSettingsDescriptionMetadata, 'GridAnimationPhaseSettingsDescriptionMetadata');
    GridAnimationPhaseSettingsDescriptionMetadata.a = null;
    return GridAnimationPhaseSettingsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogFilterChangeEventArgsDescription = /*@__PURE__*/ (() => {
    class GridFilterDialogFilterChangeEventArgsDescription extends Description {
        get_type() {
            return "GridFilterDialogFilterChangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get filter() {
            return this.h;
        }
        set filter(a) {
            this.h = a;
            this.g("Filter");
        }
    }
    GridFilterDialogFilterChangeEventArgsDescription.$t = /*@__PURE__*/ markType(GridFilterDialogFilterChangeEventArgsDescription, 'GridFilterDialogFilterChangeEventArgsDescription', Description.$);
    return GridFilterDialogFilterChangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogFilterChangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridFilterDialogFilterChangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridFilterDialogFilterChangeEventArgsDescriptionMetadata.a == null) {
                GridFilterDialogFilterChangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridFilterDialogFilterChangeEventArgsDescriptionMetadata.c(GridFilterDialogFilterChangeEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridFilterDialogFilterChangeEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridFilterDialogFilterChangeEventArgsDescriptionMetadata.a);
            ColumnFilterConditionDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Filter", "ExportedType:ColumnFilterCondition");
        }
        static d(a) {
            GridFilterDialogFilterChangeEventArgsDescriptionMetadata.b(a);
            a.ae("GridFilterDialogFilterChangeEventArgs", () => new GridFilterDialogFilterChangeEventArgsDescription());
            a.ad("GridFilterDialogFilterChangeEventArgs", GridFilterDialogFilterChangeEventArgsDescriptionMetadata.a);
        }
    }
    GridFilterDialogFilterChangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridFilterDialogFilterChangeEventArgsDescriptionMetadata, 'GridFilterDialogFilterChangeEventArgsDescriptionMetadata');
    GridFilterDialogFilterChangeEventArgsDescriptionMetadata.a = null;
    return GridFilterDialogFilterChangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogOpeningEventArgsDescription = /*@__PURE__*/ (() => {
    class GridFilterDialogOpeningEventArgsDescription extends Description {
        get_type() {
            return "GridFilterDialogOpeningEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = null;
        }
        get column() {
            return this.h;
        }
        set column(a) {
            this.h = a;
            this.g("Column");
        }
    }
    GridFilterDialogOpeningEventArgsDescription.$t = /*@__PURE__*/ markType(GridFilterDialogOpeningEventArgsDescription, 'GridFilterDialogOpeningEventArgsDescription', Description.$);
    return GridFilterDialogOpeningEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogOpeningEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridFilterDialogOpeningEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridFilterDialogOpeningEventArgsDescriptionMetadata.a == null) {
                GridFilterDialogOpeningEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridFilterDialogOpeningEventArgsDescriptionMetadata.c(GridFilterDialogOpeningEventArgsDescriptionMetadata.a);
            }
            if (a.k(GridFilterDialogOpeningEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridFilterDialogOpeningEventArgsDescriptionMetadata.a);
            DataGridColumnDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Column", "ExportedType:DataGridColumn");
        }
        static d(a) {
            GridFilterDialogOpeningEventArgsDescriptionMetadata.b(a);
            a.ae("GridFilterDialogOpeningEventArgs", () => new GridFilterDialogOpeningEventArgsDescription());
            a.ad("GridFilterDialogOpeningEventArgs", GridFilterDialogOpeningEventArgsDescriptionMetadata.a);
        }
    }
    GridFilterDialogOpeningEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridFilterDialogOpeningEventArgsDescriptionMetadata, 'GridFilterDialogOpeningEventArgsDescriptionMetadata');
    GridFilterDialogOpeningEventArgsDescriptionMetadata.a = null;
    return GridFilterDialogOpeningEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogViewModelDescription = /*@__PURE__*/ (() => {
    class GridFilterDialogViewModelDescription extends Description {
        get_type() {
            return "GridFilterDialogViewModel";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.j = false;
            this.l = 0;
            this.h = null;
        }
        get propertyType() {
            return this.n;
        }
        set propertyType(a) {
            this.n = a;
            this.g("PropertyType");
        }
        get isTopLevelOr() {
            return this.j;
        }
        set isTopLevelOr(a) {
            this.j = a;
            this.g("IsTopLevelOr");
        }
        get maxGroupingLevels() {
            return this.l;
        }
        set maxGroupingLevels(a) {
            this.l = a;
            this.g("MaxGroupingLevels");
        }
        get rows() {
            return this.h;
        }
        set rows(a) {
            this.h = a;
            this.g("Rows");
        }
    }
    GridFilterDialogViewModelDescription.$t = /*@__PURE__*/ markType(GridFilterDialogViewModelDescription, 'GridFilterDialogViewModelDescription', Description.$);
    return GridFilterDialogViewModelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogViewModelDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridFilterDialogViewModelDescriptionMetadata extends Base {
        static b(a) {
            if (GridFilterDialogViewModelDescriptionMetadata.a == null) {
                GridFilterDialogViewModelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridFilterDialogViewModelDescriptionMetadata.c(GridFilterDialogViewModelDescriptionMetadata.a);
            }
            if (a.k(GridFilterDialogViewModelDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridFilterDialogViewModelDescriptionMetadata.a);
        }
        static c(a) {
            a.item("PropertyType", "ExportedType:string:DataSourceSchemaPropertyType");
            a.item("PropertyType@names", "StringValue;IntValue;BooleanValue;LongValue;ShortValue;DoubleValue;DecimalValue;SingleValue;DateTimeValue;DateTimeOffsetValue;ByteValue;ObjectValue");
            a.item("IsTopLevelOr", "Boolean");
            a.item("MaxGroupingLevels", "Number:int");
            a.item("Rows", "Collection:GridFilterDialogViewModelRow:GridFilterDialogViewModelRowCollection:GridFilterDialogViewModelRow");
        }
        static d(a) {
            GridFilterDialogViewModelDescriptionMetadata.b(a);
            a.ae("GridFilterDialogViewModel", () => new GridFilterDialogViewModelDescription());
            a.ad("GridFilterDialogViewModel", GridFilterDialogViewModelDescriptionMetadata.a);
        }
    }
    GridFilterDialogViewModelDescriptionMetadata.$t = /*@__PURE__*/ markType(GridFilterDialogViewModelDescriptionMetadata, 'GridFilterDialogViewModelDescriptionMetadata');
    GridFilterDialogViewModelDescriptionMetadata.a = null;
    return GridFilterDialogViewModelDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogViewModelGroupingDescription = /*@__PURE__*/ (() => {
    class GridFilterDialogViewModelGroupingDescription extends Description {
        get_type() {
            return "GridFilterDialogViewModelGrouping";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = 0;
            this.j = 0;
            this.h = false;
        }
        get startIndex() {
            return this.k;
        }
        set startIndex(a) {
            this.k = a;
            this.g("StartIndex");
        }
        get endIndex() {
            return this.j;
        }
        set endIndex(a) {
            this.j = a;
            this.g("EndIndex");
        }
        get isOrGrouping() {
            return this.h;
        }
        set isOrGrouping(a) {
            this.h = a;
            this.g("IsOrGrouping");
        }
    }
    GridFilterDialogViewModelGroupingDescription.$t = /*@__PURE__*/ markType(GridFilterDialogViewModelGroupingDescription, 'GridFilterDialogViewModelGroupingDescription', Description.$);
    return GridFilterDialogViewModelGroupingDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogViewModelGroupingDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridFilterDialogViewModelGroupingDescriptionMetadata extends Base {
        static b(a) {
            if (GridFilterDialogViewModelGroupingDescriptionMetadata.a == null) {
                GridFilterDialogViewModelGroupingDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridFilterDialogViewModelGroupingDescriptionMetadata.c(GridFilterDialogViewModelGroupingDescriptionMetadata.a);
            }
            if (a.k(GridFilterDialogViewModelGroupingDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridFilterDialogViewModelGroupingDescriptionMetadata.a);
        }
        static c(a) {
            a.item("StartIndex", "Number:int");
            a.item("EndIndex", "Number:int");
            a.item("IsOrGrouping", "Boolean");
        }
        static d(a) {
            GridFilterDialogViewModelGroupingDescriptionMetadata.b(a);
            a.ae("GridFilterDialogViewModelGrouping", () => new GridFilterDialogViewModelGroupingDescription());
            a.ad("GridFilterDialogViewModelGrouping", GridFilterDialogViewModelGroupingDescriptionMetadata.a);
        }
    }
    GridFilterDialogViewModelGroupingDescriptionMetadata.$t = /*@__PURE__*/ markType(GridFilterDialogViewModelGroupingDescriptionMetadata, 'GridFilterDialogViewModelGroupingDescriptionMetadata');
    GridFilterDialogViewModelGroupingDescriptionMetadata.a = null;
    return GridFilterDialogViewModelGroupingDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogViewModelRowDescription = /*@__PURE__*/ (() => {
    class GridFilterDialogViewModelRowDescription extends Description {
        get_type() {
            return "GridFilterDialogViewModelRow";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.l = null;
            this.h = null;
            this.m = null;
            this.n = null;
        }
        get operators() {
            return this.i;
        }
        set operators(a) {
            this.i = a;
            this.g("Operators");
        }
        get currentOperator() {
            return this.l;
        }
        set currentOperator(a) {
            this.l = a;
            this.g("CurrentOperator");
        }
        get operandNumber() {
            return this.h;
        }
        set operandNumber(a) {
            this.h = a;
            this.g("OperandNumber");
        }
        get operand1Ref() {
            return this.m;
        }
        set operand1Ref(a) {
            this.m = a;
            this.g("Operand1Ref");
        }
        get operand2Ref() {
            return this.n;
        }
        set operand2Ref(a) {
            this.n = a;
            this.g("Operand2Ref");
        }
    }
    GridFilterDialogViewModelRowDescription.$t = /*@__PURE__*/ markType(GridFilterDialogViewModelRowDescription, 'GridFilterDialogViewModelRowDescription', Description.$);
    return GridFilterDialogViewModelRowDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogViewModelRowDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridFilterDialogViewModelRowDescriptionMetadata extends Base {
        static b(a) {
            if (GridFilterDialogViewModelRowDescriptionMetadata.a == null) {
                GridFilterDialogViewModelRowDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridFilterDialogViewModelRowDescriptionMetadata.c(GridFilterDialogViewModelRowDescriptionMetadata.a);
            }
            if (a.k(GridFilterDialogViewModelRowDescriptionMetadata.a)) {
                return;
            }
            a.ac(GridFilterDialogViewModelRowDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Operators", "Array:string");
            a.item("CurrentOperator", "String");
            a.item("OperandNumber", "Array:int");
            a.item("Operand1Ref", "(w:Operand1,wf:Operand1)DataRef");
            a.item("Operand2Ref", "(w:Operand2,wf:Operand2)DataRef");
        }
        static d(a) {
            GridFilterDialogViewModelRowDescriptionMetadata.b(a);
            a.ae("GridFilterDialogViewModelRow", () => new GridFilterDialogViewModelRowDescription());
            a.ad("GridFilterDialogViewModelRow", GridFilterDialogViewModelRowDescriptionMetadata.a);
        }
    }
    GridFilterDialogViewModelRowDescriptionMetadata.$t = /*@__PURE__*/ markType(GridFilterDialogViewModelRowDescriptionMetadata, 'GridFilterDialogViewModelRowDescriptionMetadata');
    GridFilterDialogViewModelRowDescriptionMetadata.a = null;
    return GridFilterDialogViewModelRowDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GroupDataDescription = /*@__PURE__*/ (() => {
    class GroupDataDescription extends Description {
        get_type() {
            return "GroupData";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.i = null;
            this.j = null;
            this.h = null;
        }
        get groupName() {
            return this.i;
        }
        set groupName(a) {
            this.i = a;
            this.g("GroupName");
        }
        get groupValueRef() {
            return this.j;
        }
        set groupValueRef(a) {
            this.j = a;
            this.g("GroupValueRef");
        }
        get formattedText() {
            return this.h;
        }
        set formattedText(a) {
            this.h = a;
            this.g("FormattedText");
        }
    }
    GroupDataDescription.$t = /*@__PURE__*/ markType(GroupDataDescription, 'GroupDataDescription', Description.$);
    return GroupDataDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GroupDataDescriptionMetadata = /*@__PURE__*/ (() => {
    class GroupDataDescriptionMetadata extends Base {
        static b(a) {
            if (GroupDataDescriptionMetadata.a == null) {
                GroupDataDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GroupDataDescriptionMetadata.c(GroupDataDescriptionMetadata.a);
            }
            if (a.k(GroupDataDescriptionMetadata.a)) {
                return;
            }
            a.ac(GroupDataDescriptionMetadata.a);
        }
        static c(a) {
            a.item("GroupName", "String");
            a.item("GroupValueRef", "(w:GroupValue,wf:GroupValue)DataRef");
            a.item("FormattedText", "String");
        }
        static d(a) {
            GroupDataDescriptionMetadata.b(a);
            a.ae("GroupData", () => new GroupDataDescription());
            a.ad("GroupData", GroupDataDescriptionMetadata.a);
        }
    }
    GroupDataDescriptionMetadata.$t = /*@__PURE__*/ markType(GroupDataDescriptionMetadata, 'GroupDataDescriptionMetadata');
    GroupDataDescriptionMetadata.a = null;
    return GroupDataDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HierarchicalRingSeriesDescription = /*@__PURE__*/ (() => {
    class HierarchicalRingSeriesDescription extends RingSeriesBaseDescription {
        get_type() {
            return "HierarchicalRingSeries";
        }
        constructor() {
            super();
            this.cg = null;
        }
        get childrenMemberPath() {
            return this.cg;
        }
        set childrenMemberPath(a) {
            this.cg = a;
            this.g("ChildrenMemberPath");
        }
    }
    HierarchicalRingSeriesDescription.$t = /*@__PURE__*/ markType(HierarchicalRingSeriesDescription, 'HierarchicalRingSeriesDescription', RingSeriesBaseDescription.$);
    return HierarchicalRingSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HierarchicalRingSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class HierarchicalRingSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (HierarchicalRingSeriesDescriptionMetadata.a == null) {
                HierarchicalRingSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HierarchicalRingSeriesDescriptionMetadata.c(HierarchicalRingSeriesDescriptionMetadata.a);
            }
            if (a.k(HierarchicalRingSeriesDescriptionMetadata.a)) {
                return;
            }
            a.ac(HierarchicalRingSeriesDescriptionMetadata.a);
        }
        static c(a) {
            RingSeriesBaseDescriptionMetadata.c(a);
            a.item("ChildrenMemberPath", "String");
        }
        static d(a) {
            HierarchicalRingSeriesDescriptionMetadata.b(a);
            a.ae("HierarchicalRingSeries", () => new HierarchicalRingSeriesDescription());
            a.ad("HierarchicalRingSeries", HierarchicalRingSeriesDescriptionMetadata.a);
        }
    }
    HierarchicalRingSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(HierarchicalRingSeriesDescriptionMetadata, 'HierarchicalRingSeriesDescriptionMetadata');
    HierarchicalRingSeriesDescriptionMetadata.a = null;
    return HierarchicalRingSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HierarchicalRingSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class HierarchicalRingSeriesDescriptionModule extends Base {
        static register(a) {
            HierarchicalRingSeriesDescriptionMetadata.d(a);
        }
    }
    HierarchicalRingSeriesDescriptionModule.$t = /*@__PURE__*/ markType(HierarchicalRingSeriesDescriptionModule, 'HierarchicalRingSeriesDescriptionModule');
    return HierarchicalRingSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellActionManagerDescription = /*@__PURE__*/ (() => {
    class CellActionManagerDescription extends Description {
        get_type() {
            return "CellActionManager";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
            this.i = false;
        }
        get isControlPressed() {
            return this.h;
        }
        set isControlPressed(a) {
            this.h = a;
            this.g("IsControlPressed");
        }
        get isShiftPressed() {
            return this.i;
        }
        set isShiftPressed(a) {
            this.i = a;
            this.g("IsShiftPressed");
        }
    }
    CellActionManagerDescription.$t = /*@__PURE__*/ markType(CellActionManagerDescription, 'CellActionManagerDescription', Description.$);
    return CellActionManagerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellActionManagerDescriptionMetadata = /*@__PURE__*/ (() => {
    class CellActionManagerDescriptionMetadata extends Base {
        static b(a) {
            if (CellActionManagerDescriptionMetadata.a == null) {
                CellActionManagerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CellActionManagerDescriptionMetadata.c(CellActionManagerDescriptionMetadata.a);
            }
            if (a.k(CellActionManagerDescriptionMetadata.a)) {
                return;
            }
            a.ac(CellActionManagerDescriptionMetadata.a);
        }
        static c(a) {
            a.item("IsControlPressed", "Boolean");
            a.item("IsShiftPressed", "Boolean");
        }
        static d(a) {
            CellActionManagerDescriptionMetadata.b(a);
            a.ad("CellActionManager", CellActionManagerDescriptionMetadata.a);
        }
    }
    CellActionManagerDescriptionMetadata.$t = /*@__PURE__*/ markType(CellActionManagerDescriptionMetadata, 'CellActionManagerDescriptionMetadata');
    CellActionManagerDescriptionMetadata.a = null;
    return CellActionManagerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageCellInfoDescription = /*@__PURE__*/ (() => {
    class ImageCellInfoDescription extends CellInfoDescription {
        get_type() {
            return "ImageCellInfo";
        }
        constructor() {
            super();
            this.fn = null;
            this.fp = null;
            this.fo = null;
        }
        get imagePath() {
            return this.fn;
        }
        set imagePath(a) {
            this.fn = a;
            this.g("ImagePath");
        }
        get imageStretchOption() {
            return this.fp;
        }
        set imageStretchOption(a) {
            this.fp = a;
            this.g("ImageStretchOption");
        }
        get imageResourceType() {
            return this.fo;
        }
        set imageResourceType(a) {
            this.fo = a;
            this.g("ImageResourceType");
        }
    }
    ImageCellInfoDescription.$t = /*@__PURE__*/ markType(ImageCellInfoDescription, 'ImageCellInfoDescription', CellInfoDescription.$);
    ImageCellInfoDescription.__marshalByValue1 = true;
    ImageCellInfoDescription.__marshalByValueAlias1 = "ImageCellModel";
    return ImageCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class ImageCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (ImageCellInfoDescriptionMetadata.a == null) {
                ImageCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ImageCellInfoDescriptionMetadata.c(ImageCellInfoDescriptionMetadata.a);
            }
            if (a.k(ImageCellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(ImageCellInfoDescriptionMetadata.a);
        }
        static c(a) {
            CellInfoDescriptionMetadata.c(a);
            a.item("ImagePath", "String");
            a.item("ImageStretchOption", "ExportedType:string:ImageStretchOptions");
            a.item("ImageStretchOption@names", "Uniform;Fill;None");
            a.item("ImageResourceType", "ExportedType:string:ImageResourceType");
            a.item("ImageResourceType@names", "Unspecified;LocalResource;LocalAsset;EmbeddedResource;RemoteResource");
        }
        static d(a) {
            ImageCellInfoDescriptionMetadata.b(a);
            a.ae("ImageCellInfo", () => new ImageCellInfoDescription());
            a.ad("ImageCellInfo", ImageCellInfoDescriptionMetadata.a);
        }
    }
    ImageCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(ImageCellInfoDescriptionMetadata, 'ImageCellInfoDescriptionMetadata');
    ImageCellInfoDescriptionMetadata.a = null;
    return ImageCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearContourValueResolverDescription = /*@__PURE__*/ (() => {
    class LinearContourValueResolverDescription extends ContourValueResolverDescription {
        get_type() {
            return "LinearContourValueResolver";
        }
        constructor() {
            super();
            this.i = 0;
        }
        get valueCount() {
            return this.i;
        }
        set valueCount(a) {
            this.i = a;
            this.g("ValueCount");
        }
    }
    LinearContourValueResolverDescription.$t = /*@__PURE__*/ markType(LinearContourValueResolverDescription, 'LinearContourValueResolverDescription', ContourValueResolverDescription.$);
    return LinearContourValueResolverDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearContourValueResolverDescriptionMetadata = /*@__PURE__*/ (() => {
    class LinearContourValueResolverDescriptionMetadata extends Base {
        static b(a) {
            if (LinearContourValueResolverDescriptionMetadata.a == null) {
                LinearContourValueResolverDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LinearContourValueResolverDescriptionMetadata.c(LinearContourValueResolverDescriptionMetadata.a);
            }
            if (a.k(LinearContourValueResolverDescriptionMetadata.a)) {
                return;
            }
            a.ac(LinearContourValueResolverDescriptionMetadata.a);
        }
        static c(a) {
            ContourValueResolverDescriptionMetadata.c(a);
            a.item("ValueCount", "Number:int");
        }
        static d(a) {
            LinearContourValueResolverDescriptionMetadata.b(a);
            a.ae("LinearContourValueResolver", () => new LinearContourValueResolverDescription());
            a.ad("LinearContourValueResolver", LinearContourValueResolverDescriptionMetadata.a);
        }
    }
    LinearContourValueResolverDescriptionMetadata.$t = /*@__PURE__*/ markType(LinearContourValueResolverDescriptionMetadata, 'LinearContourValueResolverDescriptionMetadata');
    LinearContourValueResolverDescriptionMetadata.a = null;
    return LinearContourValueResolverDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearContourValueResolverDescriptionModule = /*@__PURE__*/ (() => {
    class LinearContourValueResolverDescriptionModule extends Base {
        static register(a) {
            LinearContourValueResolverDescriptionMetadata.d(a);
        }
    }
    LinearContourValueResolverDescriptionModule.$t = /*@__PURE__*/ markType(LinearContourValueResolverDescriptionModule, 'LinearContourValueResolverDescriptionModule');
    return LinearContourValueResolverDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridFilterDialogDescription = /*@__PURE__*/ (() => {
    class DataGridFilterDialogDescription extends Description {
        get_type() {
            return "DataGridFilterDialog";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
            this.k = 0;
            this.j = 0;
            this.s = null;
            this.l = 0;
            this.p = null;
            this.r = null;
            this.q = null;
            this.t = null;
        }
        get isAnimationEnabled() {
            return this.h;
        }
        set isAnimationEnabled(a) {
            this.h = a;
            this.g("IsAnimationEnabled");
        }
        get pixelScalingRatio() {
            return this.k;
        }
        set pixelScalingRatio(a) {
            this.k = a;
            this.g("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.j;
        }
        set actualPixelScalingRatio(a) {
            this.j = a;
            this.g("ActualPixelScalingRatio");
        }
        get iconColor() {
            return this.s;
        }
        set iconColor(a) {
            this.s = a;
            this.g("IconColor");
        }
        get viewSize() {
            return this.l;
        }
        set viewSize(a) {
            this.l = a;
            this.g("ViewSize");
        }
        get dialogOpeningRef() {
            return this.p;
        }
        set dialogOpeningRef(a) {
            this.p = a;
            this.g("DialogOpeningRef");
        }
        get filterChangingRef() {
            return this.r;
        }
        set filterChangingRef(a) {
            this.r = a;
            this.g("FilterChangingRef");
        }
        get filterChangedRef() {
            return this.q;
        }
        set filterChangedRef(a) {
            this.q = a;
            this.g("FilterChangedRef");
        }
        get renderCompletedRef() {
            return this.t;
        }
        set renderCompletedRef(a) {
            this.t = a;
            this.g("RenderCompletedRef");
        }
    }
    DataGridFilterDialogDescription.$t = /*@__PURE__*/ markType(DataGridFilterDialogDescription, 'DataGridFilterDialogDescription', Description.$);
    return DataGridFilterDialogDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridFilterDialogDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridFilterDialogDescriptionMetadata extends Base {
        static b(a) {
            if (DataGridFilterDialogDescriptionMetadata.a == null) {
                DataGridFilterDialogDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridFilterDialogDescriptionMetadata.c(DataGridFilterDialogDescriptionMetadata.a);
            }
            if (a.k(DataGridFilterDialogDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataGridFilterDialogDescriptionMetadata.a);
            GridFilterDialogOpeningEventArgsDescriptionMetadata.d(a);
            GridFilterDialogFilterChangeEventArgsDescriptionMetadata.d(a);
            FilterDialogRenderCompletedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("IsAnimationEnabled", "Boolean");
            a.item("PixelScalingRatio", "Number:double");
            a.item("ActualPixelScalingRatio", "Number:double");
            a.item("IconColor", "Brush");
            a.item("ViewSize", "Number:double");
            a.item("DialogOpeningRef", "EventRef::dialogOpening");
            a.item("FilterChangingRef", "EventRef::filterChanging");
            a.item("FilterChangedRef", "EventRef::filterChanged");
            a.item("RenderCompletedRef", "EventRef::renderCompleted");
        }
        static d(a) {
            DataGridFilterDialogDescriptionMetadata.b(a);
            a.ae("DataGridFilterDialog", () => new DataGridFilterDialogDescription());
            a.ad("DataGridFilterDialog", DataGridFilterDialogDescriptionMetadata.a);
        }
    }
    DataGridFilterDialogDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridFilterDialogDescriptionMetadata, 'DataGridFilterDialogDescriptionMetadata');
    DataGridFilterDialogDescriptionMetadata.a = null;
    return DataGridFilterDialogDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridSortIndicatorDescription = /*@__PURE__*/ (() => {
    class DataGridSortIndicatorDescription extends Description {
        get_type() {
            return "DataGridSortIndicator";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.p = null;
            this.n = null;
            this.h = false;
            this.k = 0;
            this.j = 0;
            this.q = null;
            this.o = null;
        }
        get sortDirection() {
            return this.p;
        }
        set sortDirection(a) {
            this.p = a;
            this.g("SortDirection");
        }
        get iconColor() {
            return this.n;
        }
        set iconColor(a) {
            this.n = a;
            this.g("IconColor");
        }
        get isAnimationEnabled() {
            return this.h;
        }
        set isAnimationEnabled(a) {
            this.h = a;
            this.g("IsAnimationEnabled");
        }
        get pixelScalingRatio() {
            return this.k;
        }
        set pixelScalingRatio(a) {
            this.k = a;
            this.g("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.j;
        }
        set actualPixelScalingRatio(a) {
            this.j = a;
            this.g("ActualPixelScalingRatio");
        }
        get sortIndicatorStyle() {
            return this.q;
        }
        set sortIndicatorStyle(a) {
            this.q = a;
            this.g("SortIndicatorStyle");
        }
        get renderCompletedRef() {
            return this.o;
        }
        set renderCompletedRef(a) {
            this.o = a;
            this.g("RenderCompletedRef");
        }
    }
    DataGridSortIndicatorDescription.$t = /*@__PURE__*/ markType(DataGridSortIndicatorDescription, 'DataGridSortIndicatorDescription', Description.$);
    return DataGridSortIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridSortIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridSortIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (DataGridSortIndicatorDescriptionMetadata.a == null) {
                DataGridSortIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridSortIndicatorDescriptionMetadata.c(DataGridSortIndicatorDescriptionMetadata.a);
            }
            if (a.k(DataGridSortIndicatorDescriptionMetadata.a)) {
                return;
            }
            a.ac(DataGridSortIndicatorDescriptionMetadata.a);
            SortIndicatorRenderCompletedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("SortDirection", "ExportedType:string:ColumnSortDirection");
            a.item("SortDirection@names", "None;Ascending;Descending");
            a.item("IconColor", "Brush");
            a.item("IsAnimationEnabled", "Boolean");
            a.item("PixelScalingRatio", "Number:double");
            a.item("ActualPixelScalingRatio", "Number:double");
            a.item("SortIndicatorStyle", "ExportedType:string:SortIndicatorStyle");
            a.item("SortIndicatorStyle@names", "Default;FadingUpDownArrows;FadingSimpleUpDownArrows;Unset");
            a.item("RenderCompletedRef", "EventRef::renderCompleted");
        }
        static d(a) {
            DataGridSortIndicatorDescriptionMetadata.b(a);
            a.ae("DataGridSortIndicator", () => new DataGridSortIndicatorDescription());
            a.ad("DataGridSortIndicator", DataGridSortIndicatorDescriptionMetadata.a);
        }
    }
    DataGridSortIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridSortIndicatorDescriptionMetadata, 'DataGridSortIndicatorDescriptionMetadata');
    DataGridSortIndicatorDescriptionMetadata.a = null;
    return DataGridSortIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericCellInfoDescription = /*@__PURE__*/ (() => {
    class NumericCellInfoDescription extends CellInfoDescription {
        get_type() {
            return "NumericCellInfo";
        }
        constructor() {
            super();
            this.fs = 0;
            this.fo = false;
            this.f2 = null;
            this.fl = null;
            this.f1 = null;
            this.f3 = null;
            this.f5 = null;
            this.f4 = null;
            this.f6 = null;
            this.fu = 0;
            this.fv = 0;
            this.fw = 0;
            this.fp = false;
        }
        get numericValue() {
            return this.fs;
        }
        set numericValue(a) {
            this.fs = a;
            this.g("NumericValue");
        }
        get hasDecimalValue() {
            return this.fo;
        }
        set hasDecimalValue(a) {
            this.fo = a;
            this.g("HasDecimalValue");
        }
        get formatStringOverride() {
            return this.f2;
        }
        set formatStringOverride(a) {
            this.f2 = a;
            this.g("FormatStringOverride");
        }
        get formatSpecifiers() {
            return this.fl;
        }
        set formatSpecifiers(a) {
            this.fl = a;
            this.g("FormatSpecifiers");
        }
        get formatOverrideRef() {
            return this.f1;
        }
        set formatOverrideRef(a) {
            this.f1 = a;
            this.g("FormatOverrideRef");
        }
        get negativePrefix() {
            return this.f3;
        }
        set negativePrefix(a) {
            this.f3 = a;
            this.g("NegativePrefix");
        }
        get positivePrefix() {
            return this.f5;
        }
        set positivePrefix(a) {
            this.f5 = a;
            this.g("PositivePrefix");
        }
        get negativeSuffix() {
            return this.f4;
        }
        set negativeSuffix(a) {
            this.f4 = a;
            this.g("NegativeSuffix");
        }
        get positiveSuffix() {
            return this.f6;
        }
        set positiveSuffix(a) {
            this.f6 = a;
            this.g("PositiveSuffix");
        }
        get maxFractionDigits() {
            return this.fu;
        }
        set maxFractionDigits(a) {
            this.fu = a;
            this.g("MaxFractionDigits");
        }
        get minFractionDigits() {
            return this.fv;
        }
        set minFractionDigits(a) {
            this.fv = a;
            this.g("MinFractionDigits");
        }
        get minIntegerDigits() {
            return this.fw;
        }
        set minIntegerDigits(a) {
            this.fw = a;
            this.g("MinIntegerDigits");
        }
        get showGroupingSeparator() {
            return this.fp;
        }
        set showGroupingSeparator(a) {
            this.fp = a;
            this.g("ShowGroupingSeparator");
        }
    }
    NumericCellInfoDescription.$t = /*@__PURE__*/ markType(NumericCellInfoDescription, 'NumericCellInfoDescription', CellInfoDescription.$);
    NumericCellInfoDescription.__marshalByValue1 = true;
    NumericCellInfoDescription.__marshalByValueAlias1 = "NumericCellModel";
    return NumericCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumericCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (NumericCellInfoDescriptionMetadata.a == null) {
                NumericCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumericCellInfoDescriptionMetadata.c(NumericCellInfoDescriptionMetadata.a);
            }
            if (a.k(NumericCellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(NumericCellInfoDescriptionMetadata.a);
        }
        static c(a) {
            CellInfoDescriptionMetadata.c(a);
            a.item("NumericValue", "Number:double");
            a.item("HasDecimalValue", "Boolean");
            a.item("FormatStringOverride", "String");
            a.item("FormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            a.item("FormatSpecifiers@mustSetInCode", "WebComponents;Blazor;React;WPF;Angular");
            a.item("FormatOverrideRef", "(w:FormatOverride,wf:FormatOverride)DataRef");
            a.item("NegativePrefix", "String");
            a.item("PositivePrefix", "String");
            a.item("NegativeSuffix", "String");
            a.item("PositiveSuffix", "String");
            a.item("MaxFractionDigits", "Number:int");
            a.item("MinFractionDigits", "Number:int");
            a.item("MinIntegerDigits", "Number:int");
            a.item("ShowGroupingSeparator", "Boolean");
        }
        static d(a) {
            NumericCellInfoDescriptionMetadata.b(a);
            a.ae("NumericCellInfo", () => new NumericCellInfoDescription());
            a.ad("NumericCellInfo", NumericCellInfoDescriptionMetadata.a);
        }
    }
    NumericCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(NumericCellInfoDescriptionMetadata, 'NumericCellInfoDescriptionMetadata');
    NumericCellInfoDescriptionMetadata.a = null;
    return NumericCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieSliceDataContextDescription = /*@__PURE__*/ (() => {
    class PieSliceDataContextDescription extends DataContextDescription {
        get_type() {
            return "PieSliceDataContext";
        }
        constructor() {
            super();
            this.ab = 0;
            this.z = false;
        }
        get percentValue() {
            return this.ab;
        }
        set percentValue(a) {
            this.ab = a;
            this.g("PercentValue");
        }
        get isOthersSlice() {
            return this.z;
        }
        set isOthersSlice(a) {
            this.z = a;
            this.g("IsOthersSlice");
        }
    }
    PieSliceDataContextDescription.$t = /*@__PURE__*/ markType(PieSliceDataContextDescription, 'PieSliceDataContextDescription', DataContextDescription.$);
    PieSliceDataContextDescription.__marshalByValue1 = true;
    PieSliceDataContextDescription.__marshalByValueAlias1 = "PieSliceDataContext";
    return PieSliceDataContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieSliceDataContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class PieSliceDataContextDescriptionMetadata extends Base {
        static b(a) {
            if (PieSliceDataContextDescriptionMetadata.a == null) {
                PieSliceDataContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PieSliceDataContextDescriptionMetadata.c(PieSliceDataContextDescriptionMetadata.a);
            }
            if (a.k(PieSliceDataContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(PieSliceDataContextDescriptionMetadata.a);
        }
        static c(a) {
            DataContextDescriptionMetadata.c(a);
            a.item("__marshalByValue", "Boolean");
            a.item("PercentValue", "Number:double");
            a.item("IsOthersSlice", "Boolean");
        }
        static d(a) {
            PieSliceDataContextDescriptionMetadata.b(a);
            a.ae("PieSliceDataContext", () => new PieSliceDataContextDescription());
            a.ad("PieSliceDataContext", PieSliceDataContextDescriptionMetadata.a);
        }
    }
    PieSliceDataContextDescriptionMetadata.$t = /*@__PURE__*/ markType(PieSliceDataContextDescriptionMetadata, 'PieSliceDataContextDescriptionMetadata');
    PieSliceDataContextDescriptionMetadata.a = null;
    return PieSliceDataContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieSliceOthersContextDescription = /*@__PURE__*/ (() => {
    class PieSliceOthersContextDescription extends Description {
        get_type() {
            return "PieSliceOthersContext";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    PieSliceOthersContextDescription.$t = /*@__PURE__*/ markType(PieSliceOthersContextDescription, 'PieSliceOthersContextDescription', Description.$);
    return PieSliceOthersContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieSliceOthersContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class PieSliceOthersContextDescriptionMetadata extends Base {
        static b(a) {
            if (PieSliceOthersContextDescriptionMetadata.a == null) {
                PieSliceOthersContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PieSliceOthersContextDescriptionMetadata.c(PieSliceOthersContextDescriptionMetadata.a);
            }
            if (a.k(PieSliceOthersContextDescriptionMetadata.a)) {
                return;
            }
            a.ac(PieSliceOthersContextDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            PieSliceOthersContextDescriptionMetadata.b(a);
            a.ae("PieSliceOthersContext", () => new PieSliceOthersContextDescription());
            a.ad("PieSliceOthersContext", PieSliceOthersContextDescriptionMetadata.a);
        }
    }
    PieSliceOthersContextDescriptionMetadata.$t = /*@__PURE__*/ markType(PieSliceOthersContextDescriptionMetadata, 'PieSliceOthersContextDescriptionMetadata');
    PieSliceOthersContextDescriptionMetadata.a = null;
    return PieSliceOthersContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsivePhaseDescription = /*@__PURE__*/ (() => {
    class ResponsivePhaseDescription extends Description {
        get_type() {
            return "ResponsivePhase";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.j = null;
            this.h = 0;
        }
        get name() {
            return this.j;
        }
        set name(a) {
            this.j = a;
            this.g("Name");
        }
        get delayMilliseconds() {
            return this.h;
        }
        set delayMilliseconds(a) {
            this.h = a;
            this.g("DelayMilliseconds");
        }
    }
    ResponsivePhaseDescription.$t = /*@__PURE__*/ markType(ResponsivePhaseDescription, 'ResponsivePhaseDescription', Description.$);
    return ResponsivePhaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsivePhaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class ResponsivePhaseDescriptionMetadata extends Base {
        static b(a) {
            if (ResponsivePhaseDescriptionMetadata.a == null) {
                ResponsivePhaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ResponsivePhaseDescriptionMetadata.c(ResponsivePhaseDescriptionMetadata.a);
            }
            if (a.k(ResponsivePhaseDescriptionMetadata.a)) {
                return;
            }
            a.ac(ResponsivePhaseDescriptionMetadata.a);
        }
        static c(a) {
            a.item("Name", "String");
            a.item("DelayMilliseconds", "Number:int");
        }
        static d(a) {
            ResponsivePhaseDescriptionMetadata.b(a);
            a.ae("ResponsivePhase", () => new ResponsivePhaseDescription());
            a.ad("ResponsivePhase", ResponsivePhaseDescriptionMetadata.a);
        }
    }
    ResponsivePhaseDescriptionMetadata.$t = /*@__PURE__*/ markType(ResponsivePhaseDescriptionMetadata, 'ResponsivePhaseDescriptionMetadata');
    ResponsivePhaseDescriptionMetadata.a = null;
    return ResponsivePhaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateDescription = /*@__PURE__*/ (() => {
    class ResponsiveStateDescription extends Description {
        get_type() {
            return "ResponsiveState";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.n = null;
            this.k = 0;
            this.j = 0;
            this.h = false;
            this.p = null;
            this.o = null;
            this.q = null;
        }
        get name() {
            return this.n;
        }
        set name(a) {
            this.n = a;
            this.g("Name");
        }
        get minimumWidth() {
            return this.k;
        }
        set minimumWidth(a) {
            this.k = a;
            this.g("MinimumWidth");
        }
        get maximumWidth() {
            return this.j;
        }
        set maximumWidth(a) {
            this.j = a;
            this.g("MaximumWidth");
        }
        get isManualState() {
            return this.h;
        }
        set isManualState(a) {
            this.h = a;
            this.g("IsManualState");
        }
        get stateEnteringRef() {
            return this.p;
        }
        set stateEnteringRef(a) {
            this.p = a;
            this.g("StateEnteringRef");
        }
        get stateEnteredRef() {
            return this.o;
        }
        set stateEnteredRef(a) {
            this.o = a;
            this.g("StateEnteredRef");
        }
        get stateExitedRef() {
            return this.q;
        }
        set stateExitedRef(a) {
            this.q = a;
            this.g("StateExitedRef");
        }
    }
    ResponsiveStateDescription.$t = /*@__PURE__*/ markType(ResponsiveStateDescription, 'ResponsiveStateDescription', Description.$);
    return ResponsiveStateDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateEnteringEventArgsDescription = /*@__PURE__*/ (() => {
    class ResponsiveStateEnteringEventArgsDescription extends Description {
        get_type() {
            return "ResponsiveStateEnteringEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ResponsiveStateEnteringEventArgsDescription.$t = /*@__PURE__*/ markType(ResponsiveStateEnteringEventArgsDescription, 'ResponsiveStateEnteringEventArgsDescription', Description.$);
    return ResponsiveStateEnteringEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateEnteringEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ResponsiveStateEnteringEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ResponsiveStateEnteringEventArgsDescriptionMetadata.a == null) {
                ResponsiveStateEnteringEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ResponsiveStateEnteringEventArgsDescriptionMetadata.c(ResponsiveStateEnteringEventArgsDescriptionMetadata.a);
            }
            if (a.k(ResponsiveStateEnteringEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ResponsiveStateEnteringEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ResponsiveStateEnteringEventArgsDescriptionMetadata.b(a);
            a.ae("ResponsiveStateEnteringEventArgs", () => new ResponsiveStateEnteringEventArgsDescription());
            a.ad("ResponsiveStateEnteringEventArgs", ResponsiveStateEnteringEventArgsDescriptionMetadata.a);
        }
    }
    ResponsiveStateEnteringEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ResponsiveStateEnteringEventArgsDescriptionMetadata, 'ResponsiveStateEnteringEventArgsDescriptionMetadata');
    ResponsiveStateEnteringEventArgsDescriptionMetadata.a = null;
    return ResponsiveStateEnteringEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateEnteredEventArgsDescription = /*@__PURE__*/ (() => {
    class ResponsiveStateEnteredEventArgsDescription extends Description {
        get_type() {
            return "ResponsiveStateEnteredEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ResponsiveStateEnteredEventArgsDescription.$t = /*@__PURE__*/ markType(ResponsiveStateEnteredEventArgsDescription, 'ResponsiveStateEnteredEventArgsDescription', Description.$);
    return ResponsiveStateEnteredEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateEnteredEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ResponsiveStateEnteredEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ResponsiveStateEnteredEventArgsDescriptionMetadata.a == null) {
                ResponsiveStateEnteredEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ResponsiveStateEnteredEventArgsDescriptionMetadata.c(ResponsiveStateEnteredEventArgsDescriptionMetadata.a);
            }
            if (a.k(ResponsiveStateEnteredEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ResponsiveStateEnteredEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ResponsiveStateEnteredEventArgsDescriptionMetadata.b(a);
            a.ae("ResponsiveStateEnteredEventArgs", () => new ResponsiveStateEnteredEventArgsDescription());
            a.ad("ResponsiveStateEnteredEventArgs", ResponsiveStateEnteredEventArgsDescriptionMetadata.a);
        }
    }
    ResponsiveStateEnteredEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ResponsiveStateEnteredEventArgsDescriptionMetadata, 'ResponsiveStateEnteredEventArgsDescriptionMetadata');
    ResponsiveStateEnteredEventArgsDescriptionMetadata.a = null;
    return ResponsiveStateEnteredEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateExitedEventArgsDescription = /*@__PURE__*/ (() => {
    class ResponsiveStateExitedEventArgsDescription extends Description {
        get_type() {
            return "ResponsiveStateExitedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    ResponsiveStateExitedEventArgsDescription.$t = /*@__PURE__*/ markType(ResponsiveStateExitedEventArgsDescription, 'ResponsiveStateExitedEventArgsDescription', Description.$);
    return ResponsiveStateExitedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateExitedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ResponsiveStateExitedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ResponsiveStateExitedEventArgsDescriptionMetadata.a == null) {
                ResponsiveStateExitedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ResponsiveStateExitedEventArgsDescriptionMetadata.c(ResponsiveStateExitedEventArgsDescriptionMetadata.a);
            }
            if (a.k(ResponsiveStateExitedEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ResponsiveStateExitedEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            ResponsiveStateExitedEventArgsDescriptionMetadata.b(a);
            a.ae("ResponsiveStateExitedEventArgs", () => new ResponsiveStateExitedEventArgsDescription());
            a.ad("ResponsiveStateExitedEventArgs", ResponsiveStateExitedEventArgsDescriptionMetadata.a);
        }
    }
    ResponsiveStateExitedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ResponsiveStateExitedEventArgsDescriptionMetadata, 'ResponsiveStateExitedEventArgsDescriptionMetadata');
    ResponsiveStateExitedEventArgsDescriptionMetadata.a = null;
    return ResponsiveStateExitedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateDescriptionMetadata = /*@__PURE__*/ (() => {
    class ResponsiveStateDescriptionMetadata extends Base {
        static b(a) {
            if (ResponsiveStateDescriptionMetadata.a == null) {
                ResponsiveStateDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ResponsiveStateDescriptionMetadata.c(ResponsiveStateDescriptionMetadata.a);
            }
            if (a.k(ResponsiveStateDescriptionMetadata.a)) {
                return;
            }
            a.ac(ResponsiveStateDescriptionMetadata.a);
            ResponsiveStateEnteringEventArgsDescriptionMetadata.d(a);
            ResponsiveStateEnteredEventArgsDescriptionMetadata.d(a);
            ResponsiveStateExitedEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            a.item("Name", "String");
            a.item("MinimumWidth", "Number:double");
            a.item("MaximumWidth", "Number:double");
            a.item("IsManualState", "Boolean");
            a.item("StateEnteringRef", "EventRef::stateEntering");
            a.item("StateEnteredRef", "EventRef::stateEntered");
            a.item("StateExitedRef", "EventRef::stateExited");
        }
        static d(a) {
            ResponsiveStateDescriptionMetadata.b(a);
            a.ae("ResponsiveState", () => new ResponsiveStateDescription());
            a.ad("ResponsiveState", ResponsiveStateDescriptionMetadata.a);
        }
    }
    ResponsiveStateDescriptionMetadata.$t = /*@__PURE__*/ markType(ResponsiveStateDescriptionMetadata, 'ResponsiveStateDescriptionMetadata');
    ResponsiveStateDescriptionMetadata.a = null;
    return ResponsiveStateDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RowSeparatorInfoDescription = /*@__PURE__*/ (() => {
    class RowSeparatorInfoDescription extends CellInfoDescription {
        get_type() {
            return "RowSeparatorInfo";
        }
        constructor() {
            super();
        }
    }
    RowSeparatorInfoDescription.$t = /*@__PURE__*/ markType(RowSeparatorInfoDescription, 'RowSeparatorInfoDescription', CellInfoDescription.$);
    RowSeparatorInfoDescription.__marshalByValue1 = true;
    RowSeparatorInfoDescription.__marshalByValueAlias1 = "RowSeparatorModel";
    return RowSeparatorInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RowSeparatorInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class RowSeparatorInfoDescriptionMetadata extends Base {
        static b(a) {
            if (RowSeparatorInfoDescriptionMetadata.a == null) {
                RowSeparatorInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RowSeparatorInfoDescriptionMetadata.c(RowSeparatorInfoDescriptionMetadata.a);
            }
            if (a.k(RowSeparatorInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(RowSeparatorInfoDescriptionMetadata.a);
        }
        static c(a) {
            CellInfoDescriptionMetadata.c(a);
        }
        static d(a) {
            RowSeparatorInfoDescriptionMetadata.b(a);
            a.ae("RowSeparatorInfo", () => new RowSeparatorInfoDescription());
            a.ad("RowSeparatorInfo", RowSeparatorInfoDescriptionMetadata.a);
        }
    }
    RowSeparatorInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(RowSeparatorInfoDescriptionMetadata, 'RowSeparatorInfoDescriptionMetadata');
    RowSeparatorInfoDescriptionMetadata.a = null;
    return RowSeparatorInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScalerParamsDescription = /*@__PURE__*/ (() => {
    class ScalerParamsDescription extends Description {
        get_type() {
            return "ScalerParams";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = 0;
        }
        get referenceValue() {
            return this.h;
        }
        set referenceValue(a) {
            this.h = a;
            this.g("ReferenceValue");
        }
    }
    ScalerParamsDescription.$t = /*@__PURE__*/ markType(ScalerParamsDescription, 'ScalerParamsDescription', Description.$);
    return ScalerParamsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScalerParamsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScalerParamsDescriptionMetadata extends Base {
        static b(a) {
            if (ScalerParamsDescriptionMetadata.a == null) {
                ScalerParamsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScalerParamsDescriptionMetadata.c(ScalerParamsDescriptionMetadata.a);
            }
            if (a.k(ScalerParamsDescriptionMetadata.a)) {
                return;
            }
            a.ac(ScalerParamsDescriptionMetadata.a);
        }
        static c(a) {
            a.item("ReferenceValue", "Number:double");
        }
        static d(a) {
            ScalerParamsDescriptionMetadata.b(a);
            a.ae("ScalerParams", () => new ScalerParamsDescription());
            a.ad("ScalerParams", ScalerParamsDescriptionMetadata.a);
        }
    }
    ScalerParamsDescriptionMetadata.$t = /*@__PURE__*/ markType(ScalerParamsDescriptionMetadata, 'ScalerParamsDescriptionMetadata');
    ScalerParamsDescriptionMetadata.a = null;
    return ScalerParamsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionFooterDescription = /*@__PURE__*/ (() => {
    class SectionFooterDescription extends DefinitionBaseDescription {
        get_type() {
            return "SectionFooter";
        }
        constructor() {
            super();
        }
    }
    SectionFooterDescription.$t = /*@__PURE__*/ markType(SectionFooterDescription, 'SectionFooterDescription', DefinitionBaseDescription.$);
    return SectionFooterDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionFooterDescriptionMetadata = /*@__PURE__*/ (() => {
    class SectionFooterDescriptionMetadata extends Base {
        static b(a) {
            if (SectionFooterDescriptionMetadata.a == null) {
                SectionFooterDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SectionFooterDescriptionMetadata.c(SectionFooterDescriptionMetadata.a);
            }
            if (a.k(SectionFooterDescriptionMetadata.a)) {
                return;
            }
            a.ac(SectionFooterDescriptionMetadata.a);
        }
        static c(a) {
            DefinitionBaseDescriptionMetadata.c(a);
        }
        static d(a) {
            SectionFooterDescriptionMetadata.b(a);
            a.ae("SectionFooter", () => new SectionFooterDescription());
            a.ad("SectionFooter", SectionFooterDescriptionMetadata.a);
        }
    }
    SectionFooterDescriptionMetadata.$t = /*@__PURE__*/ markType(SectionFooterDescriptionMetadata, 'SectionFooterDescriptionMetadata');
    SectionFooterDescriptionMetadata.a = null;
    return SectionFooterDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionFooterDescriptionModule = /*@__PURE__*/ (() => {
    class SectionFooterDescriptionModule extends Base {
        static register(a) {
            SectionFooterDescriptionMetadata.d(a);
        }
    }
    SectionFooterDescriptionModule.$t = /*@__PURE__*/ markType(SectionFooterDescriptionModule, 'SectionFooterDescriptionModule');
    return SectionFooterDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionHeaderCellInfoDescription = /*@__PURE__*/ (() => {
    class SectionHeaderCellInfoDescription extends CellInfoDescription {
        get_type() {
            return "SectionHeaderCellInfo";
        }
        constructor() {
            super();
            this.fo = null;
            this.fn = null;
            this.fp = null;
        }
        get resolvedText() {
            return this.fo;
        }
        set resolvedText(a) {
            this.fo = a;
            this.g("ResolvedText");
        }
        get resolvedSummaryText() {
            return this.fn;
        }
        set resolvedSummaryText(a) {
            this.fn = a;
            this.g("ResolvedSummaryText");
        }
        get summaryDisplayMode() {
            return this.fp;
        }
        set summaryDisplayMode(a) {
            this.fp = a;
            this.g("SummaryDisplayMode");
        }
    }
    SectionHeaderCellInfoDescription.$t = /*@__PURE__*/ markType(SectionHeaderCellInfoDescription, 'SectionHeaderCellInfoDescription', CellInfoDescription.$);
    SectionHeaderCellInfoDescription.__marshalByValue1 = true;
    SectionHeaderCellInfoDescription.__marshalByValueAlias1 = "SectionHeaderCellModel";
    return SectionHeaderCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionHeaderCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class SectionHeaderCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (SectionHeaderCellInfoDescriptionMetadata.a == null) {
                SectionHeaderCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SectionHeaderCellInfoDescriptionMetadata.c(SectionHeaderCellInfoDescriptionMetadata.a);
            }
            if (a.k(SectionHeaderCellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(SectionHeaderCellInfoDescriptionMetadata.a);
        }
        static c(a) {
            CellInfoDescriptionMetadata.c(a);
            a.item("ResolvedText", "String");
            a.item("ResolvedSummaryText", "String");
            a.item("SummaryDisplayMode", "ExportedType:string:GroupSummaryDisplayMode");
            a.item("SummaryDisplayMode@names", "List;Cells;RowTop;RowBottom;None");
        }
        static d(a) {
            SectionHeaderCellInfoDescriptionMetadata.b(a);
            a.ae("SectionHeaderCellInfo", () => new SectionHeaderCellInfoDescription());
            a.ad("SectionHeaderCellInfo", SectionHeaderCellInfoDescriptionMetadata.a);
        }
    }
    SectionHeaderCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(SectionHeaderCellInfoDescriptionMetadata, 'SectionHeaderCellInfoDescriptionMetadata');
    SectionHeaderCellInfoDescriptionMetadata.a = null;
    return SectionHeaderCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StyleSelectorDescription = /*@__PURE__*/ (() => {
    class StyleSelectorDescription extends Description {
        get_type() {
            return "StyleSelector";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    StyleSelectorDescription.$t = /*@__PURE__*/ markType(StyleSelectorDescription, 'StyleSelectorDescription', Description.$);
    return StyleSelectorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StyleSelectorDescriptionMetadata = /*@__PURE__*/ (() => {
    class StyleSelectorDescriptionMetadata extends Base {
        static b(a) {
            if (StyleSelectorDescriptionMetadata.a == null) {
                StyleSelectorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StyleSelectorDescriptionMetadata.c(StyleSelectorDescriptionMetadata.a);
            }
            if (a.k(StyleSelectorDescriptionMetadata.a)) {
                return;
            }
            a.ac(StyleSelectorDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            StyleSelectorDescriptionMetadata.b(a);
            a.ae("StyleSelector", () => new StyleSelectorDescription());
            a.ad("StyleSelector", StyleSelectorDescriptionMetadata.a);
        }
    }
    StyleSelectorDescriptionMetadata.$t = /*@__PURE__*/ markType(StyleSelectorDescriptionMetadata, 'StyleSelectorDescriptionMetadata');
    StyleSelectorDescriptionMetadata.a = null;
    return StyleSelectorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateCellInfoDescription = /*@__PURE__*/ (() => {
    class TemplateCellInfoDescription extends CellInfoDescription {
        get_type() {
            return "TemplateCellInfo";
        }
        constructor() {
            super();
            this.fn = null;
        }
        get valueRef() {
            return this.fn;
        }
        set valueRef(a) {
            this.fn = a;
            this.g("ValueRef");
        }
    }
    TemplateCellInfoDescription.$t = /*@__PURE__*/ markType(TemplateCellInfoDescription, 'TemplateCellInfoDescription', CellInfoDescription.$);
    TemplateCellInfoDescription.__marshalByValue1 = true;
    TemplateCellInfoDescription.__marshalByValueAlias1 = "TemplateCellModel";
    return TemplateCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateCellInfoDescriptionMetadata.a == null) {
                TemplateCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateCellInfoDescriptionMetadata.c(TemplateCellInfoDescriptionMetadata.a);
            }
            if (a.k(TemplateCellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(TemplateCellInfoDescriptionMetadata.a);
        }
        static c(a) {
            CellInfoDescriptionMetadata.c(a);
            a.item("ValueRef", "(w:Value,wf:Value)DataRef");
        }
        static d(a) {
            TemplateCellInfoDescriptionMetadata.b(a);
            a.ae("TemplateCellInfo", () => new TemplateCellInfoDescription());
            a.ad("TemplateCellInfo", TemplateCellInfoDescriptionMetadata.a);
        }
    }
    TemplateCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateCellInfoDescriptionMetadata, 'TemplateCellInfoDescriptionMetadata');
    TemplateCellInfoDescriptionMetadata.a = null;
    return TemplateCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateHeaderCellInfoDescription = /*@__PURE__*/ (() => {
    class TemplateHeaderCellInfoDescription extends TemplateCellInfoDescription {
        get_type() {
            return "TemplateHeaderCellInfo";
        }
        constructor() {
            super();
            this.fq = false;
        }
        get isFilterUIVisible() {
            return this.fq;
        }
        set isFilterUIVisible(a) {
            this.fq = a;
            this.g("IsFilterUIVisible");
        }
    }
    TemplateHeaderCellInfoDescription.$t = /*@__PURE__*/ markType(TemplateHeaderCellInfoDescription, 'TemplateHeaderCellInfoDescription', TemplateCellInfoDescription.$);
    TemplateHeaderCellInfoDescription.__marshalByValue2 = true;
    TemplateHeaderCellInfoDescription.__marshalByValueAlias2 = "TemplateHeaderCellModel";
    return TemplateHeaderCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateHeaderCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateHeaderCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateHeaderCellInfoDescriptionMetadata.a == null) {
                TemplateHeaderCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateHeaderCellInfoDescriptionMetadata.c(TemplateHeaderCellInfoDescriptionMetadata.a);
            }
            if (a.k(TemplateHeaderCellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(TemplateHeaderCellInfoDescriptionMetadata.a);
        }
        static c(a) {
            TemplateCellInfoDescriptionMetadata.c(a);
            a.item("IsFilterUIVisible", "Boolean");
        }
        static d(a) {
            TemplateHeaderCellInfoDescriptionMetadata.b(a);
            a.ae("TemplateHeaderCellInfo", () => new TemplateHeaderCellInfoDescription());
            a.ad("TemplateHeaderCellInfo", TemplateHeaderCellInfoDescriptionMetadata.a);
        }
    }
    TemplateHeaderCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateHeaderCellInfoDescriptionMetadata, 'TemplateHeaderCellInfoDescriptionMetadata');
    TemplateHeaderCellInfoDescriptionMetadata.a = null;
    return TemplateHeaderCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateSectionHeaderDescription = /*@__PURE__*/ (() => {
    class TemplateSectionHeaderDescription extends SectionHeaderDescription {
        get_type() {
            return "TemplateSectionHeader";
        }
        constructor() {
            super();
            this.ck = null;
        }
        get cellUpdatingRef() {
            return this.ck;
        }
        set cellUpdatingRef(a) {
            this.ck = a;
            this.g("CellUpdatingRef");
        }
    }
    TemplateSectionHeaderDescription.$t = /*@__PURE__*/ markType(TemplateSectionHeaderDescription, 'TemplateSectionHeaderDescription', SectionHeaderDescription.$);
    return TemplateSectionHeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateSectionHeaderCellUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class TemplateSectionHeaderCellUpdatingEventArgsDescription extends Description {
        get_type() {
            return "TemplateSectionHeaderCellUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
        }
    }
    TemplateSectionHeaderCellUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(TemplateSectionHeaderCellUpdatingEventArgsDescription, 'TemplateSectionHeaderCellUpdatingEventArgsDescription', Description.$);
    return TemplateSectionHeaderCellUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.a == null) {
                TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.c(TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.a);
            }
            if (a.k(TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.a)) {
                return;
            }
            a.ac(TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.a);
        }
        static c(a) {
        }
        static d(a) {
            TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.b(a);
            a.ae("TemplateSectionHeaderCellUpdatingEventArgs", () => new TemplateSectionHeaderCellUpdatingEventArgsDescription());
            a.ad("TemplateSectionHeaderCellUpdatingEventArgs", TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata, 'TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata');
    TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.a = null;
    return TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateSectionHeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateSectionHeaderDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateSectionHeaderDescriptionMetadata.a == null) {
                TemplateSectionHeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateSectionHeaderDescriptionMetadata.c(TemplateSectionHeaderDescriptionMetadata.a);
            }
            if (a.k(TemplateSectionHeaderDescriptionMetadata.a)) {
                return;
            }
            a.ac(TemplateSectionHeaderDescriptionMetadata.a);
            TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.d(a);
        }
        static c(a) {
            SectionHeaderDescriptionMetadata.c(a);
            a.item("CellUpdatingRef", "EventRef::cellUpdating");
        }
        static d(a) {
            TemplateSectionHeaderDescriptionMetadata.b(a);
            a.ae("TemplateSectionHeader", () => new TemplateSectionHeaderDescription());
            a.ad("TemplateSectionHeader", TemplateSectionHeaderDescriptionMetadata.a);
        }
    }
    TemplateSectionHeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateSectionHeaderDescriptionMetadata, 'TemplateSectionHeaderDescriptionMetadata');
    TemplateSectionHeaderDescriptionMetadata.a = null;
    return TemplateSectionHeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateSectionHeaderDescriptionModule = /*@__PURE__*/ (() => {
    class TemplateSectionHeaderDescriptionModule extends Base {
        static register(a) {
            SectionHeaderDescriptionModule.register(a);
            TemplateSectionHeaderDescriptionMetadata.d(a);
        }
    }
    TemplateSectionHeaderDescriptionModule.$t = /*@__PURE__*/ markType(TemplateSectionHeaderDescriptionModule, 'TemplateSectionHeaderDescriptionModule');
    return TemplateSectionHeaderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateSectionHeaderCellInfoDescription = /*@__PURE__*/ (() => {
    class TemplateSectionHeaderCellInfoDescription extends SectionHeaderCellInfoDescription {
        get_type() {
            return "TemplateSectionHeaderCellInfo";
        }
        constructor() {
            super();
        }
    }
    TemplateSectionHeaderCellInfoDescription.$t = /*@__PURE__*/ markType(TemplateSectionHeaderCellInfoDescription, 'TemplateSectionHeaderCellInfoDescription', SectionHeaderCellInfoDescription.$);
    TemplateSectionHeaderCellInfoDescription.__marshalByValue2 = true;
    TemplateSectionHeaderCellInfoDescription.__marshalByValueAlias2 = "TemplateSectionHeaderCellModel";
    return TemplateSectionHeaderCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateSectionHeaderCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateSectionHeaderCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateSectionHeaderCellInfoDescriptionMetadata.a == null) {
                TemplateSectionHeaderCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateSectionHeaderCellInfoDescriptionMetadata.c(TemplateSectionHeaderCellInfoDescriptionMetadata.a);
            }
            if (a.k(TemplateSectionHeaderCellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(TemplateSectionHeaderCellInfoDescriptionMetadata.a);
        }
        static c(a) {
            SectionHeaderCellInfoDescriptionMetadata.c(a);
        }
        static d(a) {
            TemplateSectionHeaderCellInfoDescriptionMetadata.b(a);
            a.ae("TemplateSectionHeaderCellInfo", () => new TemplateSectionHeaderCellInfoDescription());
            a.ad("TemplateSectionHeaderCellInfo", TemplateSectionHeaderCellInfoDescriptionMetadata.a);
        }
    }
    TemplateSectionHeaderCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateSectionHeaderCellInfoDescriptionMetadata, 'TemplateSectionHeaderCellInfoDescriptionMetadata');
    TemplateSectionHeaderCellInfoDescriptionMetadata.a = null;
    return TemplateSectionHeaderCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextCellInfoDescription = /*@__PURE__*/ (() => {
    class TextCellInfoDescription extends CellInfoDescription {
        get_type() {
            return "TextCellInfo";
        }
        constructor() {
            super();
            this.fn = null;
        }
        get textValue() {
            return this.fn;
        }
        set textValue(a) {
            this.fn = a;
            this.g("TextValue");
        }
    }
    TextCellInfoDescription.$t = /*@__PURE__*/ markType(TextCellInfoDescription, 'TextCellInfoDescription', CellInfoDescription.$);
    TextCellInfoDescription.__marshalByValue1 = true;
    TextCellInfoDescription.__marshalByValueAlias1 = "TextCellModel";
    return TextCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class TextCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (TextCellInfoDescriptionMetadata.a == null) {
                TextCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TextCellInfoDescriptionMetadata.c(TextCellInfoDescriptionMetadata.a);
            }
            if (a.k(TextCellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(TextCellInfoDescriptionMetadata.a);
        }
        static c(a) {
            CellInfoDescriptionMetadata.c(a);
            a.item("TextValue", "String");
        }
        static d(a) {
            TextCellInfoDescriptionMetadata.b(a);
            a.ae("TextCellInfo", () => new TextCellInfoDescription());
            a.ad("TextCellInfo", TextCellInfoDescriptionMetadata.a);
        }
    }
    TextCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(TextCellInfoDescriptionMetadata, 'TextCellInfoDescriptionMetadata');
    TextCellInfoDescriptionMetadata.a = null;
    return TextCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextHeaderCellInfoDescription = /*@__PURE__*/ (() => {
    class TextHeaderCellInfoDescription extends TextCellInfoDescription {
        get_type() {
            return "TextHeaderCellInfo";
        }
        constructor() {
            super();
            this.fq = false;
            this.fw = null;
            this.ft = null;
            this.fv = null;
            this.fu = null;
        }
        get isColumnOptionsEnabled() {
            return this.fq;
        }
        set isColumnOptionsEnabled(a) {
            this.fq = a;
            this.g("IsColumnOptionsEnabled");
        }
        get sortIndicatorStyle() {
            return this.fw;
        }
        set sortIndicatorStyle(a) {
            this.fw = a;
            this.g("SortIndicatorStyle");
        }
        get columnOptionsIconAlignment() {
            return this.ft;
        }
        set columnOptionsIconAlignment(a) {
            this.ft = a;
            this.g("ColumnOptionsIconAlignment");
        }
        get columnOptionsIconColor() {
            return this.fv;
        }
        set columnOptionsIconColor(a) {
            this.fv = a;
            this.g("ColumnOptionsIconColor");
        }
        get columnOptionsIconBehavior() {
            return this.fu;
        }
        set columnOptionsIconBehavior(a) {
            this.fu = a;
            this.g("ColumnOptionsIconBehavior");
        }
    }
    TextHeaderCellInfoDescription.$t = /*@__PURE__*/ markType(TextHeaderCellInfoDescription, 'TextHeaderCellInfoDescription', TextCellInfoDescription.$);
    TextHeaderCellInfoDescription.__marshalByValue2 = true;
    TextHeaderCellInfoDescription.__marshalByValueAlias2 = "TextHeaderCellModel";
    return TextHeaderCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextHeaderCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class TextHeaderCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (TextHeaderCellInfoDescriptionMetadata.a == null) {
                TextHeaderCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TextHeaderCellInfoDescriptionMetadata.c(TextHeaderCellInfoDescriptionMetadata.a);
            }
            if (a.k(TextHeaderCellInfoDescriptionMetadata.a)) {
                return;
            }
            a.ac(TextHeaderCellInfoDescriptionMetadata.a);
        }
        static c(a) {
            TextCellInfoDescriptionMetadata.c(a);
            a.item("IsColumnOptionsEnabled", "Boolean");
            a.item("SortIndicatorStyle", "ExportedType:string:SortIndicatorStyle");
            a.item("SortIndicatorStyle@names", "Default;FadingUpDownArrows;FadingSimpleUpDownArrows;Unset");
            a.item("ColumnOptionsIconAlignment", "ExportedType:string:ColumnOptionsIconAlignment");
            a.item("ColumnOptionsIconAlignment@names", "Unset;None;Opposite");
            a.item("ColumnOptionsIconColor", "Brush");
            a.item("ColumnOptionsIconBehavior", "ExportedType:string:ColumnOptionsIconBehavior");
            a.item("ColumnOptionsIconBehavior@names", "Unset;AlwaysVisible;AppearOnHover;AppearOnHoverAnimate");
        }
        static d(a) {
            TextHeaderCellInfoDescriptionMetadata.b(a);
            a.ae("TextHeaderCellInfo", () => new TextHeaderCellInfoDescription());
            a.ad("TextHeaderCellInfo", TextHeaderCellInfoDescriptionMetadata.a);
        }
    }
    TextHeaderCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(TextHeaderCellInfoDescriptionMetadata, 'TextHeaderCellInfoDescriptionMetadata');
    TextHeaderCellInfoDescriptionMetadata.a = null;
    return TextHeaderCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionTreeActionType_$type = /*@__PURE__*/ markEnum('DescriptionTreeActionType', 'UpdateProperty,0|ResetProperty,1|InsertItem,2|ReplaceItem,3|RemoveItem,4|ClearItems,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChildContentExtendedDescriptionModule = /*@__PURE__*/ (() => {
    class ChildContentExtendedDescriptionModule extends Base {
        static register(a) {
        }
    }
    ChildContentExtendedDescriptionModule.$t = /*@__PURE__*/ markType(ChildContentExtendedDescriptionModule, 'ChildContentExtendedDescriptionModule');
    return ChildContentExtendedDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartDefaultTooltipsExtendedDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataChartDefaultTooltipsExtendedDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    DataChartDefaultTooltipsExtendedDescriptionMetadata.$t = /*@__PURE__*/ markType(DataChartDefaultTooltipsExtendedDescriptionMetadata, 'DataChartDefaultTooltipsExtendedDescriptionMetadata');
    return DataChartDefaultTooltipsExtendedDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoughnutChartDefaultTooltipsExtendedDescriptionMetadata = /*@__PURE__*/ (() => {
    class DoughnutChartDefaultTooltipsExtendedDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    DoughnutChartDefaultTooltipsExtendedDescriptionMetadata.$t = /*@__PURE__*/ markType(DoughnutChartDefaultTooltipsExtendedDescriptionMetadata, 'DoughnutChartDefaultTooltipsExtendedDescriptionMetadata');
    return DoughnutChartDefaultTooltipsExtendedDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TooltipContainerExtendedDescriptionModule = /*@__PURE__*/ (() => {
    class TooltipContainerExtendedDescriptionModule extends Base {
        static register(a) {
        }
    }
    TooltipContainerExtendedDescriptionModule.$t = /*@__PURE__*/ markType(TooltipContainerExtendedDescriptionModule, 'TooltipContainerExtendedDescriptionModule');
    return TooltipContainerExtendedDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SimpleDefaultTooltipExtendedDescriptionMetadata = /*@__PURE__*/ (() => {
    class SimpleDefaultTooltipExtendedDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    SimpleDefaultTooltipExtendedDescriptionMetadata.$t = /*@__PURE__*/ markType(SimpleDefaultTooltipExtendedDescriptionMetadata, 'SimpleDefaultTooltipExtendedDescriptionMetadata');
    return SimpleDefaultTooltipExtendedDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartDefaultTemplatesExtendedDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialChartDefaultTemplatesExtendedDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    FinancialChartDefaultTemplatesExtendedDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialChartDefaultTemplatesExtendedDescriptionMetadata, 'FinancialChartDefaultTemplatesExtendedDescriptionMetadata');
    return FinancialChartDefaultTemplatesExtendedDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateContentExtendedDescriptionModule = /*@__PURE__*/ (() => {
    class TemplateContentExtendedDescriptionModule extends Base {
        static register(a) {
        }
    }
    TemplateContentExtendedDescriptionModule.$t = /*@__PURE__*/ markType(TemplateContentExtendedDescriptionModule, 'TemplateContentExtendedDescriptionModule');
    return TemplateContentExtendedDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebAccordionDescription = /*@__PURE__*/ (() => {
    class WebAccordionDescription extends Description {
        get_type() {
            return "WebAccordion";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.h = false;
        }
        get singleExpand() {
            return this.h;
        }
        set singleExpand(a) {
            this.h = a;
            this.g("SingleExpand");
        }
    }
    WebAccordionDescription.$t = /*@__PURE__*/ markType(WebAccordionDescription, 'WebAccordionDescription', Description.$);
    return WebAccordionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebAccordionDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebAccordionDescriptionMetadata extends Base {
        static b(a) {
            if (WebAccordionDescriptionMetadata.a == null) {
                WebAccordionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebAccordionDescriptionMetadata.c(WebAccordionDescriptionMetadata.a);
            }
            if (a.k(WebAccordionDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebAccordionDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Accordion");
            a.item("__tagNameWC", "String:igc-accordion");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("SingleExpand", "Boolean");
        }
        static d(a) {
            WebAccordionDescriptionMetadata.b(a);
            a.ae("WebAccordion", () => new WebAccordionDescription());
            a.ad("WebAccordion", WebAccordionDescriptionMetadata.a);
        }
    }
    WebAccordionDescriptionMetadata.$t = /*@__PURE__*/ markType(WebAccordionDescriptionMetadata, 'WebAccordionDescriptionMetadata');
    WebAccordionDescriptionMetadata.a = null;
    return WebAccordionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebAccordionDescriptionModule = /*@__PURE__*/ (() => {
    class WebAccordionDescriptionModule extends Base {
        static register(a) {
            WebAccordionDescriptionMetadata.d(a);
        }
    }
    WebAccordionDescriptionModule.$t = /*@__PURE__*/ markType(WebAccordionDescriptionModule, 'WebAccordionDescriptionModule');
    return WebAccordionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebAvatarDescription = /*@__PURE__*/ (() => {
    class WebAvatarDescription extends Description {
        get_type() {
            return "WebAvatar";
        }
        get type() {
            return this.get_type();
        }
        constructor() {
            super();
            this.k = null;
            this.h = null;
            this.i = null;
            this.j = null;
        }
        get src() {
            return this.k;
        }
        set src(a) {
            this.k = a;
            this.g("Src");
        }
        get alt() {
            return this.h;
        }
        set alt(a) {
            this.h = a;
            this.g("Alt");
        }
        get initials() {
            return this.i;
        }
        set initials(a) {
            this.i = a;
            this.g("Initials");
        }
        get shape() {
            return this.j;
        }
        set shape(a) {
            this.j = a;
            this.g("Shape");
        }
    }
    WebAvatarDescription.$t = /*@__PURE__*/ markType(WebAvatarDescription, 'WebAvatarDescription', Description.$);
    return WebAvatarDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebAvatarDescriptionMetadata = /*@__PURE__*/ (() => {
    class WebAvatarDescriptionMetadata extends Base {
        static b(a) {
            if (WebAvatarDescriptionMetadata.a == null) {
                WebAvatarDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WebAvatarDescriptionMetadata.c(WebAvatarDescriptionMetadata.a);
            }
            if (a.k(WebAvatarDescriptionMetadata.a)) {
                return;
            }
            a.ac(WebAvatarDescriptionMetadata.a);
        }
        static c(a) {
            a.item("__qualifiedNameTS", "String:Avatar");
            a.item("__tagNameWC", "String:igc-avatar");
            a.item("__skipModuleRegisterWebComponents", "Boolean");
            a.item("__importTypesWebComponents", "String:igniteui-webcomponents");
            a.item("Src", "String");
            a.item("Alt", "String");
            a.item("Initials", "String");
            a.item("Shape", "ExportedType:string:AvatarShape");
            a.item("Shape@stringUnion", "WebComponents;React");
            a.item("Shape@names", "Circle;Rounded;Square");
        }
        static d(a) {
            WebAvatarDescriptionMetadata.b(a);
            a.ae("WebAvatar", () => new WebAvatarDescription());
            a.ad("WebAvatar", WebAvatarDescriptionMetadata.a);
        }
    }
    WebAvatarDescriptionMetadata.$t = /*@__PURE__*/ markType(WebAvatarDescriptionMetadata, 'WebAvatarDescriptionMetadata');
    WebAvatarDescriptionMetadata.a = null;
    return WebAvatarDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebAvatarDescriptionModule = /*@__PURE__*/ (() => {
    class WebAvatarDescriptionModule extends Base {
        static register(a) {
            WebAvatarDescriptionMetadata.d(a);
        }
    }
    WebAvatarDescriptionModule.$t = /*@__PURE__*/ markType(WebAvatarDescriptionModule, 'WebAvatarDescriptionModule');
    return WebAvatarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolPanelDescriptionModule = /*@__PURE__*/ (() => {
    class ToolPanelDescriptionModule extends Base {
        static register(a) {
            ListPanelDescriptionModule.register(a);
            ToolActionLabelDescriptionModule.register(a);
            ToolActionCheckboxDescriptionModule.register(a);
            ToolActionCheckboxListDescriptionModule.register(a);
            ToolActionGroupHeaderDescriptionModule.register(a);
            ToolActionNumberInputDescriptionModule.register(a);
            ToolActionIconButtonDescriptionModule.register(a);
            ToolActionIconMenuDescriptionModule.register(a);
            ToolActionSeparatorDescriptionModule.register(a);
            ToolActionSubPanelDescriptionModule.register(a);
            ToolActionRadioDescriptionModule.register(a);
            ToolActionButtonDescriptionModule.register(a);
            InputGroupDescriptionModule.register(a);
            CheckboxDescriptionModule.register(a);
            ButtonDescriptionModule.register(a);
            IconDescriptionModule.register(a);
            ToolPanelDescriptionMetadata.d(a);
        }
    }
    ToolPanelDescriptionModule.$t = /*@__PURE__*/ markType(ToolPanelDescriptionModule, 'ToolPanelDescriptionModule');
    return ToolPanelDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ToolbarDescriptionModule = /*@__PURE__*/ (() => {
    class ToolbarDescriptionModule extends Base {
        static register(a) {
            ToolPanelDescriptionModule.register(a);
            ToolbarDescriptionMetadata.d(a);
        }
    }
    ToolbarDescriptionModule.$t = /*@__PURE__*/ markType(ToolbarDescriptionModule, 'ToolbarDescriptionModule');
    return ToolbarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Uri = /*@__PURE__*/ (() => {
    class Uri extends Base {
        constructor(a, ..._rest) {
            super();
            this._value = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, 1, true];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = d[2];
                            this.value = f;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [c, d, true];
                        {
                            let g = e[0];
                            let h = e[1];
                            let i = e[2];
                            this.value = g;
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        this.value = c;
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        throw new NotImplementedException(0);
                    }
                    break;
            }
        }
        get value() {
            return this._value;
        }
        set value(a) {
            this._value = a;
        }
        get isAbsoluteUri() {
            let a = this.value;
            let b = a.length;
            if (b != 0 && isLetter(a.charAt(0))) {
                for (let c = 1; c < b; c++) {
                    let d = a.charAt(c);
                    if (d == ':') {
                        return true;
                    }
                    if (d != '+' && d != '-' && d != '.' && !isLetterOrDigit(d)) {
                        break;
                    }
                }
            }
            return false;
        }
        get scheme() {
            let a = this.value;
            let b = a.length;
            if (b != 0 && isLetter(a.charAt(0))) {
                for (let c = 1; c < b; c++) {
                    let d = a.charAt(c);
                    if (d == ':') {
                        return a.substr(0, c);
                    }
                    if (d != '+' && d != '-' && d != '.' && !isLetterOrDigit(d)) {
                        break;
                    }
                }
            }
            throw new InvalidOperationException(1, "The scheme cannot be obtained from a relative Uri.");
        }
        static encodeURIComponent(a) {
            return null;
        }
        static escapeUriString(a) {
            if ((/^([A-Z]:)|(\\\\)/i.test(a))) {
                return a;
            }
            return (encodeURI(a));
        }
        static tryCreate(a, b, c) {
            if (Uri.isWellFormedUriString(a, b)) {
                c = new Uri(2, a, b, false);
                return {
                    ret: true,
                    p2: c
                };
            }
            c = null;
            return {
                ret: false,
                p2: c
            };
        }
        static isWellFormedUriString(a, b) {
            switch (b) {
                case 1:
                    if (!(/^(((http|ftp|https):\/\/[\w-]+(\.[\w-]*)+)|(file:\/\/\/?))([\w\\$()!'.,@?^=%&amp;:\/~+#-]*[\w@?^=%&amp;\/~+#-])?$/i.test(a))) {
                        return false;
                    }
                    break;
                case 2:
                    if (!(/^([\w\\$()!'.,@?^=%&amp;:\/~+#-]*[\w@?^=%&amp;\/~+#-])?$/i.test(a))) {
                        return false;
                    }
                    break;
                default:
                case 0:
                    if (!(/^((((http|ftp|https):\/\/[\w-]+(\.[\w-]*)+)|(file:\/\/\/?)))?([\w\\$()!'.,@?^=%&amp;:\/~+#-]*[\w@?^=%&amp;\/~+#-])?$/i.test(a))) {
                        return false;
                    }
                    break;
            }
            return true;
        }
        toString() {
            if ((/^([A-Z]:)|(\\\\)/i.test(this.value))) {
                return this.value;
            }
            let a = (decodeURI(this.value));
            if ((/^(http|ftp|https):\/\/[\w-]+(\.[\w-]*)+?$/i.test(a))) {
                a += "/";
            }
            return a;
        }
        get absolutePath() {
            throw new NotImplementedException(0);
        }
        get absoluteUri() {
            throw new NotImplementedException(0);
        }
        get localPath() {
            let a = (/^(((http|ftp|https):\/\/[\w-]+(\.[\w-]*)+)|(file:\/\/\/?))([\w\\$()!'.,@?^=%&amp;:\/~+#-]*[\w@?^=%&amp;\/~+#-])?$/i.exec(this.value));
            if (a == null) {
                throw new InvalidOperationException(0);
            }
            if (a[6] != null) {
                return (decodeURI(a[6]));
            }
            return "/";
        }
        get originalString() {
            return this.value;
        }
        isWellFormedOriginalString() {
            return Uri.isWellFormedUriString(this.value, 0);
        }
    }
    Uri.$t = /*@__PURE__*/ markType(Uri, 'Uri');
    Uri.schemeDelimiter = "://";
    return Uri;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulationSourcePointRecord = /*@__PURE__*/ (() => {
    class TriangulationSourcePointRecord extends Base {
        constructor() {
            super(...arguments);
            this.pointX = 0;
            this.pointY = 0;
            this.value = 0;
        }
    }
    TriangulationSourcePointRecord.$t = /*@__PURE__*/ markType(TriangulationSourcePointRecord, 'TriangulationSourcePointRecord');
    return TriangulationSourcePointRecord;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Triangle = /*@__PURE__*/ (() => {
    class Triangle extends Base {
        constructor() {
            super(...arguments);
            this.v1 = 0;
            this.v2 = 0;
            this.v3 = 0;
        }
    }
    Triangle.$t = /*@__PURE__*/ markType(Triangle, 'Triangle');
    return Triangle;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulatorContext = /*@__PURE__*/ (() => {
    class TriangulatorContext extends Base {
        constructor() {
            super(...arguments);
            this.j = 0;
            this.d = null;
            this.e = null;
            this.i = null;
            this.n = null;
            this.o = null;
            this.p = null;
            this.g = null;
            this.f = null;
            this.h = null;
            this.a = null;
            this.b = null;
            this.m = 0;
            this.l = 0;
            this.k = 0;
            this.c = false;
        }
    }
    TriangulatorContext.$t = /*@__PURE__*/ markType(TriangulatorContext, 'TriangulatorContext');
    return TriangulatorContext;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HalfEdge = /*@__PURE__*/ (() => {
    class HalfEdge extends Base {
        constructor(a, b) {
            super();
            this.a = 0;
            this.b = 0;
            this.a = a;
            this.b = b;
        }
    }
    HalfEdge.$t = /*@__PURE__*/ markType(HalfEdge, 'HalfEdge');
    return HalfEdge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EdgeComparer = /*@__PURE__*/ (() => {
    class EdgeComparer extends Base {
        equalsC(a, b) {
            return (a.a == b.a && a.b == b.b) || (a.a == b.b && a.b == b.a);
        }
        getHashCodeC(a) {
            return 65536 * Math.max(a.a, a.b) + Math.min(a.a, a.b);
        }
    }
    EdgeComparer.$t = /*@__PURE__*/ markType(EdgeComparer, 'EdgeComparer', Base.$, [/*@__PURE__*/ IEqualityComparer$1_$type.specialize(HalfEdge.$)]);
    return EdgeComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HalfEdgeSet = /*@__PURE__*/ (() => {
    class HalfEdgeSet extends Base {
        constructor() {
            super();
            this.b = null;
            this.b = new Dictionary$2(HalfEdge.$, Base.$, 2, new EdgeComparer());
        }
        getEnumerator() {
            return getEnumerator(this.b.keys);
        }
        getEnumeratorObject() {
            return this.getEnumerator();
        }
        d(a) {
            this.b.addItem(a, null);
        }
        f(a) {
            this.b.removeItem(a);
        }
        e() {
            this.b.clear();
        }
        get c() {
            return this.b.count;
        }
        a(a) {
            return this.b.containsKey(a);
        }
    }
    HalfEdgeSet.$t = /*@__PURE__*/ markType(HalfEdgeSet, 'HalfEdgeSet', Base.$, [/*@__PURE__*/ IEnumerable$1_$type.specialize(HalfEdge.$)]);
    return HalfEdgeSet;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointTester = /*@__PURE__*/ (() => {
    class PointTester extends Base {
        constructor() {
            super(...arguments);
            this.a = false;
            this.b = false;
        }
        c(a, b, c, d, e, f, g, h) {
            let i = Math.abs(d - f);
            let j = Math.abs(f - h);
            let k = 0;
            let l = 0;
            if (i == 0 && j == 0) {
                return false;
            }
            if (i == 0 && j != 0) {
                k = (e + c) / 2;
                l = (-(g - e) / (h - f)) * (k - ((e + g) / 2)) + ((f + h) / 2);
            }
            if (i != 0 && j == 0) {
                k = (g + e) / 2;
                l = (-(e - c) / (f - d)) * (k - ((c + e) / 2)) + ((d + f) / 2);
            }
            if (i != 0 && j != 0) {
                let m = -(e - c) / (f - d);
                let n = -(g - e) / (h - f);
                let o = (c + e) / 2;
                let p = (e + g) / 2;
                let q = (d + f) / 2;
                let r = (f + h) / 2;
                k = (m * o - n * p + r - q) / (m - n);
                l = i > j ? m * (k - o) + q : n * (k - p) + r;
            }
            let s = e - k;
            let t = f - l;
            let u = s * s + t * t;
            s = a - k;
            t = b - l;
            let v = s * s + t * t;
            this.b = v <= u;
            this.a = k < a && ((a - k) * (a - k)) > u;
            return true;
        }
    }
    PointTester.$t = /*@__PURE__*/ markType(PointTester, 'PointTester');
    return PointTester;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointComparer = /*@__PURE__*/ (() => {
    class PointComparer extends Base {
        equalsC(a, b) {
            return a.x == b.x && a.y == b.y;
        }
        getHashCodeC(a) {
            return (a.x) ^ (a.y);
        }
    }
    PointComparer.$t = /*@__PURE__*/ markType(PointComparer, 'PointComparer', Base.$, [/*@__PURE__*/ IEqualityComparer$1_$type.specialize(Point_$type)]);
    return PointComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulationStatusEventArgs = /*@__PURE__*/ (() => {
    class TriangulationStatusEventArgs extends EventArgs {
        get currentStatus() {
            return this._currentStatus;
        }
        set currentStatus(a) {
            this._currentStatus = a;
        }
        constructor(a) {
            super();
            this._currentStatus = 0;
            this.currentStatus = a;
        }
    }
    TriangulationStatusEventArgs.$t = /*@__PURE__*/ markType(TriangulationStatusEventArgs, 'TriangulationStatusEventArgs', EventArgs.$);
    return TriangulationStatusEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Triangulator = /*@__PURE__*/ (() => {
    class Triangulator extends DependencyObject {
        constructor(a, b, c) {
            super();
            this.o = 0;
            this.l = null;
            this.m = null;
            this.k = null;
            this.p = 0;
            this.triangulationStatusChanged = null;
            this.o = a;
            this.l = b;
            this.m = c;
        }
        y() {
            {
                this.v();
                if (this.k != null) {
                    this.k.c = true;
                }
                this.u();
            }
        }
        x() {
            {
                this.v();
                if (this.k != null) {
                    this.k.c = false;
                }
                this.u();
            }
        }
        v() {
            let a = this.o;
            let b = this.l;
            let c = this.m;
            let d = new List$1(Triangle.$, 0);
            let e = ((() => {
                let $ret = new List$1(Number_$type, 0);
                $ret.h = a;
                return $ret;
            })());
            let f = new HashSet$1(Point_$type, 2, new PointComparer());
            for (let g = 0; g < a; ++g) {
                let h = b.item(g), i = c.item(g);
                if (isNaN_(h) || isNaN_(i) || isInfinity(h) || isInfinity(i)) {
                    continue;
                }
                let j = { $type: Point_$type, x: h, y: i };
                if (f.contains(j)) {
                    continue;
                }
                f.add_1(j);
                e.add(g);
            }
            a = e.count;
            if (a >= 3) {
                let k = (l, m) => {
                    if (b.item(l) < b.item(m)) {
                        return -1;
                    }
                    else if (b.item(l) > b.item(m)) {
                        return 1;
                    }
                    if (c.item(l) < c.item(m)) {
                        return -1;
                    }
                    else if (c.item(l) > c.item(m)) {
                        return 1;
                    }
                    return 0;
                };
                e.aa(k);
                let l = b.item(e._inner[0]);
                let m = b.item(e._inner[a - 1]);
                let n = c.item(e._inner[0]);
                let o = n;
                for (let p = 1; p < a; p++) {
                    let q = c.item(e._inner[p]);
                    if (isNaN_(q)) {
                        continue;
                    }
                    n = Math.min(n, q);
                    o = Math.max(o, q);
                }
                let r = m - l;
                let s = o - n;
                let t = Math.max(r, s);
                let u = (m + l) / 2;
                let v = (o + n) / 2;
                let w = { $type: Point_$type, x: u - 20 * t, y: v - t };
                let x = { $type: Point_$type, x: u, y: v + 20 * t };
                let y = { $type: Point_$type, x: u + 20 * t, y: v - t };
                let z = new LinkedList$1(Triangle.$);
                let aa = new LinkedList$1(Triangle.$);
                let ab = new HalfEdgeSet();
                let ac = new PointTester();
                z.e(((() => {
                    let $ret = new Triangle();
                    $ret.v1 = a;
                    $ret.v2 = a + 1;
                    $ret.v3 = a + 2;
                    return $ret;
                })()));
                let ad = new TriangulatorContext();
                ad.j = a;
                ad.n = w;
                ad.o = x;
                ad.p = y;
                ad.f = aa;
                ad.a = ab;
                ad.h = e;
                ad.b = ac;
                ad.i = d;
                ad.g = z;
                ad.d = b;
                ad.e = c;
                let ae = 1;
                if (a > 3000) {
                    ae = 20;
                }
                ad.m = truncate(Math.ceil(a / ae));
                ad.l = 0;
                ad.k = ad.m;
                this.p = 0;
                this.t();
                this.k = ad;
            }
        }
        t() {
            this.s();
        }
        s() {
            if (this.triangulationStatusChanged != null) {
                this.triangulationStatusChanged(this, new TriangulationStatusEventArgs(this.p));
            }
        }
        n() {
            if (this.k == null) {
                return null;
            }
            return this.k.i;
        }
        w() {
            {
                if (this.k == null) {
                    return;
                }
                let a = this.k;
                let b = this.k.j;
                let c = this.k.d;
                let d = this.k.e;
                let e = this.k.h;
                let f = this.k.n;
                let g = this.k.o;
                let h = this.k.p;
                let i = this.k.i;
                let j = this.k.g;
                let k = this.k.f;
                let l = this.k.b;
                let m = this.k.a;
                let n = this.k.l;
                let o = this.k.k;
                let p;
                let q;
                let r;
                let s;
                let t;
                let u;
                let v;
                let w;
                let x;
                let y;
                let z;
                let aa;
                for (let ab = n; ab < o; ++ab) {
                    m.e();
                    if (ab < b) {
                        p = c.item(e._inner[ab]);
                        q = d.item(e._inner[ab]);
                    }
                    else if (ab == b) {
                        p = f.x;
                        q = f.y;
                    }
                    else if (ab == b + 1) {
                        p = g.x;
                        q = g.y;
                    }
                    else {
                        p = h.x;
                        q = h.y;
                    }
                    let ac = null;
                    for (let ad = j.c; ad != null; ad = ac) {
                        ac = ad.a;
                        aa = ad.c;
                        r = aa.v1;
                        u = aa.v2;
                        x = aa.v3;
                        if (r < b) {
                            s = c.item(e._inner[r]);
                            t = d.item(e._inner[r]);
                        }
                        else if (r == b) {
                            s = f.x;
                            t = f.y;
                        }
                        else if (r == b + 1) {
                            s = g.x;
                            t = g.y;
                        }
                        else {
                            s = h.x;
                            t = h.y;
                        }
                        if (u < b) {
                            v = c.item(e._inner[u]);
                            w = d.item(e._inner[u]);
                        }
                        else if (u == b) {
                            v = f.x;
                            w = f.y;
                        }
                        else if (u == b + 1) {
                            v = g.x;
                            w = g.y;
                        }
                        else {
                            v = h.x;
                            w = h.y;
                        }
                        if (x < b) {
                            y = c.item(e._inner[x]);
                            z = d.item(e._inner[x]);
                        }
                        else if (x == b) {
                            y = f.x;
                            z = f.y;
                        }
                        else if (x == b + 1) {
                            y = g.x;
                            z = g.y;
                        }
                        else {
                            y = h.x;
                            z = h.y;
                        }
                        l.c(p, q, s, t, v, w, y, z);
                        if (l.a) {
                            k.f(aa);
                            j.h(ad);
                        }
                        if (l.b) {
                            let ae;
                            ae = new HalfEdge(r, u);
                            if (m.a(ae)) {
                                m.f(ae);
                            }
                            else {
                                m.d(ae);
                            }
                            ae = new HalfEdge(u, x);
                            if (m.a(ae)) {
                                m.f(ae);
                            }
                            else {
                                m.d(ae);
                            }
                            ae = new HalfEdge(x, r);
                            if (m.a(ae)) {
                                m.f(ae);
                            }
                            else {
                                m.d(ae);
                            }
                            j.h(ad);
                        }
                    }
                    for (let af of fromEnum(m)) {
                        let ag = new Triangle();
                        ag.v1 = af.a;
                        ag.v2 = af.b;
                        ag.v3 = ab;
                        j.f(ag);
                    }
                }
                if (o == b) {
                    for (let ah = k.c; ah != null; ah = ah.a) {
                        aa = ah.c;
                        if (aa.v1 < b && aa.v2 < b && aa.v3 < b) {
                            i.add(((() => {
                                let $ret = new Triangle();
                                $ret.v1 = e._inner[aa.v1];
                                $ret.v2 = e._inner[aa.v2];
                                $ret.v3 = e._inner[aa.v3];
                                return $ret;
                            })()));
                        }
                    }
                    for (let ai = j.c; ai != null; ai = ai.a) {
                        aa = ai.c;
                        if (aa.v1 < b && aa.v2 < b && aa.v3 < b) {
                            i.add(((() => {
                                let $ret = new Triangle();
                                $ret.v1 = e._inner[aa.v1];
                                $ret.v2 = e._inner[aa.v2];
                                $ret.v3 = e._inner[aa.v3];
                                return $ret;
                            })()));
                        }
                    }
                    this.p = 100;
                    this.t();
                }
                else {
                    n = o;
                    o += a.m;
                    if (o > b) {
                        o = b;
                    }
                    a.l = n;
                    a.k = o;
                    this.p += truncate(Math.floor(100 / 20));
                    this.t();
                    this.u();
                }
            }
        }
        r() {
            {
                this.k = null;
            }
        }
        u() {
            {
                if (this.k != null && this.k.c) {
                    window.setTimeout(runOn(this, this.w), 0);
                }
                else {
                    this.w();
                }
            }
        }
        get q() {
            return this.p;
        }
    }
    Triangulator.$t = /*@__PURE__*/ markType(Triangulator, 'Triangulator', DependencyObject.$);
    return Triangulator;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulationSource = /*@__PURE__*/ (() => {
    class TriangulationSource extends Base {
        constructor() {
            super(...arguments);
            this._points = null;
            this._triangles = null;
        }
        static create(a, b, c) {
            let d = new TriangulationSource();
            let e = new Array(a);
            let f;
            let g;
            let h = new Array(a);
            let i = new Array(a);
            let j = 0;
            let k = 0;
            for (let l = 0; l < a; l++) {
                f = new TriangulationSourcePointRecord();
                g = b(l);
                j = g.x;
                k = g.y;
                f.pointX = j;
                f.pointY = k;
                f.value = c(l);
                e[l] = f;
                h[l] = j;
                i[l] = k;
            }
            d.points = e;
            let m = new Triangulator(a, boxArray$1(h), boxArray$1(i));
            m.x();
            d.triangles = m.n();
            return d;
        }
        static loadItf(a) {
            a.readBytes(5);
            let b = a.readInt32();
            let c = a.readInt32();
            let d = a.readInt32();
            let e = a.readInt32();
            a.readBytes(e);
            let f = new TriangulationSource();
            let g = new Array(b);
            let h;
            for (let i = 0; i < b; i++) {
                h = new TriangulationSourcePointRecord();
                h.pointX = a.readDouble();
                h.pointY = a.readDouble();
                h.value = a.readSingle();
                g[i] = h;
            }
            f.points = g;
            let j = new Array(c);
            let k;
            for (let l = 0; l < c; l++) {
                k = new Triangle();
                k.v1 = a.readInt32();
                k.v2 = a.readInt32();
                k.v3 = a.readInt32();
                j[l] = k;
            }
            f.triangles = boxArray$1(j);
            return f;
        }
        get points() {
            return this._points;
        }
        set points(a) {
            this._points = a;
        }
        get triangles() {
            return this._triangles;
        }
        set triangles(a) {
            this._triangles = a;
        }
    }
    TriangulationSource.$t = /*@__PURE__*/ markType(TriangulationSource, 'TriangulationSource');
    return TriangulationSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BinaryReader = /*@__PURE__*/ (() => {
    class BinaryReader extends Base {
        get canRead() {
            return this.n < this._data.length;
        }
        get currentPosition() {
            return this.n;
        }
        get length() {
            if (this.f) {
                return this._stream.length;
            }
            return this._data.length;
        }
        constructor(a, ..._rest) {
            super();
            this._data = null;
            this.d = false;
            this.n = 0;
            this.e = false;
            this.f = false;
            this._stream = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this._data = c;
                        this.d = d;
                        let data_ = this._data;
                        if ((typeof Uint8Array != 'undefined' && data_ instanceof Uint8Array)) {
                            this.e = true;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this._stream = c;
                        this.f = true;
                    }
                    break;
            }
        }
        i(offset_) {
            if (this.f) {
                this._stream.position = offset_;
                return this._stream.readByte();
            }
            else if (this.e) {
                return (+this._data[offset_] & 0xFF);
            }
            else {
                return (this._data.charCodeAt(offset_) & 0xFF);
            }
        }
        a(offset_, a) {
            let b = new Array(a);
            if (this.f) {
                this._stream.position = offset_;
                this._stream.read(b, 0, a);
            }
            else if (this.e) {
                for (let i_ = 0; i_ < a; i_++) {
                    b[i_] = (+this._data[offset_ + i_] & 0xFF);
                }
            }
            else {
                for (let i_ = 0; i_ < a; i_++) {
                    b[i_] = (this._data.charCodeAt(offset_ + i_) & 0xFF);
                }
            }
            return b;
        }
        b(offset_, length_) {
            let a = new Array(length_);
            if (this.f) {
                this._stream.position = offset_;
                this._stream.read(a, 0, length_);
                a.reverse();
            }
            else if (this.e) {
                for (let i_ = 0; i_ < length_; i_++) {
                    a[i_] = (+this._data[offset_ + (length_ - 1 - i_)] & 0xFF);
                }
            }
            else {
                for (let i_ = 0; i_ < length_; i_++) {
                    a[i_] = (this._data.charCodeAt(offset_ + (length_ - 1 - i_)) & 0xFF);
                }
            }
            return a;
        }
        readByte() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = this.i(this.n);
            this.n = this.n + 1;
            return a;
        }
        readBytes(a) {
            if (this.f) {
                this.n = this._stream.position;
            }
            let b = this.a(this.n, a);
            this.n = this.n + a;
            return b;
        }
        readUInt32() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = 0;
            if (this.d) {
                a = a + (this.i(this.n) << 24);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 16);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
                a = a + this.i(this.n);
                this.n = this.n + 1;
            }
            else {
                a = a + this.i(this.n);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 16);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 24);
                this.n = this.n + 1;
            }
            if (a < 0) {
                a = a + 0xFFFFFFFF + 1;
            }
            return a;
        }
        readUInt16() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = 0;
            if (this.d) {
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
                a = a + this.i(this.n);
                this.n = this.n + 1;
            }
            else {
                a = a + this.i(this.n);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
            }
            return a;
        }
        readInt32() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = 0;
            if (this.d) {
                a = a + (this.i(this.n) << 24);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 16);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
                a = a + this.i(this.n);
                this.n = this.n + 1;
            }
            else {
                a = a + this.i(this.n);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 16);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 24);
                this.n = this.n + 1;
            }
            if (a > 2147483647) {
                a = a - 0xFFFFFFFF - 1;
            }
            return a;
        }
        readDouble() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = this.b(this.n, 8);
            this.n = this.n + 8;
            let b = a[0] >>> 7;
            let c = 0;
            c = c + (a[1] >>> 4);
            c = c + ((a[0] & 127) << 4);
            let d = 1;
            let e = a[1];
            let f = 1 / 2;
            let g = 0;
            let h = false;
            for (g = 5; g <= 8; g++) {
                if ((e & (1 << (8 - g))) > 0) {
                    d = d + f;
                    h = true;
                }
                f = f / 2;
            }
            for (let i = 2; i < 8; i++) {
                e = a[i];
                for (g = 1; g <= 8; g++) {
                    if ((e & (1 << (8 - g))) > 0) {
                        d = d + f;
                        h = true;
                    }
                    f = f / 2;
                }
            }
            if (c == 0 && !h) {
                return 0;
            }
            if (c == 0 && h) {
                c = 1;
                d = d - 1;
            }
            if (c == 1860 && !h) {
                if (b == 1) {
                    return Number.NEGATIVE_INFINITY;
                }
                else {
                    return Number.POSITIVE_INFINITY;
                }
            }
            if (c == 1860 && h) {
                return NaN;
            }
            let j = c - 1023;
            return Math.pow(-1, b) * Math.pow(2, j) * d;
        }
        readSingle() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = this.b(this.n, 4);
            this.n = this.n + 4;
            let b = a[0] >>> 7;
            let c = 0;
            c = c + (a[1] >>> 7);
            c = c + ((a[0] & 127) << 1);
            let d = 1;
            let e = a[1];
            let f = 1 / 2;
            let g = 0;
            let h = false;
            for (g = 2; g <= 8; g++) {
                if ((e & (1 << (8 - g))) > 0) {
                    d = d + f;
                    h = true;
                }
                f = f / 2;
            }
            for (let i = 2; i < 4; i++) {
                e = a[i];
                for (g = 1; g <= 8; g++) {
                    if ((e & (1 << (8 - g))) > 0) {
                        d = d + f;
                        h = true;
                    }
                    f = f / 2;
                }
            }
            if (c == 0 && !h) {
                return 0;
            }
            if (c == 0 && h) {
                c = 1;
                d = d - 1;
            }
            if (c == 255 && !h) {
                if (b == 1) {
                    return Number.NEGATIVE_INFINITY;
                }
                else {
                    return Number.POSITIVE_INFINITY;
                }
            }
            if (c == 255 && h) {
                return NaN;
            }
            let j = c - 127;
            return Math.pow(-1, b) * Math.pow(2, j) * d;
        }
        get_baseStream() {
            return this._stream;
        }
        get baseStream() {
            return this.get_baseStream();
        }
        readBoolean() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = this.i(this.n);
            this.n = this.n + 1;
            return a != 0;
        }
        readInt16() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = 0;
            if (this.d) {
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
                a = a + this.i(this.n);
                this.n = this.n + 1;
            }
            else {
                a = a + this.i(this.n);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
            }
            if (a > 32767) {
                a -= (65535 + 1);
            }
            return a;
        }
        readSByte() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = this.i(this.n);
            this.n = this.n + 1;
            if (a > 127) {
                return (a - 255 + 1);
            }
            return a;
        }
        close() {
            this.dispose();
        }
        dispose() {
            if (this.f) {
                this._stream.dispose();
            }
        }
    }
    BinaryReader.$t = /*@__PURE__*/ markType(BinaryReader, 'BinaryReader', Base.$, [IDisposable_$type]);
    return BinaryReader;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BinaryFileDownloader = /*@__PURE__*/ (() => {
    class BinaryFileDownloader extends Base {
        static a(uri_, callback_, errorCallback_) {
            BinaryUtil.getBinary(uri_, callback_, errorCallback_);
        }
    }
    BinaryFileDownloader.$t = /*@__PURE__*/ markType(BinaryFileDownloader, 'BinaryFileDownloader');
    return BinaryFileDownloader;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncCompletedEventArgs = /*@__PURE__*/ (() => {
    class AsyncCompletedEventArgs extends EventArgs {
        constructor(a, b, c) {
            super();
            this.d = null;
            this.b = false;
            this.f = null;
            this.b = b;
            this.d = a;
            this.f = c;
        }
        get error() {
            return this.d;
        }
        get cancelled() {
            return this.b;
        }
        get userState() {
            return this.f;
        }
        h() {
            if (this.error != null) {
                throw this.error;
            }
        }
    }
    AsyncCompletedEventArgs.$t = /*@__PURE__*/ markType(AsyncCompletedEventArgs, 'AsyncCompletedEventArgs', EventArgs.$);
    return AsyncCompletedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItfConverter = /*@__PURE__*/ (() => {
    class ItfConverter extends DependencyObject {
        constructor() {
            super(...arguments);
            this.j = null;
            this.importCompleted = null;
            this.propertyChanged = null;
        }
        get source() {
            return typeCast(Uri.$, this.c(ItfConverter.sourceProperty));
        }
        set source(a) {
            this.h(ItfConverter.sourceProperty, a);
        }
        get triangulationSource() {
            return this.j;
        }
        set triangulationSource(a) {
            let b = a != this.triangulationSource;
            if (b) {
                let c = this.j;
                this.j = a;
                this.t("TriangulationSource", c, this.triangulationSource);
            }
        }
        r() {
            let a = null;
            let b = () => {
                if (a != null) {
                    this.triangulationSource = TriangulationSource.loadItf(a);
                }
                this.s(new AsyncCompletedEventArgs(null, false, null));
            };
            BinaryFileDownloader.a(this.source.value, (c) => {
                a = new BinaryReader(0, c, false);
                b();
            }, (c) => {
                throw new BaseError(1, "itf file download error: " + c);
            });
        }
        s(a) {
            if (this.importCompleted != null) {
                this.importCompleted(this, a);
            }
        }
        u(a, b, c) {
            switch (a) {
                case "Source":
                    if (this.source != null) {
                        this.r();
                    }
                    break;
            }
        }
        t(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.u(a, b, c);
        }
        getPointData() {
            if (this.j == null) {
                return null;
            }
            return new List$1(TriangulationSourcePointRecord.$, 1, this.j.points);
        }
        getTriangleData() {
            if (this.j == null) {
                return null;
            }
            return new List$1(Triangle.$, 1, this.j.triangles);
        }
    }
    ItfConverter.$t = /*@__PURE__*/ markType(ItfConverter, 'ItfConverter', DependencyObject.$, [INotifyPropertyChanged_$type]);
    ItfConverter.sourceProperty = /*@__PURE__*/ DependencyProperty.i("Source", Uri.$, ItfConverter.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => (typeCast(ItfConverter.$, a)).u("Source", b.oldValue, b.newValue)));
    return ItfConverter;
})();

class IgrAsyncCompletedEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    onImplementationCreated() {
    }
    get errorMessage() {
        if (this.i.error != null) {
            return this.i.error.message;
        }
        return null;
    }
    get cancelled() {
        return this.i.cancelled;
    }
    get userState() {
        return this.i.userState;
    }
}

/**
 * Class for converting Itf files into enumerable triangulations.
*/
class IgrTriangulationDataSource {
    createImplementation() {
        return new ItfConverter();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        //@@ZoneRunner
        this._importCompleted = null;
        this._importCompleted_wrapped = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets the string path specifying the location of the Itf file.
    */
    get source() {
        if (this.i.source == null)
            return null;
        return this.i.source.value;
    }
    /**
     * Sets the string path specifying the location of the Itf file.
    */
    set source(v) {
        if (v == null) {
            this.i.source = null;
        }
        else {
            this.i.source = new Uri(0, v);
        }
    }
    /**
    * Gets the point data.
    */
    getPointData() {
        let iv = this.i.getPointData();
        return iv._inner;
    }
    /**
    * Gets the triangle data.
    */
    getTriangleData() {
        let iv = this.i.getTriangleData();
        return iv._inner;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    /**
     * Event raised when the import operation has completed
    */
    get importCompleted() {
        return this._importCompleted;
    }
    set importCompleted(ev) {
        if (this._importCompleted_wrapped !== null) {
            this.i.importCompleted = delegateRemove(this.i.importCompleted, this._importCompleted_wrapped);
            this._importCompleted_wrapped = null;
            this._importCompleted = null;
        }
        this._importCompleted = ev;
        this._importCompleted_wrapped = (o, e) => {
            let outerArgs = new IgrAsyncCompletedEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeImportCompleted) {
                this.beforeImportCompleted(this, outerArgs);
            }
            if (this._importCompleted) {
                this._importCompleted(this, outerArgs);
            }
        };
        this.i.importCompleted = delegateCombine(this.i.importCompleted, this._importCompleted_wrapped);
        ;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DownloadingMultiScaleImageEventArgs = /*@__PURE__*/ (() => {
    class DownloadingMultiScaleImageEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._uri = null;
            this._image = null;
        }
        get uri() {
            return this._uri;
        }
        set uri(a) {
            this._uri = a;
        }
        get image() {
            return this._image;
        }
        set image(a) {
            this._image = a;
        }
    }
    DownloadingMultiScaleImageEventArgs.$t = /*@__PURE__*/ markType(DownloadingMultiScaleImageEventArgs, 'DownloadingMultiScaleImageEventArgs', EventArgs.$);
    return DownloadingMultiScaleImageEventArgs;
})();

class IgrDownloadingMultiScaleImageEventArgs {
    createImplementation() {
        return new DownloadingMultiScaleImageEventArgs();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get image() {
        return this.i.image;
    }
    set image(v) {
        this.i.image = v;
    }
    get uri() {
        return this.i.uri;
    }
    set uri(v) {
        this.i.uri = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapefileRecord = /*@__PURE__*/ (() => {
    class ShapefileRecord extends DependencyObject {
        constructor() {
            super();
            this._shapeType = 0;
            this._fieldsNames = null;
            this._fieldsTypes = null;
            this.fields = null;
            this.points = null;
            this.propertyChanged = null;
            this._fieldValues = null;
            this._bounds = null;
            this.fieldsNames = new List$1(String_$type, 0);
            this.fieldsTypes = new List$1(String_$type, 0);
        }
        get shapeType() {
            return this._shapeType;
        }
        set shapeType(a) {
            this._shapeType = a;
        }
        get fieldsNames() {
            return this._fieldsNames;
        }
        set fieldsNames(a) {
            this._fieldsNames = a;
        }
        get fieldsTypes() {
            return this._fieldsTypes;
        }
        set fieldsTypes(a) {
            this._fieldsTypes = a;
        }
        q(a) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
        get fieldValues() {
            return this._fieldValues;
        }
        set fieldValues(a) {
            this._fieldValues = a;
        }
        get bounds() {
            return this._bounds;
        }
        set bounds(a) {
            this._bounds = a;
        }
        getFieldValue(a) {
            if (this.fields.containsKey(a)) {
                return this.fields.item(a);
            }
            return null;
        }
        setFieldValue(a, b) {
            if (this.fields.containsKey(a)) {
                this.fields.item(a, b);
            }
            else {
                this.fieldsNames.add(a);
                this.fieldsTypes.add("string");
                this.fields.addItem(a, b);
            }
        }
    }
    ShapefileRecord.$t = /*@__PURE__*/ markType(ShapefileRecord, 'ShapefileRecord', DependencyObject.$, [INotifyPropertyChanged_$type]);
    return ShapefileRecord;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeFilterRecordEventArgs = /*@__PURE__*/ (() => {
    class ShapeFilterRecordEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.b = false;
        }
    }
    ShapeFilterRecordEventArgs.$t = /*@__PURE__*/ markType(ShapeFilterRecordEventArgs, 'ShapeFilterRecordEventArgs');
    return ShapeFilterRecordEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XBaseField = /*@__PURE__*/ (() => {
    class XBaseField extends Base {
        constructor() {
            super(...arguments);
            this.c = null;
            this.a = 0;
            this.b = 0;
        }
    }
    XBaseField.$t = /*@__PURE__*/ markType(XBaseField, 'XBaseField');
    return XBaseField;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Header = /*@__PURE__*/ (() => {
    class Header extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.e = null;
            this.b = new List$1(XBaseField.$, 0);
        }
        get d() {
            return { $type: Point_$type, x: this.e.left, y: this.e.top };
        }
        get c() {
            return { $type: Point_$type, x: this.e.right, y: this.e.bottom };
        }
    }
    Header.$t = /*@__PURE__*/ markType(Header, 'Header');
    return Header;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enum for XBase field data types.
 */
var XBaseDataType = /*@__PURE__*/ (function (XBaseDataType) {
    /**
     * Character data type.
     */
    XBaseDataType[XBaseDataType["Character"] = 0] = "Character";
    /**
     * Number data type.
     */
    XBaseDataType[XBaseDataType["Number"] = 1] = "Number";
    /**
     * Logical data type.
     */
    XBaseDataType[XBaseDataType["Logical"] = 2] = "Logical";
    /**
     * Date data type.
     */
    XBaseDataType[XBaseDataType["Date"] = 3] = "Date";
    /**
     * Memo data type.
     */
    XBaseDataType[XBaseDataType["Memo"] = 4] = "Memo";
    /**
     * Floating point data type.
     */
    XBaseDataType[XBaseDataType["FloatingPoint"] = 5] = "FloatingPoint";
    /**
     * Binary data type.
     */
    XBaseDataType[XBaseDataType["Binary"] = 6] = "Binary";
    /**
     * General data type.
     */
    XBaseDataType[XBaseDataType["General"] = 7] = "General";
    /**
     * Picture data type.
     */
    XBaseDataType[XBaseDataType["Picture"] = 8] = "Picture";
    /**
     * Currency data type.
     */
    XBaseDataType[XBaseDataType["Currency"] = 9] = "Currency";
    /**
     * DateTime data type.
     */
    XBaseDataType[XBaseDataType["DateTime"] = 10] = "DateTime";
    /**
     * Integer data type.
     */
    XBaseDataType[XBaseDataType["Integer"] = 11] = "Integer";
    /**
     * VariField data type.
     */
    XBaseDataType[XBaseDataType["VariField"] = 12] = "VariField";
    /**
     * Variant data type.
     */
    XBaseDataType[XBaseDataType["Variant"] = 13] = "Variant";
    /**
     * Timestamp data type.
     */
    XBaseDataType[XBaseDataType["Timestamp"] = 14] = "Timestamp";
    /**
     * Double data type.
     */
    XBaseDataType[XBaseDataType["double1"] = 15] = "double1";
    /**
     * Auto increment data type.
     */
    XBaseDataType[XBaseDataType["AutoIncrement"] = 16] = "AutoIncrement";
    return XBaseDataType;
})({});
/**
 * @hidden
 */
let XBaseDataType_$type = /*@__PURE__*/ markEnum('XBaseDataType', 'Character,0|Number,1|Logical,2|Date,3|Memo,4|FloatingPoint,5|Binary,6|General,7|Picture,8|Currency,9|DateTime,10|Integer,11|VariField,12|Variant,13|Timestamp,14|Double:double1,15|AutoIncrement,16');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Decoder = /*@__PURE__*/ (() => {
    class Decoder extends Base {
        e(a, b, c, d, e, f, g, h, i, j) {
            throw new NotImplementedException(0);
            return {
                p7: h,
                p8: i,
                p9: j
            };
        }
        b(a, b, c, d) {
            throw new NotImplementedException(0);
        }
        d(a, b, c, d, e, f) {
            throw new NotImplementedException(0);
        }
        f() {
            throw new NotImplementedException(0);
        }
    }
    Decoder.$t = /*@__PURE__*/ markType(Decoder, 'Decoder');
    return Decoder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Encoding = /*@__PURE__*/ (() => {
    class Encoding extends Base {
        static get uTF8() {
            if (Encoding.t == null) {
                Encoding.t = new UTF8Encoding(1);
            }
            return Encoding.t;
        }
        static get uTF8Unmarked() {
            if (Encoding.s == null) {
                Encoding.s = new UTF8Encoding(1);
            }
            return Encoding.s;
        }
        static get unicode() {
            if (Encoding.r == null) {
                Encoding.r = new UnicodeEncoding(0);
            }
            return Encoding.r;
        }
        getString1(a, b, c) {
            return "";
        }
        getBytes(a, b, c) {
            let d = new Array(this.getByteCount(a, b, c));
            this.getBytes2(a, b, c, d, 0);
            return d;
        }
        getBytes1(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "input");
            }
            let b = new Array(a.length);
            for (let c = 0; c < a.length; c++) {
                b[c] = a.charAt(c);
            }
            return this.getBytes(b, 0, b.length);
        }
        getString(a) {
            return this.getString1(a, 0, a.length);
        }
        getCharCount(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "bytes");
            }
            return this.getCharCount1(a, 0, a.length);
        }
        getCharCount1(a, b, c) {
            throw new NotImplementedException(0);
        }
        getChars(a, b, c, d, e) {
            throw new NotImplementedException(0);
        }
        static get aSCII() {
            if (Encoding.p == null) {
                Encoding.p = new AsciiEncoding(1);
            }
            return Encoding.p;
        }
        getDecoder() {
            return new DefaultDecoder(this);
        }
        getBytes3(a, b, c, d, e) {
            return this.getBytes2(stringToCharArray(a), b, c, d, e);
        }
        getMaxCharCount(a) {
            return a;
        }
        getMaxByteCount(a) {
            return a + 1;
        }
        getPreamble() {
            return new Array(0);
        }
        static get bigEndianUnicode() {
            if (Encoding.q == null) {
                Encoding.q = new UnicodeEncoding(1, true, false);
            }
            return Encoding.q;
        }
        static get defaultValue() {
            return Encoding.aSCII;
        }
        static getEncoding(a) {
            switch (a.toUpperCase()) {
                case "ASCII": return Encoding.aSCII;
                case "UNICODE": return Encoding.unicode;
                case "UTF-8": return Encoding.uTF8;
                default: throw new ArgumentException(1, "'" + a + "' is not a valid encoding name.");
            }
        }
        get_webName() {
            throw new NotImplementedException(0);
        }
        get webName() {
            return this.get_webName();
        }
    }
    Encoding.$t = /*@__PURE__*/ markType(Encoding, 'Encoding');
    Encoding.t = null;
    Encoding.s = null;
    Encoding.r = null;
    Encoding.p = null;
    Encoding.q = null;
    return Encoding;
})();
/**
 * @hidden
 */
let UnicodeEncoding = /*@__PURE__*/ (() => {
    class UnicodeEncoding extends Encoding {
        getString1(bytes_, a, b) {
            let c = "";
            let d = a + b;
            for (let i_ = a; i_ < d; i_ = i_ + 2) {
                if (i_ + 1 >= d) {
                    c = c + '�';
                }
                else {
                    let e;
                    let f;
                    if (this.ab) {
                        e = bytes_[i_ + 1].toString(16);
                        f = bytes_[i_].toString(16);
                    }
                    else {
                        e = bytes_[i_].toString(16);
                        f = bytes_[i_ + 1].toString(16);
                    }
                    if (e.length == 1) {
                        e = "0" + e;
                    }
                    if (f.length == 1) {
                        f = "0" + f;
                    }
                    let g = parseInt(f + e, 16);
                    c = c + String.fromCharCode(g);
                }
            }
            return c;
        }
        getCharCount1(a, b, c) {
            return intDivide(c, 2);
        }
        getBytes(a, b, c) {
            return super.getBytes(a, b, c);
        }
        getBytes1(a) {
            let b = new Array(a.length * 2);
            this.getBytes3(a, 0, a.length, b, 0);
            return b;
        }
        constructor(a, ..._rest) {
            super();
            this.ab = false;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.ab = c;
                    }
                    break;
            }
        }
        getMaxByteCount(a) {
            return (a + 1) * 2;
        }
        getMaxCharCount(a) {
            return truncate(Math.ceil(a / 2)) + 1;
        }
        getBytes3(a, b, c, d, e) {
            for (let f = b; f < b + c; f++) {
                let g = a.charCodeAt(f);
                let h = (g & 255);
                let i = ((g >> 8) & 255);
                if (this.ab) {
                    d[e++] = i;
                    d[e++] = h;
                }
                else {
                    d[e++] = h;
                    d[e++] = i;
                }
            }
            return c * 2;
        }
        getByteCount(a, b, c) {
            throw new NotImplementedException(0);
        }
        getBytes2(a, b, c, d, e) {
            throw new NotImplementedException(0);
        }
        getChars(a, b, c, d, e) {
            throw new NotImplementedException(0);
        }
    }
    UnicodeEncoding.$t = /*@__PURE__*/ markType(UnicodeEncoding, 'UnicodeEncoding', Encoding.$);
    return UnicodeEncoding;
})();
/**
 * @hidden
 */
let UTF8Encoding = /*@__PURE__*/ (() => {
    class UTF8Encoding extends Encoding {
        constructor(a, ..._rest) {
            super();
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                    }
                    break;
                case 1: break;
            }
        }
        getString1(a, b, c) {
            let d = "";
            let e = b;
            let f = 0;
            let g = 0;
            let h = 0;
            let i = 0;
            while (e < b + c) {
                f = a[e++];
                if (f < 128) {
                    d += String.fromCharCode(f);
                }
                else if (f > 191 && f < 224) {
                    if (e >= b + c) {
                        throw new InvalidOperationException(1, "UTF-8 decoding error.");
                    }
                    g = a[e++];
                    d += String.fromCharCode((((f & 31) << 6) | (g & 63)));
                }
                else if (f > 223 && f < 240) {
                    if (e + 1 >= b + c) {
                        throw new InvalidOperationException(1, "UTF-8 decoding error.");
                    }
                    g = a[e++];
                    h = a[e++];
                    d += String.fromCharCode((((f & 15) << 12) | ((g & 63) << 6) | (h & 63)));
                }
                else {
                    if (e + 2 >= b + c) {
                        throw new InvalidOperationException(1, "UTF-8 decoding error.");
                    }
                    g = a[e++];
                    h = a[e++];
                    i = a[e++];
                    let j = ((f & 7) << 18) | ((g & 63) << 12) | ((h & 63) << 6) | (i & 63);
                    if (j < 65535) {
                        d += String.fromCharCode(j);
                    }
                    else {
                        j -= 65536;
                        d += String.fromCharCode(((j >> 10) | 55296));
                        d += String.fromCharCode(((j & 1023) | 56320));
                    }
                }
            }
            return d;
        }
        getCharCount1(a, b, c) {
            return c;
        }
        getByteCount(a, b, c) {
            throw new NotImplementedException(0);
        }
        getBytes2(chars_, charIndex_, charCount_, a, b) {
            let inputUTF8_ = (unescape(encodeURIComponent(chars_.slice(charIndex_, charIndex_ + charCount_).join(""))));
            for (let i_ = 0; i_ < inputUTF8_.length; i_++) {
                a[b + i_] = (inputUTF8_.charCodeAt(i_));
            }
            return inputUTF8_.length;
        }
        getBytes(a, b, c) {
            return super.getBytes(a, b, c);
        }
        getBytes1(input_) {
            let a = new Array(input_.length);
            let inputUTF8_ = (unescape(encodeURIComponent(input_)));
            for (let i_ = 0; i_ < inputUTF8_.length; i_++) {
                a[i_] = (inputUTF8_.charCodeAt(i_));
            }
            return a;
        }
        getChars(a, b, c, d, e) {
            let f = e;
            let g = b;
            let h = 0;
            let i = 0;
            let j = 0;
            let k = 0;
            while (g < b + c) {
                h = a[g++];
                if (h < 128) {
                    d[e++] = String.fromCharCode(h);
                }
                else if (h > 191 && h < 224) {
                    if (g >= b + c) {
                        throw new InvalidOperationException(1, "UTF-8 decoding error.");
                    }
                    i = a[g++];
                    d[e++] = String.fromCharCode((((h & 31) << 6) | (i & 63)));
                }
                else if (h > 223 && h < 240) {
                    if (g + 1 >= b + c) {
                        throw new InvalidOperationException(1, "UTF-8 decoding error.");
                    }
                    i = a[g++];
                    j = a[g++];
                    d[e++] = String.fromCharCode((((h & 15) << 12) | ((i & 63) << 6) | (j & 63)));
                }
                else {
                    if (g + 2 >= b + c) {
                        throw new InvalidOperationException(1, "UTF-8 decoding error.");
                    }
                    i = a[g++];
                    j = a[g++];
                    k = a[g++];
                    let l = ((h & 7) << 18) | ((i & 63) << 12) | ((j & 63) << 6) | (k & 63);
                    if (l < 65535) {
                        d[e++] = String.fromCharCode(l);
                    }
                    else {
                        l -= 65536;
                        d[e++] = String.fromCharCode(((l >> 10) | 55296));
                        d[e++] = String.fromCharCode(((l & 1023) | 56320));
                    }
                }
            }
            return e - f;
        }
        getDecoder() {
            return new UTF8Encoding_UTF8Decoder(this);
        }
        getMaxByteCount(a) {
            return (a + 1) * 3;
        }
        getMaxCharCount(a) {
            return a + 1;
        }
    }
    UTF8Encoding.$t = /*@__PURE__*/ markType(UTF8Encoding, 'UTF8Encoding', Encoding.$);
    return UTF8Encoding;
})();
/**
 * @hidden
 */
let UTF8Encoding_UTF8Decoder = /*@__PURE__*/ (() => {
    class UTF8Encoding_UTF8Decoder extends Decoder {
        constructor(a) {
            super();
            this.g = 0;
            this.h = 0;
            this.i = 0;
            this.j = 0;
            this.k = null;
            this.k = a;
        }
        a(a, b, c) {
            return this.b(a, b, c, false);
        }
        b(a, b, c, d) {
            let e = 0;
            let f = b;
            while (f < b + c) {
                if (this.g == 0) {
                    this.g = a[f++];
                }
                if (this.g < 128) {
                    e++;
                }
                else {
                    if (f >= b + c) {
                        break;
                    }
                    if (this.h == 0) {
                        this.h = a[f++];
                    }
                    if (this.g > 191 && this.g < 224) {
                        e++;
                    }
                    else {
                        if (f >= b + c) {
                            break;
                        }
                        if (this.i == 0) {
                            this.i = a[f++];
                        }
                        if (this.g > 223 && this.g < 240) {
                            e++;
                        }
                        else {
                            if (f >= b + c) {
                                break;
                            }
                            if (this.j == 0) {
                                this.j = a[f++];
                            }
                            let g = ((this.g & 7) << 18) | ((this.h & 63) << 12) | ((this.i & 63) << 6) | (this.j & 63);
                            if (g < 65535) {
                                e++;
                            }
                            else {
                                e += 2;
                            }
                            this.j = 0;
                        }
                        this.i = 0;
                    }
                    this.h = 0;
                }
                this.g = 0;
            }
            if (d) {
                this.g = 0;
                this.h = 0;
                this.i = 0;
                this.j = 0;
            }
            return e;
        }
        c(a, b, c, d, e) {
            return this.d(a, b, c, d, e, false);
        }
        d(a, b, c, d, e, f) {
            let g = e;
            let h = b;
            while (h < b + c) {
                if (this.g == 0) {
                    this.g = a[h++];
                }
                if (this.g < 128) {
                    d[e++] = String.fromCharCode(this.g);
                }
                else {
                    if (h >= b + c) {
                        break;
                    }
                    if (this.h == 0) {
                        this.h = a[h++];
                    }
                    if (this.g > 191 && this.g < 224) {
                        d[e++] = String.fromCharCode((((this.g & 31) << 6) | (this.h & 63)));
                    }
                    else {
                        if (h >= b + c) {
                            break;
                        }
                        if (this.i == 0) {
                            this.i = a[h++];
                        }
                        if (this.g > 223 && this.g < 240) {
                            d[e++] = String.fromCharCode((((this.g & 15) << 12) | ((this.h & 63) << 6) | (this.i & 63)));
                        }
                        else {
                            if (h >= b + c) {
                                break;
                            }
                            if (this.j == 0) {
                                this.j = a[h++];
                            }
                            let i = ((this.g & 7) << 18) | ((this.h & 63) << 12) | ((this.i & 63) << 6) | (this.j & 63);
                            if (i < 65535) {
                                d[e++] = String.fromCharCode(i);
                            }
                            else {
                                i -= 65536;
                                d[e++] = String.fromCharCode(((i >> 10) | 55296));
                                d[e++] = String.fromCharCode(((i & 1023) | 56320));
                            }
                            this.j = 0;
                        }
                        this.i = 0;
                    }
                    this.h = 0;
                }
                this.g = 0;
            }
            if (f) {
                this.g = 0;
                this.h = 0;
                this.i = 0;
                this.j = 0;
            }
            return e - g;
        }
    }
    UTF8Encoding_UTF8Decoder.$t = /*@__PURE__*/ markType(UTF8Encoding_UTF8Decoder, 'UTF8Encoding_UTF8Decoder', Decoder.$);
    return UTF8Encoding_UTF8Decoder;
})();
/**
 * @hidden
 */
let AsciiEncoding = /*@__PURE__*/ (() => {
    class AsciiEncoding extends Encoding {
        constructor(a, ..._rest) {
            super();
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                    }
                    break;
                case 1: break;
            }
        }
        getString1(bytes_, a, b) {
            let ret_ = "";
            for (let i_ = a; i_ < a + b; i_++) {
                if (bytes_[i_] == 0) {
                    break;
                }
                ret_ = ret_ + String.fromCharCode(bytes_[i_]);
            }
            return ret_;
        }
        getCharCount1(a, b, c) {
            return c;
        }
        getByteCount(a, b, c) {
            return c;
        }
        getBytes2(a, b, c, d, e) {
            throw new NotImplementedException(0);
        }
        getBytes(a, b, c) {
            return super.getBytes(a, b, c);
        }
        getBytes1(input_) {
            let a = new Array(input_.length);
            for (let i_ = 0; i_ < input_.length; i_++) {
                a[i_] = (input_.charCodeAt(i_));
            }
            return a;
        }
        getChars(bytes_, byteIndex_, a, b, c) {
            let d = c;
            for (let i_ = 0; i_ < a; i_++) {
                if (bytes_[i_] == 0) {
                    break;
                }
                b[c++] = (String.fromCharCode(bytes_[byteIndex_++]));
            }
            return c - d;
        }
    }
    AsciiEncoding.$t = /*@__PURE__*/ markType(AsciiEncoding, 'AsciiEncoding', Encoding.$);
    return AsciiEncoding;
})();
/**
 * @hidden
 */
let DefaultDecoder = /*@__PURE__*/ (() => {
    class DefaultDecoder extends Decoder {
        constructor(a) {
            super();
            this.g = null;
            this.g = a;
        }
        a(a, b, c) {
            return this.b(a, b, c, false);
        }
        b(a, b, c, d) {
            return this.g.getCharCount1(a, b, c);
        }
        c(a, b, c, d, e) {
            return this.d(a, b, c, d, e, false);
        }
        d(a, b, c, d, e, f) {
            return this.g.getChars(a, b, c, d, e);
        }
    }
    DefaultDecoder.$t = /*@__PURE__*/ markType(DefaultDecoder, 'DefaultDecoder', Decoder.$);
    return DefaultDecoder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of item represented by the current row of a shapefile.
 */
var ShapeType = /*@__PURE__*/ (function (ShapeType) {
    /**
     * A placeholder value which cannot occur when reading a shapefile.
     */
    ShapeType[ShapeType["None"] = 0] = "None";
    /**
     * Specifies a point shape.
     */
    ShapeType[ShapeType["Point"] = 1] = "Point";
    /**
     * Specifies a polyline shape.
     */
    ShapeType[ShapeType["PolyLine"] = 3] = "PolyLine";
    /**
     * Specifies a polygon shape.
     */
    ShapeType[ShapeType["Polygon"] = 5] = "Polygon";
    /**
     * Specifies a polypoint shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PolyPoint"] = 8] = "PolyPoint";
    /**
     * Specifies a polypoint shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PointZ"] = 11] = "PointZ";
    /**
     * Specifies a polylinez shape
     */
    ShapeType[ShapeType["PolyLineZ"] = 13] = "PolyLineZ";
    /**
     * Specifies a polygonz shape
     */
    ShapeType[ShapeType["PolygonZ"] = 15] = "PolygonZ";
    /**
     * Specifies a polypointz shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PolyPointZ"] = 18] = "PolyPointZ";
    /**
     * Specifies a pointm shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PointM"] = 21] = "PointM";
    /**
     * Specifies a polylinem shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PolyLineM"] = 23] = "PolyLineM";
    /**
     * Specifies a polygonm shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PolygonM"] = 25] = "PolygonM";
    /**
     * Specifies a polypointm shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PolyPointM"] = 28] = "PolyPointM";
    /**
     * Specifies a polypatchm shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PolyPatch"] = 31] = "PolyPatch";
    return ShapeType;
})({});
/**
 * @hidden
 */
let ShapeType_$type = /*@__PURE__*/ markEnum('ShapeType', 'None,0|Point,1|PolyLine,3|Polygon,5|PolyPoint,8|PointZ,11|PolyLineZ,13|PolygonZ,15|PolyPointZ,18|PointM,21|PolyLineM,23|PolygonM,25|PolyPointM,28|PolyPatch,31');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeFileUtil = /*@__PURE__*/ (() => {
    class ShapeFileUtil extends Base {
        static a(a, b) {
            if (ShapeFileUtil.k == null) {
                ShapeFileUtil.n();
            }
            let c = new Header();
            let d = ShapeFileUtil.l(a.readInt32());
            if (d != 9994) {
                throw new BaseError(1, "Corrupt Shp file - incorrect file code");
            }
            a.readInt32();
            a.readInt32();
            a.readInt32();
            a.readInt32();
            a.readInt32();
            ShapeFileUtil.l(a.readInt32());
            a.readInt32();
            c.a = a.readInt32();
            let e = PointUtil.create();
            let f = PointUtil.create();
            e.x = a.readDouble();
            e.y = a.readDouble();
            f.x = a.readDouble();
            f.y = a.readDouble();
            a.readDouble();
            a.readDouble();
            a.readDouble();
            a.readDouble();
            c.e = new Rect(0, e.x, e.y, f.x - e.x, f.y - e.y);
            if (b != null) {
                let g = b.readByte();
                if (g != 3) {
                    throw new BaseError(1, "Corrupt Dbf file - wrong version number");
                }
                b.readByte();
                b.readByte();
                b.readByte();
                b.readUInt32();
                b.readUInt16();
                let h = b.readUInt16();
                b.readBytes(2);
                b.readBytes(1);
                b.readBytes(1);
                b.readBytes(4);
                b.readBytes(8);
                b.readBytes(1);
                b.readBytes(1);
                b.readBytes(2);
                let i = 0;
                while (i < h - 1) {
                    let j = new XBaseField();
                    j.c = stringReplace(Encoding.uTF8.getString1(b.readBytes(11), 0, 10), "\0", "");
                    let k = Encoding.uTF8.getString1(b.readBytes(1), 0, 1).charAt(0);
                    j.a = ShapeFileUtil.k.item(k);
                    b.readBytes(4);
                    j.b = b.readByte();
                    b.readBytes(15);
                    c.b.add(j);
                    i += j.b;
                }
                if (b.readByte() != 13) {
                    throw new BaseError(1, "Corrupt Dbf file - Missing field descriptor array terminator");
                }
            }
            return c;
        }
        static f(a, b, c) {
            let d = ShapeFileUtil.l(b.readInt32());
            let e = ShapeFileUtil.l(b.readInt32());
            let f = b.readInt32();
            let g = null;
            switch (f) {
                case 0: break;
                case 1:
                    g = ShapeFileUtil.j(b);
                    break;
                case 3:
                    g = ShapeFileUtil.b(b);
                    break;
                case 5:
                    g = ShapeFileUtil.g(b);
                    break;
                case 8: break;
                case 11:
                    g = ShapeFileUtil.e(b);
                    break;
                case 13:
                    g = ShapeFileUtil.d(b);
                    break;
                case 15:
                    g = ShapeFileUtil.i(b);
                    break;
                case 18: break;
                case 21: break;
                case 23: break;
                case 25: break;
                case 28: break;
                case 31: break;
                default: break;
            }
            if (g == null) {
                throw new BaseError(1, "Corrupt Shp file - failed to read " + EnumUtil.getName(ShapeType_$type, f));
            }
            g.shapeType = f;
            if (c != null) {
                c.readBytes(1);
                g.fields = new Dictionary$2(String_$type, Base.$, 0);
                for (let h of fromEnum(a.b)) {
                    g.fieldsNames.add(h.c);
                    let i = c.readBytes(h.b);
                    let j = Encoding.uTF8.getString1(i, 0, h.b);
                    switch (h.a) {
                        case 1:
                            g.fieldsTypes.add("double");
                            let k = parseFloat(j);
                            if (!isNaN_(k)) {
                                g.fields.addItem(h.c, k);
                                ShapeFileUtil.m(g, h.c, k);
                            }
                            break;
                        case 5:
                            g.fieldsTypes.add("float");
                            let l = parseFloat(j);
                            if (!isNaN_(l)) {
                                g.fields.addItem(h.c, l);
                                ShapeFileUtil.m(g, h.c, l);
                            }
                            break;
                        case 0:
                            g.fieldsTypes.add("string");
                            let m = j.trim();
                            g.fields.addItem(h.c, m);
                            ShapeFileUtil.m(g, h.c, m);
                            break;
                        case 3:
                            g.fieldsTypes.add("date");
                            let str_ = j;
                            let n = Date.parse(str_);
                            g.fields.addItem(h.c, n);
                            ShapeFileUtil.m(g, h.c, n);
                            break;
                        default: throw new BaseError(1, "Unrecognized field type: " + enumGetBox(XBaseDataType_$type, h.a));
                    }
                }
            }
            return g;
        }
        static m(row_, property_, val_) {
            if (!row_.fieldValues) {
                row_.fieldValues = {};
            }
            ;
            row_.fieldValues[property_] = val_;
        }
        static l(a) {
            return (((a & 255) << 24) | ((a & 65280) << 8) | ((a & 16711680) >> 8) | ((u32BitwiseAnd(a, 4278190080)) >> 24));
        }
        static j(a) {
            let b = ((() => {
                let $ret = PointUtil.create();
                $ret.x = a.readDouble();
                $ret.y = a.readDouble();
                return $ret;
            })());
            return ((() => {
                let $ret = new ShapefileRecord();
                $ret.bounds = new Rect(3, b, Size.empty);
                $ret.points = new List$1(List$1.$.specialize(Point_$type), 1, [new List$1(Point_$type, 1, [b])]);
                return $ret;
            })());
        }
        static e(a) {
            let b = a.readDouble();
            let c = a.readDouble();
            let d = a.readDouble();
            let e = a.readDouble();
            let f = ((() => {
                let $ret = PointUtil.create();
                $ret.x = d;
                $ret.y = e;
                return $ret;
            })());
            return ((() => {
                let $ret = new ShapefileRecord();
                $ret.bounds = new Rect(3, f, Size.empty);
                $ret.points = new List$1(List$1.$.specialize(Point_$type), 1, [new List$1(Point_$type, 1, [f])]);
                return $ret;
            })());
        }
        static d(a) {
            let b, c;
            let d = ((() => { let e = ShapeFileUtil.c(a, b, c); b = e.p1; c = e.p2; return e.ret; })());
            a.readDouble();
            a.readDouble();
            for (let e = 0; e < c; e++) {
                a.readDouble();
            }
            a.readDouble();
            a.readDouble();
            for (let f = 0; f < c; f++) {
                a.readDouble();
            }
            return d;
        }
        static c(a, b, c) {
            let d = PointUtil.create();
            let e = ((() => {
                let $ret = PointUtil.create();
                $ret.x = a.readDouble();
                $ret.y = a.readDouble();
                return $ret;
            })());
            let f = ((() => {
                let $ret = PointUtil.create();
                $ret.x = a.readDouble();
                $ret.y = a.readDouble();
                return $ret;
            })());
            let g = new Rect(0, e.x, e.y, f.x - e.x, f.y - e.y);
            b = a.readInt32();
            c = a.readInt32();
            let h = new Array(b);
            for (let i = 0; i < b; ++i) {
                h[i] = a.readInt32();
            }
            let j = new List$1(List$1.$.specialize(Point_$type), 0);
            for (let k = 0; k < b; ++k) {
                let l = (k < b - 1 ? h[k + 1] : c) - h[k];
                let m = new List$1(Point_$type, 2, l - 1);
                for (let n = 0; n < l; ++n) {
                    d = PointUtil.create();
                    d.x = a.readDouble();
                    d.y = a.readDouble();
                    m.add(d);
                }
                if (m.count > 0) {
                    j.add(m);
                }
            }
            return {
                ret: ((() => {
                    let $ret = new ShapefileRecord();
                    $ret.bounds = g;
                    $ret.points = j;
                    return $ret;
                })()),
                p1: b,
                p2: c
            };
        }
        static b(a) {
            let b, c;
            return ((() => { let d = ShapeFileUtil.c(a, b, c); b = d.p1; c = d.p2; return d.ret; })());
        }
        static i(a) {
            let b, c;
            let d = ((() => { let e = ShapeFileUtil.h(a, b, c); b = e.p1; c = e.p2; return e.ret; })());
            a.readDouble();
            a.readDouble();
            for (let e = 0; e < c; e++) {
                a.readDouble();
            }
            a.readDouble();
            a.readDouble();
            for (let f = 0; f < c; f++) {
                a.readDouble();
            }
            return d;
        }
        static g(a) {
            let b, c;
            return ((() => { let d = ShapeFileUtil.h(a, b, c); b = d.p1; c = d.p2; return d.ret; })());
        }
        static h(a, b, c) {
            let d = ((() => {
                let $ret = PointUtil.create();
                $ret.x = a.readDouble();
                $ret.y = a.readDouble();
                return $ret;
            })());
            let e = ((() => {
                let $ret = PointUtil.create();
                $ret.x = a.readDouble();
                $ret.y = a.readDouble();
                return $ret;
            })());
            let f = new Rect(0, d.x, d.y, e.x - d.x, e.y - d.y);
            let g = PointUtil.create();
            b = a.readInt32();
            c = a.readInt32();
            let h = new Array(b);
            for (let i = 0; i < b; ++i) {
                h[i] = a.readInt32();
            }
            let j = new List$1(List$1.$.specialize(Point_$type), 0);
            for (let k = 0; k < b; ++k) {
                let l = (k < b - 1 ? h[k + 1] : c) - h[k];
                let m = new List$1(Point_$type, 2, l);
                g = PointUtil.create();
                g.x = a.readDouble();
                g.y = a.readDouble();
                for (let n = 1; n < l; ++n) {
                    g = PointUtil.create();
                    g.x = a.readDouble();
                    g.y = a.readDouble();
                    m.add(g);
                }
                if (m.count > 1) {
                    j.add(m);
                }
            }
            return {
                ret: ((() => {
                    let $ret = new ShapefileRecord();
                    $ret.bounds = f;
                    $ret.points = j;
                    return $ret;
                })()),
                p1: b,
                p2: c
            };
        }
        static n() {
            ShapeFileUtil.k = new Dictionary$2(String_$type, XBaseDataType_$type, 0);
            ShapeFileUtil.k.item('C', 0);
            ShapeFileUtil.k.item('N', 1);
            ShapeFileUtil.k.item('L', 2);
            ShapeFileUtil.k.item('D', 3);
            ShapeFileUtil.k.item('M', 4);
            ShapeFileUtil.k.item('F', 5);
            ShapeFileUtil.k.item('B', 6);
            ShapeFileUtil.k.item('G', 7);
            ShapeFileUtil.k.item('P', 8);
            ShapeFileUtil.k.item('Y', 9);
            ShapeFileUtil.k.item('T', 10);
            ShapeFileUtil.k.item('I', 11);
            ShapeFileUtil.k.item('V', 12);
            ShapeFileUtil.k.item('X', 13);
            ShapeFileUtil.k.item('@', 14);
            ShapeFileUtil.k.item('O', 15);
            ShapeFileUtil.k.item('+', 16);
        }
        static staticInit() {
            ShapeFileUtil.n();
        }
    }
    ShapeFileUtil.$t = /*@__PURE__*/ markType(ShapeFileUtil, 'ShapeFileUtil');
    ShapeFileUtil.k = null;
    return ShapeFileUtil;
})();
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapefileConverter = /*@__PURE__*/ (() => {
    class ShapefileConverter extends DependencyObjectNotifier {
        get name() {
            return this._name;
        }
        set name(a) {
            this._name = a;
        }
        constructor() {
            super();
            this._name = null;
            this.a8 = null;
            this.a7 = Rect.empty;
            this._shapeHeader = null;
            this.q = false;
            this.importPending = null;
            this.importCompleted = null;
            this.x = null;
            this.collectionChanged = null;
            this.filter = null;
            this.records = new ObservableCollection$1(ShapefileRecord.$, 0);
            let a = this.records;
            a.collectionChanged = delegateCombine(a.collectionChanged, (a, b) => {
                if (this.collectionChanged != null) {
                    this.collectionChanged(this, b);
                }
            });
        }
        get worldRect() {
            return this.a8;
        }
        set worldRect(a) {
            if (Rect.l_op_Inequality(this.a8, a)) {
                let b = this.a8;
                this.a8 = a;
                this.aw("WorldRect", b, this.a8);
            }
        }
        get computedWorldRect() {
            return this.a7;
        }
        set computedWorldRect(a) {
            if (Rect.l_op_Inequality(this.a7, a)) {
                let b = this.a7;
                this.a7 = a;
                this.aw("ComputedWorldRect", b, this.a7);
            }
        }
        getWorldBounds(a) {
            if (a && this.computedWorldRect.isEmpty == false) {
                return this.computedWorldRect;
            }
            return this.worldRect;
        }
        setWorldBounds(a, b) {
            if (a) {
                this.computedWorldRect = b;
            }
            else {
                this.worldRect = b;
            }
        }
        get shapeType() {
            return this.shapeHeader.a;
        }
        get shapeHeader() {
            return this._shapeHeader;
        }
        set shapeHeader(a) {
            this._shapeHeader = a;
        }
        aw(a, b, c) {
            switch (a) {
                case ShapefileConverter.$$p[2]:
                case ShapefileConverter.$$p[0]:
                    if (this.shapefileSource != null && this.databaseSource != null) {
                        this.at();
                    }
                    break;
            }
            this.j(a);
        }
        sendImportCompleted() {
            if (this.deferImportCompleted && this.q) {
                this.deferImportCompleted = false;
                if (this.importCompleted != null) {
                    this.importCompleted(this, new AsyncCompletedEventArgs(null, false, null));
                }
            }
        }
        au(a) {
            this.q = true;
            if (this.deferImportCompleted) {
                if (this.importPending != null) {
                    this.importPending(this, a);
                }
                return;
            }
            if (this.importCompleted != null) {
                this.importCompleted(this, a);
            }
        }
        at() {
            this.q = false;
            let a = null;
            let b = null;
            let c = () => {
                if (a != null && b != null) {
                    this.av(a, b);
                    this.au(new AsyncCompletedEventArgs(null, false, null));
                }
            };
            BinaryFileDownloader.a(this.shapefileSource, (d) => {
                a = new BinaryReader(0, d, false);
                c();
            }, (d) => {
                throw new BaseError(1, "shape file download error: " + d);
            });
            BinaryFileDownloader.a(this.databaseSource, (d) => {
                b = new BinaryReader(0, d, false);
                c();
            }, (d) => {
                throw new BaseError(1, "dbf file download error: " + d);
            });
        }
        av(a, b) {
            this.shapeHeader = ShapeFileUtil.a(a, b);
            this.worldRect = this.shapeHeader.e;
            let c = a.currentPosition;
            let d = a.length;
            let e = Rect.empty;
            while (c < d) {
                let f = ShapeFileUtil.f(this.shapeHeader, a, b);
                let record_ = f;
                let g = true;
                if (this.filter != null) {
                    let h = new ShapeFilterRecordEventArgs();
                    h.b = true;
                    h.a = f;
                    this.filter(this, h);
                    if (!h.b) {
                        g = false;
                    }
                }
                if (g) {
                    this.records.add(f);
                    if (e.isEmpty) {
                        e = f.bounds;
                    }
                    else {
                        e.union(f.bounds);
                    }
                }
                c = a.currentPosition;
                d = a.length;
            }
            this.computedWorldRect = e.isEmpty ? this.worldRect : e;
        }
        get records() {
            return this.x;
        }
        set records(a) {
            this.x = a;
        }
        indexOf(a) {
            return this.x.indexOf(a);
        }
        insert(a, b) {
            this.x.insert(a, b);
        }
        removeAt(a) {
            this.x.removeAt(a);
        }
        item(a, b) {
            if (arguments.length === 2) {
                this.x.item(a, b);
                return b;
            }
            else {
                return this.x._inner[a];
            }
        }
        add(a) {
            this.x.add(a);
        }
        clear() {
            this.x.clear();
        }
        contains(a) {
            return this.x.contains(a);
        }
        copyTo(a, b) {
            this.x.copyTo(a, b);
        }
        get count() {
            return this.x.count;
        }
        get isReadOnly() {
            return this.x.isReadOnly;
        }
        remove(a) {
            return this.x.remove(a);
        }
        getEnumerator() {
            return this.x.getEnumerator();
        }
        getEnumeratorObject() {
            return this.getEnumerator();
        }
        getPointData() {
            return new List$1(ShapefileRecord.$, 1, this.records);
        }
        getRecordsCount() {
            if (this.records == null) {
                return 0;
            }
            return this.records.count;
        }
        getRecord(a) {
            return this.records._inner[a];
        }
        getRecordBounds(a) {
            if (this.records == null) {
                return Rect.empty;
            }
            if (a < 0 || a > this.records.count - 1) {
                return Rect.empty;
            }
            return this.records._inner[a].bounds;
        }
        getRecordFieldNames(a) {
            if (this.records == null) {
                return null;
            }
            if (a < 0 || a > this.records.count - 1) {
                return null;
            }
            let b = this.records._inner[a];
            if (b == null || b.fieldsNames == null) {
                return null;
            }
            return b.fieldsNames.toArray();
        }
        getRecordValue(a, b) {
            if (this.records == null) {
                return null;
            }
            if (a < 0 || a > this.records.count - 1) {
                return null;
            }
            let c = this.records._inner[a];
            if (c == null || c.fieldsNames == null) {
                return null;
            }
            return c.getFieldValue(b);
        }
        removeRecord(a) {
            if (this.records == null) {
                return;
            }
            if (a < 0 || a > this.records.count - 1) {
                return;
            }
            this.records.removeAt(a);
        }
        shiftAllShapes(a, b) {
            if (this.records == null) {
                return;
            }
            for (let c = 0; c < this.records.count; c++) {
                this.shiftShapes(c, a, b);
            }
        }
        shiftShapes(a, b, c) {
            if (this.records == null) {
                return;
            }
            if (a < 0 || a > this.records.count - 1) {
                return;
            }
            let d = new List$1(List$1.$.specialize(Point_$type), 0);
            let e = this.records._inner[a].points;
            for (let f of fromEnum(e)) {
                let g = ShapefileConverter.w(f, b, c);
                for (let h of fromEnum(g)) {
                    d.add(h);
                }
            }
            this.records._inner[a].points = d;
        }
        static ai(a, b) {
            return ShapefileConverter.ag(a, b, -180, 180);
        }
        static ah(a, b) {
            return ShapefileConverter.ag(a, b, -85.05112878, 85.05112878);
        }
        static ag(a, b, c, d) {
            let e = a;
            if (isNaN_(b) || b == 0) {
                return e;
            }
            if (e + b < c) {
                e += 2 * d;
                e += b;
            }
            else if (e + b > d) {
                e -= 2 * d;
                e += b;
            }
            else {
                e += b;
            }
            return e;
        }
        static isValidGeoPoint(a) {
            if (a.x < -180 || a.x > 180) {
                return false;
            }
            if (a.y < -90 || a.y > 90) {
                return false;
            }
            return true;
        }
        static isValidGeoShape(a) {
            if (a.count < 3) {
                return false;
            }
            for (let b of fromEnum(a)) {
                if (!ShapefileConverter.isValidGeoPoint(b)) {
                    return false;
                }
            }
            return true;
        }
        static w(a, b, c, d = "") {
            let e = 1.7976931348623157E+308;
            let f = -1.7976931348623157E+308;
            let g = new List$1(Point_$type, 0);
            for (let h of fromEnum(a)) {
                let i = ShapefileConverter.ag(h.x, b, -180, 180);
                let j = ShapefileConverter.ag(h.y, c, -85.05112878, 85.05112878);
                e = Math.min(e, i);
                f = Math.max(f, i);
                g.add({ $type: Point_$type, x: i, y: j });
            }
            let k = new List$1(List$1.$.specialize(Point_$type), 0);
            let l = ShapefileConverter.ba(g);
            let m = l.width;
            if (l.left >= -180 && l.right <= 180 && l.width > 180) {
                let n = new List$1(Point_$type, 0);
                let o = new List$1(Point_$type, 0);
                for (let p of fromEnum(g)) {
                    if (p.x >= -180 && p.x < 0) {
                        n.add(p);
                    }
                    else {
                        o.add(p);
                    }
                }
                let q = ShapefileConverter.ba(n);
                let r = q.width;
                let s = ShapefileConverter.ba(o);
                let t = s.width;
                if (ShapefileConverter.isValidGeoShape(n)) {
                    k.add(n);
                }
                if (ShapefileConverter.isValidGeoShape(o)) {
                    k.add(o);
                }
            }
            else {
                if (ShapefileConverter.isValidGeoShape(g)) {
                    k.add(g);
                }
            }
            return k;
        }
        getMaxLongitude(a, b, c, d) {
            if (this.records == null) {
                return NaN;
            }
            if (a < 0 || a > this.records.count - 1) {
                return NaN;
            }
            let e = this.records._inner[a].points;
            let f = c;
            if (b) {
                let g = ShapefileConverter.v(e);
                for (let h of fromEnum(g)) {
                    if (h.x < d) {
                        f = Math.max(f, h.x);
                    }
                }
            }
            else {
                for (let i of fromEnum(e)) {
                    for (let j of fromEnum(i)) {
                        if (j.x < d) {
                            f = Math.max(f, j.x);
                        }
                    }
                }
            }
            return f;
        }
        setRecordValue(a, b, c) {
            if (this.records == null) {
                return;
            }
            if (a < 0 || a > this.records.count - 1) {
                return;
            }
            let d = this.records._inner[a];
            if (d == null || d.fieldsNames == null) {
                return;
            }
            d.setFieldValue(b, c);
        }
        getRecordValues(a) {
            if (this.records == null) {
                return null;
            }
            let b = new Array(this.records.count);
            for (let c = 0; c < this.records.count; c++) {
                let d = this.getRecordValue(c, a);
                b[c] = d;
            }
            return b;
        }
        setRecordValues(a, b) {
            if (this.records == null) {
                return;
            }
            let c = Math.min(b.length, this.records.count);
            for (let d = 0; d < c; d++) {
                this.setRecordValue(d, a, b[d]);
            }
        }
        static ba(a) {
            let b = Number.POSITIVE_INFINITY;
            let c = Number.POSITIVE_INFINITY;
            let d = Number.NEGATIVE_INFINITY;
            let e = Number.NEGATIVE_INFINITY;
            for (let f = 0; f < a.count; f++) {
                let g = a._inner[f];
                b = Math.min(b, g.x);
                c = Math.min(c, g.y);
                d = Math.max(d, g.x);
                e = Math.max(e, g.y);
            }
            if (isInfinity(b) || isInfinity(c) || isInfinity(c) || isInfinity(e)) {
                return Rect.empty;
            }
            return new Rect(0, b, c, d - b, e - c);
        }
        getLargestShapeBoundsForRecord(a) {
            if (this.records == null) {
                return Rect.empty;
            }
            if (a < 0 || a > this.records.count - 1) {
                return Rect.empty;
            }
            let b = this.records._inner[a];
            if (b == null || b.fieldsNames == null) {
                return Rect.empty;
            }
            let c = ShapefileConverter.v(b.points);
            return ShapefileConverter.ba(c);
        }
        static v(a) {
            let b = new List$1(Point_$type, 0);
            let c = -1.7976931348623157E+308;
            for (let d of fromEnum(a)) {
                let e = 1.7976931348623157E+308;
                let f = -1.7976931348623157E+308;
                let g = 1.7976931348623157E+308;
                let h = -1.7976931348623157E+308;
                for (let i of fromEnum(d)) {
                    g = Math.min(g, i.y);
                    h = Math.max(h, i.y);
                    e = Math.min(e, i.x);
                    f = Math.max(f, i.x);
                }
                let j = f - e;
                let k = h - g;
                let l = new Rect(0, e, g, j, k);
                let m = l.width * l.height;
                if (m > c) {
                    c = m;
                    b = d;
                }
            }
            return b;
        }
    }
    ShapefileConverter.$t = /*@__PURE__*/ markType(ShapefileConverter, 'ShapefileConverter', DependencyObjectNotifier.$, [/*@__PURE__*/ IList$1_$type.specialize(ShapefileRecord.$), INotifyCollectionChanged_$type]);
    ShapefileConverter.minLatitude = -85.05112878;
    ShapefileConverter.maxLatitude = 85.05112878;
    ShapefileConverter.minLongitude = -180;
    ShapefileConverter.maxLongitude = 180;
    ShapefileConverter.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, ShapefileConverter, 'aw', ['DatabaseSource', [2, null], 'DeferImportCompleted', [0, false], 'ShapefileSource', [2, null]]);
    return ShapefileConverter;
})();

/**
 * Represents a record of data from a Shapefile (.shp and .dbf).
*/
class IgrShapefileRecord {
    createImplementation() {
        return new ShapefileRecord();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets the shape type, as read from the header of the Shapefile.
    */
    get shapeType() {
        return this.i.shapeType;
    }
    /**
     * Gets an array of field names and values for this record
    */
    get fieldsNames() {
        return this.i.fieldsNames._inner;
    }
    /**
     * Gets an arry of field types and values for this record
    */
    get fieldsTypes() {
        return this.i.fieldsTypes._inner;
    }
    /**
     * Gets an array of arrays of points for this record
    */
    get points() {
        var ret = [];
        var list = this.i.points;
        for (var i = 0; i < list.count; i++) {
            var innerlist = list.item(i);
            ret.push(list.item(i)._inner);
        }
        return ret;
    }
    get fieldValues() {
        return this.i.fieldValues;
    }
    set fieldValues(v) {
        this.i.fieldValues = v;
    }
    /**
     * Gets the bounds for the shapes
    */
    get bounds() {
        return fromRect(this.i.bounds);
    }
    set bounds(v) {
        this.i.bounds = toRect(v);
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    getFieldValue(fieldName) {
        let iv = this.i.getFieldValue(fieldName);
        return (iv);
    }
    setFieldValue(fieldName, value) {
        this.i.setFieldValue(fieldName, value);
    }
}

class IgrShapeFilterRecordEventArgs {
    createImplementation() {
        return new ShapeFilterRecordEventArgs();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get record() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrShapefileRecord();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set record(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    get shouldInclude() {
        return this.i.b;
    }
    set shouldInclude(v) {
        this.i.b = ensureBool(v);
    }
}

/**
 * Class used to convert Shapefiles into CLR objects.
*/
class IgrShapeDataSource {
    createImplementation() {
        return new ShapefileConverter();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        //@@ZoneRunner
        this._importPending = null;
        this._importPending_wrapped = null;
        this._importCompleted = null;
        this._importCompleted_wrapped = null;
        this._filter = null;
        this._filter_wrapped = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    //   private _databaseSource: string;
    ///**
    // * Gets the string Uri path of the .dbf portion of the Shapefile
    //*/
    //   get databaseSource(): string {
    //       return this._databaseSource;
    //   }
    ///**
    // * Sets the string Uri path of the .dbf portion of the Shapefile
    //*/
    //   set databaseSource(v: string) {
    //       this._databaseSource = v;
    //   }
    //   private _shapefileSource: string;
    ///**
    // * Gets the string Uri path of the .shp portion of the Shapefile
    //*/
    //   get shapefileSource(): string {
    //       return this._shapefileSource;
    //   }
    ///**
    // * Sets the string Uri path of the .shp portion of the Shapefile
    //*/
    //   set shapefileSource(v: string) {
    //       this._shapefileSource = v;
    //   }
    dataBind() {
        //this.i.shapefileSource = null;
        //this.i.databaseSource = null;
        //if (this._shapefileSource && this._databaseSource) {
        //    this.i.shapefileSource = new Uri(0, this._shapefileSource);
        //    this.i.databaseSource = new Uri(0, this._databaseSource);
        //}
    }
    /**
    * Gets the point data.
    */
    getPointData() {
        let list = this.i.getPointData();
        let ret = [];
        for (var i = 0; i < list.count; i++) {
            var shapeRecord = list.item(i);
            if (!shapeRecord.externalObject) {
                let e = new IgrShapefileRecord();
                e._implementation = shapeRecord;
                shapeRecord.externalObject = e;
            }
            ret.push(shapeRecord.externalObject);
        }
        return ret;
    }
    get name() {
        return this.i.name;
    }
    set name(v) {
        this.i.name = v;
    }
    /**
     * Gets the world bounding rectangle, as read from the header of the Shapefile.
    */
    get worldRect() {
        return fromRect(this.i.worldRect);
    }
    set worldRect(v) {
        this.i.worldRect = toRect(v);
    }
    /**
     * Gets the world bounding rectangle, based on the filtered shapes
    */
    get computedWorldRect() {
        return fromRect(this.i.computedWorldRect);
    }
    set computedWorldRect(v) {
        this.i.computedWorldRect = toRect(v);
    }
    /**
     * Gets the shape type, as read from the header of the Shapefile.
    */
    get shapeType() {
        return this.i.shapeType;
    }
    /**
     * Gets the header of the Shapefile.
    */
    get shapeHeader() {
        return this.i.shapeHeader;
    }
    set shapeHeader(v) {
        this.i.shapeHeader = v;
    }
    /**
     * The Uri of the .shp portion of the Shapefile.
    */
    get deferImportCompleted() {
        return this.i.deferImportCompleted;
    }
    set deferImportCompleted(v) {
        this.i.deferImportCompleted = ensureBool(v);
    }
    /**
     * The Uri of the .shp portion of the Shapefile.
    */
    get shapefileSource() {
        return this.i.shapefileSource;
    }
    set shapefileSource(v) {
        this.i.shapefileSource = v;
    }
    /**
     * The Uri of the .dbf portion of the Shapefile.
    */
    get databaseSource() {
        return this.i.databaseSource;
    }
    set databaseSource(v) {
        this.i.databaseSource = v;
    }
    /**
     * The total number of ShapefileRecords in the collection.
    */
    get count() {
        return this.i.count;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    getWorldBounds(useComputed) {
        let iv = this.i.getWorldBounds(useComputed);
        return fromRect(iv);
    }
    setWorldBounds(setComputed, bounds) {
        this.i.setWorldBounds(setComputed, toRect(bounds));
    }
    sendImportCompleted() {
        this.i.sendImportCompleted();
    }
    getRecordsCount() {
        let iv = this.i.getRecordsCount();
        return (iv);
    }
    getRecord(index) {
        let iv = this.i.getRecord(index);
        let ret = null;
        if (iv && iv.externalObject) {
            ret = iv.externalObject;
        }
        else {
            if (iv) {
                let e = new IgrShapefileRecord();
                e._implementation = iv;
                iv.externalObject = e;
                ret = e;
            }
        }
        return ret;
    }
    getRecordBounds(index) {
        let iv = this.i.getRecordBounds(index);
        return fromRect(iv);
    }
    getRecordFieldNames(index) {
        let iv = this.i.getRecordFieldNames(index);
        return (iv);
    }
    getRecordValue(index, fieldName) {
        let iv = this.i.getRecordValue(index, fieldName);
        return (iv);
    }
    removeRecord(index) {
        this.i.removeRecord(index);
    }
    shiftAllShapes(offsetX, offsetY) {
        this.i.shiftAllShapes(offsetX, offsetY);
    }
    shiftShapes(recordIndex, offsetX, offsetY) {
        this.i.shiftShapes(recordIndex, offsetX, offsetY);
    }
    getMaxLongitude(recordIndex, useLargestShape, fromLongitude, toLongitude) {
        let iv = this.i.getMaxLongitude(recordIndex, useLargestShape, fromLongitude, toLongitude);
        return (iv);
    }
    setRecordValue(index, fieldName, value) {
        this.i.setRecordValue(index, fieldName, value);
    }
    getRecordValues(fieldName) {
        let iv = this.i.getRecordValues(fieldName);
        return (iv);
    }
    setRecordValues(fieldName, values) {
        this.i.setRecordValues(fieldName, values);
    }
    getLargestShapeBoundsForRecord(index) {
        let iv = this.i.getLargestShapeBoundsForRecord(index);
        return fromRect(iv);
    }
    /**
     * Event raised when the Shapefile has been imported from both the ShapefileSource and DatabaseSource Uris.
    */
    get importPending() {
        return this._importPending;
    }
    set importPending(ev) {
        if (this._importPending_wrapped !== null) {
            this.i.importPending = delegateRemove(this.i.importPending, this._importPending_wrapped);
            this._importPending_wrapped = null;
            this._importPending = null;
        }
        this._importPending = ev;
        this._importPending_wrapped = (o, e) => {
            let outerArgs = new IgrAsyncCompletedEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeImportPending) {
                this.beforeImportPending(this, outerArgs);
            }
            if (this._importPending) {
                this._importPending(this, outerArgs);
            }
        };
        this.i.importPending = delegateCombine(this.i.importPending, this._importPending_wrapped);
        ;
    }
    /**
     * Event raised when the Shapefile has been imported from both the ShapefileSource and DatabaseSource Uris.
    */
    get importCompleted() {
        return this._importCompleted;
    }
    set importCompleted(ev) {
        if (this._importCompleted_wrapped !== null) {
            this.i.importCompleted = delegateRemove(this.i.importCompleted, this._importCompleted_wrapped);
            this._importCompleted_wrapped = null;
            this._importCompleted = null;
        }
        this._importCompleted = ev;
        this._importCompleted_wrapped = (o, e) => {
            let outerArgs = new IgrAsyncCompletedEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeImportCompleted) {
                this.beforeImportCompleted(this, outerArgs);
            }
            if (this._importCompleted) {
                this._importCompleted(this, outerArgs);
            }
        };
        this.i.importCompleted = delegateCombine(this.i.importCompleted, this._importCompleted_wrapped);
        ;
    }
    get filter() {
        return this._filter;
    }
    set filter(ev) {
        if (this._filter_wrapped !== null) {
            this.i.filter = delegateRemove(this.i.filter, this._filter_wrapped);
            this._filter_wrapped = null;
            this._filter = null;
        }
        this._filter = ev;
        this._filter_wrapped = (o, e) => {
            let outerArgs = new IgrShapeFilterRecordEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeFilter) {
                this.beforeFilter(this, outerArgs);
            }
            if (this._filter) {
                this._filter(this, outerArgs);
            }
        };
        this.i.filter = delegateCombine(this.i.filter, this._filter_wrapped);
        ;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITileGenerator_$type = /*@__PURE__*/ new Type(null, 'ITileGenerator');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScalerVisibleBounds = /*@__PURE__*/ (() => {
    class ScalerVisibleBounds extends Base {
        constructor(a, b, c, d) {
            super();
            this.d = 0;
            this.a = 0;
            this.c = 0;
            this.b = 0;
            this.b = a;
            this.d = b;
            this.c = c;
            this.a = d;
        }
    }
    ScalerVisibleBounds.$t = /*@__PURE__*/ markType(ScalerVisibleBounds, 'ScalerVisibleBounds');
    return ScalerVisibleBounds;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileScaler = /*@__PURE__*/ (() => {
    class HeatTileScaler extends Base {
        constructor() {
            super();
            this.b = 0;
            this.c = 0;
            this.d = 0;
            this.e = 0;
            this.b = 85.05112878 - -85.05112878;
            this.c = 180 - -180;
            this.d = this.k(85.05112878);
            this.e = this.k(85.05112878) - this.k(-85.05112878);
        }
        k(a) {
            let b = a * (0.017453292519943295);
            let c = Math.sin(b);
            let d = 0.5 * Math.log((1 + c) / (1 - c));
            return d;
        }
        static a(a, b) {
            let c = new Rect(0, b.left / a.width, b.top / a.height, b.width / a.width, b.height / a.height);
            let d = c.left + c.width * a.left;
            let e = c.left + c.width * a.right;
            let f = c.top + c.height * a.top;
            let g = c.top + c.height * a.bottom;
            let h = new ScalerVisibleBounds(d, f, e, g);
            return h;
        }
        static m(a) {
            a = Math.exp(2 * a);
            return Math.asin((a - 1) / (a + 1)) / 0.017453292519943295;
        }
        t(a, b, c) {
            let d = (a - c.top) * b.width + b.top * c.height;
            d = this.k(85.05112878) - d / (c.height / this.e);
            return HeatTileScaler.m(d);
        }
        r(a, b, c) {
            let d = c.top + this.l(a, c.height);
            return (d - b.top * c.height) / b.width;
        }
        l(a, b) {
            a = a > -85.05112878 ? (a < 85.05112878 ? a : 85.05112878) : -85.05112878;
            let c = this.k(a);
            let d = (this.d - c) * b / this.e;
            return (d);
        }
        u(a, b, c) {
            let d = b.left + b.width * (a - c.left) / c.width;
            return -180 + d * (this.c);
        }
        s(a, b, c) {
            let d = (a - -180) / (this.c);
            return c.left + c.width * (d - b.left) / b.width;
        }
        i(a, b) {
            let c = HeatTileScaler.a(a, b);
            return this.t(b.bottom, a, b);
        }
        g(a, b) {
            let c = HeatTileScaler.a(a, b);
            return this.t(b.top, a, b);
        }
        j(a, b) {
            let c = HeatTileScaler.a(a, b);
            return this.u(b.left, a, b);
        }
        h(a, b) {
            let c = HeatTileScaler.a(a, b);
            return this.u(b.right, a, b);
        }
        v(a, b, c) {
            let d = c.height;
            let e = c.top;
            for (let f = 0; f < a.count; f++) {
                let g = a._inner[f];
                g = g > -85.05112878 ? (g < 85.05112878 ? g : 85.05112878) : -85.05112878;
                let h = g * (0.017453292519943295);
                let i = Math.sin(h);
                let j = 0.5 * Math.log((1 + i) / (1 - i));
                let k = (this.d - j) * d / this.e;
                k = e + k;
                a._inner[f] = (k - b.top * d) / b.width;
            }
        }
        w(a, b, c) {
            let d = c.left;
            let e = c.width;
            let f = b.left;
            let g = b.width;
            for (let h = 0; h < a.count; h++) {
                let i = (a._inner[h] - -180) / (this.c);
                a._inner[h] = c.left + c.width * (i - b.left) / b.width;
            }
        }
    }
    HeatTileScaler.$t = /*@__PURE__*/ markType(HeatTileScaler, 'HeatTileScaler');
    return HeatTileScaler;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileWorkSettings = /*@__PURE__*/ (() => {
    class TileWorkSettings extends Base {
        constructor() {
            super(...arguments);
            this._scaler = null;
            this._blurRadius = 0;
            this._maxBlurRadius = 0;
            this._useBlurRadiusAdjustedForZoom = false;
            this._minimumColor = new Color();
            this._maximumColor = new Color();
            this._tileViewport = null;
            this._yValues = null;
            this._xValues = null;
            this._values = null;
            this._isNewData = false;
            this._minimumVisibleLatitude = 0;
            this._maximumVisibleLatitude = 0;
            this._minimumVisibleLongitude = 0;
            this._maximumVisibleLongitude = 0;
            this._z = 0;
            this._x = 0;
            this._y = 0;
            this._window = null;
            this._testRun = false;
            this._globalMinimum = 0;
            this._globalMaximum = 0;
            this._useGlobalMinMax = false;
            this._minimumValue = 0;
            this._maximumValue = 0;
            this._scaleColors = null;
            this._scaleColorOffsets = null;
            this._useLogarithmicScale = false;
            this._logarithmBase = 0;
            this._image = null;
        }
        get scaler() {
            return this._scaler;
        }
        set scaler(a) {
            this._scaler = a;
        }
        get blurRadius() {
            return this._blurRadius;
        }
        set blurRadius(a) {
            this._blurRadius = a;
        }
        get maxBlurRadius() {
            return this._maxBlurRadius;
        }
        set maxBlurRadius(a) {
            this._maxBlurRadius = a;
        }
        get useBlurRadiusAdjustedForZoom() {
            return this._useBlurRadiusAdjustedForZoom;
        }
        set useBlurRadiusAdjustedForZoom(a) {
            this._useBlurRadiusAdjustedForZoom = a;
        }
        get minimumColor() {
            return this._minimumColor;
        }
        set minimumColor(a) {
            this._minimumColor = a;
        }
        get maximumColor() {
            return this._maximumColor;
        }
        set maximumColor(a) {
            this._maximumColor = a;
        }
        get tileViewport() {
            return this._tileViewport;
        }
        set tileViewport(a) {
            this._tileViewport = a;
        }
        get yValues() {
            return this._yValues;
        }
        set yValues(a) {
            this._yValues = a;
        }
        get xValues() {
            return this._xValues;
        }
        set xValues(a) {
            this._xValues = a;
        }
        get values() {
            return this._values;
        }
        set values(a) {
            this._values = a;
        }
        get isNewData() {
            return this._isNewData;
        }
        set isNewData(a) {
            this._isNewData = a;
        }
        get minimumVisibleLatitude() {
            return this._minimumVisibleLatitude;
        }
        set minimumVisibleLatitude(a) {
            this._minimumVisibleLatitude = a;
        }
        get maximumVisibleLatitude() {
            return this._maximumVisibleLatitude;
        }
        set maximumVisibleLatitude(a) {
            this._maximumVisibleLatitude = a;
        }
        get minimumVisibleLongitude() {
            return this._minimumVisibleLongitude;
        }
        set minimumVisibleLongitude(a) {
            this._minimumVisibleLongitude = a;
        }
        get maximumVisibleLongitude() {
            return this._maximumVisibleLongitude;
        }
        set maximumVisibleLongitude(a) {
            this._maximumVisibleLongitude = a;
        }
        get z() {
            return this._z;
        }
        set z(a) {
            this._z = a;
        }
        get x() {
            return this._x;
        }
        set x(a) {
            this._x = a;
        }
        get y() {
            return this._y;
        }
        set y(a) {
            this._y = a;
        }
        get window() {
            return this._window;
        }
        set window(a) {
            this._window = a;
        }
        get testRun() {
            return this._testRun;
        }
        set testRun(a) {
            this._testRun = a;
        }
        get globalMinimum() {
            return this._globalMinimum;
        }
        set globalMinimum(a) {
            this._globalMinimum = a;
        }
        get globalMaximum() {
            return this._globalMaximum;
        }
        set globalMaximum(a) {
            this._globalMaximum = a;
        }
        get useGlobalMinMax() {
            return this._useGlobalMinMax;
        }
        set useGlobalMinMax(a) {
            this._useGlobalMinMax = a;
        }
        get minimumValue() {
            return this._minimumValue;
        }
        set minimumValue(a) {
            this._minimumValue = a;
        }
        get maximumValue() {
            return this._maximumValue;
        }
        set maximumValue(a) {
            this._maximumValue = a;
        }
        get scaleColors() {
            return this._scaleColors;
        }
        set scaleColors(a) {
            this._scaleColors = a;
        }
        get scaleColorOffsets() {
            return this._scaleColorOffsets;
        }
        set scaleColorOffsets(a) {
            this._scaleColorOffsets = a;
        }
        get useLogarithmicScale() {
            return this._useLogarithmicScale;
        }
        set useLogarithmicScale(a) {
            this._useLogarithmicScale = a;
        }
        get logarithmBase() {
            return this._logarithmBase;
        }
        set logarithmBase(a) {
            this._logarithmBase = a;
        }
        get image() {
            return this._image;
        }
        set image(a) {
            this._image = a;
        }
        flatten() {
            let minA_ = this.minimumColor.l;
            let minR_ = this.minimumColor.o;
            let minG_ = this.minimumColor.n;
            let minB_ = this.minimumColor.m;
            let maxA_ = this.maximumColor.l;
            let maxR_ = this.maximumColor.o;
            let maxG_ = this.maximumColor.n;
            let maxB_ = this.maximumColor.m;
            let scaleColors_ = null;
            if (this.scaleColors != null) {
                scaleColors_ = new Array(this.scaleColors.length);
                for (let a = 0; a < this.scaleColors.length; a++) {
                    let a_ = this.scaleColors[a].l;
                    let r_ = this.scaleColors[a].o;
                    let g_ = this.scaleColors[a].n;
                    let b_ = this.scaleColors[a].m;
                    let color_ = { a: a_, r: r_, g: g_, b: b_ };
                    scaleColors_[a] = color_;
                }
            }
            return {
                blurRadius: this.blurRadius,
                maxBlurRadius: this.maxBlurRadius,
                //isLinearScaler: this.isLinearScaler,
                //linearScalerMinimumXValue: this.linearScalerMinimumXValue,
                //linearScalerMinimumYValue: this.linearScalerMinimumYValue,
                //linearScalerMaximumXValue: this.linearScalerMaximumXValue,
                //linearScalerMaximumYValue: this.linearScalerMaximumYValue,
                //linearScalerXIsInverted: this.linearScalerXIsInverted,
                //linearScalerYIsInverted: this.linearScalerYIsInverted,
                useBlurRadiusAdjustedForZoom: this.useBlurRadiusAdjustedForZoom,
                minimumColor: { a: minA_, r: minR_, g: minG_, b: minB_ },
                maximumColor: { a: maxA_, r: maxR_, g: maxG_, b: maxB_ },
                tileViewport: { left: this.tileViewport.left, top: this.tileViewport.top, width: this.tileViewport.width, height: this.tileViewport.height },
                yValues: this.yValues,
                xValues: this.xValues,
                values: this.values,
                isNewData: this.isNewData,
                minimumVisibleLatitude: this.minimumVisibleLatitude,
                minimumVisibleLongitude: this.minimumVisibleLongitude,
                maximumVisibleLatitude: this.maximumVisibleLatitude,
                maximumVisibleLongitude: this.maximumVisibleLongitude,
                z: this.z,
                x: this.x,
                y: this.y,
                window: { left: this.window.left, top: this.window.top, width: this.window.width, height: this.window.height },
                testRun: this.testRun,
                globalMinimum: this.globalMinimum,
                globalMaximum: this.globalMaximum,
                useGlobalMinMax: this.useGlobalMinMax,
                minimumValue: this.minimumValue,
                maximumValue: this.maximumValue,
                scaleColorOffsets: this.scaleColorOffsets,
                scaleColors: scaleColors_,
                useLogarithmicScale: this.useLogarithmicScale,
                logarithmBase: this.logarithmBase
            };
        }
    }
    TileWorkSettings.$t = /*@__PURE__*/ markType(TileWorkSettings, 'TileWorkSettings');
    return TileWorkSettings;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileImageCreatedEventArgs = /*@__PURE__*/ (() => {
    class TileImageCreatedEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._imageData = null;
            this._image = null;
            this._z = 0;
            this._x = 0;
            this._y = 0;
            this._url = null;
        }
        get imageData() {
            return this._imageData;
        }
        set imageData(a) {
            this._imageData = a;
        }
        get image() {
            return this._image;
        }
        set image(a) {
            this._image = a;
        }
        get z() {
            return this._z;
        }
        set z(a) {
            this._z = a;
        }
        get x() {
            return this._x;
        }
        set x(a) {
            this._x = a;
        }
        get y() {
            return this._y;
        }
        set y(a) {
            this._y = a;
        }
        get url() {
            return this._url;
        }
        set url(a) {
            this._url = a;
        }
    }
    TileImageCreatedEventArgs.$t = /*@__PURE__*/ markType(TileImageCreatedEventArgs, 'TileImageCreatedEventArgs', EventArgs.$);
    return TileImageCreatedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileImageCreatedEventArgs = /*@__PURE__*/ (() => {
    class HeatTileImageCreatedEventArgs extends TileImageCreatedEventArgs {
        constructor() {
            super(...arguments);
            this._globalMinimumValue = 0;
            this._globalMaximumValue = 0;
            this._globalMaximumValueLongitude = 0;
            this._globalMaximumValueLatitude = 0;
            this._globalMinimumValueLongitude = 0;
            this._globalMinimumValueLatitude = 0;
        }
        get globalMinimumValue() {
            return this._globalMinimumValue;
        }
        set globalMinimumValue(a) {
            this._globalMinimumValue = a;
        }
        get globalMaximumValue() {
            return this._globalMaximumValue;
        }
        set globalMaximumValue(a) {
            this._globalMaximumValue = a;
        }
        get globalMaximumValueLongitude() {
            return this._globalMaximumValueLongitude;
        }
        set globalMaximumValueLongitude(a) {
            this._globalMaximumValueLongitude = a;
        }
        get globalMaximumValueLatitude() {
            return this._globalMaximumValueLatitude;
        }
        set globalMaximumValueLatitude(a) {
            this._globalMaximumValueLatitude = a;
        }
        get globalMinimumValueLongitude() {
            return this._globalMinimumValueLongitude;
        }
        set globalMinimumValueLongitude(a) {
            this._globalMinimumValueLongitude = a;
        }
        get globalMinimumValueLatitude() {
            return this._globalMinimumValueLatitude;
        }
        set globalMinimumValueLatitude(a) {
            this._globalMinimumValueLatitude = a;
        }
    }
    HeatTileImageCreatedEventArgs.$t = /*@__PURE__*/ markType(HeatTileImageCreatedEventArgs, 'HeatTileImageCreatedEventArgs', TileImageCreatedEventArgs.$);
    return HeatTileImageCreatedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileGeneratorWorker = /*@__PURE__*/ (() => {
    class HeatTileGeneratorWorker extends Base {
        get t() {
            return this.r;
        }
        get g() {
            return this.f;
        }
        constructor(a) {
            super();
            this.f = null;
            this.a = null;
            this.n = 0;
            this.o = 0;
            this.p = 0;
            this.w = null;
            this.u = 0;
            this.h = false;
            this.r = 0;
            this.i = 0;
            this.j = 0;
            this.k = 0;
            this.l = 0;
            this._completedSink = null;
            this.f = a;
            HeatTileGeneratorWorker.s++;
            if (HeatTileGeneratorWorker.s == 0x7FFFFFFFFFFFFFFF) {
                HeatTileGeneratorWorker.s = 0;
            }
            this.r = HeatTileGeneratorWorker.s;
        }
        doWork() {
            let a = this.g.blurRadius;
            let b = a;
            let c = this.g.maxBlurRadius;
            let d = this.g.scaler;
            this.n = this.g.x;
            this.o = this.g.y;
            this.p = this.g.z;
            if (this.g.useBlurRadiusAdjustedForZoom && this.p > 0) {
                let e = Math.sqrt(1 * 1 + 1 * 1) * Math.pow(2, this.p - 1);
                b = a * e;
            }
            if (!isNaN_(c)) {
                if (b > c) {
                    b = c;
                }
            }
            let f = this.g.xValues;
            let g = this.g.yValues;
            let h = this.g.values;
            let i = this.g.xValues.length;
            let j = this.g.yValues.length;
            let k;
            let l;
            let m;
            let n;
            let o;
            let p;
            let q;
            let r = this.g.minimumVisibleLongitude;
            let s = this.g.maximumVisibleLongitude;
            let t = this.g.minimumVisibleLatitude;
            let u = this.g.maximumVisibleLatitude;
            let v = this.q(this.g.tileViewport, b);
            let w = this.c(v, b);
            let x = Math.abs(d.t(0, this.g.window, this.g.tileViewport) - d.t(b, this.g.window, this.g.tileViewport));
            let y = Math.abs(d.u(0, this.g.window, this.g.tileViewport) - d.u(b, this.g.window, this.g.tileViewport));
            let z;
            let aa;
            let ab = new List$1(Number_$type, 0);
            let ac = new List$1(Number_$type, 0);
            let ad = new List$1(Number_$type, 0);
            for (let ae = 0; ae < i; ae++) {
                k = f[ae];
                l = g[ae];
                m = h[ae];
                n = k - y;
                o = k + y;
                p = l - x;
                q = l + x;
                if (o < r || q < t || p > u || n > s) {
                    continue;
                }
                ab.add(k);
                ac.add(l);
                ad.add(m);
            }
            let af = this.d(this.g.tileViewport);
            let ag = this.b(this.g.tileViewport);
            let ah = truncate(this.g.tileViewport.width);
            let ai = ac.count;
            d.v(ac, this.g.window, this.g.tileViewport);
            d.w(ab, this.g.window, this.g.tileViewport);
            let aj;
            let ak;
            let al;
            let am;
            for (let an = 0; an < ai; an++) {
                z = truncate(Math.floor(ab._inner[an] - b));
                aa = truncate(Math.floor(ac._inner[an] - b));
                for (let ao = z; ao < z + v; ao++) {
                    for (let ap = aa; ap < aa + v; ap++) {
                        aj = ao - z;
                        ak = ap - aa;
                        if (ao < 0 || ao > (ah - 1) || ap < 0 || ap > (ah - 1)) {
                            continue;
                        }
                        al = w[ak * v + aj];
                        am = ad._inner[an] * al;
                        ag[ap * ah + ao] = ag[ap * ah + ao] + am;
                    }
                }
            }
            let aq = ag.length;
            let ar = -1.7976931348623157E+308;
            let as = 1.7976931348623157E+308;
            let at;
            if (!isNaN_(this.g.globalMinimum) && !isNaN_(this.g.globalMaximum) && this.g.useGlobalMinMax && !this.g.testRun) {
                as = this.g.globalMinimum;
                ar = this.g.globalMaximum;
                if (!isNaN_(this.g.minimumValue)) {
                    as = this.g.minimumValue;
                }
                if (!isNaN_(this.g.maximumValue)) {
                    ar = this.g.maximumValue;
                }
            }
            else if (!isNaN_(this.g.minimumValue) && !isNaN_(this.g.maximumValue)) {
                as = this.g.minimumValue;
                ar = this.g.maximumValue;
            }
            else {
                let au = -1;
                let av = -1;
                for (let aw = 0; aw < aq; aw++) {
                    at = ag[aw];
                    if (at > 0) {
                        if (at > ar) {
                            ar = at;
                            au = aw;
                        }
                        if (at < as) {
                            as = at;
                            av = aw;
                        }
                    }
                }
                let ax = truncate(Math.floor(au / ah));
                let ay = au % ah;
                let az = truncate(Math.floor(av / ah));
                let a0 = av % ah;
                this.g.globalMinimum = as;
                this.g.globalMaximum = ar;
                let a1 = 0;
                let a2 = 0;
                let a3 = 0;
                let a4 = 0;
                let a5 = 0;
                let a6 = 0;
                for (let a7 = 0; a7 < ai; a7++) {
                    z = truncate(Math.floor(ab._inner[a7] - b));
                    aa = truncate(Math.floor(ac._inner[a7] - b));
                    for (let a8 = z; a8 < z + v; a8++) {
                        for (let a9 = aa; a9 < aa + v; a9++) {
                            aj = a8 - z;
                            ak = a9 - aa;
                            if (a8 < 0 || a8 > (ah - 1) || a9 < 0 || a9 > (ah - 1)) {
                                continue;
                            }
                            if (a8 == ay && a9 == ax) {
                                a1++;
                                a3 = a3 + d.t(ac._inner[a7], this.g.window, this.g.tileViewport);
                                a4 = a4 + d.u(ab._inner[a7], this.g.window, this.g.tileViewport);
                            }
                            if (a8 == a0 && a9 == az) {
                                a2++;
                                a5 = a5 + d.t(ac._inner[a7], this.g.window, this.g.tileViewport);
                                a6 = a6 + d.u(ab._inner[a7], this.g.window, this.g.tileViewport);
                            }
                        }
                    }
                }
                this.i = a3 / a1;
                this.j = a4 / a1;
                this.k = a5 / a2;
                this.l = a6 / a2;
                if (!isNaN_(this.g.minimumValue)) {
                    as = this.g.minimumValue;
                }
                if (!isNaN_(this.g.maximumValue)) {
                    ar = this.g.maximumValue;
                }
            }
            if (!this.g.testRun) {
                this.x(af, ag, ar, as);
                this.a = af;
            }
            this.z();
        }
        x(a, b, c, d) {
            let e;
            let f = b.length;
            if (this.g.useLogarithmicScale) {
                if (d <= 0) {
                    d = 0;
                }
                else {
                    d = logBase(d, this.g.logarithmBase);
                }
                if (c <= 0) {
                    c = 0;
                }
                else {
                    c = logBase(c, this.g.logarithmBase);
                }
            }
            let g = 0;
            let h = c - d;
            if (isNaN_(h) || h <= 0) {
                h = 1;
            }
            let i;
            let j;
            let k;
            let l;
            let m = this.g.useLogarithmicScale;
            let n = this.g.logarithmBase;
            if (this.g.scaleColors != null) {
                let o = new Array(this.g.scaleColors.length);
                let p = new Array(this.g.scaleColors.length);
                let q = new Array(this.g.scaleColors.length);
                let r = new Array(this.g.scaleColors.length);
                let s = new Array(this.g.scaleColors.length);
                let t = new Array(this.g.scaleColors.length);
                let u = new Array(this.g.scaleColors.length);
                let v = new Array(this.g.scaleColors.length);
                let w = new Array(this.g.scaleColors.length);
                let x = new Array(this.g.scaleColors.length);
                let y = new Array(this.g.scaleColors.length);
                let z = new Array(this.g.scaleColors.length);
                let aa = this.g.scaleColorOffsets;
                if (aa == null || aa.length != this.g.scaleColors.length) {
                    aa = new Array(this.g.scaleColors.length);
                    if (aa.length == 1) {
                        aa[0] = 0;
                    }
                    else {
                        for (let ab = 0; ab < this.g.scaleColors.length; ab++) {
                            aa[ab] = ab / (this.g.scaleColors.length - 1);
                        }
                    }
                }
                for (let ac = 0; ac < this.g.scaleColors.length; ac++) {
                    o[ac] = this.g.scaleColors[ac].l;
                    q[ac] = this.g.scaleColors[ac].o;
                    s[ac] = this.g.scaleColors[ac].n;
                    u[ac] = this.g.scaleColors[ac].m;
                    if (ac < this.g.scaleColors.length - 1) {
                        p[ac] = this.g.scaleColors[ac + 1].l;
                        r[ac] = this.g.scaleColors[ac + 1].o;
                        t[ac] = this.g.scaleColors[ac + 1].n;
                        v[ac] = this.g.scaleColors[ac + 1].m;
                    }
                    else {
                        p[ac] = this.g.scaleColors[ac].l;
                        r[ac] = this.g.scaleColors[ac].o;
                        t[ac] = this.g.scaleColors[ac].n;
                        v[ac] = this.g.scaleColors[ac].m;
                    }
                    w[ac] = p[ac] - o[ac];
                    x[ac] = r[ac] - q[ac];
                    y[ac] = t[ac] - s[ac];
                    z[ac] = v[ac] - u[ac];
                }
                for (let ad = 0; ad < f; ad++) {
                    e = b[ad];
                    if (e == 0) {
                        continue;
                    }
                    if (m) {
                        if (e <= 0) {
                            e = 0;
                        }
                        else {
                            e = logBase(e, n);
                        }
                    }
                    g = (e - d) / (h);
                    if (g < 0) {
                        g = 0;
                    }
                    if (g > 1) {
                        g = 1;
                    }
                    let ae = 0;
                    for (let af = 0; af < aa.length; af++) {
                        if (aa[af] >= g) {
                            ae = af - 1;
                            break;
                        }
                    }
                    if (ae > aa.length - 2) {
                        ae = aa.length - 2;
                    }
                    if (ae < 0) {
                        ae = 0;
                    }
                    g = (g - aa[ae]) / (aa[ae + 1] - aa[ae]);
                    i = truncate(Math.floor(o[ae] + g * (w[ae])));
                    j = truncate(Math.floor(q[ae] + g * (x[ae])));
                    k = truncate(Math.floor(s[ae] + g * (y[ae])));
                    l = truncate(Math.floor(u[ae] + g * (z[ae])));
                    a[4 * ad] = i;
                    a[4 * ad + 1] = j;
                    a[4 * ad + 2] = k;
                    a[4 * ad + 3] = l;
                }
            }
            else {
                let ag = this.g.minimumColor.l;
                let ah = this.g.maximumColor.l;
                let ai = this.g.minimumColor.o;
                let aj = this.g.maximumColor.o;
                let ak = this.g.minimumColor.n;
                let al = this.g.maximumColor.n;
                let am = this.g.minimumColor.m;
                let an = this.g.maximumColor.m;
                let ao = ah - ag;
                let ap = aj - ai;
                let aq = al - ak;
                let ar = an - am;
                for (let as = 0; as < f; as++) {
                    e = b[as];
                    if (e == 0) {
                        continue;
                    }
                    if (m) {
                        e = logBase(e, n);
                    }
                    g = (e - d) / (h);
                    if (g < 0) {
                        g = 0;
                    }
                    if (g > 1) {
                        g = 1;
                    }
                    i = truncate(Math.floor(ag + g * (ao)));
                    j = truncate(Math.floor(ai + g * (ap)));
                    k = truncate(Math.floor(ak + g * (aq)));
                    l = truncate(Math.floor(am + g * (ar)));
                    a[4 * as] = i;
                    a[4 * as + 1] = j;
                    a[4 * as + 2] = k;
                    a[4 * as + 3] = l;
                }
            }
        }
        b(a) {
            let b = new Array(truncate(a.width) * truncate(a.height));
            for (let c = 0; c < b.length; c++) {
                b[c] = 0;
            }
            return b;
        }
        d(a) {
            let b = new Array(truncate(a.width) * truncate(a.height) * 4);
            for (let c = 0; c < b.length; c++) {
                b[c] = 0;
            }
            return b;
        }
        c(a, b) {
            let c = new Array(a * a);
            for (let d = 0; d < c.length; d++) {
                c[d] = 0;
            }
            let e = a / 2;
            let f = a / 2;
            for (let g = 0; g < a; g++) {
                for (let h = 0; h < a; h++) {
                    let i = Math.sqrt(Math.pow(g - f, 2) + Math.pow(h - f, 2));
                    if (i > e) {
                        c[h * a + g] = 0;
                    }
                    else {
                        c[h * a + g] = e - i;
                    }
                }
            }
            let j = 0;
            let k = -1.7976931348623157E+308;
            let l = 1.7976931348623157E+308;
            for (let m = 0; m < a; m++) {
                for (let n = 0; n < a; n++) {
                    let o = c[n * a + m];
                    if (o == 0) {
                        continue;
                    }
                    j += o;
                    k = o > k ? o : k;
                    l = o < l ? o : l;
                }
            }
            for (let p = 0; p < a; p++) {
                for (let q = 0; q < a; q++) {
                    let r = c[q * a + p];
                    if (r == 0) {
                        continue;
                    }
                    let s = (r - l) / (k - l);
                    c[q * a + p] = 0.01 + s * (0.99);
                }
            }
            c[truncate(f) * a + truncate(f)] = 1;
            return c;
        }
        q(a, b) {
            return truncate(Math.floor(b * 2));
        }
        z() {
            if (this.completedSink == null) {
                return;
            }
            this.completedSink.onCompleted(((() => {
                let $ret = new HeatTileImageCreatedEventArgs();
                $ret.url = this.w;
                $ret.x = this.n;
                $ret.y = this.o;
                $ret.z = this.p;
                $ret.globalMinimumValue = this.g.globalMinimum;
                $ret.globalMaximumValue = this.g.globalMaximum;
                $ret.globalMaximumValueLongitude = this.j;
                $ret.globalMaximumValueLatitude = this.i;
                $ret.globalMinimumValueLongitude = this.l;
                $ret.globalMinimumValueLatitude = this.k;
                $ret.imageData = this.a;
                $ret.image = this.g.image;
                return $ret;
            })()));
        }
        get completedSink() {
            return this._completedSink;
        }
        set completedSink(a) {
            this._completedSink = a;
        }
    }
    HeatTileGeneratorWorker.$t = /*@__PURE__*/ markType(HeatTileGeneratorWorker, 'HeatTileGeneratorWorker');
    HeatTileGeneratorWorker.v = {};
    HeatTileGeneratorWorker.s = 0;
    HeatTileGeneratorWorker.m = 0;
    return HeatTileGeneratorWorker;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITileWorkCompletedSink_$type = /*@__PURE__*/ new Type(null, 'ITileWorkCompletedSink');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileGeneratorWorkerManager = /*@__PURE__*/ (() => {
    class HeatTileGeneratorWorkerManager extends Base {
        constructor() {
            super();
            this.b = true;
            this.o = null;
            this.k = null;
            this._supportsTransferable = false;
            this.d = false;
            this._worker = null;
            this.a = false;
            this.j = 0;
            this.g = new Dictionary$2(String_$type, TileWorkSettings.$, 0);
            this.h = new Dictionary$2(String_$type, Delegate_$type, 0);
            this.i = new LinkedList$1(HeatTileGeneratorWorker.$);
            this.f = new Dictionary$2(String_$type, List$1.$.specialize(LinkedListNode$1.$.specialize(HeatTileGeneratorWorker.$)), 0);
        }
        get e() {
            return this.b;
        }
        set e(a) {
            this.b = a;
        }
        get p() {
            return this.o;
        }
        set p(a) {
            this.o = a;
        }
        get n() {
            return this.k;
        }
        set n(a) {
            this.k = a;
        }
        u() {
            if (!this.a) {
                this.a = true;
                if ((window.Worker)) {
                    this.d = true;
                }
                if (this.d && this.e) {
                    this.v();
                    var test = new ArrayBuffer(1);
                    this._worker.postMessage(test, [test]);
                    if (test.byteLength == 0) {
                        this._supportsTransferable = true;
                    }
                    ;
                }
                if (!this._supportsTransferable) {
                    this.b = false;
                }
            }
        }
        v() {
            if (this.p == null && this.n == null) {
                throw new Error('HeatTileGenerator wants to use web workers, but webWorkerScriptPath and webWorkerInstance were not specified. Either specify the path, an instance, or set allowWebWorkers to false');
            }
            if (this.n != null) {
                this._worker = this.n;
            }
            else {
                let path_ = this.p;
                this._worker = new Worker(path_);
            }
            this._worker.postMessage = this._worker.webkitPostMessage || this._worker.postMessage;
            let onMessage_ = runOn(this, this.z);
            this._worker.onmessage = onMessage_;
        }
        z(args_) {
            let data_ = args_.data;
            let a = new HeatTileImageCreatedEventArgs();
            a.imageData = (data_.imageData == null ? null : new Uint8ClampedArray(data_.imageData));
            a.z = (data_.z);
            a.x = (data_.x);
            a.y = (data_.y);
            a.url = (data_.url);
            a.globalMinimumValue = (data_.globalMinimumValue);
            a.globalMaximumValue = (data_.globalMaximumValue);
            a.globalMaximumValueLongitude = (data_.globalMaximumValueLongitude);
            a.globalMaximumValueLatitude = (data_.globalMaximumValueLatitude);
            a.globalMinimumValueLongitude = (data_.globalMinimumValueLongitude);
            a.globalMinimumValueLatitude = (data_.globalMinimumValueLatitude);
            let b = (data_.messageId.toString());
            if (!this.g.containsKey(b)) {
                return;
            }
            let c = this.g.item(b);
            let d = this.h.item(b);
            this.g.removeItem(b);
            this.h.removeItem(b);
            a.image = c.image;
            d(this, a);
        }
        x() {
            this.u();
            if (this.e && this._worker == null) {
                this.v();
            }
            if (!this.e && this._worker != null) {
                this._worker.terminate();
                this._worker.onmessage = null;
                this._worker = null;
            }
        }
        toDoubleArray(arr_) {
            return new Float64Array(arr_).buffer;
        }
        r(a, b, c) {
            this.j++;
            if (this.j >= 0x7FFFFFFF) {
                this.j = 1;
            }
            this.g.addItem(this.j.toString(), a);
            this.h.addItem(this.j.toString(), b);
            let messageId_ = this.j;
            let innerSettings_ = a.flatten();
            innerSettings_.messageId = messageId_;
            innerSettings_.transferableSupported = this._supportsTransferable;
            if (a.isNewData) {
                innerSettings_.latitudes = this.toDoubleArray(innerSettings_.latitudes);
                innerSettings_.longitudes = this.toDoubleArray(innerSettings_.longitudes);
                innerSettings_.values = this.toDoubleArray(innerSettings_.values);
            }
            else {
                innerSettings_.latitudes = null;
                innerSettings_.longitudes = null;
                innerSettings_.values = null;
            }
            if (this._supportsTransferable && a.isNewData) {
                this._worker.postMessage(innerSettings_, [innerSettings_.latitudes,
                    innerSettings_.longitudes,
                    innerSettings_.values]);
            }
            else {
                this._worker.postMessage(innerSettings_);
            }
        }
        t(z_, x_, y_) {
            let cancelMsg_ = {
                cancelTile: true,
                z: z_,
                x: x_,
                y: y_
            };
            this._worker.postMessage(cancelMsg_);
        }
        y(a, b, c) {
            this.x();
            if (this.e) {
                this.r(a, b, c);
            }
            else {
                this.q(a, b, c);
            }
        }
        aa() {
            if (this.i.c != null) {
                let a = this.i.c;
                this.i.h(a);
                let b = a.c.g;
                if (this.f.containsKey(b.z + "_" + b.x + "_" + b.y)) {
                    let c = this.f.item(b.z + "_" + b.x + "_" + b.y);
                    c.remove(a);
                    if (c.count == 0) {
                        this.f.removeItem(b.z + "_" + b.x + "_" + b.y);
                    }
                }
                a.c.doWork();
            }
            if (this.i.c != null) {
                window.setTimeout(() => this.aa(), 16);
            }
        }
        q(a, b, c) {
            {
                let d = new HeatTileGeneratorWorker(a);
                d.completedSink = new TileWorkCompletedSink(this, b);
                this.i.f(d);
                let e;
                let f = d.g.z + "_" + d.g.x + "_" + d.g.y;
                if (this.f.containsKey(f)) {
                    e = this.f.item(f);
                }
                else {
                    e = new List$1(LinkedListNode$1.$.specialize(HeatTileGeneratorWorker.$), 0);
                    this.f.addItem(f, e);
                }
                e.add(this.i.d);
                window.setTimeout(() => this.aa(), 16);
            }
        }
        w() {
            if (this._worker != null) {
                this._worker.terminate();
                this._worker = null;
            }
            this.g.clear();
            this.h.clear();
        }
        s(a, b, c) {
            this.x();
            if (this.e) {
                this.t(a, b, c);
            }
            else {
                if (this.f.containsKey(a + "_" + b + "_" + c)) {
                    let d = this.f.item(a + "_" + b + "_" + c);
                    for (let e = d.count - 1; e >= 0; e--) {
                        let f = d._inner[e];
                        if (f.c.g.testRun) {
                            continue;
                        }
                        d.removeAt(e);
                        let g = f.c;
                        this.i.h(f);
                        g.completedSink = null;
                    }
                }
            }
        }
    }
    HeatTileGeneratorWorkerManager.$t = /*@__PURE__*/ markType(HeatTileGeneratorWorkerManager, 'HeatTileGeneratorWorkerManager');
    return HeatTileGeneratorWorkerManager;
})();
/**
 * @hidden
 */
let TileWorkCompletedSink = /*@__PURE__*/ (() => {
    class TileWorkCompletedSink extends Base {
        constructor(a, b) {
            super();
            this.a = null;
            this.b = null;
            this.a = a;
            this.b = b;
        }
        onCompleted(a) {
            this.b(this.a, a);
        }
    }
    TileWorkCompletedSink.$t = /*@__PURE__*/ markType(TileWorkCompletedSink, 'TileWorkCompletedSink', Base.$, [ITileWorkCompletedSink_$type]);
    return TileWorkCompletedSink;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileImageZoomChangingEventArgs = /*@__PURE__*/ (() => {
    class TileImageZoomChangingEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._z = 0;
            this._x = 0;
            this._y = 0;
        }
        get z() {
            return this._z;
        }
        set z(a) {
            this._z = a;
        }
        get x() {
            return this._x;
        }
        set x(a) {
            this._x = a;
        }
        get y() {
            return this._y;
        }
        set y(a) {
            this._y = a;
        }
    }
    TileImageZoomChangingEventArgs.$t = /*@__PURE__*/ markType(TileImageZoomChangingEventArgs, 'TileImageZoomChangingEventArgs', EventArgs.$);
    return TileImageZoomChangingEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileGenerator = /*@__PURE__*/ (() => {
    class HeatTileGenerator extends Base {
        constructor() {
            super();
            this.m = new HeatTileScaler();
            this.bz = new Rect(0, 0, 0, 256, 256);
            this.l = new HeatTileGeneratorWorkerManager();
            this.e = null;
            this.d = null;
            this.c = null;
            this.bw = new Color();
            this.bv = new Color();
            this.b = null;
            this.a = null;
            this.ac = 0;
            this.am = NaN;
            this.p = false;
            this.q = false;
            this.r = false;
            this.ao = NaN;
            this.an = NaN;
            this.al = 10;
            this.s = false;
            this.t = true;
            this.a0 = null;
            this.ax = null;
            this.ad = NaN;
            this.ag = NaN;
            this.aw = {};
            this.au = -1;
            this.ay = {};
            this.ak = 0;
            this.aj = 0;
            this.z = new Dictionary$2(String_$type, Tuple$2.$.specialize(Number_$type, Number_$type), 0);
            this.aa = new Dictionary$2(String_$type, List$1.$.specialize(Delegate_$type), 0);
            this.ah = 0;
            this.ai = 0;
            this.ae = 0;
            this.af = 0;
            this.n = false;
            this.ab = new List$1(Delegate_$type, 0);
            this.o = false;
            this.m = new HeatTileScaler();
        }
        get k() {
            return this.e;
        }
        set k(a) {
            let b = this.e;
            this.e = a;
            if (this.e != b) {
                this.br("YValues", b, this.e);
            }
        }
        get j() {
            return this.d;
        }
        set j(a) {
            let b = this.d;
            this.d = a;
            if (this.d != b) {
                this.br("XValues", b, this.d);
            }
        }
        get i() {
            return this.c;
        }
        set i(a) {
            let b = this.c;
            this.c = a;
            if (this.c != b) {
                this.br("Values", b, this.c);
            }
        }
        get by() {
            return this.bw;
        }
        set by(a) {
            let b = this.bw;
            this.bw = a;
            if (Color.d(this.bw, b)) {
                this.br("MinimumColor", b, this.bw);
            }
        }
        get bx() {
            return this.bv;
        }
        set bx(a) {
            let b = this.bv;
            this.bv = a;
            if (Color.d(this.bv, b)) {
                this.br("MaximumColor", b, this.bv);
            }
        }
        get scaleColors() {
            return this.b;
        }
        set scaleColors(a) {
            let b = this.b;
            this.b = a;
            if (this.b != b) {
                this.br("ScaleColors", b, this.b);
            }
        }
        get g() {
            return this.a;
        }
        set g(a) {
            let b = this.a;
            this.a = a;
            if (this.a != b) {
                this.br("ScaleColorOffsets", b, this.a);
            }
        }
        get ap() {
            return this.ac;
        }
        set ap(a) {
            let b = this.ac;
            this.ac = a;
            if (this.ac != b) {
                this.br("BlurRadius", b, this.ac);
            }
        }
        get ar() {
            return this.am;
        }
        set ar(a) {
            let b = this.am;
            this.am = a;
            if (this.am != b) {
                this.br("MaxBlurRadius", b, this.am);
            }
        }
        get u() {
            return this.p;
        }
        set u(a) {
            let b = this.p;
            this.p = a;
            if (this.p != b) {
                this.br("UseBlurRadiusAdjustedForZoom", b, this.p);
            }
        }
        get v() {
            return this.q;
        }
        set v(a) {
            let b = this.q;
            this.q = a;
            if (this.q != b) {
                this.br("UseGlobalMinMax", b, this.q);
            }
        }
        get w() {
            return this.r;
        }
        set w(a) {
            let b = this.r;
            this.r = a;
            if (this.r != b) {
                this.br("UseGlobalMinMaxAdjustedForZoom", b, this.r);
            }
        }
        get at() {
            return this.ao;
        }
        set at(a) {
            let b = this.ao;
            this.ao = a;
            if (this.ao != b) {
                this.br("MinimumValue", b, this.ao);
            }
        }
        get as() {
            return this.an;
        }
        set as(a) {
            let b = this.an;
            this.an = a;
            if (this.an != b) {
                this.br("MaximumValue", b, this.an);
            }
        }
        get aq() {
            return this.al;
        }
        set aq(a) {
            let b = this.al;
            this.al = a;
            if (this.al != b) {
                this.br("LogarithmBase", b, this.al);
            }
        }
        get x() {
            return this.s;
        }
        set x(a) {
            let b = this.s;
            this.s = a;
            if (this.s != b) {
                this.br("UseLogarithmicScale", b, this.s);
            }
        }
        get y() {
            return this.t;
        }
        set y(a) {
            let b = this.t;
            this.t = a;
            if (this.t != b) {
                this.br("UseWebWorkers", b, this.t);
            }
        }
        get bi() {
            return this.a0;
        }
        set bi(a) {
            let b = this.a0;
            this.a0 = a;
            if (this.a0 != b) {
                this.br("WebWorkerScriptPath", b, this.a0);
            }
        }
        get az() {
            return this.ax;
        }
        set az(a) {
            let b = this.ax;
            this.ax = a;
            if (this.ax != b) {
                this.br("WebWorkerInstance", b, this.ax);
            }
        }
        bo() {
            this.e = null;
            this.d = null;
            this.c = null;
            this.l.w();
        }
        br(a, b, c) {
            this.bs(a, b, c);
        }
        bs(a, b, c) {
            switch (a) {
                case "XValues":
                case "YValues":
                case "Values":
                    this.bq();
                    break;
                case "UseWebWorkers":
                    this.l.e = this.y;
                    break;
                case "WebWorkerScriptPath":
                    this.l.p = this.bi;
                    break;
                case "WebWorkerInstance":
                    this.l.n = this.az;
                    break;
            }
        }
        getTile(a, b, c, d, e, f, g) {
            this.getTile1(a, b, c, d, e, f, g, false);
        }
        getTile1(a, b, c, d, e, f, g, h) {
            let i = NaN;
            let j = NaN;
            if (!h && this.v && (isNaN_(this.ag) || isNaN_(this.ad))) {
                let k = false;
                if ((isNaN_(this.ag) || isNaN_(this.ad)) && !this.n) {
                    k = true;
                    this.n = true;
                }
                else {
                    this.ab.add(() => this.bm(a, b, c, h, j, i, d, e, f, g));
                    return;
                }
                if (k) {
                    let l = 1.7976931348623157E+308;
                    let m = -1.7976931348623157E+308;
                    let n = 0;
                    let o = 0;
                    let p = 0;
                    let q = 0;
                    this.getTile1(0, 0, 0, (r, s) => {
                        let t = s;
                        l = t.globalMinimumValue;
                        m = t.globalMaximumValue;
                        n = t.globalMinimumValueLongitude;
                        o = t.globalMinimumValueLatitude;
                        p = t.globalMaximumValueLongitude;
                        q = t.globalMaximumValueLatitude;
                        let u = new Rect(0, 0, 0, 1, 1);
                        let v = this.bz;
                        i = l;
                        j = m;
                        let w = new List$1(Delegate_$type, 0);
                        this.ag = i;
                        this.ad = j;
                        this.ah = o;
                        this.ai = n;
                        this.ae = q;
                        this.af = p;
                        for (let x = 0; x < this.ab.count; x++) {
                            w.add(this.ab._inner[x]);
                        }
                        this.ab.clear();
                        this.bm(a, b, c, h, j, i, d, e, f, g);
                        for (let y = 0; y < w.count; y++) {
                            w._inner[y]();
                        }
                    }, (r, s) => {
                    }, (r, s) => {
                    }, g, true);
                    return;
                }
                else {
                    i = this.ag;
                    j = this.ad;
                }
            }
            else {
                i = this.ag;
                j = this.ad;
            }
            this.bm(a, b, c, h, j, i, d, e, f, g);
        }
        cancelTile(a, b, c) {
            this.l.s(a, b, c);
        }
        bm(a, b, c, d, e, f, g, h, i, j) {
            this.bn(a, b, c, d, i, () => {
                if (this.w && !d) {
                    if (a > 0 && this.z.containsKey(a.toString())) {
                        let k = this.z.item(a.toString());
                        e = k.c;
                        f = k.d;
                    }
                }
                let l = this.b0(a, b, c);
                let m = new TileWorkSettings();
                m.window = l;
                m.z = a;
                m.x = b;
                m.y = c;
                m.globalMinimum = f;
                m.globalMaximum = e;
                m.useGlobalMinMax = this.v;
                m.minimumValue = this.at;
                m.maximumValue = this.as;
                m.useLogarithmicScale = this.x;
                m.logarithmBase = this.aq;
                if (m.logarithmBase <= 0) {
                    m.logarithmBase = 10;
                }
                m.tileViewport = this.bz;
                m.maximumColor = this.bx;
                m.minimumColor = this.by;
                m.scaler = this.m;
                m.values = this.c;
                m.blurRadius = this.ap;
                if (m.blurRadius <= 0) {
                    m.blurRadius = 1;
                }
                m.useBlurRadiusAdjustedForZoom = this.u;
                m.maxBlurRadius = this.ar;
                if (m.maxBlurRadius <= 0) {
                    m.maxBlurRadius = 1;
                }
                m.values = this.i;
                m.scaleColors = this.scaleColors;
                m.scaleColorOffsets = this.g;
                m.minimumVisibleLatitude = this.m.i(l, this.bz);
                m.maximumVisibleLatitude = this.m.g(l, this.bz);
                m.minimumVisibleLongitude = this.m.j(l, this.bz);
                m.maximumVisibleLongitude = this.m.h(l, this.bz);
                m.yValues = this.e;
                m.xValues = this.d;
                if (this.c == null && this.e != null) {
                    this.c = new Array(this.e.length);
                    for (let n = 0; n < this.e.length; n++) {
                        this.c[n] = 1;
                    }
                    m.values = this.c;
                }
                if (!this.o) {
                    this.o = true;
                    m.isNewData = true;
                }
                m.image = j;
                m.testRun = d;
                this.l.y(m, (o, p) => {
                    p.url = this.a2(p.imageData);
                    p.imageData = this.f(p.imageData);
                    g(this, p);
                }, h);
            });
        }
        bn(a, b, c, d, e, f) {
            let g = false;
            g = this.au != a;
            if (!g || d) {
                f();
                return;
            }
            let h = false;
            let i = false;
            if (a != this.au) {
                if (this.z.containsKey(a.toString()) && !isNaN_(this.z.item(a.toString()).c) && !isNaN_(this.z.item(a.toString()).d)) {
                    this.au = a;
                    e(this, ((() => {
                        let $ret = new TileImageZoomChangingEventArgs();
                        $ret.z = a;
                        $ret.x = b;
                        $ret.y = c;
                        return $ret;
                    })()));
                    h = true;
                }
                else if (this.z.containsKey(a.toString())) {
                    if (a > 0 && this.w) {
                        let j;
                        if (this.aa.containsKey(a.toString())) {
                            j = this.aa.item(a.toString());
                        }
                        else {
                            j = new List$1(Delegate_$type, 0);
                            this.aa.addItem(a.toString(), j);
                        }
                        j.add(f);
                    }
                }
                else {
                    if (a > 0 && this.w) {
                        this.z.addItem(a.toString(), new Tuple$2(Number_$type, Number_$type, NaN, NaN));
                        i = true;
                    }
                }
            }
            if (i) {
                if (a > 0 && this.w) {
                    this.bt(a, f);
                }
            }
            if (h) {
                f();
            }
        }
        a2(a) {
            if (a == null) {
                return null;
            }
            let b = document.createElement("canvas");
            b.setAttribute("width", "256");
            b.setAttribute("height", "256");
            let c = b.getContext("2d");
            let d = c.getImageData(0, 0, 256, 256);
            let e = d.data;
            let f = e.length / 4;
            for (let g = 0; g < f; g++) {
                let h = a[g * 4];
                let i = a[g * 4 + 1];
                let j = a[g * 4 + 2];
                let k = a[g * 4 + 3];
                e[g * 4] = i;
                e[g * 4 + 1] = j;
                e[g * 4 + 2] = k;
                e[g * 4 + 3] = h;
            }
            c.putImageData(d, 0, 0);
            let ele_ = b;
            return (ele_.toDataURL());
        }
        f(a) {
            if (a == null) {
                return null;
            }
            return a;
        }
        bt(a, b) {
            let c = 0;
            let d = 0;
            let e = 0;
            let f = 0;
            let g = new Rect(0, 0, 0, 256 * Math.pow(2, a), 256 * Math.pow(2, a));
            let h = new Rect(0, 0, 0, 1, 1);
            let i = this.m.s(this.af, h, g);
            let j = this.m.r(this.ae, h, g);
            let k = this.m.s(this.ai, h, g);
            let l = this.m.r(this.ah, h, g);
            c = truncate(Math.floor(k / 256));
            d = truncate(Math.floor(l / 256));
            e = truncate(Math.floor(i / 256));
            f = truncate(Math.floor(j / 256));
            let m = 0;
            let n = 0;
            this.getTile1(a, c, d, (o, p) => {
                let q = p;
                m = q.globalMinimumValue;
                n = q.globalMaximumValue;
                if (e != c && f != d) {
                    this.getTile1(a, e, f, (r, s) => {
                        let t = s;
                        n = t.globalMaximumValue;
                        this.bu(a, n, m, b);
                    }, (r, s) => {
                    }, (r, s) => {
                    }, null, true);
                }
                else {
                    this.bu(a, n, m, b);
                }
            }, (o, p) => {
            }, (o, p) => {
            }, null, true);
        }
        bu(a, b, c, d) {
            if (b < this.aj) {
                b = this.aj;
            }
            if (isNaN_(c) || c > this.ak) {
                c = this.ak;
            }
            let e = new List$1(Delegate_$type, 0);
            this.z.item(a.toString(), new Tuple$2(Number_$type, Number_$type, b, c));
            if (this.aa.containsKey(a.toString())) {
                let f = this.aa.item(a.toString());
                for (let g = 0; g < f.count; g++) {
                    e.add(f._inner[g]);
                }
            }
            this.aa.removeItem(a.toString());
            this.au = a;
            d();
            for (let h = 0; h < e.count; h++) {
                e._inner[h]();
            }
        }
        b0(a, b, c) {
            let d = truncate(Math.pow(2, a)) * 256;
            let e = (b * 256) / d;
            let f = (c * 256) / d;
            let g = 256 / d;
            let h = 256 / d;
            return new Rect(0, e, f, g, h);
        }
        bq() {
            let a = -1.7976931348623157E+308;
            let b = 1.7976931348623157E+308;
            if (this.c != null) {
                for (let c = 0; c < this.c.length; c++) {
                    let d = this.c[c];
                    a = d > a ? d : a;
                    b = d < b ? d : b;
                }
            }
            let e = this.ak = b * 0.01;
            this.aj = a;
            this.o = false;
        }
    }
    HeatTileGenerator.$t = /*@__PURE__*/ markType(HeatTileGenerator, 'HeatTileGenerator', Base.$, [ITileGenerator_$type]);
    return HeatTileGenerator;
})();

class IgrHeatTileGenerator {
    createImplementation() {
        return new HeatTileGenerator();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get scaleColors() {
        if (this.i.scaleColors == null) {
            return null;
        }
        let c = [];
        for (let i = 0; i < this.i.scaleColors.length; i++) {
            c.push(colorToString(this.i.scaleColors[i]));
        }
        return c;
    }
    set scaleColors(v) {
        if (v == null) {
            this.i.scaleColors = null;
            return;
        }
        let c = [];
        for (let i = 0; i < v.length; i++) {
            c.push(stringToColor(v[i]));
        }
        this.i.scaleColors = c;
    }
    get yValues() {
        return this.i.k;
    }
    set yValues(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.k = v;
    }
    get xValues() {
        return this.i.j;
    }
    set xValues(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.j = v;
    }
    get values() {
        return this.i.i;
    }
    set values(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.i = v;
    }
    get minimumColor() {
        return colorToString(this.i.by);
    }
    set minimumColor(v) {
        this.i.by = stringToColor(v);
    }
    get maximumColor() {
        return colorToString(this.i.bx);
    }
    set maximumColor(v) {
        this.i.bx = stringToColor(v);
    }
    get scaleColorOffsets() {
        return this.i.g;
    }
    set scaleColorOffsets(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.g = v;
    }
    get blurRadius() {
        return this.i.ap;
    }
    set blurRadius(v) {
        this.i.ap = +v;
    }
    get maxBlurRadius() {
        return this.i.ar;
    }
    set maxBlurRadius(v) {
        this.i.ar = +v;
    }
    get useBlurRadiusAdjustedForZoom() {
        return this.i.u;
    }
    set useBlurRadiusAdjustedForZoom(v) {
        this.i.u = ensureBool(v);
    }
    get useGlobalMinMax() {
        return this.i.v;
    }
    set useGlobalMinMax(v) {
        this.i.v = ensureBool(v);
    }
    get useGlobalMinMaxAdjustedForZoom() {
        return this.i.w;
    }
    set useGlobalMinMaxAdjustedForZoom(v) {
        this.i.w = ensureBool(v);
    }
    get minimumValue() {
        return this.i.at;
    }
    set minimumValue(v) {
        this.i.at = +v;
    }
    get maximumValue() {
        return this.i.as;
    }
    set maximumValue(v) {
        this.i.as = +v;
    }
    get logarithmBase() {
        return this.i.aq;
    }
    set logarithmBase(v) {
        this.i.aq = +v;
    }
    get useLogarithmicScale() {
        return this.i.x;
    }
    set useLogarithmicScale(v) {
        this.i.x = ensureBool(v);
    }
    get useWebWorkers() {
        return this.i.y;
    }
    set useWebWorkers(v) {
        this.i.y = ensureBool(v);
    }
    get webWorkerScriptPath() {
        return this.i.bi;
    }
    set webWorkerScriptPath(v) {
        this.i.bi = v;
    }
    get webWorkerInstance() {
        return this.i.az;
    }
    set webWorkerInstance(v) {
        this.i.az = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    destroy() {
        this.i.bo();
    }
    getTile(z, x, y, onCreated, onCreating, zoomChanging, existingImage) {
        this.i.getTile(z, x, y, onCreated, onCreating, zoomChanging, existingImage);
    }
    cancelTile(z, x, y) {
        this.i.cancelTile(z, x, y);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrShapeDataSourceModule {
    static register() {
        TypeRegistrar.registerCons('IgrShapeDataSource', IgrShapeDataSource);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrHeatTileGeneratorModule {
    static register() {
        TypeRegistrar.registerCons('IgrHeatTileGenerator', IgrHeatTileGenerator);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileGeneratorWebWorker = /*@__PURE__*/ (() => {
    class HeatTileGeneratorWebWorker extends Base {
        static get postmessage() {
            return HeatTileGeneratorWebWorker._postmessage;
        }
        static set postmessage(a) {
            HeatTileGeneratorWebWorker._postmessage = a;
        }
        static onmessage(args_) {
            let data_ = args_.data;
            let a = (data_.cancelTile);
            let b = (data_.z);
            let c = (data_.y);
            let d = (data_.x);
            if (a) {
                for (let i_ = 0; i_ < HeatTileGeneratorWebWorker.b.length; i_++) {
                    let e = HeatTileGeneratorWebWorker.b[i_];
                    if (e.g.testRun) {
                        continue;
                    }
                    if (e.g.z == b && e.g.x == d && e.g.y == c) {
                        let workers_ = HeatTileGeneratorWebWorker.b;
                        workers_.splice(i_, 1);
                        i_--;
                    }
                }
            }
            let f = new TileWorkSettings();
            let g = data_;
            if (!g["messageId"]) {
                return;
            }
            if (g["isNewData"]) {
                let yValues_ = g["yValues"];
                let xValues_ = g["xValues"];
                let values_ = g["values"];
                HeatTileGeneratorWebWorker._yValues = (new Float64Array(yValues_));
                HeatTileGeneratorWebWorker._xValues = (new Float64Array(xValues_));
                HeatTileGeneratorWebWorker._values = (new Float64Array(values_));
            }
            let h = g["scaleColors"];
            let i = new Array(h.length);
            for (let j = 0; j < h.length; j++) {
                i[j] = Color.u(typeGetValue(h[j]["a"]), typeGetValue(h[j]["r"]), typeGetValue(h[j]["g"]), typeGetValue(h[j]["b"]));
            }
            f.scaler = HeatTileGeneratorWebWorker.e;
            f.blurRadius = g["blurRadius"];
            f.maxBlurRadius = g["maxBlurRadius"];
            f.useBlurRadiusAdjustedForZoom = (g["useBlurRadiusAdjustedForZoom"]);
            f.minimumColor = Color.u(typeGetValue(g["minimumColor"]["a"]), typeGetValue(g["minimumColor"]["r"]), typeGetValue(g["minimumColor"]["g"]), typeGetValue(g["minimumColor"]["b"]));
            f.maximumColor = Color.u(typeGetValue(g["maximumColor"]["a"]), typeGetValue(g["maximumColor"]["r"]), typeGetValue(g["maximumColor"]["g"]), typeGetValue(g["maximumColor"]["b"]));
            f.tileViewport = new Rect(0, g["tileViewport"]["left"], g["tileViewport"]["top"], g["tileViewport"]["width"], g["tileViewport"]["height"]);
            f.yValues = HeatTileGeneratorWebWorker._yValues;
            f.xValues = HeatTileGeneratorWebWorker._xValues;
            f.values = HeatTileGeneratorWebWorker._values;
            f.minimumVisibleLatitude = g["minimumVisibleLatitude"];
            f.minimumVisibleLongitude = g["minimumVisibleLongitude"];
            f.maximumVisibleLatitude = g["maximumVisibleLatitude"];
            f.maximumVisibleLongitude = g["maximumVisibleLongitude"];
            f.z = typeGetValue(g["z"]);
            f.x = typeGetValue(g["x"]);
            f.y = typeGetValue(g["y"]);
            f.window = new Rect(0, g["window"]["left"], g["window"]["top"], g["window"]["width"], g["window"]["height"]);
            f.testRun = g["testRun"];
            f.globalMinimum = g["globalMinimum"];
            f.globalMaximum = g["globalMaximum"];
            f.useGlobalMinMax = g["useGlobalMinMax"];
            f.minimumValue = g["minimumValue"];
            f.maximumValue = g["maximumValue"];
            f.scaleColorOffsets = g["scaleColorOffsets"];
            f.scaleColors = i;
            f.useLogarithmicScale = g["useLogarithmicScale"];
            f.logarithmBase = g["logarithmBase"];
            let k = new HeatTileGeneratorWorker(f);
            k.u = typeGetValue(g["messageId"]);
            k.h = true;
            k.completedSink = new CompletedSinkImpl(k);
            let workersl_ = HeatTileGeneratorWebWorker.b;
            let worker_ = k;
            workersl_.push(worker_);
        }
        static start() {
            let workers_ = HeatTileGeneratorWebWorker.b;
            setInterval(function () {
                if (workers_.length > 0) {
                    var worker = workers_.shift();
                    worker.doWork();
                    worker.completedSink = null;
                }
            }, 16);
            ;
        }
    }
    HeatTileGeneratorWebWorker.$t = /*@__PURE__*/ markType(HeatTileGeneratorWebWorker, 'HeatTileGeneratorWebWorker');
    HeatTileGeneratorWebWorker.e = /*@__PURE__*/ new HeatTileScaler();
    HeatTileGeneratorWebWorker.b = [];
    HeatTileGeneratorWebWorker._postmessage = null;
    HeatTileGeneratorWebWorker._yValues = null;
    HeatTileGeneratorWebWorker._xValues = null;
    HeatTileGeneratorWebWorker._values = null;
    return HeatTileGeneratorWebWorker;
})();
/**
 * @hidden
 */
let CompletedSinkImpl = /*@__PURE__*/ (() => {
    class CompletedSinkImpl extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        onCompleted(a) {
            let b = a;
            let c = {};
            let imageData_ = b.imageData;
            c["messageId"] = this.a.u;
            c["imageData"] = (b.imageData == null ? null : (new Uint8ClampedArray(imageData_))["buffer"]);
            c["z"] = b.z;
            c["x"] = b.x;
            c["y"] = b.y;
            c["url"] = b.url;
            c["globalMinimumValue"] = b.globalMinimumValue;
            c["globalMaximumValue"] = b.globalMaximumValue;
            c["globalMaximumValueLongitude"] = b.globalMaximumValueLongitude;
            c["globalMaximumValueLatitude"] = b.globalMaximumValueLatitude;
            c["globalMinimumValueLongitude"] = b.globalMinimumValueLongitude;
            c["globalMinimumValueLatitude"] = b.globalMinimumValueLatitude;
            if (this.a.h && c["imageData"] != null) {
                HeatTileGeneratorWebWorker.postmessage(c, [c["imageData"]]);
            }
            else {
                HeatTileGeneratorWebWorker.postmessage(c);
            }
        }
    }
    CompletedSinkImpl.$t = /*@__PURE__*/ markType(CompletedSinkImpl, 'CompletedSinkImpl', Base.$, [ITileWorkCompletedSink_$type]);
    return CompletedSinkImpl;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Image = /*@__PURE__*/ (() => {
    class Image extends FrameworkElement {
        constructor() {
            super(...arguments);
            this.ac = null;
            this.ab = false;
        }
    }
    Image.$t = /*@__PURE__*/ markType(Image, 'Image', FrameworkElement.$);
    return Image;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Tile = /*@__PURE__*/ (() => {
    class Tile extends Base {
        constructor() {
            super(...arguments);
            this.d = 0;
            this.e = 0;
            this.f = 0;
            this.c = 0;
            this.i = null;
            this.h = null;
            this.b = new Date();
            this.a = false;
            this.g = null;
        }
        get j() {
            let a = Math.pow(2, -this.f);
            let b = Math.pow(2, -this.f);
            return new Rect(0, this.d * a, this.e * b, a, b);
        }
    }
    Tile.$t = /*@__PURE__*/ markType(Tile, 'Tile');
    return Tile;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WriteableBitmap = /*@__PURE__*/ (() => {
    class WriteableBitmap extends Base {
        constructor(a, b) {
            super();
            this.b = 0;
            this.a = 0;
            this.c = null;
            this.d = null;
            this.b = a;
            this.a = b;
            this.d = Rect.empty;
        }
    }
    WriteableBitmap.$t = /*@__PURE__*/ markType(WriteableBitmap, 'WriteableBitmap');
    return WriteableBitmap;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CancellingMultiScaleImageEventArgs = /*@__PURE__*/ (() => {
    class CancellingMultiScaleImageEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._uri = null;
            this._image = null;
        }
        get uri() {
            return this._uri;
        }
        set uri(a) {
            this._uri = a;
        }
        get image() {
            return this._image;
        }
        set image(a) {
            this._image = a;
        }
    }
    CancellingMultiScaleImageEventArgs.$t = /*@__PURE__*/ markType(CancellingMultiScaleImageEventArgs, 'CancellingMultiScaleImageEventArgs', EventArgs.$);
    return CancellingMultiScaleImageEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IEasingFunction_$type = /*@__PURE__*/ new Type(null, 'IEasingFunction');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TilePositionComparer = /*@__PURE__*/ (() => {
    class TilePositionComparer extends Base {
        equalsC(a, b) {
            return a.d == b.d && a.e == b.e && a.f == b.f;
        }
        getHashCodeC(a) {
            let b = 23;
            b = b * 31 + a.d;
            b = b * 31 + a.e;
            b = b * 31 + a.f;
            return b;
        }
    }
    TilePositionComparer.$t = /*@__PURE__*/ markType(TilePositionComparer, 'TilePositionComparer', Base.$, [/*@__PURE__*/ IEqualityComparer$1_$type.specialize(Tile.$)]);
    return TilePositionComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XamMultiScaleImageView = /*@__PURE__*/ (() => {
    class XamMultiScaleImageView extends Base {
        constructor(a) {
            super();
            this.b = null;
            this.h = null;
            this.g = new Dictionary$2(Base.$, List$1.$.specialize(Delegate_$type), 0);
            this.j = new List$1(Tile.$, 0);
            this.i = new List$1(Tile.$, 0);
            this.p = -1;
            this.o = -1;
            this.k = null;
            this.m = null;
            this.c = null;
            this._isDirty = false;
            this.au = Rect.empty;
            this.l = null;
            this.b = a;
            this.b.ag.o(this);
            this.h = new List$1(Image.$, 0);
            this.b.ap = ((() => {
                let $ret = new StackPool$1(Image.$);
                $ret.j = runOn(this, this.at);
                $ret.b = runOn(this, this.y);
                $ret.c = runOn(this, this.aa);
                $ret.d = runOn(this, this.z);
                return $ret;
            })());
            for (let b = 0; b < 4; ++b) {
                this.i.add(null);
            }
        }
        at() {
            return new Image();
        }
        y(a) {
            this.h.add(a);
        }
        aa(a) {
            this.h.remove(a);
        }
        z(a) {
        }
        ao(a, b, c) {
            a.n = b;
            a.o = c;
        }
        r(a) {
            for (let b = 0; b < this.i.count; ++b) {
                if (a == this.i._inner[b]) {
                    if (a.i != null && a.i.ac != null) {
                        let c = a.i.ac;
                        let d = c.c;
                        let e = this.b.ao.w(a.f + 8, a.d, a.e);
                        if (e != null) {
                            let f = ((() => {
                                let $ret = new CancellingMultiScaleImageEventArgs();
                                $ret.uri = e.value;
                                $ret.image = d;
                                return $ret;
                            })());
                            this.b.bu(f);
                        }
                        if (this.g.containsKey(d)) {
                            let g = this.g.item(d);
                            for (let h = 0; h < g.count; h++) {
                                g._inner[h]();
                            }
                            g.clear();
                            this.g.removeItem(d);
                        }
                    }
                    this.i._inner[b] = null;
                    this.q();
                    return;
                }
            }
            for (let i = 0; i < this.j.count; ++i) {
                if (this.j._inner[i] == a) {
                    this.j.removeAt(i);
                    break;
                }
            }
        }
        u(a) {
            this.j.add(a);
            this.j.aa((b, c) => {
                let d = 0;
                let e = 0;
                if (b.h != null) {
                    d = b.h.ac.b;
                }
                if (c.h != null) {
                    e = c.h.ac.b;
                }
                if (d < e) {
                    return -1;
                }
                else if (d > e) {
                    return 1;
                }
                return 0;
            });
            this.q();
        }
        q() {
            let index_ = -1;
            if (this.l == null) {
                return;
            }
            if (this.j.count > 0) {
                for (let a = 0; a < this.i.count; ++a) {
                    if (this.i._inner[a] == null) {
                        index_ = a;
                        break;
                    }
                }
            }
            if (index_ >= 0) {
                this.i._inner[index_] = this.j._inner[0];
                let b = new WriteableBitmap(this.b.ao.r, this.b.ao.p);
                this.i._inner[index_].i.ac = b;
                let ele_ = this.l.createElement("img");
                let c = ele_.getNativeElement();
                b.c = c;
                let self_ = this;
                let d = new List$1(Delegate_$type, 0);
                this.g.addItem(c, d);
                d.add(ele_.listen("load", (e) => this.ab(e, index_)));
                d.add(ele_.listen("readystatechange", (e) => this.ab(e, index_)));
                d.add(ele_.listen("error", (e) => this.ac(e, index_)));
                this.j.removeAt(0);
                let e = this.b.ao.w(this.i._inner[index_].f + 8, this.i._inner[index_].d, this.i._inner[index_].e);
                if (e == null) {
                    return;
                }
                let f = e.value;
                let g = ((() => {
                    let $ret = new DownloadingMultiScaleImageEventArgs();
                    $ret.uri = f;
                    $ret.image = c;
                    return $ret;
                })());
                this.b.bv(g);
                f = g.uri;
                if (f != null) {
                    c.src = f;
                }
            }
        }
        ab(a, b) {
            let e_ = a.originalEvent;
            let img_ = (e_.target);
            let c = (img_.complete || (img_.readyState == 'complete' && e_.type == 'readystatechange'));
            if (c) {
                this.downloadCompleted(a, b);
            }
        }
        ac(a, b) {
            this.downloadError(a, b);
        }
        downloadError(a, b) {
            let c = this.i._inner[b];
            this.i._inner[b] = null;
            if (c != null && c.i != null && c.i.ac != null) {
                let e_ = a.originalEvent;
                let d = (e_.target);
                if (this.g.containsKey(d)) {
                    let e = this.g.item(d);
                    for (let f = 0; f < e.count; f++) {
                        e._inner[f]();
                    }
                    e.clear();
                    this.g.removeItem(d);
                }
            }
            this.q();
            this.ad();
        }
        downloadCompleted(a, b) {
            let c = this.i._inner[b];
            let d = true;
            if (c != null && c.i != null && c.i.ac != null) {
                d = false;
                let ele_ = c.i.ac.c;
                if (!ele_.complete) {
                    d = true;
                }
                if ((ele_.width == 0 && ele_.height == 0)) {
                    d = true;
                }
            }
            this.i._inner[b] = null;
            if (d) {
                this.q();
                this.ad();
                return;
            }
            let e_ = a.originalEvent;
            let e = (e_.target);
            if (this.g.containsKey(e)) {
                let f = this.g.item(e);
                for (let g = 0; g < f.count; g++) {
                    f._inner[g]();
                }
                f.clear();
                this.g.removeItem(e);
            }
            this.b.bo(c, c.i.ac);
            if (c.i != null) {
                this.b.ca(c);
            }
            this.q();
            this.ad();
        }
        a(a, b, c, d) {
            let e = new WriteableBitmap(a, a);
            e.c = b.c;
            if (!b.d.isEmpty) {
                c += truncate(Math.round(b.d.left));
                d += truncate(Math.round(b.d.top));
            }
            e.d = new Rect(0, c, d, a, a);
            return e;
        }
        am(a) {
            a.s = 0;
        }
        an(a) {
            a.s = 1;
        }
        f() {
            return true;
        }
        s(a) {
            if (this.b.al != null) {
                this.b.al.deferredRefresh();
            }
            else {
                if (this.k != null) {
                    this.k.setTimeout(a, 0);
                }
                else {
                    window.setTimeout(a, 0);
                }
            }
        }
        aq() {
            if (this.p == -1) {
                this.p = window.setInterval(runOn(this.b, this.b.b9), 50);
            }
        }
        as() {
            if (this.p != -1) {
                window.clearInterval(this.p);
                this.p = -1;
            }
        }
        ap() {
            if (this.o == -1) {
                this.o = window.setInterval(runOn(this.b, this.b.br), 50);
            }
        }
        ar() {
            if (this.o != -1) {
                window.clearInterval(this.o);
                this.o = -1;
            }
        }
        t() {
            if (this.p != -1) {
                this.ar();
                this.b.by();
            }
        }
        ae(a) {
            this.k = a;
            this.k.rootWrapper.setStyleProperty("position", "relative");
            this.m = this.k.createElement("canvas");
            this.m.setStyleProperty("position", "absolute");
            this.m.setStyleProperty("top", "0px");
            this.m.setStyleProperty("left", "0px");
            this.k.append(this.m);
            this.c = new RenderingContext(new CanvasViewRenderer(), this.k.get2DCanvasContext(this.m));
            this.af(this.k.rootWrapper.width(), this.k.rootWrapper.height());
        }
        af(a, b) {
            this.m.setAttribute("width", truncate((a * this.b.a4)).toString());
            this.m.setAttribute("height", truncate((b * this.b.a4)).toString());
            this.m.setStyleProperty("width", a.toString() + "px");
            this.m.setStyleProperty("height", b.toString() + "px");
            this.b.cn = new Rect(0, 0, 0, a, b);
            this.b.b5();
        }
        aj() {
            this.ad();
        }
        get index() {
            return 0;
        }
        postRender() {
        }
        get isDirty() {
            return this._isDirty;
        }
        set isDirty(a) {
            this._isDirty = a;
        }
        ad() {
            if (this.c == null) {
                return;
            }
            if (!this.isDirty) {
                this.isDirty = true;
                this.b.ag.q();
            }
        }
        undirty(a) {
            this.isDirty = false;
            this.ak();
        }
        ak() {
            if (this.c == null) {
                return;
            }
            if (this.c.d && this.b.a4 != 1) {
                this.c.aa();
                this.c.ab(this.b.a4, this.b.a4);
            }
            if (!this.au.isEmpty) {
                this.c.l(this.au.left, this.au.top, this.au.width, this.au.height);
            }
            this.au = this.b.cn;
            for (let a = 0; a < this.h.count; a++) {
                let b = this.h._inner[a];
                if (b.s == 0) {
                    this.al(b);
                }
            }
            for (let c = 0; c < this.h.count; c++) {
                let d = this.h._inner[c];
                if (d.s == 1) {
                    this.al(d);
                }
            }
            if (this.c.d && this.b.a4 != 1) {
                this.c.z();
            }
            this.b.bt();
            this.b.bw();
        }
        d() {
            let a = true;
            for (let b = 0; b < this.i.count; b++) {
                if (this.i._inner[b] != null) {
                    a = false;
                }
            }
            return a;
        }
        al(a) {
            if (this.c == null) {
                return;
            }
            let b = a.ac;
            let c = a._opacity * this.b._opacity;
            if (b == null || b.c == null) {
                return;
            }
            if (this.e(b.c)) {
                return;
            }
            if (!b.d.isEmpty) {
                if (b.d.width < 1 || b.d.height < 1) {
                    return;
                }
                this.c.o(b.c, c, b.d.left, b.d.top, b.d.width, b.d.height, Math.round(a.n + this.b.cn.left), Math.round(a.o + this.b.cn.top), a.width, a.height);
            }
            else {
                this.c.n(b.c, c, Math.round(a.n + this.b.cn.left), Math.round(a.o + this.b.cn.top), a.width, a.height);
            }
        }
        e(a) {
            let img_ = a;
            if (!img_.complete) {
                return true;
            }
            if ((img_.width == 0 && img_.height == 0)) {
                return true;
            }
            return false;
        }
        x() {
            this.ad();
        }
        ag(a) {
            this.c = a;
            this.ad();
        }
        ah(a) {
            this.l = a;
            this.q();
        }
        ai(a) {
            this.b.cn = a;
            this.b.b5();
        }
        preRender() {
        }
        isValid() {
            return true;
        }
    }
    XamMultiScaleImageView.$t = /*@__PURE__*/ markType(XamMultiScaleImageView, 'XamMultiScaleImageView', Base.$, [ISchedulableRender_$type]);
    return XamMultiScaleImageView;
})();
/**
 * @hidden
 */
let XamMultiScaleTileSource = /*@__PURE__*/ (() => {
    class XamMultiScaleTileSource extends DependencyObject {
        constructor(a, b, c, d, e) {
            super();
            this.t = 0;
            this.s = 0;
            this.n = 1;
            this.l = false;
            this.r = 0;
            this.p = 0;
            this.q = 0;
            this.j = null;
            this.t = a;
            this.s = b;
            this.r = c;
            this.p = d;
            this.q = e;
        }
        get v() {
            return this.t;
        }
        set v(a) {
            this.t = a;
            this.y(0, 0, 0, 0);
        }
        get u() {
            return this.s;
        }
        set u(a) {
            this.s = a;
            this.y(0, 0, 0, 0);
        }
        get o() {
            return this.n;
        }
        set o(a) {
            this.n = a;
            if (this.k != null) {
                this.k._opacity = this.n;
            }
        }
        get m() {
            return this.l;
        }
        set m(a) {
            this.l = a;
            if (this.k != null) {
                this.k.av = this.l;
            }
        }
        get k() {
            return this.j;
        }
        set k(a) {
            this.j = a;
            if (this.j != null) {
                this.j._opacity = this.o;
            }
        }
        w(a, b, c) {
            let d = new List$1(Base.$, 0);
            this.x(a, b, c, d);
            let e = null;
            if (d.count > 0) {
                e = typeCast(Uri.$, d._inner[0]);
            }
            return e;
        }
        y(a, b, c, d) {
            if (this.k != null) {
                this.k.bs(a, b, c, d);
            }
        }
    }
    XamMultiScaleTileSource.$t = /*@__PURE__*/ markType(XamMultiScaleTileSource, 'XamMultiScaleTileSource', DependencyObject.$);
    return XamMultiScaleTileSource;
})();
/**
 * @hidden
 */
let XamMultiScaleImage = /*@__PURE__*/ (() => {
    class XamMultiScaleImage extends Control {
        constructor() {
            super();
            this.ap = null;
            this.an = null;
            this.ak = null;
            this.ck = null;
            this.a2 = 0;
            this.at = false;
            this.propertyChanged = null;
            this.ba = 0;
            this.bb = 0;
            this.a0 = new Date();
            this.cl = null;
            this.a3 = 0;
            this.ay = new List$1(Tile.$, 0);
            this.aw = false;
            this.aq = new LRUCache$2(Tile.$, WriteableBitmap.$, 1, 0x7FFFFFFF, new TilePositionComparer());
            this.az = new List$1(Tile.$, 0);
            this.imageTilesReady = null;
            this.as = false;
            this.cn = null;
            this.ag = null;
            this.imagesChanged = null;
            this.downloadingImage = null;
            this.cancellingImage = null;
            this.a1 = 1;
            this.cn = Rect.empty;
            this.ag = new CanvasRenderScheduler();
            this.an = new XamMultiScaleImageView(this);
            this.ab = XamMultiScaleImage.$;
            this.ck = this.cm;
            this.a2 = this.a5;
        }
        get al() {
            return this.ak;
        }
        set al(a) {
            if (this.ak != null) {
                this.ak.unRegister(this);
            }
            this.ak = a;
            if (this.ak != null) {
                this.ak.register(this, runOn(this, this.b6));
            }
        }
        bc() {
            if (!stringIsNullOrEmpty(this.bf)) {
                return this.bf;
            }
            return null;
        }
        bd() {
            if (!stringIsNullOrEmpty(this.bj)) {
                return this.bj;
            }
            return null;
        }
        bx(a, b, c) {
            let d = new PropertyChangedEventArgs(a);
            if (this.propertyChanged != null) {
                this.propertyChanged(this, d);
            }
            switch (a) {
                case XamMultiScaleImage.$$p[2]:
                    if (this.ao != null) {
                        this.ao.k = this;
                    }
                    this.b4();
                    this.b7();
                    this.b5();
                    break;
                case XamMultiScaleImage.$$p[6]:
                    this.b8();
                    break;
                case XamMultiScaleImage.$$p[7]:
                    this.b8();
                    break;
                case XamMultiScaleImage.$$p[4]:
                    if (!this.ax) {
                        this.an.t();
                    }
                    break;
                case XamMultiScaleImage.$$p[0]:
                    this.at = this.av;
                    this.b5();
                    break;
            }
        }
        v() {
            super.v();
            this.b5();
        }
        b7() {
            this.cb();
            if (this.ao != null) {
                this.ba = Convert.toInt32(logBase(this.ao.r, 2));
                this.bb = Convert.toInt32(logBase(this.ao.v, 2));
            }
        }
        bs(a, b, c, d) {
            this.b4();
            this.b7();
            this.b5();
        }
        b8() {
            if (this.ax) {
                this.a0 = dateNow();
                this.cl = this.ck;
                this.a3 = this.a2;
                this.an.aq();
            }
            else {
                this.ck = this.cm;
                this.a2 = this.a5;
                this.b5();
            }
        }
        b9() {
            let a = 2;
            let b = dateNow().getTime() - this.a0.getTime();
            let c = b / 1000;
            let d = MathUtil.d((c) / a, 0, 1);
            let e = this.aj != null ? this.aj.ease(d) : d;
            let f = 1 - e;
            this.a2 = this.a3 * f + this.a5 * e;
            this.ck = { $type: Point_$type, x: this.cl.x * f + this.cm.x * e, y: this.cl.y * f + this.cm.y * e };
            if (d >= 1) {
                this.an.as();
            }
            else {
            }
            this.b5();
        }
        a8(a, b, c, d) {
            for (let e = 0; e < this.ay.count; ++e) {
                if (this.ay._inner[e].c == a && this.ay._inner[e].d == b && this.ay._inner[e].e == c && this.ay._inner[e].f == d) {
                    return e;
                }
            }
            return -1;
        }
        b6(a) {
            this.aw = false;
            this.as = false;
            let b = this.at;
            if (this.ao == null || !this.an.f() || this.cn.width == 0 || this.cn.height == 0) {
                return;
            }
            let c = truncate(Math.ceil(this.cn.width / this.ao.r));
            let d = truncate(Math.max(1, Math.floor(-logBase(this.a2 / c, 2))));
            if (d >= this.bb - 8) {
                d = (this.bb - 8) - 1;
            }
            let e = truncate(Math.round(Math.pow(2, d)));
            let f = this.a2;
            let g = this.cn.height * f / this.cn.width;
            let h = this.ao.v / Math.pow(2, d);
            let i = this.ao.u / Math.pow(2, d);
            let j = truncate(Math.floor((this.ck.x * this.ao.v) / h));
            let k = truncate(Math.ceil(((this.ck.x + f) * this.ao.v) / h));
            let l = truncate(Math.floor((this.ck.y * this.ao.u) / i));
            let m = truncate(Math.ceil(((this.ck.y + g) * this.ao.v) / i));
            if (!b) {
                j = Math.max(j, 0);
                k = Math.min(k, e);
            }
            l = Math.max(l, 0);
            m = Math.min(m, e);
            let n = ((j * h) - (this.ck.x * this.ao.v)) / h;
            let o = ((l * i) - (this.ck.y * this.ao.u)) / i;
            let p = (f * this.ao.v / h) * (this.ao.r / this.cn.width);
            let q = new List$1(Tile.$, 0);
            let r;
            let s;
            for (let t = j; t < k; ++t) {
                r = t;
                s = t;
                while (s < 0) {
                    s = e + s;
                }
                while (s > e - 1) {
                    s = (s - e);
                }
                for (let u = l; u < m; ++u) {
                    let v = this.a8(r, s, u, d);
                    if (v >= 0) {
                        q.add(this.ay._inner[v]);
                        this.ay.removeAt(v);
                    }
                    else {
                        q.add(((() => {
                            let $ret = new Tile();
                            $ret.c = r;
                            $ret.d = s;
                            $ret.e = u;
                            $ret.f = d;
                            return $ret;
                        })()));
                    }
                }
            }
            this.ap.f = true;
            this.cb();
            this.ay = q;
            for (let w = 0; w < this.ay.count; ++w) {
                if (this.ay._inner[w].i == null) {
                    this.ay._inner[w].i = this.ap.a();
                    this.ay._inner[w].i._opacity = 1;
                    this.an.am(this.ay._inner[w].i);
                    let x = this.am(this.ay._inner[w]);
                    if (x != null) {
                        this.ay._inner[w].i.ac = x;
                    }
                    else {
                        let y = null;
                        let z = ((() => {
                            let $ret = new Tile();
                            $ret.d = this.ay._inner[w].d;
                            $ret.e = this.ay._inner[w].e;
                            $ret.f = this.ay._inner[w].f;
                            return $ret;
                        })());
                        while (z.f >= 0 && y == null) {
                            z.d = z.d >> 1;
                            z.e = z.e >> 1;
                            z.f = z.f - 1;
                            y = this.am(z);
                        }
                        if (y != null) {
                            let aa = truncate(Math.pow(2, this.ay._inner[w].f - z.f));
                            let ab = intDivide(256, aa);
                            let ac = ab * (this.ay._inner[w].d % aa);
                            let ad = ab * (this.ay._inner[w].e % aa);
                            this.ay._inner[w].h = this.ap.a();
                            this.ay._inner[w].h._opacity = 1;
                            this.an.an(this.ay._inner[w].h);
                            x = this.an.a(ab, y, ac, ad);
                            this.ay._inner[w].h.ac = x;
                        }
                        this.an.u(this.ay._inner[w]);
                    }
                }
                let ae = this.ao.r / p;
                let af = this.ao.p / p;
                let ag = (this.ay._inner[w].c - j + n) * ae;
                let ah = (this.ay._inner[w].e - l + o) * af;
                this.ay._inner[w].i.width = ae + 0.5;
                this.ay._inner[w].i.height = af + 0.5;
                this.an.ao(this.ay._inner[w].i, ag, ah);
                if (this.ay._inner[w].h != null) {
                    this.ay._inner[w].h.width = ae + 0.5;
                    this.ay._inner[w].h.height = af + 0.5;
                    this.an.ao(this.ay._inner[w].h, ag, ah);
                }
            }
            this.ap.f = false;
            this.an.aj();
        }
        b5() {
            if (this.ao == null || !this.an.f() || this.cn.width == 0 || this.cn.height == 0) {
                return;
            }
            if (this.aw) {
                return;
            }
            this.aw = true;
            this.an.s(runOn(this, this.b6));
        }
        cb() {
            for (let a = 0; a < this.ay.count; ++a) {
                this.an.r(this.ay._inner[a]);
                this.bp(this.ay._inner[a]);
                if (this.ay._inner[a].i != null) {
                    this.ap.n(this.ay._inner[a].i);
                    this.ay._inner[a].i.ac = null;
                    this.ay._inner[a].i = null;
                }
            }
        }
        b4() {
            this.ar.i();
        }
        am(a) {
            return this.ar.item(a);
        }
        bo(a, b) {
            this.ar.item(a, b);
        }
        get ar() {
            return this.aq;
        }
        set ar(a) {
            this.aq = a;
        }
        au() {
            return this.az.count != 0;
        }
        bt() {
            let a = true;
            if (this.au()) {
                a = false;
            }
            if (!this.an.d()) {
                a = false;
            }
            if (a && !this.as) {
                if (this.imageTilesReady != null) {
                    this.imageTilesReady(this, new EventArgs());
                }
            }
            this.as = a;
        }
        ca(a) {
            if (a.h != null) {
                a.b = dateNow();
                this.az.add(a);
                this.an.ap();
            }
            else {
                this.bt();
            }
        }
        bp(a) {
            if (a.h != null) {
                this.ap.n(a.h);
                a.h.ac = null;
                a.h = null;
                for (let b = 0; b < this.az.count; ++b) {
                    if (this.az._inner[b] == a) {
                        this.az.removeAt(b);
                        break;
                    }
                }
                if (this.az.count == 0) {
                    this.an.ar();
                }
            }
        }
        br() {
            let a = dateNow();
            let b = 0.5;
            for (let c = 0; c < this.az.count;) {
                let d = a.getTime() - this.az._inner[c].b.getTime();
                let e = d / 1000;
                let f = (e) / b;
                f = MathUtil.d(f, 0, 1);
                this.az._inner[c].h._opacity = 1 - f;
                if (f >= 1) {
                    this.ap.n(this.az._inner[c].h);
                    this.az._inner[c].h.ac = null;
                    this.az._inner[c].h = null;
                    this.az.removeAt(c);
                }
                else {
                    ++c;
                }
                this.an.x();
            }
            if (this.az.count == 0) {
                this.an.ar();
            }
        }
        by() {
            this.a2 = this.a5;
            this.ck = this.cm;
            this.b5();
        }
        b0(a) {
            let b = a;
            this.ag.m(b);
            this.an.ae(a);
        }
        b1(a) {
            this.an.ag(a);
        }
        b2(a) {
            this.an.ah(a);
        }
        b3(a) {
            this.an.ai(a);
        }
        bw() {
            if (this.imagesChanged != null) {
                this.imagesChanged(this, new EventArgs());
            }
        }
        bq() {
            this.aw = false;
        }
        bv(a) {
            if (this.downloadingImage != null) {
                this.downloadingImage(this, a);
            }
        }
        bu(a) {
            if (this.cancellingImage != null) {
                this.cancellingImage(this, a);
            }
        }
        get a4() {
            return this.a1;
        }
        bz(a) {
            this.a1 = a;
        }
        get a9() {
            return this.ar.h;
        }
        set a9(a) {
            let b = a != this.a9;
            if (b) {
                this.ar = new LRUCache$2(Tile.$, WriteableBitmap.$, 1, a, new TilePositionComparer());
            }
        }
    }
    XamMultiScaleImage.$t = /*@__PURE__*/ markType(XamMultiScaleImage, 'XamMultiScaleImage', Control.$, [INotifyPropertyChanged_$type]);
    XamMultiScaleImage.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, XamMultiScaleImage, 'bx', ['IsHorizontalTileWrappingEnabled:av:cc', [0, false], 'Referer:bf:cd', [2, null], 'Source:ao:ce', [XamMultiScaleTileSource.$, null], 'SpringsEasingFunction:aj:cf', [IEasingFunction_$type, null], 'UseSprings:ax:ch', [0, false], 'UserAgent:bj:cg', [2, null], 'ViewportOrigin:cm:ci', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'ViewportWidth:a5:cj', [1, 1]]);
    return XamMultiScaleImage;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MapTileSource = /*@__PURE__*/ (() => {
    class MapTileSource extends XamMultiScaleTileSource {
        constructor(a, b, c, d, e) {
            super(a, b, c, d, e);
        }
    }
    MapTileSource.$t = /*@__PURE__*/ markType(MapTileSource, 'MapTileSource', XamMultiScaleTileSource.$);
    return MapTileSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArcGISOnlineTileSource = /*@__PURE__*/ (() => {
    class ArcGISOnlineTileSource extends MapTileSource {
        constructor() {
            super(2097152, 2097152, 256, 256, 0);
        }
        get mapServerUri() {
            return this.c(ArcGISOnlineTileSource.mapServerUriProperty);
        }
        set mapServerUri(a) {
            this.h(ArcGISOnlineTileSource.mapServerUriProperty, a);
        }
        get isMapPublic() {
            return this.c(ArcGISOnlineTileSource.isMapPublicProperty);
        }
        set isMapPublic(a) {
            this.h(ArcGISOnlineTileSource.isMapPublicProperty, a);
        }
        get levelOfDetail() {
            return typeGetValue(this.c(ArcGISOnlineTileSource.levelOfDetailProperty));
        }
        set levelOfDetail(a) {
            this.h(ArcGISOnlineTileSource.levelOfDetailProperty, a);
        }
        get userToken() {
            return this.c(ArcGISOnlineTileSource.userTokenProperty);
        }
        set userToken(a) {
            this.h(ArcGISOnlineTileSource.userTokenProperty, a);
        }
        x(a, b, c, d) {
            let e = this.mapServerUri + "/tile/{0}/{1}/{2}";
            let f = "";
            if (stringIsNullOrEmpty(this.mapServerUri) || this.levelOfDetail < 1 || !Uri.isWellFormedUriString(this.mapServerUri, 1)) {
                return;
            }
            if (!this.isMapPublic) {
                if (!stringIsNullOrEmpty(this.userToken)) {
                    e += "?token={3}";
                    f = this.userToken.trim();
                }
                else {
                    return;
                }
            }
            let g = a - 8;
            if (g > 0) {
                let h = stringFormat1(e, g, c, b, f);
                d.add(new Uri(0, h));
            }
        }
        static ad(a, b) {
            let c = a;
            if (b.f == ArcGISOnlineTileSource.mapServerUriProperty) {
                if (c.mapServerUri != typeCast(String_$type, b.newValue)) {
                    c.mapServerUri = typeCast(String_$type, b.newValue);
                }
                c.y(0, 0, 0, 0);
            }
            if (b.f == ArcGISOnlineTileSource.userTokenProperty) {
                if (c.userToken != typeCast(String_$type, b.newValue)) {
                    c.userToken = typeCast(String_$type, b.newValue);
                }
                c.y(0, 0, 0, 0);
            }
            if (b.f == ArcGISOnlineTileSource.levelOfDetailProperty) {
                c.v = truncate((Math.pow(2, c.levelOfDetail - 1) * 256));
                c.u = truncate((Math.pow(2, c.levelOfDetail - 1) * 256));
            }
            if (b.f == ArcGISOnlineTileSource.isMapPublicProperty) {
                c.y(0, 0, 0, 0);
            }
        }
    }
    ArcGISOnlineTileSource.$t = /*@__PURE__*/ markType(ArcGISOnlineTileSource, 'ArcGISOnlineTileSource', MapTileSource.$);
    ArcGISOnlineTileSource.mapServerUriProperty = /*@__PURE__*/ DependencyProperty.i("MapServerUri", String_$type, ArcGISOnlineTileSource.$, /*@__PURE__*/ new PropertyMetadata(2, null, ArcGISOnlineTileSource.ad));
    ArcGISOnlineTileSource.isMapPublicProperty = /*@__PURE__*/ DependencyProperty.i("IsMapPublic", Boolean_$type, ArcGISOnlineTileSource.$, /*@__PURE__*/ new PropertyMetadata(2, true, ArcGISOnlineTileSource.ad));
    ArcGISOnlineTileSource.levelOfDetailProperty = /*@__PURE__*/ DependencyProperty.i("LevelOfDetail", Number_$type, ArcGISOnlineTileSource.$, /*@__PURE__*/ new PropertyMetadata(2, -1, ArcGISOnlineTileSource.ad));
    ArcGISOnlineTileSource.userTokenProperty = /*@__PURE__*/ DependencyProperty.i("UserToken", String_$type, ArcGISOnlineTileSource.$, /*@__PURE__*/ new PropertyMetadata(2, null, ArcGISOnlineTileSource.ad));
    return ArcGISOnlineTileSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BingMapsTileSource = /*@__PURE__*/ (() => {
    class BingMapsTileSource extends MapTileSource {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(256 << 22, 256 << 22, 256, 256, 0);
                        this.ab = null;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        {
                            super(256 << 22, 256 << 22, 256, 256, 0);
                            this.ab = null;
                        }
                        this.tilePath = c;
                        this.subDomains = d;
                    }
                    break;
            }
        }
        get tilePath() {
            return this.c(BingMapsTileSource.tilePathProperty);
        }
        set tilePath(a) {
            this.h(BingMapsTileSource.tilePathProperty, a);
        }
        get subDomains() {
            return this.c(BingMapsTileSource.subDomainsProperty);
        }
        set subDomains(a) {
            this.h(BingMapsTileSource.subDomainsProperty, a);
        }
        ag(a, b) {
            this.y(0, 0, 0, 0);
        }
        get cultureName() {
            return this.c(BingMapsTileSource.cultureNameProperty);
        }
        set cultureName(a) {
            this.h(BingMapsTileSource.cultureNameProperty, a);
        }
        x(a, b, c, d) {
            if (!this.z()) {
                d.clear();
                return;
            }
            if (stringIsNullOrEmpty(this.tilePath)) {
                return;
            }
            a -= 8;
            if (a > 0) {
                let e = this.ad(a, b, c);
                let f = this.tilePath;
                f = stringReplace(f, "{culture}", this.ab);
                f = stringReplace(f, "{quadkey}", e);
                let g = parseInt(e.substr(e.length - 1, 1));
                if (this.subDomains == null || g >= this.subDomains.count) {
                    return;
                }
                f = stringReplace(f, "{subdomain}", this.subDomains._inner[g]);
                f = stringReplace(f, "&token={token}", "");
                d.add(new Uri(0, f));
            }
        }
        z() {
            let a = true;
            return a;
        }
        ad(a, b, c) {
            let d = new StringBuilder(0);
            for (let e = a; e > 0; --e) {
                let f = '0';
                let g = 1 << (e - 1);
                if ((b & g) != 0) {
                    ((() => { let $value = f; f = String.fromCharCode($value.charCodeAt(0) + 1); return $value; })());
                }
                if ((c & g) != 0) {
                    ((() => { let $value = f; f = String.fromCharCode($value.charCodeAt(0) + 1); return $value; })());
                    ((() => { let $value = f; f = String.fromCharCode($value.charCodeAt(0) + 1); return $value; })());
                }
                d.h(f);
            }
            return d.toString();
        }
        static af(a, b) {
            let c = a;
            if ((b.f == BingMapsTileSource.subDomainsProperty) || (b.f == BingMapsTileSource.tilePathProperty) || (b.f == BingMapsTileSource.cultureNameProperty)) {
                if (b.f == BingMapsTileSource.subDomainsProperty) {
                    let d = typeCast(ObservableCollection$1.$.specialize(String_$type), b.oldValue);
                    let e = typeCast(ObservableCollection$1.$.specialize(String_$type), b.newValue);
                    if (d != null) {
                        d.collectionChanged = delegateRemove(d.collectionChanged, runOn(c, c.ag));
                    }
                    if (e != null) {
                        e.collectionChanged = delegateCombine(e.collectionChanged, runOn(c, c.ag));
                    }
                }
                if (b.f == BingMapsTileSource.cultureNameProperty) {
                    c.ab = b.newValue;
                }
                c.y(0, 0, 0, 0);
            }
        }
    }
    BingMapsTileSource.$t = /*@__PURE__*/ markType(BingMapsTileSource, 'BingMapsTileSource', MapTileSource.$);
    BingMapsTileSource.tilePathProperty = /*@__PURE__*/ DependencyProperty.i("TilePath", String_$type, BingMapsTileSource.$, /*@__PURE__*/ new PropertyMetadata(2, null, BingMapsTileSource.af));
    BingMapsTileSource.subDomainsProperty = /*@__PURE__*/ DependencyProperty.i("SubDomains", /*@__PURE__*/ ObservableCollection$1.$.specialize(String_$type), BingMapsTileSource.$, /*@__PURE__*/ new PropertyMetadata(2, null, BingMapsTileSource.af));
    BingMapsTileSource.cultureNameProperty = /*@__PURE__*/ DependencyProperty.i("CultureName", String_$type, BingMapsTileSource.$, /*@__PURE__*/ new PropertyMetadata(2, null, BingMapsTileSource.af));
    return BingMapsTileSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileGeneratorTileSource = /*@__PURE__*/ (() => {
    class TileGeneratorTileSource extends MapTileSource {
        constructor() {
            super(134217728, 134217728, 256, 256, 0);
            this.z = "tilegen://tile/{Z}/{X}/{Y}.png";
        }
        x(a, b, c, d) {
            let e = a - 8;
            if (e > 0) {
                let f = "tilegen://tile/" + e + "/" + b + "/" + c + ".png";
                d.add(new Uri(0, f));
            }
        }
    }
    TileGeneratorTileSource.$t = /*@__PURE__*/ markType(TileGeneratorTileSource, 'TileGeneratorTileSource', MapTileSource.$);
    return TileGeneratorTileSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GetTileImageUriArgs = /*@__PURE__*/ (() => {
    class GetTileImageUriArgs extends EventArgs {
        constructor(a, b, c) {
            super();
            this._tileLevel = 0;
            this._tilePositionX = 0;
            this._tilePositionY = 0;
            this._tileImageUri = null;
            this.tileLevel = a;
            this.tilePositionX = b;
            this.tilePositionY = c;
        }
        get tileLevel() {
            return this._tileLevel;
        }
        set tileLevel(a) {
            this._tileLevel = a;
        }
        get tilePositionX() {
            return this._tilePositionX;
        }
        set tilePositionX(a) {
            this._tilePositionX = a;
        }
        get tilePositionY() {
            return this._tilePositionY;
        }
        set tilePositionY(a) {
            this._tilePositionY = a;
        }
        get tileImageUri() {
            return this._tileImageUri;
        }
        set tileImageUri(a) {
            this._tileImageUri = a;
        }
    }
    GetTileImageUriArgs.$t = /*@__PURE__*/ markType(GetTileImageUriArgs, 'GetTileImageUriArgs', EventArgs.$);
    return GetTileImageUriArgs;
})();

/**
 * Event arguments for GetTileImageUri event
*/
class IgrGetTileImageUriArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets or sets the tile level.
    */
    get tileLevel() {
        return this.i.tileLevel;
    }
    set tileLevel(v) {
        this.i.tileLevel = +v;
    }
    /**
     * Gets or sets the tile's X position
    */
    get tilePositionX() {
        return this.i.tilePositionX;
    }
    set tilePositionX(v) {
        this.i.tilePositionX = +v;
    }
    /**
     * Gets or sets the tile's Y position
    */
    get tilePositionY() {
        return this.i.tilePositionY;
    }
    set tilePositionY(v) {
        this.i.tilePositionY = +v;
    }
    /**
     * Gets or sets the tile's image URI
    */
    get tileImageUri() {
        return this.i.tileImageUri;
    }
    set tileImageUri(v) {
        this.i.tileImageUri = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomMapTileSource = /*@__PURE__*/ (() => {
    class CustomMapTileSource extends MapTileSource {
        constructor(a, b, c, d, e) {
            super(a, b, c, d, e);
            this.getTileImageUri = null;
        }
        x(a, b, c, d) {
            let e = new GetTileImageUriArgs(a, b, c);
            this.aa(e);
            if (e.tileImageUri != null) {
                let f = new Uri(0, e.tileImageUri);
                d.add(f);
            }
        }
        aa(a) {
            if (this.getTileImageUri != null) {
                this.getTileImageUri(this, a);
            }
        }
    }
    CustomMapTileSource.$t = /*@__PURE__*/ markType(CustomMapTileSource, 'CustomMapTileSource', MapTileSource.$);
    return CustomMapTileSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OpenStreetMapTileSource = /*@__PURE__*/ (() => {
    class OpenStreetMapTileSource extends MapTileSource {
        constructor() {
            super(134217728, 134217728, 256, 256, 0);
            this.z = "tile.openstreetmap.org/{Z}/{X}/{Y}.png";
            this.setTilePathUrl(this.z);
        }
        x(a, b, c, d) {
            let e = a - 8;
            if (e > 0) {
                let f = this.z;
                f = stringReplace(f, "{Z}", e.toString());
                f = stringReplace(f, "{X}", b.toString());
                f = stringReplace(f, "{Y}", c.toString());
                d.add(new Uri(0, f));
            }
        }
        setTilePathUrl(a) {
            if (!stringIsNullOrEmpty(a)) {
                if (stringStartsWith(a, "http://") || stringStartsWith(a, "https://")) {
                    this.z = a;
                }
                else {
                    let b = "http://";
                    b = (('https:' == document.location.protocol ? 'https://' : 'http://'));
                    this.z = b + a;
                }
            }
        }
    }
    OpenStreetMapTileSource.$t = /*@__PURE__*/ markType(OpenStreetMapTileSource, 'OpenStreetMapTileSource', MapTileSource.$);
    return OpenStreetMapTileSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IMapRenderDeferralHandler_$type = /*@__PURE__*/ new Type(null, 'IMapRenderDeferralHandler');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Pair$2 = /*@__PURE__*/ (() => {
    class Pair$2 extends Base {
        constructor($t1, $t2, a, b) {
            super();
            this.$t1 = null;
            this.$t2 = null;
            this.a = null;
            this.b = null;
            this.$t1 = $t1;
            this.$t2 = $t2;
            this.$type = this.$type.specialize(this.$t1, this.$t2);
            this.a = a;
            this.b = b;
        }
    }
    Pair$2.$t = /*@__PURE__*/ markType(Pair$2, 'Pair$2');
    return Pair$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

class IgrCancellingMultiScaleImageEventArgs {
    createImplementation() {
        return new CancellingMultiScaleImageEventArgs();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get uri() {
        return this.i.uri;
    }
    set uri(v) {
        this.i.uri = v;
    }
}

class IgrTriangulationStatusEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * The current status from 0 to 100 of the progressive triangulation.
    */
    get currentStatus() {
        return this.i.currentStatus;
    }
    set currentStatus(v) {
        this.i.currentStatus = +v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelCollisionPlacementPositions_$type = /*@__PURE__*/ markEnum('LabelCollisionPlacementPositions', 'Top,0|Left,1|Right,2|Bottom,3|TopLeft,4|TopRight,5|BottomLeft,6|BottomRight,7|SliceCenter,8|SliceInnerEnd,9|SliceOuterEnd,10|SliceBestFit,11');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelCollisionManagerCollisionMode_$type = /*@__PURE__*/ markEnum('LabelCollisionManagerCollisionMode', 'SimulatedAnnealing,0|Greedy,1|GreedyCenterOfMass,2|RadialBestFit,3|RadialInsideStart,4|RadialInsideEnd,5|RadialOutsideEnd,6|RadialCenter,7');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let QuadTreeBoundingBox = /*@__PURE__*/ (() => {
    class QuadTreeBoundingBox extends Base {
        constructor() {
            super();
            this.d = 0;
            this.e = 0;
            this.g = 0;
            this.f = 0;
            this.i = null;
        }
        c(a) {
            if (this.d + this.g < a.d - a.g || this.e + this.f < a.e - a.f || this.d - this.g > a.d + a.g || this.e - this.f > a.e + a.f) {
                return false;
            }
            return true;
        }
        h(a) {
            let b = this.d - this.g;
            let c = this.e - this.f;
            let d = this.d + this.g;
            let e = this.e + this.f;
            let f = a.d - a.g;
            let g = a.e - a.f;
            let h = a.d + a.g;
            let i = a.e + a.f;
            let j = Math.max(b, f);
            let k = Math.min(d, h);
            let l = Math.max(c, g);
            let m = Math.min(e, i);
            return (k - j) * (m - l);
        }
        static b(a) {
            let b = new QuadTreeBoundingBox();
            b.d = a.left + a.width / 2;
            b.e = a.top + a.height / 2;
            b.f = a.height / 2;
            b.g = a.width / 2;
            return b;
        }
        static a(a) {
            let b = new QuadTreeBoundingBox();
            b.d = a.left + a.width / 2;
            b.e = a.top + a.height / 2;
            b.f = a.height / 2;
            b.g = a.width / 2;
            return b;
        }
        j() {
            let a = new Rect(0, this.d - this.g, this.e - this.f, this.g + this.g, this.f + this.f);
            return a;
        }
    }
    QuadTreeBoundingBox.$t = /*@__PURE__*/ markType(QuadTreeBoundingBox, 'QuadTreeBoundingBox');
    return QuadTreeBoundingBox;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let QuadTreeForceVector = /*@__PURE__*/ (() => {
    class QuadTreeForceVector extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = 0;
        }
    }
    QuadTreeForceVector.$t = /*@__PURE__*/ markType(QuadTreeForceVector, 'QuadTreeForceVector');
    return QuadTreeForceVector;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let QuadTree = /*@__PURE__*/ (() => {
    class QuadTree extends Base {
        constructor(a, b, c, d) {
            super();
            this.b = null;
            this.f = 0;
            this.i = 0;
            this.b = new QuadTreeNode();
            this.b.b = this;
            this.b.c = new QuadTreeBoundingBox();
            let e = Math.max(a, b);
            this.b.c.d = e / 2;
            this.b.c.e = e / 2;
            this.b.c.g = e / 2;
            this.b.c.f = e / 2;
            this.f = d;
            this.i = c;
        }
        c(a) {
            return this.b.i(a);
        }
        d(a) {
            return this.b.k(a);
        }
        e(a) {
            let b = new List$1(QuadTreeNode.$, 0);
            this.b.x(a, b);
            return b;
        }
        j() {
            this.b.w();
        }
        k() {
            this.b.z();
        }
        g() {
            return this.h(this.b, new HashSet$1(QuadTreeBoundingBox.$, 0));
        }
        h(a, b) {
            if (a.j) {
                let c = 0;
                let d = a.l.c;
                while (d != null) {
                    if (!b.contains(d.c)) {
                        c += 1;
                        b.add_1(d.c);
                    }
                    d = d.a;
                }
                return c;
            }
            let e = this.h(a.f, b);
            e += this.h(a.e, b);
            e += this.h(a.h, b);
            e += this.h(a.g, b);
            return e;
        }
        a(a, b, c) {
            return this.b.d(a, b, c);
        }
    }
    QuadTree.$t = /*@__PURE__*/ markType(QuadTree, 'QuadTree');
    return QuadTree;
})();
/**
 * @hidden
 */
let QuadTreeNode = /*@__PURE__*/ (() => {
    class QuadTreeNode extends Base {
        constructor() {
            super();
            this.b = null;
            this.l = null;
            this.t = 0;
            this.c = null;
            this.q = 0;
            this.a = null;
            this.m = 0;
            this.n = 0;
            this.o = 0;
            this.m = 0;
            this.n = 0;
            this.o = 0;
            this.l = new LinkedList$1(QuadTreeBoundingBox.$);
            this.a = new Array(4);
            this.c = new QuadTreeBoundingBox();
            for (let a = 0; a < 4; a++) {
                this.a[a] = null;
            }
        }
        k(a) {
            if (!this.c.c(a)) {
                return false;
            }
            let b = this.f == null && this.e == null && this.h == null && this.g == null;
            if (b) {
                let c = this.l.c;
                while (c != null) {
                    if (c.c == a) {
                        this.l.h(c);
                        this.t--;
                        return true;
                    }
                    c = c.a;
                }
                return false;
            }
            this.f.k(a);
            this.e.k(a);
            this.h.k(a);
            this.g.k(a);
            return false;
        }
        get j() {
            return this.f == null && this.e == null && this.h == null && this.g == null;
        }
        x(a, b) {
            if (!this.c.c(a)) {
                return;
            }
            if (this.j) {
                b.add(this);
                return;
            }
            this.f.x(a, b);
            this.e.x(a, b);
            this.h.x(a, b);
            this.g.x(a, b);
        }
        w() {
            if (this.f != null) {
                this.f.w();
            }
            if (this.e != null) {
                this.e.w();
            }
            if (this.h != null) {
                this.h.w();
            }
            if (this.g != null) {
                this.h.w();
            }
            if (this.f.j && this.f.t == 0 && this.e.j && this.e.t == 0 && this.h.j && this.h.t == 0 && this.g.j && this.g.t == 0) {
                this.f = null;
                this.e = null;
                this.h = null;
                this.g = null;
                return;
            }
        }
        i(a) {
            if (!this.c.c(a)) {
                return false;
            }
            let b = this.f == null && this.e == null && this.h == null && this.g == null;
            if (b && this.t < this.b.f) {
                this.l.f(a);
                this.t++;
                return true;
            }
            else if (b && this.q < this.b.i) {
                this.y();
            }
            else if (b) {
                this.l.f(a);
                this.t++;
                return true;
            }
            let c = this.f.i(a);
            c = this.e.i(a) || c;
            c = this.h.i(a) || c;
            c = this.g.i(a) || c;
            return c;
        }
        y() {
            this.f = new QuadTreeNode();
            this.e = new QuadTreeNode();
            this.h = new QuadTreeNode();
            this.g = new QuadTreeNode();
            let a = this.c.g / 2;
            this.f.c.d = this.c.d - a;
            this.f.c.e = this.c.e - a;
            this.e.c.d = this.c.d + a;
            this.e.c.e = this.c.e - a;
            this.h.c.d = this.c.d - a;
            this.h.c.e = this.c.e + a;
            this.g.c.d = this.c.d + a;
            this.g.c.e = this.c.e + a;
            for (let b = 0; b < 4; b++) {
                this.a[b].q = this.q + 1;
                this.a[b].c.g = a;
                this.a[b].c.f = a;
                this.a[b].b = this.b;
            }
            let c = this.l.c;
            while (c != null) {
                let d = c.c;
                this.f.i(d);
                this.e.i(d);
                this.h.i(d);
                this.g.i(d);
                c = c.a;
            }
            this.l.g();
            this.t = 0;
        }
        z() {
            if (this.j) {
                let a = 0;
                let b = 0;
                let c = this.l.c;
                while (c != null) {
                    let d = c.c;
                    a += d.d;
                    b += d.e;
                    c = c.a;
                }
                if (this.t == 0) {
                    this.m = 0;
                    this.n = 0;
                    this.o = 0;
                }
                else {
                    this.m = a / this.t;
                    this.n = b / this.t;
                    this.o = this.t;
                }
            }
            else {
                this.f.z();
                this.h.z();
                this.e.z();
                this.g.z();
                let e = 0;
                let f = 0;
                let g = 0;
                for (let h = 0; h < 4; h++) {
                    g += this.a[h].o;
                    e += this.a[h].m * this.a[h].o;
                    f += this.a[h].n * this.a[h].o;
                }
                if (this.o > 0) {
                    this.m = e / g;
                    this.n = f / g;
                }
                this.o = g;
            }
        }
        d(a, b, c) {
            let d = Math.sqrt((a - this.m) * (a - this.m) + (b - this.n) * (b - this.n));
            let e = this.c.g * 2;
            if (e / d < c || this.j) {
                let f = (a - this.m) * this.o / (d * d);
                let g = (b - this.n) * this.o / (d * d);
                return ((() => {
                    let $ret = new QuadTreeForceVector();
                    $ret.a = f;
                    $ret.b = g;
                    return $ret;
                })());
            }
            else {
                let h = 0;
                let i = 0;
                for (let j = 0; j < 4; j++) {
                    let k = this.a[j].d(a, b, c);
                    h += k.a;
                    i += k.b;
                }
                return ((() => {
                    let $ret = new QuadTreeForceVector();
                    $ret.a = h;
                    $ret.b = i;
                    return $ret;
                })());
            }
        }
        get f() {
            return this.a[0];
        }
        set f(a) {
            this.a[0] = a;
        }
        get e() {
            return this.a[1];
        }
        set e(a) {
            this.a[1] = a;
        }
        get h() {
            return this.a[2];
        }
        set h(a) {
            this.a[2] = a;
        }
        get g() {
            return this.a[3];
        }
        set g(a) {
            this.a[3] = a;
        }
    }
    QuadTreeNode.$t = /*@__PURE__*/ markType(QuadTreeNode, 'QuadTreeNode');
    return QuadTreeNode;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelCollisionInfo = /*@__PURE__*/ (() => {
    class LabelCollisionInfo extends Base {
        constructor() {
            super(...arguments);
            this.i = null;
            this.s = 0;
            this.t = 0;
            this.r = 0;
            this.q = 0;
            this.e = null;
            this.p = 0;
            this.o = 0;
            this.m = 0;
            this.n = 0;
            this.w = 0;
            this.x = 0;
            this.k = 0;
            this.l = 0;
            this.u = 0;
            this.v = 0;
            this.b = 0;
            this.c = null;
            this.y = null;
            this.f = false;
            this.a = null;
            this.d = null;
            this.g = false;
            this.j = null;
            this.h = false;
        }
    }
    LabelCollisionInfo.$t = /*@__PURE__*/ markType(LabelCollisionInfo, 'LabelCollisionInfo');
    return LabelCollisionInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeometryUtil = /*@__PURE__*/ (() => {
    class GeometryUtil extends Base {
        static m(a) {
            if (isNaN_(a) || isInfinity(a)) {
                return a;
            }
            while (a > 360) {
                a -= 360;
            }
            while (a < 0) {
                a += 360;
            }
            return a;
        }
        static f(a) {
            return Math.atan(a);
        }
        static n(a, b) {
            return (b.y - a.y) / (b.x - a.x);
        }
        static h(a) {
            return 1 - Math.pow(a.height / 2, 2) / Math.pow(a.width / 2, 2);
        }
        static t(a, b, c, d, e) {
            let f = Math.cos(a);
            let g = Math.sin(a);
            let h = Math.sqrt(d * d / (1 - (b * Math.pow(f, 2))));
            h *= e;
            return { $type: Point_$type, x: h * f + c.x, y: h * g + c.y };
        }
        static p(a, b, c, d, e) {
            let f;
            if (c) {
                f = GeometryUtil.q({ $type: Point_$type, x: a / 2, y: b / 2 }, d, e);
            }
            else {
                f = { $type: Point_$type, x: a / 2, y: b / 2 };
            }
            return f;
        }
        static q(a, b, c) {
            b = b / 180 * Math.PI;
            let d = a.y + c * Math.sin(b);
            let e = a.x + c * Math.cos(b);
            return { $type: Point_$type, x: e, y: d };
        }
        static s(a, b, c) {
            let d = b.x - a.x;
            let e = b.y - a.y;
            let f = Math.sqrt(d * d + e * e);
            d = d / f * c;
            e = e / f * c;
            return { $type: Point_$type, x: a.x + d, y: a.y + e };
        }
        static j(a, b) {
            let c = Math.abs(b.x - a.x);
            let d = Math.abs(b.y - a.y);
            return Math.sqrt(c * c + d * d);
        }
        static r(a, b, c, d, e) {
            return CoreGeometryUtil.c(a, b, c, d, e);
        }
        static i(a, b) {
            let c = Math.sqrt(Math.pow(b.x - a.x, 2) + Math.pow(b.y - a.y, 2));
            let d = Math.acos((b.x - a.x) / c);
            if ((b.y - a.y) < 0) {
                d = (2 * Math.PI) - d;
            }
            return d;
        }
        static e(a, b, c, d, e, f) {
            if (isNaN_(c) || isNaN_(d) || isNaN_(e)) {
                return false;
            }
            let g = e * e;
            let h = f * f;
            let i = a.x - b.x;
            let j = a.y - b.y;
            if (i > g || j > g) {
                return false;
            }
            let k = i * i + j * j;
            if (k > g) {
                return false;
            }
            if (k < h) {
                return false;
            }
            let l = Math.atan2(j, i);
            return GeometryUtil.a(l, c, d);
        }
        static a(a, b, c) {
            let d = MathUtil.f(a);
            let e = MathUtil.f(b);
            let f = MathUtil.f(c);
            d = GeometryUtil.m(d);
            let g = Math.min(e, f);
            let h = Math.max(e, f);
            return (d > g && d < h) || (d - 360 > g && d - 360 < h) || (d + 360 > g && d + 360 < h);
        }
        static u(a, b, c, d) {
            let e = { $type: Point_$type, x: a.x + Math.cos(b) * d, y: a.y + Math.sin(b) * d };
            let f = { $type: Point_$type, x: a.x + Math.cos(c) * d, y: a.y + Math.sin(c) * d };
            let g = new List$1(Point_$type, 0);
            g.add(e);
            g.add(f);
            g.add(a);
            let h = MathUtil.f(b);
            let i = MathUtil.f(c);
            h = GeometryUtil.m(h);
            i = GeometryUtil.m(i);
            if ((0 > h && 0 < i) || (360 > h && 360 < i) || (i < h)) {
                g.add(GeometryUtil.q(a, 0, d));
            }
            if (90 > h && 90 < i) {
                g.add(GeometryUtil.q(a, 90, d));
            }
            if (180 > h && 180 < i) {
                g.add(GeometryUtil.q(a, 180, d));
            }
            if (270 > h && 270 < i) {
                g.add(GeometryUtil.q(a, 270, d));
            }
            let j = 1.7976931348623157E+308;
            let k = 1.7976931348623157E+308;
            let l = -1.7976931348623157E+308;
            let m = -1.7976931348623157E+308;
            for (let n of fromEnum(g)) {
                j = Math.min(j, n.x);
                k = Math.min(k, n.y);
                l = Math.max(l, n.x);
                m = Math.max(m, n.y);
            }
            return new Rect(0, j, k, l - j, m - k);
        }
        static b(a, b, c) {
            let d = a.x - b.x;
            let e = a.y - b.y;
            let f = d * d + e * e;
            let g = c * c;
            return f < g;
        }
        static o(a, b, c, d) {
            let e = a.x - c.x;
            let f = a.y - c.y;
            let g = b.x - c.x;
            let h = b.y - c.y;
            let i = g - e;
            let j = h - f;
            let k = Math.sqrt(i * i + j * j);
            let l = e * h - g * f;
            let m = d * d;
            let n = k * k;
            let o = l * l;
            let p = m * n - o;
            if (p < 0) {
                return new Tuple$2(Point_$type, Point_$type, { $type: Point_$type, x: NaN, y: NaN }, { $type: Point_$type, x: NaN, y: NaN });
            }
            let q = 1;
            if (j < 0) {
                q = -1;
            }
            let r = (l * j + q * i * Math.sqrt(p)) / n;
            let s = (l * j - q * i * Math.sqrt(p)) / n;
            let t = (-1 * l * i + Math.abs(j) * Math.sqrt(p)) / n;
            let u = (-1 * l * i - Math.abs(j) * Math.sqrt(p)) / n;
            return new Tuple$2(Point_$type, Point_$type, { $type: Point_$type, x: r + c.x, y: t + c.y }, { $type: Point_$type, x: s + c.x, y: u + c.y });
        }
        static c(a, b, c, d) {
            let e = d * d;
            let f = b.x;
            let g = b.y;
            let h = c.x;
            let i = c.y;
            let j = a.x;
            let k = a.y;
            if (g == i) {
                let l = Math.abs(g - k) < d;
                let m = j >= Math.min(f, h) - d && j <= Math.max(f, h) + d;
                if (l && m) {
                    return true;
                }
                else {
                    return false;
                }
            }
            if (f == h) {
                let n = Math.abs(f - j) < d;
                let o = k >= Math.min(g, i) - d && k <= Math.max(g, i) + d;
                if (n && o) {
                    return true;
                }
                else {
                    return false;
                }
            }
            let p = h - f;
            let q = i - g;
            let r = p * p + q * q;
            if (r == 0) {
                return (j - f) * (j - f) + (k - g) * (k - g) < e;
            }
            let s = ((j - f) * p + (k - g) * q) / r;
            s = s < 0 ? 0 : (s > 1 ? 1 : s);
            let t = f + p * s;
            let u = g + q * s;
            let v = (t - j) * (t - j) + (u - k) * (u - k);
            if (v < e) {
                return true;
            }
            return false;
        }
        static g(a, b, c) {
            let d = b.x;
            let e = b.y;
            let f = c.x;
            let g = c.y;
            let h = a.x;
            let i = a.y;
            let j = f - d;
            let k = g - e;
            let l = j * j + k * k;
            if (l == 0) {
                return (h - d) * (h - d) + (i - e) * (i - e);
            }
            let m = ((h - d) * j + (i - e) * k) / l;
            m = m < 0 ? 0 : (m > 1 ? 1 : m);
            let n = d + j * m;
            let o = e + k * m;
            let p = (n - h) * (n - h) + (o - i) * (o - i);
            return p;
        }
        static l(a, b, c) {
            let d = b.x;
            let e = b.y;
            let f = c.x;
            let g = c.y;
            let h = a.x;
            let i = a.y;
            let j = f - d;
            let k = g - e;
            let l = j * j + k * k;
            if (l == 0) {
                return 0;
            }
            let m = ((h - d) * j + (i - e) * k) / l;
            m = m < 0 ? 0 : (m > 1 ? 1 : m);
            return m;
        }
        static d(a, b, c, d) {
            let e;
            let f;
            let g = d * d;
            let h = c.count;
            if (h == 0) {
                return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) < g;
            }
            let i = a.x;
            let j = a.y;
            for (let k = 0; k < h; k++) {
                if (k == 0) {
                    f = c.item(k);
                    e = b;
                }
                else {
                    f = c.item(k);
                    e = c.item(k - 1);
                }
                let l = e.x;
                let m = e.y;
                let n = f.x;
                let o = f.y;
                if (m == o) {
                    let p = Math.abs(m - j) < d;
                    let q = i >= Math.min(l, n) - d && i <= Math.max(l, n) + d;
                    if (p && q) {
                        return true;
                    }
                    else {
                        continue;
                    }
                }
                if (l == n) {
                    let r = Math.abs(l - i) < d;
                    let s = j >= Math.min(m, o) - d && j <= Math.max(m, o) + d;
                    if (r && s) {
                        return true;
                    }
                    else {
                        continue;
                    }
                }
                let t = n - l;
                let u = o - m;
                let v = t * t + u * u;
                if (v == 0) {
                    return (i - l) * (i - l) + (j - m) * (j - m) < g;
                }
                let w = ((i - l) * t + (j - m) * u) / v;
                w = w < 0 ? 0 : (w > 1 ? 1 : w);
                let x = l + t * w;
                let y = m + u * w;
                let z = (x - i) * (x - i) + (y - j) * (y - j);
                if (z < g) {
                    return true;
                }
            }
            return false;
        }
        static k(a, b, c, d) {
            let e = Math.abs(Math.cos(b));
            let f = Math.abs(Math.sin(b));
            let g = c * 0.5;
            let h = d * 0.5;
            let i = e * h - f * g;
            if (a * a >= i * i) {
                let j = e * g + f * h + Math.sqrt(a * a - i * i);
                let k = j * e - g;
                let l = j * f - h;
                if (k > 0 && l > 0) {
                    return j;
                }
                else if (k > 0) {
                    return (a + g) / e;
                }
                else if (l > 0) {
                    return (a + h) / f;
                }
                else {
                    return 0;
                }
            }
            else {
                if (i > 0) {
                    return (a + g) / e;
                }
                else if (i < 0) {
                    return (a + h) / f;
                }
                else {
                    return 0;
                }
            }
        }
    }
    GeometryUtil.$t = /*@__PURE__*/ markType(GeometryUtil, 'GeometryUtil');
    return GeometryUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelCollisionManager = /*@__PURE__*/ (() => {
    class LabelCollisionManager extends Base {
        constructor(a, b, c, d, e, f, g, h, i, j, k) {
            super();
            this.o = false;
            this.a = new Array(8);
            this.aj = null;
            this.labelsMoved = null;
            this.m = null;
            this.h = null;
            this.g = 0;
            this.e = null;
            this.ai = null;
            this.au = 0;
            this.a2 = 0;
            this.a1 = 0;
            this.bu = null;
            this.aw = 0;
            this.at = 0;
            this.ag = new LinkedList$1(LabelCollisionInfo.$);
            this.ay = 0;
            this.ah = new List$1(LabelCollisionInfo.$, 0);
            this.q = false;
            this.p = false;
            this.a0 = 0;
            this.ax = 0;
            this.ak = 0;
            this.al = 0;
            this.az = 0;
            this.r = false;
            this.n = false;
            this.b = null;
            this.a7 = null;
            this.a5 = null;
            this.am = 0;
            this.an = 0;
            this.o = k != null;
            this.bu = c;
            this.aw = a;
            this.at = b;
            this.h = new QuadTree(a, b, 8, 8);
            this.g = f;
            this.e = d;
            this.ai = new List$1(LabelCollisionPlacementPositions_$type, 0);
            this.ai.add(0);
            this.ai.add(5);
            this.ai.add(7);
            this.ai.add(2);
            this.ai.add(3);
            this.ai.add(6);
            this.ai.add(1);
            this.ai.add(4);
            let l = 0;
            for (let m = 0; m < g.length; m++) {
                if (this.ai.contains(g[m])) {
                    this.ai.remove(g[m]);
                    this.ai.insert(l, g[m]);
                    l++;
                }
            }
            if (k != null) {
                this.aj = new List$1(LabelCollisionPlacementPositions_$type, 0);
                for (let n = 0; n < this.a.length; n++) {
                    this.a[n] = false;
                }
                for (let o = 0; o < k.length; o++) {
                    this.a[k[o]] = true;
                    this.aj.add(k[o]);
                }
                this.b = k;
            }
            else {
                this.aj = new List$1(LabelCollisionPlacementPositions_$type, 0);
                this.aj.add(0);
                this.aj.add(5);
                this.aj.add(7);
                this.aj.add(2);
                this.aj.add(3);
                this.aj.add(6);
                this.aj.add(1);
                this.aj.add(4);
                if (this.ad(this.g)) {
                    this.aj = new List$1(LabelCollisionPlacementPositions_$type, 0);
                    this.aj.add(10);
                    this.aj.add(11);
                    this.aj.add(8);
                    this.aj.add(9);
                }
                let p = 0;
                for (let q = 0; q < g.length; q++) {
                    if (this.aj.contains(g[q])) {
                        this.aj.remove(g[q]);
                        this.aj.insert(p, g[q]);
                        p++;
                    }
                }
            }
            this.au = e;
            this.a2 = h;
            this.a1 = i;
            this.n = j;
        }
        l(a, b, c, d, e) {
            let f = 0;
            let g = 0;
            switch (b) {
                case 0:
                    f = a.s;
                    g = (((a.t - a.q) - a.o) - this.au - d);
                    break;
                case 4:
                    f = (((a.s - a.r) - a.p) - this.au) - c;
                    g = (((a.t - a.q) - a.o) - this.au) - d;
                    break;
                case 5:
                    f = (((a.s + a.r) + a.p) + this.au) + c;
                    g = (((a.t - a.q) - a.o) - this.au) - d;
                    break;
                case 1:
                    f = (((a.s - a.r) - a.p) - this.au) - c;
                    g = a.t;
                    break;
                case 2:
                    f = (((a.s + a.r) + a.p) + this.au) + c;
                    g = a.t;
                    break;
                case 3:
                    f = a.s;
                    g = (((a.t + a.q) + a.o) + this.au) + d;
                    break;
                case 6:
                    f = (((a.s - a.r) - a.p) - this.au) - c;
                    g = (((a.t + a.q) + a.o) + this.au) + d;
                    break;
                case 7:
                    f = (((a.s + a.r) + a.p) + this.au) + c;
                    g = (((a.t + a.q) + a.o) + this.au) - d;
                    break;
                case 8:
                    {
                        let h = this.i(a);
                        if (h != null) {
                            a.b = 8;
                            f = h.d;
                            g = h.e;
                        }
                        else {
                            return null;
                        }
                        break;
                    }
                case 9:
                    {
                        let i = this.j(a);
                        if (i != null) {
                            a.b = 9;
                            f = i.d;
                            g = i.e;
                        }
                        else {
                            return null;
                        }
                        break;
                    }
                case 10:
                    {
                        let j = this.k(a);
                        if (j != null) {
                            a.b = 10;
                            f = j.d;
                            g = j.e;
                        }
                        else {
                            return null;
                        }
                        break;
                    }
                case 11:
                    {
                        let k = this.i(a);
                        if (k != null) {
                            a.b = 8;
                            f = k.d;
                            g = k.e;
                        }
                        else {
                            let l = this.j(a);
                            if (l != null) {
                                f = l.d;
                                g = l.e;
                            }
                            else {
                                let m = this.j(a);
                                if (m != null) {
                                    f = m.d;
                                    g = m.e;
                                }
                                else {
                                    return null;
                                }
                            }
                        }
                        break;
                    }
            }
            let n = new QuadTreeBoundingBox();
            n.d = f;
            n.e = g;
            n.g = a.p;
            n.f = a.o;
            n.i = a;
            if (this.x(n) && !e) {
                return null;
            }
            return n;
        }
        x(a) {
            let b = a.d - a.g;
            let c = a.d + a.g;
            let d = a.e - a.f;
            let e = a.e + a.f;
            let f = this.bu;
            if (b < f.left || c > f.right || d < f.top || e > f.bottom) {
                return true;
            }
            return false;
        }
        a8(a) {
            this.ay++;
            this.ag.f(a);
            a.i = this.ag.d;
            if (a.e == null) {
                a.e = new QuadTreeBoundingBox();
                a.e.d = a.s;
                a.e.e = a.t;
                a.e.g = a.r;
                a.e.f = a.q;
                a.e.i = a;
                this.h.c(a.e);
            }
            if (a.a != null) {
                if (a.d == null) {
                    a.d = QuadTreeBoundingBox.a(a.a.boundingBox);
                    a.d.i = a;
                    this.h.c(a.d);
                }
            }
        }
        bl(a) {
            if (a.e != null) {
                this.h.d(a.e);
                a.e = null;
            }
            if (a.d != null) {
                this.h.d(a.d);
                a.d = null;
            }
            if (a.c != null) {
                this.h.d(a.c);
                a.c = null;
            }
            if (a.i != null) {
                this.ag.h(a.i);
                a.i = null;
            }
            this.ay--;
        }
        bi(a) {
            if (a.e != null && a.e.d == a.s && a.e.e == a.t) {
                return;
            }
            if (a.e != null) {
                this.h.d(a.e);
            }
            if (a.d != null) {
                this.h.d(a.d);
                a.d = null;
            }
            let b = NaN;
            let c = NaN;
            if (a.e == null) {
                a.e = new QuadTreeBoundingBox();
                a.e.i = a;
            }
            else {
                if (a.c != null) {
                    b = a.c.d - a.e.d;
                    c = a.c.e - a.e.e;
                }
            }
            a.e.d = a.s;
            a.e.e = a.t;
            a.e.g = a.r;
            a.e.f = a.q;
            this.h.c(a.e);
            if (a.a != null) {
                if (a.d == null) {
                    a.d = QuadTreeBoundingBox.a(a.a.boundingBox);
                    a.d.i = a;
                    this.h.c(a.d);
                }
            }
            if (a.c != null) {
                this.h.d(a.c);
                if (a.b == 8 || a.b == 9) {
                    b = NaN;
                }
                if (!isNaN_(b)) {
                    a.c = new QuadTreeBoundingBox();
                    a.c.d = a.e.d + b;
                    a.c.e = a.e.e + c;
                    a.c.i = a;
                    a.c.g = a.p;
                    a.c.f = a.o;
                    a.k = a.c.d;
                    a.l = a.c.e;
                    this.h.c(a.c);
                }
                else {
                    a.c = this.l(a, a.b, 0, 0, true);
                    if (a.c != null) {
                        this.bg(a);
                        a.k = a.c.d;
                        a.l = a.c.e;
                        this.h.c(a.c);
                    }
                    else {
                        this.bf(a);
                    }
                }
            }
        }
        bh(a) {
            this.h.d(a.c);
            a.c.d = a.k;
            a.c.e = a.l;
            a.c.g = a.p;
            a.c.f = a.o;
            this.h.c(a.c);
        }
        bp() {
            this.p = false;
            {
                let a = this.ag.c;
                while (a != null) {
                    a.c.h = false;
                    if (a.c.c != null) {
                        this.h.d(a.c.c);
                        a.c.c = null;
                        if (a.c.j != null) {
                            a.c.j.clear();
                        }
                    }
                    a = a.a;
                }
                this.az = 0;
            }
            this.ax = 0;
            this.ak = 0.4;
            this.al = 0.4;
            let b = truncate(Math.ceil((this.a1 / 150) * this.a2));
            this.a0 = b;
            this.bc();
        }
        ba() {
            this.ah.clear();
        }
        a9() {
            this.p = true;
        }
        be() {
            this.q = false;
            if (this.p) {
                return;
            }
            this.bc();
        }
        bc() {
            this.ah.clear();
            this.bj(false);
            if (this.g == 0) {
                for (let a = 0; a < this.a2; a++) {
                    this.al = this.ak * (this.a0 - this.ax) / this.a0;
                    this.bd();
                    this.ax++;
                    if (this.ax > this.a0) {
                        if (this.m != null) {
                            this.m();
                        }
                        return;
                    }
                }
                if (this.labelsMoved != null) {
                    for (let b of fromEnum(this.ah)) {
                    }
                    this.labelsMoved(this.ah);
                }
                if (this.az > 0) {
                    if (!this.q) {
                        this.q = true;
                        this.e.executeDelayed(runOn(this, this.be), 150);
                    }
                }
                else {
                    if (this.m != null) {
                        this.m();
                    }
                }
            }
            else {
                if (this.g == 2) {
                    let c = this.ag.c;
                    this.h.k();
                    while (c != null) {
                        let d = c.c;
                        if (d.c != null) {
                            this.h.d(d.c);
                            d.c = null;
                            d.f = false;
                            d.j = null;
                        }
                        c = c.a;
                    }
                    this.az = 0;
                    this.bj(true);
                }
                if (this.labelsMoved != null) {
                    this.labelsMoved(this.ah);
                }
            }
        }
        bd() {
            let a = truncate(Math.round((this.ay - 1) * LabelCollisionManager.a6.nextDouble()));
            let b = 0;
            let c = this.ag.c;
            let d = this.as(null);
            let e = 30;
            let f = 60;
            while (c != null) {
                let g = c.c;
                let h = 0;
                let i = 0;
                if (this.n) {
                    h = LabelCollisionManager.a6.nextDouble() * g.p * 2;
                    i = LabelCollisionManager.a6.nextDouble() * g.o * 2;
                }
                if (b == a) {
                    let j = truncate(Math.round((this.aj.count - 1) * LabelCollisionManager.a6.nextDouble()));
                    while (this.aj._inner[j] == g.b) {
                        j = truncate(Math.round((this.aj.count - 1) * LabelCollisionManager.a6.nextDouble()));
                    }
                    let k = g.c;
                    let l = this.l(g, this.aj._inner[j], h, i, false);
                    let m = 0;
                    while (l == null) {
                        if (m >= e) {
                            h = 0;
                            i = 0;
                        }
                        if (m >= f) {
                            break;
                        }
                        j = truncate(Math.round((this.aj.count - 1) * LabelCollisionManager.a6.nextDouble()));
                        l = this.l(g, this.aj._inner[j], h, i, false);
                        m++;
                    }
                    g.c = l;
                    if (k != null) {
                        this.h.d(k);
                    }
                    if (l != null) {
                        this.h.c(l);
                        let n = this.as(g);
                        let o = d > n;
                        if (!o) {
                            let p = Math.exp(-(n - d) / this.al);
                            if (LabelCollisionManager.a6.nextDouble() < p) {
                                o = true;
                            }
                        }
                        if (!o && k != null) {
                            this.h.d(l);
                            this.h.c(k);
                            g.c = k;
                            if (!this.r) {
                                this.as(g);
                            }
                        }
                        else {
                            g.b = this.aj._inner[j];
                            g.k = g.c.d;
                            g.l = g.c.e;
                            this.ah.add(g);
                        }
                    }
                    else {
                        if (!this.r) {
                            this.as(g);
                        }
                        g.f = false;
                        this.ah.add(g);
                    }
                    break;
                }
                b++;
                c = c.a;
            }
        }
        v(a, b) {
            return this.w(a, b);
        }
        w(a, b) {
            if (!a.c(b)) {
                return false;
            }
            if (a.i == null) {
                return true;
            }
            let c = a.i;
            if (c.a == null) {
                if (b.i != null) {
                    let d = b.i;
                    if (d.d == b) {
                        let e = d.a;
                        return e.e(a.j());
                    }
                    else {
                        return true;
                    }
                }
            }
            let f = c.a;
            if (c.d == a) {
                return f.e(b.j());
            }
            if (b.i != null) {
                let g = b.i;
                if (g.d == b) {
                    if (this.ad(this.g)) {
                        return false;
                    }
                    let h = g.a;
                    return h.e(a.j());
                }
                else {
                    return true;
                }
            }
            return true;
        }
        as(a) {
            if (this.r) {
                let b = 0;
                let c = this.ag.c;
                while (c != null) {
                    let d = c.c;
                    let e = d.f;
                    d.f = false;
                    if (d.c != null) {
                        let f = this.h.e(d.c);
                        for (let g = 0; g < f.count; g++) {
                            let h = f._inner[g].l.c;
                            while (h != null) {
                                let i = h.c;
                                if (this.ae(i, d)) {
                                    h = h.a;
                                    continue;
                                }
                                if (this.v(d.c, i)) {
                                    d.f = true;
                                    b += d.c.h(i);
                                }
                                h = h.a;
                            }
                        }
                        if (d.f != e) {
                            this.ah.add(d);
                        }
                    }
                    c = c.a;
                }
                return b;
            }
            else {
                if (a != null) {
                    let j = new HashSet$1(LabelCollisionInfo.$, 0);
                    let k = new HashSet$1(LabelCollisionInfo.$, 0);
                    let l = new HashSet$1(LabelCollisionInfo.$, 0);
                    let m = new List$1(LabelCollisionInfo.$, 0);
                    if (a.j != null) {
                        for (let n = 0; n < a.j.count; n++) {
                            j.add_1(a.j._inner[n]);
                            k.add_1(a.j._inner[n]);
                        }
                    }
                    let o = a.f;
                    a.f = false;
                    if (a.c != null) {
                        let p = this.h.e(a.c);
                        for (let q = 0; q < p.count; q++) {
                            let r = p._inner[q].l.c;
                            while (r != null) {
                                let s = r.c;
                                if (this.ae(s, a)) {
                                    r = r.a;
                                    continue;
                                }
                                if (this.v(a.c, s) && !l.contains(s.i)) {
                                    a.f = true;
                                    l.add_1(s.i);
                                    m.add(s.i);
                                }
                                r = r.a;
                            }
                        }
                        p = this.h.e(a.e);
                        for (let t = 0; t < p.count; t++) {
                            let u = p._inner[t].l.c;
                            while (u != null) {
                                let v = u.c;
                                if (this.ae(v, a)) {
                                    u = u.a;
                                    continue;
                                }
                                if (this.s(a.e, v)) {
                                    u = u.a;
                                    continue;
                                }
                                if (this.v(a.e, v) && !l.contains(v.i)) {
                                    a.f = true;
                                    l.add_1(v.i);
                                    m.add(v.i);
                                }
                                u = u.a;
                            }
                        }
                        if (a.f != o) {
                            this.ah.add(a);
                        }
                        if (a.j != null) {
                            for (let w = a.j.count - 1; w >= 0; w--) {
                                if (!l.contains(a.j._inner[w])) {
                                    let x = a.j._inner[w];
                                    let y = false;
                                    if (x != a) {
                                        y = x.j.remove(a);
                                    }
                                    else {
                                    }
                                    a.j.removeAt(w);
                                    if (x.j.count == 0 && y) {
                                        this.az--;
                                    }
                                    let z = j.remove(x);
                                    if (j.count == 0 && z) {
                                        this.az--;
                                    }
                                }
                            }
                        }
                        for (let aa = 0; aa < m.count; aa++) {
                            let ab = m._inner[aa];
                            if (!j.contains(ab)) {
                                if (a.j == null) {
                                    a.j = new List$1(LabelCollisionInfo.$, 0);
                                }
                                a.j.add(ab);
                                if (j.count == 0) {
                                    this.az++;
                                }
                                j.add_1(ab);
                                if (ab != a) {
                                    if (ab.j == null) {
                                        ab.j = new List$1(LabelCollisionInfo.$, 0);
                                    }
                                    if (ab.j.count == 0) {
                                        this.az++;
                                    }
                                    ab.j.add(a);
                                }
                            }
                        }
                    }
                }
                return this.az;
            }
        }
        s(a, b) {
            if ((((a.i != null) && a.i.e == a) || ((a.i != null) && a.i.d == a)) && (((a.i != null) && a.i.e == b) || ((a.i != null) && a.i.d == b))) {
                return true;
            }
            return false;
        }
        get a3() {
            return this.az;
        }
        bm(a, b, c) {
            this.bu = c;
            let d = new QuadTree(a, b, this.h.i, this.h.f);
            let e = this.ag.c;
            while (e != null) {
                d.c(e.c.e);
                if (e.c.d != null) {
                    d.c(e.c.d);
                }
                if (e.c.c != null) {
                    d.c(e.c.c);
                }
                e = e.a;
            }
            this.h = d;
            this.aw = a;
            this.at = b;
        }
        ab() {
            let a = this.ag.c;
            while (a != null) {
                a.c.f = false;
                if (a.c.c != null) {
                    if (this.x(a.c.c)) {
                        return true;
                    }
                }
                a = a.a;
            }
            return false;
        }
        t() {
            let a = this.ag.c;
            let b = this.aj;
            while (a != null) {
                if (a.c.c != null) {
                    if (this.x(a.c.c)) {
                        let c = a.c;
                        for (let d = 0; d < b.count; d++) {
                            let e = this.l(c, b._inner[d], 0, 0, false);
                            if (e != null) {
                                return true;
                            }
                        }
                    }
                }
                a = a.a;
            }
            return false;
        }
        a4() {
            let a = this.ag.c;
            while (a != null) {
                a.c.f = false;
                a = a.a;
            }
            a = this.ag.c;
            while (a != null) {
                let b = a.c.c;
                let c = a.c.e;
                let d = this.h.e(c);
                for (let e = 0; e < d.count; e++) {
                    let f = d._inner[e].l.c;
                    while (f != null) {
                        let g = f.c;
                        if (this.s(c, g)) {
                            f = f.a;
                            continue;
                        }
                        if (this.v(c, g)) {
                            let h = f.c.i;
                            if (!this.ae(f.c, a.c)) {
                                h.f = true;
                                a.c.f = true;
                            }
                        }
                        f = f.a;
                    }
                }
                if (b == null) {
                    return -1;
                }
                d = this.h.e(b);
                for (let i = 0; i < d.count; i++) {
                    let j = d._inner[i].l.c;
                    while (j != null) {
                        let k = j.c;
                        if (this.v(b, k)) {
                            let l = j.c.i;
                            if (!this.ae(j.c, a.c)) {
                                l.f = true;
                                a.c.f = true;
                            }
                        }
                        j = j.a;
                    }
                }
                a = a.a;
            }
            let m = 0;
            let n = 1.7976931348623157E+308;
            let o = -1.7976931348623157E+308;
            let p = 1.7976931348623157E+308;
            let q = -1.7976931348623157E+308;
            a = this.ag.c;
            while (a != null) {
                if (a.c.f) {
                    m++;
                    if (!isNaN_(a.c.s) && !isNaN_(a.c.t)) {
                        n = Math.min(n, a.c.s);
                        o = Math.max(o, a.c.s);
                        p = Math.min(p, a.c.t);
                        q = Math.max(q, a.c.t);
                    }
                }
                a = a.a;
            }
            this.am = Math.abs(o - n);
            this.an = Math.abs(q - p);
            return m;
        }
        bj(a) {
            let b = this.ag.c;
            if (this.ad(this.g)) {
                this.bk();
                return;
            }
            while (b != null) {
                let c = b.c;
                if (c.c == null || a) {
                    let d = false;
                    if (a) {
                        let e = this.h.a(c.s, c.t, 1.5);
                        let f = this.c(e);
                        if (f != null) {
                            for (let g = 0; g < f.length; g++) {
                                let h = f[g];
                                let i = this.l(c, h, 0, 0, false);
                                if (i == null) {
                                    continue;
                                }
                                let j = this.h.e(i);
                                d = true;
                                for (let k = 0; k < j.count; k++) {
                                    let l = j._inner[k].l.c;
                                    while (l != null) {
                                        let m = l.c;
                                        if (this.v(i, m)) {
                                            d = false;
                                            break;
                                        }
                                        l = l.a;
                                    }
                                }
                                if (d) {
                                    c.c = i;
                                    c.b = h;
                                    c.k = c.c.d;
                                    c.l = c.c.e;
                                    this.h.c(c.c);
                                    this.ah.add(c);
                                    break;
                                }
                            }
                        }
                    }
                    if (!d) {
                        d = this.z(c, false);
                    }
                    if (!d) {
                        if (c.c == null) {
                            this.z(c, true);
                        }
                    }
                }
                b = b.a;
            }
        }
        bk() {
            let a = this.ag.c;
            let b = new List$1(LabelCollisionInfo.$, 0);
            let c = new List$1(LabelCollisionInfo.$, 0);
            let d = new List$1(LabelCollisionInfo.$, 0);
            let e = new List$1(LabelCollisionInfo.$, 0);
            let f = this.g;
            while (a != null) {
                let g = a.c;
                let h = g.a;
                if (g.a == null || h.type != 2) {
                    g.h = true;
                    this.ah.add(g);
                    a = a.a;
                    continue;
                }
                let i = h;
                let j = this.bt(i);
                let k = g;
                let l = k.p + k.p;
                let m = k.o + k.o;
                let n = (i.startAngle + i.endAngle) / 2;
                n = MathUtil.f(n);
                let o = Rect.empty;
                if (f == 3 || f == 7) {
                    let p = this.i(k);
                    if (p != null) {
                        if (this.u(p, g)) {
                            if (f == 7) {
                                this.bf(k);
                                a = a.a;
                                continue;
                            }
                        }
                        else {
                            k.b = 8;
                            this.bq(k, p);
                            d.add(k);
                            this.ah.add(k);
                            this.h.c(p);
                            a = a.a;
                            continue;
                        }
                    }
                    if (k.h) {
                        a = a.a;
                        continue;
                    }
                }
                if (f == 5 || f == 3) {
                    let q = this.j(k);
                    if (q != null) {
                        if (this.u(q, g)) {
                            if (f == 5) {
                                this.bf(k);
                                a = a.a;
                                continue;
                            }
                        }
                        else {
                            k.b = 9;
                            e.add(k);
                            this.bq(k, q);
                            this.ah.add(k);
                            this.h.c(q);
                            a = a.a;
                            continue;
                        }
                    }
                    if (k.h) {
                        a = a.a;
                        continue;
                    }
                }
                let r = this.k(k);
                if (r != null) {
                    k.b = 10;
                    this.bq(k, r);
                    this.ah.add(k);
                    this.h.c(k.c);
                    if (k.c.d < j.x) {
                        c.add(k);
                    }
                    else {
                        b.add(k);
                    }
                }
                else {
                    this.bf(k);
                }
                a = a.a;
            }
            this.bo(b);
            this.bn(b);
            this.bo(c);
            this.bn(c);
        }
        bq(a, b) {
            let c = new List$1(LabelCollisionInfo.$, 0);
            let d = new HashSet$1(LabelCollisionInfo.$, 0);
            if (!this.r) {
                c = new List$1(LabelCollisionInfo.$, 0);
            }
            this.bb(a, b, c, d);
            let e = a.e;
            if (e == null) {
                e = new QuadTreeBoundingBox();
                e.i = a;
                e.d = a.s;
                e.e = a.t;
                e.g = a.r;
                e.f = a.q;
                this.h.c(e);
                a.e = e;
            }
            this.bb(a, e, c, d);
            this.af(a, c);
            a.c = b;
            a.k = a.c.d;
            a.l = a.c.e;
        }
        bb(a, b, c, d) {
            if (this.u(b, a)) {
                let e = this.h.e(b);
                for (let f = 0; f < e.count; f++) {
                    let g = e._inner[f].l.c;
                    while (g != null) {
                        let h = g.c;
                        if (this.v(b, h)) {
                            if (!this.r) {
                                if (!d.contains(h.i)) {
                                    c.add(h.i);
                                    d.add_1(h.i);
                                }
                            }
                        }
                        g = g.a;
                    }
                }
            }
        }
        k(a) {
            let b = null;
            let c = a.a;
            if (c == null) {
                return null;
            }
            let d = this.bt(c);
            let e = a.p + a.p;
            let f = a.o + a.o;
            let g = (c.startAngle + c.endAngle) / 2;
            g = MathUtil.f(g);
            let h = GeometryUtil.q(d, g, c.radius + this.au);
            a.b = 10;
            this.bg(a);
            let i = LabelCollisionManager.ap(d, c.radius, c, a);
            let j = GeometryUtil.q(d, g, i);
            let k = new Rect(0, j.x - e / 2, j.y - f / 2, e, f);
            if (g < 90 && g >= 0) {
                k = new Rect(0, h.x, h.y, e, f);
            }
            else if (g < 180 && g >= 90) {
                k = new Rect(0, h.x - e, h.y, e, f);
            }
            else if (g < 270 && g >= 180) {
                k = new Rect(0, h.x - e, h.y - f, e, f);
            }
            else {
                k = new Rect(0, h.x, h.y - f, e, f);
            }
            if (k.y < 0) {
                k = new Rect(0, k.x, 0, k.width, k.height);
            }
            if (k.bottom > this.bu.bottom) {
                k = new Rect(0, k.x, this.bu.bottom - k.height, k.width, k.height);
            }
            b = ((() => {
                let $ret = new QuadTreeBoundingBox();
                $ret.d = k.left + k.width / 2;
                $ret.e = k.top + k.height / 2;
                $ret.g = k.width / 2;
                $ret.f = k.height / 2;
                $ret.i = a;
                return $ret;
            })());
            return b;
        }
        bg(a) {
            if (a == null) {
                return;
            }
            let b = !a.h;
            if (b) {
                return;
            }
            a.h = false;
            this.ah.add(a);
        }
        bf(a) {
            if (a == null) {
                return;
            }
            let b = !a.h;
            if (!b) {
                return;
            }
            a.h = true;
            this.ah.add(a);
        }
        j(a) {
            let b = null;
            let c = a.a;
            if (c == null) {
                return null;
            }
            let d = this.bt(c);
            let e = a.p + a.p;
            let f = a.o + a.o;
            let g = (c.startAngle + c.endAngle) / 2;
            g = MathUtil.f(g);
            let h = LabelCollisionManager.ap(d, c.radius, c, a);
            let i = GeometryUtil.q(d, g, h);
            let j = new Rect(0, i.x - e / 2, i.y - f / 2, e, f);
            let k = this.aa(c, j, a, d);
            if (k || this.g == 5) {
                a.b = 9;
                if (!k && this.g == 5) {
                    this.bf(a);
                }
                else {
                    b = ((() => {
                        let $ret = new QuadTreeBoundingBox();
                        $ret.d = j.left + j.width / 2;
                        $ret.e = j.top + j.height / 2;
                        $ret.g = j.width / 2;
                        $ret.f = j.height / 2;
                        $ret.i = a;
                        return $ret;
                    })());
                    this.bg(a);
                    return b;
                }
            }
            return b;
        }
        i(a) {
            let b = null;
            let c = a.a;
            if (c == null) {
                return null;
            }
            let d = this.bt(c);
            let e = a.p + a.p;
            let f = a.o + a.o;
            let g = (c.startAngle + c.endAngle) / 2;
            g = MathUtil.f(g);
            let h = c.innerRadius;
            let i = GeometryUtil.q(d, g, c.radius - (c.radius - h) / 2);
            let j = new Rect(0, i.x - a.p, i.y - a.o, e, f);
            let k = this.aa(c, j, a, i);
            if (k || this.g == 7) {
                a.b = 8;
                if (!k && this.g == 7) {
                    this.bf(a);
                }
                else {
                    this.bg(a);
                    b = ((() => {
                        let $ret = new QuadTreeBoundingBox();
                        $ret.d = j.left + j.width / 2;
                        $ret.e = j.top + j.height / 2;
                        $ret.g = j.width / 2;
                        $ret.f = j.height / 2;
                        $ret.i = a;
                        return $ret;
                    })());
                    return b;
                }
            }
            return b;
        }
        static ap(a, b, c, d) {
            let e = (c.startAngle + c.endAngle / 2);
            e = MathUtil.f(e);
            let f = e * Math.PI / 180;
            let g = 1;
            let h = GeometryUtil.q({ $type: Point_$type, x: 0, y: 0 }, e, g);
            let i = LabelCollisionManager.bs(c, d);
            let j = Math.sqrt(i.x * i.x + i.y * i.y);
            let k = { $type: Point_$type, x: i.x / j, y: i.y / j };
            let l = LabelCollisionManager.aq(h, k);
            let m = j / b;
            let n = l * m;
            let o = n;
            let p = GeometryUtil.i({ $type: Point_$type, x: 0, y: 0 }, h);
            let q = GeometryUtil.i({ $type: Point_$type, x: 0, y: 0 }, k);
            if (q < p) {
                o = -o;
            }
            let r = GeometryUtil.q(a, (f + o) * 180 / Math.PI, b);
            let s = LabelCollisionManager.br(c, d, r);
            let t = Math.sqrt((s.x - a.x) * (s.x - a.x) + (s.y - a.y) * (s.y - a.y));
            let u = t - 5;
            return u;
        }
        static br(a, b, c) {
            let d = (a.startAngle + a.endAngle / 2);
            d = MathUtil.f(d);
            let e = GeometryUtil.m(d);
            let f = b.p;
            let g = b.o;
            if (e >= 0 && e <= 90) {
                return { $type: Point_$type, x: c.x - f, y: c.y - g };
            }
            if (e >= 90 && e <= 180) {
                return { $type: Point_$type, x: c.x + f, y: c.y - g };
            }
            if (e >= 180 && e <= 270) {
                return { $type: Point_$type, x: c.x + f, y: c.y + g };
            }
            return { $type: Point_$type, x: c.x - f, y: c.y + g };
        }
        static aq(a, b) {
            let c = a.x * b.x + a.y * b.y;
            let d = Math.sqrt(a.x * a.x + a.y * a.y);
            let e = Math.sqrt(b.x * b.x + b.y * b.y);
            let f = Math.acos(c / (d * e));
            return f;
        }
        static bs(a, b) {
            let c = (a.startAngle + a.endAngle / 2);
            c = MathUtil.f(c);
            let d = GeometryUtil.m(c);
            let e = b.p;
            let f = b.o;
            if (d >= 0 && d <= 90) {
                return { $type: Point_$type, x: e, y: f };
            }
            if (d >= 90 && d <= 180) {
                return { $type: Point_$type, x: -e, y: f };
            }
            if (d >= 180 && d <= 270) {
                return { $type: Point_$type, x: -e, y: -f };
            }
            return { $type: Point_$type, x: e, y: -f };
        }
        static ao(a, b, c, d) {
            let e = MathUtil.g(a - b, c - d);
            let f = Math.asin((c - d) / e) * 180 / Math.PI;
            if (a < b) {
                f = 180 - f;
            }
            if (a > b) {
                f = 360 + f;
            }
            if (f == 360) {
                f = 0;
            }
            return GeometryUtil.m(f);
        }
        bo(a) {
            let b = new Array(a.count);
            for (let c = 0; c < a.count; c++) {
                let d = a._inner[c];
                let e = d.a;
                let f = this.bt(e);
                let g = (e.startAngle + e.endAngle) / 2;
                g = MathUtil.f(g);
                let h = GeometryUtil.q(f, g, e.radius);
                b[c] = h.y;
            }
            for (let i = 0; i < a.count; i++) {
                for (let j = i + 1; j < a.count; j++) {
                    if (b[i] >= b[j]) {
                        let k = a._inner[i];
                        a._inner[i] = a._inner[j];
                        a._inner[j] = k;
                        let l = b[i];
                        b[i] = b[j];
                        b[j] = l;
                    }
                }
            }
        }
        bn(a) {
            if (a.count == 0) {
                return;
            }
            let b = this.bu.width;
            let c = this.bu.height;
            let d = a.count;
            let e = a._inner[0].a;
            let f = e.radius;
            let g = this.bt(e);
            let h = true;
            let i = 0;
            let j = Number.POSITIVE_INFINITY;
            let k = Number.NEGATIVE_INFINITY;
            i = this.a4();
            let l = 0;
            for (let m of fromEnum(a)) {
                j = Math.min(j, m.o + m.o);
                k = Math.max(k, m.o + m.o);
                l += m.o + m.o;
            }
            if (l > c) {
                h = false;
            }
            if (h && i > 0) {
                for (let n = 0; n < d - 1; n++) {
                    for (let o = n + 1; o < d; o++) {
                        let p = a._inner[n];
                        let q = a._inner[o];
                        if (p.c.c(q.c)) {
                            let r = q.c;
                            let s = r.e - r.f;
                            let t = r.g + r.g;
                            let u = MathUtil.f(this.ar(q));
                            let v = Math.min(p.c.e + p.c.f + 0.01, c - j);
                            let w = this.au + f;
                            let x = Math.abs(g.y - (s + j / 2));
                            let y = Math.sqrt(Math.abs(w * w - x * x));
                            let z = GeometryUtil.m(u);
                            if (z > 90 && z < 270) {
                                y = (t + y) * -1;
                            }
                            let aa = g.x + y;
                            let ab = ((() => {
                                let $ret = new QuadTreeBoundingBox();
                                $ret.d = aa + r.g;
                                $ret.e = v + r.f;
                                $ret.g = r.g;
                                $ret.f = r.f;
                                $ret.i = q;
                                return $ret;
                            })());
                            if (q.c != null) {
                                this.h.d(q.c);
                            }
                            this.bq(q, ab);
                            this.h.c(q.c);
                        }
                    }
                }
                for (let ac = d - 1; ac > 0; ac--) {
                    for (let ad = ac - 1; ad >= 0; ad--) {
                        let ae = a._inner[ac];
                        let af = a._inner[ad];
                        if (ae.c.c(af.c)) {
                            let ag = af.c;
                            let ah = ag.e - ag.f;
                            let ai = ag.g + ag.g;
                            let aj = Math.max((ae.c.e - ae.c.f) - j - 0.01, 0);
                            let ak = this.au + f;
                            let al = Math.abs(g.y - (ah + j / 2));
                            let am = Math.sqrt(Math.abs(ak * ak - al * al));
                            let an = GeometryUtil.m(MathUtil.f(this.ar(af)));
                            if (an > 90 && an < 270) {
                                am = (ai + am) * -1;
                            }
                            let ao = g.x + am;
                            let ap = ((() => {
                                let $ret = new QuadTreeBoundingBox();
                                $ret.d = ao + ag.g;
                                $ret.e = aj + ag.f;
                                $ret.g = ag.g;
                                $ret.f = ag.f;
                                $ret.i = af;
                                return $ret;
                            })());
                            if (af.c != null) {
                                this.h.d(af.c);
                            }
                            this.bq(af, ap);
                            this.h.c(af.c);
                        }
                    }
                }
            }
            for (let aq of fromEnum(a)) {
                let ar = aq.c.j();
                if (ar.left > b || ar.right < 0) {
                    this.bf(aq);
                    if (aq.c != null) {
                        this.h.d(aq.c);
                    }
                    this.af(aq, null);
                    aq.c = null;
                }
                else if (ar.left < 0) {
                    this.bf(aq);
                    if (aq.c != null) {
                        this.h.d(aq.c);
                    }
                    this.af(aq, null);
                    aq.c = null;
                }
                else if (ar.right > b) {
                    this.bf(aq);
                    if (aq.c != null) {
                        this.h.d(aq.c);
                    }
                    this.af(aq, null);
                    aq.c = null;
                }
            }
        }
        ar(a) {
            let b = a.a;
            return (b.startAngle + b.endAngle) / 2;
        }
        static av(a) {
            let b = Math.round(a * Math.pow(10, 5)) / Math.pow(10, 5);
            return b;
        }
        ac(a) {
            return LabelCollisionManager.av(MathUtil.f(Math.abs(a.endAngle - a.startAngle))) == 360;
        }
        aa(a, b, c, d) {
            if (a == null) {
                return false;
            }
            let e = this.bt(a);
            let f = Math.min(a.startAngle, a.endAngle);
            let g = Math.max(a.startAngle, a.endAngle);
            f = MathUtil.f(f);
            g = MathUtil.f(g);
            let h = false;
            let i = false;
            let j = GeometryUtil.q(e, f, a.radius);
            let k = GeometryUtil.q(e, g, a.radius);
            f = LabelCollisionManager.ao(j.x, e.x, j.y, e.y);
            g = LabelCollisionManager.ao(k.x, e.x, k.y, e.y);
            if (this.ac(a)) {
                i = true;
            }
            let l;
            l = MathUtil.g(b.right - e.x, b.top - e.y);
            if (l > a.radius) {
                return false;
            }
            l = MathUtil.g(b.right - e.x, b.bottom - e.y);
            if (l > a.radius) {
                return false;
            }
            l = MathUtil.g(b.left - e.x, b.top - e.y);
            if (l > a.radius) {
                return false;
            }
            l = MathUtil.g(b.left - e.x, b.bottom - e.y);
            if (l > a.radius) {
                return false;
            }
            if (i) {
                return true;
            }
            if (f > g) {
                f = f - 360;
                h = true;
            }
            let m;
            m = LabelCollisionManager.ao(b.right, e.x, b.top, e.y);
            if (h && m > 180 && m < 360) {
                m = m - 360;
            }
            if (m < f || m > g) {
                return false;
            }
            m = LabelCollisionManager.ao(b.right, e.x, b.bottom, e.y);
            if (h && m > 180 && m < 360) {
                m = m - 360;
            }
            if (m < f || m > g) {
                return false;
            }
            m = LabelCollisionManager.ao(b.left, e.x, b.top, e.y);
            if (h && m > 180 && m < 360) {
                m = m - 360;
            }
            if (m < f || m > g) {
                return false;
            }
            m = LabelCollisionManager.ao(b.left, e.x, b.bottom, e.y);
            if (h && m > 180 && m < 360) {
                m = m - 360;
            }
            if (m < f || m > g) {
                return false;
            }
            return true;
        }
        bt(a) {
            return { $type: Point_$type, x: a.centerX, y: a.centerY };
        }
        ad(a) {
            return a == 7 || a == 3 || a == 6 || a == 4 || a == 5;
        }
        z(a, b) {
            let c = this.aj;
            a.h = false;
            let d = false;
            if (!d) {
                for (let e = 0; e < c.count; e++) {
                    let f = this.l(a, c._inner[e], 0, 0, b);
                    if (a.h) {
                        break;
                    }
                    if (f == null) {
                        continue;
                    }
                    d = !this.u(f, a);
                    let g = a.e;
                    if (g == null) {
                        g = new QuadTreeBoundingBox();
                        g.i = a;
                        g.d = a.s;
                        g.e = a.t;
                        g.g = a.r;
                        g.f = a.q;
                        this.h.c(g);
                        a.e = g;
                    }
                    if (a.a != null) {
                        if (a.d == null) {
                            a.d = QuadTreeBoundingBox.a(a.a.boundingBox);
                            a.d.i = a;
                            this.h.c(a.d);
                        }
                    }
                    let h = this.u(g, a);
                    d = d && !h;
                    if (d) {
                        a.c = f;
                        if (c._inner[e] != 11) {
                            a.b = c._inner[e];
                        }
                        a.k = a.c.d;
                        a.l = a.c.e;
                        this.h.c(a.c);
                        this.ah.add(a);
                        break;
                    }
                }
            }
            if (!d && !a.h) {
                let i = Number.POSITIVE_INFINITY;
                let j = 0;
                let k = null;
                for (let l = 0; l < c.count; l++) {
                    let m = 0;
                    let n = null;
                    let o = new HashSet$1(LabelCollisionInfo.$, 0);
                    if (!this.r) {
                        n = new List$1(LabelCollisionInfo.$, 0);
                    }
                    let p = this.l(a, c._inner[l], 0, 0, b);
                    if (p == null) {
                        continue;
                    }
                    let q = this.h.e(p);
                    for (let r = 0; r < q.count; r++) {
                        let s = q._inner[r].l.c;
                        while (s != null) {
                            let t = s.c;
                            if (this.v(p, t)) {
                                m += p.h(t);
                                if (!this.r) {
                                    if (!o.contains(t.i)) {
                                        n.add(t.i);
                                        o.add_1(t.i);
                                    }
                                }
                            }
                            s = s.a;
                        }
                    }
                    let u = a.e;
                    if (u == null) {
                        u = new QuadTreeBoundingBox();
                        u.i = a;
                        u.d = a.s;
                        u.e = a.t;
                        u.g = a.r;
                        u.f = a.q;
                    }
                    q = this.h.e(u);
                    for (let v = 0; v < q.count; v++) {
                        let w = q._inner[v].l.c;
                        while (w != null) {
                            let x = w.c;
                            if (this.ae(w.c, a)) {
                                w = w.a;
                                continue;
                            }
                            if (this.s(u, x)) {
                                w = w.a;
                                continue;
                            }
                            if (this.v(u, x)) {
                                if (!this.r) {
                                    if (!o.contains(x.i)) {
                                        n.add(x.i);
                                        o.add_1(x.i);
                                    }
                                }
                            }
                            w = w.a;
                        }
                    }
                    if (m < i) {
                        let y = this.l(a, c._inner[l], 0, 0, b);
                        if (y != null) {
                            i = m;
                            j = l;
                            if (!this.r) {
                                k = n;
                            }
                        }
                    }
                }
                let z = this.l(a, c._inner[j], 0, 0, b);
                a.f = true;
                if (!this.af(a, k)) {
                    return false;
                }
                a.h = false;
                a.c = z;
                a.b = c._inner[j];
                a.k = a.c.d;
                a.l = a.c.e;
                this.h.c(a.c);
                this.ah.add(a);
            }
            return d;
        }
        af(a, b) {
            if (!this.r) {
                if (a.j != null && a.j.count > 0) {
                    this.az--;
                    for (let c = a.j.count - 1; c >= 0; c--) {
                        let d = a.j._inner[c];
                        if (d.j != null) {
                            d.j.remove(a);
                            if (d.j.count == 0) {
                                this.az--;
                            }
                        }
                    }
                }
                if (b == null) {
                    a.f = false;
                    this.ah.add(a);
                    return false;
                }
                a.j = b;
                if (b.count > 0) {
                    this.az++;
                }
                for (let e = 0; e < b.count; e++) {
                    let f = b._inner[e];
                    if (f.j == null) {
                        f.j = new List$1(LabelCollisionInfo.$, 0);
                    }
                    if (!f.j.contains(a)) {
                        if (f.j.count == 0) {
                            this.az++;
                        }
                        f.j.add(a);
                    }
                }
            }
            return true;
        }
        ae(a, b) {
            if (a.i == b && (a.i == null || a.i.d != a)) {
                return true;
            }
            return false;
        }
        u(a, b) {
            let c = false;
            let d = this.h.e(a);
            for (let e = 0; e < d.count; e++) {
                let f = d._inner[e].l.c;
                while (f != null) {
                    if (this.ae(f.c, b)) {
                        f = f.a;
                        continue;
                    }
                    let g = f.c;
                    if (this.s(a, g)) {
                        f = f.a;
                        continue;
                    }
                    if (this.v(a, g)) {
                        c = true;
                        break;
                    }
                    f = f.a;
                }
            }
            return c;
        }
        c(a) {
            let b = new Array(3);
            let c = GeometryUtil.i({ $type: Point_$type, x: 0, y: 0 }, { $type: Point_$type, x: a.a, y: a.b });
            c = c * 180 / Math.PI;
            c = GeometryUtil.m(c);
            if ((c >= 0 && c <= 22.5) || (c >= 337.5 && c <= 360)) {
                b[0] = 2;
                b[1] = 5;
                b[2] = 7;
            }
            if (c >= 22.5 && c <= 67.5) {
                b[0] = 2;
                b[1] = 7;
                b[2] = 3;
            }
            if (c >= 67.5 && c <= 112.5) {
                b[0] = 7;
                b[1] = 3;
                b[2] = 6;
            }
            if (c >= 112.5 && c <= 157.5) {
                b[0] = 3;
                b[1] = 6;
                b[2] = 1;
            }
            if (c >= 157.5 && c <= 202.5) {
                b[0] = 6;
                b[1] = 1;
                b[2] = 4;
            }
            if (c >= 202.5 && c <= 247.5) {
                b[0] = 1;
                b[1] = 4;
                b[2] = 0;
            }
            if (c >= 247.5 && c <= 292.5) {
                b[0] = 4;
                b[1] = 0;
                b[2] = 5;
            }
            if (c >= 292.5 && c <= 337.5) {
                b[0] = 0;
                b[1] = 5;
                b[2] = 2;
            }
            if (this.o) {
                let d = 0;
                for (let e = 0; e < b.length; e++) {
                    if (this.a[b[e]]) {
                        d++;
                    }
                }
                if (d == 0) {
                    return null;
                }
                let f = 0;
                let g = new Array(d);
                for (let h = 0; h < b.length; h++) {
                    if (this.a[b[h]]) {
                        g[f] = b[h];
                        f++;
                    }
                }
                b = g;
            }
            return b;
        }
        f(a, b) {
            let c = false;
            let d = null;
            let e = new QuadTreeBoundingBox();
            e.d = a.x;
            e.e = a.y;
            e.g = 5;
            e.f = 5;
            let f = this.h.e(e);
            for (let g = 0; g < f.count; g++) {
                let h = f._inner[g].l.c;
                while (h != null) {
                    let i = h.c;
                    if (i.i.e == i) {
                        h = h.a;
                        continue;
                    }
                    if (this.v(e, i)) {
                        d = i;
                        c = true;
                        break;
                    }
                    h = h.a;
                }
            }
            if (c) {
                return d.i;
            }
            else {
                return null;
            }
        }
        y() {
            return this.am < 10 && this.an < 10;
        }
    }
    LabelCollisionManager.$t = /*@__PURE__*/ markType(LabelCollisionManager, 'LabelCollisionManager');
    LabelCollisionManager.a6 = /*@__PURE__*/ new Random(0);
    return LabelCollisionManager;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var CollisionGeometryType = /*@__PURE__*/ (function (CollisionGeometryType) {
    CollisionGeometryType[CollisionGeometryType["Box"] = 0] = "Box";
    CollisionGeometryType[CollisionGeometryType["Boxes"] = 1] = "Boxes";
    CollisionGeometryType[CollisionGeometryType["PieSlice"] = 2] = "PieSlice";
    CollisionGeometryType[CollisionGeometryType["Circle"] = 3] = "Circle";
    return CollisionGeometryType;
})({});
/**
 * @hidden
 */
let CollisionGeometryType_$type = /*@__PURE__*/ markEnum('CollisionGeometryType', 'Box,0|Boxes,1|PieSlice,2|Circle,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CollisionRect = /*@__PURE__*/ (() => {
    class CollisionRect extends Base {
        constructor(a, ..._rest) {
            super();
            this.u = 0;
            this.v = 0;
            this.t = 0;
            this.p = 0;
            this.s = 0;
            this.q = 0;
            this.r = 0;
            this.o = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        this.left = c.left;
                        this.top = c.top;
                        this.width = c.width;
                        this.height = c.height;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        this.top = d;
                        this.left = c;
                        this.width = e;
                        this.height = f;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        this.top = d;
                        this.left = c;
                        this.width = e.width;
                        this.height = e.height;
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.top = Math.min(c.y, d.y);
                        this.left = Math.min(c.x, d.x);
                        this.width = Math.max(Math.max(c.x, d.x) - this.left, 0);
                        this.height = Math.max(Math.max(c.y, d.y) - this.top, 0);
                    }
                    break;
                case 4:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.top = c.y;
                        this.left = c.x;
                        this.width = d.width;
                        this.height = d.height;
                    }
                    break;
                case 5:
                    {
                        this.top = 0;
                        this.left = 0;
                        this.width = 0;
                        this.height = 0;
                    }
                    break;
            }
        }
        get x() {
            return this.u;
        }
        set x(a) {
            this.u = a;
            this.q = this.u;
            this.r = this.q + this.t;
        }
        get y() {
            return this.v;
        }
        set y(a) {
            this.v = a;
            this.s = this.v;
            this.o = this.s + this.p;
        }
        get width() {
            return this.t;
        }
        set width(a) {
            this.t = a;
            this.r = this.q + this.t;
        }
        get height() {
            return this.p;
        }
        set height(a) {
            this.p = a;
            this.o = this.s + this.p;
        }
        get top() {
            return this.s;
        }
        set top(a) {
            this.s = a;
            this.y = this.s;
        }
        get left() {
            return this.q;
        }
        set left(a) {
            this.q = a;
            this.x = this.q;
        }
        get right() {
            return this.r;
        }
        set right(a) {
            this.r = a;
            this.t = this.r - this.q;
        }
        get bottom() {
            return this.o;
        }
        set bottom(a) {
            this.o = a;
            this.p = this.o - this.s;
        }
        get isEmpty() {
            return this.t < 0;
        }
        static get empty() {
            return new CollisionRect(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY, Number.NEGATIVE_INFINITY, Number.NEGATIVE_INFINITY);
        }
        equals(a) {
            if (CollisionRect.l_op_Equality(a, null)) {
                return false;
            }
            if (a.x == this.x && a.y == this.y && a.width == this.width && a.height == this.height) {
                return true;
            }
            return false;
        }
        f(a, b) {
            return a >= this.u && a - this.t <= this.u && b >= this.v && b - this.p <= this.v;
        }
        containsLocation(a, b) {
            return !this.isEmpty && this.f(a, b);
        }
        containsPoint(a) {
            return this.containsLocation(a.x, a.y);
        }
        containsRect(a) {
            return !this.isEmpty && !a.isEmpty && (this.u <= a.u && this.v <= a.v && this.u + this.t >= a.u + a.t) && this.v + this.p >= a.v + a.p;
        }
        inflate(a, b) {
            this.x -= a;
            this.y -= b;
            this.width += a * 2;
            this.height += b * 2;
            if (this.t < 0 || this.p < 0) {
                this.ah();
            }
        }
        ah() {
            this.top = Number.POSITIVE_INFINITY;
            this.left = Number.POSITIVE_INFINITY;
            this.width = Number.NEGATIVE_INFINITY;
            this.height = Number.NEGATIVE_INFINITY;
        }
        intersectsWith(a) {
            if (this.isEmpty || a.isEmpty) {
                return false;
            }
            return a.left < this.right && this.left < a.right && a.top < this.bottom && this.top < a.bottom;
        }
        intersect(a) {
            if (!this.intersectsWith(a)) {
                this.ah();
            }
            else {
                let b = Math.max(this.x, a.x);
                let c = Math.max(this.y, a.y);
                let d = Math.min(this.x + this.width, a.x + a.width) - b;
                let e = Math.min(this.y + this.height, a.y + a.height) - c;
                if (d < 0) {
                    d = 0;
                }
                if (e < 0) {
                    e = 0;
                }
                this.t = d;
                this.p = e;
                this.u = b;
                this.v = c;
                this.q = this.u;
                this.s = this.v;
                this.r = this.q + this.t;
                this.o = this.s + this.p;
            }
        }
        union(a) {
            if (this.isEmpty) {
                this.u = a.x;
                this.v = a.y;
                this.t = a.width;
                this.p = a.height;
                this.q = this.u;
                this.s = this.v;
                this.r = this.q + this.t;
                this.o = this.s + this.p;
                return;
            }
            if (!a.isEmpty) {
                let b = Math.min(this.x, a.x);
                let c = Math.min(this.y, a.y);
                let d = this.width;
                let e = this.height;
                if (a.width == Number.POSITIVE_INFINITY || this.width == Number.POSITIVE_INFINITY) {
                    d = Number.POSITIVE_INFINITY;
                }
                else {
                    let f = Math.max(this.right, a.right);
                    d = f - b;
                }
                if (a.height == Number.POSITIVE_INFINITY || this.height == Number.POSITIVE_INFINITY) {
                    e = Number.POSITIVE_INFINITY;
                }
                else {
                    let g = Math.max(this.bottom, a.bottom);
                    e = g - c;
                }
                this.u = b;
                this.v = c;
                this.t = d;
                this.p = e;
                this.q = this.u;
                this.s = this.v;
                this.r = this.q + this.t;
                this.o = this.s + this.p;
            }
        }
        equals1(a) {
            if (a == null) {
                return super.equals(a);
            }
            let b = a;
            return b.left == this.left && b.top == this.top && b.width == this.width && b.height == this.height;
        }
        getHashCode() {
            return (this.u) ^ (this.v) ^ (this.t) ^ (this.p);
        }
        copy() {
            return new CollisionRect(1, this.x, this.y, this.width, this.height);
        }
        static l_op_Equality(a, b) {
            if (a == null) {
                return b == null;
            }
            else if (b == null) {
                return false;
            }
            return a.u == b.u && a.v == b.v && a.t == b.t && a.p == b.p;
        }
        static l_op_Inequality(a, b) {
            if (a == null) {
                return b != null;
            }
            else if (b == null) {
                return true;
            }
            return a.u != b.u || a.v != b.v || a.t != b.t || a.p != b.p;
        }
    }
    CollisionRect.$t = /*@__PURE__*/ markType(CollisionRect, 'CollisionRect');
    return CollisionRect;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CollisionGeometry = /*@__PURE__*/ (() => {
    class CollisionGeometry extends Base {
        e(a) {
            return this.collidesWith(new CollisionRect(0, a));
        }
        collidesWith(a) {
            if (!this.boundingBox.intersectsWith(a)) {
                return false;
            }
            return this.d(a);
        }
        collidesWithPoint(a, b) {
            let c = new CollisionRect(1, a, b, 0, 0);
            if (!this.boundingBox.intersectsWith(c)) {
                return false;
            }
            return this.d(c);
        }
    }
    CollisionGeometry.$t = /*@__PURE__*/ markType(CollisionGeometry, 'CollisionGeometry');
    return CollisionGeometry;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BoxCollisionGeometry = /*@__PURE__*/ (() => {
    class BoxCollisionGeometry extends CollisionGeometry {
        get_type() {
            return 0;
        }
        get type() {
            return this.get_type();
        }
        constructor(a) {
            super();
            this.g = null;
            this.g = a;
        }
        get_boundingBox() {
            return this.g;
        }
        get boundingBox() {
            return this.get_boundingBox();
        }
        d(a) {
            return true;
        }
    }
    BoxCollisionGeometry.$t = /*@__PURE__*/ markType(BoxCollisionGeometry, 'BoxCollisionGeometry', CollisionGeometry.$);
    return BoxCollisionGeometry;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BoxesCollisionGeometry = /*@__PURE__*/ (() => {
    class BoxesCollisionGeometry extends CollisionGeometry {
        get_type() {
            return 0;
        }
        get type() {
            return this.get_type();
        }
        constructor(a) {
            super();
            this.g = null;
            this.h = CollisionRect.empty;
            this.g = a;
        }
        get_boundingBox() {
            if (this.h.isEmpty) {
                let a = CollisionRect.empty;
                for (let b = 0; b < this.g.length; b++) {
                    a.union(this.g[b]);
                }
                this.h = a;
            }
            return this.h;
        }
        get boundingBox() {
            return this.get_boundingBox();
        }
        d(a) {
            for (let b = 0; b < this.g.length; b++) {
                if (a.intersectsWith(this.g[b])) {
                    return true;
                }
            }
            return false;
        }
    }
    BoxesCollisionGeometry.$t = /*@__PURE__*/ markType(BoxesCollisionGeometry, 'BoxesCollisionGeometry', CollisionGeometry.$);
    return BoxesCollisionGeometry;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CircleCollisionGeometry = /*@__PURE__*/ (() => {
    class CircleCollisionGeometry extends CollisionGeometry {
        get_type() {
            return 0;
        }
        get type() {
            return this.get_type();
        }
        constructor(a, b, c) {
            super();
            this.h = 0;
            this.i = 0;
            this.j = 0;
            this.g = CollisionRect.empty;
            this.h = a;
            this.i = b;
            this.j = c;
        }
        get_boundingBox() {
            if (this.g.isEmpty) {
                this.g = new CollisionRect(1, this.h - this.j, this.i - this.j, this.j + this.j, this.j + this.j);
            }
            return this.g;
        }
        get boundingBox() {
            return this.get_boundingBox();
        }
        d(a) {
            let b = { $type: Point_$type, x: a.left, y: a.top };
            let c = { $type: Point_$type, x: a.right, y: a.top };
            let d = { $type: Point_$type, x: a.right, y: a.bottom };
            let e = { $type: Point_$type, x: a.left, y: a.bottom };
            let f = { $type: Point_$type, x: this.h, y: this.i };
            let g = this.j;
            return GeometryUtil.b(b, f, g) || GeometryUtil.b(c, f, g) || GeometryUtil.b(d, f, g) || GeometryUtil.b(e, f, g);
        }
    }
    CircleCollisionGeometry.$t = /*@__PURE__*/ markType(CircleCollisionGeometry, 'CircleCollisionGeometry', CollisionGeometry.$);
    return CircleCollisionGeometry;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieSliceCollisionGeometry = /*@__PURE__*/ (() => {
    class PieSliceCollisionGeometry extends CollisionGeometry {
        get_type() {
            return 2;
        }
        get type() {
            return this.get_type();
        }
        get centerX() {
            return this.h;
        }
        get centerY() {
            return this.i;
        }
        get radius() {
            return this.l;
        }
        get startAngle() {
            return this.m;
        }
        get endAngle() {
            return this.j;
        }
        constructor(a, b, c, d, e, f) {
            super();
            this.h = 0;
            this.i = 0;
            this.l = 0;
            this.m = 0;
            this.j = 0;
            this.g = CollisionRect.empty;
            this.k = 0;
            this.h = a;
            this.i = b;
            this.m = e;
            this.j = f;
            this.l = c;
            this.k = d;
        }
        get_boundingBox() {
            if (this.g.isEmpty) {
                let a = GeometryUtil.u({ $type: Point_$type, x: this.h, y: this.i }, this.m, this.j, this.l);
                this.g = new CollisionRect(0, a);
            }
            return this.g;
        }
        get boundingBox() {
            return this.get_boundingBox();
        }
        get innerRadius() {
            return this.k;
        }
        d(a) {
            let b = { $type: Point_$type, x: a.left, y: a.top };
            let c = { $type: Point_$type, x: a.right, y: a.top };
            let d = { $type: Point_$type, x: a.right, y: a.bottom };
            let e = { $type: Point_$type, x: a.left, y: a.bottom };
            let f = { $type: Point_$type, x: this.h, y: this.i };
            let g = this.l;
            let h = this.k;
            if (GeometryUtil.e(b, f, this.m, this.j, g, h) || GeometryUtil.e(c, f, this.m, this.j, g, h) || GeometryUtil.e(d, f, this.m, this.j, g, h) || GeometryUtil.e(e, f, this.m, this.j, g, h)) {
                return true;
            }
            return false;
        }
    }
    PieSliceCollisionGeometry.$t = /*@__PURE__*/ markType(PieSliceCollisionGeometry, 'PieSliceCollisionGeometry', CollisionGeometry.$);
    return PieSliceCollisionGeometry;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EdgeClipper = /*@__PURE__*/ (() => {
    class EdgeClipper extends Base {
        constructor() {
            super(...arguments);
            this.h = null;
            this._nextClipper = null;
            this.c = true;
            this.j = null;
            this.l = null;
            this.g = false;
            this.d = false;
            this.f = false;
        }
        get i() {
            return this.h;
        }
        set i(a) {
            if (this.h != a) {
                this.c = true;
                this.h = a;
            }
        }
        get nextClipper() {
            return this._nextClipper;
        }
        set nextClipper(a) {
            this._nextClipper = a;
        }
        add(a) {
            let b = this.e(a);
            if (this.c) {
                this.c = false;
                this.j = a;
            }
            else {
                if (true) {
                    if (b) {
                        if (!this.g) {
                            this.h.add(this.k(this.l, a));
                        }
                        else {
                            if (!this.d && !this.f) {
                                this.h.add(this.l);
                                this.f = true;
                            }
                        }
                        this.h.add(a);
                    }
                    else {
                        if (this.g) {
                            if (!this.d && !this.f) {
                                this.h.add(this.l);
                                this.f = true;
                            }
                            this.h.add(this.k(this.l, a));
                        }
                    }
                }
            }
            this.l = a;
            this.g = b;
        }
        clear() {
            if (this.d && !this.c) {
                this.add(this.j);
            }
            if (this._nextClipper != null) {
                this._nextClipper.clear();
            }
            this.c = true;
            this.f = false;
        }
        getEnumeratorObject() {
            return null;
        }
        getEnumerator() {
            return null;
        }
        get isReadOnly() {
            return false;
        }
        get count() {
            return 0;
        }
        remove(a) {
            return false;
        }
        removeAt(a) {
        }
        copyTo(a, b) {
        }
        contains(a) {
            return false;
        }
        item(a, b) {
            if (arguments.length === 2) {
                return b;
            }
            else {
                return { $type: Point_$type, x: 0, y: 0 };
            }
        }
        insert(a, b) {
        }
        indexOf(a) {
            return -1;
        }
    }
    EdgeClipper.$t = /*@__PURE__*/ markType(EdgeClipper, 'EdgeClipper', Base.$, [/*@__PURE__*/ IList$1_$type.specialize(Point_$type)]);
    return EdgeClipper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LeftClipper = /*@__PURE__*/ (() => {
    class LeftClipper extends EdgeClipper {
        constructor() {
            super(...arguments);
            this.m = 0;
        }
        e(a) {
            return a.x >= this.m;
        }
        k(a, b) {
            return { $type: Point_$type, x: this.m, y: a.y + (b.y - a.y) * (this.m - a.x) / (b.x - a.x) };
        }
    }
    LeftClipper.$t = /*@__PURE__*/ markType(LeftClipper, 'LeftClipper', EdgeClipper.$);
    return LeftClipper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BottomClipper = /*@__PURE__*/ (() => {
    class BottomClipper extends EdgeClipper {
        constructor() {
            super(...arguments);
            this.m = 0;
        }
        e(a) {
            return a.y <= this.m;
        }
        k(a, b) {
            return { $type: Point_$type, x: a.x + (b.x - a.x) * (this.m - a.y) / (b.y - a.y), y: this.m };
        }
    }
    BottomClipper.$t = /*@__PURE__*/ markType(BottomClipper, 'BottomClipper', EdgeClipper.$);
    return BottomClipper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RightClipper = /*@__PURE__*/ (() => {
    class RightClipper extends EdgeClipper {
        constructor() {
            super(...arguments);
            this.m = 0;
        }
        e(a) {
            return a.x <= this.m;
        }
        k(a, b) {
            return { $type: Point_$type, x: this.m, y: a.y + (b.y - a.y) * (this.m - a.x) / (b.x - a.x) };
        }
    }
    RightClipper.$t = /*@__PURE__*/ markType(RightClipper, 'RightClipper', EdgeClipper.$);
    return RightClipper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TopClipper = /*@__PURE__*/ (() => {
    class TopClipper extends EdgeClipper {
        constructor() {
            super(...arguments);
            this.m = 0;
        }
        e(a) {
            return a.y >= this.m;
        }
        k(a, b) {
            return { $type: Point_$type, x: a.x + (b.x - a.x) * (this.m - a.y) / (b.y - a.y), y: this.m };
        }
    }
    TopClipper.$t = /*@__PURE__*/ markType(TopClipper, 'TopClipper', EdgeClipper.$);
    return TopClipper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Clipper = /*@__PURE__*/ (() => {
    class Clipper extends Base {
        get i() {
            return this.h;
        }
        set i(a) {
            if (this.b != null) {
                this.b.clear();
            }
            this.b = null;
            this.h = a;
            let b = this.h;
            if (this.c != null) {
                this.c.i = b;
                b = this.c;
                this.b = this.c;
            }
            if (this.a != null) {
                this.a.i = b;
                b = this.a;
                this.a._nextClipper = this.b;
                this.b = this.a;
            }
            if (this.d != null) {
                this.d.i = b;
                b = this.d;
                this.d._nextClipper = this.b;
                this.b = this.d;
            }
            if (this.e != null) {
                this.e.i = b;
                b = this.e;
                this.e._nextClipper = this.b;
                this.b = this.e;
            }
            this.g = b;
        }
        constructor(a, ..._rest) {
            super();
            this.g = null;
            this.b = null;
            this.h = null;
            this.c = null;
            this.a = null;
            this.d = null;
            this.e = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.c = ((() => {
                            let $ret = new LeftClipper();
                            $ret.m = c.left;
                            $ret.d = d;
                            return $ret;
                        })());
                        this.a = ((() => {
                            let $ret = new BottomClipper();
                            $ret.m = c.bottom;
                            $ret.d = d;
                            return $ret;
                        })());
                        this.d = ((() => {
                            let $ret = new RightClipper();
                            $ret.m = c.right;
                            $ret.d = d;
                            return $ret;
                        })());
                        this.e = ((() => {
                            let $ret = new TopClipper();
                            $ret.m = c.top;
                            $ret.d = d;
                            return $ret;
                        })());
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        this.c = !isNaN_(c) ? ((() => {
                            let $ret = new LeftClipper();
                            $ret.m = c;
                            $ret.d = g;
                            return $ret;
                        })()) : null;
                        this.a = !isNaN_(d) ? ((() => {
                            let $ret = new BottomClipper();
                            $ret.m = d;
                            $ret.d = g;
                            return $ret;
                        })()) : null;
                        this.d = !isNaN_(e) ? ((() => {
                            let $ret = new RightClipper();
                            $ret.m = e;
                            $ret.d = g;
                            return $ret;
                        })()) : null;
                        this.e = !isNaN_(f) ? ((() => {
                            let $ret = new TopClipper();
                            $ret.m = f;
                            $ret.d = g;
                            return $ret;
                        })()) : null;
                    }
                    break;
            }
        }
        j(a) {
            this.g.add(a);
        }
        k(a, b) {
            let c = a;
            let d = a.count;
            let e = new Array(4);
            e[0] = this.e;
            e[1] = this.d;
            e[2] = this.a;
            e[3] = this.c;
            let f = 0;
            let g = 0;
            let h = 0;
            let i = 0;
            if (this.e != null) {
                f = this.e.m;
            }
            if (this.d != null) {
                g = this.d.m;
            }
            if (this.a != null) {
                h = this.a.m;
            }
            if (this.c != null) {
                i = this.c.m;
            }
            let j = false;
            let k;
            let l = e.length;
            let m = l + 1;
            let n = null;
            let o;
            let p;
            let q = 0;
            let r = new Array(16);
            let s = 0;
            let t = new Array(16);
            let u = 0;
            let v = 1;
            let w;
            let x;
            if (b) {
                u = d - 1;
                v = -1;
            }
            for (let y = u; y < d && y >= 0; y += v) {
                o = c.item(y);
                r[q] = o;
                q++;
                for (k = 0; k < m; k++) {
                    if (k < l) {
                        n = e[k];
                        if (n == null) {
                            continue;
                        }
                    }
                    for (p = 0; p < q; p++) {
                        o = r[p];
                        x = o.x;
                        w = o.y;
                        if (k >= l) {
                            this.h.add(o);
                            continue;
                        }
                        j = (k == 0 && w >= f) || (k == 1 && x <= g) || (k == 2 && w <= h) || (k == 3 && x >= i);
                        if (n.c) {
                            n.c = false;
                            n.j = o;
                        }
                        else {
                            if (true) {
                                if (j) {
                                    if (!n.g) {
                                        t[s] = n.k(n.l, o);
                                        s++;
                                    }
                                    else {
                                        if (!n.d && !n.f) {
                                            t[s] = n.l;
                                            s++;
                                            n.f = true;
                                        }
                                    }
                                    t[s] = o;
                                    s++;
                                }
                                else {
                                    if (n.g) {
                                        if (!n.d && !n.f) {
                                            t[s] = n.l;
                                            s++;
                                            n.f = true;
                                        }
                                        t[s] = n.k(n.l, o);
                                        s++;
                                    }
                                }
                            }
                        }
                        n.l = o;
                        n.g = j;
                    }
                    let z = r;
                    r = t;
                    t = z;
                    q = s;
                    s = 0;
                }
            }
        }
        get f() {
            return (this.c == null || this.c.d) && (this.a == null || this.a.d) && (this.d == null || this.d.d) && (this.e == null || this.e.d);
        }
        set f(a) {
            if (this.c != null) {
                this.c.d = a;
            }
            if (this.a != null) {
                this.a.d = a;
            }
            if (this.d != null) {
                this.d.d = a;
            }
            if (this.e != null) {
                this.e.d = a;
            }
        }
    }
    Clipper.$t = /*@__PURE__*/ markType(Clipper, 'Clipper');
    return Clipper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Flattener = /*@__PURE__*/ (() => {
    class Flattener extends Base {
        constructor() {
            super();
        }
        static d(a, b, c, d) {
            let e = new List$1(Number_$type, 0);
            Flattener.c(e, b, c, 0, a - 1, d);
            return e;
        }
        static c(a, b, c, d, e, f) {
            return Flattener.b(a, (g) => g, b, c, d, e, f);
        }
        static a(a, b, c, d, e, f, g) {
            return Flattener.b(a, (h) => b.item(h), c, d, e, f, g);
        }
        static b(a, b, c, d, e, f, g) {
            if (e > f) {
                return a;
            }
            let h = c(b(e));
            let i = d(b(e));
            while ((isNaN_(h) || isNaN_(i)) && e < f) {
                ++e;
                h = c(b(e));
                i = d(b(e));
            }
            let j = c(b(f));
            let k = d(b(f));
            while ((isNaN_(j) || isNaN_(k)) && e < f) {
                --f;
                j = c(b(f));
                k = d(b(f));
            }
            if (e == f) {
                a.add(b(e));
                return a;
            }
            a.add(b(e));
            Flattener.e(a, b, c, d, e, f, g);
            a.add(b(f));
            return a;
        }
        static e(a, b, c, d, e, f, g) {
            let h = c(b(e));
            let i = d(b(e));
            while ((isNaN_(h) || isNaN_(i)) && e < f) {
                ++e;
                h = c(b(e));
                i = d(b(e));
            }
            let j = c(b(f));
            let k = d(b(f));
            while ((isNaN_(j) || isNaN_(k)) && e < f) {
                --f;
                j = c(b(f));
                k = d(b(f));
            }
            if (e + 1 >= f) {
                return;
            }
            let l = -1;
            let m = g;
            let n = MathUtil.g(j - h, k - i);
            if (n == 0) {
                for (let o = e + 1; o < f; ++o) {
                    let p = c(b(o));
                    let q = d(b(o));
                    if (isNaN_(p) || isNaN_(q)) {
                        continue;
                    }
                    let r = MathUtil.g(j - p, k - q);
                    if (r >= m) {
                        m = r;
                        l = o;
                    }
                }
            }
            else {
                let s = j - h;
                let t = k - i;
                for (let u = e + 1; u < f; ++u) {
                    let v = c(b(u));
                    let w = d(b(u));
                    if (isNaN_(v) || isNaN_(w)) {
                        continue;
                    }
                    let x = NaN;
                    let y = c(b(u)) - h;
                    let z = d(b(u)) - i;
                    let aa = s * y + t * z;
                    if (aa <= 0) {
                        x = MathUtil.g(h - v, i - w);
                    }
                    else {
                        let ab = s * s + t * t;
                        if (ab <= aa) {
                            x = MathUtil.g(j - v, k - w);
                        }
                        else {
                            let ac = aa / ab;
                            x = MathUtil.g(h + ac * s - v, i + ac * t - w);
                        }
                    }
                    if (x >= m) {
                        m = x;
                        l = u;
                    }
                }
            }
            if (l != -1) {
                Flattener.e(a, b, c, d, e, l, g);
                a.add(b(l));
                Flattener.e(a, b, c, d, l, f, g);
            }
            return;
        }
    }
    Flattener.$t = /*@__PURE__*/ markType(Flattener, 'Flattener');
    return Flattener;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FlattenerSettings = /*@__PURE__*/ (() => {
    class FlattenerSettings extends Base {
        constructor() {
            super();
            this._chunkingAmount = 0;
            this.chunkingAmount = 3000;
        }
        static get instance() {
            if (FlattenerSettings.a == null) {
                FlattenerSettings.a = new FlattenerSettings();
            }
            return FlattenerSettings.a;
        }
        get chunkingAmount() {
            return this._chunkingAmount;
        }
        set chunkingAmount(a) {
            this._chunkingAmount = a;
        }
    }
    FlattenerSettings.$t = /*@__PURE__*/ markType(FlattenerSettings, 'FlattenerSettings');
    FlattenerSettings.a = null;
    return FlattenerSettings;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastFlattener = /*@__PURE__*/ (() => {
    class FastFlattener extends Base {
        constructor() {
            super();
        }
        static e(a, b, c, d, e, f) {
            if (d > e) {
                return a;
            }
            let g = b[d];
            let h = c[d];
            while ((isNaN_(g) || isNaN_(h)) && d < e) {
                ++d;
                g = b[d];
                h = c[d];
            }
            let i = b[e];
            let j = c[e];
            while ((isNaN_(i) || isNaN_(j)) && d < e) {
                --e;
                i = b[e];
                j = c[e];
            }
            if (d == e) {
                a.add(d);
                return a;
            }
            a.add(d);
            FastFlattener.h(a, b, c, d, e, f);
            a.add(e);
            return a;
        }
        static c(a, b, c, d, e) {
            let f;
            let g;
            if (c) {
                f = 0;
                g = 1;
            }
            else if (d) {
                f = 0;
                g = 2;
            }
            else {
                f = 2;
                g = 3;
            }
            return FastFlattener.d(a, b, f, g, e);
        }
        static b(a, b, c, d, e) {
            let f = new List$1(Number_$type, 0);
            let g = FastFlattener.a(f, b, c, d, 0, a - 1, e);
            return g;
        }
        static d(a, b, c, d, e) {
            let f = new List$1(Number_$type, 0);
            FastFlattener.g(f, b, c, d, 0, a - 1, e);
            return f;
        }
        static a(a, b, c, d, e, f, g) {
            let h = FlattenerSettings.instance.chunkingAmount;
            if ((f - e + 1) <= h) {
                return FastFlattener.f(a, b, c, d, e, f, g);
            }
            let i = a;
            if (h < 0) {
                for (let j = e; j <= f; j++) {
                    i.add(j);
                }
                return i;
            }
            let k = e;
            let l = f;
            let m = l - k + 1;
            while (m > 0) {
                if (m <= h) {
                    FastFlattener.f(i, b, c, d, k, l, g);
                    k = l + 1;
                }
                else {
                    let n = k + h - 1;
                    FastFlattener.f(i, b, c, d, k, n, g);
                    k = n + 1;
                }
                m = l - k + 1;
            }
            return i;
        }
        static f(a, b, c, d, e, f, g) {
            let h;
            let i;
            if (c) {
                h = 0;
                i = 1;
            }
            else if (d) {
                h = 0;
                i = 2;
            }
            else {
                h = 2;
                i = 3;
            }
            return FastFlattener.g(a, b, h, i, e, f, g);
        }
        static g(a, b, c, d, e, f, g) {
            if (e > f) {
                return a;
            }
            let h = b._inner[e];
            let i, j;
            i = h[c];
            j = h[d];
            while ((isNaN_(i) || isNaN_(j)) && e < f) {
                ++e;
                h = b._inner[e];
                i = h[c];
                j = h[d];
            }
            let k = b._inner[f];
            let l, m;
            l = k[c];
            m = k[d];
            while ((isNaN_(l) || isNaN_(m)) && e < f) {
                --f;
                k = b._inner[f];
                l = k[c];
                m = k[d];
            }
            if (e == f) {
                a.add(e);
                return a;
            }
            a.add(e);
            FastFlattener.i(a, b, c, d, e, f, g);
            a.add(f);
            return a;
        }
        static h(a, b, c, d, e, f) {
            let g = b[d];
            let h = c[d];
            while ((isNaN_(g) || isNaN_(h)) && d < e) {
                ++d;
                g = b[d];
                h = c[d];
            }
            let i = b[e];
            let j = c[e];
            while ((isNaN_(i) || isNaN_(j)) && d < e) {
                --e;
                i = b[e];
                j = c[e];
            }
            if (d + 1 >= e) {
                return;
            }
            let k = -1;
            let l = f * f;
            let m;
            let n;
            m = i - g;
            n = j - h;
            let o = m * m + n * n;
            if (o == 0) {
                for (let p = d + 1; p < e; ++p) {
                    let q = b[p];
                    let r = c[p];
                    if (isNaN_(q) || isNaN_(r)) {
                        continue;
                    }
                    m = i - q;
                    n = j - r;
                    let s = m * m + n * n;
                    if (s >= l) {
                        l = s;
                        k = p;
                    }
                }
            }
            else {
                let t = i - g;
                let u = j - h;
                for (let v = d + 1; v < e; ++v) {
                    let w = b[v];
                    let x = c[v];
                    if (isNaN_(w) || isNaN_(x)) {
                        continue;
                    }
                    let y = NaN;
                    let z = b[v] - g;
                    let aa = c[v] - h;
                    let ab = t * z + u * aa;
                    if (ab <= 0) {
                        m = g - w;
                        n = h - x;
                        y = m * m + n * n;
                    }
                    else {
                        let ac = t * t + u * u;
                        if (ac <= ab) {
                            m = i - w;
                            n = j - x;
                            y = m * m + n * n;
                        }
                        else {
                            let ad = ab / ac;
                            m = g + ad * t - w;
                            n = h + ad * u - x;
                            y = m * m + n * n;
                        }
                    }
                    if (y >= l) {
                        l = y;
                        k = v;
                    }
                }
            }
            if (k != -1) {
                FastFlattener.h(a, b, c, d, k, f);
                a.add(k);
                FastFlattener.h(a, b, c, k, e, f);
            }
            return;
        }
        static i(a, b, c, d, e, f, g) {
            let h = b._inner[e];
            let i, j;
            i = h[c];
            j = h[d];
            while ((i != i) || (j != j) && e < f) {
                ++e;
                h = b._inner[e];
                i = h[c];
                j = h[d];
            }
            let k = b._inner[f];
            let l, m;
            l = k[c];
            m = k[d];
            while ((l != l) || (m != m) && e < f) {
                --f;
                k = b._inner[f];
                l = k[c];
                m = k[d];
            }
            if (e + 1 >= f) {
                return;
            }
            let n = -1;
            let o = g * g;
            let p;
            let q;
            p = l - i;
            q = m - j;
            let r = p * p + q * q;
            if (r == 0) {
                for (let s = e + 1; s < f; ++s) {
                    let t = b._inner[s];
                    let u, v;
                    u = t[c];
                    v = t[d];
                    if ((u != u) || (v != v)) {
                        continue;
                    }
                    p = l - u;
                    q = m - v;
                    let w = p * p + q * q;
                    if (w >= o) {
                        o = w;
                        n = s;
                    }
                }
            }
            else {
                let x = l - i;
                let y = m - j;
                for (let z = e + 1; z < f; ++z) {
                    let aa = b._inner[z];
                    let ab, ac;
                    ab = aa[c];
                    ac = aa[d];
                    if ((ab != ab) || (ac != ac)) {
                        continue;
                    }
                    let ad = NaN;
                    let ae = ab - i;
                    let af = ac - j;
                    let ag = x * ae + y * af;
                    if (ag <= 0) {
                        p = i - ab;
                        q = j - ac;
                        ad = p * p + q * q;
                    }
                    else {
                        let ah = x * x + y * y;
                        if (ah <= ag) {
                            p = l - ab;
                            q = m - ac;
                            ad = p * p + q * q;
                        }
                        else {
                            let ai = ag / ah;
                            p = i + ai * x - ab;
                            q = j + ai * y - ac;
                            ad = p * p + q * q;
                        }
                    }
                    if (ad >= o) {
                        o = ad;
                        n = z;
                    }
                }
            }
            if (n != -1) {
                FastFlattener.i(a, b, c, d, e, n, g);
                a.add(n);
                FastFlattener.i(a, b, c, d, n, f, g);
            }
            return;
        }
    }
    FastFlattener.$t = /*@__PURE__*/ markType(FastFlattener, 'FastFlattener');
    return FastFlattener;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SpiralTodo = /*@__PURE__*/ (() => {
    class SpiralTodo extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = 0;
        }
    }
    SpiralTodo.$t = /*@__PURE__*/ markType(SpiralTodo, 'SpiralTodo');
    return SpiralTodo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SpiralFlattener = /*@__PURE__*/ (() => {
    class SpiralFlattener extends Base {
        constructor() {
            super();
        }
        static a(a, b, c, d, e) {
            if (isNaN_(e) || e <= 0) {
                e = 1;
            }
            let f = new List$1(Number_$type, 0);
            let g = new Stack$1(SpiralTodo.$);
            let h = (d - b) / (c - a);
            let i = b - h * a;
            let j = h * h;
            let k = i * i;
            let l = i * h;
            g.h(((() => {
                let $ret = new SpiralTodo();
                $ret.a = 0;
                $ret.b = 1;
                return $ret;
            })()));
            while (g.f != 0) {
                let m = g.e();
                let n = b + m.a * (d - b);
                let o = a + m.a * (c - a);
                let p = o * o;
                let q = p * o;
                let r = b + m.b * (d - b);
                let s = a + m.b * (c - a);
                let t = s * s;
                let u = t * s;
                let v;
                if (h == 0) {
                    v = k * (s - o) / 2 + l * (t - p) / 2 + j * (u - q) / 6;
                }
                else {
                    v = (Math.pow(i + h * s, 3) - Math.pow(i + h * o, 3)) / (6 * h);
                }
                let w = 0.5 * n * r * Math.sin(s - o);
                if (v - w > e) {
                    let x = 0.5 * (m.a + m.b);
                    g.h(((() => {
                        let $ret = new SpiralTodo();
                        $ret.a = x;
                        $ret.b = m.b;
                        return $ret;
                    })()));
                    g.h(((() => {
                        let $ret = new SpiralTodo();
                        $ret.a = m.a;
                        $ret.b = x;
                        return $ret;
                    })()));
                }
                else {
                    f.add(m.a);
                }
            }
            f.add(1);
            return f;
        }
    }
    SpiralFlattener.$t = /*@__PURE__*/ markType(SpiralFlattener, 'SpiralFlattener');
    return SpiralFlattener;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AngleSimplifier = /*@__PURE__*/ (() => {
    class AngleSimplifier extends Base {
        static a(a) {
            if (isNaN_(a) || isInfinity(a)) {
                return a;
            }
            while (a > 360) {
                a -= 360;
            }
            while (a < 0) {
                a += 360;
            }
            return a;
        }
    }
    AngleSimplifier.$t = /*@__PURE__*/ markType(AngleSimplifier, 'AngleSimplifier');
    return AngleSimplifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolyLineSegment = /*@__PURE__*/ (() => {
    class PolyLineSegment extends PathSegment {
        constructor() {
            super();
            this._points = null;
            this._points = new PointCollection(0);
        }
        get points() {
            return this._points;
        }
        set points(a) {
            this._points = a;
        }
        get_a() {
            return 3;
        }
        get a() {
            return this.get_a();
        }
    }
    PolyLineSegment.$t = /*@__PURE__*/ markType(PolyLineSegment, 'PolyLineSegment', PathSegment.$);
    return PolyLineSegment;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathFigureUtil = /*@__PURE__*/ (() => {
    class PathFigureUtil extends Base {
        static b(a) {
            let b = new PathFigureCollection();
            for (let c of fromEnum(a)) {
                b.add(PathFigureUtil.a(c));
            }
            return b;
        }
        static a(a) {
            if (a == null) {
                return null;
            }
            let b = new PathSegmentCollection();
            for (let c of fromEnum(a._segments)) {
                switch (c.a) {
                    case 4:
                        let d = c;
                        let e = new ArcSegment();
                        e.b = d.b;
                        e.e = d.e;
                        e.c = d.c;
                        e.f = d.f;
                        e.d = d.d;
                        b.add(e);
                        break;
                    case 0:
                        let f = c;
                        let g = new LineSegment(1);
                        g.c = f.c;
                        b.add(g);
                        break;
                    case 3:
                        let h = c;
                        let i = new PolyLineSegment();
                        for (let j of fromEnum(h._points)) {
                            i._points.add(j);
                        }
                        b.add(i);
                        break;
                }
            }
            return ((() => {
                let $ret = new PathFigure();
                $ret.isClosed = a._isClosed;
                $ret.isFilled = a._isFilled;
                $ret.startPoint = a._startPoint;
                $ret.segments = b;
                return $ret;
            })());
        }
    }
    PathFigureUtil.$t = /*@__PURE__*/ markType(PathFigureUtil, 'PathFigureUtil');
    return PathFigureUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolygonUtil = /*@__PURE__*/ (() => {
    class PolygonUtil extends Base {
        static b(a, b) {
            if (a == null) {
                return false;
            }
            let c = a.count;
            if (c < 4) {
                return false;
            }
            let d = false;
            for (let e = 0, f = c - 1; e < c; f = e++) {
                if (((a.item(e).y > b.y) != (a.item(f).y > b.y)) && (b.x < (a.item(f).x - a.item(e).x) * (b.y - a.item(e).y) / (a.item(f).y - a.item(e).y) + a.item(e).x)) {
                    d = !d;
                }
            }
            return d;
        }
        static a(a, b) {
            if (a == null) {
                return false;
            }
            let c = a.length;
            if (c < 4) {
                return false;
            }
            let d = false;
            for (let e = 0, f = c - 1; e < c; f = e++) {
                if (((a[e].y > b.y) != (a[f].y > b.y)) && (b.x < (a[f].x - a[e].x) * (b.y - a[e].y) / (a[f].y - a[e].y) + a[e].x)) {
                    d = !d;
                }
            }
            return d;
        }
    }
    PolygonUtil.$t = /*@__PURE__*/ markType(PolygonUtil, 'PolygonUtil');
    return PolygonUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolySimplification = /*@__PURE__*/ (() => {
    class PolySimplification extends Base {
        static b(a, b) {
            let c = a.c;
            let d = a.d;
            if (c.length == 0) {
                return 0;
            }
            let e = 0;
            let f = 0;
            let g = b * b;
            e++;
            let h;
            let i;
            let j;
            for (let k = 0; k < c.length; k++) {
                h = c[k] - c[f];
                i = d[k] - d[f];
                j = (h * h) + (i * i);
                if (j > g) {
                    c[e] = c[k];
                    d[e] = d[k];
                    e++;
                    f = k;
                }
            }
            return e;
        }
        static a(a, b) {
            let c = b.x - a.x;
            let d = b.y - a.y;
            return (c * c) + (d * d);
        }
    }
    PolySimplification.$t = /*@__PURE__*/ markType(PolySimplification, 'PolySimplification');
    return PolySimplification;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISmartPlaceable_$type = /*@__PURE__*/ new Type(null, 'ISmartPlaceable');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SmartPlaceableWrapper$1 = /*@__PURE__*/ (() => {
    class SmartPlaceableWrapper$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this.f = false;
            this.c = null;
            this.g = null;
            this.i = null;
            this.a = [4];
            this.b = [4, 5, 2, 1, 8, 7, 0, 3, 6];
            this.j = new Size();
            this.e = 0;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.f = false;
        }
        get d() {
            return this.c;
        }
        set d(a) {
            this.c = a;
        }
        getSmartPositions() {
            if (this.f) {
                return this.a;
            }
            else {
                return this.b;
            }
        }
        k() {
            return this.j;
        }
        getSmartBounds(a) {
            let b = this.k();
            let c = b.width;
            let d = b.height;
            let e;
            {
                e = this.h(a, c, d);
            }
            return new Rect(0, this.i.x + e.x, this.i.y + e.y, c, d);
        }
        get opacity() {
            return this.d._opacity;
        }
        set opacity(a) {
            this.d._opacity = a;
        }
        get smartPosition() {
            return this.e;
        }
        set smartPosition(a) {
            this.e = a;
            let b = this.k();
            let c = b.height;
            let d = b.width;
            let e;
            {
                e = this.h(this.e, d, c);
            }
            this.g = { $type: Point_$type, x: this.i.x + e.x, y: this.i.y + e.y };
        }
        h(a, b, c) {
            let d = 0.25;
            switch (a) {
                case 0: return { $type: Point_$type, x: -b * d, y: -c * d };
                case 1: return { $type: Point_$type, x: 0, y: -c * d };
                case 2: return { $type: Point_$type, x: b * d, y: -c * d };
                case 3: return { $type: Point_$type, x: -b * d, y: 0 };
                case 4: return { $type: Point_$type, x: 0, y: 0 };
                case 5: return { $type: Point_$type, x: b * d, y: 0 };
                case 6: return { $type: Point_$type, x: -b * d, y: c * d };
                case 7: return { $type: Point_$type, x: 0, y: c * d };
                default: return { $type: Point_$type, x: b * d, y: c * d };
            }
        }
    }
    SmartPlaceableWrapper$1.$t = /*@__PURE__*/ markType(SmartPlaceableWrapper$1, 'SmartPlaceableWrapper$1', Base.$, [ISmartPlaceable_$type]);
    return SmartPlaceableWrapper$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available positions for smart label placement with respect to the notional rectangle's
 * origin
 */
var SmartPosition = /*@__PURE__*/ (function (SmartPosition) {
    /**
     * Specifies left top as a valid smart placement position.
     */
    SmartPosition[SmartPosition["LeftTop"] = 0] = "LeftTop";
    /**
     * Specifies center top as a valid smart placement position.
     */
    SmartPosition[SmartPosition["CenterTop"] = 1] = "CenterTop";
    /**
     * Specifies right top as a valid smart placement position.
     */
    SmartPosition[SmartPosition["RightTop"] = 2] = "RightTop";
    /**
     * Specifies left center as a valid smart placement position.
     */
    SmartPosition[SmartPosition["LeftCenter"] = 3] = "LeftCenter";
    /**
     * Specifies center center as a valid smart placement position.
     */
    SmartPosition[SmartPosition["CenterCenter"] = 4] = "CenterCenter";
    /**
     * Specifies right center as a valid smart placement position.
     */
    SmartPosition[SmartPosition["RightCenter"] = 5] = "RightCenter";
    /**
     * Specifies left bottom as a valid smart placement position.
     */
    SmartPosition[SmartPosition["LeftBottom"] = 6] = "LeftBottom";
    /**
     * Specifies center bottom as a valid smart placement position.
     */
    SmartPosition[SmartPosition["CenterBottom"] = 7] = "CenterBottom";
    /**
     * Specifies right bottom as a valid smart placement position.
     */
    SmartPosition[SmartPosition["RightBottom"] = 8] = "RightBottom";
    return SmartPosition;
})({});
/**
 * @hidden
 */
let SmartPosition_$type = /*@__PURE__*/ markEnum('SmartPosition', 'LeftTop,0|CenterTop,1|RightTop,2|LeftCenter,3|CenterCenter,4|RightCenter,5|LeftBottom,6|CenterBottom,7|RightBottom,8');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SmartPlacer = /*@__PURE__*/ (() => {
    class SmartPlacer extends Base {
        constructor() {
            super();
            this.e = null;
            this.c = 0;
            this.b = 0;
            this.a = new List$1(Rect.$, 0);
            this.e = Rect.empty;
            this.c = 0.3;
            this.b = 2;
        }
        d(a) {
            if (a == null) {
                return;
            }
            let b = 1.7976931348623157E+308;
            let c = Rect.empty;
            let d = 7;
            let e = false;
            let h = a.getSmartPositions();
            for (let g = 0; g < h.length; g++) {
                let f = h[g];
                let i = a.getSmartBounds(f);
                if (this.e.isEmpty || this.e.containsRect(i)) {
                    let j = 0;
                    for (let k of fromEnum(this.a)) {
                        j += RectUtil.i(i, k);
                    }
                    if (j == 0) {
                        b = j;
                        d = f;
                        c = i;
                        e = true;
                        break;
                    }
                    if (j < b) {
                        b = j;
                        d = f;
                        c = i;
                        e = true;
                    }
                }
            }
            let l = 0;
            if (e) {
                l = b / RectUtil.e(c);
            }
            if (!e || l > this.c) {
                a.opacity = 0;
            }
            else {
                if (b > 0) {
                    a.opacity = Math.pow(1 - MathUtil.d(0, l, 1), this.b);
                }
                else {
                    a.opacity = 1;
                }
                a.smartPosition = d;
                this.a.add(c);
            }
        }
    }
    SmartPlacer.$t = /*@__PURE__*/ markType(SmartPlacer, 'SmartPlacer');
    return SmartPlacer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointCollectionUtil = /*@__PURE__*/ (() => {
    class PointCollectionUtil extends Base {
        static d(a, b, c) {
            if (b == null) {
                return;
            }
            b.clear();
            if (a.count >= 2) {
                let d = Flattener.d(a.count, (e) => a.item(e).x, (e) => a.item(e).y, c);
                for (let e of fromEnum(d)) {
                    b.add(a.item(e));
                }
            }
        }
        static g(a) {
            let b = Number.POSITIVE_INFINITY;
            let c = Number.POSITIVE_INFINITY;
            let d = Number.NEGATIVE_INFINITY;
            let e = Number.NEGATIVE_INFINITY;
            for (let f of fromEnum(a)) {
                b = Math.min(b, f.x);
                c = Math.min(c, f.y);
                d = Math.max(d, f.x);
                e = Math.max(e, f.y);
            }
            if (isInfinity(b) || isInfinity(c) || isInfinity(c) || isInfinity(e)) {
                return Rect.empty;
            }
            return new Rect(0, b, c, d - b, e - c);
        }
        static h(a) {
            let b = Rect.empty;
            for (let c of fromEnum(a)) {
                b.union(PointCollectionUtil.g(c));
            }
            return b;
        }
        static i(a) {
            let b = Number.POSITIVE_INFINITY;
            let c = Number.POSITIVE_INFINITY;
            let d = Number.NEGATIVE_INFINITY;
            let e = Number.NEGATIVE_INFINITY;
            let f;
            for (let g = 0; g < a.count; g++) {
                f = a.item(g);
                b = Math.min(b, f.x);
                c = Math.min(c, f.y);
                d = Math.max(d, f.x);
                e = Math.max(e, f.y);
            }
            if (isInfinity(b) || isInfinity(c) || isInfinity(c) || isInfinity(e)) {
                return Rect.empty;
            }
            return new Rect(0, b, c, d - b, e - c);
        }
        static j(a) {
            if (a == null) {
                return Rect.empty;
            }
            let b = Rect.empty;
            let c;
            for (let d = 0; d < a.count; d++) {
                c = a._inner[d];
                b.union(PointCollectionUtil.i(c));
            }
            return b;
        }
        static k(a) {
            let b = Rect.empty;
            let c;
            for (let d = 0; d < a.count; d++) {
                c = a._inner[d];
                b.union(PointCollectionUtil.i(c));
            }
            return b;
        }
        static c(a, b, c) {
            let d = a.count;
            for (let e = 0; e < d; e++) {
                c.j(a.item(e));
            }
            c.i = null;
        }
        static e(a) {
            let b = 0;
            let c = 0;
            let d = 0;
            for (let e of fromEnum(a)) {
                b += e.x;
                c += e.y;
                d += 1;
            }
            return { $type: Point_$type, x: b / d, y: c / d };
        }
        static f(a) {
            let b = new PointCollection(0);
            for (let c of fromEnum(a)) {
                b.add(c);
            }
            return b;
        }
        static b(a) {
            let b = new List$1(Point_$type, 0);
            for (let c of fromEnum(a)) {
                b.add(c);
            }
            return b;
        }
        static a(a) {
            let b = new List$1(PointCollection.$, 0);
            let c;
            let d = a.count;
            for (let e = 0; e < d; e++) {
                c = a._inner[e];
                let f = new PointCollection(1, c);
                b.add(f);
            }
            return b;
        }
    }
    PointCollectionUtil.$t = /*@__PURE__*/ markType(PointCollectionUtil, 'PointCollectionUtil');
    return PointCollectionUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MouseEventArgs = /*@__PURE__*/ (() => {
    class MouseEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._position = null;
            this._originalSource = null;
        }
        get position() {
            return this._position;
        }
        set position(a) {
            this._position = a;
        }
        get originalSource() {
            return this._originalSource;
        }
        set originalSource(a) {
            this._originalSource = a;
        }
        getPosition(a) {
            return this.position;
        }
    }
    MouseEventArgs.$t = /*@__PURE__*/ markType(MouseEventArgs, 'MouseEventArgs', EventArgs.$);
    return MouseEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BaseDOMEventProxy = /*@__PURE__*/ (() => {
    class BaseDOMEventProxy extends EventProxy {
        constructor() {
            super(...arguments);
            this.b4 = null;
            this.bv = false;
            this.bx = false;
            this.b3 = null;
            this.bo = false;
            this.b1 = 0;
            this.b2 = 0;
            this.bz = 0;
            this.b0 = 0;
            this.b5 = 0;
            this.c3 = null;
            this.c2 = null;
            this.bn = false;
            this.b6 = -1;
            this.bs = false;
            this.bp = false;
            this.bm = false;
        }
        d() {
            let a = new DOMEventProxy(this.b4, this.b3, this.bx);
            a.ab = this.ab;
            a.ap = this.ap;
            return a;
        }
        static get by() {
            return (BaseDOMEventProxy.bt || BaseDOMEventProxy.bu);
        }
        bk(a) {
            return DOMEventProxy.c4(a);
        }
        br(e_) {
            let pointerEvent_ = e_.originalEvent;
            let a = false;
            if (BaseDOMEventProxy.bu) {
                a = (pointerEvent_.pointerType == 'touch');
            }
            else {
                a = (pointerEvent_.pointerType == pointerEvent_.MSPOINTER_TYPE_TOUCH);
            }
            return a;
        }
        cu(a) {
            if (!this.ae) {
                if (this.bq(a)) {
                    if (this.ar == null || this.ar(a)) {
                        a.preventDefault();
                    }
                }
            }
        }
        bq(e_) {
            return (e_.originalEvent.cancelable || e_.originalEvent.cancelable == undefined);
        }
        cq() {
            let source_ = this.b4.getNativeElement();
            BaseDOMEventProxy.ct(source_);
        }
        static ct(source_) {
            if (BaseDOMEventProxy.bu) {
                source_.style.touchAction = 'none';
            }
            else {
                source_.style.msTouchAction = 'none';
            }
            source_.style.msUserSelect = 'none';
            source_.style.webkitTouchCallout = 'none';
            source_.style.webkitUserSelect = 'none';
            source_.style.khtmlUserSelect = 'none';
            source_.style.mozUserSelect = 'none';
            source_.style.userSelect = 'none';
        }
        static cn(source_) {
            if (BaseDOMEventProxy.bu) {
                source_.style.touchAction = 'auto';
            }
            else {
                source_.style.msTouchAction = 'auto';
            }
            source_.style.msUserSelect = 'auto';
            source_.style.webkitTouchCallout = 'none';
            source_.style.webkitUserSelect = 'auto';
            source_.style.khtmlUserSelect = 'auto';
            source_.style.mozUserSelect = 'auto';
            source_.style.userSelect = 'auto';
        }
        co() {
            let source_ = this.b4.getNativeElement();
            BaseDOMEventProxy.cn(source_);
        }
        aw() {
            super.aw();
            if (!this.ae) {
                this.cq();
            }
            else {
                this.co();
            }
        }
        cb() {
            let ver_ = -1;
            let matchIE_ = /Trident\/([\d.]+)/;
            if ((matchIE_.exec(navigator.userAgent) != null)) {
                ver_ = (parseFloat(RegExp.$1));
            }
            return ver_;
        }
        ca() {
            let ver_ = -1;
            let matchIE_ = /Edge\/([\d.]+)/;
            if ((matchIE_.exec(navigator.userAgent) != null)) {
                ver_ = (parseFloat(RegExp.$1));
            }
            return ver_;
        }
        static cs(e_) {
            let a = BaseDOMEventProxy.cc >= 6;
            let oe_ = e_.originalEvent;
            if ((((typeof e_.pageX == 'undefined')) || a) && oe_.clientX != null) {
                let od_;
                if ((e_.target !== undefined)) {
                    od_ = e_.target.ownerDocument;
                }
                else {
                    od_ = e_.originalEvent.target.ownerDocument;
                }
                let ed_ = od_ ? od_ : document;
                let doc_ = ed_.documentElement;
                let body_ = ed_.body;
                let clientX_ = oe_.clientX;
                let clientY_ = oe_.clientY;
                let scrollLeft_ = doc_ && doc_.scrollLeft || body_ && body_.scrollLeft || 0;
                let scrollTop_ = doc_ && doc_.scrollTop || body_ && body_.scrollTop || 0;
                let clientLeft_ = doc_ && doc_.clientLeft || body_ && body_.clientLeft || 0;
                let clientTop_ = doc_ && doc_.clientTop || body_ && body_.clientTop || 0;
                e_.pageX = clientX_ + (scrollLeft_ - clientLeft_);
                e_.pageY = clientY_ + (scrollTop_ - clientTop_);
            }
            if ((!e_.pageX)) {
                e_.pageX = e_.originalEvent.pageX;
            }
            if ((!e_.pageY)) {
                e_.pageY = e_.originalEvent.pageY;
            }
            if (((typeof e_.button == 'undefined')) && ((typeof oe_.button != 'undefined'))) {
                e_.button = oe_.button;
            }
        }
        static c4(a) {
            let b = BaseDOMEventProxy.cc >= 6;
            let source_ = a.getNativeElement();
            let d_ = source_.ownerDocument;
            let doc_ = d_ ? d_.documentElement : null;
            let z_ = doc_ ? doc_.msContentZoomFactor : null;
            let body_ = doc_.body;
            if ((z_ && z_ > 1) || b) {
                let rect_ = source_.getBoundingClientRect();
                let x_ = (rect_.left);
                let y_ = (rect_.top);
                let scrollLeft_ = (doc_ && doc_.scrollLeft || body_ && body_.scrollLeft || 0);
                let scrollTop_ = (doc_ && doc_.scrollTop || body_ && body_.scrollTop || 0);
                let clientLeft_ = (doc_ && doc_.clientLeft || body_ && body_.clientLeft || 0);
                let clientTop_ = (doc_ && doc_.clientTop || body_ && body_.clientTop || 0);
                let c = x_ + scrollLeft_ - clientLeft_;
                let d = y_ + scrollTop_ - clientTop_;
                return new Rect(0, c, d, 0, 0);
            }
            else {
                let e = a.getOffset();
                return new Rect(0, e.left, e.top, 0, 0);
            }
        }
        get b8() {
            return this.b5;
        }
        set b8(a) {
            this.b5 = a;
        }
        cx(a) {
            this.as = a;
            BaseDOMEventProxy.cs(a);
            let b = BaseDOMEventProxy.c4(this.b4);
            let c = 0;
            let d = 0;
            if (Rect.l_op_Inequality(this.bl, null)) {
                c = this.bl.left;
                d = this.bl.top;
            }
            this.b1 = a.pageX - b.left;
            this.b2 = a.pageY - b.top;
            this.bz = this.b1 - c;
            this.b0 = this.b2 - d;
            this.c3 = { $type: Point_$type, x: this.b1, y: this.b2 };
            this.c2 = { $type: Point_$type, x: this.bz, y: this.b0 };
        }
        cy(e_) {
            this.as = e_;
            BaseDOMEventProxy.cs(e_);
            if (BaseDOMEventProxy.by) {
                let a = e_.pageX;
                let b = e_.pageY;
                let c = BaseDOMEventProxy.c4(this.b4);
                this.b1 = a - c.left;
                this.b2 = b - c.top;
            }
            else {
                this.b5 = 0;
                if (!e_.originalEvent.targetTouches || e_.originalEvent.targetTouches.length < 1) {
                    return;
                }
                ;
                this.b5 = (e_.originalEvent.targetTouches.length);
                let d = (e_.originalEvent.targetTouches[0].pageX);
                let e = (e_.originalEvent.targetTouches[0].pageY);
                let f = BaseDOMEventProxy.c4(this.b4);
                this.b1 = d - f.left;
                this.b2 = e - f.top;
            }
            let g = 0;
            let h = 0;
            if (Rect.l_op_Inequality(this.bl, null)) {
                g = this.bl.left;
                h = this.bl.top;
            }
            this.bz = this.b1 - g;
            this.b0 = this.b2 - h;
            this.c3 = { $type: Point_$type, x: this.b1, y: this.b2 };
            this.c2 = { $type: Point_$type, x: this.bz, y: this.b0 };
        }
        cm(e_) {
            this.cw(e_);
            if (this.ad(this.c3, false, true)) {
                let deltaY_ = 0;
                let ev_ = e_;
                deltaY_ = (ev_.originalEvent ? ev_.originalEvent.deltaY : ev_.deltaY);
                let deltaX_ = 0;
                deltaX_ = (ev_.originalEvent ? ev_.originalEvent.deltaX : ev_.deltaX);
                let a = (ev_.originalEvent ? (ev_.originalEvent.deltaMode == 1) : (ev_.deltaMode == 1));
                if (a) {
                    deltaY_ = deltaY_ * 40;
                    deltaX_ = deltaX_ * 40;
                }
                let b = this.aj(this.c2, deltaY_);
                let c = this.ak(this.c2, deltaX_);
                if (b || c) {
                    this.cu(e_);
                }
            }
        }
        ck(e_) {
            this.cw(e_);
            this.cx(e_);
            if (this.ad(this.c3, false, true)) {
                let ev_ = e_;
                let delta_ = 0;
                if (ev_.wheelDelta) {
                    delta_ = ev_.wheelDelta / 120;
                }
                ;
                if (ev_.originalEvent && ev_.originalEvent.wheelDelta) {
                    delta_ = ev_.originalEvent.wheelDelta / 120;
                }
                ;
                if (ev_.detail) {
                    delta_ = -ev_.detail / 3;
                }
                ;
                if (ev_.originalEvent && ev_.originalEvent.detail) {
                    delta_ = -ev_.originalEvent.detail / 3;
                }
                ;
                delta_ = delta_ / 10;
                let a = this.aj(this.c2, delta_);
                if (a) {
                    this.cu(e_);
                }
            }
        }
        cr() {
            if (this.bn) {
                if (this.b6 == -1) {
                    this.b6 = this.b3.setTimeout(runOn(this, this.cp), 500);
                }
                else {
                    window.clearTimeout(this.b6);
                    this.b6 = -1;
                    this.b6 = this.b3.setTimeout(runOn(this, this.cp), 500);
                }
            }
        }
        cd() {
            this.bn = true;
            if (this.b6 != -1) {
                window.clearTimeout(this.b6);
                this.b6 = -1;
            }
        }
        cp() {
            this.bn = false;
        }
        get bw() {
            return this.bp;
        }
        set bw(a) {
            this.bp = a;
        }
        ci(a) {
            if (this.bp || this.bn) {
                return;
            }
            this.cx(a);
            if (this.bs) {
                this.bs = false;
                this.a9(this.c2);
            }
        }
        cj(a) {
            if (this.bp || this.bn) {
                return;
            }
            this.cx(a);
            this.cw(a);
            let b = new MouseEventArgs();
            b.position = this.c3;
            if (this.ad(this.c3, false, false)) {
                if (!this.bs) {
                    this.bs = true;
                    this.a8(this.c3);
                }
                this.ba(this.c3, true, false);
                this.ay(this.c2, false);
            }
            else if (this.bs) {
                this.ci(a);
            }
        }
        cv(a) {
            this.b4.focus(this.bv);
        }
        ch(a) {
            if (this.bp || this.bn) {
                return;
            }
            this.cv(a);
            this.cx(a);
            this.cw(a);
            if (this.ad(this.c3, false, false)) {
                this.bm = true;
                this.a7(this.c3);
                this.az(this.c2, false);
                this.cu(a);
            }
        }
        cz(a) {
            if (this.bp || this.bn) {
                return;
            }
            if (this.bm) {
                this.cl(a);
            }
        }
        cl(a) {
            if (this.bp || this.bn) {
                return;
            }
            this.cw(a);
            if (PointUtil.equals(this.c3, null) || PointUtil.equals(this.c2, null)) {
                this.cx(a);
            }
            let b = this.ad(this.c3, false, false) || this.bm || this.bs;
            this.bm = false;
            this.bb(this.c3);
            this.ax(this.c2, false, false);
            if (b) {
                this.cu(a);
            }
        }
        ce(a) {
            this.cf(a, true);
        }
        cg(a) {
            this.cf(a, false);
        }
        c1(a) {
            return BaseDOMEventProxy.c0(a);
        }
        static c0(a) {
            let b;
            switch (a.which) {
                case 33:
                    b = 10;
                    break;
                case 34:
                    b = 11;
                    break;
                case 36:
                    b = 13;
                    break;
                case 37:
                    b = 14;
                    break;
                case 38:
                    b = 15;
                    break;
                case 39:
                    b = 16;
                    break;
                case 40:
                    b = 17;
                    break;
                case 9:
                    b = 2;
                    break;
                case 32:
                    b = 9;
                    break;
                case 13:
                    b = 3;
                    break;
                case 27:
                    b = 8;
                    break;
                case 16:
                    b = 4;
                    break;
                case 17:
                    b = 5;
                    break;
                case 18:
                    b = 6;
                    break;
                case 8:
                    b = 1;
                    break;
                case 35:
                    b = 12;
                    break;
                case 45:
                    b = 18;
                    break;
                case 46:
                    b = 19;
                    break;
                case 106:
                    b = 78;
                    break;
                case 107:
                    b = 79;
                    break;
                case 109:
                    b = 80;
                    break;
                case 110:
                    b = 81;
                    break;
                case 111:
                    b = 82;
                    break;
                case 220:
                    b = 85;
                    break;
                case 192:
                    b = 86;
                    break;
                case 191:
                    b = 84;
                    break;
                case 186:
                    b = 83;
                    break;
                case 189:
                    b = 88;
                    break;
                case 187:
                    b = 87;
                    break;
                default:
                    if (112 <= a.which && a.which <= 123) {
                        b = (56 + a.which - 112);
                    }
                    else if (65 <= a.which && a.which <= 90) {
                        b = (30 + a.which - 65);
                    }
                    else if (48 <= a.which && a.which <= 57) {
                        b = (20 + a.which - 48);
                    }
                    else if (96 <= a.which && a.which <= 105) {
                        b = (68 + a.which - 96);
                    }
                    else {
                        b = 0;
                    }
                    break;
            }
            return b;
        }
        cf(a, b) {
            let c = this.c1(a);
            let d = c != 0;
            this.cw(a);
            if (d) {
                let e = false;
                if (b) {
                    e = this.ah(c);
                }
                else {
                    e = this.ai(c);
                }
                if (e) {
                    this.cu(a);
                }
            }
        }
        cw(a) {
            this.as = a;
            this.bi = 0;
            if (a.shiftKey) {
                this.bi = this.bi | 4;
            }
            if (a.altKey) {
                this.bi = this.bi | 1;
            }
            if (a.ctrlKey) {
                this.bi = this.bi | 2;
            }
            this.al = a.button == 2;
        }
        bj() {
            let a = BaseDOMEventProxy.c4(this.b4);
            let b = a.left;
            let c = a.top;
            return { $type: Point_$type, x: b, y: c };
        }
    }
    BaseDOMEventProxy.$t = /*@__PURE__*/ markType(BaseDOMEventProxy, 'BaseDOMEventProxy', EventProxy.$);
    BaseDOMEventProxy.bt = false;
    BaseDOMEventProxy.bu = false;
    BaseDOMEventProxy.cc = 0;
    BaseDOMEventProxy.b9 = 0;
    return BaseDOMEventProxy;
})();
/**
 * @hidden
 */
let DOMEventProxy = /*@__PURE__*/ (() => {
    class DOMEventProxy extends BaseDOMEventProxy {
        constructor(a, b, c) {
            super();
            this.de = 0;
            this.dg = "";
            this.c6 = false;
            this.df = null;
            this.c8 = new Dictionary$2(String_$type, List$1.$.specialize(Delegate_$type), 0);
            this.d3 = null;
            this.dc = -1;
            this.d4 = null;
            this.da = 0;
            this.db = 0;
            this.c9 = 5;
            this.c5 = false;
            this.d2 = null;
            this.bx = c;
            this.b3 = b;
            this.ap = (d) => true;
            this.ab = false;
            DOMEventProxy.dd++;
            this.de = DOMEventProxy.dd;
            this.dg = ".DOMProxy" + this.de.toString();
            this.bi = 0;
            this.b4 = a;
            BaseDOMEventProxy.bt = false;
            try {
                BaseDOMEventProxy.bt = (window.navigator.msPointerEnabled && window.MSGesture !== undefined);
            }
            catch (d) {
            }
            BaseDOMEventProxy.bu = false;
            try {
                BaseDOMEventProxy.bu = (window.PointerEvent !== undefined);
            }
            catch (e) {
            }
            BaseDOMEventProxy.cc = this.cb();
            BaseDOMEventProxy.b9 = this.ca();
            this.at(this.b4, "");
            this.ao = (f) => true;
        }
        dh(a, b, c) {
        }
        at(a, b) {
            let c = a;
            let d = this.dg + b;
            if (!this.b3.supportsDOMEvents()) {
                return;
            }
            let e = new List$1(Delegate_$type, 0);
            this.c8.addItem(d, e);
            this.dh(a, b, e);
            if (!BaseDOMEventProxy.by) {
                e.add(c.listen("mousemove", runOn(this, this.cj)));
                e.add(c.listen("mouseleave", runOn(this, this.ci)));
                e.add(c.listen("mousedown", runOn(this, this.ch)));
                e.add(c.listen("mouseup", runOn(this, this.cl)));
                e.add(this.b3.globalListen("window", "mouseup", runOn(this, this.cz)));
            }
            e.add(c.listen("keydown", runOn(this, this.ce)));
            e.add(c.listen("keyup", runOn(this, this.cg)));
            let source_ = this.b4.getNativeElement();
            if (!this.ae) {
                BaseDOMEventProxy.ct(source_);
            }
            if (BaseDOMEventProxy.by) {
                let f = this.b4.getNativeElement();
                if ((window.MSGesture !== undefined)) {
                    let gesture_ = new window.MSGesture();
                    let container_ = f;
                    gesture_.target = container_;
                    this.df = gesture_;
                    e.add(c.listen("MSGestureStart", runOn(this, this.dk)));
                    e.add(c.listen("MSGestureChange", runOn(this, this.di)));
                    e.add(c.listen("MSGestureEnd", runOn(this, this.dj)));
                }
                if (BaseDOMEventProxy.bu) {
                    e.add(c.listen("pointerdown", runOn(this, this.dn)));
                    e.add(c.listen("pointerup", runOn(this, this.dr)));
                    e.add(c.listen("pointercancel", runOn(this, this.dm)));
                    e.add(c.listen("pointermove", runOn(this, this.dp)));
                    e.add(c.listen("pointerout", runOn(this, this.dq)));
                    e.add(c.listen("lostpointercapture", runOn(this, this.dl)));
                }
                else {
                    e.add(c.listen("MSPointerDown", runOn(this, this.dn)));
                    e.add(c.listen("MSPointerUp", runOn(this, this.dr)));
                    e.add(c.listen("MSPointerCancel", runOn(this, this.dm)));
                    e.add(c.listen("MSPointerMove", runOn(this, this.dp)));
                    e.add(c.listen("MSPointerOut", runOn(this, this.dq)));
                    e.add(c.listen("MSLostPointerCapture", runOn(this, this.dl)));
                }
            }
            else {
                e.add(c.listen("gesturestart", runOn(this, this.dk)));
                e.add(c.listen("gesturechange", runOn(this, this.di)));
                e.add(c.listen("gestureend", runOn(this, this.dj)));
                e.add(c.listen("touchstart", runOn(this, this.du)));
                e.add(c.listen("touchmove", runOn(this, this.dt)));
                e.add(c.listen("touchend", runOn(this, this.ds)));
            }
            if (this.bx) {
                e.add(c.listen("wheel", runOn(this, this.cm)));
            }
            else {
                e.add(c.listen("DOMMouseScroll", runOn(this, this.ck)));
                e.add(c.listen("mousewheel", runOn(this, this.ck)));
            }
        }
        dr(e_) {
            let a = this.br(e_);
            if (a) {
                this.b8 = this.b8 - 1;
                if (this.b8 < 0) {
                    this.b8 = 0;
                }
            }
            if (this.b8 < 2 && this.c6 && a) {
                this.c6 = false;
                let b = (e_.originalEvent.scale);
                this.a4(this.c2, b);
            }
            else {
                if (a) {
                    this.ds(e_);
                }
                else {
                    this.cl(e_);
                }
            }
        }
        dl(e_) {
            let a = this.br(e_);
            if (a) {
                this.b8--;
                if (this.b8 < 0) {
                    this.b8 = 0;
                }
            }
            if (this.b8 < 2 && this.c6 && a) {
                this.c6 = false;
                let b = (e_.originalEvent.scale);
                this.a4(this.c2, b);
            }
        }
        dm(e_) {
            let a = this.br(e_);
            if (a) {
                this.b8--;
                if (this.b8 < 0) {
                    this.b8 = 0;
                }
            }
            if (this.b8 < 2 && this.c6 && a) {
                this.c6 = false;
                let b = (e_.originalEvent.scale);
                this.a4(this.c2, b);
            }
        }
        dn(e_) {
            let a = this.br(e_);
            if (this.df != null && a) {
                this.b8++;
                let mGesture_ = this.df;
                mGesture_.addPointer(e_.originalEvent.pointerId);
            }
            let eventSource_ = this.b4.getNativeElement();
            if (BaseDOMEventProxy.bu) {
                eventSource_.setPointerCapture(e_.originalEvent.pointerId);
            }
            else {
                eventSource_.msSetPointerCapture(e_.originalEvent.pointerId);
            }
            if (this.b8 > 1 && !this.c6 && a) {
                this.c6 = true;
                this.cy(e_);
                let b = (e_.originalEvent.scale);
                this.bd(this.c2, b);
            }
            else {
                if (a) {
                    this.du(e_);
                }
                else {
                    this.ch(e_);
                }
            }
        }
        dp(e_) {
            let a = this.br(e_);
            if (this.c6) {
                return;
            }
            if (a) {
                this.dt(e_);
            }
            else {
                this.cj(e_);
            }
        }
        dq(e_) {
            let a = this.br(e_);
            if (this.c6) {
                return;
            }
            if (a) {
            }
            else {
                this.ci(e_);
            }
        }
        dk(e_) {
            this.bs = true;
            this.cw(e_);
            this.cy(e_);
            this.dw();
            if (this.ad(this.c3, true, false)) {
                this.cu(e_);
                if (BaseDOMEventProxy.by && this.b8 < 2) {
                    return;
                }
                let a = (e_.originalEvent.scale);
                this.bd(this.c2, a);
            }
        }
        di(e_) {
            this.bs = true;
            this.cw(e_);
            this.cy(e_);
            if (this.ad(this.c3, true, false)) {
                this.cu(e_);
                if (BaseDOMEventProxy.by && this.b8 < 2) {
                    return;
                }
                let a = (e_.originalEvent.scale);
                this.bc(this.c2, a);
            }
        }
        dj(e_) {
            this.cu(e_);
            let a = (e_.originalEvent.scale);
            this.bs = false;
            this.cw(e_);
            this.cy(e_);
            if (!BaseDOMEventProxy.by || this.c6) {
                this.a4(this.c2, a);
            }
        }
        du(e_) {
            this.bs = true;
            this.cw(e_);
            this.cy(e_);
            this.d3 = this.c2;
            if (this.ad(this.c3, true, false)) {
                if (!this.ab) {
                    this.cu(e_);
                }
                else {
                    this.bw = true;
                }
                this.ba(this.c3, false, true);
                this.a7(this.c3);
                this.az(this.c2, true);
                this.dz();
            }
        }
        dz() {
            if (this.dc == -1) {
                this.da = this.c3.x;
                this.db = this.c3.y;
                this.dc = this.b3.setTimeout(runOn(this, this.dx), 1500);
            }
        }
        dw() {
            if (Math.abs(this.da - this.c3.x) > this.c9 || Math.abs(this.db - this.c3.y) > this.c9) {
                this.d0();
            }
        }
        d0() {
            if (this.dc != -1) {
                window.clearTimeout(this.dc);
                this.dc = -1;
            }
        }
        dx() {
            this.dc = -1;
            if (this.bw) {
                this.bw = false;
                this.cd();
            }
            this.a5(this.c2);
        }
        dt(a) {
            this.bs = true;
            this.cw(a);
            this.cy(a);
            if (this.bw) {
                if (this.ad(this.c3, true, false) && this.c7()) {
                    this.bw = false;
                    this.cd();
                }
            }
            this.dw();
            this.d1();
            if (this.ad(this.c3, true, false) && this.b8 == 1 && !this.bw) {
                this.cu(a);
                if (!this.c5) {
                    this.c5 = true;
                    this.d2 = this.c2;
                    this.a3(this.d2);
                }
                else {
                    this.ba(this.c3, true, true);
                    this.ay(this.c2, true);
                    this.a2(this.c2);
                }
            }
        }
        c7() {
            let a = { $type: Point_$type, x: this.d3.x - this.c2.x, y: this.d3.y - this.c2.y };
            if (Math.abs(a.x) < 2 && Math.abs(a.y) < 2) {
                return false;
            }
            if (Math.abs(a.x) > Math.abs(a.y)) {
                a.y = 0;
            }
            if (Math.abs(a.y) > Math.abs(a.x)) {
                a.x = 0;
            }
            return this.ap(a);
        }
        ds(a) {
            this.bs = false;
            this.cw(a);
            this.cy(a);
            this.d0();
            if (this.bw) {
                this.bw = false;
                this.cd();
            }
            this.cu(a);
            this.ba(this.c3, false, true);
            this.bb(this.c3);
            if (this.b8 == 0) {
                this.dy(this.c3);
                this.cr();
            }
            if (this.c5 && this.b8 == 0) {
                this.c5 = false;
                this.d2 = null;
                this.a1(this.c2);
                this.cr();
            }
            this.ax(this.c2, true, this.b8 > 0);
        }
        dy(a) {
            if (Rect.l_op_Equality(this.d4, null)) {
                this.d4 = new Rect(0, a.x - 50, a.y - 50, 100, 100);
                this.b3.setTimeout(runOn(this, this.d1), 500);
            }
            else {
                if (a.x >= this.d4.x && a.x <= this.d4.right && a.y >= this.d4.y && a.y <= this.d4.bottom) {
                    this.d1();
                    this.a0(a);
                }
            }
        }
        d1() {
            this.d4 = null;
        }
        dv(a) {
            if (this.c8.containsKey(a)) {
                let b = this.c8.item(a);
                this.c8.removeItem(a);
                for (let c = 0; c < b.count; c++) {
                    b._inner[c]();
                }
                b.clear();
            }
        }
        bh(a, b) {
            let c = a;
            let d = this.dg + b;
            this.dv(d);
        }
        av() {
            if (this.b4 == null) {
                return;
            }
            this.dv(this.dg);
            this.b4 = null;
        }
    }
    DOMEventProxy.$t = /*@__PURE__*/ markType(DOMEventProxy, 'DOMEventProxy', BaseDOMEventProxy.$);
    DOMEventProxy.dd = 0;
    return DOMEventProxy;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TouchHistoryItem = /*@__PURE__*/ (() => {
    class TouchHistoryItem extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = 0;
            this.c = 0;
        }
    }
    TouchHistoryItem.$t = /*@__PURE__*/ markType(TouchHistoryItem, 'TouchHistoryItem');
    return TouchHistoryItem;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TouchVelocityReading = /*@__PURE__*/ (() => {
    class TouchVelocityReading extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = 0;
        }
    }
    TouchVelocityReading.$t = /*@__PURE__*/ markType(TouchVelocityReading, 'TouchVelocityReading');
    return TouchVelocityReading;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TouchVelocityTracker = /*@__PURE__*/ (() => {
    class TouchVelocityTracker extends Base {
        constructor() {
            super(...arguments);
            this.a = new Array(5);
            this.d = 0;
        }
        g(a, b, c) {
            if (isNaN_(a) || isNaN_(b)) {
                return;
            }
            let d = ((() => {
                let $ret = new TouchHistoryItem();
                $ret.a = a;
                $ret.b = b;
                $ret.c = c;
                return $ret;
            })());
            this.a[this.d] = d;
            this.d++;
            if (this.d > 5 - 1) {
                this.d = 0;
            }
        }
        f() {
            this.d = 0;
            for (let a = 0; a < 5; a++) {
                this.a[a] = null;
            }
        }
        b(a) {
            let b = a;
            let c = NaN;
            let d = NaN;
            let e = NaN;
            let f = NaN;
            let g = 0;
            let h = 0;
            let i = true;
            for (let j = 0; j < 5; j++) {
                if (this.a[j] == null) {
                    continue;
                }
                let k = (this.a[j].c - b) > 300;
                if (k) {
                    continue;
                }
                if (i) {
                    i = false;
                    c = this.a[j].a;
                    d = this.a[j].a;
                    e = this.a[j].b;
                    f = this.a[j].b;
                    g = this.a[j].c;
                    h = this.a[j].c;
                }
                else {
                    if (this.a[j].c < g) {
                        g = this.a[j].c;
                        d = this.a[j].a;
                        f = this.a[j].b;
                    }
                    if (this.a[j].c > h) {
                        h = this.a[j].c;
                        c = this.a[j].a;
                        e = this.a[j].b;
                    }
                }
            }
            if (g == h || isNaN_(c) || isNaN_(d) || isNaN_(e) || isNaN_(f)) {
                return ((() => {
                    let $ret = new TouchVelocityReading();
                    $ret.a = NaN;
                    $ret.b = NaN;
                    return $ret;
                })());
            }
            return ((() => {
                let $ret = new TouchVelocityReading();
                $ret.a = (c - d) / ((h - g) / 1000);
                $ret.b = (e - f) / ((h - g) / 1000);
                return $ret;
            })());
        }
    }
    TouchVelocityTracker.$t = /*@__PURE__*/ markType(TouchVelocityTracker, 'TouchVelocityTracker');
    return TouchVelocityTracker;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TouchPointInfo = /*@__PURE__*/ (() => {
    class TouchPointInfo extends Base {
        constructor(a, ..._rest) {
            super();
            this.a = 0;
            this.b = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.a = c;
                        this.b = d;
                    }
                    break;
                case 1: break;
            }
        }
    }
    TouchPointInfo.$t = /*@__PURE__*/ markType(TouchPointInfo, 'TouchPointInfo');
    return TouchPointInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TouchGestureEventArgs = /*@__PURE__*/ (() => {
    class TouchGestureEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.d = 0;
            this.e = 0;
            this.c = 0;
            this.f = 0;
            this.g = 0;
            this.a = 0;
            this.b = 0;
            this.h = 0;
            this.i = 0;
        }
    }
    TouchGestureEventArgs.$t = /*@__PURE__*/ markType(TouchGestureEventArgs, 'TouchGestureEventArgs');
    return TouchGestureEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TouchGestureRecognizer = /*@__PURE__*/ (() => {
    class TouchGestureRecognizer extends Base {
        constructor(a) {
            super();
            this.n = 0;
            this.p = new TouchVelocityTracker();
            this.u = 0;
            this.v = 0;
            this.ab = 0;
            this.ac = 0;
            this.w = 0;
            this.x = 0;
            this.an = NaN;
            this.ao = NaN;
            this.am = NaN;
            this.ak = 1;
            this.al = 1;
            this.z = 1;
            this.y = 10;
            this.az = -1;
            this.ap = 0;
            this.aq = 0;
            this.a0 = 0;
            this.ag = 1;
            this.ah = 1;
            this.ad = 1;
            this.ae = NaN;
            this.af = NaN;
            this.r = false;
            this.o = null;
            this.av = 800;
            this.ax = -1;
            this.b = null;
            this.q = false;
            this.ay = -1;
            this.holdStarting = null;
            this.holdEnding = null;
            this.panStarting = null;
            this.manipulationStarting = null;
            this.manipulationChanging = null;
            this.manipulationEnding = null;
            this.panEnding = null;
            this.zoomStarting = null;
            this.zoomEnding = null;
            this.flingStarting = null;
            this.doubleTapped = null;
            this.ai = 0;
            this.aj = 0;
            this.aa = 0;
            this.ar = 0;
            this.as = 0;
            this.a0 = 500;
            this.n = 0;
            this.b = a;
        }
        get aw() {
            return this.y;
        }
        set aw(a) {
            this.y = a;
        }
        get at() {
            return this.u;
        }
        get au() {
            return this.v;
        }
        bh() {
            return { $type: Point_$type, x: Math.abs(this.w - this.ab), y: Math.abs(this.x - this.ac) };
        }
        bf(a) {
            let b = false;
            if (!isNaN_(this.ab) && !isNaN_(this.ac)) {
                this.w = a._inner[0].a;
                this.x = a._inner[0].b;
                if (Math.abs(a._inner[0].a - this.ab) > this.y || Math.abs(a._inner[0].b - this.ac) > this.y) {
                    b = true;
                }
            }
            if (b) {
                this.be();
            }
        }
        a7(a) {
            let b = a.count;
            let c = this.n;
            let d = false;
            let e = false;
            let f = false;
            let g = false;
            let h = false;
            let i = false;
            let j = false;
            let k = false;
            let l = 0;
            let m = 0;
            let n = 0;
            let o = this.n;
            if (b > 0 && b < 2) {
                switch (this.n) {
                    case 5:
                        this.r = false;
                        c = 4;
                        e = true;
                        j = true;
                        break;
                    case 0:
                        c = 4;
                        e = true;
                        break;
                    case 2:
                        c = 1;
                        j = true;
                        g = true;
                        break;
                }
            }
            if (b > 1) {
                switch (this.n) {
                    case 5:
                        this.r = false;
                        c = 2;
                        h = true;
                        k = true;
                        break;
                    case 4:
                        f = true;
                        c = 2;
                        h = true;
                        break;
                    case 0:
                        c = 2;
                        h = true;
                        break;
                    case 1:
                        c = 2;
                        i = true;
                        h = true;
                        break;
                }
            }
            if (b == 0) {
                switch (this.n) {
                    case 4:
                        if (this.s(new TouchPointInfo(0, this.u, this.v))) {
                            c = 0;
                            f = true;
                            if (this.doubleTapped != null) {
                                this.doubleTapped(this, this.c());
                            }
                        }
                        else {
                            f = true;
                            c = 0;
                        }
                        break;
                    case 1:
                        c = 0;
                        i = true;
                        break;
                    case 2:
                        c = 0;
                        g = true;
                        break;
                    case 3:
                        c = 0;
                        d = true;
                        break;
                }
            }
            if (k || this.r) {
                if (j) {
                    if (this.panEnding != null) {
                        this.panEnding(this, this.c());
                    }
                    if (this.manipulationEnding != null) {
                        this.manipulationEnding(this, this.c());
                    }
                }
                this.a2();
            }
            if (e) {
                this.ab = a._inner[0].a;
                this.ac = a._inner[0].b;
            }
            if (c == 4) {
                if (!isNaN_(this.ab) && !isNaN_(this.ac)) {
                    this.w = a._inner[0].a;
                    this.x = a._inner[0].b;
                    if (Math.abs(a._inner[0].a - this.ab) > this.y || Math.abs(a._inner[0].b - this.ac) > this.y) {
                        f = true;
                        j = true;
                        c = 1;
                    }
                }
            }
            let p = 0;
            let q = 0;
            for (let r = 0; r < b; r++) {
                p += a._inner[r].a;
                q += a._inner[r].b;
            }
            p /= b;
            q /= b;
            if (b == 0) {
                p = this.ae;
                q = this.af;
            }
            this.u = p;
            this.v = q;
            this.p.g(this.u, this.v, this.a1());
            if (h) {
                let s = a._inner[0].a - a._inner[1].a;
                let t = a._inner[0].b - a._inner[1].b;
                this.an = Math.abs(s);
                this.ao = Math.abs(t);
                this.am = Math.sqrt(s * s + t * t);
                if (this.an < 1) {
                    this.an = 1;
                }
                if (this.ao < 1) {
                    this.ao = 1;
                }
                if (this.am < 1) {
                    this.am = 1;
                }
            }
            if (c == 2) {
                let u = a._inner[0].a - a._inner[1].a;
                let v = a._inner[0].b - a._inner[1].b;
                l = Math.abs(u);
                m = Math.abs(v);
                n = Math.sqrt(u * u + v * v);
                if (l < 1) {
                    l = 1;
                }
                if (m < 1) {
                    m = 1;
                }
                if (n < 1) {
                    n = 1;
                }
                this.ak = l / this.an;
                this.al = m / this.ao;
                this.z = n / this.am;
            }
            else {
                this.an = NaN;
                this.ao = NaN;
                this.ak = 1;
                this.al = 1;
                this.ai = 1;
                this.aj = 1;
                this.aa = 1;
            }
            this.n = c;
            if (o == 0 && this.n == 1 || this.n == 2) {
                if (this.manipulationStarting != null) {
                    this.manipulationStarting(this, this.c());
                }
            }
            if (g) {
                this.a6();
            }
            if (i) {
                this.a5();
            }
            if (d) {
                this.a4();
            }
            if (f) {
                this.be();
            }
            if (j) {
                this.bb();
            }
            if (e) {
                this.ba();
            }
            if (h) {
                this.bc();
            }
            if (this.n == 2) {
                this.ai = this.ak / this.ag;
                this.aj = this.al / this.ah;
                this.aa = this.z / this.ad;
                this.ar = this.u - this.ae;
                this.as = this.v - this.af;
                this.ag = this.ag * this.ai;
                this.ah = this.ah * this.aj;
                this.ad = this.ad * this.aa;
                this.ae = this.u;
                this.af = this.v;
                if (this.manipulationChanging != null) {
                    this.manipulationChanging(this, this.c());
                }
            }
            if (this.n == 1) {
                this.ar = this.u - this.ae;
                this.as = this.v - this.af;
                this.ae = this.u;
                this.af = this.v;
                if (this.manipulationChanging != null) {
                    this.manipulationChanging(this, this.c());
                }
            }
            this.ae = this.u;
            this.af = this.v;
            if ((i || g) && this.n == 0) {
                if (this.manipulationEnding != null) {
                    this.manipulationEnding(this, this.c());
                }
            }
        }
        s(a) {
            let b = this.a1();
            if ((b - this.az) < 500) {
                if (Math.abs(a.a - this.ap) < 50 && Math.abs(a.b - this.aq) < 50) {
                    return true;
                }
            }
            this.ap = a.a;
            this.aq = a.b;
            this.az = b;
            return false;
        }
        ba() {
            this.ay = this.a1();
            if (!this.q) {
                this.q = true;
                this.b.executeDelayed(runOn(this, this.a3), 1000);
            }
        }
        a3() {
            if (!this.q) {
                return;
            }
            let a = this.a1();
            if (a - this.ay >= this.a0) {
                this.a9();
            }
            else {
                this.b.executeDelayed(runOn(this, this.a3), (this.a0 - (a - this.ay)));
            }
        }
        be() {
            this.q = false;
        }
        a6() {
            this.p.f();
            if (this.zoomEnding != null) {
                this.zoomEnding(this, this.c());
            }
        }
        a9() {
            if (this.holdStarting != null) {
                this.holdStarting(this, this.c());
            }
        }
        bc() {
            this.p.f();
            this.a2();
            this.ag = 1;
            this.ah = 1;
            this.ad = 1;
            this.ae = this.u;
            this.af = this.v;
            if (this.zoomStarting != null) {
                this.zoomStarting(this, this.c());
            }
        }
        a4() {
            if (this.holdEnding != null) {
                this.holdEnding(this, this.c());
            }
        }
        bb() {
            this.p.f();
            this.a2();
            this.ae = this.u;
            this.af = this.v;
            if (this.panStarting != null) {
                this.panStarting(this, this.c());
            }
        }
        bd() {
            if (this.n == 5) {
                this.r = true;
            }
        }
        a2() {
            this.r = false;
            if (this.n == 5) {
                this.n = 0;
            }
        }
        bg() {
            if (this.n != 5) {
                this.r = false;
                return;
            }
            if (this.o == null || this.ax == -1) {
                this.a2();
                return;
            }
            let a = this.a1();
            let b = a - this.ax;
            if (b < 16) {
                this.a8(runOn(this, this.bg));
                return;
            }
            this.ax = a;
            let c = b / 1000;
            let d = this.av * c;
            let e = this.o;
            if (e.a > 0) {
                e.a -= d;
                if (e.a < 0) {
                    e.a = 0;
                }
            }
            if (e.a < 0) {
                e.a += d;
                if (e.a > 0) {
                    e.a = 0;
                }
            }
            if (e.b > 0) {
                e.b -= d;
                if (e.b < 0) {
                    e.b = 0;
                }
            }
            if (e.b < 0) {
                e.b += d;
                if (e.b > 0) {
                    e.b = 0;
                }
            }
            if ((e.a == 0 && e.b == 0) || this.r) {
                this.n = 0;
                if (this.panEnding != null) {
                    this.panEnding(this, this.c());
                }
                if (this.manipulationEnding != null) {
                    this.manipulationEnding(this, this.c());
                }
                this.a2();
                return;
            }
            this.u += e.a * c;
            this.v += e.b * c;
            this.ar = this.u - this.ae;
            this.as = this.v - this.af;
            this.ae = this.u;
            this.af = this.v;
            if (this.manipulationChanging != null) {
                this.manipulationChanging(this, this.c());
            }
            this.a8(runOn(this, this.bg));
        }
        t(a) {
            this.r = false;
            if (this.n == 5) {
                this.a2();
            }
            this.ax = this.a1();
            this.o = a;
            this.n = 5;
            this.a8(runOn(this, this.bg));
            if (this.flingStarting != null) {
                if (!this.flingStarting(this, this.c())) {
                    this.a2();
                    return false;
                }
            }
            return true;
        }
        a8(a) {
            this.b.enqueueAnimationAction(a);
        }
        a5() {
            let a = this.p.b(this.a1());
            if ((a.a > 5 || a.a < -5 || a.b > 5 || a.b < -5) && this.n == 0) {
                this.n = 1;
                if (!this.t(a)) {
                    if (this.n == 0) {
                        if (this.panEnding != null) {
                            this.panEnding(this, this.c());
                        }
                        if (this.manipulationEnding != null) {
                            this.manipulationEnding(this, this.c());
                        }
                    }
                }
            }
            else {
                if (this.panEnding != null) {
                    this.panEnding(this, this.c());
                }
                if (this.n == 0) {
                    if (this.manipulationEnding != null) {
                        this.manipulationEnding(this, this.c());
                    }
                }
            }
        }
        c() {
            let a = new TouchGestureEventArgs();
            a.a = this.u;
            a.b = this.v;
            a.d = this.ai;
            a.e = this.aj;
            a.c = this.aa;
            a.f = this.ar;
            a.g = this.as;
            a.h = this.o != null ? this.o.a : this.p.b(this.a1()).a;
            a.i = this.o != null ? this.o.b : this.p.b(this.a1()).b;
            return a;
        }
        a1() {
            return this.b.getCurrentRelativeTime();
        }
    }
    TouchGestureRecognizer.$t = /*@__PURE__*/ markType(TouchGestureRecognizer, 'TouchGestureRecognizer');
    return TouchGestureRecognizer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CanvasGestureDOMEventProxy = /*@__PURE__*/ (() => {
    class CanvasGestureDOMEventProxy extends BaseDOMEventProxy {
        d() {
            let a = new CanvasGestureDOMEventProxy(this.b4, this.b3, this.bx);
            a.ab = this.ab;
            a.ap = this.ap;
            return a;
        }
        constructor(a, b, c) {
            super();
            this.dh = 0;
            this.dj = "";
            this.c5 = null;
            this.di = null;
            this.db = new Dictionary$2(String_$type, List$1.$.specialize(Delegate_$type), 0);
            this.d7 = null;
            this.c6 = false;
            this.dc = new List$1(Number_$type, 0);
            this.dd = new List$1(Point_$type, 0);
            this.c8 = false;
            this.de = new List$1(TouchPointInfo.$, 0);
            this.bx = c;
            this.b3 = b;
            this.c5 = new TouchGestureRecognizer(new DOMExecutionContext(b));
            let d = this.c5;
            d.holdEnding = delegateCombine(d.holdEnding, runOn(this, this.dl));
            let e = this.c5;
            e.holdStarting = delegateCombine(e.holdStarting, runOn(this, this.dm));
            let f = this.c5;
            f.zoomStarting = delegateCombine(f.zoomStarting, runOn(this, this.du));
            let g = this.c5;
            g.zoomEnding = delegateCombine(g.zoomEnding, runOn(this, this.dt));
            let h = this.c5;
            h.panStarting = delegateCombine(h.panStarting, runOn(this, this.ds));
            let i = this.c5;
            i.panEnding = delegateCombine(i.panEnding, runOn(this, this.dr));
            let j = this.c5;
            j.manipulationStarting = delegateCombine(j.manipulationStarting, runOn(this, this.dq));
            let k = this.c5;
            k.manipulationChanging = delegateCombine(k.manipulationChanging, runOn(this, this.dn));
            let l = this.c5;
            l.manipulationEnding = delegateCombine(l.manipulationEnding, runOn(this, this.dp));
            let m = this.c5;
            m.doubleTapped = delegateCombine(m.doubleTapped, runOn(this, this.dk));
            let n = this.c5;
            n.flingStarting = delegateCombine(n.flingStarting, runOn(this, this.c7));
            this.ap = (o) => true;
            this.ab = true;
            CanvasGestureDOMEventProxy.dg++;
            this.dh = CanvasGestureDOMEventProxy.dg;
            this.dj = ".DOMProxy" + this.dh.toString();
            this.bi = 0;
            this.b4 = a;
            BaseDOMEventProxy.bt = false;
            try {
                BaseDOMEventProxy.bt = (window.navigator.msPointerEnabled && window.MSGesture !== undefined);
            }
            catch (o) {
            }
            BaseDOMEventProxy.bu = false;
            try {
                BaseDOMEventProxy.bu = (window.PointerEvent !== undefined);
            }
            catch (p) {
            }
            if (BaseDOMEventProxy.by) {
                this.ab = false;
            }
            BaseDOMEventProxy.cc = this.cb();
            BaseDOMEventProxy.b9 = this.ca();
            this.at(this.b4, "");
            this.ao = (q) => true;
        }
        c7(a, b) {
            return this.ag({ $type: Point_$type, x: b.a, y: b.b }, b.h, b.i);
        }
        dk(a, b) {
            this.a0({ $type: Point_$type, x: b.a, y: b.b });
        }
        get_an() {
            return true;
        }
        get_ac() {
            return this.c5.n == 5;
        }
        au() {
            super.au();
            this.c5.bd();
        }
        dp(a, b) {
            if (this.c5.n == 0) {
                this.a4({ $type: Point_$type, x: b.a, y: b.b }, b.d);
                this.cr();
            }
        }
        dn(a, b) {
            if (this.c5.n == 2) {
                this.bc({ $type: Point_$type, x: b.a, y: b.b }, b.d);
                this.bf({ $type: Point_$type, x: b.a, y: b.b }, b.d, b.e, b.c);
            }
            if (this.c5.n == 1 || this.c5.n == 5) {
                this.ay({ $type: Point_$type, x: b.a, y: b.b }, true);
                this.a2({ $type: Point_$type, x: b.a, y: b.b });
            }
        }
        dq(a, b) {
        }
        dr(a, b) {
            this.c6 = false;
            if (this.c5.n == 0) {
                this.ax({ $type: Point_$type, x: b.a, y: b.b }, true, false);
                this.a1({ $type: Point_$type, x: b.a, y: b.b });
            }
        }
        ds(a, b) {
            this.a3({ $type: Point_$type, x: b.a, y: b.b });
        }
        dt(a, b) {
            this.be({ $type: Point_$type, x: b.a, y: b.b }, b.d, b.e, b.c);
        }
        du(a, b) {
            this.bd({ $type: Point_$type, x: b.a, y: b.b }, 1);
            this.bg({ $type: Point_$type, x: b.a, y: b.b }, 1, 1, 1);
        }
        dm(a, b) {
            this.c6 = true;
            this.a5({ $type: Point_$type, x: b.a, y: b.b });
        }
        dl(a, b) {
            if (this.c5.n == 0) {
                this.ax({ $type: Point_$type, x: b.a, y: b.b }, true, false);
            }
        }
        static c9() {
            BaseDOMEventProxy.bt = false;
            try {
                BaseDOMEventProxy.bt = (window.navigator.msPointerEnabled && window.MSGesture !== undefined);
            }
            catch (a) {
            }
            BaseDOMEventProxy.bu = false;
            try {
                BaseDOMEventProxy.bu = (window.PointerEvent !== undefined);
            }
            catch (b) {
            }
            return BaseDOMEventProxy.by;
        }
        dv(a, b, c) {
        }
        at(a, b) {
            let c = a;
            if (!this.b3.supportsDOMEvents()) {
                return;
            }
            let d = this.dj + b;
            let e = new List$1(Delegate_$type, 0);
            this.db.addItem(d, e);
            this.dv(a, b, e);
            if (!BaseDOMEventProxy.by) {
                e.add(c.listen("mousemove", runOn(this, this.cj)));
                e.add(c.listen("mouseleave", runOn(this, this.ci)));
                e.add(c.listen("mousedown", runOn(this, this.ch)));
                e.add(c.listen("mouseup", runOn(this, this.cl)));
                e.add(this.b3.globalListen("window", "mouseup", runOn(this, this.cz)));
            }
            e.add(c.listen("keydown", runOn(this, this.ce)));
            e.add(c.listen("keyup", runOn(this, this.cg)));
            if (BaseDOMEventProxy.by) {
                let source_ = this.b4.getNativeElement();
                BaseDOMEventProxy.ct(source_);
                let f = this.b4.getNativeElement();
                if (BaseDOMEventProxy.bu) {
                    e.add(c.listen("pointerdown", runOn(this, this.dy)));
                    e.add(c.listen("pointerup", runOn(this, this.d1)));
                    e.add(c.listen("pointercancel", runOn(this, this.dx)));
                    e.add(c.listen("pointermove", runOn(this, this.dz)));
                    e.add(c.listen("pointerleave", runOn(this, this.d0)));
                    e.add(c.listen("lostpointercapture", runOn(this, this.dw)));
                }
                else {
                    e.add(c.listen("MSPointerDown", runOn(this, this.dy)));
                    e.add(c.listen("MSPointerUp", runOn(this, this.d1)));
                    e.add(c.listen("MSPointerCancel", runOn(this, this.dx)));
                    e.add(c.listen("MSPointerMove", runOn(this, this.dz)));
                    e.add(c.listen("MSPointerLeave", runOn(this, this.d0)));
                    e.add(c.listen("MSLostPointerCapture", runOn(this, this.dw)));
                }
            }
            else {
                e.add(c.listen("touchstart", runOn(this, this.d4)));
                e.add(c.listen("touchmove", runOn(this, this.d3)));
                e.add(c.listen("touchend", runOn(this, this.d2)));
            }
            if (this.bx) {
                e.add(c.listen("wheel", runOn(this, this.cm)));
            }
            else {
                e.add(c.listen("DOMMouseScroll", runOn(this, this.ck)));
                e.add(c.listen("mousewheel", runOn(this, this.ck)));
            }
        }
        d1(e_) {
            let a = this.br(e_);
            let b = this.dc.indexOf((e_.originalEvent.pointerId));
            if (b >= 0) {
                this.dc.removeAt(b);
                this.dd.removeAt(b);
                this.b8 = this.dc.count;
            }
            if (a) {
                this.d2(e_);
            }
            else {
                this.cl(e_);
            }
        }
        dw(e_) {
            let a = this.br(e_);
        }
        dx(e_) {
            let a = this.br(e_);
            let b = this.dc.indexOf((e_.originalEvent.pointerId));
            if (b >= 0) {
                this.dc.removeAt(b);
                this.dd.removeAt(b);
                this.b8 = this.dc.count;
            }
        }
        dy(e_) {
            let a = this.br(e_);
            BaseDOMEventProxy.cs(e_);
            this.dc.add((e_.originalEvent.pointerId));
            this.dd.add({ $type: Point_$type, x: e_.pageX, y: e_.pageY });
            this.b8 = this.dc.count;
            if (a) {
                this.cy(e_);
            }
            else {
                this.cx(e_);
            }
            this.cw(e_);
            if (!this.c8 && this.ad(this.c3, a, false)) {
                let eventSource_ = this.b4.getNativeElement();
                if (BaseDOMEventProxy.bu) {
                    eventSource_.setPointerCapture(e_.originalEvent.pointerId);
                }
                else {
                    eventSource_.msSetPointerCapture(e_.originalEvent.pointerId);
                }
            }
            if (a) {
                this.d4(e_);
            }
            else {
                this.ch(e_);
            }
        }
        dz(e_) {
            let a = this.br(e_);
            BaseDOMEventProxy.cs(e_);
            this.cw(e_);
            this.cy(e_);
            let b = this.dc.indexOf((e_.originalEvent.pointerId));
            if (b >= 0) {
                this.dd._inner[b] = { $type: Point_$type, x: e_.pageX, y: e_.pageY };
            }
            if (this.c8 && this.ad(this.c3, a, false)) {
                let eventSource_ = this.b4.getNativeElement();
                if (BaseDOMEventProxy.bu) {
                    eventSource_.setPointerCapture(e_.originalEvent.pointerId);
                }
                else {
                    eventSource_.msSetPointerCapture(e_.originalEvent.pointerId);
                }
            }
            if (a) {
                this.d3(e_);
            }
            else {
                this.cj(e_);
            }
        }
        d0(e_) {
            let a = this.br(e_);
            if (a) {
            }
            else {
                this.ci(e_);
            }
        }
        d4(e_) {
            this.bs = true;
            this.cw(e_);
            this.cy(e_);
            this.d7 = this.c2;
            if (this.ad(this.c3, true, false)) {
                if (!this.ab || this.b8 > 1) {
                    if (this.bw) {
                        this.bw = false;
                        this.cd();
                    }
                    this.cu(e_);
                }
                else {
                    this.bw = true;
                    this.c6 = false;
                }
                this.ba(this.c3, false, true);
                this.a7(this.c3);
                this.az(this.c2, true);
                this.c5.a7(this.df(e_));
            }
        }
        df(e_) {
            let a = BaseDOMEventProxy.c4(this.b4);
            let b = this.bl;
            let c = 0;
            let d = 0;
            if (Rect.l_op_Inequality(b, null)) {
                c = b.left;
                d = b.top;
            }
            this.de.clear();
            if (BaseDOMEventProxy.by) {
                let e = this.dc.count;
                for (let j_ = 0; j_ < e; j_++) {
                    let f = this.dc._inner[j_];
                    let g = this.dd._inner[j_];
                    let h = g.x;
                    let i = g.y;
                    let j = new TouchPointInfo(1);
                    j.a = (h - a.left) - b.left;
                    j.b = (i - a.top) - b.top;
                    this.de.add(j);
                }
            }
            else {
                let k = (e_.originalEvent.targetTouches.length);
                for (let j_ = 0; j_ < k; j_++) {
                    let l = (e_.originalEvent.targetTouches[j_].pageX);
                    let m = (e_.originalEvent.targetTouches[j_].pageY);
                    let n = new TouchPointInfo(1);
                    n.a = (l - a.left) - c;
                    n.b = (m - a.top) - d;
                    this.de.add(n);
                }
            }
            return this.de;
        }
        d3(a) {
            this.bs = true;
            this.cw(a);
            this.cy(a);
            if (this.bw) {
                if ((this.ad(this.c3, true, false) && this.da()) || this.c6 == true || this.c5.n == 2) {
                    this.bw = false;
                    this.cd();
                }
            }
            if ((this.c6 || this.c5.n == 2 || this.ad(this.c3, true, false)) && !this.bw) {
                this.c6 = true;
                this.cu(a);
                this.c5.a7(this.df(a));
            }
        }
        da() {
            let a = { $type: Point_$type, x: this.d7.x - this.c2.x, y: this.d7.y - this.c2.y };
            if (Math.abs(a.x) > Math.abs(a.y)) {
                a.y = 0;
            }
            if (Math.abs(a.y) > Math.abs(a.x)) {
                a.x = 0;
            }
            return this.ap(a);
        }
        d2(a) {
            this.bs = false;
            this.cw(a);
            this.cy(a);
            if (this.bw) {
                this.bw = false;
                this.cd();
            }
            let b = this.c5.n;
            let c = this.ad(this.c3, true, false) || b != 0;
            if (this.c5.n != 2 && this.c5.n != 5) {
                this.ba(this.c3, false, true);
                this.bb(this.c3);
            }
            let d = this.c5.n == 2;
            if (d) {
                c = true;
                this.ax({ $type: Point_$type, x: this.c5.at, y: this.c5.au }, true, true);
            }
            this.c5.a7(this.df(a));
            if (this.c5.n == 0) {
                this.cr();
            }
            if (!d && this.c5.n == 0) {
                this.ax({ $type: Point_$type, x: this.c5.at, y: this.c5.au }, true, false);
            }
            if (this.c5.n != 0) {
                c = true;
            }
            if (c) {
                this.cu(a);
            }
        }
        d5(a) {
            if (this.db.containsKey(a)) {
                let b = this.db.item(a);
                this.db.removeItem(a);
                for (let c = 0; c < b.count; c++) {
                    b._inner[c]();
                }
                b.clear();
            }
        }
        bh(a, b) {
            let c = a;
            let d = this.dj + b;
            this.d5(d);
        }
        av() {
            if (this.b4 == null) {
                return;
            }
            this.d5(this.dj);
            this.b4 = null;
        }
        static register() {
            TypeRegistrar.register("CanvasGestureDOMEventProxy", CanvasGestureDOMEventProxy.$);
        }
    }
    CanvasGestureDOMEventProxy.$t = /*@__PURE__*/ markType(CanvasGestureDOMEventProxy, 'CanvasGestureDOMEventProxy', BaseDOMEventProxy.$);
    CanvasGestureDOMEventProxy.dg = 0;
    return CanvasGestureDOMEventProxy;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrSimpleDefaultTooltip extends Component {
    render() {
        return (createElement("div", { className: "ui-simple-default-tooltip-content" }, createElement("span", { style: { whiteSpace: "nowrap", fontWeight: "bold" } }, this.getLabel(this.props.context))));
    }
    constructor(props) {
        super(props);
    }
    ensureDefaultTooltip(gauge) {
        if (gauge.showToolTip) {
            gauge.tooltipTemplate = this.props.tooltip;
        }
        else {
            gauge.tooltipTemplate = null;
        }
    }
    getLabel(context) {
        if (context.itemName == null) {
            let label = context.label.split(":");
            return label.length < 2 ? context.label : label[1].trim();
        }
        return context.label;
    }
    willComponentMount() {
        if (this.onContentReady != null) {
            this.onContentReady();
        }
    }
    static register() {
        TypeRegistrar.registerCons("IgrSimpleDefaultTooltip", IgrSimpleDefaultTooltip);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDVInteractivityModule {
    static register() {
        TypeRegistrar.register('CanvasGestureDOMEventProxy', CanvasGestureDOMEventProxy.$type);
        IgrTooltipContainerModule.register();
        TypeRegistrar.registerCons('IgrSimpleDefaultTooltip', IgrSimpleDefaultTooltip);
        IgrSimpleDefaultTooltip.register();
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TouchGestureState_$type = /*@__PURE__*/ markEnum('TouchGestureState', 'None,0|Pan,1|Zoom,2|Hold,3|PendingPan,4|Flinging,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyEventArgs = /*@__PURE__*/ (() => {
    class KeyEventArgs extends EventArgs {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c.which, c.altKey, c.shiftKey, c.ctrlKey, c];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = d[2];
                            let i = d[3];
                            let j = d[4];
                            super();
                            this.h = 0;
                            this.m = 0;
                            this.j = null;
                            this.g = null;
                            this.b = false;
                            this.j = j;
                            this.h = f;
                            this.m = KeyEventArgs.n(g, h, i);
                        }
                        this.g = c;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        super();
                        this.h = 0;
                        this.m = 0;
                        this.j = null;
                        this.g = null;
                        this.b = false;
                        this.j = g;
                        this.h = c;
                        this.m = KeyEventArgs.n(d, e, f);
                    }
                    break;
            }
        }
        get alt() {
            return 1 == (this.m & 1);
        }
        get ctrl() {
            return 2 == (this.m & 2);
        }
        get keyCode() {
            return this.h;
        }
        get modifiers() {
            return this.m;
        }
        get shift() {
            return 4 == (this.m & 4);
        }
        get defaultPrevented() {
            return this.b;
        }
        preventDefault() {
            this.g.preventDefault();
            this.b = true;
        }
        stopPropagation() {
            this.g.stopPropagation();
        }
        static n(a, b, c) {
            let d = 0;
            if (a) {
                d |= 1;
            }
            if (b) {
                d |= 4;
            }
            if (c) {
                d |= 2;
            }
            return d;
        }
    }
    KeyEventArgs.$t = /*@__PURE__*/ markType(KeyEventArgs, 'KeyEventArgs', EventArgs.$);
    return KeyEventArgs;
})();

/**
 * Event args for KeyUp and KeyDown events.
*/
class IgrKeyEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets a value indicating whether the ALT key was pressed.
    */
    get alt() {
        return this.i.alt;
    }
    /**
     * Gets a value indicating whether the CTRL key was pressed.
    */
    get ctrl() {
        return this.i.ctrl;
    }
    /**
     * Gets the keyboard code for a KeyDown or KeyUp event.
    */
    get keyCode() {
        return this.i.keyCode;
    }
    /**
     * Gets the modifier flags for a KeyDown or KeyUp event.
     * The flags indicate which combination of CTRL, SHIFT, and ALT keys was pressed.
    */
    get modifiers() {
        return this.i.modifiers;
    }
    /**
     * Gets a value indicating whether the SHIFT key was pressed.
    */
    get shift() {
        return this.i.shift;
    }
    /**
     * Gets whether the PreventDefault method was called.
    */
    get defaultPrevented() {
        return this.i.defaultPrevented;
    }
    /**
     * Tells the user agent that if the event does not get explicitly handled, its default action should not be taken as it normally would be.
    
    */
    preventDefault() {
        this.i.preventDefault();
    }
    /**
     * Prevent the event from bubbling up.
    
    */
    stopPropagation() {
        this.i.stopPropagation();
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var MouseButton = /*@__PURE__*/ (function (MouseButton) {
    MouseButton[MouseButton["Left"] = 0] = "Left";
    MouseButton[MouseButton["Middle"] = 1] = "Middle";
    MouseButton[MouseButton["Right"] = 2] = "Right";
    MouseButton[MouseButton["Unkown"] = 3] = "Unkown";
    return MouseButton;
})({});
/**
 * @hidden
 */
let MouseButton_$type = /*@__PURE__*/ markEnum('MouseButton', 'Left,0|Middle,1|Right,2|Unkown,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates where the popup pointer should be positioned.
 */
var PopupPointerPosition = /*@__PURE__*/ (function (PopupPointerPosition) {
    PopupPointerPosition[PopupPointerPosition["Auto"] = 0] = "Auto";
    PopupPointerPosition[PopupPointerPosition["Top"] = 1] = "Top";
    PopupPointerPosition[PopupPointerPosition["Bottom"] = 2] = "Bottom";
    PopupPointerPosition[PopupPointerPosition["Left"] = 3] = "Left";
    PopupPointerPosition[PopupPointerPosition["Right"] = 4] = "Right";
    return PopupPointerPosition;
})({});
/**
 * @hidden
 */
let PopupPointerPosition_$type = /*@__PURE__*/ markEnum('PopupPointerPosition', 'Auto,0|Top,1|Bottom,2|Left,3|Right,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Popup_OuterAnimationInfo = /*@__PURE__*/ (() => {
    class Popup_OuterAnimationInfo extends ValueType {
        constructor() {
            super();
            this.g = 0;
            this.h = 0;
            this.c = 0;
            this.f = 0;
            this.a = 0;
            this.d = 0;
            this.b = 0;
            this.e = 0;
        }
    }
    Popup_OuterAnimationInfo.$t = /*@__PURE__*/ markStruct(Popup_OuterAnimationInfo, 'Popup_OuterAnimationInfo');
    return Popup_OuterAnimationInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Popup_InnerAnimationInfo = /*@__PURE__*/ (() => {
    class Popup_InnerAnimationInfo extends ValueType {
        constructor() {
            super();
            this.a = 0;
            this.b = 0;
        }
    }
    Popup_InnerAnimationInfo.$t = /*@__PURE__*/ markStruct(Popup_InnerAnimationInfo, 'Popup_InnerAnimationInfo');
    return Popup_InnerAnimationInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var PopupAnimationType = /*@__PURE__*/ (function (PopupAnimationType) {
    PopupAnimationType[PopupAnimationType["GrowShrink"] = 0] = "GrowShrink";
    PopupAnimationType[PopupAnimationType["FadeInOutSlide"] = 1] = "FadeInOutSlide";
    return PopupAnimationType;
})({});
/**
 * @hidden
 */
let PopupAnimationType_$type = /*@__PURE__*/ markEnum('PopupAnimationType', 'GrowShrink,0|FadeInOutSlide,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnClosedEventArgs = /*@__PURE__*/ (() => {
    class OnClosedEventArgs extends EventArgs {
    }
    OnClosedEventArgs.$t = /*@__PURE__*/ markType(OnClosedEventArgs, 'OnClosedEventArgs', EventArgs.$);
    return OnClosedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PopupAnimation = /*@__PURE__*/ (() => {
    class PopupAnimation extends Base {
        constructor() {
            super();
            this.d = 0;
            this.a = false;
            this.b = false;
            this.c = null;
            this.c = new List$1(IKeyFrameAnimation_$type, 0);
        }
        f() {
            for (let a = 0; a < this.c.count; a++) {
                let b = this.c._inner[a];
                for (let c = 0; c < b.effect.h.length; c++) {
                    for (let d = 0; d < b.effect.h[c].b.length; d++) {
                        let e = b.effect.h[c].b[d].a;
                        for (let f = 0; f < b.effect.f.length; f++) {
                            if (b.effect.f[f] == e) {
                                b.effect.g[f].c(b.effect.a4, b.effect.h[c].b[d].d);
                            }
                        }
                    }
                }
            }
        }
        h(a) {
            this.a = false;
            this.d = 0;
            this.b = true;
            for (let b = 0; b < this.c.count; b++) {
                this.c._inner[b].play();
                this.c._inner[b].finished.f((c) => {
                    this.d++;
                    if (this.d == this.c.count && a != null) {
                        this.b = false;
                        a(this.a);
                    }
                });
            }
        }
        e() {
            this.a = true;
            for (let a = 0; a < this.c.count; a++) {
                if (this.c._inner[a].playState == 1) {
                    this.c._inner[a].cancel();
                }
            }
        }
        i() {
            for (let a = 0; a < this.c.count; a++) {
                this.c._inner[a].reverse();
            }
        }
        g() {
            for (let a = 0; a < this.c.count; a++) {
                this.c._inner[a].commitStyles();
            }
        }
    }
    PopupAnimation.$t = /*@__PURE__*/ markType(PopupAnimation, 'PopupAnimation');
    return PopupAnimation;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnPopupEventArgs = /*@__PURE__*/ (() => {
    class OnPopupEventArgs extends EventArgs {
    }
    OnPopupEventArgs.$t = /*@__PURE__*/ markType(OnPopupEventArgs, 'OnPopupEventArgs', EventArgs.$);
    return OnPopupEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PopupVisualModelExport = /*@__PURE__*/ (() => {
    class PopupVisualModelExport extends Base {
        constructor() {
            super(...arguments);
            this.e = 0;
            this.d = false;
            this.c = null;
            this.b = null;
            this.a = null;
        }
        f() {
            let a = new StringBuilder(0);
            a.l("{");
            a.l("actualElevation : " + this.e + ", ");
            a.l("isShown : " + this.d + ", ");
            a.l("actualUmbraShadowColor : " + this.c.serialize() + ", ");
            a.l("actualPenumbraShadowColor : " + this.b.serialize() + ", ");
            a.l("actualAmbientShadowColor : " + this.a.serialize() + ", ");
            a.l("}");
            return a.toString();
        }
    }
    PopupVisualModelExport.$t = /*@__PURE__*/ markType(PopupVisualModelExport, 'PopupVisualModelExport');
    return PopupVisualModelExport;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColorData = /*@__PURE__*/ (() => {
    class ColorData extends Base {
        constructor() {
            super(...arguments);
            this._a = 0;
            this._r = 0;
            this._g = 0;
            this._b = 0;
        }
        get a() {
            return this._a;
        }
        set a(a) {
            this._a = a;
        }
        get r() {
            return this._r;
        }
        set r(a) {
            this._r = a;
        }
        get g() {
            return this._g;
        }
        set g(a) {
            this._g = a;
        }
        get b() {
            return this._b;
        }
        set b(a) {
            this._b = a;
        }
        serialize() {
            return "{ a: " + this.a + ", r: " + this.r + ", g: " + this.g + ", b: " + this.b + "}";
        }
        static a_1(a) {
            let b = new ColorData();
            b.a = a.l;
            b.r = a.o;
            b.g = a.n;
            b.b = a.m;
            return b;
        }
        f() {
            let a = new Color();
            a.l = this.a;
            a.o = this.r;
            a.n = this.g;
            a.m = this.b;
            return a;
        }
    }
    ColorData.$t = /*@__PURE__*/ markType(ColorData, 'ColorData', Base.$, [IVisualData_$type]);
    return ColorData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushAppearanceData = /*@__PURE__*/ (() => {
    class BrushAppearanceData extends Base {
        serialize() {
            return "{ type: \"" + this.type + "\", " + this.a() + " }";
        }
        a() {
            return "";
        }
    }
    BrushAppearanceData.$t = /*@__PURE__*/ markType(BrushAppearanceData, 'BrushAppearanceData', Base.$, [IVisualData_$type]);
    return BrushAppearanceData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GradientStopAppearanceData = /*@__PURE__*/ (() => {
    class GradientStopAppearanceData extends Base {
        constructor() {
            super(...arguments);
            this._colorValue = null;
            this._offset = 0;
        }
        get colorValue() {
            return this._colorValue;
        }
        set colorValue(a) {
            this._colorValue = a;
        }
        get offset() {
            return this._offset;
        }
        set offset(a) {
            this._offset = a;
        }
        serialize() {
            return "{ " + "colorValue: " + (this.colorValue != null ? this.colorValue.serialize() : "null") + ", offset: " + this.offset + " }";
        }
    }
    GradientStopAppearanceData.$t = /*@__PURE__*/ markType(GradientStopAppearanceData, 'GradientStopAppearanceData', Base.$, [IVisualData_$type]);
    return GradientStopAppearanceData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGradientBrushAppearanceData = /*@__PURE__*/ (() => {
    class LinearGradientBrushAppearanceData extends BrushAppearanceData {
        constructor() {
            super();
            this._startX = 0;
            this._startY = 0;
            this._endX = 0;
            this._endY = 0;
            this._stops = null;
            this.stops = new List$1(GradientStopAppearanceData.$, 0);
        }
        get_type() {
            return "linear";
        }
        get type() {
            return this.get_type();
        }
        get startX() {
            return this._startX;
        }
        set startX(a) {
            this._startX = a;
        }
        get startY() {
            return this._startY;
        }
        set startY(a) {
            this._startY = a;
        }
        get endX() {
            return this._endX;
        }
        set endX(a) {
            this._endX = a;
        }
        get endY() {
            return this._endY;
        }
        set endY(a) {
            this._endY = a;
        }
        get stops() {
            return this._stops;
        }
        set stops(a) {
            this._stops = a;
        }
        a() {
            let a = new StringBuilder(0);
            a.l("startX: " + this.startX + ", endX: " + this.endX + ", startY: " + this.startY + ", endY: " + this.endY);
            a.l(", stops: [");
            for (let b = 0; b < this.stops.count; b++) {
                if (b > 0) {
                    a.l(", ");
                }
                a.l(this.stops._inner[b].serialize());
            }
            a.l("]");
            return a.toString();
        }
    }
    LinearGradientBrushAppearanceData.$t = /*@__PURE__*/ markType(LinearGradientBrushAppearanceData, 'LinearGradientBrushAppearanceData', BrushAppearanceData.$);
    return LinearGradientBrushAppearanceData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SolidBrushAppearanceData = /*@__PURE__*/ (() => {
    class SolidBrushAppearanceData extends BrushAppearanceData {
        constructor() {
            super(...arguments);
            this._colorValue = null;
        }
        get_type() {
            return "solid";
        }
        get type() {
            return this.get_type();
        }
        get colorValue() {
            return this._colorValue;
        }
        set colorValue(a) {
            this._colorValue = a;
        }
        a() {
            return "colorValue: " + (this.colorValue != null ? this.colorValue.serialize() : "null");
        }
    }
    SolidBrushAppearanceData.$t = /*@__PURE__*/ markType(SolidBrushAppearanceData, 'SolidBrushAppearanceData', BrushAppearanceData.$);
    return SolidBrushAppearanceData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeometryData = /*@__PURE__*/ (() => {
    class GeometryData extends Base {
        serialize() {
            return "{ type: \"" + this.type + "\", " + this.a() + "}";
        }
        a() {
            return "";
        }
    }
    GeometryData.$t = /*@__PURE__*/ markType(GeometryData, 'GeometryData', Base.$, [IVisualData_$type]);
    return GeometryData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineGeometry = /*@__PURE__*/ (() => {
    class LineGeometry extends Geometry {
        constructor() {
            super(...arguments);
            this.d = null;
            this.c = null;
        }
        get_b() {
            return 1;
        }
        get b() {
            return this.get_b();
        }
    }
    LineGeometry.$t = /*@__PURE__*/ markType(LineGeometry, 'LineGeometry', Geometry.$);
    return LineGeometry;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeometryCollection = /*@__PURE__*/ (() => {
    class GeometryCollection extends List$1 {
        constructor() {
            super(Geometry.$, 0);
        }
    }
    GeometryCollection.$t = /*@__PURE__*/ markType(GeometryCollection, 'GeometryCollection', /*@__PURE__*/ List$1.$.specialize(Geometry.$));
    return GeometryCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeometryGroup = /*@__PURE__*/ (() => {
    class GeometryGroup extends Geometry {
        constructor() {
            super();
            this.d = null;
            this.c = 0;
            this.d = new GeometryCollection();
        }
        get_b() {
            return 0;
        }
        get b() {
            return this.get_b();
        }
    }
    GeometryGroup.$t = /*@__PURE__*/ markType(GeometryGroup, 'GeometryGroup', Geometry.$);
    return GeometryGroup;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectangleGeometry = /*@__PURE__*/ (() => {
    class RectangleGeometry extends Geometry {
        constructor() {
            super(...arguments);
            this.e = null;
            this.c = 0;
            this.d = 0;
        }
        get_b() {
            return 2;
        }
        get b() {
            return this.get_b();
        }
    }
    RectangleGeometry.$t = /*@__PURE__*/ markType(RectangleGeometry, 'RectangleGeometry', Geometry.$);
    return RectangleGeometry;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EllipseGeometry = /*@__PURE__*/ (() => {
    class EllipseGeometry extends Geometry {
        constructor() {
            super(...arguments);
            this.e = null;
            this.c = 0;
            this.d = 0;
        }
        get_b() {
            return 3;
        }
        get b() {
            return this.get_b();
        }
    }
    EllipseGeometry.$t = /*@__PURE__*/ markType(EllipseGeometry, 'EllipseGeometry', Geometry.$);
    return EllipseGeometry;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointData = /*@__PURE__*/ (() => {
    class PointData extends Base {
        constructor(a, b) {
            super();
            this._x = 0;
            this._y = 0;
            this.x = a;
            this.y = b;
        }
        get x() {
            return this._x;
        }
        set x(a) {
            this._x = a;
        }
        get y() {
            return this._y;
        }
        set y(a) {
            this._y = a;
        }
        serialize() {
            return "{ x: " + this.x + ", y: " + this.y + "}";
        }
        static b(a) {
            let b = new PointData(a.x, a.y);
            return b;
        }
        g() {
            let a = PointUtil.create();
            a.x = this.x;
            a.y = this.y;
            return a;
        }
        equals(a) {
            let b = typeCast(PointData.$, a);
            if (b == null) {
                return false;
            }
            return b.x == this.x && b.y == this.y;
        }
        getHashCode() {
            return ((this.x) * 397) ^ (this.y);
        }
        static get empty() {
            return new PointData(Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
        }
    }
    PointData.$t = /*@__PURE__*/ markType(PointData, 'PointData', Base.$, [IVisualData_$type]);
    return PointData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EllipseGeometryData = /*@__PURE__*/ (() => {
    class EllipseGeometryData extends GeometryData {
        constructor() {
            super(...arguments);
            this._centerX = 0;
            this._centerY = 0;
            this._radiusX = 0;
            this._radiusY = 0;
        }
        get_type() {
            return "Ellipse";
        }
        get type() {
            return this.get_type();
        }
        get centerX() {
            return this._centerX;
        }
        set centerX(a) {
            this._centerX = a;
        }
        get centerY() {
            return this._centerY;
        }
        set centerY(a) {
            this._centerY = a;
        }
        get radiusX() {
            return this._radiusX;
        }
        set radiusX(a) {
            this._radiusX = a;
        }
        get radiusY() {
            return this._radiusY;
        }
        set radiusY(a) {
            this._radiusY = a;
        }
        a() {
            return "centerX: " + this.centerX + ", centerY: " + this.centerY + ", radiusX: " + this.radiusX + ", radiusY: " + this.radiusY;
        }
        scaleByViewport(a) {
            this.centerX = (this.centerX - a.left) / a.width;
            this.centerY = (this.centerY - a.top) / a.height;
            this.radiusX = this.radiusX / a.width;
            this.radiusY = this.radiusY / a.height;
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            c.add(new PointData(this.centerX, this.centerY));
        }
    }
    EllipseGeometryData.$t = /*@__PURE__*/ markType(EllipseGeometryData, 'EllipseGeometryData', GeometryData.$);
    return EllipseGeometryData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectangleGeometryData = /*@__PURE__*/ (() => {
    class RectangleGeometryData extends GeometryData {
        constructor() {
            super(...arguments);
            this._x = 0;
            this._y = 0;
            this._width = 0;
            this._height = 0;
        }
        get_type() {
            return "Rectangle";
        }
        get type() {
            return this.get_type();
        }
        get x() {
            return this._x;
        }
        set x(a) {
            this._x = a;
        }
        get y() {
            return this._y;
        }
        set y(a) {
            this._y = a;
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
        a() {
            return "x: " + this.x + ", y: " + this.y + ", width: " + this.width + ", height: " + this.height;
        }
        scaleByViewport(a) {
            this.x = (this.x - a.left) / a.width;
            this.y = (this.y - a.top) / a.height;
            this.width = this.width / a.width;
            this.height = this.height / a.height;
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            c.add(new PointData(this.x, this.y));
            c.add(new PointData(this.x + this.width, this.y));
            c.add(new PointData(this.x + this.width, this.y + this.height));
            c.add(new PointData(this.x, this.y + this.height));
        }
    }
    RectangleGeometryData.$t = /*@__PURE__*/ markType(RectangleGeometryData, 'RectangleGeometryData', GeometryData.$);
    return RectangleGeometryData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineGeometryData = /*@__PURE__*/ (() => {
    class LineGeometryData extends GeometryData {
        constructor() {
            super(...arguments);
            this._x1 = 0;
            this._y1 = 0;
            this._x2 = 0;
            this._y2 = 0;
        }
        get_type() {
            return "Line";
        }
        get type() {
            return this.get_type();
        }
        get x1() {
            return this._x1;
        }
        set x1(a) {
            this._x1 = a;
        }
        get y1() {
            return this._y1;
        }
        set y1(a) {
            this._y1 = a;
        }
        get x2() {
            return this._x2;
        }
        set x2(a) {
            this._x2 = a;
        }
        get y2() {
            return this._y2;
        }
        set y2(a) {
            this._y2 = a;
        }
        a() {
            return "x1: " + this.x1 + ", y1: " + this.y1 + ", x2: " + this.x2 + ", y2:" + this.y2;
        }
        scaleByViewport(a) {
            this.x1 = (this.x1 - a.left) / a.width;
            this.y1 = (this.y1 - a.top) / a.height;
            this.x2 = (this.x2 - a.left) / a.width;
            this.y2 = (this.y2 - a.top) / a.height;
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            c.add(new PointData(this.x1, this.y1));
            c.add(new PointData(this.x2, this.y2));
        }
    }
    LineGeometryData.$t = /*@__PURE__*/ markType(LineGeometryData, 'LineGeometryData', GeometryData.$);
    return LineGeometryData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SegmentData = /*@__PURE__*/ (() => {
    class SegmentData extends Base {
        serialize() {
            let a = new StringBuilder(0);
            a.u("{");
            a.u("type: \"" + this.type + "\", ");
            a.u(this.a());
            a.u("}");
            return a.toString();
        }
        a() {
            return "";
        }
    }
    SegmentData.$t = /*@__PURE__*/ markType(SegmentData, 'SegmentData', Base.$, [IVisualData_$type]);
    return SegmentData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineSegmentData = /*@__PURE__*/ (() => {
    class LineSegmentData extends SegmentData {
        constructor(a, ..._rest) {
            super();
            this._point = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.point = new PointData(NaN, NaN);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.point = PointData.b(c.c);
                    }
                    break;
            }
        }
        get_type() {
            return "Line";
        }
        get type() {
            return this.get_type();
        }
        get point() {
            return this._point;
        }
        set point(a) {
            this._point = a;
        }
        a() {
            return "point: { x: " + this.point.x + ", y: " + this.point.y + "}";
        }
        scaleByViewport(a) {
            this.point = new PointData((this.point.x - a.left) / a.width, (this.point.y - a.top) / a.height);
        }
        getPointsOverride(a, b) {
            a.add(new PointData(this.point.x, this.point.y));
        }
    }
    LineSegmentData.$t = /*@__PURE__*/ markType(LineSegmentData, 'LineSegmentData', SegmentData.$);
    return LineSegmentData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolylineSegmentData = /*@__PURE__*/ (() => {
    class PolylineSegmentData extends SegmentData {
        constructor(a, ..._rest) {
            super();
            this._points = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.points = new List$1(PointData.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.points = new List$1(PointData.$, 0);
                        for (let d = 0; d < c._points.count; d++) {
                            this.points.add(PointData.b(c._points._inner[d]));
                        }
                    }
                    break;
            }
        }
        get_type() {
            return "Polyline";
        }
        get type() {
            return this.get_type();
        }
        get points() {
            return this._points;
        }
        set points(a) {
            this._points = a;
        }
        a() {
            let a = new StringBuilder(0);
            a.u("points: [");
            for (let b = 0; b < this.points.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l("{ x: " + this.points._inner[b].x + ", y: " + this.points._inner[b].y + "}");
            }
            a.u("]");
            return a.toString();
        }
        scaleByViewport(a) {
            for (let b = 0; b < this.points.count; b++) {
                this.points._inner[b] = new PointData((this.points._inner[b].x - a.left) / a.width, (this.points._inner[b].y - a.top) / a.height);
            }
        }
        getPointsOverride(a, b) {
            for (let c = 0; c < this.points.count; c++) {
                a.add(new PointData(this.points._inner[c].x, this.points._inner[c].y));
            }
        }
    }
    PolylineSegmentData.$t = /*@__PURE__*/ markType(PolylineSegmentData, 'PolylineSegmentData', SegmentData.$);
    return PolylineSegmentData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArcSegmentData = /*@__PURE__*/ (() => {
    class ArcSegmentData extends SegmentData {
        constructor(a, ..._rest) {
            super();
            this._point = null;
            this._isLargeArc = false;
            this._isCounterClockwise = false;
            this._sizeX = 0;
            this._sizeY = 0;
            this._rotationAngle = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.point = new PointData(NaN, NaN);
                        this.isLargeArc = false;
                        this.isCounterClockwise = true;
                        this.rotationAngle = 0;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.point = PointData.b(c.e);
                        this.isLargeArc = c.b;
                        this.isCounterClockwise = c.d == 0;
                        this.sizeX = c.f.width;
                        this.sizeY = c.f.height;
                        this.rotationAngle = c.c;
                    }
                    break;
            }
        }
        get_type() {
            return "Arc";
        }
        get type() {
            return this.get_type();
        }
        get point() {
            return this._point;
        }
        set point(a) {
            this._point = a;
        }
        get isLargeArc() {
            return this._isLargeArc;
        }
        set isLargeArc(a) {
            this._isLargeArc = a;
        }
        get isCounterClockwise() {
            return this._isCounterClockwise;
        }
        set isCounterClockwise(a) {
            this._isCounterClockwise = a;
        }
        get sizeX() {
            return this._sizeX;
        }
        set sizeX(a) {
            this._sizeX = a;
        }
        get sizeY() {
            return this._sizeY;
        }
        set sizeY(a) {
            this._sizeY = a;
        }
        get rotationAngle() {
            return this._rotationAngle;
        }
        set rotationAngle(a) {
            this._rotationAngle = a;
        }
        a() {
            return "point: { x: " + this.point.x + ", y: " + this.point.y + " }, isLargeArc: " + (this.isLargeArc ? "true" : "false") + ", isCounterClockwise: " + (this.isCounterClockwise ? "true" : "false") + ", sizeX: " + this.sizeX + ", sizeY: " + this.sizeY + ", rotationAngle: " + this.rotationAngle;
        }
        scaleByViewport(a) {
            this.point = new PointData((this.point.x - a.left) / a.width, (this.point.y - a.top) / a.height);
            this.sizeX = this.sizeX / a.width;
            this.sizeY = this.sizeY / a.height;
        }
        getPointsOverride(a, b) {
            a.add(new PointData(this.point.x, this.point.y));
        }
    }
    ArcSegmentData.$t = /*@__PURE__*/ markType(ArcSegmentData, 'ArcSegmentData', SegmentData.$);
    return ArcSegmentData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolyBezierSegmentData = /*@__PURE__*/ (() => {
    class PolyBezierSegmentData extends SegmentData {
        constructor(a, ..._rest) {
            super();
            this._points = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.points = new List$1(PointData.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.points = new List$1(PointData.$, 0);
                        for (let d = 0; d < c.b.count; d++) {
                            this.points.add(PointData.b(c.b._inner[d]));
                        }
                    }
                    break;
            }
        }
        get_type() {
            return "PolyBezierSpline";
        }
        get type() {
            return this.get_type();
        }
        get points() {
            return this._points;
        }
        set points(a) {
            this._points = a;
        }
        a() {
            let a = new StringBuilder(0);
            a.u("points: [");
            for (let b = 0; b < this.points.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l("{ x: " + this.points._inner[b].x + ", y: " + this.points._inner[b].y + "}");
            }
            a.u("]");
            return a.toString();
        }
        scaleByViewport(a) {
            for (let b = 0; b < this.points.count; b++) {
                this.points._inner[b] = new PointData((this.points._inner[b].x - a.left) / a.width, (this.points._inner[b].y - a.top) / a.height);
            }
        }
        getPointsOverride(a, b) {
            for (let c = 0; c < this.points.count; c++) {
                a.add(new PointData(this.points._inner[c].x, this.points._inner[c].y));
            }
        }
    }
    PolyBezierSegmentData.$t = /*@__PURE__*/ markType(PolyBezierSegmentData, 'PolyBezierSegmentData', SegmentData.$);
    return PolyBezierSegmentData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BezierSegmentData = /*@__PURE__*/ (() => {
    class BezierSegmentData extends SegmentData {
        constructor(a, ..._rest) {
            super();
            this._points = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.points = new List$1(PointData.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.points = new List$1(PointData.$, 0);
                        this.points.add(PointData.b(c.e));
                        this.points.add(PointData.b(c.f));
                        this.points.add(PointData.b(c.g));
                    }
                    break;
            }
        }
        get_type() {
            return "Bezier";
        }
        get type() {
            return this.get_type();
        }
        get points() {
            return this._points;
        }
        set points(a) {
            this._points = a;
        }
        a() {
            let a = new StringBuilder(0);
            a.u("points: [");
            for (let b = 0; b < this.points.count; b++) {
                if (this.points._inner[b] == null) {
                    break;
                }
                if (b != 0) {
                    a.l(", ");
                }
                a.l("{ x: " + this.points._inner[b].x + ", y: " + this.points._inner[b].y + "}");
            }
            a.u("]");
            return a.toString();
        }
        scaleByViewport(a) {
            for (let b = 0; b < this.points.count; b++) {
                if (this.points._inner[b] == null) {
                    break;
                }
                this.points._inner[b] = new PointData((this.points._inner[b].x - a.left) / a.width, (this.points._inner[b].y - a.top) / a.height);
            }
        }
        getPointsOverride(a, b) {
            for (let c = 0; c < this.points.count; c++) {
                a.add(new PointData(this.points._inner[c].x, this.points._inner[c].y));
            }
        }
    }
    BezierSegmentData.$t = /*@__PURE__*/ markType(BezierSegmentData, 'BezierSegmentData', SegmentData.$);
    return BezierSegmentData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathFigureData = /*@__PURE__*/ (() => {
    class PathFigureData extends Base {
        constructor(a, ..._rest) {
            super();
            this._startPoint = null;
            this._segments = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.segments = new List$1(SegmentData.$, 0);
                        this.startPoint = new PointData(NaN, NaN);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.segments = new List$1(SegmentData.$, 0);
                        this.startPoint = PointData.b(c._startPoint);
                        for (let d = 0; d < c._segments.count; d++) {
                            let e = c._segments._inner[d];
                            let f = null;
                            switch (e.a) {
                                case 0:
                                    f = new LineSegmentData(1, e);
                                    break;
                                case 3:
                                    f = new PolylineSegmentData(1, e);
                                    break;
                                case 4:
                                    f = new ArcSegmentData(1, e);
                                    break;
                                case 2:
                                    f = new PolyBezierSegmentData(1, e);
                                    break;
                                case 1:
                                    f = new BezierSegmentData(1, e);
                                    break;
                            }
                            this.segments.add(f);
                        }
                    }
                    break;
            }
        }
        get startPoint() {
            return this._startPoint;
        }
        set startPoint(a) {
            this._startPoint = a;
        }
        get segments() {
            return this._segments;
        }
        set segments(a) {
            this._segments = a;
        }
        serialize() {
            let a = new StringBuilder(0);
            a.u("{");
            if (this.startPoint != null) {
                a.u("startPoint: { x: " + this.startPoint.x + ", y: " + this.startPoint.y + "}, ");
            }
            a.u("segments: [");
            for (let b = 0; b < this.segments.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l(this.segments._inner[b].serialize());
            }
            a.u("]");
            a.u("}");
            return a.toString();
        }
        d(a) {
            if (this.startPoint != null) {
                this.startPoint = new PointData((this.startPoint.x - a.left) / a.width, (this.startPoint.y - a.top) / a.height);
            }
            for (let b = 0; b < this.segments.count; b++) {
                this.segments._inner[b].scaleByViewport(a);
            }
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            if (!b.ignoreFigureStartPoint) {
                c.add(new PointData(this.startPoint.x, this.startPoint.y));
            }
            for (let d = 0; d < this.segments.count; d++) {
                this.segments._inner[d].getPointsOverride(c, b);
            }
        }
    }
    PathFigureData.$t = /*@__PURE__*/ markType(PathFigureData, 'PathFigureData', Base.$, [IVisualData_$type]);
    return PathFigureData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathGeometryData = /*@__PURE__*/ (() => {
    class PathGeometryData extends GeometryData {
        constructor() {
            super();
            this._figures = null;
            this.figures = new List$1(PathFigureData.$, 0);
        }
        get_type() {
            return "Path";
        }
        get type() {
            return this.get_type();
        }
        get figures() {
            return this._figures;
        }
        set figures(a) {
            this._figures = a;
        }
        a() {
            let a = new StringBuilder(0);
            a.u("figures: [");
            for (let b = 0; b < this.figures.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l(this.figures._inner[b].serialize());
            }
            a.u("]");
            return a.toString();
        }
        scaleByViewport(a) {
            for (let b of fromEnum(this.figures)) {
                b.d(a);
            }
        }
        getPointsOverride(a, b) {
            for (let c = 0; c < this.figures.count; c++) {
                let d = this.figures._inner[c];
                d.getPointsOverride(a, b);
            }
        }
    }
    PathGeometryData.$t = /*@__PURE__*/ markType(PathGeometryData, 'PathGeometryData', GeometryData.$);
    return PathGeometryData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelAppearanceData = /*@__PURE__*/ (() => {
    class LabelAppearanceData extends Base {
        constructor() {
            super(...arguments);
            this._text = null;
            this._horizontalAlignment = null;
            this._verticalAlignment = null;
            this._textAlignment = null;
            this._textWrapping = null;
            this._textPosition = null;
            this._labelBrush = null;
            this._labelBrushExtended = null;
            this._angle = 0;
            this._opacity = 0;
            this._visibility = false;
            this._font = null;
            this._fontFamily = null;
            this._fontSize = 0;
            this._fontWeight = null;
            this._fontStyle = null;
            this._fontStretch = null;
            this._marginLeft = 0;
            this._marginRight = 0;
            this._marginTop = 0;
            this._marginBottom = 0;
        }
        get text() {
            return this._text;
        }
        set text(a) {
            this._text = a;
        }
        get horizontalAlignment() {
            return this._horizontalAlignment;
        }
        set horizontalAlignment(a) {
            this._horizontalAlignment = a;
        }
        get verticalAlignment() {
            return this._verticalAlignment;
        }
        set verticalAlignment(a) {
            this._verticalAlignment = a;
        }
        get textAlignment() {
            return this._textAlignment;
        }
        set textAlignment(a) {
            this._textAlignment = a;
        }
        get textWrapping() {
            return this._textWrapping;
        }
        set textWrapping(a) {
            this._textWrapping = a;
        }
        get textPosition() {
            return this._textPosition;
        }
        set textPosition(a) {
            this._textPosition = a;
        }
        get labelBrush() {
            return this._labelBrush;
        }
        set labelBrush(a) {
            this._labelBrush = a;
        }
        get labelBrushExtended() {
            return this._labelBrushExtended;
        }
        set labelBrushExtended(a) {
            this._labelBrushExtended = a;
        }
        get angle() {
            return this._angle;
        }
        set angle(a) {
            this._angle = a;
        }
        get opacity() {
            return this._opacity;
        }
        set opacity(a) {
            this._opacity = a;
        }
        get visibility() {
            return this._visibility;
        }
        set visibility(a) {
            this._visibility = a;
        }
        get font() {
            return this._font;
        }
        set font(a) {
            this._font = a;
        }
        get fontFamily() {
            return this._fontFamily;
        }
        set fontFamily(a) {
            this._fontFamily = a;
        }
        get fontSize() {
            return this._fontSize;
        }
        set fontSize(a) {
            this._fontSize = a;
        }
        get fontWeight() {
            return this._fontWeight;
        }
        set fontWeight(a) {
            this._fontWeight = a;
        }
        get fontStyle() {
            return this._fontStyle;
        }
        set fontStyle(a) {
            this._fontStyle = a;
        }
        get fontStretch() {
            return this._fontStretch;
        }
        set fontStretch(a) {
            this._fontStretch = a;
        }
        get marginLeft() {
            return this._marginLeft;
        }
        set marginLeft(a) {
            this._marginLeft = a;
        }
        get marginRight() {
            return this._marginRight;
        }
        set marginRight(a) {
            this._marginRight = a;
        }
        get marginTop() {
            return this._marginTop;
        }
        set marginTop(a) {
            this._marginTop = a;
        }
        get marginBottom() {
            return this._marginBottom;
        }
        set marginBottom(a) {
            this._marginBottom = a;
        }
        serialize() {
            let a = new StringBuilder(0);
            a.u("{");
            a.u("text: \"" + (this.text != null ? this.text : "") + "\", ");
            if (this.textAlignment != null) {
                a.u("textAlignment: \"" + this.textAlignment + "\", ");
            }
            if (this.textWrapping != null) {
                a.u("textWrapping: \"" + this.textWrapping + "\", ");
            }
            a.u("labelBrush: " + (this.labelBrush != null ? this.labelBrush.serialize() : "null") + ", ");
            a.u("labelBrushExtended: " + (this.labelBrushExtended != null ? this.labelBrushExtended.serialize() : "null") + ", ");
            a.u("angle: " + this.angle + ", ");
            a.u("marginLeft: " + this.marginLeft + ", ");
            a.u("marginRight: " + this.marginRight + ", ");
            a.u("marginTop: " + this.marginTop + ", ");
            a.u("marginBottom: " + this.marginBottom + ", ");
            a.u("opacity: " + this.opacity + ", ");
            a.u("visibility: " + (this.visibility ? "true" : "false") + ", ");
            if (this.horizontalAlignment != null) {
                a.u("horizontalAlignment: \"" + this.horizontalAlignment + "\", ");
            }
            if (this.verticalAlignment != null) {
                a.u("verticalAlignment: \"" + this.verticalAlignment + "\", ");
            }
            if (this.font != null) {
                a.u("font: \"" + this.font + "\",");
            }
            if (this.fontFamily != null) {
                a.u("fontFamily: \"" + stringReplace(this.fontFamily, "\"", "'") + "\",");
            }
            if (this.fontWeight != null) {
                a.u("fontWeight: \"" + this.fontWeight + "\",");
            }
            if (this.fontStyle != null) {
                a.u("fontStyle: \"" + this.fontStyle + "\",");
            }
            if (this.fontStretch != null) {
                a.u("fontStretch: \"" + this.fontStretch + "\",");
            }
            a.u("fontSize: " + this.fontSize);
            a.u("}");
            return a.toString();
        }
    }
    LabelAppearanceData.$t = /*@__PURE__*/ markType(LabelAppearanceData, 'LabelAppearanceData', Base.$, [IVisualData_$type]);
    return LabelAppearanceData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AppearanceHelper = /*@__PURE__*/ (() => {
    class AppearanceHelper extends Base {
        static b(a) {
            if (a == null) {
                return ColorData.a_1(Color.u(0, 0, 0, 0));
            }
            if (Color.c(toNullable(Color.$, a.color), toNullable(Color.$, null))) {
                return ColorData.a_1(Color.u(0, 0, 0, 0));
            }
            return ColorData.a_1(a.color);
        }
        static a(a) {
            if (a == null) {
                return null;
            }
            if (a.isGradient) {
                let b = new LinearGradientBrushAppearanceData();
                let c = a;
                b.startX = c.startX;
                b.startY = c.startY;
                b.endX = c.endX;
                b.endY = c.endY;
                let f = c.gradientStops;
                for (let e = 0; e < f.length; e++) {
                    let d = f[e];
                    let g = new GradientStopAppearanceData();
                    g.colorValue = ColorData.a_1(d.color);
                    g.offset = d.offset;
                    b.stops.add(g);
                }
                return b;
            }
            else if (a.isRadialGradient) {
                return null;
            }
            else {
                let h = new SolidBrushAppearanceData();
                h.colorValue = ColorData.a_1(a.color);
                return h;
            }
        }
        static m(a) {
            return a.n;
        }
        static n(a) {
            return a.o;
        }
        static o(a) {
            return a.s;
        }
        static j(a) {
            return AppearanceHelper.g(a.an);
        }
        static h(a) {
            let b = new LineGeometry();
            b.c = { $type: Point_$type, x: a.ao, y: a.aq };
            b.d = { $type: Point_$type, x: a.an, y: a.ap };
            return AppearanceHelper.g(b);
        }
        static g(a) {
            if (a == null) {
                return new List$1(GeometryData.$, 0);
            }
            if (typeCast(GeometryGroup.$, a) !== null) {
                let b = new List$1(GeometryData.$, 0);
                let c = a;
                for (let d = 0; d < c.d.count; d++) {
                    let e = AppearanceHelper.g(c.d._inner[d]);
                    for (let f = 0; f < e.count; f++) {
                        b.add(e._inner[f]);
                    }
                }
                return b;
            }
            else if (typeCast(PathGeometry.$, a) !== null) {
                return AppearanceHelper.k(a);
            }
            else if (typeCast(LineGeometry.$, a) !== null) {
                return AppearanceHelper.i(a);
            }
            else if (typeCast(RectangleGeometry.$, a) !== null) {
                return AppearanceHelper.l(a);
            }
            else if (typeCast(EllipseGeometry.$, a) !== null) {
                return AppearanceHelper.f(a);
            }
            else {
                throw new NotSupportedException(1, "not supported");
            }
        }
        static f(a) {
            let b = new List$1(GeometryData.$, 0);
            let c = new EllipseGeometryData();
            b.add(c);
            c.centerX = a.e.x;
            c.centerY = a.e.y;
            c.radiusX = a.c;
            c.radiusY = a.d;
            return b;
        }
        static l(a) {
            let b = new List$1(GeometryData.$, 0);
            let c = new RectangleGeometryData();
            b.add(c);
            c.x = a.e.x;
            c.y = a.e.y;
            c.width = a.e.width;
            c.height = a.e.height;
            return b;
        }
        static i(a) {
            let b = new List$1(GeometryData.$, 0);
            let c = new LineGeometryData();
            b.add(c);
            c.x1 = a.d.x;
            c.y1 = a.d.y;
            c.x2 = a.c.x;
            c.y2 = a.c.y;
            return b;
        }
        static k(a) {
            let b = new List$1(GeometryData.$, 0);
            let c = new PathGeometryData();
            b.add(c);
            for (let d = 0; d < a.c.count; d++) {
                let e = a.c._inner[d];
                let f = new PathFigureData(1, e);
                c.figures.add(f);
            }
            return b;
        }
        static p(a, b) {
            a.stroke = AppearanceHelper.b(b._stroke);
            a.fill = AppearanceHelper.b(b._fill);
            a.strokeExtended = AppearanceHelper.a(b._stroke);
            a.fillExtended = AppearanceHelper.a(b._fill);
            a.strokeThickness = b.ad;
            a.dashArray = null;
            if (b.ai != null) {
                a.dashArray = b.ai.asArray();
            }
            a.dashCap = b.aj;
            a.isVisible = b._visibility == 0;
            a.opacity = b._opacity;
            a.canvasLeft = AppearanceHelper.m(b);
            a.canvasTop = AppearanceHelper.n(b);
            a.canvaZIndex = AppearanceHelper.o(b);
        }
        static c(a, b) {
            let c = new LabelAppearanceData();
            let d = a;
            c.text = d.al;
            c.labelBrush = AppearanceHelper.b(d.ao);
            c.labelBrushExtended = AppearanceHelper.a(d.ao);
            c.visibility = (d._visibility == 0) ? true : false;
            c.opacity = d._opacity;
            if (b != null) {
                if (b.q != null) {
                    c.fontFamily = b.q;
                }
                if (!isNaN_(b.f)) {
                    c.fontSize = b.f;
                }
                c.fontWeight = stringIsNullOrEmpty(b.v) ? "Normal" : b.v;
                c.fontStyle = stringIsNullOrEmpty(b.t) ? "Normal" : b.t;
                if (b.r != null) {
                    c.fontStretch = b.t;
                }
            }
            let e = 0;
            let f = d.j;
            if (typeCast(RotateTransform.$, f) !== null) {
                let g = typeCast(RotateTransform.$, f);
                e = g.j;
            }
            else if (typeCast(TransformGroup.$, f) !== null) {
                let h = typeCast(TransformGroup.$, f);
                for (let i of fromEnum(h.j)) {
                    if (typeCast(RotateTransform.$, i) !== null) {
                        let j = typeCast(RotateTransform.$, i);
                        e = j.j;
                        break;
                    }
                }
            }
            c.angle = e;
            return c;
        }
        static serializeItems(a, b, c, d) {
            if (c != null) {
                if (!d) {
                    a.l(", ");
                }
                a.l(b);
                a.l(": [");
                let e = false;
                for (let f of fromEnum(c)) {
                    if (e) {
                        a.u(", ");
                    }
                    else {
                        e = true;
                    }
                    a.l(f.serialize());
                }
                a.u("]");
                return true;
            }
            return false;
        }
        static serializeItem(a, b, c, d) {
            if (c != null) {
                if (!d) {
                    a.l(", ");
                }
                a.l(b);
                a.l(": ");
                a.u(c.serialize());
                return true;
            }
            return false;
        }
    }
    AppearanceHelper.$t = /*@__PURE__*/ markType(AppearanceHelper, 'AppearanceHelper');
    return AppearanceHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PopupView = /*@__PURE__*/ (() => {
    class PopupView extends Base {
        constructor() {
            super(...arguments);
            this.ag = null;
            this.f = null;
            this.ao = null;
            this.an = null;
            this.am = null;
            this.aj = null;
            this.al = null;
            this.ak = null;
            this.aq = null;
            this.v = 0;
            this.w = 0;
            this.u = 0;
            this.m = false;
            this.x = 0;
            this.s = 0;
            this.t = 0;
            this.q = 0;
            this.r = 0;
            this.ai = null;
            this.ap = null;
            this.br = new Size(1, 0, 0);
            this.k = true;
            this.p = false;
        }
        get af() {
            return this.g.a3;
        }
        get ac() {
            return this.af / 2;
        }
        get ab() {
            return this.af * 1.414;
        }
        get aa() {
            return this.ab / 2;
        }
        get ad() {
            return (this.bs.width / 2 - this.ac);
        }
        get ae() {
            return (this.bs.height / 2 - this.ac);
        }
        get g() {
            return this.f;
        }
        get ah() {
            return this.ag;
        }
        a6() {
            this.ao.setStyleProperty("height", "0%");
            this.ao.setStyleProperty("width", "0%");
            this.aj = this.ag.createElement("div");
            this.be(this.g.aq);
            this.aj.setStyleProperty("z-index", "10000");
            this.aj.setStyleProperty("inset", "unset");
            this.aj.setStyleProperty("padding", "0px");
            this.aj.setStyleProperty("border-width", "0px");
            this.al = this.ag.createElement("div");
            this.al.setStyleProperty("height", 20 * 1.414 / 2 + "px");
            this.ak = this.ag.createElement("div");
            this.ak.setStyleProperty("position", "relative");
            this.ak.setStyleProperty("width", this.af + "px");
            this.ak.setStyleProperty("height", this.af + "px");
            this.ak.setStyleProperty("z-index", "1");
            this.ak.setStyleProperty("clip-path", stringFormat("path(\"M0,0l{0},{0}l0,-{0}l-{0},0Z\")", this.af));
            this.al.append(this.ak);
            this.an = this.ag.createElement("div");
            this.an.setStyleProperty("position", "relative");
            this.an.setStyleProperty("overflow", "hidden");
            this.an.setAttribute("key", "popupContentAreaOuter");
            this.bf(this.g.ar);
            this.aj.listen("mouseenter", runOn(this, this.a7));
            this.aj.listen("mouseleave", runOn(this, this.a8));
            this.aj.listen("focusin", runOn(this, this.a4));
            this.aj.listen("focusout", runOn(this, this.a5));
            this.am = this.ag.createElement("div");
            this.am.setAttribute("key", "popupContentAreaInner");
            this.an.append(this.am);
            this.aj.append(this.an);
        }
        bn() {
            let a = this.g;
            let b = ElevationHelper.e(a.a6, a.cx, a.cw, a.cv);
            if (this.l()) {
                this.aj.setStyleProperty("box-shadow", b);
            }
            else {
                this.an.setStyleProperty("box-shadow", b);
            }
        }
        bl() {
            if (this.g.cy != null) {
                this.an.setStyleProperty("background-color", this.g.cy._fill);
                this.ak.setStyleProperty("background-color", this.g.cy._fill);
            }
            if (this.g.c2 != null) {
                this.ak.setStyleProperty("background-color", this.g.c2._fill);
            }
        }
        bm() {
            if (!isNaN_(this.g.a0)) {
                NativeUI.o(this.an, new CornerRadius(0, this.g.a0));
            }
        }
        bo() {
            if (null == this.ao) {
                return;
            }
            this.be(this.g.aq);
            this.bn();
            this.bl();
            this.bm();
        }
        a7(a) {
            this.g.cd();
        }
        a8(a) {
            this.g.ce();
        }
        a4(a) {
            this.g.cb();
        }
        a5(a) {
            this.g.cc(a.originalEvent.relatedTarget);
        }
        o() {
            return (HTMLElement.prototype.hasOwnProperty("popover"));
        }
        l() {
            return this.o() && this.g.ax;
        }
        at() {
            if (null != this.aj) {
                this.bo();
                this.an.setStyleProperty("height", "0px");
                let a = this.aj.getNativeElement();
                if (false == this.m) {
                    this.al.remove();
                    if (this.g.at) {
                        let b = this.g.t();
                        if (b == 1) {
                            this.aj.setStyleProperty("display", "block");
                            let c = this.aj.getNativeElement();
                            let d = this.al.getNativeElement();
                            let e = this.an.getNativeElement();
                            c.insertBefore(d, e);
                        }
                        else if (b == 2) {
                            this.aj.setStyleProperty("display", "block");
                            this.aj.append(this.al);
                        }
                        else if (b == 3) {
                            this.aj.setStyleProperty("display", "flex");
                            let f = this.aj.getNativeElement();
                            let g = this.al.getNativeElement();
                            let h = this.an.getNativeElement();
                            f.insertBefore(g, h);
                            this.al.setStyleProperty("height", "unset");
                            this.al.setStyleProperty("width", 20 * 1.414 / 2 + "px");
                        }
                        else if (b == 4) {
                            this.aj.setStyleProperty("display", "flex");
                            this.aj.append(this.al);
                            this.al.setStyleProperty("height", "unset");
                            this.al.setStyleProperty("width", 20 * 1.414 / 2 + "px");
                        }
                    }
                    if (this.g.bd != null) {
                        this.g.bd.appendChild(a);
                    }
                    else {
                        document.body.appendChild(a);
                    }
                    this.bh(this.g.ax);
                    if (this.l()) {
                        a.showPopover();
                    }
                    this.m = true;
                    if (this.k) {
                        this.a1();
                    }
                }
            }
        }
        au(a, b) {
            this.aj.setStyleProperty("top", PopupView.ar(a.f));
            this.an.setStyleProperty("height", PopupView.as(a.h));
            this.am.setStyleProperty("top", PopupView.as(b.b));
            this.am.setStyleProperty("opacity", "1");
            this.am.setStyleProperty("transform", stringEmpty());
            this.x = 0;
            if (this.p) {
                this.bk();
            }
            if (this.g.aw) {
                this.ap.observe(this.ai.getNativeElement());
            }
            else {
                this.ap.disconnect();
            }
            if (this.g.an) {
                this.bg(this.g.as);
            }
            return {
                p0: a,
                p1: b
            };
        }
        av(a) {
            this.x = a;
            if (this.g.an) {
                this.bg(false);
            }
            this.bi(this.bs.width, a);
        }
        bc() {
            if (null != this.aj && this.m) {
                let a = this.aj.getNativeElement();
                if (this.g.bd != null) {
                    this.g.bd.removeChild(a);
                }
                else {
                    document.body.removeChild(a);
                }
                this.m = false;
            }
        }
        aw(a) {
            this.ai = a;
            this.am.append(this.ai);
            this.ap = new ResizeObserver(runOn(this, this.a3));
        }
        a3(a) {
            if (this.m) {
                if (this.g.ao() && this.g.p == 0) {
                    return;
                }
                this.g.b8();
            }
        }
        j(a) {
            let b = this.aj.getNativeElement();
            return b.contains(a);
        }
        bb(a) {
            this.ai = null;
            this.ap.disconnect();
            this.ap = null;
            a.remove();
        }
        d(a) {
            return new AnimationKeyFrameEffect(0, this.am, 0, null, a);
        }
        e(a) {
            return new AnimationKeyFrameEffect(0, this.an, 0, null, a);
        }
        ay() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.ah;
            }
        }
        c(a) {
            return new AnimationKeyFrameEffect(0, this.aj, 0, null, a);
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.an, 0, null, a);
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.aj, 0, null, a);
        }
        i() {
            return 12;
        }
        h() {
            return 11;
        }
        n() {
            return this.g.bd != null && !this.g.aq && !this.l();
        }
        get bs() {
            if (this.k) {
                this.a1();
            }
            return this.br;
        }
        y(a, b, c) {
            let d;
            switch (b) {
                case 3:
                    d = (!this.n() ? a.left : 0) - (this.bs.width + (this.g.at ? this.aa : 0));
                    break;
                case 4:
                    d = !this.n() ? a.right : a.width;
                    break;
                case 0:
                case 2:
                case 1:
                default:
                    switch (c) {
                        case 2:
                            d = (!this.n() ? a.right : a.width) - this.bs.width;
                            break;
                        case 3:
                            d = (!this.n() ? a.right : a.width) - (a.width / 2) - (this.bs.width / 2);
                            break;
                        case 0:
                        case 1:
                        default:
                            d = !this.n() ? a.left : 0;
                            break;
                    }
                    break;
            }
            return d;
        }
        z(a, b, c) {
            let d;
            switch (b) {
                case 3:
                case 4:
                    switch (c) {
                        case 2:
                            d = (!this.n() ? a.bottom : 0) - this.bs.height;
                            break;
                        case 3:
                            d = (!this.n() ? a.top : -a.height) - (this.bs.height / 2) + (a.height / 2);
                            break;
                        case 0:
                        case 1:
                        default:
                            d = !this.n() ? a.top : -a.height;
                            break;
                    }
                    break;
                case 2:
                    d = (!this.n() ? a.top : -a.height) - (this.bs.height + (this.g.at ? this.aa : 0));
                    break;
                case 0:
                case 1:
                default:
                    d = !this.n() ? a.bottom : 0;
                    break;
            }
            return d;
        }
        static as(a) {
            return stringFormat("{0}px", a);
        }
        static ar(a) {
            return stringFormat("{0}px", a);
        }
        bj() {
            if (this.g.r == 1 || this.g.r == 2) {
                switch (this.g.j) {
                    case 3:
                        this.v = this.ad + (this.s - this.q);
                        break;
                }
            }
            else if (this.g.r == 3 || this.g.r == 4) {
                switch (this.g.j) {
                    case 3:
                        this.w = this.ae + (this.t - this.r);
                        break;
                }
            }
            this.ak.setStyleProperty("transform", "translate(" + this.v + "px, " + this.w + "px) rotate(" + this.u + "deg)");
        }
        ax(a, b, c, d) {
            this.s = a;
            this.t = b;
            if (this.g.r == 1 || this.g.r == 2) {
                let e = (window.innerWidth);
                let f = a;
                let g = f + c;
                if (f < 5) {
                    a = 5;
                }
                else if (g > e - 5) {
                    a = f - (g - (e - 5));
                }
            }
            else if (this.g.r == 3 || this.g.r == 4) {
                let h = (window.innerHeight);
                let i = b;
                let j = i + d;
                if (i < 5) {
                    b = 5;
                }
                else if (j > h - 5) {
                    b = i - (j - (h - 5));
                }
            }
            return {
                p0: a,
                p1: b
            };
        }
        bq(a, b, c) {
            let d = this.z(a, b, c);
            let e = this.y(a, b, c);
            if (this.g.bd == null) {
                let f = this.ax(e, d, this.bs.width, this.bs.height);
                e = f.p0;
                d = f.p1;
            }
            this.bd(e, d);
            if (b == 2 || c == 2) {
                let g = 10;
                while (g > 0) {
                    let h = this.z(a, b, c);
                    let i = this.y(a, b, c);
                    if (this.g.bd == null) {
                        let j = this.ax(i, h, this.bs.width, this.bs.height);
                        i = j.p0;
                        h = j.p1;
                    }
                    if (h == d && i == e) {
                        g = 0;
                        break;
                    }
                    d = h;
                    e = i;
                    this.bd(e, d);
                    g--;
                }
            }
            this.bj();
            return new Rect(0, e, d, this.bs.width, this.bs.height);
        }
        bp(a, b, c) {
            let d = new Rect(4);
            let target_ = a;
            if ((target_.getBoundingClientRect)) {
                let bRect_ = target_.getBoundingClientRect();
                d.left = (bRect_.left);
                d.top = (bRect_.top);
                d.width = (bRect_.width);
                d.height = (bRect_.height);
            }
            let e = this.bq(d, b, c);
            return e;
        }
        a1() {
            if (this.m) {
                this.an.setStyleProperty("width", stringEmpty());
                this.an.setStyleProperty("height", stringEmpty());
                this.aj.setStyleProperty("width", stringEmpty());
                this.aj.setStyleProperty("height", stringEmpty());
                this.aj.setStyleProperty("position", "absolute");
                this.br = new Size(1, this.am.outerWidth(), this.am.outerHeight());
                this.k = false;
                this.bk();
            }
            else {
                this.k = true;
            }
        }
        bd(a, b) {
            let c = stringFormat("{0}px", a);
            let d = stringFormat("{0}px", b);
            this.aj.setStyleProperty("left", c);
            this.aj.setStyleProperty("top", d);
            this.q = a;
            this.r = b;
        }
        a9(a) {
            if (a == null) {
                this.ag = null;
                if (this.aj != null) {
                    this.aj.unlistenAll();
                }
                return;
            }
            this.ag = a;
            let b = a.rootWrapper;
            this.az(b);
            this.ag.getPortal(this.am, "ChildContent", (c) => {
                let comp_ = c.componentRef;
                this.aq = comp_;
            }, true);
        }
        bk() {
            let a = new Size(1, this.bs.width, this.bs.height);
            if (!this.m || (!this.g.aw && !this.g.ap)) {
                a.height = 0;
            }
            let b = a.width;
            let c = a.height;
            let d = stringFormat("{0}px", b);
            let e = stringFormat("{0}px", c);
            this.bi(b, c);
            if (this.g.at) {
                switch (this.g.t()) {
                    case 2:
                        d = stringFormat("{0}px", b);
                        e = stringFormat("{0}px", this.aa + c);
                        break;
                    case 1:
                        d = stringFormat("{0}px", b);
                        e = stringFormat("{0}px", this.aa + c);
                        break;
                    case 3:
                        d = stringFormat("{0}px", this.aa + b);
                        e = stringFormat("{0}px", c);
                        break;
                    case 4:
                        d = stringFormat("{0}px", this.aa + b);
                        e = stringFormat("{0}px", c);
                        break;
                }
            }
            if (this.f.ao()) {
                if (this.g.ap || this.x == c) {
                    return;
                }
                this.f.b2();
                this.p = true;
                return;
            }
            this.p = false;
            let f = stringFormat("{0}px", b);
            let g = stringFormat("{0}px", c);
            this.an.setStyleProperty("width", f);
            this.an.setStyleProperty("height", g);
            if (!this.l()) {
                if (this.g.bd != null) {
                    e = "0px";
                }
                this.aj.setStyleProperty("width", d);
                this.aj.setStyleProperty("height", e);
            }
            this.be(this.g.aq);
        }
        bi(a, b) {
            if (this.g.at) {
                let c = 0;
                let d = 0;
                switch (this.g.t()) {
                    case 2:
                        c = 135;
                        d = -this.ac;
                        this.v = a / 2 - this.ac;
                        this.w = d;
                        break;
                    case 1:
                        c = -45;
                        d = this.aa - this.ac;
                        this.v = a / 2 - this.ac;
                        this.w = d;
                        break;
                    case 3:
                        c = -135;
                        d = this.aa - this.ac;
                        this.v = d;
                        this.w = b / 2 - this.ac;
                        break;
                    case 4:
                        c = 45;
                        d = -this.ac;
                        this.v = d;
                        this.w = b / 2 - this.ac;
                        break;
                }
                this.u = c;
                this.ak.setStyleProperty("transform", "translate(" + this.v + "px, " + this.w + "px) rotate(" + this.u + "deg)");
            }
        }
        az(a) {
            this.ao = a;
            this.a6();
        }
        a0(a) {
            this.f = a;
        }
        a2() {
        }
        ba() {
            this.at();
            if (this.g.aw) {
                return;
            }
            this.bk();
        }
        bg(a) {
            if (this.aj != null) {
                this.aj.setStyleProperty("pointer-events", a ? "auto" : "none");
            }
        }
        bf(a) {
            if (this.aj != null) {
                this.aj.setAttribute("tabindex", a ? "-1" : "");
            }
        }
        be(a) {
            if (this.aj != null) {
                this.aj.setStyleProperty("position", a ? "fixed" : this.g.bd != null ? "relative" : "absolute");
            }
        }
        bh(a) {
            if (this.aj != null && this.o()) {
                let b = this.aj.getNativeElement();
                if (a) {
                    b.popover = "manual";
                }
                else {
                    b.popover = undefined;
                }
            }
        }
    }
    PopupView.$t = /*@__PURE__*/ markType(PopupView, 'PopupView');
    return PopupView;
})();
/**
 * @hidden
 */
let Popup = /*@__PURE__*/ (() => {
    class Popup extends Base {
        get c6() {
            return this.c5;
        }
        get c4() {
            return this.c3;
        }
        get r() {
            return this.q;
        }
        set r(a) {
            this.q = a;
        }
        get j() {
            return this.i;
        }
        get a2() {
            return this.a1;
        }
        get bd() {
            return this.bb;
        }
        constructor() {
            super();
            this.q = 0;
            this.i = 0;
            this.a1 = 0;
            this.c5 = null;
            this.c3 = null;
            this.bb = null;
            this.onClosed = null;
            this.onPopup = null;
            this.propertyChanged = null;
            this.popupMouseEnter = null;
            this.popupMouseLeave = null;
            this.popupGotFocus = null;
            this.popupLostFocus = null;
            this.w = null;
            this.af = false;
            this.a7 = 50;
            this.ak = true;
            this.o = 0;
            this.a5 = -1;
            this.a4 = Popup.a9;
            this.av = false;
            this.cs = Popup.c1;
            this.cr = Popup.c0;
            this.cq = Popup.cz;
            this.ct = null;
            this.ay = 0;
            this.ag = true;
            this.ac = false;
            this.ah = false;
            this.s = 0;
            this.cu = null;
            this.az = 20;
            this.ai = false;
            this.ad = false;
            this.ae = false;
            this.aj = false;
            this.k = null;
            NativeUIInputsFactory.n();
            let a = this.v();
            this.w = a;
            a.a0(this);
        }
        cf(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.ci(a, b, c);
        }
        cd() {
            if (this.popupMouseEnter != null) {
                this.popupMouseEnter(this, new MouseEventArgs());
            }
        }
        ce() {
            if (this.popupMouseLeave != null) {
                this.popupMouseLeave(this, new MouseEventArgs());
            }
        }
        cb() {
            if (this.popupGotFocus != null) {
                this.popupGotFocus(this, new FocusEventArgs());
            }
        }
        cc(a) {
            if (this.popupLostFocus != null) {
                this.popupLostFocus(this, ((() => {
                    let $ret = new FocusEventArgs();
                    $ret.a = a;
                    return $ret;
                })()));
            }
        }
        get ar() {
            return this.af;
        }
        set ar(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.cf("IsFocusable", b, this.af);
            }
        }
        get a8() {
            return this.a7;
        }
        set a8(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.cf("AnimationDuration", b, a);
            }
        }
        get al() {
            return this.ak;
        }
        set al(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.cf("AnimationEnabled", b, a);
            }
        }
        get p() {
            return this.o;
        }
        set p(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.cf("AnimationType", enumGetBox(PopupAnimationType_$type, b), enumGetBox(PopupAnimationType_$type, this.o));
            }
        }
        get ba() {
            return this.a5;
        }
        set ba(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.cf("Elevation", b, a);
            }
        }
        get a6() {
            return this.a4;
        }
        set a6(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.cf("ActualElevation", b, a);
            }
        }
        get aw() {
            return this.av;
        }
        get cx() {
            return this.cs;
        }
        set cx(a) {
            let b = this.cs;
            this.cs = a;
            if (b != this.cs) {
                this.cf("ActualUmbraShadowColor", b, a);
            }
        }
        get cw() {
            return this.cr;
        }
        set cw(a) {
            let b = this.cr;
            this.cr = a;
            if (b != this.cr) {
                this.cf("ActualPenumbraShadowColor", b, a);
            }
        }
        get cv() {
            return this.cq;
        }
        set cv(a) {
            let b = this.cq;
            this.cq = a;
            if (b != this.cq) {
                this.cf("ActualAmbientShadowColor", b, a);
            }
        }
        get cy() {
            return this.ct;
        }
        set cy(a) {
            let b = this.ct;
            this.ct = a;
            if (b != this.ct) {
                this.cf("Background", b, this.ct);
            }
        }
        get a0() {
            return this.ay;
        }
        set a0(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.cf("CornerRadius", b, this.ay);
            }
        }
        get as() {
            return this.ag;
        }
        set as(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.cf("IsHitTestVisible", b, this.ag);
            }
        }
        get an() {
            return this.ac;
        }
        set an(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.cf("DisableHitTestDuringAnimation", b, this.ac);
            }
        }
        get at() {
            return this.ah;
        }
        set at(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.cf("IsPointerEnabled", b, this.ah);
            }
        }
        get u() {
            return this.s;
        }
        set u(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.cf("PointerPosition", enumGetBox(PopupPointerPosition_$type, b), enumGetBox(PopupPointerPosition_$type, this.s));
            }
        }
        get c2() {
            return this.cu;
        }
        set c2(a) {
            let b = this.cu;
            this.cu = a;
            if (b != this.cu) {
                this.cf("PointerBackground", b, this.cu);
            }
        }
        get a3() {
            return this.az;
        }
        set a3(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.cf("PointerSize", b, this.az);
            }
        }
        get au() {
            return this.ai;
        }
        set au(a) {
            this.ai = a;
        }
        get ap() {
            return this.ad;
        }
        set ap(a) {
            this.ad = a;
        }
        get aq() {
            return this.ae;
        }
        set aq(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.cf("IsFixed", b, this.ae);
            }
        }
        get ax() {
            return this.aj;
        }
        set ax(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.cf("UseTopLayer", b, this.aj);
            }
        }
        v() {
            return new PopupView();
        }
        ci(a, b, c) {
            switch (a) {
                case "IsShown":
                    if (false == this.aw) {
                        this.w.bc();
                        this.bb = null;
                    }
                    break;
                case "Elevation":
                    this.a6 = this.ba == -1 ? Popup.a9 : this.ba;
                    break;
                case "ActualElevation":
                case "ActualUmbraShadowColor":
                case "ActualPenumbraShadowColor":
                case "ActualAmbientShadowColor":
                case "Background":
                case "CornerRadius":
                    this.w.bo();
                    break;
                case "AnimationEnabled":
                    if (false == this.al) {
                        this.b2();
                    }
                    break;
                case "IsHitTestVisible":
                    this.w.bg(this.as);
                    break;
                case "IsFocusable":
                    this.w.bf(this.ar);
                    break;
                case "IsFixed":
                    this.w.be(this.aq);
                    break;
                case "UseTopLayer":
                    this.w.bh(this.ax);
                    break;
            }
        }
        b2() {
            if (this.ao()) {
                this.k.e();
            }
        }
        z(a) {
            let b = this.g(a);
            let c = a ? this.c() : this.b();
            let d = this.w.d(c);
            let e = new List$1(AnimationKeyFrameProperty.$, 0);
            let f = new List$1(AnimationKeyFrameProperty.$, 0);
            let g = new TranslateTransform();
            g.k = b.a;
            let h = new TranslateTransform();
            h.k = b.b;
            let i = new AnimationKeyFrameProperty(14, g);
            let j = new AnimationKeyFrameProperty(14, h);
            e.add(i);
            f.add(j);
            d.m(...e.toArray());
            d.m(...f.toArray());
            return KeyFrameAnimationFactory.f.c(d);
        }
        a(a) {
            let b = new List$1(IKeyFrameAnimation_$type, 0);
            let c = this.h(a);
            this.w.av(c.h);
            let d = a ? this.c() : this.b();
            let e = this.w.e(d);
            let f = new List$1(AnimationKeyFrameProperty.$, 0);
            let g = new List$1(AnimationKeyFrameProperty.$, 0);
            let h = new AnimationKeyFrameProperty(10, c.g);
            let i = new AnimationKeyFrameProperty(10, c.h);
            f.add(h);
            g.add(i);
            e.m(...f.toArray());
            e.m(...g.toArray());
            b.add(KeyFrameAnimationFactory.f.c(e));
            if (this.q == 2) {
                let j = c.c;
                let k = c.f;
                let l = this.w.c(d);
                let m = new List$1(AnimationKeyFrameProperty.$, 0);
                let n = new List$1(AnimationKeyFrameProperty.$, 0);
                let o = new AnimationKeyFrameProperty(12, j);
                let p = new AnimationKeyFrameProperty(12, k);
                m.add(o);
                n.add(p);
                l.m(...m.toArray());
                l.m(...n.toArray());
                b.add(KeyFrameAnimationFactory.f.c(l));
            }
            return b.toArray();
        }
        b() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = this.a8;
            a.b = 3;
            return a;
        }
        c() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = this.a8;
            a.b = 3;
            return a;
        }
        b7() {
            this.w.ay();
        }
        g(a) {
            let b = truncate(this.w.bs.height);
            if (b <= 0) {
                b = 500;
            }
            let c = a ? -b : 0;
            let d = a ? 0 : -b;
            if (this.q == 2) {
                c = 0;
                d = 0;
            }
            let e = ((() => {
                let $ret = new Popup_InnerAnimationInfo();
                $ret.a = c;
                $ret.b = d;
                return $ret;
            })());
            return e;
        }
        h(a) {
            let b = truncate(this.w.bs.height);
            if (b <= 0) {
                b = 500;
            }
            let c = a ? 0 : b;
            let d = a ? b : 0;
            let e = this.c5.top;
            let f = this.c5.top;
            let g = this.c5.left;
            let h = g;
            switch (this.q) {
                case 2:
                    e = a ? this.c5.bottom : this.c5.top;
                    f = a ? this.c5.top : this.c5.bottom;
                    g = this.c5.left;
                    h = g;
                    break;
                case 1:
                    e = this.c5.top;
                    f = this.c5.top;
                    g = this.c5.left;
                    h = g;
                    break;
                case 3:
                case 4:
                    e = this.c5.top;
                    f = e;
                    g = this.c5.left;
                    h = g;
                    break;
            }
            let i = ((() => {
                let $ret = new Popup_OuterAnimationInfo();
                $ret.g = c;
                $ret.h = d;
                $ret.c = e;
                $ret.f = f;
                $ret.a = g;
                $ret.d = h;
                return $ret;
            })());
            return i;
        }
        ao() {
            if (this.k == null) {
                return false;
            }
            return this.k.b;
        }
        b8() {
            this.w.a1();
            if (this.aw) {
                if (this.bd != null) {
                    this.c5 = this.w.bp(this.bd, this.q, this.i);
                }
                else {
                    this.c5 = this.w.bq(this.c3, this.q, this.i);
                }
            }
        }
        ch(a, b, c) {
            this.c3 = a;
            this.q = b;
            this.i = c;
            this.a1 = 0;
            this.w.ba();
            this.c5 = this.w.bq(a, b, c);
        }
        cg(a, b, c) {
            this.bb = a;
            this.q = b;
            this.i = c;
            this.a1 = 0;
            this.w.ba();
            this.c5 = this.w.bp(a, b, c);
        }
        cm(a, b, c) {
            if (this.av) {
                this.av = false;
                this.cf("IsShown", true, this.av);
            }
            this.ch(a, b, c);
            this.cn(true);
        }
        cl(a, b, c) {
            if (this.av) {
                this.av = false;
                this.cf("IsShown", true, this.av);
            }
            this.cg(a, b, c);
            this.cn(true);
        }
        cn(a) {
            let b = this.av;
            this.av = a;
            this.au = a;
            this.ap = !a;
            if (false == this.al) {
                let c = this.h(a);
                let d = this.g(a);
                let e = this.w.au(c, d);
                c = e.p0;
                d = e.p1;
                return;
            }
            if (this.ao()) {
                this.k.i();
                return;
            }
            this.b7();
            this.k = this.l(this.p, this.av);
            this.k.h((f) => {
                this.k.g();
                if (f) {
                    switch (this.p) {
                        case 0:
                            this.b4(this.av);
                            break;
                        case 1:
                            this.b3(this.av);
                            break;
                    }
                }
                this.cf("IsShown", b, this.av);
                if (this.av) {
                    if (this.onPopup != null) {
                        this.onPopup(this, new OnPopupEventArgs());
                    }
                }
                else {
                    if (this.onClosed != null) {
                        this.onClosed(this, new OnClosedEventArgs());
                    }
                }
                this.au = false;
                this.ap = false;
                let g = this.h(this.av);
                let h = this.g(this.av);
                let i = this.w.au(g, h);
                g = i.p0;
                h = i.p1;
            });
        }
        l(a, b) {
            switch (a) {
                case 0: return this.n(b);
                case 1: return this.m(b);
                default: return this.n(b);
            }
        }
        n(a) {
            let b = this.z(a);
            let c = this.a(a);
            let d = new PopupAnimation();
            d.c.add(b);
            for (let f = 0; f < c.length; f++) {
                let e = c[f];
                d.c.add(e);
            }
            return d;
        }
        b4(a) {
            let b = this.h(a);
            let c = this.g(a);
            for (let d of fromEnum(this.k.c)) {
                for (let e = 0; e < d.effect.f.length; e++) {
                    switch (d.effect.f[e]) {
                        case 14:
                            d.effect.g[e].c(d.effect.a4, ((() => {
                                let $ret = new TranslateTransform();
                                $ret.k = c.b;
                                return $ret;
                            })()));
                            break;
                        case 10:
                            d.effect.g[e].c(d.effect.a4, b.h);
                            break;
                        case 12:
                            d.effect.g[e].c(d.effect.a4, b.f);
                            break;
                    }
                }
            }
        }
        m(a) {
            let b = this.h(a);
            this.w.av(a ? b.h : b.g);
            let c = this.c();
            let d = this.w.c(c);
            let e = DeviceUtils.g(30);
            let f = this.w.i();
            let g = b.f - e;
            let h = b.f;
            switch (this.q) {
                case 2:
                    g = a ? b.f + e : b.c + e;
                    h = a ? b.f : b.c;
                    f = this.w.i();
                    break;
                case 1:
                    g = b.f - e;
                    h = b.f;
                    f = this.w.i();
                    break;
                case 3:
                    g = b.d + e;
                    h = b.d;
                    f = this.w.h();
                    break;
                case 4:
                    g = b.d - e;
                    h = b.d;
                    f = this.w.h();
                    break;
            }
            d.m(new AnimationKeyFrameProperty(f, a ? g : h));
            d.m(new AnimationKeyFrameProperty(f, a ? h : g));
            let i = this.w.a(c);
            i.m(new AnimationKeyFrameProperty(1, a ? 0 : 1));
            i.m(new AnimationKeyFrameProperty(1, a ? 1 : 0));
            let j = this.w.b(c);
            j.m(new AnimationKeyFrameProperty(10, (a ? b.h : b.g)));
            j.m(new AnimationKeyFrameProperty(10, (a ? b.h : b.g)));
            let k = new PopupAnimation();
            k.c.add(KeyFrameAnimationFactory.f.c(d));
            k.c.add(KeyFrameAnimationFactory.f.c(i));
            k.c.add(KeyFrameAnimationFactory.f.c(j));
            return k;
        }
        b3(a) {
            let b = this.h(a);
            let c = this.w.i();
            let d = NaN;
            let e = a ? 1 : 0;
            let f = a ? b.h : b.g;
            switch (this.q) {
                case 2:
                    c = this.w.i();
                    d = a ? b.f : b.c;
                    break;
                case 1:
                    c = this.w.i();
                    d = b.f;
                    break;
                case 3:
                    c = this.w.h();
                    d = b.d;
                    break;
                case 4:
                    c = this.w.h();
                    d = b.d;
                    break;
            }
            for (let g of fromEnum(this.k.c)) {
                for (let h = 0; h < g.effect.f.length; h++) {
                    if (g.effect.f[h] == c) {
                        g.effect.g[h].c(g.effect.a4, d);
                    }
                    else if (g.effect.f[h] == 1) {
                        g.effect.g[h].c(g.effect.a4, e);
                    }
                    else if (g.effect.f[h] == 10) {
                        g.effect.g[h].c(g.effect.a4, f);
                    }
                }
            }
        }
        contains(a) {
            return this.w.j(a);
        }
        appendPopupContent(a) {
            this.w.aw(a);
        }
        removePopupContent(a) {
            this.w.bb(a);
        }
        b5() {
            if (!this.av) {
                return;
            }
            this.cn(false);
        }
        destroy() {
            this.provideRenderer(null);
        }
        showRelativeToExclusionRect(a, b, c) {
            this.cm(a, b, c);
        }
        cp(a, b, c) {
            this.cl(a, b, c);
        }
        b9(a) {
            this.c3 = a;
            this.c5 = this.w.bq(a, this.q, this.i);
        }
        notifySizeChanged() {
        }
        provideRenderer(a) {
            this.w.a9(a);
        }
        bc() {
            return this.d();
        }
        bp() {
            let a = this.d();
            return a.f();
        }
        d() {
            let a = new PopupVisualModelExport();
            a.e = this.a6;
            a.d = this.aw;
            a.c = AppearanceHelper.a(this.cx);
            a.b = AppearanceHelper.a(this.cw);
            a.a = AppearanceHelper.a(this.cv);
            return a;
        }
        t() {
            let a = this.u;
            if (a == 0) {
                switch (this.r) {
                    case 4:
                        a = 3;
                        break;
                    case 3:
                        a = 4;
                        break;
                    case 2:
                        a = 2;
                        break;
                    case 1:
                        a = 1;
                        break;
                }
            }
            return a;
        }
    }
    Popup.$t = /*@__PURE__*/ markType(Popup, 'Popup', Base.$, [INotifyPropertyChanged_$type]);
    Popup.a9 = 2;
    Popup.c1 = /*@__PURE__*/ BrushUtil.h(66, 0, 0, 0);
    Popup.c0 = /*@__PURE__*/ BrushUtil.h(30, 0, 0, 0);
    Popup.cz = /*@__PURE__*/ BrushUtil.h(20, 0, 0, 0);
    return Popup;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

class IgrOnPopupEventArgs {
    createImplementation() {
        return new OnPopupEventArgs();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
}

class IgrOnClosedEventArgs {
    createImplementation() {
        return new OnClosedEventArgs();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
}

class IgrPopup extends Component {
    set height(value) {
        this._height = value;
        if (this._elRef) {
            this._elRef.style.height = value;
            this.i.notifySizeChanged();
        }
    }
    get height() {
        return this._height;
    }
    set width(value) {
        this._width = value;
        if (this._elRef) {
            this._elRef.style.height = value;
            this.i.notifySizeChanged();
        }
    }
    get width() {
        return this._width;
    }
    _getMainRef(ref) {
        this._elRef = ref;
        this.verifyReferences();
    }
    verifyReferences() {
        if (this._elRef) {
            this.requestRender = this.requestRender.bind(this);
            this._portalManager = new PortalManager("popupContent", this.requestRender);
            this._reactRenderer = new ReactRenderer(this._elRef, document, true, {}, this._portalManager);
            // render needs to fire again after the portalManager is created. 
            this.requestRender();
            this.i.provideRenderer(this._reactRenderer);
        }
    }
    render() {
        let propChildren = this.props.children;
        let children = [];
        Children.forEach(propChildren, (ch) => {
            children.push(cloneElement(ch));
        });
        if (this._portalManager)
            this._portalManager.onRender(children);
        let div = createElement("div", {
            ref: this._getMainRef,
            children: children
        });
        return div;
    }
    requestRender() {
        if (this._initialized)
            this.setState({});
    }
    constructor(props) {
        super(props);
        this._reactRenderer = null;
        this._implementation = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._onClosed = null;
        this._onClosed_wrapped = null;
        this._onPopup = null;
        this._onPopup_wrapped = null;
        this._popupGotFocus = null;
        this._popupGotFocus_wrapped = null;
        this._popupLostFocus = null;
        this._popupLostFocus_wrapped = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._getMainRef = this._getMainRef.bind(this);
        if (props) {
            this.initializeProperties();
        }
        this._initialized = true;
    }
    shouldComponentUpdate(nextProps, nextState) {
        const mod = getModifiedProps(this.props, nextProps);
        for (const p of Object.keys(mod)) {
            if (isValidProp(this, p)) {
                this[p] = mod[p];
            }
        }
        return true;
    }
    initializeProperties() {
        for (const p of Object.keys(this.props)) {
            if (isValidProp(this, p)) {
                this[p] = this.props[p];
            }
        }
    }
    // supports angular themes or custom properties set in CSS
    updateStyle() {
        this._styling(this._elRef, this);
    }
    destroy() {
        this.i.destroy();
        if (this._reactRenderer)
            this._reactRenderer.destroy();
    }
    componentWillUnmount() {
    }
    componentDidMount() {
        this._elRef.style.width = this._width ? this._width : "";
        this._elRef.style.height = this._height ? this._height : "";
        this.initializeContent();
    }
    initializeContent() {
        this._styling(this._elRef, this);
        this.updateStyle();
    }
    createImplementation() {
        return new Popup();
    }
    get i() {
        return this._implementation;
    }
    get isFocusable() {
        return this.i.ar;
    }
    set isFocusable(v) {
        this.i.ar = ensureBool(v);
    }
    /**
     * Gets or sets the duration of the Popup and Closeup animations in milliseconds.
    */
    get animationDuration() {
        return this.i.a8;
    }
    set animationDuration(v) {
        this.i.a8 = +v;
    }
    /**
     * Gets or sets whether the popup and closeup animations are animated.
    */
    get animationEnabled() {
        return this.i.al;
    }
    set animationEnabled(v) {
        this.i.al = ensureBool(v);
    }
    /**
     * Gets or sets the type of animation to use when the popup opens and closes.
    */
    get animationType() {
        return this.i.p;
    }
    set animationType(v) {
        this.i.p = ensureEnum(PopupAnimationType_$type, v);
    }
    /**
     * Gets or sets the elevation to use for the button regardless of type.
    */
    get elevation() {
        return this.i.ba;
    }
    set elevation(v) {
        this.i.ba = +v;
    }
    /**
     * Gets or sets the elevation of the border shadow
    */
    get actualElevation() {
        return this.i.a6;
    }
    set actualElevation(v) {
        this.i.a6 = +v;
    }
    /**
     * Gets / sets the isShown state of the panel.
    */
    get isShown() {
        return this.i.aw;
    }
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualUmbraShadowColor() {
        return brushToString(this.i.cx);
    }
    set actualUmbraShadowColor(v) {
        this.i.cx = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualPenumbraShadowColor() {
        return brushToString(this.i.cw);
    }
    set actualPenumbraShadowColor(v) {
        this.i.cw = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualAmbientShadowColor() {
        return brushToString(this.i.cv);
    }
    set actualAmbientShadowColor(v) {
        this.i.cv = stringToBrush(v);
    }
    /**
     * Gets or sets the background color of the popup.
    */
    get background() {
        return brushToString(this.i.cy);
    }
    set background(v) {
        this.i.cy = stringToBrush(v);
    }
    get cornerRadius() {
        return this.i.a0;
    }
    set cornerRadius(v) {
        this.i.a0 = +v;
    }
    /**
     * Gets or sets whether to disable hit testing on the popup.
    */
    get isHitTestVisible() {
        return this.i.as;
    }
    set isHitTestVisible(v) {
        this.i.as = ensureBool(v);
    }
    /**
     * Gets or sets whether to disable hit testing during the open and close animations.
    */
    get disableHitTestDuringAnimation() {
        return this.i.an;
    }
    set disableHitTestDuringAnimation(v) {
        this.i.an = ensureBool(v);
    }
    /**
     * Gets or sets whether to show a pointer off the side of the popup towards the popup target.
    */
    get isPointerEnabled() {
        return this.i.at;
    }
    set isPointerEnabled(v) {
        this.i.at = ensureBool(v);
    }
    /**
     * Gets or sets the pointer position.
    */
    get pointerPosition() {
        return this.i.u;
    }
    set pointerPosition(v) {
        this.i.u = ensureEnum(PopupPointerPosition_$type, v);
    }
    /**
     * Gets or sets the pointer background color.
    */
    get pointerBackground() {
        return brushToString(this.i.c2);
    }
    set pointerBackground(v) {
        this.i.c2 = stringToBrush(v);
    }
    /**
     * Gets or sets the pointer size.
    */
    get pointerSize() {
        return this.i.a3;
    }
    set pointerSize(v) {
        this.i.a3 = +v;
    }
    /**
     * Gets whether the popup is in the middle of opening or not.
    */
    get isShowing() {
        return this.i.au;
    }
    set isShowing(v) {
        this.i.au = ensureBool(v);
    }
    /**
     * Gets whether the popup is in the middle of closing or not.
    */
    get isClosing() {
        return this.i.ap;
    }
    set isClosing(v) {
        this.i.ap = ensureBool(v);
    }
    /**
     * Indicates that the popup will position itself relative to the window instead of the document.
    */
    get isFixed() {
        return this.i.aq;
    }
    set isFixed(v) {
        this.i.aq = ensureBool(v);
    }
    /**
     * Indicates that the popup will place itself into the browser top layer.
    */
    get useTopLayer() {
        return this.i.ax;
    }
    set useTopLayer(v) {
        this.i.ax = ensureBool(v);
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("Popup");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
 * Closes the popup.

*/
    close() {
        this.i.b5();
    }
    showRelativeToExclusionRect(exclusionRect, popupDirection, popupAlignment) {
        this.i.showRelativeToExclusionRect(toRect(exclusionRect), (popupDirection == null ? null : popupDirection), (popupAlignment == null ? null : popupAlignment));
    }
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel() {
        let iv = this.i.bc();
        return (iv);
    }
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel() {
        let iv = this.i.bp();
        return (iv);
    }
    get onClosed() {
        return this._onClosed;
    }
    set onClosed(ev) {
        if (this._onClosed_wrapped !== null) {
            this.i.onClosed = delegateRemove(this.i.onClosed, this._onClosed_wrapped);
            this._onClosed_wrapped = null;
            this._onClosed = null;
        }
        this._onClosed = ev;
        this._onClosed_wrapped = (o, e) => {
            let outerArgs = new IgrOnClosedEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeOnClosed) {
                this.beforeOnClosed(this, outerArgs);
            }
            if (this._onClosed) {
                this._onClosed(this, outerArgs);
            }
        };
        this.i.onClosed = delegateCombine(this.i.onClosed, this._onClosed_wrapped);
        ;
    }
    /**
     * Fires when the popup is shown
    */
    get onPopup() {
        return this._onPopup;
    }
    set onPopup(ev) {
        if (this._onPopup_wrapped !== null) {
            this.i.onPopup = delegateRemove(this.i.onPopup, this._onPopup_wrapped);
            this._onPopup_wrapped = null;
            this._onPopup = null;
        }
        this._onPopup = ev;
        this._onPopup_wrapped = (o, e) => {
            let outerArgs = new IgrOnPopupEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeOnPopup) {
                this.beforeOnPopup(this, outerArgs);
            }
            if (this._onPopup) {
                this._onPopup(this, outerArgs);
            }
        };
        this.i.onPopup = delegateCombine(this.i.onPopup, this._onPopup_wrapped);
        ;
    }
    /**
     * Fired when the open popup gains focus.
    */
    get popupGotFocus() {
        return this._popupGotFocus;
    }
    set popupGotFocus(ev) {
        if (this._popupGotFocus_wrapped !== null) {
            this.i.popupGotFocus = delegateRemove(this.i.popupGotFocus, this._popupGotFocus_wrapped);
            this._popupGotFocus_wrapped = null;
            this._popupGotFocus = null;
        }
        this._popupGotFocus = ev;
        this._popupGotFocus_wrapped = (o, e) => {
            let outerArgs = new IgrFocusEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforePopupGotFocus) {
                this.beforePopupGotFocus(this, outerArgs);
            }
            if (this._popupGotFocus) {
                this._popupGotFocus(this, outerArgs);
            }
        };
        this.i.popupGotFocus = delegateCombine(this.i.popupGotFocus, this._popupGotFocus_wrapped);
        ;
    }
    /**
     * Fired when the open popup loses focus.
    */
    get popupLostFocus() {
        return this._popupLostFocus;
    }
    set popupLostFocus(ev) {
        if (this._popupLostFocus_wrapped !== null) {
            this.i.popupLostFocus = delegateRemove(this.i.popupLostFocus, this._popupLostFocus_wrapped);
            this._popupLostFocus_wrapped = null;
            this._popupLostFocus = null;
        }
        this._popupLostFocus = ev;
        this._popupLostFocus_wrapped = (o, e) => {
            let outerArgs = new IgrFocusEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforePopupLostFocus) {
                this.beforePopupLostFocus(this, outerArgs);
            }
            if (this._popupLostFocus) {
                this._popupLostFocus(this, outerArgs);
            }
        };
        this.i.popupLostFocus = delegateCombine(this.i.popupLostFocus, this._popupLostFocus_wrapped);
        ;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrPopupModule {
    static register() {
        IgrChildContentModule.register();
        TypeRegistrar.registerCons('IgrPopup', IgrPopup);
        TypeRegistrar.registerCons('IgrPopup', IgrPopup);
        TypeRegistrar.register('Popup', Popup.$type);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates which side of the exclusion rectangle to which the popup is aligned.
 */
var PopupAlignment = /*@__PURE__*/ (function (PopupAlignment) {
    /**
     * No specified direction.
     */
    PopupAlignment[PopupAlignment["Auto"] = 0] = "Auto";
    /**
     * Popup should be aligned to the near side. This usually means left or top.
     */
    PopupAlignment[PopupAlignment["Near"] = 1] = "Near";
    /**
     * Popup should be aligned to the near far. This usually means right or bottom.
     */
    PopupAlignment[PopupAlignment["Far"] = 2] = "Far";
    /**
     * Popup should be aligned in the middle.
     */
    PopupAlignment[PopupAlignment["Middle"] = 3] = "Middle";
    return PopupAlignment;
})({});
/**
 * @hidden
 */
let PopupAlignment_$type = /*@__PURE__*/ markEnum('PopupAlignment', 'Auto,0|Near,1|Far,2|Middle,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates which direction the popup will pop up in relation to the exclusion rectangle.
 */
var PopupDirection = /*@__PURE__*/ (function (PopupDirection) {
    /**
     * No specified direction.
     */
    PopupDirection[PopupDirection["Auto"] = 0] = "Auto";
    /**
     * Popup should be displayed downward.
     */
    PopupDirection[PopupDirection["Down"] = 1] = "Down";
    /**
     * Popup should be displayed upward.
     */
    PopupDirection[PopupDirection["Up"] = 2] = "Up";
    /**
     * Popup should be displayed to the left.
     */
    PopupDirection[PopupDirection["Left"] = 3] = "Left";
    /**
     * Popup should be displayed to the right.
     */
    PopupDirection[PopupDirection["Right"] = 4] = "Right";
    return PopupDirection;
})({});
/**
 * @hidden
 */
let PopupDirection_$type = /*@__PURE__*/ markEnum('PopupDirection', 'Auto,0|Down,1|Up,2|Left,3|Right,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes the different types of scrollbars available.
 */
var ScrollbarStyle = /*@__PURE__*/ (function (ScrollbarStyle) {
    /**
     * The default scrollbar style.
     */
    ScrollbarStyle[ScrollbarStyle["Default"] = 0] = "Default";
    /**
     * The scrollbar will fade away after a few seconds when the mouse moves away from it or scrolling stops.
     */
    ScrollbarStyle[ScrollbarStyle["Fading"] = 1] = "Fading";
    /**
     * The scrollbar appears as a thin line when idle. It will grow in size when scrolling or when the mouse is close by.
     */
    ScrollbarStyle[ScrollbarStyle["Thin"] = 2] = "Thin";
    return ScrollbarStyle;
})({});
/**
 * @hidden
 */
let ScrollbarStyle_$type = /*@__PURE__*/ markEnum('ScrollbarStyle', 'Default,0|Fading,1|Thin,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IScrollerView_$type = /*@__PURE__*/ new Type(null, 'IScrollerView');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScrollerScrollingEventArgs = /*@__PURE__*/ (() => {
    class ScrollerScrollingEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._deltaX = 0;
            this._deltaY = 0;
        }
        get deltaX() {
            return this._deltaX;
        }
        set deltaX(a) {
            this._deltaX = a;
        }
        get deltaY() {
            return this._deltaY;
        }
        set deltaY(a) {
            this._deltaY = a;
        }
    }
    ScrollerScrollingEventArgs.$t = /*@__PURE__*/ markType(ScrollerScrollingEventArgs, 'ScrollerScrollingEventArgs', EventArgs.$);
    return ScrollerScrollingEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScrollerView = /*@__PURE__*/ (() => {
    class ScrollerView extends Base {
        constructor(a) {
            super();
            this.c = null;
            this.ab = null;
            this.af = null;
            this.b = null;
            this.aa = null;
            this.a = null;
            this.ae = null;
            this.ac = null;
            this.ad = null;
            this.ag = null;
            this.e = false;
            this.d = null;
            this.i = false;
            this.h = false;
            this.w = 0;
            this.t = 0;
            this.x = -1;
            this.u = -1;
            this.g = false;
            this.f = false;
            this.v = 0;
            this.s = 0;
            this.c = a;
        }
        getDefaultScrollbarBrush() {
            return ((() => {
                let $ret = new Brush();
                $ret.fill = "#666666";
                return $ret;
            })());
        }
        provideContainer(a) {
            if (a == null) {
                if (this.ab != null) {
                    this.ab = null;
                }
                if (this.a != null) {
                    this.a.ao = null;
                    this.a.av();
                }
                return;
            }
            this.ab = a;
            this.c.executionContext = new DOMExecutionContext(this.ab);
            let b = Math.round(this.ab.rootWrapper.width());
            let c = Math.round(this.ab.rootWrapper.height());
            this.ae = this.ab.rootWrapper;
            this.ae.setStyleProperty("position", "relative");
            this.af = this.ab.createElement("div");
            this.af.setStyleProperty("position", "relative");
            this.af.setStyleProperty("width", "100%");
            this.af.setStyleProperty("height", "100%");
            this.af.setStyleProperty("overflow", "hidden");
            this.ae.append(this.af);
            this.ad = this.ab.createElement("div");
            this.ad.setStyleProperty("position", "absolute");
            this.ad.setStyleProperty("height", this.c.scrollbarSpan + "px");
            this.ad.setStyleProperty("width", this.c.minScrollbarSize + "px");
            this.ad.setStyleProperty("background-color", this.c.scrollbarBrush._fill);
            this.ad.setStyleProperty("display", "none");
            this.ad.setStyleProperty("border-radius", "5px");
            this.ad.setStyleProperty("z-index", "10000");
            this.ad.setStyleProperty("bottom", "0px");
            this.ae.append(this.ad);
            this.ag = this.ab.createElement("div");
            this.ag.setStyleProperty("position", "absolute");
            this.ag.setStyleProperty("width", this.c.scrollbarSpan + "px");
            this.ag.setStyleProperty("height", this.c.minScrollbarSize + "px");
            this.ag.setStyleProperty("background-color", this.c.scrollbarBrush._fill);
            this.ag.setStyleProperty("display", "none");
            this.ag.setStyleProperty("border-radius", "5px");
            this.ag.setStyleProperty("z-index", "10000");
            this.ag.setStyleProperty("right", "0px");
            this.ae.append(this.ag);
            this.updateScrollbarStatus(false);
            this.aa = this.af.getNativeElement();
            this.a = new CanvasGestureDOMEventProxy(this.ab.rootWrapper, this.ab, true);
            this.ab.rootWrapper.setProperty("tabIndex", 1000);
            this.ab.rootWrapper.setRawStyleProperty("outline", "none");
            this.a.c8 = true;
            this.a.bv = true;
            let d = this.a;
            d.onMouseWheel = delegateCombine(d.onMouseWheel, runOn(this, this.l));
            let e = this.a;
            e.onMouseWheelHorizontal = delegateCombine(e.onMouseWheelHorizontal, runOn(this, this.m));
            let f = this.a;
            f.onMouseLeave = delegateCombine(f.onMouseLeave, runOn(this, this.an));
            let g = this.a;
            g.onDragStarted = delegateCombine(g.onDragStarted, runOn(this, this.am));
            let h = this.a;
            h.onDragDelta = delegateCombine(h.onDragDelta, runOn(this, this.al));
            let i = this.a;
            i.onDragCompleted = delegateCombine(i.onDragCompleted, runOn(this, this.ak));
            let j = this.a;
            j.onFlingStarted = delegateCombine(j.onFlingStarted, runOn(this, this.j));
            let k = this.a;
            k.onContactStarted = delegateCombine(k.onContactStarted, runOn(this, this.aj));
            let l = this.a;
            l.onContactMoved = delegateCombine(l.onContactMoved, runOn(this, this.ai));
            let m = this.a;
            m.onContactCompleted = delegateCombine(m.onContactCompleted, runOn(this, this.ah));
            this.a.ab = true;
            this.a.aq = runOn(this, this.r);
            let n = this.a;
            n.onKeyDown = delegateCombine(n.onKeyDown, runOn(this, this.k));
            this.a.ar = (o) => {
                let e_ = o.originalEvent;
                let p = (e_.type);
                if (p == "pointerdown" && !this.a.br(o)) {
                    return false;
                }
                return true;
            };
            this.c.di(b, c);
            this.c.horizontalAnimation.u(this.ab);
            this.c.verticalAnimation.u(this.ab);
            this.attachNativeScroll();
        }
        k(a) {
            return this.c.ao(a, (this.a.bi & 4) != 0, (this.a.bi & 2) != 0);
        }
        r(a, b, c) {
            if (this.f || this.g) {
                return true;
            }
            if (c || b) {
                return true;
            }
            if (this.n(a, b)) {
                this.c.c3();
                return true;
            }
            else if (this.c.isHorizontalActive) {
                this.c.c7();
            }
            if (this.o(a, b)) {
                this.c.c4();
                return true;
            }
            else if (this.c.isVerticalActive) {
                this.c.c8();
            }
            return false;
        }
        ah(a, b) {
            this.f = false;
            this.g = false;
            this.c.isDraggingVBar = false;
            this.c.isDraggingHBar = false;
        }
        ai(a, b) {
            if (this.g) {
                let c = a.y - this.v;
                this.v = a.y;
                this.c.dh(c);
            }
            else if (this.f) {
                let d = a.x - this.s;
                this.s = a.x;
                this.c.df(d);
            }
        }
        aj(a, b) {
            this.e = false;
            this.cancelInertia();
            let c = this.q(a, b);
            let d = this.p(a, b);
            if (c) {
                this.c.isDraggingVBar = true;
                this.g = true;
                this.v = a.y;
                this.focus();
            }
            else if (d) {
                this.c.isDraggingHBar = true;
                this.f = true;
                this.s = a.x;
                this.focus();
            }
        }
        p(a, b) {
            if (!this.h) {
                return false;
            }
            if (a.y >= this.c.viewportHeight - this.c.scrollbarSpan && a.y <= this.c.viewportHeight && a.x >= this.u - this.t / 2 && a.x <= this.u + this.t / 2) {
                return true;
            }
            return false;
        }
        q(a, b) {
            if (!this.i) {
                return false;
            }
            if (a.x >= this.c.viewportWidth - this.c.scrollbarSpan && a.x <= this.c.viewportWidth && a.y >= this.x - this.w / 2 && a.y <= this.x + this.w / 2) {
                return true;
            }
            return false;
        }
        n(a, b) {
            if (!this.h) {
                return false;
            }
            return a.y >= this.c.viewportHeight - this.c.scrollbarSpan - 40 && a.y <= this.c.viewportHeight;
        }
        o(a, b) {
            if (!this.i) {
                return false;
            }
            return a.x >= this.c.viewportWidth - this.c.scrollbarSpan - 40 && a.x <= this.c.viewportWidth;
        }
        j(a, b, c) {
            this.e = true;
            return true;
        }
        onViewportHeightChanged(a) {
            this.a.bl = new Rect(0, 0, 0, this.c.viewportWidth, this.c.viewportHeight);
        }
        onViewportWidthChanged(a) {
            this.a.bl = new Rect(0, 0, 0, this.c.viewportWidth, this.c.viewportHeight);
        }
        onContentHeightChanged(a) {
            if (this.ac != null) {
                this.ac.setStyleProperty("height", a + "px");
            }
        }
        onContentWidthChanged(a) {
            if (this.ac != null) {
                this.ac.setStyleProperty("width", a + "px");
            }
        }
        cancelInertia() {
        }
        ak(a) {
            if (this.f || this.g) {
                return;
            }
            this.e = false;
            this.c.dc(a);
        }
        al(a) {
            if (this.f || this.g) {
                return;
            }
            this.c.dd(a);
        }
        updateScrollTop(a) {
            this.aa.scrollTop = truncate(a);
        }
        am(a) {
            if (this.f || this.g) {
                return;
            }
            this.e = false;
            this.c.de(a);
        }
        getInitialScrollLeft() {
            return this.aa.scrollLeft;
        }
        getInitialScrollTop() {
            return this.aa.scrollTop;
        }
        l(a, b) {
            this.e = false;
            this.cancelInertia();
            return this.c.aq(a, 0, b);
        }
        m(a, b) {
            this.e = false;
            this.cancelInertia();
            return this.c.aq(a, b, 0);
        }
        an(a) {
            if (this.c.horizontalScrollbarStatus > 0) {
                this.c.c7();
            }
            if (this.c.verticalScrollbarStatus > 0) {
                this.c.c8();
            }
        }
        updateScrollLeft(a) {
            this.aa.scrollLeft = truncate(a);
        }
        provideContent(a) {
            this.ac = a;
            this.af.append(this.ac);
        }
        requestWork(a) {
            if (this.ab == null) {
                return;
            }
            if (this.d == null) {
                this.d = this.ab.getRequestAnimationFrame();
            }
            if (this.e) {
                a();
            }
            else {
                this.d(() => a());
            }
        }
        hideVScrollbar() {
            if (this.i) {
                this.i = false;
                this.ag.setStyleProperty("display", "none");
            }
        }
        hideHScrollbar() {
            if (this.h) {
                this.h = false;
                this.ad.setStyleProperty("display", "none");
            }
        }
        updateVScrollbar(a, b) {
            let c = false;
            if (!this.i) {
                c = true;
                this.i = true;
                this.ag.setStyleProperty("display", "block");
            }
            if (a != this.x || c) {
                this.x = a;
                if (this.i) {
                    this.ag.setRawYPosition(a - b / 2);
                }
            }
            if (b != this.w || c) {
                this.w = b;
                if (this.i) {
                    this.ag.setRawSize(this.z(), b);
                }
            }
        }
        updateHScrollbar(a, b) {
            let c = false;
            if (!this.h) {
                c = true;
                this.h = true;
                this.ad.setStyleProperty("display", "block");
            }
            if (a != this.u || c) {
                this.u = a;
                if (this.h) {
                    this.ad.setRawXPosition(a - b / 2);
                }
            }
            if (b != this.t || c) {
                this.t = b;
                if (this.h) {
                    this.ad.setRawSize(b, this.y());
                }
            }
        }
        updateScrollbarBrush() {
            if (this.ad != null) {
                this.ad.setStyleProperty("background-color", this.c.scrollbarBrush._fill);
            }
            if (this.ag != null) {
                this.ag.setStyleProperty("background-color", this.c.scrollbarBrush._fill);
            }
        }
        updateScrollbarStatus(a) {
            if (this.ad != null && this.ag != null) {
                switch (this.c.scrollbarStyle) {
                    case 0:
                        if (a) {
                            this.ad.setStyleProperty("opacity", "1");
                            this.ag.setStyleProperty("opacity", "1");
                            this.ad.setRawSize(this.t, this.y());
                            this.ag.setRawSize(this.z(), this.w);
                        }
                        break;
                    case 1:
                        if (a) {
                            this.ad.setRawSize(this.t, this.y());
                            this.ag.setRawSize(this.z(), this.w);
                        }
                        this.ad.setStyleProperty("opacity", this.c.horizontalScrollbarStatus.toString());
                        this.ag.setStyleProperty("opacity", this.c.verticalScrollbarStatus.toString());
                        break;
                    case 2:
                        if (a) {
                            this.ad.setStyleProperty("opacity", "1");
                            this.ag.setStyleProperty("opacity", "1");
                        }
                        this.ad.setRawSize(this.t, this.y());
                        this.ag.setRawSize(this.z(), this.w);
                        break;
                }
            }
        }
        y() {
            if (this.c.scrollbarStyle == 2) {
                return this.c.horizontalScrollbarStatus * (this.c.scrollbarSpan - 2) + 2;
            }
            return this.c.scrollbarSpan;
        }
        z() {
            if (this.c.scrollbarStyle == 2) {
                return this.c.verticalScrollbarStatus * (this.c.scrollbarSpan - 2) + 2;
            }
            return this.c.scrollbarSpan;
        }
        focus() {
            this.ab.rootWrapper.focus(true);
        }
        onDetachedFromUI() {
            if (this.a != null) {
                this.a.bh(this.ab.rootWrapper, "");
            }
        }
        onAttachedToUI() {
            if (this.a != null) {
                this.a.at(this.ab.rootWrapper, "");
            }
        }
        attachNativeScroll() {
            let a = this.af.getNativeElement();
            a.addEventListener("scroll", runOn(this, this.onNativeScroll));
        }
        detachNativeScroll() {
            let a = this.af.getNativeElement();
            a.removeEventListener("scroll", runOn(this, this.onNativeScroll));
        }
        onNativeScroll(a) {
        }
    }
    ScrollerView.$t = /*@__PURE__*/ markType(ScrollerView, 'ScrollerView', Base.$, [IScrollerView_$type]);
    return ScrollerView;
})();
/**
 * @hidden
 */
let Scroller = /*@__PURE__*/ (() => {
    class Scroller extends Base {
        constructor() {
            super();
            this.bh = 49;
            this._keyboardListener = null;
            this.a9 = NaN;
            this.a3 = 49;
            this.a1 = NaN;
            this.bg = 48;
            this.a8 = NaN;
            this.a2 = 48;
            this.a0 = NaN;
            this.a6 = 0;
            this.ba = 20;
            this.bd = 8;
            this.bj = 0;
            this.dx = null;
            this.x = false;
            this.a5 = 0;
            this.bl = 0;
            this.bk = 0;
            this.bf = 0;
            this.be = 0;
            this.c = null;
            this.v = true;
            this.aa = false;
            this.a4 = 0;
            this.az = 0;
            this.h = 0;
            this.a7 = 0;
            this.bi = 0;
            this.j = null;
            this.k = null;
            this.bu = 0;
            this.b5 = 0;
            this.bv = 0;
            this.b6 = 0;
            this._executionContext = null;
            this._isDraggingVBar = false;
            this._isDraggingHBar = false;
            this.s = false;
            this.q = false;
            this.r = false;
            this.dz = null;
            this.p = false;
            this.propertyChanged = null;
            this.onScrolling = null;
            this.onScrollStart = null;
            this.onScrollStop = null;
            this._isScrolling = false;
            this.bb = 0;
            this.bc = 0;
            this.w = false;
            this.ay = new List$1(Boolean_$type, 0);
            this.cb = 500;
            this.cc = 0;
            this.cd = 0;
            this.o = false;
            this.z = false;
            this.n = false;
            this.y = false;
            this.t = true;
            this.u = true;
            this.dx = this.view.getDefaultScrollbarBrush();
            this.j = new DoubleAnimator(0, 1, 400);
            this.k = new DoubleAnimator(0, 1, 400);
            this.j.b = EasingFunctions.cubicEase;
            this.k.b = EasingFunctions.cubicEase;
            let a = this.j;
            a.propertyChanged = delegateCombine(a.propertyChanged, runOn(this, this.c1));
            let b = this.k;
            b.propertyChanged = delegateCombine(b.propertyChanged, runOn(this, this.c2));
        }
        get smallVerticalChange() {
            return this.bh;
        }
        set smallVerticalChange(a) {
            let b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.dg("SmallVerticalChange", b, this.bh);
            }
        }
        get keyboardListener() {
            return this._keyboardListener;
        }
        set keyboardListener(a) {
            this._keyboardListener = a;
        }
        get largeVerticalChange() {
            return this.a9;
        }
        set largeVerticalChange(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.dg("LargeVerticalChange", b, this.a9);
            }
        }
        get bq() {
            return this.a3;
        }
        set bq(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.dg("ActualSmallVerticalChange", b, this.a3);
            }
        }
        get bo() {
            return this.a1;
        }
        set bo(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.dg("ActualLargeVerticalChange", b, this.a1);
            }
        }
        get smallHorizontalChange() {
            return this.bg;
        }
        set smallHorizontalChange(a) {
            let b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.dg("SmallHorizontalChange", b, this.bg);
            }
        }
        get largeHorizontalChange() {
            return this.a8;
        }
        set largeHorizontalChange(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.dg("LargeHorizontalChange", b, this.a8);
            }
        }
        get bp() {
            return this.a2;
        }
        set bp(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.dg("ActualSmallHorizontalChange", b, this.a2);
            }
        }
        get bn() {
            return this.a0;
        }
        set bn(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.dg("ActualLargeHorizontalChange", b, this.a0);
            }
        }
        get contentWidth() {
            return this.a6;
        }
        set contentWidth(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.dg("ContentWidth", b, this.a6);
            }
        }
        get minScrollbarSize() {
            return this.ba;
        }
        set minScrollbarSize(a) {
            let b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.dg("MinScrollbarSize", b, this.ba);
            }
        }
        get scrollbarSpan() {
            return this.bd;
        }
        set scrollbarSpan(a) {
            let b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.dg("ScrollbarSpan", b, this.bd);
            }
        }
        ao(a, b, c) {
            switch (a) {
                case 11: return this.ar(b, c);
                case 10: return this.as(b, c);
                case 17: return this.ah(b, c);
                case 15: return this.aw(b, c);
                case 14: return this.ap(b, c);
                case 16: return this.at(b, c);
                case 13: return this.am(b, c);
                case 12: return this.ai(b, c);
                case 2: return this.av(b, c);
                case 3: return this.aj(b, c);
                case 8: return this.ak();
                case 57: return this.al();
                case 9: return this.au(b, c);
                default: return this.an(a, b, c);
            }
            return false;
        }
        au(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onSpace(a, b)) {
                    return true;
                }
            }
            return false;
        }
        al() {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onF2()) {
                    return true;
                }
            }
            return false;
        }
        ak() {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onEscape()) {
                    return true;
                }
            }
            return false;
        }
        av(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onTab(a, b)) {
                    return true;
                }
            }
            return false;
        }
        ai(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onEnd(a, b)) {
                    return true;
                }
            }
            return false;
        }
        am(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onHome(a, b)) {
                    return true;
                }
            }
            return false;
        }
        at(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onRightArrow(a, b)) {
                    return true;
                }
            }
            if (this.scrollLeft + this.viewportWidth >= this.contentWidth) {
                return false;
            }
            this.dn(this.bp, 0);
            return true;
        }
        ap(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onLeftArrow(a, b)) {
                    return true;
                }
            }
            if (this.scrollLeft <= 0) {
                return false;
            }
            this.dn(this.bp * -1, 0);
            return true;
        }
        aw(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onUpArrow(a, b)) {
                    return true;
                }
            }
            if (this.scrollTop <= 0) {
                return false;
            }
            this.dn(0, this.bq * -1);
            return true;
        }
        ah(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onDownArrow(a, b)) {
                    return true;
                }
            }
            if (this.scrollTop + this.viewportHeight >= this.contentHeight) {
                return false;
            }
            this.dn(0, this.bq);
            return true;
        }
        as(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onPageUp(a, b)) {
                    return true;
                }
            }
            if (this.scrollTop < 0) {
                return false;
            }
            this.dn(0, this.bo * -1);
            return true;
        }
        ar(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onPageDown(a, b)) {
                    return true;
                }
            }
            if (this.scrollTop + this.viewportHeight >= this.contentHeight) {
                return false;
            }
            this.dn(0, this.bo);
            return true;
        }
        aj(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onEnter(a, b)) {
                    return true;
                }
            }
            return false;
        }
        an(a, b, c) {
            if (this.keyboardListener != null) {
                return this.keyboardListener.onKeyDown(a, b, c);
            }
            return false;
        }
        get verticalTrackStartInset() {
            return this.bj;
        }
        set verticalTrackStartInset(a) {
            let b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.dg("VerticalTrackStartInset", b, this.bj);
            }
        }
        get scrollbarBrush() {
            return this.dx;
        }
        set scrollbarBrush(a) {
            let b = this.dx;
            this.dx = a;
            if (b != this.dx) {
                this.dg("ScrollbarBrush", b, this.dx);
            }
        }
        dg(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.dj(a, b, c);
        }
        get ax() {
            return this.x;
        }
        set ax(a) {
            this.x = a;
            if (!this.x) {
                this.view.updateScrollTop(this.scrollTop);
                this.view.updateScrollLeft(this.scrollLeft);
            }
        }
        dj(a, b, c) {
            switch (a) {
                case "ContentWidth":
                    this.view.onContentWidthChanged(this.contentWidth);
                    let d = c;
                    let e = b;
                    if (d < e && this.scrollLeft + this.viewportWidth >= d) {
                        this.dp(d - (this.scrollLeft + this.viewportWidth), 0);
                    }
                    this.du();
                    break;
                case "ContentHeight":
                    this.view.onContentHeightChanged(this.contentHeight);
                    let f = c;
                    let g = b;
                    if (f < g && this.scrollTop > 0 && this.scrollTop + this.viewportHeight >= f) {
                        this.dp(0, f - (this.scrollTop + this.viewportHeight));
                    }
                    this.dw();
                    break;
                case "ScrollTop":
                    if (!this.ax) {
                        this.view.updateScrollTop(this.scrollTop);
                    }
                    break;
                case "ScrollLeft":
                    if (!this.ax) {
                        this.view.updateScrollLeft(this.scrollLeft);
                    }
                    break;
                case "ViewportWidth":
                    this.view.onViewportWidthChanged(this.viewportWidth);
                    if (isNaN_(this.largeVerticalChange)) {
                        this.bn = this.viewportWidth;
                    }
                    if (this.contentWidth > 0 && this.scrollLeft + this.viewportWidth > this.contentWidth) {
                        this.dp(this.contentWidth - this.viewportWidth - this.scrollLeft, 0);
                    }
                    this.du();
                    if (this.view.getInitialScrollLeft() != this.scrollLeft) {
                        this.view.updateScrollLeft(this.scrollLeft);
                    }
                    break;
                case "ViewportHeight":
                    this.view.onViewportHeightChanged(this.viewportHeight);
                    if (isNaN_(this.largeVerticalChange)) {
                        this.bo = this.viewportHeight;
                    }
                    this.dw();
                    if (this.view.getInitialScrollTop() != this.scrollTop) {
                        this.view.updateScrollTop(this.scrollTop);
                    }
                    break;
                case "ScrollbarBrush":
                    this.view.updateScrollbarBrush();
                    break;
                case "ScrollbarSpan":
                case "MinScrollbarSize":
                case "VerticalTrackStartInset":
                    this.dw();
                    this.du();
                    break;
                case "HorizontalScrollbarStatus":
                case "VerticalOpacity":
                    this.view.updateScrollbarStatus(false);
                    break;
                case "ScrollbarStyle":
                    this.view.updateScrollbarStatus(true);
                    break;
            }
        }
        get contentHeight() {
            return this.a5;
        }
        set contentHeight(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.dg("ContentHeight", b, this.a5);
            }
        }
        dh(a) {
            let b = Math.max(this.minScrollbarSize, this.actualVerticalScrollbarHeight);
            let c = this.verticalTrackStartInset + (b / 2);
            let d = this.viewportHeight - (b / 2);
            let e = a / (d - c);
            let f = e * (this.contentHeight - this.viewportHeight);
            this.dn(0, f);
        }
        df(a) {
            let b = Math.max(this.minScrollbarSize, this.actualHorizontalScrollbarWidth);
            let c = 0 + (b / 2);
            let d = this.viewportWidth - (b / 2);
            let e = a / (d - c);
            let f = e * (this.contentWidth - this.viewportWidth);
            this.dn(f, 0);
        }
        di(a, b, c = false) {
            let d = this.bl;
            let e = this.bk;
            this.bl = a;
            this.bk = b;
            if (c && (d != a || e != b)) {
                this.dg("ViewportWidth", d, a);
                this.dg("ViewportHeight", e, b);
            }
        }
        get viewportWidth() {
            return this.bl;
        }
        set viewportWidth(a) {
            let b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.dg("ViewportWidth", b, this.bl);
            }
        }
        get viewportHeight() {
            return this.bk;
        }
        set viewportHeight(a) {
            let b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.dg("ViewportHeight", b, this.bk);
            }
        }
        get scrollTop() {
            return this.bf;
        }
        set scrollTop(a) {
            let b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.dg("ScrollTop", b, this.bf);
            }
        }
        get scrollLeft() {
            return this.be;
        }
        set scrollLeft(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.dg("ScrollLeft", b, this.be);
            }
        }
        get view() {
            if (this.c == null) {
                this.c = new ScrollerView(this);
            }
            return this.c;
        }
        set view(a) {
            this.c = a;
        }
        provideContainer(a) {
            this.view.provideContainer(a);
            this.bf = this.view.getInitialScrollTop();
            this.be = this.view.getInitialScrollLeft();
            this.du();
            this.dw();
        }
        onDetachedFromUI() {
            this.view.onDetachedFromUI();
        }
        onAttachedToUI() {
            this.view.onAttachedToUI();
        }
        provideContent(a) {
            this.view.provideContent(a);
        }
        aq(a, b, c) {
            this.r = false;
            this.q = false;
            this.s = false;
            this.view.cancelInertia();
            if (this.keyboardListener != null) {
                this.keyboardListener.onWheel();
            }
            this.dn(b, c);
            return true;
        }
        get lockScrollDirection() {
            return this.v;
        }
        set lockScrollDirection(a) {
            this.v = true;
        }
        get actualVerticalScrollbarHeight() {
            return this.a4;
        }
        set actualVerticalScrollbarHeight(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.dg("ActualVerticalScrollbarHeight", b, this.a4);
            }
        }
        get actualHorizontalScrollbarWidth() {
            return this.az;
        }
        set actualHorizontalScrollbarWidth(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.dg("ActualHorizontalScrollbarWidth", b, this.az);
            }
        }
        get scrollbarStyle() {
            return this.h;
        }
        set scrollbarStyle(a) {
            let b = this.h;
            this.h = a;
            if (b != this.h) {
                this.dg("ScrollbarStyle", enumGetBox(ScrollbarStyle_$type, b), enumGetBox(ScrollbarStyle_$type, this.h));
            }
        }
        get horizontalScrollbarStatus() {
            return this.a7;
        }
        set horizontalScrollbarStatus(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.dg("HorizontalScrollbarStatus", b, this.a7);
            }
        }
        get verticalScrollbarStatus() {
            return this.bi;
        }
        set verticalScrollbarStatus(a) {
            let b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.dg("VerticalOpacity", b, this.bi);
            }
        }
        get horizontalAnimation() {
            return this.j;
        }
        get verticalAnimation() {
            return this.k;
        }
        get executionContext() {
            return this._executionContext;
        }
        set executionContext(a) {
            this._executionContext = a;
        }
        get isVerticalActive() {
            return this.y;
        }
        get isHorizontalActive() {
            return this.n;
        }
        get isDraggingVBar() {
            return this._isDraggingVBar;
        }
        set isDraggingVBar(a) {
            this._isDraggingVBar = a;
        }
        get isDraggingHBar() {
            return this._isDraggingHBar;
        }
        set isDraggingHBar(a) {
            this._isDraggingHBar = a;
        }
        focus() {
            this.view.focus();
        }
        de(a) {
            this.view.focus();
            this.s = false;
            this.q = false;
            this.r = false;
            this.p = true;
            this.dz = { $type: Point_$type, x: a.x, y: a.y };
        }
        dd(a) {
            if (this.p) {
                let b = a.y - this.dz.y;
                let c = a.x - this.dz.x;
                if (this.lockScrollDirection && !this.r) {
                    this.r = true;
                    if (b > 0 || c > 0) {
                        if (b > c) {
                            this.s = true;
                        }
                        else {
                            this.s = true;
                        }
                    }
                }
                this.dz = { $type: Point_$type, x: a.x, y: a.y };
                this.dn(-c, -b);
            }
        }
        get isScrolling() {
            return this._isScrolling;
        }
        set isScrolling(a) {
            this._isScrolling = a;
        }
        scrollTo(a, b) {
            this.view.detachNativeScroll();
            this.bb = a - this.scrollLeft;
            this.bc = b - this.scrollTop;
            this.dm();
        }
        dn(a, b) {
            this.view.detachNativeScroll();
            this.bb += a;
            this.bc += b;
            this.dm();
        }
        dp(a, b) {
            this.view.detachNativeScroll();
            this.bb += a;
            this.bc += b;
            this.dt();
        }
        dm() {
            if (this.w) {
                return;
            }
            this.w = true;
            this.view.requestWork(runOn(this, this.dt));
        }
        dt() {
            this.w = false;
            let a = this.bb;
            let b = this.bc;
            this.bb = 0;
            this.bc = 0;
            if (this.r) {
                if (this.s) {
                    a = 0;
                }
                if (this.q) {
                    b = 0;
                }
            }
            if (a != 0) {
                this.t = false;
                this.c3();
                this.c7();
                this.t = true;
            }
            if (b != 0) {
                this.u = false;
                this.c4();
                this.c8();
                this.u = true;
            }
            let c = Math.round(this.scrollTop + b);
            let d = Math.round(this.scrollLeft + a);
            if (c < 0) {
                c = 0;
                this.view.cancelInertia();
            }
            if (d < 0) {
                d = 0;
                this.view.cancelInertia();
            }
            if (c + this.viewportHeight > this.contentHeight) {
                c = this.contentHeight - this.viewportHeight;
                if (c < 0) {
                    c = 0;
                }
                this.view.cancelInertia();
            }
            if (d + this.viewportWidth > this.contentWidth) {
                d = this.contentWidth - this.viewportWidth;
                if (d < 0) {
                    d = 0;
                }
                this.view.cancelInertia();
            }
            b = c - this.scrollTop;
            a = d - this.scrollLeft;
            if (b != 0 || a != 0) {
                try {
                    this.ax = true;
                    this.aa = true;
                    this.scrollTop = c;
                    this.scrollLeft = d;
                    this.dw();
                    this.du();
                    this.aa = false;
                    if (!this.isScrolling) {
                        this.isScrolling = true;
                        if (this.onScrollStart != null) {
                            this.onScrollStart(this, ((() => {
                                let $ret = new ScrollerScrollingEventArgs();
                                $ret.deltaX = a;
                                $ret.deltaY = b;
                                return $ret;
                            })()));
                        }
                    }
                    if (this.onScrolling != null) {
                        this.onScrolling(this, ((() => {
                            let $ret = new ScrollerScrollingEventArgs();
                            $ret.deltaX = a;
                            $ret.deltaY = b;
                            return $ret;
                        })()));
                    }
                    if (this.ay.count > 0) {
                        this.ay._inner[this.ay.count - 1] = false;
                    }
                    this.ay.add(true);
                    this.executionContext.executeDelayed(() => {
                        if (this.ay._inner[0]) {
                            if (this.onScrollStop != null) {
                                this.onScrollStop(this, ((() => {
                                    let $ret = new ScrollerScrollingEventArgs();
                                    $ret.deltaX = a;
                                    $ret.deltaY = b;
                                    return $ret;
                                })()));
                            }
                            this.isScrolling = false;
                            this.view.attachNativeScroll();
                        }
                        this.ay.removeAt(0);
                    }, 50);
                }
                finally {
                    this.ax = false;
                }
            }
        }
        dw() {
            this.dv(this.contentHeight, this.viewportHeight, this.scrollTop, true);
        }
        du() {
            this.dv(this.contentWidth, this.viewportWidth, this.scrollLeft, false);
        }
        dv(a, b, c, d) {
            let e = Math.round((b / a) * b);
            let f = d ? this.verticalTrackStartInset : 0;
            e = e - f;
            if (e < this.minScrollbarSize) {
                e = this.minScrollbarSize;
            }
            if (e >= (b - f)) {
                if (d) {
                    this.view.hideVScrollbar();
                }
                else {
                    this.view.hideHScrollbar();
                }
                return;
            }
            let g = f + (e / 2);
            let h = b - (e / 2);
            let i = c / (a - b);
            let j = Math.round(g + (h - g) * i);
            if (d) {
                this.actualVerticalScrollbarHeight = e;
                this.view.updateVScrollbar(j, e);
            }
            else {
                this.actualHorizontalScrollbarWidth = e;
                this.view.updateHScrollbar(j, e);
            }
        }
        dc(a) {
            this.r = false;
            this.q = false;
            this.s = false;
            this.p = false;
        }
        c1(a, b) {
            this.horizontalScrollbarStatus = this.bu + this.j.o * (this.b5 - this.bu);
        }
        c2(a, b) {
            this.verticalScrollbarStatus = this.bv + this.k.o * (this.b6 - this.bv);
        }
        c3() {
            if (this.n) {
                return;
            }
            if (this.scrollbarStyle == 1 || this.scrollbarStyle == 2) {
                if (this.j.f()) {
                    this.j.w();
                }
                this.horizontalScrollbarStatus = 1;
                if (this.o && this.t) {
                    this.o = false;
                }
            }
            this.n = true;
        }
        c4() {
            if (this.y) {
                return;
            }
            if (this.scrollbarStyle == 1 || this.scrollbarStyle == 2) {
                if (this.k.f()) {
                    this.k.w();
                }
                this.verticalScrollbarStatus = 1;
                if (this.z && this.u) {
                    this.z = false;
                }
            }
            this.y = true;
        }
        c7() {
            if (!this.n || this.isDraggingHBar) {
                return;
            }
            if (this.scrollbarStyle == 1 || this.scrollbarStyle == 2) {
                this.dr();
            }
            this.n = false;
        }
        c8() {
            if (!this.y || this.isDraggingVBar) {
                return;
            }
            if (this.scrollbarStyle == 1 || this.scrollbarStyle == 2) {
                this.ds();
            }
            this.y = false;
        }
        dr() {
            if (!this.o) {
                this.o = true;
                this.cc = this.executionContext.getCurrentRelativeTime();
                this.executionContext.executeDelayed(runOn(this, this.c5), this.cb);
            }
            else {
                this.cc = this.executionContext.getCurrentRelativeTime();
            }
        }
        ds() {
            if (!this.z) {
                this.z = true;
                this.cd = this.executionContext.getCurrentRelativeTime();
                this.executionContext.executeDelayed(runOn(this, this.c6), this.cb);
            }
            else {
                this.cd = this.executionContext.getCurrentRelativeTime();
            }
        }
        c5() {
            if (!this.o) {
                return;
            }
            let a = this.executionContext.getCurrentRelativeTime();
            if (a - this.cc >= this.cb) {
                if (!this.j.f() && this.horizontalScrollbarStatus != 0) {
                    this.bu = this.horizontalScrollbarStatus;
                    this.b5 = 0;
                    this.j.v();
                }
                this.o = false;
            }
            else {
                this.executionContext.executeDelayed(runOn(this, this.c5), (this.cb - (a - this.cc)));
            }
        }
        c6() {
            if (!this.z) {
                return;
            }
            let a = this.executionContext.getCurrentRelativeTime();
            if (a - this.cd >= this.cb) {
                if (!this.k.f() && this.verticalScrollbarStatus != 0) {
                    this.bv = this.verticalScrollbarStatus;
                    this.b6 = 0;
                    this.k.v();
                }
                this.z = false;
            }
            else {
                this.executionContext.executeDelayed(runOn(this, this.c6), (this.cb - (a - this.cd)));
            }
        }
    }
    Scroller.$t = /*@__PURE__*/ markType(Scroller, 'Scroller', Base.$, [INotifyPropertyChanged_$type]);
    return Scroller;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IScrollerKeyboardListener_$type = /*@__PURE__*/ new Type(null, 'IScrollerKeyboardListener');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrimitiveAppearanceData = /*@__PURE__*/ (() => {
    class PrimitiveAppearanceData extends Base {
        constructor() {
            super(...arguments);
            this._stroke = null;
            this._strokeExtended = null;
            this._fill = null;
            this._fillExtended = null;
            this._strokeThickness = 0;
            this._isVisible = false;
            this._opacity = 0;
            this._canvasLeft = 0;
            this._canvasTop = 0;
            this._canvaZIndex = 0;
            this._dashArray = null;
            this._dashCap = 0;
        }
        get stroke() {
            return this._stroke;
        }
        set stroke(a) {
            this._stroke = a;
        }
        get strokeExtended() {
            return this._strokeExtended;
        }
        set strokeExtended(a) {
            this._strokeExtended = a;
        }
        get fill() {
            return this._fill;
        }
        set fill(a) {
            this._fill = a;
        }
        get fillExtended() {
            return this._fillExtended;
        }
        set fillExtended(a) {
            this._fillExtended = a;
        }
        get strokeThickness() {
            return this._strokeThickness;
        }
        set strokeThickness(a) {
            this._strokeThickness = a;
        }
        get isVisible() {
            return this._isVisible;
        }
        set isVisible(a) {
            this._isVisible = a;
        }
        get opacity() {
            return this._opacity;
        }
        set opacity(a) {
            this._opacity = a;
        }
        get canvasLeft() {
            return this._canvasLeft;
        }
        set canvasLeft(a) {
            this._canvasLeft = a;
        }
        get canvasTop() {
            return this._canvasTop;
        }
        set canvasTop(a) {
            this._canvasTop = a;
        }
        get canvaZIndex() {
            return this._canvaZIndex;
        }
        set canvaZIndex(a) {
            this._canvaZIndex = a;
        }
        get dashArray() {
            return this._dashArray;
        }
        set dashArray(a) {
            this._dashArray = a;
        }
        get dashCap() {
            return this._dashCap;
        }
        set dashCap(a) {
            this._dashCap = a;
        }
        m(a) {
            this.canvasLeft = (this.canvasLeft - a.left) / a.width;
            this.canvasTop = (this.canvasTop - a.top) / a.height;
        }
        serialize() {
            let a = new StringBuilder(0);
            a.u("{");
            a.u("stroke: " + (this.stroke != null ? this.stroke.serialize() : "null") + ", ");
            a.u("fill: " + (this.fill != null ? this.fill.serialize() : "null") + ", ");
            a.u("strokeExtended: " + (this.strokeExtended != null ? this.strokeExtended.serialize() : "null") + ", ");
            a.u("fillExtended: " + (this.fillExtended != null ? this.fillExtended.serialize() : "null") + ", ");
            a.u("strokeThickness: " + this.strokeThickness + ", ");
            a.u("isVisible: " + (this.isVisible ? "true" : "false") + ", ");
            a.u("opacity: " + this.opacity + ", ");
            a.u("canvasLeft: " + this.canvasLeft + ", ");
            a.u("canvasTop: " + this.canvasTop + ", ");
            a.u("canvasZIndex: " + this.canvaZIndex + ", ");
            if (this.dashArray != null) {
                a.l("dashArray: ");
                a.l("[");
                for (let b = 0; b < this.dashArray.length; b++) {
                    if (b > 0) {
                        a.l(", ");
                    }
                    a.l(this.dashArray[b].toString());
                }
                a.u("], ");
            }
            else {
                a.u("dashArray: null, ");
            }
            a.u("dashCap: " + this.dashCap);
            a.u("}");
            return a.toString();
        }
    }
    PrimitiveAppearanceData.$t = /*@__PURE__*/ markType(PrimitiveAppearanceData, 'PrimitiveAppearanceData', Base.$, [IVisualData_$type]);
    return PrimitiveAppearanceData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeTags = /*@__PURE__*/ (() => {
    class ShapeTags extends List$1 {
        constructor() {
            super(String_$type, 0);
        }
    }
    ShapeTags.$t = /*@__PURE__*/ markType(ShapeTags, 'ShapeTags', /*@__PURE__*/ List$1.$.specialize(String_$type));
    return ShapeTags;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrimitiveVisualData = /*@__PURE__*/ (() => {
    class PrimitiveVisualData extends Base {
        constructor(a, ..._rest) {
            super();
            this._appearance = null;
            this._tags = null;
            this._name = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        this.name = c;
                        this.tags = new ShapeTags();
                        this.appearance = new PrimitiveAppearanceData();
                    }
                    break;
            }
        }
        get appearance() {
            return this._appearance;
        }
        set appearance(a) {
            this._appearance = a;
        }
        get tags() {
            return this._tags;
        }
        set tags(a) {
            this._tags = a;
        }
        get name() {
            return this._name;
        }
        set name(a) {
            this._name = a;
        }
        scaleByViewport(a) {
            this.appearance.m(a);
        }
        getPoints(a) {
            let b = new List$1(List$1.$.specialize(PointData.$), 0);
            this.getPointsOverride(b, a);
            return b;
        }
        serialize() {
            let a = new StringBuilder(0);
            a.u("{");
            a.u("appearance: " + (this.appearance != null ? this.appearance.serialize() : "null") + ", ");
            a.u("tags: [");
            for (let b = 0; b < this.tags.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l("\"" + this.tags._inner[b] + "\"");
            }
            a.u("],");
            a.u("type: \"" + this.type + "\", ");
            a.u("name: \"" + this.name + "\", ");
            a.u(this.e());
            a.u("}");
            return a.toString();
        }
        e() {
            return "";
        }
    }
    PrimitiveVisualData.$t = /*@__PURE__*/ markType(PrimitiveVisualData, 'PrimitiveVisualData', Base.$, [IVisualData_$type]);
    return PrimitiveVisualData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrimitiveVisualDataList = /*@__PURE__*/ (() => {
    class PrimitiveVisualDataList extends List$1 {
        constructor() {
            super(PrimitiveVisualData.$, 0);
        }
        containingTag(a) {
            let b = new PrimitiveVisualDataList();
            for (let c = 0; c < this.count; c++) {
                let d = this._inner[c];
                for (let e = 0; e < d.tags.count; e++) {
                    if (d.tags._inner[e] == a) {
                        b.add(d);
                        break;
                    }
                }
            }
            return b;
        }
        serialize() {
            let a = new StringBuilder(0);
            a.l("{ items: [");
            for (let b = 0; b < this.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l(this._inner[b].serialize());
            }
            return a.toString();
        }
    }
    PrimitiveVisualDataList.$t = /*@__PURE__*/ markType(PrimitiveVisualDataList, 'PrimitiveVisualDataList', /*@__PURE__*/ List$1.$.specialize(PrimitiveVisualData.$), [IVisualData_$type]);
    return PrimitiveVisualDataList;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VisualDataPixelScalingOptions = /*@__PURE__*/ (() => {
    class VisualDataPixelScalingOptions extends Base {
    }
    VisualDataPixelScalingOptions.$t = /*@__PURE__*/ markType(VisualDataPixelScalingOptions, 'VisualDataPixelScalingOptions');
    return VisualDataPixelScalingOptions;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelAppearanceDataList = /*@__PURE__*/ (() => {
    class LabelAppearanceDataList extends List$1 {
        constructor() {
            super(LabelAppearanceData.$, 0);
        }
        serialize() {
            let a = new StringBuilder(0);
            a.l("{ items: [");
            for (let b = 0; b < this.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l(this._inner[b].serialize());
            }
            return a.toString();
        }
    }
    LabelAppearanceDataList.$t = /*@__PURE__*/ markType(LabelAppearanceDataList, 'LabelAppearanceDataList', /*@__PURE__*/ List$1.$.specialize(LabelAppearanceData.$), [IVisualData_$type]);
    return LabelAppearanceDataList;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectData = /*@__PURE__*/ (() => {
    class RectData extends Base {
        constructor(a, b, c, d) {
            super();
            this._top = 0;
            this._left = 0;
            this._width = 0;
            this._height = 0;
            this.left = a;
            this.top = b;
            this.width = c;
            this.height = d;
        }
        get top() {
            return this._top;
        }
        set top(a) {
            this._top = a;
        }
        get left() {
            return this._left;
        }
        set left(a) {
            this._left = a;
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
        serialize() {
            return "{ top: " + this.top + ", left: " + this.left + ", width: " + this.width + ", height: " + this.height + "}";
        }
        static b(a) {
            let b = new RectData(a.left, a.top, a.width, a.height);
            return b;
        }
        h() {
            let a = new Rect(0, this.left, this.top, this.width, this.height);
            return a;
        }
        get isEmpty() {
            return this.width < 0;
        }
        static get empty() {
            return new RectData(Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY, Number.NEGATIVE_INFINITY, Number.NEGATIVE_INFINITY);
        }
    }
    RectData.$t = /*@__PURE__*/ markType(RectData, 'RectData', Base.$, [IVisualData_$type]);
    return RectData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SizeData = /*@__PURE__*/ (() => {
    class SizeData extends Base {
        constructor(a, b) {
            super();
            this._width = 0;
            this._height = 0;
            this.width = a;
            this.height = b;
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
        serialize() {
            return "{ width: " + this.width + ", height: " + this.height + "}";
        }
        static b(a) {
            let b = new SizeData(a.width, a.height);
            return b;
        }
        e() {
            let a = new Size(1, this.width, this.height);
            return a;
        }
        static get empty() {
            return new SizeData(Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
        }
    }
    SizeData.$t = /*@__PURE__*/ markType(SizeData, 'SizeData', Base.$, [IVisualData_$type]);
    return SizeData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GetPointsSettings = /*@__PURE__*/ (() => {
    class GetPointsSettings extends Base {
        constructor() {
            super(...arguments);
            this._ignoreFigureStartPoint = false;
        }
        get ignoreFigureStartPoint() {
            return this._ignoreFigureStartPoint;
        }
        set ignoreFigureStartPoint(a) {
            this._ignoreFigureStartPoint = a;
        }
    }
    GetPointsSettings.$t = /*@__PURE__*/ markType(GetPointsSettings, 'GetPointsSettings');
    return GetPointsSettings;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectangleVisualData = /*@__PURE__*/ (() => {
    class RectangleVisualData extends PrimitiveVisualData {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "rect1");
                        this._width = 0;
                        this._height = 0;
                        this._radiusX = 0;
                        this._radiusY = 0;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                        this._width = 0;
                        this._height = 0;
                        this._radiusX = 0;
                        this._radiusY = 0;
                        this.width = d.width;
                        this.height = d.height;
                        this.radiusX = d.ap;
                        this.radiusY = d.aq;
                        AppearanceHelper.p(this.appearance, d);
                    }
                    break;
            }
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
        get radiusX() {
            return this._radiusX;
        }
        set radiusX(a) {
            this._radiusX = a;
        }
        get radiusY() {
            return this._radiusY;
        }
        set radiusY(a) {
            this._radiusY = a;
        }
        e() {
            return "width: " + this.width + ", height: " + this.height + ", radiusX: " + this.radiusX + ", radiusY: " + this.radiusY;
        }
        get_type() {
            return "Rectangle";
        }
        get type() {
            return this.get_type();
        }
        scaleByViewport(a) {
            super.scaleByViewport(a);
            this.width = this.width / a.width;
            this.height = this.height / a.height;
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            c.add(new PointData(this.appearance.canvasLeft, this.appearance.canvasTop));
            c.add(new PointData(this.appearance.canvasLeft + this.width, this.appearance.canvasTop));
            c.add(new PointData(this.appearance.canvasLeft + this.width, this.appearance.canvasTop + this.height));
            c.add(new PointData(this.appearance.canvasLeft, this.appearance.canvasTop + this.height));
        }
    }
    RectangleVisualData.$t = /*@__PURE__*/ markType(RectangleVisualData, 'RectangleVisualData', PrimitiveVisualData.$);
    return RectangleVisualData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineVisualData = /*@__PURE__*/ (() => {
    class LineVisualData extends PrimitiveVisualData {
        get_type() {
            return "Line";
        }
        get type() {
            return this.get_type();
        }
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "line1");
                        this._x1 = 0;
                        this._y1 = 0;
                        this._x2 = 0;
                        this._y2 = 0;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                        this._x1 = 0;
                        this._y1 = 0;
                        this._x2 = 0;
                        this._y2 = 0;
                        this.x1 = d.an;
                        this.y1 = d.ap;
                        this.x2 = d.ao;
                        this.y2 = d.aq;
                        AppearanceHelper.p(this.appearance, d);
                    }
                    break;
            }
        }
        get x1() {
            return this._x1;
        }
        set x1(a) {
            this._x1 = a;
        }
        get y1() {
            return this._y1;
        }
        set y1(a) {
            this._y1 = a;
        }
        get x2() {
            return this._x2;
        }
        set x2(a) {
            this._x2 = a;
        }
        get y2() {
            return this._y2;
        }
        set y2(a) {
            this._y2 = a;
        }
        e() {
            return "x1: " + this.x1 + ", y1: " + this.y1 + ", x2: " + this.x2 + ", y2: " + this.y2;
        }
        scaleByViewport(a) {
            super.scaleByViewport(a);
            this.x1 = (this.x1 - a.left) / a.width;
            this.y1 = (this.y1 - a.top) / a.height;
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            c.add(new PointData(this.x1, this.y1));
            c.add(new PointData(this.x2, this.y2));
        }
    }
    LineVisualData.$t = /*@__PURE__*/ markType(LineVisualData, 'LineVisualData', PrimitiveVisualData.$);
    return LineVisualData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EllipseVisualData = /*@__PURE__*/ (() => {
    class EllipseVisualData extends PrimitiveVisualData {
        get_type() {
            return "Ellipse";
        }
        get type() {
            return this.get_type();
        }
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "ellipse1");
                        this._width = 0;
                        this._height = 0;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                        this._width = 0;
                        this._height = 0;
                        this.width = d.width;
                        this.height = d.height;
                        AppearanceHelper.p(this.appearance, d);
                    }
                    break;
            }
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
        e() {
            return "width: " + this.width + ", height: " + this.height;
        }
        scaleByViewport(a) {
            super.scaleByViewport(a);
            this.width = this.width / a.width;
            this.height = this.height / a.height;
        }
        getPointsOverride(a, b) {
        }
    }
    EllipseVisualData.$t = /*@__PURE__*/ markType(EllipseVisualData, 'EllipseVisualData', PrimitiveVisualData.$);
    return EllipseVisualData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolyLineVisualData = /*@__PURE__*/ (() => {
    class PolyLineVisualData extends PrimitiveVisualData {
        get_type() {
            return "Polyline";
        }
        get type() {
            return this.get_type();
        }
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "polyLine1");
                        this._points = null;
                        this.points = new List$1(PointData.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                        this._points = null;
                        this.points = new List$1(PointData.$, 0);
                        for (let e = 0; e < d.an.count; e++) {
                            this.points.add(PointData.b(d.an._inner[e]));
                        }
                        AppearanceHelper.p(this.appearance, d);
                    }
                    break;
            }
        }
        get points() {
            return this._points;
        }
        set points(a) {
            this._points = a;
        }
        e() {
            let a = new StringBuilder(0);
            a.u("points: [");
            for (let b = 0; b < this.points.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l("{ x: " + this.points._inner[b].x + ", y: " + this.points._inner[b].y + "}");
            }
            a.u("]");
            return a.toString();
        }
        scaleByViewport(a) {
            super.scaleByViewport(a);
            for (let b = 0; b < this.points.count; b++) {
                this.points._inner[b] = new PointData((this.points._inner[b].x - a.left) / a.width, (this.points._inner[b].y - a.top) / a.height);
            }
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            for (let d = 0; d < this.points.count; d++) {
                c.add(this.points._inner[d]);
            }
        }
    }
    PolyLineVisualData.$t = /*@__PURE__*/ markType(PolyLineVisualData, 'PolyLineVisualData', PrimitiveVisualData.$);
    return PolyLineVisualData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolygonVisualData = /*@__PURE__*/ (() => {
    class PolygonVisualData extends PrimitiveVisualData {
        get_type() {
            return "Polygon";
        }
        get type() {
            return this.get_type();
        }
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "polygon1");
                        this._points = null;
                        this.points = new List$1(PointData.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                        this._points = null;
                        this.points = new List$1(PointData.$, 0);
                        for (let e = 0; e < d.an.count; e++) {
                            this.points.add(PointData.b(d.an._inner[e]));
                        }
                        AppearanceHelper.p(this.appearance, d);
                    }
                    break;
            }
        }
        get points() {
            return this._points;
        }
        set points(a) {
            this._points = a;
        }
        e() {
            let a = new StringBuilder(0);
            a.u("points: [");
            for (let b = 0; b < this.points.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l("{ x: " + this.points._inner[b].x + ", y: " + this.points._inner[b].y + "}");
            }
            a.u("]");
            return a.toString();
        }
        scaleByViewport(a) {
            super.scaleByViewport(a);
            for (let b = 0; b < this.points.count; b++) {
                this.points._inner[b] = new PointData((this.points._inner[b].x - a.left) / a.width, (this.points._inner[b].y - a.top) / a.height);
            }
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            for (let d = 0; d < this.points.count; d++) {
                c.add(this.points._inner[d]);
            }
        }
    }
    PolygonVisualData.$t = /*@__PURE__*/ markType(PolygonVisualData, 'PolygonVisualData', PrimitiveVisualData.$);
    return PolygonVisualData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathVisualData = /*@__PURE__*/ (() => {
    class PathVisualData extends PrimitiveVisualData {
        get_type() {
            return "Path";
        }
        get type() {
            return this.get_type();
        }
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "path1");
                        this._data = null;
                        this.data = new List$1(GeometryData.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                        this._data = null;
                        this.data = AppearanceHelper.g(d.an);
                        AppearanceHelper.p(this.appearance, d);
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                        this._data = null;
                        this.data = AppearanceHelper.h(d);
                        AppearanceHelper.p(this.appearance, d);
                    }
                    break;
            }
        }
        get data() {
            return this._data;
        }
        set data(a) {
            this._data = a;
        }
        e() {
            let a = new StringBuilder(0);
            a.u("data: [");
            for (let b = 0; b < this.data.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l((this.data._inner[b] != null ? this.data._inner[b].serialize() : "null"));
            }
            a.u("]");
            return a.toString();
        }
        scaleByViewport(a) {
            super.scaleByViewport(a);
            for (let b of fromEnum(this.data)) {
                b.scaleByViewport(a);
            }
        }
        getPointsOverride(a, b) {
            for (let c = 0; c < this.data.count; c++) {
                let d = this.data._inner[c];
                d.getPointsOverride(a, b);
            }
        }
    }
    PathVisualData.$t = /*@__PURE__*/ markType(PathVisualData, 'PathVisualData', PrimitiveVisualData.$);
    return PathVisualData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArgumentOutOfRangeException = /*@__PURE__*/ (() => {
    class ArgumentOutOfRangeException extends ArgumentException {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c + " is out of range.");
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, d);
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = [e, c];
                        {
                            let h = f[0];
                            let i = f[1];
                            super(1, i);
                        }
                    }
                    break;
                case 4:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(3, c, d);
                    }
                    break;
            }
        }
    }
    ArgumentOutOfRangeException.$t = /*@__PURE__*/ markType(ArgumentOutOfRangeException, 'ArgumentOutOfRangeException', ArgumentException.$);
    return ArgumentOutOfRangeException;
})();

//
/**
 * @hidden
 */
let Buffer = /*@__PURE__*/ (() => {
    class Buffer extends Base {
        static b(a) {
            try {
            }
            catch (b) {
            }
            if (a == null) {
                throw new ArgumentNullException(0, "array");
            }
            let c = a.length;
            if (c < 0) {
                throw new ArgumentException(1, "Object must be an array of primitives.");
            }
            return c;
        }
        static a(a, b) {
            if (b < 0 || b >= Buffer.b(a)) {
                throw new ArgumentOutOfRangeException(2, "index", "Value must be non-negative and less than the size of the collection.");
            }
            return typeGetValue(a[b]);
        }
        static d(a, b, c) {
            if (b < 0 || b >= Buffer.b(a)) {
                throw new ArgumentOutOfRangeException(2, "index", "Value must be non-negative and less than the size of the collection.");
            }
            a[b] = c;
        }
        static c(a, b, c, d, e) {
            let f = b;
            let g = d;
            if (a == null) {
                throw new ArgumentNullException(0, "src");
            }
            if (c == null) {
                throw new ArgumentNullException(0, "dst");
            }
            if (b < 0) {
                throw new ArgumentOutOfRangeException(2, "srcOffset", "Non-negative number required.");
            }
            if (d < 0) {
                throw new ArgumentOutOfRangeException(2, "dstOffset", "Non-negative number required.");
            }
            if (e < 0) {
                throw new ArgumentOutOfRangeException(2, "count", "Non-negative number required.");
            }
            if ((b > Buffer.b(a) - e) || (d > Buffer.b(c) - e)) {
                throw new ArgumentException(1, "Offset and length were out of bounds for the array or count is greater than " + "the number of elements from index to the end of the source collection.");
            }
            for (let h = 0; h < e; h++) {
                c[g++] = a[f++];
            }
        }
    }
    Buffer.$t = /*@__PURE__*/ markType(Buffer, 'Buffer');
    return Buffer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AbstractEnumerator = /*@__PURE__*/ (() => {
    class AbstractEnumerator extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        get currentObject() {
            return this.a.currentObject;
        }
        moveNext() {
            return this.a.moveNext();
        }
        reset() {
            this.a.reset();
        }
    }
    AbstractEnumerator.$t = /*@__PURE__*/ markType(AbstractEnumerator, 'AbstractEnumerator', Base.$, [IEnumerator_$type]);
    return AbstractEnumerator;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AbstractEnumerable = /*@__PURE__*/ (() => {
    class AbstractEnumerable extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        getEnumeratorObject() {
            return new AbstractEnumerator(getEnumeratorObject(this.a()));
        }
    }
    AbstractEnumerable.$t = /*@__PURE__*/ markType(AbstractEnumerable, 'AbstractEnumerable', Base.$, [IEnumerable_$type]);
    return AbstractEnumerable;
})();

class IgrObjectCollection extends IgCollection {
    constructor(list) {
        super();
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        let coll = new SyncableObservableCollection$2(Base.$type, Base.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ObjectCollection = /*@__PURE__*/ (() => {
    class ObjectCollection extends ObservableCollection$1 {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(Base.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(Base.$, 1, c);
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        super(Base.$, 2, c);
                    }
                    break;
            }
        }
    }
    ObjectCollection.$t = /*@__PURE__*/ markType(ObjectCollection, 'ObjectCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(Base.$));
    return ObjectCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Collection$1 = /*@__PURE__*/ (() => {
    class Collection$1 extends List$1 {
        constructor($t) {
            super($t, 0);
            this.$t = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
        get ac() {
            return this;
        }
    }
    Collection$1.$t = /*@__PURE__*/ markType(Collection$1, 'Collection$1', /*@__PURE__*/ List$1.$.specialize(0));
    return Collection$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GenericEnumerator$1 = /*@__PURE__*/ (() => {
    class GenericEnumerator$1 extends Base {
        constructor($t, a) {
            super();
            this.$t = null;
            this.a = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.a = a;
        }
        get current() {
            return this.a.current;
        }
        get currentObject() {
            return getBoxIfEnum(this.$t, this.a.current);
        }
        moveNext() {
            return this.a.moveNext();
        }
        reset() {
            this.a.reset();
        }
        dispose() {
        }
    }
    GenericEnumerator$1.$t = /*@__PURE__*/ markType(GenericEnumerator$1, 'GenericEnumerator$1', Base.$, [/*@__PURE__*/ IEnumerator$1_$type.specialize(0)]);
    return GenericEnumerator$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GenericEnumerable$1 = /*@__PURE__*/ (() => {
    class GenericEnumerable$1 extends Base {
        constructor($t, a) {
            super();
            this.$t = null;
            this.a = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.a = a;
        }
        getEnumerator() {
            return new GenericEnumerator$1(this.$t, getEnumerator(this.a()));
        }
        getEnumeratorObject() {
            return new GenericEnumerator$1(this.$t, getEnumerator(this.a()));
        }
    }
    GenericEnumerable$1.$t = /*@__PURE__*/ markType(GenericEnumerable$1, 'GenericEnumerable$1', Base.$, [/*@__PURE__*/ IEnumerable$1_$type.specialize(0)]);
    return GenericEnumerable$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var NotifyCollectionChangedAction = /*@__PURE__*/ (function (NotifyCollectionChangedAction) {
    NotifyCollectionChangedAction[NotifyCollectionChangedAction["Add"] = 0] = "Add";
    NotifyCollectionChangedAction[NotifyCollectionChangedAction["Remove"] = 1] = "Remove";
    NotifyCollectionChangedAction[NotifyCollectionChangedAction["Replace"] = 2] = "Replace";
    NotifyCollectionChangedAction[NotifyCollectionChangedAction["Reset"] = 4] = "Reset";
    return NotifyCollectionChangedAction;
})({});
/**
 * @hidden
 */
let NotifyCollectionChangedAction_$type = /*@__PURE__*/ markEnum('NotifyCollectionChangedAction', 'Add,0|Remove,1|Replace,2|Reset,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NameValueCollection = /*@__PURE__*/ (() => {
    class NameValueCollection extends Base {
        constructor() {
            super();
            this.a = null;
            this.a = new Dictionary$2(String_$type, String_$type, 0);
        }
        item(a, b) {
            if (arguments.length === 2) {
                if (this.a.containsKey(a)) {
                    this.a.item(a, b);
                }
                else {
                    this.a.addItem(a, b);
                }
                return b;
            }
            else {
                if (this.a.containsKey(a)) {
                    return this.a.item(a);
                }
                else {
                    return null;
                }
            }
        }
    }
    NameValueCollection.$t = /*@__PURE__*/ markType(NameValueCollection, 'NameValueCollection');
    return NameValueCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BitArray = /*@__PURE__*/ (() => {
    class BitArray extends Base {
        constructor(a, ..._rest) {
            super();
            this.i = 0;
            this.a = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c.a];
                        {
                            let f = d[0];
                            this.i = f.length * 32;
                            this.a = new Array(f.length);
                            for (let g = 0; g < f.length; g++) {
                                this.a[g] = f[g];
                            }
                        }
                        this.i = c.i;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.j = c.length;
                        for (let d = 0; d < c.length; d++) {
                            this.item(d, c[d]);
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = [c, false];
                        {
                            let f = d[0];
                            let g = d[1];
                            this.i = f;
                            this.a = new Array((intDivide((f - 1), 32)) + 1);
                            this.m(g);
                        }
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        this.i = c.length * 32;
                        this.a = new Array(c.length);
                        for (let d = 0; d < c.length; d++) {
                            this.a[d] = c[d];
                        }
                    }
                    break;
                case 4:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.i = c;
                        this.a = new Array((intDivide((c - 1), 32)) + 1);
                        this.m(d);
                    }
                    break;
            }
        }
        get count() {
            return this.i;
        }
        get c() {
            return false;
        }
        get isSynchronized() {
            return false;
        }
        get j() {
            return this.i;
        }
        set j(a) {
            if (a < 0) {
                throw new ArgumentOutOfRangeException(0);
            }
            this.i = a;
            let b = (intDivide((this.i - 1), 32)) + 1;
            if (this.a.length < b) {
                let c = this.a;
                this.a = new Array(b);
                for (let d = 0; d < c.length; d++) {
                    this.a[d] = c[d];
                }
            }
        }
        get syncRoot() {
            return null;
        }
        item(a, b) {
            if (arguments.length === 2) {
                if (a < 0 || this.i <= a) {
                    throw new IndexOutOfRangeException(0);
                }
                if (b) {
                    this.a[intDivide(a, 32)] |= 1 << (a % 32);
                }
                else {
                    this.a[intDivide(a, 32)] &= ~(1 << (a % 32));
                }
                return b;
            }
            else {
                if (a < 0 || this.i <= a) {
                    throw new IndexOutOfRangeException(0);
                }
                return (this.a[intDivide(a, 32)] & (1 << (a % 32))) != 0;
            }
        }
        e(a) {
            if (a.j != this.j) {
                throw new ArgumentException(1, "The BitArrays do not have the same length");
            }
            for (let b = 0; b < this.a.length; b++) {
                this.a[b] &= a.a[b];
            }
            return this;
        }
        k() {
            return new BitArray(0, this);
        }
        copyTo(a, b) {
            for (let c = 0; c < this.i; c++) {
                a[b + c] = this.item(c);
            }
        }
        b(a) {
            return this.item(a);
        }
        *_getEnumeratorObject() {
            for (let a = 0; a < this.i; a++) {
                yield this.item(a);
            }
        }
        getEnumeratorObject() {
            return toEnum(() => this._getEnumeratorObject()).getEnumeratorObject();
        }
        f() {
            for (let a = 0; a < this.a.length; a++) {
                this.a[a] = ~this.a[a];
            }
            return this;
        }
        g(a) {
            if (a.j != this.j) {
                throw new ArgumentException(1, "The BitArrays do not have the same length");
            }
            for (let b = 0; b < this.a.length; b++) {
                this.a[b] |= a.a[b];
            }
            return this;
        }
        l(a, b) {
            this.item(a, b);
        }
        m(a) {
            let b = a ? -1 : 0;
            for (let c = 0; c < this.a.length; c++) {
                this.a[c] = b;
            }
        }
        h(a) {
            if (a.j != this.j) {
                throw new ArgumentException(1, "The BitArrays do not have the same length");
            }
            for (let b = 0; b < this.a.length; b++) {
                this.a[b] ^= a.a[b];
            }
            return this;
        }
    }
    BitArray.$t = /*@__PURE__*/ markType(BitArray, 'BitArray', Base.$, [ICollection_$type, IEnumerable_$type]);
    return BitArray;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ReadOnlyObservableCollection$1 = /*@__PURE__*/ (() => {
    class ReadOnlyObservableCollection$1 extends ReadOnlyCollection$1 {
        constructor($t, a) {
            super($t, 0);
            this.$t = null;
            this.collectionChanged = null;
            this.propertyChanged = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
    }
    ReadOnlyObservableCollection$1.$t = /*@__PURE__*/ markType(ReadOnlyObservableCollection$1, 'ReadOnlyObservableCollection$1', /*@__PURE__*/ ReadOnlyCollection$1.$.specialize(0), [INotifyCollectionChanged_$type, INotifyPropertyChanged_$type]);
    return ReadOnlyObservableCollection$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IOrderedEnumerable$1_$type = /*@__PURE__*/ new Type(null, 'IOrderedEnumerable$1', null, [/*@__PURE__*/ IEnumerable$1_$type.specialize(0), IEnumerable_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SortedList$1 = /*@__PURE__*/ (() => {
    class SortedList$1 extends List$1 {
        constructor($tElement, a) {
            super($tElement, 1, a);
            this.$tElement = null;
            this.$tElement = $tElement;
            this.$type = this.$type.specialize(this.$tElement);
        }
        getEnumeratorObject() {
            return super.getEnumerator();
        }
    }
    SortedList$1.$t = /*@__PURE__*/ markType(SortedList$1, 'SortedList$1', /*@__PURE__*/ List$1.$.specialize(0), [/*@__PURE__*/ IOrderedEnumerable$1_$type.specialize(0)]);
    return SortedList$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Enumerable = /*@__PURE__*/ (() => {
    class Enumerable extends Base {
        static *_u($tSource, a, b) {
            for (let c of fromEnum(a)) {
                if (b(c)) {
                    yield c;
                }
            }
        }
        static u($tSource, a, b) {
            return toEnum(() => Enumerable._u($tSource, a, b));
        }
        static *_v($tSource, a, b) {
            let c = 0;
            for (let d of fromEnum(a)) {
                if (b(d, c)) {
                    yield d;
                }
                c++;
            }
        }
        static v($tSource, a, b) {
            return toEnum(() => Enumerable._v($tSource, a, b));
        }
        static *_o($tSource, $tResult, a, b) {
            for (let c of fromEnum(a)) {
                yield b(c);
            }
        }
        static o($tSource, $tResult, a, b) {
            return toEnum(() => Enumerable._o($tSource, $tResult, a, b));
        }
        static *_p($tSource, $tResult, a, b) {
            for (let c of fromEnum(a)) {
                for (let d of fromEnum(b(c))) {
                    yield d;
                }
            }
        }
        static p($tSource, $tResult, a, b) {
            return toEnum(() => Enumerable._p($tSource, $tResult, a, b));
        }
        static *_l($tResult, a) {
            for (let b of fromEn(a)) {
                if (typeCast($tResult, b) !== null) {
                    yield typeCastObjTo$t($tResult, b);
                }
            }
        }
        static l($tResult, a) {
            return toEnum(() => Enumerable._l($tResult, a));
        }
        static ah($tSource, a) {
            let b = typeCast(IList$1_$type.specialize($tSource), a);
            if (b != null) {
                return b.item(b.count - 1);
            }
            let c = Type.getDefaultValue($tSource);
            for (let d of fromEnum(a)) {
                c = d;
            }
            return c;
        }
        static ad($tSource, a) {
            for (let b of fromEnum(a)) {
                return b;
            }
            return Type.getDefaultValue($tSource);
        }
        static ae($tSource, a, b) {
            for (let c of fromEnum(a)) {
                if (b(c)) {
                    return c;
                }
            }
            return Type.getDefaultValue($tSource);
        }
        static af($tSource, a) {
            for (let b of fromEnum(a)) {
                return b;
            }
            return Type.getDefaultValue($tSource);
        }
        static x($tSource, $tKey, a, b) {
            let c = new SortedList$1($tSource, a);
            c.aa((d, e) => {
                let f = d;
                let g = e;
                let h = b(f);
                let i = b(g);
                if (typeCast(IComparable_$type, h) !== null) {
                    return CompareUtil.compareToObject((typeCast(IComparable_$type, h)), getBoxIfEnum($tKey, i));
                }
                else {
                    return stringCompareTo(stringToString$1($tKey, h), stringToString$1($tKey, i));
                }
            });
            return c;
        }
        static y($tSource, $tKey, a, b) {
            let c = new SortedList$1($tSource, a);
            c.aa((d, e) => {
                let f = e;
                let g = d;
                let h = b(f);
                let i = b(g);
                if (typeCast(IComparable_$type, h) !== null) {
                    return CompareUtil.compareToObject((typeCast(IComparable_$type, h)), getBoxIfEnum($tKey, i));
                }
                else {
                    return stringCompareTo(stringToString$1($tKey, h), stringToString$1($tKey, i));
                }
            });
            return c;
        }
        static z($tSource, a) {
            let b = new List$1($tSource, 1, a);
            return b;
        }
        static *_m(a, b) {
            for (let c = a; c < b; c++) {
                yield c;
            }
        }
        static m(a, b) {
            return toEnum(() => Enumerable._m(a, b));
        }
        static *_i($tSource, a, b) {
            for (let c of fromEnum(a)) {
                yield c;
            }
            for (let d of fromEnum(b)) {
                yield d;
            }
        }
        static i($tSource, a, b) {
            return toEnum(() => Enumerable._i($tSource, a, b));
        }
        static ak(a) {
            let b = true;
            let c = 0;
            for (let d of fromEnum(a)) {
                if (b) {
                    b = false;
                    c = d;
                }
                else {
                    c = Math.max(c, d);
                }
            }
            return c;
        }
        static al($tSource, a, b) {
            return Enumerable.ak(Enumerable.o($tSource, Number_$type, a, b));
        }
        static am(a) {
            let b = true;
            let c = 0;
            for (let d of fromEnum(a)) {
                if (b) {
                    b = false;
                    c = d;
                }
                else {
                    c = Math.min(c, d);
                }
            }
            return c;
        }
        static an($tSource, a, b) {
            return Enumerable.ak(Enumerable.o($tSource, Number_$type, a, b));
        }
        static aj($tSource, a) {
            let b = 0;
            for (let c of fromEnum(a)) {
                b++;
            }
            return b;
        }
        static *_n($tSource, a) {
            let b = new List$1($tSource, 1, a);
            for (let c = b.count - 1; c >= 0; c--) {
                yield b._inner[c];
            }
        }
        static n($tSource, a) {
            return toEnum(() => Enumerable._n($tSource, a));
        }
        static h($tResult, a) {
            if (a == null) {
                throw new ArgumentNullException(0, "source");
            }
            let b = typeCast(IEnumerable$1_$type.specialize($tResult), a);
            if (b != null) {
                return b;
            }
            let c = new List$1($tResult, 0);
            for (let d of fromEn(a)) {
                if (typeCast($tResult, d) !== null) {
                    c.add(typeCastObjTo$t($tResult, d));
                }
                else {
                    c.add(Type.getDefaultValue($tResult));
                }
            }
            return c;
        }
        static *_s($tSource, a, b) {
            for (let c of fromEnum(a)) {
                if (b > 0) {
                    b--;
                    yield c;
                }
                else {
                    return undefined;
                }
            }
        }
        static s($tSource, a, b) {
            return toEnum(() => Enumerable._s($tSource, a, b));
        }
        static *_r($tSource, a, b) {
            for (let c of fromEnum(a)) {
                if (b <= 0) {
                    yield c;
                }
                else {
                    b--;
                }
            }
        }
        static r($tSource, a, b) {
            return toEnum(() => Enumerable._r($tSource, a, b));
        }
        static c($tSource, a) {
            for (let b of fromEnum(a)) {
                return true;
            }
            return false;
        }
        static e($tSource, a, value_) {
            for (let item_ of fromEnum(a)) {
                if (item_ === value_) {
                    return true;
                }
                ;
            }
            return false;
        }
        static t($tSource, a, b) {
            return null;
        }
        static a($tSource, a) {
            let b = typeCast(List$1.$.specialize($tSource), a);
            if (b != null) {
                return b.toArray();
            }
            b = new List$1($tSource, 1, a);
            return b.asArray();
        }
        static ac($tSource, a, b) {
            let c = typeCast(IList$1_$type.specialize($tSource), a);
            if (c != null) {
                return c.item(b);
            }
            return Enumerable.ad($tSource, Enumerable.r($tSource, a, b));
        }
        static aa(a) {
            let b = 0;
            for (let c of fromEnum(a)) {
                b += c;
            }
            return b;
        }
        static ab($tSource, a, b) {
            return Enumerable.aa(Enumerable.o($tSource, Number_$type, a, b));
        }
        static f($tSource, a, b) {
            if (a == null) {
                throw new ArgumentNullException(0, "first");
            }
            if (b == null) {
                throw new ArgumentNullException(0, "second");
            }
            let c = getEnumerator(a);
            let d = getEnumerator(b);
            {
                while (c.moveNext()) {
                    if (!d.moveNext() || !Base.equalsStatic(getBoxIfEnum($tSource, c.current), getBoxIfEnum($tSource, d.current))) {
                        return false;
                    }
                }
                return (d.moveNext() == false);
            }
        }
        static *_k($tSource) {
            return undefined;
        }
        static k($tSource) {
            return toEnum(() => Enumerable._k($tSource));
        }
        static *_q($tSource, $tCollection, $tResult, a, b, c) {
            for (let d of fromEnum(a)) {
                for (let e of fromEnum(b(d))) {
                    yield c(d, e);
                }
            }
        }
        static q($tSource, $tCollection, $tResult, a, b, c) {
            return toEnum(() => Enumerable._q($tSource, $tCollection, $tResult, a, b, c));
        }
        static d($tSource, a, b) {
            for (let c of fromEnum(a)) {
                if (b(c)) {
                    return true;
                }
            }
            return false;
        }
        static ag($tSource, a, b) {
            for (let c of fromEnum(a)) {
                if (b(c)) {
                    return c;
                }
            }
            return Type.getDefaultValue($tSource);
        }
        static b($tSource, a, b) {
            for (let c of fromEnum(a)) {
                if (b(c) == false) {
                    return false;
                }
            }
            return true;
        }
        static g($tSource, $tKey, a, b) {
            let c = new Dictionary$2($tKey, $tSource, 0);
            for (let d of fromEnum(a)) {
                c.item(b(d), d);
            }
            return c;
        }
        static ai($tSource, a) {
            throw new NotImplementedException(0);
        }
        static w($tFirst, $tSecond, $tResult, a, b, c) {
            throw new NotImplementedException(0);
        }
        static j($tSource, a) {
            throw new NotImplementedException(0);
        }
    }
    Enumerable.$t = /*@__PURE__*/ markType(Enumerable, 'Enumerable');
    return Enumerable;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IGrouping$2_$type = /*@__PURE__*/ new Type(null, 'IGrouping$2', null, [/*@__PURE__*/ IEnumerable$1_$type.specialize(1), IEnumerable_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ExpressionSyntax = /*@__PURE__*/ (() => {
    class ExpressionSyntax extends Base {
        static c(a, b, c, ...d) {
            return null;
        }
        static a(a, ...b) {
            return null;
        }
        static b(a, b) {
            return null;
        }
        static d(a) {
            return null;
        }
        static e(a, b) {
            return null;
        }
    }
    ExpressionSyntax.$t = /*@__PURE__*/ markType(ExpressionSyntax, 'ExpressionSyntax');
    return ExpressionSyntax;
})();
/**
 * @hidden
 */
let LambdaExpression = /*@__PURE__*/ (() => {
    class LambdaExpression extends ExpressionSyntax {
    }
    LambdaExpression.$t = /*@__PURE__*/ markType(LambdaExpression, 'LambdaExpression', ExpressionSyntax.$);
    return LambdaExpression;
})();
/**
 * @hidden
 */
let MemberExpression = /*@__PURE__*/ (() => {
    class MemberExpression extends ExpressionSyntax {
        constructor() {
            super(...arguments);
            this.f = null;
        }
        g(a) {
            return null;
        }
    }
    MemberExpression.$t = /*@__PURE__*/ markType(MemberExpression, 'MemberExpression', ExpressionSyntax.$);
    return MemberExpression;
})();
/**
 * @hidden
 */
let MethodCallExpression = /*@__PURE__*/ (() => {
    class MethodCallExpression extends ExpressionSyntax {
        constructor() {
            super(...arguments);
            this.f = null;
            this.g = null;
        }
        h(a, b) {
            return null;
        }
    }
    MethodCallExpression.$t = /*@__PURE__*/ markType(MethodCallExpression, 'MethodCallExpression', ExpressionSyntax.$);
    return MethodCallExpression;
})();
/**
 * @hidden
 */
let ParameterExpression = /*@__PURE__*/ (() => {
    class ParameterExpression extends ExpressionSyntax {
        constructor() {
            super(...arguments);
            this.f = false;
            this.g = null;
        }
    }
    ParameterExpression.$t = /*@__PURE__*/ markType(ParameterExpression, 'ParameterExpression', ExpressionSyntax.$);
    return ParameterExpression;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IQueryable_$type = /*@__PURE__*/ new Type(null, 'IQueryable');
/**
 * @hidden
 */
let IQueryable$1_$type = /*@__PURE__*/ new Type(null, 'IQueryable$1', null, [IQueryable_$type]);
/**
 * @hidden
 */
let IQueryProvider_$type = /*@__PURE__*/ new Type(null, 'IQueryProvider');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Queryable = /*@__PURE__*/ (() => {
    class Queryable extends Base {
        static a(a) {
            return null;
        }
    }
    Queryable.$t = /*@__PURE__*/ markType(Queryable, 'Queryable');
    return Queryable;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GC = /*@__PURE__*/ (() => {
    class GC extends Base {
    }
    GC.$t = /*@__PURE__*/ markType(GC, 'GC');
    return GC;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Activator = /*@__PURE__*/ (() => {
    class Activator extends Base {
        static createInstance(a) {
            return null;
        }
        static c(a, ...b) {
            return null;
        }
        static createInstance$1($t) {
            return Type.getDefaultValue($t);
        }
    }
    Activator.$t = /*@__PURE__*/ markType(Activator, 'Activator');
    return Activator;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Guid_ParseFailureKind_$type = /*@__PURE__*/ markEnum('Guid_ParseFailureKind', 'None,0|ArgumentNull,1|Format,2|FormatWithParameter,3|NativeException,4|FormatWithInnerException,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Guid_GuidParseThrowStyle_$type = /*@__PURE__*/ markEnum('Guid_GuidParseThrowStyle', 'None,0|All,1|AllButOverflow,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Guid_GuidStyles_$type = /*@__PURE__*/ markEnum('Guid_GuidStyles', 'AllowBraces,2|AllowDashes,4|AllowHexPrefix,8|AllowParenthesis,1|Any,15|BraceFormat,96|DigitFormat,64|HexFormat,160|None,0|NumberFormat,0|ParenthesisFormat,80|RequireBraces,32|RequireDashes,64|RequireHexPrefix,128|RequireParenthesis,16');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StringComparer = /*@__PURE__*/ (() => {
    class StringComparer extends Base {
        constructor(a, ..._rest) {
            super();
            this.h = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        this.h = c;
                    }
                    break;
            }
        }
        compareObject(a, b) {
            return stringCompare1(typeCast(String_$type, a), typeCast(String_$type, b), this.h);
        }
        compare(a, b) {
            return stringCompare1(a, b, this.h);
        }
        static a(a, b) {
            if (a.name == CultureInfo.invariantCulture.name) {
                return b ? StringComparer.e : StringComparer.d;
            }
            return b ? StringComparer.c : StringComparer.b;
        }
        equalsC(a, b) {
            return this.compare(a, b) == 0;
        }
        getHashCodeC(a) {
            if (a == null) {
                return 0;
            }
            switch (this.h) {
                case 0:
                case 2:
                case 4: return Base.getHashCodeStatic(a);
                case 1: return Base.getHashCodeStatic(a.toLowerCase());
                case 3:
                case 5: return Base.getHashCodeStatic(a.toLowerCase());
                default: return 0;
            }
        }
    }
    StringComparer.$t = /*@__PURE__*/ markType(StringComparer, 'StringComparer', Base.$, [IComparer_$type, IEqualityComparer_$type, /*@__PURE__*/ IComparer$1_$type.specialize(String_$type), /*@__PURE__*/ IEqualityComparer$1_$type.specialize(String_$type)]);
    StringComparer.b = /*@__PURE__*/ new StringComparer(1, 0);
    StringComparer.c = /*@__PURE__*/ new StringComparer(1, 1);
    StringComparer.d = /*@__PURE__*/ new StringComparer(1, 2);
    StringComparer.e = /*@__PURE__*/ new StringComparer(1, 3);
    StringComparer.f = /*@__PURE__*/ new StringComparer(1, 4);
    StringComparer.g = /*@__PURE__*/ new StringComparer(1, 5);
    return StringComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Tuple = /*@__PURE__*/ (() => {
    class Tuple extends Base {
        static a($t1, $t2, a, b) {
            return new Tuple$2($t1, $t2, a, b);
        }
        static b($t1, $t2, $t3, a, b, c) {
            return new Tuple$3($t1, $t2, $t3, a, b, c);
        }
    }
    Tuple.$t = /*@__PURE__*/ markType(Tuple, 'Tuple');
    return Tuple;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var UriKind = /*@__PURE__*/ (function (UriKind) {
    UriKind[UriKind["RelativeOrAbsolute"] = 0] = "RelativeOrAbsolute";
    UriKind[UriKind["Absolute"] = 1] = "Absolute";
    UriKind[UriKind["Relative"] = 2] = "Relative";
    return UriKind;
})({});
/**
 * @hidden
 */
let UriKind_$type = /*@__PURE__*/ markEnum('UriKind', 'RelativeOrAbsolute,0|Absolute,1|Relative,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CancelEventArgs = /*@__PURE__*/ (() => {
    class CancelEventArgs extends EventArgs {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super();
                        this._cancel = false;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super();
                        this._cancel = false;
                    }
                    break;
            }
        }
        get cancel() {
            return this._cancel;
        }
        set cancel(a) {
            this._cancel = a;
        }
    }
    CancelEventArgs.$t = /*@__PURE__*/ markType(CancelEventArgs, 'CancelEventArgs', EventArgs.$);
    return CancelEventArgs;
})();

class IgrCancelEventArgs {
    createImplementation() {
        return new CancelEventArgs(0);
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get cancel() {
        return this.i.cancel;
    }
    set cancel(v) {
        this.i.cancel = ensureBool(v);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var ListSortDirection = /*@__PURE__*/ (function (ListSortDirection) {
    ListSortDirection[ListSortDirection["Ascending"] = 0] = "Ascending";
    ListSortDirection[ListSortDirection["Descending"] = 1] = "Descending";
    return ListSortDirection;
})({});
/**
 * @hidden
 */
let ListSortDirection_$type = /*@__PURE__*/ markEnum('ListSortDirection', 'Ascending,0|Descending,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Debug = /*@__PURE__*/ (() => {
    class Debug extends Base {
        static b(a, b) {
        }
        static d(a) {
        }
        static a(a) {
        }
        static c(a) {
        }
    }
    Debug.$t = /*@__PURE__*/ markType(Debug, 'Debug');
    return Debug;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BitConverter = /*@__PURE__*/ (() => {
    class BitConverter extends Base {
        static r(a) {
            throw new NotImplementedException(0);
        }
        static a(a) {
            return [a ? 1 : 0];
        }
        static b(a) {
            throw new NotImplementedException(0);
        }
        static c(a) {
            let b = 0;
            let c = 0;
            if (a == Number.POSITIVE_INFINITY) {
                b = 2146435072;
            }
            else if (a == Number.NEGATIVE_INFINITY) {
                b = 4293918720;
            }
            else if (a == 0) {
                if (1 / a == 1 / 0) {
                    b = 0;
                }
                else {
                    b = 2147483648;
                }
            }
            else if (isNaN_(a)) {
                b = 4294443008;
            }
            else {
                if (a < -0) {
                    b = 2147483648;
                    a = -a;
                }
                let d = Math.floor(Math.log(a) / Math.log(2));
                let e = truncate(Math.floor((a / Math.pow(2, d)) * Math.pow(2, 52)));
                c = (u32BitwiseAnd(e, 4294967295));
                e = intDivide(e, truncate(Math.pow(2, 32)));
                d += 1023;
                if (d >= 2047) {
                    d = 2047;
                    e = 0;
                }
                else if (d < 0) {
                    d = 0;
                }
                b = u32BitwiseOr(b, u32LS(truncate(d), 20));
                b = u32BitwiseOr(b, u32BitwiseAnd(e, ~(-1 << 20)));
            }
            return [(c & 255), ((c >>> 8) & 255), ((c >>> 16) & 255), ((c >>> 24) & 255), (b & 255), ((b >>> 8) & 255), ((b >>> 16) & 255), ((b >>> 24) & 255)];
        }
        static g(a) {
            throw new NotImplementedException(0);
        }
        static e(a) {
            return BitConverter.i(intSToU(a));
        }
        static f(a) {
            return BitConverter.j(a);
        }
        static d(a) {
            return BitConverter.h(a);
        }
        static i(a) {
            return [(a & 255), ((a >>> 8) & 255), ((a >>> 16) & 255), ((a >>> 24) & 255)];
        }
        static j(a) {
            let b = (a | 0);
            let c = u32BitwiseOr(truncate((a / Math.pow(2, 32))), 0);
            return [(b & 255), ((b >>> 8) & 255), ((b >>> 16) & 255), ((b >>> 24) & 255), (c & 255), ((c >>> 8) & 255), ((c >>> 16) & 255), ((c >>> 24) & 255)];
        }
        static h(a) {
            return [(a & 255), ((a >>> 8) & 255)];
        }
        static n(a) {
            throw new NotImplementedException(0);
        }
        static l(a, b) {
            return a[b] != 0;
        }
        static m(a, b) {
            throw new NotImplementedException(0);
        }
        static o(a, b) {
            let c = (a[b + 7] & 1 << 7) >> 7;
            let d = (((a[b + 7] & 127) << 4) | (a[b + 6] & (15 << 4)) >> 4);
            if (d == 0) {
                return (c == 0) ? 0 : -0;
            }
            if (d == 2047) {
                if ((a[b + 6] & 8) != 0) {
                    return NaN;
                }
                return (c == 0) ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
            }
            let e = Math.pow(2, d - 1023 - 52);
            let f = a[b] + a[b + 1] * Math.pow(2, 8 * 1) + a[b + 2] * Math.pow(2, 8 * 2) + a[b + 3] * Math.pow(2, 8 * 3) + a[b + 4] * Math.pow(2, 8 * 4) + a[b + 5] * Math.pow(2, 8 * 5) + (a[b + 6] & 15) * Math.pow(2, 8 * 6) + Math.pow(2, 52);
            return Math.pow(-1, c) * f * e;
        }
        static p(a, b) {
            let c = BitConverter.w(a, b);
            if (c > 32767) {
                c -= (65535 + 1);
            }
            return c;
        }
        static q(a, b) {
            return a[b] | (a[b + 1] << 8) | (a[b + 2] << 16) | (a[b + 3] << 24);
        }
        static s(a, b) {
            throw new NotImplementedException(0);
        }
        static t(a) {
            throw new NotImplementedException(0);
        }
        static u(a, b) {
            throw new NotImplementedException(0);
        }
        static v(a, b, c) {
            throw new NotImplementedException(0);
        }
        static w(a, b) {
            return (a[b] | (a[b + 1] << 8));
        }
        static x(a, b) {
            return intSToU(BitConverter.q(a, b));
        }
    }
    BitConverter.$t = /*@__PURE__*/ markType(BitConverter, 'BitConverter');
    BitConverter.k = false;
    return BitConverter;
})();

//------------------------------------------------------------------------------
/**
 * @hidden
 */
let IOPath = /*@__PURE__*/ (() => {
    class IOPath extends Base {
        static getExtension(a) {
            let b = a.lastIndexOf('.');
            if (b < 0) {
                return stringEmpty();
            }
            return a.substr(b);
        }
        static getDirectoryName(a) {
            let b = lastIndexOfAny(a, ['\\', '/']);
            if (b < 0) {
                return stringEmpty();
            }
            return a.substr(0, b);
        }
        static getFileName(a) {
            let b = lastIndexOfAny(a, ['\\', '/']);
            if (b < 0) {
                return a;
            }
            return a.substr(b + 1);
        }
        static combine1(a, b) {
            if (a == null || a.length == 0) {
                return b;
            }
            if (b == null || b.length == 0) {
                return a;
            }
            if (a.charAt(a.length - 1) == '\\' || a.charAt(a.length - 1) == '/' || b.charAt(0) == '\\' || b.charAt(0) == '/') {
                return a + b;
            }
            return a + '\\' + b;
        }
        static isPathRooted(a) {
            if (a == null) {
                return false;
            }
            if (a.length >= 1 && (a.charAt(0) == '/' || a.charAt(0) == '\\')) {
                return true;
            }
            if (a.length >= 2 && a.charAt(1) == ':') {
                return true;
            }
            return false;
        }
        static changeExtension(a, b) {
            throw new NotImplementedException(0);
        }
        static combine(...a) {
            throw new NotImplementedException(0);
        }
        static combine2(a, b, c) {
            throw new NotImplementedException(0);
        }
        static getFileNameWithoutExtension(a) {
            throw new NotImplementedException(0);
        }
        static getFullPath(a) {
            throw new NotImplementedException(0);
        }
        static getInvalidPathChars() {
            throw new NotImplementedException(0);
        }
        static getPathRoot(a) {
            if (a == null) {
                return null;
            }
            return stringEmpty();
        }
        static getTempFileName() {
            throw new NotImplementedException(0);
        }
        static getTempPath() {
            throw new NotImplementedException(0);
        }
        static hasExtension(a) {
            throw new NotImplementedException(0);
        }
    }
    IOPath.$t = /*@__PURE__*/ markType(IOPath, 'IOPath');
    IOPath.altDirectorySeparatorChar = '/';
    IOPath.directorySeparatorChar = '\\';
    IOPath.pathSeparator = ';';
    IOPath.volumeSeparatorChar = ':';
    return IOPath;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BinaryWriter = /*@__PURE__*/ (() => {
    class BinaryWriter extends Base {
        constructor(a, ..._rest) {
            super();
            this.b = null;
            this.d = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = [c, new UTF8Encoding(0, false, true)];
                        {
                            let f = d[0];
                            let g = d[1];
                            this.b = f;
                            this.d = g;
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.b = c;
                        this.d = d;
                    }
                    break;
            }
        }
        get_c() {
            return this.b;
        }
        get c() {
            return this.get_c();
        }
        e() {
            this.disposeCore(true);
        }
        dispose() {
            this.disposeCore(true);
        }
        disposeCore(a) {
            if (a) {
                this.b.close();
            }
        }
        g() {
            this.b.flush();
        }
        a(a, b) {
            return this.b.seek(a, b);
        }
        l(a) {
            this.b.write(BitConverter.a(a), 0, 1);
        }
        m(a) {
            this.b.write(BitConverter.d(a), 0, 1);
        }
        h(a) {
            this.b.write(a, 0, a.length);
        }
        n(a) {
        }
        i(a) {
        }
        o(a) {
            this.b.write(BitConverter.c(a), 0, 8);
        }
        t(a) {
            this.b.write(BitConverter.g(a), 0, 4);
        }
        q(a) {
            this.b.write(BitConverter.e(a), 0, 4);
        }
        r(a) {
            this.b.write(BitConverter.f(a), 0, 8);
        }
        s(a) {
            this.b.write(BitConverter.d(a), 0, 2);
        }
        p(a) {
            this.b.write(BitConverter.d(a), 0, 2);
        }
        u(a) {
        }
        w(a) {
            this.b.write(BitConverter.i(a), 0, 4);
        }
        x(a) {
            this.b.write(BitConverter.j(a), 0, 8);
        }
        v(a) {
            this.b.write(BitConverter.h(a), 0, 2);
        }
        j(a, b, c) {
        }
        k(a, b, c) {
        }
        y(a) {
        }
    }
    BinaryWriter.$t = /*@__PURE__*/ markType(BinaryWriter, 'BinaryWriter', Base.$, [IDisposable_$type]);
    return BinaryWriter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MemoryStream = /*@__PURE__*/ (() => {
    class MemoryStream extends Stream {
        constructor(a, ..._rest) {
            super();
            this.o = null;
            this.t = 0;
            this.s = 0;
            this.r = false;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [0];
                        {
                            let e = c[0];
                            this.o = new Array(e);
                            for (let f = 0; f < e; f++) {
                                this.o[f] = 0;
                            }
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.o = new Array(c);
                        for (let d = 0; d < c; d++) {
                            this.o[d] = 0;
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        this.o = c;
                        this.s = c.length;
                        this.r = this.s != 0 && typeof this.o[0] === 'string';
                    }
                    break;
            }
        }
        get_canRead() {
            return true;
        }
        get canRead() {
            return this.get_canRead();
        }
        get_canSeek() {
            return true;
        }
        get canSeek() {
            return this.get_canSeek();
        }
        get_canWrite() {
            return true;
        }
        get canWrite() {
            return this.get_canWrite();
        }
        get_capacity() {
            return this.o.length;
        }
        set_capacity(a) {
            if (this.o.length == a) {
                return;
            }
            for (let b = this.s; b < a; b++) {
                this.o[b] = 0;
            }
        }
        get capacity() {
            return this.get_capacity();
        }
        set capacity(a) {
            this.set_capacity(a);
        }
        get_length() {
            return this.s;
        }
        get length() {
            return this.get_length();
        }
        get_position() {
            return this.t;
        }
        set_position(a) {
            if (this.t == a) {
                return;
            }
            this.t = a;
            if (this.capacity <= this.t) {
                this.capacity = this.t + 1;
            }
        }
        get position() {
            return this.get_position();
        }
        set position(a) {
            this.set_position(a);
        }
        disposeCore(a) {
        }
        flush() {
        }
        getBuffer() {
            return this.o;
        }
        read(a, b, c) {
            let d = Math.min(this.s - this.t, c);
            if (this.r) {
                for (let e = 0; e < d; e++) {
                    a[b++] = (this.o[this.t++].charCodeAt(0) & 0xFF);
                }
            }
            else {
                for (let f = 0; f < d; f++) {
                    a[b++] = this.o[this.t++];
                }
            }
            return d;
        }
        readByte() {
            if (this.s <= this.t) {
                return -1;
            }
            if (this.r) {
                return (this.o[this.t++].charCodeAt(0) & 0xFF);
            }
            return this.o[this.t++];
        }
        seek(a, b) {
            switch (b) {
                case 0:
                    this.t = a;
                    break;
                case 1:
                    this.t += a;
                    break;
                case 2:
                    this.t = this.s + a;
                    break;
            }
            return this.t;
        }
        setLength(a) {
            if (this.capacity < a) {
                this.capacity = Math.max(a, this.capacity * 2);
            }
            this.s = a;
            if (this.s < this.t) {
                this.t = this.s;
            }
        }
        toArray() {
            if (this.r) {
                let a = new Array(this.s);
                let b = this.position;
                this.position = 0;
                this.read(a, 0, a.length);
                this.position = b;
                return a;
            }
            return (this.o.slice(0, this.s));
        }
        write(a, b, c) {
            let d = this.t + c;
            if (this.length < d) {
                this.setLength(d);
            }
            let e = c != 0 && typeof a[b] === 'string';
            if (e == this.r) {
                for (let f = 0; f < c; f++) {
                    this.o[this.t++] = a[b++];
                }
            }
            else if (e) {
                for (let g = 0; g < c; g++) {
                    this.o[this.t++] = (a.charCodeAt(b++) & 0xFF);
                }
            }
            else {
                for (let h = 0; h < c; h++) {
                    this.o[this.t++] = typeGetValue((String.fromCharCode(a[b++])));
                }
            }
        }
        writeByte(a) {
            let b = typeof a === 'string';
            if (b == this.r) {
                this.o[this.t++] = a;
            }
            else if (b) {
                this.o[this.t++] = (a.charCodeAt(0) & 0xFF);
            }
            else {
                this.o[this.t++] = typeGetValue((String.fromCharCode(a)));
            }
            if (this.s < this.t) {
                this.s = this.t;
            }
        }
        writeTo(a) {
            a.write(this.o, 0, this.s);
        }
    }
    MemoryStream.$t = /*@__PURE__*/ markType(MemoryStream, 'MemoryStream', Stream.$);
    return MemoryStream;
})();

//
/**
 * @hidden
 */
let TextReader = /*@__PURE__*/ (() => {
    class TextReader extends Base {
        static staticInit() {
            TextReader.e = new TextReader_NullTextReader();
        }
        constructor() {
            super();
        }
        i() {
            this.dispose1(true);
        }
        dispose() {
            this.dispose1(true);
        }
        dispose1(a) {
            if (a) {
            }
            return;
        }
        a() {
            return -1;
        }
        b() {
            return -1;
        }
        c(a, b, c) {
            let d, e;
            for (e = 0; e < c; e++) {
                if ((d = this.b()) == -1) {
                    return e;
                }
                a[b + e] = String.fromCharCode(d);
            }
            return e;
        }
        d(a, b, c) {
            let d = 0;
            let e = 0;
            do {
                e = this.c(a, b, c);
                b += e;
                d += e;
                c -= e;
            } while (e != 0 && c > 0);
            return d;
        }
        g() {
            return stringEmpty();
        }
        h() {
            return stringEmpty();
        }
        static f(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "reader is null");
            }
            if (typeCast(SynchronizedReader.$, a) !== null) {
                return a;
            }
            return new SynchronizedReader(a);
        }
    }
    TextReader.$t = /*@__PURE__*/ markType(TextReader, 'TextReader', Base.$, [IDisposable_$type]);
    TextReader.e = null;
    return TextReader;
})();
/**
 * @hidden
 */
let TextReader_NullTextReader = /*@__PURE__*/ (() => {
    class TextReader_NullTextReader extends TextReader {
        g() {
            return null;
        }
    }
    TextReader_NullTextReader.$t = /*@__PURE__*/ markType(TextReader_NullTextReader, 'TextReader_NullTextReader', TextReader.$);
    return TextReader_NullTextReader;
})();
/**
 * @hidden
 */
let SynchronizedReader = /*@__PURE__*/ (() => {
    class SynchronizedReader extends TextReader {
        constructor(a) {
            super();
            this.k = null;
            this.k = a;
        }
        i() {
            this.k.i();
        }
        a() {
            return this.k.a();
        }
        d(a, b, c) {
            return this.k.d(a, b, c);
        }
        g() {
            return this.k.g();
        }
        h() {
            return this.k.h();
        }
        b() {
            return this.k.b();
        }
        c(a, b, c) {
            return this.k.c(a, b, c);
        }
    }
    SynchronizedReader.$t = /*@__PURE__*/ markType(SynchronizedReader, 'SynchronizedReader', TextReader.$);
    return SynchronizedReader;
})();
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StreamReader = /*@__PURE__*/ (() => {
    class StreamReader extends TextReader {
        constructor(a) {
            super();
            this.o = null;
            this.q = null;
            this.p = null;
            this.k = null;
            this.l = 0;
            this.m = 0;
            this.o = a;
            this.q = Encoding.uTF8;
            this.p = this.q.getDecoder();
            this.k = new Array(this.q.getMaxCharCount(1024));
        }
        r() {
            let a = new Array(1024);
            let b = this.o.read(a, 0, a.length);
            this.l = this.p.c(a, 0, b, this.k, 0);
            this.m = 0;
        }
        a() {
            if (this.m == this.l) {
                this.r();
                if (this.m == this.l) {
                    return -1;
                }
            }
            return this.k[this.m].charCodeAt(0);
        }
        b() {
            if (this.m == this.l) {
                this.r();
                if (this.m == this.l) {
                    return -1;
                }
            }
            return this.k[this.m++].charCodeAt(0);
        }
        c(a, b, c) {
            let d = 0;
            while (c > 0) {
                let e = Math.min(c, this.l - this.m);
                if (e == 0) {
                    this.r();
                    e = Math.min(c, this.l - this.m);
                    if (e == 0) {
                        break;
                    }
                }
                arrayCopy1(this.k, this.m, a, b, e);
                d += e;
                c -= e;
                this.m += e;
            }
            return d;
        }
        g() {
            throw new NotImplementedException(0);
        }
        h() {
            let a = new StringBuilder(0);
            while (true) {
                let b = this.l - this.m;
                if (b == 0) {
                    this.r();
                    b = this.l - this.m;
                    if (b == 0) {
                        break;
                    }
                }
                a.g(this.k, this.m, b);
                this.m = this.l;
            }
            return a.toString();
        }
    }
    StreamReader.$t = /*@__PURE__*/ markType(StreamReader, 'StreamReader', TextReader.$);
    return StreamReader;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Capture = /*@__PURE__*/ (() => {
    class Capture extends Base {
        constructor(a, b, c) {
            super();
            this.a = 0;
            this.c = 0;
            this.f = null;
            this.a = a;
            this.c = b;
            this.f = c;
        }
        get b() {
            if (this.a < 0) {
                throw new NotSupportedException(1, "Cannot get the index of regex groups");
            }
            return this.a;
        }
        get d() {
            return this.c;
        }
        get g() {
            return this.f;
        }
        toString() {
            return this.f;
        }
    }
    Capture.$t = /*@__PURE__*/ markType(Capture, 'Capture');
    return Capture;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Group = /*@__PURE__*/ (() => {
    class Group extends Capture {
        constructor(a, b, c, d) {
            super(b, c, d);
            this.h = false;
            this.h = a;
        }
        get i() {
            return this.h;
        }
    }
    Group.$t = /*@__PURE__*/ markType(Group, 'Group', Capture.$);
    return Group;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GroupCollection = /*@__PURE__*/ (() => {
    class GroupCollection extends Base {
        constructor(a) {
            super();
            this.f = null;
            this.a = null;
            this.f = a;
            let b = this.f.j;
            let c = this.f.p.a;
            this.a = new Array((c.length));
            for (let d = 0; d < this.a.length; d++) {
                let e = (c[d]);
                for (let f = 0; f < e.length; f++) {
                    let g = (b[e[f]]);
                    if (g != null) {
                        this.a[d] = new Group(true, -1, g.length, g);
                    }
                }
            }
        }
        get count() {
            return this.a.length;
        }
        get b() {
            return true;
        }
        get isSynchronized() {
            return false;
        }
        get syncRoot() {
            return null;
        }
        item(a) {
            return this.a[a] || GroupCollection.c;
        }
        item1(a) {
            return this.item((this.f.p.e[a]));
        }
        copyTo(a, b) {
            arrayCopyTo(this.a, a, b);
        }
        getEnumeratorObject() {
            return getEnumeratorObject(this.a);
        }
    }
    GroupCollection.$t = /*@__PURE__*/ markType(GroupCollection, 'GroupCollection', Base.$, [ICollection_$type, IEnumerable_$type]);
    GroupCollection.c = /*@__PURE__*/ new Group(false, -1, 0, "");
    return GroupCollection;
})();
/**
 * @hidden
 */
let Match = /*@__PURE__*/ (() => {
    class Match extends Group {
        constructor(a, b, c) {
            super(c != null, c == null ? 0 : (c.index), c == null ? 0 : c[0].length, c == null ? "" : c[0]);
            this.j = null;
            this.p = null;
            this.k = null;
            this.l = null;
            this.j = c;
            this.p = a;
            this.k = b;
        }
        static get n() {
            return new Match(null, null, null);
        }
        get_m() {
            if (this.l == null) {
                this.l = new GroupCollection(this);
            }
            return this.l;
        }
        get m() {
            return this.get_m();
        }
        o() {
            if (this.i == false) {
                return this;
            }
            return this.p.j(this.k, this.b + this.d);
        }
    }
    Match.$t = /*@__PURE__*/ markType(Match, 'Match', Group.$);
    return Match;
})();
/**
 * @hidden
 */
let Regex = /*@__PURE__*/ (() => {
    class Regex extends Base {
        constructor(a, b) {
            super();
            this.d = null;
            this.e = null;
            this.a = null;
            this.c = false;
            let c = "g";
            if ((b & 1) != 0) {
                c += "i";
            }
            if ((b & 2) != 0) {
                c += "m";
            }
            if ((b & 32) != 0) {
                a = a.replace(/\s/g, "");
            }
            if ((b & 4) != 0) {
                let d = a.indexOf('(');
                while (d >= 0 && d < a.length) {
                    let e = (d > 0 && a.charAt(d - 1) == '\\') || (d < a.length - 1 && a.charAt(d + 1) == '?');
                    if (!e) {
                        a = a.substr(0, d) + "(?:" + a.substr(d + 1);
                    }
                    d = a.indexOf('(', d + 1);
                }
            }
            let f = (netRegexToJS(a));
            this.e = f.nameToNetGroupIndexMap;
            this.a = (f.netToJSGroupIndexMap);
            this.c = (f.matchMustStartAtCurrentPosition);
            this.d = new RegExp(f.pattern, c);
        }
        static f(a) {
            for (let b = 0; b < a.length; b++) {
                if (Regex.b(a.charAt(b)) == false) {
                    continue;
                }
                let c = new StringBuilder(0);
                let d = a.charAt(b);
                c.m(a, 0, b);
                do {
                    c.h('\\');
                    switch (d) {
                        case '\t':
                            d = 't';
                            break;
                        case '\n':
                            d = 'n';
                            break;
                        case '\f':
                            d = 'f';
                            break;
                        case '\r':
                            d = 'r';
                            break;
                    }
                    c.h(d);
                    b++;
                    let e = b;
                    while (b < a.length) {
                        d = a.charAt(b);
                        if (Regex.b(d)) {
                            break;
                        }
                        b++;
                    }
                    c.m(a, e, b - e);
                } while (b < a.length);
                return c.toString();
            }
            return a;
        }
        static b(a) {
            switch (a.charCodeAt(0)) {
                case 9:
                case 10:
                case 12:
                case 13:
                case 32:
                case 35:
                case 36:
                case 40:
                case 41:
                case 42:
                case 43:
                case 46:
                case 63:
                case 91:
                case 92:
                case 94:
                case 123:
                case 124: return true;
                default: return false;
            }
        }
        i(a) {
            return this.j(a, 0);
        }
        j(a, b) {
            this.d.lastIndex = b;
            let c = (this.d.exec(a));
            if (c != null && this.c && b != (c.index)) {
                c = null;
            }
            return new Match(this, a, c);
        }
        g(a, b) {
            return (a.replace(this.d, b));
        }
        static h(a, b, c, d) {
            let e = new Regex(b, d);
            return e.g(a, c);
        }
    }
    Regex.$t = /*@__PURE__*/ markType(Regex, 'Regex');
    return Regex;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var RegexOptions = /*@__PURE__*/ (function (RegexOptions) {
    RegexOptions[RegexOptions["None"] = 0] = "None";
    RegexOptions[RegexOptions["IgnoreCase"] = 1] = "IgnoreCase";
    RegexOptions[RegexOptions["Multiline"] = 2] = "Multiline";
    RegexOptions[RegexOptions["ExplicitCapture"] = 4] = "ExplicitCapture";
    RegexOptions[RegexOptions["Compiled"] = 8] = "Compiled";
    RegexOptions[RegexOptions["Singleline"] = 16] = "Singleline";
    RegexOptions[RegexOptions["IgnorePatternWhitespace"] = 32] = "IgnorePatternWhitespace";
    RegexOptions[RegexOptions["RightToLeft"] = 64] = "RightToLeft";
    RegexOptions[RegexOptions["ECMAScript"] = 256] = "ECMAScript";
    RegexOptions[RegexOptions["CultureInvariant"] = 512] = "CultureInvariant";
    return RegexOptions;
})({});
/**
 * @hidden
 */
let RegexOptions_$type = /*@__PURE__*/ markEnum('RegexOptions', 'None,0|IgnoreCase,1|Multiline,2|ExplicitCapture,4|Compiled,8|Singleline,16|IgnorePatternWhitespace,32|RightToLeft,64|ECMAScript,256|CultureInvariant,512');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TaskFactory = /*@__PURE__*/ (() => {
    class TaskFactory extends Base {
        c(a, b) {
            return new Task(0, this.b(this.a(a)).always(() => b(a)));
        }
        d($tResult, a, b) {
            let c = new TaskCompletionSource$1($tResult, 0);
            this.b(this.a(a)).always(() => {
                try {
                    let d = b(a);
                    c.e(d);
                }
                catch (e) {
                    c.d((e));
                }
            });
            return c.b;
        }
        e($tAntecedentResult, $tResult, a, b) {
            let c = (d) => getBoxIfEnum($tResult, b(d));
            return this.d(Base.$, a, c).k($tResult, (d) => typeCastObjTo$t($tResult, d.n));
        }
        a(a) {
            let b = new Array(a.length);
            for (let c = 0; c < a.length; c++) {
                b[c] = a[c].d;
            }
            return b;
        }
        b(a) {
            let promises_ = a;
            let b = null;
            return b;
        }
    }
    TaskFactory.$t = /*@__PURE__*/ markType(TaskFactory, 'TaskFactory');
    return TaskFactory;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TaskStatus = /*@__PURE__*/ (function (TaskStatus) {
    TaskStatus[TaskStatus["Created"] = 0] = "Created";
    TaskStatus[TaskStatus["RanToCompletion"] = 5] = "RanToCompletion";
    TaskStatus[TaskStatus["Canceled"] = 6] = "Canceled";
    TaskStatus[TaskStatus["Faulted"] = 7] = "Faulted";
    return TaskStatus;
})({});
/**
 * @hidden
 */
let TaskStatus_$type = /*@__PURE__*/ markEnum('TaskStatus', 'Created,0|RanToCompletion,5|Canceled,6|Faulted,7');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let APIFactory = /*@__PURE__*/ (() => {
    class APIFactory extends Base {
        static createPoint(a, b) {
            return { $type: Point_$type, x: a, y: b };
        }
        static createRect(a, b, c, d) {
            return new Rect(0, a, b, c, d);
        }
        static createSize(a, b) {
            return new Size(1, a, b);
        }
        static createColor(a) {
            let b = new Color();
            b.colorString = a;
            return b;
        }
    }
    APIFactory.$t = /*@__PURE__*/ markType(APIFactory, 'APIFactory');
    return APIFactory;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Clipboard = /*@__PURE__*/ (() => {
    class Clipboard extends Base {
        static c() {
            return Clipboard.b;
        }
        static a(a, b = false) {
            Clipboard.b = a;
        }
    }
    Clipboard.$t = /*@__PURE__*/ markType(Clipboard, 'Clipboard');
    Clipboard.b = null;
    return Clipboard;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataFormats = /*@__PURE__*/ (() => {
    class DataFormats extends Base {
    }
    DataFormats.$t = /*@__PURE__*/ markType(DataFormats, 'DataFormats');
    DataFormats.a = "CSV";
    DataFormats.b = "HTML Format";
    DataFormats.c = "System.String";
    DataFormats.d = "Text";
    DataFormats.e = "UnicodeText";
    return DataFormats;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataObject_$type = /*@__PURE__*/ new Type(null, 'IDataObject');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataObject = /*@__PURE__*/ (() => {
    class DataObject extends Base {
        constructor() {
            super();
            this.a = null;
            this.a = new Dictionary$2(String_$type, Base.$, 0);
        }
        getData(a) {
            let b;
            if (((() => { let c = this.a.tryGetValue(a, b); b = c.p1; return c.ret; })())) {
                return b;
            }
            return null;
        }
        getDataPresent(a) {
            return this.a.containsKey(a);
        }
        setData(a, b) {
            this.a.item(a, b);
        }
    }
    DataObject.$t = /*@__PURE__*/ markType(DataObject, 'DataObject', Base.$, [IDataObject_$type]);
    return DataObject;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataTemplate = /*@__PURE__*/ (() => {
    class DataTemplate extends Base {
        constructor() {
            super(...arguments);
            this._render = null;
            this._measure = null;
            this._passStarting = null;
            this._passCompleted = null;
        }
        get render() {
            return this._render;
        }
        set render(a) {
            this._render = a;
        }
        get measure() {
            return this._measure;
        }
        set measure(a) {
            this._measure = a;
        }
        get passStarting() {
            return this._passStarting;
        }
        set passStarting(a) {
            this._passStarting = a;
        }
        get passCompleted() {
            return this._passCompleted;
        }
        set passCompleted(a) {
            this._passCompleted = a;
        }
    }
    DataTemplate.$t = /*@__PURE__*/ markType(DataTemplate, 'DataTemplate');
    return DataTemplate;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataTemplatePassInfo = /*@__PURE__*/ (() => {
    class DataTemplatePassInfo extends Base {
        constructor() {
            super(...arguments);
            this.renderContext = null;
            this.context = null;
            this.viewportTop = 0;
            this.viewportLeft = 0;
            this.viewportWidth = 0;
            this.viewportHeight = 0;
            this.isHitTestRender = false;
            this.passID = null;
        }
    }
    DataTemplatePassInfo.$t = /*@__PURE__*/ markType(DataTemplatePassInfo, 'DataTemplatePassInfo');
    return DataTemplatePassInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates the horizontal position of an item relative to another object.
 */
var HorizontalAlignment = /*@__PURE__*/ (function (HorizontalAlignment) {
    /**
     * Align the item to the left
     */
    HorizontalAlignment[HorizontalAlignment["Left"] = 0] = "Left";
    /**
     * Center the item
     */
    HorizontalAlignment[HorizontalAlignment["Center"] = 1] = "Center";
    /**
     * Align the item to the right
     */
    HorizontalAlignment[HorizontalAlignment["Right"] = 2] = "Right";
    /**
     * Stretch the item to the full width
     */
    HorizontalAlignment[HorizontalAlignment["Stretch"] = 3] = "Stretch";
    return HorizontalAlignment;
})({});
/**
 * @hidden
 */
let HorizontalAlignment_$type = /*@__PURE__*/ markEnum('HorizontalAlignment', 'Left,0|Center,1|Right,2|Stretch,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyPath = /*@__PURE__*/ (() => {
    class PropertyPath extends Base {
        get b() {
            return this.a;
        }
        set b(a) {
            this.a = a;
        }
        constructor(a) {
            super();
            this.a = null;
            this.b = a;
        }
    }
    PropertyPath.$t = /*@__PURE__*/ markType(PropertyPath, 'PropertyPath');
    return PropertyPath;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Style = /*@__PURE__*/ (() => {
    class Style extends Base {
        constructor() {
            super(...arguments);
            this.fill = null;
            this.stroke = null;
            this.strokeThickness = NaN;
            this.opacity = NaN;
        }
    }
    Style.$t = /*@__PURE__*/ markType(Style, 'Style');
    return Style;
})();

/**
 * A class that exposes style realted properties.
*/
class IgrStyle {
    createImplementation() {
        return new Style();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates the vertica position of an item relative to another object.
 */
var VerticalAlignment = /*@__PURE__*/ (function (VerticalAlignment) {
    /**
     * Align the item to the top
     */
    VerticalAlignment[VerticalAlignment["Top"] = 0] = "Top";
    /**
     * Center the item
     */
    VerticalAlignment[VerticalAlignment["Center"] = 1] = "Center";
    /**
     * Align the item to the bottom
     */
    VerticalAlignment[VerticalAlignment["Bottom"] = 2] = "Bottom";
    /**
     * Stretch the item to the full height
     */
    VerticalAlignment[VerticalAlignment["Stretch"] = 3] = "Stretch";
    return VerticalAlignment;
})({});
/**
 * @hidden
 */
let VerticalAlignment_$type = /*@__PURE__*/ markEnum('VerticalAlignment', 'Top,0|Center,1|Bottom,2|Stretch,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Canvas = /*@__PURE__*/ (() => {
    class Canvas extends Panel {
    }
    Canvas.$t = /*@__PURE__*/ markType(Canvas, 'Canvas', Panel.$);
    return Canvas;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextBlock = /*@__PURE__*/ (() => {
    class TextBlock extends FrameworkElement {
        constructor() {
            super(...arguments);
            this.ag = false;
            this.ah = 0;
            this.ak = null;
            this.ao = null;
            this.af = true;
            this.ae = null;
            this.ad = null;
            this.ab = null;
            this.ac = null;
            this.ai = -1;
        }
        get al() {
            return this.ak;
        }
        set al(a) {
            if (this.ak != a) {
                this.af = true;
                this.ak = a;
            }
        }
        an(a, b) {
            if (this.ai == -1) {
                return null;
            }
            if (!this.af) {
                if (this.ab[this.ai] == a) {
                    return this.ae[this.ai];
                }
            }
            for (let c = 0; c < 5; c++) {
                let d = this.ai - c;
                if (d < 0) {
                    d = (5) + d;
                }
                if (b != this.ac[d] || a != this.ab[d] || this.ak != this.ad[d]) {
                    continue;
                }
                return this.ae[d];
            }
            return null;
        }
        am(a, b, c) {
            if (this.ai == -1) {
                this.ad = new Array(5);
                this.ab = new Array(5);
                this.ac = new Array(5);
                this.ae = new Array(5);
            }
            this.ai++;
            if (this.ai > 5 - 1) {
                this.ai = 0;
            }
            this.ad[this.ai] = this.ak;
            this.ab[this.ai] = a;
            this.ac[this.ai] = b;
            this.ae[this.ai] = c;
            this.af = false;
        }
    }
    TextBlock.$t = /*@__PURE__*/ markType(TextBlock, 'TextBlock', FrameworkElement.$);
    return TextBlock;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Binding = /*@__PURE__*/ (() => {
    class Binding extends Base {
        constructor(a, ..._rest) {
            super();
            this.c = null;
            this.e = null;
            this.a = false;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        this.e = new PropertyPath(c);
                    }
                    break;
            }
        }
        get d() {
            return this.c;
        }
        set d(a) {
            this.c = a;
        }
        get f() {
            return this.e;
        }
        set f(a) {
            this.e = a;
        }
        get b() {
            return this.a;
        }
        set b(a) {
            this.a = a;
        }
    }
    Binding.$t = /*@__PURE__*/ markType(Binding, 'Binding');
    return Binding;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var Key = /*@__PURE__*/ (function (Key) {
    Key[Key["None"] = 0] = "None";
    Key[Key["Back"] = 1] = "Back";
    Key[Key["Tab"] = 2] = "Tab";
    Key[Key["Enter"] = 3] = "Enter";
    Key[Key["Shift"] = 4] = "Shift";
    Key[Key["Ctrl"] = 5] = "Ctrl";
    Key[Key["Alt"] = 6] = "Alt";
    Key[Key["CapsLock"] = 7] = "CapsLock";
    Key[Key["Escape"] = 8] = "Escape";
    Key[Key["Space"] = 9] = "Space";
    Key[Key["PageUp"] = 10] = "PageUp";
    Key[Key["PageDown"] = 11] = "PageDown";
    Key[Key["End"] = 12] = "End";
    Key[Key["Home"] = 13] = "Home";
    Key[Key["Left"] = 14] = "Left";
    Key[Key["Up"] = 15] = "Up";
    Key[Key["Right"] = 16] = "Right";
    Key[Key["Down"] = 17] = "Down";
    Key[Key["Insert"] = 18] = "Insert";
    Key[Key["del"] = 19] = "del";
    Key[Key["D0"] = 20] = "D0";
    Key[Key["D1"] = 21] = "D1";
    Key[Key["D2"] = 22] = "D2";
    Key[Key["D3"] = 23] = "D3";
    Key[Key["D4"] = 24] = "D4";
    Key[Key["D5"] = 25] = "D5";
    Key[Key["D6"] = 26] = "D6";
    Key[Key["D7"] = 27] = "D7";
    Key[Key["D8"] = 28] = "D8";
    Key[Key["D9"] = 29] = "D9";
    Key[Key["A"] = 30] = "A";
    Key[Key["B"] = 31] = "B";
    Key[Key["C"] = 32] = "C";
    Key[Key["D"] = 33] = "D";
    Key[Key["E"] = 34] = "E";
    Key[Key["F"] = 35] = "F";
    Key[Key["G"] = 36] = "G";
    Key[Key["H"] = 37] = "H";
    Key[Key["I"] = 38] = "I";
    Key[Key["J"] = 39] = "J";
    Key[Key["K"] = 40] = "K";
    Key[Key["L"] = 41] = "L";
    Key[Key["M"] = 42] = "M";
    Key[Key["N"] = 43] = "N";
    Key[Key["O"] = 44] = "O";
    Key[Key["P"] = 45] = "P";
    Key[Key["Q"] = 46] = "Q";
    Key[Key["R"] = 47] = "R";
    Key[Key["S"] = 48] = "S";
    Key[Key["T"] = 49] = "T";
    Key[Key["U"] = 50] = "U";
    Key[Key["V"] = 51] = "V";
    Key[Key["W"] = 52] = "W";
    Key[Key["X"] = 53] = "X";
    Key[Key["Y"] = 54] = "Y";
    Key[Key["Z"] = 55] = "Z";
    Key[Key["F1"] = 56] = "F1";
    Key[Key["F2"] = 57] = "F2";
    Key[Key["F3"] = 58] = "F3";
    Key[Key["F4"] = 59] = "F4";
    Key[Key["F5"] = 60] = "F5";
    Key[Key["F6"] = 61] = "F6";
    Key[Key["F7"] = 62] = "F7";
    Key[Key["F8"] = 63] = "F8";
    Key[Key["F9"] = 64] = "F9";
    Key[Key["F10"] = 65] = "F10";
    Key[Key["F11"] = 66] = "F11";
    Key[Key["F12"] = 67] = "F12";
    Key[Key["NumPad0"] = 68] = "NumPad0";
    Key[Key["NumPad1"] = 69] = "NumPad1";
    Key[Key["NumPad2"] = 70] = "NumPad2";
    Key[Key["NumPad3"] = 71] = "NumPad3";
    Key[Key["NumPad4"] = 72] = "NumPad4";
    Key[Key["NumPad5"] = 73] = "NumPad5";
    Key[Key["NumPad6"] = 74] = "NumPad6";
    Key[Key["NumPad7"] = 75] = "NumPad7";
    Key[Key["NumPad8"] = 76] = "NumPad8";
    Key[Key["NumPad9"] = 77] = "NumPad9";
    Key[Key["Multiply"] = 78] = "Multiply";
    Key[Key["Add"] = 79] = "Add";
    Key[Key["Subtract"] = 80] = "Subtract";
    Key[Key["Decimal"] = 81] = "Decimal";
    Key[Key["Divide"] = 82] = "Divide";
    Key[Key["OemSemicolon"] = 83] = "OemSemicolon";
    Key[Key["OemQuestion"] = 84] = "OemQuestion";
    Key[Key["OemPipe"] = 85] = "OemPipe";
    Key[Key["OemTilde"] = 86] = "OemTilde";
    Key[Key["OemPlus"] = 87] = "OemPlus";
    Key[Key["OemMinus"] = 88] = "OemMinus";
    Key[Key["Unknown"] = 255] = "Unknown";
    return Key;
})({});
/**
 * @hidden
 */
let Key_$type = /*@__PURE__*/ markEnum('Key', 'None,0|Back,1|Tab,2|Enter,3|Shift,4|Ctrl,5|Alt,6|CapsLock,7|Escape,8|Space,9|PageUp,10|PageDown,11|End,12|Home,13|Left,14|Up,15|Right,16|Down,17|Insert,18|Delete:del,19|D0,20|D1,21|D2,22|D3,23|D4,24|D5,25|D6,26|D7,27|D8,28|D9,29|A,30|B,31|C,32|D,33|E,34|F,35|G,36|H,37|I,38|J,39|K,40|L,41|M,42|N,43|O,44|P,45|Q,46|R,47|S,48|T,49|U,50|V,51|W,52|X,53|Y,54|Z,55|F1,56|F2,57|F3,58|F4,59|F5,60|F6,61|F7,62|F8,63|F9,64|F10,65|F11,66|F12,67|NumPad0,68|NumPad1,69|NumPad2,70|NumPad3,71|NumPad4,72|NumPad5,73|NumPad6,74|NumPad7,75|NumPad8,76|NumPad9,77|Multiply,78|Add,79|Subtract,80|Decimal,81|Divide,82|OemSemicolon,83|OemQuestion,84|OemPipe,85|OemTilde,86|OemPlus,87|OemMinus,88|Unknown,255');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var ModifierKeys = /*@__PURE__*/ (function (ModifierKeys) {
    ModifierKeys[ModifierKeys["None"] = 0] = "None";
    ModifierKeys[ModifierKeys["Alt"] = 1] = "Alt";
    ModifierKeys[ModifierKeys["Control"] = 2] = "Control";
    ModifierKeys[ModifierKeys["Shift"] = 4] = "Shift";
    ModifierKeys[ModifierKeys["Windows"] = 8] = "Windows";
    ModifierKeys[ModifierKeys["Apple"] = 8] = "Apple";
    return ModifierKeys;
})({});
/**
 * @hidden
 */
let ModifierKeys_$type = /*@__PURE__*/ markEnum('ModifierKeys', 'None,0|Alt,1|Control,2|Shift,4|Windows,8|Apple,8');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MouseButtonEventArgs = /*@__PURE__*/ (() => {
    class MouseButtonEventArgs extends MouseEventArgs {
        constructor() {
            super(...arguments);
            this._handled = false;
        }
        get handled() {
            return this._handled;
        }
        set handled(a) {
            this._handled = a;
        }
    }
    MouseButtonEventArgs.$t = /*@__PURE__*/ markType(MouseButtonEventArgs, 'MouseButtonEventArgs', MouseEventArgs.$);
    return MouseButtonEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var FillRule = /*@__PURE__*/ (function (FillRule) {
    FillRule[FillRule["EvenOdd"] = 0] = "EvenOdd";
    FillRule[FillRule["Nonzero"] = 1] = "Nonzero";
    return FillRule;
})({});
/**
 * @hidden
 */
let FillRule_$type = /*@__PURE__*/ markEnum('FillRule', 'EvenOdd,0|Nonzero,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var GeometryType = /*@__PURE__*/ (function (GeometryType) {
    GeometryType[GeometryType["Group"] = 0] = "Group";
    GeometryType[GeometryType["Line"] = 1] = "Line";
    GeometryType[GeometryType["Rectangle"] = 2] = "Rectangle";
    GeometryType[GeometryType["Ellipse"] = 3] = "Ellipse";
    GeometryType[GeometryType["Path"] = 4] = "Path";
    return GeometryType;
})({});
/**
 * @hidden
 */
let GeometryType_$type = /*@__PURE__*/ markEnum('GeometryType', 'Group,0|Line,1|Rectangle,2|Ellipse,3|Path,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var PathSegmentType = /*@__PURE__*/ (function (PathSegmentType) {
    PathSegmentType[PathSegmentType["Line"] = 0] = "Line";
    PathSegmentType[PathSegmentType["Bezier"] = 1] = "Bezier";
    PathSegmentType[PathSegmentType["PolyBezier"] = 2] = "PolyBezier";
    PathSegmentType[PathSegmentType["PolyLine"] = 3] = "PolyLine";
    PathSegmentType[PathSegmentType["Arc"] = 4] = "Arc";
    return PathSegmentType;
})({});
/**
 * @hidden
 */
let PathSegmentType_$type = /*@__PURE__*/ markEnum('PathSegmentType', 'Line,0|Bezier,1|PolyBezier,2|PolyLine,3|Arc,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enum representing the direction of an arc.
 */
var SweepDirection = /*@__PURE__*/ (function (SweepDirection) {
    /**
     * In a direction opposite the typical forward movement of the hands of a clock.
     */
    SweepDirection[SweepDirection["Counterclockwise"] = 0] = "Counterclockwise";
    /**
     * In a direction corresponding to the typical forward movement of the hands of a clock.
     */
    SweepDirection[SweepDirection["Clockwise"] = 1] = "Clockwise";
    return SweepDirection;
})({});
/**
 * @hidden
 */
let SweepDirection_$type = /*@__PURE__*/ markEnum('SweepDirection', 'Counterclockwise,0|Clockwise,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathMarkupTokenType_$type = /*@__PURE__*/ markEnum('PathMarkupTokenType', 'Move,0|Line,1|Horizontal,2|Vertical,3|CubicBezier,4|QuadraticBezier,5|SmoothCubicBezier,6|SmoothQuadraticBezier,7|Arc,8|Close,9|Number,10|None,11');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates the type of shape at the end of a line.
 */
var PenLineCap = /*@__PURE__*/ (function (PenLineCap) {
    /**
     * A flat end
     */
    PenLineCap[PenLineCap["Flat"] = 0] = "Flat";
    /**
     * A square end
     */
    PenLineCap[PenLineCap["Square"] = 1] = "Square";
    /**
     * A round end
     */
    PenLineCap[PenLineCap["Round"] = 2] = "Round";
    /**
     * A triangluar end
     */
    PenLineCap[PenLineCap["Triangle"] = 3] = "Triangle";
    return PenLineCap;
})({});
/**
 * @hidden
 */
let PenLineCap_$type = /*@__PURE__*/ markEnum('PenLineCap', 'Flat,0|Square,1|Round,2|Triangle,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates the type of shape at the end of a line.
 */
var PenLineJoin = /*@__PURE__*/ (function (PenLineJoin) {
    /**
     * Regular angular vertices.
     */
    PenLineJoin[PenLineJoin["Miter"] = 0] = "Miter";
    /**
     * Beveled vertices.
     */
    PenLineJoin[PenLineJoin["Bevel"] = 1] = "Bevel";
    /**
     * Rounded vertices.
     */
    PenLineJoin[PenLineJoin["Round"] = 2] = "Round";
    return PenLineJoin;
})({});
/**
 * @hidden
 */
let PenLineJoin_$type = /*@__PURE__*/ markEnum('PenLineJoin', 'Miter,0|Bevel,1|Round,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var Stretch = /*@__PURE__*/ (function (Stretch) {
    Stretch[Stretch["None"] = 0] = "None";
    Stretch[Stretch["Fill"] = 1] = "Fill";
    Stretch[Stretch["Uniform"] = 2] = "Uniform";
    Stretch[Stretch["UniformToFill"] = 3] = "UniformToFill";
    return Stretch;
})({});
/**
 * @hidden
 */
let Stretch_$type = /*@__PURE__*/ markEnum('Stretch', 'None,0|Fill,1|Uniform,2|UniformToFill,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Shape = /*@__PURE__*/ (() => {
    class Shape extends FrameworkElement {
        constructor() {
            super();
            this._fill = null;
            this._stroke = null;
            this.ab = false;
            this.ad = 0;
            this.ai = null;
            this.al = 0;
            this.ak = 0;
            this.am = 0;
            this.ac = 0;
            this.aj = 0;
        }
        get fill() {
            return this._fill;
        }
        set fill(a) {
            this._fill = a;
        }
        get stroke() {
            return this._stroke;
        }
        set stroke(a) {
            this._stroke = a;
        }
    }
    Shape.$t = /*@__PURE__*/ markType(Shape, 'Shape', FrameworkElement.$);
    return Shape;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Ellipse = /*@__PURE__*/ (() => {
    class Ellipse extends Shape {
        constructor() {
            super();
            this.width = 0;
            this.height = 0;
        }
    }
    Ellipse.$t = /*@__PURE__*/ markType(Ellipse, 'Ellipse', Shape.$);
    return Ellipse;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Line = /*@__PURE__*/ (() => {
    class Line extends Shape {
        constructor() {
            super();
            this.an = 0;
            this.ao = 0;
            this.ap = 0;
            this.aq = 0;
            this.an = 0;
            this.ao = 0;
            this.ap = 0;
            this.aq = 0;
        }
    }
    Line.$t = /*@__PURE__*/ markType(Line, 'Line', Shape.$);
    return Line;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Path = /*@__PURE__*/ (() => {
    class Path extends Shape {
        constructor() {
            super(...arguments);
            this.an = null;
        }
    }
    Path.$t = /*@__PURE__*/ markType(Path, 'Path', Shape.$);
    return Path;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Polygon = /*@__PURE__*/ (() => {
    class Polygon extends Shape {
        constructor() {
            super();
            this.an = null;
            this.an = new PointCollection(0);
        }
    }
    Polygon.$t = /*@__PURE__*/ markType(Polygon, 'Polygon', Shape.$);
    return Polygon;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Polyline = /*@__PURE__*/ (() => {
    class Polyline extends Shape {
        constructor() {
            super();
            this.an = null;
            this.an = new PointCollection(0);
        }
    }
    Polyline.$t = /*@__PURE__*/ markType(Polyline, 'Polyline', Shape.$);
    return Polyline;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Rectangle = /*@__PURE__*/ (() => {
    class Rectangle extends Shape {
        get ap() {
            return this.an;
        }
        set ap(a) {
            this.an = a;
        }
        get aq() {
            return this.ao;
        }
        set aq(a) {
            this.ao = a;
        }
        constructor() {
            super();
            this.as = null;
            this.an = 0;
            this.ao = 0;
            this.as = new Rect(0, 0, 0, 0, 0);
        }
        ar(a) {
        }
    }
    Rectangle.$t = /*@__PURE__*/ markType(Rectangle, 'Rectangle', Shape.$);
    return Rectangle;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UriParser = /*@__PURE__*/ (() => {
    class UriParser extends Base {
        static a(a) {
            return UriParser.b.contains(a.toLowerCase());
        }
    }
    UriParser.$t = /*@__PURE__*/ markType(UriParser, 'UriParser');
    UriParser.b = /*@__PURE__*/ new List$1(String_$type, 1, ["http", "https", "ws", "wss", "ftp", "file", "gopher", "nntp", "news", "mailto", "uuid", "telnet", "ldap", "net.tcp", "net.pipe"]);
    return UriParser;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ICredentials_$type = /*@__PURE__*/ new Type(null, 'ICredentials');
/**
 * @hidden
 */
let NetworkCredential = /*@__PURE__*/ (() => {
    class NetworkCredential extends Base {
        constructor(a, ..._rest) {
            super();
            this.c = null;
            this.b = null;
            this.a = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [c, d, stringEmpty()];
                        {
                            let g = e[0];
                            let h = e[1];
                            let i = e[2];
                            this.c = g;
                            this.b = h;
                            this.a = i;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        this.c = c;
                        this.b = d;
                        this.a = e;
                    }
                    break;
            }
        }
        getCredential(a, b) {
            return this;
        }
    }
    NetworkCredential.$t = /*@__PURE__*/ markType(NetworkCredential, 'NetworkCredential', Base.$, [ICredentials_$type]);
    return NetworkCredential;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UploadDataCompletedEventArgs = /*@__PURE__*/ (() => {
    class UploadDataCompletedEventArgs extends AsyncCompletedEventArgs {
        constructor(a, b, c, d) {
            super(b, c, d);
            this.i = null;
            this.i = a;
        }
        get result() {
            this.h();
            return this.i;
        }
    }
    UploadDataCompletedEventArgs.$t = /*@__PURE__*/ markType(UploadDataCompletedEventArgs, 'UploadDataCompletedEventArgs', AsyncCompletedEventArgs.$);
    return UploadDataCompletedEventArgs;
})();

class IgrUploadDataCompletedEventArgs extends IgrAsyncCompletedEventArgs {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get result() {
        return this.i.result;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UploadStringCompletedEventArgs = /*@__PURE__*/ (() => {
    class UploadStringCompletedEventArgs extends AsyncCompletedEventArgs {
        constructor(a, b, c, d) {
            super(b, c, d);
            this.i = null;
            this.i = a;
        }
        get result() {
            this.h();
            return this.i;
        }
    }
    UploadStringCompletedEventArgs.$t = /*@__PURE__*/ markType(UploadStringCompletedEventArgs, 'UploadStringCompletedEventArgs', AsyncCompletedEventArgs.$);
    return UploadStringCompletedEventArgs;
})();

class IgrUploadStringCompletedEventArgs extends IgrAsyncCompletedEventArgs {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get result() {
        return this.i.result;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebHeaderCollection = /*@__PURE__*/ (() => {
    class WebHeaderCollection extends NameValueCollection {
    }
    WebHeaderCollection.$t = /*@__PURE__*/ markType(WebHeaderCollection, 'WebHeaderCollection', NameValueCollection.$);
    return WebHeaderCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebClient = /*@__PURE__*/ (() => {
    class WebClient extends Base {
        constructor() {
            super();
            this.e = null;
            this.d = null;
            this.a = null;
            this.uploadStringCompleted = null;
            this.uploadDataCompleted = null;
            this.d = new WebHeaderCollection();
        }
        k(a, b, c, d) {
            this.g(a, b, c).j((e) => {
                if (this.uploadStringCompleted != null) {
                    let f = null;
                    let g = null;
                    try {
                        f = e.n;
                    }
                    catch (h) {
                        g = (h);
                    }
                    this.uploadStringCompleted(this, new UploadStringCompletedEventArgs(f, g, e.h == 6, d));
                }
            });
        }
        g(a, b, c) {
            let url_ = a.value;
            let method_ = b;
            let data_ = c;
            let contentType_ = this.d.item("Content-Type");
            let credentials_ = this.a;
            throw new NotImplementedException(0);
        }
        j(a, b, c, d) {
            this.f(a, b, c).j((e) => {
                if (this.uploadDataCompleted != null) {
                    let f = null;
                    let g = null;
                    try {
                        f = e.n;
                    }
                    catch (h) {
                        g = (h);
                    }
                    this.uploadDataCompleted(this, new UploadDataCompletedEventArgs(f, g, e.h == 6, d));
                }
            });
        }
        f(a, b, c) {
            let url_ = a.value;
            let method_ = b;
            let data_ = c;
            let contentType_ = this.d.item("Content-Type");
            let credentials_ = this.a;
            throw new NotImplementedException(0);
        }
        i(a, b, c, d) {
            a.e(b);
        }
        h(a, b, c, d) {
            a.d(new BaseError(1, d));
        }
    }
    WebClient.$t = /*@__PURE__*/ markType(WebClient, 'WebClient');
    return WebClient;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JavaScriptSerializer = /*@__PURE__*/ (() => {
    class JavaScriptSerializer extends Base {
        constructor() {
            super();
        }
        a(a) {
            let text_ = a;
            return JSON.parse(text_);
        }
        b(a) {
            let value_ = a;
            return (JSON.stringify(value_));
        }
    }
    JavaScriptSerializer.$t = /*@__PURE__*/ markType(JavaScriptSerializer, 'JavaScriptSerializer');
    return JavaScriptSerializer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FaultCode = /*@__PURE__*/ (() => {
    class FaultCode extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
    }
    FaultCode.$t = /*@__PURE__*/ markType(FaultCode, 'FaultCode');
    return FaultCode;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FaultException = /*@__PURE__*/ (() => {
    class FaultException extends BaseError {
        constructor(a, b, c) {
            super(0);
            this._action = null;
            this._code = null;
            this._reason = null;
            this.reason = a;
            this.code = b;
            this.action = c;
        }
        get action() {
            return this._action;
        }
        set action(a) {
            this._action = a;
        }
        get code() {
            return this._code;
        }
        set code(a) {
            this._code = a;
        }
        get reason() {
            return this._reason;
        }
        set reason(a) {
            this._reason = a;
        }
    }
    FaultException.$t = /*@__PURE__*/ markType(FaultException, 'FaultException', BaseError.$);
    return FaultException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FaultException$1 = /*@__PURE__*/ (() => {
    class FaultException$1 extends FaultException {
        constructor($tDetail, a, b, c, d) {
            super(b, c, d);
            this.$tDetail = null;
            this._detail = null;
            this.$tDetail = $tDetail;
            this.$type = this.$type.specialize(this.$tDetail);
            this.detail = a;
        }
        get detail() {
            return this._detail;
        }
        set detail(a) {
            this._detail = a;
        }
    }
    FaultException$1.$t = /*@__PURE__*/ markType(FaultException$1, 'FaultException$1', FaultException.$);
    return FaultException$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FaultReason = /*@__PURE__*/ (() => {
    class FaultReason extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        toString() {
            return this.a;
        }
    }
    FaultReason.$t = /*@__PURE__*/ markType(FaultReason, 'FaultReason');
    return FaultReason;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XmlUtils = /*@__PURE__*/ (() => {
    class XmlUtils extends Base {
        static a() {
            return (!!window.DOMParser);
        }
        static m(a) {
            let text_ = a;
            return ((new DOMParser()).parseFromString(text_, 'text/xml'));
        }
        static l(a) {
            let text_ = a;
            return ((function (xml) {
                var xmlDoc = new window.ActiveXObject('Microsoft.XMLDOM');
                xmlDoc.async = false;
                xmlDoc.loadXML(xml);
                return xmlDoc;
            })(text_));
        }
        static f(a) {
            let node_ = a;
            return ((new XMLSerializer()).serializeToString(node_));
        }
        static e(a) {
            let node_ = a;
            return (node_.xml);
        }
        static k() {
            return (new window.ActiveXObject('Microsoft.XMLDOM'));
        }
        static n(a) {
            if (XmlUtils.a()) {
                return XmlUtils.m(a);
            }
            else {
                return XmlUtils.l(a);
            }
        }
        static xmlNodeToString(a) {
            if (XmlUtils.a()) {
                return XmlUtils.f(a);
            }
            else {
                return XmlUtils.e(a);
            }
        }
        static j() {
            let a;
            if (XmlUtils.a()) {
                a = XmlUtils.m("<dummy/>");
                a.removeChild(a.documentElement);
            }
            else {
                a = XmlUtils.k();
            }
            return a;
        }
        static o(a, b) {
            let doc_ = XmlUtils.j();
            if (XmlUtils.a()) {
                return doc_.createElementNS(b, a);
            }
            else {
                let name_ = a;
                let namespaceURI_ = b;
                return (doc_.createNode(1 /*NODE_ELEMENT*/, name_, namespaceURI_));
            }
        }
        static c(a) {
            if (XmlUtils.a()) {
                return a.textContent;
            }
            else {
                let node_ = a;
                return (node_.text);
            }
        }
        static h(a, b) {
            if (XmlUtils.a()) {
                a.textContent = b;
            }
            else {
                let node_ = a;
                let text_ = b;
                node_.text = text_;
            }
        }
        static p(a, b) {
            if (XmlUtils.a()) {
                return a.importNode(b, true);
            }
            else {
                return b;
            }
        }
        static d(a) {
            if (XmlUtils.a()) {
                return a.localName;
            }
            else {
                let node_ = a;
                return (node_.baseName);
            }
        }
        static i(a, b, c) {
            if (XmlUtils.a()) {
                return a.getAttributeNodeNS(c, b);
            }
            else {
                let elem_ = a;
                let ln_ = b;
                let nn_ = c;
                return (elem_.attributes.getQualifiedItem(ln_, nn_));
            }
        }
        static b(a) {
            if (XmlUtils.a()) {
                return a.nodeValue;
            }
            else {
                let attr_ = a;
                return (attr_.value);
            }
        }
    }
    XmlUtils.$t = /*@__PURE__*/ markType(XmlUtils, 'XmlUtils');
    return XmlUtils;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XObject = /*@__PURE__*/ (() => {
    class XObject extends Base {
        constructor(a) {
            super();
            this._backingNode = null;
            this.backingNode = a;
        }
        get backingNode() {
            return this._backingNode;
        }
        set backingNode(a) {
            this._backingNode = a;
        }
        toString() {
            if (this.backingNode != null) {
                return XmlUtils.xmlNodeToString(this.backingNode);
            }
            else {
                return "";
            }
        }
    }
    XObject.$t = /*@__PURE__*/ markType(XObject, 'XObject');
    return XObject;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XAttribute = /*@__PURE__*/ (() => {
    class XAttribute extends XObject {
        constructor(a) {
            super(a);
        }
        e(a) {
            this.backingNode = this.backingNode.cloneNode(true);
            a.setAttributeNode(this.backingNode);
        }
        get_nodeType() {
            return 2;
        }
        get nodeType() {
            return this.get_nodeType();
        }
        get value() {
            return XmlUtils.b(this.backingNode);
        }
    }
    XAttribute.$t = /*@__PURE__*/ markType(XAttribute, 'XAttribute', XObject.$);
    return XAttribute;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XNode = /*@__PURE__*/ (() => {
    class XNode extends XObject {
        constructor(a) {
            super(a);
        }
    }
    XNode.$t = /*@__PURE__*/ markType(XNode, 'XNode', XObject.$);
    return XNode;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XNamespace = /*@__PURE__*/ (() => {
    class XNamespace extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        static get(a) {
            return new XNamespace(a);
        }
        static get xmlns() {
            return XNamespace.get("http://www.w3.org/2000/xmlns/");
        }
        get namespaceName() {
            return this.a;
        }
    }
    XNamespace.$t = /*@__PURE__*/ markType(XNamespace, 'XNamespace');
    return XNamespace;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XName = /*@__PURE__*/ (() => {
    class XName extends Base {
        constructor(a, b) {
            super();
            this.a = null;
            this.b = null;
            this.a = a;
            this.b = b;
        }
        get localName() {
            return this.a;
        }
        get namespaceName() {
            return this.b;
        }
        get namespace() {
            return XNamespace.get(this.b);
        }
        static get(a, b) {
            return new XName(a, b);
        }
    }
    XName.$t = /*@__PURE__*/ markType(XName, 'XName');
    return XName;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XContainer = /*@__PURE__*/ (() => {
    class XContainer extends XNode {
        constructor(a) {
            super(a);
        }
        element(a) {
            let b = null;
            let c = this.backingNode;
            let d = c.childNodes;
            let e = d.length;
            let f = a.localName;
            let g = a.namespaceName;
            for (let h = 0; h < e; h++) {
                let i = d.item(h);
                if (i.namespaceURI == g && i.nodeType == 1 && XmlUtils.d(i) == f) {
                    b = i;
                }
            }
            if (b == null) {
                return null;
            }
            else {
                return new XElement(0, b);
            }
        }
        elements() {
            return this.f(null);
        }
        elements1(a) {
            return this.f(a);
        }
        f(a) {
            let b = new List$1(XElement.$, 0);
            for (let c = 0; c < this.backingNode.childNodes.length; c++) {
                let d = this.backingNode.childNodes.item(c);
                if (d.nodeType == 1) {
                    let e = false;
                    if (a != null) {
                        if (XmlUtils.d(d) == a.localName && d.namespaceURI == a.namespaceName) {
                            e = true;
                        }
                    }
                    else {
                        e = true;
                    }
                    if (e) {
                        b.add(new XElement(0, d));
                    }
                }
            }
            return b;
        }
        add(a) {
            let b = this.backingNode;
            let c;
            if (typeCast(XDocument.$, this) !== null) {
                c = this.backingNode;
            }
            else {
                c = this.backingNode.ownerDocument;
            }
            if (typeCast(XAttribute.$, a) !== null) {
                a.e(b);
            }
            else if (typeCast(XElement.$, a) !== null) {
                a.j(b, c);
            }
        }
    }
    XContainer.$t = /*@__PURE__*/ markType(XContainer, 'XContainer', XNode.$);
    return XContainer;
})();
/**
 * @hidden
 */
let XDocument = /*@__PURE__*/ (() => {
    class XDocument extends XContainer {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(c);
                    }
                    break;
                case 1:
                    {
                        super(XmlUtils.j());
                    }
                    break;
            }
        }
        get_nodeType() {
            return 9;
        }
        get nodeType() {
            return this.get_nodeType();
        }
        static parse(a) {
            return new XDocument(0, XmlUtils.n(a));
        }
    }
    XDocument.$t = /*@__PURE__*/ markType(XDocument, 'XDocument', XContainer.$);
    return XDocument;
})();
/**
 * @hidden
 */
let XElement = /*@__PURE__*/ (() => {
    class XElement extends XContainer {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = [c, null];
                        {
                            let f = d[0];
                            let g = d[1];
                            super(XmlUtils.o(f.localName, f.namespaceName));
                            let h = g == null ? "" : g.toString();
                            this.value = h;
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(XmlUtils.o(c.localName, c.namespaceName));
                        let e = d == null ? "" : d.toString();
                        this.value = e;
                    }
                    break;
            }
        }
        get value() {
            return XmlUtils.c(this.backingNode);
        }
        set value(a) {
            XmlUtils.h(this.backingNode, a);
        }
        get_nodeType() {
            return 1;
        }
        get nodeType() {
            return this.get_nodeType();
        }
        get name() {
            return XName.get(XmlUtils.d(this.backingNode), this.backingNode.namespaceURI);
        }
        attribute(a) {
            return new XAttribute(XmlUtils.i(this.backingNode, a.localName, a.namespaceName));
        }
        j(a, b) {
            if (this.backingNode.ownerDocument != b) {
                this.backingNode = XmlUtils.p(b, this.backingNode);
            }
            a.appendChild(this.backingNode);
        }
    }
    XElement.$t = /*@__PURE__*/ markType(XElement, 'XElement', XContainer.$);
    return XElement;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Locale = /*@__PURE__*/ (() => {
    class Locale extends Base {
        static a(a) {
            return a;
        }
    }
    Locale.$t = /*@__PURE__*/ markType(Locale, 'Locale');
    return Locale;
})();

//
/**
 * @hidden
 */
let FormatException2 = /*@__PURE__*/ (() => {
    class FormatException2 extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, Locale.a("Invalid format."));
                        this._hResult = 0;
                        this.hResult = -2146233033;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                        this._hResult = 0;
                        this.hResult = -2146233033;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(2, c, d);
                        this._hResult = 0;
                        this.hResult = -2146233033;
                    }
                    break;
            }
        }
        get hResult() {
            return this._hResult;
        }
        set hResult(a) {
            this._hResult = a;
        }
    }
    FormatException2.$t = /*@__PURE__*/ markType(FormatException2, 'FormatException2', BaseError.$);
    return FormatException2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Hashtable = /*@__PURE__*/ (() => {
    class Hashtable extends Base {
        constructor() {
            super();
            this.b = new Dictionary$2(String_$type, Base.$, 0);
        }
        get c() {
            return this.b.keys;
        }
        f(a) {
            this.b.removeItem(a);
        }
        e(a, b) {
            this.b.addItem(a, b);
        }
        a(a) {
            return this.b.containsKey(a);
        }
        item(a, b) {
            if (arguments.length === 2) {
                this.b.item(a, b);
                return b;
            }
            else {
                return this.b.item(a);
            }
        }
    }
    Hashtable.$t = /*@__PURE__*/ markType(Hashtable, 'Hashtable', Base.$, [IDictionary_$type]);
    return Hashtable;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MarshalByRefObject = /*@__PURE__*/ (() => {
    class MarshalByRefObject extends Base {
    }
    MarshalByRefObject.$t = /*@__PURE__*/ markType(MarshalByRefObject, 'MarshalByRefObject');
    return MarshalByRefObject;
})();

//
/**
 * @hidden
 */
let NullReferenceException = /*@__PURE__*/ (() => {
    class NullReferenceException extends SystemException {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, Locale.a("A null value was found where an object instance was required."));
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(2, c, d);
                    }
                    break;
            }
        }
    }
    NullReferenceException.$t = /*@__PURE__*/ markType(NullReferenceException, 'NullReferenceException', SystemException.$);
    return NullReferenceException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ObjectDisposedException = /*@__PURE__*/ (() => {
    class ObjectDisposedException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(0);
                    }
                    break;
            }
        }
    }
    ObjectDisposedException.$t = /*@__PURE__*/ markType(ObjectDisposedException, 'ObjectDisposedException', BaseError.$);
    return ObjectDisposedException;
})();

//
/**
 * @hidden
 */
let IPermission_$type = /*@__PURE__*/ new Type(null, 'IPermission');

//
/**
 * @hidden
 */
let PermissionSet = /*@__PURE__*/ (() => {
    class PermissionSet extends Base {
        constructor(a, ..._rest) {
            super();
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                    }
                    break;
            }
        }
        b(a) {
            return a;
        }
        a() {
            return true;
        }
        c(a) {
            return new PermissionSet(0);
        }
    }
    PermissionSet.$t = /*@__PURE__*/ markType(PermissionSet, 'PermissionSet');
    return PermissionSet;
})();

// PermissionState.cs
var PermissionState = /*@__PURE__*/ (function (PermissionState) {
    PermissionState[PermissionState["Unrestricted"] = 1] = "Unrestricted";
    PermissionState[PermissionState["None"] = 0] = "None";
    return PermissionState;
})({});
/**
 * @hidden
 */
let PermissionState_$type = /*@__PURE__*/ markEnum('PermissionState', 'Unrestricted,1|None,0');

//
var SecurityAction = /*@__PURE__*/ (function (SecurityAction) {
    SecurityAction[SecurityAction["Demand"] = 2] = "Demand";
    SecurityAction[SecurityAction["Assert"] = 3] = "Assert";
    SecurityAction[SecurityAction["Deny"] = 4] = "Deny";
    SecurityAction[SecurityAction["PermitOnly"] = 5] = "PermitOnly";
    SecurityAction[SecurityAction["LinkDemand"] = 6] = "LinkDemand";
    SecurityAction[SecurityAction["InheritanceDemand"] = 7] = "InheritanceDemand";
    SecurityAction[SecurityAction["RequestMinimum"] = 8] = "RequestMinimum";
    SecurityAction[SecurityAction["RequestOptional"] = 9] = "RequestOptional";
    SecurityAction[SecurityAction["RequestRefuse"] = 10] = "RequestRefuse";
    return SecurityAction;
})({});
/**
 * @hidden
 */
let SecurityAction_$type = /*@__PURE__*/ markEnum('SecurityAction', 'Demand,2|Assert,3|Deny,4|PermitOnly,5|LinkDemand,6|InheritanceDemand,7|RequestMinimum,8|RequestOptional,9|RequestRefuse,10');

//
/**
 * @hidden
 */
let NullStream = /*@__PURE__*/ (() => {
    class NullStream extends Stream {
        get_canRead() {
            return true;
        }
        get canRead() {
            return this.get_canRead();
        }
        get_canSeek() {
            return true;
        }
        get canSeek() {
            return this.get_canSeek();
        }
        get_canWrite() {
            return true;
        }
        get canWrite() {
            return this.get_canWrite();
        }
        get_length() {
            return 0;
        }
        get length() {
            return this.get_length();
        }
        get_position() {
            return 0;
        }
        set_position(a) {
        }
        get position() {
            return this.get_position();
        }
        set position(a) {
            this.set_position(a);
        }
        flush() {
        }
        read(a, b, c) {
            return 0;
        }
        readByte() {
            return -1;
        }
        seek(a, b) {
            return 0;
        }
        setLength(a) {
        }
        write(a, b, c) {
        }
        writeByte(a) {
        }
    }
    NullStream.$t = /*@__PURE__*/ markType(NullStream, 'NullStream', Stream.$);
    return NullStream;
})();

//
/**
 * @hidden
 */
let TextWriter = /*@__PURE__*/ (() => {
    class TextWriter extends MarshalByRefObject {
        static staticInit() {
            TextWriter.d = new TextWriter_NullTextWriter();
        }
        constructor(a, ..._rest) {
            super();
            this.a = null;
            this.c = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.a = stringToCharArray(Environment.newLine);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.a = stringToCharArray(Environment.newLine);
                        this.c = c;
                    }
                    break;
            }
        }
        get_b() {
            return this.c;
        }
        get b() {
            return this.get_b();
        }
        get_g() {
            return stringCreateFromCharArray(this.a);
        }
        set_g(a) {
            if (a == null) {
                a = Environment.newLine;
            }
            this.a = stringToCharArray(a);
        }
        get g() {
            return this.get_g();
        }
        set g(a) {
            this.set_g(a);
        }
        i() {
            this.dispose1(true);
        }
        dispose1(a) {
            if (a) {
            }
        }
        dispose() {
            this.dispose1(true);
        }
        k() {
        }
        static e(a) {
            return TextWriter.f(a, false);
        }
        static f(a, b) {
            if (a == null) {
                throw new ArgumentNullException(0, "writer is null");
            }
            if (typeCast(SynchronizedWriter.$, a) !== null) {
                return a;
            }
            return new SynchronizedWriter(1, a, b);
        }
        n(a) {
            this.v(a.toString());
        }
        o(a) {
        }
        l(a) {
            if (a == null) {
                return;
            }
            this.m(a, 0, a.length);
        }
        p(a) {
            this.v(numberToString(a, this.c));
        }
        q(a) {
            this.v(numberToString(a, this.c));
        }
        r(a) {
            this.v(numberToString(a, this.c));
        }
        s(a) {
            this.v(numberToString(a, this.c));
        }
        t(a) {
            if (a != null) {
                this.v(a.toString());
            }
        }
        u(a) {
            this.v(numberToString(a, this.c));
        }
        v(a) {
            if (a != null) {
                this.l(stringToCharArray(a));
            }
        }
        aa(a) {
            this.v(intToString(a, this.c));
        }
        ab(a) {
            this.v(numberToString(a, this.c));
        }
        x(a, b) {
            this.v(stringFormat(a, b));
        }
        w(a, ...b) {
            this.v(stringFormat1(a, ...b));
        }
        m(a, b, c) {
            if (a == null) {
                throw new ArgumentNullException(0, "buffer");
            }
            if (b < 0 || b > a.length) {
                throw new ArgumentOutOfRangeException(1, "index");
            }
            if (c < 0 || (b > a.length - c)) {
                throw new ArgumentOutOfRangeException(1, "count");
            }
            for (; c > 0; --c, ++b) {
                this.o(a[b]);
            }
        }
        y(a, b, c) {
            this.v(stringFormat(a, b, c));
        }
        z(a, b, c, d) {
            this.v(stringFormat(a, b, c, d));
        }
        ac() {
            this.l(this.a);
        }
        af(a) {
            this.n(a);
            this.ac();
        }
        ag(a) {
            this.o(a);
            this.ac();
        }
        ad(a) {
            this.l(a);
            this.ac();
        }
        ah(a) {
            this.p(a);
            this.ac();
        }
        ai(a) {
            this.q(a);
            this.ac();
        }
        aj(a) {
            this.r(a);
            this.ac();
        }
        ak(a) {
            this.s(a);
            this.ac();
        }
        al(a) {
            this.t(a);
            this.ac();
        }
        am(a) {
            this.u(a);
            this.ac();
        }
        an(a) {
            this.v(a);
            this.ac();
        }
        as(a) {
            this.aa(a);
            this.ac();
        }
        at(a) {
            this.ab(a);
            this.ac();
        }
        ap(a, b) {
            this.x(a, b);
            this.ac();
        }
        ao(a, ...b) {
            this.w(a, ...b);
            this.ac();
        }
        ae(a, b, c) {
            this.m(a, b, c);
            this.ac();
        }
        aq(a, b, c) {
            this.y(a, b, c);
            this.ac();
        }
        ar(a, b, c, d) {
            this.z(a, b, c, d);
            this.ac();
        }
    }
    TextWriter.$t = /*@__PURE__*/ markType(TextWriter, 'TextWriter', MarshalByRefObject.$, [IDisposable_$type]);
    TextWriter.d = null;
    return TextWriter;
})();
/**
 * @hidden
 */
let TextWriter_NullTextWriter = /*@__PURE__*/ (() => {
    class TextWriter_NullTextWriter extends TextWriter {
        constructor() {
            super(0);
        }
        get_h() {
            return Encoding.defaultValue;
        }
        get h() {
            return this.get_h();
        }
        v(a) {
        }
        o(a) {
        }
        m(a, b, c) {
        }
    }
    TextWriter_NullTextWriter.$t = /*@__PURE__*/ markType(TextWriter_NullTextWriter, 'TextWriter_NullTextWriter', TextWriter.$);
    return TextWriter_NullTextWriter;
})();
/**
 * @hidden
 */
let SynchronizedWriter = /*@__PURE__*/ (() => {
    class SynchronizedWriter extends TextWriter {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, false];
                        {
                            let f = d[0];
                            let g = d[1];
                            super(0);
                            this.av = null;
                            this.au = false;
                            this.av = f;
                            this.au = g;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(0);
                        this.av = null;
                        this.au = false;
                        this.av = c;
                        this.au = d;
                    }
                    break;
            }
        }
        i() {
            if (this.au) {
                return;
            }
            this.av.i();
        }
        k() {
            this.av.k();
        }
        n(a) {
            this.av.n(a);
        }
        o(a) {
            this.av.o(a);
        }
        l(a) {
            this.av.l(a);
        }
        p(a) {
            this.av.p(a);
        }
        r(a) {
            this.av.r(a);
        }
        s(a) {
            this.av.s(a);
        }
        t(a) {
            this.av.t(a);
        }
        u(a) {
            this.av.u(a);
        }
        v(a) {
            this.av.v(a);
        }
        aa(a) {
            this.av.aa(a);
        }
        ab(a) {
            this.av.ab(a);
        }
        x(a, b) {
            this.av.x(a, b);
        }
        w(a, ...b) {
            this.av.w(a, ...b);
        }
        m(a, b, c) {
            this.av.m(a, b, c);
        }
        y(a, b, c) {
            this.av.y(a, b, c);
        }
        z(a, b, c, d) {
            this.av.z(a, b, c, d);
        }
        ac() {
            this.av.ac();
        }
        af(a) {
            this.av.af(a);
        }
        ag(a) {
            this.av.ag(a);
        }
        ad(a) {
            this.av.ad(a);
        }
        ah(a) {
            this.av.ah(a);
        }
        ai(a) {
            this.av.ai(a);
        }
        aj(a) {
            this.av.aj(a);
        }
        ak(a) {
            this.av.ak(a);
        }
        al(a) {
            this.av.al(a);
        }
        am(a) {
            this.av.am(a);
        }
        an(a) {
            this.av.an(a);
        }
        as(a) {
            this.av.as(a);
        }
        at(a) {
            this.av.at(a);
        }
        ap(a, b) {
            this.av.ap(a, b);
        }
        ao(a, ...b) {
            this.av.ao(a, ...b);
        }
        ae(a, b, c) {
            this.av.ae(a, b, c);
        }
        aq(a, b, c) {
            this.av.aq(a, b, c);
        }
        ar(a, b, c, d) {
            this.av.ar(a, b, c, d);
        }
        get_h() {
            return this.av.h;
        }
        get h() {
            return this.get_h();
        }
        get_b() {
            return this.av.b;
        }
        get_g() {
            return this.av.g;
        }
        set_g(a) {
            this.av.g = a;
        }
    }
    SynchronizedWriter.$t = /*@__PURE__*/ markType(SynchronizedWriter, 'SynchronizedWriter', TextWriter.$);
    return SynchronizedWriter;
})();
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

//
/**
 * @hidden
 */
let StreamWriter = /*@__PURE__*/ (() => {
    class StreamWriter extends TextWriter {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, Encoding.uTF8Unmarked, 1024];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = d[2];
                            super(0);
                            this.a8 = null;
                            this.a6 = null;
                            this.ay = false;
                            this.au = null;
                            this.a0 = 0;
                            this.av = null;
                            this.a1 = 0;
                            this.ax = false;
                            this.az = false;
                            if (null == f) {
                                throw new ArgumentNullException(0, "stream");
                            }
                            if (null == g) {
                                throw new ArgumentNullException(0, "encoding");
                            }
                            if (h <= 0) {
                                throw new ArgumentOutOfRangeException(1, "bufferSize");
                            }
                            if (!f.canWrite) {
                                throw new ArgumentException(1, "Can not write to stream");
                            }
                            this.a6 = f;
                            this.bb(g, h);
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [c, d, 1024];
                        {
                            let g = e[0];
                            let h = e[1];
                            let i = e[2];
                            super(0);
                            this.a8 = null;
                            this.a6 = null;
                            this.ay = false;
                            this.au = null;
                            this.a0 = 0;
                            this.av = null;
                            this.a1 = 0;
                            this.ax = false;
                            this.az = false;
                            if (null == g) {
                                throw new ArgumentNullException(0, "stream");
                            }
                            if (null == h) {
                                throw new ArgumentNullException(0, "encoding");
                            }
                            if (i <= 0) {
                                throw new ArgumentOutOfRangeException(1, "bufferSize");
                            }
                            if (!g.canWrite) {
                                throw new ArgumentException(1, "Can not write to stream");
                            }
                            this.a6 = g;
                            this.bb(h, i);
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        super(0);
                        this.a8 = null;
                        this.a6 = null;
                        this.ay = false;
                        this.au = null;
                        this.a0 = 0;
                        this.av = null;
                        this.a1 = 0;
                        this.ax = false;
                        this.az = false;
                        if (null == c) {
                            throw new ArgumentNullException(0, "stream");
                        }
                        if (null == d) {
                            throw new ArgumentNullException(0, "encoding");
                        }
                        if (e <= 0) {
                            throw new ArgumentOutOfRangeException(1, "bufferSize");
                        }
                        if (!c.canWrite) {
                            throw new ArgumentException(1, "Can not write to stream");
                        }
                        this.a6 = c;
                        this.bb(d, e);
                    }
                    break;
            }
        }
        bb(a, b) {
            this.a8 = a;
            this.a1 = this.a0 = 0;
            let c = Math.max(b, 256);
            this.av = new Array(c);
            this.au = new Array(a.getMaxByteCount(c));
            if (this.a6.canSeek && this.a6.position > 0) {
                this.az = true;
            }
        }
        get_aw() {
            return this.ay;
        }
        set_aw(a) {
            this.ay = a;
            if (this.ay) {
                this.k();
            }
        }
        get aw() {
            return this.get_aw();
        }
        set aw(a) {
            this.set_aw(a);
        }
        get_a5() {
            return this.a6;
        }
        get a5() {
            return this.get_a5();
        }
        get_h() {
            return this.a8;
        }
        get h() {
            return this.get_h();
        }
        dispose1(a) {
            let b = null;
            if (!this.ax && a && this.a6 != null) {
                try {
                    this.k();
                }
                catch (c) {
                    b = c;
                }
                this.ax = true;
                try {
                    this.a6.close();
                }
                catch (d) {
                    if (b == null) {
                        b = d;
                    }
                }
            }
            this.a6 = null;
            this.au = null;
            this.a8 = null;
            this.av = null;
            if (b != null) {
                throw b;
            }
        }
        k() {
            if (this.ax) {
                throw new ObjectDisposedException(0, "StreamWriter");
            }
            this.a9();
            if (this.a0 > 0) {
                this.ba();
                this.a6.flush();
            }
        }
        ba() {
            if (!this.az && this.a0 > 0) {
                let a = this.a8.getPreamble();
                if (a.length > 0) {
                    this.a6.write(a, 0, a.length);
                }
                this.az = true;
            }
            this.a6.write(this.au, 0, this.a0);
            this.a0 = 0;
        }
        a9() {
            if (this.a0 > 0) {
                this.ba();
            }
            if (this.a1 > 0) {
                let a = this.a8.getBytes2(this.av, 0, this.a1, this.au, this.a0);
                this.a0 += a;
                this.a1 = 0;
            }
        }
        m(a, b, c) {
            if (this.ax) {
                throw new ObjectDisposedException(0, "StreamWriter");
            }
            if (a == null) {
                throw new ArgumentNullException(0, "buffer");
            }
            if (b < 0) {
                throw new ArgumentOutOfRangeException(2, "index", "< 0");
            }
            if (c < 0) {
                throw new ArgumentOutOfRangeException(2, "count", "< 0");
            }
            if (b > a.length - c) {
                throw new ArgumentException(1, "index + count > buffer.Length");
            }
            this.bc(a, b, c);
            if (this.ay) {
                this.k();
            }
        }
        bc(a, b, c) {
            while (c > 0) {
                let d = this.av.length - this.a1;
                if (d == 0) {
                    this.a9();
                    d = this.av.length;
                }
                if (d > c) {
                    d = c;
                }
                arrayCopy1(a, b, this.av, this.a1, d);
                c -= d;
                b += d;
                this.a1 += d;
            }
        }
        bd(a) {
            let b = a.length;
            let c = 0;
            while (b > 0) {
                let d = this.av.length - this.a1;
                if (d == 0) {
                    this.a9();
                    d = this.av.length;
                }
                if (d > b) {
                    d = b;
                }
                for (let e = 0; e < d; e++) {
                    this.av[e + this.a1] = a.charAt(e + c);
                }
                b -= d;
                c += d;
                this.a1 += d;
            }
        }
        o(a) {
            if (this.ax) {
                throw new ObjectDisposedException(0, "StreamWriter");
            }
            if (this.a1 >= this.av.length) {
                this.a9();
            }
            this.av[this.a1++] = a;
            if (this.ay) {
                this.k();
            }
        }
        l(a) {
            if (this.ax) {
                throw new ObjectDisposedException(0, "StreamWriter");
            }
            if (a != null) {
                this.bc(a, 0, a.length);
            }
            if (this.ay) {
                this.k();
            }
        }
        v(a) {
            if (this.ax) {
                throw new ObjectDisposedException(0, "StreamWriter");
            }
            if (a != null) {
                this.bd(a);
            }
            if (this.ay) {
                this.k();
            }
        }
        i() {
            this.dispose1(true);
        }
    }
    StreamWriter.$t = /*@__PURE__*/ markType(StreamWriter, 'StreamWriter', TextWriter.$);
    StreamWriter.a7 = /*@__PURE__*/ new StreamWriter(2, /*@__PURE__*/ new NullStream(), Encoding.uTF8Unmarked, 1);
    return StreamWriter;
})();

//
/**
 * @hidden
 */
let StringReader = /*@__PURE__*/ (() => {
    class StringReader extends TextReader {
        constructor(a) {
            super();
            this.m = null;
            this.k = 0;
            this.l = 0;
            if (a == null) {
                throw new ArgumentNullException(0, "s");
            }
            this.m = a;
            this.k = 0;
            this.l = a.length;
        }
        i() {
            this.dispose1(true);
        }
        dispose1(a) {
            this.m = null;
            super.dispose1(a);
        }
        a() {
            this.n();
            if (this.k >= this.l) {
                return -1;
            }
            else {
                return this.m.charAt(this.k).charCodeAt(0);
            }
        }
        b() {
            this.n();
            if (this.k >= this.l) {
                return -1;
            }
            else {
                return this.m.charAt(this.k++).charCodeAt(0);
            }
        }
        c(a, b, c) {
            this.n();
            if (a == null) {
                throw new ArgumentNullException(0, "buffer");
            }
            if (a.length - b < c) {
                throw new ArgumentException(1, stringEmpty());
            }
            if (b < 0 || c < 0) {
                throw new ArgumentOutOfRangeException(0);
            }
            let d;
            if (this.k > this.l - c) {
                d = this.l - this.k;
            }
            else {
                d = c;
            }
            stringCopyToCharArray(this.m, this.k, a, b, d);
            this.k += d;
            return d;
        }
        g() {
            this.n();
            if (this.k >= this.m.length) {
                return null;
            }
            let a = this.m.indexOf('\r', this.k);
            let b = this.m.indexOf('\n', this.k);
            let c;
            let d = false;
            if (a == -1) {
                if (b == -1) {
                    return this.h();
                }
                c = b;
            }
            else if (b == -1) {
                c = a;
            }
            else {
                c = (a > b) ? b : a;
                d = (a + 1 == b);
            }
            let e = this.m.substr(this.k, c - this.k);
            this.k = c + ((d) ? 2 : 1);
            return e;
        }
        h() {
            this.n();
            let a = this.m.substr(this.k, this.l - this.k);
            this.k = this.l;
            return a;
        }
        n() {
            if (this.m == null) {
                throw new ObjectDisposedException(1, "StringReader", "Cannot read from a closed StringReader");
            }
        }
    }
    StringReader.$t = /*@__PURE__*/ markType(StringReader, 'StringReader', TextReader.$);
    return StringReader;
})();

//
/**
 * @hidden
 */
let StringWriter = /*@__PURE__*/ (() => {
    class StringWriter extends TextWriter {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [new StringBuilder(0)];
                        {
                            let e = c[0];
                            let f = [e, null];
                            {
                                let h = f[0];
                                let i = f[1];
                                super(0);
                                this.aw = null;
                                this.au = false;
                                if (h == null) {
                                    throw new ArgumentNullException(0, "sb");
                                }
                                this.aw = h;
                                this.c = i;
                            }
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = [new StringBuilder(0), c];
                        {
                            let f = d[0];
                            let g = d[1];
                            super(0);
                            this.aw = null;
                            this.au = false;
                            if (f == null) {
                                throw new ArgumentNullException(0, "sb");
                            }
                            this.aw = f;
                            this.c = g;
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = [c, null];
                        {
                            let f = d[0];
                            let g = d[1];
                            super(0);
                            this.aw = null;
                            this.au = false;
                            if (f == null) {
                                throw new ArgumentNullException(0, "sb");
                            }
                            this.aw = f;
                            this.c = g;
                        }
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(0);
                        this.aw = null;
                        this.au = false;
                        if (c == null) {
                            throw new ArgumentNullException(0, "sb");
                        }
                        this.aw = c;
                        this.c = d;
                    }
                    break;
            }
        }
        get_h() {
            return Encoding.unicode;
        }
        get h() {
            return this.get_h();
        }
        i() {
            this.dispose1(true);
            this.au = true;
        }
        dispose1(a) {
            super.dispose1(a);
            this.au = true;
        }
        av() {
            return this.aw;
        }
        toString() {
            return this.aw.toString();
        }
        o(a) {
            if (this.au) {
                throw new ObjectDisposedException(1, "StringReader", Locale.a("Cannot write to a closed StringWriter"));
            }
            this.aw.h(a);
        }
        v(a) {
            if (this.au) {
                throw new ObjectDisposedException(1, "StringReader", Locale.a("Cannot write to a closed StringWriter"));
            }
            this.aw.l(a);
        }
        m(a, b, c) {
            if (this.au) {
                throw new ObjectDisposedException(1, "StringReader", Locale.a("Cannot write to a closed StringWriter"));
            }
            if (a == null) {
                throw new ArgumentNullException(0, "buffer");
            }
            if (b < 0) {
                throw new ArgumentOutOfRangeException(2, "index", "< 0");
            }
            if (c < 0) {
                throw new ArgumentOutOfRangeException(2, "count", "< 0");
            }
            if (b > a.length - c) {
                throw new ArgumentException(1, "index + count > buffer.Length");
            }
            this.aw.g(a, b, c);
        }
    }
    StringWriter.$t = /*@__PURE__*/ markType(StringWriter, 'StringWriter', TextWriter.$);
    return StringWriter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

//
/**
 * @hidden
 */
let DecoderFallbackBuffer = /*@__PURE__*/ (() => {
    class DecoderFallbackBuffer extends Base {
        constructor() {
            super();
        }
        e() {
        }
    }
    DecoderFallbackBuffer.$t = /*@__PURE__*/ markType(DecoderFallbackBuffer, 'DecoderFallbackBuffer');
    return DecoderFallbackBuffer;
})();

//
/**
 * @hidden
 */
let DecoderFallbackException = /*@__PURE__*/ (() => {
    class DecoderFallbackException extends ArgumentException {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [null];
                        {
                            let e = c[0];
                            super(1, e);
                            this.c = null;
                            this.e = -1;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                        this.c = null;
                        this.e = -1;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(3, c, d);
                        this.c = null;
                        this.e = -1;
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        super(1, c);
                        this.c = null;
                        this.e = -1;
                        this.c = d;
                        this.e = e;
                    }
                    break;
            }
        }
        get bytesUnknown() {
            return this.c;
        }
        get index() {
            return this.e;
        }
    }
    DecoderFallbackException.$t = /*@__PURE__*/ markType(DecoderFallbackException, 'DecoderFallbackException', ArgumentException.$);
    return DecoderFallbackException;
})();

//
/**
 * @hidden
 */
let DecoderExceptionFallbackBuffer = /*@__PURE__*/ (() => {
    class DecoderExceptionFallbackBuffer extends DecoderFallbackBuffer {
        constructor() {
            super();
        }
        get_d() {
            return 0;
        }
        get d() {
            return this.get_d();
        }
        a(a, b) {
            throw new DecoderFallbackException(3, null, a, b);
        }
        c() {
            return charMinValue();
        }
        b() {
            return false;
        }
    }
    DecoderExceptionFallbackBuffer.$t = /*@__PURE__*/ markType(DecoderExceptionFallbackBuffer, 'DecoderExceptionFallbackBuffer', DecoderFallbackBuffer.$);
    return DecoderExceptionFallbackBuffer;
})();

//
/**
 * @hidden
 */
let DecoderFallback = /*@__PURE__*/ (() => {
    class DecoderFallback extends Base {
        static staticInit() {
            DecoderFallback.b = new DecoderExceptionFallback();
            DecoderFallback.d = new DecoderReplacementFallback(0);
            DecoderFallback.f = new DecoderReplacementFallback(1, "�");
        }
        constructor() {
            super();
        }
        static get c() {
            return DecoderFallback.b;
        }
        static get e() {
            return DecoderFallback.d;
        }
        static get g() {
            return DecoderFallback.f;
        }
    }
    DecoderFallback.$t = /*@__PURE__*/ markType(DecoderFallback, 'DecoderFallback');
    DecoderFallback.b = null;
    DecoderFallback.d = null;
    DecoderFallback.f = null;
    return DecoderFallback;
})();
/**
 * @hidden
 */
let DecoderExceptionFallback = /*@__PURE__*/ (() => {
    class DecoderExceptionFallback extends DecoderFallback {
        constructor() {
            super();
        }
        get_a() {
            return 0;
        }
        get a() {
            return this.get_a();
        }
        h() {
            return new DecoderExceptionFallbackBuffer();
        }
        equals(a) {
            return (typeCast(DecoderExceptionFallback.$, a) !== null);
        }
        getHashCode() {
            return 0;
        }
    }
    DecoderExceptionFallback.$t = /*@__PURE__*/ markType(DecoderExceptionFallback, 'DecoderExceptionFallback', DecoderFallback.$);
    return DecoderExceptionFallback;
})();
/**
 * @hidden
 */
let DecoderReplacementFallback = /*@__PURE__*/ (() => {
    class DecoderReplacementFallback extends DecoderFallback {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = ["?"];
                        {
                            let e = c[0];
                            super();
                            this.j = null;
                            if (e == null) {
                                throw new ArgumentNullException(0, "replacement");
                            }
                            this.j = e;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super();
                        this.j = null;
                        if (c == null) {
                            throw new ArgumentNullException(0, "replacement");
                        }
                        this.j = c;
                    }
                    break;
            }
        }
        get i() {
            return this.j;
        }
        get_a() {
            return this.j.length;
        }
        get a() {
            return this.get_a();
        }
        h() {
            return new DecoderReplacementFallbackBuffer(this);
        }
        equals(a) {
            let b = typeCast(DecoderReplacementFallback.$, a);
            return b != null && this.j == b.j;
        }
        getHashCode() {
            return Base.getHashCodeStatic(this.j);
        }
    }
    DecoderReplacementFallback.$t = /*@__PURE__*/ markType(DecoderReplacementFallback, 'DecoderReplacementFallback', DecoderFallback.$);
    return DecoderReplacementFallback;
})();
/**
 * @hidden
 */
let DecoderReplacementFallbackBuffer = /*@__PURE__*/ (() => {
    class DecoderReplacementFallbackBuffer extends DecoderFallbackBuffer {
        constructor(a) {
            super();
            this.f = false;
            this.g = 0;
            this.h = null;
            if (a == null) {
                throw new ArgumentNullException(0, "fallback");
            }
            this.h = a.i;
            this.g = 0;
        }
        get_d() {
            return this.f ? this.h.length - this.g : 0;
        }
        get d() {
            return this.get_d();
        }
        a(a, b) {
            if (a == null) {
                throw new ArgumentNullException(0, "bytesUnknown");
            }
            if (this.f && this.d != 0) {
                throw new ArgumentException(1, "Reentrant Fallback method invocation occured. It might be because either this FallbackBuffer is incorrectly shared by multiple threads, invoked inside Encoding recursively, or Reset invocation is forgotten.");
            }
            if (b < 0 || a.length < b) {
                throw new ArgumentOutOfRangeException(1, "index");
            }
            this.f = true;
            this.g = 0;
            return this.h.length > 0;
        }
        c() {
            if (!this.f) {
                return '\0';
            }
            if (this.g >= this.h.length) {
                return charMinValue();
            }
            return this.h.charAt(this.g++);
        }
        b() {
            if (this.g == 0) {
                return false;
            }
            this.g--;
            return true;
        }
        e() {
            this.f = false;
            this.g = 0;
        }
    }
    DecoderReplacementFallbackBuffer.$t = /*@__PURE__*/ markType(DecoderReplacementFallbackBuffer, 'DecoderReplacementFallbackBuffer', DecoderFallbackBuffer.$);
    return DecoderReplacementFallbackBuffer;
})();
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DTDObjectModel = /*@__PURE__*/ (() => {
    class DTDObjectModel extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
            this.c = null;
            this.d = null;
            this.a = null;
        }
    }
    DTDObjectModel.$t = /*@__PURE__*/ markType(DTDObjectModel, 'DTDObjectModel');
    return DTDObjectModel;
})();

// From: https://github.com/mosa/Mono-Class-Libraries/blob/28840dee90750d61ed6cbdb753292cd64cac169e/mcs/class/System.XML/System.Xml/EntityHandling.cs
/**
 */
var EntityHandling = /*@__PURE__*/ (function (EntityHandling) {
    /**
     */
    EntityHandling[EntityHandling["ExpandEntities"] = 1] = "ExpandEntities";
    /**
     */
    EntityHandling[EntityHandling["ExpandCharEntities"] = 2] = "ExpandCharEntities";
    return EntityHandling;
})({});
/**
 * @hidden
 */
let EntityHandling_$type = /*@__PURE__*/ markEnum('EntityHandling', 'ExpandEntities,1|ExpandCharEntities,2');

// Formatting.cs
/**
 */
var Formatting = /*@__PURE__*/ (function (Formatting) {
    /**
     */
    Formatting[Formatting["None"] = 0] = "None";
    /**
     */
    Formatting[Formatting["Indented"] = 1] = "Indented";
    return Formatting;
})({});
/**
 * @hidden
 */
let Formatting_$type = /*@__PURE__*/ markEnum('Formatting', 'None,0|Indented,1');

//
/**
 * @hidden
 */
let IXmlLineInfo_$type = /*@__PURE__*/ new Type(null, 'IXmlLineInfo');

//
/**
 * @hidden
 */
let IXmlNamespaceResolver_$type = /*@__PURE__*/ new Type(null, 'IXmlNamespaceResolver');

// From: https://github.com/mosa/Mono-Class-Libraries/blob/28840dee90750d61ed6cbdb753292cd64cac169e/mcs/class/System.XML/System.Xml/NamespaceHandling.cs
/**
 * @hidden
 */
let NamespaceHandling_$type = /*@__PURE__*/ markEnum('NamespaceHandling', 'Default,0|OmitDuplicates,1');

// -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*-
/**
 * @hidden
 */
let XmlNameTable = /*@__PURE__*/ (() => {
    class XmlNameTable extends Base {
    }
    XmlNameTable.$t = /*@__PURE__*/ markType(XmlNameTable, 'XmlNameTable');
    return XmlNameTable;
})();

//
/**
 * @hidden
 */
let NameTable_Entry = /*@__PURE__*/ (() => {
    class NameTable_Entry extends Base {
        constructor(a, b, c) {
            super();
            this.c = null;
            this.a = 0;
            this.b = 0;
            this.d = null;
            this.c = a;
            this.b = a.length;
            this.a = b;
            this.d = c;
        }
    }
    NameTable_Entry.$t = /*@__PURE__*/ markType(NameTable_Entry, 'NameTable_Entry');
    return NameTable_Entry;
})();

//
/**
 * @hidden
 */
let NameTable = /*@__PURE__*/ (() => {
    class NameTable extends XmlNameTable {
        constructor() {
            super();
            this.g = 128;
            this.e = new Array(128);
            this.i = 0;
        }
        a(a, b, c) {
            if (((0 > b) && (b >= a.length)) || ((0 > c) && (c >= a.length - c))) {
                throw new IndexOutOfRangeException(1, "The Index is out of range.");
            }
            if (c == 0) {
                return stringEmpty();
            }
            let d = 0;
            let e = b + c;
            for (let f = b; f < e; f++) {
                d = (d << 5) - d + a[f].charCodeAt(0);
            }
            d &= 2147483647;
            for (let g = this.e[d % this.g]; g != null; g = g.d) {
                if (g.a == d && g.b == c && NameTable.f(g.c, a, b)) {
                    return g.c;
                }
            }
            return this.j(stringCreateFromCharArraySlice(a, b, c), d);
        }
        b(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "key");
            }
            let b = a.length;
            if (b == 0) {
                return stringEmpty();
            }
            let c = 0;
            for (let d = 0; d < b; d++) {
                c = (c << 5) - c + a.charAt(d).charCodeAt(0);
            }
            c &= 2147483647;
            for (let e = this.e[c % this.g]; e != null; e = e.d) {
                if (e.a == c && e.b == a.length && e.c == a) {
                    return e.c;
                }
            }
            return this.j(a, c);
        }
        c(a, b, c) {
            if (((0 > b) && (b >= a.length)) || ((0 > c) && (c >= a.length - c))) {
                throw new IndexOutOfRangeException(1, "The Index is out of range.");
            }
            if (c == 0) {
                return stringEmpty();
            }
            let d = 0;
            let e = b + c;
            for (let f = b; f < e; f++) {
                d = (d << 5) - d + a[f].charCodeAt(0);
            }
            d &= 2147483647;
            for (let g = this.e[d % this.g]; g != null; g = g.d) {
                if (g.a == d && g.b == c && NameTable.f(g.c, a, b)) {
                    return g.c;
                }
            }
            return null;
        }
        d(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "value");
            }
            let b = a.length;
            if (b == 0) {
                return stringEmpty();
            }
            let c = 0;
            for (let d = 0; d < b; d++) {
                c = (c << 5) - c + a.charAt(d).charCodeAt(0);
            }
            c &= 2147483647;
            for (let e = this.e[c % this.g]; e != null; e = e.d) {
                if (e.a == c && e.b == a.length && e.c == a) {
                    return e.c;
                }
            }
            return null;
        }
        j(a, b) {
            let c = b % this.g;
            this.e[c] = new NameTable_Entry(a, b, this.e[c]);
            if (this.i++ == this.g) {
                this.g <<= 1;
                let d = this.g - 1;
                let e = new Array(this.g);
                for (let f = 0; f < this.e.length; f++) {
                    let g = this.e[f];
                    let h = g;
                    while (h != null) {
                        let i = h.a & d;
                        let j = h.d;
                        h.d = e[i];
                        e[i] = h;
                        h = j;
                    }
                }
                this.e = e;
            }
            return a;
        }
        static f(a, b, c) {
            let d = a.length;
            d--;
            c += d;
            do {
                if (a.charAt(d) != b[c]) {
                    return false;
                }
                d--;
                c--;
            } while (d >= 0);
            return true;
        }
    }
    NameTable.$t = /*@__PURE__*/ markType(NameTable, 'NameTable', XmlNameTable.$);
    return NameTable;
})();

// From: https://github.com/mosa/Mono-Class-Libraries/blob/28840dee90750d61ed6cbdb753292cd64cac169e/mcs/class/System.XML/System.Xml/NewLineHandling.cs
/**
 * @hidden
 */
let NewLineHandling_$type = /*@__PURE__*/ markEnum('NewLineHandling', 'Replace,0|Entitize,1|None,2');

// ReadState.cs
/**
 */
var ReadState = /*@__PURE__*/ (function (ReadState) {
    /**
     */
    ReadState[ReadState["Initial"] = 0] = "Initial";
    /**
     */
    ReadState[ReadState["Interactive"] = 1] = "Interactive";
    /**
     */
    ReadState[ReadState["Error"] = 2] = "Error";
    /**
     */
    ReadState[ReadState["EndOfFile"] = 3] = "EndOfFile";
    /**
     */
    ReadState[ReadState["Closed"] = 4] = "Closed";
    return ReadState;
})({});
/**
 * @hidden
 */
let ReadState_$type = /*@__PURE__*/ markEnum('ReadState', 'Initial,0|Interactive,1|Error,2|EndOfFile,3|Closed,4');

// WhitespaceHandling.cs
/**
 */
var WhitespaceHandling = /*@__PURE__*/ (function (WhitespaceHandling) {
    /**
     */
    WhitespaceHandling[WhitespaceHandling["All"] = 0] = "All";
    /**
     */
    WhitespaceHandling[WhitespaceHandling["Significant"] = 1] = "Significant";
    /**
     */
    WhitespaceHandling[WhitespaceHandling["None"] = 2] = "None";
    return WhitespaceHandling;
})({});
/**
 * @hidden
 */
let WhitespaceHandling_$type = /*@__PURE__*/ markEnum('WhitespaceHandling', 'All,0|Significant,1|None,2');

// -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*-
/**
 */
var WriteState = /*@__PURE__*/ (function (WriteState) {
    /**
     * A write method has not been called.
     */
    WriteState[WriteState["Start"] = 0] = "Start";
    /**
     * The prolog is being written.
     */
    WriteState[WriteState["Prolog"] = 1] = "Prolog";
    /**
     * An element start tag is being written.
     */
    WriteState[WriteState["Element"] = 2] = "Element";
    /**
     * An attribute is being written.
     */
    WriteState[WriteState["Attribute"] = 3] = "Attribute";
    /**
     * Element content is being written.
     */
    WriteState[WriteState["Content"] = 4] = "Content";
    /**
     * The close method has been called.
     */
    WriteState[WriteState["Closed"] = 5] = "Closed";
    return WriteState;
})({});
/**
 * @hidden
 */
let WriteState_$type = /*@__PURE__*/ markEnum('WriteState', 'Start,0|Prolog,1|Element,2|Attribute,3|Content,4|Closed,5');

// -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*-
/**
 * @hidden
 */
let XmlChar = /*@__PURE__*/ (() => {
    class XmlChar extends Base {
        static p(a) {
            return a == 32 || a == 9 || a == 13 || a == 10;
        }
        static q(a) {
            for (let b = 0; b < a.length; b++) {
                if (!XmlChar.p(a.charAt(b).charCodeAt(0))) {
                    return false;
                }
            }
            return true;
        }
        static u(a) {
            for (let b = 0; b < a.length; b++) {
                if (!XmlChar.p(a.charAt(b).charCodeAt(0))) {
                    return b;
                }
            }
            return -1;
        }
        static e(a) {
            if ((a >= 'a'.charCodeAt(0) && a <= 'z'.charCodeAt(0)) || (a >= 'A'.charCodeAt(0) && a <= 'Z'.charCodeAt(0))) {
                return true;
            }
            else if (intSToU(a) <= 65535) {
                return (u32BitwiseAnd(XmlChar.b[(XmlChar.a[a >> 8] << 3) + ((a & 255) >> 5)], (1 << (a & 31)))) != 0;
            }
            return false;
        }
        static n(a) {
            return !XmlChar.f(a);
        }
        static f(a) {
            switch (a) {
                case 9:
                case 10:
                case 13: return false;
            }
            if (a < 32) {
                return true;
            }
            if (a < 55296) {
                return false;
            }
            if (a < 57344) {
                return true;
            }
            if (a < 65534) {
                return false;
            }
            if (a < 65536) {
                return true;
            }
            if (a < 1114112) {
                return false;
            }
            else {
                return true;
            }
        }
        static t(a, b) {
            for (let c = 0; c < a.length; c++) {
                if (XmlChar.f(a.charAt(c).charCodeAt(0))) {
                    if (!b || c + 1 == a.length || a.charAt(c).charCodeAt(0) < '\ud800'.charCodeAt(0) || a.charAt(c).charCodeAt(0) >= '\udc00'.charCodeAt(0) || a.charAt(c + 1).charCodeAt(0) < '\udc00'.charCodeAt(0) || a.charAt(c + 1).charCodeAt(0) >= ''.charCodeAt(0)) {
                        return c;
                    }
                    c++;
                }
            }
            return -1;
        }
        static s(a, b, c, d) {
            let e = b + c;
            if (a.length < e) {
                throw new ArgumentOutOfRangeException(1, "length");
            }
            for (let f = b; f < e; f++) {
                if (XmlChar.f(a[f].charCodeAt(0))) {
                    if (!d || f + 1 == e || a[f].charCodeAt(0) < '\ud800'.charCodeAt(0) || a[f].charCodeAt(0) >= '\udc00'.charCodeAt(0) || a[f + 1].charCodeAt(0) < '\udc00'.charCodeAt(0) || a[f + 1].charCodeAt(0) >= ''.charCodeAt(0)) {
                        return f;
                    }
                    f++;
                }
            }
            return -1;
        }
        static h(a) {
            if ((a >= 'a'.charCodeAt(0) && a <= 'z'.charCodeAt(0)) || (a >= 'A'.charCodeAt(0) && a <= 'Z'.charCodeAt(0))) {
                return true;
            }
            else if (intSToU(a) <= 65535) {
                return (u32BitwiseAnd(XmlChar.b[(XmlChar.c[a >> 8] << 3) + ((a & 255) >> 5)], (1 << (a & 31)))) != 0;
            }
            else {
                return false;
            }
        }
        static j(a) {
            let b = false;
            if (a >= 0 && a <= 65535 && a != ':'.charCodeAt(0)) {
                b = (u32BitwiseAnd(XmlChar.b[(XmlChar.c[a >> 8] << 3) + ((a & 255) >> 5)], (1 << (a & 31)))) != 0;
            }
            return b;
        }
        static g(a) {
            if (a.length == 0) {
                return false;
            }
            if (!XmlChar.e(a.charAt(0).charCodeAt(0))) {
                return false;
            }
            for (let b = 1; b < a.length; b++) {
                if (!XmlChar.h(a.charAt(b).charCodeAt(0))) {
                    return false;
                }
            }
            return true;
        }
        static i(a) {
            if (a.length == 0) {
                return false;
            }
            if (!XmlChar.e(a.charAt(0).charCodeAt(0))) {
                return false;
            }
            for (let b = 0; b < a.length; b++) {
                if (!XmlChar.j(a.charAt(b).charCodeAt(0))) {
                    return false;
                }
            }
            return true;
        }
        static k(a) {
            if (a.length == 0) {
                return false;
            }
            for (let b = 0; b < a.length; b++) {
                if (!XmlChar.h(a.charAt(b).charCodeAt(0))) {
                    return false;
                }
            }
            return true;
        }
        static m(a) {
            return (XmlChar.p(a) && a != '\t'.charCodeAt(0)) || ('a'.charCodeAt(0) <= a && a <= 'z'.charCodeAt(0)) || ('A'.charCodeAt(0) <= a && a <= 'Z'.charCodeAt(0)) || ('0'.charCodeAt(0) <= a && a <= '9'.charCodeAt(0)) || (("-'()+,./:=?;!*#@$_%").indexOf(String.fromCharCode(a)) >= 0);
        }
        static l(a) {
            for (let b = 0; b < a.length; b++) {
                if (!XmlChar.m(a.charAt(b).charCodeAt(0))) {
                    return false;
                }
            }
            return true;
        }
        static o(a) {
            if (a != null) {
                let b = a.length;
                if (b > 0) {
                    let c = a.charAt(0);
                    if ((c.charCodeAt(0) >= 'A'.charCodeAt(0) && c.charCodeAt(0) <= 'Z'.charCodeAt(0)) || (c.charCodeAt(0) >= 'a'.charCodeAt(0) && c.charCodeAt(0) <= 'z'.charCodeAt(0))) {
                        for (let d = 1; d < b; d++) {
                            c = a.charAt(d);
                            if ((c.charCodeAt(0) < 'A'.charCodeAt(0) || c.charCodeAt(0) > 'Z'.charCodeAt(0)) && (c.charCodeAt(0) < 'a'.charCodeAt(0) || c.charCodeAt(0) > 'z'.charCodeAt(0)) && (c.charCodeAt(0) < '0'.charCodeAt(0) || c.charCodeAt(0) > '9'.charCodeAt(0)) && c != '.' && c != '_' && c != '-') {
                                return false;
                            }
                        }
                        return true;
                    }
                }
            }
            return false;
        }
        static r(a) {
            switch (a) {
                case "amp": return '&'.charCodeAt(0);
                case "lt": return '<'.charCodeAt(0);
                case "gt": return '>'.charCodeAt(0);
                case "quot": return '\"'.charCodeAt(0);
                case "apos": return '\''.charCodeAt(0);
                default: return -1;
            }
        }
    }
    XmlChar.$t = /*@__PURE__*/ markType(XmlChar, 'XmlChar');
    XmlChar.d = [' ', '\n', '\t', '\r'];
    XmlChar.a = [2, 3, 4, 5, 6, 7, 8, 0, 0, 9, 10, 11, 12, 13, 14, 15, 16, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 19, 0, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
    XmlChar.c = [25, 3, 26, 27, 28, 29, 30, 0, 0, 31, 32, 33, 34, 35, 36, 37, 16, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 19, 38, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
    XmlChar.b = [0, 0, 0, 0, 0, 0, 0, 0, 4294967295, 4294967295, 4294967295, 4294967295, 4294967295, 4294967295, 4294967295, 4294967295, 0, 67108864, 2281701374, 134217726, 0, 0, 4286578687, 4286578687, 4294967295, 2146697215, 4294966782, 2147483647, 4294967295, 4294967295, 4294959119, 4231135231, 16777215, 0, 4294901760, 4294967295, 4294967295, 4160750079, 3, 0, 0, 0, 0, 0, 4294956864, 4294967291, 1417641983, 1048573, 4294959102, 4294967295, 3758030847, 4294967295, 4294901763, 4294967295, 4294908319, 54513663, 0, 4294836224, 41943039, 4294967294, 127, 0, 4294901760, 460799, 0, 134217726, 2046, 4294836224, 4294967295, 2097151999, 3112959, 96, 4294967264, 603979775, 4278190080, 3, 4294549472, 63307263, 2952790016, 196611, 4294543328, 57540095, 1577058304, 1835008, 4294684640, 602799615, 0, 1, 4294549472, 600702463, 2952790016, 3, 3594373088, 62899992, 0, 0, 4294828000, 66059775, 0, 3, 4294828000, 66059775, 1073741824, 3, 4294828000, 67108351, 0, 3, 0, 0, 0, 0, 4294967294, 884735, 63, 0, 4277151126, 537750702, 31, 0, 0, 0, 4294967039, 1023, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4294967295, 4294901823, 8388607, 514797, 1342177280, 2184269825, 2908843, 1073741824, 4118857984, 7, 33622016, 4294967295, 4294967295, 4294967295, 4294967295, 268435455, 4294967295, 4294967295, 67108863, 1061158911, 4294967295, 2868854591, 1073741823, 4294967295, 1608515583, 265232348, 534519807, 0, 19520, 0, 0, 7, 0, 0, 0, 128, 1022, 4294967294, 4294967295, 2097151, 4294967294, 4294967295, 134217727, 4294967264, 8191, 0, 0, 0, 0, 0, 0, 4294967295, 4294967295, 4294967295, 4294967295, 4294967295, 63, 0, 0, 4294967295, 4294967295, 4294967295, 4294967295, 4294967295, 15, 0, 0, 0, 134176768, 2281701374, 134217726, 0, 8388608, 4286578687, 4286578687, 16777215, 0, 4294901760, 4294967295, 4294967295, 4160750079, 196611, 0, 4294967295, 4294967295, 63, 3, 4294956992, 4294967291, 1417641983, 1048573, 4294959102, 4294967295, 3758030847, 4294967295, 4294901883, 4294967295, 4294908319, 54513663, 0, 4294836224, 41943039, 4294967294, 4294836351, 3154116603, 4294901782, 460799, 0, 134217726, 524287, 4294902783, 4294967295, 2097151999, 4293885951, 67059199, 4294967278, 4093640703, 4280172543, 65487, 4294549486, 3552968191, 2961193375, 262095, 4294543332, 3547201023, 1577073031, 2097088, 4294684654, 4092460543, 15295, 65473, 4294549486, 4090363391, 2965387663, 65475, 3594373100, 3284125464, 8404423, 65408, 4294828014, 3287285247, 6307295, 65475, 4294828012, 3287285247, 1080049119, 65475, 4294828012, 3288333823, 8404431, 65475, 0, 0, 0, 0, 4294967294, 134184959, 67076095, 0, 4277151126, 1006595246, 67059551, 0, 50331648, 3265266687, 4294967039, 4294837247, 4273934303, 50216959, 0, 0, 0, 0, 0, 0, 0, 0, 536805376, 2, 160, 4128766, 4294967294, 4294967295, 1713373183, 4294967294, 4294967295, 2013265919];
    return XmlChar;
})();

//
/**
 * @hidden
 */
let XmlException = /*@__PURE__*/ (() => {
    class XmlException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(0);
                        this.d = 0;
                        this.f = 0;
                        this.i = null;
                        this.h = null;
                        this.c = null;
                        this.h = "Xml_DefaultException";
                        this.c = new Array(1);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(2, c, d);
                        this.d = 0;
                        this.f = 0;
                        this.i = null;
                        this.h = null;
                        this.c = null;
                        this.h = "Xml_UserException";
                        this.c = [c];
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        super(0);
                        this.d = 0;
                        this.f = 0;
                        this.i = null;
                        this.h = null;
                        this.c = null;
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        super(1, c);
                        this.d = 0;
                        this.f = 0;
                        this.i = null;
                        this.h = null;
                        this.c = null;
                        this.h = "Xml_UserException";
                        this.c = [c];
                    }
                    break;
                case 4:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = [c, d];
                        {
                            let i = g[0];
                            let j = g[1];
                            super(2, i, j);
                            this.d = 0;
                            this.f = 0;
                            this.i = null;
                            this.h = null;
                            this.c = null;
                            this.h = "Xml_UserException";
                            this.c = [i];
                        }
                        this.d = e;
                        this.f = f;
                    }
                    break;
            }
        }
        get lineNumber() {
            return this.d;
        }
        get linePosition() {
            return this.f;
        }
    }
    XmlException.$t = /*@__PURE__*/ markType(XmlException, 'XmlException', BaseError.$);
    return XmlException;
})();

//
/**
 * @hidden
 */
let XmlConvert = /*@__PURE__*/ (() => {
    class XmlConvert extends Base {
        constructor() {
            super();
        }
        static ap(a) {
            if (a == null || a.length < 6) {
                return a;
            }
            let b = '\uffff';
            try {
                b = String.fromCharCode(parseInt32_2(a.substr(1, 4), 515, CultureInfo.invariantCulture));
            }
            catch (c) {
                return a.charAt(0) + XmlConvert.s(a.substr(1));
            }
            if (a.length == 6) {
                return b.toString();
            }
            return b + XmlConvert.s(a.substr(6));
        }
        static s(a) {
            if (a == null || a.length == 0) {
                return a;
            }
            let b = a.indexOf('_');
            if (b == -1 || b + 6 >= a.length) {
                return a;
            }
            if ((a.charAt(b + 1) != 'X' && a.charAt(b + 1) != 'x') || a.charAt(b + 6) != '_') {
                return a.charAt(0) + XmlConvert.s(a.substr(1));
            }
            return a.substr(0, b) + XmlConvert.ap(a.substr(b + 1));
        }
        static u(a) {
            if (a == null) {
                return a;
            }
            let b = XmlConvert.v(a);
            let c = b.indexOf(':');
            if (c == -1) {
                return b;
            }
            return stringReplace(b, ":", "_x003A_");
        }
        static c(a, b) {
            if (a == ':') {
                return false;
            }
            if (b) {
                return !XmlChar.e(a.charCodeAt(0));
            }
            else {
                return !XmlChar.h(a.charCodeAt(0));
            }
        }
        static w(a, b) {
            if (a == null || a.length == 0) {
                return a;
            }
            let c = new StringBuilder(0);
            let d = a.length;
            for (let e = 0; e < d; e++) {
                let f = a.charAt(e);
                if (XmlConvert.c(f, e == 0 && !b)) {
                    c.q("_x{0:X4}_", f.charCodeAt(0));
                }
                else if (f == '_' && e + 6 < d && a.charAt(e + 1) == 'x' && a.charAt(e + 6) == '_') {
                    c.l("_x005F_");
                }
                else {
                    c.h(f);
                }
            }
            return c.toString();
        }
        static v(a) {
            return XmlConvert.w(a, false);
        }
        static x(a) {
            if (a == stringEmpty()) {
                throw new XmlException(3, "Invalid NmToken: ''");
            }
            return XmlConvert.w(a, true);
        }
        static d(a) {
            a = trim(a, ...XmlChar.d);
            switch (a) {
                case "1": return true;
                case "true": return true;
                case "0": return false;
                case "false": return false;
                default: throw new FormatException(1, a + " is not a valid boolean value");
            }
        }
        static y(a) {
            let b = new StringWriter(0);
            XmlConvert.ay(a, 0, a.length, b);
            return b.toString();
        }
        static ay(a, b, c, d) {
            if (a == null) {
                throw new ArgumentNullException(0, "buffer");
            }
            if (b < 0) {
                throw new ArgumentOutOfRangeException(3, "index", b, "index must be non negative integer.");
            }
            if (c < 0) {
                throw new ArgumentOutOfRangeException(3, "count", c, "count must be non negative integer.");
            }
            if (a.length < b + c) {
                throw new ArgumentOutOfRangeException(1, "index and count must be smaller than the length of the buffer.");
            }
            let e = b + c;
            for (let f = b; f < e; f++) {
                let g = a[f];
                let h = g >> 4;
                let i = g & 15;
                if (h > 9) {
                    d.o(String.fromCharCode((h + 55)));
                }
                else {
                    d.o(String.fromCharCode((h + 48)));
                }
                if (i > 9) {
                    d.o(String.fromCharCode((i + 55)));
                }
                else {
                    d.o(String.fromCharCode((i + 48)));
                }
            }
        }
        static f(a) {
            return parseUInt8_2(a, 7, CultureInfo.invariantCulture);
        }
        static g(a) {
            return ConvertUtil.toChar(a);
        }
        static h(a) {
            return parseNumber(a, CultureInfo.invariantCulture);
        }
        static i(a) {
            if (a == null) {
                throw new ArgumentNullException(1);
            }
            let b = XmlConvert.r(a);
            if (b != 0) {
                return b;
            }
            return parseNumber1(a, 423, CultureInfo.invariantCulture);
        }
        static r(a) {
            let b = 0;
            while (b < a.length && /\s/i.test(a.charAt(b))) {
                b++;
            }
            if (b == a.length) {
                throw new FormatException(0);
            }
            let c = a.length - 1;
            while (/\s/i.test(a.charAt(c))) {
                c--;
            }
            if (XmlConvert.e("NaN", a, b, c)) {
                return NaN;
            }
            if (XmlConvert.e("INF", a, b, c)) {
                return Number.POSITIVE_INFINITY;
            }
            if (XmlConvert.e("-INF", a, b, c)) {
                return Number.NEGATIVE_INFINITY;
            }
            if (XmlConvert.e("Infinity", a, b, c)) {
                return Number.POSITIVE_INFINITY;
            }
            if (XmlConvert.e("-Infinity", a, b, c)) {
                return Number.NEGATIVE_INFINITY;
            }
            return 0;
        }
        static e(a, b, c, d) {
            return d - c + 1 == a.length && stringCompareOrdinal(a, 0, b, c, a.length) == 0;
        }
        static l(a) {
            return parseInt16_2(a, 7, CultureInfo.invariantCulture);
        }
        static n(a) {
            return parseInt32_2(a, 7, CultureInfo.invariantCulture);
        }
        static o(a) {
            return parseInt64_2(a, 7, CultureInfo.invariantCulture);
        }
        static p(a) {
            return parseInt8_2(a, 7, CultureInfo.invariantCulture);
        }
        static q(a) {
            if (a == null) {
                throw new ArgumentNullException(1);
            }
            let b = XmlConvert.r(a);
            if (b != 0) {
                return b;
            }
            return parseNumber1(a, 423, CultureInfo.invariantCulture);
        }
        static ah(a) {
            return a.toString();
        }
        static ag(a) {
            return a.toString();
        }
        static aa(a) {
            return a.toString();
        }
        static ai(a) {
            return a.toString();
        }
        static ab(a) {
            return ConvertUtil.toString1(a, CultureInfo.invariantCulture);
        }
        static z(a) {
            if (a) {
                return "true";
            }
            return "false";
        }
        static aj(a) {
            return a.toString();
        }
        static ae(a) {
            return numberToString(a, CultureInfo.invariantCulture);
        }
        static ao(a) {
            return a.toString();
        }
        static al(a) {
            if (a == (0)) {
                return "PT0S";
            }
            let b = new StringBuilder(0);
            if (timeSpanTicks(a) < 0) {
                if (a == (-9007199254740991)) {
                    return "-P10675199DT2H48M5.4775808S";
                }
                b.h('-');
                a = timeSpanNegate(a);
            }
            b.h('P');
            if (timeSpanDays(a) > 0) {
                b.j(timeSpanDays(a)).h('D');
            }
            let c = timeSpanTicks(a) % (10000);
            if (timeSpanDays(a) > 0 || timeSpanHours(a) > 0 || timeSpanMinutes(a) > 0 || timeSpanSeconds(a) > 0 || timeSpanMilliseconds(a) > 0 || c > 0) {
                b.h('T');
                if (timeSpanHours(a) > 0) {
                    b.j(timeSpanHours(a)).h('H');
                }
                if (timeSpanMinutes(a) > 0) {
                    b.j(timeSpanMinutes(a)).h('M');
                }
                if (timeSpanSeconds(a) > 0 || timeSpanMilliseconds(a) > 0 || c > 0) {
                    b.j(timeSpanSeconds(a));
                    let d = true;
                    if (c > 0) {
                        b.h('.').q("{0:0000000}", timeSpanTicks(a) % (10000000));
                    }
                    else if (timeSpanMilliseconds(a) > 0) {
                        b.h('.').q("{0:000}", timeSpanMilliseconds(a));
                    }
                    else {
                        d = false;
                    }
                    if (d) {
                        while (b.item(b.c - 1) == '0') {
                            b.y(b.c - 1, 1);
                        }
                    }
                    b.h('S');
                }
            }
            return b.toString();
        }
        static af(a) {
            if (isNegativeInfinity(a)) {
                return "-INF";
            }
            if (isPositiveInfinity(a)) {
                return "INF";
            }
            if (isNaN_(a)) {
                return "NaN";
            }
            return a.toString();
        }
        static ak(a) {
            if (isNegativeInfinity(a)) {
                return "-INF";
            }
            if (isPositiveInfinity(a)) {
                return "INF";
            }
            if (isNaN_(a)) {
                return "NaN";
            }
            return a.toString();
        }
        static an(a) {
            return a.toString();
        }
        static am(a) {
            return a.toString();
        }
        static ac(a) {
            return dateToStringFormat(a, "yyyy-MM-ddTHH:mm:ss.fffffffzzz", CultureInfo.invariantCulture);
        }
        static ad(a, b) {
            return dateToStringFormat(a, b, CultureInfo.invariantCulture);
        }
        static au(a) {
            a = trim(a, ...XmlChar.d);
            if (a.length == 0) {
                throw new FormatException(1, "Invalid format string for duration schema datatype.");
            }
            let b = 0;
            if (a.charAt(0) == '-') {
                b = 1;
            }
            let c = (b == 1);
            if (a.charAt(b) != 'P') {
                throw new FormatException(1, "Invalid format string for duration schema datatype.");
            }
            b++;
            let d = 0;
            let e = 0;
            let f = false;
            let g = 0;
            let h = 0;
            let i = 0;
            let j = 0;
            let k = 0;
            let l = false;
            let m = b;
            while (m < a.length) {
                if (a.charAt(m) == 'T') {
                    f = true;
                    d = 4;
                    m++;
                    b = m;
                    continue;
                }
                for (; m < a.length; m++) {
                    if (a.charAt(m).charCodeAt(0) < '0'.charCodeAt(0) || '9'.charCodeAt(0) < a.charAt(m).charCodeAt(0)) {
                        break;
                    }
                }
                if (d == 7) {
                    k = m - b;
                }
                let n = parseInt32_1(a.substr(b, m - b), CultureInfo.invariantCulture);
                if (d == 7) {
                    for (; k > 7; k--) {
                        n = intDivide(n, 10);
                    }
                    for (; k < 7; k++) {
                        n *= 10;
                    }
                }
                switch (a.charAt(m)) {
                    case 'Y':
                        e += n * 365;
                        if (d > 0) {
                            l = true;
                        }
                        else {
                            d = 1;
                        }
                        break;
                    case 'M':
                        if (d < 2) {
                            e += 365 * (intDivide(n, 12)) + 30 * (n % 12);
                            d = 2;
                        }
                        else if (f && d < 6) {
                            h = n;
                            d = 6;
                        }
                        else {
                            l = true;
                        }
                        break;
                    case 'D':
                        e += n;
                        if (d > 2) {
                            l = true;
                        }
                        else {
                            d = 3;
                        }
                        break;
                    case 'H':
                        g = n;
                        if (!f || d > 4) {
                            l = true;
                        }
                        else {
                            d = 5;
                        }
                        break;
                    case 'S':
                        if (d == 7) {
                            j = n;
                        }
                        else {
                            i = n;
                        }
                        if (!f || d > 7) {
                            l = true;
                        }
                        else {
                            d = 8;
                        }
                        break;
                    case '.':
                        if (d > 7) {
                            l = true;
                        }
                        i = n;
                        d = 7;
                        break;
                    default:
                        l = true;
                        break;
                }
                if (l) {
                    break;
                }
                ++m;
                b = m;
            }
            if (l) {
                throw new FormatException(1, "Invalid format string for duration schema datatype.");
            }
            let o = timeSpanInit3(e, g, h, i);
            if (c) {
                return timeSpanFromTicks(-(timeSpanTicks(o) + j));
            }
            else {
                return timeSpanFromTicks(timeSpanTicks(o) + j);
            }
        }
        static av(a) {
            return parseUInt16_2(a, 7, CultureInfo.invariantCulture);
        }
        static aw(a) {
            return parseUInt32_2(a, 7, CultureInfo.invariantCulture);
        }
        static ax(a) {
            return parseUInt64_2(a, 7, CultureInfo.invariantCulture);
        }
        static aq(a) {
            if (a == null || a.length == 0) {
                throw new ArgumentNullException(0, "name");
            }
            if (!XmlChar.g(a)) {
                throw new XmlException(3, "'" + a + "' is not a valid XML Name");
            }
            return a;
        }
        static ar(a) {
            if (a == null || a.length == 0) {
                throw new ArgumentNullException(0, "ncname");
            }
            if (!XmlChar.i(a)) {
                throw new XmlException(3, "'" + a + "' is not a valid XML NCName");
            }
            return a;
        }
        static at(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "name");
            }
            if (a.length == 0) {
                return a;
            }
            if (XmlChar.p(a.charAt(0).charCodeAt(0)) || XmlChar.p(a.charAt(a.length - 1).charCodeAt(0))) {
                throw new XmlException(3, "Whitespace characters (#xA, #xD, #x9, #x20) are not allowed as leading or trailing whitespaces of xs:token.");
            }
            for (let b = 0; b < a.length; b++) {
                if (XmlChar.p(a.charAt(b).charCodeAt(0)) && a.charAt(b) != ' ') {
                    throw new XmlException(3, "Either #xA, #xD or #x9 are not allowed inside xs:token.");
                }
            }
            return a;
        }
        static as(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "name");
            }
            if (!XmlChar.k(a)) {
                throw new XmlException(3, "'" + a + "' is not a valid XML NMTOKEN");
            }
            return a;
        }
        static b(a) {
            let b = stringToCharArray(a);
            let c = new Array(intDivide(b.length, 2) + b.length % 2);
            XmlConvert.m(b, 0, b.length, c);
            return c;
        }
        static m(a, b, c, d) {
            let e = b;
            for (let f = 0; f < c - 1; f += 2) {
                d[e] = (a[f].charCodeAt(0) > '9'.charCodeAt(0) ? (a[f].charCodeAt(0) - 'A'.charCodeAt(0) + 10) : (a[f].charCodeAt(0) - '0'.charCodeAt(0)));
                d[e] <<= 4;
                d[e] += a[f + 1].charCodeAt(0) > '9'.charCodeAt(0) ? (a[f + 1].charCodeAt(0) - 'A'.charCodeAt(0) + 10) : (a[f + 1].charCodeAt(0) - '0'.charCodeAt(0));
                e++;
            }
            if (c % 2 != 0) {
                d[e++] = ((a[c - 1].charCodeAt(0) > '9'.charCodeAt(0) ? (a[c - 1].charCodeAt(0) - 'A'.charCodeAt(0) + 10) : (a[c - 1].charCodeAt(0) - '0'.charCodeAt(0))) << 4);
            }
            return e - b;
        }
    }
    XmlConvert.$t = /*@__PURE__*/ markType(XmlConvert, 'XmlConvert');
    XmlConvert.a = ["yyyy-MM-ddTHH:mm:sszzz", "yyyy-MM-ddTHH:mm:ss.fzzz", "yyyy-MM-ddTHH:mm:ss.ffzzz", "yyyy-MM-ddTHH:mm:ss.fffzzz", "yyyy-MM-ddTHH:mm:ss.ffffzzz", "yyyy-MM-ddTHH:mm:ss.fffffzzz", "yyyy-MM-ddTHH:mm:ss.ffffffzzz", "yyyy-MM-ddTHH:mm:ss.fffffffzzz", "yyyy-MM-ddTHH:mm:ssZ", "yyyy-MM-ddTHH:mm:ss.fZ", "yyyy-MM-ddTHH:mm:ss.ffZ", "yyyy-MM-ddTHH:mm:ss.fffZ", "yyyy-MM-ddTHH:mm:ss.ffffZ", "yyyy-MM-ddTHH:mm:ss.fffffZ", "yyyy-MM-ddTHH:mm:ss.ffffffZ", "yyyy-MM-ddTHH:mm:ss.fffffffZ", "yyyy-MM-ddTHH:mm:ss", "yyyy-MM-ddTHH:mm:ss.f", "yyyy-MM-ddTHH:mm:ss.ff", "yyyy-MM-ddTHH:mm:ss.fff", "yyyy-MM-ddTHH:mm:ss.ffff", "yyyy-MM-ddTHH:mm:ss.fffff", "yyyy-MM-ddTHH:mm:ss.ffffff", "yyyy-MM-ddTHH:mm:ss.fffffff", "HH:mm:ss", "HH:mm:ss.f", "HH:mm:ss.ff", "HH:mm:ss.fff", "HH:mm:ss.ffff", "HH:mm:ss.fffff", "HH:mm:ss.ffffff", "HH:mm:ss.fffffff", "HH:mm:sszzz", "HH:mm:ss.fzzz", "HH:mm:ss.ffzzz", "HH:mm:ss.fffzzz", "HH:mm:ss.ffffzzz", "HH:mm:ss.fffffzzz", "HH:mm:ss.ffffffzzz", "HH:mm:ss.fffffffzzz", "HH:mm:ssZ", "HH:mm:ss.fZ", "HH:mm:ss.ffZ", "HH:mm:ss.fffZ", "HH:mm:ss.ffffZ", "HH:mm:ss.fffffZ", "HH:mm:ss.ffffffZ", "HH:mm:ss.fffffffZ", "yyyy-MM-dd", "yyyy-MM-ddzzz", "yyyy-MM-ddZ", "yyyy-MM", "yyyy-MMzzz", "yyyy-MMZ", "yyyy", "yyyyzzz", "yyyyZ", "--MM-dd", "--MM-ddzzz", "--MM-ddZ", "---dd", "---ddzzz", "---ddZ"];
    return XmlConvert;
})();

//
/**
 * @hidden
 */
let XmlNamespaceManager_NsDecl = /*@__PURE__*/ (() => {
    class XmlNamespaceManager_NsDecl extends ValueType {
        constructor() {
            super();
            this.a = null;
            this.b = null;
        }
    }
    XmlNamespaceManager_NsDecl.$t = /*@__PURE__*/ markStruct(XmlNamespaceManager_NsDecl, 'XmlNamespaceManager_NsDecl');
    return XmlNamespaceManager_NsDecl;
})();

//
/**
 * @hidden
 */
let XmlNamespaceManager_NsScope = /*@__PURE__*/ (() => {
    class XmlNamespaceManager_NsScope extends ValueType {
        constructor() {
            super();
            this.a = 0;
            this.b = null;
        }
    }
    XmlNamespaceManager_NsScope.$t = /*@__PURE__*/ markStruct(XmlNamespaceManager_NsScope, 'XmlNamespaceManager_NsScope');
    return XmlNamespaceManager_NsScope;
})();

//
/**
 * @hidden
 */
let XmlNamespaceManager = /*@__PURE__*/ (() => {
    class XmlNamespaceManager extends Base {
        ab() {
            this.a = new Array(10);
            this.b = new Array(40);
            for (let a = 0; a < this.a.length; a++) {
                this.a[a] = new XmlNamespaceManager_NsDecl();
            }
            for (let b = 0; b < this.b.length; b++) {
                this.b[b] = new XmlNamespaceManager_NsScope();
            }
        }
        z() {
            let a = this.a;
            this.a = new Array(this.k * 2 + 1);
            if (this.k > 0) {
                arrayCopy1(a, 0, this.a, 0, this.k);
            }
            for (let b = this.k; b < this.a.length; b++) {
                this.a[b] = new XmlNamespaceManager_NsDecl();
            }
        }
        aa() {
            let a = this.b;
            this.b = new Array(this.l * 2 + 1);
            if (this.l > 0) {
                arrayCopy1(a, 0, this.b, 0, this.l);
            }
            for (let b = this.l; b < this.b.length; b++) {
                this.b[b] = new XmlNamespaceManager_NsScope();
            }
        }
        constructor(a) {
            super();
            this.a = null;
            this.k = -1;
            this.b = null;
            this.l = -1;
            this.m = null;
            this.j = 0;
            this.af = null;
            this.f = false;
            if (a == null) {
                throw new ArgumentNullException(0, "nameTable");
            }
            this.af = a;
            a.b("xmlns");
            a.b("xml");
            a.b(stringEmpty());
            a.b("http://www.w3.org/2000/xmlns/");
            a.b("http://www.w3.org/XML/1998/namespace");
            this.ab();
        }
        get_n() {
            return this.m == null ? stringEmpty() : this.m;
        }
        get n() {
            return this.get_n();
        }
        get ag() {
            return this.af;
        }
        x(a, b) {
            this.y(a, b, false);
        }
        y(a, b, c) {
            if (a == null) {
                throw new ArgumentNullException(0, "prefix Value cannot be null.");
            }
            if (b == null) {
                throw new ArgumentNullException(0, "uri Value cannot be null.");
            }
            if (!c) {
                a = this.af.b(a);
                b = this.af.b(b);
            }
            if (a == "xml" && b == "http://www.w3.org/XML/1998/namespace") {
                return;
            }
            XmlNamespaceManager.o(a, b, true);
            if (a.length == 0) {
                this.m = b;
            }
            for (let d = this.k; d > this.k - this.j; d--) {
                if (Base.referenceEquals(this.a[d].a, a)) {
                    this.a[d].b = b;
                    return;
                }
            }
            this.k++;
            this.j++;
            if (this.k == this.a.length) {
                this.z();
            }
            this.a[this.k].a = a;
            this.a[this.k].b = b;
        }
        static o(a, b, c) {
            let d = null;
            if (a == "xml" && b != "http://www.w3.org/XML/1998/namespace") {
                d = stringFormat("Prefix \"xml\" can only be bound to the fixed namespace URI \"{0}\". \"{1}\" is invalid.", "http://www.w3.org/XML/1998/namespace", b);
            }
            else if (d == null && a == "xmlns") {
                d = "Declaring prefix named \"xmlns\" is not allowed to any namespace.";
            }
            else if (d == null && b == "http://www.w3.org/2000/xmlns/") {
                d = stringFormat("Namespace URI \"{0}\" cannot be declared with any namespace.", "http://www.w3.org/2000/xmlns/");
            }
            if (d != null && c) {
                throw new ArgumentException(1, d);
            }
            else {
                return d;
            }
        }
        getEnumeratorObject() {
            let a = new Hashtable();
            for (let b = 0; b <= this.k; b++) {
                if (this.a[b].a != stringEmpty() && this.a[b].b != null) {
                    a.item(this.a[b].a, this.a[b].b);
                }
            }
            a.item(stringEmpty(), this.n);
            a.item("xml", "http://www.w3.org/XML/1998/namespace");
            a.item("xmlns", "http://www.w3.org/2000/xmlns/");
            return getEnumerator(a.c);
        }
        getNamespacesInScope(a) {
            return this.i(a);
        }
        i(a) {
            let b = new Hashtable();
            if (a == 2) {
                for (let c = 0; c < this.j; c++) {
                    if (this.a[this.k - c].a == stringEmpty() && this.a[this.k - c].b == stringEmpty()) {
                        if (b.a(stringEmpty())) {
                            b.f(stringEmpty());
                        }
                    }
                    else if (this.a[this.k - c].b != null) {
                        b.e(this.a[this.k - c].a, this.a[this.k - c].b);
                    }
                }
                return b;
            }
            else {
                for (let d = 0; d <= this.k; d++) {
                    if (this.a[d].a == stringEmpty() && this.a[d].b == stringEmpty()) {
                        if (b.a(stringEmpty())) {
                            b.f(stringEmpty());
                        }
                    }
                    else if (this.a[d].b != null) {
                        b.item(this.a[d].a, this.a[d].b);
                    }
                }
                if (a == 0) {
                    b.e("xml", "http://www.w3.org/XML/1998/namespace");
                }
                return b;
            }
        }
        d(a) {
            return this.e(a, false);
        }
        e(a, b) {
            if (a == null || this.j == 0) {
                return false;
            }
            for (let c = this.k; c > this.k - this.j; c--) {
                if (this.a[c].a == a) {
                    return true;
                }
            }
            return false;
        }
        lookupNamespace(a) {
            switch (a) {
                case "xmlns": return this.af.d("http://www.w3.org/2000/xmlns/");
                case "xml": return this.af.d("http://www.w3.org/XML/1998/namespace");
                case "": return this.n;
                case null: return null;
            }
            for (let b = this.k; b >= 0; b--) {
                if (this.c(this.a[b].a, a, this.f) && this.a[b].b != null) {
                    return this.a[b].b;
                }
            }
            return null;
        }
        lookupNamespace1(a, b) {
            this.f = b;
            let c = this.lookupNamespace(a);
            this.f = false;
            return c;
        }
        lookupPrefix(a) {
            return this.lookupPrefix1(a, true);
        }
        c(a, b, c) {
            if (c) {
                return Base.referenceEquals(a, b);
            }
            else {
                return a == b;
            }
        }
        lookupPrefix1(a, b) {
            return this.r(a, b, false);
        }
        s(a, b) {
            return this.r(a, b, true);
        }
        r(a, b, c) {
            if (a == null) {
                return null;
            }
            if (this.c(a, this.n, b)) {
                return stringEmpty();
            }
            if (this.c(a, "http://www.w3.org/XML/1998/namespace", b)) {
                return "xml";
            }
            if (this.c(a, "http://www.w3.org/2000/xmlns/", b)) {
                return "xmlns";
            }
            for (let d = this.k; d >= 0; d--) {
                if (this.c(this.a[d].b, a, b) && this.a[d].a.length > 0) {
                    if (!c || !this.g(d)) {
                        return this.a[d].a;
                    }
                }
            }
            return null;
        }
        g(a) {
            if (a == this.k) {
                return false;
            }
            let b = this.a[a + 1].a;
            for (let c = a + 1; c <= this.k; c++) {
                if (this.a[a].a == b) {
                    return true;
                }
            }
            return false;
        }
        h() {
            if (this.l == -1) {
                return false;
            }
            this.k -= this.j;
            this.m = this.b[this.l].b;
            this.j = this.b[this.l].a;
            this.l--;
            return true;
        }
        ac() {
            this.l++;
            if (this.l == this.b.length) {
                this.aa();
            }
            this.b[this.l].b = this.m;
            this.b[this.l].a = this.j;
            this.j = 0;
        }
        ad(a, b) {
            this.ae(a, b, false);
        }
        ae(a, b, c) {
            if (a == null) {
                throw new ArgumentNullException(0, "prefix");
            }
            if (b == null) {
                throw new ArgumentNullException(0, "uri");
            }
            if (this.j == 0) {
                return;
            }
            for (let d = this.k; d > this.k - this.j; d--) {
                if (this.c(this.a[d].a, a, c) && this.c(this.a[d].b, b, c)) {
                    this.a[d].b = null;
                }
            }
        }
    }
    XmlNamespaceManager.$t = /*@__PURE__*/ markType(XmlNamespaceManager, 'XmlNamespaceManager', Base.$, [IXmlNamespaceResolver_$type, IEnumerable_$type]);
    return XmlNamespaceManager;
})();

//
/**
 * @hidden
 */
let XmlNamespaceScope_$type = /*@__PURE__*/ markEnum('XmlNamespaceScope', 'All,0|ExcludeXml,1|Local,2');

//
/**
 * @hidden
 */
let XmlParserContext_ContextItem = /*@__PURE__*/ (() => {
    class XmlParserContext_ContextItem extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.b = null;
            this.c = 0;
        }
    }
    XmlParserContext_ContextItem.$t = /*@__PURE__*/ markType(XmlParserContext_ContextItem, 'XmlParserContext_ContextItem');
    return XmlParserContext_ContextItem;
})();

// From https://github.com/mosa/Mono-Class-Libraries/blob/28840dee90750d61ed6cbdb753292cd64cac169e/mcs/class/System.XML/System.Xml/XmlTextWriter2.cs
/**
 * @hidden
 */
let XmlTextWriter_XmlNodeInfo = /*@__PURE__*/ (() => {
    class XmlTextWriter_XmlNodeInfo extends Base {
        constructor() {
            super(...arguments);
            this.e = null;
            this.c = null;
            this.d = null;
            this.b = false;
            this.a = false;
            this.f = null;
            this.g = 0;
        }
    }
    XmlTextWriter_XmlNodeInfo.$t = /*@__PURE__*/ markType(XmlTextWriter_XmlNodeInfo, 'XmlTextWriter_XmlNodeInfo');
    return XmlTextWriter_XmlNodeInfo;
})();

// From https://github.com/mosa/Mono-Class-Libraries/blob/28840dee90750d61ed6cbdb753292cd64cac169e/mcs/class/System.XML/System.Xml/XmlTextWriter2.cs
/**
 * @hidden
 */
let XmlTextWriter_StringUtil = /*@__PURE__*/ (() => {
    class XmlTextWriter_StringUtil extends Base {
        static d(a, b) {
            return XmlTextWriter_StringUtil.a.indexOf1(a, b);
        }
        static c(a, b) {
            return XmlTextWriter_StringUtil.a.compare4(a, b);
        }
        static e(a, ...b) {
            return stringFormat2(XmlTextWriter_StringUtil.b, a, ...b);
        }
    }
    XmlTextWriter_StringUtil.$t = /*@__PURE__*/ markType(XmlTextWriter_StringUtil, 'XmlTextWriter_StringUtil');
    XmlTextWriter_StringUtil.b = CultureInfo.invariantCulture;
    XmlTextWriter_StringUtil.a = CultureInfo.invariantCulture.compareInfo;
    return XmlTextWriter_StringUtil;
})();

// From https://github.com/mosa/Mono-Class-Libraries/blob/28840dee90750d61ed6cbdb753292cd64cac169e/mcs/class/System.XML/System.Xml/XmlTextWriter2.cs
/**
 * @hidden
 */
let XmlReader = /*@__PURE__*/ (() => {
    class XmlReader extends Base {
        constructor() {
            super();
            this.at = null;
        }
        get_a() {
            return false;
        }
        get a() {
            return this.get_a();
        }
        get_b() {
            return false;
        }
        get b() {
            return this.get_b();
        }
        get_c() {
            return false;
        }
        get c() {
            return this.get_c();
        }
        get_e() {
            return this.w > 0;
        }
        get e() {
            return this.get_e();
        }
        static j(a) {
            return a != null && XmlChar.g(a);
        }
        static k(a) {
            return a != null && XmlChar.k(a);
        }
        l() {
            return (this.a6() == 1);
        }
        m(a) {
            if (!this.l()) {
                return false;
            }
            return (this.ai == a);
        }
        n(a, b) {
            if (!this.l()) {
                return false;
            }
            return (this.ag == a && this.aj == b);
        }
        g(a) {
            switch (a) {
                case 3: return true;
                case 4: return true;
                case 1: return true;
                case 15: return true;
                case 5: return true;
                case 16: return true;
            }
            return false;
        }
        a6() {
            switch (this.a3) {
                case 0:
                case 1: break;
                default: return this.a7;
            }
            if (this.a7 == 2) {
                this.q();
            }
            do {
                if (this.g(this.a7)) {
                    return this.a7;
                }
                this.t();
            } while (!this.d);
            return 0;
        }
        al() {
            if (this.a6() != 1) {
                let a = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                throw this.a4(a);
            }
            let b = stringEmpty();
            if (!this.i) {
                this.t();
                b = this.aq();
                if (this.a7 != 15) {
                    let c = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                    throw this.a4(c);
                }
            }
            this.t();
            return b;
        }
        am(a) {
            if (this.a6() != 1) {
                let b = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                throw this.a4(b);
            }
            if (a != this.ai) {
                let c = stringFormat("The {0} tag from namespace {1} is expected.", this.ai, this.aj);
                throw this.a4(c);
            }
            let d = stringEmpty();
            if (!this.i) {
                this.t();
                d = this.aq();
                if (this.a7 != 15) {
                    let e = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                    throw this.a4(e);
                }
            }
            this.t();
            return d;
        }
        an(a, b) {
            if (this.a6() != 1) {
                let c = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                throw this.a4(c);
            }
            if (a != this.ag || this.aj != b) {
                let d = stringFormat("The {0} tag from namespace {1} is expected.", this.ag, this.aj);
                throw this.a4(d);
            }
            let e = stringEmpty();
            if (!this.i) {
                this.t();
                e = this.aq();
                if (this.a7 != 15) {
                    let f = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                    throw this.a4(f);
                }
            }
            this.t();
            return e;
        }
        ax() {
            if (this.a6() != 15) {
                let a = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                throw this.a4(a);
            }
            this.t();
        }
        ao() {
            if (this.a3 != 1 || this.a7 == 15) {
                return stringEmpty();
            }
            if (this.i) {
                this.t();
                return stringEmpty();
            }
            let a = new StringWriter(0);
            let b = new XmlTextWriter(1, a);
            if (this.a7 == 1) {
                let c = this.x;
                this.t();
                while (c < this.x) {
                    if (this.a3 != 1) {
                        throw this.a4("Unexpected end of the XML reader.");
                    }
                    b.ac(this, false);
                }
                this.t();
            }
            else {
                b.ac(this, false);
            }
            return a.toString();
        }
        ap() {
            if (this.a3 != 1 || this.a7 == 15) {
                return stringEmpty();
            }
            switch (this.a7) {
                case 1:
                case 2:
                    let a = new StringWriter(0);
                    let b = new XmlTextWriter(1, a);
                    b.ac(this, false);
                    return a.toString();
                default:
                    this.a2();
                    return stringEmpty();
            }
        }
        ay() {
            if (this.a6() != 1) {
                let a = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                throw this.a4(a);
            }
            this.t();
        }
        az(a) {
            if (this.a6() != 1) {
                let b = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                throw this.a4(b);
            }
            if (a != this.ai) {
                let c = stringFormat("The {0} tag from namespace {1} is expected.", this.ai, this.aj);
                throw this.a4(c);
            }
            this.t();
        }
        a0(a, b) {
            if (this.a6() != 1) {
                let c = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                throw this.a4(c);
            }
            if (a != this.ag || this.aj != b) {
                let d = stringFormat1("Expecting {0} tag from namespace {1}, got {2} and {3} instead", a, b, this.ag, this.aj);
                throw this.a4(d);
            }
            this.t();
        }
        aq() {
            if (this.at == null) {
                this.at = new StringBuilder(0);
            }
            this.at.c = 0;
            this.q();
            switch (this.a7) {
                default: return stringEmpty();
                case 1:
                    if (this.i) {
                        return stringEmpty();
                    }
                    do {
                        this.t();
                        switch (this.a7) {
                            case 3:
                            case 4:
                            case 13:
                            case 14:
                                this.at.l(this.ar);
                                continue;
                        }
                        break;
                    } while (true);
                    break;
                case 3:
                case 4:
                case 13:
                case 14:
                    do {
                        switch (this.a7) {
                            case 3:
                            case 4:
                            case 13:
                            case 14:
                                this.at.l(this.ar);
                                this.t();
                                continue;
                        }
                        break;
                    } while (true);
                    break;
            }
            let a = this.at.toString();
            this.at.c = 0;
            return a;
        }
        y(a, b, c) {
            throw new NotSupportedException(0);
        }
        a2() {
            if (this.a3 != 1) {
                return;
            }
            this.q();
            if (this.a7 != 1 || this.i) {
                this.t();
                return;
            }
            let a = this.x;
            while (this.t() && a < this.x) {
                ;
            }
            if (this.a7 == 15) {
                this.t();
            }
        }
        a4(a) {
            return new XmlException(2, typeCast(IXmlLineInfo_$type, this), this.z, a);
        }
        dispose() {
            this.disposeCore(true);
        }
        disposeCore(a) {
            if (a && this.a3 != 4) {
                this.au();
            }
        }
    }
    XmlReader.$t = /*@__PURE__*/ markType(XmlReader, 'XmlReader', Base.$, [IDisposable_$type]);
    return XmlReader;
})();
/**
 * @hidden
 */
let XmlWriter = /*@__PURE__*/ (() => {
    class XmlWriter extends Base {
        constructor() {
            super();
        }
        DisposeImpl(a) {
            this.c();
        }
        dispose() {
            this.DisposeImpl(false);
        }
        f(a, b) {
            if (!b && a.h) {
                return;
            }
            this.aj(a.ak, a.ag, a.aj);
            while (a.u()) {
                switch (a.a7) {
                    case 3:
                        this.ap(a.ar);
                        break;
                    case 5:
                        this.w(a.ai);
                        break;
                }
            }
            this.t();
        }
        g(a, b) {
            if (a == null) {
                throw new ArgumentException(2, "null XmlReader specified.", "reader");
            }
            let t1 = a.a7;
            L0: while (true) {
                switch (t1) {
                    case 17:
                        this.h("version", a.item1("version"));
                        if (a.item1("encoding") != null) {
                            this.h("encoding", a.item1("encoding"));
                        }
                        if (a.item1("standalone") != null) {
                            this.h("standalone", a.item1("standalone"));
                        }
                        break;
                    case 1:
                        if (a.r()) {
                            t1 = 2;
                            continue L0;
                        }
                        break;
                    case 2:
                        do {
                            this.f(a, b);
                        } while (a.s());
                        a.q();
                        break;
                    default: throw new XmlException(3, "NodeType is not one of Element, Attribute, nor XmlDeclaration.");
                }
                break;
            }
        }
        h(a, b) {
            this.j("", a, null, b);
        }
        i(a, b, c) {
            this.j("", a, b, c);
        }
        j(a, b, c, d) {
            this.aj(a, b, c);
            if (d != null && d.length > 0) {
                this.ap(d);
            }
            this.t();
        }
        r(a, b) {
            this.am(a);
            if (b != null && b.length > 0) {
                this.ap(b);
            }
            this.v();
        }
        s(a, b, c) {
            this.an(a, b);
            if (c != null && c.length > 0) {
                this.ap(c);
            }
            this.v();
        }
        z(a) {
            XmlConvert.aq(a);
            this.ap(a);
        }
        ab(a) {
            let b = true;
            b = XmlChar.k(a);
            if (!b) {
                throw new ArgumentException(1, "Argument name is not a valid NMTOKEN.");
            }
            this.ap(a);
        }
        af(a, b) {
            if (a == null || a == stringEmpty()) {
                throw new ArgumentException(0);
            }
            if (b == null) {
                b = stringEmpty();
            }
            XmlConvert.ar(a);
            let c = b.length > 0 ? this.a(b) : stringEmpty();
            if (c == null) {
                throw new ArgumentException(1, stringFormat("Namespace '{0}' is not declared.", b));
            }
            if (c != stringEmpty()) {
                this.ap(c);
                this.ap(":");
                this.ap(a);
            }
            else {
                this.ap(a);
            }
        }
        ac(a, b) {
            if (a == null) {
                throw new ArgumentException(0);
            }
            if (a.a3 == 0) {
                a.t();
                do {
                    this.ac(a, b);
                } while (!a.d);
                return;
            }
            let t1 = a.a7;
            L0: while (true) {
                switch (t1) {
                    case 1:
                        this.ao(a.ak, a.ag, a.aj);
                        if (a.e) {
                            for (let c = 0; c < a.w; c++) {
                                a.aw(c);
                                this.f(a, b);
                            }
                            a.q();
                        }
                        if (a.i) {
                            this.v();
                        }
                        else {
                            let d = a.x;
                            a.t();
                            if (a.a7 != 15) {
                                do {
                                    this.ac(a, b);
                                } while (d < a.x);
                            }
                            this.x();
                        }
                        break;
                    case 2: return;
                    case 3:
                        this.ap(a.ar);
                        break;
                    case 4:
                        this.m(a.ar);
                        break;
                    case 5:
                        this.w(a.ai);
                        break;
                    case 17:
                    case 7:
                        this.ad(a.ai, a.ar);
                        break;
                    case 8:
                        this.p(a.ar);
                        break;
                    case 10:
                        this.q(a.ai, a.item1("PUBLIC"), a.item1("SYSTEM"), a.ar);
                        break;
                    case 14:
                        t1 = 13;
                        continue L0;
                    case 13:
                        this.ar(a.ar);
                        break;
                    case 15:
                        this.x();
                        break;
                    case 16: break;
                    case 0: break;
                    default: throw new XmlException(3, "Unexpected node " + a.ai + " of type " + enumGetBox(XmlNodeType_$type, a.a7));
                }
                break;
            }
            a.t();
        }
        ai(a, b) {
            this.aj(null, a, b);
        }
        am(a) {
            this.ao(null, a, null);
        }
        an(a, b) {
            this.ao(null, a, b);
        }
    }
    XmlWriter.$t = /*@__PURE__*/ markType(XmlWriter, 'XmlWriter', Base.$, [IDisposable_$type]);
    return XmlWriter;
})();
/**
 * @hidden
 */
let XmlTextWriter = /*@__PURE__*/ (() => {
    class XmlTextWriter extends XmlWriter {
        constructor(a, ..._rest) {
            super();
            this.bm = null;
            this.bp = null;
            this.bq = null;
            this.bo = null;
            this.bv = null;
            this.a4 = false;
            this.ax = false;
            this.az = true;
            this.a0 = false;
            this.a5 = true;
            this.cn = 0;
            this.ay = false;
            this.cj = 2;
            this.a3 = false;
            this.ck = 0;
            this.cm = 0;
            this.cl = null;
            this.bl = 0;
            this.au = new Array(10);
            this.be = new Array();
            this.bd = arrayListCreate();
            this.ci = 0;
            this.a1 = false;
            this.bj = 2;
            this.a9 = ' ';
            this.bs = "  ";
            this.bu = null;
            this.a2 = false;
            this.bb = '\"';
            this.a7 = false;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [new StreamWriter(1, c, d == null ? XmlTextWriter.by : d)];
                        {
                            let g = e[0];
                            if (g == null) {
                                throw new ArgumentNullException(0, "writer");
                            }
                            this.a0 = (g.h == null);
                            this.b3(g);
                            this.ax = true;
                        }
                        this.a0 = (d == null);
                        this.b3(this.bq);
                        this.ax = true;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        if (c == null) {
                            throw new ArgumentNullException(0, "writer");
                        }
                        this.a0 = (c.h == null);
                        this.b3(c);
                        this.ax = true;
                    }
                    break;
            }
        }
        b3(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "writer");
            }
            let b = new NameTable();
            this.bq = a;
            if (typeCast(StreamWriter.$, a) !== null) {
                this.bm = a.a5;
            }
            this.bp = a;
            this.cl = new XmlNamespaceManager(b);
            this.bu = a.g;
            XmlTextWriter.aw = this.cj != 2 ? ['&', '<', '>', '\r', '\n'] : ['&', '<', '>'];
            XmlTextWriter.av = ['\"', '&', '<', '>', '\r', '\n'];
        }
        get ch() {
            return this.a1 ? 1 : 0;
        }
        set ch(a) {
            this.a1 = (a == 1);
        }
        get bk() {
            return this.bj;
        }
        set bk(a) {
            if (a < 0) {
                throw this.bf("Indentation must be non-negative integer.");
            }
            this.bj = a;
            this.bs = a == 0 ? stringEmpty() : stringCreateFromChar(this.a9, this.bj);
        }
        get ba() {
            return this.a9;
        }
        set ba(a) {
            this.a9 = a;
            this.bs = stringCreateFromChar(this.a9, this.bj);
        }
        get bc() {
            return this.bb;
        }
        set bc(a) {
            if (this.ck == 3) {
                throw this.bh("QuoteChar must not be changed inside attribute value.");
            }
            if ((a != '\'') && (a != '\"')) {
                throw this.bf("Only ' and \" are allowed as an attribute quote character.");
            }
            this.bb = a;
            XmlTextWriter.av[0] = this.bb;
        }
        get_b() {
            return this.bl == 0 ? null : this.au[this.bl - 1].f;
        }
        get b() {
            return this.get_b();
        }
        get_at() {
            return this.bl == 0 ? 0 : this.au[this.bl - 1].g;
        }
        get at() {
            return this.get_at();
        }
        get_as() {
            return this.ck;
        }
        get as() {
            return this.get_as();
        }
        a(a) {
            if (a == null || a == stringEmpty()) {
                throw this.bf("The Namespace cannot be empty.");
            }
            if (a == this.cl.n) {
                return stringEmpty();
            }
            let b = this.cl.s(a, false);
            return b;
        }
        get bn() {
            return this.bm;
        }
        c() {
            if (this.ck == 3) {
                this.t();
            }
            while (this.bl > 0) {
                this.v();
            }
            if (this.az) {
                this.bq.i();
            }
            else {
                this.bq.k();
            }
            this.ck = 5;
        }
        e() {
            this.bq.k();
        }
        get a6() {
            return this.a5;
        }
        set a6(a) {
            if (this.ck != 0) {
                throw this.bh("This property must be set before writing output.");
            }
            this.a5 = a;
        }
        ak() {
            this.cg(false, false);
            this.a3 = true;
        }
        al(a) {
            this.cg(true, a);
            this.a3 = true;
        }
        cg(a, b) {
            if (this.ck != 0) {
                throw this.bi("XmlDeclaration");
            }
            switch (this.cn) {
                case 1: return;
                case 3: throw this.bh("WriteStartDocument cannot be called when ConformanceLevel is Fragment.");
            }
            this.ck = 1;
            this.bq.v("<?xml version=");
            this.bq.o(this.bb);
            this.bq.v("1.0");
            this.bq.o(this.bb);
            if (!this.a0) {
                this.bq.v(" encoding=");
                this.bq.o(this.bb);
                this.bq.v(this.bq.h.webName);
                this.bq.o(this.bb);
            }
            if (a) {
                this.bq.v(" standalone=");
                this.bq.o(this.bb);
                this.bq.v(b ? "yes" : "no");
                this.bq.o(this.bb);
            }
            this.bq.v("?>");
            this.cn = 1;
        }
        u() {
            switch (this.ck) {
                case 5:
                case 0: throw this.bi("EndDocument");
            }
            if (this.ck == 3) {
                this.t();
            }
            while (this.bl > 0) {
                this.v();
            }
            this.ck = 0;
            this.a3 = false;
        }
        q(a, b, c, d) {
            if (a == null) {
                throw this.bf("name");
            }
            if (!XmlChar.g(a)) {
                throw this.bf("name");
            }
            if (this.cm != 0) {
                throw this.bi("DocType");
            }
            this.cm = 10;
            if (this.cn == 2) {
                this.b4();
            }
            this.cd();
            this.bq.v("<!DOCTYPE ");
            this.bq.v(a);
            if (b != null) {
                this.bq.v(" PUBLIC ");
                this.bq.o(this.bb);
                this.bq.v(b);
                this.bq.o(this.bb);
                this.bq.o(' ');
                this.bq.o(this.bb);
                if (c != null) {
                    this.bq.v(c);
                }
                this.bq.o(this.bb);
            }
            else if (c != null) {
                this.bq.v(" SYSTEM ");
                this.bq.o(this.bb);
                this.bq.v(c);
                this.bq.o(this.bb);
            }
            if (d != null) {
                this.bq.v("[");
                this.bq.v(d);
                this.bq.v("]");
            }
            this.bq.o('>');
            this.ck = 1;
        }
        ao(a, b, c) {
            if (this.ck == 5) {
                throw this.bi("StartTag");
            }
            this.cm = 1;
            let d = (a == null);
            if (a == null) {
                a = stringEmpty();
            }
            if (!this.a5 && c != null && c.length > 0) {
                throw this.bf("Namespace is disabled in this XmlTextWriter.");
            }
            if (!this.a5 && a.length > 0) {
                throw this.bf("Namespace prefix is disabled in this XmlTextWriter.");
            }
            if (a.length > 0 && c == null) {
                c = this.cl.lookupNamespace1(a, false);
                if (c == null || c.length == 0) {
                    throw this.bf("Namespace URI must not be null when prefix is not an empty string.");
                }
            }
            if (this.a5 && a != null && a.length == 3 && c != "http://www.w3.org/XML/1998/namespace" && (a.charAt(0) == 'x' || a.charAt(0) == 'X') && (a.charAt(1) == 'm' || a.charAt(1) == 'M') && (a.charAt(2) == 'l' || a.charAt(2) == 'L')) {
                throw new ArgumentException(1, "A prefix cannot be equivalent to \"xml\" in case-insensitive match.");
            }
            if (this.cn == 2) {
                this.b4();
            }
            if (this.ck == 2) {
                this.b1();
            }
            if (this.bl > 0) {
                this.au[this.bl - 1].a = true;
            }
            this.cl.ac();
            if (this.a5 && c != null) {
                if (d && c.length > 0) {
                    a = this.a(c);
                }
                if (a == null || c.length == 0) {
                    a = stringEmpty();
                }
            }
            this.cd();
            this.bq.v("<");
            if (a.length > 0) {
                this.bq.v(a);
                this.bq.o(':');
            }
            this.bq.v(b);
            if (this.au.length == this.bl) {
                let e = new Array(this.bl << 1);
                arrayCopy2(this.au, e, this.bl);
                this.au = e;
            }
            if (this.au[this.bl] == null) {
                this.au[this.bl] = new XmlTextWriter_XmlNodeInfo();
            }
            let f = this.au[this.bl];
            f.e = a;
            f.c = b;
            f.d = c;
            f.b = false;
            f.a = false;
            f.f = this.b;
            f.g = this.at;
            this.bl++;
            if (this.a5 && c != null) {
                let g = this.cl.lookupNamespace1(a, false);
                if (g != c) {
                    this.cl.x(a, c);
                    this.be.push(a);
                }
            }
            this.ck = 2;
        }
        b1() {
            this.b2();
            if (this.ck == 2) {
                this.bq.o('>');
            }
            this.ck = 4;
        }
        b2() {
            if (this.ck == 3) {
                this.t();
            }
            if (this.be.length == 0) {
                if (this.bd.count > 0) {
                    this.bd.clear();
                }
                return;
            }
            let a = this.bd.count;
            while (this.be.length > 0) {
                let b = this.be.pop();
                let c = false;
                for (let d = 0; d < this.bd.count; d++) {
                    if (this.bd.item(d) == b) {
                        c = true;
                        break;
                    }
                }
                if (c) {
                    continue;
                }
                this.bd.add(b);
            }
            for (let e = a; e < this.bd.count; e++) {
                let f = this.bd.item(e);
                let g = this.cl.lookupNamespace1(f, false);
                if (g == null) {
                    continue;
                }
                if (f.length > 0) {
                    this.bq.v(" xmlns:");
                    this.bq.v(f);
                }
                else {
                    this.bq.v(" xmlns");
                }
                this.bq.o('=');
                this.bq.o(this.bb);
                this.cc(g, true);
                this.bq.o(this.bb);
            }
            this.bd.clear();
        }
        v() {
            this.ca(false);
        }
        x() {
            this.ca(true);
        }
        ca(a) {
            if (this.ck == 5) {
                throw this.bi("EndElement");
            }
            if (this.bl == 0) {
                throw this.bh("There is no more open element.");
            }
            this.b2();
            this.cl.h();
            if (this.ck == 2) {
                if (a) {
                    this.bq.o('>');
                }
                else {
                    this.bq.v(" />");
                }
            }
            if (a || this.ck == 4) {
                this.cf();
            }
            let b = this.au[--this.bl];
            if (a || this.ck == 4) {
                this.bq.v("</");
                if (b.e.length > 0) {
                    this.bq.v(b.e);
                    this.bq.o(':');
                }
                this.bq.v(b.c);
                this.bq.o('>');
            }
            this.ck = 4;
            if (this.bl == 0) {
                this.cm = 15;
            }
        }
        aj(a, b, c) {
            if (this.ck == 3) {
                this.t();
            }
            if (this.ck != 2 && this.ck != 0) {
                throw this.bi("Attribute");
            }
            if (a == null) {
                a = stringEmpty();
            }
            let d = false;
            if (c == "http://www.w3.org/2000/xmlns/") {
                d = true;
                if (a.length == 0 && b != "xmlns") {
                    a = "xmlns";
                }
            }
            else {
                d = (a == "xmlns" || b == "xmlns" && a.length == 0);
            }
            if (d) {
                if (b == null || b.length == 0) {
                    b = a;
                    a = stringEmpty();
                }
            }
            if (this.a5) {
                if (a == "xml") {
                    c = "http://www.w3.org/XML/1998/namespace";
                }
                else if (c == null || (this.a7 && c.length == 0)) {
                    if (d) {
                        c = "http://www.w3.org/2000/xmlns/";
                    }
                    else {
                        c = stringEmpty();
                    }
                }
                if (d && c != "http://www.w3.org/2000/xmlns/") {
                    throw this.bf(stringFormat("The 'xmlns' attribute is bound to the reserved namespace '{0}'", "http://www.w3.org/2000/xmlns/"));
                }
                if (a.length > 0 && c.length == 0) {
                    c = this.cl.lookupNamespace1(a, false);
                    if (c == null || c.length == 0) {
                        throw this.bf("Namespace URI must not be null when prefix is not an empty string.");
                    }
                }
                if (!d && c.length > 0) {
                    a = this.br(a, b, c);
                }
            }
            if (this.a2) {
                this.ce();
            }
            else if (this.ck != 0) {
                this.bq.o(' ');
            }
            if (a.length > 0) {
                this.bq.v(a);
                this.bq.o(':');
            }
            this.bq.v(b);
            this.bq.o('=');
            this.bq.o(this.bb);
            if (d || a == "xml") {
                if (this.bo == null) {
                    this.bo = new StringWriter(0);
                }
                else {
                    this.bo.av().c = 0;
                }
                this.bq = this.bo;
                if (!d) {
                    this.a4 = false;
                    this.bv = b;
                }
                else {
                    this.a4 = true;
                    this.bv = b == "xmlns" ? stringEmpty() : b;
                }
            }
            this.ck = 3;
        }
        br(a, b, c) {
            let d = false;
            if (a.length == 0) {
                a = this.a(c);
                if (a != null && a.length > 0) {
                    return a;
                }
                d = true;
            }
            else {
                a = this.cl.ag.b(a);
                let e = this.cl.lookupNamespace1(a, true);
                if (e == c) {
                    return a;
                }
                if (e != null) {
                    this.cl.ad(a, e);
                    if (this.cl.lookupNamespace1(a, true) != e) {
                        d = true;
                        this.cl.x(a, e);
                    }
                }
            }
            if (d) {
                a = this.bt(c, true);
            }
            this.be.push(a);
            this.cl.x(a, c);
            return a;
        }
        bt(a, b) {
            let c = b ? null : this.a(a);
            if (c != null && c.length > 0) {
                return c;
            }
            for (let d = 1;; d++) {
                c = XmlTextWriter_StringUtil.e("d{0}p{1}", this.bl, d);
                if (arrayContains(this.be, c)) {
                    continue;
                }
                if (null != this.cl.lookupNamespace(this.cl.ag.d(c))) {
                    continue;
                }
                this.cl.x(c, a);
                this.be.push(c);
                return c;
            }
        }
        t() {
            if (this.ck != 3) {
                throw this.bi("End of attribute");
            }
            if (this.bq == this.bo) {
                this.bq = this.bp;
                let a = this.bo.toString();
                if (this.a4) {
                    if (this.bv.length > 0 && a.length == 0) {
                        throw this.bf("Non-empty prefix must be mapped to non-empty namespace URI.");
                    }
                    let b = this.cl.lookupNamespace1(this.bv, false);
                    if ((this.ci & 1) == 0 || b != a) {
                        this.bd.add(this.bv);
                    }
                    if (this.bl > 0) {
                        if (this.a7 && this.au[this.bl - 1].e == this.bv && this.au[this.bl - 1].d != a) {
                            throw new XmlException(3, stringFormat("Cannot redefine the namespace for prefix '{0}' used at current element", this.bv));
                        }
                        if (this.au[this.bl - 1].d == stringEmpty() && this.au[this.bl - 1].e == this.bv) {
                            ;
                        }
                        else if (b != a) {
                            this.cl.x(this.bv, a);
                        }
                    }
                }
                else {
                    switch (this.bv) {
                        case "lang":
                            if (this.bl > 0) {
                                this.au[this.bl - 1].f = a;
                            }
                            break;
                        case "space":
                            switch (a) {
                                case "default":
                                    if (this.bl > 0) {
                                        this.au[this.bl - 1].g = 1;
                                    }
                                    break;
                                case "preserve":
                                    if (this.bl > 0) {
                                        this.au[this.bl - 1].g = 2;
                                    }
                                    break;
                                default: throw this.bf("Invalid value for xml:space.");
                            }
                            break;
                    }
                }
                this.bq.v(a);
            }
            this.bq.o(this.bb);
            this.ck = 2;
        }
        p(a) {
            if (a == null) {
                throw this.bf("text");
            }
            if (a.length > 0 && a.charAt(a.length - 1) == '-') {
                throw this.bf("An input string to WriteComment method must not end with '-'. Escape it with '&#2D;'.");
            }
            if (XmlTextWriter_StringUtil.d(a, "--") > 0) {
                throw this.bf("An XML comment cannot end with \"-\".");
            }
            if (this.ck == 3 || this.ck == 2) {
                this.b1();
            }
            this.cd();
            this.b6("Comment", false, false, false);
            this.bq.v("<!--");
            this.bq.v(a);
            this.bq.v("-->");
        }
        ad(a, b) {
            if (a == null) {
                throw this.bf("name");
            }
            if (b == null) {
                throw this.bf("text");
            }
            this.cd();
            if (!XmlChar.g(a)) {
                throw this.bf("A processing instruction name must be a valid XML name.");
            }
            if (XmlTextWriter_StringUtil.d(b, "?>") > 0) {
                throw this.bf("Processing instruction cannot contain \"?>\" as its value.");
            }
            this.b6("ProcessingInstruction", false, a == "xml", false);
            this.bq.v("<?");
            this.bq.v(a);
            this.bq.o(' ');
            this.bq.v(b);
            this.bq.v("?>");
            if (this.ck == 0) {
                this.ck = 1;
            }
        }
        ar(a) {
            if (a == null) {
                throw this.bf("text");
            }
            if (a.length == 0 || XmlChar.u(a) >= 0) {
                throw this.bf("WriteWhitespace method accepts only whitespaces.");
            }
            this.b6("Whitespace", true, false, true);
            this.bq.v(a);
        }
        m(a) {
            if (a == null) {
                a = stringEmpty();
            }
            this.b5("CData", false);
            if (XmlTextWriter_StringUtil.d(a, "]]>") >= 0) {
                throw this.bf("CDATA section must not contain ']]>'.");
            }
            this.bq.v("<![CDATA[");
            this.b9(a);
            this.bq.v("]]>");
        }
        ap(a) {
            if (a == null || (a.length == 0 && !this.a7)) {
                return;
            }
            this.b5("Text", true);
            this.cc(a, this.ck == 3);
        }
        ah(a) {
            if (a == null) {
                return;
            }
            this.b6("Raw string", true, true, true);
            this.bq.v(a);
        }
        n(a) {
            this.b7(a, '\0', false);
        }
        aq(a, b) {
            this.b7(a, b, true);
        }
        b7(a, b, c) {
            if (c && ('\ud800'.charCodeAt(0) > b.charCodeAt(0) || b.charCodeAt(0) > '\udc00'.charCodeAt(0) || '\udc00'.charCodeAt(0) > a.charCodeAt(0) || a.charCodeAt(0) > '\udfff'.charCodeAt(0))) {
                throw this.bf(stringFormat("Invalid surrogate pair was found. Low: &#x{0:X}; High: &#x{0:X};", a.charCodeAt(0), b.charCodeAt(0)));
            }
            else if (this.ay && XmlChar.f(a.charCodeAt(0))) {
                throw this.bf(stringFormat("Invalid character &#x{0:X};", a.charCodeAt(0)));
            }
            this.b5("Character", true);
            let d = c ? (b.charCodeAt(0) - 55296) * 1024 + a.charCodeAt(0) - 56320 + 65536 : a.charCodeAt(0);
            this.bq.v("&#x");
            this.bq.v(intToString1(d, "X", CultureInfo.invariantCulture));
            this.bq.o(';');
        }
        w(a) {
            if (a == null) {
                throw this.bf("name");
            }
            if (!XmlChar.g(a)) {
                throw this.bf("Argument name must be a valid XML name.");
            }
            this.b5("Entity reference", true);
            this.bq.o('&');
            this.bq.v(a);
            this.bq.o(';');
        }
        y(a) {
            if (a == null) {
                throw this.bf("name");
            }
            if (!XmlChar.g(a)) {
                throw this.bf("Not a valid name string.");
            }
            this.ap(a);
        }
        aa(a) {
            if (a == null) {
                throw this.bf("nmtoken");
            }
            if (!XmlChar.k(a)) {
                throw this.bf("Not a valid NMTOKEN string.");
            }
            this.ap(a);
        }
        ae(a, b) {
            if (a == null) {
                throw this.bf("localName");
            }
            if (b == null) {
                b = stringEmpty();
            }
            if (b == "http://www.w3.org/2000/xmlns/") {
                throw this.bf("Prefix 'xmlns' is reserved and cannot be overriden.");
            }
            if (!XmlChar.i(a)) {
                throw this.bf("localName must be a valid NCName.");
            }
            this.b5("QName", true);
            let c = b.length > 0 ? this.a(b) : stringEmpty();
            if (c == null) {
                if (this.ck == 3) {
                    c = this.bt(b, false);
                }
                else {
                    throw this.bf(stringFormat("Namespace '{0}' is not declared.", b));
                }
            }
            if (c != stringEmpty()) {
                this.bq.v(c);
                this.bq.v(":");
            }
            this.bq.v(a);
        }
        bz(a, b, c) {
            if (a == null) {
                throw new ArgumentNullException(0, "buffer");
            }
            if (b < 0 || a.length < b) {
                throw this.bg("index");
            }
            if (c < 0 || a.length < b + c) {
                throw this.bg("count");
            }
        }
        k(a, b, c) {
            throw new NotImplementedException(1, "WriteBase64 not implemented");
        }
        l(a, b, c) {
            this.bz(a, b, c);
            this.b5("BinHex", true);
            XmlConvert.ay(a, b, c, this.bq);
        }
        o(a, b, c) {
            this.bz(a, b, c);
            this.b5("Chars", true);
            this.cb(a, b, c, this.ck == 3);
        }
        ag(a, b, c) {
            this.bz(a, b, c);
            this.b5("Raw text", false);
            this.bq.m(a, b, c);
        }
        cd() {
            this.a8(0, false);
        }
        cf() {
            this.a8(-1, false);
        }
        ce() {
            if (!this.a8(0, true)) {
                this.bq.o(' ');
            }
        }
        a8(a, b) {
            if (!this.a1) {
                return false;
            }
            for (let c = this.bl - 1; c >= 0; c--) {
                if (!b && this.au[c].b) {
                    return false;
                }
            }
            if (this.ck != 0) {
                this.bq.v(this.bu);
            }
            for (let d = 0; d < this.bl + a; d++) {
                this.bq.v(this.bs);
            }
            return true;
        }
        b4() {
            if (this.ck != 0) {
                return;
            }
            this.cg(false, false);
        }
        b6(a, b, c, d) {
            let t1 = this.ck;
            L0: while (true) {
                switch (t1) {
                    case 5: throw this.bi(a);
                    case 0:
                        if (d) {
                            this.b0();
                        }
                        if (this.cn == 2 && !c) {
                            this.b4();
                        }
                        this.ck = 1;
                        break;
                    case 3:
                        if (b) {
                            break;
                        }
                        t1 = 5;
                        continue L0;
                    case 2:
                        if (d) {
                            this.b0();
                        }
                        this.b1();
                        break;
                    case 4:
                        if (d) {
                            this.b0();
                        }
                        break;
                }
                break;
            }
        }
        b0() {
            if (this.bl > 0) {
                this.au[this.bl - 1].b = true;
            }
        }
        b5(a, b) {
            let t1 = this.ck;
            L0: while (true) {
                switch (t1) {
                    case 5: throw this.bi(a);
                    case 1:
                    case 0:
                        if (!this.ax || this.a3) {
                            t1 = 5;
                            continue L0;
                        }
                        if (this.cn == 2) {
                            this.b4();
                        }
                        this.b0();
                        this.ck = 4;
                        break;
                    case 3:
                        if (b) {
                            break;
                        }
                        t1 = 5;
                        continue L0;
                    case 2:
                        this.b1();
                        this.b0();
                        break;
                    case 4:
                        this.b0();
                        break;
                }
                break;
            }
        }
        cc(a, b) {
            let c = b ? XmlTextWriter.av : XmlTextWriter.aw;
            let d = indexOfAny(a, c);
            if (d >= 0) {
                let e = stringToCharArray(a);
                this.b8(e, 0, d);
                this.cb(e, d, e.length - d, b);
            }
            else {
                this.b9(a);
            }
        }
        b9(a) {
            let b = XmlChar.t(a, true);
            if (b >= 0) {
                let c = stringToCharArray(a);
                this.bq.m(c, 0, b);
                this.b8(c, b, c.length - b);
            }
            else {
                this.bq.v(a);
            }
        }
        b8(a, b, c) {
            let d = b;
            let e = b + c;
            while ((b = XmlChar.s(a, d, c, true)) >= 0) {
                if (this.ay) {
                    throw this.bf(stringFormat("Input contains invalid character at {0} : &#x{1:X};", b, a[b].charCodeAt(0)));
                }
                if (d < b) {
                    this.bq.m(a, d, b - d);
                }
                this.bq.v("&#x");
                this.bq.v(intToString1(a[b].charCodeAt(0), "X", CultureInfo.invariantCulture));
                this.bq.o(';');
                c -= b - d + 1;
                d = b + 1;
            }
            if (d < e) {
                this.bq.m(a, d, e - d);
            }
        }
        cb(a, b, c, d) {
            let e = b;
            let f = b + c;
            L0: for (let g = e; g < f; g++) {
                let t1 = a[g];
                L1: while (true) {
                    switch (t1) {
                        default: continue L0;
                        case '&':
                        case '<':
                        case '>':
                            if (e < g) {
                                this.b8(a, e, g - e);
                            }
                            this.bq.o('&');
                            switch (a[g]) {
                                case '&':
                                    this.bq.v("amp;");
                                    break;
                                case '<':
                                    this.bq.v("lt;");
                                    break;
                                case '>':
                                    this.bq.v("gt;");
                                    break;
                                case '\'':
                                    this.bq.v("apos;");
                                    break;
                                case '\"':
                                    this.bq.v("quot;");
                                    break;
                            }
                            break;
                        case '\"':
                        case '\'':
                            if (d && a[g] == this.bb) {
                                t1 = '&';
                                continue L1;
                            }
                            continue L0;
                        case '\r':
                            if (g + 1 < f && a[g] == '\n') {
                                g++;
                            }
                            t1 = '\n';
                            continue L1;
                        case '\n':
                            if (e < g) {
                                this.b8(a, e, g - e);
                            }
                            if (d) {
                                this.bq.v(a[g] == '\r' ? "&#xD;" : "&#xA;");
                                break;
                            }
                            switch (this.cj) {
                                case 1:
                                    this.bq.v(a[g] == '\r' ? "&#xD;" : "&#xA;");
                                    break;
                                case 0:
                                    this.bq.v(this.bu);
                                    break;
                                default:
                                    this.bq.o(a[g]);
                                    break;
                            }
                            break;
                    }
                    break;
                }
                e = g + 1;
            }
            if (e < f) {
                this.b8(a, e, f - e);
            }
        }
        bg(a) {
            return new ArgumentOutOfRangeException(1, a);
        }
        bf(a) {
            return new ArgumentException(1, a);
        }
        bh(a) {
            return new InvalidOperationException(1, a);
        }
        bi(a) {
            return this.bh(stringFormat("This XmlWriter does not accept {0} at this state {1}.", a, enumGetBox(WriteState_$type, this.ck)));
        }
    }
    XmlTextWriter.$t = /*@__PURE__*/ markType(XmlTextWriter, 'XmlTextWriter', XmlWriter.$);
    XmlTextWriter.by = /*@__PURE__*/ new UTF8Encoding(0, false, false);
    XmlTextWriter.aw = null;
    XmlTextWriter.av = null;
    return XmlTextWriter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

//
/**
 * @hidden
 */
let XmlTextReader_DtdInputState_$type = /*@__PURE__*/ markEnum('XmlTextReader_DtdInputState', 'Free,1|ElementDecl,2|AttlistDecl,3|EntityDecl,4|NotationDecl,5|PI,6|Comment,7|InsideSingleQuoted,8|InsideDoubleQuoted,9');

//
/**
 * @hidden
 */
let XmlTextReader_DtdInputStateStack = /*@__PURE__*/ (() => {
    class XmlTextReader_DtdInputStateStack extends Base {
        constructor() {
            super();
            this.a = new Array();
            this.b(1);
        }
        c() {
            return EnumUtil.getEnumValue(XmlTextReader_DtdInputState_$type, arrayLast(this.a));
        }
        d() {
            return EnumUtil.getEnumValue(XmlTextReader_DtdInputState_$type, this.a.pop());
        }
        b(a) {
            this.a.push(enumGetBox(XmlTextReader_DtdInputState_$type, a));
        }
    }
    XmlTextReader_DtdInputStateStack.$t = /*@__PURE__*/ markType(XmlTextReader_DtdInputStateStack, 'XmlTextReader_DtdInputStateStack');
    return XmlTextReader_DtdInputStateStack;
})();

//
/**
 * @hidden
 */
let XmlResolver = /*@__PURE__*/ (() => {
    class XmlResolver extends Base {
        d(a, b) {
            if (a == null) {
                if (b == null) {
                    throw new ArgumentNullException(0, "Either baseUri or relativeUri are required.");
                }
                if (stringStartsWith(b, "http:") || stringStartsWith(b, "https:") || stringStartsWith(b, "ftp:") || stringStartsWith(b, "file:")) {
                    return new Uri(0, b);
                }
                throw new InvalidOperationException(1, b + " not supported");
            }
            if (b == null) {
                return a;
            }
            return new Uri(3, a, this.c(b));
        }
        c(a) {
            return stringReplace(stringReplace(stringReplace(stringReplace(stringReplace(a, "<", "%3C"), ">", "%3E"), "#", "%23"), "%", "%25"), "\"", "%22");
        }
    }
    XmlResolver.$t = /*@__PURE__*/ markType(XmlResolver, 'XmlResolver');
    return XmlResolver;
})();

// System.Xml.XmlUrlResolver.cs
/**
 * @hidden
 */
let XmlUrlResolver = /*@__PURE__*/ (() => {
    class XmlUrlResolver extends XmlResolver {
        constructor() {
            super();
            this.e = null;
        }
        set_a(a) {
            this.e = a;
        }
        set a(a) {
            this.set_a(a);
        }
        b(a, b, c) {
            throw new NotImplementedException(0);
        }
        f(a) {
            return stringReplace(stringReplace(stringReplace(stringReplace(stringReplace(stringReplace(a, "%3C", "<"), "%3E", ">"), "%23", "#"), "%22", "\""), "%20", " "), "%25", "%");
        }
    }
    XmlUrlResolver.$t = /*@__PURE__*/ markType(XmlUrlResolver, 'XmlUrlResolver', XmlResolver.$);
    return XmlUrlResolver;
})();

//
/**
 * @hidden
 */
let NonBlockingStreamReader = /*@__PURE__*/ (() => {
    class NonBlockingStreamReader extends TextReader {
        constructor(a, b) {
            super();
            this.l = null;
            this.k = null;
            this.p = 0;
            this.u = 0;
            this.o = 0;
            this.z = null;
            this.x = null;
            this.w = null;
            this.n = false;
            this.ab = null;
            this.m = false;
            let c = 1024;
            this.w = a;
            this.l = new Array(c);
            this.o = c;
            this.z = b;
            this.x = this.y();
            this.k = new Array(b.getMaxCharCount(c));
            this.p = 0;
            this.u = 0;
        }
        y() {
            return this.z.getDecoder();
        }
        get aa() {
            return this.z;
        }
        i() {
            this.dispose1(true);
        }
        dispose1(a) {
            if (a && this.w != null) {
                this.w.close();
            }
            this.l = null;
            this.k = null;
            this.z = null;
            this.x = null;
            this.w = null;
            super.dispose1(a);
        }
        ac() {
            this.u = this.p = 0;
            this.n = false;
            this.x = this.y();
        }
        v() {
            this.u = 0;
            let a = 0;
            this.p = 0;
            let b = 0;
            do {
                a = this.w.read(this.l, 0, this.o);
                if (a == 0) {
                    return 0;
                }
                this.n = (a < this.o);
                this.p += this.x.c(this.l, b, a, this.k, 0);
                b = 0;
            } while (this.p == 0);
            return this.p;
        }
        a() {
            if (this.w == null) {
                throw new ObjectDisposedException(1, "StreamReader", "Cannot read from a closed StreamReader");
            }
            if (this.u >= this.p && (this.n || this.v() == 0)) {
                return -1;
            }
            return this.k[this.u].charCodeAt(0);
        }
        b() {
            if (this.w == null) {
                throw new ObjectDisposedException(1, "StreamReader", "Cannot read from a closed StreamReader");
            }
            if (this.u >= this.p && this.v() == 0) {
                return -1;
            }
            return this.k[this.u++].charCodeAt(0);
        }
        c(a, b, c) {
            if (this.w == null) {
                throw new ObjectDisposedException(1, "StreamReader", "Cannot read from a closed StreamReader");
            }
            if (a == null) {
                throw new ArgumentNullException(0, "dest_buffer");
            }
            if (b < 0) {
                throw new ArgumentOutOfRangeException(2, "index", "< 0");
            }
            if (c < 0) {
                throw new ArgumentOutOfRangeException(2, "count", "< 0");
            }
            if (b > a.length - c) {
                throw new ArgumentException(1, "index + count > dest_buffer.Length");
            }
            let d = 0;
            {
                if (this.u >= this.p && this.v() == 0) {
                    return d > 0 ? d : 0;
                }
                let e = Math.min(this.p - this.u, c);
                arrayCopy1(this.k, this.u, a, b, e);
                this.u += e;
                b += e;
                c -= e;
                d += e;
            }
            return d;
        }
        s() {
            let a = '\0';
            for (; this.u < this.p; this.u++) {
                a = this.k[this.u];
                if (a == '\n') {
                    this.u++;
                    let b = (this.m) ? (this.u - 2) : (this.u - 1);
                    if (b < 0) {
                        b = 0;
                    }
                    this.m = false;
                    return b;
                }
                else if (this.m) {
                    this.m = false;
                    return this.u - 1;
                }
                this.m = (a == '\r');
            }
            return -1;
        }
        g() {
            if (this.w == null) {
                throw new ObjectDisposedException(1, "StreamReader", "Cannot read from a closed StreamReader");
            }
            if (this.u >= this.p && this.v() == 0) {
                return null;
            }
            let a = this.u;
            let b = this.s();
            if (b < this.p && b >= a) {
                return stringCreateFromCharArraySlice(this.k, a, b - a);
            }
            if (this.ab == null) {
                this.ab = new StringBuilder(0);
            }
            else {
                this.ab.c = 0;
            }
            while (true) {
                if (this.m) {
                    this.p--;
                }
                this.ab.l(stringCreateFromCharArraySlice(this.k, a, this.p - a));
                if (this.v() == 0) {
                    if (this.ab.b > 32768) {
                        let c = this.ab;
                        this.ab = null;
                        return c.f(0, c.c);
                    }
                    return this.ab.f(0, this.ab.c);
                }
                a = this.u;
                b = this.s();
                if (b < this.p && b >= a) {
                    this.ab.l(stringCreateFromCharArraySlice(this.k, a, b - a));
                    if (this.ab.b > 32768) {
                        let d = this.ab;
                        this.ab = null;
                        return d.f(0, d.c);
                    }
                    return this.ab.f(0, this.ab.c);
                }
            }
        }
        h() {
            if (this.w == null) {
                throw new ObjectDisposedException(1, "StreamReader", "Cannot read from a closed StreamReader");
            }
            let a = new StringBuilder(0);
            let b = this.k.length;
            let c = new Array(b);
            let d;
            while ((d = this.c(c, 0, b)) != 0) {
                a.g(c, 0, d);
            }
            return a.toString();
        }
    }
    NonBlockingStreamReader.$t = /*@__PURE__*/ markType(NonBlockingStreamReader, 'NonBlockingStreamReader', TextReader.$);
    return NonBlockingStreamReader;
})();

//
/**
 * @hidden
 */
let XmlInputStream = /*@__PURE__*/ (() => {
    class XmlInputStream extends Stream {
        static staticInit() {
            XmlInputStream.strictUTF8 = new UTF8Encoding(0, false, true);
        }
        constructor(a) {
            super();
            this.w = null;
            this.t = null;
            this.o = null;
            this.p = 0;
            this.q = 0;
            this.y(a);
        }
        u(a, b) {
            let c = this.q;
            while (this.q < a + b) {
                if (this.r() < 0) {
                    return null;
                }
            }
            this.q = c;
            return Encoding.aSCII.getString1(this.o, a, b);
        }
        y(a) {
            this.o = new Array(6);
            this.t = a;
            this.w = XmlInputStream.strictUTF8;
            this.p = a.read(this.o, 0, this.o.length);
            if (this.p == -1 || this.p == 0) {
                return;
            }
            let b = this.r();
            switch (b) {
                case 255:
                    b = this.r();
                    if (b == 254) {
                        this.w = Encoding.unicode;
                    }
                    else {
                        this.q = 0;
                    }
                    break;
                case 254:
                    b = this.r();
                    if (b == 255) {
                        this.w = Encoding.bigEndianUnicode;
                        return;
                    }
                    else {
                        this.q = 0;
                    }
                    break;
                case 239:
                    b = this.r();
                    if (b == 187) {
                        b = this.r();
                        if (b != 191) {
                            this.q = 0;
                        }
                    }
                    else {
                        this.o[--this.q] = 239;
                    }
                    break;
                case '<'.charCodeAt(0):
                    if (this.p >= 5 && this.u(1, 4) == "?xml") {
                        this.q += 4;
                        b = this.s();
                        if (b == 'v'.charCodeAt(0)) {
                            while (b >= 0) {
                                b = this.r();
                                if (b == '0'.charCodeAt(0)) {
                                    this.r();
                                    break;
                                }
                            }
                            b = this.s();
                        }
                        if (b == 'e'.charCodeAt(0)) {
                            if (this.u(this.q, 7) == "ncoding") {
                                this.q += 7;
                                b = this.s();
                                if (b != '='.charCodeAt(0)) {
                                    throw XmlInputStream.z;
                                }
                                b = this.s();
                                let c = b;
                                let d = new StringBuilder(0);
                                while (true) {
                                    b = this.r();
                                    if (b == c) {
                                        break;
                                    }
                                    else if (b < 0) {
                                        throw XmlInputStream.z;
                                    }
                                    d.h(String.fromCharCode(b));
                                }
                                let e = d.toString();
                                if (!XmlChar.o(e)) {
                                    throw XmlInputStream.z;
                                }
                                this.w = Encoding.getEncoding(e);
                            }
                        }
                    }
                    this.q = 0;
                    break;
                default:
                    this.q = 0;
                    break;
            }
        }
        r() {
            if (this.p > this.q) {
                return this.o[this.q++];
            }
            let a = new Array(this.o.length * 2);
            Buffer.c(this.o, 0, a, 0, this.p);
            let b = this.t.read(a, this.p, this.o.length);
            if (b == -1 || b == 0) {
                return -1;
            }
            this.p += b;
            this.o = a;
            return this.o[this.q++];
        }
        s() {
            let a;
            L0: while (true) {
                a = this.r();
                let t1 = String.fromCharCode(a);
                L1: while (true) {
                    switch (t1) {
                        case '\r':
                            t1 = ' ';
                            continue L1;
                        case '\n':
                            t1 = ' ';
                            continue L1;
                        case '\t':
                            t1 = ' ';
                            continue L1;
                        case ' ': continue L0;
                        default: return a;
                    }
                    break;
                }
            }
        }
        get actualEncoding() {
            return this.w;
        }
        get_canRead() {
            if (this.p > this.q) {
                return true;
            }
            else {
                return this.t.canRead;
            }
        }
        get canRead() {
            return this.get_canRead();
        }
        get_canSeek() {
            return false;
        }
        get canSeek() {
            return this.get_canSeek();
        }
        get_canWrite() {
            return false;
        }
        get canWrite() {
            return this.get_canWrite();
        }
        get_length() {
            return this.t.length;
        }
        get length() {
            return this.get_length();
        }
        get_position() {
            return this.t.position - this.p + this.q;
        }
        set_position(a) {
            if (a < this.p) {
                this.q = a;
            }
            else {
                this.t.position = a - this.p;
            }
        }
        get position() {
            return this.get_position();
        }
        set position(a) {
            this.set_position(a);
        }
        close() {
            this.t.close();
        }
        flush() {
            this.t.flush();
        }
        read(a, b, c) {
            let d;
            if (c <= this.p - this.q) {
                Buffer.c(this.o, this.q, a, b, c);
                this.q += c;
                d = c;
            }
            else {
                let e = this.p - this.q;
                if (this.p > this.q) {
                    Buffer.c(this.o, this.q, a, b, e);
                    this.q += e;
                }
                d = e + this.t.read(a, b + e, c - e);
            }
            return d;
        }
        readByte() {
            if (this.p > this.q) {
                return this.o[this.q++];
            }
            return this.t.readByte();
        }
        seek(a, b) {
            let c = this.p - this.q;
            if (b == 1) {
                if (a < c) {
                    return this.o[this.q + a];
                }
                else {
                    return this.t.seek(a - c, b);
                }
            }
            else {
                return this.t.seek(a, b);
            }
        }
        setLength(a) {
            this.t.setLength(a);
        }
        write(a, b, c) {
            throw new NotSupportedException(0);
        }
    }
    XmlInputStream.$t = /*@__PURE__*/ markType(XmlInputStream, 'XmlInputStream', Stream.$);
    XmlInputStream.strictUTF8 = null;
    XmlInputStream.z = /*@__PURE__*/ new XmlException(3, "invalid encoding specification.");
    return XmlInputStream;
})();
(function (v) { callStaticConstructors(); })(true);

//
/**
 * @hidden
 */
let XmlStreamReader = /*@__PURE__*/ (() => {
    class XmlStreamReader extends NonBlockingStreamReader {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(c, c.actualEncoding != null ? c.actualEncoding : XmlInputStream.strictUTF8);
                        this.ae = null;
                        this.ae = c;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = [new XmlInputStream(c)];
                        {
                            let f = d[0];
                            super(f, f.actualEncoding != null ? f.actualEncoding : XmlInputStream.strictUTF8);
                            this.ae = null;
                            this.ae = f;
                        }
                    }
                    break;
            }
        }
        i() {
            this.ae.close();
        }
        c(a, b, c) {
            try {
                return super.c(a, b, c);
            }
            catch (d) {
                throw new XmlException(3, "invalid data.");
            }
        }
        dispose1(a) {
            super.dispose1(a);
            if (a) {
                this.i();
            }
        }
    }
    XmlStreamReader.$t = /*@__PURE__*/ markType(XmlStreamReader, 'XmlStreamReader', NonBlockingStreamReader.$);
    XmlStreamReader.ad = /*@__PURE__*/ new XmlException(3, "invalid data.");
    return XmlStreamReader;
})();

//
/**
 * @hidden
 */
let XmlTextReader_TagName = /*@__PURE__*/ (() => {
    class XmlTextReader_TagName extends ValueType {
        constructor(a, ..._rest) {
            super();
            this.b = null;
            this.a = null;
            this.c = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        this.b = c;
                        this.a = d;
                        this.c = e;
                    }
                    break;
            }
        }
    }
    XmlTextReader_TagName.$t = /*@__PURE__*/ markStruct(XmlTextReader_TagName, 'XmlTextReader_TagName');
    return XmlTextReader_TagName;
})();

//
/**
 * @hidden
 */
let XmlParserContext = /*@__PURE__*/ (() => {
    class XmlParserContext extends Base {
        constructor(a, ..._rest) {
            super();
            this.c = stringEmpty();
            this.e = stringEmpty();
            this.o = null;
            this.g = stringEmpty();
            this.u = null;
            this.w = null;
            this.i = stringEmpty();
            this.k = stringEmpty();
            this.m = stringEmpty();
            this.y = 0;
            this.a = null;
            this.b = 0;
            this.s = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = [c, d, null, null, null, null, null, e, f, null];
                        {
                            let i = g[0];
                            let j = g[1];
                            let k = g[2];
                            let l = g[3];
                            let m = g[4];
                            let n = g[5];
                            let o = g[6];
                            let p = g[7];
                            let q = g[8];
                            let r = g[9];
                            let s = [i, j, (k != null && k != stringEmpty()) ? new XmlTextReader(9, TextReader.e, i).d8(k, l, m, n) : null, o, p, q, r];
                            {
                                let u = s[0];
                                let v = s[1];
                                let w = s[2];
                                let x = s[3];
                                let y = s[4];
                                let z = s[5];
                                let aa = s[6];
                                this.u = v;
                                this.w = u != null ? u : v != null ? v.ag : null;
                                if (w != null) {
                                    this.f = w.b;
                                    this.j = w.c;
                                    this.l = w.d;
                                    this.h = w.a;
                                    this.s = w;
                                }
                                this.o = aa;
                                this.d = x;
                                this.n = y;
                                this.y = z;
                                this.a = arrayListCreate();
                            }
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        let h = [c, d, null, null, null, null, null, e, f, g];
                        {
                            let j = h[0];
                            let k = h[1];
                            let l = h[2];
                            let m = h[3];
                            let n = h[4];
                            let o = h[5];
                            let p = h[6];
                            let q = h[7];
                            let r = h[8];
                            let s = h[9];
                            let t = [j, k, (l != null && l != stringEmpty()) ? new XmlTextReader(9, TextReader.e, j).d8(l, m, n, o) : null, p, q, r, s];
                            {
                                let v = t[0];
                                let w = t[1];
                                let x = t[2];
                                let y = t[3];
                                let z = t[4];
                                let aa = t[5];
                                let ab = t[6];
                                this.u = w;
                                this.w = v != null ? v : w != null ? w.ag : null;
                                if (x != null) {
                                    this.f = x.b;
                                    this.j = x.c;
                                    this.l = x.d;
                                    this.h = x.a;
                                    this.s = x;
                                }
                                this.o = ab;
                                this.d = y;
                                this.n = z;
                                this.y = aa;
                                this.a = arrayListCreate();
                            }
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        let h = _rest[5];
                        let i = _rest[6];
                        let j = _rest[7];
                        let k = _rest[8];
                        let l = [c, d, e, f, g, h, i, j, k, null];
                        {
                            let n = l[0];
                            let o = l[1];
                            let p = l[2];
                            let q = l[3];
                            let r = l[4];
                            let s = l[5];
                            let t = l[6];
                            let u = l[7];
                            let v = l[8];
                            let w = l[9];
                            let x = [n, o, (p != null && p != stringEmpty()) ? new XmlTextReader(9, TextReader.e, n).d8(p, q, r, s) : null, t, u, v, w];
                            {
                                let z = x[0];
                                let aa = x[1];
                                let ab = x[2];
                                let ac = x[3];
                                let ad = x[4];
                                let ae = x[5];
                                let af = x[6];
                                this.u = aa;
                                this.w = z != null ? z : aa != null ? aa.ag : null;
                                if (ab != null) {
                                    this.f = ab.b;
                                    this.j = ab.c;
                                    this.l = ab.d;
                                    this.h = ab.a;
                                    this.s = ab;
                                }
                                this.o = af;
                                this.d = ac;
                                this.n = ad;
                                this.y = ae;
                                this.a = arrayListCreate();
                            }
                        }
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        let h = _rest[5];
                        let i = _rest[6];
                        let j = _rest[7];
                        let k = _rest[8];
                        let l = _rest[9];
                        let m = [c, d, (e != null && e != stringEmpty()) ? new XmlTextReader(9, TextReader.e, c).d8(e, f, g, h) : null, i, j, k, l];
                        {
                            let o = m[0];
                            let p = m[1];
                            let q = m[2];
                            let r = m[3];
                            let s = m[4];
                            let t = m[5];
                            let u = m[6];
                            this.u = p;
                            this.w = o != null ? o : p != null ? p.ag : null;
                            if (q != null) {
                                this.f = q.b;
                                this.j = q.c;
                                this.l = q.d;
                                this.h = q.a;
                                this.s = q;
                            }
                            this.o = u;
                            this.d = r;
                            this.n = s;
                            this.y = t;
                            this.a = arrayListCreate();
                        }
                    }
                    break;
                case 4:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        let h = _rest[5];
                        let i = _rest[6];
                        this.u = d;
                        this.w = c != null ? c : d != null ? d.ag : null;
                        if (e != null) {
                            this.f = e.b;
                            this.j = e.c;
                            this.l = e.d;
                            this.h = e.a;
                            this.s = e;
                        }
                        this.o = i;
                        this.d = f;
                        this.n = g;
                        this.y = h;
                        this.a = arrayListCreate();
                    }
                    break;
            }
        }
        get d() {
            return this.c;
        }
        set d(a) {
            this.c = a != null ? a : stringEmpty();
        }
        get f() {
            return this.e != null ? this.e : this.s != null ? this.s.b : null;
        }
        set f(a) {
            this.e = a != null ? a : stringEmpty();
        }
        get t() {
            return this.s;
        }
        set t(a) {
            this.s = a;
        }
        get p() {
            return this.o;
        }
        set p(a) {
            this.o = a;
        }
        get h() {
            return this.g != null ? this.g : this.s != null ? this.s.a : null;
        }
        set h(a) {
            this.g = a != null ? a : stringEmpty();
        }
        get v() {
            return this.u;
        }
        set v(a) {
            this.u = a;
        }
        get x() {
            return this.w;
        }
        set x(a) {
            this.w = a;
        }
        get j() {
            return this.i != null ? this.i : this.s != null ? this.s.c : null;
        }
        set j(a) {
            this.i = a != null ? a : stringEmpty();
        }
        get l() {
            return this.k != null ? this.k : this.s != null ? this.s.d : null;
        }
        set l(a) {
            this.k = a != null ? a : stringEmpty();
        }
        get n() {
            return this.m;
        }
        set n(a) {
            this.m = a != null ? a : stringEmpty();
        }
        get z() {
            return this.y;
        }
        set z(a) {
            this.y = a;
        }
        r() {
            let a = null;
            if (this.a.count == this.b) {
                a = new XmlParserContext_ContextItem();
                this.a.add(a);
            }
            else {
                a = this.a.item(this.b);
            }
            a.a = this.d;
            a.b = this.n;
            a.c = this.z;
            this.b++;
        }
        q() {
            if (this.b == 0) {
                throw new XmlException(3, "Unexpected end of element scope.");
            }
            this.b--;
            let a = this.a.item(this.b);
            this.c = a.a;
            this.m = a.b;
            this.y = a.c;
        }
    }
    XmlParserContext.$t = /*@__PURE__*/ markType(XmlParserContext, 'XmlParserContext');
    return XmlParserContext;
})();
/**
 * @hidden
 */
let XmlTextReader = /*@__PURE__*/ (() => {
    class XmlTextReader extends XmlReader {
        constructor(a, ..._rest) {
            super();
            this.es = null;
            this.er = null;
            this.ep = null;
            this.eq = null;
            this.a9 = new Array(10);
            this.ba = new Array(10);
            this.b6 = 0;
            this.b7 = 0;
            this.b3 = 0;
            this.ej = null;
            this.eg = null;
            this.ef = null;
            this.eb = 0;
            this.bk = false;
            this.ca = 0;
            this.cb = 0;
            this.bj = false;
            this.bq = false;
            this.bb = null;
            this.cc = 0;
            this.be = false;
            this.bl = false;
            this.bz = false;
            this.c0 = null;
            this.c7 = null;
            this.cy = null;
            this.bc = null;
            this.ck = 0;
            this.cl = 0;
            this.b5 = 0;
            this.br = false;
            this.ce = 0;
            this.b4 = 0;
            this.b8 = 0;
            this.b9 = 0;
            this.b2 = false;
            this.ei = 0;
            this.eh = 0;
            this.ch = 0;
            this.bu = false;
            this.bm = true;
            this.ec = 0;
            this.ek = new XmlUrlResolver();
            this.bo = false;
            this.bg = false;
            this.bs = false;
            this.bh = true;
            this.d9 = 0;
            this.ea = null;
            this.bd = null;
            this.eo = new XmlTextReader_DtdInputStateStack();
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = [new XmlStreamReader(1, c)];
                        {
                            let f = d[0];
                            let g = [f, new NameTable()];
                            {
                                let i = g[0];
                                let j = g[1];
                                let k = [stringEmpty(), i, j];
                                {
                                    let m = k[0];
                                    let n = k[1];
                                    let o = k[2];
                                    let p = [m, n, 9, null];
                                    {
                                        let r = p[0];
                                        let s = p[1];
                                        let t = p[2];
                                        let u = p[3];
                                        this.dn(r, u, s, t);
                                    }
                                }
                            }
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = [c, new NameTable()];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h;
                            let i = ((() => { let j = this.cw(f, h); h = j.p1; return j.ret; })());
                            let j = new XmlParserContext(0, g, new XmlNamespaceManager(g), stringEmpty(), 0);
                            this.dn(h, j, new XmlStreamReader(1, i), 9);
                        }
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = [c, new NameTable()];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = [stringEmpty(), f, g];
                            {
                                let j = h[0];
                                let k = h[1];
                                let l = h[2];
                                let m = [j, k, 9, null];
                                {
                                    let o = m[0];
                                    let p = m[1];
                                    let q = m[2];
                                    let r = m[3];
                                    this.dn(o, r, p, q);
                                }
                            }
                        }
                    }
                    break;
                case 4:
                    {
                        let c = _rest[0];
                        let d = [stringEmpty(), null, 0, null];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = d[2];
                            let i = d[3];
                            this.dn(f, i, g, h);
                        }
                    }
                    break;
                case 5:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [new XmlStreamReader(1, c), d];
                        {
                            let g = e[0];
                            let h = e[1];
                            let i = [stringEmpty(), g, h];
                            {
                                let k = i[0];
                                let l = i[1];
                                let m = i[2];
                                let n = [k, l, 9, null];
                                {
                                    let p = n[0];
                                    let q = n[1];
                                    let r = n[2];
                                    let s = n[3];
                                    this.dn(p, s, q, r);
                                }
                            }
                        }
                    }
                    break;
                case 6:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [c, new XmlStreamReader(1, d)];
                        {
                            let g = e[0];
                            let h = e[1];
                            let i = [g, h, new NameTable()];
                            {
                                let k = i[0];
                                let l = i[1];
                                let m = i[2];
                                let n = [k, l, 9, null];
                                {
                                    let p = n[0];
                                    let q = n[1];
                                    let r = n[2];
                                    let s = n[3];
                                    this.dn(p, s, q, r);
                                }
                            }
                        }
                    }
                    break;
                case 7:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [c, d, new NameTable()];
                        {
                            let g = e[0];
                            let h = e[1];
                            let i = e[2];
                            let j = [g, h, 9, null];
                            {
                                let l = j[0];
                                let m = j[1];
                                let n = j[2];
                                let o = j[3];
                                this.dn(l, o, m, n);
                            }
                        }
                    }
                    break;
                case 8:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e;
                        let f = ((() => { let g = this.cw(c, e); e = g.p1; return g.ret; })());
                        let g = new XmlParserContext(0, d, new XmlNamespaceManager(d), stringEmpty(), 0);
                        this.dn(e, g, new XmlStreamReader(1, f), 9);
                    }
                    break;
                case 9:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [stringEmpty(), c, d];
                        {
                            let g = e[0];
                            let h = e[1];
                            let i = e[2];
                            let j = [g, h, 9, null];
                            {
                                let l = j[0];
                                let m = j[1];
                                let n = j[2];
                                let o = j[3];
                                this.dn(l, o, m, n);
                            }
                        }
                    }
                    break;
                case 10:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        if (d == null) {
                            d = new XmlUrlResolver();
                        }
                        this.em = d;
                        let h;
                        let i = ((() => { let j = this.cw(e, h); h = j.p1; return j.ret; })());
                        this.dn(h, g, new XmlStreamReader(1, i), f);
                    }
                    break;
                case 11:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = [e != null ? e.d : stringEmpty(), new XmlStreamReader(1, c), d, e];
                        {
                            let h = f[0];
                            let i = f[1];
                            let j = f[2];
                            let k = f[3];
                            this.dn(h, k, i, j);
                        }
                        this.bk = true;
                    }
                    break;
                case 12:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = [c, d, e, null];
                        {
                            let h = f[0];
                            let i = f[1];
                            let j = f[2];
                            let k = f[3];
                            this.dn(h, k, i, j);
                        }
                    }
                    break;
                case 13:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = [c, new XmlStreamReader(1, d), e];
                        {
                            let h = f[0];
                            let i = f[1];
                            let j = f[2];
                            let k = [h, i, 9, null];
                            {
                                let m = k[0];
                                let n = k[1];
                                let o = k[2];
                                let p = k[3];
                                this.dn(m, p, n, o);
                            }
                        }
                    }
                    break;
                case 14:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = [c, d, 9, null];
                        {
                            let h = f[0];
                            let i = f[1];
                            let j = f[2];
                            let k = f[3];
                            this.dn(h, k, i, j);
                        }
                    }
                    break;
                case 15:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = [e != null ? e.d : stringEmpty(), new StringReader(c), d, e];
                        {
                            let h = f[0];
                            let i = f[1];
                            let j = f[2];
                            let k = f[3];
                            this.dn(h, k, i, j);
                        }
                        this.bk = true;
                    }
                    break;
                case 16:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        this.dn(c, f, d, e);
                    }
                    break;
            }
        }
        cw(a, b) {
            let c = this.ek.d(null, a);
            b = c != null ? c.toString() : stringEmpty();
            return {
                ret: typeCast(Stream.$, this.ek.b(c, null, Stream.$)),
                p1: b
            };
        }
        get_w() {
            return this.b3;
        }
        get w() {
            return this.get_w();
        }
        get_z() {
            return this.ej.d;
        }
        get z() {
            return this.get_z();
        }
        get_a() {
            return true;
        }
        get_b() {
            return true;
        }
        get bf() {
            return this.bg;
        }
        set bf(a) {
            this.bg = a;
        }
        get bi() {
            return this.bh;
        }
        set bi(a) {
            this.bh = a;
        }
        get_x() {
            let a = this.er.n == 1 ? 0 : -1;
            if (this.b7 >= 0) {
                return a + this.cb + 2;
            }
            else if (this.b6 >= 0) {
                return a + this.cb + 1;
            }
            return this.cb;
        }
        get x() {
            return this.get_x();
        }
        get c6() {
            return this.ej.p || Encoding.uTF8;
        }
        get_d() {
            return this.eb == 3;
        }
        get d() {
            return this.get_d();
        }
        get_f() {
            return this.es.k != null;
        }
        get f() {
            return this.get_f();
        }
        get_h() {
            return false;
        }
        get h() {
            return this.get_h();
        }
        get_i() {
            return this.es.a;
        }
        get i() {
            return this.get_i();
        }
        item(a) {
            return this.aa(a);
        }
        item1(a) {
            return this.ab(a);
        }
        item2(a, b) {
            return this.ac(a, b);
        }
        get cf() {
            if (this.b2) {
                return this.ce;
            }
            else {
                return this.es.c;
            }
        }
        get cg() {
            if (this.b2) {
                return this.b4;
            }
            else {
                return this.es.d;
            }
        }
        get_ag() {
            return this.es.g;
        }
        get ag() {
            return this.get_ag();
        }
        get_ai() {
            return this.es.h;
        }
        get ai() {
            return this.get_ai();
        }
        get bn() {
            return this.bm;
        }
        set bn(a) {
            if (this.eb != 0) {
                throw new InvalidOperationException(1, "Namespaces have to be set before reading.");
            }
            this.bm = a;
        }
        get_aj() {
            return this.es.i;
        }
        get aj() {
            return this.get_aj();
        }
        get_a5() {
            return this.eg;
        }
        get a5() {
            return this.get_a5();
        }
        get_a7() {
            return this.es.n;
        }
        get a7() {
            return this.get_a7();
        }
        get bp() {
            return this.bo;
        }
        set bp(a) {
            this.bo = a;
        }
        get_ak() {
            return this.es.j;
        }
        get ak() {
            return this.get_ak();
        }
        get bt() {
            return this.bs;
        }
        set bt(a) {
            this.bs = a;
        }
        get_v() {
            return this.es.b;
        }
        get v() {
            return this.get_v();
        }
        get_a3() {
            return this.eb;
        }
        get a3() {
            return this.get_a3();
        }
        get_ar() {
            return this.es.k != null ? this.es.k : stringEmpty();
        }
        get ar() {
            return this.get_ar();
        }
        get ed() {
            return this.ec;
        }
        set ed(a) {
            this.ec = a;
        }
        get_as() {
            return this.ej.n;
        }
        get as() {
            return this.get_as();
        }
        set em(a) {
            this.ek = a;
        }
        get_a8() {
            return this.ej.z;
        }
        get a8() {
            return this.get_a8();
        }
        au() {
            this.eb = 4;
            this.es.m();
            this.er.m();
            this.b3 = 0;
            if (this.bh && this.cy != null) {
                this.cy.i();
            }
        }
        aa(a) {
            if (a >= this.b3) {
                throw new ArgumentOutOfRangeException(1, "i is smaller than AttributeCount");
            }
            else {
                return this.a9[a].k;
            }
        }
        ab(a) {
            for (let b = 0; b < this.b3; b++) {
                if (this.a9[b].h == a) {
                    return this.a9[b].k;
                }
            }
            return null;
        }
        cd(a, b) {
            b = b != null ? b : stringEmpty();
            for (let c = 0; c < this.b3; c++) {
                let d = this.a9[c];
                if (d.g == a && d.i == b) {
                    return c;
                }
            }
            return -1;
        }
        ac(a, b) {
            let c = this.cd(a, b);
            if (c < 0) {
                return null;
            }
            return this.a9[c].k;
        }
        cx() {
            if (this.cl < 0) {
                return this.cy;
            }
            return new StringReader(stringCreateFromCharArraySlice(this.bc, this.ck, this.cl - this.ck) + this.cy.h());
        }
        ah(a) {
            return this.c1(a, false);
        }
        c1(a, b) {
            let c = this.ef.lookupNamespace1(a, b);
            return c == stringEmpty() ? null : c;
        }
        aw(a) {
            if (a >= this.b3) {
                throw new ArgumentOutOfRangeException(1, "attribute index out of range.");
            }
            this.b6 = a;
            this.b7 = -1;
            this.es = this.a9[a];
        }
        o(a) {
            for (let b = 0; b < this.b3; b++) {
                let c = this.a9[b];
                if (c.h == a) {
                    this.aw(b);
                    return true;
                }
            }
            return false;
        }
        p(a, b) {
            let c = this.cd(a, b);
            if (c < 0) {
                return false;
            }
            this.aw(c);
            return true;
        }
        q() {
            if (this.er == null) {
                return false;
            }
            if (this.es == this.er) {
                return false;
            }
            if (this.b6 >= 0) {
                this.b6 = -1;
                this.b7 = -1;
                this.es = this.er;
                return true;
            }
            else {
                return false;
            }
        }
        r() {
            if (this.b3 == 0) {
                return false;
            }
            this.q();
            return this.s();
        }
        s() {
            if (this.b6 == 0 && this.b3 == 0) {
                return false;
            }
            if (this.b6 + 1 < this.b3) {
                this.b6++;
                this.b7 = -1;
                this.es = this.a9[this.b6];
                return true;
            }
            else {
                return false;
            }
        }
        t() {
            if (this.eb == 4) {
                return false;
            }
            this.b5 = this.ck;
            this.br = true;
            this.ch = 0;
            this.df();
            if (this.ei == 2) {
                if (this.b6 == 0) {
                    return false;
                }
                this.d6();
                this.de();
                this.dk();
                this.ds('\"'.charCodeAt(0));
                this.es = this.a9[0];
                this.b7 = -1;
                this.eb = 1;
                return true;
            }
            if (this.eb == 0 && this.eh == 1) {
                this.d6();
            }
            let a = false;
            this.eb = 1;
            this.b8 = this.ce;
            this.b9 = this.b4;
            this.b2 = true;
            this.es = this.er;
            this.b3 = 0;
            this.b6 = this.b7 = -1;
            this.er.m();
            if (this.bj) {
                ++this.ca;
                this.bj = false;
            }
            if (this.bu) {
                this.bu = false;
                return this.bx();
            }
            a = this.bv();
            if (!a && this.ei == 9 && this.eh != 15) {
                throw this.ee("Document element did not appear.");
            }
            this.b2 = false;
            return a;
        }
        u() {
            if (this.eb == 0 && this.ei == 2) {
                this.t();
            }
            if (this.b6 < 0) {
                return false;
            }
            let a = this.a9[this.b6];
            if (this.b7 < 0) {
                this.b7 = a.q - 1;
            }
            if (this.b7 < a.p) {
                this.b7++;
                this.es = this.ba[this.b7];
                return true;
            }
            else {
                return false;
            }
        }
        cn(a, b, c) {
            return 0;
        }
        co(a, b, c) {
            return 0;
        }
        cr(a, b, c) {
            if (b < 0) {
                throw new ArgumentOutOfRangeException(3, "offset", b, "Offset must be non-negative integer.");
            }
            else if (c < 0) {
                throw new ArgumentOutOfRangeException(3, "length", c, "Length must be non-negative integer.");
            }
            else if (a.length < b + c) {
                throw new ArgumentOutOfRangeException(1, "buffer length is smaller than the sum of offset and length.");
            }
            if (this.i) {
                this.t();
                return 0;
            }
            if (!this.bu && this.a7 != 1) {
                return 0;
            }
            this.br = false;
            this.bu = true;
            this.b2 = true;
            return this.cs(a, b, c);
        }
        d2() {
            if (this.bk) {
                throw new InvalidOperationException(1, "Cannot call ResetState when parsing an XML fragment.");
            }
            this.dd();
        }
        a1() {
            throw new InvalidOperationException(1, "XmlTextReader cannot resolve external entities.");
        }
        get el() {
            return this.ek;
        }
        ee(a) {
            return new XmlException(2, typeCast(IXmlLineInfo_$type, this), this.z, a);
        }
        initXmlTextReader() {
            this.be = false;
            this.bb = new Array(10);
            this.c7 = new StringBuilder(0);
            this.bg = true;
            this.bs = false;
            this.bh = true;
            this.d9 = 2;
            this.ck = 0;
            if (this.bc == null) {
                this.bc = new Array(1024);
            }
            this.cl = -1;
            this.b5 = -1;
            this.ce = 1;
            this.b4 = 1;
            this.b8 = this.b9 = 0;
            this.dd();
        }
        dd() {
            this.er = new XmlTextReader_XmlTokenInfo(this);
            this.es = this.er;
            this.b6 = -1;
            this.b7 = -1;
            this.b3 = 0;
            this.eb = 0;
            this.ca = 0;
            this.cb = 0;
            this.bj = false;
            this.bq = this.be = false;
            this.cc = 0;
            this.bl = false;
            this.bz = false;
            this.c0 = stringEmpty();
            this.b2 = false;
            this.eh = 0;
            this.bu = false;
        }
        dn(a, b, c, d) {
            this.ei = d;
            this.ej = b;
            if (b == null) {
                let e = new NameTable();
                this.ej = new XmlParserContext(0, e, new XmlNamespaceManager(e), stringEmpty(), 0);
            }
            this.eg = this.ej.x;
            this.eg = this.eg != null ? this.eg : new NameTable();
            this.ef = this.ej.v;
            this.ef = this.ef != null ? this.ef : new XmlNamespaceManager(this.eg);
            if (a != null && a.length > 0) {
                let f = null;
                try {
                    f = new Uri(0, a);
                }
                catch (g) {
                    throw g;
                }
                this.ej.d = f.toString();
            }
            this.initXmlTextReader();
            this.cy = c;
            switch (d) {
                case 2:
                    this.cy = new StringReader(stringReplace(c.h(), "\"", "&quot;"));
                    break;
                case 1:
                    this.eh = 1;
                    this.be = true;
                    break;
                case 9: break;
                default: throw new XmlException(3, stringFormat("NodeType {0} is not allowed to create XmlTextReader.", enumGetBox(XmlNodeType_$type, d)));
            }
        }
        d4(a, b, c, d, e, f, g) {
            this.d5(this.er, a, b, c, d, e, f, g);
            this.er.c = this.b8;
            this.er.d = this.b9;
        }
        d5(a, b, c, d, e, f, g, h) {
            a.n = b;
            a.h = c;
            a.j = d;
            a.g = e;
            a.a = f;
            a.k = g;
            this.cb = this.ca;
            if (h) {
                this.de();
            }
        }
        de() {
            this.b3 = 0;
            this.b6 = -1;
            this.b7 = -1;
        }
        cm(a) {
            if (this.cl <= this.ck + 1) {
                if (!this.bw(a)) {
                    return a;
                }
            }
            let b = this.bc[this.ck].charCodeAt(0);
            let c = this.bc[this.ck + 1].charCodeAt(0);
            if (((b & 64512) != 55296) || ((c & 64512) != 56320)) {
                return b;
            }
            return 65536 + (b - 55296) * 1024 + (c - 56320);
        }
        ci() {
            if (this.ck < this.cl) {
                let a = this.bc[this.ck].charCodeAt(0);
                if (a == 0) {
                    return -1;
                }
                if (a < 55296 || a >= 57343) {
                    return a;
                }
                return this.cm(a);
            }
            else {
                if (!this.bw(-1)) {
                    return -1;
                }
                return this.ci();
            }
        }
        cp() {
            let a = this.ci();
            this.ck++;
            if (a >= 65536) {
                this.ck++;
            }
            if (a == '\n'.charCodeAt(0)) {
                this.ce++;
                this.b4 = 1;
            }
            else if (a != -1) {
                this.b4++;
            }
            return a;
        }
        c9(a) {
            this.ck++;
            if (a >= 65536) {
                this.ck++;
            }
            if (a == '\n'.charCodeAt(0)) {
                this.ce++;
                this.b4 = 1;
            }
            else if (a != -1) {
                this.b4++;
            }
        }
        bw(a) {
            if (this.cl < 0) {
                this.cl = this.cy.c(this.bc, 0, this.bc.length);
                return this.cl > 0;
            }
            let b = a >= 0 ? 1 : 0;
            let c = this.cl - this.b5;
            if (!this.br) {
                this.b5 = 0;
                this.ck = 0;
            }
            else if (this.cl < this.bc.length) {
            }
            else if (this.b5 <= (this.cl >> 1)) {
                let d = new Array(this.bc.length * 2);
                arrayCopy1(this.bc, this.b5, d, 0, c);
                this.bc = d;
                this.b5 = 0;
                this.ck = c;
            }
            else {
                arrayCopy1(this.bc, this.b5, this.bc, 0, c);
                this.b5 = 0;
                this.ck = c;
            }
            if (a >= 0) {
                this.bc[this.ck] = String.fromCharCode(a);
            }
            let e = this.bc.length - this.ck - b;
            if (e > 1024) {
                e = 1024;
            }
            let f = this.cy.c(this.bc, this.ck + b, e);
            let g = b + f;
            this.cl = this.ck + g;
            return (g != 0);
        }
        bv() {
            if (this.bq) {
                this.ef.h();
                this.ej.q();
                this.bq = false;
            }
            if (this.bz) {
                this.d3();
            }
            else {
                let a = this.ci();
                if (a == -1) {
                    this.eb = 3;
                    this.df();
                    this.d4(0, stringEmpty(), stringEmpty(), stringEmpty(), false, null, true);
                    if (this.ca > 0) {
                        throw this.ee("unexpected end of file. Current depth is " + this.ca);
                    }
                    return false;
                }
                else {
                    switch (a) {
                        case 60:
                            this.c9(a);
                            switch (this.ci()) {
                                case 47:
                                    this.c9(47);
                                    this.dx();
                                    break;
                                case 63:
                                    this.c9(63);
                                    this.dz();
                                    break;
                                case 33:
                                    this.c9(33);
                                    this.dv();
                                    break;
                                default:
                                    this.d0();
                                    break;
                            }
                            break;
                        case 13:
                        case 10:
                        case 9:
                        case 32:
                            if (!this.by()) {
                                return this.bv();
                            }
                            break;
                        default:
                            this.d1(true);
                            break;
                    }
                }
            }
            return this.a3 != 3;
        }
        d3() {
            this.df();
            this.d4(5, this.c0, stringEmpty(), this.c0, false, null, true);
            this.bz = false;
            this.c0 = stringEmpty();
        }
        d0() {
            if (this.eh == 15) {
                throw this.ee("Multiple document element was detected.");
            }
            this.eh = 1;
            this.ef.ac();
            this.b8 = this.ce;
            this.b9 = this.b4;
            let a, b;
            let c = ((() => { let d = this.c3(a, b); a = d.p0; b = d.p1; return d.ret; })());
            if (this.eh == 15) {
                throw this.ee("document has terminated, cannot open new element");
            }
            let d = false;
            this.de();
            this.b0();
            if (XmlChar.e(this.ci())) {
                this.dr(false);
            }
            this.es = this.er;
            for (let e = 0; e < this.b3; e++) {
                this.a9[e].u();
            }
            for (let f = 0; f < this.b3; f++) {
                this.a9[f].t();
            }
            if (this.bm) {
                for (let g = 0; g < this.b3; g++) {
                    if (this.a9[g].j == "xmlns" && this.a9[g].k == stringEmpty()) {
                        throw this.ee("Empty namespace URI cannot be mapped to non-empty prefix.");
                    }
                }
            }
            for (let h = 0; h < this.b3; h++) {
                for (let i = h + 1; i < this.b3; i++) {
                    if (Base.referenceEquals(this.a9[h].h, this.a9[i].h) || (Base.referenceEquals(this.a9[h].g, this.a9[i].g) && Base.referenceEquals(this.a9[h].i, this.a9[i].i))) {
                        throw this.ee("Attribute name and qualified name must be identical.");
                    }
                }
            }
            if (this.ci() == '/'.charCodeAt(0)) {
                this.c9('/'.charCodeAt(0));
                d = true;
                this.bq = true;
            }
            else {
                this.bj = true;
                this.dq(c, b, a);
            }
            this.ej.r();
            this.dg('>'.charCodeAt(0));
            this.d4(1, c, a, b, d, null, false);
            if (a.length > 0) {
                this.er.i = this.c1(a, true);
            }
            else if (this.bm) {
                this.er.i = this.ef.n;
            }
            if (this.bm) {
                if (this.aj == null) {
                    throw this.ee(stringFormat("'{0}' is undeclared namespace.", this.ak));
                }
                try {
                    for (let j = 0; j < this.b3; j++) {
                        this.aw(j);
                        if (this.aj == null) {
                            throw this.ee(stringFormat("'{0}' is undeclared namespace.", this.ak));
                        }
                    }
                }
                finally {
                    this.q();
                }
            }
            for (let k = 0; k < this.b3; k++) {
                if (!Base.referenceEquals(this.a9[k].j, "xml")) {
                    continue;
                }
                let l = this.a9[k].g;
                let m = this.a9[k].k;
                switch (l) {
                    case "base":
                        if (this.ek != null) {
                            let n = this.z != stringEmpty() ? new Uri(0, this.z) : null;
                            if (n == null && stringIsNullOrEmpty(m)) {
                                break;
                            }
                            let o = this.ek.d(n, m);
                            this.ej.d = o != null ? o.toString() : stringEmpty();
                        }
                        else {
                            this.ej.d = m;
                        }
                        break;
                    case "lang":
                        this.ej.n = m;
                        break;
                    case "space":
                        switch (m) {
                            case "preserve":
                                this.ej.z = 2;
                                break;
                            case "default":
                                this.ej.z = 1;
                                break;
                            default: throw this.ee(stringFormat("Invalid xml:space value: {0}", m));
                        }
                        break;
                }
            }
            if (this.i) {
                this.dc();
            }
        }
        dq(a, b, c) {
            if (this.bb.length == this.cc) {
                let d = new Array(this.bb.length * 2);
                arrayCopy1(this.bb, 0, d, 0, this.cc);
                this.bb = d;
            }
            this.bb[this.cc++] = new XmlTextReader_TagName(1, a, b, c);
        }
        dx() {
            if (this.eh != 1) {
                throw this.ee("End tag cannot appear in this state.");
            }
            this.b8 = this.ce;
            this.b9 = this.b4;
            if (this.cc == 0) {
                throw this.ee("closing element without matching opening element");
            }
            let a = this.bb[--this.cc];
            this.dh(a.b);
            this.di('>');
            --this.ca;
            this.d4(15, a.b, a.c, a.a, false, null, true);
            if (a.c.length > 0) {
                this.er.i = this.c1(a.c, true);
            }
            else if (this.bm) {
                this.er.i = this.ef.n;
            }
            this.bq = true;
            this.dc();
        }
        dc() {
            if (this.ca == 0 && !this.be && (this.i || this.a7 == 15)) {
                this.eh = 15;
            }
        }
        db(a) {
            if (a <= charMaxValue().charCodeAt(0)) {
                this.c7.h(String.fromCharCode(a));
            }
            else {
                this.da(a);
            }
        }
        da(a) {
            this.c7.h(String.fromCharCode((intDivide((a - 65536), 1024) + 55296)));
            this.c7.h(String.fromCharCode(((a - 65536) % 1024 + 56320)));
        }
        cz() {
            switch (this.a7) {
                case 13:
                case 14:
                    let a = this.c7.c;
                    if (this.bd == null) {
                        this.bd = new Array(32);
                    }
                    if (a >= this.bd.length) {
                        break;
                    }
                    if (this.ea == null) {
                        this.ea = new NameTable();
                    }
                    for (let b = 0; b < a; b++) {
                        this.bd[b] = this.c7.item(b);
                    }
                    return this.ea.a(this.bd, 0, this.c7.c);
            }
            return (this.c7.b < 100) ? this.c7.f(0, this.c7.c) : this.c7.toString();
        }
        df() {
            this.c7.c = 0;
        }
        d1(a) {
            if (this.eh != 1) {
                throw this.ee("Text node cannot appear in this state.");
            }
            this.br = false;
            if (a) {
                this.df();
            }
            let b = this.ci();
            let c = false;
            while (b != '<'.charCodeAt(0) && b != -1) {
                if (b == '&'.charCodeAt(0)) {
                    this.cp();
                    b = this.cu(false);
                    if (this.bz) {
                        break;
                    }
                }
                else if (this.bo && b == '\r'.charCodeAt(0)) {
                    this.cp();
                    b = this.ci();
                    if (b != '\n'.charCodeAt(0)) {
                        this.db('\n'.charCodeAt(0));
                    }
                    continue;
                }
                else {
                    if (this.bf && XmlChar.f(b)) {
                        throw this.ee("Not allowed character was found.");
                    }
                    b = this.cp();
                }
                {
                    if (b <= charMaxValue().charCodeAt(0)) {
                        this.c7.h(String.fromCharCode(b));
                    }
                    else {
                        this.da(b);
                    }
                }
                if (b == ']'.charCodeAt(0)) {
                    if (c) {
                        if (this.ci() == '>'.charCodeAt(0)) {
                            throw this.ee("Inside text content, character sequence ']]>' is not allowed.");
                        }
                    }
                    c = true;
                }
                else if (c) {
                    c = false;
                }
                b = this.ci();
                a = true;
            }
            if (this.bz && this.c7.c == 0) {
                this.d3();
            }
            else {
                let d = a ? 3 : this.a8 == 2 ? 14 : 13;
                this.d4(d, stringEmpty(), stringEmpty(), stringEmpty(), false, null, true);
            }
        }
        cu(a) {
            if (this.ci() == '#'.charCodeAt(0)) {
                this.c9('#'.charCodeAt(0));
                return this.cq();
            }
            else {
                return this.ct(a);
            }
        }
        cq() {
            let a = 0;
            let b;
            if (this.ci() == 'x'.charCodeAt(0)) {
                this.c9('x'.charCodeAt(0));
                while ((b = this.ci()) != ';'.charCodeAt(0) && b != -1) {
                    this.c9(b);
                    if (b >= '0'.charCodeAt(0) && b <= '9'.charCodeAt(0)) {
                        a = (a << 4) + b - '0'.charCodeAt(0);
                    }
                    else if (b >= 'A'.charCodeAt(0) && b <= 'F'.charCodeAt(0)) {
                        a = (a << 4) + b - 'A'.charCodeAt(0) + 10;
                    }
                    else if (b >= 'a'.charCodeAt(0) && b <= 'f'.charCodeAt(0)) {
                        a = (a << 4) + b - 'a'.charCodeAt(0) + 10;
                    }
                    else {
                        throw this.ee(stringFormat2(CultureInfo.invariantCulture, "invalid hexadecimal digit: {0} (#x{1:X})", String.fromCharCode(b), b));
                    }
                }
            }
            else {
                while ((b = this.ci()) != ';'.charCodeAt(0) && b != -1) {
                    this.c9(b);
                    if (b >= '0'.charCodeAt(0) && b <= '9'.charCodeAt(0)) {
                        a = a * 10 + b - '0'.charCodeAt(0);
                    }
                    else {
                        throw this.ee(stringFormat2(CultureInfo.invariantCulture, "invalid decimal digit: {0} (#x{1:X})", String.fromCharCode(b), b));
                    }
                }
            }
            this.cp();
            if (this.bf && this.bp && XmlChar.f(a)) {
                throw this.ee("Referenced character was not allowed in XML. Normalization is " + this.bo + ", checkCharacters = " + this.bg);
            }
            return a;
        }
        ct(a) {
            let b = this.c2();
            this.dg(';'.charCodeAt(0));
            let c = XmlChar.r(b);
            if (c >= 0) {
                return c;
            }
            else {
                if (a) {
                    this.db('&'.charCodeAt(0));
                    for (let d = 0; d < b.length; d++) {
                        this.db(b.charAt(d).charCodeAt(0));
                    }
                    this.db(';'.charCodeAt(0));
                }
                else {
                    this.bz = true;
                    this.c0 = b;
                }
            }
            return -1;
        }
        dr(a) {
            let b = -1;
            let c = false;
            this.b6 = -1;
            this.b7 = -1;
            do {
                if (!this.b0() && c) {
                    throw this.ee("Unexpected token. Name is required here.");
                }
                this.dk();
                this.ep.c = this.ce;
                this.ep.d = this.b4;
                let d, e;
                this.ep.h = ((() => { let f = this.c3(d, e); d = f.p0; e = f.p1; return f.ret; })());
                this.ep.j = d;
                this.ep.g = e;
                this.di('=');
                this.b0();
                this.ds(-1);
                let f;
                if (a) {
                    f = this.ep.k;
                }
                this.b3++;
                if (!this.b0()) {
                    c = true;
                }
                b = this.ci();
                if (a) {
                    if (b == '?'.charCodeAt(0)) {
                        break;
                    }
                }
                else if (b == '/'.charCodeAt(0) || b == '>'.charCodeAt(0)) {
                    break;
                }
            } while (b != -1);
            this.b6 = -1;
            this.b7 = -1;
        }
        c8(a, b) {
            this.dk();
            let c = this.a9[this.b6];
            c.h = this.a5.b(a);
            c.j = stringEmpty();
            c.i = stringEmpty();
            this.dl();
            let d = this.ba[this.b7];
            this.d5(d, 3, stringEmpty(), stringEmpty(), stringEmpty(), false, b, false);
            c.k = b;
            this.b3++;
        }
        dk() {
            this.b6++;
            if (this.a9.length == this.b6) {
                let a = new Array(this.a9.length * 2);
                arrayCopyTo(this.a9, a, 0);
                this.a9 = a;
            }
            if (this.a9[this.b6] == null) {
                this.a9[this.b6] = new XmlTextReader_XmlAttributeTokenInfo(this);
            }
            this.ep = this.a9[this.b6];
            this.ep.m();
        }
        dl() {
            this.b7++;
            if (this.ba.length == this.b7) {
                let a = new Array(this.ba.length * 2);
                arrayCopyTo(this.ba, a, 0);
                this.ba = a;
            }
            if (this.ba[this.b7] == null) {
                this.ba[this.b7] = new XmlTextReader_XmlTokenInfo(this);
            }
            this.eq = this.ba[this.b7];
            this.eq.m();
        }
        ds(a) {
            let b = (a < 0) ? this.cp() : a;
            if (b != '\''.charCodeAt(0) && b != '\"'.charCodeAt(0)) {
                throw this.ee("an attribute value was not quoted");
            }
            this.ep.b = String.fromCharCode(b);
            this.dl();
            this.ep.q = this.b7;
            this.eq.c = this.ce;
            this.eq.d = this.b4;
            let c = false;
            let d = true;
            let e = true;
            let f = 0;
            this.eq.f = this.c7.c;
            L0: while (e) {
                f = this.cp();
                if (f == b) {
                    break;
                }
                if (c) {
                    this.dl();
                    this.eq.f = this.c7.c;
                    this.eq.c = this.ce;
                    this.eq.d = this.b4;
                    c = false;
                    d = true;
                }
                let t1 = f;
                L1: while (true) {
                    switch (t1) {
                        case '<'.charCodeAt(0): throw this.ee("attribute values cannot contain '<'");
                        case -1:
                            if (a < 0) {
                                throw this.ee("unexpected end of file in an attribute value");
                            }
                            else {
                                e = false;
                            }
                            break;
                        case '\r'.charCodeAt(0):
                            if (!this.bo) {
                                t1 = void 0;
                                continue L1;
                            }
                            if (this.ci() == '\n'.charCodeAt(0)) {
                                continue L0;
                            }
                            if (!this.bo) {
                                t1 = void 0;
                                continue L1;
                            }
                            f = ' '.charCodeAt(0);
                            t1 = void 0;
                            continue L1;
                        case '\n'.charCodeAt(0):
                        case '\t'.charCodeAt(0):
                            if (!this.bo) {
                                t1 = void 0;
                                continue L1;
                            }
                            f = ' '.charCodeAt(0);
                            t1 = void 0;
                            continue L1;
                        case '&'.charCodeAt(0):
                            if (this.ci() == '#'.charCodeAt(0)) {
                                this.c9('#'.charCodeAt(0));
                                f = this.cq();
                                this.db(f);
                                break;
                            }
                            let g = this.c2();
                            this.dg(';'.charCodeAt(0));
                            let h = XmlChar.r(g);
                            if (h < 0) {
                                {
                                    this.eq.e = this.c7.c;
                                    this.eq.n = 3;
                                    if (!d) {
                                        this.dl();
                                    }
                                    this.eq.h = g;
                                    this.eq.k = stringEmpty();
                                    this.eq.n = 5;
                                    c = true;
                                }
                            }
                            else {
                                this.db(h);
                            }
                            break;
                        default:
                            if (this.bf && XmlChar.f(f)) {
                                throw this.ee("Invalid character was found.");
                            }
                            {
                                if (f <= charMaxValue().charCodeAt(0)) {
                                    this.c7.h(String.fromCharCode(f));
                                }
                                else {
                                    this.da(f);
                                }
                            }
                            break;
                    }
                    break;
                }
                d = false;
            }
            if (!c) {
                this.eq.e = this.c7.c;
                this.eq.n = 3;
            }
            this.ep.p = this.b7;
        }
        dz() {
            let a = this.c2();
            if (a != "xml" && stringToLocaleLower(a, CultureInfo.invariantCulture) == "xml") {
                throw this.ee("Not allowed processing instruction name which starts with 'X', 'M', 'L' was found.");
            }
            if (!this.b0()) {
                if (this.ci() != '?'.charCodeAt(0)) {
                    throw this.ee("Invalid processing instruction name was found.");
                }
            }
            this.df();
            let b;
            while ((b = this.ci()) != -1) {
                this.c9(b);
                if (b == '?'.charCodeAt(0) && this.ci() == '>'.charCodeAt(0)) {
                    this.c9('>'.charCodeAt(0));
                    break;
                }
                if (this.bf && XmlChar.f(b)) {
                    throw this.ee("Invalid character was found.");
                }
                this.db(b);
            }
            if (Base.referenceEquals(a, "xml")) {
                this.d7();
            }
            else {
                if (this.eh == 0) {
                    this.eh = 17;
                }
                this.d4(7, a, stringEmpty(), a, false, null, true);
            }
        }
        d7() {
            if (!this.be && this.eh != 0) {
                throw this.ee("XML declaration cannot appear in this state.");
            }
            this.eh = 17;
            let a = this.cz();
            this.de();
            let b = 0;
            let c = null, d = null;
            let e, f;
            let g = this.dp(a, b, e, f);
            b = g.p1;
            e = g.p2;
            f = g.p3;
            if (e != "version" || f != "1.0") {
                throw this.ee("'version' is expected.");
            }
            e = stringEmpty();
            if (((() => { let h = this.b1(a, b); b = h.p1; return h.ret; })()) && b < a.length) {
                let h = this.dp(a, b, e, f);
                b = h.p1;
                e = h.p2;
                f = h.p3;
            }
            if (e == "encoding") {
                if (!XmlChar.o(f)) {
                    throw this.ee("'encoding' must be a valid IANA encoding name.");
                }
                if (typeCast(XmlStreamReader.$, this.cy) !== null) {
                    this.ej.p = this.cy.aa;
                }
                else {
                    if (this.ej.p == null && stringCompare1(f, "UTF-8", 2) == 0) {
                        this.ej.p = Encoding.uTF8;
                    }
                    else {
                        this.ej.p = Encoding.unicode;
                    }
                }
                c = f;
                e = stringEmpty();
                if (((() => { let i = this.b1(a, b); b = i.p1; return i.ret; })()) && b < a.length) {
                    let i = this.dp(a, b, e, f);
                    b = i.p1;
                    e = i.p2;
                    f = i.p3;
                }
            }
            if (e == "standalone") {
                this.bl = f == "yes";
                if (f != "yes" && f != "no") {
                    throw this.ee("Only 'yes' or 'no' is allow for 'standalone'");
                }
                d = f;
                let j = this.b1(a, b);
                b = j.p1;
            }
            else if (e.length != 0) {
                throw this.ee(stringFormat("Unexpected token: '{0}'", e));
            }
            if (b < a.length) {
                throw this.ee("'?' is expected.");
            }
            this.c8("version", "1.0");
            if (c != null) {
                this.c8("encoding", c);
            }
            if (d != null) {
                this.c8("standalone", d);
            }
            this.b6 = this.b7 = -1;
            this.d4(17, "xml", stringEmpty(), "xml", false, a, false);
        }
        b1(a, b) {
            let c = b;
            while (b < a.length && XmlChar.p(a.charAt(b).charCodeAt(0))) {
                b++;
            }
            return {
                ret: b - c > 0,
                p1: b
            };
        }
        dp(a, b, c, d) {
            while (b < a.length && XmlChar.p(a.charAt(b).charCodeAt(0))) {
                b++;
            }
            let e = b;
            while (b < a.length && XmlChar.h(a.charAt(b).charCodeAt(0))) {
                b++;
            }
            c = a.substr(e, b - e);
            while (b < a.length && XmlChar.p(a.charAt(b).charCodeAt(0))) {
                b++;
            }
            if (b == a.length || a.charAt(b) != '=') {
                throw this.ee(stringFormat("'=' is expected after {0}", c));
            }
            b++;
            while (b < a.length && XmlChar.p(a.charAt(b).charCodeAt(0))) {
                b++;
            }
            if (b == a.length || a.charAt(b) != '\"' && a.charAt(b) != '\'') {
                throw this.ee("'\"' or ''' is expected.");
            }
            let f = a.charAt(b);
            b++;
            e = b;
            while (b < a.length && a.charAt(b) != f) {
                b++;
            }
            b++;
            d = a.substr(e, b - e - 1);
            return {
                p1: b,
                p2: c,
                p3: d
            };
        }
        d6() {
            if (this.ci() != '<'.charCodeAt(0)) {
                return;
            }
            this.cp();
            if (this.ci() != '?'.charCodeAt(0)) {
                this.ck = 0;
                return;
            }
            this.cp();
            while (this.ck < 6) {
                if (this.ci() < 0) {
                    break;
                }
                else {
                    this.cp();
                }
            }
            if (stringCreateFromCharArraySlice(this.bc, 2, 4) != "xml ") {
                if (stringToLocaleLower(stringCreateFromCharArraySlice(this.bc, 2, 4), CultureInfo.invariantCulture) == "xml ") {
                    throw this.ee("Processing instruction name must not be character sequence 'X' 'M' 'L' with case insensitivity.");
                }
                this.ck = 0;
                return;
            }
            this.b0();
            if (this.ci() == 'v'.charCodeAt(0)) {
                this.dh("version");
                this.di('=');
                this.b0();
                let a = this.cp();
                let b = new Array(3);
                let c = 0;
                switch (a) {
                    case '\''.charCodeAt(0):
                    case '\"'.charCodeAt(0):
                        while (this.ci() != a) {
                            if (this.ci() == -1) {
                                throw this.ee("Invalid version declaration inside text declaration.");
                            }
                            else if (c == 3) {
                                throw this.ee("Invalid version number inside text declaration.");
                            }
                            else {
                                b[c] = String.fromCharCode(this.cp());
                                c++;
                                if (c == 3 && stringCreateFromCharArray(b) != "1.0") {
                                    throw this.ee("Invalid version number inside text declaration.");
                                }
                            }
                        }
                        this.cp();
                        this.b0();
                        break;
                    default: throw this.ee("Invalid version declaration inside text declaration.");
                }
            }
            if (this.ci() == 'e'.charCodeAt(0)) {
                this.dh("encoding");
                this.di('=');
                this.b0();
                let d = this.cp();
                switch (d) {
                    case '\''.charCodeAt(0):
                    case '\"'.charCodeAt(0):
                        while (this.ci() != d) {
                            if (this.cp() == -1) {
                                throw this.ee("Invalid encoding declaration inside text declaration.");
                            }
                        }
                        this.cp();
                        this.b0();
                        break;
                    default: throw this.ee("Invalid encoding declaration inside text declaration.");
                }
            }
            this.dh("?>");
            this.b5 = this.ck;
        }
        dv() {
            let a = this.ci();
            switch (a) {
                case '-'.charCodeAt(0):
                    this.dh("--");
                    this.du();
                    break;
                case '['.charCodeAt(0):
                    this.cp();
                    this.dh("CDATA[");
                    this.dt();
                    break;
                case 'D'.charCodeAt(0):
                    this.dh("DOCTYPE");
                    this.dw();
                    break;
                default: throw this.ee("Unexpected declaration markup was found.");
            }
        }
        du() {
            if (this.eh == 0) {
                this.eh = 17;
            }
            this.br = false;
            this.df();
            let a;
            while ((a = this.ci()) != -1) {
                this.c9(a);
                if (a == '-'.charCodeAt(0) && this.ci() == '-'.charCodeAt(0)) {
                    this.c9('-'.charCodeAt(0));
                    if (this.ci() != '>'.charCodeAt(0)) {
                        throw this.ee("comments cannot contain '--'");
                    }
                    this.c9('>'.charCodeAt(0));
                    break;
                }
                if (XmlChar.f(a)) {
                    throw this.ee("Not allowed character was found.");
                }
                this.db(a);
            }
            this.d4(8, stringEmpty(), stringEmpty(), stringEmpty(), false, null, true);
        }
        dt() {
            if (this.eh != 1) {
                throw this.ee("CDATA section cannot appear in this state.");
            }
            this.br = false;
            this.df();
            let a = false;
            let b = 0;
            while (this.ci() != -1) {
                if (!a) {
                    b = this.cp();
                }
                a = false;
                if (b == ']'.charCodeAt(0) && this.ci() == ']'.charCodeAt(0)) {
                    b = this.cp();
                    if (this.ci() == '>'.charCodeAt(0)) {
                        this.cp();
                        break;
                    }
                    else {
                        a = true;
                    }
                }
                if (this.bo && b == '\r'.charCodeAt(0)) {
                    b = this.ci();
                    if (b != '\n'.charCodeAt(0)) {
                        this.db('\n'.charCodeAt(0));
                    }
                    continue;
                }
                if (this.bf && XmlChar.f(b)) {
                    throw this.ee("Invalid character was found.");
                }
                {
                    if (b <= charMaxValue().charCodeAt(0)) {
                        this.c7.h(String.fromCharCode(b));
                    }
                    else {
                        this.da(b);
                    }
                }
            }
            this.d4(4, stringEmpty(), stringEmpty(), stringEmpty(), false, null, true);
        }
        dw() {
            if (this.bs) {
                throw this.ee("Document Type Declaration (DTD) is prohibited in this XML.");
            }
            switch (this.eh) {
                case 10:
                case 1:
                case 15: throw this.ee("Document type cannot appear in this state.");
            }
            this.eh = 10;
            let a = null;
            let b = null;
            let c = null;
            let d = 0;
            let e = 0;
            this.b0();
            a = this.c2();
            this.b0();
            switch (this.ci()) {
                case 'S'.charCodeAt(0):
                    c = this.c5(true);
                    break;
                case 'P'.charCodeAt(0):
                    b = this.c4();
                    if (!this.b0()) {
                        throw this.ee("Whitespace is required between PUBLIC id and SYSTEM id.");
                    }
                    c = this.c5(false);
                    break;
            }
            this.b0();
            if (this.ci() == '['.charCodeAt(0)) {
                this.cp();
                d = this.cf;
                e = this.cg;
                this.df();
                this.dy();
                this.ej.h = this.cz();
            }
            this.di('>');
            this.d4(10, a, stringEmpty(), a, false, this.ej.h, true);
            if (b != null) {
                this.c8("PUBLIC", b);
            }
            if (c != null) {
                this.c8("SYSTEM", c);
            }
            this.b6 = this.b7 = -1;
        }
        d8(a, b, c, d) {
            return new DTDObjectModel();
        }
        get en() {
            return this.eo.c();
        }
        cv() {
            let a = this.cp();
            this.db(a);
            return a;
        }
        dj(a) {
            this.dh(a);
            this.c7.l(a);
        }
        dy() {
            let a = true;
            L0: while (a) {
                switch (this.cv()) {
                    case ']'.charCodeAt(0):
                        switch (this.en) {
                            case 1:
                                this.c7.y(this.c7.c - 1, 1);
                                a = false;
                                break;
                            case 9:
                            case 8:
                            case 7: continue L0;
                            default: throw this.ee("unexpected end of file at DTD.");
                        }
                        break;
                    case -1: throw this.ee("unexpected end of file at DTD.");
                    case '<'.charCodeAt(0):
                        switch (this.en) {
                            case 9:
                            case 8:
                            case 7: continue L0;
                        }
                        let b = this.cv();
                        switch (b) {
                            case '?'.charCodeAt(0):
                                this.eo.b(6);
                                break;
                            case '!'.charCodeAt(0):
                                switch (this.cv()) {
                                    case 'E'.charCodeAt(0):
                                        switch (this.cv()) {
                                            case 'L'.charCodeAt(0):
                                                this.dj("EMENT");
                                                this.eo.b(2);
                                                break;
                                            case 'N'.charCodeAt(0):
                                                this.dj("TITY");
                                                this.eo.b(4);
                                                break;
                                            default: throw this.ee("unexpected token '<!E'.");
                                        }
                                        break;
                                    case 'A'.charCodeAt(0):
                                        this.dj("TTLIST");
                                        this.eo.b(3);
                                        break;
                                    case 'N'.charCodeAt(0):
                                        this.dj("OTATION");
                                        this.eo.b(5);
                                        break;
                                    case '-'.charCodeAt(0):
                                        this.dj("-");
                                        this.eo.b(7);
                                        break;
                                }
                                break;
                            default: throw this.ee(stringFormat("unexpected '<{0}'.", String.fromCharCode(b)));
                        }
                        break;
                    case '\''.charCodeAt(0):
                        if (this.en == 8) {
                            this.eo.d();
                        }
                        else if (this.en != 9 && this.en != 7) {
                            this.eo.b(8);
                        }
                        break;
                    case '\"'.charCodeAt(0):
                        if (this.en == 9) {
                            this.eo.d();
                        }
                        else if (this.en != 8 && this.en != 7) {
                            this.eo.b(9);
                        }
                        break;
                    case '>'.charCodeAt(0):
                        let t1 = this.en;
                        L1: while (true) {
                            switch (t1) {
                                case 2:
                                    t1 = 5;
                                    continue L1;
                                case 3:
                                    t1 = 5;
                                    continue L1;
                                case 4:
                                    t1 = 5;
                                    continue L1;
                                case 5:
                                    this.eo.d();
                                    break;
                                case 9:
                                case 8:
                                case 7: continue L0;
                                default: throw this.ee("unexpected token '>'");
                            }
                            break;
                        }
                        break;
                    case '?'.charCodeAt(0):
                        if (this.en == 6) {
                            if (this.cv() == '>'.charCodeAt(0)) {
                                this.eo.d();
                            }
                        }
                        break;
                    case '-'.charCodeAt(0):
                        if (this.en == 7) {
                            if (this.ci() == '-'.charCodeAt(0)) {
                                this.cv();
                                this.dj(">");
                                this.eo.d();
                            }
                        }
                        break;
                    case '%'.charCodeAt(0):
                        if (this.en != 1 && this.en != 4 && this.en != 7 && this.en != 9 && this.en != 8) {
                            throw this.ee("Parameter Entity Reference cannot appear as a part of markupdecl (see XML spec 2.8).");
                        }
                        break;
                }
            }
        }
        c5(a) {
            if (a) {
                this.dh("SYSTEM");
                if (!this.b0()) {
                    throw this.ee("Whitespace is required after 'SYSTEM'.");
                }
            }
            else {
                this.b0();
            }
            let b = this.cp();
            let c = 0;
            this.df();
            while (c != b) {
                c = this.cp();
                if (c < 0) {
                    throw this.ee("Unexpected end of stream in ExternalID.");
                }
                if (c != b) {
                    this.db(c);
                }
            }
            return this.cz();
        }
        c4() {
            this.dh("PUBLIC");
            if (!this.b0()) {
                throw this.ee("Whitespace is required after 'PUBLIC'.");
            }
            let a = this.cp();
            let b = 0;
            this.df();
            while (b != a) {
                b = this.cp();
                if (b < 0) {
                    throw this.ee("Unexpected end of stream in ExternalID.");
                }
                if (b != a && !XmlChar.m(b)) {
                    throw this.ee(stringFormat("character '{0}' not allowed for PUBLIC ID", String.fromCharCode(b)));
                }
                if (b != a) {
                    this.db(b);
                }
            }
            return this.cz();
        }
        c2() {
            let a, b;
            return ((() => { let c = this.c3(a, b); a = c.p0; b = c.p1; return c.ret; })());
        }
        c3(a, b) {
            let c = this.br;
            this.br = true;
            let d = this.ck - this.b5;
            let e = this.ci();
            if (!XmlChar.e(e)) {
                throw this.ee(stringFormat2(CultureInfo.invariantCulture, "a name did not start with a legal character {0} ({1})", e, String.fromCharCode(e)));
            }
            this.c9(e);
            let f = 1;
            let g = -1;
            while (XmlChar.h((e = this.ci()))) {
                this.c9(e);
                if (e == ':'.charCodeAt(0) && this.bm && g < 0) {
                    g = f;
                }
                f++;
            }
            let h = this.b5 + d;
            let i = this.a5.a(this.bc, h, f);
            if (g > 0) {
                a = this.a5.a(this.bc, h, g);
                b = this.a5.a(this.bc, h + g + 1, f - g - 1);
            }
            else {
                a = stringEmpty();
                b = i;
            }
            this.br = c;
            return {
                ret: i,
                p0: a,
                p1: b
            };
        }
        dg(a) {
            let b = this.cp();
            if (b != a) {
                throw this.ee(stringFormat2(CultureInfo.invariantCulture, "expected '{0}' ({1:X}) but found '{2}' ({3:X})", String.fromCharCode(a), a, b < 0 ? "EOF" : String.fromCharCode(b), b));
            }
        }
        dh(a) {
            for (let b = 0; b < a.length; b++) {
                if (this.cp() != a.charAt(b).charCodeAt(0)) {
                    throw this.ee(stringFormat2(CultureInfo.invariantCulture, "'{0}' is expected", a));
                }
            }
        }
        di(a) {
            while (true) {
                let b = this.cp();
                if (b < 33 && XmlChar.p(b)) {
                    continue;
                }
                if (a.charCodeAt(0) != b) {
                    throw this.ee(stringFormat2(CultureInfo.invariantCulture, "Expected {0}, but found {1} [{2}]", a, b < 0 ? "EOF" : String.fromCharCode(b), b));
                }
                break;
            }
        }
        b0() {
            let a = this.ci();
            let b = (a == 32 || a == 9 || a == 10 || a == 13);
            if (!b) {
                return false;
            }
            this.c9(a);
            while ((a = this.ci()) == 32 || a == 9 || a == 10 || a == 13) {
                this.c9(a);
            }
            return b;
        }
        by() {
            if (this.eh == 0) {
                this.eh = 17;
            }
            let a = this.br;
            this.br = true;
            let b = this.ck - this.b5;
            let c = this.ci();
            do {
                this.c9(c);
                c = this.ci();
            } while (c == 32 || c == 9 || c == 10 || c == 13);
            let d = this.eh == 1 && c != -1 && c != '<'.charCodeAt(0);
            if (!d && (this.ec == 2 || this.ec == 1 && this.a8 != 2)) {
                return false;
            }
            this.df();
            this.c7.g(this.bc, this.b5, this.ck - this.b5 - b);
            this.br = a;
            if (d) {
                this.d1(false);
            }
            else {
                let e = (this.a8 == 2) ? 14 : 13;
                this.d4(e, stringEmpty(), stringEmpty(), stringEmpty(), false, null, true);
            }
            return true;
        }
        cs(a, b, c) {
            let d = b;
            for (let e = 0; e < c; e++) {
                let f = this.ci();
                switch (f) {
                    case -1: throw this.ee("Unexpected end of xml.");
                    case '<'.charCodeAt(0):
                        if (e + 1 == c) {
                            return e;
                        }
                        this.c9(f);
                        if (this.ci() != '/'.charCodeAt(0)) {
                            this.ch++;
                            a[d++] = '<';
                            continue;
                        }
                        else if (this.ch-- > 0) {
                            a[d++] = '<';
                            continue;
                        }
                        this.dg('/'.charCodeAt(0));
                        if (this.bj) {
                            this.ca++;
                            this.bj = false;
                        }
                        this.dx();
                        this.bu = false;
                        this.t();
                        return e;
                    default:
                        this.c9(f);
                        if (f <= charMaxValue().charCodeAt(0)) {
                            a[d++] = String.fromCharCode(f);
                        }
                        else {
                            a[d++] = String.fromCharCode((intDivide((f - 65536), 1024) + 55296));
                            a[d++] = String.fromCharCode(((f - 65536) % 1024 + 56320));
                        }
                        break;
                }
            }
            return c;
        }
        bx() {
            if (this.x == 0) {
                this.eh = 15;
            }
            let a;
            do {
                a = this.cp();
                switch (a) {
                    case -1: throw this.ee("Unexpected end of xml.");
                    case '<'.charCodeAt(0):
                        if (this.ci() != '/'.charCodeAt(0)) {
                            this.ch++;
                            continue;
                        }
                        else if (--this.ch > 0) {
                            continue;
                        }
                        this.cp();
                        let b = this.c2();
                        if (b != this.bb[this.cc - 1].b) {
                            continue;
                        }
                        this.dg('>'.charCodeAt(0));
                        this.ca--;
                        return this.t();
                }
            } while (true);
        }
    }
    XmlTextReader.$t = /*@__PURE__*/ markType(XmlTextReader, 'XmlTextReader', XmlReader.$);
    return XmlTextReader;
})();
/**
 * @hidden
 */
let XmlTextReader_XmlTokenInfo = /*@__PURE__*/ (() => {
    class XmlTextReader_XmlTokenInfo extends Base {
        constructor(a) {
            super();
            this.l = null;
            this.o = null;
            this.h = null;
            this.g = null;
            this.j = null;
            this.i = null;
            this.a = false;
            this.b = '\0';
            this.c = 0;
            this.d = 0;
            this.f = 0;
            this.e = 0;
            this.n = 0;
            this.o = a;
            this.m();
        }
        get_k() {
            if (this.l == null) {
                if (this.f >= 0) {
                    this.l = this.o.c7.f(this.f, this.e - this.f);
                }
                else {
                    switch (this.n) {
                        case 3:
                        case 14:
                        case 13:
                        case 8:
                        case 4:
                        case 7:
                            this.l = this.o.cz();
                            break;
                    }
                }
            }
            return this.l;
        }
        set_k(a) {
            this.l = a;
        }
        get k() {
            return this.get_k();
        }
        set k(a) {
            this.set_k(a);
        }
        m() {
            this.f = -1;
            this.l = null;
            this.n = 0;
            this.h = this.g = this.j = this.i = stringEmpty();
            this.a = false;
            this.b = '\"';
            this.c = this.d = 0;
        }
    }
    XmlTextReader_XmlTokenInfo.$t = /*@__PURE__*/ markType(XmlTextReader_XmlTokenInfo, 'XmlTextReader_XmlTokenInfo');
    return XmlTextReader_XmlTokenInfo;
})();
/**
 * @hidden
 */
let XmlTextReader_XmlAttributeTokenInfo = /*@__PURE__*/ (() => {
    class XmlTextReader_XmlAttributeTokenInfo extends XmlTextReader_XmlTokenInfo {
        constructor(a) {
            super(a);
            this.q = 0;
            this.p = 0;
            this.r = null;
            this.s = new StringBuilder(0);
            this.n = 2;
        }
        get_k() {
            if (this.r != null) {
                return this.r;
            }
            if (this.q == this.p) {
                let a = this.o.ba[this.q];
                if (a.n == 5) {
                    this.r = stringConcat("&", a.h, ";");
                }
                else {
                    this.r = a.k;
                }
                return this.r;
            }
            this.s.c = 0;
            for (let b = this.q; b <= this.p; b++) {
                let c = this.o.ba[b];
                if (c.n == 3) {
                    this.s.l(c.k);
                }
                else {
                    this.s.h('&');
                    this.s.l(c.h);
                    this.s.h(';');
                }
            }
            this.r = this.s.f(0, this.s.c);
            return this.r;
        }
        set_k(a) {
            this.r = a;
        }
        m() {
            super.m();
            this.r = null;
            this.n = 2;
            this.q = this.p = 0;
        }
        u() {
            if (Base.referenceEquals(this.j, "xmlns")) {
                this.o.ef.x(this.g, this.k);
            }
            else if (Base.referenceEquals(this.h, "xmlns")) {
                this.o.ef.x(stringEmpty(), this.k);
            }
        }
        t() {
            if (Base.referenceEquals(this.j, "xmlns") || Base.referenceEquals(this.h, "xmlns")) {
                this.i = "http://www.w3.org/2000/xmlns/";
            }
            else if (this.j.length == 0) {
                this.i = stringEmpty();
            }
            else {
                this.i = this.o.c1(this.j, true);
            }
        }
    }
    XmlTextReader_XmlAttributeTokenInfo.$t = /*@__PURE__*/ markType(XmlTextReader_XmlAttributeTokenInfo, 'XmlTextReader_XmlAttributeTokenInfo', XmlTextReader_XmlTokenInfo.$);
    return XmlTextReader_XmlAttributeTokenInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

// XmlSpace.cs
/**
 * Specifies the current xml:space scope
 */
var XmlSpace = /*@__PURE__*/ (function (XmlSpace) {
    /**
     * No xml:space scope.
     */
    XmlSpace[XmlSpace["None"] = 0] = "None";
    /**
     * the xml:space scope = "default"
     */
    XmlSpace[XmlSpace["Default"] = 1] = "Default";
    /**
     * the xml:space scope = "preserve"
     */
    XmlSpace[XmlSpace["Preserve"] = 2] = "Preserve";
    return XmlSpace;
})({});
/**
 * @hidden
 */
let XmlSpace_$type = /*@__PURE__*/ markEnum('XmlSpace', 'None,0|Default,1|Preserve,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

// From https://github.com/mosa/Mono-Class-Libraries/blob/28840dee90750d61ed6cbdb753292cd64cac169e/mcs/class/System.XML/System.Xml/XmlTextWriter2.cs
/**
 * @hidden
 */
let XmlTextWriter_XmlDeclState_$type = /*@__PURE__*/ markEnum('XmlTextWriter_XmlDeclState', 'Allow,0|Ignore,1|Auto,2|Prohibit,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

export { APIFactory, AbsolutePanelBridge, AbsoluteVolumeOscillatorIndicatorDescription, AbsoluteVolumeOscillatorIndicatorDescriptionMetadata, AbsoluteVolumeOscillatorIndicatorDescriptionModule, AbstractEnumerable, AbstractEnumerator, AccumulationDistributionIndicatorDescription, AccumulationDistributionIndicatorDescriptionMetadata, AccumulationDistributionIndicatorDescriptionModule, Activator, AggregateException, AggregatedDataProvider, AggregatedDataProviderLayerInfo, AggregatedDataProviderLayerMap, AggregatedDataProviderTargetDataSourceNotifier, AggregatedDataProviderTopLayer, AlignLinearGraphLabelEventArgsDescription, AlignLinearGraphLabelEventArgsDescriptionMetadata, AlignRadialGaugeLabelEventArgsDescription, AlignRadialGaugeLabelEventArgsDescriptionMetadata, AnchoredCategorySeriesDescription, AnchoredCategorySeriesDescriptionMetadata, AnchoredRadialSeriesDescription, AnchoredRadialSeriesDescriptionMetadata, AngleSimplifier, AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter, AngularTemplateCodeGeneratingComponentRendererCodeEmitter, AnimationBrowserTickProvider, AnimationIdleEventArgsDescription, AnimationIdleEventArgsDescriptionMetadata, AnimationKeyFrame, AnimationKeyFrameEffect, AnimationKeyFrameEffectTargetType_$type, AnimationKeyFrameEffectTiming, AnimationKeyFrameProperty, AnimationManager, AnimationState, AnnotationLayerDescription, AnnotationLayerDescriptionMetadata, AnnotationLayerProxyDescriptionModule, AppearanceHelper, ApplyButtonClickEventArgsDescription, ApplyButtonClickEventArgsDescriptionMetadata, ArcGISOnlineMapImageryDescription, ArcGISOnlineMapImageryDescriptionMetadata, ArcGISOnlineMapImageryDescriptionModule, ArcGISOnlineTileSource, ArcSegment, ArcSegmentData, AreaFragmentDescription, AreaFragmentDescriptionMetadata, AreaFragmentDescriptionModule, AreaSeriesDescription, AreaSeriesDescriptionMetadata, AreaSeriesDescriptionModule, ArgumentException, ArgumentNullException, ArgumentOutOfRangeException, ArrayAccessHelper, ArrayBox$1, ArrayExtension, Array_$type, AsciiEncoding, AssigningCategoryMarkerStyleEventArgsDescription, AssigningCategoryMarkerStyleEventArgsDescriptionMetadata, AssigningCategoryStyleEventArgsBaseDescription, AssigningCategoryStyleEventArgsBaseDescriptionMetadata, AssigningCategoryStyleEventArgsDescription, AssigningCategoryStyleEventArgsDescriptionMetadata, AssigningPolarMarkerStyleEventArgsDescription, AssigningPolarMarkerStyleEventArgsDescriptionMetadata, AssigningPolarStyleEventArgsBaseDescription, AssigningPolarStyleEventArgsBaseDescriptionMetadata, AssigningPolarStyleEventArgsDescription, AssigningPolarStyleEventArgsDescriptionMetadata, AssigningRadialMarkerStyleEventArgsDescription, AssigningRadialMarkerStyleEventArgsDescriptionMetadata, AssigningRadialStyleEventArgsBaseDescription, AssigningRadialStyleEventArgsBaseDescriptionMetadata, AssigningRadialStyleEventArgsDescription, AssigningRadialStyleEventArgsDescriptionMetadata, AssigningScatterMarkerStyleEventArgsDescription, AssigningScatterMarkerStyleEventArgsDescriptionMetadata, AssigningScatterStyleEventArgsBaseDescription, AssigningScatterStyleEventArgsBaseDescriptionMetadata, AssigningScatterStyleEventArgsDescription, AssigningScatterStyleEventArgsDescriptionMetadata, AssigningSeriesShapeStyleEventArgsBaseDescription, AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata, AssigningSeriesStyleEventArgsBaseDescription, AssigningSeriesStyleEventArgsBaseDescriptionMetadata, AssigningShapeMarkerStyleEventArgsDescription, AssigningShapeMarkerStyleEventArgsDescriptionMetadata, AssigningShapeStyleEventArgsBaseDescription, AssigningShapeStyleEventArgsBaseDescriptionMetadata, AssigningShapeStyleEventArgsDescription, AssigningShapeStyleEventArgsDescriptionMetadata, AsyncCompletedEventArgs, AsyncCompletedEventArgsDescription, AsyncCompletedEventArgsDescriptionMetadata, AsyncDataSourcePageRequest, AsyncDataSourcePageTaskHolder, AsyncVirtualDataSourceDataProviderWorkerSettings, AsyncVirtualDataSourceProviderTaskDataHolder, AsyncVirtualDataSourceProviderWorker, AsyncVirtualDataTask, AverageDirectionalIndexIndicatorDescription, AverageDirectionalIndexIndicatorDescriptionMetadata, AverageDirectionalIndexIndicatorDescriptionModule, AverageSummaryCalculator, AverageTrueRangeIndicatorDescription, AverageTrueRangeIndicatorDescriptionMetadata, AverageTrueRangeIndicatorDescriptionModule, AxisAnnotationDescription, AxisAnnotationDescriptionMetadata, AxisDescription, AxisDescriptionMetadata, AxisRangeChangedEventArgsDescription, AxisRangeChangedEventArgsDescriptionMetadata, BarFragmentDescription, BarFragmentDescriptionMetadata, BarFragmentDescriptionModule, BarSeriesDescription, BarSeriesDescriptionMetadata, BarSeriesDescriptionModule, Base, BaseControlTheme, BaseControlTheme_$type, BaseDOMEventProxy, BaseDataSource, BaseDataSourceDescription, BaseDataSourceDescriptionMetadata, BaseError, BaseTransactionService, BezierSegment, BezierSegmentData, BinaryFileDownloader, BinaryReader, BinaryUtil, BinaryWriter, Binding, BindingFormatter, BingMapsMapImageryDescription, BingMapsMapImageryDescriptionMetadata, BingMapsMapImageryDescriptionModule, BingMapsTileSource, BitArray, BitConverter, BlazorCodeBehindCodeGeneratingComponentRendererCodeEmitter, BlazorCodeGeneratingComponentRendererModuleEmitter, BlazorRazorCodeGeneratingComponentRendererCodeEmitter, BollingerBandWidthIndicatorDescription, BollingerBandWidthIndicatorDescriptionMetadata, BollingerBandWidthIndicatorDescriptionModule, BollingerBandsOverlayDescription, BollingerBandsOverlayDescriptionMetadata, BollingerBandsOverlayDescriptionModule, Boolean_$type, BottomClipper, BoxCollisionGeometry, BoxesCollisionGeometry, Brush, BrushAppearanceData, BrushCollection, BrushCollectionUtil, BrushScaleDescription, BrushScaleDescriptionMetadata, BrushScaleDescriptionModule, BrushUtil, BrushUtilCore, BubbleSeriesDescription, BubbleSeriesDescriptionMetadata, BubbleSeriesDescriptionModule, Buffer, BulletGraphCoreDescriptionModule, BulletGraphDescription, BulletGraphDescriptionMetadata, BulletGraphDescriptionModule, ButtonClickEventArgsDescription, ButtonClickEventArgsDescriptionMetadata, ButtonDescription, ButtonDescriptionMetadata, ButtonDescriptionModule, ButtonGroupDescription, ButtonGroupDescriptionMetadata, ButtonGroupDescriptionModule, ButtonGroupSelectionChangedEventArgsDescription, ButtonGroupSelectionChangedEventArgsDescriptionMetadata, CSSColorUtil, CalculatedColumnDescription, CalculatedColumnDescriptionMetadata, Calendar, CalendarDateDescription, CalendarDateDescriptionMetadata, CalendarDescription, CalendarDescriptionMetadata, CalendarDescriptionModule, CalendarFormatOptionsDescription, CalendarFormatOptionsDescriptionMetadata, CalendarWeekRule_$type, CalloutAnnotationDescription, CalloutAnnotationDescriptionMetadata, CalloutCollisionMode, CalloutCollisionMode_$type, CalloutContentUpdatingEventArgsDescription, CalloutContentUpdatingEventArgsDescriptionMetadata, CalloutLabelUpdatingEventArgsDescription, CalloutLabelUpdatingEventArgsDescriptionMetadata, CalloutLayerDescription, CalloutLayerDescriptionMetadata, CalloutLayerDescriptionModule, CalloutRenderStyleUpdatingEventArgsDescription, CalloutRenderStyleUpdatingEventArgsDescriptionMetadata, CalloutSeriesSelectingEventArgsDescription, CalloutSeriesSelectingEventArgsDescriptionMetadata, CalloutStyleUpdatingEventArgsDescription, CalloutStyleUpdatingEventArgsDescriptionMetadata, CancelBehavior, CancelBehavior_$type, CancelButtonClickEventArgsDescription, CancelButtonClickEventArgsDescriptionMetadata, CancelEventArgs, CancelEventArgsDescription, CancelEventArgsDescriptionMetadata, CancellingMultiScaleImageEventArgs, CancellingMultiScaleImageEventArgsDescription, CancellingMultiScaleImageEventArgsDescriptionMetadata, Canvas, CanvasGestureDOMEventProxy, CanvasRenderScheduler, CanvasViewRenderer, Capture, CaptureImageFormat, CaptureImageFormat_$type, CaptureImageSettings, CaptureImageSettingsDescription, CaptureImageSettingsDescriptionMetadata, CategoryAngleAxisDescription, CategoryAngleAxisDescriptionMetadata, CategoryAngleAxisDescriptionModule, CategoryAxisBaseDescription, CategoryAxisBaseDescriptionMetadata, CategoryChartCoreDescriptionModule, CategoryChartDescription, CategoryChartDescriptionMetadata, CategoryChartDescriptionModule, CategoryChartToolbarDescriptionModule, CategoryDateTimeXAxisDescription, CategoryDateTimeXAxisDescriptionMetadata, CategoryDateTimeXAxisDescriptionModule, CategoryHighlightLayerDescription, CategoryHighlightLayerDescriptionMetadata, CategoryHighlightLayerDescriptionModule, CategoryItemHighlightLayerDescription, CategoryItemHighlightLayerDescriptionMetadata, CategoryItemHighlightLayerDescriptionModule, CategorySeriesDescription, CategorySeriesDescriptionMetadata, CategoryToolTipLayerDescription, CategoryToolTipLayerDescriptionMetadata, CategoryToolTipLayerDescriptionModule, CategoryXAxisDescription, CategoryXAxisDescriptionMetadata, CategoryXAxisDescriptionModule, CategoryYAxisDescription, CategoryYAxisDescriptionMetadata, CategoryYAxisDescriptionModule, CellActionManagerDescription, CellActionManagerDescriptionMetadata, CellInfoDescription, CellInfoDescriptionMetadata, CellKeyDescription, CellKeyDescriptionMetadata, CellKeyDescriptionModule, CellRangeDescription, CellRangeDescriptionMetadata, CellRangeDescriptionModule, CellStyleRequestedEventArgsDescription, CellStyleRequestedEventArgsDescriptionMetadata, ChaikinOscillatorIndicatorDescription, ChaikinOscillatorIndicatorDescriptionMetadata, ChaikinOscillatorIndicatorDescriptionModule, ChaikinVolatilityIndicatorDescription, ChaikinVolatilityIndicatorDescriptionMetadata, ChaikinVolatilityIndicatorDescriptionModule, ChartCursorEventArgsDescription, ChartCursorEventArgsDescriptionMetadata, ChartGroupDescriptionDescription, ChartGroupDescriptionDescriptionMetadata, ChartGroupDescriptionDescriptionModule, ChartMouseEventArgsDescription, ChartMouseEventArgsDescriptionMetadata, ChartSelectionDescription, ChartSelectionDescriptionMetadata, ChartSelectionDescriptionModule, ChartSeriesEventArgsDescription, ChartSeriesEventArgsDescriptionMetadata, ChartSortDescriptionDescription, ChartSortDescriptionDescriptionMetadata, ChartSortDescriptionDescriptionModule, ChartSummaryDescriptionDescription, ChartSummaryDescriptionDescriptionMetadata, ChartSummaryDescriptionDescriptionModule, CheckboxChangeEventArgsDescription, CheckboxChangeEventArgsDescriptionMetadata, CheckboxDescription, CheckboxDescriptionMetadata, CheckboxDescriptionModule, CheckboxListDescription, CheckboxListDescriptionMetadata, CheckboxListDescriptionModule, CheckedChangedEventArgsDescription, CheckedChangedEventArgsDescriptionMetadata, ChildContentDescriptionModule, ChildContentExtendedDescriptionModule, CircleCollisionGeometry, Clipboard, Clipper, CodeGeneratingCodeWriter, CodeGeneratingComponentRenderer, CodeGeneratingComponentRendererCodeEmitter, CodeGeneratingComponentRendererDataEmitter, CodeGeneratingComponentRendererDataEmitterItemType, CodeGeneratingComponentRendererDataEmitterPropertyType, CodeGeneratingComponentRendererHandlerEmitter, CodeGeneratingComponentRendererModuleEmitter, CodeGeneratingComponentRendererTemplateEmitter, CodeGeneratingImportManager, CodeGeneratingRegexHelper, CodeGeneratingRendererResult, CodeGenerationContainer, CodeGenerationFolderTemplate, CodeGenerationItemBuilder, CodeGenerationItemBuilderPropertyInfo, CodeGenerationLibrary, CodeGenerationLibraryItem, CodeGenerationLibraryItemContent, CodeGenerationLibraryItemContentConfiguration, CodeGenerationLibraryItemContentLocation, CodeGenerationLibraryItemContentLocation_$type, CodeGenerationLibraryItemPlatform, CodeGenerationLibraryItemPlatform_$type, CodeGenerationLibraryItemType, CodeGenerationLibraryItemType_$type, CodeGenerationRendererAdapter, CodeGenerationRendererOptions, CodeGenerationSpecialValue, CodeGenerationSpecialValueType_$type, CodeGenerationTargetPlatforms, CodeGenerationTargetPlatforms_$type, CodeGenerationTransformer, Collection$1, CollectionAdapter, CollisionGeometry, CollisionGeometryType, CollisionGeometryType_$type, CollisionRect, Color, ColorCollectionUtil, ColorData, ColorScaleDescription, ColorScaleDescriptionMetadata, ColorUtil, ColumnChooserDescription, ColumnChooserDescriptionMetadata, ColumnChooserDescriptionModule, ColumnComparisonFilterConditionDescription, ColumnComparisonFilterConditionDescriptionMetadata, ColumnCustomFilterConditionDescription, ColumnCustomFilterConditionDescriptionMetadata, ColumnDependenciesDescriptionModule, ColumnExchangerDescription, ColumnExchangerDescriptionMetadata, ColumnFilterConditionDescription, ColumnFilterConditionDescriptionMetadata, ColumnFilterConditionGroupDescription, ColumnFilterConditionGroupDescriptionMetadata, ColumnFragmentDescription, ColumnFragmentDescriptionMetadata, ColumnFragmentDescriptionModule, ColumnGroupDescriptionDescription, ColumnGroupDescriptionDescriptionMetadata, ColumnGroupDescriptionDescriptionModule, ColumnGroupingDescription, ColumnGroupingDescriptionMetadata, ColumnGroupingDescriptionModule, ColumnHiddenChangedEventArgsDescription, ColumnHiddenChangedEventArgsDescriptionMetadata, ColumnMovingSeparatorDescription, ColumnMovingSeparatorDescriptionMetadata, ColumnMovingSeparatorDescriptionModule, ColumnPinnedChangedEventArgsDescription, ColumnPinnedChangedEventArgsDescriptionMetadata, ColumnPinningDescription, ColumnPinningDescriptionMetadata, ColumnPinningDescriptionModule, ColumnPropertySetterDescription, ColumnPropertySetterDescriptionMetadata, ColumnReference, ColumnResizingSeparatorDescription, ColumnResizingSeparatorDescriptionMetadata, ColumnResizingSeparatorDescriptionModule, ColumnSeriesDescription, ColumnSeriesDescriptionMetadata, ColumnSeriesDescriptionModule, ColumnSortDescriptionDescription, ColumnSortDescriptionDescriptionMetadata, ColumnSortDescriptionDescriptionModule, ColumnSummaryDescriptionDescription, ColumnSummaryDescriptionDescriptionMetadata, ColumnSummaryDescriptionDescriptionModule, ColumnSupportingCalculationDescription, ColumnSupportingCalculationDescriptionMetadata, ColumnWidthDescription, ColumnWidthDescriptionMetadata, ColumnWidthDescriptionModule, ComboBoxColumnDescription, ComboBoxColumnDescriptionMetadata, ComboBoxColumnDescriptionModule, CommodityChannelIndexIndicatorDescription, CommodityChannelIndexIndicatorDescriptionMetadata, CommodityChannelIndexIndicatorDescriptionModule, CompareInfo, CompareUtil, Comparer$1, CompletedSinkImpl, ComponentRenderer, ComponentRendererAdapter, ComponentRendererMethodHelper, ComponentRendererMethodHelperArgumentBuilder, ComponentRendererMethodHelperBuilder, ComponentRendererMethodHelperReturnBuilder, ComponentRendererSerializationHelper, ContainerState, ContainsPropertyDataSourceFilterExpressionVisitor, ContentChildCollection, ContentChildrenManager, ContentControl, ContourValueResolverDescription, ContourValueResolverDescriptionMetadata, Control, ControlDisplayDensity, ControlDisplayDensity_$type, Convert, ConvertUtil, CoreGeometryUtil, CornerRadius, CountSummaryCalculator, CrosshairLayerDescription, CrosshairLayerDescriptionMetadata, CrosshairLayerDescriptionModule, CssColorPropertyAccessor, CssCornerRadiusPropertyAccessor, CssCursorPropertyAccessor, CssFloatPropertyAccessor, CssGradientUtil, CssHelper, CssHitTestVisiblePropertyAccessor, CssLengthArrayPropertyAccessor, CssLengthPropertyAccessor, CssPixelsPropertyAccessor, CssThicknessPropertyAccessor, CssTransformPropertyAccessor, CssVisibilityPropertyAccessor, CultureInfo, CustomContourValueResolverDescription, CustomContourValueResolverDescriptionMetadata, CustomContourValueResolverDescriptionModule, CustomContourValueResolverEventArgsDescription, CustomContourValueResolverEventArgsDescriptionMetadata, CustomIndicatorDescription, CustomIndicatorDescriptionMetadata, CustomIndicatorDescriptionModule, CustomMapImageryDescription, CustomMapImageryDescriptionMetadata, CustomMapImageryDescriptionModule, CustomMapTileSource, CustomPaletteBrushScaleDescription, CustomPaletteBrushScaleDescriptionMetadata, CustomPaletteBrushScaleDescriptionModule, CustomPaletteColorScaleDescription, CustomPaletteColorScaleDescriptionMetadata, CustomPaletteColorScaleDescriptionModule, DOMEventProxy, DOMExecutionContext, DOMWindowBridge, DTDObjectModel, DVContainer, DVInteractivityDescriptionModule, DVSR, DataAbbreviationMode, DataAbbreviationMode_$type, DataBindingEventArgsDescription, DataBindingEventArgsDescriptionMetadata, DataChartAnnotationDescriptionModule, DataChartCategoryCoreDescriptionModule, DataChartCategoryDescriptionModule, DataChartCategoryTrendLineDescriptionModule, DataChartCoreDescriptionModule, DataChartDefaultTooltipsDescriptionMetadata, DataChartDefaultTooltipsExtendedDescriptionMetadata, DataChartDescription, DataChartDescriptionMetadata, DataChartExtendedAxesDescriptionModule, DataChartFinancialCoreDescriptionModule, DataChartFinancialDescriptionModule, DataChartFinancialIndicatorsDescriptionModule, DataChartFinancialOverlaysDescriptionModule, DataChartInteractivityDescriptionModule, DataChartMouseButtonEventArgsDescription, DataChartMouseButtonEventArgsDescriptionMetadata, DataChartPolarCoreDescriptionModule, DataChartPolarDescriptionModule, DataChartRadialCoreDescriptionModule, DataChartRadialDescriptionModule, DataChartScatterCoreDescriptionModule, DataChartScatterDescriptionModule, DataChartShapeCoreDescriptionModule, DataChartShapeDescriptionModule, DataChartStackedDescriptionModule, DataChartToolbarDescriptionModule, DataChartToolbarIconsDescriptionModule, DataChartVerticalCategoryCoreDescriptionModule, DataChartVerticalCategoryDescriptionModule, DataChartVisualDataDescriptionModule, DataContext, DataContextDescription, DataContextDescriptionMetadata, DataFormats, DataGridAllColumnsDescriptionModule, DataGridCellEventArgsDescription, DataGridCellEventArgsDescriptionMetadata, DataGridColumnDescription, DataGridColumnDescriptionMetadata, DataGridComparisonOperatorSelectorDescription, DataGridComparisonOperatorSelectorDescriptionMetadata, DataGridCoreDescriptionModule, DataGridDescription, DataGridDescriptionMetadata, DataGridDescriptionModule, DataGridExpansionIndicatorDescription, DataGridExpansionIndicatorDescriptionMetadata, DataGridFilterDialogDescription, DataGridFilterDialogDescriptionMetadata, DataGridPagerDescription, DataGridPagerDescriptionMetadata, DataGridPagerDescriptionModule, DataGridSortIndicatorDescription, DataGridSortIndicatorDescriptionMetadata, DataGridSummaryResultDescription, DataGridSummaryResultDescriptionMetadata, DataGridToolbarDescription, DataGridToolbarDescriptionMetadata, DataGridToolbarDescriptionModule, DataLegendDescription, DataLegendDescriptionMetadata, DataLegendDescriptionModule, DataLegendHeaderDateMode, DataLegendHeaderDateMode_$type, DataLegendHeaderTimeMode, DataLegendHeaderTimeMode_$type, DataLegendLabelMode, DataLegendLabelMode_$type, DataLegendLayoutMode, DataLegendLayoutMode_$type, DataLegendSeriesContext, DataLegendSeriesContextDescription, DataLegendSeriesContextDescriptionMetadata, DataLegendSeriesFamily, DataLegendSeriesFamily_$type, DataLegendSeriesValueInfo, DataLegendSeriesValueInfoDescription, DataLegendSeriesValueInfoDescriptionMetadata, DataLegendSeriesValueType, DataLegendSeriesValueType_$type, DataLegendStylingColumnEventArgsDescription, DataLegendStylingColumnEventArgsDescriptionMetadata, DataLegendStylingRowEventArgsDescription, DataLegendStylingRowEventArgsDescriptionMetadata, DataLegendSummaryColumn, DataLegendSummaryColumnDescription, DataLegendSummaryColumnDescriptionMetadata, DataLegendSummaryEventArgsDescription, DataLegendSummaryEventArgsDescriptionMetadata, DataLegendSummaryType, DataLegendSummaryType_$type, DataLegendUnitsMode, DataLegendUnitsMode_$type, DataLegendValueMode, DataLegendValueMode_$type, DataObject, DataPieBaseChartDescription, DataPieBaseChartDescriptionMetadata, DataPieChartCoreDescriptionModule, DataPieChartDescription, DataPieChartDescriptionMetadata, DataPieChartDescriptionModule, DataPieChartToolbarDescriptionModule, DataSeries, DataSeriesAdapter, DataSeriesAdapterCachedProviderType_$type, DataSeriesAdapterImplementation, DataSeriesAdapterProviderInfo, DataSeriesAdapterRemovingDuplicatesEventArgs, DataSeriesAdapterRuleCollection, DataSeriesAdapterRunContext, DataSeriesAdapterRunEventArgs, DataSeriesAdapterUpdateNotifier, DataSeriesAxisType, DataSeriesAxisType_$type, DataSeriesCollection, DataSeriesDataProviderAnalyzer, DataSeriesIntent, DataSeriesIntent_$type, DataSeriesMarker, DataSeriesMarker_$type, DataSeriesMemberPathHint, DataSeriesType, DataSeriesType_$type, DataSourceAggregatedResult, DataSourceAggregatedResultDescription, DataSourceAggregatedResultDescriptionMetadata, DataSourceBatchCompletedEventArgs, DataSourceBatchStartedEventArgs, DataSourceDataCommittedEventArgs, DataSourceDataProviderSchemaChangedEventArgs, DataSourceDataProviderSchemaChangedEventArgsDescription, DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata, DataSourceExecutionContext, DataSourceLocalDataProvider, DataSourcePageRequestPriority, DataSourcePageRequestPriority_$type, DataSourcePropertiesComparer, DataSourceRowExpansionChangedEventArgs, DataSourceRowExpansionChangedEventArgsDescription, DataSourceRowExpansionChangedEventArgsDescriptionMetadata, DataSourceRowType, DataSourceRowType_$type, DataSourceSchemaChangedEventArgs, DataSourceSchemaChangedEventArgsDescription, DataSourceSchemaChangedEventArgsDescriptionMetadata, DataSourceSchemaPropertyType, DataSourceSchemaPropertyType_$type, DataSourceSectionHeaderDisplayMode, DataSourceSectionHeaderDisplayMode_$type, DataSourceSpecialRow, DataSourceSpecialRowDescription, DataSourceSpecialRowDescriptionMetadata, DataSourceSummaryOperand, DataSourceSummaryOperand_$type, DataSourceSummaryScope, DataSourceSummaryScope_$type, DataSourceSupportingCalculationDescription, DataSourceSupportingCalculationDescriptionMetadata, DataSourceVelocityReading, DataSourceVelocityTracker, DataTemplate, DataTemplateMeasureInfo, DataTemplatePassInfo, DataTemplateRenderInfo, DataToolTipLayerDescription, DataToolTipLayerDescriptionMetadata, DataToolTipLayerDescriptionModule, DataToolTipLayerGroupingMode, DataToolTipLayerGroupingMode_$type, DataTooltipGroupedPositionX, DataTooltipGroupedPositionX_$type, DataTooltipGroupedPositionY, DataTooltipGroupedPositionY_$type, DataVisualizationLocaleCs, DataVisualizationLocaleDa, DataVisualizationLocaleDe, DataVisualizationLocaleEn, DataVisualizationLocaleEs, DataVisualizationLocaleFr, DataVisualizationLocaleHu, DataVisualizationLocaleIt, DataVisualizationLocaleJa, DataVisualizationLocaleKo, DataVisualizationLocaleNb, DataVisualizationLocaleNl, DataVisualizationLocalePl, DataVisualizationLocalePt, DataVisualizationLocaleRo, DataVisualizationLocaleSv, DataVisualizationLocaleTr, DataVisualizationLocaleZhHans, DataVisualizationLocaleZhHant, DatePartDeltasDescription, DatePartDeltasDescriptionMetadata, DatePickerDescription, DatePickerDescriptionMetadata, DatePickerDescriptionModule, DateRangeDescriptorDescription, DateRangeDescriptorDescriptionMetadata, DateTimeCellInfoDescription, DateTimeCellInfoDescriptionMetadata, DateTimeColumnDescription, DateTimeColumnDescriptionMetadata, DateTimeColumnDescriptionModule, DateTimeFormat, DateTimeFormatSpecifier, DateTimeFormatSpecifierDescription, DateTimeFormatSpecifierDescriptionMetadata, DateTimeFormatSpecifierDescriptionModule, DateTimeKind_$type, Date_$type, DayOfWeek, DayOfWeek_$type, Debug, Decoder, DecoderExceptionFallback, DecoderExceptionFallbackBuffer, DecoderFallback, DecoderFallbackBuffer, DecoderFallbackException, DecoderReplacementFallback, DecoderReplacementFallbackBuffer, DefaultComparer$1, DefaultDataSourceDataProviderUpdateNotifier, DefaultDataSourceSchema, DefaultDecoder, DefaultEqualityComparer$1, DefaultODataLiteralEmitter, DefaultSectionInformation, DefaultSummaryResult, DefinitionBaseDescription, DefinitionBaseDescriptionMetadata, DelayManager, DelayManagerCallbackSettings, Delegate_$type, DependencyObject, DependencyObjectNotifier, DependencyPropertiesCollection, DependencyProperty, DependencyPropertyChangedEventArgs, Description, DescriptionJsonValidator, DescriptionPropertyValue, DescriptionRef, DescriptionRefTargetInfo, DescriptionRefValueChangedEventArgs, DescriptionResult, DescriptionSerializer, DescriptionSerializerBuilder, DescriptionTreeAction, DescriptionTreeActionType_$type, DescriptionTreeBuilder, DescriptionTreeNode, DescriptionTreeReconciler, DescriptionTreeReconciler_TreeModeData, DetrendedPriceOscillatorIndicatorDescription, DetrendedPriceOscillatorIndicatorDescriptionMetadata, DetrendedPriceOscillatorIndicatorDescriptionModule, DeviceUtils, Dictionary$2, DictionaryUtil, Dictionary_EnumerableCollection$3, DiffApplyInfo, DivBridge, DomPortal_$type, DomRenderer_$type, DomWrapper_$type, DomainChartDescription, DomainChartDescriptionMetadata, DomainChartSeriesPointerEventArgsDescription, DomainChartSeriesPointerEventArgsDescriptionMetadata, DomainChartToolbarDescriptionModule, DotNetCodeGeneratingComponentRendererDataEmitter, DotNetCodeGeneratingComponentRendererHandlerEmitter, DotNetCodeGeneratingComponentRendererModuleEmitter, DotNetCodeGeneratingComponentRendererTemplateEmitter, DoubleAnimator, DoubleCollection, DoubleValueChangedEventArgs, DoubleValueChangedEventArgsDescription, DoubleValueChangedEventArgsDescriptionMetadata, DoughnutChartCoreDescriptionModule, DoughnutChartDefaultTooltipsDescriptionMetadata, DoughnutChartDefaultTooltipsExtendedDescriptionMetadata, DoughnutChartDescription, DoughnutChartDescriptionMetadata, DoughnutChartDescriptionModule, DoughnutChartInteractivityDescriptionModule, DownloadingMultiScaleImageEventArgs, DownloadingMultiScaleImageEventArgsDescription, DownloadingMultiScaleImageEventArgsDescriptionMetadata, EaseOfMovementIndicatorDescription, EaseOfMovementIndicatorDescriptionMetadata, EaseOfMovementIndicatorDescriptionModule, EasingFunctions, EdgeClipper, EdgeComparer, EditRowDefinitionDescription, EditRowDefinitionDescriptionMetadata, EditRowDefinitionDescriptionModule, EditorCellInfoDescription, EditorCellInfoDescriptionMetadata, EditorDefinitionDescription, EditorDefinitionDescriptionMetadata, EditorDefinitionDescriptionModule, EditorRowCellInfoDescription, EditorRowCellInfoDescriptionMetadata, ElevationHelper, ElevationMode, ElevationMode_$type, Ellipse, EllipseGeometry, EllipseGeometryData, EllipseVisualData, EmbeddedRefDescription, Encoding, EntityHandling, EntityHandling_$type, Enum, EnumBox, EnumUtil, Enumerable, EnumerableWrapper, EnumerableWrapperObject, EnumeratorWrapper, EnumeratorWrapperObject, Environment, EqualityComparer$1, ErrorBarCalculatorReference, ErrorBarCalculatorReference_$type, ErrorBarCalculatorType, ErrorBarCalculatorType_$type, ErrorMessageDisplayingEventArgs, EventArgs, EventProxy, ExpansionPanelDescription, ExpansionPanelDescriptionMetadata, ExpansionPanelDescriptionModule, ExpressionSyntax, Extensions, FastFlattener, FastItemColumn, FastItemDateTimeColumn, FastItemIntColumn, FastItemObjectColumn, FastItemsSource, FastItemsSourceEventAction, FastItemsSourceEventAction_$type, FastItemsSourceEventArgs, FastItemsSourceReference, FastIterationDictionary$2, FastReflectionHelper, FastStochasticOscillatorIndicatorDescription, FastStochasticOscillatorIndicatorDescriptionMetadata, FastStochasticOscillatorIndicatorDescriptionModule, FaultCode, FaultException, FaultException$1, FaultReason, FillRule, FillRule_$type, FilterCellInfoDescription, FilterCellInfoDescriptionMetadata, FilterDialogRenderCompletedEventArgsDescription, FilterDialogRenderCompletedEventArgsDescriptionMetadata, FilterExpression, FilterExpressionCollection, FilterExpressionConversionVisitor, FilterExpressionDescription, FilterExpressionDescriptionMetadata, FilterExpressionFunctionType, FilterExpressionFunctionType_$type, FilterExpressionOperatorType, FilterExpressionOperatorType_$type, FilterExpressionParsingHelper, FilterExpressionParsingResult, FilterExpressionVisitor, FilterExpressionWrapperType, FilterExpressionWrapperType_$type, FilterFactory, FilterOperandDescription, FilterOperandDescriptionMetadata, FilterOperandDescriptionModule, FilterRowDefinitionDescription, FilterRowDefinitionDescriptionMetadata, FilterRowDefinitionDescriptionModule, FilterStringErrorsParsingEventArgsDescription, FilterStringErrorsParsingEventArgsDescriptionMetadata, FilterSyntaxBinaryOperatorExpressionSyntax, FilterSyntaxExpressionSyntax, FilterSyntaxIdentifierExpressionSyntax, FilterSyntaxLexer, FilterSyntaxMemberExpressionSyntax, FilterSyntaxMethodCallExpressionSyntax, FilterSyntaxNullExpressionSyntax, FilterSyntaxParenthesisExpressionSyntax, FilterSyntaxParseResult, FilterSyntaxParser, FilterSyntaxPrimitiveValueExpressionSyntax, FilterSyntaxPrintingHelper, FilterSyntaxToken, FilterSyntaxTokenType_$type, FilterSyntaxUnaryOperatorExpressionSyntax, FilterSyntaxVisitor, FinalValueLayerDescription, FinalValueLayerDescriptionMetadata, FinalValueLayerDescriptionModule, FinancialCalculationDataSourceDescription, FinancialCalculationDataSourceDescriptionMetadata, FinancialCalculationSupportingCalculationsDescription, FinancialCalculationSupportingCalculationsDescriptionMetadata, FinancialChartCoreDescriptionModule, FinancialChartCustomIndicatorArgsDescription, FinancialChartCustomIndicatorArgsDescriptionMetadata, FinancialChartDefaultTemplatesDescriptionMetadata, FinancialChartDefaultTemplatesExtendedDescriptionMetadata, FinancialChartDescription, FinancialChartDescriptionMetadata, FinancialChartDescriptionModule, FinancialDataAdapter, FinancialEventArgsDescription, FinancialEventArgsDescriptionMetadata, FinancialIndicatorDescription, FinancialIndicatorDescriptionMetadata, FinancialLegendDescription, FinancialLegendDescriptionMetadata, FinancialLegendDescriptionModule, FinancialOverlayDescription, FinancialOverlayDescriptionMetadata, FinancialPriceSeriesDescription, FinancialPriceSeriesDescriptionMetadata, FinancialPriceSeriesDescriptionModule, FinancialSeriesDescription, FinancialSeriesDescriptionMetadata, FlatDataProvider, FlatDataProviderJoinCollisionType, FlatDataProviderJoinCollisionType_$type, FlatDataProviderJoinType, FlatDataProviderJoinType_$type, FlatDataProviderTargetDataSourceNotifier, Flattener, FlattenerSettings, FocusEventArgs, FocusEventArgsDescription, FocusEventArgsDescriptionMetadata, FocusOptionsDescription, FocusOptionsDescriptionMetadata, FontDefaults, FontInfo, FontUtil, ForceIndexIndicatorDescription, ForceIndexIndicatorDescriptionMetadata, ForceIndexIndicatorDescriptionModule, FormatException, FormatException2, FormatGroupTextEventArgsDescription, FormatGroupTextEventArgsDescriptionMetadata, FormatLinearGraphLabelEventArgsDescription, FormatLinearGraphLabelEventArgsDescriptionMetadata, FormatRadialGaugeLabelEventArgsDescription, FormatRadialGaugeLabelEventArgsDescriptionMetadata, FormatSpecifier, FormatSpecifierCollection, FormatSpecifierDescription, FormatSpecifierDescriptionMetadata, FormatSpecifierDescriptionModule, FormatSummaryTextEventArgsDescription, FormatSummaryTextEventArgsDescriptionMetadata, Formatting, Formatting_$type, FragmentBaseDescription, FragmentBaseDescriptionMetadata, FrameworkElement, FrameworkElementExtensions, FullStochasticOscillatorIndicatorDescription, FullStochasticOscillatorIndicatorDescriptionMetadata, FullStochasticOscillatorIndicatorDescriptionModule, FunctionFilterExpression, FunctionFilterExpressionDescription, FunctionFilterExpressionDescriptionMetadata, FunnelChartCoreDescriptionModule, FunnelChartDescription, FunnelChartDescriptionMetadata, FunnelChartDescriptionModule, FunnelDataContextDescription, FunnelDataContextDescriptionMetadata, FunnelSliceClickedEventArgsDescription, FunnelSliceClickedEventArgsDescriptionMetadata, FunnelSliceDataContextDescription, FunnelSliceDataContextDescriptionMetadata, FunnelSliceEventArgsDescription, FunnelSliceEventArgsDescriptionMetadata, GC, GenericEnumerable$1, GenericEnumerator$1, GeographicContourLineSeriesDescription, GeographicContourLineSeriesDescriptionMetadata, GeographicContourLineSeriesDescriptionModule, GeographicHighDensityScatterSeriesDescription, GeographicHighDensityScatterSeriesDescriptionMetadata, GeographicHighDensityScatterSeriesDescriptionModule, GeographicMapCoreDescriptionModule, GeographicMapDescription, GeographicMapDescriptionMetadata, GeographicMapDescriptionModule, GeographicMapImageryDescription, GeographicMapImageryDescriptionMetadata, GeographicMapSeriesHostDescription, GeographicMapSeriesHostDescriptionMetadata, GeographicMarkerSeriesBaseDescription, GeographicMarkerSeriesBaseDescriptionMetadata, GeographicMarkerSeriesDescription, GeographicMarkerSeriesDescriptionMetadata, GeographicPolylineSeriesDescription, GeographicPolylineSeriesDescriptionMetadata, GeographicPolylineSeriesDescriptionModule, GeographicProportionalSymbolSeriesBaseDescription, GeographicProportionalSymbolSeriesBaseDescriptionMetadata, GeographicProportionalSymbolSeriesDescription, GeographicProportionalSymbolSeriesDescriptionMetadata, GeographicProportionalSymbolSeriesDescriptionModule, GeographicScatterAreaSeriesDescription, GeographicScatterAreaSeriesDescriptionMetadata, GeographicScatterAreaSeriesDescriptionModule, GeographicShapeSeriesBaseBaseDescription, GeographicShapeSeriesBaseBaseDescriptionMetadata, GeographicShapeSeriesBaseDescription, GeographicShapeSeriesBaseDescriptionMetadata, GeographicShapeSeriesDescription, GeographicShapeSeriesDescriptionMetadata, GeographicShapeSeriesDescriptionModule, GeographicSymbolSeriesBaseDescription, GeographicSymbolSeriesBaseDescriptionMetadata, GeographicSymbolSeriesDescription, GeographicSymbolSeriesDescriptionMetadata, GeographicSymbolSeriesDescriptionModule, GeographicTileSeriesDescription, GeographicTileSeriesDescriptionMetadata, GeographicTileSeriesDescriptionModule, GeographicXYTriangulatingSeriesBaseDescription, GeographicXYTriangulatingSeriesBaseDescriptionMetadata, GeographicXYTriangulatingSeriesDescription, GeographicXYTriangulatingSeriesDescriptionMetadata, Geometry, GeometryCollection, GeometryData, GeometryGroup, GeometryType, GeometryType_$type, GeometryUtil, GetPointsSettings, GetTileImageUriArgs, GetTileImageUriArgsDescription, GetTileImageUriArgsDescriptionMetadata, GotFocusEventArgsDescription, GotFocusEventArgsDescriptionMetadata, GradientDirection, GradientDirection_$type, GradientStop, GradientStopAppearanceData, GridActiveCellChangedEventArgsDescription, GridActiveCellChangedEventArgsDescriptionMetadata, GridAnimationPhaseSettingsDescription, GridAnimationPhaseSettingsDescriptionMetadata, GridAnimationSettingsDescription, GridAnimationSettingsDescriptionMetadata, GridBridge, GridBridgeColumnDefinition, GridBridgeRowDefinition, GridCellEditEndedEventArgsDescription, GridCellEditEndedEventArgsDescriptionMetadata, GridCellEditStartedEventArgsDescription, GridCellEditStartedEventArgsDescriptionMetadata, GridCellEventArgsDescription, GridCellEventArgsDescriptionMetadata, GridCellPositionDescription, GridCellPositionDescriptionMetadata, GridCellPositionDescriptionModule, GridCellValueChangingEventArgsDescription, GridCellValueChangingEventArgsDescriptionMetadata, GridColumnAnimationSettingsDescription, GridColumnAnimationSettingsDescriptionMetadata, GridColumnButtonOptionsDescription, GridColumnButtonOptionsDescriptionMetadata, GridColumnButtonOptionsDescriptionModule, GridColumnFilterOptionsDescription, GridColumnFilterOptionsDescriptionMetadata, GridColumnFilterOptionsDescriptionModule, GridColumnGroupOptionsDescription, GridColumnGroupOptionsDescriptionMetadata, GridColumnGroupOptionsDescriptionModule, GridColumnHideOptionsDescription, GridColumnHideOptionsDescriptionMetadata, GridColumnHideOptionsDescriptionModule, GridColumnMoveOptionsDescription, GridColumnMoveOptionsDescriptionMetadata, GridColumnMoveOptionsDescriptionModule, GridColumnOptionsBaseDescription, GridColumnOptionsBaseDescriptionMetadata, GridColumnOptionsDescription, GridColumnOptionsDescriptionMetadata, GridColumnOptionsDescriptionModule, GridColumnOptionsSectionBaseDescription, GridColumnOptionsSectionBaseDescriptionMetadata, GridColumnOptionsSimpleSectionBaseDescription, GridColumnOptionsSimpleSectionBaseDescriptionMetadata, GridColumnPinOptionsDescription, GridColumnPinOptionsDescriptionMetadata, GridColumnPinOptionsDescriptionModule, GridColumnSortOptionsDescription, GridColumnSortOptionsDescriptionMetadata, GridColumnSortOptionsDescriptionModule, GridColumnSummaryOptionsDescription, GridColumnSummaryOptionsDescriptionMetadata, GridColumnSummaryOptionsDescriptionModule, GridColumnWidthChangedEventArgsDescription, GridColumnWidthChangedEventArgsDescriptionMetadata, GridColumnsAutoGeneratedEventArgsDescription, GridColumnsAutoGeneratedEventArgsDescriptionMetadata, GridColumnsChangedEventArgsDescription, GridColumnsChangedEventArgsDescriptionMetadata, GridCustomFilterRequestedEventArgsDescription, GridCustomFilterRequestedEventArgsDescriptionMetadata, GridDataCommittedEventArgsDescription, GridDataCommittedEventArgsDescriptionMetadata, GridDataCommittingEventArgsDescription, GridDataCommittingEventArgsDescriptionMetadata, GridFilterDialogFilterChangeEventArgsDescription, GridFilterDialogFilterChangeEventArgsDescriptionMetadata, GridFilterDialogOpeningEventArgsDescription, GridFilterDialogOpeningEventArgsDescriptionMetadata, GridFilterDialogViewModelDescription, GridFilterDialogViewModelDescriptionMetadata, GridFilterDialogViewModelGroupingDescription, GridFilterDialogViewModelGroupingDescriptionMetadata, GridFilterDialogViewModelRowDescription, GridFilterDialogViewModelRowDescriptionMetadata, GridFilterExpressionsEventArgsDescription, GridFilterExpressionsEventArgsDescriptionMetadata, GridGroupDescriptionsChangedEventArgsDescription, GridGroupDescriptionsChangedEventArgsDescriptionMetadata, GridRowEditEndedEventArgsDescription, GridRowEditEndedEventArgsDescriptionMetadata, GridRowEditStartedEventArgsDescription, GridRowEditStartedEventArgsDescriptionMetadata, GridSelectedCellRangesChangedEventArgsDescription, GridSelectedCellRangesChangedEventArgsDescriptionMetadata, GridSelectedCellsChangedEventArgsDescription, GridSelectedCellsChangedEventArgsDescriptionMetadata, GridSelectedItemsChangedEventArgsDescription, GridSelectedItemsChangedEventArgsDescriptionMetadata, GridSelectedKeysChangedEventArgsDescription, GridSelectedKeysChangedEventArgsDescriptionMetadata, GridSelectionChangedEventArgsDescription, GridSelectionChangedEventArgsDescriptionMetadata, GridSizeChangedEventArgsDescription, GridSizeChangedEventArgsDescriptionMetadata, GridSortDescriptionsChangedEventArgsDescription, GridSortDescriptionsChangedEventArgsDescriptionMetadata, GridSummaryDescriptionsChangedEventArgsDescription, GridSummaryDescriptionsChangedEventArgsDescriptionMetadata, Group, GroupCollection, GroupDataDescription, GroupDataDescriptionMetadata, Guid, Guid_GuidParseThrowStyle_$type, Guid_GuidResult, Guid_GuidStyles_$type, Guid_ParseFailureKind_$type, HalfEdge, HalfEdgeSet, HashPool$2, HashSet$1, Hashtable, Header, HeaderDescription, HeaderDescriptionMetadata, HeaderRowSeparatorDescription, HeaderRowSeparatorDescriptionMetadata, HeaderRowSeparatorDescriptionModule, HeaderSeparatorDescription, HeaderSeparatorDescriptionMetadata, HeaderSeparatorDescriptionModule, HeatTileGenerator, HeatTileGeneratorDescription, HeatTileGeneratorDescriptionMetadata, HeatTileGeneratorDescriptionModule, HeatTileGeneratorWebWorker, HeatTileGeneratorWorker, HeatTileGeneratorWorkerManager, HeatTileImageCreatedEventArgs, HeatTileScaler, HierarchicalRingSeriesDescription, HierarchicalRingSeriesDescriptionMetadata, HierarchicalRingSeriesDescriptionModule, HighDensityScatterSeriesDescription, HighDensityScatterSeriesDescriptionMetadata, HighDensityScatterSeriesDescriptionModule, HighlightState, HighlightState_$type, HighlightedValueDisplayMode, HighlightedValueDisplayMode_$type, HighlightedValueLabelMode, HighlightedValueLabelMode_$type, HighlightingData, HighlightingInfo, HighlightingInfoComparer, HighlightingInfoDescription, HighlightingInfoDescriptionMetadata, HighlightingManager, HighlightingState, HighlightingState_$type, HoleDimensionsChangedEventArgsDescription, HoleDimensionsChangedEventArgsDescriptionMetadata, HorizontalAlignment, HorizontalAlignment_$type, HorizontalAnchoredCategorySeriesDescription, HorizontalAnchoredCategorySeriesDescriptionMetadata, HorizontalAnchoredCategorySeriesProxyDescriptionModule, HorizontalRangeCategorySeriesDescription, HorizontalRangeCategorySeriesDescriptionMetadata, HorizontalRangeCategorySeriesProxyDescriptionModule, HorizontalStackedSeriesBaseDescription, HorizontalStackedSeriesBaseDescriptionMetadata, HttpRequestUtil, IArrayList_$type, IArray_$type, IChartItemLegend_$type, IChartLegend_$type, IChartScaleLegend_$type, ICodeGenerationRendererTemplate_$type, ICollection$1_$type, ICollection_$type, ICommandAvailabilityListener_$type, ICommandStateChangedListener_$type, IComparable$1_$type, IComparable_$type, IComparer$1_$type, IComparer_$type, IComponentRendererAdapter_$type, IConvertible_$type, ICredentials_$type, IDataLegendSeries_$type, IDataLegendTarget_$type, IDataLegend_$type, IDataObject_$type, IDataSeriesAdapterRule_$type, IDataSourceClonableDataProvider_$type, IDataSourceDataProviderUpdateNotifier_$type, IDataSourceDataProvider_$type, IDataSourceExecutionContext_$type, IDataSourceLocalDataProvider_$type, IDataSourcePage_$type, IDataSourceSchema_$type, IDataSourceSupportsCount_$type, IDataSourceSupportsIndexedAccess_$type, IDataSourceUpdateNotifier_$type, IDataSourceVirtualDataProvider_$type, IDataSource_$type, IDependentRenderer_$type, IDictionary$2_$type, IDictionary_$type, IDisposable_$type, IEasingFunction_$type, IEditableDataSource_$type, IEnumerable$1_$type, IEnumerable_$type, IEnumerator$1_$type, IEnumerator_$type, IEqualityComparer$1_$type, IEqualityComparer_$type, IEquatable$1_$type, IErrorBarCalculator_$type, IExecutionContext_$type, IExternalDataSeriesAdapter_$type, IExternalDataSource_$type, IExternalLocalDataSource_$type, IExternalVirtualDataSource_$type, IFastItemColumn$1_$type, IFastItemColumnInternal_$type, IFastItemColumnPropertyName_$type, IFastItemsSourceProvider_$type, IFastItemsSource_$type, IFilterExpression_$type, IFormatProvider_$type, IFormattable_$type, IFunctionFilterExpression_$type, IGetItemAtIndex_$type, IGrouping$2_$type, IHashPool$2_$type, IHighlightingManager_$type, IIcon_$type, IIndexedPool$1_$type, IInternalLegendOwner_$type, IKeyFrameAnimation_$type, ILegendContext_$type, ILegendOwner_$type, ILegendSeriesInternal_$type, ILegendSeries_$type, ILegendTemplateProvider_$type, IList$1_$type, IList_$type, ILiteralFilterExpression_$type, IMapRenderDeferralHandler_$type, INativeUIAbsolutePanelBridge_$type, INativeUIColumnBridge_$type, INativeUIContainerBridge_$type, INativeUIContentBridge_$type, INativeUIElementBridge_$type, INativeUIElementFactory_$type, INativeUIGridBridge_$type, INativeUIInputBridge_$type, INativeUIPopupBridge_$type, INativeUIWindowBridge_$type, INotifyCollectionChanged_$type, INotifyPropertyChanged_$type, IOPath, IOnDemandRender_$type, IOperationFilterExpression_$type, IOrderedEnumerable$1_$type, IOverviewPlusDetailControl_$type, IOverviewPlusDetailPane_$type, IPageCandidatesSink_$type, IPermission_$type, IPlatformAPIHelperImpl_$type, IPool$1_$type, IPropertyReferenceFilterExpression_$type, IQueryProvider_$type, IQueryable$1_$type, IQueryable_$type, IRenderer_$type, IScaleLegendSeries_$type, ISchedulableRender_$type, IScrollerKeyboardListener_$type, IScrollerView_$type, ISectionInformation_$type, ISmartPlaceable_$type, ISummaryResult_$type, ISupportsAnimation_$type, ISupportsDataChangeNotifications_$type, ISupportsExpansionChangeNotifications_$type, ISupportsInput_$type, ITickProvider_$type, ITileGenerator_$type, ITileWorkCompletedSink_$type, IToolbarTarget_$type, ITypeDescriptionPropertyTransforms_$type, IUnknownValuePlotting_$type, IVisualData_$type, IXmlLineInfo_$type, IXmlNamespaceResolver_$type, IZoomSlider_$type, IconDescription, IconDescriptionMetadata, IconDescriptionModule, IgCollection, IgEvent, IgcButtonBridge, IgcCheckboxBridge, IgcDropdownBridge, IgcIconButtonBridge, IgcInputBridge, IgcSliderBridge, IgrAsyncCompletedEventArgs, IgrCancelEventArgs, IgrCancellingMultiScaleImageEventArgs, IgrCaptureImageSettings, IgrChildContent, IgrChildContentModule, IgrComponentRendererContainer, IgrComponentRendererContainerModule, IgrContentChildCollection, IgrDVInteractivityModule, IgrDataContext, IgrDataLegendSeriesContext, IgrDataLegendSeriesValueInfo, IgrDataLegendSummaryColumn, IgrDataSeriesCollection, IgrDataSourceDataProviderSchemaChangedEventArgs, IgrDataSourceRowExpansionChangedEventArgs, IgrDataSourceSchemaChangedEventArgs, IgrDataVisualizationLocaleCsModule, IgrDataVisualizationLocaleDaModule, IgrDataVisualizationLocaleDeModule, IgrDataVisualizationLocaleEnModule, IgrDataVisualizationLocaleEsModule, IgrDataVisualizationLocaleFrModule, IgrDataVisualizationLocaleHuModule, IgrDataVisualizationLocaleItModule, IgrDataVisualizationLocaleJaModule, IgrDataVisualizationLocaleKoModule, IgrDataVisualizationLocaleNbModule, IgrDataVisualizationLocaleNlModule, IgrDataVisualizationLocalePlModule, IgrDataVisualizationLocalePtModule, IgrDataVisualizationLocaleRoModule, IgrDataVisualizationLocaleSvModule, IgrDataVisualizationLocaleTrModule, IgrDataVisualizationLocaleZhHansModule, IgrDataVisualizationLocaleZhHantModule, IgrDateTimeFormatSpecifier, IgrDateTimeFormatSpecifierModule, IgrDoubleValueChangedEventArgs, IgrDownloadingMultiScaleImageEventArgs, IgrFilterExpressionCollection, IgrFocusEventArgs, IgrFormatSpecifier, IgrFormatSpecifierCollection, IgrFormatSpecifierModule, IgrGetTileImageUriArgs, IgrHeatTileGenerator, IgrHeatTileGeneratorModule, IgrHighlightingInfo, IgrImageCapturedEventArgs, IgrKeyEventArgs, IgrLocalDataSourceModule, IgrNumberFormatSpecifier, IgrNumberFormatSpecifierModule, IgrObjectCollection, IgrOnClosedEventArgs, IgrOnPopupEventArgs, IgrPopup, IgrPopupModule, IgrPropertyUpdatedEventArgs, IgrProvideCalculatorEventArgs, IgrRectChangedEventArgs, IgrShapeDataSource, IgrShapeDataSourceModule, IgrShapeFilterRecordEventArgs, IgrShapefileRecord, IgrSimpleDefaultTooltip, IgrStockChangedEventArgs, IgrStyle, IgrTemplateContainer, IgrTemplateContainerModule, IgrTemplateContent, IgrTemplateContentModule, IgrTemplateView, IgrToolCommandArgumentCollection, IgrTooltipContainer, IgrTooltipContainerModule, IgrTransactionState, IgrTriangulationDataSource, IgrTriangulationStatusEventArgs, IgrUploadDataCompletedEventArgs, IgrUploadStringCompletedEventArgs, Image, ImageCapturedEventArgs, ImageCapturedEventArgsDescription, ImageCapturedEventArgsDescriptionMetadata, ImageCellInfoDescription, ImageCellInfoDescriptionMetadata, ImageColumnDescription, ImageColumnDescriptionMetadata, ImageColumnDescriptionModule, ImageTilesReadyEventArgsDescription, ImageTilesReadyEventArgsDescriptionMetadata, ImagesChangedEventArgsDescription, ImagesChangedEventArgsDescriptionMetadata, IndexOutOfRangeException, IndicatorProxyDescriptionModule, IndicatorsDescriptionModule, InputChangeEventArgsDescription, InputChangeEventArgsDescriptionMetadata, InputDescription, InputDescriptionMetadata, InputDescriptionModule, InputGroupDescription, InputGroupDescriptionMetadata, InputGroupDescriptionModule, InputGroupItemDescription, InputGroupItemDescriptionMetadata, InteractionState, InteractionState_$type, InterpolationMode, InterpolationMode_$type, InterpolationUtil, InvalidOperationException, ItemLegendDescription, ItemLegendDescriptionMetadata, ItemLegendDescriptionModule, ItemToolTipLayerDescription, ItemToolTipLayerDescriptionMetadata, ItemToolTipLayerDescriptionModule, ItemwiseStrategyBasedIndicatorDescription, ItemwiseStrategyBasedIndicatorDescriptionMetadata, IterableWrapper, IteratorWrapper, ItfConverter, JavaScriptSerializer, JsonDictionaryArray, JsonDictionaryItem, JsonDictionaryObject, JsonDictionaryParser, JsonDictionaryValue, JsonDictionaryValueType_$type, JsonWriter, Key, KeyEventArgs, KeyEventArgsDescription, KeyEventArgsDescriptionMetadata, KeyFrameAnimationDirect, KeyFrameAnimationEffectPhase_$type, KeyFrameAnimationFactory, KeyFrameAnimationFill_$type, KeyFrameAnimationPlayState_$type, KeyFrameAnimationTimeline, KeyFrameEffectEasing_$type, KeyFrameEffectTimingDirection_$type, KeyValuePair$2, Key_$type, LRUCache$2, LRUCacheItem$2, LabelAppearanceData, LabelAppearanceDataList, LabelClickEventArgsDescription, LabelClickEventArgsDescriptionMetadata, LabelCollisionInfo, LabelCollisionManager, LabelCollisionManagerCollisionMode_$type, LabelCollisionPlacementPositions_$type, LabelDescription, LabelDescriptionMetadata, LabelDescriptionModule, LambdaExpression, LastMonthExpression, LastMonthExpressionDescription, LastMonthExpressionDescriptionMetadata, LastQuarterExpression, LastQuarterExpressionDescription, LastQuarterExpressionDescriptionMetadata, LastWeekExpression, LastWeekExpressionDescription, LastWeekExpressionDescriptionMetadata, LastYearExpression, LastYearExpressionDescription, LastYearExpressionDescriptionMetadata, LayoutPrimaryKeyValueDescription, LayoutPrimaryKeyValueDescriptionMetadata, LayoutPrimaryKeyValueDescriptionModule, LeastSquaresFit, LeftClipper, LegendBaseDescription, LegendBaseDescriptionMetadata, LegendDescription, LegendDescriptionMetadata, LegendDescriptionModule, LegendItemBadgeMode, LegendItemBadgeMode_$type, LegendItemBadgeShape, LegendItemBadgeShape_$type, LegendItemHelper, LegendMouseButtonEventArgsDescription, LegendMouseButtonEventArgsDescriptionMetadata, LegendMouseEventArgsDescription, LegendMouseEventArgsDescriptionMetadata, Line, LineFragmentDescription, LineFragmentDescriptionMetadata, LineFragmentDescriptionModule, LineGeometry, LineGeometryData, LineSegment, LineSegmentData, LineSeriesDescription, LineSeriesDescriptionMetadata, LineSeriesDescriptionModule, LineVisualData, LinearContourValueResolverDescription, LinearContourValueResolverDescriptionMetadata, LinearContourValueResolverDescriptionModule, LinearGaugeCoreDescriptionModule, LinearGaugeDescription, LinearGaugeDescriptionMetadata, LinearGaugeDescriptionModule, LinearGradientBrush, LinearGradientBrushAppearanceData, LinearGraphRangeDescription, LinearGraphRangeDescriptionMetadata, LinearGraphRangeDescriptionModule, LinkedList$1, LinkedListNode$1, List$1, ListPanelContentRefreshedEventArgsDescription, ListPanelContentRefreshedEventArgsDescriptionMetadata, ListPanelDescription, ListPanelDescriptionMetadata, ListPanelDescriptionModule, ListPanelItemModelDescription, ListPanelItemModelDescriptionMetadata, ListPanelTemplateHeightRequestedEventArgsDescription, ListPanelTemplateHeightRequestedEventArgsDescriptionMetadata, ListPanelTemplateItemUpdatingEventArgsDescription, ListPanelTemplateItemUpdatingEventArgsDescriptionMetadata, ListPanelTemplateWidthRequestedEventArgsDescription, ListPanelTemplateWidthRequestedEventArgsDescriptionMetadata, ListSortDirection, ListSortDirection_$type, LiteralFilterExpression, LiteralFilterExpressionDescription, LiteralFilterExpressionDescriptionMetadata, LocalDataSource, LocalDataSourceDescription, LocalDataSourceDescriptionMetadata, LocalDataSourceDescriptionModule, LocalDataSourceViewExpansionNotifier, LocalDataSourceViewUpdateNotifier, Locale, Localization, LostFocusEventArgsDescription, LostFocusEventArgsDescriptionMetadata, MapTileSource, MarkerSeriesDescription, MarkerSeriesDescriptionMetadata, MarketFacilitationIndexIndicatorDescription, MarketFacilitationIndexIndicatorDescriptionMetadata, MarketFacilitationIndexIndicatorDescriptionModule, MarshalByRefObject, MassIndexIndicatorDescription, MassIndexIndicatorDescriptionMetadata, MassIndexIndicatorDescriptionModule, Match, Matcher, MathUtil, MathUtilExtended, Matrix, MatrixTransform, MaxSummaryCalculator, MedianPriceIndicatorDescription, MedianPriceIndicatorDescriptionMetadata, MedianPriceIndicatorDescriptionModule, MemberExpression, MemoryStream, MethodCallExpression, MinSummaryCalculator, ModifierKeys, ModifierKeys_$type, MoneyFlowIndexIndicatorDescription, MoneyFlowIndexIndicatorDescriptionMetadata, MoneyFlowIndexIndicatorDescriptionModule, MouseButton, MouseButtonEventArgs, MouseButton_$type, MouseEventArgs, MovingAverageConvergenceDivergenceIndicatorDescription, MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata, MovingAverageConvergenceDivergenceIndicatorDescriptionModule, MultiColumnComboBoxDescription, MultiColumnComboBoxDescriptionMetadata, MultiColumnComboBoxDescriptionModule, MultiColumnComboBoxTextChangedEventArgsDescription, MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata, MultiColumnComboBoxValueChangedEventArgsDescription, MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata, NamePatcher, NameTable, NameTable_Entry, NameValueCollection, NamespaceHandling_$type, NativeUI, NativeUIAbsolutePanel, NativeUIAlignItems_$type, NativeUIBoxSizing_$type, NativeUIBuiltInEvents_$type, NativeUIBuiltInProperties_$type, NativeUIButton, NativeUIButtonClickedEventArgs, NativeUIButtonDisplayType_$type, NativeUICheckbox, NativeUICheckboxChangeEventArgs, NativeUICheckboxList, NativeUICheckboxListChangeEventArgs, NativeUIChildren, NativeUIClickedEventArgs, NativeUIColumn, NativeUIComponent, NativeUIComponentBuiltInType_$type, NativeUIComponentHorizontalAlignment_$type, NativeUIComponentVerticalAlignment_$type, NativeUIContainer, NativeUIContent, NativeUICursor_$type, NativeUIDisplayDensity_$type, NativeUIDropDown, NativeUIDropDownSelectedValueChangedEventArgs, NativeUIElementBridge, NativeUIElementFactoryFlavor, NativeUIElementFactoryFlavor_$type, NativeUIFocusEventArgs, NativeUIGrid, NativeUIGridHeightType_$type, NativeUIGridWidthType_$type, NativeUIIcon, NativeUIIconButton, NativeUIInput, NativeUIInputChangingEventArgs, NativeUIInputDisplayType_$type, NativeUIInputType_$type, NativeUIInputsFactory, NativeUILabel, NativeUIMouseEventArgs, NativeUIPlaceContent_$type, NativeUIPopup, NativeUIPopupAlignment_$type, NativeUIPopupAnimationType_$type, NativeUIPopupClosedEventArgs, NativeUIPopupDirection_$type, NativeUIPopupOpenedEventArgs, NativeUIPopupPointerPosition_$type, NativeUIPositionChangedEventArgs, NativeUISizeChangedEventArgs, NativeUISlider, NativeUISliderValueChangedEventArgs, NativeUIWindow, NeedleBeingDragged, NeedleBeingDragged_$type, NegativeVolumeIndexIndicatorDescription, NegativeVolumeIndexIndicatorDescriptionMetadata, NegativeVolumeIndexIndicatorDescriptionModule, NetworkCredential, NewLineHandling_$type, NextMonthExpression, NextMonthExpressionDescription, NextMonthExpressionDescriptionMetadata, NextQuarterExpression, NextQuarterExpressionDescription, NextQuarterExpressionDescriptionMetadata, NextWeekExpression, NextWeekExpressionDescription, NextWeekExpressionDescriptionMetadata, NextYearExpression, NextYearExpressionDescription, NextYearExpressionDescriptionMetadata, NonBlockingStreamReader, NotImplementedException, NotSupportedException, NotifyCollectionChangedAction, NotifyCollectionChangedAction_$type, NotifyCollectionChangedEventArgs, NullReferenceException, NullStream, Nullable, Nullable$1, NumberAbbreviatorDescriptionModule, NumberFormatInfo, NumberFormatSpecifier, NumberFormatSpecifierDescription, NumberFormatSpecifierDescriptionMetadata, NumberFormatSpecifierDescriptionModule, Number_$type, Numeric, NumericAngleAxisDescription, NumericAngleAxisDescriptionMetadata, NumericAngleAxisDescriptionModule, NumericAxisBaseDescription, NumericAxisBaseDescriptionMetadata, NumericCellInfoDescription, NumericCellInfoDescriptionMetadata, NumericColumnDescription, NumericColumnDescriptionMetadata, NumericColumnDescriptionModule, NumericRadiusAxisDescription, NumericRadiusAxisDescriptionMetadata, NumericRadiusAxisDescriptionModule, NumericXAxisDescription, NumericXAxisDescriptionMetadata, NumericXAxisDescriptionModule, NumericYAxisDescription, NumericYAxisDescriptionMetadata, NumericYAxisDescriptionModule, ODataDataSourceFilterExpressionVisitor, ODataDataSourceSchema, ODataLiteralEmitter_$type, ObjectCollection, ObjectDisposedException, ObservableCollection$1, ObservableColorCollection, OffsettableWeekExpression, OffsettableWeekExpressionDescription, OffsettableWeekExpressionDescriptionMetadata, OnBalanceVolumeIndicatorDescription, OnBalanceVolumeIndicatorDescriptionMetadata, OnBalanceVolumeIndicatorDescriptionModule, OnClosedEventArgs, OnClosedEventArgsDescription, OnClosedEventArgsDescriptionMetadata, OnCollapsedEventArgsDescription, OnCollapsedEventArgsDescriptionMetadata, OnExpandedEventArgsDescription, OnExpandedEventArgsDescriptionMetadata, OnPopupEventArgs, OnPopupEventArgsDescription, OnPopupEventArgsDescriptionMetadata, OpenStreetMapImageryDescription, OpenStreetMapImageryDescriptionMetadata, OpenStreetMapImageryDescriptionModule, OpenStreetMapTileSource, OperationFilterExpression, OperationFilterExpressionDescription, OperationFilterExpressionDescriptionMetadata, OperatorSelectorClosingEventArgsDescription, OperatorSelectorClosingEventArgsDescriptionMetadata, OperatorSelectorOpeningEventArgsDescription, OperatorSelectorOpeningEventArgsDescriptionMetadata, OperatorSelectorValueChangedEventArgsDescription, OperatorSelectorValueChangedEventArgsDescriptionMetadata, OrdinalTimeXAxisDescription, OrdinalTimeXAxisDescriptionMetadata, OrdinalTimeXAxisDescriptionModule, OthersCategoryType, OthersCategoryType_$type, OverlayProxyDescriptionModule, OverlaysDescriptionModule, PageChangedEventArgsDescription, PageChangedEventArgsDescriptionMetadata, PagePredictionEngine, PagedDataSource, PagedDataSourceDescription, PagedDataSourceDescriptionMetadata, Pair$2, Panel, PanelBridge, ParameterExpression, Path, PathFigure, PathFigureCollection, PathFigureData, PathFigureUtil, PathGeometry, PathGeometryData, PathMarkupParser, PathMarkupToken, PathMarkupTokenType_$type, PathSegment, PathSegmentCollection, PathSegmentType, PathSegmentType_$type, PathVisualData, PenLineCap, PenLineCap_$type, PenLineJoin, PenLineJoin_$type, PercentChangeYAxisDescription, PercentChangeYAxisDescriptionMetadata, PercentChangeYAxisDescriptionModule, PercentagePriceOscillatorIndicatorDescription, PercentagePriceOscillatorIndicatorDescriptionMetadata, PercentagePriceOscillatorIndicatorDescriptionModule, PercentageVolumeOscillatorIndicatorDescription, PercentageVolumeOscillatorIndicatorDescriptionMetadata, PercentageVolumeOscillatorIndicatorDescriptionModule, PermissionSet, PermissionState, PermissionState_$type, PieChartBaseDescription, PieChartBaseDescriptionMetadata, PieChartCoreDescriptionModule, PieChartDescription, PieChartDescriptionMetadata, PieChartDescriptionModule, PieSliceCollisionGeometry, PieSliceDataContextDescription, PieSliceDataContextDescriptionMetadata, PieSliceOthersContextDescription, PieSliceOthersContextDescriptionMetadata, PinnedAreaSeparatorDescription, PinnedAreaSeparatorDescriptionMetadata, PinnedAreaSeparatorDescriptionModule, PlatformAPIHelper, PlatformConstants, PlatformFormatter, PlatformKeyFrameAnimationFactory, PlatformSpecifierType_$type, PlatformUIElementPropertyAccessorFactory, PlotAreaMouseButtonEventArgsDescription, PlotAreaMouseButtonEventArgsDescriptionMetadata, PlotAreaMouseEventArgsDescription, PlotAreaMouseEventArgsDescriptionMetadata, PointCollection, PointCollectionUtil, PointComparer, PointData, PointDescription, PointSeriesDescription, PointSeriesDescriptionMetadata, PointSeriesDescriptionModule, PointTester, PointUtil, Point_$type, PolarAreaSeriesDescription, PolarAreaSeriesDescriptionMetadata, PolarAreaSeriesDescriptionModule, PolarBaseDescription, PolarBaseDescriptionMetadata, PolarLineSeriesBaseDescription, PolarLineSeriesBaseDescriptionMetadata, PolarLineSeriesDescription, PolarLineSeriesDescriptionMetadata, PolarLineSeriesDescriptionModule, PolarScatterSeriesDescription, PolarScatterSeriesDescriptionMetadata, PolarScatterSeriesDescriptionModule, PolarSplineAreaSeriesDescription, PolarSplineAreaSeriesDescriptionMetadata, PolarSplineAreaSeriesDescriptionModule, PolarSplineSeriesDescription, PolarSplineSeriesDescriptionMetadata, PolarSplineSeriesDescriptionModule, PolyBezierSegment, PolyBezierSegmentData, PolyLineSegment, PolyLineVisualData, PolySimplification, Polygon, PolygonUtil, PolygonVisualData, Polyline, PolylineSegmentData, Pool$1, Popup, PopupAlignment, PopupAlignment_$type, PopupAnimation, PopupAnimationType, PopupAnimationType_$type, PopupDescription, PopupDescriptionMetadata, PopupDescriptionModule, PopupDirection, PopupDirection_$type, PopupPointerPosition, PopupPointerPosition_$type, PopupView, PopupVisualModelExport, Popup_InnerAnimationInfo, Popup_OuterAnimationInfo, PortalManager, PositiveVolumeIndexIndicatorDescription, PositiveVolumeIndexIndicatorDescriptionMetadata, PositiveVolumeIndexIndicatorDescriptionModule, PredictionEnginePageCandidate, PrefixDescription, PrefixDescriptionMetadata, PrefixDescriptionModule, PriceChannelOverlayDescription, PriceChannelOverlayDescriptionMetadata, PriceChannelOverlayDescriptionModule, PriceVolumeTrendIndicatorDescription, PriceVolumeTrendIndicatorDescriptionMetadata, PriceVolumeTrendIndicatorDescriptionModule, PrimaryKeyValueDescription, PrimaryKeyValueDescriptionMetadata, PrimaryKeyValueDescriptionModule, PrimitiveAppearanceData, PrimitiveVisualData, PrimitiveVisualDataList, ProgressiveLoadStatusEventArgsDescription, ProgressiveLoadStatusEventArgsDescriptionMetadata, PromiseFactory, PromiseWrapper, PropertyChangedEventArgs, PropertyChangedEventArgs$1, PropertyEditorDataSourceDescription, PropertyEditorDataSourceDescriptionMetadata, PropertyEditorDescription, PropertyEditorDescriptionMetadata, PropertyEditorDescriptionModule, PropertyEditorDescriptionObjectDescription, PropertyEditorDescriptionObjectDescriptionMetadata, PropertyEditorPanelDescription, PropertyEditorPanelDescriptionMetadata, PropertyEditorPanelDescriptionModule, PropertyEditorPropertyDescriptionButtonClickEventArgsDescription, PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata, PropertyEditorPropertyDescriptionChangedEventArgsDescription, PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata, PropertyEditorPropertyDescriptionDescription, PropertyEditorPropertyDescriptionDescriptionMetadata, PropertyEditorPropertyDescriptionDescriptionModule, PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription, PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata, PropertyMetadata, PropertyPath, PropertyReferenceFilterExpression, PropertyReferenceFilterExpressionDescription, PropertyReferenceFilterExpressionDescriptionMetadata, PropertyUpdatedEventArgs, PropertyUpdatedEventArgsDescription, PropertyUpdatedEventArgsDescriptionMetadata, ProportionalCategoryAngleAxisDescription, ProportionalCategoryAngleAxisDescriptionMetadata, ProportionalCategoryAngleAxisDescriptionModule, ProvideCalculatorEventArgs, ProvideCalculatorEventArgsDescription, ProvideCalculatorEventArgsDescriptionMetadata, Q1Expression, Q1ExpressionDescription, Q1ExpressionDescriptionMetadata, Q2Expression, Q2ExpressionDescription, Q2ExpressionDescriptionMetadata, Q3Expression, Q3ExpressionDescription, Q3ExpressionDescriptionMetadata, Q4Expression, Q4ExpressionDescription, Q4ExpressionDescriptionMetadata, QuadTree, QuadTreeBoundingBox, QuadTreeForceVector, QuadTreeNode, Queryable, Queue$1, RadialAreaSeriesDescription, RadialAreaSeriesDescriptionMetadata, RadialAreaSeriesDescriptionModule, RadialBaseChartDescription, RadialBaseChartDescriptionMetadata, RadialBaseDescription, RadialBaseDescriptionMetadata, RadialColumnSeriesDescription, RadialColumnSeriesDescriptionMetadata, RadialColumnSeriesDescriptionModule, RadialGaugeCoreDescriptionModule, RadialGaugeDescription, RadialGaugeDescriptionMetadata, RadialGaugeDescriptionModule, RadialGaugeRangeDescription, RadialGaugeRangeDescriptionMetadata, RadialGaugeRangeDescriptionModule, RadialLabelMode, RadialLabelMode_$type, RadialLineSeriesDescription, RadialLineSeriesDescriptionMetadata, RadialLineSeriesDescriptionModule, RadialPieSeriesDescription, RadialPieSeriesDescriptionMetadata, RadialPieSeriesDescriptionModule, Random, RangeAreaSeriesDescription, RangeAreaSeriesDescriptionMetadata, RangeAreaSeriesDescriptionModule, RangeCategorySeriesDescription, RangeCategorySeriesDescriptionMetadata, RangeColumnSeriesDescription, RangeColumnSeriesDescriptionMetadata, RangeColumnSeriesDescriptionModule, RateOfChangeAndMomentumIndicatorDescription, RateOfChangeAndMomentumIndicatorDescriptionMetadata, RateOfChangeAndMomentumIndicatorDescriptionModule, ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter, ReactMarkupCodeGeneratingComponentRendererCodeEmitter, ReactRenderer, ReactTemplateAdapter, ReactWrapper, ReadOnlyCollection$1, ReadOnlyObservableCollection$1, ReadState, ReadState_$type, RearrangedList$1, RearrangedListView, Rect, RectChangedEventArgs, RectChangedEventArgsDescription, RectChangedEventArgsDescriptionMetadata, RectData, RectDescription, RectUtil, Rectangle, RectangleGeometry, RectangleGeometryData, RectangleVisualData, RefValueChangedTarget, ReflectionUtil, RefreshCompletedEventArgsDescription, RefreshCompletedEventArgsDescriptionMetadata, Regex, RegexOptions, RegexOptions_$type, RelativeStrengthIndexIndicatorDescription, RelativeStrengthIndexIndicatorDescriptionMetadata, RelativeStrengthIndexIndicatorDescriptionModule, RemovedShiftedRowInfo, RenderRequestedEventArgsDescription, RenderRequestedEventArgsDescriptionMetadata, RenderingContext, ResponsivePhaseDescription, ResponsivePhaseDescriptionMetadata, ResponsiveStateDescription, ResponsiveStateDescriptionMetadata, ResponsiveStateEnteredEventArgsDescription, ResponsiveStateEnteredEventArgsDescriptionMetadata, ResponsiveStateEnteringEventArgsDescription, ResponsiveStateEnteringEventArgsDescriptionMetadata, ResponsiveStateExitedEventArgsDescription, ResponsiveStateExitedEventArgsDescriptionMetadata, ReverseArrayEnumerator$1, RightClipper, RingDescription, RingDescriptionMetadata, RingSeriesBaseDescription, RingSeriesBaseDescriptionMetadata, RingSeriesDescription, RingSeriesDescriptionMetadata, RingSeriesDescriptionModule, RippleDescription, RippleDescriptionMetadata, RippleDescriptionModule, RotateTransform, RowSeparatorDescription, RowSeparatorDescriptionMetadata, RowSeparatorDescriptionModule, RowSeparatorInfoDescription, RowSeparatorInfoDescriptionMetadata, SRProvider, SVGAttributeType_$type, SVGBrush, SVGBrushType_$type, SVGCircle, SVGEllipse, SVGGroup, SVGLine, SVGNode, SVGNodeType_$type, SVGParser, SVGPath, SVGPresentationNode, SVGRect, SVGRoot, ScaleLegendDescription, ScaleLegendDescriptionMetadata, ScaleLegendDescriptionModule, ScaleTransform, ScalerParamsDescription, ScalerParamsDescriptionMetadata, ScalerVisibleBounds, ScatterAreaSeriesDescription, ScatterAreaSeriesDescriptionMetadata, ScatterAreaSeriesDescriptionModule, ScatterBaseDescription, ScatterBaseDescriptionMetadata, ScatterContourSeriesDescription, ScatterContourSeriesDescriptionMetadata, ScatterContourSeriesDescriptionModule, ScatterLineSeriesDescription, ScatterLineSeriesDescriptionMetadata, ScatterLineSeriesDescriptionModule, ScatterPolygonSeriesDescription, ScatterPolygonSeriesDescriptionMetadata, ScatterPolygonSeriesDescriptionModule, ScatterPolylineSeriesDescription, ScatterPolylineSeriesDescriptionMetadata, ScatterPolylineSeriesDescriptionModule, ScatterSeriesDescription, ScatterSeriesDescriptionMetadata, ScatterSeriesDescriptionModule, ScatterSplineSeriesDescription, ScatterSplineSeriesDescriptionMetadata, ScatterSplineSeriesDescriptionModule, ScatterTriangulationSeriesDescription, ScatterTriangulationSeriesDescriptionMetadata, SchedulableRenderWrapper, ScrollbarStyle, ScrollbarStyle_$type, Scroller, ScrollerScrollingEventArgs, ScrollerView, SectionData, SectionDataStartIndexComparer, SectionDataUndisplacedStartIndexComparer, SectionFooterDescription, SectionFooterDescriptionMetadata, SectionFooterDescriptionModule, SectionHeaderCellInfoDescription, SectionHeaderCellInfoDescriptionMetadata, SectionHeaderDescription, SectionHeaderDescriptionMetadata, SectionHeaderDescriptionModule, SectionInformationDescription, SectionInformationDescriptionMetadata, SectionMap, SectionSearchData, SecurityAction, SecurityAction_$type, SeekOrigin, SegmentData, SelectAllCheckboxChangedEventArgsDescription, SelectAllCheckboxChangedEventArgsDescriptionMetadata, SelectedItemChangedEventArgsDescription, SelectedItemChangedEventArgsDescriptionMetadata, SelectedItemChangingEventArgsDescription, SelectedItemChangingEventArgsDescriptionMetadata, SelectedItemsChangedEventArgsDescription, SelectedItemsChangedEventArgsDescriptionMetadata, SelectedItemsChangingEventArgsDescription, SelectedItemsChangingEventArgsDescriptionMetadata, SelectedValueChangedEventArgsDescription, SelectedValueChangedEventArgsDescriptionMetadata, SeriesDescription, SeriesDescriptionMetadata, SeriesLayerDescription, SeriesLayerDescriptionMetadata, SeriesLayerPropertyOverlayDescription, SeriesLayerPropertyOverlayDescriptionMetadata, SeriesLayerPropertyOverlayValueResolvingEventArgsDescription, SeriesLayerPropertyOverlayValueResolvingEventArgsDescriptionMetadata, SeriesMatcherDescription, SeriesMatcherDescriptionMetadata, SeriesMatcherDescriptionModule, SeriesViewerDescription, SeriesViewerDescriptionMetadata, SeriesViewerManipulationEventArgsDescription, SeriesViewerManipulationEventArgsDescriptionMetadata, SeriesViewerSelectedSeriesItemsChangedEventArgsDescription, SeriesViewerSelectedSeriesItemsChangedEventArgsDescriptionMetadata, SeriesViewerSelectedSeriesItemsChangingEventArgsDescription, SeriesViewerSelectedSeriesItemsChangingEventArgsDescriptionMetadata, Shape, ShapeDataSourceDescription, ShapeDataSourceDescriptionMetadata, ShapeDataSourceDescriptionModule, ShapeFileUtil, ShapeFilterRecordEventArgs, ShapeFilterRecordEventArgsDescription, ShapeFilterRecordEventArgsDescriptionMetadata, ShapeSeriesBaseDescription, ShapeSeriesBaseDescriptionMetadata, ShapeTags, ShapeType, ShapeType_$type, ShapefileConverter, ShapefileRecord, ShapefileRecordDescription, ShapefileRecordDescriptionMetadata, SimpleCategorySeriesRule, SimpleDefaultTooltipDescriptionMetadata, SimpleDefaultTooltipExtendedDescriptionMetadata, SimpleFinancialPriceSeriesRule, SimplePieSeriesRule, SimpleScatterSeriesRule, Size, SizeData, SizeDescription, SizeScaleDescription, SizeScaleDescriptionMetadata, SizeScaleDescriptionModule, SliceClickEventArgsDescription, SliceClickEventArgsDescriptionMetadata, SliceEventArgsDescription, SliceEventArgsDescriptionMetadata, SlowStochasticOscillatorIndicatorDescription, SlowStochasticOscillatorIndicatorDescriptionMetadata, SlowStochasticOscillatorIndicatorDescriptionModule, SmartPlaceableWrapper$1, SmartPlacer, SmartPosition, SmartPosition_$type, SolidBrushAppearanceData, SortDescription, SortDescriptionCollection, SortGroupParser, SortIndicatorRenderCompletedEventArgsDescription, SortIndicatorRenderCompletedEventArgsDescriptionMetadata, SortedList$1, SpanBridge, SparklineCoreDescriptionModule, SparklineDescription, SparklineDescriptionMetadata, SparklineDescriptionModule, SpiralFlattener, SpiralTodo, SplineAreaFragmentDescription, SplineAreaFragmentDescriptionMetadata, SplineAreaFragmentDescriptionModule, SplineAreaSeriesDescription, SplineAreaSeriesDescriptionMetadata, SplineAreaSeriesDescriptionModule, SplineFragmentBaseDescription, SplineFragmentBaseDescriptionMetadata, SplineFragmentDescription, SplineFragmentDescriptionMetadata, SplineFragmentDescriptionModule, SplineSeriesBaseDescription, SplineSeriesBaseDescriptionMetadata, SplineSeriesDescription, SplineSeriesDescriptionMetadata, SplineSeriesDescriptionModule, Stack$1, StackPool$1, Stacked100AreaSeriesDescription, Stacked100AreaSeriesDescriptionMetadata, Stacked100AreaSeriesDescriptionModule, Stacked100BarSeriesDescription, Stacked100BarSeriesDescriptionMetadata, Stacked100BarSeriesDescriptionModule, Stacked100ColumnSeriesDescription, Stacked100ColumnSeriesDescriptionMetadata, Stacked100ColumnSeriesDescriptionModule, Stacked100LineSeriesDescription, Stacked100LineSeriesDescriptionMetadata, Stacked100LineSeriesDescriptionModule, Stacked100SplineAreaSeriesDescription, Stacked100SplineAreaSeriesDescriptionMetadata, Stacked100SplineAreaSeriesDescriptionModule, Stacked100SplineSeriesDescription, Stacked100SplineSeriesDescriptionMetadata, Stacked100SplineSeriesDescriptionModule, StackedAreaSeriesDescription, StackedAreaSeriesDescriptionMetadata, StackedAreaSeriesDescriptionModule, StackedBarSeriesDescription, StackedBarSeriesDescriptionMetadata, StackedBarSeriesDescriptionModule, StackedColumnSeriesDescription, StackedColumnSeriesDescriptionMetadata, StackedColumnSeriesDescriptionModule, StackedFragmentSeriesDescription, StackedFragmentSeriesDescriptionMetadata, StackedFragmentSeriesDescriptionModule, StackedLineSeriesDescription, StackedLineSeriesDescriptionMetadata, StackedLineSeriesDescriptionModule, StackedSeriesBaseDescription, StackedSeriesBaseDescriptionMetadata, StackedSeriesCreatedEventArgsDescription, StackedSeriesCreatedEventArgsDescriptionMetadata, StackedSplineAreaSeriesDescription, StackedSplineAreaSeriesDescriptionMetadata, StackedSplineAreaSeriesDescriptionModule, StackedSplineSeriesDescription, StackedSplineSeriesDescriptionMetadata, StackedSplineSeriesDescriptionModule, StandardDeviationIndicatorDescription, StandardDeviationIndicatorDescriptionMetadata, StandardDeviationIndicatorDescriptionModule, StandardLegendItems_$type, StepAreaSeriesDescription, StepAreaSeriesDescriptionMetadata, StepAreaSeriesDescriptionModule, StepLineSeriesDescription, StepLineSeriesDescriptionMetadata, StepLineSeriesDescriptionModule, StochRSIIndicatorDescription, StochRSIIndicatorDescriptionMetadata, StochRSIIndicatorDescriptionModule, StockChangedEventArgs, StockChangedEventArgsDescription, StockChangedEventArgsDescriptionMetadata, StockDataGenerator, StockDataLookup, StockDetails, StockInfo, StockPosition, StockPriceHistory, StockPricePoint, StraightNumericAxisBaseDescription, StraightNumericAxisBaseDescriptionMetadata, StrategyBasedIndicatorDescription, StrategyBasedIndicatorDescriptionMetadata, Stream, StreamReader, StreamWriter, Stretch, Stretch_$type, StringBuilder, StringComparer, StringReader, StringWriter, String_$type, Style, StyleDescription, StyleDescriptionMetadata, StyleSelectorDescription, StyleSelectorDescriptionMetadata, StyleShapeEventArgsDescription, StyleShapeEventArgsDescriptionMetadata, SubCollectionsRule, SuffixDescription, SuffixDescriptionMetadata, SumSummaryCalculator, SummaryCalculator, SummaryCellInfoDescription, SummaryCellInfoDescriptionMetadata, SummaryChangedEventArgsDescription, SummaryChangedEventArgsDescriptionMetadata, SummaryChooserDescriptionModule, SummaryDataDescription, SummaryDataDescriptionMetadata, SummaryDescription, SummaryDescriptionCollection, SummaryGroup, SummaryParser, SummaryRowDescription, SummaryRowDescriptionMetadata, SummaryRowRootDescription, SummaryRowRootDescriptionMetadata, SummaryRowRootDescriptionModule, SummaryRowSectionDescription, SummaryRowSectionDescriptionMetadata, SummaryRowSectionDescriptionModule, SvgIconCollection, SvgIconRegistry, SweepDirection, SweepDirection_$type, SyncableObservableCollection$1, SyncableObservableCollection$2, SyncableObservableCollectionChangedListener_$type, SynchronizedReader, SynchronizedWriter, SystemException, TRIXIndicatorDescription, TRIXIndicatorDescriptionMetadata, TRIXIndicatorDescriptionModule, TSCodeGeneratingComponentRendererDataEmitter, TSCodeGeneratingComponentRendererHandlerEmitter, TSCodeGeneratingComponentRendererModuleEmitter, TSCodeGeneratingComponentRendererTemplateEmitter, Task, Task$1, TaskCompletionSource$1, TaskFactory, TaskStatus, TaskStatus_$type, TemplateCellInfoDescription, TemplateCellInfoDescriptionMetadata, TemplateCellUpdatingEventArgsDescription, TemplateCellUpdatingEventArgsDescriptionMetadata, TemplateColumnDescription, TemplateColumnDescriptionMetadata, TemplateColumnDescriptionModule, TemplateContainerDescriptionModule, TemplateContentDescriptionModule, TemplateContentExtendedDescriptionModule, TemplateHeaderCellInfoDescription, TemplateHeaderCellInfoDescriptionMetadata, TemplateHeaderCellUpdatingEventArgsDescription, TemplateHeaderCellUpdatingEventArgsDescriptionMetadata, TemplateHeaderDescription, TemplateHeaderDescriptionMetadata, TemplateHeaderDescriptionModule, TemplateSectionHeaderCellInfoDescription, TemplateSectionHeaderCellInfoDescriptionMetadata, TemplateSectionHeaderCellUpdatingEventArgsDescription, TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata, TemplateSectionHeaderDescription, TemplateSectionHeaderDescriptionMetadata, TemplateSectionHeaderDescriptionModule, TestFilterSyntaxVisitor, TextBlock, TextCellInfoDescription, TextCellInfoDescriptionMetadata, TextColumnDescription, TextColumnDescriptionMetadata, TextColumnDescriptionModule, TextFontMetrics, TextHeaderCellInfoDescription, TextHeaderCellInfoDescriptionMetadata, TextHeaderDescription, TextHeaderDescriptionMetadata, TextHeaderDescriptionModule, TextReader, TextReader_NullTextReader, TextWriter, TextWriter_NullTextWriter, Thickness, ThisMonthExpression, ThisMonthExpressionDescription, ThisMonthExpressionDescriptionMetadata, ThisQuarterExpression, ThisQuarterExpressionDescription, ThisQuarterExpressionDescriptionMetadata, ThisWeekExpression, ThisWeekExpressionDescription, ThisWeekExpressionDescriptionMetadata, ThisYearExpression, ThisYearExpressionDescription, ThisYearExpressionDescriptionMetadata, Thread, Tile, TileGeneratorDescription, TileGeneratorDescriptionMetadata, TileGeneratorMapImageryDescription, TileGeneratorMapImageryDescriptionMetadata, TileGeneratorMapImageryDescriptionModule, TileGeneratorTileSource, TileImageCreatedEventArgs, TileImageZoomChangingEventArgs, TilePositionComparer, TileSeriesDescription, TileSeriesDescriptionMetadata, TileSeriesDescriptionModule, TileWorkCompletedSink, TileWorkSettings, TimeAxisBaseDescription, TimeAxisBaseDescriptionMetadata, TimeAxisBreakDescription, TimeAxisBreakDescriptionMetadata, TimeAxisBreakDescriptionModule, TimeAxisIntervalDescription, TimeAxisIntervalDescriptionMetadata, TimeAxisIntervalDescriptionModule, TimeAxisLabelFormatDescription, TimeAxisLabelFormatDescriptionMetadata, TimeAxisLabelFormatDescriptionModule, TimeXAxisDescription, TimeXAxisDescriptionMetadata, TimeXAxisDescriptionModule, TodayExpression, TodayExpressionDescription, TodayExpressionDescriptionMetadata, TomorrowExpression, TomorrowExpressionDescription, TomorrowExpressionDescriptionMetadata, ToolActionButtonDescription, ToolActionButtonDescriptionMetadata, ToolActionButtonDescriptionModule, ToolActionCheckboxDescription, ToolActionCheckboxDescriptionMetadata, ToolActionCheckboxDescriptionModule, ToolActionCheckboxInfo, ToolActionCheckboxInfoDescription, ToolActionCheckboxInfoDescriptionMetadata, ToolActionCheckboxListDescription, ToolActionCheckboxListDescriptionMetadata, ToolActionCheckboxListDescriptionModule, ToolActionCheckboxListInfo, ToolActionCheckboxListInfoDescription, ToolActionCheckboxListInfoDescriptionMetadata, ToolActionDescription, ToolActionDescriptionMetadata, ToolActionEventDetailDescription, ToolActionEventDetailDescriptionMetadata, ToolActionGroupHeaderDescription, ToolActionGroupHeaderDescriptionMetadata, ToolActionGroupHeaderDescriptionModule, ToolActionGroupHeaderInfo, ToolActionGroupHeaderInfoDescription, ToolActionGroupHeaderInfoDescriptionMetadata, ToolActionIconButtonDescription, ToolActionIconButtonDescriptionMetadata, ToolActionIconButtonDescriptionModule, ToolActionIconButtonInfo, ToolActionIconButtonInfoDescription, ToolActionIconButtonInfoDescriptionMetadata, ToolActionIconMenuDescription, ToolActionIconMenuDescriptionMetadata, ToolActionIconMenuDescriptionModule, ToolActionIconMenuInfo, ToolActionIconMenuInfoDescription, ToolActionIconMenuInfoDescriptionMetadata, ToolActionInfo, ToolActionInfoDescription, ToolActionInfoDescriptionMetadata, ToolActionLabelDescription, ToolActionLabelDescriptionMetadata, ToolActionLabelDescriptionModule, ToolActionLabelInfo, ToolActionLabelInfoDescription, ToolActionLabelInfoDescriptionMetadata, ToolActionNumberInputDescription, ToolActionNumberInputDescriptionMetadata, ToolActionNumberInputDescriptionModule, ToolActionNumberInputInfo, ToolActionNumberInputInfoDescription, ToolActionNumberInputInfoDescriptionMetadata, ToolActionPerformedEventArgsDescription, ToolActionPerformedEventArgsDescriptionMetadata, ToolActionRadioDescription, ToolActionRadioDescriptionMetadata, ToolActionRadioDescriptionModule, ToolActionRadioInfo, ToolActionRadioInfoDescription, ToolActionRadioInfoDescriptionMetadata, ToolActionSeparatorDescription, ToolActionSeparatorDescriptionMetadata, ToolActionSeparatorDescriptionModule, ToolActionSeparatorInfo, ToolActionSeparatorInfoDescription, ToolActionSeparatorInfoDescriptionMetadata, ToolActionSubPanelDescription, ToolActionSubPanelDescriptionMetadata, ToolActionSubPanelDescriptionModule, ToolActionType, ToolActionType_$type, ToolCommand, ToolCommandArgument, ToolCommandArgumentCollection, ToolCommandArgumentDescription, ToolCommandArgumentDescriptionMetadata, ToolCommandDescription, ToolCommandDescriptionMetadata, ToolCommandEventArgsDescription, ToolCommandEventArgsDescriptionMetadata, ToolCommandExecutionState, ToolCommandExecutionState_$type, ToolCommandStateChanged, ToolCommandStateType, ToolCommandStateType_$type, ToolPanelContentRefreshedEventArgsDescription, ToolPanelContentRefreshedEventArgsDescriptionMetadata, ToolPanelDescription, ToolPanelDescriptionMetadata, ToolPanelDescriptionModule, ToolbarDescription, ToolbarDescriptionMetadata, ToolbarDescriptionModule, TooltipContainerDescriptionModule, TooltipContainerExtendedDescriptionModule, TopClipper, TouchGestureEventArgs, TouchGestureRecognizer, TouchGestureState_$type, TouchHistoryItem, TouchPointInfo, TouchVelocityReading, TouchVelocityTracker, Transaction, TransactionCommit, TransactionEvent, TransactionEvent_$type, TransactionHistory, TransactionKeyEqualityComparer, TransactionPendingState, TransactionPendingState_$type, TransactionService, TransactionState, TransactionStateDescription, TransactionStateDescriptionMetadata, TransactionType, TransactionType_$type, Transform, TransformCollection, TransformGroup, TransformMatrixHelpler, TransitionOutCompletedEventArgsDescription, TransitionOutCompletedEventArgsDescriptionMetadata, TranslateTransform, TreemapDescription, TreemapDescriptionMetadata, TreemapDescriptionModule, TreemapNodePointerEventArgsDescription, TreemapNodePointerEventArgsDescriptionMetadata, TreemapNodeStyleDescription, TreemapNodeStyleDescriptionMetadata, TreemapNodeStyleDescriptionModule, TreemapNodeStyleMappingDescription, TreemapNodeStyleMappingDescriptionMetadata, TreemapNodeStyleMappingDescriptionModule, TreemapNodeStylingEventArgsDescription, TreemapNodeStylingEventArgsDescriptionMetadata, TrendCalculators, TrendLineType, TrendLineType_$type, Triangle, TriangulationDataSourceDescription, TriangulationDataSourceDescriptionMetadata, TriangulationSource, TriangulationSourcePointRecord, TriangulationStatusEventArgs, TriangulationStatusEventArgsDescription, TriangulationStatusEventArgsDescriptionMetadata, Triangulator, TriangulatorContext, Tuple, Tuple$2, Tuple$3, Type, TypeDescriptionCleanups, TypeDescriptionContext, TypeDescriptionMetadata, TypeDescriptionPlatform, TypeDescriptionPlatform_$type, TypeDescriptionPropretyTransforms, TypeDescriptionWellKnownType, TypeDescriptionWellKnownType_$type, TypeRegistrar, TypicalPriceIndicatorDescription, TypicalPriceIndicatorDescriptionMetadata, TypicalPriceIndicatorDescriptionModule, UIElement, UIElementCollection, UIElementPropertyAccessor, UIElementPropertyAccessorFactory, UIElementPropertyId_$type, UTF8Encoding, UTF8Encoding_UTF8Decoder, UltimateOscillatorIndicatorDescription, UltimateOscillatorIndicatorDescriptionMetadata, UltimateOscillatorIndicatorDescriptionModule, UnicodeEncoding, UnknownValuePlotting, UnknownValuePlotting_$type, UnsetValue, UploadDataCompletedEventArgs, UploadDataCompletedEventArgsDescription, UploadDataCompletedEventArgsDescriptionMetadata, UploadStringCompletedEventArgs, UploadStringCompletedEventArgsDescription, UploadStringCompletedEventArgsDescriptionMetadata, Uri, UriKind, UriKind_$type, UriParser, ValueBrushScaleDescription, ValueBrushScaleDescriptionMetadata, ValueBrushScaleDescriptionModule, ValueLayerDescription, ValueLayerDescriptionMetadata, ValueLayerDescriptionModule, ValueOverlayDescription, ValueOverlayDescriptionMetadata, ValueOverlayDescriptionModule, ValueType, VersionQueueAction, VersionQueueHelper, VerticalAlignment, VerticalAlignment_$type, VerticalAnchoredCategorySeriesDescription, VerticalAnchoredCategorySeriesDescriptionMetadata, VerticalSeparatorCellInfoDescription, VerticalSeparatorCellInfoDescriptionMetadata, VerticalStackedSeriesBaseDescription, VerticalStackedSeriesBaseDescriptionMetadata, VirtualDataSource, VirtualDataSourceDescription, VirtualDataSourceDescriptionMetadata, Visibility, Visibility_$type, VisualDataPixelScalingOptions, VoidEventArgsDescription, VoidEventArgsDescriptionMetadata, Void_$type, WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter, WPFXamlCodeGeneratingComponentRendererCodeEmitter, WaterfallSeriesDescription, WaterfallSeriesDescriptionMetadata, WaterfallSeriesDescriptionModule, WeakReference, WebAccordionDescription, WebAccordionDescriptionMetadata, WebAccordionDescriptionModule, WebActionStripDescription, WebActionStripDescriptionMetadata, WebActionStripDescriptionModule, WebActionStripResourceStringsDescription, WebActionStripResourceStringsDescriptionMetadata, WebActiveNodeChangeEventArgsDescription, WebActiveNodeChangeEventArgsDescriptionMetadata, WebActiveNodeChangeEventArgsDetailDescription, WebActiveNodeChangeEventArgsDetailDescriptionMetadata, WebActivePaneEventArgsDescription, WebActivePaneEventArgsDescriptionMetadata, WebActivePaneEventArgsDetailDescription, WebActivePaneEventArgsDetailDescriptionMetadata, WebActiveStepChangedArgsDetailDescription, WebActiveStepChangedArgsDetailDescriptionMetadata, WebActiveStepChangedArgsEventArgsDescription, WebActiveStepChangedArgsEventArgsDescriptionMetadata, WebActiveStepChangingArgsDetailDescription, WebActiveStepChangingArgsDetailDescriptionMetadata, WebActiveStepChangingArgsEventArgsDescription, WebActiveStepChangingArgsEventArgsDescriptionMetadata, WebAvatarDescription, WebAvatarDescriptionMetadata, WebAvatarDescriptionModule, WebBadgeDescription, WebBadgeDescriptionMetadata, WebBadgeDescriptionModule, WebBannerDescription, WebBannerDescriptionMetadata, WebBannerDescriptionModule, WebBaseAlertLikeDescription, WebBaseAlertLikeDescriptionMetadata, WebBaseAlertLikeDescriptionModule, WebBaseComboBoxLikeDescription, WebBaseComboBoxLikeDescriptionMetadata, WebBaseComboBoxLikeDescriptionModule, WebBaseDateTimeFilteringOperandDescription, WebBaseDateTimeFilteringOperandDescriptionMetadata, WebBaseEventArgsDescription, WebBaseEventArgsDescriptionMetadata, WebBaseEventArgsDetailDescription, WebBaseEventArgsDetailDescriptionMetadata, WebBaseExporterDescription, WebBaseExporterDescriptionMetadata, WebBaseOptionLikeDescription, WebBaseOptionLikeDescriptionMetadata, WebBaseOptionLikeDescriptionModule, WebBaseSearchInfoDescription, WebBaseSearchInfoDescriptionMetadata, WebBaseToolbarColumnActionsDirectiveDescription, WebBaseToolbarColumnActionsDirectiveDescriptionMetadata, WebBaseToolbarColumnActionsDirectiveDescriptionModule, WebBaseToolbarDirectiveDescription, WebBaseToolbarDirectiveDescriptionMetadata, WebBooleanFilteringOperandDescription, WebBooleanFilteringOperandDescriptionMetadata, WebButtonBaseDescription, WebButtonBaseDescriptionMetadata, WebButtonBaseDescriptionModule, WebButtonDescription, WebButtonDescriptionMetadata, WebButtonDescriptionModule, WebButtonGroupDescription, WebButtonGroupDescriptionMetadata, WebButtonGroupDescriptionModule, WebCalendarBaseDescription, WebCalendarBaseDescriptionMetadata, WebCalendarBaseDescriptionModule, WebCalendarDateEventArgsDescription, WebCalendarDateEventArgsDescriptionMetadata, WebCalendarDescription, WebCalendarDescriptionMetadata, WebCalendarDescriptionModule, WebCalendarResourceStringsDescription, WebCalendarResourceStringsDescriptionMetadata, WebCancelableBrowserEventArgsDescription, WebCancelableBrowserEventArgsDescriptionMetadata, WebCancelableBrowserEventArgsDetailDescription, WebCancelableBrowserEventArgsDetailDescriptionMetadata, WebCancelableEventArgsDescription, WebCancelableEventArgsDescriptionMetadata, WebCancelableEventArgsDetailDescription, WebCancelableEventArgsDetailDescriptionMetadata, WebCardActionsDescription, WebCardActionsDescriptionMetadata, WebCardActionsDescriptionModule, WebCardContentDescription, WebCardContentDescriptionMetadata, WebCardContentDescriptionModule, WebCardDescription, WebCardDescriptionMetadata, WebCardDescriptionModule, WebCardHeaderDescription, WebCardHeaderDescriptionMetadata, WebCardHeaderDescriptionModule, WebCardMediaDescription, WebCardMediaDescriptionMetadata, WebCardMediaDescriptionModule, WebCellPositionDescription, WebCellPositionDescriptionMetadata, WebCellTemplateContextDescription, WebCellTemplateContextDescriptionMetadata, WebCellTypeDescription, WebCellTypeDescriptionMetadata, WebCheckboxBaseDescription, WebCheckboxBaseDescriptionMetadata, WebCheckboxBaseDescriptionModule, WebCheckboxChangeEventArgsDescription, WebCheckboxChangeEventArgsDescriptionMetadata, WebCheckboxChangeEventArgsDetailDescription, WebCheckboxChangeEventArgsDetailDescriptionMetadata, WebCheckboxDescription, WebCheckboxDescriptionMetadata, WebCheckboxDescriptionModule, WebChildGridRowDescription, WebChildGridRowDescriptionMetadata, WebChildGridRowDescriptionModule, WebChipDescription, WebChipDescriptionMetadata, WebChipDescriptionModule, WebCircularGradientDescription, WebCircularGradientDescriptionMetadata, WebCircularGradientDescriptionModule, WebCircularProgressDescription, WebCircularProgressDescriptionMetadata, WebCircularProgressDescriptionModule, WebClient, WebClipboardOptionsDescription, WebClipboardOptionsDescriptionMetadata, WebCodeBehindCodeGeneratingComponentRendererCodeEmitter, WebColumnComponentEventArgsDescription, WebColumnComponentEventArgsDescriptionMetadata, WebColumnDescription, WebColumnDescriptionMetadata, WebColumnDescriptionModule, WebColumnExportingEventArgsDescription, WebColumnExportingEventArgsDescriptionMetadata, WebColumnExportingEventArgsDetailDescription, WebColumnExportingEventArgsDetailDescriptionMetadata, WebColumnGroupDescription, WebColumnGroupDescriptionMetadata, WebColumnGroupDescriptionModule, WebColumnLayoutDescription, WebColumnLayoutDescriptionMetadata, WebColumnLayoutDescriptionModule, WebColumnMovingEndEventArgsDescription, WebColumnMovingEndEventArgsDescriptionMetadata, WebColumnMovingEndEventArgsDetailDescription, WebColumnMovingEndEventArgsDetailDescriptionMetadata, WebColumnMovingEventArgsDescription, WebColumnMovingEventArgsDescriptionMetadata, WebColumnMovingEventArgsDetailDescription, WebColumnMovingEventArgsDetailDescriptionMetadata, WebColumnMovingStartEventArgsDescription, WebColumnMovingStartEventArgsDescriptionMetadata, WebColumnMovingStartEventArgsDetailDescription, WebColumnMovingStartEventArgsDetailDescriptionMetadata, WebColumnPipeArgsDescription, WebColumnPipeArgsDescriptionMetadata, WebColumnResizeEventArgsDescription, WebColumnResizeEventArgsDescriptionMetadata, WebColumnResizeEventArgsDetailDescription, WebColumnResizeEventArgsDetailDescriptionMetadata, WebColumnSelectionEventArgsDescription, WebColumnSelectionEventArgsDescriptionMetadata, WebColumnSelectionEventArgsDetailDescription, WebColumnSelectionEventArgsDetailDescriptionMetadata, WebColumnStateDescription, WebColumnStateDescriptionMetadata, WebColumnTemplateContextDescription, WebColumnTemplateContextDescriptionMetadata, WebColumnToggledEventArgsDescription, WebColumnToggledEventArgsDescriptionMetadata, WebColumnToggledEventArgsDetailDescription, WebColumnToggledEventArgsDetailDescriptionMetadata, WebColumnVisibilityChangedEventArgsDescription, WebColumnVisibilityChangedEventArgsDescriptionMetadata, WebColumnVisibilityChangedEventArgsDetailDescription, WebColumnVisibilityChangedEventArgsDetailDescriptionMetadata, WebColumnVisibilityChangingEventArgsDescription, WebColumnVisibilityChangingEventArgsDescriptionMetadata, WebColumnVisibilityChangingEventArgsDetailDescription, WebColumnVisibilityChangingEventArgsDetailDescriptionMetadata, WebColumnsAutoGeneratedEventArgsDescription, WebColumnsAutoGeneratedEventArgsDescriptionMetadata, WebColumnsAutoGeneratedEventArgsDetailDescription, WebColumnsAutoGeneratedEventArgsDetailDescriptionMetadata, WebComboChangeEventArgsDescription, WebComboChangeEventArgsDescriptionMetadata, WebComboChangeEventArgsDetailDescription, WebComboChangeEventArgsDetailDescriptionMetadata, WebComboDescription, WebComboDescriptionMetadata, WebComboDescriptionModule, WebComponentBoolValueChangedEventArgsDescription, WebComponentBoolValueChangedEventArgsDescriptionMetadata, WebComponentDataValueChangedEventArgsDescription, WebComponentDataValueChangedEventArgsDescriptionMetadata, WebComponentDateValueChangedEventArgsDescription, WebComponentDateValueChangedEventArgsDescriptionMetadata, WebComponentValueChangedEventArgsDescription, WebComponentValueChangedEventArgsDescriptionMetadata, WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter, WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter, WebContentPaneDescription, WebContentPaneDescriptionMetadata, WebContentPaneDescriptionModule, WebDataCloneStrategyDescription, WebDataCloneStrategyDescriptionMetadata, WebDateFilteringOperandDescription, WebDateFilteringOperandDescriptionMetadata, WebDatePickerDescription, WebDatePickerDescriptionMetadata, WebDatePickerDescriptionModule, WebDateSummaryOperandDescription, WebDateSummaryOperandDescriptionMetadata, WebDateTimeFilteringOperandDescription, WebDateTimeFilteringOperandDescriptionMetadata, WebDateTimeInputDescription, WebDateTimeInputDescriptionMetadata, WebDateTimeInputDescriptionModule, WebDialogDescription, WebDialogDescriptionMetadata, WebDialogDescriptionModule, WebDimensionsChangeDescription, WebDimensionsChangeDescriptionMetadata, WebDimensionsChangeDetailDescription, WebDimensionsChangeDetailDescriptionMetadata, WebDimensionsChangeEventArgsDescription, WebDimensionsChangeEventArgsDescriptionMetadata, WebDividerDescription, WebDividerDescriptionMetadata, WebDividerDescriptionModule, WebDockManagerDescription, WebDockManagerDescriptionMetadata, WebDockManagerDescriptionModule, WebDockManagerLayoutDescription, WebDockManagerLayoutDescriptionMetadata, WebDockManagerLayoutDescriptionModule, WebDockManagerPaneDescription, WebDockManagerPaneDescriptionMetadata, WebDockManagerPointDescription, WebDockManagerPointDescriptionMetadata, WebDockManagerPointDescriptionModule, WebDockManagerResourceStringsDescription, WebDockManagerResourceStringsDescriptionMetadata, WebDockPaneActionDescription, WebDockPaneActionDescriptionMetadata, WebDockingIndicatorDescription, WebDockingIndicatorDescriptionMetadata, WebDocumentHostDescription, WebDocumentHostDescriptionMetadata, WebDocumentHostDescriptionModule, WebDragServiceDescription, WebDragServiceDescriptionMetadata, WebDragServiceDescriptionModule, WebDropdownDescription, WebDropdownDescriptionMetadata, WebDropdownDescriptionModule, WebDropdownGroupDescription, WebDropdownGroupDescriptionMetadata, WebDropdownGroupDescriptionModule, WebDropdownHeaderDescription, WebDropdownHeaderDescriptionMetadata, WebDropdownHeaderDescriptionModule, WebDropdownItemComponentEventArgsDescription, WebDropdownItemComponentEventArgsDescriptionMetadata, WebDropdownItemDescription, WebDropdownItemDescriptionMetadata, WebDropdownItemDescriptionModule, WebExpansionPanelComponentEventArgsDescription, WebExpansionPanelComponentEventArgsDescriptionMetadata, WebExpansionPanelDescription, WebExpansionPanelDescriptionMetadata, WebExpansionPanelDescriptionModule, WebExporterEventArgsDescription, WebExporterEventArgsDescriptionMetadata, WebExporterEventArgsDetailDescription, WebExporterEventArgsDetailDescriptionMetadata, WebExporterOptionsBaseDescription, WebExporterOptionsBaseDescriptionMetadata, WebFieldPipeArgsDescription, WebFieldPipeArgsDescriptionMetadata, WebFilteringEventArgsDescription, WebFilteringEventArgsDescriptionMetadata, WebFilteringEventArgsDetailDescription, WebFilteringEventArgsDetailDescriptionMetadata, WebFilteringExpressionDescription, WebFilteringExpressionDescriptionMetadata, WebFilteringExpressionsTreeDescription, WebFilteringExpressionsTreeDescriptionMetadata, WebFilteringExpressionsTreeDetailDescription, WebFilteringExpressionsTreeDetailDescriptionMetadata, WebFilteringExpressionsTreeEventArgsDescription, WebFilteringExpressionsTreeEventArgsDescriptionMetadata, WebFilteringExpressionsTreeOrFilteringExpressionDescription, WebFilteringExpressionsTreeOrFilteringExpressionDescriptionMetadata, WebFilteringExpressionsTreeOrFilteringOperationDescription, WebFilteringExpressionsTreeOrFilteringOperationDescriptionMetadata, WebFilteringOperandDescription, WebFilteringOperandDescriptionMetadata, WebFilteringOperationDescription, WebFilteringOperationDescriptionMetadata, WebFilteringOptionsDescription, WebFilteringOptionsDescriptionMetadata, WebFilteringStrategyDescription, WebFilteringStrategyDescriptionMetadata, WebFloatPaneActionDescription, WebFloatPaneActionDescriptionMetadata, WebFloatingPaneResizeEventArgsDescription, WebFloatingPaneResizeEventArgsDescriptionMetadata, WebFloatingPaneResizeEventArgsDetailDescription, WebFloatingPaneResizeEventArgsDetailDescriptionMetadata, WebFloatingPaneResizeMoveEventArgsDescription, WebFloatingPaneResizeMoveEventArgsDescriptionMetadata, WebFloatingPaneResizeMoveEventArgsDetailDescription, WebFloatingPaneResizeMoveEventArgsDetailDescriptionMetadata, WebForOfDataChangingEventArgsDescription, WebForOfDataChangingEventArgsDescriptionMetadata, WebForOfDataChangingEventArgsDetailDescription, WebForOfDataChangingEventArgsDetailDescriptionMetadata, WebForOfStateDescription, WebForOfStateDescriptionMetadata, WebForOfStateDetailDescription, WebForOfStateDetailDescriptionMetadata, WebForOfStateEventArgsDescription, WebForOfStateEventArgsDescriptionMetadata, WebGridActionButtonDescription, WebGridActionButtonDescriptionMetadata, WebGridActionsBaseDirectiveDescription, WebGridActionsBaseDirectiveDescriptionMetadata, WebGridActionsBaseDirectiveDescriptionModule, WebGridBaseDirectiveDescription, WebGridBaseDirectiveDescriptionMetadata, WebGridCellEventArgsDescription, WebGridCellEventArgsDescriptionMetadata, WebGridCellEventArgsDetailDescription, WebGridCellEventArgsDetailDescriptionMetadata, WebGridCellIdentifierDescription, WebGridCellIdentifierDescriptionMetadata, WebGridClipboardEventDescription, WebGridClipboardEventDescriptionMetadata, WebGridClipboardEventDetailDescription, WebGridClipboardEventDetailDescriptionMetadata, WebGridClipboardEventEventArgsDescription, WebGridClipboardEventEventArgsDescriptionMetadata, WebGridContextMenuEventArgsDescription, WebGridContextMenuEventArgsDescriptionMetadata, WebGridContextMenuEventArgsDetailDescription, WebGridContextMenuEventArgsDetailDescriptionMetadata, WebGridCreatedEventArgsDescription, WebGridCreatedEventArgsDescriptionMetadata, WebGridCreatedEventArgsDetailDescription, WebGridCreatedEventArgsDetailDescriptionMetadata, WebGridDescription, WebGridDescriptionMetadata, WebGridDescriptionModule, WebGridEditDoneEventArgsDescription, WebGridEditDoneEventArgsDescriptionMetadata, WebGridEditDoneEventArgsDetailDescription, WebGridEditDoneEventArgsDetailDescriptionMetadata, WebGridEditEventArgsDescription, WebGridEditEventArgsDescriptionMetadata, WebGridEditEventArgsDetailDescription, WebGridEditEventArgsDetailDescriptionMetadata, WebGridEditingActionsDescription, WebGridEditingActionsDescriptionMetadata, WebGridEditingActionsDescriptionModule, WebGridEmptyTemplateContextDescription, WebGridEmptyTemplateContextDescriptionMetadata, WebGridFormGroupCreatedEventArgsDescription, WebGridFormGroupCreatedEventArgsDescriptionMetadata, WebGridFormGroupCreatedEventArgsDetailDescription, WebGridFormGroupCreatedEventArgsDetailDescriptionMetadata, WebGridGroupingStrategyDescription, WebGridGroupingStrategyDescriptionMetadata, WebGridHeaderTemplateContextDescription, WebGridHeaderTemplateContextDescriptionMetadata, WebGridKeydownEventArgsDescription, WebGridKeydownEventArgsDescriptionMetadata, WebGridKeydownEventArgsDetailDescription, WebGridKeydownEventArgsDetailDescriptionMetadata, WebGridMasterDetailContextDescription, WebGridMasterDetailContextDescriptionMetadata, WebGridPaginatorTemplateContextDescription, WebGridPaginatorTemplateContextDescriptionMetadata, WebGridPinningActionsDescription, WebGridPinningActionsDescriptionMetadata, WebGridPinningActionsDescriptionModule, WebGridResourceStringsDescription, WebGridResourceStringsDescriptionMetadata, WebGridRowDescription, WebGridRowDescriptionMetadata, WebGridRowDragGhostContextDescription, WebGridRowDragGhostContextDescriptionMetadata, WebGridRowEditActionsTemplateContextDescription, WebGridRowEditActionsTemplateContextDescriptionMetadata, WebGridRowEditTextTemplateContextDescription, WebGridRowEditTextTemplateContextDescriptionMetadata, WebGridRowEventArgsDescription, WebGridRowEventArgsDescriptionMetadata, WebGridRowEventArgsDetailDescription, WebGridRowEventArgsDetailDescriptionMetadata, WebGridRowTemplateContextDescription, WebGridRowTemplateContextDescriptionMetadata, WebGridScrollEventArgsDescription, WebGridScrollEventArgsDescriptionMetadata, WebGridScrollEventArgsDetailDescription, WebGridScrollEventArgsDetailDescriptionMetadata, WebGridSelectionRangeDescription, WebGridSelectionRangeDescriptionMetadata, WebGridSelectionRangeDetailDescription, WebGridSelectionRangeDetailDescriptionMetadata, WebGridSelectionRangeEventArgsDescription, WebGridSelectionRangeEventArgsDescriptionMetadata, WebGridSortingStrategyDescription, WebGridSortingStrategyDescriptionMetadata, WebGridStateBaseDirectiveDescription, WebGridStateBaseDirectiveDescriptionMetadata, WebGridStateBaseDirectiveDescriptionModule, WebGridStateCollectionDescription, WebGridStateCollectionDescriptionMetadata, WebGridStateDescription, WebGridStateDescriptionMetadata, WebGridStateDescriptionModule, WebGridStateInfoDescription, WebGridStateInfoDescriptionMetadata, WebGridStateInfoDetailDescription, WebGridStateInfoDetailDescriptionMetadata, WebGridStateInfoEventArgsDescription, WebGridStateInfoEventArgsDescriptionMetadata, WebGridStateOptionsDescription, WebGridStateOptionsDescriptionMetadata, WebGridTemplateContextDescription, WebGridTemplateContextDescriptionMetadata, WebGridToolbarActionsDescription, WebGridToolbarActionsDescriptionMetadata, WebGridToolbarActionsDescriptionModule, WebGridToolbarAdvancedFilteringDescription, WebGridToolbarAdvancedFilteringDescriptionMetadata, WebGridToolbarAdvancedFilteringDescriptionModule, WebGridToolbarBaseActionDescription, WebGridToolbarBaseActionDescriptionMetadata, WebGridToolbarContentDescription, WebGridToolbarContentDescriptionMetadata, WebGridToolbarDescription, WebGridToolbarDescriptionMetadata, WebGridToolbarDescriptionModule, WebGridToolbarExportEventArgsDescription, WebGridToolbarExportEventArgsDescriptionMetadata, WebGridToolbarExportEventArgsDetailDescription, WebGridToolbarExportEventArgsDetailDescriptionMetadata, WebGridToolbarExporterDescription, WebGridToolbarExporterDescriptionMetadata, WebGridToolbarExporterDescriptionModule, WebGridToolbarHidingDescription, WebGridToolbarHidingDescriptionMetadata, WebGridToolbarHidingDescriptionModule, WebGridToolbarPinningDescription, WebGridToolbarPinningDescriptionMetadata, WebGridToolbarPinningDescriptionModule, WebGridToolbarTemplateContextDescription, WebGridToolbarTemplateContextDescriptionMetadata, WebGridToolbarTitleDescription, WebGridToolbarTitleDescriptionMetadata, WebGridToolbarTitleDescriptionModule, WebGridValidationStateDescription, WebGridValidationStateDescriptionMetadata, WebGridValidationStatusEventArgsDescription, WebGridValidationStatusEventArgsDescriptionMetadata, WebGridValidationStatusEventArgsDetailDescription, WebGridValidationStatusEventArgsDetailDescriptionMetadata, WebGroupByExpandStateDescription, WebGroupByExpandStateDescriptionMetadata, WebGroupByKeyDescription, WebGroupByKeyDescriptionMetadata, WebGroupByRecordDescription, WebGroupByRecordDescriptionMetadata, WebGroupByResultDescription, WebGroupByResultDescriptionMetadata, WebGroupByRowSelectorTemplateContextDescription, WebGroupByRowSelectorTemplateContextDescriptionMetadata, WebGroupByRowSelectorTemplateDetailsDescription, WebGroupByRowSelectorTemplateDetailsDescriptionMetadata, WebGroupByRowTemplateContextDescription, WebGroupByRowTemplateContextDescriptionMetadata, WebGroupingDoneEventArgsDescription, WebGroupingDoneEventArgsDescriptionMetadata, WebGroupingDoneEventArgsDetailDescription, WebGroupingDoneEventArgsDetailDescriptionMetadata, WebGroupingExpressionDescription, WebGroupingExpressionDescriptionMetadata, WebGroupingStateDescription, WebGroupingStateDescriptionMetadata, WebHeadSelectorTemplateContextDescription, WebHeadSelectorTemplateContextDescriptionMetadata, WebHeadSelectorTemplateDetailsDescription, WebHeadSelectorTemplateDetailsDescriptionMetadata, WebHeaderCollection, WebHeaderTypeDescription, WebHeaderTypeDescriptionMetadata, WebHierarchicalGridBaseDirectiveDescription, WebHierarchicalGridBaseDirectiveDescriptionMetadata, WebHierarchicalGridDescription, WebHierarchicalGridDescriptionMetadata, WebHierarchicalGridDescriptionModule, WebIconButtonDescription, WebIconButtonDescriptionMetadata, WebIconButtonDescriptionModule, WebIconDescription, WebIconDescriptionMetadata, WebIconDescriptionModule, WebIconMetaDescription, WebIconMetaDescriptionMetadata, WebImportsHalper, WebInputBaseDescription, WebInputBaseDescriptionMetadata, WebInputBaseDescriptionModule, WebInputDescription, WebInputDescriptionMetadata, WebInputDescriptionModule, WebLayoutChangeEventArgsDescription, WebLayoutChangeEventArgsDescriptionMetadata, WebLinearProgressDescription, WebLinearProgressDescriptionMetadata, WebLinearProgressDescriptionModule, WebListDescription, WebListDescriptionMetadata, WebListDescriptionModule, WebListHeaderDescription, WebListHeaderDescriptionMetadata, WebListHeaderDescriptionModule, WebListItemDescription, WebListItemDescriptionMetadata, WebListItemDescriptionModule, WebMaskInputBaseDescription, WebMaskInputBaseDescriptionMetadata, WebMaskInputBaseDescriptionModule, WebMaskInputDescription, WebMaskInputDescriptionMetadata, WebMaskInputDescriptionModule, WebMoveFloatingPaneActionDescription, WebMoveFloatingPaneActionDescriptionMetadata, WebMoveTabActionDescription, WebMoveTabActionDescriptionMetadata, WebNavDrawerDescription, WebNavDrawerDescriptionMetadata, WebNavDrawerDescriptionModule, WebNavDrawerHeaderItemDescription, WebNavDrawerHeaderItemDescriptionMetadata, WebNavDrawerHeaderItemDescriptionModule, WebNavDrawerItemDescription, WebNavDrawerItemDescriptionMetadata, WebNavDrawerItemDescriptionModule, WebNavbarDescription, WebNavbarDescriptionMetadata, WebNavbarDescriptionModule, WebNumberEventArgsDescription, WebNumberEventArgsDescriptionMetadata, WebNumberFilteringOperandDescription, WebNumberFilteringOperandDescriptionMetadata, WebNumberSummaryOperandDescription, WebNumberSummaryOperandDescriptionMetadata, WebOverlayOutletDirectiveDescription, WebOverlayOutletDirectiveDescriptionMetadata, WebOverlaySettingsDescription, WebOverlaySettingsDescriptionMetadata, WebPageCancellableEventArgsDescription, WebPageCancellableEventArgsDescriptionMetadata, WebPageCancellableEventArgsDetailDescription, WebPageCancellableEventArgsDetailDescriptionMetadata, WebPageEventArgsDescription, WebPageEventArgsDescriptionMetadata, WebPageEventArgsDetailDescription, WebPageEventArgsDetailDescriptionMetadata, WebPaginatorDescription, WebPaginatorDescriptionMetadata, WebPaginatorDescriptionModule, WebPaginatorResourceStringsDescription, WebPaginatorResourceStringsDescriptionMetadata, WebPagingStateDescription, WebPagingStateDescriptionMetadata, WebPaneCloseEventArgsDescription, WebPaneCloseEventArgsDescriptionMetadata, WebPaneCloseEventArgsDetailDescription, WebPaneCloseEventArgsDetailDescriptionMetadata, WebPaneDragActionDescription, WebPaneDragActionDescriptionMetadata, WebPaneDragEndEventArgsDescription, WebPaneDragEndEventArgsDescriptionMetadata, WebPaneDragEndEventArgsDetailDescription, WebPaneDragEndEventArgsDetailDescriptionMetadata, WebPaneDragOverEventArgsDescription, WebPaneDragOverEventArgsDescriptionMetadata, WebPaneDragOverEventArgsDetailDescription, WebPaneDragOverEventArgsDetailDescriptionMetadata, WebPaneDragStartEventArgsDescription, WebPaneDragStartEventArgsDescriptionMetadata, WebPaneDragStartEventArgsDetailDescription, WebPaneDragStartEventArgsDetailDescriptionMetadata, WebPaneHeaderConnectionEventArgsDescription, WebPaneHeaderConnectionEventArgsDescriptionMetadata, WebPaneHeaderConnectionEventArgsDetailDescription, WebPaneHeaderConnectionEventArgsDetailDescriptionMetadata, WebPaneHeaderElementDescription, WebPaneHeaderElementDescriptionMetadata, WebPaneHeaderElementDescriptionModule, WebPanePinnedEventArgsDescription, WebPanePinnedEventArgsDescriptionMetadata, WebPanePinnedEventArgsDetailDescription, WebPanePinnedEventArgsDetailDescriptionMetadata, WebPinColumnCancellableEventArgsDescription, WebPinColumnCancellableEventArgsDescriptionMetadata, WebPinColumnCancellableEventArgsDetailDescription, WebPinColumnCancellableEventArgsDetailDescriptionMetadata, WebPinColumnEventArgsDescription, WebPinColumnEventArgsDescriptionMetadata, WebPinColumnEventArgsDetailDescription, WebPinColumnEventArgsDetailDescriptionMetadata, WebPinRowEventArgsDescription, WebPinRowEventArgsDescriptionMetadata, WebPinRowEventArgsDetailDescription, WebPinRowEventArgsDetailDescriptionMetadata, WebPinningConfigDescription, WebPinningConfigDescriptionMetadata, WebPivotAggregatorDescription, WebPivotAggregatorDescriptionMetadata, WebPivotConfigurationChangedEventArgsDescription, WebPivotConfigurationChangedEventArgsDescriptionMetadata, WebPivotConfigurationChangedEventArgsDetailDescription, WebPivotConfigurationChangedEventArgsDetailDescriptionMetadata, WebPivotConfigurationDescription, WebPivotConfigurationDescriptionMetadata, WebPivotDataSelectorDescription, WebPivotDataSelectorDescriptionMetadata, WebPivotDataSelectorDescriptionModule, WebPivotDateDimensionDescription, WebPivotDateDimensionDescriptionMetadata, WebPivotDateDimensionDescriptionModule, WebPivotDateDimensionOptionsDescription, WebPivotDateDimensionOptionsDescriptionMetadata, WebPivotDimensionDescription, WebPivotDimensionDescriptionMetadata, WebPivotDimensionDetailDescription, WebPivotDimensionDetailDescriptionMetadata, WebPivotDimensionEventArgsDescription, WebPivotDimensionEventArgsDescriptionMetadata, WebPivotDimensionStrategyDescription, WebPivotDimensionStrategyDescriptionMetadata, WebPivotGridColumnDescription, WebPivotGridColumnDescriptionMetadata, WebPivotGridDescription, WebPivotGridDescriptionMetadata, WebPivotGridDescriptionModule, WebPivotGridRecordDescription, WebPivotGridRecordDescriptionMetadata, WebPivotGridValueTemplateContextDescription, WebPivotGridValueTemplateContextDescriptionMetadata, WebPivotKeysDescription, WebPivotKeysDescriptionMetadata, WebPivotUISettingsDescription, WebPivotUISettingsDescriptionMetadata, WebPivotValueDescription, WebPivotValueDescriptionMetadata, WebPivotValueDetailDescription, WebPivotValueDetailDescriptionMetadata, WebPivotValueEventArgsDescription, WebPivotValueEventArgsDescriptionMetadata, WebPositionSettingsDescription, WebPositionSettingsDescriptionMetadata, WebPositionStrategyDescription, WebPositionStrategyDescriptionMetadata, WebProgressBaseDescription, WebProgressBaseDescriptionMetadata, WebProgressBaseDescriptionModule, WebRadioChangeEventArgsDescription, WebRadioChangeEventArgsDescriptionMetadata, WebRadioChangeEventArgsDetailDescription, WebRadioChangeEventArgsDetailDescriptionMetadata, WebRadioDescription, WebRadioDescriptionMetadata, WebRadioDescriptionModule, WebRadioGroupDescription, WebRadioGroupDescriptionMetadata, WebRadioGroupDescriptionModule, WebRangeSliderDescription, WebRangeSliderDescriptionMetadata, WebRangeSliderDescriptionModule, WebRangeSliderValueDescription, WebRangeSliderValueDescriptionMetadata, WebRangeSliderValueEventArgsDescription, WebRangeSliderValueEventArgsDescriptionMetadata, WebRatingDescription, WebRatingDescriptionMetadata, WebRatingDescriptionModule, WebRatingSymbolDescription, WebRatingSymbolDescriptionMetadata, WebRatingSymbolDescriptionModule, WebRippleDescription, WebRippleDescriptionMetadata, WebRippleDescriptionModule, WebRowDataCancelableEventArgsDescription, WebRowDataCancelableEventArgsDescriptionMetadata, WebRowDataCancelableEventArgsDetailDescription, WebRowDataCancelableEventArgsDetailDescriptionMetadata, WebRowDataEventArgsDescription, WebRowDataEventArgsDescriptionMetadata, WebRowDataEventArgsDetailDescription, WebRowDataEventArgsDetailDescriptionMetadata, WebRowDirectiveDescription, WebRowDirectiveDescriptionMetadata, WebRowDragEndEventArgsDescription, WebRowDragEndEventArgsDescriptionMetadata, WebRowDragEndEventArgsDetailDescription, WebRowDragEndEventArgsDetailDescriptionMetadata, WebRowDragStartEventArgsDescription, WebRowDragStartEventArgsDescriptionMetadata, WebRowDragStartEventArgsDetailDescription, WebRowDragStartEventArgsDetailDescriptionMetadata, WebRowExportingEventArgsDescription, WebRowExportingEventArgsDescriptionMetadata, WebRowExportingEventArgsDetailDescription, WebRowExportingEventArgsDetailDescriptionMetadata, WebRowIslandDescription, WebRowIslandDescriptionMetadata, WebRowIslandDescriptionModule, WebRowSelectionEventArgsDescription, WebRowSelectionEventArgsDescriptionMetadata, WebRowSelectionEventArgsDetailDescription, WebRowSelectionEventArgsDetailDescriptionMetadata, WebRowSelectorTemplateContextDescription, WebRowSelectorTemplateContextDescriptionMetadata, WebRowSelectorTemplateDetailsDescription, WebRowSelectorTemplateDetailsDescriptionMetadata, WebRowToggleEventArgsDescription, WebRowToggleEventArgsDescriptionMetadata, WebRowToggleEventArgsDetailDescription, WebRowToggleEventArgsDetailDescriptionMetadata, WebRowTypeDescription, WebRowTypeDescriptionMetadata, WebScrollStrategyDescription, WebScrollStrategyDescriptionMetadata, WebSearchInfoDescription, WebSearchInfoDescriptionMetadata, WebSelectDescription, WebSelectDescriptionMetadata, WebSelectDescriptionModule, WebSelectGroupDescription, WebSelectGroupDescriptionMetadata, WebSelectGroupDescriptionModule, WebSelectHeaderDescription, WebSelectHeaderDescriptionMetadata, WebSelectHeaderDescriptionModule, WebSelectItemComponentEventArgsDescription, WebSelectItemComponentEventArgsDescriptionMetadata, WebSelectItemDescription, WebSelectItemDescriptionMetadata, WebSelectItemDescriptionModule, WebSizeDescription, WebSizeDescriptionMetadata, WebSliderBaseDescription, WebSliderBaseDescriptionMetadata, WebSliderBaseDescriptionModule, WebSliderDescription, WebSliderDescriptionMetadata, WebSliderDescriptionModule, WebSliderLabelDescription, WebSliderLabelDescriptionMetadata, WebSliderLabelDescriptionModule, WebSnackbarDescription, WebSnackbarDescriptionMetadata, WebSnackbarDescriptionModule, WebSortingEventArgsDescription, WebSortingEventArgsDescriptionMetadata, WebSortingEventArgsDetailDescription, WebSortingEventArgsDetailDescriptionMetadata, WebSortingExpressionDescription, WebSortingExpressionDescriptionMetadata, WebSortingExpressionEventArgsDescription, WebSortingExpressionEventArgsDescriptionMetadata, WebSortingOptionsDescription, WebSortingOptionsDescriptionMetadata, WebSortingStrategyDescription, WebSortingStrategyDescriptionMetadata, WebSplitPaneDescription, WebSplitPaneDescriptionMetadata, WebSplitPaneDescriptionModule, WebStepDescription, WebStepDescriptionMetadata, WebStepDescriptionModule, WebStepperDescription, WebStepperDescriptionMetadata, WebStepperDescriptionModule, WebStringFilteringOperandDescription, WebStringFilteringOperandDescriptionMetadata, WebSummaryExpressionDescription, WebSummaryExpressionDescriptionMetadata, WebSummaryOperandDescription, WebSummaryOperandDescriptionMetadata, WebSummaryResultDescription, WebSummaryResultDescriptionMetadata, WebSummaryTemplateContextDescription, WebSummaryTemplateContextDescriptionMetadata, WebSwitchDescription, WebSwitchDescriptionMetadata, WebSwitchDescriptionModule, WebTabComponentEventArgsDescription, WebTabComponentEventArgsDescriptionMetadata, WebTabDescription, WebTabDescriptionMetadata, WebTabDescriptionModule, WebTabGroupPaneDescription, WebTabGroupPaneDescriptionMetadata, WebTabGroupPaneDescriptionModule, WebTabHeaderConnectionEventArgsDescription, WebTabHeaderConnectionEventArgsDescriptionMetadata, WebTabHeaderConnectionEventArgsDetailDescription, WebTabHeaderConnectionEventArgsDetailDescriptionMetadata, WebTabHeaderElementDescription, WebTabHeaderElementDescriptionMetadata, WebTabHeaderElementDescriptionModule, WebTabPanelDescription, WebTabPanelDescriptionMetadata, WebTabPanelDescriptionModule, WebTabsDescription, WebTabsDescriptionMetadata, WebTabsDescriptionModule, WebTextareaDescription, WebTextareaDescriptionMetadata, WebTextareaDescriptionModule, WebTimeFilteringOperandDescription, WebTimeFilteringOperandDescriptionMetadata, WebTimeSummaryOperandDescription, WebTimeSummaryOperandDescriptionMetadata, WebToastDescription, WebToastDescriptionMetadata, WebToastDescriptionModule, WebToggleButtonDescription, WebToggleButtonDescriptionMetadata, WebToggleButtonDescriptionModule, WebToggleViewCancelableEventArgsDescription, WebToggleViewCancelableEventArgsDescriptionMetadata, WebToggleViewCancelableEventArgsDetailDescription, WebToggleViewCancelableEventArgsDetailDescriptionMetadata, WebToggleViewEventArgsDescription, WebToggleViewEventArgsDescriptionMetadata, WebToggleViewEventArgsDetailDescription, WebToggleViewEventArgsDetailDescriptionMetadata, WebTransactionServiceDescription, WebTransactionServiceDescriptionMetadata, WebTreeDescription, WebTreeDescriptionMetadata, WebTreeDescriptionModule, WebTreeGridDescription, WebTreeGridDescriptionMetadata, WebTreeGridDescriptionModule, WebTreeGridRecordDescription, WebTreeGridRecordDescriptionMetadata, WebTreeItemComponentEventArgsDescription, WebTreeItemComponentEventArgsDescriptionMetadata, WebTreeItemDescription, WebTreeItemDescriptionMetadata, WebTreeItemDescriptionModule, WebTreeSelectionChangeDescription, WebTreeSelectionChangeDescriptionMetadata, WebTreeSelectionChangeDetailDescription, WebTreeSelectionChangeDetailDescriptionMetadata, WebTreeSelectionChangeEventArgsDescription, WebTreeSelectionChangeEventArgsDescriptionMetadata, WebTreeSelectionOptionsEventArgsDescription, WebTreeSelectionOptionsEventArgsDescriptionMetadata, WebTreeSelectionOptionsEventDetailDescription, WebTreeSelectionOptionsEventDetailDescriptionMetadata, WebValidationErrorsDescription, WebValidationErrorsDescriptionMetadata, WebValidatorHandlerDescription, WebValidatorHandlerDescriptionMetadata, WebValuesChangeDescription, WebValuesChangeDescriptionMetadata, WebValuesChangeDetailDescription, WebValuesChangeDetailDescriptionMetadata, WebValuesChangeEventArgsDescription, WebValuesChangeEventArgsDescriptionMetadata, WeightedCloseIndicatorDescription, WeightedCloseIndicatorDescriptionMetadata, WeightedCloseIndicatorDescriptionModule, WhitespaceHandling, WhitespaceHandling_$type, WilliamsPercentRIndicatorDescription, WilliamsPercentRIndicatorDescriptionMetadata, WilliamsPercentRIndicatorDescriptionModule, WrapperExpression, WrapperExpressionDescription, WrapperExpressionDescriptionMetadata, WriteState, WriteState_$type, WriteableBitmap, XAttribute, XBaseDataType, XBaseDataType_$type, XBaseField, XContainer, XDocument, XElement, XName, XNamespace, XNode, XObject, XYChartDescription, XYChartDescriptionMetadata, XamMultiScaleImage, XamMultiScaleImageView, XamMultiScaleTileSource, XmlAttribute_$type, XmlChar, XmlConvert, XmlDocument_$type, XmlElement_$type, XmlException, XmlInputStream, XmlLinkedNode_$type, XmlNameTable, XmlNamedNodeMap_$type, XmlNamespaceManager, XmlNamespaceManager_NsDecl, XmlNamespaceManager_NsScope, XmlNamespaceScope_$type, XmlNodeList_$type, XmlNodeType, XmlNodeType_$type, XmlNode_$type, XmlParserContext, XmlParserContext_ContextItem, XmlReader, XmlResolver, XmlSpace, XmlSpace_$type, XmlStreamReader, XmlTextReader, XmlTextReader_DtdInputStateStack, XmlTextReader_DtdInputState_$type, XmlTextReader_TagName, XmlTextReader_XmlAttributeTokenInfo, XmlTextReader_XmlTokenInfo, XmlTextWriter, XmlTextWriter_StringUtil, XmlTextWriter_XmlDeclState_$type, XmlTextWriter_XmlNodeInfo, XmlUrlResolver, XmlUtils, XmlWriter, YearToDateExpression, YearToDateExpressionDescription, YearToDateExpressionDescriptionMetadata, YesterdayExpression, YesterdayExpressionDescription, YesterdayExpressionDescriptionMetadata, ZoomSliderDescription, ZoomSliderDescriptionMetadata, ZoomSliderDescriptionModule, ZoomSliderResolvingAxisValueEventArgsDescription, ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata, a$, addBrushPaletteThemeEntry, addPaletteThemeEntry, addTextThemeEntry, arrayClear, arrayClear1, arrayContains, arrayCopy, arrayCopy1, arrayCopy2, arrayCopyTo, arrayFindByName, arrayGetLength, arrayGetRank, arrayGetValue, arrayIndexOf1, arrayInsert, arrayInsertRange, arrayInsertRange1, arrayLast, arrayListCreate, arrayRemoveAt, arrayRemoveItem, arrayResize, arrayShallowClone, b$, b64toUint8Array, boolCompare, boolToDecimal, boolToDouble, boolToInt16, boolToInt32, boolToInt64, boolToSingle, boolToString, boolToUInt16, boolToUInt32, boolToUInt64, boxArray$1, brushCollectionToString, brushToString, callStaticConstructors, ceil10, charMaxValue, charMinValue, colorCollectionToString, colorToString, compareTo, createGuid, createMutationObserver, d$, dateAdd, dateAddDays, dateAddHours, dateAddMinutes, dateAddMonths, dateAddSeconds, dateAddYears, dateEquals, dateFromFileTime, dateFromFileTimeUtc, dateFromMilliseconds, dateFromTicks, dateFromValues, dateGetDate, dateGetMonth, dateGetTimeOfDay, dateIsDST, dateIsLeapYear, dateKind, dateMaxValue, dateMinValue, dateNow, dateParse, dateParseExact, dateStdTimezoneOffset, dateSubtract, dateToFileTime, dateToString, dateToStringFormat, dateToday, dateTryParse, daysInMonth, decimalAdjust, defaultDVDateParse, delegateCombine, delegateRemove, doubleCollectionToString, endsWith1, ensureBool, ensureEnum, enumGetBox, enumToString, floor10, fromBrushCollection, fromColorCollection, fromDict, fromDoubleCollection, fromEn, fromEnum, fromOADate, fromPoint, fromRect, fromSize, fromSpinal, getAllPropertyNames, getBoxIfEnum, getColorStringSafe, getEn, getEnumerator, getEnumeratorObject, getInstanceType, getModifiedProps, ieeeRemainder, indexOfAny, initializePropertiesFromCss, intDivide, intSToU, intToString, intToString1, interfaceToInternal, isDigit, isDigit1, isInfinity, isLetter, isLetterOrDigit, isLower, isNaN_, isNegativeInfinity, isNumber, isPoint, isPositiveInfinity, isRect, isSize, isValidProp, lastIndexOfAny, log10, logBase, markDep, markEnum, markStruct, markType, n$, netRegexToJS, nullableAdd, nullableConcat, nullableDivide, nullableEquals, nullableGreaterThan, nullableGreaterThanOrEqual, nullableIsNull, nullableLessThan, nullableLessThanOrEqual, nullableModulus, nullableMultiply, nullableNotEquals, nullableSubtract, numberToString, numberToString1, numberToString2, padLeft, padRight, parseBool, parseInt16_1, parseInt16_2, parseInt32_1, parseInt32_2, parseInt64_1, parseInt64_2, parseInt8_1, parseInt8_2, parseIntCore, parseNumber, parseNumber1, parseUInt16_1, parseUInt16_2, parseUInt32_1, parseUInt32_2, parseUInt64_1, parseUInt64_2, parseUInt8_1, parseUInt8_2, pointFromLiteral, pointToLiteral, pointToString, rectFromLiteral, rectToLiteral, rectToString, reverse, rgbToHex, round10, round10N, runOn, s$, sizeFromLiteral, sizeToLiteral, sizeToString, sleep, startsWith1, strToColor, stringCompare, stringCompare1, stringCompare2, stringCompare3, stringCompareOrdinal, stringCompareTo, stringConcat, stringContains, stringCopyToCharArray, stringCreateFromChar, stringCreateFromCharArray, stringCreateFromCharArraySlice, stringEmpty, stringEndsWith, stringEquals, stringEquals1, stringEscapeRegExp, stringFormat, stringFormat1, stringFormat2, stringInsert, stringIsDigit, stringIsNullOrEmpty, stringIsNullOrWhiteSpace, stringJoin, stringJoin1, stringRemove, stringReplace, stringSplit, stringStartsWith, stringToBrush, stringToCharArray, stringToColor, stringToLocaleLower, stringToLocaleUpper, stringToString$1, stringToString1, timeSpanDays, timeSpanFromDays, timeSpanFromHours, timeSpanFromMilliseconds, timeSpanFromMinutes, timeSpanFromSeconds, timeSpanFromTicks, timeSpanHours, timeSpanInit1, timeSpanInit2, timeSpanInit3, timeSpanMilliseconds, timeSpanMinutes, timeSpanNegate, timeSpanSeconds, timeSpanTicks, timeSpanTotalDays, timeSpanTotalHours, timeSpanTotalMilliseconds, timeSpanTotalMinutes, timeSpanTotalSeconds, toBoolean, toBrushCollection, toColorCollection, toDecimal, toDouble, toDoubleCollection, toEn, toEnum, toLocalTime, toLongDateString, toLongTimeString, toNullable, toOADate, toPoint, toRect, toSize, toSpinal, toString1, toUniversalTime, trim, trimEnd, trimStart, truncate, tryParseBool, tryParseInt16_1, tryParseInt16_2, tryParseInt32_1, tryParseInt32_2, tryParseInt64_1, tryParseInt64_2, tryParseInt8_1, tryParseInt8_2, tryParseIntCore, tryParseNumber, tryParseNumber1, tryParseUInt16_1, tryParseUInt16_2, tryParseUInt32_1, tryParseUInt32_2, tryParseUInt64_1, tryParseUInt64_2, tryParseUInt8_1, tryParseUInt8_2, typeCast, typeCastObjTo$t, typeGetValue, u32BitwiseAnd, u32BitwiseOr, u32BitwiseXor, u32LS, uint8ArraytoB64, unboxArray, unicode_hack, unwrapNullable, v$, wellKnownColors, wrapNullable };
